# Semiempirical Extended Tight-Binding Program Package

[![License](https://img.shields.io/github/license/grimme-lab/xtb)](https://github.com/grimme-lab/xtb/blob/master/COPYING)
[![Latest Version](https://img.shields.io/github/v/release/grimme-lab/xtb)](https://github.com/grimme-lab/xtb/releases/latest)
[![DOI](https://img.shields.io/badge/DOI-10.1002%2Fwcms.1493-blue)](https://doi.org/10.1002/wcms.1493)
[![Github Downloads All Releases](https://img.shields.io/github/downloads/grimme-lab/xtb/total)](https://github.com/grimme-lab/xtb/releases)

This is the offical repository of the `xtb` program package developed by the Grimme group in Bonn.

<div align="center">
<img src="./assets/logo/xtb.svg" alt="Extended Tight Binding" width="220">
</div>


## Installation

[![Build Status](https://img.shields.io/github/actions/workflow/status/grimme-lab/xtb/fortran-build.yml?branch=main)](https://github.com/grimme-lab/xtb/actions)

Statically linked binaries (Intel Compiler) can be found at the [latest release page](https://github.com/grimme-lab/xtb/releases/latest), a version for Linux (Intel 18.0.2, GLIBC 2.19) and Windows (Intel 2022) is provided.
The `xtb` program and library are packaged on conda-forge for Linux (x86\_64, aarch64, ppc64le) and MacOS (x86\_64, arm64).
For homebrew users a custom tap is available at [grimme-lab/homebrew-qc](https://github.com/grimme-lab/homebrew-qc) providing prebuilt MacOS/x86\_64 binaries, for MacOS/arm64 binaries will be compiled on installation automatically.

Bleeding edge releases (Linux only) of the latest source from this repository are available on the [continuous release tag](https://github.com/grimme-lab/xtb/releases/tag/bleed).

This projects supports two build systems, meson and CMake.
A short guide on the usage of each is given here, follow the linked instructions for a more detailed information ([meson guide](./meson/README.adoc), [CMake guide](./cmake/README.adoc)).


### Meson

Using [meson](https://mesonbuild.com/) as build system requires you to install a fairly new version like 0.62 or newer.
To use the default backend of meson you have to install [ninja](https://ninja-build.org/) version 1.7 or newer.

```bash
export FC=ifort CC=icc
meson setup build --buildtype release --optimization 2 -Dfortran_link_args="-qopenmp"
ninja -C build test
```

Make sure the testsuite is running without errors.

To install the `xtb` binaries to `/usr/local` use (might require `sudo`)

```bash
ninja -C build install
```

For more information on the build with meson see the instructions [here](./meson/README.adoc).


### CMake

The CMake build system requires both make and CMake to be installed, the latter has to be version 3.9 or newer.

Building `xtb` with CMake works with the following chain of commands:

```bash
cmake -B build -DCMAKE_BUILD_TYPE=Release
make -C build
make -C build test
```

To install the `xtb` binaries to `/usr/local` use (might require `sudo`)

```bash
make -C build install
```

For more detailed information on the build with CMake see the instructions [here](./cmake/README.adoc).


### Conda

[![Conda Version](https://img.shields.io/conda/vn/conda-forge/xtb.svg)](https://anaconda.org/conda-forge/xtb)

Installing `xtb` from the `conda-forge` channel can be achieved by adding `conda-forge` to your channels with:

```
conda config --add channels conda-forge
```

Once the `conda-forge` channel has been enabled, `xtb` can be installed with:

```
conda install xtb
```

It is possible to list all of the versions of `xtb` available on your platform with:

```
conda search xtb --channel conda-forge
```


## Documentation

[![Documentation Status](https://readthedocs.org/projects/xtb-docs/badge/?version=latest)](https://xtb-docs.readthedocs.io/en/latest/?badge=latest)

The `xtb` documentation is hosted at [read-the-docs](https://xtb-docs.readthedocs.io/en/latest/contents.html).


## Contributing

Please read our [contributing guidelines](CONTRIBUTING.md)
before contributing to this project.


### Contributors

We are developing this program to make our research possible.
Many of the features that `xtb` has today have been added because there
was a dire need for them and we had many contributors who made these
features reality:

- P. Atkinson ([@patrickatkinson](https://github.com/patrickatkinson))
- [C. Bannwarth](https://www.ipc.rwth-aachen.de/cms/IPC/Das-Institut/IPC-Arbeitsgruppen/~onnkh) ([@cbannwarth](https://github.com/cbannwarth))
- F. Bohle ([@fabothch](https://github.com/fabothch))
- [G. Brandenburg](http://www.gerit-brandenburg.de/) ([@gbrandenburg](https://github.com/gbrandenburg))
- [E. Caldeweyher](https://eikecaldeweyher.de/) ([@f3rmion](https://github.com/f3rmion))
- M. Checinski
- S. Dohm ([@thch-dohm](https://github.com/thch-dohm))
- S. Ehlert ([@awvwgk](https://github.com/awvwgk))
- S. Ehrlich
- I. Gerasimov ([@FulgurIgor](https://github.com/fulgurigor))
- [S. Grimme](https://www.chemie.uni-bonn.de/pctc/mulliken-center/grimme/) ([@stefangrimme](https://github.com/stefangrimme))
- C. Hölzer ([@hoelzerC](https://github.com/hoelzerc))
- A. Katbashev ([@Albkat](https://github.com/albkat))
- J. Koopman ([@JayTheDog](https://github.com/jaythedog))
- C. Lavinge ([@clavigne](https://github.com/clavigne))
- S. Lehtola ([@susilehtola](https://github.com/susilehtola))
- F. März
- M. Müller ([@marcelmbn](https://github.com/marcelmbn))
- F. Musil ([@felixmusil](https://github.com/felixmusil))
- H. Neugebauer ([@haneug](https://github.com/haneug))
- J. Pisarek
- C. Plett ([@cplett](https://github.com/cplett))
- P. Pracht ([@pprcht](https://github.com/pprcht))
- F. Pultar ([@pultar](https://github.com/pultar))
- J. Seibert ([@liljay42](https://github.com/liljay42))
- P. Shushkov
- S. Spicher ([@sespic](https://github.com/sespic))
- M. Stahn ([@MtoLStoN](https://github.com/mtolston))
- M. Steiner ([@steinmig](https://github.com/steinmig))
- T. Strunk ([@timostrunk](https://github.com/timostrunk))
- J. Stückrath ([@jbstueckrath](https://github.com/jbstueckrath))
- T. Rose ([@Thomas3R](https://github.com/thomas3r))
- J. Unsleber ([@nabbelbabbel](https://github.com/nabbelbabbel))

Contributors are listed in alphabetical order.
Some contributions predate the GitHub release of this project and are not visible in the repository commit history.
For the contributor data from the commit history since then look [here](https://github.com/grimme-lab/xtb/graphs/contributors).


## Citations

General Reference to `xtb` and the implemented GFN methods:
- C. Bannwarth, E. Caldeweyher, S. Ehlert, A. Hansen, P. Pracht, J. Seibert, S. Spicher, S. Grimme
  *WIREs Comput. Mol. Sci.*, **2020**, 11, e01493.
  DOI: [10.1002/wcms.1493](https://doi.org/10.1002/wcms.1493)

for GFN-xTB:
- S. Grimme, C. Bannwarth, P. Shushkov, *J. Chem. Theory Comput.*, **2017**, 13, 1989-2009.
  DOI: [10.1021/acs.jctc.7b00118](https://dx.doi.org/10.1021/acs.jctc.7b00118)
- C. Bannwarth, S. Ehlert and S. Grimme., *J. Chem. Theory Comput.*, **2019**, 15, 1652-1671.
  DOI: [10.1021/acs.jctc.8b01176](https://dx.doi.org/10.1021/acs.jctc.8b01176)
- P. Pracht, E. Caldeweyher, S. Ehlert, S. Grimme, *ChemRxiv*, **2019**, preprint.
  DOI: [10.26434/chemrxiv.8326202.v1](https://dx.doi.org/10.26434/chemrxiv.8326202.v1)

for GFN-FF:
- S. Spicher and S. Grimme, *Angew. Chem. Int. Ed.*, **2020**, 59, 15665–15673
  DOI: [10.1002/anie.202004239](https://doi.org/10.1002/anie.202004239)

for GBSA and ALPB implicit solvation:
- S. Ehlert, M. Stahn, S. Spicher, S. Grimme,
  *J. Chem. Theory Comput.*, **2021**, 17, 4250-4261
  DOI: [10.1021/acs.jctc.1c00471](https://doi.org/10.1021/acs.jctc.1c00471)

for DFT-D4:
- E. Caldeweyher, C. Bannwarth and S. Grimme, *J. Chem. Phys.*, **2017**, 147, 034112.
  DOI: [10.1063/1.4993215](https://dx.doi.org/10.1063/1.4993215)
- E. Caldeweyher, S. Ehlert, A. Hansen, H. Neugebauer, S. Spicher, C. Bannwarth and S. Grimme, *J. Chem. Phys.*,
  **2019**, 150, 154122. DOI: [10.1063/1.5090222](https://dx.doi.org/10.1063/1.5090222)
- E. Caldeweyher, J.-M. Mewes, S. Ehlert and S. Grimme, *Phys. Chem. Chem. Phys.*, **2020**, 22, 8499-8512. 
  DOI: [10.1039/D0CP00502A](https://dx.doi.org/10.1039/D0CP00502A) 

for sTDA-xTB:
- S. Grimme and C. Bannwarth, *J. Chem. Phys.*, **2016**, 145, 054103.
  DOI: [10.1063/1.4959605](https://dx.doi.org/10.1063/1.4959605)

in the mass-spec context:
- V. Asgeirsson, C. Bauer and S. Grimme, *Chem. Sci.*, **2017**, 8, 4879.
  DOI: [10.1039/c7sc00601b](https://dx.doi.org/10.1039/c7sc00601b)
- J. Koopman and S. Grimme, *ACS Omega*, **2019**, 4, 12, 15120-15133.
  DOI: [10.1021/acsomega.9b02011](https://dx.doi.org/10.1021/acsomega.9b02011)
- J. Koopman and S. Grimme, *J. Am. Soc. Mass Spectrom.*, **2021**, 32, 7, 1735-1751.
  DOI: [10.1021/jasms.1c00098](https://dx.doi.org/10.1021/jasms.1c00098)

for metadynamics refer to:
- S. Grimme, *J. Chem. Theory Comput.*, **2019**, 155, 2847-2862.
  DOI: [10.1021/acs.jctc.9b00143](https://dx.doi.org/10.1021/acs.jctc.9b00143)
  
for SPH calculations refer to:
- S. Spicher and S. Grimme, *J. Chem. Theory Comput.*, **2021**, 17, 1701–1714.
  DOI: [10.1021/acs.jctc.0c01306](https://doi.org/10.1021/acs.jctc.0c01306)  

All references are available in [bibtex format](./assets/references.bib).


## License

`xtb` is free software: you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

`xtb` is distributed in the hope that it will be useful,
but without any warranty; without even the implied warranty of
merchantability or fitness for a particular purpose.  See the
GNU Lesser General Public License for more details.

Unless you explicitly state otherwise, any contribution intentionally
submitted for inclusion in `xtb` by you, as defined in the
GNU Lesser General Public license, shall be licensed as above, without any
additional terms or conditions.

# Python API for the Extended Tight Binding Program

The Python API for `xtb` has been migrated to its own repository at https://github.com/grimme-lab/xtb-python.
The documentation can be found at https://xtb-python.readthedocs.io.

There is nothing to see here anymore.

# The xTB Logo

<img src="./xtb.svg" alt="Extended Tight Binding" width="340"> <img src="./xtb_alt.svg" alt="Extended Tight Binding" width="300">

Created by Sebastian Ehlert.

<a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/"><img alt="Creative Commons License" style="border-width:0" src="https://i.creativecommons.org/l/by-sa/4.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/4.0/">Creative Commons Attribution-ShareAlike 4.0 International License</a>.

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine gfn1_prparam(iunit,n,at,par)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_param
   use xtb_aoparam
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   type(scc_parameter),intent(in) :: par

   integer nn(94),i,j,l
   character(30) atmp
   character(3) lnam(0:13)

   write(iunit,'(13x,''KAB for M(3d)-M(3d) :'',f22.4)') 1.1
   write(iunit,'(13x,''KAB for M(4d)-M(4d) :'',f22.4)') 1.2
   write(iunit,'(13x,''KAB for M(5d)-M(5d) :'',f22.4)') 1.2

   write(iunit,'(13x,a,3x,":",10x,F12.4)') &
    !"k(s)             ",par%kspd(1),&
    !"k(p)             ",par%kspd(2),&
    !"k(d)             ",par%kspd(3),&
    !"k(f)             ",par%kspd(4),&
    !"kEN (H0ij)       ",par%kenscal,&
    !"D3 a1            ",par%disp%a1,&
    !"D3 a2            ",par%disp%a2,&
    "D3 s6            ",1.0_wp,&
    !"D3 s8            ",par%disp%s8,&
    "D3 s9            ",0.0_wp!,&
    !"alphaj           ",par%alphaj!,&
    !"XBdamp           ",par%xbdamp,&
    !"XBrad            ",par%xbrad
   !write(iunit,'(13x,a,3x,":",2x,4F10.4)') &
    !"kcnsh            ",par%kcnsh(1:4)/0.01_wp

   write(iunit,'(a)')

   lnam(0)='s'
   lnam(1)='p'
   lnam(2)='d'
   lnam(3)='f'
   lnam(11)='S'
   lnam(12)='sp'
   lnam(13)='spd'

   nn=0
   do i=1,n
      nn(at(i))=nn(at(i))+1
   enddo

   write(iunit,*)' Z AO/shell   Hii/eV     exponent'
   do i=1,94
      atmp=timestp(i)
      if(nn(i).eq.0      ) cycle
      if(atmp(1:1).eq.'-') cycle
      write(iunit,'(i3,5x,A30,"  EN:",F6.3," GAM:",F6.3,"  GM3:",F7.4)') &
         & i,timestp(i),en(i),gam(i),gam3(i)
      do j=1,ao_n(i)
         l=ao_l(j,i)
         write(iunit,'(3x,i3,a3,2F12.6)') &
            & ao_pqn(j,i),lnam(l),ao_lev(j,i),ao_exp(j,i)
      enddo
   enddo

end subroutine gfn1_prparam

subroutine gfn2_prparam(iunit,n,at,par)
   use xtb_mctc_accuracy, only : kdp => wp
   use xtb_type_param
   use xtb_aoparam
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   type(scc_parameter),intent(in) :: par

   integer nn(94),i,j,l
   character(30) atmp
   character(3) lnam(0:13)

   write(iunit,'(13x,a,":",10x,F12.4)') &
    !"k(s)              ",par%kspd(1),&
    !"k(p)              ",par%kspd(2),&
    !"k(d)              ",par%kspd(3),&
    !"k(f)              ",par%kspd(4),&
    !"kEN (H0ij)        ",par%kenscal,&
    !"D4 a1             ",par%disp%a1,&
    !"D4 a2             ",par%disp%a2,&
    !"D4 s6             ",par%disp%s6,&
    !"D4 s8             ",par%disp%s8,&
    !"D4 s9             ",par%disp%s9,&
    "alphaj            ",2.0_kdp
   write(iunit,'(a)')

   lnam(0)='s'
   lnam(1)='p'
   lnam(2)='d'
   lnam(3)='f'
   lnam(11)='S'
   lnam(12)='sp'
   lnam(13)='spd'

   nn=0
   do i=1,n
      nn(at(i))=nn(at(i))+1
   enddo

   write(iunit,*)' Z AO/shell   Hii/eV     exponent'
   do i=1,94
      atmp=timestp(i)
      if(nn(i).eq.0      ) cycle
      if(atmp(1:1).eq.'-') cycle
      write(iunit,'(i3,5x,A30,''  EN:'',F6.3,'' GM2:'',F6.3, &
         & ''  GM3:'',F7.4,''  RAES:'',F5.2)') &
         & i,timestp(i),en(i),gam(i),gam3(i),radaes(i)
      do j=1,ao_n(i)
         l=ao_l(j,i)
         write(iunit,'(3x,i3,a3,2F12.6)') &
            & ao_pqn(j,i),lnam(l),ao_lev(j,i),ao_exp(j,i)
      enddo
   enddo

end subroutine gfn2_prparam

subroutine gfn0_prparam(iunit,n,at,par)
   use xtb_mctc_accuracy, only : kdp => wp
   use xtb_type_param
   use xtb_aoparam
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   type(scc_parameter),intent(in) :: par

   integer nn(94),i,j,l
   character(30) atmp
   character(3) lnam(0:13)

   write(iunit,'(13x,''KAB for M(3d)-M(3d)    :'',f8.4)') 1.1
   write(iunit,'(13x,''KAB for M(4d)-M(4d)    :'',f8.4)') 1.1
   write(iunit,'(13x,''KAB for M(5d)-M(5d)    :'',f8.4)') 1.1
   write(iunit,'(13x,''KAB for M-M (group XI) :'',f8.4)') 0.9

   !write(iunit,'(13x,a,":",10x,F12.4)') &
    !"k(s)             ",par%kspd(1),&
    !"k(p)             ",par%kspd(2),&
    !"k(d)             ",par%kspd(3),&
    !"k(f)             ",par%kspd(4),&
    !"kEN (H0ij)       ",par%kenscal,&
    !"D3 a1            ",par%disp%a1,&
    !"D3 a2            ",par%disp%a2,&
    !"D3 s6            ",par%disp%s6,&
    !"D3 s8            ",par%disp%s8,&
    !"D3 s9            ",par%disp%s9,&
    !"alphaj           ",par%alphaj,&
    !"ken⁴             ",par%xbdamp,&
    !"rep dEN          ",par%xbrad,&
    !"k(dz)            ",par%kcnsh(1),&
    !"SRB shift        ",par%kcnsh(2),&
    !"SRB prefact.     ",par%kcnsh(3),&
    !"SRB slope        ",par%kcnsh(4)
   write(iunit,'(a)')

   lnam(0)='s'
   lnam(1)='p'
   lnam(2)='d'
   lnam(3)='f'
   lnam(11)='S'
   lnam(12)='sp'
   lnam(13)='spd'

   nn=0
   do i=1,n
      nn(at(i))=nn(at(i))+1
   enddo

   write(iunit,*)' Z AO/shell   Hii/eV     exponent'
   do i=1,94
      atmp=timestp(i)
      if(nn(i).eq.0      ) cycle
      if(atmp(1:1).eq.'-') cycle
      write(iunit,'(i3,5x,A30,''  EN:'',F6.3,'' GAM:'',F6.3,''  GM3:'',F7.4)') &
         & i,timestp(i),en(i),gam(i),gam3(i)
      do j=1,ao_n(i)
         l=ao_l(j,i)
         write(iunit,'(3x,i3,a3,2F12.6)') &
            & ao_pqn(j,i),lnam(l),ao_lev(j,i),ao_exp(j,i)
      enddo
   enddo

end subroutine gfn0_prparam

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> TODO
module xtb_io_writer
   use mctc_env, only : error_type
   use mctc_io, only : structure_type, write_structure
   use xtb_io_writer_turbomole, only : writeResultsTurbomole
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType
   use xtb_mctc_version, only : version
   use xtb_type_molecule, only : TMolecule, assignment(=)
   
   implicit none
   private
   public :: writeMolecule

contains
!------------------------------------------------------------------
!   To write molecular structure data into a file
!------------------------------------------------------------------
subroutine writeMolecule(self, unit, format, energy, gnorm, number)
   
   class(TMolecule), intent(in) :: self
      !! dynamic type of TMolecule 
   integer, intent(in) :: unit
      !! IO unit for file
   integer, intent(in), optional :: format
      !! the format: xyz, pdb, sdf, etc. 
   real(wp), intent(in), optional :: energy
      !! energy output for comment line
   real(wp), intent(in), optional :: gnorm
      !! gradient norm output for comment line
   integer, intent(in), optional :: number
      !!
   
   character(len=:), allocatable :: comment_line
   character(len=20) :: energy_line
   character(len=20) :: gnorm_line
   type(structure_type) :: struc
   type(error_type), allocatable :: error
   integer :: ftype
   
   if (present(format)) then
      ftype = format
   else
      ftype = self%ftype
   endif

   comment_line = ''
   if (present(energy)) then
      write(energy_line, '(f20.12)') energy
      comment_line = comment_line // " energy: " // trim(adjustl(energy_line))
   endif
   if (present(gnorm)) then
      write(gnorm_line, '(f20.12)') gnorm
      comment_line = comment_line // " gnorm: " // trim(adjustl(gnorm_line))
   endif
   comment_line = comment_line // " xtb: " // version

   struc = self
   struc%comment = trim(comment_line)
   call write_structure(struc, unit, ftype, error)

   ! Flush file so that the output file can be visualized during optimization
   flush(unit)
end subroutine writeMolecule


end module xtb_io_writer

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_gfn2
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_gfn2

contains

!> Collect all exported unit tests
subroutine collect_gfn2(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("scc", test_gfn2_scc), &
      new_unittest("api", test_gfn2_api), &
      new_unittest("gbsa", test_gfn2gbsa_api), &
      new_unittest("salt", test_gfn2salt_api), &
      new_unittest("pcem", test_gfn2_pcem_api), &
      new_unittest("pcem_io", test_gfn2_pcem_io), &
      new_unittest("mindless-basic", test_gfn2_mindless_basic), &
      new_unittest("mindless-solvation", test_gfn2_mindless_solvation), &
      new_unittest("dmetal", test_gfn2_dmetal), &
      new_unittest("mindless-cosmo", test_gfn2_mindless_cosmo), &
      new_unittest("wbo", test_gfn2_wbo) &
      ]

end subroutine collect_gfn2


subroutine test_gfn2_scc(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_wavefunction
   use xtb_type_basisset
   use xtb_type_param
   use xtb_type_data
   use xtb_type_pcem
   use xtb_type_environment
   use xtb_type_solvation
   use xtb_solv_gbsa

   use xtb_setparam
   use xtb_basis
   use xtb_scf
   use xtb_scc_core
   use xtb_paramset

   use xtb_xtb_data
   use xtb_xtb_gfn2

   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-7_wp
   real(wp),parameter :: thr2 = 1.0e-5_wp
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      [ 0.00000000000000_wp,  0.00000000000000_wp, -0.73578586109551_wp, &
      & 1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp, &
      &-1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp  &
      & ],shape(xyz))
   real(wp),parameter :: et = 300.0_wp
   integer, parameter :: maxiter = 50
   integer, parameter :: prlevel = 2
   logical, parameter :: lgrad = .true.
   logical, parameter :: restart = .false.
   real(wp),parameter :: acc = 1.0_wp

   type(TEnvironment) :: env
   type(TMolecule)     :: mol
   type(scc_results)     :: res
   type(TBasisset)     :: basis
   type(TWavefunction) :: wfn
   type(tb_pcem)         :: pcem
   type(TxTBData) :: xtbData
   class(TSolvation), allocatable :: solvation

   real(wp) :: etot,egap
   real(wp), allocatable :: g(:,:)

   type(TxTBParameter) :: globpar
   logical  :: okpar,okbas
   logical :: exitRun

   set%gfn_method = 2
   call init(env)

   call init(mol, at, xyz)

   wfn%nel = idint(sum(mol%z))
   wfn%nopen = 0

   allocate( g(3,mol%n), source = 0.0_wp )

   call use_parameterset('param_gfn2-xtb.txt',globpar,xtbData,okpar)
   call check_(error, okpar)

   call newBasisset(xtbData,mol%n,mol%at,basis,okbas)
   call check_(error, okbas)

   call check_(error, basis%nshell,4)
   call check_(error, basis%nbf,   6)
   call check_(error, basis%nao,   6)

   call wfn%allocate(mol%n,basis%nshell,basis%nao)
   wfn%q = mol%chrg/real(mol%n,wp)

   call iniqshell(xtbData,mol%n,mol%at,mol%z,basis%nshell,wfn%q,wfn%qsh,set%gfn_method)

   g = 0.0_wp

   call scf(env,mol,wfn,basis,pcem,xtbData,solvation, &
      &   egap,et,maxiter,prlevel,restart,lgrad,acc,etot,g,res)

   call env%check(exitRun)
   call check_(error, .not.exitRun)

   call check_(error, res%converged)

   call check_(error, res%e_total,-5.070451355118_wp, thr=thr)
   call check_(error, res%gnorm,   0.006457420125_wp, thr=thr)
   ! value in electron volt
   call check_(error, res%hl_gap, 14.450372368833_wp, thr=1.0e-4_wp)
   call check_(error, res%e_elec, -5.104362813671_wp, thr=thr)
   ! es and aes are not welldefined at this accuracy level
   call check_(error, res%e_es,    0.031408028914_wp, thr=thr*10)
   call check_(error, res%e_aes,   0.000563300591_wp, thr=thr*10)
   call check_(error, res%e_axc,  -0.000813611055_wp, thr=thr)
   call check_(error, res%e_disp, -0.000141250480_wp, thr=thr)
   call check_(error, res%e_rep,   0.033911458523_wp, thr=thr)

   call check_(error, wfn%q(2),0.28158903353422_wp, thr=thr2)
   call check_(error, wfn%q(3),wfn%q(2), thr=thr2)
   call check_(error, wfn%qsh(1),0.25886041477578_wp, thr=thr2)
   call check_(error, wfn%dipm(2,2), 0.00000000000000E+00_wp, thr=thr2)
   call check_(error, wfn%dipm(1,3),-0.55238805565739E-01_wp, thr=thr2)
   call check_(error, wfn%qp(6,1),0.41207363331933E-01_wp, thr=thr2)
   call check_(error, wfn%qp(1,3),0.95084219046109E-01_wp, thr=thr2)

   call check_(error, wfn%ihomo,4)
   call check_(error, wfn%ihomoa,wfn%ihomob)
   call check_(error, wfn%emo(wfn%ihomo),-12.166283951806_wp, thr=thr2)
   call check_(error, wfn%focca(wfn%ihomo),wfn%foccb(wfn%ihomo), thr=thr2)
   call check_(error, wfn%focc(wfn%ihomo),2.0_wp, thr=thr2)

   call mol%deallocate
   call wfn%deallocate
   call basis%deallocate

end subroutine test_gfn2_scc

subroutine test_gfn2_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-9_wp
   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,6,6,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00000000000000_wp, 0.00000000000000_wp,-1.79755622305860_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 0.95338756106749_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 3.22281255790261_wp, &
      &-0.96412815539807_wp,-1.66991895015711_wp,-2.53624948351102_wp, &
      &-0.96412815539807_wp, 1.66991895015711_wp,-2.53624948351102_wp, &
      & 1.92825631079613_wp, 0.00000000000000_wp,-2.53624948351102_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 5.23010455462158_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = "none")

   type(TMolecule)    :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3, 3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)
   call check_(error, hl_gap, 7.0005867526665_wp, thr=thr)
   call check_(error, energy,-8.3824793849585_wp, thr=thr)
   call check_(error, norm2(gradient),0.11544410028854E-01_wp, thr=thr)

   call check_(error, gradient(2,3), 0.00000000000000E+00_wp, thr=thr)
   call check_(error, gradient(3,1),-0.74649908147372E-03_wp, thr=thr)
   call check_(error, gradient(1,4),-0.28433755158510E-03_wp, thr=thr)
   call check_(error, gradient(3,7), 0.99750545315944E-02_wp, thr=thr)

end subroutine test_gfn2_api

subroutine test_gfn2gbsa_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment
   use xtb_solv_input

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 5.0e-7_wp
   integer, parameter :: nat = 11
   integer, parameter :: at(nat) = [7,1,1,1,15,6,6,6,7,7,7]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.84112686339230_wp,-1.15671648374837_wp, 0.00000000000000_wp, &
      & 5.87217277985151_wp,-0.70323701391366_wp, 1.54511189584035_wp, &
      & 5.87217277985151_wp,-0.70323701391366_wp,-1.54511189584035_wp, &
      & 4.61871932563459_wp,-3.05696083228965_wp, 0.00000000000000_wp, &
      & 0.23751589819013_wp, 1.28722286021158_wp, 0.00000000000000_wp, &
      & 0.00161949529588_wp,-0.89075264835377_wp, 2.57562301980395_wp, &
      &-3.06580664031769_wp, 2.16487781673832_wp, 0.00000000000000_wp, &
      & 0.00161949529588_wp,-0.89075264835377_wp,-2.57562301980395_wp, &
      &-5.06585309511506_wp, 3.00827014874972_wp, 0.00000000000000_wp, &
      & 0.00161949529588_wp,-2.15043086045241_wp, 4.34183098346579_wp, &
      & 0.00161949529588_wp,-2.15043086045241_wp,-4.34183098346579_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = "h2o")

   type(TMolecule)    :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)
   call addSolvationModel(env, calc, TSolvInput(solvent=opt%solvent, alpb=.false., kernel=gbKernel%still))

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 3.408607724814_wp, thr=1e-5_wp)
   call check_(error, energy,-22.002501380096_wp, thr=thr)
   call check_(error, norm2(gradient),0.19441977481008E-01_wp, thr=thr)
   call check_(error, gradient(1,1), .9038674439127e-02_wp, thr=thr)
   call check_(error, gradient(3,2),-.1394693523214e-02_wp, thr=thr)
   call check_(error, gradient(3,11),-gradient(3,10), thr=thr)
   call check_(error, gradient(1,8),0.22890674680144E-02_wp, thr=thr)

end subroutine test_gfn2gbsa_api

subroutine test_gfn2salt_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_convert, only : aatoau

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment
   use xtb_solv_input

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 5.0e-7_wp
   integer, parameter :: nat = 8
   integer, parameter :: at(nat) = [7,7,9,1,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00000000000000_wp, 1.30633555031959_wp, 0.00000000000000_wp,  &
      &-1.26402080275201_wp,-4.06871453465823_wp, 0.00000000000000_wp,  &
      & 1.42937939828404_wp, 3.57212474255400_wp, 0.00000000000000_wp,  &
      &-2.92500314615638_wp,-3.12058224200551_wp, 0.00000000000000_wp,  &
      & 0.71133449039308_wp, 0.35812010971703_wp, 1.51289962417918_wp,  &
      &-1.25697212427635_wp,-5.20406577474818_wp,-1.53711646457211_wp,  &
      & 0.71133449039308_wp, 0.35812010971703_wp,-1.51289962417918_wp,  &
      &-1.25697212427635_wp,-5.20406577474818_wp, 1.53711646457211_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = 'ch2cl2' )

   type(TMolecule)    :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)
   call addSolvationModel(env, calc, TSolvInput(solvent=opt%solvent, &
      & ionRad=1.0_wp*aatoau, ionStrength=1.0e-3_wp, alpb=.false., kernel=gbKernel%still))

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 6.895830675032_wp, thr=5e-5_wp)
   call check_(error, energy,-13.027106170796_wp, thr=thr)
   call check_(error, norm2(gradient),0.014655633557_wp, thr=thr)

   call check_(error, gradient(1,1),-0.6696141112967e-02_wp, thr=thr)
   call check_(error, gradient(2,4),-0.7608884457863e-03_wp, thr=thr)
   call check_(error, gradient(1,5), 0.2359793849677e-02_wp, thr=thr)
   call check_(error, gradient(3,7), 0.6882248903260e-02_wp, thr=thr)

end subroutine test_gfn2salt_api

subroutine test_gfn2_pcem_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_pcem
   use xtb_type_environment

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 12, nat2 = nat/2
   integer, parameter :: at(nat) = [8,1,1, 8,1,1, 8,1,1, 8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape([&
      &-2.75237178376284_wp, 2.43247309226225_wp,-0.01392519847964_wp, &
      &-0.93157260886974_wp, 2.79621404458590_wp,-0.01863384029005_wp, &
      &-3.43820531288547_wp, 3.30583608421060_wp, 1.42134539425148_wp, &
      &-2.43247309226225_wp,-2.75237178376284_wp, 0.01392519847964_wp, &
      &-2.79621404458590_wp,-0.93157260886974_wp, 0.01863384029005_wp, &
      &-3.30583608421060_wp,-3.43820531288547_wp,-1.42134539425148_wp, &
      & 2.75237178376284_wp,-2.43247309226225_wp,-0.01392519847964_wp, &
      & 0.93157260886974_wp,-2.79621404458590_wp,-0.01863384029005_wp, &
      & 3.43820531288547_wp,-3.30583608421060_wp, 1.42134539425148_wp, &
      & 2.43247309226225_wp, 2.75237178376284_wp, 0.01392519847964_wp, &
      & 2.79621404458590_wp, 0.93157260886974_wp, 0.01863384029005_wp, &
      & 3.30583608421060_wp, 3.43820531288547_wp,-1.42134539425148_wp], shape(xyz))
   real(wp),parameter :: q(nat2) = [&
      &-0.69645733_wp,       0.36031084_wp,       0.33614649_wp, &
      &-0.69645733_wp,       0.36031084_wp,       0.33614649_wp]
   real(wp),parameter :: gam(nat2) = [&
      & 0.451896_wp,       0.405771_wp,       0.405771_wp, &
      & 0.451896_wp,       0.405771_wp,       0.405771_wp]
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 12.391144584178_wp, thr=thr)
   call check_(error, energy,-20.323978512117_wp, thr=thr)
   call check_(error, norm2(gradient),0.78119239557115E-02_wp, thr=thr)

   call check_(error, gradient(1,5),-0.22192122053513E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.22192122053512E-02_wp, thr=thr)
   call check_(error, gradient(1,4), 0.95621597761913E-03_wp, thr=thr)
   call check_(error, gradient(3,6),-0.11904153838296E-02_wp, thr=thr)

   ! reset
   call mol%deallocate
   deallocate(gradient)

   call init(mol, at(:nat2), xyz(:, :nat2))
   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)

   call calc%pcem%allocate(nat2)
   calc%pcem%xyz = xyz(:,nat2+1:)
   ! gam from xtb_aoparam is now filled with GFN2-xTB hardnesses
   calc%pcem%gam = gam
   calc%pcem%q   = q
   calc%pcem%grd = 0.0_wp

   call newWavefunction(env, mol, calc, chk)
   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 12.718203165741_wp, thr=thr)
   call check_(error, energy,-10.160927754235_wp, thr=thr)
   call check_(error, norm2(gradient),0.21549557655285E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.20326749264006E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.33125459724368E-02_wp, thr=thr)
   call check_(error, gradient(1,4),-0.11929405659085E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.16607682747438E-02_wp, thr=thr)

   call check_(error, norm2(calc%pcem%grd),0.10043976337709E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,5),-0.24831958012524E-03_wp, thr=thr)
   call check_(error, calc%pcem%grd(2,2), 0.14208444722973E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,4), 0.37466852704082E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(3,6), 0.65161344334732E-03_wp, thr=thr)

   ! reset
   energy = 0.0_wp
   gradient = 0.0_wp
   calc%pcem%grd = 0.0_wp
   calc%pcem%gam = 999.0_wp ! point charges

   call newWavefunction(env, mol, calc, chk)
   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 13.024345612330_wp, thr=thr)
   call check_(error, energy,-10.168788268962_wp, thr=thr)
   call check_(error, norm2(gradient),0.18113624400926E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.50646289499094E-03_wp, thr=thr)
   call check_(error, gradient(2,2), 0.25468320656932E-02_wp, thr=thr)
   call check_(error, gradient(1,4),-0.74927880093291E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.13248514654811E-02_wp, thr=thr)

   call check_(error, norm2(calc%pcem%grd),0.18721791896294E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,5),-0.21573703225712E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(2,2), 0.25653662154150E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,4), 0.12124342986218E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(3,6), 0.12140575062433E-02_wp, thr=thr)

end subroutine test_gfn2_pcem_api

subroutine test_gfn2_pcem_io(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_pcem
   use xtb_type_environment
   use xtb_embedding, only: read_pcem

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 12, nat2 = nat/2
   integer, parameter :: at(nat) = [8,1,1, 8,1,1, 8,1,1, 8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape([&
      &-2.75237178376284_wp, 2.43247309226225_wp,-0.01392519847964_wp, &
      &-0.93157260886974_wp, 2.79621404458590_wp,-0.01863384029005_wp, &
      &-3.43820531288547_wp, 3.30583608421060_wp, 1.42134539425148_wp, &
      &-2.43247309226225_wp,-2.75237178376284_wp, 0.01392519847964_wp, &
      &-2.79621404458590_wp,-0.93157260886974_wp, 0.01863384029005_wp, &
      &-3.30583608421060_wp,-3.43820531288547_wp,-1.42134539425148_wp, &
      & 2.75237178376284_wp,-2.43247309226225_wp,-0.01392519847964_wp, &
      & 0.93157260886974_wp,-2.79621404458590_wp,-0.01863384029005_wp, &
      & 3.43820531288547_wp,-3.30583608421060_wp, 1.42134539425148_wp, &
      & 2.43247309226225_wp, 2.75237178376284_wp, 0.01392519847964_wp, &
      & 2.79621404458590_wp, 0.93157260886974_wp, 0.01863384029005_wp, &
      & 3.30583608421060_wp, 3.43820531288547_wp,-1.42134539425148_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   integer :: tmp_unit

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 12.391144584178_wp, thr=thr)
   call check_(error, energy,-20.323978512117_wp, thr=thr)
   call check_(error, norm2(gradient),0.78119239557115E-02_wp, thr=thr)

   call check_(error, gradient(1,5),-0.22192122053513E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.22192122053512E-02_wp, thr=thr)
   call check_(error, gradient(1,4), 0.95621597761913E-03_wp, thr=thr)
   call check_(error, gradient(3,6),-0.11904153838296E-02_wp, thr=thr)

   ! reset
   call mol%deallocate
   deallocate(gradient)

   call init(mol, at(:nat2), xyz(:, :nat2))
   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)

   open(newunit=tmp_unit, Status="Scratch")
      write(tmp_unit,'(a)') &
      "6",&
      "-0.69645733    2.75237178376284    -2.43247309226225    -0.01392519847964  O", &
      " 0.36031084    0.93157260886974    -2.79621404458590    -0.01863384029005  H", &
      " 0.33614649    3.43820531288547    -3.30583608421060     1.42134539425148  H", &
      "-0.69645733    2.43247309226225     2.75237178376284     0.01392519847964  O", &
      " 0.36031084    2.79621404458590     0.93157260886974     0.01863384029005  H", &
      " 0.33614649    3.30583608421060     3.43820531288547    -1.42134539425148  H"
   Call read_pcem(tmp_unit,env,calc%pcem,calc%xtbData%coulomb)
   close(tmp_unit,Status="Delete")

   calc%pcem%grd = 0.0_wp

   call newWavefunction(env, mol, calc, chk)
   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 12.718203165741_wp, thr=thr)
   call check_(error, energy,-10.160927754235_wp, thr=thr)
   call check_(error, norm2(gradient),0.21549557655285E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.20326749264006E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.33125459724368E-02_wp, thr=thr)
   call check_(error, gradient(1,4),-0.11929405659085E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.16607682747438E-02_wp, thr=thr)

   call check_(error, norm2(calc%pcem%grd),0.10043976337709E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,5),-0.24831958012524E-03_wp, thr=thr)
   call check_(error, calc%pcem%grd(2,2), 0.14208444722973E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,4), 0.37466852704082E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(3,6), 0.65161344334732E-03_wp, thr=thr)

   ! reset
   energy = 0.0_wp
   gradient = 0.0_wp
   calc%pcem%grd = 0.0_wp
   calc%pcem%gam = 999.0_wp ! point charges

   call newWavefunction(env, mol, calc, chk)
   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 13.024345612330_wp, thr=thr)
   call check_(error, energy,-10.168788268962_wp, thr=thr)
   call check_(error, norm2(gradient),0.18113624400926E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.50646289499094E-03_wp, thr=thr)
   call check_(error, gradient(2,2), 0.25468320656932E-02_wp, thr=thr)
   call check_(error, gradient(1,4),-0.74927880093291E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.13248514654811E-02_wp, thr=thr)

   call check_(error, norm2(calc%pcem%grd),0.18721791896294E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,5),-0.21573703225712E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(2,2), 0.25653662154150E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,4), 0.12124342986218E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(3,6), 0.12140575062433E-02_wp, thr=thr)

end subroutine test_gfn2_pcem_io

subroutine test_gfn2_mindless_basic(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   real(wp), parameter :: ref_energies(10) = &
      &[-30.348902328339_wp, -24.069929673504_wp, -23.718708414840_wp, &
      & -22.751497890244_wp, -27.735987617741_wp, -18.559531652263_wp, &
      & -33.423246445911_wp, -29.982410709899_wp, -20.549458882257_wp, &
      & -25.648093031152_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.06081938165963_wp, 0.05480379303387_wp, 0.04179957306749_wp, &
      & 0.06932568214054_wp, 0.05133081215262_wp, 0.05897000784363_wp, &
      & 0.04600837003153_wp, 0.06088718433105_wp, 0.05314451272641_wp, &
      & 0.04588800056975_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[2.2611412120964_wp, 1.2455369848896_wp, 0.1490345448030_wp, &
      & 1.2694246332861_wp, 2.2362028272626_wp, 2.6053844166160_wp, &
      & 2.6312636988491_wp, 0.8502228061534_wp, 3.2960732039022_wp, &
      & 0.4185654147579_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn2-xtb.txt', 2)
      call newWavefunction(env, mol, calc, chk)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn2_mindless_basic


subroutine test_gfn2_mindless_solvation(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   character(len=*), parameter :: solvents(10) = [character(len=20) ::&
      & "h2o", "chcl3", "thf", "acetonitrile", "toluene", &
      & "ch2cl2", "ether", "methanol", "cs2", "dmso"]
   real(wp), parameter :: ref_energies(10) = &
      &[-30.384994095620_wp, -24.092790321708_wp, -23.760000587724_wp, &
      & -22.759033676135_wp, -27.755756860587_wp, -18.578906535415_wp, &
      & -33.448544467530_wp, -29.993777657049_wp, -20.567481283491_wp, &
      & -25.665458003353_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.064382736361151_wp, 0.055824257363022_wp, 0.040696787567357_wp, &
      & 0.073197307180171_wp, 0.049852029310233_wp, 0.053051084845551_wp, &
      & 0.046463198340453_wp, 0.057936724779824_wp, 0.055081716352177_wp, &
      & 0.045339090185313_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[2.5109978045214_wp, 1.3559515037838_wp, 0.1719065524538_wp, &
      & 1.2428812469179_wp, 2.1428443722148_wp, 2.2548300583012_wp, &
      & 2.6935601499212_wp, 0.83100059690964_wp, 3.3270919380043_wp, &
      & 0.3859217429034_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn2-xtb.txt', 2)
      call newWavefunction(env, mol, calc, chk)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & alpb=mod(iMol, 2)==0, kernel=gbKernel%still))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn2_mindless_solvation


subroutine test_gfn2_dmetal(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   real(wp), parameter :: ref_energies(3) = &
      &[-34.066853522474_wp, -34.078580189077_wp, -34.078529449408_wp]
   real(wp), parameter :: ref_gnorms(3) = &
      &[0.26985488354859_wp, 0.26591831790033_wp, 0.26613440125774_wp]
   real(wp), parameter :: ref_hlgaps(3) = &
      &[ 2.9239308006972_wp,  2.9163891345974_wp,  2.9168589130125_wp]

   call init(env)
   do iMol = 1, 3

      call getMolecule(mol, 'feco5')

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn2-xtb.txt', 2)
      call newWavefunction(env, mol, calc, chk)
      if (iMol > 1) then
         call addSolvationModel(env, calc, TSolvInput(solvent='ch2cl2', &
            & alpb=iMol==3, kernel=gbKernel%still))
      end if

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 1, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn2_dmetal


subroutine test_gfn2_mindless_cosmo(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   character(len=*), parameter :: solvents(10) = [character(len=20) ::&
      & "h2o", "chcl3", "thf", "acetonitrile", "toluene", &
      & "ch2cl2", "ether", "methanol", "cs2", "dmso"]
   real(wp), parameter :: ref_energies(10) = &
      &[-30.398257570644_wp,-24.125868305041_wp,-23.787177902522_wp, &
      & -22.779539008049_wp,-27.783054701847_wp,-18.610486346192_wp, &
      & -33.456896298026_wp,-30.008556230192_wp,-20.588957648989_wp, &
      & -25.684670492104_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.070117675966_wp, 0.060272066809_wp, 0.048063628868_wp, &
      & 0.076296084561_wp, 0.050041916284_wp, 0.051542825738_wp, &
      & 0.046066119467_wp, 0.060436009320_wp, 0.058023381592_wp, &
      & 0.050440402702_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[3.173028297842_wp, 1.553006040621_wp, 0.324761161079_wp, &
      & 1.233091187215_wp, 1.918282889245_wp, 2.067664999523_wp, &
      & 2.757505697757_wp, 0.846361565116_wp, 3.336544801399_wp, &
      & 0.315118656281_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn2-xtb.txt', 2)
      call newWavefunction(env, mol, calc, chk)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & cosmo=.true., nang=74))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do
end subroutine test_gfn2_mindless_cosmo

subroutine test_gfn2_wbo(error)
   use xtb_mctc_accuracy, only : wp
   use mctc_io_convert, only : aatoau
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   energy=0.0_wp
   call init(env)
   
   !-----!
   ! RHF !
   !-----!
   
   ! initialization of mol str !
   call getMolecule(mol, 'co_cnx6')
   mol%xyz = mol%xyz*aatoau

   ! allocate GFN2 calculator !
   if (allocated(gradient)) deallocate(gradient)
   allocate(gradient(3, len(mol)))
   call newXTBCalculator(env, mol, calc, 'param_gfn2-xtb.txt', 2)
   call newWavefunction(env, mol, calc, chk)

   call env%check(exitRun)
   call check_(error, .not.exitRun)

   ! actual SP !
   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)
   
   call env%check(exitRun)
   call check_(error, .not.exitRun)

   ! check  scc !
   call check_(error, energy, -34.191439852632_wp, thr=thr)
   call check_(error, norm2(gradient), 0.041770673817_wp, thr=thr)
   call check_(error, hl_gap, 3.769023080904_wp, thr=thr)

   ! check wbo !
   call check_(error, chk%wfn%wbo(1,2), 0.889766438284303_wp,thr=thr) 
   call check_(error, chk%wfn%wbo(3,4), 1.728632460261216E-002_wp,thr=thr) 
   call check_(error, chk%wfn%wbo(2,10), 2.73380919723017_wp,thr=thr) 

   !-----!
   ! UHF !
   !-----!
   
   ! initialization of mol str !
   call getMolecule(mol, 'fe_cnx6')
   mol%xyz = mol%xyz*aatoau
   
   ! allocate GFN2 calculator !
   if (allocated(gradient)) deallocate(gradient)
   allocate(gradient(3, len(mol)))
   call newXTBCalculator(env, mol, calc, 'param_gfn2-xtb.txt', 2)
   call newWavefunction(env, mol, calc, chk)

   call env%check(exitRun)
   call check_(error, .not.exitRun)
  
   ! actual SP !
   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)
 
   call env%check(exitRun)
   call check_(error, .not.exitRun)

   ! check  scc !
   call check_(error, energy, -33.314958144107_wp, thr=thr)
   call check_(error, norm2(gradient), 0.018945181484_wp, thr=thr)
   call check_(error, hl_gap, 1.805948277212_wp, thr=thr)


   ! check wbo !
   call check_(error, chk%wfn%wbo(1,2), 0.587095913328687_wp,thr=thr) 
   call check_(error, chk%wfn%wbo(3,4), 3.798539382576892E-002_wp,thr=thr) 
   call check_(error, chk%wfn%wbo(2,10), 2.81892857328157_wp,thr=thr) 

end subroutine test_gfn2_wbo

end module test_gfn2

! This file is part of xtb.
!
! Copyright (C) 2020, NVIDIA CORPORATION. All rights reserved.
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module nvtx

  use iso_c_binding
  implicit none

  integer,private :: col(7) = [ Z'0000ff00', Z'000000ff', Z'00ffff00', Z'00ff00ff', Z'0000ffff', Z'00ff0000', Z'00ffffff']
  character(len=256),private :: tempName

  type, bind(C):: nvtxEventAttributes
    integer(C_INT16_T):: version=1
    integer(C_INT16_T):: size=48 !
    integer(C_INT):: category=0
    integer(C_INT):: colorType=1 ! NVTX_COLOR_ARGB = 1
    integer(C_INT):: color
    integer(C_INT):: payloadType=0 ! NVTX_PAYLOAD_UNKNOWN = 0
    integer(C_INT):: reserved0
    integer(C_INT64_T):: payload   ! union uint,int,double
    integer(C_INT):: messageType=1  ! NVTX_MESSAGE_TYPE_ASCII     = 1 
    type(C_PTR):: message  ! ascii char
  end type

  interface nvtxRangePush
    ! push range with custom label and standard color
    subroutine nvtxRangePushA(name) bind(C, name='nvtxRangePushA')
      use iso_c_binding
      character(kind=C_CHAR,len=*) :: name
    end subroutine

    ! push range with custom label and custom color
    subroutine nvtxRangePushEx(event) bind(C, name='nvtxRangePushEx')
      use iso_c_binding
      import:: nvtxEventAttributes
      type(nvtxEventAttributes):: event
    end subroutine
  end interface

  interface nvtxRangePop
    subroutine nvtxRangePop() bind(C, name='nvtxRangePop')
    end subroutine
  end interface

contains

  subroutine nvtxStartRange(name,id)
    character(kind=c_char,len=*) :: name
    integer, optional:: id
    type(nvtxEventAttributes):: event

    tempName=trim(name)//c_null_char

    if ( .not. present(id)) then
      call nvtxRangePush(tempName)
    else
      event%color=col(mod(id,7)+1)
      event%message=c_loc(tempName)
      call nvtxRangePushEx(event)
    end if
  end subroutine

  subroutine nvtxEndRange
    call nvtxRangePop
  end subroutine

end module nvtx

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> implementation of different relaxation procedures, every relax algorithm
!  comes with its own parameter class (most are general parameters like thresholds)
module xtb_relaxation_engine
   use xtb_io_writer, only : writeMolecule
   use xtb_mctc_accuracy, only : wp, sp
   use xtb_mctc_convert, only : fstoau, amutoau
   use xtb_mctc_fileTypes, only : fileType
   use xtb_type_environment, only : TEnvironment
   use xtb_optimizer, only : convergence_log, load_turbomole_log
   use xtb_bfgs
   use xtb_david2
   implicit none
   private :: wp
   !> precision of the rational function step (usually single instead of double)

   !> generic optimization options bundle, contains mostly convergence thresholds
   !  and IO informations
   type relax_options
      !> printlevel
      integer  :: printlevel = 2
      !> single point accuracy
      real(wp) :: acc = 1.0_wp
      !> maximum displacement for MD step
      real(wp) :: max_displacement = 0.2_wp
      !> write optimization log for every nth step
      integer  :: logstep = 1
      !> unit for the optimization log
      integer  :: ilog = -1
      !> file type for optimization log
      integer  :: ftype = 1
      !> threshold for the converence of the energy change of the system
      real(wp) :: e_thr = 5.0e-6_wp
      !> threshold for the converence of the gradient norm of the system
      real(wp) :: g_thr = 1.0e-3_wp
      !> threshold for the converence of the displacement norm of the system
      real(wp) :: d_thr = 1.0e-3_wp
      !> threshold for the converence of the maximum compounent of the gradient
      real(wp) :: g_max = 1.0e-3_wp
      !> threshold for the converence of the maximum compounent of the displacement
      real(wp) :: d_max = 1.0e-3_wp
   end type relax_options

   !> settings for the fast inertial relaxation engine
   type, extends(relax_options) :: fire_options
      !> number of steps for resetting ANC's
      integer :: micro_cycle = 20
      !> time step for the MD propagation
      real(wp) :: time_step = 0.25_wp * fstoau
      !> time step for the MD propagation
      real(wp) :: lat_time_step = 0.25_wp * fstoau
      !> parameter for adjusting velocities
      real(wp) :: astart = 0.1_wp
      !> scaling parameter for astart
      real(wp) :: fa = 0.99_wp
      !> step to start incrementing propagation time length
      integer  :: nmin = 5
      !> increment of time step
      real(wp) :: finc = 1.1_wp
      !> decrement of time step at internal reset
      real(wp) :: fdec = 0.5_wp
      !> maximium number of timestep
      real(wp) :: dtmax = 1.25_wp * fstoau
      !> power threshold for internal reset
      real(wp) :: pcut = 0.0_wp
      !> mass of particles
      real(wp) :: mass = 1.0_wp * amutoau
      !> mass of lattice parameters
      real(wp) :: lat_mass = 1.0_wp * amutoau
      !> use preconditioning with (model) hessian
      logical :: precon = .false.
      !> use BFGS update of hessian
      logical :: update = .false.
   end type fire_options

   !> settings for the low memory BFGS optimizer
   type, extends(relax_options) :: lbfgs_options
      !> lifetime of the approximate normal coordinate system
      integer :: micro_cycle = 20
      !> convergence threshold for the iterative RF solver
      real(sp) :: rfthr = 1.0e-8_sp
      !> number of images to consider in the updating procedure
      integer :: memory = 20
      !> lower eigenvalue cutoff for (model) hessian
      real(wp) :: hlow = 0.02_wp
      !> highest eigenvalue cutoff for (model) hessian
      real(wp) :: hmax = 5.0_wp
      !> increment for microcycles
      real(wp) :: cycle_inc = 1.1_wp
   end type lbfgs_options

   !> use profiler while performing relaxation
   logical, private, parameter :: profile = .true.

   !> format for printing reals in setup section using scientific notation
   character(len=*), private, parameter :: scifmt = &
      '(10x,":",3x,a,e21.7,1x,a,1x,":")'
   !> format for printing reals in setup section
   character(len=*), private, parameter :: dblfmt = &
      '(10x,":",3x,a,f17.7,5x,a,1x,":")'
   !> format for printing ints in setup section
   character(len=*), private, parameter :: intfmt = &
      '(10x,":",3x,a,i17,  5x,a,1x,":")'
   !> format for printing strings in setup section
   character(len=*), private, parameter :: chrfmt = &
      '(10x,":",3x,a,a17,      11x,":")'

   !> format for printlevel==2 cycle header
   character(len=*), private, parameter :: cyclefmt = &
      '(/,72("."),/,30(".")," CYCLE",i5,1x,30("."),/,72("."))'

contains

!> frontend implementation of the fast inertial relaxation engine
subroutine fire &
      &   (env,ilog,mol,chk,calc, &
      &    optlevel,maxstep,energy,egap,gradient,sigma,printlevel,fail)

   use xtb_mctc_convert

   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_type_timer

   use xtb_setparam
   use xtb_fixparam

   use xtb_optimizer
   use xtb_axis
   use xtb_hessian
   use xtb_lsrmsd
   use xtb_pbc_tools

   implicit none

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "relaxation_engine_fire"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   integer, intent(in) :: ilog

   type(TMolecule), intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   !> optimization level
   integer, intent(in) :: optlevel
   !> maximum number of steps
   integer, intent(in) :: maxstep
   !> energy of the system, contains energy of initial configuration on start
   !  and energy of final configuration at exit
   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: egap
   !> gradient of the system, contains gradient of initial configuration on start
   !  and gradient of final configuration at exit
   real(wp), intent(inout) :: gradient(:,:)
   real(wp), intent(inout) :: sigma(3,3)
   integer, intent(in) :: printlevel
   logical, intent(out) :: fail

   logical :: minpr
   logical :: pr
   logical :: debug
   logical :: converged
   logical :: linear
   integer :: iter
   integer :: nvar
   integer :: nat3
   integer :: thisstep
   integer :: maxcycle

   type(TMolecule) :: molopt

   real(wp) :: time
   real(wp) :: a,b,c
   real(wp) :: U(3,3), x_center(3), y_center(3), rmsdval
   real(wp) :: estart,esave
   real(wp), allocatable :: xyz0(:,:)
   real(wp), allocatable :: xyzopt(:,:)
   real(wp), allocatable :: grmsd(:,:)
   real(wp), allocatable :: velocities(:,:)
   !  packed (model) hessian
   real(wp), allocatable :: hessp(:)
   !  dummy for projection
   real(wp), allocatable :: pmode(:,:)

   !  settings for the fast inertial relaxation engine
   type(fire_options) :: opt

   !  optimize cell parameters
   logical :: optcell
   real(wp) :: lat_gradient(3,3)
   real(wp) :: lat_velocities(3,3)
   real(wp) :: inv_lat(3,3)

   !  timer for profiling (only for printlevel > 1)
   type(tb_timer) :: timer

   ! its an atom, we are done here
   if (mol%n.eq.1) return
   ! setup the timer for a profiling run
   if (profile) call timer%new(8,.false.)
   if (profile) call timer%measure(1,'setup')

   ! settings for optimizer, defaults from ase/optimize/precon/fire.py
   opt = fire_options(logstep = 1, &
      &               dtmax = 1.25_wp * fstoau, time_step = 0.25_wp * fstoau, &
      &               micro_cycle = set%optset%micro_opt, &
      &               max_displacement = set%optset%maxdispl_opt, &
      &               printlevel = printlevel, &
      &               precon = .false., update = .false.)

   ! obtain the thresholds from the optlevel, possible optlevels are currently
   call get_optthr(mol%n,optlevel,opt%e_thr,opt%g_thr,maxcycle,opt%acc)
   ! check for user input regarding the maximum number of cycles
   if (maxstep > 0) maxcycle = maxstep
   ! deactivate microcyles (seems to be expensive with only small gains)

   ! open the logfile, the log is bound to unit 942, so we cannot use newunit
   ! and have to hope that nobody else is currently occupying this identifier
   opt%ilog = ilog
   if (mol%npbc > 0) then
      opt%ftype = fileType%vasp
   else
      opt%ftype = fileType%xyz
   endif
   !call open_file(opt%ilog,'xtbopt.log','w')
   ! write starting structure to log
   if (opt%ilog.ne.-1) then
      call writeMolecule(mol, opt%ilog,format=opt%ftype, energy=energy, &
         & gnorm=norm2(gradient))
   endif

   ! get memory
   nat3 = 3*mol%n
   nvar = nat3
   if(fixset%n.gt.0) then ! exact fixing
      nvar=nat3-3*fixset%n-3
      if(nvar.le.0) nvar=1
   endif

   allocate( velocities(3,mol%n), pmode(nvar,1), hessp(nat3*(nat3+1)/2), &
      &      xyzopt(3,mol%n), source = 0.0_wp )
   ! set defaults
   iter = 0
   converged = .false.
   optcell = mol%npbc > 0
   minpr = opt%printlevel > 0
   pr    = opt%printlevel > 1
   debug = opt%printlevel > 2

   ! initial velocities
   velocities = -opt%time_step * gradient/opt%mass
   if (optcell) then
      inv_lat = mat_inv_3x3(mol%lattice)
      call sigma_to_latgrad(sigma,inv_lat,lat_gradient)
      lat_velocities = -opt%lat_time_step * lat_gradient/opt%lat_mass
   endif

   call axis(mol%n,mol%at,mol%xyz,a,b,c)
   linear = c.lt.1.0e-10_wp

   ! print a nice summary with all settings and thresholds of FIRE
   if(pr)then
      write(env%unit,'(a)') &
         "      ----------------------------------------------------------- ",&
         "     |              Fast Inertial Relaxation Engine              |",&
         "      ----------------------------------------------------------- "
      write(env%unit,'(/,10x,51("."))')
      write(env%unit,'(10x,":",22x,a,22x,":")') "SETUP"
      write(env%unit,'(10x,":",49("."),":")')
      write(env%unit,scifmt) "energy convergence",opt%e_thr,           "Eh   "
      write(env%unit,scifmt) "grad. convergence ",opt%g_thr,           "Eh/a0"
      write(env%unit,chrfmt) "optimization log  ",bool2string(opt%ilog.ne.-1)
      write(env%unit,intfmt) "writing optlog all",opt%logstep,         "steps"
      write(env%unit,intfmt) "Hessian reset     ",opt%micro_cycle,     "steps"
      write(env%unit,intfmt) "time step scaling ",opt%nmin,            "steps"
      write(env%unit,dblfmt) "maximium step len.",opt%max_displacement,"a0   "
      write(env%unit,dblfmt) "initial time step ",opt%time_step*autofs,"fs   "
      write(env%unit,dblfmt) "maximum time step ",opt%dtmax*autofs,    "fs   "
      write(env%unit,dblfmt) "power reset thr   ",opt%pcut,            "au   "
      write(env%unit,dblfmt) "alpha parameter   ",opt%astart,          "     "
      write(env%unit,chrfmt) "BFGS update       ",bool2string(opt%update)
      write(env%unit,chrfmt) "preconditioning   ",bool2string(opt%precon)
      write(env%unit,'(10x,51("."))')
   endif

   if (profile) call timer%measure(1)

   estart = energy
   thisstep = opt%micro_cycle
   molopt = mol

   if (.not.pr.and.minpr) write(env%unit,'(a6,a14,a16,a16,a15,a6)') &
      &          "cycle", "energy", "change", "gnorm", "step", "conv?"
! ======================================================================
   Precon_microiter: do while (.not.converged .and. iter.lt.maxcycle)
! ======================================================================
   if (profile) call timer%measure(7,"model hessian")
   if (opt%precon) then
      if (minpr) write(env%unit,'(" * calculating model hessian...")')
      call modhes(env,calc,set%mhset,molopt%n,molopt%xyz,molopt%at,hessp,pr)
      if(fixset%n.gt.0)then
         ! exact fixing
         call trproj(molopt%n,molopt%n*3,molopt%xyz,hessp,.false.,-1,pmode,1)
      else
         if (.not.linear) &
         ! normal
         call trproj(molopt%n,molopt%n*3,molopt%xyz,hessp,.false.,0,pmode,1) 
      endif

   endif
   if (profile) call timer%measure(7)
   esave = energy
   xyz0 = molopt%xyz

   call inertial_relax &
      &   (env,iter,thisstep,opt,molopt, &
      &    chk,calc,energy,egap,gradient,sigma,hessp,velocities, &
      &    lat_velocities,optcell,converged,fail,timer)

   thisstep = min(ceiling(thisstep*opt%finc),2*opt%micro_cycle)

   call rmsd(molopt%n,xyz0,molopt%xyz,1,U,x_center,y_center,rmsdval,.false.,grmsd)

   if (.not.converged.and.pr) then
      write(env%unit,'(" * RMSD in coord.:",f14.7,1x,"a0")',advance='no') rmsdval
      write(env%unit,'(5x,"energy gain",e16.7,1x,"Eh")') energy-esave
   endif
! ======================================================================
   enddo Precon_microiter
! ======================================================================

   if (converged) then
      if(pr) then
         call rmsd(mol%n,mol%xyz,molopt%xyz,1,U,x_center,y_center,rmsdval,.false.,grmsd)
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***",/)') &
            "GEOMETRY OPTIMIZATION CONVERGED AFTER",iter,"CYCLES"
         write(env%unit,'(72("-"))')
         write(env%unit,'(1x,"total energy gain   :",F18.7,1x,"Eh",F14.4,1x,"kcal/mol")') &
            energy-estart, (energy-estart)*autokcal
         write(env%unit,'(1x,"total RMSD          :",F18.7,1x,"a0",F14.4,1x,"Å")') &
            rmsdval, rmsdval*autoaa
         if (profile) then
            write(env%unit,'(1x,"total power (kW/mol):",F18.7,1x,"(step)",F10.4,1x,"(real)")') &
               & (energy-estart)*autokJ/iter, (energy-estart)*autokJ/timer%get()
         endif
         write(env%unit,'(72("-"))')
      endif
   else
      ! not converging in the given cycles is a FAILURE, we should make this clearer
      ! This is still no ERROR, since we want the geometry written afterwards
      if(pr) then
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***",/)') &
            "FAILED TO CONVERGE GEOMETRY OPTIMIZATION IN",iter,"CYCLES"
      endif
   endif

   ! save optimized geometry
   mol = molopt

   ! we cannot be sure that the geometry was written in the last optimization
   ! step due to the logstep > 1, so we append the last structure to the optlog
   if (mod(iter-1,opt%logstep).ne.0 .and. opt%ilog.ne.-1) then
      call writeMolecule(mol, opt%ilog, format=opt%ftype, energy=energy, &
         & gnorm=norm2(gradient))
   endif
   !call close_file(opt%ilog)

   ! finally flush the timer to the output unit
   if (minpr.and.profile) call timer%write(env%unit,'FIRE')

end subroutine fire

!> frontend implementation of the low memory/linear scaling (by taste)
!  approximate normal coordinate rational function optimizer (L-ANCopt)
subroutine l_ancopt &
      &   (env,ilog,mol,chk,calc, &
      &    optlevel,maxcycle_in,energy,egap,gradient,sigma,printlevel,fail)

   use xtb_mctc_convert
   use xtb_mctc_lapack, only : lapack_syev

   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_xtb_calculator
   use xtb_gfnff_calculator
   use xtb_extern_turbomole, only : TTMCalculator
   use xtb_type_data
   use xtb_type_timer

   use xtb_setparam
   use xtb_fixparam

   use xtb_optimizer
   use xtb_axis
   use xtb_hessian
   use xtb_lsrmsd
   use xtb_detrotra, only : detrotra4

   use xtb_gfnff_fraghess

   implicit none

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "relaxation_engine_l_ancopt"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   integer, intent(in) :: ilog

   type(TMolecule), intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   !> optimization level
   integer, intent(in) :: optlevel
   !> maximum number of optimization cycles
   integer, intent(in) :: maxcycle_in
   !> energy of the system, contains energy of initial configuration on start
   !  and energy of final configuration at exit
   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: egap
   !> gradient of the system, contains gradient of initial configuration on start
   !  and gradient of final configuration at exit
   real(wp), intent(inout) :: gradient(:,:)
   real(wp), intent(inout) :: sigma(3,3)
   integer, intent(in) :: printlevel
   logical, intent(out) :: fail

   logical :: minpr
   logical :: pr
   logical :: debug
   logical :: converged
   logical :: linear
   integer :: iter
   integer :: nvar
   integer :: maxcycle
   integer :: thiscycle

   type(TMolecule) :: molopt

   real(wp) :: a,b,c
   real(wp) :: U(3,3), x_center(3), y_center(3), rmsdval
   real(wp) :: estart,esave
   real(wp), allocatable :: xyzopt(:,:)
   real(wp), allocatable :: grmsd(:,:)
   !  packed (model) hessian
   real(wp), allocatable :: hessp(:)
   !  dummy for projection
   real(wp), allocatable :: pmode(:,:)

   !  ANC generation
   integer :: i,j,ij,k
   integer :: nat3
   integer :: lwork
   integer :: info
   integer :: itry
   real(wp) :: thr
   real(wp) :: damp
   real(wp) :: edum
   real(sp), allocatable :: hess(:,:)
   real(sp), allocatable :: aux(:)
   real(sp), allocatable :: eig(:)
   real(wp), allocatable :: trafo(:,:)
   real(wp), allocatable :: hdiag(:)
   real(wp), allocatable :: anc(:)
   real(wp), allocatable :: xyz0(:,:)
   type(convergence_log), allocatable :: avconv

   !  settings for the LBFGS optimizer
   type(lbfgs_options) :: opt

   !  determine wheter hessian is fragmented or not
   logical :: fragmented_hessian

   !  timer for profiling (only for printlevel > 1)
   type(tb_timer) :: timer

   ! its an atom, we are done here
   if (mol%n.eq.1) return
   ! setup the timer for a profiling run
   if (profile) call timer%new(8,.false.)
   if (profile) call timer%measure(1,'setup')

   ! settings for optimizer, defaults from opt.f
   opt = lbfgs_options(logstep = 1, &
      &                printlevel = printlevel, &
      &                micro_cycle = set%optset%micro_opt, &
      &                memory = set%optset%micro_opt, &
      &                max_displacement = set%optset%maxdispl_opt, &
      &                hlow = set%optset%hlow_opt )

   ! obtain the thresholds from the optlevel, possible optlevels are currently
   call get_optthr(mol%n,optlevel,opt%e_thr,opt%g_thr,maxcycle,opt%acc)
   ! check for user input regarding the maximum number of cycles
   if (maxcycle_in > 0) maxcycle = maxcycle_in

   ! Activate averaged convergence criterium
   if (set%optset%average_conv) then
      select type(calc)
      class is(TTMCalculator)
         avconv = load_turbomole_log(maxcycle)
         if (avconv%nlog > 0 .and. pr) then
            write(env%unit, '(a, 1x, i0, 1x, a)') &
               "Convergence averaging initialized with", avconv%nlog, "entries"
         end if
      class default
         avconv = convergence_log(maxcycle)
      end select
   end if

   ! open the logfile, the log is bound to unit 942, so we cannot use newunit
   ! and have to hope that nobody else is currently occupying this identifier
   opt%ilog = ilog
   if (mol%npbc > 0) then
      opt%ftype = fileType%vasp
   else
      opt%ftype = fileType%xyz
   endif
   !call open_file(opt%ilog,'xtbopt.log','w')
   if (opt%ilog.ne.-1) then
      call writeMolecule(mol, opt%ilog, format=opt%ftype, energy=energy, &
         & gnorm=norm2(gradient))
   endif

   ! get memory, allocate single and double precision arrays separately
   nat3 = 3*mol%n
   allocate( pmode(nat3,1), hessp(nat3*(nat3+1)/2), trafo(nat3,nat3), &
      &      hdiag(nat3), xyz0(3,mol%n), anc(nat3), xyzopt(3,mol%n), &
      &      source = 0.0_wp )
   allocate( hess(nat3,nat3), eig(nat3), source = 0.0_sp )
   ! set defaults
   iter = 0
   converged = .false.
   minpr = opt%printlevel > 0
   pr    = opt%printlevel > 1
   debug = opt%printlevel > 2
   fragmented_hessian = set%mode_extrun.eq.p_ext_gfnff.and.mol%n.gt.500

   if (set%mode_extrun.eq.p_ext_gfnff) opt%hlow = 0.02
   if (fragmented_hessian) then
      if (mol%n .gt. 2000) opt%hlow = 2.0e-2_wp + (mol%n - 2000.0_wp) * 5.0e-6_wp
      opt%hlow=min(opt%hlow,0.05_wp)
   end if   

   call axis(mol%n,mol%at,mol%xyz,a,b,c)
   linear = c.lt.1.0e-10_wp

   ! different DOF in case of frag hess
   nat3 = 3 * mol%n
   if (fragmented_hessian) then
      nvar = nat3
   else
      nvar = nat3 - 6
      if(linear) nvar = nat3 - 5

      if(fixset%n.gt.0) then ! exact fixing
         nvar=nat3-3*fixset%n-3
         if(nvar.le.0) nvar=1
      endif
   end if

   ! print a nice summary with all settings and thresholds of ANCopt
   if(pr)then
      write(env%unit,'(a)') &
         "      ----------------------------------------------------------- ",&
         "     |                       L-ANC optimizer                     |",&
         "      ----------------------------------------------------------- "
      write(env%unit,'(10x,a)') &
         "low memory version by Sebastian Ehlert"
      write(env%unit,'(/,10x,51("."))')
      write(env%unit,'(10x,":",22x,a,22x,":")') "SETUP"
      write(env%unit,'(10x,":",49("."),":")')
      write(env%unit,scifmt) "energy convergence",opt%e_thr,           "Eh   "
      write(env%unit,scifmt) "grad. convergence ",opt%g_thr,           "Eh/a0"
      write(env%unit,chrfmt) "optimization log  ",bool2string(opt%ilog.ne.-1)
      write(env%unit,intfmt) "writing optlog all",opt%logstep,         "steps"
      write(env%unit,intfmt) "Hessian reset     ",opt%micro_cycle,     "steps"
      write(env%unit,dblfmt) "maximium step len.",opt%max_displacement,"a0   "
      write(env%unit,intfmt) "LBFGS images      ",opt%memory,          "     "
      write(env%unit,'(10x,51("."))')
   endif

   if (profile) call timer%measure(1)

   estart = energy
   thiscycle = opt%micro_cycle
   molopt = mol

   if (.not.pr.and.minpr) write(env%unit,'(a6,a14,a16,a16,a15,a6)') &
      &          "cycle", "energy", "change", "gnorm", "step", "conv?"
! ======================================================================
   ANC_microiter: do while (.not.converged .and. iter.lt.maxcycle)
! ======================================================================
   if (profile) call timer%measure(2,"model hessian")
   if (minpr) write(env%unit,'(" * calculating model hessian...")')
   call modhes(env,calc,set%mhset,molopt%n,molopt%xyz,molopt%at,hessp,pr)

   ! Project translation, rotation and fixed atoms
    if(fixset%n.gt.0)then
        call trproj(molopt%n,nat3,molopt%xyz,hessp,.false., -1  ,pmode,1)     ! exact fixing
    else
        if (.not.linear) &
        call trproj(molopt%n,nat3,molopt%xyz,hessp,.false.,0,pmode,1)     ! normal
    endif


   if (profile) call timer%measure(2)
   if (profile) call timer%measure(3,"ANC generation")
   ! blowup hessian
   do i = 1, 3*molopt%n
      do j = 1, i
         ij = i*(i-1)/2 + j
         hess(i,j) = hessp(ij)
         hess(j,i) = hessp(ij)
      enddo
   enddo
   ! diagonalize the hessian
   select type(calc)
   type is(TGFFCalculator)
   if (fragmented_hessian) then
      if (calc%topo%nsystem.gt.1) then
         write(env%unit,'(" * fragmented diagonalization...",1x,i0,1x,"fragments")') calc%topo%nsystem
         call frag_hess_diag(mol%n,hess,eig,calc%topo%ispinsyst, &
            & calc%topo%nspinsyst,calc%topo%nsystem)
       else if (calc%topo%nsystem.eq.1) then
          lwork  = 1 + 6*nat3 + 2*nat3**2
          allocate(aux(lwork))
          call lapack_syev ('V','U',nat3,hess,nat3,eig,aux,lwork,info)
          deallocate(aux)
       end if
   else
      lwork  = 1 + 6*nat3 + 2*nat3**2
      allocate(aux(lwork))
      call lapack_syev ('V','U',nat3,hess,nat3,eig,aux,lwork,info)
      deallocate(aux)
   end if
   class default
      lwork  = 1 + 6*nat3 + 2*nat3**2
      allocate(aux(lwork))
      call lapack_syev ('V','U',nat3,hess,nat3,eig,aux,lwork,info)
      deallocate(aux)
   end select

   if (.not. fragmented_hessian) then
      call detrotra4(linear,mol,hess,eig)
   end if

   select type(calc)
   class default
      thr = 1.0e-11_wp
      ! shift all non-zero eigenvalues by
      edum = minval(eig)
      damp = max(opt%hlow - edum,0.0_wp)
      where(abs(eig).gt.thr) eig = eig+damp
   type is(TGFFCalculator)
      thr = 1.0e-11_wp
      ! shift all non-zero eigenvalues by
      edum = minval(eig)
      damp = max(opt%hlow - edum,0.0_wp)
   end select

   if(pr)then
      write(env%unit,*) 'Shifting diagonal of input Hessian by ', damp
      write(env%unit,*) 'Lowest  eigenvalues of input Hessian'
      write(env%unit,'(6F12.6)')(eig(i),i=1,min(18,nat3))
      write(env%unit,*) 'Highest eigenvalues'
      write(env%unit,'(6F12.6)')(eig(i),i=nat3-5,nat3)
      write(env%unit,*)
   endif

! initialize hessian for opt.
   do itry = 1, 4
      trafo = 0.0_wp
      j = 0
      k = 0
      hessp = 0.0_wp
! take largest (positive) first
      do i=nat3,1,-1
         if(abs(eig(i)).gt.thr .and. k.lt.nvar)then
            k=k+1
            trafo(1:nat3,k)=hess(1:nat3,i)
            hessp(k+k*(k-1)/2)=min(max(eig(i),opt%hlow),opt%hmax)
         endif
      enddo

      if (k.ne.nvar) thr=thr*0.1_wp
   enddo
   if(k.ne.nvar) then
      write(env%unit,*)'k=',k,'  nvar=',nvar
      write(env%unit,*) 'ANC generation failed'
      fail=.true.
      return
   endif

   ! sort
   call sort(nat3,nvar,hessp,trafo)
   ! and invert diagonal for LBFGS
   do i = 1, nvar
      j = i*(i-1)/2 + i
      hdiag(i) = 1.0_wp / hessp(j)
   enddo

   ! reset approximate normal coordinate system
   anc  = 0.0_wp
   xyz0 = molopt%xyz
   esave = energy
   if (profile) call timer%measure(3)

   call lbfgs_relax &
      &   (env,iter,thiscycle,opt,molopt, &
      &    chk,calc,energy,egap,gradient,sigma,nvar,hdiag,trafo,anc,xyz0, &
      &    converged,fail,timer,avconv)

   thiscycle = min(ceiling(thiscycle*opt%cycle_inc),2*opt%micro_cycle)

   call rmsd(molopt%n,xyz0,molopt%xyz,1,U,x_center,y_center,rmsdval,.false.,grmsd)

   if (.not.converged.and.pr) then
      write(env%unit,'(" * RMSD in coord.:",f14.7,1x,"a0")',advance='no') rmsdval
      write(env%unit,'(5x,"energy gain",e16.7,1x,"Eh")') energy-esave
   endif
! ======================================================================
   enddo ANC_microiter
! ======================================================================

   if (converged) then
      if(minpr) then
         call rmsd(mol%n,mol%xyz,molopt%xyz,1,U,x_center,y_center,rmsdval,.false.,grmsd)
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***",/)') &
            "GEOMETRY OPTIMIZATION CONVERGED AFTER",iter,"CYCLES"
         write(env%unit,'(72("-"))')
         write(env%unit,'(1x,"total energy gain   :",F18.7,1x,"Eh",F14.4,1x,"kcal/mol")') &
            energy-estart, (energy-estart)*autokcal
         write(env%unit,'(1x,"total RMSD          :",F18.7,1x,"a0",F14.4,1x,"Å")') &
            rmsdval, rmsdval*autoaa
         if (profile) then
            write(env%unit,'(1x,"total power (kW/mol):",F18.7,1x,"(step)",F10.4,1x,"(real)")') &
               & (energy-estart)*autokJ/iter, (energy-estart)*autokJ/timer%get()
         endif
         write(env%unit,'(72("-"))')
      endif
   else
      ! not converging in the given cycles is a FAILURE, we should make this clearer
      ! This is still no ERROR, since we want the geometry written afterwards
      if(minpr) then
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***",/)') &
            "FAILED TO CONVERGE GEOMETRY OPTIMIZATION IN",iter,"CYCLES"
      endif
   endif

   ! save optimized geometry
   mol = molopt

   if (profile) call timer%measure(7,"optimization log")
   ! we cannot be sure that the geometry was written in the last optimization
   ! step due to the logstep > 1, so we append the last structure to the optlog
   if (mod(iter,opt%logstep).ne.1.and.opt%ilog.ne.-1) then
      call writeMolecule(mol, opt%ilog, format=opt%ftype, energy=energy, &
         & gnorm=norm2(gradient))
   end if
   !call close_file(opt%ilog)
   if (profile) call timer%measure(7)

   ! finally flush the timer to the output unit
   if (minpr.and.profile) call timer%write(env%unit,'L-ANCopt')

end subroutine l_ancopt

!> updates displacement using the formula given by Nocedal, generally known
!  as limited memory BFGS algorithm
subroutine lbfgs_step(iter,memory,nvar,gradient,glast,displacement, &
      &               hdiag,s,y,rho)
   implicit none
   !> current iteration step
   integer, intent(in) :: iter
   !> memory limit for the LBFGS update
   integer, intent(in) :: memory
   !> 3*natoms
   integer, intent(in) :: nvar
   !> current gradient
   real(wp), intent(in) :: gradient(:)
   !> gradient on the last point
   real(wp), intent(in) :: glast(:)
   !> on input displacement from the last step, on exit new displacement vector
   real(wp), intent(inout) :: displacement(:)
   !> *inverse* Hessian in diagonal form
   real(wp), intent(in) :: hdiag(:)

   !> LBFGS scratch array of former displacements
   real(wp), intent(inout) :: s(:,:)
   !> LBFGS scratch array of former gradient changes
   real(wp), intent(inout) :: y(:,:)
   !> LBFGS scratch array of dot products between s and y
   real(wp), intent(inout) :: rho(:)

   real(wp), allocatable :: d(:)
   real(wp), allocatable :: q(:)
   real(wp), allocatable :: a(:)
   real(wp) :: b

   real(wp), external :: ddot

   integer :: thisiter
   integer :: lastiter
   integer :: mem
   integer :: i

   allocate( q(nvar), d(nvar), a(memory), source = 0.0_wp )

   thisiter = mod(iter-1, memory) + 1
   s(:,thisiter) = displacement
   y(:,thisiter) = gradient - glast

   b = ddot(nvar,s(:,thisiter),1,y(:,thisiter),1)

   rho(thisiter) = 1.0_wp / max(abs(b), epsilon(1.0_wp))

   q = gradient
   !do mem = 1, min(memory-1, iter-1)
      !i = mod(thisiter - mem - 1, memory) + 1
   do mem = iter, max(1,iter-memory), -1
      i = mod(mem-1,memory)+1
      a(i) = rho(i) * ddot(nvar,s(:,i),1,q,1)
      q = q - a(i) * y(:,i)
   enddo

   d = Hdiag * q

   !lastiter = mod(thisiter, memory) + 1
   !do mem = 0, min(memory-1,iter-1)
      !i = mod(lastiter + mem - 1, memory) + 1
   do mem = max(1,iter-memory), iter
      i = mod(mem-1,memory)+1
      b = rho(i) * ddot(nvar,y(:,i),1,d,1)
      d = d + s(:,i) * (a(i) - b)
   enddo

   displacement = -d
end subroutine lbfgs_step

!> backend implementation of the low memory BFGS algorithm, this implementation
!  is augmented with a coordinate transformation in approximate normal coordinates
subroutine lbfgs_relax &
      &   (env,iter,maxcycle,opt,mol, &
      &    chk,calc,energy,egap,g_xyz,sigma,nvar,hdiag,trafo,anc,xyz0, &
      &    converged,fail,timer,avconv)

   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_type_timer

   use xtb_setparam

   use xtb_optimizer

   implicit none

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "relaxation_engine_lbfgs_relax"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(inout) :: mol

   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc

   !> settings for the low memory BFGS
   type(lbfgs_options), intent(in) :: opt
   !> current iteration
   integer, intent(inout) :: iter
   !> maximum number of steps to be performed by this optimizer
   integer, intent(in) :: maxcycle
   !> convergence information
   logical, intent(out) :: converged
   !> internal error
   logical, intent(out) :: fail
   !> energy of the system, contains energy of initial configuration on start
   !  and energy of final configuration at exit
   real(wp), intent(inout) :: energy
   !> HOMO-LUMO gap
   real(wp), intent(inout) :: egap
   !> gradient of the system, contains gradient of initial configuration on start
   !  and gradient of final configuration at exit
   real(wp), intent(inout) :: g_xyz(:,:)
   real(wp), intent(inout) :: sigma(3,3)
   !> dimension of approximate normal coordinate system
   integer, intent(in) :: nvar
   !> diagonal hessian
   real(wp), intent(in) :: hdiag(:)
   !> transformation matrix for cartesian coordinates to ANC's
   real(wp), intent(in) :: trafo(:,:)
   !> approximate normal coordinate system
   real(wp), intent(inout) :: anc(:)
   !> start geometry used to generate ANC's
   real(wp), intent(in) :: xyz0(:,:)
   !> timer for profiling the relaxation procedure
   type(tb_timer), intent(inout) :: timer
   !> Average convergence memory
   type(convergence_log), intent(inout), optional :: avconv

   type(scc_results) :: res

   integer :: icycle
   logical :: minpr
   logical :: pr
   logical :: debug
   integer :: memory
   integer :: i,j,ij

   real(wp) :: alpha
   real(wp) :: gnorm
   real(wp) :: elast
   real(wp) :: ediff
   real(wp) :: depred
   real(wp) :: max_displacement
   real(wp) :: step_length
   real(wp), allocatable :: displacement(:)
   real(wp), allocatable :: g_anc(:)
   real(wp), allocatable :: glast(:)

   !  LBFGS variables
   real(wp), allocatable :: lbfgs_s(:,:)
   real(wp), allocatable :: lbfgs_y(:,:)
   real(wp), allocatable :: lbfgs_rho(:)

   !  RF variables
   integer :: nvar1,npvar,npvar1
   real(sp) :: dsnrm
   real(sp), external :: sdot
   real(sp), allocatable :: eaug(:)
   real(sp), allocatable :: Uaug(:,:)
   real(sp), allocatable :: Aaug(:)

   !  BLAS interface
   real(wp), external :: ddot

   !  displacement in coordinates is lower than given threshold
   logical  :: dconverged
   logical  :: econverged
   logical  :: gconverged

   minpr = opt%printlevel > 0
   pr    = opt%printlevel > 1
   debug = opt%printlevel > 2

   fail = .false.
   converged  = .false.
   dconverged = .false.
   econverged = .false.
   gconverged = .false.

   memory = min(opt%memory,maxcycle)

   allocate( displacement(nvar), g_anc(nvar), glast(nvar), &
      &      source = 0.0_wp )

   if (profile) call timer%measure(4,'coordinate transformation')
   ! transform cartesian gradient in ANC's
   call dgemv('t',3*mol%n,nvar,1.0_wp,trafo,3*mol%n,g_xyz,1,0.0_wp,g_anc,1)
   ! get current gradient norm
   gnorm = sqrt(ddot(nvar,g_anc,1,g_anc,1))
   if (profile) call timer%measure(4)
   if (profile) call timer%measure(5,"Rational function")

   ! we need an initial guess for the displacement, to get one, we solve
   !   ⎛ H  g ⎞ ⎛ dx ⎞     ⎛ dx ⎞
   !   ⎝ g  0 ⎠ ⎝  1 ⎠ = λ ⎝  1 ⎠
   ! 'cause it has to a damn good one!
   nvar1  = nvar+1 ! dimension of RF calculation
   npvar = nvar*nvar1/2
   npvar1 = nvar1*(1+nvar1)/2
   allocate(Uaug(nvar1,1),eaug(nvar1),Aaug(npvar1), source = 0.0_sp)
   ! generate the augmented Hessian first
   Aaug = 0.0_sp
   ! at the very beginning, the Hessian is diagonal in the ANC coordinates
   do i = 1, nvar
      Aaug(i*(1+i)/2) = 1.0_wp / hdiag(i)
   enddo
   Aaug(npvar+1:npvar1-1) = g_anc
   ! do steepest decent guess
   Uaug(:,1)=[-real(g_anc,sp),1.0_sp]
   dsnrm = sqrt(sdot(nvar1,Uaug,1,Uaug,1))
   Uaug  = Uaug/dsnrm
   ! refine guess with davidson
   !call sdavid(debug,.false.,nvar1,1,opt%rfthr,Aaug,Uaug,eaug)
   call solver_sdavidson(nvar1,opt%rfthr,Aaug,Uaug,eaug,fail,debug)
   if (abs(Uaug(nvar1,1)) .lt. 1.0e-10_sp) error stop "Internal RF error"
   displacement = Uaug(:nvar,1) / Uaug(nvar1,1)
   ! discard memory allocation in favor of LBFGS
   deallocate( Aaug, Uaug, eaug )
   if (profile) call timer%measure(5)

   ! now get the memory for the LBFGS
   allocate( lbfgs_s(nvar,memory), lbfgs_y(nvar,memory), lbfgs_rho(memory), &
      &      source = 0.0_wp )

   opt_cycle: do icycle = 1, maxcycle
      iter = iter+1

      if (pr) write(env%unit,cyclefmt) iter

      ! rescale the steplength based on the gradient norm
      if (gnorm.lt.0.002_wp) then
         alpha = 1.5_wp
      elseif (gnorm.lt.0.0006_wp) then
         alpha = 2.0_wp
      elseif (gnorm.lt.0.0003_wp) then
         alpha = 3.0_wp
      else
         alpha = 1.0_wp
      endif

      ! check if step is too large
      step_length = alpha * sqrt(ddot(nvar,displacement,1,displacement,1))
      ! the old ANCopt used to cut of the displacement, which will immediately
      ! destroy the LBFGS procedure, therefore we *have* to rescale
      if (step_length > opt%max_displacement) then
         if (debug) write(env%unit,'(" * rescaling step by",f14.7)') &
            &             opt%max_displacement / step_length
         displacement = opt%max_displacement * displacement / step_length
      endif

      ! check for convergence in step length (only printout)
      dconverged = step_length < opt%d_thr

      ! update ANC's
      anc = anc + displacement * alpha
      ! transform from ANC to cartesian coordinates
      if (profile) call timer%measure(4)
      call trfp2xyz(nvar,3*mol%n,anc,xyz0,trafo,mol%xyz)
      if (profile) call timer%measure(4)

      ! save energy and gradient from previous calculation
      glast = g_anc
      elast = energy

      ! get singlepoint energy
      if (profile) call timer%measure(6,"singlepoint calculation")
      call calc%singlepoint(env,mol,chk,opt%printlevel-1,.true.,energy,g_xyz,sigma,egap,res)
      !call gfnff_eg(.false.,mol%n,charge,attyp,xyz,q,.true.,g_xyz,energy)
      if (profile) call timer%measure(6)
      call env%check(fail)
      if (fail) then
         call env%error('SCF not converged, aborting...', source)
         return
      endif

      ! transform cartesian gradient in ANC coordinate system
      if (profile) call timer%measure(4)
      call dgemv('t',3*mol%n,nvar,1.0_wp,trafo,3*mol%n,g_xyz,1,0.0_wp,g_anc,1)
      if (profile) call timer%measure(4)

      if (profile) call timer%measure(7,"optimization log")
      if (opt%ilog.ne.-1) then
         if (mod(icycle,opt%logstep).eq.1.or.opt%logstep.eq.1) then
            call writeMolecule(mol, opt%ilog,format=opt%ftype,energy=res%e_total, &
               & gnorm=res%gnorm)
         end if
      endif
      !call wrlog(mol%n,xyz,attyp,energy,gnorm,.false.)
      if (profile) call timer%measure(7)

      if (present(avconv)) then
         call avconv%set_eg_log(energy, gnorm)
         energy = avconv%get_averaged_energy()
         gnorm = avconv%get_averaged_gradient()
         if (pr) then
            write(env%unit,'("av. E:",1x,f14.7,1x,"->",1x,f14.7)') &
               avconv%elog(avconv%nlog), energy
            write(env%unit,'("av. G:",1x,f14.7,1x,"->",1x,f14.7)') &
               avconv%glog(avconv%nlog), gnorm
         end if
      end if

      ! check for convergence of the energy change
      ediff = energy - elast
      econverged = ediff < 0.0_wp .and. abs(ediff) < opt%e_thr

      ! check for convergence of the gradient norm
      gnorm = sqrt(ddot(nvar,g_anc,1,g_anc,1))
      gconverged = gnorm < opt%g_thr

      if (pr) then
         write(env%unit,'(" * total energy  :",f14.7,1x,"Eh")',advance='no') energy
         write(env%unit,'(5x,"change   ",e18.7,1x,"Eh")')                    ediff
         write(env%unit,'(3x,"gradient norm :",f14.7,1x,"Eh/a0")',advance='no') gnorm
         write(env%unit,'(2x,"converged?",3x,3(1x,a,"=",l1))') &
            "E",econverged,"G",gconverged,"D",dconverged
         write(env%unit,'(3x,"step length   :",f14.7,1x,"a0")') step_length
      else if (minpr) then
         write(env%unit,'(i6,f14.7,1x,"(",e14.7,")",2(1x,f14.7),1x,"(",3l1,")")') &
            & iter, energy, ediff, gnorm, step_length, &
            & econverged, gconverged, dconverged
      endif

      ! check for convergence of the minimization
      converged = econverged.and.gconverged
      if (converged) then
         exit opt_cycle
      endif

      ! update the inverse Hessian and obtain next step
      if (profile) call timer%measure(8,"hessian update")
      call lbfgs_step(icycle,memory,nvar,g_anc,glast,displacement, &
         &            hdiag,lbfgs_s,lbfgs_y,lbfgs_rho)
      if (profile) call timer%measure(8)

   enddo opt_cycle

end subroutine lbfgs_relax

!> backend implementation of the fast inertial relaxation engine
subroutine inertial_relax &
      &   (env,iter,maxstep,opt,mol, &
      &    chk,calc,energy,egap,gradient,sigma,hessp,velocities, &
      &    lat_velocities,optcell,converged,fail,timer)

   use xtb_mctc_convert

   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_type_timer

   use xtb_setparam

   use xtb_pbc_tools

   implicit none

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "relaxation_engine_inertial_relax"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc

   !> settings for the fast inertial relaxation engine
   type(fire_options), intent(in) :: opt
   !> current iteration
   integer, intent(inout) :: iter
   !> maximum number of steps to be performed by this relaxation engine
   integer, intent(in) :: maxstep
   !> convergence information
   logical, intent(out) :: converged
   !> internal error
   logical, intent(out) :: fail
   !> energy of the system, contains energy of initial configuration on start
   !  and energy of final configuration at exit
   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: egap
   !> gradient of the system, contains gradient of initial configuration on start
   !  and gradient of final configuration at exit
   real(wp), intent(inout) :: gradient(:,:)
   real(wp), intent(inout) :: sigma(3,3)
   !> packed (model) hessian for preconditioner
   real(wp), intent(inout) :: hessp(:)
   !> velocities of the atoms
   real(wp), intent(inout) :: velocities(:,:)
   logical,  intent(in)    :: optcell
   real(wp), intent(inout) :: lat_velocities(3,3)
   !> timer for profiling the relaxation procedure
   type(tb_timer), intent(inout) :: timer

   type(scc_results) :: res

   integer :: istep
   logical :: minpr
   logical :: pr
   logical :: debug
   integer :: jstep

   real(wp) :: power
   real(wp) :: elast
   real(wp) :: ediff
   real(wp) :: gnorm
   real(wp) :: speed
   real(wp) :: step_length
   real(wp) :: time_step
   real(wp) :: max_tstep
   real(wp) :: apar
   real(wp) :: gpinvg
   real(wp), allocatable :: displacement(:,:)
   real(wp), allocatable :: pinvg(:,:)
   real(wp), allocatable :: scratch(:,:)

   !  cell optimization
   integer  :: lstep
   real(wp) :: lat_step_length
   real(wp) :: lat_displacement(3,3)
   real(wp) :: lat_gradient(3,3)
   real(wp) :: inv_lat(3,3)
   real(wp) :: lat_gnorm
   real(wp) :: lat_power
   real(wp) :: lat_speed
   real(wp) :: lat_time_step
   real(wp) :: lat_apar

   !  BLAS interface
   real(wp), external :: ddot

   !  displacement in coordinates is lower than given threshold
   logical  :: dconverged
   logical  :: econverged
   logical  :: gconverged
   logical  :: logthis

   allocate( displacement(3,mol%n), pinvg(3,mol%n), scratch(3,mol%n), &
      &      source = 0.0_wp )

   minpr = opt%printlevel > 0
   pr    = opt%printlevel > 1
   debug = opt%printlevel > 2

   fail = .false.
   converged  = .false.
   dconverged = .false.
   econverged = .false.
   gconverged = .false.

   time_step = opt%time_step
   max_tstep = opt%dtmax
   apar = opt%astart
   if (optcell) then
      lat_apar = opt%astart
      lat_time_step = opt%lat_time_step
   endif

   ! get current gradient norm
   gnorm = sqrt(ddot(3*mol%n,gradient,1,gradient,1))
   ! get current speed
   speed = sqrt(ddot(3*mol%n,velocities,1,velocities,1))
   ! get power based on v·F = -v·g
   power = -ddot(3*mol%n,velocities,1,gradient,1)/opt%mass
   if (optcell) then
      inv_lat = mat_inv_3x3(mol%lattice)
      call sigma_to_latgrad(sigma,inv_lat,lat_gradient)
      lat_gnorm = sqrt(ddot(9,lat_gradient,1,lat_gradient,1))
      lat_speed = sqrt(ddot(9,lat_velocities,1,lat_velocities,1))
      lat_power = -ddot(9,lat_velocities,1,lat_gradient,1)/opt%lat_mass
   endif

   jstep = 0
   lstep = 0
   md_step: do istep = 1, maxstep
      iter = iter+1
      jstep = jstep+1
      lstep = lstep+1

      if (pr) write(env%unit,cyclefmt) iter

      if (profile) call timer%measure(6,"preconditioner")
      if (opt%precon) &
         call get_preconditioner_metric(mol%n*3,hessp,gradient,pinvg,fail)
      if (profile) call timer%measure(6)

      if (profile) call timer%measure(2,"velocities")
      ! update velocities based on current forces
      if (power > opt%pcut) then
         if (.not.fail .and. opt%precon) then
            gpinvg = -ddot(3*mol%n,gradient,1,pinvg,1)
            call dspmv('u',3*mol%n,1.0_wp,hessp,velocities,1,0.0_wp,scratch,1)
            velocities = (1.0_wp - apar) * velocities &
               &       + apar * pinvg/gpinvg * ddot(3*mol%n,scratch,1,velocities,1)
         else
            velocities = (1.0_wp - apar) * velocities &
               &       - apar * gradient/gnorm * speed
         endif
         if (jstep > opt%nmin) then
            time_step = min(time_step * opt%finc, max_tstep)
            apar = apar*opt%fa
         endif
      else
         write(env%unit,'(" * reset velocities")')
         ! internal reset of current velocities (TODO: return to driver?)
         velocities = 0.0_wp
         apar = opt%astart
         time_step = time_step*opt%fdec
         jstep = 0
      endif
      if (opt%precon) then
         velocities = velocities + time_step * pinvg/opt%mass
      else
         velocities = velocities - time_step * gradient/opt%mass
      endif

      if (optcell) then
         if (lat_power > opt%pcut) then
            lat_velocities = (1.0_wp - lat_apar) * lat_velocities &
               &       - lat_apar * lat_gradient/lat_gnorm * lat_speed
            if (lstep > opt%nmin) then
               lat_time_step = min(lat_time_step * opt%finc, max_tstep)
               lat_apar = lat_apar*opt%fa
            endif
         else
            write(env%unit,'(" * reset lattice velocities")')
            ! internal reset of current velocities (TODO: return to driver?)
            lat_velocities = 0.0_wp
            lat_apar = opt%astart
            lat_time_step = lat_time_step*opt%fdec
            lstep = 0
         endif

         lat_velocities = lat_velocities - lat_time_step * lat_gradient/opt%lat_mass
      endif

      ! get new speed
      speed = sqrt(ddot(3*mol%n,velocities,1,velocities,1))
      if (optcell) then
         lat_speed = sqrt(ddot(9,lat_velocities,1,lat_velocities,1))
      endif

      if (profile) call timer%measure(2)
      if (profile) call timer%measure(3,"propagation")

      ! get propagation from velocities
      displacement = time_step * velocities
      if (optcell) then
         lat_displacement = lat_time_step * lat_velocities
      endif

      ! renormalize if step taken is to large
      step_length = sqrt(ddot(3*mol%n,displacement,1,displacement,1))
      if (step_length > opt%max_displacement) then
         write(env%unit,'(" * rescaling displacement step")')
         displacement = opt%max_displacement * displacement / step_length
         !velocities = opt%max_displacement * velocities / step_length
      endif
      !print*,velocities
      !print*,gradient
      !print*,displacement
      if (optcell) then
         lat_step_length = sqrt(ddot(9,lat_displacement,1,lat_displacement,1))
         if (lat_step_length > opt%max_displacement) then
            write(env%unit,'(" * rescaling lattice displacement")')
            lat_displacement = opt%max_displacement*lat_displacement/lat_step_length
         endif
      endif

      dconverged = step_length < opt%d_thr .and. &
         & (.not.optcell .or. lat_step_length < opt%d_thr)

      ! update positions
      if (optcell) then
         mol%lattice = mol%lattice + lat_displacement
         call mol%wrap_back
      endif
      mol%xyz = mol%xyz + displacement
      ! save last energy
      elast = energy
      ! save last gradient
      scratch = gradient

      if (profile) call timer%measure(3)
      if (profile) call timer%measure(4,"singlepoint calculation")
      ! get singlepoint energy
      call calc%singlepoint(env,mol,chk,opt%printlevel-1,.true.,energy,gradient,sigma,egap,res)
      if (profile) call timer%measure(4)
      call env%check(fail)
      if (fail) then
         call env%error('SCF not converged, aborting...', source)
         return
      endif
      if (profile) call timer%measure(5,"log and printout")

      ! check if we write to the optimization log this step
      logthis = opt%ilog.ne.-1 .and. mod(istep-1,opt%logstep).eq.0
      if (logthis) then
         call writeMolecule(mol, opt%ilog,format=opt%ftype,energy=res%e_total, &
            & gnorm=res%gnorm)
      endif

      ! check for convergence of the energy change
      ediff = energy - elast
      econverged = ediff < 0.0_wp .and. abs(ediff) < opt%e_thr

      ! get new power
      power = -ddot(3*mol%n,velocities,1,gradient,1)/opt%mass
      ! check for convergence of the gradient norm
      gnorm = sqrt(ddot(3*mol%n,gradient,1,gradient,1))
      if (optcell) then
         inv_lat = mat_inv_3x3(mol%lattice)
         call sigma_to_latgrad(sigma,inv_lat,lat_gradient)
         lat_power = -ddot(9,lat_velocities,1,lat_gradient,1)/opt%lat_mass
         lat_gnorm = sqrt(ddot(9,lat_gradient,1,lat_gradient,1))
      endif

      gconverged = gnorm < opt%g_thr .and. &
         & (.not.optcell .or. lat_gnorm < opt%g_thr)

      if (pr) then
         write(env%unit,'(" * total energy  :",f14.7,1x,"Eh")',advance='no')   energy
         write(env%unit,'(5x,"change    :",e16.7,1x,"Eh")')                    ediff
         write(env%unit,'(3x,"gradient norm :",f14.7,1x,"Eh/a0")',advance='no')gnorm
         write(env%unit,'(2x,"converged?",3x,3(1x,a,"=",l1))') &
            "E",econverged,"G",gconverged,"D",dconverged
         write(env%unit,'(3x,"time step     :",f14.7,1x,"fs")',advance='no') &
            time_step * autofs
         write(env%unit,'(5x,"power     :",e16.7)') power
         write(env%unit,'(3x,"step length   :",f14.7,1x,"a0")',advance='no') &
            step_length
         write(env%unit,'(5x,"speed     :",e16.7)') speed
         if (optcell) then
            write(env%unit,'(3x,"time step     :",f14.7,1x,"fs")',advance='no') &
               lat_time_step * autofs
            write(env%unit,'(5x,"cell power:",e16.7)') lat_power
            write(env%unit,'(3x,"step length   :",f14.7,1x,"a0")',advance='no') &
               lat_step_length
            write(env%unit,'(5x,"cell speed:",e16.7)') lat_speed
         endif
      else if (minpr) then
         write(env%unit,'(i6,f14.7,1x,"(",e14.7,")",2(1x,f14.7),1x,"(",3l1,")")') &
            & iter, energy, ediff, gnorm, step_length, &
            & econverged, gconverged, dconverged
      endif
      if (profile) call timer%measure(5)

      ! check for convergence of the minimization
      converged = econverged.and.gconverged
      if (converged) then
         exit md_step
      endif

      ! update the Hessian
      ! we perform the Hessian update after the convergence check, this avoids
      ! doing an update on a converged geometry, but still updates at the end
      ! of the microcycle (if you drop the Hessian afterwards, this is wasted)
      if (profile) call timer%measure(8,"hessian update")
      if (opt%update) &
         call bfgs(3*mol%n,gnorm,gradient,scratch,displacement,hessp)
      if (profile) call timer%measure(8)

   enddo md_step

end subroutine inertial_relax

!> Calculates predicted energy change according to the second order model.
function predict_energy_change(nat3,grad,displ,hess) result(depred)

   implicit none

   !> 3*natoms
   integer, intent(in) :: nat3
   !> Gradient vector
   real(wp), dimension(nat3), intent(in) :: grad
   !> Displacement vector
   real(wp), dimension(nat3), intent(in) :: displ
   !> Hessian matrix stored as lower triangle
   real(wp), dimension(nat3*(nat3+1)/2), intent(in) :: hess

   !> Predicted energy change
   real(wp) :: depred

   real(wp), dimension(nat3) :: hdx
   real(wp), external :: ddot
   real(wp) :: gtmp, htmp

   call dspmv('u',nat3,0.5_wp,hess,displ,1,0.0_wp,hdx,1)

   gtmp   = ddot(nat3,displ,1,grad,1)

   htmp   = ddot(nat3,displ,1,hdx,1)

   depred = htmp + gtmp

end function predict_energy_change

!> obtain preconditioner by solving P·x = y.
!  P·g⁻¹ is saved in pinvg on exit
subroutine get_preconditioner_metric(nvar,hess,grad,pinvg,fail)
   implicit none
   !> calculation dimension (usually 3*natoms)
   integer, intent(in) :: nvar
   real(wp), intent(in) :: hess(:)
   real(wp), intent(in) :: grad(:,:)
   real(wp), intent(out) :: pinvg(:,:)
   logical, intent(out) :: fail

   integer :: i,ii,j,ij
   integer :: info
   integer :: lwork
   integer, allocatable :: ipiv(:)
   real(wp) :: test(1)
   real(wp), allocatable :: work(:)
   real(wp), allocatable :: htmp(:,:)

   real(wp), parameter :: c_stab = 0.1_wp

   allocate( ipiv(nvar), source = 0 )
   allocate( htmp(nvar,nvar), source = 0.0_wp )

   ! blowup packed hessian (avoids destroying Hessian in the following step)
   do i = 1, nvar
      ii = i*(i-1)/2
      do j = 1, i-1
         ij = ii + j
         htmp(i,j) = hess(ij)
         htmp(j,i) = hess(ij)
      enddo
      ! add stabilization term to diagonal (not tracked by BFGS!)
      htmp(i,i) = hess(ii+i) + c_stab
   enddo

   ! initialize right hand side
   pinvg = -grad

   call dsysv('u',nvar,1,htmp,nvar,ipiv,pinvg,nvar,test,-1,info)
   if (info.eq.0) then
      lwork = int(test(1))
      allocate( work(lwork), source = 0.0_wp )

      call dsysv('u',nvar,1,htmp,nvar,ipiv,pinvg,nvar,work,lwork,info)

      deallocate(work,ipiv)
   endif

   fail = info.ne.0
end subroutine get_preconditioner_metric

pure function bool2string(bool) result(string)
   logical,intent(in) :: bool
   character(len=:),allocatable :: string
   if (bool) then
      string = 'true'
   else
      string = 'false'
   endif
end function bool2string

end module xtb_relaxation_engine

! This file is part of dipro.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Calculation of Wiberg/Mayer type bond orders
module xtb_dipro_bondorder
   use mctc_env, only : wp
#if WITH_TBLITE
   use tblite_basis_type, only : basis_type
   use tblite_blas, only : gemm
   implicit none

   public :: get_wiberg_bondorder

contains

!> Calculate Wiberg/Mayer type bond orders from density and overlap matrices
subroutine get_wiberg_bondorder(bas, smat, pmat, wbo)
   !> Basis set information
   type(basis_type), intent(in) :: bas
   !> Overlap matrix
   real(wp), intent(in) :: smat(:, :)
   !> Density matrix
   real(wp), intent(in) :: pmat(:, :)
   !> Wiberg/Mayer type bond orders
   real(wp), intent(out) :: wbo(:, :)

   real(wp), allocatable :: spmat(:, :)
   integer :: iao, jao, iat, jat

   allocate(spmat(bas%nao,bas%nao)) !XXXX  (mold=pmat)
   call gemm(pmat, smat, spmat)

   wbo(:, :) = 0.0_wp
   do iao = 1, bas%nao
      iat = bas%ao2at(iao)
      do jao = 1, bas%nao
         jat = bas%ao2at(jao)
         wbo(jat, iat) = wbo(jat, iat) + spmat(iao, jao) * spmat(jao, iao)
      end do
   end do

   do iat = 1, size(wbo, 2)
      wbo(iat, iat) = 0.0_wp
   end do

end subroutine get_wiberg_bondorder
#endif

end module xtb_dipro_bondorder

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> DFT+U approximation within PTB
!> Consumes parameters, the density matrix and the coordination numbers;
!> returns the DFT+U potential

module xtb_ptb_plusu
#if WITH_TBLITE
   !> mctc-lib
   use mctc_env, only: error_type, wp
   use mctc_io, only: structure_type
   !> tblite-lib
   use tblite_basis_type, only: basis_type
   use tblite_integral_multipole, only: msao
   !> xtb_ptb-lib
   use xtb_ptb_data, only: TPlusU

   implicit none
   private

   public :: plusu_potential_type

   type :: plusu_potential_type
      !> DFT+U self energies for each shell
      real(wp), allocatable :: selfenergies(:, :)
      !> DFT+U interatomic damping matrix
      real(wp), allocatable :: damping(:, :)
      !##### Parameters #####
      !> Scaling of the diagonal elements of the +U nao x nao matrix
      real(wp), allocatable :: diag_scaling(:)
   contains
      procedure :: get_potential => calc_V_plusU
      procedure :: init
   end type plusu_potential_type

contains

   subroutine init(self, plusudata, mol, bas, q, cn, selfenergy_scal)
      !> Initialize the data for the DFT+U potential
      !> Self class
      class(plusu_potential_type), intent(inout) :: self
      !> DFT+U parameterization data
      type(TPlusU), intent(in) :: plusudata
      !> Structure type
      type(structure_type), intent(in) :: mol
      !> Basis set type
      type(basis_type), intent(in) :: bas
      !> Atomic charges
      real(wp), intent(in) :: q(:)
      !> Coordination numbers
      real(wp), intent(in) :: cn(:)
      !> Add. scaling factor for the self-energies for the +U matrix [mol%nid]
      real(wp), intent(in), optional :: selfenergy_scal(:)
      integer :: iat, iid

      !> Allocate the self energies and damping matrix
      allocate (self%selfenergies(maxval(bas%nsh_id), mol%nat))
      allocate (self%damping(mol%nat, mol%nat))
      allocate (self%diag_scaling(mol%nat))

      !> Initialize the parameters with the data from the parameterization
      do iat = 1, mol%nat
         iid = mol%id(iat)
         self%diag_scaling(iat) = plusudata%cud(iid)
      end do

      call init_damping_matrix(self, mol, cn, plusudata%avcn, plusudata%ar, plusudata%arcn)
      if (present(selfenergy_scal)) then
         call init_selfenergies(self, mol, bas, q, &
            & plusudata%cu1, plusudata%cu2, plusudata%cueffl, selfenergy_scal)
      else
         call init_selfenergies(self, mol, bas, q, &
            & plusudata%cu1, plusudata%cu2, plusudata%cueffl)
      end if

   end subroutine init

   subroutine init_damping_matrix(self, mol, cn, average_cn, atomic_radii, atomic_radii_cn)
      !> Self type
      class(plusu_potential_type), intent(inout) :: self
      !> Structure type
      type(structure_type), intent(in) :: mol
      !> Coordination numbers
      real(wp), intent(in) :: cn(:)
      !> Average coordination numbers
      real(wp), intent(in) :: average_cn(:)
      !> Atomic radii
      real(wp), intent(in) :: atomic_radii(:)
      !> Atomic radii for coordination numbers
      real(wp), intent(in) :: atomic_radii_cn(:)
      !> Loop variables
      integer :: iat, jat, izp, jzp
      real(wp) :: ra, rb, rij

      !> debug mode
      logical, parameter :: debug = .false.

      do iat = 1, mol%nat
         izp = mol%id(iat)
         ra = atomic_radii(izp) + (cn(iat) - average_cn(izp)) * atomic_radii_cn(izp)
         do jat = 1, iat
            jzp = mol%id(jat)
            rb = atomic_radii(jzp) + (cn(jat) - average_cn(jzp)) * atomic_radii_cn(jzp)
            rij = norm2(mol%xyz(:, iat) - (mol%xyz(:, jat)))
            self%damping(jat, iat) = 0.5_wp * (1.0_wp + erf(-1.8_wp * (rij - (ra + rb)) / (ra + rb)))
            self%damping(iat, jat) = self%damping(jat, iat)
            
            if (debug) & !##### DEV WRITE #####
               write (*, *) 'damping', iat, jat, self%damping(iat, jat)
            
         end do
      end do

   end subroutine init_damping_matrix

   subroutine init_selfenergies(self, mol, bas, q, q_scal, q2_scal, shell_level, &
      & selfenergy_scal)
      !> Self type
      class(plusu_potential_type), intent(inout) :: self
      !> Structure type
      type(structure_type), intent(in) :: mol
      !> Basis set type
      type(basis_type), intent(in) :: bas
      !> Atomic charges
      real(wp), intent(in) :: q(:)
      !> Scaling of the first order charge
      real(wp), intent(in) :: q_scal(:)
      !> Scaling of the second order charge
      real(wp), intent(in) :: q2_scal(:)
      !> Shell level
      real(wp), intent(in) :: shell_level(:, :)
      !> Add. scaling factor for the self-energies for the +U matrix [mol%nid]
      real(wp), intent(in), optional :: selfenergy_scal(:)
      !> Loop variables
      integer :: iat, iid, ish
      
      !> debug mode
      logical, parameter :: debug = .false.

      do iat = 1, mol%nat
         iid = mol%id(iat)
         do ish = 1, bas%nsh_at(iat)
            self%selfenergies(ish, iat) = shell_level(ish, iid) * &
               & (1.0_wp - (q_scal(iid) * q(iat) + q2_scal(iid) * q(iat)**2))
            if (present(selfenergy_scal)) then
               self%selfenergies(ish, iat) = self%selfenergies(ish, iat) * selfenergy_scal(iid)
            end if
            if (debug) & !##### DEV WRITE #####
               write (*, *) 'selfenergies', ish, iat, self%selfenergies(ish, iat)
            
         end do
      end do
   end subroutine init_selfenergies

   subroutine calc_V_plusU(self, mol, bas, density, potential)
      !> DFT+U approximation within PTB
      !> Self class
      class(plusu_potential_type), intent(inout) :: self
      !> Structure type
      type(structure_type), intent(in) :: mol
      !> Basis set type
      type(basis_type), intent(in) :: bas
      !> Density matrix
      real(wp), intent(in) :: density(:, :)
      !> Potential matrix (nao x nao)
      real(wp), intent(inout) :: potential(:, :)
      !> Loop variables
      integer :: iat, jat, izp, jzp, ii, ish, jsh, jj
      integer :: is, js, iao, jao
      real(wp) :: sum_levels, tmp

      !> Different atom
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         do jat = 1, iat - 1
            jzp = mol%id(jat)
            js = bas%ish_at(jat)
            do ish = 1, bas%nsh_at(iat)
               ii = bas%iao_sh(is + ish)
               do jsh = 1, bas%nsh_at(jat)
                  jj = bas%iao_sh(js + jsh)
                  sum_levels = self%selfenergies(ish, iat) + self%selfenergies(jsh, jat)
                  do iao = 1, msao(bas%cgto(ish, iat)%ang)
                     do jao = 1, msao(bas%cgto(jsh, jat)%ang)
                        tmp = density(jj + jao, ii + iao) * sum_levels * self%damping(jat, iat)
                        potential(jj + jao, ii + iao) = potential(jj + jao, ii + iao) + tmp
                        potential(ii + iao, jj + jao) = potential(ii + iao, jj + jao) + tmp
                     end do
                  end do
               end do
            end do
         end do
         !> Same atom, different shell
         do ish = 1, bas%nsh_at(iat)
            ii = bas%iao_sh(is + ish)
            do jsh = 1, ish - 1
               jj = bas%iao_sh(is + jsh)
               sum_levels = self%selfenergies(ish, iat) + self%selfenergies(jsh, iat)
               do iao = 1, msao(bas%cgto(ish, iat)%ang)
                  do jao = 1, msao(bas%cgto(jsh, iat)%ang)
                     tmp = density(jj + jao, ii + iao) * sum_levels * self%damping(iat, iat)
                     potential(jj + jao, ii + iao) = potential(jj + jao, ii + iao) + tmp
                     potential(ii + iao, jj + jao) = potential(ii + iao, jj + jao) + tmp
                  end do
               end do
            end do
            !> Same atom, same shell, different AO
            sum_levels = 2.0_wp * self%selfenergies(ish, iat)
            do iao = 1, msao(bas%cgto(ish, iat)%ang)
               do jao = 1, iao - 1
                  tmp = density(ii + jao, ii + iao) * sum_levels * self%damping(iat, iat)
                  potential(ii + jao, ii + iao) = potential(ii + jao, ii + iao) + tmp
                  potential(ii + iao, ii + jao) = potential(ii + iao, ii + jao) + tmp
               end do
               !> Same atom, same shell, same AO
               potential(ii + iao, ii + iao) = potential(ii + iao, ii + iao) + &
                  & density(ii + iao, ii + iao) * sum_levels * self%damping(iat, iat) &
                  & * self%diag_scaling(iat)
            end do
         end do
      end do

   end subroutine calc_V_plusU

#endif
end module xtb_ptb_plusu

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Helper routines to transform generalized eigenvalue problems in standard form.
module xtb_mctc_lapack_gst
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: mctc_sygst, mctc_spgst

   public :: lapack_sygst, lapack_spgst, lapack_hegst, lapack_hpgst


   !> Reduces a real symmetric-definite generalized eigenproblem
   !  to standard form.
   !
   !  If ITYPE = 1, the problem is A*x = lambda*B*x,
   !  and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
   !
   !  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !  B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
   !
   !  B must have been previously factorized as U**T*U or L*L**T by DPOTRF.
   interface mctc_sygst
      module procedure :: mctc_ssygst
      module procedure :: mctc_dsygst
   end interface mctc_sygst

   !> reduces a real symmetric-definite generalized eigenproblem
   !  to standard form, using packed storage.
   !
   !  If ITYPE = 1, the problem is A*x = lambda*B*x,
   !  and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
   !
   !  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !  B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
   !
   !  B must have been previously factorized as U**T*U or L*L**T by DPPTRF.
   interface mctc_spgst
      module procedure :: mctc_sspgst
      module procedure :: mctc_dspgst
   end interface mctc_spgst


   !> DSYGST reduces a real symmetric-definite generalized eigenproblem
   !  to standard form.
   !
   !  If ITYPE = 1, the problem is A*x = lambda*B*x,
   !  and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
   !
   !  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !  B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
   !
   !  B must have been previously factorized as U**T*U or L*L**T by DPOTRF.
   interface lapack_sygst
      pure subroutine ssygst(itype, uplo, n, a, lda, b, ldb, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ssygst
      pure subroutine dsygst(itype, uplo, n, a, lda, b, ldb, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dsygst
   end interface lapack_sygst

   !> reduces a complex Hermitian-definite generalized
   !  eigenproblem to standard form.
   !
   !  If ITYPE = 1, the problem is A*x = lambda*B*x,
   !  and A is overwritten by inv(U**H)*A*inv(U) or inv(L)*A*inv(L**H)
   !
   !  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !  B*A*x = lambda*x, and A is overwritten by U*A*U**H or L**H*A*L.
   !
   !  B must have been previously factorized as U**H*U or L*L**H by CPOTRF.
   interface lapack_hegst
      pure subroutine chegst(itype, uplo, n, a, lda, b, ldb, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine chegst
      pure subroutine zhegst(itype, uplo, n, a, lda, b, ldb, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine zhegst
   end interface lapack_hegst

   !> reduces a real symmetric-definite generalized eigenproblem
   !  to standard form, using packed storage.
   !
   !  If ITYPE = 1, the problem is A*x = lambda*B*x,
   !  and A is overwritten by inv(U**T)*A*inv(U) or inv(L)*A*inv(L**T)
   !
   !  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !  B*A*x = lambda*x, and A is overwritten by U*A*U**T or L**T*A*L.
   !
   !  B must have been previously factorized as U**T*U or L*L**T by DPPTRF.
   interface lapack_spgst
      pure subroutine sspgst(itype, uplo, n, ap, bp, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(in) :: bp(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine sspgst
      pure subroutine dspgst(itype, uplo, n, ap, bp, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(in) :: bp(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine dspgst
   end interface lapack_spgst

   !> reduces a complex Hermitian-definite generalized
   !  eigenproblem to standard form, using packed storage.
   !
   !  If ITYPE = 1, the problem is A*x = lambda*B*x,
   !  and A is overwritten by inv(U**H)*A*inv(U) or inv(L)*A*inv(L**H)
   !
   !  If ITYPE = 2 or 3, the problem is A*B*x = lambda*x or
   !  B*A*x = lambda*x, and A is overwritten by U*A*U**H or L**H*A*L.
   !
   !  B must have been previously factorized as U**H*U or L*L**H by CPPTRF.
   interface lapack_hpgst
      pure subroutine chpgst(itype, uplo, n, ap, bp, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         complex(sp), intent(in) :: bp(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine chpgst
      pure subroutine zhpgst(itype, uplo, n, ap, bp, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         complex(dp), intent(in) :: bp(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine zhpgst
   end interface lapack_hpgst


contains


subroutine mctc_ssygst(env, amat, bmat, itype, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sygst'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   integer, intent(in), optional :: itype
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: ity, info, n, lda, ldb
   if(present(itype)) then
      ity = itype
   else
      ity = 1
   endif
   if(present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   endif
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   call lapack_sygst(ity, ula, n, amat, lda, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Transformation of the eigenvalue problem failed", source)
   end if
end subroutine mctc_ssygst


subroutine mctc_dsygst(env, amat, bmat, itype, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sygst'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   integer, intent(in), optional :: itype
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: ity, info, n, lda, ldb
   if(present(itype)) then
      ity = itype
   else
      ity = 1
   endif
   if(present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   endif
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   call lapack_sygst(ity, ula, n, amat, lda, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Transformation of the eigenvalue problem failed", source)
   end if
end subroutine mctc_dsygst


subroutine mctc_sspgst(env, amat, bmat, itype, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_spgst'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:)
   real(sp), intent(in) :: bmat(:)
   integer, intent(in), optional :: itype
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: ity, info, n, nn
   if(present(itype)) then
      ity = itype
   else
      ity = 1
   endif
   if(present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   endif
   nn = size(amat)
   if(nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   endif
   call lapack_spgst(ity, ula, n, amat, bmat, info)
   if (info /= 0) then
      call env%error("Transformation of the eigenvalue problem failed", source)
   end if
end subroutine mctc_sspgst


subroutine mctc_dspgst(env, amat, bmat, itype, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_spgst'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:)
   real(dp), intent(in) :: bmat(:)
   integer, intent(in), optional :: itype
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: ity, info, n, nn
   if(present(itype)) then
      ity = itype
   else
      ity = 1
   endif
   if(present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   endif
   nn = size(amat)
   if(nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   endif
   call lapack_spgst(ity, ula, n, amat, bmat, info)
   if (info /= 0) then
      call env%error("Transformation of the eigenvalue problem failed", source)
   end if
end subroutine mctc_dspgst


end module xtb_mctc_lapack_gst

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ------------------------------------------------------------------------
!  The set documentation has been moved to set_module.f90
!  here you can define all global variables but no more I/O-stuff
!! ------------------------------------------------------------------------
module xtb_setparam
   use xtb_mctc_accuracy, only : wp
   use xtb_solv_kernel, only : gbKernel
   use xtb_solv_input, only : TSolvInput
   use xtb_type_setvar

   implicit none

   private :: wp

   character,private,parameter :: flag = '$'
   character,private,parameter :: colon = ':'
   character,private,parameter :: space = ' '
   character,private,parameter :: equal = '='
   character,private,parameter :: hash = '#'
   character,private,parameter :: dot = '.'
   character,private,parameter :: comma = ','
   character(len=*),private,parameter :: flag_end = flag//'end'

!  Using allocatable arrays of dynamic length strings is only possible
!  with a lot of hacks, so we use good'ol fixed size stack arrays.
!  Let's choose something different from 42 that is not dividable by 10... ;)
!  Happy debugging!
   integer,private,parameter :: p_str_length = 48
   integer,private,parameter :: p_arg_length = 24

   public

!! ------------------------------------------------------------------------
!  GFN Hamiltonian: 1=JCTC 2017 version, monopole ES, 2=multipole ES/D4(atm),
   integer,parameter :: p_method_gfn0xtb = 0
   integer,parameter :: p_method_gfn1xtb = 1
   integer,parameter :: p_method_gfn2xtb = 2

!  Geometry input type
   integer,parameter :: p_geo_coord  = 1
   integer,parameter :: p_geo_xmol   = 2
   integer,parameter :: p_geo_sdf    = 3
   integer,parameter :: p_geo_poscar = 4

   ! Initial guess charges
   integer, parameter :: p_guess_sad = 0
   integer, parameter :: p_guess_gasteiger = 1
   integer, parameter :: p_guess_goedecker = 2
   integer, parameter :: p_guess_multieq = 3

   integer, parameter :: p_olev_crude   = -3
   integer, parameter :: p_olev_sloppy  = -2
   integer, parameter :: p_olev_loose   = -1
   integer, parameter :: p_olev_lax     = -4
   integer, parameter :: p_olev_normal  =  0
   integer, parameter :: p_olev_tight   =  1
   integer, parameter :: p_olev_vtight  =  2
   integer, parameter :: p_olev_extreme =  3
   ! geometry optimization backend
   integer, parameter :: p_engine_rf       = 1
   integer, parameter :: p_engine_lbfgs    = 2
   integer, parameter :: p_engine_inertial = 3

   integer, parameter :: p_modh_read     = -2
   integer, parameter :: p_modh_unit     = -1
   integer, parameter :: p_modh_lindh    =  1
   integer, parameter :: p_modh_lindh_d2 =  2
   integer, parameter :: p_modh_swart    =  3
   integer, parameter :: p_modh_old      =  4
   integer, parameter :: p_modh_gff      =  5

!  Choose the grid for the GBSA
   integer, parameter :: ldgrids(32) = &
      &[  6,  14,  26,  38,  50,  74,  86, 110, 146, 170, &
      & 194, 230, 266, 302, 350, 434, 590, 770, 974,1202, &
      &1454,1730,2030,2354,2702,3074,3470,3890,4334,4802, &
      &5294,5810]
   integer, parameter :: p_angsa_normal    = ldgrids(12)
   integer, parameter :: p_angsa_tight     = ldgrids(19)
   integer, parameter :: p_angsa_verytight = ldgrids(23)
   integer, parameter :: p_angsa_extreme   = ldgrids(32)

   ! interface mode
   integer,parameter :: p_pcem_legacy = 1
   integer,parameter :: p_pcem_orca = 2
   
   type oniom_settings
      !> inner region charge
      integer  :: innerchrg
      
      !> cut high order(>1) covalent bonds
      logical :: ignore_topo = .false.
      
      !> derived mode
      logical :: derived = .false.
      
      !> dummy execution to check inner region geo and chrg
      logical :: cut_inner = .false.

      !> explicite charges (inner:outer)
      logical :: fixed_chrgs= .false.
      
      !> mute external output (ORCA,TURBOMOLE)
      logical :: silent = .false.
      
      !> print optimization logs for inner region calculations
      logical :: logs = .false.
      
      !> log units
      integer:: ilog1, ilog2
  end type oniom_settings

   type qm_external
      character(len=:),allocatable :: path
      character(len=:),allocatable :: executable
      character(len=:),allocatable :: input_file
      character(len=:),allocatable :: input_string
      logical :: exist
         !! if input_file exist
      logical :: oniom=.false.
         !! special case of the oniom embedding 
   end type qm_external

   integer, parameter :: p_ext_vtb       = -1
   integer, parameter :: p_ext_eht       =  0
   integer, parameter :: p_ext_xtb       =  1
   integer, parameter :: p_ext_driver    =  3
   integer, parameter :: p_ext_turbomole =  4
   integer, parameter :: p_ext_orca      =  5
   integer, parameter :: p_ext_mopac     = 12
   integer, parameter :: p_ext_gfnff     = 13
   integer, parameter :: p_ext_oniom     = 14
   integer, parameter :: p_ext_iff       = 15
   integer, parameter :: p_ext_tblite    = 16

   integer, parameter :: p_run_scc    =   2
   integer, parameter :: p_run_grad   =   3
   integer, parameter :: p_run_opt    =   4
   integer, parameter :: p_run_hess   =   5
   integer, parameter :: p_run_ohess  =   7
   integer, parameter :: p_run_bhess  =  71
   integer, parameter :: p_run_md     =   6
   integer, parameter :: p_run_omd    =   8
   integer, parameter :: p_run_path   =  10
   integer, parameter :: p_run_screen =  11
   integer, parameter :: p_run_modef  =  13
   integer, parameter :: p_run_mdopt  =  14
   integer, parameter :: p_run_metaopt=  15
   integer, parameter :: p_run_vip    = 100
   integer, parameter :: p_run_vea    = 101
   integer, parameter :: p_run_vipea  = 102
   integer, parameter :: p_run_vfukui = 103
   integer, parameter :: p_run_vomega = 104

   integer,private :: idum

   type :: TSet
   integer  :: gfn_method = -1
   integer  :: maxscciter = 250
   logical  :: newdisp = .true.
   logical  :: solve_scc = .true.
   logical  :: periodic = .false.

!  Geometry input type
   integer  :: geometry_inputfile = p_geo_coord

!! ------------------------------------------------------------------------
!  electronic SCC temperature
   real(wp) :: etemp = 300.0_wp
!  damping in Broyden SCC procedure (0.05 for critical cases, autoadjusted)
   real(wp) :: broydamp = 0.40_wp
   real(wp) :: dispscale = 1.0_wp

   integer  :: guess_charges = p_guess_goedecker

!  shift molecule to center of mass
   logical  :: do_cma_trafo = .false.

! linear dependencies overlap cut-off stuff
   real(wp) :: lidethr = 0.00001_wp   ! cut-off threshold for small overlap eigenvalues

!! ------------------------------------------------------------------------
!  default optimization level
!  crude = -3,     sloppy = -2,      loose = -1,      normal = 0,
!  tight = 1,      verytight = 2,    extreme = 3
   character(len=:), allocatable :: opt_outfile
   character(len=:), allocatable :: opt_logfile
   integer, allocatable :: opt_engine
   type(ancopt_setvar) :: optset = ancopt_setvar (&
      optlev = p_olev_normal, &
!  number of opt. cycles before new ANC are made
      micro_opt = 20, &
!  total number of opt. cycles, 0 means automatically determined
      maxoptcycle = 0, & ! det. in ancopt routine if not read in
!  maximum coordinate displacement in ancopt
      maxdispl_opt = 1.000_wp, &
!  lowest force constant in ANC generation (should be > 0.005)
      hlow_opt = 0.010_wp, &
      average_conv = .false.)
   type(modhess_setvar) :: mhset = modhess_setvar (&
      model = p_modh_old, &
!  force constants for stretch, bend and torsion
      kr = 0.4000_wp, &
      kf = 0.1300_wp, &
      kt = 0.0075_wp, &
      ko = 0.0000_wp, &
      kd = 0.0000_wp, &
      kq = 0.0000_wp, &
!  cutoff for constructing Hessian
      rcut = 70.0_wp, &
!  dispersion scaling in ANC generation
      s6 = 20.0_wp)

!! ------------------------------------------------------------------------
!  temp. for thermostatistical calc. (could be more than just one T)
   integer  :: nthermo = 1
   real(wp) :: thermotemp(50) = [298.15_wp, spread(0.0_wp, 1, 49)]
!  rotor cut-off (cm-1) in thermo  (was 100 cm-1 previously)
   real(wp) :: thermo_sthr = 50.0_wp
!  threshold (cm-1) for inverting imaginary modes
   real(wp) :: thermo_ithr = -20.0_wp
   ! frequency scaling for therostatistical calculation
   real(wp) :: thermo_fscal = 1.0_wp

!! ------------------------------------------------------------------------
!  MD thermostat/initial siman/GBSA temperature
   real(wp) :: temp_md = 298.15_wp
!  MD run time in ps
   real(wp) :: time_md = 50.0_wp
!  dump (=optimize) structure in siman every mddump fs
   real(wp) :: dump_md = 1000.0_wp ! scoord
!  MD dump step in fs for xyz output file, MUST BE .eq. mdstep for power
!  IR spectra
   real(wp) :: dump_md2 = 50.0_wp ! molden,xyzfile
!  set to 1 if dumps (trj file) should contain velocities
   logical  :: velodump = .false.
!  use thermostat (=1, =0 for NVE)
   logical  :: nvt_md = .true.
!  skip interval in -mdav, -mdopt
   integer  :: skip_md = 500 ! mdopt, mdav
!  MD time step in fs (automatically determined if < 0),
!  could be 4-5 fs with shake =2, md_hmass=4
   real(wp) :: tstep_md = 4.0_wp
!  increase hydrogen mass to this value in amu (at const. tot. mass)
!  allowing large time steps (=0 off)
   integer  :: md_hmass = 4
!  shake on (=0: off which is default) for X-H bonds only (=1),
!  or all bonds (=2) or user defined bonds (=3)
   integer  :: shake_mode = 2
   logical  :: shake_md = .true.
   logical  :: xhonly = .true.
   logical  :: honly = .false.
   logical :: forcewrrestart = .false.

!! ------------------------------------------------------------------------
!  target rmsd value for bhess run in Ångström
   real(wp) :: target_rmsd = 0.1_wp

!! ------------------------------------------------------------------------
!  number of siman annealing blocks
   integer  :: ntemp_siman = 3
!  energy window (kcal) for considering conformers
   real(wp) :: ewin_conf = 20.0_wp
!  highest siman annealing temperature (very system specific)
   real(wp) :: Tend_siman = 1000.0_wp
!  include enantiomers in siman (=1)
   logical  :: enan_siman = .false.
!  SCC accuracy level in MD. Every 10th step the SCC is properly converged
!  at sccconv=1.0. sccmd should be < 5 in critical cases, effects may show
!  up as bad thermostating
   real(wp) :: accu_md = 2.0_wp

!! ------------------------------------------------------------------------
!  SCC accuracy level in Hessian runs
   real(wp) :: accu_hess = 0.3_wp
!  Cartesian displacement increment for numerical Hessian
   real(wp) :: step_hess = 0.005_wp
   ! Scaling factor for the hessian elements
   real(wp) :: scale_hess = 1.0_wp

!  switch on gbsa for solvent if second argument is a valid solvent name
   type(TSolvInput) :: solvInput

!! ------------------------------------------------------------------------
!  of points along normal mode path scan
   integer  :: mode_nscan = 31
!  step lengths for scan (should be around 1 because its adjusted
!  internally to mode mass and FC)
   real(wp) :: mode_step = 1.0_wp
!  update search mode with a fraction of the displacement at every step
!  (0.0 means no update, 0.1-0.2 is a good choice)
   real(wp) :: mode_updat = 0.2_wp
!  use canonical normal modes (=0) or Pipek-Mezey localized ones (=1)
   integer  :: mode_local = 0
!  threshold up to which frequency modes are used for mode based conformer
!  search (def. is 300)
   real(wp) :: mode_vthr = 0.0_wp
!  number of second mode which should be projected out in mode following
!  (normally = 7 ie the TS mode which is fixed then)
   integer  :: mode_prj = 0
!  set by -modef via cmdline
   integer  :: mode_follow = 7

!! ------------------------------------------------------------------------
!  biased path finder based on RMSD criteria
!! ------------------------------------------------------------------------
   type(path_setvar) :: pathset

!! ------------------------------------------------------------------------
!  nano reactor based on RMSD biasing potential
!! ------------------------------------------------------------------------
   type(reactor_setvar) :: reactset

!! ------------------------------------------------------------------------
!  grid spacing for cube file
   real(wp) :: cube_step = 0.4_wp
!  density matrix neglect threshold
   real(wp) :: cube_pthr = 0.05_wp
!  cube boundary offset
   real(wp) :: cube_boff = 3.0_wp
!! ------------------------------------------------------------------------
!  PRINTOUT
!! ------------------------------------------------------------------------
   character(len=:),allocatable  :: property_file
   logical  :: pr_esp = .false.
   character(len=:),allocatable  :: esp_gridfile
   character(len=10) :: lmoinfo_fname='xtblmoinfo'
   logical  :: pr_molden_input = .false.
   logical  :: pr_lmo = .false.
   logical  :: pr_local = .true.
   logical  :: pr_density = .false.
   logical  :: pr_spin_population = .false.
   logical  :: pr_spin_density = .false.
   logical  :: pr_fod = .false.
   logical  :: pr_fod_pop = .false.
   logical  :: pr_wiberg = .true.
   logical  :: pr_wbofrag = .false.
   logical  :: pr_charges = .true.
   logical  :: pr_dipole = .true.
   logical  :: pr_mulliken = .true.
   logical  :: pr_eig = .true.
   logical  :: pr_gbw = .false.
   logical  :: pr_tmmos = .false.
   logical  :: pr_tmbas = .false.
   logical  :: pr_json = .false.
   logical  :: pr_distances = .true.
   logical  :: pr_angles = .false.
   logical  :: pr_torsions = .false.
   logical  :: pr_geosum = .true.
   logical  :: pr_finalstruct = .true.
   logical  :: pr_moments = .true.
   logical  :: pr_modef = .false.
   logical  :: pr_gbsa = .false.
   logical  :: pr_nmtm = .false.
   logical  :: pr_dftbp_hessian_out = .false.

!! ------------------------------------------------------------------------
!  point group symmetrization threshold
   real(wp) :: desy = 0.1_wp
!  point group determination skipped if # atoms > this value
!  (i.e. desymaxat 0 switches it off)
   integer  :: maxatdesy = 200

!  compare molecules in ensemble for removing doubles by RMSD (=0)
!  or rot.const.(=1)
   logical  :: check_rmsd = .true.

!! ------------------------------------------------------------------------
!  (point) charge embedding stuff
!! ------------------------------------------------------------------------
   integer  :: pcem_dummyatom = 7 ! nitrogen
   integer  :: pcem_interface = p_pcem_legacy
   ! pcharge input file
   character(len=:),allocatable :: pcem_file
   character(len=:),allocatable :: pcem_grad
   logical  :: pcem_orca   = .false.
!  controls which interactions included in the Fockian depend on the
!  external point charges
   logical  :: pcem_l_es   = .true.
!  external point charges are included in the anisotropic electrostatics
   logical  :: pcem_l_aes  = .false.
!  external point charges are included as type A non-additive dispersion
   logical  :: pcem_l_disp = .false.
!  external point charges can be anisotropic and will be included
!  in the AES (GFN2 only, works only with pcem_l_aes = .true.)
   logical  :: pcem_l_dipm = .false.
   logical  :: pcem_l_qp   = .false.
!  external point charges can have a coordination number
   logical  :: pcem_l_cn   = .false.
!  external point charges are included in the ATM calculation for
!  type B non-additive dispersion
   logical  :: pcem_l_atm  = .false.

!! ------------------------------------------------------------------------
!  STM images
!! ------------------------------------------------------------------------
   logical  :: pr_stm     = .false.
   real(wp) :: stm_alp    =1.5_wp
   real(wp) :: stm_targ   =1.e-4_wp
   real(wp) :: stm_grid   =0.5_wp
   real(wp) :: stm_pot    =0.0_wp
   real(wp) :: stm_thr    =1.0_wp

!  exchange correction scaling factor for HS case 0.3, for LS case -1.4
   real(wp) :: ex_open ! set to 0.5/-0.5 in .xtbrc, respectively

!! ------------------------------------------------------------------------
!  ONIOM
!! ------------------------------------------------------------------------
   type(oniom_settings) :: oniom_settings

!! ------------------------------------------------------------------------
!  External settings
!! ------------------------------------------------------------------------
   type(qm_external) :: ext_driver
   type(qm_external) :: ext_orca
   type(qm_external) :: ext_turbo
   type(qm_external) :: ext_mopac

!! ------------------------------------------------------------------------
!  information about molecule
!! ------------------------------------------------------------------------
   integer  :: ichrg = 0
   logical  :: clichrg = .false.
   integer  :: nalphabeta = 0

!  cannot be set by .xtbrc/setblock
   integer  :: modflag(50) = 0
   integer  :: tsroot = 0
   integer  :: extcode = 0
   integer  :: extmode = 0
   integer  :: mode_extrun = 1 ! xtb is default
!  integer  :: dummyint ! not used
   integer  :: runtyp = 2 ! SCC by default
   logical  :: rdset = .false.

   ! ENSO (ENergic SOrting something algorithm) compatibility mode
   logical  :: enso_mode = .false.

   logical  :: restart_md = .false.
   logical  :: fit = .false. ! write fit data in scf.f
   logical  :: tsopt = .false.
   logical  :: mdrtrconstr = .false. ! not used
!  initialize at each start the RNG if .false.
   logical  :: samerand = .false.
!  just check the input, don't do calculations
   logical  :: define = .false.
!  printlevel for the main program
   logical  :: silent = .false.
   logical  :: verbose = .false.
   logical  :: veryverbose = .false.
   logical  :: ceasefiles  = .false.

!  character(len=80) :: inputname = ''
   character(len= 4) :: pgroup = 'C1  '
!! ------------------------------------------------------------------------
    
   end type
   

   type(TSet) :: set

   type(env_setvar) :: xenv

   character(len=:),allocatable :: molnameline
   character(len=:),allocatable :: commentline

contains


subroutine initrand
   implicit none
   integer :: i,j
   integer,allocatable :: iseed(:)
   integer :: imagic = 41
   if (set%samerand) then
      call random_seed(size=j)
      allocate(iseed(j), source = imagic)
      do i = 1, j
         iseed(i) = iseed(i)+j
      enddo
      call random_seed(put=iseed)
      deallocate(iseed)
   else
      call random_seed()
   endif
end subroutine initrand

function get_namespace(string) result(name)
   use xtb_mctc_global, only : persistentEnv
   implicit none
   character(len=*),intent(in)  :: string
   character(len=:),allocatable :: name
   if (string(1:1).eq.'/') then
      name = string
      return
   endif
   if (allocated(persistentEnv%io%namespace)) then
      if (string(1:1).eq.dot) then
         name = dot//persistentEnv%io%namespace//string
      else
         name = persistentEnv%io%namespace//dot//string
      endif
   else
      name = string
   endif
end function get_namespace

end module xtb_setparam

module test_cpx
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed, skip_test
   use xtb_features, only : get_xtb_feature
   implicit none
   private

   public :: collect_cpx

contains

!> Collect all exported unit tests
subroutine collect_cpx(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("solvation", test_cpx_solv) &
      ]

end subroutine collect_cpx

subroutine test_cpx_solv(error)
   use xtb_solv_cpx, only : TCpcmx
   use mctc_env, only: err_type => error_type, wp

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment
   use xtb_solv_input
   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_kernel

   type(error_type), allocatable, intent(out) :: error
   type(err_type), allocatable :: err
   type(Tcpcmx) :: cpcmx
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp) :: energy_gas, total_energy
   real(wp),allocatable :: gradient(:,:)
   real(wp),parameter :: thr = 5.0e-5_wp
   integer, parameter :: nat = 11
   integer, parameter :: at(nat) = [7,1,1,1,15,6,6,6,7,7,7]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.84112686339230_wp,-1.15671648374837_wp, 0.00000000000000_wp, &
      & 5.87217277985151_wp,-0.70323701391366_wp, 1.54511189584035_wp, &
      & 5.87217277985151_wp,-0.70323701391366_wp,-1.54511189584035_wp, &
      & 4.61871932563459_wp,-3.05696083228965_wp, 0.00000000000000_wp, &
      & 0.23751589819013_wp, 1.28722286021158_wp, 0.00000000000000_wp, &
      & 0.00161949529588_wp,-0.89075264835377_wp, 2.57562301980395_wp, &
      &-3.06580664031769_wp, 2.16487781673832_wp, 0.00000000000000_wp, &
      & 0.00161949529588_wp,-0.89075264835377_wp,-2.57562301980395_wp, &
      &-5.06585309511506_wp, 3.00827014874972_wp, 0.00000000000000_wp, &
      & 0.00161949529588_wp,-2.15043086045241_wp, 4.34183098346579_wp, &
      & 0.00161949529588_wp,-2.15043086045241_wp,-4.34183098346579_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = "h2o")
   integer :: ich

   character(len=*), parameter :: cpxsolvent="water"

   if (.not.get_xtb_feature('cpcmx')) then
      call skip_test(error, 'CPCM-X libary not available.')
      return
   end if
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)
   call addSolvationModel(env, calc, TSolvInput(solvent='infinity', alpb=.false., cosmo=.true.))

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)
   call cpcmx%setup(env,cpxsolvent)
   deallocate(calc%solvation)
   call calc%singlepoint(env, mol, chk, 0, .false., energy_gas, gradient, sigma, &
      & hl_gap, res)
   call cpcmx%calc_solv(env,cpxsolvent,energy_gas,0.4_wp,298.15_wp,500,0.0001_wp,total_energy)
   call cpcmx%print(.true.)
   call check_(error, total_energy-energy_gas, -0.1555665E-01_wp, thr=thr)
   call check_(error, total_energy, -22.00017093824971_wp, thr=thr)

end subroutine test_cpx_solv
end module test_cpx

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Atomic Radii of the Elements
!>
!> M. Mantina, R. Valero, C. J. Cramer, and D. G. Truhlar,
!> in CRC Handbook of Chemistry and Physics, 91st Edition (2010-2011),
!> edited by W. M. Haynes (CRC Press, Boca Raton, FL, 2010), pages 9-49-9-50;
!> corrected Nov. 17, 2010 for the 92nd edition.
module xtb_param_atomicrad
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   use xtb_mctc_symbols, only : toNumber
   implicit none
   private

   public :: getAtomicRad, atomicRad


   !> Get atomic radius for a species
   interface getAtomicRad
      module procedure :: getAtomicRadSymbol
      module procedure :: getAtomicRadNumber
   end interface getAtomicRad


   !> Atomic radii
   real(wp), parameter :: atomicRad(1:118) = aatoau * [ &
      & 0.32_wp, 0.37_wp, 1.30_wp, 0.99_wp, 0.84_wp, 0.75_wp, 0.71_wp, 0.64_wp, &
      & 0.60_wp, 0.62_wp, 1.60_wp, 1.40_wp, 1.24_wp, 1.14_wp, 1.09_wp, 1.04_wp, &
      & 1.00_wp, 1.01_wp, 2.00_wp, 1.74_wp, 1.59_wp, 1.48_wp, 1.44_wp, 1.30_wp, &
      & 1.29_wp, 1.24_wp, 1.18_wp, 1.17_wp, 1.22_wp, 1.20_wp, 1.23_wp, 1.20_wp, &
      & 1.20_wp, 1.18_wp, 1.17_wp, 1.16_wp, 2.15_wp, 1.90_wp, 1.76_wp, 1.64_wp, &
      & 1.56_wp, 1.46_wp, 1.38_wp, 1.36_wp, 1.34_wp, 1.30_wp, 1.36_wp, 1.40_wp, &
      & 1.42_wp, 1.40_wp, 1.40_wp, 1.37_wp, 1.36_wp, 1.36_wp, 2.38_wp, 2.06_wp, &
      & 1.94_wp, 1.84_wp, 1.90_wp, 1.88_wp, 1.86_wp, 1.85_wp, 1.83_wp, 1.82_wp, &
      & 1.81_wp, 1.80_wp, 1.79_wp, 1.77_wp, 1.77_wp, 1.78_wp, 1.74_wp, 1.64_wp, &
      & 1.58_wp, 1.50_wp, 1.41_wp, 1.36_wp, 1.32_wp, 1.30_wp, 1.30_wp, 1.32_wp, &
      & 1.44_wp, 1.45_wp, 1.50_wp, 1.42_wp, 1.48_wp, 1.46_wp, 2.42_wp, 2.11_wp, &
      & 2.01_wp, 1.90_wp, 1.84_wp, 1.83_wp, 1.80_wp, 1.80_wp, 1.73_wp, 1.68_wp, &
      & 1.68_wp, 1.68_wp, 1.65_wp, 1.67_wp, 1.73_wp, 1.76_wp, 1.61_wp, 1.57_wp, &
      & 1.49_wp, 1.43_wp, 1.41_wp, 1.34_wp, 1.29_wp, 1.28_wp, 1.21_wp, 1.22_wp, &
      & 1.36_wp, 1.43_wp, 1.62_wp, 1.75_wp, 1.65_wp, 1.57_wp]


contains


!> Get atomic radius for species with a given symbol
elemental function getAtomicRadSymbol(symbol) result(radius)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> atomic radius
   real(wp) :: radius

   radius = getAtomicRad(toNumber(symbol))

end function getAtomicRadSymbol


!> Get atomic radius for species with a given atomic number
elemental function getAtomicRadNumber(number) result(radius)

   !> Atomic number
   integer, intent(in) :: number

   !> atomic radius
   real(wp) :: radius

   if (number > 0 .and. number <= size(atomicRad, dim=1)) then
      radius = atomicRad(number)
   else
      radius = -1.0_wp
   end if

end function getAtomicRadNumber


end module xtb_param_atomicrad

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_fixparam
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   private :: wp
   public

!! ------------------------------------------------------------------------
!  exact fixing and freezing for Hessian
!! ------------------------------------------------------------------------
   type(fix_setvar) :: fixset
   type(fix_setvar) :: shakeset
   type(fix_setvar) :: freezeset

!! ------------------------------------------------------------------------
!  RMSD based meta dynamic feature
!! ------------------------------------------------------------------------
   type(metadyn_setvar) :: metaset
   type(metadyn_setvar) :: rmsdset

contains

subroutine init_fix(nfix)
   implicit none
   integer, intent(in) :: nfix
   call clear_fix
   call fixset%allocate(nfix)
   call shakeset%allocate(nfix*(nfix+1)/2)
   call freezeset%allocate(nfix)
end subroutine init_fix

subroutine clear_fix
   call fixset%deallocate
   call shakeset%deallocate
   call freezeset%deallocate
end subroutine clear_fix

subroutine init_metadyn(nat,nstruc)
   implicit none
   integer, intent(in) :: nat
   integer, intent(in) :: nstruc
   call metaset%allocate(nat,nstruc)
   metaset%factor = metaset%global_factor
   metaset%width = metaset%global_width
end subroutine init_metadyn

subroutine init_bhess(nat)
   implicit none
   integer, intent(in) :: nat
   call metaset%allocate(nat,1)
   metaset%maxsave= 1
   metaset%factor = metaset%global_factor
end subroutine init_bhess

subroutine clear_metadyn
   call metaset%deallocate
end subroutine clear_metadyn

subroutine fix_info(iunit,n,at,xyz)
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,ii,j,k,l,m,mm
   real(wp) :: val

   if (fixset%n.gt.0 .or. freezeset%n.gt.0 .or. shakeset%n.gt.0) then
      call generic_header(iunit,"Fixed Atoms",49,10)
      write(iunit,'(a)')
   endif
   if (fixset%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') fixset%n, &
         "fixed atom positions, i.e. in gradient"
      write(iunit,'(a)')
      write(iunit,'(5x,"#",3x,"Z",3x,32x,"position/Å")')
      do i = 1, fixset%n
         ii = fixset%atoms(i)
         write(iunit,'(i6,1x,i3,1x,a2,3f14.7)') &
            ii,at(ii),toSymbol(at(ii)),xyz(:,ii)*autoaa
      enddo
      write(iunit,'(a)')
   endif
   if (freezeset%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') freezeset%n, &
         "frozen atom positions, i.e. in hessian"
      write(iunit,'(a)')
      write(iunit,'(5x,"#",3x,"Z",3x,32x,"position/Å")')
      do i = 1, freezeset%n
         ii = freezeset%atoms(i)
         write(iunit,'(i6,1x,i3,1x,a2,3f14.7)') &
            ii,at(ii),toSymbol(at(ii)),xyz(:,ii)*autoaa
      enddo
      write(iunit,'(a)')
   endif
   if (shakeset%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') shakeset%n/2, &
         "constrained distances for dynamics (SHAKE)"
      write(iunit,'(a)')
      write(iunit,'(2(5x,"#",3x,"Z",3x),8x,"value/Å")')
      do m = 1, shakeset%n, 2
         i = shakeset%atoms(m)
         j = shakeset%atoms(m+1)
         val = sqrt(sum((xyz(:,i)-xyz(:,j))**2))
         write(iunit,'(2(i6,1x,i3,1x,a2),1x,f14.7)') &
            i,at(i),toSymbol(at(i)), &
            j,at(j),toSymbol(at(j)), &
            val*autoaa
      enddo
      write(iunit,'(a)')

   endif

end subroutine fix_info

end module xtb_fixparam

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

      subroutine preig(io,occ,f,e,istart,norbs)
      use xtb_mctc_accuracy, only : wp
      implicit none
      integer, intent(in) :: io
      integer, intent(in) :: istart
      real(wp),intent(in) :: f
      integer, intent(in) :: norbs
      real(wp),intent(in) :: occ(norbs)
      real(wp),intent(in) :: e(norbs)
      integer :: n,ntimes,nrest,j,n2,k,i

      write(io,'(/,10x,''eigenvalues'')')
      n=8
      ntimes=(norbs-istart+1)/n
      nrest=mod(norbs-istart+1,n)
      if(ntimes.eq.0) nrest=norbs-istart+1

      j=istart
      n2=n+istart-1

      do k=1,ntimes
      write(io,100)(i,i=j,n2)
      write(io,200)(occ(i),i=j,n2)
      write(io,300)(f*e(i),i=j,n2)
      j =j +n
      n2=n2+n
      enddo

      if(nrest.gt.0.or.ntimes.eq.0) then
      write(io,100)(i,i=j,j+nrest-1)
      write(io,200)(occ(i),i=j,j+nrest-1)
      write(io,300)(f*e(i),i=j,j+nrest-1)
      endif

      return

 100  format(' #    : ',2x,8(3x,i6,2x))
 200  format(' occ. : ',2x,8(4x,f6.3,1x))
 300  format(' eps  : ',2x,8f11.3)
      end subroutine preig

      SUBROUTINE PREIG2(IO,OCC,E,NORBS)
      use xtb_mctc_accuracy, only : wp
      implicit none
      integer, intent(in) :: io
      integer, intent(in) :: norbs
      real(wp),intent(in) :: occ(norbs)
      real(wp),intent(in) :: e(norbs)
      integer :: n,ntimes,nrest,j,n2,k,i

      n=6
      ntimes=norbs/n
      nrest=mod(norbs,n)
      if(ntimes.eq.0) nrest=norbs

      j=1
      n2=n

      do k=1,ntimes
      write(io,100)(i,i=j,n2)
      write(io,200)(occ(i),i=j,n2)
      write(io,300)(e(i),i=j,n2)
      j =j +n
      n2=n2+n
      enddo

      if(nrest.gt.0.or.ntimes.eq.0) then
      write(io,100)(i,i=j,j+nrest-1)
      write(io,200)(occ(i),i=j,j+nrest-1)
      write(io,300)(e(i),i=j,j+nrest-1)
      endif

      return

 100  format('#       :',2x,6(4x,i4,2x))
 200  format('# atoms :',2x,6(4x,f5.3,1x))
 300  format('shift ev:',2x,6f10.5)
      end subroutine preig2

      SUBROUTINE PREIG3(IO,E,NORBS)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION E(*)
      N=10
      NTIMES=NORBS/N
      NREST=MOD(NORBS,N)
      IF(NTIMES.EQ.0) NREST=NORBS
      J=1
      N2=N
      DO K=1,NTIMES
!     WRITE(IO,100)(I,I=J,N2)
      WRITE(IO,300)J,N2,(E(i),I=J,N2)
      J =J +N
      N2=N2+N
      ENDDO
      IF(NREST.GT.0.OR.NTIMES.EQ.0) THEN
      WRITE(IO,300)J,J+NREST-1,(E(i),I=J,J+NREST-1)
      ENDIF

 100  FORMAT('atoms : ',2X,6(4X,I4,2X))
 300  FORMAT(' value',i5,'-',i5,':',2X,12F6.2)
      END SUBROUTINE PREIG3

      SUBROUTINE PRMAT(IUOUT,R,N,M,HEAD)
      REAL*8 R
      CHARACTER*(*) HEAD
      DIMENSION R(*)
!     SUBROUTINE PRINTS MATRIX R,WHICH IS SUPPOSED
!     TO HAVE DIMENSION N,M  WHEN M IS NONZERO AND
!     ((N+1)*N)/2 WHEN M IS ZERO

      WRITE(IUOUT,1001) HEAD
      NKPB=6
      IF(M)10,10,80
!
   10 CONTINUE
      IBL=N/NKPB
      IR=N-IBL*NKPB
      J1=1
      K1S=1
      KD=0
      IF(IBL.EQ.0) GO TO 50
      J2=NKPB
      DO 40 I=1,IBL
      WRITE(IUOUT,1002)(J,J=J1,J2)
      K1=K1S
      K2=K1
      KK=0
      DO 20 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   20 K2=K1+KK
      J1=J1+NKPB
      IF(J1.GT.N) RETURN
      J2=J2+NKPB
      K2=K1-1
      K1=K2+1
      K2=K1+(NKPB-1)
      K1S=K2+1
      KK=KD+NKPB
      DO 30 J=J1,N
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KK
   30 K2=K2+KK
   40 KD=KD+NKPB
   50 IF(IR.EQ.0) GO TO 70
      K1=K1S
      J2=J1+IR-1
      KK=0
      K2=K1
      WRITE(IUOUT,1002)(J,J=J1,J2)
      WRITE(IUOUT,1003)
      DO 60 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   60 K2=K1+KK
   70 RETURN
   80 IBL=M/NKPB
      IR=M-IBL*NKPB
      I2=0
      K2=0
      IF(IBL.EQ.0) GO TO 100
      DO 90 I=1,IBL
      I1=(I-1)*N*NKPB+1
      I2=I1+(NKPB-1)*N
      K1=K2+1
      K2=K1+(NKPB-1)
      WRITE(IUOUT,1002)(K,K=K1,K2)
      DO 90 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
   90 I2=I1+(NKPB-1)*N
  100 IF(IR.EQ.0) GO TO 120
      I1=IBL*N*NKPB+1
      I2=I1+(IR-1)*N
      K1=K2+1
      K2=M
      WRITE(IUOUT,1002)(K,K=K1,K2)
      WRITE(IUOUT,1003)
      DO 110 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
      I2=I1+(IR-1)*N
  110 CONTINUE
  120 WRITE(IUOUT,1003)
      RETURN
 1001 FORMAT(/' MATRIX PRINTED:',2X,A)
 1002 FORMAT(/,' ',4X,6(3X,I4,3X),/)
 1003 FORMAT(' ',I4,6F10.5)
      END

      SUBROUTINE PRMAT4(IUOUT,R,N,M,HEAD)
      REAL*4 R
      CHARACTER*(*) HEAD
      DIMENSION R(*)
!     SUBROUTINE PRINTS MATRIX R,WHICH IS SUPPOSED
!     TO HAVE DIMENSION N,M  WHEN M IS NONZERO AND
!     ((N+1)*N)/2 WHEN M IS ZERO

      WRITE(IUOUT,1001) HEAD
      NKPB=6
      IF(M)10,10,80
!
   10 CONTINUE
      IBL=N/NKPB
      IR=N-IBL*NKPB
      J1=1
      K1S=1
      KD=0
      IF(IBL.EQ.0) GO TO 50
      J2=NKPB
      DO 40 I=1,IBL
      WRITE(IUOUT,1002)(J,J=J1,J2)
      K1=K1S
      K2=K1
      KK=0
      DO 20 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   20 K2=K1+KK
      J1=J1+NKPB
      IF(J1.GT.N) RETURN
      J2=J2+NKPB
      K2=K1-1
      K1=K2+1
      K2=K1+(NKPB-1)
      K1S=K2+1
      KK=KD+NKPB
      DO 30 J=J1,N
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KK
   30 K2=K2+KK
   40 KD=KD+NKPB
   50 IF(IR.EQ.0) GO TO 70
      K1=K1S
      J2=J1+IR-1
      KK=0
      K2=K1
      WRITE(IUOUT,1002)(J,J=J1,J2)
      WRITE(IUOUT,1003)
      DO 60 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   60 K2=K1+KK
   70 RETURN
   80 IBL=M/NKPB
      IR=M-IBL*NKPB
      I2=0
      K2=0
      IF(IBL.EQ.0) GO TO 100
      DO 90 I=1,IBL
      I1=(I-1)*N*NKPB+1
      I2=I1+(NKPB-1)*N
      K1=K2+1
      K2=K1+(NKPB-1)
      WRITE(IUOUT,1002)(K,K=K1,K2)
      DO 90 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
   90 I2=I1+(NKPB-1)*N
  100 IF(IR.EQ.0) GO TO 120
      I1=IBL*N*NKPB+1
      I2=I1+(IR-1)*N
      K1=K2+1
      K2=M
      WRITE(IUOUT,1002)(K,K=K1,K2)
      WRITE(IUOUT,1003)
      DO 110 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
      I2=I1+(IR-1)*N
  110 CONTINUE
  120 WRITE(IUOUT,1003)
      RETURN
 1001 FORMAT(/' MATRIX PRINTED:',2X,A)
 1002 FORMAT(/,' ',4X,6(3X,I4,3X),/)
 1003 FORMAT(' ',I4,6F10.5)
      END

      SUBROUTINE PRMATI(IUOUT,RR,N,M,HEAD)
      CHARACTER*(*) HEAD
      integer RR(*)
      DIMENSION R(n*n)
!     SUBROUTINE PRINTS MATRIX R,WHICH IS SUPPOSED
!     TO HAVE DIMENSION N,M  WHEN M IS NONZERO AND
!     ((N+1)*N)/2 WHEN M IS ZERO

      R(1:n*n)=float(RR(1:n*n))
      WRITE(IUOUT,1001) HEAD
      NKPB=6
      IF(M)10,10,80
!
   10 CONTINUE
      IBL=N/NKPB
      IR=N-IBL*NKPB
      J1=1
      K1S=1
      KD=0
      IF(IBL.EQ.0) GO TO 50
      J2=NKPB
      DO 40 I=1,IBL
      WRITE(IUOUT,1002)(J,J=J1,J2)
      K1=K1S
      K2=K1
      KK=0
      DO 20 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   20 K2=K1+KK
      J1=J1+NKPB
      IF(J1.GT.N) RETURN
      J2=J2+NKPB
      K2=K1-1
      K1=K2+1
      K2=K1+(NKPB-1)
      K1S=K2+1
      KK=KD+NKPB
      DO 30 J=J1,N
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KK
   30 K2=K2+KK
   40 KD=KD+NKPB
   50 IF(IR.EQ.0) GO TO 70
      K1=K1S
      J2=J1+IR-1
      KK=0
      K2=K1
      WRITE(IUOUT,1002)(J,J=J1,J2)
      WRITE(IUOUT,1003)
      DO 60 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   60 K2=K1+KK
   70 RETURN
   80 IBL=M/NKPB
      IR=M-IBL*NKPB
      I2=0
      K2=0
      IF(IBL.EQ.0) GO TO 100
      DO 90 I=1,IBL
      I1=(I-1)*N*NKPB+1
      I2=I1+(NKPB-1)*N
      K1=K2+1
      K2=K1+(NKPB-1)
      WRITE(IUOUT,1002)(K,K=K1,K2)
      DO 90 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
   90 I2=I1+(NKPB-1)*N
  100 IF(IR.EQ.0) GO TO 120
      I1=IBL*N*NKPB+1
      I2=I1+(IR-1)*N
      K1=K2+1
      K2=M
      WRITE(IUOUT,1002)(K,K=K1,K2)
      WRITE(IUOUT,1003)
      DO 110 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
      I2=I1+(IR-1)*N
  110 CONTINUE
  120 WRITE(IUOUT,1003)
      RETURN
 1001 FORMAT(/' MATRIX PRINTED:',2X,A)
 1002 FORMAT(/,' ',4X,6(3X,I4,3X),/)
 1003 FORMAT(' ',I4,6F10.5)
      END

      SUBROUTINE PRMATS(IUOUT,R,N,M,HEAD)
      REAL*8 R
      CHARACTER*(*) HEAD
      DIMENSION R(*)
!     SUBROUTINE PRINTS MATRIX R,WHICH IS SUPPOSED
!     TO HAVE DIMENSION N,M  WHEN M IS NONZERO AND
!     ((N+1)*N)/2 WHEN M IS ZERO

      WRITE(IUOUT,1001) HEAD
      NKPB=12
      IF(M)10,10,80
!
   10 CONTINUE
      IBL=N/NKPB
      IR=N-IBL*NKPB
      J1=1
      K1S=1
      KD=0
      IF(IBL.EQ.0) GO TO 50
      J2=NKPB
      DO 40 I=1,IBL
      WRITE(IUOUT,1002)(J,J=J1,J2)
      K1=K1S
      K2=K1
      KK=0
      DO 20 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   20 K2=K1+KK
      J1=J1+NKPB
      IF(J1.GT.N) RETURN
      J2=J2+NKPB
      K2=K1-1
      K1=K2+1
      K2=K1+(NKPB-1)
      K1S=K2+1
      KK=KD+NKPB
      DO 30 J=J1,N
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KK
   30 K2=K2+KK
   40 KD=KD+NKPB
   50 IF(IR.EQ.0) GO TO 70
      K1=K1S
      J2=J1+IR-1
      KK=0
      K2=K1
      WRITE(IUOUT,1002)(J,J=J1,J2)
      WRITE(IUOUT,1003)
      DO 60 J=J1,J2
      WRITE(IUOUT,1003)J,(R(K),K=K1,K2)
      KK=KK+1
      K1=K1+KD+KK
   60 K2=K1+KK
   70 RETURN
   80 IBL=M/NKPB
      IR=M-IBL*NKPB
      I2=0
      K2=0
      IF(IBL.EQ.0) GO TO 100
      DO 90 I=1,IBL
      I1=(I-1)*N*NKPB+1
      I2=I1+(NKPB-1)*N
      K1=K2+1
      K2=K1+(NKPB-1)
      WRITE(IUOUT,1002)(K,K=K1,K2)
      DO 90 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
   90 I2=I1+(NKPB-1)*N
  100 IF(IR.EQ.0) GO TO 120
      I1=IBL*N*NKPB+1
      I2=I1+(IR-1)*N
      K1=K2+1
      K2=M
      WRITE(IUOUT,1002)(K,K=K1,K2)
      WRITE(IUOUT,1003)
      DO 110 J=1,N
      WRITE(IUOUT,1003)J,(R(IJ),IJ=I1,I2,N)
      I1=I1+1
      I2=I1+(IR-1)*N
  110 CONTINUE
  120 WRITE(IUOUT,1003)
      RETURN
 1001 FORMAT(/' MATRIX PRINTED:',2X,A)
 1002 FORMAT(/,' ',2X,12(2X,I3,1X),/)
 1003 FORMAT(' ',I4,12F6.2)
      END

      subroutine preigf(io,e,norbs)
      implicit real*8 (a-h,o-z)
      dimension e(*)
      n=6
      ntimes=norbs/n
      nrest=mod(norbs,n)
      if(ntimes.eq.0) nrest=norbs
      j=1
      n2=n
      do k=1,ntimes
      write(io,300)     (e(i),i=j,n2)
      j =j +n
      n2=n2+n
      enddo
      if(nrest.gt.0.or.ntimes.eq.0) then
      write(io,300)            (e(i),i=j,j+nrest-1)
      endif

 100  format(' #     : ',2x,6(4x,i4,2x))
 300  format('eigval : '           ,2x,10f9.2)
      end subroutine preigf

      subroutine preigf0(io,e,norbs)
      implicit real*8 (a-h,o-z)
      dimension e(*)
      n=6
      ntimes=norbs/n
      nrest=mod(norbs,n)
      if(ntimes.eq.0) nrest=norbs
      j=1
      n2=n
      do k=1,ntimes
      write(io,300)     (e(i),i=j,n2)
      j =j +n
      n2=n2+n
      enddo
      if(nrest.gt.0.or.ntimes.eq.0) then
      write(io,300)            (e(i),i=j,j+nrest-1)
      endif

 100  format(' #     : ',2x,6(4x,i4,2x))
 300  format('eig.   : '           ,2x,10f9.2)
      end subroutine preigf0

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> API for dealing with the calculation results
module xtb_api_results
   use, intrinsic :: iso_c_binding
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : evtoau
   use xtb_api_environment
   use xtb_api_utils
   use xtb_type_restart
   implicit none
   private

   public :: VResults
   public :: newResults_api, delResults_api, getEnergy_api, getGradient_api, &
      & getPCGradient_api, getVirial_api, getDipole_api, getCharges_api, &
      & getBondOrders_api, getNao_api, getOrbitalEigenvalues_api, &
      & getOrbitalOccupations_api, getOrbitalCoefficients_api, copyResults_api


   !> Void pointer to wavefunction and result objects
   type :: VResults
      type(TRestart), allocatable :: chk
      real(wp), allocatable :: energy
      real(wp), allocatable :: gradient(:, :)
      real(wp), allocatable :: pcgradient(:, :)
      real(wp), allocatable :: sigma(:, :)
      real(wp), allocatable :: dipole(:)
      real(wp), allocatable :: egap
   end type VResults


contains


!> Create new singlepoint results object
function newResults_api() result(vres) &
      & bind(C, name="xtb_newResults")
   !DEC$ ATTRIBUTES DLLEXPORT :: newResults_api
   type(VResults), pointer :: res
   type(c_ptr) :: vres

   call checkGlobalEnv

   allocate(res)
   vres = c_loc(res)

end function newResults_api


!> Delete singlepoint results object
subroutine delResults_api(vres) &
      & bind(C, name="xtb_delResults")
   !DEC$ ATTRIBUTES DLLEXPORT :: delResults_api
   type(c_ptr), intent(inout) :: vres
   type(VResults), pointer :: res

   call checkGlobalEnv

   if (c_associated(vres)) then
      call c_f_pointer(vres, res)
      deallocate(res)
      vres = c_null_ptr
   end if

end subroutine delResults_api


!> Create copy from a singlepoint results object
function copyResults_api(vold) result(vres) &
      & bind(C, name="xtb_copyResults")
   !DEC$ ATTRIBUTES DLLEXPORT :: copyResults_api
   type(VResults), pointer :: res
   type(c_ptr) :: vres
   type(VResults), pointer :: old
   type(c_ptr), value :: vold

   vres = c_null_ptr

   if (c_associated(vold)) then
      call c_f_pointer(vold, old)
      call checkGlobalEnv

      allocate(res, source=old)
      vres = c_loc(res)
   end if

end function copyResults_api


!> Query singlepoint results object for energy
subroutine getEnergy_api(venv, vres, dptr) &
      & bind(C, name="xtb_getEnergy")
   !DEC$ ATTRIBUTES DLLEXPORT :: getEnergy_api
   character(len=*), parameter :: source = "xtb_api_getEnergy"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%energy)) then
         call env%ptr%error("Energy is not available in results", source)
         return
      end if

      dptr = res%energy

   end if

end subroutine getEnergy_api


!> Query singlepoint results object for gradient
subroutine getGradient_api(venv, vres, dptr) &
      & bind(C, name="xtb_getGradient")
   !DEC$ ATTRIBUTES DLLEXPORT :: getGradient_api
   character(len=*), parameter :: source = "xtb_api_getGradient"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(3, *)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%gradient)) then
         call env%ptr%error("Gradient is not available in results", source)
         return
      end if

      dptr(1:3, 1:size(res%gradient, 2)) = res%gradient

   end if

end subroutine getGradient_api


!> Query singlepoint results object for gradients on external charges
subroutine getPCGradient_api(venv, vres, dptr) &
      & bind(C, name="xtb_getPCGradient")
   !DEC$ ATTRIBUTES DLLEXPORT :: getPCGradient_api
   character(len=*), parameter :: source = "xtb_api_getGradient"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(3, *)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%pcgradient)) then
         call env%ptr%error("External charge gradients are not available in results", source)
         return
      end if

      dptr(1:3, 1:size(res%pcgradient, 2)) = res%pcgradient

   end if

end subroutine getPCGradient_api


!> Query singlepoint results object for virial
subroutine getVirial_api(venv, vres, dptr) &
      & bind(C, name="xtb_getVirial")
   !DEC$ ATTRIBUTES DLLEXPORT :: getVirial_api
   character(len=*), parameter :: source = "xtb_api_getVirial"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(3, 3)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%sigma)) then
         call env%ptr%error("Virial is not available in results", source)
         return
      end if

      dptr(1:3, 1:3) = res%sigma

   end if

end subroutine getVirial_api


!> Query singlepoint results object for dipole moment
subroutine getDipole_api(venv, vres, dptr) &
      & bind(C, name="xtb_getDipole")
   !DEC$ ATTRIBUTES DLLEXPORT :: getDipole_api
   character(len=*), parameter :: source = "xtb_api_getDipole"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(3)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%dipole)) then
         call env%ptr%error("Dipole moment is not available in results", source)
         return
      end if

      dptr(1:3) = res%dipole

   end if

end subroutine getDipole_api


!> Query singlepoint results object for partial charges
subroutine getCharges_api(venv, vres, dptr) &
      & bind(C, name="xtb_getCharges")
   !DEC$ ATTRIBUTES DLLEXPORT :: getCharges_api
   character(len=*), parameter :: source = "xtb_api_getCharges"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(*)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%chk)) then
         call env%ptr%error("Partial charges are not available in results", source)
         return
      end if

      dptr(1:size(res%chk%wfn%q)) = res%chk%wfn%q

   end if

end subroutine getCharges_api


!> Query singlepoint results object for bond orders
subroutine getBondOrders_api(venv, vres, dptr) &
      & bind(C, name="xtb_getBondOrders")
   !DEC$ ATTRIBUTES DLLEXPORT :: getBondOrders_api
   character(len=*), parameter :: source = "xtb_api_getBondOrders"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(*)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%chk)) then
         call env%ptr%error("Bond orders are not available in results", source)
         return
      end if

      dptr(1:size(res%chk%wfn%wbo)) = reshape(res%chk%wfn%wbo, [size(res%chk%wfn%wbo)])

   end if

end subroutine getBondOrders_api


!> Query singlepoint results object for bond orders
subroutine getNao_api(venv, vres, iptr) &
      & bind(C, name="xtb_getNao")
   !DEC$ ATTRIBUTES DLLEXPORT :: getNao_api
   character(len=*), parameter :: source = "xtb_api_getNao"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   integer(c_int), intent(inout) :: iptr

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (allocated(res%chk)) then
         iptr = res%chk%wfn%nao
      else
         iptr = 0
      end if

   end if

end subroutine getNao_api


!> Query singlepoint results object for orbital energies
subroutine getOrbitalEigenvalues_api(venv, vres, dptr) &
      & bind(C, name="xtb_getOrbitalEigenvalues")
   !DEC$ ATTRIBUTES DLLEXPORT :: getOrbitalEigenvalues_api
   character(len=*), parameter :: source = "xtb_api_getOrbitalEigenvalues"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(*)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%chk)) then
         call env%ptr%error("Orbital eigenvalues are not available in results", &
            & source)
         return
      end if

      dptr(1:size(res%chk%wfn%emo)) = res%chk%wfn%emo * evtoau

   end if

end subroutine getOrbitalEigenvalues_api


!> Query singlepoint results object for occupation numbers
subroutine getOrbitalOccupations_api(venv, vres, dptr) &
      & bind(C, name="xtb_getOrbitalOccupations")
   !DEC$ ATTRIBUTES DLLEXPORT :: getOrbitalOccupations_api 
   character(len=*), parameter :: source = "xtb_api_getOrbitalOccupations"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(*)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%chk)) then
         call env%ptr%error("Occupation numbers are not available in results", &
            & source)
         return
      end if

      dptr(1:size(res%chk%wfn%focc)) = res%chk%wfn%focc

   end if

end subroutine getOrbitalOccupations_api


!> Query singlepoint results object for orbital coefficients
subroutine getOrbitalCoefficients_api(venv, vres, dptr) &
      & bind(C, name="xtb_getOrbitalCoefficients")
   !DEC$ ATTRIBUTES DLLEXPORT :: getOrbitalCoefficients_api 
   character(len=*), parameter :: source = "xtb_api_getOrbitalCoefficients"
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   real(c_double), intent(inout) :: dptr(*)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vres)) then
         call env%ptr%error("Results object is not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      if (.not.allocated(res%chk)) then
         call env%ptr%error("Orbital coefficients are not available in results", &
            & source)
         return
      end if

      dptr(1:size(res%chk%wfn%C)) = reshape(res%chk%wfn%C, [size(res%chk%wfn%C)])

   end if

end subroutine getOrbitalCoefficients_api


end module xtb_api_results

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> general functions for core functionalities of the SCC
module xtb_scc_core
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_la, only : contract
   use xtb_mctc_lapack, only : lapack_sygvd
   use xtb_mctc_blas, only : blas_gemm, mctc_symv, mctc_gemm
   use xtb_mctc_lapack_eigensolve, only : TEigenSolver
   use xtb_type_environment, only : TEnvironment
   use xtb_type_solvation, only : TSolvation
   use xtb_xtb_data
   use xtb_xtb_coulomb
   use xtb_xtb_dispersion
   use xtb_xtb_multipole
   use xtb_broyden
   implicit none
   private

   public :: build_h0, scc, electro, solve, solve4
   public :: fermismear, occ, occu, dmat, get_unrestricted_wiberg
   public :: get_wiberg, mpopall, mpop0, mpopao, mpop, mpopsh, qsh2qat, lpop
   public :: iniqshell, setzshell
   public :: shellPoly, h0scal


   integer, private, parameter :: mmm(20)=(/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/)


contains

!! ========================================================================
!  build GFN2 core Hamiltonian
!! ========================================================================
subroutine build_h0(hData,H0,n,at,ndim,nmat,matlist, &
   &                xyz,selfEnergy,S,aoat2,lao2,valao2,aoexp,ao2sh)
   type(THamiltonianData), intent(in) :: hData
   real(wp),intent(out) :: H0(ndim*(ndim+1)/2)
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   integer, intent(in)  :: ndim
   integer, intent(in)  :: nmat
   integer, intent(in)  :: matlist(2,nmat)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(in)  :: selfEnergy(:)
   real(wp),intent(in)  :: S(ndim,ndim)
   integer, intent(in)  :: aoat2(ndim)
   integer, intent(in)  :: lao2(ndim)
   integer, intent(in)  :: valao2(ndim)
   integer, intent(in)  :: ao2sh(ndim)
   real(wp),intent(in)  :: aoexp(ndim)

   integer  :: i,j,k,m
   integer  :: iat,jat,ish,jsh,il,jl,iZp,jZp
   real(wp) :: hdii,hdjj,hav
   real(wp) :: km

   H0=0.0_wp

   do m = 1, nmat
      i = matlist(1,m)
      j = matlist(2,m)
      k = j+i*(i-1)/2
      iat = aoat2(i)
      jat = aoat2(j)
      ish = ao2sh(i)
      jsh = ao2sh(j)
      iZp = at(iat)
      jZp = at(jat)
      il = mmm(lao2(i))
      jl = mmm(lao2(j))
      hdii = selfEnergy(ish)
      hdjj = selfEnergy(jsh)
      call h0scal(hData,il,jl,izp,jzp,valao2(i).ne.0,valao2(j).ne.0, &
      &           km)
      km = km*(2*sqrt(aoexp(i)*aoexp(j))/(aoexp(i)+aoexp(j)))**hData%wExp
      hav = 0.5d0*(hdii+hdjj)* &
      &      shellPoly(hData%shellPoly(il, iZp), hData%shellPoly(jl, jZp), &
      &                hData%atomicRad(iZp), hData%atomicRad(jZp),xyz(:,iat),xyz(:,jat))
      H0(k) = S(j,i)*km*hav
   enddo
!  diagonal
   k=0
   do i=1,ndim
      k=k+i
      iat = aoat2(i)
      ish = ao2sh(i)
      il = mmm(lao2(i))
      H0(k) = selfEnergy(ish)
   enddo

end subroutine build_h0

!> build isotropic H1/Fockian
subroutine buildIsotropicH1(n, at, ndim, nshell, nmat, matlist, H, &
      & H0, S, shellShift, aoat2, ao2sh)
   use xtb_mctc_convert, only : autoev,evtoau
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   integer, intent(in)  :: ndim
   integer, intent(in)  :: nshell
   integer, intent(in)  :: nmat
   integer, intent(in)  :: matlist(2,nmat)
   real(wp),intent(in)  :: H0(ndim*(1+ndim)/2)
   real(wp),intent(in)  :: S(ndim,ndim)
   real(wp),intent(in)  :: shellShift(nshell)
   integer, intent(in)  :: aoat2(ndim)
   integer, intent(in)  :: ao2sh(ndim)
   real(wp),intent(out) :: H(ndim,ndim)

   integer  :: m,i,j,k
   integer  :: ishell,jshell
   integer  :: ii,jj,kk
   real(wp) :: dum
   real(wp) :: eh1,t8,t9,tgb,h1

   H = 0.0_wp

   do m = 1, nmat
      i = matlist(1,m)
      j = matlist(2,m)
      k = j+i*(i-1)/2
      ishell = ao2sh(i)
      jshell = ao2sh(j)
      ! SCC terms
      eh1 = autoev*(shellShift(ishell) + shellShift(jshell))
      H1 = -S(j,i)*eh1*0.5_wp
      H(j,i) = H0(k) + H1
      H(i,j) = H(j,i)
   enddo

end subroutine buildIsotropicH1

!> build anisotropic H1/Fockian
subroutine addAnisotropicH1(n,at,ndim,nshell,nmat,ndp,nqp,matlist,mdlst,mqlst,&
                         H,S,dpint,qpint,vs,vd,vq,aoat2,ao2sh)
   use xtb_mctc_convert, only : autoev,evtoau
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   integer, intent(in)  :: ndim
   integer, intent(in)  :: nshell
   integer, intent(in)  :: nmat
   integer, intent(in)  :: ndp
   integer, intent(in)  :: nqp
   integer, intent(in)  :: matlist(2,nmat)
   integer, intent(in)  :: mdlst(2,ndp)
   integer, intent(in)  :: mqlst(2,nqp)
   real(wp),intent(in)  :: S(ndim,ndim)
   real(wp),intent(in)  :: dpint(3,ndim,ndim)
   real(wp),intent(in)  :: qpint(6,ndim,ndim)
   real(wp),intent(in)  :: vs(n)
   real(wp),intent(in)  :: vd(3,n)
   real(wp),intent(in)  :: vq(6,n)
   integer, intent(in)  :: aoat2(ndim)
   integer, intent(in)  :: ao2sh(ndim)
   real(wp),intent(inout) :: H(ndim,ndim)

   integer, external :: lin
   integer  :: m,i,j,k,l
   integer  :: ii,jj,kk
   integer  :: ishell,jshell
   real(wp) :: dum,eh1,t8,t9,tgb

   !> overlap dependent terms
   do m=1,nmat
      i=matlist(1,m)
      j=matlist(2,m)
      k=j+i*(i-1)/2
      ii=aoat2(i)
      jj=aoat2(j)
      dum=S(j,i)
      ! CAMM potential
      eh1=0.50d0*dum*(vs(ii)+vs(jj))*autoev
      H(j,i)=H(j,i)+eh1
      H(i,j)=H(j,i)
   enddo
   !> dipolar terms
   do m=1,ndp
      i=mdlst(1,m)
      j=mdlst(2,m)
      k=lin(j,i)
      ii=aoat2(i)
      jj=aoat2(j)
      eh1=0.0d0
      do l=1,3
         eh1=eh1+dpint(l,i,j)*(vd(l,ii)+vd(l,jj))
      enddo
      eh1=0.50d0*eh1*autoev
      H(i,j)=H(i,j)+eh1
      H(j,i)=H(i,j)
   enddo
   !> quadrupole-dependent terms
   do m=1,nqp
      i=mqlst(1,m)
      j=mqlst(2,m)
      ii=aoat2(i)
      jj=aoat2(j)
      k=lin(j,i)
      eh1=0.0d0
      ! note: these come in the following order
      ! xx, yy, zz, xy, xz, yz
      do l=1,6
         eh1=eh1+qpint(l,i,j)*(vq(l,ii)+vq(l,jj))
      enddo
      eh1=0.50d0*eh1*autoev
      H(i,j)=H(i,j)+eh1
      H(j,i)=H(i,j)
   enddo

end subroutine addAnisotropicH1


!> self consistent charge iterator
subroutine scc(env,xtbData,solver,n,nel,nopen,ndim,ndp,nqp,nmat,nshell, &
      &        at,matlist,mdlst,mqlst,aoat2,ao2sh,ash, &
      &        q,dipm,qp,qq,qlmom,qsh,zsh, &
      &        xyz,aes, &
      &        cm5,cm5a,gborn,solvation, &
      &        scD4, &
      &        broy,broydamp,damp0, &
      &        pcem,shellShift,externShift, &
      &        et,focc,focca,foccb,efa,efb, &
      &        eel,ees,eaes,epol,ed,epcem,egap,emo,ihomo,ihomoa,ihomob, &
      &        H0,H,S,dpint,qpint,X,P,ies, &
      &        maxiter,startpdiag,scfconv,qconv, &
      &        minpr,pr, &
      &        fail,jter)
   use xtb_mctc_convert, only : autoev,evtoau

   use xtb_disp_dftd4,  only: disppot,edisp_scc
   use xtb_aespot, only : gfn2broyden_diff,gfn2broyden_out,gfn2broyden_save, &
   &                  mmompop,aniso_electro,setvsdq
   use xtb_embedding, only : electro_pcem

   character(len=*), parameter :: source = 'scc_core'

   type(TEnvironment), intent(inout) :: env

   type(TxTBData), intent(in) :: xtbData
   type(TEigenSolver), intent(inout) :: solver

   integer, intent(in)  :: n
   integer, intent(in)  :: nel
   integer, intent(in)  :: nopen
   integer, intent(in)  :: ndim
   integer, intent(in)  :: ndp
   integer, intent(in)  :: nqp
   integer, intent(in)  :: nmat
   integer, intent(in)  :: nshell
!! ------------------------------------------------------------------------
!  general options for the iterator
   integer, intent(in)  :: maxiter
   integer, intent(in)  :: startpdiag
   real(wp),intent(in)  :: scfconv
   real(wp),intent(in)  :: qconv
   logical, intent(in)  :: minpr
   logical, intent(in)  :: pr
   logical, intent(out) :: fail
!! ------------------------------------------------------------------------
   integer, intent(in)  :: at(n)
!! ------------------------------------------------------------------------
   integer, intent(in)  :: matlist(2,nmat)
   integer, intent(in)  :: mdlst(2,ndp)
   integer, intent(in)  :: mqlst(2,nqp)
   integer, intent(in)  :: aoat2(ndim)
   integer, intent(in)  :: ao2sh(ndim)
   integer, intent(in)  :: ash(:)
!! ------------------------------------------------------------------------
!  a bunch of charges and CAMMs
   real(wp),intent(inout) :: q(n)
   real(wp),intent(inout) :: dipm(3,n)
   real(wp),intent(inout) :: qp(6,n)
   real(wp),intent(inout) :: qq(n)
   real(wp),intent(inout) :: qlmom(3,n)
   real(wp),intent(inout) :: qsh(nshell)
   real(wp),intent(in)    :: zsh(nshell)
!! ------------------------------------------------------------------------
!  anisotropic electrostatic
   type(TxTBMultipole), intent(in), optional :: aes
   real(wp),intent(in)    :: xyz(3,n)
   real(wp), allocatable :: vs(:)
   real(wp), allocatable :: vd(:, :)
   real(wp), allocatable :: vq(:, :)
!! ------------------------------------------------------------------------
!  continuum solvation model GBSA
   class(TSolvation), allocatable, intent(inout) :: solvation
   real(wp),intent(in)    :: cm5a(n)
   real(wp),intent(inout) :: cm5(n)
   real(wp),intent(inout) :: gborn
!! ------------------------------------------------------------------------
!  selfconsistent DFT-D4 dispersion correction
   type(TxTBDispersion), intent(inout), optional :: scD4
!! ------------------------------------------------------------------------
!  point charge embedding potentials
   logical, intent(in)    :: pcem
   real(wp),intent(inout) :: shellShift(nshell)
   real(wp),intent(inout) :: externShift(nshell)
   real(wp), allocatable :: atomicShift(:)
!! ------------------------------------------------------------------------
!  Fermi-smearing
   real(wp),intent(in)    :: et
   real(wp),intent(inout) :: focc(ndim)
   real(wp),intent(inout) :: foccb(ndim),focca(ndim)
   real(wp),intent(inout) :: efa,efb
!! ------------------------------------------------------------------------
!  Convergence accelerators, a simple damping as well as a Broyden mixing
!  are available. The Broyden mixing is used by default seems reliable.
   real(wp),intent(in)    :: damp0
   real(wp)               :: damp
!  Broyden
   integer                :: nbr
   logical, intent(in)    :: broy
   real(wp),intent(inout) :: broydamp
   real(wp)               :: omegap
   real(wp),allocatable   :: df(:,:)
   real(wp),allocatable   :: u(:,:)
   real(wp),allocatable   :: a(:,:)
   real(wp),allocatable   :: q_in(:)
   real(wp),allocatable   :: dq(:)
   real(wp),allocatable   :: qlast_in(:)
   real(wp),allocatable   :: dqlast(:)
   real(wp),allocatable   :: omega(:)
!! ------------------------------------------------------------------------
!  results of the SCC iterator
   real(wp),intent(out)   :: eel
   real(wp),intent(out)   :: epcem
   real(wp),intent(out)   :: ees
   real(wp),intent(out)   :: eaes
   real(wp),intent(out)   :: epol
   real(wp),intent(out)   :: ed
   real(wp),intent(out)   :: egap
   real(wp),intent(out)   :: emo(ndim)
   integer, intent(inout) :: ihomo
   integer, intent(inout) :: ihomoa
   integer, intent(inout) :: ihomob
!! ------------------------------------------------------------------------
   real(wp),intent(in)    :: H0(ndim*(ndim+1)/2)
   real(wp),intent(out)   :: H(ndim,ndim)
   real(wp),intent(inout) :: P(ndim,ndim)
   real(wp),intent(inout) :: X(ndim,ndim)
   real(wp),intent(in)    :: S(ndim,ndim)
   real(wp),intent(in)    :: dpint(3,ndim,ndim)
   real(wp),intent(in)    :: qpint(6,ndim,ndim)
   type(TxTBCoulomb), intent(inout) :: ies

   integer, intent(inout) :: jter
!! ------------------------------------------------------------------------
!  local variables
   integer,external :: lin
   integer  :: i,ii,j,jj,k,kk,l,m
   integer  :: ishell,jshell
   real(wp) :: t8,t9
   real(wp) :: eh1,dum,tgb
   real(wp) :: eold
   real(wp) :: ga,gb
   real(wp) :: rmsq
   real(wp) :: nfoda,nfodb
   logical  :: fulldiag
   logical  :: lastdiag
   integer  :: iter
   integer  :: thisiter
   logical  :: converged
   logical  :: econverged
   logical  :: qconverged

   converged = .false.
   lastdiag = .false.
   ! number of iterations for this iterator
   thisiter = maxiter - jter

   damp = damp0
   if (present(aes)) then
      nbr = nshell + 9*n
      allocate(vs(n), vd(3, n), vq(6, n))
   else
      nbr = nshell
   end if
!  broyden data storage and init
   allocate( df(thisiter,nbr),u(thisiter,nbr),a(thisiter,thisiter), &
   &         dq(nbr),dqlast(nbr),qlast_in(nbr),omega(thisiter), &
   &         q_in(nbr),atomicShift(n), source = 0.0_wp )

!! ------------------------------------------------------------------------
!  Iteration entry point
   scc_iterator: do iter = 1, thisiter

   ! set up ES potential
   atomicShift(:) = 0.0_wp
   shellShift(:) = externShift
   call ies%addShift(q, qsh, atomicShift, shellShift)
   ! compute potential intermediates
   if (present(aes)) then
      call setvsdq(aes,n,at,xyz,q,dipm,qp,aes%gab3,aes%gab5,vs,vd,vq)
   end if
   ! Solvation contributions
   if (allocated(solvation)) then
      cm5(:) = q + cm5a
      call solvation%addShift(env, cm5, qsh, atomicShift, shellShift)
   end if
   ! self consistent dispersion contributions
   if (present(scD4)) then
      call scD4%addShift(at, q, atomicShift)
   end if
   ! expand all atomic potentials to shell resolved potentials
   call addToShellShift(ash, atomicShift, shellShift)

   ! build the charge dependent Hamiltonian
   call buildIsotropicH1(n,at,ndim,nshell,nmat,matlist,H,H0,S, &
      & shellShift,aoat2,ao2sh)
   if (present(aes)) then
      call addAnisotropicH1(n,at,ndim,nshell,nmat,ndp,nqp,matlist,mdlst,mqlst,&
         & H,S,dpint,qpint,vs,vd,vq,aoat2,ao2sh)
   end if

   ! ------------------------------------------------------------------------
   ! solve HC=SCemo(X,P are scratch/store)
   ! solution is in H(=C)/emo
   ! ------------------------------------------------------------------------
   fulldiag=.false.
   if(iter.lt.startpdiag) fulldiag=.true.
   if(lastdiag )          fulldiag=.true.

   !call solve(fulldiag,ndim,ihomo,scfconv,H,S,X,P,emo,fail)

   call solver%solve(env, H, S, emo)
   call env%check(fail)
   if(fail)then
      call env%error("Diagonalization of Hamiltonian failed", source)
      return
   endif

   if(ihomo+1.le.ndim.and.ihomo.ge.1)egap=emo(ihomo+1)-emo(ihomo)
   ! automatic reset to small value
   if(egap.lt.0.1.and.iter.eq.0) broydamp=0.03

   ! Fermi smearing
   if(et.gt.0.1)then
      ! convert restricted occ first to alpha/beta
      if(nel.gt.0) then
         call occu(ndim,nel,nopen,ihomoa,ihomob,focca,foccb)
      else
         focca=0.0d0
         foccb=0.0d0
         ihomoa=0
         ihomob=0
      endif
      if (ihomoa+1.le.ndim) then
         call fermismear(.false.,ndim,ihomoa,et,emo,focca,nfoda,efa,ga)
      endif
      if (ihomob+1.le.ndim) then
         call fermismear(.false.,ndim,ihomob,et,emo,foccb,nfodb,efb,gb)
      endif
      focc = focca + foccb
   else
      ga = 0.0_wp
      gb = 0.0_wp
   endif

   ! save q
   q_in(1:nshell)=qsh(1:nshell)
   if (present(aes)) then
      k=nshell
      call gfn2broyden_save(n,k,nbr,dipm,qp,q_in)
   end if

   ! density matrix
   call dmat(ndim,focc,H,P)

   ! new q
   call mpopsh(n,ndim,nshell,ao2sh,S,P,qsh)
   qsh = zsh - qsh

   ! qat from qsh
   call qsh2qat(ash,qsh,q)

   eold=eel
   call electro(n,at,ndim,nshell,ies,H0,P,q,qsh,ees,eel)
   ! multipole electrostatic
   if (present(aes)) then
      call mmompop(n,ndim,aoat2,xyz,p,s,dpint,qpint,dipm,qp)
      ! evaluate energy
      call aniso_electro(aes,n,at,xyz,q,dipm,qp,aes%gab3,aes%gab5,eaes,epol)
      eel=eel+eaes+epol
   end if

   ! Self consistent dispersion
   if (present(scD4)) then
      call scD4%getEnergy(at, q, ed)
      eel = eel + ed
   endif

   ! point charge contribution
   if(pcem) then
      call electro_pcem(nshell,qsh,externShift,epcem,eel)
   end if

   ! new cm5 charges and gborn energy
   if (allocated(solvation)) then
      cm5=q+cm5a
      call solvation%getEnergy(env, cm5, qsh, gborn)
      eel = eel + gborn
   end if

   ! add el. entropies*T
   eel=eel+ga+gb

   ! ------------------------------------------------------------------------
   ! check for energy convergence
   econverged = abs(eel - eold) < scfconv
   ! ------------------------------------------------------------------------

   dq(1:nshell)=qsh(1:nshell)-q_in(1:nshell)
   if (present(aes)) then
      k=nshell
      call gfn2broyden_diff(n,k,nbr,dipm,qp,q_in,dq) ! CAMM case
   end if
   rmsq=sum(dq(1:nbr)**2)/dble(n)
   rmsq=sqrt(rmsq)

   ! ------------------------------------------------------------------------
   ! end of SCC convergence part
   qconverged = rmsq < qconv
   ! ------------------------------------------------------------------------

   ! SCC convergence acceleration
   if(.not.broy)then

      ! simple damp
      if(iter.gt.0) then
         omegap=egap
         ! monopoles only
         do i=1,nshell
            qsh(i)=damp*qsh(i)+(1.0d0-damp)*q_in(i)
         enddo
         if (present(aes)) then
            ! CAMM
            k=nshell
            do i=1,n
               do j=1,3
                  k=k+1
                  dipm(j,i)=damp*dipm(j,i)+(1.0d0-damp)*q_in(k)
               enddo
               do j=1,6
                  k=k+1
                  qp(j,i)=damp*qp(j,i)+(1.0d0-damp)*q_in(k)
               enddo
            enddo
         end if
         if(eel-eold.lt.0) then
            damp=damp*1.15
         else
            damp=damp0
         endif
         damp=min(damp,1.0)
         if(egap.lt.1.0)damp=min(damp,0.5)
      endif

   else

      ! Broyden mixing
      omegap=0.0d0
      call broyden(nbr,q_in,qlast_in,dq,dqlast,iter,thisiter,broydamp,omega,df,u,a)
      qsh(1:nshell)=q_in(1:nshell)
      if (present(aes)) then
         k=nshell
         call gfn2broyden_out(n,k,nbr,q_in,dipm,qp) ! CAMM case
      end if
      if(iter.gt.1) omegap=omega(iter-1)
   endif ! Broyden?

   call qsh2qat(ash, qsh, q) !new qat

   if(allocated(solvation)) cm5 = q+cm5a

   if(minpr)write(env%unit,'(i4,F15.7,E14.6,E11.3,f8.2,2x,f8.1,l3)') &
   &  iter+jter,eel,eel-eold,rmsq,egap,omegap,fulldiag
   qq=q

!  end of SCC convergence part

!! ------------------------------------------------------------------------
   if (econverged.and.qconverged) then
      converged = .true.
      if (lastdiag) exit scc_iterator
      lastdiag = .true.
   endif
!! ------------------------------------------------------------------------

   enddo scc_iterator

   jter = jter + min(iter,thisiter)
   fail = .not.converged

end subroutine scc


!> H0 off-diag scaling
subroutine h0scal(hData,il,jl,izp,jzp,valaoi,valaoj,km)
  !$acc routine seq
   type(THamiltonianData), intent(in) :: hData
   integer, intent(in)  :: il
   integer, intent(in)  :: jl
   integer, intent(in)  :: izp
   integer, intent(in)  :: jzp
   logical, intent(in)  :: valaoi
   logical, intent(in)  :: valaoj
   real(wp),intent(out) :: km
   real(wp) :: den, enpoly

   km = 0.0_wp

!  valence
   if(valaoi.and.valaoj) then
      den=(hData%electronegativity(izp)-hData%electronegativity(jzp))**2
      enpoly = (1.0_wp+hData%enScale(jl-1,il-1)*den*(1.0_wp+hData%enScale4*den))
      km=hData%kScale(jl-1,il-1)*enpoly*hData%pairParam(izp,jzp)
      return
   endif

!  "DZ" functions (on H for GFN or 3S for EA calc on all atoms)
   if((.not.valaoi).and.(.not.valaoj)) then
      km=hData%kDiff
      return
   endif
   if(.not.valaoi.and.valaoj) then
      km=0.5*(hData%kScale(jl-1,jl-1)+hData%kDiff)
      return
   endif
   if(.not.valaoj.and.valaoi) then
      km=0.5*(hData%kScale(il-1,il-1)+hData%kDiff)
   endif


end subroutine h0scal


!! ========================================================================
!  total energy for GFN1
!! ========================================================================
pure subroutine electro(n,at,nbf,nshell,ies,H0,P,dq,dqsh,es,scc)
   use xtb_mctc_convert, only : evtoau
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   integer, intent(in) :: nbf
   integer, intent(in) :: nshell
   real(wp),intent(in)  :: H0(nbf*(nbf+1)/2)
   real(wp),intent(in)  :: P (nbf,nbf)
   type(TxTBCoulomb), intent(inout) :: ies
   real(wp),intent(in)  :: dq(n)
   real(wp),intent(in)  :: dqsh(nshell)
   real(wp),intent(out) :: es
   real(wp),intent(out) :: scc
   real(wp) :: ehb ! not used

   integer  :: i,j,k
   real(wp) :: h,t

   ! ES energy in Eh
   call ies%getEnergy(dq, dqsh, es)

!  H0 part
   k=0
   h=0.0_wp
   do i=1,nbf
      do j=1,i-1
         k=k+1
         h=h+P(j,i)*H0(k)
      enddo
      k=k+1
      h=h+P(i,i)*H0(k)*0.5_wp
   enddo

!  Etotal in Eh
   scc = es + 2.0_wp*h*evtoau

end subroutine electro


!! ========================================================================
!  S(R) enhancement factor
!! ========================================================================
pure function shellPoly(iPoly,jPoly,iRad,jRad,xyz1,xyz2)
   use xtb_mctc_convert, only : aatoau
   !$acc routine seq
   real(wp), intent(in) :: iPoly,jPoly
   real(wp), intent(in) :: iRad,jRad
   real(wp), intent(in) :: xyz1(3),xyz2(3)
   real(wp) :: shellPoly
   real(wp) :: rab,k1,rr,r,rf1,rf2,dx,dy,dz,a

   a=0.5           ! R^a dependence 0.5 in GFN1

   dx=xyz1(1)-xyz2(1)
   dy=xyz1(2)-xyz2(2)
   dz=xyz1(3)-xyz2(3)

   rab=sqrt(dx**2+dy**2+dz**2)

   ! this sloppy conv. factor has been used in development, keep it
   rr=jRad+iRad

   r=rab/rr

   rf1=1.0d0+0.01*iPoly*r**a
   rf2=1.0d0+0.01*jPoly*r**a

   shellPoly= rf1*rf2

end function shellPoly

!! ========================================================================
!  set up Coulomb potential due to 2nd order fluctuation
!! ========================================================================
pure subroutine setespot(nshell, qsh, jmat, shellShift)

   !> Dimension of the Coulomb matrix
   integer, intent(in) :: nshell

   !> Shell resolved partial charges
   real(wp),intent(in) :: qsh(:)

   !> Coulomb matrix
   real(wp),intent(in) :: jmat(:, :)

   !> shell-resolved potential shift
   real(wp),intent(inout) :: shellShift(:)

   !call blas_symv('l', nshell, 1.0_wp, jmat, nshell, qsh, 1, 1.0_wp, shellShift, 1)
   call mctc_symv(jmat, qsh, shellShift, beta=1.0_wp)

end subroutine setespot


pure subroutine addToShellShift(shellAtom, atomicShift, shellShift)

   !> Atom each shell is centered on
   integer, intent(in) :: shellAtom(:)

   !> Atomic potential shift
   real(wp), intent(in) :: atomicShift(:)

   !> Shell-resolved potential shift
   real(wp), intent(inout) :: shellShift(:)

   integer :: ii

   do ii = 1, size(shellShift, dim=1)
      shellShift(ii) = shellShift(ii) + atomicShift(shellAtom(ii))
   end do

end subroutine addToShellShift


!! ========================================================================
!  eigenvalue solver single-precision
!! ========================================================================
subroutine solve4(full,ndim,ihomo,acc,H,S,X,P,e,fail)
   use xtb_mctc_accuracy, only : sp
   integer, intent(in)   :: ndim
   logical, intent(in)   :: full
   integer, intent(in)   :: ihomo
   real(wp),intent(inout):: H(ndim,ndim)
   real(wp),intent(in)   :: S(ndim,ndim)
   real(wp),intent(out)  :: X(ndim,ndim)
   real(wp),intent(out)  :: P(ndim,ndim)
   real(wp),intent(out)  :: e(ndim)
   real(wp),intent(in)   :: acc
   logical, intent(out)  :: fail

   integer i,j,info,lwork,liwork,nfound,iu,nbf
   integer, allocatable :: iwork(:),ifail(:)
   real(wp),allocatable :: aux  (:)
   real(wp) w0,w1,t0,t1

   real(sp),allocatable :: H4(:,:)
   real(sp),allocatable :: S4(:,:)
   real(sp),allocatable :: X4(:,:)
   real(sp),allocatable :: P4(:,:)
   real(sp),allocatable :: e4(:)
   real(sp),allocatable :: aux4(:)


   allocate(H4(ndim,ndim),S4(ndim,ndim))
   allocate(X4(ndim,ndim),P4(ndim,ndim),e4(ndim))

   H4 = H
   S4 = S

   fail =.false.
!  standard first full diag call
   if(full) then
!                                                     call timing(t0,w0)
!     if(ndim.gt.0)then
!     USE DIAG IN NON-ORTHORGONAL BASIS
      allocate (aux4(1),iwork(1),ifail(ndim))
      P4 = s4
      call lapack_sygvd(1,'v','u',ndim,h4,ndim,p4,ndim,e4,aux4, &!workspace query
     &           -1,iwork,liwork,info)
      lwork=int(aux4(1))
      liwork=iwork(1)
      deallocate(aux4,iwork)
      allocate (aux4(lwork),iwork(liwork))              !do it
      call lapack_sygvd(1,'v','u',ndim,h4,ndim,p4,ndim,e4,aux4, &
     &           lwork,iwork,liwork,info)
      if(info.ne.0) then
         fail=.true.
         return
      endif
      X4 = H4 ! save
      deallocate(aux4,iwork,ifail)

!     else
!        USE DIAG IN ORTHOGONAL BASIS WITH X=S^-1/2 TRAFO
!        nbf = ndim
!        lwork  = 1 + 6*nbf + 2*nbf**2
!        allocate (aux(lwork))
!        call blas_gemm('N','N',nbf,nbf,nbf,1.0d0,H,nbf,X,nbf,0.0d0,P,nbf)
!        call blas_gemm('T','N',nbf,nbf,nbf,1.0d0,X,nbf,P,nbf,0.0d0,H,nbf)
!        call SYEV('V','U',nbf,H,nbf,e,aux,lwork,info)
!        if(info.ne.0) error stop 'diag error'
!        call blas_gemm('N','N',nbf,nbf,nbf,1.0d0,X,nbf,H,nbf,0.0d0,P,nbf)
!        H = P
!        deallocate(aux)
!     endif
!                                                     call timing(t1,w1)
!                                    call prtime(6,t1-t0,w1-w0,'dsygvd')

   else
!                                                     call timing(t0,w0)
!     go to MO basis using trafo(X) from first iteration (=full diag)
!      call blas_gemm('N','N',ndim,ndim,ndim,1.d0,H4,ndim,X4,ndim,0.d0,P4,ndim)
!      call blas_gemm('T','N',ndim,ndim,ndim,1.d0,X4,ndim,P4,ndim,0.d0,H4,ndim)
!                                                     call timing(t1,w1)
!                       call prtime(6,1.5*(t1-t0),1.5*(w1-w0),'3xdgemm')
!                                                     call timing(t0,w0)
!      call pseudodiag(ndim,ihomo,H4,e4)
!                                                     call timing(t1,w1)
!                                call prtime(6,t1-t0,w1-w0,'pseudodiag')

!     C = X C', P=scratch
!      call blas_gemm('N','N',ndim,ndim,ndim,1.d0,X4,ndim,H4,ndim,0.d0,P4,ndim)
!     save and output MO matrix in AO basis
!      H4 = P4
   endif

   H = H4
   P = P4
   X = X4
   e = e4

   deallocate(e4,P4,X4,S4,H4)

end subroutine solve4


!! ========================================================================
!  eigenvalue solver
!! ========================================================================
subroutine solve(full,ndim,ihomo,acc,H,S,X,P,e,fail)
   integer, intent(in)   :: ndim
   logical, intent(in)   :: full
   integer, intent(in)   :: ihomo
   real(wp),intent(inout):: H(ndim,ndim)
   real(wp),intent(in)   :: S(ndim,ndim)
   real(wp),intent(out)  :: X(ndim,ndim)
   real(wp),intent(out)  :: P(ndim,ndim)
   real(wp),intent(out)  :: e(ndim)
   real(wp),intent(in)   :: acc
   logical, intent(out)  :: fail

   integer i,j,info,lwork,liwork,nfound,iu,nbf
   integer, allocatable :: iwork(:),ifail(:)
   real(wp),allocatable :: aux  (:)
   real(wp) w0,w1,t0,t1

   fail =.false.

!  standard first full diag call
   if(full) then
!                                                     call timing(t0,w0)
!     if(ndim.gt.0)then
!     USE DIAG IN NON-ORTHORGONAL BASIS
      allocate (aux(1),iwork(1),ifail(ndim))
      P = s
      call lapack_sygvd(1,'v','u',ndim,h,ndim,p,ndim,e,aux, &!workspace query
     &           -1,iwork,liwork,info)
      lwork=int(aux(1))
      liwork=iwork(1)
      deallocate(aux,iwork)
      allocate (aux(lwork),iwork(liwork))              !do it
      call lapack_sygvd(1,'v','u',ndim,h,ndim,p,ndim,e,aux, &
     &           lwork,iwork,liwork,info)
      !write(*,*)'SYGVD INFO', info
      if(info.ne.0) then
         fail=.true.
         return
      endif
      X = H ! save
      deallocate(aux,iwork,ifail)

!     else
!        USE DIAG IN ORTHOGONAL BASIS WITH X=S^-1/2 TRAFO
!        nbf = ndim
!        lwork  = 1 + 6*nbf + 2*nbf**2
!        allocate (aux(lwork))
!        call blas_gemm('N','N',nbf,nbf,nbf,1.0d0,H,nbf,X,nbf,0.0d0,P,nbf)
!        call blas_gemm('T','N',nbf,nbf,nbf,1.0d0,X,nbf,P,nbf,0.0d0,H,nbf)
!        call SYEV('V','U',nbf,H,nbf,e,aux,lwork,info)
!        if(info.ne.0) error stop 'diag error'
!        call blas_gemm('N','N',nbf,nbf,nbf,1.0d0,X,nbf,H,nbf,0.0d0,P,nbf)
!        H = P
!        deallocate(aux)
!     endif
!                                                     call timing(t1,w1)
!                                    call prtime(6,t1-t0,w1-w0,'dsygvd')

   else
!                                                     call timing(t0,w0)
!     go to MO basis using trafo(X) from first iteration (=full diag)
      call blas_gemm('N','N',ndim,ndim,ndim,1.d0,H,ndim,X,ndim,0.d0,P,ndim)
      call blas_gemm('T','N',ndim,ndim,ndim,1.d0,X,ndim,P,ndim,0.d0,H,ndim)
!                                                     call timing(t1,w1)
!                       call prtime(6,1.5*(t1-t0),1.5*(w1-w0),'3xdgemm')
!                                                     call timing(t0,w0)
      call pseudodiag(ndim,ihomo,H,e)
!                                                     call timing(t1,w1)
!                                call prtime(6,t1-t0,w1-w0,'pseudodiag')

!     C = X C', P=scratch
      call blas_gemm('N','N',ndim,ndim,ndim,1.d0,X,ndim,H,ndim,0.d0,P,ndim)
!     save and output MO matrix in AO basis
      H = P
   endif

end subroutine solve


subroutine fermismear(prt,norbs,nel,t,eig,occ,fod,e_fermi,s)
   use xtb_mctc_convert, only : autoev
   use xtb_mctc_constants, only : kB
   integer, intent(in)  :: norbs
   integer, intent(in)  :: nel
   real(wp),intent(in)  :: eig(norbs)
   real(wp),intent(out) :: occ(norbs)
   real(wp),intent(in)  :: t
   real(wp),intent(out) :: fod
   real(wp),intent(out) :: e_fermi
   logical, intent(in)  :: prt

   real(wp) :: boltz,bkt,occt,total_number,thr
   real(wp) :: total_dfermi,dfermifunct,fermifunct,s,change_fermi

   parameter (boltz = kB*autoev)
   parameter (thr   = 1.d-9)
   integer :: ncycle,i,j,m,k,i1,i2

   bkt = boltz*t

   e_fermi = 0.5*(eig(nel)+eig(nel+1))
   occt=nel

   do ncycle = 1, 200  ! this loop would be possible instead of gotos
      total_number = 0.0
      total_dfermi = 0.0
      do i = 1, norbs
         fermifunct = 0.0
         if((eig(i)-e_fermi)/bkt.lt.50) then
            fermifunct = 1.0/(exp((eig(i)-e_fermi)/bkt)+1.0)
            dfermifunct = exp((eig(i)-e_fermi)/bkt) / &
            &       (bkt*(exp((eig(i)-e_fermi)/bkt)+1.0)**2)
         else
            dfermifunct = 0.0
         end if
         occ(i) = fermifunct
         total_number = total_number + fermifunct
         total_dfermi = total_dfermi + dfermifunct
      end do
      change_fermi = (occt-total_number)/total_dfermi
      e_fermi = e_fermi+change_fermi
      if (abs(occt-total_number).le.thr) exit
   enddo

   fod=0
   s  =0
   do i=1,norbs
      if(occ(i).gt.thr.and.1.0d00-occ(i).gt.thr) &
      &   s=s+occ(i)*log(occ(i))+(1.0d0-occ(i))*log(1.0d00-occ(i))
      if (eig(i).lt.e_fermi) then
         fod=fod+1.0d0-occ(i)
      else
         fod=fod+      occ(i)
      endif
   enddo
   s=s*kB*t

   if (prt) then
      write(*,'('' t,e(fermi),nfod : '',2f10.3,f10.6)') t,e_fermi,fod
   endif

end subroutine fermismear


subroutine occ(ndim,nel,nopen,ihomo,focc)
   integer  :: nel
   integer  :: nopen
   integer  :: ndim
   integer  :: ihomo
   real(wp) :: focc(ndim)
   integer  :: i,na,nb

   focc=0
!  even nel
   if(mod(nel,2).eq.0)then
      ihomo=nel/2
      do i=1,ihomo
         focc(i)=2.0d0
      enddo
      if(2*ihomo.ne.nel) then
         ihomo=ihomo+1
         focc(ihomo)=1.0d0
         if(nopen.eq.0)nopen=1
      endif
      if(nopen.gt.1)then
         do i=1,nopen/2
            focc(ihomo-i+1)=focc(ihomo-i+1)-1.0
            focc(ihomo+i)=focc(ihomo+i)+1.0
         enddo
      endif
!  odd nel
   else
      na=nel/2+(nopen-1)/2+1
      nb=nel/2-(nopen-1)/2
      do i=1,na
         focc(i)=focc(i)+1.
      enddo
      do i=1,nb
         focc(i)=focc(i)+1.
      enddo
   endif

   do i=1,ndim
      if(focc(i).gt.0.99) ihomo=i
   enddo

end subroutine occ


subroutine occu(ndim,nel,nopen,ihomoa,ihomob,focca,foccb)
   integer  :: nel
   integer  :: nopen
   integer  :: ndim
   integer  :: ihomoa
   integer  :: ihomob
   real(wp) :: focca(ndim)
   real(wp) :: foccb(ndim)
   integer  :: focc(ndim)
   integer  :: i,na,nb,ihomo

   focc=0
   focca=0
   foccb=0
!  even nel
   if(mod(nel,2).eq.0)then
      ihomo=nel/2
      do i=1,ihomo
         focc(i)=2
      enddo
      if(2*ihomo.ne.nel) then
         ihomo=ihomo+1
         focc(ihomo)=1
         if(nopen.eq.0)nopen=1
      endif
      if(nopen.gt.1)then
         do i=1,nopen/2
            focc(ihomo-i+1)=focc(ihomo-i+1)-1
            focc(ihomo+i)=focc(ihomo+i)+1
         enddo
      endif
!  odd nel
   else
      na=nel/2+(nopen-1)/2+1
      nb=nel/2-(nopen-1)/2
      do i=1,na
         focc(i)=focc(i)+1
      enddo
      do i=1,nb
         focc(i)=focc(i)+1
      enddo
   endif

   do i=1,ndim
      if(focc(i).eq.2)then
         focca(i)=1.0d0
         foccb(i)=1.0d0
      endif
      if(focc(i).eq.1)focca(i)=1.0d0
   enddo

   ihomoa=0
   ihomob=0
   do i=1,ndim
      if(focca(i).gt.0.99) ihomoa=i
      if(foccb(i).gt.0.99) ihomob=i
   enddo

end subroutine occu


!> density matrix
! C: MO coefficient
! X: scratch
! P  dmat
subroutine dmat(ndim,focc,C,P)
   integer, intent(in)  :: ndim
   real(wp),intent(in)  :: focc(:)
   real(wp),intent(in)  :: C(:,:)
   real(wp),intent(out) :: P(:,:)
   integer :: i,m
   real(wp),allocatable :: Ptmp(:,:)

   allocate(Ptmp(ndim,ndim))
   ! acc enter data create(Ptmp(:,:)) copyin(C(:, :), focc(:), P(:, :))
   ! acc kernels default(present)
   Ptmp = 0.0_wp
   ! acc end kernels

   ! acc parallel
   ! acc loop gang collapse(2)
   do m=1,ndim
      do i=1,ndim
         Ptmp(i,m)=C(i,m)*focc(m)
      enddo
   enddo
   ! acc end parallel
   ! acc update host(Ptmp)
   call mctc_gemm(C, Ptmp, P, transb='t')
   ! acc exit data copyout(P(:,:)) delete(C(:,:), focc(:), Ptmp(:, :))

   deallocate(Ptmp)

end subroutine dmat

! Reference: I. Mayer, "Simple Theorems, Proofs, and Derivations in Quantum Chemistry", formula (7.35)
subroutine get_wiberg(n,ndim,at,xyz,P,S,wb,fila2)
   integer, intent(in)  :: n,ndim,at(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(in)  :: P(ndim,ndim)
   real(wp),intent(in)  :: S(ndim,ndim)
   real(wp),intent(out) :: wb (n,n)
   integer, intent(in)  :: fila2(:,:)

   real(wp),allocatable :: Ptmp(:,:)
   real(wp) xsum,rab
   integer i,j,k,m

   allocate(Ptmp(ndim,ndim))
   call blas_gemm('N','N',ndim,ndim,ndim,1.0d0,P,ndim,S,ndim,0.0d0,Ptmp,ndim)
   wb = 0
   do i = 1, n
      do j = 1, i-1
         xsum = 0.0_wp
         rab = sum((xyz(:,i) - xyz(:,j))**2)
         if(rab < 100.0_wp)then
            do k = fila2(1,i), fila2(2,i) ! AOs on atom i
               do m = fila2(1,j), fila2(2,j) ! AOs on atom j
                  xsum = xsum + Ptmp(k,m)*Ptmp(m,k)
               enddo
            enddo
         endif
         wb(i,j) = xsum
         wb(j,i) = xsum
      enddo
   enddo
   deallocate(Ptmp)

end subroutine get_wiberg

! Reference: I. Mayer, "Simple Theorems, Proofs, and Derivations in Quantum Chemistry", formula (7.36)
subroutine get_unrestricted_wiberg(n,ndim,at,xyz,Pa,Pb,S,wb,fila2)
   integer, intent(in)  :: n,ndim,at(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(in)  :: Pa(ndim,ndim)
   real(wp),intent(in)  :: Pb(ndim,ndim)
   real(wp),intent(in)  :: S(ndim,ndim)
   real(wp),intent(out) :: wb (n,n)
   integer, intent(in)  :: fila2(:,:)

   real(wp),allocatable :: Ptmp_a(:,:)
   real(wp),allocatable :: Ptmp_b(:,:)
   real(wp) xsum,rab
   integer i,j,k,m

   allocate(Ptmp_a(ndim,ndim))
   allocate(Ptmp_b(ndim,ndim))

   ! P^(alpha) * S !
   call blas_gemm('N','N',ndim,ndim,ndim,1.0d0,Pa,ndim,S,ndim,0.0d0,Ptmp_a,ndim)
   
   ! P^(beta) * S !
   call blas_gemm('N','N',ndim,ndim,ndim,1.0d0,Pb,ndim,S,ndim,0.0d0,Ptmp_b,ndim)
   
   wb = 0
   do i = 1, n
      do j = 1, i-1
         xsum = 0.0_wp
         rab = sum((xyz(:,i) - xyz(:,j))**2)
         if(rab < 100.0_wp)then
            do k = fila2(1,i), fila2(2,i) ! AOs on atom i
               do m = fila2(1,j), fila2(2,j) ! AOs on atom j
                  xsum = xsum + Ptmp_a(k,m)*Ptmp_a(m,k) + Ptmp_b(k,m)*Ptmp_b(m,k) 
               enddo
            enddo
         endif
         wb(i,j) = 2*xsum
         wb(j,i) = 2*xsum
      enddo
   enddo
   deallocate(Ptmp_a)
   deallocate(Ptmp_b)

end subroutine get_unrestricted_wiberg

!> Mulliken pop + AO pop
subroutine mpopall(n,nao,aoat,S,P,qao,q)
   integer nao,n,aoat(nao)
   real(wp)  S (nao,nao)
   real(wp)  P (nao,nao)
   real(wp)  qao(nao),q(n),ps

   integer i,j,ii,jj,ij,is,js

   q  = 0
   qao= 0
   do i=1,nao
      ii=aoat(i)
      do j=1,i-1
         jj=aoat(j)
         ps=p(j,i)*s(j,i)
         q(ii)=q(ii)+ps
         q(jj)=q(jj)+ps
         qao(i)=qao(i)+ps
         qao(j)=qao(j)+ps
      enddo
      ps=p(i,i)*s(i,i)
      q(ii)=q(ii)+ps
      qao(i)=qao(i)+ps
   enddo

end subroutine mpopall


!> Mulliken pop
subroutine mpop0(n,nao,aoat,S,P,q)
   integer nao,n,aoat(nao)
   real(wp)  S (nao,nao)
   real(wp)  P (nao,nao)
   real(wp)  q(n),ps

   integer i,j,ii,jj,ij,is,js

   q = 0
   do i=1,nao
      ii=aoat(i)
      do j=1,i-1
         jj=aoat(j)
         ps=p(j,i)*s(j,i)
         q(ii)=q(ii)+ps
         q(jj)=q(jj)+ps
      enddo
      ps=p(i,i)*s(i,i)
      q(ii)=q(ii)+ps
   enddo

end subroutine mpop0


!> Mulliken AO pop
subroutine mpopao(n,nao,S,P,qao)
   integer nao,n
   real(wp)  S (nao,nao)
   real(wp)  P (nao,nao)
   real(wp)  qao(nao),ps

   integer i,j

   qao = 0
   do i=1,nao
      do j=1,i-1
         ps=p(j,i)*s(j,i)
         qao(i)=qao(i)+ps
         qao(j)=qao(j)+ps
      enddo
      ps=p(i,i)*s(i,i)
      qao(i)=qao(i)+ps
   enddo

end subroutine mpopao


!> Mulliken pop
subroutine mpop(n,nao,aoat,lao,S,P,q,ql)
   integer nao,n,aoat(nao),lao(nao)
   real(wp)  S (nao,nao)
   real(wp)  P (nao,nao)
   real(wp)  q(n),ps
   real(wp)  ql(3,n)

   integer i,j,ii,jj,ij,is,js,mmm(20)
   data    mmm/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/

   ql= 0
   q = 0
   do i=1,nao
      ii=aoat(i)
      is=mmm(lao(i))
      do j=1,i-1
         jj=aoat(j)
         js=mmm(lao(j))
         ps=p(j,i)*s(j,i)
         q(ii)=q(ii)+ps
         q(jj)=q(jj)+ps
         ql(is,ii)=ql(is,ii)+ps
         ql(js,jj)=ql(js,jj)+ps
      enddo
      ps=p(i,i)*s(i,i)
      q(ii)=q(ii)+ps
      ql(is,ii)=ql(is,ii)+ps
   enddo

end subroutine mpop


!> Mulliken pop shell wise
subroutine mpopsh(n,nao,nshell,ao2sh,S,P,qsh)
   integer nao,n,nshell,ao2sh(nao)
   real(wp)  S (nao,nao)
   real(wp)  P (nao,nao)
   real(wp)  qsh(nshell),ps

   integer i,j,ii,jj,ij

   qsh=0
   do i=1,nao
      ii =ao2sh(i)
      do j=1,i-1
         jj =ao2sh(j)
         ps=p(j,i)*s(j,i)
         qsh(ii)=qsh(ii)+ps
         qsh(jj)=qsh(jj)+ps
      enddo
      ps=p(i,i)*s(i,i)
      qsh(ii)=qsh(ii)+ps
   enddo

end subroutine mpopsh


subroutine qsh2qat(ash,qsh,qat)
   integer, intent(in) :: ash(:)
   real(wp), intent(in) :: qsh(:)
   real(wp), intent(out) :: qat(:)

   integer :: iSh

   qat(:) = 0.0_wp
   do iSh = 1, size(qsh)
      qat(ash(iSh)) = qat(ash(iSh)) + qsh(iSh)
   enddo

end subroutine qsh2qat


!> Loewdin pop
subroutine lpop(n,nao,aoat,lao,occ,C,f,q,ql)
   integer nao,n,aoat(nao),lao(nao)
   real(wp)  C (nao,nao)
   real(wp)  occ(nao)
   real(wp)  q(n)
   real(wp)  ql(3,n)
   real(wp)  f

   integer i,j,ii,jj,js,mmm(20)
   data    mmm/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/
   real(wp)  cc

   do i=1,nao
      if(occ(i).lt.1.d-8) cycle
      do j=1,nao
         cc=f*C(j,i)*C(j,i)*occ(i)
         jj=aoat(j)
         js=mmm(lao(j))
         q(jj)=q(jj)+cc
         ql(js,jj)=ql(js,jj)+cc
      enddo
   enddo

end subroutine lpop


!> atomic valence shell pops and total atomic energy
subroutine iniqshell(xtbData,n,at,z,nshell,q,qsh,gfn_method)
   type(TxTBData), intent(in) :: xtbData
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   integer, intent(in)  :: nshell
   integer, intent(in)  :: gfn_method
   real(wp),intent(in)  :: z(n)
   real(wp),intent(in)  :: q(n)
   real(wp),intent(out) :: qsh(nshell)
   real(wp) :: zshell
   real(wp) :: ntot,fracz
   integer  :: i,j,k,m,l,ll(0:3),iat,lll,iver
   data ll /1,3,5,7/

   qsh = 0.0_wp

   k=0
   do i=1,n
      iat=at(i)
      ntot=-1.d-6
      do m=1,xtbData%nShell(iat)
         l=xtbData%hamiltonian%angShell(m,iat)
         k=k+1
         zshell=xtbData%hamiltonian%referenceOcc(m,iat)
         ntot=ntot+zshell
         if(ntot.gt.z(i)) zshell=0
         fracz=zshell/z(i)
         qsh(k)=fracz*q(i)
      enddo
   enddo

end subroutine iniqshell


subroutine setzshell(xtbData,n,at,nshell,z,zsh,e,gfn_method)
   type(TxTBData), intent(in) :: xtbData
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   integer, intent(in)  :: nshell
   integer, intent(in)  :: gfn_method
   real(wp),intent(in)  :: z(n)
   real(wp),intent(out) :: zsh(nshell)
!   integer, intent(out) :: ash(nshell)
!   integer, intent(out) :: lsh(nshell)
   real(wp),intent(out) :: e

   real(wp)  ntot,fracz
   integer i,j,k,m,l,ll(0:3),iat,lll,iver
   data ll /1,3,5,7/

   k=0
   e=0.0_wp
   do i=1,n
      iat=at(i)
      ntot=-1.d-6
      do m=1,xtbData%nShell(iat)
         l=xtbData%hamiltonian%angShell(m,iat)
         k=k+1
         zsh(k)=xtbData%hamiltonian%referenceOcc(m,iat)
!         lsh(k)=l
!         ash(k)=i
         ntot=ntot+zsh(k)
         if(ntot.gt.z(i)) zsh(k)=0
         e=e+xtbData%hamiltonian%selfEnergy(m,iat)*zsh(k)
      enddo
   enddo

end subroutine setzshell


end module xtb_scc_core

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_timer
   use xtb_mctc_accuracy, only : wp, int64 => i8
   implicit none

   public :: tb_timer
   private

   type :: tb_timer
      
      !> number of timers
      integer, private :: n = 0
      
      !> printlevel 
      logical, private :: verbose = .false.
      
      real(wp),private :: totwall = 0.0_wp
      real(wp),private :: totcpu = 0.0_wp
      logical, private,allocatable :: running(:)
      real(wp),private,allocatable :: twall(:)
      real(wp),private,allocatable :: tcpu(:)
      character(len=40),private,allocatable :: tag(:)
   
   contains
   
      procedure :: new => allocate_timer
      procedure :: allocate => allocate_timer
      procedure :: deallocate => deallocate_timer
      procedure :: measure => timer
      procedure :: write_timing
      procedure :: write => write_all_timings
      procedure :: get => get_timer
      procedure,private :: start_timing
      procedure,private :: stop_timing
   
   end type tb_timer

contains

!> To initialize timer
subroutine allocate_timer(self,n,verbose)
   
   implicit none
   
   !> instance of timer
   class(tb_timer),intent(inout) :: self

   !> number of timers
   integer, intent(in)           :: n
   
   !> if verbose
   logical, intent(in), optional :: verbose

   real(wp) :: time_cpu
   real(wp) :: time_wall

   call self%deallocate
   
   ! capture negative values !
   if (n < 1) return
   
   self%n = n
   if (present(verbose)) self%verbose = verbose
   allocate( self%twall(0:n), source = 0.0_wp )
   allocate( self%tcpu(0:n),  source = 0.0_wp )
   allocate( self%running(n), source =.false. )
   allocate( self%tag(n) ); self%tag = ' '

   ! launch timer !
   call self%start_timing(0)

end subroutine allocate_timer

!> To deallocate memory
subroutine deallocate_timer(self)
   
   implicit none
   
   !> instance of timer
   class(tb_timer),intent(inout) :: self
   
   self%n = 0
   self%totwall = 0
   self%totcpu  = 0
   self%verbose = .false.
   if (allocated(self%twall))   deallocate(self%twall)
   if (allocated(self%tcpu))    deallocate(self%tcpu)
   if (allocated(self%running)) deallocate(self%running)

end subroutine deallocate_timer

!> To obtain current elapsed time
function get_timer(self,i) result(time)

   !> instance of timer
   class(tb_timer),intent(inout) :: self
   
   !> if specific timer
   integer,intent(in),optional :: i

   integer  :: it
   real(wp) :: tcpu,twall
   real(wp) :: time
   logical  :: running
   
   ! if i is not given, calculate overall elapsed time !
   if (present(i)) then
      it = i
   else
      it = 0
   endif
   
   if (it > 0) then
      running = self%running(it)
   else
      running = .true.
   endif
   
   if (running) then
      call timing(tcpu,twall)
      time = self%twall(it) + twall
   else
      time = self%twall(it)
   endif

end function get_timer

!> To write timing for specific timer 
subroutine write_timing(self,iunit,i,inmsg,verbose)

   implicit none
   
   !> instance of timer
   class(tb_timer),intent(inout) :: self
   
   !> I/O unit
   integer,intent(in) :: iunit
   
   !> index 
   integer,intent(in) :: i
   
   !> raw message text 
   character(len=*),intent(in),optional :: inmsg
   
   !> if verbose
   logical,intent(in),optional :: verbose
   
   character(len=26) :: msg
   real(wp) :: cputime,walltime
   integer(int64) ::  cpudays, cpuhours, cpumins
   integer(int64) :: walldays,wallhours,wallmins
   logical :: lverbose

!  '(1x,a,1x,"time:",1x,a)'
   ! check if tag should be added !
   if (present(inmsg)) then
      msg = inmsg
   else
      msg = self%tag(i)
   endif
   
   ! verbosity settings !
   if (present(verbose)) then
      lverbose = verbose
   else
      lverbose = self%verbose
   endif
   
   !           DAYS   HOURS   MINUTES   SECONDS
   ! DAYS        1     1/24    1/1440   1/86400
   ! HOURS      24      1       1/60     1/3600
   ! MINUTES   1440    60        1        1/60
   ! SECONDS  86400   3600      60         1
   
   ! convert elapsed CPU time into days, hours, minutes !
   cputime = self%tcpu (i)
   cpudays = int(cputime/86400._wp)
   cputime = cputime - cpudays*86400._wp
   cpuhours = int(cputime/3600._wp)
   cputime = cputime - cpuhours*3600._wp
   cpumins = int(cputime/60._wp)
   cputime = cputime - cpumins*60._wp

   ! convert elapsed wall time into days, hours, minutes !
   walltime = self%twall(i)
   walldays = int(walltime/86400._wp)
   walltime = walltime - walldays*86400._wp
   wallhours = int(walltime/3600._wp)
   walltime = walltime - wallhours*3600._wp
   wallmins = int(walltime/60._wp)
   walltime = walltime - wallmins*60._wp
   
   !----------!
   ! printout !
   !----------!
   
   if (lverbose) then
      write(iunit,'(1x,a)') msg
      write(iunit,'(" * wall-time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') &
         walldays,wallhours,wallmins,walltime
      write(iunit,'(" *  cpu-time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') &
         cpudays, cpuhours, cpumins, cputime
      write(iunit,'(1x,"*",1x,"ratio c/w:",1x,f9.3,1x,"speedup")') self%tcpu (i)/self%twall(i)
   else
      write(iunit,'(1x,a30,1x,"...",i9," min, ",f6.3," sec")') &
         msg, wallmins, walltime
   endif

end subroutine write_timing

!> To write timing for all timers
subroutine write_all_timings(self,iunit,inmsg)
   
   implicit none
   
   !> instance of timer
   class(tb_timer),intent(inout) :: self
   
   !> I/O unit
   integer,intent(in) :: iunit
   
   !> raw message 
   character(len=*),intent(in),optional :: inmsg

   character(len=26) :: msg
   real(wp) :: cputime,walltime
   integer  :: i
   integer(int64) ::  cpudays, cpuhours, cpumins
   integer(int64) :: walldays,wallhours,wallmins

   call self%stop_timing(0)

!  '(1x,a,1x,"time:",1x,a)'
   ! check if an external message should be added !
   if (present(inmsg)) then
      msg = inmsg // " (total)"
   else
      msg = "total time"
   endif
   
   !           DAYS   HOURS   MINUTES   SECONDS
   ! DAYS        1     1/24    1/1440   1/86400
   ! HOURS      24      1       1/60     1/3600
   ! MINUTES   1440    60        1        1/60
   ! SECONDS  86400   3600      60         1
   
   ! convert overall elapsed CPU time into days, hours, minutes !
   cputime = self%tcpu (0)
   cpudays = int(cputime/86400._wp)
   cputime = cputime - cpudays*86400._wp
   cpuhours = int(cputime/3600._wp)
   cputime = cputime - cpuhours*3600._wp
   cpumins = int(cputime/60._wp)
   cputime = cputime - cpumins*60._wp

   ! convert overall elapsed wall time into days, hours, minutes !
   walltime = self%twall(0)
   walldays = int(walltime/86400._wp)
   walltime = walltime - walldays*86400._wp
   wallhours = int(walltime/3600._wp)
   walltime = walltime - wallhours*3600._wp
   wallmins = int(walltime/60._wp)
   walltime = walltime - wallmins*60._wp
   
   !----------!
   ! printout !
   !----------!
   
   write(iunit,'(a)')
   if (self%verbose) then
      write(iunit,'(1x,a,":")') msg
      write(iunit,'(" * wall-time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') &
         walldays,wallhours,wallmins,walltime
      write(iunit,'(" *  cpu-time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') &
         cpudays, cpuhours, cpumins, cputime
      write(iunit,'(1x,"*",1x,"ratio c/w:",1x,f9.3,1x,"speedup")') self%tcpu (0)/self%twall(0)
   else
      write(iunit,'(1x,a26,i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') &
         msg,walldays,wallhours,wallmins,walltime
   endif

   ! printout every timer and corresponding speedup !
   do i = 1, self%n
      walltime = self%twall(i)
      wallmins = int(walltime/60._wp)
      walltime = walltime - wallmins*60._wp
      write(iunit,'(1x,a30,1x,"...",i9," min, ",f6.3," sec (",f7.3,"%)")') &
         self%tag(i), wallmins, walltime, 100*self%twall(i)/self%twall(0)
   enddo
   write(iunit,'(a)')
   
end subroutine write_all_timings

!> start/stop button
subroutine timer(self,i,inmsg)
   
   implicit none
   
   !> instance of timer
   class(tb_timer),intent(inout) :: self

   !> index
   integer,intent(in) :: i
   
   !> raw message text
   character(len=*),intent(in),optional :: inmsg


   ! check if appropriate index is given !
   if (i > self%n .or. i < 1) return
   
   ! switcher between start/stop status !
   if (self%running(i)) then
      call self%stop_timing(i)
   else
      call self%start_timing(i)
   endif
   
   ! update status !
   self%running(i) = .not.self%running(i)
   
   ! assign tag to specific timer !
   if (present(inmsg)) self%tag(i) = trim(inmsg)

end subroutine timer

!> To start counting
subroutine start_timing(self,i)
   
   implicit none

   !> instance of timer
   class(tb_timer),intent(inout) :: self
   
   !> index 
   integer,intent(in) :: i
   
   real(wp) :: time_cpu
   real(wp) :: time_wall
   
   call timing(time_cpu,time_wall)
   self%tcpu (i) = self%tcpu (i) - time_cpu
   self%twall(i) = self%twall(i) - time_wall

end subroutine start_timing

!> To stop counting
subroutine stop_timing(self,i)
   
   implicit none
 
   !> instance of timer
   class(tb_timer),intent(inout) :: self
  
   !> index
   integer,intent(in) :: i
   
   real(wp) :: time_cpu
   real(wp) :: time_wall
   
   call timing(time_cpu,time_wall)
   self%tcpu (i) = self%tcpu (i) + time_cpu
   self%twall(i) = self%twall(i) + time_wall

end subroutine stop_timing

!> To retrieve the current CPU and wall time
subroutine timing(time_cpu,time_wall)
   
   implicit none

   real(wp),intent(out) :: time_cpu
   real(wp),intent(out) :: time_wall
   
   !> current value of system clock (time passed from arbitary point)
   integer(int64) :: time_count
   
   !> number of clock ticks per second (conversion factor b/n ticks and seconds)
   integer(int64) :: time_rate
   integer(int64) :: time_max
   
   call system_clock(time_count,time_rate,time_max)
   call cpu_time(time_cpu)

   ! elapsed time in seconds !
   time_wall = real(time_count,wp)/real(time_rate,wp)

end subroutine timing

end module xtb_type_timer

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_printout
   use xtb_mctc_accuracy, only : wp, sp
   implicit none

contains

!! ---------------------------------------------------------------[FB1808]-
subroutine writecosmofile(np,pa,espe,fname,nat,at,xyz,atom_weight)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autoaa
   use xtb_mctc_symbols, only : toLcSymbol, toSymbol
   implicit none
   integer, intent(in)             :: np
   real(wp), intent(in)            :: pa(3,np)
   real(wp), intent(in)            :: espe(np)
   integer, intent(in)             :: at(nat)
   real(wp), intent(in)            :: xyz(3,nat)
   integer, intent(in)             :: nat
   character(len=*),intent(in)     :: fname
   real(wp),intent(in)             :: atom_weight(2,np)
   logical                         :: exist
   integer                         :: id, i

   call open_file(id,fname,'w')
   write(id,'(a)') '$coord_car'
   write(id,'(a,/,a)') '!BIOSYM archive 3','coordinates from COSMO calculation'
   do i=1,nat
      write(id,'("X1",1x,3f22.14,1x,"COSM 1",1x,a,1x,a,1x,"0.000")')&
         xyz(:,i)*autoaa,toLcSymbol(at(i)),toSymbol(at(i))
   enddo
   write(id,'(a)') 'end'
   write(id,'(a)') '$segment_information'
   do i=1,np
      write(id,'(2x,i5,2x,i0,4f22.14,1x,f22.14,1x,f22.14,1x,"0.000")')&
         i,int(atom_weight(1,i)), pa(:,i)*autoaa,espe(i)/10, &
         atom_weight(2,i)*100,espe(i)/10
   enddo
   call close_file(id)

end subroutine writecosmofile

subroutine setup_summary(iunit,n,fname,xcontrol,wfx,xrc)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_global, only : persistentEnv
   use xtb_mctc_systools
   use xtb_type_wavefunction
   use xtb_setparam
   !$ use omp_lib
   implicit none
   type(TWavefunction),intent(in) :: wfx
   integer, intent(in) :: iunit
   character(len=*),intent(in),optional :: xrc
   character(len=*),intent(in) :: xcontrol
   character(len=*),intent(in) :: fname
   integer :: i,l,err
   integer,intent(in) :: n
   real(wp) :: dum5
   character(len=:),allocatable :: cdum
   write(iunit,'(a)')
   call generic_header(iunit,'Calculation Setup',49,10)
   write(iunit,'(a)')
   if (allocated(cdum)) deallocate(cdum)
   call get_command(length=l)
   allocate( character(len=l) :: cdum )
   call get_command(cdum)
   write(iunit,'(10x,a,":",1x,a)') 'program call               ',cdum
   call rdvar('HOSTNAME',cdum,err)
   if (err.eq.0) &
      write(iunit,'(10x,a,":",1x,a)') 'hostname                   ',cdum
   if (allocated(persistentEnv%io%namespace)) &
      write(iunit,'(10x,a,":",1x,a)') 'calculation namespace      ',persistentEnv%io%namespace
   ! ----------------------------------------------------------------------
   !  print the home and path to check if there are set correctly
   write(iunit,'(10x,a,":",1x,a)') 'coordinate file            ',fname
   if (set%verbose) then
      write(iunit,'(10x,a,":",1x,a)') 'xtbhome directory          ',xenv%home
      write(iunit,'(10x,a,":",1x,a)') 'path for xtb               ',xenv%path
      write(iunit,'(10x,a,":",1x,a)') 'xcontrol input file        ',xcontrol
      if (present(xrc)) &
         write(iunit,'(10x,a,":",1x,a)') 'global configurations file ',xrc
   endif
   ! ----------------------------------------------------------------------
   !  technical data
   !$omp parallel
   !$omp master
   !$ write(iunit,'(10x,a,":",6x,i16)') 'omp threads                ',omp_get_num_threads()
   !$omp end master
   !$omp end parallel
   ! ----------------------------------------------------------------------
   write(iunit,'(a)')

end subroutine

end module xtb_printout

! This file is part of xtb.
!
! Copyright (C) 2022 Stefan Grimme, Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_iff_iffenergy
   use xtb_mctc_accuracy, only: wp
   use xtb_type_environment, only: TEnvironment
   use xtb_docking_param
   !use xtb_sphereparam
   use xtb_sphereparam, only : sphere_alpha, wpot, polynomial_cavity_list, sphere, cavity_egrad,&
           & cavitye, maxwalls, rabc, sphere
   implicit none

   private
   public :: iff_e, intermole_probe, alignmol

contains

   subroutine iff_e(env, n, n1, n2, at1, at2, neigh, A1, c02, q01, q02, c6ab,&
                            & z1, z2, nl1, nl2, l1, l2, AL1, c0l2,&
                            & qdr1, qdr2,&
                            & cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
                            & den1, den2, gab1, gab2,&
                            & pr, mode, e, icoord)
      type(TEnvironment), intent(inout) :: env
      integer, intent(in) :: n, n1, n2
      integer, intent(in) :: nl1, nl2
      integer, intent(in) :: at1(n1)
      integer, intent(in) :: at2(n2)
      integer, intent(in) :: mode
      integer, intent(in) :: neigh(0:n, n)
      !> mol1 xyz
      real(wp), intent(in) :: A1(3, n1)    
      !> mol2 xyz
      real(wp), intent(in) :: c02(3, n2)   
      !> mol1 LMO
      real(wp), intent(in) :: AL1(4, n1*10)
      !> mol2 LMO
      real(wp), intent(in) :: c0l2(4, n2*10)
      real(wp), intent(in) :: q01(n1)
      real(wp), intent(in) :: qdr1(n1)
      real(wp), intent(in) :: q02(n2)
      real(wp), intent(in) :: qdr2(n2)
      real(wp), intent(in) :: cn1(n1)
      real(wp), intent(in) :: z1(n1)
      real(wp), intent(in) :: z2(n2)
      real(wp), intent(in) :: cn2(n2)
      real(wp), intent(in) :: alp1(n1)
      real(wp), intent(in) :: alp2(n2)
      real(wp), intent(in) :: c6ab(n, n)
      real(wp), intent(in) :: alpab(n2, n1)
      real(wp), intent(in) :: qct1(n1, 2), qct2(n2, 2)
      real(wp), intent(in) :: den1(2,4,n1),den2(2,4,n2),gab1(n1,n1),gab2(n2,n2)
      integer, intent(in) :: l1(n1*10)
      integer, intent(in) :: l2(n2*10)
      logical, intent(in) :: pr
      real(wp), optional, intent(in) :: icoord(6)
      real(wp), intent(out) :: e

      real(wp) :: ed,es,ep,esl,ei,eabc,ect,ep2,esph,eadd,gborn,gsolv,dgrrho
      real(wp) :: e_const
      real(wp) :: r0,rr,av,c6,r2,r6,r8,r42,er2,edum,symnum,qq,dhrrho,dzpve
      real(wp) :: R06, rmin, f, dc6, t6, t8, qt1, qt2, tmpr, rrr, p72, nn12
      real(wp) :: d2(3), t1, t2, t3, c9, ang, damp, tmp1, tmp2, sum1, sum2
      real(wp) :: c2(3, n2), cl2(4, 10*n2), dip(3), h, zz1, zz2, nn1, nn2, ees
      real(wp) :: rab(n2, n1), rotm(3, 3), q1(n1), q2(n2), AL2(4, n2*10), A2(3, n2)
      real(wp) :: r2ab(n2, n1), r0tmp(n2, n1), r0tmp2(n2, n1), r, oner, sab(n2, n1)
      !> Thermo stuff
      real(wp) :: aa, bb, cc, avmom, wt, h298, g298, ts298, zp, symn, freq(3*n)
      real(wp) :: xyz(3, n)
      real(wp) :: cavgrad(3) = 0.0_wp
      real(wp), parameter ::autoang = 0.52917726d0
      real(wp), parameter ::au = 627.509541d0
      integer :: pair(2, n1*n2)
      integer :: npair
      integer :: i, j, k, kk, i1, j2, iat, jat, n3, metal(86)
      integer :: at(n)
      logical :: linear, ATM, ijh, ijx
      character(len=4) :: pgroup

      !> Initial stuff
      metal = 1
      metal(1:2) = 0
      metal(6:10) = 0
      metal(14:18) = 0
      metal(32:36) = 0
      metal(50:54) = 0
      metal(82:86) = 0
      e_const=0.0_wp

      ! new cartesians if icoord is present
      if (present(icoord)) then
         call rotmat(icoord, rotm) !write(env%unit icoord(4:6) with new angles
         call move(n2, nl2, c02, c0l2, A2, AL2, rotm, icoord)      !A2 new coords
      else
         A2 = c02
         AL2 = c0l2
      end if

      ATM = .false.
      if (pr .or. fulle .or. mode .eq. 0) ATM = .true.

      ed = 0
      ep = 0
      es = 0
      esl = 0
      ei = 0
      eabc = 0
      eadd = 0
      esph = 0
      gsolv = 0
      dgrrho = 0
      npair = 0
      pair = 0
      do i = 1, n1
         do j = 1, n2
            r2 = (A1(1, i) - A2(1, j))**2&
             &+ (A1(2, i) - A2(2, j))**2&
             &+ (A1(3, i) - A2(3, j))**2
            r2ab(j, i) = r2 + 1.d-12
            rab(j, i) = sqrt(r2) + 1.d-12
            if (r2 .gt. 12000.0d0 .or. r2 .lt. 5.0d0) cycle  ! induction cut-off
            if (metal(at1(i)) .eq. 1 .or. metal(at2(j)) .eq. 1) cycle
            npair = npair + 1
            pair(1, npair) = i
            pair(2, npair) = j
         end do
      end do


!     atomic density overlap
      call ovlp(n1, n2, r2ab, den1, den2, sab)

!     CT
      q1 = q01
      q2 = q02
      call chrgtransfer(env, n1, n2, at1, at2, q1, q2, qct1, qct2, gab1, gab2,&
                       &alpab, rab, debug .and. pr, ect)

!     interatomic ES part
      p72 = par_es_damp
      do i = 1, n1
         do j = 1, n2
            r = rab(j, i)
            r0tmp(j, i) = p72*alpab(j, i)
            if (r .gt. 8) then                 ! point charge cut-off, good to 0.02 kcal
               qq = q1(i)*q2(j)
               es = es + qq/r
            else
               zz1 = z1(i)
               zz2 = z2(j)
               nn1 = zz1 - q1(i)
               nn2 = zz2 - q2(j)
               call truees(n1, n2, i, j, r, r2ab(j, i), den1, den2,&
                          &zz1, zz2, nn1, nn2, ees)  ! via density
               es = es + ees
            end if
         end do
      end do

!     D3 + Pauli via density
      ep2 = 0
      do i = 1, n1
         iat = at1(i)
         nn1 = z1(i) - q1(i)
         do j = 1, n2
            r6 = r2ab(j, i)**3
            r8 = r2ab(j, i)*r6
            jat = at2(j)
            r42 = rrab(jat, iat)
            dc6 = 1./(r6 + r0ab6(jat, iat)) + r42/(r8 + r0ab8(jat, iat))
            ed = ed + dc6*c6ab(j + n1, i)                          ! disp
            if(directedset%n > 0 .and. directed_type == p_atom_att) then
               ed = ed - directedset%val(i) * (exp(-0.01*((rab(j,i)-2)**2)))
               !- Because ed is substracted at the end
            end if
            if (rab(j, i) .gt. 25) cycle
            nn12 = nn1*(z2(j) - q2(j))
            ep = ep + nn12*sab(j, i)/rab(j, i)      ! ovlp S(S+1) is slightly worse, S(S-1) very slightly better
            if (iat .eq. 1 .or. jat .eq. 1)&
           &ep2 = ep2 + sqrt(nn12)*exp(-par_xh1*rab(j, i)*alpab(j, i)) ! X-H corr.
            if(directedset%n > 0 .and. directed_type == p_atom_pot) then
               ep = ep + directedset%val(i) * (1/rab(j,i)**pot_expo) * pot_scal !Add potential for directed docking
            end if
         end do
      end do

!     D3 ATM term (simplified i.e. no damping on i..k and j..k)
      if (ATM) then
         do i = 1, n1
            iat = at1(i)
            do j = 1, n2
               r2 = r2ab(j, i)
               if (r2 .gt. 500.0d0) cycle  ! ATM cut-off E^(3) accurate to about 1 %
               jat = at2(j)
               d2(1) = r2
               r = rab(j, i)
               rrr = r/alpab(j, i)
               damp = 1.0d0/(1.d0 + 6.d0*rrr**(-8))
               do kk = 1, neigh(0, i)
                  k = neigh(kk, i)   ! k on i
                  c9 = c6ab(j + n1, i)*c6ab(i, k)*c6ab(j + n1, k)
                  d2(2) = r2ab(j, k)
                  d2(3) = ((A1(1, i) - A1(1, k))**2&
                           &+ (A1(2, i) - A1(2, k))**2&
                           &+ (A1(3, i) - A1(3, k))**2)
                  t1 = (d2(1) + d2(2) - d2(3))
                  t2 = (d2(1) + d2(3) - d2(2))
                  t3 = (d2(3) + d2(2) - d2(1))
                  tmp2 = d2(1)*d2(2)*d2(3)
                  ang = (0.375d0*t1*t2*t3/tmp2 + 1.0d0)/tmp2**1.5d0
                  eabc = eabc + damp*ang*sqrt(c9)
               end do
               do kk = 1, neigh(0, j + n1)
                  k = neigh(kk, j + n1)   ! k on j
                  c9 = c6ab(j + n1, i)*c6ab(j + n1, k + n1)*c6ab(i, k + n1)
                  d2(2) = ((A2(1, j) - A2(1, k))**2&
                           &+ (A2(2, j) - A2(2, k))**2&
                           &+ (A2(3, j) - A2(3, k))**2)
                  d2(3) = r2ab(k, i)
                  t1 = (d2(1) + d2(2) - d2(3))
                  t2 = (d2(1) + d2(3) - d2(2))
                  t3 = (d2(3) + d2(2) - d2(1))
                  tmp2 = d2(1)*d2(2)*d2(3)
                  ang = (0.375d0*t1*t2*t3/tmp2 + 1.0d0)/tmp2**1.5d0
                  eabc = eabc + damp*ang*sqrt(c9)
               end do
            end do
         end do
      end if

! LP - LP  corrections
      do i = 1, nl1
         iat = l1(i)
         do j = 1, nl2
            jat = l2(j)
            r2 = (AL1(1, i) - AL2(1, j))**2&
              &+ (AL1(2, i) - AL2(2, j))**2&
              &+ (AL1(3, i) - AL2(3, j))**2
            r = dble(sqrt(real(r2)))
            esl = esl + AL1(4, i)*AL2(4, j)/(r + r0tmp(jat, iat)/r)
         end do
!        LP atom corrections
         do j = 1, n2
            r2 = (A2(1, j) - AL1(1, i))**2&
              &+ (A2(2, j) - AL1(2, i))**2&
              &+ (A2(3, j) - AL1(3, i))**2
            r = dble(sqrt(real(r2)))
            esl = esl + AL1(4, i)*q2(j)/(r + r0tmp(j, iat)/r)
         end do
      end do
!     LP atom corrections
      do i = 1, nl2
         iat = l2(i)
         do j = 1, n1
            r2 = (A1(1, j) - AL2(1, i))**2&
              &+ (A1(2, j) - AL2(2, i))**2&
              &+ (A1(3, j) - AL2(3, i))**2
            r = dble(sqrt(real(r2)))
            esl = esl + AL2(4, i)*q1(j)/(r + r0tmp(iat, j)/r)
         end do
      end do

!     Drude Oscillator energy
      call drudescf(n1, n2, nl1, nl2, at1, at2, npair, pair, &
                    A1, q1, qdr1, A2, q2, qdr2, alpab, r0tmp2, ei)

!     Cavity Energies (For Wall Potentials)
      esph = 0.0_wp
      if(qcg) then
         do i=1, maxwalls
            if(.not. allocated(wpot(i)%list)) then
               rabc(1:3) = wpot(i)%radius(1:3)
               exit
            end if
         end do
         sphere = 2
         call cavitye(n1,A1,esph)
         call cavitye(n2,A2,esph)
      else
         at(1:n1) = at1(1:n1)
         at(n1+1:n) = at2(1:n2)
         xyz(1:3, 1:n1) = A1(1:3, 1:n1)
         xyz(1:3, n1+1:n) = A2(1:3, 1:n2)
         call cavity_egrad(n, at, xyz, esph, cavgrad)
     end if

      !> Final Energies
      ep = ep*par_rep_scal + ep2*par_xh2*0.01

      e = -ed + es + ep + esl + ei + gsolv + eabc + ect + esph

      if(isnan(e)) e = 1.0_wp**42

! all done now output
      if (pr .and. e .lt. 10000.2) then ! only if it makes sense to print
         call rcma(n1, A1, at1, n2, A2, at2, r, rmin)
         write (env%unit, '(''R CMA (Angst) :'',F10.3)') r*autoang
         write (env%unit, '(''R min (Angst) :'',F10.3)') rmin*autoang
         call diptot(n1, n2, nl1, nl2, A1, A2, AL1, AL2, l1, l2, q1, q2, dip)
         write(env%unit,'(''dipole moment :'',F10.3)') sqrt(dip(1)**2+dip(2)**2+dip(3)**2)
         write (env%unit, '(''intermolecular energies in kcal/mol'')')
         write (env%unit, '(''E Pauli       :'',F10.3)') ep*au
         write (env%unit, '(''E disp ATM    :'',F10.3)') eabc*au
         write (env%unit, '(''E disp 2B     :'',F10.3)') - ed*au
         write (env%unit, '(''E disp total  :'',F10.3)') - ed*au + eabc*au
         write (env%unit, '(''E ES atom     :'',F10.3)') es*au
         write (env%unit, '(''E ES LMO      :'',F10.3)') esl*au
         write (env%unit, '(''E ES total    :'',F10.3)') (es + esl)*au
         write (env%unit, '(''E induction   :'',F10.3)') ei*au
         write (env%unit, '(''E CT          :'',F10.3)') ect*au
         if (sphere .ne. 0) write (env%unit, '(''E cavity      :'',F10.3)') esph*au
         write (env%unit, '(''Eint total,gas:'',F10.3)') (e - gsolv)*au
        write (env%unit, '(''              '',F14.8,''  <== Gint total'')') e*au
      end if


   end subroutine iff_e

   subroutine drudescf(n1,n2,nl1,nl2,at1,at2,npair,pair,xyz1,qat1,qdr1,xyz2,&
                      &qat2, qdr2, alpab, r0, edr)
      integer, intent(in) :: n1, n2, npair, pair(2, n1*n2), nl1, nl2
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)
      real(wp), intent(in) :: qdr1(n1)
      real(wp), intent(in) :: qat1(n1)
      real(wp), intent(in) :: qdr2(n2)
      real(wp), intent(in) :: qat2(n2)
      real(wp), intent(in) :: alpab(n2, n1)
      real(wp), intent(in) :: r0(n2, n1)
      integer, intent(in):: at1(n1), at2(n2)
      real(wp), intent(out) :: edr

      logical :: echo
      logical :: lp
      integer :: i, k, ii, j, jj, i0
      real(wp) :: alpha, e0
      real(wp) :: q1(n1)
      real(wp) :: q2(n2)
      real(wp) :: gdr1(3, n1)
      real(wp) :: gdr2(3, n2)
      real(wp) :: xyzdr1(3, n1)
      real(wp) :: xyzdr2(3, n2)

      xyzdr1 = xyz1
      xyzdr2 = xyz2

      alpha = 2.0

      do i = 1, n1
         q1(i) = qat1(i) - qdr1(i)
      end do
      do i = 1, n2
         q2(i) = qat2(i) - qdr2(i)
      end do

      do ii = 1, 2
         call indeg(n1, n2, nl1, nl2, npair, pair, xyz1, q1, xyzdr1, qdr1,&
              &xyz2, q2, xyzdr2, qdr2, at1, at2, alpab, r0, ii, edr, gdr1, gdr2)
         if (ii .eq. 1) then
            e0 = edr
            do i = 1, n1
               xyzdr1(1:3, i) = xyzdr1(1:3, i) - alpha*gdr1(1:3, i)
            end do
            do i = 1, n2
               xyzdr2(1:3, i) = xyzdr2(1:3, i) - alpha*gdr2(1:3, i)
            end do
         end if

         edr = edr - e0

      end do
   end subroutine drudescf

! Drude SCF gradient
   subroutine indeg(n1, n2, nl1, nl2, npair, pair, xyz1, q1, xyzdr1, qdr1,&
                   &xyz2, q2, xyzdr2, qdr2, at1, at2, alpab, r0, kode,&
                  & ec, gdr1, gdr2)
      integer, intent(in) :: n1, n2, nl1, nl2, npair, pair(2, n1*n2), kode
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyzdr1(3, n1)
      real(wp), intent(in) :: q1(n1)
      real(wp), intent(in) :: qdr1(n1)
      real(wp), intent(in) :: xyz2(3, n2)
      real(wp), intent(in) :: xyzdr2(3, n2)
      real(wp), intent(in) :: q2(n2)
      real(wp), intent(in) :: qdr2(n2)
      real(wp), intent(in) :: alpab(n2, n1)
      real(wp), intent(in) :: r0(n2, n1)
      integer, intent(in) :: at1(n1), at2(n2)
      real(wp), intent(out) :: gdr1(3, n1)
      real(wp), intent(out) :: gdr2(3, n2)
      real(wp), intent(out) :: ec

      integer :: i, j, k, i1, i2, ij
      real(wp) :: rab, rabd, r2, onedr, dum, dum2, oner
      real(wp) :: dx, dy, dz, edr, espring, qq, damp
      real(wp) :: edr1, edr2, edr3

      dum = par_drude_fc
      dum2 = 2.0d0*dum
      damp = par_drude_damp

      if (kode .eq. 1) then  ! E and G
      ! spring force and E
         espring = 0
         do i = 1, n1
            dx = (xyzdr1(1, i) - xyz1(1, i))
            dy = (xyzdr1(2, i) - xyz1(2, i))
            dz = (xyzdr1(3, i) - xyz1(3, i))
            rab = dx*dx + dy*dy + dz*dz
            dum = par_drude_fc*gam(at1(i))
            dum2 = 2.*dum
            espring = espring + dum*rab
            gdr1(1, i) = dum2*dx
            gdr1(2, i) = dum2*dy
            gdr1(3, i) = dum2*dz
         end do
         do i = 1, n2
            dx = (xyzdr2(1, i) - xyz2(1, i))
            dy = (xyzdr2(2, i) - xyz2(2, i))
            dz = (xyzdr2(3, i) - xyz2(3, i))
            rab = dx*dx + dy*dy + dz*dz
            dum = par_drude_fc*gam(at2(i))
            dum2 = 2.*dum
            espring = espring + dum*rab
            gdr2(1, i) = dum2*dx
            gdr2(2, i) = dum2*dy
            gdr2(3, i) = dum2*dz
         end do

         edr = 0
         do ij = 1, npair
            i1 = pair(1, ij)  ! on mol 1
            i2 = pair(2, ij)  ! on mol 2
            ! Coulomb force and E by other Drudes
            dx = (xyzdr1(1, i1) - xyzdr2(1, i2))
            dy = (xyzdr1(2, i1) - xyzdr2(2, i2))
            dz = (xyzdr1(3, i1) - xyzdr2(3, i2))
            r2 = dx*dx + dy*dy + dz*dz
            rab = sqrt(r2)
            ! rabd=rab+r0(i2,i1)/r2
            rabd = rab + damp
            qq = qdr1(i1)*qdr2(i2)
            edr = edr + qq/rabd
            oner = qq/(rabd*rabd*rab)
            gdr1(1, i1) = gdr1(1, i1) - dx*oner
            gdr1(2, i1) = gdr1(2, i1) - dy*oner
            gdr1(3, i1) = gdr1(3, i1) - dz*oner
            gdr2(1, i2) = gdr2(1, i2) + dx*oner
            gdr2(2, i2) = gdr2(2, i2) + dy*oner
            gdr2(3, i2) = gdr2(3, i2) + dz*oner
            ! Coulomb force and E on Drudes by atoms
            dx = (xyz1(1, i1) - xyzdr2(1, i2))
            dy = (xyz1(2, i1) - xyzdr2(2, i2))
            dz = (xyz1(3, i1) - xyzdr2(3, i2))
            r2 = dx*dx + dy*dy + dz*dz
            rab = sqrt(r2)
            ! rabd=rab+r0(i2,i1)/r2
            rabd = rab + damp
            qq = q1(i1)*qdr2(i2)
            edr = edr + qq/rabd
            oner = qq/(rabd*rabd*rab)
            gdr2(1, i2) = gdr2(1, i2) + dx*oner
            gdr2(2, i2) = gdr2(2, i2) + dy*oner
            gdr2(3, i2) = gdr2(3, i2) + dz*oner
            ! and reverse
            dx = (xyz2(1, i2) - xyzdr1(1, i1))
            dy = (xyz2(2, i2) - xyzdr1(2, i1))
            dz = (xyz2(3, i2) - xyzdr1(3, i1))
            r2 = dx*dx + dy*dy + dz*dz
            rab = sqrt(r2)
            ! rabd=rab+r0(i2,i1)/r2
            rabd = rab + damp
            qq = q2(i2)*qdr1(i1)
            edr = edr + qq/rabd
            oner = qq/(rabd*rabd*rab)
            gdr1(1, i1) = gdr1(1, i1) + dx*oner
            gdr1(2, i1) = gdr1(2, i1) + dy*oner
            gdr1(3, i1) = gdr1(3, i1) + dz*oner
         end do

      elseif (kode .eq. 2) then ! E only
        ! spring force and E
         espring = 0
         do i = 1, n1
            dx = (xyzdr1(1, i) - xyz1(1, i))
            dy = (xyzdr1(2, i) - xyz1(2, i))
            dz = (xyzdr1(3, i) - xyz1(3, i))
            rab = dx*dx + dy*dy + dz*dz
            dum = par_drude_fc*gam(at1(i))
            espring = espring + dum*rab
         end do
         do i = 1, n2
            dx = (xyzdr2(1, i) - xyz2(1, i))
            dy = (xyzdr2(2, i) - xyz2(2, i))
            dz = (xyzdr2(3, i) - xyz2(3, i))
            rab = dx*dx + dy*dy + dz*dz
            dum = par_drude_fc*gam(at2(i))
            espring = espring + dum*rab
         end do

         edr = 0
         do ij = 1, npair
            i1 = pair(1, ij)  ! on mol 1
            i2 = pair(2, ij)  ! on mol 2
            ! Coulomb E by other Drudes
            dx = (xyzdr1(1, i1) - xyzdr2(1, i2))
            dy = (xyzdr1(2, i1) - xyzdr2(2, i2))
            dz = (xyzdr1(3, i1) - xyzdr2(3, i2))
            r2 = dx*dx + dy*dy + dz*dz
            rab = sqrt(r2)
            ! rabd=rab+r0(i2,i1)/r2
            rabd = rab + damp
            qq = qdr1(i1)*qdr2(i2)
            edr = edr + qq/rabd
            ! Coulomb E on Drudes by atoms
            dx = (xyz1(1, i1) - xyzdr2(1, i2))
            dy = (xyz1(2, i1) - xyzdr2(2, i2))
            dz = (xyz1(3, i1) - xyzdr2(3, i2))
            r2 = dx*dx + dy*dy + dz*dz
            rab = sqrt(r2)
            ! rabd=rab+r0(i2,i1)/r2
            rabd = rab + damp
            qq = q1(i1)*qdr2(i2)
            edr = edr + qq/rabd
            ! and reverse
            dx = (xyz2(1, i2) - xyzdr1(1, i1))
            dy = (xyz2(2, i2) - xyzdr1(2, i1))
            dz = (xyz2(3, i2) - xyzdr1(3, i1))
            r2 = dx*dx + dy*dy + dz*dz
            rab = sqrt(r2)
            ! rabd=rab+r0(i2,i1)/r2
            rabd = rab + damp
            qq = q2(i2)*qdr1(i1)
            edr = edr + qq/rabd
         end do

      end if

      ec = edr + espring

   end subroutine indeg

!************************************************************************
!* true electrostatic interaction for two atoms with squared distance
!* r2, distance r,
!* density exponents a,b
!* nuclear (valence) charges z1,z2
!* electron numbers n1,n2 (i.e. the atomic charge is q=z-n)
!* the density is assumed to be spherical
!************************************************************************
   subroutine truees(m1, m2, i, j, r, r2, den1, den2, z1, z2, n1, n2, es)
      integer, intent(in) :: i, j, m1, m2 ! atoms, atom numbers
      real(wp), intent(in) :: r, r2
      real(wp), intent(in) :: z1, z2, n1, n2  ! val charge, val number of el
      real(wp), intent(in) :: den1(2, 4, m1), den2(2, 4, m2)
      real(wp), intent(out) :: es

      real(wp) :: apb, cc, cc1, cc2, apb1, apb2, t, f02, vv, f1, f2
      real(wp) :: vv1, vv2, v1, v2, abcd, eabcd
      integer :: ip, jp, kp, lp, np
      real(wp), parameter :: pi = 3.14159265358979_wp
      real(wp), parameter :: tpi = 6.28318530717958_wp
      real(wp), parameter :: tpi25 = 34.98683665524963_wp

      ! set 1s density functions with 4 prims = np
      np = 4

      ! nuc-nuc
      es = z1*z2/r
      ! e-nuc, nuc-e
      v1 = 0
      v2 = 0
      do ip = 1, np
         do jp = 1, ip - 1
            apb1 = den1(1, ip, i) + den1(1, jp, i)
            cc1 = den1(2, ip, i)*den1(2, jp, i)
            apb2 = den2(1, ip, j) + den2(1, jp, j)
            cc2 = den2(2, ip, j)*den2(2, jp, j)
            call get_f02(apb1*r2, f02)
            v1 = v1 + f02*cc1*tpi/apb1
            call get_f02(apb2*r2, f02)
            v2 = v2 + f02*cc2*tpi/apb2
         end do
         apb1 = den1(1, ip, i) + den1(1, ip, i)
         cc1 = den1(2, ip, i)*den1(2, ip, i)
         apb2 = den2(1, ip, j) + den2(1, ip, j)
         cc2 = den2(2, ip, j)*den2(2, ip, j)
         call get_f02(apb1*r2, f02)
         v1 = v1 + 0.5*f02*cc1*tpi/apb1
         call get_f02(apb2*r2, f02)
         v2 = v2 + 0.5*f02*cc2*tpi/apb2
      end do
      v1 = 2.0d0*v1
      v2 = 2.0d0*v2
      es = es - v1*z2*n1 - v2*z1*n2
      ! e-e
      vv = 0
      do ip = 1, np
         do jp = 1, ip
            f1 = 2.0d0
            if (ip .eq. jp) f1 = 1.0d0
            apb1 = den1(1, ip, i) + den1(1, jp, i)
            cc1 = den1(2, ip, i)*den1(2, jp, i)*f1
            do kp = 1, np
               do lp = 1, kp - 1
                  apb2 = den2(1, kp, j) + den2(1, lp, j)
                  cc2 = den2(2, kp, j)*den2(2, lp, j)*2.0d0
                  eabcd = apb1*apb2
                  abcd = apb1 + apb2
                  t = r2*eabcd/abcd
                  call get_f02(t, f02)
                  vv = vv + tpi25/(eabcd*dsqrt(abcd))*f02*cc1*cc2
               end do
               apb2 = den2(1, kp, j) + den2(1, kp, j)
               cc2 = den2(2, kp, j)*den2(2, kp, j)
               eabcd = apb1*apb2
               abcd = apb1 + apb2
               t = r2*eabcd/abcd
               call get_f02(t, f02)
               vv = vv + tpi25/(eabcd*dsqrt(abcd))*f02*cc1*cc2
            end do
         end do
      end do
      es = es + n1*n2*vv

   end subroutine truees

   subroutine ovlp(n1, n2, r2ab, den1, den2, sab)
      integer, intent(in) :: n1, n2
      real(wp), intent(in) :: r2ab(n2, n1)
      real(wp), intent(in) :: den1(2, 4, n1), den2(2, 4, n2)
      real(wp), intent(out) :: sab(n2, n1)

      real(wp) :: apb, fn, s, e1, e2, c1, c2
      integer :: i, j, ip, jp, np
      real(wp), parameter :: pi = 3.14159265358979_wp

      np = 4
      sab = 0
      do i = 1, n1
         do j = 1, n2
            if (r2ab(j, i) .gt. 500.) cycle
            s = 0
            do ip = 1, np
               e1 = den1(1, ip, i)
               c1 = den1(2, ip, i)
               do jp = 1, np
                  e2 = den2(1, jp, j)
                  c2 = den2(2, jp, j)
                  apb = 1.0d0/(e1 + e2)
                  s = s + c1*c2*(pi*apb)**1.50d0*dexp(-r2ab(j, i)*e1*e2*apb)
               end do
            end do
            sab(j, i) = s
         end do
      end do

   end subroutine ovlp

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! CT corrections
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   subroutine chrgtransfer(env, n1, n2, at1, at2, q1, q2, qct1, qct2,&
                          &gab1, gab2, alpab, rab, pr, ect)
      type(TEnvironment), intent(inout) :: env
      integer, intent(in) :: n1, n2
      integer, intent(in) :: at1(n1), at2(n2)
      real(wp), intent(inout) :: q1(n1), q2(n2)
      real(wp), intent(in) :: gab1(n1, n1), gab2(n2, n2)
      real(wp), intent(in) :: qct1(n1, 2), qct2(n2, 2)
      real(wp), intent(in) :: rab(n2, n1)
      real(wp), intent(in) :: alpab(n2, n1)
      logical, intent(in) :: pr
      real(wp), intent(out) :: ect

      real(wp) :: r, a(6), u(3, 3), ee(3), jij12, jij21, qq, oner, shift, expo2
      real(wp) :: coup1, coup2, u0, u12, u21, ex, ex1, ex2, tmp, scal, expo
      real(wp) :: q01(n1), q02(n2), dq1, dq2, e, e0, qq0, emo, r0, gfac
      integer :: i, j, ati, atj

      q01 = q1
      q02 = q2

      shift = 0.37  ! orbital gap shift a la sTDA-xTB 0.45
      expo = 2.9   ! R coupling dep. 3.2
      scal = 0.02  ! off diag scaling 0.03
      expo2 = 100.  ! gap coupling dep.
      gfac = 1.0

      coup1 = 0
      coup2 = 0
      do i = 1, n1
         do j = 1, n2
            r = rab(j, i)
            if (r .gt. 20.0d0) cycle  ! cut-off
            ex = exp(-expo*(r/alpab(j, i))**0.5d0)
            coup1 = coup1 + qct1(i, 1)*qct2(j, 2)*ex            ! Fock coupling 12
            coup2 = coup2 + qct2(j, 1)*qct1(i, 2)*ex            ! Fock coupling 21
         end do
      end do

      a(1) = 0.0d0
      ex1 = exp(-expo2*(elumo(2) - ehomo(1))**2)
      if (elumo(2) - ehomo(1) .lt. 0) ex1 = 1.
      ex2 = exp(-expo2*(elumo(1) - ehomo(2))**2)
      if (elumo(1) - ehomo(2) .lt. 0) ex2 = 1.
      a(2) = -coup1*scal*100.*ex1
      a(4) = -coup2*scal*100.*ex2
      a(3) = elumo(2) - ehomo(1) + shift  ! single exc. CSF energy CT12
      a(5) = 0.0d0
      a(6) = elumo(1) - ehomo(2) + shift  ! single exc. CSF energy CT21
      call rsp(a, 3, 3, ee, u)
      i = 1
      u0 = u(1, 1)**2
      if (u(1, 2)**2 .gt. u0) i = 2
      if (u(1, 3)**2 .gt. u0) i = 3
      u0 = u(1, i)**2
      u12 = u(2, i)**2
      u21 = u(3, i)**2

      ! corrections to charges
      dq1 = 0
      e = 0
      e0 = 0
      do i = 1, n1
         q1(i) = u0*q1(i) + u12*(q1(i) + qct1(i, 1)) + u21*(q1(i) - qct1(i, 2))
         dq1 = dq1 + q1(i) - q01(i)
      end do
      call esxtb(n1, at1, gab1, q1, e)
      call esxtb(n1, at1, gab1, q01, e0)
      ect = (e - e0)*gfac
      if (pr) then
         write (env%unit, *) ' dq system 1       ', dq1
         write (env%unit, *) ' De system 1 /kcal ', 627.51*(e - e0)
      end if

      dq2 = 0
      e = 0
      e0 = 0
      do i = 1, n2
         q2(i) = u0*q2(i) + u12*(q2(i) - qct2(i, 2)) + u21*(q2(i) + qct2(i, 1))
         dq2 = dq2 + q2(i) - q02(i)
      end do
      call esxtb(n2, at2, gab2, q2, e)
      call esxtb(n2, at2, gab2, q02, e0)
      ect = ect + (e - e0)*gfac

      if (dq1 .gt. 0) then
         emo = -dq1*ehomo(1) + dq1*elumo(2)
      else
         emo = dq1*ehomo(2) - dq1*elumo(1)
      end if
      ect = ect + emo

      if (pr) then
         write (env%unit, *) ' dq system 2       ', dq2
         write (env%unit, *) ' De system 2 /kcal ', 627.51*(e - e0)
         write (env%unit, *) ' De MO       /kcal ', 627.51*emo
      end if

   end subroutine chrgtransfer

! xtb intramolecular ES
   subroutine esxtb(n, at, gab, q, es)
      integer, intent(in) :: n, at(n)
      real(wp), intent(in) :: q(n), gab(n, n)
      real(wp), intent(out) :: es

      real(wp) :: t, gam3(94), qq
      integer :: i, j
      data gam3/& ! PBE values
      &-0.02448, 0.178614, 0.194034, 0.154068, 0.173892, 0.16716, 0.156306,&
      &0.321466, 0.163314, 0.170862, 0.256128, 0.18906, 0.146310, 0.136686,&
      &0.123558, 0.122070, 0.119424, 0.115368, 0.175938, 0.152214, 0.24030,&
      &0.204654, 0.186552, 0.178824, 0.174474, 0.205038, 0.188772, 0.180462,&
      &0.180354, 0.176508, 0.158250, 0.139212, 0.131868, 0.119712, 0.115476,&
      &0.108444, 0.091032, 0.07698, 0.102642, 0.095346, 0.088266, 0.086364,&
      &0.085254, 0.088242, 0.087774, 0.088470, 0.091314, 0.090372, 0.110862,&
      &0.093588, 0.079908, 0.074082, 0.069342, 0.064638, 0.077826, 0.0590214,&
      &0.073614, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000,&
      &0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000,&
      &0.000000, 0.085236, 0.07782, 0.074112, 0.07206, 0.070188, 0.069246,&
      &0.072042, 0.07038, 0.072570, 0.108096, 0.084150, 0.070350, 0.06954,&
      &0.064866, 0.0596874, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000,&
      &0.000000, 0.000000, 0.000000/

      es = 0
      do i = 1, n
         do j = i + 1, n
            es = es + q(i)*q(j)*gab(j, i)
         end do
      end do
      es = es*2.0d0

      t = 0
      do i = 1, n
         qq = q(i)*q(i)
         t = t + gam3(at(i))*q(i)*qq
         es = es + qq*gab(i, i)
      end do
      es = es*0.5d0 + t/3.0d0

   end subroutine esxtb

   subroutine get_f02(ARG, f02)
      real(wp), intent(in) :: ARG
      real(wp), intent(out) :: f02

      real(wp), parameter :: PI = 3.14159265358979_wp

      IF (ARG .GE. 1.0D-10) then
         f02 = 0.50D0*DSQRT(PI/ARG)*DERF(DSQRT(ARG))
         RETURN
      else
         f02 = 1.0D0 - 0.33333333333333D0*ARG
         RETURN
      end if

   end subroutine get_f02

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! RG atom as probe for possible sites in R space
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   subroutine intermole_probe(n1, nl1, at1, q1, c1, cl1, c2, l1, cn1, c6xx, e, eqp)
      integer, intent(in) :: n1, nl1
      integer, intent(in) :: at1(n1)
      integer, intent(in) :: l1(n1*10)
      real(wp), intent(in) :: c2(3)
      real(wp), intent(in) :: q1(n1)
      real(wp), intent(in) :: c1(3, n1)
      real(wp), intent(in) :: cl1(4, n1*10)
      real(wp), intent(in) :: c6xx(n1)
      real(wp), intent(in) :: cn1(n1)
      real(wp), intent(out) :: e, eqp

      integer :: i, j, iat
      real(wp) :: ed, ep
      real(wp) :: r, r0, r2, rr, av, c6, r6, r8, r42, tmpr
      real(wp) :: R06, R08, dc6, t6, t8

      ed = 0
      ep = 0
      eqp = 0
      do i = 1, n1 !cycle over every atom of molA
         iat = at1(i)
         r2 = (c1(1, i) - c2(1))**2 + (c1(2, i) - c2(2))**2 + (c1(3, i) - c2(3))**2
         if (r2 .gt. 5000.0d0) cycle
         r = sqrt(r2)
         eqp = eqp + q1(i)/(r + 0.1)
         r6 = r2*r2*r2
         r42 = rrab(iat, probe_atom_type)
         R06 = r0ab6(iat, probe_atom_type)
         R08 = r0ab8(iat, probe_atom_type)
         dc6 = 1./(r6 + R06) + r42/(r6*r2 + R08)
         ed = ed + dc6*c6xx(i)
         if(directedset%n > 0 .and. directed_type == p_atom_att) then
            ed = ed - directedset%val(i) * (exp(-0.1*((r2-2)**2)))
         end if

         ! ed= disperion energy (sum over atompairs)
         ! Pauli : fit to true IFF potential
         rr = -3.85*sqrt(r2/r42)
         ep = ep + val_e(iat)*(erf(rr) + 1.)/(r + 0.6)
         if(directedset%n > 0 .and. directed_type == p_atom_pot) then
            ep = ep + directedset%val(i) * (1/r2**pot_expo) * pot_scal !Add potential for directed docking
         end if
      end do

      do i = 1, nl1
         r2 = (c2(1) - cl1(1, i))**2 + (c2(2) - cl1(2, i))**2 + (c2(3) - cl1(3, i))**2
         if (r2 .gt. 1000.0d0) cycle
         r = sqrt(r2)
         eqp = eqp + cl1(4, i)/(r + 0.1)
      end do

      e = 8.0d0*ep - ed*0.70d0

      eqp = eqp*0.1  ! 0.1=probe charge

   end subroutine intermole_probe

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! align xyz2(mol2) on xyz1(gridpoint cluster) by minimizing a dispersion type model potential
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
   subroutine alignmol(n1, n2, at1, at2, xyz1, xyz2, coord)
      integer, intent(in) :: n1, n2
      integer, intent(in) :: at1(n1)
      integer, intent(in) :: at2(n2)
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)
      real(wp), intent(out) :: coord(6)

      real(wp), allocatable :: found(:, :), found2(:, :)
      real(wp) :: rr, av, sig, displ(6), e, r1(3), r2(3), dr(3), c2(3, n2), c6i
      real :: f(6)
      integer :: i, j, ii, jj, kk, icycle, maxparent, ndim, maxgen

      maxgen = 20
      maxparent = 50
      ndim = maxparent**2
      allocate (found(7, ndim), found2(7, ndim))
      found = 0
      found2 = 0
      coord = 0

      call cmadock(n1, n1, at1, xyz1, r1)

      displ = 0
      do i = 1, maxparent
         displ(1:3) = r1(1:3)
         call rand6(0.8d0, 0.10d0, 6.28d0, displ)   ! initial random sample
         found(1:6, i) = displ(1:6)
      end do

      do icycle = 1, maxgen

         kk = 0
         do i = 1, maxparent
            do j = 1, maxparent
               kk = kk + 1
               call random_number(f)
              displ(1:6) = found(1:6, i)*f(1:6) + found(1:6, j)*(1.0d0 - f(1:6))
               if (i .ne. j) call rand6(0.8d0, 1.00d0, 0.10d0, displ)   ! mutation only on childs
               call move2(n2, xyz2, c2, displ)
               e = 0
               c6i = float(at1(1))
               do ii = 1, n1
                  do jj = 1, n2
                     rr = (xyz1(1, ii) - c2(1, jj))**2&
                      &+ (xyz1(2, ii) - c2(2, jj))**2&
                      &+ (xyz1(3, ii) - c2(3, jj))**2
                     e = e - c6i*float(at2(jj))/(rr*rr*rr + 1.d+5)
                  end do
               end do
               found2(1:6, kk) = displ(1:6)
               found2(7, kk) = e
            end do
         end do

         call sort6(kk, found2)                              ! and sort for energy

         found = found2                                     ! new set

         av = sum(found(7, 1:maxparent))/float(maxparent)
         sig = 0
         do i = 1, maxparent
            sig = sig + (found(7, i) - av)**2
         end do
         sig = sqrt(sig/float(maxparent - 1))
         if (sig .lt. 0.001d0) exit
      end do

      coord(1:6) = found(1:6, 1)

      deallocate (found, found2)

   end subroutine alignmol

end module xtb_iff_iffenergy

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Wrappers for BLAS
module xtb_mctc_blas_wrap3
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_mctc_blas_level3, only : mctc_gemm, mctc_symm, mctc_syrk, mctc_syr2k, &
      & mctc_trmm, mctc_trsm
   implicit none
   private

   public :: mctc_gemm, mctc_symm, mctc_syrk, mctc_syr2k, mctc_trmm, mctc_trsm


   !> Performs one of the matrix-matrix operations
   !
   !    C := alpha*op( A )*op( B ) + beta*C,
   !
   ! where  op( X ) is one of
   !
   !    op( X ) = X   or   op( X ) = X**T,
   !
   ! alpha and beta are scalars, and A, B and C are matrices, with op( A )
   ! an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
   interface mctc_gemm
      module procedure :: mctc_sgemm323
      module procedure :: mctc_sgemm233
      module procedure :: mctc_sgemm332
      module procedure :: mctc_dgemm323
      module procedure :: mctc_dgemm233
      module procedure :: mctc_dgemm332
   end interface mctc_gemm


contains


subroutine mctc_sgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call mctc_gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine mctc_sgemm323


subroutine mctc_sgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   call mctc_gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine mctc_sgemm233


subroutine mctc_sgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: bmat(:, :, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call mctc_gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine mctc_sgemm332


subroutine mctc_dgemm323(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), cptr(:, :)
   character(len=1) :: tra
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   end if
   cptr(1:size(cmat, 1)*size(cmat, 2), 1:size(cmat, 3)) => cmat
   call mctc_gemm(aptr, bmat, cptr, tra, transb, alpha, beta)
end subroutine mctc_dgemm323


subroutine mctc_dgemm233(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout), contiguous, target :: cmat(:, :, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: bptr(:, :), cptr(:, :)
   character(len=1) :: trb
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   end if
   cptr(1:size(cmat, 1), 1:size(cmat, 2)*size(cmat, 3)) => cmat
   call mctc_gemm(amat, bptr, cptr, transa, trb, alpha, beta)
end subroutine mctc_dgemm233


subroutine mctc_dgemm332(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: bmat(:, :, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), pointer :: aptr(:, :), bptr(:, :)
   character(len=1) :: tra, trb
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
   end if
   if (any(trb == ['n', 'N'])) then
      bptr(1:size(bmat, 1)*size(bmat, 2), 1:size(bmat, 3)) => bmat
   else
      bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   end if
   call mctc_gemm(aptr, bptr, cmat, tra, trb, alpha, beta)
end subroutine mctc_dgemm332


end module xtb_mctc_blas_wrap3

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Version information
module xtb_mctc_version
   implicit none
   public

   include 'xtb_version.fh'

end module xtb_mctc_version

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! read coordinates in au or Ang. if its a xmol file
! redone by S.E. to avoid some input errors. Looks for $coord, ang,
! bohr or number (xmol) in the first line
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine rdcoord(fname,n,xyz,iat)
   use xtb_mctc_global, only : persistentEnv
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_systools
   use xtb_setmod
   implicit none

   character(len=*),intent(in) :: fname
   integer, intent(inout) :: n
   real(wp),intent(out) :: xyz(3,n)
   integer, intent(out) :: iat(n)

   real(wp) :: floats(3),f
   character(len=128) :: line
   character(len=80)  :: strings(3)
   integer  :: j,k,ich,cs,cf,ncheck

   if(index(fname,'.sdf').ne.0)then
      call set_geopref('sdf')
      call rdsdf(fname,n,xyz,iat) ! sdf is not allowed to overwrite charge
      return
   endif

   f=0.0_wp
   call open_file(ich,fname,'r')
   ncheck=0
   rewind(ich)
   do
      read(ich,'(a)',end=200)line
      if(line.ne."") exit
   enddo

   call readline(line,floats,strings,cs,cf)
   if(cf.eq.1.and.floats(1).gt.0) then
      call set_geopref('xmol')
      f=aatoau
      call getline(ich,commentline)
   else if (index(line,'$coord').ne.0) then
      call set_geopref('coord')
      f=1.0_wp
   else if (index(line,'ang').ne.0) then
      f=aatoau
   else if (index(line,'bohr').ne.0) then
      f=1.0_wp
   endif
   if(f.lt.1.0_wp) then
      call persistentEnv%error('Coordinate format not recognized!')
      return
   endif
   do
      read(ich,'(a)',end=200)line
!     print*,trim(line)
      if(index(line,'$').ne.0) exit
      !        if(index(line,'$redu').ne.0) exit
      !        if(index(line,'$user').ne.0) exit
      !        if(index(line,'$end' ).ne.0) exit
      !        if(index(line,'$set' ).ne.0) exit
      call readline(line,floats,strings,cs,cf)
      if(cf.ne.3) cycle
      !        call readl(line,floats,k)
      call elem(strings(1),j)
      if(j.le.0) cycle !ignores dummies and unknown elements
      ncheck=ncheck+1
      xyz(1,ncheck)=floats(1)*f
      xyz(2,ncheck)=floats(2)*f
      xyz(3,ncheck)=floats(3)*f
      iat(ncheck)=j
   enddo

   200 continue

   if (n.ne.ncheck) then
      write(stdout,'(i0,1x,''/='',1x,i0)') n,ncheck
      call persistentEnv%error('reading coord file failed')
   endif
   call close_file(ich)

   !  321 FORMAT(F20.10,F20.10,F20.10,1X,A3,1X,A3,1X,A3,I3,L) !debug output
end subroutine rdcoord

subroutine rdatomnumber(fname,n)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   implicit none
   character(len=*) :: fname
   integer,intent(out) :: n

   real(wp) :: floats(3),f
   character(len=128) :: line
   character(len=128) :: strings(3)
   integer :: j,ich,cs,cf

   f=0.0_wp
   call open_file(ich,fname,'r')
   if(index(fname,'.sdf').ne.0)then
      read(ich,'(a)')
      read(ich,'(a)')
      read(ich,'(a)')
      read(ich,'(i3)') n
      return
   endif
   n=0
   do
      read(ich,'(a)',end=200)line
      if(line.ne."") exit
   enddo
   call readline(line,floats,strings,cs,cf)
   if(cf.eq.1.and.floats(1).gt.0.and.cs.eq.0) then
      f=aatoau
      !         write(*,*)floats(1)
      n=int(floats(1))
      call close_file(ich)
      return
   else if (index(line,'$coord').ne.0) then
      f=1.0_wp
   else if (index(line,'ang').ne.0) then
      f=aatoau
   else if (index(line,'bohr').ne.0) then
      f=1.0_wp
   endif
   if(f.lt.1.0_wp) then
      write(*,*) f
      call raise('E','Coordinate format not recognized!')
   endif
   DO
      read(ich,'(a)',end=200)line
      if(index(line,'$').ne.0) exit
      !        if(index(line,'$redu').ne.0) exit
      !        if(index(line,'$user').ne.0) exit
      !        if(index(line,'$end' ).ne.0) exit
      call readline(line,floats,strings,cs,cf)
      if(cf.ne.3) exit
      call elem(strings(1),j)
      if(j.eq.0) cycle
      n=n+1
   ENDDO

   200 continue

   call close_file(ich)

   !  321 FORMAT(F20.10,F20.10,F20.10,1X,A3,1X,A3,1X,A3,I3,L) !debug output
end subroutine rdatomnumber


!reads a line cuts the at blanks and tabstops and returns all floats and strings in order of occurence
subroutine readline(line,floats,strings,cs,cf)
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp) :: floats(3)
   character(len=*),intent(in) :: line
   character(len=80)  :: strings(3)

   real(wp) :: num
   character(len=80) :: stmp,str
   character(len=1)  :: digit
   integer  :: i,ty,cs,cf

   stmp=''
   cs=1
   cf=1
   strings(:)=''
   do i=1,len(trim(line))
      digit=line(i:i)
      if(digit.ne.' '.and.digit.ne.char(9)) then  !should exclude tabstops and blanks, 9 is ascii code for tab
         stmp=trim(stmp)//trim(digit)
      elseif(stmp.ne.'')then
         call checktype(stmp,num,str,ty)      !get type of string, 0=number, 1=character
         if(ty.eq.0) then
            floats(cf)=num
            cf=cf+1
         elseif(ty.eq.1) then
            strings(cs)=str
            cs=cs+1
         else
            write(stdout, &
               & '(''readline: problem in checktype, must abort'')')
            exit
         endif
         stmp=''
      endif
      if(i.eq.len(trim(line))) then  !special case: end of line
         call checktype(stmp,num,str,ty)
         if(ty.eq.0) then
            floats(cf)=num
            cf=cf+1
         elseif(ty.eq.1) then
            strings(cs)=str
            cs=cs+1
         else
            write(stdout, &
               & '(''readline: problem in checktype, must abort'')')
            exit
         endif
         stmp=''
      endif
   enddo
   cs=cs-1
   cf=cf-1
end subroutine readline

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! read coordinates, xyz only
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine rdxyz(fname,n,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   implicit real(wp) (a-h,o-z)
   integer, intent(in)  :: n
   real(wp),intent(out) :: xyz(3,n)
   character(len=128)   :: line
   character(len=*),intent(in) :: fname
   real(wp) :: xx(10)

   call open_file(ich,fname,'r')

   if(index(fname,'xyz').ne.0)then
      read(ich,'(a)')line
      read(ich,'(a)')line
      do i=1,n
         read(ich,'(a)')line
         call readl(line,xx,nn)
         xyz(1:3,i)=xx(1:3)
      enddo
      xyz = xyz * aatoau
   else
      read(ich,'(a)')line
      do i=1,n
         read(ich,'(a)')line
         call readl(line,xx,nn)
         xyz(1:3,i)=xx(1:3)
      enddo
   endif

   call close_file(ich)
end subroutine rdxyz

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! read sdf coordinate file
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine rdsdf(fname,n,xyz,iat)
   use xtb_mctc_global, only : persistentEnv
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_systools
   use xtb_setmod
   implicit none
   integer, intent(inout) :: n
   real(wp),intent(out) :: xyz(3,n)
   integer, intent(out) :: iat(n)
   character(len=128)   :: line
   character(len=*),intent(in)  :: fname
   character(len=:),allocatable :: wfile

   real(wp) :: xx(20)
   character(len=20)   :: chdum
   integer  :: nn,i,j,ich,idum
   logical  :: exist

   idum=0
   call open_file(ich,fname,'r')

   call getline(ich,molnameline)
   read(ich,'(a)')!skip
   call getline(ich,commentline)
   read(ich,'(i3)') n

   do i=1,n
      read(ich,'(a)')line
      call readl(line,xx,nn)
      call elem(line,j)
      iat(i) = j
      xyz(1:3,i)=xx(1:3)
   enddo

   xyz = xyz * aatoau

   100 read(ich,'(a)',end=200)line
   if(index(line,'$$$$').ne.0) goto 200
   if(index(line,'M  CHG').ne.0) then
      call readl(line,xx,nn)
      idum=idum+idint(xx(nn))
   endif
   goto 100
   200 continue
   if (idum.ne.0) then
      write(chdum,'(i0)') idum
      call set_chrg(persistentEnv, trim(chdum))
      if (idum.ne.set%ichrg) then
         call persistentEnv%warning('sdf input attempted to set charge, '//&
            &'but variables is already locked')
      endif
   endif

   call close_file(ich)

end subroutine rdsdf

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the electronegativity equilibration model
module xtb_xtb_eeq
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : mctc_dot, mctc_symv
   use xtb_mctc_lapack, only : lapack_sytrf, lapack_sytri
   use xtb_mctc_la, only : contract
   use xtb_type_coulomb, only : TCoulomb
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   implicit none
   private

   public :: TENEquilibration, init


   !> Electronegativity equilibration model
   type :: TENEquilibration

      !> Electronegativity of each species
      real(wp), allocatable :: chi(:, :)

      !> Coordination number dependence of each species
      real(wp), allocatable :: kcn(:, :)

      !> Chemical hardness of each species
      real(wp), allocatable :: gam(:, :)

      !> Solver for the linear system
      procedure(solve), nopass, pointer :: solve_lineq => null()

      !> Inversion of the linear system (for response)
      procedure(solve), nopass, pointer :: invert_lineq => null()

   contains

      !> Evaluate charge equilibration model
      procedure :: chargeEquilibration

   end type TENEquilibration


   !> Initialize equilibration model
   interface init
      module procedure :: initENEquilibration
      module procedure :: initENEquilibrationAtomic
   end interface init


   abstract interface
   !> Interface to a solver for linear systems
   subroutine solve(env, mat, rhs, vec)
   import :: wp, TEnvironment

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Matrix containing the linear system, might contain inverse on exit
   real(wp), intent(inout) :: mat(:, :)

   !> Right hand side of the linear system
   real(wp), intent(in) :: rhs(:)

   !> Solution vector of the linear system
   real(wp), intent(out), target :: vec(:)

   end subroutine solve
   end interface


contains


!> Initialize equilibration model form parameters
subroutine initENEquilibrationAtomic(self, env, chi, kcn, gam, num)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_initENEquilibrationAtomic'

   !> Instance of the equilibration model
   type(TENEquilibration), intent(out) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Electronegativity of each species
   real(wp), intent(in) :: chi(:)

   !> Coordination number dependence of each species
   real(wp), intent(in), optional :: kcn(:)

   !> Chemical hardness of each species
   real(wp), intent(in), optional :: gam(:)

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   integer :: ii

   if (present(num)) then
      allocate(self%chi(1, size(num)))
      do ii = 1, size(num)
         self%chi(1, ii) = chi(num(ii))
      end do
   else
      self%chi = reshape(chi, [1, size(chi)])
   end if

   self%solve_lineq => solve_sysv
   self%invert_lineq => solve_sytri

   if (present(kcn)) then
      if (any(shape(kcn) /= shape(chi))) then
         call env%error("Cannot initialize CN dependence of EN", source)
         allocate(self%kcn(1, size(self%chi)))
         self%kcn(:, :) = 0.0_wp
      else
         if (present(num)) then
            allocate(self%kcn(1, size(num)))
            do ii = 1, size(num)
               self%kcn(1, ii) = kcn(num(ii))
            end do
         else
            self%kcn = reshape(kcn, [1, size(kcn)])
         end if
      end if
   end if

   if (present(gam)) then
      if (any(shape(gam) /= shape(chi))) then
         call env%error("Cannot initialize chemical hardness", source)
         allocate(self%gam(1, size(self%chi)))
         self%gam(:, :) = 0.0_wp
      else
         if (present(num)) then
            allocate(self%gam(1, size(num)))
            do ii = 1, size(num)
               self%gam(1, ii) = gam(num(ii))
            end do
         else
            self%gam = reshape(gam, [1, size(gam)])
         end if
      end if
   end if

end subroutine initENEquilibrationAtomic


!> Initialize equilibration model form parameters
subroutine initENEquilibration(self, env, chi, kcn, gam, num)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_initENEquilibration'

   !> Instance of the equilibration model
   type(TENEquilibration), intent(out) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Electronegativity of each species
   real(wp), intent(in) :: chi(:, :)

   !> Coordination number dependence of each species
   real(wp), intent(in), optional :: kcn(:, :)

   !> Chemical hardness of each species
   real(wp), intent(in), optional :: gam(:, :)

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   integer :: ii

   if (present(num)) then
      allocate(self%chi(size(chi, dim=1), size(num)))
      do ii = 1, size(num)
         self%chi(:, ii) = chi(:, num(ii))
      end do
   else
      self%chi = chi
   end if

   self%solve_lineq => solve_sysv
   self%invert_lineq => solve_sytri

   if (present(kcn)) then
      if (any(shape(kcn) /= shape(chi))) then
         call env%error("Cannot initialize CN dependence of EN", source)
         allocate(self%kcn(size(self%chi, 1), size(self%chi, 2)))
         self%kcn(:, :) = 0.0_wp
      else
         if (present(num)) then
            allocate(self%kcn(size(kcn, dim=1), size(num)))
            do ii = 1, size(num)
               self%kcn(:, ii) = kcn(:, num(ii))
            end do
         else
            self%kcn = kcn
         end if
      end if
   end if

   if (present(gam)) then
      if (any(shape(gam) /= shape(chi))) then
         call env%error("Cannot initialize chemical hardness", source)
         allocate(self%gam(size(self%chi, 1), size(self%chi, 2)))
         self%gam(:, :) = 0.0_wp
      else
         if (present(num)) then
            allocate(self%gam(size(gam, dim=1), size(num)))
            do ii = 1, size(num)
               self%gam(:, ii) = gam(:, num(ii))
            end do
         else
            self%gam = gam
         end if
      end if
   end if

end subroutine initENEquilibration


subroutine chargeEquilibration(self, env, mol, coulomb, cn, dcndr, dcndL, &
      & energy, gradient, sigma, qat, qsh, dqdr, dqdL)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_chargeEquilibration'

   !> Instance of the equilibration model
   class(TENEquilibration), intent(inout) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Instance of the Coulomb evaluator
   class(TCoulomb), intent(inout) :: coulomb

   !> Coordination number
   real(wp), intent(in) :: cn(:)

   !> Derivative of the coordination number w.r.t. Cartesian coordinates
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of the coordination number w.r.t. strain derivatives
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Electrostatic energy
   real(wp), intent(inout), optional :: energy

   !> Molecular gradient
   real(wp), intent(inout), optional :: gradient(:, :)

   !> Strain derivatives
   real(wp), intent(inout), optional :: sigma(:, :)

   !> Atomic partial charges
   real(wp), intent(out), optional :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(out), optional :: qsh(:)

   !> Derivative of the partial charges w.r.t. Cartesian coordinates
   real(wp), intent(out), optional :: dqdr(:, :, :)

   !> Derivative of the partial charges w.r.t. strain derivatives
   real(wp), intent(out), optional :: dqdL(:, :, :)

   real(wp), allocatable :: jmat(:, :), inv(:, :)
   real(wp), allocatable :: djdr(:, :, :), djdtr(:, :), djdL(:, :, :)
   real(wp), allocatable :: xvec(:), qvec(:), dxdcn(:), shift(:)
   real(wp), allocatable :: dxdr(:, :, :), dxdL(:, :, :)

   logical :: deriv, response, exitRun
   integer :: nsh, ndim
   integer :: iat, ish, ii, iid
   real(wp) :: tmp

   deriv = present(gradient) .or. present(sigma)
   response = present(dqdr) .or. present(dqdL)
   nsh = sum(coulomb%itbl(2, :))
   ndim = nsh + 1
   allocate(jmat(ndim, ndim))
   allocate(xvec(ndim))
   allocate(qvec(ndim))
   allocate(dxdcn(nsh))

   call coulomb%getCoulombMatrix(mol, jmat)

   do iat = 1, mol%n
      ii = coulomb%itbl(1, iat)
      iid = mol%id(iat)
      do ish = 1, coulomb%itbl(2, iat)
         tmp = self%kcn(ish, iid) / (sqrt(cn(iat)) + 1.0e-14_wp)
         xvec(ii+ish) = -self%chi(ish, iid) + tmp*cn(iat)
         dxdcn(ii+ish) = 0.5_wp*tmp
         jmat(ii+ish, ii+ish) = jmat(ii+ish, ii+ish) + self%gam(ish, iid)
         jmat(ii+ish, ndim) = 1.0_wp
         jmat(ndim, ii+ish) = 1.0_wp
      end do
   end do
   xvec(ndim) = mol%chrg
   jmat(ndim, ndim) = 0.0_wp

   inv = jmat
   if (response) then
      call self%invert_lineq(env, inv, xvec, qvec)
   else
      call self%solve_lineq(env, inv, xvec, qvec)
   end if

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Solving linear equations failed", source)
      return
   end if

   if (present(qat)) then
      qat(:) = 0.0_wp
      do iat = 1, mol%n
         ii = coulomb%itbl(1, iat)
         do ish = 1, coulomb%itbl(2, iat)
            qat(iat) = qat(iat) + qvec(ii+ish)
         end do
      end do
   end if

   if (present(qsh)) then
      qsh(:) = qvec(:nsh)
   end if

   if (present(energy)) then
      shift = xvec
      call mctc_symv(jmat, qvec, shift, alpha=0.5_wp, beta=-1.0_wp)
      energy = energy + mctc_dot(qvec, shift)
   end if

   if (deriv .or. response) then
      allocate(djdr(3, mol%n, ndim))
      allocate(djdtr(3, ndim))
      allocate(djdL(3, 3, ndim))
      allocate(dxdr(3, mol%n, ndim))
      allocate(dxdL(3, 3, ndim))
      call coulomb%getCoulombDerivs(mol, qvec, djdr, djdtr, djdL)
      do iat = 1, mol%n
         ii = coulomb%itbl(1, iat)
         do ish = 1, coulomb%itbl(2, iat)
            dxdr(:, :, ii+ish) = -dxdcn(ii+ish)*dcndr(:, :, iat)
            dxdL(:, :, ii+ish) = -dxdcn(ii+ish)*dcndL(:, :, iat)
         end do
      end do
      dxdr(:, :, ndim) = 0.0_wp
      dxdL(:, :, ndim) = 0.0_wp

      if (present(gradient)) then
         call contract(djdr, qvec, gradient, beta=1.0_wp)
         call contract(dxdr, qvec, gradient, beta=1.0_wp)
      end if

      if (present(sigma)) then
         call contract(djdL, qvec, sigma, beta=1.0_wp)
         call contract(dxdL, qvec, sigma, beta=1.0_wp)
      end if

      if (response) then
         do iat = 1, mol%n
            ii = coulomb%itbl(1, iat)
            do ish = 1, coulomb%itbl(2, iat)
               djdr(:, iat, ii+ish) = djdr(:, iat, ii+ish) + djdtr(:, ii+ish)
            end do
         end do

         if (present(dqdr)) then
            dqdr(:, :, :) = 0.0_wp
            call contract(djdr, inv(:, :nsh), dqdr, alpha=-1.0_wp, beta=0.0_wp)
            call contract(dxdr, inv(:, :nsh), dqdr, alpha=-1.0_wp, beta=1.0_wp)
         end if

         if (present(dqdL)) then
            dqdL(:, :, :) = 0.0_wp
            call contract(djdL, inv(:, :nsh), dqdL, alpha=-2.0_wp, beta=0.0_wp)
            call contract(dxdL, inv(:, :nsh), dqdL, alpha=-1.0_wp, beta=1.0_wp)
         end if
      end if
   end if

end subroutine chargeEquilibration


subroutine solve_sysv(env, mat, rhs, vec)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_sysv'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   real(wp), intent(inout) :: mat(:, :)

   real(wp), intent(in) :: rhs(:)

   real(wp), intent(out), target :: vec(:)

   integer :: lwork, ndim, info
   real(wp), pointer :: ptr(:, :)
   real(wp) :: test(1)
   real(wp), allocatable :: work(:)
   integer, allocatable :: ipiv(:)

   ndim = size(mat, dim=1)
   if (size(mat, dim=2) < ndim .or. size(vec) < ndim .or. size(rhs) < ndim) then
      call env%error("A not so carefully crafted algorithm did mess up", source)
      return
   end if

   vec(:ndim) = rhs(:ndim)
   allocate(ipiv(ndim))
   ptr(1:ndim, 1:1) => vec(1:ndim)

   ! assume work space query, set best value to test after first dsysv call
   call dsysv('l', ndim, 1, mat, ndim, ipiv, ptr, ndim, test, -1, info)
   lwork = int(test(1))
   allocate(work(lwork))

   call dsysv('l', ndim, 1, mat, ndim, ipiv, ptr, ndim, work, lwork, info)

   if (info > 0) then
      call env%error("LAPACK linear equation solver failed", source)
      return
   end if

end subroutine solve_sysv


subroutine solve_sytri(env, mat, rhs, vec)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_sytri'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   real(wp), intent(inout) :: mat(:, :)

   real(wp), intent(in) :: rhs(:)

   real(wp), intent(out), target :: vec(:)

   integer :: ndim
   logical :: exitRun

   ndim = size(mat, dim=1)
   if (size(mat, dim=2) < ndim .or. size(vec) < ndim .or. size(rhs) < ndim) then
      call env%error("A not so carefully crafted algorithm did mess up", source)
      return
   end if

   call invert_sytri(env, mat)

   call env%check(exitRun)
   if (exitRun) return

   call mctc_symv(mat, rhs, vec)

end subroutine solve_sytri


subroutine invert_sytri(env, mat)

   !> Source for error generation
   character(len=*), parameter :: source = 'xtb_eeq_sytri'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   real(wp), intent(inout) :: mat(:, :)

   integer :: ii, jj
   integer :: lwork, ndim, info
   real(wp) :: test(1)
   real(wp), allocatable :: work(:)
   integer, allocatable :: ipiv(:)

   ndim = size(mat, dim=1)
   if (size(mat, dim=2) < ndim) then
      call env%error("A not so carefully crafted algorithm did mess up", source)
      return
   end if

   allocate(ipiv(ndim))

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L', ndim, mat, ndim, ipiv, test, -1, info)
   lwork = int(test(1))
   allocate(work(lwork))

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L', ndim, mat, ndim, ipiv, work, lwork, info)
   if(info > 0)then
      call env%error('Bunch-Kaufman factorization failed', source)
      return
   endif

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in matrix
   ! matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L', ndim, mat, ndim, ipiv, work, info)
   if (info > 0) then
      call env%error('Bunch-Kaufman inversion failed', source)
      return
   endif

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do ii = 1, ndim
      do jj = ii+1, ndim
         mat(ii,jj) = mat(jj,ii)
      enddo
   enddo

end subroutine invert_sytri


end module xtb_xtb_eeq

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> 
module xtb_type_iohandler
   use xtb_mctc_filetypes, only : generateFileMetaInfo
   implicit none
   private

   public :: TIOHandler, init


   type :: TFileStatusEnum
      integer :: readin = 1
      integer :: append = 2
      integer :: written = 3
      integer :: replaced = 4
      integer :: deleted = 5
      integer :: created = 6
   end type

   type(TFileStatusEnum), parameter :: fileStatus = TFileStatusEnum()


   type :: TFileHandle
      character(len=:),allocatable :: name
      integer :: status
      integer :: unit
      logical :: open
   end type TFileHandle

   interface TFileHandle
      module procedure :: initFileHandle
   end interface TFileHandle


   type :: TIOHandler

      character(len=:), allocatable :: namespace

      integer :: count
      type(TFileHandle), allocatable :: log(:)

   contains

      procedure :: readFile
      procedure :: writeFile
      procedure :: readBinary
      procedure :: writeBinary
      procedure :: touchFile
      procedure :: closeFile
      procedure :: deleteFile
      procedure :: list

      procedure, private :: getName
      procedure, private :: pushBack
      procedure, private :: findUnit

   end type TIOHandler


   interface init
      module procedure :: initIOHandler
   end interface init


contains


subroutine initIOHandler(self, namespace)
   type(TIOHandler), intent(out) :: self
   character(len=*), intent(in), optional :: namespace

   if (present(namespace)) then
      self%namespace = namespace
   end if
   self%count = 0
   allocate(self%log(20))

end subroutine initIOHandler


elemental function initFileHandle(name, status, unit, open) result(self)
   character(len=*), intent(in) :: name
   integer, intent(in) :: status
   integer, intent(in) :: unit
   logical, intent(in) :: open
   type(TFileHandle) :: self

   self%name = name
   self%status = status
   self%unit = unit
   self%open = open

end function initFileHandle

!> check for namespace and, if present, add it accordingly to the file name
subroutine getName(self, file, filename)
   class(TIOHandler), intent(inout) :: self
   character(len=*), intent(in) :: file
   character(len=:), allocatable, intent(out) :: filename

   if (allocated(self%namespace)) then
      if (index(file, '/') == 0) then
         if (file(1:1) == '.') then
            filename = '.'//self%namespace//file
         else
            filename = self%namespace//'.'//file
         end if
      else
         filename = file
      end if
   else
      filename = file
   end if

end subroutine getName


subroutine pushBack(self, fileHandle)
   class(TIOHandler), intent(inout) :: self
   type(TFileHandle), intent(in) :: fileHandle
   type(TFileHandle), allocatable :: tmp(:)
   integer :: n

   self%count = self%count + 1
   if (self%count > size(self%log)) then
      n = size(self%log)
      allocate(tmp(n))
      tmp=self%log
      deallocate(self%log)
      allocate(self%log(n + n/2 + 1))
      self%log(1:n) = tmp
      deallocate(tmp)
   end if
   self%log(self%count) = fileHandle

end subroutine pushBack


subroutine findUnit(self, unit, pos)
   class(TIOHandler), intent(in) :: self
   integer, intent(in) :: unit
   integer, intent(out) :: pos
   integer :: i

   pos = 0
   do i = 1, self%count
      if (self%log(i)%open .and. self%log(i)%unit == unit) then
         pos = i
         exit
      end if
   end do

end subroutine findUnit


subroutine list(self, unit)
   class(TIOHandler), intent(in) :: self
   integer, intent(in) :: unit
   character(len=8) :: status
   integer :: i

   if (self%count > 0) then
      write(unit,'(1x,"unit",2x,"open",3x,"action",5x,"filename")')
   end if
   do i = 1, self%count
      select case(self%log(i)%status)
      case(fileStatus%readin);   status = "read    "
      case(fileStatus%written);  status = "written "
      case(fileStatus%deleted);  status = "deleted "
      case(fileStatus%replaced); status = "replaced"
      case(fileStatus%created);  status = "created "
      case default;              status = "unknown "
      end select
      if (self%log(i)%open) then
         write(unit,'(i5,1x,a5,1x,":",1x,a8,3x,a)') &
            & abs(self%log(i)%unit), "true", status, self%log(i)%name
      else
         write(unit,'(i5,1x,a5,1x,":",1x,a8,3x,a)') &
            & abs(self%log(i)%unit), "false", status, self%log(i)%name
      end if
   end do

end subroutine list


subroutine readFile(self, unit, file, iostat)
   class(TIOHandler), intent(inout) :: self
   integer, intent(out) :: unit
   character(len=*), intent(in) :: file
   integer, intent(out), optional :: iostat
   character(len=:), allocatable :: name
   logical :: exist
   integer :: error

   unit = -1
   error = 0

   call self%getName(file, name)
   !$omp critical(io)
   inquire(file=name, exist=exist)

   if (exist) then
      open(file=name, newunit=unit, status='old', action='read', iostat=error)
      if (error == 0) then
         call self%pushBack(TFileHandle(name, fileStatus%readin, unit, .true.))
      else
         unit = -1
      end if
   else
      inquire(file=file, exist=exist)
      if (exist) then
         open(file=file, newunit=unit, status='old', action='read', iostat=error)
         if (error == 0) then
            call self%pushBack(TFileHandle(file, fileStatus%readin, unit, .true.))
         else
            unit = -1
         end if
      else
         error = 1
      end if
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine readFile


subroutine writeFile(self, unit, file, iostat)
   class(TIOHandler), intent(inout) :: self
   integer, intent(out) :: unit
   character(len=*), intent(in) :: file
   integer, intent(out), optional :: iostat
   character(len=:), allocatable :: name
   logical :: exist
   integer :: error

   unit = -1
   error = 0

   call self%getName(file, name)
   !$omp critical(io)
   inquire(file=name, exist=exist)

   open(file=name, newunit=unit, action='write', iostat=error)
   if (error == 0) then
      if (exist) then
         call self%pushBack(TFileHandle(name, fileStatus%replaced, unit, .true.))
      else
         call self%pushBack(TFileHandle(name, fileStatus%written, unit, .true.))
      end if
   else
      unit = -1
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine writeFile


subroutine readBinary(self, unit, file, iostat)
   class(TIOHandler), intent(inout) :: self
   integer, intent(out) :: unit
   character(len=*), intent(in) :: file
   integer, intent(out), optional :: iostat
   character(len=:), allocatable :: name
   logical :: exist
   integer :: error

   unit = -1
   error = 0

   call self%getName(file, name)
   !$omp critical(io)
   inquire(file=name, exist=exist)

   if (exist) then
      open(file=name, newunit=unit, status='old', action='read', &
         & form='unformatted', iostat=error)
      if (error == 0) then
         call self%pushBack(TFileHandle(name, fileStatus%readin, unit, .true.))
      else
         unit = -1
      end if
   else
      inquire(file=file, exist=exist)
      if (exist) then
         open(file=file, newunit=unit, status='old', action='read', &
            & form='unformatted', iostat=error)
         if (error == 0) then
            call self%pushBack(TFileHandle(file, fileStatus%readin, unit, .true.))
         else
            unit = -1
         end if
      else
         error = 1
      end if
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine readBinary


subroutine writeBinary(self, unit, file, iostat)
   class(TIOHandler), intent(inout) :: self
   integer, intent(out) :: unit
   character(len=*), intent(in) :: file
   integer, intent(out), optional :: iostat
   character(len=:), allocatable :: name
   logical :: exist
   integer :: error

   unit = -1
   error = 0

   call self%getName(file, name)
   !$omp critical(io)
   inquire(file=name, exist=exist)

   open(file=name, newunit=unit, action='write', form='unformatted', iostat=error)
   if (error == 0) then
      if (exist) then
         call self%pushBack(TFileHandle(name, fileStatus%replaced, unit, .true.))
      else
         call self%pushBack(TFileHandle(name, fileStatus%written, unit, .true.))
      end if
   else
      unit = -1
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine writeBinary


subroutine touchFile(self, file, iostat)
   class(TIOHandler), intent(inout) :: self
   character(len=*), intent(in) :: file
   integer, intent(out), optional :: iostat
   character(len=:), allocatable :: name
   integer :: unit, error
   logical :: exist

   error = 0

   call self%getName(file, name)
   !$omp critical(io)
   inquire(file=name, exist=exist)
   if (exist) then
      error = 1
   else
      open(file=name, newunit=unit, status='new', iostat=error)
      if (error == 0) then
         call self%pushBack(TFileHandle(name, fileStatus%created, unit, .false.))
         close(unit, iostat=error)
      end if
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine touchFile


subroutine closeFile(self, unit, iostat, remove)
   class(TIOHandler), intent(inout) :: self
   integer, intent(in) :: unit
   integer, intent(out), optional :: iostat
   logical, intent(in), optional :: remove
   integer :: pos, error
   logical :: delete

   if (present(remove)) then
      delete = remove
   else
      delete = .false.
   end if

   error = 0

   call self%findUnit(unit, pos)

   !$omp critical(io)
   if (pos > 0) then
      if (delete) then
         close(unit, iostat=error, status='delete')
      else
         close(unit, iostat=error)
      end if
      if (error == 0) then
         self%log(pos)%open = .false.
         if (delete) then
            self%log(pos)%status = fileStatus%deleted
         end if
      end if
   else
      error = 1
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine closeFile


subroutine deleteFile(self, file, iostat)
   ! Declaration section
   class(TIOHandler), intent(inout) :: self
   character(len=*), intent(in) :: file
   integer, intent(out), optional :: iostat
   character(len=:), allocatable :: name
   integer :: unit
   logical :: exist
   integer :: error
   
   ! Execution section
   unit = -1
   error = 0

   call self%getName(file, name)

   !$omp critical(io)
      !! to restrict execution to 1 thread at a time  
   inquire(file=name, exist=exist)

   if (exist) then
      open(file=name, newunit=unit, status='old', iostat=error)
         !! open existing file withh automatically chosen logical unit number
      if (error == 0) then
         call self%pushBack(TFileHandle(name, fileStatus%deleted, unit, .false.))
            !! to record deletion in log   
         close(unit, status='delete', iostat=error)
      end if
   else
      error = 1
   end if
   !$omp end critical(io)

   if (present(iostat)) then
      iostat = error
   end if

end subroutine deleteFile


end module xtb_type_iohandler

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Self-consistent dispersion energy
module xtb_xtb_dispersion
   use xtb_mctc_accuracy, only : wp
   use xtb_disp_dftd4
   use xtb_disp_ncoord
   use xtb_type_molecule, only : TMolecule
   use xtb_type_dispersionmodel, only : TDispersionModel
   use xtb_xtb_data, only : TDispersionData
   implicit none
   private

   public :: TxTBDispersion, init


   type :: TxTBDispersion

      integer :: ndim

      real(wp) :: g_a

      real(wp) :: g_c

      real(wp) :: wf

      integer, allocatable :: itbl(:)

      real(wp), allocatable :: dispMat(:, :)

      real(wp), allocatable :: gweight(:)

      real(wp), allocatable :: refC6(:, :)

      type(TDispersionModel), pointer :: dispm => null()

   contains

      procedure :: addShift

      procedure :: getEnergy

   end type TxTBDispersion


   interface init
      module procedure :: initDispersion
   end interface init


contains


subroutine initDispersion(self, input, mol)

   type(TxTBDispersion), intent(out) :: self

   type(TDispersionData), intent(in), target :: input

   type(TMolecule), intent(in) :: mol

   real(wp), allocatable :: cn(:)

   integer :: k, iat
   integer, allocatable :: itbl(:)

   self%g_a = input%g_a
   self%g_c = input%g_c
   self%wf = input%wf
   self%dispm => input%dispm
   call d4dim(self%dispm, mol%n, mol%at, self%ndim)

   allocate(self%gweight(self%ndim))
   allocate(self%refC6(self%ndim, self%ndim))
   allocate(self%dispmat(self%ndim, self%ndim))
   allocate(self%itbl(mol%n))
   allocate(cn(mol%n))

   k = 0
   do iat = 1, mol%n
      self%itbl(iat) = k
      k = k + self%dispm%nref(mol%at(iat))
   enddo

   call ncoord_d4(mol%n, mol%at, mol%xyz, cn, thr=1600.0_wp)
   call d4(self%dispm, mol%n, self%ndim, mol%at, self%wf, self%g_a, &
      & self%g_c, cn, self%gweight, self%refC6)
   call build_wdispmat(self%dispm, mol%n, self%ndim, mol%at, self%itbl, mol%xyz, &
      & input%dpar, self%refC6, self%gweight, self%dispmat)

end subroutine initDispersion


subroutine addShift(self, id, qat, atomicShift)

   class(TxTBDispersion), intent(inout) :: self

   integer, intent(in) :: id(:)

   real(wp), intent(in) :: qat(:)

   real(wp), intent(inout) :: atomicShift(:)

   call disppot(self%dispm, size(id), self%ndim, id, self%itbl, qat, self%g_a, self%g_c, &
      & self%dispMat, self%gweight, atomicShift)

end subroutine addShift


subroutine getEnergy(self, id, qat, energy)

   class(TxTBDispersion), intent(inout) :: self

   integer, intent(in) :: id(:)

   real(wp), intent(in) :: qat(:)

   real(wp), intent(out) :: energy

   energy = edisp_scc(self%dispm, size(id), self%ndim, id, self%itbl, qat, self%g_a, &
      & self%g_c, self%dispMat, self%gweight)

end subroutine getEnergy


end module xtb_xtb_dispersion

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_gfnff_setup
  use xtb_gfnff_ini, only : gfnff_ini
  use xtb_gfnff_data, only : TGFFData
  use xtb_gfnff_topology, only : TGFFTopology
  use xtb_gfnff_generator, only : TGFFGenerator
  implicit none
  private
  public :: gfnff_setup, gfnff_input

contains

subroutine gfnff_setup(env,verbose,restart,mol,gen,param,topo,accuracy,version)
  use xtb_restart
  use xtb_type_environment, only : TEnvironment
  use xtb_type_molecule, only : TMolecule
  use xtb_gfnff_param, only : ini, gfnff_set_param
  use xtb_setparam, only : set
  implicit none
  character(len=*), parameter :: source = 'gfnff_setup'
! Dummy
  !integer,intent(in) :: ich
  type(TGFFTopology), intent(inout) :: topo
  type(TGFFGenerator), intent(inout) :: gen
  type(TGFFData), intent(inout) :: param
  integer,intent(in) :: version
  logical,intent(in) :: restart
  logical,intent(in) :: verbose
  real(wp),intent(in) :: accuracy
  type(TMolecule)  :: mol
  type(TEnvironment), intent(inout) :: env
! Stack
  logical            :: ex
  logical            :: success
  logical :: exitRun

  call gfnff_input(env, mol, topo)
  call env%check(exitRun)
  if (exitRun) then
     call env%error("Failed to prepare topology from geometry input", source)
     return
  end if

  call gfnff_set_param(mol%n, gen, param)
  param%dispscale = set%dispscale
  if (restart) then
     call read_restart_gff(env,'gfnff_topo',mol%n,version,success,.true.,topo)
     if (success) then
        write(env%unit,'(10x,"GFN-FF topology read from file successfully!")')
        return
     else
        call env%warning("Could not read topology file.", source)
        call env%check(exitRun)
        if (exitRun) return
     end if
  end if

  call gfnff_ini(env,verbose,ini,mol,gen,param,topo,accuracy)

  call env%check(exitRun)
  if (exitRun) then
     call env%error("Failed to generate topology", source)
     return
  end if

  if (.not.mol%info%two_dimensional) then
     call write_restart_gff(env,'gfnff_topo',mol%n,version,topo)
     call write_gfnff_adjacency('gfnff_adjacency',topo)
  end if

end subroutine gfnff_setup

subroutine gfnff_input(env, mol, topo)
  use xtb_mctc_accuracy, only : wp
  use xtb_type_environment, only : TEnvironment
  use xtb_type_molecule
  use xtb_mctc_filetypes, only : fileType
  use xtb_gfnff_param
  implicit none
  ! Dummy
  type(TMolecule),intent(in) :: mol
  type(TEnvironment), intent(inout) :: env
  type(TGFFTopology), intent(inout) :: topo
  ! Stack
  integer           :: i,j,k
  integer           :: ni
  integer           :: ns
  integer           :: nf
  integer           :: ich
  integer           :: iatom
  integer           :: iresidue
  integer           :: ifrag
  integer           :: ibond
  integer           :: bond_ij(3)
  real(wp)          :: r
  real(wp)          :: dum1
  real(wp)          :: floats(10)
  logical           :: ex
  character(len=80) :: atmp, atmp_0
  character(len=80) :: s(10)
  integer, allocatable :: rn(:)
  ! IO Error
  integer :: err

  if (.not.allocated(topo%nb))       allocate( topo%nb(20,mol%n), source = 0 )
  if (.not.allocated(topo%qfrag))    allocate( topo%qfrag(mol%n), source = 0.0d0 )
  if (.not.allocated(topo%fraglist)) allocate( topo%fraglist(mol%n), source = 0 )

  select case(mol%ftype)
  !--------------------------------------------------------------------
  ! PDB case
  case(fileType%pdb)
    ini = .true.
    ifrag=0
    allocate(rn(mol%n))
    rn(:) = mol%pdb%residue_number
    do iresidue = minval(rn),maxval(rn)
      if (any(iresidue .eq. rn)) then
        ifrag=ifrag+1
        where(iresidue .eq. rn) topo%fraglist = ifrag
      end if
    end do
    deallocate(rn)
    topo%nfrag = maxval(topo%fraglist)
    if (.not.allocated(topo%qpdb)) allocate(topo%qpdb(mol%n))
    do iatom=1,mol%n
      topo%qfrag(topo%fraglist(iatom)) = topo%qfrag(topo%fraglist(iatom)) &
        & + dble(mol%pdb(iatom)%charge)
      topo%qpdb(iatom) = mol%pdb(iatom)%charge
    end do
    if (abs(mol%chrg - sum(topo%qfrag(1:topo%nfrag))) < sqrt(epsilon(1.0_wp))) then
       write(env%unit,'(10x,"charge from pdb residues: ",i0)') &
          & nint(sum(topo%qfrag(1:topo%nfrag)))
    else
       if (allocated(topo%qpdb)) deallocate(topo%qpdb)
       topo%qfrag(1:topo%nfrag) = 0.0_wp
       topo%nfrag = 0
    end if
  !--------------------------------------------------------------------
  ! SDF case
  case(fileType%sdf,fileType%molfile)
    ini = .false.
    topo%nb=0
    topo%nfrag=0
    do ibond = 1, len(mol%bonds)
      call mol%bonds%get_item(ibond,bond_ij)
      i = bond_ij(1)
      j = bond_ij(2)
      ni=topo%nb(20,i)
      ex=.false.
      do k=1,ni
        if(topo%nb(k,i).eq.j) then
          ex=.true.
          exit
        endif
      enddo
      if(.not.ex)then
        topo%nb(20,i)=topo%nb(20,i)+1
        topo%nb(topo%nb(20,i),i)=j
        topo%nb(20,j)=topo%nb(20,j)+1
        topo%nb(topo%nb(20,j),j)=i
      endif
    end do
    do i=1,mol%n
      if(topo%nb(20,i).eq.0)then
        dum1=1.d+42
        k = 0
        do j=1,i
          r=sqrt(sum((mol%xyz(:,i)-mol%xyz(:,j))**2))
          if(r.lt.dum1.and.r.gt.0.001)then
            dum1=r
            k=j
          endif
        enddo
        if (k > 0) then
          topo%nb(20,i)=1
          topo%nb(1,i)=k
        end if
      endif
    end do
    ! initialize qfrag as in the default case
    topo%qfrag(1)=mol%chrg
    topo%qfrag(2:mol%n)=0
  !--------------------------------------------------------------------
  ! General case: input = xyz or coord
  case default
    if (mol%npbc > 0) then
      call env%error("Input file format not suitable for GFN-FF!")
      return
    end if
    ini = .true.
    call open_file(ich,'.CHRG','r')
    if (ich.ne.-1) then
      read(ich,'(a)') atmp_0 ! first line contains total charge
      read(ich,'(a)',iostat=err)atmp  ! second line contains fragment charges
      if (err .ne. 0) atmp=atmp_0
      call close_file(ich)
      call readline(atmp,floats,s,ns,nf)
      topo%qfrag(1:nf)=floats(1:nf)
      if (abs(mol%chrg - sum(topo%qfrag(1:nf))) < sqrt(epsilon(1.0_wp))) then
         write(env%unit,'(10x,"charge from .CHRG file: ",i0)') &
            & nint(sum(topo%qfrag(1:nf)))
      else
         ! ignore fragment charges if they are not consistent with the total charge
         topo%qfrag(1:nf) = 0.0_wp
      end if
    else
      topo%qfrag(1)=mol%chrg
      topo%qfrag(2:mol%n)=0
    end if
  end select

  !-------------------------------------------------------------------

end subroutine gfnff_input


subroutine write_gfnff_adjacency(fname, topo)
   implicit none
   character(len=*),intent(in) :: fname
   integer :: ifile ! file handle
   type(TGFFTopology) :: topo
   integer :: i, j

   call open_file(ifile,fname,'w') 
   ! looping over topology neighboring list
   if (ifile.ne.-1) then
      write(ifile, '(a)') '# indices of neighbouring atoms (max seven)'  
      do i = 1, size(topo%nb, 2)
        write(ifile, '(*(i0:, 1x))') (topo%nb(j, i), j = 1, topo%nb(size(topo%nb, 1), i))
      end do
   end if
   call close_file(ifile)

end subroutine write_gfnff_adjacency


end module xtb_gfnff_setup

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Information on the current input geometry
module xtb_prog_info
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autoamu
   use xtb_mctc_filetypes, only : getFileType
   use xtb_mctc_version, only : version, author, date
   use xtb_io_reader, only : readMolecule
   use xtb_type_environment, only : TEnvironment
   use xtb_type_identitymap, only : TIdentityMap, init
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_reader, only : TReader
   use xtb_param_atomicmass, only : getAtomicMass
   use xtb_prog_argparser, only : TArgParser
   use xtb_splitparam, only : atmass
   implicit none
   private

   public :: xtbInfo


contains


!> Main program of the info submodule
subroutine xtbInfo(env, argParser)

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "prog_info"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Commandline argument parser
   type(TArgParser), intent(inout) :: argParser

   !> Molecular structure data
   type(TMolecule) :: mol

   !> Reader for input files
   type(TReader) :: reader

   !> Identity map for unique species in molecular structure
   type(TIdentityMap) :: idMap

   !> Read in file name
   character(len=:), allocatable :: file

   !> File type
   integer :: ftype

   !> Current run
   integer :: iRun

   !> Number of total runs
   integer :: nRun

   !> Signal from environment to terminate the program
   logical, allocatable :: exitRun(:)

   !> Check for very close distances
   logical :: coldFusion

   !> Determine the number of runs from the files in the command line
   nRun = argParser%countFiles()
   !> No input files are an error
   if (nRun == 0) then
      call env%terminate("No geometry input provided")
   end if

   !> Print an informative banner
   call infoHeader(env%unit)

   !> Save status of each run
   allocate(exitRun(nRun))

   !> Execute runs in order
   do iRun = 1, nRun

      !> Pop the first file from the parser
      call argParser%nextFile(file)
      !> Determine the file type for processing in the reader
      ftype = getFileType(file)
      !> Generate the reader by connecting the file to the instance
      call reader%open(file)
      !> Process the file to obtain the molecular structure data
      call readMolecule(env, mol, reader%unit, ftype)
      !> Close the file, we are done with it here
      call reader%close

      !> Print an informative header for this run
      call runHeader(env%unit, file, iRun, nRun, len(mol))

      call env%check(exitRun(iRun))
      if (exitRun(iRun)) then
         call env%show('Could not read geometry due to')
         cycle
      end if

      !> make sure the geometry summery does not error on splitparam globals
      atmass = getAtomicMass(mol%at) * autoamu ! from splitparam.f90

      !> Intialize and print the identity map
      call init(idMap, mol)
      call generic_header(env%unit, 'Identifiers', 49, 10)
      write(env%unit, '(a)')
      call idMap%writeInfo(env%unit)
      write(env%unit, '(a)')

      !> Check for very small distances in the input geometry
      call check_cold_fusion(env, mol, coldFusion)
      if (coldFusion) then
         call env%error("Some atoms in the geometry are very close", source)
      else
         !> Geometry summary
         call main_geometry(env%unit, mol)
      end if

      call env%check(exitRun(iRun))
      call env%show('Following warnings occurred with this input')

   end do

   if (nRun > 1) then
      write(env%unit, '(72("~"))')
      write(env%unit, '(1x, a, 1x, i0, 1x, a)') "Processed", nRun, "individual inputs"
      if (count(exitRun) > 0) then
         write(env%unit, '(1x, i0, "/", i0, 1x, a, "(", f5.1, "%)")') &
            & count(exitRun), nRun, "inputs failed info check", &
            & real(count(exitRun)*100, wp)/real(nRun, wp)
      end if
      write(env%unit, '(72("~"), /)')
   end if
   if (any(exitRun)) then
      call terminate(1)
   else
      call terminate(0)
   end if


end subroutine xtbInfo


!> Print a header for each new run
subroutine runHeader(unit, file, iRun, nRun, nAtom)

   !> IO unit
   integer, intent(in) :: unit

   !> Read in file name
   character(len=*), intent(in) :: file

   !> Current run
   integer, intent(in) :: iRun

   !> Number of total runs
   integer, intent(in) :: nRun

   !> Number of atoms in this structure
   integer, intent(in) :: nAtom

   if (nRun > 1) then
      write(unit, '(72("~"))')
      write(unit, '(1x, "Run:", t66, i0, "/", i0)') iRun, nRun
      write(unit, '(72("~"))')
   end if
   write(unit, '(1x, "Input:", 1x, a)') file
   write(unit, '(1x, "Number of atoms:", 1x, i0, /)') nAtom

end subroutine runHeader


!> Header for this submodule
subroutine infoHeader(unit)

   !> IO unit
   integer, intent(in) :: unit

   write(unit,'(a)') &
      "      -----------------------------------------------------------",&
      "     |                   =====================                   |",&
      "     |                      x t b - i n f o                      |",&
      "     |                   =====================                   |",&
      "     |                         S. Ehlert                         |",&
      "     |          Mulliken Center for Theoretical Chemistry        |",&
      "     |                    University of Bonn                     |",&
      "      -----------------------------------------------------------",""
   write(unit,'(3x,"*",*(1x,a))') &
      & "xtb version", version, "compiled by", author, "on", date
   write(unit,'(a)')

end subroutine infoHeader


end module xtb_prog_info

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Manipulation of character variables
module xtb_mctc_chartools
   implicit none
   private

   public :: toLowercase


   !> ASCII offset between lowercase and uppercase letters
   integer, parameter :: offset = iachar('A') - iachar('a')


contains


!> Convert input string to lowercase
function toLowercase(str) result(lcStr)

   !> Input string
   character(len=*), intent(in) :: str

   !> Lowercase version of string
   character(len=len_trim(str)):: lcStr

   integer :: ilen, iquote, i, iav, iqc

   ilen = len_trim(str)
   iquote = 0
   lcstr = str

   do i = 1, ilen
      iav = iachar(str(i:i))
      if (iquote == 0 .and. (iav == 34 .or.iav == 39)) then
         iquote = 1
         iqc = iav
         cycle
      end if
      if (iquote == 1 .and. iav==iqc) then
         iquote=0
         cycle
      end if
      if (iquote == 1) cycle
      if (iav >= iachar('A') .and. iav <= iachar('Z')) then
         lcstr(i:i) = achar(iav - offset)
      else
         lcstr(i:i) = str(i:i)
      end if
   end do

end function toLowercase


end module xtb_mctc_chartools

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Coulomb interactions of the PTB method

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

module xtb_ptb_coulomb
#if WITH_TBLITE
   use mctc_env, only: wp
   use mctc_io, only: structure_type

   use tblite_basis_type, only: basis_type
   use tblite_coulomb_charge_effective, only: harmonic_average
   use tblite_blas, only: symv
   use tblite_wavefunction, only: wavefunction_type
   use tblite_scf_potential, only: potential_type

   use dftd4_data_hardness, only: get_hardness

   implicit none
   private

   public :: coulomb_potential

   type :: coulomb_potential
      !> Effective Hubbard parameters
      real(wp), allocatable :: hubbard(:, :, :, :)
      !> effective gams (chemical hardness)
      real(wp), allocatable :: gam(:, :)
      !> Coulomb matrix
      real(wp), allocatable :: cmat(:, :)
      !> Ohno-Klopman contribution
      real(wp) :: cok
      !> Effective Hubbard-Derivatives for third-order contribution
      real(wp), allocatable :: hubbard_derivs(:)
   contains
      procedure :: init
      procedure :: update => get_coulomb_matrix
      procedure :: get_potential
   end type coulomb_potential

contains

   subroutine get_coulomb_matrix(self, mol, bas)
      !> Coulomb type
      class(coulomb_potential), intent(inout) :: self
      !> Molecular structure
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> tmp variables
      integer :: iat, jat, izp, jzp, ii, jj, ish, jsh
      real(wp) :: vec(3), r1, gam, tmp, r12

      !> debug mode
      logical, parameter :: debug = .false.

      !$omp parallel do default(none) schedule(runtime) &
      !$omp shared(mol, self, bas) &
      !$omp private(iat, izp, ii, ish, jat, jzp, jj, jsh, gam) &
      !$omp private(vec, r1, tmp, r12)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = bas%ish_at(iat)
         do jat = 1, iat - 1
            jzp = mol%id(jat)
            jj = bas%ish_at(jat)
            vec = mol%xyz(:, jat) - mol%xyz(:, iat)
            r1 = norm2(vec)
            r12 = r1**2
            do ish = 1, bas%nsh_at(iat)
               do jsh = 1, bas%nsh_at(jat)
                  gam = self%hubbard(jsh, ish, jat, iat)
                  tmp = (self%cok / sqrt(r12 + gam**(-2))) + &  !> Ohno-Klopman average
                     & ((1.0_wp - self%cok) / (r1 + gam**(-1))) !> Mataga-Nishimoto average
                  !$omp atomic
                  self%cmat(jj + jsh, ii + ish) = self%cmat(jj + jsh, ii + ish) + tmp
                  !$omp atomic
                  self%cmat(ii + ish, jj + jsh) = self%cmat(ii + ish, jj + jsh) + tmp
               end do
            end do
         end do
         do ish = 1, bas%nsh_at(iat)
            do jsh = 1, ish - 1
               gam = self%hubbard(jsh, ish, iat, iat)
               !$omp atomic
               self%cmat(ii + jsh, ii + ish) = self%cmat(ii + jsh, ii + ish) + gam
               !$omp atomic
               self%cmat(ii + ish, ii + jsh) = self%cmat(ii + ish, ii + jsh) + gam
            end do
            gam = self%hubbard(ish, ish, iat, iat)
            !$omp atomic
            self%cmat(ii + ish, ii + ish) = self%cmat(ii + ish, ii + ish) + gam 
         end do
      end do

      if (debug) then !##### DEV WRITE #####
         write (*, *) "cmat ..."
         do ish = 1, bas%nsh
            do jsh = 1, bas%nsh
               write (*, '(f13.9)', advance="no") self%cmat(ish, jsh)
            end do
            write (*, *)
         end do
      endif

   end subroutine get_coulomb_matrix

   subroutine init(self, mol, bas, q, gamsh, kqhubb, kok, kthirdoder)
      !> Effective Hubbard parameters
      class(coulomb_potential), intent(inout) :: self
      !> Molecular structure
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Atomic charges
      real(wp), intent(in) :: q(:)
      !> Shell-wise gamma scaling factors
      real(wp), intent(in) :: gamsh(:, :)
      !> Scaling factor for the charge dependent part of the Hubbard parameters
      real(wp), intent(in) :: kqhubb
      !> Ohno-Klopman contribution
      real(wp), intent(in) :: kok
      !> Scaling for third-order contributions
      real(wp), intent(in) :: kthirdoder(:)

      call init_hubbard(self, mol, bas, q, gamsh, kqhubb, kok)
      call init_hubbard_derivs(self, mol, kthirdoder)

   end subroutine init

   subroutine init_hubbard(self, mol, bas, q, gamsh, kqhubb, kok)
      !> Effective Hubbard parameters
      class(coulomb_potential), intent(inout) :: self
      !> Molecular structure
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Atomic charges
      real(wp), intent(in) :: q(:)
      !> Shell-wise gamma scaling factors
      real(wp), intent(in) :: gamsh(:, :)
      !> Scaling factor for the charge dependent part of the Hubbard parameters
      real(wp), intent(in) :: kqhubb
      !> Ohno-Klopman contribution
      real(wp), intent(in) :: kok

      integer :: izp, iat, iid, ish, jsh, jat

      !> Initialize variables
      if (.not. allocated(self%gam)) allocate (self%gam(maxval(bas%nsh_id), mol%nat), source=0.0_wp)
      if (.not. allocated(self%hubbard)) then
         allocate (self%hubbard(maxval(bas%nsh_id), maxval(bas%nsh_id), mol%nat, mol%nat), source=0.0_wp)
      end if
      if (.not. allocated(self%cmat)) then
         allocate (self%cmat(bas%nsh, bas%nsh), source=0.0_wp)
      else
         self%cmat = 0.0_wp
      end if
      self%cok = kok

      !> Atom-individual chemical hardnesses per shell; Eq. 19
      do iat = 1, mol%nat
         iid = mol%id(iat)
         izp = mol%num(iid)
         do ish = 1, bas%nsh_id(iid)
            self%gam(ish, iat) = (1.0_wp + kqhubb * q(iat)) * get_hardness(izp) * &
               & gamsh(ish, iid)
         end do
      end do

      !> Effective Hubbard parameters; Eq. 16
      do iat = 1, mol%nat
         do jat = 1, mol%nat
            self%hubbard(:, :, jat, iat) = 0.0_wp
            do ish = 1, bas%nsh_at(iat)
               do jsh = 1, bas%nsh_at(jat)
                  self%hubbard(jsh, ish, jat, iat) = &
                     & harmonic_average(self%gam(ish, iat), self%gam(jsh, jat))
               end do
            end do
         end do
      end do

   end subroutine init_hubbard

   subroutine init_hubbard_derivs(self, mol, kthirdoder)
      !> Effective Hubbard parameters
      class(coulomb_potential), intent(inout) :: self
      !> Molecular structure
      type(structure_type), intent(in) :: mol
      !> Scaling for third-order contributions
      real(wp), intent(in) :: kthirdoder(:)

      integer :: iat, iid

      !> Third-order on-center electrostatics; Eq. 17
      if (.not. allocated(self%hubbard_derivs)) then
         allocate (self%hubbard_derivs(mol%nat), source=0.0_wp)
      end if
      do iat = 1, mol%nat
         iid = mol%id(iat)
         self%hubbard_derivs(iat) = 2.0_wp * kthirdoder(iid)
      end do

   end subroutine init_hubbard_derivs

   subroutine get_potential(self, wfn, pot)
      !> Coulomb type
      class(coulomb_potential), intent(inout) :: self
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(in) :: wfn
      !> Instance of the density dependent potential
      type(potential_type), intent(inout) :: pot

      call get_potential_secondorder(self, wfn, pot)
      call get_potential_thirdorder(self, wfn, pot)

   end subroutine get_potential

   subroutine get_potential_secondorder(self, wfn, pot)
      !> Coulomb type
      class(coulomb_potential), intent(inout) :: self
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(in) :: wfn
      !> Instance of the density dependent potential
      type(potential_type), intent(inout) :: pot
      !> tmp variables
      integer :: i

      !> debug mode 
      logical, parameter :: debug = .false.

      call symv(self%cmat, wfn%qsh(:, 1), pot%vsh(:, 1), beta=1.0_wp)

      if (debug) then !##### DEV WRITE #####
         write (*, *) "pot%vsh ..."
         do i = 1, size(pot%vsh, 1)
            write (*, *) i, pot%vsh(i,1)
         end do
      endif

   end subroutine get_potential_secondorder

   subroutine get_potential_thirdorder(self, wfn, pot)
      !> Coulomb type
      class(coulomb_potential), intent(inout) :: self
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(in) :: wfn
      !> Instance of the density dependent potential
      type(potential_type), intent(inout) :: pot
      !> tmp variables
      integer :: iat

      !> debug mode 
      logical, parameter :: debug = .false.
      
      do iat = 1, size(wfn%qat, 1)
         pot%vat(iat, 1) = pot%vat(iat, 1) + wfn%qat(iat, 1)**2 * self%hubbard_derivs(iat)
         
         if (debug) then !##### DEV WRITE #####
            write (*, *) "q^2 * self_hubbard_derivs: ",  wfn%qat(iat, 1)**2 * self%hubbard_derivs(iat)
            write (*, *) "qat: ", wfn%qat(iat, 1)
         endif
      
      end do

   end subroutine get_potential_thirdorder

#endif
end module xtb_ptb_coulomb

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine lopt(init, n, no, accr, op, d)
   !
   !     subroutine for boys localization  r.ahlrichs 2/85
   !     to determine vectors |i>, i=1,n
   !     which maximize
   !     f = sum(i,j=1,n)sum(k=1,no) (<i|op(k)|i>-<j|op(k)|j>)**2
   !     equivalent to maximization of
   !     g = sum(i=1,n)sum(k=1,no) <i|op(k)|i>**2 + <j|op(k)|j>**2
   !     equivalent to minimization of
   !     h = sum(i<j)sum(k) <i|op(k)|j>**2
   !     stationarity condition
   !     sum(k) op(ij,k)*(op(ii,k)-op(jj,k)) = 0 all i.ne.j
   !
   use xtb_mctc_accuracy, only : wp
   use xtb_setparam

   implicit real(wp)(a-h,o-z)

   logical init
   integer :: auxi
   real(wp) :: d(n,n)
   real(wp) :: op(n*(n+1)/2,no)
   real(wp) :: auxvec(n)
   real(wp) :: accr
   !DIR$ ASSUME_ALIGNED D: 64
   !DIR$ ASSUME_ALIGNED OP: 64
   !DIR$ ASSUME_ALIGNED auxvec: 64






   !
   !     input
   !           n = dimension of lin. space
   !           no = # of operators in f or g
   !           op(ij,k) matrix representation of k'th operator
   !                symmetric and stored triangular,nn1=n(n+1)/2
   !           thi = rotation threshold (1.-6 to 1.-12 sngl or dbl prc)
   !           nboys = max. nb. of sweeps
   !     result
   !            d contains the solution vectors as columns
   !            op the transformed operators
   !
   a0=0.d0
   a1=1.d0
   a2=2.d0
   a10=10.d0
   aqu=0.25d0
   !   accr=1.d-6 ! originally 10-14 but this setting saves a factor of 3 !
   thi=1.d-10

   first=0

   th=dmax1(thi,accr)
   !
   !     set d to unit matrix
   !
   if(init)then
      if(set%pr_local) write(*,*) 'initialization of trafo matrix to unity'
      do i=1,n
         do j=1,n
            10              d(j,i)=a0-accr*i+accr*i*j
         end do
         20          d(i,i)=a1
      end do
   endif

   if(n.eq.1) return

   nboys=20000
   nn1=n*(n+1)/2

   !
   !     opn = operator norm needed for cut off threshold
   !
   opn=a0
   do k=1,no
      do i=1,nn1
         21          opn=opn+op(i,k)**2
      end do
      22  continue
   end do
   if(opn.eq.a0) return
   opn=dsqrt(opn/dble(nn1*no))*accr

   ths=aqu
   it=0
   do isw=1,nboys
      !
      !     loop over sweeps
      !
      thsw=a0
      ii=1
      ij=2
      do i=2,n
         !
         ii=ii+i
         jj=0
         im1=i-1
         ip1=i+1
         li=ii-i
         do j=1,im1
            !
            !     loop over i,j rotations
            !     maximize sum(k) <i|op(k)|i>**2 + <j|op(k)|j>**2
            !     like in jacobi
            !
            jj=jj+j
            !
            !     get ax , b determining the tan of the rotation angle
            !
            ax=a0
            b=a0
            do k=1,no
               aux1=op(jj,k)-op(ii,k)
               aux2=op(ij,k)
               ax=ax+aux1*aux2
               30                  b=b+aqu*aux1**2-aux2**2
            end do
            !
            !     rotation angle x0
            !
            if (dabs(ax)+dabs(b).lt.opn) go to 100
            x0=aqu*datan2(ax,b)
            thsw=dmax1(thsw,dabs(x0))
            if (dabs(x0).lt.ths) go to 100
            !
            !     rotation
            !
            it=it+1
            !     c=dcos(x0)
            s=dsin(x0)
            s2=s*s
            c2=a1-s2
            c=dsqrt(c2)
            do l=1,n
               aux1=d(l,j)
               d(l,j)=c*d(l,j)+s*d(l,i)
               d(l,i)=c*d(l,i)-s*aux1
               40              continue
            end do
            jm1=j-1
            !     c2=c*c
            !     s2=s*s
            cs=c*s
            c2ms2=c2-s2
            lj=jj-j
            jp1=j+1

            ! !$OMP  PARALLEL PRIVATE (k,l,aux1,aux2,il,jl) &
            ! !$OMP& SHARED(op) &
            ! !$OMP& DEFAULT(SHARED)
            ! !$OMP DO
            do k=1,no
               aux1=op(ii,k)
               aux2=op(jj,k)
               op(ii,k)=aux1*c2+aux2*s2-a2*op(ij,k)*cs
               op(jj,k)=aux1*s2+aux2*c2+a2*op(ij,k)*cs
               op(ij,k)=cs*(aux1-aux2)+op(ij,k)*c2ms2
               if(jm1.le.0) go to 60

               !                   do l=1,jm1
               !                       aux1=c*op(li+l,k)-s*op(lj+l,k)
               !                       op(lj+l,k)=s*op(li+l,k)+c*op(lj+l,k)
               !                       op(li+l,k)=aux1
               !                   end do
               auxvec(1:jm1) = c*op(li+1:li+jm1,k)-s*op(lj+1:lj+jm1,k)
               op(lj+1:lj+jm1,k) = op(lj+1:lj+jm1,k) * c
               op(lj+1:lj+jm1,k) = op(lj+1:lj+jm1,k) + s*op(li+1:li+jm1,k)
               op(li+1:li+jm1,k) = auxvec(1:jm1)



               60                  if (im1.eq.j) go to 80
               jl=jj+j

               do l=jp1,im1
                  aux1=c*op(li+l,k)-s*op(jl,k)
                  op(jl,k)=c*op(jl,k)+s*op(li+l,k)
                  op(li+l,k)=aux1
                  70                          jl=jl+l
               end do


               80                  if (i.eq.n) go to 95
               jl=ii+j
               il=ii+i

               do l=ip1,n
                  aux1=c*op(jl,k)+s*op(il,k)
                  op(il,k)=c*op(il,k)-s*op(jl,k)
                  op(jl,k)=aux1
                  il=il+l
                  90                           jl=jl+l
               end do

               95              continue
            end do
            ! !$OMP END DO
            ! !$OMP END PARALLEL

            100             ij=ij+1
         end do
         110         ij=ij+1
      end do
      !
      !     check convergence
      !
      if (thsw.le.th) go to 210
      ths=dmin1(thsw**2,ths*aqu)
      ths=dmax1(th,ths)
      if(mod(isw,50).eq.0 .AND. set%pr_local)&
         &write(*,'(''iteration'',i7,2x,''convergence'',d16.8)')isw,thsw
      200 continue
   end do
   if(set%pr_local) write (*,300) isw,thsw
   return
   210 if(set%pr_local) write (*,310) isw,thsw

   return
   300 format (/' not converged in',i7,' iterations, threshold :',d16.8)
   310 format (/' converged in',i7,' iterations, threshold : ',d16.8)
end subroutine lopt

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


! principal quantum number of valence shell
pure elemental integer function pqn(at)
  integer,intent(in) :: at
  if(at.le.2)then
     pqn=1
  elseif(at.le.10)then
     pqn=2
  elseif(at.le.18)then
     pqn=3
  elseif(at.le.36)then
     pqn=4
  elseif(at.le.54)then
     pqn=5
  else
     pqn=6
  endif
end function pqn

pure elemental integer function ncore(at)
  integer,intent(in) :: at
  if(at.le.2)then
     ncore=0
  elseif(at.le.10)then
     ncore=2
  elseif(at.le.18)then
     ncore=10
  elseif(at.le.29)then   !zn
     ncore=18
  elseif(at.le.36)then
     ncore=28
  elseif(at.le.47)then
     ncore=36
  elseif(at.le.54)then
     ncore=46
  elseif(at.le.71)then
     ncore=54
  elseif(at.le.79)then
     ncore=68
  elseif(at.le.86)then
     ncore=78
  endif
end function ncore

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the command line argument parser
module xtb_prog_argparser
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_chartools, only : toLowercase
   implicit none
   private

   public :: TArgParser, init


   !> Command line argument
   type :: TArgument

      !> Has the argument been processed
      logical :: unused

      !> Corresponds to an existing file
      logical :: isFile

      !> Looks like a command line flag
      logical :: isFlag

      !> Raw value of the argument
      character(len=:), allocatable :: raw

   end type TArgument


   !> Command line argument parser
   type :: TArgParser
      private

      !> All command line arguments
      type(TArgument), allocatable :: arg(:)

      !> Start of command line flags
      integer :: flagStart

      !> End of command line flags
      integer :: flagEnd

      !> Position of the flag iterator
      integer :: flagPos

   contains

      !> Basic search of argument list
      procedure, private :: findArg

      !> Basic search of argument list, also markes argument as read
      procedure, private :: getArg

      procedure :: countFlags

      procedure :: countFiles

      procedure :: nextFlag

      procedure :: nextFile

      procedure :: nextArg

      procedure :: reset

   end type TArgParser


   !> Initialize command line argument parser
   interface init
      module procedure :: initArgParser
      module procedure :: initArgument
   end interface init


contains


!> Initialized command line argument
subroutine initArgument(self, iArg)

   !> Command argument
   type(TArgument), intent(out) :: self

   !> Position of argument
   integer, intent(in) :: iArg

   integer :: length
   character(len=*), parameter :: numbers = &
      '0123456789.eE+-'
   character(len=*), parameter :: flagchars = &
      'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_-'

   self%unused = .true.

   call get_command_argument(iArg, length=length)
   allocate(character(len=length) :: self%raw)
   call get_command_argument(iArg, self%raw)

   inquire(file=self%raw, exist=self%isFile)
   self%isFlag = index(self%raw, '-') == 1 &  ! starts with a dash
      & .and. verify(self%raw, flagchars) == 0 &  ! looks like a flag
      & .and. verify(self%raw, numbers) > 0  ! but not like a number

end subroutine initArgument


!> Initialize command line argument parser
subroutine initArgParser(self)

   !> Instance of the parser
   type(TArgParser), intent(out) :: self

   integer :: nArg, iArg

   nArg = command_argument_count()
   allocate(self%arg(nArg))

   do iArg = 1, nArg
      call init(self%arg(iArg), iArg)
   end do

   self%flagStart = 1
   iArg = self%getArg('--')
   if (iArg > 0) then
      self%flagEnd = iArg
   else
      self%flagEnd = nArg
   end if

   self%flagPos = 0

end subroutine initArgParser


!> Reset the command line argument parser
subroutine reset(self)

   !> Instance of the parser
   class(TArgParser), intent(inout) :: self

   self%arg%unused = .true.
   self%flagPos = 0

end subroutine reset


!> Count number of unprocessed flags
function countFlags(self) result(nFlags)

   !> Instance of the parser
   class(TArgParser), intent(in) :: self

   !> Number of unprocessed flags
   integer :: nFlags

   nFlags = count(self%arg%unused .and. self%arg%isFlag)

end function countFlags


!> Count number of unprocessed files
function countFiles(self) result(nFiles)

   !> Instance of the parser
   class(TArgParser), intent(in) :: self

   !> Number of unprocessed files
   integer :: nFiles

   nFiles = count(self%arg%unused .and. self%arg%isFile)

end function countFiles


!> Return file name
subroutine nextFlag(self, flag)

   !> Instance of the parser
   class(TArgParser), intent(inout) :: self

   character(len=:), allocatable, intent(out) :: flag

   integer :: iArg

   do iArg = self%flagStart, self%flagEnd
      if (self%arg(iArg)%unused .and. self%arg(iArg)%isFlag) then
         flag = self%arg(iArg)%raw
         self%flagPos = iArg
         self%arg(iArg)%unused = .false.
         exit
      end if
   end do

end subroutine nextFlag


!> Return file name
subroutine nextArg(self, arg)

   !> Instance of the parser
   class(TArgParser), intent(inout) :: self

   character(len=:), allocatable, intent(out) :: arg

   integer :: iArg

   iArg = self%flagPos + 1
   if (iArg <= self%flagEnd) then
      if (self%arg(iArg)%unused .and. .not.self%arg(iArg)%isFlag) then
         self%flagPos = iArg
         arg = self%arg(iArg)%raw
         self%arg(iArg)%unused = .false.
      end if
   end if

end subroutine nextArg


!> Return file name
subroutine nextFile(self, file)

   !> Instance of the parser
   class(TArgParser), intent(inout) :: self

   character(len=:), allocatable, intent(out) :: file

   integer :: iArg

   do iArg = 1, size(self%arg)
      if (self%arg(iArg)%unused .and. self%arg(iArg)%isFile) then
         file = self%arg(iArg)%raw
         self%arg(iArg)%unused = .false.
         exit
      end if
   end do

end subroutine nextFile


!> Basic search of argument list
function findArg(self, arg, iStart, iEnd) result(position)

   !> Instance of the parser
   class(TArgParser), intent(in) :: self

   !> Argument
   character(len=*), intent(in) :: arg

   !> Start position
   integer, intent(in), optional :: iStart

   !> End position
   integer, intent(in), optional :: iEnd

   !> Position of argument
   integer :: position

   integer :: iArg, jStart, jEnd

   if (present(iStart)) then
      jStart = max(1, iStart)
   else
      jStart = 1
   end if

   if (present(iEnd)) then
      jEnd = min(iEnd, size(self%arg))
   else
      jEnd = size(self%arg)
   end if

   position = 0
   do iArg = jStart, jEnd
      if (self%arg(iArg)%unused) then
         if (toLowercase(arg) == toLowercase(self%arg(iArg)%raw)) then
            position = iArg
            exit
         end if
      end if
   end do

end function findArg


!> Basic search of argument list, also markes argument as read
function getArg(self, arg, iStart, iEnd) result(position)

   !> Instance of the parser
   class(TArgParser), intent(inout) :: self

   !> Argument
   character(len=*), intent(in) :: arg

   !> Start position
   integer, intent(in), optional :: iStart

   !> End position
   integer, intent(in), optional :: iEnd

   !> Position of argument
   integer :: position

   position = self%findArg(arg, iStart, iEnd)
   if (position > 0) then
      self%arg(position)%unused = .false.
   end if

end function getArg


end module xtb_prog_argparser

! This file is part of xtb.
!
! Copyright (C) 2022 Christoph Plett
!
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

! Molecule A and B contain always the CMA transformed coords.
! Every structure is saved as array(1:6) where (1:3) are the
! translation of B starting at the origin and (4:6) are the
! rotation angles of molB.

!> Docking implementation for xtb
module xtb_prog_dock
   use xtb_type_environment, only: TEnvironment, init
   use xtb_prog_argparser, only: TArgParser
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_filetypes, only: getFileType, fileType
   use xtb_mctc_timings
   use xtb_mctc_version, only: version, author, date
   use xtb_io_reader, only: readMolecule
   use xtb_type_molecule
   use xtb_type_reader, only: TReader
   use xtb_setparam, only: initrand
   use xtb_gfnff_param, only: gff_print
   use xtb_mctc_systools
   use xtb_setmod
   use xtb_docking_set_module
   use xtb_docking_param
   use xtb_mctc_convert, only: autokcal
   use xtb_iff_data, only: TIFFData
   use xtb_iff_iffini, only: init_iff
   use xtb_iff_iffprepare, only: precomp
   use xtb_iff_iffenergy, only : iff_e
   use xtb_docking_search_nci, only: docking_search
   use xtb_sphereparam, only: sphere, rabc, boxr, init_walls, wpot, maxwalls
   use xtb_constrain_param, only: read_userdata
   use xtb_fixparam, only: init_fix
   use xtb_scanparam, only: init_constr, init_scan, maxconstr, maxscan
   use xtb_embedding, only: init_pcem
   use xtb_splitparam, only: init_split, maxfrag
   use xtb_readin, only : find_new_name, mirror_line, getValue
   use xtb_mctc_global, only : persistentEnv
   use xtb_solv_state
   use xtb_type_identitymap, only : TIdentityMap,init
   implicit none

   private
   public :: xtbDock

contains

!> Entry point for performing non-covalent docking
   subroutine xtbDock(env, argParser)

      !> Source of errors in the main program unit
      character(len=*), parameter :: source = "prog_dock"

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env

      !> Command line arguments
      type(TArgParser), intent(inout) :: argParser

      !> Molecular structure data
      type(TMolecule) :: molA, molB

      !> Combined structure
      type(TMolecule) :: comb

      !> All important variables stored here
      type(TIFFData) :: iff_data

      !> Storage of translational difference of molB and molA (1:3) and rotation angles of molB (4:6)
      real(wp) :: icoord(6)

      type(TReader) :: reader

      !> File names
      character(len=:), allocatable :: fnameA, fnameB, fname, fnam

      !> File types
      integer :: nFiles, ftypeA, ftypeB, ich
      !character(len=:),allocatable :: xcontrol ! instruction file

      !> global instruction file
      character(len=:), allocatable :: xrc

      logical :: exist

      real(wp) :: e, dum, xx(10), zeffqmdff(86) ! various
      real(wp) :: icoord0(6) ! internal coords
      real(wp) :: r(3)
      integer :: i, j, k
      real(wp) :: molA_e, molB_e

      !> Print an informative banner
      call dockingHeader(env%unit)
      !> make sure you cannot blame us for destroying your computer
      call disclamer(env%unit)
      !> Citations
      write(env%unit,'(3x,a)') &
        "Cite this work as:", &
        "* C. Plett, S. Grimme, Angew. Chem. Int. Ed. 2023, 62, e202214477.",&
        "DOI: 10.1002/anie.202214477",&
        ""

      !> Check .CHRG, .UHF
      call check_for_files(env)

      !> Parse arguments
      call parseArguments(env, argParser, fname)
      if (optlvl == 'gfn0') call env%error('GFN0 is not supported for docking')
      if (optlvl == 'gfnff') set%mhset%model = p_modh_gff ! With p_modh_old some problems occur
      nFiles = argParser%countFiles()
      if (nFiles == 0) then
         call env%error("No input file given, so there is nothing to do", source)
         call dockingHelp(env%unit)
      elseif (nFiles == 1) then
         call env%error("Please provide two sets of coordinates, aborting", source)
      else
         call argParser%nextFile(fnameA)
         call argParser%nextFile(fnameB)
         if (allocated(fname)) xcontrol = fname
      end if
      call env%checkpoint("Command line argument parsing failed")

      ! ------------------------------------------------------------------------
      !> read the xtbrc if you can find it (use rdpath directly instead of xfind)
      if (allocated(xcontrol)) call rdcontrol_iff(xcontrol, env, .false.)

      call rdpath(env%xtbpath, '.xtbrc', xrc, exist)
      if (exist) then
         call rdcontrol_iff(xrc, env, .false.)
         call env%checkpoint("Reading '"//xrc//"' failed")
      end if

      call env%checkpoint("Command line argument parsing failed")
      !> Determine the file type for processing in the reader
      ftypeA = getFileType(fnameA)
      !> Generate the reader by connecting the file to the instance
      call reader%open(fnameA)
      !> Process the file to obtain the molecular structure data
      call readMolecule(env, molA, reader%unit, ftypeA)
      !> Close the file, we are done with it here
      call reader%close
      call env%checkpoint("Could not read geometry from '"//fnameA//"'")
      !> Determine the file type for processing in the reader
      ftypeB = getFileType(fnameB)
      !> Generate the reader by connecting the file to the instance
      call reader%open(fnameB)
      !> Process the file to obtain the molecular structure data
      call readMolecule(env, molB, reader%unit, ftypeB)
      !> Close the file, we are done with it here
      call reader%close
      call env%checkpoint("Could not read geometry from '"//fnameB//"'")

      !> Set molecular charges
      molA%chrg = chrg(1)
      molB%chrg = chrg(2)

      !> Set molecular charges
      molA%uhf = uhf(1)
      molB%uhf = uhf(2)

      !> Print current time
      call prdate('S')

      !> Random number initiation
      call initrand

      !> Set some parameter
      call set_iff_param
      fnam = 'xtblmoinfo'

      !> Printout Settings
      call dockingPrintout(env%unit, fnameA, fnameB, molA, molB)

      !> Allocate stuff
      call iff_data%allocateIFFData(molA%n, molB%n)

      !> Get IFF required properties with GFN2 singlepoints
      set%pr_local = .false.
      call start_timing(2)
      write(*,*)
      !MolA
      write (env%unit, *) 'Precomputation of electronic porperties'
      write (env%unit, *) ' For Molecule 1'
      call precomp(env, iff_data, molA, molA_e, 1)
      write (env%unit, *) ' Successful'
      call stop_timing(2)

      !MolB
      write (env%unit, *) ' For Molecule 2'
      call precomp(env, iff_data, molB, molB_e, 2)
      write (env%unit, *) ' Successful'

      !> Special Docking CMA shift
      if (nfrag1 .eq. 0) then
         call cmadock(molA%n, molA%n, molA%at, molA%xyz, r)
      else
         call cmadock(nfrag1, molA%n, molA%at, molA%xyz, r)
      end if
      do i = 1, 3
         molA%xyz(i, 1:molA%n) = molA%xyz(i, 1:molA%n) - r(i)
      end do
      call cmadock(molB%n, molB%n, molB%at, molB%xyz, r)
      do i = 1, 3
         molB%xyz(i, 1:molB%n) = molB%xyz(i, 1:molB%n) - r(i)
      end do

      !> Initialize the IFF energy stuff
      call init_iff(env, iff_data%n1, iff_data%n2, iff_data%at1, iff_data%at2,&
         &          iff_data%neigh, iff_data%xyz1, iff_data%xyz2, iff_data%q1, &
         &          iff_data%q2, iff_data%c6ab, iff_data%z1, iff_data%z2, iff_data%cprob,&
         &          iff_data%nlmo1, iff_data%nlmo2, iff_data%lmo1, iff_data%lmo2,&
         &          iff_data%qdr1, iff_data%qdr2, iff_data%rlmo1, iff_data%rlmo2,&
         &          iff_data%cn1, iff_data%cn2, iff_data%alp1, iff_data%alp2, iff_data%alpab,&
         &          iff_data%den1, iff_data%den2, iff_data%gab1, iff_data%gab2, iff_data%qcm1,&
         &          iff_data%qcm2, iff_data%n, iff_data%at, iff_data%xyz, iff_data%q, icoord, icoord0,&
         &          .false.)


      !> CONSTRAINTS & SCANS
      call init_fix(iff_data%n)
      call init_split(iff_data%n)
      call init_constr(iff_data%n, iff_data%at)
      call init_scan
      call init_walls
      call init_pcem
      !> Read the constrain
      call init(comb,iff_data%at,iff_data%xyz)
      if (allocated(xcontrol)) then
         call read_userdata(xcontrol, env, comb)
         call read_userdata_iff(xcontrol, env, comb)
      end if

      !> For directed docking, repulsive potentials for each atom other than
      !  the defined ones is setup as range dependent on the smallest distance
      !  to these atoms
      if(directedset%n > 0) then
         if(directedset%n > molA%n) call env%error(&
           &"More atoms for directed docking defined than in molecule A", source)
         if (directed_type == p_atom_pot) call get_repulsive_pot(env,iff_data%xyz,comb)
         if (directed_type == p_atom_att) call get_attractive_pot(env,comb)
      end if

      deallocate (comb%at, comb%xyz)

      !------------------------------------------------------
      !> Single Point energy of first 'Cold fusion' structure
      !------------------------------------------------------
      call start_timing(3)
      call iff_e(env, iff_data%n, iff_data%n1, iff_data%n2, iff_data%at1, iff_data%at2,&
                &  iff_data%neigh, iff_data%xyz1, iff_data%xyz2, iff_data%q1, iff_data%q2,&
                & iff_data%c6ab, iff_data%z1, iff_data%z2,&
                & iff_data%nlmo1, iff_data%nlmo2, iff_data%lmo1, iff_data%lmo2, &
                & iff_data%rlmo1, iff_data%rlmo2,&
                & iff_data%qdr1, iff_data%qdr2, iff_data%cn1, iff_data%cn2, iff_data%alp1, &
                & iff_data%alp2, iff_data%alpab, iff_data%qct1, iff_data%qct2, &
                & iff_data%den1, iff_data%den2, iff_data%gab1, iff_data%gab2, &
                & set%verbose, 0, e, icoord)
      write(*,*)
      write(*, '(''Energy of cold fusion in kcal/mol:'', F8.2)') e * autokcal
      call stop_timing(3)

      !----------------
      !> Docking search
      !----------------
      !> First set optimization level in global parameters
      call set_optlvl(env) 
      call docking_search(env, molA, molB, iff_data%n, iff_data%n1, iff_data%n2,&
       iff_data%at1, iff_data%at2, iff_data%neigh, iff_data%xyz1,&
                    & iff_data%xyz2, iff_data%q1, iff_data%q2, iff_data%c6ab,&
                    & iff_data%z1, iff_data%z2,&
                    & iff_data%nlmo1, iff_data%nlmo2, iff_data%lmo1,&
                    & iff_data%lmo2, iff_data%rlmo1, iff_data%rlmo2,&
                    & iff_data%qdr1, iff_data%qdr2, iff_data%cn1, iff_data%cn2, iff_data%alp1,&
                    & iff_data%alp2, iff_data%alpab, iff_data%qct1, iff_data%qct2,&
                    & iff_data%den1, iff_data%den2, iff_data%gab1, iff_data%gab2, molA_e, molB_e,&
                    & iff_data%cprob, e, icoord, comb)
      if(debug) call wrc('screening.coord', iff_data%n1, iff_data%n2, iff_data%at1,&
                        & iff_data%at2, iff_data%xyz1, iff_data%xyz2, icoord)

      call env%checkpoint("Docking submodule")

      ! ------------------------------------------------------------------------
      !  we may have generated some non-fatal errors, which have been saved,
      !  so we should tell the user, (s)he may want to know what went wrong
      call env%show("Runtime exception occurred")
      call raise('F', 'Some non-fatal runtime exceptions were caught,'// &
         &           ' please check:')

      !> make some post processing afterward, show some timings and stuff
      write (env%unit, '(a)')
      write (env%unit, '(72("-"))')
      call stop_timing_run
      call stop_timing(1)
      call prdate('E')
      write (env%unit, '(72("-"))')
      call prtiming(1, 'total')
      call prtiming(2, 'LMO Computation')
      call prtiming(3, 'SP')
      call prtiming(4, 'Searching')
      call prtiming(5, 'ANC optimizer')

      write (env%unit, '(a)')
      call terminate(0)

   end subroutine xtbDock

   subroutine parseArguments(env, args, inputFile)

      !> Name of error producer
      character(len=*), parameter :: source = "prog_docking_parseArguments"

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env

      !> Command line argument parser
      type(TArgParser), intent(inout) :: args

      !> Detailed input file name
      character(len=:), allocatable, intent(out) :: inputFile

      integer :: nFlags, idum
      character(len=:), allocatable :: flag, sec, trd
      real(wp) :: ddum

      !> Defaults
      optlvl = 'gfn2'

      nFlags = args%countFlags()
      call args%nextFlag(flag)
      do while (allocated(flag))
         if (len(flag) > 2 .and. flag(1:1) == '-' .and. flag(1:2) /= '--') then
            call env%warning("the use of '"//flag//"' is discouraged, "// &
               & "please use '-"//flag//"' next time", source)
            flag = '-'//flag
         end if
         select case (flag)
         case default
            call env%warning("Unknown option '"//flag//"' provided", source)

         case ('--help', '-h')
            call dockingHelp(env%unit)
            call terminate(0)

         case ('--dummy')
            write (*, *) 'Dummy option used'

         case ('--verbose')
            set%verbose = .true.
            debug = .true.

         case ('--very%verbose')
            set%veryverbose = .true.

         case ('--cs')
            cssym = .true.

         case ('--onlypocket')
            stack_grid = .false.
            angular_grid = .false.
            pocket_grid = .true.

         case ('-nopocket')
            call set_logicals(env, 'nopocket')

         case ('--pocket')
            call set_logicals(env, 'pocket')

         case ('--onlystack')
            pocket_grid = .false.
            stack_grid = .true.
            angular_grid = .false.

         case ('--nostack')
            call set_logicals(env, 'nostack')

         case ('--stack')
            call set_logicals(env, 'stack')

         case ('--onlyangular')
            pocket_grid = .false.
            stack_grid = .false.
            angular_grid = .true.

         case ('--noangular')
            call set_logicals(env, 'noangular')

         case ('--angular')
            call set_logicals(env, 'angular')

         case ('--org')
            call set_logicals(env, 'org')

         case ('--fast')  ! fast version
            call set_logicals(env, 'fast')

         case ('--qcg')
            call set_logicals(env, 'qcg')

         case ('--noind')
            call set_logicals(env, 'noind')

         case ('--loose')
            call set_logicals(env, 'loose')

         case ('--atm')
            call set_logicals(env, 'atm')

         case ('--stepr')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_docking(env, 'stepr', sec)
            else
               call env%error("Radial step --stepr option is missing", source)
            end if

         case ('--stepa')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_docking(env, 'stepa', sec)
            else
               call env%error("Angular step --stepa option is missing", source)
            end if

         case ('--nfinal')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_docking(env, 'nfinal', sec)
            else
               call env%error("Maxopt in --nfinal option is missing", source)
            end if

         case ('--maxgen')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_docking(env, 'maxgen', sec)
            else
               call env%error("Maxgen in --maxgen option is missing", source)
            end if

         case ('--maxparent')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_docking(env, 'maxparent', sec)
            else
            call env%error("Maxparent in --maxparent option is missing", source)
            end if

         case ('--nstack')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_docking(env, 'nstack', sec)
            else
            call env%error("Argument in --nstack option is missing", source)
            end if

         case ('--etemp')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_scc(env, 'temp', sec)
            else
              call env%error("Temperature in --etemp option is missing", source)
            end if

         case ('--iterations')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_scc(env, 'maxiterations', sec)
            else
          call env%error("Integer argument for --iterations is missing", source)
            end if

         case ('-o', '--opt')
            call set_runtyp('opt')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'optlevel', sec)
            end if

         case ('--cycles')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'maxcycle', sec)
            else
              call env%error("Integer argument for --cycles is missing", source)
            end if

         case ('--optlvl')
            call args%nextArg(sec)
            select case (sec)
            case default
               call env%warning("No optlevel specified, using GFN-FF", source)
            case ('gfn')
               call args%nextArg(trd)
               if (allocated(trd)) then
                  if (trd == '0') then; optlvl = 'gfn0'; call set_gfn(env, 'method', '0'); end if
                  if (trd == '1') then; optlvl = 'gfn1'; call set_gfn(env, 'method', '1'); end if
                  if (trd == '2') then; optlvl = 'gfn2'; call set_gfn(env, 'd4', 'true'); end if
                  if (trd == 'ff') optlvl = 'gfnff'
               else
                  call env%error("No method provided for --gfn option", source)
               end if

            case ('gfn1')
               optlvl = 'gfn1'
               call set_gfn(env, 'method', '1')

            case ('gfn2')
               optlvl = 'gfn2'
               call set_gfn(env, 'd4', 'true')

            case ('gfn0')
               optlvl = 'gfn0'

            case ('gfnff')
               optlvl = 'gfnff'

            case ('gff')
               optlvl = 'gfnff'

            end select

         case ('--gfn')
            call args%nextArg(trd)
            if (allocated(trd)) then
               if (trd == '0') then; optlvl = 'gfn0'; call set_gfn(env, 'method', '0'); end if
               if (trd == '1') then; optlvl = 'gfn1'; call set_gfn(env, 'method', '1'); end if
               if (trd == '2') then; optlvl = 'gfn2'; call set_gfn(env, 'd4', 'true'); end if
               if (trd == 'ff') optlvl = 'gfnff'
            else
               call env%error("No method provided for --gfn option", source)
            end if

         case ('--gfn1')
            optlvl = 'gfn1'
            call set_gfn(env, 'method', '1')
            call env%warning("The use of '"//flag//"' is discouraged, "//&
               & "please use '--gfn 1' next time", source)

         case ('--gfn2')
            optlvl = 'gfn2'
            call set_gfn(env, 'd4', 'true')

         case ('--gfn0')
            optlvl = 'gfn0'
            call set_gfn(env, 'method', '0')
            call env%warning("The use of '"//flag//"' is discouraged, "//&
               & "please use '--gfn 0' next time", source)

         case ('--gfnff')
            optlvl = 'gfnff'

         case ('--gff')
            optlvl = 'gfnff'

         case ('-a', '--acc')
            call args%nextArg(sec)
            if (allocated(sec)) then
               if (getValue(env, sec, ddum)) then
                  if (ddum .lt. 1.e-4_wp) then
                call env%warning("We cannot provide this level of accuracy, "//&
                             & "resetted accuracy to 0.0001", source)
                     acc = 1.e-4_wp
                  else if (ddum .gt. 1.e+3_wp) then
                call env%warning("We cannot provide this level of accuracy, "//&
                             & "resetted accuracy to 1000", source)
                     acc = 1.e+3_wp
                  else
                     acc = ddum
                  end if
               end if
            else
               call env%error("Accuracy is not provided", source)
            end if

         case ('--nfrag1')
            call args%nextArg(sec)
            if (getValue(env, sec, ddum)) nfrag1 = int(ddum)

         case ('--chrg', '--chrg1')
            call args%nextArg(sec)
            if (getValue(env, sec, ddum)) chrg(1) = ddum

         case ('--chrg2')
            call args%nextArg(sec)
            if (getValue(env, sec, ddum)) chrg(2) = ddum

         case ('--uhf', '--uhf1')
            call args%nextArg(sec)
            if (getValue(env, sec, ddum)) uhf(1) = ddum

         case ('--uhf2')
            call args%nextArg(sec)
            if (getValue(env, sec, ddum)) uhf(2) = ddum

         case ('-I', '--input')
            call args%nextArg(inputFile)
            if (.not. allocated(inputFile)) then
               call env%error("Filename for detailed input is missing", source)
            end if

         !> Implicit solvation only works for final optimizations
         case ('-g', '--gbsa')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_gbsa(env, 'solvent', sec)
               call set_gbsa(env, 'alpb', 'false')
               call set_gbsa(env, 'kernel', 'still')
               call args%nextArg(sec)
               if (allocated(sec)) then
                  if (sec == 'reference') then
                     gsolvstate_iff = solutionState%reference
                  else if (sec == 'bar1M') then
                     gsolvstate_iff = solutionState%mol1bar
                  else
                 call env%warning("Unknown reference state '"//sec//"'", source)
                  end if
               end if
            else
               call env%error("No solvent name provided for GBSA", source)
            end if

         case ('--alpb')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_gbsa(env, 'solvent', sec)
               call args%nextArg(sec)
               if (allocated(sec)) then
                  if (sec == 'reference') then
                     gsolvstate_iff = solutionState%reference
                  else if (sec == 'bar1M') then
                     gsolvstate_iff = solutionState%mol1bar
                  else
                 call env%warning("Unknown reference state '"//sec//"'", source)
                  end if
               end if
            else
               call env%error("No solvent name provided for GBSA", source)
            end if

         case ('--ensemble', '--ens')
            call set_logicals(env, 'ensemble')

         end select
         call args%nextFlag(flag)
      end do

   end subroutine parseArguments

   !> Header for this submodule
   subroutine dockingHeader(unit)

      !> IO unit
      integer, intent(in) :: unit

      write (unit, '(a)') &
         "      -----------------------------------------------------------", &
         "     |                   =====================                   |", &
         "     |                          a I S S                          |", &
         "     |                   =====================                   |", &
         "     |               C. Plett, S. Ehlert, S. Grimme              |", &
         "     |          Mulliken Center for Theoretical Chemistry        |", &
         "     |                    University of Bonn                     |", &
         "      -----------------------------------------------------------", ""
      write (unit, '(3x,"*",*(1x,a))') &
         & "xtb-docking algorithm", version, "compiled by", author, "on", date
      write (unit, '(a)')

   end subroutine dockingHeader

   subroutine dockingPrintout(iunit, fnameA, fnameB, molA, molB)
      !$ use omp_lib

      integer, intent(in) :: iunit
      type(TMolecule), intent(in) :: molA, molB
      character(len=:), allocatable, intent(in) :: fnameA, fnameB

      character(len=:), allocatable :: cdum
      integer :: l, err
      real(wp) :: dum5

      write (iunit, '(a)')
      call generic_header(iunit, 'Calculation Setup', 49, 10)
      write (iunit, '(a)')
      if (allocated(cdum)) deallocate (cdum)
      call get_command(length=l)
      allocate (character(len=l) :: cdum)
      call get_command(cdum)
      write (iunit, '(10x,a,":",1x,a)') 'program call               ', cdum
      call rdvar('HOSTNAME', cdum, err)
      if (err .eq. 0) &
         write (iunit, '(10x,a,":",1x,a)') 'hostname                   ', cdum
      ! Number of threads
      !$omp parallel
      !$omp master
      !$ write(iunit,'(10x,a,":",6x,i16)') 'omp threads                ',omp_get_num_threads()
      !$omp end master
      !$omp end parallel
      ! ----------------------------------------------------------------------
      !  print the home and path to check if there are set correctly
      write (iunit, '(10x,a,":",1x,a)') 'coordinate file A          ', fnameA
      write (iunit, '(10x,a,":",1x,a)') 'coordinate file B          ', fnameB
      !  print more specific calculation data
      write (iunit, '(10x,a,":",6x,i16)') 'number of atoms A          ', molA%n
      write (iunit, '(10x,a,":",6x,i16)') 'number of atoms B          ', molB%n
      write (iunit, '(10x,a,":",6x,F16.1)') 'charge of molecule A       ', molA%chrg
      write (iunit, '(10x,a,":",6x,F16.1)') 'charge of molecule B       ', molB%chrg
      write (iunit, '(10x,a,":",6x,i16)') 'spin of molecule A         ', molA%uhf
      write (iunit, '(10x,a,":",6x,i16)') 'spin of molecule B         ', molB%uhf
      call random_number(dum5)
      write (iunit, '(10x,a,":",6x,f16.14)') 'first test random number   ', dum5
      if (set%veryverbose) then
         write (iunit, '(10x,a,":",20x,a)') 'is this your card?         ', "🃓"
      end if
      write (iunit, '(a)')

   end subroutine dockingPrintout

   subroutine dockingHelp(iunit)

      !> IO unit
      integer, intent(in) :: iunit

      write (iunit, '(a)') &
         "Usage: xtb dock <geometry> <geometry> [-options]", &
         "", &
         "<geometry> may be provided as any valid input to xtb", &
         "", &
         "Options:", &
         "", &
         "    --I,--input <file>: Provide an control file", &
         "    --nopocket        : Perform no pocket search [Default]", &
         "    --pocket          : Perform pocket search", &
         "    --onlypocket      : Perform only pocket search", &
         "    --nostack         : Perform no stack search [Default]", &
         "    --stack           : Perform stack search", &
         "    --onlystack       : Perform only stack search", &
         "    --noangular       : Perform no angular search [Default]", &
         "    --angular         : Perform angular search", &
         "    --onlyangular     : Perform only angular search", &
         "    --atm             : Include ATM term in iff Energy", &
      "    --fast            : Faster search, sufficient for small molecules", &
         "    --chrg <real>     : Charge of first molecule", &
         "    --chrg2 <real>    : Charge of second molecule", &
     "    --uhf <real>      : Number of unpaired electrons of first molecule", &
    "    --uhf2 <real>     : Number of unpaired electrons of second molecule", &
         "    --stepr <real>    : Grid step size for rare gas prescreening", &
         "    --stepa <real>    : Grid step size for angular grid in [deg]", &
    "    --nfinal <INT>    : Number of structures that are finally optimized", &
         "    --optlvl <method> : Defines the Method of final optimizations", &
         "    --maxgen <INT>    : Number of structure generation cycles", &
         "    --nstack <INT>    : Number of grid points in one direction of stack search", &
         "    --maxparent <INT> : Number of parents for structure generation", &
         "    --cs              : Decreases the computational costs, if first", &
         "                        geometry is CS symmetric", &
         !   "    --sphere <REAL>   : Spherical wall potential with radius",&
         !   "    --ellips <REAL> <REAL> <REAL> : Ellipsoid wall potential given",&
         !   "                                    with three unit axis radii",&
         ""

   end subroutine dockingHelp

   subroutine check_for_files(env)

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env

      character(len=*), parameter :: source = "iff_file_read"

      integer :: ich, err
      character(len=:), allocatable :: cdum     ! temporary string
      real(wp) :: charge
      integer :: elect

      call open_file(ich, '.CHRG', 'r')
      if (ich .ne. -1) then
         !> Total Charge
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%error('.CHRG is empty!', source)
         else
            if (.not. getValue(env, cdum, charge)) then
               call env%error('.CHRG has a problem')
            end if
         end if
         !> Charge molA
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%warning('.CHRG has only one line!')
         else
            if (getValue(env, cdum, charge)) then
               chrg(1) = charge
            end if
         end if
         !> Charge molB
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%warning('.CHRG has only two lines!')
         else
            if (getValue(env, cdum, charge)) then
               chrg(2) = charge
            end if
         end if

         call close_file(ich)
      end if

      call env%checkpoint("Reading charge from file failed")

      !> Number of unpaired electrons
      call open_file(ich, '.UHF', 'r')
      if (ich .ne. -1) then
         !> Total number
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%error('.UHF is empty!', source)
         end if
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%error('.UHF is empty!', source)
         else
            if (getValue(env, cdum, elect)) then
               uhf(1) = elect
            end if
         end if
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%warning('.UHF has only one line!')
         else
            if (getValue(env, cdum, elect)) then
               uhf(2) = elect
            end if
         end if
         call close_file(ich)
      end if

   end subroutine check_for_files

   subroutine rdcontrol_iff(fname, env, copy_file)
   
      character(len=*), parameter :: source = 'set_rdcontrol'
      character(len=*), intent(in)  :: fname
      type(TEnvironment), intent(inout) :: env
      character(len=:), allocatable :: line
      character(len=:), allocatable :: key
      character(len=:), allocatable :: val
      character(len=:), allocatable :: newname
      logical, intent(in), optional  :: copy_file
      character, parameter :: flag = '$'
      integer :: i
      integer :: id
      integer :: ic
      integer :: ie
      integer :: ncount
      integer :: copy
      integer :: err
      logical :: exist
      logical :: do_copy
      logical :: exitRun

      if (present(copy_file)) then
         do_copy = copy_file
      else
         do_copy = .false.
      end if

      call open_file(id, fname, 'r')
      if (id .eq. -1) then
         call env%warning("could not find '"//fname//"'", source)
         return
      end if

      if (do_copy) then
         newname = find_new_name(fname)
         call open_file(copy, newname, 'w')
      else
         copy = -1 ! deactivate copy in mirror_line
      end if

!  read first line before the readloop starts, I have to do this
!  to avoid using backspace on id (dammit Turbomole format)
      call mirror_line(id, copy, line, err)
      readflags: do
         !  check if there is a $ in the *first* column
         if (index(line, flag) .eq. 1) then
            select case (line(2:))
               ! logical
            case ('fit'); call set_fit; call mirror_line(id, copy, line, err)
            case ('samerand'); call set_samerand; call mirror_line(id, copy, line, err)
            case ('cma'); call set_cma; call mirror_line(id, copy, line, err)
               ! data
            case ('cube'); call rdblock(env, set_cube, line, id, copy, err, ncount)
            case ('write'); call rdblock(env, set_write, line, id, copy, err, ncount)
            case ('gfn'); call rdblock(env, set_gfn, line, id, copy, err, ncount)
            case ('scc'); call rdblock(env, set_scc, line, id, copy, err, ncount)
            case ('opt'); call rdblock(env, set_opt, line, id, copy, err, ncount)
            case ('gbsa'); call rdblock(env, set_gbsa, line, id, copy, err, ncount)
            case ('solvation'); call rdblock(env, set_gbsa, line, id, copy, err, ncount)
            case ('thermo'); call rdblock(env, set_thermo, line, id, copy, err, ncount)
            case ('path'); call rdblock(env, set_path, line, id, copy, err, ncount)
            case ('fix'); call rdblock(env, set_fix, line, id, copy, err, ncount)
            case ('wall'); call rdblock(env, set_wall, line, id, copy, err, ncount)
               maxwalls = maxwalls + ncount
            case ('constrain'); call rdblock(env, set_constr, line, id, copy, err, ncount)
               maxconstr = maxconstr + ncount; constraint_xyz = .true.
            case ('dock'); call rdblock_docking(env, set_docking, line, id, copy, err, ncount)
            case default ! unknown keyword -> ignore, we don't raise them
!           get a new line
               call mirror_line(id, copy, line, err)
            end select
         else ! not a keyword -> ignore
            call mirror_line(id, copy, line, err)
         end if
         !  check for end of file, which I will tolerate as alternative to $end
         if (is_iostat_end(err)) exit readflags
         call env%check(exitRun)
         if (exitRun) then
            call env%error("processing of data group failed", source)
            exit
         end if
      end do readflags

      if (do_copy) call close_file(copy)
      call close_file(id)
   end subroutine rdcontrol_iff

   subroutine read_userdata_iff(fname,env,mol)

      character(len=*), parameter :: source = 'userdata_read'
      type(TEnvironment), intent(inout) :: env
      type(TMolecule), intent(inout) :: mol
      character(len=*),intent(in)  :: fname
      character(len=:),allocatable :: line
      character(len=:),allocatable :: key
      character(len=:),allocatable :: val
      character(len=:),allocatable :: newname
      type(TIdentityMap) :: idMap
      integer :: i
      integer :: id
      integer :: ic
      integer :: ie
      integer :: err
      logical :: exist
      character, parameter :: flag = '$'

      if (set%verbose) then
         write(env%unit,'(72("$"))')
         write(env%unit,'(1x,"CONSTRAINTS & SCANS: DEBUG SECTION")')
         write(env%unit,'(72("$"))')
      endif

      call open_file(id,fname,'r')
      if (id.eq.-1) then
         call env%warning("could not find '"//fname//"'",source)
         return
      endif
      rewind(id) ! not sure if this is necessary

      call init(idMap, mol)

   !  read first line before the readloop starts, I have to do this
   !  to avoid using backspace on id (dammit Turbomole format)
      call getline(id,line,err)
      readflags: do
           !  check if there is a $ in the *first* column
         if (index(line,flag).eq.1) then
            select case(line(2:))
            case('directed'      )
               if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
               call rdblock_docking2(env,set_directed,line,id,mol%n,mol%at,idMap,mol%xyz,err)
            case default ! unknown keyword -> ignore, we don't raise them
               call getline(id,line,err)
            end select
         else ! not a keyword -> ignore
            call getline(id,line,err)
         endif
      !  check for end of file, which I will tolerate as alternative to $end
         if (is_iostat_end(err)) exit readflags
   !     if (index(line,flag_end).ne.0) exit readflags ! compatibility reasons
      enddo readflags

      if (set%verbose) write(env%unit,'(72("$"))')
      call close_file(id)
   end subroutine read_userdata_iff

   subroutine get_repulsive_pot(env,xyz,comb)

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env

      !> Combined structure
      type(TMolecule), intent(in) :: comb
      real(wp), intent(in) :: xyz(3, comb%n)

      real(wp) :: dist, min_dist, rep_pot
      integer :: i, j

      allocate(directedset%val(comb%n),directedset%expo(comb%n), source=0.0_wp)

      ! First get the smalles distance for each atom and saving it into directedset%val
      do i = 1, comb%n
         if(any(i == directedset%atoms)) cycle !Distance for atoms in defined docking region
         min_dist = 0.0_wp
         do j = 1, directedset%n
            dist = sqrt((xyz(1,i)-xyz(1,directedset%atoms(j)))**2 &
                 & +(xyz(2,i)-xyz(2,directedset%atoms(j)))**2 &
                 & +(xyz(3,i)-xyz(3,directedset%atoms(j)))**2)
            if(min_dist == 0.0_wp) then
               min_dist = dist
            elseif (dist < min_dist) then
               min_dist = dist
            end if
         end do
         directedset%val(i) = min_dist
      end do
      !> Changing the distance to a repulsive potential sitting on every atom other then
      !  the defined docking atoms. This potentail is a damped exponential increase.
      !  It is later in the energy calculation and RG screening added in sitance depdence to
      !  docked molecule via 1/r²
      do i=1, comb%n
         if(any(i == directedset%atoms)) cycle !Potential zero for atoms in defined docking region
         dist = directedset%val(i)
         rep_pot = 0.1*erf(0.07 * dist - 0.28) !Potential starts at distance of 4
         if(rep_pot < 0.0_wp) rep_pot = 0.0_wp
         directedset%val(i) = rep_pot !Overwrite distance with repulsive Potential
      end do
   end subroutine get_repulsive_pot

   subroutine get_attractive_pot(env,comb)

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env

      !> Combined structure
      type(TMolecule), intent(in) :: comb
      integer :: i

      allocate(directedset%val(comb%n),directedset%expo(comb%n), source=0.0_wp)

      ! First get the smalles distance for each atom and saving it into directedset%val
      do i = 1, comb%n
         if(any(i == directedset%atoms)) then
           directedset%val(i) = attractive_pot !attractive pot is negative
         else 
           directedset%val(i) = 0.0_wp
         end if
      end do
   end subroutine get_attractive_pot

end module xtb_prog_dock

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_shake
   use xtb_mctc_accuracy, only : wp
   use xtb_setparam, only: set
   use xtb_param_atomicrad, only : atomicRad
   implicit none
   private :: atomicRad
   integer, parameter :: ndim = 100000
   !integer :: shake_mode
   integer :: ncons = 0
   integer :: nconsu = 0
   integer :: conslistu(2,ndim)
   integer, allocatable :: conslist(:,:)
   real(wp),  allocatable :: distcons(:)
   real(wp),  allocatable :: dro(:,:)
   real(wp),  allocatable :: dr (:,:)
   integer, parameter :: maxcyc = 250
   real(wp), parameter :: tolshake = 1.d-7

   integer, private, parameter :: metal(1:86) = [&
      & 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, &
      & 1, 0, 0, 0, 0, 0]

contains

subroutine init_shake(nat,at,xyz,wbo)
   use xtb_mctc_convert, only : autoaa
   use xtb_fixparam, only : shakeset
   implicit none
   integer :: nat,at(nat)
   integer :: nbond
   real(wp)  :: xyz(3,nat)
   real(wp)  :: wbo(nat,nat)
   integer :: iat,jat,i,j,jmin
   real(wp)  :: minrij,rij,wthr
   real(wp)  :: drij(3)

   integer list(nat*(nat+1)/2),lin,ij
   real(wp) rco
   logical metalbond,rcut

   nconsu=0
   ! list of atoms interpreted as pairs: i1 j1 i2 j2 i3 j3 ....
   ! taken from fixb input
   if(shakeset%n.gt.0)then
      do i = 1, shakeset%n, 2
         nconsu = nconsu + 1
         conslistu(1,nconsu) = shakeset%atoms(i)
         conslistu(2,nconsu) = shakeset%atoms(i+1)
         write(*,*) 'SHAKE user input constraining bond ', &
            &      conslistu(1:2,nconsu)
      enddo
      !        switch of additional potential
   endif

   ! constrain X-H only
   if(set%shake_mode.eq.1)then
      do i = 1, nat
         if(at(i).eq.1) then
            minrij=1000.d0
            do j = 1, nat
               if(j.ne.i)then
                  rij=(xyz(1,i)-xyz(1,j))**2+(xyz(2,i)-xyz(2,j))**2+(xyz(3,i)-xyz(3,j))**2
                  if(rij.lt.minrij) then
                     minrij=rij
                     jmin=j
                  endif
               endif
            enddo
            if(at(jmin).eq.1) then
               if(jmin.gt.i) then
                  nconsu = nconsu + 1
                  conslistu(1,nconsu) = i
                  conslistu(2,nconsu) = jmin
               endif
            else
               nconsu = nconsu + 1
               conslistu(1,nconsu) = i
               conslistu(2,nconsu) = jmin
            endif
         endif
      enddo
   endif
   ! all bonds
   if(set%shake_mode.eq.2)then
      list=0
      do i = 1, nat
         do j =1, nat
            if(i.eq.j) cycle
            rij=(xyz(1,i)-xyz(1,j))**2+(xyz(2,i)-xyz(2,j))**2+(xyz(3,i)-xyz(3,j))**2
            rco=(atomicRad(at(j))+atomicRad(at(i)))*autoaa
            ij=lin(i,j)
            rcut=0.52917726*sqrt(rij).lt.1.2*rco.and.list(ij).eq.0 ! to consider?
            metalbond=metal(at(i)).eq.1.or.metal(at(j)).eq.1       ! metal bond?
            wthr=0.5  ! WBO threshold. if WBO > thr, the bond is constrained
            if(metalbond) wthr=0.1 ! e.g. K...O in phosphates have WBO around 0.15
            !           write(*,'(2i3,3f10.4)')
            !    .      at(i),at(j),0.52917726*sqrt(rij),rco,wbo(i,j)
            !           if(wbo(i,j).lt.wthr.and.wbo(i,j).gt.0.3.and.rcut)       ! warning
            !    .      write(*,*) 'bond slightly below threshold ', i,j,
            !    .                 'not constrained'
            if(rcut.and.wbo(i,j).gt.wthr)then                       ! its relevant
               metalbond=metal(at(i)).eq.1.or.metal(at(j)).eq.1    ! do not constrain M bonds except Li/Be
               if(at(i).eq.3.or.at(i).eq.4.or.at(j).eq.3.or.at(j).eq.4) &
                  &         metalbond=.false.
               if(metalbond) then
                  if(i.lt.j) &
                     &          write(*,*)'init_shake: metal bond ', i,j, &
                     &                    'not constrained'
               else
                  list(ij)=1
                  nconsu = nconsu + 1
                  conslistu(1,nconsu) = i
                  conslistu(2,nconsu) = j
               endif
            endif
         enddo
      enddo

   endif

99 ncons  = nconsu
   if(nconsu.lt.1) return

   allocate(conslist(2,ncons),distcons(ncons),dro(3,ncons),dr(4,ncons))

   conslist(1:2,1:ncons)=conslistu(1:2,1:ncons)
   do i = 1, ncons
      iat = conslist(1,i)
      jat = conslist(2,i)
      drij(1:3) = xyz(1:3,iat) - xyz(1:3,jat)
      distcons(i) = drij(1)**2 + drij(2)**2 + drij(3)**2
   enddo

   return
end subroutine init_shake

subroutine do_shake(nat,xyzo,xyz,velo,acc,mass,tstep)
   implicit none
   integer nat
   real(wp) xyzo(3,nat),xyz(3,nat),velo(3,nat),acc(3,nat),mass(nat)
   real(wp) virsh(3),tstep
   real(wp) xyzt(3,nat)
   real(wp) vel(3)
   integer i,icyc
   integer iat,jat
   logical conv
   real(wp) maxdev
   real(wp) r, dev,dist,denom
   real(wp) gcons, rmi, rmj
   real(wp) tau1,tau2
   integer jmaxdev

   conv = .false.
   icyc = 0

   xyzt = xyz

   tau1 = 1.d0/tstep
   tau2 = tau1*tau1

   do i = 1, ncons
      iat = conslist(1,i)
      jat = conslist(2,i)
      dro(1:3,i) = xyzo(1:3,iat) - xyzo(1:3,jat)
   enddo

100 continue

   maxdev = 0.d0

   do i = 1, ncons
      iat = conslist(1,i)
      jat = conslist(2,i)
      dr(1:3,i) = xyzt(1:3,iat) - xyzt(1:3,jat)
      dr(4,i)   = dr(1,i)**2 + dr(2,i)**2 + dr(3,i)**2
      dist = distcons(i)
      dev = abs(dr(4,i) - dist) / dist
      if(dev.gt.maxdev) then
         maxdev = dev
         jmaxdev = i
      endif
   enddo

   if(maxdev.lt.tolshake) conv = .true.

   if(.not.conv) then

      do i = 1, ncons

         iat = conslist(1,i)
         jat = conslist(2,i)
         dist = distcons(i)

         rmi = 1.d0/mass(iat)
         rmj = 1.d0/mass(jat)

         denom = 2.d0*(rmi+rmj)*(dr(1,i)*dro(1,i)+dr(2,i)*dro(2,i)+ &
            &                            dr(3,i)*dro(3,i))

         gcons = (dist-dr(4,i))/denom

         xyzt(1:3,iat) = xyzt(1:3,iat) + rmi*gcons*dro(1:3,i)
         xyzt(1:3,jat) = xyzt(1:3,jat) - rmj*gcons*dro(1:3,i)

      enddo

   endif

   icyc = icyc + 1

   if(.not.conv.and.icyc.le.maxcyc) goto 100

   if(conv) then
      velo = velo + (xyzt-xyz)*tau1
      acc  = acc  + (xyzt-xyz)*tau2
      xyz  = xyzt
   else
      write(*,*)'SHAKE did not converge! maxdev=',maxdev
      !        if(maxdev.gt.1.d-3) stop 'SHAKE error too large'
   endif

   return
end subroutine do_shake

end module xtb_shake

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine qpotini(natoms,iat,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_setparam
   use xtb_fixparam
   implicit none
   integer natoms,iat(natoms)
   real(wp) xyz(3,natoms)

   integer i,j,k,nread,at(natoms)
   real(wp) xyzf(3,natoms),rij(3)
   character(80) fname,a80
   logical ex

   if(fixset%n.eq.0)then
      write(*,*)'no old-style atom pair restraining (fixing) potential'
   else
      !       calculate distance matrix for fixed atoms
      k=0
      do i=1,fixset%n
         do j=1,i-1
            k=k+1
            rij=xyz(:,fixset%atoms(j))-xyz(:,fixset%atoms(i))
            fixset%val(k)=sqrt(sum(rij*rij))
         enddo
      enddo
      write(*,'(a,i5,a,F10.4)')'# fixed atoms:',fixset%n,' FC:',fixset%fc
      fixset%fc=fixset%fc/(fixset%n-1)
      write(*,'(a,F10.4)')'Final FC :',fixset%fc
      write(*,'(a,F10.0)')'exponent :',fixset%expo
      write(*,'(''fixed atoms'',15I5)')fixset%atoms(1:fixset%n)
   endif

end subroutine qpotini

subroutine countfix(nat,nfix,fname)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_strings, only : lowercase
   implicit none
   real(wp) xx(10)
   integer n,nn,j,nat,k,nfix
   character(128) line
   character(40) fname
   logical fixed(nat),f
   integer :: ich

   call open_file(ich,fname,'r')
   n=0
   fixed=.false.
   100 read(ich,'(a)',end=300)line
   if(index(line,'$user').ne.0)goto 200
   if(index(line,'$red' ).ne.0)goto 200
   if(index(line,'$end' ).ne.0)goto 200
   call readl(line,xx,nn)
   if(nn.ne.3) goto 100
   n=n+1
   line = lowercase(line)
   call getf(line,f)
   if(f)then
      fixed(n)=.true.
   endif
   goto 100
   200 continue
   nfix=count(fixed)
   call close_file(ich)
   return
   300 continue
   call raise('e','internal error in countfix')
end subroutine countfix


subroutine rdfix(nat,n,xyz,iat,fname,fixed)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_strings, only : lowercase
   implicit none
   real(wp) xyz(3,*), xx(10)
   integer nat,iat(nat),n,nn,j,k,fixed(*)
   character(128) line
   character(40) fname
   logical f
   integer :: ich

   write(*,'(''Reading '',A,'' ...'')') trim(fname)
   call open_file(ich,fname,'r')
   n=0
   k=0
10 read(ich,'(a)',end=20)line
   if(index(line,'$user').ne.0)goto 30
   if(index(line,'$red' ).ne.0)goto 30
   if(index(line,'$end' ).ne.0)goto 30
   call readl(line,xx,nn)
   if(nn.ne.3) goto 10
   n=n+1
   xyz(1,n)=xx(1)
   xyz(2,n)=xx(2)
   xyz(3,n)=xx(3)
   line = lowercase(line)
   call elem(line,j)
   call getf(line,f)
   if(f)then
      k=k+1
      fixed(k)=n  !save the array position of fixed atoms
   endif
   !        if(j.eq.0) error stop 'error reading element symbol'
   !        iat(n)=j
   goto 10
20 continue

   call close_file(ich)
   call raise('e','internal error in rdfix')
30 call close_file(ich)
   return
end subroutine rdfix

subroutine getf(line,fix)
   implicit none
   character(*) line
   CHARACTER(3) e
   logical fix
   integer i,j,k,l,n
   e='   '
   k=1
   fix=.false.
   DO J=1,len(line)
      if (k.gt.2)exit
      N=ICHAR(line(J:J))
      if(len_trim(e).ge.1 .and. n.eq.ichar(' '))exit!break if space after elem. symbol
      if(len_trim(e).ge.1 .and. n.eq.9)exit !break if tab after elem. symbol
      if(n.ge.ichar('a') .and. n.le.ichar('z') )then
         e(k:k)=line(j:j)
         k=k+1
      endif
   enddo
   if(j.eq.len(line))then
      return
   else
      do i=j,len(line)
         n=ichar(line(i:i))
         if (n.eq.ichar('f'))fix=.true.
      enddo
   endif
end subroutine getf

! special routine for the Ln fit for Xrays
subroutine fixmetal(n,iat,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_fixparam
   implicit none
   integer n,iat(n),nb(0:20,n),nn,ifix(n)
   real(wp) xyz(3,n)
   integer i,j,k

   call neighbor(n,xyz,iat,nb)

   ifix=1
   do i=1,n
      if(iat(i).gt.57.and.iat(i).lt.72)then
         nn=nb(20,i)
         ifix(i)=0
         do j=1,nn
            k=nb(j,i)
            ifix(k)=0
         enddo
      endif
   enddo

   fixset%n=0
   do i=1,n
      if(ifix(i).eq.1)then
         fixset%n=fixset%n+1
         fixset%atoms(fixset%n)=i
      endif
   enddo

end subroutine fixmetal


subroutine neighbor(natoms,xyz,iz,nb)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer iz(*),natoms,nb(0:20,*)
   real(wp)  xyz(3,*)

   logical da
   integer iat,i,j,k,nn,ni
   real(wp) dx,dy,dz,r,damp,xn,rr,rco,r2,f,pi,a1
   real(wp) rad(94)
   data rad / &
      & 0.32D0,0.37D0,1.30D0,0.99D0,0.84D0,0.75D0,0.71D0,0.64D0,0.60D0, &
      & 0.62D0,1.60D0,1.40D0,1.24D0,1.14D0,1.09D0,1.04D0,1.00D0,1.01D0, &
      & 2.00D0,1.74D0,1.59D0,1.48D0,1.44D0,1.30D0,1.29D0,1.24D0,1.18D0, &
      & 1.17D0,1.22D0,1.20D0,1.23D0,1.20D0,1.20D0,1.18D0,1.17D0,1.16D0, &
      & 2.15D0,1.90D0,1.76D0,1.64D0,1.56D0,1.46D0,1.38D0,1.36D0,1.34D0, &
      & 1.30D0,1.36D0,1.40D0,1.42D0,1.40D0,1.40D0,1.37D0,1.36D0,1.36D0, &
      & 2.38D0,2.06D0,1.94D0,1.84D0,1.90D0,1.88D0,1.86D0,1.85D0,1.83D0, &
      & 1.82D0,1.81D0,1.80D0,1.79D0,1.77D0,1.77D0,1.78D0,1.74D0,1.64D0, &
      & 1.58D0,1.50D0,1.41D0,1.36D0,1.32D0,1.30D0,1.30D0,1.32D0,1.44D0, &
      & 1.45D0,1.50D0,1.42D0,1.48D0,1.46D0,2.42D0,2.11D0,2.01D0,1.90D0, &
      & 1.84D0,1.83D0,1.80D0,1.80D0 /

   do i=1,natoms
      f=1.3
      k=0
      100    do iat=1,natoms
         if(iat.ne.i)then
            dx=xyz(1,iat)-xyz(1,i)
            dy=xyz(2,iat)-xyz(2,i)
            dz=xyz(3,iat)-xyz(3,i)
            r2=dx*dx+dy*dy+dz*dz
            r=sqrt(r2)*0.52917726
            rco=rad(iz(i))+rad(iz(iat))
            if(r.lt.f*rco)then
               k=k+1
               nb(k,i)=iat
            endif
         endif
      enddo
      if(k.lt.1.and.f.lt.1.5)then
         f=f*1.1
         goto 100
      endif
      nb(20,i)=k
   enddo

end subroutine neighbor

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Topological data for force field type calculations
module xtb_gfnff_topology
   use xtb_mctc_accuracy, only : wp
   use xtb_type_dispersionmodel, only : TDispersionModel
   implicit none
   private

   public :: TGFFTopology, TPrintTopo


   !> Topology information for a given system
   type :: TGFFTopology

      !number of terms
      integer  :: nbond
      integer  :: nangl
      integer  :: ntors
      integer  :: nathbH
      integer  :: nathbAB
      integer  :: natxbAB
      integer  :: nbatm
      integer  :: nfrag
      integer  :: maxsystem   ! max. number of fragmentsfor hessian
      integer  :: bond_hb_nr  ! number of unique AH...B HB/bond terms
      integer  :: b_max      ! number of B atoms per unique AH bond

      !numbers that are rewritten, so must be stored for allocation
      integer  :: nbond_blist
      integer  :: nbond_vbond
      integer  :: nangl_alloc
      integer  :: ntors_alloc

      !file type read
      integer  :: read_file_type

      !lists
      integer,allocatable ::     nb(:,:)   ! neighbors nb(20,i) is the # neigbors
      integer,allocatable ::     hyb(:)   ! hybridization of every atom
      integer,allocatable ::    bpair(:)   ! # of cov. between atoms
      integer,allocatable ::  blist(:,:)   ! bonded atoms
      integer,allocatable ::  alist(:,:)   ! angles
      integer,allocatable ::  tlist(:,:)   ! torsions
      integer,allocatable :: b3list(:,:)   ! bond atm
      integer,allocatable :: sTorsl(:,:)
      !-----------------------------------------------
      integer,allocatable :: nr_hb(:)      ! Nr. of H bonds per O-H or N-H bond
      integer,allocatable :: bond_hb_AH(:,:) ! A, H atoms in bonds that are also part of HBs
      integer,allocatable :: bond_hb_B(:,:)  ! B atoms in bonds that are also part of HBs
      integer,allocatable :: bond_hb_Bn(:)   ! Nr. of B atoms for one AH bond pair
      !-----------------------------------------------
      integer,allocatable :: hbatABl(:,:)  ! AB atoms for HB
      integer,allocatable :: xbatABl(:,:)  ! AB atoms for XB
      integer,allocatable :: hbatHl (:)    ! H  atoms for HB
      integer,allocatable :: fraglist(:)   ! atoms in molecular fragments (for EEQ)
      integer,allocatable :: qpdb  (:)     ! atomic charge in residues from PDB file

      !potential parameters used in energy-gradient routine
      real(wp),allocatable:: vbond(:,:)    ! bonds
      real(wp),allocatable:: vangl(:,:)    ! angles
      real(wp),allocatable:: vtors(:,:)    ! torsions
      real(wp),allocatable:: chieeq(:)     ! atomic ENs for EEQ
      real(wp),allocatable:: gameeq(:)     ! atomic gamma for EEQ
      real(wp),allocatable:: alpeeq(:)     ! atomic alpha for EEQ, squared
      real(wp),allocatable:: alphanb(:)    ! non-bonded exponent for atom pairs
      real(wp),allocatable::    qa(:)      ! estimated atomic charges (fixed and obtained from topology EEQ)
      real(wp),allocatable::    xyze0(:,:) ! atom xyz, starting geom. (for Efield energy)
      real(wp),allocatable:: zetac6(:)     ! D4 scaling factor product
      real(wp),allocatable:: qfrag (:)     ! fragment charge (for EEQ)
      real(wp),allocatable:: hbbas (:)     ! HB donor atom basicity
      real(wp),allocatable:: hbaci (:)     ! HB acceptor atom acidity

      integer, allocatable  :: ispinsyst(:,:)
      integer, allocatable  :: nspinsyst(:)
      integer               :: nsystem

      type(TDispersionModel) :: dispm



   contains

      procedure :: zero

   end type TGFFTopology

   ! logicals for GFN-FF topology list printout
   type :: TPrintTopo
     logical :: etot    = .false.
     logical :: gnorm   = .false.
     logical :: nb      = .false.
     logical :: bpair   = .false.
     logical :: alist   = .false.
     logical :: blist   = .false.
     logical :: tlist   = .false.
     logical :: vtors   = .false.
     logical :: vbond   = .false.
     logical :: vangl   = .false.
     logical :: hbbond  = .false.
     logical :: eeq     = .false.
     logical :: warning = .false.

   contains

   procedure :: any

   end type TPrintTopo

contains


subroutine zero(self)
   class(TGFFTopology), intent(out) :: self

   self%nbond = 0
   self%nangl = 0
   self%ntors = 0
   self%nathbH = 0
   self%nathbAB = 0
   self%natxbAB = 0
   self%nbatm = 0
   self%nfrag = 0
   self%maxsystem = 0
   self%bond_hb_nr = 0
   self%b_max = 0

   self%nbond_blist = 0
   self%nbond_vbond = 0
   self%nangl_alloc = 0
   self%ntors_alloc = 0

   self%read_file_type = 0

end subroutine zero

function any(self) result(tf)
  class(TPrintTopo), intent(in) :: self
  logical :: tf

  tf = self%nb.or.self%bpair.or.self%alist.or.self%blist.or. &
     & self%tlist.or.self%vtors.or.self%vbond.or.self%vangl.or. &
     & self%hbbond.or.self%eeq.or.self%etot.or.self%gnorm
end function any

end module xtb_gfnff_topology

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Reallocation implementation for resizing arrays
module xtb_mctc_resize
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: resize


   !> Overloaded resize interface
   interface resize
      module procedure :: resizeChar
      module procedure :: resizeInt
      module procedure :: resizeReal
      module procedure :: resizeReal2d
   end interface resize


contains


!> Reallocate list of integers
pure subroutine resizeInt(var, n)

   !> TODO
   integer, allocatable, intent(inout) :: var(:)

   !> TODO
   integer, intent(in), optional :: n

   integer, allocatable :: tmp(:)
   integer :: length, currentLength

   currentLength = size(var)
   if (currentLength > 0) then
      if (present(n)) then
         if (n <= currentLength) return
         length = n
      else
         length = currentLength + currentLength/2 + 1
      endif
      allocate(tmp(length), source=0)
      tmp(:currentLength) = var(:currentLength)
      deallocate(var)
      call move_alloc(tmp, var)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(var(length), source=0)
   endif

end subroutine resizeInt


!> Reallocate list of characters
pure subroutine resizeChar(var, n)

   !> TODO
   character(len=*), allocatable, intent(inout) :: var(:)

   !> TODO
   integer, intent(in), optional :: n

   character(len=:), allocatable :: tmp(:)
   integer :: length, currentLength

   currentLength = size(var)
   if (currentLength > 0) then
      if (present(n)) then
         if (n <= currentLength) return
         length = n
      else
         length = currentLength + currentLength/2 + 1
      endif
      allocate(tmp(length), mold=var)
      tmp(:currentLength) = var(:currentLength)
      deallocate(var)
      call move_alloc(tmp, var)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(var(length), source=' ')
   endif

end subroutine resizeChar


!> Reallocate list of reals
pure subroutine resizeReal(var, n)

   !> TODO
   real(wp), allocatable, intent(inout) :: var(:)

   !> TODO
   integer, intent(in), optional :: n

   real(wp), allocatable :: tmp(:)
   integer :: length, order, currentLength

   currentLength = size(var)
   if (currentLength > 0) then
      if (present(n)) then
         if (n <= currentLength) return
         length = n
      else
         length = currentLength + currentLength/2 + 1
      endif
      allocate(tmp(length), source=0.0_wp)
      tmp(:currentLength) = var(:currentLength)
      deallocate(var)
      call move_alloc(tmp, var)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(var(length), source=0.0_wp)
   endif

end subroutine resizeReal


!> Reallocate list of reals
pure subroutine resizeReal2d(var, n)

   !> TODO
   real(wp), allocatable, intent(inout) :: var(:,:)

   !> TODO
   integer, intent(in), optional :: n(2)

   real(wp), allocatable :: tmp(:,:)
   integer :: length, order, currentLength

   currentLength = size(var, 2)
   if (currentLength > 0) then
      if (present(n)) then
         if (n(2) <= currentLength) return
         order = n(1)
         length = n(2)
      else
         length = currentLength + currentLength/2 + 1
         order = size(var, 1)
      endif
      allocate(tmp(order, length), source=0.0_wp)
      tmp(:, :currentLength) = var(:, :currentLength)
      deallocate(var)
      call move_alloc(tmp, var)
   else
      if (present(n)) then
         order = n(1)
         length = n(2)
      else
         order = 3
         length = 64
      endif
      allocate(var(order,length), source=0.0_wp)
   endif

end subroutine resizeReal2d


end module xtb_mctc_resize

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_dtrafo

contains

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c transforms cao(6d) integrals to sao(5d) basis
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine cao2sao(nbf,nao,s,basis)
  use xtb_type_basisset
  implicit none
  type(TBasisset), intent(in) :: basis
  integer nbf,nao
  real(8)  s(nbf,nbf)
  real(8)  sspher
  integer lll(20),firstd(nbf)
  integer i,j,k,ii,jj,kk,iii,jjj,lin,li,lj,mm,nn,m,n
  data lll/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/

  real(8) trafo(6,6)
  real(8),allocatable :: sneu(:)

  trafo = 0.0d0
  ! dS
  trafo(1,1)=1.d0/sqrt(3.d0)*sqrt(3.d0/5.d0)
  trafo(2,1)=1.d0/sqrt(3.d0)*sqrt(3.d0/5.d0)
  trafo(3,1)=1.d0/sqrt(3.d0)*sqrt(3.d0/5.d0)
  ! dx2-y2
  trafo(1,2)= 1.d0/sqrt(2.d0)*sqrt(3.d0/2.d0)
  trafo(2,2)=-1.d0/sqrt(2.d0)*sqrt(3.d0/2.d0)
  ! dz2
  trafo(1,3)= 0.50d0
  trafo(2,3)= 0.50d0
  trafo(3,3)=-1.0d0
  !      trafo(1,3)= 0.408248290464D+00*sqrt(3./2.)
  !      trafo(2,3)= 0.408248290464D+00*sqrt(3./2.)
  !      trafo(3,3)=-0.816496580928D+00*sqrt(3./2.)
  ! rest
  trafo(4,4)=1.0d0
  trafo(5,5)=1.0d0
  trafo(6,6)=1.0d0

  nao=0
  firstd = 0
  i=1
42 if(basis%lao(i).gt.4.and.basis%lao(i).le.10)then
     nao=nao+1
     firstd(i:i+5)=i
     i=i+5
  endif
  i=i+1
  if(i.lt.nbf)goto 42

  if(nao.eq.0) then
     nao=nbf
     return
  endif

  allocate(sneu(nbf*(nbf+1)/2))

  k=0
  do i=1,nbf
     do j=1,i
        k=K+1
        sneu(k)=s(j,i)
     enddo
  enddo

  k=0
  do i=1,nbf
     li=lll(basis%lao(i))
     do j=1,i
        lj=lll(basis%lao(j))
        k=k+1
        ! d-d
        if(li.eq.3.and.lj.eq.3)then
           ii=basis%lao(i)-4
           jj=basis%lao(j)-4
           sspher=0
           do m=1,6
              mm=firstd(i)-1+m
              do n=1,6
                 nn=firstd(j)-1+n
                 sspher=sspher+trafo(m,ii)*trafo(n,jj)*s(mm,nn)
              enddo
           enddo
           sneu(k)=sspher
        endif
        ! d-sp
        if(li.eq.3.and.lj.le.2)then
           ii=basis%lao(i)-4
           sspher=0
           do m=1,6
              mm=firstd(i)-1+m
              sspher=sspher+trafo(m,ii)*s(mm,j)
           enddo
           sneu(k)=sspher
        endif
        ! sp-d
        if(li.le.2.and.lj.eq.3)then
           jj=basis%lao(j)-4
           sspher=0
           do n=1,6
              nn=firstd(j)-1+n
              sspher=sspher+trafo(n,jj)*s(i,nn)
           enddo
           sneu(k)=sspher
        endif

     enddo
  enddo

  s=0

  k=0
  iii=0
  do i=1,nbf
     if(basis%lao(i).ne.5)iii=iii+1
     jjj=0
     do j=1,i
        if(basis%lao(j).ne.5)jjj=jjj+1
        k=k+1
        if(basis%lao(i).eq.5.or.basis%lao(j).eq.5)cycle
        s(iii,jjj)=sneu(k)
        s(jjj,iii)=sneu(k)
     enddo
  enddo

  nao=nbf-nao

  deallocate(sneu)
end subroutine cao2sao

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c transforms sao(5d) integrals to cao(6d) basis
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine sao2cao(nbf,s,ncao,x,basis)
  use xtb_type_basisset
  implicit none
  type(TBasisset), intent(in) :: basis
  integer nbf,new,ncao
  real(8)  s(nbf,nbf),x(ncao,nbf)
  real(8)  xcart
  integer lll(20),firstd(nbf),idprev
  integer i,j,k,jj,mm,m
  data lll/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/

  real(8) trafo(5,6)

  trafo = 0.0d0
  ! x2
  trafo(1,1)=1./sqrt(2.)*sqrt(3./2.)
  !      trafo(2,1)=0.408248290464D+00*sqrt(3./2.)
  trafo(2,1)=0.50d0
  ! y2
  trafo(1,2)=-1./sqrt(2.)*sqrt(3./2.)
  !      trafo(2,2)=0.408248290464D+00*sqrt(3./2.)
  trafo(2,2)=0.50d0
  ! z2
  trafo(1,3)=0.0d0
  trafo(2,3)=-1.0d0
  !      trafo(2,3)=-0.816496580928D+00*sqrt(3./2.)
  ! rest
  trafo(3,4)=1.0d0
  trafo(4,5)=1.0d0
  trafo(5,6)=1.0d0

  new=ncao-nbf

  if(new.eq.0) then
     return
  endif

  firstd = 0
  i=1
  j=0
  ! lao is still in old dimensions (i.e., ncao) while s comes with nsao
42 if(basis%lao(i).gt.4.and.basis%lao(i).le.10)then
     firstd(i-j:i-j+4)=i-j
     j=j+1
     i=i+5
  endif
  i=i+1
  if(i.lt.ncao)goto 42
  ! sanity check
  if(new.ne.j) call raise('E','in sao2cao trafo')

  x=0.0d0

  do i=1,nbf ! go through eigenvectors
     k = 0
     idprev=0
     do j=1,nbf ! go through LCAO-MO coefficients
        if(idprev.gt.0.and.firstd(j).eq.idprev) cycle
        if(firstd(j).gt.idprev)then ! if a set of d functions is found, do trafo for all six d orbitals
           do jj=1,6
              k=k+1
              xcart=0.0d0
              do m=1,5
                 mm=firstd(j)-1+m
                 xcart=xcart+trafo(m,jj)*s(mm,i)
              enddo
              x(k,i)=xcart
           enddo
           idprev=firstd(j) ! setting idprev to new value guarantees that the following 4
                            ! spherical d functions will be skipped (we already did the trafo)
           cycle
        endif
        k=k+1
        x(k,i)= s(j,i)
     enddo
     if (k.ne.ncao) stop 'error in eigenvector dimension'
  enddo

end subroutine sao2cao

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!c transforms cao(6d) integrals to sao(5d) basis, packed output
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine cao2saop(nbf,nao,s,basis)
  use xtb_type_basisset
  use xtb_lin, only : lin
  implicit none
  type(TBasisset), intent(in) :: basis
  integer nbf,nao
  real(8)  s(nbf*(nbf+1)/2)
  real(8)  sspher
  integer lll(20),firstd(nbf)
  integer i,j,k,ii,jj,kk,iii,jjj,li,lj,mm,nn,m,n
  data lll/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/

  real(8) trafo(6,6)
  real(8),allocatable :: sneu(:)

  trafo = 0.0d0
  ! dS
  trafo(1,1)=1.d0/sqrt(3.d0)*sqrt(3.d0/5.d0)
  trafo(2,1)=1.d0/sqrt(3.d0)*sqrt(3.d0/5.d0)
  trafo(3,1)=1.d0/sqrt(3.d0)*sqrt(3.d0/5.d0)
  ! dx2-y2
  trafo(1,2)= 1.d0/sqrt(2.d0)*sqrt(3.d0/2.d0)
  trafo(2,2)=-1.d0/sqrt(2.d0)*sqrt(3.d0/2.d0)
  ! dz2
  trafo(1,3)= 0.50d0
  trafo(2,3)= 0.50d0
  trafo(3,3)=-1.0d0
  ! rest
  trafo(4,4)=1.0d0
  trafo(5,5)=1.0d0
  trafo(6,6)=1.0d0

  nao=0
  firstd = 0
  i=1
42 if(basis%lao(i).gt.4.and.basis%lao(i).le.10)then
     nao=nao+1
     firstd(i:i+5)=i
     i=i+5
  endif
  i=i+1
  if(i.lt.nbf)goto 42

  if(nao.eq.0) then
     nao=nbf
     return
  endif

  allocate(sneu(nbf*(nbf+1)/2))

  sneu = s

  k=0
  do i=1,nbf
     li=lll(basis%lao(i))
     do j=1,i
        lj=lll(basis%lao(j))
        k=k+1
        ! d-d
        if(li.eq.3.and.lj.eq.3)then
           ii=basis%lao(i)-4
           jj=basis%lao(j)-4
           sspher=0
           do m=1,6
              mm=firstd(i)-1+m
              do n=1,6
                 nn=firstd(j)-1+n
                 sspher=sspher+trafo(m,ii)*trafo(n,jj)*s(lin(mm,nn))
              enddo
           enddo
           sneu(k)=sspher
        endif
        ! d-sp
        if(li.eq.3.and.lj.le.2)then
           ii=basis%lao(i)-4
           sspher=0
           do m=1,6
              mm=firstd(i)-1+m
              sspher=sspher+trafo(m,ii)*s(lin(mm,j))
           enddo
           sneu(k)=sspher
        endif
        ! sp-d
        if(li.le.2.and.lj.eq.3)then
           jj=basis%lao(j)-4
           sspher=0
           do n=1,6
              nn=firstd(j)-1+n
              sspher=sspher+trafo(n,jj)*s(lin(i,nn))
           enddo
           sneu(k)=sspher
        endif

     enddo
  enddo

  s(1:nao*(nao+1)/2)=0

  k=0
  iii=0
  do i=1,nbf
     if(basis%lao(i).ne.5)iii=iii+1
     jjj=0
     do j=1,i
        if(basis%lao(j).ne.5)jjj=jjj+1
        k=k+1
        if(basis%lao(i).eq.5.or.basis%lao(j).eq.5)cycle
        s(lin(iii,jjj))=sneu(k)
     enddo
  enddo

  nao=nbf-nao

  deallocate(sneu)
end subroutine cao2saop
end module xtb_dtrafo

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

integer function ifind(x,n,xx)
   implicit none
   integer n
   real*8 x,xx(n),mind
   integer i,mem

   mind=1.d+42
   do i=1,n
      if(abs(x-xx(i)).lt.mind)then
         mind=abs(x-xx(i))
         mem=i
      endif
   enddo
   ifind = mem

end function ifind

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


! This is the ROTATIONAL symmetry number (sigma)
pure subroutine getsymnum(pgroup,lin,symnum)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp),intent(out) :: symnum
   character(len=*),intent(in) :: pgroup
   logical,intent(in) :: lin
   symnum=1
   if(index(pgroup,'ci').ne.0)symnum=1
   if(index(pgroup,'cs').ne.0)symnum=1
   if(index(pgroup,'c2').ne.0)symnum=2
   if(index(pgroup,'c3').ne.0)symnum=3
   if(index(pgroup,'c4').ne.0)symnum=4
   if(index(pgroup,'c5').ne.0)symnum=5
   if(index(pgroup,'c6').ne.0)symnum=6
   if(index(pgroup,'c7').ne.0)symnum=7
   if(index(pgroup,'c8').ne.0)symnum=8
   if(index(pgroup,'c9').ne.0)symnum=9
   if(index(pgroup,'c10').ne.0)symnum=10
   if(index(pgroup,'c11').ne.0)symnum=11
   if(index(pgroup,'s4').ne.0)symnum=2
   if(index(pgroup,'s6').ne.0)symnum=3
   if(index(pgroup,'s8').ne.0)symnum=4
   if(index(pgroup,'d2').ne.0)symnum=4
   if(index(pgroup,'d3').ne.0)symnum=6
   if(index(pgroup,'d4').ne.0)symnum=8
   if(index(pgroup,'d5').ne.0)symnum=10
   if(index(pgroup,'d6').ne.0)symnum=12
   if(index(pgroup,'d7').ne.0)symnum=14
   if(index(pgroup,'d8').ne.0)symnum=16
   if(index(pgroup,'d9').ne.0)symnum=18
   if(index(pgroup,'d10').ne.0)symnum=20
   if(index(pgroup,'t').ne.0)symnum=12
   if(index(pgroup,'th').ne.0)symnum=12
   if(index(pgroup,'td').ne.0)symnum=12
   if(index(pgroup,'o').ne.0)symnum=24
   if(index(pgroup,'oh').ne.0)symnum=24
   if(index(pgroup,'ih').ne.0)symnum=60
   if(index(pgroup,'c').ne.0.and.lin)symnum=1
   if(index(pgroup,'d').ne.0.and.lin)symnum=2
   if(index(pgroup,'Ci').ne.0)symnum=1
   if(index(pgroup,'Cs').ne.0)symnum=1
   if(index(pgroup,'C2').ne.0)symnum=2
   if(index(pgroup,'C3').ne.0)symnum=3
   if(index(pgroup,'C4').ne.0)symnum=4
   if(index(pgroup,'C5').ne.0)symnum=5
   if(index(pgroup,'C6').ne.0)symnum=6
   if(index(pgroup,'C7').ne.0)symnum=7
   if(index(pgroup,'C8').ne.0)symnum=8
   if(index(pgroup,'C9').ne.0)symnum=9
   if(index(pgroup,'C10').ne.0)symnum=10
   if(index(pgroup,'C11').ne.0)symnum=11
   if(index(pgroup,'S4').ne.0)symnum=2
   if(index(pgroup,'S6').ne.0)symnum=3
   if(index(pgroup,'S8').ne.0)symnum=4
   if(index(pgroup,'D2').ne.0)symnum=4
   if(index(pgroup,'D3').ne.0)symnum=6
   if(index(pgroup,'D4').ne.0)symnum=8
   if(index(pgroup,'D5').ne.0)symnum=10
   if(index(pgroup,'D6').ne.0)symnum=12
   if(index(pgroup,'D7').ne.0)symnum=14
   if(index(pgroup,'D8').ne.0)symnum=16
   if(index(pgroup,'D9').ne.0)symnum=18
   if(index(pgroup,'D10').ne.0)symnum=20
   if(index(pgroup,'T').ne.0)symnum=12
   if(index(pgroup,'Th').ne.0)symnum=12
   if(index(pgroup,'Td').ne.0)symnum=12
   if(index(pgroup,'O').ne.0)symnum=24
   if(index(pgroup,'Oh').ne.0)symnum=24
   if(index(pgroup,'Ih').ne.0)symnum=60
   if(index(pgroup,'C').ne.0.and.lin)symnum=1
   if(index(pgroup,'D').ne.0.and.lin)symnum=2
end subroutine getsymnum

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_molecule
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   implicit none
   private

   public :: collect_molecule

contains

!> Collect all exported unit tests
subroutine collect_molecule(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("mic-distances", test_class_molecule_mic_distances), &
      new_unittest("axis-trafo", test_class_molecule_axis_trafo) &
      ]

end subroutine collect_molecule


subroutine test_class_molecule_mic_distances(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule
   use xtb_type_param
   use xtb_eeq
   use xtb_disp_ncoord
   use xtb_pbc_tools
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   ! SiO2 (random, no symmetry)
   integer, parameter :: nat = 6
   integer, parameter :: at(nat) = [14,14,8,8,8,8]
   real(wp),parameter :: abc(3,nat) = reshape(&
      &[.095985472469032_wp,     .049722204206931_wp,     0.10160624337938_wp, &
      & 0.54722204206931_wp,     0.52863628207623_wp,     0.38664208660311_wp, &
      & 0.29843937068984_wp,     0.39572194413818_wp,     0.20321248675876_wp, &
      & 0.23364982659922_wp,     0.85647058758674_wp,     0.31884968761485_wp, &
      & 0.72250232459952_wp,     0.65548544066844_wp,     .056207709103487_wp, &
      & 0.70514214000043_wp,     0.28321754549582_wp,     0.36424822189074_wp],&
      & shape(abc))
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[ 8.7413053236641_wp,      0.0000000000000_wp,      0.0000000000000_wp,   &
      &  0.0000000000000_wp,      8.7413053236641_wp,      0.0000000000000_wp,   &
      &  0.0000000000000_wp,      0.0000000000000_wp,      8.7413053236641_wp],  &
      & shape(lattice))
   integer, parameter :: wsc_rep(3) = [1,1,1]
   real(wp),allocatable :: xyz(:,:)

   type(TMolecule)       :: mol

   allocate(xyz(3, nat))
   call coord_trafo(nat,lattice,abc,xyz)
   call init(mol, at, xyz, lattice=lattice)

   call check(error, mol%dist(1,1),8.7413053236641_wp, thr=thr)
   call check(error, mol%dist(3,6),3.9480992656526_wp, thr=thr)
   call check(error, mol%dist(2,3),2.9411012169549_wp, thr=thr)
   call check(error, mol%dist(1,4),2.8120981086302_wp, thr=thr)

   call mol%deallocate

end subroutine test_class_molecule_mic_distances

subroutine test_class_molecule_axis_trafo(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule
   use xtb_type_param
   use xtb_disp_ncoord
   use xtb_eeq
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,8,1,6,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      [ 0.236995341_wp,     0.794935672_wp,     0.000000000_wp,  &
      & 2.159203072_wp,    -0.439230068_wp,     0.000000000_wp,  &
      & 0.329518229_wp,     2.884317091_wp,     0.000000000_wp,  &
      &-2.377225608_wp,    -0.313030650_wp,     0.000000000_wp,  &
      &-2.288077922_wp,    -2.365932814_wp,     0.000000000_wp,  &
      &-3.405901173_wp,     0.355579334_wp,     1.660010899_wp,  &
      &-3.405901173_wp,     0.355579335_wp,    -1.660010899_wp   &
      & ],shape(xyz))

   type(TMolecule)       :: mol
   real(wp) :: molmass
   real(wp) :: center(3)
   real(wp) :: moments(3)

   call init(mol, at, xyz)

   center = mol%center_of_geometry()
   call check(error, center(1),-1.2501984620000_wp, thr=thr)
   call check(error, center(2), .18174541428571_wp, thr=thr)
   call check(error, center(3), 0.0000000000000_wp, thr=thr)

   call mol%shift_to_center_of_geometry
   call check(error, mol%xyz(2,1),.61319025771429_wp, thr=thr)
   call check(error, mol%xyz(1,3),1.5797166910000_wp, thr=thr)
   call check(error, mol%xyz(3,6),1.6600108990000_wp, thr=thr)

   molmass = sum(mol%atmass)
   call check(error, molmass,80303.049694083_wp, thr=1.0e-5_wp) ! in au
   center = mol%center_of_mass()
   call check(error, center(1),1.2502034210661_wp, thr=thr)

   call mol%shift_to_center_of_mass
   call check(error, mol%xyz(2,4),-0.31302884934293_wp, thr=thr)
   call check(error, mol%xyz(1,1), 0.23699038193392_wp, thr=thr)

   moments = mol%moments_of_inertia()
   call check(error, moments(1),57768.744315301_wp, thr=1.0e-5_wp)
   call check(error, moments(3),361019.51690412_wp, thr=1.0e-5_wp)

!   call mol%align_to_principal_axes(break_symmetry = .false.)
!   call check(error, mol%xyz(2,1),-.79493732581159_wp, thr=thr)
!   call check(error, mol%xyz(1,7), 3.4059059117382_wp, thr=thr)
!
!   call mol%align_to_principal_axes(break_symmetry = .true.)
!   call check(error, mol%xyz(2,1),-.79493703211973_wp, thr=thr)
!   call check(error, mol%xyz(1,7), 3.4059054710786_wp, thr=thr)

   call mol%deallocate

end subroutine test_class_molecule_axis_trafo

end module test_molecule

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Static neighbour list implementation
!>
!> Based on the implementation used in DFTB+ (see module dftbp_periodic there)
module xtb_type_neighbourlist
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_search, only : bisectSearch
   use xtb_mctc_sort, only : indexHeapSort
   use xtb_mctc_thresholds, only : tolSameDist2, minNeighDist2
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: TNeighbourList, init
   public :: initialNumberOfNeighbours, resizeNeigh, resizeImage


   !> Static neighbour list
   type :: TNeighbourList

      !> Maximum number of neighbours for each atom
      integer, allocatable :: neighs(:)

      !> Mapping from neighbours to atoms in the central cell
      integer, allocatable :: image(:)

      !> Index of the translation vector generating the neighbour
      integer, allocatable :: trans(:)

      !> Coordinates of the atoms and their images
      real(wp), allocatable :: coords(:, :)

      !> Neighbours of each atom
      integer, allocatable :: iNeigh(:, :)

      !> Quadratic distances to all neighbours
      real(wp), allocatable :: dist2(:, :)

      !> Weights of the neighbour contributions
      real(wp), allocatable :: weight(:, :)

      !> Maximum cutoff supported by this neighbour list
      real(wp) :: cutoff

   contains

      !> Generate neighbour list
      procedure :: generate

      !> Update neighbour list
      procedure :: update

      !> Get number of neighbours
      generic :: getNeighs => getNeighsAll, getNeighsOne

      !> Get number of all neighbours
      procedure, private :: getNeighsAll

      !> Get number of neighbours for one atom
      procedure, private :: getNeighsOne

      !> Sort the neighbour list
      procedure :: sort

   end type TNeighbourList


   !> Initialize neighbour list
   interface init
      module procedure :: initNeighbourList
   end interface init


   !> Initial number of neighbours
   integer, parameter :: initialNumberOfNeighbours = 40


contains


!> Initialize neighbour list
subroutine initNeighbourList(self, nAtom)

   !> Instance of the neighbour list
   type(TNeighbourList), intent(out) :: self

   !> Number of atoms in the system
   integer, intent(in) :: nAtom

   allocate(self%neighs(nAtom))
   allocate(self%image(nAtom))
   allocate(self%coords(3, nAtom))
   allocate(self%trans(nAtom))

   allocate(self%iNeigh(0:initialNumberOfNeighbours, nAtom))
   allocate(self%dist2(0:initialNumberOfNeighbours, nAtom))
   allocate(self%weight(0:initialNumberOfNeighbours, nAtom))

   self%cutoff = -1.0_wp

end subroutine initNeighbourList


!> Generate neighbour list
subroutine generate(self, env, coords0, cutoff, latPoint, symmetric)

   !> Instance of the neighbour list
   class(TNeighbourList), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Folded coordinates of the atoms inside the unit cell
   real(wp), intent(in) :: coords0(:, :)

   !> Realspace cutoff for the generation of neighbours
   real(wp), intent(in) :: cutoff

   !> Lattice points for all supercells within the cutoff
   real(wp), intent(in) :: latPoint(:, :)

   !> Generate a symmetric map
   logical, intent(in) :: symmetric

   call generateSequential(self, env, coords0, cutoff, latPoint, symmetric)

   call self%sort

end subroutine generate


!> Generate neighbour list in serial
subroutine generateSequential(self, env, coords0, cutoff, latPoint, symmetric)

   !> Source for generating errors
   character(len=*), parameter :: source = 'type_neighbourlist_generateSerial'

   !> Instance of the neighbour list
   class(TNeighbourList), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Folded coordinates of the atoms inside the unit cell
   real(wp), intent(in) :: coords0(:, :)

   !> Realspace cutoff for the generation of neighbours
   real(wp), intent(in) :: cutoff

   !> Lattice points for all supercells within the cutoff
   real(wp), intent(in) :: latPoint(:, :)

   !> Generate a symmetric map
   logical, intent(in) :: symmetric

   !> Number of atoms in the central cell
   integer :: nAtom

   !> Number of translations to consider
   integer :: nTrans

   !> Capacity of the atom related arrays
   integer :: mImage

   !> Capacity of the neighbour related arrays
   integer :: mNeigh

   !> Index of the current image
   integer :: nImage

   !> Quadratic cutoff
   real(wp) :: cutoff2

   integer :: iTr, iAt, iAtOld, jAt, jAtEnd
   real(wp) :: ri(3), dist2, trans(3)

   !> Get dimensions for the generator loop
   nAtom = size(self%neighs, dim=1)
   nTrans = size(latPoint, dim=2)

   !> Get initial capacities
   mImage = size(self%coords, dim=2)
   mNeigh = ubound(self%iNeigh, dim=1)

   !> Set the value of the cutoff
   self%cutoff = cutoff
   cutoff2 = cutoff**2

   !> Initialize neighbour list with distances from every atom to itself
   self%neighs(:) = 0
   self%iNeigh(:, :) = 0
   self%dist2(:, :) = 0.0_wp
   self%weight(:, :) = 0.0_wp
   do iAt = 1, nAtom
      self%iNeigh(0, iAt) = iAt
      self%weight(0, iAt) = 1.0_wp
   end do

   nImage = 0
   lpTrans: do iTr = 1, nTrans
      trans(:) = latPoint(:, iTr)
      iAtOld = 0
      lpIAt: do iAt = 1, nAtom
         !> Generate position of image
         ri(:) = coords0(:, iAt) + trans(:)
         if (symmetric) then
            jAtEnd = nAtom
         else
            jAtEnd = iAt
         end if
         lpJAt: do jAt = 1, jAtEnd
            !> Calculate distance between atoms in cell and the image
            dist2 = sum((coords0(:, jAt) - ri(:))**2)
            if (dist2 > cutoff2) then
               cycle lpJAt
            end if

            !> New atom in range found, add image to list
            if (iAt /= iAtOld) then
               nImage = nImage + 1
               if (nImage > mImage) then
                  mImage = 2*mImage
                  call resizeImage(mImage, self%image, self%trans, self%coords)
               end if
               self%coords(:, nImage) = ri(:)
               self%image(nImage) = iAt
               self%trans(nImage) = iTr
               iAtOld = iAt
            end if

            !> Check for particular close distance
            if (dist2 < minNeighDist2) then
               !> Small distances between the atom and itself are okay
               if (iTr == 1 .and. iAt == jAt) then
                  cycle lpJAt
               else
                  call env%error("Very close distance found", source)
               end if
            end if

            self%neighs(jAt) = self%neighs(jAt) + 1
            if (self%neighs(jAt) > mNeigh) then
               mNeigh = 2*mNeigh
               call resizeNeigh(mNeigh, self%iNeigh, self%dist2, self%weight)
            end if
            self%iNeigh(self%neighs(jAt), jAt) = nImage
            self%dist2(self%neighs(jAt), jAt) = dist2
            self%weight(self%neighs(jAt), jAt) = 1.0_wp

         end do lpJAt
      end do lpIAt
   end do lpTrans

   call resizeImage(nImage, self%image, self%trans, self%coords)

end subroutine generateSequential


!> Update neighbour list with new coordinates
subroutine update(self, coords0, cellVec)

   !> Initialized instance on exit
   class(TNeighbourList), intent(inout) :: self

   !> Absolute coordinates of the shifted super cells
   real(wp), intent(in) :: cellVec(:, :)

   !> Coordinates of atoms (folded into unit cell, if periodic)
   real(wp), intent(in) :: coords0(:, :)

   !> Number of atoms in the system
   integer :: nAtom

   !> Maximum number of atom without reallocation
   integer :: nImage

   integer :: iAt, iAtf, jAt, iTr, iNeigh
   real(wp) :: vec(3)

   nAtom = size(self%neighs, dim=1)
   nImage = size(self%coords, dim=2)

   !> Update the coordinates of all images
   do iAt = 1, nImage
      iAtf = self%image(iAt)
      iTr = self%trans(iAt)
      self%coords(:, iAt) = coords0(:, iAtf) + cellVec(:, iTr)
   end do

   !> Update neighbour list for all atoms
   do iAt = 1, nAtom
      do iNeigh = 1, self%neighs(iAt)
         jAt = self%iNeigh(iNeigh, iAt)
         vec(:) = self%coords(:, iAt) - self%coords(:, jAt)
         self%dist2(iNeigh, iAt) = sum(vec**2)
      end do
   end do

   !> Sort neighbour lists
   call self%sort

end subroutine update


!> Sort neighbours for all atom by distance
subroutine sort(self)

   !> Instance of the neighbour list
   class(TNeighbourList), intent(inout) :: self

   integer, allocatable :: indx(:)
   integer :: nAtom, mNeigh, iAt, nn

   nAtom = size(self%neighs, dim=1)
   mNeigh = ubound(self%iNeigh, dim=1)

   allocate(indx(mNeigh))

   do iAt = 1, nAtom
      nn = self%neighs(iAt)
      call indexHeapSort(indx(1:nn), self%dist2(1:nn, iAt), tolSameDist2)
      self%iNeigh(1:nn, iAt) = self%iNeigh(indx(:nn), iAt)
      self%dist2(1:nn, iAt) = self%dist2(indx(:nn), iAt)
      self%weight(1:nn, iAt) = self%weight(indx(:nn), iAt)
   end do

end subroutine sort


!> Get all neighbours for a given cutoff
pure subroutine getNeighsAll(self, neighs, cutoff)

   !> Instance of the neighbour list
   class(TNeighbourList), intent(in) :: self

   !> Realspace cutoff radius
   real(wp), intent(in), optional :: cutoff

   !> Number of neighbour.
   integer, intent(out) :: neighs(:)

   integer :: iatom
   real(wp) :: cutoff0

   if (present(cutoff)) then
      cutoff0 = min(cutoff, self%cutoff)
   else
      cutoff0 = self%cutoff
   end if

   do concurrent(iatom = 1:size(neighs))
      call self%getNeighs(neighs(iatom), iatom, cutoff0)
   end do

end subroutine getNeighsAll


!> Get neighbour for a given cutoff
elemental subroutine getNeighsOne(self, neighs, iatom, cutoff)

   !> Instance of the neighbour list
   class(TNeighbourList), intent(in) :: self

   !> Atom of interest.
   integer, intent(in) :: iatom

   !> Realspace cutoff radius
   real(wp), intent(in), optional :: cutoff

   !> Number of neighbour.
   integer, intent(out) :: neighs

   real(wp) :: cutoff2

   if (present(cutoff)) then
      cutoff2 = min(cutoff, self%cutoff)**2
   else
      cutoff2 = self%cutoff**2
   endif

   call bisectSearch(neighs, self%dist2(1:self%neighs(iatom), iatom), &
      & cutoff2, tolSameDist2)

end subroutine getNeighsOne


!> Reallocate arrays which depends on the maximal nr. of all atoms.
subroutine resizeImage(mImage, image, trans, coords)

   !> Maximum number of new atoms
   integer, intent(in) :: mImage

   !> Array mapping images of atoms to originals in the central cell
   integer, allocatable, intent(inout) :: image(:)

   !> Index of unit cell containing atom
   integer, allocatable, intent(inout) :: trans(:)

   !> Coordinates of all atoms (actual and image)
   real(wp), allocatable, intent(inout) :: coords(:, :)

   integer :: nImage
   integer, allocatable :: iTmp(:)
   real(wp), allocatable :: rTmp(:, :)

   nImage = min(size(image), mImage)

   call move_alloc(image, iTmp)
   allocate(image(mImage))
   image(:) = 0
   image(:nImage) = iTmp(:nImage)

   iTmp(:) = trans(:)
   deallocate(trans)
   allocate(trans(mImage))
   trans(:nImage) = iTmp(:nImage)

   call move_alloc(coords, rTmp)
   allocate(coords(3, mImage))
   coords(:, :nImage) = rTmp(:, :nImage)

end subroutine resizeImage


!> Reallocate array which depends on the maximal nr. of neighbours.
subroutine resizeNeigh(mNeigh, iNeigh, dist2, weight)

   !> Maximum number of new atoms
   integer, intent(in) :: mNeigh

   !> List of neighbours
   integer, allocatable, intent(inout) :: iNeigh(:, :)

   !> Square of distances between atoms
   real(wp), allocatable, intent(inout) :: dist2(:,:)

   !> Weights for all neighbours
   real(wp), allocatable, intent(inout) :: weight(:,:)

   integer :: nNeigh, nAtom
   integer, allocatable :: iTmp(:,:)
   real(wp), allocatable :: rTmp(:,:)

   nNeigh = ubound(iNeigh, dim=1)
   nAtom = size(iNeigh, dim=2)

   call move_alloc(iNeigh, iTmp)
   allocate(iNeigh(0:mNeigh, nAtom))
   iNeigh(:,:) = 0
   iNeigh(:nNeigh, :nAtom) = iTmp

   call move_alloc(dist2, rTmp)
   allocate(dist2(0:mNeigh, nAtom))
   dist2(:,:) = 0.0_wp
   dist2(:nNeigh, :nAtom) = rTmp

   rTmp(:,:) = weight
   deallocate(weight)
   allocate(weight(0:mNeigh, nAtom))
   weight(:,:) = 0.0_wp
   weight(:nNeigh, :nAtom) = rTmp

end subroutine resizeNeigh


end module xtb_type_neighbourlist

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_eeq
   use, intrinsic :: iso_fortran_env, only : istdout => output_unit
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_blas, only : mctc_gemv, mctc_gemm, mctc_symv, mctc_copy, mctc_dot
   use xtb_mctc_lapack, only : lapack_sytrf, lapack_sytri
   use xtb_type_environment, only : TEnvironment
   use xtb_gfn0param, alp => alpg
   use xtb_coulomb_ewald, only : ewaldMatPBC3D, ewaldDerivPBC3D => ewaldDerivPBC3D_alp
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_param
   use xtb_type_wsc, only : tb_wsc
   implicit none

   public :: eeq_chrgeq
   public :: goedecker_chrgeq
   private

   ! √(2/π)
   real(wp),parameter :: sqrt2pi = sqrt(2.0_wp/pi)

   interface eeq_chrgeq
      module procedure :: eeq_chrgeq_core
      module procedure :: eeq_chrgeq_gbsa
      module procedure :: eeq_chrgeq_qonly
   end interface eeq_chrgeq

   interface get_coulomb_matrix
      module procedure :: get_coulomb_matrix_0d
      module procedure :: get_coulomb_matrix_3d
   end interface get_coulomb_matrix


   interface get_coulomb_derivs
      module procedure :: get_coulomb_derivs_0d
      module procedure :: get_coulomb_derivs_3d
   end interface get_coulomb_derivs


contains


subroutine get_coulomb_matrix_0d(mol, chrgeq, amat)
   type(TMolecule), intent(in) :: mol
   type(chrg_parameter), intent(in) :: chrgeq
   real(wp), intent(out) :: amat(:, :)
   integer :: iat, jat
   real(wp) :: r1, gamij
   Amat = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) shared(mol,chrgeq, amat) &
   !$omp private(jat, r1, gamij)
   do iat = 1, len(mol)
      ! EN of atom i
      do jat = 1, iat-1
         r1 = sqrt(sum((mol%xyz(:,jat) - mol%xyz(:,iat))**2))
         gamij = 1.0_wp/sqrt(chrgeq%alpha(iat)**2+chrgeq%alpha(jat)**2)
         Amat(jat, iat) = erf(gamij*r1)/r1
         Amat(iat, jat) = Amat(jat,iat)
      enddo
      Amat(iat, iat) = chrgeq%gam(iat) + sqrt2pi/chrgeq%alpha(iat)
   enddo
   !$omp end parallel do
end subroutine get_coulomb_matrix_0d

subroutine get_coulomb_matrix_3d(mol, wsc, chrgeq, rTrans, gTrans, cf, amat)
   use xtb_type_molecule
   use xtb_type_param
   type(TMolecule), intent(in) :: mol
   type(tb_wsc), intent(in) :: wsc
   type(chrg_parameter), intent(in) :: chrgeq
   real(wp), intent(in) :: rTrans(:, :)
   real(wp), intent(in) :: gTrans(:, :)
   real(wp), intent(in) :: cf
   real(wp), intent(out) :: amat(:, :)
   integer, parameter :: ewaldCutD(3) = 2
   integer, parameter :: ewaldCutR(3) = 2
   real(wp), parameter :: zero(3) = 0.0_wp
   integer :: iat, jat, wscAt, iG1, iG2, iG3, iRp
   real(wp) :: gamii, gamij, riw(3), gVec(3)

   amat = 0.0_wp
   !$omp parallel do default(none) reduction(+:amat) &
   !$omp shared(mol, wsc, chrgeq, cf, gTrans, rTrans) &
   !$omp private(iat, jat, wscAt, gamii, gamij, riw)
   do iat = 1, len(mol)
      gamii = 1.0_wp/(sqrt(2.0_wp)*chrgeq%alpha(iat))
      amat(iat, iat) = chrgeq%gam(iat) + sqrt2pi/chrgeq%alpha(iat) &
         ! reciprocal for 0th atom
         + ewaldMatPBC3D(zero, gTrans, 0.0_wp, mol%volume, cf, 1.0_wp) &
         ! direct for 0th atom
         + eeq_ewald_3d_dir(zero, rTrans, gamii, cf, 1.0_wp)
      do jat = 1, iat-1
         gamij = 1.0_wp/sqrt(chrgeq%alpha(iat)**2+chrgeq%alpha(jat)**2)
         do wscAt = 1, wsc%itbl(jat,iat)
            ! PGI 20.7 fails with `ICE: Errors in Lowering' for
            ! - matmul(mol%lattice,wsc%lattr(:,wscAt,jat,iat))
            riw = mol%xyz(:,iat) - mol%xyz(:,jat) &
               & - (mol%lattice(:,1) * wsc%lattr(1,wscAt,jat,iat) &
               &  + mol%lattice(:,2) * wsc%lattr(2,wscAt,jat,iat) &
               &  + mol%lattice(:,3) * wsc%lattr(3,wscAt,jat,iat))
            amat(iat,jat) = Amat(iat,jat) &
               ! reciprocal lattice sums
               + ewaldMatPBC3D(riw, gTrans, 0.0_wp, mol%volume, cf, &
                  & wsc%w(jat,iat)) &
               ! direct lattice sums
               + eeq_ewald_3d_dir(riw, rTrans, gamij, cf, wsc%w(jat,iat))
         end do
         amat(jat,iat) = amat(iat,jat)
      end do
   end do
   !$omp end parallel do
end subroutine get_coulomb_matrix_3d

subroutine get_coulomb_derivs_0d(mol, chrgeq, qvec, amatdr, atrace)
   use xtb_type_molecule
   use xtb_type_param
   type(TMolecule), intent(in) :: mol
   type(chrg_parameter), intent(in) :: chrgeq
   real(wp), intent(in) :: qvec(:)
   real(wp), intent(out) :: amatdr(:, :, :)
   real(wp), intent(out) :: atrace(:, :)
   integer :: iat, jat
   real(wp) :: rij(3), r2, gamij2, arg2
   real(wp) :: dE, dG(3)
   amatdr = 0.0_wp
   atrace = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) reduction(+:atrace, amatdr) &
   !$omp shared(mol,chrgeq, qvec) private(jat, rij, r2, gamij2, arg2, dE, dG)
   do iat = 1, len(mol)
      ! EN of atom i
      do jat = 1, iat-1
         rij = mol%xyz(:,iat) - mol%xyz(:,jat)
         r2 = sum(rij**2)
         gamij2 = 1.0_wp/(chrgeq%alpha(iat)**2+chrgeq%alpha(jat)**2)
         arg2 = gamij2*r2
         dE = erf(sqrt(arg2))/sqrt(r2)
         dG = (2*sqrt(gamij2)*exp(-arg2)/sqrtpi - dE) * rij/r2
         amatdr(:, iat, jat) = amatdr(:, iat, jat) + dG*qvec(iat)
         amatdr(:, jat, iat) = amatdr(:, jat, iat) - dG*qvec(jat)
         atrace(:, iat) = atrace(:, iat) + dG*qvec(jat)
         atrace(:, jat) = atrace(:, jat) - dG*qvec(iat)
      enddo
   enddo
   !$omp end parallel do
end subroutine get_coulomb_derivs_0d

subroutine get_coulomb_derivs_3d(mol, wsc, chrgeq, qvec, rTrans, gTrans, cf, &
      & amatdr, amatdL, atrace)
   use xtb_type_molecule
   use xtb_type_param
   type(TMolecule), intent(in) :: mol
   type(tb_wsc), intent(in) :: wsc
   type(chrg_parameter), intent(in) :: chrgeq
   real(wp), intent(in) :: cf
   real(wp), intent(in) :: qvec(:)
   real(wp), intent(in) :: gTrans(:, :)
   real(wp), intent(in) :: rTrans(:, :)
   real(wp), intent(out) :: amatdr(:, :, :)
   real(wp), intent(out) :: amatdL(:, :, :)
   real(wp), intent(out) :: atrace(:, :)
   integer, parameter :: ewaldCutD(3) = 2
   integer, parameter :: ewaldCutR(3) = 2
   real(wp), parameter :: zero(3) = 0.0_wp
   integer :: iat, jat, wscAt, ii
   real(wp) :: gamij, dG(3), dS(3, 3), riw(3)
   integer :: iG1, iG2, iG3, iRp
   real(wp) :: gVec(3)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   amatdr = 0.0_wp
   amatdL = 0.0_wp
   atrace = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) &
   !$omp reduction(+:atrace,amatdr,amatdL) &
   !$omp shared(mol, wsc, chrgeq, qvec, cf, gTrans, rTrans) &
   !$omp private(iat, jat, ii, wscAt, riw, gamij, dG, dS)
   do iat = 1, len(mol)
      do jat = 1, iat-1
         ! over WSC partner
         gamij = 1.0_wp/sqrt(chrgeq%alpha(iat)**2 + chrgeq%alpha(jat)**2)
         do wscAt = 1, wsc%itbl(jat,iat)
            ! PGI 20.7 fails with `ICE: Errors in Lowering' for
            ! - matmul(mol%lattice,wsc%lattr(:,wscAt,jat,iat))
            riw = mol%xyz(:,iat) - mol%xyz(:,jat) &
               & - (mol%lattice(:,1) * wsc%lattr(1,wscAt,jat,iat) &
               &  + mol%lattice(:,2) * wsc%lattr(2,wscAt,jat,iat) &
               &  + mol%lattice(:,3) * wsc%lattr(3,wscAt,jat,iat))
            call ewaldDerivPBC3D(riw, gTrans, 0.0_wp, mol%volume, cf, &
               & wsc%w(jat,iat), dG, dS)
            amatdr(:, iat, jat) = amatdr(:, iat, jat) + dG*qvec(iat)
            amatdr(:, jat, iat) = amatdr(:, jat, iat) - dG*qvec(jat)
            atrace(:, iat) = atrace(:, iat) + dG*qvec(jat)
            atrace(:, jat) = atrace(:, jat) - dG*qvec(iat)
            amatdL(:, :, iat) = amatdL(:, :, iat) + dS*qvec(jat)
            amatdL(:, :, jat) = amatdL(:, :, jat) + dS*qvec(iat)
            call eeq_ewald_dx_3d_dir(riw, rTrans, gamij, cf, wsc%w(jat,iat), &
               &                     dG,dS)
            amatdr(:, iat, jat) = amatdr(:, iat, jat) + dG*qvec(iat)
            amatdr(:, jat, iat) = amatdr(:, jat, iat) - dG*qvec(jat)
            atrace(:, iat) = atrace(:, iat) + dG*qvec(jat)
            atrace(:, jat) = atrace(:, jat) - dG*qvec(iat)
            amatdL(:, :, iat) = amatdL(:, :, iat) + dS*qvec(jat)
            amatdL(:, :, jat) = amatdL(:, :, jat) + dS*qvec(iat)
         enddo  ! k WSC partner
      enddo     ! jat

      gamij = 1.0_wp/(sqrt(2.0_wp)*chrgeq%alpha(iat))
      call ewaldDerivPBC3D(zero, gTrans, 0.0_wp, mol%volume, cf, 1.0_wp, dG, dS)
      amatdL(:, :, iat) = amatdL(:, :, iat) + dS*qvec(iat)
      call eeq_ewald_dx_3d_dir(zero, rTrans, gamij, cf, 1.0_wp, dG, dS)
      amatdL(:, :, iat) = amatdL(:, :, iat) + (dS+unity*cf/sqrtpi/3.0_wp)*qvec(iat)
   enddo
   !$omp end parallel do
end subroutine get_coulomb_derivs_3d


pure function eeq_ewald_3d_dir(riw,rTrans,gamij,cf,scale) result(Amat)
   use xtb_mctc_constants
   implicit none
   real(wp),intent(in) :: riw(3)    !< distance from i to WSC atom
   real(wp),intent(in) :: rTrans(:,:) !< direct lattice
   real(wp),intent(in) :: gamij     !< interaction radius
   real(wp),intent(in) :: cf        !< convergence factor
   real(wp),intent(in) :: scale
   real(wp) :: Amat                 !< element of interaction matrix
   real(wp),parameter :: eps = 1.0e-9_wp
   integer  :: dx,dy,dz,itr
   real(wp) :: distiw,rij(3)
   real(wp) :: t(3)
   Amat = 0.0_wp
   do itr = 1, size(rTrans, dim=2)
      rij = riw + rTrans(:, itr)
      distiw = sqrt(sum(rij**2))
      ! self-interaction correction
      if(distiw < eps) then
         Amat = Amat - cf/sqrtpi
      else
         Amat = Amat - erf(   cf*distiw)/distiw &
            &        + erf(gamij*distiw)/distiw
      end if
   end do
   Amat = Amat * scale
end function eeq_ewald_3d_dir

pure subroutine eeq_ewald_dx_3d_dir(riw,rTrans,gamij,cf,scale,dAmat,sigma)
   use xtb_mctc_constants
   use xtb_pbc_tools
   implicit none
   real(wp),intent(in) :: riw(3)    !< distance from i to WSC atom
   real(wp),intent(in) :: rTrans(:,:)
   real(wp),intent(in) :: gamij     !< interaction radius
   real(wp),intent(in) :: cf        !< convergence factor
   real(wp),intent(in) :: scale
   real(wp),intent(out) :: dAmat(3) !< element of interaction matrix
   real(wp),intent(out) :: sigma(3,3)
   real(wp),parameter :: eps = 1.0e-9_wp
   integer  :: dx,dy,dz,i,itr
   real(wp) :: distiw,rij(3),arga,argb
   real(wp) :: t(3),dtmp,stmp(3)
   dAmat = 0.0_wp
   sigma = 0.0_wp
   do itr = 1, size(rTrans, dim=2)
      ! real contributions
      rij = riw + rTrans(:, itr)
      distiw = sqrt(sum(rij**2))
      if(distiw < eps) cycle
      arga = cf**2   *distiw**2
      stmp = + exp(-arga)/sqrtpi * cf * 2.0_wp / 3.0_wp
      do i = 1, 3
         sigma(i,i) = sigma(i,i) + stmp(i)! * rij(i)**2
      enddo
      argb = gamij**2*distiw**2
      dtmp = - 2*cf*exp(-arga)/(sqrtpi*distiw**2) &
         &   + erf(cf*distiw)/(distiw**3)           &
         &   + 2*gamij*exp(-argb)/(sqrtpi*distiw**2) &
         &   - erf(gamij*distiw)/(distiw**3)
      dAmat = dAmat + rij*dtmp
      sigma = sigma + dtmp*outer_prod_3x3(rij,rij)
   enddo
   dAmat = dAmat * scale
   sigma = sigma * scale

end subroutine eeq_ewald_dx_3d_dir


!! ========================================================================
!  Purpose:
!! ------------------------------------------------------------------------
!  calculate energies and properties from the Goedecker charge model
!  using the parametrisation from the GFN0-xTB.
!
!  Input:
!! ------------------------------------------------------------------------
!  n                 - number of atoms
!  at(n)             - atom type/ordinal number
!  xyz(3,n)          - molecular geometry
!  chrg              - total charge of the system
!  cn(n)             - coordination number (usually erf-CN)
!  dcndr(3,n,n)      - derivative of the coordination number
!                      (switched indices are assumed here!)
!
!  Output:
!! ------------------------------------------------------------------------
!  q(n)              - partial charges
!  dqdr(3,n,n+1)     - derivative of the partial charges and
!                      Lagrange multiplier (n+1 instead of n!)
!
!  Input/Output:
!! ------------------------------------------------------------------------
!  energy            - isotropic electrostatic energy
!  gradient(3,n)     - molecular gradient
!
!  Citation:
!! ------------------------------------------------------------------------
!  Original work: S. Alireza Ghasemi, Albert Hofstetter, Santanu Saha, and
!                 Stefan Goedecker, PHYSICAL REVIEW B 92, 045131 (2015).
!  This work:     S. Ehlert, E. Caldeweyher, S. Spicher and S. Grimme,
!                 to be published.
!
!  Note: For computational effiency this routine does NOT work with the
!        energy expression but with the Lagrangian (n+1 instead of n),
!        therefore, all intermediates live in the space of the Lagrangian.
!
!  Implemented by SAW in 2018, see focusing lab course report for details.
!! ========================================================================
subroutine goedecker_chrgeq(n,at,xyz,chrg,cn,dcndr,q,dqdr,energy,gradient,&
                            lverbose,lgrad,lcpq)
   implicit none

!! ------------------------------------------------------------------------
!  Input
!! ------------------------------------------------------------------------
   integer, intent(in)    :: n             ! number of atoms
   integer, intent(in)    :: at(n)         ! ordinal numbers
   real(wp),intent(in)    :: xyz(3,n)      ! geometry
   real(wp),intent(in)    :: chrg          ! total charge
   real(wp),intent(in)    :: cn(n)         ! erf-CN
   real(wp),intent(in),optional :: dcndr(3,n,n)  ! derivative of erf-CN
   logical, intent(in)    :: lverbose      ! toggles printout
   logical, intent(in)    :: lgrad         ! flag for gradient calculation
   logical, intent(in)    :: lcpq          ! do partial charge derivative
!! --------
!  Output
!! ------------------------------------------------------------------------
   real(wp),intent(out), optional   :: q(n)          ! partial charges
   real(wp),intent(out), optional   :: dqdr(3,n,n) ! derivative of partial charges
   real(wp),intent(inout), optional :: energy        ! electrostatic energy
   real(wp),intent(inout), optional :: gradient(3,n) ! molecular gradient of IES
!
!! ------------------------------------------------------------------------
!  charge model
!! ------------------------------------------------------------------------
   integer  :: m ! dimension of the Lagrangian
   real(wp),allocatable :: Amat(:,:)
   real(wp),allocatable :: Xvec(:)
   real(wp),allocatable :: Ainv(:,:)
   real(wp),allocatable :: dAmat(:,:,:)
   real(wp),allocatable :: dXvec(:,:,:)

!! ------------------------------------------------------------------------
!  local variables
!! ------------------------------------------------------------------------
   integer  :: i,j,k,l
   real(wp) :: r,rij(3),r2
   real(wp) :: gamij,gamij2
   real(wp) :: arg,tmp,dtmp
   real(wp) :: lambda
   real(wp) :: es

!! ------------------------------------------------------------------------
!  scratch variables
!! ------------------------------------------------------------------------
   real(wp),allocatable :: alpha(:)
   real(wp),allocatable :: xtmp(:)
   real(wp),allocatable :: atmp(:,:)
   real(wp),allocatable :: Xfac(:)
   real(wp),allocatable :: Afac(:,:)

!! ------------------------------------------------------------------------
!  Lapack work variables
!! ------------------------------------------------------------------------
   integer, allocatable :: ipiv(:)
   real(wp),allocatable :: temp(:)
   real(wp),allocatable :: work(:)
   integer  :: lwork
   integer  :: info
   real(wp) :: test(1)

!! ------------------------------------------------------------------------
!  initial banner if verbose
!! ------------------------------------------------------------------------
   if (lverbose) then
      write(istdout,'(72("="),/,1x,a,/,72("="),/)') &
         "GOEDECKER CHARGE MODEL USING GFN0-xTB PARAMETRIZATION"
   endif

!! ------------------------------------------------------------------------
!  initizialization
!! ------------------------------------------------------------------------
   m    = n+1
   q    = 0.0_wp
   allocate( ipiv(m), source = 0 )
   allocate( Amat(m,m), Xvec(m), Xfac(m), alpha(n), source = 0.0_wp )

!! ------------------------------------------------------------------------
!  set up the A matrix and X vector
!! ------------------------------------------------------------------------
!  αi -> alpha(i), ENi -> xi(i), κi -> kappa(i), Jii -> gam(i)
!  γij = 1/√(αi+αj)
!  Xi  = -ENi + κi·√CNi
!  Aii = Jii + 2/√π·γii
!  Aij = erf(γij·Rij)/Rij = 2/√π·F0(γ²ij·R²ij)
!! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Setup of the A matrix and the RHS X vector"
!  prepare some arrays
!$omp parallel default(none) &
!$omp shared(n,at,cn,xi,cnfak,alp,gamm) &
!$omp private(i,tmp) &
!$omp shared(Xvec,Xfac,alpha)
!$omp do schedule(runtime)
   do i = 1, n
      tmp = cnfak(at(i))/(sqrt(cn(i))+1e-14_wp)
      Xvec(i) = -xi(at(i)) + tmp*cn(i)
      Xfac(i) = 0.5_wp*tmp
      alpha(i) = alp(at(i))**2
   enddo
!$omp enddo
!$omp endparallel

!$omp parallel default(none) &
!$omp shared(n,at,xyz,gamm,alpha) &
!$omp private(i,j,r,gamij) &
!$omp shared(Xvec,Xfac,Amat)
!$omp do schedule(runtime)
   ! prepare A matrix
   do i = 1, n
      ! EN of atom i
      do j = 1, i-1
         r = sqrt(sum((xyz(:,j) - xyz(:,i))**2))
         gamij = 1.0_wp/sqrt(alpha(i)+alpha(j))
         Amat(j,i) = erf(gamij*r)/r
         Amat(i,j) = Amat(j,i)
      enddo
      Amat(i,i) = gamm(at(i)) + sqrt2pi/sqrt(alpha(i))
   enddo
!$omp enddo
!$omp endparallel

!! ------------------------------------------------------------------------
!  solve the linear equations to obtain partial charges
!! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Solve the linear equations to obtain partial charges"
   Amat(m,1:m) = 1.0_wp
   Amat(1:m,m) = 1.0_wp
   Amat(m,m  ) = 0.0_wp
   Xvec(m)     = chrg
   ! generate temporary copy
   allocate( Atmp(m,m), source = Amat )
   allocate( Xtmp(m),   source = Xvec )

   ! assume work space query, set best value to test after first dsysv call
   call dsysv('u', m, 1, Atmp, m, ipiv, Xtmp, m, test, -1, info)
   lwork = int(test(1))
   allocate( work(lwork), source = 0.0_wp )

   call dsysv('u',m,1,Atmp,m,ipiv,Xtmp,m,work,lwork,info)
   if(info > 0) call raise('E','(goedecker_solve) DSYSV failed')

   q = Xtmp(:n)
   if(abs(sum(q)-chrg) > 1.e-6_wp) &
      call raise('E','(goedecker_solve) charge constrain error')
   !print'(3f20.14)',Xtmp

   lambda = Xtmp(m)
   if (lverbose) then
      write(istdout,'(72("-"))')
      write(istdout,'(1x,a,1x,f20.14)') &
         "lambda       :",lambda,&
         "total charge :",sum(q)
   endif

!! ------------------------------------------------------------------------
!  calculate isotropic electrostatic (IES) energy
!! ------------------------------------------------------------------------
!  E = ∑i (ENi - κi·√CNi)·qi + ∑i (Jii + 2/√π·γii)·q²i
!      + ½ ∑i ∑j,j≠i qi·qj·2/√π·F0(γ²ij·R²ij)
!    = q·(½A·q - X)
!! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Isotropic electrostatic (IES) energy calculation"
   call mctc_copy(Xvec, work)
   call mctc_symv(Amat, Xtmp, work, alpha=0.5_wp, beta=-1.0_wp)
   es = mctc_dot(Xtmp, work)
   energy = es + energy
   if (lverbose) then
      write(istdout,'(72("-"))')
      write(istdout,'(1x,a,1x,f20.14)') &
         "energy",es
   endif

!! ------------------------------------------------------------------------
!  calculate molecular gradient of the IES energy
!! ------------------------------------------------------------------------
!  dE/dRj -> g(:,j), ∂Xi/∂Rj -> -dcn(:,i,j), ½∂Aij/∂Rj -> dAmat(:,j,i)
!  dE/dR = (½∂A/∂R·q - ∂X/∂R)·q
!  ∂Aij/∂Rj = ∂Aij/∂Ri
!! ------------------------------------------------------------------------
do_molecular_gradient: if (lgrad .or. lcpq) then
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "molecular gradient calculation"
   allocate( dAmat(3,n,m), dXvec(3,n,m), Afac(3,n), source = 0.0_wp )
   !allocate( dAmat(3,n,m), Afac(3,n), source = 0.0_wp )
!$omp parallel default(none) &
!$omp shared(n,dcndr,xyz,alpha,Amat,Xfac,Xtmp) &
!$omp private(i,j,rij,r2,gamij,arg,dtmp) &
!$omp shared(dXvec,dAmat) &
!$omp reduction(+:Afac)
!$omp do schedule(runtime)
   do i = 1, n
      dXvec(:,i,i) = +dcndr(:,i,i)*Xfac(i) ! merge dX and dA for speedup
      do j = 1, i-1
         dXvec(:,j,i) = dcndr(:,i,j)*Xfac(i)
         dXvec(:,i,j) = dcndr(:,j,i)*Xfac(j)
         rij = xyz(:,i) - xyz(:,j)
         r2 = sum(rij**2)
         gamij = 1.0_wp/sqrt(alpha(i) + alpha(j))
         arg = gamij**2*r2
         dtmp = 2.0_wp*gamij*exp(-arg)/(sqrtpi*r2)-Amat(j,i)/r2
         Afac(:,i) = +dtmp*rij*Xtmp(j) + Afac(:,i)
         Afac(:,j) = -dtmp*rij*Xtmp(i) + Afac(:,j)
         dAmat(:,i,j) = +dtmp*rij*Xtmp(i) !+ dcndr(:,i,j)*Xfac(i)
         dAmat(:,j,i) = -dtmp*rij*Xtmp(j) !+ dcndr(:,j,i)*Xfac(j)
      enddo
      !dAmat(:,i,i) = +dcndr(:,i,i)*Xfac(i)
   enddo
!$omp enddo
!$omp endparallel
endif do_molecular_gradient

   if (lgrad) then
   call mctc_gemv(dAmat,Xtmp,gradient,alpha=+1.0_wp,beta=1.0_wp)
   call mctc_gemv(dXvec,Xtmp,gradient,alpha=-1.0_wp,beta=1.0_wp)
   endif

!! ------------------------------------------------------------------------
!  invert the A matrix using a Bunch-Kaufman factorization
!  A⁻¹ = (L·D·L^T)⁻¹ = L^T·D⁻¹·L
!! ------------------------------------------------------------------------
do_partial_charge_derivative: if (lcpq) then
   dqdr = 0.0_wp
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "A matrix inversion by Bunch-Kaufman factorization"
   allocate( Ainv(m,m), source = Amat )

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L',m,Ainv,m,ipiv,test,-1,info)
   if (int(test(1)) > lwork) then
      deallocate(work)
      lwork=int(test(1))
      allocate( work(lwork), source = 0.0_wp )
   endif

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L',m,Ainv,m,ipiv,work,lwork,info)
   if(info > 0)then
      call raise('E', '(goedecker_inversion) DSYTRF failed')
   endif

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in Ainv matrix
   ! Ainv matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L',m,Ainv,m,ipiv,work,info)
   if (info > 0) then
      call raise('E', '(goedecker_inversion) DSYTRI failed')
   endif

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do i = 1, m
      do j = i+1, m
         Ainv(i,j)=Ainv(j,i)
      enddo
   enddo

!! ------------------------------------------------------------------------
!  calculate gradient of the partial charge w.r.t. the nuclear coordinates
!! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "calculating the derivative of the partial charges"
   do i = 1, n
      dAmat(:,i,i) = Afac(:,i) + dAmat(:,i,i)
   enddo
   call mctc_gemm(dAmat, Ainv, dqdr, alpha=-1.0_wp, beta=1.0_wp)
   call mctc_gemm(dXvec, Ainv, dqdr, alpha=+1.0_wp, beta=1.0_wp)
   !print'(/,"analytical gradient")'
   !print'(3f20.14)',dqdr(:,:,:n)

endif do_partial_charge_derivative

!! ------------------------------------------------------------------------
!  Clean up
!! ------------------------------------------------------------------------
   if (allocated(alpha)) deallocate(alpha)
   if (allocated(Amat))  deallocate(Amat)
   if (allocated(dAmat)) deallocate(dAmat)
   if (allocated(Afac))  deallocate(Afac)
   if (allocated(Xvec))  deallocate(Xvec)
   if (allocated(Xfac))  deallocate(Xfac)
   if (allocated(Xtmp))  deallocate(Xtmp)
   if (allocated(Atmp))  deallocate(Atmp)
   if (allocated(temp))  deallocate(temp)
   if (allocated(work))  deallocate(work)
   if (allocated(ipiv))  deallocate(ipiv)

end subroutine goedecker_chrgeq

subroutine eeq_chrgeq_qonly(mol,env,chrgeq,cn,q,lverbose)

   use xtb_type_molecule
   use xtb_type_param

   implicit none

! ------------------------------------------------------------------------
!  Input
! ------------------------------------------------------------------------
   type(TMolecule),intent(in) :: mol     !< molecular structure information
   real(wp),intent(in)    :: cn(mol%n)     ! erf-CN
   type(chrg_parameter),intent(in) :: chrgeq
   real(wp),allocatable   :: dcndr(:,:,:)
   real(wp),allocatable   :: dcndL(:,:,:)
   logical, intent(in), optional :: lverbose
   logical :: verbose
   type(TEnvironment), intent(inout) :: env

! ------------------------------------------------------------------------
!  Output
! ------------------------------------------------------------------------
   real(wp),intent(out)   :: q(mol%n)
   real(wp),allocatable   :: dqdr(:,:,:)
   real(wp),allocatable   :: dqdL(:,:,:)
   real(wp)               :: energy
   real(wp),allocatable   :: gradient(:,:)
   real(wp),allocatable   :: sigma(:,:)

   if (present(lverbose)) then
      verbose = lverbose
   else
      verbose = .false.
   endif

   call eeq_chrgeq_core(mol,env,chrgeq,cn,dcndr,dcndL,q,dqdr,dqdL, &
      &                 energy,gradient,sigma,verbose,.false.,.false.)

end subroutine eeq_chrgeq_qonly

! ======================================================================
!  Modified Version of eeq_chrgeq routine that reads also the chrgeq construct
! ======================================================================
subroutine eeq_chrgeq_core(mol,env,chrgeq,cn,dcndr,dcndL,q,dqdr,dqdL, &
      &                    energy,gradient,sigma,lverbose,lgrad,lcpq)

   use xtb_mctc_convert

   use xtb_type_molecule
   use xtb_type_param

   use xtb_disp_ncoord

   use xtb_pbc_tools

   implicit none

   character(len=*), parameter :: source = 'eeq_chrgeq'

! ------------------------------------------------------------------------
!  Input
! ------------------------------------------------------------------------
   type(TMolecule),intent(in) :: mol     !< molecular structure information
   real(wp),intent(in)    :: cn(mol%n)     ! erf-CN
   real(wp),intent(in)    :: dcndr(3,mol%n,mol%n) ! derivative of erf-CN
   real(wp),intent(in)    :: dcndL(3,3,mol%n) ! derivative of erf-CN
   logical, intent(in)    :: lverbose      ! toggles printout
   logical, intent(in)    :: lgrad         ! flag for gradient calculation
   logical, intent(in)    :: lcpq          ! do partial charge derivative
   type(chrg_parameter),intent(in) :: chrgeq
   type(TEnvironment), intent(inout) :: env

! ------------------------------------------------------------------------
!  Output
! ------------------------------------------------------------------------
   real(wp),intent(out)   :: q(mol%n)          ! partial charges
   real(wp),intent(out)   :: dqdr(3,mol%n,mol%n) ! derivative of partial charges
   real(wp),intent(out)   :: dqdL(3,3,mol%n) ! derivative of partial charges
   real(wp),intent(inout) :: energy        ! electrostatic energy
   real(wp),intent(inout) :: gradient(3,mol%n) ! molecular gradient of IES
   real(wp),intent(inout) :: sigma(3,3) ! molecular gradient of IES
!
! ------------------------------------------------------------------------
!  charge model
! ------------------------------------------------------------------------
   integer  :: m ! dimension of the Lagrangian
   real(wp),allocatable :: Amat(:,:)
   real(wp),allocatable :: Xvec(:)
   real(wp),allocatable :: Ainv(:,:)
   real(wp),allocatable :: dAmatdr(:,:,:)
   real(wp),allocatable :: dAmatdL(:,:,:)
   real(wp),allocatable :: dXvecdr(:,:,:)
   real(wp),allocatable :: dXvecdL(:,:,:)

! ------------------------------------------------------------------------
!  local variables
! ------------------------------------------------------------------------
   integer  :: i,j,k,l
   real(wp) :: r,rij(3),r2
   real(wp) :: gamij,gamij2
   real(wp) :: arg,tmp,dtmp
   real(wp) :: lambda
   real(wp) :: es

! ------------------------------------------------------------------------
!  for periodic case
! ------------------------------------------------------------------------
   integer  :: wscAt
   real(wp) :: gamii,riw(3),dAtmp(3),stmp(3,3),vec(3)
   real(wp) :: cf ! convergence factor
   integer, parameter :: ewaldCutD(3) = 2
   integer, parameter :: ewaldCutR(3) = 2
   real(wp), allocatable :: gTrans(:, :)
   real(wp), allocatable :: rTrans(:, :)
   integer :: iG1, iG2, iG3, iT1, iT2, iT3, iRp

   interface
      subroutine generate_wsc(mol,wsc)
         import :: TMolecule, tb_wsc
         type(TMolecule), intent(in) :: mol
         type(tb_wsc),    intent(inout) :: wsc
      end subroutine generate_wsc
   end interface

   type(tb_wsc) :: wsc

! ------------------------------------------------------------------------
!  scratch variables
! ------------------------------------------------------------------------
   real(wp),allocatable :: xtmp(:)
   real(wp),allocatable :: atmp(:,:)
   real(wp),allocatable :: Xfac(:)
   real(wp),allocatable :: Afac(:,:)

! ------------------------------------------------------------------------
!  Lapack work variables
! ------------------------------------------------------------------------
   integer, allocatable :: ipiv(:)
   real(wp),allocatable :: temp(:)
   real(wp),allocatable :: work(:)
   integer  :: lwork
   integer  :: info
   real(wp) :: test(1)

! ------------------------------------------------------------------------
!  initizialization
! ------------------------------------------------------------------------
   m    = mol%n+1
   q    = 0.0_wp
   allocate( ipiv(m), source = 0 )
   allocate( Amat(m,m), Xvec(m), Xfac(m), source = 0.0_wp )

! ------------------------------------------------------------------------
!  set up the A matrix and X vector
! ------------------------------------------------------------------------
!  αi -> alpha(i), ENi -> xi(i), κi -> kappa(i), Jii -> gam(i)
!  γij = 1/√(αi+αj)
!  Xi  = -ENi + κi·√CNi
!  Aii = Jii + 2/√π·γii
!  Aij = erf(γij·Rij)/Rij = 2/√π·F0(γ²ij·R²ij)
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Setup of the A matrix and the RHS X vector"

   ! prepare some arrays
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(mol,cn,chrgeq) private(i,tmp) shared(Xvec,Xfac)
   do i = 1, mol%n
      tmp = chrgeq%kappa(i)/(sqrt(cn(i))+1e-14_wp)
      Xvec(i) = -chrgeq%en(i) + tmp*cn(i)
      Xfac(i) = 0.5_wp*tmp
   enddo
   !$omp end parallel do

   if (mol%npbc > 0) then
      call generate_wsc(mol, wsc)

      iRp = 0
      allocate(gTrans(3, product(2*ewaldCutR+1)-1))
      do iG1 = -ewaldCutR(1), ewaldCutR(1)
         do iG2 = -ewaldCutR(2), ewaldCutR(2)
            do iG3 = -ewaldCutR(3), ewaldCutR(3)
               if (iG1 == 0 .and. iG2 == 0 .and. iG3 == 0) cycle
               iRp = iRp + 1
               vec(:) = [iG1, iG2, iG3]
               gTrans(:, iRp) = matmul(mol%rec_lat, vec)
            end do
         end do
      end do

      iRp = 0
      allocate(rTrans(3, product(2*ewaldCutD+1)))
      do iT1 = -ewaldCutD(1), ewaldCutD(1)
         do iT2 = -ewaldCutD(2), ewaldCutD(2)
            do iT3 = -ewaldCutD(3), ewaldCutD(3)
               iRp = iRp + 1
               vec(:) = [iT1, iT2, iT3]
               rTrans(:, iRp) = matmul(mol%lattice, vec)
            end do
         end do
      end do

      cf = sqrtpi/mol%volume**(1.0_wp/3.0_wp)
      ! build Ewald matrix
      call get_coulomb_matrix(mol, wsc, chrgeq, rTrans, gTrans, cf, amat)
   else
      call get_coulomb_matrix(mol, chrgeq, amat)
   endif

! ------------------------------------------------------------------------
!  solve the linear equations to obtain partial charges
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Solve the linear equations to obtain partial charges"
   Amat(m,1:m) = 1.0_wp
   Amat(1:m,m) = 1.0_wp
   Amat(m,m  ) = 0.0_wp
   Xvec(m)     = mol%chrg
   ! generate temporary copy
   allocate( Atmp(m,m), source = Amat )
   allocate( Xtmp(m),   source = Xvec )

   ! assume work space query, set best value to test after first dsysv call
   call dsysv('u', m, 1, Atmp, m, ipiv, Xtmp, m, test, -1, info)
   lwork = int(test(1))
   allocate( work(lwork), source = 0.0_wp )

   call dsysv('u',m,1,Atmp,m,ipiv,Xtmp,m,work,lwork,info)
   if(info > 0) then
      call env%error("Coulomb matrix is singular, cannot solve lin. eq.", source)
      return
   end if

   q = Xtmp(:mol%n)
   if(abs(sum(q)-mol%chrg) > 1.e-6_wp) then
      call env%error("Charge constraint is not satisfied", source)
      return
   end if
   !print'(3f20.14)',Xtmp

   lambda = Xtmp(m)
   if (lverbose) then
      write(istdout,'(72("-"))')
      write(istdout,'(1x,a,1x,f20.14)') &
         "lambda       :",lambda,&
         "total charge :",sum(q)
   endif

! ------------------------------------------------------------------------
!  calculate isotropic electrostatic (IES) energy
! ------------------------------------------------------------------------
!  E = ∑i (ENi - κi·√CNi)·qi + ∑i (Jii + 2/√π·γii)·q²i
!      + ½ ∑i ∑j,j≠i qi·qj·2/√π·F0(γ²ij·R²ij)
!    = q·(½A·q - X)
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Isotropic electrostatic (IES) energy calculation"
   call mctc_copy(Xvec, work)
   call mctc_symv(Amat, Xtmp, work, alpha=0.5_wp, beta=-1.0_wp)
   es = mctc_dot(Xtmp, work)
   energy = es + energy
   if (lverbose) then
      write(istdout,'(72("-"))')
      write(istdout,'(1x,a,1x,f20.14)') &
         "energy",es
   endif

! ------------------------------------------------------------------------
!  calculate molecular gradient of the IES energy
! ------------------------------------------------------------------------
!  dE/dRj -> g(:,j), ∂Xi/∂Rj -> -dcn(:,i,j), ½∂Aij/∂Rj -> dAmat(:,j,i)
!  dE/dR = (½∂A/∂R·q - ∂X/∂R)·q
!  ∂Aij/∂Rj = ∂Aij/∂Ri
! ------------------------------------------------------------------------
do_molecular_gradient: if (lgrad .or. lcpq) then
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "molecular gradient calculation"
   allocate( dAmatdr(3,mol%n,m), dXvecdr(3,mol%n,m), Afac(3,mol%n), source = 0.0_wp )
   if (mol%npbc > 0) then
      allocate( dAmatdL(3,3,m), dXvecdL(3,3,m), source = 0.0_wp )
      call get_coulomb_derivs(mol, wsc, chrgeq, Xtmp, rTrans, gTrans, cf, &
         & dAmatdr, dAmatdL, Afac)
      do i = 1, mol%n
         dXvecdr(:,:,i) = -dcndr(:,:,i)*Xfac(i)
         dXvecdL(:,:,i) = -dcndL(:,:,i)*Xfac(i)
      enddo
   else
      call get_coulomb_derivs(mol, chrgeq, Xtmp, dAmatdr, Afac)
      do i = 1, mol%n
         dXvecdr(:,:,i) = -dcndr(:,:,i)*Xfac(i) ! merge dX and dA for speedup
      enddo
   endif
endif do_molecular_gradient

   if (lgrad) then
   call mctc_gemv(dAmatdr, Xtmp, gradient, alpha=+1.0_wp, beta=1.0_wp)
   call mctc_gemv(dXvecdr, Xtmp, gradient, alpha=+1.0_wp, beta=1.0_wp)
   if (mol%npbc > 0) then
      call mctc_gemv(dAmatdL, Xtmp, sigma, alpha=+0.5_wp, beta=1.0_wp)
      call mctc_gemv(dXvecdL, Xtmp, sigma, alpha=+1.0_wp, beta=1.0_wp)
   endif
   endif

! ------------------------------------------------------------------------
!  invert the A matrix using a Bunch-Kaufman factorization
!  A⁻¹ = (L·D·L^T)⁻¹ = L^T·D⁻¹·L
! ------------------------------------------------------------------------
do_partial_charge_derivative: if (lcpq) then
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "A matrix inversion by Bunch-Kaufman factorization"
   allocate( Ainv(m,m), source = Amat )

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L',m,Ainv,m,ipiv,test,-1,info)
   if (int(test(1)) > lwork) then
      deallocate(work)
      lwork=int(test(1))
      allocate( work(lwork), source = 0.0_wp )
   endif

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L',m,Ainv,m,ipiv,work,lwork,info)
   if(info > 0)then
      call env%error("Could not factorize Coulomb matrix", source)
      return
   endif

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in Ainv matrix
   ! Ainv matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L',m,Ainv,m,ipiv,work,info)
   if (info > 0) then
      call env%error("Coulomb Matrix is singular, cannot invert", source)
      return
   endif

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do i = 1, m
      do j = i+1, m
         Ainv(i,j)=Ainv(j,i)
      enddo
   enddo

! ------------------------------------------------------------------------
!  calculate gradient of the partial charge w.r.t. the nuclear coordinates
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "calculating the derivative of the partial charges"
   dqdr = 0.0_wp
   if (mol%npbc > 0) then
      dqdL = 0.0_wp
   endif
   do i = 1, mol%n
      dAmatdr(:,i,i) = Afac(:,i) + dAmatdr(:,i,i)
   enddo
   !call dsymm('r','l',3*n,m,-1.0_wp,Ainv,m,dAmatdr,3*n,1.0_wp,dqdr,3*n)
   call mctc_gemm(dAmatdr, Ainv, dqdr, alpha=-1.0_wp, beta=1.0_wp)
   call mctc_gemm(dXvecdr, Ainv, dqdr, alpha=-1.0_wp, beta=1.0_wp)
   if (mol%npbc > 0) then
      call mctc_gemm(dAmatdL, Ainv, dqdL, alpha=-1.0_wp, beta=1.0_wp)
      call mctc_gemm(dXvecdL, Ainv, dqdL, alpha=-1.0_wp, beta=1.0_wp)
   endif
   !print'(/,"analytical gradient")'
   !print'(3f20.14)',dqdr(:,:,:n)

endif do_partial_charge_derivative

! ------------------------------------------------------------------------
!  Clean up
! ------------------------------------------------------------------------
   if (allocated(Amat))  deallocate(Amat)
   if (allocated(dAmatdr)) deallocate(dAmatdr)
   if (allocated(Afac))  deallocate(Afac)
   if (allocated(Xvec))  deallocate(Xvec)
   if (allocated(Xfac))  deallocate(Xfac)
   if (allocated(Xtmp))  deallocate(Xtmp)
   if (allocated(Atmp))  deallocate(Atmp)
   if (allocated(temp))  deallocate(temp)
   if (allocated(work))  deallocate(work)
   if (allocated(ipiv))  deallocate(ipiv)

end subroutine eeq_chrgeq_core


! ======================================================================
!  Modified Version of eeq_chrgeq routine that reads also the chrgeq construct
! ======================================================================
subroutine eeq_chrgeq_gbsa(mol,env,chrgeq,gbsa,cn,dcndr,q,dqdr, &
      &                    energy,gsolv,gradient,lverbose,lgrad,lcpq)

   use xtb_mctc_convert

   use xtb_type_molecule
   use xtb_type_param

   use xtb_disp_ncoord
   use xtb_solv_gbsa, only : TBorn

   use xtb_pbc_tools

   implicit none

   character(len=*), parameter :: source = "eeq_chrgeq_gbsa"

! ------------------------------------------------------------------------
!  Input
! ------------------------------------------------------------------------
   type(TMolecule),intent(in) :: mol     !< molecular structure information
   type(TBorn), intent(in) :: gbsa
   real(wp),intent(in)    :: cn(mol%n)     ! erf-CN
   real(wp),intent(in)    :: dcndr(3,mol%n,mol%n) ! derivative of erf-CN
   logical, intent(in)    :: lverbose      ! toggles printout
   logical, intent(in)    :: lgrad         ! flag for gradient calculation
   logical, intent(in)    :: lcpq          ! do partial charge derivative
   type(chrg_parameter),intent(in) :: chrgeq
   type(TEnvironment), intent(inout) :: env

! ------------------------------------------------------------------------
!  Output
! ------------------------------------------------------------------------
   real(wp),intent(out)   :: q(mol%n)          ! partial charges
   real(wp),intent(out)   :: dqdr(3,mol%n,mol%n) ! derivative of partial charges
   real(wp),intent(inout) :: gsolv        ! electrostatic energy
   real(wp),intent(inout) :: energy        ! electrostatic energy
   real(wp),intent(inout) :: gradient(3,mol%n) ! molecular gradient of IES
!
! ------------------------------------------------------------------------
!  charge model
! ------------------------------------------------------------------------
   integer  :: m ! dimension of the Lagrangian
   real(wp),allocatable :: Amat(:,:)
   real(wp),allocatable :: Xvec(:)
   real(wp),allocatable :: Ainv(:,:)
   real(wp),allocatable :: dAmatdr(:,:,:)
   real(wp),allocatable :: dAmatdL(:,:,:)
   real(wp),allocatable :: dXvecdr(:,:,:)
   real(wp),allocatable :: dXvecdL(:,:,:)

! ------------------------------------------------------------------------
!  local variables
! ------------------------------------------------------------------------
   integer  :: i,j,k,l
   real(wp) :: r,rij(3),r2
   real(wp) :: gamij,gamij2
   real(wp) :: arg,tmp,dtmp
   real(wp) :: lambda
   real(wp) :: es

! ------------------------------------------------------------------------
!  for periodic case
! ------------------------------------------------------------------------
   integer  :: wscAt
   real(wp) :: gamii,riw(3),dAtmp(3),stmp(3,3)
   real(wp) :: cf ! convergence factor
   real(wp),parameter   :: zero(3) = [0.0_wp,0.0_wp,0.0_wp]
   integer              :: rep_cn(3)
   integer, parameter   :: ewaldCutD(3) = [2,2,2]
   integer, parameter   :: ewaldCutR(3) = [2,2,2]

! ------------------------------------------------------------------------
!  scratch variables
! ------------------------------------------------------------------------
   real(wp),allocatable :: xtmp(:)
   real(wp),allocatable :: atmp(:,:)
   real(wp),allocatable :: Xfac(:)
   real(wp),allocatable :: Afac(:,:)

! ------------------------------------------------------------------------
!  Lapack work variables
! ------------------------------------------------------------------------
   integer, allocatable :: ipiv(:)
   real(wp),allocatable :: temp(:)
   real(wp),allocatable :: work(:)
   integer  :: lwork
   integer  :: info
   real(wp) :: test(1)

   real(wp) :: gborn, ghb, r3, erft

   ! quick return if possible
   if (mol%n.eq.1) then
      q = mol%chrg
      ! should always hold, even for extendend systems
      es = 0.0_wp
      return
   endif

   gborn = 0.0_wp
   ghb   = 0.0_wp

! ------------------------------------------------------------------------
!  initizialization
! ------------------------------------------------------------------------
   m    = mol%n+1
   q    = 0.0_wp
   allocate( ipiv(m), source = 0 )
   allocate( Amat(m,m), Xvec(m), Xfac(m), source = 0.0_wp )

! ------------------------------------------------------------------------
!  set up the A matrix and X vector
! ------------------------------------------------------------------------
!  αi -> alpha(i), ENi -> xi(i), κi -> kappa(i), Jii -> gam(i)
!  γij = 1/√(αi+αj)
!  Xi  = -ENi + κi·√CNi
!  Aii = Jii + 2/√π·γii
!  Aij = erf(γij·Rij)/Rij = 2/√π·F0(γ²ij·R²ij)
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Setup of the A matrix and the RHS X vector"

   ! prepare some arrays
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(mol,cn,chrgeq) private(i,tmp) shared(Xvec,Xfac)
   do i = 1, mol%n
      tmp = chrgeq%kappa(i)/(sqrt(cn(i))+1e-14_wp)
      Xvec(i) = -chrgeq%en(i) + tmp*cn(i)
      Xfac(i) = 0.5_wp*tmp
   enddo
   !$omp end parallel do

   call get_coulomb_matrix(mol, chrgeq, Amat)

   Amat(:mol%n, :mol%n) = Amat(:mol%n, :mol%n) + gbsa%bornMat

! ------------------------------------------------------------------------
!  solve the linear equations to obtain partial charges
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Solve the linear equations to obtain partial charges"
   Amat(m,1:m) = 1.0_wp
   Amat(1:m,m) = 1.0_wp
   Amat(m,m  ) = 0.0_wp
   Xvec(m)     = mol%chrg
   ! generate temporary copy
   allocate( Atmp(m,m), source = Amat )
   allocate( Xtmp(m),   source = Xvec )

   ! assume work space query, set best value to test after first dsysv call
   call dsysv('u', m, 1, Atmp, m, ipiv, Xtmp, m, test, -1, info)
   lwork = int(test(1))
   allocate( work(lwork), source = 0.0_wp )

   call dsysv('u',m,1,Atmp,m,ipiv,Xtmp,m,work,lwork,info)
   if(info > 0) then
      call env%error("Coulomb matrix is singular, cannot solve lin. eq.", source)
      return
   end if

   q = Xtmp(:mol%n)
   if(abs(sum(q)-mol%chrg) > 1.e-6_wp) then
      call env%error("Charge constraint is not satisfied", source)
      return
   end if
   !print'(3f20.14)',Xtmp

   lambda = Xtmp(m)
   if (lverbose) then
      write(istdout,'(72("-"))')
      write(istdout,'(1x,a,1x,f20.14)') &
         "lambda       :",lambda,&
         "total charge :",sum(q)
   endif

! ------------------------------------------------------------------------
!  calculate isotropic electrostatic (IES) energy
! ------------------------------------------------------------------------
!  E = ∑i (ENi - κi·√CNi)·qi + ∑i (Jii + 2/√π·γii)·q²i
!      + ½ ∑i ∑j,j≠i qi·qj·2/√π·F0(γ²ij·R²ij)
!    = q·(½A·q - X)
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "Isotropic electrostatic (IES) energy calculation"
   call mctc_copy(Xvec, work)
   call mctc_symv(Amat, Xtmp, work, alpha=0.5_wp, beta=-1.0_wp)
   es = mctc_dot(Xtmp, work)
   energy = es + energy
   if (lverbose) then
      write(istdout,'(72("-"))')
      write(istdout,'(1x,a,1x,f20.14)') &
         "energy",es
   endif

! ------------------------------------------------------------------------
!  calculate molecular gradient of the IES energy
! ------------------------------------------------------------------------
!  dE/dRj -> g(:,j), ∂Xi/∂Rj -> -dcn(:,i,j), ½∂Aij/∂Rj -> dAmat(:,j,i)
!  dE/dR = (½∂A/∂R·q - ∂X/∂R)·q
!  ∂Aij/∂Rj = ∂Aij/∂Ri
! ------------------------------------------------------------------------
do_molecular_gradient: if (lgrad .or. lcpq) then
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "molecular gradient calculation"
   allocate( dAmatdr(3,mol%n,m), dXvecdr(3,mol%n,m), Afac(3,mol%n), source = 0.0_wp )

   call get_coulomb_derivs(mol, chrgeq, Xtmp, dAmatdr, Afac)
   do i = 1, mol%n
      dAmatdr(:,:,i) = dAmatdr(:,:,i) - dcndr(:,:,i)*Xfac(i)
   enddo
   call gbsa%addBornDeriv(Xtmp, gborn, ghb, dAmatdr, Afac)
   gsolv = gsolv + gborn + ghb + gbsa%gshift
endif do_molecular_gradient

   if (lgrad) then
   call mctc_gemv(dAmatdr, Xtmp, gradient, alpha=1.0_wp, beta=1.0_wp)
   endif

! ------------------------------------------------------------------------
!  invert the A matrix using a Bunch-Kaufman factorization
!  A⁻¹ = (L·D·L^T)⁻¹ = L^T·D⁻¹·L
! ------------------------------------------------------------------------
do_partial_charge_derivative: if (lcpq) then
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "A matrix inversion by Bunch-Kaufman factorization"
   allocate( Ainv(m,m), source = Amat )

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L',m,Ainv,m,ipiv,test,-1,info)
   if (int(test(1)) > lwork) then
      deallocate(work)
      lwork=int(test(1))
      allocate( work(lwork), source = 0.0_wp )
   endif

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L',m,Ainv,m,ipiv,work,lwork,info)
   if(info > 0)then
      call env%error("Could not factorize Coulomb matrix", source)
      return
   endif

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in Ainv matrix
   ! Ainv matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L',m,Ainv,m,ipiv,work,info)
   if (info > 0) then
      call env%error("Coulomb Matrix is singular, cannot invert", source)
      return
   endif

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do i = 1, m
      do j = i+1, m
         Ainv(i,j)=Ainv(j,i)
      enddo
   enddo

! ------------------------------------------------------------------------
!  calculate gradient of the partial charge w.r.t. the nuclear coordinates
! ------------------------------------------------------------------------
   if (lverbose) write(istdout,'(72("="),/,1x,a)') &
      "calculating the derivative of the partial charges"
   dqdr = 0.0_wp
   do i = 1, mol%n
      dAmatdr(:,i,i) = Afac(:,i) + dAmatdr(:,i,i)
   enddo
   !call dsymm('r','l',3*n,m,-1.0_wp,Ainv,m,dAmatdr,3*n,1.0_wp,dqdr,3*n)
   call dgemm('n','n',3*mol%n,mol%n,m,-1.0_wp,dAmatdr,3*mol%n,Ainv,m, &
      &       1.0_wp,dqdr,3*mol%n)
   !print'(/,"analytical gradient")'
   !print'(3f20.14)',dqdr(:,:,:n)

endif do_partial_charge_derivative

! ------------------------------------------------------------------------
!  Clean up
! ------------------------------------------------------------------------
   if (allocated(Amat))  deallocate(Amat)
   if (allocated(dAmatdr)) deallocate(dAmatdr)
   if (allocated(Afac))  deallocate(Afac)
   if (allocated(Xvec))  deallocate(Xvec)
   if (allocated(Xfac))  deallocate(Xfac)
   if (allocated(Xtmp))  deallocate(Xtmp)
   if (allocated(Atmp))  deallocate(Atmp)
   if (allocated(temp))  deallocate(temp)
   if (allocated(work))  deallocate(work)
   if (allocated(ipiv))  deallocate(ipiv)

end subroutine eeq_chrgeq_gbsa

end module xtb_eeq

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> @brief helper tools for periodic boundary conditions
module xtb_pbc_tools
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants,  only : pi
! ---------------------------> IMPORTANT <--------------------------- !
!  DO NOT INCLUDE ANY DERIVED TYPES FROM THE TBDEFS INTO THIS MODULE  !
!   features that need to work on the tbdefs should go into pbc.f90   !
! ------------------------------------------------------------------- !
   implicit none
   private :: wp, pi
   public

   real(wp),parameter :: tpi = 2.0_wp*pi

   interface coord_trafo
      module procedure :: coord_trafo_12
      module procedure :: coord_trafo_inplace
   end interface coord_trafo

contains

!> @brief convert cell parameters to direct lattice
pure subroutine cell_to_dlat(cellpar,lattice)
   implicit none
   real(wp),intent(in)  :: cellpar(6)   !< cell parameters
   real(wp),intent(out) :: lattice(3,3) !< direct lattice
   real(wp)             :: dvol

   dvol = cell_to_dvol(cellpar)

   associate( alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
      &       alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

   lattice(1,1) = alen
   lattice(2,1) = 0.0_wp
   lattice(3,1) = 0.0_wp
   lattice(3,2) = 0.0_wp
   lattice(1,2) = blen*cos(gam)
   lattice(2,2) = blen*sin(gam)
   lattice(1,3) = clen*cos(bet)
   lattice(2,3) = clen*(cos(alp) - cos(bet)*cos(gam))/sin(gam);
   lattice(3,3) = dvol/(alen*blen*sin(gam))

   end associate

end subroutine cell_to_dlat

!> @brief convert cell parameters to reciprocal lattice
pure subroutine cell_to_rlat(cellpar,rec_lat)
   implicit none
   real(wp),intent(in)  :: cellpar(6)   !< cell parameters
   real(wp),intent(out) :: rec_lat(3,3) !< reciprocal lattice
   real(wp)             :: dvol

   dvol = cell_to_dvol(cellpar)

   associate( alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
      &       alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

   rec_lat(1,1) = tpi/alen
   rec_lat(1,2) = 0.0_wp
   rec_lat(1,3) = 0.0_wp
   rec_lat(2,1) =-tpi*cos(gam)/(alen*sin(gam))
   rec_lat(2,2) = tpi/(blen*sin(gam))
   rec_lat(2,3) = 0.0_wp
   rec_lat(3,1) = tpi*(cos(gam)*cos(alp) - cos(bet))*blen*clen/(dvol*sin(gam))
   rec_lat(3,2) = tpi*(cos(gam)*cos(bet) - cos(alp))*alen*clen/(dvol*sin(gam))
   rec_lat(3,3) = tpi*sin(gam)*alen*blen/dvol

   end associate

end subroutine cell_to_rlat

!> @brief convert direct lattice to cell parameters
pure subroutine dlat_to_cell(lattice,cellpar)
   implicit none
   real(wp),intent(in)  :: lattice(3,3) !< direct lattice
   real(wp),intent(out) :: cellpar(6)   !< cell parameters

   associate( alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
      &       alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

   alen = norm2(lattice(:,1))
   blen = norm2(lattice(:,2))
   clen = norm2(lattice(:,3))

   alp = acos(dot_product(lattice(:,2),lattice(:,3))/(blen*clen))
   bet = acos(dot_product(lattice(:,1),lattice(:,3))/(alen*clen))
   gam = acos(dot_product(lattice(:,1),lattice(:,2))/(alen*blen))

   end associate

end subroutine dlat_to_cell

!> @brief convert direct lattice to cell parameters
pure subroutine dlat_to_rlat(lattice,rec_lat)
   implicit none
   real(wp),intent(in)  :: lattice(3,3) !< direct lattice
   real(wp),intent(out) :: rec_lat(3,3) !< reciprocal lattice
!  real(wp)             :: dvol
   rec_lat = tpi*transpose(mat_inv_3x3(lattice))
!  alternative implementation
!  dvol = dlat_volume(lattice)
!  associate( a => lattice(:,1), b => lattice(:,2), c => lattice(:,3) )
!     rec_lat(:,1) = tpi*cross(b,c)/dvol
!     rec_lat(:,2) = tpi*cross(c,a)/dvol
!     rec_lat(:,3) = tpi*cross(a,b)/dvol
!  end associate
end subroutine dlat_to_rlat

!> @brief implements the cross/vector product between two 3D vectors
pure function cross(a,b) result(c)
   implicit none
   real(wp),intent(in) :: a(3)
   real(wp),intent(in) :: b(3)
   real(wp)            :: c(3)
   c(1)=a(2)*b(3)-b(2)*a(3)
   c(2)=a(3)*b(1)-b(3)*a(1)
   c(3)=a(1)*b(2)-b(1)*a(2)
end function cross

!> @brief determinat of 3×3 matrix
pure function mat_det_3x3(a) result (det)
   implicit none
   real(wp),intent(in) :: a(3,3)
   real(wp)            :: det

   det =  a(1,1)*a(2,2)*a(3,3)  &
      & - a(1,1)*a(2,3)*a(3,2)  &
      & - a(1,2)*a(2,1)*a(3,3)  &
      & + a(1,2)*a(2,3)*a(3,1)  &
      & + a(1,3)*a(2,1)*a(3,2)  &
      & - a(1,3)*a(2,2)*a(3,1)

end function mat_det_3x3

!> Performs a direct calculation of the inverse of a 3×3 matrix.
!
!  reference: http://fortranwiki.org/fortran/show/Matrix+inversion
pure function mat_inv_3x3(a) result(b)
   implicit none
   real(wp),intent(in) :: a(3,3)   !< Matrix
   real(wp)            :: b(3,3)   !< Inverse matrix
   real(wp)            :: detinv

  ! Calculate the inverse determinant of the matrix
  detinv = 1.0_wp/mat_det_3x3(a)

  ! Calculate the inverse of the matrix
  b(1,1) = +detinv * (a(2,2)*a(3,3) - a(2,3)*a(3,2))
  b(2,1) = -detinv * (a(2,1)*a(3,3) - a(2,3)*a(3,1))
  b(3,1) = +detinv * (a(2,1)*a(3,2) - a(2,2)*a(3,1))
  b(1,2) = -detinv * (a(1,2)*a(3,3) - a(1,3)*a(3,2))
  b(2,2) = +detinv * (a(1,1)*a(3,3) - a(1,3)*a(3,1))
  b(3,2) = -detinv * (a(1,1)*a(3,2) - a(1,2)*a(3,1))
  b(1,3) = +detinv * (a(1,2)*a(2,3) - a(1,3)*a(2,2))
  b(2,3) = -detinv * (a(1,1)*a(2,3) - a(1,3)*a(2,1))
  b(3,3) = +detinv * (a(1,1)*a(2,2) - a(1,2)*a(2,1))
end function mat_inv_3x3

!> @brief calculate the cell volume from the cell parameters
pure function cell_to_dvol(cellpar) result(dvol)
   implicit none
   real(wp),intent(in) :: cellpar(6) !< cell parameters
   real(wp)            :: vol2
   real(wp)            :: dvol

   associate( alen => cellpar(1), blen => cellpar(2), clen => cellpar(3), &
      &       alp  => cellpar(4), bet  => cellpar(5), gam  => cellpar(6) )

   vol2 = 1.0_wp - cos(alp)**2 - cos(bet)**2 - cos(gam)**2 &
      & + 2.0_wp*cos(alp)*cos(bet)*cos(gam)

   dvol = sqrt(abs(vol2))*alen*blen*clen
   ! return negative volume instead of imaginary one (means bad cell parameters)
   if (vol2 < 0.0_wp) dvol = -dvol ! this should not happen, but who knows...

   end associate
end function cell_to_dvol

!> @brief calculate the cell volume from the direct lattice
pure function dlat_to_dvol(lattice) result(dvol)
   implicit none
   real(wp),intent(in) :: lattice(3,3) !< direct lattice
   real(wp)            :: dvol

   dvol = abs(mat_det_3x3(lattice))

end function dlat_to_dvol

!> @brief inverts volume of direct unit cell
pure function dvol_to_rvol(dvol) result(rvol)
   implicit none
   real(wp),intent(in) :: dvol !< direct volume
   real(wp)            :: rvol !< reciprocal volume
   rvol = tpi**3/dvol
end function dvol_to_rvol

!> @brief transform from fractional coordinates into cartesian coordinates
pure subroutine abc_to_xyz(n,dlat,abc,xyz)
   implicit none
   integer, intent(in)  :: n
   real(wp),intent(in)  :: dlat(3,3)
   real(wp),intent(in)  :: abc(3,n)
   real(wp),intent(out) :: xyz(3,n)

   call coord_trafo(n,dlat,abc,xyz)

end subroutine abc_to_xyz

!> @brief transform from cartesian coordinates into fractional coordinates
pure subroutine xyz_to_abc(n,dlat,xyz,abc,pbc)
   implicit none
   integer, intent(in)  :: n
   real(wp),intent(in)  :: dlat(3,3)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(out) :: abc(3,n)
   logical, intent(in)  :: pbc(3)
   real(wp)             :: invlat(3,3)
   real(wp)             :: tmp(3)
   integer              :: iat,idir

   ! note that this is not the reciprocal lattice
   invlat = mat_inv_3x3(dlat)
   do iat = 1, n
      tmp = matmul(invlat,xyz(:,iat))
      do idir = 1, 3
         if (pbc(idir)) &
            tmp(idir) = shift_back_abc(tmp(idir))
      enddo
      abc(:,iat) = tmp
   enddo

end subroutine xyz_to_abc

!> @brief shift back fractional coordinates into the range [0,1)
pure elemental function shift_back_abc(in) result(out)
   implicit none
   real(wp),intent(in) :: in   !< fractional coordinate in (-∞,+∞)
   real(wp)            :: out  !< fractional coordinate in [0,1)
   real(wp),parameter  :: p_pbc_eps = 1.0e-14_wp
   out = in
   if(in < (0.0_wp - p_pbc_eps)) &
      out = in + real(ceiling(-in),wp)
   if(in > (1.0_wp + p_pbc_eps)) &
      out = in - real(floor  ( in),wp)
   if (abs(in - 1.0_wp) < p_pbc_eps) &
      out = in - 1.0_wp
end function shift_back_abc

!> @brief transform from one coordinate system into another
pure subroutine coord_trafo_12(dim,trafo,coord1,coord2)
   implicit none
   integer, intent(in)  :: dim
   real(wp),intent(in)  :: trafo(3,3)
   real(wp),intent(in)  :: coord1(3,dim)
   real(wp),intent(out) :: coord2(3,dim)

   integer i

   coord2 = 0.0_wp
   do concurrent (i = 1:dim)
      coord2(:,i) = matmul(trafo,coord1(:,i))
   enddo

end subroutine coord_trafo_12

!> @brief transform from one coordinate system into another
pure subroutine coord_trafo_inplace(dim,trafo,coord)
   implicit none
   integer, intent(in)    :: dim
   real(wp),intent(in)    :: trafo(3,3)
   real(wp),intent(inout) :: coord(3,dim)
   real(wp) :: tmp(3)

   integer i

   do concurrent (i = 1:dim)
      tmp = coord(:,i)
      coord(:,i) = matmul(trafo,tmp)
   enddo

end subroutine coord_trafo_inplace

!> @brief calculate distance between to atoms under minimum image convention
pure function minimum_image_distance(lsame,fi,fj,dlat,lpbc) result(dist)
   implicit none
   logical, intent(in) :: lsame
   real(wp),intent(in) :: fi(3)
   real(wp),intent(in) :: fj(3)
   real(wp),intent(in) :: dlat(3,3)
   logical, intent(in) :: lpbc(3)
   real(wp) :: dist
   real(wp) :: fij(3),tfij(3),rij(3),tmp
   integer  :: rep(3),tx,ty,tz,idir
   logical  :: first

   fij = fi - fj

   if (lsame) then
      do idir = 1, 3
         if (lpbc(idir)) then
            rep(idir) = 1
         else
            rep(idir) = 0
         endif
      enddo
      first = .true.
      dist  = 0.0_wp
      tmp   = 0.0_wp

      do tx = -rep(1),rep(1)
         do ty = -rep(2),rep(2)
            do tz = -rep(3),rep(3)
               if (tx==0 .and. ty==0 .and. tz==0) cycle
               tfij = fij + [tx, ty, tz]

               rij = matmul(dlat,tfij)
               tmp = norm2(rij)

               if (first) then
                  dist = tmp
                  first = .false.
               else
                  dist = min(dist,tmp)
               endif

            enddo
         enddo
      enddo

   else
      do idir = 1, 3
         if (lpbc(idir)) fij(idir) = fij(idir) - idnint(fij(idir))
      enddo

      rij = matmul(dlat,fij)

      dist = norm2(rij)
   endif

end function minimum_image_distance

!> @brief calculate center of unit cell
pure function get_center_dlat(dlat) result(center)
   implicit none
   real(wp),intent(in) :: dlat(3,3)
   real(wp) :: center(3)
   real(wp) :: half(3)

   half = 0.5_wp

   center = matmul(dlat,half)

end function get_center_dlat

pure function outer_prod_3x3(a,b) result(c)
   real(wp),intent(in) :: a(3),b(3)
   real(wp) :: c(3,3)
   c(1,1) = a(1)*b(1); c(2,1) = a(2)*b(1); c(3,1) = a(3)*b(1)
   c(1,2) = a(1)*b(2); c(2,2) = a(2)*b(2); c(3,2) = a(3)*b(2)
   c(1,3) = a(1)*b(3); c(2,3) = a(2)*b(3); c(3,3) = a(3)*b(3)
end function outer_prod_3x3

pure subroutine latgrad_to_sigma(latgrad,lattice,sigma)
   implicit none
   real(wp), intent(in) :: latgrad(3,3)
   real(wp), intent(in) :: lattice(3,3)
   real(wp), intent(out) :: sigma(3,3)

   integer :: i,j,k

   sigma = 0.0_wp

   do i = 1, 3
      do j = 1, 3
         do k = 1,3
            sigma(i,j) = sigma(i,j) + latgrad(i,k)*lattice(j,k)
         enddo
      enddo
   enddo

end subroutine latgrad_to_sigma
pure subroutine sigma_to_latgrad(sigma,inv_lat,latgrad)
   implicit none
   real(wp), intent(in) :: sigma(3,3)
   real(wp), intent(in) :: inv_lat(3,3)
   real(wp), intent(out) :: latgrad(3,3)

   integer :: i,j,k

   latgrad(1,1) = sigma(1,1)*inv_lat(1,1) + sigma(1,2)*inv_lat(1,2) + sigma(1,3)*inv_lat(1,3)
   latgrad(1,2) = sigma(1,1)*inv_lat(2,1) + sigma(1,2)*inv_lat(2,2) + sigma(1,3)*inv_lat(2,3)
   latgrad(1,3) = sigma(1,1)*inv_lat(3,1) + sigma(1,2)*inv_lat(3,2) + sigma(1,3)*inv_lat(3,3)
   latgrad(2,1) = sigma(2,1)*inv_lat(1,1) + sigma(2,2)*inv_lat(1,2) + sigma(2,3)*inv_lat(1,3)
   latgrad(2,2) = sigma(2,1)*inv_lat(2,1) + sigma(2,2)*inv_lat(2,2) + sigma(2,3)*inv_lat(2,3)
   latgrad(2,3) = sigma(2,1)*inv_lat(3,1) + sigma(2,2)*inv_lat(3,2) + sigma(2,3)*inv_lat(3,3)
   latgrad(3,1) = sigma(3,1)*inv_lat(1,1) + sigma(3,2)*inv_lat(1,2) + sigma(3,3)*inv_lat(1,3)
   latgrad(3,2) = sigma(3,1)*inv_lat(2,1) + sigma(3,2)*inv_lat(2,2) + sigma(3,3)*inv_lat(2,3)
   latgrad(3,3) = sigma(3,1)*inv_lat(3,1) + sigma(3,2)*inv_lat(3,2) + sigma(3,3)*inv_lat(3,3)

end subroutine sigma_to_latgrad

end module xtb_pbc_tools

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!calculates the shortest path between two atoms
!start and goal are integers, determining the index in xyz
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
real*4 function shortest_distance(nspin, start, goal, neighbours, input_distances, visited, precessor)
    implicit none
    !Dummy Arguments:
    integer, intent(in) :: nspin
    integer, intent(in) :: start
    integer, intent(in) :: goal
    integer, intent(in) :: neighbours(20,nspin)
    real*4,  intent(in) :: input_distances(nspin*(nspin+1)/2)
    logical, intent(out):: visited(nspin)
    integer, intent(out):: precessor(nspin)

    integer lin

    !Stack:
    integer:: current
    integer:: neighbour
    integer:: i_neighbours
    real*4:: alt_dist
    real*4:: distance(nspin)

    !logical:: visited(nspin)

    precessor = 0
    distance = huge(distance)
    distance(start) = 0
    visited = .false.
    do while (all(visited) == .false.) !as long there are unvisited nodes
        current = minloc(distance,1, .not. visited)

        !Abort if Fragments are not connected:
        if (distance(current) == huge(distance)) then
            shortest_distance = huge(distance)
            return
        end if ! distance(current) == huge(distance)

        visited(current) = .true.
        if (current == goal) then
            shortest_distance = distance(goal)
            !route to target found
            do while (precessor(current) /= 0)
                current = precessor(current)
            end do ! End loop: while precessor(current) /= 0
            exit
        else
            !loop over all neighbours of current atom
            do i_neighbours = 1, neighbours(20,current)
                neighbour = neighbours(i_neighbours,current)
                if (visited(neighbour) == .false.) then
                    !distanzupdate
                    alt_dist = distance(current) + input_distances(lin(current,neighbour))
                    if ((alt_dist < distance(neighbour))) then
                        distance(neighbour) = alt_dist
                        precessor(neighbour) = current
                    end if ! (alt_dist < distance(neighbour))
                endif !(visited(neighbour))
            end do ! End Loop over  i_neighbours from 1 to all_Atoms(current)%n_neighbours
        endif
    end do ! End loop: while sum(visited) /= 0
        !initialize
    shortest_distance = distance(goal)
end function shortest_distance

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Numerical thresholds shared between multiple algorithms
module xtb_mctc_thresholds
   use xtb_mctc_accuracy, only : wp
   implicit none
   public


   !> Tolerance for atomic distances
   real(wp), parameter :: tolSameDist = 1.0e-5_wp

   !> Tolerance for atomic square distances
   real(wp), parameter :: tolSameDist2 = tolSameDist**2

   !> Minimal distance between neighbours
   real(wp), parameter :: minNeighDist = 1.0e-2_wp

   !> Minimal square distance between neighbours
   real(wp), parameter :: minNeighDist2 = minNeighDist**2


contains


end module xtb_mctc_thresholds

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ------------------------------------------------------------------------
!  From the Fortran 2003 Standard
!! ------------------------------------------------------------------------
!  OPEN(UNIT=integer,           -- unit specifier
!       ACCESS=character,       -- Specifies access mode for the connection
!                                  values: 'direct', 'sequential' (default),
!                                          'stream'
!                                  if ACCESS is 'direct', RECL is required
!       ACTION=character,       -- Specifies the actions allowed for the connection
!                                  values: 'read', 'write', 'readwrite'
!       ASYNCHRONOUS=character, -- Specifiers whether or not asynchronous
!                                  input/output is allowed
!                                  values: 'yes', 'no' (default)
!       BLANK=character,        -- values: 'null' (default), 'zero'
!       DECIMAL=character,      -- values: 'comma', 'point' (default)
!       DELIM=character,        -- values: 'apostrophe', 'quote', 'none' (default)
!       ENCODING=character,     -- Specifies the character encoding method
!                                  for formatted files
!                                  values: 'utf-8', 'default' (default)
!       ERR=label,              -- 
!       FILE=character,         -- Specifies the name of the file being connected
!                                  rules:
!                                  1. Trailing blanks in the name are ignored.
!                                  2. The name must be a file name allowed by the 
!                                     processor.
!                                  3. The interpretation of case is processor 
!                                     dependent; for example, the processor
!                                     may distinguish file names by case or
!                                     it may interpret the name all in uppercase
!                                     or lowercase letters.
!                                  4. The FILE specifier must appear if the STATUS
!                                     value is 'new' or 'replace'.
!                                  5. If the STATUS value is 'old', the FILE
!                                     specifier must appear unless the unit is
!                                     already connected to a unit that exists.
!                                  6. If the STATUS specifier has the value
!                                     'scratch', the FILE specifier must not
!                                     appear.
!       FORM=character,         -- Specifies formatted or unformatted input/output
!                                  values: 'formated', 'unformatted'
!                                  rules:
!                                  1. The default value is 'unformatted', if the
!                                     file is connected for direct or stream access.
!                                  2. The default value is 'formatted', if the file 
!                                     is connected for sequential access.
!       IOMSG=character,        -- 
!       IOSTAT=integer,         -- 
!       PAD=character,          -- values: 'yes' (default), 'no'
!       POSITION=character,     -- Specifies the initial position of the file
!                                  values: 'asis' (default), 'rewind', 'append'
!                                  rules:
!                                  1. The default value is 'asis', permitting an
!                                     OPEN statement to change other connection
!                                     properties of a file that is already
!                                     connected without changing its position.
!                                  2. The file must be connected for sequential or
!                                     stream access.
!                                  3. If the file is new, it is positioned at its
!                                     initial point.
!       RECL=integer,           -- Specifies record length for direct- or
!                                  sequential-access files. The expression
!                                  specifies the length of each direct-access
!                                  record or the maximum record length if the
!                                  access method is sequential.
!       ROUND=character,        -- values: 'up', 'down', 'zero', 'nearest',
!                                          'compatible', 'processor_defined'
!       SIGN=character,         -- values: 'plus', 'suppress', 'processor_defined'
!       STATUS=character)       -- Specifies the file existence before the
!                                  connection is made
!                                  values:
!                                 'old'     -- file must exist
!                                 'new'     -- file must not exist, will be created
!                                 'unknown' -- default
!                                 'replace' -- if file does not exist, it is
!                                              created and given STATUS 'old';
!                                              if file does exist, it is deleted,
!                                              and a new file is created with the
!                                              same name and STATUS 'old'.
!                                 'scratch' -- file is created and connected to the
!                                              specified unit; it is deleted when
!                                              the program terminates normally
!                                              or a CLOSE statement is executed on
!                                              that unit (file must be unnamed)
!! ------------------------------------------------------------------------
module xtb_mctc_filetools
implicit none

type :: filelog
   character(len=:),allocatable :: name
   character(len=1) :: status
   integer :: unit
   logical :: open
end type filelog

type(filelog),allocatable :: filelist(:)
integer :: nfiles = 0

contains

subroutine init_filelist(maxfiles)
   integer,intent(in) :: maxfiles
   nfiles = 0
   if (allocated(filelist)) deallocate(filelist)
   allocate( filelist(maxfiles) )
end subroutine init_filelist

subroutine reallocate_filelist
   integer :: current_size,new_size
   type(filelog),allocatable :: tmplist(:)
   current_size = size(filelist,1)
   new_size = current_size+current_size/2+1
   allocate( tmplist(new_size) )
   tmplist(:current_size) = filelist
   deallocate( filelist )
   call move_alloc(tmplist,filelist)
end subroutine reallocate_filelist

subroutine push_file(unit,name,status)
   implicit none
   character(len=*),intent(in)  :: name
   character(len=1),intent(in)  :: status
   integer,         intent(in)  :: unit
   character(len=:),allocatable :: tmp

   nfiles = nfiles + 1
   if (nfiles .gt. size(filelist,1)) call reallocate_filelist

   filelist(nfiles)%name = name
   filelist(nfiles)%status = status
   filelist(nfiles)%unit = unit
   if (status.eq.'d' .or. status.eq.'t') then
      filelist(nfiles)%open = .false.
   else
      filelist(nfiles)%open = .true.
   endif
end subroutine push_file

subroutine pop_file(unit,status)
   implicit none
   integer,intent(in) :: unit
   character(len=1),intent(in),optional :: status
   logical :: found
   integer :: i
   found = .false.

   do i = 1, nfiles
      found = unit.eq.filelist(i)%unit .and. filelist(i)%open
      if (found) then
         if (present(status)) filelist(i)%status = status
         filelist(i)%open = .false.
         exit
      endif
   enddo
end subroutine pop_file

end module xtb_mctc_filetools

! This file is part of ancopt.
! SPDX-Identifier: LGPL-3.0-or-later
!
! ancopt is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! ancopt is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with ancopt.  If not, see <https://www.gnu.org/licenses/>.

!> Proxy module for creating optimizer objects
module xtb_pbc_optimizer_optimizer
   use xtb_type_environment, only : TEnvironment
   use  xtb_pbc_optimizer_filter_type, only : filter_type
   use xtb_pbc_optimizer_lbfgs, only : optimizer_type, lbfgs_optimizer, lbfgs_input, new_lbfgs_optimizer
   implicit none
   private

   public :: optimizer_type, optimizer_input, new_optimizer


   type :: optimizer_input
      character(len=:), allocatable :: method
      type(lbfgs_input) :: lbfgs
   end type


contains

subroutine new_optimizer(self, env, input, filter)
   !> Instance of the optimization driver
   class(optimizer_type), allocatable, intent(out) :: self
   !> Calculation environment
   type(TEnvironment), intent(inout) :: env
   !> Input for constructing the optimizer
   type(optimizer_input), intent(in) :: input
   !> Transformation filter
   class(filter_type), intent(in) :: filter

   call new_lbfgs_optimizer_(self, env, input%lbfgs, filter)

end subroutine new_optimizer

subroutine new_lbfgs_optimizer_(self, env, input, filter)
   !> Instance of the optimizer
   class(optimizer_type), allocatable, intent(out) :: self
  !> Calculation environment
  type(TEnvironment), intent(inout) :: env
   !> Input for constructing the optimizer
   type(lbfgs_input), intent(in) :: input
   !> Transformation filter
   class(filter_type), intent(in) :: filter

   type(lbfgs_optimizer), allocatable :: new

   allocate(new)
   call new_lbfgs_optimizer(new, env, input, filter)
   call move_alloc(new, self)
end subroutine new_lbfgs_optimizer_


end module xtb_pbc_optimizer_optimizer

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_metadynamic
contains

subroutine metadynamic(metavar,nat,at,xyz,ebias,g)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   use xtb_lsrmsd
   implicit none
   type(metadyn_setvar),intent(in) :: metavar
   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(in)    :: xyz(3,nat)
   real(wp),intent(inout) :: ebias
   real(wp),intent(inout) :: g(3,nat)

   real(wp),allocatable   :: xyzref(:,:),grad(:,:),xyzdup(:,:)
   real(wp) :: U(3,3), x_center(3), y_center(3)
   real(wp) :: etmp,rmsdval,e
   integer  :: i,j,k,iref,iat

   if(metavar%nstruc < 1 ) return

   if (metavar%nat == 0) then
      allocate( xyzref(3,nat), grad(3,nat),source = 0.0_wp )
      !$omp parallel default(none) &
      !$omp shared(metavar,nat,xyz) &
      !$omp private(grad,xyzref,U,x_center,y_center,rmsdval,e,etmp) &
      !$omp reduction(+:ebias,g)
      !$omp do schedule(dynamic)
      do iref = 1, metavar%nstruc
         grad = 0.0_wp
         xyzref = metavar%xyz(:,:,iref)
         call rmsd(nat,xyz,xyzref,1,U,x_center,y_center,rmsdval, &
                   .true.,grad)
         e = metavar%factor(iref) * exp(-metavar%width(iref) * rmsdval**2)
         ebias = ebias + e
         etmp = -2.0_wp * metavar%width(iref) * e * rmsdval
         g = g + etmp*grad
      enddo
      !$omp enddo
      !$omp end parallel
   else
      allocate( xyzref(3,metavar%nat), xyzdup(3,metavar%nat), grad(3,metavar%nat) )
      !$omp parallel default(none) &
      !$omp shared(metavar,nat,xyz) &
      !$omp private(grad,xyzref,xyzdup,U,x_center,y_center,rmsdval,e,etmp,i,iat) &
      !$omp reduction(+:ebias,g)
      !$omp do schedule(dynamic)
      do iref = 1, metavar%nstruc
         grad = 0.0_wp
         do i = 1, metavar%nat
            iat = metavar%atoms(i)
            xyzref(:,i) = metavar%xyz(:,iat,iref)
            xyzdup(:,i) = xyz(:,iat)
         enddo
         call rmsd(metavar%nat,xyzdup,xyzref,1,U,x_center,y_center,rmsdval, &
                   .true.,grad)
         e = metavar%factor(iref) * exp(-metavar%width(iref) * rmsdval**2)
         ebias = ebias + e
         etmp = -2.0_wp * metavar%width(iref) * e * rmsdval
         do i = 1, metavar%nat
            iat = metavar%atoms(i)
            g(:,iat) = g(:,iat) + etmp*grad(:,i)
         enddo
      enddo
      !$omp enddo
      !$omp end parallel
      deallocate( xyzdup )
   endif
   deallocate( xyzref, grad )

end subroutine metadynamic

subroutine load_metadynamic(metavar,nat,at,xyz)
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_fixparam
   use xtb_readin
   implicit none
   type(metadyn_setvar),intent(inout) :: metavar
   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(in)    :: xyz(3,nat)

   integer  :: nstruc

   if (.not.allocated(metavar%fname)) return

   nstruc = metavar%maxsave
   call readlog(metavar%fname,nat,at,metavar%xyz,nstruc)
   metavar%nstruc = nstruc
   write(stdout,'(a,1x,i0,1x,a)') &
      "metadynamics with", nstruc, "initial structures loaded"
end subroutine load_metadynamic

subroutine load_rmsdbias(metavar,nat,at,xyz)
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   use xtb_mctc_systools, only : getline
   use xtb_fixparam
   use xtb_readin
   implicit none
   type(metadyn_setvar),intent(inout) :: metavar
   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(in)    :: xyz(3,nat)

   integer :: ii, nn, mm, cc, stat, unit
   integer, parameter :: initial_size = 16
   real(wp) :: kk, aa, xx, yy, zz
   character(len=:), allocatable :: line
   character(len=4) :: sym
   real(wp), allocatable :: tmp_xyz(:, :, :), tmp_realloc3(:, :, :)
   real(wp), allocatable :: tmp_par(:, :), tmp_realloc2(:, :)

   if (.not.allocated(metavar%fname)) return

   write(stdout, '("#", *(1x, g0))') &
      "Reading bias information from", metavar%fname

   allocate(tmp_xyz(3, nat, initial_size), tmp_par(2, initial_size))

   open(unit, file=metavar%fname, iostat=stat)
   cc = 0
   rdxyz: do while(stat == 0)
      call getline(unit, line, stat)
      if (stat /= 0) exit rdxyz
      read(line, *, iostat=stat) nn
      if (stat /= 0) exit rdxyz
      if (nn /= nat) then
         stat = 1
         exit rdxyz
      end if

      call getline(unit, line, stat)
      read(line, *, iostat=stat) kk, aa
      if (stat /= 0) exit rdxyz

      nn = size(tmp_xyz, 3)
      if (cc >= nn) then
         mm = nn + nn/2 + 1
         nn = min(nn, mm)
         call move_alloc(tmp_xyz, tmp_realloc3)
         call move_alloc(tmp_par, tmp_realloc2)
         allocate(tmp_xyz(3, nat, mm), tmp_par(2, mm))
         tmp_xyz(:, :, :nn) = tmp_realloc3(:, :, :nn)
         tmp_par(:, :nn) = tmp_realloc2(:, :nn)
         deallocate(tmp_realloc3, tmp_realloc2)
      end if
      cc = cc + 1

      tmp_par(:, cc) = [kk, aa]

      do ii = 1, nat
         call getline(unit, line, stat)
         if (stat /= 0) exit rdxyz
         read(line, *, iostat=stat) sym, xx, yy, zz
         if (stat /= 0) exit rdxyz
         tmp_xyz(:, ii, cc) = [xx, yy, zz] * aatoau
      end do
   end do rdxyz
   if (is_iostat_end(stat)) stat = 0
   if (stat /= 0) return
   close(unit, iostat=stat)

   write(stdout, '("#", *(1x, g0))') &
      "Read bias potential for", cc, "structures"

   call metavar%allocate(nat, cc)
   metavar%nstruc = cc
   metavar%xyz(:, :, :) = tmp_xyz(:, :, :cc)
   metavar%factor(:) = tmp_par(1, :cc)
   metavar%width(:) = tmp_par(2, :cc)

end subroutine load_rmsdbias

subroutine set_metadynamic(metavar,nat,at,xyz)
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_fixparam
   use xtb_readin
   implicit none
   type(metadyn_setvar),intent(inout) :: metavar
   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(in)    :: xyz(3,nat)

   integer  :: nstruc

   nstruc = metavar%maxsave
   metavar%nstruc = nstruc
   metavar%xyz(:,:,nstruc) = xyz
   metavar%width=1.0
   write(stdout,'(a,1x,i0,1x,a)') &
      "metadynamics with", nstruc, "initial structures loaded"
end subroutine set_metadynamic

end module xtb_metadynamic

! This file is part of xtb.
!
! Copyright (C) 2022 Stefan Grimme, Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_docking_param
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_symbols, only: toSymbol
   use xtb_type_setvar
   use xtb_type_molecule, only: TMolecule, init
   use xtb_param_covalentRadD3, only: covalentRadD3
   use xtb_mctc_param, only: sqrt_z_r4_over_r2
   use xtb_splitparam, only: atmass
   implicit none

   private :: toSymbol

   !> Parameter
   real(wp) :: par_rep_scal,par_d3_a1,par_d3_a2,par_d3_s8,par_chrg_lp,par_chrg_sig,&
             & par_chrg_pi,par_pos1_lp,par_pos2_lp,par_pos_sig,par_es_damp,par_drude_fc,&
             & par_drude_damp, par_xh1, par_xh2
   real(wp) :: r0ab,r0ab6(94,94),r0ab8(94,94),rrab(94,94),r0scal(94),val_e(86),r0_atom(86),rcov(94),r2r4(94)
   integer :: lpatom(86), sigatom(86)

   !> # of generations
   integer :: maxgen = 10

   !> # of parents for genetic algo
   integer :: maxparent = 100 

   !> step size for RG grid
   real(wp) :: stepr = 2.5    

   !> Step size for angular grid
   real(wp) :: stepa = 45    

   !> Maximal number of points CMA search
   integer :: mxcma = 1000    

   !> Size for pocket clusteing
   integer :: mxcent_clust = 500  

   !> Include input in gene pool?
   logical :: incl_org = .false.  

   !> Search types
   logical :: stack_only = .false.
   logical :: pocket_only = .false.
   logical :: no_pocket = .true.

   !> Probe atom type
   integer :: probe_atom_type = 36

   !> # of final geo. opts
   integer :: n_opt = 15 

   !> Mode
   integer :: mode = 0            

   !> CS symmetric molecule A?
   logical :: cssym = .false.     

   character*80 :: solvent, XTBHOME
   character(len=:), allocatable :: natom_arg
   integer :: natom_molA = 0

   !> Optimization accuracy
   real(wp) :: acc = 1.0_wp
   real(wp) :: shift_geo !How much molB is shifted away from molA to determine Topo and D4 coefficients
   real(wp) :: pre_e_A = 0.0_wp
   real(wp) :: pre_e_B = 0.0_wp

   !>Settings
   logical :: fulle = .false.
   logical :: hess = .false.
   logical :: debug = .false.
   integer :: nfrag1 = 0
   logical :: samerand = .false.
   logical :: test = .false.
   character(len=:), allocatable :: optlvl

   !>docklmocommon
   integer :: maxlmo = 50000
   real(wp) :: lmoint(3, 50000, 2) = 0.0_wp
   integer :: lmoatom(4, 50000, 2) = 0

   !>dockmolcommon
   real(wp) :: dipol(2) = 0.0_wp
   real(wp) :: grotrav(2) = 0.0_wp
   real(wp) :: hrotrav(2) = 0.0_wp
   real(wp) :: zpve(2) = 0.0_wp
   real(wp) :: extb(2) = 0.0_wp

   real(wp) :: chrg(2) = 0.0_wp
   real(wp) :: uhf(2) = 0.0_wp
   real(wp) :: elumo(2) = 0.0_wp
   real(wp) :: ehomo(2) = 0.0_wp

   !>Stuff for constraints
   logical :: constraint_xyz = .false.
   logical :: auto_wall = .false.
   character(len=:), allocatable :: xcontrol

   !> Options
   logical :: pocket_grid = .false.
   logical :: angular_grid = .true.
   logical :: stack_grid = .true.  

   !> General Control
   integer :: gsolvstate_iff
   logical :: docking_ens = .false.

   !> Fixing for Directed Docking
   type(fix_setvar) :: directedset
   !> Scaling factor for repulstive potential
   real(wp),parameter :: pot_scal = 1.0_wp
   !> Exponent for repulsitve potential
   real(wp),parameter :: pot_expo = 2.0_wp
   !> 20 kcal/mol attractive potential
   real(wp) :: attractive_pot = -0.032_wp
   integer :: directed_type = 3
   !> Repulsive atom-centered potential
   integer, parameter :: p_atom_pot = 2
   !> Attractive atom-centered potential
   integer, parameter :: p_atom_att = 3 
   !Wall pot for directed docking
   integer, parameter :: p_wall_pot = 1 
   integer :: place_wall_pot
   !QCG mode (special treatment of wall potentials)
   logical :: qcg = .false.

   !> Drude
   real(wp) :: gam(94)
   data gam/&
  &0.47259288, 0.92203391, 0.17452888, 0.25700733, 0.33949086, 0.42195412,&
  &0.50438193, 0.58691863, 0.66931351, 0.75191607, 0.17964105, 0.22157276,&
  &0.26348578, 0.30539645, 0.34734014, 0.38924725, 0.43115670, 0.47308269,&
  &0.17105469, 0.20276244, 0.21007322, 0.21739647, 0.22471039, 0.23201501,&
  &0.23933969, 0.24665638, 0.25398255, 0.26128863, 0.26859476, 0.27592565,&
  &0.30762999, 0.33931580, 0.37235985, 0.40273549, 0.43445776, 0.46611708,&
  &0.15585079, 0.18649324, 0.19356210, 0.20063311, 0.20770522, 0.21477254,&
  &0.22184614, 0.22891872, 0.23598621, 0.24305612, 0.25013018, 0.25719937,&
  &0.28784780, 0.31848673, 0.34912431, 0.37976593, 0.41040808, 0.44105777,&
  &0.05019332, 0.06762570, 0.08504445, 0.10247736, 0.11991105, 0.13732772,&
  &0.15476297, 0.17218265, 0.18961288, 0.20704760, 0.22446752, 0.24189645,&
  &0.25932503, 0.27676094, 0.29418231, 0.31159587, 0.32902274, 0.34592298,&
  &0.36388048, 0.38130586, 0.39877476, 0.41614298, 0.43364510, 0.45104014,&
  &0.46848986, 0.48584550, 0.12526730, 0.14268677, 0.16011615, 0.17755889,&
  &0.19497557, 0.21240778, 0.07263525, 0.09422158, 0.09920295, 0.10418621,&
  &0.14235633, 0.16394294, 0.18551941, 0.22370139/

contains

   subroutine set_iff_param

      character(len=80) :: fname
      logical :: ex
      integer :: i, j

      rcov = covalentRadD3(1:94)
      r2r4 = sqrt_z_r4_over_r2(1:94)
      call valel(val_e)

      fname = trim(XTBHOME)//'.param.xtbiff'
      inquire (file=fname, exist=ex)

      if (ex) then
         write (*, *) 'reading parameter file', trim(fname)
         open (unit=2, file=fname)
         read (2, *) par_rep_scal
         read (2, *) par_d3_a1
         read (2, *) par_d3_a2
         read (2, *) par_d3_s8
         read (2, *) par_chrg_lp    ! / 1.8 for Z > 10 in setlmo
         read (2, *) par_chrg_sig
         read (2, *) par_chrg_pi    ! x 3.0 for deloc pi in setlmo
         read (2, *) par_pos1_lp
         read (2, *) par_es_damp
         read (2, *) par_xh1
         read (2, *) par_xh2
         read (2, *) par_drude_fc
         do i = 1, 86
            read (2, *) j, r0scal(i)
         end do
         close (2)
      else
         write (*, *) 'taking internal default parameters'
         par_rep_scal = 0.1232398
         par_d3_a1 = 0.4459020
         par_d3_a2 = 4.4216615
         par_d3_s8 = 2.0000000
         par_chrg_lp = 3.1064458
         par_chrg_sig = 2.7000000
         par_chrg_pi = 0.8892689
         par_pos1_lp = 3.7082486
         par_es_damp = 0.2298506
         par_xh1 = 0.3614582
         par_xh2 = 6.7354042
         par_drude_fc = 0.9811899
         r0scal(1) = 0.6500000
         r0scal(2) = 0.6500000
         r0scal(3) = 0.8500000
         r0scal(4) = 1.1000000
         r0scal(5) = 1.2000000
         r0scal(6) = 1.2606324
         r0scal(7) = 1.3744700
         r0scal(8) = 1.1377692
         r0scal(9) = 0.9300000
         r0scal(10) = 0.8500000
         r0scal(11) = 0.8500000
         r0scal(12) = 1.3000000
         r0scal(13) = 1.3500000
         r0scal(14) = 1.3500000
         r0scal(15) = 1.6000000
         r0scal(16) = 1.6000000
         r0scal(17) = 1.6000000
         r0scal(18) = 0.9000000
         r0scal(19) = 0.8500000
         r0scal(20) = 1.4000000
         r0scal(21) = 1.3500000
         r0scal(22) = 1.3500000
         r0scal(23) = 1.3500000
         r0scal(24) = 1.3500000
         r0scal(25) = 1.3500000
         r0scal(26) = 1.3500000
         r0scal(27) = 1.6000000
         r0scal(28) = 1.6000000
         r0scal(29) = 1.6000000
         r0scal(30) = 1.6000000
         r0scal(31) = 1.5500000
         r0scal(32) = 1.5500000
         r0scal(33) = 1.5500000
         r0scal(34) = 1.6000000
         r0scal(35) = 1.6000000
         r0scal(36) = 0.9000000
         r0scal(37) = 0.9500000
         r0scal(38) = 1.5000000
         r0scal(39) = 1.3500000
         r0scal(40) = 1.3500000
         r0scal(41) = 1.6000000
         r0scal(42) = 1.3500000
         r0scal(43) = 1.6500000
         r0scal(44) = 1.3500000
         r0scal(45) = 1.6000000
         r0scal(46) = 1.6000000
         r0scal(47) = 1.6000000
         r0scal(48) = 1.6000000
         r0scal(49) = 1.3500000
         r0scal(50) = 1.3500000
         r0scal(51) = 1.5500000
         r0scal(52) = 1.5500000
         r0scal(53) = 1.6000000
         r0scal(54) = 0.9500000
         r0scal(55) = 0.9500000
         r0scal(56) = 1.5000000
         r0scal(57) = 1.3500000
         r0scal(58) = 1.6000000
         r0scal(59) = 1.6000000
         r0scal(60) = 1.6000000
         r0scal(61) = 1.6000000
         r0scal(62) = 1.6000000
         r0scal(63) = 1.6000000
         r0scal(64) = 1.6000000
         r0scal(65) = 1.6000000
         r0scal(66) = 1.6000000
         r0scal(67) = 1.6000000
         r0scal(68) = 1.6000000
         r0scal(69) = 1.6000000
         r0scal(70) = 1.6000000
         r0scal(71) = 1.6000000
         r0scal(72) = 1.3500000
         r0scal(73) = 1.6000000
         r0scal(74) = 1.6000000
         r0scal(75) = 1.6000000
         r0scal(76) = 1.6000000
         r0scal(77) = 1.6000000
         r0scal(78) = 1.6000000
         r0scal(79) = 1.6000000
         r0scal(80) = 1.6000000
         r0scal(81) = 1.4500000
         r0scal(82) = 1.4500000
         r0scal(83) = 1.4500000
         r0scal(84) = 1.6000000
         r0scal(85) = 1.6000000
         r0scal(86) = 0.9500000

      end if

!     not fully fitted ("hand made")
!     four additional CT parameters in xtbdock_energy.f (chrgtransfer)
      par_drude_damp = 0.020! induction damp
      par_pos_sig = par_pos1_lp
      par_pos2_lp = 0.0

! which atom has LP ES interactions?
      lpatom = 0
      lpatom(6:9) = 1
      lpatom(14:17) = 1
      lpatom(32:35) = 1
      lpatom(50:53) = 1
      lpatom(82:85) = 1

! which atom has sigma quadrupole ES interactions?
      sigatom = 0
      sigatom(9) = 1
      sigatom(17) = 1
      sigatom(35) = 1
      sigatom(53) = 1
      sigatom(85) = 1

   end subroutine set_iff_param

   subroutine diptot(n1, n2, nl1, nl2, c1, c2, cl1, cl2, l1, l2, q1, q2, dipol)
      integer, intent(in) :: n1, n2
      integer, intent(in) :: nl1, nl2
      real(wp), intent(in) :: c1(3, n1)
      real(wp), intent(in) :: c2(3, n2)
      real(wp), intent(in) :: cl1(4, n1*10)
      real(wp), intent(in) :: cl2(4, n2*10)
      real(wp), intent(in) :: q1(n1)
      real(wp), intent(in) :: q2(n2)
      integer, intent(in) :: l1(n1*10)
      integer, intent(in) :: l2(n2*10)
      real(wp), intent(out) :: dipol(3)

      integer :: i

      dipol = 0
      do i = 1, nl1
         dipol(1:3) = dipol(1:3) + cl1(1:3, i)*cl1(4, i)    ! one off-charge at LMO
      end do
      do i = 1, n1
         dipol(1:3) = dipol(1:3) + c1(1:3, i)*q1(i)
      end do
      do i = 1, nl2
         dipol(1:3) = dipol(1:3) + cl2(1:3, i)*cl2(4, i)    ! one off-charge at LMO
      end do
      do i = 1, n2
         dipol(1:3) = dipol(1:3) + c2(1:3, i)*q2(i)
      end do

   end subroutine diptot

! compute center of mass(sum3) and moment of intertia and corresponding
! axis
! molw is the weigth, sum3 the CMA (all in a.u.)

   subroutine axis(numat, nat, coord, sum3, sumw, eig, evec)

      integer, intent(in) ::numat, nat(numat)
      real(wp), intent(in) :: coord(3, *)
      real(wp), intent(out) :: sum3(3), sumw, eig(3), evec(3, 3)

      real(wp) :: t(6)
      real(wp) :: x(numat), y(numat), z(numat)
      real(wp) :: sumwx, sumwy, sumwz
      real(wp) :: atmass
      integer :: i
      real(wp) ::  ams(107)
      data ams/1.00790d0, 4.00260d0, 6.94000d0, 9.01218d0,&
     & 10.81000d0, 12.01100d0, 14.00670d0, 15.99940d0, 18.99840d0,&
     & 20.17900d0, 22.98977d0, 24.30500d0, 26.98154d0, 28.08550d0,&
     & 30.97376d0, 32.06000d0, 35.45300d0, 39.94800d0, 39.09830d0,&
     & 40.08000d0, 44.95590d0, 47.90000d0, 50.94150d0, 51.99600d0,&
     & 54.93800d0, 55.84700d0, 58.93320d0, 58.71000d0, 63.54600d0,&
     & 65.38000d0, 69.73500d0, 72.59000d0, 74.92160d0, 78.96000d0,&
     & 79.90400d0, 83.80000d0, 85.46780d0, 87.62000d0, 88.90590d0,&
     & 91.22000d0, 92.90640d0, 95.94000d0, 98.90620d0, 101.0700d0,&
     & 102.9055d0, 106.4000d0, 107.8680d0, 112.4100d0, 114.8200d0,&
     & 118.6900d0, 121.7500d0, 127.6000d0, 126.9045d0, 131.3000d0,&
     & 132.9054d0, 137.3300d0, &
     & 138.91, 140.12, 140.91, 144.24, 147.00, 150.36, 151.97, 157.25,&
     & 158.93, 162.50, 164.93, 167.26, 168.93, 173.04, 174.97,&
     & 178.4900d0, 180.9479d0,&
     & 183.8500d0, 186.2070d0, 190.2000d0, 192.2200d0, 195.0900d0,&
     & 196.9665d0, 200.5900d0, 204.3700d0, 207.2000d0, 208.9804d0,&
     & 209., 210., 222., 21*0.000d0/

      sumw = 0
      sumwx = 0.d0
      sumwy = 0.d0
      sumwz = 0.d0

      do i = 1, numat
         atmass = ams(nat(i))
         sumw = sumw + atmass
         sumwx = sumwx + atmass*coord(1, i)
         sumwy = sumwy + atmass*coord(2, i)
         sumwz = sumwz + atmass*coord(3, i)
      end do

      sum3(1) = sumwx/sumw
      sum3(2) = sumwy/sumw
      sum3(3) = sumwz/sumw

      do i = 1, numat
         x(i) = coord(1, i) - sum3(1)
         y(i) = coord(2, i) - sum3(2)
         z(i) = coord(3, i) - sum3(3)
      end do

      do i = 1, 6
         t(i) = real(i, wp)*1.0e-10_wp
      end do

      do i = 1, numat
         atmass = ams(nat(i))
         t(1) = t(1) + atmass*(y(i)**2 + z(i)**2)
         t(2) = t(2) - atmass*x(i)*y(i)
         t(3) = t(3) + atmass*(z(i)**2 + x(i)**2)
         t(4) = t(4) - atmass*z(i)*x(i)
         t(5) = t(5) - atmass*y(i)*z(i)
         t(6) = t(6) + atmass*(x(i)**2 + y(i)**2)
      end do

      call rsp(t, 3, 3, eig, evec)
      eig = eig/sumw

   end subroutine axis

   subroutine cmadock(n, numat, nat, coord, sum3)

      integer, intent(in) :: n, numat, nat(numat)
      real(wp), intent(in) :: coord(3, numat)
      real(wp), intent(out) :: sum3(3)
      real(wp)  :: ams(107)
      real(wp) :: sumw, sumwx, sumwy, sumwz
      integer :: i
      data ams/1.00790d0, 4.00260d0, 6.94000d0, 9.01218d0,&
     & 10.81000d0, 12.01100d0, 14.00670d0, 15.99940d0, 18.99840d0,&
     & 20.17900d0, 22.98977d0, 24.30500d0, 26.98154d0, 28.08550d0,&
     & 30.97376d0, 32.06000d0, 35.45300d0, 39.94800d0, 39.09830d0,&
     & 40.08000d0, 44.95590d0, 47.90000d0, 50.94150d0, 51.99600d0,&
     & 54.93800d0, 55.84700d0, 58.93320d0, 58.71000d0, 63.54600d0,&
     & 65.38000d0, 69.73500d0, 72.59000d0, 74.92160d0, 78.96000d0,&
     & 79.90400d0, 83.80000d0, 85.46780d0, 87.62000d0, 88.90590d0,&
     & 91.22000d0, 92.90640d0, 95.94000d0, 98.90620d0, 101.0700d0,&
     & 102.9055d0, 106.4000d0, 107.8680d0, 112.4100d0, 114.8200d0,&
     & 118.6900d0, 121.7500d0, 127.6000d0, 126.9045d0, 131.3000d0,&
     & 132.9054d0, 137.3300d0, &
     & 138.91, 140.12, 140.91, 144.24, 147.00, 150.36, 151.97, 157.25,&
     & 158.93, 162.50, 164.93, 167.26, 168.93, 173.04, 174.97,&
     & 178.4900d0, 180.9479d0,&
     & 183.8500d0, 186.2070d0, 190.2000d0, 192.2200d0, 195.0900d0,&
     & 196.9665d0, 200.5900d0, 204.3700d0, 207.2000d0, 208.9804d0,&
     & 209., 210., 222., 21*0.000d0/
! atomic masses

      sumw = 1.e-20_wp
      sumwx = 0.0_wp
      sumwy = 0.0_wp
      sumwz = 0.0_wp

      do i = 1, n
         sumw = sumw + ams(nat(i))
         sumwx = sumwx + ams(nat(i))*coord(1, i)
         sumwy = sumwy + ams(nat(i))*coord(2, i)
         sumwz = sumwz + ams(nat(i))*coord(3, i)
      end do

      sum3(1) = sumwx/sumw
      sum3(2) = sumwy/sumw
      sum3(3) = sumwz/sumw

   end subroutine cmadock

   subroutine rcma(n1, xyz1, iz1, n2, xyz2, iz2, r, rmin)

      integer, intent(in) :: n1, n2
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)
      integer, intent(in) :: iz1(n1)
      integer, intent(in) :: iz2(n2)
      real(wp), intent(out) :: r, rmin

      real(wp) :: x1(3)
      real(wp) :: x2(3)
      integer :: i, j
      real(wp) :: rr

      call cmadock(n1, n1, iz1, xyz1, x1)
      call cmadock(n2, n2, iz2, xyz2, x2)

      r = sqrt((x1(1) - x2(1))**2 + (x1(2) - x2(2))**2 + (x1(3) - x2(3))**2)

      rmin = 1.d+42
      do i = 1, n1
         do j = 1, n2
            rr = sqrt((xyz1(1, i) - xyz2(1, j))**2 +&
               &(xyz1(2, i) - xyz2(2, j))**2 +&
               &(xyz1(3, i) - xyz2(3, j))**2)
            if (rr .lt. rmin) rmin = rr
         end do
      end do

   end subroutine rcma

! xtbdock version
   subroutine rotmat(rxyz, rot)
      real(wp), intent(in) :: rxyz(6)
      real(wp), intent(out) :: rot(3, 3)

      real(wp) :: r1(3, 3)
      real(wp) :: r2(3, 3)
      real(wp) :: r3(3, 3)
      real(wp) :: tmp(3, 3)

      r1(1, 1) = 1.0
      r1(1, 2) = 0.0
      r1(1, 3) = 0.0
      r1(2, 1) = 0.0
      r1(2, 2) = cos(rxyz(4))
      r1(2, 3) = -sin(rxyz(4))
      r1(3, 1) = 0.0
      r1(3, 2) = sin(rxyz(4))
      r1(3, 3) = cos(rxyz(4))

      r2(2, 1) = 0.0
      r2(2, 2) = 1.0
      r2(2, 3) = 0.0
      r2(1, 1) = cos(rxyz(5))
      r2(1, 2) = 0.0
      r2(1, 3) = sin(rxyz(5))
      r2(3, 1) = -sin(rxyz(5))
      r2(3, 2) = 0.0
      r2(3, 3) = cos(rxyz(5))

      r3(3, 1) = 0.0
      r3(3, 2) = 0.0
      r3(3, 3) = 1.0
      r3(1, 1) = cos(rxyz(6))
      r3(1, 2) = -sin(rxyz(6))
      r3(1, 3) = 0.0
      r3(2, 1) = sin(rxyz(6))
      r3(2, 2) = cos(rxyz(6))
      r3(2, 3) = 0.0

      tmp = matmul(r2, r3)
      rot = matmul(r1, tmp)

   end subroutine rotmat

! rotate 3D-vector array around Euler angles ang
   subroutine rot3(n, xyz, rotm)

      integer, intent(in) :: n
      real(wp), intent(inout) :: xyz(3, n)
      real(wp), intent(in) :: rotm(3, 3)

      integer :: i

      xyz = matmul(rotm, xyz)

   end subroutine rot3

   subroutine rot4(n, xyz, rotm)

      integer, intent(in) :: n
      real(wp), intent(inout) :: xyz(4, 10*n)
      real(wp), intent(in) :: rotm(3, 3)

      real(wp) :: tmp(3, n)
      integer :: i

      tmp(1:3, 1:n) = xyz(1:3, 1:n)
      tmp = matmul(rotm, tmp)
      xyz(1:3, 1:n) = tmp(1:3, 1:n)

   end subroutine rot4

   subroutine wrc0(fname, n1, at1, xyz1)

      character(len=*), intent(in) :: fname
      integer, intent(in) :: n1, at1(n1)
      real(wp), intent(in) :: xyz1(3, n1)

      integer :: j

      open (unit=1, file=fname)
      write (1, '(''$coord'')')
      do j = 1, n1
         write (1, '(3F24.10,5x,a2)') xyz1(1:3, j), toSymbol(at1(j))
      end do
      write (1, '(''$end'')')
      close (1)

   end subroutine wrc0

   subroutine wrc(fname, n1, n2, at1, at2, xyz1, xyz2, icoord)

      character(len=*), intent(in) :: fname
      integer, intent(in) :: n1, at1(n1)
      integer, intent(in) :: n2, at2(n2)
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)
      real(wp), intent(in) :: icoord(6)

      real(wp) ::   c2(3, n2)
      integer :: j

      call move2(n2, xyz2, c2, icoord)

      open (unit=1, file=fname)
      write (1, '(''$coord'')')
      do j = 1, n1
         write (1, '(3F24.10,5x,a2)') xyz1(1:3, j), toSymbol(at1(j))
      end do
      do j = 1, n2
         write (1, '(3F24.10,5x,a2)') c2(1:3, j), toSymbol(at2(j))
      end do
      write (1, '(''$end'')')
      close (1)

   end subroutine wrc

   subroutine wrc2(fname, mode, n1, n2, at1, at2, xyz1, xyz2, nf, found)

      character(len=*), intent(in) :: fname
      integer, intent(in) :: nf, mode
      integer, intent(in) :: n1, at1(n1)
      integer, intent(in) :: n2, at2(n2)
      real(wp), intent(in) :: found(7, *)
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)

      real(wp) ::   c2(3, n2)
      real(wp) :: icoord(6)
      real(wp), parameter :: autoang = 0.52917726d0
      integer :: i, j

      open (unit=33, file=fname)
      do i = 1, nf
         write (33, *) n1 + n2
         write (33, '('' SCF done '',F16.8)') found(7, i)
         icoord(1:6) = found(1:6, i)
         call move2(n2, xyz2, c2, icoord)
         do j = 1, n1
            write (33, '(a2,3F24.10)') toSymbol(at1(j)), xyz1(1:3, j)*autoang
         end do
         do j = 1, n2
            if (mode .eq. 0) then
               write (33, '(a2,3F24.10)') toSymbol(at2(j)), c2(1:3, j)*autoang !  element symbol
            else
               write (33, '(a2,3F24.10)') toSymbol(5), c2(1:3, j)*autoang !  Bor for visualization
            end if
         end do
      end do
      close (33)

   end subroutine wrc2

   subroutine wrc3(fname, n1, n2, at1, at2, xyz1, xyz2, i, found)

      character(len=*), intent(in) :: fname
      integer, intent(in) :: i
      integer, intent(in) :: n1, at1(n1)
      integer, intent(in) :: n2, at2(n2)
      real(wp), intent(in) :: found(7, *)
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)

      real(wp) ::   c2(3, n2)
      real(wp) :: icoord(6)
      real(wp), parameter :: autoang = 0.52917726d0
      real(wp), parameter :: au = 627.509541d0
      real(wp) :: f
      integer :: j

      f = 1.
      if (i .eq. 0) f = au
      open (unit=33, file=fname)
      write (33, *) n1 + n2
      write (33, '('' SCF done '',F16.8)') found(7, 1)*f
      icoord(1:6) = found(1:6, 1)
      call move2(n2, xyz2, c2, icoord)
      do j = 1, n1
         write (33, '(a2,3F24.10)') toSymbol(at1(j)), xyz1(1:3, j)*autoang
      end do
      do j = 1, n2
         write (33, '(a2,3F24.10)') toSymbol(at2(j)), c2(1:3, j)*autoang !  element symbol
      end do
      close (33)

   end subroutine wrc3

   subroutine wr_grid(fname, n1, n2, at1, element, xyz1, xyz2)

      character(len=*), intent(in) :: fname
      integer, intent(in) :: n1, at1(n1)
      integer, intent(in) :: n2
      integer, intent(in) :: element
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)

      real(wp), parameter :: autoang = 0.52917726d0
      integer :: i, j

      open (unit=33, file=fname)
      write (33, *) n1 + n2
      write (33, *)
      do j = 1, n1
         write (33, '(a2,3F24.10)') toSymbol(at1(j)), xyz1(1:3, j)*autoang
      end do
      do j = 1, n2
         write (33, '(a2,3F24.10)') toSymbol(element), xyz2(1:3, j)*autoang !  Bor for visualization
      end do
      close (33)

   end subroutine wr_grid

! new cartesian cooordinates from internals
! move coordinates and LP centers
   subroutine move(n2, nl2, xyz, cl, xyznew, clnew, rotm, coord)

      integer, intent(in) :: n2, nl2
      real(wp), intent(in) :: xyz(3, n2)
      real(wp), intent(out) :: xyznew(3, n2)
      real(wp), intent(in) :: cl(4, n2*10)
      real(wp), intent(out) :: clnew(4, n2*10)
      real(wp), intent(in) :: coord(6)
      real(wp), intent(in) :: rotm(3, 3)

      integer :: k

!     rotate (its at the CMA)
      xyznew = xyz
      clnew = cl
      if (sum(abs(coord)) .lt. 1.d-12) return

      call rot3(n2, xyznew, rotm)
      call rot4(nl2, clnew, rotm)

!     shift
      do k = 1, 3
         xyznew(k, 1:n2) = xyznew(k, 1:n2) + coord(k)
         clnew(k, 1:nl2) = clnew(k, 1:nl2) + coord(k)
      end do

   end subroutine move

! move just coordinates
   subroutine move2(n2, xyz, xyznew, coord)

      integer, intent(in) :: n2
      real(wp), intent(in) :: xyz(3, n2)
      real(wp), intent(out) :: xyznew(3, n2)
      real(wp), intent(in) :: coord(6)

      real(wp) :: rotm(3, 3)
      integer :: k

!     rotate (its at the CMA)
      xyznew = xyz
      call rotmat(coord, rotm)
      call rot3(n2, xyznew, rotm)

!     shift
      do k = 1, 3
         xyznew(k, 1:n2) = xyznew(k, 1:n2) + coord(k)
      end do

   end subroutine move2

   subroutine rnorm(i, j, found, r)

      integer, intent(in) :: i, j
      real(wp), intent(in) :: found(7, *)
      real(wp), intent(out) :: r

      integer :: k
      real(wp) :: x

      r = 0
      do k = 1, 3
         r = r + (found(k, i) - found(k, j))**2
      end do
      do k = 4, 6
         x = found(k, i) - found(k, j)
         r = r + sin(0.5*x)**2
      end do

      r = sqrt(r)

   end subroutine rnorm

! random stuff
   subroutine rand6(mut, r1, r2, d) !Currently mut=0.5, r1=r2=1.0

      real(wp), intent(in) :: mut, r1, r2
      real(wp), intent(inout) :: d(6)

      real(wp), parameter :: pi2 = 2*3.14159265358979_wp
      real(wp) :: x, y, yy, f
      integer :: j, k

      call random_number(yy)
      if (yy .lt. mut) return    ! 50 % mutation rate

      do j = 1, 3                ! Shift position by either -x or +x (0<x<1)
         call random_number(y)
         f = 1.0
         if (y .lt. 0.5) f = -1.0
         call random_number(x)
         d(j) = d(j) + f*r1*x
      end do

      if (yy .gt. 0.95) then       !in 5 % of the cases turn around an random axis by 180 deg.
         call random_number(y)
         call irand(3, k)
         f = 0.5
         if (y .lt. 0.5) f = -0.5
         d(k + 3) = d(k + 3) + f*pi2
         return
      end if

      do j = 4, 6                  !Change angle by either -x or +x (0<x<1)
         call random_number(y)
         f = 1.0
         if (y .lt. 0.5) f = -1.0
         call random_number(x)
         d(j) = d(j) + f*r2*x
         if (d(j) .gt. pi2) d(j) = d(j) - pi2 !To not get lower than 0°
         if (d(j) .lt. 0) d(j) = d(j) + pi2   !To not get larger than 360°
      end do

   end subroutine rand6

! integer random number n=<irand<=1
   subroutine irand(n, k)
      integer, intent(in) :: n
      integer, intent(out) :: k

      real :: x, nx

      call random_number(x)
      nx = n*x + 1
      k = int(nx)
      if (k .gt. n) k = n

   end subroutine irand

   subroutine crossover(r, d)
      real(wp), intent(in) :: r
      real(wp), intent(inout) :: d(6)

      integer :: j
      real :: x

      do j = 1, 6
         call random_number(x)
         if (x .gt. r) then
            d(j) = x
         else
            cycle
         end if
      end do

   end subroutine crossover

! sorts
   subroutine sort6(n, e)

      integer, intent(in) :: n
      real(wp), intent(inout) :: e(7, n)

      integer :: ind(n), i
      real(wp) :: tmp(n), ftmp(7, n)

      ftmp = e
      do i = 1, n
         ind(i) = i
         tmp(i) = e(7, i)
      end do

      call Qsort(tmp, 1, n, ind) ! sort

      do i = 1, n
         e(1:7, i) = ftmp(1:7, ind(i))
      end do

   end subroutine sort6

! write complex coord file
   subroutine wrlmocoord(fname, n1, n2, xyz1, xyz2, at1, at2, nlmo1, nlmo2,&
  &                      lmo1, lmo2, rlmo1, rlmo2)

      character(len=*), intent(in) :: fname
      integer, intent(in) :: n1, nlmo1, at1(n1), lmo1(n1*10)
      integer, intent(in) :: n2, nlmo2, at2(n2), lmo2(n2*10)
      real(wp), intent(in) :: xyz1(3, n1), rlmo1(4, n1*10)
      real(wp), intent(in) :: xyz2(3, n2), rlmo2(4, n2*10)

      integer :: i

      open (unit=32, file=fname)
      write (32, '(''$coord'')')
      do i = 1, n1
         write (32, '(3F24.10,5x,a2)') xyz1(1:3, i), toSymbol(at1(i))
      end do
      do i = 1, n2
         write (32, '(3F24.10,5x,a2)') xyz2(1:3, i), toSymbol(at2(i))
      end do
      do i = 1, nlmo1
         write (32, '(3F24.10,5x,a2)') rlmo1(1:3, i), toSymbol(2)
      end do
      do i = 1, nlmo2
         write (32, '(3F24.10,5x,a2)') rlmo2(1:3, i), toSymbol(2)
      end do
      write (32, '(''$end'')')
      close (32)

   end subroutine wrlmocoord

   ! recursively split molecule xyz,at into non-cov. bound fragments
   subroutine mrec(molcount, xyz, nat, at, molvec)

      ! molcount: number of total fragments (increased during search)
      ! xyz: overall Cart. coordinates
      ! nat: overall number of atoms
      ! at: atomic number array
      ! molvec: assignment vector of atom to fragment

      real(wp), intent(in) :: xyz(3, nat)
      integer, intent(in) :: nat, at(nat)
      integer, intent(out) :: molvec(nat), molcount

      real(wp) :: cn(nat), bond(nat, nat)
      integer :: i
      logical :: taken(nat)

      molvec = 0
      molcount = 1
      taken = .false.

      call xcoord(nat, at, xyz, cn, bond)

      do i = 1, nat
         if (.not. taken(i)) then
            molvec(i) = molcount
            taken(i) = .true.
            call neighbours(i, xyz, at, taken, nat, cn, bond, molvec, molcount)
            molcount = molcount + 1
         end if
      end do
      molcount = molcount - 1
   end subroutine mrec

   recursive subroutine neighbours(i, xyz, iat, taken, nat, cn, bond,&
        &                                molvec, molcnt)

      real(wp), intent(in) :: xyz(3, nat)
      real(wp), intent(inout) :: cn(nat), bond(nat, nat)
      integer, intent(in) :: i, nat, molcnt
      integer, intent(inout) :: molvec(nat)
      logical :: taken(nat)

      real(wp) :: r, tr, xi(3), cntmp
      integer :: j, iat(nat), icn, k

      tr = 2.0d0

      xi(1:3) = xyz(1:3, i)
      icn = nint(cn(i))
      do k = 1, icn
         j = maxloc(bond(:, i), 1)
         bond(j, i) = 0.0d0
         if (i .eq. j) cycle
         if (.not. taken(j)) then
            molvec(j) = molcnt
            taken(j) = .true.
            call neighbours(j, xyz, iat, taken, nat, cn, bond, molvec, molcnt)
         end if
      end do
   end subroutine neighbours

   ! compute coordination numbers by adding an inverse damping function
   subroutine xcoord(natoms, iz, xyz, cn, bond)

      integer, intent(in) :: iz(natoms), natoms
      real(wp), intent(in) :: xyz(3, natoms)
      real(wp), intent(out) :: bond(natoms, natoms), cn(natoms)

      integer :: iat, i, j
      real(wp) :: xn

      bond = 0.0d0
      cn = 0.0d0

      do i = 1, natoms
         call xdamp(natoms, i, xyz, iz, rcov, xn, bond)
         cn(i) = xn
      end do

   end subroutine xcoord

   subroutine xdamp(natoms, i, xyz, iz, rcv, xn, bond)

      integer, intent(in) :: natoms, iz(natoms), i
      real(wp), intent(in) :: xyz(3, natoms), rcv(94)
      real(wp), intent(out) :: bond(natoms, natoms), xn

      real(wp) :: dx, dy, dz, r, damp, rr, rco, r2
      integer :: iat

      xn = 0.0d0
      do iat = 1, natoms
         if (iat .eq. i) cycle
         dx = xyz(1, iat) - xyz(1, i)
         dy = xyz(2, iat) - xyz(2, i)
         dz = xyz(3, iat) - xyz(3, i)
         r2 = dx*dx + dy*dy + dz*dz
         r = sqrt(r2)
         ! covalent distance in Bohr
         rco = (rcv(iz(i)) + rcv(iz(iat)))*0.75! this scaling reduces the size of the clusters
         ! counting function exponential has a better long-range behavior than MHGs inverse damping
         damp = 1.d0/(1.d0 + exp(-16.0d0*(rco/r - 1.0d0)))
         bond(iat, i) = damp
         xn = xn + damp
      end do

   end subroutine xdamp

   subroutine valel(z)

      real(wp), intent(out) :: z(86)
      z(1) = 1.0
      z(2) = 2.0
      z(3) = 1.0
      z(4) = 2.0
      z(5) = 3.0
      z(6) = 4.0
      z(7) = 5.0
      z(8) = 6.0
      z(9) = 7.0
      z(10) = 8.0
      z(11) = 1.0
      z(12) = 2.0
      z(13) = 3.0
      z(14) = 4.0
      z(15) = 5.0
      z(16) = 6.0
      z(17) = 7.0
      z(18) = 8.0
      z(19) = 1.0
      z(20) = 2.0
      z(21) = 3.0
      z(22) = 4.0
      z(23) = 5.0
      z(24) = 6.0
      z(25) = 7.0
      z(26) = 8.0
      z(27) = 9.0
      z(28) = 10.0
      z(29) = 11.0
      z(30) = 2.0
      z(31) = 3.0
      z(32) = 4.0
      z(33) = 5.0
      z(34) = 6.0
      z(35) = 7.0
      z(36) = 8.0
      z(37) = 1.0
      z(38) = 2.0
      z(39) = 3.0
      z(40) = 4.0
      z(41) = 5.0
      z(42) = 6.0
      z(43) = 7.0
      z(44) = 8.0
      z(45) = 9.0
      z(46) = 10.0
      z(47) = 11.0
      z(48) = 2.0
      z(49) = 3.0
      z(50) = 4.0
      z(51) = 5.0
      z(52) = 6.0
      z(53) = 7.0
      z(54) = 8.0
      z(55) = 1.0
      z(56) = 2.0
      z(57) = 3.0
      z(58) = 3.0
      z(59) = 3.0
      z(60) = 3.0
      z(61) = 3.0
      z(62) = 3.0
      z(63) = 3.0
      z(64) = 3.0
      z(65) = 3.0
      z(66) = 3.0
      z(67) = 3.0
      z(68) = 3.0
      z(69) = 3.0
      z(70) = 3.0
      z(71) = 3.0
      z(72) = 3.0
      z(73) = 3.0
      z(74) = 3.0
      z(75) = 3.0
      z(76) = 3.0
      z(77) = 3.0
      z(78) = 3.0
      z(79) = 3.0
      z(80) = 3.0
      z(81) = 3.0
      z(82) = 4.0
      z(83) = 5.0
      z(84) = 6.0
      z(85) = 7.0
      z(86) = 8.0

   end subroutine valel

   subroutine get_mol(istart, iend, comb, mol)

      integer, intent(in) :: istart, iend

      type(TMolecule), intent(in) :: comb

      type(TMolecule), intent(out) :: mol

      integer, allocatable :: at(:)
      real(wp), allocatable :: xyz(:, :)
      integer :: n

      write (*, *) 'istart,iend', istart, iend
      n = iend - istart + 1

      allocate (at(n), xyz(3, n))

      at(1:iend) = comb%at(istart:iend)
      xyz(1:3, 1:iend) = comb%xyz(1:3, istart:iend)

      write (*, *) 'all', istart, iend, at, xyz

      call init(mol, at, xyz)

      deallocate (at, xyz)
   end subroutine get_mol

   subroutine split_mol(molA, molB, size_list, list, comb)

      type(TMolecule), intent(in) :: comb
      integer, intent(in) :: size_list, list(size_list)

      type(TMolecule), intent(inout) :: molA, molB

      integer :: at1(molA%n), at2(molB%n)
      integer :: i
      real(wp) :: xyz1(3, molA%n), xyz2(3, molB%n)

      do i=1, comb%n
         if(any(list == i)) then
            at1 = comb%at(1:molA%n)
            xyz1(1:3, :) = comb%xyz(1:3, 1:molA%n)
         else
            at2 = comb%at(molA%n + 1:molA%n + molB%n)
            xyz2(1:3, :) = comb%xyz(1:3, molA%n + 1:molA%n + molB%n)
         end if
      end do

      call init(molA, at1, xyz1)
      call init(molB, at2, xyz2)

   end subroutine split_mol

   subroutine combine_mol(comb, molA, molB)

      !> Molecular structure data
      type(TMolecule), intent(in) :: molA, molB
      type(TMolecule), intent(inout) :: comb

      integer, allocatable :: at(:)
      real(wp), allocatable :: xyz(:, :)
      integer :: i, j

      comb%n = molA%n + molB%n
      allocate (at(comb%n), source=0)
      allocate (xyz(3, comb%n), source=0.0_wp)

      !> Adding coords
      do i = 1, molA%n
         xyz(1, i) = molA%xyz(1, i)
         xyz(2, i) = molA%xyz(2, i)
         xyz(3, i) = molA%xyz(3, i)
      end do

      j = 1
      do i = molA%n + 1, comb%n
         xyz(1, i) = molB%xyz(1, j) + shift_geo
         xyz(2, i) = molB%xyz(2, j) + shift_geo
         xyz(3, i) = molB%xyz(3, j) + shift_geo
         j = j + 1
      end do

      !> Adding Atom-Types
      do i = 1, molA%n
         at(i) = molA%at(i)
      end do

      j = 1
      do i = molA%n + 1, comb%n
         at(i) = molB%at(j)
         j = j + 1
      end do

      if (allocated(comb%sym)) deallocate (comb%sym)
      allocate (comb%sym(comb%n), source='    ')
      deallocate (comb%sym)
      call init(comb, at, xyz)
      comb%chrg = molA%chrg + molB%chrg
      comb%uhf = molA%uhf + molB%uhf
      deallocate (at)
      deallocate (xyz)

      end subroutine combine_mol

end module xtb_docking_param

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Utilities to work with data types from C
module xtb_api_utils
   use, intrinsic :: iso_c_binding
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule
   use xtb_type_environment, only : init
   implicit none
   private

   public :: c_f_character, f_c_character, verifyMolecule, checkGlobalEnv

contains


subroutine c_f_character(rhs, lhs)
   character(kind=c_char), intent(in) :: rhs(*)
   !> Resulting Fortran string
   character(len=:, kind=c_char), allocatable, intent(out) :: lhs

   integer :: ii

   do ii = 1, huge(ii) - 1
      if (rhs(ii) == c_null_char) then
         exit
      end if
   end do
   allocate(character(len=ii-1) :: lhs)
   lhs = transfer(rhs(1:ii-1), lhs)

end subroutine c_f_character


subroutine f_c_character(rhs, lhs, len)
   character(kind=c_char), intent(out) :: lhs(*)
   character(len=*), intent(in) :: rhs
   integer, intent(in) :: len
   integer :: length
   length = min(len-1, len_trim(rhs))

   lhs(1:length) = transfer(rhs(1:length), lhs(1:length)) // c_null_char

end subroutine f_c_character


!> Cold fusion check
integer function verifyMolecule(mol) result(status)
   type(TMolecule), intent(in) :: mol
   integer :: iat, jat
   status = 0
   do iat = 1, mol%n
      do jat = 1, iat - 1
         if (mol%dist(jat, iat) < 1.0e-9_wp) status = status + 1
      end do
   end do
end function verifyMolecule


subroutine checkGlobalEnv
   use xtb_mctc_global, only : persistentEnv
   if (.not.allocated(persistentEnv)) then
      allocate(persistentEnv)
      call init(persistentEnv)
   end if
end subroutine checkGlobalEnv


end module xtb_api_utils

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_axis
   use xtb_mctc_accuracy, only : wp
contains
  subroutine axis(numat,nat,xyz,aa,bb,cc)
    use xtb_splitparam
    implicit double precision (a-h,o-z)
    dimension xyz(3,numat)
    integer nat(numat)

    PARAMETER (BOHR=0.52917726)
    dimension t(6), rot(3), xyzmom(3), eig(3), evec(3,3)
    dimension x(numat),y(numat),z(numat),coord(3,numat)
    data t /6*0.d0/
    !************************************************************************
    !*     const1 =  10**40/(n*a*a)
    !*               n = avergadro's number
    !*               a = cm in an angstrom
    !*               10**40 is to allow units to be 10**(-40)gram-cm**2
    !*
    !************************************************************************
    const1 = 1.66053d0
    !************************************************************************
    !*
    !*     const2 = conversion factor from angstrom-amu to cm**(-1)
    !*
    !*            = (planck's constant*n*10**16)/(8*pi*pi*c)
    !*            = 6.62618*10**(-27)[erg-sec]*6.02205*10**23*10**16/
    !*              (8*(3.1415926535)**2*2.997925*10**10[cm/sec])
    !*
    !***********************************************************************
    const2=16.8576522d0

    sumw=1.d-20
    sumwx=0.d0
    sumwy=0.d0
    sumwz=0.d0

    coord(1:3,1:numat)=xyz(1:3,1:numat)*bohr

    do i=1,numat
       sumw=sumw+atmass(i)
       sumwx=sumwx+atmass(i)*coord(1,i)
       sumwy=sumwy+atmass(i)*coord(2,i)
       sumwz=sumwz+atmass(i)*coord(3,i)
    enddo

    sumwx=sumwx/sumw
    sumwy=sumwy/sumw
    sumwz=sumwz/sumw
    f=1.0d0/bohr
    do  i=1,numat
       x(i)=coord(1,i)-sumwx
       y(i)=coord(2,i)-sumwy
       z(i)=coord(3,i)-sumwz
    enddo

    !************************************************************************
    !*    matrix for moments of inertia is of form
    !*
    !*           |   y**2+z**2                         |
    !*           |    -y*x       z**2+x**2             | -i =0
    !*           |    -z*x        -z*y       x**2+y**2 |
    !*
    !************************************************************************
    do i=1,6
       t(i)=dble(i)*1.0d-10
    enddo
    do i=1,numat
       t(1)=t(1)+atmass(i)*(y(i)**2+z(i)**2)
       t(2)=t(2)-atmass(i)*x(i)*y(i)
       t(3)=t(3)+atmass(i)*(z(i)**2+x(i)**2)
       t(4)=t(4)-atmass(i)*z(i)*x(i)
       t(5)=t(5)-atmass(i)*y(i)*z(i)
       t(6)=t(6)+atmass(i)*(x(i)**2+y(i)**2)
    enddo
    call rsp(t,3,3,eig,evec)
    !     xsum=evec(1,1)*(evec(2,2)*evec(3,3)-evec(3,2)*evec(2,3)) +
    !    1     evec(1,2)*(evec(2,3)*evec(3,1)-evec(2,1)*evec(3,3)) +
    !    2     evec(1,3)*(evec(2,1)*evec(3,2)-evec(2,2)*evec(3,1))
    do i=1,3
       if(eig(i).lt.3.d-4) then
          eig(i)=0.d0
          rot(i)=0.d0
       else
          rot(i)=2.9979245d+4*const2/eig(i)
       endif
       xyzmom(i)=eig(i)*const1
    enddo

    aa=rot(3)/2.9979245d+4
    bb=rot(2)/2.9979245d+4
    cc=rot(1)/2.9979245d+4
    avmom=1.d-47*(xyzmom(1)+xyzmom(2)+xyzmom(3))/3.

    return
  end subroutine axis

  subroutine axis2(numat,nat,xyz,aa,bb,cc,avmom,sumw)
    use xtb_splitparam
    implicit double precision (a-h,o-z)
    dimension xyz(3,numat)
    integer nat(numat)

    PARAMETER (BOHR=0.52917726)
    dimension t(6), rot(3), xyzmom(3), eig(3), evec(3,3)
    dimension x(numat),y(numat),z(numat),coord(3,numat)
    data t /6*0.d0/
    !************************************************************************
    !*     const1 =  10**40/(n*a*a)
    !*               n = avergadro's number
    !*               a = cm in an angstrom
    !*               10**40 is to allow units to be 10**(-40)gram-cm**2
    !*
    !************************************************************************
    const1 = 1.66053d0
    !************************************************************************
    !*
    !*     const2 = conversion factor from angstrom-amu to cm**(-1)
    !*
    !*            = (planck's constant*n*10**16)/(8*pi*pi*c)
    !*            = 6.62618*10**(-27)[erg-sec]*6.02205*10**23*10**16/
    !*              (8*(3.1415926535)**2*2.997925*10**10[cm/sec])
    !*
    !************************************************************************
    const2=16.8576522d0

    sumw=1.d-20
    sumwx=0.d0
    sumwy=0.d0
    sumwz=0.d0

    coord(1:3,1:numat)=xyz(1:3,1:numat)*bohr

    do i=1,numat
       sumw=sumw+atmass(i)
       sumwx=sumwx+atmass(i)*coord(1,i)
       sumwy=sumwy+atmass(i)*coord(2,i)
       sumwz=sumwz+atmass(i)*coord(3,i)
    enddo

    sumwx=sumwx/sumw
    sumwy=sumwy/sumw
    sumwz=sumwz/sumw
    f=1.0d0/bohr
    do i=1,numat
       x(i)=coord(1,i)-sumwx
       y(i)=coord(2,i)-sumwy
       z(i)=coord(3,i)-sumwz
    enddo

    !************************************************************************
    !*    matrix for moments of inertia is of form
    !*
    !*           |   y**2+z**2                         |
    !*           |    -y*x       z**2+x**2             | -i =0
    !*           |    -z*x        -z*y       x**2+y**2 |
    !*
    !************************************************************************
    do i=1,6
       t(i)=dble(i)*1.0d-10
    enddo
    do i=1,numat
       t(1)=t(1)+atmass(i)*(y(i)**2+z(i)**2)
       t(2)=t(2)-atmass(i)*x(i)*y(i)
       t(3)=t(3)+atmass(i)*(z(i)**2+x(i)**2)
       t(4)=t(4)-atmass(i)*z(i)*x(i)
       t(5)=t(5)-atmass(i)*y(i)*z(i)
       t(6)=t(6)+atmass(i)*(x(i)**2+y(i)**2)
    enddo
    call rsp(t,3,3,eig,evec)
    do i=1,3
       if(eig(i).lt.3.d-4) then
          eig(i)=0.d0
          rot(i)=0.d0
       else
          rot(i)=2.9979245d+4*const2/eig(i)
       endif
       xyzmom(i)=eig(i)*const1
    enddo

    aa=rot(3)/2.9979245d+4
    bb=rot(2)/2.9979245d+4
    cc=rot(1)/2.9979245d+4
    avmom=1.d-47*(xyzmom(1)+xyzmom(2)+xyzmom(3))/3.

    return
  end subroutine axis2

  subroutine axisvec(numat,nat,xyz,aa,bb,cc,evec)
    use xtb_splitparam
    implicit double precision (a-h,o-z)
    dimension xyz(3,numat)
    integer nat(numat)

    PARAMETER (BOHR=0.52917726)
    dimension t(6), rot(3), xyzmom(3), eig(3), evec(3,3)
    dimension x(numat),y(numat),z(numat),coord(3,numat)
    data t /6*0.d0/
    !************************************************************************
    !*     const1 =  10**40/(n*a*a)
    !*               n = avergadro's number
    !*               a = cm in an angstrom
    !*               10**40 is to allow units to be 10**(-40)gram-cm**2
    !*
    !************************************************************************
    const1 = 1.66053d0
    !************************************************************************
    !*
    !*     const2 = conversion factor from angstrom-amu to cm**(-1)
    !*
    !*            = (planck's constant*n*10**16)/(8*pi*pi*c)
    !*            = 6.62618*10**(-27)[erg-sec]*6.02205*10**23*10**16/
    !*              (8*(3.1415926535)**2*2.997925*10**10[cm/sec])
    !*
    !************************************************************************
    const2=16.8576522d0

    sumw=1.d-20
    sumwx=0.d0
    sumwy=0.d0
    sumwz=0.d0

    coord(1:3,1:numat)=xyz(1:3,1:numat)*bohr

    do i=1,numat
       sumw=sumw+atmass(i)
       sumwx=sumwx+atmass(i)*coord(1,i)
       sumwy=sumwy+atmass(i)*coord(2,i)
       sumwz=sumwz+atmass(i)*coord(3,i)
    enddo

    sumwx=sumwx/sumw
    sumwy=sumwy/sumw
    sumwz=sumwz/sumw
    f=1.0d0/bohr
    do i=1,numat
       x(i)=coord(1,i)-sumwx
       y(i)=coord(2,i)-sumwy
       z(i)=coord(3,i)-sumwz
    enddo

    !************************************************************************
    !*    matrix for moments of inertia is of form
    !*
    !*           |   y**2+z**2                         |
    !*           |    -y*x       z**2+x**2             | -i =0
    !*           |    -z*x        -z*y       x**2+y**2 |
    !*
    !************************************************************************
    do i=1,6
       t(i)=dble(i)*1.0d-10
    enddo
    do i=1,numat
       t(1)=t(1)+atmass(i)*(y(i)**2+z(i)**2)
       t(2)=t(2)-atmass(i)*x(i)*y(i)
       t(3)=t(3)+atmass(i)*(z(i)**2+x(i)**2)
       t(4)=t(4)-atmass(i)*z(i)*x(i)
       t(5)=t(5)-atmass(i)*y(i)*z(i)
       t(6)=t(6)+atmass(i)*(x(i)**2+y(i)**2)
    enddo
    call rsp(t,3,3,eig,evec)
    !     xsum=evec(1,1)*(evec(2,2)*evec(3,3)-evec(3,2)*evec(2,3)) +
    !    1     evec(1,2)*(evec(2,3)*evec(3,1)-evec(2,1)*evec(3,3)) +
    !    2     evec(1,3)*(evec(2,1)*evec(3,2)-evec(2,2)*evec(3,1))
    do i=1,3
       if(eig(i).lt.3.d-4) then
          eig(i)=0.d0
          rot(i)=0.d0
       else
          rot(i)=2.9979245d+4*const2/eig(i)
       endif
       xyzmom(i)=eig(i)*const1
    enddo

    aa=rot(3)/2.9979245d+4
    bb=rot(2)/2.9979245d+4
    cc=rot(1)/2.9979245d+4
    avmom=1.d-47*(xyzmom(1)+xyzmom(2)+xyzmom(3))/3.

    return
  end subroutine axisvec

!*****************************************************************
! transform to CMA for output on trj xyz file
! input coords remain unchanged
!*****************************************************************

   subroutine axis3(mode,numat,nat,coord,coordout,eig)
      use xtb_splitparam
      implicit none
      integer, intent(in)  :: numat,nat(numat),mode
      real(wp),intent(in)  :: coord(3,numat)
      real(wp),intent(out) :: coordout(3,numat),eig(3)

      real(wp) :: sumw,sumwx,sumwy,sumwz,xsum,eps,ams
      real(wp) :: t(6), evec(3,3)
      real(wp) :: x(numat),y(numat),z(numat),coordtmp(3,numat)
      real(wp) :: coord1(3,numat)
      integer  :: i,j,k
      t = (/(0.0_wp,i=1,6)/)

      sumw=1.e-20_wp
      sumwx=0.0_wp
      sumwy=0.0_wp
      sumwz=0.0_wp
      do i=1,numat
         if(mode.eq.0)then
            ams = atmass(i)
         else
            ams = 1._wp/atmass(i)
         endif
         sumw=sumw+ams
         sumwx=sumwx+ams*coord(1,i)
         sumwy=sumwy+ams*coord(2,i)
         sumwz=sumwz+ams*coord(3,i)
      enddo

      eps=1.e-3_wp
      sumwx=sumwx/sumw
      sumwy=sumwy/sumw
      sumwz=sumwz/sumw
      do i=1,numat
         x(i)=coord(1,i)-sumwx
         y(i)=coord(2,i)-sumwy
         z(i)=coord(3,i)-sumwz
         coordtmp(1,i)=x(i)
         coordtmp(2,i)=y(i)
         coordtmp(3,i)=z(i)
      enddo

      do i=1,6
         t(i)=real(i,wp)*1.0e-10_wp
      enddo

      do i=1,numat
         t(1)=t(1)+atmass(i)*(y(i)**2+z(i)**2)+eps
         t(2)=t(2)-atmass(i)*x(i)*y(i)
         t(3)=t(3)+atmass(i)*(z(i)**2+x(i)**2)+eps
         t(4)=t(4)-atmass(i)*z(i)*x(i)
         t(5)=t(5)-atmass(i)*y(i)*z(i)
         t(6)=t(6)+atmass(i)*(x(i)**2+y(i)**2)+eps
      enddo

      call rsp(t,3,3,eig,evec)

!   now to orient the molecule so the chirality is preserved
      xsum=evec(1,1)*(evec(2,2)*evec(3,3)-evec(3,2)*evec(2,3)) + &
     &     evec(1,2)*(evec(2,3)*evec(3,1)-evec(2,1)*evec(3,3)) + &
     &     evec(1,3)*(evec(2,1)*evec(3,2)-evec(2,2)*evec(3,1))
      if( xsum .lt. 0) then
         do j=1,3
   80       evec(j,1)=-evec(j,1)
         enddo
      endif
!     call prmat(6,evec,3,3,'Rmat')

      do i=1,numat
         do j=1,3
            xsum=0.d0
            do k=1,3
               xsum=xsum+coordtmp(k,i)*evec(k,j)
            enddo
            coord1(j,i)=xsum
         enddo
      enddo

      do i=1,numat
         coordout(1,i)=coord1(1,i)
         coordout(2,i)=coord1(2,i)
         coordout(3,i)=coord1(3,i)
      enddo

      return
   end subroutine axis3

end module xtb_axis

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_biaspath
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: bias_path

contains

!! ========================================================================
!  RMSD biased push/pull path finder (RMSD-BPP)
!  SG 12/18, modified 06/20
!! ========================================================================
subroutine bias_path(env, mol, chk, calc, egap, et, maxiter, epot, grd, sigma)
   use xtb_mctc_filetypes, only : fileType
   use xtb_mctc_convert
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_type_restart
   use xtb_type_data, only : scc_results
   use xtb_single, only : singlepoint
   use xtb_io_writer, only : writeMolecule
   use xtb_setparam
   use xtb_fixparam
   use xtb_cqpath
   use xtb_geoopt
   use xtb_optimizer
   use xtb_lsrmsd
   use xtb_metadynamic
   use xtb_readin
   use xtb_axis, only : axis
   use xtb_param_atomicRad, only : atomicRad

   implicit none

   character(len=*), parameter :: source = 'xtb_path'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule),    intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   integer, intent(in)    :: maxiter
   real(wp),intent(in)    :: epot
   real(wp),intent(in)    :: et
   real(wp),intent(inout) :: egap
   real(wp),intent(inout) :: grd(3,mol%n)
   real(wp),intent(inout) :: sigma(3,3)

   real(wp),allocatable :: xyze(:,:)
   real(wp),allocatable :: xyzp(:,:)
   real(wp),allocatable :: gtmp(:,:)
   real(wp),allocatable :: xyzpath(:,:,:)
   real(wp),allocatable :: xyzdum (:,:,:)
   real(wp),allocatable :: bo(:,:), cn(:)
   real(wp),allocatable :: pvec1(:), pvec2(:)
   real(wp),allocatable :: epath(:), mempath(:,:)
   integer, allocatable :: atp(:)
   integer, allocatable :: splitl(:)
   integer, allocatable :: npath(:)

   integer i,j,k,ii,nn,olev,skip,irun,maxoptiter,nk,maxcycle,idum,maxpath
   integer np,iter,its,modef,run,npathk,tsmodeav,ialp,nrefine,nalp,imem(100)
   integer ilog,ilog2,idat ! file handle

   real(wp) U(3,3),x(3),y(3),rms,barr,drms,gnew,e1,dum0,r,rco,rms2,factor2
   real(wp) x3(3),t3(3),xx(10),dum,factor,distort,gnorm,dum1,thr,scc,w1,w2
   real(wp) fnat,rmsd_prod_thr,alp_change,k_change,edrmsd,ppull
   real(wp) gdum,gts,emax,eback,eforw,eforw_prev,gsum_prev,pthr
   real(wp) de_min,grad_min,e_ed,e_pr,de,ddot,gthr

   character(len=80) :: atmp,btmp
   logical fail,ex,done,degen
   type(scc_results) :: res

   !! ------------------------------------------------------------------------
   !  some parameters
   !! ------------------------------------------------------------------------

   nrefine =set%pathset%nrun! # of refinement (full path opt) steps (usually 1)
   nalp    =4           ! # of test runs with different alpha bias
   nk      =6           ! # of test runs with different k bias
   maxpath =nalp*nk

   ppull= set%pathset%ppull ! default pull strength on path point

   pthr = 0.00_wp       ! include points on path depending on overlap of approx TS modes
   gthr = 0.01_wp       ! Gnorm at TS exit thr
   rmsd_prod_thr=0.2_wp ! RMSD between product and last point on path found
   ! if less, loop terminates and path is considered as ok
   k_change  = 1.5_wp   ! increase k push/pull in each try by this
   alp_change= 0.2_wp   ! decrease alpha in each alp try by this
   scc       = 2.0_wp   ! high accuracy not important in SP

   set%optset%maxdispl_opt=0.50_wp ! don't make it too small (more points, erratic behavior)
   set%optset%hlow_opt    =0.03_wp ! too small values can cause spikes

   ilog =14
   ilog2=142

   call metaset%allocate(mol%n,2)
   allocate(splitl(mol%n),gtmp(3,mol%n),pvec1(3*mol%n),pvec2(3*mol%n))
   allocate(xyze(3,mol%n),xyzp(3,mol%n),bo(mol%n,mol%n),atp(mol%n),cn(mol%n))
   allocate(npath(maxpath),mempath(4,maxpath))

   if (.not.allocated(set%pathset%fname)) then
      call env%error('No product structure given!', source)
      return
   endif
   write(env%unit,*) 'reading reference structures from '//set%pathset%fname//' ...'
   call rdcoord(set%pathset%fname,mol%n,xyzp,atp) ! product
   if (any(atp.ne.mol%at)) then
      call env%error('Atom type missmatch between reactant and product!', source)
   endif
   xyze=mol%xyz ! reactant

   call rmsd(mol%n,xyze,xyzp,0,U,x,y,rms,.false.,gtmp)
   write(env%unit,'("reactant product RMSD :",f9.3)')rms

   if (set%pathset%nat.gt.0) then
      metaset%nat = set%pathset%nat
      metaset%atoms = set%pathset%atoms
      fnat=real(metaset%nat,wp)   ! # atoms used in RMSD
   else
      metaset%nat = 0
      fnat= mol%n  ! all atoms used in RMSD
   endif

   write(env%unit,'("initial k push/pull (in code xNat) :",2f9.3)')set%pathset%kpush,set%pathset%kpull
   write(env%unit,'("initial Gaussian width (1/Bohr)    :",f9.3)')set%pathset%alp
   write(env%unit,'("# refinement runs                  :",i4)')nrefine
   write(env%unit,'("# of ''an''-optimization steps       :",i4)')set%pathset%anopt
   write(env%unit,'("# optlevel                         :",i4)')set%optset%optlev
   write(env%unit,*)

   !! ------------------------------------------------------------------------
   !  check if its poly-molecular reaction (in case increas rmsd_prod_thr)
   !! ------------------------------------------------------------------------

   bo = 0
   do i=1,mol%n
      cn(i)=0
      do j=1,mol%n
         r=sqrt(sum(xyzp(:,i)-xyzp(:,j)))
         rco=(atomicRad(mol%at(i))+atomicRad(mol%at(j)))*autoaa
         if(r.lt.2.5*rco) then
            bo(j,i)=1
            cn(i)=cn(i)+1
         endif
      enddo
      bo(i,i)=0
   enddo
   call mrec(i,xyzp,cn,bo,mol%n,mol%at,splitl)
   rmsd_prod_thr = rmsd_prod_thr * float(i) ! RMSD can be large if fragments are involved
   deallocate(bo,cn,splitl)

   call axis(mol%n,mol%at,xyze,x(1),x(2),x(3))
   call axis(mol%n,mol%at,xyzp,y(1),y(2),y(3))

   degen = .false.
   dum = 2.0_wp*abs(sum(x)-sum(y))/(sum(x)+sum(y))
   if(dum.lt.0.01) degen = .true.  ! possibly degenrate E/P
   write(env%unit,'("degenerate system :",l,2f9.6)')degen,sum(x),sum(y)

   !! ------------------------------------------------------------------------
   !  loop over runs with increasing Vbias
   !! ------------------------------------------------------------------------

   metaset%xyz(:,:,1) = xyze
   metaset%xyz(:,:,2) = xyzp
   done  = .false.
   irun  = 0
   factor2= 0.0_wp
   call delete_file('.xtbtmpmode')
   call delete_file('hessian')

   bias_loop: do ialp=1,nalp ! alp
      factor = 1.0_wp
      do run=1,nk  ! k_push/pull

         irun = irun + 1
         ! set for metadyn routine (common)
         metaset%factor(1) = set%pathset%kpush * factor * fnat
         metaset%factor(2) = set%pathset%kpull * factor * fnat
         metaset%width(:) = set%pathset%alp - factor2
         metaset%width(:) = max(metaset%width(:),0.2_wp)

         !! ------------------------------------------------------------------------
         ! make path
         !! ------------------------------------------------------------------------

         if(degen)then ! avoid symmetry trapping
            do i=1,mol%n
               do j=1,3
                  call random_number(dum)
                  if(mod(i,2).eq.0)then
                     mol%xyz(j,i)=mol%xyz(j,i)+0.05*dum
                  else
                     mol%xyz(j,i)=mol%xyz(j,i)-0.05*dum
                  endif
               enddo
            enddo
         endif

         metaset%nstruc = 2
         maxoptiter     = 0
         olev           = set%optset%optlev       ! opt level
         mol%xyz        = xyze

         atmp='xtbopt.log'
         call open_file(ilog,atmp,'w')
         call ancopt (env,ilog,mol,chk,calc,egap,et,maxiter,maxoptiter,dum,grd,sigma,olev,.false.,fail)
         call close_file(ilog)

         !! ------------------------------------------------------------------------
         ! read opt history file (kept)
         !! ------------------------------------------------------------------------

         call cqpath_read_pathfile_parameter(atmp,j,k,npath(irun))
         if(k.ne.mol%n) call env%terminate('read error in bias_path, 1')
         allocate(xyzpath(3,mol%n,npath(irun)),epath(npath(irun)))
         call cqpath_read_pathfile(atmp,j,k,npath(irun),xyzpath,mol%at,epath)
         xyzpath=xyzpath/0.52917726_wp

         ! check RMSD if something happened
         mol%xyz(:, :) = xyzpath(:, :, npath(irun))
         call rmsd(mol%n,mol%xyz,xyzp,0,U,x,y,rms,.false.,gtmp)

         write(env%unit,'(i3," # points, run ",i3," for k push/pull/alpha :",3f8.3,5x," prod-ed RMSD:",f8.3)')  &
            &  npath(irun),run,metaset%factor(1:2)/fnat, metaset%width(1), rms

         !! ------------------------------------------------------------------------
         ! save results
         !! ------------------------------------------------------------------------

         write(btmp,'("xtbpath_",i0,".xyz")') irun
         call open_file(ilog2,btmp,'w')
         metaset%nstruc = 0 ! no bias
         barr=-1.d+42
         do i=1,npath(irun)
            mol%xyz(:, :) = xyzpath(:, :, i)
            call singlepoint(env,mol,chk,calc,egap,et,maxiter,0,.true.,.false.,scc,epath(i),grd,sigma,res)
            dum=autokcal*(epath(i)-epath(1))
            if(dum.gt.barr) barr=dum
            call writeMolecule(mol, ilog2, fileType%xyz, energy=dum)
         enddo
         call close_file(ilog2)
         mempath(1,irun)=barr
         mempath(2,irun)=autokcal*(epath(npath(irun))-epath(1))
         mempath(3,irun)=rms
         mempath(4,irun)=metaset%width(1)
         deallocate(xyzpath,epath)

         ! increase power
         factor = factor * k_change

         if(done) exit bias_loop

         if(rms.lt.rmsd_prod_thr) then ! found product
            factor = factor / k_change / 1.2_wp  ! test a bit smaller push/pull
            done = .true. ! close enough to product, add one more (with less bias) and then exit
         endif

      enddo
      factor2= factor2 + alp_change
   enddo bias_loop
   
   !! ------------------------------------------------------------------------
   ! output and find path yielding product
   !! ------------------------------------------------------------------------

   write(env%unit,*)
   write(env%unit,*) 'path trials (see xtbpath_*.xyz), energies in kcal/mol'
   j = 0
   do i=1,irun
      write(env%unit,'("run",i2,"  barrier:",f7.2,"  dE:",f7.2, "  product-end path RMSD:",f8.3 &
         &       )') i,mempath(1:3,i)
      if(mempath(3,i).lt.rmsd_prod_thr) then
         j = j + 1
         imem(j) = i
      endif
   enddo
   if(j.eq.0) then
      call env%error('No product! Decrease alp in $path and/or optlevel.', source)
      return
   end if
   dum = 1.d+42
   k = 1
   do i=1,j   ! take from those the one with lowest barrier
      ii=imem(i)
      if(mempath(1,ii).lt.dum) then
         dum = mempath(1,ii)
         k = ii
      endif
   enddo
   npathk = k

   ! important modification of the pull strength on the path
   ppull = ppull * (mempath(4,npathk)/1.2_wp)**2  ! if the opt. path alpha is small, the
   ! kpull for the constrained opt. must be small
   ! e.g. for helicene or BCF racem.

   !! ------------------------------------------------------------------------
   !  take best path for refinement
   !! ------------------------------------------------------------------------

   write(btmp,'("xtbpath_",i0,".xyz")') npathk
   call cqpath_read_pathfile_parameter(btmp,j,k,np)
   allocate(xyzpath(3,mol%n,np),epath(np))
   call cqpath_read_pathfile(btmp,j,k,np,xyzpath,mol%at,epath)
   xyzpath=xyzpath/0.52917726_wp
   write(env%unit,'("path ",i2," taken with ",i4," points.")') npathk, np

   deallocate(npath,mempath)

   !! ------------------------------------------------------------------------
   !  make the path nicer for optimizations
   !! ------------------------------------------------------------------------

   write(env%unit,'("screening points ...")')
   if(np.gt.set%pathset%nopt)then
      allocate(xyzdum(3,mol%n,np))
      call screenpath(np,set%pathset%nopt,idum,mol%n,xyzpath,epath,xyzdum)
      xyzdum(:,:,1:idum)=xyzpath(1:,:,1:idum)
      deallocate(xyzpath,epath)
      np=idum
      allocate(xyzpath(3,mol%n,np),epath(np))
      xyzpath(:,:,1:np)=xyzdum(1:,:,1:np)
      deallocate(xyzdum)
      write(env%unit,'("new # points :",i3)') np
   endif

   !  call cleanpath(np,mol%n,xyzpath,xyze,xyzp,pthr) ! not good

   epath = 0
   btmp='xtbpath_0.xyz' ! write the path before opt.
   write(env%unit,'("start path on file ",a)') btmp
   call open_file(ilog2,btmp,'w')
   metaset%nstruc = 0 ! unbiased energy and gradient
   mol%xyz=xyzpath(:,:,1)
   call singlepoint(env,mol,chk,calc,egap,et,maxiter,0,.true.,.false.,scc,epath(1),grd,sigma,res)
   call writeMolecule(mol, ilog2, fileType%xyz, energy=0.0_wp)
   do i=2,np-1
      mol%xyz=xyzpath(:,:,i)
      call singlepoint(env,mol,chk,calc,egap,et,maxiter,0,.true.,.false.,scc,epath(i),grd,sigma,res)
      call writeMolecule(mol, ilog2, fileType%xyz, energy=autokcal*(epath(i)-epath(1)))
   end do
   mol%xyz=xyzpath(:,:,np)
   call singlepoint(env,mol,chk,calc,egap,et,maxiter,0,.true.,.false.,scc,epath(np),grd,sigma,res)
   call writeMolecule(mol, ilog2, fileType%xyz, energy=autokcal*(epath(np)-epath(1)))
   call close_file(ilog2)

   !! ------------------------------------------------------------------------
   !  new section for path refinment by restricted (path biased) opt.
   !! ------------------------------------------------------------------------

   maxoptiter=set%pathset%anopt

   allocate(xyzdum(3,mol%n,np))
   call open_file(ilog,'xtbopt.log','w')
   eforw= 1.0d+42
   gts  = 1.0d+42
   do iter=1,nrefine
      write(env%unit,'(''refinement cycle'',i4)')iter
      call alignpath(mol%n,np,xyzpath)

      xyzdum(:,:,1:np) = xyzpath(:,:,1:np)      ! save coords for path mode projection
      do i=2,np-1                               ! one opt for all points
         if(mod(i,10).eq.0.or.i.eq.2) write(*,*) 'optimizing points ',i,' ...'
         mol%xyz=xyzpath(:,:,i)
         call metadyn_tsmode(mol%n,np,i,xyzdum,mol%xyz,ppull) ! add bias on path (and constrain optionally)
         call ancopt (env,ilog,mol,chk,calc,egap,et,maxiter,maxoptiter,epath(i),grd,sigma,olev,.false.,fail)
         xyzpath(:,:,i)=mol%xyz
      end do

      call open_file(ilog2,'xtbpath.xyz','w')
      mol%xyz=xyzpath(:,:,1) ! first point
      call writeMolecule(mol, ilog2, fileType%xyz, energy=0.0_wp)
      write(env%unit,*)
      dum =-1.d+42
      metaset%nstruc = 0 ! unbiased energy and gradient
      do i=2,np-1
         mol%xyz=xyzpath(:,:,i)
         call singlepoint(env,mol,chk,calc,egap,et,maxiter,0,.true.,.true.,scc,epath(i),grd,sigma,res)
         call writeMolecule(mol, ilog2, fileType%xyz, energy=autokcal*(epath(i)-epath(1)))
         if(epath(i).gt.dum)then
            dum=epath(i)
            gts=sqrt(sum(grd**2))
            its=i
         endif
      enddo
      mol%xyz=xyzpath(:,:,np)  ! last point
      call writeMolecule(mol, ilog2, fileType%xyz, energy=autokcal*(epath(np)-epath(1)))
      call close_file(ilog2)

      gsum_prev=gts
      eforw_prev=eforw
      emax=maxval(epath(1:np))
      eforw=(emax-epath(1) )*autokcal
      eback=(emax-epath(np))*autokcal
      de   =(epath(np)-epath(1))*autokcal
      write(env%unit,'(''forward  barrier (kcal)  :'',f10.3)') eforw
      write(env%unit,'(''backward barrier (kcal)  :'',f10.3)') eback
      write(env%unit,'(''reaction energy  (kcal)  :'',f10.3)') de
      write(env%unit,'(''opt. pull strength       :'',f10.3)') ppull
      write(env%unit,'(''norm(g) at est. TS, point:'', f8.5,i4)') gts, its

      if(gts.lt.gthr) then
         write(env%unit,'("terminated because grad at TS <threshold")')
         exit
      endif

   end do
   write(env%unit,*)
   if(iter.ge.nrefine)write(env%unit,'("terminated because max. # cycles reached")')

   !! ------------------------------------------------------------------------
   !  output
   !! ------------------------------------------------------------------------

   btmp='xtbpath_ts.xyz'
   write(env%unit,'("estimated TS on file ",a)') btmp
   call open_file(ilog,btmp,'w')
   mol%xyz=xyzpath(:,:,its)
   call writeMolecule(mol, ilog, fileType%xyz, energy=epath(its))
   close(ilog)

   dum=0
   write(env%unit,'("path data (pmode=approx. path mode):")')
   write(env%unit,'("point",5x,"drms",5x,"energy",1x,"pmode ovlp",1x,"pmode grad")')
   do i=2,np
      call guess_tsmode(mol%n,np,i,xyzpath,pvec1,pvec2)
      gdum=ddot(3*mol%n,pvec1,1,pvec2,1)
      mol%xyz=xyzpath(:,:,i)
      call rmsd(mol%n,xyzpath(:,:,i),xyzpath(:,:,i-1),0,U,x,y,rms,.false.,gtmp)
      dum1=(epath(i)-epath(i-1))/(rms*real(mol%n))  ! gradient along path
      write(env%unit,'(i4,3f10.3,f10.5)') i,dum,(epath(i)-epath(1))*autokcal,gdum,dum1
      dum=dum+rms
   enddo

end subroutine bias_path

!! ========================================================================
!  remove unecessary points
!! ========================================================================
subroutine screenpath(np,npwanted,npnew,n,xyz,e,xyzdum)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_environment
   implicit none
   integer   n,np,npwanted,npnew
   real(wp)  xyz   (3,n,np)       ! path coords
   real(wp)  e     (np)           ! energies
   real(wp)  xyzdum(3,n,np)       ! path coords

   integer i, j, k
   real(wp) :: dum1,dum2,thr
   real(wp), allocatable :: grad(:)

   allocate(grad(np))

   xyzdum = xyz

   do i=2,np-1
      dum2 = sum((xyz(:,:,i+1)-xyz(:,:,i-1))**2)+1.0_wp
      dum1 = e(i+1)-e(i-1)
      grad(i) = dum1/dum2
   enddo

   thr=0.01_wp
   k  = 0
10 continue
   k = k + 1
   j = 1
   do i=2,np-1
      if(abs(grad(i)).gt.thr)then
         j = j + 1
         xyz(:,:,j) = xyzdum(:,:,i)
      endif
   enddo
   if(j.ge.npwanted.and.k.lt.100)then
      thr = thr * 1.3
      goto 10
   endif

   npnew = j + 1
   xyz(:,:,1) = xyzdum(:,:,1)
   xyz(:,:,npnew) = xyzdum(:,:,np)

end subroutine


!! ========================================================================
!  put a bias on structure of actual point on path (and project out mode)
!! ========================================================================

subroutine metadyn_tsmode(n,sn,its,xyzpath,xyzact,kpull)
   use xtb_mctc_accuracy, only : wp
   use xtb_metadynamic
   use xtb_fixparam
   implicit none
   integer   n,its,sn
   real(wp)  xyzpath(3,n,sn)    ! path coords
   real(wp)  xyzact (3,n)       ! actual "
   real(wp)  kpull

   real(wp), allocatable :: pvec1(:), pvec2(:)
   integer :: i,j,k
   integer :: modef, idat


   metaset%nstruc = 1

   metaset%factor(1) = -kpull * real(n)  ! pull point on path, 0.05 good choice
   metaset%width(1) = 1.3_wp

   metaset%xyz(:,:,1) = xyzact(:,:)

   ! do not project, is unstable

   !   allocate(pvec1(3*n),pvec2(3*n))
   !   call guess_tsmode(n,sn,its,xyzpath,pvec1,pvec2)
   !   modef = 1
   !   idat  =15
   !   call open_binary(idat,'.xtbtmpmode','w')
   !   write (idat) modef
   !   write (idat) 0.5*(pvec1+pvec2)
   !   call close_file(idat)
   !   deallocate(pvec1,pvec2)

end subroutine

!! ========================================================================
!  get TS mode(s) (two directions) at path point its
!! ========================================================================

subroutine guess_tsmode(n,sn,its,xyz,pvec1,pvec2)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer   n,its,sn
   real(wp)  xyz(3,n,sn)
   real(wp)  pvec1(3*n)
   real(wp)  pvec2(3*n)

   integer :: i,j,k
   real(wp)  rms1,rms2,dum,dum2,third1,third2
   real(wp), allocatable, dimension(:) :: v
   parameter (third1 = 1.0_wp/3.0_wp)
   parameter (third2 = 2.0_wp/3.0_wp)

   i   = 0
   rms1= 0
   rms2= 0
   do k=1,n
      do j=1,3
         i = i + 1
         dum = (xyz(j,k,its+1) - xyz(j,k,its))
         if(its+2.le.sn)then
            dum2 = (xyz(j,k,its+2) - xyz(j,k,its+1))
            dum  = third2*dum+third1*dum2
         endif
         pvec1(i) = dum
         rms1= rms1 + dum**2
         dum = (xyz(j,k,its  ) - xyz(j,k,its-1))
         if(its.gt.2)then
            dum2 = (xyz(j,k,its-1) - xyz(j,k,its-2))
            dum  = third2*dum+third1*dum2
         endif
         pvec2(i) = dum
         rms2= rms2 + dum**2
      enddo
   enddo
   pvec1(:) = pvec1(:) / dsqrt(rms1) ! the vectors point in the same direction
   pvec2(:) = pvec2(:) / dsqrt(rms2)

end subroutine

subroutine alignpath(nat,sn,xyz)
   implicit none
   integer nat,sn
   real(wp) xyz(3,nat,sn)

   real(wp), allocatable, dimension(:,:) :: sp_atom
   real(wp), allocatable, dimension(:) :: x,y,x2,y2,strecke_X
   real(wp) :: strecke_X_inc,temp_strecke_X,xyz_0(3),xyz_1(3),xyz_diff(3)
   integer :: i,j,k

   allocate (strecke_X(sn),sp_atom(3,sn),x(sn),y(sn),x2(sn),y2(sn))

   ! loop over all atoms to get an array of all points of each atom along the path
   do i=1,nat
      sp_atom(:,:) = xyz(:,i,:)
      ! loop over path
      xyz_0(:) = sp_atom(:,1)
      strecke_X(1) = 0.0
      do j=2,sn
         xyz_1(:) = sp_atom(:,j)
         xyz_diff = xyz_1 - xyz_0
         xyz_0 = xyz_1
         strecke_X(j) = strecke_X(j-1) + sqrt(sum(xyz_diff**2))
      end do
      ! make a cubic spline for x,y,z dependent on strecke_X
      !       X = strecke_X , Y = [x|y|z]
      do k=1,3
         x(:) = strecke_X(:)
         y(:) = sp_atom(k,:)
         ! reposition on x
         call cqpath_repos_sym(sn,x,x2)               ! symmetric
         call cqpath_damped_cube_spline(sn,x,y,x2,y2) ! much better than non-damped
         sp_atom(k,:) = y2(:)
      end do
      ! save point
      xyz(:,i,:) = sp_atom(:,:)
   end do

   deallocate (strecke_X,sp_atom,x,y,x2,y2)
end subroutine

subroutine cqpath_repos_sym(n,x,x2)
   ! in    n  - dimension of array x,y
   !       x  - array x
   ! out   x2 - symmetric points from array x
   !
   implicit none
   integer, intent(in)  :: n
   real(wp), intent(in)  :: x(n)
   real(wp), intent(out) :: x2(n)

   real(wp) x_wert, x_anfang, x_ende, x_schritt
   integer :: i

   ! symmetric distribution
   ! dx(i) = distance/points
   x_anfang = x(1)
   x_ende = x(n)
   x_schritt = (x_ende-x_anfang)/(REAL(n,wp)-1.0)

   x_wert = x_anfang
   x2(1) = x_anfang
   do i=2,n-1
      x_wert = x_wert + x_schritt
      x2(i) = x_wert
   end do
   x2(n) = x_ende

end subroutine

subroutine cqpath_repos_asym(n,x1,x2)
   implicit none
   integer, intent(in)  :: n
   real(wp), intent(in)  :: x1(n)
   real(wp), intent(out) :: x2(n)

   real(wp) x_schritt, x_anfang, x_ende, x, ynorm
   real(wp), dimension(:), allocatable :: y
   integer :: i

   allocate(y(n))

   ynorm = 0.
   x = -1.
   do i=1,n
      y(i)=1./exp(-2.0*x**4)
      ynorm = ynorm + y(i)
      x = x + 2./float(n-1)
   enddo
   y = real(n,8) * y / ynorm

   x_anfang = x1(1)
   x_ende   = x1(n)
   x_schritt= (x_ende-x_anfang)/(REAL(n,wp)-2.0)

   x = x_anfang
   do i=1,n
      x2(i) = x
      x = x + x_schritt*y(i)
   end do

end subroutine

subroutine cqpath_cube_spline(n,x,y,x2,y2)
   ! in    n  - dimension of array x,y
   !       x  - array x
   !       y  - array y
   ! out   x2 - symmetric points from x
   !       y2 - symmetric points from y
   implicit none
   integer, intent(in) :: n
   real(wp), intent(in) :: x(n),y(n),x2(n)
   real(wp), intent(out) :: y2(n)

   real(wp), dimension(:), allocatable :: ypp
   real(wp) y_wert, y_wert_ypval, y_wert_yppval
   integer :: i

   allocate (ypp(n))
   call spline_cubic_set ( n, x, y, 0, 0.0d0, 0, 0.0d0, ypp )
   y2(1) = y(1)
   do i=2,n-1
      call spline_cubic_val ( n, x, y, ypp, x2(i), y_wert, y_wert_ypval, y_wert_yppval )
      y2(i) = y_wert
   end do
   y2(n) = y(n)
   deallocate (ypp)
   return
end subroutine

subroutine cqpath_damped_cube_spline(n,x,y,x2,y2)
   ! in    n  - dimension of array x,y
   !       x  - array x
   !       y  - array y
   ! out   x2 - symmetric points from x
   !       y2 - symmetric points from y
   implicit none
   integer, intent(in) :: n
   real(wp), intent(in) :: x(n),y(n),x2(n)
   real(wp), intent(out) :: y2(n)

   real(wp), dimension(:,:), allocatable :: abcd
   real(wp) y_wert
   integer :: i

   allocate (abcd(n,4))
   call cqpath_damped_cube_spline_set(n,x,y,abcd)

   y2(1) = y(1)
   do i=2,n-1
      call cqpath_damped_cube_spline_val(n,abcd,x,x2(i),y_wert)
      y2(i) = y_wert
   end do
   y2(n) = y(n)

   deallocate (abcd)
   return
end subroutine

subroutine cqpath_damped_cube_spline_set(n,x,y,abcd)
   ! in    n  - dimension von array x,y
   !       x  - array x
   !       y  - array y
   ! out   abcd - array of polynom coefficients
   !
   ! Based on Constrained Cubic Spline Interpolation for Chemical Engineering Application
   ! by CJC Kruger
   !
   ! Rewritten and optimized in fortran
   implicit none
   integer, intent(in) :: n
   real(wp), intent(in) :: x(n)
   real(wp), intent(in) :: y(n)
   real(wp), intent(out) :: abcd(n,4)

   real(wp) fs_x0,fs_x1,fss_x0,fss_x1
   real(wp) x0,x1,x2,y0,y1,y2
   real(wp) x1_x0,y1_y0,x0_2,x0_3,x1_x0_2,x1_2
   real(wp) steigung
   real(wp), dimension(:), allocatable :: dx,dy,f1

   integer :: i,j,nf

   nf = n-1
   allocate (dx(nf),dy(nf),f1(n))

   do i=1,nf
      dx(i) = x(i+1)-x(i)
      dy(i) = y(i+1)-y(i)
   end do

   do i=2,nf
      steigung = dy(i-1)*dy(i)
      if (steigung > 0.0) then
         f1(i) = 2.0/(dx(i)/dy(i)+dx(i-1)/dy(i-1))
      else if (steigung <= 0.0) then
         f1(i) = 0.0
      end if
   end do

   f1(1) = 3.0*dy(1)/(2.0*dx(1)) - f1(2)/2.0
   f1(n) = 3.0*dy(n-1)/(2.0*dx(n-1)) - f1(n-1)/2.0

   do i=2,n
      x1_x0 = dx(i-1)
      y1_y0 = dy(i-1)
      x0_2 = x(i-1)*x(i-1)
      x0_3 = x0_2*x(i-1)
      x1_x0_2 = x1_x0*x1_x0
      x1_2 = x(i)*x(i)

      fss_x0 = -2.0*(f1(i) + 2.0*f1(i-1))/(x1_x0)+6.0*(y1_y0)/x1_x0_2
      fss_x1 = 2.0*(2.0*f1(i) + f1(i-1))/(x1_x0)-6.0*(y1_y0)/x1_x0_2

      abcd(i,4) = (fss_x1 - fss_x0)/(6.0*(x1_x0))
      abcd(i,3) = (x(i)*fss_x0-x(i-1)*fss_x1)/(2.0*x1_x0)
      abcd(i,2) = ((y1_y0)-abcd(i,3)*(x1_2-x0_2)-abcd(i,4)*(x1_2*x(i)-x0_3))/(x1_x0)
      abcd(i,1) = y(i-1) - abcd(i,2)*x(i-1) - abcd(i,3) * x0_2 - abcd(i,4) * x0_3
   end do

   deallocate(dx,dy,f1)
end subroutine

subroutine cqpath_damped_cube_spline_val(n,abcd,x,x1,y1)
   ! in    n    - dimension von array x,y
   !       abcd - array of polynom coefficients
   !       x    - x
   ! out   y    - f(x,abcd)
   !
   ! Based on Constrained Cubic Spline Interpolation for Chemical Engineering Application
   ! by CJC Kruger
   !
   ! Rewritten and optimized in fortran
   integer, intent(in) :: n
   real(wp), intent(in) :: abcd(n,4)
   real(wp), intent(in) :: x(n)
   real(wp), intent(in) :: x1
   real(wp), intent(out) :: y1

   integer :: j
   real(wp) :: xx

   do j=2,n
      if (x1 < x(j)) then
         if (x1 >= x(j-1)) then
            xx = x1*x1
            y1 = abcd(j,1)+abcd(j,2)*x1+abcd(j,3)*xx+abcd(j,4)*xx*x1
         end if
      end if
   end do
   return
end subroutine

!! ========================================================================
!  remove bad points, not used
!! ========================================================================

subroutine cleanpath(np,n,xyz,xyz0,xyz1,pthr)
   use xtb_type_environment
   implicit none
   integer   n,np
   real(wp)  xyz(3,n,np)       ! path coords
   real(wp)  xyz0(3,n)         ! path coords
   real(wp)  xyz1(3,n)         ! path coords
   real(wp)  pthr              ! threshold

   real(wp), allocatable :: pvec1(:), pvec2(:), ovlp(:), delta(:,:), xyzdum(:,:,:)
   real(wp)              :: dum, ddot
   integer               :: i,j,k,l
   integer               :: ib, ie

   write(*,'(''input path length :'',i3)') np

   allocate(pvec1(3*n),pvec2(3*n),ovlp(np),delta(3,n),xyzdum(3,n,np))

   ovlp = 1
   do i=2,np-1
      call guess_tsmode(n,np,i,xyz,pvec1,pvec2)
      ovlp(i)=ddot(3*n,pvec1,1,pvec2,1)
   enddo
   write(*,*) 'path overlaps before alignment'
   write(*,'(20f6.2)') ovlp(1:np)
   call alignpath(n,np,xyz)
   do i=2,np-1
      call guess_tsmode(n,np,i,xyz,pvec1,pvec2)
      ovlp(i)=ddot(3*n,pvec1,1,pvec2,1)
   enddo
   write(*,*) 'path overlaps after alignment'
   write(*,'(20f6.2)') ovlp(1:np)

   ! get bad points and replace them by linear interpolation
   do i=2,np-1
      if(ovlp(i).lt.pthr)then
         write(*,*) 'bad point ',i
         do k=i-1,1,-1
            ib=k
            if(ovlp(k).gt.pthr) then
               ib = k
               exit
            endif
         enddo
         do k=i+1,np
            ie=k
            if(ovlp(k).gt.pthr) then
               ie = k
               exit
            endif
         enddo
         !         write(*,*) i,ib,ie,ovlp(i)
         ! structures ib+1...i-1 are unreliable
         delta (:,:) = (xyz(:,:,ie) - xyz(:,:,ib))/float(ib-ie)
         l = 0
         do k=ib+1,ie-1
            l = l + 1
            xyzdum(:,:,k) = xyz(:,:,ib) - delta(:,:)*float(l)
         enddo
      endif
   enddo

   do i=2,np-1
      if(ovlp(i).lt.pthr) xyz(:,:,i) = xyzdum(:,:,i)
   enddo

   call alignpath(n,np,xyz)
   do i=2,np-1
      call guess_tsmode(n,np,i,xyz,pvec1,pvec2)
      ovlp(i)=ddot(3*n,pvec1,1,pvec2,1)
   enddo
   write(*,*) 'path overlaps after cleaning and alignment'
   write(*,'(20f6.2)') ovlp(1:np)

end subroutine

end module xtb_biaspath

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_thermo
   use xtb_mctc_accuracy, only : wp
   implicit none

contains

subroutine getsymmetry (pr, iunit, n, iat, xyz, symthr, maxatdesy, sfsym)
   use iso_c_binding, only: c_char, c_null_char
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: iunit
   integer n, iat(n), maxatdesy
   real(wp)  xyz(3,n)
   real(wp) symthr
   Character(len=*) sfsym
   logical pr
   Character(len=4) atmp
   integer,allocatable :: ictdum(:,:)

   Real(wp) :: paramar (11)  !parameter array for get_schoenflies_

   if(n.gt.maxatdesy) then
      if(pr)write(iunit,*) 'symmetry recognition skipped because # atoms >',maxatdesy
      return
   endif

   if (pr) write(iunit,'(a)')
   !parameters for symmetry recognition:
   paramar (1) = - 1         ! verbose, increase for more detailed output (to stdout)
   paramar (2) = 10          ! MaxAxisOrder
   paramar (3) = 100         ! MaxOptCycles
   paramar (4) = 0.001d0     ! ToleranceSame
   paramar (5) = 0.5d0       ! TolerancePrimary
   paramar (6) = symthr      ! ToleranceFinal, THIS IS THE IMPORTANT VALUE
   paramar (7) = 0.5d0       ! MaxOptStep
   paramar (8) = 1.0D-7      ! MinOptStep
   paramar (9) = 1.0D-7      ! GradientStep
   paramar (10) = 1.0D-8     ! OptChangeThreshold
   paramar (11) = 5          ! OptChangeHits

   atmp='    '
   Call get_schoenflies (n, iat, xyz, atmp, paramar)
   !call flush(iunit)

   !TM stuff (trafo table)
   sfsym(1:3)=atmp(1:3)
   if(sfsym(1:1).eq.'D') sfsym(1:1)='d'
   if(sfsym(1:1).eq.'C') sfsym(1:1)='c'
   if(sfsym(1:1).eq.'T') sfsym(1:1)='t'
   if(sfsym(1:1).eq.'O') sfsym(1:1)='o'
   if(sfsym(1:1).eq.'I') sfsym(1:1)='i'
   if(sfsym.eq.'dih') sfsym='d6h'
   if(sfsym.eq.'civ') sfsym='c6v'
   if(sfsym(3:3).gt.'v'.or.sfsym(3:3).lt.'a') sfsym(3:3)=' '

   if(pr) then
      write(iunit,'(a3,'' symmetry found (for desy threshold: '',e9.2,'') used in thermo'')')sfsym, symthr
   endif

End subroutine getsymmetry

subroutine thermodyn(iunit,A_rcm,B_rcm,C_rcm,avmom_si,linear,atom,sym,molmass, &
      &              vibs,nvibs,escf,T,sthr_rcm,et,ht,g,ts,zp,pr)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_convert
   implicit none
   integer, intent(in)  :: iunit       !< output_unit
   integer, intent(in)  :: nvibs       !< number of vibrational frequencies
   real(wp),intent(in)  :: escf        !< total energy from electronic structure
   real(wp),intent(in)  :: A_rcm       !< rotational constants in cm-1
   real(wp),intent(in)  :: B_rcm       !< rotational constants in cm-1
   real(wp),intent(in)  :: C_rcm       !< rotational constants in cm-1
   real(wp),intent(in)  :: avmom_si    !< average moment of inertia in whatever
   real(wp),intent(in)  :: sym         !< symmetry number
   real(wp),intent(in)  :: molmass     !< molecular mass in in amu
   real(wp),intent(in)  :: T           !< temperature in K
   real(wp),intent(in)  :: sthr_rcm    !< rotor cutoff in cm-1
   real(wp),intent(out) :: et          !< enthalpy in Eh
   real(wp),intent(out) :: ht          !< enthalpy in Eh
   real(wp),intent(out) :: g           !< free energy in Eh
   real(wp),intent(out) :: ts          !< entropy in Eh
   real(wp),intent(in)  :: zp          !< zero point vibrational energy in Eh
   real(wp),intent(in)  :: vibs(nvibs) !< vibrational frequencies in cm-1
   logical, intent(in)  :: linear      !< is linear
   logical, intent(in)  :: atom        !< only one atom
   logical, intent(in)  :: pr          !< clutter the screen with printout
   real(wp),parameter :: R = 1.98726D0    ! GAS CONSTANT IN CALORIES/MOLE
   real(wp),parameter :: H = 6.626176D-27 ! PLANCK'S CONSTANT IN ERG-SECONDS
   real(wp),parameter :: AK = 1.3807D-16  ! BOLTZMANN CONSTANT IN ERG/DEGREE
   real(wp),parameter :: conv3 = amutokg*1000 ! 1.6606d-24
   real(wp),parameter :: magic4 = 2.2868d0 ! unknown
   real(wp),parameter :: magic5 = 2.3135d0 ! unknown
   real(wp),parameter :: caltoj = autokj/autokcal

   integer  :: i
   real(wp) :: s_tr,s_rot,s_vib,s_int,s_tot
   real(wp) :: h_tr,h_rot,h_vib,h_int,h_tot
   real(wp) :: q_tr,q_rot,q_vib,q_int,q_tot
   real(wp) :: cptr,cprot,cpvib,cpint,cptot
   real(wp) :: beta,sthr,avmom,A,B,C
   real(wp) :: ewj,omega,e,xxmom,xmom,mu
   real(wp) :: wofrot,RT
   real(wp) :: cp_ho,cp_rr
   real(wp) :: sv_ho,sv_rr
   !*******************************************************************

   ! convert EVERYTHING to atomic units NOW and avoid horror and dispair later
   beta=1.0_wp/kB/T ! beta in 1/Eh
   !c1=h*ac/ak/T    ! beta in cm
   sthr  = sthr_rcm * rcmtoau ! sthr in Eh
   avmom = avmom_si*kgtome*aatoau**2*1.0e+20_wp ! in me·α² (au)
   A = A_rcm * rcmtoau
   B = B_rcm * rcmtoau
   C = C_rcm * rcmtoau

   !   ***   INITIALISE SOME VARIABLES   ***
   q_vib = 1.0_wp
   h_vib = 0.0_wp
   cpvib = 0.0_wp
   s_vib = 0.0_wp
   q_rot = 1.0_wp
   h_rot = 0.0_wp
   cprot = 0.0_wp
   s_rot = 0.0_wp
   ! free rotor heat capacity is constant 0.5*R
   ! we use the below to work with Eh² units 
   ! conversion to cal/mol/K is done later
   cp_rr = 0.5_wp/(beta**2) 

   ! construct the frequency dependent parts of partition function
   do i=1,nvibs
      omega=vibs(i)
      ! omega in Eh, beta in 1/Eh
      ewj=exp(-omega*beta)
      q_vib=q_vib/(1.0_wp-ewj)
      ! h_vib in Eh
      h_vib=h_vib+omega*ewj/(1.0_wp-ewj)
      ! cp_ho in Eh²
      cp_ho=omega**2 * ewj/(1.0_wp-ewj)/(1.0_wp-ewj)
      ! replace low-lying vibs for S by rotor approx.
      mu = 0.5_wp / (omega + 1.0e-14_wp)
      ! this reduced moment limits the rotational moment of inertia for
      ! this vibration to that of the total molecule rotation/3
      ! avmom and xmom are in me·α² (au)
      mu = mu*avmom/(mu+avmom)
      if(omega.gt.0)then
         ! sv is S/R which is dimensionless
         ! harm. osc. entropy
         sv_ho = vibs(i)*beta*ewj/(1.0_wp-ewj) - log(1.0_wp-ewj)
         ! free rotor entropy
         ! Cramer, page 328 for one degree of freedom or
         ! http://cccbdb.nist.gov/thermo.asp, eq. 35, sigma=1
         !sv_rr = (0.5_wp+log(sqrt(8.0_wp*pi**3*xmom*sik*t)/sih))
         sv_rr = 0.5_wp + log(sqrt(pi/beta*2.0_wp*mu))
      else
         sv_ho = 0.0_wp
         sv_rr = 0.0_wp
      endif
      ! fermi weigthing
      ! wofrot=1./(1.+exp( (omega-sthr)/20.0 ) )
      ! Head-Gordon weighting
      wofrot=1.0_wp-chg_switching(omega,sthr)
      ! heat capacity (cp_rr is a constant), all in Eh²
      cpvib = cpvib + ((1.0_wp-wofrot)*cp_ho + wofrot*cp_rr)
      ! entropy s_vib is converted to cal/mol/K... by multiplying with R
      s_vib=s_vib+R*((1.0_wp-wofrot)*sv_ho + wofrot*sv_rr)
   enddo
   !   ***   FINISH CALCULATION OF VIBRATIONAL PARTS   ***
   ! now unit conversion again...
   ! h_vib in Eh, beta is in 1/Eh, T is in K, R is in cal/mol/K,
   h_vib=h_vib*R*beta*T
   ! same here
   ! cpvib is in Eh², beta in 1/Eh, R in cal/mol/K
   cpvib=cpvib*R*beta**2
   !   ***   NOW CALCULATE THE ROTATIONAL PARTS  (FIRST LINEAR MOLECULES)
   if (.not.atom) then
      if(linear) then
         ! A is in Eh, beta is in 1/Eh, q_rot is dimensionless
         q_rot=1/(beta*A*sym)
         ! h_rot is in cal/mol
         h_rot=R*T
         ! cprot  is in cal/mol/K
         cprot=R
         ! s_rot is in cal/mol/K
         s_rot=R*((log(1.0_wp/(beta*A*sym)))+1.0_wp)
      else
         ! see above
         q_rot=sqrt(pi/(A*B*C*beta**3))/sym
         h_rot=3.0_wp*R*T/2.0_wp
         cprot=3.0_wp*R/2.0_wp
         s_rot=0.5_wp*R*(-2.0_wp*log(sym)+log(pi/(A*B*C*beta**3))+3.0_wp)
      endif
   endif
   !   ***   CALCULATE INTERNAL CONTRIBUTIONS   ***
   q_int=q_vib*q_rot
   h_int=h_vib+h_rot
   cpint=cpvib+cprot
   s_int=s_vib+s_rot
   !   ***   CONSTRUCT TRANSLATION CONTRIBUTIONS   ***
   q_tr=(sqrt(2.0_wp*pi*molmass*t*ak*conv3)/h)**3
   ! this is 3/2rt+pv=5/2rt
   h_tr=5.0_wp*R*T/2.0_wp
   cptr=5.0_wp*R/2.0_wp
   s_tr=magic4*(5.0_wp*log10(t)+3.0_wp*log10(molmass))-magic5
   !   ***   CONSTRUCT TOTALS   ***
   cptot=cptr+cpint
   s_tot=s_tr+s_int
   h_tot=h_tr+h_int

   if(pr)then
      write(iunit,'(a)')
      write(iunit,'("   temp. (K)  partition function ", &
         & "  enthalpy   heat capacity  entropy")')
      write(iunit,'(  "                                   ", &
         & "cal/mol     cal/K/mol   cal/K/mol   J/K/mol")')
      write(iunit,'(  f7.2,"  VIB ",G10.3,10X,3F11.3)') &
         & T,q_vib,  h_vib,  cpvib,  s_vib
      write(iunit,'(7X,"  ROT ",G10.3,10X,3F11.3)') &
         & q_rot,  h_rot,  cprot,  s_rot
      write(iunit,'(7X,"  INT ",G10.3,10X,3F11.3)') &
         & q_int,h_int,cpint,s_int
      write(iunit,'(7X,"  TR  ",G10.3,10X,3F11.3)') &
         & q_tr, h_tr, cptr, s_tr
      write(iunit,'(7X,"  TOT ",21X,F11.4,3F11.4)') &
         & h_tot,cptot,s_tot,s_tot*caltoj
   endif

   ht=h_tot/1000.0_wp*kcaltoau
   et=ht+zp
   ts=s_tot*t/1000.0_wp*kcaltoau

   g=et-ts

end subroutine thermodyn

subroutine oldthermo(a,b,c,avmom,linear,atom,sym,molmass,vibs,nvibs,escf, &
      & T,sthr,et,ht,g,ts,zp,pr)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_convert
   implicit none
   integer, intent(in)  :: nvibs       !< number of vibrational frequencies
   real(wp),intent(in)  :: escf        !< total energy from electronic structure
   real(wp),intent(in)  :: A,B,C       !< rotational constants in cm-1
   real(wp),intent(in)  :: avmom       !< average moment of inertia in whatever
   real(wp),intent(in)  :: sym         !< symmetry number
   real(wp),intent(in)  :: molmass     !< molecular mass in in amu
   real(wp),intent(in)  :: T           !< temperature in K
   real(wp),intent(in)  :: sthr        !< rotor cutoff in cm-1
   real(wp),intent(out) :: et          !< enthalpy in Eh
   real(wp),intent(out) :: ht          !< enthalpy in Eh
   real(wp),intent(out) :: g           !< free energy in Eh
   real(wp),intent(out) :: ts          !< entropy in Eh
   real(wp),intent(out) :: zp          !< zero point vibrational energy in Eh
   real(wp),intent(in)  :: VIBS(nvibs) !< vibrational frequencies in cm-1
   LOGICAL, intent(in)  :: LINEAR      !< is linear
   LOGICAL, intent(in)  :: ATOM        !< only one atom
   LOGICAL, intent(in)  :: pr          !< clutter the screen with printout
   !*******************************************************************
   !*  THE FOLLOWING CONSTANTS ARE NOW DEFINED:
   !*          PI  = CIRCUMFERENCE TO DIAMETER OF A CIRCLE
   !*          R   = GAS CONSTANT IN CALORIES/MOLE
   !*          H   = PLANCK'S CONSTANT IN ERG-SECONDS
   !*          AK  = BOLTZMANN CONSTANT IN ERG/DEGREE
   !*          AC  = SPEED OF LIGHT IN CM/SEC
   !*******************************************************************
   real(wp),parameter :: R = 1.98726D0
   real(wp),parameter :: H = 6.626176D-27
   real(wp),parameter :: AK = 1.3807D-16
   real(wp),parameter :: AC = 2.99792458D+10
   real(wp),parameter :: siK = 1.38066D-23
   real(wp),parameter :: siH = 6.626076D-34
   real(wp),parameter :: siNA = 6.022137D+23
   real(wp),parameter :: conv1 = rcmtoau*autokcal*0.5_wp ! 1.4295718d-3
   real(wp),parameter :: conv2 = rcmtoau*autokJ*1000 ! 0.01196266D+3
   real(wp),parameter :: conv3 = amutokg*1000 ! 1.6606d-24
   real(wp),parameter :: conv4 = 2.2868d0 ! unknown
   real(wp),parameter :: conv5 = 2.3135d0 ! unknown
   real(wp),parameter :: caltoj = autokj/autokcal
   real(wp),parameter :: hbar = H/twopi
   real(wp),parameter :: sihbar = siH/twopi

   integer  :: i
   real(wp) :: s_tr,s_rot,s_vib,s_int,s_tot
   real(wp) :: h_tr,h_rot,h_vib,h_int,h_tot
   real(wp) :: q_tr,q_rot,q_vib,q_int,q_tot
   real(wp) :: cptr,cprot,cpvib,cpint,cptot
   real(wp) :: beta,c1
   real(wp) :: ewj,omega,e,xxmom,xmom
   real(wp) :: sv1,sv2,sv3,wofrot
   !*******************************************************************

   !   ***   INITIALISE SOME VARIABLES   ***
   beta=1.0_wp/kB/T ! beta in 1/Eh
   c1=h*ac/ak/T     ! beta in cm
   q_vib = 1.0_wp
   h_vib = 0.0_wp
   cpvib = 0.0_wp
   s_vib = 0.0_wp
   q_rot = 0.0_wp
   h_rot = 0.0_wp
   cprot = 0.0_wp
   s_rot = 0.0_wp
   zp = 0.5_wp * sum(vibs(1:nvibs))
   !   ***   CONSTRUCT THE FREQUENCY DEPENDENT PARTS OF PARTITION FUNCTION
   do i=1,nvibs
      ! frequency is in cm-1
      omega=vibs(i)*autorcm
      ! omega in cm-1, c1 in cm
      ewj=exp(-omega*c1)
      q_vib=q_vib/(1.0_wp-ewj)
      ! h_vib in cm-1
      h_vib=h_vib+omega*ewj/(1.0_wp-ewj)
      ! cpvib in cm-2
      cpvib=cpvib+omega*omega*ewj/(1.0_wp-ewj)/(1.0_wp-ewj)
      ! replace low-lying vibs for S by rotor approx.
      ! E in J (omega in cm-1)
      e=(1.d-14+omega)*rcmtoau*autokj*1000.0_wp/siNA
      ! mom of intertia corresponding to the rotor with frequency omega
      ! xxmom is in kg·m²
      xxmom=siHbar**2.0d0/(2.0d0*e)
      ! write(*,*) xxmom,avmom,xxmom*avmom/(xxmom+avmom)
      ! this reduced moment limits the rotational moment of
      ! inertia for this vib to that of the total molecule
      ! rotation/3
      ! avmom and xmom are in kg·m²
      xmom=xxmom*avmom/(xxmom+avmom)
      !              free rotor entropy
      ! Cramer, page 328 for one degree of freedom or
      ! http://cccbdb.nist.gov/thermo.asp, eq. 35, sigma=1
      !              harm. osc. entropy
      if(omega.gt.0)then
         ! sv1 is S/R which is dimensionless
         sv1=log(1.0_wp-ewj)
         ! sv2 is in cm-1
         sv2=omega*ewj/(1.0_wp-ewj)
         ! sv3 is cal/mol/K
         sv3=r*(0.5_wp+log(sqrt(8.0_wp*pi**3*xmom*sik*t)/sih))
      else
         sv1=0
         sv2=0
         sv3=0
      endif
      ! fermi weigthing
      ! wofrot=1./(1.+exp( (omega-sthr)/20.0 ) )
      ! Head-Gordon weighting
      wofrot=1.0_wp-chg_switching(omega,sthr)
      if(sthr.lt.0) wofrot=0.0_wp
      ! now convert everything to cal/mol...
      ! sv1 [dimensionless] -> multiply with R    -> cal/mol/K
      ! sv2 [cm-1]          -> multiply with R*c1 -> cal/mol/K
      ! sv3 [cal/mol/K]     ->
      s_vib=s_vib+(1.0_wp-wofrot)*(sv2*r*c1-r*sv1)+wofrot*sv3
      if(omega.lt.300.0_wp .and. pr) &
         & write(*,'("omega=",f6.2,5x,"gvib=",f10.3, &
         &       5x,"grot=",f10.3,5x,"gused=",f10.3)') &
         &  omega,-(sv2*r*c1-r*sv1)*t/1000.0_wp,-sv3*t/1000.0_wp, &
         & -t*((1.0_wp-wofrot)*(sv2*r*c1-r*sv1)+wofrot*sv3)/1000.0_wp
   enddo
   !   ***   FINISH CALCULATION OF VIBRATIONAL PARTS   ***
   ! now unit conversion again...
   ! h*ac/ak is c1*T -> cm*K, R is in cal/mol/K, h_vib in cm-1
   h_vib=h_vib*r*h*ac/ak
   ! same here
   ! cpvib is in cm-2, c1 in cm, R in cal/mol/K
   cpvib=cpvib*r*c1*c1
   !   ***   NOW CALCULATE THE ROTATIONAL PARTS  (FIRST LINEAR MOLECULES
   if (.not.atom) then
      if(linear) then
         ! A is in cm-1, q_rot is dimensionless
         q_rot=1/(c1*a*sym)
         ! h_rot is in cal/mol
         h_rot=r*t
         ! cprot  is in cal/mol/K
         cprot=r
         ! s_rot is in cal/mol/K
         s_rot=r*(log(t*ak/(h*ac*a*sym)))+r
      else
         ! see above
         q_rot=sqrt(pi/(a*b*c*c1*c1*c1))/sym
         h_rot=3.0_wp*r*t/2.0_wp
         cprot=3.0_wp*r/2.0_wp
         s_rot=0.5_wp*r*(3.0_wp*log(1.0_wp/c1)-2.0_wp*log(sym)+log(pi/(a*b*c))+3.0_wp)
      endif
   endif
   !   ***   CALCULATE INTERNAL CONTRIBUTIONS   ***
   q_int=q_vib*q_rot
   h_int=h_vib+h_rot
   cpint=cpvib+cprot
   s_int=s_vib+s_rot
   !   ***   CONSTRUCT TRANSLATION CONTRIBUTIONS   ***
   q_tr=(sqrt(2.0_wp*pi*molmass*t*ak*conv3)/h)**3
   ! this is 3/2rt+pv=5/2rt
   h_tr=5.0_wp*r*t/2.0_wp
   cptr=5.0_wp*r/2.0_wp
   s_tr=conv4*(5.0_wp*log10(t)+3.0_wp*log10(molmass))-conv5
   !   ***   CONSTRUCT TOTALS   ***
   cptot=cptr+cpint
   s_tot=s_tr+s_int
   h_tot=h_tr+h_int

   if(pr)then
      write(*,*)
      write(*,'("   temp. (K)  partition function ", &
         & "  enthalpy   heat capacity  entropy")')
      write(*,'(  "                                   ", &
         & "cal/mol     cal/K/mol   cal/K/mol   J/K/mol")')
      write(*,'(  f7.2,"  VIB ",G10.3,10X,3F11.3)') &
         & T,q_vib,  h_vib,  cpvib,  s_vib
      write(*,'(7X,"  ROT ",G10.3,10X,3F11.3)') &
         & q_rot,  h_rot,  cprot,  s_rot
      write(*,'(7X,"  INT ",G10.3,10X,3F11.3)') &
         & q_int,h_int,cpint,s_int
      write(*,'(7X,"  TR  ",G10.3,10X,3F11.3)') &
         & q_tr, h_tr, cptr, s_tr
      write(*,'(7X,"  TOT ",21X,F11.4,3F11.4)') &
         & h_tot,cptot,s_tot,s_tot*caltoj
   endif

   ht=h_tot/1000.0_wp*kcaltoau
   et=ht+zp
   ts=s_tot*t/1000.0_wp*kcaltoau

   g=et-ts

end subroutine oldthermo

pure elemental function lnqrot(temp,f,avmom) result(lnq_r)
   use xtb_mctc_constants, only : pi
   use xtb_mctc_convert
   implicit none
   real(wp), parameter :: rcmtoj = rcmtoau*autokj*1000.0_wp
   real(wp), parameter :: avogadro = 6.0221413e23_wp ! 1/mol
   real(wp), parameter :: planck = 6.62606957e-34_wp ! J*s
   real(wp), parameter :: hbar = planck/(2.0_wp*pi)
   real(wp), parameter :: kb = 1.3806488e-23_wp ! J/K
   real(wp), intent(in) :: temp   !< temperature in K
   real(wp), intent(in) :: f      !< vibrational frequency in cm⁻¹
   real(wp), intent(in) :: avmom  !< average moment of inertia in kg·m²
   real(wp):: e
   real(wp):: mu
   real(wp):: lnq_r
   real(wp):: t_rot

   ! moment of inertia corresponding to the rotor with frequency f(ifreq)
   ! convert frequency first from cm⁻¹ to J, we add also a little offset to avoid Infinities
   e = ((f*rcmtoJ)+1.0e-14_wp)/avogadro
   mu = hbar**2/(2.0_wp*e)
   ! the vibrational moment of inertia is now in SI
   ! reduce the moment relative to the total rotational moment
   mu = avmom*mu/(avmom+mu)
   ! now we need a rotational temperature of mu,
   ! since we are SI already no unit conversion needed
   t_rot = hbar**2/(2.0_wp*mu*kb)
   ! ln(q) of the free rotor partition function, we assume σ=1
   lnq_r = log(sqrt(pi*temp/t_rot))

end function lnqrot

pure elemental function lnqvib(temp,f) result(lnq_v)
   implicit none
   real(wp), parameter  :: planck = 6.62606957e-34_wp ! J*s
   real(wp), parameter  :: kb = 1.3806488e-23_wp ! J/K
   real(wp), parameter  :: speed_of_light = 299792458.0_wp ! m/s
   real(wp), parameter  :: factor = planck*100.0_wp*speed_of_light/kb
   real(wp), intent(in) :: temp   !< temperature in K
   real(wp), intent(in) :: f      !< vibrational frequency in cm⁻¹
   real(wp):: lnq_v
   real(wp):: t_vib
   ! get the vibrational temperature (which is in K, BTW)
   t_vib = factor*f
   ! modified oscillator, for sthr = 0 -> HO.
   ! ln(q) of the harmonic oscillator partition function
   lnq_v = - 0.5_wp*t_vib/temp - log(1.0_wp - exp(-t_vib/temp))

end function lnqvib

pure elemental function lnqvibmod(temp,f,sthr,avmom) result(lnq)
   implicit none
   real(wp), intent(in) :: temp   !< temperature in K
   real(wp), intent(in) :: f      !< vibrational frequency in cm⁻¹
   real(wp), intent(in) :: sthr   !< rotor cutoff in cm⁻¹
   real(wp), intent(in) :: avmom  !< average moment of inertia in kg·m²
   real(wp):: fswitch
   real(wp):: lnq_r,lnq_v,lnq
   ! ln(q) of the harmonic oscillator partition function
   lnq_v = lnqvib(temp,f)
   ! ln(q) of the free rotor partition function, we assume σ=1
   lnq_r =  lnqrot(temp,f,avmom)

   ! Chai--Head-Gordon weighting
   fswitch = 1.0_wp - chg_switching(sthr,f)

   ! now final modified vibrational partiation function
   lnq = (1.0_wp-fswitch) * lnq_v + fswitch * lnq_r

end function lnqvibmod

pure elemental function chg_switching(omega,sthr) result(f)
   real(wp),intent(in) :: omega
   real(wp),intent(in) :: sthr
   real(wp) :: f
   if(sthr.ge.0.0_wp) then
      f = 1.0_wp/(1.0_wp+(sthr/omega)**4)
   else
      f = 1.0_wp
   endif
end function chg_switching

pure elemental function chg_inverted(f,sthr) result(omega)
   real(wp),intent(in) :: f
   real(wp),intent(in) :: sthr
   real(wp) :: omega
   omega = sthr/(1.0_wp/f - 1.0_wp)**0.25_wp

end function chg_inverted

end module xtb_thermo

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Numerical storage size parameters
module xtb_mctc_accuracy
   implicit none
   public


   !> Single precision real numbers
   integer, parameter :: sp = selected_real_kind(6)

   !> Double precision real numbers
   integer, parameter :: dp = selected_real_kind(15)

   !> Wanted precision
   integer, parameter :: wp = dp

   !> Char length for integers
   integer, parameter :: i1 = selected_int_kind(2)

   !> Short length for integers
   integer, parameter :: i2 = selected_int_kind(4)

   !> Length of default integers
   integer, parameter :: i4 = selected_int_kind(9)

   !> Long length for integers
   integer, parameter :: i8 = selected_int_kind(18)


end module xtb_mctc_accuracy

! This file is part of xtb.
!
! Copyright (C) 2022 Julia Kohn, Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> IR / Raman intensities from DFTB+ Hessians
module xtb_prog_ir
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autorcm, autoamu
   use xtb_mctc_filetypes, only : getFileType, hessType
   use xtb_mctc_timings
   use xtb_mctc_version, only : version, author, date
   use xtb_io_reader, only : readMolecule, readHessian
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   use xtb_type_reader, only : TReader
   use xtb_prog_argparser, only : TArgParser
   use xtb_freq_project, only : projectHessian
   use xtb_freq_utils, only : massWeightHessian, diagHessian
   use xtb_propertyoutput, only : print_thermo
   use xtb_splitparam, only : atmass
   use xtb_setmod, only : set_thermo, set_symmetry
   implicit none
   private

   public :: xtbIR


contains


!> Main program of the IR submodule
subroutine xtbIR(env, argParser)

    use xtb_freq_io, only: write_tm_vibspectrum, wrhess, writeHessianOut, g98fake2

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "prog_ir"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Commandline argument parser
   type(TArgParser), intent(inout) :: argParser

   !> Molecular structure data
   type(TMolecule) :: mol

   type(TReader) :: reader
   character(len=:), allocatable :: file,born
   real(wp), allocatable :: freq(:), hessian(:, :), dipd(:, :), dipt(:),atmasslong(:),rmass(:)
   real(wp) :: htot, gtot, zp, sum2, trdip(3), autokmmol=1.7770969e+6_wp,xsum
   integer :: nFiles, ftype, hFormat, nimag, i,j,k, ifile, ia, ic,ios
   logical :: massWeighted

   !> dipd are 1. mixed 2nd derivative of energy wrt atomic positions and electric field
   !           2. 1st derivative of dipole moments wrt to atomic positions
   !           3. 1st derivative of forces wrt electric field
   ! 1. == 2.== 3. == Born charges

   call parseArguments(env, argParser, hFormat, massWeighted, born)

   nFiles = argParser%countFiles()
   if (nFiles == 0) then
      call env%error("No input file given, so there is nothing to do", source)
      call IRHelp(env%unit)
   end if
   if (nFiles > 2) then
      call env%error("Multiple input files present, aborting", source)
   end if

   call env%checkpoint("Command line argument parsing failed")

   call argParser%nextFile(file)

   !> Determine the file type for processing in the reader
   ftype = getFileType(file)

   !> Generate the reader by connecting the file to the instance
   call reader%open(file)
   !> Process the file to obtain the molecular structure data
   call readMolecule(env, mol, reader%unit, ftype)
   !> Close the file, we are done with it here
   call reader%close

   call env%checkpoint("Could not read geometry from '"//file//"'")

   !> Print an informative banner
   call IRHeader(env%unit)
   !> print current time
   call prdate('S')

   !> Also store a copy of the atomic masses in amu in global storage
   atmass = mol%atmass * autoamu

   !>read in dipole derivatives from dftb+ custom file (born.out)
   allocate(dipd(3,3*mol%n))

   call reader%open(born)
   do i=1,3*mol%n
      read(reader%unit,*,iostat=ios) dipd(1:3,i)  
      if (ios < 0 ) then
          !>abort run if born charges can't be read
          write(env%unit,*) "'"//born//"' file corrupted ... aborting" 
          stop 
      end if
   end do
   call reader%close

   write(env%unit,*) "  "
   write(env%unit,*) "Dipole derivatives (DFTB+) read in from file '"//born//"' "
   write(env%unit,*) "  "

   !>read in hessian from dftb+ custom file (hessian.out)
   call argParser%nextFile(file)
   allocate(freq(3*mol%n),rmass(3*mol%n))

   if (allocated(file)) then
      allocate(hessian(3*mol%n, 3*mol%n))
      call reader%open(file)
      call readHessian(env, mol, hessian, reader, format=hFormat)
      call reader%close
      
      write(env%unit,*) "Hessian (DFTB+) read in from file '"//file//"' "
      write(env%unit,*) "  "

      if (.not.massWeighted) then
         call massWeightHessian(hessian, mol%atmass)
      end if
      if (hFormat == hessType%dftbplus) then
         call projectHessian(hessian, mol, .true., .true.)
      end if

      call diagHessian(env, hessian, freq)

      call preigf(env%unit, freq, autorcm)

      call env%checkpoint("Could not read hessian from '"//file//"'")
   else
      freq(:) = -1.0_wp
   end if
   freq(:) = freq * autorcm

   !>expansion from atmass(n) to atmasslong(3*n)
   allocate(atmasslong(3*mol%n))
   do j=1,mol%n
      do k=1,3
         atmasslong((j-1)*3+k)=mol%atmass(j)
      end do
   end do

   !>IR intensities copied from src/hessian.F90
   allocate(dipt(3*mol%n))
    do i = 1, 3*mol%n
      do k = 1, 3
         sum2 = 0.0_wp
         do j = 1, 3*mol%n
            sum2 = sum2 + dipd(k,j)*(hessian(j,i)/sqrt(atmasslong(j)))              
         end do
         trdip(k) = sum2
      end do
      dipt(i) = autokmmol*(trdip(1)**2+trdip(2)**2+trdip(3)**2)
   end do

   !>write IR vib_spectrum
   call open_file(ifile,'vib_spectrum','w')
   call write_tm_vibspectrum(ifile,3*mol%n,freq,dipt)
   call close_file(ifile)

   k=0
   do i=1,3*mol%n
      xsum=0
      k=k+1
      do ia=1,mol%n
         do ic=1,3
            j = (ia-1)*3+ic
            xsum=xsum+hessian(j,i)**2/atmasslong(ia)
         enddo
      enddo
      rmass(i)=xsum
   enddo

   !>write fake molden input for mode visualization
   call g98fake2('g98.out',mol%n,mol%at,mol%xyz,freq,rmass,dipt,hessian)

   call print_thermo(env%unit,mol%n, size(freq), mol%at, mol%xyz, freq, 0.0_wp, &
      & htot, gtot, nimag, .true., zp)

   write(env%unit,*) "  "
   write(env%unit,*) "IR spectrum can be found in file vib_spectrum "
   write(env%unit,*) "  "
   write(env%unit,*) "molden input for visualization of spectrum and vibrations can be found in g98.out"

   write(env%unit,'(a)')
   write(env%unit,'(72("-"))')
   call stop_timing_run
   call stop_timing(1)
   call prdate('E')
   write(env%unit,'(72("-"))')
   call prtiming(1,'total')

   write(env%unit,'(a)')
   call terminate(0)

end subroutine xtbIR


subroutine preigf(unit, freq, scale)
   real(wp), intent(in) :: freq(:)
   real(wp), intent(in) :: scale
   integer, intent(in) :: unit
   integer, parameter :: nRows = 6
   integer :: ntimes, nrest, i, j, n2, k
   ntimes = size(freq)/nRows
   nrest = mod(size(freq), nRows)
   if (ntimes.eq.0) nrest = size(freq)
   j = 1
   n2 = nRows
   do k = 1, ntimes
      write(unit,'("eigval :",3x,10f9.2)') (freq(i)*scale,i=j,n2)
      j = j + nRows
      n2 = n2 + nRows
   end do
   if (nrest.gt.0.or.ntimes.eq.0) then
      write(unit,'("eigval :",3x,10f9.2)') (freq(i)*scale,i=j,j+nrest-1)
   end if

end subroutine preigf


!> Parse command line arguments
subroutine parseArguments(env, args, htype, massWeighted, born)

   !> Name of error producer
   character(len=*), parameter :: source = "prog_ir_parseArguments"

   !> Calculation environment
   type(TEnvironment) :: env

   !> Command line argument parser
   type(TArgParser) :: args

   !> File type of the hessian
   integer, intent(out) :: htype

   !> Hessian is already mass weighted
   logical, intent(out) :: massWeighted

   integer :: nFlags
   character(len=:), allocatable :: flag, sec
   character(len=:), allocatable, intent(out) :: born

   htype = hessType%tmol
   massWeighted = .false.

   nFlags = args%countFlags()
   call args%nextFlag(flag)
   do while(allocated(flag))
      if (len(flag) > 2 .and. flag(1:1) == '-' .and. flag(1:2) /= '--') then
         call env%warning("the use of '"//flag//"' is discouraged, "// &
            & "please use '-"//flag//"' next time", source)
         flag = '-'//flag
      end if
      select case(flag)
      case default
         call env%warning("Unknown option '"//flag//"' provided", source)

      case('--help', '-h')
         call IRHelp(env%unit)
         call terminate(0)

      case('--dftb+','--dftbplus') !> '+' is not accepted by every command-line parser
         htype = hessType%dftbplus

      case('--born')   
         call args%nextArg(sec)
         if (allocated(sec)) then
            born=sec
         else
            call env%error("dipole derivatives are missing", source)
         end if

      case('--scale')
         call args%nextArg(sec)
         if (allocated(sec)) then
            call set_thermo(env, 'scale', sec)
         else
            call env%error("Freq. scaling factor missing", source)
         end if

      case('--sthr')
         call args%nextArg(sec)
         if (allocated(sec)) then
            call set_thermo(env, 'sthr', sec)
         else
            call env%error("Rotor cutoff is missing", source)
         end if
     
      case('--ithr')
         call args%nextArg(sec)
         if (allocated(sec)) then
            call set_thermo(env, 'imagthr','-'//sec)
         else
            call env%error("Imaginary cutoff is missing", source)
         end if
      
      case('--desy')
         call args%nextArg(sec)
         if (allocated(sec)) then
            call set_symmetry(env,'desy',sec)
         else
            call env%error("Threshold for symmetry recognition missing", source)
         end if

      case('--temp')
         call args%nextArg(sec)
         if (allocated(sec)) then
            call set_thermo(env, 'temp', sec)
         else
            call env%error("Temperature in K is missing", source)
         end if

      end select
      call args%nextFlag(flag)
   end do

end subroutine parseArguments


!> Header for this submodule
subroutine IRHeader(unit)

   !> IO unit
   integer, intent(in) :: unit

   write(unit,'(a)') &
      "      -----------------------------------------------------------",&
      "     |                   =====================                   |",&
      "     |                            I R                            |",&
      "     |                   =====================                   |",&
      "     |                    S. Ehlert , J. Kohn                    |",&
      "     |          Mulliken Center for Theoretical Chemistry        |",&
      "     |                    University of Bonn                     |",&
      "      -----------------------------------------------------------",""
   write(unit,'(3x,"*",*(1x,a))') &
      & "xtb-IR version", version, "compiled by", author, "on", date
   write(unit,'(a)')

end subroutine IRHeader


subroutine IRHelp(unit)

   !> IO unit
   integer, intent(in) :: unit

   write(unit, '(a)') &
   "Usage: xtb ir [options] <geometry> --dftbplus <hessian> --born <born>", &
   "",&
   "<geometry> may be provided as any valid input to xtb", &
   "the [hessian] file is read and processed depending on the selected options,", &
   "the default format is a non-massweighted Turbomole hessian file", &
   "",&
   "Options",&
   "",&
   "   --sthr REAL         Rotor cutoff for RRHO partition function in rcm",&
   "",&
   "   --ithr REAL         Imag. freq. cutoff for RRHO in rcm",&
   "                       enter a positive value, the sign will be inverted",&
   "",&
   "   --scale REAL        Frequency scaling factor for RRHO",&
   "",&
   "   --desy REAL         Threshold for symmetry recognition",&
   "",&
   "   --temp REAL[,...]   Temperature for thermodynamic functions in K,",&
   "                       takes a comma separated list of temperatures",&
   "",&
   "   --dftb+             Read a DFTB+ hessian file, implies projection",&
   "   --dftbplus ",&
   "",&
   "   --born              Read a DFTB+ dipole derivatives / born charges file",&
   "",&
   "Output Conventions:",&
   "",&
   "total energies are given in atomic units (Eh), frequencies in reciprocal cm",&
   "",&
   "More information can be obtained at https://xtb-docs.readthedocs.io/",&
   ""
end subroutine IRHelp


end module xtb_prog_ir

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! pseudodiagonalization
! STEWART. J.J.P., CSASZAR, P., PULAY, P., J. COMP. CHEM.,3, 227, (1982)
!
! n   : total # MOs
! nocc: # occ MOs
! fmo : fock matrix in MO basis
! eig : replaced eigenvalues
! fmo : on output the new (rotated) eigenvectors in MO basis
! vector: scratch
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine pseudodiag(n,nocc,fmo,eig)
    use xtb_mctc_blas, only : mctc_rot
!$  use omp_lib
    implicit none
    !Dummy Arguments
    integer, intent(in)  :: n
    integer, intent(in)  :: nocc
    real*8, intent(inout):: fmo   (n,n)
    real*8, intent(out)  :: eig(n)
    !Stack Variables
    integer:: i
    integer:: j
    integer:: m
    integer:: aux_occ,aux_virt, loop_count
    integer:: blocksize, batch, dest, nproc
    integer:: i_virt
    integer:: nvirt
    integer:: i_occ
    integer :: bound
    real*8:: a
    real*8:: b
    real*8:: c
    real*8:: d
    real*8:: e
    !real*8:: alpha
    !real*8:: beta
    !Heap Variables and pointer targets
    integer, allocatable, save :: indizes(:,:)
    real*4, allocatable :: vector(:,:)   ! R4 saves 30 % due to less cache misses for 1000 atoms
    !real*8, allocatable, target :: occ(:,:)
    !real*8, allocatable, target :: virt(:,:)
    real*4,allocatable :: alphaarr(:,:)
    real*4,allocatable :: betaarr(:,:)


    allocate(vector(n,n))
    vector = 0
    nvirt = n - nocc

    allocate (alphaarr(nocc,nvirt))
    allocate (betaarr(nocc,nvirt))
    alphaarr = 0.0d0
    betaarr  = 0.0d0

    do i=1,n
        vector(i,i)=1
    enddo
    do i=1,n
        eig(i) = fmo(i,i)
    enddo

    !$omp parallel SHARED(alphaarr, betaarr, fmo) PRIVATE(a,c,d,e, i_occ, i_virt)
    !$omp do
    do i_occ = 1, nocc
        a=fmo(i_occ, i_occ)
        !DIR$ IVDEP
        do i_virt = 1, nvirt
            c=fmo(i_occ,nocc + i_virt)
            d=a-fmo(nocc + i_virt,nocc + i_virt)
            !if(abs(c/d).lt.1.d-6) cycle
            e=sign(sqrt(4.d0*c*c+d*d),d)
            alphaarr(i_occ,i_virt) = sqrt(0.5d0*(1.d0+d/e))
            betaarr(i_occ,i_virt) = -sign(sqrt(1.d0-alphaarr(i_occ,i_virt)*alphaarr(i_occ,i_virt)),c)
        end do ! End Loop over  i_virt from 1 to nvirt
    end do ! End Loop over  i_occ from 1 to nocc
   !$OMP END DO
   !$OMP END PARALLEL


    !blocksize = 28
    nproc = 1
    !$ nproc = omp_get_max_threads()
    !blocksize = 30 * nproc !for cluster
    blocksize = 6 * nproc !for Desktop

    !Batched Loop
    do batch = 0, nvirt/blocksize-1
        do aux_occ = 1, nocc
            !$omp parallel SHARED(alphaarr, betaarr, vector, aux_occ, n, nocc), &
            !$OMP& PRIVATE(i_occ, i_virt, aux_virt)
            !$omp do

            !DIR$ IVDEP
            do aux_virt = 1, blocksize
                i_virt = batch*blocksize + aux_virt
                i_occ  = i_virt+aux_occ-1 - (((i_virt-1+aux_occ)/(nocc+1))*nocc)
                 !      rotation of pseudo-eigenvectors
                call mctc_rot(vector(:,i_occ), vector(:,nocc+i_virt), alphaarr(i_occ,i_virt), betaarr(i_occ,i_virt) )
            end do ! End Loop over  j from 1 to nocc
            !$OMP END DO
        !$OMP END PARALLEL
        end do ! End Loop over  i from 1 to nvirt
    end do ! End Loop over  batch from 1 to nvirt / blocksize + 1

    !Residual Loop
    do aux_occ = 1, nocc
        !$omp parallel SHARED(alphaarr, betaarr, vector, aux_occ, n, nocc), &
        !$OMP& PRIVATE(i_occ, i_virt)
        !$omp do

        !DIR$ IVDEP
        do aux_virt = 1, mod(nvirt,blocksize)
            i_virt = batch*blocksize + aux_virt
            i_occ  = i_virt+aux_occ-1 - (((i_virt-1+aux_occ)/(nocc+1))*nocc)
            !if ((alphaarr(i_occ,i_virt)==0.0) .and. (betaarr(i_occ,i_virt)==0.0)) cycle
            call mctc_rot(vector(:,i_occ), vector(:,nocc+i_virt), alphaarr(i_occ,i_virt), betaarr(i_occ,i_virt))
        end do ! End Loop over  j from 1 to nocc
        !$OMP END DO
    !$OMP END PARALLEL
    end do ! End Loop over  i from 1 to nvirt

    fmo = vector
    deallocate(vector, alphaarr, betaarr)
end

! This file is part of xtb.
!
! Copyright (C) 2022 Stefan Grimme, Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_docking_search_nci
   use xtb_mctc_accuracy, only: wp
   use xtb_type_environment, only: TEnvironment
   use xtb_docking_param
   use xtb_iff_iffenergy, only: iff_e, intermole_probe, alignmol
   use xtb_scanparam
   use xtb_mctc_symbols, only: toSymbol
   use xtb_type_molecule, only: TMolecule
   use xtb_type_restart, only: TRestart
   use xtb_setparam
   use xtb_gfnff_calculator, only: TGFFCalculator,newGFFCalculator
   use xtb_xtb_calculator, only: TxTBCalculator
   use xtb_type_calculator, only: TCalculator
   use xtb_main_setup, only: newCalculator
   use xtb_geoopt
   use xtb_main_defaults, only: initDefaults
   use xtb_solv_state, only: solutionState
   use xtb_dynamic, only: xyzsort2
   use xtb_gfnff_setup, only: gfnff_setup, gfnff_input
   use xtb_disp_dftd4, only: newD3Model
   use xtb_single, only: singlepoint
   use xtb_type_data, only: scc_results
   use xtb_readin, only: xfind
   use xtb_mctc_timings
   use xtb_gfnff_topology, only: TGFFTopology
   use xtb_type_topology, only: TTopology
   use xtb_gfnff_ini, only: gfnff_ini
   use xtb_topology, only: makeBondTopology
   use xtb_sphereparam, only : number_walls, cavity_egrad, maxwalls, wpot
   use xtb_gfnff_param, only: ini, gfnff_set_param, gfnff_param_alloc,&
   & gff_print, gfnff_param_dealloc
   use xtb_constrain_param, only: read_userdata
   use xtb_fixparam
   use xtb_disp_ncoord, only: ncoord_gfn, ncoord_erf
   use xtb_scc_core, only: iniqshell
   use xtb_eeq, only: goedecker_chrgeq
   use xtb_basis, only: newBasisset
   implicit none

   private
   public :: docking_search

contains

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! find best structure globally by genetic algorithm
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
   subroutine docking_search(env,molA,molB,n,n1,n2,at1,at2,neigh,xyz1,xyz2,q1,q2,c6ab,&
                       &        z1, z2, nl1, nl2, l1, l2, cl1, cl2, qdr1, qdr2,&
                       &        cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
                       &        den1, den2, gab1, gab2, molA_e, molB_e, cprob, emin, coord, comb)

      INTERFACE
         RECURSIVE SUBROUTINE Quicksort(Item, First, Last, Indices)
            REAL, DIMENSION(:), INTENT(INOUT) :: Item       ! array of values
            INTEGER, INTENT(IN)    :: First, Last
            INTEGER, DIMENSION(:), INTENT(INOUT) :: Indices
         END SUBROUTINE Quicksort
      END INTERFACE

      !> Source of errors in the main program unit
      character(len=*), parameter :: source = "docking_search"
      type(TEnvironment), intent(inout) :: env
      integer, intent(in) :: n, n1, n2
      integer, intent(in) :: nl1, nl2
      integer, intent(in) :: neigh(0:n, n)
      real(wp), intent(inout) ::molA_e, molB_e
      real(wp), intent(in) :: xyz1(3, n1)
      real(wp), intent(in) :: xyz2(3, n2)
      real(wp), intent(in) :: cl1(4, n1*10)
      real(wp), intent(in) :: cl2(4, n2*10)
      real(wp), intent(in) :: q1(n1)
      real(wp), intent(in) :: q2(n2)
      real(wp), intent(in) :: c6ab(n, n)
      real(wp), intent(in) :: alpab(n2, n1)
      real(wp), intent(in) :: cprob(n1)
      real(wp), intent(in) :: emin
      real(wp), intent(in) :: coord(6)
      real(wp), intent(in) :: qdr1(n1)
      real(wp), intent(in) :: qdr2(n2)
      real(wp), intent(in) :: z1(n1)
      real(wp), intent(in) :: cn1(n1)
      real(wp), intent(in) :: z2(n2)
      real(wp), intent(in) :: cn2(n2)
      real(wp), intent(in) :: alp1(n1)
      real(wp), intent(in) :: alp2(n2)
      real(wp), intent(in) :: qct1(n1, 2), qct2(n2, 2)
      real(wp), intent(in) :: den1(2,4,n1),den2(2,4,n2),gab1(n1,n1),gab2(n2,n2)
      integer, intent(in) :: at1(n1)
      integer, intent(in) :: at2(n2)
      integer, intent(in) :: l1(n1*10)
      integer, intent(in) :: l2(n2*10)
      type(TMolecule), intent(inout) :: molA, molB
      type(TMolecule), intent(inout) :: comb

      real(wp) :: E_int
      real(wp), allocatable :: found(:, :), found2(:, :)
      real(wp), allocatable :: xyzprobc(:, :)
      real(wp), allocatable :: xyzprob3(:, :), xyzprob4(:, :)
      real(wp), allocatable :: xyztmp(:, :), rprobc(:, :)
      real(wp), allocatable :: xyzprob0(:), xyzprob1(:), xyzprob2(:), rprob(:)
      integer, allocatable :: ind0(:), ind1(:), ind2(:), rind(:), attmp(:)
      integer :: counter
      real(wp) :: found_tmp(6), displ(6), c2(3, n2), f(6), bestsofar
      real(wp) :: r,e,dx,dy,dz,xx1,yy1,zz1,bord,bord_rg,stepr3(3),stepr4,eshift
      real(wp) :: dx_rg, dy_rg, dz_rg, xx1_rg, yy1_rg, zz1_rg
      real(wp) :: r1, r2, r3, a1, a2, a3, av, sig, epq, tmpx(15), t0, t1, w0, w1
      real(wp) :: dum3(3, 3), dum2(3), dum(3), pmass, rmin, mvec(3, 14)
      real(wp) :: rmsd(n_opt*(n_opt + 1)/2)
      real(wp) :: dx2, dy2, dz2
      real*4   :: r4
      integer :: i, j, k, nang, nr, ii, jj, ns, icycle, maxs, iseed(2)
      integer :: kk = 0
      integer :: m1, m2, m3, l, nn, ndim, ll, kkk, kkkk, mfrag, maxlow, nclust, ierr
      integer :: mm1, mm2, mm3, maxpock, icssym
      integer, allocatable :: atfrag(:), molvec(:), iatnum(:)
      real(wp), allocatable :: xyzfrag(:, :)
      logical :: tooclose
      integer :: maxstruc
      character(len=100) :: warning
      real(wp) :: xyz_tmp(3, molB%n)
      integer, external :: ncore
      !> GFN-FF Calculator
      class(TCalculator), allocatable :: calc
      type(TGFFCalculator) :: gff_calc
      type(TGFFTopology) :: topo_backup, topo_xTB
      type(TTopology) :: bonds 
      !> Parameterfile
      character(len=:), allocatable :: pfile
      character(len=:), allocatable :: fnv
      character(len=*), parameter :: p_fname_param_gfn0 = 'param_gfn0-xtb.txt'
      character(len=*), parameter :: p_fname_param_gfn1 = 'param_gfn1-xtb.txt'
      character(len=*), parameter :: p_fname_param_gfn2 = 'param_gfn2-xtb.txt'
      character(len=*), parameter :: p_fname_param_gfnff = '.param_gfnff-xtb'
      !> Restart
      type(TRestart) :: chk
      !> SCC results
      type(scc_results) :: results
      !> Opt variable
      real(wp) :: egap, et, etot, grad(3, n), sigma(3, 3)
!      integer :: maxiter, maxcycle_in,olev
      logical :: pr, initial_sp, fail
      logical :: restart = .false.
      !> Dummy
      integer, allocatable ::  tmp_unit
      integer :: itemp = 64, iopt = 96, iprob = 30, ifinal = 31
      integer :: itopo = 32, ipocket = 53, ichr = 33, iscreen = 34
      !> Pocket optimization
      real(wp), allocatable :: xyz_pocket(:, :, :)
      real(wp), allocatable :: pocket_e(:)
      !> Structure after Optimization
      real(wp), allocatable :: xyz_opt(:, :, :)
      !> Final energies
      real(wp), allocatable :: final_e(:)
      real(wp) :: tmp_e
      !> Minimumposition
      integer :: minpos

      !> Parameter
      real(wp), parameter :: pi2 = 2*3.14159265358979_wp
      real(wp), parameter :: pi = 3.14159265358979_wp
      real(wp), parameter :: au = 627.509541_wp
      real(wp), parameter ::autoang = 0.52917726_wp
      character*80 atmp
      data mvec/1., 0., 0., 0., 1., 0., 0., 0., 1.,&
                 &-1., 0., 0., 0, -1., 0., 0., 0., -1.,&
                 & 1., 1., 1., -1., -1., -1.,&
                 &-1., 1., 1., 1., -1., 1., 1., 1., -1.,&
                 & 1., -1., -1., -1., 1., -1., -1., -1., 1./

      call start_timing(4)

      write (env%unit, *)
      write (env%unit, *) '=============================================='
      write (env%unit, *) '|         Starting Energy Screening          |'
      write (env%unit, *) '=============================================='
      write (env%unit, *)
      if (.not. fulle) write (env%unit, *) ' Fast Mode selected (recommended)'
      if (.not. fulle) write (env%unit, *) ' If ATM term should be included, use -atm option.'
      if (.not. fulle) write (env%unit, *)

!     just output
      call axis(n1, at1, xyz1, dum, pmass, dum2, dum3)
      r1 = sqrt(dum2(1) + dum2(2) + dum2(3))
      call axis(n2, at2, xyz2, dum, pmass, dum2, dum3)
      r2 = sqrt(dum2(1) + dum2(2) + dum2(3))
      call rcma(n1, xyz1, at1, n2, xyz2, at2, r, rmin)
      write (env%unit, '('' Method for final opts.    :'',1x,a  )') optlvl
      write (env%unit, '('' # of genetic optimizations:'',1x,i0  )') maxgen
      write (env%unit, '('' # of parents              :'',1x,i0  )') maxparent
      write (env%unit, '('' # of final geo. opts.     :'',1x,i0  )') n_opt
      write (env%unit, '('' Rare gas grid step size   :'',F8.2)') stepr
      write (env%unit, '('' ang step size /deg        :'',F8.2)') stepa
      write (env%unit, '('' # angular grid points     :'',1x,i0  )') (360/int(stepa))**3
      write(*,*)
      if (pocket_grid) write (env%unit, '('' Performing pocket search'')')
      if (stack_grid) write (env%unit, '('' Performing stack search'')')
      if (angular_grid)  write (env%unit, '('' Performing angular search'')')
      write(*,*)

      !Calculator prep
      call combine_mol(comb, molA, molB) !molB is shifted far away from molA

      !Setting up z
      do i = 1, comb%n
         comb%z(i) = comb%at(i) - ncore(comb%at(i))
         ! lanthanides without f are treated as La
         if (comb%at(i) .gt. 57 .and. comb%at(i) .lt. 72) comb%z(i) = 3
      end do

      call open_file(itemp, 'opt_tmp', 'w')
      tmp_unit = env%unit
      env%unit = itemp
      if (optlvl == 'gfnff') fnv = xfind(p_fname_param_gfnff)
      if (optlvl == 'gfn2') fnv = xfind(p_fname_param_gfn2)
      if (optlvl == 'gfn0') fnv = xfind(p_fname_param_gfn0)
      if (optlvl == 'gfn1') fnv = xfind(p_fname_param_gfn1)
      call newCalculator(env, comb, calc, fnv, restart, acc)
      call initDefaults(env, calc, comb, gsolvstate_iff)
      write(*,*) 'initialization done'

      select type (calc)
      type is (TGFFCalculator)
         topo_backup = calc%topo !topo is from molA and molB that are far away
      end select
      pr = .false.
      initial_sp = .true.
      !>Silent GFN calculations (No charge file or anything is written)
      set%silent = .true.
      gff_print = .false.
      set%pr_finalstruct = .false.

      !> SP molA
      set%ichrg = nint(molA%chrg)
      select type (calc)
      type is (TGFFCalculator)
         !With p_modh_old the next step craches sometimes for really large systmes
         call restart_gff(env, molA, calc)
         call calc%singlepoint(env,molA,chk,1,.false.,etot,grad,sigma,egap,results)
         do i = 1, molA%n
            topo_backup%qa(i) = calc%topo%qa(i) !Done to ensure right charge assignment to molecules
         end do
         molA_e = etot
      type is (TxTBCalculator)
         molA_e = pre_e_A
      end select

      !> SP molB
      set%ichrg = nint(molB%chrg)
      select type (calc)
      type is (TGFFCalculator)
         call restart_gff(env, molB, calc)
         call calc%singlepoint(env,molB,chk,1,.false.,etot,grad,sigma,egap,results)
         do i = 1, molB%n
            topo_backup%qa(i + molA%n) = calc%topo%qa(i)!Charges from molB for right partial charges
         end do
         molB_e = etot

         !> Topo of both single molecules together
      type is (TxTBCalculator)
         molB_e = pre_e_B
      end select

      etot = 0.0_wp; grad = 0.0_wp; sigma = 0.0_wp; egap = 0.0_wp

      env%unit = tmp_unit
      call close_file(itemp)
      call remove_file(itemp)

      write (env%unit, '(''  Total '', a,'' energy molecule 1: '', F16.10)') optlvl, molA_e
      write (env%unit, '(''  Total '', a,'' energy molecule 2: '', F16.10)') optlvl, molB_e

      !> Setting charge back to combined ones
      set%ichrg = nint(comb%chrg)

      write (env%unit, *)
      write (env%unit, *) '-----------------------------'
      write (env%unit, *) ' Grid based energy screening '
      write (env%unit, *) '-----------------------------'
      write (env%unit, *)

      !>Getting borders
      xx1 = maxval(xyz1(1, 1:n1)) - minval(xyz1(1, 1:n1))
      yy1 = maxval(xyz1(2, 1:n1)) - minval(xyz1(1, 1:n1))
      zz1 = maxval(xyz1(3, 1:n1)) - minval(xyz1(1, 1:n1))
      dum(1) = xx1
      dum(2) = yy1
      dum(3) = zz1
      dx2 = maxval(xyz2(1, 1:n2)) - minval(xyz2(1, 1:n2)) !On every side, molB has to have space
      dy2 = maxval(xyz2(2, 1:n2)) - minval(xyz2(2, 1:n2))
      dz2 = maxval(xyz2(3, 1:n2)) - minval(xyz2(3, 1:n2))
      dum2(1) = dx2
      dum2(2) = dy2
      dum2(3) = dz2
      bord = maxval(abs(dum)) + maxval(dum2) + 2 !Max bond distance of 2 considered
      bord_rg = 30 !Additional border increase for RG scan

      !> Angular search grid
      dx = maxval(xyz1(1, 1:n1)) - minval(xyz1(1, 1:n1)) + bord
      dy = maxval(xyz1(2, 1:n1)) - minval(xyz1(2, 1:n1)) + bord
      dz = maxval(xyz1(3, 1:n1)) - minval(xyz1(3, 1:n1)) + bord
      xx1 = minval(xyz1(1, 1:n1)) - bord*0.5
      yy1 = minval(xyz1(2, 1:n1)) - bord*0.5
      zz1 = minval(xyz1(3, 1:n1)) - bord*0.5
      stepr3(1) = dx/3
      stepr3(2) = dy/3
      stepr3(3) = dz/3
      mm1 = 4
      mm2 = 4
      mm3 = 4 !Grid with 256 points

      !> RG Grid (larger to have more points for pocket search, cheap)
      dx_rg = dx + bord_rg
      dy_rg = dy + bord_rg
      dz_rg = dz + bord_rg
      xx1_rg = xx1 - bord_rg*0.5
      yy1_rg = yy1 - bord_rg*0.5
      zz1_rg = zz1 - bord_rg*0.5
     !> Increase Gridsize for RG-Scan additionally to have enough points for pocket search
      m1 = 1 + int((dx_rg)/stepr)
      m2 = 1 + int((dy_rg)/stepr)
      m3 = 1 + int((dz_rg)/stepr)

      icssym = 0
      if (cssym) then
         dx2 = dx - bord
         dy2 = dy - bord
         dz2 = dz - bord
         if (dx2 .lt. dy2 .and. dx2 .lt. dz2) then
            m1 = m1/2
            mm1 = mm1/2
            xx1 = xx1 + bord*0.5
            icssym = 1
         end if
         if (dy2 .lt. dx2 .and. dy2 .lt. dz2) then
            m2 = m2/2
            mm2 = mm2/2
            yy1 = yy1 + bord*0.5
            icssym = 2
         end if
         if (dz2 .lt. dx2 .and. dz2 .lt. dy2) then
            m3 = m3/2
            mm3 = mm3/2
            zz1 = zz1 + bord*0.5
            icssym = 3
         end if
         write (*, '(''  # Cs symmetry red. :'',i1  )') icssym
      end if

      nn = m1*m2*m3
      if (maxparent < 28) then
         maxparent = 28 !Otherwise the computation crashes as more structures than parents are present
         call env%warning('Too few maxparent, taking 28', source)
      end if
      maxpock = 10 ! max number of pockets
      ndim = maxparent**2 !size of gene pool
      nclust = 0

      allocate (found(7, ndim), found2(7, ndim))  ! main arrays for gen ensemble
      found = 0
      found2 = 0

      write (*, '(''  # probe RG points   :'',i0  )') nn
      allocate (xyzprob0(nn), xyzprob1(nn),&
              &xyzprob2(nn), xyzprobc(3, nn),&
              &ind0(nn), ind1(nn), ind2(nn))
      xyzprob0 = 0
      xyzprob1 = 0
      xyzprob2 = 0

!ccccccccccccc
! R grid for RG atom
!ccccccccccccc
      dx_rg = xx1_rg
      l = 0
      do i = 1, m1
         dum(1) = dx_rg
         dy_rg = yy1_rg
         do j = 1, m2
            dum(2) = dy_rg
            dz_rg = zz1_rg
            do k = 1, m3
               dum(3) = dz_rg
               l = l + 1
               xyzprobc(1:3, l) = dum(1:3)
               dz_rg = dz_rg + stepr
            end do
            dy_rg = dy_rg + stepr
         end do
         dx_rg = dx_rg + stepr
      end do

      if (debug) then
        call wr_grid('RG_grid.xyz', molA%n, nn, molA%at, 36, molA%xyz, xyzprobc)
      end if

!> Raregas atom check around MolA
!$omp parallel do default(none) &
!$omp shared(xyzprob0,xyzprob1,xyzprob2,n1,nl1,at1,q1,xyz1,cl1,l1,cn1,cprob,nn,xyzprobc) &
!$omp private(l,e,epq,dum)
      do l = 1, nn
         dum(1:3) = xyzprobc(1:3, l)
         call intermole_probe(n1, nl1, at1, q1, xyz1, cl1,&
                             &dum, l1, cn1, cprob,&
                             &e, epq)
         xyzprob0(l) = e
         xyzprob1(l) = e + epq
         xyzprob2(l) = e - epq
      end do
!$omp end parallel do

      do i = 1, nn
         ind0(i) = i
         ind1(i) = i
         ind2(i) = i
      end do
      call Qsort(xyzprob0, 1, nn, ind0) ! sort for E neutral
      call Qsort(xyzprob1, 1, nn, ind1) ! sort for probe + 0.1 charge
      call Qsort(xyzprob2, 1, nn, ind2) ! sort for probe - 0.1 charge

      if (debug) then
        call wr_grid('best_RG_position.xyz', molA%n, 1, molA%at, 36, molA%xyz, xyzprobc(1:3, ind0(1)))
      end if

      write (*, '(''  Best rare gas probe energy/kcal   :'',F8.2)') xyzprob0(1)*au
      write (*, '(''  +0.1 charged probe energy/kcal:'',F8.2)') xyzprob1(1)*au
      write (*, '(''  -0.1 charged probe energy/kcal:'',F8.2)') xyzprob2(1)*au

!cccccccccccccccccccccccccccccccccccccccccc
! clustering based on RG filled pockets
!cccccccccccccccccccccccccccccccccccccccccc
!---------------------------------------------------------- start pocket search
      if (pocket_grid) then
         write(*,*)
         write (*,*) '  Starting pocket search'
         write(*,*)

         if (nn/4 < mxcent_clust) mxcent_clust = nn/4 !Default mxcent_clust=500

         allocate(atfrag(mxcent_clust),molvec(mxcent_clust),iatnum(mxcent_clust),xyzfrag(3,mxcent_clust))

         do i = 1, mxcent_clust
            xyzfrag(1:3, i) = xyzprobc(1:3, ind0(i))
            atfrag(i) = probe_atom_type
         end do
         molvec = 0
         call mrec(mfrag, xyzfrag, mxcent_clust, atfrag, molvec) ! recursive mol splitting into non-bonded fragments
         ! mfrag is the number of fragments that the best 500 gridpoints xyzfrag were split into
         ! molvec tells to which nci fragment the respective gridpoint belongs to
         ! if all scanned gridpoints are close, only one fragment results and every value of molvec will be 1
         iatnum = 0
         do i = 1, mxcent_clust
            k = molvec(i)
            iatnum(k) = iatnum(k) + 1
         end do

         ! now generate fragment geom
         kk = 0
         do i = 1, mfrag
            k = iatnum(i)
            allocate (xyztmp(3, k), attmp(k))
            xyztmp = 0.0d0
            attmp = 0
            l = 0
            do j = 1, mxcent_clust
               if (molvec(j) .eq. i) then !gridpoint j belongs to fragment number i
                  l = l + 1
                  xyztmp(1:3, l) = xyzfrag(1:3, j)
                  attmp(l) = atfrag(j)
               end if
            end do
            if (debug) then
               call wr_grid('pocket_grid.xyz', molA%n, k, molA%at, 36, xyz1, xyztmp)
            end if

            ! xyztmp contains now each gridpoint belonging to fragment i
            ! same for attmp (anyway always probe_atom_type)
            ! determine size (=R) of gridpoint cluster belonging to fragment i
            call axis(k, attmp, xyztmp, dum, pmass, dum2, dum3)
            r = sqrt(dum2(1) + dum2(2) + dum2(3))

            !> check if moleculeB is small enough to fit in gridpoint cluster of fragmen i
            if (r/r2 .gt. 0.5 .and. k .gt. 10) then  
               displ = 0
               !> Align xyz2 into gridpoint cluster number i by placing it in the middle and
               !  performing random mutations on the xyz coords and the rotation angles
               !  Each position is scanned by dispersion energy and the lowest one is given back as displ
               call alignmol(k, n2, attmp, at2, xyztmp, xyz2, displ)
               kk = kk + 1
               found2(1:6, kk) = displ(1:6)
            end if
            deallocate (xyztmp, attmp)
         end do
         write (*, '(''# pocket optimizations  :'',2i5  )') kk
         allocate (xyz_pocket(3, comb%n, kk))
         allocate (pocket_e(kk))

         !> Prepare optimization
         set%opt_logfile = 'pocket_opt.xyz'
         call open_file(ipocket, 'pocket.xyz', 'w')
         call open_file(itemp, 'opt_tmp', 'w')
         tmp_unit = env%unit
         env%unit = itemp

         do i = 1, kk
            displ(1:6) = found2(1:6, i)
            found_tmp = found2(1:6, i)
            call move2(molB%n, molB%xyz, xyz_tmp, found_tmp) !return xyz_tmp that is with found_tmp transformed molB%xyz
            counter = 0
            do j = 1, molA%n
               comb%xyz(1:3, j) = molA%xyz(1:3, j) !comb overwritten with A, as it is changed upon geo_opt
            end do
            do j = molA%n + 1, molA%n + molB%n
               counter = counter + 1
               comb%xyz(1:3, j) = xyz_tmp(1:3, counter) !combined molA and shifted molB
            end do
            !> Select which kind of optimization is done
            select type (calc)
            type is (TGFFCalculator)
               call restart_gff(env, comb, calc)
               !Keeping Fragments and charges
               calc%topo%nbond = topo_backup%nbond
               calc%topo%nb = topo_backup%nb
               calc%topo%qfrag = topo_backup%qfrag
               calc%topo%qa = topo_backup%qa
               calc%topo%fraglist = topo_backup%fraglist
               calc%topo%nfrag = topo_backup%nfrag
            type is (TxTBCalculator)
               call restart_xTB(env, comb, chk, calc)
            end select
            call geometry_optimization&
            &     (env, comb, chk, calc, egap, set%etemp, set%maxscciter, set%optset%maxoptcycle,&
            &      etot, grad, sigma, set%optset%optlev, pr, initial_sp, fail)
            grad = 0.0_wp; sigma = 0.0_wp; egap = 0.0_wp
            do k = 1, 3
               do j = 1, comb%n
                  xyz_pocket(k, j, kk) = comb%xyz(k, j)
               end do
            end do
            pocket_e(i) = etot
            write (*, '(''pocket '',i3,'' E /au :'',f9.2)') i, etot
            write (ipocket, '(i0)') comb%n
            write (ipocket, '(f20.14)') etot
            do j = 1, comb%n
               write (ipocket, '(a4,2x,3f20.14)') comb%sym(j), comb%xyz(:, j)*autoang
            end do
         end do

         call close_file(ipocket)
         call remove_file(itemp)
         call delete_file(set%opt_logfile)
         env%unit = tmp_unit
         if (.not. stack_grid .AND. .not. angular_grid) then
            call stop_timing(4)
            return !Than nothing has to be done anymore
         end if
      end if
!---------------------------------------------------------- end pocket search

!---------------------------------------------------------- start stack grid
      if (stack_grid) then
         write(*,*)
         write (*,*) '  Starting stack search'

!        move along axis seperately. This solves the identical molecule/stack case
!        mxcma= 20 !Setting for nice pictures
         ii = mxcma   ! SETING
         nn = 4*14*ii ! all directions incl. diagonal axis, none+ three rotsations of molB on each position
         if (cssym) nn = 4*9*ii
         write (*, '(''   Grid points: '',i0  )') nn
         allocate (rprobc(6, nn), rprob(nn), source=0.0_wp)
         allocate (rind(nn), source=0)
         stepr4 = 0.2*float(n1 + n2)**0.10d0 ! increase step for larger systems
!        stepr4=2 !Setting for nice pictures

         l = 0
         do j = 1, 14
            if (cssym .and. mvec(icssym, j) .lt. 0) cycle ! exclude sym. equiv.
            r = stepr4
            if (j .gt. 6) r = stepr4/sqrt(3.)
            dum2(1:3) = mvec(1:3, j)*r !mvec just vector in every direction in 3D
            do i = 1, ii !Moving stepwise along one vector of mvec (one direction in 3D)
               displ = 0
               displ(1:3) = float(ii + 1 - i)*dum2(1:3) !Point in distance ii-i in every direction
               l = l + 1
               rprobc(1:6, l) = displ(1:6)
               do k = 4, 6
                  displ(k) = pi !Rotationangles = Pi
                  l = l + 1
                  rprobc(1:6, l) = displ(1:6)
               end do
            end do
         end do

         !$omp parallel do default(none) reduction(+:rprob) &
         !$omp shared(env,nn,n,n1,n2,at1,at2,neigh,xyz1,xyz2,q1,q2,c6ab,&
         !$omp z1,z2,nl1,nl2,l1,l2,cl1,cl2,qdr1,qdr2,cn1,cn2,alp1,&
         !$omp alp2,alpab,qct1,qct2,den1,den2,gab1,gab2,rprobc) &
         !$omp private(l,e,displ)
         do l = 1, nn
            displ(1:6) = rprobc(1:6, l)
            call iff_e(env, n, n1, n2, at1, at2, neigh, xyz1, xyz2, q1, q2, c6ab,&
                          &z1, z2, nl1, nl2, l1, l2, cl1, cl2,&
                          &qdr1, qdr2,&
                          &cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
                          &den1, den2, gab1, gab2,&
                          &.false., -1, e, displ)
            rprob(l) = e
         end do
         !$omp end parallel do

         if (debug) then
            call wr_grid('stack_grid.xyz', molA%n, nn, molA%at, &
                    &    36, xyz1, rprobc(1:3, 1:nn))
         end if

         do i = 1, nn
            rind(i) = i
         end do
         call Qsort(rprob, 1, nn, rind) ! sort for E neutral
         write (*, '(''   lowest found /kcal :'',F8.2)') rprob(1)*au
         do i = 1, nn/100 ! take some lowest
            if (rprob(i) .lt. 0.1) then
               nclust = nclust + 1
               found(1:6, nclust) = rprobc(1:6, rind(i))
               found(7, nclust) = rprob(rind(i))
            end if
         end do
         ll = nclust

         if(debug) then
            if (rprob(1)*au .lt. bestsofar) then
               call wrc3('best_after_angular_stack.xyz', n1, n2, at1, at2, xyz1, xyz2, 0, found)
               bestsofar = rprob(1)*au
            end if

            deallocate (rprobc, rprob, rind)
         endif

      end if
!--------------------------------------------------------------- end stack grid

!--------------------------------------------------------------- start angular rot
      if (angular_grid) then
         write(*,*)
         write (*, *) '  Starting angular search'

         m1 = 360/int(stepa)       ! angular grid with stepa deg steps
         maxlow = mm1*mm2*mm3 + 2    ! crude R grid dim
         nn = maxlow*m1*m1*m1
         write (*, '(''   Grid points:'',i0  )') nn
         allocate (xyzprob3(3, maxlow), xyzprob4(7, nn), source=0.0_wp)

!        include the best +/- polar points for the angular grid
         xyzprob3(1:3, 1) = xyzprobc(1:3, ind1(1)) ! take only lowest
         xyzprob3(1:3, 2) = xyzprobc(1:3, ind2(1)) !  "    "     "

         deallocate (xyzprobc, xyzprob0, xyzprob1, xyzprob2, ind0, ind1, ind2)

!        just a very crude grid over entire molecule 1 for filling up points
         dx = xx1
         l = 2 !The first two are best +/- polarized points
         do i = 1, mm1
            dum(1) = dx
            dy = yy1
            do j = 1, mm2
               dum(2) = dy
               dz = zz1
               do k = 1, mm3
                  dum(3) = dz
                  l = l + 1
                  xyzprob3(1:3, l) = dum(1:3)
                  dz = dz + stepr3(3) !stepr3=10*stepr
               end do
               dy = dy + stepr3(2)
            end do
            dx = dx + stepr3(1)
         end do
         stepa = pi2/float(m1 - 1)

         if (debug) then
            call wr_grid('angular_grid.xyz', molA%n, maxlow, molA%at, 36, xyz1, xyzprob3)
         end if

!        loop over R points
         !$omp parallel do default(none) &
         !$omp shared(env,xyzprob4,maxlow,m1,stepa,xyzprob3,n,n1,n2,at1,at2,neigh,&
         !$omp xyz1,xyz2,q1,q2,c6ab,z1,z2,nl1,nl2,l1,l2,cl1,cl2,&
         !$omp qdr1,qdr2,cn1,cn2,alp1,alp2,alpab,qct1,qct2,den1,den2,gab1,gab2)&
         !$omp private(icycle,i,j,k,e,displ,l)
         do icycle = 1, maxlow !Maxlow is dimension of R grid with stepr3
            l = 0
            !> Rotating at each crude gridpoint moleculeB stepwise
            do i = 1, m1
               displ(4) = (i - 1)*stepa
               do j = 1, m1
                  displ(5) = (j - 1)*stepa
                  do k = 1, m1
                     displ(6) = (k - 1)*stepa
                     displ(1:3) = xyzprob3(1:3, icycle)
                     call iff_e(env, n, n1, n2, at1, at2, neigh,&
                               &xyz1, xyz2, q1, q2, c6ab, z1, z2,&
                               &nl1, nl2, l1, l2, cl1, cl2,&
                               &qdr1, qdr2,&
                               &cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
                               &den1, den2, gab1, gab2,&
                               &.false., -1, e, displ)
                     l = k + m1*(j - 1) + m1**2*(i - 1) + (icycle - 1)*maxlow
                     xyzprob4(1:6, l) = displ(1:6)
                     xyzprob4(7, l) = e
                  end do
               end do
            end do
         end do
         !$omp end parallel do
         call sort6(nn, xyzprob4)
!--------------------------------------------------------------------- end angular rot

         !> Adding stack and angular search
         ll = 5*maxparent + nclust

         !> Performing an energy computation of stack and angular search structures
         !> to rank them energetically
         !$omp parallel do default(none) &
         !$omp shared(env,found,ll,xyzprob4,nclust,n,n1,n2,at1,at2,neigh,xyz1,&
         !$omp xyz2,q1,q2,c6ab,z1,z2,nl1,nl2,l1,l2,cl1,cl2,qdr1,qdr2,cn1,cn2,&
         !$omp alp1,alp2,alpab,qct1,qct2,den1,den2,gab1,gab2) &
         !$omp private(i,displ,e)
         do i = 1, ll                     ! approx nparent*2 because doubles appear
            if (i .le. nclust) then
               displ(1:6) = found(1:6, i) !Lowest of stack search
            else
               displ(1:6) = xyzprob4(1:6, i - nclust) !Lowest of angular search
            end if
            call iff_e(env, n, n1, n2, at1, at2, neigh, xyz1, xyz2, q1, q2, c6ab,&
                          &z1, z2, nl1, nl2, l1, l2, cl1, cl2,&
                          &qdr1, qdr2,&
                          &cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
                          &den1, den2, gab1, gab2,&
                          &.false., -1, e, displ)
            found(1:6, i) = displ(1:6)
            found(7, i) = e*au
         end do
         !$omp end parallel do

         deallocate (xyzprob3, xyzprob4)
      end if

      call doubles(ll, ndim, 3.0d0, 0.1d0, found)    ! Sorting out doubles
      call sort6(ll, found)
      if(debug) call wrc3('best_before_gen.xyz', n1, n2, at1, at2, xyz1, xyz2, 1, found)

      write (*, *)
      write (*, *) '  Interaction energy of lowest structures so far in kcal/mol:'
      do i = 1, 10
         write (*, '(   F14.2)') found(7, i)
      end do
      write(*,*)

!      write (*, *) '(Rx,Ry,Rz,alp,bet,gam,Eint in kcal/mol):'
!      do i = 1, 10
!         write (*, '(6F8.3,5x,F14.2)') found(1:7, i)
!      end do

      if (debug) then
         call wrc2('genstart.xyz', 1, n1, n2, at1, at2, xyz1, xyz2,&
                   &maxparent, found)
      end if

!-------------------------------------------------------------- start genetic optimization

      write (*, *) '------------------------------'
      write (*, *) 'genetic optimization algorithm'
      write (*, *) '------------------------------'
      write (*, *) '  cycle  Eint/kcal/mol  average Eint'
      do icycle = 1, maxgen

         !$omp parallel do default(none) &
         !$omp shared(env,found2,maxparent,found,n,n1,n2,at1,at2,neigh,&
         !$omp xyz1,xyz2,q1,q2,c6ab,z1,z2,nl1,nl2,l1,l2,cl1,cl2,qdr1,qdr2,cn1,cn2,&
         !$omp alp1,alp2,alpab,qct1,qct2,den1,den2,gab1,gab2) &
         !$omp private(i,j,ii,displ,e,f)
!     LOOP HEAD -------------------------------------------------------
         do i = 1, maxparent
            do j = 1, maxparent
               ii = (i - 1)*maxparent + j
               call crossover(0.00d0, f)
               displ(1:6) = found(1:6, i)*f(1:6) + found(1:6, j)*(1.0d0 - f(1:6))
               if (i .ne. j) call rand6(0.5d0, 1.0d0, 1.0d0, displ)   ! mutation only on childs
               call iff_e(env, n, n1, n2, at1, at2, neigh, xyz1, xyz2, q1, q2, c6ab,&
                               &z1, z2, nl1, nl2, l1, l2, cl1, cl2,&
                               &qdr1, qdr2,&
                               &cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
                               &den1, den2, gab1, gab2,&
                               &.false., -1, e, displ)            ! only e returned
               found2(1:6, ii) = displ(1:6)
               found2(7, ii) = e*au
            end do
         end do
         !$omp end parallel do

         ii = maxparent**2
         call doubles(ii, ndim, 3.0d0, 0.10d0, found2)          ! SETING
         call sort6(ii, found2)

         found = found2
         if (debug) call wrc2('structures_after_gen.xyz', 0, n1, n2, at1, at2, xyz1,&
         & xyz2, n_opt, found)
         call wrc3('best_after_gen.xyz', n1, n2, at1, at2, xyz1, xyz2, 1, found)

         av = sum(found(7, 1:maxparent))/float(maxparent)
         sig = 0
         do i = 1, n_opt
            sig = sig + (found(7, i) - av)**2
         end do
         sig = sqrt(sig/float(n_opt - 1))
         write(*,'(4x,i0,7x,F7.1,5x,F8.1,5x)')&
         &icycle, found(7, 1), av
         if (sig .lt. 0.3d0) exit
!     LOOP END ------
      end do
      call stop_timing(4)
!-------------------------------------------------------------- end genetic optimization

      !> Check if ensemble runtype is requested
      if (docking_ens) then
         n_opt = 0
         do i = 1, ii
            !> Increase number of optimizations for each structure with an Eint of lower than -0.1 kcal/mol
            if (found(7, i) < -0.1) then
               n_opt = n_opt + 1
            else
               exit
            end if
         end do
      end if

!-------------------------------------------------------------- final optimization

      call open_file(iopt, 'optimized_structures.xyz', 'w')
      call open_file(itemp, 'opt_tmp', 'w')
      tmp_unit = env%unit
      env%unit = itemp
      set%opt_logfile = 'final_opt.xyz'

      if (pocket_grid) then !include pocket search
         allocate (xyz_opt(3, n, n_opt + kk), source=0.0_wp)
         allocate (final_e(n_opt + kk), source=0.0_wp)
      else
         allocate (xyz_opt(3, n, n_opt), source=0.0_wp)
         allocate (final_e(n_opt), source=0.0_wp)
      end if

      write (*, *)
      write (*, '(''Optimizing '',i0,'' best structures with '',a )') n_opt, optlvl
      do icycle = 1, n_opt
         found_tmp = found2(1:6, icycle)
         call move2(molB%n, molB%xyz, xyz_tmp, found_tmp) !return xyz_tmp that is with found_tmp transformed molB%xyz
         do j = 1, molA%n
            comb%xyz(1:3, j) = molA%xyz(1:3, j) !comb overwritten with A, as it is changed upon geo_opt
         end do
         counter = 0
         do j = molA%n + 1, molA%n + molB%n
            counter = counter + 1
            comb%xyz(1:3, j) = xyz_tmp(1:3, counter) !combined molA and shifted molB
         end do
         select type (calc)
         type is (TGFFCalculator)
            call restart_gff(env, comb, calc)
            calc%topo%nbond = topo_backup%nbond
            calc%topo%nb = topo_backup%nb
            calc%topo%qfrag = topo_backup%qfrag
            calc%topo%qa = topo_backup%qa
            calc%topo%fraglist = topo_backup%fraglist
            calc%topo%nfrag = topo_backup%nfrag
         type is (TxTBCalculator)
            call restart_xTB(env, comb, chk, calc)
         end select
         write (*, *) icycle
         call start_timing(5)
         call geometry_optimization &
         &     (env, comb, chk, calc, egap, set%etemp, set%maxscciter, set%optset%maxoptcycle,&
         &      etot, grad, sigma, set%optset%optlev, pr, initial_sp, fail)
         grad = 0.0_wp; sigma = 0.0_wp; egap = 0.0_wp
         call stop_timing(5)
         do i = 1, 3
            do j = 1, comb%n
               xyz_opt(i, j, icycle) = comb%xyz(i, j)
            end do
         end do
         final_e(icycle) = etot

         write (iopt, '(i0)') comb%n
         write (iopt, '(f20.14)') etot
         do j = 1, comb%n
            write (iopt, '(a4,2x,3f20.14)') comb%sym(j), comb%xyz(:, j)*autoang
         end do
         found(7, i) = etot
      end do

      env%unit = tmp_unit
      call remove_file(itemp)
      call close_file(iopt)

      !> Include pocket structure if present
      if (pocket_grid) then
         do k = 1, kk
            final_e(n_opt + k) = pocket_e(k)
            do j = 1, comb%n
               do i = 1, 3
                  xyz_opt(i, j, n_opt + k) = xyz_pocket(i, j, k)
               end do
            end do
         end do
      end if

      !>Sorting strucutures
      call sortxyz_e(n, n_opt+kk, final_e, xyz_opt)
      call open_file(ifinal, 'final_structures.xyz', 'w')
      do i = 1, n_opt + kk !kk=0 if no pocket search
         write (ifinal, '(i0)') comb%n
         write (ifinal, '(f20.14)') final_e(i)
         do j = 1, comb%n
            write (ifinal, '(a4,2x,3f20.14)') comb%sym(j), xyz_opt(1, j, i)*autoang, &
                    &                         xyz_opt(2, j, i)*autoang, xyz_opt(3, j, i)*autoang
         end do
      end do
      call close_file(ifinal)

      call remove_file(iopt)

      call open_file(ifinal, 'best.xyz', 'w')
      write (ifinal, '(i0)') comb%n
      write (ifinal, '(f20.14)') final_e(1)
      do j = 1, comb%n
         write (ifinal, '(a4,2x,3f20.14)') comb%sym(j), xyz_opt(1, j, 1)*autoang, &
         &                                 xyz_opt(2, j, 1)*autoang, xyz_opt(3, j, 1)*autoang
      end do
      call close_file(ifinal)
      call delete_file(set%opt_logfile)

      !> Printout Interaction Energy
      write (env%unit, *)
      write (env%unit, *) '  ---------------------------'
      write (env%unit, *) '     Interaction energies'
      write (env%unit, *) '  ---------------------------'
      write (env%unit, *) 'Attention: monomers are not optimized'
      write (env%unit, *) 'Interaction energies are not physical'
      write(*,*) 
      write (env%unit, '(2x,''Lowest Interaction Energy:'',1x, F10.2, 1x, ''kcal/mol'' )') &
              & (final_e(1) - molA_e - molB_e)*au

      write (env%unit, *) ' #   E_int (kcal/mol)'
      do i = 1, n_opt + kk
         E_int = (final_e(i) - molA_e - molB_e)*au
         write (*, '(2x,i0,3x,F10.2)') i, E_int
      end do

      if (pocket_grid) then
         deallocate (xyz_pocket, pocket_e)
      end if
      deallocate (xyz_opt, final_e)

   end subroutine docking_search

!Sorts xyz according to an energy (minimum first)
!Necessary as the xyzsort and xyzsort2 does somehow not work
   subroutine sortxyz_e(n, nall, e, xyz)

      INTERFACE
         RECURSIVE SUBROUTINE Quicksort(Item, First, Last, Indices)
            REAL, DIMENSION(:), INTENT(INOUT) :: Item       ! array of values
            INTEGER, INTENT(IN)    :: First, Last
            INTEGER, DIMENSION(:), INTENT(INOUT) :: Indices
         END SUBROUTINE Quicksort
      END INTERFACE

      integer, intent(in) :: n, nall
      real(wp), intent(inout) :: e(nall), xyz(3, n, nall)

      integer :: ind(nall), i, j, k
      real(wp) :: e_tmp(nall), xyz_tmp(3, n, nall)

      do i = 1, nall
         ind(i) = i
      end do

      call Qsort(e, 1, nall, ind)

      xyz_tmp = xyz
      do i = 1, nall
         do k = 1, n
            do j = 1, 3
               xyz(j, k, i) = xyz_tmp(j, k, ind(i))
            end do
         end do
      end do

   end subroutine sortxyz_e

   subroutine restart_gff(env, mol, calc)

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env
      type(TMolecule), intent(inout) :: mol
      type(TGFFCalculator), intent(inout)::calc

      integer :: itopo = 32

      !> Read the constrain again with new xyz only if necessary
      if (constraint_xyz) then
         call read_userdata(xcontrol, env, mol)
         call constrain_xTB_gff(env, mol)
      end if

      !if(auto_walls) call number_walls=0; read_userdata(xcontrol,env,mol) !everytime new wall pot

      call open_file(itopo, 'gfnff_topo', 'r')
      call remove_file(itopo)
      call open_file(itopo, 'charges', 'r')
      call remove_file(itopo)
      call open_file(itopo, 'gfnff_adjacency', 'r')
      call remove_file(itopo)
      call calc%topo%zero
      calc%update = .true.
      call gfnff_param_dealloc(calc%topo)
      call newD3Model(calc%topo%dispm, mol%n, mol%at)
      call gfnff_set_param(mol%n, calc%gen, calc%param)
      if (.not. allocated(calc%topo%nb)) allocate (calc%topo%nb(20, mol%n), source=0)
      if (.not.allocated(calc%topo%qfrag)) &
              & allocate( calc%topo%qfrag(mol%n), source = 0.0d0 )
      if (.not.allocated(calc%topo%fraglist)) &
              & allocate( calc%topo%fraglist(mol%n), source = 0 )
      calc%topo%qfrag(1) = set%ichrg
      calc%topo%qfrag(2:mol%n) = 0.0_wp
      call gfnff_ini(env, .false., ini, mol, calc%gen,&
           &         calc%param, calc%topo, calc%accuracy)

   end subroutine restart_gff

   subroutine restart_xTB(env, mol, chk, calc, basisset)

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env
      type(TMolecule), intent(inout) :: mol
      type(TRestart), intent(inout) :: chk
      type(TxTBCalculator), intent(inout)::calc
      logical, optional, intent(in) :: basisset

      real(wp), allocatable :: cn(:), dcn(:, :, :), dq(:, :, :), g(:, :)
      real(wp) :: er
      logical :: okbas
      integer :: i

      allocate (cn(mol%n), g(3, mol%n))

      !> Read the constrain again with new xyz only if necessary
      if (constraint_xyz) then
         number_walls = 0 !Reset wall potentials
         do i=1, maxwalls
!            deallocate(wpot(i)%list)
            if(allocated(wpot(i)%list)) deallocate(wpot(i)%list)
         end do
         call read_userdata(xcontrol, env, mol)
         call constrain_xTB_gff(env, mol)
      end if

      if (present(basisset)) then
         if (basisset) then
            deallocate (calc%basis)
            allocate (calc%basis)
            call newBasisset(calc%xtbData, mol%n, mol%at, calc%basis, okbas)
         end if
      end if

      calc%etemp = set%etemp
      calc%maxiter = set%maxscciter

      call chk%wfn%allocate(mol%n, calc%basis%nshell, calc%basis%nao)
      !> EN charges and CN
      call ncoord_gfn(mol%n, mol%at, mol%xyz, cn)
      if (mol%npbc > 0) then
         chk%wfn%q = real(set%ichrg, wp)/real(mol%n, wp)
      else
         call ncoord_erf(mol%n, mol%at, mol%xyz, cn)
         call goedecker_chrgeq(mol%n,mol%at,mol%xyz,real(set%ichrg,wp),cn,dcn,chk%wfn%q,dq,er,g,&
                             & .false., .false., .false.)
         chk%wfn%q = real(set%ichrg, wp)/real(mol%n, wp)
      end if
      !> initialize shell charges from gasteiger charges
      call iniqshell(calc%xtbData,mol%n,mol%at,mol%z,calc%basis%nshell,chk%wfn%q,chk%wfn%qsh,set%gfn_method)
      call delete_file('.sccnotconverged')
      call env%checkpoint("Setup for calculation failed")

   end subroutine restart_xTB

   subroutine constrain_xTB_gff(env, mol)

      type(TEnvironment), intent(inout) :: env

      type(TMolecule) :: mol
      real(wp), save :: fc
      logical, save :: called = .false.

      !> restraining potential
      if (allocated(potset%xyz)) then
      if (lconstr_all_bonds) call constrain_all_bonds(mol%n, mol%at, potset%xyz)
      if (lconstr_all_angles) call constrain_all_angles(mol%n, mol%at, potset%xyz)
      if (lconstr_all_torsions) call constrain_all_torsions(mol%n, mol%at, potset%xyz)
         call setup_constrain_pot(mol%n, mol%at, potset%xyz)
      else
         if (lconstr_all_bonds) call constrain_all_bonds(mol%n, mol%at, mol%xyz)
         if (lconstr_all_angles) call constrain_all_angles(mol%n, mol%at, mol%xyz)
         if (lconstr_all_torsions) call constrain_all_torsions(mol%n, mol%at, mol%xyz)
         call setup_constrain_pot(mol%n, mol%at, mol%xyz)
      end if
      if (.not. called) then
         called = .true.
         fc = potset%pos%fc
      else
         potset%pos%fc = fc
      end if

   end subroutine constrain_xTB_gff

   subroutine doubles(nlow, ndim, rthr, ethr, found)
      integer, intent(in) :: nlow, ndim
      real(wp), intent(in) :: rthr
      real(wp), intent(in) :: ethr
      real(wp), intent(inout) :: found(7, ndim)

      real(wp) :: scr(7, ndim)
      integer :: i, j, k
      real(wp) :: r, de, dem

      scr = found

      do i = 1, nlow - 1
         do j = i + 1, nlow
            call rnorm(i, j, found, r)
            de = abs(found(7, i) - found(7, j))
            dem = abs(found(7, i) + found(7, j))*0.5
            if (r .lt. rthr .and. de/dem .lt. ethr) then
               scr(7, j) = 1.d+42
            end if
            if (abs(found(7, i) - found(7, j)) .lt. 1.d-3) scr(7, j) = 1.d+42 ! chiral or symmetry case
         end do
      end do

      found = scr

   end subroutine doubles

end module xtb_docking_search_nci

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Cosmo van-der-Waals radii

module xtb_param_vdwradcosmo
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   use xtb_mctc_symbols, only : toNumber
   implicit none
   private

   public :: getVanDerWaalsRadCosmo, vanDerWaalsRadCosmo


   !> Get van-der-Waals Rad for a species
   interface getVanDerWaalsRadCosmo
      module procedure :: getVanDerWaalsRadCosmoSymbol
      module procedure :: getVanDerWaalsRadCosmoNumber
   end interface getVanDerWaalsRadCosmo


   !> Default value for unoptimized van-der-Waals radii
   real(wp), parameter :: cosmostub = 2.223_wp

   !> COSMO optimized van-der-Waals radii
   real(wp), parameter :: vanDerWaalsRadCosmo(94) = aatoau * [ &
       & 1.3000_wp, 1.6380_wp, 1.5700_wp, 1.0530_wp, &   ! h-be
       & 2.0480_wp, 2.0000_wp, 1.8300_wp, 1.7200_wp, &   ! B-O
       & 1.7200_wp, 1.8018_wp, 1.8000_wp, 1.6380_wp, &   ! F-Mg
       & 2.1530_wp, 2.2000_wp, 2.1060_wp, 2.1600_wp, &   ! Al-S
       & 2.0500_wp, 2.2000_wp, 2.2230_wp, cosmostub, &   ! Cl-Ca
       & cosmostub, 2.2930_wp, cosmostub, cosmostub, &   ! Sc-Cr
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Mn-Ni
       & cosmostub, 1.6260_wp, cosmostub, 2.7000_wp, &   ! Cu-Ge
       & 2.3500_wp, 2.2000_wp, 2.1600_wp, 2.3630_wp, &   ! As-Kr
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rb-Zr
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Nb-Ru
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Rh-Cd
       & 2.2580_wp, 2.5500_wp, 2.4100_wp, 2.4100_wp, &   ! In-Te
       & 2.3200_wp, 2.5270_wp, cosmostub, cosmostub, &   ! I-Ba
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! La-Nd
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Pm-Gd
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tb-Er
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Tm-Hf
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ta-Os
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ir-Hg
       & cosmostub, 2.3600_wp, 2.4220_wp, 2.3050_wp, &   ! Tl-Po
       & 2.3630_wp, 2.5740_wp, cosmostub, cosmostub, &   ! At-Ra
       & cosmostub, cosmostub, cosmostub, cosmostub, &   ! Ac-U
       & cosmostub, cosmostub]                           ! Np-Pu


contains


!> Get van-der-Waals radius for species with a given symbol
elemental function getVanDerWaalsRadCosmoSymbol(symbol) result(rad)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> van-der-Waals radius
   real(wp) :: rad

   rad = getVanDerWaalsRadCosmo(toNumber(symbol))

end function getVanDerWaalsRadCosmoSymbol


!> Get van-der-Waals radius for species with a given atomic number
elemental function getVanDerWaalsRadCosmoNumber(number) result(rad)

   !> Atomic number
   integer, intent(in) :: number

   !> van-der-Waals radius
   real(wp) :: rad

   if (number > 0 .and. number <= size(vanDerWaalsRadCosmo, dim=1)) then
      rad = vanDerWaalsRadCosmo(number)
   else
      rad = -1.0_wp
   end if

end function getVanDerWaalsRadCosmoNumber


end module xtb_param_vdwradcosmo

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Extended tight binding calculator
module xtb_xtb_calculator
   use xtb_mctc_accuracy, only : wp
   use xtb_solv_gbsa, only : TBorn
   use xtb_solv_model, only : info, newSolvationModel, newBornModel
   use xtb_type_basisset, only : TBasisset
   use xtb_type_calculator, only : TCalculator
   use xtb_type_data
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   use xtb_type_param, only : scc_parameter, TxTBParameter, chrg_parameter
   use xtb_type_pcem
   use xtb_type_solvation, only : TSolvation
   use xtb_type_restart, only : TRestart
   use xtb_xtb_data, only : TxTBData
   use xtb_setparam
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_scf, only : scf
   use xtb_peeq, only : peeq
   use xtb_embedding, only : read_pcem
   use xtb_metadynamic
   use xtb_constrainpot
   use xtb_basis, only : newBasisset
   use xtb_mctc_systools, only : rdpath
   use xtb_readparam, only : readParam
   use xtb_paramset, only : use_parameterset
   use xtb_chargemodel, only : new_charge_model_2019
   use xtb_disp_ncoord, only : ncoord_erf
   use xtb_eeq, only : eeq_chrgeq
   use xtb_iniq, only : iniqcn
   use xtb_scc_core, only : iniqshell
   implicit none

   private

   public :: TxTBCalculator, newXTBCalculator, newWavefunction


   !> Calculator interface for xTB based methods
   type, extends(TCalculator) :: TxTBCalculator

      !> Tight binding basis set
      type(TBasisset), allocatable :: basis

      !> Parametrisation data base
      type(TxTBData), allocatable :: xtbData

      !> Electronic temperature
      real(wp) :: etemp

      !> Maximum number of cycles for SCC convergence
      integer :: maxiter

      !> External potential
      type(tb_pcem) :: pcem

   contains

      !> Perform xTB single point calculation
      procedure :: singlepoint

      !> Write informative printout
      procedure :: writeInfo

   end type TxTBCalculator

   character(len=*),private,parameter :: outfmt = &
      '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'


contains


subroutine newXTBCalculator(env, mol, calc, fname, method, accuracy)

   character(len=*), parameter :: source = 'xtb_calculator_newXTBCalculator'

   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(in) :: mol

   type(TxTBCalculator), intent(out) :: calc

   integer, intent(in), optional :: method

   real(wp), intent(in), optional :: accuracy

   character(len=*), intent(in), optional :: fname

   character(len=:), allocatable :: filename
   type(TxTBParameter) :: globpar
   integer :: ich
   logical :: exist, okbas
   logical :: exitRun

   if (present(fname)) then
      filename = fname
   else
      if (present(method)) then
         select case(method)
         case(0)
            call rdpath(env%xtbpath, 'param_gfn0-xtb.txt', filename, exist)
            if (.not.exist) filename = 'param_gfn0-xtb.txt'
         case(1)
            call rdpath(env%xtbpath, 'param_gfn1-xtb.txt', filename, exist)
            if (.not.exist) filename = 'param_gfn1-xtb.txt'
         case(2)
            call rdpath(env%xtbpath, 'param_gfn2-xtb.txt', filename, exist)
            if (.not.exist) filename = 'param_gfn2-xtb.txt'
         end select
      end if
   end if
   if (.not.allocated(filename)) then
      call env%error("No parameter file or parametrisation info provided", source)
      return
   end if

   if (present(accuracy)) then
      calc%accuracy = accuracy
   else
      calc%accuracy = 1.0_wp
   end if

   calc%etemp = 300.0_wp
   calc%maxiter = 250

   !> Obtain the parameter file
   allocate(calc%xtbData)
   call open_file(ich, filename, 'r')
   exist = ich /= -1
   if (exist) then
      call readParam(env, ich, globpar, calc%xtbData, .true.)
      call close_file(ich)
   else ! no parameter file, check if we have one compiled into the code
      call use_parameterset(filename, globpar, calc%xtbData, exist)
      if (.not.exist) then
         call env%error('Parameter file '//filename//' not found!', source)
         return
      end if
   endif

   if (present(method)) then
      if (method /= calc%xtbData%level) then
         call env%error("Requested method does not match loaded method", source)
         return
      end if
   end if

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Could not load parameters", source)
      return
   end if

   !> set up the basis set for the tb-Hamiltonian
   allocate(calc%basis)
   call newBasisset(calc%xtbData, mol%n, mol%at, calc%basis, okbas)
   if (.not.okbas) then
      call env%error('basis set could not be setup completely', source)
      return
   end if

   !> check for external point charge field
   if (allocated(set%pcem_file)) then
      call open_file(ich, set%pcem_file, 'r')
      if (ich /= -1) then
         call read_pcem(ich, env, calc%pcem, calc%xtbData%coulomb)
         call close_file(ich)
      end if
   end if

end subroutine newXTBCalculator


subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)

   !> Source of the generated errors
   character(len=*), parameter :: source = 'xtb_calculator_singlepoint'

   !> Calculator instance
   class(TxTBCalculator), intent(inout) :: self

   !> Computational environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol

   !> Wavefunction data
   type(TRestart), intent(inout) :: chk

   !> Print level for IO
   integer, intent(in) :: printlevel

   !> Restart from previous results
   logical, intent(in) :: restart

   !> Total energy
   real(wp), intent(out) :: energy

   !> Molecular gradient
   real(wp), intent(out) :: gradient(:, :)

   !> Strain derivatives
   real(wp), intent(out) :: sigma(:, :)

   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap

   !> Detailed results
   type(scc_results), intent(out) :: results

   class(TSolvation), allocatable :: solvation
   type(TBorn), allocatable :: gbsa
   integer :: i,ich
   integer :: mode_sp_run = 1
   real(wp) :: efix
   logical :: inmol
   logical, parameter :: ccm = .true.
   logical :: exitRun

   call mol%update

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   hlgap = 0.0_wp
   efix = 0.0_wp

   ! ------------------------------------------------------------------------
   !  actual calculation
   select case(self%xtbData%level)
   case(1, 2)
      if (allocated(self%solvation)) then
         call newSolvationModel(self%solvation, env, solvation, mol%at)
      end if
      call scf(env,mol,chk%wfn,self%basis,self%pcem,self%xtbData,solvation, &
         &   hlgap,self%etemp,self%maxiter,printlevel,restart,.true., &
         &   self%accuracy,energy,gradient,results)

   case(0)
      if (allocated(self%solvation)) then
         allocate(gbsa)
         call newBornModel(self%solvation, env, gbsa, mol%at)
      end if
      call peeq &
         & (env,mol,chk%wfn,self%basis,self%xtbData,gbsa,hlgap,self%etemp, &
         &  printlevel,.true.,ccm,self%accuracy,energy,gradient,sigma,results)

   end select

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Electronic structure method terminated", source)
      return
   end if

   ! ------------------------------------------------------------------------
   !  post processing of gradient and energy

   ! point charge embedding gradient file
   if (allocated(set%pcem_grad) .and. self%pcem%n > 0) then
      call open_file(ich,set%pcem_grad,'w')
      do i=1,self%pcem%n
         write(ich,'(3f12.8)')self%pcem%grd(1:3,i)
      enddo
      call close_file(ich)
   endif

   ! ------------------------------------------------------------------------
   !  various external potentials
   call constrain_pot(potset,mol%n,mol%at,mol%xyz,gradient,efix)
   call constrpot   (mol%n,mol%at,mol%xyz,gradient,efix)
   call cavity_egrad(mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (metaset,mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (rmsdset,mol%n,mol%at,mol%xyz,efix,gradient)

   ! ------------------------------------------------------------------------
   !  fixing of certain atoms
   !  print*,abs(efix/etot)
   energy = energy + efix
   results%e_total = energy
   results%gnorm = norm2(gradient)
   if (fixset%n.gt.0) then
      do i=1, fixset%n
         !print*,i,fixset%atoms(i)
         gradient(1:3,fixset%atoms(i))=0
      enddo
   endif

   ! save point charge gradients in results
   if (self%pcem%n > 0) then
      results%pcem = self%pcem
   endif

   if (printlevel.ge.2) then
      ! start with summary header
      if (.not.set%silent) then
         write(env%unit,'(9x,53(":"))')
         write(env%unit,'(9x,"::",21x,a,21x,"::")') "SUMMARY"
      endif
      write(env%unit,'(9x,53(":"))')
      write(env%unit,outfmt) "total energy      ", results%e_total,"Eh   "
      if (.not.set%silent.and.allocated(self%solvation)) then
         write(env%unit,outfmt) "total w/o Gsasa/hb", &
            &  results%e_total-results%g_sasa-results%g_hb-results%g_shift, "Eh   "
      endif
      write(env%unit,outfmt) "gradient norm     ", results%gnorm,  "Eh/a0"
      write(env%unit,outfmt) "HOMO-LUMO gap     ", results%hl_gap, "eV   "
      if (.not.set%silent) then
         if (set%verbose) then
            write(env%unit,'(9x,"::",49("."),"::")')
            write(env%unit,outfmt) "HOMO orbital eigv.", chk%wfn%emo(chk%wfn%ihomo),  "eV   "
            write(env%unit,outfmt) "LUMO orbital eigv.", chk%wfn%emo(chk%wfn%ihomo+1),"eV   "
         endif
         write(env%unit,'(9x,"::",49("."),"::")')
         if (self%xtbData%level.eq.2) call print_gfn2_results(env%unit,results,set%verbose,allocated(self%solvation))
         if (self%xtbData%level.eq.1) call print_gfn1_results(env%unit,results,set%verbose,allocated(self%solvation))
         if (self%xtbData%level.eq.0) call print_gfn0_results(env%unit,results,set%verbose,allocated(self%solvation))
         write(env%unit,outfmt) "add. restraining  ", efix,       "Eh   "
         write(env%unit,outfmt) "total charge      ", sum(chk%wfn%q), "e    "
         if (set%verbose) then
            write(env%unit,'(9x,"::",49("."),"::")')
            write(env%unit,outfmt) "atomisation energy", results%e_atom, "Eh   "
         endif
      endif
      write(env%unit,'(9x,53(":"))')
      write(env%unit,'(a)')
   endif

end subroutine singlepoint


subroutine print_gfn0_results(iunit,res,verbose,lsolv)
   use xtb_type_data
   integer, intent(in) :: iunit ! file handle (usually output_unit=6)
   type(scc_results),    intent(in) :: res
   logical,intent(in) :: verbose,lsolv
   write(iunit,outfmt) "H0 energy         ", res%e_elec, "Eh   "
   write(iunit,outfmt) "repulsion energy  ", res%e_rep,  "Eh   "
   write(iunit,outfmt) "electrostat energy", res%e_es,   "Eh   "
   write(iunit,outfmt) "-> Gsolv          ", res%g_solv, "Eh   "
   !write(iunit,outfmt) "   -> Gborn       ", res%g_born, "Eh   " ! not saved
   write(iunit,outfmt) "   -> Gsasa       ", res%g_sasa, "Eh   "
   !write(iunit,outfmt) "   -> Ghb         ", res%g_hb,   "Eh   " ! not saved
   write(iunit,outfmt) "   -> Gshift      ", res%g_shift,"Eh   "
   write(iunit,outfmt) "dispersion energy ", res%e_disp, "Eh   "
   write(iunit,outfmt) "short-range corr. ", res%e_xb,   "Eh   "
end subroutine print_gfn0_results

subroutine print_gfn1_results(iunit,res,verbose,lsolv)
   use xtb_type_data
   integer, intent(in) :: iunit ! file handle (usually output_unit=6)
   type(scc_results),    intent(in) :: res
   logical,intent(in) :: verbose,lsolv
   write(iunit,outfmt) "SCC energy        ", res%e_elec, "Eh   "
   write(iunit,outfmt) "-> electrostatic  ", res%e_es,   "Eh   "
   if (lsolv) then
   write(iunit,outfmt) "-> Gsolv          ", res%g_solv, "Eh   "
   write(iunit,outfmt) "   -> Gelec       ", res%g_born, "Eh   "
   write(iunit,outfmt) "   -> Gsasa       ", res%g_sasa, "Eh   "
   write(iunit,outfmt) "   -> Ghb         ", res%g_hb,   "Eh   "
   write(iunit,outfmt) "   -> Gshift      ", res%g_shift,"Eh   "
   endif
   write(iunit,outfmt) "repulsion energy  ", res%e_rep,  "Eh   "
   write(iunit,outfmt) "dispersion energy ", res%e_disp, "Eh   "
   write(iunit,outfmt) "halogen bond corr.", res%e_xb,   "Eh   "
end subroutine print_gfn1_results

subroutine print_gfn2_results(iunit,res,verbose,lsolv)
   use xtb_type_data
   integer, intent(in) :: iunit ! file handle (usually output_unit=6)
   type(scc_results),    intent(in) :: res
   logical,intent(in) :: verbose,lsolv
   write(iunit,outfmt) "SCC energy        ", res%e_elec, "Eh   "
   write(iunit,outfmt) "-> isotropic ES   ", res%e_es,   "Eh   "
   write(iunit,outfmt) "-> anisotropic ES ", res%e_aes,  "Eh   "
   write(iunit,outfmt) "-> anisotropic XC ", res%e_axc,  "Eh   "
   write(iunit,outfmt) "-> dispersion     ", res%e_disp, "Eh   "
   if (lsolv) then
   write(iunit,outfmt) "-> Gsolv          ", res%g_solv, "Eh   "
   write(iunit,outfmt) "   -> Gelec       ", res%g_born, "Eh   "
   write(iunit,outfmt) "   -> Gsasa       ", res%g_sasa, "Eh   "
   write(iunit,outfmt) "   -> Ghb         ", res%g_hb,   "Eh   "
   write(iunit,outfmt) "   -> Gshift      ", res%g_shift,"Eh   "
   endif
   write(iunit,outfmt) "repulsion energy  ", res%e_rep,  "Eh   "
end subroutine print_gfn2_results


subroutine writeInfo(self, unit, mol)

   !> Calculator instance
   class(TxTBCalculator), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   call self%xtbData%writeInfo(unit, mol%at)

   if (allocated(self%solvation)) then
      call info(self%solvation, unit)
   end if

end subroutine writeInfo

!---------------------------------------------
! Initialize new wavefunction
!---------------------------------------------
subroutine newWavefunction(env, mol, calc, chk)
   
   implicit none
   character(len=*), parameter :: source = 'xtb_calculator_newWavefunction'
      !! Name of error producer routine
   type(TEnvironment), intent(inout) :: env
      !! Calculation environment to handle I/O stream and error log
   type(TRestart), intent(inout) :: chk
      !! Restart data wrapper for wfn and nlist      
   type(TxTBCalculator), intent(in) :: calc
      !! Instance of xTB Calculator
   type(TMolecule), intent(in) :: mol
      !! Molecular structure data
   real(wp), allocatable :: cn(:)
      !! Coordination number
   type(chrg_parameter) :: chrgeq
      !! guess charges(gasteiger/goedecker/sad) 
   logical :: exitRun
      !! if it is recommended to terminate the run 

   associate(wfn => chk%wfn)
      allocate(cn(mol%n))
      call wfn%allocate(mol%n,calc%basis%nshell,calc%basis%nao)
      
      !> find partial charges
      if (mol%npbc > 0) then
         !! if periodic
         wfn%q = mol%chrg/real(mol%n,wp)
            !! evenly distribute charge with the equal partial charges 
      else
         if (set%guess_charges.eq.p_guess_gasteiger) then
            call iniqcn(mol%n,mol%at,mol%z,mol%xyz,nint(mol%chrg),1.0_wp, &
               & wfn%q,cn,calc%xtbData%level,.true.)
         else if (set%guess_charges.eq.p_guess_goedecker) then
            !! default
            
            call new_charge_model_2019(chrgeq,mol%n,mol%at)
               !! to get parametrized values for q (en,gam,kappa,alpha)

            call ncoord_erf(mol%n,mol%at,mol%xyz,cn)
               !! to obtain CN
               !! (49) Extended Tight-Binding Quantum Chemistry Mehods 2020
            
            call eeq_chrgeq(mol,env,chrgeq,cn,wfn%q)
               !! to obtain partial charges q
               !! (47) Extended Tight-Binding Quantum Chemistry Mehods 2020

            call env%check(exitRun)
               !! to check status of environment
            if (exitRun) then
               call env%rescue("EEQ guess failed, falling back to SAD guess", source)
               wfn%q = mol%chrg/real(mol%n,wp)
            end if
         else
            wfn%q = mol%chrg/real(mol%n,wp)
         end if
      end if
      
      !> find shell charges
      call iniqshell(calc%xtbData,mol%n,mol%at,mol%z,calc%basis%nshell, &
         & wfn%q,wfn%qsh,calc%xtbData%level)
   
   end associate

end subroutine newWavefunction

end module xtb_xtb_calculator

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Driver for unit testing
program tester
   use, intrinsic :: iso_fortran_env, only : error_unit
   use testdrive, only : new_testsuite, testsuite_type, select_suite, run_selected, &
      & get_argument, unittest_type, collect_interface, error_type
   use test_atomlist, only : collect_atomlist
   use test_coordinationnumber, only : collect_coordinationnumber
   use test_coulomb, only : collect_coulomb
   use test_dftd3, only : collect_dftd3
   use test_dftd4, only : collect_dftd4
   use test_docking, only : collect_docking
   use test_eeq, only : collect_eeq
   use test_gfn0, only : collect_gfn0
   use test_gfn1, only : collect_gfn1
   use test_gfn2, only : collect_gfn2
   use test_gfnff, only : collect_gfnff
   use test_hessian, only : collect_hessian
   use test_iff, only : collect_iff
   use test_latticepoint, only : collect_latticepoint
   use test_molecule, only : collect_molecule
   use test_oniom, only : collect_oniom
   use test_dipro, only : collect_dipro
   use test_pbc_tools, only : collect_pbc_tools
   use test_peeq, only : collect_peeq
   use test_ptb, only: collect_ptb
   use test_repulsion, only : collect_repulsion
   use test_symmetry, only : collect_symmetry
   use test_tblite, only : collect_tblite
   use test_thermo, only : collect_thermo
   use test_vertical, only : collect_fukui
   use test_wsc, only : collect_wsc
   use test_cpx, only : collect_cpx
   implicit none
   integer :: stat, is
   character(len=:), allocatable :: suite_name, test_name
   type(testsuite_type), allocatable :: testsuites(:)
   character(len=*), parameter :: fmt = '("#", *(1x, a))'

   call mctc_init('test',10,.true.)

   stat = 0

   testsuites = [ &
      new_testsuite("atomlist", collect_atomlist), &
      new_testsuite("coordinationnumber", collect_coordinationnumber), &
      new_testsuite("coulomb", collect_coulomb), &
      new_testsuite("dftd3", collect_dftd3), &
      new_testsuite("dftd4", collect_dftd4), &
      new_testsuite("docking", collect_docking), &
      new_testsuite("eeq", collect_eeq), &
      new_testsuite("gfn0", collect_gfn0), &
      new_testsuite("gfn1", collect_gfn1), &
      new_testsuite("gfn2", collect_gfn2), &
      new_testsuite("gfnff", collect_gfnff), &
      new_testsuite("hessian", collect_hessian), &
      new_testsuite("iff", collect_iff), &
      new_testsuite("latticepoint", collect_latticepoint), &
      new_testsuite("molecule", collect_molecule), &
      new_testsuite("oniom", collect_oniom), &
      new_testsuite("dipro", collect_dipro), &
      new_testsuite("pbc-tools", collect_pbc_tools), &
      new_testsuite("peeq", collect_peeq), &
      new_testsuite("ptb", collect_ptb), &
      new_testsuite("repulsion", collect_repulsion), &
      new_testsuite("symmetry", collect_symmetry), &
      new_testsuite("tblite", collect_tblite), &
      new_testsuite("thermo", collect_thermo), &
      new_testsuite("vertical", collect_fukui), &
      new_testsuite("wsc", collect_wsc), &
      new_testsuite("cpx", collect_cpx) &
      ]

   call get_argument(1, suite_name)
   call get_argument(2, test_name)

   if (allocated(suite_name)) then
      is = select_suite(testsuites, suite_name)
      if (is > 0 .and. is <= size(testsuites)) then
         if (allocated(test_name)) then
            write(error_unit, fmt) "Suite:", testsuites(is)%name
            call run_selected(testsuites(is)%collect, test_name, error_unit, stat)
            if (stat < 0) then
               error stop 1
            end if
         else
            write(error_unit, fmt) "Testing:", testsuites(is)%name
            call run_testsuite(testsuites(is)%collect, error_unit, stat)
         end if
      else
         write(error_unit, fmt) "Available testsuites"
         do is = 1, size(testsuites)
            write(error_unit, fmt) "-", testsuites(is)%name
         end do
         error stop 1
      end if
   else
      do is = 1, size(testsuites)
         write(error_unit, fmt) "Testing:", testsuites(is)%name
         call run_testsuite(testsuites(is)%collect, error_unit, stat)
      end do
   end if

   if (stat > 0) then
      write(error_unit, '(i0, 1x, a)') stat, "test(s) failed!"
      error stop 1
   end if


contains

!> Driver for testsuite
subroutine run_testsuite(collect, unit, stat)

   !> Collect tests
   procedure(collect_interface) :: collect

   !> Unit for IO
   integer, intent(in) :: unit

   !> Number of failed tests
   integer, intent(inout) :: stat

   type(unittest_type), allocatable :: testsuite(:)
   integer :: it

   call collect(testsuite)

   do it = 1, size(testsuite)
      !$omp critical(testdrive_testsuite)
      write(unit, '(1x, 3(1x, a), 1x, "(", i0, "/", i0, ")")') &
         & "Starting", testsuite(it)%name, "...", it, size(testsuite)
      !$omp end critical(testdrive_testsuite)
      call run_unittest(testsuite(it), unit, stat)
   end do

end subroutine run_testsuite

!> Run a selected unit test
subroutine run_unittest(test, unit, stat)

   !> Unit test
   type(unittest_type), intent(in) :: test

   !> Unit for IO
   integer, intent(in) :: unit

   !> Number of failed tests
   integer, intent(inout) :: stat

   type(error_type), allocatable :: error
   character(len=:), allocatable :: message

   call test%test(error)
   if (.not.test_skipped(error) .and. allocated(error) .neqv. test%should_fail) then
      stat = stat + 1
   end if
   call make_output(message, test, error)
   !$omp critical(testdrive_testsuite)
   write(unit, '(a)') message
   !$omp end critical(testdrive_testsuite)
   if (allocated(error)) then
      call clear_error(error)
   end if

end subroutine run_unittest

!> Create output message for test (this procedure is pure and therefore cannot launch tests)
pure subroutine make_output(output, test, error)

   !> Output message for display
   character(len=:), allocatable, intent(out) :: output

   !> Unit test
   type(unittest_type), intent(in) :: test

   !> Error handling
   type(error_type), intent(in), optional :: error

   character(len=:), allocatable :: label
   character(len=*), parameter :: indent = repeat(" ", 7) // repeat(".", 3) // " "

   if (test_skipped(error)) then
      output = indent // test%name // " [SKIPPED]" &
         & // new_line("a") // "  Message: " // error%message
      return
   end if

   if (present(error) .neqv. test%should_fail) then
      if (test%should_fail) then
         label = " [UNEXPECTED PASS]"
      else
         label = " [FAILED]"
      end if
   else
      if (test%should_fail) then
         label = " [EXPECTED FAIL]"
      else
         label = " [PASSED]"
      end if
   end if
   output = indent // test%name // label
   if (present(error)) then
      output = output // new_line("a") // "  Message: " // error%message
   end if
end subroutine make_output

pure function test_skipped(error) result(is_skipped)

   !> Error handling
   type(error_type), intent(in), optional :: error

   !> Test was skipped
   logical :: is_skipped

   is_skipped = .false.
   if (present(error)) then
      is_skipped = error%stat == 77
   end if

end function test_skipped

!> Clear error type after it has been handled.
subroutine clear_error(error)

   !> Error handling
   type(error_type), intent(inout) :: error

   if (error%stat /= 0) then
      error%stat = 0
   end if

   if (allocated(error%message)) then
      deallocate(error%message)
   end if

end subroutine clear_error

end program tester

! This file is part of dipro.
! SPDX-Identifier: Apache-2.0
!
! Licensed under the Apache License, Version 2.0 (the "License");
! you may not use this file except in compliance with the License.
! You may obtain a copy of the License at
!
!     http://www.apache.org/licenses/LICENSE-2.0
!
! Unless required by applicable law or agreed to in writing, software
! distributed under the License is distributed on an "AS IS" BASIS,
! WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
! See the License for the specific language governing permissions and
! limitations under the License.

!> Fragmentation based on bond orders found for a system
module xtb_dipro_fragment
   use mctc_env, only : wp
   implicit none
   private

   public :: get_wiberg_fragment

contains

!> Obtain fragment information from Wiberg/Mayer type bond orders
subroutine get_wiberg_fragment(fragment,wbo,thr)
   !> Fragment information
   integer, intent(out) :: fragment(:)
   !> Bond orders
   real(wp),intent(in) :: wbo(:, :)
   !> Threshold to count bond orders as actual bond
   real(wp),intent(in) :: thr

   real(wp),allocatable :: bond(:, :)
   logical, allocatable :: taken(:)
   integer :: i, nfrag, nat
   real(wp) :: xsum

   nat = size(fragment)
   fragment(:) = 0
   allocate(taken(nat), source=.false.)
   allocate(bond(nat, nat), source=0.0_wp)
   where(wbo > thr)
      bond = min(wbo, 1.0_wp) !filtert kleinsten Wert aus wbo und setzt den an die richtige 
!nat,nat stell in wbo, falls wbo < 1.0 wird =1 gesetzt
   elsewhere
      bond = 0.0_wp !sollte in einer symmetrischen Matrix mit 0/1/>1 resultieren
   endwhere

   nfrag = 0
   do i = 1, nat
      if(taken(i)) cycle
      nfrag=nfrag+1
      fragment(i)=nfrag
      taken(i)=.true.
      call find_neighbours(i, sum(ceiling(bond(:,:)), 1), taken, bond, fragment, nfrag)
   end do !ceiling(-63.2234)=-63, ceiling(63.2234)=63 . Aufrunden-FUnktion
end subroutine get_wiberg_fragment

!> Worker routine to transverse the graph recursively
recursive subroutine find_neighbours(i, cn, taken, bond, fragment, this_fragment)
   !> Current node in the graph
   integer, intent(in) :: i
   !> Number of edges for every node
   integer, intent(in) :: cn(:)
   !> Status of nodes
   logical, intent(inout) :: taken(:)
   !> Weights of the graph edges, destroyed while transversing the graph
   real(wp), intent(inout) :: bond(:,:)
   !> Fragments found
   integer, intent(inout) :: fragment(:)
   !> Index of the current fragmant
   integer, intent(inout) :: this_fragment

   integer :: j, k

   do k = 1, cn(i)
      j = maxloc(bond(:, i), 1)
      bond(j, i) = 0
      if (i == j .or. taken(j)) cycle
      fragment(j) = this_fragment
      taken(j) = .true.
      call find_neighbours(j, cn, taken, bond, fragment, this_fragment)
   end do
end subroutine find_neighbours

end module xtb_dipro_fragment

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_tblite
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, &
      & test_failed, skip_test
   use xtb_mctc_accuracy, only : wp
   use xtb_features, only : get_xtb_feature
   use xtb_tblite_calculator, only : TTBLiteCalculator, TTBLiteInput, newTBLiteCalculator, &
      & newTBLiteWavefunction
   implicit none
   private

   public :: collect_tblite

   real(wp),parameter :: thr = 5.0e-8_wp, thrg = 1.0e-6_wp

contains

!> Collect all exported unit tests
subroutine collect_tblite(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("gfn1", test_gfn1), &
      new_unittest("gfn2", test_gfn2), &
      new_unittest("gfn1-mindless", test_gfn2_mindless_basic), &
      new_unittest("gfn2-mindless", test_gfn2_mindless_basic) &
      ]

end subroutine collect_tblite

subroutine test_gfn2(error)
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment

   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,6,6,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00000000000000_wp, 0.00000000000000_wp,-1.79755622305860_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 0.95338756106749_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 3.22281255790261_wp, &
      &-0.96412815539807_wp,-1.66991895015711_wp,-2.53624948351102_wp, &
      &-0.96412815539807_wp, 1.66991895015711_wp,-2.53624948351102_wp, &
      & 1.92825631079613_wp, 0.00000000000000_wp,-2.53624948351102_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 5.23010455462158_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = "none")

   type(TMolecule)    :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TTBLiteCalculator) :: calc

   real(wp) :: energy, sigma(3, 3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   if (.not.get_xtb_feature('tblite')) then
      call skip_test(error, "xtb not compiled with tblite support")
      return
   end if

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newTBLiteCalculator(env, mol, calc, TTBLiteInput(method="gfn2"))
   call newTBLiteWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)
   call check_(error, energy,-8.3824793849585_wp, thr=thr)
   call check_(error, norm2(gradient),0.11544410028854E-01_wp, thr=thrg)
end subroutine test_gfn2


subroutine test_gfn1(error)

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_data
   use xtb_type_restart
   use xtb_type_environment

   type(error_type), allocatable, intent(out) :: error

   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,6,6,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00000000000000_wp, 0.00000000000000_wp, 0.00000000000000_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp,-2.45883087071663_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 2.45883087071663_wp, &
      &-1.23873299308709_wp,-1.23873299308709_wp,-3.52402313872811_wp, &
      & 1.23873299308709_wp, 1.23873299308709_wp,-3.52402313872811_wp, &
      &-1.23873299308709_wp, 1.23873299308709_wp, 3.52402313872811_wp, &
      & 1.23873299308709_wp,-1.23873299308709_wp, 3.52402313872811_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: chk
   type(scc_results) :: res
   type(TTBLiteCalculator) :: calc

   real(wp) :: energy, sigma(3, 3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   if (.not.get_xtb_feature('tblite')) then
      call skip_test(error, "xtb not compiled with tblite support")
      return
   end if

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newTBLiteCalculator(env, mol, calc, TTBLiteInput(method="gfn1"))
   call newTBLiteWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, energy,-8.4156335928615_wp, thr=thr)
   call check_(error, norm2(gradient),0.95790240549503E-02_wp, thr=thrg)

end subroutine test_gfn1


subroutine test_gfn2_mindless_basic(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   type(error_type), allocatable, intent(out) :: error

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TTBLiteCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   real(wp), parameter :: ref_energies(10) = &
      &[-30.348902328339_wp, -24.069929673504_wp, -23.718708414840_wp, &
      & -22.751497890244_wp, -27.735987617741_wp, -18.559531652263_wp, &
      & -33.423246445911_wp, -29.982410709899_wp, -20.549458882257_wp, &
      & -25.648093031152_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.06081938165963_wp, 0.05480379303387_wp, 0.04179957306749_wp, &
      & 0.06932568214054_wp, 0.05133081215262_wp, 0.05897000784363_wp, &
      & 0.04600837003153_wp, 0.06088718433105_wp, 0.05314451272641_wp, &
      & 0.04588800056975_wp]

   if (.not.get_xtb_feature('tblite')) then
      call skip_test(error, "xtb not compiled with tblite support")
      return
   end if

   call init(env)
   do iMol = 2, 10, 2

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newTBLiteCalculator(env, mol, calc, TTBLiteInput(method="gfn2", accuracy=0.01_wp))
      call newTBLiteWavefunction(env, mol, calc, chk)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thrg)

   end do

end subroutine test_gfn2_mindless_basic


subroutine test_gfn1_mindless_basic(error)
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TTBLiteCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   real(wp), parameter :: ref_energies(10) = &
      &[-33.040345103560_wp, -26.858637887392_wp, -25.818131312372_wp, &
      & -24.896623131166_wp, -29.038403257541_wp, -20.596982571512_wp, &
      & -35.754243805311_wp, -33.088749099589_wp, -21.414820157390_wp, &
      & -26.650774557476_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.049510354228196_wp, 0.062164738458454_wp, 0.050970505747783_wp, &
      & 0.089329244570940_wp, 0.049188889391502_wp, 0.059353809155596_wp, &
      & 0.063932193893054_wp, 0.059154356097925_wp, 0.043307936447560_wp, &
      & 0.043009212776427_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[3.4192962150687_wp, 1.6702597448498_wp, 2.4899572196060_wp, &
      & 1.6706491472352_wp, 2.4613273978074_wp, 3.9778768185046_wp, &
      & 2.5370236462819_wp, 1.3590769445407_wp, 4.0816020166740_wp, &
      & 1.3640382002752_wp]

   if (.not.get_xtb_feature('tblite')) then
      call skip_test(error, "xtb not compiled with tblite support")
      return
   end if

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newTBLiteCalculator(env, mol, calc, TTBLiteInput(method="gfn1", accuracy=0.01_wp))
      call newTBLiteWavefunction(env, mol, calc, chk)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn1_mindless_basic

end module test_tblite

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Proxy module to integrate the [tblite] tight-binding framework with xtb
!>
!> [tblite]: https://tblite.readthedocs.io
module xtb_tblite_calculator
   use mctc_env, only : error_type, fatal_error
   use mctc_io, only : structure_type, read_structure, filetype
#if WITH_TBLITE
   use tblite_basis_type, only : basis_type
   use tblite_container, only : container_type
   use tblite_context, only : context_type, context_terminal, escape
   use tblite_external_field, only : electric_field
   use tblite_param, only : param_record
   use tblite_results, only : results_type
   use tblite_spin, only : spin_polarization, new_spin_polarization
   use tblite_solvation, only : new_solvation, solvation_type
   use tblite_wavefunction, only : wavefunction_type, new_wavefunction, sad_guess, eeq_guess
   use tblite_xtb_calculator, only : xtb_calculator, new_xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator, export_gfn2_param
   use tblite_xtb_gfn1, only : new_gfn1_calculator, export_gfn1_param
   use tblite_xtb_ipea1, only : new_ipea1_calculator, export_ipea1_param
   use tblite_xtb_singlepoint, only : xtb_singlepoint
   use tblite_data_spin, only : get_spin_constant
#endif
   use xtb_mctc_accuracy, only : wp
   use xtb_type_calculator, only : TCalculator
   use xtb_type_data
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, assignment(=)
   use xtb_type_restart, only : TRestart
   use xtb_setparam
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_metadynamic
   use xtb_constrainpot
   implicit none
   private

   public :: TTBLiteCalculator, TTBLiteInput, newTBLiteCalculator, newTBLiteWavefunction

   !> Input for tblite library
   type :: TTBLiteInput
      !> Perform a spin-polarized calculation
      logical :: spin_polarized = .false.
      !> Electronic temperature in Kelvin
      real(wp) :: etemp = 300.0_wp
      !> Numerical accuracy
      real(wp) :: accuracy = 1.0_wp
      !> Parameter file to read
      character(len=:), allocatable :: param
      !> Method used for computation
      character(len=:), allocatable :: method
      !> Colorful output
      logical :: color = .false.
   end type TTBLiteInput

   !> Calculator interface for xTB based methods
   type, extends(TCalculator) :: TTBLiteCalculator
      !> Number of spin channels
      integer :: nspin
      !> Electronic temperature in Hartree
      real(wp) :: etemp
      !> Guess for initial wavefunction
      character(len=:), allocatable :: guess
      !> Colorful output
      logical :: color
#if WITH_TBLITE
      !> Instance of tblite calculator
      type(xtb_calculator) :: tblite
      !> Perform a spin-polarized calculation
      logical :: spin_polarized = .false.
#endif
   contains
      !> Perform calculator for a singlepoint
      procedure :: singlepoint
      !> Write information instance
      procedure :: writeInfo
   end type TTBLiteCalculator


   !> Conversion factor from temperature to energy
   real(wp), parameter :: kt = 3.166808578545117e-06_wp

contains


!> Create a new instance of an tblite based xTB calculator
subroutine newTBLiteCalculator(env, mol, calc, input)
   !> Source of the generated errors
   character(len=*), parameter :: source = 'tblite_calculator_newTBLiteCalculator'
   !> Calculation environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol
   !> Instance of the new calculator
   type(TTBLiteCalculator), intent(out) :: calc
   !> Input for calculator settings
   type(TTBLiteInput), intent(in) :: input

#if WITH_TBLITE
   character(len=:), allocatable :: method
   type(error_type), allocatable :: error
   type(structure_type) :: struc
   type(param_record) :: param

   struc = mol

   calc%nspin = merge(2, 1, input%spin_polarized)
   calc%etemp = input%etemp * kt
   calc%guess = "sad"
   calc%accuracy = input%accuracy
   calc%color = input%color
   calc%spin_polarized = input%spin_polarized

   if (allocated(input%param)) then
      call param%load(input%param, error)
      if (.not. allocated(error)) then
         call new_xtb_calculator(calc%tblite, struc, param, error)
      end if
   else
      method = "gfn2"
      if (allocated(input%method)) method = input%method
      select case(method)
      case default
         call fatal_error(error, "Unknown method '"//method//"' requested")
      case("gfn2")
         call new_gfn2_calculator(calc%tblite, struc)
      case("gfn1")
         call new_gfn1_calculator(calc%tblite, struc)
      case("ipea1")
         call new_ipea1_calculator(calc%tblite, struc)
      end select
   end if
   if (allocated(error)) then
      call env%error(error%message, source)
      return
   end if

!   if (allocated(config%efield)) then
!      block
!         class(container_type), allocatable :: cont
!         cont = electric_field(config%efield*vatoau)
!         call calc%tblite%push_back(cont)
!      end block
!   end if
!
   if (calc%spin_polarized) then
      block
         class(container_type), allocatable :: cont
         type(spin_polarization), allocatable :: spin
         real(wp), allocatable :: wll(:, :, :)
         allocate(spin)
         call get_spin_constants(wll, struc, calc%tblite%bas)
         call new_spin_polarization(spin, struc, wll, calc%tblite%bas%nsh_id)
         call move_alloc(spin, cont)
         call calc%tblite%push_back(cont)
      end block
   end if
!
!   if (allocated(config%solvation)) then
!      block
!         class(container_type), allocatable :: cont
!         class(solvation_type), allocatable :: solv
!         call new_solvation(solv, struc, config%solvation, error)
!         if (.not.allocated(error)) then
!            call move_alloc(solv, cont)
!            call calc%tblite%push_back(cont)
!         end if
!      end block
!   end if
!
!   if (allocated(error)) then
!      call env%error(error%message, source)
!      return
!   end if
#else
    call feature_not_implemented(env)
#endif
end subroutine newTBLiteCalculator


!> Create new wavefunction restart data for tblite library
subroutine newTBLiteWavefunction(env, mol, calc, chk)
   !> Source of the generated errors
   character(len=*), parameter :: source = 'tblite_calculator_newTBLiteWavefunction'
   !> Calculation environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol
   !> Instance of the new calculator
   type(TTBLiteCalculator), intent(in) :: calc
   !> Wavefunction data
   type(TRestart), intent(inout) :: chk

#if WITH_TBLITE
   type(structure_type) :: struc
   type(error_type), allocatable :: error

   struc = mol

   associate(wfn => chk%tblite)
      call new_wavefunction(wfn, struc%nat, calc%tblite%bas%nsh, calc%tblite%bas%nao, &
         & calc%nspin, calc%etemp)

      select case(calc%guess)
      case default
         call fatal_error(error, "Unknown starting guess '"//calc%guess//"' requested")
      case("sad")
         call sad_guess(struc, calc%tblite, wfn)
      case("eeq")
         call eeq_guess(struc, calc%tblite, wfn)
      end select
   end associate
   if (allocated(error)) then
      call env%error(error%message, source)
      return
   end if
#else
    call feature_not_implemented(env)
#endif
end subroutine newTBLiteWavefunction


!> Perform calculation for single point
subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)
   !> Source of the generated errors
   character(len=*), parameter :: source = 'tblite_calculator_singlepoint'
   !> Calculator instance
   class(TTBLiteCalculator), intent(inout) :: self
   !> Computational environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol
   !> Wavefunction data
   type(TRestart), intent(inout) :: chk
   !> Print level for IO
   integer, intent(in) :: printlevel
   !> Restart from previous results
   logical, intent(in) :: restart
   !> Total energy
   real(wp), intent(out) :: energy
   !> Molecular gradient
   real(wp), intent(out) :: gradient(:, :)
   !> Strain derivatives
   real(wp), intent(out) :: sigma(:, :)
   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap
   !> Detailed results
   type(scc_results), intent(out) :: results

#if WITH_TBLITE
   type(structure_type) :: struc
   integer :: spin, charge, stat, unit, nspin
   logical :: exist
   type(error_type), allocatable :: error
   type(context_type) :: ctx

   struc = mol
   ctx%unit = env%unit
   ctx%terminal = context_terminal(self%color)

   ! Needed to update atomic charges after reading restart file
   call get_qat_from_qsh(self%tblite%bas, chk%tblite%qsh, chk%tblite%qat)

   call xtb_singlepoint(ctx, struc, self%tblite, chk%tblite, self%accuracy, &
      & energy, gradient, sigma, printlevel)
   if (ctx%failed()) then
      do while(ctx%failed())
         call ctx%get_error(error)
         call env%error(error%message, source)
      end do
      return
   end if

   results%e_total = energy
   results%converged = .true.
   results%dipole = sum(chk%tblite%dpat(:, :, 1), 2) + matmul(struc%xyz, chk%tblite%qat(: ,1))
   results%gnorm = norm2(gradient)

!   if (printlevel > 2) then
!      call ascii_levels(ctx%unit, printlevel, chk%tblite%homo, chk%tblite%emo, &
!         & chk%tblite%focc, 7)
!   end if
#else
    call feature_not_implemented(env)
#endif
end subroutine singlepoint


subroutine writeInfo(self, unit, mol)
   !> Calculator instance
   class(TTBLiteCalculator), intent(in) :: self
   !> Unit for I/O
   integer, intent(in) :: unit
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

#if WITH_TBLITE
#endif
end subroutine writeInfo


#if WITH_TBLITE
subroutine get_qat_from_qsh(bas, qsh, qat)
   type(basis_type), intent(in) :: bas
   real(wp), intent(in) :: qsh(:, :)
   real(wp), intent(out) :: qat(:, :)

   integer :: ish, ispin

   qat(:, :) = 0.0_wp
   !$omp parallel do schedule(runtime) collapse(2) default(none) &
   !$omp reduction(+:qat) shared(bas, qsh) private(ish)
   do ispin = 1, size(qsh, 2)
      do ish = 1, size(qsh, 1)
         qat(bas%sh2at(ish), ispin) = qat(bas%sh2at(ish), ispin) + qsh(ish, ispin)
      end do
   end do
end subroutine get_qat_from_qsh
#endif

#if WITH_TBLITE
subroutine get_spin_constants(wll, mol, bas)
   real(wp), allocatable, intent(out) :: wll(:, :, :)
   type(structure_type), intent(in) :: mol
   type(basis_type), intent(in) :: bas

   integer :: izp, ish, jsh, il, jl

   allocate(wll(bas%nsh, bas%nsh, mol%nid), source=0.0_wp)

   do izp = 1, mol%nid
      do ish = 1, bas%nsh_id(izp)
         il = bas%cgto(ish, izp)%ang
         do jsh = 1, bas%nsh_id(izp)
            jl = bas%cgto(jsh, izp)%ang
            wll(jsh, ish, izp) = get_spin_constant(jl, il, mol%num(izp))
         end do
      end do
   end do
end subroutine get_spin_constants
#endif

#if ! WITH_TBLITE
subroutine feature_not_implemented(env)
   !> Computational environment
   type(TEnvironment), intent(inout) :: env

   call env%error("Compiled without support for tblite library")
end subroutine feature_not_implemented
#endif

end module xtb_tblite_calculator

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_blowsy
contains

pure subroutine blowsy(ity,a,b,n)
   use xtb_mctc_accuracy, only : wp
   implicit none
   ! blow up symmetric or antisymmetric matrix to full size
   integer, intent(in)  :: ity
   integer, intent(in)  :: n
   real(wp),intent(in)  :: a(*)
   real(wp),intent(out) :: b(n,n)
   integer :: ij,i,j
   ! determine if we have an antisymmetric integral

   ij=0
   if (ity.eq.-1) then
      do i=1,n
         do j=1,i-1
            ij=ij+1
            b(j,i)=-a(ij)
            b(i,j)=a(ij)
         enddo
         ij=ij+1
         b(i,i)=0.d0
      enddo
   else
      do i=1,n
         do j=1,i-1
            ij=ij+1
            b(j,i)=a(ij)
            b(i,j)=a(ij)
         enddo
         ij=ij+1
         b(i,i)=a(ij)
      enddo
   endif
end subroutine blowsy
end module xtb_blowsy

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

Subroutine get_schoenflies (n, iat, xyz, sfsym, paramar)
   Use iso_c_binding
   Implicit None
   integer, parameter :: wp = selected_real_kind(15, 307)

   Interface c_interface
      !Interface to c routine for symmetry recognition
      !attypes are Atom types as integers (e.g 6 for Carbon etc...)
      !coord must be ``one dimensional'' sequential(!) arrays of doubles
      !symbol is the recognized schoenflies symbol
      Subroutine schoenflies (natoms, attypes, coord, symbol, paramar) &
            &    bind (C, name="schoenflies")
         Use iso_c_binding
         import
         Implicit None
         Integer (c_int), Intent (In), value :: natoms
         integer(c_int), intent(in) :: attypes(*)
         real(c_double), intent(in) :: coord(3,*)
         Character (kind=c_char), Intent (out)  :: symbol(*)
         real(c_double), intent(in) :: paramar(*)
      End Subroutine schoenflies
   End Interface c_interface

   !Dummy Arguments
   Character (Len=*), target :: sfsym
   Integer, Intent (In)  :: n
   Integer, Intent (In)  :: iat (n)
   Real(wp), Intent (In) :: xyz (3, n)
   Real(wp), Intent (In) :: paramar (11)

   !local variables for passing to c routine:
   Integer (c_int) :: natoms
   Integer (c_int), Allocatable, Dimension (:) :: attypes
   Real (c_double), Allocatable, Dimension (:,:) :: coord
   Real (c_double), Allocatable, Dimension (:) :: c_paramar
   character(kind=c_char) :: symbol(6)

   !local stack:
   Integer :: i

   Allocate (attypes(n))
   Allocate (coord(3,n))
   Allocate (c_paramar(11))

   !now, copy contents
   natoms = n
   attypes = iat
   coord = xyz
   c_paramar = paramar
   symbol = C_NULL_CHAR

   !$omp critical (schoenflies_)
   Call schoenflies (natoms, attypes, coord, symbol, c_paramar)
   !$omp end critical (schoenflies_)

   sfsym = ""
   do i = 1, size(symbol)
      if (symbol(i).eq.c_null_char) exit
      sfsym(i:i) = symbol(i)
   enddo

   !deallocate arrays:
   Deallocate (attypes, coord, c_paramar)
End Subroutine get_schoenflies

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_gfnff_ini

contains

subroutine gfnff_ini(env,pr,makeneighbor,mol,gen,param,topo,accuracy)
      use xtb_mctc_accuracy, only : wp, sp
      use xtb_type_molecule
      use xtb_type_environment, only : TEnvironment
      use xtb_gfnff_param, only : efield, gfnff_thresholds
      use xtb_gfnff_data, only : TGFFData
      use xtb_gfnff_topology, only : TGFFTopology
      use xtb_gfnff_generator, only : TGFFGenerator
      use xtb_gfnff_ini2
      use xtb_gfnff_eg, only : gfnff_dlogcoord
      use xtb_gfnff_mrec, only : mrecgff
      use xtb_gfnff_fraghess
      use xtb_restart
      use xtb_mctc_constants

      implicit none
      character(len=*), parameter :: source = 'gfnff_ini'
!--------------------------------------------------------------------------------------------------
      type(TEnvironment), intent(inout) :: env
      type(TMolecule), intent(in) :: mol   ! # molecule type
      type(TGFFTopology), intent(inout) :: topo
      type(TGFFGenerator), intent(in) :: gen
      type(TGFFData), intent(in) :: param
      real(wp), intent(in) :: accuracy

      logical, intent(in) :: pr            ! print flag
      logical, intent(in) :: makeneighbor  ! make a neigbor list or use existing one?
!--------------------------------------------------------------------------------------------------

      integer ati,atj,atk,i,j,k,l,lin,nn,ii,jj,kk,ll,m,rings,ia,ja,ij,ix,nnn,idum,ip,ji,no,nbi
      integer ineig,jneig,nrot,bbtyp,ringtyp,nn1,nn2,hybi,hybj,pis,ka,nh,jdum,hcalc,nc
      integer ringsi,ringsj,ringsk,ringl,npi,nelpi,picount,npiall,maxtors,rings4,nheav
      integer nm,maxhb,ki,n13,current,ncarbo,mtyp1,mtyp2
      integer ind3(3),sr(20),cr(10,20),niel(86)
      integer qloop_count,nf,nsi,nmet,nhi,nhj,ifrag
      integer hbA,hbH,Bat,atB,Aat,Hat
      integer AHB_nr
      integer bond_hbn
      interface
         integer function itabrow6(i)
            integer i
         end function
      end interface

      real(wp) r0,ff,omega,f1,f2,phi,valijklff,ringf,fcn
      real(wp) shift,dum,dum1,dum2,dum4,qafac,fqq,feta
      real(wp) sumppi,fpi,fxh,fijk,fsrb2,ees
      real(wp) fheavy,fn,eold,fctot,fij
      real(wp) hbpi(2),hbpj(2),sdum3(3)
      real(wp) bstrength
      real(wp) xx(20)
      real(wp) fkl,qreps,fbsmall,bohr

      parameter (bohr=1.0_wp/0.52917726_wp)

      real(wp), parameter :: rabd_cutoff = 13.0_wp

      logical lring,picon,notpicon,bridge,sp3ij,ccij,success
      logical heavy,triple,piat,sp3kl,ex,cnij,frag_charges_known

      integer,allocatable :: btyp(:),imetal(:),nbm(:,:),nbf(:,:)
      integer,allocatable :: itag(:)
      integer,allocatable :: piadr(:),piadr2(:),piadr3(:),piadr4(:)
      integer,allocatable :: itmp(:),sring(:,:),cring(:,:,:)
      integer,allocatable :: ipis(:),pimvec(:),nbpi(:,:),piel(:)
      integer,allocatable :: lin_AHB(:)
      integer,allocatable :: bond_hbl(:,:)
      real(wp),allocatable:: rab  (:)
      real(wp),allocatable:: sqrab(:)
      real(wp),allocatable:: cn   (:)
      real(wp),allocatable:: dcn(:,:,:)
      real(wp),allocatable:: dgam(:), dxi(:)
      real(wp),allocatable:: mchar(:)
      real(wp),allocatable:: rtmp (:)
      real(wp),allocatable:: pbo  (:)
      real(wp),allocatable:: qtmp (:), dqa(:), qah(:)
      real(wp),allocatable:: Api(:,:),S(:,:),Pold(:,:),pibo(:),occ(:),eps(:)
      real(wp),allocatable:: pispop(:),pisea(:),pisip(:),apisave(:,:)
      real(sp),allocatable:: rabd(:,:)

      character(len=255) atmp
      integer  :: ich, err
      real(wp) :: dispthr, cnthr, repthr, hbthr1, hbthr2
      logical :: exitRun

      call gfnff_thresholds(accuracy, dispthr, cnthr, repthr, hbthr1, hbthr2)

      if (pr) then
         write(env%unit,*)
         write(env%unit,'(10x,"entering GFN-FF setup routine... ",i0)') mol%n
      endif

      write(env%unit,*)
      write(env%unit,'(10x,"==================== Thresholds ====================")')
      write(env%unit,'(10x,"CN  :",f12.5)')   cnthr
      write(env%unit,'(10x,"rep :",f12.5)')   repthr
      write(env%unit,'(10x,"disp:",f12.5)')   dispthr
      write(env%unit,'(10x,"HB1 :",f12.5)')   hbthr1
      write(env%unit,'(10x,"HB2 :",f12.5)')   hbthr2
      write(env%unit,*)

      allocate( rab(mol%n*(mol%n+1)/2), source = 0.0d0 )
      allocate( cn(mol%n), source = 0.0d0 )
      allocate( sqrab(mol%n*(mol%n+1)/2), source = 0.0d0 )
      allocate( topo%hyb(mol%n), source = 0 )
      allocate( topo%alphanb(mol%n*(mol%n+1)/2), source = 0.0d0 )
      allocate( rtmp(mol%n*(mol%n+1)/2), source = 0.0d0 )
      allocate( pbo(mol%n*(mol%n+1)/2), source = 0.0d0 )
      allocate( piadr(mol%n), source = 0 )
      allocate( piadr2(mol%n), source = 0 )
      allocate( topo%bpair(mol%n*(mol%n+1)/2), source = 0 )
      allocate( itmp(mol%n), source = 0 )
      allocate( itag(mol%n), source = 0 )
      allocate( sring(20,mol%n), source = 0 )
      allocate( cring(10,20,mol%n), source = 0 )
      allocate( piadr3(mol%n), source = 0 )
      allocate( piadr4(mol%n), source = 0 )
      allocate( qtmp(mol%n), source = 0.0d0 )
      allocate( dxi(mol%n), source = 0.0d0 )
      allocate( dgam(mol%n), source = 0.0d0 )
      allocate( topo%chieeq(mol%n), source = 0.0d0 )
      allocate( topo%gameeq(mol%n), source = 0.0d0 )
      allocate( topo%alpeeq(mol%n), source = 0.0d0 )
      allocate( topo%qa(mol%n), source = 0.0d0 )
      allocate( dqa(mol%n), source = 0.0d0)
      allocate( qah(mol%n), source = 0.0d0 )
      allocate( nbm(20,mol%n), source = 0 )
      allocate( mchar(mol%n), source = 0.0d0 )
      allocate( imetal(mol%n), source = 0 )
      allocate( topo%zetac6(mol%n*(mol%n+1)/2), source = 0.0d0 )
      allocate( topo%xyze0(3,mol%n), source = 0.0d0 )
      allocate( nbf(20,mol%n), source = 0 )

      niel=0
      do i=1,mol%n
         niel(mol%at(i))=niel(mol%at(i))+1
      enddo

      write(env%unit,'(10x,"Pauling EN used:")')
      do i=1,86
         if(niel(i).gt.0) write(env%unit,'(10x,"Z :",i2,"  EN :",f6.2)') i,param%en(i)
      enddo

      dum = sqrt(sum(efield**2))
      write(env%unit,'(10x,"electric field strengths (au):",f6.3)') dum
!     alp = alp *(1.+0.0*dum)

      write(env%unit,*)
      write(env%unit,'(10x," ------------------------------------------------- ")')
      write(env%unit,'(10x,"|           Force Field Initialization            |")')
      write(env%unit,'(10x," ------------------------------------------------- ")')
      write(env%unit,*)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! distances and bonds
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      topo%xyze0 = mol%xyz ! initial geom

      write(env%unit,'(10x,"distances ...")')
      pbo   = 0
      rab   = 0
      sqrab = 0
      do i=1,mol%n
         ati=mol%at(i)
         kk=i*(i-1)/2
         do j=1,i-1
            atj=mol%at(j)
            k=kk+j
            sqrab(k)=(mol%xyz(1,i)-mol%xyz(1,j))**2+(mol%xyz(2,i)-mol%xyz(2,j))**2+(mol%xyz(3,i)-mol%xyz(3,j))**2
            rab(k)  =sqrt(sqrab(k))
            if(rab(k).lt.1.d-3) then
               write(env%unit,*) i,j,ati,atj,rab(k)
               call env%error("Particular close distance present", source)
               exit
            endif
         enddo
      enddo

      call env%check(exitRun)
      if (exitRun) then
         return
      end if

!     Calculate CN and derivative
      allocate(dcn(3,mol%n,mol%n), source = 0.0d0 )
      call gfnff_dlogcoord(mol%n,mol%at,mol%xyz,rab,cn,dcn,cnthr,param) ! dcn needed
      do i=1,mol%n
         dum2=0
         do j=1,mol%n
            dum2=dum2+sqrt(dcn(1,j,i)**2+dcn(2,j,i)**2+dcn(3,j,i)**2)
         enddo
         mchar(i) = exp(-0.005d0*param%en(mol%at(i))**8)*dum2/(cn(i)+1.0d0)     ! estimated metallic character as ratio of av. dCN and CN
                                                                      ! and an EN cut-off function, used in neigbor routinen and for BS estimate
      enddo
      deallocate(dcn)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! neighbor list, hyb and ring info
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      topo%qa = 0
      qloop_count = 0

!111   continue
!  do the loop only if factor is significant
   do while (qloop_count.lt.2.and.gen%rqshrink.gt.1.d-3)

      write(env%unit,'(10x,"----------------------------------------")')
      write(env%unit,'(10x,"generating topology and atomic info file ...")')
      call gfnff_neigh(env,makeneighbor,mol%n,mol%at,mol%xyz,rab,gen%rqshrink, &
         & gen%rthr,gen%rthr2,gen%linthr,mchar,topo%hyb,itag,nbm,nbf,param,topo)

      do i=1,mol%n
         imetal(i)=param%metal(mol%at(i))
         if(topo%nb(20,i).le.4.and.param%group(mol%at(i)).gt.3) imetal(i)=0 ! Sn,Pb,Bi, with small CN are better described as non-metals
      enddo


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! bonds (non bonded directly in EG)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      topo%bpair=0
      do i=1,mol%n
         do j=1,topo%nb(20,i)
            k=topo%nb(j,i)
            topo%bpair(lin(k,i))=1
         enddo
      enddo
      topo%nbond = sum(topo%bpair)
      topo%nbond_blist = topo%nbond
      allocate( topo%blist(2,topo%nbond), source = 0 )
      allocate( btyp(topo%nbond), source = 0 )
      allocate( pibo(topo%nbond), source = 0.0d0 )

      pibo  = -99.
      topo%nbond = 0
      do i=1,mol%n
         kk=i*(i-1)/2
         do j=1,i-1
            k=kk+j
            if ( topo%bpair(k) .eq. 1 ) then  ! bonds
                topo%nbond = topo%nbond +1
                topo%blist(1,topo%nbond)=i
                topo%blist(2,topo%nbond)=j
            endif
         enddo
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Hueckel setup for all first-row sp2 and sp atoms
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! setup list of all possible pi atoms
      k=0
      piadr =0
      piadr2=0
      do i=1,mol%n ! setup loop
         piat =(topo%hyb(i).eq.1.or.topo%hyb(i).eq.2).and.pilist(mol%at(i)) ! sp or sp2 and CNOFS
         kk=0
         do j=1,topo%nb(20,i)
            jj=topo%nb(j,i)
            if(mol%at(i).eq.8.and.mol%at(jj).eq.16.and.topo%hyb(jj).eq.5) then
                                                             piat=.false.
                                                             cycle ! SO3   is not a pi
                                                             endif
            if(topo%hyb(jj).eq.1.or.topo%hyb(jj).eq.2)  kk=kk+1         ! attached to sp2 or sp
         enddo
         picon=kk.gt.0.and.nofs(mol%at(i))                     ! an N,O,F (sp3) on sp2
         if(mol%at(i).eq. 7.and.topo%nb(20,i).gt.3) cycle           ! NR3-X is not a pi
         if(mol%at(i).eq.16.and.topo%hyb(i).eq.5  ) cycle           ! SO3   is not a pi
         if(picon.or.piat) then
            k=k+1
            piadr (k)=i
            piadr2(i)=k
         endif
      enddo
      npiall=k
! make pi neighbor list
      allocate( nbpi(20,npiall),pimvec(npiall), source = 0 )
      nbpi=0
      do i=1,mol%n
         if(piadr2(i).eq.0) cycle
         ii=piadr2(i)
         nbpi(20,ii)=0
         do j=1,topo%nb(20,i)
            k=topo%nb(j,i)
            if(piadr2(k).gt.0)then
               nbpi(20,ii)=nbpi(20,ii)+1
               nbpi(nbpi(20,ii),ii)=piadr2(k)
            endif
         enddo
      enddo

! assign pi atoms to fragments
      call mrecgff(npiall,nbpi,picount,pimvec)
      deallocate(nbpi)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! setup xi correction for EEQ
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      dxi = 0 ! default none
      do i=1,mol%n
         ati=mol%at(i)
         nn =topo%nb(20,i)
         if(nn.eq.0) cycle
         ip =piadr2(i)
         ji =topo%nb(1,i) ! first neighbor
         nh =0
         nm =0
         do j=1,nn
            if(mol%at(topo%nb(j,i)).eq.1)        nh=nh+1
            if(imetal(  topo%nb(j,i) ).ne.0) nm=nm+1
         enddo
!     hydrogen
!        if(ati.eq.1.and.nn.gt.1)                                                 dxi(i)=dxi(i)-nn*0.01
!     boron
         if(ati.eq.5)                                                             dxi(i)=dxi(i)+nh*0.015
!     carbon
         if(ati.eq.6.and.nn.eq.2.and.itag(i).eq.1)                                dxi(i)=-0.15 ! make carbene more negative
!        if(ati.eq.6.and.nn.eq.2)then
!           ki=topo%nb(2,i)
!           if(mol%at(ki).eq.8.and.mol%at(ji).eq.8.and.topo%nb(20,ji).eq.1.and.topo%nb(20,ki).eq.1)then          ! free CO2
!                                                                                 dxi(ki)=0.19 ! lower EN for O
!                                                                                 dxi(ji)=0.19 !  "    "   "  "
!           endif
!        endif
         if(ati.eq.6.and.nn.eq.1.and.mol%at(ji).eq.8.and.topo%nb(20,ji).eq.1)              dxi(ji)=0.15! free CO
!     nitrogen
!        if(ati.eq.7.and.nn.eq.1.and.mol%at(ji).eq.6)                                 dxi(i)=0.00  !CN
!     oxygen / group 6
         if(ati.eq.8.and.nn.eq.1.and.ip.ne.0.and.mol%at(ji).eq.7.and.piadr2(ji).ne.0) dxi(i)= 0.05    ! nitro oxygen, otherwise NO2 HBs are too strong
         if(ati.eq.8.and.nn.eq.2.and.nh.eq.2)                                     dxi(i)=-0.02    ! H2O
         if(param%group(ati).eq.6.and.nn.gt.2)                                          dxi(i)=dxi(i)+nn*0.005! good effect
         if(ati.eq.8.or.ati.eq.16)                                                dxi(i)=dxi(i)-nh*0.005
!    fluorine / group 7
         if(param%group(ati).eq.7.and.ati.gt.9.and.nn.gt.1) then ! polyvalent Cl,Br ...
                                         if(nm.eq.0)then
                                                                                  dxi(i)=dxi(i)-nn*0.021! good effect
                                         else
                                                                                  dxi(i)=dxi(i)+nn*0.05 ! good effect for TMs
                                         endif
         endif
      enddo

!     prepare EEQ xi ATOMIC parameter
!     at this point for the non-geom. dep. charges qa with CN = nb
      do i=1,mol%n
         ati=mol%at(i)
         dum =min(dble(topo%nb(20,i)),gen%cnmax)  ! limits it
!                   base val  spec. corr.    CN dep.
         topo%chieeq(i)=-param%chi(ati) + dxi(i) + param%cnf(ati)*sqrt(dum)
         topo%gameeq(i)= param%gam(ati)
         if(imetal(i).eq.2)then           ! the "true" charges for the TM metals are small (for various reasons)
            topo%chieeq(i)=topo%chieeq(i)-gen%mchishift ! so take for the non-geom. dep. ones less electronegative metals yield more q+
         endif                            ! which reflect better the true polarity used for guessing various
                                          ! potential terms. The positive effect of this is big.
         topo%alpeeq(i)= param%alp(ati)**2
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! topology based charges
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      write(env%unit,'(10x,"pair mat ...")')
      call nbondmat(mol%n,topo%nb,topo%bpair)  ! get number of cov. bonds between atoms up to 4 bonds
      write(env%unit,'(10x,"computing topology distances matrix with Floyd-Warshall algo ...")')
      allocate( rabd(mol%n,mol%n), source = 0.0e0_sp)
      rabd = rabd_cutoff
!     determine topology distances by Floyd-Warshall algo
!     they are used in the EEQ to determine qa (approximate topology charges)
      do i = 1, mol%n
        rabd(i, i) = 0.0
        do j = 1, topo%nb(20, i)
           k=topo%nb(j,i)
           rabd(k, i) = param%rad(mol%at(i)) + param%rad(mol%at(k))
           rabd(i, k) = rabd(k, i)
        end do
      end do
      do k = 1, mol%n
      do i = 1, mol%n
         if (rabd(i, k) > gen%tdist_thr) cycle
         do j = 1, mol%n
            if (rabd(k, j) >  gen%tdist_thr) cycle
            if (rabd(i, j) > (rabd(i, k) + rabd(k, j))) then
                rabd(i, j) =  rabd(i, k) + rabd(k, j)
            end if
         end do
      end do
      end do

      do i=1,mol%n
         do j=1,i-1
            ij=lin(j,i)
            if(rabd(j,i).gt.gen%tdist_thr) rabd(j,i)=rabd_cutoff ! values not properly considered
            rtmp(ij) = gen%rfgoed1* rabd(j,i) / 0.52917726d0
         enddo
      enddo
      deallocate(rabd)

      frag_charges_known=.false.
      write(env%unit,'(10x,"making topology EEQ charges ...")')
      if(topo%nfrag.le.1) then                           ! nothing is known
!     first check for fragments
      call mrecgff(mol%n,nbf,topo%nfrag,topo%fraglist)
      write(env%unit,'(10x,"#fragments for EEQ constrain: ",i0)') topo%nfrag
!     read QM info if it exists
      call open_file(ich, 'charges', 'r')
      if (ich /= -1) then
         qtmp = 0
         err = 0
         i = 0
         do while(err == 0)
            read(ich,*,iostat=err) dum
            if (err /= 0) exit
            if (i < mol%n) then
               i = i+1
               qtmp(topo%fraglist(i))=qtmp(topo%fraglist(i))+dum
            else
               call env%warning("More charges than atoms present, assuming missmatch", source)
               err = 1
            end if
         enddo
         if (is_iostat_end(err) .and. i == mol%n) err = 0
         call close_file(ich)
         if (err == 0) then
            if (i < mol%n .or. abs(sum(qtmp) - mol%chrg) > 1.0e-3_wp) then
               call env%warning("Rejecting external charges input due to missmatch", source)
            else
               topo%qfrag=dnint(qtmp)
               write(env%unit,'(10x,"fragment charges from <charges> :",10F7.3)') topo%qfrag(1:topo%nfrag)
            end if
         else
            call env%warning("Could not initialize fragment charges from file", source)
         endif

         call env%check(exitRun)
         if (exitRun) then
            return
         end if
      endif
      if(mol%n.lt.100.and.topo%nfrag.gt.2.and.mol%chrg.ne.0.and.sum(topo%qfrag(2:topo%nfrag)).gt.999) then
         itmp=0
         do i=1,mol%n
            itmp(topo%fraglist(i))=itmp(topo%fraglist(i))+1
         enddo
         do i=1,topo%nfrag
            write(env%unit,*)i,itmp(i)
         enddo
         call env%error('fragment charge input required', source)
         return
      endif
      if(mol%n.ge.100.and.topo%nfrag.gt.2.and.mol%chrg.ne.0.and.sum(topo%qfrag(2:topo%nfrag)).gt.999) then
         topo%qfrag(1)=mol%chrg
         topo%qfrag(2:topo%nfrag)=0
      endif
      if(topo%nfrag.eq.2.and.mol%chrg.ne.0.and.sum(topo%qfrag(2:topo%nfrag)).gt.999) then
         write(env%unit,*) 'trying auto detection of charge on 2 fragments:'
         topo%qfrag(1)=0
         topo%qfrag(2)=mol%chrg
         call goedeckera(env,mol%n,mol%at,topo%nb,rtmp,topo%qa,dum1,topo)
         call env%check(exitRun)
         if (exitRun) then
            call env%error("Failed to generate charges", source)
            return
         end if
         topo%qfrag(2)=0
         topo%qfrag(1)=mol%chrg
         call goedeckera(env,mol%n,mol%at,topo%nb,rtmp,topo%qa,dum2,topo)
         call env%check(exitRun)
         if (exitRun) then
            call env%error("Failed to generate charges", source)
            return
         end if
         if(dum1.lt.dum2) then
            topo%qfrag(1)=0
            topo%qfrag(2)=mol%chrg
         endif
         write(env%unit,*) 'dEes      :',dum1-dum2
         write(env%unit,*) 'charge 1/2:',topo%qfrag(1:2)
      endif
      else if (allocated(mol%pdb)) then ! frag_charges_known
         write(env%unit,'(10x,"#fragments for EEQ constrain from pdb file: ",i0)') topo%nfrag
         frag_charges_known=.true.
      endif

!     make estimated, topology only EEQ charges from rabd values, including "right" fragment charge
      call goedeckera(env,mol%n,mol%at,topo%nb,rtmp,topo%qa,ees,topo)
      call env%check(exitRun)
      if (exitRun) then
         call env%error("Failed to generate charges", source)
         return
      end if

!     estimate how much of the frag charge is on the pi sub systems
      if(picount.gt.0.and.qloop_count.gt.0) then
         allocate( ipis(picount), source = 0 )
         if(frag_charges_known) then                        ! PDB case
         ipis = 0
         do pis=1,picount ! loop over pi systems
            do k=1,npiall
               if(pimvec(k).eq.pis) then
                  ipis(pis)=ipis(pis)+topo%qpdb(piadr(k))
                  topo%qpdb(piadr(k))=0
               endif
            enddo
         enddo
         else                                               ! general case
         qtmp = topo%qa ! save the "right" ones
         qah  = topo%qa
         call qheavy(mol%n,mol%at,topo%nb,qah) ! heavy atoms only ie H condensed to neighbor
         do pis=1,picount ! loop over pi systems
            do k=1,npiall
               if(pimvec(k).eq.pis) then
                  kk=piadr(k)
                  ifrag=topo%fraglist(kk) !the pi atom of this pi fragment is in EEQ fragment ifrag
                  exit
               endif
            enddo
            dum2=topo%qfrag(ifrag) ! save
            topo%qfrag(ifrag) = 0 ! make only this EEQ fragment neutral
            call goedeckera(env,mol%n,mol%at,topo%nb,rtmp,topo%qa,ees,topo) ! for neutral
            call env%check(exitRun)
            if (exitRun) then
               call env%error("Failed to generate charges", source)
               return
            end if
            topo%qfrag(ifrag) = dum2 ! back
            call qheavy(mol%n,mol%at,topo%nb,topo%qa)
            dqa =qah-topo%qa ! difference charges upon ionization
            dum1=0
            dum=0
            do k=1,npiall
               if(pimvec(k).eq.pis) dum=dum+dqa(piadr(k)) ! only pi atoms
            enddo
            dum = dum * 1.1 !charges tend to be slightly too small 1.1-1.2
            ipis(pis)=idnint(dum)
            dum1=dum1+dum
         enddo
         topo%qa = qtmp ! put "right" charges used in FF construction and for HB/XB in place
         endif
      endif

      if(qloop_count.eq.0) itmp(1:mol%n)=topo%nb(20,1:mol%n)
      qloop_count=qloop_count+1
      if(qloop_count.lt.2.and.gen%rqshrink.gt.1.d-3) then  ! do the loop only if factor is significant

         deallocate(topo%blist,btyp,pibo,pimvec)
!         goto 111
      endif
   end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! change EEQ J with estimated q
! which is a kind of third-order term
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      do i=1,mol%n
         ff=0                           ! do nothing
         if(mol%at(i).eq. 1)                 ff=-0.08 ! H
         if(mol%at(i).eq. 5)                 ff=-0.05 ! B
         if(mol%at(i).eq. 6)                 then
                                         ff=-0.27 ! C
                         if(topo%hyb(i).lt.3) ff=-0.45 ! unsat
                         if(topo%hyb(i).lt.2) ff=-0.34 ! unsat
         endif
         if(mol%at(i).eq. 7)                 then
                                         ff=-0.13 ! N
           if(piadr(i).ne.0)             ff=-0.14
           if(amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,i))ff=-0.16
         endif
         if(mol%at(i).eq. 8)                 then
                                         ff=-0.15 ! O
                         if(topo%hyb(i).lt.3) ff=-0.08 ! unsat
         endif
         if(mol%at(i).eq. 9)                 ff= 0.10 ! F
         if(mol%at(i).gt.10)                 ff=-0.02 ! heavy
         if(mol%at(i).eq.17)                 ff=-0.02 ! Cl
         if(mol%at(i).eq.35)                 ff=-0.11 ! Br
         if(mol%at(i).eq.53)                 ff=-0.07 ! I
         if(imetal(i).eq.1)              ff=-0.08 ! M maing
         if(imetal(i).eq.2)              ff=-0.9  ! M TM    ??? too large
         if(param%group(mol%at(i)).eq.8)           ff= 0.0  ! RG
         dgam(i)=topo%qa(i)*ff
      enddo

!     prepare true EEQ parameter, they are ATOMIC not element specific!
      do i=1,mol%n
!                   base val   spec. corr.
         topo%chieeq(i)=-param%chi(mol%at(i)) + dxi(i)
         topo%gameeq(i)= param%gam(mol%at(i)) +dgam(i)
         if (amideH(mol%n,mol%at,topo%hyb,topo%nb,piadr2,i)) topo%chieeq(i) = topo%chieeq(i) - 0.02
         ff = 0
         if(mol%at(i).eq.6)       ff= 0.09
         if(mol%at(i).eq.7)       ff=-0.21
         if(param%group(mol%at(i)).eq.6)ff=-0.03
         if(param%group(mol%at(i)).eq.7)ff= 0.50
         if(imetal(i).eq.1)   ff= 0.3
         if(imetal(i).eq.2)   ff=-0.1
         topo%alpeeq(i) = (param%alp(mol%at(i))+ff*topo%qa(i))**2
      enddo
      deallocate(dgam,dxi)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! get ring info (smallest ring size)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      write(env%unit,'(10x,"rings ...")')
!$omp parallel default(none) private(i,cr,sr) shared(mol,nbm,cring,sring)
!$omp do
      do i=1,mol%n
         call getring36(mol%n,mol%at,nbm,i,cr,sr)
         cring(1:10,1:20,i)=cr(1:10,1:20)
         sring(     1:20,i)=sr(1:20)
      enddo
!$omp end do
!$omp end parallel
      deallocate(nbm)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! bonded atom triples not included in
! bend and tors
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      idum=1000*mol%n
      allocate( topo%b3list(3,idum), source = 0 )
      topo%nbatm=0
      do i=1,mol%n
         do j=1,i-1
            ij=lin(j,i)
            if(topo%bpair(ij).eq.3) then  ! 1,4 exclusion of back-pair makes it worse, 1,3 makes little effect
            do m=1,topo%nb(20,j)
               k=topo%nb(m,j)
               topo%nbatm=topo%nbatm+1
               topo%b3list(1,topo%nbatm)=i
               topo%b3list(2,topo%nbatm)=j
               topo%b3list(3,topo%nbatm)=k
            enddo
            do m=1,topo%nb(20,i)
               k=topo%nb(m,i)
               topo%nbatm=topo%nbatm+1
               topo%b3list(1,topo%nbatm)=i
               topo%b3list(2,topo%nbatm)=j
               topo%b3list(3,topo%nbatm)=k
            enddo
            endif
         enddo
      enddo
      if(topo%nbatm.gt.idum) then
         write(env%unit,*) idum,topo%nbatm
         call env%error('overflow in ini', source)
         return
      endif
      write(env%unit,'(10x,"# BATM",3x,i0)') topo%nbatm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! non bonded pair exponents
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      do i=1,mol%n
         ati=mol%at(i)
         fn=1.0d0 + gen%nrepscal/(1.0d0+dble(topo%nb(20,i))**2)
         dum1=param%repan(ati)*(1.d0 + topo%qa(i)*gen%qrepscal)*fn ! a small but physically correct decrease of repulsion with q
         f1=zeta(ati,topo%qa(i))
         do j=1,i-1
            atj=mol%at(j)
            fn=1.0d0 + gen%nrepscal/(1.0d0+dble(topo%nb(20,j))**2)
            dum2=param%repan(atj)*(1.d0 + topo%qa(j)*gen%qrepscal)*fn
            f2=zeta(atj,topo%qa(j))
            ij=lin(j,i)
            ff = 1.0d0
            if(ati.eq.1.and.atj.eq.1) then
               ff = 1.0d0*gen%hhfac                     ! special H ... H case (for other pairs there is no good effect of this)
               if(topo%bpair(ij).eq.3) ff=ff*gen%hh14rep     ! 1,4 case important for right torsion pot.
               if(topo%bpair(ij).eq.2) ff=ff*gen%hh13rep     ! 1,3 case
            endif
            if((ati.eq.1.and.param%metal(atj).gt.0).or.(atj.eq.1.and.param%metal(ati).gt.0)) ff=0.85 ! M...H
            if((ati.eq.1.and.atj.eq.6).or.(atj.eq.1.and.ati.eq.6))               ff=0.91 ! C...H, good effect
            if((ati.eq.1.and.atj.eq.8).or.(atj.eq.1.and.ati.eq.8))               ff=1.04 ! O...H, good effect
            topo%alphanb(ij)=sqrt(dum1*dum2)*ff
            topo%zetac6(ij)=f1*f2  ! D4 zeta scaling using qref=0
         enddo
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! make list of HB donor bascity
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      !atom specific (not element) basicity parameters
      allocate( topo%hbbas(mol%n), source =1.0d0 )
      do i = 1,mol%n
         nn=topo%nb(20,i)
         ati=mol%at(i)
         topo%hbbas(i)=param%xhbas(mol%at(i))
         ! Carbene:
         if(ati.eq.6.and.nn.eq.2.and.itag(i).eq.1) topo%hbbas(i) = 1.46
         ! Carbonyl R-C=O
         if(ati.eq.8.and.nn.eq.1.and.mol%at(topo%nb(nn,i)).eq.6) topo%hbbas(i) = 0.68
         ! Nitro R-N=O
         if(ati.eq.8.and.nn.eq.1.and.mol%at(topo%nb(nn,i)).eq.7) topo%hbbas(i) = 0.47
      end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! make list of HB donor acidity
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      !atom specific (not element) basicity parameters
      allocate( topo%hbaci(mol%n), source =1.0d0 )
      do i = 1,mol%n
         topo%hbaci(i)=param%xhaci(mol%at(i))
      end do
      do i = 1,mol%n
         nn=topo%nb(1,i)
         topo%hbaci(i)=param%xhaci(mol%at(i))
         ! AmideH:
         if (amideH(mol%n,mol%at,topo%hyb,topo%nb,piadr2,i)) topo%hbaci(nn) = topo%hbaci(nn) * 0.80
      end do

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! make list of ABs for HAB
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      allocate( topo%hbatHl(mol%n),topo%hbatABl(2,mol%n*(mol%n+1)/2), source = 0 )

      topo%nathbH=0
      do i=1,mol%n
         if(mol%at(i).ne.1)  cycle
         if(topo%hyb(i).eq.1) cycle      ! exclude bridging hydrogens from HB correction
         ff=gen%hqabthr
         j=topo%nb(1,i)
         if(j.le.0) cycle
         if(mol%at(j).gt.10) ff=ff-0.20                ! H on heavy atoms may be negatively charged
         if(mol%at(j).eq.6.and.topo%hyb(j).eq.3) ff=ff+0.05 ! H on sp3 C must be really positive 0.05
         if(topo%qa(i).gt.ff)then                       ! make list of HB H atoms but only if they have a positive charge
            topo%nathbH=topo%nathbH+1
            topo%hbatHl(topo%nathbH)=i
         endif
      enddo
      write(env%unit,'(10x,"# H in HB",3x,i0)') topo%nathbH

      topo%nathbAB=0
      do i=1,mol%n
         if(mol%at(i).eq. 6.and.piadr2(i).eq.0) cycle ! C sp or sp2 pi
         ff=gen%qabthr
         if(mol%at(i).gt.10) ff=ff+0.2   ! heavy atoms may be positively charged
         if(topo%qa(i).gt.ff) cycle
         do j=1,i-1
            ff=gen%qabthr
            if(mol%at(j).gt.10) ff=ff+0.2  ! heavy atoms may be positively charged
            if(topo%qa(j).gt.ff) cycle
            call hbonds(i,j,hbpi,hbpj,param,topo)
            if(hbpi(1)*hbpj(2).lt.1.d-6.and.hbpi(2)*hbpj(1).lt.1.d-6)cycle
            if(mol%at(j).eq. 6.and.piadr2(j).eq.0) cycle ! C sp or sp2 pi
            topo%nathbAB = topo%nathbAB + 1
            topo%hbatABl(1,topo%nathbAB)=i
            topo%hbatABl(2,topo%nathbAB)=j
         enddo
      enddo

! make ABX list
      m=0
      do i=1,mol%n
         do ia=1,topo%nb(20,i)
            ix=topo%nb(ia,i)
            if(xatom(mol%at(ix))) then
            if(mol%at(ix).eq.16.and.topo%nb(20,ix).gt.2) cycle ! no sulphoxide etc S
            do j=1,mol%n
               if(i.eq.j.or.j.eq.ix) cycle
               if(topo%bpair(lin(j,ix)).le.3) cycle   ! must be A...B and not X-B i.e. A-X...B
               if(param%xhbas(mol%at(j)).lt.1.d-6) cycle   ! B must be O,N,...
               if(param%group(mol%at(j)).eq.4    ) then
                  if(piadr2(j).eq.0.or.topo%qa(j).gt.0.05) cycle   ! must be a (pi)base
               endif
               m=m+1
            enddo
            endif
         enddo
      enddo
      topo%natxbAB=m
      allocate(topo%xbatABl(3,topo%natxbAB), source = 0 )
      m=0
      do i=1,mol%n
         do ia=1,topo%nb(20,i)
            ix=topo%nb(ia,i)
            if(xatom(mol%at(ix))) then
            if(mol%at(ix).eq.16.and.topo%nb(20,ix).gt.2) cycle ! no sulphoxide etc S
            do j=1,mol%n
               if(i.eq.j.or.j.eq.ix) cycle
               if(topo%bpair(lin(j,ix)).le.3) cycle  ! must be A...B and not X-B i.e. A-X...B
               if(param%xhbas(mol%at(j)).lt.1.d-6) cycle  ! B must be O,N,...
               if(param%group(mol%at(j)).eq.4    ) then
                  if(piadr2(j).eq.0.or.topo%qa(j).gt.0.05) cycle   ! must be a (pi)base
               endif
               m=m+1
               topo%xbatABl(1,m)=i
               topo%xbatABl(2,m)=j
               topo%xbatABl(3,m)=ix
            enddo
            endif
         enddo
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! do Hueckel
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      if(picount.gt.0) then
      write(env%unit,'(10x,"doing iterative Hueckel for ",i0," subsystem(s) ...")') picount
      allocate( pispop(picount),pisip(picount),pisea(picount), source = 0.0d0 )
      allocate( piel(mol%n), source = 0 )
      itmp = 0 ! save pi atom info
      hcalc= 0
      pisip= 0
      pisea= 0

      if(pr) then
         write(env%unit,'(10x,"iterative Hueckel run to get P ...")')
      endif
      do pis=1,picount ! loop over pi systems
      npi   =0
      nelpi =0
      piadr3=0
      piadr4=0
      piel  =0

      do k=1,npiall
         if(pimvec(k).eq.pis) then
            npi=npi+1
            ati =mol%at (piadr(k))
            hybi=topo%hyb(piadr(k))
            ii  =nelpi
            if(ati.eq.5.and.hybi.eq.1)           nelpi=nelpi+1  ! B in borine
            if(ati.eq.6.and.itag(piadr(k)).ne.1) nelpi=nelpi+1  ! skip if its a carbene (tag itag=1)
            if(ati.eq.7.and.hybi.eq.2.and.itag(piadr(k)).eq.1) &
     &                                           nelpi=nelpi+1  ! the itag=1 avoids an odd el number for the nitro group (its 4)
            if(ati.eq.7.and.hybi.le.2)           nelpi=nelpi+1
            if(ati.eq.7.and.hybi.eq.3)           nelpi=nelpi+2
            if(ati.eq.8.and.hybi.eq.1)           nelpi=nelpi+1
            if(ati.eq.8.and.hybi.eq.2)           nelpi=nelpi+1
            if(ati.eq.8.and.hybi.eq.3)           nelpi=nelpi+2
            if(ati.eq.9.and.hybi.ne.1)           nelpi=nelpi+2
            if(ati.eq.9.and.hybi.eq.1)           nelpi=nelpi+3 !??? otherwise fluor-furan+ is wrong
            if(ati.eq.16.and.hybi.eq.1)          nelpi=nelpi+1
            if(ati.eq.16.and.hybi.eq.2)          nelpi=nelpi+1
            if(ati.eq.16.and.hybi.eq.3)          nelpi=nelpi+2
            if(ati.eq.17.and.hybi.eq.0)          nelpi=nelpi+2
            if(ati.eq.17.and.hybi.eq.1)          nelpi=nelpi+3
            piadr3(npi)=piadr(k) ! map to original, full atom set
            piadr4(piadr(k))=npi
            piel(piadr(k))=nelpi-ii
            if(piel(piadr(k)).gt.2)piel(piadr(k))=2
         endif
      enddo
      nelpi=nelpi-ipis(pis)
      if(npi.lt.2.or.nelpi.lt.1) cycle
      allocate(Api(npi,npi),apisave(npi,npi),Pold(npi,npi),S(npi,npi),occ(npi),eps(npi)) ! S is just scratch here

      eold= 0
      Pold= 2.d0/3.d0
! iterative Hueckel loop, off-diag terms are reduced depending on P to avoid overdelocalization
      do nn=1,nint(gen%maxhiter)      ! just some iterations
      Api = 0
      do i=1,npi
         ii=piadr3(i)
         Api(i,i)=gen%hdiag(mol%at(ii))+topo%qa(ii)*gen%hueckelp3-dble(piel(ii)-1)*gen%pilpf
      enddo
!     loop over bonds for pair interactions
      do i=1,topo%nbond
         ii=topo%blist(1,i)
         jj=topo%blist(2,i)
         ia=piadr4(ii)
         ja=piadr4(jj)
         if(ia.gt.0.and.ja.gt.0) then
            dum=1.d-9*rab(lin(ii,jj))                                 ! distort so that Huckel for e.g. COT localizes to right bonds
            dum=sqrt(gen%hoffdiag(mol%at(ii))*gen%hoffdiag(mol%at(jj)))-dum           ! better than arithmetic
            dum2=gen%hiter
            if(topo%hyb(ii).eq.1)                 dum2=dum2*gen%htriple        ! triple bond is different
            if(topo%hyb(jj).eq.1)                 dum2=dum2*gen%htriple        ! triple bond is different
            Api(ja,ia)=-dum  * (1.0d0-dum2*(2.0d0/3.0d0-Pold(ja,ia))) ! Pmat scaling with benzene as reference
            Api(ia,ja)=Api(ja,ia)
         endif
      enddo

      apisave = Api
      call gfnffqmsolve(.false.,Api,S,.false.,4000.0d0,npi,0,nelpi,dum,occ,eps)  !diagonalize, 4000 better than 300

      do i=1,npi  ! save IP/EA
         if(occ(i).gt.0.5) then
                       pisip(pis)=eps(i)   ! IP
         if(i+1.lt.npi)pisea(pis)=eps(i+1) ! EA
         endif
      enddo
      if(abs(dum-eold).lt.1.d-4) exit  ! end of iterations
      Pold = Api
      eold = dum
      enddo
! end of iterative loop
      if(pr)then
         write(env%unit,'(''Hueckel system :'',i3,'' charge : '',i3,'' ndim/Nel :'',2i5, &
     &         3x, ''eps(HOMO/LUMO)'',2f12.6)')pis,ipis(pis),npi,nelpi,pisip(pis),pisea(pis)
      end if
      if(pisip(pis).gt.0.40) then
         write(env%unit,'(a,i0,a)')'WARNING: probably wrong pi occupation for system ',pis,'. Second attempt with Nel=Nel-1!'
         do i=1,mol%n
            if(piadr4(i).ne.0) write(env%unit,*) 'at,nb,topo%hyb,Npiel:', i,mol%sym(i),topo%nb(20,i),topo%hyb(i),piel(i)
         enddo
         nelpi=nelpi-1
         Api = Apisave
         call gfnffqmsolve(.false.,Api,S,.false.,4000.0d0,npi,0,nelpi,dum,occ,eps)  !diagonalize
         call PREIG(6,occ,1.0d0,eps,1,npi)
         do i=1,npi  ! save IP/EA
            if(occ(i).gt.0.5) then
               pisip(pis)=eps(i)   ! IP
               if(i+1.lt.npi)pisea(pis)=eps(i+1) ! EA
            endif
         enddo
      if(pr)then
         write(env%unit,'(''Hueckel system :'',i3,'' charge : '',i3,'' ndim/Nel :'',2i5, &
     &         3x, ''eps(HOMO/LUMO)'',2f12.6)')pis,ipis(pis),npi,nelpi,pisip(pis),pisea(pis)
      end if
      endif
! save BO
      do i=1,topo%nbond
         ii=topo%blist(1,i)
         jj=topo%blist(2,i)
         ia=piadr4(ii)
         ja=piadr4(jj)
         if(ia.gt.0.and.ja.gt.0) then
            pibo(i)=Api(ja,ia)
            pbo(lin(ii,jj))=Api(ja,ia)
            itmp(ii)=1
            itmp(jj)=1
         endif
      enddo
      deallocate(Api,apisave,Pold,S,occ,eps)
      enddo
! end of pi system loop
      piadr = itmp  ! array used for identifying pi atoms in following codes
      deallocate(pispop,pisip,pisea,ipis,pimvec,piel)
      endif
!----------- end Hueckel

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! modify hyb due to pi assignment
! and output
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      do i=1,mol%n
         if(topo%hyb(i).eq.2 .and. piadr(i).eq.0 .and. topo%nb(20,i).eq.3 .and. param%group(mol%at(i)).eq.4)then ! C,Si,Ge... CN=3, no pi
            jj=topo%nb(1,i)
            kk=topo%nb(2,i)
            ll=topo%nb(3,i)
            phi=omega(mol%n,mol%xyz,i,jj,kk,ll)  ! the shitty second geom. dep. term GEODEP
            if(abs(phi)*180./pi.gt.40.d0) topo%hyb(i) = 3  ! change to sp^3
         endif
      enddo

!     if(pr)then
      write(env%unit,*)
      write(env%unit,'(2x,"atom   neighbors  erfCN metchar sp-hybrid imet pi  qest     coordinates")')
      do i=1,mol%n
         j = topo%hyb(i)
         if(amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,i))  j=-topo%hyb(i)
         if(mol%at(i).eq.6.and.itag(i).eq.1) j=-topo%hyb(i)
         write(env%unit,'(i5,2x,a2,3x,i4,3x,f5.2,2x,f5.2,8x,i2,3x,i2,3x,i2,2x,f6.3,3f12.6)') &
     &             i,mol%sym(i),topo%nb(20,i),cn(i),mchar(i),j,imetal(i),piadr(i),topo%qa(i),mol%xyz(1:3,i)
      enddo

!     compute fragments and charges for output (check for CT)
!     call mrecgff(mol%n,topo%nb,nmol,piadr3)
!     write(env%unit,*) 'Nmol',nmol
      if(pr)then
      write(env%unit,'(/,''molecular fragment  # atoms  topo charge'')')
      do i=1,topo%nfrag
         dum=0
           m=0
         do k=1,mol%n
            if(topo%fraglist(k).eq.i) then
               m=m+1
               dum=dum+topo%qa(k)
            endif
         enddo
         write(env%unit,'(5x,i3,10x,i4,10x,f8.3)')i,m,dum
      enddo
      write(env%unit,*)
      endif


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!            bonds
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      call gfnffrab(mol%n,mol%at,cn,rtmp)           ! guess RAB for output

      topo%nbond_vbond = topo%nbond
      allocate( topo%vbond(3,topo%nbond), source = 0.0d0 )

      write(env%unit,*)
      write(env%unit,'(10x,"#atoms :",3x,i0)') mol%n
      write(env%unit,'(10x,"#bonds :",3x,i0)') topo%nbond
      if(pr)then
      write(env%unit,*)
      write(env%unit,*) 'bond atoms        type  in ring    R      R0    piBO    fqq  kbond(tot)  alp'
      endif

      do i=1,topo%nbond
         ii=topo%blist(1,i)
         jj=topo%blist(2,i)
         ij=lin(ii,jj)
         ia=mol%at(ii)
         ja=mol%at(jj)
         call ringsbond(mol%n,ii,jj,cring,sring,rings)
         shift =0.d0
         fxh   =1.d0
         ringf =1.d0
         fqq   =1.d0
         fpi   =1.d0
         fheavy=1.d0
         fheavy=1.d0
         fcn   =1.d0
         fsrb2 =gen%srb2
         bridge=.false.
         shift =0.d0
! assign bond type
                                                                  btyp(i)=1 ! single
         if(topo%hyb(ii).eq.2.and.topo%hyb(jj).eq.2)                        btyp(i)=2 ! sp2-sp2 = pi
         if(topo%hyb(ii).eq.3.and.topo%hyb(jj).eq.2.and.ia.eq.7)            btyp(i)=2 ! N-sp2
         if(topo%hyb(jj).eq.3.and.topo%hyb(ii).eq.2.and.ja.eq.7)            btyp(i)=2 ! N-sp2
         if(topo%hyb(ii).eq.1.or. topo%hyb(jj).eq.1)                        btyp(i)=3 ! sp-X i.e. no torsion
         if((param%group(ia).eq.7.or.ia.eq.1).and.topo%hyb(ii).eq.1)then
                                                                  btyp(i)=3 ! linear halogen i.e. no torsion
                                                                  bridge=.true.
         endif
         if((param%group(ja).eq.7.or.ja.eq.1).and.topo%hyb(jj).eq.1)then
                                                                  btyp(i)=3 ! linear halogen i.e. no torsion
                                                                  bridge=.true.
         endif
         if(topo%hyb(ii).eq.5.or. topo%hyb(jj).eq.5)                        btyp(i)=4 ! hypervalent
         if(imetal(ii).gt.0.or.imetal(jj).gt.0)                   btyp(i)=5 ! metal
         if(imetal(ii).eq.2.and.imetal(jj).eq.2)                  btyp(i)=7 ! TM metal-metal
         if(imetal(jj).eq.2.and.itag(ii).eq.-1.and.piadr(ii).gt.0)btyp(i)=6 ! eta
         if(imetal(ii).eq.2.and.itag(jj).eq.-1.and.piadr(jj).gt.0)btyp(i)=6 ! eta
         bbtyp=btyp(i)
! normal bond
         if(bbtyp.lt.5)then
            hybi=max(topo%hyb(ii),topo%hyb(jj))
            hybj=min(topo%hyb(ii),topo%hyb(jj))
            if(hybi.eq.5.or.hybj.eq.5) then
            bstrength=gen%bstren(4)                                       ! base value hypervalent
            else
            bstrength=gen%bsmat(hybi,hybj)                                ! base value normal hyb
            endif
            if(hybi.eq.3.and.hybj.eq.2.and.(ia.eq.7.or.ja.eq.7)) &
     &                                      bstrength=gen%bstren(2)*1.04   ! N-sp2

            if(bridge)then
               if(param%group(ia).eq.7)           bstrength=gen%bstren(1)*0.50d0 ! bridging X
               if(param%group(ja).eq.7)           bstrength=gen%bstren(1)*0.50d0 ! bridging X
               if(ia.eq.1.or.ia.eq.9)       bstrength=gen%bstren(1)*0.30d0 ! bridging H/F
               if(ja.eq.1.or.ja.eq.9)       bstrength=gen%bstren(1)*0.30d0 ! bridging H/F
            endif
            if(bbtyp.eq.4)                  shift=gen%hyper_shift          ! hypervalent
            if(ia.eq.1.or.ja.eq.1)          shift=gen%rabshifth            ! XH
            if(ia.eq.9.and.ja.eq.9)         shift=0.22                 ! f2
            if(topo%hyb(ii).eq.3.and.topo%hyb(jj).eq.0)shift=shift-0.022         ! X-sp3
            if(topo%hyb(ii).eq.0.and.topo%hyb(jj).eq.3)shift=shift-0.022         ! X-sp3
            if(topo%hyb(ii).eq.1.and.topo%hyb(jj).eq.0)shift=shift+0.14          ! X-sp
            if(topo%hyb(ii).eq.0.and.topo%hyb(jj).eq.1)shift=shift+0.14          ! X-sp
            if( (ia.eq.1.and.ja.eq.6) )then
                           call ringsatom(mol%n,jj,cring,sring,ringsj)
                           if(ringsj.eq.3)                 fxh=1.05    ! 3-ring CH
                           if(ctype(mol%n,mol%at,topo%nb,piadr,jj).eq.1)fxh=0.95    ! aldehyd CH
            endif
            if( (ia.eq.6.and.ja.eq.1) )then
                           call ringsatom(mol%n,ii,cring,sring,ringsi)
                           if(ringsi.eq.3)                 fxh=1.05    ! 3-ring CH
                           if(ctype(mol%n,mol%at,topo%nb,piadr,ii).eq.1)fxh=0.95    ! aldehyd CH
            endif
            if( (ia.eq.1.and.ja.eq.5) )                    fxh=1.10    ! BH
            if( (ja.eq.1.and.ia.eq.5) )                    fxh=1.10    !
            if( (ia.eq.1.and.ja.eq.7) )                    fxh=1.06    ! NH
            if( (ja.eq.1.and.ia.eq.7) )                    fxh=1.06    !
            if( (ia.eq.1.and.ja.eq.8) )                    fxh=0.93    ! OH
            if( (ja.eq.1.and.ia.eq.8) )                    fxh=0.93    !
            if(bbtyp.eq.3.and.ia.eq.6.and.ja.eq.8) bstrength=gen%bstren(3)*0.90d0 ! makes CO right and M-CO reasonable
            if(bbtyp.eq.3.and.ia.eq.8.and.ja.eq.6) bstrength=gen%bstren(3)*0.90d0 !
!           modify locally for triple bonds
            if( bbtyp.eq.3.and. (topo%hyb(ii).eq.0.or.topo%hyb(jj).eq.0) ) bbtyp=1 ! sp-sp3
            if( bbtyp.eq.3.and. (topo%hyb(ii).eq.3.or.topo%hyb(jj).eq.3) ) bbtyp=1 ! sp-sp3
            if( bbtyp.eq.3.and. (topo%hyb(ii).eq.2.or.topo%hyb(jj).eq.2) ) bbtyp=2 ! sp-sp2
!           Pi stuff
            if(pibo(i).gt.0) then
                          shift=gen%hueckelp*(gen%bzref - pibo(i)) ! ref value = no correction is benzene, P=2/3
                          if(bbtyp.ne.3.and.pibo(i).gt.0.1) then
                                                            btyp(i)=2
                                                            bbtyp=2
                          endif
                          fpi=1.0d0-gen%hueckelp2*(gen%bzref2 - pibo(i)) ! deepness
            endif
            if(ia.gt.10.and.ja.gt.10)then
              fcn=fcn/(1.0d0+0.007*dble(topo%nb(20,ii))**2)
              fcn=fcn/(1.0d0+0.007*dble(topo%nb(20,jj))**2)
            endif
            qafac=topo%qa(ii)*topo%qa(jj)*70.0d0
            fqq=1.0d0+gen%qfacbm0*exp(-15.d0*qafac)/(1.0d0+exp(-15.d0*qafac))
! metal involed
         else
            shift=0
            bstrength=gen%bstren(bbtyp)
            if(bbtyp.eq.7)then ! TM-TM
               if(itabrow6(ia).gt.4.and.itabrow6(ja).gt.4) bstrength=gen%bstren(8) ! 4/5d-4/5d
               if(itabrow6(ia).eq.4.and.itabrow6(ja).gt.4) bstrength=gen%bstren(9) ! 3d-4/5d
               if(itabrow6(ja).eq.4.and.itabrow6(ia).gt.4) bstrength=gen%bstren(9) ! 3d-4/5d
               dum=2.0d0*mchar(ii)+2.0d0*mchar(jj)
               dum=min(dum,0.5d0)  ! limit the "metallic" correction
               bstrength=bstrength*(1.0d0-dum)
            endif
                                                  mtyp1=0  ! no metal
                                                  mtyp2=0
            if(param%group(ia).eq.1)                    mtyp1=1  ! Li...
            if(param%group(ia).eq.2)                    mtyp1=2  ! Be...
            if(param%group(ia).gt.2.and.imetal(ii).eq.1)mtyp1=3  ! main group
            if(imetal(ii).eq.2)                   mtyp1=4  ! TM
            if(param%group(ja).eq.1)                    mtyp2=1  ! Li...
            if(param%group(ja).eq.2)                    mtyp2=2  ! Be...
            if(param%group(ja).gt.2.and.imetal(jj).eq.1)mtyp2=3  ! main group
            if(imetal(jj).eq.2)                   mtyp2=4  ! TM
            qafac=topo%qa(ii)*topo%qa(jj)*25.0d0
            dum=exp(-15.d0*qafac)/(1.0d0+exp(-15.d0*qafac))
            fqq=1.0d0+dum * (gen%qfacbm(mtyp1)+gen%qfacbm(mtyp2))*0.5   ! metal charge corr.
            if(imetal(ii).eq.2.and.ja.gt.10)      fheavy=0.65d0 ! heavy gen. ligand
            if(imetal(jj).eq.2.and.ia.gt.10)      fheavy=0.65d0
            if(imetal(ii).eq.2.and.ja.eq.15)      fheavy=1.60d0 ! P ligand
            if(imetal(jj).eq.2.and.ia.eq.15)      fheavy=1.60d0
            if(imetal(ii).eq.2.and.param%group(ja).eq.6)fheavy=0.85d0 ! chalcogen ligand
            if(imetal(jj).eq.2.and.param%group(ia).eq.6)fheavy=0.85d0
            if(imetal(ii).eq.2.and.param%group(ja).eq.7)fheavy=1.30d0 ! halogen ligand
            if(imetal(jj).eq.2.and.param%group(ia).eq.7)fheavy=1.30d0
            if(imetal(ii).eq.2.and.ja.eq.1.and.itabrow6(ia).le.5) fxh =0.80d0 ! hydrogen 3d/4d
            if(imetal(jj).eq.2.and.ia.eq.1.and.itabrow6(ja).le.5) fxh =0.80d0 ! hydrogen 3d/4d
            if(imetal(ii).eq.2.and.ja.eq.1.and.itabrow6(ia).gt.5) fxh =1.00d0 ! hydrogen 5d
            if(imetal(jj).eq.2.and.ia.eq.1.and.itabrow6(ja).gt.5) fxh =1.00d0 ! hydrogen 5d
            if(imetal(ii).eq.1.and.ja.eq. 1)      fxh   =1.20d0
            if(imetal(jj).eq.1.and.ia.eq. 1)      fxh   =1.20d0
            if(imetal(jj).eq.2.and.topo%hyb(ii).eq.1) then !CO/CN/NC...
                                       if(ia.eq.6)then
                                                  fpi   =1.5d0
                                                  shift=-0.45d0
                                       endif
                                       if(ia.eq.7.and.topo%nb(20,ii).ne.1)then
                                                  fpi   =0.4d0
                                                  shift= 0.47d0
                                       endif
            endif
            if(imetal(ii).eq.2.and.topo%hyb(jj).eq.1) then !CO/CN/NC...
                                       if(ja.eq.6)then
                                                  fpi   =1.5d0
                                                  shift=-0.45d0
                                       endif
                                       if(ja.eq.7.and.topo%nb(20,jj).ne.1)then
                                                  fpi   =0.4d0
                                                  shift= 0.47d0
                                       endif
            endif
            if(imetal(ii).eq.2)                   shift=shift+gen%metal2_shift   ! metal shift TM
            if(imetal(jj).eq.2)                   shift=shift+gen%metal2_shift   !
            if(imetal(ii).eq.1.and.param%group(ia).le.2)shift=shift+gen%metal1_shift   ! metal shift group 1+2
            if(imetal(jj).eq.1.and.param%group(ja).le.2)shift=shift+gen%metal1_shift   !
            if(mtyp1     .eq.3)                   shift=shift+gen%metal3_shift   ! metal shift MG
            if(mtyp2     .eq.3)                   shift=shift+gen%metal3_shift   !
            if(bbtyp.eq.6.and.param%metal(ia).eq.2)     shift=shift+gen%eta_shift*topo%nb(20,ii)! eta coordinated
            if(bbtyp.eq.6.and.param%metal(ja).eq.2)     shift=shift+gen%eta_shift*topo%nb(20,jj)! eta coordinated
            if(mtyp1.gt.0.and.mtyp1.lt.3) fcn=fcn/(1.0d0+0.100*dble(topo%nb(20,ii))**2)
            if(mtyp2.gt.0.and.mtyp2.lt.3) fcn=fcn/(1.0d0+0.100*dble(topo%nb(20,jj))**2)
            if(mtyp1.eq.3)                fcn=fcn/(1.0d0+0.030*dble(topo%nb(20,ii))**2)
            if(mtyp2.eq.3)                fcn=fcn/(1.0d0+0.030*dble(topo%nb(20,jj))**2)
            if(mtyp1.eq.4)                fcn=fcn/(1.0d0+0.036*dble(topo%nb(20,ii))**2)
            if(mtyp2.eq.4)                fcn=fcn/(1.0d0+0.036*dble(topo%nb(20,jj))**2)
            if(mtyp1.eq.4.or.mtyp2.eq.4)then
              fsrb2=-gen%srb2*0.22! weaker, inverse EN dep. for TM metals
            else
              fsrb2= gen%srb2*0.28! "normal" for other metals
            endif
         endif

         if(ia.gt.10.and.ja.gt.10) then  ! both atoms are heavy
             shift = shift + gen%hshift3
             if(ia.gt.18) shift = shift + gen%hshift4
             if(ja.gt.18) shift = shift + gen%hshift4
             if(ia.gt.36) shift = shift + gen%hshift5
             if(ja.gt.36) shift = shift + gen%hshift5
         endif

! shift
         topo%vbond(1,i) = gen%rabshift + shift   ! value for all bonds + special part

! RINGS prefactor
         if(rings.gt.0) ringf = 1.0d0 + gen%fringbo*(6.0d0-dble(rings))**2  ! max ring size is 6

! steepness
         topo%vbond(2,i) =  gen%srb1*( 1.0d0 + fsrb2*(param%en(ia)-param%en(ja))**2 + gen%srb3*bstrength )

! tot prefactor        atoms              spec     typ       qterm    heavy-M  pi   XH(3ring,OH...) CN for M
         topo%vbond(3,i) = -param%bond(ia)*param%bond(ja) * ringf * bstrength * fqq * fheavy * fpi * fxh * fcn
!        write(env%unit,*) bond(ia),bond(ja),ringf,bstrength,fqq,fheavy,fpi,fxh

! output
         r0 = (rtmp(ij)+topo%vbond(1,i))*0.529167
         if(pr) write(env%unit,'(2a3,2i5,2x,2i5,2x,6f8.3)') &
     &   mol%sym(ii),mol%sym(jj),ii,jj,bbtyp,rings,0.529167*rab(ij),r0,pibo(i),fqq,topo%vbond(3,i),topo%vbond(2,i)
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     scale FC if bond is part of hydrogen bridge
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!      do i=1,topo%nbond
!         ii=topo%blist(1,i)
!         jj=topo%blist(2,i)
!         ia=mol%at(ii)
!         ja=mol%at(jj)
!         do j=1,topo%nathbAB
!            hbA=topo%hbatABl(2,j)
!            !O-H case:
!            if (ia.eq.8.and.ja.eq.1.or.ia.eq.1.and.ja.eq.8) then
!               if (ii.eq.hbA.or.jj.eq.hbA) then
!                  topo%vbond(2,i) = topo%vbond(2,i) * 1.00
!                  !topo%vbond(1,i) = topo%vbond(1,i) * 1.00
!               end if
!            !N-H case
!          else if (ia.eq.7.and.ja.eq.1.or.ia.eq.1.and.ja.eq.7) then
!               if (ii.eq.hbA.or.jj.eq.hbA) then
!                  topo%vbond(2,i) = topo%vbond(2,i) * 1.00
!                  !topo%vbond(1,i) = topo%vbond(1,i) * 1.00
!               end if
!            end if
!         end do
!      end do

      deallocate(rtmp)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!     scale FC if bond is part of hydrogen bridge
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      !Set up fix hblist just like for the HB term
      call bond_hbset0(mol%n,mol%at,mol%xyz,sqrab,bond_hbn,topo,hbthr1,hbthr2)
      allocate(bond_hbl(3,bond_hbn))
      allocate(topo%nr_hb(topo%nbond), source=0)
      call bond_hbset(mol%n,mol%at,mol%xyz,sqrab,bond_hbn,bond_hbl,topo,hbthr1,hbthr2)

      !Set up AH, B and nr. of B list
      call bond_hb_AHB_set0(mol%n,mol%at,topo%nbond,bond_hbn,bond_hbl,AHB_nr,topo)
      allocate( lin_AHB(0:AHB_nr), source=0  )
      call bond_hb_AHB_set1(mol%n,mol%at,topo%nbond,bond_hbn,bond_hbl,AHB_nr,lin_AHB,topo%bond_hb_nr,topo%b_max,topo)
      allocate( topo%bond_hb_AH(2,topo%bond_hb_nr), source = 0 )
      allocate( topo%bond_hb_B(topo%b_max,topo%bond_hb_nr), source = 0 )
      allocate( topo%bond_hb_Bn(topo%bond_hb_nr), source = 0 )
      call bond_hb_AHB_set(mol%n,mol%at,topo%nbond,bond_hbn,bond_hbl,AHB_nr,lin_AHB,topo)

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!               bend
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      topo%nangl=0
      do i=1,mol%n
         nn=topo%nb(20,i)                 ! take full set to include M-X-Y
         if(nn.le.1) cycle
         if(topo%nb(20,i).gt.6) cycle     ! no highly coordinated atom
         ati=mol%at(i)
         do j=1,nn
            do k=1,j-1
               jj=topo%nb(j,i)
               kk=topo%nb(k,i)
               atj=mol%at(jj)
               atk=mol%at(kk)
               fijk=param%angl(ati)*param%angl2(atj)*param%angl2(atk)
               if(fijk.lt.gen%fcthr) cycle     ! too small
               topo%nangl=topo%nangl+1
            enddo
         enddo
      enddo

      write(env%unit,'(10x,"#angl  :",3x,i0)') topo%nangl
      if(pr)then
      write(env%unit,*)
      write(env%unit,*) 'angle atoms        phi0    phi      FC  pi rings'
      endif

      topo%nangl_alloc = topo%nangl
      allocate( topo%alist(3,topo%nangl), source = 0 )
      allocate( topo%vangl(2,topo%nangl), source = 0.0d0 )
      topo%nangl=0
      do i=1,mol%n
         nn=topo%nb(20,i)
         if(nn.le.1) cycle
         if(topo%nb(20,i).gt.6) cycle
         ii=i
         ati=mol%at(i)
         do j=1,nn
            do k=1,j-1
               jj=topo%nb(j,i)
               kk=topo%nb(k,i)
               atj=mol%at(jj)
               atk=mol%at(kk)
               fijk=param%angl(ati)*param%angl2(atj)*param%angl2(atk)
               if(fijk.lt.gen%fcthr) cycle     ! too small
               call bangl(mol%xyz,jj,i,kk,phi)
               if(param%metal(ati).gt.0.and.phi*180./pi.lt.60.) cycle ! skip eta cases even if CN < 6 (e.g. CaCp+)
               feta=1.0d0
               if(imetal(ii).eq.2.and.itag(jj).eq.-1.and.piadr(jj).gt.0) feta=0.3d0       ! eta coord.
               if(imetal(ii).eq.2.and.itag(kk).eq.-1.and.piadr(kk).gt.0) feta=feta*0.3d0  !
               nh =0
               if(atj.eq.1)nh=nh+1
               if(atk.eq.1)nh=nh+1
               nnn=0
               if(atj.eq.7)nnn=nnn+1
               if(atk.eq.7)nnn=nnn+1
               no=0
               if(atj.eq.8)no=no+1
               if(atk.eq.8)no=no+1
               nheav=0
               if(atj.gt.14)nheav=nheav+1
               if(atk.gt.14)nheav=nheav+1
               nsi=0
               if(atj.eq.14)nsi=nsi+1
               if(atk.eq.14)nsi=nsi+1
               nc=0
               if(atj.eq.6)nc=nc+1
               if(atk.eq.6)nc=nc+1
               nmet=0
               if(param%metal(atj).ne.0)nmet=nmet+1
               if(param%metal(atk).ne.0)nmet=nmet+1
               npi=0
               if(piadr(jj).ne.0)npi=npi+1
               if(piadr(kk).ne.0)npi=npi+1
               topo%nangl=topo%nangl+1
               topo%alist(1,topo%nangl)=ii
               topo%alist(2,topo%nangl)=jj
               topo%alist(3,topo%nangl)=kk
               call ringsbend(mol%n,ii,jj,kk,cring,sring,rings)
               triple=(topo%hyb(ii).eq.1 .or. topo%hyb(jj).eq.1) .or. &
     &                (topo%hyb(ii).eq.1 .or. topo%hyb(kk).eq.1)
               if(imetal(ii).eq.0.and.imetal(jj).eq.0.and.imetal(kk).eq.0) then
               fqq=1.0d0-(topo%qa(ii)*topo%qa(jj)+topo%qa(ii)*topo%qa(kk))*gen%qfacBEN      ! weaken it
               else
               fqq=1.0d0-(topo%qa(ii)*topo%qa(jj)+topo%qa(ii)*topo%qa(kk))*gen%qfacBEN*2.5
               endif
               f2 =1.0d0
               fn =1.0d0

!-------------------------
! definitions come here
!-------------------------

!!!!!!!!!!
! DEFAULT
!!!!!!!!!!
               r0=100.0

               if(topo%hyb(i).eq.1)                                   r0=180.
               if(topo%hyb(i).eq.2)                                   r0=120.
               if(topo%hyb(i).eq.3)                                   r0=109.5
               if(topo%hyb(i).eq.3.and.mol%at(i).gt.10) then
                                               if(nn.le.3)       r0=gen%aheavy3    ! heavy maingroup three coordinated
                                               if(nn.ge.4)       r0=gen%aheavy4    ! heavy maingroup four  coordinated
                                if(nn.eq.4.and.param%group(ati).eq.5)  r0=109.5      ! four coordinated group 5
                  if(nn.eq.4.and.param%group(ati).eq.4.and.ati.gt.49)  r0=109.5      ! four coordinated Sn, Pb
                                           if(param%group(ati).eq.4)   r0=r0-nh*5.   ! smaller angles for XHn Si...
                                           if(param%group(ati).eq.5)   r0=r0-nh*5.   ! smaller angles for XHn P..
                                           if(param%group(ati).eq.6)   r0=r0-nh*5.   ! smaller angles for XHn S..
               endif
               if(topo%hyb(i).eq.5)                                   then
                                                                 r0=90.
                                                                 f2=0.11       ! not very important
                                       if(phi*180./pi.gt.gen%linthr) r0=180.       ! hypervalent coordination can be linear GEODEP
               endif
!!!!!!!!!!
! B
!!!!!!!!!!
               if(ati.eq.5)then
                  if(topo%hyb(i).eq.3)                                r0=115.
                  if(topo%hyb(i).eq.2)                                r0=115.
               endif
!!!!!!!!!!
! C cases
!!!!!!!!!!
               if(ati.eq.6)then
                  if(topo%hyb(i).eq.3.and.nh.eq.2)                    r0=108.6  ! CHH
                  if(topo%hyb(i).eq.3.and.no.eq.1)                    r0=108.5  ! COR
                  if(topo%hyb(i).eq.2.and.no.eq.2)                    r0=122.   ! COO
                  if(topo%hyb(i).eq.2.and.no.eq.1)                    f2=0.7    ! C=O
                  if(topo%hyb(i).eq.1.and.no.eq.2)                    then
                                                                 triple=.false.   ! CO2
                                                                 f2=2.0
                  endif
                  if(topo%hyb(i).eq.3.and.nn.gt.4)                    then
                                       if(phi*180./pi.gt.gen%linthr) r0=180.       ! hypervalent coordination can be linear GEODEP
                  endif
               endif
!!!!!!!!!!
! O cases
!!!!!!!!!!
               if(ati.eq.8.and.nn.eq.2) then
                                                                 r0=104.5
!                   H2O
                    if(nh.eq.2)                                  then
                                                                 r0=100. ! compensate ES of the Hs
                                                                 f2=1.20 ! H2O is better with 1.2-1.3 but H2O in fit behaves differently
                                                                 endif
                                                                 r0 = r0 + 7.*nsi   ! O angles widen with Si attached
                                                                 r0 = r0 +14.*nmet  ! O angles widen with M attached
                    if(npi.eq.2)                                 then
                                                                 r0=109. ! e.g. Ph-O-Ph
                                                                 endif
                    if(nmet.gt.0.and.phi*180./pi.gt.gen%linthr)      then
                                                                 r0=180. ! metal coordination can be linear GEODEP
                                                                 f2 = 0.3
                                                                 endif
               endif
!!!!!!!!!!
! N cases
!!!!!!!!!!
               if(ati.eq.7.and.nn.eq.2) then
                                                                  f2=1.4
                                                                  r0=115.
                                    if(rings.ne.0)                r0=105.
                                    if(mol%at(kk).eq.8.or.mol%at(jj).eq.8)r0=103.
                                    if(mol%at(kk).eq.9.or.mol%at(jj).eq.9)r0=102.
                                    if(topo%hyb(i).eq.1)               r0=180.   ! NC or NNN
               if(imetal(jj).eq.2.and.topo%hyb(i).eq.1.and.mol%at(kk).eq.7)r0=135.   ! NN on M
               if(imetal(kk).eq.2.and.topo%hyb(i).eq.1.and.mol%at(jj).eq.7)r0=135.   ! NN on M
               endif
! NR3
               if(ati.eq.7.and.topo%hyb(i).eq.3)then
!                 in pi system
                  if(npi.gt.0)then
                                                                 if(amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,i))then
                                                                   r0=115.
                                                                   f2=1.2d0
                                                                 else
                                                                   sumppi=pbo(lin(ii,jj))+pbo(lin(ii,kk))
                                                                   r0=113.
                                                                   f2=1.d0-sumppi*0.7d0 ! must be -!
                                                                 endif
                  else
                                                                 r0=104. ! sat. pyr. N, steep around 106
                                                                 f2=0.40 ! 1.0 is better for NH3
                                                                 f2=f2+nh*0.19
                                                                 f2=f2+no*0.25
                                                                 f2=f2+nc*0.01
                  endif
               endif
!!!!!!!!!!
! RING < 5
!!!!!!!!!!
               if(rings.eq.3)                                    r0=82. ! 60 gives too little strain
               if(rings.eq.4)                                    r0=96.
               if(rings.eq.5.and.ati.eq.6)                       r0=109.
!!!!!!!!!!
! specials
!!!!!!!!!!
! R-X in 3-rings e.g. cyclopropene
               if(rings.eq.0)then
                  call ringsatom(mol%n,i,cring,sring,idum)
                  if(idum.eq.3) then
                     call ringsatom(mol%n,jj,cring,sring,ringsj)
                     call ringsatom(mol%n,kk,cring,sring,ringsk)
                     if(ringsj+ringsk.eq.102)                    r0=r0+4.d0
                  endif
               endif

! triple bonds
               if (triple) then
                                                                 f2 = 0.60d0  ! complex 7 in S30L makes artificial torsions if this is 0.4 which is
                                                                              ! slightly better for the phenylmethylethyne bending pot.
                 if(atj.eq.7.or.atk.eq.7)                        f2 = 1.00d0
                 if((imetal(jj).eq.2.or.imetal(kk).eq.2).and.phi*180./pi.gt.gen%linthr) then
                                 if(ati.eq.6.and.atj.eq.6)       f2=3.   ! M-CC
                                 if(ati.eq.6.and.atk.eq.6)       f2=3.   ! M-CC
                                 if(ati.eq.6.and.atj.eq.7)       f2=3.   ! M-CN
                                 if(ati.eq.6.and.atk.eq.7)       f2=3.   ! M-CN
                                 if(ati.eq.6.and.param%group(atj).eq.6)f2=14.  ! M-CO or CS
                                 if(ati.eq.6.and.param%group(atk).eq.6)f2=14.  ! M-CO or CS
                                 if(ati.eq.7.and.atj.eq.7)       f2=10.  ! M-NN
                                 if(ati.eq.7.and.atj.eq.6)       f2=10.  ! M-NC
                                 if(ati.eq.7.and.atk.eq.6)       f2=10.  ! M-NC
                                 if(ati.eq.7.and.atj.eq.8)then; r0=180.;f2=12.; endif  ! M-NO
                                 if(ati.eq.7.and.atk.eq.8)then; r0=180.;f2=12.; endif  ! M-NO
                                 endif
               endif
! carbene analogous
               if(param%group(ati).eq.4.and.nn.eq.2.and.itag(i).eq.1)  then
                                                                 if(ati.eq.6) r0=145.
                                                                 if(ati.gt.6) r0= 90.
               endif
! SO3X
               if(param%group(ati).eq.6.and.nn.eq.4.and.no.ge.1)       r0=115.
! halogens CN=2
               if(param%group(ati).eq.7.and.topo%hyb(i).eq.1)               then
                                                                 if(ati.eq.9)  r0= 90.
                                                                 if(ati.eq.17) r0= 90.
                                                                 if(ati.eq.35) r0= 90.
                                                                 if(ati.eq.53) r0= 90.
                                        if(ati.gt.9.and.phi*180./pi.gt.gen%linthr) r0=180. ! change to linear if linear coordinated, GEODEP
                                                                 f2=0.6/dble(ati)**0.15
               endif
! PB or Sn can be pyramidal
               if(topo%hyb(i).eq.3.and.param%group(ati).eq.4.and.ati.gt.32.and.topo%qa(i).gt.0.4)then
                  if(phi*180./pi.gt.140.) then
                     r0=180. ! change to linear
                  endif
                  if(phi*180./pi.lt.100.) then
                     r0=90.
                  endif
                  f2=1.0
               endif
! METAL
               if(imetal(ii).gt.0) then
                                   if(topo%hyb(i).eq.0)               then
                                                                 r0=90.
                                                                 f2=1.35  ! important difference to other bends, big effect 1.15,1.25,1.35
                                   endif
                                   if(topo%hyb(i).eq.1)               r0=180.
                                   if(topo%hyb(i).eq.2)               r0=120.
                                   if(topo%hyb(i).eq.3)               r0=109.5
                                   if(phi*180./pi.gt.gen%linthr)     r0=180. ! change to linear
               endif

               fn=1.0d0 - 2.36d0/dble(nn)**2

!----------------------
! end of definitions
!----------------------
               topo%vangl(1,topo%nangl)=r0*pi/180.
               fbsmall=(1.0d0-gen%fbs1*exp(-0.64*(topo%vangl(1,topo%nangl)-pi)**2))

!                          central*neigbor charge spec. met.  small angle corr.
               topo%vangl(2,topo%nangl)= fijk * fqq * f2 * fn * fbsmall * feta
!              write(env%unit,*) param%angl(ati),param%angl2(atj),param%angl2(atk), param%angl(ati)*param%angl2(atj)*param%angl2(atk), fqq,f2,fn,fbsmall
               if(pr)write(env%unit,'(3i5,2x,3f8.3,l2,i4)') ii,jj,kk,r0,phi*180./pi,topo%vangl(2,topo%nangl),picon,rings
            enddo
         enddo
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!              torsion
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      topo%ntors=sum(piadr)+mol%n
      do m=1,topo%nbond
         ii=topo%blist(1,m)
         jj=topo%blist(2,m)
         if(btyp(m).eq.3.or.btyp(m).eq.6)           cycle ! no sp-sp or metal eta
         if(param%tors(mol%at(ii)).lt.0.or.param%tors(mol%at(jj)).lt.0) cycle ! no negative values
         if(param%tors(mol%at(ii))*param%tors(mol%at(jj)).lt.1.d-3)     cycle ! no small values
         if(param%metal(mol%at(ii)).gt.1.and.topo%nb(20,ii).gt.4)  cycle ! no HC metals
         if(param%metal(mol%at(jj)).gt.1.and.topo%nb(20,jj).gt.4)  cycle !
         topo%ntors=topo%ntors+topo%nb(20,ii)*topo%nb(20,jj)*2 ! upper limit
      enddo
      maxtors=topo%ntors
      if(pr) write(env%unit,*) 'torsion atoms        nrot   rings    phi0    phi      FC'

      topo%ntors_alloc = topo%ntors
      allocate( topo%tlist(5,topo%ntors), source = 0 )
      allocate( topo%vtors(2,topo%ntors), source = 0.0d0 )
      topo%ntors=0
      do m=1,topo%nbond
         ii=topo%blist(1,m)
         jj=topo%blist(2,m)
         if(btyp(m).eq.3.or.btyp(m).eq.6) cycle    ! metal eta or triple
         fij=param%tors(mol%at(ii))*param%tors(mol%at(jj))             ! atom contribution, central bond
         if(fij.lt.gen%fcthr)                 cycle
         if(param%tors(mol%at(ii)).lt.0.or.param%tors(mol%at(jj)).lt.0) cycle ! no negative values
         if(param%metal(mol%at(ii)).gt.1.and.topo%nb(20,ii).gt.4)  cycle ! no HC metals
         if(param%metal(mol%at(jj)).gt.1.and.topo%nb(20,jj).gt.4)  cycle !
         fqq=1.0d0+abs(topo%qa(ii)*topo%qa(jj))*gen%qfacTOR      ! weaken it for e.g. CF-CF and similar
         call ringsbond(mol%n,ii,jj,cring,sring,rings) ! i and j in same ring
         lring=.false.
         ccij =.false.
         if(rings.gt.0) lring=.true.
         sp3ij=topo%hyb(ii).eq.3.and.topo%hyb(jj).eq.3
         if(mol%at(ii).eq.6.and.mol%at(jj).eq.6) ccij=.true.
         nhi=1
         nhj=1
         do ineig=1,topo%nb(20,ii)
            if(mol%at(topo%nb(ineig,ii)).eq.1) nhi=nhi+1
         enddo
         do jneig=1,topo%nb(20,jj)
            if(mol%at(topo%nb(jneig,jj)).eq.1) nhj=nhj+1
         enddo
         fij=fij*(dble(nhi)*dble(nhj))**0.07 ! n H term
         ! amides and alpha carbons in peptides/proteins
         if (alphaCO(mol%n,mol%at,topo%hyb,topo%nb,piadr,ii,jj)) fij = fij * 1.3d0
         if (amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,ii).and.topo%hyb(jj).eq.3.and.mol%at(jj).eq.6) fij = fij * 1.3d0
         if (amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,jj).and.topo%hyb(ii).eq.3.and.mol%at(ii).eq.6) fij = fij * 1.3d0
         ! hypervalent
         if(btyp(m).eq.4)                                                                   fij = fij * 0.2d0
!        loop over neighbors of ij
         do ineig=1,topo%nb(20,ii)
            kk=topo%nb(ineig,ii)
            if(kk.eq.jj) cycle
            do jneig=1,topo%nb(20,jj)
               ll=topo%nb(jneig,jj)
               if(ll.eq.ii) cycle
               if(ll.eq.kk) cycle
               if(chktors(mol%n,mol%xyz,ii,jj,kk,ll)) cycle  ! near 180
               fkl=param%tors2(mol%at(kk))*param%tors2(mol%at(ll))       ! outer kl term
               if(mol%at(kk).eq.7.and.piadr(kk).eq.0) fkl=param%tors2(mol%at(kk))*param%tors2(mol%at(ll))*0.5
               if(mol%at(ll).eq.7.and.piadr(ll).eq.0) fkl=param%tors2(mol%at(kk))*param%tors2(mol%at(ll))*0.5
               if(fkl.lt.gen%fcthr)               cycle
               if(param%tors(mol%at(kk)).lt.0.or.param%tors(mol%at(ll)).lt.0) cycle ! no negative values
               f1 = gen%torsf(1)
               f2 = 0.0d0
               fkl=fkl*(dble(topo%nb(20,kk))*dble(topo%nb(20,ll)))**(-0.14)  ! CN term

!-----------------------
! definitions come here
!-----------------------
               if ( lring ) then
                    if(rings.gt.3)then
                    call ringstors(mol%n,ii,jj,kk,ll,cring,sring,rings4) ! smallest ring in which i,j,k,l are
                    else
                    rings4=3 ! the 3-ring is special
                    endif
! RING CASE
                    nrot = 1
                    if(btyp(m).eq.2) nrot = 2 ! max at 90 for pi and symmetric at 0,-180,180
                    phi  = 0  ! cis
                    if ( btyp(m).eq.1 .and. rings4 .gt. 0 )then
                      call ringstorl(mol%n,ii,jj,kk,ll,cring,sring,ringl)  ! largest ring in which i,j,k,l are
                      notpicon=piadr(kk).eq.0.and.piadr(ll).eq.0                      ! do it only for sat. rings
                      if ( rings4 .eq. 3 .and.                      notpicon) then; nrot=1; phi = 0.d0; f1=gen%fr3; endif
                      if ( rings4 .eq. 4 .and. ringl.eq.rings4 .and.notpicon) then; nrot=6; phi =30.d0; f1=gen%fr4; endif
                      if ( rings4 .eq. 5 .and. ringl.eq.rings4 .and.notpicon) then; nrot=6; phi =30.d0; f1=gen%fr5; endif
                      if ( rings4 .eq. 6 .and. ringl.eq.rings4 .and.notpicon) then; nrot=3; phi =60.d0; f1=gen%fr6; endif
                    endif
                    if ( rings4.eq.0 .and. btyp(m).eq.1 .and. &
                                 topo%nb(20,kk).eq.1.and.topo%nb(20,ll).eq.1) then; nrot=6; phi =30.d0; f1=0.30; endif
                    if(btyp(m).eq.2 .and. rings.eq.5 .and. mol%at(ii)*mol%at(jj).eq.42) then
                       if(amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,ii).or.amide(mol%n,mol%at,topo%hyb,topo%nb,piadr,jj)) f1=5.  ! improving CB7
                    endif
               else
! ACYCLIC
                                                      phi  = 180.d0 ! trans
                                                      nrot = 1
                    if(topo%hyb(ii).eq.3.and.topo%hyb(jj).eq.3) nrot = 3 ! Me case
                    if(btyp(m).eq.2)                  nrot = 2 ! max at 90 for pi and symmetric at 0,-180,180
                    if(piadr(ii).gt.0.and.(piadr(jj).eq.0.and.topo%hyb(jj).eq.3))then  ! pi-sp3
                                                         f1=0.5d0
                                         if(mol%at(ii).eq.7) f1=0.2d0 ! important for CB7 conf.
                                                         phi  =180.d0
                                                         nrot = 3
                    endif
                    if(piadr(jj).gt.0.and.(piadr(ii).eq.0.and.topo%hyb(ii).eq.3))then
                                                         f1=0.5d0
                                         if(mol%at(jj).eq.7) f1=0.2d0 ! important for CB7 conf.
                                                         phi  =180.d0
                                                         nrot = 3
                    endif
               endif
! SP3 specials
               if(topo%hyb(ii).eq.3.and.topo%hyb(jj).eq.3) then
! N-N, P-P ...
               if(param%group(mol%at(ii)).eq.5.and.param%group(mol%at(jj)).eq.5) then
                                                             nrot=3
                                                             phi=60.d0
                                                             f1= 3.0d0
               endif
! 5-6
               if((param%group(mol%at(ii)).eq.5.and.param%group(mol%at(jj)).eq.6).or. &
     &            (param%group(mol%at(ii)).eq.6.and.param%group(mol%at(jj)).eq.5))then
                                                             nrot=2
                                                             phi=90.d0
                                                             f1=1.0d0
                            if(mol%at(ii).ge.15.and.mol%at(jj).ge.15)f1=20.0d0
               endif
! O-O, S-S ...
               if(param%group(mol%at(ii)).eq.6.and.param%group(mol%at(jj)).eq.6) then
                                                             nrot=2
                                                             phi=90.d0
                                                             f1=5.0d0
                            if(mol%at(ii).ge.16.and.mol%at(jj).ge.16)f1=25.0d0 ! better for h2s2
               endif
               endif
! pi system
               if(pibo(m).gt.0) then
                                f2=pibo(m)*exp(-2.5d0*(1.24d0-pibo(m))**14)  ! decrease to very small values for P < 0.3
                                                                             ! values of 2.5 instead of 2.4 give larger tangles
                                                                             ! the parameter 1.24 is very sensitive ie 1.25 yield 5 deg more in 1,3cB
                                if(piadr(kk).eq.0.and.mol%at(kk).gt.10) f2=f2*1.3! the pi BO becomes more significant if heavies are attached
                                if(piadr(ll).eq.0.and.mol%at(ll).gt.10) f2=f2*1.3
                                f1 = f1 * 0.55
               endif

               if(topo%hyb(kk).eq.5.or.topo%hyb(ll).eq.5) fkl = fkl * 1.5 ! hypervalent corr.
!--------------------
! end of definitions
!-------------------

! total FC            sigma       pi             charge central outer kl
               fctot = (f1 + 10.d0*gen%torsf(2)*f2) * fqq * fij * fkl

               if(fctot.gt.gen%fcthr) then ! avoid tiny potentials
                  topo%ntors=topo%ntors+1
                  if (topo%ntors.gt.maxtors) then
                     call env%error('internal (torsion setup) error', source)
                     return
                  end if
                  topo%tlist(1,topo%ntors)=ll
                  topo%tlist(2,topo%ntors)=ii
                  topo%tlist(3,topo%ntors)=jj
                  topo%tlist(4,topo%ntors)=kk
                  topo%tlist(5,topo%ntors)=nrot
                  topo%vtors(1,topo%ntors)=phi*pi/180.0d0
                  topo%vtors(2,topo%ntors)=fctot
!                 printout
                  phi=valijklff(mol%n,mol%xyz,ll,ii,jj,kk)
                  if(pr)write(env%unit,'(4i5,2x,i2,5x,i2,4x,3f8.3)') &
     &            ii,jj,kk,ll,topo%tlist(5,topo%ntors),rings,topo%vtors(1,topo%ntors)*180./pi,phi*180./pi,topo%vtors(2,topo%ntors)
               endif

! extra rot=1 torsion potential for sp3-sp3 to get gauche conf energies well
               sp3kl=topo%hyb(kk).eq.3.and.topo%hyb(ll).eq.3
               if(sp3kl.and.sp3ij.and.(.not.lring).and.btyp(m).lt.5) then
                  topo%ntors=topo%ntors+1
                  if (topo%ntors.gt.maxtors) then
                     call env%error('internal (torsion setup) error', source)
                     return
                  end if
                  ff = gen%torsf(6)
                  if(mol%at(ii).eq.7.or.mol%at(jj).eq.7) ff = gen%torsf(7)
                  if(mol%at(ii).eq.8.or.mol%at(jj).eq.8) ff = gen%torsf(8)
                  topo%tlist(1,topo%ntors)=ll
                  topo%tlist(2,topo%ntors)=ii
                  topo%tlist(3,topo%ntors)=jj
                  topo%tlist(4,topo%ntors)=kk
                  topo%tlist(5,topo%ntors)=1
                  topo%vtors(1,topo%ntors)=pi
                  topo%vtors(2,topo%ntors)= ff * fij * fkl *fqq
                  if(pr)write(env%unit,'(4i5,2x,i2,5x,i2,4x,3f8.3)') &
     &            ii,jj,kk,ll,topo%tlist(5,topo%ntors),rings,topo%vtors(1,topo%ntors)*180./pi,phi*180./pi,topo%vtors(2,topo%ntors)
               endif

            enddo ! neighbors ij
         enddo
      enddo ! bond loop

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! out-of-plane, improper (three-fold coordinated central pi atom i or an N)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      if(pr) write(env%unit,*) 'out-of-plane atoms          phi0    phi      FC'
      do i=1,mol%n
         if(topo%nb(20,i).ne.3) cycle
         if(piadr(i).eq.0) then
            if(      mol%at(i) .ne.7) cycle
         endif
         topo%ntors=topo%ntors+1
         jj=topo%nb(1,i)
         kk=topo%nb(2,i)
         ll=topo%nb(3,i)
!        sort atoms according to distance to central atom such that the same inversion angle def. always results
         sdum3(1)=rab(lin(i,jj))
         sdum3(2)=rab(lin(i,kk))
         sdum3(3)=rab(lin(i,ll))
         ind3(1)=jj
         ind3(2)=kk
         ind3(3)=ll
         call ssort(3,sdum3,ind3)
         jj=ind3(1)
         kk=ind3(2)
         ll=ind3(3)
         topo%tlist(1,topo%ntors)=i
         topo%tlist(2,topo%ntors)=jj
         topo%tlist(3,topo%ntors)=kk
         topo%tlist(4,topo%ntors)=ll
         if(piadr(i).eq.0.and.mol%at(i).eq.7) then  ! sat N case
           r0=80.0d0
           ff=0.60d0
           topo%tlist(5,topo%ntors)=-1
           topo%vtors(1,topo%ntors)=r0*pi/180. ! double min at +/- phi0
           topo%vtors(2,topo%ntors)=0.0d0
           do m=1,topo%nb(20,i)
              idum=topo%nb(m,i)
              topo%vtors(2,topo%ntors)=topo%vtors(2,topo%ntors)+ff*sqrt(param%repz(mol%at(idum)))  ! NX3 has higher inv barr. than NH3
           enddo
         else
           ncarbo=0
           nf    =0
           do m=1,topo%nb(20,i)
              idum=topo%nb(m,i)
              if(mol%at(idum).eq.8.or.mol%at(idum).eq.16) ncarbo=ncarbo+1
              if(param%group(mol%at(idum)).eq.7           ) nf    =nf    +1
           enddo
           fqq=1.0d0+topo%qa(i)*5.0d0
           topo%tlist(5,topo%ntors)=0         ! phi0=0 case (pi)
           topo%vtors(1,topo%ntors)=0.0d0     !  "      "
           sumppi=pbo(lin(i,jj))+pbo(lin(i,kk))+pbo(lin(i,ll))
           f2=1.0d0-sumppi*gen%torsf(5)
!                         base val  piBO  charge term
           topo%vtors(2,topo%ntors)=gen%torsf(3) * f2 * fqq
!          carbonyl corr.
           if(mol%at(i).eq.5.and.ncarbo.gt.0)             topo%vtors(2,topo%ntors)=topo%vtors(2,topo%ntors)*38.
           if(mol%at(i).eq.6.and.ncarbo.gt.0)             topo%vtors(2,topo%ntors)=topo%vtors(2,topo%ntors)*38.
           if(mol%at(i).eq.6.and.nf.gt.0.and.ncarbo.eq.0) topo%vtors(2,topo%ntors)=topo%vtors(2,topo%ntors)*10.
           if(mol%at(i).eq.7.and.ncarbo.gt.0)             topo%vtors(2,topo%ntors)=topo%vtors(2,topo%ntors)*10./f2 ! no pi dep
         endif
!        printout
         phi=omega(mol%n,mol%xyz,i,jj,kk,ll)
         if(pr)write(env%unit,'(4i5,7x,3f8.3)') i,jj,kk,ll,topo%vtors(1,topo%ntors)*180./pi,phi*180./pi,topo%vtors(2,topo%ntors)
      enddo

      write(env%unit,'(10x,"#tors  :",3x,i0)') topo%ntors
      write(env%unit,'(10x,"#nmol  :",3x,i0)') topo%nfrag

! all done

      topo%maxsystem = 5000
      !if(mol%n.gt.800)then
      block
         use xtb_setparam, only : set, p_modh_old

         if (set%mhset%model == p_modh_old) then
            call fragmentize(mol%n,mol%at,mol%xyz,topo%maxsystem,500,rab,topo%nb, &
               & topo%ispinsyst,topo%nspinsyst,topo%nsystem,env)
         else
            topo%nsystem=1
         endif
      end block


      write(env%unit,'(10x,"#optfrag :",3x,i0)') topo%nfrag
      !write(env%unit,*) '#optfrag :',nsystem


      ! check if triple bonded carbon is present (for torsion term)
      nn=0
      do i=1, mol%n
        if (mol%at(i).eq.6.and.topo%nb(20,i).eq.2) then
          do j=1, 2
            nbi=topo%nb(j,i)
            if (mol%at(nbi).eq.6.and.topo%nb(20,nbi).eq.2) then
              nn = nn + 1
            endif
          enddo
        endif
      enddo
      if (nn.ne.0) then
        ! fix double counting
        nn = nn/2
        allocate(topo%sTorsl(6, nn), source=0)
        call specialTorsList(nn, mol, topo, topo%sTorsl)
      endif


      if(pr)then
      write(env%unit,*)
      write(env%unit,*) 'GFN-FF setup done.'
      write(env%unit,*)
      endif

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! special treatment for rotation around carbon triple bonds
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! requested for obtaining diphenylacetylene torsion potential
! also applied for e.g. divinylacetylene

! Check for triple bonded carbon (Ci and Cnbi) and setup list for calculating
!  torsion potential using dehidral angle between C1 C2 C3 C4
! C--C1                C--C
!      \              /
!       C2--Ci-Cnbi--C3
!      /             \
! C-- C               C4--C
!
! using C1=ii, C2=jj, C3=kk, C4=ll
subroutine specialTorsList(nst, mol, topo, sTorsList)
  integer, intent(in) :: nst
  type(TMolecule), intent(in) :: mol   ! # molecule type
  type(TGFFTopology), intent(in) :: topo
  integer, intent(inout) :: sTorsList(6, nst)
  integer :: i,j,k,ii,jj,kk,ll,idx
  logical :: iiok, llok
  idx=0
  do i=1, mol%n
    ! carbon with two neighbors bonded to other carbon* with two neighbors
    if (mol%at(i).eq.6.and.topo%nb(20,i).eq.2) then
      do j=1, 2
        nbi=topo%nb(j,i)
        if (mol%at(nbi).eq.6.and.topo%nb(20,nbi).eq.2) then  ! *other carbon
          ! check carbon triple bond distance
          if (NORM2(mol%xyz(1:3,i)-mol%xyz(1:3,nbi)).le.2.37) then
            ! at this point we know that i and nbi are carbons bonded through triple bond
            ! check C2 and C3
            do k=1, 2  ! C2 is other nb of Ci
              if (topo%nb(k,i).ne.nbi.and.mol%at(topo%nb(k,i)).eq.6) then
                jj=topo%nb(k,i)
              endif
            enddo
            do k=1, 2  ! C3 is other nb of Cnbi
              if (topo%nb(k,nbi).ne.i.and.mol%at(topo%nb(k,nbi)).eq.6) then
                kk=topo%nb(k,nbi)
              endif
            enddo
            ! check C1 through C4 are sp2 carbon
            if (topo%hyb(jj).eq.2.and.topo%hyb(kk).eq.2 &
            &   .and.mol%at(jj).eq.6.and.mol%at(kk).eq.6) then
              iiok=.false.
              llok=.false.
              ! which of the two valid neighbors is picked as C1 depends
              !  on atom sorting in input file !!! The last one in file.
              do k=1, topo%nb(20,jj)
                if (topo%hyb(k).eq.2.and.mol%at(k).eq.6.and.topo%nb(20,k).eq.3.and. &
                   & topo%nb(k,jj).ne.i) then
                  ii=topo%nb(k,jj)
                  iiok=.true.
                endif
              enddo
              ! which of the two valid neighbors is picked as C4 depends
              !  on atom sorting in input file !!! The last one in file.
              do k=1, topo%nb(20,kk)
                if (topo%hyb(k).eq.2.and.mol%at(k).eq.6.and.topo%nb(20,k).eq.3.and. &
                   & topo%nb(k,kk).ne.nbi) then
                  ll=topo%nb(k,kk)
                  llok=.true.
                endif
              enddo
              if (nbi.gt.i.and.iiok.and.llok) then ! to avoid double counting
                idx = idx + 1
                sTorsList(1, idx) = ii  ! C1
                sTorsList(2, idx) = jj  ! C2
                sTorsList(3, idx) = i   ! Ci
                sTorsList(4, idx) = nbi ! Cnbi
                sTorsList(5, idx) = kk  ! C3
                sTorsList(6, idx) = ll  ! C4
              endif
            endif ! C1-C4 are sp2 carbon
          endif  ! CC distance
        endif  ! other carbon
      enddo
    endif ! is carbon with nnb=2
  enddo
end subroutine specialTorsList

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!> zeta(g_a,gam(ia)*g_c,refq(ii,ia)+iz,q(i)+iz)

!> @brief charge scaling function
pure elemental function zeta(at,q)
use xtb_mctc_accuracy, only : wp
   implicit none
   integer ,intent(in) :: at
   real(wp),intent(in) :: q

   real(wp)           :: zeta,qmod
   real(wp),parameter :: zeff(86) = (/ &
   &   1,                                                 2,  & ! H-He
   &   3, 4,                               5, 6, 7, 8, 9,10,  & ! Li-Ne
   &  11,12,                              13,14,15,16,17,18,  & ! Na-Ar
   &  19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,  & ! K-Kr
   &   9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,  & ! Rb-Xe
   &   9,10,11,30,31,32,33,34,35,36,37,38,39,40,41,42,43,  & ! Cs-Lu
   &  12,13,14,15,16,17,18,19,20,21,22,23,24,25,26/)  ! Hf-Rn
!! Semiempirical Evaluation of the GlobalHardness of the Atoms of 103
!! Elements of the Periodic Table Using the Most Probable Radii as
!! their Size Descriptors DULAL C. GHOSH, NAZMUL ISLAM 2009 in
!! Wiley InterScience (www.inte"rscience.wiley.com).
!! DOI 10.1002/qua.22202
!! values in the paper multiplied by two because
!! (ii:ii)=(IP-EA)=d^2 E/dN^2 but the hardness
!! definition they use is 1/2d^2 E/dN^2 (in Eh)
   real(wp),parameter :: c(1:86) = (/ &
  &0.47259288_wp,0.92203391_wp,0.17452888_wp,0.25700733_wp,0.33949086_wp,0.42195412_wp, & ! H-C
  &0.50438193_wp,0.58691863_wp,0.66931351_wp,0.75191607_wp,0.17964105_wp,0.22157276_wp, & ! N-Mg
  &0.26348578_wp,0.30539645_wp,0.34734014_wp,0.38924725_wp,0.43115670_wp,0.47308269_wp, & ! Al-Ar
  &0.17105469_wp,0.20276244_wp,0.21007322_wp,0.21739647_wp,0.22471039_wp,0.23201501_wp, & ! Ca-Cr
  &0.23933969_wp,0.24665638_wp,0.25398255_wp,0.26128863_wp,0.26859476_wp,0.27592565_wp, & ! Mn-Zn
  &0.30762999_wp,0.33931580_wp,0.37235985_wp,0.40273549_wp,0.43445776_wp,0.46611708_wp, & ! Ga-Kr
  &0.15585079_wp,0.18649324_wp,0.19356210_wp,0.20063311_wp,0.20770522_wp,0.21477254_wp, & ! Rb-Mo
  &0.22184614_wp,0.22891872_wp,0.23598621_wp,0.24305612_wp,0.25013018_wp,0.25719937_wp, & ! Tc-Cd
  &0.28784780_wp,0.31848673_wp,0.34912431_wp,0.37976593_wp,0.41040808_wp,0.44105777_wp, & ! In-Xe
  &0.05019332_wp,0.06762570_wp,0.08504445_wp,0.10247736_wp,0.11991105_wp,0.13732772_wp, & ! Cs-Nd
  &0.15476297_wp,0.17218265_wp,0.18961288_wp,0.20704760_wp,0.22446752_wp,0.24189645_wp, & ! Pm-Dy
  &0.25932503_wp,0.27676094_wp,0.29418231_wp,0.31159587_wp,0.32902274_wp,0.34592298_wp, & ! Ho-Hf
  &0.36388048_wp,0.38130586_wp,0.39877476_wp,0.41614298_wp,0.43364510_wp,0.45104014_wp, & ! Ta-Pt
  &0.46848986_wp,0.48584550_wp,0.12526730_wp,0.14268677_wp,0.16011615_wp,0.17755889_wp, & ! Au-Po
  &0.19497557_wp,0.21240778_wp/)

   intrinsic :: exp

   qmod = zeff(at) + q
   if (qmod.lt.0._wp) then
      zeta = exp( 3.0d0 )
   else
      zeta = exp( 3.0d0  * ( 1._wp - exp( c(at) * ( 1._wp - zeff(at) / qmod ) ) ) )
   endif

end function zeta

end subroutine gfnff_ini

end module xtb_gfnff_ini

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_peeq
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_la
   use xtb_xtb_data
   use xtb_chargemodel
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType, &
      & cutCoordinationNumber
   use xtb_disp_dftd4, only : d4_gradient
   use xtb_disp_encharges, only : getENCharges
   use xtb_coulomb_gaussian
   use xtb_intgrad, only : get_grad_overlap, get_overlap
   use xtb_xtb_eeq
   use xtb_xtb_hamiltonian, only : getSelfEnergy
   use xtb_type_wsc, only : tb_wsc
   implicit none
   private

   public :: peeq

   !> print the different gradient contributions (for debugging)
   logical,parameter,private :: gpr =.false.

   !> profiling
   logical,parameter,private :: profile = .true.

contains

subroutine peeq &
      (env,mol,wfn,basis,xtbData,gbsa,egap,et,prlevel,grd,ccm,acc,etot,gradient,sigma,res)

! ------------------------------------------------------------------------
!  Class definitions
! ------------------------------------------------------------------------
   use xtb_solv_gbsa, only : TBorn
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_wavefunction
   use xtb_type_basisset
   use xtb_type_param
   use xtb_type_data
   use xtb_type_timer

! ------------------------------------------------------------------------
!  Get interfaces
! ------------------------------------------------------------------------
   use xtb_readin
   use xtb_aespot
   use xtb_scc_core
   use xtb_grad_core
   use xtb_eeq
   use xtb_disp_ncoord
   use xtb_lineardep
   use xtb_pbc

   implicit none

   character(len=*), parameter :: source = 'peeq'

! ------------------------------------------------------------------------
!  INPUT
! ------------------------------------------------------------------------
   type(TEnvironment), intent(inout)    :: env
   type(TMolecule),  intent(in) :: mol     !< molecular structure infomation
   type(TBasisset),  intent(in) :: basis   !< basis set
   type(TxTBData), intent(in) :: xtbData
   real(wp),intent(in)            :: et      !< electronic temperature
   integer, intent(in)            :: prlevel !< amount of printout
   logical, intent(in)            :: grd     !< toggles gradient calculation
   real(wp),intent(in)            :: acc     !< numerical accuracy
   logical, intent(in)            :: ccm     !< use cyclic cluster model

! ------------------------------------------------------------------------
!  INPUT/OUTPUT
! ------------------------------------------------------------------------
   real(wp),intent(inout)                    :: etot !< total energy
   real(wp),intent(inout)                    :: egap !< HOMO-LUMO gap
   real(wp),intent(inout),dimension(3,mol%n) :: gradient    !< molecular gradient
   type(TWavefunction),intent(inout)       :: wfn  !< TB-wavefunction
   type(TBorn),allocatable,intent(inout) :: gbsa
! ------------------------------------------------------------------------
!  OUTPUT
! ------------------------------------------------------------------------
   type(scc_results),intent(out) :: res !< bundles all calculation informations

! ------------------------------------------------------------------------
   type(chrg_parameter) :: chrgeq
   real(wp), allocatable :: cn(:), dcndr(:,:,:), dcndL(:,:,:)
   real(wp), allocatable :: ccn(:), dccndr(:,:,:), dccndL(:,:,:)
   real(wp), allocatable :: X    (:,:)
   real(wp), allocatable :: S    (:,:)
   real(wp), allocatable :: H    (:,:)
   real(wp), allocatable :: H0   (:)
   real(wp), allocatable :: H1   (:)
   real(wp), allocatable :: zsh  (:)
   real(wp), allocatable :: kcnao(:)
   real(wp), allocatable :: kqao (:)
   real(wp), allocatable :: selfEnergy(:, :)
   real(wp), allocatable :: dSEdcn(:, :)
   real(wp), allocatable :: dSEdq(:, :)
   real(wp), allocatable :: Pa   (:,:)
   real(wp), allocatable :: Pb   (:,:)
   integer :: rep_cn(3)
   integer :: nid
   integer, allocatable :: idnum(:)
   real(wp),allocatable :: chargeWidth(:, :)
   type(TGaussianSmeared) :: coulomb
   type(TENEquilibration) :: eeq

! ------------------------------------------------------------------------
   ! local variable (without comment)
   integer :: ii,jj,i,j,k,m,iat,jat,ati,atj,kk
   integer :: il,jl

   integer,parameter :: lladr(4)    = [1,3,6,10]
   integer,parameter :: lladr2(0:3) = [1,3,5,7 ]

   real(wp) :: dipol(3)
   real(wp) :: eatoms,eat
   real(wp) :: dum

   logical :: ex
   logical :: minpr
   logical :: pr
   logical :: fail

   ! timer
   type(tb_timer) :: timer
   ! Fermi smearing variables
   real(wp) :: efa,efb,nfoda,nfodb,ga,gb
   ! numerical thresholds
   real(wp) :: intcut,neglect,neglect2,scfconv
   ! energies
   real(wp) :: eel,ed,ees,exb,ep

! ---------------------------------------
!  PEEQ information
! ---------------------------------------
   real(wp) , allocatable, dimension(:)     :: rab0
   real(wp) , allocatable, dimension(:,:,:) :: grab0
   real(wp) , allocatable, dimension(:)     :: lcn
   real(wp) , allocatable, dimension(:,:,:) :: dlcn
   real(wp),               dimension(2)     :: hbpi
   real(wp),               dimension(2)     :: hbpj
   real(wp) :: esrb
   real(wp) :: ehb
   real(wp) :: den2
   real(wp) :: den4
   real(wp) :: ken2
   real(wp) :: ken4
   integer  :: nhb
   integer  :: nh
   integer  :: ich
   logical :: debug
   logical :: exitRun

! ---------------------------------------
!  PEEQ q dependent H0
! ---------------------------------------
   real(wp),allocatable, dimension(:)     :: qeeq
   real(wp),allocatable, dimension(:,:,:) :: dqdr
   real(wp),allocatable, dimension(:,:,:) :: dqdL
   real(wp),allocatable, dimension(:)     :: dHdq
   real(wp),allocatable, dimension(:)     :: dHdcn
   real(wp),allocatable, dimension(:,:)   :: pew
   real(wp),allocatable, dimension(:)     :: tmp

! ---------------------------------------
!  PEEQ WSC information
! ---------------------------------------
   real(wp),dimension(3,3),intent(inout)     :: sigma
   type(TLatticePoint) :: latp
   real(wp), allocatable :: trans(:, :)

! For eigenvalues of S via dsyev routine
   real(wp),allocatable,dimension(:,:)       :: Stmp
   real(wp),allocatable,dimension(:)         :: ev_s
   integer                                   :: info
   integer                                   :: lwork
   real(wp),allocatable,dimension(:)         :: aux
   real(wp) :: test(1)

   integer :: xdim ! new dimension of the cut Overlap (lin.depend.)

   character(len=*),parameter :: scifmt = &
      '(10x,":",2x,a,e22.7,1x,a,1x,":")'
   character(len=*),parameter :: dblfmt = &
      '(10x,":",2x,a,f18.7,5x,a,1x,":")'
   character(len=*),parameter :: intfmt = &
      '(10x,":",2x,a,i18,      10x,":")'
   character(len=*),parameter :: chrfmt = &
      '(10x,":",2x,a,a18,      10x,":")'

   interface
      subroutine generate_wsc(mol,wsc)
         import :: TMolecule, tb_wsc
         type(TMolecule), intent(in) :: mol
         type(tb_wsc),    intent(inout) :: wsc
      end subroutine generate_wsc
   end interface

   type(tb_wsc) :: wsc

! ---------------------------------------
!  EEQ/GBSA information
! ---------------------------------------
   real(wp) :: gsolv

   associate( nao => basis%nao, &
         &    nbf => basis%nbf, &
         &    nshell => basis%nshell, &
         &    naop => basis%nao*(basis%nao+1)/2, &
         &    nbfp => basis%nbf*(basis%nbf+1)/2)

   if (ccm) &
      call generate_wsc(mol, wsc)

   if (profile) then
      if (allocated(gbsa)) then
         call timer%new(9,.false.)
      else
         call timer%new(8,.false.)
      endif
   endif
   if (profile) call timer%measure(1,"EHT setup")

   etot  = 0.0_wp
   dipol = 0.0_wp
   exb   = 0.0_wp
   ga    = 0.0_wp
   gb    = 0.0_wp
   eel   = 0.0_wp
   ep    = 0.0_wp
   ehb   = 0.0_wp
   esrb  = 0.0_wp
   ed    = 0.0_wp
   ees   = 0.0_wp
   gradient = 0.0_wp

   !debug = prlevel.gt.2
   debug =.false.
   pr    = prlevel.gt.1
   minpr = prlevel.gt.0

! ---------------------------------------
!  Numerical stuff and cutoffs
! ---------------------------------------
   intcut=25.0_wp-10.0_wp*log10(acc)
   intcut=max(20.0_wp,intcut)
   neglect =10.0e-9_wp*acc
   neglect2=neglect*10.0_wp
   scfconv=1.e-6_wp*acc

   call init(latp, env, mol, 60.0_wp)

! ---------------------------------------
!  IMPORTANT FACT: H is given in eV
! ---------------------------------------

! ---------------------------------------
!  Get memory
! ---------------------------------------
   allocate(cn(mol%n));                     cn = 0.0_wp
   allocate(dcndr(3,mol%n,mol%n));       dcndr = 0.0_wp
   allocate(dcndL(3,3,mol%n));           dcndL = 0.0_wp
   allocate(ccn(mol%n));                   ccn = 0.0_wp
   allocate(dccndr(3,mol%n,mol%n));     dccndr = 0.0_wp
   allocate(dccndL(3,3,mol%n));         dccndL = 0.0_wp
   allocate(H(nao,nao));                     H = 0.0_wp
   allocate(X(nao,nao));                     X = 0.0_wp
   allocate(H0(naop));                      H0 = 0.0_wp
   allocate(S(nao,nao));                     S = 0.0_wp
   allocate(H1(naop));                      H1 = 0.0_wp
   allocate(kcnao(nao));                 kcnao = 0.0_wp
   allocate(kqao(nao));                   kqao = 0.0_wp
   allocate(zsh(nshell));                  zsh = 0.0_wp
   allocate(selfEnergy(maxval(xtbData%nshell), mol%n))
   allocate(dSEdcn(maxval(xtbData%nshell), mol%n))
   allocate(dSEdq(maxval(xtbData%nshell), mol%n))
   allocate(qeeq(mol%n));           qeeq = 0.0_wp
   allocate(dqdr(3,mol%n,mol%n)); dqdr = 0.0_wp
   allocate(dqdL(3,3,mol%n));     dqdL = 0.0_wp

   wfn%nel = nint(sum(mol%z) - mol%chrg)
   wfn%nopen = mol%uhf
   if(wfn%nopen == 0 .and. mod(wfn%nel,2) /= 0) wfn%nopen=1

! ---------------------------------------
!  Fill levels
! ---------------------------------------
   call setzshell(xtbData,mol%n,mol%at,nshell,mol%z,zsh,eatoms,0)
   if(wfn%nel.ne.0) then
      call occu(nao,wfn%nel,wfn%nopen,wfn%ihomoa,wfn%ihomob,wfn%focca,wfn%foccb)
      wfn%focc = wfn%focca + wfn%foccb
      wfn%ihomo=wfn%ihomoa
   else
      wfn%focc=0.0_wp
      wfn%ihomo=0
      wfn%ihomoa=0
      wfn%nopen=0
   endif

   if (prlevel > 1) then
      write(env%unit,'(/,10x,51("."))')
      write(env%unit,'(10x,":",22x,a,22x,":")') "SETUP"
      write(env%unit,'(10x,":",49("."),":")')
      write(env%unit,intfmt) "# basis functions  ",basis%nbf
      write(env%unit,intfmt) "# atomic orbitals  ",basis%nao
      write(env%unit,intfmt) "# shells           ",basis%nshell
      write(env%unit,intfmt) "# electrons        ",wfn%nel
      if (mol%npbc > 0) &
      write(env%unit,chrfmt) "PBC by CCM         ",bool2string(ccm)
      write(env%unit,dblfmt) "electronic temp.   ",et,      "K   "
      write(env%unit,dblfmt) "accuracy           ",acc,     "    "
      write(env%unit,scifmt) "-> integral cutoff ",intcut,  "    "
      write(env%unit,scifmt) "-> integral neglect",neglect, "    "
      write(env%unit,'(10x,51("."))')
   endif

   if (profile) call timer%measure(1)
   if (profile) call timer%measure(2,"Coordination number")
! ---------------------------------------
!  Get CN(1:n) + dcndr(3,1:n,1:n) under pbc
! ---------------------------------------
   call latp%getLatticePoints(trans, 40.0_wp)
   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
      & cn, dcndr, dcndL)
   call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)

   if (profile) call timer%measure(2)
   if (profile) call timer%measure(4,"D4 Dispersion")
! ----------------------------------------
!  D4 dispersion energy + gradient (2B) under pbc
! ----------------------------------------
   call getENCharges(env, mol, cn, dcndr, dcndL, qeeq, dqdr, dqdL)
   call env%check(exitRun)
   if (exitRun) then
      call env%error("Could not get EN charges for D4 dispersion", source)
      return
   end if

   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%cov, &
      & ccn, dccndr, dccndL)
   call latp%getLatticePoints(trans, 60.0_wp)
   call d4_gradient(mol, xtbData%dispersion%dispm, trans, xtbData%dispersion%dpar, &
      & xtbData%dispersion%g_a, xtbData%dispersion%g_c, xtbData%dispersion%wf, &
      & 60.0_wp, ccn, dccndr, dccndL, qeeq, dqdr, dqdL, ed, gradient, sigma)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Evaluation of dispersion energy failed", source)
      return
   end if

   ! better save than sorry, delete the D4-EEQ charges
   qeeq(:) = 0.0_wp
   dqdr(:, :, :) = 0.0_wp
   dqdL(:, :, :) = 0.0_wp

   if (profile) call timer%measure(4)
! ---------------------------------------
!  Get EEQ charges q(1:n) + dqdr(3,1:n,1:n) under pbc
! ---------------------------------------

   if (allocated(gbsa)) then
      if (profile) call timer%measure(9,"GBSA setup")
      ! compute Born radii
      call gbsa%update(env, mol%at, mol%xyz)
      ! add SASA term to energy and gradient
      ees = gbsa%gsasa + gbsa%gshift
      gsolv = gbsa%gsasa
      gradient = gradient + gbsa%dsdr
      if (profile) call timer%measure(9)
   endif


   if (profile) call timer%measure(3,"EEQ model density")
   ! names DO NOT corresponds to content of variables, obviously...
   call gfn0_charge_model(chrgeq,mol%n,mol%at,xtbData%coulomb)
   ! initialize electrostatic energy
   if (allocated(gbsa)) then
      call eeq_chrgeq(mol,env,chrgeq,gbsa,cn,dcndr,qeeq,dqdr, &
         &            ees,gsolv,gradient,.false.,.true.,.true.)
   else
      nid = maxval(mol%id)
      allocate(idnum(nid))
      do ii = 1, nId
         jat = 0
         do iat = 1, mol%n
            if (mol%id(iat) == ii) then
               jat = iat
               exit
            end if
         end do
         idnum(ii) = mol%at(jat)
      end do
      allocate(chargeWidth(1, nid))
      do ii = 1, nid
         ati = idnum(ii)
         chargeWidth(1, ii) = xtbData%coulomb%chargeWidth(ati)
      end do
      call init(coulomb, env, mol, chargeWidth)
      call init(eeq, env, xtbData%coulomb%electronegativity, &
         & xtbData%coulomb%kcn, xtbData%coulomb%chemicalHardness, num=idnum)
      call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
         & ees, gradient, sigma, qat=qeeq, dqdr=dqdr, dqdL=dqdL)
   endif

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Electronegativity equilibration failed", source)
      return
   end if

   wfn%q = qeeq

   if (profile) call timer%measure(3)
   if (profile) call timer%measure(5,"Integral evaluation")
! ---------------------------------------
!  Build AO overlap S and H0 integrals under pbc
! ---------------------------------------
   call getSelfEnergy(xtbData%hamiltonian, xtbData%nShell, mol%at, cn, wfn%q, &
      & selfEnergy, dSEdcn, dSEdq)
   if (ccm) then
      call ccm_build_SH0(xtbData%nShell, xtbData%hamiltonian, selfEnergy, &
         & mol%n, mol%at, basis, nbf, nao, mol%xyz, mol%lattice, intcut, &
         & s, h0, wsc)
   else
      call latp%getLatticePoints(trans, sqrt(800.0_wp))
      call pbc_build_SH0(xtbData%nShell, xtbData%hamiltonian, selfEnergy, &
         & mol%n, mol%at, basis, nbf, nao, mol%xyz, trans, intcut, s, h0)
   endif

   if (profile) call timer%measure(5)
   if (profile) call timer%measure(6,"Cholesky factorization")

! ---------------------------------------
!  Check for near linear dependencies via Cholesky decomposition
! ---------------------------------------
   call cholesky(env%unit,pr,nao,S,orthog) ! S is not modified
   if(orthog)then
      !if (profile) call timer%measure(7,"Canonical orthogonalization")
      call renorm(nao,S) ! S is renormalized
      call canorthog(env%unit,nao,S,X,xdim,pr,fail)
      !if (profile) call timer%measure(7)
   endif

   if (profile) call timer%measure(6)
   if (profile) call timer%measure(7,"Zeroth order Hamiltonian")
! ---------------------------------------
!  Setup H0 under pbc
! ---------------------------------------
!  H0 already initialized
   do i = 1, nao
      do j = 1, i
         k = j+i*(i-1)/2
         H(j,i) = H0(k)
         H(i,j) = H(j,i)
      enddo
   enddo

   if(.not.orthog)then
      call solve(.true.,nao,wfn%ihomo,scfconv,H,S,X,wfn%P,wfn%emo,fail)
   else
      call orthgsolve2(.true.,nao,xdim,wfn%ihomo,scfconv,H,S,X,wfn%P,wfn%emo,fail)
   endif
   ! for geometry optimization
   res % converged = .not. fail

   ! save eigenvectors
   wfn%C = H

   if (fail) then
      call env%error("Diagonalization of Hamiltonian failed", source)
      return
   end if

! ---------------------------------------
!  Fermi smearing
! ---------------------------------------
   if(et.gt.0.1_wp)then
      if (wfn%ihomoa+1.le.nao) then
         call fermismear(.false.,nao,wfn%ihomoa,et,wfn%emo,wfn%focca,nfoda,efa,ga)
      endif
      if (wfn%ihomob+1.le.nao) then
         call fermismear(.false.,nao,wfn%ihomob,et,wfn%emo,wfn%foccb,nfodb,efb,gb)
      endif
      wfn%focc = wfn%focca + wfn%foccb
   endif
   ! create density matrix = save in wfn%P
   call dmat(nao,wfn%focc,wfn%C,wfn%P)

   call mpopsh(mol%n,nao,nshell,basis%ao2sh,S,wfn%P,wfn%qsh)

! ---------------------------------------
!  emo: Eigenvalues from H0
! ---------------------------------------
   eel = sum(wfn%focc*wfn%emo)*evtoau + ga + gb

   if (profile) call timer%measure(7)
   if (.not.pr.and.profile.and.minpr) &
      call timer%write_timing(env%unit,7,"Diagonalization")
   if (profile) call timer%measure(8,"Gradient calculation")
! ======================================================================
!  GRADIENT (100% analytical)
! ======================================================================
   ! repulsion energy + gradient
   !gradient = 0.0_wp; sigma = 0.0_wp
   call latp%getLatticePoints(trans, 40.0_wp)
   call drep_grad(xtbData%repulsion,mol,trans,ep,gradient,sigma)
   ! short ranged bond energy + gradient
   if (allocated(xtbData%srb)) then
      call latp%getLatticePoints(trans, sqrt(200.0_wp))
      call dsrb_grad(mol,xtbData%srb,cn,dcndr,dcndL,trans,esrb,gradient,sigma)
   end if
   !etot = ep + esrb; return
   ! h0 gradient
   allocate( dHdcn(mol%n), dHdq(mol%n), pew(nao,nao), tmp(nao), &
      &      source = 0.0_wp )
   tmp = wfn%focc*wfn%emo*evtoau
   ! setup energy weighted density matrix = pew
   call dmat(nao,tmp,wfn%C,pew)
   if (ccm) then
      call ccm_build_dSH0(xtbData%nShell, xtbData%hamiltonian, selfEnergy, &
         & dSEdcn, dSEdq, mol%n, basis, intcut, nao, nbf, mol%at, mol%xyz, &
         & mol%lattice, wfn%P, Pew, gradient, sigma, dhdcn, dhdq, wsc)
   else
      call latp%getLatticePoints(trans, sqrt(800.0_wp))
      call pbc_build_dSH0(xtbData%nShell, xtbData%hamiltonian, selfEnergy, &
         & dSEdcn, dSEdq, mol%n, basis, intcut, nao, nbf, mol%at, mol%xyz, &
         & trans, wfn%P, Pew, gradient, sigma, dhdcn, dhdq)
   endif
   if (mol%npbc > 0) then
      ! setup CN sigma
      call dgemv('n',9,mol%n,1.0_wp,dcndL,9,dhdcn,1,1.0_wp,sigma,1)
      ! setup  q sigma
      call dgemv('n',9,mol%n,1.0_wp,dqdL, 9, dhdq,1,1.0_wp,sigma,1)
   endif
   ! setup CN gradient
   call dgemv('n',3*mol%n,mol%n, 1.0_wp,dcndr,3*mol%n,dhdcn,1,1.0_wp,gradient,1)
   ! setup  q gradient
   call dgemv('n',3*mol%n,mol%n, 1.0_wp,dqdr, 3*mol%n, dhdq,1,1.0_wp,gradient,1)

   if (profile) call timer%measure(8)

!  calculate the norm for printout
   res%gnorm = sqrt(sum( gradient**2 ))

! ---------------------------------------
!  Properties + printout
! ---------------------------------------
   printing: if (pr) then
      ! print orbital energies and occupation numbers
      !call preig(6,wfn%focc,1.0_wp,wfn%emo, &
      !     max(wfn%ihomoa-12,1),min(wfn%ihomoa+11,nao))
      if(.not.orthog)then
        call print_orbital_eigenvalues(env%unit,wfn,5)
        if ((wfn%ihomo+1.le.nao).and.(wfn%ihomo.ge.1)) &
           egap = wfn%emo(wfn%ihomo+1)-wfn%emo(wfn%ihomo)
      else
        wfn%nao = xdim
        call print_orbital_eigenvalues(env%unit,wfn,5)
        if ((wfn%ihomo+1.le.xdim).and.(wfn%ihomo.ge.1)) &
           egap = wfn%emo(wfn%ihomo+1)-wfn%emo(wfn%ihomo)
        wfn%nao = nao
      endif


   endif printing
   
   !--------------------------!
   ! Wiberg-Mayer bond orders !
   !--------------------------!

   ! closed-shell !
   if (wfn%nopen == 0) then
      
      call get_wiberg(mol%n,basis%nao,mol%at,mol%xyz,wfn%P,S,wfn%wbo,basis%fila2)
   
   ! (restricted) open-shell !
   else if (wfn%nopen > 0) then   
         
      allocate(Pa(basis%nao,basis%nao))
      allocate(Pb(basis%nao,basis%nao))
      
      ! obtain alpha and beta spin densities !
      call dmat(basis%nao, wfn%focca, wfn%C, Pa) 
      call dmat(basis%nao, wfn%foccb, wfn%C, Pb) 
      
      call get_unrestricted_wiberg(mol%n, basis%nao, mol%at, mol%xyz, Pa, Pb ,S, wfn%wbo, &
         & basis%fila2)

   endif
! ---------------------------------------
!  Save all the energy contributions
! ---------------------------------------
   etot = eel + ees + ep + exb + esrb
   eat = eatoms*evtoau - etot
   etot = etot + ed

   res%e_elec  = eel
   res%e_atom  = eat
   res%e_rep   = ep
   res%e_es    = ees
   res%e_aes   = 0.0_wp
   res%e_axc   = 0.0_wp
   res%e_xb    = esrb
   res%e_disp  = ed
   res%g_hb    = ehb
   res%e_total = etot
   res%hl_gap  = egap
   if (allocated(gbsa)) then
      res%g_solv  = gsolv
      !res%g_born  = gborn    ! not returned
      res%g_sasa  = gbsa%gsasa
      !res%g_hb    = gbsa%ghb ! not returned
      res%g_shift = gbsa%gshift
   endif
   ! do NOT calculate the dipole moment from the density, because it's really bad
   res%dipole  = matmul(mol%xyz,wfn%q)
   res%g_solv  = 0.0_wp

   if (profile.and.pr) call timer%write(env%unit,'EHT')

end associate

   if (profile) call timer%deallocate

end subroutine peeq

! repulsion
pure subroutine drep_grad(repData,mol,trans,erep,gradient,sigma)
   use xtb_type_molecule
   use xtb_type_param
   use xtb_pbc_tools
   use xtb_pbc
   implicit none
   type(TRepulsionData), intent(in) :: repData
   type(TMolecule), intent(in) :: mol
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(out) :: erep
   integer :: i,j,k,lin
   integer :: iat,jat,ati,atj
   real(wp) :: ri(3),dr(3)
   real(wp) :: rij(3)
   real(wp) :: r2,r,r2top34,r2top34top2
   real(wp) :: den2,den4
   real(wp) :: alpha
   real(wp) :: repab
   real(wp) :: expterm
   real(wp) :: dtmp
   real(wp), parameter :: rthr = 1600.0_wp
   real(wp) :: w,t(3)
   integer  :: latrep(3),tx,ty,tz,itr
   call get_realspace_cutoff(mol%lattice,rthr,latrep)
   w = 1.0_wp
   ! initialize
   erep = 0.0_wp
   do i = 1, mol%n
      ati=mol%at(i)
      do j = 1, i
         do itr = 1, size(trans, dim=2)
            t = trans(:, itr)
            rij = mol%xyz(:,i) - mol%xyz(:,j) + t
            r2 = sum(rij**2)
            if(r2.gt.rthr .or. r2.lt.1.0e-6_wp) cycle
            atj=mol%at(j)
            r = sqrt(r2)
            den2 = (repData%electronegativity(ati) - repData%electronegativity(atj))**2
            den4 = den2**2
            alpha=sqrt(repData%alpha(ati)*repData%alpha(atj))&
               *(1.0_wp+(0.01_wp*den2+0.01_wp*den4)*repData%enScale)
            repab = repData%zeff(ati)*repData%zeff(atj)
            r2top34 = r2**0.75_wp
            r2top34top2 = r2top34**2
            expterm = exp(-alpha*r2top34)*repab
            ! save repulsion energy
            erep = erep + expterm/r * w
            ! save repulsion gradient
            dtmp = expterm*(1.5_wp*alpha*r2top34 + 1)/r2top34top2 * w
            gradient(:,i) = gradient(:,i) - dtmp*rij
            gradient(:,j) = gradient(:,j) + dtmp*rij
            sigma = sigma - dtmp*outer_prod_3x3(rij,rij)
         enddo ! k WSC partner
      enddo ! j atom
   enddo ! i atom

end subroutine drep_grad

! short-ranged bond correction
subroutine dsrb_grad(mol,srb,cn,dcndr,dcndL,trans,esrb,gradient,sigma)

   use xtb_type_param
   use xtb_type_molecule

   use xtb_approxrab
   use xtb_disp_ncoord
   use xtb_pbc_tools
   use xtb_pbc

   implicit none

   type(TMolecule), intent(in) :: mol
   type(TShortRangeData), intent(in) :: srb
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(out) :: esrb
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:,:,:)
   real(wp), intent(in) :: dcndL(:,:,:)

   integer :: i,j,k,wsAt
   integer :: iat,jat,ati,atj
   integer :: nsrb,itr
   real(wp) :: den
   real(wp) :: expterm
   ! distances
   real(wp) :: rij(3)
   real(wp) :: r2,r,dr,rab
   real(wp) :: dtmp,pre
   real(wp) :: w
   ! allocatables
   real(wp), allocatable :: dEdr0(:)
   real(wp), allocatable :: drab0dr(:,:,:)
   real(wp), allocatable :: drab0dL(:,:,:)
   real(wp), allocatable :: rab0(:)
   integer,  allocatable :: srblist(:,:)

   ! initialize
   esrb = 0.0_wp

   w = 1.0_wp

   call build_srblist(mol,nsrb,srblist)
   if (nsrb.eq.0) return

   ! get memory
   allocate( dEdr0(nsrb), source = 0.0_wp )
   allocate( drab0dr(3,mol%n,nsrb), source = 0.0_wp )
   allocate( drab0dL(3,3,nsrb),     source = 0.0_wp )
   allocate( rab0(nsrb),            source = 0.0_wp )
   ! get approximated distances rab and gradients
   call pbc_approx_rab(mol%n,mol%at,mol%xyz,cn,dcndr,dcndL,nsrb,srblist,srb%shift, &
      &                rab0,drab0dr,drab0dL)
   do i = 1, nsrb
      iat = srblist(1,i)
      jat = srblist(2,i)
      ati = mol%at(iat)
      atj = mol%at(jat)
      den = en(ati) - en(atj)
      pre = srb%steepness*(1.0_wp + srb%enScale*den**2)
      do itr = 1, size(trans, dim=2)
         rij = mol%xyz(:,iat) - (mol%xyz(:,jat) + trans(:, itr))
         rab = norm2(rij)
         dr = rab - rab0(i)
         expterm = srb%prefactor*exp(-pre*dr**2)
         ! save SRB energy
         esrb = esrb + expterm * w
         dtmp = 2.0_wp*pre*dr*expterm * w
         gradient(:,iat) = gradient(:,iat) - dtmp*rij/rab
         gradient(:,jat) = gradient(:,jat) + dtmp*rij/rab
         ! three body gradient
         dEdr0(i) = dEdr0(i) + dtmp
         sigma = sigma - dtmp*spread(rij, 1, 3)*spread(rij, 2, 3)/rab
      enddo ! rep
   enddo ! i

   call contract(drab0dr, dEdr0, gradient, beta=1.0_wp)
   call contract(drab0dL, dEdr0, sigma, beta=1.0_wp)

end subroutine dsrb_grad

pure subroutine build_srblist(mol,nsrb,srblist)
   use xtb_type_molecule
   implicit none
   type(TMolecule), intent(in) :: mol
   integer, intent(out) :: nsrb
   integer, allocatable, intent(out) :: srblist(:,:)
   integer  :: i,j,k
   real(wp) :: r2
   ! cutoff
   real(wp), parameter    :: srb_cut = 200.0_wp
   nsrb = 0
   do i = 1, mol%n-1
      if (srbatom(mol%at(i))) cycle    ! i i case
      do j = i+1, mol%n
         if (srbatom(mol%at(j))) cycle ! j j case
         if (mol%at(i).eq.mol%at(j)) cycle ! hetero only
         r2  = mol%dist(j,i)**2 ! get minimum image distance
         ! increment array size according to SRB cutoff criterium
         ! default: srb_cut = 200.0_wp
         if(r2.lt.srb_cut) nsrb=nsrb+1
      enddo ! j
   enddo ! i
   ! nsrb = 0: no pairs for SRB correction, nothing to do here
   if(nsrb.eq.0) return
   ! get memory
   allocate( srblist(2,nsrb), source = 0 )
   ! setup srblist
   k=0
   do i = 1, mol%n-1
      if (srbatom(mol%at(i))) cycle    ! i i case
      do j = i+1, mol%n
         if (srbatom(mol%at(j))) cycle ! j j case
         if (mol%at(i).eq.mol%at(j)) cycle ! hetero only
         r2  = mol%dist(j,i)**2 ! get minimum image distance
         if(r2.gt.srb_cut) cycle
         k = k + 1
         srblist(1,k) = i
         srblist(2,k) = j
      enddo ! j
   enddo ! i
   nsrb = k

contains

pure elemental function srbatom(iat) result(lsrb)
   integer, intent(in) :: iat
   logical :: lsrb
   lsrb = iat < 5 .or. iat > 9
end function srbatom

end subroutine build_srblist

! ------------------------------------------------------------------------
!  Calculate the periodic AO overlap matrix
! ------------------------------------------------------------------------
subroutine ccm_build_SH0(nShell, hData, selfEnergy, nat, at, basis, nbf, nao, &
      & xyz, lattice, intcut, sint, h0, wsc)

   use xtb_type_basisset
   use xtb_type_wsc

   use xtb_lin, only : lin
   use xtb_intgrad
   use xtb_scc_core

   implicit none

   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   type(tb_wsc), intent(in) :: wsc
   type(TBasisset), intent(in) :: basis
   real(wp), intent(in) :: selfEnergy(:, :)

   integer, intent(in)  :: nat
   integer, intent(in)  :: nbf
   integer, intent(in)  :: nao
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)  :: lattice(3,3)
   real(wp),intent(in)  :: intcut

   real(wp),intent(out) :: sint(nao,nao)  ! overlap matrix S
   real(wp),intent(out) :: h0(nao*(1+nao)/2)

   integer, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij
   real(wp) tmp1,tmp2,tmp3,tmp4,step,step2
   real(wp) dx,dy,dz,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,f,ci,cc,cj,alpi,rab2,ab,est

   real(wp) :: den,den2,den4,enpoly
   real(wp) :: zi,zj,zetaij
   real(wp) :: hii,hjj,hav
   real(wp) :: shpoly,km
   logical  :: valaoi,valaoj

   real(wp)  ri(3),rj(3),t(3),f1,f2
   real(wp),parameter ::point(3) = 0.0_wp
   real(wp) dtmp(3),qtmp(6),ss(6,6),dd(3,6,6),qq(6,6,6),tmp(6,6)
   real(wp) sstmp(6,6) !TESTST
   integer ip,jp,iat,jat,ati,atj,ish,jsh,icao,jcao,iao,jao,jshmax,il,jl
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   integer itt(0:3)

   integer kat

   parameter(itt  =(/0,1,4,10/))
   real(wp) :: saw(10)

   sint = 0.0_wp
   h0   = 0.0_wp

   !$omp parallel do default(none) schedule(dynamic) &
   !$omp private(iat,jat,ij,ati,cc,ci,rab2,atj,ish,ishtyp,valaoi,valaoj, &
   !$omp&        ri,rj,icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp, &
   !$omp&        ss,saw,est,alpi,alpj,ab,iprim,jprim,ip,jp,km,shpoly, &
   !$omp&        mli,mlj,tmp,zi,zj,zetaij,enpoly,iao,jao, &
   !$omp&        ii,jj,k,den,den2,den4,i,j,il,jl,hii,hjj,hav,t) &
   !$omp shared(sint,h0) &
   !$omp shared(wsc,basis,at,nShell,hData,xyz,lattice,intcut,nat,selfEnergy)
   do iat = 1, nat
      ri  = xyz(:,iat)
      ati = at(iat)
      do jat = 1, iat-1
         atj = at(jat)

         den = hData%electronegativity(ati) - hData%electronegativity(atj)
         den2 =  den**2
         den4 = den2**2

         ishells: do ish = 1, nShell(ati)
            ishtyp = hData%angShell(ish,ati)
            icao = basis%caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(atj)
            if (iat == jat) jshmax = ish

            jshells: do jsh = 1, jshmax
               jshtyp = hData%angShell(jsh,atj)
               jcao = basis%caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! evaluate the EN polynom for this shells
               enpoly = (1.0_wp + hData%enScale(jl-1,il-1)*den2 &
                  & + hData%enScale4*hData%enScale(jl-1,il-1)*den4)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, ati)
               zj = hData%slaterExponent(jsh, atj)
               zetaij = 2 * sqrt(zi*zj)/(zi+zj)

               ! now do the real magic (called EHT enhancement factor)
               km = hData%kScale(jl-1,il-1) * hData%pairParam(ati,atj) * zetaij * enpoly

               ! check for valence orbitals
               valaoi = hData%valenceShell(ish, ati).eq.0
               valaoj = hData%valenceShell(jsh, atj).eq.0
               ! and scale appropiately
               if (valaoi) then
                  if (valaoj) then
                     km = 0.0_wp
                  else
                     km = km * hData%kDiff
                  endif
               else
                  if (valaoj) km = km * hData%kDiff
               endif

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * km * (hii + hjj)

               wscAt: do kat = 1, wsc%itbl(jat,iat)
                  ss = 0.0_wp
                  t = wsc%lattr(:,kat,jat,iat)
                  rj = xyz(:,jat) + matmul(lattice,t)

                  ! distance dependent polynomial
                  shpoly = shellPoly(hData%shellPoly(il,ati),hData%shellPoly(jl,atj),&
                     &               hData%atomicRad(ati),hData%atomicRad(atj),ri,rj)

                  ! get overlap integral
                  call get_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj,point, &
                     &             intcut,basis%nprim,basis%primcount, &
                     &             basis%alp,basis%cont,ss)

                  !transform from CAO to SAO
                  call dtrf2(ss,ishtyp,jshtyp)

                  do ii = 1, llao2(ishtyp)
                     iao = ii+basis%saoshell(ish,iat)
                     do jj = 1, llao2(jshtyp)
                        jao = jj+basis%saoshell(jsh,jat)
                        if (jao > iao) cycle
                        ij = lin(iao,jao)
                        ! add all WSC images
                        !sint(iao,jao) = sint(iao,jao) + ss(jj,ii)*wsc%w(jat,iat)
                        sint(jao,iao) = sint(jao,iao) + ss(jj,ii)*wsc%w(jat,iat)
                        ! Hamiltonian
                        H0(ij) = H0(ij) + hav * shpoly * ss(jj,ii) * wsc%w(jat,iat)
                     enddo
                  enddo

               enddo wscAt
            enddo jshells
         enddo ishells
      enddo
   enddo
   !$omp parallel do default(none) shared(nao, sint) private(iao, jao)
   do iao = 1, nao
      do jao = 1, iao - 1
         sint(iao, jao) = sint(jao, iao)
      end do
   end do

   ! diagonal elements
   do iat = 1, nat
      ati = at(iat)
      do ish = 1, nShell(ati)
         iao = 1+basis%saoshell(ish,iat)
         ishtyp = hData%angShell(ish,ati)
         il = ishtyp + 1
         do iao = 1, llao2(ishtyp)
            i = iao+basis%saoshell(ish,iat)
            sint(i,i)=1.0_wp+sint(i,i)

            ii  = i*(1+i)/2 ! H0 is packed, note i*(i-1)/2+i = i*(1+i)/2

            ! calculate environment dependent shift
            hii = selfEnergy(ish, iat)
            H0(ii) = hii
         end do
      end do
   end do

end subroutine ccm_build_SH0

! ------------------------------------------------------------------------
!  Calculate the periodic AO overlap matrix
! ------------------------------------------------------------------------
subroutine pbc_build_SH0(nShell, hData, selfEnergy, nat, at, basis, nbf, nao, &
      & xyz, trans, intcut, sint, h0)

   use xtb_type_basisset

   use xtb_lin, only : lin
   use xtb_intgrad
   use xtb_scc_core

   implicit none

   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   type(TBasisset), intent(in) :: basis
   real(wp), intent(in) :: selfEnergy(:, :)

   integer, intent(in)  :: nat
   integer, intent(in)  :: nbf
   integer, intent(in)  :: nao
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)  :: trans(:,:)
   real(wp),intent(in)  :: intcut

   real(wp),intent(out) :: sint(nao,nao)  ! overlap matrix S
   real(wp),intent(out) :: h0(nao*(1+nao)/2)

   integer, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij
   real(wp) tmp1,tmp2,tmp3,tmp4,step,step2
   real(wp) dx,dy,dz,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,f,ci,cc,cj,alpi,rab2,ab,est

   real(wp) :: den,den2,den4,enpoly
   real(wp) :: zi,zj,zetaij
   real(wp) :: hii,hjj,hav
   real(wp) :: shpoly,km
   logical  :: valaoi,valaoj

   real(wp)  ri(3),rj(3),f1,f2
   real(wp), parameter :: point(3) = 0.0_wp
   real(wp) dtmp(3),qtmp(6),ss(6,6),dd(3,6,6),qq(6,6,6),tmp(6,6)
   real(wp) sstmp(6,6) !TESTST
   integer ip,jp,iat,jat,ati,atj,ish,jsh,icao,jcao,iao,jao,jshmax,il,jl
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   integer itt(0:3)

   integer kat

   parameter(itt  =(/0,1,4,10/))
   real(wp) :: saw(10)
   integer  :: itr
   real(wp) :: t(3),w

   w = 1.0_wp !/ real(product(2*latrep+1),wp)

   sint = 0.0_wp
   h0   = 0.0_wp

   !$omp parallel do default(none) schedule(dynamic) &
   !$omp private(iat,jat,ij,ati,cc,ci,rab2,atj,ish,ishtyp,valaoi,valaoj, &
   !$omp&        ri,rj,icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp, &
   !$omp&        ss,saw,est,alpi,alpj,ab,iprim,jprim,ip,jp,km,shpoly, &
   !$omp&        mli,mlj,tmp,zi,zj,zetaij,enpoly,iao,jao, &
   !$omp&        ii,jj,k,den,den2,den4,i,j,il,jl,hii,hjj,hav,itr,t) &
   !$omp shared(sint,h0) &
   !$omp shared(basis,at,nShell,hData,xyz,intcut,nat,trans,w,selfEnergy)
   do iat = 1, nat
      ri  = xyz(:,iat)
      ati = at(iat)
      do jat = 1, iat-1
         atj = at(jat)

         den = hData%electronegativity(ati) - hData%electronegativity(atj)
         den2 =  den**2
         den4 = den2**2

         ishells: do ish = 1, nShell(ati)
            ishtyp = hData%angShell(ish,ati)
            icao = basis%caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(atj)
            if (iat == jat) jshmax = ish

            jshells: do jsh = 1, jshmax
               jshtyp = hData%angShell(jsh,atj)
               jcao = basis%caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! evaluate the EN polynom for this shells
               enpoly = (1.0_wp + hData%enScale(jl-1,il-1)*den2 &
                  & + hData%enScale4*hData%enScale(jl-1,il-1)*den4)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, ati)
               zj = hData%slaterExponent(jsh, atj)
               zetaij = 2 * sqrt(zi*zj)/(zi+zj)

               ! now do the real magic (called EHT enhancement factor)
               km = hData%kScale(jl-1,il-1) * hData%pairParam(ati,atj) * zetaij * enpoly

               ! check for valence orbitals
               valaoi = hData%valenceShell(ish, ati).eq.0
               valaoj = hData%valenceShell(jsh, atj).eq.0
               ! and scale appropiately
               if (valaoi) then
                  if (valaoj) then
                     km = 0.0_wp
                  else
                     km = km * hData%kDiff
                  endif
               else
                  if (valaoj) km = km * hData%kDiff
               endif

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * km * (hii + hjj)

               do itr = 1, size(trans, dim=2)
                  t = trans(:, itr)
                  rj = xyz(:,jat) + t
                  ss = 0.0_wp

                  ! distance dependent polynomial
                  shpoly = shellPoly(hData%shellPoly(il,ati),hData%shellPoly(jl,atj),&
                     &               hData%atomicRad(ati),hData%atomicRad(atj),ri,rj)

                  ! get overlap integral
                  call get_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj,point, &
                     &             intcut,basis%nprim,basis%primcount, &
                     &             basis%alp,basis%cont,ss)

                  !transform from CAO to SAO
                  call dtrf2(ss,ishtyp,jshtyp)

                  do ii = 1, llao2(ishtyp)
                     iao = ii+basis%saoshell(ish,iat)
                     do jj = 1, llao2(jshtyp)
                        jao = jj+basis%saoshell(jsh,jat)
                        if (jao > iao) cycle
                        ij = lin(iao,jao)
                        ! add all WSC images
                        sint(iao,jao) = sint(iao,jao) + ss(jj,ii)*w
                        sint(jao,iao) = sint(jao,iao) + ss(jj,ii)*w
                        ! Hamiltonian
                        H0(ij) = H0(ij) + hav * shpoly * ss(jj,ii)*w
                     enddo
                  enddo

               enddo
            enddo jshells
         enddo ishells
      enddo
   enddo
   !$omp parallel do default(none) shared(nao, sint) private(iao, jao)
   do iao = 1, nao
      do jao = 1, iao - 1
         sint(iao, jao) = sint(jao, iao)
      end do
   end do

   ! diagonal elements
   do iat = 1, nat
      ati = at(iat)
      do ish = 1, nShell(ati)
         iao = 1+basis%saoshell(ish,iat)
         ishtyp = hData%angShell(ish,ati)
         il = ishtyp + 1
         do iao = 1, llao2(ishtyp)
            i = iao+basis%saoshell(ish,iat)
            sint(i,i)=1.0_wp+sint(i,i)

            ii  = i*(1+i)/2 ! H0 is packed, note i*(i-1)/2+i = i*(1+i)/2

            ! calculate environment dependent shift
            hii = selfEnergy(ish, iat)
            H0(ii) = hii
         end do
      end do
   end do

end subroutine pbc_build_SH0

! ------------------------------------------------------------------------
!  Calculate the gradient resulting from a periodic AO overlap matrix
! ------------------------------------------------------------------------
subroutine ccm_build_dSH0(nShell, hData, selfEnergy, dSEdcn, dSEdq, nat, basis, &
      & thr, nao, nbf, at, xyz, lattice, P, Pew, g, sigma, dHdcn, dHdq, wsc)
   use xtb_mctc_constants, only : pi
   use xtb_mctc_convert

   use xtb_type_wsc
   use xtb_type_basisset

   use xtb_intgrad
   use xtb_grad_core

   implicit none

   ! intent in
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   real(wp), intent(in) :: selfEnergy(:, :)
   real(wp), intent(in) :: dSEdcn(:, :)
   real(wp), intent(in) :: dSEdq(:, :)
   integer, intent(in)      :: nat
   type(tb_wsc), intent(in) :: wsc
   type(TBasisset), intent(in) :: basis
   real(wp),intent(in)      :: thr
   integer, intent(in)      :: nao
   integer, intent(in)      :: nbf
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)
   real(wp),intent(in) :: lattice(3,3)
   real(wp),intent(in) :: P(nao,nao)
   real(wp),intent(in) :: Pew(nao,nao)
   ! intent inout
   real(wp),intent(inout) :: dHdq(nat)
   real(wp),intent(inout) :: dHdcn(nat)
   real(wp),intent(inout) :: g(3,nat)
   real(wp),intent(inout) :: sigma(3,3)

   integer, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   integer itt(0:3)
   parameter (itt=(/0,1,4,10/))
   real(wp) tmp1,tmp2,tmp3,step,step2,step3,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4
   real(wp) thr2,f,ci,cc,cj,alpi,rab2,ab,est
   real(wp) f1,f2,tmp(6,6),rij(3),ri(3),rj(3),rij2,t(3)
   real(wp) stmp,ral(3,3),rar(3,3),rbl(3,3),pre
   real(wp) dtmp,qtmp,rbr(3,3),r2l(3),r2r(3),qqa(6,6,6,3)
   real(wp)  ss(6,6,3),ddc(3,6,6,3),qqc(6,6,6,3),dda(3,6,6,3)
   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij,lin,jshmax
   integer ip,jp,iat,jat,kat,ati,atj,ish,jsh,icao,jcao,iao,jao,ixyz,jxyz
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   real(wp) :: dumdum(3),dum,sdq(6,6),sdqg(3,6,6)
   real(wp),parameter :: point(3) = 0.0_wp

   integer  :: il,jl
   real(wp) :: Hij,Pii,Pij,HPij,H0sr
   real(wp) :: den,den2,den4,enpoly
   real(wp) :: zi,zj,zetaij
   real(wp) :: hii,hjj,hav
   real(wp) :: shpoly,dshpoly(3),km
   logical  :: valaoi,valaoj
   real(wp) :: g_xyz(3)

   !$omp parallel default(none) &
   !$omp private(iat,jat,ixyz,ati,cc,ci,rab2,atj,ish,ishtyp,valaoi,valaoj,g_xyz, &
   !$omp&        ri,rj,icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp,rij2, &
   !$omp&        sdq,sdqg,est,alpi,alpj,ab,iprim,jprim,ip,jp,km,shpoly,dshpoly, &
   !$omp&        mli,mlj,dum,dumdum,tmp,stmp,rij,zi,zj,zetaij,enpoly,iao,jao,t, &
   !$omp&        ii,jj,k,den,den2,den4,i,j,il,jl,hii,hjj,hav,Pij,Hij,HPij,H0sr) &
   !$omp reduction (+:g,sigma,dhdcn,dhdq) &
   !$omp shared(wsc,basis,at,nShell,hData,xyz,lattice,thr,nat,selfEnergy, &
   !$omp        dSEdcn,dSEdq,P,Pew)
   !$omp do schedule(runtime)
   do iat = 1, nat
      ri  = xyz(:,iat)
      ati = at(iat)
      do jat = 1, iat-1
         atj = at(jat)

         den = hData%electronegativity(ati) - hData%electronegativity(atj)
         den2 =  den**2
         den4 = den2**2

         ishells: do ish = 1, nShell(ati)
            ishtyp = hData%angShell(ish,ati)
            icao = basis%caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(atj)
            if(iat == jat) jshmax = ish

            jshells: do jsh = 1, jshmax
               jshtyp = hData%angShell(jsh,atj)
               jcao = basis%caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! evaluate the EN polynom for this shells
               enpoly = (1.0_wp + hData%enScale(jl-1,il-1)*den2 &
                  & + hData%enScale4*hData%enScale(jl-1,il-1)*den4)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, ati)
               zj = hData%slaterExponent(jsh, atj)
               zetaij = 2 * sqrt(zi*zj)/(zi+zj)

               ! now do the real magic (called EHT enhancement factor)
               km = hData%kScale(jl-1,il-1) * hData%pairParam(ati,atj) * zetaij * enpoly

               ! check for valence orbitals
               valaoi = hData%valenceShell(ish, ati).eq.0
               valaoj = hData%valenceShell(jsh, atj).eq.0
               ! and scale appropiately
               if (valaoi) then
                  if (valaoj) then
                     km = 0.0_wp
                  else
                     km = km * hData%kDiff
                  endif
               else
                  if (valaoj) km = km * hData%kDiff
               endif

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * km * (hii + hjj)

               wscAt: do kat = 1,wsc%itbl(jat,iat)
                  t = wsc%lattr(:,kat,jat,iat)
                  rj = xyz(:,jat) + matmul(lattice,t)
                  rij = ri - rj
                  rij2 = sum(rij**2)

                  ! distance dependent polynomial
                  call dshellPoly(hData%shellPoly(il,ati),hData%shellPoly(jl,atj),&
                     & hData%atomicRad(ati),hData%atomicRad(atj),rij2,ri,rj,&
                     & shpoly,dshpoly)

                  call get_grad_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj, &
                     &                  point,thr,basis%nprim,basis%primcount, &
                     &                  basis%alp,basis%cont,sdq,sdqg)

                  call dtrf2(sdq,ishtyp,jshtyp)
                  do ixyz = 1, 3
                     ! transform from CAO to SAO, only transform the gradient
                     tmp = sdqg(ixyz,:,:)
                     call dtrf2(tmp,ishtyp,jshtyp)
                     sdqg(ixyz,:,:) = tmp
                  enddo

                  do ii = 1, llao2(ishtyp)
                     iao = ii+basis%saoshell(ish,iat)
                     do jj = 1, llao2(jshtyp)
                        jao = jj+basis%saoshell(jsh,jat)

                        Pij = P(jao,iao) * evtoau

                        ! Hamiltonian element without overlap
                        Hij  = hav * shpoly
                        HPij = Hij * Pij

                        ! overlap contribution
                        stmp = 2*wsc%w(jat,iat) * (HPij - Pew(jao,iao))

                        ! distance dependent polynomial contribution
                        H0sr = 2*HPij*sdq(jj,ii)*wsc%w(jat,iat)
                        g_xyz = stmp*sdqg(:,jj,ii) + H0sr*dshpoly/shpoly

                        ! distribute to atom i
                        g(:,iat) = g(:,iat) + g_xyz

                        ! distribute to atom j
                        g(:,jat) = g(:,jat) - g_xyz

                        ! reduce to strain
                        sigma(:,1) = sigma(:,1) + g_xyz*rij(1)
                        sigma(:,2) = sigma(:,2) + g_xyz*rij(2)
                        sigma(:,3) = sigma(:,3) + g_xyz*rij(3)

                        ! Hamiltonian without Hav
                        HPij = km * shpoly * Pij * sdq(jj,ii) * wsc%w(jat,iat)
                        ! save dE/dCN for CNi
                        dhdcn(iat) = dhdcn(iat) + HPij*dSEdcn(ish, iat)
                        ! save dE/dCN for CNj
                        dhdcn(jat) = dhdcn(jat) + HPij*dSEdcn(jsh, jat)

                        ! save dE/dq for qi
                        dhdq(iat) = dhdq(iat) + HPij*dSEdq(ish, iat)
                        ! save dE/dq for qj
                        dhdq(jat) = dhdq(jat) + HPij*dSEdq(jsh, jat)

                     enddo
                  enddo

               enddo wscAt

            enddo jshells
         enddo  ishells

      enddo ! jat
   enddo  ! iat
   !$omp end do
   !$omp end parallel

   ! diagonal contributions
   do iat = 1, nat
      ati = at(iat)
      do ish = 1, nShell(ati)
         iao = 1+basis%saoshell(ish,iat)
         ishtyp = hData%angShell(ish,ati)
         il = ishtyp + 1
         do iao = 1, llao2(ishtyp)
            i = iao+basis%saoshell(ish,iat)
            ii = i*(1+i)/2 ! H0 is packed, note i*(i-1)/2+i = i*(1+i)/2

            Pii = P(i,i)*evtoau

            ! save dE/dCN for CNi
            dhdcn(iat) = dhdcn(iat) + Pii*dSEdcn(ish, iat)
            ! save dE/dq for qi
            dhdq(iat) = dhdq(iat) + Pii*dSEdq(ish, iat)
         end do
      end do
   end do

end subroutine ccm_build_dSH0

! ------------------------------------------------------------------------
!  Calculate the gradient resulting from a periodic AO overlap matrix
! ------------------------------------------------------------------------
subroutine pbc_build_dSH0(nShell, hData, selfEnergy, dSEdcn, dSEdq, nat, basis, &
      & thr, nao, nbf, at, xyz, trans, P, Pew, g, sigma, dHdcn, dHdq)
   use xtb_mctc_constants, only : pi
   use xtb_mctc_convert

   use xtb_type_wsc
   use xtb_type_basisset

   use xtb_intgrad
   use xtb_grad_core

   implicit none

   ! intent in
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   real(wp), intent(in) :: selfEnergy(:, :)
   real(wp), intent(in) :: dSEdcn(:, :)
   real(wp), intent(in) :: dSEdq(:, :)
   integer, intent(in)      :: nat
   type(TBasisset), intent(in) :: basis
   real(wp),intent(in)      :: thr
   integer, intent(in)      :: nao
   integer, intent(in)      :: nbf
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: xyz(3,nat)
   real(wp),intent(in) :: trans(:,:)
   real(wp),intent(in) :: P(nao,nao)
   real(wp),intent(in) :: Pew(nao,nao)
   ! intent inout
   real(wp),intent(inout) :: dHdq(nat)
   real(wp),intent(inout) :: dHdcn(nat)
   real(wp),intent(inout) :: g(3,nat)
   real(wp),intent(inout) :: sigma(3,3)

   integer, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   integer itt(0:3)
   parameter (itt=(/0,1,4,10/))
   real(wp) tmp1,tmp2,tmp3,step,step2,step3,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4
   real(wp) thr2,f,ci,cc,cj,alpi,rab2,ab,est
   real(wp) f1,f2,tmp(6,6),rij(3),ri(3),rj(3),rij2
   real(wp) stmp,ral(3,3),rar(3,3),rbl(3,3),pre
   real(wp) dtmp,qtmp,rbr(3,3),r2l(3),r2r(3),qqa(6,6,6,3)
   real(wp)  ss(6,6,3),ddc(3,6,6,3),qqc(6,6,6,3),dda(3,6,6,3)
   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij,lin,jshmax
   integer ip,jp,iat,jat,kat,ati,atj,ish,jsh,icao,jcao,iao,jao,ixyz,jxyz
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   real(wp) :: dumdum(3),dum,sdq(6,6),sdqg(3,6,6)
   real(wp),parameter :: point(3) = 0.0_wp

   integer  :: il,jl,itr
   real(wp) :: Hij,Pii,Pij,HPij,H0sr
   real(wp) :: den,den2,den4,enpoly
   real(wp) :: zi,zj,zetaij
   real(wp) :: hii,hjj,hav
   real(wp) :: shpoly,dshpoly(3),km
   logical  :: valaoi,valaoj
   real(wp) :: g_xyz(3)
   integer  :: tx,ty,tz
   real(wp) :: t(3),w

   w = 1.0_wp !/ real(product(2*latrep+1),wp)

   !$omp parallel default(none) &
   !$omp private(iat,jat,ixyz,ati,cc,ci,rab2,atj,ish,ishtyp,valaoi,valaoj,g_xyz, &
   !$omp&        ri,rj,icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp,rij2, &
   !$omp&        sdq,sdqg,est,alpi,alpj,ab,iprim,jprim,ip,jp,km,shpoly,dshpoly, &
   !$omp&        mli,mlj,dum,dumdum,tmp,stmp,rij,zi,zj,zetaij,enpoly,iao,jao, &
   !$omp&        ii,jj,k,den,den2,den4,i,j,il,jl,hii,hjj,hav,Pij,Hij,HPij,H0sr, &
   !$omp&        itr,t) &
   !$omp reduction (+:g,sigma,dhdcn,dhdq) &
   !$omp shared(basis,at,nShell,hData,xyz,thr,nat,trans,P,Pew,w,selfEnergy, &
   !$omp& dSEdcn,dSEdq)
   !$omp do schedule(runtime)
   do iat = 1, nat
      ri  = xyz(:,iat)
      ati = at(iat)
      do jat = 1, iat-1
         atj = at(jat)

         den = hData%electronegativity(ati) - hData%electronegativity(atj)
         den2 =  den**2
         den4 = den2**2

         ishells: do ish = 1, nShell(ati)
            ishtyp = hData%angShell(ish,ati)
            icao = basis%caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(atj)
            if(iat == jat) jshmax = ish

            jshells: do jsh = 1, jshmax
               jshtyp = hData%angShell(jsh,atj)
               jcao = basis%caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! evaluate the EN polynom for this shells
               enpoly = (1.0_wp + hData%enScale(jl-1,il-1)*den2 &
                  & + hData%enScale4*hData%enScale(jl-1,il-1)*den4)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, ati)
               zj = hData%slaterExponent(jsh, atj)
               zetaij = 2 * sqrt(zi*zj)/(zi+zj)

               ! now do the real magic (called EHT enhancement factor)
               km = hData%kScale(jl-1,il-1) * hData%pairParam(ati,atj) * zetaij * enpoly

               ! check for valence orbitals
               valaoi = hData%valenceShell(ish, ati).eq.0
               valaoj = hData%valenceShell(jsh, atj).eq.0
               ! and scale appropiately
               if (valaoi) then
                  if (valaoj) then
                     km = 0.0_wp
                  else
                     km = km * hData%kDiff
                  endif
               else
                  if (valaoj) km = km * hData%kDiff
               endif

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * km * (hii + hjj)

               do itr = 1, size(trans, dim=2)
                  t = trans(:, itr)
                  rj = xyz(:,jat) + t
                  rij = ri - rj
                  rij2 = sum(rij**2)

                  ! distance dependent polynomial
                  call dshellPoly(hData%shellPoly(il,ati),hData%shellPoly(jl,atj),&
                     & hData%atomicRad(ati),hData%atomicRad(atj),rij2,ri,rj,&
                     & shpoly,dshpoly)

                  call get_grad_overlap(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj, &
                     &                  point,thr,basis%nprim,basis%primcount, &
                     &                  basis%alp,basis%cont,sdq,sdqg)

                  call dtrf2(sdq,ishtyp,jshtyp)
                  do ixyz = 1, 3
                     ! transform from CAO to SAO, only transform the gradient
                     tmp = sdqg(ixyz,:,:)
                     call dtrf2(tmp,ishtyp,jshtyp)
                     sdqg(ixyz,:,:) = tmp
                  enddo

                  do ii = 1, llao2(ishtyp)
                     iao = ii+basis%saoshell(ish,iat)
                     do jj = 1, llao2(jshtyp)
                        jao = jj+basis%saoshell(jsh,jat)

                        Pij = P(jao,iao) * evtoau

                        ! Hamiltonian element without overlap
                        Hij  = hav * shpoly
                        HPij = Hij * Pij

                        ! overlap contribution
                        stmp = 2*w * (HPij - Pew(jao,iao))

                        ! distance dependent polynomial contribution
                        H0sr = 2*HPij*sdq(jj,ii)*w
                        g_xyz = stmp*sdqg(:,jj,ii) + H0sr*dshpoly/shpoly

                        ! distribute to atom i
                        g(:,iat) = g(:,iat) + g_xyz

                        ! distribute to atom j
                        g(:,jat) = g(:,jat) - g_xyz

                        ! reduce to strain
                        sigma(:,1) = sigma(:,1) + g_xyz*rij(1)
                        sigma(:,2) = sigma(:,2) + g_xyz*rij(2)
                        sigma(:,3) = sigma(:,3) + g_xyz*rij(3)

                        ! Hamiltonian without Hav
                        HPij = km * shpoly * Pij * sdq(jj,ii) * w
                        ! save dE/dCN for CNi
                        dhdcn(iat) = dhdcn(iat) + HPij*dSEdcn(ish, iat)
                        ! save dE/dCN for CNj
                        dhdcn(jat) = dhdcn(jat) + HPij*dSEdcn(jsh, jat)

                        ! save dE/dq for qi
                        dhdq(iat) = dhdq(iat) + HPij*dSEdq(ish, iat)
                        ! save dE/dq for qj
                        dhdq(jat) = dhdq(jat) + HPij*dSEdq(jsh, jat)

                     enddo
                  enddo

               enddo

            enddo jshells
         enddo  ishells

      enddo ! jat
   enddo  ! iat
   !$omp end do
   !$omp end parallel

   ! diagonal contributions
   do iat = 1, nat
      ati = at(iat)
      do ish = 1, nShell(ati)
         iao = 1+basis%saoshell(ish,iat)
         ishtyp = hData%angShell(ish,ati)
         il = ishtyp + 1
         do iao = 1, llao2(ishtyp)
            i = iao+basis%saoshell(ish,iat)
            ii = i*(1+i)/2 ! H0 is packed, note i*(i-1)/2+i = i*(1+i)/2

            Pii = P(i,i)*evtoau

            ! save dE/dCN for CNi
            dhdcn(iat) = dhdcn(iat) + Pii*dSEdcn(ish, iat)
            ! save dE/dq for qi
            dhdq(iat) = dhdq(iat) + Pii*dSEdq(ish, iat)
         end do
      end do
   end do

end subroutine pbc_build_dSH0


end module xtb_peeq

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_gfnff_gdisp0
   use xtb_mctc_accuracy, only : wp
   implicit none
   public :: d3_gradient
   private

contains

!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references(nat, atoms, wf, cn, gwvec, gwdcn)
   use xtb_disp_dftd3param
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf
   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)
   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out) :: gwdcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk

   gwvec = 0.0_wp
   gwdcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      norm = 0.0_wp
      dnorm = 0.0_wp
      do iref = 1, number_of_references(ati)
         gw = weight_cn(wf, cn(iat), reference_cn(iref, ati))
         norm = norm + gw
         dnorm = dnorm + 2*wf*(reference_cn(iref, ati) - cn(iat)) * gw
      end do
      norm = 1.0_wp / norm
      do iref = 1, number_of_references(ati)
         expw = weight_cn(wf, cn(iat), reference_cn(iref, ati))
         expd = 2*wf*(reference_cn(iref, ati) - cn(iat)) * expw

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(reference_cn(:number_of_references(ati), ati)) &
               & == reference_cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         gwvec(iref, iat) = gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         gwdcn(iref, iat) = dgwk

      end do
   end do

end subroutine weight_references

!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references_d4(dispm, nat, atoms, wf, cn, gwvec, gwdcn)
   use xtb_type_dispersionmodel, only : TDispersionModel
   type(TDispersionModel), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf
   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)
   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out) :: gwdcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk

   gwvec = 0.0_wp
   gwdcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      norm = 0.0_wp
      dnorm = 0.0_wp
      do iref = 1, dispm%nref(ati)
         gw = weight_cn(wf, cn(iat), dispm%cn(iref, ati))
         norm = norm + gw
         dnorm = dnorm + 2*wf*(dispm%cn(iref, ati) - cn(iat)) * gw
      end do
      norm = 1.0_wp / norm
      do iref = 1, dispm%nref(ati)
         expw = weight_cn(wf, cn(iat), dispm%cn(iref, ati))
         expd = 2*wf*(dispm%cn(iref, ati) - cn(iat)) * expw

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(dispm%cn(:dispm%nref(ati), ati)) &
               & == dispm%cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         gwvec(iref, iat) = gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         gwdcn(iref, iat) = dgwk

      end do
   end do

end subroutine weight_references_d4

!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6(nat, atoms, gwvec, gwdcn, c6, dc6dcn)
   use xtb_disp_dftd3param
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in) :: gwdcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj

   c6 = 0.0_wp
   dc6dcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      do jat = 1, iat
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         do iref = 1, number_of_references(ati)
            do jref = 1, number_of_references(atj)
               refc6 = get_c6(iref, jref, ati, atj)
               dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcni = dc6dcni + gwdcn(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + gwvec(iref, iat) * gwdcn(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
      end do
   end do
end subroutine get_atomic_c6

!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6_d4(dispm, nat, atoms, gwvec, gwdcn, c6, dc6dcn)
   use xtb_disp_dftd3param, only : get_c6
   use xtb_type_dispersionmodel, only : TDispersionModel
   type(TDispersionModel), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in) :: gwdcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj

   c6 = 0.0_wp
   dc6dcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      do jat = 1, iat
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         do iref = 1, dispm%nref(ati)
            do jref = 1, dispm%nref(atj)
               refc6 = dispm%c6(iref, jref, ati, atj)
               dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcni = dc6dcni + gwdcn(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + gwvec(iref, iat) * gwdcn(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
      end do
   end do
end subroutine get_atomic_c6_d4

subroutine d3_gradient(dispm, nat, at, xyz, npair, pairlist, zeta_scale, radii, &
      & r4r2, weighting_factor, dispscale, cn, dcndr, energy, gradient)
   use xtb_disp_dftd3param
   use xtb_type_dispersionmodel, only : TDispersionModel

   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in) :: nat
   integer, intent(in) :: at(:)
   real(wp), intent(in) :: xyz(:, :)
   integer, intent(in) :: npair
   integer, intent(in) :: pairlist(:, :)
   real(wp), intent(in) :: zeta_scale(:)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: radii(:)

   real(wp), intent(in) :: dispscale
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp) :: sigma(3, 3)

   integer :: max_ref
   integer :: iat, jat, ati, atj, ij, img

   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   max_ref = maxval(dispm%nref(at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      &     dc6dcn(nat, nat), energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references_d4(dispm, nat, at, weighting_factor, cn, gw, dgwdcn)

   !gw = gw*zeta_scale
   !dgwdcn = dgwdcn*zeta_scale
   call get_atomic_c6_d4(dispm, nat, at, gw, dgwdcn, c6, dc6dcn)

   !$omp parallel do default(none) schedule(runtime) &
   !$omp reduction(+:energies, gradient, sigma, dEdcn) &
   !$omp shared(at, xyz, npair, pairlist, zeta_scale, dispscale, radii, r4r2, c6, &
   !$omp&       dc6dcn) &
   !$omp private(ij, img, iat, jat, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG, dS)
   do img = 1, npair
      iat = pairlist(1, img)
      jat = pairlist(2, img)
      ij = jat + iat*(iat-1)/2
      ati = at(iat)
      atj = at(jat)
      rij = xyz(:, iat) - xyz(:, jat)
      r2 = sum(rij**2)

      r4r2ij = 3*r4r2(ati)*r4r2(atj)
      r0 = radii(lin(ati, atj))

      t6 = 1._wp/(r2**3+r0**3)
      t8 = 1._wp/(r2**4+r0**4)

      d6 = -6*r2**2*t6**2
      d8 = -8*r2**3*t8**2

      disp = (t6 + 2*r4r2ij*t8) * zeta_scale(ij)*dispscale
      ddisp= (d6 + 2*r4r2ij*d8) * zeta_scale(ij)*dispscale

      dE = -c6(iat, jat)*disp * 0.5_wp
      dG = -c6(iat, jat)*ddisp*rij
      dS = spread(dG, 1, 3) * spread(rij, 2, 3) * 0.5_wp

      energies(iat) = energies(iat) + dE
      dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
      sigma = sigma + dS
      if (iat /= jat) then
         energies(jat) = energies(jat) + dE
         dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
         gradient(:, iat) = gradient(:, iat) + dG
         gradient(:, jat) = gradient(:, jat) - dG
         sigma = sigma + dS
      endif

   enddo
   !$omp end parallel do

   call dgemv('n', 3*nat, nat, 1.0_wp, dcndr, 3*nat, dEdcn, 1, 1.0_wp, gradient, 1)
   !call dgemv('n', 9, nat, 1.0_wp, dcndL, 9, dEdcn, 1, 1.0_wp, sigma, 1)

   energy = sum(energies)

end subroutine d3_gradient

pure elemental integer function lin(i1,i2)
   integer,intent(in) :: i1,i2
   integer :: idum1,idum2
   idum1=max(i1,i2)
   idum2=min(i1,i2)
   lin=idum2+idum1*(idum1-1)/2
end function lin

real(wp) pure elemental function weight_cn(wf,cn,cnref) result(cngw)
   real(wp),intent(in) :: wf, cn, cnref
   intrinsic :: exp
   cngw = exp ( -wf * ( cn - cnref )**2 )
end function weight_cn

real(wp) pure elemental function pair_scale(iat, jat) result(scale)
   integer, intent(in) :: iat, jat
   if (iat == jat) then
      scale = 0.5_wp
   else
      scale = 1.0_wp
   endif
end function pair_scale

end module xtb_gfnff_gdisp0

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> abstract calculator that hides implementation details from calling codes
module xtb_type_calculator
   use xtb_mctc_accuracy, only : wp
   use xtb_solv_model, only : TSolvModel
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   use xtb_type_restart, only : TRestart
   implicit none

   public :: TCalculator
   private


   !> Base calculator
   type, abstract :: TCalculator

      real(wp) :: accuracy
      logical :: lSolv = .false.
      type(TSolvModel), allocatable :: solvation
      logical :: threadsafe = .true.

   contains

      !> Perform single point calculation
      procedure(singlepoint), deferred :: singlepoint

      !> Perform hessian calculation
      procedure :: hessian

      !> Write informative printout
      procedure(writeInfo), deferred :: writeInfo

   end type TCalculator


   abstract interface
      subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
            & energy, gradient, sigma, hlgap, results)
         import :: TCalculator, TEnvironment, TMolecule, TRestart, wp
         import :: scc_results

         !> Calculator instance
         class(TCalculator), intent(inout) :: self

         !> Computational environment
         type(TEnvironment), intent(inout) :: env

         !> Molecular structure data
         type(TMolecule), intent(inout) :: mol

         !> Wavefunction data
         type(TRestart), intent(inout) :: chk

         !> Print level for IO
         integer, intent(in) :: printlevel

         !> Restart from previous results
         logical, intent(in) :: restart

         !> Total energy
         real(wp), intent(out) :: energy

         !> Molecular gradient
         real(wp), intent(out) :: gradient(:, :)

         !> Strain derivatives
         real(wp), intent(out) :: sigma(:, :)

         !> HOMO-LUMO gap
         real(wp), intent(out) :: hlgap

         !> Detailed results
         type(scc_results), intent(out) :: results

      end subroutine singlepoint


      subroutine writeInfo(self, unit, mol)
         import :: TCalculator, TMolecule

         !> Calculator instance
         class(TCalculator), intent(in) :: self

         !> Unit for I/O
         integer, intent(in) :: unit

         !> Molecular structure data
         type(TMolecule), intent(in) :: mol

      end subroutine writeInfo
   end interface


contains


!> Evaluate hessian by finite difference for all atoms
subroutine hessian(self, env, mol0, chk0, list, step, hess, dipgrad)
   character(len=*), parameter :: source = "hessian_numdiff_numdiff2"
   !> Single point calculator
   class(TCalculator), intent(inout) :: self
   !> Computation environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol0
   !> Restart data
   type(TRestart), intent(in) :: chk0
   !> List of atoms to displace
   integer, intent(in) :: list(:)
   !> Step size for numerical differentiation
   real(wp), intent(in) :: step
   !> Array to add Hessian to
   real(wp), intent(inout) :: hess(:, :)
   !> Array to add dipole gradient to
   real(wp), intent(inout) :: dipgrad(:, :)

   integer :: iat, jat, kat, ic, jc, ii, jj
   type(TMolecule) :: mol
   type(TRestart) :: chk
   real(wp) :: er, el, dr(3), dl(3), sr(3, 3), sl(3, 3), egap, step2
   real(wp) :: t0, t1, w0, w1
   real(wp), allocatable :: gr(:, :), gl(:, :)
   type(scc_results) :: rr, rl

   call timing(t0, w0)
   step2 = 0.5_wp / step
   allocate(gr(3, mol0%n), gl(3, mol0%n))

   !$omp parallel do if(self%threadsafe) schedule(runtime) collapse(2) default(none) &
   !$omp shared(self, env, mol0, chk0, list, step, hess, dipgrad, egap, step2, t0, w0) &
   !$omp private(kat, iat, jat, jc, jj, ii, er, el, gr, gl, sr, sl, rr, rl, dr, dl, &
   !$omp& mol, chk, t1, w1)
   do kat = 1, size(list)
      do ic = 1, 3
         iat = list(kat)
         ii = 3*(iat - 1) + ic
         er = 0.0_wp
         el = 0.0_wp
         gr = 0.0_wp
         gl = 0.0_wp

         call mol%copy(mol0)
         mol%xyz(ic, iat) = mol0%xyz(ic, iat) + step
         call chk%copy(chk0)
         call self%singlepoint(env, mol, chk, -1, .true., er, gr, sr, egap, rr)
         dr = rr%dipole

         call mol%copy(mol0)
         mol%xyz(ic, iat) = mol0%xyz(ic, iat) - step
         call chk%copy(chk0)
         call self%singlepoint(env, mol, chk, -1, .true., el, gl, sl, egap, rl)
         dl = rl%dipole

         dipgrad(:, ii) = (dr - dl) * step2
         do jat = 1, mol0%n
            do jc = 1, 3
               jj = 3*(jat - 1) + jc
               hess(jj, ii) = hess(jj, ii) &
                  & + (gr(jc, jat) - gl(jc, jat)) * step2
            end do
         end do

         if (kat == 3 .and. ic == 3) then
            !$omp critical(xtb_numdiff2)
            call timing(t1, w1)
            write(*,'("estimated CPU  time",F10.2," min")') &
               & 0.3333333_wp*size(list)*(t1-t0)/60.0_wp
            write(*,'("estimated wall time",F10.2," min")') &
               & 0.3333333_wp*size(list)*(w1-w0)/60.0_wp
            !$omp end critical(xtb_numdiff2)
         endif

      end do
   end do
end subroutine hessian


end module xtb_type_calculator

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> TODO
module xtb_xtb_multipole
   use xtb_mctc_accuracy, only : wp
   use xtb_xtb_data, only : TMultipoleData
   implicit none
   private

   public :: TxTBMultipole, init


   type, extends(TMultipoleData) :: TxTBMultipole

      real(wp), allocatable :: gab3(:, :)

      real(wp), allocatable :: gab5(:, :)

   end type


   interface init
      module procedure :: initMultipole
   end interface init


contains


subroutine initMultipole(self, input)

   type(TxTBMultipole), intent(out) :: self

   type(TMultipoleData), intent(in) :: input

   self%TMultipoleData = input

end subroutine initMultipole


end module xtb_xtb_multipole

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> The primary driver for the xtb program package
program xtb_prog_primary
   use xtb_prog_argparser
   use xtb_prog_dock, only : xtbDock
   use xtb_prog_info, only : xtbInfo
   use xtb_prog_main, only : xtbMain
   use xtb_prog_thermo, only : xtbThermo
   use xtb_prog_topology, only : xtbTopology
   use xtb_prog_ir, only: xtbIR
   use xtb_prog_submodules
   use xtb_type_environment

   implicit none

   !> Command line argument parser
   type(TArgParser) :: argParser

   !> Calculation environment
   type(TEnvironment) :: env

   !> Requested run mode
   integer :: runMode

   !> start by initializing the MCTC library
   call mctc_init('xtb',10,.true.)

   !> Initialize calculation environment
   call init(env)

   !> Initialize argument parser from command line
   call init(argParser)

   !> Get the requested run mode
   call getRunmode(argParser, runMode)

   !> Select the correct submodule to run
   select case(runMode)
   case(xtbSubmodule%main)
      !> Run the main program
      call xtbMain(env, argParser)

   case(xtbSubmodule%info)
      !> Run the info submodule
      call xtbInfo(env, argParser)

   case(xtbSubmodule%thermo)
      !> Run the thermo submodule
      call xtbThermo(env, argParser)

   case(xtbSubmodule%topo)
      !> Run the thermo submodule
      call xtbTopology(env, argParser)

   case(xtbSubmodule%dock)
      !> Run the docking submodule
      call xtbDock(env, argParser)

   case(xtbSubmodule%ir)
      !> Run the IR submodule
      call xtbIR(env, argParser)
   end select

contains

subroutine getRunmode(argParser, runMode)

   !> Command line argument parser
   type(TArgParser), intent(inout) :: argParser

   !> Requested run mode
   integer, intent(out) :: runMode

   !> First command line argument
   character(len=:), allocatable :: argument

   !> Initialize run mode with default submodule
   runMode = xtbSubmodule%main

   !> Get first argument
   call argParser%nextArg(argument)

   !> Check if we have a command line argument
   if (allocated(argument)) then

      !> Get the identifier of the submodule
      runMode = getSubmodule(argument)

      !> In case of an invalid identifier, we reset the parser and use the default
      if (runMode == xtbSubmodule%invalid) then
         call argParser%reset
         runMode = xtbSubmodule%main
      end if

   end if

end subroutine getRunmode

end program xtb_prog_primary

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Pauli exchange approximation
module xtb_ptb_paulixc
#if WITH_TBLITE
   !> mctc-lib
   use mctc_env, only: error_type, wp
   use mctc_io, only: structure_type

   use tblite_blas, only: gemm
   use tblite_basis_type, only: basis_type
   use tblite_integral_multipole, only: msao

   use xtb_ptb_vdzp, only: max_shell

   implicit none
   private

   public :: calc_Vxc_pauli

   interface calc_Vxc_pauli
      module procedure calc_Vxc_pauli_shellscaling
      module procedure calc_Vxc_pauli_atomscaling
   end interface calc_Vxc_pauli

contains

   subroutine calc_Vxc_pauli_atomscaling(mol, bas, psh, Sxc, selfenergies, katom, potential)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> shell populations
      real(wp), intent(in) :: psh(:)
      !> Overlap matrix scaled for XC potential
      real(wp), intent(in) :: Sxc(:, :)
      !> Self-energies (levels)
      real(wp), intent(in) :: selfenergies(:)
      !> Atom-specific scaling factors
      real(wp), intent(in) :: katom(:)
      !> Vxc potential
      real(wp), intent(inout) :: potential(:, :)

      !> shell-specific scaling factors
      real(wp), allocatable :: kshell(:, :)
      !> Loop indices
      integer :: ii, ish

      allocate (kshell(max_shell, mol%nid), source=0.0_wp)

      !> element scaling in first iter to decouple 1. and 2. iter and
      !> to account for missing P-dependent term of 2. iter
      !> HERE: Projection of atom-wise scaling factors onto shells
      do ii = 1, mol%nid
         do ish = 1, bas%nsh_id(ii)
            kshell(ish, ii) = katom(ii)
         end do
      end do

      call calc_Vxc_pauli(mol, bas, psh, Sxc, selfenergies, kshell, potential)
   end subroutine calc_Vxc_pauli_atomscaling

   subroutine calc_Vxc_pauli_shellscaling(mol, bas, psh, Sxc, selfenergies, kshell, potential)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> shell populations
      real(wp), intent(in) :: psh(:)
      !> Overlap matrix (scaled) for XC potential
      real(wp), intent(in) :: Sxc(:, :)
      !> Self-energies (levels)
      real(wp), intent(in) :: selfenergies(:)
      !> Shell-specific scaling factors
      real(wp), intent(in) :: kshell(:, :)
      !> Vxc potential
      real(wp), intent(inout) :: potential(:, :)

      real(wp) :: f1
      real(wp), allocatable :: stmp(:, :)
      integer :: i, jat, jzp, js, jsh, jj, jao, ml

      !> debug mode
      logical, parameter :: debug(2) = [ .false., .false.]

      allocate (stmp(bas%nao, bas%nao))

      !> N^2 step
      do i = 1, bas%nao
         do jat = 1, mol%nat
            jzp = mol%id(jat)
            js = bas%ish_at(jat)
            do jsh = 1, bas%nsh_id(jzp) !> Iteration over core shells of atom jat
               jj = bas%iao_sh(js + jsh)
               ml = msao(bas%cgto(jsh, jat)%ang)
               f1 = psh(js + jsh) * kshell(jsh, jzp) / dble(ml) ! shell wise scaling

               if (debug(1)) then !##### DEV WRITE #####
                  if (i == 1) then
                     write (*, '(a,i0,a,i0,a,f8.4,a,f8.4,a,f8.4,a,f8.4)') "shell: ", jsh, " atom: ", jat, " f1: ", f1, &
                  & " psh: ", psh(js + jsh), " cnf2: ", kshell(jsh, jzp), " nl: ", dble(ml)
                  end if
               endif
               
               do jao = 1, ml
                  stmp(jj + jao, i) = selfenergies(js + jsh) * Sxc(jj + jao, i) * f1
                  
                  if (debug(2)) & !##### DEV WRITE #####
                     write(*,*) "stmp: ", jj + jao, i, stmp(jj + jao, i)
                 
               end do
            end do
         end do
      end do

      !> N^3 step
      call gemm(Sxc, stmp, potential, beta=1.0_wp)

   end subroutine calc_Vxc_pauli_shellscaling

#endif
end module xtb_ptb_paulixc

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      module esp
      contains
      subroutine espplot(n,nmo,nbf,at,xyz,z,occ,C,basis)
      use xtb_mctc_systools
      use xtb_type_basisset
      use xtb_intpack
      use xtb_printout, only : writecosmofile
      use xtb_setparam, only : set, get_namespace
      implicit none
      type(TBasisset), intent(in) :: basis
      integer nproc,n,nbf,nmo,at(n)
      real*8 xyz(3,n),z(n),occ(nmo),C(nbf,nmo)
      integer,external :: omp_get_num_threads

      real*8,allocatable :: pa(:,:),espe(:), atom_weight(:,:)
      real*8,allocatable :: ee(:,:),efact(:),gama(:),dd(:,:)
      real*8,allocatable :: P(:)
      integer,allocatable:: indp(:,:),nnn(:)
      real*8 point(3),rx,ry,rz,r,intcut,t0,t1,w0,w1,pthr,av
      character(len=:),allocatable :: grid_file
      character(len=:),allocatable :: line
      integer :: err

      integer i,j,k,l,m,done,mprim,npp,ind1,ind2,np
      logical ex

      nproc = 1
      !$ nproc = omp_get_num_threads()
      intcut=10. ! loose primitive cut-off, =20 makes a factor of 2 compared to =10
                 ! errors are around 1e-4 Eh for Etoposid
      pthr=1.d-4 ! -4 def

      if (allocated(set%esp_gridfile)) then
          grid_file = set%esp_gridfile
      else
          grid_file = get_namespace('esp_coord')
      endif

      write(*,*)
      write(*,*)'ESP plotting routine'
      inquire(file=grid_file,exist=ex)
      if(ex) write(*,*)
     &'reading <esp_coord> for xyz triples (in Bohr) to be used'
      write(*,*)'writing <xtb_esp.dat> and <xtb_esp_profile.dat>'

!     call setfmc

      if(.not.ex) call surfac(grid_file,n,xyz,at) ! generate surface coords

      open(unit=83,file=grid_file)
      open(unit=84,file='xtb_esp.dat')

      write(*,*)'computing CAO density maxtrix ...'
      allocate(P(nbf*(nbf+1)/2))
      P=0
      do i=1,nmo
         if(occ(i).gt.1.d-6) then
            m=0
            do k=1,nbf
               do l=1,k-1
                  m=m+1
                  P(m)=P(m)+occ(i)*C(k,i)*C(l,i)*2.0 ! include factor of 2 from contraction loop
               enddo
               m=m+1
               P(m)=P(m)+occ(i)*C(k,i)*C(k,i)
            enddo
         endif
      enddo

!     compute primitive pair data
      write(*,*)'computing primitive pair data ...'
      call preints(n,nbf,xyz,intcut,mprim,npp,pthr,P,basis)
      allocate(efact(npp),gama(npp),ee(3,npp),dd(35,npp),
     &         nnn(npp),indp(mprim,mprim))
      rewind(103)
      indp = 0
      do i=1,npp
         read(103)ind1,ind2,nnn(i),efact(i),gama(i),ee(1:3,i),dd(1:35,i)
         indp(ind1,ind2)=i
      enddo
      close(103,status='delete')

!     write(*,*)
!    &' Cartesian coordinates                     ESP (Hartree)'
      done=0
 10   continue
      read(83,*,end=100) point
      done=done+1
      goto 10
100   continue

      np=done
      allocate(pa(3,np),espe(np))
      allocate(atom_weight(2,np))
      rewind(83)
      do i=1,np
         call getline(83,line,err)
         if(err.ne.0)call raise('E',"Could not read points for ESP!")
         read(line,*,iostat=err) pa(1:3,i), atom_weight(1:2,i)
         if (err.ne.0) then
            read(line,*,iostat=err) pa(1:3,i)
            if (err.ne.0) call raise('E',"Could not read coordinates!")
         endif
      enddo
      write(*,*) np,' points read.'
      call timing(t0,w0)
      point=0
      call espints(n,nbf,xyz,intcut,point,pthr,P,
     &             mprim,npp,nnn,indp,efact,gama,ee,dd,espe(i),basis)
      call timing(t1,w1)
      write(*,'('' estimated wall time (s) '',f6.1)') np*(w1-w0)/nproc
      write(*,*)'computing ESP ...'

!$OMP  PARALLEL PRIVATE(i,rx,ry,rz,r,point)
!$OMP& SHARED(espe,pa,basis)
!$OMP& DEFAULT(SHARED)
!$OMP DO
      do i=1,np
!     ESP at point(3)
      espe(i)=0
      point(1:3)=pa(1:3,i)
!     core
      do j=1,n
         rx=xyz(1,j)-point(1)
         ry=xyz(2,j)-point(2)
         rz=xyz(3,j)-point(3)
         r=dsqrt(rx**2+ry**2+rz**2)
         espe(i)=espe(i)+z(j)/(1.0d-14+r)
      enddo
!     ints and contraction with P
      call espints(n,nbf,xyz,intcut,point,pthr,P,
     &             mprim,npp,nnn,indp,efact,gama,ee,dd,espe(i),basis)
      enddo
!$OMP END DO
!$OMP END PARALLEL

      av=0
      do i=1,np
         write(84,'(3E18.10,F14.8)') pa(1:3,i),espe(i)
!        write(*, '(3E14.6,F14.8 )') pa(1:3,i),espe(i)
         av=av+espe(i)
      enddo
      call writecosmofile(np,pa,espe,get_namespace('xtb_esp.cosmo')
     & ,n,at,xyz,atom_weight)
      write(*,'(''maximum/minimum/av ESP value :'',3F12.6)')
     &          maxval(espe),minval(espe),av/np

      call histo(1,np,espe,'xtb_esp_profile.dat')

      if(.not.ex) then
          close(83,status='delete')
      else
          close(83)
      endif
      close(84)

      end


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine espints(n,nbf,xyz,intcut,point,pthr,P,
     &                   mprim,npp,nnn,indp,efact,gama,ee,dd,espe,basis)
      use xtb_type_basisset
      use xtb_intpack
      implicit none
      type(TBasisset), intent(in) :: basis
      integer n,nbf
      integer mprim,npp,indp(mprim,mprim),nnn(npp)
      real*8  P (nbf*(nbf+1)/2)
      real*8  xyz(3,n)
      real*8  point(3)
      real*8  efact(npp),gama(npp),ee(3,npp),dd(35,npp)
      real*8  espe,intcut,pthr

      integer i,j,k,l,iprimcount,jprimcount,ppp
      integer npri,nprj,ii,iii,jj,jjj,ll,m,li,lj,mm,nn
      real*8  xyza(3),xyzb(3),rab,est,gam,arg
      real*8  tt1,ttt,thr,cce,pthr2

      pthr2=pthr*5.d-3

      k=0
      iprimcount=0
      do i=1,nbf
! aufpunkt i
         xyza(1:3)=xyz(1:3,basis%aoat(i))
! #prims
         npri=basis%nprim(i)
         jprimcount=0
         do j=1,i
            k=k+1
            nprj=basis%nprim(j)
            if(abs(P(k)).lt.pthr) goto 42   ! loose P mat neglect threshold
! aufpunkt j
              xyzb(1:3)=xyz(1:3,basis%aoat(j))
! prim loop
              tt1=0.0d0
              do ii=1,npri
                 iii=iprimcount+ii
                 do jj=1,nprj
                    jjj=jprimcount+jj
                    ppp=indp(iii,jjj)
! cutoff
                    if(ppp.gt.0)then
!                   call propa(opaa0,xyza,xyzb,point,
!    &                         alp(iii),alp(jjj),
!    &                         lao(i),lao(j),ttt,1)
                    cce=basis%cont(iii)*basis%cont(jjj)*efact(ppp)*P(K)
                    if(abs(cce).gt.pthr2)then
                    call propa1(opaa0,point,nnn(ppp),
     &                         gama(ppp),ee(1,ppp),dd(1,ppp),
     &                         ttt)
                    tt1=tt1+ttt*cce
                    endif
                    endif
                 enddo
              enddo
            espe=espe-tt1
 42         jprimcount=jprimcount+nprj
         enddo
         iprimcount=iprimcount+npri
      enddo

      end

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine preints(n,nbf,xyz,intcut,nprimp,ppair,pthr,P,basis)
      use xtb_type_basisset
      use xtb_intpack
      implicit none
      type(TBasisset), intent(in) :: basis
      integer n,nbf,nprimp,ppair
      real*8  P(nbf*(nbf+1)/2)
      real*8  xyz(3,n),intcut,pthr

      integer i,j,k,l,iprimcount,jprimcount
      integer npri,nprj,ii,iii,jj,jjj,ll,m,li,lj,mm,nn
      real*8  xyza(3),xyzb(3),rab,est,gama,arg,cc

      open(unit=103,file='xtb_TMP',form='unformatted')

      k=0
      ppair=0
      iprimcount=0
      do i=1,nbf
! aufpunkt i
         xyza(1:3)=xyz(1:3,basis%aoat(i))
! #prims
         npri=basis%nprim(i)
         jprimcount=0
         do j=1,i
            k=k+1
            nprj=basis%nprim(j)
            if(abs(P(k)).lt.pthr) goto 42   ! loose P mat neglect threshold
! aufpunkt j
              xyzb(1:3)=xyz(1:3,basis%aoat(j))
              rab=(xyza(1)-xyzb(1))**2
     &           +(xyza(2)-xyzb(2))**2
     &           +(xyza(3)-xyzb(3))**2
! prim loop
              do ii=1,npri
                 iii=iprimcount+ii
                 do jj=1,nprj
                    jjj=jprimcount+jj
                    gama=1.0d0/(basis%alp(iii)+basis%alp(jjj))
                    est=rab*basis%alp(iii)*basis%alp(jjj)*gama
                    cc=basis%cont(iii)*basis%cont(jjj)
! cutoff
                    if(est.lt.intcut.and.abs(cc*P(k)).gt.1.d-5)then
                    ppair=ppair+1
                    call propa0(xyza,xyzb,
     &                         basis%alp(iii),basis%alp(jjj),
     &                         basis%lao(i),basis%lao(j),iii,jjj)
                    endif
                 enddo
              enddo
 42         jprimcount=jprimcount+nprj
         enddo
         iprimcount=iprimcount+npri
      enddo
      nprimp=iprimcount

      write(*,*) 'number of prim pairs',ppair

      end

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine propa0(a,b,etaij4,etakl4,iff1,iff2,ind1,ind2)
      use xtb_intpack
      implicit real*8(a-h,o-z)
! aufpunkte
      real*8 a(3),b(3)
! local
      common /abfunc/ ra(3),rb(3),ga,gb,ia,ib
      dimension d(3),dd(84),ddd(35)
      dimension e(3),aa(20),bb(20)
      dimension lin(84),min(84),nin(84)
      data lin/0,1,0,0,2,0,0,1,1,0,3,0,0,2,2,1,0,1,0,1,4,0,0,3,3,1,0,1,0
     1 ,2,2,0,2,1,1,5,0,0,3,3,2,2,0,0,4,4,1,0,0,1,1,3,1,2,2,1,6,0,0,3,
     2 3,0,5,5,1,0,0,1,4,4,2,0,2,0,3,3,1,2,2,1,4,1,1,2/,min/0,0,1,0,0,
     3 2,0,1,0,1,0,3,0,1,0,2,2,0,1,1,0,4,0,1,0,3,3,0,1,2,0,2,1,2,1,0,5,
     4 0,2,0,3,0,3,2,1,0,4,4,1,0,1,1,3,2,1,2,0,6,0,3,0,3,1,0,0,1,5,5,2,0
     5,0,2,4,4,2,1,3,1,3,2,1,4,1,2/,nin/0,0,0,1,0,0,2,0,1,1,0,0,3,0,1,0,
     6 1,2,2,1,0,0,4,0,1,0,1,3,3,0,2,2,1,1,2,0,0,5,0,2,0,3,2,3,0,1,0,1,
     7 4,4,3,1,1,1,2,2,0,0,6,0,3,3,0,1,5,5,1,0,0,2,4,4,0,2,1,2,2,3,1,3,
     8 1,1,4,2/

! --- a,b are centres of gaussians
      ra = a
      rb = b
! --- ga,gb are their exponents
      ga=etaij4
      gb=etakl4
      aa = 0
      bb = 0
      aa(iff1)=1.0d0
      bb(iff2)=1.0d0
      ia=iff1
      ib=iff2
! --- ia,ib are the canonical indices for monom
! --- apply product theorem
      cij=0.0d0
      ckl=0.0d0
      call divpt(a,etaij4,b,etakl4,cij,ckl,e,gama,efact)

! --- calculate cartesian prefactor for first gaussian
      call rhftce(aa,a,e,iff1)
! --- calculate cartesian prefactor for second gaussian
      call rhftce(bb,b,e,iff2)
! --- form their product
      call prod(aa,bb,dd,iff1,iff2)

      ddd(1:35)=dd(1:35)
      call lprimprod(iff1,iff2,nnn)  ! l-type of pair
      write(103) ind1,ind2,nnn,efact,gama,e,ddd

      end

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! no f-functions !

      subroutine propa1(aname,c,nnn,gama,e,dd,va)
      use xtb_intpack
      implicit real*8(a-h,o-z)
      external aname
! aufpunkte,ref point,intarray
      real*8 c(3),va,dd(35),e(3)  ! dd(84) for f-fct
! local
      dimension lin(84),min(84),nin(84),d(3)
      data lin/0,1,0,0,2,0,0,1,1,0,3,0,0,2,2,1,0,1,0,1,4,0,0,3,3,1,0,1,0
     1 ,2,2,0,2,1,1,5,0,0,3,3,2,2,0,0,4,4,1,0,0,1,1,3,1,2,2,1,6,0,0,3,
     2 3,0,5,5,1,0,0,1,4,4,2,0,2,0,3,3,1,2,2,1,4,1,1,2/,min/0,0,1,0,0,
     3 2,0,1,0,1,0,3,0,1,0,2,2,0,1,1,0,4,0,1,0,3,3,0,1,2,0,2,1,2,1,0,5,
     4 0,2,0,3,0,3,2,1,0,4,4,1,0,1,1,3,2,1,2,0,6,0,3,0,3,1,0,0,1,5,5,2,0
     5,0,2,4,4,2,1,3,1,3,2,1,4,1,2/,nin/0,0,0,1,0,0,2,0,1,1,0,0,3,0,1,0,
     6 1,2,2,1,0,0,4,0,1,0,1,3,3,0,2,2,1,1,2,0,0,5,0,2,0,3,2,3,0,1,0,1,
     7 4,4,3,1,1,1,2,2,0,0,6,0,3,3,0,1,5,5,1,0,0,2,4,4,0,2,1,2,2,3,1,3,
     8 1,1,4,2/

      va =0
!     e is center of product gaussian with exponent gama, c is reference point
      d = e - c
!     aname represents an external function
      do i=1,nnn
         if (dabs(dd(i))-1.d-8 .gt. 0.d0) then
            call aname(lin(i),min(i),nin(i),gama,v,d)
            va=dd(i)*v+va
         end if
      end do
      return

      end

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine histo(n1,n2,aval,ftmp)
      implicit none
      integer n1,n2
      real*8 aval(*)
      character*(*) ftmp

      real*8 mina,maxa,dx,val,bin1,bin2,dum,du
      integer i,j,k,nbin,bin(10)

      nbin=10
      mina= 1.d+42
      maxa=-1.d+42
      do i=n1,n2
         if(aval(i).lt.mina)mina=aval(i)
         if(aval(i).gt.maxa)maxa=aval(i)
      enddo
      mina=mina-1.d-2
      maxa=maxa+1.d-2
      dx=(maxa-mina)/(nbin)

      bin=0
      do i=n1,n2
         val=aval(i)
         bin1=mina
         do k=1,nbin
            bin2=bin1+dx
            if(val.ge.bin1.and.val.lt.bin2)then
            bin(k)=bin(k)+1
            endif
            bin1=bin1+dx
         enddo
      enddo

      dum=0
      do i=1,nbin
         dum=dum+dx*bin(i)
      enddo

      open(unit=11,file=ftmp)
      bin1=mina
      do i=1,nbin
         du=bin1+0.5*dx
         write(11,*) du,bin(i)/dum
         bin1=bin1+dx
      enddo
!     write(11,*)n2-n1+1
!     do i=n1,n2
!        write(11,*) aval(i)
!     enddo
      close(11)

      end subroutine histo

      subroutine lprimprod(iff1,iff2,nnn)
      implicit none
      integer iff1,iff2,nnn

      if(iff1.gt.4.or.iff2.gt.4) goto 120
      if(iff1.gt.1.or.iff2.gt.1) goto 130
!           s - s
      nnn=1
      return
  130 continue
      if(iff1.ne.1.and.iff2.ne.1) goto 131
!           s - p
      nnn=4
      return
  131 continue
!           p - p
      nnn=10
      return
  120 continue
      if(iff1.ne.1.and.iff2.ne.1) goto 121
!           s - d
      nnn=10
      return
  121 continue
      if(iff1.gt.4.and.iff2.gt.4) goto 122
!           p - d
      nnn=20
      return
  122 continue
!           d - d
      nnn=35

      end subroutine lprimprod
      end module esp

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_geoopt
contains

!> wrapper for relaxation engines
!> more info: https://xtb-docs.readthedocs.io/en/latest/optimization.html 
subroutine geometry_optimization &
      &   (env,mol,wfn,calc,egap,et,maxiter,maxcycle_in,etot,g,sigma, &
      &    tight,pr,initial_sp,fail)

   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_optimizer
   use xtb_relaxation_engine
   use xtb_single
   ! modules for PBC opt with LBFGS including lattice optimization
   use xtb_pbc_optimizer_driver, only : relax_pbc
   use xtb_pbc_optimizer_lbfgs, only : optimizer_type, lbfgs_optimizer, new_lbfgs_optimizer
   use xtb_pbc_optimizer_lbfgs, only : lbfgs_input
   use xtb_pbc_optimizer_filter_cart, only : cartesian_filter, new_cartesian_filter
   use xtb_setparam

   implicit none
   
   character(len=*), parameter :: source = 'xtb_geoopt'
   
   !> instace of polymorphic calculatior
   class(TCalculator), intent(inout) :: calc
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> molecular data information
   type(TMolecule), intent(inout) :: mol

   !> wavefunction
   type(TRestart),intent(inout) :: wfn
   
   !> optimization level
   integer, intent(in)    :: tight

   !> max number of SCC cycles
   integer, intent(in)    :: maxiter
   
   !> max number of optimization cycles
   integer, intent(in)    :: maxcycle_in
   
   !> total energy
   real(wp),intent(inout) :: etot
   
   !> electronic temperature 
   real(wp),intent(in)    :: et
   
   !> HOMO-LUMO gap
   real(wp),intent(inout) :: egap
   
   !> gradients
   real(wp),intent(inout) :: g(3,mol%n)
   
   !> strain derivatives
   real(wp),intent(inout) :: sigma(3,3)
   
   !> internal printlevel 
   logical, intent(in)    :: pr
   
   !> optimization convergence
   logical, intent(out)   :: fail
   
   !> perform initial single point 
   logical, intent(in)    :: initial_sp

   type(scc_results) :: res
   logical :: final_sp, exitRun
   integer :: printlevel
   integer :: ilog
   ! for PBC optimization with lbfgs (including lattice optimization)
   logical :: optcell
   type(lbfgs_optimizer) :: lbfgs_opt
   type(lbfgs_input) :: opt_input
   type(cartesian_filter)  :: filter

!----------------!
! Initialization !
!----------------!

   final_sp = pr

   if (pr) then
      call delete_file('NOT_CONVERGED')
      call delete_file('.xtboptok')
      printlevel = 2
   else
      printlevel = 0
   endif
   
   ! create/open optimization log !
   if (.not.allocated(set%opt_logfile)) then
      call open_file(ilog,'xtbopt.log','w')
   else
      if (set%opt_logfile == '-') then
         ilog = stdout
      else
         call open_file(ilog,set%opt_logfile,'w')
         if (pr) write(stdout,'(/,a)') &
            "Optimization log is written to '"//set%opt_logfile//"'"
      endif
   endif
   
   ! create ONIOM optimization logs for low & high methods ! 
   if (set%oniom_settings%logs) then
      call open_file(set%oniom_settings%ilog1,"low.inner_region.log",'w')
      call open_file(set%oniom_settings%ilog2,"high.inner_region.log",'w')
   endif

   call mol%update ! update interatomic and minimum image (periodic) distances 

!-------------!
! Calculation !
!-------------!

   if (initial_sp)  call singlepoint &
         &(env,mol,wfn,calc, &
         & egap,et,maxiter,printlevel-1,.false.,.false.,1.0_wp,etot,g,sigma,res)

   select case(set%opt_engine)
   case(p_engine_rf) ! ANCopt !
      call ancopt &
         &(env,ilog,mol,wfn,calc, &
         & egap,et,maxiter,maxcycle_in,etot,g,sigma,tight,pr,fail)
      final_sp = .true. ! required since ANCopt might perform an untracked displacement 
   
   case(p_engine_lbfgs)
      call l_ancopt & ! L-ANCopt !
         &(env,ilog,mol,wfn,calc, &
         & tight,maxcycle_in,etot,egap,g,sigma,printlevel,fail)
   case(p_engine_pbc_lbfgs)
     ! get number of unique species; used in precond_lindh
     !call get_identity(mol%nid, mol%id, mol%at)
     ! create new anc filter
     optcell = mol%npbc > 0 .and. set%optcell
     call new_cartesian_filter(filter, mol, optcell)
     ! create new Limited-memory BFGS optimizer 
     call new_lbfgs_optimizer(lbfgs_opt, env, opt_input, filter)
     ! run optimization
     call relax_pbc(lbfgs_opt, env, mol, wfn, calc, filter, printlevel)
   case(p_engine_inertial)
      call fire & ! FIRE !
         &(env,ilog,mol,wfn,calc, &
         & tight,maxcycle_in,etot,egap,g,sigma,printlevel,fail)
   
   end select
  
!-----------------!
! Post-processing !
!-----------------!

   ! check convergence !
   if (pr) then
      if (fail) then
         call touch_file('NOT_CONVERGED')
         call env%warning("Geometry optimization did not converge", source)
      else
         call touch_file('.xtboptok')
      endif
   end if

   call env%check(exitRun) ! error check 

   if (exitRun) then
      call env%rescue("Trying to recover from failed geometry optimization", source)
      fail = .true.
   end if
   
   ! print fine details of optimized geometry !
   if (pr.and.set%pr_finalstruct) then
      write(env%unit,'(''================'')')
      write(env%unit,*) 'final structure:'
      write(env%unit,'(''================'')')
      call writeMolecule(mol, env%unit)
   endif
   if (pr.and.set%pr_geosum) call geosum(mol%n,mol%at,mol%xyz)
   
   ! final SP (usually for all engines) !
   if (final_sp) then
      if (pr) call generic_header(env%unit,'Final Singlepoint',49,10)
      call singlepoint &
         &(env,mol,wfn,calc, &
         & egap,et,maxiter,printlevel,.false.,.false.,1.0_wp,etot,g,sigma,res)
   endif
   
   ! close log file !
   if (ilog.ne.stdout) call close_file(ilog)
   
   ! close ONIOM optlogs !
   if (set%oniom_settings%logs) then
      call close_file(set%oniom_settings%ilog1)
      call close_file(set%oniom_settings%ilog2)
   endif

end subroutine geometry_optimization

end module

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Interfaces to BLAS
module xtb_mctc_blas
   use xtb_mctc_blas_level1, only : blas_asum, blas_axpy, blas_copy, blas_dot, &
      & blas_dotc, blas_dotu, blas_nrm2, blas_rot, blas_scal, blas_swap, &
      & blas_iamax, blas_cabs1
   use xtb_mctc_blas_level2, only : blas_gbmv, blas_gemv, blas_ger, blas_gerc, &
      & blas_geru, blas_hbmv, blas_hemv, blas_her, blas_her2, blas_hpmv, &
      & blas_hpr, blas_hpr2, blas_sbmv, blas_spmv, blas_spr, blas_spr2, &
      & blas_symv, blas_syr, blas_syr2, blas_tbmv, blas_tbsv, blas_tpmv, &
      & blas_tpsv, blas_trmv, blas_trsv
   use xtb_mctc_blas_level3, only : blas_gemm, blas_hemm, blas_herk, blas_her2k, &
      & blas_symm, blas_syrk, blas_syr2k, blas_trmm, blas_trsm
   use xtb_mctc_blas_wrap1
   use xtb_mctc_blas_wrap2
   use xtb_mctc_blas_wrap3
   implicit none
   public

end module xtb_mctc_blas

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_sphereparam
   use xtb_mctc_accuracy, only : wp
   implicit none
   private :: wp
   public

   integer,parameter :: p_type_polynomial = 1
   integer,parameter :: p_type_logfermi   = 2
   integer  :: spherepot_type = p_type_polynomial

   integer,parameter :: p_cent_zero = 1
   integer,parameter :: p_cent_com  = 2
   integer,parameter :: p_cent_cog  = 3
   integer  :: spherecent = p_cent_zero

   integer,parameter :: p_auto_dist = 1
   integer,parameter :: p_auto_dens = 2
   integer,parameter :: p_auto_force  = 3
   integer  :: sphereauto = p_auto_dist

   integer  :: maxwalls = 0

!  old, only needed for QCG mode of docking
   real(wp) :: boxr = -1.0_wp
   real(wp) :: rabc(3) = (/-1.0_wp,-1.0_wp,-1.0_wp/)
   integer  :: sphere = -1

   integer  :: sphere_alpha = 30
   real(wp) :: sphere_beta  = 6.0_wp
   real(wp) :: sphere_temp  = 300.0_wp
   real(wp) :: sphere_autoscale = 1.0_wp
   real(wp) :: sphere_shift = 3.5_wp

   type :: tb_wall
      integer  :: fragment = 0
      integer,allocatable :: list(:)
      real(wp) :: radius(3) = 0.0_wp
      real(wp) :: center(3) = 0.0_wp
   end type tb_wall

   integer :: number_walls
   type(tb_wall),allocatable :: wpot(:)

   interface set_sphere_radius
      module procedure set_sphere_radius_iso
      module procedure set_sphere_radius_aniso
   end interface

   interface get_sphere_radius
      module procedure get_sphere_radius_list
      module procedure get_sphere_radius_fragment
      module procedure get_sphere_radius_all
   end interface

!  I need to implement this first...
!   interface get_ellipsoid_radius
!      module procedure get_ellipsoid_radius_list
!      module procedure get_ellipsoid_radius_fragment
!      module procedure get_ellipsoid_radius_all
!   end interface

!  original wall potential
   interface polynomial_cavity
      module procedure polynomial_cavity_list
      module procedure polynomial_cavity_frag
      module procedure polynomial_cavity_all
   end interface polynomial_cavity

! `bias function' by M. Shiga and M. Masia, J. Chem. Phys. 139, 044120 (2013).
!  http://dx.doi.org/10.1063/1.4816629
!  E = -Σi kT·log{1/(1+exp[-α(R0-Ri)])} = Σi kT·log{1+exp[-α(R0-Ri)]}
!  NOTE: since this is defined only for isotropic spheres, therefore we cannot
!        use anisotropic ellipsoid axis, but have to change the metric of the
!        cartesian coordinates (this is done by redefining the scalarproduct)
   interface logfermi_cavity
      module procedure logfermi_cavity_list
      module procedure logfermi_cavity_frag
      module procedure logfermi_cavity_all
   end interface logfermi_cavity

contains

!! ========================================================================
!  get some space for wall potentials, maxwalls is counted in rdcontrol
!  in setparam.f90 and is supposed to be the maximal number of possible
!  walls
subroutine init_walls
   call clear_walls
   allocate ( wpot(maxwalls) )
end subroutine init_walls

!! ========================================================================
!  clean up the heap space for reallocating or termination of the program
subroutine clear_walls
   if (allocated(wpot)) deallocate(wpot)
end subroutine clear_walls

!! ========================================================================
!  argument setter for interaction with this module in setparam.f90,
!  isotropic and anisotropic spheres are overloaded in one function
subroutine set_sphere_radius_iso(radius,center,nlist,list,fragment)
   implicit none
   real(wp),intent(in) :: radius
   real(wp),intent(in),optional :: center(3)
   integer, intent(in),optional :: nlist,list(:)
   integer, intent(in),optional :: fragment
   number_walls = number_walls + 1
   if (number_walls.gt.maxwalls) & ! This should never happen
   &  call raise('E','Number of wall potentials exceeded provided array size')
   wpot(number_walls)%radius = radius
   if (present(center)) wpot(number_walls)%center = center
   if (present(list).and.present(nlist)) &
   &  allocate( wpot(number_walls)%list(nlist), source = list(1:nlist) )
   if (present(fragment)) wpot(number_walls)%fragment = fragment
end subroutine set_sphere_radius_iso
subroutine set_sphere_radius_aniso(radius,center,nlist,list,fragment)
   implicit none
   real(wp), intent(in) :: radius(3)
   real(wp),intent(in),optional :: center(3)
   integer, intent(in),optional :: nlist,list(:)
   integer, intent(in),optional :: fragment
   number_walls = number_walls + 1
   if (number_walls.gt.maxwalls) & ! If this happens, you used it wrong!
   &  call raise('E','Number of wall potentials exceeded provided array size')
   wpot(number_walls)%radius = radius
   if (present(center)) wpot(number_walls)%center = center
   if (present(list).and.present(nlist)) &
   &  allocate( wpot(number_walls)%list(nlist), source = list(1:nlist) )
   if (present(fragment)) wpot(number_walls)%fragment = fragment
end subroutine set_sphere_radius_aniso

!! ========================================================================
!  determine sphere radius such that all atoms fit in
!  requires cema trafo (not done)
!! ------------------------------------------------------------------------
!  this is the old subroutine, not used anywhere anymore, I think...
subroutine getsphererad(n,at,xyz)
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   real(wp) :: dum(3),rx,ry,rz
   real(wp) :: x,y,z,f,rr,r
   integer  :: i,j

!  call axis3(0,n,at,xyz,xyz2,dum)

!  xyz = xyz2

   r=0.0_wp
   do i=1,n-1
      do j=i+1,n
         rx=xyz(1,i)-xyz(1,j)
         ry=xyz(2,i)-xyz(2,j)
         rz=xyz(3,i)-xyz(3,j)
         rr=sqrt(rx**2+ry**2+rz**2)
         if(rr.gt.r) r=rr
      enddo
   enddo

   boxr=0.5*r+3.5d0 ! assume some vdW radius
!  this is wrong, because the cavity uses a relative measure for the constrain,
!  but here it is treated as an absolute measure, using this routine will
!  artifically compress larger molecules. I should fix this, dunno how.

end subroutine getsphererad

!! --------------------------------------------------------------[SAW1809]-
!  new version
subroutine get_sphere_radius_list(nat,at,xyz,nlist,list,center,radius,do_trafo)
   use xtb_axis, only : axis3
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: nlist
   integer, intent(in)  :: list(nlist)
   real(wp),intent(out) :: center(3)
   real(wp),intent(out) :: radius
   logical, intent(in)  :: do_trafo

   integer  :: i,j
   real(wp) :: max_distance,distance,dum(3)
   real(wp),allocatable :: coord(:,:)
   logical  :: trafo
   optional :: do_trafo

   center = 0.0_wp

   if (present(do_trafo)) then
      trafo = do_trafo
   else
      trafo = .false.
   endif

   if (trafo) then
      allocate( coord(3,nat), source = 0.0_wp )
      call axis3(0,nat,at,xyz,coord,dum)
   else
      allocate( coord(3,nat), source = xyz )
   endif

   max_distance = 0.0_wp ! ~equals diameter of sphere
   do i = 1, nlist
      do j = 1, i-1
         distance = sqrt(sum((coord(:,list(j))-coord(:,list(i)))**2))
         max_distance = max(max_distance,distance)
      enddo
   enddo

   select case(spherepot_type)
   case(p_type_polynomial)
      radius = (0.5_wp/0.7_wp * max_distance) * sphere_autoscale
   case(p_type_logfermi)
      radius = (0.5_wp * max_distance + sphere_shift) * sphere_autoscale
   end select

end subroutine get_sphere_radius_list

subroutine get_sphere_radius_fragment(nat,at,xyz,center,fragment,radius,do_trafo)
   use xtb_axis, only : axis3
   use xtb_splitparam
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: fragment
   real(wp),intent(out) :: center(3)
   real(wp),intent(out) :: radius
   logical, intent(in)  :: do_trafo

   integer  :: i,j
   real(wp) :: max_distance,distance,dum(3)
   real(wp),allocatable :: coord(:,:)
   logical  :: trafo
   optional :: do_trafo

   center = 0.0_wp

   if (present(do_trafo)) then
      trafo = do_trafo
   else
      trafo = .false.
   endif

   if (trafo) then
      allocate( coord(3,nat), source = 0.0_wp )
      call axis3(0,nat,at,xyz,coord,dum)
   else
      allocate( coord(3,nat), source = xyz )
   endif

   max_distance = 0.0_wp ! ~equals diameter of sphere
   do i = 1, nat
      do j = 1, i-1
         if (splitlist(i).ne.fragment.or.fragment.ne.splitlist(j)) cycle
         distance = sqrt(sum((coord(:,j)-coord(:,i))**2))
         max_distance = max(max_distance,distance)
      enddo
   enddo

   select case(spherepot_type)
   case(p_type_polynomial)
      radius = (0.5_wp/0.7_wp * max_distance) * sphere_autoscale
   case(p_type_logfermi)
      radius = (0.5_wp * max_distance + sphere_shift) * sphere_autoscale
   end select

end subroutine get_sphere_radius_fragment

subroutine get_sphere_radius_all(nat,at,xyz,center,radius,do_trafo)
   use xtb_axis, only : axis3
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: center(3)
   real(wp),intent(out) :: radius
   logical, intent(in)  :: do_trafo

   integer  :: i,j
   real(wp) :: max_distance,distance,dum(3)
   real(wp),allocatable :: coord(:,:)
   logical  :: trafo
   optional :: do_trafo

   center = 0.0_wp

   if (present(do_trafo)) then
      trafo = do_trafo
   else
      trafo = .false.
   endif

   if (trafo) then
      allocate( coord(3,nat), source = 0.0_wp )
      call axis3(0,nat,at,xyz,coord,dum)
   else
      allocate( coord(3,nat), source = xyz )
   endif

   max_distance = 0.0_wp ! ~equals diameter of sphere
   do i = 1, nat
      do j = 1, i-1
         distance = sqrt(sum((coord(:,j)-coord(:,i))**2))
         max_distance = max(max_distance,distance)
      enddo
   enddo

   select case(spherepot_type)
   case(p_type_polynomial)
      radius = (0.5_wp/0.7_wp * max_distance) * sphere_autoscale
   case(p_type_logfermi)
      radius = (0.5_wp * max_distance + sphere_shift) * sphere_autoscale
   end select

end subroutine get_sphere_radius_all

!! ========================================================================
subroutine logfermi_cavity_list(nat,at,xyz,nlist,list,temp,alpha,center,radius,&
   &                            efix,gfix)
   use xtb_mctc_constants, only : kB
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: nlist
   integer, intent(in)  :: list(nlist)

   real(wp),intent(in)  :: temp      ! temperature
   real(wp),intent(in)  :: alpha     ! potential steepness
   real(wp),intent(in)  :: center(3) ! aufpunkt of wall potential
   real(wp),intent(in)  :: radius(3) ! radius of the sphere (anisotropic)

   integer  :: i,iat
   real(wp) :: r(3),w(3),dist,R0,expterm,fermi

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   R0 = maxval(radius)
   w  = R0/radius ! for anisotropy

   do i = 1, nlist
      iat = list(i)
      r = w*(xyz(:,iat) - center)
      dist = sqrt(sum(r**2))
      expterm = exp(alpha*(dist-R0))
      fermi = 1.0_wp/(1.0_wp+expterm)
      efix = efix + kB*temp * log( 1.0_wp+expterm )
      gfix(:,iat) = gfix(:,iat) + kB*temp * alpha*expterm*fermi * (r*w)/(dist+1.0e-14_wp)
   enddo

end subroutine logfermi_cavity_list

subroutine logfermi_cavity_frag(nat,at,xyz,fragment,temp,alpha,center,radius,&
   &                            efix,gfix)
   use xtb_mctc_constants, only : kB
   use xtb_splitparam
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: fragment

   real(wp),intent(in)  :: temp      ! temperature
   real(wp),intent(in)  :: alpha     ! potential steepness
   real(wp),intent(in)  :: center(3) ! aufpunkt of wall potential
   real(wp),intent(in)  :: radius(3) ! radius of the sphere (anisotropic)

   integer  :: i
   real(wp) :: r(3),w(3),dist,R0,expterm,fermi

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   R0 = maxval(radius)
   w  = R0/radius ! for anisotropy

   do i = 1, nat
      if (splitlist(i).ne.fragment) cycle
      r = w*(xyz(:,i) - center)
      dist = sqrt(sum(r**2))
      expterm = exp(alpha*(dist-R0))
      fermi = 1.0_wp/(1.0_wp+expterm)
      efix = efix + kB*temp * log( 1.0_wp+expterm )
      gfix(:,i) = gfix(:,i) + kB*temp * alpha*expterm*fermi * (r*w)/(dist+1.0e-14_wp)
   enddo

end subroutine logfermi_cavity_frag

subroutine logfermi_cavity_all(nat,at,xyz,temp,alpha,center,radius,&
   &                           efix,gfix)
   use xtb_mctc_constants, only : kB
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)

   real(wp),intent(in)  :: temp      ! temperature
   real(wp),intent(in)  :: alpha     ! potential steepness
   real(wp),intent(in)  :: center(3) ! aufpunkt of wall potential
   real(wp),intent(in)  :: radius(3) ! radius of the sphere (anisotropic)

   integer  :: i
   real(wp) :: r(3),w(3),dist,R0,expterm,fermi

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   R0 = maxval(radius)
   w  = R0/radius ! for anisotropy

   do i = 1, nat
      r = w*(xyz(:,i) - center)
      dist = sqrt(sum(r**2))
      expterm = exp(alpha*(dist-R0))
      fermi = 1.0_wp/(1.0_wp+expterm)
      efix = efix + kB*temp * log( 1.0_wp+expterm )
      gfix(:,i) = gfix(:,i) + kB*temp * alpha*expterm*fermi * (r*w)/(dist+1.0e-14_wp)
   enddo

end subroutine logfermi_cavity_all

!! ========================================================================
subroutine polynomial_cavity_list(nat,at,xyz,nlist,list,alpha,center,radius,&
   &                              efix,gfix)
   use xtb_mctc_constants, only : kB
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: nlist
   integer, intent(in)  :: list(nlist)

   integer, intent(in)  :: alpha     ! potential steepness
   real(wp),intent(in)  :: center(3) ! aufpunkt of wall potential
   real(wp),intent(in)  :: radius(3) ! radius of the sphere (anisotropic)

   integer  :: i,iat
   real(wp) :: r(3),w(3),dist,R0,polyterm

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   R0 = maxval(radius)
   w  = R0/radius ! for anisotropy

   do i = 1, nlist
      iat = list(i)
      r = w*(xyz(:,iat) - center)
      dist = sqrt(sum(r**2))
      polyterm = (dist/R0)**alpha
      efix = efix + polyterm
      gfix(:,iat) = gfix(:,iat) + alpha*polyterm * (r*w)/(dist**2+1.0e-14_wp)
   enddo

end subroutine polynomial_cavity_list

subroutine polynomial_cavity_frag(nat,at,xyz,fragment,alpha,center,radius,&
   &                              efix,gfix)
   use xtb_mctc_constants, only : kB
   use xtb_splitparam
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: fragment

   integer, intent(in)  :: alpha     ! potential steepness
   real(wp),intent(in)  :: center(3) ! aufpunkt of wall potential
   real(wp),intent(in)  :: radius(3) ! radius of the sphere (anisotropic)

   integer  :: i
   real(wp) :: r(3),w(3),dist,R0,polyterm

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   R0 = maxval(radius)
   w  = R0/radius ! for anisotropy

   do i = 1, nat
      if (splitlist(i).ne.fragment) cycle
      r = w*(xyz(:,i) - center)
      dist = sqrt(sum(r**2))
      polyterm = (dist/R0)**alpha
      efix = efix + polyterm
      gfix(:,i) = gfix(:,i) + alpha*polyterm * (r*w)/(dist**2+1.0e-14_wp)
   enddo

end subroutine polynomial_cavity_frag

subroutine polynomial_cavity_all(nat,at,xyz,alpha,center,radius,&
   &                             efix,gfix)
   use xtb_mctc_constants, only : kB
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)

   integer, intent(in)  :: alpha     ! potential steepness
   real(wp),intent(in)  :: center(3) ! aufpunkt of wall potential
   real(wp),intent(in)  :: radius(3) ! radius of the sphere (anisotropic)

   integer  :: i
   real(wp) :: r(3),w(3),dist,R0,polyterm

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   R0 = maxval(radius)
   w  = R0/radius ! for anisotropy

   do i = 1, nat
      r = w*(xyz(:,i) - center)
      dist = sqrt(sum(r**2))
      polyterm = (dist/R0)**alpha
      efix = efix + polyterm
      gfix(:,i) = gfix(:,i) + alpha*polyterm * (r*w)/(dist**2+1.0e-14_wp)
   enddo

end subroutine polynomial_cavity_all

!! ========================================================================
!  energy and gradient of the wall potentials
subroutine cavity_egrad(nat,at,xyz,efix,gfix)
   use xtb_mctc_constants, only : kB
   implicit none
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)

   real(wp),intent(inout) :: efix
   real(wp),intent(inout) :: gfix(3,nat)

   integer :: i,nlist

   if (.not.allocated(wpot)) return

   do i = 1, number_walls
      select case(spherepot_type)
      case default ! make sure that this never happens, REALLY!
         call raise('E','Internal error in sphereparam.f90, please report this.')
      case(p_type_polynomial)
         if (wpot(i)%fragment.gt.0) then
            call polynomial_cavity(nat,at,xyz,wpot(i)%fragment,sphere_alpha, &
                 wpot(i)%center,wpot(i)%radius,efix,gfix)
         else if (allocated(wpot(i)%list)) then
            nlist = size(wpot(i)%list,1)
            call polynomial_cavity(nat,at,xyz,nlist,wpot(i)%list,sphere_alpha, &
                 wpot(i)%center,wpot(i)%radius,efix,gfix)
         else
            call polynomial_cavity(nat,at,xyz,sphere_alpha, &
                 wpot(i)%center,wpot(i)%radius,efix,gfix)
         endif
      case(p_type_logfermi)
         if (wpot(i)%fragment.gt.0) then
            call logfermi_cavity(nat,at,xyz,wpot(i)%fragment,sphere_temp, &
                 sphere_beta,wpot(i)%center,wpot(i)%radius,efix,gfix)
         else if (allocated(wpot(i)%list)) then
            nlist = size(wpot(i)%list,1)
            call logfermi_cavity(nat,at,xyz,nlist,wpot(i)%list,sphere_temp, &
                 sphere_beta,wpot(i)%center,wpot(i)%radius,efix,gfix)
         else
            call logfermi_cavity(nat,at,xyz,sphere_temp,sphere_beta, &
                 wpot(i)%center,wpot(i)%radius,efix,gfix)
         endif
      end select
   end do

end subroutine cavity_egrad

!! ========================================================================
!  old subroutines from spherepot.f
!! ========================================================================

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! energy and gradient of wall
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine cavityeg(n,xyz,e,g)
   implicit none
   real(wp) :: xyz(3,n)
   real(wp) :: g  (3,n)
   real(wp) :: e
   integer n,i,a
   real(wp) :: rij(3),dr,r,term,dum,r0,r2,rx,ry,rz,term1,term3,a2,am1

   if(sphere.lt.1) return

   if(sphere.eq.2) then
      a  =15
      am1=14
      a2=2.0d0*a
      do i=1,n
         rx=(xyz(1,i)/rabc(1))**2
         ry=(xyz(2,i)/rabc(2))**2
         rz=(xyz(3,i)/rabc(3))**2
         term1=rx+ry+rz
         term =term1**a
         term3=a2*term1**am1
         e=e+term
         g(1,i)=g(1,i)+xyz(1,i)*term3/rabc(1)**2
         g(2,i)=g(2,i)+xyz(2,i)*term3/rabc(2)**2
         g(3,i)=g(3,i)+xyz(3,i)*term3/rabc(3)**2
      enddo
      return
   endif

   if(sphere.eq.1) then
      a=30
      do i=1,n
         rij=xyz(:,i)
         r2=sum(rij*rij)
         r=sqrt(r2)
         term=(r/boxr)**a
         e=e+term
         dum=term*a/r2
         g(1,i)=g(1,i)+rij(1)*dum
         g(2,i)=g(2,i)+rij(2)*dum
         g(3,i)=g(3,i)+rij(3)*dum
      enddo
   endif

end subroutine cavityeg

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! energy of wall
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine cavitye(n,xyz,e)
   implicit none
   real(wp) :: xyz(3,n)
   real(wp) :: e
   integer n,i,a
   real(wp) :: rij(3),dr,r,term,dum,r0,r2,rx,ry,rz

   if(sphere.lt.1) return

   if(sphere.eq.2) then
      a=15
      do i=1,n
         rx=(xyz(1,i)/rabc(1))**2
         ry=(xyz(2,i)/rabc(2))**2
         rz=(xyz(3,i)/rabc(3))**2
         term=(rx+ry+rz)**a
         e=e+term
      enddo
      return
   endif

   if(sphere.eq.1) then
      a=30
      do i=1,n
         rij=xyz(:,i)
         r2=sum(rij*rij)
         r=sqrt(r2)
         term=(r/boxr)**a
         e=e+term
      enddo
      return
   endif

end subroutine cavitye
end module xtb_sphereparam

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implements sorting algorithms
module xtb_mctc_sort
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: indexHeapSort


contains


!> Real case heap sort returning an index.
!  Based on Numerical Recipes Software 1986-92
pure subroutine indexHeapSort(indx, array, tolerance)
   !> Indexing array on return
   integer, intent(out) :: indx(:)
   !> Array of values to be sorted
   real(wp), intent(in) :: array(:)
   !> Tolerance for equality of two elements
   real(wp), intent(in), optional :: tolerance

   integer :: n, ir, ij, il, ii
   integer :: indxTmp
   real(wp) :: arrayTmp, tol

   !:ASSERT(size(array)==size(indx))

   if (present(tolerance)) then
      tol = tolerance
   else
      tol = epsilon(0.0_wp)
   end if

   do ii = 1, size(indx)
      indx(ii) = ii
   end do
   n = size(array)
   if (n <= 1) return
   il = n/2 + 1
   ir = n
   do
      if (il > 1) then
         il = il - 1
         indxTmp = indx(il)
         arrayTmp = array(indxTmp)
      else
         indxTmp = indx(ir)
         arrayTmp = array(indxTmp)
         indx(ir) = indx(1)
         ir = ir - 1
         if (ir < 1) then
            indx(1) = indxTmp
            return
         end if
      end if
      ii = il
      ij = 2 * il
      do while (ij <= ir)
         if (ij < ir) then
            if (array(indx(ij)) < array(indx(ij+1)) - tol) then
               ij = ij + 1
            end if
         end if
         if(arrayTmp < array(indx(ij)) - tol) then
            indx(ii) = indx(ij)
            ii = ij
            ij = 2*ij
         else
            ij = ir + 1
         end if
      end do
      indx(ii)=indxTmp
   end do

end subroutine indexHeapSort


end module xtb_mctc_sort

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


  subroutine ispline(u, x, y, b, c, d, n, isp, isp1, isp2)
!======================================================================
! function ispline evaluates the cubic spline interpolation at point z
! ispline = y(i)+b(i)*(u-x(i))+c(i)*(u-x(i))**2+d(i)*(u-x(i))**3
! where  x(i) <= u <= x(i+1)
!----------------------------------------------------------------------
! input..
! u       = the abscissa at which the spline is to be evaluated
! x, y    = the arrays of given data points
! b, c, d = arrays of spline coefficients computed by spline
! n       = the number of data points
! output:
! isp     = interpolated value at point u
! isp1    = first derivative   at point u
! isp2    = second derivative  at point u
!=======================================================================
implicit none
double precision isp,isp1,isp2
integer n
double precision  u, x(n), y(n), b(n), c(n), d(n)
integer i, j, k
double precision dx

isp1=0
isp2=0
! if u is ouside the x() interval take a boundary value (left or right)
if(u <= x(1)) then
  isp = y(1)
  return
end if
if(u >= x(n)) then
  isp = y(n)
  return
end if

!*
!  binary search for for i, such that x(i) <= u <= x(i+1)
!*
i = 1
j = n+1
do while (j > i+1)
  k = (i+j)/2
  if(u < x(k)) then
    j=k
    else
    i=k
   end if
end do
!*
!  evaluate spline interpolation and derivatives
!*
dx = u - x(i)
isp = y(i) + dx*(b(i) + dx*(c(i) + dx*d(i)))
isp1=           (b(i) + dx*(c(i)*2. + 3.*dx*d(i)))
isp2=                 +    (c(i)*2. + 6.*dx*d(i))
end

subroutine spline2(x, y, b, c, d, n)
!======================================================================
!  Calculate the coefficients b(i), c(i), and d(i), i=1,2,...,n
!  for cubic spline interpolation
!  s(x) = y(i) + b(i)*(x-x(i)) + c(i)*(x-x(i))**2 + d(i)*(x-x(i))**3
!  for  x(i) <= x <= x(i+1)
!----------------------------------------------------------------------
!  input..
!  x = the arrays of data abscissas (in strictly increasing order)
!  y = the arrays of data ordinates
!  n = size of the arrays xi() and yi() (n>=2)
!  output..
!  b, c, d  = arrays of spline coefficients
!  comments ...
!  spline.f90 program is based on fortran version of program spline.f
!  the accompanying function fspline can be used for interpolation
!======================================================================
implicit none
integer n
double precision x(n), y(n), b(n), c(n), d(n)
integer i, j, gap
double precision h

gap = n-1
! check input
if ( n < 2 ) return
if ( n < 3 ) then
b(1) = (y(2)-y(1))/(x(2)-x(1))   ! linear interpolation
c(1) = 0.
d(1) = 0.
b(2) = b(1)
c(2) = 0.
d(2) = 0.
return
end if
!
! step 1: preparation
!
d(1) = x(2) - x(1)
c(2) = (y(2) - y(1))/d(1)
do i = 2, gap
d(i) = x(i+1) - x(i)
b(i) = 2.0*(d(i-1) + d(i))
c(i+1) = (y(i+1) - y(i))/d(i)
c(i) = c(i+1) - c(i)
end do
!
! step 2: end conditions
!
b(1) = -d(1)
b(n) = -d(n-1)
c(1) = 0.0
c(n) = 0.0
if(n /= 3) then
c(1) = c(3)/(x(4)-x(2)) - c(2)/(x(3)-x(1))
c(n) = c(n-1)/(x(n)-x(n-2)) - c(n-2)/(x(n-1)-x(n-3))
c(1) = c(1)*d(1)**2/(x(4)-x(1))
c(n) = -c(n)*d(n-1)**2/(x(n)-x(n-3))
end if
!
! step 3: forward elimination
!
do i = 2, n
h = d(i-1)/b(i-1)
b(i) = b(i) - h*d(i-1)
c(i) = c(i) - h*c(i-1)
end do
!
! step 4: back substitution
!
c(n) = c(n)/b(n)
do j = 1, gap
i = n-j
c(i) = (c(i) - d(i)*c(i+1))/b(i)
end do
!
! step 5: compute spline coefficients
!
b(n) = (y(n) - y(gap))/d(gap) + d(gap)*(c(gap) + 2.0*c(n))
do i = 1, gap
b(i) = (y(i+1) - y(i))/d(i) - d(i)*(c(i+1) + 2.0*c(i))
d(i) = (c(i+1) - c(i))/d(i)
c(i) = 3.*c(i)
end do
c(n) = 3.0*c(n)
d(n) = d(n-1)
end subroutine spline2

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_aespot
   use xtb_mctc_accuracy, only : wp
   use xtb_intpack, only : olap,divpt,rhftce,prod,opab1,opab4,propa
   use xtb_xtb_data
   integer,private, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer,private, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

contains

! setdqlist:  precomputes the dipole and quadrupole potential terms for Fock matrix
! thr              : neglect matrix elements in potential
! nao              : # of spherical AOs (SAOs)
! dpint            : dipole integral matrix, dimension 3,nao*(nao+1)/2
! qpint            : quadrupole integral matrix, dimension 6,nao*(nao+1)/2
! ndp,nqp          : number of elements to be computed in Fock matrix with X-dip and X-qpole terms
! matdlst,matqlst  : index list, to which AO, the ndp/nqp potential terms refer to
subroutine setdqlist(nao,ndp,nqp,thr,dpint,qpint,matdlst,matqlst)
   implicit none
   integer, intent(in)    :: nao
   integer, intent(inout) :: ndp,nqp
   real(wp),intent(in)  ::  thr
   real(wp),intent(in)  :: dpint(3,nao,nao)
   real(wp),intent(in)  :: qpint(6,nao,nao)
   integer, intent(inout):: matqlst(2,nqp),matdlst(2,ndp)

   real(wp) tmp1,tmp2,tmp3,tmp4
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,thr2,f
   ! stuff for potential

   integer i,j,k,l,m,ii,jj,ll,kk,mq,md,ij

   ! INFO: this threshold must be slightly larger than max(0,thr2),
   !       where thr2 is the one used in screening in routine aesdqint
   thr2 = thr*1.0d-2 ! we compare squared int-elements
   !      thr2 = 1.0d-20 ! conservative, keep all terms

   md = 0
   mq = 0
   ! set uo matrix lists
   ij = 0
   do i = 1,nao
      do j = 1,i
         ij = ij+1
         tmp1 = 0.0_wp
         tmp2 = 0.0_wp
         kk = 0
         do k = 1,3
            tmp1 = tmp1+dpint(k,i,j)*dpint(k,i,j)
            tmp2 = tmp2-qpint(k,i,j)*qpint(k,i,j)
         enddo
         do k = 1,6
            tmp2 = tmp2+2.0_wp*qpint(k,i,j)*qpint(k,i,j)
         enddo
         if(tmp1.gt.thr2)then
            md = md+1
            matdlst(1,md) = int(i,2)
            matdlst(2,md) = int(j,2)
         endif
         if(tmp2.gt.thr2)then
            mq = mq+1
            matqlst(1,mq) = int(i,2)
            matqlst(2,mq) = int(j,2)
         endif
      enddo
   enddo
   ndp = md
   nqp = mq
end subroutine setdqlist

! scalecamm: scale all anisotropic CAMMs by element-specific parameters
! nat              : # of atoms
! at(nat)          : atom-to-element identifier
! dipm(3,nat)      : cumulative atomic dipole moments (x,y,z)
! qp(6,nat)        : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
subroutine scalecamm(nat,at,dipm,qp)
   implicit none
   integer, intent(in) :: nat,at(nat)
   real(wp), intent(inout):: dipm(3,nat),qp(6,nat)
   integer i,iat

   ! CAMM  scaling
   do i = 1,nat
      qp(1:6,i) = qp(1:6,i)*(3./3.)
   enddo
end subroutine scalecamm

! unscalecamm: unscale all anisotropic CAMMs from element-specific parameters
! nat              : # of atoms
! at(nat)          : atom-to-element identifier
! dipm(3,nat)      : cumulative atomic dipole moments (x,y,z)
! qp(6,nat)        : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
subroutine unscalecamm(nat,at,dipm,qp)
   implicit none
   integer, intent(in) :: nat,at(nat)
   real(wp), intent(inout):: dipm(3,nat),qp(6,nat)
   real(wp) aesi
   integer i,iat

   ! CAMM  scaling
   do i = 1,nat
      qp(1:6,i) = qp(1:6,i)*(3./3.)
   enddo
end subroutine unscalecamm




! mmpop:  compute the cumulative atomic dipole and quadrupole moments via Mulliken population analysis
! nat              : # of atoms
! nao              : # of spherical AOs (SAOs)
! aoat2(nao)       : SAO to atom intex
! s(nao,nao)       : overlap matrix
! xyz(3,nat)       : cartesian coordinates
! dpint            : dipole integral matrix, dimension 3,nao*(nao+1)/2
! qpint            : quadrupole integral matrix, dimension 6,nao*(nao+1)/2
! p(nao,nao)       : density matrix
! dipm(3,nat)      : cumulative atomic dipole moments (x,y,z)
! qp(6,nat)        : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
subroutine mmompop(nat,nao,aoat2,xyz,p,s,dpint,qpint,dipm,qp)
   implicit none
   integer, intent(in) :: nao,nat,aoat2(:)
   real(wp), intent(in) :: s(:, :)
   real(wp), intent(in) :: p(:, :)
   real(wp), intent(in) :: dpint(:, :, :)
   real(wp), intent(in) :: qpint(:, :, :)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(out):: dipm(:, :)
   real(wp), intent(out):: qp(:, :)

   real(wp) xk1,xl1,xk2,xl2,pij,tii,tjj
   real(wp) pqm,pdmk,pdml,ps,ra(3)

   integer i,j,k,l,ii,jj,kl,kj,lin

   !$acc enter data create(dipm(:, :), qp(:, :))

   ! CAMM
   !$acc kernels default(present)
   dipm = 0.0_wp
   qp = 0.0_wp
   !$acc end kernels

   !$acc enter data copyin(nao, nat, aoat2(:), s(:, :), p(:, :), dpint(:, :, :), &
   !$acc& qpint(:, :, :),xyz(:, :))

   !$acc parallel private(pij,ps,ra,k,l,ii,jj)

   !$acc loop gang vector collapse(2)
   do i = 1,nao
      do j = 1,nao
         if (j >= i) cycle
         ii = aoat2(i)
         jj = aoat2(j)
         ra(1:3) = xyz(1:3,ii)
         pij = p(j,i)
         ps = pij*s(j,i)
         !  the qpint is stored as xx,yy,zz,xy,xz,yz (from integral routine)
         !  when doing the Mulliken population, we switch to lin-compatible sorting
         !  i,e. xx,xy,yy,xz,yz,zz
         !$acc loop vector private(xk1,xl1,xk2,xl2,tii,tjj,pqm,pdmk,pdml,kl,kj)
         do k = 1,3
            xk1 = ra(k)
            xk2 = xyz(k,jj)
            pdmk = pij*dpint(k,j,i)
            tii = xk1*ps-pdmk
            tjj = xk2*ps-pdmk
            !$acc atomic
            dipm(k,jj) = dipm(k,jj)+tjj
            !$acc atomic
            dipm(k,ii) = dipm(k,ii)+tii
            ! off-diagonal
            do l = 1,k-1
               kl = k*(k-1)/2+l
               kj = k+l+1
               xl1 = ra(l)
               xl2 = xyz(l,jj)
               pdml = pij*dpint(l,j,i)
               pqm = pij*qpint(kj,j,i)
               tii = pdmk*xl1+pdml*xk1-xl1*xk1*ps-pqm
               tjj = pdmk*xl2+pdml*xk2-xl2*xk2*ps-pqm
               !$acc atomic
               qp(kl,jj) = qp(kl,jj)+tjj
               !$acc atomic
               qp(kl,ii) = qp(kl,ii)+tii
            enddo
            ! diagonal
            kl = k*(k+1)/2
            pqm = pij*qpint(k,j,i)
            tii = 2.0_wp*pdmk*xk1-xk1*xk1*ps-pqm
            tjj = 2.0_wp*pdmk*xk2-xk2*xk2*ps-pqm
            !$acc atomic
            qp(kl,jj) = qp(kl,jj)+tjj
            !$acc atomic
            qp(kl,ii) = qp(kl,ii)+tii
         enddo
      enddo
   enddo

   !$acc loop gang vector
   do i = 1,nao
      ii = aoat2(i)
      ra(1:3) = xyz(1:3,ii)
      pij = p(i,i)
      ps = pij*s(i,i)
      !  the qpint is stored as xx,yy,zz,xy,xz,yz (from integral routine)
      !  when doing the Mulliken population, we switch to lin-compatible sorting
      !  i,e. xx,xy,yy,xz,yz,zz
      !$acc loop vector private(xk1,xl1,xk2,xl2,tii,pqm,pdmk,pdml,kl,kj)
      do k = 1,3
         xk1 = ra(k)
         pdmk = pij*dpint(k,i,i)
         tii = xk1*ps-pdmk
         !$acc atomic
         dipm(k,ii) = dipm(k,ii)+tii
         ! off-diagonal
         do l = 1,k-1
            kl = k*(k-1)/2+l
            kj = k+l+1 ! the qpint is stored as xx,yy,zz,xy,xz,yz (from integral routine)
            xl1 = ra(l)
            pdml = pij*dpint(l,i,i)
            pqm = pij*qpint(kj,i,i)
            tii = pdmk*xl1+pdml*xk1-xl1*xk1*ps-pqm
            !$acc atomic
            qp(kl,ii) = qp(kl,ii)+tii
         enddo
         !diagonal
         kl = k*(k+1)/2
         pqm = pij*qpint(k,i,i)
         tii = 2.0_wp*pdmk*xk1-xk1*xk1*ps-pqm
         !$acc atomic
         qp(kl,ii) = qp(kl,ii)+tii
      enddo
   enddo
   !$acc end parallel

   !$acc exit data copyout(dipm(:, :), qp(:, :))

   ! remove trace
   do i = 1,nat
      tii = qp(1,i)+qp(3,i)+qp(6,i)
      tii = 0.50_wp*tii
      qp(1:6,i) = 1.50_wp*qp(1:6,i)
      qp(1,i) = qp(1,i)-tii
      qp(3,i) = qp(3,i)-tii
      qp(6,i) = qp(6,i)-tii
   enddo

   !$acc exit data delete(nao, nat, aoat2(:), s(:, :), p(:, :), dpint(:, :, :), &
   !$acc& qpint(:, :, :),xyz(:, :))

end subroutine mmompop


! distributed atomic multipole moment interactions: all interactions up to r**-3
! energy evaluation
! nat         : # of atoms
! xyz(3,nat)  : cartesian coordinates
! q(nat)      : atomic partial charges
! dipm(3,nat) : cumulative atomic dipole moments (x,y,z)
! qp(6,nat)   : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
! gab3,gab5   : damped R**-3 and R**-5 Coulomb laws, dimension: nat*(nat+1)/2
!               multiplication with numerator then leads to R**-2 and R**-3 decay, respectively
! e           : E_AES
subroutine aniso_electro(aesData,nat,at,xyz,q,dipm,qp,gab3,gab5,e,epol)
   use xtb_lin, only : lin
   implicit none
   class(TMultipoleData), intent(in) :: aesData
   integer, intent(in) :: nat,at(:)
   real(wp), intent(in) :: xyz(:,:),q(:)
   real(wp), intent(inout) :: e
   real(wp) qp1(6),rr(3),dp1(3),rij(3)
   real(wp) edd,e01,e02,e11,r2,tt,tt3,q1,qs2
   real(wp) ed,eq,epol
   ! stuff for potential
   real(wp), intent(in) :: gab3(:,:),gab5(:,:)
   real(wp), intent(in) :: dipm(:,:),qp(:,:)
   integer, parameter :: idx(3, 3) = reshape([1, 2, 4, 2, 3, 5, 4, 5, 6], [3, 3])

   integer i,j,k,l,m,ki,kj,kl

   ! acc enter data copyin(at, xyz, q, dipm, qp, gab3, gab5, &
   ! acc& aesData, aesData%dipKernel(:), aesData%quadKernel(:))

   ! acc kernels
   e = 0.0_wp
   epol = 0.0_wp
   e01 = 0.0_wp
   e02 = 0.0_wp
   e11 = 0.0_wp
   ! acc end kernels

   ! acc parallel private(qp1, rr, dp1, rij)

   ! acc loop gang
   do i = 1, nat
      q1 = q(i)
      rr(1:3) = xyz(1:3,i)
      dp1(1:3) = dipm(1:3,i)
      qp1(1:6) = qp(1:6,i)
      ! test: semilocal CT correction
      ! dipole
      tt = dp1(1)*dp1(1)+dp1(2)*dp1(2)+dp1(3)*dp1(3)
      ! qpole
      tt3 = 0.0_wp
      ! acc loop seq
      do k = 1,3
         ! acc loop seq
         do l = 1,3
            kl = idx(l,k)
            tt3 = tt3+qp1(kl)*qp1(kl)
         enddo
      enddo
      eq = aesData%dipKernel(at(i))*tt+tt3*aesData%quadKernel(at(i))
      ! acc atomic
      epol = epol+eq
      ! ---
   enddo

   ! acc loop gang collapse(2)
   do i = 1, nat
      do j = 1, nat
         if (j >= i) cycle
         q1 = q(i)
         rr(1:3) = xyz(1:3,i)
         dp1(1:3) = dipm(1:3,i)
         qp1(1:6) = qp(1:6,i)
         kj = i*(i-1)/2 + j
         rij(1:3) = xyz(1:3,j)-rr(1:3)
         r2 = sum(rij*rij)
         ed = 0.0_wp
         eq = 0.0_wp
         edd = 0.0_wp
         !           dipole - charge
         ! acc loop seq
         do k = 1,3
            ed = ed+q(j)*dp1(k)*rij(k)
            ed = ed-dipm(k,j)*q1*rij(k)
            !              dip-dip & charge-qpole
            ! acc loop seq
            do l = 1,3
               kl = idx(l,k)
               tt = rij(l)*rij(k)
               tt3 = 3.0_wp*tt
               eq = eq+q(j)*qp1(kl)*tt
               eq = eq+qp(kl,j)*q1*tt
               edd = edd-dipm(k,j)*dp1(l)*tt3
            enddo
            !              diagonal dip-dip term
            edd = edd+dipm(k,j)*dp1(k)*r2
         enddo
         ! acc atomic
         e01 = e01+ed*gab3(j,i)
         ! acc atomic
         e02 = e02+eq*gab5(j,i)
         ! acc atomic
         e11 = e11+edd*gab5(j,i)
      enddo
   enddo
   ! acc end parallel
   ! acc kernels
   e = e01 + e02 + e11
   ! acc end kernels
   !     write(*,'(''d,q,dd'',3f9.5)')  e01,e02,e11
   !      write(*,*) ' semilocal CT corr.: ',epol
   ! acc exit data delete(aesData, aesData%dipKernel(:), aesData%quadKernel(:), &
   ! acc& at, xyz, q, dipm, qp, gab3, gab5)

end subroutine aniso_electro

! aniso-electro from Fock matrix elements
! nao              : # of spherical AOs (SAOs)
! s(nao,nao)       : overlap matrix
! aoat2(nao)       : SAO to atom intex
! dpint            : dipole integral matrix, dimension 3,nao*(nao+1)/2
! qpint            : quadrupole integral matrix, dimension 6,nao*(nao+1)/2
! p(nao,nao)       : density matrix
! vs(nat)          : overlap proportional potential
! vd(3,nat)        : dipint proportional potential
! vq(6,nat)        : quadrupole proportional potential
subroutine fockelectro(nat,nao,aoat2,p,s,dpint,qpint,vs,vd,vq,e)
   use xtb_lin, only : lin
   implicit none
   integer, intent(in) :: nat,nao,aoat2(nao)
   real(wp), intent(in) :: dpint(3,nao,nao),s(nao,nao)
   real(wp), intent(in) :: qpint(6,nao,nao),p(nao,nao)
   real(wp), intent(in) :: vs(nat),vd(3,nat),vq(6,nat)
   real(wp), intent(out) :: e
   real(wp) eaes,pji,fji
   integer i,j,k,l,ii,jj,ij,kl,kj
   ! CAMM
   eaes = 0.0_wp
   ij = 0
   do i = 1,nao
      ii = aoat2(i)
      do j = 1,nao
         ij = lin(j,i)
         jj = aoat2(j)
         fji = 0.0_wp
         pji = p(j,i)
         fji = fji+s(j,i)*(vs(ii)+vs(jj))
         do k = 1,3
            fji = fji+dpint(k,i,j)*(vd(k,ii)+vd(k,jj))
         enddo
         do k = 1,6
            fji = fji+qpint(k,i,j)*(vq(k,ii)+vq(k,jj))
         enddo
         eaes = eaes+pji*fji
      enddo
   enddo
   eaes = 0.250_wp*eaes
   !      write(*,*) 'EAES',eaes
   e = eaes
end subroutine fockelectro


! set-up potential terms v, which are proportional to s, d, or q-integrals
! it is to be multiplied with Sji when stting up Fji (hence, termed vs)
! comes essentially at no cost, once cumulative atomic quadrupole moments are available.
! NEW: the CAMMs were already scaled by scalecamm, but the corresponding potential terms
!      including shift terms need to be scaled
! nat         : # of atoms
! at(nat)     : atom-to-element identifier
! xyz(3,nat)  : cartesian coordinates
! q(nat)      : atomic partial charges
! dipm(3,nat) : atomic dipole moments
! qp(6,nat)   : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
! gab3,gab5   : damped Coulomb laws, dimension: nat*(nat+1)/2
! vs(nat)     : s-proportional potential from all atoms acting on atom i
! vd(3,nat)   : dipint-proportional potential from all atoms acting on atom i
! vq(6,nat)   : qpole-int proportional potential from all atoms acting on atom i
subroutine setvsdq(aesData,nat,at,xyz,q,dipm,qp,gab3,gab5,vs,vd,vq)
   use xtb_lin, only : lin
   implicit none
   class(TMultipoleData), intent(in) :: aesData
   integer, intent(in) :: nat,at(:)
   real(wp), intent(in) ::  q(:),dipm(:,:)
   real(wp), intent(in) ::  xyz(:,:),qp(:,:)
   real(wp), intent(in) :: gab3(:,:)
   real(wp), intent(in) :: gab5(:,:)
   real(wp), intent(out) :: vs(:),vd(:,:),vq(:,:)
   real(wp) ra(3),dra(3),rb(3),stmp,dum3a,dum5a,t1a,t2a,t3a,t4a,r2a
   real(wp) r2ab,t1b,t2b,t3b,t4b,dum3b,dum5b,dtmp(3),qtmp(6),g3,g5
   real(wp) qs1,qs2
   integer i,j,k,l1,l2,ll,m,mx,ki,kj
   vs = 0.0_wp
   vd = 0.0_wp
   vq = 0.0_wp
   ! set up overlap proportional potential
   do i = 1,nat
      ra(1:3) = xyz(1:3,i)
      stmp = 0.0_wp
      dtmp = 0.0_wp
      qtmp = 0.0_wp
      do j = 1,nat
         g3 = gab3(j,i)
         g5 = gab5(j,i)
         rb(1:3) = xyz(1:3,j)
         dra(1:3) = ra(1:3)-rb(1:3)
         dum3a = 0.0_wp ! collect gab3 dependent terms
         dum5a = 0.0_wp ! collect gab5 dependent terms
         r2a = 0.0_wp
         r2ab = 0.0_wp
         t1a = 0.0_wp
         t2a = 0.0_wp
         t3a = 0.0_wp
         t4a = 0.0_wp
         ll = 0
         do l1 = 1,3
            ! potential from dipoles
            r2a = r2a+ra(l1)*ra(l1)      ! R_C * R_C
            r2ab = r2ab+dra(l1)*dra(l1)  ! R_AC * R_AC
            t1a = t1a+ra(l1)*dra(l1)     ! R_C * R_AC  : for dip-q (q-shift) and dip-dip (q-shift)
            t2a = t2a+dipm(l1,j)*dra(l1) ! mu_A * R_AC : for q-dip and dip-dip (q-shift)
            t3a = t3a+ra(l1)*dipm(l1,j)  ! R_C * mu_A  : for diag. dip-dip (q-shift)
            t4a = t4a+dra(l1)*dra(l1)*ra(l1)*ra(l1) ! (R_C o R_AC)**"2(square of Hadamard product) :
            ! results from trace remove from q-pole (q-shift)
            do l2 = 1,3
               ll = lin(l1,l2)
               ! potential from quadrupoles
               dum5a = dum5a-qp(ll,j)*dra(l1)*dra(l2) &
                  & -1.50_wp*q(j)*dra(l1)*dra(l2)*ra(l1)*ra(l2)
               if(l2.ge.l1) cycle
               ki = l1+l2+1
               qtmp(ki) = qtmp(ki)-3.0_wp*q(j)*g5*dra(l2)*dra(l1)
            enddo
            qtmp(l1) = qtmp(l1)-1.50_wp*q(j)*g5*dra(l1)*dra(l1)
         enddo
         !
         ! set up S-dependent potential
         dum3a = -t1a*q(j)-t2a ! dip-q (q-shift) and q-dip
         dum5a = dum5a+t3a*r2ab-3.0_wp*t1a*t2a & !dip-dip (q-shift terms)
            & +0.50_wp*q(j)*r2a*r2ab !qpole-q (q-shift, trace removal)
         stmp = stmp+dum5a*g5+dum3a*g3
         do l1 = 1,3
            dum3a = dra(l1)*q(j)
            dum5a = 3.0_wp*dra(l1)*t2a &           ! dipint-dip
               & -r2ab*dipm(l1,j) &            ! dipint-dip (diagonal)
               & -q(j)*r2ab*ra(l1) &           ! qpole-q (dipint-shift, trace removal)
               & +3.0_wp*q(j)*dra(l1)*t1a   ! qpole-q (dipint-shift)
            dtmp(l1) = dtmp(l1)+dum3a*g3+dum5a*g5
            qtmp(l1) = qtmp(l1)+0.50_wp*r2ab*q(j)*g5 !remove trace term
         enddo
      enddo
      vs(i) = stmp                       ! q terms
      vd(1:3,i) = dtmp(1:3)              ! dipints from atom i
      vq(1:6,i) = qtmp(1:6)              ! qpints from atom i
      ! --- CT correction terms
      qs1 = aesData%dipKernel(at(i))*2.0_wp
      qs2 = aesData%quadKernel(at(i))*6.0_wp ! qpole pot prefactors
      t3a = 0.0_wp
      t2a = 0.0_wp
      do l1 = 1,3
         ! potential from dipoles
         t3a = t3a+ra(l1)*dipm(l1,i)*qs1  ! R_C * mu_C  : for diag. dip-dip
         vd(l1,i) = vd(l1,i)-qs1*dipm(l1,i)
         do l2 = 1,l1-1
            ! potential from quadrupoles
            ll = lin(l1,l2)
            ki = l1+l2+1
            vq(ki,i) = vq(ki,i)-qp(ll,i)*qs2
            t3a = t3a-ra(l1)*ra(l2)*qp(ll,i)*qs2
            vd(l1,i) = vd(l1,i)+ra(l2)*qp(ll,i)*qs2
            vd(l2,i) = vd(l2,i)+ra(l1)*qp(ll,i)*qs2
         enddo
         ! diagonal
         ll = lin(l1,l1)
         vq(l1,i) = vq(l1,i)-qp(ll,i)*qs2*0.50_wp
         t3a = t3a-ra(l1)*ra(l1)*qp(ll,i)*qs2*0.50_wp
         vd(l1,i) = vd(l1,i)+ra(l1)*qp(ll,i)*qs2
         ! collect trace removal terms
         t2a = t2a+qp(ll,i)
      enddo
      vs(i) = vs(i)+t3a
      ! trace removal
      t2a = t2a*aesData%quadKernel(at(i))
      do l1 = 1,3
         vq(l1,i) = vq(l1,i)+t2a
         vd(l1,i) = vd(l1,i)-2.0_wp*ra(l1)*t2a
         vs(i) = vs(i)+t2a*ra(l1)*ra(l1)
      enddo
      ! ---
   enddo

   !      call prmat(6,vs,nat,0,'vs')

end subroutine setvsdq

! set-up potential terms v used for nuclear gradients
! here, the shift terms are removed, since we use multipole derivatives w/ origin at the atoms
! nat         : # of atoms
! xyz(3,nat)  : cartesian coordinates
! q(nat)      : atomic partial charges
! dipm(3,nat) : atomic dipole moments
! qp(6,nat)   : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
! gab3,gab5   : damped Coulomb laws, dimension: nat*(nat+1)/2
! vs(nat)     : s-proportional potential from all atoms acting on atom i
! vd(3,nat)   : dipint-proportional potential from all atoms acting on atom i
! vq(6,nat)   : qpole-int proportional potential from all atoms acting on atom i
subroutine setdvsdq(aesData,nat,at,xyz,q,dipm,qp,gab3,gab5,vs,vd,vq)
   use xtb_lin, only : lin
   implicit none
   class(TMultipoleData), intent(in) :: aesData
   integer, intent(in) :: nat,at(:)
   real(wp), intent(in) ::  q(:),dipm(:,:)
   real(wp), intent(in) ::  xyz(:,:),qp(:,:)
   real(wp), intent(in) :: gab3(:,:)
   real(wp), intent(in) :: gab5(:,:)
   real(wp), intent(out) :: vs(:),vd(:,:),vq(:,:)
   real(wp) ra(3),dra(3),rb(3),stmp,dum3a,dum5a,t1a,t2a,t3a,t4a,r2a
   real(wp) r2ab,t1b,t2b,t3b,t4b,dum3b,dum5b,dtmp(3),qtmp(6),g3,g5
   real(wp) qs1,qs2
   integer i,j,k,l1,l2,ll,m,mx,ki,kj
   vs = 0.0_wp
   vd = 0.0_wp
   vq = 0.0_wp
   ! set up overlap proportional potential
   do i = 1,nat
      ra(1:3) = xyz(1:3,i)
      stmp = 0.0_wp
      dtmp = 0.0_wp
      qtmp = 0.0_wp
      do j = 1,nat
         g3 = gab3(j,i)
         g5 = gab5(j,i)
         rb(1:3) = xyz(1:3,j)
         dra(1:3) = ra(1:3)-rb(1:3)
         dum3a = 0.0_wp ! collect gab3 dependent terms
         dum5a = 0.0_wp ! collect gab5 dependent terms
         r2a = 0.0_wp
         r2ab = 0.0_wp
         t2a = 0.0_wp
         ll = 0
         do l1 = 1,3
            ! potential from dipoles
            r2ab = r2ab+dra(l1)*dra(l1)  ! R_AC * R_AC
            t2a = t2a+dipm(l1,j)*dra(l1) ! mu_A * R_AC : for q-dip and dip-dip (q-shift)
            do l2 = 1,3
               ll = lin(l1,l2)
               ! potential from quadrupoles
               dum5a = dum5a-qp(ll,j)*dra(l1)*dra(l2)
               if(l2.ge.l1) cycle
               ki = l1+l2+1
               qtmp(ki) = qtmp(ki)-3.0_wp*q(j)*g5*dra(l2)*dra(l1)
            enddo
            qtmp(l1) = qtmp(l1)-1.50_wp*q(j)*g5*dra(l1)*dra(l1)
         enddo
         dum3a = -t2a ! q-dip ! w/o shift terms
         stmp = stmp+dum3a*g3+dum5a*g5
         do l1 = 1,3
            dum3a = dra(l1)*q(j) ! w/o shift terms
            dum5a = 3.0_wp*dra(l1)*t2a & ! dipint-dip
               & -r2ab*dipm(l1,j)  ! dipint-dip (diagonal)
            dtmp(l1) = dtmp(l1)+dum3a*g3+dum5a*g5
            qtmp(l1) = qtmp(l1)+0.50_wp*r2ab*q(j)*g5 !remove trace term
         enddo
      enddo
      vs(i) = stmp
      vd(1:3,i) = dtmp(1:3)
      vq(1:6,i) = qtmp(1:6)
      ! --- CT correction terms
      qs1 = aesData%dipKernel(at(i))*2.0_wp
      qs2 = aesData%quadKernel(at(i))*6.0_wp ! qpole pot prefactors
      t2a = 0.0_wp
      do l1 = 1,3
         ! potential from dipoles
         vd(l1,i) = vd(l1,i)-qs1*dipm(l1,i)
         do l2 = 1,l1-1
            ! potential from quadrupoles
            ll = lin(l1,l2)
            ki = l1+l2+1
            vq(ki,i) = vq(ki,i)-qp(ll,i)*qs2
         enddo
         ll = lin(l1,l1)
         vq(l1,i) = vq(l1,i)-qp(ll,i)*qs2*0.50_wp
         ! collect trace removal terms
         t2a = t2a+qp(ll,i)
      enddo
      ! trace removal
      t2a = t2a*aesData%quadKernel(at(i))
      do l1 = 1,3
         vq(l1,i) = vq(l1,i)+t2a
      enddo
      ! ---


   enddo

   !      call prmat(6,vs,nat,0,'vs')

end subroutine setdvsdq

! molmom: computes molecular multipole moments from CAMM
! n           : # of atoms
! xyz(3,n)    : cartesian coordinates
! q(n)        : atomic partial charges
! dipm(3,n)   : cumulative atomic dipole moments (x,y,z)
! qp(6,n)     : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
subroutine molmom(iunit,n,xyz,q,dipm,qp,dip,d3)
   use xtb_mctc_convert
   use xtb_lin, only : lin
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: n
   real(wp), intent(in)  :: xyz(:,:),q(:),dipm(:,:),qp(:,:)
   real(wp), intent(out) :: dip,d3(:)
   real(wp) rr1(3),rr2(3),tma(6),tmb(6),tmc(6),dum
   integer i,j,k,l
   rr1 = 0.0_wp
   rr2 = 0.0_wp
   write(iunit,'(a)')
   do i = 1,n
      do j = 1,3
         rr1(j) = rr1(j)+q(i)*xyz(j,i)
         rr2(j) = rr2(j)+dipm(j,i)
      enddo
   enddo
   d3(1:3) = rr1(1:3)+rr2(1:3)
   dip = sqrt(d3(1)**2+d3(2)**2+d3(3)**2)
   write(iunit,'(a)',advance='yes')'molecular dipole:'
   write(iunit,'(a)',advance='no')'                 '
   write(iunit,'(a)',advance='yes') &
      & 'x           y           z       tot (Debye)'
   write(iunit,'(a,3f12.3)') ' q only: ',rr1(1:3)
   write(iunit,'(a,4f12.3)') '   full: ',d3(1:3),dip*autod

   tma = 0.0_wp
   tmb = 0.0_wp
   tmc = 0.0_wp
   do i = 1,n
      l = 0
      do j = 1,3
         do k = 1,j
            l = lin(k,j)
            tma(l) = tma(l)+xyz(j,i)*xyz(k,i)*q(i)
            tmb(l) = tmb(l)+dipm(k,i)*xyz(j,i)+dipm(j,i)*xyz(k,i)
            tmc(l) = tmc(l)+qp(l,i)
         enddo
      enddo
   enddo
   ! remove traces and multiply with 3/2 in q and dip parts
   dum = tma(1)+tma(3)+tma(6)
   dum = 0.50_wp*dum
   tma = 1.50_wp*tma
   l = 0
   do j = 1,3
      l = l+j
      tma(l) = tma(l)-dum
   enddo
   dum = tmb(1)+tmb(3)+tmb(6)
   dum = 0.50_wp*dum
   tmb = 1.50_wp*tmb
   l = 0
   do j = 1,3
      l = l+j
      tmb(l) = tmb(l)-dum
   enddo
   write(iunit,'(a)',advance='yes')'molecular quadrupole (traceless):'
   write(iunit,'(a)',advance='no')'                '
   write(iunit,'(a)',advance='no')'xx          xy          yy          '
   write(iunit,'(a)',advance='yes')'xz          yz          zz'
   write(iunit,'(a,6f12.3)') ' q only: ',tma(1:6)
   write(iunit,'(a,6f12.3)') '  q+dip: ',tma(1:6)+tmb(1:6)
   write(iunit,'(a,6f12.3)') '   full: ',tma(1:6)+tmb(1:6)+tmc(1:6)

end subroutine molmom

! gradient evaluation from
! cumulative atomic multipole moment interactions: all interactions up to r**-3
! nat         : # of atoms
! xyz(3,nat)  : cartesian coordinates
! q(nat)      : atomic partial charges
! dipm(3,nat) : cumulative atomic dipole moments (x,y,z)
! qp(6,nat)   : traceless(!) cumulative atomic quadrupole moments (xx,xy,yy,xz,yz,zz)
! gab3,gab5   : damped R**-3 and R**-5 Coulomb laws, dimension: nat*(nat+1)/2
!               multiplication with numerator then leads to R**-2 and R**-3 decay, respectively
! radcn(nat)  : CN-depentent atomic radii
! dcn(3,i,j)  : derivative of radcn(j) w.r.t. cartesian directions of i
! exj         : exponent in gab, gab3, and gab5 - determines interpolation
! g           : nuclear gradient (3)
subroutine aniso_grad(nat,at,xyz,q,dipm,qp,kdmp3,kdmp5, &
      & radcn,dcn,gab3,gab5,g)
   use xtb_lin, only : lin
   !gab3 Hellmann-Feynman terms correct, shift terms to be tested yet
   implicit none
   integer, intent(in)   :: nat,at(:)
   real(wp), intent(in)    :: xyz(:,:),q(:),dipm(:,:),qp(:,:)
   real(wp), intent(in)    :: gab3(:,:),gab5(:,:)
   real(wp), intent(in)    :: kdmp3,kdmp5,radcn(:),dcn(:,:,:)
   real(wp), intent(inout) :: g(:,:)
   real(wp) qp1(6),rr(3),dip(3),rij(3)
   real(wp) ed,eq,edd,e01,e02,e11,r2,tt,tt3,q1,dxi
   real(wp) tmp2,tmp3,rab,rabi,ddm2,ddm3a,ddm3b,qqa,qqb
   real(wp) dgab3,dgab5,damp1,damp2,ddamp,qs2

   integer i,j,k,l,m,ki,kj,kl
   do i = 1,nat
      q1 = q(i)
      rr(1:3) = xyz(1:3,i)
      dip(1:3) = dipm(1:3,i)
      qp1(1:6) = qp(1:6,i)
      tmp2 = 0.0_wp ! cumulate terms propto CN gradient -  to scale only quadratically
      do j = 1,nat            ! loop over other atoms
         if(i.eq.j) cycle
         kj = lin(j,i)
         rij(1:3) = xyz(1:3,j)-rr(1:3)
         r2 = sum(rij*rij)
         rabi = 1.0_wp/sqrt(r2)
         !           call dzero(2.0_wp,rabi,at(i),at(j),damp,ddamp)
         call dzero(kdmp3,rabi,radcn(i),radcn(j),damp1,ddamp)
         dgab3 = dgab(3.0_wp,rabi,damp1,ddamp)
         !           call dzero(3.0_wp,rabi,at(i),at(j),damp,ddamp)
         call dzero(kdmp5,rabi,radcn(i),radcn(j),damp2,ddamp)
         dgab5 = dgab(5.0_wp,rabi,damp2,ddamp)
         !!!         DEBUG
         !            dgab3 = 0.0_wp
         !            dgab5 = 0.0_wp
         !            dgab3 = dgab3*100.0_wp
         !            dgab5 = dgab5*100.0_wp
         !!!
         ed = 0.0_wp
         edd = 0.0_wp
         eq = 0.0_wp
         !           dipole - charge
         do k = 1,3
            ed = ed+q(j)*dip(k)*rij(k)
            ed = ed-dipm(k,j)*q1*rij(k)
            tt = q1*dipm(k,j)-q(j)*dip(k)
            ! part of dip-q derivative
            g(k,i) = g(k,i)+gab3(j,i)*tt
            !              dip-dip & charge-qpole
            ddm2 = 0.0_wp
            ddm3a = 0.0_wp
            ddm3b = 0.0_wp
            qqa = 0.0_wp
            qqb = 0.0_wp
            do l = 1,3
               kl = lin(l,k)
               tt = rij(l)*rij(k)
               tt3 = 3.0_wp*tt
               eq = eq+q(j)*qp1(kl)*tt
               eq = eq+qp(kl,j)*q1*tt
               edd = edd-dipm(k,j)*dip(l)*tt3
               ! extra d-d terms
               ddm2 = ddm2+dipm(l,j)*dip(l)
               ddm3a = ddm3a+dip(l)*rij(l)
               ddm3b = ddm3b+dipm(l,j)*rij(l)
               ! extra q-qpole terms
               qqa = qqa+rij(l)*qp(kl,j)
               qqb = qqb+rij(l)*qp1(kl)
            enddo
            edd = edd+dipm(k,j)*dip(k)*r2
            g(k,i) = g(k,i)-2.0_wp*gab5(j,i)*ddm2*rij(k)
            g(k,i) = g(k,i)+3.0_wp*gab5(j,i)*ddm3a*dipm(k,j)
            g(k,i) = g(k,i)+3.0_wp*gab5(j,i)*ddm3b*dip(k)
            g(k,i) = g(k,i)-2.0_wp*gab5(j,i)*qqa*q1
            g(k,i) = g(k,i)-2.0_wp*gab5(j,i)*qqb*q(j)
         enddo
         do k = 1,3
            dxi = rij(k)*rabi
            g(k,i) = g(k,i)-ed*dgab3*dxi
            g(k,i) = g(k,i)-(eq+edd)*dgab5*dxi
         enddo
         ! collect terms for CN-dependent part
         rab = 0.50_wp*(radcn(i)+radcn(j))
         tmp3 = ed*kdmp3*gab3(j,i)*(damp1/rab)*(rab*rabi)**kdmp3
         tmp2 = tmp2+tmp3
         tmp3 = (eq+edd)*kdmp5*gab5(j,i)*(damp2/rab)*(rab*rabi)**kdmp5
         tmp2 = tmp2+tmp3
      enddo
      ! CN-dependent part  - O(N^2)
      tmp2 = 3.0_wp*tmp2
      g(:,:) = g-tmp2*dcn(:,:,i)

   enddo
end subroutine aniso_grad


! check and print sparsity w.r.t. individual contribution
! to get an idea
subroutine checkspars(nao,ndp,nqp,nmat,matlist,mqlst,mdlst)
   use xtb_lin, only : lin
   implicit none
   integer,intent(in) :: ndp,nqp,nmat,nao
   integer,intent(in) :: matlist(:,:)
   integer,intent(in) :: mqlst(:,:),mdlst(:,:)
   integer  :: i,j,m,k,ntot,mi,mj,ki,kj,mm,kk
   logical,allocatable ::  nzero(:)
   ! check overall sparsity
   allocate(nzero(nao*(nao+1)/2))
   nzero = .false.
   do k = 1,ndp
      ki = mdlst(1,k)
      kj = mdlst(2,k)
      kk = lin(ki,kj)
      nzero(kk) = .true.
   enddo
   do k = 1,nqp
      ki = mqlst(1,k)
      kj = mqlst(2,k)
      kk = lin(ki,kj)
      nzero(kk) = .true.
   enddo
   do k = 1,nmat
      ki = matlist(1,k)
      kj = matlist(2,k)
      kk = lin(ki,kj)
      nzero(kk) = .true.
   enddo
   mm = nao*(nao+1)/2
   ntot = 0
   do i = 1,mm
      if(nzero(i)) ntot = ntot+1
   enddo
   write(*,'(a)',advance='yes') ' '
   write(*,'(a)')'% of non-zero elements in H:'
   write(*,'(''           by overlap:'',f6.2)') &
      & 100.*float(nmat)/float(mm)
   write(*,'(''      by dipole ints.:'',f6.2)') &
      & 100.*float(ndp)/float(mm)
   write(*,'(''  by quadrupole ints.:'',f6.2)') &
      & 100.*float(nqp)/float(mm)
   write(*,'(''                total:'',f6.2)') &
      & 100.*float(ntot)/float(mm)
   write(*,'(a)',advance='yes') ' '
   deallocate(nzero)
end subroutine checkspars

! zero-damped gab
subroutine mmomgabzero(nat,at,xyz,kdmp3,kdmp5,radcn,gab3,gab5)
   implicit none
   integer, intent(in) :: nat,at(:)
   real(wp), intent(in)  ::  xyz(:,:),radcn(:)
   real(wp), intent(in)  ::  kdmp3,kdmp5
   real(wp), intent(out) :: gab3(:,:),gab5(:,:)
   real(wp) damp,ddamp

   real(wp) tmp1,tmp2,rr(3)
   integer i,j,k,l,lin

   !!!!!!! set up damped Coulomb operators for multipole interactions
   gab3 = 0.0_wp ! for r**-2 decaying q-dip term
   gab5 = 0.0_wp ! for r**-3 decaying terms (q-qpol,dip-dip)
   do i = 1,nat
      do j = 1,nat
         if (j.ge.i) cycle
         rr(1:3) = xyz(1:3,i)
         l = i*(i-1)/2+j
         tmp2 = 0.0_wp
         do k = 1,3
            tmp1 = xyz(k,j)-rr(k)
            tmp2 = tmp2+tmp1**2
         enddo
         tmp1 = 1.0_wp/sqrt(tmp2)
         !           call dzero(2.0_wp,tmp1,at(i),at(j),damp,ddamp)
         call dzero(kdmp3,tmp1,radcn(i),radcn(j),damp,ddamp)
         gab3(j,i) = gab(3.0_wp,tmp1,damp)
         gab3(i,j) = gab3(j,i)
         !           call dzero(3.0_wp,tmp1,at(i),at(j),damp,ddamp)
         call dzero(kdmp5,tmp1,radcn(i),radcn(j),damp,ddamp)
         gab5(j,i) = gab(5.0_wp,tmp1,damp)
         gab5(i,j) = gab5(j,i)
      enddo
   enddo

end subroutine mmomgabzero


!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     setup CN-dependet atomic radii
!     n : # of atoms
! at(n) : atomic number array
! cn(n) : coordination number of atoms
! shift : global offset from cnval     (parameter)
! expo  : exponent scaling/ steepness  (parameter)
! rmax  : maximum radius               (parameter)
! radcn : CN-dependent radius
subroutine get_radcn(aesData,n,at,cn,shift,expo,rmax,radcn)
   implicit none
   class(TMultipoleData), intent(in) :: aesData
   integer, intent (in) :: n,at(:)
   real(wp), intent (in)  :: cn(:),shift,expo,rmax
   real(wp), intent (out) :: radcn(:)
   real(wp) rco,t1,t2
   integer i,j
   do i = 1,n
      rco = aesData%multiRad(at(i))             ! base radius of element
      t1 =cn(i)-aesData%valenceCN(at(i))-shift  ! CN - VALCN - SHIFT
      t2 =rco +(rmax-rco)/(1.0_wp+exp(-expo*t1))
      radcn(i) = t2
   enddo
end subroutine get_radcn
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     derivative of CN-dependet atomic radii w.r.t. other atoms
!     n : # of atoms
! at(n) : atomic number array
! cn(n) : coordination number of atoms
! shift : global offset from cnval     (parameter)
! expo  : exponent scaling/ steepness  (parameter)
! rmax  : maximum radius               (parameter)
! dcn   : on input  : derivatives of CN(j) w.r.t. Cart. directions of i
!       : on output : derivatives of RADCN(j) w.r.t. Cart. directions of i
subroutine dradcn(aesData,n,at,cn,shift,expo,rmax,dcn)
   implicit none
   class(TMultipoleData), intent(in) :: aesData
   integer, intent (in) :: n,at(:)
   real(wp), intent (in)  :: cn(:),shift,expo,rmax
   real(wp), intent (inout) :: dcn(:,:,:)
   real(wp) rco,t1,t2,t3,t4,tmp1,tmp2
   integer i,j,k
   do i = 1,n
      rco = aesData%multiRad(at(i))             ! base radius of element
      t1 =exp(-expo*(cn(i)-aesData%valenceCN(at(i))-shift))  ! CN - VALCN - SHIFT
      t2 =(rmax-rco)/(1.0_wp+2.0_wp*t1+t1*t1)
      t2 = t2*expo*t1
      dcn(:,:,i) = dcn(:,:,i)*t2
   end do
end subroutine dradcn

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!     zero-damping function and derivative
!     rscal         : scaling of radii
!     dex           : exponent in zero-damping function
!     rabinv        : inverse distance, i.e., 1/Rab
!     aradi,radj    : CN-dependent atomic number radii
!     damp          : zero damping function
!     ddamp         : derivative w.r.t. Rab
subroutine dzero(dex,rabinv,radi,radj,damp,ddamp)
   implicit none
   real(wp), intent (in) :: radi,radj
   real(wp), intent (in)  :: rabinv,dex
   real(wp), intent (out) :: damp,ddamp
   real(wp) rco,f1,f2
   !     rco = 2.0/(1./aesData%multiRad(ati)+1./aesData%multiRad(atj))  ! unstable
   !     rco = sqrt(aesData%multiRad(ati)*aesData%multiRad(atj))        ! unstable
   rco = 0.5*(radi+radj)
   ! zero-damping function and gradient w.r.t. Rab
   damp = 1.0_wp/(1.0_wp+6.0_wp*(rco*rabinv)**dex)
   ddamp = -dex*rabinv*(damp*damp-damp)
end subroutine dzero

!!!   gab - computes the damped Coulomb type interaction with dex decay:
!     gab = damp * Rab**(-dex)
!     dex           : exponent defining the decay: Rab**(-dex)
!     rabinv        : inverse distance, i.e., 1/Rab
!     damp          : zero damping function
real(wp) function gab(dex,rabinv,damp)
   implicit none
   real(wp) dex,rabinv,damp
   ! compute r**dex decaying intermediate
   gab = damp*(rabinv**dex) ! LR-decay * damping
end function gab


!!!   dgab - computes the derivative w.r.t. Rab of a damped Coulomb type interaction with dex decay:
!     gab = damp * Rab**(-dex)
!     dex           : exponent defining the decay: Rab**(-dex)
!     rabinv        : inverse distance, i.e., 1/Rab
!     damp          : zero damping function
!     ddamp         : derivative of damping function
real(wp) function dgab(dex,rabinv,damp,ddamp)
   implicit none
   real(wp) dex,rabinv,damp,ddamp,tmp1
   ! compute r**dex decaying intermediate
   tmp1 = -dex*rabinv*(rabinv**dex) ! LR-decay derivative
   dgab = tmp1*damp+ddamp*rabinv**dex
end function dgab

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine gfn2broyden_diff(n,istart,nbr,dipm,qp,q_in,dq)
   implicit none
   integer, intent (in) :: n,nbr
   integer, intent (inout) ::  istart
   real(wp), intent (in)  :: dipm(:,:),qp(:,:),q_in(:)
   real(wp), intent (inout) :: dq(:)
   integer i,j,k
   k = istart
   do i = 1,n
      do j = 1,3
         k = k+1
         dq(k) = dipm(j,i)-q_in(k)
      enddo
      do j = 1,6
         k = k+1
         dq(k) = qp(j,i)-q_in(k)
      enddo
   enddo
   istart = k

end subroutine gfn2broyden_diff

subroutine gfn2broyden_save(n,istart,nbr,dipm,qp,q_in)
   implicit none
   integer, intent (in) :: n,nbr
   integer, intent (inout) ::  istart
   real(wp), intent (in)  :: dipm(:,:),qp(:,:)
   real(wp), intent (inout) :: q_in(:)
   integer i,j,k
   k = istart
   do i = 1,n
      do j = 1,3
         k = k+1
         q_in(k) = dipm(j,i)
      enddo
      do j = 1,6
         k = k+1
         q_in(k) = qp(j,i)
      enddo
   enddo
   istart = k

end subroutine gfn2broyden_save



subroutine gfn2broyden_out(n,istart,nbr,q_in,dipm,qp)
   implicit none
   integer, intent (in) :: n,nbr
   integer, intent (inout) ::  istart
   real(wp), intent (in)  :: q_in(:)
   real(wp), intent (out) :: dipm(:,:),qp(:,:)
   integer i,j,k
   k = istart
   do i = 1,n
      do j = 1,3
         k = k+1
         dipm(j,i) = q_in(k)
      enddo
      do j = 1,6
         k = k+1
         qp(j,i) = q_in(k)
      enddo
   enddo
   istart = k
end subroutine gfn2broyden_out


end module xtb_aespot

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_hlex
contains

subroutine hlex(nat,at,nbf,nao,ihomo,xyz,focc,s,cmo,eiga,basis)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autoev,evtoau
   use xtb_type_basisset
   use xtb_dtrafo
   use xtb_onetri
   use xtb_dipole
   implicit none
   type(TBasisset), intent(in) :: basis
   integer, intent(in)  :: nao,ihomo,nat,at(nat),nbf
   real(wp),intent(in)  :: cmo(nao,nao),eiga(nao),focc(nao),xyz(3,nat)
   real(wp),intent(in)  :: s(nao,nao)

   real(wp),allocatable :: cca(:)
   real(wp),allocatable :: dip2(:)
   real(wp),allocatable :: dip (:,:)

   integer  :: mo,n,i,j,k,idum,ii
   real(wp) :: dum,de,dtot(3),fl

   ! # of transformed MOs
   n=2

   allocate(cca(nao*nao))

   ! do only singly occ. ones
   cca=0
   ii =0
   do i=ihomo-1,ihomo
      ii=ii+1
      do j=1,nao
         cca(j+(ii-1)*nao)=cmo(j,i)
      enddo
   enddo

   ! boys
   !     dipole integrals
   allocate(dip2(nao*nao),dip(nbf*(nbf+1)/2,3))

   call Dints(nat,nbf,xyz,dip(1,1),dip(1,2),dip(1,3),basis)
   call cao2saop(nbf,nao,dip(1,1),basis)
   call cao2saop(nbf,nao,dip(1,2),basis)
   call cao2saop(nbf,nao,dip(1,3),basis)
   i=1
   j=2
   do mo=1,3
      call onetri(1,dip(1,mo),dip2,cca,nao,n)
      dtot(mo)=dip2(j+(i-1)*n)
   enddo
   dum=sqrt(dtot(1)**2+dtot(2)**2+dtot(3)**2)
   de=(eiga(ihomo)-eiga(ihomo-1))*evtoau
   write(*,*)
   write(*,*)'transition dipole moment (au) for excitation:',ihomo-1,ihomo
   write(*,*)'    X       Y       Z   '
   write(*,'(3f9.4,''  total (au/Debye): '',2f8.3)') &
   &      dtot(1),dtot(2),dtot(3),dum,dum*2.5418
   fl=sqrt(2.)*(2./3.)*dum*dum*de
   write(*,'('' dE (eV)             : '',f8.3)') de*autoev
   write(*,'('' oscillator strength : '',e12.5)') fl

end subroutine hlex
end module xtb_hlex

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_timings
   use, intrinsic :: iso_fortran_env, only : int64, output_unit
   use xtb_mctc_accuracy, only : wp
   implicit none

   public  :: init_timing,start_timing_run,stop_timing_run
   public  :: start_timing,stop_timing
   public  :: prdate,prtiming

   private :: timing_wall,timing_cpu,timing_max
   private :: start_date,start_time,start_zone,start_values
   private :: stop_date,stop_time,stop_zone,stop_values
   private :: timing
   private :: verbose

   real(wp),allocatable :: timing_wall(:)
   real(wp),allocatable :: timing_cpu(:)
   integer :: timing_max
   logical  :: verbose = .false.
   
   character(len=8)  :: start_date,stop_date
   character(len=10) :: start_time,stop_time
   character(len=5)  :: start_zone,stop_zone
   integer(int64) :: start_values(8),stop_values(8)

   intrinsic :: kind,date_and_time,system_clock,cpu_time,present

contains

subroutine prtiming(i,inmsg)
   implicit none
   integer,intent(in) :: i
   character(len=*),intent(in),optional :: inmsg
   character(len=:),allocatable :: msg
   real(wp) :: cputime,walltime
   integer(int64) ::  cpudays, cpuhours, cpumins
   integer(int64) :: walldays,wallhours,wallmins
!                      <7-------> <5---------> <7-----------> <10------------>
!  '(1x,a,1x,"time:",1x,5i,1x,"d",1x,2i,1x,"h",1x,2i,1x,"min",1x,f5.2,1x,"sec")'
!                     '(5i,1x,"d")'
!                             '(a,1x,2i,1x,"h")'
!                                            '(1x,2i,1x,"min")'                 
!                                                           '(1x,f5.2,1x,"sec")'
!  '(1x,a,1x,"time:",1x,a)'
   if (present(inmsg)) then
      msg = inmsg
   else
      msg = '*'
   endif
   !           DAYS   HOURS   MINUTES   SECONDS
   ! DAYS        1     1/24    1/1440   1/86400
   ! HOURS      24      1       1/60     1/3600
   ! MINUTES   1440    60        1        1/60
   ! SECONDS  86400   3600      60         1
   cputime = timing_cpu (i)
!  if (cputime.ge.86400._wp) then
      cpudays = int(cputime/86400._wp)
      cputime = cputime - cpudays*86400._wp
!  endif
!  if (cputime.ge.3600._wp) then
      cpuhours = int(cputime/3600._wp)
      cputime = cputime - cpuhours*3600._wp
!  endif
!  if (cputime.ge.60._wp) then
      cpumins = int(cputime/60._wp)
      cputime = cputime - cpumins*60._wp
!  endif
   walltime = timing_wall(i)
!  if (walltime.ge.86400._wp) then
      walldays = int(walltime/86400._wp)
      walltime = walltime - walldays*86400._wp
!  endif
!  if (walltime.ge.3600._wp) then
      wallhours = int(walltime/3600._wp)
      walltime = walltime - wallhours*3600._wp
!  endif
!  if (walltime.ge.60._wp) then
      wallmins = int(walltime/60._wp)
      walltime = walltime - wallmins*60._wp
!  endif
   
   if (verbose) then
      write(output_unit,'(1x,a,":")') msg
      write(output_unit,'(" * wall-time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') walldays,wallhours,wallmins,walltime
      write(output_unit,'(" *  cpu-time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")')  cpudays, cpuhours, cpumins, cputime
      write(output_unit,'(1x,"*",1x,"ratio c/w:",1x,f9.3,1x,"speedup")') timing_cpu (i)/timing_wall(i)
   else
      write(output_unit,'(1x,a,1x,"time: ",i5," d, ",i2," h, ",i2," min, ",f6.3," sec")') msg,walldays,wallhours,wallmins,walltime
   endif
end subroutine prtiming

function prtimestring(mode) result(timestring)
   character,intent(in) :: mode
   character(len=*),parameter :: timefmt = &
   &  '(a,''/'',a,''/'',a,1x,''at'',1x,a,'':'',a,'':'',a)'
   character(len=8)  :: date
   character(len=10) :: time
   character(len=5)  :: zone
   character(len=31) :: timestring
   select case(mode)
   case('S','s')
   write(timestring,timefmt) &
   &   start_date(:4),start_date(5:6),start_date(7:), &
   &   start_time(:2),start_time(3:4),start_time(5:)
   case('E','e')
   write(timestring,timefmt) &
   &   stop_date(:4),stop_date(5:6),stop_date(7:), &
   &   stop_time(:2),stop_time(3:4),stop_time(5:)
   case default
   call date_and_time(date,time,zone)
   write(timestring,timefmt) &
   &   date(:4),date(5:6),date(7:), &
   &   time(:2),time(3:4),time(5:)
   end select
end function prtimestring

subroutine prdate(mode)
   implicit none
   character,intent(in) :: mode
   character(len=*),parameter :: outfmt = '('' * '',a,1x,a)'
   character(len=8)  :: date
   character(len=10) :: time
   character(len=5)  :: zone
   character(len=31) :: timestring
   integer(int64) :: values(8)
   select case(mode)
   case('S','s')
   write(output_unit,outfmt) 'started run on', prtimestring(mode)
   case('E','e')
   write(output_unit,outfmt) 'finished run on', prtimestring(mode)
   case default
   write(output_unit,outfmt) 'current time:', prtimestring(mode)
   end select
end subroutine prdate

subroutine init_timing(i,verb)
   implicit none
   integer,intent(in) :: i
   logical,intent(in),optional :: verb
   if (allocated(timing_wall)) deallocate(timing_wall)
   if (allocated(timing_cpu))  deallocate(timing_cpu)
   if (present(verb)) verbose = verb
   timing_max = i
   allocate( timing_wall(i),  &
   &         timing_cpu (i),  &
   &         source=0.0_wp )
end subroutine init_timing

subroutine start_timing_run
   call date_and_time(start_date,start_time,start_zone,start_values)
end subroutine start_timing_run

subroutine stop_timing_run
   call date_and_time(stop_date,stop_time,stop_zone,stop_values)
end subroutine stop_timing_run

subroutine start_timing(i)
   implicit none
   integer,intent(in) :: i
   real(wp) :: time_cpu
   real(wp) :: time_wall
   call timing(time_cpu,time_wall)
   timing_cpu (i) = timing_cpu (i) - time_cpu
   timing_wall(i) = timing_wall(i) - time_wall
end subroutine start_timing

subroutine stop_timing(i)
   implicit none
   integer,intent(in) :: i
   real(wp) :: time_cpu
   real(wp) :: time_wall
   call timing(time_cpu,time_wall)
   timing_cpu (i) = timing_cpu (i) + time_cpu
   timing_wall(i) = timing_wall(i) + time_wall
end subroutine stop_timing

subroutine timing(time_cpu,time_wall)
   implicit none
   real(wp),intent(out) :: time_cpu
   real(wp),intent(out) :: time_wall
   integer(int64) :: time_count,time_rate,time_max
   call system_clock(time_count,time_rate,time_max)
   call cpu_time(time_cpu)
   time_wall = real(time_count,wp)/real(time_rate,wp)
end subroutine timing

end module xtb_mctc_timings

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

logical function equalrot(i,j,nall,thr,rot)
   implicit none
   integer i,j,nall
   real*8 rot(3,nall),r,r1,thr

   equalrot=.false.

   r1=rot(1,i)**2+rot(2,i)**2+rot(3,i)**2
   r=(rot(1,i)-rot(1,j))**2&
      & +(rot(2,i)-rot(2,j))**2&
      & +(rot(3,i)-rot(3,j))**2

   if(sqrt(r)/sqrt(r1).lt.thr) equalrot=.true.

end function

logical function equalrot2(i,j,nall,thr,rot)
   implicit none
   integer i,j,nall
   real*8 rot(3,0:nall),r,r1,r2,thr

   equalrot2=.false.

   r1=rot(1,i)**2+rot(2,i)**2+rot(3,i)**2
   r2=rot(1,j)**2+rot(2,j)**2+rot(3,j)**2
   r=(rot(1,i)-rot(1,j))**2&
      & +(rot(2,i)-rot(2,j))**2&
      & +(rot(3,i)-rot(3,j))**2

   if(2.*sqrt(r)/(sqrt(r1)+sqrt(r2)).lt.thr) equalrot2=.true.

end function

real*8 function rotdiff(i,j,nall,rot)
   implicit none
   integer i,j,nall
   real*8 rot(3,nall),r,r1,r2

   r1=rot(1,i)**2+rot(2,i)**2+rot(3,i)**2
   r2=rot(1,j)**2+rot(2,j)**2+rot(3,j)**2
   r=(rot(1,i)-rot(1,j))**2&
      & +(rot(2,i)-rot(2,j))**2&
      & +(rot(3,i)-rot(3,j))**2

   rotdiff=2.*sqrt(r)/(sqrt(r1)+sqrt(r2))

end function

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine write_tm_basis(iunit,xtbData,nat,at,basis,wfn)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_symbols, only : toLcSymbol
   use xtb_type_wavefunction
   use xtb_type_basisset
   use xtb_xtb_data
   implicit none
   type(TxTBData), intent(in) :: xtbData
   type(TBasisset),    intent(in) :: basis
   type(TWavefunction),intent(in) :: wfn
   integer,intent(in)  :: iunit
   integer,intent(in)  :: nat
   integer,intent(in)  :: at(nat)
   character(1) :: lnam(0:3)
   integer :: nn(94)
   integer :: iat,iatyp,ish,icao,ip,iprim,ishtyp

   lnam(0)='s'
   lnam(1)='p'
   lnam(2)='d'
   lnam(3)='f'

   write(iunit,'(a)') '$basis'
   nn=0
   do iat = 1, nat
      nn(at(iat)) = iat
   enddo
   write(iunit,'(a)') '*'
   do iatyp = 1, 86
      iat = nn(iatyp)
      if (iat.eq.0) cycle
      write(iunit,'(a,1x,a)') trim(toLcSymbol(iatyp)),'tbbas'
      write(iunit,'(a)') '*'
      do ish = 1, xtbData%nShell(iatyp)
         ishtyp = xtbData%hamiltonian%angShell(ish,iatyp)
         icao = basis%caoshell(ish,iat)
         write(iunit,'(1x,i3,2x,a1,25x,a)') &
            basis%nprim(icao+1),lnam(ishtyp)
         do ip = 1, basis%nprim(icao+1)
            iprim = ip + basis%primcount(icao+1)
            if (basis%cont(iprim) < 0) then
               write(iunit,'(2x,g16.11,1x,g17.11)') basis%alp(iprim), basis%cont(iprim)
            else
               write(iunit,'(2(2x,g16.11))') basis%alp(iprim), basis%cont(iprim)
            endif
         enddo
      enddo
      write(iunit,'(a)') '*'
   enddo
   write(iunit,'(a)') '$end'
end subroutine write_tm_basis

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_constants
   use xtb_mctc_accuracy, only : wp
   implicit none
   private
   real(wp),public,parameter :: pi = 3.1415926535897932384626433832795029_wp
   real(wp),public,parameter :: pi4 = 3.1415926535897932384626433832795029_wp*4._wp
!  √π
   real(wp),public,parameter ::  sqrtpi  = sqrt(pi)
!  2×π
   real(wp),public,parameter :: twopi = 2.0_wp * pi
!  4×π
   real(wp),public,parameter :: fourpi = 4.0_wp * pi
!  π/2
   real(wp),public,parameter :: pihalf = 0.5_wp * pi
!  2π/3
   real(wp),public,parameter :: twothirdpi = 2.0_wp * pi / 3.0_wp
!  Boltzmann constant in Eh/K
   real(wp),public,parameter :: kB = 3.166808578545117e-06_wp
!  speed of light c in vacuum in a.u.
   real(wp),public,parameter :: lightspeed = 137.0359990740_wp
end module xtb_mctc_constants

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_pcem
   use xtb_mctc_accuracy, only : wp
   implicit none

   public :: tb_pcem
   private

   type :: tb_pcem
      integer  :: n = 0
      real(wp),allocatable :: xyz(:,:)
      real(wp),allocatable :: q(:)
      real(wp),allocatable :: gam(:)
      real(wp),allocatable :: grd(:,:)
   contains
   procedure :: allocate => allocate_pcem
   procedure :: deallocate => deallocate_pcem
   end type tb_pcem

contains

subroutine allocate_pcem(self,n)
   implicit none
   class(tb_pcem),intent(inout) :: self
   integer,intent(in) :: n
   call self%deallocate
   self%n = n
   allocate(self%xyz(3,n), source = 0.0_wp )
   allocate(self%q  (n),   source = 0.0_wp )
   allocate(self%gam(n),   source = 0.0_wp )
   allocate(self%grd(3,n), source = 0.0_wp )
end subroutine allocate_pcem

subroutine deallocate_pcem(self)
   implicit none
   class(tb_pcem),intent(inout) :: self
   self%n = 0
   if (allocated(self%xyz)) deallocate(self%xyz)
   if (allocated(self%q))   deallocate(self%q)
   if (allocated(self%gam)) deallocate(self%gam)
   if (allocated(self%grd)) deallocate(self%grd)
end subroutine deallocate_pcem

end module xtb_type_pcem

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_gfnff_ini2
   use xtb_gfnff_data, only : TGFFData
   use xtb_gfnff_neighbourlist, only : TGFFNeighbourList
   use xtb_gfnff_topology, only : TGFFTopology
   use xtb_type_environment, only : TEnvironment
   implicit none
   private
   public :: gfnff_neigh, getnb, nbondmat
   public :: pairsbond, pilist, nofs, xatom, ctype, amide, amideH, alphaCO
   public :: ringsatom, ringsbond, ringsbend, ringstors, ringstorl
   public :: chktors, chkrng, hbonds, getring36, ssort, goedeckera, qheavy
   public :: gfnff_hbset, gfnff_hbset0, bond_hbset, bond_hbset0
   public :: bond_hb_AHB_set, bond_hb_AHB_set1, bond_hb_AHB_set0

contains

subroutine gfnff_neigh(env,makeneighbor,natoms,at,xyz,rab,fq,f_in,f2_in,lintr,mchar,hyb,itag,nbm,nbf,param,topo)
      use xtb_gfnff_param
      implicit none
      character(len=*), parameter :: source = 'gfnff_ini2_neigh'
      type(TEnvironment), intent(inout) :: env
      type(TGFFData), intent(in) :: param
      type(TGFFTopology), intent(inout) :: topo
      logical makeneighbor
      integer at(natoms),natoms
      integer hyb (natoms)
      integer itag(natoms)
      integer nbm(20,natoms)                 ! needed for ring assignment (done without metals)
      integer nbf(20,natoms)                 ! full needed for fragment assignment
      real*8  rab   (natoms*(natoms+1)/2)
      real*8  xyz(3,natoms)
      real*8  mchar(natoms)
      real*8  fq
      real*8  f_in,f2_in               ! radius scaling for atoms/metal atoms recpectively
      real*8  lintr                    ! threshold for linearity

      logical etacoord,da,strange_iat,metal_iat
      integer,allocatable :: nbdum(:,:)
      real*8 ,allocatable :: cn(:),rtmp(:)
      integer iat,i,j,k,ni,ii,jj,kk,ll,lin,ati,nb20i,nbdiff,hc_crit,nbmdiff,nnf,nni,nh,nm
      integer ai,aj,nn,im,ncm,l,no
      real*8 r,pi,a1,f,f1,phi,f2,rco,fat(86)
      data pi/3.1415926535897932384626433832795029d0/
      data fat   / 86 * 1.0d0 /

!     special hacks
      fat( 1)=1.02
      fat( 4)=1.03
      fat( 5)=1.02
      fat( 8)=1.02
      fat( 9)=1.05
      fat(10)=1.10
      fat(11)=1.01
      fat(12)=1.02
      fat(15)=0.97
      fat(18)=1.10
      fat(19)=1.02
      fat(20)=1.02
      fat(38)=1.02
      fat(34)=0.99
      fat(50)=1.01
      fat(51)=0.99
      fat(52)=0.95
      fat(53)=0.98
      fat(56)=1.02
      fat(76)=1.02
      fat(82)=1.06
      fat(83)=0.95

      allocate(cn(natoms),rtmp(natoms*(natoms+1)/2),nbdum(20,natoms))

! determine the neighbor list
      if(makeneighbor) then

        topo%nb =0  ! without highly coordinates atoms
        nbm=0  ! without any metal
        nbf=0  ! full

        do i=1,natoms
           cn(i)=dble(param%normcn(at(i)))
        enddo
        call gfnffrab(natoms,at,cn,rtmp) ! guess RAB based on "normal" CN
        do i=1,natoms
           ai=at(i)
           f1=fq
           if(param%metal(ai) > 0) f1 = f1 * 2.0d0
           do j=1,i-1
              f2=fq
              aj=at(j)
              if(param%metal(aj) > 0) f2 = f2 * 2.0d0
              k=lin(j,i)
              rco=rtmp(k)
              rtmp(k)=rtmp(k)-topo%qa(i)*f1-topo%qa(j)*f2 ! change radius of atom i and j with charge
!             element specials
              rtmp(k)=rtmp(k)*fat(ai)*fat(aj)
           enddo
        enddo

        call getnb(natoms,at,rtmp,rab,mchar,1,f_in,f2_in,nbdum,nbf,param) ! full
        call getnb(natoms,at,rtmp,rab,mchar,2,f_in,f2_in,nbf  ,topo%nb,param) ! no highly coordinates atoms
        call getnb(natoms,at,rtmp,rab,mchar,3,f_in,f2_in,nbf  ,nbm,param) ! no metals and unusually coordinated stuff

! take the input
      else

        nbf = topo%nb
        nbm = topo%nb

      endif
! done

      itag = 0 ! save special hyb info

! tag atoms in nb(19,i) if they belong to a cluster (which avoids the ring search)
      do i=1,natoms
         if(nbf(20,i).eq.0.and.param%group(at(i)).ne.8)then
            write(env%unit,'(''!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'')')
            write(env%unit,'(''  warning: no bond partners for atom'',i4)')i
            write(env%unit,'(''!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!'')')
         endif
         if(at(i).lt.11.and.nbf(20,i).gt.2)then
            do k=1,nbf(20,i)
               kk=nbf(k,i)
               if(param%metal(at(kk)).ne.0.or.topo%nb(20,kk).gt.4) then
                  topo%nb (19,i)=1
                  nbf(19,i)=1
                  nbm(19,i)=1
               endif
            enddo
         endif
!        write(env%unit,*) i,(topo%nb(j,i),j=1,topo%nb(20,i))
      enddo

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! hybridization states
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      do i=1,natoms
         ati  = at(i)
!        important: determine cases where atom is pi bonded to a metal and thus
!        the hyb must be obtained from the reduced (wo metals) neighbor list
         etacoord=.false.
         if(ati.le.10)then
            if(ati.eq.6.and.nbf(20,i).ge.4.and.nbm(20,i).eq.3) etacoord=.true.  ! CP case
            if(ati.eq.6.and.nbf(20,i).eq.3.and.nbm(20,i).eq.2) etacoord=.true.  ! alkyne case
            nm=0
            do k=1,nbf(20,i)  ! how many metals ? and which
               kk=nbf(k,i)
               if(param%metal(at(kk)).ne.0) then
                  nm=nm+1
                  im=kk
               endif
            enddo
            if(nm.eq.0) then
               etacoord=.false.  ! etacoord makes no sense without metals!
            elseif(nm.eq.1)then  ! distinguish M-CR2-R i.e. not an eta coord.
               ncm=0
               do k=1,nbf(20,i)  !
                  if(nbf(k,i).ne.im)then ! all neighbors that are not the metal im
                     kk=nbf(k,i)
                     do l=1,nbf(20,kk)
                        if(nbf(l,kk).eq.im) ncm=ncm+1 ! ncm=1 is alkyne, =2 is cp
                     enddo
                  endif
               enddo
               if(ncm.eq.0) etacoord=.false.
            endif
         endif
         if(etacoord)then
          itag(i)=-1
          nbdum(1:20,i)=nbm(1:20,i)
         else
          nbdum(1:20,i)=nbf(1:20,i) ! take full set of neighbors by default
         endif
      enddo

      do i=1,natoms
         ati  = at(i)
         hyb(i)=0    ! don't know it
         nbdiff =nbf(20,i)-topo%nb (20,i)
         nbmdiff=nbf(20,i)-nbm(20,i)
         nb20i=nbdum(20,i)
         nh=0
         no=0
         do j=1,nb20i
            if(at(nbdum(j,i)).eq.1) nh=nh+1
            if(at(nbdum(j,i)).eq.8) no=no+1
         enddo
! H
         if(param%group(ati).eq.1) then
            if(nb20i.eq.2)               hyb(i)=1 ! bridging H
            if(nb20i.gt.2)               hyb(i)=3 ! M+ tetra coord
            if(nb20i.gt.4)               hyb(i)=0 ! M+ HC
         endif
! Be
         if(param%group(ati).eq.2) then
            if(nb20i.eq.2)               hyb(i)=1 ! bridging M
            if(nb20i.gt.2)               hyb(i)=3 ! M+ tetra coord
            if(nb20i.gt.4)               hyb(i)=0 !
         endif
! B
         if(param%group(ati).eq.3) then
            if(nb20i.gt.4)                               hyb(i)=3
            if(nb20i.gt.4.and.ati.gt.10.and.nbdiff.eq.0) hyb(i)=5
            if(nb20i.eq.4)                               hyb(i)=3
            if(nb20i.eq.3)                               hyb(i)=2
            if(nb20i.eq.2)                               hyb(i)=1
         endif
! C
         if(param%group(ati).eq.4) then
            if(nb20i.ge.4)                               hyb(i)=3
            if(nb20i.gt.4.and.ati.gt.10.and.nbdiff.eq.0) hyb(i)=5
            if(nb20i.eq.3)                               hyb(i)=2
            if(nb20i.eq.2) then
              call bangl(xyz,nbdum(1,i),i,nbdum(2,i),phi)
              if(phi*180./pi.lt.150.0)then                         ! geometry dep. setup! GEODEP
                                                         hyb(i)=2  ! otherwise, carbenes will not be recognized
                                                        itag(i)=1  ! tag for Hueckel and HB routines
              else
                                                         hyb(i)=1  ! linear triple bond etc
              endif
              if(topo%qa(i).lt.-0.4)                          then
                                                         hyb(i)=2
                                                        itag(i)=0  ! tag for Hueckel and HB routines
              endif
            endif
            if(nb20i.eq.1)                               hyb(i)=1  ! CO
         endif
! N
         if(param%group(ati).eq.5) then
            if(nb20i.ge.4)                               hyb(i)=3
            if(nb20i.gt.4.and.ati.gt.10.and.nbdiff.eq.0) hyb(i)=5
            if(nb20i.eq.3)                               hyb(i)=3
            if(nb20i.eq.3.and.ati.eq.7)  then
               kk=0
               ll=0
               nn=0
               do j=1,3
                  jj=nbdum(j,i)
                  if(at(jj).eq. 8.and.topo%nb(20,jj).eq.1) kk=kk+1 ! check for NO2 or R2-N=O
                  if(at(jj).eq. 5.and.topo%nb(20,jj).eq.4) ll=ll+1 ! check for B-N, if the CN(B)=4 the N is loosely bound and sp2
                  if(at(jj).eq.16.and.topo%nb(20,jj).eq.4) nn=nn+1 ! check for N-SO2-
               enddo
               if(nn.eq.1.and.ll.eq.0.and.kk.eq.0)       hyb(i)=3
               if(ll.eq.1.and.nn.eq.0)                   hyb(i)=2
               if(kk.ge.1) then
                                                         hyb(i)=2
                                                        itag(i)=1  ! tag for Hueckel with no el. for the N in NO2
               endif
               if(nbmdiff.gt.0.and.nn.eq.0)              hyb(i)=2  ! pyridin N coord. to heavy atom
            endif
            if(nb20i.eq.2) then
                                                         hyb(i)=2
               call bangl(xyz,nbdum(1,i),i,nbdum(2,i),phi)
               jj=nbdum(1,i)
               kk=nbdum(2,i)
               if(nbdum(20,jj).eq.1.and.at(jj).eq.6)     hyb(i)=1  ! R-N=C
               if(nbdum(20,kk).eq.1.and.at(kk).eq.6)     hyb(i)=1  ! R-N=C
               if(nbdum(20,jj).eq.1.and.at(jj).eq.7)     hyb(i)=1  ! R-N=N in e.g. diazomethane
               if(nbdum(20,kk).eq.1.and.at(kk).eq.7)     hyb(i)=1  ! R-N=N in e.g. diazomethane
               if(nbdum(1,i).gt.0.and.param%metal(at(nbdum(1,i))).gt.0) hyb(i)=1 ! M-NC-R in e.g. nitriles
               if(nbdum(2,i).gt.0.and.param%metal(at(nbdum(2,i))).gt.0) hyb(i)=1 ! M-NC-R in e.g. nitriles
               if(at(jj).eq.7.and.at(kk).eq.7.and. &
     &          nbdum(20,jj).le.2.and.nbdum(20,kk).le.2) hyb(i)=1  ! N=N=N
               if(phi*180./pi.gt.lintr)                 hyb(i)=1  ! geometry dep. setup! GEODEP
            endif
            if(nb20i.eq.1)                               hyb(i)=1
         endif
! O
         if(param%group(ati).eq.6) then
            if(nb20i.ge.3)                               hyb(i)=3
            if(nb20i.gt.3.and.ati.gt.10.and.nbdiff.eq.0) hyb(i)=5
            if(nb20i.eq.2)                               hyb(i)=3
            if(nb20i.eq.2.and.nbmdiff.gt.0) then
               call nn_nearest_noM(i,natoms,at,topo%nb,rab,j,param) ! CN of closest non-M atom
                                        if(j.eq.3)       hyb(i)=2 ! M-O-X konj
                                        if(j.eq.4)       hyb(i)=3 ! M-O-X non
            endif
            if(nb20i.eq.1)                               hyb(i)=2
            if(nb20i.eq.1.and.nbdiff.eq.0) then
            if(topo%nb(20,topo%nb(1,i)).eq.1)                      hyb(i)=1 ! CO
            endif
         endif
! F
         if(param%group(ati).eq.7) then
            if(nb20i.eq.2)                               hyb(i)=1
            if(nb20i.gt.2.and.ati.gt.10)                 hyb(i)=5
         endif
! Ne
         if(param%group(ati).eq.8) then
                                                         hyb(i)=0
            if(nb20i.gt.0.and.ati.gt.2)                  hyb(i)=5
         endif
! done with main groups
         if(param%group(ati).le.0) then ! TMs
            nni=nb20i
            if(nh.ne.0.and.nh.ne.nni) nni=nni-nh ! don't count Hs
            if(nni.le.2)                               hyb(i)=1
            if(nni.le.2.and.param%group(ati).le.-6)          hyb(i)=2
            if(nni.eq.3)                               hyb(i)=2
            if(nni.eq.4.and.param%group(ati).gt.-7)          hyb(i)=3  ! early TM, tetrahedral
            if(nni.eq.4.and.param%group(ati).le.-7)          hyb(i)=3  ! late TM, square planar
            if(nni.eq.5.and.param%group(ati).eq.-3)          hyb(i)=3  ! Sc-La are tetrahedral CN=5
         endif
      enddo

      topo%nb = nbdum ! list is complete but hyb determination is based only on reduced (without metals) list

      deallocate(nbdum)

      j = 0
      do i=1,natoms
         if(topo%nb(20,i).gt.12) j = j +1
         do k=1,topo%nb(20,i)
            kk=topo%nb(k,i)
            if(at(kk).eq.6.and.at(i).eq.6.and.itag(i).eq.1.and.itag(kk).eq.1) then ! check the very special situation of
               itag(i) =0                                                          ! two carbene C bonded which is an arine
               itag(kk)=0
            endif
         enddo
      enddo
      if(dble(j)/dble(natoms).gt.0.3) then
         call env%error(' too many atoms with extreme high CN', source)
      end if

      end subroutine gfnff_neigh

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! fill neighbor list
!ccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine getnb(n,at,rad,r,mchar,icase,f,f2,nbf,nb,param)
      implicit none
      type(TGFFData), intent(in) :: param
      integer n,at(n),nbf(20,n),nb(20,n)
      real*8 rad(n*(n+1)/2),r(n*(n+1)/2),mchar(n),f,f2

      integer i,j,k,nn,icase,hc_crit,nnfi,nnfj,lin
      integer tag(n*(n+1)/2)
      real*8 rco,fm

      nb  = 0 ! resulting array (nbf is full from first call)
      tag = 0
      do i=1,n
         nnfi=nbf(20,i)                  ! full CN of i, only valid for icase > 1
         do j=1,i-1
            nnfj=nbf(20,j)               ! full CN of i
            fm=1.0d0
!           full case
            if(icase.eq.1)then
               if(param%metal(at(i)).eq.2) fm=fm*f2 !change radius for metal atoms
               if(param%metal(at(j)).eq.2) fm=fm*f2
               if(param%metal(at(i)).eq.1) fm=fm*(f2+0.025)
               if(param%metal(at(j)).eq.1) fm=fm*(f2+0.025)
            endif
!           no HC atoms
            if(icase.eq.2)then
               hc_crit = 6
               if(param%group(at(i)).le.2) hc_crit = 4
               if(nnfi.gt.hc_crit) cycle
               hc_crit = 6
               if(param%group(at(j)).le.2) hc_crit = 4
               if(nnfj.gt.hc_crit) cycle
            endif
!           no metals and unusually coordinated stuff
            if(icase.eq.3)then
               if(mchar(i).gt.0.25 .or. param%metal(at(i)).gt.0) cycle   ! metal case TMonly ?? TODO
               if(mchar(j).gt.0.25 .or. param%metal(at(j)).gt.0) cycle   ! metal case
               if(nnfi.gt.param%normcn(at(i)).and.at(i).gt.10)   cycle   ! HC case
               if(nnfj.gt.param%normcn(at(j)).and.at(j).gt.10)   cycle   ! HC case
            endif
            k=lin(j,i)
            rco=rad(k) !(rad(i)+rad(j))/0.5291670d0
!               R         est. R0
            if(r(k).lt. fm * f * rco) tag(k)=1
         enddo
      enddo

      do i=1,n
         nn = 0
         do j=1,n
            if(tag(lin(j,i)).eq.1.and.i.ne.j) then
               nn=nn+1
               nb(nn,i)=j
            endif
         enddo
         nb(20,i) = nn
      enddo

      end subroutine getnb 

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! find the CN of nearest non metal of atom i
!ccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine nn_nearest_noM(ii,n,at,nb,r,nn,param)
      implicit none
      type(TGFFData), intent(in) :: param
      integer ii,n,at(n),nn,nb(20,n)
      real*8 r(n*(n+1)/2)

      integer jmin,j,jj,lin
      real*8 rmin

      nn=0
      rmin=1.d+42
      jmin=0
      do j=1,nb(20,ii)
         jj=nb(j,ii)
         if(param%metal(at(jj)).ne.0) cycle
         if(r(lin(jj,ii)).lt.rmin)then
            rmin=r(lin(jj,ii))
            jmin=jj
         endif
      enddo

      if(jmin.gt.0) nn=nb(20,jmin)

      end subroutine nn_nearest_noM

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest ring in which atom i is located
!ccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine ringsatom(n,i,c,s,rings)
      implicit none
      integer n,i,k,l,c(10,20,n),s(20,n),rings,rings1

      rings=99
      do k=1,s(20,i)    ! all rings of atom i
         if(s(k,i).lt.rings) rings=s(k,i)
      enddo

      end subroutine ringsatom

!ccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest ring in which bond i-j is located
!ccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine ringsbond(n,i,j,c,s,rings)
      implicit none
      integer n,i,j,k,l,c(10,20,n),s(20,n),rings,rings1,rings2

      rings1=99
      rings2=99
      do k=1,s(20,i)    ! all rings of atom i
         do l=1,s(k,i)  ! all atoms of ring k
            if(c(l,k,i).eq.j.and.s(k,i).lt.rings1)then
               rings1=s(k,i)
            endif
         enddo
      enddo
      do k=1,s(20,j)    ! all rings of atom i
         do l=1,s(k,j)  ! all atoms of ring k
            if(c(l,k,j).eq.i.and.s(k,j).lt.rings2)then
               rings2=s(k,j)
            endif
         enddo
      enddo
      continue
      rings=min(rings1,rings2)
      if(rings.eq.99) rings=0

      end subroutine ringsbond

!cccccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest ring in which angle i-j-k is located
!cccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine ringsbend(n,i,j,k,c,s,rings)
      implicit none
      integer n,i,j,k,rings
      integer c(10,20,n),s(20,n)
      integer itest,rings1,rings2,rings3,m,l

      if(s(20,i).eq.0.or.s(20,j).eq.0.or.s(20,k).eq.0)then
         rings=0
         return
      endif

      rings1=99
      rings2=99
      rings3=99

      do m=1,s(20,i)    ! all rings of atom i
         itest=0
         do l=1,s(m,i)  ! all atoms of ring m
            if(c(l,m,i).eq.j.or.c(l,m,i).eq.k) itest=itest+1
         enddo
         if(itest.eq.2.and.s(m,i).lt.rings1) rings1=s(m,i)
      enddo
      do m=1,s(20,j)    ! all rings of atom j
         itest=0
         do l=1,s(m,j)  ! all atoms of ring m
            if(c(l,m,j).eq.i.or.c(l,m,j).eq.k) itest=itest+1
         enddo
         if(itest.eq.2.and.s(m,j).lt.rings2) rings2=s(m,j)
      enddo
      do m=1,s(20,k)    ! all rings of atom k
         itest=0
         do l=1,s(m,k)  ! all atoms of ring m
            if(c(l,m,k).eq.i.or.c(l,m,k).eq.j) itest=itest+1
         enddo
         if(itest.eq.2.and.s(m,j).lt.rings3) rings3=s(m,k)
      enddo

      rings=min(rings1,rings2,rings3)
      if(rings.eq.99) rings=0

      end subroutine ringsbend

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest torsion in which angle i-j-k-l is located
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine ringstors(n,i,j,k,l,c,s,rings)
      implicit none
      integer n,i,j,k,l,rings
      integer c(10,20,n),s(20,n)
      integer itest,rings1,rings2,rings3,rings4,m,a
!     integer ht1,ht2,ht3,ht4

      if(s(20,i).eq.0.or.s(20,j).eq.0.or.s(20,k).eq.0.or.s(20,l).eq.0)then
         rings=0
         return
      endif

      rings1=99
      rings2=99
      rings3=99
      rings4=99

      do m=1,s(20,i)    ! all rings of atom i
         itest=0
         do a=1,s(m,i)  ! all atoms of ring m
            if(c(a,m,i).eq.j.or.c(a,m,i).eq.k.or.c(a,m,i).eq.l) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,i).lt.rings1) then
            rings1=s(m,i)
!           ht1=c(m,19,i)
         endif
      enddo
      do m=1,s(20,j)    ! all rings of atom j
         itest=0
         do a=1,s(m,j)  ! all atoms of ring m
            if(c(a,m,j).eq.i.or.c(a,m,j).eq.k.or.c(a,m,j).eq.l) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,j).lt.rings2) then
            rings2=s(m,j)
!           ht2=c(m,19,j)
         endif
      enddo
      do m=1,s(20,k)    ! all rings of atom k
         itest=0
         do a=1,s(m,k)  ! all atoms of ring m
            if(c(a,m,k).eq.i.or.c(a,m,k).eq.j.or.c(a,m,k).eq.l) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,k).lt.rings3) then
            rings3=s(m,k)
!           ht3=c(m,19,k)
         endif
      enddo
      do m=1,s(20,l)    ! all rings of atom k
         itest=0
         do a=1,s(m,l)  ! all atoms of ring m
            if(c(a,m,l).eq.i.or.c(a,m,l).eq.k.or.c(a,m,l).eq.j) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,l).lt.rings4) then
            rings4=s(m,l)
!           ht4=c(m,19,l)
         endif
      enddo

      rings=min(rings1,rings2,rings3,rings4)
      if(rings.eq.99) then
         rings=0
      endif

      end subroutine ringstors

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! find smallest torsion in which angle i-j-k-l is located
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine ringstorl(n,i,j,k,l,c,s,ringl)
      implicit none
      integer n,i,j,k,l,ringl
      integer c(10,20,n),s(20,n)
      integer itest,rings1,rings2,rings3,rings4,m,a

      if(s(20,i).eq.0.or.s(20,j).eq.0.or.s(20,k).eq.0.or.s(20,l).eq.0)then
         ringl=0
         return
      endif

      rings1=-99
      rings2=-99
      rings3=-99
      rings4=-99

      do m=1,s(20,i)    ! all rings of atom i
         itest=0
         do a=1,s(m,i)  ! all atoms of ring m
            if(c(a,m,i).eq.j.or.c(a,m,i).eq.k.or.c(a,m,i).eq.l) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,i).gt.rings1) then
            rings1=s(m,i)
         endif
      enddo
      do m=1,s(20,j)    ! all rings of atom j
         itest=0
         do a=1,s(m,j)  ! all atoms of ring m
            if(c(a,m,j).eq.i.or.c(a,m,j).eq.k.or.c(a,m,j).eq.l) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,j).gt.rings2) then
            rings2=s(m,j)
         endif
      enddo
      do m=1,s(20,k)    ! all rings of atom k
         itest=0
         do a=1,s(m,k)  ! all atoms of ring m
            if(c(a,m,k).eq.i.or.c(a,m,k).eq.j.or.c(a,m,k).eq.l) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,k).gt.rings3) then
            rings3=s(m,k)
         endif
      enddo
      do m=1,s(20,l)    ! all rings of atom k
         itest=0
         do a=1,s(m,l)  ! all atoms of ring m
            if(c(a,m,l).eq.i.or.c(a,m,l).eq.k.or.c(a,m,l).eq.j) itest=itest+1
         enddo
         if(itest.eq.3.and.s(m,l).gt.rings4) then
            rings4=s(m,l)
         endif
      enddo

      ringl=max(rings1,rings2,rings3,rings4)
      if(ringl.eq.-99) then
         ringl=0
      endif

      end subroutine ringstorl

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      logical function chktors(n,xyz,i,j,k,l)  ! true if dihedral angle is bad i.e. near 180
      implicit none
      integer n,i,j,k,l
      real*8 xyz(3,n),phi

      chktors=.true.

      call bangl(xyz,j,i,k,phi)
!     write(env%unit,*) phi*180./3.1415926d0
      if(phi*180./3.1415926d0.gt.170.0d0) return
      call bangl(xyz,i,j,l,phi)
!     write(env%unit,*) phi*180./3.1415926d0
      if(phi*180./3.1415926d0.gt.170.0d0) return

      chktors=.false.

      end function chktors

      logical function chkrng(nn,n,c)
      implicit none
      integer n,idum(nn),nn,c(10),i,j
      chkrng=.true.
      idum=0
      do i=1,n
         idum(c(i))=idum(c(i))+1
      enddo
      j=0
      do i=1,nn
         if(idum(i).eq.1) j=j+1
      enddo
      if(j.ne.n) chkrng=.false.
      end function chkrng

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gfnff_hbset(n,at,xyz,sqrab,topo,nlist,hbthr1,hbthr2)
use xtb_mctc_accuracy, only : wp
      use xtb_gfnff_param
      implicit none
      type(TGFFTopology), intent(in) :: topo
      type(TGFFNeighbourList), intent(inout) :: nlist
      integer n
      integer at(n)
      real(wp) sqrab(n*(n+1)/2)
      real(wp) xyz(3,n)
      real(wp), intent(in) :: hbthr1, hbthr2

      integer i,j,k,nh,ia,ix,lin,ij,inh,jnh
      real(wp) rab,rmsd
      logical ijnonbond

      rmsd = sqrt(sum((xyz-nlist%hbrefgeo)**2))/dble(n)

      if(rmsd.lt.1.d-6 .or. rmsd.gt. 0.3d0) then ! update list if first call or substantial move occured

      nlist%nhb1=0
      nlist%nhb2=0
      do ix=1,topo%nathbAB
         i=topo%hbatABl(1,ix)
         j=topo%hbatABl(2,ix)
         ij=j+i*(i-1)/2
         rab=sqrab(ij)
         if(rab.gt.hbthr1)cycle
         ijnonbond=topo%bpair(ij).ne.1
         do k=1,topo%nathbH
            nh=topo%hbatHl(k)
            inh=lin(i,nh)
            jnh=lin(j,nh)
            if(topo%bpair(inh).eq.1.and.ijnonbond)then ! exclude cases where A and B are bonded
               nlist%nhb2=nlist%nhb2+1
               nlist%hblist2(1,nlist%nhb2)=i
               nlist%hblist2(2,nlist%nhb2)=j
               nlist%hblist2(3,nlist%nhb2)=nh
            elseif(topo%bpair(jnh).eq.1.and.ijnonbond)then ! exclude cases where A and B are bonded
               nlist%nhb2=nlist%nhb2+1
               nlist%hblist2(1,nlist%nhb2)=j
               nlist%hblist2(2,nlist%nhb2)=i
               nlist%hblist2(3,nlist%nhb2)=nh
            elseif(rab+sqrab(inh)+sqrab(jnh).lt.hbthr2) then
               nlist%nhb1=nlist%nhb1+1
               nlist%hblist1(1,nlist%nhb1)=i
               nlist%hblist1(2,nlist%nhb1)=j
               nlist%hblist1(3,nlist%nhb1)=nh
            endif
         enddo
      enddo

      nlist%nxb =0
      do ix=1,topo%natxbAB
         i =topo%xbatABl(1,ix)
         j =topo%xbatABl(2,ix)
         ij=j+i*(i-1)/2
         rab=sqrab(ij)
         if(rab.gt.hbthr2)cycle
         nlist%nxb=nlist%nxb+1
         nlist%hblist3(1,nlist%nxb)=i
         nlist%hblist3(2,nlist%nxb)=j
         nlist%hblist3(3,nlist%nxb)=topo%xbatABl(3,ix)
      enddo

      nlist%hbrefgeo = xyz

      endif  ! else do nothing

      end subroutine gfnff_hbset

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine bond_hbset(n,at,xyz,sqrab,bond_hbn,bond_hbl,topo,hbthr1,hbthr2)
use xtb_mctc_accuracy, only : wp
      use xtb_gfnff_param
      implicit none
      type(TGFFTopology), intent(in) :: topo
      integer,intent(in) :: n
      integer,intent(in) :: at(n)
      integer,intent(in) :: bond_hbn
      integer,intent(out) :: bond_hbl(3,bond_hbn)
      real(wp),intent(in) :: sqrab(n*(n+1)/2)
      real(wp),intent(in) :: xyz(3,n)
      real(wp),intent(in) :: hbthr1, hbthr2

      integer i,j,k,nh,ia,ix,lin,ij,inh,jnh
      integer bond_nr
      real(wp) rab
      logical ijnonbond


      bond_nr=0
      bond_hbl=0
      do ix=1,topo%nathbAB
         i=topo%hbatABl(1,ix)
         j=topo%hbatABl(2,ix)
         ij=j+i*(i-1)/2
         rab=sqrab(ij)
         if(rab.gt.hbthr1)cycle
         ijnonbond=topo%bpair(ij).ne.1
         do k=1,topo%nathbH
            nh=topo%hbatHl(k)
            inh=lin(i,nh)
            jnh=lin(j,nh)
            if(topo%bpair(inh).eq.1.and.ijnonbond)then ! exclude cases where A and B are bonded
               bond_nr=bond_nr+1
               bond_hbl(1,bond_nr)=i
               bond_hbl(2,bond_nr)=j
               bond_hbl(3,bond_nr)=nh
            elseif(topo%bpair(jnh).eq.1.and.ijnonbond)then ! exclude cases where A and B are bonded
               bond_nr=bond_nr+1
               bond_hbl(1,bond_nr)=j
               bond_hbl(2,bond_nr)=i
               bond_hbl(3,bond_nr)=nh
            endif
         enddo
      enddo

end subroutine bond_hbset

subroutine bond_hbset0(n,at,xyz,sqrab,bond_hbn,topo,hbthr1,hbthr2)
use xtb_mctc_accuracy, only : wp
      use xtb_gfnff_param
      implicit none
      type(TGFFTopology), intent(in) :: topo
      integer,intent(in) :: n
      integer,intent(in) :: at(n)
      integer,intent(out) :: bond_hbn
      real(wp),intent(in) :: sqrab(n*(n+1)/2)
      real(wp),intent(in) :: xyz(3,n)
      real(wp),intent(in) :: hbthr1, hbthr2

      integer i,j,k,nh,ia,ix,lin,ij,inh,jnh
      real(wp) rab
      logical ijnonbond


      bond_hbn=0
      do ix=1,topo%nathbAB
         i=topo%hbatABl(1,ix)
         j=topo%hbatABl(2,ix)
         ij=j+i*(i-1)/2
         rab=sqrab(ij)
         if(rab.gt.hbthr1)cycle
         ijnonbond=topo%bpair(ij).ne.1
         do k=1,topo%nathbH
            nh=topo%hbatHl(k)
            inh=lin(i,nh)
            jnh=lin(j,nh)
            if(topo%bpair(inh).eq.1.and.ijnonbond)then ! exclude cases where A and B are bonded
               bond_hbn=bond_hbn+1
            elseif(topo%bpair(jnh).eq.1.and.ijnonbond)then ! exclude cases where A and B are bonded
               bond_hbn=bond_hbn+1
            endif
         enddo
      enddo

end subroutine bond_hbset0

subroutine bond_hb_AHB_set(n,at,numbond,bond_hbn,bond_hbl,tot_AHB_nr,lin_AHB,topo)
      use xtb_gfnff_param
      implicit none
      !Dummy
      type(TGFFTopology), intent(inout) :: topo
      integer,intent(in)  :: n
      integer,intent(in)  :: numbond
      integer,intent(in)  :: at(n)
      integer,intent(in)  :: bond_hbn
      integer,intent(in)  :: bond_hbl(3,bond_hbn)
      integer,intent(in)  :: tot_AHB_nr
      integer,intent(inout) :: lin_AHB(0:tot_AHB_nr)
      !Stack
      integer :: i,j
      integer :: ii,jj
      integer :: ia,ja
      integer :: lin
      integer :: hbH,hbA
      integer :: Hat,Aat
      integer :: Bat,atB
      integer :: tot_count
      integer :: AH_count
      integer :: B_count
      integer :: lin_diff

      tot_count=0
      AH_count=0
      B_count=0
      lin_diff=0

      do i=1,numbond
         ii=topo%blist(1,i)
         jj=topo%blist(2,i)
         ia=at(ii)
         ja=at(jj)
         if (ia.eq.1) then
           hbH=ii
           hbA=jj
         else if (ja.eq.1) then
           hbH=jj
           hbA=ii
         else
           cycle
         end if
         if (at(hbA).eq.7.or.at(hbA).eq.8) then
            do j = 1, bond_hbn
               Bat = bond_hbl(2,j)
               atB = at(Bat)
               Aat  = bond_hbl(1,j)
               Hat  = bond_hbl(3,j)
               if (hbA.eq.Aat.and.hbH.eq.Hat) then
                  if (atB.eq.7.or.atB.eq.8) then
                     tot_count = tot_count + 1
                     lin_AHB(tot_count) = lin(hbA,hbH)
                     lin_diff=lin_AHB(tot_count)-lin_AHB(tot_count-1)
                     if (lin_diff.eq.0) then
                        B_count = B_count + 1
                     end if
                     !Next AH pair
                     if (lin_diff.ne.0) then
                        AH_count = AH_count + 1
                        topo%bond_hb_AH(1,AH_count) = hbA
                        topo%bond_hb_AH(2,AH_count) = hbH
                        !Reset B count
                        B_count = 1
                     end if
                     topo%bond_hb_Bn(AH_count) = B_count
                     topo%bond_hb_B(B_count,AH_count) = Bat
                  end if
               else
                 cycle
               end if
            end do
         end if
      end do

end subroutine bond_hb_AHB_set

subroutine bond_hb_AHB_set1(n,at,numbond,bond_hbn,bond_hbl,tot_AHB_nr,lin_AHB,AH_count,bmax,topo)
      use xtb_gfnff_param
      implicit none
      !Dummy
      type(TGFFTopology), intent(inout) :: topo
      integer,intent(in)  :: n
      integer,intent(in)  :: numbond
      integer,intent(in)  :: at(n)
      integer,intent(in)  :: bond_hbn
      integer,intent(in)  :: bond_hbl(3,bond_hbn)
      integer,intent(in)  :: tot_AHB_nr
      integer,intent(inout) :: lin_AHB(0:tot_AHB_nr)
      integer,intent(out) :: AH_count
      integer,intent(out) :: bmax
      !Stack
      integer :: i,j
      integer :: ii,jj
      integer :: ia,ja
      integer :: lin
      integer :: hbH,hbA
      integer :: Hat,Aat
      integer :: Bat,atB
      integer :: tot_count
      integer :: B_count
      integer :: lin_diff

      tot_count=0
      AH_count=0
      B_count=1
      bmax=1
      lin_diff=0

      do i=1,numbond
         ii=topo%blist(1,i)
         jj=topo%blist(2,i)
         ia=at(ii)
         ja=at(jj)
         if (ia.eq.1) then
           hbH=ii
           hbA=jj
         else if (ja.eq.1) then
           hbH=jj
           hbA=ii
         else
           cycle
         end if
         if (at(hbA).eq.7.or.at(hbA).eq.8) then
            do j = 1, bond_hbn
               Bat = bond_hbl(2,j)
               atB = at(Bat)
               Aat  = bond_hbl(1,j)
               Hat  = bond_hbl(3,j)
               if (hbA.eq.Aat.and.hbH.eq.Hat) then
                 if (atB.eq.7.or.atB.eq.8) then
                     tot_count = tot_count + 1
                     lin_AHB(tot_count) = lin(hbA,hbH)
                     lin_diff=lin_AHB(tot_count)-lin_AHB(tot_count-1)
                     if (lin_diff.eq.0) B_count = B_count + 1
                     if (lin_diff.ne.0) then
                        AH_count = AH_count + 1
                        B_count = 1
                     end if
                     if (B_count.gt.bmax) bmax = B_count
                  end if
               else
                 cycle
               end if
            end do
            topo%nr_hb(i) = B_count
         end if
      end do

end subroutine bond_hb_AHB_set1

subroutine bond_hb_AHB_set0(n,at,numbond,bond_hbn,bond_hbl,tot_AHB_nr,topo)
      use xtb_gfnff_param
      implicit none
      !Dummy
      type(TGFFTopology), intent(in) :: topo
      integer,intent(in)  :: n
      integer,intent(in)  :: numbond
      integer,intent(in)  :: at(n)
      integer,intent(in)  :: bond_hbn
      integer,intent(in)  :: bond_hbl(3,bond_hbn)
      integer,intent(out) :: tot_AHB_nr
      !Stack
      integer :: i,j
      integer :: ii,jj
      integer :: ia,ja
      integer :: hbH,hbA
      integer :: Hat,Aat
      integer :: Bat,atB

      tot_AHB_nr=0

      do i=1,numbond
         ii=topo%blist(1,i)
         jj=topo%blist(2,i)
         ia=at(ii)
         ja=at(jj)
         if (ia.eq.1) then
           hbH=ii
           hbA=jj
         else if (ja.eq.1) then
           hbH=jj
           hbA=ii
         else
           cycle
         end if
         if (at(hbA).eq.7.or.at(hbA).eq.8) then
            do j = 1, bond_hbn
               Bat = bond_hbl(2,j)
               atB = at(Bat)
               Aat  = bond_hbl(1,j)
               Hat  = bond_hbl(3,j)
               if (hbA.eq.Aat.and.hbH.eq.Hat) then
                 if (atB.eq.7.or.atB.eq.8) then
                     tot_AHB_nr = tot_AHB_nr + 1
                  end if
               else
                 cycle
               end if
            end do
         end if
      end do

end subroutine bond_hb_AHB_set0

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine gfnff_hbset0(n,at,xyz,sqrab,topo,nhb1,nhb2,nxb,hbthr1,hbthr2)
use xtb_mctc_accuracy, only : wp
      use xtb_gfnff_param
      implicit none
      type(TGFFTopology), intent(in) :: topo
      integer, intent(out) :: nhb1
      integer, intent(out) :: nhb2
      integer, intent(out) :: nxb
      integer n
      integer at(n)
      real(wp) sqrab(n*(n+1)/2)
      real(wp) xyz(3,n)
      real(wp),intent(in) :: hbthr1, hbthr2

      integer i,j,k,nh,ia,ix,lin,ij,inh,jnh
      logical ijnonbond
      real(wp) rab

      nhb1=0
      nhb2=0
      do ix=1,topo%nathbAB
         i=topo%hbatABl(1,ix)
         j=topo%hbatABl(2,ix)
         ij=j+i*(i-1)/2
         rab=sqrab(ij)
         if(rab.gt.hbthr1)cycle
         ijnonbond=topo%bpair(ij).ne.1
         do k=1,topo%nathbH
            nh=topo%hbatHl(k)
            inh=lin(i,nh)
            jnh=lin(j,nh)
            if(topo%bpair(inh).eq.1.and.ijnonbond)then
               nhb2=nhb2+1
            elseif(topo%bpair(jnh).eq.1.and.ijnonbond)then
               nhb2=nhb2+1
            elseif(rab+sqrab(inh)+sqrab(jnh).lt.hbthr2) then
               nhb1=nhb1+1
            endif
         enddo
      enddo

      nxb =0
      do ix=1,topo%natxbAB
         i =topo%xbatABl(1,ix)
         j =topo%xbatABl(2,ix)
         ij=j+i*(i-1)/2
         rab=sqrab(ij)
         if(rab.gt.hbthr2)cycle
         nxb=nxb+1
      enddo

      end subroutine gfnff_hbset0

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! HB strength
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine hbonds(i,j,ci,cj,param,topo)
      use xtb_gfnff_param
      implicit none
      type(TGFFTopology), intent(in) :: topo
      type(TGFFData), intent(in) :: param
      integer i,j
      integer ati,atj
      real*8 ci(2),cj(2)
      ci(1)=topo%hbbas(i)
      cj(1)=topo%hbbas(j)
      ci(2)=topo%hbaci(i)
      cj(2)=topo%hbaci(j)
      end subroutine hbonds

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! ring analysis routine, don't touch ;-)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine getring36(n,at,nbin,a0_in,cout,irout)
      implicit none
      integer cout(10,20),irout(20)  ! output: atomlist, ringsize, # of rings in irout(20)
      integer at(n)
      integer n,nbin(20,n),a0,i,nb(20,n),a0_in
      integer    i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
      integer n0,n1,n2,n3,n4,n5,n6,n7,n8,n9,n10
      integer    a1,a2,a3,a4,a5,a6,a7,a8,a9,a10
      integer maxr
      parameter (maxr=500)
      integer list(n),m,mm,nn,c(10),cdum(10,maxr),iring
      integer adum1(0:n),adum2(0:n),kk,j,idum(maxr),same(maxr),k
      real*8  w(n),av,sd

      cout = 0
      irout= 0
!     if(n.le.2.or.at(a0_in).gt.10.or.nbin(19,a0_in).eq.1) return
      if(n.le.2.                  .or.nbin(19,a0_in).eq.1) return

      nn=nbin(20,a0_in)

      cdum=0
      kk=0
      do m=1,nn
!     if(nb(m,a0_in).eq.1) cycle ! check (comment out)
      nb=nbin
      if(nb(m,a0_in).eq.1) cycle ! check (comment out)
      do i=1,n
         if(nb(20,i).eq.1)nb(20,i)=0
      enddo

      do mm=1,nn
         w(mm)=dble(mm)
         list(mm)=mm
      enddo
      w(m)   =0.0d0
      call ssort(nn,w,list)
      do mm=1,nn
         nb(mm,a0_in)=nbin(list(mm),a0_in)
      enddo

      iring =0
      c     =0

      a0=a0_in
      n0=nb(20,a0)

      do i1=1,n0
         a1=nb(i1,a0)
         if(a1.eq.a0) cycle
         n1=nb(20,a1)
         do i2=1,n1
            a2=nb(i2,a1)
            if(a2.eq.a1) cycle
            n2=nb(20,a2)
            do i3=1,n2
               a3=nb(i3,a2)
               n3=nb(20,a3)
               if(a3.eq.a2) cycle
               c(1)=a1
               c(2)=a2
               c(3)=a3
               if(a3.eq.a0.and.chkrng(n,3,c))then
                iring=3
                if(kk.eq.maxr) goto 99
                kk=kk+1
                cdum(1:iring,kk)=c(1:iring)
                idum(kk)=iring
               endif
               do i4=1,n3
                  a4=nb(i4,a3)
                  n4=nb(20,a4)
                  if(a4.eq.a3) cycle
                  c(4)=a4
                  if(a4.eq.a0.and.chkrng(n,4,c))then
                   iring=4
                   if(kk.eq.maxr) goto 99
                   kk=kk+1
                   cdum(1:iring,kk)=c(1:iring)
                   idum(kk)=iring
                  endif
                  do i5=1,n4
                     a5=nb(i5,a4)
                     n5=nb(20,a5)
                     if(a5.eq.a4) cycle
                     c(5)=a5
                     if(a5.eq.a0.and.chkrng(n,5,c))then
                      iring=5
                      if(kk.eq.maxr) goto 99
                      kk=kk+1
                      cdum(1:iring,kk)=c(1:iring)
                      idum(kk)=iring
                     endif
                     do i6=1,n5
                        a6=nb(i6,a5)
                        n6=nb(20,a6)
                        if(a6.eq.a5) cycle
                        c(6)=a6
                        if(a6.eq.a0.and.chkrng(n,6,c))then
                         iring=6
                         if(kk.eq.maxr) goto 99
                         kk=kk+1
                         cdum(1:iring,kk)=c(1:iring)
                         idum(kk)=iring
                        endif
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo

 99   continue

      enddo

! compare
      same=0
      do i=1,kk
         do j=i+1,kk
            if(idum(i).ne.idum(j)) cycle ! different ring size
            if(same(j).eq.1      ) cycle ! already double
            adum1=0
            adum2=0
            do m=1,10
               i1=cdum(m,i)
               i2=cdum(m,j)
               adum1(i1)=1
               adum2(i2)=1
            enddo
            if(sum(abs(adum1-adum2)).ne.0) then
                  same(j)=0
            else
                  same(j)=1
            endif
         enddo
      enddo

      m=0
      do i=1,kk
         if(same(i).eq.0) then
            m=m+1
            irout(m)=idum(i)     ! number of atoms in ring m
            nn=idum(i)
            cout(1:nn,m)=cdum(1:nn,i)
            if(m.gt.19) then
               m=19
               goto 999
            endif
         endif
      enddo
999   irout(20)=m  ! number of rings for this atom

      return
      end subroutine getring36

      subroutine ssort(n,edum,ind)
      implicit none
      integer n,ii,k,j,m,i,sc1
      real*8 edum(n),pp
      integer ind(n)

      do 140   ii = 2, n
         i = ii - 1
         k = i
         pp= edum(i)
         do 120   j = ii, n
            if (edum(j) .gt. pp) go to 120
            k = j
            pp= edum(j)
  120    continue
         if (k .eq. i) go to 140
         edum(k) = edum(i)
         edum(i) = pp
         sc1=ind(i)
         ind(i)=ind(k)
         ind(k)=sc1
  140 continue

      end subroutine ssort

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! neighbor only version of EEQ model
! included up to 1,4 interactions
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine goedeckera(env,n,at,nb,pair,q,es,topo)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_lapack, only : mctc_sytrf, mctc_sytrs
   implicit none
   character(len=*), parameter :: source = 'gfnff_ini2_goedeckera'
   type(TEnvironment), intent(inout) :: env
   type(TGFFTopology), intent(in) :: topo
   integer, intent(in)  :: n          ! number of atoms
   integer, intent(in)  :: at(n)      ! ordinal numbers
   integer, intent(in)  :: nb(20,n)   ! neighbors
   real(wp),intent(in)  :: pair(n*(n+1)/2)
   real(wp),intent(out) :: q(n)       ! output charges
   real(wp),intent(out) :: es         ! ES energy

!  local variables
   logical :: exitRun
   integer  :: m,i,j,k,l,ii,jj,kk
   integer  :: ij,lj
   integer,allocatable :: ipiv(:)

   real(wp) :: gammij,sief1,sief2
   real(wp) :: r2,r0
   real(wp) :: rij
   real(wp) :: tsqrt2pi,bohr
   real(wp) :: tmp
   real(wp),allocatable :: A (:,:)
   real(wp),allocatable :: x(:)

!  parameter
   parameter (tsqrt2pi = 0.797884560802866_wp)

   m=n+topo%nfrag ! # atoms frag constrain
   allocate(A(m,m),x(m),ipiv(m))

!  call prmati(6,pair,n,0,'pair')

   A = 0

!  setup RHS
   do i=1,n
      x(i)    =topo%chieeq(i) ! EN of atom
      A(i,i)  =topo%gameeq(i)+tsqrt2pi/sqrt(topo%alpeeq(i))
   enddo

!  setup A matrix
   do i=1,n
      do j=1,i-1
         ij = i*(i-1)/2+j
         rij=pair(ij)
         r2 = rij*rij
         gammij=1.d0/sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above
         tmp = erf(gammij*rij)/rij
         A(j,i) = tmp
         A(i,j) = tmp
      enddo
   enddo

!  fragment charge constrain
   do i=1,topo%nfrag
      x(n+i)=topo%qfrag(i)
      do j=1,n
         if(topo%fraglist(j).eq.i) then
            A(n+i,j)=1
            A(j,n+i)=1
         endif
      enddo
   enddo
!  call prmat(6,A,m,m,'A ini')

   call mctc_sytrf(env, a, ipiv)
   call mctc_sytrs(env, a, x, ipiv)

   call env%check(exitRun)
   if (exitRun) then
      call env%error('Solving linear equations failed', source)
      return
   end if

   q(1:n) = x(1:n)

   if(n.eq.1) q(1)=topo%qfrag(1)

!  energy
      es = 0.0_wp
      do i=1,n
      ii = i*(i-1)/2
      do j=1,i-1
         ij = ii+j
         rij=pair(ij)
         gammij=1.d0/sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above
         tmp = erf(gammij*rij)/rij
         es = es + q(i)*q(j)*tmp/rij
      enddo
      es = es - q(i)* topo%chieeq(i) &
     &        + q(i)*q(i)*0.5d0*(topo%gameeq(i)+tsqrt2pi/sqrt(topo%alpeeq(i)))
      enddo

end subroutine goedeckera

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! condense charges to heavy atoms based on topology
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine qheavy(n,at,nb,q)
      implicit none
      integer,intent(in)   ::  n,nb(20,n),at(n)
      real*8,intent(inout) ::  q(n)

      integer i,j,k
      real*8 qtmp(n)

      qtmp = q
      do i=1,n
         if(at(i).ne.1) cycle
         qtmp(i)=0
         do j=1,nb(20,i)
            k=nb(j,i)
            qtmp(k)=qtmp(k)+q(i)/dble(nb(20,i))  ! could be a bridging H
         enddo
      enddo

      q = qtmp

      end subroutine qheavy

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! determine number of cov. bonds between atoms
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      subroutine nbondmat(n,nb,pair)
      implicit none
!     Dummy
      integer,intent(in)  :: n
      integer,intent(in)  :: nb(20,n)
      integer,intent(out) ::  pair(n*(n+1)/2)
!     Stack
      integer i,ni,newi,j,newatom,tag,d,i1,ni1,iii,ii,jj,k,lin
      integer,allocatable :: list(:,:),nlist(:,:),nnn(:),nn(:)
      logical da

      allocate(nnn(n),nn(n),list(5*n,n),nlist(5*n,n))

      nn(1:n)=nb(20,1:n)

      pair=0
      list=0
      do i=1,n
         ni=nn(i)
         list(1:ni,i)=nb(1:ni,i)
      enddo

      nlist=list

      pair=0
      do i=1,n
         do j=1,nb(20,i)
            k=nb(j,i)
            pair(lin(k,i))=1
         enddo
      enddo

!     one bond, tag=1
      tag=1
!     call pairsbond(n,nn,list,pair,tag)

!     determine up to 3 bonds in between
      do d=1,2

!     loop over atoms
      do i=1,n
         ni=nn(i)
         newi=ni
!        all neighbors of i
         do ii=1,ni
            i1=list(ii,i)
            ni1=nb(20,i1)
!           all neighbors of neighbors of i
            do iii=1,ni1
               newatom=nb(iii,i1)
               da=.false.
               do j=1,newi
                  if(newatom.eq.list(j,i))da=.true.
               enddo
               if(.not.da)then
                 newi=newi+1
                 nlist(newi,i)=newatom
               endif
            enddo
         enddo
         nnn(i)=newi
      enddo

      list=nlist
      nn  =nnn

!     one bond more
      tag=tag+1
      call pairsbond(n,nn,list,pair,tag)

      enddo
      do i=1,n
         do j=1,i
            if(i.ne.j.and.pair(lin(j,i)).eq.0) pair(lin(j,i))=5
         enddo
      enddo

      end subroutine nbondmat

      subroutine pairsbond(n,nn,list,pair,tag)
      implicit none
      integer n,nn(n),list(5*n,n),tag
      integer i,j,k,ni,nj,ii,jj,ij
      integer pair(n*(n+1)/2)
      logical dai,daj

      do i=1,n
         ni=nn(i)
         ij= i*(i-1)/2
         do j=1,i-1
            k = ij+j
            nj=nn(j)
            dai=.false.
            daj=.false.
            do ii=1,ni
               if(list(ii,i).eq.j)daj=.true.
            enddo
            do jj=1,nj
               if(list(jj,j).eq.i)dai=.true.
            enddo
            if(dai.and.daj.and.pair(k).eq.0) then
               pair(k)=tag
            endif
         enddo
      enddo

      end subroutine pairsbond

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      logical function pilist(ati)
      integer ati
      pilist=.false.
!     if(ati.eq.5.or.ati.eq.6.or.ati.eq.7.or.ati.eq.8.or.ati.eq.9.or.ati.eq.16) pilist=.true.
      if(ati.eq.5.or.ati.eq.6.or.ati.eq.7.or.ati.eq.8.or.ati.eq.9.or.ati.eq.16.or.ati.eq.17) pilist=.true.
      end function pilist

      logical function nofs(ati)
      integer ati
      nofs=.false.
!     if(ati.eq.7.or.ati.eq.8.or.ati.eq.9.or.ati.eq.16) nofs=.true.
      if(ati.eq.7.or.ati.eq.8.or.ati.eq.9.or.ati.eq.16.or.ati.eq.17) nofs=.true.
      end function nofs

      logical function xatom(ati)
      integer ati
      xatom=.false.
      if(ati.eq.17.or.ati.eq.35.or.ati.eq.53.or.&  ! X in A-X...B
     &   ati.eq.16.or.ati.eq.34.or.ati.eq.52.or.&
     &   ati.eq.15.or.ati.eq.33.or.ati.eq.51) xatom=.true.
      end function xatom

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      integer function ctype(n,at,nb,pi,a)
      integer n,a,at(n),nb(20,n),pi(n)
      integer i,no,j

      ctype = 0 ! don't know

      no=0
      do i=1,nb(20,a)
         j=nb(i,a)
         if(at(j).eq.8.and.pi(j).ne.0) no = no + 1
      enddo

      if(no.eq.1.and.pi(a).ne.0) ctype = 1 ! a C=O carbon

      end function ctype

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      logical function alphaCO(n,at,hyb,nb,pi,a,b)
      integer n,a,b,at(n),hyb(n),nb(20,n),pi(n)
      integer i,j,no,nc

      alphaCO = .false. 
      if(pi(a).ne.0.and.hyb(b).eq.3.and.at(a).eq.6.and.at(b).eq.6) then  
         no = 0
         do i=1,nb(20,a)
            j=nb(i,a)
            if(at(j).eq. 8.and.pi(j).ne.0.and.nb(20,j).eq.1) no = no +1 ! a pi =O on the C?
         enddo
         if(no.eq.1) then
            alphaCO = .true.
            return
         endif
      endif
      if(pi(b).ne.0.and.hyb(a).eq.3.and.at(b).eq.6.and.at(a).eq.6) then  
         no = 0
         do i=1,nb(20,b)
            j=nb(i,b)
            if(at(j).eq. 8.and.pi(j).ne.0.and.nb(20,j).eq.1) no = no +1 ! a pi =O on the C?
         enddo
         if(no.eq.1) then
            alphaCO = .true.
            return
         endif
      endif
 
      end function alphaCO

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      logical function amide(n,at,hyb,nb,pi,a)
      integer n,a,at(n),hyb(n),nb(20,n),pi(n)
      integer i,j,no,nc,ic

      amide = .false. ! don't know
      if(pi(a).eq.0.or.hyb(a).ne.3.or.at(a).ne.7) return

      nc=0
      no=0
      do i=1,nb(20,a)
         j=nb(i,a)
         if(at(j).eq.6.and.pi(j).ne.0) then  ! a pi C on N?
            nc = nc + 1
            ic = j
         endif
      enddo

      if(nc.eq.1)then
         do i=1,nb(20,ic)
            j=nb(i,ic)
            if(at(j).eq. 8.and.pi(j).ne.0.and.nb(20,j).eq.1) no = no +1 ! a pi =O on the C?
!           if(at(j).eq.16.and.pi(j).ne.0.and.nb(20,j).eq.1) no = no +1 ! a pi =S on the C?
         enddo
      endif

      if( no .eq. 1 ) amide = .true.

      end function amide

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      logical function amideH(n,at,hyb,nb,pi,a)
      integer n,a,at(n),hyb(n),nb(20,n),pi(n)
      integer i,j,nc,nn
      !logical amide

      amideH = .false. ! don't know
      if(nb(20,a).ne.1               )  return
      nn=nb(1,a)       ! the N
      if(.not.amide(n,at,hyb,nb,pi,nn)) return

      nc=0
      do i=1,nb(20,nn)
         j=nb(i,nn)
         if(at(j).eq.6.and.hyb(j).eq.3) then  ! a sp3 C on N?
            nc = nc + 1
         endif
      enddo

      if( nc .eq. 1 ) amideH = .true.

      end function amideH

end module xtb_gfnff_ini2

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

c--------1---------2---------3---------4---------5---------6---------7--
c reference : g. cisneros, m .berrondo, c. f. bunge
c             computers and chemistry vol. 4, p 281 (1986)
c for ibm rs6000:
c                 s. grimme, uni bonn, 9.92
c erweitert auf gleichzeitige behandlung mehrerer wurzeln
c nach einem verfahren von
c       b. liu
c       numerical algorithms in chemistry:algebraic methods,
c       lbl-8158 lawrence berkeley laboratory
c       eds.: c. moler and i. shavitt
c                 b. engels, uni bonn, 12.93
c direct version and several modifications s.grimme, 6.2.99
c new general (BLAS) version SG, 12/18
c note: the current version only works for the LOWEST root i.e. nr=1 !!!
c-----------------------------------------------------------------------
 
      subroutine ddavid(pr,ini,n,nr,crite,H,C,e)
      use xtb_mctc_lapack, only : lapack_syevd
      use xtb_mctc_blas, only : blas_copy, blas_axpy, blas_dot,
     & blas_spmv
      implicit none                        
      logical pr      ! print logical
      logical ini     ! initialize start vector if .true., if false starts from previous vector
      integer n       ! dimension
      integer nr      ! # roots
      real*8  crite   ! eigenvalue convergence threshold
      real*8  H(n,n)  ! matrix to be diagonalized
      real*8  C(n,nr) ! eigenvectors
      real*8  e(nr)   ! eigenvalues

c local
      integer maxiter        ! maximum # of iterations
      parameter (maxiter=100)      
      integer iter,iconf(nr),ineue(nr),janf,jneu1,lun1,lun2
      integer iideks(nr*maxiter),mx2,idum,j,jalt,ilauf,jneu,nneue
      integer lauf,l1,l2,k,LWORK,LIWORK,INFO,ianf,i,ien,ico,ialt,memlun2
      integer,allocatable :: iwork(:)

      real*8 valn(nr),uim,s,one,zero,denerg
      real*8, allocatable :: adiag(:),vecf1(:),vecf2(:),w(:)
      real*8, allocatable :: Uaug(:,:),d(:),aux(:)
      real*8, allocatable :: AB(:,:),av(:),tmpav(:,:)
      real*8, allocatable :: HP(:)
      parameter (one =1)      
      parameter (zero=0)      

      mx2=nr*maxiter

      if(pr)then
      write(*,'(/,10x,''******************************************'')')
      write(*,'(10x,''*            multi-root davidson (R8)    *'')')
      write(*,'(10x,''******************************************'',/)')
      write(*,*) 'dim ',n,' # roots ',nr
      endif

      allocate(adiag(n),vecf1(n*nr),vecf2(n*nr),w(n),av(mx2*(mx2+1)/2),
     .         HP(n*(n+1)/2))

c IO
      lun1=86
      lun2=87
      open(unit=lun1,recl=n*8,access='direct',
     .        file='david1.tmp',
     .        form='unformatted')    
      open(unit=lun2,recl=n*8,access='direct',
     .        file='david2.tmp',
     .        form='unformatted')    

      k=0
      do i=1,n
         do j=1,i
            k=k+1
            HP(k)=H(j,i)
         enddo
      enddo

C H * C for initialization
      ianf = 1
      do i = 1,nr
         if(ini) then
          do k=1,n
            call random_number(s)
            C(k,i)=s
          enddo
          s=blas_dot(n,C(:,i),1,C(:,i),1)
          C(1:n,i)=C(1:n,i)/sqrt(s)
         endif
         call dmwrite(n,lun1,C(1,i),i)
c        call dgemv('N',n,n,ONE,H,n,C(1,i),1,ZERO,vecf2(ianf),1)
         call blas_spmv('U',n,ONE,HP,C(:,i),1,ZERO,vecf2(ianf:),1)
         call dmwrite(n,lun2,vecf2(ianf),i)   
         ianf = ianf + n
      enddo

c aufbau des iideks feldes
      iideks(1) = 1
      do idum = 2,mx2
         iideks(idum) = iideks(idum - 1) + idum
      enddo
      valn = 0
      iconf= 0
      e    = 0

      do i=1,n
         adiag(i)=H(i,i)
      enddo
    
      if(nr.eq.1)then
         av(1)=blas_dot(n,C(:,1),1,vecf2,1)
      else
         error stop '# roots > 1 not implemented'
c aufbau der startmatrix av = bi*a*bj mit bi, bj startvektoren
c     allocate(tmpav(nr,nr),AB(n,nr))
c     k=0
c     do l1=1,nr
c        do l2=1,l1
c           k=k+1
c           av(k)=tmpav(l2,l1)
c        enddo
c     enddo
c     deallocate(tmpav,AB)
      endif
c done

      j = nr 
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c eigentliche schleife im davidson
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      do iter = 1, maxiter

      lwork  = 1 + 6*j + 2*j**2
      liwork = 8*j
      allocate(Uaug(j,j),d(j),iwork(liwork),aux(lwork))

      k=0
      do l1=1,j
         do l2=1,l1
            k=k+1
            Uaug(l2,l1) = av(k)
            Uaug(l1,l2) = av(k)
         enddo
      enddo
      call lapack_syevd('V','U',j,Uaug,j,d,aux,LWORK,IWORK,LIWORK,INFO)
      valn(1:nr) = d(1:nr)

c aufbau der eigentlichen vektoren, die stehen dann auf vecf1
c multiplikation der vorherigen entwicklungsvektoren mit den entwicklungskoeffizienten
      vecf1=0     
      do i=1,j
         call dmread(n,lun1,w,i)
         ianf = 1
         do lauf = 1,nr    
            uim = Uaug(i,lauf)
            call blas_axpy(n,uim,w,1,vecf1(ianf:),1)
            ianf = ianf + n
         enddo
      enddo

c aufbau -E*bi: vecf1 ist bi; vecf2 dann E*bi
      ianf = 1
      do lauf = 1,nr    
         ien = ianf + n -1
         vecf2(ianf:ien) = -valn(lauf) * vecf1(ianf:ien)
         ianf = ianf + n
      enddo
c aufbau des residuen vektors (h*bi-e*bi)
c steht dann auf vecf2 ueberschreibt also -e*bi
c h*bi-e*bi steht jetzt auf vecf2
      do i=1,j
         call dmread(n,lun2,w,i)
         memlun2 = i
         ianf = 1
         do lauf = 1,nr   
            uim = Uaug(i,lauf)
            call blas_axpy(n,uim,w,1,vecf2(ianf:),1)
            ianf = ianf + n
         enddo
      enddo
      deallocate(Uaug,d,iwork,aux)

      ianf = 1
      do lauf = 1,nr            
         C(1:n,lauf)=vecf1(ianf:ianf+n-1)
         ianf = ianf + n
      enddo

c aufbau (h*bi - e*bi)/(e - haa); steht danach auf vecf2
      ianf = 1
      do lauf = 1,nr   
         call dvdssvd(n,valn(lauf),vecf2(ianf),adiag,vecf1(ianf))
         ianf = ianf + n
      enddo

      denerg = 0.0d0
      do lauf = 1,nr
         denerg = denerg + abs(valn(lauf) - e(lauf))
         if ( abs(valn(lauf) - e(lauf)) .lt. crite) iconf(lauf) = 1
      enddo
      denerg = denerg / nr   
      ico = sum(iconf)
      if(pr) write(*,*) iter,ico,denerg,valn(1:nr)

      if (ico .eq. nr) then
          if(pr) write(*,*) 'all roots converged'
          go to 9999
      endif

      if(j.gt.0) then
c-- mit allen alten
         nneue = 0
         ialt = j
         ianf = 1
         do lauf = 1,nr    
c orthogonaliesung des betrachteten auf die alten
           do jalt = 1,ialt
              call dmread(n,lun1,w,jalt)
              s=-blas_dot(n,w,1,vecf1(ianf:),1)
              call blas_axpy(n,s,w,1,vecf1(ianf:),1)
           enddo
c normierung dessen was vom betrachteten uebrig bleibt
           s=blas_dot(n,vecf1(ianf:),1,vecf1(ianf:),1)
           if (s.gt.0.00000001)then
c neuer wird mitgenommen
              s = ONE /sqrt(s)
              vecf1(ianf:ianf+n-1)= vecf1(ianf:ianf+n-1) * s
              ialt = ialt + 1
              nneue = nneue + 1
              ineue(nneue) = ianf
c wegschreiben des neuen zu den alten
              call dmwrite(n,lun1,vecf1(ianf),jalt)
           else
              goto 9999
           endif
           ianf = ianf + n
         enddo
      endif

c umspeichern der ueberlebenden vektoren auf vecf1
      ianf = 1
      do lauf = 1,nneue
         call blas_copy(n,vecf1(ineue(lauf):),1,vecf1(ianf:),1)
         ianf = ianf + n
      enddo

C H * C
      ianf = 1
      do i = 1,nneue
c        call dgemv('N',n,n,ONE,H,n,vecf1(ianf),1,ZERO,vecf2(ianf),1)
         call blas_spmv('U',n,ONE,HP,vecf1(ianf:),1,ZERO,vecf2(ianf:),1)
         ianf = ianf + n
      enddo

      ianf = 1
      do i = 1,nneue
         call dmwrite(n,lun2,vecf2(ianf),memlun2+i)   
         ianf = ianf + n
      enddo

c berechnung der neuen matrixelemente der davidson-matrix
c zunaechst mit den alten
      do jalt = 1,j 
        call dmread(n,lun1,w,jalt)
        ianf = 1 
        ilauf = iideks(j) + jalt
        do jneu = 1,nneue 
           av(ilauf) = blas_dot(n,w,1,vecf2(ianf:),1)
           ilauf = ilauf + jneu + j 
           ianf = ianf + n 
        enddo  
      enddo
c dann mit den neuen
      ianf = 1 
      do jneu = 1,nneue
         janf = 1 
         ilauf = iideks(j+jneu) - jneu + 1 
         do jneu1 = 1,jneu
            av(ilauf) = blas_dot(n,vecf2(ianf:),1,vecf1(janf:),1)
            janf = janf + n 
            ilauf = ilauf + 1 
        enddo
        ianf = ianf + n 
      enddo

c increase expansion space and iterate further
      e = valn 
      j = j + nneue

      enddo   

      if(pr) write(*,*) 'Warning: davidson not properly converged'
c exit

9999  continue

      deallocate(adiag,vecf1,vecf2,w,av,HP)
      close (lun1,status='delete')
      close (lun2,status='delete')

      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine dvdssvd(n,sl,v1,v2,v)
      implicit none                          
      real*8 sl, v1(*), v(*), v2(*)
      integer n

      integer i,m,mp1

      do i = 1,n
        v(i)=v1(i)/(sl-v2(i))
      enddo

      return
      end 

***********************************************************************

      subroutine dmwrite(n,iwo,v,irec)
      implicit none
      real*8 v(n)
      integer n,iwo,irec
      write(iwo,rec=irec) v
      return
      end 


      subroutine dmread(n,iwo,v,irec)
      implicit none
      real*8 v(n)
      integer n,iwo,irec
      read(iwo,rec=irec) v
      return
      end 

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c real*4 version
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine sdavid(pr,ini,n,nr,crite,H,C,e)
      use xtb_mctc_lapack, only : lapack_syevd
      use xtb_mctc_blas, only : blas_copy, blas_axpy, blas_dot,
     & blas_spmv
      implicit none                        
      logical pr      ! print logical
      logical ini     ! initialize start vector if .true., if false starts from previous vector
      integer n       ! dimension
      integer nr      ! # roots
      real*4  crite   ! eigenvalue convergence threshold
      real*4  H(n,n)  ! matrix to be diagonalized
      real*4  C(n,nr) ! eigenvectors
      real*4  e(nr)   ! eigenvalues

c local
      integer maxiter        ! maximum # of iterations
      parameter (maxiter=100)      
      integer iter,iconf(nr),ineue(nr),janf,jneu1,lun1,lun2
      integer iideks(nr*maxiter),mx2,idum,j,jalt,ilauf,jneu,nneue
      integer lauf,l1,l2,k,LWORK,LIWORK,INFO,ianf,i,ien,ico,ialt,memlun2
      integer,allocatable :: iwork(:)

      real*4 valn(nr),uim,s,one,zero,denerg
      real*4, allocatable :: adiag(:),vecf1(:),vecf2(:),w(:)
      real*4, allocatable :: Uaug(:,:),d(:),aux(:)
      real*4, allocatable :: AB(:,:),av(:),tmpav(:,:)
      real*4, allocatable :: HP(:)
      parameter (one =1)      
      parameter (zero=0)      

      mx2=nr*maxiter

      if(pr)then
      write(*,'(/,10x,''******************************************'')')
      write(*,'(10x,''*            multi-root davidson (R4)    *'')')
      write(*,'(10x,''******************************************'',/)')
      write(*,*) 'dim ',n,' # roots ',nr
      endif

      allocate(adiag(n),vecf1(n*nr),vecf2(n*nr),w(n),av(mx2*(mx2+1)/2),
     .         HP(n*(n+1)/2))

c IO
      lun1=86
      lun2=87
      open(unit=lun1,recl=n*4,access='direct',
     .        file='david1.tmp',
     .        form='unformatted')    
      open(unit=lun2,recl=n*4,access='direct',
     .        file='david2.tmp',
     .        form='unformatted')    

      k=0
      do i=1,n
         do j=1,i
            k=k+1
            HP(k)=H(j,i)
         enddo
      enddo

C H * C for initialization
      ianf = 1
      do i = 1,nr
         if(ini) then
          do k=1,n
            call random_number(s)
            C(k,i)=s
          enddo
          s=blas_dot(n,C(:,i),1,C(:,i),1)
          C(1:n,i)=C(1:n,i)/sqrt(s)
         endif
         call smwrite(n,lun1,C(1,i),i)
c        call sgemv('N',n,n,ONE,H,n,C(1,i),1,ZERO,vecf2(ianf),1)
         call blas_spmv('U',n,ONE,HP, C(:,i),1,ZERO,vecf2(ianf:),1)
         call smwrite(n,lun2,vecf2(ianf),i)   
         ianf = ianf + n
      enddo

c aufbau des iideks feldes
      iideks(1) = 1
      do idum = 2,mx2
         iideks(idum) = iideks(idum - 1) + idum
      enddo
      valn = 0
      iconf= 0
      e    = 0

      do i=1,n
         adiag(i)=H(i,i)
      enddo
    
      if(nr.eq.1)then
         av(1)=blas_dot(n,C(:,1),1,vecf2,1)
      else
         error stop '# roots > 1 not implemented'
c aufbau der startmatrix av = bi*a*bj mit bi, bj startvektoren
c     allocate(tmpav(nr,nr),AB(n,nr))
c     k=0
c     do l1=1,nr
c        do l2=1,l1
c           k=k+1
c           av(k)=tmpav(l2,l1)
c        enddo
c     enddo
c     deallocate(tmpav,AB)
      endif
c done

      j = nr 
      
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c eigentliche schleife im davidson
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      do iter = 1, maxiter

      lwork  = 1 + 6*j + 2*j**2
      liwork = 8*j
      allocate(Uaug(j,j),d(j),iwork(liwork),aux(lwork))

      k=0
      do l1=1,j
         do l2=1,l1
            k=k+1
            Uaug(l2,l1) = av(k)
            Uaug(l1,l2) = av(k)
         enddo
      enddo
      call lapack_syevd('V','U',j,Uaug,j,d,aux,LWORK,IWORK,LIWORK,INFO)
      valn(1:nr) = d(1:nr)

c aufbau der eigentlichen vektoren, die stehen dann auf vecf1
c multiplikation der vorherigen entwicklungsvektoren mit den entwicklungskoeffizienten
      vecf1=0     
      do i=1,j
         call smread(n,lun1,w,i)
         ianf = 1
         do lauf = 1,nr    
            uim = Uaug(i,lauf)
            call blas_axpy(n,uim,w,1,vecf1(ianf:),1)
            ianf = ianf + n
         enddo
      enddo

c aufbau -E*bi: vecf1 ist bi; vecf2 dann E*bi
      ianf = 1
      do lauf = 1,nr    
         ien = ianf + n -1
         vecf2(ianf:ien) = -valn(lauf) * vecf1(ianf:ien)
         ianf = ianf + n
      enddo
c aufbau des residuen vektors (h*bi-e*bi)
c steht dann auf vecf2 ueberschreibt also -e*bi
c h*bi-e*bi steht jetzt auf vecf2
      do i=1,j
         call smread(n,lun2,w,i)
         memlun2 = i
         ianf = 1
         do lauf = 1,nr   
            uim = Uaug(i,lauf)
            call blas_axpy(n,uim,w,1,vecf2(ianf:),1)
            ianf = ianf + n
         enddo
      enddo
      deallocate(Uaug,d,iwork,aux)

      ianf = 1
      do lauf = 1,nr            
         C(1:n,lauf)=vecf1(ianf:ianf+n-1)
         ianf = ianf + n
      enddo

c aufbau (h*bi - e*bi)/(e - haa); steht danach auf vecf2
      ianf = 1
      do lauf = 1,nr   
         call svdssvd(n,valn(lauf),vecf2(ianf),adiag,vecf1(ianf))
         ianf = ianf + n
      enddo

      denerg = 0.0d0
      do lauf = 1,nr
         denerg = denerg + abs(valn(lauf) - e(lauf))
         if ( abs(valn(lauf) - e(lauf)) .lt. crite) iconf(lauf) = 1
      enddo
      denerg = denerg / nr   
      ico = sum(iconf)
      if(pr) write(*,*) iter,ico,denerg,valn(1:nr)

      if (ico .eq. nr) then
          if(pr) write(*,*) 'all roots converged'
          go to 9999
      endif

      if(j.gt.0) then
c-- mit allen alten
         nneue = 0
         ialt = j
         ianf = 1
         do lauf = 1,nr    
c orthogonaliesung des betrachteten auf die alten
           do jalt = 1,ialt
              call smread(n,lun1,w,jalt)
              s=-blas_dot(n,w,1,vecf1(ianf:),1)
              call blas_axpy(n,s,w,1,vecf1(ianf:),1)
           enddo
c normierung dessen was vom betrachteten uebrig bleibt
           s=blas_dot(n,vecf1(ianf:),1,vecf1(ianf:),1)
           if (s.gt.0.00000001)then
c neuer wird mitgenommen
              s = ONE /sqrt(s)
              vecf1(ianf:ianf+n-1)= vecf1(ianf:ianf+n-1) * s
              ialt = ialt + 1
              nneue = nneue + 1
              ineue(nneue) = ianf
c wegschreiben des neuen zu den alten
              call smwrite(n,lun1,vecf1(ianf),jalt)
           else
              goto 9999
           endif
           ianf = ianf + n
         enddo
      endif

c umspeichern der ueberlebenden vektoren auf vecf1
      ianf = 1
      do lauf = 1,nneue
         call blas_copy(n,vecf1(ineue(lauf):),1,vecf1(ianf:),1)
         ianf = ianf + n
      enddo

C H * C
      ianf = 1
      do i = 1,nneue
c        call sgemv('N',n,n,ONE,H,n,vecf1(ianf),1,ZERO,vecf2(ianf),1)
         call blas_spmv('U',n,ONE,HP,vecf1(ianf:),1,ZERO,vecf2(ianf:),1)
         ianf = ianf + n
      enddo

      ianf = 1
      do i = 1,nneue
         call smwrite(n,lun2,vecf2(ianf),memlun2+i)   
         ianf = ianf + n
      enddo

c berechnung der neuen matrixelemente der davidson-matrix
c zunaechst mit den alten
      do jalt = 1,j 
        call smread(n,lun1,w,jalt)
        ianf = 1 
        ilauf = iideks(j) + jalt
        do jneu = 1,nneue 
           av(ilauf) = blas_dot(n,w,1,vecf2(ianf:),1)
           ilauf = ilauf + jneu + j 
           ianf = ianf + n 
        enddo  
      enddo
c dann mit den neuen
      ianf = 1 
      do jneu = 1,nneue
         janf = 1 
         ilauf = iideks(j+jneu) - jneu + 1 
         do jneu1 = 1,jneu
            av(ilauf) = blas_dot(n,vecf2(ianf:),1,vecf1(janf:),1)
            janf = janf + n 
            ilauf = ilauf + 1 
        enddo
        ianf = ianf + n 
      enddo

c increase expansion space and iterate further
      e = valn 
      j = j + nneue

      enddo   

      if(pr) write(*,*) 'Warning: davidson not properly converged'
c exit

9999  continue

      deallocate(adiag,vecf1,vecf2,w,av,HP)
      close (lun1,status='delete')
      close (lun2,status='delete')

      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine svdssvd(n,sl,v1,v2,v)
      implicit none                          
      real*4 sl, v1(*), v(*), v2(*)
      integer n

      integer i,m,mp1

      do i = 1,n
        v(i)=v1(i)/(sl-v2(i))
      enddo

      return
      end 

***********************************************************************

      subroutine smwrite(n,iwo,v,irec)
      implicit none
      real*4 v(n)
      integer n,iwo,irec
      write(iwo,rec=irec) v
      return
      end 


      subroutine smread(n,iwo,v,irec)
      implicit none
      real*4 v(n)
      integer n,iwo,irec
      read(iwo,rec=irec) v
      return
      end 

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> This data types wraps common restart data for calculator, the main purpose
!  of this data type is to keep the calculator free from data that is changed
!  in the course of the calculation.
module xtb_type_restart
#if WITH_TBLITE
   use tblite_wavefunction, only : wavefunction_type
#endif
   use xtb_type_wavefunction, only : TWavefunction
   use xtb_gfnff_neighbourlist, only : TGFFNeighbourList
   implicit none
   private

   public :: TRestart


   !> Restart wrapper type
   type :: TRestart
      !> Tight binding wavefunction
      type(TWavefunction) :: wfn
      !> Force field topology
      type(TGFFNeighbourList) :: nlist
#if WITH_TBLITE
      !> TBLite cache
      type(wavefunction_type) :: tblite
#endif
   contains
      procedure :: copy => copyRestartType
   end type TRestart

contains

subroutine copyRestartType(self, other)
   class(TRestart), intent(out) :: self
   class(TRestart), intent(in) :: other

   self%wfn = other%wfn
   self%nlist = other%nlist
#if WITH_TBLITE
   self%tblite = other%tblite
#endif
end subroutine copyRestartType


end module xtb_type_restart

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_param
   use xtb_mctc_accuracy, only : wp
   implicit none

   public :: dftd_parameter
   public :: TxTBParameter
   public ::  scc_parameter

   public :: chrg_parameter
   private

   type :: TxTBParameter
      real(wp) :: kshell(0:3) = 0.0_wp
      real(wp) :: ksp = 0.0_wp
      real(wp) :: ksd = 0.0_wp
      real(wp) :: kpd = 0.0_wp
      real(wp) :: kdiff = 0.0_wp
      real(wp) :: kdiffa = 0.0_wp
      real(wp) :: kdiffb = 0.0_wp
      real(wp) :: enshell(0:3) = 0.0_wp
      real(wp) :: enscale4 = 0.0_wp
      real(wp) :: cnshell(2, 0:3) = 0.0_wp
      real(wp) :: gam3shell(2, 0:3) = 0.0_wp
      real(wp) :: srbshift = 0.0_wp
      real(wp) :: srbpre = 0.0_wp
      real(wp) :: srbexp = 0.0_wp
      real(wp) :: srbken = 0.0_wp
      real(wp) :: wllscal = 0.0_wp
      real(wp) :: gscal = 0.0_wp
      real(wp) :: zcnf = 0.0_wp
      real(wp) :: tscal = 0.0_wp
      real(wp) :: kcn = 0.0_wp
      real(wp) :: fpol = 0.0_wp
      real(wp) :: ken = 0.0_wp
      real(wp) :: lshift = 0.0_wp
      real(wp) :: lshifta = 0.0_wp
      real(wp) :: split = 0.0_wp
      real(wp) :: zqf = 0.0_wp
      real(wp) :: alphaj = 0.0_wp
      real(wp) :: kexpo = 0.0_wp
      real(wp) :: dispa = 0.0_wp
      real(wp) :: dispb = 0.0_wp
      real(wp) :: dispc = 0.0_wp
      real(wp) :: dispatm = 0.0_wp
      real(wp) :: xbdamp = 0.0_wp
      real(wp) :: xbrad = 0.0_wp
      real(wp) :: aesshift = 0.0_wp
      real(wp) :: aesexp = 0.0_wp
      real(wp) :: aesrmax = 0.0_wp
      real(wp) :: aesdmp3 = 0.0_wp
      real(wp) :: aesdmp5 = 0.0_wp
      real(wp) :: ipeashift = 0.0_wp
      real(wp) :: renscale = 0.0_wp
   end type TxTBParameter

   type :: dftd_parameter
      real(wp) :: s6  = -1.0_wp
      real(wp) :: s8  = -1.0_wp
      real(wp) :: s10 =  0.0_wp
      real(wp) :: a1  = -1.0_wp
      real(wp) :: a2  = -1.0_wp
      real(wp) :: s9  =  1.0_wp
      integer  :: alp = 16
      ! for MBD@rsSCS
      real(wp) :: beta = 1.0_wp
   end type dftd_parameter

   type :: scc_parameter
      real(wp) :: gam3l(0:3)
      real(wp) :: ipshift
      real(wp) :: eashift
      real(wp) :: g_a
      real(wp) :: g_c
      real(wp) :: wf
   end type scc_parameter

   type chrg_parameter
      integer  :: n
      real(wp),allocatable :: en(:)
      real(wp),allocatable :: gam(:)
      real(wp),allocatable :: kappa(:)
      real(wp),allocatable :: alpha(:)
      real(wp),allocatable :: dpol(:)
      real(wp),allocatable :: beta(:)
   contains
      procedure :: allocate => allocate_chrgeq
      procedure :: deallocate => deallocate_chrgeq
   end type chrg_parameter

contains

subroutine allocate_chrgeq(self,n,extended)
   implicit none
   class(chrg_parameter) :: self
   integer,intent(in) :: n
   logical,intent(in),optional :: extended
   logical :: multipoles
   if (present(extended)) then
      multipoles = extended
   else
      multipoles = .false.
   endif
   call self%deallocate
   allocate( self%en(n),    source = 0.0_wp )
   allocate( self%gam(n),   source = 0.0_wp )
   allocate( self%kappa(n), source = 0.0_wp )
   allocate( self%alpha(n), source = 0.0_wp )
   if (multipoles) then
   allocate( self%dpol(n),  source = 0.0_wp )
   allocate( self%beta(n),  source = 0.0_wp )
   endif
end subroutine allocate_chrgeq

subroutine deallocate_chrgeq(self)
   implicit none
   class(chrg_parameter) :: self
   if (allocated(self%en))    deallocate(self%en)
   if (allocated(self%gam))   deallocate(self%gam)
   if (allocated(self%kappa)) deallocate(self%kappa)
   if (allocated(self%alpha)) deallocate(self%alpha)
   if (allocated(self%dpol))  deallocate(self%dpol)
   if (allocated(self%beta))  deallocate(self%beta)
end subroutine deallocate_chrgeq

end module xtb_type_param

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Generator for lattice points
module xtb_type_latticepoint
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_boundaryconditions, only : boundaryCondition
   use xtb_mctc_math, only : crossProd
   use xtb_mctc_search, only : bisectSearch
   use xtb_mctc_sort, only : indexHeapSort
   use xtb_mctc_thresholds, only : tolSameDist2
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   implicit none
   private

   public :: TLatticePoint, init


   !> Lattice point generator
   type :: TLatticePoint

      !> Boundary conditions for this generator
      integer :: boundaryCondition

      !> Ranges for generating translations
      integer :: ranges(2, 3)

      !> Lattice vectors
      real(wp) :: lattice(3, 3)

      !> Real space cutoff for the generation of lattice points
      real(wp) :: cutoff

      !> Exclude inversion symmetry in the lattice points
      logical :: excludeInversion

      !> Number of generated translations
      integer :: nTrans

      !> Lattice translations
      integer, allocatable :: trans(:, :)

      !> Distance of lattice points from origin
      real(wp), allocatable :: dist2(:)

   contains

      !> Update lattice points
      procedure :: update

      !> Returns all lattice points within a given cutoff
      procedure :: getLatticePoints

      !> Generate lattice points
      procedure :: generate

   end type TLatticePoint


   !> Initializes lattice point generator
   interface init
      module procedure :: initLatticePoint
      module procedure :: initLatticePointMolecule
   end interface init


contains


!> Initializes lattice point generator
subroutine initLatticePointMolecule(self, env, mol, cutoff, excludeInversion)

   !> Instance of the lattice point generator
   type(TLatticePoint), intent(out) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Real space cutoff for the generation of lattice points
   real(wp), intent(in) :: cutoff

   !> Exclude inversion symmetry in the lattice points
   logical, intent(in), optional :: excludeInversion

   call init(self, env, mol%lattice, mol%boundaryCondition, cutoff, &
      & excludeInversion)

end subroutine initLatticePointMolecule


!> Initializes lattice point generator
subroutine initLatticePoint(self, env, lattice, boundaryCond, cutoff, &
      & excludeInversion)

   !> Instance of the lattice point generator
   type(TLatticePoint), intent(out) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Boundary condition
   integer, intent(in) :: boundaryCond

   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)

   !> Real space cutoff for the generation of lattice points
   real(wp), intent(in) :: cutoff

   !> Exclude inversion symmetry in the lattice points
   logical, intent(in), optional :: excludeInversion

   self%boundaryCondition = boundaryCond
   self%lattice(:, :) = lattice
   self%cutoff = cutoff
   self%nTrans = 0

   if (present(excludeInversion)) then
      self%excludeInversion = excludeInversion
   else
      self%excludeInversion = .false.
   end if

   select case(boundaryCond)
   case(boundaryCondition%cluster)
      self%ranges(:, :) = 0

   case(boundaryCondition%pbc3d)
      call getRangesPBC3D(lattice, cutoff, self%ranges)

   end select

   call self%update(env, lattice)

end subroutine initLatticePoint


!> Update lattice point generator
subroutine update(self, env, lattice, updated)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_latticepoint_update'

   !> Instance of the lattice point generator
   class(TLatticePoint), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)

   !> New lattice points generated
   logical, intent(out), optional :: updated

   logical :: exitRun
   integer :: ranges(2, 3)

   self%lattice(:, :) = lattice

   select case(self%boundaryCondition)
   case(boundaryCondition%pbc3d)
      call getRangesPBC3D(lattice, self%cutoff, ranges)
      if (any(self%ranges /= ranges)) then
         self%ranges(:, :) = ranges
         self%nTrans = 0
      end if

   end select

   if (present(updated)) updated = self%nTrans == 0

   if (self%nTrans == 0) then
      call self%generate(env)
      call env%check(exitRun)
      if (exitRun) then
         call env%error("Could not generate lattice points", source)
         return
      end if
   end if

end subroutine update


!> Returns all lattice points within a given cutoff
subroutine getLatticePoints(self, latticePoint, cutoff)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_latticepoint_getLatticePoints'

   !> Instance of the lattice point generator
   class(TLatticePoint), intent(in) :: self

   !> Translation vectors for all lattice points
   real(wp), allocatable, intent(out) :: latticePoint(:, :)

   !> Cutoff for lattice points to be returned
   real(wp), intent(in), optional :: cutoff

   real(wp) :: cutoff2
   integer :: iTr, nTrans

   if (self%nTrans == 0) then
      return
   end if

   if (present(cutoff)) then
      cutoff2 = min(cutoff**2, self%cutoff**2)
   else
      cutoff2 = self%cutoff**2
   end if

   select case(self%boundaryCondition)
   case(boundaryCondition%cluster)
      allocate(latticePoint(3, 1))
      latticePoint(:, :) = 0.0_wp

   case(boundaryCondition%pbc3d)
      call bisectSearch(nTrans, self%dist2(1:self%nTrans), cutoff2, tolSameDist2)
      allocate(latticePoint(3, nTrans))
      do iTr = 1, nTrans
         latticePoint(:, iTr) = self%lattice(:, 1) * self%trans(1, iTr) &
               &              + self%lattice(:, 2) * self%trans(2, iTr) &
               &              + self%lattice(:, 3) * self%trans(3, iTr)
      end do

   end select

end subroutine getLatticePoints


!> Generate lattice points
subroutine generate(self, env)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_latticepoint_generate'

   !> Instance of the lattice point generator
   class(TLatticePoint), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   select case(self%boundaryCondition)
   case(boundaryCondition%cluster)
      self%nTrans = 1
      if (allocated(self%trans)) then
         if (size(self%trans, dim=2) < self%nTrans) then
            deallocate(self%trans)
            allocate(self%trans(3, self%nTrans))
         end if
      else
         allocate(self%trans(3, self%nTrans))
      end if
      self%trans(:, 1) = 0

   case(boundaryCondition%pbc3d)
      call generatePBC3D(self)

   case default
      call env%error("Boundary condition is not supported", source)
   end select

end subroutine generate


!> Generate lattice points under 3D infinite periodic boundary conditions
subroutine generatePBC3D(self)

   !> Instance of the lattice point generator
   class(TLatticePoint), intent(inout) :: self

   integer :: mTrans, nTrans
   integer :: iTr, iTr1, iTr2, iTr3
   real(wp) :: cutoff2, r2, point(3)
   integer, allocatable :: indx(:)
   integer, allocatable :: trans(:, :)

   mTrans = product(self%ranges(2, :) - self%ranges(1, :) + 1)
   if (allocated(self%trans)) then
      if (size(self%trans, dim=2) < mTrans) then
         deallocate(self%trans)
         allocate(self%trans(3, mTrans))
      end if
   else
      allocate(self%trans(3, mTrans))
   end if

   if (allocated(self%dist2)) then
      if (size(self%dist2) < mTrans) then
         deallocate(self%dist2)
         allocate(self%dist2(mTrans))
      end if
   else
      allocate(self%dist2(mTrans))
   end if

   cutoff2 = self%cutoff**2

   nTrans = 0
   do iTr1 = self%ranges(1, 1), self%ranges(2, 1)
      do iTr2 = self%ranges(1, 2), self%ranges(2, 2)
         do iTr3 = self%ranges(1, 3), self%ranges(2, 3)
            if (self%excludeInversion) then
               if (iTr1 < 0) cycle
               if (iTr2 < 0 .and. iTr1 == 0) cycle
               if (iTr3 < 0 .and. iTr2 == 0 .and. iTr1 == 0) cycle
            end if
            point(:) = self%lattice(:, 1) * iTr1 &
               &     + self%lattice(:, 2) * iTr2 &
               &     + self%lattice(:, 3) * iTr3
            r2 = sum(point**2)
            if (r2 <= cutoff2) then
               nTrans = nTrans + 1
               self%dist2(nTrans) = r2
               self%trans(:, nTrans) = [iTr1, iTr2, iTr3]
            end if
         end do
      end do
   end do

   allocate(indx(nTrans))
   call indexHeapSort(indx(:nTrans), self%dist2(:nTrans), tolSameDist2)
   self%dist2(:nTrans) = self%dist2(indx(:nTrans))

   self%nTrans = nTrans
   call move_alloc(self%trans, trans)
   allocate(self%trans(3, nTrans))
   do iTr = 1, nTrans
      self%trans(:, iTr) = trans(:, indx(iTr))
   end do

end subroutine generatePBC3D


!> Calculate the range of images of the central cell that interact
subroutine getRangesPBC3D(lattice, cutoff, ranges)

   !> Lattice vectors
   real(wp), intent(in) :: lattice(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Array of the two extremal points
   integer, intent(out) :: ranges(2, 3)

   integer :: tMax1, tMax2, tMax3
   real(wp) :: cos1, cos2, cos3
   real(wp) :: normal1(3), normal2(3), normal3(3)

   !> Get normals to lattice vectors
   normal1 = crossProd(lattice(:, 2), lattice(:, 3))
   normal2 = crossProd(lattice(:, 3), lattice(:, 1))
   normal3 = crossProd(lattice(:, 1), lattice(:, 2))

   !> Normalize to unit length
   normal1 = normal1 / norm2(normal1)
   normal2 = normal2 / norm2(normal2)
   normal3 = normal3 / norm2(normal3)

   !> Get angle between lattice vectors and normals
   cos1 = dot_product(normal1, lattice(:, 1))
   cos2 = dot_product(normal2, lattice(:, 2))
   cos3 = dot_product(normal3, lattice(:, 3))

   !> Determine maximal translations
   tMax1 = ceiling(abs(cutoff/cos1))
   tMax2 = ceiling(abs(cutoff/cos2))
   tMax3 = ceiling(abs(cutoff/cos3))

   !> Save maximal translations as ranges
   ranges(:, 1) = [-tMax1, tMax1]
   ranges(:, 2) = [-tMax2, tMax2]
   ranges(:, 3) = [-tMax3, tMax3]

end subroutine getRangesPBC3D


end module xtb_type_latticepoint

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Force field topology generator
module xtb_prog_topology
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : getFileType, fileType
   use xtb_mctc_systools, only : rdpath, getline
   use xtb_mctc_timings
   use xtb_mctc_version, only : version, author, date
   use xtb_io_reader, only : readMolecule, readHessian
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   use xtb_type_reader, only : TReader
   use xtb_prog_argparser, only : TArgParser
   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   use xtb_setparam, only : xenv, set
   use xtb_setmod, only : set_chrg
   implicit none
   private

   public :: xtbTopology


contains


!> Main program of the topology submodule
subroutine xtbTopology(env, argParser)

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "prog_topology"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Commandline argument parser
   type(TArgParser), intent(inout) :: argParser

   !> Molecular structure data
   type(TMolecule) :: mol

   !> Force field instance
   type(TGFFCalculator) :: calc

   type(TReader) :: reader
   character(len=:), allocatable :: file, param, line
   integer :: nFiles, ftype, unit, err
   logical :: exist

   call parseArguments(env, argParser, param)

   nFiles = argParser%countFiles()
   if (nFiles == 0) then
      call env%error("No input file given, so there is nothing to do", source)
      call topologyHelp(env%unit)
   end if
   if (nFiles > 1) then
      call env%error("Multiple input files present, aborting", source)
   end if

   call env%checkpoint("Command line argument parsing failed")

   call argParser%nextFile(file)

   !> Determine the file type for processing in the reader
   ftype = getFileType(file)

   !> Generate the reader by connecting the file to the instance
   call reader%open(file)
   !> Process the file to obtain the molecular structure data
   call readMolecule(env, mol, reader%unit, ftype)
   !> Close the file, we are done with it here
   call reader%close

   call open_file(unit, '.CHRG', 'r')
   if (unit /= -1) then
      call getline(unit, line, iostat=err)
      if (err /= 0) then
         call env%error('.CHRG is empty!', source)
      else
         call set_chrg(env, line)
         mol%chrg = set%ichrg
         call close_file(unit)
      end if
   end if

   call env%checkpoint("Could not read geometry from '"//file//"'")

   !> Print an informative banner
   call topologyHeader(env%unit)
   !> print current time
   call prdate('S')

   if (.not.allocated(param)) then
      call rdpath(env%xtbpath, '.param_gfnff.xtb', param, exist)
      if (.not.exist) param = '.param_gfnff.xtb'
   end if

   call newGFFCalculator(env, mol, calc, param, .false.)

   call env%checkpoint("Could not setup force field topology")

   write(env%unit,'(a)')
   write(env%unit,'(72("-"))')
   call stop_timing_run
   call stop_timing(1)
   call prdate('E')
   write(env%unit,'(72("-"))')
   call prtiming(1,'total')

   write(env%unit,'(a)')
   call terminate(0)

end subroutine xtbTopology


!> Parse command line arguments
subroutine parseArguments(env, args, param)
   use xtb_mctc_global, only : persistentEnv

   !> Name of error producer
   character(len=*), parameter :: source = "prog_topology_parseArguments"

   !> Calculation environment
   type(TEnvironment) :: env

   !> Command line argument parser
   type(TArgParser) :: args

   !> Parameter file
   character(len=:), allocatable, intent(out) :: param

   integer :: nFlags
   character(len=:), allocatable :: flag, sec
   logical :: exist

   nFlags = args%countFlags()
   call args%nextFlag(flag)
   do while(allocated(flag))
      if (len(flag) > 2 .and. flag(1:1) == '-' .and. flag(1:2) /= '--') then
         call env%warning("the use of '"//flag//"' is discouraged, "// &
            & "please use '-"//flag//"' next time", source)
         flag = '-'//flag
      end if
      select case(flag)
      case default
         call env%warning("Unknown option '"//flag//"' provided", source)

      case('--help', '-h')
         call topologyHelp(env%unit)
         call terminate(0)

      case('--param')
         call args%nextArg(param)
         if (.not.allocated(param)) then
            call env%error("Missing argument for parameter file", source)
         else
            inquire(exist=exist, file=param)
            if (.not.exist) then
               call env%error("Parameter file does not exist", source)
            end if
         end if

      case('--namespace')
         call args%nextArg(persistentEnv%io%namespace)
         if (.not.allocated(persistentEnv%io%namespace)) then
            call env%error("Namespace argument is missing", source)
         end if

      end select
      call args%nextFlag(flag)
   end do

end subroutine parseArguments


!> Header for this submodule
subroutine topologyHeader(unit)

   !> IO unit
   integer, intent(in) :: unit

   write(unit,'(a)') &
      "      -----------------------------------------------------------",&
      "     |                   =====================                   |",&
      "     |                      x t b - t o p o                      |",&
      "     |                   =====================                   |",&
      "     |                         S. Grimme                         |",&
      "     |          Mulliken Center for Theoretical Chemistry        |",&
      "     |                    University of Bonn                     |",&
      "      -----------------------------------------------------------",""
   write(unit,'(3x,"*",*(1x,a))') &
      & "xtb-topology version", version, "compiled by", author, "on", date
   write(unit,'(a)')

end subroutine topologyHeader


subroutine topologyHelp(unit)

   !> IO unit
   integer, intent(in) :: unit

   write(unit, '(a)') &
   "Usage: xtb topology [options] <geometry>", &
   "",&
   "<geometry> may be provided as any valid input to xtb", &
   "",&
   "Options",&
   "",&
   "   --namespace STRING   Set a namespace for the calculation",&
   "",&
   "   --param FILE         Use alternative parameter file for the generator",&
   "",&
   "More information can be obtained at https://xtb-docs.readthedocs.io/",&
   ""
end subroutine topologyHelp


end module xtb_prog_topology

! This file is part of ancopt.
! SPDX-Identifier: LGPL-3.0-or-later
!
! ancopt is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! ancopt is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with ancopt.  If not, see <https://www.gnu.org/licenses/>.

module xtb_pbc_optimizer_driver
   use xtb_mctc_accuracy, only : wp!, error_type, fatal_error
   use xtb_type_molecule, only : TMolecule
   use xtb_type_calculator
   use xtb_gfnff_calculator, only : TGFFCalculator
   use xtb_type_environment, only : TEnvironment
   use xtb_pbc_optimizer_filter_cart, only : cartesian_filter
   use xtb_type_restart, only : TRestart
   use xtb_type_data, only : scc_results
   use xtb_pbc_optimizer_lbfgs, only : optimizer_type, lbfgs_optimizer

   implicit none
   private

    public :: relax_pbc


 contains


!> Driver for performing geometry optimization
!subroutine    relax(self, ctx, mol, calc, filter, accuracy, verbosity)
subroutine relax_pbc(self, env, mol, chk, calc, filter, printlevel)
  use xtb_pbc, only: cross_product
  use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
  !> Instance of the optimization driver
  class(optimizer_type), intent(inout) :: self
  !> Calculation environment
  type(TEnvironment), intent(inout) :: env
  type(TEnvironment) :: env2
  !> Molecular structure data
  type(TMolecule), intent(inout) :: mol
  !> Wavefunction data
  type(TRestart), intent(inout) :: chk
  !> calculator type
  type(TGFFCalculator), allocatable :: gfnff
  class(TCalculator), intent(inout) :: calc
  !> Transformation filter for coordinates
  class(cartesian_filter), intent(in) :: filter
  !> Output verbosity
  integer, intent(in) :: printlevel
  ! Variables for/from singlepoint 
  !> Restart from previous results
  logical :: restart ! = .true.
  !> HOMO-LUMO gab
  real(wp) :: hlgap
  !> Detailed results
  type(scc_results) :: results
  !> optimization cycle failed
  logical :: fail
  !> singlepoint energy
  real(wp) :: energy
  !> gradient and stress tensor
  real(wp), allocatable :: gxyz(:, :), sigma(:, :)

  !> Convergence accuracy
  real(wp) :: accuracy
  integer :: nvar, step, this_step, i, stat
  real(wp) :: elast, ediff, gnorm, dnorm, ethr, gthr, dthr, gamax, damax, cvol
  real(wp), allocatable :: val, gcurr(:), glast(:), displ(:)
  logical :: econv, gconv, dconv, converged, f_exists
  !> Source of errors in the program unit
  character(len=*), parameter :: source = "relax_pbc"
  !> numerical gradient and stress tensor for debugging
  real(wp) :: numgrad(3,mol%n), numsig(3,3)
  logical, parameter :: debug = .false.

  real(wp) :: emin_global, xyz_emin(3,mol%n), latt_emin(3,3)
  character(6), parameter :: fname = "noName"
  
  nvar = filter%get_dimension()
  allocate(gcurr(nvar), glast(nvar), displ(nvar))
  allocate(gxyz(3, mol%n), sigma(3, 3), source=0.0_wp)
  val = huge(0.0_wp)
  emin_global = huge(0.0_wp)
  energy = 0.0_wp
  gcurr(:) = 0.0_wp
  glast(:) = 0.0_wp
  displ(:) = 0.0_wp

  accuracy = 1.0_wp
  call get_thr(accuracy, ethr, gthr, dthr)
  this_step = 20*nvar

  inquire( file="xtboptlog.cif", exist=f_exists )
  if(f_exists)then
    open(unit=133, iostat=stat, file="xtboptlog.cif", status='old')
    if (stat == 0) close(133, status='delete')
  endif
  open(133, file = "xtboptlog.cif", status = "new")

  ! start of optimization loop
  optLoop: do step = 1, this_step
    ! CYCLE header
    if (printlevel > 0) then
      write(env%unit,'(/,72("."),/,30(".")," CYCLE",i5,1x,30("."),/,72("."))')step
    end if

    ! 
    call filter%transform_structure(mol, displ) ! original

    dnorm = norm2(displ)
    damax = maxval(abs(gcurr))
    dconv = dnorm/nvar < dthr

    glast(:) = gcurr
    elast = val
    restart=.true.

    call calc%singlepoint(env, mol, chk, printlevel-1, restart, &
         & energy, gxyz, sigma, hlgap, results)

    call env%check(fail)
    if (fail) then
      call env%error('Single point calculation failed, aborting...', source)
      return
    endif

    ! calculate numerical gradient and stress tensor if requested
    if (debug) then
       numsig = 0.0_wp
       call num_sigma(env, mol, chk, calc, printlevel, sigma, numsig)
       numgrad = 0.0_wp
       call num_grad(env, mol, chk, calc, printlevel, gxyz, numgrad)
    endif


    ! calculate new gradients from gxyz and sigma from SP
    call filter%transform_derivative(mol, energy, gxyz, sigma, val, gcurr)

    ! set up values for convergence test
    ediff = val - elast
    econv = ediff <= epsilon(0.0_wp) .and. abs(ediff) < ethr
    gnorm = norm2(gcurr)
    gamax = maxval(abs(gcurr))
    gconv = gnorm/nvar < gthr
    converged = econv .and. gconv .and. dconv
    cvol=dot_product(mol%lattice(:,1), cross_product( &
                   & mol%lattice(:,2), mol%lattice(:,3)))/6.748334606_wp !in a0 now

    ! output key values of optimization step
    call step_summary(env, energy, ediff, gnorm, gamax, dnorm, damax, &
            cvol, mol%lattice, printlevel)

    ! save coordinates and lattice of  
    if (val.lt.emin_global) then
      emin_global = val
      xyz_emin  = mol%xyz
      latt_emin = mol%lattice
    endif
    ! write current structure to xtboptlog.cif
    call write_optlog(step, mol%n, mol%xyz, mol%lattice, mol%sym, val)

    ! check for convergence 
    if (converged) exit

    ! perform LBFGS step
    call self%step(val, gcurr, glast, displ, step)

  end do optLoop
  ! end of optimization loop

close(133) ! close xtboptlog.cif unit

! write structure of minimum energy to file
if (val.ne.emin_global) then
  inquire( file="xtbopt_emin.coord", exist=f_exists )
  if(f_exists)then
    open(unit=133, iostat=stat, file="xtbopt_emin.coord", status='old')
    if (stat == 0) then
      close(133, status='delete')
    else
      write(env%unit,*) 'A problem occured while handling xtbopt_emin.coord'
    endif
  endif
  open(133, file = "xtbopt_emin.coord", status = "new")
  write(133,'(a)') '$coord'
  do i=1, mol%n
    write(133,'(3f20.10,a,a)') xyz_emin(:,i),'    ',mol%sym(i)
  enddo
  write(133,'(a)') '$periodic 3'
  write(133,'(a)') '$lattice'
  write(133,'(3f25.10)') latt_emin
  write(133,'(a)') '$end'
  close(133)
endif

  ! Output message if not converged after maximum steps
  if (.not.converged) then
    write(*,*) ''
    write(*,*) 'Could not converge in',step,' steps.'
    call env%error("Could not converge geometry.",source)
  end if
  ! Output message if converged in time
  if (printlevel > 0 .and. converged) then
    write(*,*) ''
    write(env%unit,'(a,i6,a)') "Geometry optimization converged after"&
            &,step," steps."
  end if

end subroutine relax_pbc



subroutine step_summary(env, energy, ediff, gnorm, gamax, dnorm, damax, cvol, &
                & lattice, prlevel)
  !> Computational environment
  type(TEnvironment), intent(inout) :: env
  real(wp), intent(in) :: energy, ediff, gnorm, gamax, dnorm, damax, cvol
  real(wp), intent(in) :: lattice(3,3)
  integer, intent(in) :: prlevel

   if (prlevel <= 0) return

   if (prlevel > 1) then
     write(env%unit,'(a25,F25.15,a)')  " total energy   ",energy," Eh"
     write(env%unit,'(a25,E16.2,a)')    "   energy change",ediff," Eh"
     write(env%unit,*) ""
     write(env%unit,'(a25,F25.15,a)')  " gradient norm  ",gnorm," Eh/a0"
     write(env%unit,'(a25,F25.15,a)')    "   max. gradient",gamax," Eh/a0"
     write(env%unit,*) ""
     write(env%unit,'(a25,F25.15,a)')    " step length  ",dnorm," a0"
     write(env%unit,'(a25,F25.15,a)')  "   max. step    ",damax," a0"
     write(env%unit,*) ""
     write(env%unit,'(a25,F25.15,a)')    " unit cell volume  ",cvol," A^3"
     write(env%unit,*) ""
     write(env%unit,'(a25)')    " current lattice:  "
     write(env%unit,'(3F25.15)') lattice
   else
     write(env%unit,'(a25,F25.15,a)')  " total energy   ",energy," Eh"
   end if
end subroutine step_summary


subroutine get_thr(accuracy, ethr, gthr, dthr)
   real(wp), intent(in) :: accuracy
   real(wp), intent(out) :: ethr
   real(wp), intent(out) :: gthr
   real(wp), intent(out) :: dthr

   ethr = accuracy * 5.0e-7_wp
   gthr = accuracy * 1.0e-3_wp
   dthr = 5.0e-2_wp
end subroutine get_thr

!>
subroutine write_optlog(step, n, xyz, lattice, symbol, energy)
   integer, intent(in)  :: step
   integer, intent(in)  :: n
   real(wp), intent(in) :: xyz(3,n)
   real(wp), intent(in) :: lattice(3,3)
   character(*), intent(in) :: symbol(:)
   real(wp), intent(in) :: energy
   integer :: i
   real(wp) :: lat_len(3)
   real(wp) :: lat_ang(3)
   real(wp), parameter :: faua = 0.5291772109_wp

   call calculate_cell_parameters(lattice, lat_len, lat_ang)
   
   write(133,'(a,i0)') 'data_',step
   write(133,'(a,i6,a,f16.10)') '# Step:',step,'  Energy:',energy
   write(133,'(a)') "_symmetry_space_group_name_H-M   'P 1'"
   write(133,'(a,f12.4)') "_cell_length_a",lat_len(1)*faua
   write(133,'(a,f12.4)') "_cell_length_b",lat_len(2)*faua
   write(133,'(a,f12.4)') "_cell_length_c",lat_len(3)*faua
   write(133,'(a,f10.2)') "_cell_angle_alpha",lat_ang(1)
   write(133,'(a,f10.2)') "_cell_angle_beta",lat_ang(2)
   write(133,'(a,f10.2)') "_cell_angle_gamma",lat_ang(3)
   write(133,'(a)') "loop_"
   write(133,'(a)') "_atom_site_label"
   write(133,'(a)') "_atom_site_Cartn_x"
   write(133,'(a)') "_atom_site_Cartn_y"
   write(133,'(a)') "_atom_site_Cartn_z"
   do i=1, n
     write(133,'(A4,3f20.10)') symbol(i), xyz(1,i)*faua, xyz(2,i)*faua, xyz(3,i)*faua
   enddo
   write(133,*) ""
   
end subroutine write_optlog

!> Calculate the cell parameters for CIF format optimization trajectory
subroutine calculate_cell_parameters(lattice, lat_len, lat_ang)
  real(wp), intent(in) :: lattice(3,3)
  real(wp), intent(out) :: lat_len(3)
  real(wp), intent(out) :: lat_ang(3)

  ! Calculate lengths
  lat_len(1) = sqrt(lattice(1,1)**2 + lattice(2,1)**2 + lattice(3,1)**2) ! a
  lat_len(2) = sqrt(lattice(1,2)**2 + lattice(2,2)**2 + lattice(3,2)**2) ! b
  lat_len(3) = sqrt(lattice(1,3)**2 + lattice(2,3)**2 + lattice(3,3)**2) ! c

  ! Calculate angles (in degrees)
  lat_ang(1) = acosd(dot_product(lattice(:,2),lattice(:,3))/(lat_len(2)*lat_len(3))) ! angle "oposite" of a
  lat_ang(2) = acosd(dot_product(lattice(:,1),lattice(:,3))/(lat_len(1)*lat_len(3))) ! angle "oposite" of b
  lat_ang(3) = acosd(dot_product(lattice(:,1),lattice(:,2))/(lat_len(1)*lat_len(2))) ! angle "oposite" of c

end subroutine calculate_cell_parameters

! Function to convert radians to degrees degrees = rad*180/pi
pure function acosd(x) result(degrees)
  real(8), intent(in) :: x
  real(8) :: degrees
  degrees = acos(x) * 180.0_wp / acos(-1.0_wp)
end function acosd


!> numerical gradient for debugging purposes
subroutine num_grad(env, mol, chk, calc, printlevel, grad, numgrad)
  !> Calculation environment
  type(TEnvironment), intent(inout) :: env
  !> Molecular structure data
  type(TMolecule), intent(inout) :: mol
  !> Wavefunction data
  type(TRestart), intent(inout) :: chk
  !> calculator type
  class(TCalculator), intent(inout) :: calc
  !> Output verbosity
  integer, intent(in) :: printlevel
  !> gradient and sigma from previous SP calculation
  real(wp), intent(in) :: grad(3,mol%n)
  real(wp), intent(inout) :: numgrad(3,mol%n)
  ! Variables for/from singlepoint 
  !> Restart from previous results
  logical :: restart ! = .true.
  !> HOMO-LUMO gab
  real(wp) :: hlgap
  !> Detailed results
  type(scc_results) :: results
  !> singlepoint energy
  real(wp) :: energy
  !> gradient and stress tensor
  real(wp) :: sdum(3,3), gdum(3, mol%n), numg(3,mol%n)
  !> copy of original coordinates
  real(wp) :: coord(3,mol%n)
  !> copy of Wavefunction data
  type(TRestart) :: wf0
  !
  real(wp) :: nums(3,3), eps(3,3), er, el
  !
  integer :: i,j,k
  ! step size for numerical sigma
  real(wp),parameter    ::  step = 0.00001_wp, step2 = 0.5_wp/step ! for numerical gradient
  
  numgrad=0.0_wp
  gdum=0.0_wp
  sdum=0.0_wp
  coord = mol%xyz 
!  allocate( numg(3,mol%n),gdum(3,mol%n),sdum(3,3), source = 0.0_wp )
  wf0 = chk
  do i = 1, mol%n
     do j = 1, 3
        mol%xyz(j,i) = mol%xyz(j,i) + step
        chk = wf0
            call calc%singlepoint(env, mol, chk, printlevel-1, restart, &
               & er, gdum, sdum, hlgap, results)
!        call singlepoint &
!           &       (env,mol,chk,calc, &
!           &        egap,etemp,maxscciter,0,.true.,.true.,acc,er,gdum,sdum,res)
        mol%xyz(j,i) = mol%xyz(j,i) - 2*step
        chk = wf0
            call calc%singlepoint(env, mol, chk, printlevel-1, restart, &
               & el, gdum, sdum, hlgap, results)
!        call singlepoint &
!           &       (env,mol,chk,calc, &
!           &        egap,etemp,maxscciter,0,.true.,.true.,acc,el,gdum,sdum,res)
        mol%xyz(j,i) = mol%xyz(j,i) + step
        numg(j,i) = step2 * (er - el)
     enddo
  enddo
  print'(/,"analytical gradient")'
  print *, grad
  print'(/,"numerical gradient")'
  print *, numg
  print'(/,"difference gradient")'
  print*,grad-numg
  numgrad=numg

end subroutine num_grad

!> numerical stress tensor for debugging purposes
subroutine num_sigma(env, mol, chk, calc, printlevel, sigma, numsig)
  !> Calculation environment
  type(TEnvironment), intent(inout) :: env
  !> Molecular structure data
  type(TMolecule), intent(inout) :: mol
  !> Wavefunction data
  type(TRestart), intent(inout) :: chk
  !> calculator type
  class(TCalculator), intent(inout) :: calc
  !> Output verbosity
  integer, intent(in) :: printlevel
  !> gradient and sigma from previous SP calculation
  real(wp), intent(in) :: sigma(3,3)
  real(wp), intent(inout) :: numsig(3,3)
  ! Variables for/from singlepoint 
  !> Restart from previous results
  logical :: restart ! = .true.
  !> HOMO-LUMO gab
  real(wp) :: hlgap
  !> Detailed results
  type(scc_results) :: results
  !> singlepoint energy
  real(wp) :: energy
  !> gradient and stress tensor
  real(wp), allocatable :: gdum(:, :)
  ! dummies and copies
  real(wp) ::  sdum(3,3), latt(3,3)
  !> copy of original coordinates
  real(wp), allocatable :: coord(:,:)
  !> copy of Wavefunction data
  type(TRestart) :: wf0
  !
  real(wp) :: nums(3,3), eps(3,3), er, el
  !
  integer :: i,j,k
  ! step size for numerical sigma
  real(wp),parameter   :: sstep = 1.0_wp*10.0_wp**(-6), sstep2 = 0.5_wp/sstep
  

   ! ------------------------------------------------------------------------
   !> numerical sigma (=volume*stressTensor) for debugging purposes
      !  generate a warning to keep release versions from calculating numerical gradients
      print'(/,"analytical sigma")'
      print *, sigma
      sdum=0.0_wp
      if(.not.allocated(gdum)) allocate(gdum(3,mol%n), source = 0.0_wp )
      ! save original xyz and lattice
      allocate( coord(3,mol%n), source = mol%xyz )
      latt=mol%lattice
      wf0 = chk
      nums = 0.0_wp
      do j = 1, 3
        do i = 1, j
          ! Only eps_ij=step the rest equals zero: eps_(kl.ne.ij)=0
            eps=0.0_wp
            eps(i,j)=sstep
            ! adjust position vectors and lattice to get er
            do k=1,3
              mol%xyz(k,:)  =   kron(k,1)*mol%xyz(1,:) + eps(k,1)*mol%xyz(1,:) + &
                            &   kron(k,2)*mol%xyz(2,:) + eps(k,2)*mol%xyz(2,:) + &
                            &   kron(k,3)*mol%xyz(3,:) + eps(k,3)*mol%xyz(3,:) 
              mol%lattice(k,1) = (kron(k,1) + eps(k,1))*mol%lattice(1,1) + &
                               & (kron(k,2) + eps(k,2))*mol%lattice(2,1) + &
                               & (kron(k,3) + eps(k,3))*mol%lattice(3,1)
              mol%lattice(k,2) = (kron(k,1) + eps(k,1))*mol%lattice(1,2) + &
                               & (kron(k,2) + eps(k,2))*mol%lattice(2,2) + &
                               & (kron(k,3) + eps(k,3))*mol%lattice(3,2)
              mol%lattice(k,3) = (kron(k,1) + eps(k,1))*mol%lattice(1,3) + &
                               & (kron(k,2) + eps(k,2))*mol%lattice(2,3) + &
                               & (kron(k,3) + eps(k,3))*mol%lattice(3,3)
            enddo
            chk = wf0
            call calc%singlepoint(env, mol, chk, printlevel-1, restart, &
               & er, gdum, sdum, hlgap, results)

            ! reset coordinates and lattice
            mol%xyz=coord
            mol%lattice=latt
            ! adjust position vectors and lattice to get el
            do k=1,3
              mol%xyz(k,:)  =  kron(k,1)*mol%xyz(1,:) - eps(k,1)*mol%xyz(1,:) + &
                            &  kron(k,2)*mol%xyz(2,:) - eps(k,2)*mol%xyz(2,:) + &
                            &  kron(k,3)*mol%xyz(3,:) - eps(k,3)*mol%xyz(3,:) 
              mol%lattice(k,1) = (kron(k,1) - eps(k,1))*mol%lattice(1,1) + &
                               & (kron(k,2) - eps(k,2))*mol%lattice(2,1) + &
                               & (kron(k,3) - eps(k,3))*mol%lattice(3,1)
              mol%lattice(k,2) = (kron(k,1) - eps(k,1))*mol%lattice(1,2) + &
                               & (kron(k,2) - eps(k,2))*mol%lattice(2,2) + &
                               & (kron(k,3) - eps(k,3))*mol%lattice(3,2)
              mol%lattice(k,3) = (kron(k,1) - eps(k,1))*mol%lattice(1,3) + &
                               & (kron(k,2) - eps(k,2))*mol%lattice(2,3) + &
                               & (kron(k,3) - eps(k,3))*mol%lattice(3,3)
            enddo
            chk = wf0
            call calc%singlepoint(env, mol, chk, printlevel-1, restart, &
               & el, gdum, sdum, hlgap, results)

            ! numerical sigma (=volume*stressTensor)
            nums(i,j) = sstep2 * (er - el)  ! divide by 2 times step size
            nums(j,i) = nums(i,j)  ! stress tensor is symmetric
            ! reset coordinates and lattice
            mol%xyz=coord
            mol%lattice=latt
         enddo
      enddo

      print'(/,"numerical sigma")'
      print *, nums
      print'(/,"difference sigma")'
      print*,sigma-nums
      chk = wf0
      numsig=nums
end subroutine num_sigma


function kron(i,j) result(res_kronij)  ! kronecker delta
  integer, intent(in) :: i,j
  real(wp) :: res_kronij

  res_kronij = 0.0_wp
  if(i.eq.j) res_kronij=1.0_wp

end function


end module xtb_pbc_optimizer_driver

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_paramset
   use xtb_mctc_accuracy, only : wp
   use xtb_xtb_data
   use xtb_xtb_gfn0
   use xtb_xtb_gfn1
   use xtb_xtb_gfn2
   use xtb_type_param

contains

subroutine set_gfn1_parameter(xpar,globpar,xtbData)
   use xtb_disp_dftd3param
   implicit none
   type(scc_parameter),intent(inout) :: xpar
   type(TxTBParameter), intent(in) :: globpar
   type(TxTBData), intent(inout) :: xtbData
end subroutine set_gfn1_parameter


subroutine set_gfn2_parameter(xpar,globpar,xtbData)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_param
   use xtb_disp_dftd4
   implicit none
   type(scc_parameter),intent(inout) :: xpar
   type(TxTBParameter), intent(in) :: globpar
   type(TxTBData), intent(inout) :: xtbData
end subroutine set_gfn2_parameter

subroutine set_gfn0_parameter(xpar,globpar,xtbData)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_param
   !use gfn0_module
   use xtb_aoparam
   use xtb_disp_dftd4
   implicit none
   type(scc_parameter),intent(inout) :: xpar
   type(TxTBParameter), intent(in) :: globpar
   type(TxTBData), intent(inout) :: xtbData
end subroutine set_gfn0_parameter

subroutine use_parameterset(name,globpar,xtbData,exist)
   use xtb_aoparam, only : kpair
   implicit none
   character(len=*),intent(in) :: name
   logical,intent(out)  :: exist
   type(TxTBParameter), intent(out) :: globpar
   type(TxTBData), intent(out) :: xtbData
   exist = .false.
   select case(name)
   case('param_gfn0-xtb.txt')
      return
      globpar = gfn0Globals
      call initGFN0(xtbData)
   case('param_gfn1-xtb.txt')
      globpar = gfn1Globals
      call initGFN1(xtbData)
   case('param_gfn2-xtb.txt')
      globpar = gfn2Globals
      call initGFN2(xtbData)
   case default
      return
   end select
   exist = .true.
end subroutine use_parameterset

! global, predefined pair parameters
subroutine setpair(gfn_method, pairParam)
   real(wp), intent(inout) :: pairParam(:, :)
   integer gfn_method
   integer i,j,ii,jj
   real*8  kp(3)
   real*8  kparam
   integer tmgroup(3)
   logical notset

   if(gfn_method.eq.1)then
      kp(1)=1.1    ! 3d
      kp(2)=1.2    ! 4d
      kp(3)=1.2    ! 5d or 4f
   elseif(gfn_method.eq.0)then
      kp(1)=1.10
      kp(2)=1.10
      kp(3)=1.10
      kparam=0.9
      tmgroup=(/29,47,79/)
      do i=1,3
         do j=1,3
            ii=tmgroup(i)
            jj=tmgroup(j)
            pairParam(ii,jj)=kparam
            pairParam(jj,ii)=kparam
         enddo
      enddo
   elseif(gfn_method.gt.1)then
      kp(1)=1.   ! 3d
      kp(2)=1.   ! 4d
      kp(3)=1.   ! 5d or 4f
      !     write(*,'(''KAB for pair M(3d)-M(3d) :'',f8.4)')kp(1)
      !     write(*,'(''KAB for pair M(4d)-M(4d) :'',f8.4)')kp(2)
      !     write(*,'(''KAB for pair M(5d)-M(5d) :'',f8.4)')kp(3)
   endif

   do i=21,79
      do j=21,i
         ii=tmmetal(i)
         jj=tmmetal(j)
         !           metal-metal interaction
         notset=abs(pairParam(i,j)-1.0d0).lt.1.d-6 .and. &
            &             abs(pairParam(j,i)-1.0d0).lt.1.d-6
         if(ii.gt.0.and.jj.gt.0.and.notset) then
            pairParam(i,j)=0.5*(kp(ii)+kp(jj))
            pairParam(j,i)=0.5*(kp(ii)+kp(jj))
         endif
      enddo
   enddo

end subroutine setpair

integer function tmmetal(i)
   integer i,j

   j=0
   if(i.gt.20.and.i.lt.30) j=1
   if(i.gt.38.and.i.lt.48) j=2
   if(i.gt.56.and.i.lt.80) j=3

   tmmetal=j

end function tmmetal

end module xtb_paramset

! This file is part of xtb.
!
! Copyright (C) 2019-2021 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of Hessian projections
module xtb_freq_project
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : mctc_syrk, mctc_nrm2, mctc_symm
   use xtb_mctc_math, only : eigvec3x3, crossProd
   use xtb_type_molecule, only : TMolecule
   implicit none
   private

   public :: projectHessian, trproj


contains


!> Project translations and rotations from the Hessian matrix
subroutine projectHessian(hessian, mol, removeTrans, removeRot)

   !> Mass weighted Hessian matrix
   real(wp), intent(inout) :: hessian(:,:)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Translation should be projected
   logical, intent(in) :: removeTrans

   !> Rotations should be projected, will be automatically disabled for PBC input
   logical, intent(in) :: removeRot

   real(wp), allocatable :: nullvec(:, :), projector(:, :), scratch(:, :)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   real(wp) :: center(3), vec(3), r2, inertia(3,3), moments(3), molMass, axes(3,3)
   integer :: ndim, nproj, ii, jj, iat, ic

   ndim = 3*mol%n

   nproj = 0
   if (removeTrans) then
      nproj = nproj + 3
   end if
   if (removeRot .and. mol%npbc == 0) then
      nproj = nproj + 3
   end if

   if (nproj == 0) then
      return
   end if

   allocate(nullvec(ndim, nproj))
   allocate(projector(ndim, ndim))
   projector(:, :) = 0.0_wp
   nullvec(:, :) = 0.0_wp

   ! symmetrize
   do ii = 1, ndim
      do jj = 1, ii - 1
         hessian(jj, ii) = 0.5_wp*(hessian(jj, ii) + hessian(ii, jj))
         hessian(ii, jj) = hessian(jj, ii)
      end do
   end do

   do jj = 1, ndim
      projector(jj, jj) = 1.0_wp
   end do

   if (removeTrans) then
      do iat = 1, mol%n
         ic = (iat - 1) * 3
         do ii = 1, 3
            nullvec(ic+ii, ii) = 1.0_wp
         end do
      end do
   end if

   if (removeRot .and. mol%npbc == 0) then
      center(:) = 0.0_wp
      molMass = 0.0_wp
      do iat = 1, mol%n
         center(:) = center + mol%xyz(:, iat) * mol%atmass(iat)
         molMass = molMass + mol%atmass(iat)
      end do
      center(:) = center / molMass

      inertia(:, :) = 0.0_wp
      do iat = 1, mol%n
         vec(:) = mol%xyz(:, iat) - center
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         inertia(:, :) = inertia + mol%atmass(iat) &
            & * (unity*r2 - spread(vec, 1, 3)*spread(vec, 2, 3))
      end do

      call eigvec3x3(inertia, moments, axes)

      ! axis to project with respect to
      do ii = 1, 3
         if (moments(ii) < epsilon(0.0_wp)) cycle
         do iat = 1, mol%n
            ic = (iat - 1) * 3
            vec(:) = mol%xyz(:,iat) - center
            vec(:) = crossProd(axes(:, ii), vec)
            nullvec(ic+1:ic+3, nproj-ii+1) = vec
         end do
      end do
   end if

   ! mass weight the displacement vectors
   do iat = 1, mol%n
      ic = (iat - 1) * 3
      nullvec(ic+1:ic+3, :) = nullvec(ic+1:ic+3, :) * sqrt(mol%atmass(iat))
   end do

   ! renormalise
   do ii = 1, nproj
      if (sum(nullvec(:,ii)**2) > epsilon(1.0_wp)) then
         nullvec(:,ii) = nullvec(:,ii) / mctc_nrm2(nullvec(:, ii))
      end if
   end do

   call mctc_syrk(nullvec, projector, alpha=-1.0_wp, beta=1.0_wp)

   deallocate(nullvec)
   allocate(scratch(ndim, ndim))

   call mctc_symm(projector, hessian, scratch, side='r')
   call mctc_symm(projector, scratch, hessian, side='l')

end subroutine projectHessian

subroutine trproj(natoms,nat3,xyz,hess,ldebug,nmode,mode,ndim)

   !----------------------------------------------------------------------
   !  subroutine trproj drives projection of hessian out of the
   !  space of translational and rotational motions:
   !  first get xyz c.m.; second get transl. and rot. projection matrix
   !
   !  get center of mass coordinates with unit mass
   !
   ! Input
   !   natoms  = number of atoms
   !   nat3    = 3*natoms
   !   xyz     = cartesian coordinates
   !       ldebug  = debug flag = .true. for debugging
   !
   ! Ouput fo gtrprojm.f
   !   xyzucm  = temporary c.m. coordinates
   !
   !       hess        = projected hessian out of space of transl. and rot.
   !                 motion
   !
   !----------------------------------------------------------------------

   implicit none

   ! Input
   logical, intent(in) :: ldebug
   integer, intent(in) :: natoms,nat3,nmode,ndim
   real(wp), dimension(3,natoms) :: xyz
   real(wp), dimension(nat3,ndim):: mode
   ! Ouput
   real(wp), dimension(nat3*(nat3+1)/2) :: hess
   ! Local
   integer :: i
   real(wp) :: xm,ym,zm
   real(wp), dimension(3,natoms) ::xyzucm

   xyzucm(:,:) = xyz(:,:)

   xm = 0.0_wp
   ym = 0.0_wp
   zm = 0.0_wp

   do i=1,natoms
      xm = xm + xyzucm(1,i)
      ym = ym + xyzucm(2,i)
      zm = zm + xyzucm(3,i)
   end do

   xm = xm/natoms
   ym = ym/natoms
   zm = zm/natoms


   do i=1,natoms
      xyzucm(1,i) = xyzucm(1,i) - xm
      xyzucm(2,i) = xyzucm(2,i) - ym
      xyzucm(3,i) = xyzucm(3,i) - zm
   end do

   ! get translational and rotational projection matrix

   call gtrprojm(natoms,nat3,xyzucm,hess,ldebug,nmode,mode,ndim)

end subroutine trproj

!----------------------------------------------------------------------
subroutine gtrprojm(natoms,nat3,xyzucm,hess,ldebug,nmode,mode,ndim)
   !----------------------------------------------------------------------
   ! calculating the translational-rotational projection matrix
   !
   ! Input
   !   natoms  = number of atoms
   !   nat3    = 3*natoms
   !   xyzucm  = coords c.m. from gxyzucm.f
   !           hess    = hessian
   !       ldebug      = debug flag = .true. for debugging
   !
   ! Ouput
   !   fmat    = F-matrix with translational and rotational vectors
   !       pmat        = projection matrix P = (1-FFt)
   !   hess    = projected hessian
   !----------------------------------------------------------------------
   use xtb_fixparam
   use xtb_mctc_la, only : blckmgs,syprj

   implicit none

   ! Input
   logical, intent(in) :: ldebug
   integer, intent(in) :: natoms,nat3,nmode,ndim
   real(wp), dimension(3,natoms) :: xyzucm
   real(wp), dimension(nat3,ndim):: mode
   ! Ouput
   real(wp), dimension(nat3*(nat3+1)/2) :: hess

   ! Local
   integer :: i,ii,iii
   real(wp), allocatable :: fmat(:,:)
   integer :: nprj

   nprj=6
   if(nmode.gt.0) nprj=nprj+nmode
   if(nmode.lt.0) nprj=nprj+fixset%n*3
   allocate(fmat(nat3,nprj))
   fmat(:,:) = 0.0_wp

   if(nmode.ge.0) then
      do i=1,natoms
         do ii=1,3
            !        translation vectors
            fmat(3*(i-1)+ii,ii) = 1.0_wp
         end do
         !        rotational vectors
         fmat(3*(i-1)+1,4) =  0.0_wp
         fmat(3*(i-1)+2,4) = -xyzucm(3,i)
         fmat(3*(i-1)+3,4) =  xyzucm(2,i)
         fmat(3*(i-1)+1,5) =  xyzucm(3,i)
         fmat(3*(i-1)+2,5) =  0.0_wp
         fmat(3*(i-1)+3,5) = -xyzucm(1,i)
         fmat(3*(i-1)+1,6) = -xyzucm(2,i)
         fmat(3*(i-1)+2,6) =  xyzucm(1,i)
         fmat(3*(i-1)+3,6) =  0.0_wp
      end do
   endif

   if(nmode.gt.0) then  ! NMF
      do i=1,nmode
         fmat(1:nat3,6+i)=mode(1:nat3,i)
      enddo
   endif

   if(nmode.lt.0) then ! exact fixing
      do i=1,natoms
         !        rotational vectors
         fmat(3*(i-1)+1,1) =  0.0_wp
         fmat(3*(i-1)+2,1) = -xyzucm(3,i)
         fmat(3*(i-1)+3,1) =  xyzucm(2,i)
         fmat(3*(i-1)+1,2) =  xyzucm(3,i)
         fmat(3*(i-1)+2,2) =  0.0_wp
         fmat(3*(i-1)+3,2) = -xyzucm(1,i)
         fmat(3*(i-1)+1,3) = -xyzucm(2,i)
         fmat(3*(i-1)+2,3) =  xyzucm(1,i)
         fmat(3*(i-1)+3,3) =  0.0_wp
      enddo
      do i=1,fixset%n
         iii=fixset%atoms(i)
         do ii=1,3
            fmat(3*(iii-1)+ii,3+(i-1)*3+ii) = 1.0_wp
         end do
      enddo
   endif

   if(ldebug) then
      write(*,'(a)')
      write(*,'(a)') ' Basis vectors before orthonormalization'
      write(*,'(3e22.14)') fmat
   end if

   ! do orthogonalization

   call  blckmgs(nat3,nprj,nat3,fmat)

   ! do projection

   call syprj(nat3,nprj,fmat,nat3,hess)

   deallocate(fmat)

end subroutine gtrprojm

end module xtb_freq_project

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_readparam
   use xtb_xtb_data
   use xtb_xtb_gfn0
   use xtb_xtb_gfn1
   use xtb_xtb_gfn2
   use xtb_paramset
   use xtb_disp_dftd3param, only : copy_c6, reference_c6
   use xtb_disp_dftd4, only : newD4Model, p_refq_gfn2xtb, p_refq_goedecker

contains

subroutine readParam &
      (env, iunit,globpar,xtbData,initialize)
   use xtb_mctc_accuracy, only : wp

   use xtb_readin, only : getline => strip_line
   use xtb_type_environment, only : TEnvironment
   use xtb_type_param, only : TxTBParameter
   use xtb_param_paulingen, only : paulingEN
   use xtb_param_atomicrad, only : atomicRad
   use xtb_mctc_param, only: chemical_hardness

   implicit none

   logical, parameter :: debug = .false.

   type(TEnvironment), intent(inout) :: env
   integer, intent(in) :: iunit
   type(TxTBParameter), intent(inout) :: globpar
   type(TxTBData), intent(out) :: xtbData
   logical, intent(in) :: initialize

   character(len=1), parameter :: equal = '='
   character(len=1), parameter :: space = ' '
   character(len=1), parameter :: flag = '$'
   character(len=*), parameter :: flag_end = flag//'end'
   integer, parameter :: p_str_length = 48
   integer, parameter :: p_arg_length = 24

   integer, parameter :: max_elem = 118
   integer :: nShell(max_elem)
   integer :: principalQuantumNumber(10,max_elem)
   integer :: angShell(10,max_elem)
   real(wp) :: shellPoly(1:4,max_elem)
   real(wp) :: selfEnergy(10,max_elem)
   real(wp) :: slaterExponent(10,max_elem)
   real(wp) :: thirdOrderAtom(max_elem)
   real(wp) :: atomicHardness(max_elem)
   real(wp) :: shellHardness(1:4,max_elem)
   real(wp) :: electronegativity(max_elem)
   real(wp) :: repAlpha(max_elem)
   real(wp) :: repZeff(max_elem)
   real(wp) :: halogenBond(max_elem)
   real(wp) :: dipKernel(max_elem)
   real(wp) :: quadKernel(max_elem)
   real(wp) :: eeqkcn(max_elem)
   real(wp) :: chargeWidth(max_elem)
   real(wp) :: kqat2(max_elem)
   real(wp) :: kqat(0:2,max_elem)
   real(wp) :: kpair(max_elem,max_elem)
   real(wp) :: kcnat(0:2,max_elem)
   real(wp) :: eeqEN(max_elem)
   real(wp) :: kExpLight, kExp
   character(len=30) :: timestp(max_elem)
   type(dftd_parameter) :: disp

   character(len=:), allocatable :: line

   integer :: mShell, iSh, jSh
   integer :: level
   integer :: err
   logical :: newFormat

   disp = dftd_parameter(s6=1.0_wp, s8=0.0_wp, a1=0.0_wp, a2=0.0_wp, s9=0.0_wp)
   globpar = TxTBParameter()

   principalQuantumNumber=0
   angShell  =0
   nShell  =0
   selfEnergy=0.0_wp
   slaterExponent=0.0_wp
   shellPoly =0.0_wp
   halogenBond = 0.0_wp
   atomicHardness = chemical_hardness(:max_elem)
   shellHardness  =0.0_wp
   thirdOrderAtom  =0.0_wp
   kqat2 =0.0_wp
   eeqkcn=0.0_wp
   eeqen =0.0_wp
   kcnat =0.0_wp

   electronegativity = paulingEN(:max_elem)
   repAlpha = 0.0_wp
   repZeff = 0.0_wp

   dipKernel = 0.0_wp ! read values are scaled by 0.01
   quadKernel = 0.0_wp !  "     "     "    "    "   "

   kpair =1.0_wp

   kExpLight = 0.0_wp
   level = -1
   newFormat = .false.
   call getline(iunit,line,err)
   if (debug) print'(">",a)',line
   readgroups: do
      if (index(line,flag).eq.1) then
         select case(line(2:))
         case('info')
            newFormat = .true.
            call read_info
         case('globpar')
            call read_globpar
         case('pairpar')
            call read_pairpar
         case default
            if (index(line,'Z').eq.2) then
               call read_elempar
            else
               call getline(iunit,line,err)
               if (debug) print'(">",a)',line
            endif
         end select
      else
         call getline(iunit,line,err)
         if (debug) print'(">",a)',line
      endif
      if (err.ne.0) exit readgroups
      !if (index(line,flag_end).gt.0) exit readgroups
   enddo readgroups

   if (.not.newFormat) then
      call env%error("Old format parameter file is not supported anymore")
   end if

   call setpair(level, kpair)

   mShell = maxval(nShell)
   xtbData%level = level
   xtbData%nShell = nShell
   xtbData%ipeashift = globpar%ipeashift * 0.1_wp

   ! Repulsion
   call init(xtbData%repulsion, kExp, kExpLight, 1.0_wp, globpar%renscale, &
      & repAlpha, repZeff, electronegativity)

   ! Coulomb
   xtbData%coulomb%gExp = globpar%alphaj
   xtbData%coulomb%chemicalHardness = atomicHardness(:max_elem)
   allocate(xtbData%coulomb%shellHardness(mShell, max_elem))
   call setGFN1ShellHardness(xtbData%coulomb%shellHardness, nShell, angShell, &
      & atomicHardness, shellHardness)
   xtbData%coulomb%thirdOrderAtom = thirdOrderAtom(:max_elem)
   xtbData%coulomb%electronegativity = eeqEN(:max_elem)
   xtbData%coulomb%kCN = eeqkCN(:max_elem)
   xtbData%coulomb%chargeWidth = chargeWidth(:max_elem)

   ! Dispersion
   xtbData%dispersion%dpar = disp
   xtbData%dispersion%g_a = 3.0_wp
   xtbData%dispersion%g_c = 2.0_wp
   xtbData%dispersion%wf  = 6.0_wp

   ! Hamiltonian
   xtbData%hamiltonian%angShell = angShell(:mShell, :)

   do iSh = 0, 3
      do jSh = 0, 3
         xtbData%hamiltonian%kScale(jSh, iSh) = 0.5_wp * (globpar%kShell(iSh) &
            & + globpar%kShell(jSh))
      end do
   end do
   if (globpar%ksp > 0.0_wp) then
      xtbData%hamiltonian%kScale(0,1) = globpar%ksp
      xtbData%hamiltonian%kScale(1,0) = globpar%ksp
   end if
   if (globpar%ksd > 0.0_wp) then
      xtbData%hamiltonian%kScale(0,2) = globpar%ksd
      xtbData%hamiltonian%kScale(2,0) = globpar%ksd
   end if
   if (globpar%kpd > 0.0_wp) then
      xtbData%hamiltonian%kScale(1,2) = globpar%kpd
      xtbData%hamiltonian%kScale(2,1) = globpar%kpd
   end if
   xtbData%hamiltonian%kDiff = globpar%kDiff

   do iSh = 0, 3
      do jSh = 0, 3
         xtbData%hamiltonian%enScale(jSh, iSh) = 0.005_wp * (globpar%enShell(iSh) &
            & + globpar%enShell(jSh))
      end do
   end do
   xtbData%hamiltonian%enScale4 = globpar%enscale4

   xtbData%hamiltonian%electronegativity = electronegativity(:)
   xtbData%hamiltonian%atomicRad = atomicRad(:)
   xtbData%hamiltonian%shellPoly = shellPoly(:, :)
   xtbData%hamiltonian%pairParam = kpair(:, :)
   xtbData%hamiltonian%selfEnergy = selfEnergy(:mShell, :)
   xtbData%hamiltonian%slaterExponent = slaterExponent(:mShell, :)
   xtbData%hamiltonian%principalQuantumNumber = principalQuantumNumber(:mShell, :)

   allocate(xtbData%hamiltonian%valenceShell(mShell, max_elem))
   call generateValenceShellData(xtbData%hamiltonian%valenceShell, &
      & xtbData%nShell, xtbData%hamiltonian%angShell)

   select case(level)
   case(0)
      ! Hamiltonian
      xtbData%hamiltonian%wExp = 1.0_wp

      allocate(xtbData%hamiltonian%kCN(mShell, max_elem))
      call angToShellData(xtbData%hamiltonian%kCN, xtbData%nShell, &
         & xtbData%hamiltonian%angShell, kcnat)

      allocate(xtbData%hamiltonian%kQShell(mShell, max_elem))
      call angToShellData(xtbData%hamiltonian%kQShell, xtbData%nShell, &
         & xtbData%hamiltonian%angShell, kqat)
      xtbData%hamiltonian%kQAtom = kqat2(:)

      allocate(xtbData%hamiltonian%referenceOcc(mShell, max_elem))
      call setGFN2ReferenceOcc(xtbData%hamiltonian, xtbData%nShell)

      allocate(xtbData%hamiltonian%numberOfPrimitives(mShell, max_elem))
      call setGFN0NumberOfPrimitives(xtbData%hamiltonian, xtbData%nShell)

      allocate(xtbData%srb)
      xtbData%srb%shift = globpar%srbshift
      xtbData%srb%prefactor = globpar%srbpre
      xtbData%srb%steepness = globpar%srbexp
      xtbData%srb%enScale = globpar%srbken

      ! Dispersion
      call newD4Model(xtbData%dispersion%dispm, xtbData%dispersion%g_a, &
         & xtbData%dispersion%g_c, p_refq_goedecker)

   case(1)
      ! Halogen
      allocate(xtbData%halogen)
      call init(xtbData%halogen, globpar%xbrad, globpar%xbdamp, halogenBond)

      ! Hamiltonian
      xtbData%hamiltonian%wExp = 0.0_wp

      allocate(xtbData%hamiltonian%kCN(mShell, max_elem))
      call setGFN1kCN(xtbData%hamiltonian%kCN, xtbData%nShell, &
         & xtbData%hamiltonian%angShell, xtbData%hamiltonian%selfEnergy, &
         & globpar%cnshell)

      allocate(xtbData%hamiltonian%referenceOcc(mShell, max_elem))
      call setGFN1ReferenceOcc(xtbData%hamiltonian, xtbData%nShell)

      allocate(xtbData%hamiltonian%numberOfPrimitives(mShell, max_elem))
      call setGFN1NumberOfPrimitives(xtbData%hamiltonian, xtbData%nShell)

      ! Dispersion
      if (.not.allocated(reference_c6)) call copy_c6(reference_c6)

   case(2)
      ! Coulomb
      if (any(globpar%gam3shell > 0.0_wp)) then
         allocate(xtbData%Coulomb%thirdOrderShell(mShell, max_elem))
         call setGFN2ThirdOrderShell(xtbData%Coulomb%thirdOrderShell, &
            & xtbData%nShell, xtbData%hamiltonian%angShell, thirdOrderAtom, &
            & globpar%gam3shell)
      end if

      ! Multipole
      allocate(xtbData%multipole)
      call init(xtbData%multipole, globpar%aesshift, globpar%aesexp, &
         & globpar%aesrmax, globpar%aesdmp3, globpar%aesdmp5, &
         & dipKernel, quadKernel)

      ! Hamiltonian
      xtbData%hamiltonian%wExp = 0.5_wp

      allocate(xtbData%hamiltonian%kCN(mShell, max_elem))
      call angToShellData(xtbData%hamiltonian%kCN, xtbData%nShell, &
         & xtbData%hamiltonian%angShell, kcnat)

      allocate(xtbData%hamiltonian%referenceOcc(mShell, max_elem))
      call setGFN2ReferenceOcc(xtbData%hamiltonian, xtbData%nShell)

      allocate(xtbData%hamiltonian%numberOfPrimitives(mShell, max_elem))
      call setGFN2NumberOfPrimitives(xtbData%hamiltonian, xtbData%nShell)

      ! Dispersion
      call newD4Model(xtbData%dispersion%dispm, xtbData%dispersion%g_a, &
         & xtbData%dispersion%g_c, p_refq_gfn2xtb)

   end select

contains

subroutine read_info
   use xtb_readin, only : getValue
   character(len=:), allocatable :: key, val
   integer :: ie, idum
   do
      call getline(iunit,line,err)
      if (debug) print'("->",a)',line
      if (err.ne.0) exit
      if (index(line,flag).gt.0) exit

      ie = index(line,space)
      if (line.eq.'') cycle ! skip empty lines
      if (ie.eq.0) cycle

      key = trim(line(:ie-1))
      val = trim(adjustl(line(ie+1:)))

      select case(key)
      case default
         call env%warning("Unknown key '"//key//"' for '"//flag//"info'")
      case('level')
         if (getValue(env,val,idum)) level = idum
      case('name')
         xtbData%name = val
      case('doi')
         xtbData%doi = val
      end select
   enddo
end subroutine read_info

subroutine read_globpar
   implicit none
   character(len=:), allocatable :: key, val
   integer :: ie
   do
      call getline(iunit,line,err)
      if (debug) print'("->",a)',line
      if (err.ne.0) exit
      if (index(line,flag).gt.0) exit

      ie = index(line,space)
      if (line.eq.'') cycle ! skip empty lines
      if (ie.eq.0) cycle

      key = trim(line(:ie-1))
      val = trim(adjustl(line(ie+1:)))

      call gfn_globpar(key,val,globpar)

   enddo
end subroutine read_globpar

subroutine gfn_globpar(key,val,globpar)
   use xtb_readin, only : getValue
   implicit none
   character(len=*), intent(in) :: key, val
   type(TxTBParameter), intent(inout) :: globpar
   real(wp) :: ddum
   select case(key)
   case default
      call env%warning("Unknown key '"//key//"' for '"//flag//"globpar'")
   case('kexp'); if (getValue(env,val,ddum)) kExp = ddum
   case('kexplight'); if (getValue(env,val,ddum)) kExpLight = ddum
   case('ks'); if (getValue(env,val,ddum)) globpar%kshell(0) = ddum
   case('kp'); if (getValue(env,val,ddum)) globpar%kshell(1) = ddum
   case('kd'); if (getValue(env,val,ddum)) globpar%kshell(2) = ddum
   case('kf'); if (getValue(env,val,ddum)) globpar%kshell(3) = ddum
   case('ksp'); if (getValue(env,val,ddum)) globpar%ksp = ddum
   case('ksd'); if (getValue(env,val,ddum)) globpar%ksd = ddum
   case('kpd'); if (getValue(env,val,ddum)) globpar%kpd = ddum
   case('kdiff'); if (getValue(env,val,ddum)) globpar%kdiff = ddum
   case('kdiffa'); if (getValue(env,val,ddum)) globpar%kdiffa = ddum
   case('kdiffb'); if (getValue(env,val,ddum)) globpar%kdiffb = ddum
   case('ens'); if (getValue(env,val,ddum)) globpar%enshell(0) = ddum
   case('enp'); if (getValue(env,val,ddum)) globpar%enshell(1) = ddum
   case('end'); if (getValue(env,val,ddum)) globpar%enshell(2) = ddum
   case('enf'); if (getValue(env,val,ddum)) globpar%enshell(3) = ddum
   case('enscale'); if (getValue(env,val,ddum)) globpar%enshell = ddum
   case('enscale4'); if (getValue(env,val,ddum)) globpar%enscale4 = ddum
   case('renscale'); if (getValue(env,val,ddum)) globpar%renscale = ddum
   case('cns'); if (getValue(env,val,ddum)) globpar%cnshell(:, 0) = ddum
   case('cnp'); if (getValue(env,val,ddum)) globpar%cnshell(:, 1) = ddum
   case('cnd'); if (getValue(env,val,ddum)) globpar%cnshell(:, 2) = ddum
   case('cnf'); if (getValue(env,val,ddum)) globpar%cnshell(:, 3) = ddum
   case('cnd1'); if (getValue(env,val,ddum)) globpar%cnshell(1, 2) = ddum
   case('cnd2'); if (getValue(env,val,ddum)) globpar%cnshell(2, 2) = ddum
   case('gam3s'); if (getValue(env,val,ddum)) globpar%gam3shell(:, 0) = ddum
   case('gam3p'); if (getValue(env,val,ddum)) globpar%gam3shell(:, 1) = ddum
   case('gam3d'); if (getValue(env,val,ddum)) globpar%gam3shell(:, 2) = ddum
   case('gam3f'); if (getValue(env,val,ddum)) globpar%gam3shell(:, 3) = ddum
   case('gam3d1'); if (getValue(env,val,ddum)) globpar%gam3shell(1, 2) = ddum
   case('gam3d2'); if (getValue(env,val,ddum)) globpar%gam3shell(2, 2) = ddum
   case('srbshift'); if (getValue(env,val,ddum)) globpar%srbshift = ddum
   case('srbpre'); if (getValue(env,val,ddum)) globpar%srbpre = ddum
   case('srbexp'); if (getValue(env,val,ddum)) globpar%srbexp = ddum
   case('srbken'); if (getValue(env,val,ddum)) globpar%srbken = ddum
   case('wllscal'); if (getValue(env,val,ddum)) globpar%wllscal = ddum
   case('ipeashift'); if (getValue(env,val,ddum)) globpar%ipeashift = ddum
   case('gscal'); if (getValue(env,val,ddum)) globpar%gscal = ddum
   case('zcnf'); if (getValue(env,val,ddum)) globpar%zcnf = ddum
   case('tscal'); if (getValue(env,val,ddum)) globpar%tscal = ddum
   case('kcn'); if (getValue(env,val,ddum)) globpar%kcn = ddum
   case('fpol'); if (getValue(env,val,ddum)) globpar%fpol = ddum
   case('ken'); if (getValue(env,val,ddum)) globpar%ken = ddum
   case('lshift'); if (getValue(env,val,ddum)) globpar%lshift = ddum
   case('lshifta'); if (getValue(env,val,ddum)) globpar%lshifta = ddum
   case('split'); if (getValue(env,val,ddum)) globpar%split = ddum
   case('zqf'); if (getValue(env,val,ddum)) globpar%zqf = ddum
   case('alphaj'); if (getValue(env,val,ddum)) globpar%alphaj = ddum
   case('kexpo'); if (getValue(env,val,ddum)) globpar%kexpo = ddum
   case('dispa'); if (getValue(env,val,ddum)) globpar%dispa = ddum
   case('dispb'); if (getValue(env,val,ddum)) globpar%dispb = ddum
   case('dispc'); if (getValue(env,val,ddum)) globpar%dispc = ddum
   case('dispatm'); if (getValue(env,val,ddum)) globpar%dispatm = ddum
   case('a1'); if (getValue(env,val,ddum)) disp%a1 = ddum
   case('a2'); if (getValue(env,val,ddum)) disp%a2 = ddum
   case('s6'); if (getValue(env,val,ddum)) disp%s6 = ddum
   case('s8'); if (getValue(env,val,ddum)) disp%s8 = ddum
   case('s9'); if (getValue(env,val,ddum)) disp%s9 = ddum
   case('xbdamp'); if (getValue(env,val,ddum)) globpar%xbdamp = ddum
   case('xbrad'); if (getValue(env,val,ddum)) globpar%xbrad = ddum
   case('aesdmp3'); if (getValue(env,val,ddum)) globpar%aesdmp3 = ddum
   case('aesdmp5'); if (getValue(env,val,ddum)) globpar%aesdmp5 = ddum
   case('aesshift'); if (getValue(env,val,ddum)) globpar%aesshift = ddum
   case('aesexp'); if (getValue(env,val,ddum)) globpar%aesexp = ddum
   case('aesrmax'); if (getValue(env,val,ddum)) globpar%aesrmax = ddum
   end select
end subroutine gfn_globpar

subroutine read_pairpar
   use xtb_mctc_strings
   use xtb_readin, only : getValue
   implicit none
   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv
   integer  :: iAt,jAt
   real(wp) :: ddum
   do
      call getline(iunit,line,err)
      if (debug) print'("->",a)',line
      if (err.ne.0) exit
      if (index(line,flag).gt.0) exit

      call parse(line,space,argv,narg)
      if (narg .ne. 3) cycle
      if (getValue(env,trim(argv(1)),iAt) .and. &
         &getValue(env,trim(argv(2)),jAt) .and. &
         &getValue(env,trim(argv(3)),ddum)) then
            kpair(iAt,jAt) = ddum
            kpair(jAt,iAt) = ddum
      endif
   enddo
end subroutine read_pairpar

subroutine read_elempar
   use xtb_mctc_strings
   use xtb_readin
   implicit none
   character(len=:), allocatable :: key, val
   integer :: iz, ie
   if (getValue(env,line(4:5),iz)) then
      timestp(iz) = line(7:len_trim(line))
      do
         call getline(iunit,line,err)
         if (debug) print'("->",a)',line
         if (err.ne.0) exit
         if (index(line,flag).gt.0) exit

         ie = index(line,equal)
         if (line.eq.'') cycle ! skip empty lines
         if (ie.eq.0) cycle

         key = lowercase(trim(line(:ie-1)))
         val = trim(adjustl(line(ie+1:)))

         call gfn_elempar(key,val,iz)

      enddo
   else
      call getline(iunit,line,err)
   endif
end subroutine read_elempar

subroutine gfn_elempar(key,val,iz)
   use xtb_mctc_strings
   use xtb_readin
   implicit none
   character(len=*), intent(in) :: key, val
   integer, intent(in) :: iz
   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv
   integer :: i, ii
   integer :: idum
   real(wp) :: ddum
   select case(key)
   case default
      call env%warning("Unknown key '"//key//"' for '"//flag//"Z'")
   case('ao')
      !print'(a,":",a)',key,val
      if (mod(len(val),2).eq.0) then
         nShell(iz) = len(val)/2
         do i = 1, nShell(iz)
            ii = 2*i-1
            !print*,i,ii,val(ii:ii),val(ii+1:ii+1)
            if (getValue(env,val(ii:ii),idum)) then
               principalQuantumNumber(i,iz) = idum
               select case(val(ii+1:ii+1))
               case('s'); angShell(i,iz) = 0
               case('p'); angShell(i,iz) = 1
               case('d'); angShell(i,iz) = 2
               case('f'); angShell(i,iz) = 3
               case('g'); angShell(i,iz) = 4
               case('S'); angShell(i,iz) = 0
               end select
            endif
         enddo
      endif
   case('lev')
      call parse(val,space,argv,narg)
      if (narg .eq. nShell(iz)) then
         do i = 1, nShell(iz)
            if (getValue(env,trim(argv(i)),ddum)) selfEnergy(i,iz) = ddum
         enddo
      endif
   case('exp')
      call parse(val,space,argv,narg)
      if (narg .eq. nShell(iz)) then
         do i = 1, nShell(iz)
            if (getValue(env,trim(argv(i)),ddum)) slaterExponent(i,iz) = ddum
         enddo
      endif
   case('en');  if (getValue(env,val,ddum)) electronegativity(iz)    = ddum
   case('gam'); if (getValue(env,val,ddum)) atomicHardness(iz)   = ddum
   case('xi');  if (getValue(env,val,ddum)) eeqEN(iz) = ddum
   case('alpg'); if (getValue(env,val,ddum)) chargeWidth(iz)   = ddum
   case('gam3');  if (getValue(env,val,ddum)) thirdOrderAtom(iz)    = ddum * 0.1_wp
   case('kappa'); if (getValue(env,val,ddum)) eeqkCN(iz)  = ddum
   case('cxb');   if (getValue(env,val,ddum)) halogenBond(iz) = ddum * 0.1_wp
   case('kqat2'); if (getValue(env,val,ddum)) kqat2(iz)   = ddum
   case('dpol');  if (getValue(env,val,ddum)) dipKernel(iz)   = ddum * 0.01_wp
   case('qpol');  if (getValue(env,val,ddum)) quadKernel(iz)   = ddum * 0.01_wp
   case('repa');  if (getValue(env,val,ddum)) repAlpha(iz)   = ddum
   case('repb');  if (getValue(env,val,ddum)) repZeff(iz)   = ddum
   case('polys'); if (getValue(env,val,ddum)) shellPoly(1,iz) = ddum
   case('polyp'); if (getValue(env,val,ddum)) shellPoly(2,iz) = ddum
   case('polyd'); if (getValue(env,val,ddum)) shellPoly(3,iz) = ddum
   case('polyf'); if (getValue(env,val,ddum)) shellPoly(4,iz) = ddum
   case('lpars'); if (getValue(env,val,ddum)) shellHardness(1,iz)  = ddum * 0.1_wp
   case('lparp'); if (getValue(env,val,ddum)) shellHardness(2,iz)  = ddum * 0.1_wp
   case('lpard'); if (getValue(env,val,ddum)) shellHardness(3,iz)  = ddum * 0.1_wp
   case('lparf'); if (getValue(env,val,ddum)) shellHardness(4,iz)  = ddum * 0.1_wp
   case('kcns');  if (getValue(env,val,ddum)) kcnat(0,iz) = ddum * 0.1_wp
   case('kcnp');  if (getValue(env,val,ddum)) kcnat(1,iz) = ddum * 0.1_wp
   case('kcnd');  if (getValue(env,val,ddum)) kcnat(2,iz) = ddum * 0.1_wp
   case('kqs');   if (getValue(env,val,ddum)) kqat(0,iz)  = ddum
   case('kqp');   if (getValue(env,val,ddum)) kqat(1,iz)  = ddum
   case('kqd');   if (getValue(env,val,ddum)) kqat(2,iz)  = ddum
   end select
end subroutine gfn_elempar

end subroutine readParam

end module xtb_readparam


      logical function maingroup(i)
      integer i
      logical main_group(107)
      data main_group /&
     &  2*.true.,&                              ! H  - He
     &  8*.true.,&                              ! Li - Ne
     &  8*.true.,&                              ! Na - Ar
     &  2*.true., 9*.false., 7*.true.,&         ! K  - Kr
     &  2*.true., 9*.false., 7*.true.,&         ! Rb - Xe
     &  2*.true.,23*.false., 7*.true.,&         ! Cs - Rn
     & 21*.true.                               / ! Fr - Tv

      maingroup = main_group(i)

      end function maingroup

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_strings
!use iso_fortran_env, only : kr4 => real32, kr8 => real64, &
!&                           ki4 => int32,  ki8 => int64
implicit none

! Real kinds
!> @brief single precision real
integer, parameter :: kr4 = selected_real_kind(6,37)
!> @brief double precision real
integer, parameter :: kr8 = selected_real_kind(15,307)

! Integer kinds
!> @brief single precision integer
integer, parameter :: ki4 = selected_int_kind(9)
!> @brief double precision integer
integer, parameter :: ki8 = selected_int_kind(18)

! Complex kinds
!> @brief single precision complex
integer, parameter :: kc4 = kr4
!> @brief double precision complex
integer, parameter :: kc8 = kr8

private :: kr4,kr8,ki4,ki8,kc4,kc8

private :: value_dr,value_sr,value_di,value_si
private :: write_dr,write_sr,write_di,write_si
private :: writeq_dr,writeq_sr,writeq_di,writeq_si

!> @brief Generic operator for converting a number string to a
!! number. Calling syntax is 'call value(numstring,number,ios)'
!! where 'numstring' is a number string and 'number' is a
!! real number or an integer (single or double precision).
interface value
   module procedure value_dr
   module procedure value_sr
   module procedure value_di
   module procedure value_si
end interface

!> @brief Generic  interface for writing a number to a string. The
!! number is left justified in the string. The calling syntax
!! is 'call writenum(number,string,format)' where 'number' is
!! a real number or an integer, 'string' is a character string
!! containing the result, and 'format' is the format desired,
!! e.g., 'e15.6' or 'i5'.
interface writenum
   module procedure write_dr
   module procedure write_sr
   module procedure write_di
   module procedure write_si
end interface

!> @brief Generic interface equating a name to a numerical value. The
!! calling syntax is 'call writeq(unit,name,value,format)' where
!! unit is the integer output unit number, 'name' is the variable
!! name, 'value' is the real or integer value of the variable,
!! and 'format' is the format of the value. The result written to
!! the output unit has the form <name> = <value>.
interface writeq
   module procedure writeq_dr
   module procedure writeq_sr
   module procedure writeq_di
   module procedure writeq_si
end interface


!**********************************************************************

contains

!**********************************************************************

pure function capitalize (str)
integer :: il,i
character(len=*),intent(in) :: str
character(len=len(str))     :: capitalize
character(len=26),parameter :: cap = &
&       'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
character(len=26),parameter :: low = &
&       'abcdefghijklmnopqrstuvwxyz'
capitalize = str
il = INDEX(low, str(1:1))
if (il.gt.0) capitalize(1:1) = cap(il:il)
do i = 2, len_trim(str)
   il = INDEX(cap, str(i:i))
   if (il.gt.0) capitalize(i:i) = low(il:il)
enddo
end function capitalize

!**********************************************************************

!> @brief Parses the string 'str' into arguments args(1), ..., args(nargs) based on
!! the delimiters contained in the string 'delims'. Preceding a delimiter in
!! 'str' by a backslash (\) makes this particular instance not a delimiter.
!! The integer output variable nargs contains the number of arguments found.
pure subroutine parse(str,delims,args,nargs)

character(len=*), intent(in) :: str
character(len=*), intent(in) :: delims
character(len=len_trim(str)) :: tmpstr
character(len=*), dimension(:), intent(out) :: args

integer, intent(out) :: nargs
integer :: na,i,lenstr,k

tmpstr=str
call compact(tmpstr)
na=size(args)
do i=1,na
  args(i)=' '
end do
nargs=0
lenstr=len_trim(tmpstr)
if(lenstr==0) return
k=0

do
   if(len_trim(tmpstr) == 0) exit
   nargs=nargs+1
   if (nargs > size(args)) exit
   call split(tmpstr,delims,args(nargs))
   call removebksl(args(nargs))
end do

end subroutine parse

!**********************************************************************

!> @brief Converts multiple spaces and tabs to single spaces; deletes control characters;
!! removes initial spaces.
pure subroutine compact(str)


character(len=*), intent(inout) :: str
character(len=1) :: ch
character(len=len_trim(str)) :: outstr

integer :: lenstr,isp,k,i,ich

str=adjustl(str)
lenstr=len_trim(str)
outstr=' '
isp=0
k=0

do i=1,lenstr
  ch=str(i:i)
  ich=iachar(ch)

  select case(ich)

    case(9,32)     ! space or tab character
      if(isp==0) then
        k=k+1
        outstr(k:k)=' '
      end if
      isp=1

    case(33:)      ! not a space, quote, or control character
      k=k+1
      outstr(k:k)=ch
      isp=0

  end select

end do

str=adjustl(outstr)

end subroutine compact

!**********************************************************************

!> @brief Removes spaces, tabs, and control characters in string str
pure subroutine removesp(str)

character(len=*), intent(inout) :: str
character(len=1) :: ch
character(len=len_trim(str)) :: outstr

integer :: lenstr,k,i,ich

str=adjustl(str)
lenstr=len_trim(str)
outstr=' '
k=0

do i=1,lenstr
  ch=str(i:i)
  ich=iachar(ch)
  select case(ich)
    case(0:32)  ! space, tab, or control character
         cycle
    case(33:)
      k=k+1
      outstr(k:k)=ch
  end select
end do

str=adjustl(outstr)

end subroutine removesp

!**********************************************************************

!> @brief Converts number string to a double precision real number
pure subroutine value_dr(str,rnum,iostat)

character(len=*), intent(in) ::str
real(kr8), intent(out) ::rnum
integer, intent(out), optional :: iostat

integer :: ilen,ipos,ios

ilen=len_trim(str)
ipos=scan(str,'Ee')
if(.not.is_digit(str(ilen:ilen)) .and. ipos/=0) then
   if (present(iostat)) iostat=3
   return
end if
read(str,*,iostat=ios) rnum
if (present(iostat)) iostat = ios

end subroutine value_dr

!**********************************************************************

!> @brief Converts number string to a single precision real number
pure subroutine value_sr(str,rnum,iostat)

character(len=*), intent(in) ::str
real(kr4), intent(out) :: rnum
real(kr8) :: rnumd

integer, intent(out), optional :: iostat
integer :: ios

call value_dr(str,rnumd,ios)
if (present(iostat)) iostat = ios
if( abs(rnumd) > huge(rnum) ) then
   if (present(iostat)) iostat = 15
   return
end if
if( abs(rnumd) < tiny(rnum) ) rnum=0.0_kr4
rnum=rnumd

end subroutine value_sr

!**********************************************************************

!> @brief Converts number string to a double precision integer value
pure subroutine value_di(str,inum,iostat)


character(len=*), intent(in) ::str
integer(ki8), intent(out) :: inum
real(kr8) :: rnum

integer, intent(out), optional :: iostat
integer :: ios

call value_dr(str,rnum,ios)
if (present(iostat)) iostat = ios
if(abs(rnum)>huge(inum)) then
   if (present(iostat)) iostat = 15
   return
end if
inum=nint(rnum,ki8)

end subroutine value_di

!**********************************************************************

!> @brief Converts number string to a single precision integer value
pure subroutine value_si(str,inum,iostat)

character(len=*), intent(in) ::str
integer(ki4), intent(out) :: inum
real(kr8) :: rnum

integer, intent(out), optional :: iostat
integer :: ios

call value_dr(str,rnum,ios)
if (present(iostat)) iostat = ios
if(abs(rnum)>huge(inum)) then
   if (present(iostat)) iostat=15
   return
end if
inum=nint(rnum,ki4)

end subroutine value_si

!**********************************************************************

!> @brief Shifts characters in in the string 'str' n positions (positive values
!! denote a right shift and negative values denote a left shift). Characters
!! that are shifted off the end are lost. Positions opened up by the shift
!! are replaced by spaces.
pure subroutine shiftstr(str,n)

character(len=*), intent(inout) :: str
integer, intent(in) :: n

integer :: lenstr,nabs

lenstr=len(str)
nabs=iabs(n)
if(nabs>=lenstr) then
  str=repeat(' ',lenstr)
  return
end if
if(n<0) str=str(nabs+1:)//repeat(' ',nabs)  ! shift left
if(n>0) str=repeat(' ',nabs)//str(:lenstr-nabs)  ! shift right
return

end subroutine shiftstr

!**********************************************************************

!> @brief Inserts the string 'strins' into the string 'str' at position 'loc'.
!! Characters in 'str' starting at position 'loc' are shifted right to
!! make room for the inserted string. Trailing spaces of 'strins' are
!! removed prior to insertion
pure subroutine insertstr(str,strins,loc)


character(len=*), intent(inout) :: str
character(len=*), intent(in) :: strins
character(len=len(str)) :: tempstr

integer, intent(in) :: loc
integer :: lenstrins

lenstrins=len_trim(strins)
tempstr=str(loc:)
call shiftstr(tempstr,lenstrins)
tempstr(1:lenstrins)=strins(1:lenstrins)
str(loc:)=tempstr
return

end subroutine insertstr

!**********************************************************************

!> @brief Deletes first occurrence of substring 'substr' from string 'str' and
!! shifts characters left to fill hole. Trailing spaces or blanks are
!! not considered part of 'substr'.
pure subroutine delsubstr(str,substr)

character(len=*), intent(inout) :: str
character(len=*), intent(in) :: substr

integer :: lensubstr,ipos

lensubstr=len_trim(substr)
ipos=index(str,substr)
if(ipos==0) return
if(ipos == 1) then
   str=str(lensubstr+1:)
else
   str=str(:ipos-1)//str(ipos+lensubstr:)
end if
return

end subroutine delsubstr

!**********************************************************************

!> @brief Deletes all occurrences of substring 'substr' from string 'str' and
!! shifts characters left to fill holes.
pure subroutine delall(str,substr)


character(len=*), intent(inout) :: str
character(len=*), intent(in) :: substr

integer :: lensubstr
integer :: ipos

lensubstr=len_trim(substr)
do
   ipos=index(str,substr)
   if(ipos == 0) exit
   if(ipos == 1) then
      str=str(lensubstr+1:)
   else
      str=str(:ipos-1)//str(ipos+lensubstr:)
   end if
end do
return

end subroutine delall

!**********************************************************************

!> @brief convert string to upper case
function uppercase(str) result(ucstr)


character (len=*):: str
character (len=len_trim(str)):: ucstr

integer :: ilen,ioffset,iquote,i,iav,iqc

ilen=len_trim(str)
ioffset=iachar('A')-iachar('a')
iquote=0
ucstr=str
do i=1,ilen
  iav=iachar(str(i:i))
  if(iquote==0 .and. (iav==34 .or.iav==39)) then
    iquote=1
    iqc=iav
    cycle
  end if
  if(iquote==1 .and. iav==iqc) then
    iquote=0
    cycle
  end if
  if (iquote==1) cycle
  if(iav >= iachar('a') .and. iav <= iachar('z')) then
    ucstr(i:i)=achar(iav+ioffset)
  else
    ucstr(i:i)=str(i:i)
  end if
end do
return

end function uppercase

!**********************************************************************

!> @brief convert string to lower case
function lowercase(str) result(lcstr)

character (len=*):: str
character (len=len_trim(str)):: lcstr

integer :: ilen,ioffset,iquote,i,iav,iqc

ilen=len_trim(str)
ioffset=iachar('A')-iachar('a')
iquote=0
lcstr=str
do i=1,ilen
  iav=iachar(str(i:i))
  if(iquote==0 .and. (iav==34 .or.iav==39)) then
    iquote=1
    iqc=iav
    cycle
  end if
  if(iquote==1 .and. iav==iqc) then
    iquote=0
    cycle
  end if
  if (iquote==1) cycle
  if(iav >= iachar('A') .and. iav <= iachar('Z')) then
    lcstr(i:i)=achar(iav-ioffset)
  else
    lcstr(i:i)=str(i:i)
  end if
end do
return

end function lowercase

!**********************************************************************

!> @brief Reads line from unit=nunitr, ignoring blank lines
!! and deleting comments beginning with an exclamation point(!)
subroutine readline(nunitr,line,ios)

character (len=*):: line

integer :: nunitr,ios,ipos

do
  read(nunitr,'(a)', iostat=ios) line      ! read input line
  if(ios /= 0) return
  line=adjustl(line)
  ipos=index(line,'!')
  if(ipos == 1) cycle
  if(ipos /= 0) line=line(:ipos-1)
  if(len_trim(line) /= 0) exit
end do
return

end subroutine readline

!**********************************************************************

!> @brief Sets imatch to the position in string of the delimiter matching the delimiter
!! in position ipos. Allowable delimiters are (), [], {}, <>.
pure subroutine match(str,ipos,imatch,status)

character(len=*), intent(in) :: str
character :: delim1,delim2,ch

integer, intent(out), optional :: status
integer :: stat

integer, intent(in) :: ipos
integer, intent(out) :: imatch
integer :: lenstr,idelim2,istart,inc,iend,isum,i

lenstr=len_trim(str)
delim1=str(ipos:ipos)
select case(delim1)
   case('(')
      idelim2=iachar(delim1)+1
      istart=ipos+1
      iend=lenstr
      inc=1
   case(')')
      idelim2=iachar(delim1)-1
      istart=ipos-1
      iend=1
      inc=-1
   case('[','{','<')
      idelim2=iachar(delim1)+2
      istart=ipos+1
      iend=lenstr
      inc=1
   case(']','}','>')
      idelim2=iachar(delim1)-2
      istart=ipos-1
      iend=1
      inc=-1
   case default
      stat = 1
      if (present(status)) status = stat
      !write(*,*) delim1,' is not a valid delimiter'
      return
end select
if(istart < 1 .or. istart > lenstr) then
   stat = 2
   if (present(status)) status = stat
   !write(*,*) delim1,' has no matching delimiter'
   return
end if
delim2=achar(idelim2) ! matching delimiter

isum=1
do i=istart,iend,inc
   ch=str(i:i)
   if(ch /= delim1 .and. ch /= delim2) cycle
   if(ch == delim1) isum=isum+1
   if(ch == delim2) isum=isum-1
   if(isum == 0) exit
end do
if(isum /= 0) then
   stat = 3
   if (present(status)) status = stat
   !write(*,*) delim1,' has no matching delimiter'
   return
end if
imatch=i
if (present(status)) status = 0

return

end subroutine match

!**********************************************************************

!> @brief Writes double precision real number rnum to string str using format fmt
pure subroutine write_dr(rnum,str,fmt)

real(kr8), intent(in) :: rnum
character(len=*), intent(out) :: str
character(len=*), intent(in), optional :: fmt
character(len=80) :: formt

if (present(fmt)) then
   formt='('//trim(fmt)//')'
else
   formt='(g0)'
endif
write(str,formt) rnum
str=adjustl(str)

end subroutine write_dr

!***********************************************************************

!> @brief Writes single precision real number rnum to string str using format fmt
pure subroutine write_sr(rnum,str,fmt)

real(kr4), intent(in) :: rnum
character(len=*), intent(out) :: str
character(len=*), intent(in), optional :: fmt
character(len=80) :: formt

if (present(fmt)) then
   formt='('//trim(fmt)//')'
else
   formt='(g0)'
endif
write(str,formt) rnum
str=adjustl(str)

end subroutine write_sr

!***********************************************************************

!> @brief Writes double precision integer inum to string str using format fmt
pure subroutine write_di(inum,str,fmt)

integer(ki8), intent(in) :: inum
character(len=*), intent(out) :: str
character(len=*), intent(in), optional :: fmt
character(len=80) :: formt

if (present(fmt)) then
   formt='('//trim(fmt)//')'
else
   formt='(g0)'
endif
write(str,formt) inum
str=adjustl(str)

end subroutine write_di

!***********************************************************************

!> @brief Writes single precision integer inum to string str using format fmt
pure subroutine write_si(inum,str,fmt)

integer(ki4), intent(in) :: inum
character(len=*), intent(out) :: str
character(len=*), intent(in), optional :: fmt
character(len=80) :: formt

if (present(fmt)) then
   formt='('//trim(fmt)//')'
else
   formt='(g0)'
endif
write(str,formt) inum
str=adjustl(str)

end subroutine write_si

!***********************************************************************


!> @brief Deletes nonsignificant trailing zeroes from number string str. If number
!! string ends in a decimal point, one trailing zero is added.
pure subroutine trimzero(str)

character(len=*), intent(inout) :: str
character :: ch
character(len=10) :: exp

integer :: ipos,i,lstr

ipos=scan(str,'eE')
if(ipos>0) then
   exp=str(ipos:)
   str=str(1:ipos-1)
endif
lstr=len_trim(str)
do i=lstr,1,-1
   ch=str(i:i)
   if(ch=='0') cycle
   if(ch=='.') then
      str=str(1:i)//'0'
      if(ipos>0) str=trim(str)//trim(exp)
      exit
   endif
   str=str(1:i)
   exit
end do
if(ipos>0) str=trim(str)//trim(exp)

end subroutine trimzero

!**********************************************************************

!> @brief Writes a string of the form <name> = value to unit
subroutine writeq_dr(unit,namestr,value,fmt)

real(kr8) :: value
integer :: unit
character(len=*) :: namestr,fmt
character(len=32) :: tempstr

call writenum(value,tempstr,fmt)
call trimzero(tempstr)
write(unit,*) trim(namestr)//' = '//trim(tempstr)

end subroutine writeq_dr

!**********************************************************************

!> @brief Writes a string of the form <name> = value to unit
subroutine writeq_sr(unit,namestr,value,fmt)


real(kr4) :: value
integer :: unit
character(len=*) :: namestr,fmt
character(len=32) :: tempstr

call writenum(value,tempstr,fmt)
call trimzero(tempstr)
write(unit,*) trim(namestr)//' = '//trim(tempstr)

end subroutine writeq_sr

!**********************************************************************

!> @brief Writes a string of the form <name> = ivalue to unit
subroutine writeq_di(unit,namestr,ivalue,fmt)


integer(ki8) :: ivalue
integer :: unit
character(len=*) :: namestr,fmt
character(len=32) :: tempstr
call writenum(ivalue,tempstr,fmt)
call trimzero(tempstr)
write(unit,*) trim(namestr)//' = '//trim(tempstr)

end subroutine writeq_di

!**********************************************************************

!> @brief Writes a string of the form <name> = ivalue to unit
subroutine writeq_si(unit,namestr,ivalue,fmt)


integer(ki4) :: ivalue
integer :: unit
character(len=*) :: namestr,fmt
character(len=32) :: tempstr
call writenum(ivalue,tempstr,fmt)
call trimzero(tempstr)
write(unit,*) trim(namestr)//' = '//trim(tempstr)

end subroutine writeq_si

!**********************************************************************

!> @brief Returns .true. if ch is a letter and .false. otherwise
function is_letter(ch) result(res)


character :: ch
logical :: res

select case(ch)
case('A':'Z','a':'z')
  res=.true.
case default
  res=.false.
end select
return

end function is_letter

!**********************************************************************

!> @brief Returns .true. if ch is a digit (0,1,...,9) and .false. otherwise
pure elemental function is_digit(ch) result(res)

character, intent(in) :: ch
logical :: res

select case(ch)
case('0':'9')
  res=.true.
case default
  res=.false.
end select
return

end function is_digit

!**********************************************************************

!> @brief Routine finds the first instance of a character from 'delims' in the
!! the string 'str'. The characters before the found delimiter are
!! output in 'before'. The characters after the found delimiter are
!! output in 'str'. The optional output character 'sep' contains the
!! found delimiter. A delimiter in 'str' is treated like an ordinary
!! character if it is preceded by a backslash (\). If the backslash
!! character is desired in 'str', then precede it with another backslash.
pure subroutine split(str,delims,before,sep)

character(len=*), intent(inout) :: str
character(len=*), intent(in) :: delims
character(len=*), intent(out) :: before
character, intent(out), optional :: sep
logical :: pres
character :: ch,cha

integer :: lenstr,k,ibsl,i,ipos,iposa

pres=present(sep)
str=adjustl(str)
call compact(str)
lenstr=len_trim(str)
if(lenstr == 0) return        ! string str is empty
k=0
ibsl=0                        ! backslash initially inactive
before=' '
do i=1,lenstr
   ch=str(i:i)
   if(ibsl == 1) then          ! backslash active
      k=k+1
      before(k:k)=ch
      ibsl=0
      cycle
   end if
   if(ch == '\') then          ! backslash with backslash inactive
      k=k+1
      before(k:k)=ch
      ibsl=1
      cycle
   end if
   ipos=index(delims,ch)
   if(ipos == 0) then          ! character is not a delimiter
      k=k+1
      before(k:k)=ch
      cycle
   end if
   if(ch /= ' ') then          ! character is a delimiter that is not a space
      str=str(i+1:)
      if(pres) sep=ch
      exit
   end if
   cha=str(i+1:i+1)            ! character is a space delimiter
   iposa=index(delims,cha)
   if(iposa > 0) then          ! next character is a delimiter
      str=str(i+2:)
      if(pres) sep=cha
      exit
   else
      str=str(i+1:)
      if(pres) sep=ch
      exit
   end if
end do
if(i >= lenstr) str=''
str=adjustl(str)              ! remove initial spaces
return

end subroutine split

!**********************************************************************

!> @brief Removes backslash (\) characters. Double backslashes (\\) are replaced
!! by a single backslash.
pure subroutine removebksl(str)

character(len=*), intent(inout) :: str
character(len=1) :: ch
character(len=len_trim(str)) :: outstr

integer :: lenstr,k,ibsl,i

str=adjustl(str)
lenstr=len_trim(str)
outstr=' '
k=0
ibsl=0                        ! backslash initially inactive

do i=1,lenstr
  ch=str(i:i)
  if(ibsl == 1) then          ! backslash active
   k=k+1
   outstr(k:k)=ch
   ibsl=0
   cycle
  end if
  if(ch == '\') then          ! backslash with backslash inactive
   ibsl=1
   cycle
  end if
  k=k+1
  outstr(k:k)=ch              ! non-backslash with backslash inactive
end do

str=adjustl(outstr)

end subroutine removebksl

!**********************************************************************

end module xtb_mctc_strings

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_anc
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas
   use xtb_mctc_lapack, only : lapack_spevd, lapack_syevd
   implicit none

   public :: tb_anc
   private

   type tb_anc
      integer  :: n    !< number of atoms
      integer  :: n3   !< dimension of hessian
      integer  :: nvar !< actual dimension
      real(wp) :: hlow
      real(wp) :: hmax
      real(wp),allocatable :: hess(:)
      real(wp),allocatable :: B(:,:)
      real(wp),allocatable :: eigv(:)
      real(wp),allocatable :: coord(:)
      real(wp),allocatable :: xyz(:,:)
   contains
   procedure :: allocate => allocate_anc
   procedure :: deallocate => deallocate_anc
   procedure :: write => write_anc
   procedure :: new => generate_anc_blowup
   procedure :: get_cartesian
   end type tb_anc

contains

subroutine allocate_anc(self,n,nvar,hlow,hmax)
   implicit none
   class(tb_anc),intent(inout)  :: self
   integer,      intent(in)     :: n
   integer,      intent(in)     :: nvar
   integer                      :: n3
   real(wp),intent(in),optional :: hlow
   real(wp),intent(in),optional :: hmax
   n3 = 3*n
   call self%deallocate
   self%n    = n
   self%n3   = 3*n
   self%nvar = nvar
   if (present(hlow)) self%hlow = hlow
   if (present(hmax)) self%hmax = hmax
   allocate( self%hess(nvar*(nvar+1)/2), source = 0.0_wp )
   allocate( self%B(n3,n3),              source = 0.0_wp )
   allocate( self%eigv(n3),              source = 0.0_wp )
   allocate( self%coord(nvar),           source = 0.0_wp )
   allocate( self%xyz(3,n),              source = 0.0_wp )
end subroutine allocate_anc

subroutine deallocate_anc(self)
   implicit none
   class(tb_anc),intent(inout) :: self
   self%n    = 0
   self%n3   = 0
   self%nvar = 0
   if (allocated(self%hess )) deallocate( self%hess  )
   if (allocated(self%B    )) deallocate( self%B     )
   if (allocated(self%eigv )) deallocate( self%eigv  )
   if (allocated(self%coord)) deallocate( self%coord )
   if (allocated(self%xyz  )) deallocate( self%xyz   )
end subroutine deallocate_anc

!> @brief print information about current approximate normal coordinates to unit
subroutine write_anc(self,iunit,comment)
   implicit none
   class(tb_anc),   intent(in) :: self    !< approximate normal coordinates
   integer,         intent(in) :: iunit   !< file handle
   character(len=*),intent(in) :: comment !< name of the variable
   character(len=*),parameter  :: dfmt = '(1x,a,1x,"=",1x,g0)'

   write(iunit,'(72(">"))')
   write(iunit,'(1x,"*",1x,a)') "Writing 'tb_anc' class"
   write(iunit,'(  "->",1x,a)') comment
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "status of the fields"
   write(iunit,dfmt) "integer :: n           ",self%n
   write(iunit,dfmt) "integer :: n3          ",self%n3
   write(iunit,dfmt) "integer :: nvar        ",self%nvar
   write(iunit,dfmt) "real    :: hlow        ",self%hlow
   write(iunit,dfmt) "real    :: hmax        ",self%hmax
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "allocation status"
   write(iunit,dfmt) "allocated? hess(:)     ",allocated(self%hess)
   write(iunit,dfmt) "allocated? B(:)        ",allocated(self%B)
   write(iunit,dfmt) "allocated? eigv(:)     ",allocated(self%eigv)
   write(iunit,dfmt) "allocated? coord(:)    ",allocated(self%coord)
   write(iunit,dfmt) "allocated? xyz(:,:)    ",allocated(self%xyz)
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "size of memory allocation"
   if (allocated(self%hess)) then
   write(iunit,dfmt) "size(1) :: hess(*)     ",size(self%hess,1)
   endif
   if (allocated(self%B)) then
   write(iunit,dfmt) "size(1) :: B(*,:)      ",size(self%B,1)
   write(iunit,dfmt) "size(2) :: B(:,*)      ",size(self%B,2)
   endif
   if (allocated(self%eigv)) then
   write(iunit,dfmt) "size(1) :: eigv(*)     ",size(self%eigv,1)
   endif
   if (allocated(self%coord)) then
   write(iunit,dfmt) "size(1) :: coord(*)    ",size(self%coord,1)
   endif
   if (allocated(self%xyz)) then
   write(iunit,dfmt) "size(1) :: xyz(*,:)    ",size(self%xyz,1)
   write(iunit,dfmt) "size(2) :: xyz(:,*)    ",size(self%xyz,2)
   endif
   write(iunit,'(72("<"))')
end subroutine write_anc

subroutine generate_anc_blowup(self,iunit,xyz,hess,pr,linear)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_la
   use xtb_detrotra, only : detrotra8
   implicit none
   class(tb_anc),intent(inout) :: self
   integer,      intent(in)    :: iunit
   real(wp),     intent(in)    :: xyz(3,self%n)
   real(wp),     intent(inout) :: hess(self%n3,self%n3)
   logical,      intent(in)    :: pr
   logical,      intent(in)    :: linear

   real(wp),parameter   :: thr1 = 1.0e-10_wp
   real(wp),parameter   :: thr2 = 1.0e-11_wp
   integer, parameter   :: maxtry = 4
   integer  :: i,itry
   integer  :: nvar
   integer  :: info
   integer  :: lwork
   integer  :: liwork
   logical  :: fail
   integer, allocatable :: iwork(:)
   real(wp) :: elow,damp,thr
   real(wp),allocatable :: aux(:)

   self%xyz = xyz

   thr = thr2
   lwork  = 1 + 6*self%n3 + 2*self%n3**2
   liwork = 8 * self%n3

   allocate(iwork(liwork), source = 0 )
   allocate(aux(lwork), source = 0.0_wp )

   call lapack_syevd('V','U',self%n3,hess,self%n3,self%eigv, &
      &        aux,lwork,iwork,liwork,info)

   call detrotra8(linear,self%n,self%xyz,hess,self%eigv) 

   !elow = 1.0e+99_wp
   elow = minval(self%eigv,mask=(abs(self%eigv) > thr1))
!   do i = 1, self%n3
!      if (abs(self%eigv(i)) > thr1 ) elow = min(elow,self%eigv(i))
!   enddo

   damp = max(self%hlow - elow,0.0_wp) 
   where(abs(self%eigv) > thr2) self%eigv = self%eigv + damp
!   do i = 1, self%n3
!      if (abs(self%eigv(i)) > thr2 ) self%eigv(i) = self%eigv(i) + damp
!   enddo

   if(pr)then
      write(iunit,*) 'Shifting diagonal of input Hessian by ', damp
      write(iunit,*) 'Lowest  eigenvalues of input Hessian'
      write(iunit,'(6F12.6)')(self%eigv(i),i=1,min(18,self%n3))
      write(iunit,*) 'Highest eigenvalues'
      write(iunit,'(6F12.6)')(self%eigv(i),i=self%n3-5,self%n3)
      write(iunit,*)
   endif

   fail = .true.
   get_anc: do itry = 1, maxtry
      self%B = 0.0_wp
      self%hess = 0.0_wp
      nvar = 0
      ! take largest (positive) first
      do i = self%n3, 1, -1
         if (abs(self%eigv(i)) > thr .and. nvar < self%nvar) then
            nvar = nvar+1
            self%B(:,nvar) = hess(:,i)
            self%hess(nvar+nvar*(nvar-1)/2) = &
               min(max(self%eigv(i),self%hlow),self%hmax)
         endif
      enddo

      if (nvar.ne.self%nvar) then
         thr = thr * 0.1_wp
         cycle get_anc
      endif

      fail = .false.
      exit get_anc

   enddo get_anc

   if (fail) then
      write(*,*) 'nvar, selv%nvar',nvar,self%nvar
      call raise('E',"ANC generation failed!")
   end if

   call sort(self%n3,self%nvar,self%hess,self%B)

   self%coord = 0.0_wp
end subroutine generate_anc_blowup

subroutine generate_anc_packed(self,xyz,hess,pr)
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_la
   implicit none
   class(tb_anc),intent(inout) :: self
   real(wp),     intent(in)    :: xyz(3,self%n)
   real(wp),     intent(inout) :: hess(self%n3*(self%n3+1)/2)
   logical,      intent(in)    :: pr

   real(wp),parameter   :: thr1 = 1.0e-10_wp
   real(wp),parameter   :: thr2 = 1.0e-11_wp
   integer, parameter   :: maxtry = 4
   integer  :: i,itry
   integer  :: nvar
   integer  :: info
   integer  :: lwork
   integer  :: liwork
   logical  :: fail
   integer, allocatable :: iwork(:)
   real(wp) :: elow,damp,thr
   real(wp),allocatable :: aux(:)
   real(wp),allocatable :: u(:,:)

   self%xyz = xyz

   thr = thr2
   lwork  = 1 + 6*self%n3 + 2*self%n3**2
   liwork = 8 * self%n3

   allocate(iwork(liwork), source = 0 )
   allocate(aux(lwork), source = 0.0_wp )
   allocate(u(self%n3,self%n3), source = 0.0_wp )

   call lapack_spevd('V','U',self%n3,hess,self%eigv,u,self%n3, &
      &        aux,lwork,iwork,liwork,info)

   !elow = 1.0e+99_wp
   elow = minval(self%eigv,mask=(abs(self%eigv) > thr1))
   !do i = 1, self%n3
   !   if (abs(self%eigv(i)) > thr1 ) elow = min(elow,self%eigv(i))
   !enddo

   damp = max(self%hlow - elow,0.0_wp)
   where(abs(self%eigv) > thr2) self%eigv = self%eigv + damp
!   do i = 1, self%n3
!      if (abs(self%eigv(i)) > thr2 ) self%eigv(i) = self%eigv(i) + damp
!   enddo

   if(pr)then
      write(stdout,*) 'Shifting diagonal of input Hessian by ', damp
      write(stdout,*) 'Lowest  eigenvalues of input Hessian'
      write(stdout,'(6F12.6)')(self%eigv(i),i=1,min(18,self%n3))
      write(stdout,*) 'Highest eigenvalues'
      write(stdout,'(6F12.6)')(self%eigv(i),i=self%n3-5,self%n3)
      write(stdout,*)
   endif

   fail = .true.
   get_anc: do itry = 1, maxtry
      self%B = 0.0_wp
      self%hess = 0.0_wp
      nvar = 0
      ! take largest (positive) first
      do i = self%n3, 1, -1
         if (abs(self%eigv(i)) > thr .and. nvar < self%nvar) then
            nvar = nvar+1
            self%B(:,nvar) = u(:,i)
            self%hess(nvar+nvar*(nvar-1)/2) = &
               min(max(self%eigv(i),self%hlow),self%hmax)
         endif
      enddo

      if (nvar.ne.self%nvar) then
         thr = thr * 0.1_wp
         cycle get_anc
      endif

      fail = .false.
      exit get_anc

   enddo get_anc

   if (fail) &
      call raise('E',"ANC generation failed!")

   call sort(self%n3,self%nvar,self%hess,self%B)

   self%coord = 0.0_wp
end subroutine generate_anc_packed

pure subroutine sort(nat3,nvar,hess,b)
   implicit none
   integer :: ii,k,j,m,i
   integer, intent(in)    :: nat3,nvar
   real(wp),intent(inout) :: hess(nvar*(nvar+1)/2)
   real(wp),intent(inout) :: b(nat3,nat3)
   real(wp) :: pp,sc1
   real(wp),allocatable   :: edum(:)
   allocate( edum(nvar), source = 0.0_wp )

   do k=1,nvar
      edum(k)=hess(k+k*(k-1)/2)
   enddo
!  sort
   do ii = 2, nvar
      i = ii - 1
      k = i
      pp= edum(i)
      do j = ii, nvar
         if (edum(j) .gt. pp) cycle
         k = j
         pp= edum(j)
      enddo
      if (k .eq. i) cycle
      edum(k) = edum(i)
      edum(i) = pp
      do m=1,nat3
         sc1=b(m,i)
         b(m,i)=b(m,k)
         b(m,k)=sc1
      enddo
   enddo

   do k=1,nvar
      hess(k+k*(k-1)/2)=edum(k)
   enddo

end subroutine sort

subroutine get_cartesian(self,xyz)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(tb_anc),intent(in) :: self
   integer :: m,i,j,k
   real(wp),intent(out) :: xyz (3,self%n)
   real(wp) :: dum

!  generate cartesian displacement vector
   xyz = self%xyz
   call dgemv('n',self%n3,self%nvar,1.0_wp,self%B,self%n3,self%coord,1,1.0_wp,xyz,1)

end subroutine get_cartesian

end module xtb_type_anc

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> API for dealing with the single point calculator
module xtb_api_calculator
   use, intrinsic :: iso_c_binding
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io
   use xtb_mctc_systools, only : rdpath
   use xtb_api_environment
   use xtb_api_molecule
   use xtb_api_utils
   use xtb_gfnff_calculator
   use xtb_type_pcem
   use xtb_main_setup
   use xtb_solv_kernel
   use xtb_solv_input
   use xtb_solv_state
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_xtb_calculator
   implicit none
   private

   public :: VCalculator
   public :: newCalculator_api, delCalculator_api
   public :: loadGFNFF_api, loadGFN0xTB_api, loadGFN1xTB_api, loadGFN2xTB_api
   public :: setSolvent_api, releaseSolvent_api
   public :: setExternalCharges_api, releaseExternalCharges_api
   public :: setAccuracy_api, setElectronicTemp_api, setMaxIter_api


   !> Void pointer to single point calculator
   type :: VCalculator
      class(TCalculator), allocatable :: ptr
   end type VCalculator


contains


function newCalculator_api() result(vcalc) &
      & bind(C, name="xtb_newCalculator")
   !DEC$ ATTRIBUTES DLLEXPORT :: newCalculator_api
   type(VCalculator), pointer :: calc
   type(c_ptr) :: vcalc

   call checkGlobalEnv

   allocate(calc)
   vcalc = c_loc(calc)

end function newCalculator_api


subroutine delCalculator_api(vcalc) &
      & bind(C, name="xtb_delCalculator")
   !DEC$ ATTRIBUTES DLLEXPORT :: delCalculator_api
   type(c_ptr), intent(inout) :: vcalc
   type(VCalculator), pointer :: calc

   call checkGlobalEnv

   if (c_associated(vcalc)) then
      call c_f_pointer(vcalc, calc)
      deallocate(calc)
      vcalc = c_null_ptr
   end if

end subroutine delCalculator_api


subroutine loadGFNFF_api(venv, vmol, vcalc, charptr) &
      & bind(C, name="xtb_loadGFNFF")
   !DEC$ ATTRIBUTES DLLEXPORT :: loadGFNFF_api
   character(len=*), parameter :: source = 'xtb_api_loadGFNFF'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vmol
   type(VMolecule), pointer :: mol
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   character(kind=c_char), intent(in), optional :: charptr(*)
   character(len=:, kind=c_char), allocatable :: dummy, filename
   character(len=*), parameter :: pFilename = '.param_gfnff.xtb'
   type(TGFFCalculator), allocatable :: gff
   logical :: exist, exitRun

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vmol)) then
         call env%ptr%error("Molecular structure data is not allocated", source)
         return
      end if
      call c_f_pointer(vmol, mol)

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (present(charptr)) then
         call c_f_character(charptr, dummy)
      else
         dummy = pFilename
      end if
      inquire(file=dummy, exist=exist)
      if (.not.exist) then
         call rdpath(env%ptr%xtbpath, dummy, filename, exist)
         if (.not.exist) then
            filename = dummy
         end if
      else
         filename = dummy
      end if

      allocate(gff)
      call newGFFCalculator(env%ptr, mol%ptr, gff, filename, .false.)

      call env%ptr%check(exitRun)
      if (exitRun) then
         call env%ptr%error("Could not construct GFN-FF calculator", source)
         return
      end if

      call move_alloc(gff, calc%ptr)

   end if

end subroutine loadGFNFF_api


subroutine loadGFN0xTB_api(venv, vmol, vcalc, charptr) &
      & bind(C, name="xtb_loadGFN0xTB")
   !DEC$ ATTRIBUTES DLLEXPORT :: loadGFN0xTB_api
   character(len=*), parameter :: source = 'xtb_api_loadGFN0xTB'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vmol
   type(VMolecule), pointer :: mol
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   character(kind=c_char), intent(in), optional :: charptr(*)
   character(len=:, kind=c_char), allocatable :: dummy, filename
   character(len=*), parameter :: pFilename = 'param_gfn0-xtb.txt'
   type(TxTBCalculator), allocatable :: xtb
   logical :: exist, exitRun

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vmol)) then
         call env%ptr%error("Molecular structure data is not allocated", source)
         return
      end if
      call c_f_pointer(vmol, mol)

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (present(charptr)) then
         call c_f_character(charptr, dummy)
      else
         dummy = pFilename
      end if
      inquire(file=dummy, exist=exist)
      if (.not.exist) then
         call rdpath(env%ptr%xtbpath, dummy, filename, exist)
         if (.not.exist) then
            filename = dummy
         end if
      else
         filename = dummy
      end if

      allocate(xtb)
      call newXTBCalculator(env%ptr, mol%ptr, xtb, filename)

      call env%ptr%check(exitRun)
      if (exitRun) then
         call env%ptr%error("Could not construct GFN0-xTB calculator", source)
         return
      end if

      call move_alloc(xtb, calc%ptr)

   end if

end subroutine loadGFN0xTB_api


subroutine loadGFN1xTB_api(venv, vmol, vcalc, charptr) &
      & bind(C, name="xtb_loadGFN1xTB")
   !DEC$ ATTRIBUTES DLLEXPORT :: loadGFN1xTB_api
   character(len=*), parameter :: source = 'xtb_api_loadGFN1xTB'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vmol
   type(VMolecule), pointer :: mol
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   character(kind=c_char), intent(in), optional :: charptr(*)
   character(len=:, kind=c_char), allocatable :: dummy, filename
   character(len=*), parameter :: pFilename = 'param_gfn1-xtb.txt'
   type(TxTBCalculator), allocatable :: xtb
   logical :: exist, exitRun

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vmol)) then
         call env%ptr%error("Molecular structure data is not allocated", source)
         return
      end if
      call c_f_pointer(vmol, mol)

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (present(charptr)) then
         call c_f_character(charptr, dummy)
      else
         dummy = pFilename
      end if
      inquire(file=dummy, exist=exist)
      if (.not.exist) then
         call rdpath(env%ptr%xtbpath, dummy, filename, exist)
         if (.not.exist) then
            filename = dummy
         end if
      else
         filename = dummy
      end if

      allocate(xtb)
      call newXTBCalculator(env%ptr, mol%ptr, xtb, filename)

      call env%ptr%check(exitRun)
      if (exitRun) then
         call env%ptr%error("Could not construct GFN1-xTB calculator", source)
         return
      end if

      call move_alloc(xtb, calc%ptr)

   end if

end subroutine loadGFN1xTB_api


subroutine loadGFN2xTB_api(venv, vmol, vcalc, charptr) &
      & bind(C, name="xtb_loadGFN2xTB")
   !DEC$ ATTRIBUTES DLLEXPORT :: loadGFN2xTB_api
   character(len=*), parameter :: source = 'xtb_api_loadGFN2xTB'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vmol
   type(VMolecule), pointer :: mol
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   character(kind=c_char), intent(in), optional :: charptr(*)
   character(len=:, kind=c_char), allocatable :: dummy, filename
   character(len=*), parameter :: pFilename = 'param_gfn2-xtb.txt'
   type(TxTBCalculator), allocatable :: xtb
   logical :: exist, exitRun

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vmol)) then
         call env%ptr%error("Molecular structure data is not allocated", source)
         return
      end if
      call c_f_pointer(vmol, mol)

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (present(charptr)) then
         call c_f_character(charptr, dummy)
      else
         dummy = pFilename
      end if
      inquire(file=dummy, exist=exist)
      if (.not.exist) then
         call rdpath(env%ptr%xtbpath, dummy, filename, exist)
         if (.not.exist) then
            filename = dummy
         end if
      else
         filename = dummy
      end if

      allocate(xtb)
      call newXTBCalculator(env%ptr, mol%ptr, xtb, filename)

      call env%ptr%check(exitRun)
      if (exitRun) then
         call env%ptr%error("Could not construct GFN2-xTB calculator", source)
         return
      end if

      call move_alloc(xtb, calc%ptr)

   end if

end subroutine loadGFN2xTB_api


!> Add a solvation model to calculator (requires loaded parametrisation)
subroutine setSolvent_api(venv, vcalc, charptr, state, temperature, grid) &
      & bind(C, name="xtb_setSolvent")
   !DEC$ ATTRIBUTES DLLEXPORT :: setSolvent_api
   character(len=*), parameter :: source = 'xtb_api_setSolvent'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   character(kind=c_char), intent(in) :: charptr(*)
   integer(c_int), intent(in), optional :: state
   real(c_double), intent(in), optional :: temperature
   integer(c_int), intent(in), optional :: grid
   character(len=:), allocatable :: solvent
   type(TSolvInput) :: input
   integer :: gsolvstate, nang
   real(wp) :: temp
   logical :: exitRun

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (.not.allocated(calc%ptr)) then
         call env%ptr%error("No calculator loaded to add solvation model", source)
         return
      end if

      if (present(state)) then
         gsolvstate = state
      else
         gsolvstate = solutionState%gsolv
      end if

      if (present(temperature)) then
         temp = temperature
      else
         temp = 298.15_wp
      end if

      if (present(grid)) then
         nang = grid
      else
         nang = 230
      end if

      call c_f_character(charptr, solvent)

      ! PGI 20.5 cannot use default constructor with deferred-length characters:
      ! input = TSolvInput(solvent=solvent, temperature=temp, state=gsolvstate, &
      !    & nang=nang)
      input%solvent = solvent
      input%temperature = temp
      input%state = gsolvstate
      input%nang = nang
      input%alpb = .false.
      input%kernel = gbKernel%still
      call addSolvationModel(env%ptr, calc%ptr, input)

      call env%ptr%check(exitRun)
      if (exitRun) then
         call env%ptr%error("Could not add solvation model for '"//solvent//"'", &
            & source)
         return
      end if

   end if

end subroutine setSolvent_api


!> Unset the solvation model
subroutine releaseSolvent_api(venv, vcalc) &
      & bind(C, name="xtb_releaseSolvent")
   !DEC$ ATTRIBUTES DLLEXPORT :: releaseSolvent_api
   character(len=*), parameter :: source = 'xtb_api_setRelease'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (allocated(calc%ptr)) then
         calc%ptr%lSolv = .false.
         if (allocated(calc%ptr%solvation)) then
            deallocate(calc%ptr%solvation)
         end if
      end if

   end if

end subroutine releaseSolvent_api


!> Add a external charge potential to calculator (only supported in GFN1/2-xTB)
subroutine setExternalCharges_api(venv, vcalc, npc, numbers, charges, positions) &
      & bind(C, name="xtb_setExternalCharges")
   !DEC$ ATTRIBUTES DLLEXPORT :: setExternalCharges_api
   character(len=*), parameter :: source = 'xtb_api_setExternalCharges'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   integer(c_int), intent(in) :: npc
   integer(c_int), intent(in) :: numbers(*)
   real(c_double), intent(in) :: charges(*)
   real(c_double), intent(in) :: positions(3, *)
   integer :: ii

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (npc <= 0) then
         call env%ptr%error("Negative number of point charges provided", source)
         return
      end if

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (.not.allocated(calc%ptr)) then
         call env%ptr%error("No calculator loaded to add external potential", &
            & source)
         return
      end if

      select type(xtb => calc%ptr)
      class default
         call env%ptr%error("Calculator does not support external potentials", &
            & source)
         return

      type is(TxTBCalculator)
         if (xtb%xtbData%level == 0) then
            call env%ptr%error("GFN0-xTB does not support external potentials", &
               & source)
            return
         end if

         call xtb%pcem%allocate(npc)
         do ii = 1, npc
            xtb%pcem%xyz(:, ii) = positions(:, ii)
            xtb%pcem%gam(ii) = xtb%xtbData%coulomb%chemicalHardness(numbers(ii))
            xtb%pcem%q(ii) = charges(ii)
         end do

      end select

   end if

end subroutine setExternalCharges_api


!> Unset the external charge potential
subroutine releaseExternalCharges_api(venv, vcalc) &
      & bind(C, name="xtb_releaseExternalCharges")
   !DEC$ ATTRIBUTES DLLEXPORT :: releaseExternalCharges_api
   character(len=*), parameter :: source = 'xtb_api_releaseExternalCharges'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      ! There are only limited cases when we need to perform any action.
      ! Deconstructors should behave nicely, therefore no errors on wrong input.
      if (allocated(calc%ptr)) then
         select type(xtb => calc%ptr)
         type is(TxTBCalculator)
            call xtb%pcem%deallocate
         end select
      end if

   end if

end subroutine releaseExternalCharges_api


subroutine setAccuracy_api(venv, vcalc, accuracy) &
      & bind(C, name="xtb_setAccuracy")
   !DEC$ ATTRIBUTES DLLEXPORT :: setAccuracy_api
   character(len=*), parameter :: source = 'xtb_api_setAccuracy'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   real(c_double), value, intent(in) :: accuracy

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (.not.allocated(calc%ptr)) then
         call env%ptr%error("Setting accuracy not possible, no calculator loaded", &
            & source)
         return
      end if

      if (accuracy < 1.e-4_c_double) then
         call env%ptr%warning("We cannot provide this level of accuracy, "//&
            & "resetted accuracy to 0.0001", source)
         calc%ptr%accuracy = 1.e-4_wp
      else if (accuracy > 1.e+3_c_double) then
         call env%ptr%warning("We cannot provide this level of accuracy, "//&
            & "resetted accuracy to 1000", source)
         calc%ptr%accuracy = 1.e+3_wp
      else
         calc%ptr%accuracy = accuracy
      end if

   end if

end subroutine setAccuracy_api


subroutine setMaxIter_api(venv, vcalc, maxiter) &
      & bind(C, name="xtb_setMaxIter")
   !DEC$ ATTRIBUTES DLLEXPORT :: setMaxIter_api
   character(len=*), parameter :: source = 'xtb_api_setMaxIter'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   integer(c_int), value, intent(in) :: maxiter

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (.not.allocated(calc%ptr)) then
         call env%ptr%error("Setting accuracy not possible, no calculator loaded", &
            & source)
         return
      end if

      select type(xtb => calc%ptr)
      class default
         call env%ptr%warning("Cannot set iterations for non-iterative method", &
            & source)
      type is(TxTBCalculator)
         xtb%maxiter = max(maxiter, 1)
      end select

   end if

end subroutine setMaxIter_api


subroutine setElectronicTemp_api(venv, vcalc, temperature) &
      & bind(C, name="xtb_setElectronicTemp")
   !DEC$ ATTRIBUTES DLLEXPORT :: setElectronicTemp_api
   character(len=*), parameter :: source = 'xtb_api_setElectronicTemp'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   real(c_double), value, intent(in) :: temperature

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (.not.allocated(calc%ptr)) then
         call env%ptr%error("Setting accuracy not possible, no calculator loaded", &
            & source)
         return
      end if

      select type(xtb => calc%ptr)
      class default
         call env%ptr%warning("Calculator does not support electronic temperature", &
            & source)
      type is(TxTBCalculator)
         xtb%etemp = max(temperature, 1.0e-6_c_double)
      end select

   end if

end subroutine setElectronicTemp_api


end module xtb_api_calculator

! This file is part of xtb.
!
! Copyright (C) 2017-2021 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_hessian
   use xtb_mctc_accuracy, only : wp
   use xtb_freq_io, only : rdhess, wrhess, writeHessianOut, &
      & write_tm_vibspectrum, g98fake, g98fake2
   use xtb_freq_project, only : trproj
   implicit none
   private

   public :: numhess
   public :: trproj, rdhess, g98fake2, distort, write_tm_vibspectrum

contains

subroutine numhess( &
      & env,mol,chk0,calc, &
      & egap,et,maxiter,etot,gr,sr,res)
   use xtb_mctc_accuracy, only : wp
!$ use omp_lib

   use xtb_mctc_convert
   use xtb_mctc_blas

!! ========================================================================
!  type definitions
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data

   use xtb_setparam
   use xtb_splitparam
   use xtb_fixparam
   use xtb_metadynamic

   use xtb_axis, only : axis

   implicit none

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "hessian_numhess"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(inout) :: mol
   integer, intent(in)    :: maxiter
   type(TRestart),intent(inout) :: chk0
   class(TCalculator), intent(inout) :: calc
   real(wp) :: eel
   real(wp) :: ebias
   real(wp) :: alp1,alp2
   real(wp),intent(inout) :: etot
   real(wp),intent(in)    :: et
   real(wp),intent(inout) :: egap
   real(wp),intent(inout) :: gr(3,mol%n)
   real(wp),intent(inout) :: sr(3,3)
   type(freq_results),intent(out) :: res

   type(TRestart) :: chk
   type(scc_results) :: sccr,sccl
   real(wp) :: rij(3),step,zpve,t1,t0,dumi,dum,xsum
   real(wp) :: dumj,acc,w0,w1,step2,aa,bb,cc,scalh,hof,h298
   real(wp) :: sum1,sum2,trdip(3),dipole(3)
   real(wp) :: trpol(3),sl(3,3)
   integer  :: n3,i,j,k,ic,jc,ia,ja,ii,jj,info,lwork,a,b,ri,rj
   integer  :: nread,kend,lowmode
   integer  :: nonfrozh,izero(6)
   integer, allocatable :: nb(:,:)
   integer, allocatable :: indx(:),molvec(:)
   real(wp),allocatable :: bond(:,:)

!$ integer  :: nproc

   real(wp),allocatable :: h (:,:)
   real(wp),allocatable :: htb (:,:)
   real(wp),allocatable :: hbias (:,:)
   real(wp),allocatable :: hss(:)
   real(wp),allocatable :: hsb(:)
   real(wp),allocatable :: fc_tb(:)
   real(wp),allocatable :: fc_bias(:)
   real(wp),allocatable :: v(:)
   real(wp),allocatable :: fc_tmp(:)
   real(wp),allocatable :: freq_scal(:)
   real(wp),allocatable :: aux (:)
   real(wp),allocatable :: isqm(:)
   real(wp),allocatable :: gl  (:,:)
   real(wp),allocatable :: xyzsave(:,:)
   real(wp),allocatable :: pold(:)
   real(wp),allocatable :: dipd(:,:)
   real(wp),allocatable :: amass(:)

   type(TMolecule) :: tmol

   logical :: ex,rd
   integer :: ich ! file handle
   integer :: err
   character(len=:),allocatable :: hname,fname
   logical :: exitRun
   character(len=128) :: errStr

   n3=3*mol%n
   call res%allocate(mol%n)
   res%n3true = n3-3*freezeset%n

   allocate(hss(n3*(n3+1)/2),hsb(n3*(n3+1)/2),h(n3,n3),htb(n3,n3),hbias(n3,n3), &
      & gl(3,mol%n),isqm(n3),xyzsave(3,mol%n),dipd(3,n3), &
      & pold(n3),nb(20,mol%n),indx(mol%n),molvec(mol%n),bond(mol%n,mol%n), &
      & v(n3),fc_tmp(n3),freq_scal(n3),fc_tb(n3),fc_bias(n3),amass(n3))

   rd=.false.
   xyzsave = mol%xyz

   step=0.0001_wp
   call rotmol(mol%n,mol%xyz,step,2.*step,3.*step)

   ! step length
   step=set%step_hess
   if(set%extcode.eq.5) step=step*2.0_wp ! MOPAC is not very accurate
   ! SCC accuraccy
   acc=set%accu_hess
   scalh=set%scale_hess

   call calc%singlepoint(env, mol, chk0, 0, .true., res%etot, res%grad, sr, egap, sccr)

   if (set%runtyp.eq.p_run_bhess) then
   write(env%unit,'(''kpush                :'',F10.5)') metaset%factor(metaset%nstruc)
   write(env%unit,'(''alpha                :'',F10.5)') metaset%global_width
   end if
   write(env%unit,'(''step length          :'',F10.5)') step
   write(env%unit,'(''SCC accuracy         :'',F10.5)') acc
   write(env%unit,'(''Hessian scale factor :'',F10.5)') scalh
   write(env%unit,'(''frozen atoms in %    :'',F10.5,i5)') &
      & real(freezeset%n,wp)/real(mol%n,wp)*100,freezeset%n

   res%gnorm = norm2(res%grad)
   write(env%unit,'(''RMS gradient         :'',F10.5)', advance='no') res%gnorm
   if(res%gnorm.gt.0.002_wp) then
      write(env%unit, '(1x,"!! INCOMPLETELY OPTIMIZED GEOMETRY !!")')
      call env%warning('Hessian on incompletely optimized geometry!', source)
      call env%check(exitRun)
      if (exitRun) return
   else
      write(env%unit, '(a)')
   end if

   res%linear=.false.
   call axis(mol%n,mol%at,mol%xyz,aa,bb,cc)
   if(cc.lt.1.d-10) res%linear=.true.
   step2=0.5_wp/step

   h = 0.0_wp
   htb = 0.0_wp
   hbias = 0.0_wp

!! ========================================================================
!  Hessian part -----------------------------------------------------------

   if(freezeset%n.gt.0) then
      ! for frozfc of about 10 the frozen modes
      ! approach 5000 cm-1, i.e., come too close to
      ! the real ones
      nonfrozh=mol%n-freezeset%n
      do a = 1,mol%n
         res%freq(a)=float(a)
      enddo
      do a=1,freezeset%n
         res%freq(freezeset%atoms(a))=freezeset%atoms(a)*100000_wp
      enddo
      call sortind(mol%n,res%freq)
      do a=1,nonfrozh
         indx(a)=idint(res%freq(a))
      enddo
      do a=nonfrozh+1,mol%n
         indx(a)=idint(res%freq(a)/100000_wp)
      enddo
      write(*,'(''atoms frozen in Hessian calc.:'',10i4)') &
         & indx(nonfrozh+1:mol%n)

      h = 0.0_wp
      dipd = 0.0_wp
      pold = 0.0_wp
      call calc%hessian(env, mol, chk0, indx(:nonfrozh), step, h, dipd)

   else
!! ------------------------------------------------------------------------
!  normal case
!! ------------------------------------------------------------------------
      h = 0.0_wp
      dipd = 0.0_wp
      pold = 0.0_wp
      indx = [(i, i = 1, mol%n)]
      call calc%hessian(env, mol, chk0, indx, step, h, dipd)
   endif


!  Hessian done -----------------------------------------------------------
!! ========================================================================

   if (set%runtyp.eq.p_run_bhess) call numhess_rmsd(env,mol,hbias)

   if(set%mode_extrun .eq. p_ext_turbomole .AND. set%runtyp.eq.p_run_bhess) then 
        h = h + hbias !h is biased
   end if

   if(freezeset%n.gt.0)then
      ! inverse mass array
      do a = 1, mol%n
         ia = indx(a)
         do ic = 1, 3
            ii = (ia-1)*3+ic
            isqm(ii)=1.0_wp/sqrt(atmass(ia))
            amass(ii)=isqm(ii)/sqrt(amutoau)
         enddo
      enddo
      do a = 1, nonfrozh
         ia = indx(a)
         do ic = 1, 3
            ii = (ia-1)*3+ic
            do b = 1, nonfrozh
               ja = indx(b)
               do jc = 1, 3
                  jj = (ja-1)*3+jc
                  if(abs(h(ii,jj)-h(jj,ii)).gt.1.d-2) then
                     write(errStr,'(a,1x,i0,1x,i0,1x,a,1x,es14.6,1x,es14.6)') &
                        & 'Hessian element ',i,j,' is not symmetric:',h(i,j),h(j,i)
                     call env%warning(trim(errStr), source)
                  endif
                  h(jj,ii) = 0.5_wp*(h(ii,jj)+h(jj,ii))
               enddo
            enddo
         enddo
      enddo
      ! at this point the H matrix has zeros in the frozen atom block
      do a = nonfrozh+1,mol%n
         ia = indx(a)
         do ic = 1, 3
            ii = (ia-1)*3+ic
            h(:, ii) = 0.0_wp
            h(ii, :) = 0.0_wp
            h(ii,ii)=freezeset%fc   ! fill frozen diagonal block only
         enddo
      enddo
      res%hess = h ! copy
   else
      ! symmetrize
      do i=1,n3
         do j=1,n3
            res%hess(j,i)=(h(i,j)+h(j,i))*0.5_wp
            if(abs(h(i,j)-h(j,i)).gt.1.d-2) then
               write(errStr,'(a,1x,i0,1x,i0,1x,a,1x,es14.6,1x,es14.6)') &
                  & 'Hessian element ',i,j,' is not symmetric:',h(i,j),h(j,i)
               call env%warning(trim(errStr), source)
            endif
         enddo
      enddo
      ! inverse mass array
      do ia = 1, mol%n
         do ic = 1, 3
            ii = (ia-1)*3+ic
            isqm(ii)=1.0_wp/sqrt(atmass(ia))
            amass(ii)=isqm(ii)/sqrt(amutoau)
        enddo
      enddo
   endif

   if (set%pr_dftbp_hessian_out) then
      call writeHessianOut('hessian.out', res%hess)
      write(env%unit, '(A)') "DFTB+ style hessian.out written"
   end if

   ! prepare all for diag
   ! copy
   k=0
   do i=1,n3
      do j=1,i
         k=k+1
         hss(k)=res%hess(j,i)
      enddo
   enddo
   ! same for bhess run
   if (set%runtyp.eq.p_run_bhess) then
      k=0
      do i=1,n3
         do j=1,i
            k=k+1
            hsb(k)=hbias(j,i)
         enddo
      enddo
   end if
   ! project
   if(.not.res%linear)then ! projection does not work for linear mol.
      if (set%runtyp.eq.p_run_bhess) then
         call trproj(mol%n,n3,mol%xyz,hsb,.false.,0,res%freq,1) ! freq is dummy
      end if
      call trproj(mol%n,n3,mol%xyz,hss,.false.,0,res%freq,1) ! freq is dummy
   endif
   ! non mass weigthed Hessian in hss
   hname = 'hessian'
   write(env%unit,'(a)')
   write(env%unit,'("writing file <",a,">.")') hname
   call wrhess(n3,hss,hname)

   ! include masses
   k=0
   do i=1,n3
      do j=1,i
         k=k+1
         res%hess(j,i)=hss(k)*isqm(i)*isqm(j)*scalh
         res%hess(i,j)=res%hess(j,i)
      enddo
   enddo
   ! same for bhess run
   if (set%runtyp.eq.p_run_bhess) then
      k=0
      do i=1,n3
         do j=1,i
            k=k+1
            hbias(j,i)=hsb(k)*isqm(i)*isqm(j)*scalh
            hbias(i,j)=hbias(j,i)
         enddo
      enddo
   end if
   ! calcualte htb without RMSD bias
   if (set%runtyp.eq.p_run_bhess) htb=res%hess-hbias
   ! diag
   lwork  = 1 + 6*n3 + 2*n3**2
   allocate(aux(lwork))
   call dsyev ('V','U',n3,res%hess,n3,res%freq,aux,lwork,info)
   if(info.ne.0) then
      call env%error('Diagonalization of hessian failed', source)
      return
   end if

   ! calculate fc_tb and fc_bias
   alp1=1.27_wp
   alp2=1.5d-4
   if (set%runtyp.eq.p_run_bhess) then
      do j=1,n3
         v(1:n3) = res%hess(1:n3,j) ! modes
         call mctc_gemv(htb,v,fc_tmp)
         fc_tb(j) = mctc_dot(v,fc_tmp)
         call mctc_gemv(hbias,v,fc_tmp)
         fc_bias(j) = mctc_dot(v,fc_tmp)
         if (abs(res%freq(j)).gt.1.0d-6) then
            freq_scal(j) = sqrt( (fc_tb(j)+alp2) / ( (fc_tb(j)+alp2) +  alp1*fc_bias(j) ) )
            if (fc_tb(j).lt.0.and.fc_bias(j).ne.0) then
               freq_scal(j) = -sqrt( (abs(fc_tb(j))+alp2) / ( (abs(fc_tb(j))+alp2) + alp1*fc_bias(j) ) )
            end if
         else
            freq_scal(j) = 1.0_wp
         end if
      end do
   end if

   write(env%unit,'(a)')
   if(res%linear)then
      write(env%unit,'(1x,a)') 'vibrational frequencies (cm⁻¹)'
   else
      write(env%unit,'(1x,a)') 'projected vibrational frequencies (cm⁻¹)'
   endif
   k=0
   do i=1,n3
      ! Eigenvalues in atomic units, convert to wavenumbers
      res%freq(i)=autorcm*sign(sqrt(abs(res%freq(i))),res%freq(i))/sqrt(amutoau)
      if(abs(res%freq(i)).lt.0.01_wp) then
         k=k+1
         izero(k)=i
      endif
   enddo

   ! scale frequencies
   if (set%runtyp.eq.p_run_bhess) then
      do j=1,n3
         res%freq(j)=freq_scal(j)*res%freq(j)
      end do
   end if

   if (set%verbose.and.set%runtyp.eq.p_run_bhess) then
      write(env%unit,'(4x,"freq   fc_tb      fc_bias    scal")')
      do i=1,n3
         write(env%unit,'(f8.2,2x,f9.6,2x,f9.6,2x,f7.4)') &
         res%freq(i),fc_tb(i),fc_bias(i),freq_scal(i)
      end do
      write(env%unit,*)
   end if

   ! sort such that rot/trans are modes 1:6, H/isqm are scratch
   if (mol%n > 1) then
      kend=6
      if(res%linear)then
         kend=5
         do i=1,kend
            izero(i)=i
         enddo
         res%freq(1:5)=0
      endif
      do k=1,kend
         h(1:n3,k)=res%hess(1:n3,izero(k))
         isqm(  k)=res%freq(izero(k))
      enddo
      j=kend
      do k=1,n3
         if(abs(res%freq(k)).gt.0.01_wp)then
            j=j+1
            if(j.gt.n3) then
               call env%error('internal error while sorting hessian', source)
               return
            end if
            h(1:n3,j)=res%hess(1:n3,k)
            isqm(  j)=res%freq(   k)
         endif
      enddo
   end if
   res%hess = h
   res%freq = isqm
   call PREIGF(env%unit,res%freq,res%n3true)

   ! reduced mass
   res%lowmode=1
   k=0
   do i=1,n3
      if(res%freq(i).lt.set%mode_vthr) res%lowmode=i
      xsum=0
      k=k+1
      do ia=1,mol%n
         do ic=1,3
            ii = (ia-1)*3+ic
            xsum=xsum+atmass(ia)*res%hess(ii,i)**2
         enddo
      enddo
      res%rmass(i)=xsum
   enddo

   !--- IR intensity ---!
   !  1. res%hess corresponds to the orthonormal eigenvectors of the hessian
   !     matrix (-> normal modes of vibration). Mass-weighting is introduced
   !     back again via multiplying with amass(j).
   !
   !  2. res%hess(j,i) is the matrix which transforms a derivative with
   !     respect to the j-th cartesian coordinate ("dipd") into a derivative with
   !     respect to the i-th (mass-weighted) normal coordinate.
   !
   !  3. amass(j) = 1/sqrt(m(j)); m(j) is given in atomic units (a.u.).
   !
   !  4. matmul(D x H) = U
   !
   !  5. D = dipd(3,n3); H = res%hess(n3:n3); U = Matrix with dipol derivatives
   !                                              in x, y and z direction per mode

   do i = 1, n3
      do k = 1, 3
         sum2 = 0.0_wp
         do j = 1, n3
            sum2 = sum2 + dipd(k,j)*(res%hess(j,i)*amass(j))
         end do
         trdip(k) = sum2
      end do
      res%dipt(i) = autokmmol*(trdip(1)**2+trdip(2)**2+trdip(3)**2)
   end do
   ! Raman intensity
   do i = 1, n3
      sum2 = 0.0_wp
      do j = 1, n3
         sum2 = sum2 + pold(j)*(res%hess(j,i)*amass(j))
      end do
      res%polt(i) = abs(sum2)
   end do

end subroutine numhess

subroutine numhess_rmsd( &
      & env,mol,hbias)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert

!! ========================================================================
!  type definitions
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data

   use xtb_setparam
   use xtb_splitparam
   use xtb_fixparam
   use xtb_metadynamic

   implicit none
   !> Dummy
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(inout) :: mol
   real(wp),intent(inout)         :: hbias(mol%n*3,mol%n*3)
   !> Stack
   type(TMolecule) :: tmol
   real(wp) :: ebias
   real(wp) :: step,step2
   integer  :: n3,i,j,k,ic,jc,ia,ja,ii,jj,a,b
   real(wp),allocatable :: gr(:,:)
   real(wp),allocatable :: gl(:,:)
   real(wp),allocatable :: xyzsave(:,:)

   n3=3*mol%n

   allocate(gr(3,mol%n),gl(3,mol%n),xyzsave(3,mol%n))

   xyzsave = mol%xyz

   ! step length
   step=0.0001_wp
   step=set%step_hess
   step2=0.5_wp/step

!! ========================================================================
!  RMSD part -----------------------------------------------------------

   do ia = 1, mol%n
      do ic = 1, 3
         ii = (ia-1)*3+ic

         tmol=mol
         tmol%xyz(ic,ia)=xyzsave(ic,ia)+step

         gr = 0.0_wp
         ebias = 0.0_wp
         call metadynamic(metaset,tmol%n,tmol%at,tmol%xyz,ebias,gr)

         tmol=mol
         tmol%xyz(ic,ia)=xyzsave(ic,ia)-step

         gl = 0.0_wp
         ebias = 0.0_wp
         call metadynamic(metaset,tmol%n,tmol%at,tmol%xyz,ebias,gl)

         tmol%xyz(ic,ia)=xyzsave(ic,ia)

         do ja= 1, mol%n
            do jc = 1, 3
               jj = (ja-1)*3 + jc
               hbias(ii,jj) =(gr(jc,ja) - gl(jc,ja)) * step2
            enddo
         enddo

         call tmol%deallocate
      enddo

   end do

!  RMSD done -----------------------------------------------------------
!! ========================================================================

end subroutine numhess_rmsd

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine rotmol(n,xyz,xrot,yrot,zrot)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants, only: pi
   implicit none
   integer :: n,i
   real(wp) :: xrot,yrot,zrot,xyz(3,n)
   real(wp) :: ang,xo,yo

   ang=xrot*pi/180.0_wp
   do i=1,n
      xo=xyz(2,i)
      yo=xyz(3,i)
      xyz(2,i)= xo*cos(ang)+yo*sin(ang)
      xyz(3,i)=-xo*sin(ang)+yo*cos(ang)
   enddo
   ang=yrot*pi/180.0_wp
   do i=1,n
      xo=xyz(1,i)
      yo=xyz(3,i)
      xyz(1,i)= xo*cos(ang)+yo*sin(ang)
      xyz(3,i)=-xo*sin(ang)+yo*cos(ang)
   enddo
   ang=zrot*pi/180.0_wp
   do i=1,n
      xo=xyz(1,i)
      yo=xyz(2,i)
      xyz(1,i)= xo*cos(ang)+yo*sin(ang)
      xyz(2,i)=-xo*sin(ang)+yo*cos(ang)
   enddo

end subroutine rotmol

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine distort(mol,freq,u)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : generateFileName
   use xtb_type_molecule
   use xtb_io_writer, only : writeMolecule
   implicit none
   type(TMolecule), intent(inout) :: mol
   real(wp) u(:,:),freq(:)

   integer n3,i,imag,jj,ja,jc,ich
   real(wp) f,thr
   real(wp), allocatable :: xyz2(:,:)
   character(len=:), allocatable :: fname

   xyz2 = mol%xyz

   n3=3*len(mol)
   ! cut-off for what is considered to be imag
   thr=5.0

   imag=0
   do i=1,n3
      if(freq(i).lt.0.and.abs(freq(i)).gt.thr)then
         imag=imag+1
      endif
   enddo
   if(imag.eq.0) return
   write(*,'(''imag cut-off (cm-1) :'',f8.2)') thr
   if(imag.eq.1) &
      & write(*,*) 'found ',imag,' significant imaginary frequency'
   if(imag.gt.1) &
      & write(*,*) 'found ',imag,' significant imaginary frequencies'

   ! magnitude of distortion
   f=0.5/float(imag)

   do i=1,n3
      if(freq(i).lt.0.and.abs(freq(i)).gt.thr)then
         do ja=1,len(mol)
            do jc=1,3
               jj = (ja-1)*3 + jc
               mol%xyz(jc,ja)=mol%xyz(jc,ja)+f*u(jj,i)
            enddo
         enddo
      endif
   enddo

   call generateFileName(fname, 'xtbhess', '', mol%ftype)
   write(*,*) 'writing imag mode distorted coords to '//fname
   write(*,*) 'for further optimization.'
   call open_file(ich, fname, 'w')
   call writeMolecule(mol, ich)
   call close_file(ich)

   mol%xyz = xyz2

end subroutine distort

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

pure subroutine sortind(nvar,edum)
   implicit none
   integer, intent(in)    :: nvar
   real(wp),intent(inout) :: edum(nvar)
   integer  :: ii,k,i,j
   real(wp) :: pp

   do ii = 2, nvar
      i = ii - 1
      k = i
      pp= edum(i)
      do j = ii, nvar
         if (edum(j) .gt. pp) cycle
         k = j
         pp= edum(j)
      enddo
      if (k .eq. i) cycle
      edum(k) = edum(i)
      edum(i) = pp
   enddo

end subroutine sortind

end module xtb_hessian

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Parametrisation data for the PTB method
module xtb_ptb_data
   use xtb_mctc_accuracy, only: wp
   implicit none
   private

   public :: TPTBData, init
   public :: TCoulombData, THamiltonianData, TPlusU
   public :: TCorePotentialData, TEEQData, TPauliXCData, TResponse
   public :: newData, getData
   public :: angToShellData

   interface newData
      module procedure :: newAtomicData
      module procedure :: newShellData
      module procedure :: newAngShellData
   end interface newData

   interface getData
      module procedure :: getAtomicData
      module procedure :: getShellData
      module procedure :: getAngShellData
   end interface getData

   !> Data for the effective core potential
   type :: TCorePotentialData
      !> Maximum number of core shells
      integer :: max_shell

      !> Maximum number of core primitives
      integer :: max_prim

      !> Number of core shells for each atom
      integer, allocatable :: nshell(:)

      !> Principal quantum number of each shell
      integer, allocatable :: pqn(:, :)

      !> Angular momentum of each shell
      integer, allocatable :: angshell(:, :)

      !> HF level of each shell
      real(wp), allocatable :: hflev(:, :)

      !> Slater exponents of each shell
      real(wp), allocatable :: sl_exp(:, :)

      !> Effective core potential scaling factors
      real(wp), allocatable :: kecpepsilon(:)

   end type TCorePotentialData

   !> Vxc parameters
   type :: TPauliXCData
      !> Scaling factor for the Pauli repulsion in first iteration
      real(wp), allocatable :: kxc1(:)

      !> Scaling factor for the Pauli repulsion in second iteration
      real(wp), allocatable :: kxc2l(:, :)

      !> Exponent scaling for the Overlap_XC
      real(wp), allocatable :: klalphaxc(:, :)

   end type TPauliXCData

   !> EEQ parameters
   type :: TEEQData

      !> Alpha parameter for EEQ model
      real(wp), allocatable :: alp(:)

      !> EN parameter for EEQ model
      real(wp), allocatable :: chi(:)

      !> CN dependency parameter of EEQ model
      real(wp), allocatable :: cnf(:)

      !> Chemical hardness parameters for EEQ model
      real(wp), allocatable :: gam(:)

   end type TEEQData

   !> Data for the evaluation of the PTB core Hamiltonian
   type :: THamiltonianData

      !> Reference occupation of the atom
      real(wp), allocatable :: refocc(:, :)

      !----------------
      !> H0 information
      !----------------
      !> Atomic level information
      real(wp), allocatable :: selfEnergy(:, :)
      !> Coordination number dependence of the atomic levels
      real(wp), allocatable :: klh(:, :)
      !> Coordination number-star dependence of the atomic levels
      real(wp), allocatable :: kcnstar(:)
      !> Shift of atomic levels depending only on coordination number-star
      real(wp), allocatable :: kshift(:)
      !> Wolfsberg parameter for EHT
      real(wp), allocatable :: kla(:, :)
      !> Atomic radii for H0
      real(wp), allocatable :: kr(:)
      !> One-center off-diagonal scaling of S_H0 (squared)
      real(wp), allocatable :: kocod(:)
      !> OCOD scaling fo s-s', p-p', d-d'...
      real(wp), allocatable :: ksla(:, :)
      !> Exponent scaling for H0 overlap matrix
      real(wp), allocatable :: kalphah0l(:, :)
      !> Exponent scaling for H0 overlap matrix in second iteration; charge-dependency
      real(wp), allocatable :: kits0(:)

   end type THamiltonianData

   !> Data for the evalutation of the Coulomb interactions
   type :: TCoulombData

      !> Use electronegativity equlibration for reference density
      logical :: enEquilibration

      !> Include second order electrostatics
      logical :: secondOrder

      !> Include third order electrostatics
      logical :: thirdOrder

      !> Third order electrostatics is shell resolved
      logical :: shellResolved

      !> Atomic hardnesses used in second order electrostatics
      real(wp), allocatable :: chemicalHardness(:)

      !> Scaling factors for shell electrostatics in first iteration
      real(wp), allocatable :: shellHardnessFirstIter(:, :)

      !> Scaling factors for shell electrostatics in second iteration
      real(wp), allocatable :: shellHardnessSecondIter(:, :)

      !> Third order Hubbard derivatives
      real(wp), allocatable :: thirdOrderAtom(:)

      !> Shell resolved third order Hubbard derivatives
      real(wp), allocatable :: thirdOrderShell(:, :)

      !> Coordination number dependence of the EN
      real(wp), allocatable :: kCN(:)

      !> Scaling factor for charge dependence of the Hubbard parameter in the first iter.
      real(wp) :: kQHubbard

      !> Third-Order scaling parameter
      real(wp), allocatable :: kTO(:)

      !> Ohno-Klopman contribution in the first and second iteration
      real(wp) :: kOK1
      real(wp) :: kOK2

   end type TCoulombData

   !> DFT +U contribution to the Hamiltonian in the second iteration
   type :: TPlusU

      !> Average coordination number
      real(wp), allocatable :: avcn(:)

      !> Scaling factor for the diagonal element of the +U matrix
      real(wp), allocatable :: cud(:)

      !> Scaling factor for the simple charge dependence of the +U matrix
      real(wp), allocatable :: cu1(:)

      !> Scaling factor for the quadratic charge dependence of the +U matrix
      real(wp), allocatable :: cu2(:)

      !> Shell level for +U matrix
      real(wp), allocatable :: cueffl(:, :)

      !> Atomic radii for +U
      real(wp), allocatable :: ar(:)

      !> Scaling factor for the atomic radii dependent on the coordination number
      real(wp), allocatable :: arcn(:)

   end type TPlusU

   type :: TResponse

      !> Wolfsberg parameter for response approximation H0
      !> CAUTION: Parameter transformed from atomic to shell resolution to match
      !> the usual H0 parameter
      real(wp), allocatable :: kares(:, :)

      !> Ohno-Klopman contribution in the response approximation
      real(wp) :: kOK_onescf

      !> Mixing parameter for the field-free electrostatic potential
      real(wp), allocatable :: cvesres(:)

      !> Scaling factor for the diagonal element of the +U matrix
      real(wp), allocatable :: kueffres(:)

   end type TResponse

   !> Parametrisation data for the PTB method
   type :: TPTBData

      !> Name of the parametrisation
      character(len=:), allocatable :: name

      !> Reference to the publication
      character(len=:), allocatable :: doi

      !> Internal version number
      integer :: level

      !> Number of shells
      integer, allocatable :: nshell(:)

      !> Parametrisation data for core Hamiltonian
      type(THamiltonianData) :: hamiltonian

      !> Parametrisation data for Coulombic interactions
      type(TCoulombData) :: coulomb

      !> Parametrisation data for the effective core potential
      type(TCorePotentialData) :: corepotential

      !> Parametrisation data for the EEQ model
      type(TEEQData) :: eeq

      !> Pauli-XC data
      type(TPauliXCData) :: pauli

      !> Parametrisation data for the DFT+U contribution
      type(TPlusU) :: plusU

      !> Parametrisation data for the response approximation
      type(TResponse) :: response

   contains

      !> Write informative printout for the parametrisation data
      procedure :: writeInfo

   end type TPTBData

   !> Default constructor for the data types
   interface init
      module procedure :: initCoulomb
      module procedure :: initCorepotential
      module procedure :: initEEQ
      module procedure :: initHamiltonian
      module procedure :: initPlusU
      module procedure :: initPauli
      module procedure :: initResponse
   end interface init

contains

   subroutine writeInfo(self, unit, num)

      !> Instance of the parametrisation data
      class(TPTBData), intent(in) :: self

      !> Unit for I/O
      integer, intent(in) :: unit

      !> Atomic numbers
      integer, intent(in), optional :: num(:)

      character(len=*), parameter :: rnum = '(f12.6)'
      character(len=*), parameter :: offset = '(8x)'
      character(len=*), parameter :: head = '(6x,"*",1x,a,":")'
      character(len=*), parameter :: rfmt = '('//offset//',a,t36,'//rnum//')'
      character(len=*), parameter :: afmt = '('//offset//',a,t36,4x,a)'
      character(len=:), allocatable :: name
      integer :: ii, jj

      write (unit, '(a)')
      if (allocated(self%name)) then
         allocate (character(len=2*len(self%name) - 1) :: name)
         name = repeat(' ', len(name))
         do ii = 1, len(self%name)
            jj = 2 * ii - 1
            name(jj:jj) = self%name(ii:ii)
         end do
      else
         name = repeat(' ', 10)
         write (name, '(i0)') self%level
         name = 'PTB level '//trim(name)
      end if
      call generic_header(unit, name, 49, 10)
      write (unit, '(a)')
      if (allocated(self%doi)) then
         write (unit, afmt) "Reference", self%doi
      end if
      write (unit, '(a)')

      write (unit, '(a)') " @@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
      write (unit, '(a)') " @,,,,,,,,,,,,,,,,,,,,,,,,,,,,@@"
      write (unit, '(a)') " @,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,@"
      write (unit, '(a)') " @,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,*"
      write (unit, '(a)') " @,,,,,,,,@///////////////#,,,,,,,,,@"
      write (unit, '(a)') " @,,,,,,,,@/////////////////,,,,,,,,("
      write (unit, '(a)') " @,,,,,,,,@/////////////////,,,,,,,,("
      write (unit, '(a)') " @,,,,,,,,@/////////////////,,,,,,,,("
      write (unit, '(a)') " @,,,,,,,,@/////////////////,,,,,,,,("
      write (unit, '(a)') " @,,,,,,,,@/////////////////,,,,,,,,("
      write (unit, '(a)') " @,,,,,,,,@/////////////////,,,,,,,,("
      write (unit, '(a)') " @,,,,,,,,@////////////////@,,,,,,,,@"
      write (unit, '(a)') " @,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,%   @@@@@@@@@@@@@@@@@@   @@@@@@@@@@@@@@"
      write (unit, '(a)') " @,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,&////@,,,,,,,,,,,,,,,,,///@,,,,,,,,,,,,,,@"
      write (unit, '(a)') " @,,,,,,,,,,,,,,,,,,,,,,,,,,,,,@///////@,,,,,,,,,,,,,,,,,,//@,,,,,,,,,,,,,,,,@"
      write (unit, '(a)') " @,,,,,,,,@///////////////////////////////////@,,,#/////////@,,,@////////*,,,@"
      write (unit, '(a)') " @,,,,,,,,@/////////@ ////////////////////////@,,,#/////////@,,,@////////*,,,@"
      write (unit, '(a)') " @,,,,,,,,@///// %@@  ( @@@ (@ @@@ @//////////@,,,#/////////@,,,@////////*,,,@"
      write (unit, '(a)') " @,,,,,,,,@////( @//@ ( @@@ @@ @//.@//////////@,,,#/////////@,,,,,,,,,,,,,,,*"
      write (unit, '(a)') " @,,,,,,,,@///// @//@ ( @////@ @//.@//////////@,,,#/////////@,,,,,,,,,,,,,,,,@"
      write (unit, '(a)') " @,,,,,,,,@//////@@@@@/(@@@@/@@@//@@//////////@,,,#/////////@,,,@////////(,,,,@"
      write (unit, '(a)') " @,,,,,,,,@///////////#@@/ @//////////////////@,,,#/////////@,,,@/////////,,,,@"
      write (unit, '(a)') " @,,,,,,,,@//// .@@/(/# @@ @@/@ /// @/////////@,,,#/////////@,,,@/////////,,,,@"
      write (unit, '(a)') " @,,,,,,,,@////%    @/# @/ @//@ /// @/////////@,,,#/////////@,,,@////////@,,,,@"
      write (unit, '(a)') " @,,,,,,,,@////////@ /# @/ @//@ /// @/////////@,,,#/////////@,,,,,,,,,,,,,,,,@"
      write (unit, '(a)') " &@@@@@@@@@/////@@@@//(@@/#@@(/#@@@ @"
      write (unit, '(a,/)') "                              @@@ @"

   end subroutine writeInfo

   subroutine initCorepotential(self, max_core_prim, max_core_shell, & !> Array sizes
      & cbas_sl_exp, cbas_nshell, & !> Slater exponents, number of shells
      & cbas_pqn, cbas_angshell, cbas_hflev, & !> Principal quantum number, angular momentum, HF level
      & kecpepsilon) !> Effective core potential scaling factors

      integer, intent(in) :: max_core_prim, max_core_shell
      integer, intent(in) :: cbas_nshell(:), cbas_pqn(:, :), cbas_angshell(:, :)
      real(wp), intent(in) :: cbas_sl_exp(:, :), cbas_hflev(:, :), kecpepsilon(:)

      !> Data instance
      type(TCorePotentialData), intent(out) :: self

      self%max_prim = max_core_prim    ! 6
      self%max_shell = max_core_shell  ! 12
      self%nshell = cbas_nshell(:)
      self%pqn = cbas_pqn(:, :)
      self%angshell = cbas_angshell(:, :)
      self%sl_exp = cbas_sl_exp(:, :)
      self%hflev = cbas_hflev(:, :)
      self%kecpepsilon = kecpepsilon(:)

   end subroutine initCorepotential

   subroutine initEEQ(self, num, alp, chi, cnf, gam)

      !> Data instance
      type(TEEQData), intent(out) :: self

      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)

      !> Alpha parameter for EEQ model
      real(wp), intent(in) :: alp(:)

      !> EN parameter for EEQ model
      real(wp), intent(in) :: chi(:)

      !> CN dependency parameter of EEQ model
      real(wp), intent(in) :: cnf(:)

      !> Chemical hardness parameters for EEQ model
      real(wp), intent(in) :: gam(:)

      call newData(self%alp, num, alp)
      call newData(self%chi, num, chi)
      call newData(self%cnf, num, cnf)
      call newData(self%gam, num, gam)

   end subroutine initEEQ

   subroutine initPauli(self, num, nshell, kxc1, kxc2l, klalphaxc)

      !> Data instance
      type(TPauliXCData), intent(out) :: self
      !> Number of shells for each atom
      integer, intent(in) :: nshell(:)

      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)

      !> Scaling factor for the Pauli repulsion in first iteration
      real(wp), intent(in) :: kxc1(:)

      !> Scaling factor for the Pauli repulsion in second iteration
      real(wp), intent(in) :: kxc2l(:, :)

      !> Exponent scaling for the Overlap_XC
      real(wp), intent(in) :: klalphaxc(:, :)

      call newData(self%kxc1, num, kxc1)
      call newData(self%kxc2l, num, nshell, kxc2l)
      call newData(self%klalphaxc, num, nshell, klalphaxc)

   end subroutine initPauli

   subroutine initHamiltonian(self, num, nshell, ang_shell, h0_levels, &
      & cn_dependency, cnstar_dependency, cnstar_shift, wolfsberg_par, &
      & atom_radii_h0, onecenteroffdiagonal, ocod_l, expscal_h0, charge_scal_h0_overlap)

      !> Data instance
      type(THamiltonianData), intent(out) :: self
      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)
      !> Number of shells for each atom
      integer, intent(in) :: nshell(:)
      !> Angular momenta of each shell
      integer, intent(in) :: ang_shell(:, :)
      !> Atomic level information
      real(wp), intent(in) :: h0_levels(:, :)
      !> Coordination number dependence of the atomic levels
      real(wp), intent(in) :: cn_dependency(:, :)
      !> Coordination number-star dependence of the atomic levels
      real(wp), intent(in) :: cnstar_dependency(:)
      !> Shift of atomic levels depending only on coordination number-star
      real(wp), intent(in) :: cnstar_shift(:)
      !> Wolfsberg parameter for EHT
      real(wp), intent(in) :: wolfsberg_par(:, :)
      !> Atomic radii for H0
      real(wp), intent(in) :: atom_radii_h0(:)
      !> One-center off-diagonal scaling of S_H0 (squared)
      real(wp), intent(in) :: onecenteroffdiagonal(:)
      !> Ang-mom-dependent OCOD scaling for s-s', p-p', d-d'...
      real(wp), intent(in) :: ocod_l(:, :)
      !> Exponent scaling for H0 overlap matrix
      real(wp), intent(in) :: expscal_h0(:, :)
      !> Exponent scaling for H0 overlap matrix in second iteration; charge-dependency
      real(wp), intent(in) :: charge_scal_h0_overlap(:)

      call newData(self%selfEnergy, num, nshell, h0_levels)
      call newData(self%klh, num, nshell, cn_dependency)
      call newData(self%kcnstar, num, cnstar_dependency)
      call newData(self%kshift, num, cnstar_shift)
      call newData(self%kla, num, nshell, ang_shell, wolfsberg_par)
      call newData(self%kr, num, atom_radii_h0)
      call newData(self%kocod, num, onecenteroffdiagonal)
      call newData(self%ksla, num, nshell, ang_shell, ocod_l)
      call newData(self%kalphah0l, num, nshell, expscal_h0)
      call newData(self%kits0, num, charge_scal_h0_overlap)

   end subroutine initHamiltonian

   subroutine initCoulomb(self, num, nshell, shellHardnessFirstIter, &
      & shellHardnessSecondIter, thirdOrderAtomWise)

      !> Data instance
      type(TCoulombData), intent(out) :: self
      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)
      !> Number of shells for each atom
      integer, intent(in) :: nshell(:)
      !> Scaling factors for shell electrostatic hardness in first iteration
      real(wp), intent(in) :: shellHardnessFirstIter(:, :)
      !> Scaling factors for shell electrostatic hardness in second iteration
      real(wp), intent(in) :: shellHardnessSecondIter(:, :)
      !> Scaling factors for third-order electrostatics
      real(wp), intent(in) :: thirdOrderAtomWise(:)

      call newData(self%shellHardnessFirstIter, num, nshell, shellHardnessFirstIter)
      call newData(self%shellHardnessSecondIter, num, nshell, shellHardnessSecondIter)
      call newData(self%kTO, num, thirdOrderAtomWise)

   end subroutine initCoulomb

   subroutine initPlusU(self, num, nshell, avcn, diagonal_scal, simple_q_scal,  &
         & quadratic_q_scal, shell_level, atomic_radius, at_radius_cn_scal)

      !> Data instance
      type(TPlusU), intent(out) :: self
      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)
      !> Number of shells for each atom
      integer, intent(in) :: nshell(:)
      !> Average coordination number
      real(wp), intent(in) :: avcn(:)
      !> Scaling factor for the diagonal element of the +U matrix
      real(wp), intent(in) :: diagonal_scal(:)
      !> Scaling factor for the simple charge dependence of the +U matrix
      real(wp), intent(in) :: simple_q_scal(:)
      !> Scaling factor for the quadratic charge dependence of the +U matrix
      real(wp), intent(in) :: quadratic_q_scal(:)
      !> Shell level for +U matrix
      real(wp), intent(in) :: shell_level(:, :)
      !> Atomic radii for +U
      real(wp), intent(in) :: atomic_radius(:)
      !> Scaling factor for the atomic radii dependent on the coordination number
      real(wp), intent(in) :: at_radius_cn_scal(:)

      call newData(self%avcn, num, avcn)
      call newData(self%cud, num, diagonal_scal)
      call newData(self%cu1, num, simple_q_scal)
      call newData(self%cu2, num, quadratic_q_scal)
      call newData(self%cueffl, num, nshell, shell_level)
      call newData(self%ar, num, atomic_radius)
      call newData(self%arcn, num, at_radius_cn_scal)

   end subroutine initPlusU

   subroutine initResponse(self, num, nshell, wolfsberg_response, es_pot_mixing, &
         & plusu_diag_scaling )
      !> Data instance
      type(TResponse), intent(out) :: self
      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)
      !> Number of shells for each general species
      integer, intent(in) :: nshell(:)
      !> Wolfsberg parameter for response approximation H0
      real(wp), intent(in) :: wolfsberg_response(:)
      !> Mixing parameter for the field-free electrostatic potential
      real(wp), intent(in) :: es_pot_mixing(:)
      !> Scaling factor for the diagonal element of the +U matrix
      real(wp), intent(in) :: plusu_diag_scaling(:)
      !> Dummy for parameter transformation
      real(wp), allocatable :: tmp(:)

      call newData(tmp, num, wolfsberg_response)
      call AtomicToShellData(self%kares, num, nshell, tmp)

      call newData(self%cvesres, num, es_pot_mixing)
      call newData(self%kueffres, num, plusu_diag_scaling)
   end subroutine initResponse

   !> Transform a data array from angular momenta to shell number references
   subroutine angToShellData(kDat, nShell, angShell, angDat)

      !> Data in terms of shell number of each species
      real(wp), intent(out) :: kDat(:, :)

      !> Number of shells for each species
      integer, intent(in) :: nShell(:)

      !> Angular momenta of each shell
      integer, intent(in) :: angShell(:, :)

      !> Data in terms of angular momenta of each shell
      real(wp), intent(in) :: angDat(0:, :)

      integer :: nElem, iZp, iSh, lAng

      nElem = min(size(kDat, dim=2), size(nShell), size(angShell, dim=2), &
         & size(angDat, dim=2))

      kDat(:, :) = 0.0_wp
      do iZp = 1, nElem
         do iSh = 1, nShell(iZp)
            lAng = angShell(iSh, iZp)
            kDat(iSh, iZp) = angDat(lAng, iZp)
         end do
      end do

   end subroutine angToShellData

   subroutine newAtomicData(vec, num, data)

      real(wp), allocatable, intent(out) :: vec(:)

      integer, intent(in) :: num(:)

      real(wp), intent(in) :: data(:)

      allocate (vec(size(num)), source=0.0_wp)
      call getAtomicData(vec, num, data)

   end subroutine newAtomicData

   subroutine getAtomicData(vec, num, data)

      real(wp), intent(out) :: vec(:)

      integer, intent(in) :: num(:)

      real(wp), intent(in) :: data(:)

      integer :: ii, izp

      do ii = 1, size(vec, dim=1)
         izp = num(ii)
         vec(ii) = data(izp)
      end do

   end subroutine getAtomicData

   subroutine newShellData(vec, num, nshell, data)

      real(wp), allocatable, intent(out) :: vec(:, :)

      integer, intent(in) :: num(:)

      integer, intent(in) :: nshell(:)

      real(wp), intent(in) :: data(:, :)

      allocate (vec(maxval(nshell), size(num)))
      call getShellData(vec, num, nshell, data)

   end subroutine newShellData

   subroutine getShellData(vec, num, nshell, data)

      real(wp), intent(out) :: vec(:, :)

      integer, intent(in) :: num(:)

      integer, intent(in) :: nshell(:)

      real(wp), intent(in) :: data(:, :)

      integer :: ii, ish, izp

      vec(:, :) = 0.0_wp
      do ii = 1, size(vec, dim=2)
         izp = num(ii)
         do ish = 1, nshell(izp)
            vec(ish, ii) = data(ish, izp)
         end do
      end do

   end subroutine getShellData

   subroutine newAngShellData(vec, num, nshell, angmompershell, data)

      real(wp), allocatable, intent(out) :: vec(:, :)

      integer, intent(in) :: num(:)

      integer, intent(in) :: nshell(:)

      integer, intent(in) :: angmompershell(:, :)

      real(wp), intent(in) :: data(:, :)

      allocate (vec(maxval(nshell), size(num)))
      call getAngShellData(vec, num, nshell, angmompershell, data)

   end subroutine newAngShellData

   subroutine getAngShellData(vec, num, nshell, angmompershell, data)

      real(wp), intent(out) :: vec(:, :)

      integer, intent(in) :: num(:)

      integer, intent(in) :: nshell(:)

      integer, intent(in) :: angmompershell(:, :)

      real(wp), intent(in) :: data(:, :)

      integer :: ii, ish, izp, angmom

      vec(:, :) = 0.0_wp
      do ii = 1, size(vec, dim=2)
         izp = num(ii)
         do ish = 1, nshell(izp)
            angmom = angmompershell(ish, izp)
            vec(ish, ii) = data(angmom + 1, izp)
         end do
      end do

   end subroutine getAngShellData

   subroutine AtomicToShellData(vec, num, nshell, data)

      !> Data in terms of shell number of each unique species
      real(wp), allocatable, intent(out) :: vec(:, :)

      !> Atomic numbers for unique species
      integer, intent(in) :: num(:)

      !> Number of shells for each species
      integer, intent(in) :: nshell(:)

      !> Atomic data for each unique species
      real(wp), intent(in) :: data(:)
      integer :: ii, ish

      allocate (vec(maxval(nshell), size(num)), source=0.0_wp)
      do ii = 1, size(num)
         do ish = 1, maxval(nshell)
            vec(ish, ii) = data(ii)
         end do
      end do

   end subroutine AtomicToShellData

end module xtb_ptb_data

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

       module xtb_gfnff_shake
       implicit none
       integer :: shake_mode
       integer :: ncons = 0
       integer :: nconsu = 0
       integer, allocatable :: conslist(:,:)
       real*8,  allocatable :: distcons(:)
       real*8,  allocatable :: dro(:,:)
       real*8,  allocatable :: dr (:,:)
       integer, parameter :: maxcyc = 5000
       real*8, parameter :: tolshake = 1.d-6

       contains

       subroutine init_shake(nat,at,xyz,topo)
       use xtb_gfnff_topology, only : TGFFTopology
       implicit none
       type(TGFFTopology), intent(in) :: topo
       integer :: nat,at(nat)
       real*8  :: xyz(3,nat)
       real*8  :: wbo(nat,nat)
       integer :: iat,jat,i,j,jmin
       real*8  :: minrij,rij,wthr
       real*8  :: drij(3)

       integer list(nat*(nat+1)/2),lin,ij

      ncons  = topo%nbond
      allocate(conslist(2,ncons),distcons(ncons),&
     &         dro(3,ncons),dr(4,ncons))

      conslist(1:2,1:ncons)=topo%blist(1:2,1:ncons)
      do i = 1, ncons
         iat = conslist(1,i)
         jat = conslist(2,i)
         drij(1:3) = xyz(1:3,iat) - xyz(1:3,jat)
         distcons(i) = drij(1)**2 + drij(2)**2 + drij(3)**2
      enddo

      return
      end subroutine init_shake

       subroutine do_shake(nat,xyzo,xyz,velo,acc,mass,tstep)
       implicit none
       integer nat
       real*8 xyzo(3,nat),xyz(3,nat),velo(3,nat),acc(3,nat),mass(nat)
       real*8 virsh(3),tstep
       real*8 xyzt(3,nat)
       real*8 vel(3)
       integer i,icyc
       integer iat,jat
       logical conv
       real*8 maxdev
       real*8 r, dev,dist,denom
       real*8 gcons, rmi, rmj
       real*8 tau1,tau2
       integer jmaxdev

        conv = .false.
        icyc = 0

        xyzt = xyz

        tau1 = 1.d0/tstep
        tau2 = tau1*tau1

        do i = 1, ncons
         iat = conslist(1,i)
         jat = conslist(2,i)
         dro(1:3,i) = xyzo(1:3,iat) - xyzo(1:3,jat)
        enddo

!100     continue
        do  while (.not.conv.and.icyc.le.maxcyc) !goto 100

          maxdev = 0.d0

          do i = 1, ncons
           iat = conslist(1,i)
           jat = conslist(2,i)
           dr(1:3,i) = xyzt(1:3,iat) - xyzt(1:3,jat)
           dr(4,i)   = dr(1,i)**2 + dr(2,i)**2 + dr(3,i)**2
           dist = distcons(i)
           dev = abs(dr(4,i) - dist) / dist
           if(dev.gt.maxdev) then
            maxdev = dev
            jmaxdev = i
           endif
          enddo

          if(maxdev.lt.tolshake) conv = .true.

          if(.not.conv) then

           do i = 1, ncons

            iat = conslist(1,i)
            jat = conslist(2,i)
            dist = distcons(i)

            rmi = 1.d0/mass(iat)
            rmj = 1.d0/mass(jat)

            denom = 2.d0*(rmi+rmj)*(dr(1,i)*dro(1,i)+dr(2,i)*dro(2,i)+&
     &                              dr(3,i)*dro(3,i))

            gcons = (dist-dr(4,i))/denom

            xyzt(1:3,iat) = xyzt(1:3,iat) + rmi*gcons*dro(1:3,i)
            xyzt(1:3,jat) = xyzt(1:3,jat) - rmj*gcons*dro(1:3,i)

           enddo

          endif

          icyc = icyc + 1

        end do
        !if(.not.conv.and.icyc.le.maxcyc) goto 100

        if(conv) then
         velo = velo + (xyzt-xyz)*tau1
         acc  = acc  + (xyzt-xyz)*tau2
         xyz  = xyzt
        else
         write(*,*)'SHAKE did not converge! maxdev=',maxdev
         !if(maxdev.gt.1.d-3) stop 'SHAKE error too large'
        endif

       return
       end subroutine do_shake

       end module xtb_gfnff_shake

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine smatinv (a,ldm,n,d)
   implicit none
   integer, intent(in) :: ldm, n
   real*8, intent(out)   :: d
   real*4, intent(inout) :: a(ldm,*)
   integer             :: i, j, k, l(n), m(n)
   real*8                :: biga, temp
   real*8, parameter     :: tol = 1.0d-12

   d = 1.0

   do k = 1, n
      l(k) = k
      m(k) = k
      biga = a(k,k)
      do j = k, n
         do i = k, n
            if ( abs(biga).lt.abs(a(j,i)) ) then
               biga = a(j,i)
               l(k) = i
               m(k) = j
            end if
         end do
      end do
      j = l(k)
      if ( j.gt.k ) then
         do i = 1, n
            temp = -a(i,k)
            a(i,k) = a(i,j)
            a(i,j) = temp
         end do
      end if
      i = m(k)
      if ( i.gt.k ) then
         do j = 1, n
            temp = -a(k,j)
            a(k,j) = a(i,j)
            a(i,j) = temp
         end do
      end if
      if ( abs(biga).lt.tol ) then
         d = 0.0
         return
      end if
      do i = 1, n
         if ( i.ne.k ) a(k,i) = a(k,i)/(-biga)
      end do
      do i = 1, n
         do j = 1, n
            if ( i.ne.k ) then
               if ( j.ne.k ) a(j,i) = a(k,i)*a(j,k) + a(j,i)
            end if
         end do
      end do
      do j = 1, n
         if ( j.ne.k ) a(j,k) = a(j,k)/biga
      end do
      d = max(-1.0d25,min(1.0d25,d))
      d = d*biga
      a(k,k) = 1.0/biga
   end do
   !
   k = n
   do
      !
      k = k - 1
      if ( k.le.0 ) exit
      i = l(k)
      if ( i.gt.k ) then
         do j = 1, n
            temp = a(k,j)
            a(k,j) = -a(i,j)
            a(i,j) = temp
         end do
      end if
      j = m(k)
      if ( j.gt.k ) then
         do i = 1, n
            temp = a(i,k)
            a(i,k) = -a(i,j)
            a(i,j) = temp
         end do
      end if
   end do
   !
end subroutine

subroutine dmatinv (a,ldm,n,d)
   implicit none
   integer, intent(in) :: ldm, n
   real*8, intent(out)   :: d
   real*8, intent(inout) :: a(ldm,*)
   integer             :: i, j, k, l(n), m(n)
   real*8                :: biga, temp
   real*8, parameter     :: tol = 1.0d-12
   !
   d = 1.0
   !
   do k = 1, n
      l(k) = k
      m(k) = k
      biga = a(k,k)
      do j = k, n
         do i = k, n
            if ( abs(biga).lt.abs(a(j,i)) ) then
               biga = a(j,i)
               l(k) = i
               m(k) = j
            end if
         end do
      end do
      j = l(k)
      if ( j.gt.k ) then
         do i = 1, n
            temp = -a(i,k)
            a(i,k) = a(i,j)
            a(i,j) = temp
         end do
      end if
      i = m(k)
      if ( i.gt.k ) then
         do j = 1, n
            temp = -a(k,j)
            a(k,j) = a(i,j)
            a(i,j) = temp
         end do
      end if
      if ( abs(biga).lt.tol ) then
         d = 0.0
         return
      end if
      do i = 1, n
         if ( i.ne.k ) a(k,i) = a(k,i)/(-biga)
      end do
      do i = 1, n
         do j = 1, n
            if ( i.ne.k ) then
               if ( j.ne.k ) a(j,i) = a(k,i)*a(j,k) + a(j,i)
            end if
         end do
      end do
      do j = 1, n
         if ( j.ne.k ) a(j,k) = a(j,k)/biga
      end do
      d = max(-1.0d25,min(1.0d25,d))
      d = d*biga
      a(k,k) = 1.0/biga
   end do
   !
   k = n
   do
      !
      k = k - 1
      if ( k.le.0 ) exit
      i = l(k)
      if ( i.gt.k ) then
         do j = 1, n
            temp = a(k,j)
            a(k,j) = -a(i,j)
            a(i,j) = temp
         end do
      end if
      j = m(k)
      if ( j.gt.k ) then
         do i = 1, n
            temp = a(i,k)
            a(i,k) = -a(i,j)
            a(i,j) = temp
         end do
      end if
   end do
   !
end subroutine

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_dipro
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed, skip_test
   use xtb_features, only : get_xtb_feature
   implicit none
   private

   public :: collect_dipro

contains

!> Collect all exported unit tests
subroutine collect_dipro(testsuite)
   type(unittest_type),allocatable,intent(out) :: testsuite(:)
      !! array of objects(unit tests)

   testsuite = [ &
         !! function that registers a new unit test -> result unittest_type object
      new_unittest("J_ab,eff", test_dipro_jabeff) &
      ]

end subroutine collect_dipro

!---------------------------------------------
! Unit test for dipro
!---------------------------------------------
subroutine test_dipro_jabeff(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_convert, only : aatoau

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_basisset
   use xtb_type_environment
   use xtb_setparam
   
   use xtb_dipro, only: get_jab, jab_input
   use xtb_tblite_calculator, only : TTBLiteCalculator, TTBLiteInput, newTBLiteWavefunction
   use xtb_io_writer 
   use xtb_mctc_filetypes, only : filetype
   type(error_type), allocatable, intent(out) :: error
   type(TMolecule)  :: mol
   type(TEnvironment)       :: env
   type(jab_input)  :: dipro
   type(TTBLiteInput) :: tblite

   real(wp), parameter :: thr = 0.002_wp
   !> Molecular structure data
   integer, parameter :: nat = 26
   !> fragments to be determined in call get_jab
   integer, allocatable :: splitlist(:)
      !! benzene - nitrobenzene cofacial dimer
   integer, parameter :: at(nat) = [6,6,6,6,6,6,1,1,1,1,1,6,6,6,6,6,6,1,1,1,1,1,1,7,8,8]
   real(wp), parameter :: xyz(3,nat) = reshape(aatoau*[&
      &  -1.20618_wp,  0.69599_wp,  1.75211_wp, &
      &  -1.20379_wp, -0.70017_wp,  1.75215_wp, &
      &   0.00616_wp, -1.39690_wp,  1.75210_wp, &
      &   1.21824_wp, -0.70002_wp,  1.75171_wp, &
      &   1.23033_wp,  0.70989_wp,  1.75117_wp, &
      &   0.00125_wp,  1.40067_wp,  1.75172_wp, &
      &   2.14504_wp, -1.25925_wp,  1.74975_wp, &
      &  -0.02278_wp,  2.48280_wp,  1.74976_wp, &
      &  -2.14520_wp,  1.23405_wp,  1.75041_wp, &
      &  -2.14028_wp, -1.24255_wp,  1.75044_wp, &
      &   0.00554_wp, -2.47919_wp,  1.75040_wp, &
      &  -1.21072_wp,  0.69984_wp, -1.75114_wp, &
      &  -1.21074_wp, -0.69902_wp, -1.75149_wp, &
      &   0.00072_wp, -1.39843_wp, -1.75114_wp, &
      &   1.21220_wp, -0.69897_wp, -1.75037_wp, &
      &   1.21222_wp,  0.69988_wp, -1.74995_wp, &
      &   0.00077_wp,  1.39929_wp, -1.75036_wp, &
      &   2.14941_wp, -1.24008_wp, -1.74839_wp, &
      &   2.14945_wp,  1.24099_wp, -1.74755_wp, &
      &   0.00077_wp,  2.48148_wp, -1.74837_wp, &
      &  -2.14799_wp,  1.24091_wp, -1.74971_wp, &
      &  -2.14800_wp, -1.24014_wp, -1.75028_wp, &
      &   0.00066_wp, -2.48066_wp, -1.74972_wp, &
      &   2.46723_wp,  1.42685_wp,  1.74737_wp, &
      &   2.47280_wp,  2.62117_wp,  1.74468_wp, &
      &   3.50640_wp,  0.83800_wp,  1.74471_wp], shape(xyz))
   
   if (.not.get_xtb_feature('tblite')) then
      call skip_test(error, 'tblite libary not available.')
      return
   end if

   call init(env)
      !! construct calculation environment

   call init(mol, at, xyz)
      !! construct molecular structure type
      !! interface to initMoleculeNumbers
   mol%chrg = 0.0_wp
   tblite%method = 'gfn2'
   dipro%othr = 0.1_wp
   
   call get_jab(env,tblite,mol,splitlist,dipro)
   call check_(error,dipro%totjab(1),0.119_wp, thr=thr)

endsubroutine test_dipro_jabeff

end module test_dipro

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

! shift the LP=protonation position to an "empty" region
subroutine shiftlp(n,at,ia1,xyz,ex,ey,ez)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer n,at(n),ia1
   real(wp) xyz(3,n),ex,ey,ez

   real(wp) r0,r1,r2,exmin,eymin,ezmin,rmin,xsave,ysave,zsave,rmax
   real x,f
   integer icount,j

   r0=2.5d0
   rmin=1.d+42
   rmax=0
   icount=0

   10  f=1.0
   call random_number(x)
   if(x.lt.0.5)f=-1.0
   call random_number(x)
   ex=xyz(1,ia1)+x*f*r0
   call random_number(x)
   ey=xyz(2,ia1)+x*f*r0
   call random_number(x)
   ez=xyz(3,ia1)+x*f*r0
   r1=sqrt((xyz(1,ia1)-ex)**2+(xyz(2,ia1)-ey)**2+(xyz(3,ia1)-ez)**2)
   if(abs(r0-r1).gt.0.1) goto 10
   rmin=1.d+42
   do j=1,n
      r2=sqrt((xyz(1,j)-ex)**2+(xyz(2,j)-ey)**2+(xyz(3,j)-ez)**2)
      if(r2.lt.rmin.and.j.ne.ia1) then
         rmin=r2
         exmin=ex
         eymin=ey
         ezmin=ez
      endif
   enddo
   if(rmin.gt.rmax)then
      rmax=rmin
      xsave=exmin
      ysave=eymin
      zsave=ezmin
   endif
   icount=icount+1
   if(icount.lt.100) goto 10

   ex=xsave
   ey=ysave
   ez=zsave

end subroutine

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine enso_printout(iunit,res)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_data

   implicit none

   integer,intent(in) :: iunit
   type(freq_results),intent(in) :: res

   write(iunit,'("{")')
   write(iunit,'(3x,"""",a,""":",f21.12,",")') "temperature",res%temp
   write(iunit,'(3x,"""",a,""": """,a,""",")') "unit","hartree"
   write(iunit,'(3x,"""",a,""":",f21.12,",")') "energy",res%etot
   write(iunit,'(3x,"""",a,""":",f21.12,",")') "free energy",res%gtot+res%etot
   write(iunit,'(3x,"""",a,""":",f21.12,",")') "G(T)",res%gtot
   write(iunit,'(3x,"""",a,""":",f21.12,",")') "ZPVE", res%zp
   write(iunit,'(3x,"""",a,""":",i0,",")')     "number of imags",res%nimag
   write(iunit,'(3x,"""",a,""": """,a,""",")') "point group",res%pg
   write(iunit,'(3x,"""",a,""":",f21.12)')     "gradient norm",res%gnorm
   write(iunit,'("}")')

end subroutine enso_printout

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

recursive subroutine qsort(a, first, last, ind)
  use xtb_mctc_accuracy, only : wp
  implicit none
  real(wp) :: a(*), x, t
  integer  :: ind(*)
  integer  :: first, last
  integer  :: i, j, ii

  x = a( (first+last) / 2 )
  i = first
  j = last
  do
     do while (a(i) < x)
        i=i+1
     end do
     do while (x < a(j))
        j=j-1
     end do
     if (i >= j) exit
     t = a(i);  a(i) = a(j);  a(j) = t
     ii=ind(i); ind(i) = ind(j);  ind(j) = ii
     i=i+1
     j=j-1
  end do
  if (first < i-1) call qsort(a, first, i-1, ind)
  if (j+1 < last)  call qsort(a, j+1, last, ind)
end subroutine qsort

recursive subroutine qqsort(a, first, last)
   use xtb_mctc_accuracy, only : wp
  implicit none
  real(wp) :: a(*), x, t
  integer  :: first, last
  integer  :: i, j, ii

  x = a( (first+last) / 2 )
  i = first
  j = last
  do
     do while (a(i) < x)
        i=i+1
     end do
     do while (x < a(j))
        j=j-1
     end do
     if (i >= j) exit
     t = a(i);  a(i) = a(j);  a(j) = t
     i=i+1
     j=j-1
  end do
  if (first < i-1) call qqsort(a, first, i-1)
  if (j+1 < last)  call qqsort(a, j+1, last)
end subroutine qqsort

! This file is part of xtb.
!
! Copyright (C) 2017-2019 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_dispersionmodel
   use xtb_mctc_accuracy, only : wp
   implicit none
   public :: TDispersionModel, init
   private

   integer, parameter :: max_elem = 118

   type :: TDispersionModel
      real(wp) :: g_a = 0.0_wp
      real(wp) :: g_c = 0.0_wp
      integer, allocatable :: atoms(:)
      integer, allocatable :: nref(:)
      integer, allocatable :: ncount(:, :)
      real(wp), allocatable :: cn(:, :)
      real(wp), allocatable :: q(:, :)
      real(wp), allocatable :: alpha(:, :, :)
      real(wp), allocatable :: c6(:, :, :, :)
   end type TDispersionModel

   interface init
      module procedure :: initDispersionModel
   end interface init

contains

subroutine initDispersionModel(self, maxElem, maxRef, maxFreq)
   type(TDispersionModel), intent(out) :: self
   integer, intent(in), optional :: maxElem
   integer, intent(in), optional :: maxRef
   integer, intent(in), optional :: maxFreq
   integer :: elem, ref, freq
   if (present(maxElem)) then
      elem = maxElem
   else
      elem = 118
   end if
   if (present(maxRef)) then
      ref = maxRef
   else
      ref = 7
   end if
   if (present(maxFreq)) then
      freq = maxFreq
   else
      freq = 23
   end if
   allocate(self%atoms(elem), source=0)
   allocate(self%nref(elem), source=0)
   allocate(self%ncount(ref, elem), source=0)
   allocate(self%cn(ref, elem), source=0.0_wp)
   allocate(self%q(ref, elem), source=0.0_wp)
   allocate(self%alpha(freq, ref, elem), source=0.0_wp)
   allocate(self%c6(ref, ref, elem, elem), source=0.0_wp)
end subroutine initDispersionModel

end module xtb_type_dispersionmodel

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_grad_core
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : evtoau
   use xtb_xtb_data

   use xtb_mctc_la

!! ========================================================================
!  we use the complete xtb_scc_core, so we inherit all interfaces and all
!  parameters. Therefore, we don't need to declare them again, note that
!  by including the xtb_grad_core you also inherit the xtb_scc_core!
   use xtb_scc_core

   implicit none

   integer, private, parameter :: mmm(20)=(/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/)

contains

!! ========================================================================
!  derivative of S(R) enhancement factor
!! ========================================================================
pure subroutine dshellPoly(iPoly,jPoly,iRad,jRad,rab2,xyz1,xyz2,rf,dxyz)
   !$acc routine seq
   real(wp), intent(in)  :: iPoly,jPoly
   real(wp), intent(in)  :: iRad,jRad
   real(wp), intent(in)  :: rab2
   real(wp), intent(out) :: dxyz(3),rf
   real(wp), intent(in)  :: xyz1(3),xyz2(3)
   real(wp) :: rab,k1,k2,rr,r,a,dum,rf1,rf2,dx,dy,dz
   real(wp) :: t14,t15,t17,t22,t20,t23,t10,t11,t35,t13

   a=0.5            ! R^a dependence 0.5 in GFN1

   dx=xyz1(1)-xyz2(1)
   dy=xyz1(2)-xyz2(2)
   dz=xyz1(3)-xyz2(3)

   rab=sqrt(rab2)

   ! this sloppy conv. factor has been used in development, keep it
   r=iRad+jRad

   rr=rab/r

   k1=iPoly*0.01_wp
   k2=jPoly*0.01_wp

   t14 = rr**a
   t15 = k1*t14
   t17 = 1.0_wp/rab2
   t22 = rr**a
   t23 = k2*t22
   rf=(1.0_wp+t15)*(1.0_wp+k2*t22)
   dxyz(:)=(t15*(1.0_wp+t23)+(1.0_wp+t15)*k2*t22)*a*t17*[dx,dy,dz]

end subroutine dshellPoly

end module xtb_grad_core

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_la
   use xtb_mctc_accuracy, only : wp, sp, dp
   use xtb_mctc_lapack
   use xtb_mctc_blas
   use xtb_mctc_blas_wrap3, only : contract => mctc_gemm
   use xtb_mctc_blas_wrap2, only : contract => mctc_gemv
   implicit none
   public ! Forward lapack/blas module

   private :: wp, sp, dp




   interface htosq
      module procedure dhtosq
   end interface htosq

   interface syprj
      module procedure dsyprj
   end interface syprj

   interface blckmgs
      module procedure dblckmgs
   end interface blckmgs


contains


subroutine dhtosq(n,a,b)
   implicit none
! ---------------------------------------------------------------------
!      expand trigonal matrix b to full matrix a
!      a and b may refer to the same address
! ---------------------------------------------------------------------
   integer, intent(in)  :: n
   real(dp),intent(out) :: a(n,n)
   real(dp),intent(in)  :: b(n*(n+1)/2)
   integer :: i,j,ioff

   do i=n,1,-1
      ioff=i*(i-1)/2
      do j=i,1,-1
         a(j,i)=b(ioff+j)
      enddo
   enddo

   do i=1,n
      do j=1,i-1
         a(i,j)=a(j,i)
      enddo
   enddo

end subroutine dhtosq

subroutine dsyprj(nbdim,m,bmat,n,asym)
!----------------------------------------------------------------------
! Purpose:
! Performs projection of a real symmetric matrix asym packed in an
! upper triangular form:
! asym = (1 - bmat*bmat')*asym*(1 - bmat*bmat')
! where (1 - bmat*bmat') is a projector constructed from bmat
! The matrix asym is overwritten on output; bmat is left unchanged.
! Operation count is proportional to n*n*m
!
! Input/Output:
! nbdim - First dimension of bmat as declared in the calling routine
! m     - Number of columns in the matrix bmat
! bmat  - n*m matrix used to build projector
! n     - Dimension of the matrix asym
! asym  - Symmetric matrix in packed upper triangular form
!----------------------------------------------------------------------
  implicit none

! Input/Output:
  integer, intent(in)    :: nbdim,m,n
  real(dp),intent(in)    :: bmat(nbdim,m)
  real(dp),intent(inout) :: asym(n*(n+1)/2)

! Local:
  integer  :: i,j,ij
  real(dp),allocatable :: scrb(:,:)
  real(dp),allocatable :: scra(:,:)
!----------------------------------------------------------------------
  allocate( scrb(n,m), scra(n,n) )

! Expand trigonal matrix asym to full matrix on scra
  call htosq(n,scra,asym)

! Calculate scrb = asym*bmat
  call blas_symm('l','u',n,m,1.0_dp,scra,n,bmat,nbdim,0.0_dp,scrb,n)
  
! Calculate scra = scrb*bmat'
  call blas_gemm('n','t',n,n,m,1.0_dp,scrb,n,bmat,nbdim,0.0_dp,scra,n)

! Calculate asym = asym - scra - scra'
  do i=1,n
     do j=1,i
        ij = i*(i-1)/2 + j
        asym(ij) = asym(ij) - scra(i,j) - scra(j,i)
     end do
  end do
     
! Calculate scrb' = scra'*bmat
  call blas_gemm('t','n',n,m,n,1.0_dp,scra,n,bmat,nbdim,0.0_dp,scrb,n)

! Calculate scra = bmat*scrb'
  call blas_gemm('n','t',n,n,m,1.0_dp,bmat,nbdim,scrb,n,0.0_dp,scra,n)
  
! Calculate asym = asym + scra
  do i=1,n
     do j=1,i
        ij = i*(i-1)/2 + j
        asym(ij) = asym(ij) + scra(i,j)
     end do
  end do

  deallocate( scra, scrb )
     
end subroutine dsyprj

subroutine dblckmgs(m,n,ndim,darray)
!----------------------------------------------------------------------
! Purpose:
! Subroutine performs modified Gramm-Schmidt orthonormalization of a 
! real matrix. Orthonormalization is done in-place, so the darray is 
! overwritten on exit. Linearly dependent vectors are set to zero.
!
! Input:
! m      - Number of rows in the matrix darray
! n      - Number of columns in the matrix darray
! ndim   - First array dimension as declared in the calling routine
! darray - Array to be orthonormalized
!
! Output:
! darray - Orthonormalized array
!----------------------------------------------------------------------
  implicit none

! Input/Output:
  integer, intent(in) :: m,n,ndim
  real(dp), dimension(ndim,n), intent(out) :: darray
!----------------------------------------------------------------------  
! Local:
  integer :: ii,jj,kk,ll,ibsize,nblcks,istrt,jstrt,iend,ncol,ierr
  real(dp) :: tmp
  real(dp), dimension(:,:), allocatable :: smat
!---------------------------------------------------------------------- 
! Local parameters
  real(dp) thr
! use BLAS directly without MCTC interfaces, for dirty hacks
  external dgemm ! I hope you know what you are doing...
!----------------------------------------------------------------------  

  thr = epsilon(1.0_dp) !Threshold for zero vectors
!----------------------------------------------------------------------  
! Block size optimized for Athlon 1200 MHz with 2.0GB memory for 
! matrices up to 5000x5000
  ibsize = 60
!----------------------------------------------------------------------  

!-----------------------------------------------------------------
! Allocate overlap matrix
!-----------------------------------------------------------------
  allocate(smat(ibsize,ibsize),stat=ierr)
  if(ierr /= 0)  call raise('E','Memory allocation error in blckmgs')

!-----------------------------------------------------------------
! Calculate the number of blocks
!-----------------------------------------------------------------
  nblcks = (n+ibsize-1)/ibsize
  ibsize = min(n,ibsize)

!-----------------------------------------------------------------
! Orthogonalize the first block using modified schmidt
!-----------------------------------------------------------------
  do ii=1,ibsize

     tmp = blas_dot(m,darray(:,ii),1,darray(:,ii),1)

! Linear dependence
     if(tmp < thr) then
        darray(1:m,ii) = 0.0_dp
        cycle
     end if

     tmp = 1.0_dp/sqrt(tmp)
     call blas_scal(m,tmp,darray(:,ii),1)

     do jj=ii+1,ibsize
        tmp = blas_dot(m,darray(:,ii),1,darray(:,jj),1)
        call blas_axpy(m,-tmp,darray(:,ii),1,darray(:,jj),1)
     end do

  end do

!-----------------------------------------------------------------
! Loop over remaining blocks
!-----------------------------------------------------------------
  do ii=1,nblcks-1

! Initial and final column and number of columns in the block ii+1
     istrt = ii*ibsize+1
     iend  = (ii+1)*ibsize
     iend  = min(n,iend)
     ncol  = iend - istrt + 1

! Orthogonalize the block ii+1 against the previous ones
     do jj=1,ii

! Initial index of the block jj
        jstrt = (jj-1)*ibsize+1

        call dgemm('t','n',ibsize,ncol,m,1.0_dp,darray(1,jstrt),ndim,darray(1,istrt),ndim,0.0_dp,smat,ibsize)
        call dgemm('n','n',m,ncol,ibsize,-1.0_dp,darray(1,jstrt),ndim,smat,ibsize,1.0_dp,darray(1,istrt),ndim)

     end do

! Othogonalize vectors on the block ii+1 among themself using modified schmidt
     do kk=istrt,iend

        tmp = blas_dot(m,darray(:,kk),1,darray(:,kk),1)

! Linear dependence
        if(tmp < thr) then
           darray(1:m,kk) = 0.0_dp
           cycle
        end if
     
        tmp = 1.0_dp/sqrt(tmp)
        call blas_scal(m,tmp,darray(:,kk),1)

        do ll=kk+1,iend
           tmp = blas_dot(m,darray(:,kk),1,darray(:,ll),1)
           call blas_axpy(m,-tmp,darray(:,kk),1,darray(:,ll),1)
        end do

     end do

  end do

! Clean up
  deallocate(smat,stat=ierr)
  if(ierr /= 0) call raise('E','Memory deallocation error in blckmgs')

end subroutine dblckmgs

function ssyluinv(Amat,m) result(info)
   implicit none
   integer, intent(in) :: m
   real(sp), intent(inout) :: Amat(m,m)
   integer, allocatable :: ipiv(:)
   real(sp),allocatable :: temp(:)
   real(sp),allocatable :: work(:)
   integer  :: lwork
   integer  :: info
   real(sp) :: test(1)
   integer  :: i,j

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L',m,Amat,m,ipiv,test,-1,info)
   lwork=int(test(1))
   allocate( work(lwork), source = 0.0_sp )

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L',m,Amat,m,ipiv,work,lwork,info)
   if(info > 0) return

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in Amat matrix
   ! Amat matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L',m,Amat,m,ipiv,work,info)
   if (info > 0) return

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do i = 1, m
      do j = i+1, m
         Amat(i,j)=Amat(j,i)
      enddo
   enddo

end function ssyluinv

function dsyluinv(Amat,m) result(info)
   implicit none
   integer, intent(in) :: m
   real(dp), intent(inout) :: Amat(m,m)
   integer, allocatable :: ipiv(:)
   real(dp),allocatable :: temp(:)
   real(dp),allocatable :: work(:)
   integer  :: lwork
   integer  :: info
   real(dp) :: test(1)
   integer  :: i,j

   allocate( ipiv(m), source = 0 )

   ! assume work space query, set best value to test after first dsytrf call
   call lapack_sytrf('L',m,Amat,m,ipiv,test,-1,info)
   lwork=int(test(1))
   allocate( work(lwork), source = 0.0_dp )

   ! Bunch-Kaufman factorization A = L*D*L**T
   call lapack_sytrf('L',m,Amat,m,ipiv,work,lwork,info)
   if(info > 0) return

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in Amat matrix
   ! Amat matrix is overwritten with lower triangular part of A⁻¹
   call lapack_sytri('L',m,Amat,m,ipiv,work,info)
   if (info > 0) return

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do i = 1, m
      do j = i+1, m
         Amat(i,j)=Amat(j,i)
      enddo
   enddo

end function dsyluinv


subroutine contract211(amat, bvec, cvec, alpha, beta)

   real(wp), intent(in), contiguous :: amat(:, :)
   real(wp), intent(in), contiguous :: bvec(:)
   real(wp), intent(inout), contiguous :: cvec(:)
   real(wp), intent(in), optional :: alpha
   real(wp), intent(in), optional :: beta

   integer :: nn, mm
   real(wp) :: aa, bb

   aa = 1.0_wp
   if (present(alpha)) aa = alpha
   bb = 0.0_wp
   if (present(beta)) bb = beta

   nn = size(amat, dim=1)
   mm = size(amat, dim=2)

   call blas_gemv('n', nn, mm, aa, amat, nn, bvec, 1, bb, cvec, 1)

end subroutine contract211


subroutine contract312(amat, bvec, cvec, alpha, beta)

   real(wp), intent(in), contiguous, target :: amat(:, :, :)
   real(wp), intent(in), contiguous :: bvec(:)
   real(wp), intent(inout), contiguous, target :: cvec(:, :)
   real(wp), intent(in), optional :: alpha
   real(wp), intent(in), optional :: beta
   real(wp), pointer :: aptr(:, :)
   real(wp), pointer :: cptr(:)

   integer :: nn, mm
   real(wp) :: aa, bb

   aa = 1.0_wp
   if (present(alpha)) aa = alpha
   bb = 0.0_wp
   if (present(beta)) bb = beta

   nn = size(amat, dim=1)*size(amat, dim=2)
   mm = size(amat, dim=3)
   aptr(1:size(amat, dim=1) * size(amat, dim=2), 1:size(amat, dim=3)) => amat
   cptr(1:size(cvec, dim=1) * size(cvec, dim=2)) => cvec

   call blas_gemv('n', nn, mm, aa, aptr, nn, bvec, 1, bb, cptr, 1)

end subroutine contract312


subroutine contract222(amat, bmat, cmat, alpha, beta)

   real(wp), intent(in), contiguous :: amat(:, :)
   real(wp), intent(in), contiguous :: bmat(:, :)
   real(wp), intent(inout), contiguous :: cmat(:, :)
   real(wp), intent(in), optional :: alpha
   real(wp), intent(in), optional :: beta

   integer :: nn, mm, kk
   real(wp) :: aa, bb

   aa = 1.0_wp
   if (present(alpha)) aa = alpha
   bb = 0.0_wp
   if (present(beta)) bb = beta

   nn = size(amat, dim=1)
   mm = size(amat, dim=2)
   kk = size(cmat, dim=2)

   call blas_gemm('n', 'n', nn, kk, mm, aa, amat, nn, bmat, mm, bb, cmat, nn)

end subroutine contract222


subroutine contract323(amat, bmat, cmat, alpha, beta)

   real(wp), intent(in), contiguous, target :: amat(:, :, :)
   real(wp), intent(in), contiguous :: bmat(:, :)
   real(wp), intent(inout), contiguous, target :: cmat(:, :, :)
   real(wp), intent(in), optional :: alpha
   real(wp), intent(in), optional :: beta
   real(wp), pointer :: aptr(:, :)
   real(wp), pointer :: cptr(:, :)

   integer :: nn, mm, kk
   real(wp) :: aa, bb

   aa = 1.0_wp
   if (present(alpha)) aa = alpha
   bb = 0.0_wp
   if (present(beta)) bb = beta

   nn = size(amat, dim=1)*size(amat, dim=2)
   mm = size(amat, dim=3)
   kk = size(cmat, dim=3)
   aptr(1:size(amat, dim=1) * size(amat, dim=2), 1:size(amat, dim=3)) => amat
   cptr(1:size(cmat, dim=1) * size(cmat, dim=2), 1:size(cmat, dim=3)) => cmat

   call blas_gemm('n', 'n', nn, kk, mm, aa, aptr, nn, bmat, mm, bb, cptr, nn)

end subroutine contract323



end module xtb_mctc_la

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_io_reader_turbomole
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_mctc_resize
   use xtb_mctc_symbols, only : toNumber, symbolLength
   use xtb_pbc_tools
   use xtb_readin, getline => strip_line
   use xtb_type_molecule
   use xtb_type_reader
   use xtb_type_vendordata, only : turbo_info
   implicit none
   private

   public :: readHessianTurbomole


   logical, parameter :: debug = .false.


contains


subroutine readHessianTurbomole(hessian, reader, mol, status, iomsg)
   real(wp), intent(out) :: hessian(:, :)
   type(TMolecule), intent(in) :: mol
   type(TReader), intent(inout) :: reader
   logical, intent(out) :: status
   character(len=:), allocatable, intent(out) :: iomsg
   character(len=:), allocatable :: line
   character(len=32) :: buffer
   integer :: error, ndim, ii, jj, jbatch, iline

   status = .false.
   iline = 1

   call reader%read(line, error)
   do while(error == 0)
      if (index(line, '$hessian') == 1) exit
      call reader%read(line, error)
      iline = iline + 1
   end do

   if (error /= 0) then
      iomsg = "Could not find $hessian data group"
      return
   end if

   ndim = 3*len(mol)

   rdlp: do ii = 1, ndim
      do jj = 1, ndim, 5
         call reader%read(line, error)
         iline = iline + 1
         if (error /= 0) exit rdlp
         jbatch = min(jj+4, ndim)
         read(line, '(5x, 5f15.10)', iostat=error) hessian(jj:jbatch, ii)
         if (error /= 0) exit rdlp
      end do
   end do rdlp

   if (error /= 0) then
      if (is_iostat_end(error)) then
         iomsg = "Unexpected end of file while reading hessian"
      else
         write(buffer, '(i0)') iline
         iomsg = "Failed to read hessian in line "//trim(buffer)
      end if
      return
   end if

   status = .true.

end subroutine readHessianTurbomole


end module xtb_io_reader_turbomole

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_wavefunction
   use xtb_mctc_accuracy, only : wp
   implicit none

   public :: TWavefunction

   private

   type :: TWavefunction
      
      !> number of atoms 
      integer :: n = 0
      
      !> number of electrons
      integer :: nel = 0
      
      !> number of unpaired electrons
      integer :: nopen = 0
      
      !> number of atomic orbitals
      integer :: nao = 0
         
      !> number of shells
      integer :: nshell = 0

      !> density matrix
      real(wp),allocatable :: P(:,:)    

      !> partial charges
      real(wp),allocatable :: q(:)      

      !> shell charges
      real(wp),allocatable :: qsh(:)    

      !> dipole moments
      real(wp),allocatable :: dipm(:,:) 
      
      !> quadrupole moments
      real(wp),allocatable :: qp(:,:)   
      
      !> wiberg bond orders
      real(wp),allocatable :: wbo(:,:)  
      
      !> HOMO position
      integer :: ihomo = 0,ihomoa = 0,ihomob = 0 

      !> fermi
      real(wp) :: efa = 0.0_wp, efb = 0.0_wp
      
      !> fractional occupation
      real(wp),allocatable :: focc(:)   
      
      !> alpha space
      real(wp),allocatable :: focca(:)  
      
      !> beta space
      real(wp),allocatable :: foccb(:)  
      
      !> orbital energies
      real(wp),allocatable :: emo(:)    
      
      !> molecular orbitals
      real(wp),allocatable :: C(:,:)    
   
   contains
   procedure :: allocate => allocate_wavefunction
   procedure :: deallocate => deallocate_wavefunction
   procedure :: print => print_wavefunction
   end type TWavefunction

contains

subroutine allocate_wavefunction(self,n,nshell,nao)
   class(TWavefunction),intent(inout) :: self
   integer,intent(in) :: n,nshell,nao
   self%n = n
   self%nshell = nshell
   self%nao = nao
   self%ihomo = 0
   self%ihomoa = 0
   self%ihomob = 0
   call self%deallocate
   allocate( self%P(nao,nao),  source = 0.0_wp )
   allocate( self%q(n),        source = 0.0_wp )
   allocate( self%qsh(nshell), source = 0.0_wp )
   allocate( self%dipm(3,n),   source = 0.0_wp )
   allocate( self%qp(6,n),     source = 0.0_wp )
   allocate( self%wbo(n,n),    source = 0.0_wp )
   allocate( self%focc(nao),   source = 0.0_wp )
   allocate( self%focca(nao),  source = 0.0_wp )
   allocate( self%foccb(nao),  source = 0.0_wp )
   allocate( self%emo(nao),    source = 0.0_wp )
   allocate( self%C(nao,nao),  source = 0.0_wp )
end subroutine allocate_wavefunction

subroutine deallocate_wavefunction(self)
   class(TWavefunction),intent(inout) :: self
   if(allocated(self%P))    deallocate(self%P)
   if(allocated(self%q))    deallocate(self%q)
   if(allocated(self%qsh))  deallocate(self%qsh)
   if(allocated(self%dipm)) deallocate(self%dipm)
   if(allocated(self%qp))   deallocate(self%qp)
   if(allocated(self%wbo))  deallocate(self%wbo)
   if(allocated(self%focc)) deallocate(self%focc)
   if(allocated(self%focca))deallocate(self%focca)
   if(allocated(self%foccb))deallocate(self%foccb)
   if(allocated(self%emo))  deallocate(self%emo)
   if(allocated(self%C))    deallocate(self%C)
end subroutine deallocate_wavefunction

!> print content of wavefunction (for debug)
subroutine print_wavefunction(self, level, unit)
   use iso_fortran_env, only : output_unit
   class(TWavefunction),intent(in) :: self
   integer,intent(in) :: level
   integer,intent(in),optional :: unit

   character(len=*), parameter :: fmt0 = '(3x,a,3x,i0)'
   character(len=30):: fmt1_n 
   character(len=30):: fmt1_nao 
   character(len=30):: fmt1_nshell
   integer :: out, i, ndim
   
   if (self%nao>20) then
      ndim=20
   else
      ndim=self%nao
   end if

   write(fmt1_n,'(a,i0,a)') '(3x,a,3x,',self%n,'(f6.2,1x))'
   write(fmt1_nao,'(a,i0,a)') '(3x,a,3x,',ndim,'(f6.2,1x))'
   write(fmt1_nshell,'(a,i0,a)') '(3x,a,3x,',self%nshell,'(f6.2,1x))'

   if (present(unit)) then
      out = unit
   else
      out = output_unit
   end if


   if (level >= 0 .and. level <= 2) then
      write(out, '(3x,a,/,2x,12("="))') 'Wavefunction'

      ! scalar values !
      write(out,fmt0) 'n      :', self%n
      write(out,fmt0) 'nel    :', self%nel
      write(out,fmt0) 'nopen  :', self%nopen
      write(out,fmt0) 'nao    :', self%nao
      write(out,fmt0) 'nshell :', self%nshell
      write(out,fmt0) 'ihomo  :', self%ihomo
      write(out,fmt0) 'ihomoa :', self%ihomoa
      write(out,fmt0) 'ihomob :', self%ihomob

      ! vector values !
      if (level>0) then
         write(out,fmt1_n) 'q      :', self%q
         write(out,fmt1_nshell) 'qsh    :', self%qsh
         write(out,fmt1_nao) 'focc   :', self%focc(:ndim)
         write(out,fmt1_nao) 'emo    :', self%emo(:ndim)

         ! matrix values !
         if (level>1) then
            
            write(out,'(/)')
            
            do i=1,3
               write(out,fmt1_n) 'dipm   :', self%dipm(i,:)
            end do
            
            write(out,'(/)')
            
            do i=1,6
               write(out,fmt1_n) 'qp     :', self%qp(i,:)
            end do
            
            write(out,'(/)')
            
            do i=1,ndim
               write(out,fmt1_nao) 'C      :', self%C(:ndim,i)
            end do

            write(out,'(/)')

            do i=1,ndim
               write(out,fmt1_nao) 'P      :', self%P(:ndim,i)
            end do
            
            write(out,'(/)')
            
         endif
      endif
   endif
end subroutine print_wavefunction

end module xtb_type_wavefunction

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


subroutine readl(a1,x,n)
   use xtb_mctc_accuracy, only : wp
   implicit real(wp) (a-h,o-z)
   character(*) a1
   dimension x(*)
   i=0
   is=1
   10  i=i+1
   x(i)=readaa(a1,is,ib,ie)
   if(ib.gt.0 .and. ie.gt.0) then
      is=ie
      goto 10
   endif
   n=i-1
   return
end subroutine readl


function readaa(a,istart,iend,iend2)
   use xtb_mctc_accuracy, only : wp
   implicit real(wp) (a-h,o-z)
   real(wp) readaa
   character(*) a

   NINE=ICHAR('9')
   IZERO=ICHAR('0')
   MINUS=ICHAR('-')
   IDOT=ICHAR('.')
   ND=ICHAR('D')
   NE=ICHAR('E')
   IBL=ICHAR(' ')

   iend=0
   iend2=0
   idig=0
   c1=0
   c2=0
   one=1.d0
   x = 1.d0
   nl=len(a)
   do j=istart,nl-1
      n=ichar(a(j:j))
      m=ichar(a(j+1:j+1))
      if(n.le.nine.and.n.ge.izero .or.n.eq.idot)goto 20
      if(n.eq.minus.and.(m.le.nine.and.m.ge.izero &
         & .or. m.eq.idot)) goto 20
   enddo
   readaa=0.d0
   return
   20  continue
   iend=j
   do i=j,nl
      n=ichar(a(i:i))
      if(n.le.nine.and.n.ge.izero) then
         idig=idig+1
         if (idig.gt.10) goto 60
         c1=c1*10+n-izero
      elseif(n.eq.minus.and.i.eq.j) then
         one=-1.d0
      elseif(n.eq.idot) then
         goto 40
      else
         goto 60
      endif
   enddo
   40  continue
   idig=0
   do ii=i+1,nl
      n=ichar(a(ii:ii))
      if(n.le.nine.and.n.ge.izero) then
         idig=idig+1
         if (idig.gt.10) goto 60
         c2=c2*10+n-izero
         x = x /10
      elseif(n.eq.minus.and.ii.eq.i) then
         x=-x
      else
         goto 60
      endif
   enddo
   !
   ! put the pieces together
   !
   60  continue
   readaa= one * ( c1 + c2 * x)
   do j=iend,nl
      n=ichar(a(j:j))
      iend2=j
      if(n.eq.ibl)return
      if(n.eq.nd .or. n.eq.ne) goto 57
   enddo
   return

   57  c1=0.0d0
   one=1.0d0
   do i=j+1,nl
      n=ichar(a(i:i))
      iend2=i
      if(n.eq.ibl)goto 70
      if(n.le.nine.and.n.ge.izero) c1=c1*10.0d0+n-izero
      if(n.eq.minus)one=-1.0d0
   enddo
   61  continue
   70  readaa=readaa*10**(one*c1)
   return
end function readaa

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_eeq
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed, &
      & skip_test
   implicit none
   private

   public :: collect_eeq

contains

!> Collect all exported unit tests
subroutine collect_eeq(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("water", test_eeq_water), &
      new_unittest("ewald", test_eeq_ewald), &
      new_unittest("gbsa", test_eeq_model_gbsa), &
      new_unittest("hbond", test_eeq_model_hbond), &
      new_unittest("salt", test_eeq_model_salt) &
      ]

end subroutine collect_eeq


subroutine test_eeq_water(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_coulomb_gaussian, only : TGaussianSmeared, init
   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_molecule, only : TMolecule, init, len
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_xtb_eeq
   type(error_type), allocatable, intent(out) :: error
   real(wp), parameter :: thr = 1.0e-10_wp

   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [8,1,1]
   real(wp), parameter :: xyz(3,nat) = reshape([&
      & 0.00000000000000_wp,  0.00000000000000_wp, -0.73578586109551_wp, &
      & 1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp, &
      &-1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp],&
      & shape(xyz))
   real(wp), parameter :: chi(1, 2) = reshape(&
      & [1.56866440_wp, 1.23695041_wp], [1, 2])
   real(wp), parameter :: gam(1, 2) = reshape(&
      & [0.03151644_wp,-0.35015861_wp], [1, 2])
   real(wp), parameter :: kcn(1, 2) = reshape(&
      & [0.11689703_wp, 0.04916110_wp], [1, 2])
   real(wp), parameter :: alp(1, 2) = reshape(&
      & [1.23166285_wp, 0.55159092_wp], [1, 2])

   type(TMolecule) :: mol
   type(TLatticePoint) :: latp
   type(TEnvironment) :: env
   type(TGaussianSmeared) :: coulomb
   type(TENEquilibration) :: eeq

   logical :: exitRun
   real(wp) :: energy, sigma(3,3)
   real(wp), allocatable :: trans(:,:)
   real(wp), allocatable :: cn(:), dcndr(:,:,:), dcndL(:,:,:)
   real(wp), allocatable :: q(:), dqdr(:,:,:), dqdL(:,:,:)
   real(wp), allocatable :: gradient(:,:), qsh(:)

   call init(env)

   call init(mol, at, xyz)
   call init(latp, env, mol, 40.0_wp)  ! Fixed cutoff
   call env%checkpoint("Lattice point init failed")
   call init(coulomb, env, mol, alp)
   call env%checkpoint("Coulomb evaluator init failed")
   call init(eeq, env, chi, kcn, gam)
   call env%checkpoint("EN-Equilibration init failed")

   allocate(gradient(3, nat))
   allocate(cn(nat), dcndr(3, nat, nat), dcndL(3, 3, nat))
   allocate(q(nat), dqdr(3, nat, nat), dqdL(3, 3, nat))
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call latp%getLatticePoints(trans, 40.0_wp)

   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
      & cn, dcndr, dcndL)

   call check(error, cn(1),1.9895544848535_wp,thr=thr)
   call check(error, cn(2),cn(3),             thr=thr)
   call check(error, cn(1),cn(2)+cn(3),       thr=thr)

   call check(error, dcndr(3,1,1), 0.80973198569003E-01_wp,thr=thr)
   call check(error, dcndr(1,2,1),-0.52891163425093E-01_wp,thr=thr)
   call check(error, dcndr(3,1,3), 0.40486599284501E-01_wp,thr=thr)

   call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
      & energy, gradient, sigma, q, qsh, dqdr, dqdL)
   call env%checkpoint("Charge equilibration failed")

   ! test electrostatic energy
   call check(error, energy,-0.64308088326667E-01_wp,thr=thr)

   ! test molecular gradient of ES, also check symmetry
   call check(error, gradient(3,1),-0.44053032330503E-01_wp,thr=thr)
   call check(error, gradient(3,2),gradient(3,3),           thr=thr)
   call check(error, gradient(1,2), 0.18102071270235E-01_wp,thr=thr)

   ! test for charge constraint
   call check(error, sum(q),0.0_wp,            thr=thr)
   call check(error, q(1),-0.59582744684480_wp,thr=thr)

   ! test derivative of partial charges
   call check(error, dqdr(3,1,1),-0.41466764014389E+00_wp,thr=thr)
   call check(error, dqdr(1,2,1), 0.17196993288918E+00_wp,thr=thr)
   call check(error, dqdr(1,3,2), 0.18631993794394E-01_wp,thr=thr)
   call check(error, dqdr(2,1,3), 0.00000000000000E+00_wp,thr=thr)

end subroutine test_eeq_water


subroutine test_eeq_ewald(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_coulomb_gaussian, only : TGaussianSmeared, init
   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType, &
      & cutCoordinationNumber
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_molecule, only : TMolecule, init, len
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_xtb_eeq
   use xtb_disp_ncoord
   use xtb_pbc_tools
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-9_wp
   real(wp),parameter :: thr2 = 1.0e-6_wp
   integer, parameter :: nat = 6
   integer, parameter :: at(nat) = [14,14,8,8,8,8]
   real(wp),parameter :: abc(3,nat) = reshape(&
      &[.095985472469032_wp, .049722204206931_wp, 0.10160624337938_wp, &
      & 0.54722204206931_wp, 0.52863628207623_wp, 0.38664208660311_wp, &
      & 0.29843937068984_wp, 0.39572194413818_wp, 0.20321248675876_wp, &
      & 0.23364982659922_wp, 0.85647058758674_wp, 0.31884968761485_wp, &
      & 0.72250232459952_wp, 0.65548544066844_wp, .056207709103487_wp, &
      & 0.70514214000043_wp, 0.28321754549582_wp, 0.36424822189074_wp],&
      & shape(abc))
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[ 8.7413053236641_wp,  0.0000000000000_wp,  0.0000000000000_wp,   &
      &  0.0000000000000_wp,  8.7413053236641_wp,  0.0000000000000_wp,   &
      &  0.0000000000000_wp,  0.0000000000000_wp,  8.7413053236641_wp],  &
      & shape(lattice))
   real(wp), allocatable :: xyz(:, :)
   real(wp), parameter :: chi(1, 2) = reshape(&
      & [ 1.12306840_wp, 1.56866440_wp], [1, 2])
   real(wp), parameter :: gam(1, 2) = reshape(&
      & [ 0.13155266_wp, 0.03151644_wp], [1, 2])
   real(wp), parameter :: kcn(1, 2) = reshape(&
      & [-0.04964052_wp, 0.11689703_wp], [1, 2])
   real(wp), parameter :: alp(1, 2) = reshape(&
      & [ 1.54075036_wp, 1.23166285_wp], [1, 2])

   type(TMolecule) :: mol
   type(TLatticePoint) :: latp
   type(TEnvironment) :: env
   type(TGaussianSmeared) :: coulomb
   type(TENEquilibration) :: eeq

   logical :: exitRun
   integer :: ii, jj, kk
   real(wp) :: energy, sigma(3,3)
   real(wp) :: er, el, eps(3, 3)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   real(wp), parameter :: step = 1.0e-6_wp, step2 = 0.5_wp/step
   real(wp), allocatable :: trans(:,:), trans2(:, :)
   real(wp), allocatable :: cn(:), dcndr(:,:,:), dcndL(:,:,:)
   real(wp), allocatable :: q(:), dqdr(:,:,:), dqdL(:,:,:)
   real(wp), allocatable :: gradient(:,:), qsh(:)
   real(wp), allocatable :: qr(:), ql(:)

   allocate(xyz(3, nat))
   call coord_trafo(nat, lattice, abc, xyz)

   call init(env)

   call init(mol, at, xyz, lattice=lattice)
   call init(latp, env, mol, 40.0_wp)  ! Fixed cutoff
   call env%checkpoint("Lattice point init failed")
   call init(coulomb, env, mol, alp)
   call env%checkpoint("Coulomb evaluator init failed")
   call init(eeq, env, chi, kcn, gam)
   call env%checkpoint("EN-Equilibration init failed")

   allocate(cn(nat), dcndr(3,nat,nat), dcndL(3,3,nat))
   allocate(q(nat), dqdr(3,nat,nat), dqdL(3,3,nat))
   allocate(gradient(3,nat))

   gradient = 0.0_wp
   energy = 0.0_wp
   sigma = 0.0_wp

   call latp%getLatticePoints(trans, 40.0_wp)

   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
      & cn, dcndr, dcndL)

   call check(error, cn(2),3.6864725130236_wp,thr=thr)
   call check(error, cn(5),1.0523558225297_wp,thr=thr)
   call check(error, cn(6),1.1699488478421_wp,thr=thr)

   call check(error, dcndr(2,3,2), 0.24281192795725E-02_wp,thr=thr)
   call check(error, dcndr(1,6,6), 0.42240789876965E+00_wp,thr=thr)
   call check(error, dcndr(1,1,2), 0.71913132896636E-01_wp,thr=thr)

   call check(error, dcndL(1,3,4),-0.36068395425405_wp,thr=thr)
   call check(error, dcndL(3,3,1),-0.92808088688242_wp,thr=thr)
   call check(error, dcndL(2,1,3),-0.44871260782914_wp,thr=thr)

   call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
      & energy, gradient, sigma, q, qsh, dqdr, dqdL)
   call env%checkpoint("Charge equilibration failed")

   call check(error, energy,-0.13262207653027_wp,thr=thr)

   call check(error, sum(q),0.0_wp,            thr=thr)
   call check(error, q(1), 0.56976165345597_wp,thr=thr)
   call check(error, q(3),-0.24549792737727_wp,thr=thr)
   call check(error, q(4),-0.30064628677070_wp,thr=thr)

   if (allocated(error)) return

   ! check numerical gradient
   allocate(qr(nat), ql(nat))
   do ii = 1, nat
      do jj = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call mol%update
         call coulomb%update(env, mol)
         call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
            & cn, dcndr, dcndL)
         call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
            & er, qat=qr)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) - 2*step
         call mol%update
         call coulomb%update(env, mol)
         call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
            & cn, dcndr, dcndL)
         call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
            & el, qat=ql)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call check(error, gradient(jj, ii), (er - el)*step2, thr=thr)
         do kk = 1, nat
            call check(error, dqdr(jj, ii, kk), (qr(kk) - ql(kk))*step2, thr=thr)
         end do
      end do
   end do

   if (allocated(error)) return

   ! check numerical strain derivatives
   trans2 = trans
   eps = unity
   do ii = 1, 3
      do jj = 1, ii
         er = 0.0_wp
         el = 0.0_wp
         eps(jj, ii) = eps(jj, ii) + step
         mol%lattice(:, :) = matmul(eps, lattice)
         mol%xyz(:, :) = matmul(eps, xyz)
         trans(:, :) = matmul(eps, trans2)
         call mol%update
         call coulomb%update(env, mol)
         call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
            & cn, dcndr, dcndL)
         call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
            & er, qat=qr)

         eps(jj, ii) = eps(jj, ii) - 2*step
         mol%lattice(:, :) = matmul(eps, lattice)
         mol%xyz(:, :) = matmul(eps, xyz)
         trans(:, :) = matmul(eps, trans2)
         call mol%update
         call coulomb%update(env, mol)
         call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
            & cn, dcndr, dcndL)
         call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
            & el, qat=ql)

         eps(jj, ii) = eps(jj, ii) + step

         call check(error, sigma(jj, ii), (er - el)*step2, thr=thr2)
         do kk = 1, nat
            call check(error, dqdL(jj, ii, kk), (qr(kk) - ql(kk))*step2, thr=thr2)
         end do
      end do
   end do

   if (allocated(error)) return

   ! reset energy, gradient and stress
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   trans(:, :) = trans2

   mol%lattice(:, :) = lattice
   mol%xyz(:, :) = xyz
   call mol%update
   call coulomb%update(env, mol)
   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, &
      & cn, dcndr, dcndL)
   call cutCoordinationNumber(nat, cn, dcndr, dcndL, maxCN=8.0_wp)

   call check(error, cn(2),3.6735104771649_wp,thr=thr)
   call check(error, cn(5),1.0517307940776_wp,thr=thr)
   call check(error, cn(6),1.1692040350311_wp,thr=thr)

   call check(error, dcndr(2,3,2), 0.23960452277676E-02_wp,thr=thr)
   call check(error, dcndr(1,6,6), 0.42195185201461E+00_wp,thr=thr)
   call check(error, dcndr(1,1,2), 0.70963201989459E-01_wp,thr=thr)

   call check(error, dcndL(1,3,4),-0.36002844990181_wp,thr=thr)
   call check(error, dcndL(3,3,1),-0.92527392943064_wp,thr=thr)
   call check(error, dcndL(2,1,3),-0.44767072306065_wp,thr=thr)

   call eeq%chargeEquilibration(env, mol, coulomb, cn, dcndr, dcndL, &
      & energy, gradient, sigma, q, qsh, dqdr, dqdL)
   call env%checkpoint("Charge equilibration failed")

   call check(error, energy,-0.13281818007229_wp,thr=thr)

   call check(error, gradient(2,1), 0.97364690950909E-02_wp,thr=thr)
   call check(error, gradient(1,3),-0.32536878267545E-02_wp,thr=thr)
   call check(error, gradient(3,5), 0.72645758604223E-03_wp,thr=thr)
   call check(error, gradient(1,6), 0.17141994546793E-01_wp,thr=thr)

   call check(error, sigma(1,1),-0.71215570232998E-01_wp,thr=thr)
   call check(error, sigma(2,3),-0.15833762501521E-01_wp,thr=thr)
   call check(error, sigma(3,1), 0.25423858284897E-01_wp,thr=thr)

   call check(error, sum(q),0.0_wp,            thr=thr)
   call check(error, q(1), 0.57003309593516_wp,thr=thr)
   call check(error, q(3),-0.24580661514550_wp,thr=thr)
   call check(error, q(4),-0.30087488142104_wp,thr=thr)

   call check(error, dqdr(1,4,2),-0.18544856267141E-01_wp,thr=thr)
   call check(error, dqdr(1,2,2), 0.58677578747262E-01_wp,thr=thr)
   call check(error, dqdr(3,1,4),-0.78746078692863E-01_wp,thr=thr)

   call check(error, dqdL(2,3,2),-0.21027678205985E-01_wp,thr=thr)
   call check(error, dqdL(3,2,1), 0.83475462871348E-01_wp,thr=thr)
   call check(error, dqdL(1,1,5), 0.81210808302498E-02_wp,thr=thr)

end subroutine test_eeq_ewald

subroutine test_eeq_model_gbsa(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_param
   use xtb_solv_gbsa
   use xtb_solv_input
   use xtb_solv_model
   use xtb_solv_state
   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType
   use xtb_eeq
   use xtb_chargemodel
   use xtb_solv_kernel
   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 8
   integer, parameter :: at(nat) = [82,1,1,1,1,52,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00607452450000_wp,-4.06569893412500_wp, 0.00000000000000_wp, &
      &-0.10304014450000_wp,-0.81095583012500_wp, 0.00000000000000_wp, &
      &-1.48984957750000_wp,-5.20124851012500_wp, 2.65857423800000_wp, &
      &-1.48984957750000_wp,-5.20124851012500_wp,-2.65857423800000_wp, &
      & 3.11171824650000_wp,-5.04151186112500_wp, 0.00000000000000_wp, &
      & 0.00607452450000_wp, 5.31621802187500_wp, 0.00000000000000_wp, &
      & 2.16097631450000_wp, 7.52891897087500_wp, 0.00000000000000_wp, &
      &-2.20210431050000_wp, 7.47552665287500_wp, 0.00000000000000_wp], shape(xyz))
   integer, parameter :: iunit = stdout
   real(wp),parameter :: temp = 298.15_wp

   type(TMolecule) :: mol
   type(chrg_parameter) :: chrgeq
   type(TBorn) :: gbsa
   type(TSolvInput) :: input
   type(TSolvModel) :: model
   type(TEnvironment) :: env
   real(wp), parameter :: trans(3, 1) = 0.0_wp
   real(wp) :: es,gsolv,sigma(3,3)
   real(wp),allocatable :: cn(:),dcndr(:,:,:),dcndL(:,:,:)
   real(wp),allocatable :: q(:),dqdr(:,:,:),dqdL(:,:,:),ges(:,:)

   allocate(cn(nat),dcndr(3,nat,nat),dcndL(3,3,nat), &
      & q(nat),dqdr(3,nat,nat),ges(3,nat))
   es  = 0.0_wp
   ges = 0.0_wp

   call init(env)
   call init(mol, at, xyz)

   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, cn, dcndr, dcndL)
   call check(error, cn(1),3.9364408722599_wp,thr=thr)
   call check(error, cn(6),1.9734817313511_wp,thr=thr)

   ! test CN derivative, correct summation of diagonals
   call check(error, dcndr(2,1,5),-0.30966754386801E-01_wp,thr=thr)
   call check(error, dcndr(1,3,2),-0.00000000000000E+00_wp,thr=thr)
   call check(error, dcndr(2,1,6), 0.24290126624329E-05_wp,thr=thr)

   call new_charge_model_2019(chrgeq,mol%n,mol%at)
   call eeq_chrgeq(mol,env,chrgeq,cn,dcndr,dcndL,q,dqdr,dqdL,es,ges,sigma, &
      &            .false.,.true.,.true.)

   ! test electrostatic energy
   call check(error, es,-0.10559262715710E-01_wp,thr=thr)

   ! test molecular gradient of ES, also check symmetry
   call check(error, ges(2,5), 0.45485199335534E-04_wp,thr=thr)
   call check(error, ges(3,3),-0.62757274919919E-04_wp,thr=thr)
   call check(error, ges(1,2), 0.70062774412852E-05_wp,thr=thr)

   ! test for charge constraint
   call check(error, sum(q),0.0_wp,            thr=thr)
   call check(error, q(1),0.21873929670215_wp,thr=thr)

   ! test derivative of partial charges
   call check(error, dqdr(2,1,6),-0.32458122507411E-02_wp,thr=thr)
   call check(error, dqdr(3,2,1), 0.00000000000000E+00_wp,thr=thr)
   call check(error, dqdr(1,3,2), 0.27025784902288E-03_wp,thr=thr)
   call check(error, dqdr(2,8,5), 0.36651303109315E-03_wp,thr=thr)

   es = 0.0_wp
   ges = 0.0_wp
   q = 0.0_wp
   dqdr = 0.0_wp

   input = TSolvInput(solvent='ch2cl2', alpb=.false., kernel=gbKernel%still, &
      & state=solutionState%gsolv)
   call init(model, env, input, 2)
   call newBornModel(model, env, gbsa, mol%at)
   call gbsa%update(env, mol%at, mol%xyz)

   es = gbsa%gsasa + gbsa%gshift
   ges = gbsa%dsdr
   call eeq_chrgeq(mol,env,chrgeq,gbsa,cn,dcndr,q,dqdr,es,gsolv,ges, &
      &            .false.,.true.,.true.)

   ! test electrostatic energy
   call check(error, es,-0.18723100944150E-01_wp,thr=thr)

   ! test molecular gradient of ES, also check symmetry
   call check(error, ges(2,5), 0.15098175186158E-03_wp,thr=thr)
   call check(error, ges(3,3),-0.42131892534669E-03_wp,thr=thr)
   call check(error, ges(1,2), 0.28893943115425E-04_wp,thr=thr)

   ! test for charge constraint
   call check(error, sum(q),0.0_wp,thr=thr)
   call check(error, q(1), 0.22653931001924E+00_wp,thr=thr)
   call check(error, q(2),-0.20322834228298E-01_wp,thr=thr)
   call check(error, q(3),-0.26032042423717E-01_wp,thr=thr)
   call check(error, q(4),-0.26032042423717E-01_wp,thr=thr)
   call check(error, q(5),-0.25976606121313E-01_wp,thr=thr)
   call check(error, q(6),-0.18580233359855E+00_wp,thr=thr)
   call check(error, q(7), 0.28815815576667E-01_wp,thr=thr)
   call check(error, q(8), 0.28810733199693E-01_wp,thr=thr)

   !call check(error, dqdr(2,1,6),-0.21098409244566E-02_wp,thr=thr)
   !call check(error, dqdr(3,2,1), 0.00000000000000E+00_wp,thr=thr)
   !call check(error, dqdr(1,3,2), 0.37653484040321E-03_wp,thr=thr)
   !call check(error, dqdr(2,8,5), 0.82628766939384E-03_wp,thr=thr)

   call mol%deallocate

end subroutine test_eeq_model_gbsa

subroutine test_eeq_model_hbond(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   type(error_type), allocatable, intent(out) :: error
   call skip_test(error, "Not implemented")
end subroutine test_eeq_model_hbond

subroutine test_eeq_model_salt(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_convert, only : aatoau
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_param
   use xtb_solv_gbsa
   use xtb_solv_input
   use xtb_solv_model
   use xtb_solv_state
   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType
   use xtb_eeq
   use xtb_chargemodel
   use xtb_solv_kernel
   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 12
   integer, parameter :: at(nat) = [9,1,6,6,6,6,6,6,9,1,1,9]
   real(wp),parameter :: xyz(3,nat) = reshape([&
      &-3.61707571665846_wp,-2.21326241566733_wp,-0.20914111039455_wp, &
      &-4.12085912923274_wp, 2.64361027892242_wp,-0.77360733295900_wp, &
      & 0.70571179547784_wp,-1.46804568562192_wp, 0.40260319330016_wp, &
      &-1.70284271199247_wp,-0.55881754958407_wp,-0.07245619686109_wp, &
      &-2.22721391221737_wp, 1.98624548249273_wp,-0.40689082126896_wp, &
      &-0.21016646823535_wp, 3.64828289401216_wp,-0.24136575031326_wp, &
      & 2.24393351740138_wp, 2.86731529508407_wp, 0.23334807696843_wp, &
      & 2.63467443489279_wp, 0.29590222227677_wp, 0.54871426109542_wp, &
      &-0.65510226134586_wp, 6.12711283170949_wp,-0.54503487549757_wp, &
      & 3.78023043231610_wp, 4.20058933929303_wp, 0.35763959771486_wp, &
      & 1.05737533649814_wp,-3.45504988937755_wp, 0.68084171455529_wp, &
      & 4.98699896397970_wp,-0.51782531551223_wp, 1.02289296328971_wp], shape(xyz))
   integer, parameter :: iunit = stdout
   real(wp),parameter :: temp = 298.15_wp

   type(TMolecule) :: mol
   type(chrg_parameter) :: chrgeq
   type(TBorn) :: gbsa
   type(TSolvInput) :: input
   type(TSolvModel) :: model
   type(TEnvironment) :: env
   real(wp), parameter :: trans(3, 1) = 0.0_wp
   real(wp) :: es,gsolv,sigma(3,3)
   real(wp),allocatable :: cn(:),dcndr(:,:,:),dcndL(:,:,:)
   real(wp),allocatable :: q(:),dqdr(:,:,:),dqdL(:,:,:),ges(:,:)
   real(wp),allocatable :: fgb(:,:),fhb(:)

   allocate( cn(nat),dcndr(3,nat,nat),dcndL(3,3,nat), &
      & q(nat),dqdr(3,nat,nat),ges(3,nat))
   es  = 0.0_wp
   ges = 0.0_wp

   call init(env)
   call init(mol, at, xyz)

   call getCoordinationNumber(mol, trans, 40.0_wp, cnType%erf, cn, dcndr, dcndL)

   call new_charge_model_2019(chrgeq,mol%n,mol%at)
   call eeq_chrgeq(mol,env,chrgeq,cn,dcndr,dcndL,q,dqdr,dqdL,es,ges,sigma, &
      &            .false.,.true.,.true.)

   ! test electrostatic energy
   call check(error, es,-0.64149462344256E-01_wp,thr=thr)

   ! test molecular gradient of ES, also check symmetry
   call check(error, ges(2,7),-0.52237685114757E-03_wp,thr=thr)
   call check(error, ges(3,3),-0.10347464904462E-03_wp,thr=thr)
   call check(error, ges(1,9),-0.19202182317373E-03_wp,thr=thr)

   ! test for charge constraint
   call check(error, sum(q),0.0_wp,            thr=thr)
   call check(error, q(1),-0.20644568417986E+00_wp,thr=thr)
   call check(error, q(8), 0.83875312119020E-01_wp,thr=thr)

   ! test derivative of partial charges
   call check(error, dqdr(2,2,6),-0.93834552520241E-02_wp,thr=thr)
   call check(error, dqdr(3,3,1),-0.24876158910325E-03_wp,thr=thr)
   call check(error, dqdr(1,5,2),-0.15306250365591E-01_wp,thr=thr)
   call check(error, dqdr(2,8,7),-0.92052318691156E-02_wp,thr=thr)

   es = 0.0_wp
   ges = 0.0_wp
   q = 0.0_wp
   dqdr = 0.0_wp

   input = TSolvInput(solvent='ch2cl2', alpb=.false., kernel=gbKernel%still, &
      & state=solutionState%gsolv, ionStrength=0.001_wp, ionRad=1.0_wp*aatoau)
   call init(model, env, input, 2)
   call newBornModel(model, env, gbsa, mol%at)
   call gbsa%update(env, mol%at, mol%xyz)

   es = gbsa%gsasa + gbsa%gshift
   ges = gbsa%dsdr
   call eeq_chrgeq(mol,env,chrgeq,gbsa,cn,dcndr,q,dqdr,es,gsolv,ges, &
      &            .false.,.true.,.true.)

   ! test electrostatic energy
   call check(error, es,-0.73041696453862E-01_wp,thr=thr)

   ! test molecular gradient of ES, also check symmetry
   call check(error, ges(2,7),-0.54144355306156E-03_wp,thr=thr)
   call check(error, ges(3,3),-0.13994375398115E-03_wp,thr=thr)
   call check(error, ges(1,9),-0.72309374268259E-04_wp,thr=thr)

   ! test for charge constraint
   call check(error, sum(q),0.0_wp,thr=thr)
   call check(error, q( 1),-0.22628341725089E+00_wp,thr=thr)
   call check(error, q( 2), 0.17181969742365E+00_wp,thr=thr)
   call check(error, q( 3),-0.31688852764536E-01_wp,thr=thr)
   call check(error, q( 4), 0.86131431150190E-01_wp,thr=thr)
   call check(error, q( 5),-0.31623215923196E-01_wp,thr=thr)
   call check(error, q( 6), 0.86034414210273E-01_wp,thr=thr)
   call check(error, q( 7),-0.31614086140679E-01_wp,thr=thr)
   call check(error, q( 8), 0.86132083253082E-01_wp,thr=thr)
   call check(error, q( 9),-0.22624788057207E+00_wp,thr=thr)
   call check(error, q(10), 0.17181804147276E+00_wp,thr=thr)
   call check(error, q(11), 0.17180510824691E+00_wp,thr=thr)
   call check(error, q(12),-0.22628332310549E+00_wp,thr=thr)

   ! test derivative of partial charges (still incorrect)
   !call check(error, dqdr(2,2,6),-0.88602533712134E-02_wp,thr=thr)
   !call check(error, dqdr(3,3,1),-0.38467542758235E-03_wp,thr=thr)
   !call check(error, dqdr(1,5,2),-0.13407102470387E-01_wp,thr=thr)
   !call check(error, dqdr(2,8,7),-0.84239153450647E-02_wp,thr=thr)

   call mol%deallocate

end subroutine test_eeq_model_salt
end module test_eeq

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_gfnff_eg
   
   use xtb_gfnff_ini2
   use xtb_gfnff_data, only : TGFFData
   use xtb_gfnff_neighbourlist, only : TGFFNeighbourList, new
   use xtb_gfnff_topology, only : TGFFTopology
   use xtb_solv_gbsa, only : TBorn
   use xtb_type_environment, only : TEnvironment
   use xtb_mctc_lapack, only : mctc_sytrf, mctc_sytrs
   use xtb_mctc_la , only : contract323
   use xtb_mctc_blas, only : mctc_gemv
   use xtb_param_sqrtzr4r2, only : sqrtZr4r2
   use xtb_mctc_constants, only : pi
   use xtb_param_covalentradd3, only : covalentRadD3
   use xtb_param_paulingen, only : paulingEN
   use xtb_type_neighbourlist, only : TNeighbourList
   use xtb_type_latticepoint, only : TLatticePoint, init_l
   use xtb_gfnff_neighbor
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule
   implicit none
   private
   public :: gfnff_eg, gfnff_dlogcoord, cnType, getCoordinationNumber

   interface getCoordinationNumber
      module procedure :: getCoordinationNumberLP
   end interface getCoordinationNumber

   !> Possible counting functions for calculating coordination numbers
   type :: TCNTypeEnum

      !> Counting function not specified
      integer :: invalid = 0

      !> Original DFT-D3 coordination number
      integer :: exp = 1

      !> Faster decaying error function CN, better for dense systems
      integer :: erf = 2

      !> Error function CN with covalency correction
      integer :: cov = 3

      !> Particular long-ranged version of the DFT-D3 coordination number
      integer :: gfn = 4

      !> log CN, erf fct capped at max value cnmax
      integer :: log = 5

   end type TCNTypeEnum

   !> Enumerator for different coordination number types
   type(TCNTypeEnum), parameter :: cnType = TCNTypeEnum()

   abstract interface
   !> Abstract interface for the counting function (and its derivative)
   pure function countingFunction(k, r, r0)
      import :: wp

      !> Constant for counting function
      real(wp), intent(in) :: k

      !> Actual distance
      real(wp), intent(in) :: r

      !> Critical distance
      real(wp), intent(in) :: r0

      !> Value of the counting function in the range of [0,1]
      real(wp) :: countingFunction

   end function countingFunction
   end interface

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k4=4.10451_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k5=19.08857_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k6=2*11.28174_wp**2

contains

!---------------------------------------------------
! GFN-FF
! energy and analytical gradient for given xyz and
! charge ichrg
! requires D3 ini (rcov,r2r4,copyc6) as well as
! gfnff_ini call
!
! the total energy is
! ees + edisp + erep + ebond + eangl + etors + ehb + exb + ebatm + eext
!
! uses EEQ charge and D3 routines
! basic trigonometry for bending and torsion angles
! taken slightly modified from QMDFF code
! repulsion and rabguess from xtb GFN0 part
!
! requires setup of
!     integer,allocatable :: blist(:,:)
!     integer,allocatable :: alist(:,:)
!     integer,allocatable :: tlist(:,:)
!     integer,allocatable ::b3list(:,:)
!     real(wp),allocatable:: vbond(:,:)
!     real(wp),allocatable:: vangl(:,:)
!     real(wp),allocatable:: vtors(:,:)
!     chi,gam,alp,cnf
!     repa,repz,alphanb
!
!---------------------------------------------------

subroutine gfnff_eg(env,mol,pr,n,ichrg,at,xyz,sigma,g,etot,res_gff, &
      & param,topo,neigh,nlist,efield,solvation,update,version,accuracy,minpr)

   use xtb_mctc_accuracy, only : wp
   use xtb_gfnff_param, only : gffVersion, gfnff_thresholds
   use xtb_type_data
   use xtb_type_timer
   use xtb_gfnff_gdisp0
   use xtb_mctc_constants
   use xtb_type_latticepoint
   use xtb_type_param, only : dftd_parameter 
   use xtb_type_molecule, only : TMolecule
   use xtb_gfnff_neighbor, only: TNeigh
   implicit none

   character(len=*), parameter :: source = 'gfnff_eg'
   real(wp),allocatable :: rec_tVec(:,:)
   type(TNeigh), intent(inout) :: neigh ! main type for introducing PBC
   type(dftd_parameter) :: disp_par, mcdisp_par 
   type(TMolecule), intent(in) :: mol
   type(TEnvironment), intent(inout) :: env
   type(scc_results),intent(out) :: res_gff
   type(TGFFData), intent(in) :: param
   type(TGFFTopology), intent(in) :: topo
   type(TGFFNeighbourList), intent(inout) :: nlist
   type(TBorn), allocatable, intent(inout) :: solvation
   real(wp), intent(in) :: efield(3)
   logical, intent(in) :: update
   integer, intent(in) :: version
   real(wp), intent(in) :: accuracy
   logical, intent(in), optional :: minpr

   integer n
   integer ichrg
   integer at(n)
   real*8 xyz(3,n)
   real(wp), intent(out) :: sigma(3,3) ! stress tensor
   real*8 g  (3,n)
   real*8 etot
   logical pr, exitRun

   real*8 edisp,ees,ebond,eangl,etors,erep,ehb,exb,ebatm,eext
   real*8 :: gsolv, gborn, ghb, gsasa, gshift

   integer i,j,k,l,m,ij,nd3,iTr,iTri,iTrj,iTrk,iTrl,iTrDum,wscAt,atnb,inb,nbb

   integer ati,atj,iat,jat
   integer hbA,hbB,nbk,nbnbk
   integer lin
   logical ex, require_update
   integer nhb1, nhb2, nxb
   real*8  r2,rab,qq0,erff,dd,dum1,r3(3),t8,dum,t22,t39,vec(3)
   real*8  dx,dy,dz,yy,t4,t5,t6,alpha,t20
   real*8  repab,t16,t19,t26,t27,xa,ya,za,cosa,de,t28
   real*8  gammij,eesinf,etmp,phi,valijklff
   real*8  omega,rn,dr,g3tmp(3,3),g4tmp(3,4)
   real*8 rij,drij(3,n),drijdcn(2)

   real*8, allocatable :: rinf(:,:)
   real*8, allocatable :: grab0(:,:,:), rab0(:), eeqtmp(:,:), rabdcn(:,:)
   real*8, allocatable :: cn(:), dcn(:,:,:), dcndr(:,:,:), dcndL(:,:,:), qtmp(:), dEdcn(:)
   real*8, allocatable :: hb_cn(:), hb_dcn(:,:,:), dhbcndL(:,:,:)
   real(wp), allocatable :: gTrans(:,:), rTrans(:,:) ! reciprocal, direct translation vector for ES
   real*8, allocatable :: sqrab(:), srab(:)
   real*8, allocatable :: g5tmp(:,:)
   integer,allocatable :: d3list(:,:)
   real(wp),allocatable :: xtmp(:)
   type(tb_timer) :: timer
   real(wp) :: dispthr, cnthr, repthr, hbthr1, hbthr2
   real(wp) :: dist(n,n)
   real(wp) :: ds(3,3)
   real(wp) :: convF  !convergence factor alpha, aka ewald parameter 
   logical, allocatable :: considered_ABH(:,:,:)
   real(wp) :: mcf_ees, mcf_ehb, mcf_nrep, mcf_s8
      if (version == gffVersion%mcgfnff2023) then
        mcf_nrep = 1.343608_wp        
        mcf_ees  = 0.800222_wp        
        mcf_ehb  = 0.727406_wp        
        mcf_s8   = 2.858671_wp
        mcdisp_par = dftd_parameter(s6=1.0_wp, s8=mcf_s8, a1=0.58_wp, a2=4.8_wp, s9=0.0_wp)
        disp_par   = dftd_parameter(s6=1.0_wp, s8=2.0_wp, a1=0.58_wp, a2=4.8_wp, s9=0.0_wp)
      else
        mcdisp_par = dftd_parameter(s6=1.0_wp, s8=2.0_wp, a1=0.58_wp, a2=4.8_wp, s9=0.0_wp)
        disp_par   = dftd_parameter(s6=1.0_wp, s8=2.0_wp, a1=0.58_wp, a2=4.8_wp, s9=0.0_wp)
        mcf_nrep = 1.0_wp        
        mcf_ees = 1.0_wp        
        mcf_ehb = 1.0_wp        
      endif

   call gfnff_thresholds(accuracy, dispthr, cnthr, repthr, hbthr1, hbthr2)

   vec=mol%lattice(:,1)+mol%lattice(:,2)
   ! get translation vectors within maximum cutoff, but at least central 27 cells (for 3D)
   neigh%oldCutOff=0.0_wp
   call neigh%getTransVec(env,mol,60.0_wp)

   ! get Distances between atoms for repulsion
   call neigh%getTransVec(env,mol,sqrt(repthr))

   g  =  0
   exb = 0
   ehb = 0
   erep= 0
   ees = 0
   edisp=0
   ebond=0
   eangl=0
   etors=0
   ebatm=0
   eext =0

   gsolv = 0.0d0
   gsasa = 0.0d0
   gborn = 0.0d0
   ghb = 0.0d0
   gshift = 0.0d0

   sigma = 0.0_wp 

   allocate(sqrab(n*(n+1)/2),srab(n*(n+1)/2),qtmp(n),g5tmp(3,n), &
   &         eeqtmp(2,n*(n+1)/2),d3list(2,n*(n+1)/2),dcn(3,n,n),cn(n), &
   &         dcndr(3,n,n), dcndL(3,3,n), hb_dcn(3,n,n),hb_cn(n),dhbcndL(3,3,n))

   if (pr) then   
   
      call timer%new(10 + count([allocated(solvation)]),.false.)

   else if (present(minpr)) then
   
      ! to iteration time for single cycle !
      if (minpr) then
         call timer%new(1, .false.)
         call timer%measure(1,'iter. time')
      end if
   
   endif

   if (pr) call timer%measure(1,'distance/D3 list')
   nd3=0
   do i=1,n
      ij = i*(i-1)/2
      do j=1,i
         if (j.eq.i) cycle ! dont calc distance to self for non-periodic distances (below)
         k = ij+j
         sqrab(k)=(xyz(1,i)-xyz(1,j))**2+&
         &  (xyz(2,i)-xyz(2,j))**2+&
         &  (xyz(3,i)-xyz(3,j))**2
         if(sqrab(k).lt.dispthr)then
               nd3=nd3+1
               d3list(1,nd3)=i
               d3list(2,nd3)=j
         endif
         srab (k)=sqrt(sqrab(k))
      enddo

      ! The loop above only runs over the off diagonal elements !
      ! This initializes the unitialized diagonal to zero but does not !
      ! add it to the dispersion list. !
      sqrab(ij + i) = 0.0d0
      srab(ij + i) = 0.0d0
   enddo
   if (mol%npbc.ne.0) then
   dist = 0.0_wp
   !$omp parallel do collapse(2) default(none) shared(dist,mol) &
   !$omp private(i,j)
   do i=1, mol%n
     do j=1, mol%n
       dist(j,i) = NORM2(mol%xyz(:,j)-mol%xyz(:,i))
     enddo
   enddo
   !$omp end parallel do
   endif

   if (pr) call timer%measure(1)

   !----------!
   ! Setup HB !
   !----------!

   if (pr) call timer%measure(10,'HB/XB (incl list setup)')
   if (allocated(nlist%q)) then
      nlist%initialized = size(nlist%q) == n
   end if
   call gfnff_hbset0(n,at,xyz,topo,nhb1,nhb2,nxb,neigh,nlist,hbthr1,hbthr2)
   nlist%initialized = nlist%initialized .and. nhb1 <= nlist%nhb1 &
      & .and. nhb2 <= nlist%nhb2 .and. nxb <= nlist%nxb
   require_update = .not.nlist%initialized
   if (.not.nlist%initialized) then
      if (pr) then
         write(env%unit,'(10x,"Number of HB bonds (bound hydrogen)",5x,i0,x,i0,x,i0)') &
               & nhb1
         write(env%unit,'(10x,"Number of HB bonds (unbound hydrogen)",3x,i0,x,i0,x,i0)') &
               & nhb2
         write(env%unit,'(10x,"Number of XB bonds",22x,i0,x,i0,x,i0)') &
               & nxb
      end if
      call new(nlist, n, 5*nhb1, 5*nhb2, 3*nxb)
      nlist%hbrefgeo(:, :) = xyz
   end if
   if (update .or. require_update) then
      call gfnff_hbset(n,at,xyz,topo,neigh,nlist,hbthr1,hbthr2)
   end if
   if (pr) call timer%measure(10)

   !------------!
   ! Setup GBSA !
   !------------!

   if (allocated(solvation)) then
      call timer%measure(11, "GBSA")
      call solvation%update(env, at, xyz)
      call timer%measure(11)
   endif

   !------------!
   ! REP part   !
   ! non-bonded !
   !------------!

   if (pr) call timer%measure(2,'non bonded repulsion')
   !$omp parallel do default(none) reduction(+:erep, g, sigma) &
   !$omp shared(n, at, xyz, srab, sqrab, repthr, &
   !$omp topo, param, neigh, mcf_nrep) &
   !$omp private(iat, jat, iTr, iTrDum, m, ij, ati, atj, rab, r2, r3, vec, t8, t16, t19, t26, t27)
   do iat=1,n
     do jat=1,iat
       do iTr=1, neigh%nTrans

         !First calculate erep, g and sigma
         r2=NORM2(xyz(:,iat)-xyz(:,jat)+neigh%transVec(:,iTr))**2
         
         ! cycle when above cut-off and when atom would interact with itself
         if(r2.gt.repthr .OR. r2.lt.1.0e-8_wp) cycle
        
         ! bonded repulsion is calculated seperately and therefore cycled here
         if(iTr.le.neigh%numctr) then
           if(neigh%bpair(iat,jat,iTr).eq.1) cycle ! list avoided because of memory
         endif
         ati=at(iat)
         atj=at(jat)
         rab=sqrt(r2)
         t16=r2**0.75
         t19=t16*t16
         ! alphanb is the same for all iTr>numctr
         if (iTr.gt.neigh%numctr) then
            iTrDum = neigh%numctr+1
         else
            iTrDum=iTr
         endif
         t8 =t16*topo%alphanb(iat,jat,iTrDum)
         t26=exp(-t8)*param%repz(ati)*param%repz(atj)*param%repscaln*mcf_nrep
         erep=erep+(t26/rab) !energy
         t27=t26*(1.5d0*t8+1.0d0)/t19
         r3 =(xyz(:,iat)-xyz(:,jat)+neigh%transVec(:,iTr))*t27 
         vec = xyz(:,iat)-xyz(:,jat)+neigh%transVec(:,iTr)
         sigma = sigma -(spread(r3, 1, 3)*spread(vec, 2, 3))
         g(:,iat)=g(:,iat)-r3
         g(:,jat)=g(:,jat)+r3
       enddo
     enddo
   enddo
   !$omp end parallel do
   if (pr) call timer%measure(2)

   ! just a extremely crude mode for 2D-3D conversion !
   ! i.e. an harmonic potential with estimated Re !
   if (version == gffVersion%harmonic2020) then
      ebond=0
      !$omp parallel do default(none) reduction(+:ebond, g) &
      !$omp shared(topo, param, xyz, at) private(i, iat, jat, rab, r2, r3, rn, dum)
      do i=1,topo%nbond
         iat=topo%blist(1,i)
         jat=topo%blist(2,i)
         r3 =xyz(:,iat)-xyz(:,jat)
         rab=sqrt(sum(r3*r3))
         rn=0.7*(param%rcov(at(iat))+param%rcov(at(jat)))
         r2=rn-rab
         ebond=ebond+0.1d0*r2**2  ! fixfc = 0.1
         dum=0.1d0*2.0d0*r2/rab
         g(:,jat)=g(:,jat)+dum*r3
         g(:,iat)=g(:,iat)-dum*r3
      enddo
      !$omp end parallel do
      etot = ebond + erep
      return
   endif

   !------------------------------!
   ! erf CN and gradient for disp !
   !------------------------------!

   if (mol%boundaryCondition.eq.0) then
     if (pr) call timer%measure(3,'dCN')
     call gfnff_dlogcoord(n,at,xyz,srab,cn,dcn,cnthr,param) ! new erf used in GFN0
     dhbcndL=0.0_wp
     if (sum(neigh%nr_hb).gt.0) call dncoord_erf(n,at,xyz,param%rcov,hb_cn,hb_dcn,900.0d0,topo,neigh,dhbcndL) ! HB erf CN
     if (pr) call timer%measure(3)

   else
     if (pr) call timer%measure(3,'dCN')
     if (sum(neigh%nr_hb).gt.0) call dncoord_erf(n,at,xyz,param%rcov,hb_cn,hb_dcn,900.0d0,topo,neigh,dhbcndL) ! HB erf CN
     call getCoordinationNumber(mol, neigh%nTrans, neigh%transVec, 60.0_wp, 5, cn, dcndr, dcndL, param)   
     if (pr) call timer%measure(3)
   endif

   !-----!
   ! EEQ !
   !-----!

   if (mol%boundaryCondition.eq.0) then
     if (pr) call timer%measure(4,'EEQ energy and q')
     call goed_gfnff(env,accuracy.gt.1,n,at,sqrab,srab,&         ! modified version
     &                dfloat(ichrg),eeqtmp,cn,nlist%q,ees,solvation,param,topo)  ! without dq/dr
     if (pr) call timer%measure(4)
   else
     if (pr) call timer%measure(4,'EEQ energy and q')
     call goed_pbc_gfnff(env,mol,accuracy.gt.1,n,at,dist, &
     & dfloat(ichrg),eeqtmp,cn,nlist%q,ees,solvation,param,topo, gTrans, &
     & rTrans, xtmp, convF)  ! without dq/dr
     ees = ees*mcf_ees 
     if (pr) call timer%measure(4)
   endif  

   !--------!
   ! D3(BJ) !
   !--------!

   if (mol%boundaryCondition.eq.0) then
     if (pr) call timer%measure(5,'D3')
     if(nd3.gt.0) then
        call d3_gradient(topo%dispm, n, at, xyz, nd3, d3list, topo%zetac6, &
        & param%d3r0, sqrtZr4r2, 4.0d0, param%dispscale, cn, dcn, edisp, g)
     endif
     deallocate(d3list)
     if (pr) call timer%measure(5)
    else
      ! use adjusted dispersion parameters for inter-molecular interactions
      ! calculate inter-molecular dispersion
      call d3_gradientPBC(topo%dispm, mol, topo%fraglist, neigh%nTrans, neigh%transVec, mcdisp_par, 4.0_wp, topo%zetac6, &
           & param%d3r0, 60.0_wp, .true., cn, dcndr, dcndL, edisp, g, sigma)
      ! calculate intra-molecular dispersion
      call d3_gradientPBC(topo%dispm, mol, topo%fraglist, neigh%nTrans, neigh%transVec, disp_par, 4.0_wp, topo%zetac6, &
           & param%d3r0, 60.0_wp, .false., cn, dcndr, dcndL, edisp, g, sigma)
   endif

   !---------!
   ! ES part !
   !---------!

if (mol%boundaryCondition.eq.0) then
   if (pr) call timer%measure(6,'EEQ gradient')
   !$omp parallel do default(none) reduction (+:g) &
   !$omp shared(nlist,n,sqrab,srab,eeqtmp,xyz,at) &
   !$omp private(i,j,k,ij,r3,r2,rab,gammij,erff,dd)
   do i=1,n
      k = i*(i-1)/2
      do j=1,i-1
         ij = k+j
         r2 =sqrab(ij)
         rab= srab(ij)
         gammij=eeqtmp(1,ij)
         erff  =eeqtmp(2,ij)
         dd=(2.0d0*gammij*exp(-gammij**2*r2) &
                  & /(sqrtpi*r2)-erff/(rab*r2))*nlist%q(i)*nlist%q(j)
         r3=(xyz(:,i)-xyz(:,j))*dd
         g(:,i)=g(:,i)+r3
         g(:,j)=g(:,j)-r3
      enddo
   enddo
   !$omp end parallel do
   if(.not.pr) deallocate(eeqtmp)

   if (allocated(solvation)) then
      call timer%measure(11, "GBSA")
      call solvation%addGradient(env, at, xyz, nlist%q, nlist%q, g)
      call solvation%getEnergyParts(env, nlist%q, nlist%q, gborn, ghb, gsasa, &
      & gshift)
      gsolv = gsasa + gborn + ghb + gshift
      call timer%measure(11)
   else
      gborn = 0.0d0
      ghb = 0.0d0
   endif

   do i=1,n
      qtmp(i)=nlist%q(i)*param%cnf(at(i))/(2.0d0*sqrt(cn(i))+1.d-16)
   enddo

   call mctc_gemv(dcn, qtmp, g, alpha=-1.0_wp, beta=1.0_wp)
   if (pr) call timer%measure(6)
else ! periodic case
   if (pr) call timer%measure(6,'EEQ gradient')

   call es_grad_sigma(mol, topo, nlist, rTrans, gTrans, xtmp, convF, &
              & sigma, g, mcf_ees) 
     
   if(.not.pr) deallocate(eeqtmp)

   if (allocated(solvation)) then
      call timer%measure(11, "GBSA")
      call solvation%addGradient(env, at, xyz, nlist%q, nlist%q, g)
      call solvation%getEnergyParts(env, nlist%q, nlist%q, gborn, ghb, gsasa, &
      & gshift)
      gsolv = gsasa + gborn + ghb + gshift
      call timer%measure(11)
   else
      gborn = 0.0d0
      ghb = 0.0d0
   endif

   ! qtmp =  q * dXdcn | where X is the right-hand side
   do i=1,n
      qtmp(i)=nlist%q(i)*param%cnf(at(i))/(2.0d0*sqrt(cn(i))+1.d-16)
   enddo

   call mctc_gemv(dcndr, qtmp, g, alpha=-mcf_ees, beta=1.0_wp)
   call mctc_gemv(dcndL, qtmp, sigma, alpha=-mcf_ees, beta=1.0_wp)
   
   if (pr) call timer%measure(6)
endif

   !-----------------!
   ! SRB bonded part !
   !-----------------!

   if (pr) call timer%measure(7,'bonds')
   if(neigh%nbond.gt.0)then
      ! rab0 and vbond go over nbond not atoms, vbond setup with pbc in gfnff_ini.f90
      allocate(grab0(3,n,neigh%nbond),rab0(neigh%nbond),rabdcn(2,neigh%nbond))
      rab0(:)=neigh%vbond(1,:)
      if (mol%boundaryCondition.eq.0) then
        call gfnffdrab(n,at,cn,dcn,neigh%nbond,neigh%blist,rab0,grab0,rabdcn)
      else
        call gfnffdrab(n,at,cn,dcndr,neigh%nbond,neigh%blist,rab0,grab0,rabdcn)
      endif
      deallocate(dcn, dcndr)
      allocate(dEdcn(n),source=0.0_wp)
      allocate(considered_ABH(topo%hb_mapNAB,topo%hb_mapNAB,topo%hb_mapNH), source=.false.)

     !$omp parallel do default(none) reduction(+:g, ebond, sigma, dEdcn) &
     !$omp shared(grab0, topo, neigh, param, rab0, rabdcn, xyz, at, hb_cn, hb_dcn, n, dhbcndL, considered_ABH) &
     !$omp private(i, k, iat, jat, ij, rab, rij, drij, drijdcn, t8, dr, dum, yy, &
     !$omp& dx, dy, dz, t4, t5, t6, ati, atj, iTr)
      do i=1,neigh%nbond
         jat=neigh%blist(1,i)
         iat=neigh%blist(2,i)
         iTr=neigh%blist(3,i)
         if(iTr.gt.neigh%nTrans) cycle
         ati=at(iat)
         atj=at(jat)
         ij=iat*(iat-1)/2+jat
         rab=NORM2(xyz(:,jat)-xyz(:,iat)+neigh%transVec(:,iTr))
         rij=rab0(i)
         drij=grab0(:,:,i)
         drijdcn=rabdcn(:,i)
         if (neigh%nr_hb(i).ge.1) then
           call egbond_hb(i,iat,jat,iTr,rab,rij,drij,drijdcn,hb_cn,hb_dcn,n,at,xyz,&
                &ebond,g,sigma,param,topo,neigh,dEdcn,dhbcndL,considered_ABH)
         else
           call egbond(i,iat,jat,iTr,rab,rij,drij,drijdcn,n,at,xyz,ebond,g,sigma,neigh,rab0,dEdcn)
         end if
      enddo
      !$omp end parallel do
       call mctc_gemv(dcndL, dEdcn, sigma, alpha=1.0_wp, beta=1.0_wp)

      deallocate(dcndL)
      deallocate(hb_dcn)

      ! bonded REP !
      
      !$omp parallel do default(none) reduction(+:erep, g, sigma) &
      !$omp shared(topo, param, at, xyz, neigh) &
      !$omp private(i, iTr, iat, jat, ij, xa, ya, za, dx, dy, dz, r2, rab, ati, atj, &
      !$omp& alpha, repab, t16, t19, t26, t27)
      do i=1,neigh%nbond
         jat=neigh%blist(1,i)
         iat=neigh%blist(2,i)
         iTr=neigh%blist(3,i)
         xa=xyz(1,iat)
         ya=xyz(2,iat)
         za=xyz(3,iat)
         dx=xa-xyz(1,jat)-neigh%transVec(1,iTr)
         dy=ya-xyz(2,jat)-neigh%transVec(2,iTr)
         dz=za-xyz(3,jat)-neigh%transvec(3,iTr)
         rab=NORM2(xyz(:,iat)-(xyz(:,jat)+neigh%transVec(:,iTr)))
         r2=rab**2
         ati=at(iat)
         atj=at(jat)
         alpha=sqrt(param%repa(ati)*param%repa(atj))
         repab=param%repz(ati)*param%repz(atj)*param%repscalb
         t16=r2**0.75d0
         t19=t16*t16
         t26=exp(-alpha*t16)*repab
         erep=erep+t26/rab !energy
         t27=t26*(1.5d0*alpha*t16+1.0d0)/t19
         g(1,iat)=g(1,iat)-dx*t27
         g(2,iat)=g(2,iat)-dy*t27
         g(3,iat)=g(3,iat)-dz*t27
         g(1,jat)=g(1,jat)+dx*t27
         g(2,jat)=g(2,jat)+dy*t27
         g(3,jat)=g(3,jat)+dz*t27
         sigma(1,1) = sigma(1,1) - 1.0_wp *dx*t27 *dx
         sigma(1,2) = sigma(1,2) - 1.0_wp *dx*t27 *dy
         sigma(1,3) = sigma(1,3) - 1.0_wp *dx*t27 *dz
         sigma(2,1) = sigma(2,1) - 1.0_wp *dy*t27 *dx
         sigma(2,2) = sigma(2,2) - 1.0_wp *dy*t27 *dy
         sigma(2,3) = sigma(2,3) - 1.0_wp *dy*t27 *dz
         sigma(3,1) = sigma(3,1) - 1.0_wp *dz*t27 *dx
         sigma(3,2) = sigma(3,2) - 1.0_wp *dz*t27 *dy
         sigma(3,3) = sigma(3,3) - 1.0_wp *dz*t27 *dz
      enddo
      !$omp end parallel do
   endif ! if neigh%nbond.gt.0
   if (pr) call timer%measure(7)

   !------!
   ! bend !
   !------!

   if (pr) call timer%measure(8,'bend and torsion')
   if(topo%nangl.gt.0)then
      !$omp parallel do default(none) reduction (+:eangl, g, sigma) &
      !$omp shared(n, at, xyz, topo, neigh, param, mol) &
      !$omp private(m, j, i, k, etmp, g3tmp,ds)
      do m=1,topo%nangl
         i = topo%alist(1,m)
         j = topo%alist(2,m)
         k = topo%alist(3,m)
         call egbend(m,j,i,k,n,at,xyz,etmp,g3tmp,ds,param,topo,neigh)
         g(1:3,i)=g(1:3,i)+g3tmp(1:3,1) ! alist has swapped i and j
         g(1:3,j)=g(1:3,j)+g3tmp(1:3,2) ! compared to orig gfnff
         g(1:3,k)=g(1:3,k)+g3tmp(1:3,3) ! therefore swapped i and j here too
         if(neigh%nTrans.ne.1) sigma = sigma + ds
         eangl=eangl+etmp
      enddo
      !$omp end parallel do
   endif

   !---------!
   ! torsion !
   !---------!

   if(topo%ntors.gt.0)then
      !$omp parallel do default(none) reduction(+:etors, g, sigma) &
      !$omp shared(param, topo, neigh, n, at, xyz, mol) &
      !$omp private(m, i, j, k, l,iTrl,iTrj,iTrk, etmp, g4tmp,ds)
      do m=1,topo%ntors
         i=topo%tlist(1,m)  ! is actually l  ! for out-of-plane it is correct
         j=topo%tlist(2,m)  ! is actually i  ! for out-of-plane it is correct
         k=topo%tlist(3,m)  ! is actually j  ! for out-of-plane it is correct
         l=topo%tlist(4,m)  ! is actually k  ! for out-of-plane it is correct
         iTrl= topo%tlist(6,m)
         iTrj= topo%tlist(7,m)
         iTrk= topo%tlist(8,m)
         if(iTrj.gt.neigh%nTrans.or.iTrk.gt.neigh%nTrans.or.iTrl.gt.neigh%nTrans) cycle
         call egtors(m,i,j,k,l,iTrl,iTrj,iTrk,n,at,xyz,etmp,g4tmp,ds,param,topo,neigh)
         g(1:3,i)=g(1:3,i)+g4tmp(1:3,1)
         g(1:3,j)=g(1:3,j)+g4tmp(1:3,2)
         g(1:3,k)=g(1:3,k)+g4tmp(1:3,3)
         g(1:3,l)=g(1:3,l)+g4tmp(1:3,4)
         if(neigh%nTrans.ne.1) sigma = sigma + ds
         etors=etors+etmp
       enddo
      !$omp end parallel do
   endif

   !----------------------------------------!
   ! triple bonded carbon torsion potential !
   !----------------------------------------!

   if (allocated(topo%sTorsl)) then
      m = size(topo%sTorsl(1,:))
      if (m.ne.0) then
         do i=1, m
               call sTors_eg(m, n, xyz, topo, etmp, g5tmp)
               etors = etors + etmp
               g = g + g5tmp
         enddo
      endif
   endif
   if (pr) call timer%measure(8)

   !------------!
   ! BONDED ATM !
   !------------!

   if (pr) call timer%measure(9,'bonded ATM')
   if(topo%nbatm.gt.0) then
      !$omp parallel do default(none) reduction(+:ebatm, g, sigma) &
      !$omp shared(n, at, xyz, srab, sqrab, topo, neigh, param) &
      !$omp private(i, j, k, l, iTrk, iTrl, etmp, g3tmp, ds)
      do i=1,topo%nbatm
         j=topo%b3list(1,i)
         k=topo%b3list(2,i)
         l=topo%b3list(3,i)
         iTrk=topo%b3list(4,i)
         iTrl=topo%b3list(5,i)
         call batmgfnff_eg(n,j,k,l,iTrk,iTrl,at,xyz,topo%qa,sqrab,srab,etmp,g3tmp,ds,param,neigh)
         g(1:3,j)=g(1:3,j)+g3tmp(1:3,1)
         g(1:3,k)=g(1:3,k)+g3tmp(1:3,2)
         g(1:3,l)=g(1:3,l)+g3tmp(1:3,3)
         sigma = sigma + ds
         ebatm=ebatm+etmp
      enddo
      !$omp end parallel do
   endif
   if (pr) call timer%measure(9)

   !-----!
   ! EHB !
   !-----!

   ! get correct num of transVec for hb lists (e.g. hblist1/2)
   call neigh%getTransVec(env,mol,sqrt(hbthr2))
   if (pr) call timer%measure(10,'HB/XB (incl list setup)')
   if (update.or.require_update) then
     call gfnff_hbset(n,at,xyz,topo,neigh,nlist,hbthr1,hbthr2)
   end if

   if(nlist%nhb1.gt.0) then
      !$omp parallel do default(none) reduction(+:ehb, g, sigma) &
      !$omp shared(topo,nlist, neigh, param, n, at, xyz, sqrab, srab, mcf_ehb) &
      !$omp private(i, j, k, l, iTri, iTrj, etmp, g3tmp)
      do i=1,nlist%nhb1
         j=nlist%hblist1(1,i)
         k=nlist%hblist1(2,i)
         l=nlist%hblist1(3,i)
         iTri=nlist%hblist1(4,i)
         iTrj=nlist%hblist1(5,i)
         if(iTri.gt.neigh%nTrans.or.iTrj.gt.neigh%nTrans) cycle
         call abhgfnff_eg1(n,j,k,l,iTri,iTrj,at,xyz,topo%qa,etmp,&
                 & g3tmp,param,topo,neigh,sigma, mcf_ehb)
         g(1:3,j)=g(1:3,j)+g3tmp(1:3,1)*mcf_ehb
         g(1:3,k)=g(1:3,k)+g3tmp(1:3,2)*mcf_ehb
         g(1:3,l)=g(1:3,l)+g3tmp(1:3,3)*mcf_ehb
         ehb=ehb+etmp*mcf_ehb
      enddo
      !$omp end parallel do
   endif
   exitRun=.false.
   if(nlist%nhb2.gt.0) then

      !$omp parallel do default(none) reduction(+:ehb, g, sigma) &
      !$omp shared(topo,nlist, neigh, param, n, at, xyz, sqrab, srab, exitRun, mcf_ehb) &
      !$omp private(i, j, k, l,iTrj,iTrk,iTrDum,iTr, nbb, nbk, nbnbk, atnb, etmp, g5tmp)
      do i=1,nlist%nhb2
         j=nlist%hblist2(1,i)  !   A
         k=nlist%hblist2(2,i)  !   B
         l=nlist%hblist2(3,i)  !   H -> always in central cell
         iTrj=nlist%hblist2(4,i) ! iTrA
         iTrk=nlist%hblist2(5,i) ! iTrB

         if(iTrj.gt.neigh%nTrans.or.iTrk.gt.neigh%nTrans) cycle
         ! prepare variables for check in carbonyl/nitro case !
         ! Number neighbors of C/N should be > 1 for carbonyl/nitro !
         ! get needed values for Carbonyl or Nitro case
         nbnbk=0
         if (at(k).eq.8.and.sum(neigh%nb(neigh%numnb,k,:)).eq.1) then
           nbk=0
           iTr=0 ! nbk is the first neighbor of k !
           atnb=0
           call neigh%jth_nb(n,xyz,nbk,1,k,iTr)
           ! get iTrC and cycle if out of cutoff (the cutoff used in last getTransVec call)
           iTrDum=neigh%fTrSum(iTr,iTrk)
           if(iTrDum.eq.-1.or.iTrDum.gt.neigh%nTrans)  cycle
           ! get number neighbors of neighbor of k !
           if(nbk.ne.0) then
              nbnbk=sum(neigh%nb(neigh%numnb,nbk,:))
              atnb=at(nbk)
           endif
         endif
      
         ! Carbonyl case R-C=O...H_A !
         if(at(k).eq.8.and.sum(neigh%nb(neigh%numnb,k,:)).eq.1.and.atnb.eq.6 &
               & .and.nbnbk.gt.1) then
            call abhgfnff_eg3(n,j,k,l,iTrj,iTrk,nbk,iTrDum,at,xyz,topo%qa,sqrab,&
                    & srab,etmp,g5tmp,param,topo,neigh,sigma,exitRun, mcf_ehb)
         
         ! Nitro case R-N=O...H_A !
         else if(at(k).eq.8.and.sum(neigh%nb(neigh%numnb,k,:)).eq.1.and.atnb.eq.7 &
               &  .and.nbnbk.gt.1) then
            call abhgfnff_eg3(n,j,k,l,iTrj,iTrk,nbk,iTrDum,at,xyz,topo%qa,sqrab,&
                    & srab,etmp,g5tmp,param,topo,neigh,sigma,exitRun, mcf_ehb)
         
         ! N hetero aromat !
         else if(at(k).eq.7.and.sum(neigh%nb(neigh%numnb,k,:)).eq.2) then
            call abhgfnff_eg2_rnr(n,j,k,l,iTrj,iTrk,at,xyz,topo%qa,sqrab,&
                     & srab,etmp,g5tmp,param,topo,neigh,sigma, mcf_ehb)
         
         ! default !
         else
            nbb = sum(neigh%nb(neigh%numnb,k,:))
            call abhgfnff_eg2new(n,j,k,l,iTrj,iTrk,nbb,at,xyz,topo%qa,sqrab,srab, &
               & etmp,g5tmp,param,topo,neigh,sigma, mcf_ehb)
         end if
         g=g+g5tmp*mcf_ehb
         ehb=ehb+etmp*mcf_ehb
         nlist%hbe2(i)=etmp

      enddo
      !$omp end parallel do
   endif

   !-----!
   ! EXB !
   !-----!

   if(nlist%nxb.gt.0) then
      !$omp parallel do default(none) reduction(+:exb, g, sigma) &
      !$omp shared(topo, neigh, nlist, param, n, at, xyz) &
      !$omp private(i, j, k, l, iTrk, iTrl, etmp, g3tmp)
      do i=1,nlist%nxb
         j=nlist%hblist3(1,i)   ! A in central cell
         k=nlist%hblist3(2,i)   ! B
         l=nlist%hblist3(3,i)   ! X
         iTrk=nlist%hblist3(4,i) !iTrB
         iTrl=nlist%hblist3(5,i) !iTrX
         if(iTrk.gt.neigh%nTrans.or.iTrl.gt.neigh%nTrans) cycle
         if(j.ne.0.and.k.ne.0) then
            call rbxgfnff_eg(n,j,k,l,iTrk,iTrl,at,xyz,topo%qa,etmp,g3tmp,param,neigh,sigma)
            g(1:3,j)=g(1:3,j)+g3tmp(1:3,1)
            g(1:3,k)=g(1:3,k)+g3tmp(1:3,2)
            g(1:3,l)=g(1:3,l)+g3tmp(1:3,3)
            exb=exb+etmp
            nlist%hbe3(i)=etmp
         endif
      enddo
      !$omp end parallel do
   endif
   if (pr) call timer%measure(10)


   ! external stuff !
   if(sum(abs(efield)).gt.1d-6)then
      do i=1,n
         r3(:) =-nlist%q(i)*efield(:)
         g(:,i)= g(:,i) + r3(:)
         eext = eext + r3(1)*(xyz(1,i)-topo%xyze0(1,i))+&
         &                    r3(2)*(xyz(2,i)-topo%xyze0(2,i))+&
         &                    r3(3)*(xyz(3,i)-topo%xyze0(3,i))
      enddo
   endif

   !--------------!
   ! total energy !
   !--------------!

   etot = ees + edisp + erep + ebond &
   &           + eangl + etors + ehb + exb + ebatm + eext &
   &           + gsolv

   !----------!
   ! printout !
   !----------!
   if (pr) then

      call timer%write(6,'E+G')
      if(abs(sum(nlist%q)-ichrg).gt.1.d-1) then ! check EEQ only once
         write(env%unit,*) nlist%q
         write(env%unit,*) sum(nlist%q),ichrg
         call env%error('EEQ charge constrain error', source)
         return
      endif
      r3 = 0
      do i=1,n
         r3(:) = r3(:)+nlist%q(i)*xyz(:,i)
      enddo

      ! just for fit De calc !
      sqrab = 1.d+12
      srab = 1.d+6
      cn = 0
      allocate(rinf(n,n), source=1.d+6)
      
      ! asymtotically for R=inf, Etot is the SIE contaminted EES !
      ! which is computed here to get the atomization energy De,n,at(n) !
      if (mol%boundaryCondition.eq.0) then
         call goed_gfnff(env,.true.,n,at,sqrab,srab,dfloat(ichrg),eeqtmp,cn,qtmp,eesinf,solvation,param,topo)
      else
         if(allocated(gTrans)) deallocate(gTrans)
         if(allocated(rTrans)) deallocate(rTrans)
         call goed_pbc_gfnff(env,mol,.true.,n,at,rinf, &
         & dfloat(ichrg),eeqtmp,cn,qtmp,eesinf,solvation,param,topo, gTrans, &
         & rTrans, xtmp, convF)  ! without dq/dr
      endif
      de=-(etot - eesinf)

   ! if geometry optimization !
   else if (present(minpr)) then

      if (minpr) then
         call timer%measure(1)
         ! stop timer and add tag !
         call timer%write_timing(env%unit,1) 
      endif

   endif

   ! write resusts to res type !
   res_gff%e_total = etot
   res_gff%gnorm   = sqrt(sum(g**2))
   res_gff%e_bond  = ebond
   res_gff%e_angl  = eangl
   res_gff%e_tors  = etors
   res_gff%e_es    = ees
   res_gff%e_rep   = erep
   res_gff%e_disp  = edisp
   res_gff%e_hb    = ehb
   res_gff%e_xb    = exb
   res_gff%e_batm  = ebatm
   res_gff%e_ext   = eext
   res_gff%g_hb    = ghb
   res_gff%g_born  = gborn
   res_gff%g_solv  = gsolv
   res_gff%g_shift = gshift
   res_gff%g_sasa  = gsasa

   call mctc_gemv(xyz, nlist%q, res_gff%dipole)

end subroutine gfnff_eg

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egbond(i,iat,jat,iTr,rab,rij,drij,drijdcn,n,at,xyz,e,g,sigma,neigh,rab0,dEdcn)
      implicit none
      !Dummy
      !type(TGFFTopology), intent(in) :: topo
      type(TNeigh), intent(in) :: neigh
      integer,intent(in)   :: i
      integer,intent(in)   :: n
      integer,intent(in)   :: iat
      integer,intent(in)   :: jat
      integer,intent(in)   :: at(n)
      integer,intent(in)   :: iTr
      real*8,intent(in)    :: rab
      real*8,intent(in)    :: rij
      real*8,intent(in)    :: drij(3,n)
      real*8,intent(in)    :: drijdcn(2)
      real*8,intent(in)    :: xyz(3,n)
      real(wp), intent(inout) :: dEdcn(n)
      real*8,intent(inout) :: e
      real*8,intent(inout) :: g(3,n)
      real*8,intent(inout) :: sigma(3,3)
      !Stack
      integer j,k
      real*8 dr,dum,ri(3),rj(3),rk(3),vrab(3)
      real*8 dx,dy,dz,dg(3)
      real*8 yy
      real*8 t4,t5,t6,t8
      real*8 rab0(neigh%nbond)

         t8 =neigh%vbond(2,i)
         dr =rab-rij
         dum=neigh%vbond(3,i)*exp(-t8*dr**2)
         e=e+dum                      ! bond energy
         yy=2.0d0*t8*dr*dum
         dx=-xyz(1,jat)+xyz(1,iat)-neigh%transVec(1,iTr)
         dy=-xyz(2,jat)+xyz(2,iat)-neigh%transVec(2,iTr)
         dz=-xyz(3,jat)+xyz(3,iat)-neigh%transVec(3,iTr)
         vrab(1)=dx
         vrab(2)=dy
         vrab(3)=dz
         t4=-yy*dx/rab
         t5=-yy*dy/rab
         t6=-yy*dz/rab
         dg(1)=t4
         dg(2)=t5
         dg(3)=t6
         g(1,iat)=g(1,iat)+t4 ! to avoid if in loop below
         g(2,iat)=g(2,iat)+t5
         g(3,iat)=g(3,iat)+t6
         dEdcn(iat) = dEdcn(iat) + yy*drijdcn(1)
         sigma = sigma + spread(dg,1,3)*spread(vrab,2,3)

         t4=yy*(dx/rab)
         t5=yy*(dy/rab)
         t6=yy*(dz/rab)
         dg(1)=t4
         dg(2)=t5
         dg(3)=t6
         g(1,jat)=g(1,jat)+t4 ! to avoid if in loop below
         g(2,jat)=g(2,jat)+t5
         g(3,jat)=g(3,jat)+t6
         ! 3B sigma ! product rule, rij depends on rab through cn
         dEdcn(jat) = dEdcn(jat) + yy*drijdcn(2)

         do k=1,n !3B gradient 
            dg= drij(:,k)*yy
            g(:,k)=g(:,k)+dg
            sigma = sigma + spread(dg,1,3)*spread(vrab,2,3)
         enddo

end subroutine egbond

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egbond_hb(i,iat,jat,iTr,rab,rij,drij,drijdcn,hb_cn,hb_dcn,n,at,xyz,e,&
                &g,sigma,param,topo,neigh,dEdcn,dhbcndL,considered_ABH)
      implicit none
      !Dummy
      type(TGFFData), intent(in) :: param
      type(TGFFTopology), intent(in) :: topo
      type(TNeigh), intent(in) :: neigh
      integer,intent(in)   :: i
      integer,intent(in)   :: n
      integer,intent(in)   :: iat
      integer,intent(in)   :: jat
      integer,intent(in)   :: iTr ! transVec index for jat
      integer,intent(in)   :: at(n)
      real*8,intent(in)    :: rab
      real*8,intent(in)    :: rij
      real*8,intent(in)    :: drij(3,n)
      real*8,intent(in)    :: drijdcn(2)
      real*8,intent(in)    :: xyz(3,n)
      real*8,intent(in)    :: hb_cn(n)
      real*8,intent(in)    :: hb_dcn(3,n,n)
      real(wp), intent(in) :: dhbcndL(3,3,n)
      logical, intent(inout)  :: considered_ABH(topo%hb_mapNAB,topo%hb_mapNAB,topo%hb_mapNH)! only consider ABH triplets once; indep of iTr
      real*8,intent(inout) :: e
      real*8,intent(inout) :: g(3,n)
      real*8,intent(inout) :: sigma(3,3)
      real(wp), intent(inout) :: dEdcn(n) 
      real(wp) :: rbh(3),r2
      !Stack
      integer j,k
      integer jA,jH,iTrA,iTrH,iTrB
      integer hbH,hbB,hbA
      integer mapA,mapB,mapH
      real*8 dr,dum
      real*8 dx,dy,dz,vrab(3),dg(3)
      real*8 yy,zz
      real*8 t1,t4,t5,t6,t8

         if (at(iat).eq.1) then
           hbH=iat
           hbA=jat
         else if (at(jat).eq.1) then
           hbH=jat
           hbA=iat
         else
           write(*,'(10x,"No H-atom found in this bond ",i0,1x,i0)'), iat,jat
           return
         end if

         t1=1.0-param%vbond_scale
         t8 =(-t1*hb_cn(hbH)+1.0)*neigh%vbond(2,i)
         dr =rab-rij
         dum=neigh%vbond(3,i)*exp(-t8*dr**2)
         e=e+dum                      ! bond energy
         yy=2.0d0*t8*dr*dum
         dx=-xyz(1,jat)+xyz(1,iat)-neigh%transVec(1,iTr)
         dy=-xyz(2,jat)+xyz(2,iat)-neigh%transVec(2,iTr)
         dz=-xyz(3,jat)+xyz(3,iat)-neigh%transVec(3,iTr)
         vrab(1)=dx
         vrab(2)=dy
         vrab(3)=dz
         t4=-yy*dx/rab
         t5=-yy*dy/rab
         t6=-yy*dz/rab
         dg(1)=t4
         dg(2)=t5
         dg(3)=t6
         g(1,iat)=g(1,iat)+t4 ! to avoid if in loop below
         g(2,iat)=g(2,iat)+t5
         g(3,iat)=g(3,iat)+t6
         dEdcn(iat) = dEdcn(iat) + yy*drijdcn(1)
         sigma = sigma + spread(dg,1,3)*spread(vrab,2,3)

         t4=yy*(dx/rab)
         t5=yy*(dy/rab)
         t6=yy*(dz/rab)
         dg(1)=t4
         dg(2)=t5
         dg(3)=t6
         g(1,jat)=g(1,jat)+t4 ! to avoid if in loop below
         g(2,jat)=g(2,jat)+t5
         g(3,jat)=g(3,jat)+t6
         dEdcn(jat) = dEdcn(jat) + yy*drijdcn(2)

         do k=1,n !3B gradient
            dg= drij(:,k)*yy
            g(:,k)=g(:,k)+dg
            sigma = sigma + spread(dg,1,3)*spread(vrab,2,3)
         end do

         zz=dum*neigh%vbond(2,i)*dr**2*t1
         do j=1,topo%bond_hb_nr !CN gradient
            jA = topo%bond_hb_AH(1,j)
            jH = topo%bond_hb_AH(2,j)
            iTrA=topo%bond_hb_AH(3,j)
            iTrH=topo%bond_hb_AH(4,j)
            if ((jH.eq.hbH.and.jA.eq.hbA.and.iTrA.eq.1.and.iTrH.eq.iTr).or.&
               &(jH.eq.hbH.and.jA.eq.hbA.and.iTrH.eq.1.and.iTrA.eq.iTr)) then
               dg=hb_dcn(:,hbH,hbH)*zz
               g(:,hbH)=g(:,hbH)+dg
               if(hbH.eq.iat) then  ! only hbH cf. energy -> dum above
                 !
                 sigma = sigma + zz*dhbcndL(:,:,iat)
               endif
               if(hbH.eq.jat) then ! only hbH cf. energy -> dum above
                 !
                 sigma = sigma + zz*dhbcndL(:,:,jat)
               endif
               do k=1,topo%bond_hb_Bn(j)
                  hbB = topo%bond_hb_B(1,k,j)
                  iTrB= topo%bond_hb_B(2,k,j)
                 ! only add gradient one time per ABH triple (independent of iTrB)
                  mapA=topo%hb_mapABH(hbA)
                  mapB=topo%hb_mapABH(hbB)
                  mapH=topo%hb_mapABH(hbH)
                 if(.not.considered_ABH(mapA,mapB,mapH)) then
                   considered_ABH(mapA,mapB,mapH)=.true.
                   dg=hb_dcn(:,hbB,hbH)*zz
                   g(:,hbB)=g(:,hbB)-dg
                 endif
               end do
            end if
         end do
      end subroutine egbond_hb

subroutine dncoord_erf(nat,at,xyz,rcov,cn,dcn,thr,topo,neigh,dcndL)
    
   use xtb_mctc_accuracy, only : wp
   
   implicit none
   
   type(TGFFTopology), intent(in) :: topo
   type(TNeigh), intent(in) :: neigh
   integer,intent(in)   :: nat
   integer,intent(in)   :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)  :: rcov(:)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcn(3,nat,nat)
   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out) :: dcndL(:, :, :)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr
   
   integer  :: i, j, iTrB, iTrH
   integer  :: lin,linAH
   integer  :: iat, jat
   integer  :: jA,jH
   integer  :: ati, atj
   real(wp) :: r, r2, rij(3), stress(3,3)
   real(wp) :: rcovij
   real(wp) :: dtmp, tmp
   real(wp),parameter :: hlfosqrtpi = 1.0_wp/1.77245385091_wp
   real(wp),parameter :: kn=27.5_wp
   real(wp),parameter :: rcov_scal=1.78

   cn  = 0._wp
   dcn = 0._wp
   dcndL = 0.0_wp

   do i = 1,topo%bond_hb_nr
      iat = topo%bond_hb_AH(2,i) ! H atom
      iTrH = topo%bond_hb_AH(4,i)
      ati = at(iat)
      do j = 1, topo%bond_hb_Bn(i)
         jat = topo%bond_hb_B(1,j,i) ! B atom
         iTrB = topo%bond_hb_B(2,j,i)
         atj = at(jat)
         if(iTrB.gt.neigh%nTrans.or.iTrH.gt.neigh%nTrans) cycle
         rij = (xyz(:,jat)+neigh%transVec(:,iTrB)) - (xyz(:,iat)+neigh%transVec(:,iTrH)) 
         r2  = sum( rij**2 )
         if (r2.gt.thr) cycle
         r = sqrt(r2)
         rcovij=rcov_scal*(rcov(ati)+rcov(atj))
         tmp = 0.5_wp * (1.0_wp + erf(-kn*(r-rcovij)/rcovij))
         dtmp =-hlfosqrtpi*kn*exp(-kn**2*(r-rcovij)**2/rcovij**2)/rcovij
         cn(iat) = cn(iat) + tmp
         cn(jat) = cn(jat) + tmp
         dcn(:,jat,jat)= dtmp*rij/r + dcn(:,jat,jat)
         dcn(:,iat,jat)= dtmp*rij/r + dcn(:,iat,jat)
         dcn(:,jat,iat)=-dtmp*rij/r + dcn(:,jat,iat)
         dcn(:,iat,iat)=-dtmp*rij/r + dcn(:,iat,iat)
        
         stress = spread(dtmp*rij/r, 1, 3) * spread(rij, 2, 3)
         dcndL(:, :, iat) = dcndL(:, :, iat) + stress
         if (iat.ne.jat.or.iTrH.ne.iTrB) then
           dcndL(:, :, jat) = dcndL(:, :, jat) + stress
         end if
      end do
   end do

end subroutine dncoord_erf

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egbend(m,j,i,k,n,at,xyz,e,g,ds,param,topo,neigh)
   use xtb_mctc_constants
   implicit none
   type(TGFFData), intent(in) :: param
   type(TGFFTopology), intent(in) :: topo
   type(TNeigh), intent(in) :: neigh
   integer m,n,at(n)
   integer i,j,k, dim1, dim2
   real*8 xyz(3,n),g(3,3),e,ds(3,3)

   real*8  c0,kijk,va(3),vb(3),vc(3),cosa
   real*8  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
   real*8  term1(3),term2(3),rab2,vab(3),vcb(3),rp
   real*8  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
   real*8  theta,deda(3),vlen,vp(3),et,dij,c1
   real*8  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
   real*8  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
   real*8  omega,rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
   real*8  dampjl,damp2jl,valijklff,rn
   integer :: iTrj,iTrk
   real*8  :: vTrj(3),vTrk(3)

   ds = 0.0_wp
   c0  =topo%vangl(1,m)
   kijk=topo%vangl(2,m)
   iTrj=topo%alist(4,m)
   vTrj=neigh%transVec(:,iTrj)
   iTrk=topo%alist(5,m)
   vTrk=neigh%transVec(:,iTrk)
   va(1:3) = xyz(1:3,j)+vTrj
   vb(1:3) = xyz(1:3,i)
   vc(1:3) = xyz(1:3,k)+vTrk
   call vsub(va,vb,vab,3)
   call vsub(vc,vb,vcb,3)
   rab2 = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
   rcb2 = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
   call crprod(vcb,vab,vp)
   rp = vlen(vp)+1.d-14
   call impsc(vab,vcb,cosa)
   cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
   theta= dacos(cosa)  ! angle for bond j-i-k  => va-vb-vc  (vb is in the middle)

   call gfnffdampa(at(j),at(i),rab2,dampij,damp2ij,param)
   call gfnffdampa(at(k),at(i),rcb2,dampjk,damp2jk,param)
   damp=dampij*dampjk

   if(pi-c0.lt.1.d-6)then ! linear
   dt  = theta - c0
   ea  = kijk * dt**2
   deddt = 2.d0 * kijk * dt
   else
   ea=kijk*(cosa-cos(c0))**2
   deddt=2.0d0*kijk*sin(theta)*(cos(c0)-cosa)
   endif

   e = ea * damp
   call crprod(vab,vp,deda)
   rmul1 = -deddt / (rab2*rp)
   deda = deda*rmul1
   call crprod(vcb,vp,dedc)
   rmul2 =  deddt / (rcb2*rp)
   dedc = dedc*rmul2
   dedb = deda+dedc
   term1(1:3)=ea*damp2ij*dampjk*vab(1:3)
   term2(1:3)=ea*damp2jk*dampij*vcb(1:3)
   g(1:3,1) = -dedb(1:3)*damp-term1(1:3)-term2(1:3)
   g(1:3,2) =  deda(1:3)*damp+term1(1:3)
   g(1:3,3) =  dedc(1:3)*damp+term2(1:3)
   ! loop over stress tensor dimensions
   do dim1=1, 3
     do dim2=dim1, 3
       ds(dim1,dim2) = g(dim2,1)*vb(dim1) + g(dim2,2)*va(dim1) + g(dim2,3)*vc(dim1)
     enddo
   enddo
   do dim1=1, 3
     do dim2=1, dim1-1
       ds(dim1,dim2) = ds(dim2,dim1)
     enddo
   enddo

end subroutine egbend

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egbend_nci_mul(j,i,k,vTrB,vTrC,c0,fc,n,at,xyz,e,g)

   use xtb_mctc_constants
   implicit none

   integer n,at(n)
   integer j,i,k ! B,C,H
   real*8 vTrB(3),vTrC(3)
   real*8  c0,fc
   real*8  xyz(3,n),g(3,3),e

   real*8  kijk,va(3),vb(3),vc(3),cosa
   real*8  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
   real*8  term1(3),term2(3),rab2,vab(3),vcb(3),rp
   real*8  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
   real*8  theta,deda(3),vlen,vp(3),et,dij,c1
   real*8  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
   real*8  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
   real*8  omega,rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
   real*8  dampjl,damp2jl,valijklff,rn

   kijk=fc/(cos(0.0d0)-cos(c0))**2
   va(1:3) = xyz(1:3,i)+vTrC
   vb(1:3) = xyz(1:3,j)+vTrB
   vc(1:3) = xyz(1:3,k)
   call vsub(va,vb,vab,3)
   call vsub(vc,vb,vcb,3)
   rab2 = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
   rcb2 = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
   call crprod(vcb,vab,vp)
   rp = vlen(vp)+1.d-14
   call impsc(vab,vcb,cosa)
   cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
   theta= dacos(cosa)

   if(pi-c0.lt.1.d-6)then     ! linear
   dt  = theta - c0
   ea  = kijk * dt**2
   deddt = 2.d0 * kijk * dt
   else
   ea=kijk*(cosa-cos(c0))**2  ! not linear
   deddt=2.0d0*kijk*sin(theta)*(cos(c0)-cosa)
   endif

   e = (1.0d0-ea)
   call crprod(vab,vp,deda)
   rmul1 = -deddt / (rab2*rp)
   deda = deda*rmul1
   call crprod(vcb,vp,dedc)
   rmul2 =  deddt / (rcb2*rp)
   dedc = dedc*rmul2
   dedb = deda+dedc
   g(1:3,1) =  dedb(1:3)
   g(1:3,2) = -deda(1:3)
   g(1:3,3) = -dedc(1:3)

end subroutine egbend_nci_mul

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egbend_nci(j,i,k,c0,kijk,n,at,xyz,e,g,param)
   
   use xtb_mctc_constants
   implicit none
   
   type(TGFFData), intent(in) :: param
   integer n,at(n)
   integer i,j,k
   real*8 c0,kijk
   real*8 xyz(3,n),g(3,3),e
   
   real*8  va(3),vb(3),vc(3),cosa
   real*8  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
   real*8  term1(3),term2(3),rab2,vab(3),vcb(3),rp
   real*8  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
   real*8  theta,deda(3),vlen,vp(3),et,dij,c1
   real*8  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
   real*8  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
   real*8  omega,rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
   real*8  dampjl,damp2jl,valijklff,rn

   va(1:3) = xyz(1:3,i)
   vb(1:3) = xyz(1:3,j)
   vc(1:3) = xyz(1:3,k)
   call vsub(va,vb,vab,3)
   call vsub(vc,vb,vcb,3)
   rab2 = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
   rcb2 = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
   call crprod(vcb,vab,vp)
   rp = vlen(vp)+1.d-14
   call impsc(vab,vcb,cosa)
   cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
   theta= dacos(cosa)

   call gfnffdampa_nci(at(i),at(j),rab2,dampij,damp2ij,param)
   call gfnffdampa_nci(at(k),at(j),rcb2,dampjk,damp2jk,param)
   damp=dampij*dampjk
   
   ! linear !
   if(pi-c0.lt.1.d-6)then 
      dt  = theta - c0
      ea  = kijk * dt**2
      deddt = 2.d0 * kijk * dt
   else
      ea=kijk*(cosa-cos(c0))**2
      deddt=2.0d0*kijk*sin(theta)*(cos(c0)-cosa)
   endif

   e = ea * damp
   call crprod(vab,vp,deda)
   rmul1 = -deddt / (rab2*rp)
   deda = deda*rmul1
   call crprod(vcb,vp,dedc)
   rmul2 =  deddt / (rcb2*rp)
   dedc = dedc*rmul2
   dedb = deda+dedc
   term1(1:3)=ea*damp2ij*dampjk*vab(1:3)
   term2(1:3)=ea*damp2jk*dampij*vcb(1:3)
   
   g(1:3,1) = -dedb(1:3)*damp-term1(1:3)-term2(1:3)
   g(1:3,2) =  deda(1:3)*damp+term1(1:3)
   g(1:3,3) =  dedc(1:3)*damp+term2(1:3)

end subroutine egbend_nci

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egtors(m,i,j,k,l,iTrl,iTrj,iTrk,n,at,xyz,e,g,ds,param,topo,neigh)
   use xtb_mctc_constants
   implicit none
   type(TGFFData), intent(in) :: param
   type(TGFFTopology), intent(in) :: topo
   type(TNeigh), intent(in) :: neigh
   integer m,n,at(n)
   integer i,j,k,l,iTrl,iTrj,iTrk,dim1,dim2
   real*8 xyz(3,n),g(3,4),e,ds(3,3)
   real*8 vTrl(3),vTrj(3),vTrk(3)

   real*8  c0,kijk,va(3),vb(3),vc(3),vd(3),cosa
   real*8  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
   real*8  term1(3),term2(3),rab2,vab(3),vcb(3),rp
   real*8  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
   real*8  theta,deda(3),vlen,vp(3),et,dij,c1
   real*8  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
   real*8  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
   real*8  omegaPBC,rij,rijk,phi0,rkl,rjk,dampkl,damp2kl
   real*8  dampjl,damp2jl,valijklffPBC,rn

   rn=dble(topo%tlist(5,m))
   phi0 =topo%vtors(1,m)

   if(topo%tlist(5,m).gt.0)then
      vTrl=neigh%transVec(:,iTrl)
      vTrj=neigh%transVec(:,iTrj)
      vTrk=neigh%transVec(:,iTrk)
      va=xyz(1:3,i)+vTrl
      vb=xyz(1:3,j)
      vc=xyz(1:3,k)+vTrj
      vd=xyz(1:3,l)+vTrk
      vab(1:3) = va-vb
      vcb(1:3) = vb-vc
      vdc(1:3) = vc-vd
      rij = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
      rjk = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
      rkl = vdc(1)*vdc(1) + vdc(2)*vdc(2) + vdc(3)*vdc(3)
 
      call gfnffdampt(at(i),at(j),rij,dampij,damp2ij,param)
      call gfnffdampt(at(k),at(j),rjk,dampjk,damp2jk,param)
      call gfnffdampt(at(k),at(l),rkl,dampkl,damp2kl,param)
      damp= dampjk*dampij*dampkl

      phi=valijklffPBC(1,n,xyz,i,j,k,l,vTrj,vTrk,vTrl)
      call dphidrPBC  (2,n,xyz,i,j,k,l,vTrj,vTrk,vTrl,phi,dda,ddb,ddc,ddd)
      dphi1=phi-phi0
      c1=rn*dphi1+pi
      x1cos=cos(c1)
      x1sin=sin(c1)
      et =(1.+x1cos)*topo%vtors(2,m)
      dij=-rn*x1sin*topo%vtors(2,m)*damp
      term1(1:3)=et*damp2ij*dampjk*dampkl*vab(1:3)
      term2(1:3)=et*damp2jk*dampij*dampkl*vcb(1:3)
      term3(1:3)=et*damp2kl*dampij*dampjk*vdc(1:3)
      g(1:3,1)=dij*dda(1:3)+term1
      g(1:3,2)=dij*ddb(1:3)-term1+term2
      g(1:3,3)=dij*ddc(1:3)+term3-term2
      g(1:3,4)=dij*ddd(1:3)-term3
      if(neigh%nTrans.ne.1) then
        do dim1=1, 3
          do dim2=dim1, 3
            ds(dim1,dim2) = g(dim2,1)*va(dim1) &
                    &      +g(dim2,2)*vb(dim1) &
                    &      +g(dim2,3)*vc(dim1) &
                    &      +g(dim2,4)*vd(dim1)
            ds(dim2,dim1) = ds(dim1,dim2)
          enddo
        enddo
        do dim1=1, 3
          do dim2=1,dim1-1
            ds(dim1,dim2)=ds(dim2,dim1)
          enddo
        enddo
      endif
      e=et*damp
   else  ! out-of-plane, improper
      vTrl=neigh%transVec(:,iTrl)
      vTrj=neigh%transVec(:,iTrj)
      vTrk=neigh%transVec(:,iTrk)
      va=xyz(1:3,i)
      vb=xyz(1:3,j)+vTrj
      vc=xyz(1:3,k)+vTrk
      vd=xyz(1:3,l)+vTrl
      vab(1:3) = vb -va
      vcb(1:3) = vb -vc
      vdc(1:3) = vb -vd
      rij = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
      rjk = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
      rjl = vdc(1)*vdc(1) + vdc(2)*vdc(2) + vdc(3)*vdc(3)

      call gfnffdampt(at(i),at(j),rij,dampij,damp2ij,param)
      call gfnffdampt(at(k),at(j),rjk,dampjk,damp2jk,param)
      call gfnffdampt(at(j),at(l),rjl,dampjl,damp2jl,param)
      damp= dampjk*dampij*dampjl

      phi=omegaPBC(n,xyz,i,j,k,l,vTrl,vTrj,vTrk)
      call domegadrPBC(n,xyz,i,j,k,l,vTrl,vTrj,vTrk,&
                     & phi,dda,ddb,ddc,ddd)

      if(topo%tlist(5,m).eq.0)then  ! phi0=0 case
         dphi1=phi-phi0
         c1=dphi1+pi
         x1cos=cos(c1)
         x1sin=sin(c1)
         et   =(1.+x1cos)*topo%vtors(2,m)
         dij  =-x1sin*topo%vtors(2,m)*damp
      else                     ! double min at phi0,-phi0
         et =   topo%vtors(2,m)*(cos(phi) -cos(phi0))**2
         dij=2.*topo%vtors(2,m)* sin(phi)*(cos(phi0)-cos(phi))*damp
      endif
      term1(1:3)=et*damp2ij*dampjk*dampjl*vab(1:3)
      term2(1:3)=et*damp2jk*dampij*dampjl*vcb(1:3)
      term3(1:3)=et*damp2jl*dampij*dampjk*vdc(1:3)
      g(1:3,1)=dij*dda(1:3)-term1
      g(1:3,2)=dij*ddb(1:3)+term1+term2+term3
      g(1:3,3)=dij*ddc(1:3)-term2
      g(1:3,4)=dij*ddd(1:3)-term3
      if(neigh%nTrans.ne.1) then
        do dim1=1, 3 
          do dim2=dim1, 3
            ds(dim1,dim2) = g(dim2,1)*va(dim1) &
                    &      +g(dim2,2)*vb(dim1) &
                    &      +g(dim2,3)*vc(dim1) &
                    &      +g(dim2,4)*vd(dim1)
          enddo
        enddo
        do dim1=1, 3
          do dim2=1,dim1-1
            ds(dim1,dim2)=ds(dim2,dim1)
          enddo
        enddo
      endif
      e=et*damp
   endif

end subroutine egtors

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!> torsion without distance damping !!! damping is inherint in the HB term
subroutine egtors_nci_mul(i,j,k,l,vTrR,vTrB,vTrC,rn,phi,phi0,tshift,n,at,xyz,e,g)
   use xtb_mctc_constants
   implicit none
   !Dummy
   integer n,at(n)
   integer i,j,k,l
   integer rn
   real*8 vTrR(3),vTrB(3),vTrC(3)
   real*8 phi,phi0,tshift
   real*8 xyz(3,n),g(3,4),e
   !Stack
   real*8  c0,fc,kijk,va(3),vb(3),vc(3),cosa
   real*8  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
   real*8  term1(3),term2(3),rab2,vab(3),vcb(3),rp
   real*8  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
   real*8  theta,deda(3),vlen,vp(3),et,dij,c1
   real*8  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
   real*8  ddd(3),ddc(3),ddb(3),dda(3),rjl
   real*8  omega,rij,rijk,rkl,rjk,dampkl,damp2kl
   real*8  dampjl,damp2jl,valijklff

      fc=(1.0d0-tshift)/2.0d0
      vab(1:3) = xyz(1:3,i)+vTrR-xyz(1:3,j)-vTrB
      vcb(1:3) = xyz(1:3,j)+vTrB-xyz(1:3,k)-vTrC
      vdc(1:3) = xyz(1:3,k)+vTrC-xyz(1:3,l)
      rij = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
      rjk = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
      rkl = vdc(1)*vdc(1) + vdc(2)*vdc(2) + vdc(3)*vdc(3)

      call dphidrPBC  (1,n,xyz,i,j,k,l,vTrR,vTrB,vTrC,phi,dda,ddb,ddc,ddd)

      dphi1=phi-phi0
      c1=rn*dphi1+pi
      x1cos=cos(c1)
      x1sin=sin(c1)
      et =(1.+x1cos)*fc+tshift
      dij=-rn*x1sin*fc
      g(1:3,1)=dij*dda(1:3)
      g(1:3,2)=dij*ddb(1:3)
      g(1:3,3)=dij*ddc(1:3)
      g(1:3,4)=dij*ddd(1:3)
      e=et !*damp
end subroutine egtors_nci_mul

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine egtors_nci(i,j,k,l,rn,phi0,fc,n,at,xyz,e,g,param)
   
   use xtb_mctc_constants
   implicit none
   
   type(TGFFData), intent(in) :: param
   integer n,at(n)
   integer i,j,k,l
   integer rn
   real*8 phi0,fc
   real*8 xyz(3,n),g(3,4),e
   
   real*8  c0,kijk,va(3),vb(3),vc(3),cosa
   real*8  dt,ea,dedb(3),dedc(3),rmul2,rmul1,deddt
   real*8  term1(3),term2(3),rab2,vab(3),vcb(3),rp
   real*8  rcb2,damp,dampij,damp2ij,dampjk,damp2jk
   real*8  theta,deda(3),vlen,vp(3),et,dij,c1
   real*8  term3(3),x1sin,x1cos,e1,dphi1,vdc(3)
   real*8  ddd(3),ddc(3),ddb(3),dda(3),rjl,phi
   real*8  omega,rij,rijk,rkl,rjk,dampkl,damp2kl
   real*8  dampjl,damp2jl,valijklff

   vab(1:3) = xyz(1:3,i)-xyz(1:3,j)
   vcb(1:3) = xyz(1:3,j)-xyz(1:3,k)
   vdc(1:3) = xyz(1:3,k)-xyz(1:3,l)
   
   rij = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
   rjk = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
   rkl = vdc(1)*vdc(1) + vdc(2)*vdc(2) + vdc(3)*vdc(3)
   
   call gfnffdampt_nci(at(i),at(j),rij,dampij,damp2ij,param)
   call gfnffdampt_nci(at(k),at(j),rjk,dampjk,damp2jk,param)
   call gfnffdampt_nci(at(k),at(l),rkl,dampkl,damp2kl,param)
   
   damp= dampjk*dampij*dampkl
   phi=valijklff(n,xyz,i,j,k,l)
   
   call dphidr  (n,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
   
   dphi1=phi-phi0
   c1=rn*dphi1+pi
   x1cos=cos(c1)
   x1sin=sin(c1)
   et =(1.+x1cos)*fc
   dij=-rn*x1sin*fc*damp
   
   term1(1:3)=et*damp2ij*dampjk*dampkl*vab(1:3)
   term2(1:3)=et*damp2jk*dampij*dampkl*vcb(1:3)
   term3(1:3)=et*damp2kl*dampij*dampjk*vdc(1:3)
   
   g(1:3,1)=dij*dda(1:3)+term1
   g(1:3,2)=dij*ddb(1:3)-term1+term2
   g(1:3,3)=dij*ddc(1:3)+term3-term2
   g(1:3,4)=dij*ddd(1:3)-term3
   
   e=et*damp

end subroutine egtors_nci

!cccccccccccccccccccccccccccccccccccccccccccccc
! damping of bend and torsion for long
! bond distances to allow proper dissociation
!cccccccccccccccccccccccccccccccccccccccccccccc

subroutine gfnffdampa(ati,atj,r2,damp,ddamp,param)
   
   implicit none
   type(TGFFData), intent(in) :: param
   integer ati,atj
   real*8 r2,damp,ddamp,rr,rcut
   
   rcut =param%atcuta*(param%rcov(ati)+param%rcov(atj))**2
   rr   =(r2/rcut)**2
   damp = 1.0d0/(1.0d0+rr)
   ddamp=-2.d0*2*rr/(r2*(1.0d0+rr)**2)

end subroutine gfnffdampa

subroutine gfnffdampt(ati,atj,r2,damp,ddamp,param)
   
   implicit none
   type(TGFFData), intent(in) :: param
   integer ati,atj
   real*8 r2,damp,ddamp,rr,rcut
   
   rcut =param%atcutt*(param%rcov(ati)+param%rcov(atj))**2
   rr   =(r2/rcut)**2
   damp = 1.0d0/(1.0d0+rr)
   ddamp=-2.d0*2*rr/(r2*(1.0d0+rr)**2)

end subroutine gfnffdampt

subroutine gfnffdampa_nci(ati,atj,r2,damp,ddamp,param)
   
   implicit none
   type(TGFFData), intent(in) :: param
   integer ati,atj
   real*8 r2,damp,ddamp,rr,rcut
   
   rcut =param%atcuta_nci*(param%rcov(ati)+param%rcov(atj))**2
   rr   =(r2/rcut)**2
   damp = 1.0d0/(1.0d0+rr)
   ddamp=-2.d0*2*rr/(r2*(1.0d0+rr)**2)

end subroutine gfnffdampa_nci

subroutine gfnffdampt_nci(ati,atj,r2,damp,ddamp,param)
   
   implicit none
   type(TGFFData), intent(in) :: param
   integer ati,atj
   real*8 r2,damp,ddamp,rr,rcut
   
   rcut =param%atcutt_nci*(param%rcov(ati)+param%rcov(atj))**2
   rr   =(r2/rcut)**2
   damp = 1.0d0/(1.0d0+rr)
   ddamp=-2.d0*2*rr/(r2*(1.0d0+rr)**2)

end subroutine gfnffdampt_nci

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Ref.: S. Alireza Ghasemi, Albert Hofstetter, Santanu Saha, and Stefan Goedecker
!       PHYSICAL REVIEW B 92, 045131 (2015)
!       Interatomic potentials for ionic systems with density functional accuracy
!       based on charge densities obtained by a neural network
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine goed_gfnff(env,single,n,at,sqrab,r,chrg,eeqtmp,cn,q,es,gbsa,param,topo)
   
   use xtb_mctc_accuracy, only : wp, sp
   use xtb_mctc_la
   implicit none
   
   character(len=*), parameter :: source = 'gfnff_eg_goed'
   type(TEnvironment), intent(inout) :: env
   type(TGFFData), intent(in) :: param
   type(TGFFTopology), intent(in) :: topo
   
   !> real*4 flag for solver
   logical, intent(in)  :: single     
   
   !> number of atoms
   integer, intent(in)  :: n          
   
   !> ordinal numbers
   integer, intent(in)  :: at(n)      
   
   !> squared dist
   real(wp),intent(in)  :: sqrab(n*(n+1)/2)      
   
   !> distance
   real(wp),intent(in)  :: r(n*(n+1)/2)      
   
   !> total charge 
   real(wp),intent(in)  :: chrg       

   !> coordination number
   real(wp),intent(in)  :: cn(n)      

   !> output charges
   real(wp),intent(out) :: q(n)       

   !> ES term
   real(wp),intent(out) :: es         

   !>intermediates
   real(wp),intent(out) :: eeqtmp(2,n*(n+1)/2)    

   !> Solvation
   type(TBorn), allocatable, intent(in) :: gbsa

   integer  :: m,i,j,k,ii,ij
   integer,allocatable :: ipiv(:)
   real(wp) :: gammij,tsqrt2pi,r2,tmp
   real(wp),allocatable :: A (:,:),x (:)
   real(sp),allocatable :: A4(:,:),x4(:)
   parameter (tsqrt2pi = 0.797884560802866_wp)
   logical :: exitRun

   ! # atoms + chrg constrain + frag constrain !
   m=n+topo%nfrag 
   allocate(A(m,m),x(m))

   !  setup RHS !

   do i=1,n
      x(i) = topo%chieeq(i) + param%cnf(at(i))*sqrt(cn(i))
   enddo

   A = 0
   
   !  setup A matrix !

   !$omp parallel default(none) &
   !$omp shared(topo,n,sqrab,r,eeqtmp,A,at) &
   !$omp private(i,j,k,ij,gammij,tmp)
   !$omp do schedule(dynamic)
   do i=1,n

      A(i,i)=tsqrt2pi/sqrt(topo%alpeeq(i))+topo%gameeq(i) ! J of i !
      k = i*(i-1)/2

      do j=1,i-1
         
         ij = k+j
         gammij=1./sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above !
         tmp = erf(gammij*r(ij))
         eeqtmp(1,ij)=gammij
         eeqtmp(2,ij)=tmp
         A(j,i) = tmp/r(ij)
         A(i,j) = A(j,i)
      
      enddo
   enddo
   !$omp enddo
   !$omp end parallel

   !  fragment charge constrain !
   
   do i=1,topo%nfrag
      x(n+i)=topo%qfrag(i)
      do j=1,n
         if(topo%fraglist(j).eq.i) then
            A(n+i,j)=1
            A(j,n+i)=1
         endif
      enddo
   enddo

   if (allocated(gbsa)) then
      A(:n, :n) = A(:n, :n) + gbsa%bornMat(:, :)
   end if

!     call prmat(6,A,m,m,'A eg')
   allocate(ipiv(m))

   if(single) then
      
      allocate(A4(m,m),x4(m))
      A4=A
      x4=x
      deallocate(A,x)
      call mctc_sytrf(env, a4, ipiv)
      call mctc_sytrs(env, a4, x4, ipiv)
      q(1:n)=x4(1:n)
      deallocate(A4,x4)
   
   else
      
      call mctc_sytrf(env, a, ipiv)
      call mctc_sytrs(env, a, x, ipiv)
      q(1:n)=x(1:n)
      deallocate(A,x)
   
   endif

   call env%check(exitRun)
   
   if(exitRun) then
      call env%error('Solving linear equations failed', source)
      return
   end if

   if(n.eq.1) q(1)=chrg

   !  energy !

   es = 0.0_wp
   do i=1,n
      
      ii = i*(i-1)/2
      
      do j=1,i-1      
         ij = ii+j
         tmp   =eeqtmp(2,ij)
         es = es + q(i)*q(j)*tmp/r(ij)
      enddo
      
      es = es - q(i)*(topo%chieeq(i) + param%cnf(at(i))*sqrt(cn(i))) &
      &        + q(i)*q(i)*0.5d0*(topo%gameeq(i)+tsqrt2pi/sqrt(topo%alpeeq(i)))
   
   enddo

end subroutine goed_gfnff


subroutine goed_pbc_gfnff(env,mol,single,n,at,r,chrg,eeqtmp,cn,q,es,&
                      & gbsa,param,topo, gTrans, rTrans, x, cf)
   use xtb_mctc_accuracy, only : wp, sp
   use xtb_mctc_la
   use xtb_mctc_blas, only: mctc_symv
   implicit none
   character(len=*), parameter :: source = 'gfnff_eg_goed'
   ! Molecular structure information
   type(TMolecule), intent(in) :: mol
   type(TEnvironment), intent(inout) :: env
   type(TGFFData), intent(in) :: param
   type(TGFFTopology), intent(in) :: topo
   logical, intent(in)  :: single     ! real*4 flag for solver
   integer, intent(in)  :: n          ! number of atoms
   !integer, intent(in)  :: numctr
   integer, intent(in)  :: at(n)      ! ordinal numbers
   real(wp),intent(in)  :: r(n,n)       ! dist
   real(wp),intent(in)  :: chrg       ! total charge on system
   real(wp),intent(in)  :: cn(n)      ! CN
   real(wp),intent(out) :: q(n)       ! output charges
   real(wp),intent(out) :: es         ! ES energyi
   real(wp),allocatable,intent(out) :: x(:)
   real(wp),intent(out) :: eeqtmp(2,n*(n+1)/2)    ! intermediates
   real(wp), intent(out) :: cf !convergence factor
   type(TBorn), allocatable, intent(in) :: gbsa

   ! local variables
   integer  :: m,i,j,k,ii,ij
   integer,allocatable :: ipiv(:)
   real(wp) :: gammij,tsqrt2pi,r2,tmp
   real(wp),allocatable :: A (:,:), x_right(:)
   real(sp),allocatable :: A4(:,:),x4(:)

   ! for calc of Coulomb matrix Amat
   real(wp), allocatable :: Amat(:,:), Amat_or(:,:)
   real(wp), allocatable, intent(out) :: rTrans(:,:)
   real(wp), allocatable, intent(out) :: gTrans(:,:)
   real(wp) :: vec(3)
   integer :: iRp, iG1, iG2, iG3, iT1, iT2, iT3
   integer, parameter :: ewaldCutD(3) = 2
   integer, parameter :: ewaldCutR(3) = 2  
   real(wp), parameter :: sqrtpi = 1.772453850905516_wp
   real(wp) :: avgAlpeeq

   ! parameter
   parameter (tsqrt2pi = 0.797884560802866_wp)
   logical :: exitRun

      m=n+topo%nfrag ! # atoms + chrg constrain + frag constrain
      
      allocate(Amat(m,m), Amat_or(m,m), x(m), x_right(m), source=0.0_wp) ! matrix contains constrains -> linear equations

      ! calculate rTrans, gTrans
      iRp = 0
      allocate(gTrans(3, product(2*ewaldCutR+1)-1), source=0.0_wp)
      do iG1 = -ewaldCutR(1), ewaldCutR(1)
         do iG2 = -ewaldCutR(2), ewaldCutR(2)
            do iG3 = -ewaldCutR(3), ewaldCutR(3)
               if (iG1 == 0 .and. iG2 == 0 .and. iG3 == 0) cycle
               iRp = iRp + 1
               vec(:) = [iG1, iG2, iG3]
               gTrans(:, iRp) = matmul(mol%rec_lat, vec)
            end do
         end do
      end do

      iRp = 0
      allocate(rTrans(3, product(2*ewaldCutD+1)))
      do iT1 = -ewaldCutD(1), ewaldCutD(1)
         do iT2 = -ewaldCutD(2), ewaldCutD(2)
            do iT3 = -ewaldCutD(3), ewaldCutD(3)
               iRp = iRp + 1
               vec(:) = [iT1, iT2, iT3]
               rTrans(:, iRp) = matmul(mol%lattice, vec) 
            end do
         end do
      end do
!  calc eeqtmp
 !$omp parallel default(none) &
 !$omp shared(topo,n,r,eeqtmp) &
 !$omp private(i,j,k,ij,gammij,tmp)
 !$omp do schedule(dynamic)
      do i=1,n
      k = i*(i-1)/2
      do j=1,i-1
         ij = k+j
         gammij=1./sqrt(topo%alpeeq(i)+topo%alpeeq(j)) ! squared above
         tmp = erf(gammij*r(i,j))
         eeqtmp(1,ij)=gammij
         eeqtmp(2,ij)=tmp
      enddo
      enddo
 !$omp enddo
 !$omp end parallel

      ! cf, aka ewald parameter
      avgAlpeeq=sum(topo%alpeeq)/mol%n
      cf = get_cf(rTrans,gTrans, mol%volume, avgAlpeeq)

      ! build Ewald matrix
      call get_amat_3d(mol, topo, cf, rTrans, gTrans, Amat) 
      

      !  setup RHS
      do i=1,n
         x(i) = topo%chieeq(i) + param%cnf(at(i))*sqrt(cn(i))
      enddo

!  fragment charge constrain
      do i=1,topo%nfrag
        x(n+i)=topo%qfrag(i)
        do j=1,n
         if(topo%fraglist(j).eq.i) then
            Amat(n+i,j)=1
            Amat(j,n+i)=1
         endif
        enddo
      enddo

      if (allocated(gbsa)) then
         Amat(:n, :n) = Amat(:n, :n) + gbsa%bornMat(:, :)
      end if

      allocate(ipiv(m))

      Amat_or = Amat
      if(single) then
         allocate(A4(m,m),x4(m))
         A4=Amat
         x4=x
         x_right(1:n)=x(1:n)
         deallocate(Amat)
         call mctc_sytrf(env, a4, ipiv)
         call mctc_sytrs(env, a4, x4, ipiv)
         q(1:n)=x4(1:n)
         x = x4
         deallocate(A4,x4)
      else
         x_right(1:n)=x(1:n)
         call mctc_sytrf(env, Amat, ipiv)
         call mctc_sytrs(env, Amat, x, ipiv)
         q(1:n)=x(1:n)
         deallocate(Amat)
      endif

      call env%check(exitRun)
      if(exitRun) then
         call env%error('Solving linear equations failed', source)
         return
      end if

      if(n.eq.1) q(1)=chrg

      ! calculate E_es = q^T*(0.5*A*q-X) |  ^T is the transpose
      ! First calc bracket term with mctc_symv, result is saved in x_right
      ! now the x is used as q to save memory
      call mctc_symv(Amat_or, x, x_right, alpha=0.5_wp, beta=-1.0_wp)
      ! from src/mctc/blas/level2.F90 about mctc_symv similar to mctc_gemv
      ! y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y

      !Calc ES as dot product (=matrix product) since q and x are vectors 
      !es = dot_product(x, x_right)
      es = mctc_dot(x, x_right)!*1.05_wp
end subroutine goed_pbc_gfnff


!cccccccccccccccccccccccccccccccccccc
! HB energy and analytical gradient
!cccccccccccccccccccccccccccccccccccc

!> Case 1: A...H...B
subroutine abhgfnff_eg1(n,A,B,H,iTrA,iTrB,at,xyz,q,energy,gdr,param,topo,neigh,sigma, mcf_ehb)
      implicit none
      type(TGFFData), intent(in)     :: param
      type(TGFFTopology), intent(in) :: topo
      type(TNeigh), intent(inout)    :: neigh
      real(wp), intent(inout)        :: sigma(3,3)
      real(wp), intent(in)           :: mcf_ehb
      integer A,B,H,n,at(n),iTrA,iTrB
      real*8 xyz(3,n),energy,gdr(3,3)
      real*8 q(n)

      real*8 outl,dampl,damps,rdamp,damp,dd24a,dd24b
      real*8 ratio1,ratio2,ratio3
      real*8 xm,ym,zm
      real*8 rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
      real*8 drah(3),drbh(3),drab(3),drm(3)
      real*8 dg(3),dga(3),dgb(3),dgh(3)
      real*8 ga(3),gb(3),gh(3)
      real*8 gi,denom,ratio,tmp,qhoutl,radab,rahprbh
      real*8 ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo
      real*8 bas,aci
      real*8 eabh
      real*8 aterm,rterm,dterm,sterm
      real*8 qa,qb,qh
      real*8 ca(2),cb(2)
      real*8 gqa,gqb,gqh
      real*8 caa,cbb
      real*8 shortcut

      integer i,j!,iTrDum ! ij,lina

      gdr  = 0
      energy=0
      call hbonds(A,B,ca,cb,param,topo) ! get HB strength
!     A-B distance
        rab=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,B)+neigh%transVec(:,iTrB)))
      rab2=rab**2
!     A-H distance
      rah=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,H)))
      rah2=rah**2
!     B-H distance
      rbh=NORM2((xyz(:,B)+neigh%transVec(:,iTrB))-xyz(:,H))
      rbh2= rbh**2

      rahprbh=rah+rbh+1.d-12
      radab=param%rad(at(A))+param%rad(at(B))

!     out-of-line damp
      expo=(param%hbacut/radab)*(rahprbh/rab-1.d0)
      if(expo.gt.15.0d0) return ! avoid overflow
      ratio2=exp(expo)
      outl=2.d0/(1.d0+ratio2)

!     long damping
      ratio1=(rab2/param%hblongcut)**param%hbalp
      dampl=1.d0/(1.d0+ratio1)

!     short damping
      shortcut=param%hbscut*radab
      ratio3=(shortcut/rab2)**param%hbalp
      damps=1.d0/(1.d0+ratio3)

      damp = damps*dampl
      rdamp = damp/rab2/rab

!     hydrogen charge scaled term
      ex1h=exp(param%hbst*q(H))
      ex2h=ex1h+param%hbsf
      qh=ex1h/ex2h

!     hydrogen charge scaled term
      ex1a=exp(-param%hbst*q(A))
      ex2a=ex1a+param%hbsf
      qa=ex1a/ex2a

!     hydrogen charge scaled term
      ex1b=exp(-param%hbst*q(B))
      ex2b=ex1b+param%hbsf
      qb=ex1b/ex2b

!     donor-acceptor term
      rah4 = rah2*rah2
      rbh4 = rbh2*rbh2
      denom = 1.d0/(rah4+rbh4)

      caa=qa*ca(1)
      cbb=qb*cb(1)
      qhoutl=qh*outl

      bas = (caa*rah4 + cbb*rbh4)*denom
      aci = (cb(2)*rah4+ca(2)*rbh4)*denom

!     energy
      rterm  = -aci*rdamp*qhoutl
      energy =  bas*rterm

!     gradient
      drah(1:3)=xyz(1:3,A)-xyz(1:3,H)+neigh%transVec(1:3,iTrA)
      drbh(1:3)=xyz(1:3,B)-xyz(1:3,H)+neigh%transVec(1:3,iTrB)
      drab(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))-(xyz(1:3,B)+neigh%transVec(1:3,iTrB))

      aterm= -aci*bas*rdamp*qh
      sterm= -rdamp*bas*qhoutl
      dterm= -aci*bas*qhoutl

      tmp=denom*denom*4.0d0
      dd24a=rah2*rbh4*tmp
      dd24b=rbh2*rah4*tmp

!     donor-acceptor part: bas
      gi = (caa-cbb)*dd24a*rterm
      ga(1:3) = gi*drah(1:3)
      gi = (cbb-caa)*dd24b*rterm
      gb(1:3) = gi*drbh(1:3)
      gh(1:3) = -ga(1:3)-gb(1:3)


!     donor-acceptor part: aci
      gi = (cb(2)-ca(2))*dd24a
      dga(1:3) = gi*drah(1:3)*sterm
      ga(1:3) = ga(1:3) + dga(1:3)

      gi = (ca(2)-cb(2))*dd24b
      dgb(1:3) = gi*drbh(1:3)*sterm
      gb(1:3) = gb(1:3) + dgb(1:3)

      dgh(1:3) = -dga(1:3)-dgb(1:3)
      gh(1:3) = gh(1:3) + dgh(1:3)

!     damping part rab
      gi = rdamp*(-(2.d0*param%hbalp*ratio1/(1+ratio1))+(2.d0*param%hbalp*ratio3/(1+ratio3))-3.d0)/rab2
      dg(1:3) = gi*drab(1:3)*dterm
      ga(1:3) = ga(1:3) + dg(1:3)
      gb(1:3) = gb(1:3) - dg(1:3)

!     out of line term: rab
      gi = aterm*2.d0*ratio2*expo*rahprbh/(1+ratio2)**2/(rahprbh-rab)/rab2
      dg(1:3) = gi*drab(1:3)
      ga(1:3) = ga(1:3) + dg(1:3)
      gb(1:3) = gb(1:3) - dg(1:3)

!     out of line term: rah,rbh
      tmp= -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
      dga(1:3) = drah(1:3)*tmp/rah
      ga(1:3) = ga(1:3) + dga(1:3)
      dgb(1:3) = drbh(1:3)*tmp/rbh
      gb(1:3) = gb(1:3) + dgb(1:3)
      dgh(1:3) = -dga(1:3)-dgb(1:3)
      gh(1:3) = gh(1:3) + dgh(1:3)
      ! sigma
      sigma=sigma+mcf_ehb*spread(ga,1,3)*spread(xyz(:,A)+neigh%transVec(1:3,iTrA),2,3)
      sigma=sigma+mcf_ehb*spread(gb,1,3)*spread(xyz(:,B)+neigh%transVec(1:3,iTrB),2,3)
      sigma=sigma+mcf_ehb*spread(gh,1,3)*spread(xyz(:,H),2,3)
!     move gradients into place
      gdr(1:3,1) = ga(1:3)
      gdr(1:3,2) = gb(1:3)
      gdr(1:3,3) = gh(1:3)

end subroutine abhgfnff_eg1

!> Case 2: A-H...B including orientation of neighbors at B
subroutine abhgfnff_eg2new(n,A,B,H,iTrA,iTrB,nbb,at,xyz,q,sqrab, &
                & srab,energy,gdr, param,topo,neigh,sigma, mcf_ehb)
      implicit none
      type(TGFFData), intent(in) :: param
      type(TGFFTopology), intent(in) :: topo
      type(TNeigh), intent(inout) :: neigh
      real(wp), intent(inout)        :: sigma(3,3)
      real(wp), intent(in)           :: mcf_ehb
      integer A,B,H,n,at(n),iTrA,iTrB,nbb
      real*8 xyz(3,n),energy,gdr(3,n)
      real*8 q(n)
      real*8 sqrab(n*(n+1)/2)   ! squared dist
      real*8 srab(n*(n+1)/2)    ! dist

      real*8 outl,dampl,damps,rdamp,damp
      real*8 ddamp,rabdamp,rbhdamp
      real*8 ratio1,ratio2,ratio2_nb(nbb),ratio3
      real*8 xm,ym,zm
      real*8 rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
      real*8 ranb(nbb),ranb2(nbb),rbnb(nbb),rbnb2(nbb)
      real*8 drah(3),drbh(3),drab(3),drm(3)
      real*8 dranb(3,nbb),drbnb(3,nbb)
      real*8 dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
      real*8 ga(3),gb(3),gh(3),gnb(3,nbb)
      real*8 denom,ratio,qhoutl,radab
      real*8 gi,gi_nb(nbb)
      real*8 tmp1,tmp2(nbb)
      real*8 rahprbh,ranbprbnb(nbb)
      real*8 ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_nb(nbb)
      real*8 eabh
      real*8 aterm,dterm,nbterm
      real*8 qa,qb,qh
      real*8 ca(2),cb(2)
      real*8 gqa,gqb,gqh
      real*8 shortcut
      real*8 const
      real*8 outl_nb(nbb),outl_nb_tot
      real*8 hbnbcut_save
      real*8 vecDum(3)
      logical mask_nb(nbb)

!     proportion between Rbh und Rab distance dependencies
      real*8 :: p_bh
      real*8 :: p_ab

      integer i,j,inb,iTr!,iTrDum!,ij,lina
      p_bh=1.d0+param%hbabmix
      p_ab=    -param%hbabmix

      gdr    = 0
      energy = 0

      call hbonds(A,B,ca,cb,param,topo)
!     Neighbours of B
      do i=1,nbb
         inb=0; iTr=0 ! jth_nb output
         call neigh%jth_nb(n,xyz,inb,i,B,iTr) ! inb is the i-th nb of B when inb is shifted to iTr
!        compute distances
         vecDum = neigh%transVec(:,iTr)+neigh%transVec(:,iTrB)
         dranb(1:3,i) = (xyz(1:3,A)+neigh%transVec(1:3,iTrA)) -(xyz(1:3,inb)+vecDum)
         drbnb(1:3,i) = (xyz(1:3,B)+neigh%transVec(1:3,iTrB)) -(xyz(1:3,inb)+vecDum)
!        A-nb(B) distance
         ranb2(i) = sum(dranb(1:3,i)**2)
         ranb(i)  = sqrt(ranb2(i))
!        B-nb(B) distance
         rbnb2(i) = sum(drbnb(1:3,i)**2)
         rbnb(i)  = sqrt(rbnb2(i))
      end do

!     A-B distance
      rab=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,B)+neigh%transVec(:,iTrB)))
      rab2=rab**2
!     A-H distance
      rah=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,H)))
      rah2=rah**2
!     B-H distance
      rbh=NORM2((xyz(:,B)+neigh%transVec(:,iTrB))-xyz(:,H))
      rbh2= rbh**2

      rahprbh=rah+rbh+1.d-12
      radab=param%rad(at(A))+param%rad(at(B))

!     out-of-line damp: A-H...B
      expo=(param%hbacut/radab)*(rahprbh/rab-1.d0)
      if(expo.gt.15.0d0) return ! avoid overflow
      ratio2=exp(expo)
      outl=2.d0/(1.d0+ratio2)

!     out-of-line damp: A...nb(B)-B
      if(at(B).eq.7.and.nbb.eq.1) then
        hbnbcut_save = 2.0
      else
        hbnbcut_save = param%hbnbcut
      end if
      do i=1,nbb
         ranbprbnb(i)=ranb(i)+rbnb(i)+1.d-12
         expo_nb(i)=(hbnbcut_save/radab)*(ranbprbnb(i)/rab-1.d0)
         ratio2_nb(i)=exp(-expo_nb(i))**(1.0)
         outl_nb(i)=( 2.d0/(1.d0+ratio2_nb(i)) ) - 1.0d0
      end do
      outl_nb_tot = product(outl_nb)

!     long damping
      ratio1=(rab2/param%hblongcut)**param%hbalp
      dampl=1.d0/(1.d0+ratio1)

!     short damping
      shortcut=param%hbscut*radab
      ratio3=(shortcut/rab2)**param%hbalp
      damps=1.d0/(1.d0+ratio3)

      damp  = damps*dampl
      ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
      rbhdamp = damp * ( (p_bh/rbh2/rbh) )
      rabdamp = damp * ( (p_ab/rab2/rab) )
      rdamp   = rbhdamp + rabdamp

!     hydrogen charge scaled term
      ex1h=exp(param%hbst*q(H))
      ex2h=ex1h+param%hbsf
      qh=ex1h/ex2h

!     hydrogen charge scaled term
      ex1a=exp(-param%hbst*q(A))
      ex2a=ex1a+param%hbsf
      qa=ex1a/ex2a

!     hydrogen charge scaled term
      ex1b=exp(-param%hbst*q(B))
      ex2b=ex1b+param%hbsf
      qb=ex1b/ex2b

      qhoutl=qh*outl*outl_nb_tot

!     constant values, no gradient
      const = ca(2)*qa*cb(1)*qb*param%xhaci_globabh
!     energy
      energy = -rdamp*qhoutl*const
!     gradient
      drah(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))- xyz(1:3,H)
      drbh(1:3)=(xyz(1:3,B)+neigh%transVec(1:3,iTrB))- xyz(1:3,H)
      drab(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))-(xyz(1:3,B)+neigh%transVec(1:3,iTrB))

      aterm  = -rdamp*qh*outl_nb_tot*const
      nbterm = -rdamp*qh*outl*const
      dterm  = -qhoutl*const

!------------------------------------------------------------------------------
!     damping part: rab
      gi = ( (rabdamp+rbhdamp)*ddamp-3.d0*rabdamp ) / rab2
      gi = gi*dterm
      dg(1:3) = gi*drab(1:3)
      ga(1:3) =  dg(1:3)
      gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!     damping part: rbh
      gi = -3.d0*rbhdamp/rbh2
      gi = gi*dterm
      dg(1:3) = gi*drbh(1:3)
      gb(1:3) = gb(1:3)+dg(1:3)
      gh(1:3) =       - dg(1:3)

!------------------------------------------------------------------------------
!     angular A-H...B term
!------------------------------------------------------------------------------
!     out of line term: rab
      tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
      gi   = -tmp1 *rahprbh/rab2
      dg(1:3) = gi*drab(1:3)
      ga(1:3) = ga(1:3) + dg(1:3)
      gb(1:3) = gb(1:3) - dg(1:3)

!     out of line term: rah,rbh
      gi = tmp1/rah
      dga(1:3) = gi*drah(1:3)
      ga(1:3)  = ga(1:3) + dga(1:3)
      gi = tmp1/rbh
      dgb(1:3) = gi*drbh(1:3)
      gb(1:3)  = gb(1:3) + dgb(1:3)
      dgh(1:3) = -dga(1:3)-dgb(1:3)
      gh(1:3)  =  gh(1:3) + dgh(1:3)

!------------------------------------------------------------------------------
!     angular A...nb(B)-B term
!------------------------------------------------------------------------------
!     out of line term: rab
      mask_nb=.true.
      do i=1,nbb
         mask_nb(i)=.false.
         tmp2(i)  = 2.d0*nbterm*product(outl_nb,mask_nb)*ratio2_nb(i)*expo_nb(i)/&
                  & (1+ratio2_nb(i))**2/(ranbprbnb(i)-rab)
         gi_nb(i) = -tmp2(i) *ranbprbnb(i)/rab2
         dg(1:3)  = gi_nb(i)*drab(1:3)
         ga(1:3)  = ga(1:3) + dg(1:3)
         gb(1:3)  = gb(1:3) - dg(1:3)
         mask_nb=.true.
      end do

!     out of line term: ranb,rbnb
      do i=1,nbb
         gi_nb(i)   = tmp2(i)/ranb(i)
         dga(1:3)   = gi_nb(i)*dranb(1:3,i)
         ga(1:3)    = ga(1:3) + dga(1:3)
         gi_nb(i)   = tmp2(i)/rbnb(i)
         dgb(1:3)   = gi_nb(i)*drbnb(1:3,i)
         gb(1:3)    = gb(1:3) + dgb(1:3)
         dgnb(1:3)  = -dga(1:3)-dgb(1:3)
         gnb(1:3,i) = dgnb(1:3)
      end do

!------------------------------------------------------------------------------
      if(nbb.lt.1) then
         gdr(1:3,A) = gdr(1:3,A) + ga(1:3)
         gdr(1:3,B) = gdr(1:3,B) + gb(1:3)
         gdr(1:3,H) = gdr(1:3,H) + gh(1:3)
         sigma=sigma+mcf_ehb*spread(ga,1,3)*spread(xyz(:,A)+neigh%transVec(1:3,iTrA),2,3)
         sigma=sigma+mcf_ehb*spread(gb,1,3)*spread(xyz(:,B)+neigh%transVec(1:3,iTrB),2,3)
         sigma=sigma+mcf_ehb*spread(gh,1,3)*spread(xyz(:,H),2,3)
         return
      endif

!------------------------------------------------------------------------------
!     move gradients into place
      gdr(1:3,A) = gdr(1:3,A) + ga(1:3)
      gdr(1:3,B) = gdr(1:3,B) + gb(1:3)
      gdr(1:3,H) = gdr(1:3,H) + gh(1:3)
      do i=1,nbb
         inb=0; iTr=0 ! jth_nb output
         call neigh%jth_nb(n,xyz,inb,i,B,iTr) ! inb is the i-th nb of B when shifted to iTr
         gdr(1:3,inb) = gdr(1:3,inb) + gnb(1:3,i)
      end do

      ! sigma according to gdr above
      sigma=sigma+mcf_ehb*spread(ga,1,3)*spread(xyz(:,A)+neigh%transVec(1:3,iTrA),2,3)
      sigma=sigma+mcf_ehb*spread(gb,1,3)*spread(xyz(:,B)+neigh%transVec(1:3,iTrB),2,3)
      sigma=sigma+mcf_ehb*spread(gh,1,3)*spread(xyz(:,H),2,3)
      do i=1,nbb
         inb=0; iTr=0 ! jth_nb output
         call neigh%jth_nb(n,xyz,inb,i,B,iTr) ! inb is the i-th nb of B when shifted to iTr
         vecDum = neigh%transVec(:,iTr)+neigh%transVec(:,iTrB)
         sigma=sigma+mcf_ehb*spread(gnb(:,i),1,3)*spread(xyz(:,inb)+vecDum,2,3)
      enddo

end subroutine abhgfnff_eg2new

!> Case 2: A-H...B including LP position
subroutine abhgfnff_eg2_rnr(n,A,B,H,iTrA,iTrB,at,xyz,q,sqrab,srab,energy,gdr,param,topo,neigh,sigma, mcf_ehb)
      implicit none
      type(TGFFData), intent(in) :: param
      type(TGFFTopology), intent(in) :: topo
      type(TNeigh), intent(inout) :: neigh
      real(wp), intent(inout)        :: sigma(3,3)
      real(wp), intent(in)           :: mcf_ehb
      integer A,B,H,iTrA,iTrB,n,at(n)
      real*8 xyz(3,n),energy,gdr(3,n)
      real*8 q(n)
      real*8 sqrab(n*(n+1)/2)   ! squared dist
      real*8 srab(n*(n+1)/2)    ! dist

      real*8 outl,dampl,damps,rdamp,damp
      real*8 ddamp,rabdamp,rbhdamp
      real*8 ratio1,ratio2,ratio2_lp,ratio2_nb(22),ratio3
      real*8 xm,ym,zm
      real*8 rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
      real*8 ranb(2),ranb2(2),rbnb(2),rbnb2(2)
      real*8 drah(3),drbh(3),drab(3),drm(3),dralp(3),drblp(3)
      real*8 dranb(3,2),drbnb(3,2)
      real*8 dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
      real*8 ga(3),gb(3),gh(3),gnb(3,2),gnb_lp(3),glp(3)
      real*8 denom,ratio,qhoutl,radab
      real*8 gi,gi_nb(2)
      real*8 tmp1,tmp2(2),tmp3
      real*8 rahprbh,ranbprbnb(2)
      real*8 ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_lp,expo_nb(2)
      real*8 eabh
      real*8 aterm,dterm,nbterm,lpterm
      real*8 qa,qb,qh
      real*8 ca(2),cb(2)
      real*8 gqa,gqb,gqh
      real*8 shortcut
      real*8 const
      real*8 outl_nb(2),outl_nb_tot,outl_lp
      real*8 vector(3),vnorm
      real*8 gii(3,3)
      real*8 unit_vec(3)
      real*8 drnb(3,2)
      real*8 lp(3)   !lonepair position
      real*8 lp_dist !distance parameter between B and lonepair
      real*8 ralp,ralp2,rblp,rblp2,ralpprblp
      logical mask_nb(2)

!     proportion between Rbh und Rab distance dependencies
      real*8 :: p_bh
      real*8 :: p_ab
!     lone-pair out-of-line damping
      real*8 hblpcut

      real*8 :: vTrinb(3)
      integer i,j,nbb,inb,iTr!,iTrDum

      p_bh=1.d0+param%hbabmix
      p_ab=    -param%hbabmix

      gdr    = 0
      energy = 0
      vector = 0
      lp_dist = 0.50-0.018*param%repz(at(B))
      hblpcut=56

      call hbonds(A,B,ca,cb,param,topo)

      nbb=2 ! given through if condition before call
!     Neighbours of B
      do i=1,nbb
         inb=0; iTr=0 ! jth_nb output
         call neigh%jth_nb(n,xyz,inb,i,B,iTr) ! inb is the i-th nb of B when shifted to iTr
!        compute distances
         vTrinb=neigh%transVec(:,iTr)+neigh%transVec(:,iTrB)
         dranb(1:3,i) = (xyz(1:3,A)+neigh%transVec(1:3,iTrA)) -(xyz(1:3,inb)+vTrinb)
         drbnb(1:3,i) = (xyz(1:3,B)+neigh%transVec(1:3,iTrB)) -(xyz(1:3,inb)+vTrinb)
!        A-nb(B) distance
         ranb2(i) = sum(dranb(1:3,i)**2)
         ranb(i)  = sqrt(ranb2(i))
!        B-nb(B) distance
         rbnb2(i) = sum(drbnb(1:3,i)**2)
         rbnb(i)  = sqrt(rbnb2(i))

         drnb(1:3,i)=(xyz(1:3,inb)+vTrinb)-(xyz(1:3,B)+neigh%transVec(1:3,iTrB))
         vector = vector + drnb(1:3,i)
      end do

      vnorm = norm2(vector)
!     lonepair coordinates
      if(vnorm.gt.1.d-10) then
      lp = (xyz(1:3,B)+neigh%transVec(1:3,iTrB)) - lp_dist * ( vector / vnorm )
      else
      lp = xyz(1:3,B)+neigh%transVec(1:3,iTrB)
      nbb = 0
      endif

!     A-B distance
      rab=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,B)+neigh%transVec(:,iTrB)))
      rab2=rab**2
!     A-H distance
      rah=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,H)))
      rah2=rah**2
!     B-H distance
      rbh=NORM2((xyz(:,B)+neigh%transVec(:,iTrB))-xyz(:,H))
      rbh2= rbh**2

      rahprbh=rah+rbh+1.d-12
      radab=param%rad(at(A))+param%rad(at(B))
!     out-of-line damp: A-H...B
      expo=(param%hbacut/radab)*(rahprbh/rab-1.d0)
      if(expo.gt.15.0d0) return ! avoid overflow
      ratio2=exp(expo)
      outl=2.d0/(1.d0+ratio2)

!     out-of-line damp: A...LP-B
      rblp2 = sum( ( (xyz(1:3,B)+neigh%transVec(1:3,iTrB)) - lp(1:3) )**2 )
      rblp  = sqrt(rblp2)
      ralp2 = sum( ( (xyz(1:3,A)+neigh%transVec(1:3,iTrA)) - lp(1:3) )**2 )
      ralp  = sqrt(ralp2)
      ralpprblp=ralp+rblp+1.d-12
      expo_lp=(hblpcut/radab)*(ralpprblp/rab-1.d0)
      ratio2_lp=exp(expo_lp)
      outl_lp=2.d0/(1.d0+ratio2_lp)

!     out-of-line damp: A...nb(B)-B
      do i=1,nbb
         ranbprbnb(i)=ranb(i)+rbnb(i)+1.d-12
         expo_nb(i)=(param%hbnbcut/radab)*(ranbprbnb(i)/rab-1.d0)
         ratio2_nb(i)=exp(-expo_nb(i))**(1.0)
         outl_nb(i)=( 2.d0/(1.d0+ratio2_nb(i)) ) - 1.0d0
      end do
      outl_nb_tot = product(outl_nb)

!     long damping
      ratio1=(rab2/param%hblongcut)**param%hbalp
      dampl=1.d0/(1.d0+ratio1)

!     short damping
      shortcut=param%hbscut*radab
      ratio3=(shortcut/rab2)**param%hbalp
      damps=1.d0/(1.d0+ratio3)

      damp  = damps*dampl
      ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
      rbhdamp = damp * ( (p_bh/rbh2/rbh) )
      rabdamp = damp * ( (p_ab/rab2/rab) )
      rdamp   = rbhdamp + rabdamp

!     hydrogen charge scaled term
      ex1h=exp(param%hbst*q(H))
      ex2h=ex1h+param%hbsf
      qh=ex1h/ex2h

!     hydrogen charge scaled term
      ex1a=exp(-param%hbst*q(A))
      ex2a=ex1a+param%hbsf
      qa=ex1a/ex2a

!     hydrogen charge scaled term
      ex1b=exp(-param%hbst*q(B))
      ex2b=ex1b+param%hbsf
      qb=ex1b/ex2b

      qhoutl=qh*outl*outl_nb_tot*outl_lp

!     constant values, no gradient
      const = ca(2)*qa*cb(1)*qb*param%xhaci_globabh

!     energy
      energy = -rdamp*qhoutl*const
!     gradient
      drah(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))- xyz(1:3,H)
      drbh(1:3)=(xyz(1:3,B)+neigh%transVec(1:3,iTrB))- xyz(1:3,H)
      drab(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))-(xyz(1:3,B)+neigh%transVec(1:3,iTrB))
      dralp(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))-lp(1:3)
      drblp(1:3)=(xyz(1:3,B)+neigh%transVec(1:3,iTrB))-lp(1:3)

      aterm  = -rdamp*qh*outl_nb_tot*outl_lp*const
      nbterm = -rdamp*qh*outl*outl_lp*const
      lpterm = -rdamp*qh*outl*outl_nb_tot*const
      dterm  = -qhoutl*const

!------------------------------------------------------------------------------
!     damping part: rab
      gi = ( (rabdamp+rbhdamp)*ddamp-3.d0*rabdamp ) / rab2
      gi = gi*dterm
      dg(1:3) = gi*drab(1:3)
      ga(1:3) =  dg(1:3)
      gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!     damping part: rbh
      gi = -3.d0*rbhdamp/rbh2
      gi = gi*dterm
      dg(1:3) = gi*drbh(1:3)
      gb(1:3) = gb(1:3)+dg(1:3)
      gh(1:3) =       - dg(1:3)

!------------------------------------------------------------------------------
!     angular A-H...B term
!------------------------------------------------------------------------------
!     out of line term: rab
      tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
      gi   = -tmp1 *rahprbh/rab2
      dg(1:3) = gi*drab(1:3)
      ga(1:3) = ga(1:3) + dg(1:3)
      gb(1:3) = gb(1:3) - dg(1:3)

!     out of line term: rah,rbh
      gi = tmp1/rah
      dga(1:3) = gi*drah(1:3)
      ga(1:3)  = ga(1:3) + dga(1:3)
      gi = tmp1/rbh
      dgb(1:3) = gi*drbh(1:3)
      gb(1:3)  = gb(1:3) + dgb(1:3)
      dgh(1:3) = -dga(1:3)-dgb(1:3)
      gh(1:3)  =  gh(1:3) + dgh(1:3)

!!------------------------------------------------------------------------------
!!     angular A...LP-B term
!!------------------------------------------------------------------------------
!     out of line term: rab
      tmp3 = -2.d0*lpterm*ratio2_lp*expo_lp/(1+ratio2_lp)**2/(ralpprblp-rab)
      gi   = -tmp3 *ralpprblp/rab2
      dg(1:3) = gi*drab(1:3)
      ga(1:3) = ga(1:3) + dg(1:3)
      gb(1:3) = gb(1:3) - dg(1:3)

!     out of line term: ralp,rblp
      gi = tmp3/ralp
      dga(1:3) = gi*dralp(1:3)
      ga(1:3)  = ga(1:3) + dga(1:3)
      gi = tmp3/(rblp+1.0d-12)
      dgb(1:3) = gi*drblp(1:3)
      gb(1:3)  = gb(1:3) - dga(1:3)
      glp(1:3) = -dga(1:3)!-dgb(1:3)

!     neighbor part: LP
      unit_vec=0
      do i=1,3
         unit_vec(i)=-1
         gii(1:3,i) = -lp_dist * dble(nbb) * ( unit_vec/vnorm + (vector*vector(i)/sum(vector**2)**(1.5d0)) )
         unit_vec=0
      end do
      gnb_lp=matmul(gii,glp)

!------------------------------------------------------------------------------
!     angular A...nb(B)-B term
!------------------------------------------------------------------------------
!     out of line term: rab
      mask_nb=.true.
      do i=1,nbb
         mask_nb(i)=.false.
         tmp2(i)  = 2.d0*nbterm*product(outl_nb,mask_nb)*ratio2_nb(i)*expo_nb(i)/&
                  & (1+ratio2_nb(i))**2/(ranbprbnb(i)-rab)
         gi_nb(i) = -tmp2(i) *ranbprbnb(i)/rab2
         dg(1:3)  = gi_nb(i)*drab(1:3)
         ga(1:3)  = ga(1:3) + dg(1:3)
         gb(1:3)  = gb(1:3) - dg(1:3)
         mask_nb=.true.
      end do

!     out of line term: ranb,rbnb
      do i=1,nbb
         gi_nb(i)   = tmp2(i)/ranb(i)
         dga(1:3)   = gi_nb(i)*dranb(1:3,i)
         ga(1:3)    = ga(1:3) + dga(1:3)
         gi_nb(i)   = tmp2(i)/rbnb(i)
         dgb(1:3)   = gi_nb(i)*drbnb(1:3,i)
         gb(1:3)    = gb(1:3) + dgb(1:3)
         dgnb(1:3)  = -dga(1:3)-dgb(1:3)
         gnb(1:3,i) = dgnb(1:3)
      end do

!------------------------------------------------------------------------------
!     move gradients into place
      gdr(1:3,A) = gdr(1:3,A) + ga(1:3)
      gdr(1:3,B) = gdr(1:3,B) + gb(1:3) + gnb_lp(1:3)
      gdr(1:3,H) = gdr(1:3,H) + gh(1:3)
      do i=1,nbb
         inb=0; iTr=0 ! jth_nb output
         call neigh%jth_nb(n,xyz,inb,i,B,iTr) ! inb is the i-th nb of B when shifted to iTr
         gdr(1:3,inb) = gdr(1:3,inb) + gnb(1:3,i) - gnb_lp(1:3)/dble(nbb)
      end do

      ! sigma according to gdr above
      sigma=sigma+mcf_ehb*spread(ga,1,3)*spread(xyz(:,A)+neigh%transVec(1:3,iTrA),2,3)
      sigma=sigma+mcf_ehb*spread(gb,1,3)*spread(xyz(:,B)+neigh%transVec(1:3,iTrB),2,3)
      sigma=sigma+mcf_ehb*spread(gh,1,3)*spread(xyz(:,H),2,3)
      sigma=sigma+mcf_ehb*spread(gnb_lp,1,3)*spread(xyz(:,B)+neigh%transVec(1:3,iTrB),2,3)
      do i=1,nbb
         inb=0; iTr=0 ! jth_nb output
         call neigh%jth_nb(n,xyz,inb,i,B,iTr) ! inb is the i-th nb of B when shifted to iTr
         vTrinb=neigh%transVec(:,iTr)+neigh%transVec(:,iTrB)
         sigma=sigma+mcf_ehb*spread(gnb(:,i),1,3)*spread(xyz(:,inb)+vTrinb,2,3)
         sigma=sigma-mcf_ehb*spread(gnb_lp(1:3)/dble(nbb),1,3)*spread(xyz(:,inb)+vTrinb,2,3)
      enddo

end subroutine abhgfnff_eg2_rnr

!> case 3: A-H...B, B is 0=C including two in plane LPs at B
!> this is the multiplicative version of incorporationg etors and ebend
!> equal to abhgfnff_eg2_new multiplied by etors and eangl
subroutine abhgfnff_eg3(n,A,B,H,iTrA,iTrB,C,iTrC,at,xyz,q,sqrab,srab,energy,&
                & gdr,param,topo,neigh,sigma,exitRun, mcf_ehb)
      use xtb_mctc_constants
      implicit none
      type(TGFFData), intent(in) :: param
      type(TGFFTopology), intent(in) :: topo
      type(TNeigh), intent(inout) :: neigh
      real(wp), intent(inout)        :: sigma(3,3)
      logical, intent(inout) :: exitRun
      real(wp), intent(in)           :: mcf_ehb
      integer A,B,H,iTrA,iTrB,n,at(n),C,iTrC
      real*8 xyz(3,n),energy,gdr(3,n)
      real*8 q(n)
      real*8 sqrab(n*(n+1)/2)   ! squared dist
      real*8 srab(n*(n+1)/2)    ! dist

      real*8 outl,dampl,damps,rdamp,damp
      real*8 ddamp,rabdamp,rbhdamp
      real*8 ratio1,ratio2,ratio2_nb,ratio3
      real*8 xm,ym,zm
      real*8 rab,rah,rbh,rab2,rah2,rbh2,rah4,rbh4
      real*8 vTrR(3),vTrB(3),vTrC(3)
      real*8 ranb,ranb2,rbnb,rbnb2
      real*8 drah(3),drbh(3),drab(3),drm(3)
      real*8 dranb(3),drbnb(3)
      real*8 dg(3),dga(3),dgb(3),dgh(3),dgnb(3)
      real*8 ga(3),gb(3),gh(3),gnb(3)
      real*8 phi,phi0,r0,t0,fc,tshift,bshift
      real*8 eangl,etors,gangl(3,n),gtors(3,n)
      real*8 etmp(20),g3tmp(3,3),g4tmp(3,4,20)
      real*8 ratio,qhoutl,radab
      real*8 gi,gi_nb
      real*8 tmp1,tmp2
      real*8 rahprbh,ranbprbnb
      real*8 ex1a,ex2a,ex1b,ex2b,ex1h,ex2h,expo,expo_nb
      real*8 eabh
      real*8 aterm,dterm,nbterm,bterm,tterm
      real*8 qa,qb,qh
      real*8 ca(2),cb(2)
      real*8 gqa,gqb,gqh
      real*8 shortcut
      integer tlist(6,sum(neigh%nb(neigh%numnb,C,:)))
      real*8 vtors(2,sum(neigh%nb(neigh%numnb,C,:)))
      real*8 valijklffPBC
      real*8 const
      real*8 outl_nb,outl_nb_tot
      logical mask_nb,t_mask(20)

!     proportion between Rbh und Rab distance dependencies
      real*8 :: p_bh
      real*8 :: p_ab

      integer D
      integer i,j,ii,jj,kk,ll,ij,lina,iTr,iTrDum,iTrR
      integer nbb,nbc
      integer ntors,rn
      real*8 delr

      p_bh=1.d0+param%hbabmix
      p_ab=    -param%hbabmix

      gdr    = 0
      energy = 0
      etors  = 0
      gtors  = 0
      eangl  = 0
      gangl  = 0
      call hbonds(A,B,ca,cb,param,topo)

      !Determine all neighbors for torsion term
      !  A
      !   \         tors:
      !    H        ll
      !     :        \
      !      O        jj
      !      ||       |
      !      C        kk
      !     / \       \
      !    R1  R2      ii
      !------------------------------------------

      nbb=1 ! routine only called for nbb.eq.1
      nbc=sum(neigh%nb(neigh%numnb,C,:))
      ntors=nbc-nbb

!     Neighbours of B
!     compute distances
      dranb(1:3) = (xyz(1:3,A)+neigh%transVec(1:3,iTrA)) - (xyz(1:3,C)+neigh%transVec(1:3,iTrC))
      drbnb(1:3) = (xyz(1:3,B)+neigh%transVec(1:3,iTrB)) - (xyz(1:3,C)+neigh%transVec(1:3,iTrC))
!     A-nb(B) distance
      ranb2 = sum(dranb(1:3)**2)
      ranb  = sqrt(ranb2)
!     B-nb(B) distance
      rbnb2 = sum(drbnb(1:3)**2)
      rbnb  = sqrt(rbnb2)
      rab=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,B)+neigh%transVec(:,iTrB)))
      rab2=rab**2
!     A-H distance
      rah=NORM2((xyz(:,A)+neigh%transVec(:,iTrA))-(xyz(:,H)))
      rah2=rah**2
!     B-H distance
      rbh=NORM2((xyz(:,B)+neigh%transVec(:,iTrB))-xyz(:,H))
      rbh2= rbh**2

      rahprbh=rah+rbh+1.d-12
      radab=param%rad(at(A))+param%rad(at(B))
!
!     out-of-line damp: A-H...B
      expo=(param%hbacut/radab)*(rahprbh/rab-1.d0)
      if(expo.gt.15.0d0) return ! avoid overflow
      ratio2=exp(expo)
      outl=2.d0/(1.d0+ratio2)

!     out-of-line damp: A...nb(B)-B
     ! do i=1,nbb
      ranbprbnb=ranb+rbnb+1.d-12
      expo_nb=(param%hbnbcut/radab)*(ranbprbnb/rab-1.d0)
      ratio2_nb=exp(-expo_nb)
      outl_nb_tot=( 2.d0/(1.d0+ratio2_nb) ) - 1.0d0
     ! end do

!     long damping
      ratio1=(rab2/param%hblongcut)**param%hbalp
      dampl=1.d0/(1.d0+ratio1)

!     short damping
      shortcut=param%hbscut*radab
      ratio3=(shortcut/rab2)**6
      damps=1.d0/(1.d0+ratio3)

      damp  = damps*dampl
      ddamp = (-2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3/(1.d0+ratio3))
      rbhdamp = damp * ( (p_bh/rbh2/rbh) )
      rabdamp = damp * ( (p_ab/rab2/rab) )
      rdamp   = rbhdamp + rabdamp
      !Set up torsion paramter
      j = 0
      do iTr=1, neigh%numctr
        do i = 1,neigh%nb(neigh%numnb,C,iTr)
          if( neigh%nb(i,C,iTr) .eq. B ) cycle
          j = j + 1
          tlist(1,j)=neigh%nb(i,C,iTr) ! R
          tlist(2,j)=B
          tlist(3,j)=C
          tlist(4,j)=H
          tlist(5,j)=2
          tlist(6,j)=neigh%fTrSum(iTr,iTrC)
          ! cycle iTr that are out of sqrt(hbtr2) cutoff
          ! vtors is set up for loop below, therefor the same cycle is included there aswell
          if(tlist(6,j).le.0.or.tlist(6,j).gt.neigh%nTrans) cycle
          vtors(1,j)=pi/2.0
          vtors(2,j)=param%tors_hb
        end do
      enddo
      !Calculate etors
      vTrB=neigh%transVec(:,iTrB)
      vTrC=neigh%transVec(:,iTrC)
      do i = 1,ntors
         ii =tlist(1,i) ! R
         jj =tlist(2,i) ! B
         kk =tlist(3,i) ! C
         ll =tlist(4,i) ! H
         rn =tlist(5,i)
         iTrR=tlist(6,i)
         if(iTrR.le.0.or.iTrR.gt.neigh%nTrans) then
           g4tmp(:,:,i) = 0.0_wp
           etmp(i) = 0.0_wp
           cycle
         endif
         phi0=vtors(1,i)
         tshift=vtors(2,i)
         vTrR=neigh%transVec(:,iTrR)

         phi=valijklffPBC(2,n,xyz,ii,jj,kk,ll,vTrR,vTrB,vTrC)
         call egtors_nci_mul(ii,jj,kk,ll,vTrR,vTrB,vTrC,rn,phi,phi0, &
                           & tshift,n,at,xyz,etmp(i),g4tmp(:,:,i))
      end do
      etors=product(etmp(1:ntors))
      !Calculate gtors
      t_mask=.true.
      do i = 1,ntors
         t_mask(i)=.false.
         ii =tlist(1,i)
         jj =tlist(2,i)
         kk =tlist(3,i)
         ll =tlist(4,i)
         gtors(1:3,ii) = gtors(1:3,ii)+g4tmp(1:3,1,i)*product(etmp(1:ntors),t_mask(1:ntors))
         gtors(1:3,jj) = gtors(1:3,jj)+g4tmp(1:3,2,i)*product(etmp(1:ntors),t_mask(1:ntors))
         gtors(1:3,kk) = gtors(1:3,kk)+g4tmp(1:3,3,i)*product(etmp(1:ntors),t_mask(1:ntors))
         gtors(1:3,ll) = gtors(1:3,ll)+g4tmp(1:3,4,i)*product(etmp(1:ntors),t_mask(1:ntors))
         t_mask=.true.
      end do

      !Calculate eangl + gangl
      r0=120
      phi0=r0*pi/180.
      bshift=param%bend_hb
      fc=1.0d0-bshift
      call egbend_nci_mul(jj,kk,ll,vTrB,vTrC,phi0,fc,n,at,xyz,eangl,g3tmp)
      gangl(1:3,jj)=gangl(1:3,jj)+g3tmp(1:3,1)
      gangl(1:3,kk)=gangl(1:3,kk)+g3tmp(1:3,2)
      gangl(1:3,ll)=gangl(1:3,ll)+g3tmp(1:3,3)

!     hydrogen charge scaled term
      ex1h=exp(param%hbst*q(H))
      ex2h=ex1h+param%hbsf
      qh=ex1h/ex2h

!     hydrogen charge scaled term
      ex1a=exp(-param%hbst*q(A))
      ex2a=ex1a+param%hbsf
      qa=ex1a/ex2a

!     hydrogen charge scaled term
      ex1b=exp(-param%hbst*q(B))
      ex2b=ex1b+param%hbsf
      qb=ex1b/ex2b

      qhoutl=qh*outl*outl_nb_tot

!     constant values, no gradient
      const = ca(2)*qa*cb(1)*qb*param%xhaci_coh
!     energy
      energy = -rdamp*qhoutl*eangl*etors*const
!     gradient
      drah(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))- xyz(1:3,H)
      drbh(1:3)=(xyz(1:3,B)+neigh%transVec(1:3,iTrB))- xyz(1:3,H)
      drab(1:3)=(xyz(1:3,A)+neigh%transVec(1:3,iTrA))-(xyz(1:3,B)+neigh%transVec(1:3,iTrB))

      aterm  = -rdamp*qh*outl_nb_tot*eangl*etors*const
      nbterm = -rdamp*qh*outl*eangl*etors*const
      dterm  = -qhoutl*eangl*etors*const
      tterm  = -rdamp*qhoutl*eangl*const
      bterm  = -rdamp*qhoutl*etors*const

!------------------------------------------------------------------------------
!     damping part: rab
      gi = ( (rabdamp+rbhdamp)*ddamp-3.d0*rabdamp ) / rab2
      gi = gi*dterm
      dg(1:3) = gi*drab(1:3)
      ga(1:3) =  dg(1:3)
      gb(1:3) = -dg(1:3)

!------------------------------------------------------------------------------
!     damping part: rbh
      gi = -3.d0*rbhdamp/rbh2
      gi = gi*dterm
      dg(1:3) = gi*drbh(1:3)
      gb(1:3) = gb(1:3)+dg(1:3)
      gh(1:3) =       - dg(1:3)

!------------------------------------------------------------------------------
!     angular A-H...B term
!------------------------------------------------------------------------------
!     out of line term: rab
      tmp1 = -2.d0*aterm*ratio2*expo/(1+ratio2)**2/(rahprbh-rab)
      gi   = -tmp1 *rahprbh/rab2
      dg(1:3) = gi*drab(1:3)
      ga(1:3) = ga(1:3) + dg(1:3)
      gb(1:3) = gb(1:3) - dg(1:3)

!     out of line term: rah,rbh
      gi = tmp1/rah
      dga(1:3) = gi*drah(1:3)
      ga(1:3)  = ga(1:3) + dga(1:3)
      gi = tmp1/rbh
      dgb(1:3) = gi*drbh(1:3)
      gb(1:3)  = gb(1:3) + dgb(1:3)
      dgh(1:3) = -dga(1:3)-dgb(1:3)
      gh(1:3)  =  gh(1:3) + dgh(1:3)

!------------------------------------------------------------------------------
!     angular A...nb(B)-B term
!------------------------------------------------------------------------------
!     out of line term: rab
      tmp2  = 2.d0*nbterm*ratio2_nb*expo_nb/(1+ratio2_nb)**2/(ranbprbnb-rab)
      gi_nb = -tmp2 *ranbprbnb/rab2
      dg(1:3)  = gi_nb*drab(1:3)
      ga(1:3)  = ga(1:3) + dg(1:3)
      gb(1:3)  = gb(1:3) - dg(1:3)

!     out of line term: ranb,rbnb
         gi_nb   = tmp2/ranb
         dga(1:3)   = gi_nb*dranb(1:3)
         ga(1:3)    = ga(1:3) + dga(1:3)
         gi_nb   = tmp2/rbnb
         dgb(1:3)   = gi_nb*drbnb(1:3)
         gb(1:3)    = gb(1:3) + dgb(1:3)
         dgnb(1:3)  = -dga(1:3)-dgb(1:3)
         gnb(1:3) = dgnb(1:3)

!------------------------------------------------------------------------------
!     torsion term H...B=C<R1,R2
!------------------------------------------------------------------------------
      do i = 1,ntors
         ii =tlist(1,i)
         gdr(1:3,ii) = gdr(1:3,ii)+gtors(1:3,ii)*tterm
      end do
      gdr(1:3,jj) = gdr(1:3,jj)+gtors(1:3,jj)*tterm
      gdr(1:3,kk) = gdr(1:3,kk)+gtors(1:3,kk)*tterm
      gdr(1:3,ll) = gdr(1:3,ll)+gtors(1:3,ll)*tterm

!------------------------------------------------------------------------------
!     angle term H...B=C
!------------------------------------------------------------------------------
      gdr(1:3,jj) = gdr(1:3,jj)+gangl(1:3,jj)*bterm
      gdr(1:3,kk) = gdr(1:3,kk)+gangl(1:3,kk)*bterm
      gdr(1:3,ll) = gdr(1:3,ll)+gangl(1:3,ll)*bterm
      ! sigma
      sigma=sigma+mcf_ehb*spread(ga,1,3)*spread(xyz(:,A)+neigh%transVec(1:3,iTrA),2,3)
      sigma=sigma+mcf_ehb*spread(gb,1,3)*spread(xyz(:,B)+neigh%transVec(1:3,iTrB),2,3)
      sigma=sigma+mcf_ehb*spread(gh,1,3)*spread(xyz(:,H),2,3)
      sigma=sigma+mcf_ehb*spread(gnb,1,3)*spread(xyz(:,C)+neigh%transVec(1:3,iTrC),2,3)
      ! torsion part
      do i = 1,ntors
         ii =tlist(1,i)
         jj =tlist(2,i)
         kk =tlist(3,i)
         ll =tlist(4,i)
         iTrR=tlist(6,i)
         if(iTrR.le.0.or.iTrR.gt.neigh%nTrans) then
           cycle
         endif
         sigma=sigma+mcf_ehb*spread(gtors(1:3,ii)*tterm,1,3)* &        ! R
                   & spread(xyz(1:3,ii)+neigh%transVec(1:3,iTrR),2,3)
      end do
      ! jj, kk and ll same for every i in loop above (only ii or R changes)
      sigma=sigma+mcf_ehb*spread(gtors(1:3,jj)*tterm,1,3)* &           ! B
                & spread(xyz(:,jj)+neigh%transVec(:,iTrB),2,3)
      sigma=sigma+mcf_ehb*spread(gtors(1:3,kk)*tterm,1,3)* &           ! C
                & spread(xyz(:,kk)+neigh%transVec(:,iTrC),2,3)
      sigma=sigma+mcf_ehb*spread(gtors(1:3,ll)*tterm,1,3)* &           ! H
                & spread(xyz(:,ll),2,3)
      ! angle part
      sigma=sigma+mcf_ehb*spread(gangl(1:3,jj)*bterm,1,3)* &           ! B
                & spread(xyz(:,jj)+neigh%transVec(:,iTrB),2,3)
      sigma=sigma+mcf_ehb*spread(gangl(1:3,kk)*bterm,1,3)* &           ! C
                & spread(xyz(:,kk)+neigh%transVec(:,iTrC),2,3)
      sigma=sigma+mcf_ehb*spread(gangl(1:3,ll)*bterm,1,3)* &           ! H
                & spread(xyz(:,ll),2,3)

!------------------------------------------------------------------------------
!     move gradients into place
      gdr(1:3,A) = gdr(1:3,A) + ga(1:3)
      gdr(1:3,B) = gdr(1:3,B) + gb(1:3)
      gdr(1:3,H) = gdr(1:3,H) + gh(1:3)
     ! B has one neighbor which is C in iTrC
      gdr(1:3,C) = gdr(1:3,C) + gnb(1:3)

end subroutine abhgfnff_eg3


!> XB energy and analytical gradient
subroutine rbxgfnff_eg(n,A,B,X,iTrB,iTrX,at,xyz,q,energy,gdr,param,neigh,sigma)

   implicit none
   type(TGFFData), intent(in) :: param
   integer               :: A,B,X,iTrB,iTrX,n,at(n)
   real*8                :: xyz(3,n)
   real*8,intent(inout)  :: energy,gdr(3,3)
   real*8                :: q(n)
   type(TNeigh), intent(inout) :: neigh
   real(wp), intent(inout)        :: sigma(3,3)

   real*8 outl,dampl,damps,rdamp,damp
   real*8 ratio1,ratio2,ratio3
   real*8 rab,rax,rbx,rab2,rax2,rbx2,rax4,rbx4
   real*8 drax(3),drbx(3),drab(3),drm(3)
   real*8 dg(3),dga(3),dgb(3),dgx(3)
   real*8 gi,ga(3),gb(3),gx(3)
   real*8 ex1_a,ex2_a,ex1_b,ex2_b,ex1_x,ex2_x,expo
   real*8 aterm,dterm
   real*8 qa,qb,qx
   real*8 cx,cb
   real*8 gqa,gqb,gqx
   real*8 shortcut,const

   integer i,j

   gdr =  0
   energy=0

   cb = 1. ! param%xhbas(at(B)) !
   cx = param%xbaci(at(X))

   ! compute distances;  A is in central cell !
   drax(1:3) =  xyz(1:3,A)                          -(xyz(1:3,X)+neigh%transVec(1:3,iTrX))
   drbx(1:3) = (xyz(1:3,B)+neigh%transVec(1:3,iTrB))-(xyz(1:3,X)+neigh%transVec(1:3,iTrX))
   drab(1:3) =  xyz(1:3,A)                          -(xyz(1:3,B)+neigh%transVec(1:3,iTrB))

   ! A-B distance !
   rab2 = sum(drab**2)
   rab  = sqrt(rab2)

   ! A-X distance !
   rax2 = sum(drax**2)
   rax  = sqrt(rax2)+1.d-12

   ! B-X distance !
   rbx2 = sum(drbx**2)
   rbx  = sqrt(rbx2)+1.d-12

   ! out-of-line damp !
   expo   = param%xbacut*((rax+rbx)/rab-1.d0)
   if(expo.gt.15.0d0) return ! avoid overflow !
   ratio2 = exp(expo)
   outl   = 2.d0/(1.d0+ratio2)

   ! long damping !
   ratio1 = (rbx2/param%hblongcut_xb)**param%hbalp
   dampl  = 1.d0/(1.d0+ratio1)

   ! short damping !
   shortcut = param%xbscut*(param%rad(at(A))+param%rad(at(B)))
   ratio3   = (shortcut/rbx2)**param%hbalp
   damps    = 1.d0/(1.d0+ratio3)

   damp  = damps*dampl
   rdamp = damp/rbx2/rbx ! **2

   ! halogen charge scaled term !
   ex1_x = exp(param%xbst*q(X))
   ex2_x = ex1_x+param%xbsf
   qx    = ex1_x/ex2_x

   ! donor charge scaled term !
   ex1_b = exp(-param%xbst*q(B))
   ex2_b = ex1_b+param%xbsf
   qb    = ex1_b/ex2_b

   ! constant values, no gradient !
   const = cb*qb*cx*qx

   ! r^3 only slightly better than r^4 !
   aterm = -rdamp*const
   dterm = -outl*const
   energy= -rdamp*outl*const

   ! damping part rab !
   gi = rdamp*(-(2.d0*param%hbalp*ratio1/(1.d0+ratio1))+(2.d0*param%hbalp*ratio3&
   &     /(1.d0+ratio3))-3.d0)/rbx2   ! 4,5,6 instead of 3 !
   gi = gi*dterm
   dg(1:3) = gi*drbx(1:3)
   gb(1:3) =  dg(1:3)
   gx(1:3) = -dg(1:3)

   ! out of line term: rab !
   gi =2.d0*ratio2*expo*(rax+rbx)/(1.d0+ratio2)**2/(rax+rbx-rab)/rab2
   gi = gi*aterm
   dg(1:3) = gi*drab(1:3)
   ga(1:3) =         + dg(1:3)
   gb(1:3) = gb(1:3) - dg(1:3)

   ! out of line term: rax,rbx !
   gi = -2.d0*ratio2*expo/(1.d0+ratio2)**2/(rax+rbx-rab)/rax
   gi = gi*aterm
   dga(1:3) = gi*drax(1:3)
   ga(1:3) = ga(1:3) + dga(1:3)
   gi = -2.d0*ratio2*expo/(1.d0+ratio2)**2/(rax+rbx-rab)/rbx
   gi = gi*aterm
   dgb(1:3) = gi*drbx(1:3)
   gb(1:3) = gb(1:3) + dgb(1:3)
   dgx(1:3) = -dga(1:3) - dgb(1:3)
   gx(1:3) = gx(1:3) + dgx(1:3)

   ! move gradients into place !
   gdr(1:3,1) = ga(1:3)
   gdr(1:3,2) = gb(1:3)
   gdr(1:3,3) = gx(1:3)
   ! sigma
   sigma=sigma+spread(ga,1,3)*spread(xyz(:,A),2,3)
   sigma=sigma+spread(gb,1,3)*spread(xyz(:,B)+neigh%transVec(:,iTrB),2,3)
   sigma=sigma+spread(gx,1,3)*spread(xyz(:,X)+neigh%transVec(:,iTrX),2,3)

   return

end subroutine rbxgfnff_eg

!> taken from D3 ATM code
subroutine batmgfnff_eg(n,iat,jat,kat,iTrj,iTrk,at,xyz,q,sqrab,srab,energy,g,ds,param,neigh)
   implicit none
   type(TGFFData), intent(in) :: param
   type(TNeigh), intent(inout) :: neigh
   integer, intent(in) :: iat,jat,kat,n,at(n),iTrj,iTrk
   real*8, intent(in) :: xyz(3,n),q(n)
   real*8, intent(out) :: energy,g(3,3),ds(3,3)
   real*8, intent(in) :: sqrab(n*(n+1)/2)   ! squared dist
   real*8, intent(in) :: srab (n*(n+1)/2)   ! dist

   real*8 r2ij,r2jk,r2ik,c9,mijk,imjk,ijmk,rijk3,ang,angr9,rav3
   real*8 rij(3),rik(3),rjk(3),ri(3),rj(3),rk(3),drij,drik,drjk,dang,ff,fi,fj,fk,fqq
   parameter (fqq=3.0d0)
   integer :: linij,linik,linjk,lina,i,j,iTrDum,dm1,dm2
   lina(i,j)=min(i,j)+max(i,j)*(max(i,j)-1)/2

   fi=(1.d0-fqq*q(iat))
   fi=min(max(fi,-4.0d0),4.0d0)
   fj=(1.d0-fqq*q(jat))
   fj=min(max(fj,-4.0d0),4.0d0)
   fk=(1.d0-fqq*q(kat))
   fk=min(max(fk,-4.0d0),4.0d0)
   ff=fi*fj*fk ! charge term
   c9=ff*param%zb3atm(at(iat))*param%zb3atm(at(jat))*param%zb3atm(at(kat)) ! strength of interaction
   r2ij=NORM2(xyz(:,iat)-(xyz(:,jat)+neigh%transVec(:,iTrj)))**2
   r2ik=NORM2(xyz(:,iat)-(xyz(:,kat)+neigh%transVec(:,iTrk)))**2
   iTrDum=neigh%fTrSum(neigh%iTrNeg(iTrj),iTrk)
   if(iTrDum.le.0.or.iTrDum.gt.neigh%numctr) then
      r2jk=NORM2((xyz(:,kat)+neigh%transVec(:,iTrk))-(xyz(:,jat)+neigh%transVec(:,iTrj)))**2
   else
      r2jk=NORM2(xyz(:,jat)-(xyz(:,kat)+neigh%transVec(:,iTrDum)))**2
   endif
   mijk=-r2ij+r2jk+r2ik
   imjk= r2ij-r2jk+r2ik
   ijmk= r2ij+r2jk-r2ik
   rijk3=r2ij*r2jk*r2ik
   rav3=rijk3**1.5 ! R^9
   ang=0.375d0*ijmk*imjk*mijk/rijk3
   angr9=(ang +1.0d0)/rav3
   energy=c9*angr9 ! energy

!     derivatives of each part w.r.t. r_ij,jk,ik
           dang=-0.375d0*(r2ij**3+r2ij**2*(r2jk+r2ik) &
  &             +r2ij*(3.0d0*r2jk**2+2.0*r2jk*r2ik+3.0*r2ik**2) &
  &             -5.0*(r2jk-r2ik)**2*(r2jk+r2ik)) &
  &             /(sqrt(r2ij)*rijk3*rav3)
           drij=-dang*c9
           dang=-0.375d0*(r2jk**3+r2jk**2*(r2ik+r2ij) &
  &             +r2jk*(3.0d0*r2ik**2+2.0*r2ik*r2ij+3.0*r2ij**2) &
  &             -5.0*(r2ik-r2ij)**2*(r2ik+r2ij)) &
  &             /(sqrt(r2jk)*rijk3*rav3)
           drjk=-dang*c9
           dang=-0.375d0*(r2ik**3+r2ik**2*(r2jk+r2ij) &
  &             +r2ik*(3.0d0*r2jk**2+2.0*r2jk*r2ij+3.0*r2ij**2) &
  &             -5.0*(r2jk-r2ij)**2*(r2jk+r2ij)) &
  &             /(sqrt(r2ik)*rijk3*rav3)
           drik=-dang*c9

   rij=xyz(:,jat)-xyz(:,iat)+neigh%transVec(:,iTrj)
   rik=xyz(:,kat)-xyz(:,iat)+neigh%transVec(:,iTrk)
   if(iTrDum.le.0.or.iTrDum.gt.neigh%numctr) then
      rjk=(xyz(:,kat)+neigh%transVec(:,iTrk))-(xyz(:,jat)+neigh%transVec(:,iTrj))
   else
      rjk=xyz(:,kat)-xyz(:,jat)+neigh%transVec(:,iTrDum)
   endif
   g(:,1  )=         drij*rij/sqrt(r2ij)
   g(:,1  )=g(:,1  )+drik*rik/sqrt(r2ik)
   g(:,2  )=         drjk*rjk/sqrt(r2jk)
   g(:,2  )=g(:,2  )-drij*rij/sqrt(r2ij)
   g(:,3  )=        -drik*rik/sqrt(r2ik)
   g(:,3  )=g(:,3  )-drjk*rjk/sqrt(r2jk)

   if(neigh%nTrans.ne.1) then
     ri = xyz(:,iat)
     rj = xyz(:,jat)+neigh%transVec(:,iTrj)
     rk = xyz(:,kat)+neigh%transVec(:,iTrk)
     do dm1=1, 3                            
       do dm2=dm1,3                        
         ds(dm1,dm2) =    (drij*rij(dm2)/sqrt(r2ij))*ri(dm1)  & ! i derivatives
                      & + (drik*rik(dm2)/sqrt(r2ik))*ri(dm1)  &
                      & + (drjk*rjk(dm2)/sqrt(r2jk))*rj(dm1)  & ! j derivatives
                      & - (drij*rij(dm2)/sqrt(r2ij))*rj(dm1)  &
                      & - (drik*rik(dm2)/sqrt(r2ik))*rk(dm1)  & ! k derivatives
                      & - (drjk*rjk(dm2)/sqrt(r2jk))*rk(dm1) 
         ds(dm2,dm1) = ds(dm1,dm2)     
       enddo                                 
     enddo                                   
   endif

end subroutine batmgfnff_eg

!> torsion term for rotation around triple bonded carbon
subroutine sTors_eg(m, n, xyz, topo, energy, dg)
   use xtb_mctc_accuracy, only : wp
   
   integer, intent(in) :: m
   integer, intent(in) :: n
   real(wp), intent(in) :: xyz(3,n)
   type(TGFFTopology), intent(in) :: topo
   real(wp), intent(out) :: energy
   real(wp), intent(out) :: dg(3,n)
   integer :: c1,c2,c3,c4
   integer :: i

   !> torsion angle between C1-C4
   real(wp) :: phi, valijklff  
   real(wp) :: erefhalf  
   real(wp) :: dp1(3),dp2(3),dp3(3),dp4(3)

   energy = 0.0_wp
   dg(:,:) = 0.0_wp

   if ( .not. any(topo%sTorsl(:,m) .eq. 0)) then
      
      c1 = topo%sTorsl(1,m)
      c2 = topo%sTorsl(2,m)
      c3 = topo%sTorsl(5,m)
      c4 = topo%sTorsl(6,m)

      ! dihedral angle in radians!
      phi=valijklff(n,xyz,c1,c2,c3,c4)
      call dphidr(n,xyz,c1,c2,c3,c4,phi,dp1,dp2,dp3,dp4)
      
      ! reference energy for torsion of 90° !
      ! calculated with DLPNO-CCSD(T) CBS on diphenylacetylene !
      erefhalf = 3.75_wp*1.0e-4_wp  ! approx 1.97 kJ/mol !
      energy = -erefhalf*cos(2.0_wp*phi) + erefhalf 
      do i=1, 3
         dg(i, c1) = dg(i, c1) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp1(i)
         dg(i, c2) = dg(i, c2) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp2(i)
         dg(i, c3) = dg(i, c3) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp3(i)
         dg(i, c4) = dg(i, c4) + erefhalf*2.0_wp*sin(2.0_wp*phi)*dp4(i)
      enddo
   endif

end subroutine sTors_eg


!> CN routines
!> logCN derivative saved in dlogCN array
subroutine gfnff_dlogcoord(n,at,xyz,rab,logCN,dlogCN,thr2,param)
   use xtb_mctc_accuracy, only : wp
   implicit none
   
   type(TGFFData), intent(in) :: param
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(in)  :: rab(n*(n+1)/2)
   real(wp),intent(out) :: logCN(n)
   real(wp),intent(out) :: dlogCN(3,n,n)
   real(wp),intent(in)  :: thr2
   real(wp)             :: cn(n)
   
   !> counter
   integer  :: i,j,ij,ii
   
   !> distances
   real(wp) :: r
   
   real(wp) :: r0
   real(wp) :: dr
   real(wp), dimension(3) :: rij
   
   !> treshold
   real(wp) :: thr
   
   !> cn parameter
   real(wp) :: erfCN
   
   real(wp) :: dlogdcni
   real(wp) :: dlogdcnj
   real(wp) :: derivative
   
   !> local parameter
   real(wp),parameter :: kn = -7.5_wp
   
   cn     = 0.0_wp
   logCN  = 0.0_wp
   dlogCN = 0.0_wp
   dlogdcni = 0.0_wp
   dlogdcnj = 0.0_wp
   derivative = 0.0_wp
   r   = 0.0_wp
   r0  = 0.0_wp
   rij = 0.0_wp
   thr = sqrt(thr2)
   
   ! create error function CN !
   do i = 2, n
      ii=i*(i-1)/2
      do j = 1, i-1
         ij = ii+j
         r = rab(ij)
         if (r.gt.thr) cycle
         r0=(param%rcov(at(i))+param%rcov(at(j)))
         dr = (r-r0)/r0
         ! hier kommt die CN funktion hin !
         ! erfCN = create_expCN(16.0d0,r,r0) !
         erfCN = 0.5_wp * (1.0_wp + erf(kn*dr))
         cn(i) = cn(i) + erfCN
         cn(j) = cn(j) + erfCN
      enddo
   enddo
   
   ! create cutted logarithm CN + derivatives !
   do i = 1, n
      ii=i*(i-1)/2
      logCN(i) = create_logCN(cn(i),param)
      
      ! get dlogCN/dCNi !
      dlogdcni = create_dlogCN(cn(i),param)
      do j = 1, i-1
         ij = ii+j
         
         ! get dlogCN/dCNj !
         dlogdcnj = create_dlogCN(cn(j),param)
         r = rab(ij)
         if (r.gt.thr) cycle
         r0 = (param%rcov(at(i)) + param%rcov(at(j)))
         
         ! get derfCN/dRij !
         derivative = create_derfCN(kn,r,r0)
         
         ! derivative = create_dexpCN(16.0d0,r,r0) !
         rij  = derivative*(xyz(:,j) - xyz(:,i))/r
         
         ! project rij gradient onto cartesians !
         dlogCN(:,j,j)= dlogdcnj*rij + dlogCN(:,j,j)
         dlogCN(:,i,j)=-dlogdcnj*rij
         dlogCN(:,j,i)= dlogdcni*rij
         dlogCN(:,i,i)=-dlogdcni*rij + dlogCN(:,i,i)
      enddo
   enddo

contains

pure elemental function create_logCN(cn,param) result(count)
   
   use xtb_mctc_accuracy, only : wp

   type(TGFFData), intent(in) :: param
   real(wp), intent(in) :: cn
   real(wp) :: count
   
   count = log(1 + exp(param%cnmax)) - log(1 + exp(param%cnmax - cn) )

end function create_logCN

pure elemental function create_dlogCN(cn,param) result(count)
   
   use xtb_mctc_accuracy, only : wp
   
   type(TGFFData), intent(in) :: param
   real(wp), intent(in) :: cn
   real(wp) :: count
   
   count = exp(param%cnmax)/(exp(param%cnmax) + exp(cn))

end function create_dlogCN

pure elemental function create_erfCN(k,r,r0) result(count)
   
   use xtb_mctc_accuracy, only : wp
   
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   real(wp) :: dr
   
   dr = (r -r0)/r0
   count = 0.5_wp * (1.0_wp + erf(kn*dr))

end function create_erfCN

pure elemental function create_derfCN(k,r,r0) result(count)
   
   use xtb_mctc_accuracy, only : wp
   
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp), parameter :: sqrtpi = 1.77245385091_wp
   real(wp) :: count
   real(wp) :: dr
   
   dr = (r -r0)/r0
   count = k/sqrtpi*exp(-k**2*dr*dr)/r0

end function create_derfCN

pure elemental function create_expCN(k,r,r0) result(count)
   
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   
   count =1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))

end function create_expCN

pure elemental function create_dexpCN(k,r,r0) result(count)
   
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   real(wp) :: expterm
   
   expterm=exp(-k*(r0/r-1._wp))
   count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))

end function create_dexpCN

end subroutine gfnff_dlogcoord

!> Actual implementation of the coordination number, takes a generic counting
!  function to return the respective CN.
subroutine ncoordNeighs(mol, neighs, neighlist, kcn, cfunc, dfunc, enscale, &
      & rcov, en, cn, dcndr, dcndL)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Number of interacting neighbours
   integer, intent(in) :: neighs(:)

   !> Neighbourlist
   type(TNeighbourList), target, intent(in) :: neighlist

   !> Function implementing the counting function
   procedure(countingFunction) :: cfunc

   !> Function implementing the derivative of counting function w.r.t. distance
   procedure(countingFunction) :: dfunc

   !> Use a covalency criterium by Pauling EN's
   logical, intent(in) :: enscale

   !> Steepness of counting function
   real(wp), intent(in) :: kcn

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(out) :: dcndL(:, :, :)

   integer :: iat, jat, ati, atj, ij, img
   real(wp) :: r2, r1, rc, rij(3), countf, countd(3), stress(3, 3), den

   cn = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp

   !$omp parallel do default(none) private(den) shared(enscale, rcov, en)&
   !$omp reduction(+:cn, dcndr, dcndL) shared(mol, kcn, neighlist, neighs) &
   !$omp private(ij, img, jat, ati, atj, r2, rij, r1, rc, countf, countd, stress)
   do iat = 1, mol%n
      ati = mol%at(iat)
      do ij = 1, neighs(iat)
         img = neighlist%iNeigh(ij, iat)
         r2 = neighlist%dist2(ij, iat)
         rij = neighlist%coords(:, iat) - neighlist%coords(:, img)
         jat = neighlist%image(img)
         atj = mol%at(jat)
         r1 = sqrt(r2)

         rc = rcov(ati) + rcov(atj)

         if (enscale) then
            den = k4*exp(-(abs(en(ati)-en(atj)) + k5)**2/k6)
         else
            den = 1.0_wp
         endif

         countf = den * cfunc(kcn, r1, rc)
         countd = den * dfunc(kcn, r1, rc) * rij/r1

         cn(iat) = cn(iat) + countf
         if (iat /= jat) then
            cn(jat) = cn(jat) + countf
         endif

         dcndr(:, iat, iat) = dcndr(:, iat, iat) + countd
         dcndr(:, jat, jat) = dcndr(:, jat, jat) - countd
         dcndr(:, iat, jat) = dcndr(:, iat, jat) + countd
         dcndr(:, jat, iat) = dcndr(:, jat, iat) - countd

         stress = spread(countd, 1, 3) * spread(rij, 2, 3)

         dcndL(:, :, iat) = dcndL(:, :, iat) + stress
         if (iat /= jat) then
            dcndL(:, :, jat) = dcndL(:, :, jat) + stress
         endif

      enddo
   enddo
   !$omp end parallel do

end subroutine ncoordNeighs


!> Geometric fractional coordination number, supports both error function
!  and exponential counting functions.
subroutine getCoordinationNumberLP(mol, ntrans, trans, cutoff, cf, cn, dcndr, dcndL, param)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Number of lattice points
   integer, intent(in) :: ntrans

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Coordination number type (by counting function)
   integer, intent(in) :: cf

   ! parameter type, holds cnmax
   type(TGFFData), intent(in) :: param

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(out) :: dcndL(:, :, :)

   real(wp), parameter :: kcn_exp = 16.0_wp
   real(wp), parameter :: kcn_erf =  7.5_wp
   real(wp), parameter :: kcn_gfn = 10.0_wp

   select case(cf)
   case(cnType%exp)
      call ncoordLatP(mol, ntrans, trans, cutoff, kcn_exp, expCount, dexpCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%erf)
      call ncoordLatP(mol, ntrans, trans, cutoff, kcn_erf, erfCount, derfCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%cov)
      call ncoordLatP(mol, ntrans, trans, cutoff, kcn_erf, erfCount, derfCount, &
         & .true., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%gfn)
      call ncoordLatP(mol, ntrans, trans, cutoff, kcn_gfn, gfnCount, dgfnCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%log)
      call ncoordLatP(mol, ntrans, trans, cutoff, kcn_erf, erfCount, derfCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
      ! calculate modified CN and derivatives
      call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, param%cnmax)

   end select


end subroutine getCoordinationNumberLP


!> Actual implementation of the coordination number, takes a generic counting
!  function to return the respective CN.
subroutine ncoordLatP(mol, ntrans, trans, cutoff, kcn, cfunc, dfunc, enscale, &
      & rcov, en, cn, dcndr, dcndL)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Number of lattice points
   integer, intent(in) :: ntrans

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Function implementing the counting function
   procedure(countingFunction) :: cfunc

   !> Function implementing the derivative of counting function w.r.t. distance
   procedure(countingFunction) :: dfunc

   !> Use a covalency criterium by Pauling EN's
   logical, intent(in) :: enscale

   !> Steepness of counting function
   real(wp), intent(in) :: kcn

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out) :: dcndL(:, :, :)

   integer :: iat, jat, ati, atj, itr 
   real(wp) :: r2, r1, rc, rij(3), countf, countd(3), stress(3, 3), den, cutoff2

   cn = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp
   cutoff2 = cutoff**2
   !$omp parallel do default(none) private(den) shared(enscale, rcov, en)&
   !$omp reduction(+:cn, dcndr, dcndL) shared(mol, kcn, trans, cutoff2, ntrans) &
   !$omp private(jat, itr, ati, atj, r2, rij, r1, rc, countf, countd, stress)
   do iat = 1, mol%n
      ati = mol%at(iat)
      do jat = 1, iat
         atj = mol%at(jat)

         if (enscale) then
            den = k4*exp(-(abs(en(ati)-en(atj)) + k5)**2/k6)
         else
            den = 1.0_wp
         end if

         do itr = 1, ntrans
            rij = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, itr))
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            rc = rcov(ati) + rcov(atj)

            countf = den * cfunc(kcn, r1, rc)
            countd = den * dfunc(kcn, r1, rc) * rij/r1

            cn(iat) = cn(iat) + countf
            if (iat.ne.jat.or.itr.ne.1) then
               cn(jat) = cn(jat) + countf
            end if

            dcndr(:, iat, iat) = dcndr(:, iat, iat) + countd
            dcndr(:, jat, jat) = dcndr(:, jat, jat) - countd
            dcndr(:, iat, jat) = dcndr(:, iat, jat) + countd
            dcndr(:, jat, iat) = dcndr(:, jat, iat) - countd

            stress = spread(countd, 1, 3) * spread(rij, 2, 3)

            dcndL(:, :, iat) = dcndL(:, :, iat) + stress
            if (iat.ne.jat.or.itr.ne.1) then
               dcndL(:, :, jat) = dcndL(:, :, jat) + stress
            end if
         end do
     end do
   end do

   !$omp end parallel do

end subroutine ncoordLatP


!> Error function counting function for coordination number contributions.
pure function erfCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = 0.5_wp * (1.0_wp + erf(-k*(r-r0)/r0))

end function erfCount


!> Derivative of the counting function w.r.t. the distance.
pure function derfCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp), parameter :: sqrtpi = sqrt(pi)

   real(wp) :: count

   count = -k/sqrtpi/r0*exp(-k**2*(r-r0)**2/r0**2)

end function derfCount


!> Exponential counting function for coordination number contributions.
pure function expCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count =1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))

end function expCount


!> Derivative of the counting function w.r.t. the distance.
pure function dexpCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count
   real(wp) :: expterm

   expterm = exp(-k*(r0/r-1._wp))

   count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))

end function dexpCount


!> Exponential counting function for coordination number contributions.
pure function gfnCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = expCount(k, r, r0) * expCount(2*k, r, r0+2)

end function gfnCount


!> Derivative of the counting function w.r.t. the distance.
pure function dgfnCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = dexpCount(k, r, r0) * expCount(2*k, r, r0+2) &
      &  + expCount(k, r, r0) * dexpCount(2*k, r, r0+2)

end function dgfnCount


!> Cutoff function for large coordination numbers
pure subroutine cutCoordinationNumber(nAtom, cn, dcndr, dcndL, maxCN)

   !> number of atoms
   integer, intent(in) :: nAtom

   !> on input coordination number, on output modified CN
   real(wp), intent(inout) :: cn(:)

   !> on input derivative of CN w.r.t. cartesian coordinates,
   !> on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndr(:, :, :)

   !> on input derivative of CN w.r.t. strain deformation,
   !> on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndL(:, :, :)

   !> maximum CN (not strictly obeyed)
   real(wp), intent(in), optional :: maxCN

   real(wp) :: cnmax
   integer :: iAt

   if (present(maxCN)) then
      cnmax = maxCN
   else
      cnmax = 4.5_wp
   end if

   if (cnmax <= 0.0_wp) return

   if (present(dcndL)) then
      do iAt = 1, nAtom
         dcndL(:, :, iAt) = dcndL(:, :, iAt) * dCutCN(cn(iAt), cnmax)
      end do
   end if

   if (present(dcndr)) then
      do iAt = 1, nAtom
         dcndr(:, :, iAt) = dcndr(:, :, iAt) * dCutCN(cn(iAt), cnmax)
      end do
   end if

   do iAt = 1, nAtom
      cn(iAt) = cutCN(cn(iAt), cnmax)
   end do

end subroutine cutCoordinationNumber


!> Cutting function for the coordination number.
elemental function cutCN(cn, cut) result(cnp)

   !> Current coordination number.
   real(wp), intent(in) :: cn

   !> Cutoff for the CN, this is not the maximum value.
   real(wp), intent(in) :: cut

   !> Cuting function vlaue
   real(wp) :: cnp

   cnp = log(1.0_wp + exp(cut)) - log(1.0_wp + exp(cut - cn))

end function cutCN


!> Derivative of the cutting function w.r.t. coordination number
elemental function dCutCN(cn, cut) result(dcnpdcn)

   !> Current coordination number.
   real(wp), intent(in) :: cn

   !> Cutoff for the CN, this is not the maximum value.
   real(wp), intent(in) :: cut

   !> Derivative of the cutting function
   real(wp) :: dcnpdcn

   dcnpdcn = exp(cut)/(exp(cut) + exp(cn))

end function dCutCn

function get_cf(rTrans,gTrans,vol,avgAlp) result(cf)
  ! output the ewald splitting parameter
  real(wp) :: cf
  ! parameter from goed_pbc_gfnff ewaldCutD and ewaldCutR
  integer, parameter :: ewaldCutD(3) = 2
  integer, parameter :: ewaldCutR(3) = 2
  ! real space lattice vectors
  real(wp), intent(in) :: rTrans( 3, product(2*ewaldCutD+1))
  ! reciprocal space lattice vectors
  real(wp), intent(in) :: gTrans(3, product(2*ewaldCutR+1)-1)
  ! unit cell volume 
  real(wp), intent(in) :: vol
  ! average alphaEEQ value
  real(wp), intent(in) :: avgAlp
  ! smallest reciprocal and real space Vectors
  real(wp) :: minG, minR
  ! approx Value of reciprocal and real part electrostatics
  real(wp) :: gPart, rPart
  ! 
  real(wp) :: gam
  ! current cf
  real(wp) :: cfCurr
  !
  real(wp) :: lenR, minTmp, gr_diff,diffMin
  real(wp) :: a(100)
  ! tolerance for golden-section search
  real(wp), parameter :: tol = 1.0e-4_wp
  ! golden ratio
  real(wp), parameter :: goldr = (1.0_wp+sqrt(2.0_wp))/2.0_wp
  ! evaluation points for gss
  real(wp) :: x1, x2, x3, x4
  ! 
  integer :: i,j,iter


  cf = 0.14999_wp ! default
  gam = 1.0_wp/sqrt(2*avgAlp)

  ! get smallest real and reciprocal vector
  minG = sqrt(minval(sum(gTrans(:,:)**2, dim=1)))
  minR = huge(1.0_wp)
  do i=1, size(rTrans, dim=2)
    lenR = sqrt(sum(rTrans(:,i)**2))
    if(lenR.ne.0.0_wp)then
      minR=min(minR, lenR)
    endif
  enddo

  ! golden-section search algorithm for convergence factor
  iter = 0
  x1 = 1.0e-8_wp  ! left margin
  x4 = 2.0e+0_wp  ! right margin
  x2 = x4 - (x4 - x1)/goldr
  x3 = x1 + (x4 - x1)/goldr
  do while ((x4-x1) > tol)
    iter = iter + 1
    if(grFct(x2,minG,minR,vol,gam).lt.grFct(x3,minG,minR,vol,gam))then
      x4 = x3
    else
      x1 = x2
    endif
    ! recalculate x2 and x3
    x2 = x4 - (x4 - x1)/goldr
    x3 = x1 + (x4 - x1)/goldr
  enddo

  cf = (x1 + x4)/2.0_wp
end function get_cf


function grFct(cfCurr, minG, minR, vol, gam) result(gr_diff)
  real(wp) :: gr_diff
  ! smallest reciprocal and real space Vectors
  real(wp), intent(in) :: cfCurr,minG, minR, vol, gam
  ! approx Value of reciprocal and real part electrostatics
  real(wp) :: gPart, rPart
  
  gPart = 4.0_wp*pi*exp(-minG**2 /(4.0_wp*cfCurr**2))/(vol*minG**2)
  rPart = -erf(cfCurr*minR)/minR + erf(gam*minR)/minR
  gr_diff = abs(gPart-rPart)
end function grFct


subroutine es_grad_sigma(mol, topo, nlist, rTrans, gTrans, xtmp, cf, &
         & sigma, gradient, mcf_ees)
   use xtb_type_molecule
   use xtb_type_param
   type(TMolecule), intent(in) :: mol
   type(TGFFTopology), intent(in) :: topo
   type(TGFFNeighbourList), intent(in) :: nlist
   real(wp), intent(in) :: cf
   !real(wp), intent(in) :: qvec(:)
   real(wp), intent(in) :: gTrans(:, :)
   real(wp), intent(in) :: rTrans(:, :)
   real(wp), intent(in) :: xtmp(mol%n+topo%nfrag)
   real(wp), intent(inout) :: sigma(3,3)
   real(wp), intent(inout) :: gradient(3,mol%n)
   real(wp), intent(in) :: mcf_ees
   real(wp), allocatable :: dXvecdr(:,:,:)
   real(wp), allocatable :: amatdr(:, :, :)
   real(wp), allocatable :: amatdL(:, :, :)
   integer :: m
   real(wp), allocatable :: atrace(:, :)
   m = mol%n+topo%nfrag
   allocate(amatdr(3,mol%n,m), amatdL(3,3,m), source = 0.0_wp)
   allocate(atrace(3, mol%n))
   amatdr = 0.0_wp
   amatdL = 0.0_wp

   ! new routine from D4 for calculating derivatives
   call get_damat_3d(mol, topo, cf, xtmp, rTrans, gTrans, amatdr, amatdL, atrace)


   !Aus mctc/blas/level2.f90: y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y
   call mctc_gemv(amatdr, nlist%q, gradient, alpha=mcf_ees, beta=1.0_wp)
   
   ! Ees=q^T*(0.5*A*q-X)  here is the 0.5qA'q part. The -qX' part is below the es_grad_sigma call
   call mctc_gemv(amatdL, nlist%q, sigma, alpha=0.5_wp*mcf_ees, beta=1.0_wp)


end subroutine es_grad_sigma

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!               code below taken from dftd4                                     !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine get_amat_3d(mol, topo, alpha, rTrans, gTrans, amat)
   type(TMolecule), intent(in) :: mol
   type(TGFFTopology), intent(in) :: topo
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: rTrans(:, :)
   real(wp), intent(in) :: gTrans(:, :)
   real(wp), intent(out) :: amat(:, :)

   integer :: iat, jat, izp, jzp, img
   real(wp) :: vec(3), gam, wsw, dtmp, rtmp, vol
   real(wp), parameter :: zero(3) = 0.0_wp
   real(wp),parameter :: sqrt2pi = sqrt(2.0_wp/pi)
   real(wp), parameter :: sqrtpi = 1.772453850905516_wp

   amat(:, :) = 0.0_wp

   vol = mol%volume ! abs(matdet_3x3(mol%lattice))
   
   !$omp parallel do default(none) schedule(runtime) &
   !$omp reduction(+:amat) shared(mol, topo, rTrans, gTrans, alpha, vol) &
   !$omp private(iat, jat, gam, wsw, vec, dtmp, rtmp)
   do iat = 1, mol%n
      !izp = mol%id(iat)
      do jat = 1, iat-1
         !jzp = mol%id(jat)
         gam = 1.0_wp / sqrt(topo%alpeeq(iat) + topo%alpeeq(jat))
         wsw = mol%wsc%w(jat,iat)
         do img = 1, mol%wsc%itbl(jat,iat)
            vec = mol%xyz(:,iat) - mol%xyz(:,jat) &
               & - (mol%lattice(:,1) * mol%wsc%lattr(1,img,jat,iat) &
               &  + mol%lattice(:,2) * mol%wsc%lattr(2,img,jat,iat) &
               &  + mol%lattice(:,3) * mol%wsc%lattr(3,img,jat,iat))
            call get_amat_dir_3d(vec, gam, alpha, rTrans, dtmp)
            call get_amat_rec_3d(vec, vol, alpha, gTrans, rtmp)
            amat(jat, iat) = amat(jat, iat) + (dtmp + rtmp) * wsw
            amat(iat, jat) = amat(iat, jat) + (dtmp + rtmp) * wsw
         end do
      end do

      gam = 1.0_wp / sqrt(2.0_wp * topo%alpeeq(iat))
      wsw = mol%wsc%w(iat,iat)
      do img = 1, mol%wsc%itbl(iat, iat)
         vec = zero

         call get_amat_dir_3d(vec, gam, alpha, rTrans, dtmp)
         call get_amat_rec_3d(vec, vol, alpha, gTrans, rtmp)
         amat(iat, iat) = amat(iat, iat) + (dtmp + rtmp) * wsw
      end do

      dtmp = topo%gameeq(iat) + sqrt2pi / sqrt(topo%alpeeq(iat)) - 2 * alpha/sqrtpi
      amat(iat, iat) = amat(iat, iat) + dtmp
   end do
   !$omp end parallel do

   amat(mol%n+1, 1:mol%n+1) = 1.0_wp
   amat(1:mol%n+1, mol%n+1) = 1.0_wp
   amat(mol%n+1, mol%n+1) = 0.0_wp

end subroutine get_amat_3d

subroutine get_amat_dir_3d(rij, gam, alp, trans, amat)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: gam
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: vec(3), r1, tmp
   real(wp),parameter :: eps = 1.0e-9_wp

   amat = 0.0_wp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      tmp = erf(gam*r1)/r1 - erf(alp*r1)/r1
      amat = amat + tmp
   end do

end subroutine get_amat_dir_3d

subroutine get_amat_rec_3d(rij, vol, alp, trans, amat)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: vol
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: amat

   integer :: itr
   real(wp) :: fac, vec(3), g2, tmp
   real(wp),parameter :: eps = 1.0e-9_wp

   amat = 0.0_wp
   fac = 4*pi/vol

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      tmp = cos(dot_product(rij, vec)) * fac * exp(-0.25_wp*g2/(alp*alp))/g2
      amat = amat + tmp
   end do

end subroutine get_amat_rec_3d

subroutine get_damat_3d(mol, topo, alpha, qvec, rTrans, gTrans, dadr, dadL, atrace)
   type(TMolecule), intent(in) :: mol
   type(TGFFTopology), intent(in) :: topo
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: qvec(:)
   real(wp), intent(in) :: rTrans(:, :)
   real(wp), intent(in) :: gTrans(:, :)
   real(wp), intent(out) :: dadr(:, :, :)
   real(wp), intent(out) :: dadL(:, :, :)
   real(wp), intent(out) :: atrace(:, :)

   integer :: iat, jat, izp, jzp, img
   real(wp) :: vol, gam, wsw, vec(3), dG(3), dS(3, 3)
   real(wp) :: dGd(3), dSd(3, 3), dGr(3), dSr(3, 3)
   real(wp), parameter :: zero(3) = 0.0_wp

   atrace(:, :) = 0.0_wp
   dadr(:, :, :) = 0.0_wp
   dadL(:, :, :) = 0.0_wp

   vol = mol%volume ! abs(matdet_3x3(mol%lattice))

   !$omp parallel do default(none) schedule(runtime) &
   !$omp reduction(+:atrace, dadr, dadL) &
   !$omp shared(mol, topo, alpha, vol, rTrans, gTrans, qvec) &
   !$omp private(iat, jat, img, gam, wsw, vec, dG, dS, &
   !$omp& dGr, dSr, dGd, dSd)
   do iat = 1, mol%n
      !izp = mol%id(iat)
      do jat = 1, iat-1
         !jzp = mol%id(jat)
         dG(:) = 0.0_wp
         dS(:, :) = 0.0_wp
         gam = 1.0_wp / sqrt(topo%alpeeq(iat) + topo%alpeeq(jat))
         wsw = mol%wsc%w(jat,iat)
         do img = 1, mol%wsc%itbl(jat,iat)
            vec = mol%xyz(:,iat) - mol%xyz(:,jat) &
               & - (mol%lattice(:,1) * mol%wsc%lattr(1,img,jat,iat) &
               &  + mol%lattice(:,2) * mol%wsc%lattr(2,img,jat,iat) &
               &  + mol%lattice(:,3) * mol%wsc%lattr(3,img,jat,iat))
            call get_damat_dir_3d(vec, gam, alpha, rTrans, dGd, dSd)
            call get_damat_rec_3d(vec, vol, alpha, gTrans, dGr, dSr)
            dG = dG + (dGd + dGr) * wsw
            dS = dS + (dSd + dSr) * wsw
         end do
         atrace(:, iat) = +dG*qvec(jat) + atrace(:, iat)
         atrace(:, jat) = -dG*qvec(iat) + atrace(:, jat)
         dadr(:, iat, jat) = +dG*qvec(iat) + dadr(:, iat, jat)
         dadr(:, jat, iat) = -dG*qvec(jat) + dadr(:, jat, iat)
         dadL(:, :, jat) = +dS*qvec(iat) + dadL(:, :, jat)
         dadL(:, :, iat) = +dS*qvec(jat) + dadL(:, :, iat)
      end do

      dS(:, :) = 0.0_wp
      gam = 1.0_wp / sqrt(2.0_wp * topo%alpeeq(iat))
      wsw = mol%wsc%w(iat,iat)
      do img = 1, mol%wsc%itbl(iat, iat)
         vec = zero
         call get_damat_dir_3d(vec, gam, alpha, rTrans, dGd, dSd)
         call get_damat_rec_3d(vec, vol, alpha, gTrans, dGr, dSr)
         dS = dS + (dSd + dSr) * wsw
      end do
      dadL(:, :, iat) = +dS*qvec(iat) + dadL(:, :, iat)
   end do
   !$omp end parallel do

end subroutine get_damat_3d

subroutine get_damat_dir_3d(rij, gam, alp, trans, dg, ds)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: gam
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: dg(3)
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: vec(3), r1, r2, gtmp, atmp, gam2, alp2
   real(wp),parameter :: eps = 1.0e-9_wp
   real(wp), parameter :: sqrtpi = 1.772453850905516_wp

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp

   gam2 = gam*gam
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = rij + trans(:, itr)
      r1 = norm2(vec)
      if (r1 < eps) cycle
      r2 = r1*r1
      gtmp = +2*gam*exp(-r2*gam2)/(sqrtpi*r2) - erf(r1*gam)/(r2*r1)
      atmp = -2*alp*exp(-r2*alp2)/(sqrtpi*r2) + erf(r1*alp)/(r2*r1)
      dg(:) = dg + (gtmp + atmp) * vec
      ds(:, :) = ds + (gtmp + atmp) * spread(vec, 1, 3) * spread(vec, 2, 3)
   end do

end subroutine get_damat_dir_3d

subroutine get_damat_rec_3d(rij, vol, alp, trans, dg, ds)
   real(wp), intent(in) :: rij(3)
   real(wp), intent(in) :: vol
   real(wp), intent(in) :: alp
   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(out) :: dg(3)
   real(wp), intent(out) :: ds(3, 3)

   integer :: itr
   real(wp) :: fac, vec(3), g2, gv, etmp, dtmp, alp2
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1, 0, 0, 0, 1, 0, 0, 0, 1], shape(unity))
   real(wp),parameter :: eps = 1.0e-9_wp

   dg(:) = 0.0_wp
   ds(:, :) = 0.0_wp
   fac = 4*pi/vol
   alp2 = alp*alp

   do itr = 1, size(trans, 2)
      vec(:) = trans(:, itr)
      g2 = dot_product(vec, vec)
      if (g2 < eps) cycle
      gv = dot_product(rij, vec)
      etmp = fac * exp(-0.25_wp*g2/alp2)/g2
      dtmp = -sin(gv) * etmp
      dg(:) = dg + dtmp * vec
      ds(:, :) = ds + etmp * cos(gv) &
         & * ((2.0_wp/g2 + 0.5_wp/alp2) * spread(vec, 1, 3)*spread(vec, 2, 3) - unity)
   end do

end subroutine get_damat_rec_3d
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!               code above taken from dftd4                                     !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



end module xtb_gfnff_eg

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Initialize default values for global variables
module xtb_main_defaults
   use xtb_mctc_accuracy, only : wp
   use xtb_type_calculator, only : TCalculator
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   use xtb_setparam, only : set, p_engine_lbfgs, p_engine_rf
   use xtb_main_setup, only : addSolvationModel
   implicit none
   private

   public :: initDefaults


contains


subroutine initDefaults(env, calc, mol, gsolvstate)

   type(TEnvironment), intent(inout) :: env
   class(TCalculator), intent(inout) :: calc
   type(TMolecule), intent(in) :: mol
   integer, intent(in) :: gsolvstate

   if (.not.allocated(set%opt_engine)) then
      if (mol%n > 500) then
         set%opt_engine = p_engine_lbfgs
      else
         set%opt_engine = p_engine_rf
      end if
   end if

   set%solvInput%state = gsolvstate

   ! Optionally add a solvation model
   call addSolvationModel(env, calc, set%solvInput)

end subroutine initDefaults


end module xtb_main_defaults

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
! but including H in OH

subroutine heavyrmsd(n,nall,k,l,xyz,at,rmsdval)
   use xtb_lsrmsd
   implicit none
   integer n,at(n),j,nall,k,l,nn
   real*8 xyz(3,n,nall),rmsdval

   logical oh,ohbonded

   real*8 ,allocatable :: xyz1(:,:), xyz2(:,:)
   !Dummys:
   real*8  g(3,3), U(3,3), x_center(3), y_center(3)
   real*8, parameter ::bohr=0.52917726d0
   integer i

   nn=0
   do j=1,n
      oh=ohbonded(n,j,xyz(1,1,k),at)
      if(at(j).gt.2.or.oh) nn=nn+1
   enddo
   allocate(xyz1(3,nn),xyz2(3,nn))

   i=0
   do j=1,n
      oh=ohbonded(n,j,xyz(1,1,k),at)
      if(at(j).gt.2.or.oh) then
         i=i+1
         xyz1(1:3,i)=xyz(1:3,j,k)*bohr
         xyz2(1:3,i)=xyz(1:3,j,l)*bohr
      endif
   enddo

   call rmsd(i,xyz1,xyz2,0,U,x_center,y_center,rmsdval,.false.,g)

   deallocate(xyz1,xyz2)
end subroutine

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine heavyrmsdfile(k,l,rmsdval)
   use xtb_lsrmsd
   implicit none
   integer k,l
   real*8 rmsdval
   character*80 atmp1,atmp2,atmp
   !Dummys:
   real*8  g(3,3), U(3,3), x_center(3), y_center(3)
   real*8, parameter ::bohr=0.52917726d0
   integer n,idum
   real*8 ,allocatable :: xyz1(:,:), xyz2(:,:)
   integer,allocatable :: at(:)

   !call getname1(k,atmp1)
   write(atmp1,'(''scoord.'',i0)')k
   !call getname1(l,atmp2)
   write(atmp2,'(''scoord.'',i0)')l
   call rdatomnumber(atmp1,n)
   allocate(xyz1(3,n),xyz2(3,n),at(n))

   !print*,trim(atmp1)
   call rdcoord(trim(atmp1),n,xyz1,at)
   !print*,trim(atmp2)
   call rdcoord(trim(atmp2),n,xyz2,at)
   xyz1 = xyz1 * bohr
   xyz2 = xyz2 * bohr

   call rmsd(n,xyz1,xyz2,0,U,x_center,y_center,rmsdval,.false.,g)

   deallocate(xyz1,xyz2)
end subroutine

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

logical function ohbonded(n,m,xyz,at)
   integer n,at(n),m
   real*8 xyz(3,n)

   ohbonded=.false.
   if(at(m).ne.1) return

   do i=1,n
      if(i.eq.m.or.at(i).ne.8) cycle
      r  =sqrt((xyz(1,i)-xyz(1,m))**2&
         &           +(xyz(2,i)-xyz(2,m))**2&
         &           +(xyz(3,i)-xyz(3,m))**2)
      if(r*0.52917726d0.lt.1.1) ohbonded=.true.
   enddo

end function

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ========================================================================
!  * WELCOME TO THE   C O N S T R A I N S   &   S C A N S   MODULE IN XTB *
!! ------------------------------------------------------------------------
!  The syntax is:
!> $constrain
!> ## this part is read by setparam.f90
!>    force constant=<real>
!>    all bonds=<bool>
!>    all angles=<bool>
!>    all torsions=<bool>
!> ## this part is read in this module
!>    distance: <i>,<j>,        auto
!>    distance: <i>,<j>,        <real>
!>    angle:    <i>,<j>,<k>,    auto
!>    angle:    <i>,<j>,<k>,    <real>
!>    dihedral: <i>,<j>,<k>,<l>,auto
!>    dihedral: <i>,<j>,<k>,<l>,<real>
!>    center:   <int>,<real>
!> $fix
!>    force constant=<real>
!>    spring exponent=<int>
!>    atoms: <list>
!> $split
!>    fragment1: <list>
!>    fragment2: <list>
!> $wall
!>    sphere: auto,all
!>    sphere: auto,<list>
!>    sphere: <real>,all
!>    sphere: <real>,<list>
!>    ellipsoid: auto,all
!>    ellipsoid: auto,<list>
!>    ellipsoid: <real>,<real>,<real>,all
!>    ellipsoid: <real>,<real>,<real>,<list>
!> $scan
!>    ...
!> $end
!! ========================================================================
module xtb_constrain_param
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_strings, only : parse
   use xtb_readin, only : getline => strip_line,getValue,getListValue
   use xtb_setparam, only : set
   use xtb_type_environment, only : TEnvironment
   use xtb_type_identitymap, only : TIdentityMap, init
   use xtb_type_molecule, only : TMolecule

   implicit none

   private :: getline,getValue, handlerInterface

   character,private,parameter :: flag = '$'
   character,private,parameter :: colon = ':'
   character,private,parameter :: space = ' '
   character,private,parameter :: equal = '='
   character,private,parameter :: hash = '#'
   character,private,parameter :: comma = ','
   character,private,parameter :: semicolon = ';'
   character,private,parameter :: dot = '.'
   character(len=*),private,parameter :: flag_end = flag//'end'

!  Using allocatable arrays of dynamic length strings is only possible
!  with a lot of hacks, so we use good'ol fixed size stack arrays.
!  Let's choose something different from 42 that is not dividable by 10... ;)
!  Happy debugging!
   integer,private,parameter :: p_str_length = 48
   integer,private,parameter :: p_arg_length = 96

   public

   abstract interface
      subroutine handlerInterface(env,key,val,nat,at,idMap,xyz)
         import :: wp, TEnvironment, TIdentityMap
         type(TEnvironment), intent(inout) :: env
         character(len=*),intent(in) :: key
         character(len=*),intent(in) :: val
         integer, intent(in) :: nat
         type(TIdentityMap), intent(in) :: idMap
         integer, intent(in) :: at(nat)
         real(wp),intent(in) :: xyz(3,nat)
      end subroutine handlerInterface
   end interface

contains

subroutine read_userdata(fname,env,mol)
   use xtb_readin, only : find_new_name
   use xtb_scanparam
   implicit none
   character(len=*), parameter :: source = 'userdata_read'
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(inout) :: mol
   character(len=*),intent(in)  :: fname
   character(len=:),allocatable :: line
   character(len=:),allocatable :: key
   character(len=:),allocatable :: val
   character(len=:),allocatable :: newname
   type(TIdentityMap) :: idMap
   integer :: i
   integer :: id
   integer :: ic
   integer :: ie
   integer :: err
   logical :: exist

   if (set%verbose) then
      write(env%unit,'(72("$"))')
      write(env%unit,'(1x,"CONSTRAINTS & SCANS: DEBUG SECTION")')
      write(env%unit,'(72("$"))')
   endif

   call open_file(id,fname,'r')
   if (id.eq.-1) then
      call env%warning("could not find '"//fname//"'",source)
      return
   endif
   rewind(id) ! not sure if this is necessary

   call init(idMap, mol)

   call idMap%writeInfo(env%unit)

!  read first line before the readloop starts, I have to do this
!  to avoid using backspace on id (dammit Turbomole format)
   call getline(id,line,err)
   readflags: do
      !  check if there is a $ in the *first* column
      if (index(line,flag).eq.1) then
         select case(line(2:))
         case('fix'      )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_fix,    line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('split'    )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_split,  line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('constrain')
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            if (allocated(potset%xyz)) then
               call rdblock(env,set_constr, line,id,mol%n,mol%at,idMap,potset%xyz,err)
            else
               call rdblock(env,set_constr, line,id,mol%n,mol%at,idMap,mol%xyz,err)
            endif
         case('scan'     )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_scan,   line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('wall'     )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_wall,   line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('metadyn'  )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_metadyn,line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('hess'     )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_hess,   line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('path'     )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_path,   line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('reactor'  )
            if (set%verbose) write(env%unit,'(">",1x,a)') line(2:)
            call rdblock(env,set_reactor,line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case('set'      ); call rdsetbl(env,set_legacy,line,id,mol%n,mol%at,idMap,mol%xyz,err)
         case default ! unknown keyword -> ignore, we don't raise them
            call getline(id,line,err)
         end select
      else ! not a keyword -> ignore
         call getline(id,line,err)
      endif
   !  check for end of file, which I will tolerate as alternative to $end
      if (is_iostat_end(err)) exit readflags
!     if (index(line,flag_end).ne.0) exit readflags ! compatibility reasons
   enddo readflags

   if (set%verbose) write(env%unit,'(72("$"))')
   call close_file(id)
end subroutine read_userdata

subroutine rdsetbl(env,handler,line,id,nat,at,idMap,xyz,err)
   implicit none
   character(len=*), parameter :: source = 'userdata_rdsetbl'
   type(TEnvironment), intent(inout) :: env
   integer,intent(in) :: id
   procedure(handlerInterface) :: handler
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)
   integer,intent(out) :: err
   character(len=:),allocatable,intent(out) :: line
   character(len=:),allocatable :: key
   character(len=:),allocatable :: val
   integer :: ie
   logical :: exitRun
   do
      call getline(id,line,err)
      if (is_iostat_end(err)) exit
      if (index(line,flag).ne.0) exit
      if (set%verbose) write(env%unit,'("->",1x,a)') line

      ! find the first colon
      ie = index(line,space)
      if ((line.eq.'').or.(ie.eq.0)) cycle
      key = trim(line(:ie-1))
      val = trim(adjustl(line(ie+1:)))
      call handler(env,key,val,nat,at,idMap,xyz)
      call env%check(exitRun)
      if (exitRun) then
         call env%error("handler could not process input", source)
         return
      end if
   enddo

end subroutine rdsetbl

subroutine rdblock(env,handler,line,id,nat,at,idMap,xyz,err)
   implicit none
   character(len=*), parameter :: source = 'userdata_rdblock'
   type(TEnvironment), intent(inout) :: env
   integer,intent(in) :: id
   procedure(handlerInterface) :: handler
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)
   integer,intent(out) :: err
   character(len=:),allocatable,intent(out) :: line
   character(len=:),allocatable :: key
   character(len=:),allocatable :: val
   integer :: ie
   logical :: exitRun
   do
      call getline(id,line,err)
      if (is_iostat_end(err)) exit
      if (index(line,flag).ne.0) exit
      if (set%verbose) write(env%unit,'("->",1x,a)') line

      ! find the first colon
      ie = index(line,colon)
      if ((line.eq.'').or.(ie.eq.0)) cycle
      key = trim(line(:ie-1))
      val = trim(adjustl(line(ie+1:)))
      call handler(env,key,val,nat,at,idMap,xyz)
      call env%check(exitRun)
      if (exitRun) then
         call env%error("handler could not process input", source)
         return
      end if
   enddo

end subroutine rdblock

subroutine set_fix(env,key,val,nat,at,idMap,xyz)
   use xtb_type_atomlist
   use xtb_fixparam
   use xtb_setparam
   implicit none
   character(len=*), parameter :: source = 'userdata_fix'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   type(TAtomList) :: atl

   integer  :: i
   integer  :: iat
   integer  :: idum
   integer  :: nlist
   integer, allocatable :: list(:)
   real(wp) :: ddum
   logical  :: ldum

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call atl%resize(nat)

   call parse(val,comma,argv,narg)
!  some debug xtb_printout
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('elements')
      call atl%new
      do idum = 1, narg
         ! get element by symbol
         if (idMap%has(argv(idum))) then
            call idMap%get(list, argv(idum))
            if (allocated(list)) then
               call atl%add(list)
            else
               call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
               cycle
            end if
         else
            ldum = getValue(env,trim(argv(idum)),iat)
            if (.not.ldum) cycle ! skip garbage input
            ! check for unreasonable input
            if (iat > 0) then
               call atl%add(at.eq.iat)
            else
               call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
               cycle
            endif
         endif
      enddo
      if (fixset%n > 0) call atl%add(fixset%atoms(:fixset%n))
      call atl%to_list(list)
      fixset%atoms = list
      fixset%n = size(list)
   case('atoms')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the fixing list',source)
         return
      endif
      if (fixset%n > 0) call atl%add(fixset%atoms(:fixset%n))
      call atl%to_list(list)
      fixset%atoms = list
      fixset%n = size(list)
   case('freeze')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the freezing list',source)
         return
      endif
      if (freezeset%n > 0) call atl%add(freezeset%atoms(:freezeset%n))
      call atl%to_list(list)
      freezeset%atoms = list
      freezeset%n = size(list)
   case('shake')
      allocate(list(nat*(nat+1)/2), source=0)
      if (mod(narg,2).ne.0) then
         call env%warning("could not read input for user defined shake!",source)
         return
      endif
         if (narg+shakeset%n > nat*(nat+1)/2) then
         call env%warning("too many SHAKE constraints!",source)
         return
      endif
      if (.not.set%shake_md) set%shake_md = .true.
      do idum = 1, narg
         if (getValue(env,trim(argv(idum)),iat)) then
            if (iat.gt.nat) then
               call env%warning('Attempted constrain atom not present in molecule.',source)
               cycle
            endif
            shakeset%n = shakeset%n+1
            shakeset%atoms(shakeset%n) = iat
         else
            call env%warning("Something went wrong in set_fix_ 'shake'.",source)
            return ! you screwed it, let's get out of here
         endif
      enddo
   end select

end subroutine set_fix

subroutine set_constr(env,key,val,nat,at,idMap,xyz)
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_type_atomlist
   use xtb_scanparam
   use xtb_splitparam
   implicit none
   character(len=*), parameter :: source = 'userdata_constr'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   type(TAtomList) :: atl

   integer  :: iat
   integer  :: ioffset
   integer  :: idum
   real(wp) :: ddum
   integer  :: nlist
   integer, allocatable :: list(:)
   logical  :: ldum
   integer  :: i,j,k,l
   real(wp) :: phi,dist,ra(3),rb(3)
   real(wp),external :: valijkl

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call atl%resize(nat)

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them

   case('elements')
      call atl%new
      do idum = 1, narg
         ! get element by symbol
         if (idMap%has(argv(idum))) then
            call idMap%get(list, argv(idum))
            if (allocated(list)) then
               call atl%add(list)
            else
               call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
               cycle
            end if
         else
            ldum = getValue(env,trim(argv(idum)),iat)
            if (.not.ldum) cycle ! skip garbage input
            ! check for unreasonable input
            if (iat > 0) then
               call atl%add(at.eq.iat)
            else
               call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
               cycle
            endif
         endif
      enddo
      if (potset%pos%n > 0) call atl%add(potset%pos%atoms(:potset%pos%n))
      call atl%to_list(list)
      potset%pos%atoms = list
      potset%pos%n = size(list)
   case('atoms')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the fixing list',source)
         return
      endif
      if (potset%pos%n > 0) call atl%add(potset%pos%atoms(:potset%pos%n))
      call atl%to_list(list)
      potset%pos%atoms = list
      potset%pos%n = size(list)

   case('DISTANCE')
      if (narg.lt.3 .or. narg.gt.4) then
         call env%error('not enough arguments to constrain a distance',source)
         return
      endif
      ioffset = 2*potset%dist%n
      potset%dist%n = potset%dist%n+1
   !  part 1: get the constrained atoms
      do i = 1, 2
         if (getValue(env,trim(argv(i)),idum)) then
            potset%dist%atoms(ioffset+i) = idum
         else
            call env%warning("Something went wrong in set_constr_ 'distance'. (1)",source)
            potset%dist%n = potset%dist%n-1 ! remove invalid contrain
            return
         endif
      enddo
   !  part 2: get the distance between those atoms
      i = potset%dist%atoms(ioffset+1)
      j = potset%dist%atoms(ioffset+2)
      if (any([i, j] > nat .or. [i, j] < 1)) then
         call env%warning("Atomic index is out of bounds for distance constraint",source)
         potset%dist%n = potset%dist%n-1 ! remove invalid contrain
         return
      end if
      dist = sqrt(sum((xyz(:,i)-xyz(:,j))**2))
      if (trim(argv(3)).eq.'auto') then
         potset%dist%val(potset%dist%n) = dist
      else
         if (getValue(env,trim(argv(3)),ddum)) then
            potset%dist%val(potset%dist%n) = ddum * aatoau
         else
            call env%warning("Something went wrong in set_constr_ 'distance'. (2)",source)
            potset%dist%n = potset%dist%n-1 ! remove invalid contrain
            return
         endif
      endif
      if (narg.eq.4) then
         if (getValue(env,trim(argv(4)),idum)) then
            if (idum < 2 .or. mod(idum, 2).ne.0) then
               call env%warning("Invalid spring exponent given", source)
               potset%dist%n = potset%dist%n-1 ! remove invalid contrain
               return
            end if
            potset%dist%expo(potset%dist%n) = real(idum, wp)
         else
            call env%warning("Something went wrong in set_constr_ 'distance'. (3)",source)
            potset%dist%n = potset%dist%n-1 ! remove invalid contrain
            return
         end if
         write(env%unit,'("constraining bond",2(1x,i0),1x,"to",'//&
            '1x,f12.7,1x,"Å, actual value:",1x,f12.7,1x,"Å",1x,"with expo",1x,i0)') &
            i,j, potset%dist%val(potset%dist%n)*autoaa, dist*autoaa, &
            nint(potset%dist%expo(potset%dist%n))
      else
         write(env%unit,'("constraining bond",2(1x,i0),1x,"to",'//&
            '1x,f12.7,1x,"Å, actual value:",1x,f12.7,1x,"Å")') &
            i,j, potset%dist%val(potset%dist%n)*autoaa, dist*autoaa
      end if

   case('ANGLE')
      if (narg.ne.4) then
         call env%error('not enough arguments to constrain an angle',source)
         return
      endif
      ioffset = 3*potset%angle%n
      potset%angle%n = potset%angle%n+1
   !  part 1: get the constrained atoms
      do i = 1, narg-1
         if (getValue(env,trim(argv(i)),idum)) then
            potset%angle%atoms(ioffset+i) = idum
         else
            call env%warning("Something went wrong in set_constr_ 'angle'. (1)",source)
            potset%angle%n = potset%angle%n-1 ! remove invalid contrain
            return
         endif
      enddo
   !  part 2: get the angle between the constrained atoms
      i = potset%angle%atoms(ioffset+1)
      j = potset%angle%atoms(ioffset+2)
      k = potset%angle%atoms(ioffset+3)
      if (any([i, j, k] > nat .or. [i, j, k] < 1)) then
         call env%warning("Atomic index is out of bounds for angle constraint",source)
         potset%angle%n = potset%angle%n-1 ! remove invalid contrain
         return
      end if
      call bangl(xyz,i,j,k,phi)
      if (trim(argv(narg)).eq.'auto') then
         potset%angle%val(potset%angle%n) = phi
      else
         if (getValue(env,trim(argv(narg)),ddum)) then
            potset%angle%val(potset%angle%n) = pi/180.0_wp * ddum
         else
            call env%warning("Something went wrong in set_constr_ 'angle'. (2)",source)
            potset%angle%n = potset%angle%n-1 ! remove invalid contrain
            return
         endif
      endif

   case('DIHEDRAL')
      if (narg.ne.5) then
         call env%error('not enough arguments to constrain a dihedral',source)
         return
      endif
      ioffset = 4*potset%dihedral%n
      potset%dihedral%n = potset%dihedral%n+1
      if (nconstr.gt.maxconstr) then ! double check this
         call env%error('This should never happen! Let somebody check set_constr',source)
         return
      end if
   !  part 1: get the constrained atoms
      do i = 1, narg-1
         if (getValue(env,trim(argv(i)),idum)) then
            potset%dihedral%atoms(ioffset+i) = idum
         else
            call env%warning("Something went wrong in set_constr_ 'dihedral'. (1)",source)
            potset%dihedral%n = potset%dihedral%n-1 ! remove invalid contrain
            return
         endif
      enddo
   !  part 2: get the angle between the constrained atoms
      i = potset%dihedral%atoms(ioffset+1)
      j = potset%dihedral%atoms(ioffset+2)
      k = potset%dihedral%atoms(ioffset+3)
      l = potset%dihedral%atoms(ioffset+4)
      if (any([i, j, k, l] > nat .or. [i, j, k, l] < 1)) then
         call env%warning("Atomic index is out of bounds for dihedral constraint",source)
         potset%dihedral%n = potset%dihedral%n-1 ! remove invalid contrain
         return
      end if
      phi=valijkl(nat,xyz,i,j,k,l)
      if (trim(argv(narg)).eq.'auto') then
         potset%dihedral%val(potset%dihedral%n) = phi
      else
         if (getValue(env,trim(argv(narg)),ddum)) then
            potset%dihedral%val(potset%dihedral%n) = pi/180.0_wp * ddum
         else
            call env%warning("Something went wrong in set_constr_ 'dihedral'. (2)",source)
            potset%dihedral%n = potset%dihedral%n-1 ! remove invalid contrain
            return
         endif
      endif

   case('distance')
      if (narg.ne.3) then
         call env%error('not enough arguments to constrain a distance',source)
         return
      endif
      nconstr = nconstr+1
      if (nconstr.gt.maxconstr) then ! double check this
         call env%error('This should never happen! Let somebody check set_constr',source)
         return
      end if
   !  part 1: get the constrained atoms
      do i = 1, narg-1
         if (getValue(env,trim(argv(i)),idum)) then
            atconstr(i,nconstr) = idum
         else
            call env%warning("Something went wrong in set_constr_ 'distance'. (1)",source)
            nconstr = nconstr-1 ! remove invalid contrain
            return
         endif
      enddo
   !  part 2: get the distance between those atoms
      i = atconstr(1,nconstr)
      j = atconstr(2,nconstr)
      if (any([i, j] > nat .or. [i, j] < 1)) then
         call env%warning("Atomic index is out of bounds for distance constraint",source)
         nconstr = nconstr-1 ! remove invalid contrain
         return
      end if
      dist = sqrt(sum((xyz(:,i)-xyz(:,j))**2))
      if (trim(argv(narg)).eq.'auto') then
         valconstr(nconstr) = dist
      else
         if (getValue(env,trim(argv(narg)),ddum)) then
            valconstr(nconstr) = ddum * aatoau
         else
            call env%warning("Something went wrong in set_constr_ 'distance'. (2)",source)
            nconstr = nconstr-1 ! remove invalid contrain
            return
         endif
      endif
      write(env%unit,'("constraining bond",2(1x,i0),1x,"to",'//&
         '1x,f12.7,1x,"Å, actual value:",1x,f12.7,1x,"Å")') &
         i,j, valconstr(nconstr)*autoaa, dist*autoaa

   case('angle')
      if (narg.ne.4) then
         call env%error('not enough arguments to constrain an angle',source)
         return
      endif
      nconstr = nconstr+1
      if (nconstr.gt.maxconstr) then ! double check this
         call env%error('This should never happen! Let somebody check set_constr',source)
         return
      end if
   !  part 1: get the constrained atoms
      do i = 1, narg-1
         if (getValue(env,trim(argv(i)),idum)) then
            atconstr(i,nconstr) = idum
         else
            call env%warning("Something went wrong in set_constr_ 'angle'. (1)",source)
            nconstr = nconstr-1 ! remove invalid contrain
            return
         endif
      enddo
   !  part 2: get the angle between the constrained atoms
      i = atconstr(1,nconstr)
      j = atconstr(2,nconstr)
      k = atconstr(3,nconstr)
      if (any([i, j, k] > nat .or. [i, j, k] < 1)) then
         call env%warning("Atomic index is out of bounds for angle constraint",source)
         nconstr = nconstr-1 ! remove invalid contrain
         return
      end if
      call bangl(xyz,i,j,k,phi)
      if (trim(argv(narg)).eq.'auto') then
         valconstr(nconstr) = phi
      else
         if (getValue(env,trim(argv(narg)),ddum)) then
            valconstr(nconstr) = pi/180.0_wp * ddum
         else
            call env%warning("Something went wrong in set_constr_ 'angle'. (2)",source)
            nconstr = nconstr-1 ! remove invalid contrain
            return
         endif
      endif
      write(env%unit,'("constraining angle",3(1x,i0),1x,"to",'//&
         '1x,f12.7,"°, actual value:",1x,f12.7,"°")') &
         i,j,k,180.0_wp/pi * valconstr(nconstr),180.0_wp/pi * phi

   case('dihedral')
      if (narg.ne.5) then
         call env%error('not enough arguments to constrain a dihedral',source)
         return
      endif
      nconstr = nconstr+1
      if (nconstr.gt.maxconstr) then ! double check this
         call env%error('This should never happen! Let somebody check set_constr',source)
         return
      end if
   !  part 1: get the constrained atoms
      do i = 1, narg-1
         if (getValue(env,trim(argv(i)),idum)) then
            atconstr(i,nconstr) = idum
         else
            call env%warning("Something went wrong in set_constr_ 'dihedral'. (1)",source)
            nconstr = nconstr-1 ! remove invalid contrain
            return
         endif
      enddo
   !  part 2: get the angle between the constrained atoms
      i = atconstr(1,nconstr)
      j = atconstr(2,nconstr)
      k = atconstr(3,nconstr)
      l = atconstr(4,nconstr)
      if (any([i, j, k, l] > nat .or. [i, j, k, l] < 1)) then
         call env%warning("Atomic index is out of bounds for dihedral constraint",source)
         nconstr = nconstr-1 ! remove invalid contrain
         return
      end if
      phi=valijkl(nat,xyz,i,j,k,l)
      if (trim(argv(narg)).eq.'auto') then
         valconstr(nconstr) = phi
      else
         if (getValue(env,trim(argv(narg)),ddum)) then
            valconstr(nconstr) = pi/180.0_wp * ddum
         else
            call env%warning("Something went wrong in set_constr_ 'dihedral'. (2)",source)
            nconstr = nconstr-1 ! remove invalid contrain
            return
         endif
      endif
      write(env%unit,'("constraining angle",4(1x,i0),1x,"to",'//&
         '1x,f12.7,"°, actual value:",1x,f12.7,"°")') &
         i,j,k,l,180.0_wp/pi * valconstr(nconstr),180.0_wp/pi * phi

   case('center')
      ! copied from molbld.f without modification (except for error handling)
      if (narg.ne.2) then
         call env%error('not enough argument to constrain center',source)
         return
      endif
      nconstr = nconstr+1
      atconstr(1,nconstr) = -2
      if (getValue(env,trim(argv(2)),ddum)) then
         valconstr(nconstr) = ddum
      else
         call env%warning("Something went wrong in set_constr_ 'center'. (1)",source)
         nconstr = nconstr-1
         return
      endif
      if (getValue(env,trim(argv(1)),idum)) then
         iatf1 = idum
      else
         call env%warning("Something went wrong in set_constr_ 'center'. (2)",source)
         nconstr = nconstr-1
         return
      endif
      massf1 = 0.0_wp
      do i = 1, iatf1
         massf1 = massf1 + atmass(i)
      enddo

   case('cma','cma interface')
      ! copied from molbld.f without modification (except for error handling)
      if (narg.ne.1) then
         call env%error('not enough argument to constrain cma',source)
         return
      endif
      if (key.eq.'cma interface') call cmaiface(nat,at,xyz)
      nconstr = nconstr+1
      atconstr(1,nconstr) = 0
      if (trim(argv(1)).eq.'auto') then
         massf1 = 0.0_wp
         massf2 = 0.0_wp
         do i = 1, nat
            if (splitlist(i).eq.1) then
               massf1 = massf1 + atmass(i)
            else
               massf2 = massf2 + atmass(i)
            endif
         enddo
         call cmafrag(nat,at,xyz,ra,rb)
         valconstr(nconstr) = rcma
         write(env%unit,'("constraining fragment CMA to initial R(Ang.)=",f8.3)')&
            valconstr(nconstr)*autoaa
      else
         if (getValue(env,trim(argv(1)),ddum)) then
            valconstr(nconstr) = ddum*aatoau
         else
            call env%warning("Something went wrong in set_constr_ 'cma'.",source)
            nconstr = nconstr-1
            return
         endif
      endif

!   case('x','y','z')
!      idum = index('xyz',key)
   case('z')
      ! copied from molbld.f without modification (except for error handling)
      if (narg.ne.1) then
         call env%error('not enough argument to constrain z coordinate',source)
         return
      endif
      zconstr = 1
      nconstr = nconstr+1
      atconstr(1,nconstr) = -1
      if (getValue(env,trim(argv(1)),ddum)) then
         valconstr(nconstr) = ddum*aatoau
      else
         call env%warning("Something went wrong in set_constr_ 'z'.",source)
         nconstr = nconstr-1
         return
      endif
      if (sum(abs(xyz(3,1:iatf1))).gt.1.d-3) then
         call env%warning('z-coordinates of fragment 1 must be 0!',source)
         nconstr = nconstr-1
         return
      endif
      write(env%unit,'("constraining fragment 2 to Z=0 plane at (Ang.)=",f8.3)') &
         valconstr(nconstr)*autoaa

   end select
end subroutine set_constr

!! --------------------------------------------------------------[SAW1809]-
!  this is the new version of the scan routine exploiting all features
subroutine set_scan(env,key,val,nat,at,idMap,xyz)
   use xtb_scanparam
   use xtb_mctc_convert, only : aatoau
   use xtb_mctc_constants, only : pi
   implicit none
   character(len=*), parameter :: source = 'userdata_scan'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum

   integer  :: i,ie
   real(wp) :: start_value,end_value
   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv
   character(len=:),allocatable :: temp

   nscan = nscan+1 ! make a new scan

   ie = index(val,semicolon)
   if (ie.ne.0) then
      temp = val(:ie-1)
      idum = nconstr
      call set_constr(env,key,temp,nat,at,idMap,xyz) ! generate a new constraint
      scan_list(nscan)%iconstr = nconstr ! new generated
      if (idum.eq.nconstr) then
         call env%error('Failed to generate constraint',source)
         return
      end if
      temp = val(1+ie:)
   else
      if (getValue(env,key,idum)) then
         if (idum.gt.nconstr) then
            call env%error('Constraint '''//key//''' is not defined',source)
            return
         endif
         scan_list(nscan)%iconstr = idum
      else
         call env%error('Constraint '''//key//''' is invalid in this context',source)
         return
      endif
      temp = val
   endif

   call parse(temp,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif

   ! get back the constraint number which should be scanned
   i = scan_list(nscan)%iconstr
   ! instead of simply saving the kind of constraint while reading,
   ! we used some really obvious integer code system depending on
   ! the number of elements in the atconstr-Array.
   ! Expected to break at some point, add a FIXME and wait for complaints...
   idum = atconstr(1,i)
   if (atconstr(2,i).gt.0) idum = 1
   if (atconstr(3,i).gt.0) idum = 2
   if (atconstr(4,i).gt.0) idum = 3

   if (getValue(env,trim(argv(1)),ddum)) then
      if (idum.le.1) then
         start_value = ddum * aatoau
      else
         start_value = ddum * pi/180.0_wp
      endif
   else
      call env%error('Invalid start value for scan',source)
      return
   endif
   if (getValue(env,trim(argv(2)),ddum)) then
      if (idum.le.1) then
         end_value = ddum * aatoau
      else
         end_value = ddum * pi/180.0_wp
      endif
   else
      call env%error('Invalid end value for scan',source)
      return
   endif
   if (getValue(env,trim(argv(3)),idum)) then
      scan_list(nscan)%nscan = idum
      allocate( scan_list(nscan)%valscan(idum), source = 0.0_wp )
   else
      call env%error('Invalid step number for scan',source)
      return
   endif

   do i = 1, scan_list(nscan)%nscan
      scan_list(nscan)%valscan(i) = start_value + (end_value-start_value) &
         &                       * real(i-1,wp)/real(scan_list(nscan)%nscan-1,wp)
      if (set%verbose) write(env%unit,'(i5,1x,f12.8)') i,scan_list(nscan)%valscan(i)
   enddo

end subroutine set_scan

subroutine set_wall(env,key,val,nat,at,idMap,xyz)
   use xtb_mctc_convert, only : autoaa
   use xtb_sphereparam
   implicit none
   character(len=*), parameter :: source = 'userdata_wall'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   integer  :: idum
   real(wp) :: ddum,darray(3)
   logical  :: ldum
   integer  :: list(nat),nlist
   integer  :: tlist(nat),ntlist
   integer  :: iarg,iaxis
   real(wp) :: radius,radii(3),center(3)

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   nlist = 0
   ntlist = 0
   list = 0
   tlist = 0

   radius = 0.0_wp
   radii  = 0.0_wp
   center = 0.0_wp

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('sphere')
      if (narg.lt.2) then
         call env%warning("Not enough arguments to set up a spherical wall",source)
         return
      endif
   !  part 1: get the sphere radius
      if (trim(argv(1)).eq.'auto') then
         call get_sphere_radius(nat,at,xyz,center,radius,do_trafo=.false.)
      else
         if (getValue(env,trim(argv(1)),ddum)) then
            radius = ddum
            center = 0.0_wp
         else
            ! warning already generated by get_value
            return ! something went wrong
         endif
      endif
   !  part 2: get atoms
      if (trim(argv(2)).eq.'all') then
         call set_sphere_radius(radius,center)
      else
         do iarg = 2, narg
            if (getListValue(env,trim(argv(iarg)),tlist,ntlist)) then
               if (nlist+ntlist.gt.nat) then
                  call env%warning("Too many atoms in list for spherical wall.",source)
                  return ! something went wrong
               endif
               if (maxval(tlist(:ntlist)).gt.nat) then
                  call env%warning("Attempted to wall in a non-existing atom",source)
                  cycle ! skip crappy input
               endif
               list(nlist+1:nlist+ntlist) = tlist
               nlist = nlist + ntlist
            else
               ! warning already generated by get_list_value
               return ! something went wrong
            endif
         enddo
         call set_sphere_radius(radius,center,nlist,list)
      endif
      write(env%unit,'("spherical wallpotenial with radius",'//&
         '1x,f12.7,1x,"Å")') radius*autoaa

   case('ellipsoid')
      if (narg.lt.4) then
         call env%warning("Not enough arguments to set up an ellipsoidal wall",source)
         return
      endif
   !  part 1: get ellipsoid axis
      if ((trim(argv(1)).eq.'auto').or.(trim(argv(2)).eq.'auto').or. &
          (trim(argv(3)).eq.'auto')) then
         ! use get_ellipsoid_radius if you manage to implement it
         call get_sphere_radius(nat,at,xyz,center,radius,do_trafo=.false.)
      endif
      do iaxis = 1, 3
         if (trim(argv(iaxis)).eq.'auto') then
            radii(iaxis) = radius
         else
            if (getValue(env,trim(argv(iaxis)),ddum)) then
               radii(iaxis) = ddum
               center(iaxis) = 0.0_wp
            else
               ! warning already generated by get_value
               return ! something went wrong
            endif
         endif
      enddo
   !  part 2: get atoms
      if (trim(argv(4)).eq.'all') then
         call set_sphere_radius(radii,center)
      else
         do iarg = 4, narg
            if (getListValue(env,trim(argv(iarg)),tlist,ntlist)) then
               if (nlist+ntlist.gt.nat) then
                  call env%warning("Too many atoms in list for spherical wall.",source)
                  return ! something went wrong
               endif
               if (maxval(tlist(:ntlist)).gt.nat) then
                  call env%warning("Attempted to wall in a non-existing atom",source)
                  cycle ! skip crappy input
               endif
               list(nlist+1:nlist+ntlist) = tlist
               nlist = nlist + ntlist
            else
               ! warning already generated by get_list_value
               return ! something went wrong
            endif
         enddo
         call set_sphere_radius(radii,center,nlist,list)
      endif
      write(env%unit,'("ellipsoidal wallpotenial with radii",'//&
         '3(1x,f12.7,1x,"Å"))') radii*autoaa

   end select

end subroutine set_wall

subroutine set_split(env,key,val,nat,at,idMap,xyz)
   use xtb_splitparam
   implicit none
   character(len=*), parameter :: source = 'userdata_split'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: list(nat),nlist
   integer  :: i,j

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('fragment1')
      do i = 1, narg
         if (getListValue(env,trim(argv(i)),list,nlist)) then
            do j = 1, nlist
               splitlist(list(j)) = 1
            enddo
            iatf1 = iatf1 + nlist ! compatibility stuff, as usual
            iatf(1) = iatf(1) + nlist
         else
            return ! you screwed it, let's get out of here
         endif
      enddo
   case('fragment2')
      do i = 1, narg
         if (getListValue(env,trim(argv(i)),list,nlist)) then
            do j = 1, nlist
               splitlist(list(j)) = 2
            enddo
            iatf2 = iatf2 + nlist ! compatibility stuff, as usual
            iatf(2) = iatf(2) + nlist
         else
            return ! you screwed it, let's get out of here
         endif
      enddo
   case('fragment')
      if (getValue(env,trim(argv(1)),idum)) then
         if (idum.gt.nat) then
            call env%warning("rejecting fragment number greater than number of atoms",source)
            return ! doesn't really make sense, sorry, your problem
         endif
         do i = 2, narg
            if (getListValue(env,trim(argv(i)),list,nlist)) then
               do j = 1, nlist
                  splitlist(list(j)) = idum
               enddo
               iatf(idum) = iatf(idum) + nlist
               if (idum.eq.1) then ! legacy, don't remove or something breaks
                  iatf1 = iatf1 + nlist
               else if (idum.eq.2) then
                  iatf2 = iatf2 + nlist
               endif
            else
               return ! you screwed it, let's get out of here
            endif
         enddo
      endif
   end select
end subroutine set_split

subroutine set_hess(env,key,val,nat,at,idMap,xyz)
   use xtb_splitparam
   implicit none
   character(len=*), parameter :: source = 'userdata_hess'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: i,j
   integer, allocatable :: list(:)

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('element mass')
      if (mod(narg,2).ne.0) then
         call env%warning("Something went wrong in set_mass_ 'element'.",source)
      endif
      do i = 1, narg, 2
         j = i+1
         if (getValue(env,trim(argv(j)),ddum)) then
            if (idMap%has(argv(i))) then
               call idMap%set(atmass, argv(i), ddum)
               write(env%unit,'(a,a,a,1x,g0)') &
                  "mass of elements '",trim(argv(i)),"' changed to", ddum
            else if (getValue(env,trim(argv(i)),idum)) then
               where(at.eq.idum) atmass = ddum
               write(env%unit,'(a,i0,a,1x,g0)') &
                  "mass of elements with Z=",idum," changed to", ddum
            end if
         end if
      enddo
   case('modify mass','isotope')
      if (mod(narg,2).ne.0) then
         call env%warning("Something went wrong in set_mass_ 'modify'.",source)
      endif
      do i = 1, narg, 2
         j = i+1
         if (getValue(env,trim(argv(i)),idum).and.&
             getValue(env,trim(argv(j)),ddum)) then
            if (idum.gt.nat) then
               call env%warning('Attempted setting atom mass not present in system.',source)
               cycle
            endif
            atmass(idum) = ddum
            write(env%unit,'(a,1x,i0,1x,a,1x,g0)') &
               'mass of atom ',idum,' changed to',atmass(idum)
         endif
      enddo
   case('scale mass')
      if (mod(narg,2).ne.0) then
         call env%warning("Something went wrong in set_mass_ 'scale'.",source)
      endif
      do i = 1, narg, 2
         j = i+1
         if (getValue(env,trim(argv(i)),idum).and.&
             getValue(env,trim(argv(j)),ddum)) then
            if (idum.gt.nat) then
               call env%warning('Attempted scaling atom not present in system.',source)
               cycle
            endif
            atmass(idum) = atmass(idum)*ddum
            write(env%unit,'(a,1x,i0,1x,a,1x,g0)') &
               'mass of atom ',idum,' changed to',atmass(idum)
         endif
      enddo
   end select

end subroutine set_hess

subroutine set_reactor(env,key,val,nat,at,idMap,xyz)
   use xtb_type_atomlist
   use xtb_setparam
   implicit none
   character(len=*), parameter :: source = 'userdata_reactor'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   type(TAtomList) :: atl

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: nlist
   integer, allocatable :: list(:)
   integer  :: i,j

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('atoms')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the reactor atom list',source)
         return
      endif
      if (set%reactset%nat > 0) call atl%add(set%reactset%atoms(:set%reactset%nat))
      call atl%to_list(list)
      set%reactset%atoms = list
      set%reactset%nat = size(list)
   end select

end subroutine set_reactor

subroutine set_path(env,key,val,nat,at,idMap,xyz)
   use xtb_type_atomlist
   use xtb_setparam
   implicit none
   character(len=*), parameter :: source = 'userdata_path'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   type(TAtomList) :: atl

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: nlist
   integer, allocatable :: list(:)
   integer  :: i,j

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('atoms')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the bias path atom list',source)
         return
      endif
      if (set%pathset%nat > 0) call atl%add(set%pathset%atoms(:set%pathset%nat))
      call atl%to_list(list)
      set%pathset%atoms = list
      set%pathset%nat = size(list)
   end select

end subroutine set_path

subroutine set_metadyn(env,key,val,nat,at,idMap,xyz)
   use xtb_type_atomlist
   use xtb_fixparam
   implicit none
   character(len=*), parameter :: source = 'userdata_metadyn'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   type(TAtomList) :: atl

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: nlist
   integer, allocatable :: list(:)
   integer  :: i,j,iat

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('bias atoms')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the metadynamic atom list',source)
         return
      endif
      if (rmsdset%nat > 0) call atl%add(rmsdset%atoms(:rmsdset%nat))
      call atl%to_list(list)
      rmsdset%atoms = list
      rmsdset%nat = size(list)
   case('bias elements')
      call atl%new
      do idum = 1, narg
         ! get element by symbol
         if (idMap%has(argv(idum))) then
            call idMap%get(list, argv(idum))
            if (allocated(list)) then
               call atl%add(list)
            else
               call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
               cycle
            end if
         else
            ldum = getValue(env,trim(argv(idum)),iat)
            if (.not.ldum) cycle ! skip garbage input
            ! check for unreasonable input
            if (iat > 0) then
               call atl%add(at.eq.iat)
            else
               call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
               cycle
            endif
         endif
      enddo
      if (rmsdset%nat > 0) call atl%add(rmsdset%atoms(:rmsdset%nat))
      call atl%to_list(list)
      rmsdset%atoms = list
      rmsdset%nat = size(list)
   case('atoms')
      call atl%new(val)
      if (atl%get_error()) then
         call env%warning('something is wrong in the metadynamic atom list',source)
         return
      endif
      if (metaset%nat > 0) call atl%add(metaset%atoms(:metaset%nat))
      call atl%to_list(list)
      metaset%atoms = list
      metaset%nat = size(list)
   case('modify factor')
      if (mod(narg,2).ne.0) then
         call env%warning("Something went wrong in set_metadyn_ 'modify'.",source)
      endif
      do i = 1, narg, 2
         j = i+1
         if (getValue(env,trim(argv(i)),idum).and.&
             getValue(env,trim(argv(j)),ddum)) then
            if (idum.gt.metaset%maxsave) then
               call env%warning('Attempted using factor not present in system.',source)
               cycle
            endif
            metaset%factor(idum) = ddum
         endif
      enddo
   case('scale factor')
      if (mod(narg,2).ne.0) then
         call env%warning("Something went wrong in set_metadyn_ 'scale'.",source)
      endif
      do i = 1, narg, 2
         j = i+1
         if (getValue(env,trim(argv(i)),idum).and.&
             getValue(env,trim(argv(j)),ddum)) then
            if (idum.gt.metaset%maxsave) then
               call env%warning('Attempted scaling factor not present in system.',source)
               cycle
            endif
            metaset%factor(idum) = metaset%factor(idum)*ddum
         endif
      enddo
   end select

end subroutine set_metadyn

subroutine set_freeze(env,key,val,nat,at,idMap,xyz)
   implicit none
   character(len=*), parameter :: source = 'userdata_freeze'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)

   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: list(nat),nlist
   integer  :: i,j

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   call parse(val,comma,argv,narg)
   if (set%verbose) then
      do idum = 1, narg
         write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
      enddo
   endif
   select case(key)
   case default ! ignore, don't even think about raising them
   case('hessf')
   case('hessa')
   end select

end subroutine set_freeze

subroutine set_legacy(env,key,val,nat,at,idMap,xyz)
   implicit none
   character(len=*), parameter :: source = 'userdata_legacy'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   type(TIdentityMap), intent(in) :: idMap
   real(wp),intent(in) :: xyz(3,nat)
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   select case(key)
   case default ! complaining about unknown keywords should already be done
      continue  ! so we do nothing here
   case('hessf');       call set_fix(env,'freeze',val,nat,at,idMap,xyz)
!   case('hessa');       call set_frozh('hessa',val)
   case('fragment1'); call set_split(env,'fragment1',val,nat,at,idMap,xyz)
   case('fragment2'); call set_split(env,'fragment1',val,nat,at,idMap,xyz)
   case('constrxyz'); call set_fix(env,'atoms',val,nat,at,idMap,xyz)
!   case('constrainel')
!   case('constrain')
!   case('scan')
   case('ellips'); call set_wall(env,'ellipsoid',val,nat,at,idMap,xyz)
   case('sphere'); call set_wall(env,'sphere',val,nat,at,idMap,xyz)
   case('fix'); call set_fix(env,'atoms',val,nat,at,idMap,xyz)
   case('atomlist+'); call set_metadyn(env,'atoms',val,nat,at,idMap,xyz)
   end select

end subroutine set_legacy

end module xtb_constrain_param

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> molecular structure information
!
!  contains information about the molecular geometry, the atom types
!  the nuclear and total charge, atomic masses and all interatomic distances
!  In periodic calculations the lattice parameters, a Wigner--Seitz cell
!  as well as fractional coordinates are attached to the data type
!
!  Additionally the molecular structure can keep a topology information
!  usually containing the bonds of the system and a list of non-overlapping
!  fragments. Both data containers are optional and need not to be filled
!  by the provider of the structure data.
!
!  Vendor specific information can be stored along with the molecular structure
!  in auxilary data objects. Data objects like PDB or SDF atomic data should
!  be kept as light-weighted as possible and the user of the structure class
!  is not required to care about it existence
module xtb_type_molecule
   use mctc_io_structure, only : structure_type, new_structure
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_boundaryconditions, only : boundaryCondition
   use xtb_mctc_symbols, only : toNumber, toSymbol, symbolLength, getIdentity
   use xtb_type_topology
   use xtb_type_fragments
   use xtb_type_buffer
   use xtb_type_vendordata
   implicit none

   public :: TMolecule, new_molecule_api, init, assignment(=)
   public :: len, size

   private


   !> Molecular structure information
   type :: TMolecule

      !> Number of atoms
      integer  :: n = 0

      !> Number of unique species
      integer  :: nId = 0

      !> Total charge
      real(wp) :: chrg = 0.0_wp

      !> Number of unpaired electrons
      integer  :: uhf = 0

      !> Periodic dimensions
      logical  :: pbc(3) = .false.

      !> Periodicity of system
      integer  :: npbc = 0

      !> Boundary condition for this structure
      integer  :: boundaryCondition = boundaryCondition%cluster

      !> Element symbols
      character(len=symbolLength), allocatable :: sym(:)

      !> Ordinal numbers
      integer, allocatable :: at(:)

      !> Chemical identity
      integer, allocatable :: id(:)

      !> Cartesian coordinates in bohr
      real(wp),allocatable :: xyz(:,:)

      !> Fractional coordinates
      real(wp),allocatable :: abc(:,:)

      !> Interatomic distances
      real(wp),allocatable :: dist(:,:)

      !> Atomic masses in amu
      real(wp),allocatable :: atmass(:)

      !> Nuclear charges
      real(wp),allocatable :: z(:)

      !> Coordination number
      real(wp),allocatable :: cn(:)

      !> Cell parameters
      real(wp) :: cellpar(6) = 0.0_wp

      !> Direct lattice parameters
      real(wp) :: lattice(3,3) = 0.0_wp

      !> Reciprocal lattice parameters
      real(wp) :: rec_lat(3,3) = 0.0_wp

      !> Volume of unit cell
      real(wp) :: volume = 0.0_wp

      !> File type of the input
      integer  :: ftype = 0

      character(len=:), allocatable :: name

      type(TTopology) :: bonds

      type(TFragments) :: frag

      !> PDB specific information about residues and chains
      type(pdb_data), allocatable :: pdb(:)

      !> SDF specific information about atom types
      type(sdf_data), allocatable :: sdf(:)

      !> Information on vendor specific data
      type(structure_info) :: info = structure_info()

   contains

      procedure :: allocate => allocate_molecule

      procedure :: deallocate => deallocate_molecule

      procedure :: calculate_distances => mol_calculate_distances

      procedure :: set_nuclear_charge => mol_set_nuclear_charge

      procedure :: set_atomic_masses => mol_set_atomic_masses

      procedure :: update

      procedure :: wrap_back

      procedure :: center_of_geometry

      procedure :: center_of_mass

      procedure :: shift_to_center_of_geometry

      procedure :: shift_to_center_of_mass

      procedure :: moments_of_inertia

      procedure :: align_to_principal_axes

      procedure ::  copy => copyMolecule

   end type TMolecule


   interface init
      module procedure :: initMolecule
      module procedure :: initMoleculeSymbols
      module procedure :: initMoleculeNumbers
   end interface


   interface TMolecule
      module procedure :: new_molecule_api
   end interface TMolecule


   interface len
      module procedure :: mol_length
   end interface


   interface assignment(=)
      module procedure :: structure_to_molecule
      module procedure :: molecule_to_structure
   end interface assignment(=)


contains


!> Copy molecule type
subroutine copyMolecule(self,mol0)

   class(TMolecule), intent(out) :: self
   type(TMolecule), intent(in) :: mol0

      Call init(self, mol0%at, mol0%sym, mol0%xyz, mol0%chrg, mol0%uhf, &
           & mol0%lattice, mol0%pbc)
end subroutine copyMolecule

!> Constructor for the molecular structure type
subroutine initMolecule &
     & (mol, at, sym, xyz, chrg, uhf, lattice, pbc)

   type(TMolecule), intent(out) :: mol
   integer, intent(in) :: at(:)
   character(len=*), intent(in) :: sym(:)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in), optional :: chrg
   integer, intent(in), optional :: uhf
   real(wp), intent(in), optional :: lattice(:, :)
   logical, intent(in), optional :: pbc(:)

   integer, allocatable :: id(:)
   character(len=symbolLength), allocatable :: sTmp(:)
   integer :: nAt, nId, iAt, iId

   nAt = min(size(at, dim=1), size(xyz, dim=2), size(sym, dim=1))

   call mol%allocate(nAt)

   if (present(lattice)) then
      mol%lattice = lattice
   else
      mol%lattice = 0.0_wp
   end if

   if (present(pbc)) then
      if (size(pbc) == 1) then
         mol%pbc = (/pbc, pbc, pbc/)
      else
         mol%pbc = pbc
      end if
      mol%npbc = count(pbc)
      if (any(pbc)) then
         mol%boundaryCondition = boundaryCondition%pbc3d
      else
         mol%boundaryCondition = boundaryCondition%cluster
      end if
   else
      if (present(lattice)) then
         mol%boundaryCondition = boundaryCondition%pbc3d
         mol%pbc = .true.
         mol%npbc = 3
      else
         mol%boundaryCondition = boundaryCondition%cluster
         mol%pbc = .false.
         mol%npbc = 0
      end if
   end if

   call getIdentity(mol%nId, mol%id, sym)
   mol%at(:) = at(:nAt)
   mol%sym(:) = sym(:nAt)

   mol%xyz(:, :) = xyz(:, :nAt)
   if (present(chrg)) then
      mol%chrg = chrg
   else
      mol%chrg = 0
   end if
   if (present(uhf)) then
      mol%uhf = uhf
   else
      mol%uhf = 0
   end if

   call mol%set_nuclear_charge
   call mol%set_atomic_masses

   call mol%update

end subroutine initMolecule


!> Constructor for the molecular structure type
subroutine initMoleculeNumbers &
      & (mol, at, xyz, chrg, uhf, lattice, pbc)
   type(TMolecule), intent(out) :: mol
   integer, intent(in) :: at(:)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in), optional :: chrg
   integer, intent(in), optional :: uhf
   real(wp), intent(in), optional :: lattice(3, 3)
   logical, intent(in), optional :: pbc(3)

   character(len=4), allocatable :: sym(:)
   integer :: nAt

   nAt = min(size(at, dim=1), size(xyz, dim=2))
   allocate(sym(nAt))
   sym(:) = toSymbol(at(:nAt))

   call init(mol, at, sym, xyz, chrg, uhf, lattice, pbc)

end subroutine initMoleculeNumbers


!> Constructor for the molecular structure type
subroutine initMoleculeSymbols &
      & (mol, sym, xyz, chrg, uhf, lattice, pbc)
   type(TMolecule), intent(out) :: mol
   character(len=*), intent(in) :: sym(:)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in), optional :: chrg
   integer, intent(in), optional :: uhf
   real(wp), intent(in), optional :: lattice(3, 3)
   logical, intent(in), optional :: pbc(3)

   integer, allocatable :: at(:)
   integer :: nAt

   nAt = min(size(sym, dim=1), size(xyz, dim=2))
   allocate(at(nAt))
   at(:) = toNumber(sym(:nAt))

   call init(mol, at, sym, xyz, chrg, uhf, lattice, pbc)

end subroutine initMoleculeSymbols


!> Constructor for the molecular structure type, compatible with C input
type(TMolecule) function new_molecule_api &
      & (n, at, xyz, chrg, uhf, lattice, pbc) result(mol)
   use iso_c_binding
   use xtb_mctc_symbols, only : toSymbol
   integer(c_int), intent(in) :: n
   integer(c_int), intent(in) :: at(n)
   real(c_double), intent(in) :: xyz(3, n)
   real(c_double), intent(in), target, optional :: chrg
   integer(c_int), intent(in), target, optional :: uhf
   real(c_double), intent(in), target, optional :: lattice(3, 3)
   logical(c_bool), intent(in), target, optional :: pbc(3)

   integer :: i

   call mol%allocate(n)

   if (c_associated(c_loc(lattice))) then
      mol%lattice = lattice
   else
      mol%lattice = 0.0_wp
   end if

   if (c_associated(c_loc(pbc))) then
      mol%pbc = pbc
      mol%npbc = count(pbc)
      if (any(pbc)) then
         mol%boundaryCondition = boundaryCondition%pbc3d
      else
         mol%boundaryCondition = boundaryCondition%cluster
      end if
   else
      if (c_associated(c_loc(lattice))) then
         mol%boundaryCondition = boundaryCondition%pbc3d
         mol%pbc = .true.
         mol%npbc = 3
      else
         mol%boundaryCondition = boundaryCondition%cluster
         mol%pbc = .false.
         mol%npbc = 0
      end if
   end if

   mol%at = at
   do i = 1, n
      mol%sym(i) = toSymbol(at(i))
   end do

   call getIdentity(mol%nId, mol%id, mol%at)

   mol%xyz = xyz
   if (c_associated(c_loc(chrg))) then
      mol%chrg = chrg
   else
      mol%chrg = 0
   end if
   if (c_associated(c_loc(uhf))) then
      mol%uhf = uhf
   else
      mol%uhf = 0
   end if

   call mol%set_nuclear_charge
   call mol%set_atomic_masses

   call mol%update

end function new_molecule_api


subroutine structure_to_molecule(mol, struc)
   type(TMolecule), intent(inout) :: mol
   type(structure_type), intent(in) :: struc
   integer :: ibd

   call initMolecule(mol, struc%num(struc%id), struc%sym(struc%id), struc%xyz, &
      & chrg=struc%charge, uhf=struc%uhf, pbc=struc%periodic, lattice=struc%lattice)
   mol%info = struc%info
   if (allocated(struc%sdf)) then
      mol%sdf = struc%sdf
   end if
   if (allocated(struc%pdb)) then
      mol%pdb = struc%pdb
   end if
   if (struc%nbd > 0) then
      call mol%bonds%allocate(3, struc%nbd)
      do ibd = 1, struc%nbd
         call mol%bonds%push_back(struc%bond(:, ibd))
      end do
   end if
end subroutine structure_to_molecule

subroutine molecule_to_structure(struc, mol)
   type(structure_type), intent(inout) :: struc
   type(TMolecule), intent(in) :: mol
   integer :: ibd, idx(3)

   call new_structure(struc, mol%at, mol%sym, mol%xyz, charge=mol%chrg, uhf=mol%uhf, &
      & periodic=mol%pbc, lattice=mol%lattice, info=mol%info)
   if (allocated(mol%sdf)) then
      struc%sdf = mol%sdf
   end if
   if (allocated(mol%pdb)) then
      struc%pdb = mol%pdb
   end if
   if (len(mol%bonds) > 0) then
      allocate(struc%bond(3, len(mol%bonds)))
      struc%nbd = len(mol%bonds)
      do ibd = 1, len(mol%bonds)
         call mol%bonds%get_item(ibd, idx)
         struc%bond(:, ibd) = idx
      end do
   end if
end subroutine molecule_to_structure


!> obtain number of atoms for molecular structure
!
!  The molecular structure is assumed to be well-behaved in this respect
!  so there is no sanity check on the allocation status.
integer pure elemental function mol_length(self) result(length)
   class(TMolecule),intent(in) :: self !< molecular structure information
   length = self%n
end function mol_length


!> constructor for molecular structure
subroutine allocate_molecule(self,n)
   implicit none
   class(TMolecule),intent(inout) :: self !< molecular structure information
   integer,intent(in) :: n
   call self%deallocate
   self%n = n
   allocate( self%id(n),          source = 0 )
   allocate( self%at(n),          source = 0 )
   allocate( self%sym(n),         source = '    ' )
   allocate( self%xyz(3,n),       source = 0.0_wp )
   allocate( self%abc(3,n),       source = 0.0_wp )
   allocate( self%dist(n,n),      source = 0.0_wp )
   allocate( self%atmass(n),      source = 0.0_wp )
   allocate( self%z(n),           source = 0.0_wp )
   allocate( self%cn(n),          source = 0.0_wp )
end subroutine allocate_molecule

!> deconstructor for molecular structure
subroutine deallocate_molecule(self)
   implicit none
   class(TMolecule),intent(inout) :: self !< molecular structure information
   self%n = 0
   self%nId = 0
   self%pbc = .false.
   self%chrg = 0.0_wp
   self%uhf = 0
   self%lattice = 0.0_wp
   if (allocated(self%id))     deallocate(self%id)
   if (allocated(self%at))     deallocate(self%at)
   if (allocated(self%sym))    deallocate(self%sym)
   if (allocated(self%xyz))    deallocate(self%xyz)
   if (allocated(self%abc))    deallocate(self%abc)
   if (allocated(self%dist))   deallocate(self%dist)
   if (allocated(self%atmass)) deallocate(self%atmass)
   if (allocated(self%z))      deallocate(self%z)
   if (allocated(self%cn))     deallocate(self%cn)
   if (allocated(self%pdb))    deallocate(self%pdb)
   if (allocated(self%sdf))    deallocate(self%sdf)
   if (allocated(self%name))   deallocate(self%name)
   call self%bonds%deallocate
   call self%frag%deallocate
end subroutine deallocate_molecule

subroutine update(self)
   use xtb_mctc_accuracy, only : wp
   use xtb_pbc_tools

   implicit none
   class(TMolecule),intent(inout) :: self  
      !! molecular structure information
   
   !> For periodic calculations
   if (self%npbc > 0) then
      call dlat_to_cell(self%lattice,self%cellpar)
      call dlat_to_rlat(self%lattice,self%rec_lat)
      self%volume = dlat_to_dvol(self%lattice)

      call self%wrap_back
   endif
   
   call self%calculate_distances

end subroutine update

!> calculates all distances for molecular structures and minimum
!> image distances for periodic structures
subroutine mol_calculate_distances(self)
   use xtb_mctc_accuracy, only : wp
   use xtb_pbc_tools
   
   implicit none
   class(TMolecule),intent(inout) :: self 
      !! molecular structure information
   integer :: i,j
   
   if (self%npbc > 0) then
      do i = 1, self%n
         do j = 1, i-1
            self%dist(j,i) = minimum_image_distance(.false.,self%abc(:,i), &
               &              self%abc(:,j),self%lattice,self%pbc)
            self%dist(i,j) = self%dist(j,i)
         enddo
         self%dist(j,i) = minimum_image_distance(.true.,self%abc(:,i), &
            &              self%abc(:,i),self%lattice,self%pbc)
      enddo
   else
      do i = 1, self%n
         do j = 1, i-1
            self%dist(j,i) = sqrt(sum((self%xyz(:,j)-self%xyz(:,i))**2))
            self%dist(i,j) = self%dist(j,i)
         enddo
         self%dist(i,i) = 0.0_wp
      enddo
   endif

end subroutine mol_calculate_distances

!> get all nuclear charges
subroutine mol_set_nuclear_charge(self)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(TMolecule),intent(inout) :: self  !< molecular structure information
   integer :: i
   do i = 1, self%n
      self%z(i) = real(self%at(i),wp) - real(ncore(self%at(i)))
      if (self%at(i) > 57 .and. self%at(i) < 72) self%z(i) = 3.0_wp
   enddo
contains

pure elemental integer function ncore(at)
  integer,intent(in) :: at
  if(at.le.2)then
     ncore=0
  elseif(at.le.10)then
     ncore=2
  elseif(at.le.18)then
     ncore=10
  elseif(at.le.29)then   !zn
     ncore=18
  elseif(at.le.36)then
     ncore=28
  elseif(at.le.47)then
     ncore=36
  elseif(at.le.54)then
     ncore=46
  elseif(at.le.71)then
     ncore=54
  elseif(at.le.79)then
     ncore=68
  elseif(at.le.86)then
     ncore=78
  endif
end function ncore
end subroutine mol_set_nuclear_charge

!> get all nuclear charges
subroutine mol_set_atomic_masses(self)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_param
   implicit none
   class(TMolecule),intent(inout) :: self  !< molecular structure information
   self%atmass = atomic_mass(self%at)
end subroutine mol_set_atomic_masses

!> wrap cartesian coordinates back into cell
!
!  This automatically done when calling @see xyz_to_abc, so we only have
!  to perform the transformation there and back again
subroutine wrap_back(self)
   use xtb_mctc_accuracy, only : wp
   use xtb_pbc_tools
   implicit none
   class(TMolecule),intent(inout) :: self !< molecular structure information
   call xyz_to_abc(self%n,self%lattice,self%xyz,self%abc,self%pbc)
   call abc_to_xyz(self%n,self%lattice,self%abc,self%xyz)
end subroutine wrap_back

pure function center_of_geometry(self) result(center)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(TMolecule),intent(in) :: self !< molecular structure information
   real(wp) :: center(3)
   integer  :: idir
   center = 0.0_wp

   do idir = 1, 3
      if (.not.self%pbc(idir)) &
         center(idir) = sum(self%xyz(idir,:))
   enddo
   center = center/real(self%n,wp)
end function center_of_geometry

pure subroutine shift_to_center_of_geometry(self)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(TMolecule),intent(inout) :: self !< molecular structure information
   real(wp) :: center(3)
   integer  :: iat
   center = self%center_of_geometry()
   do iat = 1, self%n
      self%xyz(:,iat) = self%xyz(:,iat) - center
   enddo
end subroutine shift_to_center_of_geometry

pure function molecular_mass(self) result(molmass)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(TMolecule),intent(in) :: self !< molecular structure information
   real(wp) :: molmass
   molmass = sum(self%atmass)
end function molecular_mass

pure function center_of_mass(self) result(center)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(TMolecule),intent(in) :: self !< molecular structure information
   real(wp) :: center(3)
   integer  :: idir
   center = 0.0_wp
   do idir = 1, 3
      if (.not.self%pbc(idir)) &
         center(idir) = sum(self%atmass*self%xyz(idir,:))
   enddo
   center = center/sum(self%atmass)
end function center_of_mass

pure subroutine shift_to_center_of_mass(self)
   use xtb_mctc_accuracy, only : wp
   implicit none
   class(TMolecule),intent(inout) :: self !< molecular structure information
   real(wp) :: center(3)
   integer  :: iat
   center = self%center_of_mass()
   do iat = 1, self%n
      self%xyz(:,iat) = self%xyz(:,iat) - center
   enddo
end subroutine shift_to_center_of_mass

pure function moments_of_inertia(self) result(moments)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_math, only : eigval3x3
   implicit none
   class(TMolecule),intent(in) :: self !< molecular structure information
   real(wp) :: moments(3)
   real(wp) :: center(3),atmass,inertia(3,3),work(9),tmp(3,3)
   real(wp) :: x,x2,y,y2,z,z2
   integer  :: iat,info
   ! currently not supported
   if (self%npbc > 0) then
      moments = -1.0_wp
      return
   endif
   center = self%center_of_mass()

   inertia(:, :) = 0.0_wp

   do iat = 1, self%n
      atmass = self%atmass(iat)
      x = self%xyz(1,iat)-center(1); x2 = x**2
      y = self%xyz(2,iat)-center(2); y2 = y**2
      z = self%xyz(3,iat)-center(3); z2 = z**2
      inertia(1,1) = inertia(1,1) + atmass * (y2+z2)
      inertia(1,2) = inertia(1,2) - atmass * x*y
      inertia(2,2) = inertia(2,2) + atmass * (x2+z2)
      inertia(1,3) = inertia(1,3) - atmass * x*z
      inertia(2,3) = inertia(2,3) - atmass * y*z
      inertia(3,3) = inertia(3,3) + atmass * (x2+y2)
   enddo

   call eigval3x3(inertia, moments)

end function moments_of_inertia

pure function rotational_constants(self)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_la
   implicit none
   class(TMolecule),intent(in) :: self !< molecular structure information
   real(wp) :: moments(3)
   real(wp) :: rotational_constants(3)

   moments = self%moments_of_inertia()
   rotational_constants = 0.5_wp/[moments(3), moments(2), moments(1)]

end function rotational_constants

pure subroutine align_to_principal_axes(self,break_symmetry)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_math, only : eigvec3x3, matdet3x3
   use xtb_pbc_tools
   implicit none
   class(TMolecule),intent(inout) :: self !< molecular structure information
   logical, optional, intent(in)    :: break_symmetry
   real(wp) :: moments(3),det
   real(wp) :: center(3),atmass,inertia(3,3),axes(3,3)
   real(wp) :: x,x2,y,y2,z,z2
   integer  :: i,iat
   ! currently not supported
   if (self%npbc > 0) then
      return
   endif
   center = self%center_of_mass()
   inertia(:, :) = 0.0_wp
   if (present(break_symmetry)) then
      if (break_symmetry) then
         inertia(1,1) = 1.0e-10_wp
         inertia(1,2) = 2.0e-10_wp
         inertia(2,2) = 3.0e-10_wp
         inertia(1,3) = 4.0e-10_wp
         inertia(2,3) = 5.0e-10_wp
         inertia(3,3) = 6.0e-10_wp
      end if
   endif

   do iat = 1, self%n
      atmass = self%atmass(iat)
      x = self%xyz(1,iat)-center(1); x2 = x**2
      y = self%xyz(2,iat)-center(2); y2 = y**2
      z = self%xyz(3,iat)-center(3); z2 = z**2
      inertia(1,1) = inertia(1,1) + atmass * (y2+z2)
      inertia(1,2) = inertia(1,2) - atmass * x*y
      inertia(2,2) = inertia(2,2) + atmass * (x2+z2)
      inertia(1,3) = inertia(1,3) - atmass * x*z
      inertia(2,3) = inertia(2,3) - atmass * y*z
      inertia(3,3) = inertia(3,3) + atmass * (x2+y2)
   enddo

   call eigvec3x3(inertia,moments,axes)

   det = matDet3x3(axes)
   if (det < 0) axes(:,1) = -axes(:,1)

   call coord_trafo(self%n,axes,self%xyz)

end subroutine align_to_principal_axes


end module xtb_type_molecule

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Density matrix (P) tight binding (TB) calculator
module xtb_ptb_calculator
   use xtb_type_calculator, only: TCalculator
   use xtb_type_data
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule, only: TMolecule, assignment(=)
   use xtb_type_param, only: TPTBParameter
   use xtb_type_restart, only: TRestart
   use xtb_setparam
   use xtb_fixparam
   use xtb_mctc_systools, only: rdpath

   use mctc_env, only: wp, error_type
   use mctc_io, only: structure_type, new
   use mctc_io_convert, only: autoev

#if WITH_TBLITE
   use xtb_tblite_mapping, only : convert_tblite_to_wfn, convert_tblite_to_results

   use multicharge_model, only: new_mchrg_model, mchrg_model_type

   use tblite_basis_type, only: basis_type
   use tblite_context, only: context_type
   use tblite_lapack_solver, only: lapack_solver
   use tblite_wavefunction, only: wavefunction_type, new_wavefunction
   use tblite_integral_type, only: integral_type
   use tblite_adjlist, only: adjacency_list

   !> PTB modules that are dependent on tblite
   use xtb_ptb_param, only: initPTB, ptbGlobals
   use xtb_ptb_vdzp, only: add_vDZP_basis
   use xtb_ptb_scf, only: twostepscf
   use xtb_ptb_corebasis, only: add_core_basis
   use xtb_ptb_integral_types, only: aux_integral_type
   use xtb_ptb_response, only: numgrad_polarizability
#endif
   !> PTB data type that is not dependent on tblite
   use xtb_ptb_data, only: TPTBData
   implicit none

   private

   public :: TPTBCalculator, newPTBCalculator

   !> Calculator interface for PTB method
   type, extends(TCalculator) :: TPTBCalculator

#if WITH_TBLITE
      !> PTB vDZP basis set
      type(basis_type) :: bas, cbas

      !> EEQ Model
      type(mchrg_model_type) :: eeqmodel
#endif

      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData

      !> Electronic temperature
      real(wp) :: etemp

   contains

      !> Perform PTB single point calculation
      procedure :: singlepoint

      !> Write informative printout
      procedure :: writeInfo

   end type TPTBCalculator

   character(len=*), private, parameter :: outfmt = &
                                           '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'
   character(len=*), parameter :: intfmt = &
                                  '(10x,":",2x,a,i18,      10x,":")'
   character(len=*), parameter :: chrfmt = &
                                  '(10x,":",2x,a,a18,      10x,":")'
   character(len=*), parameter :: scifmt = &
                                  '(10x,":",2x,a,e22.7,1x,a,1x,":")'
   character(len=*), parameter :: dblfmt = &
                                  '(10x,":",2x,a,f18.7,5x,a,1x,":")'
   !> Conversion factor from temperature to energy
   real(wp), parameter :: kt = 3.166808578545117e-06_wp
   !> Finite-field step for numerical dipole polarizability
   real(wp), parameter :: dF = 5.0E-5_wp

contains

   subroutine newPTBCalculator(env, struc, calc, accuracy)

      character(len=*), parameter :: source = 'xtb_ptb_calculator_newPTBCalculator'

      type(TEnvironment), intent(inout) :: env

      type(TMolecule), intent(in) :: struc

      type(TPTBCalculator), intent(out) :: calc

      real(wp), intent(in), optional :: accuracy

      character(len=:), allocatable :: filename
      integer :: ich
      logical :: exist
      logical :: exitRun

#if WITH_TBLITE
      !> mctc-io structure type
      type(structure_type) :: mol

      mol = struc

      call rdpath(env%xtbpath, 'param_ptb.txt', filename, exist)
      if (.not. exist) filename = 'param_ptb.txt'

      if (present(accuracy)) then
         calc%accuracy = accuracy
      else
         calc%accuracy = 1.0_wp
      end if

      calc%etemp = set%etemp

      !> Obtain the parameter file
      allocate (calc%ptbData)
      call open_file(ich, filename, 'r')
      exist = ich /= -1
      if (exist) &
         call env%warning('Parameter file '//filename//' not supported yet.!', source)
      
      ! read the hardcoded parameters !
      call initPTB(calc%ptbData, mol%num)

      call env%check(exitRun)
      if (exitRun) then
         call env%error("Could not load parameters", source)
         return
      end if

      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, calc%bas)

      !> Add the core basis set to 'cbas' basis set type
      call add_core_basis(mol, calc%ptbData%corepotential, calc%cbas)
      
      !> set up the EEQ model
      call new_mchrg_model(calc%eeqmodel, chi=calc%ptbData%eeq%chi, &
      & rad=calc%ptbData%eeq%alp, eta=calc%ptbData%eeq%gam, kcn=calc%ptbData%eeq%cnf)

      !> check for external point charge field
      !> not implemented yet
      ! if (allocated(set%pcem_file)) then
      !    call open_file(ich, set%pcem_file, 'r')
      !    if (ich /= -1) then
      !       call read_pcem(ich, env, calc%pcem, calc%xtbData%coulomb)
      !       call close_file(ich)
      !    end if
      ! end if
#else
      call feature_not_implemented(env)
#endif

   end subroutine newPTBCalculator

   subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
         & energy, gradient, sigma, hlgap, results)

      !> Source of the generated errors
      character(len=*), parameter :: source = 'ptb_calculator_singlepoint'

      !> Calculator instance
      class(TPTBCalculator), intent(inout) :: self

      !> Computational environment
      type(TEnvironment), intent(inout) :: env

      !> Molecular structure data
      type(TMolecule), intent(inout) :: mol

      !> Wavefunction data
      type(TRestart), intent(inout) :: chk

      !> Print level for IO
      integer, intent(in) :: printlevel

      !> Restart from previous results
      logical, intent(in) :: restart

      !> Total energy
      real(wp), intent(out) :: energy

      !> Molecular gradient
      real(wp), intent(out) :: gradient(:, :)

      !> Strain derivatives
      real(wp), intent(out) :: sigma(:, :)

      !> HOMO-LUMO gap
      real(wp), intent(out) :: hlgap

      !> Detailed results
      type(scc_results), intent(out) :: results

#if WITH_TBLITE
      !#################################################
      !> PTB INDIVIDUAL
      !#################################################
      type(structure_type) :: mctcmol
      !> tblite calculation context
      type(context_type) :: ctx
      !> Error type
      type(error_type), allocatable :: error
      !> Wiberg bond order
      real(wp), allocatable :: wbo(:, :, :)
      !> Static homogenoues external electric field
      real(wp), allocatable :: efield(:)
      !> Approx. effective core potential
      real(wp), allocatable :: Vecp(:, :)
      !> Auxiliary integrals
      type(aux_integral_type) :: auxints
      !> Exact integrals
      type(integral_type) :: ints
      !> Adjacency list
      type(adjacency_list) :: neighborlist
      !> Effective self-energies
      real(wp), allocatable :: selfenergies(:)
      !> Electrostatic potential in second iteration
      real(wp), allocatable :: v_ES_2nditer(:)
      !> Coordination number for +U contribution
      real(wp) :: CN_plusU(mol%n)

      logical :: exitRun
      !> Divide-and-conquer solver
      integer :: gvd = 1
      !> Relatively robust solver
      integer :: gvr = 2

      energy = 0.0_wp
      gradient = 0.0_wp
      sigma = 0.0_wp

      call mol%update
      mctcmol = mol

      ctx%solver = lapack_solver(gvd)
      ctx%unit = env%unit
      ctx%verbosity = printlevel

      !> Set new PTB wavefunction in tblite format
      call newPTBWavefunction(env, self, mctcmol, chk%tblite)

      !> Static Homogeneous External Electric Field
      if (sum(abs(set%efield)) > 1.0E-6_wp) then
         allocate (efield(3), source=0.0_wp)
         efield = set%efield
      end if

      allocate (wbo(mctcmol%nat, mctcmol%nat, chk%tblite%nspin))
      call twostepscf(ctx, chk%tblite, self%ptbData, mctcmol, self%bas, self%cbas, ints, auxints, self%eeqmodel, &
         & results%dipole, results%quadrupole, vecp, neighborlist, selfenergies, v_ES_2nditer, CN_plusU, wbo, efield)
      !> INFO ON RETURNED VARIABLES: On return, ints%hamiltonian contains the last Hamiltonian matrix that was solved
      !> including all potentials and contributions. I.e., it does NOT contain H0 as intended in the usual SCF procedure.

      if (ctx%failed()) then
         do while (ctx%failed())
            call ctx%get_error(error)
            call env%error(error%message, source)
         end do
         call env%error("PTB two-step SCF terminated", source)
         call env%check(exitRun)
         if (exitRun) then
            return
         end if
      end if
      call convert_tblite_to_wfn(env, self%bas, mol, chk, wbo=wbo)
      call convert_tblite_to_results(results,mol,chk,energy,.true.)
      hlgap = results%hl_gap

      !> polarizability by simple perturbative treatment
      !> this is only done in alpha,beta cases
      if (set%elprop == p_elprop_alpha) then
         call numgrad_polarizability(ctx, self%ptbData, mctcmol, self%bas, chk%tblite, &
            & ints, auxints, vecp, neighborlist, selfenergies, v_ES_2nditer, CN_plusU, dF, results%alpha)
         if (ctx%failed()) then
            do while (ctx%failed())
               call ctx%get_error(error)
               call env%error(error%message, source)
            end do
            call env%error("PTB response terminated", source)
            call env%check(exitRun)
            if (exitRun) then
               return
            end if
         end if
      end if
#else
      call feature_not_implemented(env)
#endif

   end subroutine singlepoint

   subroutine writeInfo(self, unit, mol)

      !> Calculator instance
      class(TPTBCalculator), intent(in) :: self

      !> Unit for I/O
      integer, intent(in) :: unit

      !> Molecular structure data
      type(TMolecule), intent(in) :: mol

      call self%ptbData%writeInfo(unit, mol%at)

   end subroutine writeInfo


#if WITH_TBLITE
!---------------------------------------------
! Initialize new wavefunction
!---------------------------------------------
!> Create new wavefunction restart data for tblite library
   subroutine newPTBWavefunction(env, calc, mol, wfn)
      !> Source of the generated errors
      character(len=*), parameter :: source = 'ptb_calculator_newPTBWavefunction'
      !> Calculation environment
      type(TEnvironment), intent(inout) :: env
      !> Instance of the new calculator
      type(TPTBCalculator), intent(in) :: calc
      !> mctc-io structure type
      type(structure_type) :: mol
      !> Wavefunction data
      type(wavefunction_type) :: wfn
      !> mctc-env error type
      type(error_type), allocatable :: error

      call new_wavefunction(wfn, mol%nat, calc%bas%nsh, calc%bas%nao, &
         & nspin=1, kt=calc%etemp * kt)

      if (allocated(error)) then
         call env%error(error%message, source)
         return
      end if
   end subroutine newPTBWavefunction
#endif

#if ! WITH_TBLITE
   subroutine feature_not_implemented(env)
      !> Computational environment
      type(TEnvironment), intent(inout) :: env

      call env%error("PTB not available without 'tblite'. Compiled without support for 'tblite' library.")
      call env%error("Please recompile without '-Dtblite=disabled' option or change meson setup.")
   end subroutine feature_not_implemented
#endif
end module xtb_ptb_calculator

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!******************************************
! rotate rigid fragment in binding "pocket"
! of other fragment
!******************************************
subroutine pocketscan(n,at,xyz,nout)
   use xtb_mctc_symbols, only : toSymbol
   use xtb_splitparam
   use xtb_setparam
   use xtb_disp_ncoord, only : ncoord_d3
   implicit none
   integer n,at(n),i,j,k,ios,ierr,npath,nout
   real*8 xyz(3,n),cn0(n),cn(n),coord(3,n),f,dum,cthr
   real*8 cma1(3),cma2(3),trfm1(3,3),trfm2(3,3)
   real*8, allocatable :: xyzpath(:,:,:)
   character*2 dummy
   integer :: ich

   npath=set%mode_nscan
   if(mod(npath,2).eq.0) npath=npath+1 ! make it odd
   ierr=0
   nout=0
   f=0.5291770d0
   cn0=0.0d0
   cthr=1.0d0
   !     call ncoord2(.false.,n,at,xyz,cn0,500.0d0)
   call ncoord_d3(n,at,xyz,cn0,500.0d0)
   ! obtain cma's and principal axes of 1 and 2
   call ifaceaxis(n,at,xyz,cma1,trfm1,cma2,trfm2)

   allocate(xyzpath(3,n,3*npath), stat=ios)
   if(ios.ne.0) stop 'error in mode 0 alloc'
   xyzpath=0.0d0
   !***************************************
   ! now rotate fragment 1 around axes of 1
   !***************************************
   call pocketrotation(n,at,xyz,cma1,trfm1,1,npath,xyzpath)

   call open_file(ich,'xtb_modescan_0.xyz','w')
   ! check for clashes and do reoptimization
   do k=1,3*npath
      coord(1:3,1:n)=xyzpath(1:3,1:n,k)
      cn=0.0d0
      !       call ncoord2(.false.,n,at,coord,cn,500.0d0)
      call ncoord_d3(n,at,coord,cn,500.0d0)
      dum=-1.0d0
      do i=1,n
         if(abs(cn(i)-cn0(i)).gt.dum) dum=abs(cn(i)-cn0(i)) ! clash ch
      enddo
      if(dum.gt.cthr) then
         ierr=ierr+1
         cycle
      endif
      write(ich,*)n
      write(ich,*)
      do i=1,n
         write(ich,'(1x,a2,1x,3f18.8)')&
            &     toSymbol(at(i)),xyzpath(1:3,i,k)*f
      enddo
   enddo

   deallocate(xyzpath)

   ! ***
   allocate(xyzpath(3,n,3*npath), stat=ios)
   if(ios.ne.0) stop 'error in mode 0 alloc'
   xyzpath=0.0d0

   !***************************************
   ! now rotate fragment 2 around axes of 2
   !***************************************
   call pocketrotation(n,at,xyz,cma2,trfm2,2,npath,xyzpath)
   ! check for clashes and do reoptimization
   do k=1,3*npath
      coord(1:3,1:n)=xyzpath(1:3,1:n,k)
      cn=0.0d0
      !       call ncoord2(.false.,n,at,coord,cn,500.0d0)
      call ncoord_d3(n,at,coord,cn,500.0d0)
      dum=-1.0d0
      do i=1,n
         if(abs(cn(i)-cn0(i)).gt.dum) dum=abs(cn(i)-cn0(i)) ! clash ch
      enddo
      if(dum.gt.cthr) then
         ierr=ierr+1
         cycle
      endif
      write(ich,*)n
      write(ich,*)
      do i=1,n
         write(ich,'(1x,a2,1x,3f18.8)')&
            &     toSymbol(at(i)),xyzpath(1:3,i,k)*f
      enddo
   enddo
   call close_file(ich)

   deallocate(xyzpath)


   nout=6*npath - ierr

   return
end subroutine

subroutine pocketrotation(n,at,xyz,cma,trfm,ifrag,npath,xyzpath)
   use xtb_splitparam
   implicit none
   real*8 xyz(3,n),coord(3,n),turncrd(3,n),addcrd(3,n),turncrd0(3,n)
   integer n,at(n),ifrag,npath
   real*8 cma(3),trfm(3,3),rotm(3,3),dblepi,step,f
   real*8 xyzpath(3,n,3*npath)
   integer i,j,k

   f=0.5291770d0
   dblepi =2.0d0*3.14159265358979D0
   if(npath.lt.1) then
      step=dblepi/12.0d0
      npath=11
   else
      step=dblepi/dble(npath+1)
   endif

   coord=0.0d0
   turncrd=0.0d0
   turncrd0=0.0d0
   addcrd=0.0d0
   do i=1,n
      if(splitlist(i).eq.ifrag) then
         turncrd0(1:3,i)=xyz(1:3,i)-cma(1:3) ! part that is rotated
      else
         addcrd(1:3,i)=xyz(1:3,i)-cma(1:3) ! part that is fixed and si
         ! cma is added here, simply to have a simpler addition later
      endif
   enddo
   turncrd0=matmul(trfm,turncrd0)
   !*******************
   ! rotation around x
   !*******************
   turncrd=turncrd0
   rotm(1,1)=1.0d0
   rotm(2,1)=0.0d0
   rotm(3,1)=0.0d0
   rotm(1,2)=0.0d0
   rotm(2,2)=cos(step)
   rotm(3,2)=sin(step)
   rotm(1,3)=0.0d0
   rotm(2,3)=-sin(step)
   rotm(3,3)=cos(step)
   j=0
   ! now rotate stepwise
   do k=1,npath
      j=j+1
      coord=0.0d0
      turncrd=matmul(rotm,turncrd)
      coord=matmul(transpose(trfm),turncrd)
      do i=1,n
         xyzpath(1:3,i,j)=coord(1:3,i)+cma(1:3)+addcrd(1:3,i)
      enddo
   enddo

   !*******************
   ! rotation around y
   !*******************
   turncrd=turncrd0
   rotm(1,1)=cos(step)
   rotm(2,1)=0.0d0
   rotm(3,1)=sin(step)
   rotm(1,2)=0.0d0
   rotm(2,2)=1.0d0
   rotm(3,2)=0.0d0
   rotm(1,3)=-sin(step)
   rotm(2,3)=0.0d0
   rotm(3,3)=cos(step)

   ! now rotate stepwise
   do k=1,npath
      j=j+1
      coord=0.0d0
      turncrd=matmul(rotm,turncrd)
      coord=matmul(transpose(trfm),turncrd)
      do i=1,n
         xyzpath(1:3,i,j)=coord(1:3,i)+cma(1:3)+addcrd(1:3,i)
      enddo
   enddo

   !*******************
   ! rotation around z
   !*******************
   turncrd=turncrd0
   rotm(1,1)=cos(step)
   rotm(2,1)=sin(step)
   rotm(3,1)=0.0d0
   rotm(1,2)=-sin(step)
   rotm(2,2)=cos(step)
   rotm(3,2)=0.0d0
   rotm(1,3)=0.0d0
   rotm(2,3)=0.0d0
   rotm(3,3)=1.0d0

   ! now rotate stepwise
   do k=1,npath
      j=j+1
      coord=0.0d0
      turncrd=matmul(rotm,turncrd)
      coord=matmul(transpose(trfm),turncrd)
      do i=1,n
         xyzpath(1:3,i,j)=coord(1:3,i)+cma(1:3)+addcrd(1:3,i)
      enddo
   enddo


   return
end subroutine


!*********************************************
! principal rotation axes for pocket rotation
!*********************************************
subroutine ifaceaxis(numat,nat,coord,cma1,trfm1,cma2,trfm2)
   use xtb_splitparam
   implicit none
   real*8 coord(3,numat)
   integer numat,nat(numat)
   real*8 cma1(3),cma2(3),trfm1(3,3),trfm2(3,3)
   real*8 t1(6),t2(6),eig(3),x(numat),y(numat),z(numat)
   real*8 sum1w,sum1wx,sum1wy,sum1wz,atmss,eps
   real*8 sum2w,sum2wx,sum2wy,sum2wz,xsum
   integer i,j,k

   sum1w=1.d-20
   sum1wx=0.d0
   sum1wy=0.d0
   sum1wz=0.d0
   sum2w=1.d-20
   sum2wx=0.d0
   sum2wy=0.d0
   sum2wz=0.d0

   do i=1,numat
      atmss=atmass(i)
      if(splitlist(i).eq.1)then
         sum1w =sum1w+atmss
         sum1wx=sum1wx+atmss*coord(1,i)
         sum1wy=sum1wy+atmss*coord(2,i)
         sum1wz=sum1wz+atmss*coord(3,i)
      else
         sum2w =sum2w+atmss
         sum2wx=sum2wx+atmss*coord(1,i)
         sum2wy=sum2wy+atmss*coord(2,i)
         sum2wz=sum2wz+atmss*coord(3,i)
      endif
   enddo

   eps=1.d-3
   sum1wx=sum1wx/sum1w
   sum1wy=sum1wy/sum1w
   sum1wz=sum1wz/sum1w
   sum2wx=sum2wx/sum2w
   sum2wy=sum2wy/sum2w
   sum2wz=sum2wz/sum2w
   cma1=0.0d0
   cma2=0.0d0
   cma1(1)=sum1wx
   cma1(2)=sum1wy
   cma1(3)=sum1wz
   cma2(1)=sum2wx
   cma2(2)=sum2wy
   cma2(3)=sum2wz

   ! shift to respective CMA
   do i=1,numat
      if(splitlist(i).eq.1)then
         x(i)=coord(1,i)-sum1wx
         y(i)=coord(2,i)-sum1wy
         z(i)=coord(3,i)-sum1wz
      else
         x(i)=coord(1,i)-sum2wx
         y(i)=coord(2,i)-sum2wy
         z(i)=coord(3,i)-sum2wz
      endif
   enddo

   ! initialize moment of inertia tensors
   do i=1,6
      t1(i)=dble(i)*1.0d-10
      t2(i)=dble(i)*1.0d-10
   enddo

   do i=1,numat
      atmss=atmass(i)
      if(splitlist(i).eq.1)then
         t1(1)=t1(1)+atmss*(y(i)**2+z(i)**2)+eps
         t1(2)=t1(2)-atmss*x(i)*y(i)
         t1(3)=t1(3)+atmss*(z(i)**2+x(i)**2)+eps
         t1(4)=t1(4)-atmss*z(i)*x(i)
         t1(5)=t1(5)-atmss*y(i)*z(i)
         t1(6)=t1(6)+atmss*(x(i)**2+y(i)**2)+eps
      else
         t2(1)=t2(1)+atmss*(y(i)**2+z(i)**2)+eps
         t2(2)=t2(2)-atmss*x(i)*y(i)
         t2(3)=t2(3)+atmss*(z(i)**2+x(i)**2)+eps
         t2(4)=t2(4)-atmss*z(i)*x(i)
         t2(5)=t2(5)-atmss*y(i)*z(i)
         t2(6)=t2(6)+atmss*(x(i)**2+y(i)**2)+eps
      endif
   enddo


   trfm1=0.0d0
   trfm2=0.0d0
   eig=0.0d0
   ! solve eigenvalue problem for iface 1
   call rsp(t1,3,3,eig,trfm1)
   eig=0.0d0
   ! solve eigenvalue problem for iface 2
   call rsp(t2,3,3,eig,trfm2)



   !   check for right-handedness and flip otherwise
   xsum=0.0d0
   xsum=trfm1(1,1)*(trfm1(2,2)*trfm1(3,3)-trfm1(3,2)*trfm1(2,3)) +   &
      &     trfm1(1,2)*(trfm1(2,3)*trfm1(3,1)-trfm1(2,1)*trfm1(3,3)) +   &
      &     trfm1(1,3)*(trfm1(2,1)*trfm1(3,2)-trfm1(2,2)*trfm1(3,1))
   if( xsum .lt. 0.0d0) then
      do j=1,3
         trfm1(j,1)=-trfm1(j,1)
      enddo
   endif

   xsum=0.0d0
   xsum=trfm2(1,1)*(trfm2(2,2)*trfm2(3,3)-trfm2(3,2)*trfm2(2,3)) +   &
      &     trfm2(1,2)*(trfm2(2,3)*trfm2(3,1)-trfm2(2,1)*trfm2(3,3)) +   &
      &     trfm2(1,3)*(trfm2(2,1)*trfm2(3,2)-trfm2(2,2)*trfm2(3,1))
   if( xsum .lt. 0.0d0) then
      do j=1,3
         trfm2(j,1)=-trfm2(j,1)
      enddo
   endif


   return
end subroutine

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_CPCMX
#define WITH_CPCMX 0
#endif

!> This module implements the CPCM-X solvation library for xTB.

module xtb_solv_cpx
#if WITH_CPCMX
    use cpx, only: calculation_type, parameter_type, atomicmass, density,&
    &initialize_param,load_solvent,read_cosmo
#endif
    use xtb_solv_cosmo, only: TCosmo
    use xtb_setparam, only: get_namespace
    use xtb_type_environment, only: TEnvironment
    use iso_fortran_env, only: input_unit, output_unit
    use mctc_env, only: error_type, fatal_error, wp
    implicit none
    private
    public :: TCpcmx

    character(len=*), parameter :: source = 'xtb_solv_cpx'


    !> CPCM-X calculation type
#if WITH_CPCMX
    type, extends(calculation_type) :: TCpcmx
#else
    type :: TCpcmx
#endif
        contains

        procedure :: setup => setup_cpcmx
        procedure :: calc_solv => calculate_cpcmx
        procedure :: print => print_cpcmx
    end type Tcpcmx

    contains

    subroutine setup_cpcmx(self, env, solvent)
        implicit none
        class(Tcpcmx), intent(inout) :: self
        type(TEnvironment), intent(inout) :: env
        !> Solvent name for internal CPCM-X database
        character(len=*), intent(in) :: solvent
        !> Error handling
        type(error_type), allocatable :: error
#if WITH_CPCMX
        !> Load xTB parameters from internal CPCM-X database
        call initialize_param('xtb',solvent,self,error)
        if (allocated(error)) Call env%error(error%message, source)
        call load_solvent(solvent,self%solvent,error)
        if (allocated(error)) Call env%error(error%message, source)
        !> TODO: SETUP solute directly from TCosmo instead of reading COSMO file
        Call read_cosmo(get_namespace('xtb.cosmo'),self%solute,'NONE',error)
        if (allocated(error)) Call env%error(error%message, source)
#else
        Call no_cpcmx_here(env)
#endif
    end subroutine setup_cpcmx

    subroutine calculate_cpcmx(self,env,solvent,energy_gas,probe,T,max_cycle,conv_crit,total_energy)
        implicit none
        class(Tcpcmx), intent(inout) :: self
        type(TEnvironment), intent(inout) :: env
        !> Solvent name for solvent properties (density, atomic mass) from internal CPCM-X database
        !> xTB gas phase energy
        real(wp), intent(in) :: energy_gas
        character(len=*), intent(in) :: solvent
        !> Error handling
        type(error_type), allocatable :: error
        !> Probe radius
        real(wp), intent(in) :: probe
        !> Temperature
        real(wp), intent(in) :: T
        !> Convergence criteria for restoring free energy
        integer, intent(in) :: max_cycle
        real(wp), intent(in) :: conv_crit
        !> Final Total Energy
        real(wp), intent(out) :: total_energy
#if WITH_CPCMX
        self%solute%energy_gas=energy_gas
        !> Charge averaging
        call self%average_charge(error)
        if (allocated(error)) Call env%error(error%message, source)
        call self%init_bonding()
        !> Calculate restoring free energy
        call self%solv('crs',error,T,max_cycle,conv_crit)
        if (allocated(error)) Call env%error(error%message, source)
        !> Calculate SMD contribution and state correction
        call self%state_correction(density(solvent),atomicmass(self%solvent%element),T)
        call self%cds(probe,solvent)
        total_energy= self%dG()+energy_gas
#else
        Call no_cpcmx_here(env)
#endif
    end subroutine calculate_cpcmx

    !> Print CPCM-X results
    subroutine print_cpcmx(self,verbose)
        implicit none
        class(Tcpcmx), intent(in) :: self
        !> Output level
        logical, intent(in), optional :: verbose

        real(wp), parameter :: autokcal=627.509_wp
        logical :: pr

        if (present(verbose)) then
            pr=verbose
        else
            pr=.false.
        end if
#if WITH_CPCMX
        write(output_unit,*) ""
        write(output_unit,'(5x,a,t55,a,t66,a)') &
            "Free Energy contributions:", "[Eh]", " [kcal/mol]"
        write(output_unit,'(4x,a)') repeat('-',73)
        if (pr) then
            write(output_unit,'(5x,a,t50,E13.5,t65,F10.5)') &
                "Ideal State (dG_IS):", self%dG_is, self%dG_is*autokcal, &
                "Averaging correction (dG_av):", self%dG_cc, self%dG_cc*autokcal, &
                "restoring free energy (dG_res):", self%dG_res, self%dG_res*autokcal, &
                "SMD Contribution (dG_CDS):", self%dG_smd, self%dG_smd*autokcal, &
                "Standard state correction (dG_corr):", self%dG_ss, self%dG_ss*autokcal, &
                "Systematic empirical shift (dG_shift)", self%dG_shift, self%dG_shift*autokcal
            write(output_unit,'(4x,a)') repeat('-',73)
        else
        end if
        write(output_unit,'(5x,a,t50,E13.5,t65,F10.5)') &
        "solvation free energy (dG_solv): ", self%dG(), self%dG()*autokcal, &
        "gas phase energy (E)", self%solute%energy_gas
        write(output_unit,'(4x,a)') repeat('-',73)
        write(output_unit,'(5x,a,t50,E13.5,t65,F10.5)') &
        "total free energy (dG)", self%dG()+self%solute%energy_gas
        write(output_unit,*) ""
#endif
    end subroutine print_cpcmx


#if ! WITH_CPCMX
    subroutine no_cpcmx_here(env)
        type(TEnvironment), intent(inout) :: env

        call env%error('CPCM-X is not available in this version of xtb.', source)
    end subroutine no_cpcmx_here
#endif

end module xtb_solv_cpx

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ========================================================================
!  call as:
!  interface
!     pure subroutine ncoord_name(nat,at,xyz,cn,thr)
!     use iso_fortran_env, only : wp => real64
!     implicit none
!     integer, intent(in)  :: nat
!     integer, intent(in)  :: at(nat)
!     real(wp),intent(in)  :: xyz(3,nat)
!     real(wp),intent(out) :: cn(nat)
!     real(wp),intent(in),optional :: thr
!  end interface
!  interface
!     pure subroutine dncoord_name(nat,at,xyz,cn,dcn,thr)
!     use iso_fortran_env, only : wp => real64
!     implicit none
!     integer, intent(in)  :: nat
!     integer, intent(in)  :: at(nat)
!     real(wp),intent(in)  :: xyz(3,nat)
!     real(wp),intent(out) :: cn(nat)
!     real(wp),intent(out) :: dcn(3,nat,nat)
!     real(wp),intent(in),optional :: thr
!  end interface
!! ========================================================================
module xtb_disp_ncoord
   use xtb_mctc_accuracy, only : wp
   implicit none

   real(wp),private,parameter :: cnthr = 1600.0_wp

   real(wp),parameter :: k1 = 16.0_wp
   real(wp),parameter :: k2 = 4.0_wp/3.0_wp

   real(wp),parameter :: ka=10.0_wp
   real(wp),parameter :: kb=20.0_wp
   real(wp),parameter :: r_shift=2.0_wp

   real(wp),parameter :: k4=4.10451_wp
   real(wp),parameter :: k5=19.08857_wp
   real(wp),parameter :: k6=2*11.28174_wp**2

   real(wp),parameter :: kn=7.50_wp
   real(wp),parameter :: kr=0.25_wp
   real(wp),parameter :: ke=0.05_wp

   integer,private,parameter :: max_elem = 118

!  covalent radii (taken from Pyykko and Atsumi, Chem. Eur. J. 15, 2009,
!  188-197), values for metals decreased by 10 %
   real(wp),private,parameter :: rad(max_elem) = (/  &
   & 0.32,0.46, & ! H,He
   & 1.20,0.94,0.77,0.75,0.71,0.63,0.64,0.67, & ! Li-Ne
   & 1.40,1.25,1.13,1.04,1.10,1.02,0.99,0.96, & ! Na-Ar
   & 1.76,1.54, & ! K,Ca
   &           1.33,1.22,1.21,1.10,1.07,1.04,1.00,0.99,1.01,1.09, & ! Sc-Zn
   &           1.12,1.09,1.15,1.10,1.14,1.17, & ! Ga-Kr
   & 1.89,1.67, & ! Rb,Sr
   &           1.47,1.39,1.32,1.24,1.15,1.13,1.13,1.08,1.15,1.23, & ! Y-Cd
   &           1.28,1.26,1.26,1.23,1.32,1.31, & ! In-Xe
   & 2.09,1.76, & ! Cs,Ba
   &      1.62,1.47,1.58,1.57,1.56,1.55,1.51, & ! La-Eu
   &      1.52,1.51,1.50,1.49,1.49,1.48,1.53, & ! Gd-Yb
   &           1.46,1.37,1.31,1.23,1.18,1.16,1.11,1.12,1.13,1.32, & ! Lu-Hg
   &           1.30,1.30,1.36,1.31,1.38,1.42, & ! Tl-Rn
   & 2.01,1.81, & ! Fr,Ra
   &      1.67,1.58,1.52,1.53,1.54,1.55,1.49, & ! Ac-Am
   &      1.49,1.51,1.51,1.48,1.50,1.56,1.58, & ! Cm-No
   &           1.45,1.41,1.34,1.29,1.27,1.21,1.16,1.15,1.09,1.22, & ! Lr-Cn
   &           1.22,1.29,1.46,1.58,1.48,1.41 /) ! Nh-Og
   real(wp),parameter :: rcov(max_elem) = 4.0_wp/3.0_wp*rad/0.52917726_wp

!  pauling EN's
   real(wp),parameter :: en(max_elem) = (/ &
   & 2.20,3.00, & ! H,He
   & 0.98,1.57,2.04,2.55,3.04,3.44,3.98,4.50, & ! Li-Ne
   & 0.93,1.31,1.61,1.90,2.19,2.58,3.16,3.50, & ! Na-Ar
   & 0.82,1.00, & ! K,Ca
   &           1.36,1.54,1.63,1.66,1.55,1.83,1.88,1.91,1.90,1.65, & ! Sc-Zn
   &           1.81,2.01,2.18,2.55,2.96,3.00, & ! Ga-Kr
   & 0.82,0.95, & ! Rb,Sr
   &           1.22,1.33,1.60,2.16,1.90,2.20,2.28,2.20,1.93,1.69, & ! Y-Cd
   &           1.78,1.96,2.05,2.10,2.66,2.60, & ! In-Xe
   & 0.79,0.89, & ! Cs,Ba
   &      1.10,1.12,1.13,1.14,1.15,1.17,1.18, & ! La-Eu
   &      1.20,1.21,1.22,1.23,1.24,1.25,1.26, & ! Gd-Yb
   &           1.27,1.30,1.50,2.36,1.90,2.20,2.20,2.28,2.54,2.00, & ! Lu-Hg
   &           1.62,2.33,2.02,2.00,2.20,2.20, & ! Tl-Rn
   ! only dummies below
   & 1.50,1.50, & ! Fr,Ra
   &      1.50,1.50,1.50,1.50,1.50,1.50,1.50, & ! Ac-Am
   &      1.50,1.50,1.50,1.50,1.50,1.50,1.50, & ! Cm-No
   &           1.50,1.50,1.50,1.50,1.50,1.50,1.50,1.50,1.50,1.50, & ! Rf-Cn
   &           1.50,1.50,1.50,1.50,1.50,1.50 /) ! Nh-Og


   interface get_d3_cn
      module procedure ncoord_d3_driver
      module procedure ncoord_d3
      module procedure dncoord_d3
   end interface
   interface get_erf_cn
      module procedure ncoord_erf_driver
      module procedure ncoord_erf
      module procedure dncoord_erf
   end interface
   interface get_d4_cn
      module procedure ncoord_d4_driver
      module procedure ncoord_d4
      module procedure dncoord_d4
      module procedure pbc_ncoord_d4
      module procedure pbc_dncoord_d4
   end interface
   interface get_gfn_cn
      module procedure ncoord_gfn_driver
      module procedure ncoord_gfn
      module procedure dncoord_gfn
   end interface

contains

pure subroutine ncoord_d3_driver(mol,cn,dcndr,thr)
   use xtb_type_molecule
   implicit none
   !> molecular structure information
   type(TMolecule), intent(in) :: mol
   !> coordination number
   real(wp), intent(out) :: cn(:)
   !> derivative of coordination number w.r.t. nuclear positions
   real(wp), intent(out), optional :: dcndr(:,:,:)
   !> quadratic distance threshold for sum termination
   real(wp), intent(in), optional :: thr
   real(wp) :: cn_thr

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

!   if (mol%npbc > 0) then
!      if (present(dcndr).and.present(dcndL)) then
!      else
!      endif
!   else
      if (present(dcndr)) then
         call dncoord_d3(mol%n,mol%at,mol%xyz,cn,dcndr,cn_thr)
      else
         call ncoord_d3(mol%n,mol%at,mol%xyz,cn,cn_thr)
      endif
!   endif

end subroutine ncoord_d3_driver

pure subroutine ncoord_gfn_driver(mol,cn,dcndr,thr)
   use xtb_type_molecule
   implicit none
   !> molecular structure information
   type(TMolecule), intent(in) :: mol
   !> coordination number
   real(wp), intent(out) :: cn(:)
   !> derivative of coordination number w.r.t. nuclear positions
   real(wp), intent(out), optional :: dcndr(:,:,:)
   !> quadratic distance threshold for sum termination
   real(wp), intent(in), optional :: thr
   real(wp) :: cn_thr

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

!   if (mol%npbc > 0) then
!      if (present(dcndr).and.present(dcndL)) then
!      else
!      endif
!   else
      if (present(dcndr)) then
         call dncoord_gfn(mol%n,mol%at,mol%xyz,cn,dcndr,cn_thr)
      else
         call ncoord_gfn(mol%n,mol%at,mol%xyz,cn,cn_thr)
      endif
!   endif

end subroutine ncoord_gfn_driver

pure subroutine ncoord_erf_driver(mol,cn,dcndr,dcndL,thr)
   use xtb_type_molecule
   implicit none
   !> molecular structure information
   type(TMolecule), intent(in) :: mol
   !> coordination number
   real(wp), intent(out) :: cn(:)
   !> derivative of coordination number w.r.t. nuclear positions
   real(wp), intent(out), optional :: dcndr(:,:,:)
   !> derivative of coordination number w.r.t. lattice vectors
   real(wp), intent(out), optional :: dcndL(:,:,:)
   !> quadratic distance threshold for sum termination
   real(wp), intent(in), optional :: thr
   real(wp) :: cn_thr

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   if (mol%npbc > 0) then
      if (present(dcndr).and.present(dcndL)) then
         call pbc_derfcoord(mol%n,mol%at,mol%xyz,mol%lattice,cn,dcndr,dcndL,cn_thr)
      else
         call pbc_erfcoord(mol%n,mol%at,mol%xyz,mol%lattice,cn,cn_thr)
      endif
   else
      if (present(dcndr)) then
         call dncoord_erf(mol%n,mol%at,mol%xyz,cn,dcndr,cn_thr)
      else
         call ncoord_erf(mol%n,mol%at,mol%xyz,cn,cn_thr)
      endif
   endif

end subroutine ncoord_erf_driver

pure subroutine ncoord_d4_driver(mol,cn,dcndr,dcndL,thr)
   use xtb_type_molecule
   implicit none
   !> molecular structure information
   type(TMolecule), intent(in) :: mol
   !> coordination number
   real(wp), intent(out) :: cn(:)
   !> derivative of coordination number w.r.t. nuclear positions
   real(wp), intent(out), optional :: dcndr(:,:,:)
   !> derivative of coordination number w.r.t. lattice vectors
   real(wp), intent(out), optional :: dcndL(:,:,:)
   !> quadratic distance threshold for sum termination
   real(wp), intent(in), optional :: thr
   real(wp) :: cn_thr

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   if (mol%npbc > 0) then
      if (present(dcndr).and.present(dcndL)) then
         call pbc_dncoord_d4(mol%n,mol%at,mol%xyz,mol%lattice,cn,dcndr,dcndL,cn_thr)
      else
         call pbc_ncoord_d4(mol%n,mol%at,mol%xyz,mol%lattice,cn,cn_thr)
      endif
   else
      if (present(dcndr)) then
         call dncoord_d4(mol%n,mol%at,mol%xyz,cn,dcndr,cn_thr)
      else
         call ncoord_d4(mol%n,mol%at,mol%xyz,cn,cn_thr)
      endif
   endif

end subroutine ncoord_d4_driver

! ========================================================================
!> original D3 type coordination number from 2010
pure subroutine ncoord_d3(nat,at,xyz,cn,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j
   real(wp) :: rij(3), r, rco, den, tmp, r2

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn = 0.0_wp

   do i = 1, nat
      do j = 1, i-1
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
!        covalent distance in bohr
         rco=rcov(at(j)) + rcov(at(i))
!        counting function exponential has a better long-range
!        behavior than MHGs inverse damping
         tmp=exp_count(k1,r,rco)
         cn(i)=cn(i)+tmp
         cn(j)=cn(j)+tmp
      enddo
   enddo

end subroutine ncoord_d3

! ========================================================================
!  original D3 type coordination number from 2010
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  dcndr  :: derivative of coordination number w.r.t. atom position
!  PARAMETERS: k1,k2
!  NOTE: k2 is already included in rcov
pure subroutine dncoord_d3(nat,at,xyz,cn,dcndr,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i, j
   real(wp) :: r, r2, rij(3)
   real(wp) :: rcovij
   real(wp) :: expterm
   real(wp) :: dtmp, tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0._wp
   dcndr = 0._wp

   do i = 1, nat
      do j = 1, i-1
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r = sqrt(r2)
         rcovij=(rcov(at(i))+rcov(at(j)))
         tmp = exp_count(k1,r,rcovij)
         dtmp = dexp_count(k1,r,rcovij)
         cn(i) = cn(i) + tmp
         cn(j) = cn(j) + tmp
         dcndr(:,i,i)=-dtmp*rij/r + dcndr(:,i,i) ! FIXME
         dcndr(:,j,j)= dtmp*rij/r + dcndr(:,j,j) ! FIXME
         dcndr(:,i,j)= dtmp*rij/r
         dcndr(:,j,i)=-dtmp*rij/r
      enddo
   enddo

end subroutine dncoord_d3

! gradients for pbc coordination number with exp function
pure subroutine pbc_dncoord_d3(nat,at,xyz,lat,cn,dcndr,dcndL,thr)
   use xtb_mctc_constants
   use xtb_pbc_tools
   use xtb_pbc, only : get_realspace_cutoff

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(out) :: dcndL(3,3,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j,tx,ty,tz
   real(wp) :: rij(3), r, rco, den, rr, r2, t(3)
   integer  :: rep_cn(3)
   real(wp) :: tmp,dtmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   call get_realspace_cutoff(lat,cn_thr,rep_cn)

   cn = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp

   do i = 1, nat
      do j = 1, i-1 ! loop over all atoms for PBC case
         do concurrent(tx = -rep_cn(1):rep_cn(1), &
               &       ty = -rep_cn(2):rep_cn(2), &
               &       tz = -rep_cn(3):rep_cn(3))
            t = tx*lat(:,1) + ty*lat(:,2) + tz*lat(:,3)
            rij = xyz(:,j) - xyz(:,i) + t
            r2  = sum(rij**2)
            if (r2.gt.cn_thr) cycle
            r=sqrt(r2)
!           covalent distance in bohr
            rco=rcov(at(j)) + rcov(at(i))
            tmp=exp_count(k1,r,rco)
            dtmp = dexp_count(k1,r,rco)
            cn(i)=cn(i) + tmp
            cn(j)=cn(j) + tmp
            dcndr(:,i,i)= dtmp*rij/r + dcndr(:,i,i)
            dcndr(:,j,j)=-dtmp*rij/r + dcndr(:,j,j)
            dcndr(:,i,j)= dtmp*rij/r + dcndr(:,i,j)
            dcndr(:,j,i)=-dtmp*rij/r + dcndr(:,j,i)
            dcndL(:,:,j)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,j)
            dcndL(:,:,i)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,i)
         enddo
      enddo
      do concurrent(tx = -rep_cn(1):rep_cn(1), &
            &       ty = -rep_cn(2):rep_cn(2), &
            &       tz = -rep_cn(3):rep_cn(3), &
            &       tx.ne.0 .or. ty.ne.0 .or. tz.ne.0)
         t = tx*lat(:,1) + ty*lat(:,2) + tz*lat(:,3)
         rij = t
         r2  = sum(rij**2)
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
!        covalent distance in bohr
         rco=2*rcov(at(i))
         tmp=exp_count(k1,r,rco)
         dtmp = dexp_count(k1,r,rco)
         cn(i)=cn(i) + tmp
         dcndL(:,:,i)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,i)
      enddo
   enddo

end subroutine pbc_dncoord_d3



! ========================================================================
!  modified D3 type coordination number from 2018
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  PARAMETERS: kn,k2
!  NOTE: k2 is already included in rcov
pure subroutine ncoord_erf(nat,at,xyz,cn,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j
   real(wp) :: rij(3), r, rco, den, rr, r2, tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn = 0.0_wp

   do i = 1, nat
      do j = 1, i-1
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
!        covalent distance in bohr
         rco=rcov(at(j)) + rcov(at(i))
!        error function has an even better long range behavior
         tmp = erf_count(kn,r,rco)
         cn(i)=cn(i)+tmp
         cn(j)=cn(j)+tmp
      enddo
   enddo

end subroutine ncoord_erf

! ========================================================================
!  modified D3 type coordination number from 2018
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  dcndr  :: derivative of coordination number w.r.t. atom position
!  PARAMETERS: kn,k2
!  NOTE: k2 is already included in rcov
pure subroutine dncoord_erf(nat,at,xyz,cn,dcndr,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j
   real(wp) :: r,r2,rij(3)
   real(wp) :: rcovij
   real(wp) :: dtmp,tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0._wp
   dcndr = 0._wp

   do i = 1, nat
      do j = 1, i-1
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r = sqrt(r2)
         rcovij=(rcov(at(i))+rcov(at(j)))
         tmp = erf_count(kn,r,rcovij)
         dtmp = derf_count(kn,r,rcovij)
         cn(i) = cn(i) + tmp
         cn(j) = cn(j) + tmp
         dcndr(:,i,i)= dtmp*rij/r + dcndr(:,i,i)
         dcndr(:,j,j)=-dtmp*rij/r + dcndr(:,j,j)
         dcndr(:,i,j)= dtmp*rij/r
         dcndr(:,j,i)=-dtmp*rij/r
      enddo
   enddo

end subroutine dncoord_erf

! ========================================================================
!  covalent coordination number of the DFT-D4 method
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  PARAMETERS: k1,k2,k4,k5,k6
!  NOTE: k2 is already included in rcov
pure subroutine ncoord_d4(nat,at,xyz,cn,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j
   real(wp) :: rij(3), r, rco, den, rr, r2, xn, tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn = 0._wp

   do i=1,nat
      do j=1,i-1
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
!        covalent distance in bohr
         rco=rcov(at(j)) + rcov(at(i))
         rr=rco/r
         den=k4*exp(-(abs((en(at(i))-en(at(j))))+ k5)**2/k6 )
!        counting function exponential has a better long-range
!        behavior than MHGs inverse damping
         !tmp = den/(1.d0+exp(-k1*(rr-1.0d0)))
!        error function has an even better long range behavior
         tmp = den * erf_count(kn,r,rco)
         cn(i)=cn(i)+tmp
         cn(j)=cn(j)+tmp
      enddo
   enddo

end subroutine ncoord_d4

! ========================================================================
!  derivative of the covalent coordination number of the DFT-D4 method
!  NOTE: the derivative is inlined in the dispgrad in dftd4 by hand
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  dcndr  :: derivative of coordination number w.r.t. atom position
!  PARAMETERS: k1,k2,k4,k5,k6
!  NOTE: k2 is already included in rcov
pure subroutine dncoord_d4(nat,at,xyz,cn,dcndr,thr)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i, j, ia, ja
   real(wp) :: r, r2, rij(3)
   real(wp) :: rcovij,den
   real(wp) :: dtmp, tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0._wp
   dcndr = 0._wp

   do i = 1, nat
      ia = at(i)
      do j = 1, i-1
         ja = at(j)
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r = sqrt(r2)
         rcovij=(rcov(ia)+rcov(ja))
         den=k4*exp(-(abs((en(ia)-en(ja)))+ k5)**2/k6 )
         tmp = den * erf_count(kn,r,rcovij)
         dtmp = den * derf_count(kn,r,rcovij)
         cn(i) = cn(i) + tmp
         cn(j) = cn(j) + tmp
         dcndr(:,i,i)=-dtmp*rij/r + dcndr(:,i,i)
         dcndr(:,j,j)= dtmp*rij/r + dcndr(:,j,j)
         dcndr(:,i,j)=-dtmp*rij/r
         dcndr(:,j,i)= dtmp*rij/r
      enddo
   enddo

end subroutine dncoord_d4

! same for the pbc case
pure subroutine pbc_ncoord_d4(nat,at,xyz,lat,cn,thr)
   use xtb_mctc_constants
   use xtb_pbc_tools
   use xtb_pbc, only : get_realspace_cutoff
   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer              :: rep_cn(3)
   integer              :: tx,ty,tz
   real(wp)             :: t(3)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j
   real(wp) :: rij(3), r, rco, den, r2, xn, tmp, dtmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0.0_wp

   call get_realspace_cutoff(lat,cn_thr,rep_cn)

   do i=1,nat
      do j=1,i-1
         do concurrent(tx = -rep_cn(1):rep_cn(1), &
               &       ty = -rep_cn(2):rep_cn(2), &
               &       tz = -rep_cn(3):rep_cn(3))
            t = [tx,ty,tz]
            rij = xyz(:,j) - xyz(:,i) + matmul(lat,t)
            r2  = sum(rij**2)
            if (r2.gt.cn_thr) cycle
            r=sqrt(r2)
            ! covalent distance in bohr
            rco=rcov(at(j)) + rcov(at(i))
            den=k4*exp(-(abs((en(at(i))-en(at(j))))+ k5)**2/k6 )
            tmp = den * erf_count(kn,r,rco)
            cn(i)=cn(i)+tmp
            cn(j)=cn(j)+tmp
         enddo
      enddo
      do concurrent(tx = -rep_cn(1):rep_cn(1), &
            &       ty = -rep_cn(2):rep_cn(2), &
            &       tz = -rep_cn(3):rep_cn(3), &
            &       tx.ne.0 .or. ty.ne.0 .or. tz.ne.0)
         t = [tx,ty,tz]
         rij = matmul(lat,t)
         r2  = sum(rij**2)
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
         ! covalent distance in bohr
         rco=2*rcov(at(i))
         den=k4*exp(-k5**2/k6 )
         tmp = den * erf_count(kn,r,rco)
         cn(i)=cn(i)+tmp
      enddo
   enddo

end subroutine pbc_ncoord_d4

! same for the pbc case
pure subroutine pbc_dncoord_d4(nat,at,xyz,lat,cn,dcndr,dcndL,thr)
   use xtb_mctc_constants
   use xtb_pbc_tools
   use xtb_pbc, only : get_realspace_cutoff
   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer              :: rep_cn(3)
   integer              :: tx,ty,tz
   real(wp)             :: t(3)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(out) :: dcndL(3,3,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j
   real(wp) :: rij(3), r, rco, den, r2, xn, tmp, dtmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp

   call get_realspace_cutoff(lat,cn_thr,rep_cn)

   do i=1,nat
      do j=1,i-1
         do concurrent(tx = -rep_cn(1):rep_cn(1), &
               &       ty = -rep_cn(2):rep_cn(2), &
               &       tz = -rep_cn(3):rep_cn(3))
            t = [tx,ty,tz]
            rij = xyz(:,j) - xyz(:,i) + matmul(lat,t)
            r2  = sum(rij**2)
            if (r2.gt.cn_thr) cycle
            r=sqrt(r2)
            ! covalent distance in bohr
            rco=rcov(at(j)) + rcov(at(i))
            den=k4*exp(-(abs((en(at(i))-en(at(j))))+ k5)**2/k6 )
            tmp = den * erf_count(kn,r,rco)
            dtmp = den * derf_count(kn,r,rco)
            cn(i)=cn(i)+tmp
            cn(j)=cn(j)+tmp
            dcndr(:,i,i)=-dtmp*rij/r + dcndr(:,i,i)
            dcndr(:,j,j)= dtmp*rij/r + dcndr(:,j,j)
            dcndr(:,i,j)=-dtmp*rij/r + dcndr(:,i,j)
            dcndr(:,j,i)= dtmp*rij/r + dcndr(:,j,i)
            dcndL(:,:,j)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,j)
            dcndL(:,:,i)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,i)
         enddo
      enddo
      do concurrent(tx = -rep_cn(1):rep_cn(1), &
            &       ty = -rep_cn(2):rep_cn(2), &
            &       tz = -rep_cn(3):rep_cn(3))
         ! avoid self interaction
         if ((tx.eq.0).and.(ty.eq.0).and.(tz.eq.0)) cycle
         t = [tx,ty,tz]
         rij = matmul(lat,t)
         r2  = sum(rij**2)
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
         ! covalent distance in bohr
         rco=2*rcov(at(i))
         den=k4*exp(-k5**2/k6)
         tmp = den * erf_count(kn,r,rco)
         dtmp = den * derf_count(kn,r,rco)
         cn(i)=cn(i)+tmp
         dcndL(:,:,i)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,i)
      enddo
   enddo

end subroutine pbc_dncoord_d4

! ========================================================================
!  GFN2-xTB coordination number for CN dependent parts of the Hamiltonian
!  it's similar to the D3 coordination number but doubly damped, to avoid
!  large tail contributions in dense packed systems
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  PARAMETERS: ka,kb,k2,r_shift
!  NOTE: k2 is already included in rcov
pure subroutine ncoord_gfn(nat,at,xyz,cn,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i, j, ia, ja
   real(wp) :: r, r2, rij(3)
   real(wp) :: rcovij
   real(wp) :: expterm1, expterm2
   real(wp) :: tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0.0_wp

   do i = 1, nat
      ia = at(i)
      do j = 1, i-1
         ja = at(j)
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r = sqrt(r2)
         rcovij=(rcov(ia)+rcov(ja))
         expterm1=exp_count(ka,r,rcovij)
         expterm2=exp_count(kb,r,rcovij+r_shift)
         tmp = expterm1*expterm2
         cn(i) = cn(i) + tmp
         cn(j) = cn(j) + tmp
      enddo
   enddo

end subroutine ncoord_gfn

! ========================================================================
!  GFN2-xTB coordination number for CN dependent parts of the Hamiltonian
!  it's similar to the D3 coordination number but doubly damped, to avoid
!  large tail contributions in dense packed systems
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  OUTPUT
!  cn   :: coordination number
!  dcndr  :: derivative of coordination number w.r.t. atom position
!  PARAMETERS: ka,kb,k2,r_shift
!  NOTE: k2 is already included in rcov
pure subroutine dncoord_gfn(nat,at,xyz,cn,dcndr,thr)

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i, j, ia, ja
   real(wp) :: r, r2, rij(3)
   real(wp) :: rcovij
   real(wp) :: expterm1, expterm2
   real(wp) :: dtmp, tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   cn  = 0._wp
   dcndr = 0._wp

   do i = 1, nat
      ia = at(i)
      do j = 1, i-1
         ja = at(j)
         rij = xyz(:,j) - xyz(:,i)
         r2  = sum( rij**2 )
         if (r2.gt.cn_thr) cycle
         r = sqrt(r2)
         rcovij=(rcov(ia)+rcov(ja))
         expterm1=exp(-ka*(rcovij/r-1._wp))
         expterm2=exp(-kb*((rcovij+r_shift)/r-1._wp))
         tmp = 1._wp/(1._wp+expterm1)/(1._wp+expterm2)
         dtmp = (-ka*rcovij*expterm1) &
         &  /(r2*((expterm1+1._wp)**2))/(1._wp+expterm2) &
         &  + (-kb*(rcovij+r_shift)*expterm2) &
         &  /(r2*((expterm2+1._wp)**2))/(1._wp+expterm1)
         cn(i) = cn(i) + tmp
         cn(j) = cn(j) + tmp
         dcndr(:,i,i)=-dtmp*rij/r + dcndr(:,i,i)
         dcndr(:,j,j)= dtmp*rij/r + dcndr(:,j,j)
         dcndr(:,i,j)= dtmp*rij/r
         dcndr(:,j,i)=-dtmp*rij/r
      enddo
   enddo

end subroutine dncoord_gfn

! pbc coordination number with error function
pure subroutine pbc_erfcoord(nat,at,xyz,lat,cn,thr)
   use xtb_pbc, only : get_realspace_cutoff

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j,tx,ty,tz
   real(wp) :: rij(3), r, rco, den, rr, r2, t(3)
   integer  :: rep_cn(3)
   real(wp) :: tmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   call get_realspace_cutoff(lat,cn_thr,rep_cn)

   cn = 0.0_wp

   do i = 1, nat
      do j = 1, i-1 ! loop over all atoms for PBC case
         do concurrent(tx = -rep_cn(1):rep_cn(1), &
               &       ty = -rep_cn(2):rep_cn(2), &
               &       tz = -rep_cn(3):rep_cn(3))
            ! avoid self interaction
            if ((j.eq.i).and.(tx.eq.0).and.(ty.eq.0).and.(tz.eq.0)) cycle
            t = tx*lat(:,1) + ty*lat(:,2) + tz*lat(:,3)
            rij = xyz(:,j) - xyz(:,i) + t
            r2  = sum(rij**2)
            if (r2.gt.cn_thr) cycle
            r=sqrt(r2)
!           covalent distance in bohr
            rco=rcov(at(j)) + rcov(at(i))

            tmp=erf_count(kn,r,rco)
            cn(i)=cn(i) + tmp
            cn(j)=cn(j) + tmp
         enddo
      enddo
      do concurrent(tx = -rep_cn(1):rep_cn(1), &
            &       ty = -rep_cn(2):rep_cn(2), &
            &       tz = -rep_cn(3):rep_cn(3), &
            &       tx.ne.0 .or. ty.ne.0 .or. tz.ne.0)
         t = tx*lat(:,1) + ty*lat(:,2) + tz*lat(:,3)
         rij = t
         r2  = sum(rij**2)
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
!        covalent distance in bohr
         rco=2*rcov(at(i))

         tmp=erf_count(kn,r,rco)
         cn(i)=cn(i) + tmp
      enddo
   enddo

end subroutine pbc_erfcoord

! gradients for pbc coordination number with error function
pure subroutine pbc_derfcoord(nat,at,xyz,lat,cn,dcndr,dcndL,thr)
   use xtb_mctc_constants
   use xtb_pbc_tools
   use xtb_pbc, only : get_realspace_cutoff

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: cn(nat)
   real(wp),intent(out) :: dcndr(3,nat,nat)
   real(wp),intent(out) :: dcndL(3,3,nat)
   real(wp),intent(in),optional :: thr
   real(wp) :: cn_thr

   integer  :: i,j,tx,ty,tz
   real(wp) :: rij(3), r, rco, den, rr, r2, t(3)
   integer  :: rep_cn(3)
   real(wp) :: tmp,dtmp

   if (present(thr)) then
      cn_thr = thr
   else
      cn_thr = cnthr
   endif

   call get_realspace_cutoff(lat,cn_thr,rep_cn)

   cn = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp

   do i = 1, nat
      do j = 1, i-1 ! loop over all atoms for PBC case
         do concurrent(tx = -rep_cn(1):rep_cn(1), &
               &       ty = -rep_cn(2):rep_cn(2), &
               &       tz = -rep_cn(3):rep_cn(3))
            t = tx*lat(:,1) + ty*lat(:,2) + tz*lat(:,3)
            rij = xyz(:,j) - xyz(:,i) + t
            r2  = sum(rij**2)
            if (r2.gt.cn_thr) cycle
            r=sqrt(r2)
!           covalent distance in bohr
            rco=rcov(at(j)) + rcov(at(i))
            tmp=erf_count(kn,r,rco)
            dtmp = derf_count(kn,r,rco)
            cn(i)=cn(i) + tmp
            cn(j)=cn(j) + tmp
            dcndr(:,i,i)= dtmp*rij/r + dcndr(:,i,i)
            dcndr(:,j,j)=-dtmp*rij/r + dcndr(:,j,j)
            dcndr(:,i,j)= dtmp*rij/r + dcndr(:,i,j)
            dcndr(:,j,i)=-dtmp*rij/r + dcndr(:,j,i)
            dcndL(:,:,j)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,j)
            dcndL(:,:,i)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,i)
         enddo
      enddo
      do concurrent(tx = -rep_cn(1):rep_cn(1), &
            &       ty = -rep_cn(2):rep_cn(2), &
            &       tz = -rep_cn(3):rep_cn(3), &
            &       tx.ne.0 .or. ty.ne.0 .or. tz.ne.0)
         t = tx*lat(:,1) + ty*lat(:,2) + tz*lat(:,3)
         rij = t
         r2  = sum(rij**2)
         if (r2.gt.cn_thr) cycle
         r=sqrt(r2)
!        covalent distance in bohr
         rco=2*rcov(at(i))
         tmp=erf_count(kn,r,rco)
         dtmp = derf_count(kn,r,rco)
         cn(i)=cn(i) + tmp
         dcndL(:,:,i)= dtmp*outer_prod_3x3(rij,rij)/r + dcndL(:,:,i)
      enddo
   enddo

end subroutine pbc_derfcoord

!> cutoff function for large coordination numbers
subroutine dncoord_logcn(n,cn,dcndr,dcndL,cn_max)
   implicit none
   !> number of atoms
   integer, intent(in) :: n
   !> on input coordination number, on output modified CN
   real(wp), intent(inout) :: cn(n)
   !> on input derivative of CN w.r.t. cartesian coordinates,
   !  on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndr(3,n,n)
   !> on input derivative of CN w.r.t. strain deformation,
   !  on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndL(3,3,n)
   !> maximum CN (not strictly obeyed)
   real(wp), intent(in), optional :: cn_max
   !  local
   real(wp) :: cnmax
   real(wp) :: dcnpdcn
   integer  :: i

   if (present(cn_max)) then
      cnmax = max(cn_max,0.0_wp)
   else
      cnmax = 4.5_wp
   endif

   if (present(dcndL)) then
      do i = 1, n
         dcnpdcn = dlog_cn_cut(cn(i),cnmax)
         dcndL(:,:,i) = dcnpdcn*dcndL(:,:,i)
      enddo
   endif

   if (present(dcndr)) then
      do i = 1, n
         dcnpdcn = dlog_cn_cut(cn(i),cnmax)
         dcndr(:,:,i) = dcnpdcn*dcndr(:,:,i)
      enddo
   endif

   do i = 1, n
      cn(i) = log_cn_cut(cn(i),cnmax)
   enddo

end subroutine dncoord_logcn

pure elemental function log_cn_cut(cn,cnmax) result(cnp)
   real(wp), intent(in) :: cn
   real(wp), intent(in) :: cnmax
   real(wp) :: cnp
   cnp = log(1.0_wp + exp(cnmax)) - log(1.0_wp + exp(cnmax - cn))
end function log_cn_cut

pure elemental function dlog_cn_cut(cn,cnmax) result(dcnpdcn)
   real(wp), intent(in) :: cn
   real(wp), intent(in) :: cnmax
   real(wp) :: dcnpdcn
   dcnpdcn = exp(cnmax)/(exp(cnmax) + exp(cn))
end function dlog_cn_cut

pure elemental function erf_count(k,r,r0) result(count)
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   count = 0.5_wp * (1.0_wp + erf(-k*(r-r0)/r0))
end function erf_count

pure elemental function derf_count(k,r,r0) result(count)
   use xtb_mctc_constants
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   count = -k/sqrtpi/r0*exp(-k**2*(r-r0)**2/r0**2)
end function derf_count

pure elemental function exp_count(k,r,r0) result(count)
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   count =1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))
end function exp_count

pure elemental function dexp_count(k,r,r0) result(count)
   real(wp), intent(in) :: k
   real(wp), intent(in) :: r
   real(wp), intent(in) :: r0
   real(wp) :: count
   real(wp) :: expterm
   expterm=exp(-k*(r0/r-1._wp))
   count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))
end function dexp_count

end module xtb_disp_ncoord

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_latticepoint
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_latticepoint

contains

!> Collect all exported unit tests
subroutine collect_latticepoint(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("pbc3d", test_latticepoint_pbc3d) &
      ]

end subroutine collect_latticepoint


subroutine test_latticepoint_pbc3d(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_boundaryconditions, only : boundaryCondition
   use xtb_mctc_convert, only : aatoau
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_latticepoint, only : TLatticePoint, init
   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: lattice_SiO2(3,3) = reshape(&
      &[ 8.7413053236641_wp,  0.0000000000000_wp,  0.0000000000000_wp,  &
      &  0.0000000000000_wp,  8.7413053236641_wp,  0.0000000000000_wp,  &
      &  0.0000000000000_wp,  0.0000000000000_wp,  8.7413053236641_wp], &
      & shape(lattice_SiO2))

   real(wp), parameter :: lattice_CaF2(3,3) = reshape(&
      &[ 5.9598811567890_wp,  2.1071361905157_wp,  3.6496669404404_wp,  &
      &  0.0000000000000_wp,  6.3214085715472_wp,  3.6496669404404_wp,  &
      &  0.0000000000000_wp,  0.0000000000000_wp,  7.2993338808807_wp], &
      & shape(lattice_CaF2))

   real(wp), parameter :: lattice_ammonia(3,3) = reshape(&
      &[ 6.4411018522600_wp,  0.0492571261505_wp,  0.2192046129910_wp,  &
      &  0.0462076831749_wp,  6.6435057067500_wp,  0.1670513770770_wp,  &
      &  0.2262248220170_wp, -0.9573234940220_wp,  6.7608039126200_wp], &
      & shape(lattice_ammonia)) * aatoau

   type(TEnvironment) :: env
   type(TLatticePoint) :: latp
   logical :: fail
   real(wp), allocatable :: latticePoint(:, :)

   call init(env)

   call init(latp, env, lattice_SiO2, boundaryCondition%pbc3d, 40.0_wp)
   call env%check(fail)
   call check_(error, .not.fail)
   call check_(error, allocated(latp%trans))
   call check_(error, allocated(latp%dist2))
   call check_(error, latp%nTrans, 389)

   call latp%getLatticePoints(latticePoint)
   call check_(error, size(latticePoint, dim=2), 389)

   !> Simply switch lattice without reinitalization
   call latp%update(env, lattice_CaF2)
   call env%check(fail)
   call check_(error, .not.fail)
   call check_(error, allocated(latp%trans))
   call check_(error, allocated(latp%dist2))
   call check_(error, latp%nTrans, 959)

   call latp%getLatticePoints(latticePoint, 30.0_wp)
   call check_(error, size(latticePoint, dim=2), 381)

   call latp%getLatticePoints(latticePoint, 50.0_wp)
   call check_(error, size(latticePoint, dim=2), 959)

   !> Reinitialize with new lattice and new cutoff
   call init(latp, env, lattice_ammonia, boundaryCondition%pbc3d, 60.0_wp)
   call env%check(fail)
   call check_(error, .not.fail)
   call check_(error, allocated(latp%trans))
   call check_(error, allocated(latp%dist2))
   call check_(error, latp%nTrans, 451)

   call latp%getLatticePoints(latticePoint)
   call check_(error, size(latticePoint, dim=2), 451)

   call latp%getLatticePoints(latticePoint, 40.0_wp)
   call check_(error, size(latticePoint, dim=2), 143)

   !> Reinitialize generator to exclude inversion symmetry
   call init(latp, env, lattice_ammonia, boundaryCondition%pbc3d, 50.0_wp, &
      & excludeInversion=.true.)
   call env%check(fail)
   call check_(error, .not.fail)
   call check_(error, allocated(latp%trans))
   call check_(error, allocated(latp%dist2))
   call check_(error, latp%nTrans, 130)

   call latp%getLatticePoints(latticePoint, 40.0_wp)
   call check_(error, size(latticePoint, dim=2), 72) ! 143 / 2 + 1

   call latp%getLatticePoints(latticePoint, 33.0_wp)
   call check_(error, size(latticePoint, dim=2), 41)

end subroutine test_latticepoint_pbc3d

end module test_latticepoint

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Generic wrappers for all the readers implemented
module xtb_io_reader
   use mctc_env, only : error_type
   use mctc_io, only : structure_type, read_structure
   use xtb_io_reader_genformat, only : readHessianDFTBPlus
   use xtb_io_reader_orca, only : readHessianOrca
   use xtb_io_reader_turbomole, only : readHessianTurbomole
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType, hessType
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, assignment(=)
   use xtb_type_reader, only : TReader
   implicit none
   private

   public :: readMolecule, readHessian


contains


!> Generic reader for molecules from input files
subroutine readMolecule(env, mol, unit, ftype)

   !> Name of error producer
   character(len=*), parameter :: source = "io_reader_readMolecule"

   !> Calculation environment
   class(TEnvironment), intent(inout) :: env

   !> Instance of molecular structure data
   class(TMolecule), intent(out) :: mol

   !> File reader
   !class(TReader), intent(inout) :: reader
   integer, intent(in) :: unit

   !> Idenitifier for file type
   integer, intent(in) :: ftype

   type(structure_type) :: struc
   type(error_type), allocatable :: error
   integer :: ft


   ft = merge(filetype%tmol, ftype, ftype == filetype%unknown)
   call read_structure(struc, unit, ft, error)
   if (allocated(error)) then
      call env%error(error%message)
      return
   end if

   if (count(struc%periodic) == 1) then
      call env%error("1D periodic structures are currently unsupported", source)
      return
   end if

   if (count(struc%periodic) == 2) then
      call env%error("2D periodic structures are currently unsupported", source)
      return
   end if

   if (allocated(struc%sdf)) then
      if (any(struc%sdf%hydrogens > 0)) then
         call env%error("Hydrogen atom queries in ctfiles are currently unsupported", source)
         return
      end if
   end if

   if (allocated(struc%pdb)) then
      if (.not.any(struc%num == 1)) then
         call env%error("PDB structure without hydrogen atoms found, "//&
            &"aborting due to incomplete input geometry", source)
         return
      end if
   end if

   mol = struc
   mol%ftype = ft

end subroutine readMolecule


subroutine readHessian(env, mol, hessian, reader, format)
   character(len=*), parameter :: source = 'io_reader_readHessian'
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(in) :: mol
   type(TReader), intent(inout) :: reader
   integer, intent(in) :: format
   real(wp), intent(out) :: hessian(:, :)
   character(len=:), allocatable :: message
   logical :: status

   if (any(shape(hessian) /= [3*mol%n, 3*mol%n])) then
      call env%error("Shape of hessian array does not match geometry", source)
      return
   end if

   select case(format)
   case default
      message = "Unknown hessian format"
      status = .false.

   case(hessType%tmol)
      call readHessianTurbomole(hessian, reader, mol, status, message)

   case(hessType%orca)
      call readHessianOrca(hessian, reader, mol, status, message)

   case(hessType%dftbplus)
      call readHessianDFTBPlus(hessian, reader, mol, status, message)

   end select

   if (.not.status) then
      call env%error(message, source)
      return
   end if

end subroutine readHessian


end module xtb_io_reader

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!
!      888      888  .d8888b.   .d88888b.   .d8888b.  888b     d888  .d88888b.
!      888      888 d88P  Y88b d88P" "Y88b d88P  Y88b 8888b   d8888 d88P" "Y88b
!      888      888 888    888 888     888 Y88b.      88888b.d88888 888     888
!  .d88888  .d88888 888        888     888  "Y888b.   888Y88888P888 888     888
! d88" 888 d88" 888 888        888     888     "Y88b. 888 Y888P 888 888     888
! 888  888 888  888 888    888 888     888       "888 888  Y8P  888 888     888
! Y88b 888 Y88b 888 Y88b  d88P Y88b. .d88P Y88b  d88P 888   "   888 Y88b. .d88P
!  "Y88888  "Y88888  "Y8888P"   "Y88888P"   "Y8888P"  888       888  "Y88888P"
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  COPYRIGHT (C) 2015 by Filippo Lipparini, Benjamin Stamm, Paolo Gatto        !
!  Eric Cancès, Yvon Maday, Jean-Philip Piquemal, Louis Lagardère and          !
!  Benedetta Mennucci.                                                         !
!                             ALL RIGHT RESERVED.                              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! A modular implementation of COSMO using a domain decomposition linear scaling
! strategy.
!
! This code is governed by the LGPL license and abiding by the rules of
! distribution of free software.
! This program is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU Lesser General Public License for more details.
!
! Users of this code are asked to include the following references in their
! publications:
!
! [1] E. Cancès, Y. Maday, B. Stamm
!     "Domain decomposition for implicit solvation models"
!     J. Chem. Phys. 139, 054111 (2013)
!
! [2] F. Lipparini, B. Stamm, E. Cancès, Y. Maday, B. Mennucci
!     "Fast Domain Decomposition Algorithm for Continuum Solvation Models:
!      Energy and First Derivatives"
!     J. Chem. Theory Comput. 9, 3637–3648 (2013)
!
! Also, include one of the three following reference depending on whether you
! use this code in conjunction with a QM [3], Semiempirical [4] or Classical [5]
! description of the solute:
!
! [3] F. Lipparini, G. Scalmani, L. Lagardère, B. Stamm, E. Cancès, Y. Maday,
!     J.-P. Piquemal, M. J. Frisch, B. Mennucci
!     "Quantum, classical, and hybrid QM/MM calculations in solution: General
!      implementation of the ddCOSMO linear scaling strategy"
!     J. Chem. Phys. 141, 184108 (2014)
!     (for quantum mechanical models)
!
! [4] F. Lipparini, L. Lagardère, G. Scalmani, B. Stamm, E. Cancès, Y. Maday,
!     J.-P. Piquemal, M. J. Frisch, B. Mennucci
!     "Quantum Calculations in Solution for Large to Very Large Molecules:
!      A New Linear Scaling QM/Continuum Approach"
!     J. Phys. Chem. Lett. 5, 953-958 (2014)
!     (for semiempirical models)
!
! [5] F. Lipparini, L. Lagardère, C. Raynaud, B. Stamm, E. Cancès, B. Mennucci
!     M. Schnieders, P. Ren, Y. Maday, J.-P. Piquemal
!     "Polarizable Molecular Dynamics in a Polarizable Continuum Solvent"
!     J. Chem. Theory Comput. 11, 623-634 (2015)
!     (for classical models, including polarizable force fields
!
! The users of this code should also include the appropriate reference to the
! COSMO model. This distribution includes the routines to generate lebedev
! grids by D. Laikov and C. van Wuellen, as publicly available on CCL. If the
! routines are used, the following reference should also be included:
!
! [6] V.I. Lebedev, and D.N. Laikov
!     "A quadrature formula for the sphere of the 131st
!      algebraic order of accuracy"
!     Doklady Mathematics, Vol. 59, No. 3, 1999, pp. 477-481.
!
! Written by Filippo Lipparini, October 2015.
! Adapted by Sebastian Ehlert, June 2020.
module xtb_solv_ddcosmo_core
   implicit none
   private

   public :: TDomainDecomposition, TDomainDecompositionInput, initDomainDecomposition
   public :: hsnorm, calcv, intrhs, prtsph, adjrhs, wghpot, ddupdate, fdoka, fdokb, fdoga


   integer, parameter :: wp = selected_real_kind(15)
   integer, parameter :: ndiis=25, iout=6, nngmax=100
   real(wp), parameter :: zero=0._wp, pt5=0.5_wp, one=1._wp, two=2._wp, four=4._wp
   real(wp), parameter :: se = -1.0_wp
   real(wp), parameter :: pi = 4.0_wp*atan(1.0_wp)
   real(wp), parameter :: sq2 = sqrt(2.0_wp)


   !> Quantities contained in control file
   type :: TDomainDecompositionInput

      !> Max angular momentum of spherical harmonics basis
      integer :: lmax

      !> Threshold for iterative solver
      real(wp) :: conv

      !> Regularization parameters
      real(wp) :: eta

   end type TDomainDecompositionInput


   !> Cosmo calculator
   type :: TDomainDecomposition

      !> Printing flag
      integer :: iprint

      !> Max angular momentum of spherical harmonics basis
      integer :: lmax

      !> Desired number of Lebedev integration points
      integer :: ngrid

      !> Threshold for iterative solver
      real(wp) :: conv

      !> 1) compute forces ; 0) do not compute forces
      integer :: igrad

      !> Regularization parameters
      real(wp) :: eta

      !> Number of spheres/atoms
      integer :: nat

      !> Number of integration points on cavity's boundary
      integer :: ncav

      !> Number of basis functions, i.e., spherical harmonics
      integer :: nylm

      !> Workspaces
      logical :: grad
      integer, allocatable :: inl(:), nl(:)
      real(wp), allocatable :: rvdw(:), xyz(:, :), ccav(:, :)
      real(wp), allocatable :: w(:), grid(:, :), basis(:, :)
      real(wp), allocatable :: fact(:), facl(:), facs(:)
      real(wp), allocatable :: fi(:, :), ui(:, :), zi(:, :, :)

   end type TDomainDecomposition


contains


!> Initialize data structure
!
!  allocate the various arrays needed for ddcosmo,
!  assemble the cavity and the various associated geometrical quantities.
subroutine initDomainDecomposition(self, input, rvdw, wang, grid)

   character(len=*), parameter :: source = 'ddcosmo_core::initDomainDecomposition'
   type(TDomainDecomposition), intent(out) :: self
   type(TDomainDecompositionInput), intent(in) :: input
   real(wp), intent(in) :: rvdw(:)
   real(wp), intent(in) :: wang(:), grid(:, :)

   integer :: iat, jat, i, ii, lnl, l, ind, m, igrid, inear, jnear
   integer :: istatus
   real(wp) :: fac, fl, ffl, fnorm, d2, r2, v(3), vv, t, xt, swthr

   real(wp), allocatable :: vcos(:), vsin(:), vplm(:)

   self%nat = size(rvdw)
   self%ngrid = size(wang)
   self%iprint = 0
   self%lmax = input%lmax
   self%conv = input%conv
   self%eta = input%eta
   self%igrad = 1

   ! allocate:
   self%grad   = self%igrad /= 0
   self%nylm   = (self%lmax+1)*(self%lmax+1)
   allocate(self%rvdw(self%nat), self%xyz(3, self%nat), self%w(self%ngrid), &
      & self%grid(3, self%ngrid), self%basis(self%nylm, self%ngrid), &
      & self%inl(self%nat+1), self%nl(self%nat*nngmax), &
      & self%fi(self%ngrid, self%nat), self%ui(self%ngrid, self%nat), &
      & self%fact(max(2*self%lmax+1, 2)), self%facl(self%nylm), &
      & self%facs(self%nylm))
   if (self%grad) allocate(self%zi(3, self%ngrid, self%nat))

   ! precompute various quantities (diagonal blocks of ddcosmo matrix,
   ! normalization factors for spherical harmonics, factorials)
   self%fact(1) = 1.0_wp
   self%fact(2) = 1.0_wp
   do i = 3, 2*self%lmax + 1
      self%fact(i) = real(i-1, wp)*self%fact(i-1)
   end do

   do l = 0, self%lmax
      ind = l*l + l + 1
      fl  = (2.0_wp*real(l, wp) + 1.0_wp)/(4.0_wp*pi)
      ffl = sqrt(fl)
      self%facl(ind-l:ind+l) = fl
      self%facs(ind) = ffl
      do m = 1, l
         fnorm = sq2*ffl*sqrt(self%fact(l-m+1)/self%fact(l+m+1))
         if (mod(m, 2) == 1) fnorm = -fnorm
         self%facs(ind+m) = fnorm
         self%facs(ind-m) = fnorm
      end do
   end do

   ! copy the angular grid:
   self%grid = grid
   ! scaling because the weights are normalised
   self%w = wang * four*pi

   ! set the centers and radii of the spheres:
   self%rvdw(:) = rvdw

   ! build a basis of spherical harmonics at the griwpoints:
   allocate(vplm(self%nylm), vcos(self%lmax+1), vsin(self%lmax+1))
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(self) private(i, vplm, vcos, vsin)
   do i = 1, self%ngrid
      call ylmbas(self, self%grid(:, i), self%basis(:, i), vplm, vcos, vsin)
   end do
   deallocate(vplm, vcos, vsin)

   if (self%iprint >= 4) then
      call prtsph(self, 'facs', 1, 0, self%facs)
      call prtsph(self, 'facl', 1, 0, self%facl)
      call prtsph(self, 'basis', self%ngrid, 0, self%basis)
      call ptcart(self, 'grid', 3, 0, self%grid)
      call ptcart(self, 'weights', 1, 0, self%w)
   end if

end subroutine initDomainDecomposition


subroutine ddupdate(self, xyz)

   type(TDomainDecomposition), intent(inout) :: self

   real(wp), intent(in) :: xyz(:, :)

   self%xyz(:, :) = xyz

   call mknnl(self)
   call mkfiui(self)
   call mkccav(self)

end subroutine ddupdate


! build neighbors list (CSR format)
!
!  \\  jat  |
! iat   \\  |  1   2   3   4   5   6
! -----------------------------------
!         1 |      x       x   x
!         2 |  x       x       x   x
!         3 |      x       x       x
!         4 |  x       x       x   x
!         5 |  x   x       x
!         6 |      x   x   x
!
!
!  inl =  1,       4,          8,      11,         15,      18, 21        pointer to 1st neighbor
!
!         |        |           |        |           |        |
!         v        V           V        V           V        V
!
!         1| 2| 3| 4| 5| 6| 7| 8| 9|10|11|12|13|14|15|16|17|18|19|20
!
!  nl  =  2, 4, 5, 1, 3, 5, 6, 2, 4, 6, 1, 3, 5, 6, 1, 2, 4, 2, 3, 4     neighbors list
subroutine mknnl(self)

   type(TDomainDecomposition), intent(inout) :: self

   integer :: ii, lnl, iat, jat
   real(wp) :: v(3), d2, r2

   character(len=*), parameter :: f1000 = "(t3, 'neighbours of sphere ', i6)"
   character(len=*), parameter :: f1010 = "(t5, 12i6)"

   ! index of nl
   ii  = 1
   lnl = 0
   do iat = 1, self%nat
      self%inl(iat) = lnl + 1
      do jat = 1, self%nat
         if (iat /= jat) then
            v(:) = self%xyz(:, iat) - self%xyz(:, jat)
            d2 = v(1)**2 + v(2)**2 + v(3)**2
            r2 = (self%rvdw(iat) + self%rvdw(jat))**2
            if (d2 <= r2) then
               self%nl(ii) = jat
               ii  = ii + 1
               lnl = lnl + 1
            end if
         end if
      end do
   end do
   self%inl(self%nat+1) = lnl+1

   if (self%iprint >= 4) then
      write(iout, *) '   inl:'
      write(iout, '(10i6)') self%inl(1:self%nat+1)
      write(iout, *)
      do iat = 1, self%nat
         write(iout, f1000) iat
         write(iout, f1010) self%nl(self%inl(iat):self%inl(iat+1)-1)
      end do
      write(iout, *)
   end if

end subroutine mknnl


! Define :
!
!   N_i = list of neighbors of i-sphere [ excluding i-sphere ]
!
!            | r_i + rho_i s_n - r_j |
!   t_n^ij = -------------------------
!                      rho_j
!
!   fi(n, i) =    sum    \chi(t_n^ij)
!             j \in N_i
!
! Notice that the derivative of fi(n, i) wrt to r_k is (possibly) nonzero
! when either k = i, or k \in N_j .
subroutine mkfiui(self)

   type(TDomainDecomposition), intent(inout) :: self

   integer :: iat, i, ii, jat
   real(wp) :: v(3), vv, t, xt, swthr, fac


   ! build arrays fi, ui, zi
   self%fi = 0.0_wp
   self%ui = 0.0_wp
   if (self%grad) self%zi = 0.0_wp

   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(self) private(iat, i, ii, jat, v, vv, t, xt, swthr, fac)
   ! loop over spheres
   do iat = 1, self%nat

      ! loop over integration points
      do i = 1, self%ngrid

         ! loop over neighbors of i-sphere
         do ii = self%inl(iat), self%inl(iat+1)-1

            ! neighbor's number
            jat = self%nl(ii)

            ! compute t_n^ij
            v(:) = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, i) - self%xyz(:, jat)
            vv = v(1)**2 + v(2)**2 + v(3)**2
            vv = sqrt(vv)
            t = vv/self%rvdw(jat)

            ! compute \chi(t_n^ij)
            xt = fsw(t, se, self%eta)

            ! upper bound of switch region
            swthr = 1.0_wp + (se + 1._wp)*self%eta / 2._wp

            ! t_n^ij belongs to switch region
            if (self%grad .and. (t < swthr .and. t > swthr-self%eta)) then
               fac = dfsw(t, se, self%eta) / self%rvdw(jat)

               ! accumulate for zi
               self%zi(:, i, iat) = self%zi(:, i, iat) + fac*v(:)/vv
            end if

            ! accumulate for fi
            self%fi(i, iat) = self%fi(i, iat) + xt
         end do

         ! compute ui
         if (self%fi(i, iat) <= 1.0_wp)  self%ui(i, iat) = 1.0_wp - self%fi(i, iat)
      end do
   end do

   if (self%iprint >= 4) then
      call ptcart(self, 'fi', self%nat, 0, self%fi)
      call ptcart(self, 'ui', self%nat, 0, self%ui)
   end if

end subroutine mkfiui


! build cavity array
subroutine mkccav(self)

   type(TDomainDecomposition), intent(inout) :: self

   integer :: iat, i, ii
   character(len=*), parameter :: f1100 = "(t3, i8, 3f14.6)"

   if (allocated(self%ccav)) deallocate(self%ccav)

   ! initialize number of cavity points
   self%ncav=0

   ! loop over spheres
   do iat = 1, self%nat

      ! loop over integration points
      do i = 1, self%ngrid

         ! positive contribution from integration point
         if (self%ui(i, iat) > 0.0_wp) then

            ! accumulate
            self%ncav = self%ncav + 1

         end if
      end do
   end do

   ! allocate cavity array
   allocate(self%ccav(3, self%ncav))

   ! initialize cavity array index
   ii = 0

   ! loop over spheres
   do iat = 1, self%nat

      ! loop over integration points
      do i = 1, self%ngrid

         ! positive contribution from integration point
         if (self%ui(i, iat) > 0.0_wp) then

            ! advance cavity array index
            ii = ii + 1

            ! store point
            self%ccav(:, ii) = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, i)

         end if
      end do
   end do

   if (self%iprint >= 4) then
      write(iout, *) '   external cavity points:'
      do ii = 1, self%ncav
         write(iout, f1100) ii, self%ccav(:, ii)
      end do
      write(iout, *)
   end if

end subroutine mkccav


!> Scalar product
pure function sprod(n, u, v)

   integer, intent(in) :: n
   real(wp), intent(in) :: u(n), v(n)
   real(wp) :: sprod

   integer :: i
   real(wp) :: ss

   ! initialize
   ss = 0.0_wp

   do i = 1, n
      ! accumulate
      ss = ss + u(i)*v(i)
   end do

   ! redirect
   sprod = ss

end function sprod


!> Switch function (5th degree polynomial)
elemental function fsw(t, s, eta)

   real(wp) :: fsw
   real(wp), intent(in) :: t
   real(wp), intent(in) :: s
   real(wp), intent(in) :: eta

   real(wp) :: a, b, flow, x
   real(wp), parameter :: f6=6.0_wp, f10=10._wp, f12=12._wp, f15=15._wp

   ! shift :
   ! s =  0   =>   t - eta/2  [ CENTERED ]
   ! s =  1   =>   t - eta    [ EXTERIOR ]
   ! s = -1   =>   t          [ INTERIOR ]

   ! apply shift
   x = t - (s + 1._wp)*eta / 2._wp

   ! lower bound of switch region
   flow = 1.0_wp - eta

   ! define switch function \chi
   if (x >= 1.0_wp) then
      fsw = 0.0_wp
   elseif (x <= flow) then
      fsw = 1.0_wp
   else
      a = f15*eta - f12
      b = f10*eta*eta - f15*eta + f6
      fsw = ((x-1.0_wp)*(x-1.0_wp)*(1.0_wp-x)*(f6*x*x + a*x + b)) / (eta**5)
   end if

end function fsw


!> First derivative of switch function
elemental function dfsw(t, s, eta)

   real(wp), intent(in) :: t
   real(wp), intent(in) :: s
   real(wp), intent(in) :: eta
   real(wp) :: dfsw

   real(wp) :: flow, x
   real(wp), parameter :: f30=30.0_wp

   ! shift :
   ! s =  0   =>   t - eta/2  [ CENTERED ]
   ! s =  1   =>   t - eta    [ EXTERIOR ]
   ! s = -1   =>   t          [ INTERIOR ]
   !
   ! apply shift
   x = t - (s + 1._wp)*eta / 2._wp

   ! lower bound of switch region
   flow = 1.0_wp - eta

   ! define derivative of switch function \chi
   if (x >= 1.0_wp) then
      dfsw = 0.0_wp
   elseif (x <= flow) then
      dfsw = 0.0_wp
   else
      dfsw = f30*(1.0_wp-x)*(x-1.0_wp)*(x-1.0_wp+eta)*(x-1.0_wp+eta)/(eta**5)
   end if

end function dfsw


!> Dump an array (ngrid, ncol) or just a column.
subroutine ptcart(self, label, ncol, icol, x)

   type(TDomainDecomposition), intent(in) :: self
   character(len=*), intent(in) :: label
   integer, intent(in) :: ncol, icol
   real(wp), intent(in) :: x(self%ngrid, ncol)

   integer :: ig, noff, nprt, ic, j
   character(len=*), parameter :: f1000 = "(1x, i5, f14.8)"
   character(len=*), parameter :: f1010 = "(6x, 5i14)"
   character(len=*), parameter :: f1020 = "(1x, i5, 5f14.8)"

   ! print header :
   if (ncol == 1) then
      write (iout, '(3x, a, 1x, "(column ", i4, ")")') label, icol
   else
      write (iout, '(3x, a)') label
   end if

   ! print entries :
   if (ncol == 1) then
      do ig = 1, self%ngrid
         write(iout, f1000) ig, x(ig, 1)
      end do

   else
      noff = mod (ncol, 5)
      nprt = max(ncol - noff, 0)
      do ic = 1, nprt, 5
         write(iout, f1010) (j, j = ic, ic+4)
         do ig = 1, self%ngrid
            write(iout, f1020) ig, x(ig, ic:ic+4)
         end do
      end do
      write (iout, f1010) (j, j = nprt+1, nprt+noff)
      do ig = 1, self%ngrid
         write(iout, f1020) ig, x(ig, nprt+1:nprt+noff)
      end do
   end if

end subroutine ptcart


!> Dump an array (nylm, ncol) or just a column.
subroutine prtsph(self, label, ncol, icol, x)

   type(TDomainDecomposition), intent(in) :: self
   character (len=*), intent(in) :: label
   integer, intent(in) :: ncol, icol
   real(wp), intent(in) :: x(self%nylm, ncol)

   integer :: l, m, ind, noff, nprt, ic, j
   character(len=*), parameter :: f1000 = "(1x, i3, i4, f14.8)"
   character(len=*), parameter :: f1010 = "(8x, 5i14)"
   character(len=*), parameter :: f1020 = "(1x, i3, i4, 5f14.8)"

   ! print header :
   if (ncol == 1) then
      write (iout, '(3x, a, 1x, "(column ", i4, ")")') label, icol
   else
      write (iout, '(3x, a)') label
   end if

   ! print entries :
   if (ncol == 1) then
      do l = 0, self%lmax
         ind = l*l + l + 1
         do m = -l, l
            write(iout, f1000) l, m, x(ind+m, 1)
         end do
      end do

   else
      noff = mod(ncol, 5)
      nprt = max(ncol - noff, 0)
      do ic = 1, nprt, 5
         write(iout, f1010) (j, j = ic, ic+4)
         do l = 0, self%lmax
            ind = l*l + l + 1
            do m = -l, l
               write(iout, f1020) l, m, x(ind+m, ic:ic+4)
            end do
         end do
      end do
      write (iout, f1010) (j, j = nprt+1, nprt+noff)
      do l = 0, self%lmax
         ind = l*l + l + 1
         do m = -l, l
            write(iout, f1020) l, m, x(ind+m, nprt+1:nprt+noff)
         end do
      end do
   end if

end subroutine prtsph


!> Integrate against spherical harmonics
subroutine intrhs(self, iat, x, xlm)

   type(TDomainDecomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: x(:) ! [self%ngrid]
   real(wp), intent(inout) :: xlm(:) ! [self%nylm]

   integer :: ig

   ! initialize
   xlm = 0.0_wp

   ! accumulate over integration points
   do ig = 1, self%ngrid
      xlm = xlm + self%basis(:, ig)*self%w(ig)*x(ig)
   end do

   ! printing
   if (self%iprint >= 5) then
      call ptcart(self, 'pot', 1, iat, x)
      call prtsph(self, 'vlm', 1, iat, xlm)
   end if

end subroutine intrhs


!> Compute spherical harmonics
pure subroutine ylmbas(self, x, basloc, vplm, vcos, vsin)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: x(:) ! [3]
   real(wp), intent(out) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(out) :: vcos(:), vsin(:) ! [self%lmax+1]

   integer :: l, m, ind
   real(wp) :: cthe, sthe, cphi, sphi, plm

   ! get cos(\theta), sin(\theta), cos(\phi) and sin(\phi) from the cartesian
   ! coordinates of x.

   ! evaluate cos(theta) ; sin(theta)
   cthe = x(3)
   sthe = sqrt(1.0_wp - cthe*cthe)

   ! evalutate cos(phi) ; sin(phi)
   if (sthe /= 0.0_wp) then
      cphi = x(1)/sthe
      sphi = x(2)/sthe
   else
      cphi = 0.0_wp
      sphi = 0.0_wp
   end if

   ! evaluate cos(m*phi) and sin(m*phi) arrays. notice that this is
   ! pointless if z = 1, as the only non vanishing terms will be the
   ! ones with m=0.
   if(sthe /= 0.0_wp) then
      call trgev(self, cphi, sphi, vcos, vsin)
   else
      vcos = 1.0_wp
      vsin = 0.0_wp
   end if

   ! evaluate the generalized legendre polynomials
   call polleg(self, cthe, sthe, vplm)

   ! now build the spherical harmonics. we will distinguish m=0,
   ! m>0 and m<0:
   do l = 0, self%lmax
      ind = l**2 + l + 1

      ! m = 0
      basloc(ind) = self%facs(ind)*vplm(ind)

      do m = 1, l

         plm = vplm(ind+m)

         ! m > 0
         basloc(ind+m) = self%facs(ind+m)*plm*vcos(m+1)

         ! m < 0
         basloc(ind-m) = self%facs(ind-m)*plm*vsin(m+1)

      end do
   end do

end subroutine ylmbas


!> Compute first derivatives of spherical harmonics
pure subroutine dbasis(self, x, basloc, dbsloc, vplm, vcos, vsin)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: x(:) ! [3]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: dbsloc(:, :) ! [3, self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]

   integer :: l, m, ind, VC, VS
   real(wp) :: cthe, sthe, cphi, sphi, plm, fln, pp1, pm1, pp
   real(wp) :: et(3), ep(3)

   ! get cos(\theta), sin(\theta), cos(\phi) and sin(\phi) from the cartesian
   ! coordinates of x.
   cthe = x(3)
   sthe = sqrt(1.0_wp - cthe*cthe)

   if (sthe /= 0.0_wp) then
      ! not (NORTH or SOUTH pole)
      cphi = x(1)/sthe
      sphi = x(2)/sthe
   else
      ! NORTH or SOUTH pole
      cphi = 1.0_wp
      sphi = 0.0_wp
   end if

   ! evaluate the derivatives of theta and phi:
   et(1) = cthe*cphi
   et(2) = cthe*sphi
   et(3) = -sthe

   if(sthe /= 0.0_wp) then
      ! not (NORTH or SOUTH pole)
      ep(1) = -sphi/sthe
      ep(2) = cphi/sthe
      ep(3) = 0.0_wp
   else
      ! NORTH or SOUTH pole
      ep(1) = 0.0_wp
      ep(2) = 1.0_wp
      ep(3) = 0.0_wp
   end if

   ! evaluate cos(m*phi) and sin(m*phi) arrays. notice that this is
   ! pointless if z = 1, as the only non vanishing terms will be the
   ! ones with m=0.

   if (sthe /= 0.0_wp) then
      ! not (NORTH or SOUTH pole)
      call trgev(self, cphi, sphi, vcos, vsin)
   else
      ! NORTH or SOUTH pole
      vcos(:) = 1.0_wp
      vsin(:) = 0.0_wp
   end if
   VC=0.0_wp
   VS=cthe

   ! evaluate the generalized legendre polynomials.
   call polleg(self, cthe, sthe, vplm)

   ! now build the spherical harmonics. we will distinguish m=0,
   ! m>0 and m<0:

   basloc = 0.0_wp
   dbsloc = 0.0_wp
   do l = 0, self%lmax
      ind = l*l + l + 1
      ! m = 0
      fln = self%facs(ind)
      basloc(ind) = fln*vplm(ind)
      if (l > 0) then
         dbsloc(:, ind) = fln*vplm(ind+1)*et(:)
      else
         dbsloc(:, ind) = 0.0_wp
      end if
      !$omp simd
      do m = 1, l
         fln = self%facs(ind+m)
         plm = fln*vplm(ind+m)
         pp1 = 0.0_wp
         if (m < l) pp1 = -0.5_wp*vplm(ind+m+1)
         pm1 = 0.5_wp*(real(l+m, wp)*real(l-m+1, wp)*vplm(ind+m-1))
         pp  = pp1 + pm1

         ! m > 0
         basloc(ind+m) = plm*vcos(m+1)

         if (sthe /= 0.0_wp) then
            ! not (NORTH or SOUTH pole)
            dbsloc(:, ind+m) = -fln*pp*vcos(m+1)*et(:) - real(m, wp)*plm*vsin(m+1)*ep(:)
         else
            ! NORTH or SOUTH pole
            dbsloc(:, ind+m) = -fln*pp*vcos(m+1)*et(:) - fln*pp*ep(:)*VC
         end if

         ! m < 0
         basloc(ind-m) = plm*vsin(m+1)

         if (sthe /= 0.0_wp) then
            ! not (NORTH or SOUTH pole)
            dbsloc(:, ind-m) = -fln*pp*vsin(m+1)*et(:) + real(m, wp)*plm*vcos(m+1)*ep(:)
         else
            ! NORTH or SOUTH pole
            dbsloc(:, ind-m) = -fln*pp*vsin(m+1)*et(:) - fln*pp*ep(:)*VS
         end if

      end do
   end do

end subroutine dbasis


!> Compute the l, m associated legendre polynomial for -1 <= x <= 1 using the
!  recurrence formula
!
!  (l-m)p(l, m) = x(2l-1)p(l-1, m) - (l+m-1)p(l-2, m)
pure subroutine polleg(self, x, y, plm)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: x, y
   real(wp), intent(inout) :: plm(:) ! [self%nylm]

   integer :: m, ind, l, ind2
   real(wp) :: fact, pmm, somx2, pmm1, pmmo, pll, fm, fl

   fact  = 1.0_wp
   pmm   = 1.0_wp
   somx2 = y

   do m = 0, self%lmax
      ind      = (m + 1)*(m + 1)
      plm(ind) = pmm
      if(m == self%lmax) return
      fm = real(m, wp)
      pmm1 = x*(2.0_wp*fm + 1.0_wp)*pmm
      ind2 = ind + 2*m + 2
      plm(ind2) = pmm1
      pmmo = pmm
      do l = m+2, self%lmax
         fl = real(l, wp)
         pll   = (x*(2.0_wp*fl - 1.0_wp)*pmm1 - (fl + fm - 1.0_wp)*pmm)/(fl - fm)
         ind = l*l + l + 1
         plm(ind+m) = pll
         pmm  = pmm1
         pmm1 = pll
      end do
      pmm  = -pmmo*fact*somx2
      fact = fact + 2.0_wp
   end do

end subroutine polleg


!> Service routine for computation of spherical harmonics
pure subroutine trgev(self, x, y, cx, sx)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: x, y
   real(wp), intent(inout) :: cx(:), sx(:) ! [max((self%lmax+1), 2)]

   integer :: m

   cx(1) = 1.0_wp
   sx(1) = 0.0_wp
   cx(2) = x
   sx(2) = y
   do m = 3, self%lmax+1
      cx(m) = 2.0_wp*x*cx(m-1) - cx(m-2)
      sx(m) = 2.0_wp*x*sx(m-1) - sx(m-2)
   end do

end subroutine trgev


!> Compute
!
!  sum   4pi/(2l+1) t^l * Y_l^m(s) * sigma_l^m
!  l, m
!
!  which is need to compute action of COSMO matrix L.
pure function intmlp(self, t, sigma, basloc)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: t
   real(wp), intent(in) :: sigma(:), basloc(:) ! [self%nylm]
   real(wp) :: intmlp

   integer :: l, ind
   real(wp) :: tt, ss, fac

   ! initialize t^l
   tt = 1.0_wp

   ! initialize
   ss = 0.0_wp

   ! loop over l
   do l = 0, self%lmax

      ind = l*l + l + 1

      ! update factor 4pi / (2l+1) * t^l
      fac = tt / self%facl(ind)

      ! contract over l, m and accumulate
      ss = ss + fac * dot_product(basloc(ind-l:ind+l), sigma(ind-l:ind+l))

      ! update t^l
      tt = tt*t
   end do

   ! redirect
   intmlp = ss

end function intmlp


!> Weigh potential at cavity points by characteristic function "ui"
subroutine wghpot(self, phi, g)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in)  :: phi(:) ! [self%ncav]
   real(wp), intent(out) :: g(:, :) ! [self%ngrid, self%nat]

   integer :: iat, ig, ic

   !> Initialize
   ic = 0
   g(:, :) = 0._wp

   ! loop over spheres
   do iat = 1, self%nat

      ! loop over points
      do ig = 1, self%ngrid

         ! nonzero contribution from point
         if (self%ui(ig, iat) /= 0.0_wp) then

            ! advance cavity point counter
            ic = ic + 1

            ! weight by (negative) characteristic function
            g(ig, iat) = -self%ui(ig, iat) * phi(ic)

         end if

      end do
   end do

end subroutine wghpot


!> Compute H-norm
pure subroutine hsnorm(self, u, unorm)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: u(:) !< [nylm]
   real(wp), intent(inout) :: unorm

   integer :: l, m, ind
   real(wp) :: fac

   ! initialize
   unorm = 0.0_wp

   ! loop over l
   do l = 0, self%lmax

      ! first index associated to l
      ind = l*l + l + 1

      ! scaling factor
      fac = 1.0_wp/(1.0_wp + real(l, wp))

      ! loop over m
      do m = -l, l

         ! accumulate
         unorm = unorm + fac*u(ind+m)*u(ind+m)

      end do
   end do

   ! the much neglected square root
   unorm = sqrt(unorm)

end subroutine hsnorm


!> Compute
!
!   v_l^m = v_l^m +
!
!               4 pi           l
!     sum  sum  ---- (t_n^ji)  Y_l^m(s_n^ji) W_n^ji [ \xi_j ]_n
!      j    n   2l+1
!
! which is related to the action of the adjont COSMO matrix L^* in the following
! way. Set
!
!   [ \xi_j ]_n = sum  Y_l^m(s_n) [ s_j ]_l^m
!                 l, m
!
! then
!
!   v_l^m = -   sum    (L^*)_ij s_j
!             j \ne i
!
! The auxiliary quantity [ \xi_j ]_l^m needs to be computed explicitly.
pure subroutine adjrhs(self, iat, xi, vlm, basloc, vplm, vcos, vsin)

   type(TDomainDecomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: xi(:, :) ! [self%ngrid, self%nat]
   real(wp), intent(inout) :: vlm(:) ! [self%nylm]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]

   integer :: ij, jat, ig, l, ind, m
   real(wp) :: vji(3), vvji, tji, sji(3), xji, oji, fac, ffac, t

   ! loop over neighbors of i-sphere
   do ij = self%inl(iat), self%inl(iat+1)-1

      ! j-sphere is neighbor
      jat = self%nl(ij)

      ! loop over integration points
      do ig = 1, self%ngrid

         ! compute t_n^ji = | r_j + \rho_j s_n - r_i | / \rho_i
         vji  = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, iat)
         vvji = vji(1)**2 + vji(2)**2 + vji(3)**2
         vvji = sqrt(vvji)
         tji  = vvji/self%rvdw(iat)

         ! point is INSIDE i-sphere (+ transition layer)
         if (tji < (1.0_wp + (se+1.0_wp)/2.0_wp*self%eta)) then

            ! compute s_n^ji
            sji = vji/vvji

            ! compute \chi(t_n^ji)
            xji = fsw(tji, se, self%eta)

            ! compute W_n^ji
            if (self%fi(ig, jat) > 1.0_wp) then
               oji = xji/self%fi(ig, jat)
            else
               oji = xji
            end if

            ! compute Y_l^m(s_n^ji)
            call ylmbas(self, sji, basloc, vplm, vcos, vsin)

            ! initialize (t_n^ji)^l
            t = 1.0_wp

            ! compute w_n * xi(n, j) * W_n^ji
            fac = self%w(ig) * xi(ig, jat) * oji

            ! loop over l
            do l = 0, self%lmax
               ind  = l*l + l + 1

               ! compute 4pi / (2l+1) * (t_n^ji)^l * w_n * xi(n, j) * W_n^ji
               ffac = fac*t/self%facl(ind)

               ! loop over m
               do m = -l, l
                  vlm(ind+m) = vlm(ind+m) + ffac*basloc(ind+m)
               end do

               ! update (t_n^ji)^l
               t = t*tji
            end do

         end if
      end do
   end do

end subroutine adjrhs


subroutine header(self)

   type(TDomainDecomposition), intent(in) :: self

   1000 format(/, &
      ' An implementation of COSMO using a domain decomposition linear scaling strategy.', /)
   1010 format(' Parameters:', /, &
      '   number of grid points:                  ', 8x, i8, /,   &
      '   number of spheres:                      ', 8x, i8, /,   &
      '   lmax for the spherical harmonics basis: ', 8x, i8, /,   &
      '   convergence threshold:                  ', 8x, d8.1, /, &
      '   regularization parameter (eta):         ', 8x, f8.3/)

   if (self%iprint > 0) then

      write(iout, 1000)
      write(iout, 1010) self%ngrid, self%nat, self%lmax, self%conv, self%eta

      if (self%igrad == 1)  write(iout, 1013)
      1013   format(' Compute forces.'//)

   end if

end subroutine header


!> Compute the first part of <S, L^(x)X>
pure subroutine fdoka(self, iat, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx)

   type(TDomainDecomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: sigma(:, :) ! [self%nylm, self%nat]
   real(wp), intent(in) :: xi(:) ! [self%ngrid]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: dbsloc(:, :) ! [3, self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]
   real(wp), intent(inout) :: fx(:) ! [3]

   integer :: ig, ij, jat, l, ind, m
   real(wp) :: vvij, tij, xij, oij, t, fac, fl, f1, f2, f3, beta, tlow, thigh
   real(wp) :: vij(3), sij(3), alp(3), va(3)

   tlow  = 1.0_wp - 0.5_wp*(1.0_wp - se)*self%eta
   thigh = 1.0_wp + 0.5_wp*(1.0_wp + se)*self%eta

   do ig = 1, self%ngrid
      va = 0.0_wp
      do ij = self%inl(iat), self%inl(iat+1) - 1
         jat = self%nl(ij)
         vij = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, ig) - self%xyz(:, jat)
         vvij = vij(1)**2 + vij(2)**2 + vij(3)**2
         vvij = sqrt(vvij)
         tij = vvij/self%rvdw(jat)

         if (tij >= thigh) cycle

         sij = vij/vvij
         call dbasis(self, sij, basloc, dbsloc, vplm, vcos, vsin)
         alp = 0.0_wp
         t = 1.0_wp
         do l = 1, self%lmax
            ind = l*l + l + 1
            fl = real(l, wp)
            fac = t/self%facl(ind)
            do m = -l, l
               f2 = fac*sigma(ind+m, jat)
               f1 = f2*fl*basloc(ind+m)
               alp(:) = alp(:) + f1*sij(:) + f2*dbsloc(:, ind+m)
            end do
            t = t*tij
         end do
         beta = intmlp(self, tij, sigma(:, jat), basloc)
         xij = fsw(tij, se, self%eta)
         if (self%fi(ig, iat) > 1.0_wp) then
            oij = xij/self%fi(ig, iat)
            f2  = -oij/self%fi(ig, iat)
         else
            oij = xij
            f2  = 0.0_wp
         end if
         f1 = oij/self%rvdw(jat)
         va(:) = va(:) + f1*alp(:) + beta*f2*self%zi(:, ig, iat)
         if (tij > tlow) then
            f3 = beta*dfsw(tij, se, self%eta)/self%rvdw(jat)
            if (self%fi(ig, iat) > 1.0_wp) f3 = f3/self%fi(ig, iat)
            va(:) = va(:) + f3*sij(:)
         end if
      end do
      fx = fx - self%w(ig)*xi(ig)*va(:)
   end do

end subroutine fdoka


!> Compute the the second part of <S, L^(x)X>
pure subroutine fdokb(self, iat, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, fx)

   type(TDomainDecomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: sigma(:, :) ! [self%nylm, self%nat]
   real(wp), intent(in) :: xi(:, :) ! [self%ngrid, self%nat]
   real(wp), intent(inout) :: basloc(:), vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: dbsloc(:, :) ! [3, self%nylm]
   real(wp), intent(inout) :: vcos(:), vsin(:) ! [self%lmax+1]
   real(wp), intent(inout) :: fx(:) ! [3]

   integer :: ig, ji, jat, l, ind, m, jk, kat
   logical :: proc
   real(wp) :: vvji, tji, xji, oji, t, fac, fl, f1, f2, beta, di, tlow, thigh
   real(wp) :: b, g1, g2, vvjk, tjk, f, xjk
   real(wp) :: vji(3), sji(3), alp(3), vb(3), vjk(3), sjk(3), vc(3)



   tlow  = 1.0_wp - 0.5_wp*(1.0_wp - se)*self%eta
   thigh = 1.0_wp + 0.5_wp*(1.0_wp + se)*self%eta

   do ig = 1, self%ngrid
      vb = 0.0_wp
      vc = 0.0_wp
      do ji = self%inl(iat), self%inl(iat+1) - 1
         jat = self%nl(ji)
         vji = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, iat)
         vvji = vji(1)**2 + vji(2)**2 + vji(3)**2
         vvji = sqrt(vvji)
         tji = vvji/self%rvdw(iat)

         if (tji > thigh) cycle

         sji = vji/vvji
         call dbasis(self, sji, basloc, dbsloc, vplm, vcos, vsin)

         alp = 0.0_wp
         t   = 1.0_wp
         do l = 1, self%lmax
            ind = l*l + l + 1
            fl = real(l, wp)
            fac = t/self%facl(ind)
            do m = -l, l
               f2 = fac*sigma(ind+m, iat)
               f1 = f2*fl*basloc(ind+m)
               alp = alp + f1*sji + f2*dbsloc(:, ind+m)
            end do
            t = t*tji
         end do
         xji = fsw(tji, se, self%eta)
         if (self%fi(ig, jat) > 1.0_wp) then
            oji = xji/self%fi(ig, jat)
         else
            oji = xji
         end if
         f1 = oji/self%rvdw(iat)
         vb = vb + f1*alp*xi(ig, jat)
         if (tji > tlow) then
            beta = intmlp(self, tji, sigma(:, iat), basloc)
            if (self%fi(ig, jat) > 1.0_wp) then
               di  = 1.0_wp/self%fi(ig, jat)
               fac = di*xji
               proc = .false.
               b    = 0.0_wp
               do jk = self%inl(jat), self%inl(jat+1) - 1
                  kat = self%nl(jk)
                  vjk = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, kat)
                  vvjk = vjk(1)**2 + vjk(2)**2 + vjk(3)**2
                  vvjk = sqrt(vvjk)
                  tjk = vvjk/self%rvdw(kat)
                  if (kat /= iat) then
                     if (tjk <= thigh) then
                        proc = .true.
                        sjk = vjk/vvjk
                        call ylmbas(self, sjk, basloc, vplm, vcos, vsin)
                        g1 = intmlp(self, tjk, sigma(:, kat), basloc)
                        xjk = fsw(tjk, se, self%eta)
                        b = b + g1*xjk
                     end if
                  end if
               end do
               if (proc) then
                  g1 = di*di*dfsw(tji, se, self%eta)/self%rvdw(iat)
                  g2 = g1*xi(ig, jat)*b
                  vc = vc + g2*sji
               end if
            else
               di = 1.0_wp
               fac = 0.0_wp
            end if
            f2 = (1.0_wp-fac)*di*dfsw(tji, se, self%eta)/self%rvdw(iat)
            vb = vb + f2*xi(ig, jat)*beta*sji
         end if
      end do
      fx = fx + self%w(ig)*(vb - vc)
   end do

end subroutine fdokb


!> Compute the U^(x)\Phi contribution to <S, g^(x)>
pure subroutine fdoga(self, iat, xi, phi, fx)

   type(TDomainDecomposition), intent(in) :: self
   integer, intent(in) :: iat
   real(wp), intent(in) :: xi(:, :), phi(:, :) ! [self%ngrid, self%nat]
   real(wp), intent(inout) :: fx(:) ! [3]

   integer :: ig, ji, jat
   real(wp) :: vvji, tji, fac, swthr
   real(wp) :: alp(3), vji(3), sji(3)

   do ig = 1, self%ngrid
      alp = 0.0_wp
      if (self%ui(ig, iat) > 0.0_wp .and. self%ui(ig, iat) <  1.0_wp) then
         alp = alp + phi(ig, iat)*xi(ig, iat)*self%zi(:, ig, iat)
      end if
      do ji = self%inl(iat), self%inl(iat+1) - 1
         jat = self%nl(ji)
         vji = self%xyz(:, jat) + self%rvdw(jat)*self%grid(:, ig) - self%xyz(:, iat)
         vvji = vji(1)**2 + vji(2)**2 + vji(3)**2
         vvji = sqrt(vvji)
         tji = vvji/self%rvdw(iat)
         swthr = 1.0_wp + (se + 1._wp)*self%eta / 2._wp
         if (tji < swthr .and. tji > swthr-self%eta .and. self%ui(ig, jat) > 0.0_wp) then
            sji = vji/vvji
            fac = - dfsw(tji, se, self%eta)/self%rvdw(iat)
            alp = alp + fac*phi(ig, jat)*xi(ig, jat)*sji
         end if
      end do
      fx = fx - self%w(ig)*alp
   end do

end subroutine fdoga


!> Auxiliary routine for COSMO action
!  compute
!
!   \Phi(n) =
!
!                       4 pi           l
!     sum  W_n^ij  sum  ---- (t_n^ij)  Y_l^m(s_n^ij) [ \sigma_j ]_l^m
!      j           l, m  2l+1
!
! which is related to the action of the COSMO matrix L in the following
! way :
!
!   -   sum    L_ij \sigma_j = sum  w_n Y_l^m(s_n) \Phi(n)
!     j \ne i                   n
!
! This second step is performed by routine "intrhs".
pure subroutine calcv(self, first, iat, pot, sigma, basloc, vplm, vcos, vsin)

   type(TDomainDecomposition), intent(in) :: self
   logical, intent(in) :: first
   integer, intent(in) :: iat
   real(wp), intent(in) :: sigma(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: pot(:) ! [self%ngrid]
   real(wp), intent(inout) :: basloc(:) ! [self%nylm]
   real(wp), intent(inout) :: vplm(:) ! [self%nylm]
   real(wp), intent(inout) :: vcos(:) ! [self%lmax+1]
   real(wp), intent(inout) :: vsin(:) ! [self%lmax+1]

   integer :: its, ij, jat
   real(wp) :: vij(3), sij(3)
   real(wp) :: vvij2, vvij, tij, xij, oij, stslm, stslm2, stslm3

   ! initialize
   pot(:) = 0.0_wp

   ! if 1st iteration of Jacobi method, then done!
   if (first)  return

   ! loop over grid points
   do its = 1, self%ngrid

      ! contribution from integration point present
      if (self%ui(its, iat) < 1.0_wp) then

         ! loop over neighbors of i-sphere
         do ij = self%inl(iat), self%inl(iat+1)-1

            ! neighbor is j-sphere
            jat = self%nl(ij)

            ! compute t_n^ij = | r_i + \rho_i s_n - r_j | / \rho_j
            vij  = self%xyz(:, iat) + self%rvdw(iat)*self%grid(:, its) - self%xyz(:, jat)
            vvij2 = vij(1)**2 + vij(2)**2 + vij(3)**2
            vvij = sqrt(vvij2)
            tij  = vvij / self%rvdw(jat)

            ! point is INSIDE j-sphere
            if (tij < 1.0_wp) then

               ! compute s_n^ij = (r_i + \rho_i s_n - r_j) / | ... |
               sij = vij / vvij

               ! compute \chi(t_n^ij)
               xij = fsw(tij, se, self%eta)

               ! compute W_n^ij
               if (self%fi(its, iat) > 1.0_wp) then

                  oij = xij / self%fi(its, iat)

               else

                  oij = xij

               end if

               ! compute Y_l^m(s_n^ij)
               call ylmbas(self, sij, basloc, vplm, vcos, vsin)

               ! accumulate over j, l, m
               pot(its) = pot(its) + oij * intmlp(self, tij, sigma(:, jat), basloc)

            end if
         end do
      end if
   end do

end subroutine calcv


!> Compute the xi intermediate
!
! \xi(n, i) =
!
!  sum w_n U_n^i Y_l^m(s_n) [S_i]_l^m
!  l, m
!
pure subroutine ddmkxi(self, s, xi)

   type(TDomainDecomposition), intent(in) :: self
   real(wp), intent(in) :: s(:, :) ! [self%nylm, self%nat]
   real(wp), intent(inout) :: xi(:) ! [self%ncav]

   integer :: its, iat, ii

   ii = 0
   do iat = 1, self%nat
      do its = 1, self%ngrid
         if (self%ui(its, iat) > 0.0_wp) then
            ii = ii + 1
            xi(ii) = self%w(its)*self%ui(its, iat) &
               & * dot_product(self%basis(:, its), s(:, iat))
         end if
      end do
   end do

end subroutine ddmkxi


end module xtb_solv_ddcosmo_core

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Atomic r4/r2 expectation values
module xtb_param_sqrtzr4r2
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_symbols, only : toNumber
   implicit none
   private

   public :: getSqrtZr4r2, sqrtZr4r2


   !> Get r4/r2 expectation value for a species
   interface getSqrtZr4r2
      module procedure :: getSqrtZr4r2Symbol
      module procedure :: getSqrtZr4r2Number
   end interface getSqrtZr4r2

   integer, private, parameter :: max_elem = 118

   !  PBE0/def2-QZVP atomic values calculated by S. Grimme in Gaussian (2010)
   !  rare gases recalculated by J. Mewes with PBE0/aug-cc-pVQZ in Dirac (2018)
   !  He: 3.4698 -> 3.5544, Ne: 3.1036 -> 3.7943, Ar: 5.6004 -> 5.6638,
   !  Kr: 6.1971 -> 6.2312, Xe: 7.5152 -> 8.8367
   !  not replaced but recalculated (PBE0/cc-pVQZ) were
   !   H: 8.0589 ->10.9359, Li:29.0974 ->39.7226, Be:14.8517 ->17.7460
   !  also new super heavies Cn,Nh,Fl,Lv,Og
   real(wp), parameter :: r4Overr2(max_elem) = [  &
   &  8.0589_wp, 3.4698_wp, & ! H,He
   & 29.0974_wp,14.8517_wp,11.8799_wp, 7.8715_wp, 5.5588_wp, 4.7566_wp, 3.8025_wp, 3.1036_wp, & ! Li-Ne
   & 26.1552_wp,17.2304_wp,17.7210_wp,12.7442_wp, 9.5361_wp, 8.1652_wp, 6.7463_wp, 5.6004_wp, & ! Na-Ar
   & 29.2012_wp,22.3934_wp, & ! K,Ca
   &         19.0598_wp,16.8590_wp,15.4023_wp,12.5589_wp,13.4788_wp, & ! Sc-
   &         12.2309_wp,11.2809_wp,10.5569_wp,10.1428_wp, 9.4907_wp, & ! -Zn
   &                 13.4606_wp,10.8544_wp, 8.9386_wp, 8.1350_wp, 7.1251_wp, 6.1971_wp, & ! Ga-Kr
   & 30.0162_wp,24.4103_wp, & ! Rb,Sr
   &         20.3537_wp,17.4780_wp,13.5528_wp,11.8451_wp,11.0355_wp, & ! Y-
   &         10.1997_wp, 9.5414_wp, 9.0061_wp, 8.6417_wp, 8.9975_wp, & ! -Cd
   &                 14.0834_wp,11.8333_wp,10.0179_wp, 9.3844_wp, 8.4110_wp, 7.5152_wp, & ! In-Xe
   & 32.7622_wp,27.5708_wp, & ! Cs,Ba
   &         23.1671_wp,21.6003_wp,20.9615_wp,20.4562_wp,20.1010_wp,19.7475_wp,19.4828_wp, & ! La-Eu
   &         15.6013_wp,19.2362_wp,17.4717_wp,17.8321_wp,17.4237_wp,17.1954_wp,17.1631_wp, & ! Gd-Yb
   &         14.5716_wp,15.8758_wp,13.8989_wp,12.4834_wp,11.4421_wp, & ! Lu-
   &         10.2671_wp, 8.3549_wp, 7.8496_wp, 7.3278_wp, 7.4820_wp, & ! -Hg
   &                 13.5124_wp,11.6554_wp,10.0959_wp, 9.7340_wp, 8.8584_wp, 8.0125_wp, & ! Tl-Rn
   & 29.8135_wp,26.3157_wp, & ! Fr,Ra
   &         19.1885_wp,15.8542_wp,16.1305_wp,15.6161_wp,15.1226_wp,16.1576_wp, 0.0000_wp, & ! Ac-Am
   &          0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, & ! Cm-No
   &          0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, & ! Lr-
   &          0.0000_wp, 0.0000_wp, 0.0000_wp, 0.0000_wp, 5.4929_wp, & ! -Cn
   &                  6.7286_wp, 6.5144_wp,10.9169_wp,10.3600_wp, 9.4723_wp, 8.6641_wp ] ! Nh-Og
   integer, private :: idum
   real(wp), parameter :: sqrtZr4r2(max_elem) = &
   &  sqrt(0.5_wp*(r4Overr2*[(sqrt(real(idum,wp)),idum=1,max_elem)]))


contains


!> Get r4/r2 expectation value for species with a given symbol
elemental function getSqrtZr4r2Symbol(symbol) result(mass)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> r4/r2 expectation value
   real(wp) :: mass

   mass = getSqrtZr4r2(toNumber(symbol))

end function getSqrtZr4r2Symbol


!> Get r4/r2 expectation value for species with a given atomic number
elemental function getSqrtZr4r2Number(number) result(mass)

   !> Atomic number
   integer, intent(in) :: number

   !> r4/r2 expectation value
   real(wp) :: mass

   if (number > 0 .and. number <= size(sqrtZr4r2, dim=1)) then
      mass = sqrtZr4r2(number)
   else
      mass = -1.0_wp
   end if

end function getSqrtZr4r2Number


end module xtb_param_sqrtzr4r2

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_modef
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_single, only : singlepoint
   use xtb_anharmlib
   implicit none
   private

   public :: modefollow
contains
   ! mode following routine for conformational searches or 1D-anharmonic calc
   ! thres types of operation:
   ! mode_local = 0 : conformational PES scan based on normal coords
   ! mode_local = 1 : conformational PES scan based on localized normal coords
   ! mode_local =-1 : PES scan for anharmonic corrections (ie no minima opt.)

subroutine modefollow(env, mol, chk, calc, egap, et, maxiter, epot, grd, sigma)
   use xtb_mctc_accuracy, only : wp
   use iso_c_binding, only : c_null_char

   use xtb_mctc_convert, only : autokcal, aatoau, autorcm, amutoau
   use xtb_mctc_symbols, only : toSymbol

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_type_restart
   use xtb_type_data

   use xtb_setparam
   use xtb_splitparam
   use xtb_geoopt

   implicit none
   intrinsic date_and_time

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   integer :: icall,maxiter
   real(wp) :: epot,et,egap
   real(wp), intent(inout) :: grd(3,mol%n)
   real(wp), intent(inout) :: sigma(3,3)
   type(scc_results) :: res

   real(wp),allocatable:: freq(:), u(:,:), uu(:,:)
   real(wp),allocatable:: xyza (:,:,:), rmass(:), e(:), e2(:), geo(:,:)
   real(wp),allocatable:: coord0(:,:), displ(:), xyzmin(:,:), bmat(:,:)
   real(wp),allocatable:: x(:),b(:),c(:),d(:),xx(:),yy(:),yy1(:),yy2(:)

   real(wp) :: step,step2,x1,x2,dx,tmpx,yyy,yyy1,yyy2,emin,efreq,eps,dum
   real(wp) :: norm,fc,updscal,aa1,bb1,cc1,aa2,bb2,cc2,ee,thr,dip(3)
   integer :: ii,i,j,k,n3,maxoptiter,ia,ic,ij,ss,nstep,mode,np,kk
   integer :: nsplinep,nstp,istart,iend,nporg,nprj
   integer :: m,ifind,isave,imod,kkk,minpos,tag,n36
   !integer :: map(1000),stplist(100),stptyp(100),na(n),nb(n),nc(n)
   integer,allocatable :: map(:),stplist(:),stptyp(:)
   integer,allocatable :: na(:),nb(:),nc(:)
   character(len=2) :: adum
   character(len=30) :: ctmp,fname
   logical :: ex,fail,vecupdate,scfonly,ldum,intermol
   integer :: ich,val(8)

   write(*,*)
   write(*,'(7x,''======================================='')')
   write(*,'(7x,''|     M O D E   F O L L O W I N G     |'')')
   write(*,'(7x,''======================================='')')
   write(*,*)

   !     generate a tag to identify in confg the scan
   !call system("date | gawk '{print $4}' | sed s/':'/''/g > .tmpxxx")
   !open(newunit=ich,file='.tmpxxx')
   !read(ich,*)tag
   !close(ich,status='delete')
   !ppracht 09/2018 begin
   allocate(map(1000),stplist(100),stptyp(100),na(mol%n),nb(mol%n),nc(mol%n))

   call date_and_time(values=val)
   tag=365*val(1) + 30.5*val(2) + val(3) ! actual date
   !ppracht 09/2018 end

   call delete_file('xtbmodefok')

   mode=set%mode_follow
   tag=tag+100000*mode
   intermol=iatf2.gt.0.and.mode.lt.7

   imod=mode
   fname='xtb_normalmodes'
   if(set%mode_local.gt.0) then    ! file changed to local modes
      fname='xtb_localmodes'
      imod=mode+1000
   endif

   nprj=1
   if(set%mode_prj.gt.0) nprj=2

   write(*,*) 'intermolecular mode : ',intermol
   if(set%mode_follow.ne.0)then
      write(*,*) 'normal mode file    : ',trim(fname)
      write(*,*) '# of projected modes: ',nprj
   endif

   ! error section
   inquire(file=fname,exist=ex)
   if(.not.ex.and.set%mode_follow.ne.0) &
      & call raise('E','Hessian not found! run -hess first!')

   if(mode.lt.6.and.(.not.intermol)) call raise('E','mode <7(6) makes no sense!')
   if(set%mode_follow.gt.3*mol%n) call raise('E','mode >3N makes no sense!')


   n3=3*mol%n
   allocate(freq(n3),u(n3,n3),uu(n3,nprj),xyzmin(3,mol%n), &
   &         geo(3,mol%n),coord0(3,mol%n),displ(n3),xyza(3,mol%n,1000),rmass(n3))


   ! mode_follow=0: do rotations within pockets
   if(set%mode_follow.eq.0) then
      call pocketscan(mol%n,mol%at,mol%xyz,nstp)
      xyza=0.0d0
      ! read and re-opt
      call open_file(ich,'xtb_modescan_0.xyz','r')
      rewind(ich)
      do k=1,nstp
         read(ich,*)
         read(ich,*)
         do i=1,mol%n
            read(ich,*)adum,xyza(1:3,i,k)
         enddo
      enddo
      call close_file(ich)
      imod=0
      k=0
      do ii=1,nstp
         k=k+1
         mol%xyz(1:3,1:mol%n)=xyza(1:3,1:mol%n,ii)/aatoau
         call geometry_optimization &
         &          (env, mol,chk,calc, &
         &           egap,et,maxiter,maxoptiter,ee,grd,sigma,set%optset%optlev, &
         &           .false.,.true.,fail)
         kk=k
         call modeminname(imod,kk,ctmp)
         inquire(file=ctmp,exist=ex)
         if(ex)then
            444            kk=kk+1
            call modeminname(imod,kk,ctmp)
            inquire(file=ctmp,exist=ex)
            if(ex) goto 444
         endif
         write(*,'(''Erel (w.r.t input min / kcal :'' f8.3)') &
         &       (ee-epot)*autokcal
         call open_file(ich,ctmp,'w')
         write(ich,*)mol%n
         write(ich,'(F16.8,1x,i9)')ee,tag
         do j=1,mol%n
            write(ich,'(1x,a2,1x,3f18.8)') &
            &          toSymbol(mol%at(j)),mol%xyz(1:3,j)/aatoau
         enddo
         call close_file(ich)
      enddo
      goto 999
   endif


   ! read normal modes
   ! normal case
   call open_binary(ich,fname,'r')
   read (ich)k
   if(k.ne.n3) call raise('E','severe read error on modes')
   read (ich)freq
   read (ich)rmass
   read (ich)u
   call close_file(ich)
   ! remove masses from normal modes and re-normalize
   do m=1,n3
      norm=0
      do ia=1,mol%n
         do ic=1,3
            ii = (ia-1)*3+ic
            u(ii,m)=u(ii,m)*sqrt(atmass(ia))  ! this is correct... now it is
            norm=norm+u(ii,m)**2
         enddo
      enddo
      u(1:n3,m)=u(1:n3,m)/(sqrt(norm)+1.d-12)
   enddo

   if(intermol.and.set%mode_follow.lt.7) then
      write(*,*) 'normal mode file    : xtb_inormalmodes'
      call open_binary(ich,'xtb_inormalmodes','r')
      !        read intermolecular modes and put them on 1-6
      read(ich)freq(1:6)
      read(ich)rmass(1:6)
      read(ich)u(1:3*mol%n,1:6)
      call close_file(ich)
   endif

   if(nprj.eq.2)then
      uu(1:3*mol%n,2)=u(1:3*mol%n,set%mode_prj) ! assume that the additional mode which should be projected out is nr. mode_prj
      if(mode.eq.set%mode_prj) call raise('E','bad choice of options') ! ie, normally the TS one
   endif

   maxoptiter=set%optset%maxoptcycle
   isave=set%optset%micro_opt
   set%optset%micro_opt=1000 ! no coordinate update in ancopt

   if(mod(set%mode_nscan,2).eq.0) set%mode_nscan=set%mode_nscan+1 ! make it odd
   nstep=(set%mode_nscan-1)/2

   fc=0.5*(rmass(mode)*amutoau)*(freq(mode)/autorcm)**2  ! force constant
   step=set%mode_step*sqrt(2*0.04/fc)/nstep               ! to get 0.04 Eh energy i.e. consistent paths
   step=min(step,3.0d0)                               ! for stiff and floppy systems
   step=max(step,0.08d0)
   if(set%mode_local.gt.0) step=set%mode_step                 ! freq. has no meaning for loc modes

   updscal=set%mode_updat

   scfonly=.false.
   if(mol%n.eq.2.or.maxoptiter.lt.1) scfonly=.true.
   write(*,'(''# steps              :'',i5   )')set%mode_nscan
   write(*,'(''along normal mode    :'',i5   )')mode
   write(*,'(''frequency /cm-1      :'',F12.3)')freq(mode)
   write(*,'(''force constant       :'',F10.5)')fc
   write(*,'(''mode vector mixing   :'',F10.5)')updscal
   write(*,'(''step length          :'',F10.5)')step
   write(*,'(''maxiter (opt)        :'',i5   )')maxoptiter
   write(*,'(''optlevel for minima  :'',i5   )')set%optset%optlev


   np=2*nstep+1    ! total # of points on path
   allocate(e(np))

   !     check if input is ok
   call singlepoint(env,mol,chk,calc, &
   &         egap,et,maxiter,0,.true.,.true.,1.0d0,e(nstep+1),grd,sigma,res)
   dum=sqrt(sum(grd**2))
   write(*,'(''RMS gradient         :'',F10.5)')dum
   write(*,*)
   !if(dum.gt.0.005.and.nprj.eq.1.and.freq(mode).gt.0) then
   !  write(*,*)'WARNING WARNING WARNING WARNING WARNING WARNING'
   !  write(*,*)'mode following on incompletely optimized geometry!'
   !  write(*,*)'makes no sense and hence exiting.'
   !  goto 999
   !endif
   e(1:np)=1000. ! if points are skipped
   efreq=max(10.0d0,50*freq(mode)*2.8591D-3) ! in kcal
   efreq=min(efreq,50.0d0)                   ! in kcal
   !     the minimum (which should be the input struc)
   e(nstep+1)=epot
   xyza(1:3,1:mol%n,nstep+1)=mol%xyz(1:3,1:mol%n)

   !     n36=3*n-6
   !     allocate(bmat(n36,n3))
   !     call bzmat(n,at,xyz,bmat)
   !     call xyzint(xyz,n,na,nb,nc,1.0d0,geo)
   !     call gmetry(n,geo,mol%xyz,na,nb,nc)
   !     xyza(1:3,1:n,nstep+1)=mol%xyz(1:3,1:n)

   ! -direction
   uu(1:n3,1)=u(1:n3,mode) ! start org mode
   call open_binary(ich,'.xtbtmpmode','w')
   write(ich) nprj
   write(ich) uu
   call close_file(ich)
   xyzmin = mol%xyz
   do ss=1,nstep
      do ia=1,mol%n
         do ic=1,3
            ij = (ia-1)*3+ic
            mol%xyz(ic,ia)=mol%xyz(ic,ia)-step*uu(ij,1)
         enddo
      enddo
      !        call intmodestep(n,bmat,uu,-step,geo,na,nb,nc,mol%xyz)
      coord0 = mol%xyz
      if(scfonly)then
         call singlepoint(env,mol,chk,calc, &
         &         egap,et,maxiter,0,.true.,.false.,1.0d0,e(nstep-ss+1),grd,sigma,res)
      else
         call geometry_optimization &
         &       (env, mol,chk,calc, &
         &        egap,et,maxiter,maxoptiter,e(nstep-ss+1),grd,sigma,set%optset%optlev, &
         &        .false.,.true.,fail)
      endif
      xyza(1:3,1:mol%n,nstep-ss+1)=mol%xyz(1:3,1:mol%n)
      write(*,'(''step length :'',f6.2,'' dE /kcal :'',F8.3)') &
      &   -step*ss,autokcal*(e(nstep-ss+1)-e(nstep+1))
      !        if(ss.eq.1.and.e(nstep-ss+1)-e(nstep+1).gt.0.1)then
      if(e(nstep-ss+1)-e(nstep+1).gt.0.1)then
         write(*,*) 'exit because energy is too high',nstep-ss+1
         goto 888
      endif
      do ia=1,mol%n
         do ic=1,3
            displ((ia-1)*3+ic)=(mol%xyz(ic,ia) - coord0(ic,ia))*updscal
         enddo
      enddo
      if(updscal.gt.1.d-6)call writeuu(.true.,n3,displ,uu,nprj)  ! new search vector
   enddo

   ! +direction
   888  write(*,*)
   !     call xyzint(xyz,n,na,nb,nc,1.0d0,geo)
   mol%xyz = xyzmin
   uu(1:n3,1)=u(1:n3,mode) ! start org mode
   call open_binary(ich,'.xtbtmpmode','w')  ! important: switch on projection mode in opt
   write(ich) nprj
   write(ich) uu
   call close_file(ich)
   do ss=1,nstep
      do ia=1,mol%n
         do ic=1,3
            ij = (ia-1)*3+ic
            mol%xyz(ic,ia)=mol%xyz(ic,ia)+step*uu(ij,1)
         enddo
      enddo
      !        call intmodestep(n,bmat,uu,step,geo,na,nb,nc,mol%xyz)
      coord0 = mol%xyz
      if(scfonly)then
         call singlepoint(env,mol,chk,calc, &
         &         egap,et,maxiter,0,.true.,.false.,1.0d0,e(nstep+ss+1),grd,sigma,res)
      else
         call geometry_optimization &
         &       (env, mol,chk,calc, &
         &        egap,et,maxiter,maxoptiter,e(nstep+ss+1),grd,sigma,set%optset%optlev, &
         &        .false.,.true.,fail)
      endif
      xyza(:,:,nstep+ss+1)=mol%xyz
      write(*,'(''step length :'',f6.2,'' dE /kcal :'',F8.3)') &
      &   step*ss,autokcal*(e(nstep+ss+1)-e(nstep+1))
      if(e(nstep+ss+1)-e(nstep+1).gt.0.1)then
         write(*,*) 'exit because energy is too high',nstep+ss+1
         goto 889
      endif
      do ia=1,mol%n
         do ic=1,3
            displ((ia-1)*3+ic)=(mol%xyz(ic,ia) - coord0(ic,ia))*updscal
         enddo
      enddo
      displ=-displ
      if(updscal.gt.1.d-6)call writeuu(.true.,n3,displ,uu,nprj)  ! new search vector
   enddo

   889  write(*,*) 'writing path to file xtb_modescan_*'
   write(ctmp,'(''xtb_modescan_'',i0,''.xyz'')') imod
   call open_file(ich,ctmp,'w')

   emin=minval(e)
   e=e-emin    ! set min to zero
   !     if(mode_local.gt.0) efreq=50.
   !     remove very high-lying points
   istart=1
   iend  =np
   do i=1,np
      if(autokcal*e(i).lt.efreq)then
         istart=i
         exit
      endif
   enddo
   do i=np,1,-1
      if(autokcal*e(i).lt.efreq)then
         iend=i
         exit
      endif
   enddo
   nporg=np
   np=iend-istart+1
   if(np.le.1) goto 999 ! curve is bogous
   allocate(e2(np),b(np),c(np),d(np),x(np))
   e2(1:np)=e(istart:iend)
   write(*,*) 'removing high energy points ',nporg-np
   !     write the xyz file
   step2=-nstep*step
   kk=0
   do k=1,nporg
      if(k.ge.istart.and.k.le.iend) then
         kk=kk+1
         map(kk)=k
         x(kk)=step2
         write(ich,*)mol%n
         write(ich,'(F16.8,1x,3F9.3)')e(k),freq(mode),rmass(mode),step2
         write(143,*)step2,627.51*e(k)
         do i=1,mol%n
            write(ich,'(1x,a2,1x,3f18.8)') &
            &      toSymbol(mol%at(i)),xyza(1:3,i,k)/aatoau
         enddo
      endif
      step2=step2+step
   enddo
   call close_file(ich)

   ! spline the potential
   !                  x= x input, e2= y input, b,c,d are the spline coeffcients
   !                  dimensions are e2(np),b(np),c(np),d(np),x(np)
   !                  np= # of input points
   call spline2(x, e2, b, c, d, np)

   nsplinep=50000 ! # of points to be generated (interpolated)
   allocate(xx(nsplinep), yy(nsplinep), yy1(nsplinep), yy2(nsplinep))

   x1=x(1) +0.05*x(1)
   x2=x(np)+0.05*x(np)
   dx=(x2-x1)/(nsplinep-1)
   tmpx=x1
   do i=1,nsplinep
      xx(i)=tmpx
      !                      x, original points, spline coefficients, # input points,
      call ispline(tmpx, x, e2, b, c, d, np, yyy,yyy1,yyy2)
      yy (i)=yyy  ! splined value at tmpx
      yy1(i)=yyy1 ! first derivative at tmpx
      yy2(i)=yyy2 ! second derivative at tmpx
      tmpx=tmpx+dx
   enddo
   !     find minima and saddle points
   call curveanal(nsplinep,xx,yy,yy1,yy2,stplist,stptyp,nstp,eps)

   !call system('rm .xtbtmpmode') ! switch off projection mode in opt
   call delete_file('.xtbtmpmode')
   set%optset%micro_opt =isave   ! back to default
   maxoptiter=0       ! because we need accurate structures which allow comparison

   if(nstp.gt.1.and.set%mode_local.ge.0)then  ! good, there are new minima and its not a anharm run
      !        at which point on the curve is the min?
      k=0
      thr=0.1 ! different from input ie RK off the min at 0 ?
      if(mode.eq.7) thr=-99 ! include in a single case the input min.
      ! so that the ensemble contains it
      do i=1,nstp
         if(stptyp(i).ge.2)then  ! min?
            dx=xx(stplist(i))
            if(abs(dx).gt.thr)then
               ii=ifind(dx,np,x)
               k=k+1
               write(*,'(''minimum '',i2,'' at point '',i2,  &
               &                 '' re-opt:'')') k,ii
               mol%xyz = xyza(:,:,map(ii))
               call geometry_optimization &
               &          (env, mol,chk,calc, &
               &           egap,et,maxiter,maxoptiter,ee,grd,sigma,set%optset%optlev, &
               &           .false.,.true.,fail)
               kk=k
               call modeminname(imod,kk,ctmp)
               inquire(file=ctmp,exist=ex)
               if(ex)then
   44             kk=kk+1
                  call modeminname(imod,kk,ctmp)
                  inquire(file=ctmp,exist=ex)
                  if(ex) goto 44
               endif
               write(*,'(''Erel (w.r.t input min / kcal :'' f8.3)')  &
               &       (ee-epot)*autokcal
               call open_file(ich,ctmp,'w')
               write(ich,*)mol%n
               write(ich,'(F16.8,1x,i9)')ee,tag
               do j=1,mol%n
                  write(ich,'(1x,a2,1x,3f18.8)') &
                  &          toSymbol(mol%at(j)),mol%xyz(1:3,j)/aatoau
               enddo
               call close_file(ich)
            endif
         endif
      enddo
   endif
   ! local searches often generate no new minima but lets try anyway a few opts
   ! if no minimum is found, the endpoints sometimes lead to one in a full opt
   ldum=nstp.le.2.and.set%mode_local.ge.0.and.mode.gt.6 ! exclude anharm case and intermol one
   if(set%mode_local.gt.0.or.ldum) then
      minpos=nstep+1
      do k=1,set%mode_nscan,5
         if(abs(k-minpos).lt.5) cycle
         write(*,'(''re-opt at point '',i2)') k
         mol%xyz=xyza(:,:,k)
         call geometry_optimization &
         &       (env, mol,chk,calc, &
         &        egap,et,maxiter,maxoptiter,ee,grd,sigma,set%optset%optlev, &
         &        .false.,.true.,fail)
         kk=k
         call modeminname(imod,kk,ctmp)
         inquire(file=ctmp,exist=ex)
         if(ex)then
            45           kk=kk+1
            call modeminname(imod,kk,ctmp)
            inquire(file=ctmp,exist=ex)
            if(ex) goto 45
         endif
         write(*,'(''Erel (w.r.t input min / kcal :'' f8.3)')  &
         &           (ee-epot)*autokcal
         call open_file(ich,ctmp,'w')
         write(ich,*)mol%n
         write(ich,'(F16.8,1x,i9)')ee,tag
         do j=1,mol%n
            write(ich,'(1x,a2,1x,3f18.8)') &
            &         toSymbol(mol%at(j)),mol%xyz(1:3,j)/aatoau
         enddo
         call close_file(ich)
      enddo
   endif

   999  continue
   !call system('touch xtbmodefok')                     ! for parallel runs
   call touch_file('xtbmodefok')                    ! for parallel runs

   !ppracht 09/2018 begin ! saw: some are not always allocated
   if(allocated(yy2))    deallocate(yy2)
   if(allocated(yy1))    deallocate(yy1)
   if(allocated(xx))     deallocate(xx)
   if(allocated(yy))     deallocate(yy)
   if(allocated(x))      deallocate(x)
   if(allocated(d))      deallocate(d)
   if(allocated(c))      deallocate(c)
   if(allocated(b))      deallocate(b)
   if(allocated(e))      deallocate(e)
   if(allocated(e2))     deallocate(e2)
   if(allocated(rmass))  deallocate(rmass)
   if(allocated(xyza))   deallocate(xyza)
   if(allocated(displ))  deallocate(displ)
   if(allocated(coord0)) deallocate(coord0)
   if(allocated(geo))    deallocate(geo)
   if(allocated(xyzmin)) deallocate(xyzmin)
   if(allocated(uu))     deallocate(uu)
   if(allocated(u))      deallocate(u)
   if(allocated(freq))   deallocate(freq)
   if(allocated(nc))     deallocate(nc)
   if(allocated(nb))     deallocate(nb)
   if(allocated(na))     deallocate(na)
   if(allocated(stptyp)) deallocate(stptyp)
   if(allocated(stplist))deallocate(stplist)
   if(allocated(map))    deallocate(map)
   !ppracht 09/2018 end

end subroutine modefollow

subroutine modeminname(mode,mini,nam)
   implicit none
   integer mode,mini
   character(len=*) :: nam
   write(nam,'(''xtb_modemin_'',i0,''_'',i0,''.xyz'')')mini,mode
end subroutine modeminname

subroutine writeuu(wr,n3,d,uu,nprj)
   implicit none
   logical wr
   integer n3,i,nprj
   real(wp) d(n3),uu(n3,nprj),norm
   integer ich

   uu(1:n3,1) = uu(1:n3,1) - d(1:n3)
   norm=sum(uu(1:n3,1)**2)
   uu(1:n3,1) = uu(1:n3,1) / sqrt(norm)
   if(wr)then
      call open_binary(ich,'.xtbtmpmode','w')
      write(ich) nprj
      write(ich) uu
      call close_file(ich)
   endif

end subroutine writeuu

end module xtb_modef

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!-----------------------------------------------------------------------
!> Workflows employing multiple singlepoint calculations
!-----------------------------------------------------------------------
module xtb_vertical

   use xtb_mctc_accuracy, only: wp
   use xtb_type_calculator, only: TCalculator
   use xtb_type_data, only: scc_results
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule, only: TMolecule, len
   use xtb_type_restart, only: TRestart

   implicit none
   private

   public :: vfukui
   
contains

!--------------------------------------------------
! Calculate Fukui indices
!--------------------------------------------------
subroutine vfukui(env, mol, chk, calc, fukui)
   
   implicit none
   !> Dummy-argument list
   class(TCalculator), intent(inout) :: calc
      !! instance of calculatior
   type(TEnvironment), intent(inout) :: env
      !! calculation environment
   type(TMolecule), intent(inout) :: mol
      !! molecular information
   type(TRestart), intent(inout) :: chk
   type(TRestart) :: wf_an, wf_cat
   
   ! fukui functions f(+), f(-), f(0)
   real(wp), intent(out) :: fukui(3,mol%n)
 
   type(scc_results) :: res
   real(wp) :: sigma(3,3)
   real(wp) :: etot2,egap
   real(wp) :: g(3,mol%n)
   logical :: exist
   integer :: i
   
   write(env%unit,'(a)')
   write(env%unit,'("Fukui index Calculation")')

   ! copy wavefunction
   wf_an%wfn = chk%wfn
   wf_cat%wfn = chk%wfn

   ! reduce the charge -> anion
   mol%chrg = mol%chrg - 1       
   if (mod(wf_an%wfn%nel,2).ne.0) wf_an%wfn%nopen = 1

   ! Perform single point calculation for anion
   write(env%unit,'(a)')
   write(env%unit,'("Run single point for reduced species")')
   call calc%singlepoint(env, mol, wf_an, 1, exist, etot2, g, sigma, egap, res)

   ! increase the charge -> cation
   mol%chrg = mol%chrg + 2
   if (mod(wf_cat%wfn%nel,2).ne.0) wf_cat%wfn%nopen = 1
   ! Perform single point calculation for cation
   write(env%unit,'(a)')
   write(env%unit,'("Run single point for oxidized species")')
   call calc%singlepoint(env, mol, wf_cat, 1, exist, etot2, g, sigma, egap, res)
  
   ! Calculate the fukui functions where N is the number of electrons
   ! see J. Am. Chem. Soc. 1986, 108, 19, 5708–5711 for equations
   ! keep in mind that their q are populations (p), 
   ! which are related to our q by q = Z-p 

   ! f(+) = q_N -  q_(N+1) / neutral - anion
   fukui(1,:) = chk%wfn%q  - wf_an%wfn%q
   
   ! f(-) = q_(N-1) - q_N / cation - neutral
   fukui(2,:) = wf_cat%wfn%q-chk%wfn%q
   
   ! f(0) = 0.5 * [q_(N-1) - q_(N+1)] / cation - anion
   fukui(3,:) = 0.5d0*(wf_cat%wfn%q-wf_an%wfn%q)
   
   ! Print out fukui functions
   write(env%unit,'(a)')
   write(env%unit,'("Fukui functions:")')
   write(env%unit, '(1x,"    #        f(+)     f(-)     f(0)")')
   do i=1,mol%n
      write(env%unit,'(i6,a4,2f9.3,2f9.3,2f9.3)') i, mol%sym(i), fukui(1,i), fukui(2,i), fukui(3,i)
   enddo
   mol%chrg = mol%chrg - 1

end subroutine vfukui

end module xtb_vertical

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine wrmodef(typ,n,at,xyzin,wbo,rmass,freq,u,udum,vthr,linear)
   use xtb_mctc_accuracy, only : wp
   use xtb_intmodes
   implicit none
   integer, intent(in)    :: typ,n,at(n)
   real(wp),intent(in)    :: u(3*n,3*n),freq(3*n)
   real(wp),intent(in)    :: xyzin(3,n),wbo(n,n),rmass(3*n)
   real(wp),intent(inout) :: udum(3*n,3*n)
   real(wp),intent(in)    :: vthr
   logical, intent(in)    :: linear

   real(wp) :: one
   real(wp) :: norm,w
   real(wp),allocatable :: bmat(:,:),xyz(:,:),ttyp(:),rdum(:)
   real(wp),allocatable :: tmp(:,:),pop(:),deloc(:),xtyp(:,:)
   real(wp),allocatable :: dit (:),geo(:,:),vtyp(:),fdum(:),tors(:)
   parameter (one=1.0d0)
   integer, allocatable :: ind(:)
   integer, allocatable :: na(:),nb(:),nc(:)
   integer i,k,j,ik,kl,l,root,lend,b1,b2,n3
   integer ich ! file handle
   integer :: nfree,nnull

   if (linear) then
      nnull = 5
   else
      nnull = 6
   endif
   nfree = 3*n-nnull

   allocate( bmat(nfree,3*n), xyz(3,n), ttyp(3*n), rdum(3*n), &
      &          tmp(3*n,3*n), pop(n), deloc(3*n), xtyp(3*n,3),&
      &          dit(nfree), geo(3,n), vtyp(3), fdum(3*n), tors(3*n))
   allocate( ind(3*n), na(n), nb(n), nc(n) )

   geo=0
   ttyp(1:nnull)=0
   fdum(1:nnull)=0
   rdum(1:nnull)=0
   xyz=xyzin*0.52916790d0
   n3=3*n

   call XYZINT(XYZ,n,NA,NB,NC,one,GEO)

   call bzmat(n,at,xyz,bmat)

   do root=nnull+1,n3

      dit = 0
      do k=1,n3
         do j=1,3*n-nnull
            dit(j)=dit(j)+bmat(j,k)*u(k,root)
         enddo
      enddo

      do k=1,n
         norm=0
         do ik=1,3
            norm=norm+u((k-1)*3+ik,root)**2
         enddo
         pop(k)=norm
      enddo

      norm=0
      do k=1,n
         norm=norm+pop(k)**2
      enddo
      deloc(root)=1.d0/(norm+1.d-8)

      vtyp = 0
      kl=0
      do k=2,n
         lend=3
         if(k.eq.2) lend=1
         if(k.eq.3) lend=2
         do l=1,lend
            kl=kl+1
            !              b1=nc(k)
            !              b2=nb(k)
            !              w=1.
            !              if(l.eq.3.and.dit(kl).gt.0.1)then
            !                write(*,*) b1,b2,wbo(b1,b2)
            !                if(b1.gt.0.and.b2.gt.0.and.wbo(b1,b2).gt.0.5)
            !    .           w=1.0d0/wbo(b1,b2)**8
            !              endif
            vtyp(l)=vtyp(l)+dit(kl)**2
         enddo
      enddo

      norm=sum(vtyp)
      vtyp=vtyp/norm

      !        write(*,'(i5,2f10.2,5x,4f7.2)')
      !    .   root,freq(root),rmass(root),vtyp(1:3)

      ttyp(root)=vtyp(3)**2
      tors(root)=vtyp(3)
   enddo

   write(*,*)
   write(*,*) 'normal mode %tage of torsion character'
   write(*,'(8(i4,'':'',f6.2))') (i,ttyp(i),i=1,n3)

   do root=nnull+1,n3
      if(freq(root).gt.0) then
         ttyp(root)=freq(root)+(1.-ttyp(root))*freq(root)*2.
      else
         ttyp(root)=freq(root)
      endif
   enddo
   if(typ.eq.1)then
      do root=nnull+1,n3
         if(freq(root).gt.0) then
            ttyp(root)=ttyp(root)+10.*deloc(root)**2
         else
            ttyp(root)=freq(root)
         endif
      enddo
   endif
   do i=1,nnull
      ttyp(i)=-1.d+42
   enddo

   ! sort modes according to typ (and freq)
   do i=1,n3
      ind(i)=i
   enddo
   call Qsort(ttyp, 1, n3, ind)

   j=0
   do i=nnull+1,n3
      udum(1:n3,i)=u(1:n3,ind(i))
      fdum(i)=freq(ind(i))
      rdum(i)=rmass(ind(i))
      !        write(*,'(i5,2f10.2,5x,4f7.2)')
      !    .         i,fdum(i),tors(ind(i)),rdum(i)
      if(fdum(i).lt.vthr.and.tors(ind(i)).gt.0.5.and.i.gt.j) j=i
      !        write(*,'(i4,5f10.2)') i,fdum(i),deloc(ind(i))!,xtyp(ind(i),1:3
   enddo
   write(*,*)&
      &   'recommended # of modes for mode following',max(j-nnull,4)


   if(typ.eq.0)then
      call open_file(ich,'tmpxx','w')
      write(ich,*) max(j-6,4)
      call close_file(ich)
   endif


   if(typ.eq.0)then
      call open_binary(ich,'xtb_normalmodes','w')
      call g98fake('g98_canmode.out',n,at,xyzin,fdum,udum,tmp)
   else
      call open_file(ich,'xtb_localmodes','w')
      call g98fake('g98_locmode.out',n,at,xyzin,fdum,udum,tmp)
   endif
   write(ich)n3
   write(ich)fdum
   write(ich)rdum
   write(ich)udum
   call close_file(ich)

end subroutine wrmodef

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine g98fake(fname,n,at,xyz,freq,u2,u)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: n,at(n)
   real(wp),intent(in) :: freq(3*n),xyz(3,n),u2(3*n,3*n)
   real(wp),intent(inout) :: u(3*n,3*n)
   character(len=*),intent(in) :: fname

   integer gu,i,j,ka,kb,kc,la,lb,k
   character(len=2) irrep
   real(wp),allocatable :: red_mass(:)
   real(wp),allocatable :: force   (:)
   real(wp),allocatable :: ir_int  (:)
   real(wp),allocatable :: f2      (:)
   real(wp),allocatable :: zero
   allocate( red_mass(3*n),&
      &          force   (3*n),&
      &          ir_int  (3*n),&
      &          f2      (3*n) )

   irrep='a'
   red_mass=99.0
   force   =99.0
   ir_int  =99.0
   zero    =0.0

   k=0
   do i=1,3*n
      if(abs(freq(i)).gt.1.d-1)then
         k=k+1
         u(1:3*n,k)=u2(1:3*n,i)
         f2(k)=freq(i)
      endif
   enddo

   gu=55
   call open_file(gu,fname,'w')
   write (gu,'('' Entering Gaussian System'')')
   write (gu,'('' *********************************************'')')
   write (gu,'('' Gaussian 98:'')')
   write (gu,'('' frequency output generated by the xtb code'')')
   write (gu,'('' *********************************************'')')

   write (gu,*) '                        Standard orientation:'
   write (gu,*) '---------------------------------------------',&
      &             '-----------------------'
   write (gu,*) ' Center     Atomic     Atomic',&
      &             '              Coordinates (Angstroms)'
   write (gu,*) ' Number     Number      Type ',&
      &             '             X           Y           Z'
   write (gu,*) '-----------------------',&
      &             '---------------------------------------------'
   j=0
   do i=1,n
      write(gu,111) i,at(i),j,xyz(1:3,i)*0.52917726
   enddo
   write (gu,*) '----------------------',&
      &              '----------------------------------------------'
   write (gu,*) '    1 basis functions        1 primitive gaussians'
   write (gu,*) '    1 alpha electrons        1 beta electrons'
   write (gu,*)
   111   format(i5,i11,i14,4x,3f12.6)

   write (gu,*) 'Harmonic frequencies (cm**-1), IR intensities',&
      &              ' (KM/Mole),'
   write (gu,*) 'Raman scattering activities (A**4/amu),',&
      &              ' Raman depolarization ratios,'
   write (gu,*) 'reduced masses (AMU), force constants (mDyne/A)',&
      &             ' and normal coordinates:'

   ka =1
   kc=3
   60    kb=min0(kc,k)
   write (gu,100) (j,j=ka,kb)
   write (gu,105) (irrep,j=ka,kb)
   write (gu,110) ' Frequencies --',(f2(j),j=ka,kb)
   write (gu,110) ' Red. masses --',(red_mass(j),j=ka,kb)
   write (gu,110) ' Frc consts  --',(force(j),j=ka,kb)
   write (gu,110) ' IR Inten    --',(ir_int(j),j=ka,kb)
   write (gu,110) ' Raman Activ --',(zero,j=ka,kb)
   write (gu,110) ' Depolar     --',(zero,j=ka,kb)
   write (gu,*)'Atom AN      X      Y      Z        X      Y',&
      &            '      Z        X      Y      Z'
   la=1
   70    lb=n
   do  i=la,lb
      write (gu,130) i,at(i),&
         &              (u(i*3-2,j),&
         &               u(i*3-1,j),&
         &               u(i*3  ,j),j=ka,kb)
   enddo
   if (lb.eq.n) go to 90
   go to 70
   90    if (kb.eq.k) then
      return
   endif
   ka=kc+1
   kc=kc+3
   go to 60

   100   format (3(20x,i3))
   105   format (3x,3(18x,a5))
   110   format (a15,f11.4,12x,f11.4,12x,f11.4)
   130   format (2i4,3(2x,3f7.2))

   call close_file(gu)
   return

end subroutine g98fake

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_thermo
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   implicit none
   private

   public :: collect_thermo

contains

!> Collect all exported unit tests
subroutine collect_thermo(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("axis", test_axis), &
      new_unittest("calc", test_thermo_calc), &
      new_unittest("print", test_print_thermo) &
      ]

end subroutine collect_thermo


subroutine test_axis(error)
   use xtb_mctc_accuracy, only : wp

   use xtb_mctc_convert
   use xtb_type_molecule
   use xtb_splitparam

   use xtb_axis

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp
   real(wp), parameter :: thr2 = 1.0e-5_wp
   integer,  parameter :: nat = 6
   integer,  parameter :: at(nat) = [8,8,1,1,1,1]
   real(wp), parameter :: ams(nat) = [15.99940492_wp,15.99940492_wp, &
      &  1.00794075_wp, 1.00794075_wp, 1.00794075_wp, 1.00794075_wp]
   real(wp), parameter :: iso(nat) = [16.99913170_wp,17.9991610_wp, &
      &  2.01107778_wp, 3.01042777_wp, 1.00794075_wp, 1.00794075_wp]
   real(wp), parameter :: xyz(3,nat) = reshape([&
      &-2.98956539380840_wp,-0.24213847149862_wp,-0.00000088744317_wp, &
      & 2.35000755760470_wp, 0.22356837963350_wp,-0.00000838160401_wp, &
      &-1.19731697901940_wp, 0.13238632078926_wp,-0.00000485980301_wp, &
      &-3.84082093208368_wp, 1.35616304830930_wp, 0.00002536003281_wp, &
      & 2.83883868349296_wp,-0.73499856747260_wp,-1.46075352362473_wp, &
      & 2.83885706381384_wp,-0.73498070976087_wp, 1.46074229244211_wp],&
      & shape(xyz))
   type(TMolecule) :: mol
   real(wp) :: moments(3), rot(3)
   real(wp) :: rot1(3)
   real(wp) :: rot2(3), avmom2, mass2
   real(wp) :: eval3(3), coord3(3,nat)
   real(wp) :: rot4(3), evec4(3,3)

   call init(mol, at, xyz)
   mol%atmass = ams * amutoau

   moments = mol%moments_of_inertia()

   call check(error, moments(1), 15649.5560990126_wp, thr=thr2)
   call check(error, moments(2), 484991.786527778_wp, thr=thr2)
   call check(error, moments(3), 485024.382510520_wp, thr=thr2)

   rot = 0.5_wp*autorcm/[moments(3), moments(2), moments(1)]

   call check(error, rot(1), .226251131473004_wp, thr=thr)
   call check(error, rot(2), .226266337664493_wp, thr=thr)
   call check(error, rot(3), 7.01216792608729_wp, thr=thr)

   atmass = ams

   call axis(mol%n, mol%at, mol%xyz, rot1(1), rot1(2), rot1(3))

   call check(error, rot1(1), .226251131473004_wp, thr=thr2)
   call check(error, rot1(2), .226266337664493_wp, thr=thr2)
   call check(error, rot1(3), 7.01216792608729_wp, thr=thr2)

   call axis2(mol%n, mol%at, mol%xyz, rot2(1), rot2(2), rot2(3), avmom2, mass2)

   call check(error, rot2(1), .226251131473004_wp, thr=thr2)
   call check(error, rot2(2), .226266337664493_wp, thr=thr2)
   call check(error, rot2(3), 7.01216792608729_wp, thr=thr2)

   call axisvec(mol%n, mol%at, mol%xyz, rot4(1), rot4(2), rot4(3), evec4)

   call check(error, rot4(1), .226251131473004_wp, thr=thr2)
   call check(error, rot4(2), .226266337664493_wp, thr=thr2)
   call check(error, rot4(3), 7.01216792608729_wp, thr=thr2)

   mol%atmass = iso * amutoau

   moments = mol%moments_of_inertia()

   call check(error, moments(1), 23062.951395017_wp, thr=thr2)
   call check(error, moments(2), 569661.08474644_wp, thr=thr2)
   call check(error, moments(3), 577041.88473780_wp, thr=thr2)

   rot = 0.5_wp*autorcm/[moments(3), moments(2), moments(1)]

   call check(error, rot(1), .19017218374861_wp, thr=thr)
   call check(error, rot(2), .19263614502269_wp, thr=thr)
   call check(error, rot(3), 4.7581644454539_wp, thr=thr)

   atmass = iso

   call axis(mol%n, mol%at, mol%xyz, rot1(1), rot1(2), rot1(3))

   call check(error, rot1(1), .19017218374861_wp, thr=thr2)
   call check(error, rot1(2), .19263614502269_wp, thr=thr2)
   call check(error, rot1(3), 4.7581644454539_wp, thr=thr2)

   call axis2(mol%n, mol%at, mol%xyz, rot2(1), rot2(2), rot2(3), avmom2, mass2)

   call check(error, rot2(1), .19017218374861_wp, thr=thr2)
   call check(error, rot2(2), .19263614502269_wp, thr=thr2)
   call check(error, rot2(3), 4.7581644454539_wp, thr=thr2)

   call axisvec(mol%n, mol%at, mol%xyz, rot4(1), rot4(2), rot4(3), evec4)

   call check(error, rot4(1), .19017218374861_wp, thr=thr2)
   call check(error, rot4(2), .19263614502269_wp, thr=thr2)
   call check(error, rot4(3), 4.7581644454539_wp, thr=thr2)


end subroutine test_axis

subroutine test_thermo_calc(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_mctc_convert
   use xtb_thermo

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp
   integer,  parameter :: nat = 6
   integer,  parameter :: nvibs = 12
   real(wp), parameter :: ams(nat) = [15.99940492_wp,15.99940492_wp, &
      &  1.00794075_wp, 1.00794075_wp, 1.00794075_wp, 1.00794075_wp]
   real(wp), parameter :: moments(3) = &
      &[15649.5560990126_wp, 484991.786527778_wp, 485024.382510520_wp]
   real(wp), parameter :: vibs(nvibs) = &
      &[117.29518854_wp,      161.91929949_wp,      164.05816261_wp, &
      & 218.07506352_wp,      402.96868229_wp,      558.86387616_wp, &
      &1523.62725135_wp,     1561.31279119_wp,     3460.43559680_wp, &
      &3633.65239963_wp,     3636.81476002_wp,     3665.34271369_wp]*rcmtoau
   real(wp), parameter :: vibs_iso(nvibs) = &
      &[ 86.38105508090_wp,  141.77084264327_wp,  155.89354123588_wp, &
      & 182.95872682340_wp,  333.60535802793_wp,  421.06198802042_wp, &
      &1060.49921429103_wp, 1518.72673328712_wp, 2224.56212998692_wp, &
      &2512.05098623212_wp, 3621.54401864530_wp, 3625.88416620323_wp]*rcmtoau
   real(wp), parameter :: rotational_constants(3) = &
      & 0.5_wp*autorcm/[moments(3), moments(2), moments(1)]
   real(wp), parameter :: averaged_moment = &
      & (moments(1)+moments(2)+moments(3))/3 /(kgtome*aatoau**2*1.0e+20_wp)
   logical, parameter :: atom = .false.
   logical, parameter :: linear = .false.
   real(wp), parameter :: symmetry_number = 1
   real(wp), parameter :: energy = 0.0_wp
   real(wp), parameter :: temperature = 298.15_wp
   real(wp), parameter :: rotor_cutoff = 100.0_wp
   logical, parameter :: pr = .true.
   real(wp) :: et, ht, g, ts

   call thermodyn(stdout,rotational_constants(1),rotational_constants(2), &
      &           rotational_constants(3),averaged_moment,linear,atom, &
      &           symmetry_number,sum(ams),vibs,nvibs,energy,temperature, &
      &           rotor_cutoff,et,ht,g,ts,0.5_wp*sum(vibs),pr)

   call check(error, et, 0.50275771916811E-01_wp, thr=thr)
   call check(error, ht, 0.67528241233247E-02_wp, thr=thr)
   call check(error, g,  0.17417501635698E-01_wp, thr=thr)
   call check(error, ts, 0.32858270281112E-01_wp, thr=thr)

end subroutine test_thermo_calc

subroutine test_print_thermo(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_mctc_convert
   use xtb_splitparam

   use xtb_axis
   use xtb_propertyoutput

   type(error_type), allocatable, intent(out) :: error
   
   real(wp) :: zp
   real(wp), parameter :: thr = 1.0e-8_wp
   real(wp), parameter :: thr2 = 1.0e-5_wp
   integer,  parameter :: nat = 6
   integer,  parameter :: at(nat) = [8,8,1,1,1,1]
   real(wp), parameter :: ams(nat) = [15.99940492_wp,15.99940492_wp, &
      &  1.00794075_wp, 1.00794075_wp, 1.00794075_wp, 1.00794075_wp]
   real(wp), parameter :: iso(nat) = [16.99913170_wp,17.9991610_wp, &
      &  2.01107778_wp, 3.01042777_wp, 1.00794075_wp, 1.00794075_wp]
   real(wp), parameter :: xyz(3,nat) = reshape([&
      &-2.98956539380840_wp,-0.24213847149862_wp,-0.00000088744317_wp, &
      & 2.35000755760470_wp, 0.22356837963350_wp,-0.00000838160401_wp, &
      &-1.19731697901940_wp, 0.13238632078926_wp,-0.00000485980301_wp, &
      &-3.84082093208368_wp, 1.35616304830930_wp, 0.00002536003281_wp, &
      & 2.83883868349296_wp,-0.73499856747260_wp,-1.46075352362473_wp, &
      & 2.83885706381384_wp,-0.73498070976087_wp, 1.46074229244211_wp],&
      & shape(xyz))
   integer,  parameter :: nvibs = nat*3
   real(wp), parameter :: vibs(nvibs) = &
      &[  0.00000000_wp,        0.00000000_wp,        0.00000000_wp, &
      &   0.00000000_wp,        0.00000000_wp,        0.00000000_wp, &
      & 117.29518854_wp,      161.91929949_wp,      164.05816261_wp, &
      & 218.07506352_wp,      402.96868229_wp,      558.86387616_wp, &
      &1523.62725135_wp,     1561.31279119_wp,     3460.43559680_wp, &
      &3633.65239963_wp,     3636.81476002_wp,     3665.34271369_wp]
   real(wp), parameter :: vibs_iso(nvibs) = &
      &[  0.00000000000_wp,    0.00000000000_wp,    0.00000000000_wp, &
      &   0.00000000000_wp,    0.00000000000_wp,    0.00000000000_wp, &
      &  86.38105508090_wp,  141.77084264327_wp,  155.89354123588_wp, &
      & 182.95872682340_wp,  333.60535802793_wp,  421.06198802042_wp, &
      &1060.49921429103_wp, 1518.72673328712_wp, 2224.56212998692_wp, &
      &2512.05098623212_wp, 3621.54401864530_wp, 3625.88416620323_wp]
   real(wp), parameter :: energy = 0.0_wp
   real(wp) :: etot, htot, gtot
   integer  :: nimag

   atmass = ams

   call print_thermo(stdout,nat,nvibs,at,xyz,vibs,energy, &
      &              htot,gtot,nimag,.true.,zp)

   call check(error, nimag, 0)
   call check(error, htot, 0.50275771916811E-01_wp, thr=thr)
   call check(error, gtot, 0.17337250373280E-01_wp, thr=thr)

   atmass = iso

   call print_thermo(stdout,nat,nvibs,at,xyz,vibs_iso,energy, &
      &              htot,gtot,nimag,.true.,zp)

   call check(error, nimag, 0)
   call check(error, htot, 0.43308512037251E-01_wp, thr=thr)
   call check(error, gtot, 0.88976699718681E-02_wp, thr=thr)


end subroutine test_print_thermo

end module test_thermo

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_screening
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autokcal, aatoau
   use xtb_mctc_filetypes, only : fileType
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_type_restart
   use xtb_type_data
   use xtb_io_writer, only : writeMolecule
   use xtb_axis, only : axis
   use xtb_dynamic, only : wrc,boltz,xyzsort2
   use xtb_setparam
   use xtb_geoopt
   use xtb_cqpath

   implicit none
   private

   public :: screen

contains

subroutine screen(env, mol0, chk, calc, egap, et, maxiter, epot, grd, sigma)

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(inout) :: mol0
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   integer icall,maxiter
   real(wp) epot,et,egap
   real(wp), intent(inout) :: grd(3,mol0%n)
   real(wp), intent(inout) :: sigma(3,3)
   type(TMolecule) :: mol

   real(wp),allocatable :: rot (:,:)
   real(wp),allocatable :: de  (:)
   real(wp),allocatable :: ecnf(:)
   real(wp),allocatable :: xyznew(:,:,:)
   real(wp),allocatable :: rmat(:),eread(:)
   real(wp),allocatable :: ecnfnew(:)
   real(wp),allocatable :: er(:),pp(:)
   integer,allocatable :: imass(:)
   integer,allocatable ::double(:)

   real(wp) :: e,gnorm,dens,emin,ethr,ethr2,gg,ss
   real(wp) :: xx(10),r,rmsd,acc,T,beta,A,dum
   integer :: i,j,k,m,i1,i2,iz1,iz2,lin,nst,ncnf,ndum,olev
   integer :: nall,ntemp,ncnf1,icyc,maxoptiter
   character(len=80) :: atmp,line
   logical :: fail,equalrot2,ohbonded,include_enan,enan,ex
   logical :: checkrmsd
   integer :: ich,ilog

   write(*,*)
   write(*,'(7x,''======================================='')')
   write(*,'(7x,''|              S C R E E N            |'')')
   write(*,'(7x,''|          structural screening       |'')')
   write(*,'(7x,''======================================='')')
   write(*,*)

   inquire(file='solvent',exist=ex)
   if(ex)then ! use QMDFF to generate ensemble
      nall=set%ntemp_siman*set%time_md*1000/50  ! number of qmdff write outs
      nall=nall/40 ! take every 40th step from qmdff trj
      allocate(xyznew(3,mol0%n,nall),rot(3,0:nall),de(nall), &
         &         ecnf(0:nall),double(0:nall), &
         &         imass(mol0%n),ecnfnew(0:nall))
      call qmdfftoscreen(mol0%n,mol0%at,mol0%xyz,nall,xyznew,calc%lSolv)
   else  ! the ensemble exists
      atmp='xtbscreen.xyz'
      call cqpath_read_pathfile_parameter(atmp,iz1,iz2,nall)
      if(iz2.ne.mol0%n) call raise('E','read error in screen')
      allocate(xyznew(3,mol0%n,nall),rot(3,0:nall),de(nall), &
         &         ecnf(0:nall),double(0:nall),eread(nall), &
         &         imass(mol0%n),ecnfnew(0:nall))
      call cqpath_read_pathfile(atmp,iz1,iz2,nall,xyznew,mol0%at,eread)
   endif

   T     =set%temp_md
   beta  =1./(T*8.314510/4.184/1000.+1.d-14)
   ! consider two struc. equal if dE(kcal) < this value
   ethr=0.1
   include_enan=.false.
   xyznew = xyznew*aatoau

   ! the input reference
   mol = mol0
   rot = -1
   ecnf=10000.
   i=0
   ecnf(0)=epot
   call axis(mol%n,mol%at,mol%xyz,rot(1,0),rot(2,0),rot(3,0))
   call wrc('scoord.0',mol%n,mol%xyz,mol%at)

   ncnf =nall
   ncnf1=nall
   write(*,*)ncnf,' start structures'

   !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   ! opt all
   !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   do icyc=1,3

      maxoptiter=0
      if(icyc.eq.1)then
         maxoptiter=10
         ethr2=set%ewin_conf*2
         olev=-99
      endif
      if(icyc.eq.2)then
         olev=-1
         ethr2=set%ewin_conf
      endif
      if(icyc.eq.3)then
         olev=0
         ethr2=set%ewin_conf
      endif

      i=1
      write(*,*)
      write(*,*) 'optimization blocks ',i, ' opt. level ',olev
      do i=1,ncnf

         mol%xyz(1:3,1:mol%n)=xyznew(1:3,1:mol%n,i)

         call geometry_optimization &
            &       (env, mol,chk,calc, &
            &        egap,et,maxiter,maxoptiter,ecnf(i),grd,sigma,set%optset%optlev, &
            &        .false.,.true.,fail)

         if(.not.fail)then
            !call getname1(i,atmp)
            write(atmp,'(''scoord.'',i0)')i
            write(*,'(i4,''  energy : '',f14.7)') i,ecnf(i)
            call axis(mol%n,mol%at,mol%xyz,rot(1,i),rot(2,i),rot(3,i))
            call wrc(atmp,mol%n,mol%xyz,mol%at)
         endif

      enddo

      !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ! analyse FF ensemble
      !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double=0
      do i=0,ncnf
         do j=0,i-1
            e=(ecnf(i)-ecnf(j))*autokcal
            if(set%check_rmsd) then
               call heavyrmsdfile(i,j,dum)
               if(dum.lt.0.2) double(i)=1
            else
               if(equalrot2(i,j,nall,0.05d0,rot).and.abs(e).lt.ethr) then
                  ! check enantiomers
                  if(include_enan)then
                     call heavyrmsdfile(i,j,dum)
                     if(dum.lt.0.2) double(i)=1
                  else
                     double(i)=1
                  endif
               endif
            endif
         enddo
      enddo

      emin=minval(ecnf(1:ncnf))

      m=0
      do i=1,ncnf
         ! opt failed
         if(rot(1,i).lt.0) cycle

         !call getname1(i,atmp)
         write(atmp,'(''scoord.'',i0)')i
         call open_file(ich,atmp,'r')
         read(ich,'(a)')line
         do j=1,mol%n
            read(ich,*) mol%xyz(1:3,j)
         enddo
         call remove_file(ich)

         dum=autokcal*(ecnf(i)-emin)
         if(double(i).eq.0.and.dum.lt.ethr2)then
            m=m+1
            xyznew(1:3,1:mol%n,m)=mol%xyz(1:3,1:mol%n)
            ecnfnew(m) = ecnf(i)
         endif
      enddo
      write(*,'(i3,'' conformers remaining in'',f8.2,'' kcal window'')') &
         &      m,ethr2

      ! sort by energy
      ncnf=m
      call xyzsort2(ncnf,mol%n,ncnf,ecnfnew,xyznew)
      ecnf(1:ncnf)=ecnfnew(1:ncnf)

   enddo

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! output
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
99 write(*,*)
   write(*,*) '==================================================='
   write(*,*) '============= ordered conformer list =============='
   write(*,*) '==================================================='
   write(*,*) 'written to <scoord.nnn> and xtbscreen.log'
   write(*,*) 'dE=0 corresponds to the input structure'

   allocate(er(ncnf+1),pp(ncnf+1))
   call open_file(ilog,'xtbscreen.log','w')
   call writeMolecule(mol0, ilog, fileType%xyz, energy=ecnf(0))
   j=0
   emin=1.0d+42
   do i=0,ncnf
      er(i+1)=autokcal*(ecnf(i)-ecnf(0))
      !call getname1(i,atmp)
      write(atmp,'(''scoord.'',i0)')i
      if(i.gt.0) then
         mol%xyz(:, :) = xyznew(:, :, i)
         call wrc(atmp,mol%n,xyznew(1,1,i),mol%at)
         call writeMolecule(mol, ilog, fileType%xyz, energy=ecnf(i))
      endif
      write(*,'(i4,'' dE (kcal):'',F10.2,F14.6)') i, er(i+1), ecnf(i)
   enddo
   call close_file(ilog)

   call boltz(ncnf+1,T,er,pp)
   A=0
   do i=1,ncnf+1
      A=A+pp(i)*log(pp(i)+1.d-12)
   enddo
   gg=(1./beta)*A
   ss=-1000.*4.184*gg/T
   write(*,'('' S / J/mol K  :'',F10.3)') ss
   write(*,'('' G / kcal/mol :'',F10.3)') gg

   do i=ncnf+1,ncnf1
      !call getname1(i,atmp)
      write(atmp,'(''scoord.'',i0)')i
      call delete_file(trim(atmp))
   enddo

end subroutine screen

! call QMDFF MD to generate conformer ensemble
subroutine qmdfftoscreen(n,at,xyz,nall,xyzall,lsolv)
   use iso_c_binding, only : c_null_char
   use xtb_setparam
   implicit none
   integer  :: n
   integer  :: at(n)
   integer  :: nall
   real(wp) :: xyzall(3,n,nall)
   real(wp) :: xyz   (3,n)
   logical, intent(in) :: lsolv

   character(80) :: atmp
   character(2)  :: a2
   integer  :: i,j,k,l,m,ndum,nstep,dumpstep
   real(wp) :: tstart,temp2,temp,xyztmp(3,n)
   integer  :: ilog

   !call wrcoord(16,n,xyz,at,0.0d0,'coord')  ! qmdff needs a coord file
   call wrc('coord',n,xyz,at)
   write(*,*) 'moving hessian to hessian.save'

   temp  =set%Tend_siman
   tstart=set%temp_md
   temp2 =tstart
   dumpstep=40

   k=0
   do i=1,set%ntemp_siman
      write(atmp,'(''qmdff coord -rd -md '',i4,'' -temp '',F6.1, &
         &   '' > tmp'')') idint(set%time_md),temp2
      if(lsolv) &
         &   write(atmp,'(''qmdff coord -rd -md '',i4,'' -temp '',F6.1, &
         &   '' -gbsa '',a20,'' > tmp'')') idint(set%time_md),temp2,set%solvInput%solvent
      write(*,*)'QMDFF call:',trim(atmp)
      call execute_command_line(atmp)                                ! run qmdff
      temp2=temp2+(temp-tstart)/(set%ntemp_siman-1.)
      write(atmp,'(''cp qmdff.trj qmdff.trj.T.'',i1)') i
      call execute_command_line(atmp)                                ! save qmdff trj
      call open_file(ilog,'qmdff.trj','r')
      m=0
10    m=m+1                                            ! read
      read(ilog,*,end=20) ndum
      read(ilog,'(a)') atmp
      do j=1,ndum
         read(ilog,*,end=20) a2,xyztmp(1:3,j)
      enddo
      if(mod(m,dumpstep).eq.0.or.k.eq.0) then
         k=k+1
         if(k.gt.nall) goto 20
         xyzall(1:3,1:ndum,k)=xyztmp(1:3,1:ndum)
      endif
      goto 10
20    call remove_file(ilog)
   enddo

end subroutine qmdfftoscreen

end module xtb_screening

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_gfnff
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_gfnff

contains

!> Collect all exported unit tests
subroutine collect_gfnff(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("sp", test_gfnff_sp), &
      new_unittest("hb", test_gfnff_hb), &
      new_unittest("gbsa", test_gfnff_gbsa), &
      new_unittest("mindless", test_gfnff_mindless_basic), &
      new_unittest("mindless-solvation", test_gfnff_mindless_solvation), &
      new_unittest("scaleup", test_gfnff_scaleup), &
      new_unittest("pdb", test_gfnff_pdb), &
      new_unittest("sdf", test_gfnff_sdf) &
      ]

end subroutine collect_gfnff


subroutine test_gfnff_sp(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_systools
   use xtb_solv_gbsa
   use xtb_type_environment
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_data
   use xtb_gfnff_param
   use xtb_gfnff_setup
   use xtb_gfnff_eg
   use xtb_gfnff_ini
   use xtb_gfnff_neighbourlist
   use xtb_setparam
   use xtb_setmod
   use xtb_disp_dftd3param
   use xtb_disp_dftd4
   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 8
   integer, parameter :: at(nat) = [7,15,9,9,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[1.50040286526241_wp,-2.88219140061585_wp, 0.00000000000000_wp, &
      & 0.00000000000000_wp, 1.90142164792207_wp, 0.00000000000000_wp, &
      &-0.02649585010919_wp,-5.05651406856634_wp, 0.00000000000000_wp, &
      &-1.39762821979929_wp, 4.65236211997835_wp, 0.00000000000000_wp, &
      & 2.62205170116282_wp,-3.14316635901963_wp, 1.53958066744940_wp, &
      &-1.46489869067775_wp, 0.78885483581631_wp, 1.94964934855945_wp, &
      & 2.62205170116282_wp,-3.14316635901963_wp,-1.53958066744940_wp, &
      &-1.46489869067775_wp, 0.78885483581631_wp,-1.94964934855945_wp],&
      & shape(xyz))
   logical, parameter :: restart = .false.

   type(TMolecule)     :: mol
   type(TEnvironment)  :: env
   type(scc_results)   :: res_gff
   type(TGFFCalculator) :: calc
   type(TGFFNeighbourList) :: nlist
   type(TBorn), allocatable :: solvation

   real(wp) :: etot
   real(wp), allocatable :: g(:,:)
   character(len=:),allocatable :: fnv
   integer  :: ipar

   logical  :: exist

   call init(env)
   call init(mol,at,xyz)

   call delete_file('charges')
   call newGFFCalculator(env, mol, calc, '.param_gfnff.xtb', .false.)

   call env%checkpoint("GFN-FF parameter setup failed")

   allocate( g(3,mol%n), source = 0.0_wp )
 
   call check_(error, calc%topo%nbond,6)
   call check_(error, calc%topo%nangl,6)
   call check_(error, calc%topo%ntors,1)

   g = 0.0_wp
   gff_print=.true.

   call gfnff_eg(env,gff_print,mol%n,nint(mol%chrg),mol%at,mol%xyz,make_chrg, &
      & g,etot,res_gff,calc%param,calc%topo,nlist,solvation,.true.,calc%version, &
      & calc%accuracy)

   call check_(error, res_gff%e_total,-0.76480130317838_wp, thr=thr)
   call check_(error, res_gff%gnorm,   0.06237477492373_wp, thr=thr)
   call check_(error, res_gff%e_bond, -0.74131049663951_wp, thr=thr)
   call check_(error, res_gff%e_angl,  0.00633910404059_wp, thr=thr)
   call check_(error, res_gff%e_tors,  0.00004724445432_wp, thr=thr)
   call check_(error, res_gff%e_es,   -0.05070333390156_wp, thr=thr*10)
   call check_(error, res_gff%e_disp, -0.00224146422313_wp, thr=thr)
   call check_(error, res_gff%e_rep,   0.03086605590295_wp, thr=thr)
   call check_(error, res_gff%e_hb,   -0.00003142616658_wp, thr=thr)
   call check_(error, res_gff%e_xb,   -0.00776698664545_wp, thr=thr)
   call check_(error, res_gff%e_batm, -0.00000000000000_wp, thr=thr)

   call mol%deallocate

end subroutine test_gfnff_sp

subroutine test_gfnff_hb(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_systools
   use xtb_type_environment
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_data
   use xtb_gfnff_param
   use xtb_gfnff_setup
   use xtb_gfnff_eg
   use xtb_gfnff_ini
   use xtb_setparam
   use xtb_setmod
   use xtb_disp_dftd3param
   use xtb_disp_dftd4
   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,8,1,1,8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[-5.78520874132429_wp,-1.92328475821000_wp,-0.02944611115854_wp, &
      & -5.57801768832583_wp, 0.17912532844037_wp, 0.72444143178660_wp, &
      & -4.27822256938673_wp,-2.74845397256109_wp,-1.13038073598642_wp, &
      & -7.47879539136783_wp,-2.97570121473211_wp, 0.39488815557786_wp, &
      & -0.83005338399036_wp, 2.43458470560665_wp,-0.78566331969245_wp, &
      & -0.74201439536855_wp, 4.04199055249898_wp, 0.09144422329636_wp, &
      & -2.44679415487233_wp, 1.69392751177087_wp,-0.27417668699116_wp],&
      & shape(xyz))
   logical, parameter :: restart = .false.

   type(TMolecule)     :: mol
   type(TEnvironment)  :: env
   type(TRestart)      :: chk
   type(scc_results)   :: res_gff
   type(TGFFCalculator) :: calc

   real(wp) :: etot, sigma(3,3), gap
   real(wp), allocatable :: g(:,:)
   character(len=:),allocatable :: fnv
   integer  :: ipar

   logical  :: exist

   call init(env)
   call init(mol,at,xyz)

   call delete_file('charges')
   call newGFFCalculator(env, mol, calc, '---', .false.)

   call env%checkpoint("GFN-FF parameter setup failed")

   allocate( g(3,mol%n), source = 0.0_wp )
 
   call check_(error, calc%topo%nbond,5)
   call check_(error, calc%topo%nangl,4)
   call check_(error, calc%topo%ntors,1)

   g = 0.0_wp
   gff_print=.true.

   call calc%singlepoint(env, mol, chk, 1, .false., etot, g, sigma, gap, res_gff)

   call check_(error, res_gff%e_total,-0.949706677118_wp, thr=thr)
   call check_(error, res_gff%gnorm,   0.001152720923_wp, thr=thr)
   call check_(error, res_gff%e_bond, -0.856707643513_wp, thr=thr)
   call check_(error, res_gff%e_angl,  0.000579711773_wp, thr=thr)
   call check_(error, res_gff%e_tors,  0.000000008811_wp, thr=thr)
   call check_(error, res_gff%e_es,   -0.152313816530_wp, thr=thr*10)
   call check_(error, res_gff%e_disp, -0.001251669186_wp, thr=thr)
   call check_(error, res_gff%e_rep,   0.066881023899_wp, thr=thr)
   call check_(error, res_gff%e_hb,   -0.006894292337_wp, thr=thr)
   call check_(error, res_gff%e_xb,   -0.000000000000_wp, thr=thr)
   call check_(error, res_gff%e_batm, -0.000000000000_wp, thr=thr)

   call mol%deallocate

end subroutine test_gfnff_hb

subroutine test_gfnff_gbsa(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_systools
   use xtb_solv_input
   use xtb_type_environment
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_data
   use xtb_gfnff_param
   use xtb_gfnff_setup
   use xtb_gfnff_eg
   use xtb_gfnff_ini
   use xtb_setparam
   use xtb_setmod
   use xtb_disp_dftd3param
   use xtb_disp_dftd4
   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   use xtb_main_setup, only : addSolvationModel
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,8,1,1,8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[-5.78520874132429_wp,-1.92328475821000_wp,-0.02944611115854_wp, &
      & -5.57801768832583_wp, 0.17912532844037_wp, 0.72444143178660_wp, &
      & -4.27822256938673_wp,-2.74845397256109_wp,-1.13038073598642_wp, &
      & -7.47879539136783_wp,-2.97570121473211_wp, 0.39488815557786_wp, &
      & -0.83005338399036_wp, 2.43458470560665_wp,-0.78566331969245_wp, &
      & -0.74201439536855_wp, 4.04199055249898_wp, 0.09144422329636_wp, &
      & -2.44679415487233_wp, 1.69392751177087_wp,-0.27417668699116_wp],&
      & shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = "h2o")
   logical, parameter :: restart = .false.

   type(TMolecule)     :: mol
   type(TEnvironment)  :: env
   type(TRestart)      :: chk
   type(scc_results)   :: res_gff
   type(TGFFCalculator) :: calc

   real(wp) :: etot, sigma(3,3), gap
   real(wp), allocatable :: g(:,:)
   character(len=:),allocatable :: fnv
   integer  :: ipar

   logical  :: exist

   call init(env)
   call init(mol,at,xyz)

   call delete_file('charges')
   call newGFFCalculator(env, mol, calc, '---', .false.)
   call addSolvationModel(env, calc, TSolvInput(solvent=opt%solvent, alpb=.false., kernel=gbKernel%still))

   call env%checkpoint("GFN-FF parameter setup failed")

   allocate( g(3,mol%n), source = 0.0_wp )
 
   call check_(error, calc%topo%nbond,5)
   call check_(error, calc%topo%nangl,4)
   call check_(error, calc%topo%ntors,1)

   g = 0.0_wp
   gff_print=.true.

   call calc%singlepoint(env, mol, chk, 1, .false., etot, g, sigma, gap, res_gff)

   call check_(error, res_gff%e_total,-0.964158677062_wp, thr=thr)
   call check_(error, res_gff%gnorm,   0.013624276205_wp, thr=thr)
   call check_(error, res_gff%e_bond, -0.856707643513_wp, thr=thr)
   call check_(error, res_gff%e_angl,  0.000579711773_wp, thr=thr)
   call check_(error, res_gff%e_tors,  0.000000008811_wp, thr=thr)
   call check_(error, res_gff%e_es,   -0.150043166563_wp, thr=thr*10)
   call check_(error, res_gff%e_disp, -0.001251669186_wp, thr=thr)
   call check_(error, res_gff%e_rep,   0.066881023899_wp, thr=thr)
   call check_(error, res_gff%e_hb,   -0.006894292337_wp, thr=thr)
   call check_(error, res_gff%e_xb,   -0.000000000000_wp, thr=thr)
   call check_(error, res_gff%e_batm, -0.000000000000_wp, thr=thr)
   call check_(error, res_gff%g_solv, -0.016722649876_wp, thr=thr)
   call check_(error, res_gff%g_sasa,  0.000126368690_wp, thr=thr)
   call check_(error, res_gff%g_hb,   -0.009238122476_wp, thr=thr)
   call check_(error, res_gff%g_born, -0.009468339217_wp, thr=thr)
   call check_(error, res_gff%g_shift, 0.001857443126_wp, thr=thr)

   call mol%deallocate

end subroutine test_gfnff_gbsa


subroutine test_gfnff_mindless_basic(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TGFFCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   real(wp), parameter :: ref_energies(10) = &
      &[-1.6235670601725_wp, -1.2974060907872_wp, -1.5825072926857_wp, &
      & -1.6086171378897_wp, -1.5093596077875_wp, -1.6076220027918_wp, &
      & -1.7328634195448_wp, -1.8875339867396_wp, -1.3924035489143_wp, &
      & -1.9583702712389_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.11714711890640_wp, 0.08933168067298_wp, 0.15687133018871_wp, &
      & 0.09820451651462_wp, 0.08460010429134_wp, 0.08787739425161_wp, &
      & 0.12463658172704_wp, 0.10062734775717_wp, 0.06347506656236_wp, &
      & 0.09445561400996_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call delete_file('charges')
      call newGFFCalculator(env, mol, calc, '.param_gfnff.xtb', .false.)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)

   end do

end subroutine test_gfnff_mindless_basic


subroutine test_gfnff_mindless_solvation(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TGFFCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   character(len=*), parameter :: solvents(10) = [character(len=20) ::&
      & "h2o", "chcl3", "thf", "acetonitrile", "toluene", &
      & "ch2cl2", "ether", "methanol", "cs2", "dmso"]
   real(wp), parameter :: ref_energies(10) = &
      &[-1.6540916426629_wp, -1.3143056510098_wp, -1.6141899469716_wp, &
      & -1.6204572392623_wp, -1.5288738676799_wp, -1.6293089943213_wp, &
      & -1.7562513711414_wp, -1.9034123090085_wp, -1.4068010735061_wp, &
      & -1.9722601751413_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.11594122130461_wp, 0.08871796411903_wp, 0.15190830479600_wp, &
      & 0.09873901233954_wp, 0.08427306878219_wp, 0.08670875610818_wp, &
      & 0.11948602245812_wp, 0.10022284156198_wp, 0.06288313258789_wp, &
      & 0.09564569352042_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call delete_file('charges')
      call newGFFCalculator(env, mol, calc, '.param_gfnff.xtb', .false.)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & alpb=mod(iMol, 2)==0, kernel=gbKernel%still))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)

   end do

end subroutine test_gfnff_mindless_solvation


subroutine test_gfnff_scaleup(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TGFFCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: molecules(5) = [character(len=20) ::&
      & "caffeine", "rivaroxaban", "grubbs", "remdesivir", "taxol"]
   character(len=*), parameter :: solvents(5) = [character(len=20) ::&
      & "h2o", "acetonitrile", "toluene", "ether", "dmso"]
   real(wp), parameter :: ref_energies(5) = &
      &[-4.6919926039901_wp, -8.8807760138817_wp, -13.40715596616603_wp, &
      & -13.822994859730_wp, -20.577952329212_wp]
   real(wp), parameter :: ref_gnorms(5) = &
      &[0.05947676640487_wp, 0.09522104624089_wp, 0.1753769495334539_wp, &
      & 0.12496592222660_wp, 0.19366599743810_wp]

   call init(env)
   do iMol = 1, 5

      call getMolecule(mol, trim(molecules(iMol)))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call delete_file('charges')
      call newGFFCalculator(env, mol, calc, '.param_gfnff.xtb', .false.)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & alpb=mod(iMol, 2)==0, kernel=gbKernel%still))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)

   end do

end subroutine test_gfnff_scaleup


subroutine test_gfnff_pdb(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TGFFCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)
   real(wp), parameter :: ref_energies(3) = &
      &[-12.358885277947_wp, -12.442589851697_wp, -12.442131341448_wp]
   real(wp), parameter :: ref_gnorms(3) = &
      &[0.15855661051730_wp, 0.15148957207346_wp, 0.15151167424491_wp]

   call init(env)
   do iMol = 1, 3

      call getMolecule(mol, 'pdb-4qxx')

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call delete_file('charges')
      call newGFFCalculator(env, mol, calc, '.param_gfnff.xtb', .false.)
      if (iMol > 1) then
         call addSolvationModel(env, calc, TSolvInput(solvent='h2o', &
            & alpb=iMol==3, kernel=gbKernel%still))
      end if

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)

   end do

end subroutine test_gfnff_pdb


subroutine test_gfnff_sdf(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   use xtb_setparam, only : set

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TGFFCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)
   real(wp), parameter :: ref_energies(3) = &
      &[-0.98330642628373_wp, -1.0826001974262_wp, -1.0826319137928_wp]
   real(wp), parameter :: ref_gnorms(3) = &
      &[0.11515550863614e-2_wp, 0.59760221346330e-2_wp, 0.59645861418074e-2_wp]

   call init(env)
   do iMol = 1, 3

      call getMolecule(mol, 'bug332')
      set%ichrg = nint(mol%chrg)

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call delete_file('charges')
      call newGFFCalculator(env, mol, calc, '.param_gfnff.xtb', .false.)
      if (iMol > 1) then
         call addSolvationModel(env, calc, TSolvInput(solvent='h2o', &
            & alpb=iMol==3, kernel=gbKernel%p16))
      end if

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)

   end do

end subroutine test_gfnff_sdf

end module test_gfnff

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

! % cat xtbout.json
! {
! # calculation information
!    "coordinate file": coord,
!    "method": "GFN2-xTB",
!    "parameter file": "/home/awvwgk/.parameter/.param_gfn2.xtb"
! # molecule information
!    "number of atoms": 52,
!    "number of electron": 160,
!    "total charge": 0,
!    "spin": 1,
! # basis set information
!    "number of basisfunctions": 157,
!    "number of atomic orbitals": 155,
!    "number of shells": 85,
! # wavefunction information
!    "partial charges":
!    [
!       <charges>
!    ],
!    "atomic dipole moments":
!    [
!       [<dipx>,<dipy>,<dipz>]
!    ],
!    "atomic quadrupole moments":
!    [
!       [<quadxx>,<quadyy>,<qyadzz>,<quadxy>,<quadxz>,<quadyz>]
!    ],
!    "orbital energies":
!    [
!       <emo>
!    ],
!    "occupation numbers":
!    [
!       <focc>
!    ],
! # program information
!    "version": 6.1
! }
module xtb_main_json
  implicit none

contains

  subroutine main_json &
    (ijson, mol, wfx, xbas, sccres, freqres)
    use xtb_mctc_accuracy, only: wp

!! ========================================================================
!  load class definitions
    use xtb_type_molecule
    use xtb_type_wavefunction
    use xtb_type_basisset
    use xtb_type_data
    use xtb_type_param

!! ========================================================================
!  global storage of options, parameters and basis set
    use xtb_setparam

    implicit none

!! ========================================================================
    integer, intent(in) :: ijson ! file handle (usually json-file)
!  molecule data
    type(TMolecule), intent(in) :: mol
    type(TWavefunction), intent(in) :: wfx
    type(TBasisset), intent(in) :: xbas
    type(scc_results), intent(in) :: sccres
    type(freq_results), intent(in) :: freqres

    call write_json_header(ijson)
    call write_json_scc_results(ijson, sccres)
    if (freqres%gtot .gt. 0.0_wp) then
      call write_json_thermo(ijson, freqres)
    end if
    call write_json_charges(ijson, wfx)
    if (set%gfn_method .eq. 2) then
      call write_json_dipole_moments(ijson, wfx)
      call write_json_quadrupole_moments(ijson, wfx)
    end if
    call write_json_wavefunction(ijson, wfx)
    if (freqres%n3true .gt. 0) then
      call write_json_frequencies(ijson, freqres)
      call write_json_reduced_masses(ijson, freqres)
      call write_json_intensities(ijson, freqres)
    end if
    call write_json_footer(ijson)

  end subroutine main_json

  subroutine write_json_header(ijson)
    integer, intent(in) :: ijson
    write (ijson, '("{")')
  end subroutine write_json_header

  subroutine write_json_footer(ijson)
    use xtb_setparam
    include 'xtb_version.fh'
    integer, intent(in) :: ijson
    character(len=:), allocatable :: cmdline
    integer :: l
    call get_command(length=l)
    allocate (character(len=l) :: cmdline)
    call get_command(cmdline)
    write (ijson, '(3x,''"program call":'',1x,''"'',a,''",'')') cmdline
    write (ijson, '(3x,''"method": "GFN'',i0,''-xTB",'')') set%gfn_method
    write (ijson, '(3x,a)') '"xtb version": "'//version//'"'
    write (ijson, '("}")')
  end subroutine write_json_footer

  subroutine write_json_scc_results(ijson, sccres)
    use xtb_type_data
    integer, intent(in) :: ijson
    type(scc_results), intent(in) :: sccres
    character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
    write (ijson, jfmtf) 'total energy', sccres%e_total
    write (ijson, jfmtf) 'HOMO-LUMO gap/eV', sccres%hl_gap
    write (ijson, jfmtf) 'electronic energy', sccres%e_elec
    write (ijson, '(3x,''"'',a,''":'',1x,"[",2(f15.8,","),f15.8,"],")') &
      'dipole', sccres%dipole
    !write(ijson,jfmtf) 'classical repulsion energy',sccres%e_rep
    !write(ijson,jfmtf) 'isotropic electrostatic energy',sccres%e_es
    !write(ijson,jfmtf) 'anisotropic electrostatic energy',sccres%e_aes
    !write(ijson,jfmtf) 'anisotropic XC energy',sccres%e_axc
    !write(ijson,jfmtf) 'classical halogen bound energy',sccres%e_xb
    !write(ijson,jfmtf) 'Generalized Born free energy',sccres%g_born
    !write(ijson,jfmtf) 'SASA free energy',sccres%g_born
    !write(ijson,jfmtf) 'Hydrogen bound free energy',sccres%g_born
  end subroutine write_json_scc_results

  subroutine write_json_charges(ijson, wfn)
    use xtb_type_wavefunction
    integer, intent(in) :: ijson
    type(TWavefunction), intent(in) :: wfn
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
    integer :: i
    write (ijson, jfmta) 'partial charges'
    write (ijson, '(3x,f15.8,",")') (wfn%q(i), i=1, wfn%n - 1)
    write (ijson, '(3x,f15.8,"],")') wfn%q(wfn%n)
  end subroutine write_json_charges

  subroutine write_json_dipole_moments(ijson, wfn)
    use xtb_type_wavefunction
    integer, intent(in) :: ijson
    type(TWavefunction), intent(in) :: wfn
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
    integer :: i, j
    write (ijson, jfmta) 'atomic dipole moments'
    do i = 1, wfn%n - 1
      write (ijson, '(3x,"[",2(f15.8,","),f15.8,"],")') (wfn%dipm(j, i), j=1, 3)
    end do
    write (ijson, '(3x,"[",2(f15.8,","),f15.8,"]],")') (wfn%dipm(j, wfn%n), j=1, 3)
  end subroutine write_json_dipole_moments

  subroutine write_json_quadrupole_moments(ijson, wfn)
    use xtb_type_wavefunction
    integer, intent(in) :: ijson
    type(TWavefunction), intent(in) :: wfn
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
    integer :: i, j
    write (ijson, jfmta) 'atomic quadrupole moments'
    do i = 1, wfn%n - 1
      write (ijson, '(3x,"[",5(f15.8,","),f15.8,"],")') (wfn%qp(j, i), j=1, 6)
    end do
    write (ijson, '(3x,"[",5(f15.8,","),f15.8,"]],")') (wfn%qp(j, wfn%n), j=1, 6)
  end subroutine write_json_quadrupole_moments

  subroutine write_json_wavefunction(ijson, wfn)
    use xtb_type_wavefunction
    integer, intent(in) :: ijson
    type(TWavefunction), intent(in) :: wfn
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    character(len=*), parameter :: jfmti = '(3x,''"'',a,''":'',1x,i0,",")'
    character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
    integer :: i
    write (ijson, jfmti) 'number of molecular orbitals', wfn%nao
    write (ijson, jfmti) 'number of electrons', wfn%nel
    write (ijson, jfmti) 'number of unpaired electrons', wfn%nopen
    write (ijson, jfmta) 'orbital energies/eV'
    write (ijson, '(3x,f15.8,",")') (wfn%emo(i), i=1, wfn%nao - 1)
    write (ijson, '(3x,f15.8,"],")') wfn%emo(wfn%nao)
    write (ijson, jfmta) 'fractional occupation'
    write (ijson, '(3x,f15.8,",")') (wfn%focc(i), i=1, wfn%nao - 1)
    write (ijson, '(3x,f15.8,"],")') wfn%focc(wfn%nao)
  end subroutine write_json_wavefunction

  subroutine write_json_thermo(ijson, freqres)
    use xtb_type_data
    integer, intent(in) :: ijson
    type(freq_results), intent(in) :: freqres
    character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
    write (ijson, jfmtf) 'total enthalpy', freqres%htot
    write (ijson, jfmtf) 'total free energy', freqres%gtot
  end subroutine write_json_thermo

  subroutine write_json_frequencies(ijson, freqres)
    use xtb_type_data
    integer, intent(in) :: ijson
    type(freq_results), intent(in) :: freqres
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    integer :: i
    write (ijson, jfmta) 'vibrational frequencies/rcm'
    write (ijson, '(3x,f15.8,",")') (freqres%freq(i), i=1, freqres%n3true - 1)
    write (ijson, '(3x,f15.8,"],")') freqres%freq(freqres%n3true)
  end subroutine write_json_frequencies

  subroutine write_json_intensities(ijson, freqres)
    use xtb_type_data
    integer, intent(in) :: ijson
    type(freq_results), intent(in) :: freqres
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    integer :: i
    write (ijson, jfmta) 'IR intensities/amu'
    write (ijson, '(3x,f15.8,",")') (freqres%dipt(i), i=1, freqres%n3true - 1)
    write (ijson, '(3x,f15.8,"],")') freqres%dipt(freqres%n3true)
  end subroutine write_json_intensities

  subroutine write_json_reduced_masses(ijson, freqres)
    use xtb_type_data
    integer, intent(in) :: ijson
    type(freq_results), intent(in) :: freqres
    character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
    integer :: i
    write (ijson, jfmta) 'reduced masses'
    write (ijson, '(3x,f15.8,",")') (freqres%rmass(i), i=1, freqres%n3true - 1)
    write (ijson, '(3x,f15.8,"],")') freqres%rmass(freqres%n3true)
  end subroutine write_json_reduced_masses

  subroutine write_json_gfnff_lists(n, etot, gnorm, topo, nlist, printTopo)
    use xtb_gfnff_topology, only: TGFFTopology
    use xtb_gfnff_neighbourlist, only: TGFFNeighbourList
    use xtb_gfnff_topology, only: TPrintTopo
    use xtb_mctc_accuracy, only : wp
    include 'xtb_version.fh'
    !> gfnff topology lists
    type(TGFFTopology), intent(in) :: topo
    !> gfnff neighbourlist
    type(TGFFNeighbourList), intent(in) :: nlist
    !> topology printout booleans
    type(TPrintTopo), intent(in) :: printTopo
    !> total energy and gradient norm
    real(wp), intent(in) :: etot, gnorm
    character(len=:), allocatable :: cmdline
    integer :: iunit, j, n, l

    call open_file(iunit, 'gfnff_lists.json', 'w')
    ! header
    write (iunit, '("{")')
    ! lists printout
    if (printTopo%etot) then ! total energy is scalar
      write (iunit, '(3x,''"total energy":'',f25.15,",")') etot
    end if
    if (printTopo%gnorm) then ! gradient norm is scalar
      write (iunit, '(3x,''"gradient norm":'',f25.15,",")') gnorm
    end if
    if (printTopo%nb) then ! nb(20,n)
      write (iunit, '(3x,''"nb":'',"[")')
      do j = 1, n - 1
        write (iunit, '(3x,"[",*(i7,:,","))', advance='no') topo%nb(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') topo%nb(:, n)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%bpair) then ! bpair(n*(n+1)/2) packed symmetric matrix
      write (iunit, '(3x,''"bpair":'',"[")')
      write (iunit, '(3x,*(i7,:,","))', advance='no') topo%bpair
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%alist) then ! alist(3,nangl)
      write (iunit, '(3x,''"alist":'',"[")')
      do j = 1, topo%nangl - 1
        write (iunit, '(3x,"[",*(i8,:,","))', advance='no') topo%alist(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(i8,:,","),"]",/)', advance='no') topo%alist(:, topo%nangl)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%blist) then ! blist(2,nbond)
      write (iunit, '(3x,''"blist":'',"[")')
      do j = 1, topo%nbond - 1
        write (iunit, '(3x,"[",*(i8,:,","))', advance='no') topo%blist(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(i8,:,","),"]",/)', advance='no') topo%blist(:, topo%nbond)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%tlist) then ! tlist(5,ntors)
      write (iunit, '(3x,''"tlist":'',"[")')
      do j = 1, topo%ntors - 1
        write (iunit, '(3x,"[",*(i8,:,","))', advance='no') topo%tlist(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(i8,:,","),"]",/)', advance='no') topo%tlist(:, topo%ntors)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%vtors) then ! vtors(2,ntors)
      write (iunit, '(3x,''"vtors":'',"[")')
      do j = 1, topo%ntors - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') topo%vtors(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') topo%vtors(:, topo%ntors)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%vbond) then ! vbond(3,nbond)
      write (iunit, '(3x,''"vbond":'',"[")')
      do j = 1, topo%nbond - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') topo%vbond(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') topo%vbond(:, topo%nbond)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%vangl) then ! vangl(2,nangl)
      write (iunit, '(3x,''"vangl":'',"[")')
      do j = 1, topo%nangl - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') topo%vangl(:, j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') topo%vangl(:, topo%nangl)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%hbbond) then ! hbbond: 3x(3,nhb) energies: 3x(1,nhb)
      write (iunit, '(3x,''"hbl":'',"[")') !> HBs loose
      if (nlist%nhb1 .ge. 1) then
        do j = 1, nlist%nhb1 - 1
          write (iunit, '(3x,"[",*(i7,:,","))', advance='no') nlist%hblist1(:, j)
          write (iunit, '("],")')
        end do
        write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') nlist%hblist1(:, nlist%nhb1)
        write (iunit, '("]")')
        write (iunit, '(3x,"],")')
      else
        write (iunit, '(3x,"[",*(i7,:,""))', advance='no') 0
        write (iunit, '("]")')
        write (iunit, '(3x,"],")')
      end if

      write (iunit, '(3x,''"hbb":'',"[")') !> HBs bonded
      if (nlist%nhb2 .ge. 1) then
        do j = 1, nlist%nhb2 - 1
          write (iunit, '(3x,"[",*(i7,:,","))', advance='no') nlist%hblist2(:, j)
          write (iunit, '("],")')
        end do
        write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') nlist%hblist2(:, nlist%nhb2)
        write (iunit, '("]")')
        write (iunit, '(3x,"],")')
      else
        write (iunit, '(3x,"[",*(i7,:,""))', advance='no') 0
        write (iunit, '("]")')
        write (iunit, '(3x,"],")')
      end if

      write (iunit, '(3x,''"xb":'',"[")') !> XBs
      if (nlist%nxb .ge. 1) then
        do j = 1, nlist%nxb - 1
          write (iunit, '(3x,"[",*(i7,:,","))', advance='no') nlist%hblist3(:, j)
          write (iunit, '("],")')
        end do
        write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') nlist%hblist3(:, nlist%nxb)
        write (iunit, '("]")')
        write (iunit, '(3x,"],")')
      else
        write (iunit, '(3x,"[",*(i7,:,""))', advance='no') 0
        write (iunit, '("]")')
        write (iunit, '(3x,"],")')
      end if

      ! energies
      write (iunit, '(3x,''"hbl_e":'',"[")')
      do j = 1, nlist%nhb1 - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%hbe1(j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%hbe1(nlist%nhb1)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')

      write (iunit, '(3x,''"hbb_e":'',"[")')
      do j = 1, nlist%nhb2 - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%hbe2(j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%hbe2(nlist%nhb2)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')

      write (iunit, '(3x,''"xb_e":'',"[")')
      do j = 1, nlist%nxb - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%hbe3(j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%hbe3(nlist%nxb)
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if
    if (printTopo%eeq) then ! eeq(3,n)
      write (iunit, '(3x,''"eeq":'',"[")') !> EEQ charges
      do j = 1, size(nlist%q) - 1
        write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%q(j)
        write (iunit, '("],")')
      end do
      write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%q(size(nlist%q))
      write (iunit, '("]")')
      write (iunit, '(3x,"],")')
    end if

    ! footer
    call get_command(length=l)
    allocate (character(len=l) :: cmdline)
    call get_command(cmdline)
    write (iunit, '(3x,''"program call":'',1x,''"'',a,''",'')') cmdline
    write (iunit, '(3x,''"method": "GFN-FF"'',",")')
    write (iunit, '(3x,a)') '"xtb version": "'//version//'"'
    write (iunit, '("}")')
    call close_file(iunit)

  end subroutine write_json_gfnff_lists
end module xtb_main_json

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_setvar
   use xtb_mctc_accuracy, only : wp
   implicit none

!  NOTE: some set variables here are nothing but placeholders and are
!        currently NOT IN USE! Only variables declared as public will
!        be accessable in setparam.f90 and elsewhere.

   public :: env_setvar
   public :: ancopt_setvar
   public :: modhess_setvar
   public :: fix_setvar
   public :: constr_setvar
   public :: md_setvar
   public :: metadyn_setvar
   public :: reactor_setvar
   public :: path_setvar

   private
   integer,private :: idum

   type :: env_setvar
      character(len=:),allocatable :: home
      character(len=:),allocatable :: path
      character(len=:),allocatable :: namespace
      character(len=:),allocatable :: directory
   end type env_setvar

!! ------------------------------------------------------------------------
!  runtyp
!! ------------------------------------------------------------------------
   type :: run_setvar
   end type run_setvar

!! ------------------------------------------------------------------------
!  GFN Hamiltonian
!! ------------------------------------------------------------------------
   type :: gfn_setvar
      integer  :: gfn_method = -1
      integer  :: maxscciter = 250
      logical  :: newdisp = .true.
      logical  :: solve_scc = .true.
      logical  :: periodic = .false.
   end type gfn_setvar

!! ------------------------------------------------------------------------
!  SCC calculation
!! ------------------------------------------------------------------------
   type :: scc_setvar
!     electronic SCC temperature
      real(wp) :: etemp = 300.0_wp
!     damping in Broyden SCC procedure (0.05 for critical cases, autoadjusted)
      real(wp) :: broydamp = 0.40_wp
   end type scc_setvar

!! ------------------------------------------------------------------------
!  approximate normal coordinate rational function optimizer
!! ------------------------------------------------------------------------
   type :: ancopt_setvar
!     default optimization level
!     crude = -3,     sloppy = -2,      loose = -1,      normal = 0,
!     tight = 1,      verytight = 2,    extreme = 3
      integer  :: optlev = 0
!     number of opt. cycles before new ANC are made
      integer  :: micro_opt = 0
!     total number of opt. cycles, 0 means automatically determined
      integer  :: maxoptcycle = 0 ! det. in ancopt routine if not read in
!     maximum coordinate displacement in ancopt
      real(wp) :: maxdispl_opt = 0.0_wp
!     lowest force constant in ANC generation (should be > 0.005)
      real(wp) :: hlow_opt = 0.0_wp
      logical  :: exact_rf = .false.
      logical :: average_conv = .false.
   end type ancopt_setvar

   type modhess_setvar
      integer  :: model = 0
!     force constants for stretch, bend and torsion
      real(wp) :: kr = 0.0_wp
      real(wp) :: kf = 0.0_wp
      real(wp) :: kt = 0.0_wp
      real(wp) :: ko = 0.0_wp
      real(wp) :: kd = 0.0_wp
      real(wp) :: kq = 0.0_wp
!     cutoff for constructing internal coordinates
      real(wp) :: rcut = 0.0_wp
!     dispersion scaling in ANC generation
      real(wp) :: s6 = 0.0_wp
   end type modhess_setvar

!! ------------------------------------------------------------------------
!  Constraining potential
!! ------------------------------------------------------------------------
   type :: fix_setvar
      integer  :: n    = 0
      integer  :: nval = 0
      real(wp) :: fc   = 0.0_wp
      real(wp),allocatable :: expo(:)
      integer, allocatable :: atoms(:)
      real(wp),allocatable :: val(:)
   contains
      procedure :: allocate => allocate_fix
      procedure :: deallocate => deallocate_fix
   end type fix_setvar

   type :: constr_setvar
      integer  :: n  = 0
      real(wp) :: fc = 0.0_wp
      character(len=:),allocatable :: fname
      real(wp),allocatable :: xyz(:,:)
      integer, allocatable :: lookup(:)
      integer, allocatable :: typeid(:)
      type(fix_setvar) :: pos
      type(fix_setvar) :: dist
      type(fix_setvar) :: angle
      type(fix_setvar) :: dihedral
   contains
      procedure :: allocate => allocate_constr
      procedure :: deallocate => deallocate_constr
   end type constr_setvar

!! ------------------------------------------------------------------------
!  Hessian
!! ------------------------------------------------------------------------
   type :: hessian_setvar
!     SCC accuracy level in Hessian runs
      real(wp) :: accu_hess = 0.3_wp
!     Cartesian displacement increment for numerical Hessian
      real(wp) :: step_hess = 0.005_wp
   end type hessian_setvar

!! ------------------------------------------------------------------------
!  thermostatistical corrections
!! ------------------------------------------------------------------------
   type :: thermo_setvar  
!     temp. for thermostatistical calc. (could be more than just one T)
      real(wp) :: thermotemp(50) = (/298.15_wp,(0.0_wp,idum=2,50)/)
!     rotor cut-off (cm-1) in thermo  (was 100 cm-1 previously)
      real(wp) :: thermo_sthr = 50.0_wp
   end type thermo_setvar


!! ------------------------------------------------------------------------
!  Molecular dynamics (MD)
!! ------------------------------------------------------------------------
   type :: md_setvar
!     MD thermostat/initial siman/GBSA temperature
      real(wp) :: temp = 298.15_wp
!     MD run time in ps
      real(wp) :: time = 50.0_wp
!     dump (=optimize) structure in siman every mddump fs
      real(wp) :: dump = 1000.0_wp ! scoord
!     MD dump step in fs for xyz output file, MUST BE .eq. mdstep for power
!     IR spectra
      real(wp) :: dump2 = 50.0_wp ! molden,xyzfile
!     set to 1 if dumps (trj file) should contain velocities
      logical  :: velodump = .false.
!     use thermostat (=1, =0 for NVE)
      logical  :: nvt = .true.
!     skip interval in -mdav, -mdopt
      integer  :: skip = 500 ! mdopt, mdav
!     MD time step in fs (automatically determined if < 0),
!     could be 4-5 fs with shake =2, md_hmass=4
      real(wp) :: tstep = 4.0_wp
!     increase hydrogen mass to this value in amu (at const. tot. mass)
!     allowing large time steps (=0 off)
      integer  :: hmass = 4
!     shake on (=0: off which is default) for X-H bonds only (=1),
!     or all bonds (=2) or user defined bonds (=3)
      integer  :: shake_mode = 2
      logical  :: shake_md = .true.
      logical  :: xhonly = .true.
      logical  :: honly = .false.
!     SCC accuracy level in MD. Every 10th step the SCC is properly converged
!     at sccconv=1.0. sccmd should be < 5 in critical cases, effects may show
!     up as bad thermostating
      real(wp) :: accu_md = 2.0_wp
   end type md_setvar

!! ------------------------------------------------------------------------
!  simulated annealing (SIMAN)
!! ------------------------------------------------------------------------
   type :: siman_setvar
!     number of siman annealing blocks
      integer  :: ntemp_siman = 3
!     energy window (kcal) for considering conformers
      real(wp) :: ewin_conf = 20.0_wp
!     highest siman annealing temperature (very system specific)
      real(wp) :: Tend_siman = 1000.0_wp
!     include enantiomers in siman (=1)
      logical  :: enan_siman = .false.
   end type siman_setvar

!! ------------------------------------------------------------------------
!  Mode following
!! ------------------------------------------------------------------------
   type :: modef_setvar
!     of points along normal mode path scan
      integer  :: nscan = 31
!     step lengths for scan (should be around 1 because its adjusted
!     internally to mode mass and FC)
      real(wp) :: step = 1.0_wp
!     update search mode with a fraction of the displacement at every step
!     (0.0 means no update, 0.1-0.2 is a good choice)
      real(wp) :: updat = 0.2_wp
!     use canonical normal modes (=0) or Pipek-Mezey localized ones (=1)
      integer  :: local = 0
!     threshold up to which frequency modes are used for mode based conformer
!     search (def. is 300)
      real(wp) :: vthr = 0.0_wp
!     number of second mode which should be projected out in mode following
!     (normally = 7 ie the TS mode which is fixed then)
      integer  :: prj = 0
!     set by -modef via cmdline
      integer  :: follow = 7
   end type modef_setvar

!! ------------------------------------------------------------------------
!  RMSD based meta dynamic feature
!! ------------------------------------------------------------------------
   type :: metadyn_setvar
      integer  :: maxsave = 0
      integer  :: nstruc = 0
      real(wp) :: global_factor = 0.0_wp
      real(wp),allocatable :: factor(:)
      real(wp) :: global_width = 1.0_wp
      real(wp),allocatable :: width(:)
      real(wp) :: ramp = 0.03_wp
      integer  :: nat = 0
      logical  :: static = .true.
      integer, allocatable :: atoms(:)
      real(wp),allocatable :: xyz(:,:,:)
      character(len=:),allocatable :: fname
   contains
      procedure :: allocate => allocate_metadyn
      procedure :: deallocate => deallocate_metadyn
   end type metadyn_setvar

!! ------------------------------------------------------------------------
!  biased path finder based on RMSD criteria
!! ------------------------------------------------------------------------
   type :: path_setvar
!     number of runs with different settings (<1 means auto setup)
      integer  :: nrun =3  
!     approx. no. of opt. (=points) on path 
      integer  :: nopt =50 
!     max # of "an" opt steps (2-4 is reasonable)
      integer  :: anopt=3  
!     push (educt)   Gaussian RSMD prefactor  
      real(wp) :: kpush= 0.05_wp
!     pull (product) Gaussian RSMD prefactor  
      real(wp) :: kpull=-0.04_wp
!     Gaussian RSMD width
      real(wp) :: alp  = 0.70_wp
!     file name for product structure
      character(len=:),allocatable :: fname
!     default pull strength on path point
      real(wp) :: ppull = 0.05_wp
!     atom list
      integer  :: nat = 0
      integer, allocatable :: atoms(:)
   contains
      procedure :: allocate => allocate_path
      procedure :: deallocate => deallocate_path
   end type path_setvar

!! ------------------------------------------------------------------------
!  nano reactor based on RMSD biasing potential
!! ------------------------------------------------------------------------
   type :: reactor_setvar
!     number of saved images for RMSD potential
      integer  :: nmax =50 
!     push (educt) Gaussian RSMD prefactor  
      real(wp) :: kpush= 0.05_wp
!     Gaussian RSMD width
      real(wp) :: alp  = 0.70_wp
!     density of system
      real(wp) :: dens  = 1.0_wp
!     atom list
      integer  :: nat = 0
      integer, allocatable :: atoms(:)
   contains
      procedure :: allocate => allocate_reactor
      procedure :: deallocate => deallocate_reactor
   end type reactor_setvar

contains

subroutine allocate_metadyn(self,nat,nstruc)
   implicit none
   class(metadyn_setvar) :: self
   integer, intent(in) :: nat
   integer, intent(in) :: nstruc
   self%maxsave = nstruc
   call self%deallocate
   allocate( self%atoms(nat),          source = 0 )
   allocate( self%factor(nstruc),      source = 0.0_wp )
   allocate( self%width(nstruc),       source = 0.0_wp )
   allocate( self%xyz  (3,nat,nstruc), source = 0.0_wp )
end subroutine allocate_metadyn

subroutine deallocate_metadyn(self)
   class(metadyn_setvar) :: self
   if(allocated(self%atoms))  deallocate( self%atoms )
   if(allocated(self%factor)) deallocate( self%factor )
   if(allocated(self%width))  deallocate( self%width )
   if(allocated(self%xyz  ))  deallocate( self%xyz   )
end subroutine deallocate_metadyn

subroutine allocate_path(self,nat)
   implicit none
   class(path_setvar)  :: self
   integer, intent(in) :: nat
   call self%deallocate
   allocate( self%atoms(nat),          source = 0 )
end subroutine allocate_path

subroutine deallocate_path(self)
   class(path_setvar) :: self
   if(allocated(self%atoms))  deallocate( self%atoms )
end subroutine deallocate_path

subroutine allocate_reactor(self,nat)
   implicit none
   class(reactor_setvar) :: self
   integer, intent(in) :: nat
   call self%deallocate
   allocate( self%atoms(nat),          source = 0 )
end subroutine allocate_reactor

subroutine deallocate_reactor(self)
   class(reactor_setvar) :: self
   if(allocated(self%atoms))  deallocate( self%atoms )
end subroutine deallocate_reactor

subroutine allocate_fix(self,nat,nval,fc,expo)
   implicit none
   class(fix_setvar)   :: self
   integer, intent(in) :: nat
   integer, intent(in),optional :: nval
   real(wp),intent(in),optional :: fc
   real(wp),intent(in),optional :: expo
   call self%deallocate
   if (present(nval)) self%nval = nval
   if (present(fc))   self%fc = fc
   if (present(nval) .and. present(expo)) then
      allocate(self%expo(nval))
      self%expo(:) = expo
   end if
   allocate( self%atoms(nat), source = 0 )
   if (present(nval)) allocate( self%val(nval),  source = 0.0_wp )
end subroutine allocate_fix

subroutine deallocate_fix(self)
   class(fix_setvar) :: self
   self%n = 0
   self%fc = 0.0_wp
   if(allocated(self%expo)) deallocate( self%expo )
   if(allocated(self%atoms)) deallocate( self%atoms )
   if(allocated(self%val))   deallocate( self%val )
end subroutine deallocate_fix

subroutine allocate_constr(self,nat,nval,fc,expo)
   implicit none
   class(constr_setvar) :: self
   integer, intent(in)  :: nat
   integer, intent(in)  :: nval
   real(wp),intent(in),optional :: fc
   real(wp),intent(in),optional :: expo
   call self%deallocate
   self%n = nval
   if (present(fc)) self%fc = fc
   allocate( self%lookup(nval), source = 0 )
   allocate( self%typeid(nval), source = 0 )
   call self%pos     %allocate(nat,nat*(nat+1)/2)
   call self%dist    %allocate(nval*2,nval,expo=expo)
   call self%angle   %allocate(nval*3,nval)
   call self%dihedral%allocate(nval*4,nval)
   if (present(fc)) then
      self%pos     %fc = fc
      self%dist    %fc = fc
      self%angle   %fc = fc
      self%dihedral%fc = fc
   endif
end subroutine allocate_constr

subroutine deallocate_constr(self)
   class(constr_setvar) :: self
   call self%pos     %deallocate
   call self%dist    %deallocate
   call self%angle   %deallocate
   call self%dihedral%deallocate
   self%n = 0
   self%fc = 0.0_wp
   if(allocated(self%lookup)) deallocate( self%lookup )
   if(allocated(self%typeid)) deallocate( self%typeid )
end subroutine deallocate_constr

end module xtb_type_setvar

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of orca output formats
module xtb_io_writer_orca
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule
   implicit none
   private

   public :: writeResultsOrca


contains


subroutine writeResultsOrca(unit, mol, energy, gradient)
   type(TMolecule), intent(in) :: mol
   integer, intent(in) :: unit
   real(wp), intent(in) :: energy
   real(wp), intent(in) :: gradient(:, :)
   integer :: i

   write(unit, '(a)') "#", "# Number of atoms", "#"
   write(unit, '(i10)') mol%n
   write(unit, '(a)') "#", "# The current total energy in Eh", "#"
   write(unit, '(f20.12)') energy
   write(unit, '(a)') "#", "# The current gradient in Eh/bohr", "#"
   write(unit, '(1x,f20.12)') gradient
   write(unit, '(a)') "#", "# The atomic numbers and current coordinates in Bohr", "#"
   do i = 1, mol%n
      write(unit, '(1x,i3,1x,3(1x,f12.7))') mol%at(i), mol%xyz(:, i)
   end do

end subroutine writeResultsOrca


end module xtb_io_writer_orca

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c simple STM picture simulation routine using PT according to
c Tersoff & Hamann, PRL 50 (1983), 1998.
c assumes that the molecule is lying mainly in xy plane
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      module stm
      contains
      subroutine stmpic(n,nmo,nbf,at,xyz,C,efermi,emo,basis)
         use xtb_mctc_accuracy, only : wp
      use xtb_type_basisset
      use xtb_setparam
      use xtb_scc_core, only : dmat
      use esp
      implicit none
      type(TBasisset), intent(in) :: basis
      integer nproc,n,nbf,nmo,at(n)
      real(wp) xyz(3,n),emo(nmo),C(nbf,nmo),efermi

      real(wp),allocatable :: pa(:,:),espe(:)
      real(wp),allocatable :: ee(:,:),efact(:),gama(:),dd(:,:)
      real(wp),allocatable :: P(:),eocc(:),ptmp(:,:)
      integer,allocatable:: indp(:,:),nnn(:)
      real(wp) point(3),rx,ry,rz,r,intcut,t0,t1,w0,w1,pthr,av,scal,alp
      real(wp) stepr,dx,dy,dz,xx1,yy1,zz1,bord,dum(3),targ,zmin,tmin
      real(wp) sqrt2pi,cut,bohr,bordxy,pot,de,stepz
      parameter (sqrt2pi = sqrt(2*3.141592653589790d0))
      parameter (bohr=0.52917726d0)

      integer i,j,k,l,m,done,mprim,npp,ind1,ind2,np,m1,m2,m3
      !$ integer :: omp_get_num_threads
      nproc = 1
      !$ nproc = omp_get_num_threads()

      write(*,*)
      write(*,*)'STM picture simulation routine'
      write(*,*)'in constant current mode'
      write(*,'('' tip DOS energy broadening (eV):'',f9.1)')set%stm_alp
      write(*,'('' tip potential (V)             :'',f9.6)')set%stm_pot
      write(*,'('' constant current value (a.u.) :'',f9.6)')set%stm_targ
      write(*,'('' grid width (Bohr)             :'',f9.6)')set%stm_grid
      write(*,'('' int and Pmat neglect stm_thr  :'',f9.6)')set%stm_thr

c prog parameters (should be made a user input)
      alp =set%stm_alp  !1.500 ! width of tip DOS energy broadening (eV)
      targ=set%stm_targ !1.d-4 ! constant current value (a.u.)
      stepr=set%stm_grid!0.5d0! grid width (Bohr), half that value along Z
      pot  =set%stm_pot ! potential of tip vs. molecule, negative values let e flow from mol to tip
                    ! ie occ space of mol is probed
c fix
      bord=4.5d0                    ! Z-limit (Bohr), max Z of molecule added
      intcut=20.-3.0*log10(set%stm_thr) ! primitive cut-off, =20 makes a factor of 2 compared to =10
      pthr=1.d-5*set%stm_thr            ! dmat neglect threshold
      write(*,'('' incut                         :'',f9.6)')intcut
      write(*,'('' Pthr                          :'',e9.3)')pthr

      allocate(P(nbf*(nbf+1)/2),ptmp(nbf,nbf),eocc(nmo))

c start calc
      scal=1.0d0/(alp*sqrt2pi)
      do i=1,nmo
         de=efermi-emo(i)-pot
         eocc(i)=scal*exp(-0.5*(de/alp)**2)  ! assume Gaussian DOS for tip instead of delta function
                                             ! as in the original work (eq 11)
      enddo

      write(*,*)'computing MO energy weighted density maxtrix ...'
      call dmat(nbf,eocc,C,ptmp)
      m=0
      do k=1,nbf
         do l=1,k
            m=m+1
            P(m)=ptmp(l,k)
         enddo
      enddo
      deallocate(ptmp,eocc)

c     compute primitive pair data
      write(*,*)'computing primitive pair data ...'
      call preints(n,nbf,xyz,intcut,mprim,npp,pthr,P,basis)
      allocate(efact(npp),gama(npp),ee(3,npp),dd(35,npp),
     .         nnn(npp),indp(mprim,mprim))
      rewind(103)
      indp = 0
      do i=1,npp
         read(103)ind1,ind2,nnn(i),efact(i),gama(i),ee(1:3,i),dd(1:35,i)
         indp(ind1,ind2)=i
      enddo
      close(103,status='delete')

c     R space limits
      bordxy=6.0
      stepz=stepr*0.5 ! better resol in Z
      dx=maxval(xyz(1,1:n))-minval(xyz(1,1:n))+bordxy
      dy=maxval(xyz(2,1:n))-minval(xyz(2,1:n))+bordxy
      dz=maxval(xyz(3,1:n))+bord
      xx1=minval(xyz(1,1:n))-bordxy*0.5
      yy1=minval(xyz(2,1:n))-bordxy*0.5
      zz1=0
      m1=1+int(dx/stepr)
      m2=1+int(dy/stepr)
      m3=1+int(dz/stepz)
      np=m1*m2*m3
      write(*,'('' # xyz range:'',3f8.2)') dx,dy,dz
      write(*,'('' # points   :'',i8  )') np
      allocate(pa(3,np),espe(np))

cccccccccccccc
c R grid
cccccccccccccc
      l=0
      dx=xx1
      do i=1,m1
         dum(1)=dx
         dy=yy1
         do j=1,m2
            dum(2)=dy
            dz=zz1
            do k=1,m3
               dum(3)=dz
               l=l+1
               pa(1:3,l)=dum(1:3)
               dz=dz+stepz
            enddo
            dy=dy+stepr
         enddo
         dx=dx+stepr
      enddo

      write(*,*)'computing density ...'

!$OMP  PARALLEL PRIVATE(r,i,point)
!$OMP& SHARED(espe,pa)
!$OMP& DEFAULT(SHARED)
!$OMP DO
      do i=1,np
c     at point(3)
         point(1:3)=pa(1:3,i)
c     if(mod(i,np/10).eq.0.and.nproc.eq.1) write(*,*) 100*i/np,' % done'
c     ints and contraction with P
         call densints(n,nbf,xyz,intcut,point,pthr,P,
     .                 mprim,npp,nnn,indp,efact,gama,ee,dd,cut,r,basis)
         espe(i)=r ! prefacto
      enddo
!$OMP END DO
!$OMP END PARALLEL

c makes no sense because values not treated (flaged 99) ar in
c     av=0
c     do i=1,np
c        av=av+espe(i)
c     enddo
c     write(*,'('' maximum/minimum/av current value :'',2F12.6,F9.4)')
c    .          maxval(espe),minval(espe),av/np

      write(*,*)
     .' writing STM picture in xyz (Angstroem!) to file <stm.dat>'
c output in gnuplot format, constant current mode
      open(unit=42,file='stm.dat')
      l=0
      dx=xx1
      do i=1,m1
         dy=yy1
         do j=1,m2
            dz=zz1
            tmin=1.d+42
            zmin=0
            do k=1,m3
               l=l+1
               if(abs(espe(l)-targ).lt.tmin)then ! Z point closest to target current
                  tmin=abs(espe(l)-targ)
                  zmin=dz
               endif
               dz=dz+stepz
            enddo
            write(42,'(3F14.8)') dx*bohr,dy*bohr,zmin*bohr
            dy=dy+stepr
         enddo
         write(42,*)
         dx=dx+stepr
      enddo
      close(42)

      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c density routine in analogy to esp plot
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine densints(n,nbf,xyz,intcut,point,pthr,P,
     &                    mprim,npp,nnn,indp,efact,gama,ee,dd,cut,espe,
     &                    basis)
         use xtb_mctc_accuracy, only : wp
      use xtb_type_basisset
      use xtb_intpack
      use esp
      implicit none
      type(TBasisset), intent(in) :: basis
      integer n,nbf
      integer mprim,npp,indp(mprim,mprim),nnn(npp)
      real(wp) P (nbf*(nbf+1)/2)
      real(wp) xyz(3,n)
      real(wp) point(3)
      real(wp) efact(npp),gama(npp),ee(3,npp),dd(35,npp)
      real(wp) espe,intcut,pthr,cut

      integer i,j,k,l,iprimcount,jprimcount,ppp
      integer npri,nprj,ii,iii,jj,jjj,ll,m,li,lj,mm,nn
      real(wp) xyza(3),xyzb(3),rab,est,gam,arg
      real(wp) tt1,ttt,thr,cce,pthr2

c check if point is close to any atom and if yes dens is too high and exit
      do j=1,n
         rab=(xyz(1,j)-point(1))**2+(xyz(2,j)-point(2))**2
     .      +(xyz(3,j)-point(3))**2
         if(rab.lt.9.)then
            espe=99.
            return
         endif
      enddo

      pthr2=pthr*1.d-1
      espe=0

      k=0
      iprimcount=0
      do i=1,nbf
c aufpunkt i
         xyza(1:3)=xyz(1:3,basis%aoat(i))
c #prims
         npri=basis%nprim(i)
         jprimcount=0
         do j=1,i
            k=k+1
            nprj=basis%nprim(j)
            if(abs(P(k)).lt.pthr) goto 42   ! loose P mat neglect threshold
c aufpunkt j
              xyzb(1:3)=xyz(1:3,basis%aoat(j))
c prim loop
              tt1=0.0d0
              do ii=1,npri
                 iii=iprimcount+ii
                 do jj=1,nprj
                    jjj=jprimcount+jj
                    ppp=indp(iii,jjj)
c cutoff
                    if(ppp.gt.0)then
                    cce=basis%cont(iii)*basis%cont(jjj)*efact(ppp)*P(K)
                    if(abs(cce).gt.pthr2)then
                    call propa1(opac3,point,nnn(ppp),
     .                         gama(ppp),ee(1,ppp),dd(1,ppp),
     .                         ttt)
                    tt1=tt1+ttt*cce
                    endif
                    endif
                 enddo
              enddo
            espe=espe+tt1
            if(espe.gt.cut) return     ! value too large i.e. we're looking for constant I in space
                                       ! and dens is positive
 42         jprimcount=jprimcount+nprj
         enddo
         iprimcount=iprimcount+npri
      enddo

      end


      end module stm

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ========================================================================
!  *    WELCOME TO THE   C O N T R O L   &   I N P U T   MODULE IN XTB    *
!! ------------------------------------------------------------------------
!  I use a singleton pattern for our input parser to ensure that you cannot
!  override your input data, therefore it is strictly necessary to follow a
!  strict hierachy on input sources. We decided that command arguments have
!  the highest priority, than follows the various input files and finally a
!  global configuration file is read in. The program structure is set up in
!  exactly that way, so this module has to behave like a singleton. Fortran
!  provides the save keyword, which is used in each set subroutine for this
!  purpose.
!! ------------------------------------------------------------------------
!  The syntax is:
!> # logical instructions require a single statement
!> $fit
!> $samerand
!> # special logicals are chrg and spin
!> $chrg <int>
!> $spin <int>
!> # data instructons are opened by a keyword, which by default has no effect
!> $gfn
!>    version=<int>
!>    d4=<bool>
!> $scc
!>    temp=<real>
!>    broydamp=<real>
!> ...
!> $end # this is optional
!  unknown instructions are ignored and can be used to store additional info
!  that does not affect the outcome of the calculation
!
!  generally we distinguish between, ints, bools and reals. List's of arbitrary
!  combinations those can be archived by the `parse' subroutine from the MCTC lib.
!  Be carefully when reading arrays of unknown size, because you cannot backspace
!  on the input file. Multiline input is also not supported, but we have
!  arbitrary long lines to compensate for this.
!
!  To implement a new feature start by adding the variables to the header of
!  setparam.f90 (here), think about what you are doing, this module is integrated
!  in almost every important unit of xtb, so be careful when chosing variable
!  names (dum, nat, xyz and i usually bad ideas). You should use verbose names.
!
!  Next step is to define a default and add the printout in `write_set', add
!  the necessary information about the feature in the man page of `xcontrol'
!  and a short description in the manual. SERIOUSLY, do this first.
!  For all features that are incompatible with the singleton nature of `setparam'
!  use `constrain_param' and read the introduction there carefully.
!
!  Now you can add the necessary line in the `readflags' loop of `rdcontrol'
!  and define your own set subroutine here. If you add an option to an existing
!  instruction just add the case in the appropriate and set subroutine and
!  use a saved logical to guard it (I called them set<int>).
!
!  If you have any questions on this module, feel free to ask me or another dev
!  SAW: ehlert@thch.uni-bonn.de
!
module xtb_setmod
   use xtb_mctc_accuracy, only : wp

   use xtb_readin, only : mirror_line,getValue

   use xtb_setparam

   use xtb_type_environment, only : TEnvironment

   implicit none

   private :: wp,mirror_line,getValue

   character,private,parameter :: flag = '$'
   character,private,parameter :: colon = ':'
   character,private,parameter :: space = ' '
   character,private,parameter :: equal = '='
   character,private,parameter :: hash = '#'
   character,private,parameter :: dot = '.'
   character,private,parameter :: comma = ','
   character(len=*),private,parameter :: flag_end = flag//'end'

!  Using allocatable arrays of dynamic length strings is only possible
!  with a lot of hacks, so we use good'ol fixed size stack arrays.
!  Let's choose something different from 42 that is not dividable by 10... ;)
!  Happy debugging!
   integer,private,parameter :: p_str_length = 48
   integer,private,parameter :: p_arg_length = 24

   public

   abstract interface
      subroutine handlerInterface(env, key, val)
         import TEnvironment
         type(TEnvironment), intent(inout) :: env
         character(len=*), intent(in) :: key
         character(len=*), intent(in) :: val
      end subroutine handlerInterface
   end interface

contains

subroutine write_set(ictrl)

   implicit none

   integer,intent(in) :: ictrl

!  write the coord file, charge and spin information first
   write(ictrl,'(a,"chrg",1x,i0)') flag,set%ichrg
   write(ictrl,'(a,"spin",1x,i0)') flag,set%nalphabeta

!  was the fit-flag set?
   if (set%fit) write(ictrl,'(a,"fit")') flag
   if (set%samerand) write(ictrl,'(a,"samerand")') flag

   call write_set_gfn(ictrl)
   call write_set_scc(ictrl)
   call write_set_opt(ictrl)
   call write_set_thermo(ictrl)
   call write_set_md(ictrl)
   call write_set_siman(ictrl)
   call write_set_hess(ictrl)
   call write_set_gbsa(ictrl)
   call write_set_modef(ictrl)
   call write_set_cube(ictrl)
   call write_set_symmetry(ictrl)
   call write_set_embedding(ictrl)
   call write_set_write(ictrl)
   call write_set_external(ictrl)
   call write_set_stm(ictrl)
   call write_set_path(ictrl)
   call write_set_split(ictrl)
   call write_set_wall(ictrl)
   call write_set_fix(ictrl)
   call write_set_constrain(ictrl)
   call write_set_scan(ictrl)
   call write_set_metadyn(ictrl)
   call write_set_reactor(ictrl)

end subroutine write_set

!  write *all* informations contained in the setcommon to xcontrol
subroutine write_set_gfn(ictrl)
   use xtb_readin, only : bool2int,bool2string
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"gfn")') flag
   write(ictrl,'(3x,"method=",i0)') set%gfn_method
!   select case(gfn_method)
!   case(p_method_gfn0xtb); write(ictrl,'(3x,"method=gfn0-xtb")')
!   case(p_method_gfn1xtb); write(ictrl,'(3x,"method=gfn1-xtb")')
!   case(p_method_gfn2xtb); write(ictrl,'(3x,"method=gfn2-xtb")')
!   end select
   if (set%gfn_method.gt.2) &
      write(ictrl,'(3x,"d4=",a)') bool2string(set%newdisp)
   write(ictrl,'(3x,"scc=",a)') bool2string(set%solve_scc)
   write(ictrl,'(3x,"periodic=",a)') bool2string(set%periodic)
   write(ictrl,'(3x,"dispscale=",g0)') set%dispscale
end subroutine write_set_gfn

subroutine write_set_scc(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"scc")') flag
   write(ictrl,'(3x,"maxiterations=",i0)') set%maxscciter
   write(ictrl,'(3x,"temp=",g0)') set%eTemp
   write(ictrl,'(3x,"broydamp=",g0)') set%broydamp
end subroutine write_set_scc

subroutine write_set_opt(ictrl)
   use xtb_readin, only : bool2int,bool2string
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"opt")') flag
   if (allocated(set%opt_engine)) then
      write(ictrl,'(3x,"engine=")',advance='no')
      select case(set%opt_engine)
      case default;            write(ictrl,'("unknown")')
      case(p_engine_rf);       write(ictrl,'("rf")')
      case(p_engine_lbfgs);    write(ictrl,'("lbfgs")')
      case(p_engine_inertial); write(ictrl,'("inertial")')
      end select
   end if
   if (allocated(set%opt_outfile)) &
      write(ictrl,'(3x,"output=",a)')  set%opt_outfile
   if (allocated(set%opt_logfile)) &
      write(ictrl,'(3x,"logfile=",a)') set%opt_logfile
   write(ictrl,'(3x,"optlevel=",a)') int2optlevel(set%optset%optlev)
   write(ictrl,'(3x,"microcycle=",i0)') set%optset%micro_opt
   write(ictrl,'(3x,"maxcycle=",i0)') set%optset%maxoptcycle
   write(ictrl,'(3x,"maxdispl=",g0)') set%optset%maxdispl_opt
   write(ictrl,'(3x,"hlow=",g0)') set%optset%hlow_opt
   write(ictrl,'(3x,"hessian=")',advance='no')
   select case(set%mhset%model)
   case default;          write(ictrl,'("lindh-d2")')
   case(p_modh_read);     write(ictrl,'("read")')
   case(p_modh_unit);     write(ictrl,'("unit")')
   case(p_modh_old);      write(ictrl,'("old")')
   case(p_modh_lindh);    write(ictrl,'("lindh")')
   case(p_modh_lindh_d2); write(ictrl,'("lindh-d2")')
   case(p_modh_swart);    write(ictrl,'("swart")')
   end select
   write(ictrl,'(3x,"s6=",g0)') set%mhset%s6
   write(ictrl,'(3x,"kstretch=",g0)') set%mhset%kr
   write(ictrl,'(3x,"kbend   =",g0)') set%mhset%kf
   write(ictrl,'(3x,"ktorsion=",g0)') set%mhset%kt
   write(ictrl,'(3x,"koutofp =",g0)') set%mhset%ko
   write(ictrl,'(3x,"kvdw    =",g0)') set%mhset%kd
   write(ictrl,'(3x,"kes     =",g0)') set%mhset%kq
   write(ictrl,'(3x,"rcut    =",g0)') sqrt(set%mhset%rcut)
   write(ictrl,'(3x,"ts=",i0)') bool2int(set%tsopt)
   write(ictrl,'(3x,"tsroot=",i0)') set%tsroot
   write(ictrl,'(3x,"exact rf=",g0)') bool2string(set%optset%exact_rf)
   write(ictrl,'(3x,"average conv=",g0)') bool2string(set%optset%average_conv)
end subroutine write_set_opt

subroutine write_set_thermo(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   integer :: i
   write(ictrl,'(a,"thermo")') flag
   write(ictrl,'(3x,"temp=")',advance='no')
   ! now we print all but the last argument to avoid a trailing comma
   do i = 1, set%nthermo-1
      write(ictrl,'(g0,",")',advance='no') set%thermotemp(i)
   enddo
   write(ictrl,'(g0)') set%thermotemp(set%nthermo)
   write(ictrl,'(3x,"sthr=",g0)') set%thermo_sthr
   write(ictrl,'(3x,"imagthr=",g0)') set%thermo_ithr
   write(ictrl,'(3x,"scale=",g0)') set%thermo_fscal
end subroutine write_set_thermo

subroutine write_set_md(ictrl)
   use xtb_readin, only : bool2int,bool2string
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"md")') flag
   write(ictrl,'(3x,"temp=",g0)') set%temp_md
   write(ictrl,'(3x,"time=",g0)') set%time_md
   write(ictrl,'(3x,"dump=",g0)') set%dump_md2
   write(ictrl,'(3x,"velo=",i0)') bool2int(set%velodump)
   write(ictrl,'(3x,"nvt=",i0)') bool2int(set%nvt_md)
   write(ictrl,'(3x,"skip=",g0)') set%skip_md
   write(ictrl,'(3x,"step=",g0)') set%tstep_md
   write(ictrl,'(3x,"hmass=",i0)') set%md_hmass
   write(ictrl,'(3x,"shake=",i0)') set%shake_mode
   write(ictrl,'(3x,"sccacc=",g0)') set%accu_md
   write(ictrl,'(3x,"forcewrrestart=",i0)') bool2int(set%forcewrrestart)
end subroutine write_set_md

subroutine write_set_siman(ictrl)
   use xtb_readin, only : bool2int,bool2string
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"siman")') flag
   write(ictrl,'(3x,"dump=",g0)') set%dump_md
   write(ictrl,'(3x,"n=",i0)') set%ntemp_siman
   write(ictrl,'(3x,"ewin=",g0)') set%ewin_conf
   write(ictrl,'(3x,"temp=",g0)') set%Tend_siman
   write(ictrl,'(3x,"enan=",i0)') bool2int(set%enan_siman)
   write(ictrl,'(3x,"check=",i0)') bool2int(.not.set%check_rmsd)
end subroutine write_set_siman

subroutine write_set_hess(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"hess")') flag
   write(ictrl,'(3x,"sccacc=",g0)') set%accu_hess
   write(ictrl,'(3x,"step=",g0)') set%step_hess
   write(ictrl,'(3x,"scale=",g0)') set%scale_hess
end subroutine write_set_hess

subroutine write_set_gbsa(ictrl)
   use xtb_readin, only : bool2string
   use xtb_mctc_convert, only : autoaa
   implicit none
   integer,intent(in) :: ictrl
   if (len_trim(set%solvInput%solvent).gt.0 .and. set%solvInput%solvent.ne."none") then
      write(ictrl,'(a,"solvation")') flag
      if (allocated(set%solvInput%solvent)) write(ictrl,'(3x,"solvent=",a)') set%solvInput%solvent
      write(ictrl,'(3x,"ion_st=",g0)') set%solvInput%ionStrength
      write(ictrl,'(3x,"ion_rad=",g0)') set%solvInput%ionRad * autoaa
      write(ictrl,'(3x,"grid=")',advance='no')
      select case(set%solvInput%nAng)
      case(p_angsa_normal);   write(ictrl,'(a)') "normal"
      case(p_angsa_tight);    write(ictrl,'(a)') "tight"
      case(p_angsa_verytight);write(ictrl,'(a)') "verytight"
      case(p_angsa_extreme);  write(ictrl,'(a)') "extreme"
      case default;           write(ictrl,'(i0)') set%solvInput%nAng
      end select
      write(ictrl,'(3x,"alpb=",a)') bool2string(set%solvInput%alpb)
      select case(set%solvInput%kernel)
      case(gbKernel%still)
         write(ictrl,'(3x,"kernel=still")')
      case(gbKernel%p16)
         write(ictrl,'(3x,"kernel=p16")')
      end select
      write(ictrl,'(3x,"cosmo=",a)') bool2string(set%solvInput%cosmo)
   endif
end subroutine write_set_gbsa

subroutine write_set_modef(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"modef")') flag
   write(ictrl,'(3x,"n=",i0)') set%mode_nscan
   write(ictrl,'(3x,"step=",g0)') set%mode_step
   write(ictrl,'(3x,"updat=",g0)') set%mode_updat
   write(ictrl,'(3x,"local=",i0)') set%mode_local
   write(ictrl,'(3x,"vthr=",g0)') set%mode_vthr
   write(ictrl,'(3x,"prj=",g0)') set%mode_prj
   write(ictrl,'(3x,"mode=",g0)') set%mode_follow
end subroutine write_set_modef

subroutine write_set_cube(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"cube")') flag
   write(ictrl,'(3x,"step=",g0)') set%cube_step
   write(ictrl,'(3x,"pthr=",g0)') set%cube_pthr
end subroutine write_set_cube

subroutine write_set_symmetry(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"symmetry")') flag
   write(ictrl,'(3x,"desy=",g0)') set%desy
   write(ictrl,'(3x,"maxat=",i0)') set%maxatdesy
end subroutine write_set_symmetry

subroutine write_set_embedding(ictrl)
   use xtb_readin, only : bool2int,bool2string
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"embedding")') flag
   write(ictrl,'(3x,"at=",i0)')  set%pcem_dummyatom
   write(ictrl,'(3x,"es=",a)')   bool2string(set%pcem_l_es)
   !write(ictrl,'(3x,"aes=",a)')  bool2string(pcem_l_aes)
   !write(ictrl,'(3x,"disp=",a)') bool2string(pcem_l_disp)
   !write(ictrl,'(3x,"dipm=",a)') bool2string(pcem_l_dipm)
   !write(ictrl,'(3x,"qp=",a)')   bool2string(pcem_l_qp)
   !write(ictrl,'(3x,"cn=",a)')   bool2string(pcem_l_cn)
   !write(ictrl,'(3x,"atm=",a)')  bool2string(pcem_l_atm)
end subroutine write_set_embedding

subroutine write_set_write(ictrl)
   use xtb_readin, only : bool2int,bool2string
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"write")') flag
   if (allocated(set%property_file)) &
   write(ictrl,'(3x,"output file=",a)')      set%property_file
   write(ictrl,'(3x,"esp=",a)')              bool2string(set%pr_esp)
   if (allocated(set%esp_gridfile)) write(ictrl,'(3x,"gridfile=",a)')         set%esp_gridfile
   write(ictrl,'(3x,"mos=",a)')              bool2string(set%pr_molden_input)
   write(ictrl,'(3x,"gbw=",a)')              bool2string(set%pr_gbw)
   write(ictrl,'(3x,"tm mos=",a)')           bool2string(set%pr_tmmos)
   write(ictrl,'(3x,"tm basis=",a)')         bool2string(set%pr_tmbas)
   write(ictrl,'(3x,"lmo=",a)')              bool2string(set%pr_lmo)
   write(ictrl,'(3x,"density=",a)')          bool2string(set%pr_density)
   write(ictrl,'(3x,"spin population=",a)')  bool2string(set%pr_spin_population)
   write(ictrl,'(3x,"spin density=",a)')     bool2string(set%pr_spin_density)
   write(ictrl,'(3x,"fod=",a)')              bool2string(set%pr_fod)
   write(ictrl,'(3x,"fod population=",a)')   bool2string(set%pr_fod_pop)
   write(ictrl,'(3x,"wiberg=",a)')           bool2string(set%pr_wiberg)
   write(ictrl,'(3x,"wbo fragments=",a)')    bool2string(set%pr_wbofrag)
   write(ictrl,'(3x,"dipole=",a)')           bool2string(set%pr_dipole)
   write(ictrl,'(3x,"charges=",a)')          bool2string(set%pr_charges)
   write(ictrl,'(3x,"mulliken=",a)')         bool2string(set%pr_mulliken)
   write(ictrl,'(3x,"orbital energies=",a)') bool2string(set%pr_eig)
   write(ictrl,'(3x,"inertia=",a)')          bool2string(set%pr_moments)
   write(ictrl,'(3x,"distances=",a)')        bool2string(set%pr_distances)
   write(ictrl,'(3x,"angles=",a)')           bool2string(set%pr_angles)
   write(ictrl,'(3x,"torsions=",a)')         bool2string(set%pr_torsions)
   write(ictrl,'(3x,"final struct=",a)')     bool2string(set%pr_finalstruct)
   write(ictrl,'(3x,"geosum=",a)')           bool2string(set%pr_geosum)
   write(ictrl,'(3x,"stm=",a)')              bool2string(set%pr_stm)
   write(ictrl,'(3x,"modef=",a)')            bool2string(set%pr_modef)
   write(ictrl,'(3x,"gbsa=",a)')             bool2string(set%pr_gbsa)
   write(ictrl,'(3x,"vib_normal_modes=",a)') bool2string(set%pr_nmtm)
   write(ictrl,'(3x,"hessian.out=",a)')      bool2string(set%pr_dftbp_hessian_out)
end subroutine write_set_write

subroutine write_set_external(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   write(ictrl,'(a,"external")') flag
   if (allocated(set%ext_orca%path))          &
      write(ictrl,'(3x,"orca bin=",a)')        set%ext_orca%executable
   if (allocated(set%ext_orca%input_string))  &
      write(ictrl,'(3x,"orca input line=",a)') set%ext_orca%input_string
   if (allocated(set%ext_orca%input_file))    &
      write(ictrl,'(3x,"orca input file=",a)') set%ext_orca%input_file
   if (allocated(set%ext_mopac%path))         &
      write(ictrl,'(3x,"mopac bin=",a)')       set%ext_mopac%executable
   if (allocated(set%ext_mopac%input_string)) &
      write(ictrl,'(3x,"mopac input=",a)')     set%ext_mopac%input_string
   if (allocated(set%ext_mopac%input_file))   &
      write(ictrl,'(3x,"mopac file=",a)')      set%ext_mopac%input_file
   if (allocated(set%ext_turbo%path))         &
      write(ictrl,'(3x,"turbodir=",a)')        set%ext_turbo%path
end subroutine write_set_external

subroutine write_set_stm(ictrl)
   implicit none
   integer,intent(in) :: ictrl
   if (.not.set%pr_stm) return
   write(ictrl,'(a,"stm")') flag
   write(ictrl,'(3x,"broadening=",g0,1x,"#",1x,a)') set%stm_alp,"in eV"
   write(ictrl,'(3x,"current=",g0,1x,"#")')         set%stm_targ
   write(ictrl,'(3x,"grid=",g0,1x,"#",1x,a)')       set%stm_grid,"in au"
   write(ictrl,'(3x,"thr=",g0)')                    set%stm_thr
   write(ictrl,'(3x,"potential=",g0,1x,"#",1x,a)')  set%stm_pot,"in V"
end subroutine write_set_stm

subroutine write_set_path(ictrl)
   use xtb_type_atomlist
   implicit none
   integer,intent(in) :: ictrl
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer :: i
   write(ictrl,'(a,"path")') flag
   write(ictrl,'(3x,"nrun=",i0)')  set%pathset%nrun
   write(ictrl,'(3x,"npoint=",i0)')  set%pathset%nopt
   write(ictrl,'(3x,"anopt=",i0)') set%pathset%anopt
   write(ictrl,'(3x,"kpush=",g0)') set%pathset%kpush
   write(ictrl,'(3x,"kpull=",g0)') set%pathset%kpull
   write(ictrl,'(3x,"ppull=",g0)') set%pathset%ppull
   write(ictrl,'(3x,"alp=",g0)')   set%pathset%alp
   if (allocated(set%pathset%fname)) &
      write(ictrl,'(3x,"product=",a)') set%pathset%fname
   if (set%pathset%nat > 0) then
      call atl%new(set%pathset%atoms(:set%pathset%nat))
      call atl%to_string(string)
      write(ictrl,'(3x,"atoms:",1x,a)') string
   endif

end subroutine write_set_path

subroutine write_set_reactor(ictrl)
   use xtb_type_atomlist
   implicit none
   integer,intent(in) :: ictrl
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer :: i
   write(ictrl,'(a,"reactor")') flag
   write(ictrl,'(3x,"max=",i0)')     set%reactset%nmax
   write(ictrl,'(3x,"density=",g0,1x,"# in kg/L")') &
                                     set%reactset%dens
   write(ictrl,'(3x,"kpush=",g0)')   set%reactset%kpush
   write(ictrl,'(3x,"alp=",g0)')     set%reactset%alp
   if (set%reactset%nat > 0) then
      call atl%new(set%reactset%atoms(:set%reactset%nat))
      call atl%to_string(string)
      write(ictrl,'(3x,"atoms:",1x,a)') string
   endif
end subroutine write_set_reactor


subroutine write_set_constrain(ictrl)
   use xtb_scanparam
   use xtb_splitparam
   use xtb_mctc_convert, only : autoaa
   use xtb_mctc_constants, only : pi
   implicit none
   integer, intent(in) :: ictrl
   integer :: i,idum
   if (nconstr.eq.0) return

   write(ictrl,'(a,"constrain")') flag
   write(ictrl,'(3x,"force constant=",g0)') fcconstr
   do i = 1, nconstr
      ! instead of simply saving the kind of constraint while reading,
      ! we used some really obvious integer code system depending on
      ! the number of elements in the atconstr-Array.
      ! Expected to break at some point, add a FIXME and wait for complaints...
      idum = atconstr(1,i)
      if (atconstr(2,i).gt.0) idum = 1
      if (atconstr(3,i).gt.0) idum = 2
      if (atconstr(4,i).gt.0) idum = 3
      select case(idum)
      case default ! this is bad, we don't want this to happen
         call raise('E','This is an internal error, please report this!')
      case(-2)
         write(ictrl,'(3x,"center:",1x,g0,1x,i0,1x,"# force constant")') &
            valconstr(i),iatf1
      case(-1)
         write(ictrl,'(3x,"z:",1x,g0,1x,"# in Ångström")') &
            valconstr(i)*autoaa
      case(0)
         write(ictrl,'(3x,"cma:",1x,g0,1x,"# in Ångström")') &
            valconstr(i)*autoaa
      case(1)
         write(ictrl,'(3x,"distance:",1x,2(i0,",",1x),g0,1x,"# in Ångström")') &
            atconstr(1,i),atconstr(2,i),valconstr(i)*autoaa
      case(2)
         write(ictrl,'(3x,"angle:",1x,3(i0,",",1x),g0,1x,"# in Degree")') &
            atconstr(1,i),atconstr(2,i),atconstr(3,i),valconstr(i)*180.0_wp/pi
      case(3)
         write(ictrl,'(3x,"dihedral:",1x,4(i0,",",1x),g0,1x,"# in Degree")') &
            atconstr(1,i),atconstr(2,i),atconstr(3,i),atconstr(4,i), &
            valconstr(i)*180.0_wp/pi
      end select
   enddo

end subroutine write_set_constrain

subroutine write_set_scan(ictrl)
   use xtb_scanparam
   use xtb_mctc_convert, only : autoaa
   use xtb_mctc_constants, only : pi
   implicit none
   integer, intent(in) :: ictrl
   integer :: i,idum
   if (nscan.eq.0) return

   write(ictrl,'(a,"scan")') flag
   select case(scan_mode)
   case default ! this should never happen...
      call raise('E','This is an internal error, please report this!')
   case(p_scan_sequential)
      write(ictrl,'(3x,"mode=sequential")')
   case(p_scan_concerted)
      write(ictrl,'(3x,"mode=concerted")')
   end select
   do i = 1, nscan
      ! instead of simply saving the kind of constraint while reading,
      ! we used some really obvious integer code system depending on
      ! the number of elements in the atconstr-Array.
      ! Expected to break at some point, add a FIXME and wait for complaints...
      idum = atconstr(1,i)
      if (atconstr(2,i).gt.0) idum = 1
      if (atconstr(3,i).gt.0) idum = 2
      if (atconstr(4,i).gt.0) idum = 3
      if (idum.le.1) then
         write(ictrl,'(3x,i0,":",1x,2(g0,",",1x),i0,1x,"# in Ångström")') &
            scan_list(i)%iconstr,scan_list(i)%valscan(1)*autoaa, &
            scan_list(i)%valscan(scan_list(i)%nscan)*autoaa,scan_list(i)%nscan
      else
         write(ictrl,'(3x,i0,":",1x,2(g0,",",1x),i0,1x,"# in Degree")') &
            scan_list(i)%iconstr,scan_list(i)%valscan(1)*180.0_wp/pi, &
            scan_list(i)%valscan(scan_list(i)%nscan)*180.0_wp/pi,scan_list(i)%nscan
      endif
   enddo

end subroutine write_set_scan

subroutine write_set_fix(ictrl)
   use xtb_type_atomlist
   use xtb_fixparam
   implicit none
   integer, intent(in) :: ictrl
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer :: i
   if (fixset%n.eq.0 .and. freezeset%n.eq.0) return

   write(ictrl,'(a,"fix")') flag
   if (fixset%n > 0) then
      call atl%new(fixset%atoms(:fixset%n))
      call atl%to_string(string)
      write(ictrl,'(3x,"atoms:",1x,a)') string
   endif

   write(ictrl,'(3x,"freeze frequency=",g0,1x,"# in atomic units")') freezeset%fc
   if (freezeset%n > 0) then
      call atl%new(freezeset%atoms(:freezeset%n))
      call atl%to_string(string)
      write(ictrl,'(3x,"freeze:",1x,a)') string
   endif

end subroutine write_set_fix

subroutine write_set_split(ictrl)
   use xtb_type_atomlist
   use xtb_splitparam
   implicit none
   integer, intent(in) :: ictrl
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer :: i
   if ((iatf1.eq.0).and.(iatf2.eq.0)) return

   write(ictrl,'(a,"split")') flag
   do i = 1, maxval(splitlist)
      call atl%new
      call atl%add(splitlist.eq.i)
      call atl%to_string(string)
      write(ictrl,'(3x,"fragment:",1x,i0,",",a)') i, string
   enddo

end subroutine write_set_split

subroutine write_set_wall(ictrl)
   use xtb_sphereparam
   implicit none
   integer, intent(in) :: ictrl
   integer :: i,j,nlist

   write(ictrl,'(a,"wall")') flag
   write(ictrl,'(3x,"potential=")',advance='no')
   if (spherepot_type.eq.p_type_polynomial) then
      write(ictrl,'(a)') 'polynomial'
   else
      write(ictrl,'(a)') 'logfermi'
   endif
   write(ictrl,'(3x,"alpha=",i0)') sphere_alpha
   write(ictrl,'(3x,"beta=",g0)') sphere_beta
   write(ictrl,'(3x,"temp=",g0)') sphere_temp
   write(ictrl,'(3x,"autoscale=",g0)') sphere_autoscale
   write(ictrl,'(3x,"axisshift=",g0)') sphere_shift

   if (number_walls.eq.0) return

   do i = 1, number_walls
      if (all(abs(wpot(i)%radius-wpot(i)%radius(1)).lt.1e-6_wp)) then
         write(ictrl,'(3x,"sphere:",1x,g0,",",1x)',advance='no') &
            wpot(i)%radius(1)
      else
         write(ictrl,'(3x,"ellipsoid:",1x,3(g0,",",1x))',advance='no') &
            wpot(i)%radius
      endif
      if (allocated(wpot(i)%list)) then
         nlist = size(wpot(i)%list,1)
         do j = 1, nlist-1
            write(ictrl,'(i0,",",1x)',advance='no') wpot(i)%list(j)
         enddo
         write(ictrl,'(i0,1x,"# radius in Bohr")') wpot(i)%list(nlist)
      else
         write(ictrl,'("all # radius in Bohr")')
      endif
   enddo

end subroutine write_set_wall

subroutine write_set_metadyn(ictrl)
   use xtb_type_atomlist
   use xtb_fixparam
   implicit none
   integer, intent(in) :: ictrl
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer :: i

   if (metaset%maxsave.eq.0) return

   write(ictrl,'(a,"metadyn")') flag
   write(ictrl,'(3x,"save=",i0)')   metaset%maxsave
   write(ictrl,'(3x,"factor=",1x,g0)') metaset%global_factor
   if (any((metaset%factor - metaset%global_factor).ne.0.0_wp)) then
      do i = 1, metaset%maxsave
         if ((metaset%factor(i) - metaset%global_factor).ne.0.0_wp) then
            write(ictrl,'(3x,"modify factor:",1x,i0,",",1x,g0)') &
               i,metaset%factor(i)
         endif
      enddo
   endif
   if (allocated(metaset%fname)) write(ictrl,'(3x,"coord=",a)') metaset%fname
   if (metaset%nat > 0) then
      call atl%new(metaset%atoms(:metaset%nat))
      call atl%to_string(string)
      write(ictrl,'(3x,"atoms:",1x,a)') string
   endif

end subroutine write_set_metadyn

subroutine open_set(ictrl,fname)
   use xtb_mctc_timings, only : prtimestring
   implicit none
   integer,intent(out) :: ictrl
   character(len=*),intent(in) :: fname
   character(len=:),allocatable :: buffer
   logical :: exist
   integer :: i

   call open_file(ictrl,fname,'w')

!  write the command line which has called this program
   call get_command(length=i)
   allocate(character(len=i) :: buffer)
   call get_command(buffer)
   write(ictrl,'(a,"cmd",x,a)') flag,buffer

!  write the date when this program was started, use timings for this job
   write(ictrl,'(a,"date",x,a)') flag,prtimestring('S')

end subroutine open_set

subroutine close_set(ictrl)
   integer,intent(in) :: ictrl
   write(ictrl,'("'//flag_end//'")')
   call close_file(ictrl)
end subroutine close_set

!> Read xcontrol file
subroutine rdcontrol(fname,env,copy_file)
   
   use xtb_readin, only : find_new_name
   use xtb_splitparam,  only : maxfrag
   use xtb_scanparam,   only : maxconstr,maxscan
   use xtb_sphereparam, only : maxwalls
   implicit none
   
   character(len=*), parameter :: source = 'set_rdcontrol'
   character(len=*),intent(in)  :: fname
   type(TEnvironment), intent(inout) :: env
   logical,intent(in),optional  :: copy_file
   
   character(len=:),allocatable :: line
   character(len=:),allocatable :: key
   character(len=:),allocatable :: val
   character(len=:),allocatable :: newname
   integer :: i
   integer :: id
   integer :: ic
   integer :: ie
   integer :: ncount
   integer :: copy
   integer :: err
   logical :: exist
   logical :: do_copy
   logical :: exitRun

   if (present(copy_file)) then
      !! in case of "--copy" command line argument
      do_copy=copy_file
   else
      do_copy=.false.
   endif

   call open_file(id,fname,'r')
   if (id.eq.-1) then
      call env%warning("could not find '"//fname//"'", source)
      return
   endif

   if (do_copy) then
      newname = find_new_name(fname)
         !!  newname = #1.fname
!     newunit would be nice to have here, but it would always open to a
!     negative number, currently I'm checking for a negative number in
!     in mirror_line to avoid copying to another unit, so I go with unit 41
      call open_file(copy,newname,'w')
   else
      copy = -1 
         !! deactivate copy in mirror_line
   endif


!  read first line before the readloop starts, I have to do this
!  to avoid using backspace on id (dammit Turbomole format)
   call mirror_line(id,copy,line,err)
      !! to read a line id-unit, and copy it to copy-unit
   readflags: do
      !! check if there is a $ in the *first* column
      if (index(line,flag).eq.1) then
         select case(line(2:))
         !> logical
         case('fit'     ); call set_fit;      call mirror_line(id,copy,line,err)
         case('derived'     ); call set_derived;      call mirror_line(id,copy,line,err)
         case('samerand'); call set_samerand; call mirror_line(id,copy,line,err)
         case('cma'     ); call set_cma;      call mirror_line(id,copy,line,err)
         !> data
         case('cube'     ); call rdblock(env,set_cube,    line,id,copy,err,ncount)
         case('write'    ); call rdblock(env,set_write,   line,id,copy,err,ncount)
         case('gfn'      ); call rdblock(env,set_gfn,     line,id,copy,err,ncount)
         case('scc'      ); call rdblock(env,set_scc,     line,id,copy,err,ncount)
         case('oniom'    ); call rdblock(env,set_oniom,    line,id,copy,err,ncount)
         case('opt'      ); call rdblock(env,set_opt,     line,id,copy,err,ncount)
         case('hess'     ); call rdblock(env,set_hess,    line,id,copy,err,ncount)
         case('md'       ); call rdblock(env,set_md,      line,id,copy,err,ncount)
         case('siman'    ); call rdblock(env,set_siman,   line,id,copy,err,ncount)
         case('modef'    ); call rdblock(env,set_modef,   line,id,copy,err,ncount)
         case('gbsa'     ); call rdblock(env,set_gbsa,    line,id,copy,err,ncount)
         case('solvation'); call rdblock(env,set_gbsa,    line,id,copy,err,ncount)
         case('embedding'); call rdblock(env,set_pcem,    line,id,copy,err,ncount)
         case('thermo'   ); call rdblock(env,set_thermo,  line,id,copy,err,ncount)
         case('external' ); call rdblock(env,set_external,line,id,copy,err,ncount)
         case('symmetry' ); call rdblock(env,set_symmetry,line,id,copy,err,ncount)
         case('metadyn'  ); call rdblock(env,set_metadyn, line,id,copy,err,ncount)
         case('path'     ); call rdblock(env,set_path,    line,id,copy,err,ncount)
         case('reactor'  ); call rdblock(env,set_reactor, line,id,copy,err,ncount)
         case('stm'      ); call rdblock(env,set_stm,     line,id,copy,err,ncount)
         !> data + user data which is read later, but we start counting here
         case('fix'      ); call rdblock(env,set_fix,     line,id,copy,err,ncount)
         case('wall'     ); call rdblock(env,set_wall,    line,id,copy,err,ncount)
                            maxwalls = maxwalls + ncount
         case('scan'     ); call rdblock(env,set_scan,    line,id,copy,err,ncount)
                            maxscan = maxscan + ncount
                            maxconstr = maxconstr + ncount ! better save than sorry
         case('constrain'); call rdblock(env,set_constr,  line,id,copy,err,ncount)
                            maxconstr = maxconstr + ncount
         case('split'    ); call rdblock(env,set_split,   line,id,copy,err,ncount)
                            maxfrag = maxfrag + ncount
         !> legacy
         case('set'      ); call rdsetbl(env,set_legacy,line,id,copy,err)
         
         ! unknown keyword -> ignore, we don't raise them !
         ! except for chrg and spin which you actually can set here !
         ! read them here because select case might not catch them that easy !
         case default 
            if (index(line(2:),'chrg').eq.1) call set_chrg(env,line(7:))
            if (index(line(2:),'spin').eq.1) call set_spin(env,line(7:))
            
            ! get a new line !
            call mirror_line(id,copy,line,err)
         end select
      
      ! not a keyword -> ignore !
      else 
         call mirror_line(id,copy,line,err)
      endif
      
      ! check for end of file (= $end)
      if (is_iostat_end(err)) exit readflags
!     if (index(line,flag_end).ne.0) exit readflags ! compatibility reasons
      call env%check(exitRun)
      if (exitRun) then
         call env%error("processing of data group failed", source)
         exit
      end if

   enddo readflags

   if (do_copy) call close_file(copy)
   call close_file(id)

end subroutine rdcontrol

subroutine rdsetbl(env,handler,line,id,copy,err)
   implicit none
   character(len=*), parameter :: source = 'set_rdsetbl'
   type(TEnvironment), intent(inout) :: env
   integer,intent(in) :: id
   integer,intent(in) :: copy
   procedure(handlerInterface) :: handler
   integer,intent(out) :: err
   character(len=:),allocatable,intent(out) :: line
   character(len=:),allocatable :: key
   character(len=:),allocatable :: val
   integer :: ie
   logical :: exitRun
   call env%warning('Set-blocks will become obsolete in xtb 6.0 and newer', source)
   do
      call mirror_line(id,copy,line,err)
      if (is_iostat_end(err)) exit
      if (index(line,flag).ne.0) exit

      ! find the first space
      ie = index(line,space)
      if ((line.eq.'').or.(ie.eq.0)) cycle
      key = trim(line(:ie-1))
      val = trim(adjustl(line(ie+1:)))
      call handler(env,key,val)
      call env%check(exitRun)
      
      if (exitRun) then
         call env%error("handler could not process input", source)
         return
      end if

   enddo

end subroutine rdsetbl

!> to read blocks of certain instruction ($)
!> in other words options of certain flag
subroutine rdblock(env,handler,line,id,copy,err,ncount)
   
   implicit none
   type(TEnvironment), intent(inout) :: env
   procedure(handlerInterface) :: handler
   integer,intent(in) :: id
   integer,intent(in) :: copy
   integer,intent(out) :: err
   integer,intent(out) :: ncount
   character(len=:),allocatable,intent(out) :: line
   
   character(len=*), parameter :: source = 'set_rdblock'
   character(len=:),allocatable :: key
   character(len=:),allocatable :: val
   integer :: ie
   logical :: exitRun
   
   ncount = 0
   do
      call mirror_line(id,copy,line,err)
      
      if (is_iostat_end(err)) return      ! check if EOF !
      if (index(line,flag).ne.0) return   ! check if new flag !
      
      ie = index(line,equal)              ! find the equal sign !
      if (line.eq.'') cycle               ! skip empty lines !
      ncount = ncount + 1                 ! but count non-empty lines first !
      
      if (ie.eq.0) cycle
      
      key = trim(line(:ie-1))
      val = trim(adjustl(line(ie+1:)))
      
      call handler(env,key,val)
      call env%check(exitRun)
      
      if (exitRun) then
         call env%error("handler could not process input", source)
         return
      end if
   
   enddo

end subroutine rdblock

subroutine set_exttyp(typ)
   implicit none
   character(len=*),intent(in) :: typ
   logical,save :: set1 = .true.
   if (.not.set1) return
   select case(typ)
   case default ! do nothing !
      call raise('S',typ//' is no valid exttyp (internal error)')

   case('vtb')
      set%mode_extrun = p_ext_vtb
   case('eht')
      set%mode_extrun = p_ext_eht
   case('xtb')
      set%mode_extrun = p_ext_xtb
   case('tblite')
      set%mode_extrun = p_ext_tblite
   case('orca')
      set%mode_extrun = p_ext_orca
   case('driver')
      set%mode_extrun = p_ext_driver
   case('oniom')
      set%mode_extrun = p_ext_oniom
   case('turbomole')
      set%mode_extrun = p_ext_turbomole
      set%extcode = 1
      set%extmode = 1
   case('mopac')
      set%mode_extrun = p_ext_mopac
   case('ff')
      set%mode_extrun = p_ext_gfnff
   case('iff')
      set%mode_extrun = p_ext_iff
   end select
   set1 = .false.

end subroutine set_exttyp

subroutine set_geopref(typ)
   implicit none
   character(len=*),intent(in) :: typ
   logical,save :: set1 = .true.
   if (.not.set1) return
   select case(typ)
   case default ! do nothing !
      call raise('S',typ//' is no valid geometry format (internal error)')

   case('sdf')
      set%geometry_inputfile = p_geo_sdf

   case('xmol','xyz')
      set%geometry_inputfile = p_geo_xmol

   case('coord','tm','turbomole')
      set%geometry_inputfile = p_geo_coord

   case('vasp','poscar')
      set%geometry_inputfile = p_geo_poscar
   end select
   set1 = .false.
end subroutine set_geopref

subroutine set_runtyp(typ)
   implicit none
   character(len=*),intent(in) :: typ
   logical,save :: set1 = .true.
   if (.not.set1) then
      call raise('S','Runtyp already set and locked, please use a composite runtyp instead.')
      return
   endif
   select case(typ)
   case default ! do nothing !
      call raise('E',typ//' is no valid runtyp (internal error)')

   case('scc')
      set%runtyp = p_run_scc

   case('grad')
      set%runtyp = p_run_grad
   case('opt')
      set%runtyp = p_run_opt

   case('hess')
      set%runtyp = p_run_hess
   case('ohess')
      set%runtyp = p_run_ohess
   case('bhess')
      set%runtyp = p_run_bhess

   case('md')
      set%runtyp = p_run_md
   case('omd')
      set%runtyp = p_run_omd

   case('path')
      set%runtyp = p_run_path

   case('screen')
      set%runtyp = p_run_screen

   case('modef')
      set%runtyp = p_run_modef

   case('mdopt')
      set%runtyp = p_run_mdopt

   case('metaopt')
      set%runtyp = p_run_metaopt

   case('vip')
      set%runtyp = p_run_vip
   case('vea')
      set%runtyp = p_run_vea
   case('vipea')
      set%runtyp = p_run_vipea
   case('vomega')
      set%runtyp = p_run_vomega
   case('vfukui')
      set%runtyp = p_run_vfukui
   end select
   set1 = .false.
end subroutine set_runtyp

subroutine set_derived
   implicit none
   set%oniom_settings%derived = .true.
end subroutine set_derived

subroutine set_fit
   implicit none
   set%fit = .true.
end subroutine set_fit

subroutine set_cma
   implicit none
   set%do_cma_trafo = .true.
end subroutine set_cma

subroutine set_enso_mode
   implicit none
   set%enso_mode = .true.
end subroutine set_enso_mode

subroutine set_samerand
   implicit none
   set%samerand = .true.
end subroutine set_samerand

subroutine set_define
   implicit none
   set%define = .true.
end subroutine set_define

!-----------------------------------
! Just cut molecule in ONIOM rotuine
!-----------------------------------
subroutine set_cut
   implicit none
   set%oniom_settings%cut_inner = .true.
end subroutine set_cut


!> charge initialization
!> Priority: cml -> xcontrol -> .CHRG
subroutine set_chrg(env,val)

   implicit none
   
   !> name of error producer routine
   character(len=*), parameter :: source = 'set_chrg'
   
   !> calculation environment 
   type(TEnvironment), intent(inout) :: env
   
   !> charge value
   character(len=*),intent(in) :: val
   
   integer  :: err
   integer  :: idum
   integer  :: ind, idum1, idum2
   logical,save :: set1 = .true.
   

   if (set1) then

      set%clichrg = .true.
      ind = index(val,":")
      
      ! oniom inner:outer !
      if (ind.ne.0) then
         if (getValue(env,val(:ind-1),idum1) .and. &
            & getValue(env,val(ind+1:),idum2)) then
            set%oniom_settings%fixed_chrgs = .true.
            set%oniom_settings%innerchrg = idum1
            set%ichrg = idum2
         else
            call env%error('Charge could not be read from your argument',source)
         endif
      
      ! conventional !
      else
         
         ! char into int !
         if (getValue(env,val,idum)) then
            set%ichrg = idum
         else
            call env%error('Charge could not be read from your argument',source)
         endif
         
     
      endif
   endif

   set1 = .false.

end subroutine set_chrg

subroutine set_spin(env,val)
   implicit none
   character(len=*), parameter :: source = 'set_spin'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   logical,save :: set1 = .true.
   if (set1) then
      if (getValue(env,val,idum)) then
         set%nalphabeta = idum
      else
         call env%error('Spin could not be read from your argument',source)
      endif
   endif
   set1 = .false.
end subroutine set_spin


subroutine set_efield(env, val)
   use xtb_gfnff_param, only : efield
   implicit none
   character(len=*), parameter :: source = 'set_efield'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   integer  :: err
   real(wp) :: idum(3)
   logical,save :: set1 = .true.
   if (set1) then
      if (getValue(env,val,idum)) then
         efield = idum
      else
         call env%error('E-field could not be read from your argument', source)
      endif
   endif
   set1 = .false.
end subroutine set_efield


subroutine set_write(env,key,val)
   !Purpose: set global parameter for writeouts
   implicit none
   character(len=*), parameter :: source = 'set_write'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1  = .true.
   logical,save :: set2  = .true.
   logical,save :: set3  = .true.
   logical,save :: set4  = .true.
   logical,save :: set5  = .true.
   logical,save :: set6  = .true.
   logical,save :: set7  = .true.
   logical,save :: set8  = .true.
   logical,save :: set9  = .true.
   logical,save :: set10 = .true.
   logical,save :: set11 = .true.
   logical,save :: set12 = .true.
   logical,save :: set13 = .true.
   logical,save :: set14 = .true.
   logical,save :: set15 = .true.
   logical,save :: set16 = .true.
   logical,save :: set17 = .true.
   logical,save :: set18 = .true.
   logical,save :: set19 = .true.
   logical,save :: set20 = .true.
   logical,save :: set21 = .true.
   logical,save :: set22 = .true.
   logical,save :: set23 = .true.
   logical,save :: set24 = .true.
   logical,save :: set25 = .true.
   logical,save :: set26 = .true.
   logical,save :: set27 = .true.
   logical,save :: set28 = .true.
   logical,save :: set29 = .true.
   logical,save :: set30 = .true.
   logical,save :: set31 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by write",source)
   case('esp')
      if (getValue(env,val,ldum).and.set1)  set%pr_esp = ldum
      set1 = .false.
   case('mos')
      if (getValue(env,val,ldum).and.set2)  set%pr_molden_input = ldum
      set2 = .false.
   case('lmo')
      if (getValue(env,val,ldum).and.set3)  set%pr_lmo = ldum
      set3 = .false.
   case('density')
      if (getValue(env,val,ldum).and.set4)  set%pr_density = ldum
      set4 = .false.
   case('spin population')
      if (getValue(env,val,ldum).and.set5)  set%pr_spin_population = ldum
      set5 = .false.
   case('spin density')
      if (getValue(env,val,ldum).and.set6)  set%pr_spin_density = ldum
      set6 = .false.
   case('fod')
      if (getValue(env,val,ldum).and.set7) then
         set%pr_fod = ldum
         set%pr_fod_pop = ldum
      endif
      set7 = .false.
   case('wiberg')
      if (getValue(env,val,ldum).and.set8)  set%pr_wiberg = ldum
      set8 = .false.
   case('dipole')
      if (getValue(env,val,ldum).and.set9)  set%pr_dipole = ldum
      set9 = .false.
   case('charges')
      if (getValue(env,val,ldum).and.set10) set%pr_charges = ldum
      set10 = .false.
   case('mulliken')
      if (getValue(env,val,ldum).and.set11) set%pr_mulliken = ldum
      set11 = .false.
   case('orbital energies')
      if (getValue(env,val,ldum).and.set12) set%pr_eig = ldum
      set12 = .false.
   case('gridfile', 'grid file')
       if (set13) set%esp_gridfile = val
      set13 = .false.
   case('stm')
      if (getValue(env,val,ldum).and.set14) set%pr_stm = ldum
      set14 = .false.
   case('gbw')
      if (getValue(env,val,ldum).and.set15) set%pr_gbw = ldum
      set15 = .false.
   case('tm mos')
      if (getValue(env,val,ldum).and.set16) set%pr_tmmos = ldum
      set16 = .false.
   case('tm basis')
      if (getValue(env,val,ldum).and.set17) set%pr_tmbas = ldum
      set17 = .false.
   case('json')
      if (getValue(env,val,ldum).and.set18) set%pr_json = ldum
      set18 = .false.
   case('distances')
      if (getValue(env,val,ldum).and.set19) set%pr_distances = ldum
      set19 = .false.
   case('angles')
      if (getValue(env,val,ldum).and.set20) set%pr_angles = ldum
      set20 = .false.
   case('torsions')
      if (getValue(env,val,ldum).and.set21) set%pr_torsions = ldum
      set21 = .false.
   case('final struct')
      if (getValue(env,val,ldum).and.set22) set%pr_finalstruct = ldum
      set22 = .false.
   case('geosum')
      if (getValue(env,val,ldum).and.set23) set%pr_geosum = ldum
      set23 = .false.
   case('moments','inertia')
      if (getValue(env,val,ldum).and.set24) set%pr_moments = ldum
      set24 = .false.
   case('modef')
      if (getValue(env,val,ldum).and.set25) set%pr_modef = ldum
      set25 = .false.
   case('wbo fragments')
      if (getValue(env,val,ldum).and.set26) set%pr_wbofrag = ldum
      set26 = .false.
   case('output file')
      if (set27) set%property_file = val
      set27 = .false.
   case('fod population')
      if (getValue(env,val,ldum).and.set28) set%pr_fod_pop = ldum
      set28 = .false.
   case('gbsa')
      if (getValue(env,val,ldum).and.set29) set%pr_gbsa = ldum
      set29 = .false.
   case('vib_normal_modes', 'nmtm')
      if (getValue(env,val,ldum).and.set30) set%pr_nmtm = ldum
      set30 = .false.
   case('hessian.out')
      if (getValue(env,val,ldum).and.set31) set%pr_dftbp_hessian_out = ldum
      set31 = .false.
   end select
end subroutine set_write

subroutine set_pcem(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_pcem'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1  = .true.
   logical,save :: set2  = .true.
   logical,save :: set3  = .true.
   logical,save :: set4  = .true.
   logical,save :: set5  = .true.
   logical,save :: set6  = .true.
   logical,save :: set7  = .true.
   logical,save :: set8  = .true.
   logical,save :: set9  = .true.
   logical,save :: set10 = .true.
   logical,save :: set11 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by embedding",source)
   case('at')
      if (getValue(env,val,idum).and.set1) set%pcem_dummyatom = idum
      set1 = .false.
   case('es')
      if (getValue(env,val,ldum).and.set2) set%pcem_l_es = ldum
      set2 = .false.
   case('aes')
      if (getValue(env,val,ldum).and.set3) set%pcem_l_aes = ldum
      set3 = .false.
   case('disp')
      if (getValue(env,val,ldum).and.set4) set%pcem_l_disp = ldum
      set4 = .false.
   case('dipm')
      if (getValue(env,val,ldum).and.set5) set%pcem_l_dipm = ldum
      set5 = .false.
   case('qp')
      if (getValue(env,val,ldum).and.set6) set%pcem_l_qp = ldum
      set6 = .false.
   case('cn')
      if (getValue(env,val,ldum).and.set7) set%pcem_l_cn = ldum
      set7 = .false.
   case('atm')
      if (getValue(env,val,ldum).and.set8) set%pcem_l_atm = ldum
      set8 = .false.
   case('interface')
      if (set9) then
      select case(val)
      case default
         call env%warning("Unknown interface value '"//val//"' is ignored",source)
      case('legacy')
         set%pcem_interface = p_pcem_legacy
      case('orca')
         set%pcem_interface = p_pcem_orca
         set%pcem_orca = .true.
      end select
      endif
      set9 = .false.
   case('input')
      if (set10) set%pcem_file = val
      set10 = .false.
   case('gradient')
      if (set11) set%pcem_grad = val
      set11 = .false.
   end select
end subroutine set_pcem

subroutine set_gfn(env,key,val)
   use xtb_mctc_strings, only : lowercase
   implicit none
   character(len=*), parameter :: source = 'set_gfn'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by gfn",source)
   case('version','method')
      if (key.eq.'version') &
         call env%warning("Don't use the 'version' key, since it is confusing",source)
      if(val.eq.'ff') then
         set1=.false.
         return
      endif
      if (getValue(env,val,idum).and.set1) then
         if ((idum.ge.0).and.(idum.le.2)) then ! actually, this looks stupid...
            set%gfn_method = idum
         elseif (idum.eq.3) then
            set%gfn_method = 2
            call env%warning('Please, request GFN2-xTB with method=2!',source)
         else
            call env%warning('We have not yet made a GFN'//val//'-xTB method',source)
         endif
      endif
      set1 = .false.
   case('d4')
      if (getValue(env,val,ldum).and.set2) set%newdisp = ldum
      set2 = .false.
   case('scc')
      if (getValue(env,val,ldum).and.set3) set%solve_scc = ldum
      set3 = .false.
   case('periodic')
      if (getValue(env,val,ldum).and.set4) set%periodic = ldum
      set4 = .false.
   case('dispscale')
      if (getValue(env,val,ddum).and.set5) set%dispscale = ddum
      set5 = .false.
   end select
end subroutine set_gfn

!> set ONIOM functionality
subroutine set_oniom(env,key,val)
   implicit none
   !> pointer to the error routine
   character(len=*), parameter :: source =  'set_oniom'
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   character(len=*), intent(in) :: key
   
   !> key=val
   character(len=*), intent(in) :: val
   
   logical :: ldum
   logical, save :: set1 = .true.
   logical, save :: set2 = .true.
   logical, save :: set3 = .true.
   logical, save :: set4 = .true.
   
   select case(key)
   case default
      call env%warning("the key '"//key//"' is not recognized by oniom",source)
   case('inner logs')
      if (getValue(env,val,ldum).and.set1) set%oniom_settings%logs = .true.
      set1=.false.
   
   case('derived k')
      if (getValue(env,val,ldum).and.set2) set%oniom_settings%derived = .true.
      set2=.false.

   case('silent')
      if (getValue(env,val,ldum).and.set3) set%oniom_settings%silent = .true.
      set3=.false.
   
   case('ignore topo')
      if (getValue(env,val,ldum).and.set4) set%oniom_settings%ignore_topo = .true.
      set4=.false.
   end select

end subroutine set_oniom

subroutine set_scc(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_scc'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by scc",source)
   case('temp')
      if (getValue(env,val,ddum).and.set1) set%eTemp = ddum
      set1 = .false.
   case('broydamp')
      if (getValue(env,val,ddum).and.set2) set%broydamp = ddum
      set2 = .false.
   case('guess')
      if (.not.set3) return
      if (val.eq.'gasteiger') then
         set%guess_charges = p_guess_gasteiger
      else if (val.eq.'goedecker') then
         set%guess_charges = p_guess_goedecker
      else if (val.eq.'sad') then
         set%guess_charges = p_guess_sad
      else if (val.eq.'multieq') then
         set%guess_charges = p_guess_multieq
      endif
      set3 = .false.
   case('maxiterations')
      if (getValue(env,val,idum).and.set4) then
         if (idum.le.0) then
            call env%warning('negative SCC-Iterations make no sense',source)
         else
            set%maxscciter = idum
         endif
      endif
      set4 = .false.
   end select
end subroutine set_scc

subroutine set_opt(env,key,val)
   use xtb_mctc_strings
   implicit none
   character(len=*), parameter :: source = 'set_opt'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1  = .true.
   logical,save :: set2  = .true.
   logical,save :: set3  = .true.
   logical,save :: set4  = .true.
   logical,save :: set5  = .true.
   logical,save :: set6  = .true.
   logical,save :: set7  = .true.
   logical,save :: set8  = .true.
   logical,save :: set9  = .true.
   logical,save :: set10 = .true.
   logical,save :: set11 = .true.
   logical,save :: set12 = .true.
   logical,save :: set13 = .true.
   logical,save :: set14 = .true.
   logical,save :: set15 = .true.
   logical,save :: set16 = .true.
   logical,save :: set17 = .true.
   logical,save :: set18 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by opt",source)
   case('optlevel')
      if (set1) then
         set%optset%optlev = optlevel2int(val)
      endif
      set1 = .false.
   case('microcycle')
      if (getValue(env,val,idum).and.set2) then
         if (idum > 0) then
            set%optset%micro_opt = idum
         else
            call env%warning("Non-positive microcycle input rejected: '"//val//"'")
         end if
      end if
      set2 = .false.
   case('maxcycle')
      if (getValue(env,val,idum).and.set3) then
         if (idum >= 0) then
            set%optset%maxoptcycle = idum
         else
            call env%warning("Negative optimization cycle input rejected: '"//val//"'")
         end if
      end if
      set3 = .false.
   case('maxdispl')
      if (getValue(env,val,ddum).and.set4) set%optset%maxdispl_opt = ddum
      set4 = .false.
   case('hlow')
      if (getValue(env,val,ddum).and.set5) set%optset%hlow_opt = ddum
      set5 = .false.
   case('s6','s6opt')
      if (getValue(env,val,ddum).and.set6) set%mhset%s6 = ddum
      set6 = .false.
   case('ts')
      if (getValue(env,val,ldum).and.set7) set%tsopt = ldum
      set7 = .false.
   case('tsroot')
      if (getValue(env,val,idum).and.set8) set%tsroot = idum
      set8 = .false.
   case('kstretch','kr')
      if (getValue(env,val,ddum).and.set9)  set%mhset%kr = ddum
      set9 = .false.
   case('kbend',   'kf')
      if (getValue(env,val,ddum).and.set10) set%mhset%kf = ddum
      set10 = .false.
   case('ktorsion','kt')
      if (getValue(env,val,ddum).and.set11) set%mhset%kt = ddum
      set11 = .false.
   case('koutofp','ko')
      if (getValue(env,val,ddum).and.set12) set%mhset%ko = ddum
      set12 = .false.
   case('kvdw','kd')
      if (getValue(env,val,ddum).and.set13) set%mhset%kd = ddum
      set13 = .false.
   case('hessian')
      if (set14) then
         select case(val)
         case("lindh");    set%mhset%model = p_modh_lindh
         case("lindh-d2"); set%mhset%model = p_modh_lindh_d2
         case("swart");    set%mhset%model = p_modh_swart
         case("old");      set%mhset%model = p_modh_old
         case("unit");     set%mhset%model = p_modh_unit
         case("read");     set%mhset%model = p_modh_read
         case("gfnff");    set%mhset%model = p_modh_gff
         end select
      endif
      set14 = .false.
   case('kes','kq')
      if (getValue(env,val,ddum).and.set15) set%mhset%kq = ddum
      set15 = .false.
   case('rcut')
      if (getValue(env,val,ddum).and.set16) set%mhset%rcut = ddum*ddum
      set16 = .false.
   case('exact rf')
      if (getValue(env,val,ldum).and.set17) set%optset%exact_rf = ldum
      set17 = .false.
   case('engine')
      if (.not.allocated(set%opt_engine)) then
         select case(lowercase(val))
         case default; call env%warning("engine '"//val//"' is not implemented",source)
         case('rf','ancopt');      set%opt_engine = p_engine_rf
         case('lbfgs','l-ancopt'); set%opt_engine = p_engine_lbfgs
         case('inertial','fire');  set%opt_engine = p_engine_inertial
         end select
      end if
   case('output')
      if (.not.allocated(set%opt_outfile)) set%opt_outfile = val
   case('logfile')
      if (.not.allocated(set%opt_logfile)) set%opt_logfile = val
   case('average conv')
      if (getValue(env,val,ldum).and.set18) set%optset%average_conv = ldum
      set18 = .false.
   end select
end subroutine set_opt

function optlevel2int(level) result(ilvl)
   implicit none
   character(len=*),intent(in)  :: level
   integer :: ilvl

   select case(level)
   case default
      ilvl = p_olev_normal
   case('crude','-3')
      ilvl = p_olev_crude
   case('sloppy','-2')
      ilvl = p_olev_sloppy
   case('loose','-1')
      ilvl = p_olev_loose
   case('lax')
      ilvl = p_olev_lax
   case('normal','0')
      ilvl = p_olev_normal
   case('tight','1')
      ilvl = p_olev_tight
   case('verytight','vtight','2')
      ilvl = p_olev_vtight
   case('extreme','3')
      ilvl = p_olev_extreme
   end select

end function optlevel2int

function int2optlevel(ilvl) result(level)
   implicit none
   character(len=:),allocatable :: level
   integer,         intent(in)  :: ilvl

   select case(ilvl)
   case default
      level = 'normal'
   case(-3)
      level = 'crude'
   case(-2)
      level = 'sloppy'
   case(-1)
      level = 'loose'
   case(-4) ! FIXME
      level = 'lax'
   case(0)
      level = 'normal'
   case(1)
      level = 'tight'
   case(2)
      level = 'verytight'
   case(3)
      level = 'extreme'
   end select

end function int2optlevel

subroutine set_thermo(env,key,val)
   use xtb_mctc_strings, only : parse
   implicit none
   character(len=*), parameter :: source = 'set_thermo'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: i
   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by thermo",source)
   case('temp')
      if (.not.set1) return ! we could read this twice... but we don't do
      set%thermotemp = 0.0
      set%nthermo = 0
      call parse(val,comma,argv,narg)
      idum = 0
      do i = 1, narg
         if (getValue(env,trim(argv(i)),ddum)) then
            if (ddum.le.0.0_wp) then ! doesn't make sense, skip garbage input
               call env%warning("A temperature of "//trim(argv(i))//" K is invalid in this context",source)
               cycle
            endif
            idum = idum + 1 ! use only readable arguments
            if (idum.gt.size(set%thermotemp,1)) exit ! don't overflow
            set%thermotemp(set%nthermo+idum) = ddum
         endif
      enddo
      set%nthermo = set%nthermo+idum
      set1 = .false.
      if (set%nthermo == 0) then
         call env%warning("No valid temperatures found in input: '"//val//"'",source)
         return
      endif
   case('sthr')
      if (getValue(env,val,ddum).and.set2) set%thermo_sthr = ddum
      set2 = .false.
   case('imagthr')
      if (getValue(env,val,ddum).and.set3) set%thermo_ithr = ddum
      set3 = .false.
   case('scale')
      if (getValue(env,val,ddum).and.set4) set%thermo_fscal = ddum
      set4 = .false.
   end select
end subroutine set_thermo

subroutine set_md(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_md'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   logical,save :: set8 = .true.
   logical,save :: set9 = .true.
   logical,save :: set10= .true.
   logical,save :: set11= .true.
   logical,save :: set12= .true.
   logical,save :: set13= .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by md",source)
   case('temp')
      if (getValue(env,val,ddum).and.set1) then
         set%temp_md = ddum
         set%solvInput%temperature = ddum
      end if
      set1 = .false.
   case('time')
      if (getValue(env,val,ddum).and.set2) set%time_md = ddum
      set2 = .false.
   case('dump','dumpxyz','dumptrj')
      if (getValue(env,val,ddum).and.set3) set%dump_md2 = ddum
      set3 = .false.
   case('sdump','dumpcoord')
      call set_siman(env,'dump',val)
      if (getValue(env,val,ddum).and.set12) set%dump_md = ddum
      set12 = .false. 
   case('velo')
!      if (getValue(env,val,idum).and.set4) then
!         if (idum.eq.1) then
!            velodump = .true.
!         else if (idum.eq.0) then
!            velodump = .false.
!         endif
!      endif
      if (getValue(env,val,ldum).and.set4) set%velodump = ldum
      set4 = .false.
   case('nvt')
!      if (getValue(env,val,idum).and.set5) then
!         if (idum.eq.1) then
!            nvt_md = .true.
!         else if (idum.eq.0) then
!            nvt_md = .false.
!         endif
!      endif
      if (getValue(env,val,ldum).and.set5) set%nvt_md = ldum
      set5 = .false.
   case('skip')
      if (getValue(env,val,idum).and.set6) set%skip_md = idum
      set6 = .false.
   case('step')
      if (getValue(env,val,ddum).and.set7) set%tstep_md = ddum
      set7 = .false.
   case('hmass')
      if (getValue(env,val,idum).and.set8) set%md_hmass = idum
      set8 = .false.
   case('shake')
      if (getValue(env,val,idum).and.set9) then
         if (idum.eq.2) then
            set%shake_md = .true.
            set%xhonly = .false.
            set%shake_mode = 2
         else if (idum.eq.1) then
            set%shake_md = .true.
            set%xhonly = .true.
            set%shake_mode = 1
         else if (idum.eq.0) then
            set%shake_md = .false.
            set%xhonly = .false.
            set%shake_mode = 0
         else if(idum.eq.3) then
            set%shake_md = .true.
            set%shake_mode = 3
         endif
      endif
      set9 = .false.
   case('sccacc')
      if (getValue(env,val,ddum).and.set10) set%accu_md = ddum
      set10 = .false.
   case('restart')
      if (getValue(env,val,ldum).and.set11) set%restart_md = ldum
      set11 = .false.
   case('forcewrrestart')
      if (getValue(env,val,ldum).and.set13) set%forcewrrestart = ldum
      set13 = .false.
   end select
end subroutine set_md

subroutine set_siman(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_siman'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by siman",source)
   case('dump')
      if (getValue(env,val,ddum).and.set1) set%dump_md = ddum
      set1 = .false.
   case('n')
      if (getValue(env,val,idum).and.set2) set%ntemp_siman = idum
      set2 = .false.
   case('ewin')
      if (getValue(env,val,ddum).and.set3) set%ewin_conf = ddum
      set3 = .false.
   case('temp')
      if (getValue(env,val,ddum).and.set4) set%Tend_siman = ddum
      set4 = .false.
   case('enan')
!      if (getValue(env,val,idum).and.set5) then
!         if (idum.eq.1) then
!            enan_siman = .true.
!         else if (idum.eq.0) then
!            enan_siman = .false.
!         endif
!      endif
      if (getValue(env,val,ldum).and.set5) set%enan_siman = ldum
      set5 = .false.
   case('check')
      if (getValue(env,val,idum).and.set6) then
         if (idum.eq.1) then
            set%check_rmsd = .false.
         else if (idum.eq.0) then
            set%check_rmsd = .true.
         endif
      endif
      set6 = .false.
   end select
end subroutine set_siman

subroutine set_hess(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_hess'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by hess",source)
   case('sccacc')
      if (getValue(env,val,ddum).and.set1) set%accu_hess = ddum
      set1 = .false.
   case('step')
      if (getValue(env,val,ddum).and.set2) set%step_hess = ddum
      set2 = .false.
   case('scale')
      if (getValue(env,val,ddum).and.set3) set%scale_hess = ddum
      set3 = .false.
   end select
end subroutine set_hess

subroutine set_reactor(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_reactor'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by reactor",source)
   case('kpush')
      if (getValue(env,val,ddum).and.set1) set%reactset%kpush = ddum
      set1 = .false.
   case('alp')
      if (getValue(env,val,ddum).and.set2) set%reactset%alp   = ddum
      set2 = .false.
   case('max')
      if (getValue(env,val,idum).and.set3) set%reactset%nmax  = idum
      set3 = .false.
   case('density')
      if (getValue(env,val,ddum).and.set4) set%reactset%dens  = ddum
      set4 = .false.
   end select
end subroutine set_reactor


subroutine set_gbsa(env,key,val)
   use xtb_mctc_convert, only : aatoau
   implicit none
   character(len=*), parameter :: source = 'set_gbsa'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by gbsa",source)
   case('solvent')
      if (set1 .and. val.ne.'none') then
         set%solvInput%solvent = val
      endif
      set1 = .false.
   case('ion_st')
      if (getValue(env,val,ddum).and.set2) then
         set%solvInput%ionStrength = ddum
      endif
      set2 = .false.
   case('ion_rad')
      if (getValue(env,val,ddum).and.set3) set%solvInput%ionRad = ddum * aatoau
      set3 = .false.
   case('gbsagrid', 'grid')
      if (set4) then
         select case(val)
         case default
            if (getValue(env,val,idum)) then
               if (any(idum.eq.ldgrids)) then
                  if (idum < p_angsa_normal) &
                     call env%warning("Small SASA grids can lead to numerical instabilities",source)
                  set%solvInput%nAng = idum
               else
                  call env%warning("There is no "//val//" Lebedev grid",source)
               endif
            endif
         case('normal');    set%solvInput%nAng = p_angsa_normal
         case('tight');     set%solvInput%nAng = p_angsa_tight
         case('verytight'); set%solvInput%nAng = p_angsa_verytight
         case('extreme');   set%solvInput%nAng = p_angsa_extreme
         endselect
      endif
      set4 = .false.
   case('alpb')
      if (getValue(env,val,ldum).and.set5) set%solvInput%alpb = ldum
      set5 = .false.
   case('kernel')
      if (set6) then
         select case(val)
         case default
            call env%warning("Unknown solvation kernel '"//val//"' requested", &
               & source)
         case('still'); set%solvInput%kernel = gbKernel%still
         case('p16');   set%solvInput%kernel = gbKernel%p16
         end select
      end if
      set6 = .false.
   case('cosmo')
      if (getValue(env,val,ldum).and.set7) set%solvInput%cosmo = ldum
      set7 = .false.
   end select
end subroutine set_gbsa

subroutine set_modef(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_modef'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by modef",source)
   case('n')
      if (getValue(env,val,idum).and.set1) set%mode_nscan = idum
      set1 = .false.
   case('step')
      if (getValue(env,val,ddum).and.set2) set%mode_step = ddum
      set2 = .false.
   case('updat')
      if (getValue(env,val,ddum).and.set3) set%mode_updat = ddum
      set3 = .false.
   case('local')
      if (getValue(env,val,idum).and.set4) set%mode_local = idum
      set4 = .false.
   case('vthr')
      if (getValue(env,val,ddum).and.set5) set%mode_vthr = ddum
      set5 = .false.
   case('prj')
      if (getValue(env,val,idum).and.set6) set%mode_prj = idum
      set6 = .false.
   case('mode')
      if (getValue(env,val,idum).and.set7) set%mode_follow = idum
      set7 = .false.
   end select
end subroutine set_modef

subroutine set_cube(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_cube'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by cube",source)
   case('step')
      if (getValue(env,val,ddum).and.set1) set%cube_step = ddum
      set1 = .false.
   case('pthr')
      if (getValue(env,val,ddum).and.set2) set%cube_pthr = ddum
      set2 = .false.
   case('cal')
      call env%warning("the key 'cal' has been removed",source)
!      if (getValue(env,val,idum).and.set3) cube_cal = idum
!      set3 = .false.
   case('boff')
      if (getValue(env,val,ddum).and.set4) set%cube_boff = ddum
      set4 = .false.
   end select
end subroutine set_cube

subroutine set_stm(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_stm'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by stm",source)
   case('broadening')
      if (getValue(env,val,ddum).and.set1) set%stm_alp = ddum
      set1 = .false.
   case('current')
      if (getValue(env,val,ddum).and.set2) set%stm_targ = ddum
      set2 = .false.
   case('grid')
      if (getValue(env,val,ddum).and.set3) set%stm_grid = ddum
      set3 = .false.
   case('thr')
      if (getValue(env,val,ddum).and.set4) set%stm_thr = ddum
      set4 = .false.
   case('potential')
      if (getValue(env,val,ddum).and.set5) set%stm_pot = ddum
      set5 = .false.
   end select
end subroutine set_stm

subroutine set_symmetry(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_symmetry'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by symmetry",source)
   case('desy')
      if (getValue(env,val,ddum).and.set1) set%desy = ddum
      set1 = .false.
   case('maxat')
      if (getValue(env,val,idum).and.set2) set%maxatdesy = idum
      set2 = .false.
   end select
end subroutine set_symmetry

!> Options for $external
subroutine set_external(env,key,val)
   
   implicit none
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   
   character(len=*), parameter :: source = 'set_external'
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   logical,save :: set8 = .true.
   
   select case(key)
   case default
      call env%warning("the key '"//key//"' is not recognized by external",source)
   case('orca bin')
      if (set1) set%ext_orca%executable = val
      set1 = .false.
   case('orca input line')
      if (set2) set%ext_orca%input_string = val
      set2 = .false.
   case('orca input file')
      if (set3) set%ext_orca%input_file = val
      set3 = .false.
   case('mopac bin')
      if (set4) set%ext_mopac%executable = val
      set4 = .false.
   case('mopac input')
      if (set5) set%ext_mopac%input_string = val
      set5 = .false.
   case('mopac file')
      if (set6) set%ext_mopac%input_file = val
      set6 = .false.
   case('turbodir')
      if (set7) set%ext_turbo%path = val
      set7 = .false.
   case ('cefine')
      if (set8) set%ext_turbo%input_string = val
      set8 = .false.
   end select

end subroutine set_external

subroutine set_fix(env,key,val)
   use xtb_fixparam
   implicit none
   character(len=*), parameter :: source = 'set_fix'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by fix",source)
   case('freeze frequency')
      if (getValue(env,val,ddum).and.set1) freezeset%fc = ddum
      set1 = .false.
   end select

end subroutine set_fix

subroutine set_constr(env,key,val)
   use xtb_scanparam
   implicit none
   character(len=*), parameter :: source = 'set_constr'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by constrain",source)
   case('force constant')
      if (getValue(env,val,ddum).and.set1) fcconstr = ddum
      set1 = .false.
   !  this are global constrains, you should only chose one, I think, everything
   !  else doesn't really make sense, but as user it is your own responsibility
   !  so you can set all logicals for whatever reason
   case('all bonds')
      if (getValue(env,val,ldum).and.set2) lconstr_all_bonds = ldum
      set2 = .false.
   case('all angles')
      if (getValue(env,val,ldum).and.set3) lconstr_all_angles = ldum
      set3 = .false.
   case('all torsions')
      if (getValue(env,val,ldum).and.set4) lconstr_all_torsions = ldum
      set4 = .false.
   case('reference')
      if (set5) potset%fname = val
      set5 = .false.
   end select

end subroutine set_constr

subroutine set_metadyn(env,key,val)
   use xtb_fixparam
   implicit none
   character(len=*), parameter :: source = 'set_metadyn'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum

   integer  :: i
   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv

   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   logical,save :: set8 = .true.

   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by metadyn",source)
   case('save')
      if (getValue(env,val,idum).and.set1) metaset%maxsave = idum
      set1 = .false.
   case('width','alp')
      if (getValue(env,val,ddum).and.set2) metaset%global_width = ddum
      set2 = .false.
   case('factor','kpush')
      if (getValue(env,val,ddum).and.set3) metaset%global_factor = ddum
      set3 = .false.
   case('coord')
      if (set4) metaset%fname = val
      set4 = .false.
   case('static')
      if (getValue(env,val,ldum).and.set5) metaset%static = ldum
      set5 = .false.
   case('rmsd')
      if (getValue(env,val,ddum).and.set6) set%target_rmsd = ddum
      set6 = .false.
   case('bias_ramp_time','ramp')
      if (getValue(env,val,ddum).and.set7) metaset%ramp = ddum
      set7 = .false.
   case('bias-input', 'bias_input', 'bias input')
      if (set8) rmsdset%fname = val
      set8 = .false.
   end select

end subroutine set_metadyn

subroutine set_path(env,key,val)
   implicit none
   character(len=*), parameter :: source = 'set_path'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum

   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   logical,save :: set8 = .true.

   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by path",source)
   case('nrun')
      if (getValue(env,val,idum).and.set1) set%pathset%nrun = idum
      set1 = .false.
   case('nopt', 'npoint')
      if (getValue(env,val,idum).and.set2) set%pathset%nopt = idum
      set2 = .false.
   case('anopt')
      if (getValue(env,val,idum).and.set3) set%pathset%anopt = idum
      set3 = .false.
   case('kpush')
      if (getValue(env,val,ddum).and.set4) set%pathset%kpush = ddum
      set4 = .false.
   case('kpull')
      if (getValue(env,val,ddum).and.set5) set%pathset%kpull = ddum
      set5 = .false.
   case('alp')
      if (getValue(env,val,ddum).and.set6) set%pathset%alp = ddum
      set6 = .false.
   case('product')
      if (set7) then
         inquire(file=val,exist=ldum)
         if (.not.ldum) then
            call env%error("Could not find: '"//val//"' in $path/product",source)
         endif
         set%pathset%fname = val
      endif
      set7 = .false.
   case('ppull')
      if (getValue(env,val,ddum).and.set7) set%pathset%ppull = ddum
      set7 = .false.
   end select

end subroutine set_path


! this is a dummy routine
subroutine set_scan(env,key,val)
   use xtb_scanparam
   implicit none
   character(len=*), parameter :: source = 'set_scan'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by scan",source)
   case('mode')
      if (val.eq.'sequential') then
         scan_mode = p_scan_sequential
      else if (val.eq.'concerted') then
         scan_mode = p_scan_concerted
      endif
      set1 = .false.
   end select

end subroutine set_scan

subroutine set_wall(env,key,val)
   use xtb_sphereparam
   implicit none
   character(len=*), parameter :: source = 'set_wall'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   logical,save :: set1 = .true.
   logical,save :: set2 = .true.
   logical,save :: set3 = .true.
   logical,save :: set4 = .true.
   logical,save :: set5 = .true.
   logical,save :: set6 = .true.
   logical,save :: set7 = .true.
   logical,save :: set8 = .true.
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by fix",source)
   case('potential')
      if (.not.set1) return
      if (val.eq.'polynomial') then
         spherepot_type = p_type_polynomial
      else if (val.eq.'logfermi') then
         spherepot_type = p_type_logfermi
      endif
      set1 = .false.
   case('alpha')
      if (getValue(env,val,idum).and.set2) sphere_alpha = idum
      set2 = .false.
   case('beta')
      if (getValue(env,val,ddum).and.set3) sphere_beta = ddum
      set3 = .false.
   case('temp')
      if (getValue(env,val,ddum).and.set4) sphere_temp = ddum
      set4 = .false.
   case('autoscale')
      if (getValue(env,val,ddum).and.set5) sphere_autoscale = ddum
      set5 = .false.
   case('axisshift')
      if (getValue(env,val,ddum).and.set6) sphere_shift = ddum
      set6 = .false.
   case('auto')
      if (.not.set7) return
      select case(val)
      case('distance')
         sphereauto = p_auto_dist
      case('density')
         sphereauto = p_auto_dens
      case('force')
         sphereauto = p_auto_force
      end select
      set7 = .false.
   case('center')
      if (.not.set8) return
      select case(val)
      case('zero')
         spherecent = p_cent_zero
      case('mass')
         spherecent = p_cent_com
      case('geo')
         spherecent = p_cent_cog
      end select
      set8 = .false.
   end select

end subroutine set_wall

subroutine set_natom(env,arg)
   use xtb_docking_param
   implicit none
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: arg
   integer :: idum
   character(len=*), parameter :: source = 'set_natom'
   natom_arg = arg
end subroutine set_natom

! this is a dummy routine
subroutine set_split(env,key,val)
   use xtb_splitparam
   implicit none
   character(len=*), parameter :: source = 'set_split'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
end subroutine set_split

subroutine set_legacy(env,key,val)
   use xtb_mctc_strings, only : parse
   use xtb_sphereparam
   implicit none
   character(len=*), parameter :: source = 'set_legacy'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: key
   character(len=*),intent(in) :: val
   integer  :: err
   integer  :: idum
   real(wp) :: ddum
   logical  :: ldum
   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv
   select case(key)
   case default ! do nothing
      call env%warning("the key '"//key//"' is not recognized by set",source)
   case('runtyp');      call set_runtyp(val)
   case('chrg','charge'); call set_chrg(env,val)
   case('uhf');           call set_spin(env,val)
   case('restartmd','mdrestart'); call set_md(env,'restart','1')
   case('samerand');    call set_samerand
   case('hessf');       continue ! used later in read_userdata
!   case('atomlist-');
   case('fragment1');   continue ! used later in read_userdata
   case('fragment2');   continue ! used later in read_userdata
   case('constrxyz');   continue ! used later in read_userdata
!   case('constrainel');
   case('constrainalltors','constralltors'); call set_constr(env,'all torsions','true')
   case('constrainallbo','constralltbo'); call set_constr(env,'all bonds','true')
!   case('constrain');
!   case('scan');
   case('fit');         call set_fit
   case('optlev');      call set_opt(env,'optlevel',val)
   case('gfnver');      call set_gfn(env,'method',val)
   case('ellips');      continue ! used later in read_userdata
                        maxwalls = maxwalls + 1
!   case('ellipsoi');
   case('sphere');      continue ! used later in read_userdata
                        maxwalls = maxwalls + 1
   case('fix');         continue ! used later in read_userdata
   case('fixfc');       call set_fix(env,'force constant',val)
   case('springexp');   call set_fix(env,'spring exponent',val)
   case('constrfc');    call set_constr(env,'force constant',val)
   case('hlowopt');     call set_opt(env,'hlow',val)
   case('s6opt');       call set_opt(env,'s6',val)
   case('microopt');    call set_opt(env,'microcycle',val)
   case('maxopt');      call set_opt(env,'maxcycle',val)
   case('maxdispl');    call set_opt(env,'maxdispl',val)
   case('mdtime');      call set_md(env,'time',val)
   case('mdtemp');      call set_md(env,'temp',val)
   case('etemp');       call set_scc(env,'temp',val)
   case('broydamp');    call set_scc(env,'broydamp',val)
   case('nsiman');      call set_siman(env,'n',val)
   case('mddump');      call set_siman(env,'dump',val)
   case('mddumpxyz');   call set_md(env,'dump',val)
   case('mdskip');      call set_md(env,'skip',val)
   case('shake');       call set_md(env,'shake',val)
   case('md_hmass');    call set_md(env,'hmass',val)
   case('tend');        call set_siman(env,'temp',val)
   case('mdstep');      call set_md(env,'step',val)
   case('velodump');    call set_md(env,'velo',val)
   case('sccmd');       call set_md(env,'sccacc',val)
   case('scchess');     call set_hess(env,'sccacc',val)
   case('stephess');    call set_hess(env,'step',val)
   case('nvt');         call set_md(env,'nvt',val)
   case('enan');        call set_siman(env,'enan',val)
   case('mode_n');      call set_modef(env,'n',val)
   case('mode_step');   call set_modef(env,'step',val)
   case('mode_vthr');   call set_modef(env,'vthr',val)
   case('mode_updat');  call set_modef(env,'updat',val)
   case('mode_local');  call set_modef(env,'local',val)
   case('mode_prj');    call set_modef(env,'prj',val)
   case('path_kpush');  call set_path(env,'kpush',val)
   case('path_kpull');  call set_path(env,'kpull',val)
   case('path_alp');    call set_path(env,'alp',val)
   case('path_nopt');   call set_path(env,'nopt',val)
   case('path_anopt');  call set_path(env,'anopt',val)
   case('path_nrun');   call set_path(env,'nrun',val)
   case('metadyn') ! just for the records, I was against implementing it that way
      call parse(val,space,argv,narg) ! need to parse for spaces...
      if (narg <3) then
         call env%warning('deprecated $set/metadyn keyword broken by user input',source)
         return ! okay, you screwed up, let's get outta here
      endif
      call set_metadyn(env,'factor',trim(argv(1)))
      call set_metadyn(env,'width', trim(argv(2)))
      call set_metadyn(env,'save',  trim(argv(3)))

   case('atomlist+'); continue ! use later in constrain_param
   case('atomlist-'); call env%warning("$set/atomlist- is not implemented", source)
   case('cube_pthr');   call set_cube(env,'pthr',val)
   case('cube_step');   call set_cube(env,'step',val)
   case('cube_cal'); call env%warning("The key 'cube_cal' has been removed from $set",source)
   case('gbsa');        call set_gbsa(env,'solvent',val)
   case('ion_st');      call set_gbsa(env,'ion_st',val)
   case('ion_rad');     call set_gbsa(env,'ion_rad',val)
   case('gbsagrid');    call set_gbsa(env,'gbsagrid',val)
   case('ewin_conf');   call set_siman(env,'ewin',val)
   case('desy');        call set_symmetry(env,'desy',val)
   case('thermo');      call set_thermo(env,'temp',val)
   case('thermo_sthr'); call set_thermo(env,'sthr',val)
   case('desymaxat');   call set_symmetry(env,'maxat',val)
!   case('ex_open_HS');
!   case('ex_open_LS');
!   case('orca_mpi');
!   case('orca_exe');
!   case('orca_line');
   case('check_equal'); call set_siman(env,'check',val)
   case('stm_alp');     call set_stm(env,'broadening',val)
   case('stm_targ');    call set_stm(env,'current',val)
   case('stm_grid');    call set_stm(env,'grid',val)
   case('stm_thr');     call set_stm(env,'thr',val)
   case('stm_pot');     call set_stm(env,'potential',val)
   end select

end subroutine set_legacy

end module xtb_setmod

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the third order electrostatics
module xtb_xtb_thirdorder
   use xtb_mctc_accuracy, only : wp
   use xtb_xtb_data, only : TCoulombData
   implicit none
   private

   public :: TThirdOrder, init


   !> Third order electrostatics
   type :: TThirdOrder

      !> Atomic Hubbard derivatives
      real(wp), allocatable :: atomicGam(:)

      !> Shell-resolved Hubbard derivatives
      real(wp), allocatable :: shellGam(:)

   contains

      !> Add shifts from third order contribution
      procedure :: addShift

      !> Get energy from third order contribution
      procedure :: getEnergy

   end type TThirdOrder


   !> Initialize third order electrostatics
   interface init
      module procedure :: initThirdOrder
   end interface init


contains


!> Initialize third order electrostatics
subroutine initThirdOrder(self, input, nshell, num)

   !> Instance of the third order electrostatics
   type(TThirdOrder), intent(out) :: self

   !> Parametrisation data for coulombic interactions
   type(TCoulombData), intent(in) :: input

   !> Number of shells for each species
   integer, intent(in) :: nshell(:)

   !> Atomic numbers of each element
   integer, intent(in) :: num(:)

   integer :: nat, nsh
   integer :: ii, iat, izp, ish

   nat = size(num, dim=1)
   nsh = sum(nshell(num))

   ! set 3rd order shell gammas
   if (allocated(input%thirdOrderShell)) then
      allocate(self%shellGam(nsh))
      ii = 0
      do iat = 1, nat
         izp = num(iat)
         do ish = 1, nShell(izp)
            self%shellGam(ii+ish) = input%thirdOrderShell(ish, izp)
         end do
         ii = ii + nShell(izp)
      end do
   else if (allocated(input%thirdOrderAtom)) then
      allocate(self%atomicGam(nat))
      do iat = 1, nat
         izp = num(iat)
         self%atomicGam(iat) = input%thirdOrderAtom(izp)
      end do
   end if

end subroutine initThirdOrder


pure subroutine addShift(self, qat, qsh, atomicShift, shellShift)

   !> Instance of the third order electrostatics
   class(TThirdOrder), intent(inout) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Atomic potential shift
   real(wp), intent(inout) :: atomicShift(:)

   !> Shell-resolved potential shift
   real(wp), intent(inout) :: shellShift(:)

   integer :: ii

   if (allocated(self%atomicGam)) then
      do ii = 1, size(atomicShift, dim=1)
         atomicShift(ii) = atomicShift(ii) + qat(ii)**2 * self%atomicGam(ii)
      end do
   end if

   if (allocated(self%shellGam)) then
      do ii = 1, size(shellShift, dim=1)
         shellShift(ii) = shellShift(ii) + qsh(ii)**2 * self%shellGam(ii)
      end do
   end if

end subroutine addShift


pure subroutine getEnergy(self, qat, qsh, energy)

   !> Instance of the third order electrostatics
   class(TThirdOrder), intent(in) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Third order contribution to the energy
   real(wp), intent(out) :: energy

   integer :: ii

   energy = 0.0_wp

   if (allocated(self%atomicGam)) then
      do ii = 1, size(qat, dim=1)
         energy = energy + qat(ii)**3 * self%atomicGam(ii) / 3.0_wp
      end do
   end if

   if (allocated(self%shellGam)) then
      do ii = 1, size(qsh, dim=1)
         energy = energy + qsh(ii)**3 * self%shellGam(ii) / 3.0_wp
      end do
   end if

end subroutine getEnergy


end module xtb_xtb_thirdorder

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> API for dealing with molecular structure data
module xtb_api_molecule
   use, intrinsic :: iso_c_binding
   use xtb_mctc_accuracy, only : wp
   use xtb_api_environment
   use xtb_api_utils
   use xtb_type_molecule
   implicit none
   private

   public :: VMolecule
   public :: newMolecule_api, delMolecule_api, updateMolecule_api


   !> Void pointer to molecular structure data
   type :: VMolecule
      type(TMolecule) :: ptr
   end type VMolecule


   !> Maximum accepted atomic number, actual calculator might accept less
   integer, parameter :: maxElem = 118


contains


function newMolecule_api(venv, natoms, numbers, positions, charge, uhf, lattice, &
      & periodic) result(vmol) &
      & bind(C, name="xtb_newMolecule")
   !DEC$ ATTRIBUTES DLLEXPORT :: newMolecule_api
   character(len=*), parameter :: source = 'xtb_api_newMolecule'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   integer(c_int), intent(in) :: natoms
   integer(c_int), intent(in) :: numbers(natoms)
   real(c_double), intent(in) :: positions(3, natoms)
   real(c_double), intent(in), optional :: charge
   integer(c_int), intent(in), optional :: uhf
   real(c_double), intent(in), optional :: lattice(3, 3)
   logical(c_bool), intent(in), optional :: periodic(3)
   type(VMolecule), pointer :: mol
   type(c_ptr) :: vmol
   integer(c_int) :: status

   vmol = c_null_ptr

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (natoms <= 0) then
         call env%ptr%error("Number of atoms must be positive", source)
         return
      end if

      if (any(numbers <= 0) .or. any(numbers > maxElem)) then
         call env%ptr%error("Invalid atomic number present", source)
         return
      end if

      allocate(mol)

      mol%ptr = TMolecule(natoms, numbers, positions, charge, uhf, &
         & lattice, periodic)

      status = verifyMolecule(mol%ptr)
      if (status /= 0_c_int) then
         deallocate(mol)
         call env%ptr%error("Could not generate molecular structure", source)
         return
      end if

      vmol = c_loc(mol)
   end if

end function newMolecule_api


subroutine delMolecule_api(vmol) &
      & bind(C, name="xtb_delMolecule")
   !DEC$ ATTRIBUTES DLLEXPORT :: delMolecule_api
   type(c_ptr), intent(inout) :: vmol
   type(VMolecule), pointer :: mol

   if (c_associated(vmol)) then
      call c_f_pointer(vmol, mol)
      call checkGlobalEnv

      deallocate(mol)
      vmol = c_null_ptr
   end if

end subroutine delMolecule_api


subroutine updateMolecule_api(venv, vmol, positions, lattice) &
      & bind(C, name="xtb_updateMolecule")
   !DEC$ ATTRIBUTES DLLEXPORT :: updateMolecule_api
   character(len=*), parameter :: source = 'xtb_api_updateMolecule'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vmol
   type(VMolecule), pointer :: mol
   real(c_double), intent(in) :: positions(3, *)
   real(c_double), intent(in), optional :: lattice(3, 3)
   real(wp) :: latvecs(3, 3)
   integer(c_int) :: status

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vmol)) then
         call env%ptr%error("Molecular structure data is not allocated", source)
         return
      end if

      call c_f_pointer(vmol, mol)

      if (mol%ptr%n <= 0 .or. mol%ptr%nid <= 0 .or. .not.allocated(mol%ptr%at) &
         & .or. .not.allocated(mol%ptr%id) .or. .not.allocated(mol%ptr%xyz)) then
         call env%ptr%error("Invalid molecular structure data provided", source)
         return
      end if

      mol%ptr%xyz(:, :) = positions(1:3, 1:mol%ptr%n)
      if (present(lattice)) then
         mol%ptr%lattice(:, :) = lattice(1:3, 1:3)
      end if

      call mol%ptr%update

      status = verifyMolecule(mol%ptr)
      if (status /= 0_c_int) then
         call env%ptr%error("Could not update molecular structure", source)
         return
      end if

   end if

end subroutine updateMolecule_api


end module xtb_api_molecule

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_cube
contains

!cccccccccccccccccccccccccccccccc
!    write out cube file        c
!cccccccccccccccccccccccccccccccc
! ncent  : # atoms
! nmo    : # MOs
! nbf    : # AOs
! nprims : # primitives (in total)
! xyz(4,ncent) : Cartesian coordinates & nuclear charge
! cxip(nprims) : contraction coefficients of primitives
! exip(nprims) : exponents of primitives
! cmo(nbf,nmo) : LCAO-MO coefficients
! eval(nmo)    : orbital eigenvalues
! occ(nmo)     : occupation # of MO
! ipty(nprims) : angular momentum of primitive function
! ipao(nbf)    : # primitives in contracted AO
! ibf(ncent)   : # of contracted AOs on atom

subroutine cube(n,nmo,nbf,xyz,at,cmo,eval,occ,fname,basis)
   use xtb_type_basisset
   use xtb_setparam
   use xtb_mctc_blas, only : blas_gemm
   implicit none
   type(TBasisset), intent(in) :: basis

   real*8, intent ( in ) :: xyz(3,n)
   real*8, intent ( in ) :: eval(nmo)
   real*8, intent ( in ) :: occ (nmo)
   real*8, intent ( in ) :: cmo(nbf,nmo)
   integer, intent( in ) :: at(n)
   integer, intent( in ) :: n,nmo,nbf
   character*(*) fname

   real*8 ,allocatable  ::Ptmp (:,:)
   real*8 ,allocatable  ::P    (:,:)
   real*8 ,allocatable  ::C    (:,:)
   real*4 ,allocatable  ::cb   (:,:,:)
   real*8 ,allocatable  ::array(:)
   integer,allocatable  ::matlist (:,:)

   integer i,j,k,m,nm,ii,jj,iii,jjj,npri,nprj,primstart(nbf),nexp
   integer iat,jat,xst,yst,zst,cou,iprimcount,jprimcount,iiii,jjjj
   real*8 thr,thr3,intcut,intcut2,boff
   real*8 w0,w1,t0,t1,r,r2,val,rab,ccc,gridp(3),xyza(3),xyzb(3),dr3
   real*8 step,px,py,pz,xinc,yinc,zinc,nx,ny,nz,vv(1),v,est,nfod
   real*8 f1,f2,dx1,dy1,dz1,dx2,dy2,dz2,r1,dum,r1xy,r2xy
   real*8 dxx1,dyy1,dzz1,dxx2,dyy2,dzz2,ar1,ar2,cc
   integer ifile

   call timing(t0,w0)
   write(*,*)
   write(*,*)'cube file module (SG, 7/16)'
   thr = set%cube_pthr ! Dmat pre-screen
   step= set%cube_step ! grid step (Bohr)
   boff= set%cube_boff ! bound offset
   intcut=8.00d0   ! primitive cut
   intcut2=2.0d0*intcut

   nexp=100*int(intcut2) ! size of exp array ie arguments 0:nexp
   allocate(array(0:nexp))
   do i=0,nexp
      dum=float(i)/100.0
      array(i)=exp(-dum)
   enddo

   !     do i=0,160
   !        dum=float(i)/10.0
   !        write(*,*) int(10*dum)
   !        write(*,*) exp(-dum),array(int(10*dum)),fastexp(nexp,array,dum)
   !     enddo
   !     stop

   allocate(Ptmp(nbf,nbf),P(nbf,nbf),C(nbf,nbf),matlist(2,nbf*(nbf+1)/2))
   C(1:nbf,1:nmo) = cmo(1:nbf,1:nmo)
   do m=1,nmo
      do i=1,nbf
         Ptmp(i,m)=cmo(i,m)*occ(m)
      enddo
   enddo
   if(nmo.ne.nbf)then
      Ptmp(1:nbf,nmo+1:nbf)=0
      C   (1:nbf,nmo+1:nbf)=0
   endif
   call blas_gemm('N','T',nbf,nbf,nbf, 1.0d0,C,nbf,Ptmp,nbf,0.0d0,P,nbf)
   deallocate(Ptmp,C)

   nm=0
   npri=0
   do i=1,nbf
      primstart(i)=npri  ! start index for prims of AO i
      npri=npri+basis%nprim(i)
      do j=1,i
         if(abs(P(j,i)).gt.thr)then
            nm=nm+1
            matlist(1,nm)=i
            matlist(2,nm)=j
            if(i.ne.j) P(j,i)=2.0d0*P(j,i)
         endif
      enddo
   enddo
   write(*,'('' cube_pthr     : '',f7.3)')set%cube_pthr
   write(*,'('' cube_step     : '',f7.3)')set%cube_step
   write(*,'('' cube_boundoffset     : '',f7.3)')set%cube_boff
   write(*,'('' non-zero P (%): '',f7.3,''   nmat:'',i8)') &
   & 100.*float(nm)/float(nbf*(nbf+1)/2),nm

   px=maxval(xyz(1,1:n))+boff
   py=maxval(xyz(2,1:n))+boff
   pz=maxval(xyz(3,1:n))+boff
   nx=minval(xyz(1,1:n))-boff
   ny=minval(xyz(2,1:n))-boff
   nz=minval(xyz(3,1:n))-boff
   write(*,*)'Grid Boundaries (x y z) :'
   write(*,*)px,py,pz
   write(*,*)nx,ny,nz

   ! calculate step size and number of steps (step size approx 0.2-0.5)
   xst=floor(abs(px-nx)/step)
   xinc=abs(px-nx)/xst
   yst=floor(abs(py-ny)/step)
   yinc=abs(py-ny)/yst
   zst=floor(abs(pz-nz)/step)
   zinc=abs(pz-nz)/zst
   write(*,*)'Total # of points', (xst+1)*(yst+1)*(zst+1)
   dr3=xinc*yinc*zinc

   write(*,*)'writing ',trim(fname)
   call open_file(ifile,fname,'w')
   write(ifile,*)'xtb spin/fo density'
   write(ifile,*)'By S.G.'
   write(ifile,101)n,nx,ny,nz
   write(ifile,101)xst+1,xinc,0.0,0.0
   write(ifile,101)yst+1,0.0,yinc,0.0
   write(ifile,101)zst+1,0.0,0.0,zinc
   do i=1,n
      write(ifile,102)at(i),0.0,xyz(1,i),xyz(2,i),xyz(3,i)
   enddo

   allocate(cb(0:zst,0:yst,0:xst))

   nfod=0
   cb  =0

   !     Dmat loop         -----------------------------------
   do m=1,nm
      ii=matlist(1,m)
      jj=matlist(2,m)
      iat=basis%aoat(ii)
      jat=basis%aoat(jj)
      xyza(1:3)=xyz(1:3,iat)
      xyzb(1:3)=xyz(1:3,jat)
      npri=basis%nprim(ii)
      nprj=basis%nprim(jj)
      iprimcount=primstart(ii)
      jprimcount=primstart(jj)
      rab=(xyza(1)-xyzb(1))**2  &
      &      +(xyza(2)-xyzb(2))**2  &
      &      +(xyza(3)-xyzb(3))**2
      !        prim loop
      do iiii=1,npri
         iii=iprimcount+iiii
         ccc=P(jj,ii)*basis%cont(iii)
         dum=rab*basis%alp(iii)
         do jjjj=1,nprj
            jjj=jprimcount+jjjj
            est=dum*basis%alp(jjj)/(basis%alp(iii)+basis%alp(jjj))
            if(est.lt.intcut)then
               cc=ccc*basis%cont(jjj)
               !                 grid loops
               gridp(1)=nx
               do i=0,xst
                  gridp(1)=nx+(xinc*i)
                  dx1=xyza(1)-gridp(1)
                  dx2=xyzb(1)-gridp(1)
                  dxx1=dx1*dx1
                  dxx2=dx2*dx2
                  gridp(2)=ny
                  do j=0,yst
                     gridp(2)=ny+(yinc*j)
                     dy1=xyza(2)-gridp(2)
                     dy2=xyzb(2)-gridp(2)
                     dyy1=dy1*dy1
                     dyy2=dy2*dy2
                     gridp(3)=nz
                     r1xy=dxx1+dyy1
                     r2xy=dxx2+dyy2
                     do k=0,zst
                        gridp(3)=nz+(zinc*k)
                        dz1=xyza(3)-gridp(3)
                        dz2=xyzb(3)-gridp(3)
                        dzz1=dz1*dz1
                        dzz2=dz2*dz2
                        r1=r1xy+dzz1
                        !                    primitive function value
                        ar1=basis%alp(iii)*r1
                        if(ar1.lt.intcut2)then  ! exp(-16) < 1.d-7 i.e. zero
                           call primvalf(dx1,dy1,dz1,dxx1,dyy1,dzz1,ar1, &
                              &             basis%lao(ii),nexp,array,f1)
                           r2=r2xy+dzz2
                           ar2=basis%alp(jjj)*r2
                           if(ar2.lt.intcut2)then
                              call primvalf(dx2,dy2,dz2,dxx2,dyy2,dzz2,ar2, &
                                 &             basis%lao(jj),nexp,array,f2)
                              cb(k,j,i)=cb(k,j,i)+cc*f1*f2
                           endif
                        endif
                     enddo
                  enddo
               enddo
            endif
         enddo
      enddo
   enddo
   !     Dmat loop end     -----------------------------------

   ! write
   cou=1
   do i=0,xst
      do j=0,yst
         do k=0,zst
            if (cou.lt.6) then
               write(ifile,'(E14.8,1X)',advance='no')cb(k,j,i)
               cou=cou+1
            else
               write(ifile,'(E14.8)')cb(k,j,i)
               cou=1
            endif
            nfod=nfod+cb(k,j,i)*dr3
         enddo
      enddo
   enddo
   call close_file(ifile)

   101   format(I5,3F16.6)
   102   format(I5,4F16.6)

   write(*,'('' N    (numint) : '',f6.3)')nfod
   call timing(t1,w1)
   call prtime(6,t1-t0,w1-w0,'cube')
end subroutine cube


subroutine primval(dx,dy,dz,dx2,dy2,dz2,alpr2,lao,f)
   implicit none
   integer lao
   real*8 f,dx2,dy2,dz2
   real*8 dx,dy,dz,alpr2

   goto (100,201,202,203,301,302,303,304,305,306) lao

   100  f=exp(-alpr2)
   return
   201  f=exp(-alpr2)*dx
   return
   202  f=exp(-alpr2)*dy
   return
   203  f=exp(-alpr2)*dz
   return
   301  f=exp(-alpr2)*dx2
   return
   302  f=exp(-alpr2)*dy2
   return
   303  f=exp(-alpr2)*dz2
   return
   304  f=exp(-alpr2)*dx*dy
   return
   305  f=exp(-alpr2)*dx*dz
   return
   306  f=exp(-alpr2)*dy*dz
   return

end subroutine primval

! routine with exp table lookup
subroutine primvalf(dx,dy,dz,dx2,dy2,dz2,alpr2,lao,nexp,a,f)
   implicit none
   integer lao,nexp
   real*8 a(0:nexp)
   real*8 f,dx2,dy2,dz2
   real*8 dx,dy,dz,alpr2

   goto (100,201,202,203,301,302,303,304,305,306) lao

   100  f=fastexp(nexp,a,alpr2)
   return
   201  f=fastexp(nexp,a,alpr2)*dx
   return
   202  f=fastexp(nexp,a,alpr2)*dy
   return
   203  f=fastexp(nexp,a,alpr2)*dz
   return
   301  f=fastexp(nexp,a,alpr2)*dx2
   return
   302  f=fastexp(nexp,a,alpr2)*dy2
   return
   303  f=fastexp(nexp,a,alpr2)*dz2
   return
   304  f=fastexp(nexp,a,alpr2)*dx*dy
   return
   305  f=fastexp(nexp,a,alpr2)*dx*dz
   return
   306  f=fastexp(nexp,a,alpr2)*dy*dz
   return

end subroutine primvalf

real*8 function fastexp(nexp,array,arg)
   integer nexp
   real*8 arg
   real*8 array(0:nexp)

   fastexp=array(int(100.0d0*arg))

end function fastexp

end module xtb_cube

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Calculation environment
module xtb_type_environment
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_systools, only : rdvar, rdarg
   use xtb_type_iohandler, only : TIOHandler, init_ => init
   implicit none
   private

   public :: TEnvironment, init


   !> Wrapper for characters
   type :: TMessage
      logical :: error
      character(len=:), allocatable :: message
   end type TMessage


   !> Calculation environment
   type :: TEnvironment

      !> Unit for IO
      integer :: unit

      !> Number of logged messages
      integer :: nLog

      !> Message log
      type(TMessage), allocatable :: log(:)
      
      !> Handle warnings as errors
      logical :: strict

      !> Actual executable name
      character(len=:),allocatable :: whoami

      !> Name of hosting machine
      character(len=:),allocatable :: hostname

      !> User's home directory
      character(len=:),allocatable :: home

      !> Systems path variable
      character(len=:),allocatable :: path

      !> Calculations path variable
      character(len=:),allocatable :: xtbpath

      !> Calculations home directory
      character(len=:),allocatable :: xtbhome

      !> File input/output handling
      type(TIOHandler) :: io

   contains

      !> Add a warning to the message log
      procedure :: warning

      !> Add an error to the message log
      procedure :: error

      !> Check status of environment
      procedure :: check

      !> Check status of environment
      procedure :: checkpoint

      !> Show and clear error log
      procedure :: show

      !> Forceful terminate the current run, use only in main drivers!
      procedure :: terminate => terminateRun

      !> Return log to string
      procedure :: getLog

      !> Rescue errors
      procedure :: rescue

   end type TEnvironment


   !> Constructor for the calculation environment
   interface init
      module procedure :: initEnvironment
   end interface


   !> Overloaded resize interface
   interface resize
      module procedure :: resizeMessage
   end interface resize


   !> Initial size of the message log
   integer, parameter :: initialSize = 20


contains


!> Construct the calculation environment
subroutine initEnvironment(self, strict)

   !> Calculation environment
   type(TEnvironment), intent(out) :: self
   
   !> Handle warnings as errors
   logical, intent(in), optional :: strict

   integer :: err

   self%unit = stdout
   self%nLog = 0
   allocate(self%log(initialSize))

   call rdarg(0, self%whoami, err)
   call rdvar('HOSTNAME', self%hostname, err)
   call rdvar('HOME', self%home, err)
   call rdvar('PATH', self%path, err)
   call rdvar('XTBHOME', self%xtbhome, err)
   if (.not.allocated(self%xtbhome)) self%xtbhome = ''
   if (err /= 0 .or. len(self%xtbhome) <= 0) then
      self%xtbhome = self%home
   end if
   call rdvar('XTBPATH', self%xtbpath, err)
   if (.not.allocated(self%xtbpath)) self%xtbpath = ''
   if (err /= 0 .or. len(self%xtbpath) <= 0) then
      self%xtbpath = self%xtbhome
   end if
   
   if (present(strict)) then
      self%strict = strict
   else
      self%strict = .false.
   end if

   call init_(self%io)

end subroutine initEnvironment


subroutine check(self, terminate)

   !> Calculation environment
   class(TEnvironment), intent(in) :: self

   !> Recommendation for terminating run
   logical, intent(out) :: terminate

   terminate = any(self%log(:self%nLog)%error)

end subroutine check


!> Check status of calculation environment
subroutine checkpoint(self, message)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Message in case of error
   character(len=*), intent(in) :: message

   !> Recommendation for terminating run
   logical :: terminate

   integer :: iLog

   call self%check(terminate)

   if (terminate) then
      call self%terminate(message)
   end if

end subroutine checkpoint


!> Check status of calculation environment
subroutine show(self, message, isError)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Message in case of error
   character(len=*), intent(in) :: message

   !> Recommendation for terminating run
   logical, intent(in), optional :: isError

   integer :: iLog
   logical :: isError0

   if (self%nLog > 0) then
      if (present(isError)) then
         isError0 = isError
      else
         call self%check(isError0)
      end if
      if (isError0) then
         write(self%unit, '(72("#"), /, "[ERROR]", 1x, a)') message
      else
         write(self%unit, '(72("#"), /, "[WARNING]", 1x, a)') message
      end if
      do iLog = self%nLog, 1, -1
         write(self%unit, '("-", i0, "-", 1x, a)') iLog, self%log(iLog)%message
         deallocate(self%log(iLog)%message)
      end do
      write(self%unit, '(72("#"))')
      self%nLog = 0
   end if

end subroutine show


!> Check status of calculation environment
subroutine getLog(self, message)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Message in case of error
   character(len=:), allocatable, intent(out) :: message

   integer :: iLog
   logical :: isError0
   character(len=512) :: buffer

   message = ''

   if (self%nLog > 0) then
      do iLog = self%nLog, 1, -1
         write(buffer, '("-", i0, "-", 1x, a)') iLog, self%log(iLog)%message
         deallocate(self%log(iLog)%message)
         if (len_trim(message) > 0) then
            message = message // new_line('a') // trim(buffer)
         else
            message = trim(buffer)
         end if
      end do
      self%nLog = 0
   end if

end subroutine getLog


subroutine terminateRun(self, message, code)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Message in case of error
   character(len=*), intent(in) :: message

   !> Exit code for termination
   integer, intent(in), optional :: code

   interface
      subroutine terminate(code)
         integer, intent(in) :: code
      end subroutine terminate
   end interface


   call self%error(message)

   call self%show("Program stopped due to fatal error", .true.)

   if (present(code)) then
      call terminate(code)
   else
      call terminate(1)
   end if

end subroutine terminateRun


!> Create and push back a new error to the message log
subroutine error(self, message, source)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Error message
   character(len=*), intent(in) :: message

   !> Source of the error message
   character(len=*), intent(in), optional :: source

   if (self%nLog >= size(self%log)) then
      call resize(self%log)
   end if

   self%nLog = self%nLog + 1
   if (present(source)) then
      self%log(self%nLog) = TMessage(.true., source // ": " // message)
   else
      self%log(self%nLog) = TMessage(.true., message)
   end if

end subroutine error


!> Create and push back a new error to the message log
subroutine warning(self, message, source)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Error message
   character(len=*), intent(in) :: message

   !> Source of the error message
   character(len=*), intent(in), optional :: source

   if (self%nLog >= size(self%log)) then
      call resize(self%log)
   end if

   self%nLog = self%nLog + 1
   if (present(source)) then
      self%log(self%nLog) = TMessage(self%strict, source // ": " // message)
   else
      self%log(self%nLog) = TMessage(self%strict, message)
   end if

end subroutine warning


!> Catch errors and continue
subroutine rescue(self, message, source)

   !> Calculation environment
   class(TEnvironment), intent(inout) :: self

   !> Error message
   character(len=*), intent(in) :: message

   !> Source of the error message
   character(len=*), intent(in), optional :: source

   integer :: iLog

   do iLog = 1, self%nLog
      self%log(iLog)%error = self%strict
   end do

   call self%warning(message, source)

end subroutine rescue


!> Reallocate message list
subroutine resizeMessage(var, n)

   !> Message list
   type(TMessage), allocatable, intent(inout) :: var(:)

   !> Desired size
   integer, intent(in), optional :: n

   type(TMessage), allocatable :: tmp(:)
   integer :: length, currentLength

   currentLength = size(var)
   if (currentLength > 0) then
      if (present(n)) then
         if (n <= currentLength) return
         length = n
      else
         length = currentLength + currentLength/2 + 1
      endif
      allocate(tmp(length))
      tmp(:currentLength) = var(:currentLength)
      deallocate(var)
      call move_alloc(tmp, var)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(var(length))
   endif

end subroutine resizeMessage


end module xtb_type_environment

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!cccccccccccccccccccccccccccccccc
!    write out Molden input     c
!cccccccccccccccccccccccccccccccc
! ncent  : # atoms
! nmo    : # MOs
! nbf    : # AOs
! nprims : # primitives (in total)
! xyz(4,ncent) : Cartesian coordinates & nuclear charge
! cxip(nprims) : contraction coefficients of primitives
! exip(nprims) : exponents of primitives
! cmo(nbf,nmo) : LCAO-MO coefficients
! eval(nmo)    : orbital eigenvalues
! occ(nmo)     : occupation # of MO
! ipty(nprims) : angular momentum of primitive function
! ipao(nbf)    : # primitives in contracted AO
! ibf(ncent)   : # of contracted AOs on atom


subroutine printmold(ncent,nmo,nbf,xyz,at,cmo,eval,occ,thr,basis)
   use xtb_mctc_symbols, only : toSymbol
   use xtb_type_basisset
   implicit none
   type(TBasisset), intent(in) :: basis
   real*8, intent ( in ) :: xyz(3,ncent)
   real*8, intent ( in ) :: eval(nmo)
   real*8, intent ( in ) :: occ (nmo)
   real*8, intent ( in ) :: cmo(nbf,nmo)
   real*8, intent ( in ) :: thr
   integer, intent( in ) :: at(ncent)
   integer, intent( in ) :: ncent,nmo,nbf
   ! temporary variables
   integer i,j,k,icount,jcount,z,nmomax,nop
   real*8 dum
   character*1 aang
   character*2 atyp
   logical skip
   integer :: iwfn

   iwfn=29
   call open_file(iwfn,'molden.input','w')


   write(iwfn,'(A)',advance='yes')'[Molden Format]'
   write(iwfn,'(A)',advance='yes')'[Title]'

   !cccccccccccccccccccccccccccccccccccccccccccccccc
   ! print out atoms & coordinates                 c
   !cccccccccccccccccccccccccccccccccccccccccccccccc

   write(iwfn,'(A)',advance='yes')'[Atoms] AU'
   ! either coordinates are given in a.u.
   do i = 1,ncent
      atyp = toSymbol(at(i))
      z=at(i)
      ! atom character, running number, nuclear charge, x,y,z coordin
      write (iwfn,'(a2,2i6,3E22.14)') &
         &   atyp,i,z,xyz(1,i),xyz(2,i),xyz(3,i)
   enddo
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   ! Now print basis set data                                   c
   !                                                            c
   ! go through atoms and assign orbitals (contracted & prims)  c
   ! search for [GTO] statement to read basis set data          c
   ! for each set of atomic orbitals                            c
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   write(iwfn,'(A)',advance='yes') '[GTO]'
   !ccccccccccccccccccc
   ! go through atoms c
   !ccccccccccccccccccc
   icount=1
   do i=1,ncent
      write(iwfn,*) i,'0' ! I don't know what the zero is needed for
      !  now go trough nbfs located on atom i
      do j=basis%fila(1,i),basis%fila(2,i)
         call ang2chr(basis%lao(j),aang,skip)
         if(skip)then
            do k=1,basis%nprim(j)
               icount=icount+1
            enddo
         else
            write(iwfn,*) aang,basis%nprim(j),1.00
            do k=1,basis%nprim(j)
               write(iwfn,*) basis%alp(icount),basis%cont(icount)
               icount=icount+1
            enddo
         endif
      enddo
      write(iwfn,*)
   enddo

   nmomax=0
   do i=1,nmo
      if(eval(i).gt.thr.and.nmomax.eq.0)nmomax=i-1
   enddo
   if(nmomax.eq.0) nmomax=nmo

   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   ! print occupation number of orbitals and orbital energies c
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   write(iwfn,'(A)',advance='yes') '[MO]'
   ! restricted xtb_printout
   do i=1,nmomax
      ! MO info
      write(iwfn,'(A)',advance='no') 'Sym= '
      write(iwfn,'(i5,a1)') i,'a'
      write(iwfn,'(A)',advance='no') 'Ene= '
      dum=0
      write(iwfn,*) eval(i)
      write(iwfn,'(A)',advance='no') 'Spin= '
      write(iwfn,'(A)',advance='yes') 'Alpha' ! for now just conside
      write(iwfn,'(A)',advance='no') 'Occup= '
      write(iwfn,'(F14.8)') occ(i)
      !now coefficients
      ! a notion: for l>0, the ordering is p: x,y,z ; d: xx,yy,zz,xy
      do j=1,nbf
         write(iwfn,*) j,cmo(j,i)
      enddo
   enddo
   call close_file(iwfn)
end subroutine

! true U version
subroutine printumold(ncent,nmo,nbf,xyz,at,cmoa,cmob,evala,&
      &                      evalb,occa,occb,thr,basis)
   use xtb_mctc_symbols, only : toSymbol
   use xtb_type_basisset
   implicit none
   type(TBasisset), intent(in) :: basis
   real*8, intent ( in ) :: xyz(3,ncent)
   real*8, intent ( in ) :: evala(nmo)
   real*8, intent ( in ) :: evalb(nmo)
   real*8, intent ( in ) :: occa(nmo)
   real*8, intent ( in ) :: occb(nmo)
   real*8, intent ( in ) :: cmoa(nbf,nmo)
   real*8, intent ( in ) :: cmob(nbf,nmo)
   real*8, intent ( in ) :: thr
   integer, intent( in ) :: at(ncent)
   integer, intent( in ) :: ncent,nmo,nbf
   ! temporary variables
   integer i,j,k,icount,jcount,z,nmomax,nop
   real*8 dum
   character*1 aang
   character*2 atyp
   logical skip
   integer :: iwfn

   iwfn=29
   call open_file(iwfn,'molden.input','w')

   write(iwfn,'(A)',advance='yes')'[Molden Format]'
   write(iwfn,'(A)',advance='yes')'[Title]'

   !cccccccccccccccccccccccccccccccccccccccccccccccc
   ! print out atoms & coordinates                 c
   !cccccccccccccccccccccccccccccccccccccccccccccccc

   write(iwfn,'(A)',advance='yes')'[Atoms] AU'
   ! either coordinates are given in a.u.
   do i = 1,ncent
      atyp = toSymbol(at(i))
      z=at(i)
      ! atom character, running number, nuclear charge, x,y,z coordin
      write (iwfn,'(a2,2i6,3E22.14)') &
         &   atyp,i,z,xyz(1,i),xyz(2,i),xyz(3,i)
   enddo
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   ! Now print basis set data                                   c
   !                                                            c
   ! go through atoms and assign orbitals (contracted & prims)  c
   ! search for [GTO] statement to read basis set data          c
   ! for each set of atomic orbitals                            c
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   write(iwfn,'(A)',advance='yes') '[GTO]'
   !ccccccccccccccccccc
   ! go through atoms c
   !ccccccccccccccccccc
   icount=1
   do i=1,ncent
      write(iwfn,*) i,'0' ! I don't know what the zero is needed for
      !  now go trough nbfs located on atom i
      do j=basis%fila(1,i),basis%fila(2,i)
         call ang2chr(basis%lao(j),aang,skip)
         if(skip)then
            do k=1,basis%nprim(j)
               icount=icount+1
            enddo
         else
            write(iwfn,*) aang,basis%nprim(j),1.00
            do k=1,basis%nprim(j)
               write(iwfn,*) basis%alp(icount),basis%cont(icount)
               icount=icount+1
            enddo
         endif
      enddo
      write(iwfn,*)
   enddo

   nmomax=0
   do i=1,nmo
      if(evala(i).gt.thr.and.nmomax.eq.0)nmomax=i-1
   enddo
   if(nmomax.eq.0) nmomax=nmo

   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   ! print occupation number of orbitals and orbital energies c
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   write(iwfn,'(A)',advance='yes') '[MO]'
   ! Alpha MOs
   do i=1,nmomax
      write(iwfn,'(A)',advance='no') 'Sym= '
      write(iwfn,'(i5,a1)') i,'a (alpha)'
      write(iwfn,'(A)',advance='no') 'Ene= '
      write(iwfn,*) evala(i)
      write(iwfn,'(A)',advance='no') 'Spin= '
      write(iwfn,'(A)',advance='yes') 'Alpha'
      write(iwfn,'(A)',advance='no') 'Occup= '
      write(iwfn,'(F14.8)') occa(i)
      !now coefficients
      ! a notion: for l>0, the ordering is p: x,y,z ; d: xx,yy,zz,xy
      do j=1,nbf
         write(iwfn,*) j,cmoa(j,i)
      enddo
   enddo
   ! Beta MOs
   do i=1,nmomax
      write(iwfn,'(A)',advance='no') 'Sym= '
      write(iwfn,'(i5,a1)') i,'a (beta)'
      write(iwfn,'(A)',advance='no') 'Ene= '
      write(iwfn,*) evalb(i)
      write(iwfn,'(A)',advance='no') 'Spin= '
      write(iwfn,'(A)',advance='yes') 'Beta'
      write(iwfn,'(A)',advance='no') 'Occup= '
      write(iwfn,'(F14.8)') occb(i)
      !now coefficients
      ! a notion: for l>0, the ordering is p: x,y,z ; d: xx,yy,zz,xy
      do j=1,nbf
         write(iwfn,*) j,cmob(j,i)
      enddo
   enddo

   call close_file(iwfn)
end subroutine

! this routine gives character s,p,d etc. if angular momentum is given a
subroutine ang2chr(iang,chr,skip)
   implicit none
   character*1, intent( out ) :: chr
   integer, intent( in ) :: iang
   logical, intent( inout ) :: skip

   skip=.false.
   select case(iang)
   case(1)
      chr='s'
   case(2)
      chr='p'
   case(3)
      chr='p'
      skip=.true.
   case(4)
      chr='p'
      skip=.true.
   case(5)
      chr='d'
   case(6)
      chr='d'
      skip=.true.
   case(7)
      chr='d'
      skip=.true.
   case(8)
      chr='d'
      skip=.true.
   case(9)
      chr='d'
      skip=.true.
   case(10)
      chr='d'
      skip=.true.
   end select
end subroutine




!ccccccccccccccccccccccccccccccccccccccccccccc
!
! specifies the length of an integer
!
!ccccccccccccccccccccccccccccccccccccccccccccc
subroutine lenint(iin,iout)
   implicit none
   integer, intent( in ) :: iin
   integer, intent( out) :: iout
   integer mdim,jdim
   jdim=0
   iout=0
   do
      iout=iout+1
      jdim=10*jdim+9
      mdim=iin-jdim
      if(mdim.le.0) exit
   enddo
   return
end subroutine

!     *****************************************************************

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_david2
contains

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! real*4 version
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine sdavid2(n,crite,H,C,e,fail)
   use xtb_mctc_accuracy, only : wp => sp
   use xtb_mctc_lapack, only : lapack_syevd
   use xtb_mctc_blas, only : blas_copy, blas_axpy, blas_dot, blas_spmv
   implicit none
   logical,parameter :: pr = .false.
   logical,parameter :: ini = .false.
   integer n       ! dimension
   integer,parameter :: nr = 1
   real(wp)  crite   ! eigenvalue convergence threshold
   real(wp)  H(n,n)  ! matrix to be diagonalized
   real(wp)  C(n,nr) ! eigenvectors
   real(wp)  e(nr)   ! eigenvalues
   logical,intent(out) :: fail

   ! local
   integer maxiter        ! maximum # of iterations
   parameter (maxiter=100)
   integer iter,ineue(1),janf,lun1,lun2
   integer iideks(maxiter),idum,j,jalt,ilauf,jneu
   integer l1,l2,k,LWORK,LIWORK,INFO,i,ien,ialt,memlun2
   integer,allocatable :: iwork(:)
   logical lconf

   real(wp) valn(1),uim,s,one,zero,denerg
   real(wp), allocatable :: adiag(:),vecf1(:),vecf2(:),w(:)
   real(wp), allocatable :: Uaug(:,:),d(:),aux(:)
   real(wp), allocatable :: AB(:,:),av(:),tmpav(:,:)
   real(wp), allocatable :: HP(:)
   parameter (one =1)
   parameter (zero=0)

   fail = .true.

   if(pr)then
      write(*,'(/,10x,''******************************************'')')
      write(*,'(10x,''*            multi-root davidson (R4)    *'')')
      write(*,'(10x,''******************************************'',/)')
      write(*,*) 'dim ',n,' # roots ',1
   endif

   allocate(adiag(n),vecf1(n),vecf2(n),w(n),av(maxiter*(maxiter+1)/2), &
      &     HP(n*(n+1)/2))

   ! IO
   lun1=86
   lun2=87
   open(unit=lun1,recl=n*4,access='direct',file='david1.tmp',form='unformatted')
   open(unit=lun2,recl=n*4,access='direct',file='david2.tmp',form='unformatted')

   k=0
   do i=1,n
      do j=1,i
         k=k+1
         HP(k)=H(j,i)
      enddo
   enddo

   ! H * C for initialization
   call smwrite(n,lun1,C(1,1),1)
   call blas_spmv('U',n,  ONE,HP, C(:,1),1,ZERO,vecf2,1)
   call smwrite(n,lun2,vecf2,1)

   ! aufbau des iideks feldes
   iideks(1) = 1
   do idum = 2,maxiter
      iideks(idum) = iideks(idum - 1) + idum
   enddo
   valn = 0
   lconf= .false.
   e    = 0

   do i=1,n
      adiag(i)=H(i,i)
   enddo

   av(1)=blas_dot(n,C(:,1),1,vecf2,1)
   ! done

   j = 1

   !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
   ! eigentliche schleife im davidson
   !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

   do iter = 1, maxiter-1

      lwork  = 1 + 6*j + 2*j**2
      liwork = 8*j
      allocate(Uaug(j,j),d(j),iwork(liwork),aux(lwork))

      k=0
      do l1=1,j
         do l2=1,l1
            k=k+1
            Uaug(l2,l1) = av(k)
            Uaug(l1,l2) = av(k)
         enddo
      enddo
      call lapack_syevd('V','U',j,Uaug,j,d,aux,LWORK,IWORK,LIWORK,INFO)
      valn(1:1) = d(1:1)

      ! aufbau der eigentlichen vektoren, die stehen dann auf vecf1
      ! multiplikation der vorherigen entwicklungsvektoren mit den entwicklungskoeffizienten
      vecf1=0.0_wp
      do i=1,j
         call smread(n,lun1,w,i)
         uim = Uaug(i,1)
         call blas_axpy(n,uim,w,1,vecf1,1)
      enddo

      ! aufbau -E*bi: vecf1 ist bi; vecf2 dann E*bi
      vecf2 = -valn(1) * vecf1
      ! aufbau des residuen vektors (h*bi-e*bi)
      ! steht dann auf vecf2 ueberschreibt also -e*bi
      ! h*bi-e*bi steht jetzt auf vecf2
      do i=1,j
         call smread(n,lun2,w,i)
         memlun2 = i
         uim = Uaug(i,1)
         call blas_axpy(n,uim,w,1,vecf2,1)
      enddo
      deallocate(Uaug,d,iwork,aux)

      C(1:n,1)=vecf1

      ! aufbau (h*bi - e*bi)/(e - haa); steht danach auf vecf2
      vecf1=vecf2/(valn(1)-adiag)

      denerg = abs(valn(1) - e(1))
      lconf = abs(valn(1) - e(1)) .lt. crite
      if (pr) write(*,*) iter,lconf,denerg,valn(1:1)

      if (lconf) then
         if (pr) write(*,*) 'all roots converged'
         fail = .false.
         go to 99
      endif

      if (j.gt.0) then
         !-- mit allen alten
         ialt = j
         ! orthogonaliesung des betrachteten auf die alten
         do jalt = 1,ialt
            call smread(n,lun1,w,jalt)
            s=-blas_dot(n,w,1,vecf1,1)
            call blas_axpy(n,s,w,1,vecf1,1)
         enddo
         ! normierung dessen was vom betrachteten uebrig bleibt
         s=blas_dot(n,vecf1,1,vecf1,1)
         if (s.gt.0.00000001) then
            ! neuer wird mitgenommen
            s = ONE /sqrt(s)
            vecf1= vecf1 * s
            ialt = ialt + 1
            ! wegschreiben des neuen zu den alten
            call smwrite(n,lun1,vecf1,jalt)
         else
            fail = .false.
            goto 99
         endif
      endif

      ! H * C
      call blas_spmv('U',n,  ONE,HP, vecf1,1,ZERO,vecf2,1)

      call smwrite(n,lun2,vecf2,memlun2+1)

      ! berechnung der neuen matrixelemente der davidson-matrix
      ! zunaechst mit den alten
      do jalt = 1,j
         call smread(n,lun1,w,jalt)
         ilauf = iideks(j) + jalt
         av(ilauf) = blas_dot(n,w,1,vecf2,1)
         ilauf = ilauf + 1 + j
      enddo
      ! dann mit den neuen
      av(iideks(j+1)) = blas_dot(n,vecf2,1,vecf1,1)

      ! increase expansion space and iterate further
      e = valn
      j = j + 1

   enddo

   if(pr) write(*,*) 'Warning: davidson not properly converged'
   ! exit

99 continue

   deallocate(adiag,vecf1,vecf2,w,av,HP)
   close (lun1,status='delete')
   close (lun2,status='delete')

end subroutine sdavid2

subroutine solver_sdavidson(n,crite,Hp,C,e,fail,pr)
   use xtb_mctc_accuracy, only : wp => sp
   use xtb_mctc_lapack, only : lapack_syevd
   use xtb_mctc_blas, only : blas_copy, blas_axpy, blas_dot, mctc_spmv
   implicit none
   logical, intent(in) :: pr
   logical,parameter :: ini = .false.
   integer n       ! dimension
   integer,parameter :: nr = 1
   real(wp)  crite   ! eigenvalue convergence threshold
   real(wp)  Hp(n*(n+1)/2)  ! matrix to be diagonalized
   real(wp)  C(n,nr) ! eigenvectors
   real(wp)  e(nr)   ! eigenvalues
   logical,intent(out) :: fail

   ! local
   integer maxiter        ! maximum # of iterations
   parameter (maxiter=100)
   integer iter,ineue(1),janf!,lun1,lun2
   integer iideks(maxiter),idum,j,jalt,ilauf,jneu
   integer l1,l2,k,LWORK,LIWORK,INFO,i,ien,ialt,memlun2
   integer,allocatable :: iwork(:)
   logical lconf
   real(wp), allocatable :: lun1(:,:),lun2(:,:)
   integer, parameter :: initial_dyn_array_size = 10

   real(wp) valn(1),uim,s,denerg
   real(wp), allocatable :: adiag(:),vecf1(:),vecf2(:),w(:)
   real(wp), allocatable :: Uaug(:,:),d(:),aux(:)
   real(wp), allocatable :: AB(:,:),av(:),tmpav(:,:)

   fail = .true.

   if (pr) then
      write(*,'(/,10x,''******************************************'')')
      write(*,'(10x,''*            multi-root davidson (R4)    *'')')
      write(*,'(10x,''******************************************'',/)')
      write(*,*) 'dim ',n,' # roots ',1
   endif

   allocate(adiag(n),vecf1(n),vecf2(n),w(n),av(maxiter*(maxiter+1)/2))

   allocate(lun1(n,initial_dyn_array_size), lun2(n,initial_dyn_array_size), &
      &     source = 0.0_wp)
   ! IO
   !lun1=86
   !lun2=87
   !open(unit=lun1,recl=n*4,access='direct',status='scratch',form='unformatted')
   !open(unit=lun2,recl=n*4,access='direct',status='scratch',form='unformatted')

   ! H * C for initialization
   call smwrite(n,lun1,C(1,1),1)
   call mctc_spmv(HP, C(:,1), vecf2)
   call smwrite(n,lun2,vecf2,1)

   ! aufbau des iideks feldes
   iideks(1) = 1
   do idum = 2,maxiter
      iideks(idum) = iideks(idum - 1) + idum
   enddo
   valn = 0
   lconf= .false.
   e    = 0

   do i=1,n
      adiag(i)=HP(i*(i+1)/2)
   enddo

   av(1)=blas_dot(n,C(:,1),1,vecf2,1)
   ! done

   j = 1

   !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
   ! eigentliche schleife im davidson
   !CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

   do iter = 1, maxiter-1

      lwork  = 1 + 6*j + 2*j**2
      liwork = 8*j
      allocate(Uaug(j,j),d(j),iwork(liwork),aux(lwork))

      k=0
      do l1=1,j
         do l2=1,l1
            k=k+1
            Uaug(l2,l1) = av(k)
            Uaug(l1,l2) = av(k)
         enddo
      enddo
      call lapack_syevd('V','U',j,Uaug,j,d,aux,LWORK,IWORK,LIWORK,INFO)
      valn(1:1) = d(1:1)

      ! aufbau der eigentlichen vektoren, die stehen dann auf vecf1
      ! multiplikation der vorherigen entwicklungsvektoren mit den entwicklungskoeffizienten
      vecf1=0.0_wp
      do i=1,j
         call smread(n,lun1,w,i)
         uim = Uaug(i,1)
         call blas_axpy(n,uim,w,1,vecf1,1)
      enddo

      ! aufbau -E*bi: vecf1 ist bi; vecf2 dann E*bi
      vecf2 = -valn(1) * vecf1
      ! aufbau des residuen vektors (h*bi-e*bi)
      ! steht dann auf vecf2 ueberschreibt also -e*bi
      ! h*bi-e*bi steht jetzt auf vecf2
      do i=1,j
         call smread(n,lun2,w,i)
         memlun2 = i
         uim = Uaug(i,1)
         call blas_axpy(n,uim,w,1,vecf2,1)
      enddo
      deallocate(Uaug,d,iwork,aux)

      C(1:n,1)=vecf1

      ! aufbau (h*bi - e*bi)/(e - haa); steht danach auf vecf2
      vecf1=vecf2/(valn(1)-adiag)

      denerg = abs(valn(1) - e(1))
      lconf = abs(valn(1) - e(1)) .lt. crite
      if (pr) write(*,*) iter,lconf,denerg,valn(1:1)

      if (lconf) then
         if (pr) write(*,*) 'all roots converged'
         fail = .false.
         go to 99
      endif

      if (j.gt.0) then
         !-- mit allen alten
         ialt = j
         ! orthogonaliesung des betrachteten auf die alten
         do jalt = 1,ialt
            call smread(n,lun1,w,jalt)
            s=-blas_dot(n,w,1,vecf1,1)
            call blas_axpy(n,s,w,1,vecf1,1)
         enddo
         ! normierung dessen was vom betrachteten uebrig bleibt
         s=blas_dot(n,vecf1,1,vecf1,1)
         if (s.gt.0.00000001) then
            ! neuer wird mitgenommen
            s = 1.0_wp /sqrt(s)
            vecf1= vecf1 * s
            ialt = ialt + 1
            ! wegschreiben des neuen zu den alten
            call smwrite(n,lun1,vecf1,jalt)
         else
            fail = .false.
            goto 99
         endif
      endif

      ! H * C
      call mctc_spmv(HP, vecf1, vecf2)

      call smwrite(n,lun2,vecf2,memlun2+1)

      ! berechnung der neuen matrixelemente der davidson-matrix
      ! zunaechst mit den alten
      do jalt = 1,j
         call smread(n,lun1,w,jalt)
         ilauf = iideks(j) + jalt
         av(ilauf) = blas_dot(n,w,1,vecf2,1)
         ilauf = ilauf + 1 + j
      enddo
      ! dann mit den neuen
      av(iideks(j+1)) = blas_dot(n,vecf2,1,vecf1,1)

      ! increase expansion space and iterate further
      e = valn
      j = j + 1

   enddo

   if(pr) write(*,*) 'Warning: davidson not properly converged'
   ! exit

99 continue

   deallocate(adiag,vecf1,vecf2,w,av,lun1,lun2)
   !close (lun1,status='delete')
   !close (lun2,status='delete')

contains

subroutine smwrite(n,iwo,v,irec)
   implicit none
   real(wp), intent(inout), allocatable :: iwo(:,:)
   real(wp), intent(in)  :: v(n)
   integer,  intent(in)  :: n,irec
   real(wp), allocatable :: tmp(:,:)
   integer :: d2,dn
   d2 = size(iwo,2)
   if (irec > d2) then
      dn = d2 + d2/2 + 1
      allocate(tmp(n,dn))
      tmp(:,:d2) = iwo
      deallocate(iwo)
      call move_alloc(tmp,iwo)
   endif
   iwo(:,irec) = v
   !write(iwo,rec=irec) v
   !return
end subroutine smwrite

subroutine smread(n,iwo,v,irec)
   implicit none
   real(wp), intent(out) :: v(n)
   real(wp), intent(in)  :: iwo(:,:)
   integer,  intent(in)  :: n,irec
   v = iwo(:,irec)
   !read(iwo,rec=irec) v
   !return
end subroutine smread

end subroutine solver_sdavidson

end module xtb_david2

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_optimizer
   use xtb_io_writer, only : writeMolecule
   use xtb_mctc_accuracy, only : wp, sp
   use xtb_mctc_fileTypes, only : fileType
   use xtb_type_environment, only : TEnvironment
   use xtb_extern_turbomole, only : TTMCalculator
   use xtb_bfgs
   use xtb_hessian, only : numhess
   use xtb_david2
   implicit none

   !> time profiling
   logical,private,parameter :: profile = .true.

   type :: convergence_log
      integer :: nlog
      real(wp), allocatable :: elog(:)
      real(wp), allocatable :: glog(:)
   contains
      procedure :: set_eg_log
      procedure :: get_averaged_energy
      procedure :: get_averaged_gradient
   end type convergence_log
   interface convergence_log
      module procedure new_convergence_log
   end interface convergence_log

contains

!> construct optimizer settings from optimization level
subroutine get_optthr(n,olev,ethr,gthr,maxcycle,acc)
   use xtb_setparam
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: olev
   real(wp),intent(out) :: ethr
   real(wp),intent(out) :: gthr
   integer, intent(out) :: maxcycle
   real(wp),intent(out) :: acc
   
   select case(olev)
   ! very approximate = crude !
   case(p_olev_crude)
      ethr   = 5.d-4
      gthr   = 1.d-2
      maxcycle=n
      acc=3.00d0
   
   ! approximate = sloopy !
   case(p_olev_sloppy)
      ethr   = 1.d-4
      gthr   = 6.d-3
      maxcycle=n
      acc=3.00d0
   
   ! loose !
   case(p_olev_loose)
      ethr   = 5.d-5
      gthr   = 4.d-3
      maxcycle=n*2
      acc=2.00d0

   ! for DCOSMO-RS opts with TM i.e. between loose and normal !
   case(p_olev_lax)
      ethr   = 2.d-5
      gthr   = 2.5d-3
      maxcycle=n*2
      acc=2.00d0
   
   ! normal !
   case default
      ethr  = 5.d-6
      gthr  = 1.d-3
      maxcycle=n*3
      acc=1.0d0
   
   ! tight !
   case(p_olev_tight)
      ethr   = 1.d-6
      gthr   = 8.d-4
      maxcycle=n*5
      acc=0.20d0

   ! very tight !
   case(p_olev_vtight)
      ethr   = 1.d-7
      gthr   = 2.d-4
      maxcycle=n*20
      acc=0.05d0

   ! extreme !
   case(p_olev_extreme)
      ethr   = 5.d-8
      gthr   = 5.d-5
      maxcycle=n*20
      acc=0.01d0
   end select
   
   maxcycle=min(maxcycle,10000)
   maxcycle=max(maxcycle,200)

end subroutine get_optthr

!> Approximate Normal Coordinate rational function optimizer 
subroutine ancopt(env,ilog,mol,chk,calc, &
      &           egap,et,maxiter,maxcycle_in,etot,g,sigma,tight,pr,fail)
   
   use xtb_mctc_convert
   use xtb_mctc_la

   use xtb_type_molecule
   use xtb_type_anc
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_type_timer

   use xtb_setparam
   use xtb_fixparam

   use xtb_setmod, only : int2optlevel

   use xtb_axis, only : axis2
   use xtb_hessian, only : trproj,rdhess
   use xtb_readin
   use xtb_lsrmsd

   implicit none
   
   !> traceback for error handling 
   character(len=*), parameter :: source = "optimizer_ancopt"
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(inout) :: mol
   
   !> optimization level
   integer, intent(in)    :: tight
   
   !> max number of SCC cycles
   integer, intent(in)    :: maxiter
   
   !> max number of optimization cycles
   integer, intent(in)    :: maxcycle_in
   
   !> wrapper for changing info during SCC
   type(TRestart),intent(inout) :: chk

   !> polymorphic calculator instance
   class(TCalculator), intent(inout) :: calc
   
   !> electronic energy
   real(wp) :: eel

   !> total energy
   real(wp),intent(inout) :: etot
   
   !> electronic temperature
   real(wp),intent(in)    :: et
   
   !> HOMO-LUMO gap
   real(wp),intent(inout) :: egap
   
   !> gradients
   real(wp),intent(inout) :: g(3,mol%n)
   
   !> strain derivatives
   real(wp),intent(inout) :: sigma(3,3)
   
   !> printlevel
   logical, intent(in)    :: pr
   
   !> optimization failure
   logical, intent(out)   :: fail

!-----------------!   
! local variables !
!-----------------!   
   
   type(TMolecule) :: molopt
   type(scc_results) :: res
   type(tb_anc) :: anc
   type(tb_timer) :: timer

   !> maximum coordinate displacement
   real(wp) :: maxdispl

   !> lowest value for force constant
   real(wp) :: hlow

   !> highest value for force constant
   real(wp) :: hmax 

   !> dispersion scaling
   real(wp) :: s6

   !> total energy from initial single point callculation
   real(wp) :: estart

   !> energy & gradient convergence thresholds
   real(wp) :: ethr, gthr
   
   
   !> number of modes followed
   integer :: modef
   
   !> max number of opt cycles
   integer :: maxopt

   !> max number of opt cycles before generation of new ANC
   integer :: maxmicro
   
   !> algorithm for updating Hessian  
   integer :: iupdat ! 0 = BFGS, 1 = Powell
   
   !> current iteration 
   integer :: iter

   !> number of atomic coordinates
   integer :: nat3

   !> deegrees of freedom
   integer :: nvar

   !> work array size
   integer :: lwork, liwork

   !> step size for numerical Hessian
   real(wp) :: step_hess

   real(wp) :: step,amu2au,au2cm,dumi,dumj,damp,edum,thr,aaa,bbb
   real(wp) :: energy,acc,rij(3),t1,t0,w1,w0,ccc

   integer  :: n3,i,j,k,l,jjj,ic,jc,ia,ja,ii,jj,info
   integer  :: nread,itry,iii
   integer  :: id,ihess,error
   integer, intent(in)  :: ilog
   integer, external    :: lin

   !> Hessian matrix
   real(wp),allocatable :: h (:,:), hess_tmp(:,:)

   real(wp),allocatable :: b (:,:)
   real(wp),allocatable :: pmode(:,:)
   real(wp),allocatable :: grmsd(:,:)

   !> force constants
   real(wp),allocatable :: fc(:)

   !> eigenvalues
   real(wp),allocatable :: eig(:)

   real(wp),allocatable :: aux(:)
   real(wp),allocatable :: hess(:)
   integer, allocatable :: iwork(:)
   integer, allocatable :: totsym(:)
   type(convergence_log), allocatable :: avconv
   
   real(wp) :: U(3,3), x_center(3), y_center(3), rmsdval
   real(wp) :: esave
   logical :: restart,ex,converged
   
   !> if linear molecule
   logical :: linear

   !> dipole
   real(wp),allocatable :: dipgrad(:,:)
   integer, allocatable :: list(:)
   
   !> formatting strings for output 
   character(len=*),parameter :: scifmt = &
      '(10x,":",3x,a,e22.7,1x,a,1x,":")'
   character(len=*),parameter :: dblfmt = &
      '(10x,":",3x,a,f18.7,5x,a,1x,":")'
   character(len=*),parameter :: intfmt = &
      '(10x,":",3x,a,i18,      10x,":")'
   character(len=*),parameter :: chrfmt = &
      '(10x,":",3x,a,a18,      10x,":")'
  
   !> error string
   character(len=128) :: errStr
   
   !> debug mode
   logical, parameter :: debug(2) = [.false.,.false.]
   character(len=9):: hessfmt

   ! print ANCopt header !
   call ancopt_header(env%unit,set%veryverbose)
   
   if(mol%n.eq.1) return ! skip optimization for 1 atom 

   ! performance profiling timer !
   if (profile) call timer%new(8,.false.)
   if (profile) call timer%measure(1,'optimizer setup')
   
   ! defaults !
   iter = 0
   fail  = .false.
   modef = 0
   iupdat= 0 
   hmax  = 5.0_wp
   nat3 = 3 * mol%n
   maxdispl = set%optset%maxdispl_opt  ! def: 1.0
   hlow = set%optset%hlow_opt          ! def: 0.01 
   s6   = set%mhset%s6                 ! def: 20.0
   maxmicro=set%optset%micro_opt       ! def: 20 
   estart = etot
   call get_optthr(mol%n,tight,ethr,gthr,maxopt,acc)
   
   ! if provided by user !
   if(maxcycle_in.gt.0)then
      maxopt=maxcycle_in
   endif
   if(maxopt.lt.maxmicro) maxmicro=maxopt
   
   ! use Powell update if TS optimization ! 
   if(set%tsopt)then
      hlow=max(hlow,0.250d0)
      iupdat=1
   endif
   
   ! energy and gradient averaging !
   if (set%optset%average_conv) then ! default: .false.
      select type(calc)
      class is(TTMCalculator)
         avconv = load_turbomole_log(maxopt)
         if (avconv%nlog > 0 .and. pr) then
            write(env%unit, '(a, 1x, i0, 1x, a)') &
               "Convergence averaging initialized with", avconv%nlog, "entries"
         end if
      class default
         avconv = convergence_log(maxopt)
      end select
   end if

   ! determine if linear molecule via rotational constants !
   call axis2(mol%n,mol%xyz,aaa,bbb,ccc,dumi,dumj)
   if (ccc.lt.1.d-10) then
      linear = .true.
      nvar = nat3 - 5
   else
      linear = .false.
      nvar = nat3 - 6
   endif

   ! exact fixing case ! 
   if(fixset%n.gt.0) then 
      nvar = nat3 - 3*fixset%n - 3
      if(nvar.le.0) nvar=1
   endif

   ! adjust if restrated !
   call open_binary(id,'.xtbtmpmode','r')
   if(id.ne.-1)then
      read (id) modef
      allocate(pmode(nat3,modef))
      read (id) pmode
      call close_file(id)
      nvar=nvar-modef
   else
      allocate(pmode(nat3,1)) ! dummy allocated
   endif

   ! print ANCopt settings !
   if(pr)then
      write(env%unit,'(/,10x,51("."))')
      write(env%unit,'(10x,":",22x,a,22x,":")') "SETUP"
      write(env%unit,'(10x,":",49("."),":")')
      write(env%unit,chrfmt) "optimization level", int2optlevel(tight)
      write(env%unit,intfmt) "max. optcycles    ", maxopt
      write(env%unit,intfmt) "ANC micro-cycles  ", maxmicro
      write(env%unit,intfmt) "degrees of freedom", nvar
      
      if (modef>0) then
         write(env%unit,intfmt) "# mode follow     ", modef
      endif
      
      write(env%unit,'(10x,":",49("."),":")')
      
      if (set%optset%exact_rf) then
         write(env%unit,chrfmt) "RF solver         ", "spevx"
      else
         write(env%unit,chrfmt) "RF solver         ", "davidson"
      endif
      
      write(env%unit,chrfmt) "write xtbopt.log  ", bool2string(ilog.ne.-1)
      
      if (linear) then
         write(env%unit,chrfmt) "linear (good luck)", bool2string(linear)
      else
         write(env%unit,chrfmt) "linear?           ", bool2string(linear)
      endif
      
      write(env%unit,scifmt) "energy convergence", ethr,    "Eh  "
      write(env%unit,scifmt) "grad. convergence ", gthr,    "Eh/α"
      write(env%unit,dblfmt) "maxmium RF displ. ", maxdispl,"    "
      write(env%unit,scifmt) "Hlow (freq-cutoff)", hlow,    "    "
      write(env%unit,dblfmt) "Hmax (freq-cutoff)", hmax,    "    "
      write(env%unit,dblfmt) "S6 in model hess. ", s6,      "    "
      write(env%unit,'(10x,51("."))')
   endif

   ! work arrays !
   lwork  = 1 + 6*nat3 + 2*nat3**2
   liwork = 8 * nat3

   allocate(h(nat3,nat3),fc(nat3*(nat3+1)/2),eig(nat3))

   ! read in Hessian from file !
   if (set%mhset%model == p_modh_read) then
      call open_file(ihess, 'hessian', 'r')
      if (ihess == -1) then
         call env%error("Could not read in hessian as requested.", source)
         return
      endif
      call read_hessian(ihess, nat3, h, error)
      if (error /= 0) then
         call env%error("Could not read hessian from file.", source)
         return
      endif
      ! do not reset the hessian
      maxmicro = maxopt
      ex = .true.
   else
      ex = .false.
   endif

   call anc%allocate(mol%n,nvar,hlow,hmax) ! allocate ANC
   molopt = mol ! copy molecular information
   if (profile) call timer%measure(1) ! start opt timer

! ======================================================================
   ANC_microiter: do
! ======================================================================

!----------------------------------------------------------------!
!--------------------- Hessian generation -----------------------!
!----------------------------------------------------------------!

   if (profile) call timer%measure(2,'model hessian') ! start timer for Hessian
   
   ! initial guess for Hessian !
   if (.not.ex)then ! normal case
      
      if (pr) &
         &  write(env%unit,'(/,''generating ANC from exact Hessian ...'')')
      
      call modhes(env, calc, set%mhset, molopt%n, molopt%xyz, molopt%at, fc, pr)   ! def: Lindh model (1995)
      call env%check(fail)
      if (fail) then
         call env%error("Calculation of model hessian failed", source)
         return
      end if
      
      ! blow up Hessian !
      k=0
      do i=1,nat3
         do j=1,i
            k=k+1
            h(i,j)=fc(k)
            h(j,i)=fc(k)
         enddo
      enddo

      thr=1.d-11
   
   ! read in Hessian from file !
   else 
      
      if(pr) &
         &  write(env%unit,'(/,''generating ANC from read Hessian ...'')')
      
      ! pack Hessian !
      k=0
      do i=1,nat3
         do j=1,i
            k=k+1
            fc(k)=h(j,i)
         enddo
      enddo

      thr=1.d-10

   endif
  
   if (debug(2) .and. nat3 <= 30) then !######## DEBUG ########
      write(env%unit,'(/,''Hessian matrix'')')
      write(hessfmt,'(a,i0,a)') '(', nat3, 'F10.6)'
      write(env%unit,hessfmt) (h(:,i), i=1,nat3)
   endif

   ! project out translational and rotational modes !
   if(modef.eq.0)then
      if(fixset%n.gt.0)then
         call trproj(molopt%n,nat3,molopt%xyz,fc,.false., -1  ,pmode,1)     ! exact fixing
      else
         if (.not.linear) &
         call trproj(molopt%n,nat3,molopt%xyz,fc,.false.,modef,pmode,1)     ! normal
      endif
   else
      call trproj(molopt%n,nat3,molopt%xyz,fc,.false.,modef,pmode,modef) ! NMF
   endif
   
   if (profile) call timer%measure(2) ! stop timer for model Hessian

!----------------------------------------------------------------!
!---------------------- ANC generation --------------------------!
!----------------------------------------------------------------!

   if (profile) call timer%measure(3,'ANC generation') ! start timer for ANC generation   

   ! diagonalize Hessian and sort eigenvalues !
   call anc%new(env%unit,molopt%xyz,h,pr,linear)  
   if (profile) call timer%measure(3) ! stop timer for ANC generation
   esave = etot ! save energy 

!----------------------------------------------------------------!
!---------------------- Optimization ----------------------------!
!----------------------------------------------------------------!
   call relax(env,iter,molopt,anc,restart,maxmicro,maxdispl,ethr,gthr, &
      & iii,chk,calc,egap,acc,et,maxiter,iupdat,etot,g,sigma,ilog,pr,fail, &
      & converged,timer,set%optset%exact_rf,avconv)

   ! check for errors !
   call env%check(fail)
   if (fail) then
      call env%error("Could not relax/optimize structure", source)
      return
   endif

   ! dynamically adjust number of micro iterations !
   maxmicro=min(int(maxmicro*1.1),2*set%optset%micro_opt)

   ! assess the optimization by RMSD change !
   call rmsd(molopt%n,anc%xyz,molopt%xyz,1,U,x_center,y_center,rmsdval,.false.,grmsd)

   ! this comes close to a goto, but it's not a goto ... it's even worse !
   if (restart.and.iter.lt.maxopt) then
      if (pr) then
         write(env%unit,'(" * RMSD in coord.:",f14.7,1x,"α")',advance='no') rmsdval
         write(env%unit,'(6x,"energy gain",e16.7,1x,"Eh")') etot-esave
      end if
      cycle ANC_microiter
   endif
   exit  ANC_microiter
! ======================================================================
   enddo ANC_microiter
! ======================================================================

   ! convergence report !
   if (converged) then
      if(pr) then
         call rmsd(mol%n,mol%xyz,molopt%xyz,1,U,x_center,y_center,rmsdval,.false.,grmsd)
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***",/)') &
            "GEOMETRY OPTIMIZATION CONVERGED AFTER",iter,"ITERATIONS"
         write(env%unit,'(72("-"))')
         write(env%unit,'(1x,"total energy gain   :",F18.7,1x,"Eh",F14.4,1x,"kcal/mol")') &
            etot-estart, (etot-estart)*autokcal
         write(env%unit,'(1x,"total RMSD          :",F18.7,1x,"a0",F14.4,1x,"Å")') &
            rmsdval, rmsdval*autoaa
         if (profile) then
            write(env%unit,'(1x,"total power (kW/mol):",F18.7,1x,"(step)",F10.4,1x,"(real)")') &
               & (etot-estart)*autokJ/iter, (etot-estart)*autokJ/timer%get()
         endif
         write(env%unit,'(72("-"))')
      endif
   else
      ! not converging in the given cycles is a FAILURE, we should make this clearer !
      ! This is still no ERROR, since we want the geometry written afterwards !
      if(pr) then
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***",/)') &
            "FAILED TO CONVERGE GEOMETRY OPTIMIZATION IN",iter,"ITERATIONS"
      endif
   endif

   mol = molopt ! copy optimized geometry back to molecule

   if (pr.and.profile) call timer%write(env%unit,'ANCopt') ! write timer report

   ! cleanup !
   if (profile) call timer%deallocate
   if (allocated(pmode))  deallocate(pmode)
   if (allocated(h))      deallocate(h)
   if (allocated(fc))     deallocate(fc)
   call anc%deallocate

end subroutine ancopt


!> @brief actual optimization procedure
!!
!! note that this subroutines implements the main loop of the optimization
!! procedure INSIDE the mirco iterator which is implemented by the calling
!! routine, the only way to leave this subroutine is by an EARLY return,
!! without going over the RESTART logical at the end of the subroutine.
!* I have warned you, be careful not to break anything.
subroutine relax(env,iter,mol,anc,restart,maxcycle,maxdispl,ethr,gthr, &
      &          ii,chk,calc, &
      &          egap,acc_in,et,maxiter,iupdat,etot,g,sigma,ilog,pr,fail,converged, &
      &          timer,exact,avconv)

   use xtb_mctc_blas, only : blas_gemv
   use xtb_type_molecule
   use xtb_type_anc
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_type_timer

   implicit none

   !> source of errors in the main program unit
   character(len=*), parameter :: source = "optimizer_relax"

   !> calculation environment
   type(TEnvironment), intent(inout) :: env

   !> molecular structure data
   type(TMolecule),    intent(inout) :: mol
   
   !> timer instance
   type(tb_timer),       intent(inout) :: timer
   
   !> ANC instance
   type(tb_anc),         intent(inout) :: anc
   
   !> WFN 
   type(TRestart),intent(inout) :: chk
   
   !> polymorphic calculator instance
   class(TCalculator), intent(inout) :: calc
   
   !> number of micro iterations 
   integer, intent(in)    :: maxiter

   !> Hessian update algorithm
   integer, intent(in)    :: iupdat

   !> iunit for log file
   integer, intent(in)    :: ilog

   !> temperature
   real(wp),intent(in)    :: et
   
   !> total energy
   real(wp),intent(inout) :: etot
   
   !> SCC accuracy
   real(wp),intent(in)    :: acc_in

   !> gradients
   real(wp),intent(inout) :: g(3,mol%n)

   !> strain derivatives
   real(wp),intent(inout) :: sigma(3,3)

   !> HOMO-LUMO gap
   real(wp),intent(inout) :: egap

   !> conv check
   logical, intent(out)   :: converged

   !> solver type
   logical, intent(in)    :: exact
   
   !> averaging
   type(convergence_log), intent(inout), optional :: avconv

   !> SCC results storage
   type(scc_results) :: res

   !> dimensions for RFO
   integer  :: nvar1,npvar,npvar1

   !> local booleans to control optimization
   logical  :: restart, first, pr, fail
   logical  :: econverged
   logical  :: gconverged
   logical  :: lowered

   integer  :: maxcycle, iter, prlevel
   integer  :: i, j, ii, jj, k, lwork, info, m, idum, imax(3)
   real(wp) :: energy,ethr,gthr,dsnrm,maxdispl,t0,w0,t1,w1
   real(wp) :: lambda,gnorm,dnorm,ddot,eold,xdum,estart,acc,e_in
   real(wp) :: depred,echng,dummy,maxd,alp,gchng,smallreal,gnold
   real(wp),allocatable :: gold(:)
   real(wp),allocatable :: displ(:), gint(:)

   !> RFO eigenvalues
   real(sp),allocatable :: eaug(:)

   !> RFO eigenvectors
   real(sp),allocatable :: Uaug(:,:)

   !> Augmented Hessian
   real(sp),allocatable :: Aaug(:)

   real(sp) :: r4dum,sdot
   parameter (r4dum=1.e-8)
   parameter (smallreal=1.d-14)

!----------------------------------------------------------------!
!--------------------- Initialization ---------------------------!
!----------------------------------------------------------------!
   

   ! set printlevel !
   if (pr) then 
      prlevel = 1
   else 
      prlevel=0
   endif
   
   ! initialize variables !
   gnorm  = 0.0_wp
   depred = 0.0_wp
   echng  = 0.0_wp
   alp    = 1.0_wp
   maxd   = maxdispl
   acc    = acc_in
   energy = etot
   e_in   = etot
   first  = .true.
   converged = .false.

   nvar1  = anc%nvar+1         ! dimension of RF calculation
   npvar  = anc%nvar*(nvar1)/2 ! packed size of Hessian (note the abuse of nvar1!)
   npvar1 = nvar1*(nvar1+1)/2  ! packed size of augmented Hessian
   
   allocate( gold(anc%nvar), displ(anc%nvar), gint(anc%nvar), source = 0.0_wp )
   allocate( Uaug(nvar1,1),eaug(nvar1),Aaug(npvar1) )

!! ========================================================================
   main_loop: do ii=1,maxcycle
!! ========================================================================
   
   iter=iter+1 ! iteration counter
   if(pr) &
      write(env%unit,'(/,72("."),/,30(".")," CYCLE",i5,1x,30("."),/,72("."))')iter

   ! save values from previous iteration !
   gold = gint
   gnold= gnorm
   eold = energy

   ! dE via 2-nd order Taylor expansion !
   ! E = E0 + delta * G + delta^2 * H !
   if (ii > 1) &
      call prdechng(anc%nvar,gold,displ,anc%hess,depred)
  
   ! displace cartesian coordinates !
   if (profile) call timer%measure(4,'coordinate transformation')
   call anc%get_cartesian(mol%xyz)
   if (profile) call timer%measure(4)

   ! single point + analytical gradients !
   if (profile) call timer%measure(5,'single point calculation')
   g = 0.0_wp
   call calc%singlepoint(env,mol,chk,prlevel,iter.eq.1,energy,g,sigma,egap,res)
   if (profile) call timer%measure(5)
   
   ! something went wrong in SCC or diag !
   call env%check(fail)
   if (fail) then
      call env%error('SCF not converged, aborting...', source)
      return
   endif
   if (energy.gt.1.d42) then
      call env%error('energy is bogus! aborting...', source)
      fail=.true.
      return
   endif
   
   ! write geometry to log file !
   if (profile) call timer%measure(6,'optimization log')
   call writeMolecule(mol, ilog, format=fileType%xyz, energy=res%e_total, &
      & gnorm=res%gnorm)
   if (profile) call timer%measure(6)


   ! transform xyz (g) to internal gradient (gint) !
   if (profile) call timer%measure(4)
   call dgemv('t',anc%n3,anc%nvar,1.0_wp,anc%B,anc%n3,g,1,0.0_wp,gint,1)
   if (profile) call timer%measure(4)

   ! check Euclidean norm of the normal gradient !
   gnorm = norm2(gint)
   if(gnorm.gt.500.) then   
      call env%error('|grad| > 500, something is totally wrong!', source)
      fail=.true.
      return
   endif

   ! average energy and gradient !
   if (present(avconv)) then
      call avconv%set_eg_log(energy, gnorm)
      energy = avconv%get_averaged_energy()
      gnorm = avconv%get_averaged_gradient()
      if (pr) then
         write(env%unit,'("av. E:",1x,f14.7,1x,"->",1x,f14.7)') &
            avconv%elog(avconv%nlog), energy
         write(env%unit,'("av. G:",1x,f14.7,1x,"->",1x,f14.7)') &
            avconv%glog(avconv%nlog), gnorm
      end if
   end if

   ! adjust SCC accuracy dynamically !
   if(gnorm    .lt.0.004)then
      acc=acc_in
   elseif(gnorm.lt.0.02)then
      acc=3.0d0*acc_in
   elseif(gnorm.gt.0.02)then
      acc=6.0d0*acc_in
   endif

   first =.false. ! distinguish between first and subsequent iterations

   ! calculate the change in energy and gradient norm !
   gchng = gnorm -gnold
   echng = energy-eold

   ! check for convergence !
   econverged = abs(echng).lt.ethr
   gconverged = gnorm.lt.gthr
   lowered    = echng.lt.0.0_wp

   ! print energy and gradient norm of a current cycle !
   if(pr) then
      write(env%unit,'(" * total energy  :",f14.7,1x,"Eh")',advance='no')   energy
      write(env%unit,'(5x,"change   ",e18.7,1x,"Eh")')                      echng
      write(env%unit,'(3x,"gradient norm :",f14.7,1x,"Eh/α")',advance='no') gnorm
      write(env%unit,'(3x,"predicted",e18.7)',advance='no')                 depred
      write(env%unit,'(1x,"("f7.2"%)")')         (depred-echng)/echng*100
   endif
   
   ! check 0 energy case !
   if ( energy .eq. 0 ) then
      call env%error('external program error', source)
      return
   end if

   if(ii.eq.1) estart=energy ! save energy of first iteration

   ! adjust step size dynamically !
   if(gnorm.lt.0.002)then 
      alp = 1.5d0       ! 1.5
   elseif(gnorm.lt.0.0006)then
      alp = 2.0d0       ! 2
   elseif(gnorm.lt.0.0003)then
      alp = 3.0d0       ! 3
   else
      alp = 1.0d0
   endif

!! ------------------------------------------------------------------------
!  Update the hessian
!! ------------------------------------------------------------------------

   if (profile) call timer%measure(7,'hessian update')
   if(ii.gt.1)then
      if(iupdat.eq.0)then
         call bfgs  (anc%nvar,gnorm,gint,gold,displ,anc%hess)
      else
         call powell(anc%nvar,gnorm,gint,gold,displ,anc%hess)
      endif
   endif
   if (profile) call timer%measure(7)

! ------------------------------------------------------------------------
!  the following lines define the rational function (RF) method
! ------------------------------------------------------------------------
   if (profile) call timer%measure(8,"rational function")
!  funny that implementing a RF algorithm takes 5 lines when done right... SAW
!  As it is now condensed down to a few lines, I feel the urge to explain
!  how the calculation is actually done. We solve this:
!   ⎛ H  g ⎞ ⎛ dx ⎞     ⎛ dx ⎞
!   ⎝ g  0 ⎠ ⎝  1 ⎠ = λ ⎝  1 ⎠
!  first augment hessian by gradient, we keep everything nicely packed, no blowup
   Aaug(1:npvar)          = anc%hess ! pack hessian
   Aaug(npvar+1:npvar1-1) = gint ! augment with gradient
   Aaug(npvar1)           = 0.0_sp ! add zero
   
   ! chose your favourite solver !
   if (exact .or. nvar1.lt.50) then
      call solver_sspevx(nvar1,r4dum,Aaug,Uaug,eaug,fail)
   else
      ! steepest decent guess for displacement !
      if (ii.eq.1) then
         Uaug(:,1)=[-real(gint(1:anc%nvar),sp),1.0_sp]
         dsnrm = sqrt(sdot(nvar1,Uaug,1,Uaug,1))
         Uaug  = Uaug/dsnrm
      endif
      call solver_sdavidson(nvar1,r4dum,Aaug,Uaug,eaug,fail,.false.)
      if (fail) & ! retry with better solver
      call solver_sspevx(nvar1,r4dum,Aaug,Uaug,eaug,fail)
   endif
   
   ! error handling after RF calculation !
   if (fail .or. abs(Uaug(nvar1,1)).lt.1.e-10) then
      call env%error("internal rational function error", source)
      return
   end if

   ! divide by last element to get the displacement vector !
   displ(1:anc%nvar) = Uaug(1:anc%nvar,1)/Uaug(nvar1,1)
   
   ! check if step is too large, cut off everything that is too large !
   do j=1,anc%nvar
      if(abs(displ(j)).gt.maxd) then
         if(displ(j) < 0) displ(j)=-maxd
         if(displ(j) > 0) displ(j)= maxd
      endif
   enddo
   
   ! now some output !
   dsnrm=sqrt(ddot(anc%nvar,displ,1,displ,1)) ! displacement norm
   if(pr)then
      
      ! find the largest displacement !
      gold = abs(displ)
      imax(1) = maxloc(gold,1); gold(imax(1)) = 0.0_wp
      imax(2) = maxloc(gold,1); gold(imax(2)) = 0.0_wp
      imax(3) = maxloc(gold,1)

      write(env%unit,'(3x,"displ. norm   :",f14.7,1x,"α")',advance='no') &
         dsnrm*alp
      write(env%unit,'(6x,"lambda   ",e18.7)') eaug(1) ! eigenvalue of the RF 
      write(env%unit,'(3x,"maximum displ.:",f14.7,1x,"α")',advance='no') &
         abs(displ(imax(1)))*alp
      write(env%unit,'(6x,"in ANC''s ",3("#",i0,", "),"...")') imax
   endif
   
   if (profile) call timer%measure(8)

   ! 2nd: exit and redo hessian (internal restart) !
   if(ii.gt.2.and.dsnrm.gt.2.0) then
      if (pr) write(*,*) 'exit because of too large step'
      exit main_loop
   endif

   ! new coordinates !
   anc%coord = anc%coord + displ * alp

   ! conv check !
   if(abs(echng).lt.ethr.and.gnorm.lt.gthr.and.echng.lt.1.0e-10_wp) then
      restart=.false.
      converged = .true.
      etot=energy
      return
   endif
!! ========================================================================
   enddo main_loop
!! ========================================================================
   
   ! cleanup !
   if (allocated(Uaug))  deallocate(Uaug)
   if (allocated(eaug))  deallocate(eaug)
   if (allocated(Aaug))  deallocate(Aaug)

   ! post micro cycle processing !
   restart=.true.
   etot=energy
   call anc%get_cartesian(mol%xyz)

end subroutine relax

pure subroutine solver_ssyevx(n,thr,A,U,e,fail)
   use xtb_mctc_lapack, only : lapack_syevx
   implicit none
   integer, intent(in)    :: n
   real(sp),intent(in)    :: thr
   real(sp),intent(inout) :: A(:,:)
   real(sp),intent(inout) :: U(:,:)
   real(sp),intent(inout) :: e(:)
   logical, intent(out)   :: fail

   integer :: i,j,k
   integer :: lwork,info
   real(sp),allocatable :: work(:)
   integer, allocatable :: iwork(:)
   integer, allocatable :: ifail(:)
   real(sp) :: dum

   lwork = 1+8*n+n**2
   allocate(iwork(5*n),work(lwork),ifail(n))

   j=1
   call lapack_syevx('V','I','U',n,A,n,dum,dum,j,j,thr, &
   &           i,e,U,n,work,lwork,iwork,ifail,info)
   if (info.ne.0) fail = .true.

   deallocate(iwork,work,ifail)
end subroutine solver_ssyevx

pure subroutine solver_sspevx(n,thr,A,U,e,fail)
   use xtb_mctc_lapack, only : lapack_spevx
   implicit none
   integer, intent(in)    :: n
   real(sp),intent(in)    :: thr
   real(sp),intent(inout) :: A(:)
   real(sp),intent(inout) :: U(:,:)
   real(sp),intent(inout) :: e(:)
   logical, intent(out)   :: fail

   integer :: i,j,k
   integer :: info
   real(sp),allocatable :: work(:)
   integer, allocatable :: iwork(:)
   integer, allocatable :: ifail(:)
   real(sp) :: dum

   allocate(iwork(5*n),work(8*n),ifail(n))

   j=1
   call lapack_spevx('V','I','U',n,A,dum,dum,j,j,thr,i,e,U,n,work,iwork,ifail,info)
   if (info.ne.0) fail = .true.

   deallocate(iwork,work,ifail)
end subroutine solver_sspevx

subroutine findlroot(i0,n,e,el)
   implicit none
   integer, intent(in)  :: i0
   integer, intent(in)  :: n
   real(wp),intent(in)  :: e(n)
   real(wp),intent(out) :: el
   integer :: i

   el=1.d+42
   do i=1,n
      if(i.eq.i0.and.i0.gt.0) cycle
      if(abs(e(i)) .gt. 1.d-10 .and. e(i) .lt. el ) el = e(i)
   enddo

end subroutine findlroot

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine sort(nat3,nvar,hess,b)
   implicit none
   integer, intent(in) :: nat3
   integer, intent(in) :: nvar
   real(wp),intent(inout) :: hess(nvar*(nvar+1)/2)
   real(wp),intent(inout) :: b(nat3,nat3)
   real(wp),allocatable :: edum(:)
   real(wp) :: pp,sc1
   integer  :: ii,k,j,m,i
   allocate( edum(nvar), source = 0.0_wp )

   do k=1,nvar
      edum(k)=hess(k+k*(k-1)/2)
   enddo
! sort
   do ii = 2, nvar
      i = ii - 1
      k = i
      pp= edum(i)
      do j = ii, nvar
         if (edum(j) .gt. pp) cycle
         k = j
         pp= edum(j)
      enddo
      if (k .eq. i) cycle
      edum(k) = edum(i)
      edum(i) = pp
      do m=1,nat3
         sc1=b(m,i)
         b(m,i)=b(m,k)
         b(m,k)=sc1
      enddo
   enddo

   do k=1,nvar
      hess(k+k*(k-1)/2)=edum(k)
   enddo

end subroutine sort

!> calculate predicted energy change
subroutine prdechng(nat3,grad,displ,hess,depred)
!---------------------------------------------------------------------
! Purpose:
! Calculates predicted energy change according to the second order
! model.
!
! Input:
! nat3  - 3*natoms
! hess  - Hessian matrix stored as lower triangle
! grad  - Gradient vector
! displ - Displacement vector
!
! Output:
! depred - Predicted energy change
!---------------------------------------------------------------------
   use xtb_mctc_blas, only : blas_spmv
   implicit none

! Input:
   integer, intent(in) :: nat3
   real(wp),intent(in) :: grad(nat3)
   real(wp),intent(in) :: displ(nat3)
   real(wp),intent(in) :: hess(nat3*(nat3+1)/2)

! Output:
   real(wp),intent(out) :: depred

! Local:
   real(wp), allocatable :: hdx(:)
   real(wp) :: gtmp, htmp

! BLAS functions:
   real(wp), external :: ddot
!---------------------------------------------------------------------
   allocate( hdx(nat3), source = 0.0_wp )

   call blas_spmv('u',nat3,0.5d0,hess,displ,1,0.0d0,hdx,1) ! hdx = 0.5*H*displ

   gtmp   = ddot(nat3,displ,1,grad,1) ! gtmp = grad*displ

   htmp   = ddot(nat3,displ,1,hdx,1) ! htmp = hdx*displ

   depred = htmp + gtmp

end subroutine prdechng



subroutine trfp2xyz(nvar,nat3,p,xyz0,h,dspl)
   implicit none
   integer, intent(in)  :: nat3
   integer, intent(in)  :: nvar
   integer :: nat,icount,i,j,k
   real(wp),intent(in)  :: xyz0(3,nat3/3)
   real(wp),intent(out) :: dspl(3,nat3/3)
   real(wp),intent(in)  :: h(nat3,nat3)
   real(wp),intent(in)  :: p(nvar)
   real(wp) :: dum

   dspl = 0.0d0
   nat=nat3/3

! generate cartesian displacement vector
   do i=1,nvar
      icount=0
      do j=1,nat
         do k=1,3
            icount=icount+1
            dum=h(icount,i)*p(i)
            dspl(k,j)=dspl(k,j)+dum
         enddo
      enddo
   enddo

   dspl=dspl + xyz0

   return
end subroutine trfp2xyz


subroutine prdispl(nvar,displ)
   implicit none
   integer, intent(in)  :: nvar
   real(wp),intent(in)  :: displ(nvar)
   real(wp),allocatable :: er(:)
   integer, allocatable :: merk(:)
   integer  :: i,j,ii,k
   integer  :: ihilf
   real(wp) :: pp
   allocate( er(nvar), source = 0.0_wp )
   allocate( merk(nvar), source = 0 )

   er = abs(displ)

   do i=1,nvar
      merk(i)=i
   enddo
   do ii=2,nvar
      i =ii-1
      k =i
      pp=er(i)
      do j=ii, nvar
         if(er(j).le.pp) cycle
         k=j
         pp=er(j)
      enddo
      if (k.eq.i) cycle
      er(k)=er(i)
      er(i)=pp
      ihilf=merk(i)
      merk(i)=merk(k)
      merk(k)=ihilf
   enddo

   write(*,'(''Largest |displ|/coords:'',5(f8.4,'' ('',i4,'')''))') &
      (er(i),merk(i),i=1,min(3,nvar))

end subroutine prdispl

!> generate model Hessian
subroutine modhes(env, calc, modh, natoms, xyz, chg, Hess, pr)
   use xtb_type_setvar
   use xtb_modelhessian
   use xtb_setparam
   use xtb_type_calculator
   use xtb_gfnff_calculator
!
!       generates a Lindh Model Hessian
!       Chem. Phys. Let. 241(1995) 423-428
!       with personal permission from R.L.
!
   implicit none

   !> Source of errors in the main program unit
   character(len=*), parameter :: source = "optimizer_modhes"

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Calculator
   class(TCalculator), intent(inout) :: calc

   type(modhess_setvar),intent(in) :: modh
   logical, intent(in)  :: pr

   !> other variables
   integer  :: i
   integer  :: nhess
   integer, intent(in)  :: natoms
   real(wp),intent(in)  :: xyz(3,natoms)
   
   !> model hessian
   real(wp),intent(out) :: Hess((natoms*3)*((natoms*3)+1)/2)
   integer, intent(in)  :: chg(natoms)

   ! initialize !
   Hess=0.0_wp

   select type(calc)
   class default ! all calculator cases except GFN-FF
      select case(modh%model) 
      case default
         call env%error("internal error in model hessian!", source)
         return
      case(p_modh_old)
        if (pr) write(env%unit,'(a)') "Using Lindh-Hessian (1995)"
        call ddvopt(xyz, natoms, Hess, chg, modh%s6)
      case(p_modh_lindh_d2)
        if (pr) write(env%unit,'(a)') "Using Lindh-Hessian"
        call mh_lindh_d2(xyz, natoms, Hess, chg, modh)
      case(p_modh_lindh)
        if (pr) write(env%unit,'(a)') "Using Lindh-Hessian (2007)"
        call mh_lindh(xyz, natoms, Hess, chg, modh)
      case(p_modh_swart)
        if (pr) write(env%unit,'(a)') "Using Swart-Hessian"
        call mh_swart(xyz, natoms, Hess, chg, modh)
      end select
   type is(TGFFCalculator) ! GFN-FF case
      select case(modh%model)
      case default
         call env%error("internal error in model hessian!", source)
         return
      case(p_modh_old, p_modh_gff)
         if (pr) write(env%unit,'(a)') "Using GFN-FF Lindh-Hessian"
         call gff_ddvopt(xyz, natoms, Hess, chg, modh%s6, calc%param, calc%topo, calc%neigh)
      case(p_modh_lindh_d2)
        if (pr) write(env%unit,'(a)') "Using Lindh-Hessian"
        call mh_lindh_d2(xyz, natoms, Hess, chg, modh)
      case(p_modh_lindh)
        if (pr) write(env%unit,'(a)') "Using Lindh-Hessian (2007)"
        call mh_lindh(xyz, natoms, Hess, chg, modh)
      case(p_modh_swart)
        if (pr) write(env%unit,'(a)') "Using Swart-Hessian"
        call mh_swart(xyz, natoms, Hess, chg, modh)
      end select
   end select

!  constraints
   call constrhess(natoms,chg,xyz,Hess)

end subroutine modhes

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! H(cart) = Bt * H(int) *B
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine itochess(nvar,nat3,b,hess,fc)
   use xtb_mctc_blas, only : blas_gemm
   implicit none
   integer, intent(in)  :: nvar
   integer, intent(in)  :: nat3
   real(wp),intent(in)  :: b(nat3,nat3)
   real(wp),intent(in)  :: hess(nvar*(nvar+1)/2)
   real(wp),intent(out) :: fc(nat3*(nat3+1)/2)

   integer :: i,j,k
   real(wp),allocatable :: h(:,:)
   real(wp),allocatable :: hb(:,:)
   real(wp),allocatable :: chess(:,:)

   allocate(h(nvar,nvar),hb(nvar,nat3),chess(nat3,nat3))

!  BLAS implementation of the transformation to cartesians
!  unpack BFGS hess
   k=0
   do i=1, nvar
      do j=1,i
         k=k+1
         h(i,j)=hess(k)
         h(j,i)=h(i,j)
      enddo
   enddo

!  calculate H*B (note: B is saved as Bt)
   call blas_gemm ('n','t',nvar,nat3,nvar,1.0d0,h,nvar,b,nat3,0.0d0,hb,nvar)

!  calculate Bt*HB
   call blas_gemm ('n','n',nat3,nat3,nvar,1.0d0,b,nat3,hb,nvar,0.0d0,chess,nat3)

!  pack
   k=0
   do i=1,nat3
      do j=1,i
         k=k+1
         fc(k)=chess(j,i)
      enddo
   enddo

end subroutine itochess

subroutine read_hessian(ihess, ndim, hessian, error)
   use xtb_mctc_systools
   implicit none
   integer, intent(in) :: ihess
   integer, intent(in) :: ndim
   real(wp), intent(out) :: hessian(:, :)
   character(len=:), allocatable :: line
   integer, intent(out) :: error
   integer :: i, j
   error = 0
   do while(error == 0)
      call getline(ihess, line, error)
      if (index(line, '$hessian') == 1) then
         read(ihess, *, iostat=error) &
            & ((hessian(j, i), j = 1, ndim), i = 1, ndim)
         exit
      endif
   enddo
end subroutine read_hessian

subroutine geoconvav(nc, e, g, val, deriv)
   implicit none
   !> total number of E/G points
   integer nc
   !> total energy in Eh
   real*8  e(*)
   !> norm of Cartesian gradient (in TM: |dE/dxyz|)
   real*8  g(*)
   !> av. energy in Eh to be used further
   real*8  val
   !> av. gradient
   real*8  deriv

   integer nav, low
   integer i, j
   parameter (nav=5)    ! average over last nav
   real*8 eav,gav

   ! only apply it if sufficient number of points i.e. a "tail" can exist
   ! with the censo blockl = 8 default, this can first be effective in the second
   if(nc.lt.3*nav)then
      val = e(nc)
      deriv = g(nc)
      return
   endif

   low = max(1,nc-nav+1)
   j = 0
   eav = 0
   do i=nc,low,-1
      j = j + 1
      eav = eav + e(i)
      gav = gav + g(i)
   enddo
   val = eav / float(j)

   low = max(1,nc-nav+1)
   j = 0
   gav = 0
   do i=nc,low,-1
      j = j + 1
      gav = gav + g(i)
   enddo
   ! adjust the gradient norm to xtb "conventions" because e.g. a noisy
   ! DCOSMO-RS gradient for large cases can never (even on average)
   ! become lower than the "-opt normal" thresholds
   deriv=gav / float(j) / 2.d0
end subroutine geoconvav

pure function new_convergence_log(nmax) result(self)
   integer, intent(in) :: nmax
   type(convergence_log) :: self
   self%nlog = 0
   allocate(self%elog(nmax))
   allocate(self%glog(nmax))
end function new_convergence_log

function load_turbomole_log(nmax) result(self)
   use xtb_mctc_resize, only : resize
   use xtb_mctc_systools, only : getline
   integer, intent(in) :: nmax
   type(convergence_log) :: self
   integer :: nlog, ilog
   real(wp) :: etmp, gtmp
   real(wp), allocatable :: elog(:), glog(:)
   character(len=:), allocatable :: line
   logical :: exist
   integer, parameter :: initial_size = 50
   integer :: unit, stat
   nlog = 0
   inquire(file="gradient", exist=exist)
   if (exist) then
      open(file="gradient", newunit=unit)
      allocate(elog(initial_size), glog(initial_size))
      call getline(unit, line, stat)
      do while(stat == 0)
         if (index(line, "cycle") > 0) then
            if (tokenize_cycle(line, etmp, gtmp)) then
               if (nlog >= size(elog)) then
                  call resize(elog, size(elog)+size(elog)/2+1)
                  call resize(glog, size(glog)+size(glog)/2+1)
               end if
               nlog = nlog + 1
               elog(nlog) = etmp
               glog(nlog) = gtmp
            end if
         end if
         call getline(unit, line, stat)
      end do
      close(unit)
   end if
   self = convergence_log(nmax + nlog)
   do ilog = 1, nlog
      call self%set_eg_log(elog(ilog), glog(ilog))
   end do
end function load_turbomole_log

function tokenize_cycle(line, e, g) result(stat)
   character(len=*), intent(in) :: line
   real(wp), intent(out) :: e
   real(wp), intent(out) :: g
   logical :: stat
   integer :: stat1, stat2
   read(line(33:51), *, iostat=stat1) e
   read(line(66:), *, iostat=stat2) g
   stat = stat1 == 0 .and. stat2 == 0
end function tokenize_cycle

pure function get_averaged_energy(self) result(val)
   class(convergence_log), intent(in) :: self
   real(wp) :: eav, val
   integer :: i, j, low
   integer, parameter :: nav = 5

   ! only apply it if sufficient number of points i.e. a "tail" can exist
   ! with the censo blockl = 8 default, this can first be effective in the second
   if(self%nlog.lt.3*nav)then
      val = self%elog(self%nlog)
   else
      low = max(1, self%nlog-nav+1)
      j = 0
      eav = 0
      do i = self%nlog, low, -1
         j = j + 1
         eav = eav + self%elog(i)
      enddo
      val = eav / float(j)
   end if

end function get_averaged_energy

pure function get_averaged_gradient(self) result(deriv)
   class(convergence_log), intent(in) :: self
   real(wp) :: gav, deriv
   integer :: i, j, low
   integer, parameter :: nav = 5

   ! only apply it if sufficient number of points i.e. a "tail" can exist
   ! with the censo blockl = 8 default, this can first be effective in the second
   if(self%nlog.lt.3*nav) then
      deriv = self%glog(self%nlog)
   else
      low = max(1, self%nlog-nav+1)
      j = 0
      gav = 0
      do i = self%nlog, low, -1
         j = j + 1
         gav = gav + self%glog(i)
      enddo
      ! adjust the gradient norm to xtb "conventions" because e.g. a noisy
      ! DCOSMO-RS gradient for large cases can never (even on average)
      ! become lower than the "-opt normal" thresholds
      deriv = gav / float(j) / 2.d0
   end if

end function get_averaged_gradient

pure subroutine set_eg_log(self, e, g)
   use xtb_mctc_resize, only : resize
   class(convergence_log), intent(inout) :: self
   real(wp), intent(in) :: e, g
   if (self%nlog >= size(self%elog)) then
      call resize(self%elog, size(self%elog)+size(self%elog)/2+1)
      call resize(self%glog, size(self%glog)+size(self%glog)/2+1)
   end if
   self%nlog = self%nlog + 1
   self%elog(self%nlog) = e
   self%glog(self%nlog) = g
end subroutine set_eg_log

end module xtb_optimizer

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_basisset
   use xtb_mctc_accuracy, only : wp
   implicit none

   public :: TBasisset

   private

   type :: TBasisset
      integer  :: maxao = 0
      integer  :: n = 0
      integer  :: nbf = 0
      integer  :: nao = 0
      integer  :: nshell = 0
      ! ------------------------------------------------------------------------
      !  This variables describe the ATOMS
      integer, allocatable :: caoshell(:,:)  ! atom number -> basis function
      integer, allocatable :: saoshell(:,:)  ! atom number -> AO
      integer, allocatable :: fila(:,:)      ! atom number -> basis function
      integer, allocatable :: fila2(:,:)     ! atom number -> AO
      integer, allocatable :: shells(:,:)    ! atom number -> shell
      ! ------------------------------------------------------------------------
      !  This variables describe the indivdual SHELLS
      integer, allocatable :: lsh(:)   ! shell -> azimudal quantum number
      integer, allocatable :: ash(:)   ! shell -> atom number
      real(wp),allocatable :: zeta(:)  ! shell -> exponent
      real(wp),allocatable :: level(:) ! shell -> level energy
      real(wp),allocatable :: minalp(:)! shell -> most diffuse exponent
      integer, allocatable :: sh2bf(:,:) ! shell -> BF
      integer, allocatable :: sh2ao(:,:) ! shell -> AO
      integer, allocatable :: valsh(:) ! shell -> shell type
      ! ------------------------------------------------------------------------
      !  This variables describe the SPHERICAL atomic orbitals
      real(wp),allocatable :: aoexp(:)    ! AO -> exponent
      integer, allocatable :: ao2sh(:)    ! AO -> shell
      integer, allocatable :: lao2(:)     ! AO -> azimudal quantum number
      integer, allocatable :: aoat2(:)    ! AO -> atom number
      real(wp),allocatable :: hdiag2(:)   ! AO -> level energy
      integer, allocatable :: valao2(:)   ! AO -> AO type
      ! ------------------------------------------------------------------------
      !  This variables describe the CARTESIAN basis functions
      integer, allocatable :: primcount(:) ! BF -> primitive count
      real(wp),allocatable :: hdiag(:)     ! BF -> level energy
      integer, allocatable :: nprim(:)     ! BF -> primitive number
      integer, allocatable :: aoat(:)      ! BF -> atom
      integer, allocatable :: valao(:)     ! BF -> BF type
      integer, allocatable :: lao(:)       ! BF -> azimudal quantum number
      ! ------------------------------------------------------------------------
      !  This variables decribe the PRIMITIV basis functions
      real(wp),allocatable :: alp(:)  ! primitive -> primitive exponent
      real(wp),allocatable :: cont(:) ! primitive -> contraction coeffient
   contains
   procedure :: allocate => allocate_basisset
   procedure :: deallocate => deallocate_basisset
   end type TBasisset

contains

subroutine allocate_basisset(self,n,nbf,nao,nshell)
   implicit none
   class(TBasisset),intent(inout) :: self
   integer,intent(in) :: n,nbf,nao,nshell
   self%n=n
   self%nbf=nbf
   self%nao=nao
   self%nshell=nshell
   call self%deallocate
   allocate( self%shells(2,n),    source = 0 )
   allocate( self%sh2ao(2,nshell),source = 0 )
   allocate( self%sh2bf(2,nshell),source = 0 )
   allocate( self%minalp(nshell), source = 0.0_wp )
   allocate( self%level(nshell),  source = 0.0_wp )
   allocate( self%zeta(nshell),   source = 0.0_wp )
   allocate( self%valsh(nshell),  source = 0 )
   allocate( self%hdiag(nbf),     source = 0.0_wp )
   allocate( self%alp(9*nbf),     source = 0.0_wp )
   allocate( self%cont(9*nbf),    source = 0.0_wp )
   allocate( self%hdiag2(nao),    source = 0.0_wp )
   allocate( self%aoexp(nao),     source = 0.0_wp )
   allocate( self%ash(nao),       source = 0 )
   allocate( self%lsh(nao),       source = 0 )
   allocate( self%ao2sh(nao),     source = 0 )
   allocate( self%nprim(nbf),     source = 0 )
   allocate( self%primcount(nbf), source = 0 )
   allocate( self%caoshell(5,n),  source = 0 )
   allocate( self%saoshell(5,n),  source = 0 )
   allocate( self%fila(2,n),      source = 0 )
   allocate( self%fila2(2,n),     source = 0 )
   allocate( self%lao(nbf),       source = 0 )
   allocate( self%aoat(nbf),      source = 0 )
   allocate( self%valao(nbf),     source = 0 )
   allocate( self%lao2(nao),      source = 0 )
   allocate( self%aoat2(nao),     source = 0 )
   allocate( self%valao2(nbf),    source = 0 )
end subroutine allocate_basisset

subroutine deallocate_basisset(self)
   implicit none
   class(TBasisset),intent(inout) :: self
   if(allocated(self%shells))    deallocate(self%shells)
   if(allocated(self%sh2ao))     deallocate(self%sh2ao)
   if(allocated(self%sh2bf))     deallocate(self%sh2bf)
   if(allocated(self%minalp))    deallocate(self%minalp)
   if(allocated(self%valsh))     deallocate(self%valsh)
   if(allocated(self%hdiag))     deallocate(self%hdiag)
   if(allocated(self%alp))       deallocate(self%alp)
   if(allocated(self%cont))      deallocate(self%cont)
   if(allocated(self%hdiag2))    deallocate(self%hdiag2)
   if(allocated(self%aoexp))     deallocate(self%aoexp)
   if(allocated(self%ash))       deallocate(self%ash)
   if(allocated(self%lsh))       deallocate(self%lsh)
   if(allocated(self%ao2sh))     deallocate(self%ao2sh)
   if(allocated(self%nprim))     deallocate(self%nprim)
   if(allocated(self%primcount)) deallocate(self%primcount)
   if(allocated(self%caoshell))  deallocate(self%caoshell)
   if(allocated(self%saoshell))  deallocate(self%saoshell)
   if(allocated(self%fila))      deallocate(self%fila)
   if(allocated(self%fila2))     deallocate(self%fila2)
   if(allocated(self%lao))       deallocate(self%lao)
   if(allocated(self%lao2))      deallocate(self%lao2)
   if(allocated(self%aoat))      deallocate(self%aoat2)
   if(allocated(self%valao))     deallocate(self%valao)
   if(allocated(self%valao2))    deallocate(self%valao2)
   if(allocated(self%zeta))      deallocate(self%zeta)
   if(allocated(self%level))     deallocate(self%level)
end subroutine deallocate_basisset

end module xtb_type_basisset

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

! % cat xtbout.json
! {
! # calculation information
!    "coordinate file": coord,
!    "method": "GFN2-xTB",
!    "parameter file": "/home/awvwgk/.parameter/.param_gfn2.xtb"
! # molecule information
!    "number of atoms": 52,
!    "number of electron": 160,
!    "total charge": 0,
!    "spin": 1,
! # basis set information
!    "number of basisfunctions": 157,
!    "number of atomic orbitals": 155,
!    "number of shells": 85,
! # wavefunction information
!    "partial charges":
!    [
!       <charges>
!    ],
!    "atomic dipole moments":
!    [
!       [<dipx>,<dipy>,<dipz>]
!    ],
!    "atomic quadrupole moments":
!    [
!       [<quadxx>,<quadyy>,<qyadzz>,<quadxy>,<quadxz>,<quadyz>]
!    ],
!    "orbital energies":
!    [
!       <emo>
!    ],
!    "occupation numbers":
!    [
!       <focc>
!    ],
! # program information
!    "version": 6.1
! }
module xtb_main_json
   implicit none

   private

   public :: main_xtb_json, write_json_gfnff_lists
   public :: main_ptb_json

contains

   subroutine main_xtb_json &
      (ijson, mol, wfx, xbas, sccres, freqres)
      use xtb_mctc_accuracy, only: wp

!! ========================================================================
!  load class definitions
      use xtb_type_molecule
      use xtb_type_wavefunction
      use xtb_type_basisset
      use xtb_type_data
      use xtb_type_param

!! ========================================================================
!  global storage of options, parameters and basis set
      use xtb_setparam

      implicit none

!! ========================================================================
      integer, intent(in) :: ijson ! file handle (usually json-file)
!  molecule data
      type(TMolecule), intent(in) :: mol
      type(TWavefunction), intent(in) :: wfx
      type(TBasisset), intent(in) :: xbas
      type(scc_results), intent(in) :: sccres
      type(freq_results), intent(in) :: freqres
      logical :: alpha
      alpha = set%elprop == p_elprop_alpha

      call write_json_header(ijson)
      call write_json_scc_results(ijson, sccres)
      if (freqres%gtot > 0.0_wp) then
         call write_json_thermo(ijson, freqres)
      end if
      call write_json_charges(ijson, wfx)
      if (set%gfn_method == 2) then
         call write_json_dipole_moments(ijson, wfx)
         call write_json_quadrupole_moments(ijson, wfx)
      end if
      call write_json_wavefunction(ijson, wfx)
      if (freqres%n3true > 0) then
         call write_json_frequencies(ijson, freqres)
         call write_json_reduced_masses(ijson, freqres)
         call write_json_intensities(ijson, freqres, alpha)
      end if
      call write_json_footer(ijson)

   end subroutine main_xtb_json

   subroutine write_json_header(ijson)
      integer, intent(in) :: ijson
      write (ijson, '("{")')
   end subroutine write_json_header

   subroutine write_json_footer(ijson)
      use xtb_setparam
      include 'xtb_version.fh'
      integer, intent(in) :: ijson
      character(len=:), allocatable :: cmdline
      integer :: l
      call get_command(length=l)
      allocate (character(len=l) :: cmdline)
      call get_command(cmdline)
      write (ijson, '(3x,''"program call":'',1x,''"'',a,''",'')') cmdline
      write (ijson, '(3x,''"method": "GFN'',i0,''-xTB",'')') set%gfn_method
      write (ijson, '(3x,a)') '"xtb version": "'//version//'"'
      write (ijson, '("}")')
   end subroutine write_json_footer

   subroutine write_json_ptb_footer(ijson)
      use xtb_setparam
      include 'xtb_version.fh'
      integer, intent(in) :: ijson
      character(len=:), allocatable :: cmdline
      integer :: l
      call get_command(length=l)
      allocate (character(len=l) :: cmdline)
      call get_command(cmdline)
      write (ijson, '(3x,''"program call":'',1x,''"'',a,''",'')') cmdline
      write (ijson, '(3x,''"method": "PTB",'')')
      write (ijson, '(3x,a)') '"xtb version": "'//version//'"'
      write (ijson, '("}")')
   end subroutine write_json_ptb_footer

   subroutine write_json_scc_results(ijson, sccres)
      use xtb_type_data
      integer, intent(in) :: ijson
      type(scc_results), intent(in) :: sccres
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      write (ijson, jfmtf) 'total energy', sccres%e_total
      write (ijson, jfmtf) 'HOMO-LUMO gap / eV', sccres%hl_gap
      write (ijson, jfmtf) 'electronic energy', sccres%e_elec
      write (ijson, '(3x,''"'',a,''":'',1x,"[",2(f15.8,","),f15.8,"],")') &
         'dipole / a.u.', sccres%dipole
      !write(ijson,jfmtf) 'classical repulsion energy',sccres%e_rep
      !write(ijson,jfmtf) 'isotropic electrostatic energy',sccres%e_es
      !write(ijson,jfmtf) 'anisotropic electrostatic energy',sccres%e_aes
      !write(ijson,jfmtf) 'anisotropic XC energy',sccres%e_axc
      !write(ijson,jfmtf) 'classical halogen bound energy',sccres%e_xb
      !write(ijson,jfmtf) 'Generalized Born free energy',sccres%g_born
      !write(ijson,jfmtf) 'SASA free energy',sccres%g_born
      !write(ijson,jfmtf) 'Hydrogen bound free energy',sccres%g_born
   end subroutine write_json_scc_results

   subroutine write_json_charges(ijson, wfn)
      use xtb_type_wavefunction
      integer, intent(in) :: ijson
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      integer :: i
      write (ijson, jfmta) 'partial charges'
      write (ijson, '(3x,f15.8,",")') (wfn%q(i), i=1, wfn%n - 1)
      write (ijson, '(3x,f15.8,"],")') wfn%q(wfn%n)
   end subroutine write_json_charges

   subroutine write_json_bondorder(ijson, mol, wfn)
      use xtb_type_molecule, only: TMolecule
      use xtb_type_wavefunction, only: TWavefunction
      integer, intent(in) :: ijson
      type(TMolecule), intent(in) :: mol
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      integer :: i, j
      logical :: first
      write (ijson, jfmta) 'bond orders'
      do i = 1, mol%n - 1
         do j = i, mol%n
            if (wfn%wbo(j, i) > 0.01) then
               if (first) then
                  write (ijson, '(a)') ','
               end if
               first = .true.
               write (ijson, '(3x,"[ ",i5,",",i5,",",f8.4,"]")', advance='no') i, j, wfn%wbo(j, i)
            end if
         end do
      end do
      write (ijson, '(a,/)', advance='no') '],'
   end subroutine write_json_bondorder

   subroutine write_json_dipole_moments(ijson, wfn)
      use xtb_type_wavefunction
      integer, intent(in) :: ijson
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      integer :: i, j
      write (ijson, jfmta) 'atomic dipole moments'
      do i = 1, wfn%n - 1
         write (ijson, '(3x,"[",2(f15.8,","),f15.8,"],")') (wfn%dipm(j, i), j=1, 3)
      end do
      write (ijson, '(3x,"[",2(f15.8,","),f15.8,"]],")') (wfn%dipm(j, wfn%n), j=1, 3)
   end subroutine write_json_dipole_moments

   subroutine write_json_quadrupole_moments(ijson, wfn)
      use xtb_type_wavefunction
      integer, intent(in) :: ijson
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      integer :: i, j
      write (ijson, jfmta) 'atomic quadrupole moments'
      do i = 1, wfn%n - 1
         write (ijson, '(3x,"[",5(f15.8,","),f15.8,"],")') (wfn%qp(j, i), j=1, 6)
      end do
      write (ijson, '(3x,"[",5(f15.8,","),f15.8,"]],")') (wfn%qp(j, wfn%n), j=1, 6)
   end subroutine write_json_quadrupole_moments

   subroutine write_json_wavefunction(ijson, wfn)
      use xtb_type_wavefunction
      integer, intent(in) :: ijson
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      character(len=*), parameter :: jfmti = '(3x,''"'',a,''":'',1x,i0,",")'
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      integer :: i
      write (ijson, jfmti) 'number of molecular orbitals', wfn%nao
      write (ijson, jfmti) 'number of electrons', wfn%nel
      write (ijson, jfmti) 'number of unpaired electrons', wfn%nopen
      write (ijson, jfmta) 'orbital energies / eV'
      write (ijson, '(3x,f15.8,",")') (wfn%emo(i), i=1, wfn%nao - 1)
      write (ijson, '(3x,f15.8,"],")') wfn%emo(wfn%nao)
      write (ijson, jfmta) 'fractional occupation'
      write (ijson, '(3x,f15.8,",")') (wfn%focc(i), i=1, wfn%nao - 1)
      write (ijson, '(3x,f15.8,"],")') wfn%focc(wfn%nao)
   end subroutine write_json_wavefunction

   subroutine write_json_ptb_wavefunction(ijson, wfn)
      use xtb_type_wavefunction
      integer, intent(in) :: ijson
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      character(len=*), parameter :: jfmti = '(3x,''"'',a,''":'',1x,i0,",")'
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      integer :: i, max_print
      max_print = min(wfn%nao, wfn%ihomo + 8)
      write (ijson, jfmti) 'number of molecular orbitals', wfn%nao
      write (ijson, jfmti) 'number of electrons', wfn%nel
      write (ijson, jfmti) 'number of unpaired electrons', wfn%nopen
      write (ijson, jfmta) 'orbital energies / eV'
      write (ijson, '(3x,f15.8,",")') (wfn%emo(i), i=1, max_print - 1)
      write (ijson, '(3x,f15.8,"],")') wfn%emo(max_print)
      write (ijson, jfmta) 'fractional occupation'
      write (ijson, '(3x,f15.8,",")') (wfn%focc(i), i=1, max_print - 1)
      write (ijson, '(3x,f15.8,"],")') wfn%focc(max_print)
   end subroutine write_json_ptb_wavefunction

   subroutine write_json_thermo(ijson, freqres)
      use xtb_type_data
      integer, intent(in) :: ijson
      type(freq_results), intent(in) :: freqres
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      write (ijson, jfmtf) 'total enthalpy', freqres%htot
      write (ijson, jfmtf) 'total free energy', freqres%gtot
   end subroutine write_json_thermo

   subroutine write_json_frequencies(ijson, freqres)
      use xtb_type_data
      integer, intent(in) :: ijson
      type(freq_results), intent(in) :: freqres
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      integer :: i
      write (ijson, jfmta) 'vibrational frequencies / rcm'
      write (ijson, '(3x,f15.8,",")') (freqres%freq(i), i=1, freqres%n3true - 1)
      write (ijson, '(3x,f15.8,"],")') freqres%freq(freqres%n3true)
   end subroutine write_json_frequencies

   subroutine write_json_intensities(ijson, freqres, printalpha)
      use xtb_type_data
      use xtb_mctc_accuracy, only: wp
      integer, intent(in) :: ijson
      type(freq_results), intent(in) :: freqres
      logical, intent(in) :: printalpha
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      integer :: i
      write (ijson, jfmta) 'IR intensities / km/mol'
      do i = 1, freqres%n3true - 1
         if (abs(freqres%freq(i)) < 1.0e-2_wp) then
            write (ijson, '(3x,f15.8,",")') 0.0_wp
         else
            write (ijson, '(3x,f15.8,",")') freqres%dipt(i)
         end if
      end do
      write (ijson, '(3x,f15.8,"],")') freqres%dipt(freqres%n3true)
      if (printalpha) then
         write (ijson, jfmta) 'Raman activities / A^4/amu'
         do i = 1, freqres%n3true - 1
            if (abs(freqres%freq(i)) < 1.0e-2_wp) then
               write (ijson, '(3x,f15.8,",")') 0.0_wp
            else
               write (ijson, '(3x,f15.8,",")') freqres%polt(i)
            end if
         end do
         write (ijson, '(3x,f15.8,"],")') freqres%polt(freqres%n3true)
      end if
   end subroutine write_json_intensities

   subroutine write_json_reduced_masses(ijson, freqres)
      use xtb_type_data
      integer, intent(in) :: ijson
      type(freq_results), intent(in) :: freqres
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      integer :: i
      write (ijson, jfmta) 'reduced masses'
      write (ijson, '(3x,f15.8,",")') (freqres%rmass(i), i=1, freqres%n3true - 1)
      write (ijson, '(3x,f15.8,"],")') freqres%rmass(freqres%n3true)
   end subroutine write_json_reduced_masses

   subroutine write_json_gfnff_lists(n, etot, gnorm, topo, neigh, nlist, printTopo)
      use xtb_gfnff_topology, only: TGFFTopology
      use xtb_gfnff_neighbourlist, only: TGFFNeighbourList
      use xtb_gfnff_topology, only: TPrintTopo
      use xtb_mctc_accuracy, only: wp
      use xtb_gfnff_neighbor
      include 'xtb_version.fh'
      !> gfnff topology lists
      type(TGFFTopology), intent(in) :: topo
      !> gfnff neighbourlist
      type(TNeigh) :: neigh
      !> gfnff neighbourlist
      type(TGFFNeighbourList), intent(in) :: nlist
      !> topology printout booleans
      type(TPrintTopo), intent(in) :: printTopo
      !> total energy and gradient norm
      real(wp), intent(in) :: etot, gnorm
      character(len=:), allocatable :: cmdline
      integer :: iunit, i, j, n, l

      call open_file(iunit, 'gfnff_lists.json', 'w')
      ! header
      write (iunit, '("{")')
      ! lists printout
      if (printTopo%etot) then ! total energy is scalar
         write (iunit, '(3x,''"total energy":'',f25.15,",")') etot
      end if
      if (printTopo%gnorm) then ! gradient norm is scalar
         write (iunit, '(3x,''"gradient norm":'',f25.15,",")') gnorm
      end if
      if (printTopo%nb) then ! nb(numnb, n, numctr)
         write (iunit, '(3x,''"nb":'',"[")') ! open nb
         if (neigh%numctr == 1) then
            do j = 1, n - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') neigh%nb(:, j, 1) ! open nb entry
               write (iunit, '("],")') ! close nb entry
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') neigh%nb(:, n, 1)
            write (iunit, '("]")')
         else ! periodic boundary conditions
            do i = 1, neigh%numctr - 1 ! iterate over all cells
               write (iunit, '(3x,"[")') ! open cell
               do j = 1, n - 1
                  write (iunit, '(3x,"[",*(i7,:,","))', advance='no') neigh%nb(:, j, i)
                  write (iunit, '("],")')
               end do
               write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') neigh%nb(:, n, i)
               write (iunit, '("]")')
               write (iunit, '(3x,"],")') ! close cell
            end do
            write (iunit, '(3x,"[")') ! open last cell
            do j = 1, n - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') neigh%nb(:, j, neigh%numctr)
               write (iunit, '("],")')
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') neigh%nb(:, n, neigh%numctr)
            write (iunit, '("]")')
            write (iunit, '(3x,"]")') ! close last cell
         end if
         write (iunit, '(3x,"],")') ! close nb
      end if
      ! bpair(j,i,iTr) number bonds between i and j when j is translated by iTr
      if (printTopo%bpair) then
         write (iunit, '(3x,''"bpair":'',"[")') ! open bpair
         if (neigh%numctr == 1) then
            do i = 1, n - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') neigh%bpair(:, i, 1) ! open entry
               write (iunit, '("],")') ! close entry
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') neigh%bpair(:, n, 1)
            write (iunit, '("]")')
         else ! periodic boundary conditions
            do i = 1, neigh%numctr - 1 ! iterate over all cells
               write (iunit, '(3x,"[")') ! open cell
               do j = 1, n - 1
                  write (iunit, '(3x,"[",*(i7,:,","))', advance='no') neigh%bpair(:, j, i)
                  write (iunit, '("],")')
               end do
               write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') neigh%bpair(:, n, i)
               write (iunit, '("]")')
               write (iunit, '(3x,"],")') ! close cell
            end do
            write (iunit, '(3x,"[")') ! open last cell
            do j = 1, n - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') neigh%bpair(:, j, neigh%numctr)
               write (iunit, '("],")')
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') neigh%bpair(:, n, neigh%numctr)
            write (iunit, '("]")')
            write (iunit, '(3x,"]")') ! close last cell
         end if
         write (iunit, '(3x,"],")') ! close bpair
      end if
      if (printTopo%alist) then ! alist(3,nangl)
         write (iunit, '(3x,''"alist":'',"[")')
         do j = 1, topo%nangl - 1
            write (iunit, '(3x,"[",*(i8,:,","))', advance='no') topo%alist(:, j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(i8,:,","),"]",/)', advance='no') topo%alist(:, topo%nangl)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%blist) then ! blist(3,nbond)
         write (iunit, '(3x,''"blist":'',"[")')
         do j = 1, neigh%nbond - 1
            write (iunit, '(3x,"[",*(i8,:,","))', advance='no') neigh%blist(:, j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(i8,:,","),"]",/)', advance='no') neigh%blist(:, neigh%nbond)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%tlist) then ! tlist(5,ntors)
         write (iunit, '(3x,''"tlist":'',"[")')
         do j = 1, topo%ntors - 1
            write (iunit, '(3x,"[",*(i8,:,","))', advance='no') topo%tlist(:, j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(i8,:,","),"]",/)', advance='no') topo%tlist(:, topo%ntors)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%vtors) then ! vtors(2,ntors)
         write (iunit, '(3x,''"vtors":'',"[")')
         do j = 1, topo%ntors - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') topo%vtors(:, j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') topo%vtors(:, topo%ntors)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%vbond) then ! vbond(3,nbond)
         write (iunit, '(3x,''"vbond":'',"[")')
         do j = 1, neigh%nbond - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') topo%vbond(:, j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') topo%vbond(:, neigh%nbond)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%vangl) then ! vangl(2,nangl)
         write (iunit, '(3x,''"vangl":'',"[")')
         do j = 1, topo%nangl - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') topo%vangl(:, j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') topo%vangl(:, topo%nangl)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%hbbond) then ! hbbond: 3x(3,nhb) energies: 3x(1,nhb)
         write (iunit, '(3x,''"hbl":'',"[")') !> HBs loose
         if (nlist%nhb1 >= 1) then
            do j = 1, nlist%nhb1 - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') nlist%hblist1(:, j)
               write (iunit, '("],")')
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') nlist%hblist1(:, nlist%nhb1)
            write (iunit, '("]")')
            write (iunit, '(3x,"],")')
         else
            write (iunit, '(3x,"[",*(i7,:,""))', advance='no') 0
            write (iunit, '("]")')
            write (iunit, '(3x,"],")')
         end if

         write (iunit, '(3x,''"hbb":'',"[")') !> HBs bonded
         if (nlist%nhb2 >= 1) then
            do j = 1, nlist%nhb2 - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') nlist%hblist2(:, j)
               write (iunit, '("],")')
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') nlist%hblist2(:, nlist%nhb2)
            write (iunit, '("]")')
            write (iunit, '(3x,"],")')
         else
            write (iunit, '(3x,"[",*(i7,:,""))', advance='no') 0
            write (iunit, '("]")')
            write (iunit, '(3x,"],")')
         end if

         write (iunit, '(3x,''"xb":'',"[")') !> XBs
         if (nlist%nxb >= 1) then
            do j = 1, nlist%nxb - 1
               write (iunit, '(3x,"[",*(i7,:,","))', advance='no') nlist%hblist3(:, j)
               write (iunit, '("],")')
            end do
            write (iunit, '(3x,"[",*(i7,:,","),"]",/)', advance='no') nlist%hblist3(:, nlist%nxb)
            write (iunit, '("]")')
            write (iunit, '(3x,"],")')
         else
            write (iunit, '(3x,"[",*(i7,:,""))', advance='no') 0
            write (iunit, '("]")')
            write (iunit, '(3x,"],")')
         end if

         ! energies
         write (iunit, '(3x,''"hbl_e":'',"[")')
         do j = 1, nlist%nhb1 - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%hbe1(j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%hbe1(nlist%nhb1)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')

         write (iunit, '(3x,''"hbb_e":'',"[")')
         do j = 1, nlist%nhb2 - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%hbe2(j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%hbe2(nlist%nhb2)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')

         write (iunit, '(3x,''"xb_e":'',"[")')
         do j = 1, nlist%nxb - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%hbe3(j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%hbe3(nlist%nxb)
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if
      if (printTopo%eeq) then ! eeq(3,n)
         write (iunit, '(3x,''"eeq":'',"[")') !> EEQ charges
         do j = 1, size(nlist%q) - 1
            write (iunit, '(3x,"[",*(f25.15,:,","))', advance='no') nlist%q(j)
            write (iunit, '("],")')
         end do
         write (iunit, '(3x,"[",*(f25.15,:,","),"]",/)', advance='no') nlist%q(size(nlist%q))
         write (iunit, '("]")')
         write (iunit, '(3x,"],")')
      end if

      ! footer
      call get_command(length=l)
      allocate (character(len=l) :: cmdline)
      call get_command(cmdline)
      write (iunit, '(3x,''"program call":'',1x,''"'',a,''",'')') cmdline
      write (iunit, '(3x,''"method": "GFN-FF"'',",")')
      write (iunit, '(3x,a)') '"xtb version": "'//version//'"'
      write (iunit, '("}")')
      call close_file(iunit)

   end subroutine write_json_gfnff_lists
   
   !> wrapper for tblite-PTB JSON output
   subroutine main_ptb_json &
      (ijson, mol, wfx, calc, sccres, freqres)

      use xtb_type_molecule, only: TMolecule
      use xtb_type_wavefunction, only: TWavefunction
      use xtb_type_data, only: scc_results, freq_results
      use xtb_ptb_calculator, only: TPTBCalculator

      integer, intent(in) :: ijson 
      type(TMolecule), intent(in) :: mol
      type(TWavefunction), intent(in) :: wfx
      type(TPTBCalculator), intent(in) :: calc
      type(scc_results), intent(in) :: sccres
      type(freq_results), intent(in) :: freqres

#if WITH_TBLITE
      call tblite_ptb_json(ijson, mol, wfx, calc%bas, sccres, freqres)
#endif

   end subroutine main_ptb_json

#if WITH_TBLITE
   subroutine tblite_ptb_json &
      (ijson, mol, wfx, bas, sccres, freqres)
      use mctc_env, only: wp
   !! ========================================================================
      !  load class definitions
      use xtb_type_molecule, only: TMolecule
      use xtb_type_wavefunction, only: TWavefunction
      use xtb_type_data, only: scc_results, freq_results
      !> tblite-specific types
      use tblite_basis_type, only: basis_type
   !! ========================================================================
      !  global storage of options, parameters and basis set
      use xtb_setparam
      implicit none

   !! ========================================================================
      integer, intent(in) :: ijson ! file handle (usually json-file)
      !  molecule data
      type(TMolecule), intent(in) :: mol
      type(TWavefunction), intent(in) :: wfx
      type(basis_type), intent(in) :: bas
      type(scc_results), intent(in) :: sccres
      type(freq_results), intent(in) :: freqres
      logical :: alpha
      alpha = set%elprop == p_elprop_alpha

      call write_json_header(ijson)
      call write_json_scc_results(ijson, sccres)
      if (freqres%gtot > 0.0_wp) then
         call write_json_thermo(ijson, freqres)
      end if
      call write_json_charges(ijson, wfx)
      call write_json_ptb_shell_charges(ijson, mol, bas, wfx)
      call write_json_bondorder(ijson, mol, wfx)
      call write_json_dipole_moments(ijson, wfx)
      call write_json_quadrupole_moments(ijson, wfx)
      call write_json_ptb_wavefunction(ijson, wfx)
      if (freqres%n3true > 0) then
         call write_json_frequencies(ijson, freqres)
         call write_json_reduced_masses(ijson, freqres)
         call write_json_intensities(ijson, freqres, alpha)
      end if
      call write_json_ptb_footer(ijson)

   end subroutine tblite_ptb_json

   subroutine write_json_ptb_shell_charges(ijson, mol, bas, wfn)
      use xtb_type_wavefunction, only: TWavefunction
      use xtb_type_molecule, only: TMolecule
      use xtb_ptb_vdzp, only: max_shell
      use tblite_basis_type, only: basis_type
      integer, intent(in) :: ijson
      type(TMolecule), intent(in) :: mol
      type(basis_type), intent(in) :: bas
      type(TWavefunction), intent(in) :: wfn
      character(len=*), parameter :: jfmta = '(3x,''"'',a,''": ['')'
      character(len=*), parameter :: jfmtf = '(3x,''"'',a,''":'',1x,f20.8,",")'
      integer :: iat, ish, ii
      write (ijson, jfmta) 'shell charges'
      do iat = 1, mol%n
         ii = bas%ish_at(iat)
         write (ijson, '(3x,a)', advance='no') "["
         do ish = 1, bas%nsh_at(iat) - 1
            write (ijson, '(f15.8,",")', advance="no") wfn%qsh(ii + ish)
         end do
         if (iat == mol%n) then
            write (ijson, '(f15.8,"]],",/)', advance="no") wfn%qsh(ii + bas%nsh_at(iat))
         else
            write (ijson, '(f15.8,"],",/)', advance="no") wfn%qsh(ii + bas%nsh_at(iat))
         end if
      end do
   end subroutine write_json_ptb_shell_charges
#endif

end module xtb_main_json

! This file is part of xtb.
!
! Copyright (C) 2017-2019 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_disp_dftd4param
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants, only : pi
   implicit none
   public

   real(wp) :: thopi,ootpi
   parameter ( thopi = 3._wp/pi )
   parameter ( ootpi = 0.5_wp/pi )

   integer, parameter :: p_refq_gfn2xtb          = 0
   integer, parameter :: p_refq_gasteiger        = 1
   integer, parameter :: p_refq_hirshfeld        = 2
   integer, parameter :: p_refq_periodic         = 3
   integer, parameter :: p_refq_gfn2xtb_gbsa_h2o = 4
   integer, parameter :: p_refq_goedecker        = 5

   integer, parameter :: p_mbd_none       = 0
   integer, parameter :: p_mbd_rpalike    = 1
   integer, parameter :: p_mbd_exact_atm  = 2
   integer, parameter :: p_mbd_approx_atm = 3

   integer, private, parameter :: max_elem = 118
   real(wp), parameter :: zeff(max_elem) = [ &
      &   1,                                                 2,  & ! H-He
      &   3, 4,                               5, 6, 7, 8, 9,10,  & ! Li-Ne
      &  11,12,                              13,14,15,16,17,18,  & ! Na-Ar
      &  19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,  & ! K-Kr
      &   9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,  & ! Rb-Xe
      &   9,10,11,30,31,32,33,34,35,36,37,38,39,40,41,42,43,  & ! Cs-Lu
      &  12,13,14,15,16,17,18,19,20,21,22,23,24,25,26, & ! Hf-Rn
      !  just copy & paste from above
      &   9,10,11,30,31,32,33,34,35,36,37,38,39,40,41,42,43,  & ! Fr-Lr
      &  12,13,14,15,16,17,18,19,20,21,22,23,24,25,26  ] ! Rf-Og

   integer, dimension(max_elem)      :: refn ! for D4
   real(wp),dimension(7,max_elem)    :: refq
   real(wp),dimension(7,max_elem)    :: refh
   real(wp),dimension(7,max_elem)    :: dftq,pbcq,gffq,solq,clsq
   real(wp),dimension(7,max_elem)    :: dfth,pbch,gffh,solh,clsh
   real(wp),dimension(7,max_elem)    :: hcount 
   real(wp),dimension(7,max_elem)    :: ascale
   real(wp),dimension(7,max_elem)    :: refcovcn
   real(wp),dimension(7,max_elem)    :: refcn
   integer, dimension(7,max_elem)    :: refsys 
   real(wp),dimension(23,7,max_elem) :: alphaiw
   real(wp),dimension(17)       :: secq
   real(wp),dimension(17)       :: dfts,pbcs,gffs,sols,clss
   real(wp),dimension(17)       :: sscale
   real(wp),dimension(17)       :: seccn
   real(wp),dimension(17)       :: seccnd3
   real(wp),dimension(23,17)    :: secaiw

   include 'param_ref.fh'

end module xtb_disp_dftd4param

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!-----------------------------------------------------------------------
!> ONIOM implementaion
!-----------------------------------------------------------------------
module xtb_oniom

   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_convert, only: aatoau
   use xtb_type_atomlist, only: TAtomlist, len
   use xtb_type_calculator, only: TCalculator
   use xtb_type_data, only: scc_results
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule, only: TMolecule, len
   use xtb_type_restart, only: TRestart
   use xtb_type_neighbourlist, only: TNeighbourlist
   use xtb_gfnff_calculator, only: TGFFCalculator, newGFFCalculator
   use xtb_type_topology, only: TTopology, len
   use xtb_xtb_calculator, only: TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_extern_orca, only: TOrcaCalculator, newOrcaCalculator
   use xtb_extern_turbomole, only: TTMCalculator, newTMCalculator
   use xtb_setparam, only: set

   implicit none
   private

   public :: TOniomCalculator, newOniomCalculator, oniom_input, calculateCharge
   
   !> To handle CML arguments
   type :: oniom_input
      character(len=:), allocatable :: first_arg
      character(len=:), allocatable :: second_arg
   
      end type oniom_input
   
   !> ONIOM calculator 
   type, extends(TCalculator) :: TOniomCalculator 

      !> methods specified by the user, or default: gfnff, gfn2
      integer :: method_low, method_high

      !> charge for inner region
      integer :: chrg_model
         ! rewrite

      !> inner region list
      type(TAtomList) :: list 

      !> whole region, low-level 
      class(TCalculator), allocatable :: real_low

      !> inner region, low-level
      class(TCalculator), allocatable :: model_low

      !> inner region, high-level
      class(TCalculator), allocatable :: model_high

      !> index list of the inner region
      integer, allocatable :: idx(:)
      
      !> topology used for cutting bonds
      type(TTopology), allocatable :: topo

      !> wavefunctions for inner region calculations
      type(TRestart) :: chk_low, chk_high

   contains

      procedure :: singlepoint
      procedure :: hessian
      procedure :: writeInfo
      procedure :: cutbond

   end type TOniomCalculator

   interface coord
      module procedure :: newcoord
   end interface

   interface resize
      module procedure :: new_atom
      module procedure :: new_coordinates
   end interface


contains

!> create ONIOM Calcultor
subroutine newOniomCalculator(self, env, mol, input)
   
   implicit none
   
   !> new ONIOM calculator
   type(TOniomCalculator), intent(out) :: self
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(in) :: mol
   
   !> cml input
   type(oniom_input), intent(in) :: input
   
   type(TxTBCalculator), allocatable :: xtb
   type(TOrcaCalculator), allocatable :: orca
   type(TGFFCalculator), allocatable :: gff
   integer :: icol
   integer :: i
   
   !--------------!
   ! method setup !
   !--------------!

   ! methods explicitly specified !
   if (allocated(input%first_arg)) then
      
      icol = index(input%first_arg, ':')
      if (icol == 0) then
         call env%error("Invalid method '"//input%first_arg//"' provided")
         return
      end if

      self%method_high = string_to_id(input%first_arg(:icol - 1))
      self%method_low = string_to_id(input%first_arg(icol + 1:))
      
      if (self%method_high < 0 .or. self%method_high > 5) then
         call env%error("Invalid high-level method")
         return
      end if
      
      if (self%method_low < 0 .or. self%method_low > 3) then
         call env%error("Invalid low-level method")
         return
      end if
   
   ! default, gfn2:gfnff !
   else

      self%method_high = 2
      self%method_low = 3
   
   endif
   
   ! write user-defined inner region list into array !
   self%list = TAtomList(list=input%second_arg)
   call self%list%to_list(self%idx)

   if (len(self%list) == 0) then
      call env%error("No atoms in inner region '"//input%second_arg//"'")
      return
   end if

   ! check inner region !
   if (any(self%idx < 1) .or. any(self%idx > mol%n)) then
      call env%error('The specification of inner region is not correct')
      return
   end if

   ! whole region calculator ! 
   select case (self%method_low)
   
   ! gfn1/2 !
   case default
      allocate (xtb)
      call newXTBCalculator(env, mol, xtb, method=self%method_low)
      call move_alloc(xtb, self%real_low)

   ! gfnff !
   case (3)
      allocate (gff)
      call newGFFCalculator(env, mol, gff, "", .false.)
      call move_alloc(gff, self%real_low)

   end select

end subroutine newOniomCalculator

!> 3 singlepoint energy calculations
subroutine singlepoint(self, env, mol, chk, printlevel, restart, energy, gradient, sigma, hlgap, results)

   use xtb_io_writer
   use xtb_mctc_filetypes, only : fileType
   use xtb_xtb_calculator, only: TxTBCalculator

   implicit none
   
   !> instance of TOniomCalculator
   class(TOniomCalculator), intent(inout) :: self
   
   !> calculation environment      
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(inout) :: mol
   
   !> restart data wrapper
   type(TRestart), intent(inout) :: chk
   
   !> print level for IO
   integer, intent(in) :: printlevel 
   
   !> if restarted
   logical, intent(in) :: restart
   
   
   !> ONIOM total energy
   real(wp), intent(out) :: energy
   
   !> ONIOM gradients
   real(wp), intent(out) :: gradient(:, :)
   
   !> strain derivatives
   real(wp), intent(out) :: sigma(:, :) 
   
   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap
   
   !> final output stream
   type(scc_results), intent(out) :: results
   
   
   ! temporary storages !
   type(TxTBCalculator), allocatable :: tmp 
   type(TGFFCalculator), allocatable :: gff
   type(TOrcaCalculator), allocatable :: orca
   type(TTMCalculator), allocatable :: turbo
   
   ! for inner region high- and low-level calculation !
   type(scc_results) :: results_low, results_high
   type(TMolecule) :: inner_mol
   real(wp), allocatable :: gradient_low(:, :), gradient_high(:, :)
   real(wp) :: energy_model_low, energy_model_high, hlgap_low, hlgap_high
   real(wp) :: sigma_low(3, 3), sigma_high(3, 3)

   !> arrays for matmul of gradient matrix and Jacobian  
   real(wp),allocatable :: arr_gh(:), arr_gl(:)
   
   !> Jacobian matrix
   real(wp), allocatable :: jacobian(:,:)
   
   integer,allocatable :: idx2(:)
   integer :: i, coord_unit
   logical :: exitRun

   ! check whether the calculator is initialized !
   if (.not. allocated(self%real_low)) then
      call env%error("Outer region calculator not provided")
      return
   end if

   ! forward solvation to outer region !
   if (allocated(self%solvation)) then
      call move_alloc(self%solvation, self%real_low%solvation)
   end if
   
   !-------------------------!
   ! whole system, low-level !
   !-------------------------!

   if (.not.set%oniom_settings%cut_inner) then
      
      if (printlevel > 0) then
         write(env%unit,'(a)')
         write(env%unit,'(2x,72("-"))')
         write (env%unit, '(/6x,a/)') "Singlepoint calculation of whole system with low-level method"
         write(env%unit,'(2x,72("-"))')
         write(env%unit,'(a)')
      endif

      call self%real_low%singlepoint(env, mol, chk, printlevel, restart, &
         & energy, gradient, sigma, hlgap, results)
   
   endif
   
   ! creating Linked Atoms !
   call self%cutbond(env, mol, chk, self%topo, inner_mol,jacobian,idx2)
   
   ! define inner region charge !
   inner_mol%chrg = real(set%oniom_settings%innerchrg)

   ! --cut flag termination !
   if (set%oniom_settings%cut_inner) then
      
      write(env%unit,'(a)')
      write(env%unit,'(2x,72("-"))')
      write(env%unit,'(2x,"|",24x,a,1x,i0,22x,"|")') "INNER REGION CHARGE = ", nint(inner_mol%chrg)
      write(env%unit,'(2x,72("-"))')
      write(env%unit,'(a)')
      call terminate(0)
   
   endif
    
   call env%check(exitRun)
   if (exitRun) then
      call env%error("Could not create the linked atoms")
      return
   end if

   !-------------------------!
   ! inner region, low-level !
   !-------------------------!
   
   if (.not. allocated(self%model_low)) then

      select case (self%method_low)
      case default
         call env%error("Invalid low-level inner method")
         return

      ! gfn1/2 !
      case (1, 2)
         allocate (tmp)
         call newXTBCalculator(env, inner_mol, tmp, method=self%method_low)
         call move_alloc(tmp, self%model_low)

      ! gfnff !
      case (3)
         allocate (gff)
         call newGFFCalculator(env, inner_mol, gff, "", .false.)
         call move_alloc(gff, self%model_low)
      
      end select
      
      call env%check(exitRun)
      if (exitRun) then
         call env%error("Could not setup low-level method")
         return
      end if
   
   end if
  
   !--------------------------!
   ! inner region, high-level !
   !--------------------------!

   if (.not. allocated(self%model_high)) then

      select case (self%method_high)
      case default
         call env%error("Invalid high-level inner method")
         return
      
      ! gfn1/2 !
      case (1, 2)
         allocate (tmp)
         call newXTBCalculator(env, inner_mol, tmp, method=self%method_high)
         call move_alloc(tmp, self%model_high)

      ! gfnff !
      case (3)
         allocate (gff)
         call newGFFCalculator(env, inner_mol, gff, "", .false.)
         call move_alloc(gff, self%model_high)

      ! orca !
      case (4)
         allocate (orca)
         call newOrcaCalculator(orca, env, set%ext_orca,oniom=.true.)
         call move_alloc(orca, self%model_high)

      ! turbomole !
      case (5)  
         allocate (turbo)
         call newTMCalculator(turbo, 1, 1)
         call move_alloc(turbo, self%model_high)
         
         ! to copy coord file into origin.coord !
         call protectCoord(env)

      end select
      
      call env%check(exitRun)
      if (exitRun) then
         call env%error("Could not setup high-level method")
         return
      end if

   end if
 
   ! setup partial and shell charges for gnf1/2 !
   if (.not.allocated(self%chk_low%wfn%qsh)) then
      select type (calc => self%model_low)
      type is (TxTBCalculator)
         call newWavefunction(env, inner_mol, calc, self%chk_low)
      end select
   end if
   if (.not.allocated(self%chk_high%wfn%qsh)) then
      select type (calc => self%model_high)
      type is (TxTBCalculator)
         call newWavefunction(env, inner_mol, calc, self%chk_high)
      end select
   end if
   

   ! SP: inner region low-level !
   if (printlevel > 0) then
      write(env%unit,'(a)')
      write(env%unit,'(2x,72("-"))')
      write (env%unit, '(/6x,a/)') "Singlepoint calculation of inner region with low-level method"
      write(env%unit,'(2x,72("-"))')
      write(env%unit,'(a)')
   endif

   allocate (gradient_low(3, inner_mol%n))
   energy_model_low = 0.0_wp
   gradient_low = 0.0_wp

   call self%model_low%singlepoint(env, inner_mol, self%chk_low, printlevel, restart, &
       & energy_model_low, gradient_low, sigma_low, hlgap_low, results_low)


   ! SP: inner region high-level !
   if (printlevel > 0) then
      write(env%unit,'(a)')
      write(env%unit,'(2x,72("-"))')
      write (env%unit, '(/6x,a/)') "Singlepoint calculation of inner region with high-level method"
      write(env%unit,'(2x,72("-"))')
      write(env%unit,'(a)')
   endif

   allocate (gradient_high(3, inner_mol%n))
   energy_model_high = 0.0_wp
   gradient_high = 0.0_wp

   call self%model_high%singlepoint(env, inner_mol, self%chk_high, printlevel, restart, &
       & energy_model_high, gradient_high, sigma_high, hlgap_high, results_high)
   

   ! write opt logs for inner region !
   if (set%oniom_settings%logs)then
      call writeMolecule(inner_mol, set%oniom_settings%ilog1, format=filetype%xyz,energy=energy_model_low)
      call writeMolecule(inner_mol, set%oniom_settings%ilog2, format=filetype%xyz,energy=energy_model_high)
   endif


   results%dipole = results%dipole + results_high%dipole - results_low%dipole 
   sigma = sigma - sigma_low + sigma_high
   results%hl_gap = hlgap - hlgap_low + hlgap_high

   !----------------!
   ! Postprocessing !
   !----------------!

   ! ONIOM energy !
   energy = energy + energy_model_high - energy_model_low
   results%e_total = energy
   
   ! [gradient*Jacobian] with forward and backward transformation !
   call matrix_to_array(gradient_high,arr_gh)
   call matrix_to_array(gradient_low,arr_gl)
   
   arr_gh=matmul(jacobian,arr_gh)
   arr_gl=matmul(jacobian,arr_gl)
   
   call array_to_matrix(arr_gh,gradient_high)
   call array_to_matrix(arr_gl,gradient_low)
   

   ! ONIOM gradients !
   do i = 1, size(idx2)
      gradient(:, idx2(i)) = gradient(:, idx2(i)) + gradient_high(:, i) - gradient_low(:, i) 
   end do 
   results%gnorm=norm2(gradient)   
   deallocate(gradient_high)
   deallocate(gradient_low)

end subroutine singlepoint

!> Evaluate hessian by finite difference for all atoms
subroutine hessian(self, env, mol0, chk0, list, step, hess, dipgrad)

   character(len=*), parameter :: source = "extern_oniom_hessian"
   
   !> single point calculator
   class(TOniomCalculator), intent(inout) :: self
   
   !> computation environment
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(in) :: mol0
   
   !> restart data
   type(TRestart), intent(in) :: chk0
   
   !> list of atoms to displace
   integer, intent(in) :: list(:)
   
   !> step size for numerical differentiation
   real(wp), intent(in) :: step
   
   !> array to add Hessian to
   real(wp), intent(inout) :: hess(:, :)
   
   !> array to add dipole gradient to
   real(wp), intent(inout) :: dipgrad(:, :)

   real(wp), allocatable :: jacobian(:,:)
   integer,allocatable :: idx2(:)

   integer :: ii, jj, ic, jc, im, jm
   real(wp), allocatable :: hess_model(:, :), dipgrad_model(:, :)
   type(TMolecule) :: mol_model
   integer, allocatable :: list_model(:)

   ! compute complete hessian for outer region !
   call self%real_low%hessian(env, mol0, chk0, list, step, &
       & hess, dipgrad)

   !call chk0%wfn%allocate(mol0%n,chk0%basis%nshell,chk0%real_low%basis%nao)
   
   ! create linked atoms !
   call self%cutbond(env, mol0, chk0, self%topo, mol_model,jacobian,idx2)
   mol_model%chrg = float(self%chrg_model)
   list_model = [(ii, ii = 1, size(self%idx))]

   allocate(hess_model(3*mol_model%n, 3*mol_model%n))
   allocate(dipgrad_model(3, 3*mol_model%n))

   hess_model(:, :) = 0.0_wp
   dipgrad_model(:, :) = 0.0_wp

   call self%model_low%hessian(env, mol_model, self%chk_low, list_model, step, &
       & hess_model, dipgrad_model)

   do ii = 1, size(self%idx)
      im = 3 * (ii - 1)
      ic = 3 * (self%idx(ii) - 1)
      do jj = 1, size(self%idx)
         jm = 3 * (jj - 1)
         jc = 3 * (self%idx(jj) - 1)
         hess(jc+1:jc+3, ic+1:ic+3) = hess(jc+1:jc+3, ic+1:ic+3) &
            & - hess_model(jm+1:jm+3, im+1:im+3)
      end do
      dipgrad(:, ic+1:ic+3) = dipgrad(:, ic+1:ic+3) - dipgrad_model(:, im+1:im+3)
   end do

   hess_model(:, :) = 0.0_wp
   dipgrad_model(:, :) = 0.0_wp
   call self%model_high%hessian(env, mol_model, self%chk_high, list_model, step, &
       & hess_model, dipgrad_model)

   do ii = 1, size(self%idx)
      im = 3 * (ii - 1)
      ic = 3 * (self%idx(ii) - 1)
      do jj = 1, size(self%idx)
         jm = 3 * (jj - 1)
         jc = 3 * (self%idx(jj) - 1)
         hess(jc+1:jc+3, ic+1:ic+3) = hess(jc+1:jc+3, ic+1:ic+3) &
            & + hess_model(jm+1:jm+3, im+1:im+3)
      end do
      dipgrad(:, ic+1:ic+3) = dipgrad(:, ic+1:ic+3) + dipgrad_model(:, im+1:im+3)
   end do

end subroutine hessian

subroutine writeInfo(self, unit, mol)

   class(TOniomCalculator), intent(in) :: self

   !> unit for I/O
   integer, intent(in) :: unit
   
   !> molecular structural data
   type(Tmolecule), intent(in) :: mol

end subroutine writeInfo

!> create inner region
subroutine cutbond(self, env, mol, chk, topo, inner_mol,jacobian,idx2)

   use xtb_type_molecule, only: init
   use xtb_topology, only: makeBondTopology, topologyToNeighbourList
   use xtb_io_writer
   use xtb_mctc_filetypes, only : fileType
   
   implicit none
   character(len=*), parameter :: source = "xtb_oniom_cutbond" 

   !> polymorphic calculator
   class(TOniomCalculator), intent(in) :: self
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> wavefunction wrapper
   type(TRestart), intent(in) :: chk
   
   !> molecular structure data 
   type(TMolecule), intent(in) :: mol
   
   !> inner region mol str data
   type(TMolecule), intent(inout) :: inner_mol
   
   !> topology info
   type(TTopology), allocatable, intent(inout) :: topo
   
   !> jacobian matrix 
   real(wp),allocatable, intent(inout) :: jacobian(:,:)
   
   !> list of inner region atom indices + host atoms
   integer,allocatable, intent(out) :: idx2(:)
   
   !> neighbour list
   type(TNeighbourList) :: neighList
      
   !> pair-wise indices for cutbound  
   integer, allocatable :: brokenBondPairs(:,:)
   
   integer, allocatable :: at(:), at2(:)
   integer, allocatable :: bonded(:, :)
   real(wp), allocatable :: xyz(:, :), xyz2(:, :)
   character(len=:),allocatable :: fname_inner
   
   !> if the both bonded atoms are inside the inner region
   logical :: inside
   
   integer :: i, j, n, k, pre_last,iterator
   integer :: io

   !-------!
   ! SETUP !
   !-------!

   inside = .FALSE.

   ! initial number of atoms in inner region without LAs !
   n = len(self%list)
   
   ! allocate accordingly the basic molecular data !
   allocate (at2(size(self%idx)))
   allocate (xyz2(3, size(self%idx)))
   allocate (at(n))
   allocate (xyz(3, n))
   allocate (idx2(size(self%idx)))
   
   ! save inner region list in the matching array !
   idx2=self%idx
   
   ! assign initial inner region !
   do i = 1, size(self%idx)
      at(i) = mol%at(self%idx(i))
      at2(i) = mol%at(self%idx(i))
      xyz(:, i) = mol%xyz(:, self%idx(i))
      xyz2(:, i) = mol%xyz(:, self%idx(i))
   end do
 
   ! initialiaze jacobian as identity !
   call create_jacobian(jacobian,at)
   
   ! identify bonded atoms and save them into an array + assign iterator !
   select type (calc => self%real_low)
   class default
      call env%error("Topology information could not be derived from the given calculator",source)
      return

   ! gfnff !
   type is (TGFFCalculator)
      
      ! bonded atom list !
      bonded = calc%topo%blist 
      
      ! number of bonds !
      iterator = size(bonded,2)

   ! gfn1/2 !
   type is (TxTBCalculator)
      if (.not. allocated(topo)) then
         allocate (topo)

         ! return assigned topo%list !
         call makeBondTopology(topo, mol, chk%wfn%wbo) 
         
         ! return neighList !
         call topologyToNeighbourList(topo, neighList, mol) 
      
      end if

      allocate (bonded(2, len(topo)))
      do i = 1, len(topo)
         bonded(:, i) = topo%list(1:2, i)
      end do
      
      iterator = size(bonded,2)
   
   end select

   !-----------!
   ! ALGORITHM !
   !-----------!

   ! iterate for all atoms in the user-provided list !
   do i = 1, size(self%idx)

      ! iterate through pair of atoms that are bonded !
      do j = 1, iterator

         ! if atom in the list is bonded !
         if (bonded(1, j) == self%idx(i)) then

            ! iterate again through the list !
            do k = 1, size(self%idx)
               
               ! inside inner region !
               if (self%idx(k) == bonded(2, j)) then
                  inside = .TRUE.
               end if

            end do

            ! bond is broken !
            if (.not. inside) then
               
               if (.not.set%oniom_settings%ignore_topo) then

                  ! check if single bond is broken  !
                  select type (calc => self%real_low)
                  class default
                     call checkfororder(env, mol, self%idx(i), bonded(2, j), bond=topo%list(3, j))
                  type is (TGFFCalculator)
                     call checkfororder(env, mol, self%idx(i), bonded(2, j), hybrid=calc%topo%hyb)
                  end select
               
               endif
                  
               ! increment array size by 1 !
               pre_last = size(at)
               call resize(at)
               call resize(idx2)
         
               ! save host atom index !
               idx2(pre_last+1) = bonded(2,j)
               ! assign new atom as H !
               at(pre_last + 1) = 1
               
               
               ! adjust coordinate matrix !
               call resize(xyz)
      
               ! increment Jacobian ! 
               call resize_jacobian(jacobian)   
               
               ! determine new position of added H atom !
               call coord(env,mol,xyz,self%idx(i),bonded(2,j),jacobian,i)
               
            end if
            inside = .FALSE.
         
         
         ! if atom in the list is bonded !
         else if (bonded(2, j) == self%idx(i)) then
            
            ! iterate again through the list !
            do k = 1, size(self%idx)
               if (self%idx(k) == bonded(1, j)) then
                  ! inside inner region !
                  inside = .TRUE.
               end if
            end do

            ! bond is broken !
            if (.not. inside) then
               
               if (.not.set%oniom_settings%ignore_topo) then
                  
                  ! check if single bond ! 
                  select type (calc => self%real_low)   
                  class default
                     call checkfororder(env, mol, self%idx(i), bonded(1, j), bond=topo%list(3, j))
                  type is (TGFFCalculator)
                     call checkfororder(env, mol, self%idx(i), bonded(1, j), hybrid=calc%topo%hyb)
                  end select
               
               endif

               ! increment array size by 1 !
               pre_last = size(at)
               call resize(at)
               call resize(idx2)
               
               ! save host atom index !
               idx2(pre_last+1) = bonded(1,j)
               ! assign new atom as H !
               at(pre_last + 1) = 1
               
               ! adjust coordinate matrix !
               call resize(xyz)
               
               ! increment Jacobian matrix !
               call resize_jacobian(jacobian)   
               
               ! determine new position of added H atom !
               call coord(env,mol, xyz, self%idx(i), bonded(1, j),jacobian,i)
            
            end if
            inside = .FALSE.
         
         end if
      end do
   end do

   !----------------!
   ! POSTPROCESSING !
   !----------------!

   ! initialize new mol object !
   call init(inner_mol, at, xyz)
   
   ! create Xmol file for inner region !
   if (set%oniom_settings%cut_inner) then
      fname_inner = "inner_region_without_h.xyz" 
   else
      fname_inner = "inner_region.xyz"
   endif

   call open_file(io, fname_inner, "w")
   call writeMolecule(inner_mol, io, filetype%xyz)
   call close_file(io) 

end subroutine cutbond

!> increase atomic number array by 1 
subroutine new_atom(at)
   
   implicit none
   integer, allocatable, intent(inout) :: at(:)
   integer, allocatable :: tmp2(:)

   allocate (tmp2(size(at) + 1))
   tmp2(:size(at)) = at(:size(at))
   deallocate (at)
   call move_alloc(tmp2, at)

end subroutine new_atom

!> increase coordinate matrix  by 1 
subroutine new_coordinates(xyz)
   
   implicit none
   real, allocatable :: xyz(:,:)
   real, allocatable :: tmp1(:,:)
   integer :: atom_num

   atom_num = size(xyz, 2)
   allocate (tmp1(size(xyz,1), atom_num + 1))
   tmp1(:, :size(xyz,2)) = xyz(:, :size(xyz,2))
   deallocate (xyz)
   call move_alloc(tmp1, xyz)

end subroutine new_coordinates

!> create identity matrix 
subroutine create_jacobian(matrix,at)
   
   implicit none
   real(wp),allocatable :: matrix(:,:)
   integer,intent(in) :: at(:)
   integer :: i, j

   allocate (matrix(size(at)*3,size(at)*3))
   do i=1,size(at)*3
      do j=1,size(at)*3
         if (i==j) then
            matrix(i,j)=1.0_wp
         else
            matrix(i,j)=0.0_wp
         endif
      enddo
   enddo
   
end subroutine create_jacobian

!> increase matrix dimensionality
! (3 new entries in diagonal and subsequent increase) !
subroutine resize_jacobian(matrix)
   
   implicit none
   real(wp), allocatable :: matrix(:,:)
   
   !> temporary storage
   real(wp), allocatable :: tmp(:,:)
   
   !> current number of coordinates
   integer :: coord_num

   coord_num = size(matrix,1)

   allocate(tmp(coord_num+3,coord_num+3))
   tmp(:coord_num,:coord_num) = matrix(:coord_num,:coord_num)
   deallocate(matrix)
   call move_alloc(tmp, matrix)

end subroutine resize_jacobian

!> calculate new postion for LA and corresponding J
subroutine newcoord(env,mol,xyz,idx1,idx2,jacobian,connectorPosition)
   
   implicit none
   
   !> name of error producer routine
   character(len=*), parameter :: source = "oniom_newcoord"
   
   !> calculation environment 
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(in) :: mol
   
   !> coordinate matrix
   real(wp), intent(inout) :: xyz(:, :)
   
   !> connector (one that stays in the inner region)
   integer, intent(in) :: idx1
   
   !> host (one that is substitued) 
   integer, intent(in) :: idx2
   
   !> jacobian maxtrix
   real(wp), intent(inout) :: jacobian(:,:)
   
   !> ordinal number of connector atom in mol%at
   integer, intent(in) :: connectorPosition
   
   !> standard bond length between LAC(linked atom connector)-H
   real(wp) :: dist 
   
   !> standard bond length between LAC(linked atom connector)-LAH(linked atom host)
   real(wp) :: dist2
   
   !> scaling parameter
   real(wp) :: prefactor
   
   !> squared vector length
   real(wp) :: dist_12
   
   !> cleaved atom pair coordinates
   real(wp) :: xyz1(3), xyz2(3)

   !> message for default parameter
   character(len=:), allocatable :: warning
   
   !> message for auto-switching between derived and fixed modes 
   character(len=:), allocatable :: warning2
   
   !> default is used
   logical :: def
   
   !> control warnings
   logical, save :: rep=.false.
   
   !> ordinal numbers as characters 
   character(len=3) :: dummy1, dummy2
   
   !> difference between new and old coordinates
   real(wp) :: xyz_difference(3)
   
   integer :: i,j,k
   
   !-------!
   ! SETUP !
   !-------!
   
   write (dummy1, '(I3)') mol%at(idx1)
   write (dummy2, '(I3)') mol%at(idx2)
   
   def = .false.
   warning = "Atoms "//dummy1//" and "//dummy2//" are not accounted in the parameter suite(S,P,N,C,O), the default distance values will be used."
   warning2 = "The distance between atoms "//dummy1//" and "//dummy2//" is almost the same, switching to fixed regime"
   
   ! coordinates of connector atom !
   xyz1 = mol%xyz(:, idx1)

   ! coordinates of host atom !
   xyz2 = mol%xyz(:, idx2) 
   
   dist_12=sum((xyz1 - xyz2)**2)

   ! identify average bond distances !
   ! b/n connector-H and connector-host !
   select case (mol%at(idx1))
   case default
      def = .true.
      
      ! C-H, def !
      dist = 1.084*aatoau
      ! C-C, def !
      dist2 = 1.528*aatoau
   
   ! H !
   case (1) 
      
      ! H-H !    
      dist = 0.740*aatoau
      
      select case (mol%at(idx2))
      case default
         dist2 = 1.084*aatoau
         def = .true.
      case(1)
         ! H-H !
         dist2 = 0.740*aatoau
      case (6)
         ! H-C !
         dist2 = 1.084*aatoau
      case (8)
         ! H-O !
         dist2 = 0.964*aatoau
      case (7)
         ! H-N !
         dist2 = 1.024*aatoau
      case (15)
         ! H-P !
         dist2 = 1.414*aatoau
      case (16)
         ! H-S !
         dist2 = 1.389*aatoau
      end select
   
   ! C !
   case (6)
      
      ! C-H !
      dist = 1.084*aatoau
      
      select case (mol%at(idx2))
      case default
         dist2 = 1.528*aatoau
         def = .true.
      case(1)
         ! C-H !
         dist2 = 1.084*aatoau
      case (6)
         ! C-C !
         dist2 = 1.528*aatoau
      case (8)
         ! C-O !
         dist2 = 1.430*aatoau
      case (7)
         ! C-N !
         dist2 = 1.475*aatoau
      case (15)
         ! C-P !
         dist2 = 1.860*aatoau
      case (16)
         ! C-S !
         dist2 = 1.750*aatoau
      end select
    
   ! N !
    case (7)
      
      ! N-H !
      dist = 1.024*aatoau
      
      select case (mol%at(idx2))
      case default
         dist2 = 1.470*aatoau
         def = .true.
      case(1)
         ! N-H !
         dist2 = 1.024*aatoau
      case (6)
         ! N-C !
         dist2 = 1.475*aatoau
      case (8)
         ! N-O !
         dist2 = 1.360*aatoau
      case (7)
         ! N-N !
         dist2 = 1.470*aatoau
      case (15)
         ! N-P !
         dist2 = 1.770*aatoau
      case (16)
         ! N-S !
         dist2 = 1.650*aatoau
      end select

  
   ! O !
   case (8)
      
      ! O-H !
      dist = 0.964*aatoau

      select case (mol%at(idx2))
      case default
         dist2 = 1.450*aatoau
         def = .true.
      case(1)
         ! O-H !
         dist2 = 0.964*aatoau
      case (6)
         ! O-C !
         dist2 = 1.430*aatoau
      case (8)
         ! O-O !
         dist2 = 1.450*aatoau
      case (7)
         ! O-N !
         dist2 = 1.360*aatoau
      case (15)
         ! O-P !
         dist2 = 1.750*aatoau
      case (16)
         ! O-S !
         dist2 = 1.500*aatoau
      end select

   ! P !
   case (15)
      
      ! P-H !
      dist = 1.414*aatoau
      
      select case (mol%at(idx2))
      case default
         dist2 = 1.770*aatoau
         def = .true.
      case(1)
         ! P-H !
         dist2 = 1.414*aatoau
      case (6)
         ! P-C !
         dist2 = 1.860*aatoau
      case (8)
         ! P-O !
         dist2 = 1.750*aatoau
      case (7)
         ! P-N !
         dist2 = 1.770*aatoau
      endselect

   ! S !
   case (16)
      
      ! S-H !
      dist = 1.389*aatoau
      
      select case (mol%at(idx2))
      case default
         dist2 = 1.650*aatoau
         def = .true.
      case(1)
         ! S-H !
         dist2 = 1.389*aatoau
      case (6)
         ! S-C !
         dist2 = 1.750*aatoau
      case (8)
         ! S-O !
         dist2 = 1.500*aatoau
      case (7)
         ! S-N !
         dist2 = 1.650*aatoau
      case (16)
         ! S-S !
         dist2 = 2.040*aatoau
      endselect

   end select 
   
   ! derived mode !
   if (set%oniom_settings%derived) then
      
      prefactor = dist/sqrt(dist_12)
   
   ! fixed mode !
   else
      
      prefactor = dist/dist2 
      
      ! default values !
      if(def.and. .not.rep) then
         rep=.true.
         call env%warning(warning,source)
      endif
   endif

   ! LA coordinates !
   xyz(:, size(xyz, 2)) = xyz1 + (xyz2 - xyz1) * prefactor
      
   ! determine the difference between LA and LAH cooordinates !
   ! (yes -> change from derived to fixed) ! 
   xyz_difference=xyz2-xyz(:,size(xyz,2))
   if (all(xyz_difference<1.0E-5).and.set%oniom_settings%derived) then 
      set%oniom_settings%derived=.false.
      call env%warning(warning2,source)
      prefactor = dist/dist2 
   endif

   ! take derivatives !
   call derivative(jacobian,connectorPosition,size(xyz,2),prefactor,mol%xyz,idx1,idx2,dist_12,set%oniom_settings%derived)

end subroutine newcoord

!> increment Jacobian matrix for newly added atoms
subroutine derivative(jacobian,con,link,prefactor,xyz,idx1,idx2,dist_12,derived)
   
   implicit none
   
   !> jacobian matrix
   real(wp), intent(inout) :: jacobian(:,:)
   
   !> position of connector atom 
   integer,intent(in) :: con
   
   !> position of linked atom 
   integer, intent(in) :: link

   !> scaling factor 
   real(wp),intent(in) :: prefactor
   
   !> square of distance vector
   real(wp),intent(in) :: dist_12

   !> coordinates of whole molecule
   real(wp),intent(in) :: xyz(:,:)
   
   !> connector (one that stays in inner region)
   integer, intent(in) :: idx1
   
   !> host (one that is substitued)
   integer, intent(in) :: idx2
   
   !> fix value of prefactor variable
   logical, intent(in) :: derived
   
   !> account for all 3 coordinates in J matrix
   integer :: con3, link3
   
   !> save the positions of changed matrix elements
   integer :: counter1(3), counter2(3)
   
   integer :: i, j
   
   !-------!
   ! SETUP !
   !-------!

   con3=con*3
   link3=link*3
   
   do i=1,3
      counter1(i)=con3-i+1
      counter2(i)=link3-i+1
   enddo
   
   ! nullify all new matrix elements !
   jacobian(counter2(3):,:) = 0.0_wp
   jacobian(:,counter2(3):) = 0.0_wp

   !-------------------------!
   ! JACOBIAN INCREMENTATION !
   !-------------------------!

   do i=1,3
      
      ! fixed mode !
      if(.not.derived) then
         jacobian(counter1(i),counter2(i))=1-prefactor
         jacobian(counter2(i),counter2(i))=prefactor
      
      ! derived mode !
      else
         ! x coordinate !
         if (i==1) then
            jacobian(counter2(i),counter2(i)) =(prefactor*(   (xyz(2,idx1)**2) - 2*xyz(2,idx1)*xyz(2,idx2) + (xyz(2,idx2)**2) + ((xyz(3,idx1)-xyz(3,idx2))**2)  ))/(dist_12**(3.0_wp/2.0_wp))
         
         ! y coordinate !
         else if (i==2) then
            jacobian(counter2(i),counter2(i)) =(prefactor*(   (xyz(1,idx1)**2) - 2*xyz(1,idx1)*xyz(1,idx2) + (xyz(1,idx2)**2) + ((xyz(3,idx1)-xyz(3,idx2))**2)  ))/(dist_12**(3.0_wp/2.0_wp))
         
         ! z coordinate !
         else
            jacobian(counter2(i),counter2(i)) =(prefactor*(   (xyz(1,idx1)**2) - 2*xyz(1,idx1)*xyz(1,idx2) + (xyz(1,idx2)**2) + ((xyz(2,idx1)-xyz(2,idx2))**2)  ))/(dist_12**(3.0_wp/2.0_wp))
         endif
         
         jacobian(counter1(i),counter2(i)) = (prefactor*((xyz(i,idx2)-xyz(i,idx1))**2))/(dist_12**(3.0_wp/2.0_wp)) - (prefactor/(sqrt(dist_12))) + 1.0_wp 
      
      endif
   
   enddo
   
end subroutine derivative

!> assign methods
function string_to_id(string) result(id)

   implicit none
   character(len=*), intent(in) :: string
   integer :: id

   select case (string)

   case default
      id = -1
   case ('gfn2')
      id = 2
   case ('gfn1')
      id = 1
   case ('gfnff')
      id = 3
   case ('orca')
      id = 4
   case ('turbomole')
      id = 5
   end select

end function string_to_id

!> check bond order
subroutine checkfororder(env, mol, idx1, idx2, bond, hybrid)
   
   implicit none
   
   !> name of error producer routine
   character(len=*), parameter :: source = 'xtb_oniom_checkfororder' 
   
   !> hybridization info from GFN-FF; topo%hyb
   integer, intent(in), optional :: hybrid(:)
   
   !> wiberg bond orders 
   integer, intent(in), optional :: bond
   
   !> calculation environment 
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(in) :: mol
   
   !> connector (one that stays in inner region)
   integer, intent(in) :: idx1

   !> host (one that is substitued)
   integer, intent(in) :: idx2
   
   character(len=:), allocatable :: warning
   integer :: b
   character(len=5) :: dummy1, dummy2

   write (dummy1, '(I5)') idx1
   write (dummy2, '(I5)') idx2
   warning = "You are cutting a bond with the order higher than 1 between "//dummy1//" and "//dummy2
   
   if (present(bond)) then
      if (bond > 1) then
         call env%error(warning, source)
         return
      end if
   else
      if (hybrid(idx1) /= 0 .and. hybrid(idx1) < 3) then
         if (hybrid(idx2) /= 0 .and. hybrid(idx2) < 3) then
            call env%error(warning, source)
            return
         end if
      end if
   end if

end subroutine checkfororder

!> automatic inner region charge determination
function calculateCharge(self, env, mol, chk) result(chrg_model)
   
   implicit none
   
   !> name of error producer routine
   character(len=*), parameter :: source = 'xtb_oniom_calculateCharge'
   
   !> polymorhic calculator
   class(TOniomCalculator), intent(inout) :: self
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(in) :: mol
   
   !> wavefuntion wrapper
   type(TRestart), intent(in) :: chk
   
   !> inner region charge
   real(wp) :: charge
   
   integer :: i, j, n, k, pre_last
   integer :: chrg_model
   integer, allocatable :: at(:)

   charge = 0.0_wp

   select type (calc => self%real_low)
   
   ! gfnff !
   type is (TGFFCalculator)
      do i = 1, size(self%idx)
         charge = charge + calc%topo%qa(self%idx(i))
      end do

   ! GFN1/2 !
   type is (TxTBCalculator)
      do i = 1, size(self%idx)
         charge = charge + chk%wfn%q(self%idx(i))         
      end do

   class default
      call env%error("Not possible to calculate with external methods for real region", source)
      return
   end select
      
   chrg_model = nint(charge)

end function calculateCharge

!> transform matrix into 1-dim array
subroutine matrix_to_array(mtrx,arr)
   
   implicit none
   real(wp), intent(in) :: mtrx (:,:)
   real(wp), allocatable, intent(out) :: arr(:)
   integer :: i, j, k

   allocate(arr(size(mtrx,1)*size(mtrx,2)))
   
   k=1
   do i=1, size(mtrx,2)
      do j=1, size(mtrx,1)
         arr(k)=mtrx(j,i)
         k=k+1
      enddo
   enddo

end subroutine matrix_to_array

!> transform 1-dim array to matrix
subroutine array_to_matrix(arr,mtrx)
   
   implicit none
   real(wp), intent(out) :: mtrx (:,:)
   real(wp), allocatable, intent(inout) :: arr(:)
   integer :: i, j, k
   
   k=1
   do i=1, size(mtrx,2)
      do j=1, size(mtrx,1)
         mtrx(j,i)=arr(k)
         k=k+1
      enddo
   enddo

   deallocate(arr)

end subroutine array_to_matrix
   
!> create origin.coord (if coord exist)
subroutine protectCoord(env)
   
   use xtb_readin, only : mirror_line
   implicit none
   character(len=*),parameter :: source = "xtb_oniom_protectCoord"
   type(TEnvironment),intent(inout) :: env
   integer :: cunit, new_cunit, err
   character(len=:),allocatable :: line
   logical :: exist

   inquire(file='coord',exist=exist)
   if(exist) then   
      call open_file(cunit,'coord','r')
      call open_file(new_cunit,'origin.coord','w')
      do
         call mirror_line(cunit,new_cunit,line,err)
         if(is_iostat_end(err)) exit
      enddo
      call env%warning("coord file will be renamed as unopt.coord",source)

   endif

end subroutine protectCoord

end module xtb_oniom

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module mctcpar_electronegativities
   use xtb_mctc_accuracy, only : wp
   implicit none

   integer, private, parameter :: max_elem = 118

   !> pauling EN's
   real(wp),public,parameter :: pauling_en(max_elem) = [ &
   & 2.20_wp,3.00_wp, & ! H,He
   & 0.98_wp,1.57_wp,2.04_wp,2.55_wp,3.04_wp,3.44_wp,3.98_wp,4.50_wp, & ! Li-Ne
   & 0.93_wp,1.31_wp,1.61_wp,1.90_wp,2.19_wp,2.58_wp,3.16_wp,3.50_wp, & ! Na-Ar
   & 0.82_wp,1.00_wp, & ! K,Ca
   &                 1.36_wp,1.54_wp,1.63_wp,1.66_wp,1.55_wp, & ! Sc-
   &                 1.83_wp,1.88_wp,1.91_wp,1.90_wp,1.65_wp, & ! -Zn
   &                 1.81_wp,2.01_wp,2.18_wp,2.55_wp,2.96_wp,3.00_wp, & ! Ga-Kr
   & 0.82_wp,0.95_wp, & ! Rb,Sr
   &                 1.22_wp,1.33_wp,1.60_wp,2.16_wp,1.90_wp, & ! Y-
   &                 2.20_wp,2.28_wp,2.20_wp,1.93_wp,1.69_wp, & ! -Cd
   &                 1.78_wp,1.96_wp,2.05_wp,2.10_wp,2.66_wp,2.60_wp, & ! In-Xe
   & 0.79_wp,0.89_wp, & ! Cs,Ba
   &         1.10_wp,1.12_wp,1.13_wp,1.14_wp,1.15_wp,1.17_wp,1.18_wp, & ! La-Eu
   &         1.20_wp,1.21_wp,1.22_wp,1.23_wp,1.24_wp,1.25_wp,1.26_wp, & ! Gd-Yb
   &                 1.27_wp,1.30_wp,1.50_wp,2.36_wp,1.90_wp, & ! Lu-
   &                 2.20_wp,2.20_wp,2.28_wp,2.54_wp,2.00_wp, & ! -Hg
   &                 1.62_wp,2.33_wp,2.02_wp,2.00_wp,2.20_wp,2.20_wp, & ! Tl-Rn
   ! only dummies below
   & 1.50_wp,1.50_wp, & ! Fr,Ra
   &         1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Ac-Am
   &         1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Cm-No
   &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Rf-
   &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Rf-Cn
   &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp ] ! Nh-Og

end module mctcpar_electronegativities

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Generate a new random name
module xtb_mctc_namegen
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: generateName


   character(len=1), parameter :: delimiter = '-'

   character(len=*), parameter :: tWord(61) = [ &
      &"talkative  ", "tall       ", "tame       ", "tan        ", "tangible   ", &
      &"tart       ", "tasty      ", "tattered   ", "taut       ", "tedious    ", &
      &"teeming    ", "tempting   ", "tender     ", "tense      ", "tepid      ", &
      &"terrible   ", "terrific   ", "testy      ", "thankful   ", "that       ", &
      &"these      ", "thick      ", "thin       ", "third      ", "thirsty    ", &
      &"this       ", "thorny     ", "thorough   ", "those      ", "thoughtful ", &
      &"threadbare ", "thrifty    ", "thunderous ", "tidy       ", "tight      ", &
      &"timely     ", "tinted     ", "tiny       ", "tired      ", "torn       ", &
      &"total      ", "tough      ", "tragic     ", "trained    ", "traumatic  ", &
      &"treasured  ", "tremendous ", "triangular ", "tricky     ", "trifling   ", &
      &"trim       ", "trivial    ", "troubled   ", "true       ", "trusting   ", &
      &"trustworthy", "trusty     ", "truthful   ", "tubby      ", "turbulent  ", &
      &"twin       "]

   character(len=*), parameter :: bWord(53) = [ &
      & "back      ", "backs     ", "bail      ", "balance   ", "balances  ", &
      & "balloon   ", "balloons  ", "ban       ", "bans      ", "bandage   ", &
      & "bandages  ", "bank      ", "bare      ", "bargain   ", "battle    ", &
      & "battles   ", "beam      ", "bear      ", "beat      ", "beats     ", &
      & "bend      ", "bends     ", "benefit   ", "benefits  ", "blame     ", &
      & "blast     ", "blasts    ", "bleach    ", "block     ", "bloom     ", &
      & "blow      ", "board     ", "boards    ", "bother    ", "bounce    ", &
      & "bounces   ", "bow       ", "bows      ", "box       ", "boxes     ", &
      & "bread     ", "break     ", "breaks    ", "breed     ", "broadcast ", &
      & "broadcasts", "brush     ", "brushes   ", "bump      ", "bumps     ", &
      & "burn      ", "burns     ", "buy       "]


contains


!> Generate a new random name
subroutine generateName(name)

   !> Generated name
   character(len=:), allocatable, intent(out) :: name

   real :: rNum(2)
   integer :: idx(2)

   call random_number(rNum)
   idx = int([size(tWord), size(bWord)] * rNum) + 1
   name = trim(tWord(idx(1))) // delimiter // trim(bWord(idx(2)))

end subroutine generateName


end module xtb_mctc_namegen

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ========================================================================
!  DRIVER FOR SINGLEPOINT CALCULATIONS
!  => call on (mini)scf to perform GFN-xTB single point calculations
!  => call on external driver library, interfaces
!     -> Turbomole, ORCA, driver (which is by itself an interface)
!  use the singlepoint function to get the appropiate call on the necessary
!  functions
!! ========================================================================
module xtb_single
   use xtb_mctc_accuracy, only : wp
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data
   use xtb_type_pcem
   implicit none
   public :: singlepoint
   private

contains


subroutine singlepoint &
      & (env,mol,chk,calc, &
      &  egap,et,maxiter,prlevel,restart,lgrad,acc,etot,g,sigma,res)
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   type(tb_pcem) :: pcem
   real(wp),intent(inout) :: egap
   real(wp),intent(in)    :: et
   integer, intent(in)    :: maxiter
   integer, intent(in)    :: prlevel
   logical, intent(in)    :: restart
   logical, intent(in)    :: lgrad
   real(wp),intent(in)    :: acc
   real(wp),intent(out)   :: etot
   real(wp),intent(out)   :: g(3,mol%n)
   type(scc_results),intent(out) :: res
   real(wp),intent(out)   :: sigma(3,3)

   ! Just forward the singlepoint implementation of the calculator
   call calc%singlepoint(env, mol, chk, prlevel, restart, etot, g, sigma, egap, res)

end subroutine singlepoint


end module xtb_single

! This file is part of ancopt.
! SPDX-Identifier: LGPL-3.0-or-later
!
! ancopt is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! ancopt is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with ancopt.  If not, see <https://www.gnu.org/licenses/>.

module xtb_pbc_optimizer_lbfgs
   use xtb_mctc_accuracy, only : wp
   use xtb_type_environment, only : TEnvironment
   use xtb_mctc_blas, only : mctc_dot


   use  xtb_pbc_optimizer_filter_type, only : filter_type
   implicit none
   private

   public :: optimizer_type, lbfgs_optimizer, lbfgs_input, new_lbfgs_optimizer

   type :: lbfgs_input
      integer :: memory = 20
   end type lbfgs_input
                                                   
  type, abstract :: optimizer_type                  
  contains                                          
     procedure(step_i), deferred :: step
  end type optimizer_type                           
                                                    
  abstract interface                                
     subroutine step_i(self, val, gcurr, glast, displ, tot_step)
        import :: optimizer_type, wp                
        class(optimizer_type), intent(inout) :: self
        real(wp), intent(in) :: val                 
        real(wp), intent(in) :: gcurr(:)            
        real(wp), intent(in) :: glast(:)            
        integer, intent(in) :: tot_step
        real(wp), intent(out) :: displ(:)     
     end subroutine step_i                           
  end interface                                     


   type, extends(optimizer_type) :: lbfgs_optimizer
      integer :: iter
      integer :: nvar
      integer :: memory
      real(wp), allocatable :: hdiag(:)
      real(wp), allocatable :: s(:, :)
      real(wp), allocatable :: y(:, :)
      real(wp), allocatable :: rho(:)
   contains
      procedure :: step
   end type lbfgs_optimizer

contains


!> Create new limited memory BFGS optimization driver
subroutine new_lbfgs_optimizer(self, env, input, filter)
   !> Instance of the optimizer
   type(lbfgs_optimizer), intent(out) :: self
  !> Calculation environment
  type(TEnvironment), intent(inout) :: env
   !> Input for the LBFGS optimizer
   type(lbfgs_input), intent(in) :: input
   !> Transformation filter
   class(filter_type), intent(in) :: filter

   self%iter = 0
   self%nvar = filter%get_dimension()
   self%memory = input%memory
   allocate(self%s(self%nvar, input%memory), source=0.0_wp)
   allocate(self%y(self%nvar, input%memory), source=0.0_wp)
   allocate(self%rho(input%memory), source=0.0_wp)
   allocate(self%hdiag(self%nvar), source=1.0_wp)

end subroutine new_lbfgs_optimizer


!> updates displacement using the formula given by Nocedal, generally known
!> as limited memory BFGS algorithm
subroutine lbfgs_step(iter, memory, nvar, gradient, glast, displacement, hdiag, s, y, rho, tot_step)
   !> Current iteration step
   integer, intent(in) :: iter
   !> Memory limit for the LBFGS update
   integer, intent(in) :: memory
   !> 3*natoms
   integer, intent(in) :: nvar
   !> current gradient
   real(wp), intent(in) :: gradient(:)
   !> gradient on the last point
   real(wp), intent(in) :: glast(:)
   !> on input displacement from the last step, on exit new displacement vector
   real(wp), intent(inout) :: displacement(:)
   !> *inverse* Hessian in diagonal form
   real(wp), intent(in) :: hdiag(:)
   integer, intent(in) :: tot_step

   !> LBFGS scratch array of former displacements
   real(wp), intent(inout) :: s(:, :)
   !> LBFGS scratch array of former gradient changes
   real(wp), intent(inout) :: y(:, :)
   !> LBFGS scratch array of dot products between s and y
   real(wp), intent(inout) :: rho(:)

   real(wp), allocatable :: d(:), q(:), a(:)
   real(wp) :: b

   integer :: thisiter, lastiter, mem
   integer :: i
   real(wp) :: f_damp

   allocate(q(nvar), d(nvar), a(memory), source = 0.0_wp)

   thisiter = mod(iter-1, memory) + 1
   s(:, thisiter) = displacement
   y(:, thisiter) = gradient - glast

   b = mctc_dot(s(:, thisiter), y(:, thisiter))

   rho(thisiter) = 1.0_wp / max(abs(b), epsilon(1.0_wp))

   q = gradient
   do mem = iter, max(1, iter-memory+1), -1
      i = mod(mem-1, memory)+1
      a(i) = rho(i) * mctc_dot(s(:, i), q)
      q = q - a(i) * y(:, i)
   enddo

   d = hdiag * q
if(iter.le.memory) then
   do mem = max(1, iter-memory), iter
      i = mod(mem-1, memory)+1
      b = rho(i) * mctc_dot(y(:, i), d)
      d = d + s(:, i) * (a(i) - b)
   enddo
else
   do mem = max(1, iter-memory), iter-1
      i = mod(mem-1, memory)+1
      b = rho(i) * mctc_dot(y(:, i), d)
      d = d + s(:, i) * (a(i) - b)
   enddo
endif
   f_damp = 1.0_wp/(1.0_wp + 3000.0_wp*real(tot_step)**(-3))
   if (maxval(abs(d)).lt.0.1_wp.or.tot_step.gt.50) then
     displacement = -d
   else
     displacement = -d*f_damp
   endif
end subroutine lbfgs_step


subroutine step(self, val, gcurr, glast, displ, tot_step)
   class(lbfgs_optimizer), intent(inout) :: self
   real(wp), intent(in) :: val
   real(wp), intent(in) :: gcurr(:)
   real(wp), intent(in) :: glast(:)
   integer, intent(in) :: tot_step
   real(wp), intent(out) :: displ(:)

   self%iter = self%iter + 1

   call lbfgs_step(self%iter, self%memory, self%nvar, gcurr, glast, displ, self%hdiag, &
      & self%s, self%y, self%rho, tot_step)
end subroutine step

end module xtb_pbc_optimizer_lbfgs

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> API for dealing with the calculation environment
module xtb_api_environment
   use, intrinsic :: iso_c_binding
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io
   use xtb_api_utils
   use xtb_type_environment
   use xtb_xtb_calculator
   implicit none
   private

   public :: VEnvironment
   public :: newEnvironment_api, delEnvironment_api, checkEnvironment_api, &
      & showEnvironment_api, setOutput_api, releaseOutput_api, setVerbosity_api, &
      & getError_api


   !> Void pointer to calculation environment
   type :: VEnvironment
      type(TEnvironment) :: ptr
      integer :: verbosity
   end type VEnvironment


contains


!> Create new xtb calculation environment object
function newEnvironment_api() result(venv) &
      & bind(C, name="xtb_newEnvironment")
   !DEC$ ATTRIBUTES DLLEXPORT :: newEnvironment_api
   type(VEnvironment), pointer :: env
   type(c_ptr) :: venv

   call checkGlobalEnv

   allocate(env)
   call init(env%ptr)
   env%verbosity = 1
   venv = c_loc(env)

end function newEnvironment_api


!> Delete a xtb calculation environment object
subroutine delEnvironment_api(venv) &
      & bind(C, name="xtb_delEnvironment")
   !DEC$ ATTRIBUTES DLLEXPORT :: delEnvironment_api
   type(c_ptr), intent(inout) :: venv
   type(VEnvironment), pointer :: env

   call releaseOutput_api(venv)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv
      deallocate(env)
      venv = c_null_ptr
   end if

end subroutine delEnvironment_api


!> Check current status of calculation environment
function checkEnvironment_api(venv) result(status) &
      & bind(C, name="xtb_checkEnvironment")
   !DEC$ ATTRIBUTES DLLEXPORT :: checkEnvironment_api
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   integer(c_int) :: status
   logical :: exitRun

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      call env%ptr%check(exitRun)
      if (exitRun) then
         status = 1
      else
         status = 0
      end if
   end if

end function checkEnvironment_api


!> Show and empty error stack
subroutine showEnvironment_api(venv, charptr) &
      & bind(C, name="xtb_showEnvironment")
   !DEC$ ATTRIBUTES DLLEXPORT :: showEnvironment_api
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   character(kind=c_char), intent(in), optional :: charptr(*)
   character(len=:, kind=c_char), allocatable :: message

   if (present(charptr)) then
      call c_f_character(charptr, message)
   else
      message = ''
   end if

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      call env%ptr%show(message)
   end if

end subroutine showEnvironment_api


!> Bind output from this environment
subroutine setOutput_api(venv, charptr) &
      & bind(C, name="xtb_setOutput")
   !DEC$ ATTRIBUTES DLLEXPORT :: setOutput_api
   character(len=*), parameter :: source = 'xtb_api_setOutput'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   character(kind=c_char), intent(in) :: charptr(*)
   character(len=:, kind=c_char), allocatable :: filename
   integer :: stat
   character(len=512) :: message

   call c_f_character(charptr, filename)

   call releaseOutput_api(venv)

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (filename == c_char_'-' .or. filename == c_char_'STDOUT') then
         env%ptr%unit = stdout
      else if (filename == c_char_'STDERR') then
         env%ptr%unit = stderr
      else
         open(file=filename, newunit=env%ptr%unit, iostat=stat, iomsg=message)
         if (stat /= 0) then
            call env%ptr%error(trim(message), source)
         end if
      end if
   end if

end subroutine setOutput_api


!> Release output unit from this environment
subroutine releaseOutput_api(venv) &
      & bind(C, name="xtb_releaseOutput")
   !DEC$ ATTRIBUTES DLLEXPORT :: releaseOutput_api
   character(len=*), parameter :: source = 'xtb_api_releaseOutput'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   integer :: stat
   character(len=512) :: message

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.any(env%ptr%unit /= [-1, stdout, stderr])) then
         close(unit=env%ptr%unit, iostat=stat, iomsg=message)
         if (stat /= 0) then
            call env%ptr%error(trim(message), source)
         end if
      end if
   end if

end subroutine releaseOutput_api


!> Set verbosity of calculation output
subroutine setVerbosity_api(venv, verbosity) &
      & bind(C, name="xtb_setVerbosity")
   !DEC$ ATTRIBUTES DLLEXPORT :: setVerbosity_api
   character(len=*), parameter :: source = 'xtb_api_setVerbosity'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   integer, value :: verbosity

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.any(verbosity /= [0_c_int, 1_c_int, 2_c_int])) then
         call env%ptr%warning("Verbosity specified is out of range", source)
      end if

      env%verbosity = verbosity
   end if

end subroutine setVerbosity_api


!> Set verbosity of calculation output
subroutine getError_api(venv, charptr, buffersize) &
      & bind(C, name="xtb_getError")
   !DEC$ ATTRIBUTES DLLEXPORT :: setVerbosity_api, getError_api
   character(len=*), parameter :: source = 'xtb_api_getError'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   character(kind=c_char), intent(inout) :: charptr(*)
   character(len=:, kind=c_char), allocatable :: buffer
   integer(c_int), intent(in), optional :: buffersize
   logical :: exitRun
   integer :: maxLength

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (present(buffersize)) then
         maxLength = buffersize
      else
         maxLength = huge(maxlength) - 2
      end if

      call env%ptr%check(exitRun)
      if (exitRun) then
         call env%ptr%getLog(buffer)
         if (len(buffer) > 0) then
            call f_c_character(buffer, charptr, maxLength)
         end if
      end if
   end if

end subroutine getError_api


end module xtb_api_environment

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Setup of the effective Hamiltonians for both iterations in PTB

module xtb_ptb_hamiltonian
#if WITH_TBLITE
   use mctc_io, only: structure_type
   use mctc_env, only: wp, error_type

   use tblite_basis_type, only: basis_type
   use tblite_adjlist, only: adjacency_list
   use tblite_integral_multipole, only: msao

   use xtb_ptb_data, only: THamiltonianData
   use xtb_ptb_param, only: ptbGlobals

   implicit none

   private

   public :: get_hamiltonian, get_selfenergy, get_occupation

contains

   subroutine get_selfenergy(mol, bas, hData, cn_normal, cn_star, selfenergies)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> THamiltonian data
      type(THamiltonianData), intent(in) :: hData
      !> Coordination number with fitted (normal) and literature (star) radii
      real(wp), intent(in) :: cn_normal(:), cn_star(:)
      !> Self-energies after taking into account CN dependencies
      real(wp), allocatable, intent(out) :: selfenergies(:)
      !> Loop variables
      integer :: iat, iid, ii, ish
      !> tmp reals
      real(wp) :: combinedcn

      !> debug mode
      logical, parameter :: debug(2) = [ .false., .false. ]

      allocate (selfenergies(bas%nsh), source=0.0_wp)

      do iat = 1, mol%nat
         iid = mol%id(iat)
         combinedcn = (cn_normal(iat) + cn_star(iat) * hData%kcnstar(iid))

         if (debug(1)) then !##### DEV WRITE #####
            write(*,*) 'cn_normal', cn_normal(iat)
            write(*,*) 'cn_star', cn_star(iat)
            write(*,*) 'hData%kcnstar', hData%kcnstar(iid)
            write(*,*) "atom: ", iat, "id: ", iid, "type: ", mol%num(iid)
            write(*,*) "number of shells: ", bas%nsh_id(iid)
         endif

         ii = bas%ish_at(iat)
         do ish = 1, bas%nsh_id(iid)
            selfenergies(ii + ish) = hData%selfEnergy(ish, iid) + &
               & hData%klh(ish, iid) * combinedcn + &
               & cn_star(iat) * hData%kshift(iid)

            if (debug(2)) & !##### DEV WRITE #####
               write(*,*) 'selfenergies', ii + ish, selfenergies(ii + ish)

         end do
      end do

   end subroutine get_selfenergy

   subroutine get_hamiltonian(mol, list, bas, hData, wolfsberg_par, sh0, levels, h0mat, kpol, kitr, kitocod)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Neighbour list
      type(adjacency_list), intent(in) :: list
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> THamiltonian data
      type(THamiltonianData), intent(in) :: hData
      !> (Scaled) overlap matrix
      real(wp), intent(in) :: sh0(:, :)
      !> Wolfsberg parameters [nsh, nid]
      real(wp), intent(in) :: wolfsberg_par(:, :)
      !> Levels
      real(wp), intent(in) :: levels(:)
      !> H0 matrix
      real(wp), intent(out) :: h0mat(:, :)
      !> Level polarization scaling in H0
      real(wp), intent(in) :: kpol
      !> Optional, iteration-dependent parameters:
      !> Radii scaling in H0
      real(wp), optional, intent(in) :: kitr
      !> One-center-off-diagonal scaling in H0
      real(wp), optional, intent(in) :: kitocod
      !> Loop variables
      integer :: iat, jat, izp, jzp, img, inl
      integer :: ish, jsh, is, js, ii, jj, iao, jao, nao
      real(wp) :: wolfsberg, polarized_levels, sum_levels, ocod_param, rscal
      real(wp) :: radii_dependence, ssquraedterm, ocodterm, sterm
      !> Interatomic vector
      real(wp) :: vec(3) = 0.0_wp
      real(wp) :: r2, rab

      !> debug mode
      logical, parameter :: debug(5) = &
               [ .false., .false., .false., .false., .false. ]

      if (present(kitocod)) then
         ocod_param = kitocod
      else
         ocod_param = 1.0_wp
      end if

      if (present(kitr)) then
         rscal = kitr
      else
         rscal = 1.0_wp
      end if

      !> Loop over all neighbours (iat =/= jat) and set the Hamiltonian for off-center elements
      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, list, h0mat, sh0, levels, hData, wolfsberg_par, kpol, rscal) &
      !$omp private(iat, jat, izp, jzp, is, js, ish, jsh, ii, jj, iao, jao, nao) &
      !$omp private(r2, vec, inl, img, wolfsberg, polarized_levels, sum_levels) &
      !$omp private(radii_dependence, ssquraedterm, ocodterm, sterm, rab)
      do iat = 1, mol%nat
         
         if (debug(1)) & !##### DEV WRITE #####
            write (*, *) "atom: ", iat, "id: ", mol%id(iat), "type: ", mol%num(mol%id(iat))
         
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         inl = list%inl(iat)
         do img = 1, list%nnl(iat)
            jat = list%nlat(img + inl)
            
            
            jzp = mol%id(jat)
            js = bas%ish_at(jat)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            rab = sqrt(r2)

            if (debug(2)) & !##### DEV WRITE #####
               write (*, *) "neighbour: ", jat, "id: ", mol%id(jat), "type: ", mol%num(mol%id(jat)), &
                           & "distance: ", sqrt(r2)
            
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is + ish)
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js + jsh)

                  !> Single contributions to H0
                  sum_levels = levels(js + jsh) + levels(is + ish)
                  wolfsberg = wolfsberg_par(ish, izp) + wolfsberg_par(jsh, jzp)
                  polarized_levels = 1.0_wp - kpol * ((levels(js + jsh) - levels(is + ish)) / &
                  & sum_levels)**2
                  radii_dependence = 1.0_wp + &
                  & (hData%kr(izp) + hData%kr(jzp)) * rscal / rab

                  nao = msao(bas%cgto(jsh, jat)%ang)
                  do iao = 1, msao(bas%cgto(ish, iat)%ang)
                     do jao = 1, nao
                        !> Set H0
                        h0mat(jj + jao, ii + iao) = 0.5_wp * sh0(jj + jao, ii + iao) * &
                           & sum_levels * &
                           & wolfsberg * &
                           & polarized_levels * &
                           & radii_dependence
                        h0mat(ii + iao, jj + jao) = h0mat(jj + jao, ii + iao)
                        
                        if (debug(3)) then !##### DEV WRITE #####
                           write(*,'(a,i3,i3,f8.4,f8.4,f8.4,f8.4,f8.4)') "i, j, tmp, keav, pol, xk, ssh: ",&
                           & ii+iao, jj+jao, h0mat(jj + jao, ii + iao), wolfsberg*0.5_wp, &
                           & polarized_levels, radii_dependence, sh0(jj + jao, ii + iao)*sum_levels
                        endif
                     
                     end do
                  end do

               end do
            end do

         end do
      end do

      !> Loop over all atoms and set the Hamiltonian for one-center off(-shell)-diagonal elements
      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, list, h0mat, sh0, levels, hData, kpol, ocod_param, rscal) &
      !$omp private(iat, izp, is, ish, jsh, ii, jj, iao, jao, nao) &
      !$omp private(sum_levels) &
      !$omp private(ssquraedterm, ocodterm, sterm)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is + ish)
            do jsh = 1, ish - 1

               sum_levels = levels(is + jsh) + levels(is + ish)
               !> s-s', p-p', d-d' off-diagonal, li=lj because S=0 otherwise
               !> CAUTION: ksla is angular-momentum dependent, but the parameters are projected
               !> onto the shells in xtb/src/ptb/data.f90
               ocodterm = hData%ksla(ish, izp) * ocod_param

               jj = bas%iao_sh(is + jsh)
               nao = msao(bas%cgto(jsh, iat)%ang)
               do iao = 1, msao(bas%cgto(ish, iat)%ang)
                  do jao = 1, nao
                     ssquraedterm = sh0(jj + jao, ii + iao)**2 * &
                        & sum_levels * &
                        & hData%kocod(izp) * &
                        & ocodterm
                     sterm = sh0(jj + jao, ii + iao) * &
                        & sum_levels * &
                        & ocodterm
                     h0mat(jj + jao, ii + iao) = sterm + &
                        & ssquraedterm
                     h0mat(ii + iao, jj + jao) = h0mat(jj + jao, ii + iao)
                     
                     if(debug(4)) then !##### DEV WRITE #####
                        write(*,'(a,i3,i3,f8.4,f8.4,f8.4,f8.4,f8.4)') "i, j, tmp, ssquraedterm, sterm, ocodterm: ",&
                        & ii+iao, jj+jao, h0mat(jj + jao, ii + iao), ssquraedterm, sterm, ocodterm, &
                        & sh0(jj + jao, ii + iao) * sum_levels
                     endif
                  
                  end do
               end do
            end do
         end do
      end do

      !> Loop over all atoms and set the Hamiltonian for one-center diagonal elements (same AO!)
      !> CAUTION: Loop doesn't run over one-center diagonal elements of different AOs in the same shell
      !> (Overlap matrix elements are zero for these elements)
      !> NO PARALLELIZATION YET SINCE LOOP IS QUITE SMALL
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is + ish)
            do iao = 1, msao(bas%cgto(ish, iat)%ang)
               h0mat(ii + iao, ii + iao) = 2.0_wp * levels(is + ish)

               if (debug(5)) & !##### DEV WRITE #####
                  write(*,*) "i, j, tmp: ", ii+iao, ii+iao, h0mat(ii + iao, ii + iao)
               
            end do
         end do
      end do

   end subroutine get_hamiltonian

   subroutine get_occupation(mol, bas, refocc, nocc, n0at, n0sh)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set information
      type(basis_type), intent(in) :: bas
      !> Reference occupation
      real(wp), intent(in) :: refocc(:, :)
      !> Occupation number
      real(wp), intent(out) :: nocc
      !> Reference occupation for each atom
      real(wp), intent(out) :: n0at(:)
      !> Reference occupation for each shell
      real(wp), intent(out) :: n0sh(:)

      integer :: iat, ish, izp, ii

      nocc = -mol%charge
      n0at(:) = 0.0_wp
      n0sh(:) = 0.0_wp
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = bas%ish_at(iat)
         do ish = 1, bas%nsh_id(izp)
            nocc = nocc + refocc(ish, izp)
            n0at(iat) = n0at(iat) + refocc(ish, izp)
            n0sh(ii + ish) = n0sh(ii + ish) + refocc(ish, izp)
         end do
      end do

   end subroutine get_occupation

#endif
end module xtb_ptb_hamiltonian

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

! Modified Boryden mixer according to
! D.D. Johnson, PRB 38, 12807 (1988)
! Input Variables:
! iter = current iteration
! maxiter = max number of iterations
! n = number of atoms (charges)
! q = current iteration INPUT charges (before diag)
! qlast = last iteration INPUT charges (before diag)
! dqlast = charge difference of prev. iteration (q_in - q_out)
! dq = current iteration charge difference (q_in - q_out)
! df = previous |dF>
! u = previous |u>
! a = a matrix
! Note: The modified Broyden method works on the INPUT charges of the sc
! the difference produced by the SCC step. Especially the INPUT charge o
! iteration is needed, which is usually not stored!
module xtb_broyden
contains

subroutine broyden(n,q,qlast,dq,dqlast,iter,maxiter,&
      &                   alpha,omega,df,u,a)
   use xtb_mctc_accuracy, only : wp
   implicit none

   integer i,j
   integer n,iter,maxiter,it1
   real(wp) inv

   !     charge arrays
   real(wp) q(n),qlast(n),dq(n),dqlast(n)


   !     |dF>, |u> and a from prev. iterations
   real(wp) df(maxiter,n),u(maxiter,n),a(maxiter,maxiter)
   real(wp) omega(maxiter)
   !     on the fly variables needed for the mixing
   real(wp), allocatable :: beta(:,:), c(:), gamma(:)
   !      real(wp), allocatable :: beta1(:,:)

   !     mixing parameters

   real(wp) alpha
   real(wp) omega0
   real(wp) minw,maxw,wfac
   real(wp) tmp(n)




   it1 = iter - 1



   !     set parameters

   !     alpha = 0.25d0
   omega0 = 0.01d0
   minw = 1.0d0
   maxw = 100000.0d0
   wfac = 0.01d0
   !     wfac = 0.05d0

   !     if case for first iteration: simple damping
   if (iter == 1 ) then
      dqlast = dq
      qlast = q
      q = q + alpha * dq
      return
   endif

   !     allocate
   allocate(beta(it1,it1),c(it1),gamma(it1))
   !     allocate(beta1(it1,it1))



   !     create omega (weight) for the current iteration
   omega(it1) = sqrt(dot_product(dq,dq))

   if (omega(it1) .gt. (wfac / maxw)) then
      omega(it1) = wfac / omega(it1)
   else
      omega(it1) = maxw
   endif
   if (omega(it1) .lt. minw) then
      omega(it1) = minw
   endif




   !     Build dF(iter-1)
   df(it1,:)=dq-dqlast
   inv=1.0d0 / sqrt(dot_product(df(it1,:),df(it1,:)))
   df(it1,:)=inv*df(it1,:)



   !     Next: build a, beta, c, gamma
   do i=1,it1
      a(i,it1) = dot_product(df(i,:),df(it1,:))
      a(it1,i) = a(i,it1)
      c(i) = omega(i) * dot_product(df(i,:),dq)
   enddo



   !     Build beta from a and omega
   do i = 1, it1
      beta(:it1, i) = omega(:it1) * omega(i) * a(:it1,i)
      beta(i, i) = beta(i, i) + omega0*omega0
   enddo

   !     build beta^-1
   call matinv(beta,it1)

   !     build gamma
   gamma = matmul(c,beta)

   !     Build |u>
   u(it1,:) = alpha * df(it1,:) + inv * (q-qlast) !!!

   !     save charges and deltas
   dqlast = dq
   qlast = q

   !     calculate new charges
   q = q + alpha * dq

   do i=1, it1
      q = q - omega(i) * gamma(i) * u(i,:)
   enddo

   deallocate(beta,c,gamma)

end subroutine broyden




subroutine matinv(a, nrow)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_lapack, only : lapack_getrf, lapack_getri
   integer nRow
   real(wp) a(nrow,nrow)

   integer info
   integer, allocatable :: ipiv(:)
   real(wp), allocatable :: work(:)


   allocate(ipiv(nrow),work(nrow))
   !     LU decomoposition of a general matrix
   call lapack_getrf(nrow,nrow,a,nrow,ipiv,info)
   if (info == 0) then
      !     generate inverse of a matrix given its LU decomposition
      call lapack_getri(nrow,a,nrow,ipiv,work,nrow,info)
   endif
   deallocate(ipiv,work)
   if(info .ne. 0)then
      write(*,*)"Error in Broyden matrix inversion!"
      write(*,*)"Error code",info
      error stop
   endif


end subroutine matinv
end module xtb_broyden

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Parametrisation data for xTB methods
module xtb_xtb_data
   use xtb_mctc_accuracy, only : wp
   use xtb_param_atomicrad, only : atomicRad
   use xtb_param_paulingen, only : paulingEN
   use xtb_type_param, only : dftd_parameter
   use xtb_type_dispersionmodel, only : TDispersionModel
   implicit none
   private

   public :: TxTBData, init
   public :: TRepulsionData, TCoulombData, THamiltonianData, TDispersionData
   public :: THalogenData, TMultipoleData, TShortRangeData
   public :: newData, getData
   public :: generateValenceShellData, angToShellData


   interface newData
      module procedure :: newAtomicData
      module procedure :: newShellData
   end interface newData


   interface getData
      module procedure :: getAtomicData
      module procedure :: getShellData
   end interface getData


   !> Data for the dispersion contribution
   type :: TDispersionData

      !> Damping parameters
      type(dftd_parameter) :: dpar

      !> Weighting factor for Gaussian interpolation
      real(wp) :: wf

      !> Charge steepness
      real(wp) :: g_a

      !> Charge height
      real(wp) :: g_c

      !> Reference data for the dispersion
      type(TDispersionModel) :: dispm

   end type TDispersionData


   !> Data for the repulsion contribution
   type :: TRepulsionData

      !> Repulsion exponent for heavy elements
      real(wp) :: kExp

      !> Repulsion exponent for light elements
      real(wp) :: kExpLight

      !> Repulsion exponent
      real(wp) :: rExp

      !> Electronegativity scaling of repulsion
      real(wp) :: enScale

      !> Exponents of repulsion term
      real(wp), allocatable :: alpha(:)

      !> Effective nuclear charge
      real(wp), allocatable :: zeff(:)

      !> Electronegativitity for scaling of repulsion
      real(wp), allocatable :: electronegativity(:)

      !> FIXME: real space cutoff should not be part of data
      real(wp) :: cutoff

   end type TRepulsionData


   !> Data for the evaluation of the xTB core Hamiltonian
   type :: THamiltonianData

      !> Scaling factors for different interacting shells
      real(wp) :: kScale(0:3, 0:3)

      !> Scaling factor for diffuse or polarisation function
      real(wp) :: kDiff

      !> Shell dependence of the EN polynom
      real(wp) :: enScale(0:3, 0:3)

      !> Quartic contribution to EN polynom
      real(wp) :: enscale4

      !> Exponent for shell exponent weighting
      real(wp) :: wExp

      !> Principal quantum number of each shell
      integer, allocatable :: principalQuantumNumber(:, :)

      !> Angular momentum of each shell
      integer, allocatable :: angShell(:, :)

      !> Valence character of each shell
      integer, allocatable :: valenceShell(:, :)

      !> Number of primitives for expansion of Slater functions
      integer, allocatable :: numberOfPrimitives(:, :)

      !> Exponent of the Slater function
      real(wp), allocatable :: slaterExponent(:, :)

      !> Atomic level information
      real(wp), allocatable :: selfEnergy(:, :)

      !> Reference occupation of the atom
      real(wp), allocatable :: referenceOcc(:, :)

      !> Coordination number dependence of the atomic levels
      real(wp), allocatable :: kCN(:, :)

      !> Electronegativity used in the shell polynomials
      real(wp), allocatable :: electronegativity(:)

      !> Atomic radii used in the shell polynomials
      real(wp), allocatable :: atomicRad(:)

      !> Shell polynomials to scale Hamiltonian elements
      real(wp), allocatable :: shellPoly(:, :)

      !> Pair parameters to scale Hamiltonian elements
      real(wp), allocatable :: pairParam(:, :)

      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kQShell(:, :)

      !> Charge dependence of the atomic levels
      real(wp), allocatable :: kQAtom(:)

   end type THamiltonianData


   !> Data for the evalutation of the Coulomb interactions
   type :: TCoulombData

      !> Use electronegativity equlibration for reference density
      logical :: enEquilibration

      !> Include second order electrostatics
      logical :: secondOrder

      !> Include third order electrostatics
      logical :: thirdOrder

      !> Third order electrostatics is shell resolved
      logical :: shellResolved

      !> Exponent of the generalized gamma function
      real(wp) :: gExp

      !> Atomic hardnesses used in second order electrostatics
      real(wp), allocatable :: chemicalHardness(:)

      !> Scaling factors for shell electrostatics
      real(wp), allocatable :: shellHardness(:, :)

      !> Third order Hubbard derivatives
      real(wp), allocatable :: thirdOrderAtom(:)

      !> Shell resolved third order Hubbard derivatives
      real(wp), allocatable :: thirdOrderShell(:, :)

      !> Charge widths for EEQ model
      real(wp), allocatable :: chargeWidth(:)

      !> Electronegativity for EEQ model
      real(wp), allocatable :: electronegativity(:)

      !> Coordination number dependence of the EN
      real(wp), allocatable :: kCN(:)

   end type TCoulombData


   !> Data for the evaluation of the multipole electrostatics
   type :: TMultipoleData

      !> Coordination number shift
      real(wp) :: cnShift

      !> Coordination number exponent for radii
      real(wp) :: cnExp

      !> Maximum radius
      real(wp) :: cnRMax

      !> Damping parameter for charge-dipole interactions
      real(wp) :: dipDamp

      !> Damping parameter for dipole-dipole, charge-quadrupole interactions
      real(wp) :: quadDamp

      !> Valence coordination number for radii
      real(wp), allocatable :: valenceCN(:)

      !> Cutoff radii for multipole electrostatics
      real(wp), allocatable :: multiRad(:)

      !> Dipole exchange-correlation kernel
      real(wp), allocatable :: dipKernel(:)

      !> Quadrupole exchange-correlation kernel
      real(wp), allocatable :: quadKernel(:)

   end type TMultipoleData


   !> Data for halogen bond correction
   type :: THalogenData

      !> Scaling factor of the atomic radii
      real(wp) :: radScale

      !> Damping parameter for the halogen bond interactions
      real(wp) :: dampingPar

      !> Strength of the halogen bond
      real(wp), allocatable :: bondStrength(:)

      !> Atomic radii
      real(wp), allocatable :: atomicRad(:)

   end type THalogenData


   !> Short range basis correction
   type TShortRangeData

      !> Additional offset for the reference bond lengths
      real(wp) :: shift

      !> Scaling factor for the energy contribution
      real(wp) :: prefactor

      !> Steepness of the EN dependence
      real(wp) :: steepness

      !> Scaling factor for electronegativity differences
      real(wp) :: enScale

   end type TShortRangeData


   !> Parametrisation data for the xTB method
   type :: TxTBData

      !> Name of the parametrisation
      character(len=:), allocatable :: name

      !> Reference to the publication
      character(len=:), allocatable :: doi

      !> Internal version number
      integer :: level

      !> Number of shells
      integer, allocatable :: nShell(:)

      !> Parametrisation data for repulsive interactions
      type(TRepulsionData) :: repulsion

      !> Parametrisation data for core Hamiltonian
      type(THamiltonianData) :: hamiltonian

      !> Parametrisation data for Coulombic interactions
      type(TCoulombData) :: coulomb

      !> Parametrisation data for dispersion interactions
      type(TDispersionData) :: dispersion

      !> Parametrisation data for multipole electrostatics (optional)
      type(TMultipoleData), allocatable :: multipole

      !> Parametrisation data for halogen bond correction (optional)
      type(THalogenData), allocatable :: halogen

      !> Parametrisation data for the short range basis correction (optional)
      type(TShortRangeData), allocatable :: srb

      !> Shift for IP/EA calculations
      real(wp) :: ipeashift

   contains

      !> Write informative printout for the parametrisation data
      procedure :: writeInfo

   end type TxTBData


   !> Default constructor for the data types
   interface init
      module procedure :: initRepulsion
      module procedure :: initHalogen
      module procedure :: initMultipole
      module procedure :: initCoulomb
   end interface init


   ! ========================================================================
   ! MULTIPOLE DATA
   !> Valence coordination number for radii
   real(wp), parameter :: valenceCN(1:118) = [&
      & 1.0_wp, 1.0_wp, 1.0_wp, 2.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 2.0_wp, 1.0_wp, &
      & 1.0_wp, 1.0_wp, 2.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 1.0_wp, 1.0_wp, &
      & 1.0_wp, 2.0_wp, 4.0_wp, 4.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, &
      & 4.0_wp, 4.0_wp, 2.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 1.0_wp, 1.0_wp, &
      & 1.0_wp, 2.0_wp, 4.0_wp, 4.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, &
      & 4.0_wp, 4.0_wp, 2.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 3.0_wp, 1.0_wp, 1.0_wp, &
      & 1.0_wp, 2.0_wp, 4.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, &
      & 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 4.0_wp, &
      & 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 6.0_wp, 4.0_wp, 4.0_wp, 2.0_wp, 3.0_wp, &
      & 3.0_wp, 3.0_wp, 3.0_wp, 1.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp]

   !> Cutoff radii for multipole electrostatics
   real(wp), parameter :: multiRad(1:118) = [&
      & 1.4_wp, 3.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 3.0_wp, 1.9_wp, 1.8_wp, 2.4_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 3.9_wp, 2.1_wp, 3.1_wp, 2.5_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 3.9_wp, 4.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, 5.0_wp, &
      & 5.0_wp]


contains


subroutine writeInfo(self, unit, num)

   !> Instance of the parametrisation data
   class(TxTBData), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Atomic numbers
   integer, intent(in), optional :: num(:)

   character(len=*), parameter :: rnum = '(f12.6)'
   character(len=*), parameter :: offset = '(8x)'
   character(len=*), parameter :: head = '(6x,"*",1x,a,":")'
   character(len=*), parameter :: rfmt = '('//offset//',a,t36,'//rnum//')'
   character(len=*), parameter :: afmt = '('//offset//',a,t36,4x,a)'
   character(len=:), allocatable :: name
   integer :: ii, jj

   write(unit, '(a)')
   if (allocated(self%name)) then
      allocate(character(len=2*len(self%name)-1) :: name)
      name = repeat(' ', len(name))
      do ii = 1, len(self%name)
         jj = 2*ii-1
         name(jj:jj) = self%name(ii:ii)
      end do
   else
      name = repeat(' ', 10)
      write(name, '(i0)') self%level
      name = 'xTB level '//trim(name)
   end if
   call generic_header(unit, name, 49, 10)

   write(unit, '(a)')
   if (allocated(self%doi)) then
      write(unit, afmt) "Reference", self%doi
   end if

   write(unit, head) "Hamiltonian"
   write(unit, rfmt, advance='no') "H0-scaling (s, p, d)"
   do ii = 0, 2
      write(unit, rnum, advance='no') self%hamiltonian%kScale(ii, ii)
   end do
   write(unit, '(a)')
   write(unit, rfmt) "zeta-weighting", self%hamiltonian%wExp

   write(unit, head) "Dispersion"
   write(unit, rfmt) "s8", self%dispersion%dpar%s8
   write(unit, rfmt) "a1", self%dispersion%dpar%a1
   write(unit, rfmt) "a2", self%dispersion%dpar%a2
   write(unit, rfmt) "s9", self%dispersion%dpar%s9

   write(unit, head) "Repulsion"
   write(unit, rfmt, advance='no') "kExp", self%repulsion%kExp
   if (self%repulsion%kExpLight /= self%repulsion%kExp) then
      write(unit, rnum, advance='no') self%repulsion%kExpLight
   end if
   write(unit, '(a)')
   write(unit, rfmt) "rExp", self%repulsion%rExp

   write(unit, head) "Coulomb"
   write(unit, rfmt) "alpha", self%coulomb%gExp
   if (allocated(self%coulomb%thirdOrderShell)) then
      write(unit, afmt) "third order", "shell-resolved"
   else if (allocated(self%coulomb%thirdOrderAtom)) then
      write(unit, afmt) "third order", "atomic"
   else
      write(unit, afmt) "third order", "false"
   end if

   if (allocated(self%multipole)) then
      write(unit, afmt) "anisotropic", "true"
      write(unit, rfmt) "a3", self%multipole%dipDamp
      write(unit, rfmt) "a5", self%multipole%quadDamp
      write(unit, rfmt) "cn-shift", self%multipole%cnShift
      write(unit, rfmt) "cn-exp", self%multipole%cnExp
      write(unit, rfmt) "max-rad", self%multipole%cnRMax
   else
      write(unit, afmt) "anisotropic", "false"
   end if

   if (allocated(self%halogen)) then
      write(unit, head) "Halogen bond correction"
      write(unit, rfmt) "rad-scale", self%halogen%radScale
      write(unit, rfmt) "damping", self%halogen%dampingPar
   end if

   if (allocated(self%srb)) then
      write(unit, head) "Polar bond correction"
      write(unit, rfmt) "rad-shift", self%srb%shift
      write(unit, rfmt) "strength", self%srb%prefactor
      write(unit, rfmt) "en-exp", self%srb%steepness
      write(unit, rfmt) "en-scale", self%srb%enScale
   end if
   write(unit, '(a)')

end subroutine writeInfo


!> Generator for valence shell data from the angular momenta of the shells
subroutine generateValenceShellData(valenceShell, nShell, angShell)

   !> Valency character of each shell
   integer, intent(out) :: valenceShell(:, :)

   !> Number of shells for each atom
   integer, intent(in) :: nShell(:)

   !> Angular momenta of each shell
   integer, intent(in) :: angShell(:, :)

   integer :: lAng, iZp, iSh
   logical :: valShell(0:3)

   valenceShell(:, :) = 0
   do iZp = 1, size(nShell, dim=1)
      valShell(:) = .true.
      do iSh = 1, nShell(iZp)
         lAng = angShell(iSh, iZp)
         if (valShell(lAng)) then
            valShell(lAng) = .false.
            valenceShell(iSh, iZp) = 1
         end if
      end do
   end do

end subroutine generateValenceShellData


!> Initialize halogen bond data
subroutine initHalogen(self, radScale, dampingPar, halogenBond)

   !> Data instance
   type(THalogenData), intent(out) :: self

   !> Scaling parameter for the atomic radii
   real(wp), intent(in) :: radScale

   !> Damping parameter
   real(wp), intent(in) :: dampingPar

   !> Halogen bond strength
   real(wp), intent(in) :: halogenBond(:)

   integer :: maxElem

   maxElem = size(halogenBond)

   self%radScale = radScale
   self%dampingPar = dampingPar
   self%atomicRad = atomicRad(:maxElem)
   self%bondStrength = halogenBond(:maxElem)

end subroutine initHalogen


subroutine initMultipole(self, cnShift, cnExp, cnRMax, dipDamp, quadDamp, &
      & dipKernel, quadKernel)

   !> Data instance
   type(TMultipoleData), intent(out) :: self

   !>
   real(wp), intent(in) :: cnShift

   !>
   real(wp), intent(in) :: cnExp

   !>
   real(wp), intent(in) :: cnRMax

   !>
   real(wp), intent(in) :: dipDamp

   !>
   real(wp), intent(in) :: quadDamp

   !>
   real(wp), intent(in) :: dipKernel(:)

   !>
   real(wp), intent(in) :: quadKernel(:)

   integer :: maxElem

   maxElem = min(size(dipKernel), size(quadKernel))

   self%cnShift = cnShift
   self%cnExp = cnExp
   self%cnRMax = cnRMax
   self%dipDamp = dipDamp
   self%quadDamp = quadDamp
   self%dipKernel = dipKernel(:maxElem)
   self%quadKernel = quadKernel(:maxElem)
   self%valenceCN = valenceCN(:maxElem)
   self%multiRad = multiRad(:maxElem)

end subroutine initMultipole


subroutine initRepulsion(self, kExp, kExpLight, rExp, enScale, alpha, zeff, &
      & electronegativity)

   !> Data instance
   type(TRepulsionData), intent(out) :: self

   !>
   real(wp), intent(in) :: kExp

   !>
   real(wp), intent(in) :: kExpLight

   !>
   real(wp), intent(in) :: rExp

   !>
   real(wp), intent(in) :: enScale

   !>
   real(wp), intent(in) :: alpha(:)

   !>
   real(wp), intent(in) :: zeff(:)

   !>
   real(wp), intent(in), optional :: electronegativity(:)

   integer :: maxElem

   maxElem = min(size(alpha), size(zeff))
   if (present(electronegativity)) then
      maxElem = min(maxElem, size(electronegativity))
   end if

   self%cutoff = 40.0_wp
   self%kExp = kExp
   self%kExpLight = kExpLight
   self%rExp = rExp
   self%enScale = enScale
   self%alpha = alpha(:maxElem)
   self%zeff = zeff(:maxElem)
   if (present(electronegativity)) then
      self%electronegativity = electronegativity(:maxElem)
   else
      self%electronegativity = paulingEN(:maxElem)
   end if

end subroutine initRepulsion


subroutine initCoulomb(self, nShell, chemicalHardness, shellHardness, &
      & thirdOrderAtom, electronegativity, kCN, chargeWidth)

   !> Data instance
   type(TCoulombData), intent(out) :: self

   !>
   integer, intent(in) :: nShell(:)

   !>
   real(wp), intent(in) :: chemicalHardness(:)

   !>
   real(wp), intent(in), optional :: shellHardness(:, :)

   !>
   real(wp), intent(in), optional :: thirdOrderAtom(:)

   !>
   real(wp), intent(in), optional :: electronegativity(:)

   !>
   real(wp), intent(in), optional :: kCN(:)

   !>
   real(wp), intent(in), optional :: chargeWidth(:)

   integer :: maxElem

   maxElem = size(chemicalHardness)
   if (present(shellHardness)) then
      maxElem = min(maxElem, size(shellHardness, dim=2))
   end if
   if (present(thirdOrderAtom)) then
      maxElem = min(maxElem, size(thirdOrderAtom))
   end if
   if (present(electronegativity).and.present(kCN).and.present(chargeWidth)) then
      maxElem = min(maxElem, size(electronegativity), size(kCN), size(chargeWidth))
   end if

   self%chemicalHardness = chemicalHardness(:maxElem)
   if (present(shellHardness)) then
      self%shellHardness = shellHardness(:, :maxElem)
   end if
   if (present(thirdOrderAtom)) then
      self%thirdOrderAtom = thirdOrderAtom(:maxElem)
   end if
   if (present(electronegativity).and.present(kCN).and.present(chargeWidth)) then
      self%electronegativity = electronegativity(:maxElem)
      self%kCN = kCN(:maxElem)
      self%chargeWidth = chargeWidth(:maxElem)
   end if

end subroutine initCoulomb


!> Transform a data array from angular momenta to shell number references
subroutine angToShellData(kDat, nShell, angShell, angDat)

   !> Data in terms of shell number of each species
   real(wp), intent(out) :: kDat(:, :)

   !> Number of shells for each species
   integer, intent(in) :: nShell(:)

   !> Angular momenta of each shell
   integer, intent(in) :: angShell(:, :)

   !> Data in terms of angular momenta of each shell
   real(wp), intent(in) :: angDat(0:, :)

   integer :: nElem, iZp, iSh, lAng, iKind

   nElem = min(size(kDat, dim=2), size(nShell), size(angShell, dim=2), &
      & size(angDat, dim=2))

   kDat(:, :) = 0.0_wp
   do iZp = 1, nElem
      do iSh = 1, nShell(iZp)
         lAng = angShell(iSh, iZp)
         kDat(iSh, iZp) = angDat(lAng, iZp)
      end do
   end do

end subroutine angToShellData


subroutine newAtomicData(vec, num, data)

   real(wp), allocatable, intent(out) :: vec(:)

   integer, intent(in) :: num(:)

   real(wp), intent(in) :: data(:)

   allocate(vec(size(num)))
   call getAtomicData(vec, num, data)

end subroutine newAtomicData


subroutine getAtomicData(vec, num, data)

   real(wp), intent(out) :: vec(:)

   integer, intent(in) :: num(:)

   real(wp), intent(in) :: data(:)

   integer :: ii, izp

   do ii = 1, size(vec, dim=1)
      izp = num(ii)
      vec(ii) = data(izp)
   end do

end subroutine getAtomicData


subroutine newShellData(vec, num, nshell, data)

   real(wp), allocatable, intent(out) :: vec(:, :)

   integer, intent(in) :: num(:)

   integer, intent(in) :: nshell(:)

   real(wp), intent(in) :: data(:, :)

   allocate(vec(maxval(nshell), size(num)))
   call getShellData(vec, num, nshell, data)

end subroutine newShellData


subroutine getShellData(vec, num, nshell, data)

   real(wp), intent(out) :: vec(:, :)

   integer, intent(in) :: num(:)

   integer, intent(in) :: nshell(:)

   real(wp), intent(in) :: data(:, :)

   integer :: ii, ish, izp

   vec(:, :) = 0.0_wp
   do ii = 1, size(vec, dim=2)
      izp = num(ii)
      do ish = 1, nshell(izp)
         vec(ish, ii) = data(ish, izp)
      end do
   end do

end subroutine getShellData


end module xtb_xtb_data

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Setup of the effective Hamiltonians for both iterations in PTB

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

module xtb_ptb_guess
#if WITH_TBLITE
   use mctc_io, only: structure_type
   use mctc_env, only: wp, error_type

   use tblite_wavefunction, only: wavefunction_type
   use tblite_basis_type, only: basis_type

   use xtb_ptb_vdzp, only: nshell
   implicit none

   private

   public :: guess_qsh, get_psh_from_qat, get_psh_from_qsh

contains

   subroutine guess_qsh(wfn, bas)
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(inout) :: wfn
      !> Basis set and core-valence basis set data
      type(basis_type), intent(in) :: bas

      integer :: ish, iat, ii, spin

      !> debug mode
      logical, parameter :: debug = .false.
      

      do spin = 1, size(wfn%qat, 2)
         do iat = 1, size(wfn%qat, 1)
            ii = bas%ish_at(iat)
            do ish = 1, bas%nsh_at(iat)
               
               !> wfn%qsh on output are the shell POPULATIONS
               wfn%qsh(ii+ish, spin) = (wfn%n0sh(ii+ish) / wfn%n0at(iat)) * wfn%qat(iat, spin)
               
               !> wfn%qsh on output are the shell CHARGES
               if (debug) &!##### DEV WRITE #####
                  write(*,*) ii + ish, wfn%qsh(ii + ish, spin)
              
            end do
         end do
      end do
   end subroutine guess_qsh

   function get_psh_from_qat(wfn, bas) result(psh)
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(in) :: wfn
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Shell populations
      real(wp) :: psh(bas%nsh,wfn%nspin)

      integer :: ish, iat, ii, spin

      psh = 0.0_wp
      do spin = 1, size(wfn%qat, 2)
         do iat = 1, size(wfn%qat, 1)
            ii = bas%ish_at(iat)
            do ish = 1, bas%nsh_at(iat)
               !> wfn%qat on input are actually the atomic CHARGES
               psh(ii + ish, spin) = wfn%n0sh(ii + ish) * &
               & ( wfn%n0at(iat) - wfn%qat(iat, spin) ) / wfn%n0at(iat)
            end do
         end do
      end do
   end function get_psh_from_qat

   function get_psh_from_qsh(wfn, bas) result(psh)
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(in) :: wfn
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Shell populations
      real(wp) :: psh(bas%nsh,wfn%nspin)

      integer :: ish, iat, ii, spin

      psh = 0.0_wp
      do spin = 1, size(wfn%qat, 2)
         do iat = 1, size(wfn%qat, 1)
            ii = bas%ish_at(iat)
            do ish = 1, bas%nsh_at(iat)
               psh(ii + ish, spin) = wfn%n0sh(ii + ish) - wfn%qsh(ii + ish, spin)
            end do
         end do
      end do
   end function get_psh_from_qsh

#endif
end module xtb_ptb_guess

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> defines the Wigner--Seitz-cell (wsc) data type
!
!  The Wigner--Seitz cell is used to define periodic boundary conditions
!  by the cyclic cluster model (CCM). This type is usually bound to
!  the molecule class but can in principle be used independently.
module xtb_type_wsc
   use xtb_mctc_accuracy, only : wp
   implicit none

   public :: tb_wsc

   private

!> definition of the the Wigner--Seitz-cell (wsc) data type
   type :: tb_wsc
      integer  :: n = 0       !< number of atoms in the WSC
      integer  :: cells = 0   !< number of cells used to generate WSC
      integer  :: rep(3) = 0  !< translations defining the number of cells
      real(wp) :: lattice(3,3) = 0.0_wp    !< lattice parameters
      integer, allocatable :: at(:,:)      !< define species
      integer, allocatable :: lattr(:,:,:,:) !< lattice translation
      real(wp),allocatable :: w(:,:)       !< define weights
      integer, allocatable :: itbl(:,:)    !< define index table
   contains
   procedure :: allocate => allocate_wsc
   procedure :: deallocate => deallocate_wsc
   procedure :: write => write_wsc
   end type tb_wsc

contains

!> constructor for Wigner--Seitz cell
subroutine allocate_wsc(self,n,rep)
   implicit none
   class(tb_wsc),intent(inout) :: self
   integer,intent(in) :: n      !< number of atoms
   integer,intent(in) :: rep(3) !< translations
   integer :: cells
   cells = product(2*rep+1)
   self%n       = n
   self%rep     = rep
   self%cells   = cells
   call self%deallocate
   allocate( self%at(n,n),            source = 0 )
   allocate( self%lattr(3,cells,n,n), source = 0 )
   allocate( self%w(n,n),             source = 0.0_wp )
   allocate( self%itbl(n,n),          source = 0 )
end subroutine allocate_wsc

!> @brief deconstructor for Wigner--Seitz cell
subroutine deallocate_wsc(self)
   implicit none
   class(tb_wsc),intent(inout) :: self
   if (allocated(self%at))   deallocate(self%at)
   if (allocated(self%lattr))deallocate(self%lattr)
   if (allocated(self%w))    deallocate(self%w)
   if (allocated(self%itbl)) deallocate(self%itbl)
end subroutine deallocate_wsc

subroutine write_wsc(self,iunit,comment)
   implicit none
   class(tb_wsc),   intent(in) :: self
   integer,         intent(in) :: iunit
   character(len=*),intent(in) :: comment
   character(len=*),parameter :: dfmt = '(1x,a,1x,"=",1x,g0)'

   write(iunit,'(72(">"))')
   write(iunit,'(1x,"*",1x,a)') "Writing 'tb_wsc' class"
   write(iunit,'(  "->",1x,a)') comment
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "status of the fields"
   write(iunit,dfmt) "integer :: n           ",self%n
   write(iunit,dfmt) "integer :: cells       ",self%cells
   write(iunit,dfmt) "integer :: rep(1)      ",self%rep(1)
   write(iunit,dfmt) "        &  rep(2)      ",self%rep(2)
   write(iunit,dfmt) "        &  rep(3)      ",self%rep(3)
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "allocation status"
   write(iunit,dfmt) "allocated? at(:)       ",allocated(self%at)
   write(iunit,dfmt) "allocated? lattr(:,:,:,:)",allocated(self%lattr)
   write(iunit,dfmt) "allocated? w(:,:)      ",allocated(self%w)
   write(iunit,dfmt) "allocated? itbl(:,:)   ",allocated(self%itbl)
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "size of memory allocation"
   if (allocated(self%at)) then
   write(iunit,dfmt) "size(1) :: at(*,:)     ",size(self%at,1)
   write(iunit,dfmt) "size(2) :: at(:,*)     ",size(self%at,2)
   endif
   if (allocated(self%lattr)) then
   write(iunit,dfmt) "size(1) :: lattr(*,:,:,:)",size(self%lattr,1)
   write(iunit,dfmt) "size(2) :: lattr(:,*,:,:)",size(self%lattr,2)
   write(iunit,dfmt) "size(3) :: lattr(:,:,*,:)",size(self%lattr,3)
   write(iunit,dfmt) "size(4) :: lattr(:,:,:,*)",size(self%lattr,4)
   endif
   if (allocated(self%w)) then
   write(iunit,dfmt) "size(1) :: w(*,:)      ",size(self%w,1)
   write(iunit,dfmt) "size(2) :: w(:,*)      ",size(self%w,2)
   endif
   if (allocated(self%w)) then
   write(iunit,dfmt) "size(1) :: itbl(*,:)   ",size(self%itbl,1)
   write(iunit,dfmt) "size(2) :: itbl(:,*)   ",size(self%itbl,2)
   endif
   write(iunit,'(72("<"))')

end subroutine write_wsc

end module xtb_type_wsc

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine surfac(fname,n,xyz,at)
      use, intrinsic :: iso_fortran_env, only : output_unit
      use xtb_mctc_accuracy, only : wp
      implicit none
      character(len=*),intent(in)       :: fname
      integer, intent(in)               :: n,at(n) !number of atoms,Ordnunszahlen
      real(wp), intent(in)              :: xyz(3,n)

      real(wp),allocatable              :: s(:,:) !surface 
      real(wp),allocatable              :: atom_weight(:,:)!atom and weight
      real(wp)                          :: point(3),rx,ry,rz,r,r2,rsas
      real(wp)                          :: rad(n),rad2(n),d3rad(94)

      integer, parameter                :: nangsa=86
!     integer, parameter                :: nangsa=230
      real(wp)                          :: grida(4,nangsa)
      include 'grida86.fh'
!     include 'grida230.fh'
      integer                           :: i,j,k,np,ip

      ! D3 radii in Bohr
      data d3rad/
     .  2.18230009,  1.73469996,  3.49559999,  3.09820008,  3.21600008,
     .  2.91030002,  2.62249994,  2.48169994,  2.29959989,  2.13739991,
     .  3.70819998,  3.48390007,  4.01060009,  3.79169989,  3.50169992,
     .  3.31069994,  3.10459995,  2.91479993,  4.24109983,  4.10349989,
     .  3.89030004,  3.76419997,  3.72110009,  3.44140005,  3.54620004,
     .  3.44210005,  3.43269992,  3.34619999,  3.30080009,  3.23090005,
     .  3.95790005,  3.86190009,  3.66249990,  3.52679992,  3.36619997,
     .  3.20959997,  4.61759996,  4.47639990,  4.21960020,  4.05970001,
     .  3.85960007,  3.75430012,  3.56900001,  3.46230006,  3.39750004,
     .  3.35249996,  3.33080006,  3.46199989,  4.26230001,  4.18739986,
     .  4.01499987,  3.89010000,  3.73799992,  3.58890009,  5.05670023,
     .  5.18139982,  4.62610006,  4.62010002,  4.57019997,  4.52710009,
     .  4.48960018,  4.45149994,  4.42339993,  4.12430000,  4.24270010,
     .  4.15409994,  4.27939987,  4.24499989,  4.22079992,  4.19859982,
     .  4.01300001,  4.24499989,  4.09800005,  3.98550010,  3.89549994,
     .  3.74900007,  3.44560003,  3.35249996,  3.25640011,  3.35990000,
     .  4.31269979,  4.27640009,  4.11749983,  4.00540018,  3.86439991,
     .  3.72160006,  5.07959986,  4.92939997,  4.70429993,  4.42519999,
     .  4.45940018,  4.39569998,  4.35389996,  4.43410015/


      do i=1,n
         rad (i) =(d3rad(at(i))*1.2)    ! scale factor adjusted to get vdW contacts right
         rad2(i) =(d3rad(at(i))*1.2)**2
      enddo

      np=n*nangsa
      allocate(s(3,np))
      allocate(atom_weight(2,np)) ! point belonging to atom and atomweight

      k=0 ! number of necessary gridpoints
      do i=1,n
        rsas=rad(i)
        grid_point: do ip=1,nangsa
!          grid point position
           rx = xyz(1,i) + rsas*grida(1,ip)
           ry = xyz(2,i) + rsas*grida(2,ip)
           rz = xyz(3,i) + rsas*grida(3,ip)
           do j=1,n
              if(i.eq.j) cycle
              r2=(xyz(1,j)-rx)**2+(xyz(2,j)-ry)**2+(xyz(3,j)-rz)**2
              if(r2.le.rad2(j)) cycle grid_point  ! closer to another atom, skip grid point
           enddo
           k=k+1
           s(1,k)=rx
           s(2,k)=ry
           s(3,k)=rz
           atom_weight(1,k) = i            ! point belonging to atom i
           atom_weight(2,k) = grida(4,ip)   ! weight belonging to point ip
         enddo grid_point
      enddo

      np=k
      write(*,*) 'generated ',np,' surface points'

      open(unit=83,file=fname)
      do i=1,np
      write(83,'(3E16.8,1x,i0,1x,f10.7)') s(1:3,i),
     & int(atom_weight(1,i)), atom_weight(2,i)
      enddo
      close(83)

      deallocate(s)
      end

! This file is part of xtb.
!
! Copyright (C) 2022 Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ========================================================================
!  * WELCOME TO THE   C O N S T R A I N S   &   S C A N S   MODULE OF
!  THE DOCKING ALGORITHM *
!! ------------------------------------------------------------------------
module xtb_docking_set_module
   use xtb_mctc_accuracy, only: wp
   use xtb_readin, only: mirror_line, getValue
   use xtb_docking_param
   use xtb_type_environment, only: TEnvironment
   use xtb_type_identitymap, only : TIdentityMap
   use xtb_type_atomlist
   use xtb_mctc_strings, only : parse
   use xtb_setmod

   implicit none

   private :: wp, mirror_line, getValue

   character, private, parameter :: flag = '$'
   character, private, parameter :: colon = ':'
   character, private, parameter :: space = ' '
   character, private, parameter :: equal = '='
   character, private, parameter :: hash = '#'
   character, private, parameter :: dot = '.'
   character, private, parameter :: comma = ','
   character(len=*), private, parameter :: flag_end = flag//'end'

!  Using allocatable arrays of dynamic length strings is only possible
!  with a lot of hacks, so we use good'ol fixed size stack arrays.
!  Let's choose something different from 42 that is not dividable by 10... ;)
!  Happy debugging!
   integer, private, parameter :: p_str_length = 48
   integer, private, parameter :: p_arg_length = 24

   public

      !abstract interface
      !   subroutine handlerInterface(env, key, val)
      !      import TEnvironment
      !      type(TEnvironment), intent(inout) :: env
      !      character(len=*), intent(in) :: key
      !      character(len=*), intent(in) :: val
      !   end subroutine handlerInterface
      !end interface

      abstract interface
         subroutine handlerInterface2(env,key,val,nat,at,idMap,xyz)
            import :: wp, TEnvironment, TIdentityMap
            type(TEnvironment), intent(inout) :: env
            character(len=*),intent(in) :: key
            character(len=*),intent(in) :: val
            integer, intent(in) :: nat
            type(TIdentityMap), intent(in) :: idMap
            integer, intent(in) :: at(nat)
            real(wp),intent(in) :: xyz(3,nat)
         end subroutine handlerInterface2
      end interface

contains

   subroutine rdblock_docking(env, handler, line, id, copy, err, ncount)
      !use xtb_setmod, only : handlerInterface
      character(len=*), parameter :: source = 'set_rdblock'
      type(TEnvironment), intent(inout) :: env
      procedure(handlerInterface) :: handler
      integer, intent(in) :: id
      integer, intent(in) :: copy
      integer, intent(out) :: err
      integer, intent(out) :: ncount
      character(len=:), allocatable, intent(out) :: line
      character(len=:), allocatable :: key
      character(len=:), allocatable :: val
      integer :: ie
      logical :: exitRun
      ncount = 0
      do
         call mirror_line(id, copy, line, err)
         if (is_iostat_end(err)) return
         if (index(line, flag) .ne. 0) return
         ! find the equal sign
         ie = index(line, equal)
         if (line .eq. '') cycle ! skip empty lines
         ncount = ncount + 1   ! but count non-empty lines first
         if (ie .eq. 0) then! cycle
            call set_logicals(env, line)
         else
            key = trim(line(:ie - 1))
            val = trim(adjustl(line(ie + 1:)))
            call handler(env, key, val)
            call env%check(exitRun)
            if (exitRun) then
               call env%error("handler could not process input", source)
               return
            end if
         end if
      end do

   end subroutine rdblock_docking

   subroutine rdblock_docking2(env,handler,line,id,nat,at,idMap,xyz,err)
      !use xtb_constrain_param, only : handlerInterface
      use xtb_readin, only : getline => strip_line,getValue,getListValue
      character(len=*), parameter :: source = 'userdata_rdblock'
      type(TEnvironment), intent(inout) :: env
      integer,intent(in) :: id
      procedure(handlerInterface2) :: handler
      integer, intent(in) :: nat
      integer, intent(in) :: at(nat)
      type(TIdentityMap), intent(in) :: idMap
      real(wp),intent(in) :: xyz(3,nat)
      integer,intent(out) :: err
      character(len=:),allocatable,intent(out) :: line
      character(len=:),allocatable :: key
      character(len=:),allocatable :: val
      integer :: ie
      logical :: exitRun
      do
         call getline(id,line,err)
         if (is_iostat_end(err)) exit
         if (index(line,flag).ne.0) exit
         if (debug) write(env%unit,'("->",1x,a)') line
   
         ! find the first colon
         ie = index(line,colon)
         if ((line.eq.'')) cycle
         if (ie .eq. 0) then! cycle
            call set_logicals(env, line)
         else
            key = trim(line(:ie-1))
            val = trim(adjustl(line(ie+1:)))
            call handler(env,key,val,nat,at,idMap,xyz)
            call env%check(exitRun)
            if (exitRun) then
               call env%error("handler could not process input", source)
               return
            end if
         end if
      enddo

   end subroutine rdblock_docking2

   subroutine set_docking(env, key, val)
      character(len=*), parameter :: source = 'set_docking'
      type(TEnvironment), intent(inout) :: env
      character(len=*), intent(in) :: key
      character(len=*), intent(in) :: val
      integer  :: err
      integer  :: idum
      real(wp) :: ddum
      logical  :: ldum
      logical, save :: set1 = .true.
      logical, save :: set2 = .true.
      logical, save :: set3 = .true.
      logical, save :: set4 = .true.
      logical, save :: set5 = .true.
      logical, save :: set6 = .true.
      select case (key)
      case default ! do nothing
        call env%warning("the key '"//key//"' is not recognized by scc", source)
      case ('stepr')
         if (getValue(env, val, ddum) .and. set1) stepr = ddum
         if (stepr < 1.0) then
            stepr = 1.0
            call env%warning("Too small step for radial grid, taking 1.0.")
         end if
         set1 = .false.
      case ('stepa')
         if (getValue(env, val, ddum) .and. set2) stepa = ddum
         if (stepa < 1.0) then
            stepa = 1.0
         call env%warning("Too small step for angular grid, taking 1.0. This is really expensive!")
         end if
         set2 = .false.
      case ('nfinal')
         if (getValue(env, val, idum) .and. set3) n_opt = idum
         set3 = .false.
      case ('maxgen')
         if (getValue(env, val, idum) .and. set4) maxgen = idum
         set4 = .false.
      case ('maxparent')
         if (getValue(env, val, idum) .and. set5) maxparent = idum
         set5 = .false.
      case ('nstack')
         if (getValue(env, val, idum) .and. set6) mxcma = idum
         set6 = .false.
      end select
   end subroutine set_docking

   subroutine write_set_directed(ictrl)
      use xtb_type_atomlist
      integer, intent(in) :: ictrl
      type(TAtomList) :: atl
      character(len=:), allocatable :: string
      integer :: i
      if (directedset%n.eq.0) return
   
      write(ictrl,'(a,"directed")') flag
      if (directedset%n > 0) then
         call atl%new(directedset%atoms(:directedset%n))
         call atl%to_string(string)
         write(ictrl,'(3x,"atoms:",1x,a)') string
      endif
   
   end subroutine write_set_directed

   subroutine set_directed(env,key,val,nat,at,idMap,xyz)
      character(len=*), parameter :: source = 'userdata_directed'
      type(TEnvironment), intent(inout) :: env
      character(len=*),intent(in) :: key
      character(len=*),intent(in) :: val
      integer, intent(in) :: nat
      integer, intent(in) :: at(nat)
      type(TIdentityMap), intent(in) :: idMap
      real(wp),intent(in) :: xyz(3,nat)
   
      type(TAtomList) :: atl
   
      integer  :: i
      integer  :: iat
      integer  :: idum
      integer  :: nlist
      integer, allocatable :: list(:)
      real(wp) :: ddum
      logical  :: ldum
   
      integer  :: narg
      character(len=p_str_length),dimension(p_arg_length) :: argv
   
      call atl%resize(nat)

      call parse(val,comma,argv,narg)
   !  some debug xtb_printout
      if (debug) then
         do idum = 1, narg
            write(env%unit,'("-->",1x,i0,":",1x,a)') idum, trim(argv(idum))
         enddo
      endif
      select case(key)
      case default ! ignore, don't even think about raising them
      case('elements')
         call atl%new
         do idum = 1, narg
            ! get element by symbol
            if (idMap%has(argv(idum))) then
               call idMap%get(list, argv(idum))
               if (allocated(list)) then
                  call atl%add(list)
               else
                  call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
                  cycle
               end if
            else
               ldum = getValue(env,trim(argv(idum)),iat)
               if (.not.ldum) cycle ! skip garbage input
               ! check for unreasonable input
               if (iat > 0) then
                  call atl%add(at.eq.iat)
               else
                  call env%warning("Unknown element: '"//trim(argv(idum))//"'",source)
                  cycle
               endif
            endif
         enddo
         if (directedset%n > 0) call atl%add(directedset%atoms(:directedset%n))
         call atl%to_list(list)
         directedset%atoms = list
         directedset%n = size(list)
      case('atoms')
         call atl%new(val)
         if (atl%get_error()) then
            call env%warning('something is wrong in the fixing list',source)
            return
         endif
         if (directedset%n > 0) call atl%add(directedset%atoms(:directedset%n))
         call atl%to_list(list)
         directedset%atoms = list
         directedset%n = size(list)
      end select
      call write_set_directed(env%unit)
   
   end subroutine set_directed

   subroutine set_logicals(env, key)
      character(len=*), parameter :: source = 'set_logicals'
      type(TEnvironment), intent(inout) :: env
      character(len=*), intent(in) :: key
      integer  :: err
      integer  :: idum
      real(wp) :: ddum
      logical  :: ldum
      logical, save :: set1 = .true.
      logical, save :: set2 = .true.
      logical, save :: set3 = .true.
      logical, save :: set4 = .true.
      logical, save :: set5 = .true.
      logical, save :: set6 = .true.
      logical, save :: set7 = .true.
      logical, save :: set8 = .true.
      logical, save :: set9 = .true.
      logical, save :: set10 = .true.
      logical, save :: set11 = .true.
      logical, save :: set12 = .true.
      logical, save :: set13 = .true.
      logical, save :: set14 = .true.
      logical, save :: set15 = .true.
      select case (key)
      case default ! do nothing
        call env%warning("the key '"//key//"' is not recognized by scc", source)
      case ('nopocket')
         if (set1) pocket_grid = .false.
         set1 = .false.
      case ('pocket')
         if (set2) pocket_grid = .true.
         set2 = .false.
      case ('nostack')
         if (set3) stack_grid = .false.
         set3 = .false.
      case ('stack')
         if (set4) stack_grid = .true.
         set4 = .false.
      case ('noangular')
         if (set5) angular_grid = .false.
         set5 = .false.
      case ('angular')
         if (set6) angular_grid = .true.
         set6 = .false.
      case ('atm')
         if (set7) fulle = .true.
         set7 = .false.
      case ('fast')
         if (set8) then
            maxparent = 30      ! # of parents in gene pool 100
            maxgen = 7          ! # of generations 10
            mxcma = 250         ! R points in CMA search 1000
            stepr = 4.0         ! R grid step in Bohr 2.5
            stepa = 60          ! angular grid size in deg. 45
            n_opt = 4          ! # of final grad opts 15
         end if
         set8 = .false.
      case('qcg')
         if (set8) then
            maxparent = 50      ! # of parents in gene pool 100
            maxgen = 7          ! # of generations 10
!            mxcma = 250         ! R points in CMA search 1000
!            stepr = 4.0         ! R grid step in Bohr 2.5
!            stepa = 60          ! angular grid size in deg. 45
            n_opt = 5          ! # of final grad opts 15
            qcg = .true.
         end if
         set8 = .false.
      case ('noind')
         if (set9) mode = 1
         set9 = .false.
      case ('loose')
         if (set10) mode = 2
         set10 = .false.
      case ('cs')
         if (set11) cssym = .true.
         set11 = .false.
      case ('org')
         if (set12) incl_org = .true.
         set12 = .false.
      case ('ensemble')
         if (set13) docking_ens = .true.
         set13 = .false.
      case('attractive')
         if (set14) directed_type = p_atom_att
         set14 = .false.
      case('repulsive')
         if (set15) directed_type = p_atom_pot
         set15 = .false.
      end select
   end subroutine set_logicals

   subroutine set_optlvl(env)

      !> Calculation environment
      type(TEnvironment), intent(inout) :: env

      if (optlvl == 'gfn2') then
         call set_gfn(env, 'method', '2')
         call set_gfn(env, 'd4', 'true')
      end if

      if (optlvl == 'gfn1') then
         call set_gfn(env, 'method', '1')
      end if

      if (optlvl == 'gfn0') then
         call set_gfn(env, 'method', '0')
         call set_exttyp('eht')
      end if

      if (optlvl == 'gfnff') then
         call set_exttyp('ff')
      end if

   end subroutine set_optlvl

end module xtb_docking_set_module

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> generate a Wigner--Seitz cell from a given structure
subroutine generate_wsc(mol,wsc)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule
   use xtb_type_wsc
   implicit none
   !> molecular structure informtion
   type(TMolecule),intent(in) :: mol
   !> Wigner--Seitz cell data type (might be contained in mol)
   type(tb_wsc),     intent(inout) :: wsc
! ------------------------------------------------------------------------
!  Variables
! ------------------------------------------------------------------------
   integer  :: rep(3)
   integer  :: ii,jj,ich
   integer  :: aa,bb,cc
   integer  :: c,wc
   integer  :: minpos
   integer  :: nminpos
   real(wp) :: t(3),rw(3)
   real(wp) :: mindist
   real(wp) :: nmindist
   !> overall WSC tolerance to consider atoms as WSC-images
   real(wp),parameter :: tol = 0.01_wp
   integer, allocatable,dimension(:,:)   :: lattr
   real(wp),allocatable,dimension(:)     :: dist
   logical, allocatable,dimension(:)     :: trans

   where(mol%pbc)
      rep = 1
   elsewhere
      rep = 0
   endwhere

! ------------------------------------------------------------------------
!  allocate space for the WSC first
   call wsc%allocate(mol%n,rep)

! ------------------------------------------------------------------------
! initialize
! ------------------------------------------------------------------------
   allocate( lattr(3,wsc%cells),      source = 0 )
   allocate( dist(wsc%cells),         source = 0.0_wp )
   allocate( trans(wsc%cells),        source = .true. )
! ------------------------------------------------------------------------
! Create the Wigner-Seitz Cell (WSC)
! ------------------------------------------------------------------------
   wsc%at  = 0
   wsc%itbl= 0
!$omp parallel default(none) &
!$omp private(ii,jj,wc,c,dist,trans,t,lattr,rw) &
!$omp shared(mol,wsc,rep) &
!$omp shared(mindist,minpos,nmindist,nminpos)
!$omp do schedule(dynamic)
   ! Each WSC of one atom consists of n atoms
   do ii=1,mol%n
      do jj=1,mol%n
         !if (ii.eq.jj) cycle
         ! find according neighbours
         c=0
         dist = 0.0_wp
         lattr = 0
         do aa=-rep(1),rep(1),1
            do bb=-rep(2),rep(2),1
               do cc=-rep(3),rep(3),1
                  if ((aa.eq.0 .and. bb.eq.0 .and. cc.eq.0).and.ii.eq.jj) cycle
                  t = [aa,bb,cc]
                  c=c+1
                  lattr(:,c) = [aa,bb,cc]
                  rw = mol%xyz(:,jj) + matmul(mol%lattice,t)
                  dist(c)=sqrt(sum((mol%xyz(:,ii)-rw)**2))
               end do
            end do
         end do
         ! sanity check; otherwise code below crashes sometimes
         if (c .eq. 0) cycle
         ! get first image with same dist
         ! find minimum in dist-array and assign it to minpos = minimum position
         trans=.true.
         minpos=minloc(dist(:c),dim=1)
         ! minimum distance saved in mindist
         mindist=dist(minpos)
         trans(minpos)=.false.
         wc=1
         wsc%lattr(:,wc,jj,ii)=lattr(:,minpos)
         ! get other images with same distance
         if (c > 1) then
            find_images : do
               nminpos=minloc(dist(:c),dim=1,mask=trans(:c))
               nmindist=dist(nminpos)
               if(abs(mindist-nmindist).lt.tol)then
                  trans(nminpos)=.false.
                  wc=wc+1
                  wsc%lattr(:,wc,jj,ii)=lattr(:,nminpos)
               else
                  wsc%w(jj,ii)=1.0_wp/real(wc,wp)
                  wsc%itbl(jj,ii)=wc
                  wsc%at(jj,ii)=jj
                  exit find_images
               end if
            end do find_images
         else
            wsc%w(jj,ii) = 1.0_wp
            wsc%itbl(jj,ii) = 1
            wsc%at(jj,ii)=jj
         endif
      end do
   end do
!$omp enddo
!$omp endparallel

end subroutine generate_wsc

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> TODO
module xtb_type_vendordata
   use mctc_io_structure_info, only : structure_info, pdb_data, sdf_data
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: pdb_data, sdf_data, vasp_info, turbo_info, struc_info, structure_info
   public :: resize


   !> vasp input data
   !
   !  contains specific vasp keywords that modify the appearance of the
   !  input file and can be used to reproduce it in the output
   type :: vasp_info
      real(wp) :: scale = 1.0_wp
      logical :: selective = .false.
      logical :: cartesian = .false.
   end type vasp_info

   !> Turbomole input data
   !
   !  Saves preferences for cartesian vs. direct coordinates and lattice vs. cell.
   !  Also saves units of input data groups.
   type :: turbo_info
      logical :: cartesian = .true.
      logical :: lattice = .true.
      logical :: angs_lattice = .false.
      logical :: angs_coord = .false.
   end type turbo_info


   !> structure input info
   !
   !  contains informations from different input file formats
   !  SDF: is the structure 2d or 3D?
   type :: struc_info
      logical :: two_dimensional = .false.
      logical :: add_hydrogen = .false.
   end type struc_info


   interface resize
      module procedure resize_pdb_data
   end interface


contains


subroutine resize_pdb_data(var, n)
   type(pdb_data), allocatable, intent(inout) :: var(:)
   integer, intent(in), optional :: n
   type(pdb_data), allocatable :: tmp(:)
   integer :: length, current_length
   current_length = size(var)
   if (current_length > 0) then
      if (present(n)) then
         if (n <= current_length) return
         length = n
      else
         length = current_length + current_length/2 + 1
      endif
      allocate(tmp(length), source=pdb_data())
      tmp(:current_length) = var(:current_length)
      deallocate(var)
      call move_alloc(tmp, var)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(var(length), source=pdb_data())
   endif
end subroutine resize_pdb_data


end module xtb_type_vendordata

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_extern_turbomole
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_filetypes, only : fileType
   use xtb_mctc_symbols, only : toSymbol
   use xtb_type_calculator, only : TCalculator
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_param, only : scc_parameter
   use xtb_type_restart, only : TRestart
   use xtb_io_writer, only : writeMolecule
   use xtb_io_reader, only : readHessian
   use xtb_type_reader, only : TReader
   use xtb_mctc_filetypes, only : fileType
   use xtb_mctc_systools
   use xtb_mctc_strings
   use xtb_setparam
   use xtb_readin
   use xtb_mctc_convert
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_metadynamic
   use xtb_constrainpot
   implicit none
   private

   public :: wrtm, rdtm
   public :: TTMCalculator, newTMCalculator

   type, extends(TCalculator) :: TTMCalculator
      type(qm_external) :: ext
      integer :: extcode
      integer :: extmode
   contains
      !> Perform single point calculation
      procedure :: singlepoint
      !> Calculate hessian
      procedure :: hessian
      !> Write informative printout
      procedure :: writeInfo
   end type TTMCalculator

contains

!----------------------------------------------------------
! Create a new calculator for driving the Turbomole program
!----------------------------------------------------------
subroutine newTMCalculator(self,extcode,extmode)
   
   implicit none
   type(TTMCalculator), intent(out) :: self
      !! Instance of the Turbomole calculator
   integer, intent(in) :: extcode
      !! RI, RI+d3+gCP,NoRI
   integer, intent(in) :: extmode
      !! ridft+rdgrad, ridft+rdgrad+dftd3+gcp

   self%threadsafe = .false.
      !! No parallelization
   self%extcode = extcode
   self%extmode = extmode

end subroutine newTMCalculator


subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)
   !> Source of the generated errors
   character(len=*), parameter :: source = 'extern_turbomole_singlepoint'
   !> Calculator instance
   class(TTMCalculator), intent(inout) :: self
   !> Computational environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol
   !> Wavefunction data
   type(TRestart), intent(inout) :: chk
   !> Print level for IO
   integer, intent(in) :: printlevel
   !> Restart from previous results
   logical, intent(in) :: restart
   !> Total energy
   real(wp), intent(out) :: energy
   !> Molecular gradient
   real(wp), intent(out) :: gradient(:, :)
   !> Strain derivatives
   real(wp), intent(out) :: sigma(:, :)
   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap
   !> Detailed results
   type(scc_results), intent(out) :: results

   integer :: i,ich
   integer :: mode_sp_run = 1
   real(wp) :: efix
   real(wp) :: dipole(3)
   logical :: inmol
   logical, parameter :: ccm = .true.
   logical :: exitRun
   character(len=*),parameter :: outfmt = &
      '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'

   call mol%update

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   hlgap = 0.0_wp
   efix = 0.0_wp
   dipole(:) = 0.0_wp

   call external_turbomole(env,mol%n,mol%at,mol%xyz,chk%wfn%nel,chk%wfn%nopen, &
      & self%extcode,self%extmode,.true.,energy,gradient,results%dipole,self%lSolv,mol%chrg,mol%uhf)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Electronic structure method terminated", source)
      return
   end if

   ! ------------------------------------------------------------------------
   !  various external potentials
   call constrain_pot(potset,mol%n,mol%at,mol%xyz,gradient,efix)
   call constrpot   (mol%n,mol%at,mol%xyz,gradient,efix)
   call cavity_egrad(mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (metaset,mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (rmsdset,mol%n,mol%at,mol%xyz,efix,gradient)

   ! ------------------------------------------------------------------------
   !  fixing of certain atoms
   !  print*,abs(efix/etot)
   energy = energy + efix
   results%e_total = energy
   results%gnorm = norm2(gradient)
   results%dipole = dipole
   if (fixset%n.gt.0) then
      do i=1, fixset%n
         !print*,i,fixset%atoms(i)
         gradient(1:3,fixset%atoms(i))=0
      enddo
   endif

   if (printlevel.ge.2) then
      ! start with summary header
      if (.not.set%silent) then
         write(env%unit,'(9x,53(":"))')
         write(env%unit,'(9x,"::",21x,a,21x,"::")') "SUMMARY"
      endif
      write(env%unit,'(9x,53(":"))')
      write(env%unit,outfmt) "total energy      ", results%e_total,"Eh   "
      write(env%unit,outfmt) "gradient norm     ", results%gnorm,  "Eh/a0"
      write(env%unit,outfmt) "HOMO-LUMO gap     ", results%hl_gap, "eV   "
      write(env%unit,'(9x,53(":"))')
      write(env%unit,'(a)')
   endif
end subroutine singlepoint

!---------------------------------------------------------
! To run TURBOMOLE, and cefine if needed 
!---------------------------------------------------------
subroutine external_turbomole(env,n,at,xyz,nel,nopen,extcode,extmode,grd,eel,g,dip,lsolv,chrg,uhf)
   
   use xtb_mctc_accuracy, only : wp
   use xtb_setparam
   
   implicit none
   character(len=*),parameter :: source = 'external_turbomole'
   type(TEnvironment), intent(inout) :: env
      !! Calculation environment to handle I/O stream and error log
   integer :: n, at(n), nel, nopen
      !! structural information from mol(Tmolecule) and chk(TRestart) 
   logical ::  grd
      !! if gradient calcultion is needed
   logical :: lsolv
      !! if solvated
   integer, intent(in) :: extcode, extmode
      !! turbomole settings
   real(wp) :: xyz(3,n)
      !! coordinates
   real(wp) :: xyz_cached(3,n)
      !! to save xyz values
   real(wp) :: g (3,n)
      !! gradients
   real(wp) :: eel
      !! electronic energy
   real(wp) :: dip(3)
      !! dipole moments
   real(wp), intent(in) :: chrg
      !! charge
   integer, intent(in) :: uhf
      !! multiplicity, number of unpaired electrons

   character(len=255) atmp
   character(len=:), allocatable :: syspath, cefine
   logical :: cache
      !! to check if molecule moves b/n optimization runs
   logical :: exist
   integer :: err

   cache = .false.
   dip=0
   
   !> TM input
   inquire(file="control", exist=exist)
      !! if control file present in the calc dir
   if (.not.exist) then
      
      !> cefine 
      if(len(set%ext_turbo%input_string).ne.0) then      
         call rdvar("PATH", syspath)
         call rdpath(syspath, "cefine", cefine, exist)
         if (exist) then
            call wrtm(n,at,xyz)
            if (allocated(set%ext_turbo%input_string)) then 
               call execute_command_line("exec "//cefine//" "//set%ext_turbo%input_string)
            else
               call execute_command_line("exec "//cefine//" --func b97-3c")
            endif
         else
            call env%error("No cefine binary is found", source)
            return
         end if

      else
         call writeControl(chrg,uhf)
            !! default control file
      endif

   end if

   inquire(file="control", exist=exist)
   if (.not.exist) then
      call env%error("No 'control' file in current directory")
      return
   end if
   
  
   ! TM (RI)
   if(extcode.eq.1)then
      !$omp critical (turbo_lock)
      inquire(file='gradient', exist=exist)
      if (exist .and. grd) then
         call rdtm(env,n,grd,eel,g,xyz_cached)
         cache = all(abs(xyz_cached - xyz) < 1.e-7_wp)
      end if
      if (.not.cache) then
         call wrtm(n,at,xyz)
         if(extmode.eq.1)then
            
            write(env%unit,'(72("="))')
            write(env%unit,'(1x,"*",1x,a)') &
               "letting TURBOMOLE take over the control..."
            
            if (set%oniom_settings%silent) then
               call execute_command_line('exec ridft >  job.last 2>> /dev/null',exitstat=err)
               if(grd)call execute_command_line('exec rdgrad >> job.last 2>> /dev/null ',exitstat=err)
            else
               call execute_command_line('exec ridft  | tee  job.last 2>> /dev/null',exitstat=err)
               if(grd)call execute_command_line('exec rdgrad |tee -a job.last 2>> /dev/null ',exitstat=err)
            endif

            if (err.ne.0) then
               call env%error('TURBOMOLE returned with non-zero exit status, doing the same',source)
            else
               write(env%unit,'(1x,"*",1x,a)') &
               "successful TURBOMOLE run, taking over control again..."
            endif
               write(env%unit,'(72("="))')
       endif
         call extcodeok(extcode)
         call rdtm(env,n,grd,eel,g,xyz_cached)
         if (set%ceasefiles) then
            call env%io%deleteFile('job.last') 
            call env%io%deleteFile('mos') 
            call env%io%deleteFile('statistics') 
            call env%io%deleteFile('basis') 
            call env%io%deleteFile('auxbasis') 
            call env%io%deleteFile('coord') 
         endif
      end if
      !$omp end critical (turbo_lock)
      return
   endif

   ! TM+d3+gcp
   if(extcode.eq.2)then
      !$omp critical (turbo_lock)
      inquire(file='gradient', exist=exist)
      if (exist .and. grd) then
         call rdtm(env,n,grd,eel,g,xyz_cached)
         cache = all(abs(xyz_cached - xyz) < 1.e-7_wp)
      end if
      if (.not.cache) then
         call wrtm(n,at,xyz)
         if(extmode.le.2)then
            call execute_command_line('exec ridft  >  job.last 2>> /dev/null')
            call execute_command_line('exec rdgrad >> job.last 2>> /dev/null')
            call execute_command_line('exec dftd3 coord -grad >> job.last 2>> /dev/null')
            call execute_command_line('exec gcp coord -file -grad >>job.last 2>>/dev/null')
         endif
         call extcodeok(extcode)
         call rdtm(env,n,.true.,eel,g,xyz_cached)
         
         if (set%ceasefiles) then
            call env%io%deleteFile('job.last') 
            call env%io%deleteFile('mos') 
            call env%io%deleteFile('statistics') 
            call env%io%deleteFile('basis') 
            call env%io%deleteFile('auxbasis') 
            call env%io%deleteFile('coord') 
         endif
      end if
      !$omp end critical (turbo_lock)
      return
   endif

   ! TM (NORI)
   if(extcode.eq.3)then
      !$omp critical (turbo_lock)
      inquire(file='gradient', exist=exist)
      if (exist .and. grd) then
         call rdtm(env,n,grd,eel,g,xyz_cached)
         cache = all(abs(xyz_cached - xyz) < 1.e-7_wp)
      end if
      if (.not.cache) then
         call wrtm(n,at,xyz)
         if(extmode.eq.1)then
            call execute_command_line('exec dscf  > job.last 2>> /dev/null')
            if(grd)call execute_command_line('exec grad >> job.last 2>> /dev/null')
         endif
         call extcodeok(extcode)
         call rdtm(env,n,grd,eel,g,xyz_cached)
         if (set%ceasefiles) then
            call env%io%deleteFile('job.last') 
            call env%io%deleteFile('mos') 
            call env%io%deleteFile('statistics') 
            call env%io%deleteFile('basis') 
            call env%io%deleteFile('auxbasis') 
            call env%io%deleteFile('coord') 
         endif
      end if
      !$omp end critical (turbo_lock)
      return
   endif


   call raise('E','This external code is not implemented')

end subroutine external_turbomole

!-------------------------------------------------------
! create default TM control -> future TMprep
!-------------------------------------------------------
subroutine writeControl(chrg,uhf)

   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   real(wp), intent(in) :: chrg
      !! charge
   integer, intent(in) :: uhf
      !! number of unpaired electrons
   integer :: iunit
      !! number of electrins

   iunit=39
   open(newunit=iunit,file='control')

   write(iunit,'(a)')'$coord file=coord'
   write(iunit,'(a,i0,a,i0)')'$eht charge=',nint(chrg),' unpaired=',uhf
   write(iunit,'(a)')'$symmetry c1'
   write(iunit,'(a)')'$atoms'
   write(iunit,'(3x,a)')'basis =def2-mTZVP'
   write(iunit,'(a)')'$dft'
   write(iunit,'(3x,a)')'functional b97-3c'
   write(iunit,'(3x,a)')'gridsize m4'
   write(iunit,'(a)')'$rij'
   write(iunit,'(a)')'$energy file=energy'
   write(iunit,'(a)')'$grad file=gradient'
   write(iunit,'(a)')'$disp3 -bj -abc'
   write(iunit,'(a)')'$end'

   close(iunit)

end subroutine writeControl

subroutine wrtm(n,at,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer n, at(n), iunit, i
   real(wp) xyz(3,n)

   iunit=33
   open(newunit=iunit,file='coord')

   write(iunit,'(a)')'$coord'
   do i=1,n
      write(iunit,'(3F24.14,6x,a2)') &
      &   xyz(1,i),xyz(2,i),xyz(3,i),toSymbol(at(i))
   enddo
   write(iunit,'(a)')'$end'

   close(iunit)

end subroutine wrtm

!----------------------------------------
! read TM energy and gradient files 
!----------------------------------------
!subroutine readTM(n,ifgrd,energy,gradient,xyz)
   
 !  use xtb_mctc_accuracy, only : wp
   !use xtb_filetools, only : open_file, close_file, remove_file
 !  use xtb_readin , only : strip_line,getValue

!   implicit none
!   integer, intent(in) :: n
      !! number of atoms
!   logical, intent(in) :: ifgrd
      !! if gradient fileshould be read
!   real(wp), intent(out) :: energy, gradient(3,n), xyz(3,n)
      !! TM output
   
!   integer :: grd, e
      !! file units for 'gradient' and 'energy' files
!   character(len=:), allocatable :: line
      !! tmp line
!   logical :: exist


!   if (.not.ifgrd) then
!      call open_file(e,'energy','r')
!      do
!         call strip_line(e,line,exist)
!         if (exist)
!            call readline()
!      enddo
!   endif
!
!
!end subroutine readTM
subroutine rdtm(env,n,grd,e,g,xyz)
   
   use xtb_mctc_accuracy, only : wp
   implicit none
   type(TEnvironment), intent(inout) :: env
   integer n, iunit, i, nl, j, nn
   logical grd
   real(wp) g(3,n), e, xx(10), x, y, z, xyz(3,n)
   logical ex
   character(len=128) a1

   iunit=33

   if(.not.grd)then
      open(newunit=iunit,file='energy')
      101   read(iunit,'(a)',end=102)a1
      call readl(a1,xx,nn)
      if(nn.ge.4) e=xx(2)
         !! to assign the last entry 
      goto 101
      102 continue
      if (set%ceasefiles) then
         call env%io%deleteFile('energy') 
      else
         close(iunit)
      endif
      return
   endif

   inquire(file='gradient',exist=ex)
   if(.not.ex) then
      call raise('E','no gradient file found!')
   endif

   j=0
   open(newunit=iunit,file='gradient')
201 read(iunit,'(a)',end=301)a1
   j=j+1
   if(index(a1,'cycle').ne.0)nl=j
   goto 201
   301   continue

   if(nl.lt.2)then
      call raise('E','illegal gradient file!')
   endif

   rewind iunit
   do i=1,nl
      read(iunit,'(a)')a1
   enddo
   call readl(a1,xx,nn)
   e=xx(2)
   do i=1,n
      read(iunit,*)xyz(1,i),xyz(2,i),xyz(3,i)
   enddo
   do i=1,n
      read(iunit,*)g(1,i),g(2,i),g(3,i)
   enddo
   if (set%ceasefiles) then
      call env%io%deleteFile('energy') 
      call env%io%deleteFile('gradient') 
   else
      close(iunit)
   endif

end subroutine rdtm

subroutine extcodeok(extcode)
   implicit none
   integer, intent (in) :: extcode
   integer :: ich
   character(len=80) atmp
   ! TM
   if(extcode.le.3)then
      call execute_command_line('exec grep "actual step" control > TmPfIlE')
      open(newunit=ich,file='TmPfIlE',status='old')
      read(ich,'(a)',end=100)atmp
 100  close(ich,status='delete')
      if(index(atmp,'actual').ne.0) call raise('E','external code error: '//&
      &                                            trim(atmp))
   endif

   return
end subroutine extcodeok

subroutine writeInfo(self, unit, mol)

   !> Calculator instance
   class(TTMCalculator), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   call generic_header(unit,"Orca driver",49,10)
end subroutine writeInfo

!> Evaluate hessian by finite difference for all atoms
subroutine hessian(self, env, mol0, chk0, list, step, hess, dipgrad)
   character(len=*), parameter :: source = "extern_turbomole_hessian"
   !> Single point calculator
   class(TTMCalculator), intent(inout) :: self
   !> Computation environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol0
   !> Restart data
   type(TRestart), intent(in) :: chk0
   !> List of atoms to displace
   integer, intent(in) :: list(:)
   !> Step size for numerical differentiation
   real(wp), intent(in) :: step
   !> Array to add Hessian to
   real(wp), intent(inout) :: hess(:, :)
   !> Array to add dipole gradient to
   real(wp), intent(inout) :: dipgrad(:, :)

   integer :: idipd, stat
   type(TReader) :: reader

   call wrtm(mol0%n,mol0%at,mol0%xyz) !Overwrite coord with RAM-xyz file

   call execute_command_line('exec aoforce > job.last2>> /dev/null')
   call reader%open('hessian')
   call readHessian(env, mol0, hess, reader, fileType%tmol)
   call reader%close

   call open_file(idipd,'dipgrad','r')
   if(idipd == -1) then
      call env%error("No dipolegradient found", source)
      return
   end if

   call read_dipgrad(idipd, mol0%n, dipgrad, stat)

   if(stat /=0 ) then
      call env%error('An error occurred while reading the dipolegradient', source)
      return
   end if

   call close_file(idipd)
end subroutine hessian

subroutine read_dipgrad(idipd, n, dipd, error)
   use xtb_mctc_systools

   implicit none

   integer, intent(out) :: error
   character(len=:), allocatable :: line
   integer, intent(in) :: n
   real(wp), intent(inout) :: dipd(:,:)
   integer, intent(in) :: idipd
   integer :: i,j

   error = 0

   do while(error == 0)
      call getline(idipd, line, error)
      if (index(line, '$dipgrad          cartesian dipole gradients') == 1) then
         do i=1, 3*n
            read(idipd,*) (dipd(j,i),j=1,3)
         end do
         exit
      end if
   enddo
end subroutine read_dipgrad

end module xtb_extern_turbomole

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_scan
contains

subroutine relaxed_scan(env, mol, chk, calc)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType
   use xtb_setparam
   use xtb_scanparam

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_calculator
   use xtb_type_data

   use xtb_io_writer, only : writeMolecule
   use xtb_geoopt

   implicit none

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(inout) :: mol
   class(TCalculator), intent(inout) :: calc
   type(TRestart),intent(inout) :: chk

   integer  :: ilog ! file handle
   real(wp) :: egap
   integer  :: maxiter
   integer  :: maxcycle
   real(wp) :: etot,efix
   real(wp) :: sigma(3,3)
   real(wp),allocatable :: g(:,:)
   real(wp),allocatable :: xyzsave(:,:)
   integer  :: optlevel
   logical  :: pr,fail,reset
   logical  :: exist
   integer  :: i,j,k

   pr = set%verbose
   reset = .false.
   optlevel = set%optset%optlev
   maxcycle = set%optset%maxoptcycle
   maxiter = set%maxscciter

   allocate ( g(3,mol%n), source = 0.0_wp )
   allocate ( xyzsave(3,mol%n), source = mol%xyz )

   write(env%unit,'(72("="))')
   write(env%unit,'(1x,"RELAXED SCAN")')
   write(env%unit,'(72("-"))')
   write(env%unit,'(1x,"output written to",1x,a)') get_namespace('xtbscan.log')
   call open_file(ilog,'xtbscan.log','w')

!! ========================================================================
!  SEQUENTIAL SCAN
!  -> scan over all constrains one after another
!  -> you can scan a constrain twice, we don't care
   if (scan_mode.eq.p_scan_sequential) then
      k = 0
      do i = 1, nscan
         write(env%unit,'(1x,"scaning constraint",1x,i0,1x,i0)') scan_list(i)%iconstr
         do j = 1, scan_list(i)%nscan
            k = k+1
!           write(env%unit,'(1x,"valconstr:",1x,f12.8)') scan_list%valscan(j)
            valconstr(scan_list(i)%iconstr) = scan_list(i)%valscan(j)
!           write(env%unit,'(i0,1x,i0)') i,j
            if (.not.set%verbose) &
               write(env%unit,'("... step",1x,i0,1x,"...")') k
            call geometry_optimization &
               &(env, mol,chk,calc, &
               & egap,set%etemp,maxiter,maxcycle,etot,g,sigma,optlevel,pr,.true.,fail)
            efix = 0.0_wp
            call constrpot(mol%n,mol%at,mol%xyz,g,efix)
            if (.not.set%verbose) then
               write(env%unit,'(" current energy:",1x,f20.8)') etot
               write(env%unit,'("    bias energy:",1x,f20.8)') efix
               write(env%unit,'("unbiased energy:",1x,f20.8)') etot-efix
            endif
            call writeMolecule(mol, ilog, fileType%xyz, energy=etot-efix)
         enddo
         if (reset) valconstr(scan_list(i)%iconstr) = scan_list(i)%valconstr
      enddo
!! ========================================================================
!  CONCERTED SCAN
!  -> we scan all constraints at once, therefore we require an equal number
!     of steps for each scan
!  -> you can still scan a constrain twice, which then will lead to
!     abdominations and horrors beyond your imagination, beware.
   else if (scan_mode.eq.p_scan_concerted) then
      if (any(scan_list(1:nscan)%nscan.ne.scan_list(1)%nscan)) then
         ! I'm not happy doing this here, since it should be catched already
         call raise('E','Wrong setup for concerted scan, aborting...')
      endif
      do j = 1, scan_list(1)%nscan
         do i = 1, nscan
            valconstr(scan_list(i)%iconstr) = scan_list(i)%valscan(j)
         enddo
         if (.not.set%verbose) &
            write(env%unit,'("... step",1x,i0,1x,"...")')   j
         call geometry_optimization &
            &(env, mol,chk,calc, &
            & egap,set%etemp,maxiter,maxcycle,etot,g,sigma,optlevel,pr,.true.,fail)
         efix = 0.0_wp
         call constrpot(mol%n,mol%at,mol%xyz,g,efix)
         if (.not.set%verbose) then
            write(env%unit,'(" current energy:",1x,f20.8)') etot
            write(env%unit,'("    bias energy:",1x,f20.8)') efix
            write(env%unit,'("unbiased energy:",1x,f20.8)') etot-efix
         endif
         call writeMolecule(mol, ilog, fileType%xyz, energy=etot-efix)
      enddo
!! ========================================================================
!  BUGGY SCAN
!  if you land here, you used it wrong. Fix it! Now!
   else
      call raise('E','We screwed up in scan_driver.f90, blame us in a bug report')
   endif

   call close_file(ilog)

end subroutine relaxed_scan

end module xtb_scan

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Supported file types in this program
module xtb_mctc_filetypes
   use mctc_io_filetype, only : filetype, getFileType => get_filetype
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_chartools, only : toLowercase
   implicit none
   private

   public :: fileType, getFileType, generateFileMetaInfo, generateFileName
   public :: hessType


   type :: hessEnum
      integer :: tmol = 1
      integer :: orca = 2
      integer :: dftbplus = 3
   end type hessEnum
   type(hessEnum), parameter :: hessType = hessEnum()


   !> Default file type
   integer, parameter :: defaultFileType = fileType%tmol


contains


!> Split file name into path, basename and extension
subroutine generateFileMetaInfo(Name, path, basename, extension)

   !> File name
   character(len=*), intent(in) :: name

   !> Path to the file, empty if no path found in name
   character(len=:), allocatable, intent(out) :: path

   !> Base name of the file
   character(len=:), allocatable, intent(out) :: basename

   !> Extension of the file name, empty if no extension present
   character(len=:), allocatable, intent(out) :: extension

   integer :: iDot, iSlash

   iDot = index(name, '.', back=.true.)
   iSlash = index(name, '/', back=.true.)

   ! When given a name like "Gau-3333.Ein", the basename should be "Gau-3333",
   ! so if there is no '/', we assume there is an implicit './' at the
   ! beginning of name.
   if (iSlash > 0) then
      path = name(:iSlash)
   else
      path = ''
   endif

   if (iDot > iSlash .and. iDot > 0) then
      extension = name(iDot+1:)
   else ! means point is somewhere in the path or absent
      iDot = len(name)+1
      extension = ''
   endif

   if (iDot > iSlash) then
      basename = name(iSlash+1:iDot-1)
   else
      basename = ''
   endif


end subroutine generateFileMetaInfo


subroutine generateFileName(fname, basename, extension, ftype)
   character(len=:), allocatable, intent(out) :: fname
   character(len=*), intent(in) :: basename
   character(len=*), intent(in) :: extension
   integer, intent(in) :: ftype

   if (len(basename) > 0) then
      fname = basename
   else
      fname = 'xtb'
   endif

   if (len(extension) > 0) then
      fname = fname//'.'//extension
   else
      select case(ftype)
      case(fileType%xyz)
         fname = fname//'.xyz'
      case(fileType%tmol)
         fname = fname//'.coord'
      case(fileType%molfile)
         fname = fname//'.mol'
      case(fileType%sdf)
         fname = fname//'.sdf'
      case(fileType%vasp)
         fname = fname//'.poscar'
      case(fileType%pdb)
         fname = fname//'.pdb'
      case(fileType%gen)
         fname = fname//'.gen'
      case(fileType%gaussian)
         fname = fname//'.ein'
      end select
   endif
end subroutine generateFileName


end module xtb_mctc_filetypes

! This file is part of xtb.
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_vertical
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment
   use xtb_vertical, only : vfukui

   use xtb_xtb_calculator, only : TxTBCalculator
   use xtb_main_setup, only : newXTBCalculator, newWavefunction
   implicit none
   private

   public :: collect_fukui


contains

!> Collect all exported unit tests
subroutine collect_fukui(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("gfn1", test_gfn1_fukui), &
      new_unittest("gfn2", test_gfn2_fukui) &
      ]

end subroutine collect_fukui

subroutine test_gfn1_fukui(error)
   type(error_type), allocatable, intent(out) :: error
   integer, parameter :: nat = 4
   real(wp),parameter :: thr = 1.0e-2_wp
   character(len=*), parameter :: sym(nat) = ["B", "F", "F", "F"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & -4.41826178485383_wp, 2.18219865869875_wp, -0.29163266946828_wp, &
      & -3.14927320876938_wp, 1.86405526998014_wp,  1.78831473195343_wp, &
      & -4.31209733618080_wp, 4.33072818478984_wp, -1.47918413760343_wp, &
      & -5.79274623699377_wp, 0.35153057534898_wp, -1.18447939588312_wp], &
      & shape(xyz))
   real(wp), parameter :: fukui_ref(3, nat) = reshape([ &
      &  -0.471_wp, -0.150_wp, -0.310_wp, &
      &  -0.176_wp, -0.283_wp, -0.230_wp, &
      &  -0.176_wp, -0.283_wp, -0.230_wp, &
      &  -0.176_wp, -0.283_wp, -0.230_wp], &
     &  shape(fukui_ref))
   !real(wp), parameter :: step = 1.0e-6_wp

   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   integer :: i,j
   real(wp) :: energy, sigma(3, 3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:), fukui(:,:)

   call init(env)
   call init(mol, sym, xyz)

   allocate(gradient(3,mol%n), fukui(3,mol%n))

   call newXTBCalculator(env, mol, calc, method=1)
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 1, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call vfukui(env, mol, chk, calc, fukui)

   do i = 1, size(fukui_ref, 2)
      do j = 1, size(fukui_ref, 1)
         call check(error, fukui(j, i), fukui_ref(j, i), thr=thr)
      end do
   end do

end subroutine test_gfn1_fukui

subroutine test_gfn2_fukui(error)
   type(error_type), allocatable, intent(out) :: error
   integer, parameter :: nat = 4
   real(wp),parameter :: thr = 1.0e-2_wp
   character(len=*), parameter :: sym(nat) = ["B", "F", "F", "F"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & -4.41826178485383_wp, 2.18219865869875_wp, -0.29163266946828_wp, &
      & -3.14927320876938_wp, 1.86405526998014_wp,  1.78831473195343_wp, &
      & -4.31209733618080_wp, 4.33072818478984_wp, -1.47918413760343_wp, &
      & -5.79274623699377_wp, 0.35153057534898_wp, -1.18447939588312_wp], &
      & shape(xyz))
   real(wp), parameter :: fukui_ref(3, nat) = reshape([ &
      &  -0.300_wp, 0.005_wp, -0.148_wp, &
      &  -0.233_wp, -0.335_wp, -0.284_wp, &
      &  -0.233_wp, -0.335_wp, -0.284_wp, &
      &  -0.233_wp, -0.335_wp, -0.284_wp], &
     &  shape(fukui_ref))

   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TEnvironment) :: env
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   integer :: i,j
   real(wp) :: energy, sigma(3, 3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:), fukui(:,:)

   call init(env)
   call init(mol, sym, xyz)

   allocate(gradient(3,mol%n), fukui(3,mol%n))

   call newXTBCalculator(env, mol, calc, method=2)
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 1, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call vfukui(env, mol, chk, calc, fukui)

   do i = 1, size(fukui_ref, 2)
      do j = 1, size(fukui_ref, 1)
         call check(error, fukui(j, i), fukui_ref(j, i), thr=thr)
      end do
   end do

end subroutine test_gfn2_fukui

end module test_vertical

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> D3 van-der-Waals radii
module xtb_param_vdwradd3
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   use xtb_mctc_symbols, only : toNumber
   implicit none
   private

   public :: getVanDerWaalsRadD3, vanDerWaalsRadD3


   !> Get van-der-Waals Rad for a species
   interface getVanDerWaalsRadD3
      module procedure :: getVanDerWaalsRadD3Symbol
      module procedure :: getVanDerWaalsRadD3Number
   end interface getVanDerWaalsRadD3


   !> D3 pairwise van-der-Waals radii (only homoatomic pairs present here)
   real(wp), parameter :: vanDerWaalsRadD3(1:94) = aatoau * [&
      & 1.09155_wp, 0.86735_wp, 1.74780_wp, 1.54910_wp, &
      & 1.60800_wp, 1.45515_wp, 1.31125_wp, 1.24085_wp, &
      & 1.14980_wp, 1.06870_wp, 1.85410_wp, 1.74195_wp, &
      & 2.00530_wp, 1.89585_wp, 1.75085_wp, 1.65535_wp, &
      & 1.55230_wp, 1.45740_wp, 2.12055_wp, 2.05175_wp, &
      & 1.94515_wp, 1.88210_wp, 1.86055_wp, 1.72070_wp, &
      & 1.77310_wp, 1.72105_wp, 1.71635_wp, 1.67310_wp, &
      & 1.65040_wp, 1.61545_wp, 1.97895_wp, 1.93095_wp, &
      & 1.83125_wp, 1.76340_wp, 1.68310_wp, 1.60480_wp, &
      & 2.30880_wp, 2.23820_wp, 2.10980_wp, 2.02985_wp, &
      & 1.92980_wp, 1.87715_wp, 1.78450_wp, 1.73115_wp, &
      & 1.69875_wp, 1.67625_wp, 1.66540_wp, 1.73100_wp, &
      & 2.13115_wp, 2.09370_wp, 2.00750_wp, 1.94505_wp, &
      & 1.86900_wp, 1.79445_wp, 2.52835_wp, 2.59070_wp, &
      & 2.31305_wp, 2.31005_wp, 2.28510_wp, 2.26355_wp, &
      & 2.24480_wp, 2.22575_wp, 2.21170_wp, 2.06215_wp, &
      & 2.12135_wp, 2.07705_wp, 2.13970_wp, 2.12250_wp, &
      & 2.11040_wp, 2.09930_wp, 2.00650_wp, 2.12250_wp, &
      & 2.04900_wp, 1.99275_wp, 1.94775_wp, 1.87450_wp, &
      & 1.72280_wp, 1.67625_wp, 1.62820_wp, 1.67995_wp, &
      & 2.15635_wp, 2.13820_wp, 2.05875_wp, 2.00270_wp, &
      & 1.93220_wp, 1.86080_wp, 2.53980_wp, 2.46470_wp, &
      & 2.35215_wp, 2.21260_wp, 2.22970_wp, 2.19785_wp, &
      & 2.17695_wp, 2.21705_wp]


contains


!> Get van-der-Waals radius for species with a given symbol
elemental function getVanDerWaalsRadD3Symbol(symbol) result(rad)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> van-der-Waals radius
   real(wp) :: rad

   rad = getVanDerWaalsRadD3(toNumber(symbol))

end function getVanDerWaalsRadD3Symbol


!> Get van-der-Waals radius for species with a given atomic number
elemental function getVanDerWaalsRadD3Number(number) result(rad)

   !> Atomic number
   integer, intent(in) :: number

   !> van-der-Waals radius
   real(wp) :: rad

   if (number > 0 .and. number <= size(vanDerWaalsRadD3, dim=1)) then
      rad = vanDerWaalsRadD3(number)
   else
      rad = -1.0_wp
   end if

end function getVanDerWaalsRadD3Number


end module xtb_param_vdwradd3

! This file is part of xtb.
!
! Copyright (C) 2021 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Neighbourlists for the GFN-FF
module xtb_gfnff_neighbourlist
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: TGFFNeighbourList, new


   type :: TGFFNeighbourList
      logical :: initialized = .false.
      integer :: nhb1
      integer :: nhb2
      integer :: nxb
      !> atomic charges (obtained from EEQ)
      real(wp), allocatable :: q(:)
      !> atom xyz, used to check for HB list update
      real(wp), allocatable :: hbrefgeo(:, :)
      !> HBs loose
      integer, allocatable :: hblist1(:, :)
      real(wp), allocatable :: hbe1(:) ! energies of HB bonds
      !> HBs bonded
      integer, allocatable :: hblist2(:, :)
      real(wp), allocatable :: hbe2(:)
      !> XBs
      integer, allocatable :: hblist3(:, :)
      real(wp), allocatable :: hbe3(:)
   end type TGFFNeighbourList

   interface new
      module procedure :: newGFFNeighbourList
   end interface


contains


subroutine newGFFNeighbourList(self, n, nhb1, nhb2, nxb)
   type(TGFFNeighbourList), intent(out) :: self
   integer, intent(in) :: n
   integer, intent(in) :: nhb1
   integer, intent(in) :: nhb2
   integer, intent(in) :: nxb
   self%initialized = .true.
   self%nhb1 = nhb1
   self%nhb2 = nhb2
   self%nxb = nxb
   allocate(self%q(n), source=0.0_wp)
   allocate(self%hbrefgeo(3, n), source=0.0_wp)
   allocate(self%hblist1(3, self%nhb1), source=0)
   allocate(self%hblist2(3, self%nhb2), source=0)
   allocate(self%hblist3(3, self%nxb), source=0)
   allocate(self%hbe1(self%nhb1), source=0.0_wp)
   allocate(self%hbe2(self%nhb2), source=0.0_wp)
   allocate(self%hbe3(self%nxb), source=0.0_wp)
end subroutine newGFFNeighbourList


end module xtb_gfnff_neighbourlist

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
! Copyright (C) 2020, NVIDIA CORPORATION. All rights reserved.
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Wrapper for eigensolver routines
module xtb_mctc_lapack_eigensolve
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_mctc_lapack_geneigval, only : lapack_sygvd
   use xtb_mctc_lapack_trf, only : mctc_potrf
   use xtb_type_environment, only : TEnvironment
#ifdef USE_CUSOLVER
   use xtb_mctc_global
   use cusolverDn
#endif
   implicit none
   private

   public :: TEigenSolver, init


   type :: TEigenSolver
      private
      integer :: n
      integer, allocatable :: iwork(:)
      real(sp), allocatable :: swork(:)
      real(sp), allocatable :: sbmat(:, :)
      real(dp), allocatable :: dwork(:)
      real(dp), allocatable :: dbmat(:, :)
#ifdef USE_CUSOLVER
      integer :: lwork
#endif
   contains
      generic :: solve => sgen_solve, dgen_solve
      procedure :: sgen_solve => mctc_ssygvd
      procedure :: dgen_solve => mctc_dsygvd
   end type TEigenSolver


   interface init
      module procedure :: initSEigenSolver
      module procedure :: initDEigenSolver
   end interface init


contains


subroutine initSEigenSolver(self, env, bmat)
   character(len=*), parameter :: source = 'mctc_lapack_sygvd'
   class(TEigenSolver), intent(out) :: self
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: bmat(:, :)

   self%n = size(bmat, 1)

   allocate(self%swork(1 + 6*self%n + 2*self%n**2))
   allocate(self%iwork(3 + 5*self%n))

   self%sbmat = bmat
   ! Check for Cholesky factorisation
   call mctc_potrf(env, self%sbmat)

end subroutine initSEigenSolver


subroutine initDEigenSolver(self, env, bmat)
   character(len=*), parameter :: source = 'mctc_lapack_sygvd'
   class(TEigenSolver), intent(out) :: self
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: bmat(:, :)
#ifdef USE_CUSOLVER
   integer :: istat, lwork
   ! dummy is only a dummy argument used to query the workspace size needed
   ! for cuSolverDnDsygvd -- it is okay to pass an empty array to cuSolverDnDsygvd_bufferSize
   real(dp) :: dummy(:) 
#endif

   self%n = size(bmat, 1)

#ifdef USE_CUSOLVER
   istat = cusolverDnDsygvd_bufferSize(cusolverDnH, CUSOLVER_EIG_TYPE_1, &
     CUSOLVER_EIG_MODE_VECTOR, CUBLAS_FILL_MODE_UPPER, self%n, dummy,    &
     self%n, dummy, self%n, dummy, lwork)
   if (istat /= 0) then
      call env%error("failed to get dygvd buffer size", source)
   end if

   self%lwork = lwork
   allocate(self%dwork(lwork))
#else
   allocate(self%dwork(1 + 6*self%n + 2*self%n**2))
   allocate(self%iwork(3 + 5*self%n))
#endif

   self%dbmat = bmat
   ! Check for Cholesky factorisation
   call mctc_potrf(env, self%dbmat)

end subroutine initDEigenSolver


subroutine mctc_ssygvd(self, env, amat, bmat, eval)
   character(len=*), parameter :: source = 'mctc_lapack_sygvd'
   class(TEigenSolver), intent(inout) :: self
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(out) :: eval(:)
   integer :: info, lswork, liwork

   self%sbmat(:, :) = bmat

   lswork = size(self%swork)
   liwork = size(self%iwork)
   call lapack_sygvd(1, 'v', 'u', self%n, amat, self%n, self%sbmat, self%n, eval, &
      & self%swork, lswork, self%iwork, liwork, info)

   if (info /= 0) then
      call env%error("Failed to solve eigenvalue problem", source)
   end if

end subroutine mctc_ssygvd


subroutine mctc_dsygvd(self, env, amat, bmat, eval)
   character(len=*), parameter :: source = 'mctc_lapack_sygvd'
   class(TEigenSolver), intent(inout) :: self
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(out) :: eval(:)
   integer :: info, ldwork, liwork
#ifdef USE_CUSOLVER
   integer :: istat
#endif

   self%dbmat(:, :) = bmat

#ifdef USE_CUSOLVER
   !$acc enter data copyin(amat, self%dbmat, eval, info) create(self%dwork)

   !$acc host_data use_device(amat, self%dbmat, eval, self%dwork, info)
   istat = cusolverDnDsygvd(cusolverDnH, CUSOLVER_EIG_TYPE_1, &
     CUSOLVER_EIG_MODE_VECTOR, CUBLAS_FILL_MODE_UPPER, self%n, amat, self%n, &
     self%dbmat, self%n, eval, self%dwork, self%lwork, info)
   !$acc end host_data

   !$acc exit data copyout(amat, self%dbmat, eval, info) delete(self%dwork)

   if (istat /= 0) then
      call env%error("cuSovlerDnDsygvd failed", source)
   end if
#else
   ldwork = size(self%dwork)
   liwork = size(self%iwork)
   call lapack_sygvd(1, 'v', 'u', self%n, amat, self%n, self%dbmat, self%n, eval, &
      & self%dwork, ldwork, self%iwork, liwork, info)
#endif

   if (info /= 0) then
      call env%error("Failed to solve eigenvalue problem", source)
   end if

end subroutine mctc_dsygvd


end module xtb_mctc_lapack_eigensolve

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


c     real(wp) a(100),e(10),z(10,10),aux1(20),aux2(20)
c     a(1)=0.
c     a(2)=1.
c     a(3)=0.
c     a(4)=0.
c     a(5)=1.
c     a(6)=0.
c     n=3
c     m=3
c     call rsp (10,a,n,n,e,z,aux1,aux2)
c     do i=1,n
c        write(*,'(f10.5,5x,3F12.6)') e(i), (z(j,i)      ,j=1,n)
c     enddo
c     end

      SUBROUTINE RSP(A,N,MATZ,W,Z)
         use xtb_mctc_accuracy, only : wp
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION A(n*(n+1)/2),  W(n), Z(n,n)  
      DIMENSION :: FV1(2*n),FV2(2*n)
*******************************************************************
*
*   EISPACK DIAGONALIZATION ROUTINES: TO FIND THE EIGENVALUES AND
*           EIGENVECTORS (IF DESIRED) OF A REAL SYMMETRIC PACKED MATRIX.
* ON INPUT-      N  IS THE ORDER OF THE MATRIX  A,
*                A  CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
*                   PACKED MATRIX STORED ROW-WISE,
*             MATZ  IS AN INTEGER VARIABLE SET EQUAL TO ZERO IF ONLY
*                   EIGENVALUES ARE DESIRED,  OTHERWISE IT IS SET TO
*                   ANY NON-ZERO INTEGER FOR BOTH EIGENVALUES AND
*                   EIGENVECTORS.
* ON OUTPUT-     W  CONTAINS THE EIGENVALUES IN ASCENDING ORDER,
*                Z  CONTAINS THE EIGENVECTORS IF MATZ IS NOT ZERO,
*
*******************************************************************
* THIS SUBROUTINE WAS CHOSEN AS BEING THE MOST RELIABLE. (JJPS)
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
      real(wp) esp,eta

      if(n.eq.1)then
         Z(1,1)=1.0d0 
         W(1)=A(1)
         return
      endif

c     CALL EPSETA(EPS,ETA)
c     write(*,*) eps,eta
      eps=1.000000000000000D-016 
      eta=1.000000000000000D-039
      
      NV=(N*(N+1))/2
      NM=N 
      CALL  TRED3(N,NV,A,W,FV1,FV2,EPS,EPS)
      IF (MATZ .NE. 0) GO TO 10
C     ********** FIND EIGENVALUES ONLY **********
      CALL  TQLRAT(N,W,FV2,IERR,EPS)
      GO TO 40
C     ********** FIND BOTH EIGENVALUES AND EIGENVECTORS **********
   10 DO 30    I = 1, N
C
         DO 20    J = 1, N
            Z(J,I)=0.0D0
   20    CONTINUE
C
         Z(I,I)=1.0D0
   30 CONTINUE
C
      CALL  TQL2(NM,N,W,FV1,Z,IERR,EPS)
      IF (IERR .NE. 0) GO TO 40
      CALL  TRBAK3(NM,N,NV,A,N,Z)
C     ********** LAST CARD OF RSP **********
   40 RETURN
      END

      SUBROUTINE EPSETA(EPS,ETA)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C     COMPUTE AND RETURN ETA, THE SMALLEST REPRESENTABLE NUMBER,
C     AND EPS IS THE SMALLEST NUMBER FOR WHICH 1+EPS.NE.1.
C
C
      ETA = 1.D0
   10 IF((ETA/2.D0).EQ.0.D0) GOTO 20
      IF(ETA.LT.1.D-38) GOTO 20
      ETA = ETA / 2.D0
      GOTO 10
   20 EPS = 1.D0
   30 IF((1.D0+(EPS/2.D0)).EQ.1.D0) GOTO 40
      IF(EPS.LT.1.D-17) GOTO 40
      EPS = EPS / 2.D0
      GOTO 30
   40 RETURN
      END

      SUBROUTINE TQL2(NM,N,D,E,Z,IERR,EPS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION D(*), E(*), Z(NM,*)
C               ----- SUPPORTING PACKAGE FUNCTIONS -----
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TQL2,
C     NUM. MATH. 11, 293-306(1968) BY BOWDLER, MARTIN, REINSCH, AND
C     WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 227-240(1971).
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES AND EIGENVECTORS
C     OF A SYMMETRIC TRIDIAGONAL MATRIX BY THE QL METHOD.
C     THE EIGENVECTORS OF A FULL SYMMETRIC MATRIX CAN ALSO
C     BE FOUND IF  TRED2  HAS BEEN USED TO REDUCE THIS
C     FULL MATRIX TO TRIDIAGONAL FORM.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE INPUT MATRIX
C          IN ITS LAST N-1 POSITIONS.  E(1) IS ARBITRARY,
C
C        Z CONTAINS THE TRANSFORMATION MATRIX PRODUCED IN THE
C          REDUCTION BY  TRED2, IF PERFORMED.  IF THE EIGENVECTORS
C          OF THE TRIDIAGONAL MATRIX ARE DESIRED, Z MUST CONTAIN
C          THE IDENTITY MATRIX.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT BUT
C          UNORDERED FOR INDICES 1,2,...,IERR-1,
C
C        E HAS BEEN DESTROYED,
C
C        Z CONTAINS ORTHONORMAL EIGENVECTORS OF THE SYMMETRIC
C          TRIDIAGONAL (OR FULL) MATRIX.  IF AN ERROR EXIT IS MADE,
C          Z CONTAINS THE EIGENVECTORS ASSOCIATED WITH THE STORED
C          EIGENVALUES,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C
      IERR = 0
      IF (N .EQ. 1) GO TO 160
C
      DO 10   I = 2, N
   10 E(I-1) = E(I)
C
      F=0.0D0
      B=0.0D0
      E(N)=0.0D0
C
      DO 110   L = 1, N
         J = 0
         H=EPS*(ABS (D(L))+ABS (E(L)))
         IF (B .LT. H) B=H
C     ********** LOOK FOR SMALL SUB-DIAGONAL ELEMENT **********
         DO 20   M = L, N
            IF (ABS (E(M)).LE.B)  GO TO 30
C     ********** E(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
   20    CONTINUE
C
   30    IF (M .EQ. L) GO TO 100
   40    IF (J .EQ. 30) GO TO 150
         J = J + 1
C     ********** FORM SHIFT **********
         L1 = L + 1
         G = D(L)
         P=(D(L1)-G)/(2.0D0*E(L))
         R=SQRT (P*P+1.0D0)
         D(L)=E(L)/(P+SIGN (R,P))
         H = G - D(L)
C
         DO 50   I = L1, N
   50    D(I) = D(I) - H
C
         F = F + H
C     ********** QL TRANSFORMATION **********
         P = D(M)
         C=1.0D0
         S=0.0D0
         MML = M - L
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
         DO 90   II = 1, MML
            I = M - II
            G = C * E(I)
            H = C * P
            IF (ABS (P).LT.ABS (E(I)))  GO TO 60
            C = E(I) / P
            R=SQRT (C*C+1.0D0)
            E(I+1) = S * P * R
            S = C / R
            C=1.0D0/R
            GO TO 70
   60       C = P / E(I)
            R=SQRT (C*C+1.0D0)
            E(I+1) = S * E(I) * R
            S=1.0D0/R
            C = C * S
   70       P = C * D(I) - S * G
            D(I+1) = H + S * (C * G + S * D(I))
C     ********** FORM VECTOR **********
            DO 80   K = 1, N
               H = Z(K,I+1)
               Z(K,I+1) = S * Z(K,I) + C * H
               Z(K,I) = C * Z(K,I) - S * H
   80       CONTINUE
C
   90    CONTINUE
C
         E(L) = S * P
         D(L) = C * P
         IF (ABS (E(L)).GT.B)  GO TO 40
  100    D(L) = D(L) + F
  110 CONTINUE
C     ********** ORDER EIGENVALUES AND EIGENVECTORS **********
      DO 140   II = 2, N
         I = II - 1
         K = I
         P = D(I)
C
         DO 120   J = II, N
            IF (D(J) .GE. P) GO TO 120
            K = J
            P = D(J)
  120    CONTINUE
C
         IF (K .EQ. I) GO TO 140
         D(K) = D(I)
         D(I) = P
C
         DO 130   J = 1, N
            P = Z(J,I)
            Z(J,I) = Z(J,K)
            Z(J,K) = P
  130    CONTINUE
C
  140 CONTINUE
C
      GO TO 160
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
  150 IERR = L
  160 RETURN
C     ********** LAST CARD OF TQL2 **********
      END
      SUBROUTINE TQLRAT(N,D,E2,IERR,EPS)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION D(*), E2(*)
C               ----- SUPPORTING PACKAGE FUNCTIONS -----
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TQLRAT,
C     ALGORITHM 464, COMM. ACM 16, 689(1973) BY REINSCH.
C
C     THIS SUBROUTINE FINDS THE EIGENVALUES OF A SYMMETRIC
C     TRIDIAGONAL MATRIX BY THE RATIONAL QL METHOD.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE INPUT MATRIX,
C
C        E2 CONTAINS THE SQUARES OF THE SUBDIAGONAL ELEMENTS OF THE
C          INPUT MATRIX IN ITS LAST N-1 POSITIONS.  E2(1) IS ARBITRARY.
C
C      ON OUTPUT-
C
C        D CONTAINS THE EIGENVALUES IN ASCENDING ORDER.  IF AN
C          ERROR EXIT IS MADE, THE EIGENVALUES ARE CORRECT AND
C          ORDERED FOR INDICES 1,2,...IERR-1, BUT MAY NOT BE
C          THE SMALLEST EIGENVALUES,
C
C        E2 HAS BEEN DESTROYED,
C
C        IERR IS SET TO
C          ZERO       FOR NORMAL RETURN,
C          J          IF THE J-TH EIGENVALUE HAS NOT BEEN
C                     DETERMINED AFTER 30 ITERATIONS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C
      IERR = 0
      IF (N .EQ. 1) GO TO 140
C
      DO 10   I = 2, N
   10 E2(I-1) = E2(I)
C
      F=0.0D0
      B=0.0D0
      E2(N)=0.0D0
C
      DO 120   L = 1, N
         J = 0
         H=EPS*(ABS (D(L))+SQRT (E2(L)))
         IF (B .GT. H) GO TO 20
         B = H
         C = B * B
C     ********** LOOK FOR SMALL SQUARED SUB-DIAGONAL ELEMENT **********
   20    DO 30   M = L, N
            IF (E2(M) .LE. C) GO TO 40
C     ********** E2(N) IS ALWAYS ZERO, SO THERE IS NO EXIT
C                THROUGH THE BOTTOM OF THE LOOP **********
   30    CONTINUE
C
   40    IF (M .EQ. L) GO TO 80
   50    IF (J .EQ. 30) GO TO 130
         J = J + 1
C     ********** FORM SHIFT **********
         L1 = L + 1
         S=SQRT (E2(L))
         G = D(L)
         P=(D(L1)-G)/(2.0D0*S)
         R=SQRT (P*P+1.0D0)
         D(L)=S/(P+SIGN (R,P))
         H = G - D(L)
C
         DO 60   I = L1, N
   60    D(I) = D(I) - H
C
         F = F + H
C     ********** RATIONAL QL TRANSFORMATION **********
         G = D(M)
         IF (G.EQ.0.0D0) G=B
         H = G
         S=0.0D0
         MML = M - L
C     ********** FOR I=M-1 STEP -1 UNTIL L DO -- **********
         DO 70   II = 1, MML
            I = M - II
            P = G * H
            R = P + E2(I)
            E2(I+1) = S * R
            S = E2(I) / R
            D(I+1) = H + S * (H + D(I))
            G = D(I) - E2(I) / G
            IF (G.EQ.0.0D0) G=B
            H = G * P / R
   70    CONTINUE
C
         E2(L) = S * G
         D(L) = H
C     ********** GUARD AGAINST UNDERFLOW IN CONVERGENCE TEST **********
         IF (H.EQ.0.0D0)  GO TO 80
         IF (ABS (E2(L)).LE.ABS (C/H))  GO TO 80
         E2(L) = H * E2(L)
         IF (E2(L).NE.0.0D0)  GO TO 50
   80    P = D(L) + F
C     ********** ORDER EIGENVALUES **********
         IF (L .EQ. 1) GO TO 100
C     ********** FOR I=L STEP -1 UNTIL 2 DO -- **********
         DO 90   II = 2, L
            I = L + 2 - II
            IF (P .GE. D(I-1)) GO TO 110
            D(I) = D(I-1)
   90    CONTINUE
C
  100    I = 1
  110    D(I) = P
  120 CONTINUE
C
      GO TO 140
C     ********** SET ERROR -- NO CONVERGENCE TO AN
C                EIGENVALUE AFTER 30 ITERATIONS **********
  130 IERR = L
  140 RETURN
C     ********** LAST CARD OF TQLRAT **********
      END
      SUBROUTINE TRBAK3(NM,N,NV,A,M,Z)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION A(*), Z(NM,*)
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TRBAK3,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS SUBROUTINE FORMS THE EIGENVECTORS OF A REAL SYMMETRIC
C     MATRIX BY BACK TRANSFORMING THOSE OF THE CORRESPONDING
C     SYMMETRIC TRIDIAGONAL MATRIX DETERMINED BY  TRED3.
C
C     ON INPUT-
C
C        NM MUST BE SET TO THE ROW DIMENSION OF TWO-DIMENSIONAL
C          ARRAY PARAMETERS AS DECLARED IN THE CALLING PROGRAM
C          DIMENSION STATEMENT,
C
C        N IS THE ORDER OF THE MATRIX,
C
C        NV MUST BE SET TO THE DIMENSION OF THE ARRAY PARAMETER A
C          AS DECLARED IN THE CALLING PROGRAM DIMENSION STATEMENT,
C
C        A CONTAINS INFORMATION ABOUT THE ORTHOGONAL TRANSFORMATIONS
C          USED IN THE REDUCTION BY  TRED3  IN ITS FIRST
C          N*(N+1)/2 POSITIONS,
C
C        M IS THE NUMBER OF EIGENVECTORS TO BE BACK TRANSFORMED,
C
C        Z CONTAINS THE EIGENVECTORS TO BE BACK TRANSFORMED
C          IN ITS FIRST M COLUMNS.
C
C     ON OUTPUT-
C
C        Z CONTAINS THE TRANSFORMED EIGENVECTORS
C          IN ITS FIRST M COLUMNS.
C
C     NOTE THAT TRBAK3 PRESERVES VECTOR EUCLIDEAN NORMS.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
      IF (M .EQ. 0) GO TO 50
      IF (N .EQ. 1) GO TO 50
C
      DO 40   I = 2, N
         L = I - 1
         IZ = (I * L) / 2
         IK = IZ + I
         H = A(IK)
         IF (H.EQ.0.0D0)  GO TO 40
C
         DO 30   J = 1, M
            S=0.0D0
            IK = IZ
C
            DO 10   K = 1, L
               IK = IK + 1
               S = S + A(IK) * Z(K,J)
   10       CONTINUE
C     ********** DOUBLE DIVISION AVOIDS POSSIBLE UNDERFLOW **********
            S = (S / H) / H
            IK = IZ
C
            DO 20   K = 1, L
               IK = IK + 1
               Z(K,J) = Z(K,J) - S * A(IK)
   20       CONTINUE
C
   30    CONTINUE
C
   40 CONTINUE
C
   50 RETURN
C     ********** LAST CARD OF TRBAK3 **********
      END
      SUBROUTINE TRED3(N,NV,A,D,E,E2,EPS,ETA)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C               ===== PROCESSED BY AUGMENT, VERSION 4N =====
C     APPROVED FOR VAX 11/780 ON MAY 6,1980.  J.D.NEECE
C               ----- LOCAL VARIABLES -----
C               ----- GLOBAL VARIABLES -----
      DIMENSION A(*), D(*), E(*), E2(*)
C               ----- SUPPORTING PACKAGE FUNCTIONS -----
C               ===== TRANSLATED PROGRAM =====
C
C
C     THIS SUBROUTINE IS A TRANSLATION OF THE ALGOL PROCEDURE TRED3,
C     NUM. MATH. 11, 181-195(1968) BY MARTIN, REINSCH, AND WILKINSON.
C     HANDBOOK FOR AUTO. COMP., VOL.II-LINEAR ALGEBRA, 212-226(1971).
C
C     THIS SUBROUTINE REDUCES A REAL SYMMETRIC MATRIX, STORED AS
C     A ONE-DIMENSIONAL ARRAY, TO A SYMMETRIC TRIDIAGONAL MATRIX
C     USING ORTHOGONAL SIMILARITY TRANSFORMATIONS.
C
C     ON INPUT-
C
C        N IS THE ORDER OF THE MATRIX,
C
C        NV MUST BE SET TO THE DIMENSION OF THE ARRAY PARAMETER A
C          AS DECLARED IN THE CALLING PROGRAM DIMENSION STATEMENT,
C
C        A CONTAINS THE LOWER TRIANGLE OF THE REAL SYMMETRIC
C          INPUT MATRIX, STORED ROW-WISE AS A ONE-DIMENSIONAL
C          ARRAY, IN ITS FIRST N*(N+1)/2 POSITIONS.
C
C     ON OUTPUT-
C
C        A CONTAINS INFORMATION ABOUT THE ORTHOGONAL
C          TRANSFORMATIONS USED IN THE REDUCTION,
C
C        D CONTAINS THE DIAGONAL ELEMENTS OF THE TRIDIAGONAL MATRIX,
C
C        E CONTAINS THE SUBDIAGONAL ELEMENTS OF THE TRIDIAGONAL
C          MATRIX IN ITS LAST N-1 POSITIONS.  E(1) IS SET TO ZERO,
C
C        E2 CONTAINS THE SQUARES OF THE CORRESPONDING ELEMENTS OF E.
C          E2 MAY COINCIDE WITH E IF THE SQUARES ARE NOT NEEDED.
C
C     QUESTIONS AND COMMENTS SHOULD BE DIRECTED TO B. S. GARBOW,
C     APPLIED MATHEMATICS DIVISION, ARGONNE NATIONAL LABORATORY
C
C     ------------------------------------------------------------------
C
C     ********** FOR I=N STEP -1 UNTIL 1 DO -- **********
      DO 100   II = 1, N
         I = N + 1 - II
         L = I - 1
         IZ = ( I * L ) / 2
         H=0.0D0
         SCALE=0.0D0
         DO 10   K = 1, L
            IZ = IZ + 1
            D(K) = A(IZ)
            SCALE=SCALE+ABS( D(K) )
   10    CONTINUE
C
         IF ( SCALE.NE.0.D0 ) GO TO 20
         E(I)=0.0D0
         E2(I)=0.0D0
         GO TO 90
C
   20    DO 30   K = 1, L
            D(K) = D(K) / SCALE
            H = H + D(K) * D(K)
   30    CONTINUE
C
         E2(I) = SCALE * SCALE * H
         F = D(L)
         G=-SIGN (SQRT (H),F)
         E(I) = SCALE * G
         H = H - F * G
         D(L) = F - G
         A(IZ) = SCALE * D(L)
         IF (L .EQ. 1) GO TO 90
         F=0.0D0
C
         DO 70   J = 1, L
            G=0.0D0
            JK = (J * (J-1)) / 2
C     ********** FORM ELEMENT OF A*U **********
            K = 0
   40       K = K + 1
            JK = JK + 1
            G = G + A(JK) * D(K)
            IF ( K .LT. J ) GO TO 40
            IF ( K .EQ. L ) GO TO 60
   50       JK = JK + K
            K = K + 1
            G = G + A(JK) * D(K)
            IF ( K .LT. L ) GO TO 50
C     ********** FORM ELEMENT OF P **********
   60       CONTINUE
            E(J) = G / H
            F = F + E(J) * D(J)
   70    CONTINUE
C
         HH = F / (H + H)
         JK = 0
C     ********** FORM REDUCED A **********
         DO 80   J = 1, L
            F = D(J)
            G = E(J) - HH * F
            E(J) = G
C
            DO 80   K = 1, J
               JK = JK + 1
               A(JK) = A(JK) - F * E(K) - G * D(K)
   80    CONTINUE
C
   90    D(I) = A(IZ+1)
         A(IZ+1)=SCALE*SQRT (H)
  100 CONTINUE
C
      RETURN
C     ********** LAST CARD OF TRED3 **********
      END

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine constralltors(n,at,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_scanparam
   use xtb_intmodes
   implicit none
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   real(wp),intent(in) :: xyz(3,n)

   real(wp) :: phi,valijkl,a1,a2
   integer  :: i,j,k,ii,jj,kk,ll,irm
   integer  :: nb(0:20,n),list(n,n)

   call neighbor(n,xyz,at,nb)
   list = 0
   do i=1,n
      k=nb(20,i)
      do j=1,k
         list(nb(j,i),i)=1
      enddo
   enddo

   irm=0
   k=0
   do i=1,n-1
      if(nb(20,i).le.1) cycle
      do j=i+1,n
         if(nb(20,j).le.1) cycle
         if(list(j,i).eq.1)then
            do ii=1,nb(20,i)
               kk=nb(ii,i)
               do jj=1,nb(20,j)
                  ll=nb(jj,j)
                  if(kk.eq.j) cycle
                  if(ll.eq.i) cycle
                  call BANGLE(XYZ,I,J,ll,A1)       ! avoid linear cas
                  call BANGLE(XYZ,J,I,KK,A2)
                  if(abs(pi-a1).lt.0.2.or.abs(pi-a2).lt.0.2)then
                     irm=irm+1
                     cycle
                  endif
                  k=k+1
                  atconstr(1,k)=kk
                  atconstr(2,k)=i
                  atconstr(3,k)=j
                  atconstr(4,k)=ll
                  phi=valijkl(n,xyz,kk,i,j,ll)
                  valconstr(k)=phi
                  !                    write(*,*) atconstr(1:4,k),phi*180./3.14159
               enddo
            enddo
         endif
      enddo
   enddo
   write(*,*) 'constraining ',k,' torsions'
   write(*,*) irm,' near linear torsions not included'
   nconstr=nconstr+k

end subroutine constralltors

subroutine constrallangles(n,at,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_scanparam
   implicit none
   integer n, at(n)
   real(wp) xyz(3,n)

   real(wp) phi,valijkl,a1,a2
   integer i,j,k,ii,jj,kk,ll,irm,nb(0:20,n),list(n,n)

   call neighbor(n,xyz,at,nb)
   list = 0
   do i=1,n
      k=nb(20,i)
      do j=1,k
         list(nb(j,i),i)=1
      enddo
   enddo

   irm=0
   k=0
   do i=1,n
      if(nb(20,i).le.1) cycle
      do ii=1,nb(20,i)
         kk=nb(ii,i)
         do jj=1,nb(20,i)
            ll=nb(jj,i)
            call bangl(xyz,kk,i,ll,phi)
            if(abs(pi-phi).lt.0.2)then
               irm=irm+1
               cycle
            endif
            k=k+1
            atconstr(1,k)=kk
            atconstr(2,k)=i
            atconstr(3,k)=ll
            valconstr(k)=phi
            !              write(*,*) atconstr(1:3,k),phi*180./3.14159
         enddo
      enddo
   enddo
   write(*,*) 'constraining ',k,' angles'
   write(*,*) irm,' near linear angles not included'
   nconstr=nconstr+k

end subroutine constrallangles

subroutine constrallbonds(nat,at,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autoaa
   use xtb_param_atomicrad, only : atomicRad
   use xtb_scanparam
   implicit none
   integer nat,at(nat)
   real(wp) xyz(3,nat)

   real(wp) rco,rij
   integer i,j

   do i = 1, nat
      do j =1, i
         if(i.eq.j) cycle
         rij=sqrt(sum((xyz(:,i)-xyz(:,j))**2))
         rco=(atomicRad(at(j))+atomicRad(at(i)))*autoaa
         if(0.52917726*rij.lt.1.2*rco)then
            nconstr = nconstr + 1
            atconstr(1,nconstr) = i
            atconstr(2,nconstr) = j
            valconstr(nconstr)  = rij
            !              write(*,*) at(i),at(j),rco,0.52917726*rij
         endif
      enddo
   enddo

   write(*,*) 'constraining ',nconstr,' bonds'

end subroutine constrallbonds

subroutine constrpot(nat,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_scanparam
   use xtb_splitparam
   implicit none
   integer nat,at(nat)
   real(wp) e
   real(wp) xyz(3,nat)
   real(wp) g(3,nat)

   integer i,j,k,l,kk
   real(wp)rij(3),dum,r0,ffc,vp(3),ra(3),rb(3)
   real(wp)va(3),vb(3),vc(3),vab(3),vcb(3),deda(3),dedc(3),dedb(3)
   real(wp)dda(3),ddb(3),ddc(3),ddd(3)
   real(wp)c0,rab2,rcb2,theta,dt,rmul1,rmul2,deddt,rp,cosa,ea,vlen,d
   real(wp)c1,phi0,phi,dphi1,x1cos,x1sin,dij,valijkl,ff,dum1,dum2
   real(wp)dx,dy,dz,termx,termy,termz,abcx,abcy,abcz,a,z0,expo,expom1

   if(nconstr.eq.0) return

   ffc=fcconstr

   do kk=1,nconstr
      ! CMA distance to valconstr (usually=0) for atoms in fragment1
      if(atconstr(1,kk).eq.-2)then
         rb=0
         do i=1,iatf1
            a=atmass(i)
            rb(1)=rb(1)+a*xyz(1,i)
            rb(2)=rb(2)+a*xyz(2,i)
            rb(3)=rb(3)+a*xyz(3,i)
         enddo
         z0=valconstr(kk)
         ra(1)=rb(1)/massf1 - z0
         ra(2)=rb(2)/massf1 - z0
         ra(3)=rb(3)/massf1 - z0
         d=ra(1)**2+ra(2)**2+ra(3)**2
         ffc=fcconstr/dble(iatf1)
         e=e+ffc*d
         do i=1,iatf1
            ff=2.0d0*ffc*atmass(i)/massf1
            g(1,i)=g(1,i)+ra(1)*ff
            g(2,i)=g(2,i)+ra(2)*ff
            g(3,i)=g(3,i)+ra(3)*ff
         enddo
      endif
      ! Z distance for atoms in fragment2
      if(atconstr(1,kk).eq.-1)then
         ffc=0.1*fcconstr/dble(iatf2)
         z0=valconstr(kk)
         do i=1,nat
            if(splitlist(i).eq.2)then
               dz=xyz(3,i)-z0
               e=e+ffc*dz**2
               g(3,i)=g(3,i)+2.0d0*ffc*dz
            endif
         enddo
      endif
      ! CMA distance (rcma in common block for average in MD)
      if(atconstr(1,kk).eq.0)then
         expo=6.0d0
         expom1=5.0d0
         ffc=0.1*fcconstr
         r0=valconstr (kk)
         call cmafrag(nat,at,xyz,ra,rb) ! rcma in common
         d=rcma-r0
         e=e+(1./expo)*ffc*d**expo
         do i=1,nat
            dx = (ra(2)-rb(2))**2+(ra(3)-rb(3))**2
            dy = (ra(1)-rb(1))**2+(ra(3)-rb(3))**2
            dz = (ra(2)-rb(2))**2+(ra(1)-rb(1))**2
            if(splitlist(i).eq.1)then      ! fragment 1
               a  = ffc*atmass(i)/massf1
               abcx=ra(1)-rb(1)
               abcy=ra(2)-rb(2)
               abcz=ra(3)-rb(3)
               termx=sqrt(abcx**2+dx)
               termy=sqrt(abcy**2+dy)
               termz=sqrt(abcz**2+dz)
               g(1,i)=g(1,i)+a*abcx*(termx-r0)**expom1/termx
               g(2,i)=g(2,i)+a*abcy*(termy-r0)**expom1/termy
               g(3,i)=g(3,i)+a*abcz*(termz-r0)**expom1/termz
            else                          ! fragment 2
               a  = ffc*atmass(i)/massf2
               abcx=rb(1)-ra(1)
               abcy=rb(2)-ra(2)
               abcz=rb(3)-ra(3)
               termx=sqrt(abcx**2+dx)
               termy=sqrt(abcy**2+dy)
               termz=sqrt(abcz**2+dz)
               g(1,i)=g(1,i)+a*abcx*(termx-r0)**expom1/termx
               g(2,i)=g(2,i)+a*abcy*(termy-r0)**expom1/termy
               g(3,i)=g(3,i)+a*abcz*(termz-r0)**expom1/termz
            endif
         enddo
      endif
      ! length (rcma in common block for average in MD)
      if(atconstr(3,kk).eq.0.and.atconstr(1,kk).ne.0&
         &.and.atconstr(2,kk).ne.0)then
         i= atconstr(1,kk)
         j= atconstr(2,kk)
         r0=valconstr (kk)
         rij=xyz(:,j)-xyz(:,i)
         rcma=sqrt(sum(rij*rij))
         d=rcma-r0
         !           e=e+ffc*d*d
         !           ff=ffc*2.0d0*d
         dum= d**springexpo
         dum2=d**(springexpo-1.)
         e=e+ffc*dum
         ff=ffc*springexpo*dum2
         if(kk.eq.1) pmf=ff
         dum=ff/rcma
         g(1,j)=g(1,j)+dum*rij(1)
         g(1,i)=g(1,i)-dum*rij(1)
         g(2,j)=g(2,j)+dum*rij(2)
         g(2,i)=g(2,i)-dum*rij(2)
         g(3,j)=g(3,j)+dum*rij(3)
         g(3,i)=g(3,i)-dum*rij(3)
      endif
      ! bend
      if (atconstr(4,kk).eq.0.and.atconstr(3,kk).gt.0) then
         i= atconstr(1,kk)
         j= atconstr(2,kk)
         k= atconstr(3,kk)
         c0 =valconstr(kk)
         va = xyz(1:3,i)
         vb = xyz(1:3,j)
         vc = xyz(1:3,k)
         vab = va-vb
         vcb = vc-vb
         rab2 = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
         rcb2 = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
         call crprod(vcb,vab,vp)
         rp = norm2(vp)+1.d-14
         call impsc(vab,vcb,cosa)
         cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
         theta= dacos(cosa)
         dt  = theta - c0
         ea  = ffc* dt**2
         deddt = 2.d0 * ffc * dt
         e = e + ea
         call crprod(vab,vp,deda)
         rmul1 = -deddt / (rab2*rp)
         deda = deda*rmul1
         call crprod(vcb,vp,dedc)
         rmul2 =  deddt / (rcb2*rp)
         dedc = dedc*rmul2
         dedb = deda+dedc
         g(1:3,i) = g(1:3,i) + deda(1:3)
         g(1:3,j) = g(1:3,j) - dedb(1:3)
         g(1:3,k) = g(1:3,k) + dedc(1:3)
      endif
      ! dihed
      if(atconstr(4,kk).ne.0)then
         i= atconstr(1,kk)
         j= atconstr(2,kk)
         k= atconstr(3,kk)
         l= atconstr(4,kk)
         phi0 =valconstr(kk)
         phi=valijkl(nat,xyz,i,j,k,l)
         if(abs(phi-pi).lt.1.d-8.or.abs(phi).lt.1.d-8)phi=phi+1.d-8
         call dphidr(nat,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
         dphi1=phi0-phi+pi
         x1cos=cos(dphi1)
         x1sin=sin(dphi1)
         dij  =ffc*x1sin
         g(1:3,i)=g(1:3,i)+dij*dda(1:3)
         g(1:3,j)=g(1:3,j)+dij*ddb(1:3)
         g(1:3,k)=g(1:3,k)+dij*ddc(1:3)
         g(1:3,l)=g(1:3,l)+dij*ddd(1:3)
         e=e+ffc*(1.+x1cos)
      endif

   enddo

end subroutine constrpot

subroutine constrhess(nat,at,xyz0,Hess)
   use xtb_mctc_accuracy, only : wp
   use xtb_scanparam
   use xtb_constrainpot
   use xtb_fixparam
   use xtb_metadynamic
   implicit none
   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(inout) :: Hess((nat*3)*((nat*3)+1)/2)
   real(wp),intent(in)    :: xyz0(3,nat)

   integer ia,ic,ja,jc,i,j,k,n,n3,ii,jj
   real(wp) step,step2,e
   real(wp),allocatable :: gr(:,:),gl(:,:)
   real(wp),allocatable :: xyz(:,:)
   real(wp),allocatable :: h(:,:)
   allocate(gr(3,nat),gl(3,nat),xyz(3,nat),h(nat*3,nat*3))

   call qpothess2(potset%pos,nat,at,xyz0,hess)

   if(nconstr.eq.0 .and. potset%dist%n.eq.0 .and. potset%angle%n.eq.0&
      &.and. potset%dihedral%n.eq.0 ) return

   xyz=xyz0
   n =nat
   n3=3*nat
   step =0.0001
   step2=0.5d0/step
   e=0

   do ia = 1, n
      do ic = 1, 3
         ii = (ia-1)*3+ic
         xyz(ic,ia)=xyz(ic,ia)+step
         gr=0
         call constrpot(nat,at,xyz,gr,e)
         call constrain_dist    (potset%dist,    nat,at,xyz,gr,e)
         call constrain_angle   (potset%angle,   nat,at,xyz,gr,e)
         call constrain_dihedral(potset%dihedral,nat,at,xyz,gr,e)
         call metadynamic(metaset,nat,at,xyz,e,gr)
         xyz(ic,ia)=xyz(ic,ia)-2.*step
         gl=0
         call constrpot(nat,at,xyz,gl,e)
         call constrain_dist    (potset%dist,    nat,at,xyz,gl,e)
         call constrain_angle   (potset%angle,   nat,at,xyz,gl,e)
         call constrain_dihedral(potset%dihedral,nat,at,xyz,gl,e)
         call metadynamic(metaset,nat,at,xyz,e,gl)
         xyz(ic,ia)=xyz(ic,ia)+step
         do ja = 1, n
            do jc = 1, 3
               jj = (ja-1)*3 + jc
               h(jj,ii) =(gr(jc,ja) - gl(jc,ja)) * step2
            enddo
         enddo
      enddo
   enddo

   !     call prmat(6,h,3*n,3*n,'H')

   k=0
   do i=1,n3
      do j=1,i
         k=k+1
         hess(k)=hess(k)+0.5*(h(j,i)+h(i,j))
      enddo
   enddo

end subroutine

!  .....................................................................

Subroutine dthetadr(nat,xyz,j,k,i,theta,kijk,dei,dej,dek)
   use xtb_mctc_accuracy, only : wp

   !  .....................................................................
   !
   !   Input
   !   -----
   !                              __              __
   !    ra,rb          : distance ij and distnace ik
   !
   !    sinth          : sinus of angle j-i-k
   !
   !    costh          : cosinus of angle j-i-k
   !
   !
   !   Output
   !   ------
   !
   !    dei            : derivatives of the atom i
   !
   !    dej            : derivatives of the atom j
   !
   !    dek            : derivatives of the atom k
   !
   !  .....................................................................

   implicit none

   external vecnorm

   integer ic,nat,j,k,i

   real(wp) :: &
      &         ran,rbn,theta,xyz(3,nat),&
      &         ra(3),rb(3),sinth,costh,&
      &         dei(3),dej(3),dek(3),kijk,&
      &         fac,vecnorm,eps

   parameter (eps=1.d-14)

   ! ... dtheta/dri, dtheta/drj and dtheta/drk

   sinth=sin(theta)
   costh=cos(theta)

   do ic=1,3
      ra(ic)=xyz(ic,j)-xyz(ic,i)
      rb(ic)=xyz(ic,k)-xyz(ic,i)
   end do

   ran=vecnorm(ra,3,0)
   rbn=vecnorm(rb,3,0)
   if (abs(sinth).le.eps) then
      fac=sign(kijk,costh)/(ran*rbn)
   else
      fac=1.d0/(sinth*ran*rbn)
   end if

   do ic=1,3
      ! ... dedri
      dei(ic)=fac*( ra(ic)+rb(ic)-(rbn*rbn*ra(ic)+ran*ran*rb(ic))*&
         &                  costh/(ran*rbn))
      ! ... dedrj
      dej(ic)=fac*(ra(ic)*costh*rbn/ran-rb(ic))
      ! ... dedrk
      dek(ic)=fac*(rb(ic)*costh*ran/rbn-ra(ic))
   end do

End subroutine





Subroutine dphidr(nat,xyz,i,j,k,l,phi,&
      &                  dphidri,dphidrj,dphidrk,dphidrl)
   use xtb_mctc_accuracy, only : wp
   !     the torsion derivatives

   implicit none

   external vecnorm

   integer  ic,i,j,k,l,nat

   real(wp)&
      &         sinphi,cosphi,onenner,thab,thbc,&
      &         ra(3),rb(3),rc(3),rab(3),rac(3),rbc(3),rbb(3),&
      &         raa(3),rba(3),rapba(3),rapbb(3),rbpca(3),rbpcb(3),&
      &         rapb(3),rbpc(3),na(3),nb(3),nan,nbn,&
      &         dphidri(3),dphidrj(3),dphidrk(3),dphidrl(3),&
      &         xyz(3,nat),phi,vecnorm,nenner,eps,vz

   parameter (eps=1.d-14)

   cosphi=cos(phi)
   sinphi=sin(phi)
   do ic=1,3
      ra(ic)=xyz(ic,j)-xyz(ic,i)
      rb(ic)=xyz(ic,k)-xyz(ic,j)
      rc(ic)=xyz(ic,l)-xyz(ic,k)

      rapb(ic)=ra(ic)+rb(ic)
      rbpc(ic)=rb(ic)+rc(ic)
   end do

   call crossprod(ra,rb,na)
   call crossprod(rb,rc,nb)
   nan=vecnorm(na,3,0)
   nbn=vecnorm(nb,3,0)

   nenner=nan*nbn*sinphi
   if (abs(nenner).lt.eps) then
      dphidri=0
      dphidrj=0
      dphidrk=0
      dphidrl=0
      onenner=1.0d0/(nan*nbn)
   else
      onenner=1.d0/nenner
   endif

   call crossprod(na,rb,rab)
   call crossprod(nb,ra,rba)
   call crossprod(na,rc,rac)
   call crossprod(nb,rb,rbb)
   call crossprod(nb,rc,rbc)
   call crossprod(na,ra,raa)

   call crossprod(rapb,na,rapba)
   call crossprod(rapb,nb,rapbb)
   call crossprod(rbpc,na,rbpca)
   call crossprod(rbpc,nb,rbpcb)

   ! ... dphidri
   do ic=1,3
      dphidri(ic)=onenner*(cosphi*nbn/nan*rab(ic)-rbb(ic))

      ! ... dphidrj
      dphidrj(ic)=onenner*(cosphi*(nbn/nan*rapba(ic)&
         &                                +nan/nbn*rbc(ic))&
         &                        -(rac(ic)+rapbb(ic)))
      ! ... dphidrk
      dphidrk(ic)=onenner*(cosphi*(nbn/nan*raa(ic)&
         &                             +nan/nbn*rbpcb(ic))&
         &                        -(rba(ic)+rbpca(ic)))
      ! ... dphidrl
      dphidrl(ic)=onenner*(cosphi*nan/nbn*rbb(ic)-rab(ic))
   end do

End subroutine

!  .....................................................................

Subroutine domegadr&
      &           (nat,xyz,&
      &            i,j,k,l,omega,&
      &            domegadri,domegadrj,domegadrk,domegadrl)
   use xtb_mctc_accuracy, only : wp

   !     inversion derivatives
   !  .....................................................................

   implicit none

   external vecnorm

   integer  ic,i,j,k,l,nat

   real(wp)&
      &         omega,sinomega,&
      &         xyz(3,nat),onenner,vecnorm,rnn,rvn,&
      &         rn(3),rv(3),rd(3),re(3),rdme(3),rve(3),&
      &         rne(3),rdv(3),rdn(3),&
      &         rvdme(3),rndme(3),nenner,&
      &         domegadri(3),domegadrj(3),domegadrk(3),domegadrl(3),eps

   parameter (eps=1.d-14)

   sinomega=sin(omega)

   do ic=1,3
      rv(ic)=xyz(ic,l)-xyz(ic,i)
      rd(ic)=xyz(ic,k)-xyz(ic,j)
      re(ic)=xyz(ic,i)-xyz(ic,j)

      rdme(ic)=rd(ic)-re(ic)
   end do

   call crossprod(re,rd,rn)
   rvn=vecnorm(rv,3,0)
   rnn=vecnorm(rn,3,0)

   call crossprod(rv,re,rve)
   call crossprod(rn,re,rne)
   call crossprod(rd,rv,rdv)
   call crossprod(rd,rn,rdn)
   call crossprod(rv,rdme,rvdme)
   call crossprod(rn,rdme,rndme)

   nenner=rnn*rvn*cos(omega)
   if (abs(nenner).gt.eps) then
      onenner=1.d0/nenner
      do ic=1,3
         ! ... domega/dri
         domegadri(ic)=onenner*(rdv(ic)-rn(ic)-&
            &                       sinomega*(rvn/rnn*rdn(ic)-rnn/rvn*rv(ic)))

         ! ... domega/drj
         domegadrj(ic)=onenner*(rvdme(ic)-sinomega*rvn/rnn*rndme(ic))

         ! ... domega/drk
         domegadrk(ic)=onenner*(rve(ic)-sinomega*rvn/rnn*rne(ic))

         ! ... domega/drl
         domegadrl(ic)=onenner*(rn(ic)-sinomega*rnn/rvn*rv(ic))
      end do
   else
      do ic=1,3
         domegadri(ic)=0.d0
         domegadrj(ic)=0.d0
         domegadrk(ic)=0.d0
         domegadrl(ic)=0.d0
      end do
   end if

End subroutine

!  .....................................................................

real(wp) Function valijkl(nat,xyz,i,j,k,l)
   use xtb_mctc_accuracy, only : wp

   !  .....................................................................

   implicit none

   external vecnorm,valijk

   integer ic,i,j,k,l,nat

   real(wp) :: &
      &     xyz(3,nat),&
      &     eps,ra(3),rb(3),rc(3),na(3),nb(3),&
      &     rab,rbc,thab,thbc,valijk,&
      &     vecnorm,nan,nbn,rcn,snanb,deter,pi,test,&
      &     raabs,rbabs,rcabs

   parameter (eps=1.0d-14)
   data pi/3.1415926535897932384626433832795029d0/

   raabs=0.0d0
   rbabs=0.0d0
   rcabs=0.0d0
   ! ... get torsion coordinate
   do ic=1,3
      ra(ic)=xyz(ic,j)-xyz(ic,i)
      rb(ic)=xyz(ic,k)-xyz(ic,j)
      rc(ic)=xyz(ic,l)-xyz(ic,k)
      raabs=raabs+ra(ic)*ra(ic)
      rbabs=rbabs+rb(ic)*rb(ic)
      rcabs=rcabs+rc(ic)*rc(ic)
   end do
   raabs=sqrt(raabs)
   rbabs=sqrt(rbabs)
   rcabs=sqrt(rcabs)
   ! ... normalize vectors
   do ic=1,3
      ra(ic)=ra(ic)/raabs
      rb(ic)=rb(ic)/rbabs
      rc(ic)=rc(ic)/rcabs
   end do
   ! ... determinante of rb,ra,rc
   deter= ra(1)*(rb(2)*rc(3)-rb(3)*rc(2))&
      &      -ra(2)*(rb(1)*rc(3)-rb(3)*rc(1))&
      &      +ra(3)*(rb(1)*rc(2)-rb(2)*rc(1))

   call crossprod(-ra,rc,na)
   test=0.0d0
   do ic=1,3
      test=test+na(ic)*rb(ic)
   end do

   thab=valijk(nat,xyz,i,k,j)
   thbc=valijk(nat,xyz,j,l,k)
   call crossprod(ra,rb,na)
   call crossprod(rb,rc,nb)
   nan=vecnorm(na,3,1)
   nbn=vecnorm(nb,3,1)

   snanb=0.0d0
   do ic=1,3
      snanb=snanb+na(ic)*nb(ic)
   end do
   if (abs(abs(snanb)-1.d0).lt.eps) then
      snanb=sign(1.d0,snanb)
   end if

   valijkl=acos(snanb)
   if(test.lt.0.0d0) valijkl=-acos(snanb)

   ! the gradient dphir is only compatible with this subroutine
   ! if the statement below is commented out. If not, opt. and
   ! Hessian show large errors and imags. I don't understand
   ! this entirely but thats how it is.
   ! SG, Sat May 2411:41:42 CEST 2014

   !     if (deter.lt.0) then
   !        valijkl=2.d0*pi-valijkl
   !     end if

End function

!  .....................................................................

real(wp) Function valijk(nat,xyz,j,k,i)
   use xtb_mctc_accuracy, only : wp

   !  .....................................................................

   implicit none

   external vecnorm

   integer nat,j,k,i,ic

   real(wp) :: &
      &         ra(3),rb(3),rab,eps,&
      &         xyz(3,nat),vecnorm,ran,rbn

   parameter (eps=1.d-14)

   do ic=1,3
      ra(ic)=xyz(ic,j)-xyz(ic,i)
      rb(ic)=xyz(ic,k)-xyz(ic,i)
   end do

   ran=vecnorm(ra,3,1)
   rbn=vecnorm(rb,3,1)
   rab=0.d0
   do ic=1,3
      rab=rab+ra(ic)*rb(ic)
   end do

   if (abs(abs(rab)-1.d0).lt.eps) then
      rab=sign(1.d0,rab)
   end if
   valijk=acos(rab)

End function

!  .....................................................................

real(wp) Function omega (nat,xyz,i,j,k,l)
   use xtb_mctc_accuracy, only : wp

   !   Calculates the inversion angle
   !  .....................................................................

   implicit none

   external vecnorm

   integer ic,nat,i,j,k,l

   real(wp) :: &
      &        xyz(3,nat),&
      &        rd(3),re(3),rn(3),rv(3),rnv,&
      &        vecnorm,rkjn,rljn,rnn,rvn

   do ic=1,3
      re(ic)=xyz(ic,i)-xyz(ic,j)
      rd(ic)=xyz(ic,k)-xyz(ic,j)
      rv(ic)=xyz(ic,l)-xyz(ic,i)
   end do
   call crossprod(re,rd,rn)
   rnn=vecnorm(rn,3,1)
   rvn=vecnorm(rv,3,1)

   rnv=rn(1)*rv(1)+rn(2)*rv(2)+rn(3)*rv(3)
   omega=asin( rnv )

End function


!  .....................................................................

Subroutine crossprod(ra,rb,rab)
   use xtb_mctc_accuracy, only : wp

   implicit none

   real(wp) ra(3),rb(3),rab(3)

   rab(1)=ra(2)*rb(3)-ra(3)*rb(2)
   rab(2)=ra(3)*rb(1)-ra(1)*rb(3)
   rab(3)=ra(1)*rb(2)-ra(2)*rb(1)

End subroutine

!  .....................................................................

real(wp) Function  vecnorm (r,n,inorm)
   use xtb_mctc_accuracy, only : wp

   implicit none

   integer i,n,inorm

   real(wp) r(n),or,sp,rn

   sp=0.
   do i=1,n
      sp=sp+r(i)*r(i)
   end do
   rn=sqrt(sp)
   if (inorm.gt.0) then
      if (abs(rn).gt.1.d-14) then
         or=1.0d0/rn
         do i=1,n
            r(i)=or*r(i)
         end do
      end if
   end if
   vecnorm=rn

End function

!  .....................................................................

subroutine crprod(a,b,c)
   use xtb_mctc_accuracy, only : wp
   implicit double precision (a-h,o-z)
   dimension a(3),b(3),c(3)

   c(1)=a(2)*b(3)-a(3)*b(2)
   c(2)=a(3)*b(1)-a(1)*b(3)
   c(3)=a(1)*b(2)-a(2)*b(1)

   return
end subroutine crprod

!  .....................................................................

subroutine vsc1(a,scale,tol)
   use xtb_mctc_accuracy, only : wp
   implicit double precision (a-h,o-z)
   dimension a(3)

   rlen = norm2(a)

   if (rlen.gt.tol) then
      do i=1,3
         a(i) = a(i)*scale/rlen
      end do
   endif

   return
end subroutine vsc1

!  .....................................................................

pure subroutine impsc(a,b,c)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp),intent(in)  :: a(3),b(3)
   real(wp),intent(out) :: c
   integer  :: i
   real(wp) :: rimp,al,bl

   rimp = 0.0d0

   do i=1,3
      rimp = rimp + a(i)*b(i)
   end do

   al = norm2(a)
   bl = norm2(b)

   if (al.gt.0.0d0.and.bl.gt.0.0d0) then
      c = rimp/(al*bl)
   else
      c = 0.0d0
   endif

   return
end subroutine impsc

!  .....................................................................

pure subroutine bangl(xyz,i,j,k,angle)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp),intent(in)  :: xyz(3,*)
   real(wp),intent(out) :: angle
   integer, intent(in)  :: i,j,k

   real(wp) d2ij,d2jk,d2ik,xy,temp

   d2ij = sum((xyz(:,i)-xyz(:,j))**2)
   d2jk = sum((xyz(:,j)-xyz(:,k))**2)
   d2ik = sum((xyz(:,i)-xyz(:,k))**2)
   xy = sqrt(d2ij*d2jk)
   temp = 0.5d0 * (d2ij+d2jk-d2ik) / xy
   if (temp .gt. 1.0d0)  temp= 1.0d0
   if (temp .lt. -1.0d0) temp=-1.0d0
   angle = acos( temp )

end subroutine bangl

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_systools
   implicit none

   character,parameter :: space = ' '
#ifdef _WIN32
   character,parameter :: pathdel = ';'
   character,parameter :: pathsep = '\'
#else
   character,parameter :: pathdel = ':'
   character,parameter :: pathsep = '/'
#endif

contains

!> To read line
subroutine getline(unit,line,iostat)
   
   use, intrinsic :: iso_fortran_env, only : iostat_eor
      !! iostat_eor - assigned to the iostat variable if eof occurs
   implicit none

   integer,intent(in) :: unit
   character(len=:),allocatable,intent(out) :: line
   integer,intent(out),optional :: iostat

   integer,parameter  :: buffersize=144
   character(len=buffersize) :: buffer
   integer :: size
   integer :: err

   line = ''
   do
      read(unit,'(a)',advance='no',iostat=err,size=size)  &
      &    buffer
      if (err.gt.0) then
         if (present(iostat)) iostat=err
         return ! an error occurred
      endif
      line = line // buffer(:size)
      if (err.lt.0) then
         if (err.eq.iostat_eor) err = 0
         if (present(iostat)) iostat=err
         return
      endif
   enddo

end subroutine getline

subroutine rdpath(path,arg,fname,ex)
   implicit none
   character(len=*),intent(in)  :: arg
   character(len=*),intent(in)  :: path
   character(len=:),allocatable,intent(out) :: fname
   logical,intent(out),optional :: ex

!* temporary variables
   character(len=:),allocatable :: scratch1
   character(len=:),allocatable :: scratch2
   character(len=:),allocatable :: fpath
   logical :: exist
   integer :: i

   scratch1 = path
   do
      i = index(scratch1,pathdel)
      if (i.eq.0) then
         scratch2 = scratch1
      else
         scratch2 = scratch1(:i-1)
         scratch1 = scratch1(i+1:)
      endif
      fpath = scratch2//pathsep//arg
      inquire(file=fpath,exist=exist)
      if (exist) exit
!     print*,fpath,space,scratch1,exist
      if (i.eq.0) exit
   enddo

!  print*,fpath,exist

   if (exist) fname = fpath
   if (present(ex)) ex = exist
   
end subroutine rdpath

subroutine rdarg(i,arg,iostat)
   integer,intent(in) :: i
   character(len=:),allocatable,intent(out) :: arg
   integer,intent(out),optional :: iostat
   integer :: l,err
   if (allocated(arg)) deallocate(arg)
   call get_command_argument(i,length=l,status=err)
   if (err.ne.0) then
      if (present(iostat)) then
         iostat = err
         return
      else
         call raise('E','Command argument corrupted')
      endif
   endif
   allocate( character(len=l) :: arg, stat=err )
   if (err.ne.0) then
      if (present(iostat)) then
         iostat = err
         return
      else
         call raise('E','could not be allocated')
      endif
   endif
   call get_command_argument(i,arg,status=err)
   if (err.ne.0) then
      if (present(iostat)) then
         iostat = err
         return
      else
         call raise('E','Command argument corrupted')
      endif
   endif
   if (present(iostat)) iostat=0
end subroutine rdarg

subroutine rdvar(name,var,iostat)
   character(len=*),intent(in) :: name
   character(len=:),allocatable,intent(out) :: var
   integer,intent(out),optional :: iostat
   integer :: l,err
   if (allocated(var)) deallocate(var)
   call get_environment_variable(name,length=l,status=err)
   if (err.ne.0) then
      if (present(iostat)) then
         iostat = err
         return
      else
         call raise('E','System variable unassigned')
      endif
   endif
   allocate( character(len=l) :: var, stat=err )
   if (err.ne.0) then
      if (present(iostat)) then
         iostat = err
         return
      else
         call raise('E','could not be allocated')
      endif
   endif
   ! If the environment variable has not been set, l=0, and the
   ! following get_environment_variable call crashes.
   if (l.gt.0) then
      call get_environment_variable(name,var,status=err)
      if (err.ne.0) then
         if (present(iostat)) then
            iostat = err
            return
         else
            call raise('E','System variable corrupted')
         endif
      endif
   endif
   if (present(iostat)) iostat=0
end subroutine rdvar

end module xtb_mctc_systools

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Force field calculator
module xtb_gfnff_calculator
   use xtb_mctc_accuracy, only : wp
   use xtb_solv_gbsa, only : TBorn, init
   use xtb_solv_model, only : info, newBornModel
   use xtb_type_calculator, only : TCalculator
   use xtb_type_data
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule
   use xtb_type_restart
   use xtb_setparam
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_metadynamic
   use xtb_constrainpot
   use xtb_gfnff_param, only : make_chrg,gff_print
   use xtb_gfnff_data, only : TGFFData
   use xtb_gfnff_topology, only : TGFFTopology
   use xtb_gfnff_neighbourlist, only : TGFFNeighbourList
   use xtb_gfnff_generator, only : TGFFGenerator
   use xtb_gfnff_eg
   implicit none
   private

   public :: TGFFCalculator, newGFFCalculator


   !> calculator interface for xTB based methods
   type, extends(TCalculator) :: TGFFCalculator

      type(TGFFData) :: param
      type(TGFFGenerator) :: gen
      type(TGFFTopology) :: topo
      logical :: update
      integer :: version

   contains

      !> Perform xTB single point calculationV
      procedure :: singlepoint

      !> Write informative printout
      procedure :: writeInfo

   end type TGFFCalculator

   character(len=*),private,parameter :: outfmt = &
      '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'


contains


subroutine newGFFCalculator(env, mol, calc, fname, restart, version)
   
   use xtb_gfnff_param
   use xtb_gfnff_setup, only : gfnff_setup
   use xtb_disp_dftd4, only : newD3Model

   character(len=*), parameter :: source = 'main_setup_newGFFCalculator'

   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(in) :: mol

   type(TGFFCalculator), intent(out) :: calc

   character(len=*), intent(in) :: fname

   logical, intent(in) :: restart

   integer, intent(in), optional :: version

   integer :: ich
   logical :: exist, okbas
   logical :: exitRun

   if (present(version)) then
      calc%version = version
   else
      calc%version = gffVersion%angewChem2020_2
   end if

   call calc%topo%zero
   calc%update = .true.

   ! global accuracy factor similar to acc in xtb used in SCF !
   calc%accuracy = 0.1_wp
   if (mol%n > 10000) then
      calc%accuracy = 2.0_wp
   end if

   ! obtain the parameter file !
   call open_file(ich, fname, 'r')
   exist = ich /= -1
   if (exist) then
      call gfnff_read_param(ich, calc%param)
      call close_file(ich) 
      
   ! no parameter file, try to load internal version !
   else
      call gfnff_load_param(calc%version, calc%param, exist)
      if (.not.exist) then
         call env%error('Parameter file '//fname//' not found!', source)
         return
      end if
   endif

   call newD3Model(calc%topo%dispm, mol%n, mol%at)

   call gfnff_setup(env, set%verbose, restart, mol, &
      & calc%gen, calc%param, calc%topo, calc%accuracy, calc%version)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Could not create force field calculator", source)
      return
   end if

end subroutine newGFFCalculator


!> GFN-FF wrapper for the single point energy evaluation  
subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)

   !> Source of the generated errors
   character(len=*), parameter :: source = 'gfnff_calculator_singlepoint'

   !> Calculator instance
   class(TGFFCalculator), intent(inout) :: self

   !> Computational environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol

   !> Wavefunction data
   type(TRestart), intent(inout) :: chk

   !> Print level for IO
   integer, intent(in) :: printlevel

   !> Restart from previous results
   logical, intent(in) :: restart

   !> Total energy
   real(wp), intent(out) :: energy

   !> Molecular gradient
   real(wp), intent(out) :: gradient(:, :)

   !> Strain derivatives
   real(wp), intent(out) :: sigma(:, :)

   !> HOMO-LUMO gab
   real(wp), intent(out) :: hlgap

   !> Detailed results
   type(scc_results), intent(out) :: results

   type(TBorn), allocatable :: solvation
   integer :: i,ich
   integer :: mode_sp_run = 1
   real(wp) :: efix
   logical :: inmol
   logical, parameter :: ccm = .true.
   logical :: exitRun
   logical :: pr
   
   !> GFN-FF geometry optimization
   logical :: optpr

   !-------!
   ! setup !
   !-------!

   call mol%update

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:,:) = 0.0_wp
   hlgap = 0.0_wp
   efix = 0.0_wp

   if (allocated(self%solvation)) then
      allocate(solvation)
      call newBornModel(self%solvation, env, solvation, mol%at)
   end if

   ! to distinguish optimization, final sp and sp ! 
   if ((set%runtyp.eq.p_run_opt).or.(set%runtyp.eq.p_run_ohess).or. &
      &   (set%runtyp.eq.p_run_omd).or.(set%runtyp.eq.p_run_screen).or. &
      &   (set%runtyp.eq.p_run_metaopt)) then
      optpr = printlevel < 2
   else
      optpr = .false.
   endif
   
   pr = gff_print .and. printlevel > 0
   
   !--------------------!
   ! actual calculation !
   !--------------------!

   call gfnff_eg(env,pr,mol%n,nint(mol%chrg),mol%at,mol%xyz,make_chrg, &
      & gradient,energy,results,self%param,self%topo,chk%nlist,solvation,&
      & self%update,self%version,self%accuracy,minpr=optpr)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Force-field method terminated", source)
      return
   end if

   ! ---------------------------------------!
   ! post processing of gradient and energy !
   !----------------------------------------!
   
   ! various external potentials !
   call constrain_pot(potset,mol%n,mol%at,mol%xyz,gradient,efix)
   call constrpot   (mol%n,mol%at,mol%xyz,gradient,efix)
   call cavity_egrad(mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (metaset,mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (rmsdset,mol%n,mol%at,mol%xyz,efix,gradient)

   ! fixing of certain atoms !
   !  print*,abs(efix/etot)
   energy = energy + efix
   results%e_total = energy
   results%gnorm = norm2(gradient)
   if (fixset%n.gt.0) then
      do i=1, fixset%n
         !print*,i,fixset%atoms(i)
         gradient(1:3,fixset%atoms(i))=0
      enddo
   endif

   if (printlevel.ge.2)  then
      ! start with summary header !
      if (.not.set%silent) then
         write(env%unit,'(9x,53(":"))')
         write(env%unit,'(9x,"::",21x,a,21x,"::")') "SUMMARY"
      endif
      write(env%unit,'(9x,53(":"))')
      write(env%unit,outfmt) "total energy      ", results%e_total,"Eh   "
      if (.not.set%silent.and.allocated(solvation)) then
         write(env%unit,outfmt) "total w/o Gsolv   ", &
            &  results%e_total-results%g_solv, "Eh   "
         write(env%unit,outfmt) "total w/o Gsasa/hb", &
            &  results%e_total-results%g_sasa-results%g_hb-results%g_shift, "Eh   "
      endif
      write(env%unit,outfmt) "gradient norm     ", results%gnorm,  "Eh/a0"
      if (.not.set%silent) then
         write(env%unit,'(9x,"::",49("."),"::")')
         call print_gfnff_results(env%unit,results,set%verbose,allocated(solvation))
         write(env%unit,outfmt) "add. restraining  ", efix,       "Eh   "
         write(env%unit,outfmt) "total charge      ", sum(chk%nlist%q), "e    "
         if (set%verbose) then
            write(env%unit,'(9x,"::",49("."),"::")')
            write(env%unit,outfmt) "atomisation energy", results%e_atom, "Eh   "
         endif
      endif
      write(env%unit,'(9x,53(":"))')
      write(env%unit,'(a)')
      if (.not.set%silent) then
         call open_file(ich,'gfnff_charges','w')
         call print_charges(ich,mol%n,chk%nlist%q)
         call close_file(ich)
      end if
    
    else if (set%mode_extrun .eq. p_ext_oniom) then
      write(env%unit,outfmt) "total energy      ", results%e_total,"Eh   "
      write(env%unit,outfmt) "gradient norm     ", results%gnorm,  "Eh/a0"
    
    endif

end subroutine singlepoint

subroutine print_gfnff_results(iunit,res_gff,verbose,lsolv)
   
   use xtb_type_data
   
   !> file handle (usually output_unit=6)
   integer, intent(in) :: iunit 
   type(scc_results),    intent(in) :: res_gff
   logical,intent(in) :: verbose,lsolv
   
   write(iunit,outfmt) "bond energy       ", res_gff%e_bond, "Eh   "
   write(iunit,outfmt) "angle energy      ", res_gff%e_angl, "Eh   "
   write(iunit,outfmt) "torsion energy    ", res_gff%e_tors, "Eh   "
   write(iunit,outfmt) "repulsion energy  ", res_gff%e_rep,  "Eh   "
   write(iunit,outfmt) "electrostat energy", res_gff%e_es,   "Eh   "
   write(iunit,outfmt) "dispersion energy ", res_gff%e_disp, "Eh   "
   write(iunit,outfmt) "HB energy         ", res_gff%e_hb,   "Eh   "
   write(iunit,outfmt) "XB energy         ", res_gff%e_xb,   "Eh   "
   write(iunit,outfmt) "bonded atm energy ", res_gff%e_batm, "Eh   "
   write(iunit,outfmt) "external energy   ", res_gff%e_ext,  "Eh   "
   if (lsolv) then
      write(iunit,outfmt) "-> Gsolv          ", res_gff%g_solv, "Eh   "
      write(iunit,outfmt) "   -> Gborn       ", res_gff%g_born, "Eh   "
      write(iunit,outfmt) "   -> Gsasa       ", res_gff%g_sasa, "Eh   "
      write(iunit,outfmt) "   -> Ghb         ", res_gff%g_hb,   "Eh   "
      write(iunit,outfmt) "   -> Gshift      ", res_gff%g_shift,"Eh   "
   end if
end subroutine print_gfnff_results

subroutine writeInfo(self, unit, mol)

   !> Calculator instance
   class(TGFFCalculator), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   select case(set%mode_extrun)
   case(p_ext_gfnff)
     call gfnff_header(unit,self%version)
   end select

   if (allocated(self%solvation)) then
      call info(self%solvation, unit)
   end if

end subroutine writeInfo

subroutine print_charges(ifile,n,q)
   implicit none
   integer, intent(in)  :: ifile
   integer, intent(in)  :: n
   real(wp),intent(in)  :: q(n)
   integer :: i
   if (ifile.ne.-1) then
      do i = 1, n
         write(ifile,'(f14.8)') q(i)
      end do
   end if
end subroutine print_charges

end module xtb_gfnff_calculator

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine spline_cubic_set ( n, t, y, ibcbeg, ybcbeg, ibcend, ybcend, ypp )

!*****************************************************************************80
!
!! SPLINE_CUBIC_SET computes the second derivatives of a piecewise cubic spline.
!
!  Discussion:
!
!    For data interpolation, the user must call SPLINE_CUBIC_SET to
!    determine the second derivative data, passing in the data to be
!    interpolated, and the desired boundary conditions.
!
!    The data to be interpolated, plus the SPLINE_CUBIC_SET output,
!    defines the spline.  The user may then call SPLINE_CUBIC_VAL to
!    evaluate the spline at any point.
!
!    The cubic spline is a piecewise cubic polynomial.  The intervals
!    are determined by the "knots" or abscissas of the data to be
!    interpolated.  The cubic spline has continous first and second
!    derivatives over the entire interval of interpolation.
!
!    For any point T in the interval T(IVAL), T(IVAL+1), the form of
!    the spline is
!
!      SPL(T) = A(IVAL)
!             + B(IVAL) * ( T - T(IVAL) )
!             + C(IVAL) * ( T - T(IVAL) )^2
!             + D(IVAL) * ( T - T(IVAL) )^3
!
!    If we assume that we know the values Y(*) and YPP(*), which represent
!    the values and second derivatives of the spline at each knot, then
!    the coefficients can be computed as:
!
!      A(IVAL) = Y(IVAL)
!      B(IVAL) = ( Y(IVAL+1) - Y(IVAL) ) / ( T(IVAL+1) - T(IVAL) )
!        - ( YPP(IVAL+1) + 2 * YPP(IVAL) ) * ( T(IVAL+1) - T(IVAL) ) / 6
!      C(IVAL) = YPP(IVAL) / 2
!      D(IVAL) = ( YPP(IVAL+1) - YPP(IVAL) ) / ( 6 * ( T(IVAL+1) - T(IVAL) ) )
!
!    Since the first derivative of the spline is
!
!      SPL'(T) =     B(IVAL)
!              + 2 * C(IVAL) * ( T - T(IVAL) )
!              + 3 * D(IVAL) * ( T - T(IVAL) )^2,
!
!    the requirement that the first derivative be continuous at interior
!    knot I results in a total of N-2 equations, of the form:
!
!      B(IVAL-1) + 2 C(IVAL-1) * (T(IVAL)-T(IVAL-1))
!      + 3 * D(IVAL-1) * (T(IVAL) - T(IVAL-1))^2 = B(IVAL)
!
!    or, setting H(IVAL) = T(IVAL+1) - T(IVAL)
!
!      ( Y(IVAL) - Y(IVAL-1) ) / H(IVAL-1)
!      - ( YPP(IVAL) + 2 * YPP(IVAL-1) ) * H(IVAL-1) / 6
!      + YPP(IVAL-1) * H(IVAL-1)
!      + ( YPP(IVAL) - YPP(IVAL-1) ) * H(IVAL-1) / 2
!      =
!      ( Y(IVAL+1) - Y(IVAL) ) / H(IVAL)
!      - ( YPP(IVAL+1) + 2 * YPP(IVAL) ) * H(IVAL) / 6
!
!    or
!
!      YPP(IVAL-1) * H(IVAL-1) + 2 * YPP(IVAL) * ( H(IVAL-1) + H(IVAL) )
!      + YPP(IVAL) * H(IVAL)
!      =
!      6 * ( Y(IVAL+1) - Y(IVAL) ) / H(IVAL)
!      - 6 * ( Y(IVAL) - Y(IVAL-1) ) / H(IVAL-1)
!
!    Boundary conditions must be applied at the first and last knots.
!    The resulting tridiagonal system can be solved for the YPP values.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    07 June 2013
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of data points; N must be
!    at least 2.
!
!    Input, real ( kind = 8 ) T(N), the points where data is specified.
!    The values should be distinct, and increasing.
!
!    Input, real ( kind = 8 ) Y(N), the data values to be interpolated.
!
!    Input, integer ( kind = 4 ) IBCBEG, the left boundary condition flag:
!    0: the spline should be a quadratic over the first interval;
!    1: the first derivative at the left endpoint should be YBCBEG;
!    2: the second derivative at the left endpoint should be YBCBEG;
!    3: Not-a-knot: the third derivative is continuous at T(2).
!
!    Input, real ( kind = 8 ) YBCBEG, the left boundary value, if needed.
!
!    Input, integer ( kind = 4 ) IBCEND, the right boundary condition flag:
!    0: the spline should be a quadratic over the last interval;
!    1: the first derivative at the right endpoint should be YBCEND;
!    2: the second derivative at the right endpoint should be YBCEND;
!    3: Not-a-knot: the third derivative is continuous at T(N-1).
!
!    Input, real ( kind = 8 ) YBCEND, the right boundary value, if needed.
!
!    Output, real ( kind = 8 ) YPP(N), the second derivatives of
!    the cubic spline.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ) a1(n)
  real ( kind = 8 ) a2(n)
  real ( kind = 8 ) a3(n)
  real ( kind = 8 ) a4(n)
  real ( kind = 8 ) a5(n)
  real ( kind = 8 ) b(n)
  integer ( kind = 4 ) i
  integer ( kind = 4 ) ibcbeg
  integer ( kind = 4 ) ibcend
  integer ( kind = 4 ) info
  real ( kind = 8 ) t(n)
  real ( kind = 8 ) y(n)
  real ( kind = 8 ) ybcbeg
  real ( kind = 8 ) ybcend
  real ( kind = 8 ) ypp(n)
!
!  Check.
!
  if ( n <= 1 ) then
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
    write ( *, '(a)' ) '  The number of knots must be at least 2.'
    write ( *, '(a,i8)' ) '  The input value of N = ', n
    stop 1
  end if

  do i = 1, n - 1
    if ( t(i+1) <= t(i) ) then
      write ( *, '(a)' ) ' '
      write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
      write ( *, '(a)' ) '  The knots must be strictly increasing, but'
      write ( *, '(a,i8,a,g14.6)' ) '  T(',  i,') = ', t(i)
      write ( *, '(a,i8,a,g14.6)' ) '  T(',i+1,') = ', t(i+1)
      stop 1
    end if
  end do
!
!  Zero out the matrix.
!
  a1(1:n) = 0.0D+00
  a2(1:n) = 0.0D+00
  a3(1:n) = 0.0D+00
  a4(1:n) = 0.0D+00
  a5(1:n) = 0.0D+00
!
!  Set the first equation.
!
  if ( ibcbeg == 0 ) then
    b(1) = 0.0D+00
    a3(1) =  1.0D+00
    a4(1) = -1.0D+00
  else if ( ibcbeg == 1 ) then
    b(1) = ( y(2) - y(1) ) / ( t(2) - t(1) ) - ybcbeg
    a3(1) = ( t(2) - t(1) ) / 3.0D+00
    a4(1) = ( t(2) - t(1) ) / 6.0D+00
  else if ( ibcbeg == 2 ) then
    b(1) = ybcbeg
    a3(1) = 1.0D+00
    a4(1) = 0.0D+00
  else if ( ibcbeg == 3 ) then
    b(1) = 0.0D+00
    a3(1) = - ( t(3) - t(2) )
    a4(1) =   ( t(3)        - t(1) )
    a5(1) = - (        t(2) - t(1) )
  else
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
    write ( *, '(a)' ) '  The boundary flag IBCBEG must be 0, 1, 2 or 3.'
    write ( *, '(a,i8)' ) '  The input value is IBCBEG = ', ibcbeg
    stop 1
  end if
!
!  Set the intermediate equations.
!
  do i = 2, n - 1
    b(i) = ( y(i+1) - y(i) ) / ( t(i+1) - t(i) ) &
         - ( y(i) - y(i-1) ) / ( t(i) - t(i-1) )
    a2(i) = ( t(i+1) - t(i)   ) / 6.0D+00
    a3(i) = ( t(i+1) - t(i-1) ) / 3.0D+00
    a4(i) = ( t(i)   - t(i-1) ) / 6.0D+00
  end do
!
!  Set the last equation.
!
  if ( ibcend == 0 ) then
    b(n) = 0.0D+00
    a2(n) = -1.0D+00
    a3(n) = 1.0D+00
  else if ( ibcend == 1 ) then
    b(n) = ybcend - ( y(n) - y(n-1) ) / ( t(n) - t(n-1) )
    a2(n) = ( t(n) - t(n-1) ) / 6.0D+00
    a3(n) = ( t(n) - t(n-1) ) / 3.0D+00
  else if ( ibcend == 2 ) then
    b(n) = ybcend
    a2(n) = 0.0D+00
    a3(n) = 1.0D+00
  else if ( ibcend == 3 ) then
    b(n) = 0.0D+00
    a1(n) = - ( t(n) - t(n-1) )
    a2(n) =   ( t(n)          - t(n-2) )
    a3(n) = - (        t(n-1) - t(n-2) )
  else
    write ( *, '(a)' ) ' '
    write ( *, '(a)' ) 'SPLINE_CUBIC_SET - Fatal error!'
    write ( *, '(a)' ) '  The boundary flag IBCEND must be 0, 1, 2 or 3.'
    write ( *, '(a,i8)' ) '  The input value is IBCEND = ', ibcend
    stop 1
  end if
!
!  Special case:
!    N = 2, IBCBEG = IBCEND = 0.
!
  if ( n == 2 .and. ibcbeg == 0 .and. ibcend == 0 ) then

    ypp(1) = 0.0D+00
    ypp(2) = 0.0D+00
!
!  Solve the linear system.
!
  else

    call penta ( n, a1, a2, a3, a4, a5, b, ypp )

  end if

  return
end

subroutine penta ( n, a1, a2, a3, a4, a5, b, x )

!*****************************************************************************80
!
!! PENTA solves a pentadiagonal system of linear equations.
!
!  Discussion:
!
!    The matrix A is pentadiagonal.  It is entirely zero, except for
!    the main diagaonal, and the two immediate sub- and super-diagonals.
!
!    The entries of Row I are stored as:
!
!      A(I,I-2) -> A1(I)
!      A(I,I-1) -> A2(I)
!      A(I,I)   -> A3(I)
!      A(I,I+1) -> A4(I)
!      A(I,I-2) -> A5(I)
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    07 June 2013
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Cheney, Kincaid,
!    Numerical Mathematics and Computing,
!    1985, pages 233-236.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the order of the matrix.
!
!    Input, real ( kind = 8 ) A1(N), A2(N), A3(N), A4(N), A5(N), the nonzero
!    elements of the matrix.  Note that the data in A2, A3 and A4
!    is overwritten by this routine during the solution process.
!
!    Input, real ( kind = 8 ) B(N), the right hand side of the linear system.
!
!    Output, real ( kind = 8 ) X(N), the solution of the linear system.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ) a1(n)
  real ( kind = 8 ) a2(n)
  real ( kind = 8 ) a3(n)
  real ( kind = 8 ) a4(n)
  real ( kind = 8 ) a5(n)
  real ( kind = 8 ) b(n)
  integer ( kind = 4 ) i
  real ( kind = 8 ) x(n)
  real ( kind = 8 ) xmult

  do i = 2, n - 1
    xmult = a2(i) / a3(i-1)
    a3(i) = a3(i) - xmult * a4(i-1)
    a4(i) = a4(i) - xmult * a5(i-1)
    b(i) = b(i) - xmult * b(i-1)
    xmult = a1(i+1) / a3(i-1)
    a2(i+1) = a2(i+1) - xmult * a4(i-1)
    a3(i+1) = a3(i+1) - xmult * a5(i-1)
    b(i+1) = b(i+1) - xmult * b(i-1)
  end do

  xmult = a2(n) / a3(n-1)
  a3(n) = a3(n) - xmult * a4(n-1)
  x(n) = ( b(n) - xmult * b(n-1) ) / a3(n)
  x(n-1) = ( b(n-1) - a4(n-1) * x(n) ) / a3(n-1)
  do i = n - 2, 1, -1
    x(i) = ( b(i) - a4(i) * x(i+1) - a5(i) * x(i+2) ) / a3(i)
  end do

  return
end

subroutine spline_cubic_val ( n, t, y, ypp, tval, yval, ypval, yppval )

!*****************************************************************************80
!
!! SPLINE_CUBIC_VAL evaluates a piecewise cubic spline at a point.
!
!  Discussion:
!
!    SPLINE_CUBIC_SET must have already been called to define the
!    values of YPP.
!
!    For any point T in the interval T(IVAL), T(IVAL+1), the form of
!    the spline is
!
!      SPL(T) = A
!             + B * ( T - T(IVAL) )
!             + C * ( T - T(IVAL) )^2
!             + D * ( T - T(IVAL) )^3
!
!    Here:
!      A = Y(IVAL)
!      B = ( Y(IVAL+1) - Y(IVAL) ) / ( T(IVAL+1) - T(IVAL) )
!        - ( YPP(IVAL+1) + 2 * YPP(IVAL) ) * ( T(IVAL+1) - T(IVAL) ) / 6
!      C = YPP(IVAL) / 2
!      D = ( YPP(IVAL+1) - YPP(IVAL) ) / ( 6 * ( T(IVAL+1) - T(IVAL) ) )
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    20 November 2000
!
!  Author:
!
!    John Burkardt
!
!  Reference:
!
!    Carl deBoor,
!    A Practical Guide to Splines,
!    Springer, 2001,
!    ISBN: 0387953663.
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, the number of data values.
!
!    Input, real ( kind = 8 ) T(N), the knot values.
!
!    Input, real ( kind = 8 ) Y(N), the data values at the knots.
!
!    Input, real ( kind = 8 ) YPP(N), the second derivatives of the
!    spline at the knots.
!
!    Input, real ( kind = 8 ) TVAL, a point, typically between T(1) and
!    T(N), at which the spline is to be evalulated.  If TVAL lies outside
!    this range, extrapolation is used.
!
!    Output, real ( kind = 8 ) YVAL, YPVAL, YPPVAL, the value of the spline, and
!    its first two derivatives at TVAL.
!
  implicit none

  integer ( kind = 4 ) n

  real ( kind = 8 ) dt
  real ( kind = 8 ) h
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real ( kind = 8 ) t(n)
  real ( kind = 8 ) tval
  real ( kind = 8 ) y(n)
  real ( kind = 8 ) ypp(n)
  real ( kind = 8 ) yppval
  real ( kind = 8 ) ypval
  real ( kind = 8 ) yval
!
!  Determine the interval [T(LEFT), T(RIGHT)] that contains TVAL.
!  Values below T(1) or above T(N) use extrapolation.
!
  call r8vec_bracket ( n, t, tval, left, right )
!
!  Evaluate the polynomial.
!
  dt = tval - t(left)
  h = t(right) - t(left)

  yval = y(left) &
       + dt * ( ( y(right) - y(left) ) / h &
              - ( ypp(right) / 6.0D+00 + ypp(left) / 3.0D+00 ) * h &
       + dt * ( 0.5D+00 * ypp(left) &
       + dt * ( ( ypp(right) - ypp(left) ) / ( 6.0D+00 * h ) ) ) )

  ypval = ( y(right) - y(left) ) / h &
       - ( ypp(right) / 6.0D+00 + ypp(left) / 3.0D+00 ) * h &
       + dt * ( ypp(left) &
       + dt * ( 0.5D+00 * ( ypp(right) - ypp(left) ) / h ) )

  yppval = ypp(left) + dt * ( ypp(right) - ypp(left) ) / h

  return
end

subroutine r8vec_bracket ( n, x, xval, left, right )

!*****************************************************************************80
!
!! R8VEC_BRACKET searches a sorted R8VEC for successive brackets of a value.
!
!  Discussion:
!
!    An R8VEC is an array of double precision real values.
!
!    If the values in the vector are thought of as defining intervals
!    on the real line, then this routine searches for the interval
!    nearest to or containing the given value.
!
!  Licensing:
!
!    This code is distributed under the GNU LGPL license.
!
!  Modified:
!
!    06 April 1999
!
!  Author:
!
!    John Burkardt
!
!  Parameters:
!
!    Input, integer ( kind = 4 ) N, length of input array.
!
!    Input, real ( kind = 8 ) X(N), an array sorted into ascending order.
!
!    Input, real ( kind = 8 ) XVAL, a value to be bracketed.
!
!    Output, integer ( kind = 4 ) LEFT, RIGHT, the results of the search.
!    Either:
!      XVAL < X(1), when LEFT = 1, RIGHT = 2;
!      X(N) < XVAL, when LEFT = N-1, RIGHT = N;
!    or
!      X(LEFT) <= XVAL <= X(RIGHT).
!
  implicit none

  integer ( kind = 4 ) n

  integer ( kind = 4 ) i
  integer ( kind = 4 ) left
  integer ( kind = 4 ) right
  real ( kind = 8 ) x(n)
  real ( kind = 8 ) xval

  do i = 2, n - 1

    if ( xval < x(i) ) then
      left = i - 1
      right = i
      return
    end if

   end do

  left = n - 1
  right = n

  return
end

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine prgemat(mat,d1,d2,name,inunit,instep)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: d1
   integer, intent(in) :: d2
   real(wp),intent(in) :: mat(d1,d2)
   character(len=*),intent(in),optional :: name
   integer, intent(in),optional :: inunit
   integer, intent(in),optional :: instep
   integer :: i,j,k,l,step,unit
   if (present(inunit)) then
      unit = inunit
   else
      unit = output_unit
   endif
   if (present(instep)) then
      step = instep
   else
      step = 6
   endif
   if(present(name)) write(unit,'(/,''matrix printed:'',x,a)') name
   do i = 1, d2, step
      l = min(i+step-1,d2)
      write(unit,'(/,6x)',advance='no')
      do k = i, l
      write(unit,'(6x,i7,3x)',advance='no') k
      enddo
      write(unit,'(a)')
      do j = 1, d1
         write(unit,'(i6)',advance='no') j
         do k = i, l
         write(unit,'(x,e15.8)',advance='no') mat(j,k)
         enddo
         write(unit,'(a)')
      enddo
   enddo
   return
end subroutine prgemat


subroutine prsymat(mat,d1,name,inunit,instep)
   use xtb_mctc_accuracy, only : wp
   use, intrinsic :: iso_fortran_env, only : output_unit
   implicit none
   integer, intent(in) :: d1
   real(wp),intent(in) :: mat(d1*(d1+1))
   character(len=*),intent(in),optional :: name
   integer, intent(in),optional :: inunit
   integer, intent(in),optional :: instep
   integer :: i,j,k,l,step,unit
   integer,external :: lin
   if (present(inunit)) then
      unit = inunit
   else
      unit = output_unit
   endif
   if (present(instep)) then
      step = instep
   else
      step = 6
   endif
   if(present(name)) write(unit,'(/,''matrix printed:'',x,a)') name
   do i = 1, d1, step
      l = min(i+step-1,d1)
      write(unit,'(/,6x)',advance='no')
      do k = i, l
      write(unit,'(6x,i7,3x)',advance='no') k
      enddo
      write(unit,'(a)')
      do j = i, d1
         l = min(i+(step-1),j)
         write(unit,'(i6)',advance='no') j
         do k = i, l
         write(unit,'(x,e15.8)',advance='no') mat(lin(j,k))
         enddo
         write(unit,'(a)')
      enddo
   enddo
   return
end subroutine prsymat

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Actual calculation interface
module xtb_api_interface
   use, intrinsic :: iso_c_binding
   use xtb_mctc_accuracy, only : wp
   use xtb_api_calculator
   use xtb_api_environment
   use xtb_api_molecule
   use xtb_api_results
   use xtb_api_utils
   use xtb_gfnff_calculator, only : TGFFCalculator
   use xtb_scc_core, only : iniqshell
   use xtb_type_data, only : scc_results
   use xtb_xtb_calculator, only : TxTBCalculator, newWavefunction
   implicit none
   private

   public :: singlepoint_api


contains


subroutine singlepoint_api(venv, vmol, vcalc, vres) &
      & bind(C, name="xtb_singlepoint")
   !DEC$ ATTRIBUTES DLLEXPORT :: singlepoint_api
   character(len=*), parameter :: source = 'xtb_api_singlepoint'
   type(c_ptr), value :: venv
   type(VEnvironment), pointer :: env
   type(c_ptr), value :: vmol
   type(VMolecule), pointer :: mol
   type(c_ptr), value :: vcalc
   type(VCalculator), pointer :: calc
   type(c_ptr), value :: vres
   type(VResults), pointer :: res
   type(scc_results) :: spRes

   if (c_associated(venv)) then
      call c_f_pointer(venv, env)
      call checkGlobalEnv

      if (.not.c_associated(vmol)) then
         call env%ptr%error("Molecular structure data is not allocated", source)
         return
      end if
      call c_f_pointer(vmol, mol)

      if (.not.c_associated(vcalc)) then
         call env%ptr%error("Singlepoint calculator is not allocated", source)
         return
      end if
      call c_f_pointer(vcalc, calc)

      if (.not.allocated(calc%ptr)) then
         call env%ptr%error("No calculator loaded for single point", &
            & source)
         return
      end if

      if (.not.c_associated(vres)) then
         call env%ptr%error("Calculation results are not allocated", source)
         return
      end if
      call c_f_pointer(vres, res)

      ! check cache, automatically invalidate missmatched data
      if (allocated(res%chk)) then
         select type(xtb => calc%ptr)
         type is(TxTBCalculator)
            if (res%chk%wfn%n /= mol%ptr%n .or. res%chk%wfn%n /= xtb%basis%n .or. &
               & res%chk%wfn%nao /= xtb%basis%nao .or. &
               & res%chk%wfn%nshell /= xtb%basis%nshell) then
               deallocate(res%chk)
            end if
         end select
      end if

      if (.not.allocated(res%chk)) then
         allocate(res%chk)
         ! in case of a new wavefunction cache we have to perform an initial guess
         select type(xtb => calc%ptr)
         type is(TxTBCalculator)
            call newWavefunction(env%ptr, mol%ptr, xtb, res%chk)
         end select
      end if

      if (.not.allocated(res%energy)) then
         allocate(res%energy)
      end if

      if (.not.allocated(res%egap)) then
         allocate(res%egap)
      end if

      if (allocated(res%pcgradient)) then
         deallocate(res%pcgradient)
      end if

      if (allocated(res%gradient)) then
         if (any(shape(res%gradient) /= [3, mol%ptr%n])) then
            call env%ptr%warning("Shape missmatch in gradient, reallocating", source)
            deallocate(res%gradient)
         end if
      end if
      if (.not.allocated(res%gradient)) then
         allocate(res%gradient(3, mol%ptr%n))
      end if

      if (allocated(res%sigma)) then
         if (any(shape(res%sigma) /= [3, 3])) then
            call env%ptr%warning("Shape missmatch in virial, reallocating", source)
            deallocate(res%sigma)
         end if
      end if
      if (.not.allocated(res%sigma)) then
         allocate(res%sigma(3, 3))
      end if

      ! singlepoint calculation
      call calc%ptr%singlepoint(env%ptr, mol%ptr, res%chk, env%verbosity, .true., &
         & res%energy, res%gradient, res%sigma, res%egap, spRes)

      ! invalidate cache for properties not produced in GFN-FF
      select type(gfnff => calc%ptr)
      type is(TGFFCalculator)
         deallocate(res%chk)
         deallocate(res%egap)
         deallocate(res%sigma)
      end select

      ! check if external charge gradients have been calculated
      if (allocated(spRes%pcem%grd) .and. spRes%pcem%n > 0) then
         res%pcgradient = spRes%pcem%grd
      end if

      res%dipole = spRes%dipole

   end if

end subroutine singlepoint_api


end module xtb_api_interface

! This file is part of xtb.
!
! Copyright (C) 2020, NVIDIA CORPORATION. All rights reserved.
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_xtb_hamiltonian_gpu
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants, only : pi
   use xtb_mctc_convert, only : evtoau
   use xtb_xtb_data, only : THamiltonianData
   use xtb_intgrad
   use xtb_lin
   use xtb_scc_core, only : shellPoly, h0scal
   use xtb_grad_core, only : dshellPoly
   implicit none
   private

   public :: build_SDQH0_gpu, build_dSDQH0_gpu

   integer,private, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer,private, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

   integer,parameter :: lx(84) = (/ &
      & 0, &
      & 1,0,0, &
      & 2,0,0,1,1,0, &
      & 3,0,0,2,2,1,0,1,0,1, &
      & 4,0,0,3,3,1,0,1,0,2,2,0,2,1,1, &
      & 5,0,0,3,3,2,2,0,0,4,4,1,0,0,1,1,3,1,2,2,1, &
      & 6,0,0,3,3,0,5,5,1,0,0,1,4,4,2,0,2,0,3,3,1,2,2,1,4,1,1,2/)
   integer,parameter :: ly(84) = (/ &
      & 0, &
      & 0,1,0, &
      & 0,2,0,1,0,1, &
      & 0,3,0,1,0,2,2,0,1,1, &
      & 0,4,0,1,0,3,3,0,1,2,0,2,1,2,1, &
      & 0,5,0,2,0,3,0,3,2,1,0,4,4,1,0,1,1,3,2,1,2, &
      & 0,6,0,3,0,3,1,0,0,1,5,5,2,0,0,2,4,4,2,1,3,1,3,2,1,4,1,2/)
   integer,parameter :: lz(84) = (/ &
      & 0, &
      & 0,0,1, &
      & 0,0,2,0,1,1, &
      & 0,0,3,0,1,0,1,2,2,1, &
      & 0,0,4,0,1,0,1,3,3,0,2,2,1,1,2, &
      & 0,0,5,0,2,0,3,2,3,0,1,0,1,4,4,3,1,1,1,2,2, &
      & 0,0,6,0,3,3,0,1,5,5,1,0,0,2,4,4,0,2,1,2,2,3,1,3,1,1,4,2/)

   real(wp), parameter :: trafo(6,6) = reshape((/ & ! copied from scf.f, simplyfied
      ! --- dS
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp, &
      ! --- dx²-y²
      & 0.5_wp*sqrt(3.0_wp), &
      &-0.5_wp*sqrt(3.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp, &
      ! --- dz²
      & 0.5_wp,0.5_wp,-1.0_wp, &
      & 0.0_wp,0.0_wp, 0.0_wp, &
      ! --- rest
      & 0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp /), shape(trafo))

contains


! --------------------------------------------------------------[SAW1907]-
!     a: center of first gaussian
!     b: center of second gaussian
!     c: aufpunkt of moment operator
!     alpi: alpha/exponent of a
!     alpj: beta/exponent of b
!     la/lb: defines l
!     g: gradient
!     nt: dimension of g
pure subroutine build_dsdq_ints_gpu(a,b,c,alpi,alpj,t,e,la,lb,v,g)
   !$acc routine seq
   implicit none
   !     aufpunkte,ref point,intarray
   integer,intent(in)  :: la,lb
   real(wp), intent(in)  :: alpi,alpj
   real(wp), intent(in)  :: a(3),b(3),c(3),t(0:8),e(3)
   real(wp), intent(out) :: v(10),g(3,10)
   !     local variables
   real(wp)  :: d(3),dd(0:8,3),gg(0:8,3),va(3),val(3,3),gra(3,3)
   real(wp)  :: aa(0:3,3),aap(0:4,3),aam(0:4,3),bb(0:3,3)
   real(wp)  :: gama,kab
   integer :: i,j,ij(3),ii(3),jj(3),lmax
   real(wp) :: rab2,rab(3),est,gm

   val = 0
   gra = 0

   aa = 0
   bb = 0
   dd = 0
   gg = 0
   ii = [lx(la),ly(la),lz(la)]
   jj = [lx(lb),ly(lb),lz(lb)]
   ij = ii+jj
   aa(ii(1),1)=1.0_wp
   aa(ii(2),2)=1.0_wp
   aa(ii(3),3)=1.0_wp
   bb(jj(1),1)=1.0_wp
   bb(jj(2),2)=1.0_wp
   bb(jj(3),3)=1.0_wp
   !     d/dX<a|b> = alpi<a+1|b> - i<a-1|b> = -alpj<a|b+1> + j<a|b-1>
   aap=0
   aam=0
   aap(ii(1)+1,1)=2*alpi
   aap(ii(2)+1,2)=2*alpi
   aap(ii(3)+1,3)=2*alpi
   if(ii(1).gt.0) aam(ii(1)-1,1)=-ii(1)
   if(ii(2).gt.0) aam(ii(2)-1,2)=-ii(2)
   if(ii(3).gt.0) aam(ii(3)-1,3)=-ii(3)
   ! apply product theorem
   ! e is center of product gaussian with exponent gama
   ! c is reference point
   d = e - c
   do i = 1, 3
      ! calculate cartesian prefactor for first gaussian
      call build_hshift2(aa(:,i),a(i),e(i),ii(i))    ! <a|
      call build_hshift2(aap(:,i),a(i),e(i),ii(i)+1) ! <a+1|
      call build_hshift2(aam(:,i),a(i),e(i),ii(i)-1) ! <a-1|
      ! calculate cartesian prefactor for second gaussian
      call build_hshift2(bb(:,i),b(i),e(i),jj(i))    ! |b>
      ! form their product
      call prod3(aa(:,i),bb(:,i),dd(:,i),ii(i),jj(i))
      aap(:,i) = aap(:,i) + aam(:,i)
      call prod3(aap(:,i),bb(:,i),gg(:,i),ii(i)+1,jj(i))
      lmax = ij(i)+1
      do j = 0, lmax
         !    <a|b> <a|x|b>             <a|x²|b>
         va = [t(j), t(j+1) + d(i)*t(j), t(j+2) + 2*d(i)*t(j+1) + d(i)*d(i)*t(j)]
         val(i,1:3) = val(i,1:3) + dd(j,i)*va(1:3)
         gra(i,1:3) = gra(i,1:3) + gg(j,i)*va(1:3)
      enddo
   enddo
   v( 1)=(val(1,1)*val(2,1)*val(3,1))
   v( 2)=(val(1,2)*val(2,1)*val(3,1))
   v( 3)=(val(1,1)*val(2,2)*val(3,1))
   v( 4)=(val(1,1)*val(2,1)*val(3,2))
   v( 5)=(val(1,3)*val(2,1)*val(3,1))
   v( 6)=(val(1,1)*val(2,3)*val(3,1))
   v( 7)=(val(1,1)*val(2,1)*val(3,3))
   v( 8)=(val(1,2)*val(2,2)*val(3,1))
   v( 9)=(val(1,2)*val(2,1)*val(3,2))
   v(10)=(val(1,1)*val(2,2)*val(3,2))
   g(1, 1)=(gra(1,1)*val(2,1)*val(3,1))
   g(2, 1)=(val(1,1)*gra(2,1)*val(3,1))
   g(3, 1)=(val(1,1)*val(2,1)*gra(3,1))
   g(1, 2)=(gra(1,2)*val(2,1)*val(3,1))
   g(2, 2)=(val(1,2)*gra(2,1)*val(3,1))
   g(3, 2)=(val(1,2)*val(2,1)*gra(3,1))
   g(1, 3)=(gra(1,1)*val(2,2)*val(3,1))
   g(2, 3)=(val(1,1)*gra(2,2)*val(3,1))
   g(3, 3)=(val(1,1)*val(2,2)*gra(3,1))
   g(1, 4)=(gra(1,1)*val(2,1)*val(3,2))
   g(2, 4)=(val(1,1)*gra(2,1)*val(3,2))
   g(3, 4)=(val(1,1)*val(2,1)*gra(3,2))
   g(1, 5)=(gra(1,3)*val(2,1)*val(3,1))
   g(2, 5)=(val(1,3)*gra(2,1)*val(3,1))
   g(3, 5)=(val(1,3)*val(2,1)*gra(3,1))
   g(1, 6)=(gra(1,1)*val(2,3)*val(3,1))
   g(2, 6)=(val(1,1)*gra(2,3)*val(3,1))
   g(3, 6)=(val(1,1)*val(2,3)*gra(3,1))
   g(1, 7)=(gra(1,1)*val(2,1)*val(3,3))
   g(2, 7)=(val(1,1)*gra(2,1)*val(3,3))
   g(3, 7)=(val(1,1)*val(2,1)*gra(3,3))
   g(1, 8)=(gra(1,2)*val(2,2)*val(3,1))
   g(2, 8)=(val(1,2)*gra(2,2)*val(3,1))
   g(3, 8)=(val(1,2)*val(2,2)*gra(3,1))
   g(1, 9)=(gra(1,2)*val(2,1)*val(3,2))
   g(2, 9)=(val(1,2)*gra(2,1)*val(3,2))
   g(3, 9)=(val(1,2)*val(2,1)*gra(3,2))
   g(1,10)=(gra(1,1)*val(2,2)*val(3,2))
   g(2,10)=(val(1,1)*gra(2,2)*val(3,2))
   g(3,10)=(val(1,1)*val(2,2)*gra(3,2))

end subroutine build_dsdq_ints_gpu


!> Computes the dipole and quadrupole integrals and performs screening to
!  determine, which contribute to potential
subroutine build_SDQH0_gpu(nShell, hData, nat, at, nbf, nao, xyz, trans, selfEnergy, &
      & intcut, caoshell, saoshell, nprim, primcount, alp, cont, &
      & sint, dpint, qpint, H0)
   implicit none
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   !> # of atoms
   integer, intent(in)  :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)  :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)  :: nbf
   integer, intent(in)  :: at(:)
   !> Cartesian coordinates
   real(wp),intent(in)  :: xyz(:, :)
   real(wp),intent(in)    :: trans(:, :)
   real(wp), intent(in) :: selfEnergy(:, :)
   !> Integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)  :: intcut
   !> Map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)  :: caoshell(:,:)
   !> Map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)  :: saoshell(:,:)
   integer, intent(in)  :: nprim(:)
   !> Index of first primitive (over entire system) of given CAO
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)
   !> Overlap integral matrix
   real(wp),intent(out) :: sint(:, :)
   !> Dipole integral matrix
   real(wp),intent(out) :: dpint(:, :, :)
   !> Quadrupole integral matrix
   real(wp),intent(out) :: qpint(:, :, :)
   !> Core Hamiltonian
   real(wp),intent(out) :: H0(:)


   integer i,j,k,l,m,ii,jj,ij,ioff,joff,kk
   real(wp) thr2,ci,cc,cj,alpi,rab2,ab,est,alpj

   real(wp) ra(3),rb(3),point(3)
   real(wp) dtmp(3),qtmp(6),ss(6,6),dd(6,6,3),qq(6,6,6),tmp(6,6),dd2(3,6,6)
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,jshmax
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   integer :: il, jl, itr
   real(wp) :: zi, zj, zetaij, km, hii, hjj, hav, shpoly
   integer itt(0:3)
   parameter(itt  =(/0,1,4,10/))
   real(wp) :: saw(10)

   real(wp) :: gama,kab,t(0:8),e(3)
   real(wp),parameter ::  sqrtpi  = sqrt(pi)

   real(wp) s2(6,6),dum(6,6),sspher

   !$acc enter data create(H0(:), sint(:, :), dpint(:, :, :), qpint(:, :, :))

   !$acc kernels default(present)
   ! integrals
   H0(:) = 0.0_wp
   sint = 0.0_wp
   dpint = 0.0_wp
   qpint = 0.0_wp
   !$acc end kernels
   ! --- Aufpunkt for moment operator
   point = 0.0_wp

   !$acc enter data copyin(xyz, at, nShell, selfEnergy, caoshell, saoshell, &
   !$acc& nprim, primcount, alp, cont, intcut, trans, point, hData, &
   !$acc& hData%principalQuantumNumber(:, :), hData%angShell(:, :), hData%valenceShell(:, :),  &
   !$acc& hData%numberOfPrimitives(:, :), hData%slaterExponent(:, :), hData%selfEnergy(:, :), &
   !$acc& hData%referenceOcc(:, :), hData%kCN(:, :), hData%electronegativity(:), hData%atomicRad(:), &
   !$acc& hData%shellPoly(:, :), hData%pairParam(:, :), hData%kQShell(:, :), hData%kQAtom(:))

   !$acc parallel vector_length(32) private(ss,dd,qq,rb,iat,jat,izp,ci,ra,& 
   !$acc& rab2,jzp,ish,ishtyp,icao,naoi,iptyp, &
   !$acc& jsh,jshmax,jshtyp,jcao,naoj,jptyp,shpoly, &
   !$acc& est,alpi,alpj,ab,iprim,jprim,ip,jp,il,jl,hii,hjj,km,zi,zj,zetaij,hav, &
   !$acc& mli,mlj,iao,jao,ii,jj,k,ij,itr,ioff,joff,t,e,saw,s2,dum)

   !$acc loop gang collapse(2)
   do iat = 1, nat
      do jat = 1, nat
         if (jat.ge.iat) cycle
         ra(1:3) = xyz(1:3,iat)
         izp = at(iat)
         jzp = at(jat)
         do ish = 1, nShell(izp)
            ishtyp = hData%angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            do jsh = 1, nShell(jzp)
               jshtyp = hData%angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, izp)
               zj = hData%slaterExponent(jsh, jzp)
               zetaij = (2 * sqrt(zi*zj)/(zi+zj))**hData%wExp
               call h0scal(hData,il,jl,izp,jzp,hData%valenceShell(ish, izp).ne.0, &
                  & hData%valenceShell(jsh, jzp).ne.0,km)

               hav = 0.5_wp * km * (hii + hjj) * zetaij

               !$acc loop private(ss,dd,qq,s2,dum)
               do itr = 1, size(trans, dim=2)
                  !$acc cache(ss,dd,qq,s2,dum)
                  rb(1:3) = xyz(1:3,jat) + trans(:, itr)
                  rab2 = sum( (rb-ra)**2 )

                  ! distance dependent polynomial
                  shpoly=shellPoly(hData%shellPoly(il,izp),hData%shellPoly(jl,jzp),&
                     &             hData%atomicRad(izp),hData%atomicRad(jzp),ra,rb)

                  ss = 0.0_wp
                  dd = 0.0_wp
                  qq = 0.0_wp

                  !call get_multiints(icao,jcao,naoi,naoj,iptyp,jptyp,ra,rb,point, &
                  !   &               intcut,nprim,primcount,alp,cont,ss,dd,qq)
                  !$acc loop vector private(saw,t,e) independent collapse(2)
                  do ip = 1,nprim(icao+1)
                    do jp = 1,nprim(jcao+1)

                      iprim = ip+primcount(icao+1)
                      jprim = jp+primcount(jcao+1)
                      alpi = alp(iprim)
                      alpj = alp(jprim)

                      gama = alpi+alpj
                      ab = 1.0_wp/(gama)
                      e = (alpi * ra + alpj * rb)/(alpi + alpj)
                      t(0:8) = olapp([(j,j=0,8)],gama)
                      gama = alpi+alpj
                      ab = 1.0_wp/(gama)
                      est = rab2*alpi*alpj*ab
                      kab = exp(-est)*(sqrtpi*sqrt(ab))**3

                      do mli = 1,naoi
                        do mlj = 1,naoj
                          saw = 0.0_wp

                          ! prim-prim quadrupole and dipole integrals
                          call build_sdq_ints_gpu(ra,rb,point,alpi,alpj, &
                            & iptyp+mli,jptyp+mlj,kab,t,e,lx,ly,lz,saw)

                          iprim = ip+primcount(icao+mli)
                          jprim = jp+primcount(jcao+mlj)
                          ci = cont(iprim) ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
                          cc = cont(jprim)*ci
                          ! from primitive integrals fill CAO-CAO matrix for ish-jsh block
                          !                             ! overlap
                          !$acc atomic
                          ss(mlj,mli) = ss(mlj,mli)+saw(1)*cc
                          !$acc end atomic
                          ! dipole
                          do k=1,3
                            !$acc atomic
                            dd(mlj,mli,k) = dd(mlj,mli,k)+saw(k+1)*cc
                            !$acc end atomic
                          enddo
                          do k = 1,6
                            ! quadrupole
                            !$acc atomic
                            qq(mlj,mli,k) = qq(mlj,mli,k)+saw(k+4)*cc
                            !$acc end atomic
                          enddo
                        enddo ! mlj
                      enddo ! mli
                    enddo ! jp
                  enddo ! ip

                  !transform from CAO to SAO
                  !call dtrf2(ss,ishtyp,jshtyp)
                  ! DTRF2(S)
                  !select case(ishtyp)
                  !case(0) ! s-d
                  if (ishtyp.ge.2.or.jshtyp.ge.2) then
                    if (ishtyp.eq.0) then
                      !ss
                      do jj=1,6
                        sspher=0
                        do m=1,6
                          sspher=sspher+trafo(m,jj)*ss(m,1)
                        enddo
                        s2(jj,1)=sspher
                      enddo
                      ss(1:5,1) = s2(2:6,1)

                      !dd
                      do k = 1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*dd(m,1,k)
                          enddo
                          s2(jj,1)=sspher
                        enddo
                        dd(1:5,1,k) = s2(2:6,1)
                      enddo

                      !qq
                      do k = 1,6
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*qq(m,1,k)
                          enddo
                          s2(jj,1)=sspher
                        enddo
                        qq(1:5,1,k) = s2(2:6,1)
                      enddo

                    !case(1) ! p-d
                    else if (ishtyp.eq.1) then
                      !ss
                      do ii=1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*ss(m,ii)
                          enddo
                          s2(jj,ii)=sspher
                        enddo
                        ss(1:5,ii) = s2(2:6,ii)
                      enddo

                      ! dd
                      do k = 1,3
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*dd(m,ii,k)
                            enddo
                            s2(jj,ii)=sspher
                          enddo
                          dd(1:5,ii,k) = s2(2:6,ii)
                        enddo
                      enddo

                      !qq
                      do k = 1,6
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*qq(m,ii,k)
                            enddo
                            s2(jj,ii)=sspher
                          enddo
                          qq(1:5,ii,k) = s2(2:6,ii)
                        enddo
                      enddo
                      !return
                      !end select
                      !     wasn't there, then try iat ...
                      !select case(jshtyp)
                      !case(0) ! d-s
                    else if (jshtyp.eq.0) then
                      !ss
                      do jj=1,6
                        sspher=0
                        do m=1,6
                          sspher=sspher+trafo(m,jj)*ss(1,m)
                        enddo
                        s2(1,jj)=sspher
                      enddo
                      ss(1,1:5) = s2(1,2:6)

                      !dd
                      do k = 1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*dd(1,m,k)
                          enddo
                          s2(1,jj)=sspher
                        enddo
                        dd(1,1:5,k) = s2(1,2:6)
                      enddo

                      !qq
                      do k = 1,6
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*qq(1,m,k)
                          enddo
                          s2(1,jj)=sspher
                        enddo
                        qq(1,1:5,k) = s2(1,2:6)
                      enddo
                      !return
                      !case(1) ! d-p
                    else if (jshtyp.eq.1) then

                      !ss
                      do ii=1,3
                        do jj=1,6
                          sspher=0
                          do m=1,6
                            sspher=sspher+trafo(m,jj)*ss(ii,m)
                          enddo
                          s2(ii,jj)=sspher
                        enddo
                        ss(ii,1:5) = s2(ii,2:6)
                      enddo

                      !dd
                      do k = 1,3
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*dd(ii,m,k)
                            enddo
                            s2(ii,jj)=sspher
                          enddo
                          dd(ii,1:5,k) = s2(ii,2:6)
                        enddo
                      enddo

                      !qq
                      do k = 1,6
                        do ii=1,3
                          do jj=1,6
                            sspher=0
                            do m=1,6
                              sspher=sspher+trafo(m,jj)*qq(ii,m,k)
                            enddo
                            s2(ii,jj)=sspher
                          enddo
                          qq(ii,1:5,k) = s2(ii,2:6)
                        enddo
                      enddo

                    else
                      !  return
                      !end select
                      !     if not returned up to here -> d-d
                      ! CB: transposing s in first dgemm is important for integrals other than S

                      !CALL mctc_gemm(trafo, s, dum, transa='T')

                      !ss -----------
                      do i=1,6
                        do j=1,6
                          sspher = 0.0_wp
                          do k=1,6
                            sspher = sspher + trafo(k,i) * ss(k,j)
                          enddo
                          dum(i,j) = sspher
                        enddo
                      enddo

                      !CALL mctc_gemm(dum, trafo, s2, transb='N')

                      do i=1,6
                        do j=1,6
                          sspher = 0.0_wp
                          do k=1,6
                            sspher = sspher + dum(i,k) * trafo(k,j)
                          enddo
                          s2(i,j) = sspher
                        enddo
                      enddo

                      do i=1,5
                        do j=1,5
                          ss(j,i) = s2(j+1,i+1)
                        enddo
                      enddo
                      ! end ss -----------

                      !dd --------
                      do kk = 1,3
                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + trafo(k,i) * dd(k,j,kk)
                            enddo
                            dum(i,j) = sspher
                          enddo
                        enddo

                        !CALL mctc_gemm(dum, trafo, s2, transb='N')

                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + dum(i,k) * trafo(k,j)
                            enddo
                            s2(i,j) = sspher
                          enddo
                        enddo

                        do i=1,5
                          do j=1,5
                            dd(j,i,kk) = s2(j+1,i+1)
                          enddo
                        enddo
                      enddo
                      !end dd --------------

                      !qq ---------------
                      do kk = 1,6
                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + trafo(k,i) * qq(k,j,kk)
                            enddo
                            dum(i,j) = sspher
                          enddo
                        enddo

                        !CALL mctc_gemm(dum, trafo, s2, transb='N')

                        do i=1,6
                          do j=1,6
                            sspher = 0.0_wp
                            do k=1,6
                              sspher = sspher + dum(i,k) * trafo(k,j)
                            enddo
                            s2(i,j) = sspher
                          enddo
                        enddo

                        do i=1,5
                          do j=1,5
                            qq(j,i,kk) = s2(j+1,i+1)
                          enddo
                        enddo
                      enddo
                      !end qq -----------------

                    endif
                  endif

                  ioff = saoshell(ish,iat)
                  joff = saoshell(jsh,jat)

                  ! would be good to change data order of sint,dpint,qpint for 
                  ! memory coalescence
                  !$acc loop vector collapse(2)
                  do ii = 1,llao2(ishtyp)
                     do jj = 1,llao2(jshtyp)
                       iao = ii + ioff
                       jao = jj + joff
                       ij = lin(iao, jao)
                       !$acc atomic
                       H0(ij) = H0(ij) + hav * shpoly * ss(jj, ii)
                       !$acc end atomic
                       !$acc atomic
                       sint(iao, jao) = sint(iao, jao) + ss(jj, ii)
                       !$acc end atomic
                       !$acc atomic
                       sint(jao, iao) = sint(jao, iao) + ss(jj, ii)
                       !$acc end atomic
                       do k = 1,3
                         !$acc atomic
                         dpint(k, iao, jao) = dpint(k, iao, jao) + dd(jj, ii, k)
                         !$acc end atomic
                         !$acc atomic
                         dpint(k, jao, iao) = dpint(k, jao, iao) + dd(jj, ii, k)
                         !$acc end atomic
                       enddo
                       do k = 1,6
                         !$acc atomic
                         qpint(k, iao, jao) = qpint(k, iao, jao) + qq(jj, ii, k)
                         !$acc end atomic
                         !$acc atomic
                         qpint(k, jao, iao) = qpint(k, jao, iao) + qq(jj, ii, k)
                         !$acc end atomic
                       enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
   enddo
   !$acc end parallel

   !$acc exit data copyout(H0(:), sint(:, :), dpint(:, :, :), qpint(:, :, :))

   ! dd array is transposed in ACC region, so dd2 is created for the diagonal
   ! elements, which is still running on CPU

   ! diagonal elements
   do iat = 1, nat
      ra = xyz(:, iat)
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = hData%angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)
            ii = i*(1+i)/2
            sint(i,i) = 1.0_wp + sint(i,i)
            H0(ii) = H0(ii) + selfEnergy(ish, iat)
         end do

         icao = caoshell(ish,iat)
         naoi = llao(ishtyp)
         iptyp = itt(ishtyp)
         do jsh = 1, ish
            jshtyp = hData%angShell(jsh,izp)
            jcao = caoshell(jsh,iat)
            naoj = llao(jshtyp)
            jptyp = itt(jshtyp)
            ss = 0.0_wp
            dd2 = 0.0_wp
            qq = 0.0_wp
            call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,ra,point, &
               &               intcut,nprim,primcount,alp,cont,ss,dd2,qq)
            !transform from CAO to SAO
            !call dtrf2(ss,ishtyp,jshtyp)
            do k = 1,3
               tmp(1:6, 1:6) = dd2(k,1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               dd2(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do k = 1,6
               tmp(1:6, 1:6) = qq(k, 1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               qq(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do ii = 1, llao2(ishtyp)
               iao = ii + saoshell(ish,iat)
               do jj = 1, llao2(jshtyp)
                  jao = jj + saoshell(jsh,iat)
                  if (jao > iao .and. ish ==  jsh) cycle
                  dpint(1:3, iao, jao) = dpint(1:3, iao, jao) + dd2(1:3, jj, ii)
                  if (iao /= jao) then
                     dpint(1:3, jao, iao) = dpint(1:3, jao, iao) + dd2(1:3, jj, ii)
                  end if
                  qpint(1:6, iao, jao) = qq(1:6, jj, ii)
                  if (jao /= iao) then
                     qpint(1:6, jao, iao) = qq(1:6, jj, ii)
                  end if
               end do
            end do
         end do
      end do
   end do

   !$acc exit data delete(xyz, at, nShell, selfEnergy, caoshell, saoshell, &
   !$acc& nprim, primcount, alp, cont, intcut, trans, point)

   !$acc exit data delete(hData, &
   !$acc& hData%principalQuantumNumber(:, :), hData%angShell(:, :), hData%valenceShell(:, :),  &
   !$acc& hData%numberOfPrimitives(:, :), hData%slaterExponent(:, :), hData%selfEnergy(:, :), &
   !$acc& hData%referenceOcc(:, :), hData%kCN(:, :), hData%electronegativity(:), hData%atomicRad(:), &
   !$acc& hData%shellPoly(:, :), hData%pairParam(:, :), hData%kQShell(:, :), hData%kQAtom(:))

end subroutine build_SDQH0_gpu


!> Computes the gradient of the dipole/qpole integral contribution
subroutine build_dSDQH0_gpu(nShell, hData, selfEnergy, dSEdcn, intcut, nat, nao, nbf, &
      & at, xyz, trans, caoshell, saoshell, nprim, primcount, alp, cont, &
      & p, Pew, ves, vs, vd, vq, dhdcn, g, sigma)
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   real(wp), intent(in) :: selfEnergy(:, :)
   real(wp), intent(in) :: dSEdcn(:, :)
   !> # of atoms
   integer, intent(in)    :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)    :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)    :: nbf
   !> Atomic numbers of atoms
   integer, intent(in)    :: at(:)
   !> Integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)    :: intcut
   real(wp),intent(in)    :: ves(:, :)
   real(wp),intent(in)    :: vs(nat)
   real(wp),intent(in)    :: vd(:, :)
   real(wp),intent(in)    :: vq(:, :)
   !> Cartesian coordinates
   real(wp),intent(in)    :: xyz(:, :)
   real(wp),intent(in)    :: trans(:, :)
   !> Map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)    :: caoshell(:,:)
   !> Map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)    :: saoshell(:,:)
   integer, intent(in)    :: nprim(:)
   !> Index of first primitive (over entire system) of given CAO, dimension: nbf
   integer, intent(in)    :: primcount(:)
   real(wp),intent(in)    :: alp(:)
   real(wp),intent(in)    :: cont(:)
   !> Density matrix
   real(wp),intent(in) :: p(:, :)
   !> Energy weighted density matrix
   real(wp),intent(in) :: Pew(:, :)
   real(wp),intent(inout) :: g(:, :)
   real(wp),intent(inout) :: sigma(:, :)
   real(wp),intent(inout) :: dhdcn(:)

   integer itt(0:3)
   parameter (itt=(/0,1,4,10/))
   real(wp) tmp1,tmp2,tmp3,step,step2,step3,s00r,s00l,s00,alpj,gama,t(0:8)
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,thr2,f,ci,cj,alpi,rij2,ab,est
   real(wp) f1,f2,tmp(6,6),rij(3),ri(3),rj(3)
   real(wp) stmp,ral(3,3),rar(3,3),rbl(3,3),pre
   real(wp) dtmp,qtmp,rbr(3,3),r2l(3),r2r(3),qqa(6,6,6,3)
   real(wp)  ss(6,6,3),ddc(3,6,6,3),qqc(6,6,6,3),dda(3,6,6,3)
   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij,jshmax
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,ixyz
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   real(wp) :: dum(3,9),sdq(6,6,10),sdqg(6,6,3,10),sdqg2(6,6,3,9)
   integer :: il, jl, itr
   real(wp) :: zi, zj, zetaij, km, hii, hjj, hav, shpoly, dshpoly(3)
   real(wp) :: Pij, Hij, HPij, g_xyz(3), e(3), kab, gm
   real(wp) :: cc,saw(10),sawg(3,10)
   real(wp), parameter :: rthr = 1600.0_wp

   ! sdq = 2880 B
   ! sdqg=  16416 B

   !$acc enter data copyin(nShell, hData, selfEnergy, dSEdcn, intcut, nat, nao, nbf, &
   !$acc& at, xyz, trans, caoshell, saoshell, nprim, primcount, alp, cont, &
   !$acc& p, Pew, ves, vs, vd, vq, dhdcn, g, sigma, &
   !$acc& hData%principalQuantumNumber(:, :), hData%angShell(:, :), hData%valenceShell(:, :),  &
   !$acc& hData%numberOfPrimitives(:, :), hData%slaterExponent(:, :), hData%selfEnergy(:, :), &
   !$acc& hData%referenceOcc(:, :), hData%kCN(:, :), hData%electronegativity(:), hData%atomicRad(:), &
   !$acc& hData%shellPoly(:, :), hData%pairParam(:, :), hData%kQShell(:, :), hData%kQAtom(:))

   thr2 = intcut
   ! call timing(t1,t3)

   !$acc parallel default(present) private(g_xyz,tmp,rij,ri,rj,ral,rar,rbl,rbr,r2l,r2r,qqa,&
   !$acc& ddc,qqc,dda,sdq,sdqg,sdqg2,dshpoly,saw,sawg,t,dum,e)

   !$acc loop gang collapse(2)
   do iat = 1, nat
      do jat = 1, nat
        if (jat.ge.iat) cycle

        ri = xyz(:,iat)
        izp = at(iat)
        jzp = at(jat)

         !$acc loop seq
         do ish = 1,nShell(izp)
            ishtyp = hData%angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(jzp)
            !              if(iat.eq.jat) jshmax = ish
            !$acc loop seq
            do jsh = 1,jshmax ! jshells
               jshtyp = hData%angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, izp)
               zj = hData%slaterExponent(jsh, jzp)
               zetaij = (2 * sqrt(zi*zj)/(zi+zj))**hData%wExp
               call h0scal(hData,il,jl,izp,jzp,hData%valenceShell(ish, izp).ne.0, &
                  & hData%valenceShell(jsh, jzp).ne.0,km)

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * km * (hii + hjj) * zetaij * evtoau

               !$acc loop seq
               do itr = 1, size(trans, dim=2)
                  rj = xyz(:,jat) + trans(:, itr)
                  rij = ri - rj
                  rij2 =  sum( rij**2 )

                  if (rij2 > rthr) cycle

                  ! distance dependent polynomial
                  call dshellPoly(hData%shellPoly(il,izp),hData%shellPoly(jl,jzp),&
                     & hData%atomicRad(izp),hData%atomicRad(jzp),rij2,ri,rj,&
                     & shpoly,dshpoly)

                  sdqg = 0.0_wp
                  sdq  = 0.0_wp

                  ! we go through the primitives (because the screening is the same for all of them)
                  !$acc loop seq collapse(2) private(t,e,saw,sawg)
                  do ip = 1,nprim(icao+1)
                     do jp = 1,nprim(jcao+1)
                       iprim = ip+primcount(icao+1)
                       jprim = jp+primcount(jcao+1)
                       ! exponent the same for each l component
                       alpi = alp(iprim)
                       alpj = alp(jprim)
                       gama = alpi+alpj
                       gm = 1.0_wp/gama
                       est = alpi*alpj*rij2*gm
                       if(est.gt.intcut) cycle
                       e = (alpi*ri + alpj*rj)*gm
                       kab = exp(-est)*(sqrt(pi)*sqrt(gm))**3
                       !$acc loop seq
                       do k = 0, 8
                          t(k) = olapp(k, gama)
                       end do
                       !$acc loop vector collapse(2) private(saw,sawg)
                        do mli = 1,naoi
                           do mlj = 1,naoj
                             !--------------- compute gradient ----------
                             ! now compute integrals  for different components of i(e.g., px,py,pz)
                             iprim = ip+primcount(icao+mli)
                             ! coefficients NOT the same (contain CAO2SAO lin. comb. coefficients)
                             ci = cont(iprim)
                             jprim = jp+primcount(jcao+mlj)
                             cc = cont(jprim)*ci*kab
                             saw = 0
                             sawg = 0
                             call build_dsdq_ints_gpu(ri,rj,rj,alpi,alpj,t,e,&
                                & iptyp+mli,jptyp+mlj,saw,sawg)
                             sdq(mlj,mli,:) = sdq(mlj,mli,:) + saw*cc
                             sdqg(mlj,mli,:,:) = sdqg(mlj,mli,:,:) + sawg*cc
                           enddo ! mlj : Cartesian component of j prims
                        enddo ! mli : Cartesian component of i prims
                     enddo ! jp : loop over j prims
                  enddo ! ip : loop over i prims
                  !$acc loop vector collapse(2) private(saw, sawg)
                  do mli = 1,naoi
                     do mlj = 1,naoj
                        saw = sdq(mlj,mli,:)
                        sawg = sdqg(mlj,mli,:,:)
                        call shiftintg_gpu(dum,sawg,saw,rij)
                        sdqg2(mlj,mli,:,:) = dum
                     enddo
                  enddo

                  call dtrf2_gpu(sdq(1:6,1:6,1),ishtyp,jshtyp)
                  !$acc loop seq collapse(2)
                  do k = 1,10 ! 1 S, 2-4 D, 5-10 Q
                     do ixyz = 1,3
                        ! transform from CAO to SAO
                        call dtrf2_gpu(sdqg(1:6,1:6,ixyz,k),ishtyp,jshtyp)
                     enddo
                  enddo
                  !$acc loop seq collapse(2)
                  do k = 1,9 ! 1-3 D, 4-9 Q
                     do ixyz = 1,3
                        ! transform from CAO to SAO
                        call dtrf2_gpu(sdqg2(1:6,1:6,ixyz,k),ishtyp,jshtyp)
                     enddo
                  enddo
                  g_xyz(:) = 0.0_wp
                  !$acc loop vector collapse(2)
                  do ii = 1,llao2(ishtyp)
                     do jj = 1,llao2(jshtyp)
                        iao = ii+saoshell(ish,iat)
                        jao = jj+saoshell(jsh,jat)
                        Pij = p(jao,iao)

                        ! Hamiltonian element without overlap
                        Hij  = hav * shpoly
                        HPij = Hij * Pij

                        !$acc loop seq
                        do ixyz = 1,3
                           !$acc atomic
                           g_xyz(ixyz) = g_xyz(ixyz) + 2*HPij*sdq(jj,ii,1)*dshpoly(ixyz)/shpoly
                           stmp = sdqg(jj,ii,ixyz,1)*(2*HPij - 2*Pew(jao, iao) &
                              & -Pij*(ves(ish,iat)+ves(jsh,jat)) &
                              & +Pij*(vs(iat)+vs(jat)))
                           !$acc atomic
                           g_xyz(ixyz) = g_xyz(ixyz)+stmp
                           dtmp = Pij*sum(sdqg2(jj,ii,ixyz,1:3)*vd(1:3,iat) &
                              & +sdqg(jj,ii,ixyz,2:4)*vd(1:3,jat) )
                           !$acc atomic
                           g_xyz(ixyz) = g_xyz(ixyz)+dtmp
                           qtmp = Pij*sum(sdqg2(jj,ii,ixyz,4:9)*vq(1:6,iat) &
                              & +sdqg(jj,ii,ixyz,5:10)*vq(1:6,jat) )
                           !$acc atomic
                           g_xyz(ixyz) = g_xyz(ixyz)+qtmp

                        enddo ! ixyz

                        ! Hamiltonian without Hav
                        HPij = km * zetaij * shpoly * Pij * sdq(jj,ii,1) * evtoau
                        ! save dE/dCN for CNi
                        !$acc atomic
                        dhdcn(iat) = dhdcn(iat) + HPij*dSEdcn(ish, iat)
                        ! save dE/dCN for CNj
                        !$acc atomic
                        dhdcn(jat) = dhdcn(jat) + HPij*dSEdcn(jsh, jat)
                     enddo
                  enddo

                  do k=1,3
                    !$acc atomic
                    g(k,iat) = g(k,iat)+g_xyz(k)
                    !$acc atomic
                    g(k,jat) = g(k,jat)-g_xyz(k)
                  enddo

                  do l=1,3
                    !$acc atomic
                    sigma(1,l) = sigma(1,l) + g_xyz(1) * rij(l)
                    !$acc atomic
                    sigma(2,l) = sigma(2,l) + g_xyz(2) * rij(l)
                    !$acc atomic
                    sigma(3,l) = sigma(3,l) + g_xyz(3) * rij(l)
                  enddo
                  
               enddo ! lattice translations
            enddo ! jsh : loop over shells on jat
         enddo  ! ish : loop over shells on iat
      enddo ! jat
   enddo  ! iat
   !$acc end parallel
   !                                                      call timing(t2,t4)
   !                                     call prtime(6,t2-t1,t4-t3,'dqint5')
   !$acc exit data copyout(dhdcn, g, sigma)

   ! diagonal contributions
   !$omp parallel do default(none) reduction(+:dhdcn) &
   !$omp shared(nat, at, nshell, hData, saoshell, P, dSEdcn) &
   !$omp private(iat, izp, ish, ishtyp, iao, i, Pij)
   do iat = 1, nat
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = hData%angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)

            Pij = P(i,i)
            ! save dE/dCN for CNi
            dhdcn(iat) = dhdcn(iat) + Pij*dSEdcn(ish, iat)*evtoau
         end do
      end do
   end do
   !$omp end parallel do

   !$acc exit data delete(nShell, hData, selfEnergy, dSEdcn, intcut, nat, nao, nbf, &
   !$acc& at, xyz, trans, caoshell, saoshell, nprim, primcount, alp, cont, &
   !$acc & p, Pew, ves, vs, vd, vq, &
   !$acc& hData%principalQuantumNumber(:, :), hData%angShell(:, :), hData%valenceShell(:, :),  &
   !$acc& hData%numberOfPrimitives(:, :), hData%slaterExponent(:, :), hData%selfEnergy(:, :), &
   !$acc& hData%referenceOcc(:, :), hData%kCN(:, :), hData%electronegativity(:), hData%atomicRad(:), &
   !$acc& hData%shellPoly(:, :), hData%pairParam(:, :), hData%kQShell(:, :), hData%kQAtom(:))
end subroutine build_dSDQH0_gpu


subroutine dtrf_gpu(s,li,lj)
   !$acc routine seq
   implicit none
   real(wp),intent(inout) :: s(6,6)
   integer, intent(in)    :: li,lj
   ! CAO-AO transformation
   real(wp), parameter :: trafo(6,6) = reshape((/ & ! copied from scf.f, simplyfied
      ! --- dS
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & sqrt(1.0_wp/5.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp, &
      ! --- dx²-y²
      & 0.5_wp*sqrt(3.0_wp), &
      &-0.5_wp*sqrt(3.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp, &
      ! --- dz²
      & 0.5_wp,0.5_wp,-1.0_wp, &
      & 0.0_wp,0.0_wp, 0.0_wp, &
      ! --- rest
      & 0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp /), shape(trafo))

   real(wp) s2(6,6),sspher,dum(6,6)
   integer ii,jj,m,n

   !     transformation not needed for pure s/p overlap -> do nothing
   if (li.lt.2.and.lj.lt.2) return

   ! --- means li.ge.2.or.lj.ge.2, so one of them is a d-shell
   !     assuming its on jat ... a wild guess
   select case(li)
   case(0) ! s-d
      do jj=1,6
         sspher=0
         do m=1,6
            sspher=sspher+trafo(m,jj)*s(m,1)
         enddo
         s2(jj,1)=sspher
      enddo
      s(1:5,1) = s2(2:6,1)
      return
   case(1) ! p-d
      do ii=1,3
         do jj=1,6
            sspher=0
            do m=1,6
               sspher=sspher+trafo(m,jj)*s(m,ii)
            enddo
            s2(jj,ii)=sspher
         enddo
         s(1:5,ii) = s2(2:6,ii)
      enddo
      return
   end select
   !     wasn't there, then try iat ...
   select case(lj)
   case(0) ! d-s
      do jj=1,6
         sspher=0
         do m=1,6
            sspher=sspher+trafo(m,jj)*s(1,m)
         enddo
         s2(1,jj)=sspher
      enddo
      s(1,1:5) = s2(1,2:6)
      return
   case(1) ! d-p
      do ii=1,3
         do jj=1,6
            sspher=0
            do m=1,6
               sspher=sspher+trafo(m,jj)*s(ii,m)
            enddo
            s2(ii,jj)=sspher
         enddo
         s(ii,1:5) = s2(ii,2:6)
      enddo
      return
   end select
   !     if not returned up to here -> d-d
   ! CB: transposing s in first dgemm is important for integrals other than S
   do ii=1,6
      do jj=1,6
         sspher = 0.0_wp
         do m=1,6
            sspher = sspher + trafo(m,ii) * s(m,jj)
         enddo
         dum(ii,jj) = sspher
      enddo
   enddo
   do ii=1,6
      do jj=1,6
         sspher = 0.0_wp
         do m=1,6
            sspher = sspher + dum(ii,m) * trafo(m,jj)
         enddo
         s2(ii,jj) = sspher
      enddo
   enddo
   s(1:5,1:5) = s2(2:6,2:6)

end subroutine dtrf_gpu


subroutine dtrf2_gpu(s,li,lj)
   !$acc routine seq
   implicit none
   real(wp),intent(inout) :: s(6,6)
   integer, intent(in)    :: li,lj
   ! CAO-AO transformation
   real(wp), parameter :: trafo(6,5) = reshape((/ & ! copied from scf.f, simplyfied
      ! --- dx²-y²
      & 0.5_wp*sqrt(3.0_wp), &
      &-0.5_wp*sqrt(3.0_wp), &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp, &
      ! --- dz²
      & 0.5_wp,0.5_wp,-1.0_wp, &
      & 0.0_wp,0.0_wp, 0.0_wp, &
      ! --- rest
      & 0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp,0.0_wp, &
      & 0.0_wp,0.0_wp,0.0_wp,0.0_wp,0.0_wp,1.0_wp /), shape(trafo))

   real(wp) s2(6,6),sspher,dum(6,6)
   integer ii,jj,m,n

   !     transformation not needed for pure s/p overlap -> do nothing
   if (li.lt.2.and.lj.lt.2) return

   ! --- means li.ge.2.or.lj.ge.2, so one of them is a d-shell
   !     assuming its on jat ... a wild guess
   select case(li)
   case(0) ! s-d
      do jj=1,5
         sspher=0
         do m=1,6
            sspher=sspher+trafo(m,jj)*s(m,1)
         enddo
         s2(jj,1)=sspher
      enddo
      s(1:5,1) = s2(1:5,1)
      return
   case(1) ! p-d
      do ii=1,3
         do jj=1,5
            sspher=0
            do m=1,6
               sspher=sspher+trafo(m,jj)*s(m,ii)
            enddo
            s2(jj,ii)=sspher
         enddo
         s(1:5,ii) = s2(1:5,ii)
      enddo
      return
   end select
   !     wasn't there, then try iat ...
   select case(lj)
   case(0) ! d-s
      do jj=1,5
         sspher=0
         do m=1,6
            sspher=sspher+trafo(m,jj)*s(1,m)
         enddo
         s2(1,jj)=sspher
      enddo
      s(1,1:5) = s2(1,1:5)
      return
   case(1) ! d-p
      do ii=1,3
         do jj=1,5
            sspher=0
            do m=1,6
               sspher=sspher+trafo(m,jj)*s(ii,m)
            enddo
            s2(ii,jj)=sspher
         enddo
         s(ii,1:5) = s2(ii,1:5)
      enddo
      return
   end select
   !     if not returned up to here -> d-d
   ! CB: transposing s in first dgemm is important for integrals other than S
   do ii=1,5
      do jj=1,6
         sspher = 0.0_wp
         do m=1,6
            sspher = sspher + trafo(m,ii) * s(m,jj)
         enddo
         dum(ii,jj) = sspher
      enddo
   enddo
   do ii=1,5
      do jj=1,5
         sspher = 0.0_wp
         do m=1,6
            sspher = sspher + dum(ii,m) * trafo(m,jj)
         enddo
         s2(ii,jj) = sspher
      enddo
   enddo
   s(1:5,1:5) = s2(1:5,1:5)

end subroutine dtrf2_gpu


! --------------------------------------------------------------[SAW1801]-
!> move gradient operator from center a to center b
pure subroutine shiftintg_gpu(g2,g,s,r)
   !$acc routine vector
   implicit none
   real(wp),intent(in) :: g(3,10)
   real(wp),intent(out) :: g2(3,9)
   real(wp),intent(in) :: s(10),r(3)
   g2(:,1)=g(:,2)-r(1)*g(:,1)
   g2(:,2)=g(:,3)-r(2)*g(:,1)
   g2(:,3)=g(:,4)-r(3)*g(:,1)
   g2(:,4)=g(:,5)-2*r(1)*g(:,2)+r(1)**2*g(:,1)
   g2(:,5)=g(:,6)-2*r(2)*g(:,3)+r(2)**2*g(:,1)
   g2(:,6)=g(:,7)-2*r(3)*g(:,4)+r(3)**2*g(:,1)
   g2(:,7)=g(:,8)-r(1)*g(:,3)-r(2)*g(:,2)+r(1)*r(2)*g(:,1)
   g2(:,8)=g(:,9)-r(1)*g(:,4)-r(3)*g(:,2)+r(1)*r(3)*g(:,1)
   g2(:,9)=g(:,10)-r(2)*g(:,4)-r(3)*g(:,3)+r(2)*r(3)*g(:,1)
   g2(1,1)=g2(1,1)-s(1)
   g2(2,2)=g2(2,2)-s(1)
   g2(3,3)=g2(3,3)-s(1)
   g2(1,4)=g2(1,4)-2*s(2)+2*r(1)*s(1)
   g2(2,5)=g2(2,5)-2*s(3)+2*r(2)*s(1)
   g2(3,6)=g2(3,6)-2*s(4)+2*r(3)*s(1)
   g2(1,7)=g2(1,7)-s(3)+r(2)*s(1)
   g2(2,7)=g2(2,7)-s(2)+r(1)*s(1)
   g2(1,8)=g2(1,8)-s(4)+r(3)*s(1)
   g2(3,8)=g2(3,8)-s(2)+r(1)*s(1)
   g2(2,9)=g2(2,9)-s(4)+r(3)*s(1)
   g2(3,9)=g2(3,9)-s(3)+r(2)*s(1)
end subroutine shiftintg_gpu


end module xtb_xtb_hamiltonian_gpu

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_dynamic
   use xtb_io_writer, only : writeMolecule
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType
   use xtb_single, only : singlepoint
   use xtb_intmodes, only : xyzgeo
   use xtb_metadynamic

contains
!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

pure subroutine xyzsort(n,lab,ew,xyz,list)
   implicit none
   integer, intent(in) :: n
   integer, intent(in) :: lab
   integer, intent(inout) :: list(*)
   real(wp),intent(inout) :: ew(*)
   real(wp),intent(inout) :: xyz(3,n,*)
   integer  :: i,ii,j,k,m
   integer  :: ihilf
   real(wp) :: pp,hilf

   do ii = 2, lab
      i = ii - 1
      k = i
      pp= ew(i)
      do j = ii, lab
         if (ew(j) .gt. pp) cycle
         k = j
         pp= ew(j)
      enddo
      if (k .eq. i) cycle
      ew(k) = ew(i)
      ew(i) = pp

      ihilf=list(i)
      list(i)=list(k)
      list(k)=ihilf
      do m=1,n
         do j=1,3
            hilf=xyz(j,m,i)
            xyz(j,m,i)=xyz(j,m,k)
            xyz(j,m,k)=hilf
         enddo
      enddo
   enddo

end subroutine xyzsort

pure subroutine xyzsort2(ndim,n,lab,ew,xyz)
   implicit none
   integer, intent(in) :: ndim
   integer, intent(in) :: n
   integer, intent(in) :: lab
   real(wp),intent(inout) :: ew(0:ndim)
   real(wp),intent(inout) :: xyz(3,n,*)
   integer  :: i,ii,j,k,m
   real(wp) :: pp, hilf

   do ii = 2, lab
      i = ii - 1
      k = i
      pp= ew(i)
      do j = ii, lab
         if (ew(j) .gt. pp) cycle
         k = j
         pp= ew(j)
      enddo
      if (k .eq. i) cycle
      ew(k) = ew(i)
      ew(i) = pp

      do m=1,n
         do j=1,3
            hilf=xyz(j,m,i)
            xyz(j,m,i)=xyz(j,m,k)
            xyz(j,m,k)=hilf
         enddo
      enddo
   enddo

end subroutine xyzsort2

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine wrc(fname,n,xyz,at)
   use xtb_setparam
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   character*(*) fname
   integer n,at(n),j
   real(wp) xyz(3,n)
   integer :: ich ! file handle

   call open_file(ich,fname,'w')
   write(ich,'(''$coord'')')
   do j=1,n
      write(ich,'(3F24.10,5x,a2)') xyz(1:3,j),toSymbol(at(j))
   enddo
   write(ich,'(''$end'')')
   write(ich,'(''$set'')')
   write(ich,'('' chrg     '',i2)') set%ichrg
   write(ich,'('' uhf      '',i2)') set%nalphabeta
   write(ich,'(''$end'')')
   call close_file(ich)

end subroutine wrc

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine boltz(n,t,e,p)
   implicit none
   integer,  intent(in)  :: n
   real(wp), intent(in)  :: t
   real(wp), intent(in)  :: e(n)
   real(wp), intent(out) :: p(n)
   real(wp) f
   f = 8.31451_wp * t / 4.184e+3_wp
   p = exp(-e/f)
   p = p / sum(p)
end subroutine boltz

subroutine md(env,mol,chk,calc, &
      &       egap,et,maxiter,epot,grd,sigma,icall,Tsoll,cdump2)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autokcal, aatoau, amutokg, amutoau, fstoau
   use xtb_mctc_constants, only : pi, kB
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_type_restart
   use xtb_type_data
   use xtb_shake, only: do_shake,ncons
   use xtb_setparam
   use xtb_fixparam
   use xtb_scanparam
   use xtb_splitparam
   use xtb_type_setvar, only: metadyn_setvar
   implicit none

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule),intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   integer  :: icall
   integer, intent(in) :: maxiter
   integer, intent(inout) :: cdump2
   real(wp), intent(inout) :: epot
   real(wp), intent(in) :: et
   real(wp), intent(inout) :: egap
   real(wp), intent(inout) :: grd(3,mol%n)
   real(wp), intent(inout) :: sigma(3,3)
   real(wp), intent(in) :: Tsoll
   type(scc_results) :: res

   real(wp) :: step,eel1,tstep,taut,xlam2,accu,driftthr
   real(wp) :: Ekin,tmass,f,mintime
   real(wp) :: Tinit,Tav,T,epav,ekav,dav,cma(3),bave,bavt
   real(wp) :: dum,edum,eerror,xx(10),molmass,slope,maxtime
   real(wp) :: tstep0,tmax,nfreedom,t0,w0,t1,w1,ep_prec,rege(4)
   real(wp) :: tors(mol%n),be(3),b0(3),tor,dip(3)
   real(wp) :: rcoord(3)
   logical  :: ex,thermostat,restart,confdump,equi,gmd,ldum

   integer :: i,j,k,ic,jc,ia,ja,ii,jj,ndum,cdump,nmax,ibin
   integer :: nstep,ndump,mdump,dumpstep,screendump,acount
   integer :: cdump0,nbo(0:20,mol%n),k3,nreg,ngeoav
   integer :: blockl,iblock,nblock
   real(wp),allocatable :: velo(:,:)
   real(wp),allocatable :: vel (:,:)
   real(wp),allocatable :: veln(:,:)
   real(wp),allocatable :: xyzo(:,:)
   real(wp),allocatable :: acc (:,:)
   real(wp),allocatable :: tmpx(:,:)
   real(wp),allocatable :: mass(:)
   real(wp),allocatable :: blocke(:),blockt(:)
   real(wp),allocatable :: intgeo(:,:),intgeo0(:,:)
   real(wp),allocatable :: intgeoav(:,:),tmpg(:,:)
   integer, allocatable :: na(:),nb(:),nc(:)
   character(len=80) :: atmp
   character(len=:),allocatable :: fname
   integer :: ich,trj,pdb,imdl
   logical :: exist

   ! Displace reference geometry by 1e-6
   real(wp), parameter :: atom_displacement = 1.0e-6_wp

   type(metadyn_setvar) :: metasetlocal
   real(wp) :: emtd
   real(wp) :: metatime
   metatime = 0.0_wp

   call delete_file('xtbmdok')

   if(icall.eq.0)then
      write(*,*)'trajectories on xtb.trj or xtb.trj.<n>'
   endif

   ! special equi and GMD settings
   tmax=set%time_md
   equi=.false.
   gmd=.false.
   if(icall.eq.-1) equi = .true.   ! equilibration
   if(icall.eq.-2)  gmd = .true.   ! GMD production run

   if(equi) then
      mintime = 5.0d0              ! minimum time in ps
      maxtime = tmax               ! maximum time in ps
      driftthr=2.d-3               ! stop MD if drift = slope Epot (block average) regression (4 points) below this value
   endif
   if(gmd) then
      mintime = tmax               ! minimum time in ps
      maxtime = tmax * 4           ! maximum time in ps
      driftthr=1.d-3
   endif

   ! real coord dump to e.g. scoord.n in siman
   confdump=.false.
   if(nscan.eq.0.and.cdump2.ge.0) confdump=.true.
   if(set%ceasefiles) confdump=.false.
   ! just screen
   screendump=200

   ! blocklength for SD of energy and T
   blockl=min(5000,idint(5000/set%tstep_md))
   allocate(blocke(blockl),blockt(blockl))

   ! take paramters from common
   tstep0=set%tstep_md
   cdump0=set%dump_md/set%tstep_md    ! scoord
   dumpstep=set%dump_md2/set%tstep_md ! xyz
   thermostat=set%nvt_md
   restart=set%restart_md
   accu=set%accu_md

   allocate(velo(3,mol%n),vel(3,mol%n),veln(3,mol%n),xyzo(3,mol%n),acc(3,mol%n),mass(mol%n))

   call neighbor(mol%n,mol%xyz,mol%at,nbo) ! neighbor list
   molmass=0
   do i=1,mol%n
      molmass=molmass+atmass(i)
      mass(i)=atmass(i)*amutoau
   enddo
   tmass=molmass*amutoau
   do i=1,mol%n
      if(mol%at(i).eq.1.and.set%md_hmass.gt.0) then
         mass(i)=dble(set%md_hmass)*amutoau
         ! k=nbo(1,i) ! atom to which H is bonded
         ! mass(k)=mass(k)-mass(i)+ams(1)*amutoau ! reduce by the increase H mass
      endif
   enddo
   molmass=molmass*amutokg

   nmax=tmax*1000/tstep0
   if(gmd.or.equi) nmax=maxtime*1000/tstep0

   write(*,*)
   write(*,'('' MD time /ps        :'',f8.2)')tmax
   write(*,'('' dt /fs             :'',f8.2)')tstep0
   write(*,'('' SCC accuracy       :'',f8.2)')accu
   write(*,'('' temperature /K     :'',f8.2)')Tsoll
   write(*,'('' max steps          :'',i6  )')nmax
   write(*,'('' block length (av.) :'',i6  )')blockl
   write(*,'('' dumpstep(trj) /fs  :'',f8.2,i6)')set%dump_md2,dumpstep
   write(*,'('' dumpstep(coords)/fs:'',f8.2,i6)')set%dump_md,cdump0
   if(equi.or.gmd)then
      write(*,'('' minimum runtime(ps):'',f6.1)')mintime
      write(*,'('' maximum runtime(ps):'',f6.1)')maxtime
   endif
   if(set%md_hmass.gt.0) &
      &write(*,'('' H atoms mass (amu) :'',i6  )')set%md_hmass

   nfreedom = 3._wp*real(mol%n,wp)
   if(set%mdrtrconstr ) nfreedom = nfreedom - 6.0d0
   if(set%shake_md    ) nfreedom = nfreedom - dble(ncons)
   if(zconstr.eq.1) nfreedom = nfreedom - dble(iatf1)  ! fragment 1 in Z plane
   write(*,'('' # deg. of freedom  :'',i6  )')idint(nfreedom)

   taut=500. ! damping of thermostat, 1000 is slow heating
   if(equi) taut=100.

   Tinit=Tsoll
   if (equi) Tinit=0.3*Tsoll   ! slow equi

   if(.not.restart)then
      f=1
      if(.not.thermostat) f = 2
      edum=f*Tinit*0.5*kB*nfreedom
      call mdinitu(mol%n,mol%at,velo,mass,edum)
   else
      call rdmdrestart(mol%n,mol%xyz,velo)
   endif

   if(set%shake_md) then
      write(*,*) 'SHAKE on. # bonds  :',ncons,' all:',.not.set%xhonly
   else
      write(*,*) 'SHAKE off'
   endif
   if(thermostat)   write(*,*) 'Berendsen THERMOSTAT on'
   if(equi)       write(*,*) 'EQUILIBRATION mode'
   if( gmd)       write(*,*) 'GMD mode'
   if(restart)    write(*,*) 'RESTART'


   !--- For "true" metadynamics an independent RMSD potential
   !    is constructed for this MD. "metaset" contains alpha and k
   !    "metasetlocal" is the dynamic potential for the MTD.
   !    If an ensemble was read into "metaset", only a static RMSD bias is applied.

   metasetlocal = metaset
   if((metaset%nstruc > 0).and.(metaset%static))then !if >0, an ensemble was read --> static potential
       metasetlocal%maxsave=0 !save nothing new --> deactivate dynamic potential
   else
       metaset%nstruc=0  !avoid calculation of RMSD potential within singlepoint routine
                         !--> would lead to double counting with "metasetlocal"
   endif

   if ((metasetlocal%maxsave.gt.0) .or. (metaset%nstruc > 0)) then
      write(env%unit,'(" --- metadynamics parameter ---")')
      write(env%unit,'(" kpush  :",f9.3)') metasetlocal%global_factor
      write(env%unit,'(" alpha  :",f9.3)') metasetlocal%global_width
      write(env%unit,'(" update :",i8)')   metasetlocal%maxsave
      if((metasetlocal%ramp - 0.03_wp) .ne. 0.0_wp)then
      write(env%unit,'(" ramp   :",f9.3)') metasetlocal%ramp
      endif
      if (metasetlocal%nstruc.eq.0) then
         do i = 1, mol%n
            ! Generate randomly displaced geometry
            do
               ! Generate numbers in [0,1]
               call random_number(rcoord)
               ! Convert numbers to [-1, 1]
               rcoord = 2.0_wp*rcoord-1.0_wp
               ! Ensure that displacement is large enough so that it
               ! can be normalized to the unit sphere
               if(norm2(rcoord) >= 1e-8) then
                  exit
               endif
            enddo
            ! Normalize displacement to the unit sphere
            rcoord = rcoord/norm2(rcoord)
            ! Assign displaced geometry
            metasetlocal%xyz(:,i,1) = mol%xyz(:,i) + atom_displacement*rcoord
         enddo
         metasetlocal%nstruc = 1
      else
      write(env%unit,'(" number of input RMSDs :",i4)') metasetlocal%nstruc
      endif
   endif

   atmp='xtb.trj'
   if(icall.gt.0)then
      write(atmp,'(''xtb.trj.'',i0)')icall
   endif
   call open_file(trj,trim(atmp),'w')
   pdb = -1
   if (allocated(mol%pdb) .and. icall == 0) then
      call open_file(pdb, 'xtb-trj.pdb', 'w')
      imdl = 0
   end if

   if(.not.thermostat)then
      write(*,'(9x,''time (ps)'',4x,''<Epot>'',6x,''Ekin   <T>   T'',5x, &
         &         ''Etot'',7x,''error'','' '')')
   else
      write(*,'(9x,''time (ps)'',4x,''<Epot>'',6x,''Ekin   <T>   T'',5x, &
         &              ''Etot'')')
   endif

   tstep=tstep0*fstoau

   mdump=screendump
   ndump=dumpstep

   call ekinet(mol%n,velo,mass,Ekin)

   grd=0.0_wp
   epot=0.0_wp
   call singlepoint &
      &     (env,mol,chk,calc, &
      &      egap,et,maxiter,0,.true.,.false.,1.0_wp,epot,grd,sigma,res)

   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   ! MD loop
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   Edum   =Epot+Ekin
   Eerror =0
   Tav    =0
   Epav   =0
   Ekav   =0
   iblock =0
   nblock =0
   acount =0
   k3     =0
   ep_prec=0
   nreg   =0
   T      =0
   cdump  =0
   nstep  =0
   ngeoav =0

   call zeroz(mol%n,velo) ! optional z-plane fix
   !     call zero3n6(mol%n,velo,acc) ! fix 6 deg. of freedom
   call timing(t0,w0)
   do k=1,nmax

      !ccccccccccccccccccc
      ! calc E and forces                                       STEP 1
      !ccccccccccccccccccc
      accu=set%accu_md
      if(acount.eq.10)then  ! accurate SCC
         accu=1.0d0
         acount=0
      else
         acount=acount+1
      endif
      epot=0.0_wp
      grd = 0.0_wp
      call singlepoint &
         &     (env,mol,chk,calc, &
         &      egap,et,maxiter,0,.true.,.true.,accu,epot,grd,sigma,res)

      if (metasetlocal%maxsave.ne.0) then
         metatime = metatime + 1.0_wp
         metasetlocal%factor(1:metasetlocal%nstruc) = metasetlocal%global_factor
         metasetlocal%factor(metasetlocal%nstruc) = metasetlocal%factor(metasetlocal%nstruc) &
            &    * (2.0_wp/(1.0_wp+exp(-metasetlocal%ramp*metatime))-1.0_wp)
         if (cdump.gt.cdump0) then
            if (metasetlocal%nstruc.lt.metasetlocal%maxsave) then
               metatime = 0.0
               metasetlocal%nstruc = metasetlocal%nstruc + 1
               metasetlocal%xyz(:,:,metasetlocal%nstruc) = mol%xyz
            else
               do i = 2, metasetlocal%maxsave
                  metasetlocal%xyz(:,:,i-1) = metasetlocal%xyz(:,:,i)
               enddo
               metasetlocal%xyz(:,:,metasetlocal%maxsave) = mol%xyz
            endif
            write(*,'(2x,"adding snapshot to metadynamics bias")')
         endif
      !-------------------------------------------------------------------------
         emtd = 0.0d0
         call metadynamic (metasetlocal,mol%n,mol%at,mol%xyz,emtd,grd)
         epot = epot + emtd
      endif

      if(acount.eq.0)then  ! take only accurate Epot for average
         k3=k3+1
         ep_prec=ep_prec+epot
      endif

      ! okay, but you can also check for res%converged, can't you?
      if(epot.ne.epot.or. &
         &   epot.gt.1.d+5.or. &
         &   epot.lt.-1.d+5.or. & ! WHY?! this is completely resonable for >10000 atoms
         &   T.gt.10000) then
         write(*,*) epot,T
         write(*,*) 'MD is unstable, emergency exit '
         write(*,*) 'but still taking it as converged!'
         goto 1000
      endif

      if(k.eq.100)then
         call timing(t1,w1)
         write(*,'(''est. speed in wall clock h for 100 ps :'',f6.2)')  &
            &   100.0*(1000./tstep0)*(w1-w0)/100.0d0/3600.
      endif

      if(iblock.eq.blockl)then
         if(equi)then
            Tinit=Tinit*1.5
            Tinit=min(Tsoll,Tinit)
         endif
         nblock=nblock+1
         iblock=0
         call blocksd(mol%n,blockl,blocke,blockt,bave,bavt)
         nreg = nreg + 1
         rege(:) = [rege(2:), bave]
         if(nreg.ge.4)then
            call regress(1,4,rege,slope)
         else
            slope=99.
         endif
         write(*,'(''block <Epot> / <T> :'',f14.5,f6.0,5x, &
            &             ''drift:'',d10.2,3x,''Tbath :'',f5.0)')  &
            &             bave,bavt,slope,Tinit
      else
         iblock=iblock+1
         blocke(iblock)=epot
         blockt(iblock)=T
      endif

      !     dump coords to xyz and scoord
      !! ========================================================================
      ! dump for conformational sampling (scoor)
      if(cdump.gt.cdump0.and.confdump)then
         cdump2=cdump2+1
         call getname1(cdump2,atmp)
         call open_file(ich,trim(atmp),'w')
         call writeMolecule(mol, ich, fileType%tmol)
         call close_file(ich)
         cdump=0
      endif
      ! screen
      if(mdump.gt.screendump-1)then
         if(.not.thermostat)then
            write(*,'(i7,f8.2,F13.5,F9.4,2F6.0,F12.5,4F10.4)') &
               &   nstep,0.001*nstep*tstep/fstoau,Epav/k,Ekin,Tav/k,T,Epot+Ekin, &
               &   Edum/k-Epot-Ekin
         else
            write(*,'(i7,f8.2,F13.5,F9.4,2F6.0,F12.5,E14.6)') &
               &   nstep,0.001*nstep*tstep/fstoau,Epav/k,Ekin,Tav/k,T,Epot+Ekin
         endif
         mdump=0
      endif
      ! dump xyz (trj)
      if(ndump.gt.dumpstep-1)then
         ndump=0
         call writeMolecule(mol, trj, fileType%xyz, energy=epot, gnorm=res%gnorm)
         if(set%velodump)then
            do i=1,mol%n
               write(trj,'(3f20.14)')velo(1:3,i)
            enddo
         endif
         if (pdb /= -1) then
            imdl = imdl+1
            call writeMolecule(mol, pdb, fileType%pdb, number=imdl, &
               & energy=epot, gnorm=res%gnorm)
         end if
         if (set%forcewrrestart) then
            call wrmdrestart(mol%n,mol%xyz,velo)
         endif
      endif
      !! ========================================================================

      !     compute the accelaration at t
      do i=1,mol%n
         acc(:,i)=-grd(:,i)/mass(i)
      enddo

      call zeroz(mol%n,acc) ! z-plane fix
      ! call zero3n6(mol%n,velo,acc) ! fix 6 deg. of freedom

      ! store positions (at t); velocities are at t-1/2dt
      xyzo = mol%xyz

      !ccccccccccccccccccc
      ! temperature and pressure/density control               STEP 2
      !ccccccccccccccccccc

      ! estimate velocities at t
      veln = velo + 0.5d0*tstep*acc

      ! compute kinetic energy
      call ekinet(mol%n, veln, mass, Ekin)

      ! compute temperature
      T = 2.d0*Ekin/nfreedom/kB

      ! compute temperature scaling factors
      xlam2 = dsqrt(1.0d0 + (tstep0/taut)*(Tinit/T-1.0d0))

      !ccccccccccccccccccc
      ! velocity and position update                           STEP 3
      !ccccccccccccccccccc

      if(thermostat) then
         vel = xlam2 * (velo + acc*tstep)
      else
         vel = velo + acc*tstep
      endif

      ! update positions to t+dt
      mol%xyz = xyzo + vel*tstep

      !cccccccccccccccccc
      ! new temperature and pressure scaling factors
      !cccccccccccccccccc

      ! estimate velocities at t
      veln = 0.5d0*(velo + vel)

      ! compute kinetic energy
      call ekinet(mol%n, veln, mass, Ekin)

      ! compute temperature
      T = 2.d0*Ekin/nfreedom/kB

      ! compute temperature scaling factors
      if(thermostat) then
         xlam2 = dsqrt(1.0d0 + (tstep0/taut)*(Tinit/T-1.0d0))
      endif

      !ccccccccccccccccccc
      ! SHAKE (apply constraint at t+dt)
      !ccccccccccccccccccc

      if(set%shake_md) call do_shake(mol%n,xyzo,mol%xyz,vel,acc,mass,tstep)

      ! update velocities
      velo = vel

      ! remove trans/rot velocities
      call rmrottr(mol%n,mass,velo,mol%xyz)

      ! average internal coords
      if(gmd)then
         ngeoav=ngeoav+1
         tmpg=mol%xyz/aatoau
         call xyzgeo(tmpg,mol%n,na,nb,nc,1.d0,intgeo)
         do j=4,mol%n
            !          if(j.eq.20.or.j.eq.8)  write(*,*) j,tors(j),intgeo(3,j)
            if(tors(j)-intgeo(3,j).gt.pi)intgeo(3,j)=intgeo(3,j)+2.d0*pi ! check 0/180 torsion changes
            if(abs(tors(j)-intgeo(3,j)).gt.pi)then   ! check
               intgeo(3,j)=-2.0*pi-intgeo(3,j)
            endif
            if(abs(tors(j)-intgeo(3,j)).gt.pi) then  ! check
               intgeo(3,j)=-intgeo(3,j)
            endif
            if(abs(tors(j)-intgeo(3,j)).gt.pi) then  ! check
               intgeo(3,j)=2.*intgeo(3,j)
            endif
            if(abs(tors(j)-intgeo(3,j)).gt.pi) then  ! still in error
               write(*,*) j,tors(j),intgeo(3,j)
               stop 'error in md/zmat'
            endif
         enddo
         tors(1:mol%n)=intgeo(3,1:mol%n)
         intgeoav = intgeoav + intgeo-intgeo0
      endif

      ! compute averages
      nstep=nstep+1
      ndump=ndump+1
      mdump=mdump+1
      cdump=cdump+1
      Edum=Edum+Epot+Ekin
      Eerror=Edum/k-Epot-Ekin
      Tav =Tav+T
      Epav=Epav+epot
      Ekav=Ekav+ekin
      ! pmfav(k)=rcma

      if((equi.or.gmd).and.0.001*nstep*tstep/fstoau.gt.mintime)then ! check for equilibration end exit
         if( nblock.gt.1 .and. abs(bavt-Tinit)/Tinit.lt.0.02.and. &
            &       abs(slope).lt.driftthr) then
            write(*,*) 'GOOD AVERAGES REACHED'
            goto 1000
         endif
      endif
      if((equi.or.gmd).and.0.001*nstep*tstep/fstoau.gt.maxtime)then ! check for equilibration end exit
         write(*,*) 'MAXIMUM RUN TIME EXCEEDED'
         goto 1000
      endif

      ! end MD loop
   enddo

   ! exit
1000 call close_file(trj)
   if (pdb /= -1) then
      call close_file(pdb)
   end if

   write(*,*) 'average properties '
   write(*,*) 'Epot               :',Epav/k
   write(*,*) 'Epot (accurate SCC):',ep_prec/k3
   write(*,*) 'Ekin               :',Ekav/k
   write(*,*) 'Etot               :',(Ekav+Epav)/k
   write(*,*) 'T                  :',Tav/k

   if (abs(Tav/k-Tinit).gt.0.02*Tinit .and. &
      &   k.gt.500 .and. thermostat .and. (.not.equi)) &
      &   write(*,*)'thermostating problem'

   call wrmdrestart(mol%n,mol%xyz,velo)

   call touch_file('xtbmdok')

   write(*,*) 'normal exit of md()'

end subroutine md

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      pure subroutine regress(n1,n2,rege,slope)
      implicit none
      real(wp), intent(in) :: rege(:)
      real(wp), intent(out) :: slope
      integer, intent(in) :: n1,n2
      integer :: n,i
      real(wp) :: sx,sy,sxx,sxy,x

      n=n2-n1+1
      sx=0
      sy=0
      sxy=0
      sxx=0
      x=0
      do i=n1,n2
         x=x+1.
         sx=sx+x
         sy=sy+rege(i)
         sxx=sxx+x**2
         sxy=sxy+x*rege(i)
      enddo

      slope=(real(n, wp)*sxy-sx*sy)/(real(n, wp)*sxx-sx*sx)

      end subroutine regress

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine blocksd(n,nbl,ebl,tbl,esd,tsd)
      implicit none
      integer n,nbl
      real(wp) ebl(nbl),tbl(nbl),dum,av,esd,tsd
      integer i

      dum=0
      do i=1,nbl
         dum=dum+ebl(i)
      enddo
      av=dum/dble(nbl)
      esd=av

!     dum=0
!     do i=1,nbl
!        dum=dum+(ebl(i)-av)**2
!     enddo
!     esd=sqrt(dum/dble(nbl-1))/dble(n)

      dum=0
      do i=1,nbl
         dum=dum+tbl(i)
      enddo
      av=dum/dble(nbl)
      tsd=av
!     dum=0
!     do i=1,nbl
!        dum=dum+(tbl(i)-av)**2
!     enddo
!     tsd=sqrt(dum/dble(nbl-1))

      end

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine ekinet(n,velo,mass,E)
   implicit none
   real(wp) velo(3,n),mass(n),E
   integer n,i
   e=0
   do i=1,n
      e=e+mass(i)*(velo(1,i)**2+velo(2,i)**2+velo(3,i)**2)
   enddo
   e=e*0.5
end subroutine ekinet

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! rescale velos to get temperature tsoll
! H's get half of the velo

      subroutine veloscal(n,iat,velo,mass,tsoll,t)
      implicit none
      integer n
      real(wp) velo (3,n)
      real(wp) mass(n)
      integer iat(n),nh,i,j
      real(wp) velo2(3,n)
      real(wp) tsoll,t,edum,f

      velo = velo * sqrt(tsoll/t)

      velo2 = velo
      j=0
      f=0.5d0
 10   j=j+1
      do i=1,n
         if(iat(i).eq.1)then
            velo(1:3,i)=velo2(1:3,i)*f
         else
            velo(1:3,i)=velo2(1:3,i)
         endif
      enddo

 20   call ekinet(n,velo,mass,edum)
      t=edum/(0.5*3*n*0.316681534524639E-05)
      f=f+0.0001
      if(abs(t-tsoll).gt.1.and.j.lt.100000) goto 10

      end

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine wrmdrestart(n,xyz,velo)
   implicit none
   integer n,i
   real(wp) xyz(3,n),velo(3,n)
   integer :: ich

   call open_file(ich,'mdrestart','w')
   write(ich,*) '-1.0'
   do i=1,n
      write(ich,'(6D22.14)')xyz(1:3,i),velo(1:3,i)
   enddo
   call close_file(ich)

end subroutine wrmdrestart

subroutine rdmdrestart(n,xyz,velo)
   use xtb_setparam, only : get_namespace
   implicit none
   integer n,i
   real(wp) xyz(3,n),velo(3,n),dum
   integer :: ich
   character(len=:),allocatable :: fname

   call open_file(ich,'mdrestart','r')
   read(ich,*) dum
   do i=1,n
      read (ich,'(6D22.14)')xyz(1:3,i),velo(1:3,i)
   enddo
   call close_file(ich)

end subroutine rdmdrestart

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! initialize velocities uniformly
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine mdinitu(n,iat,velo,mass,Ekin)
   use xtb_setparam
   implicit none
   integer n
   real(wp) velo(3,n)
   integer iat(n)
   real(wp) mass(n)
   real(wp) Ekin
   real x,ranf

   real(wp) eperat,v,f,t,edum,f2
   integer i,j
   integer, allocatable :: iseed(:)

   call initrand

   eperat=Ekin/(3.0*n)

   do i=1,n
      f2=1
      if(iat(i).eq.1) f2=2
      v=sqrt(2*eperat/mass(i))
      f=1.0d0
      call random_number(x)
      if(x.gt.0.5)f=-1.0d0
      velo(1,i)=v*f*f2
      f=1.0d0
      call random_number(x)
      if(x.gt.0.5)f=-1.0d0
      velo(2,i)=v*f*f2
      f=1.0d0
      call random_number(x)
      if(x.gt.0.5)f=-1.0d0
      velo(3,i)=v*f*f2
   enddo

   call ekinet(n,velo,mass,edum)

   t=edum/(0.5*3*n*0.316681534524639E-05)

end subroutine mdinitu

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! integer random number n=<irand<=1

integer function irand(n)
   integer n
   real x,ranf
   call random_number(x)
   irand=n*x
   if(irand.lt.1) irand=1
   if(irand.gt.n) irand=n
end function irand

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine zeroz(n,array)
   use xtb_splitparam
   use xtb_scanparam
   implicit none
   integer n
   real(wp) array(3,*)
   integer i

   if(zconstr.eq.0) return

   do i=1,n
      if(splitlist(i).eq.1) array(3,i) = 0
   enddo

   return
end subroutine zeroz

subroutine zero3n6(n,v,a)
   use xtb_setparam
   implicit none
   integer n
   real(wp) a(3,n),v(3,n)

   if(.not.set%mdrtrconstr) return

   a(1:3,n)=0.d0
   a(1:2,n-1)=0.d0
   a(1,n-2)=0.d0
   v(1:3,n)=0.d0
   v(1:2,n-1)=0.d0
   v(1,n-2)=0.d0

   return
end subroutine zero3n6

end module xtb_dynamic

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Defines the API version for xtb
module xtb_api_version
   use, intrinsic :: iso_c_binding
   implicit none
   private

   public :: getAPIVersion_api

   integer(c_int), parameter :: apiMajor = 1
   integer(c_int), parameter :: apiMinor = 0
   integer(c_int), parameter :: apiPatch = 0


contains


function getAPIVersion_api() result(version) &
      & bind(C, name="xtb_getAPIVersion")
   !DEC$ ATTRIBUTES DLLEXPORT :: getAPIVersion_api
   integer(c_int) :: version

   version = 10000_c_int * apiMajor + 100_c_int * apiMinor + apiPatch

end function getAPIVersion_api


end module xtb_api_version

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_pbc_tools
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   implicit none
   private

   public :: collect_pbc_tools

contains

!> Collect all exported unit tests
subroutine collect_pbc_tools(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("cutoff", test_pbc_tools_cutoff), &
      new_unittest("convert", test_pbc_tools_convert) &
      ]

end subroutine collect_pbc_tools


subroutine test_pbc_tools_convert(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_pbc_tools
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   real(wp),parameter :: cellpar(6) = &
      [9.09903131_wp, 9.09903131_wp, 30.46049560_wp, 90.0_wp, 90.0_wp, 120.0_wp]
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[5.9598811567890_wp,      2.1071361905157_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      6.3214085715472_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      0.0000000000000_wp,      7.2993338808807_wp],   &
      & shape(lattice))
   real(wp) :: dlat(3,3),rlat(3,3),volume,cpar(6),center(3)

   call cell_to_dlat(cellpar,dlat)
   call check(error, cellpar(1),dlat(1,1), thr=thr)
   call check(error, dlat(1,3),-13.648544412579_wp, thr=thr)
   call check(error, dlat(3,3), 26.878966813429_wp, thr=thr)

   call cell_to_rlat(cellpar,rlat)
   call check(error, rlat(1,1), 0.69053343077018_wp, thr=thr)
   call check(error, rlat(2,1),-0.96832302603374_wp, thr=thr)
   call check(error, rlat(3,2), 0.19327597283376_wp, thr=thr)

   volume = cell_to_dvol(cellpar)
   call check(error, volume,1292.0766773144_wp, thr=thr)

   call dlat_to_cell(lattice,cpar)
   call check(error, cpar(1),cpar(2), thr=thr)
   call check(error, cpar(3),7.2993338808807_wp, thr=thr)
   call check(error, cpar(4),1.0471975511966_wp, thr=thr)

   call dlat_to_rlat(lattice,rlat)
   call check(error, rlat(1,1), 1.0542467445047_wp, thr=thr)
   call check(error, rlat(1,3),-.35141558150155_wp, thr=thr)
   call check(error, rlat(2,2), .99395336277746_wp, thr=thr)

   volume = dlat_to_dvol(lattice)
   call check(error, volume, 275.00126402469_wp, thr=thr)

   center = get_center_dlat(lattice)
   call check(error, center(1),2.9799405783945_wp, thr=thr)
   call check(error, center(2),4.2142723810314_wp, thr=thr)

end subroutine test_pbc_tools_convert

subroutine test_pbc_tools_cutoff(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_pbc_tools
   use xtb_pbc
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   real(wp),parameter :: lattice_1(3,3) = reshape(&
      &[9.0990313100000_wp,      0.0000000000000_wp,      0.0000000000000_wp,    &
      & 7.4082581428274_wp,      5.2829993440840_wp,      0.0000000000000_wp,    &
      &-13.648544412579_wp,     -4.3680854682659_wp,      26.878966813429_wp],   &
      & shape(lattice_1))
   real(wp),parameter :: lattice_2(3,3) = reshape(&
      &[5.9598811567890_wp,      2.1071361905157_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      6.3214085715472_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      0.0000000000000_wp,      7.2993338808807_wp],   &
      & shape(lattice_2))
   real(wp),parameter :: rthr_1 =  40.0_wp ** 2
   real(wp),parameter :: rthr_2 =  70.0_wp ** 2
   real(wp),parameter :: rthr_3 = 100.0_wp ** 2
   integer :: rep(3)

   call get_realspace_cutoff(lattice_1,rthr_1,rep)
   call check(error, rep(1), 8)
   call check(error, rep(3), 2)

   call get_realspace_cutoff(lattice_1,rthr_2,rep)
   call check(error, rep(2),14)
   call check(error, rep(3), 3)

   call get_realspace_cutoff(lattice_1,rthr_3,rep)
   call check(error, rep(1),20)
   call check(error, rep(2),20)
   call check(error, rep(3), 4)

   call get_realspace_cutoff(lattice_2,rthr_1,rep)
   call check(error, rep(1),rep(2))
   call check(error, rep(3), 7)

   call get_realspace_cutoff(lattice_2,rthr_2,rep)
   call check(error, rep(1),rep(3))
   call check(error, rep(2),12)

   call get_realspace_cutoff(lattice_2,rthr_3,rep)
   call check(error, rep(3),rep(2))
   call check(error, rep(1),17)

end subroutine test_pbc_tools_cutoff

end module test_pbc_tools

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_io_reader_orca
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_symbols, only : toNumber, symbolLength
   use xtb_type_molecule
   use xtb_pbc_tools
   use xtb_type_reader
   use xtb_readin, only : getline => strip_line
   implicit none
   private

   public :: readHessianOrca


   logical, parameter :: debug = .false.


contains


subroutine readHessianOrca(hessian, reader, mol, status, iomsg)

   real(wp), intent(out) :: hessian(:, :)
   type(TMolecule), intent(in) :: mol
   type(TReader), intent(inout) :: reader
   logical, intent(out) :: status
   character(len=:), allocatable, intent(out) :: iomsg
   character(len=:), allocatable :: line
   character(len=32) :: buffer
   integer :: nline
   real(wp),allocatable :: values(:)
   integer, allocatable :: list(:)
   integer :: error, ndim, ii, jj, jbatch, iline

   status = .false.
   iline = 1

   call reader%read(line, error)
   do while(error == 0)
      if (index(line, '$hessian') == 1) exit
      call reader%read(line, error)
      iline = iline + 1
   end do

   if (error /= 0) then
      iomsg = "Could not find $hessian data group"
      return
   end if

   allocate(list(5))
   allocate(values(5))
   call reader%read(line, error)
   iline = iline + 1
   read(line, *, iostat=error) ndim

   if (error /= 0) then
      iomsg = "Could not find dimension of ORCA Hessian"
      return
   end if

   rdlp: do 
      call reader%read(line, error)
      iline = iline + 1
      if (error /= 0) exit rdlp
      call linelen(line, nline)
      list=spread(0, 1, nline)
      values=spread(0.0_wp, 1, nline)
      if (nline == 0) exit rdlp
      read(line, *, iostat=error) list
      if (error /= 0) exit rdlp
      do ii=1, ndim
         call reader%read(line, error)
         iline = iline + 1
         if (error /= 0) exit rdlp
         read(line, *, iostat=error) jj, values
         if (error /= 0) exit rdlp
         hessian(list+1, jj+1) = values
      end do
      if (nline < 5) exit rdlp
   end do rdlp

   if (error /= 0) then
      if (is_iostat_end(error)) then
         iomsg = "Unexpected end of file while reading hessian"
      else
         write(buffer, '(i0)') iline
         iomsg = "Failed to read hessian in line "//trim(buffer)
      end if
      return
   end if

   status = .true.

end subroutine readHessianOrca


subroutine linelen(line,nline)
   character(len=*), intent(in) :: line
   integer, intent(out) :: nline
   integer :: istart, iend

   istart = 0
   iend = 0
   nline = 0
   do
      istart = verify(line(iend+1:), " ") - 1 + iend
      if (istart < iend) istart = len(line)
      iend = scan(line(istart+1:), " ") - 1 + istart
      if (iend < istart) iend = len(line)
      if (iend == len(line)) exit
      nline = nline +1
   end do
end subroutine linelen

end module xtb_io_reader_orca

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_cqpath
contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Repositionierung entlang des Reaktionspfads
!
! Methoden:
!   m_repos
!       1 - symmetrische Verteilung
!       2 - unsymmetrische Verteilung, höhere Dichte am pot. TS punkten
!   m_spline
!       1 - cubischer spline
!       2 - gedämpfter cubischer spline (constrained cubic spline)
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine cqpath_spline_repos(nat,sn,m_repos,m_spline,xyz,e,g)
    implicit none
    integer nat,sn,m_repos,m_spline
    real*8 xyz(3,nat,sn)
    real*8 e(sn)
    real*8 g(sn)

    integer :: i,j,k,l
    real(8), allocatable, dimension(:) :: strecke_X
    real(8), allocatable, dimension(:) :: strecke_N
    real(8), allocatable, dimension(:,:) :: sp_atom
    real(8), allocatable, dimension(:) :: xyz_0,xyz_1,xyz_diff
    real(8), allocatable, dimension(:) :: x,y,x2,y2
    real(8) :: strecke_X_inc, temp_strecke_X

    allocate (strecke_X(sn))
    allocate (strecke_N(sn))
    allocate (sp_atom(3,sn))
    allocate (xyz_0(3))
    allocate (xyz_1(3))
    allocate (xyz_diff(3))
    allocate (x(sn))
    allocate (y(sn))
    allocate (x2(sn))
    allocate (y2(sn))

!     print *,'cqpath_spline_repos'
!     print *,'repos  : ',m_repos
!     print *,'spline : ',m_spline

!       loop über alle atome um ein array der punte eines atoms entlang des pfads zu bekommen
    do i=1,nat
!           loop über den pfad
    do j=1,sn
        sp_atom(1,j) = xyz(1,i,j)
        sp_atom(2,j) = xyz(2,i,j)
        sp_atom(3,j) = xyz(3,i,j)
    end do
!           X-Achse für den Spline generieren = Strecke
    xyz_0(1) = sp_atom(1,1)
    xyz_0(2) = sp_atom(2,1)
    xyz_0(3) = sp_atom(3,1)
    strecke_X(1) = 0.0
    do j=2,sn
        xyz_1(1) = sp_atom(1,j)
        xyz_1(2) = sp_atom(2,j)
        xyz_1(3) = sp_atom(3,j)
        xyz_diff = xyz_1 - xyz_0
        xyz_0 = xyz_1
        strecke_X(j) = strecke_X(j-1) + sqrt(sum(xyz_diff**2))
    end do

!           Für x,y,z in abh. von strecke_X einen cube Spline machen
    do k=1,3
        ! X = strecke_X , Y = [x|y|z]
        do l=1,sn
            x(l) = strecke_X(l)
            y(l) = sp_atom(k,l)
        end do

! Repositionieren auf x
        call cqpath_repos(sn,m_repos,x,e,g,x2)

! y2-Werte auf dem spline an den repositionierten Punkten x2 bestimmen.
        if (m_spline == 1) then
            call cqpath_cube_spline(sn,x,y,x2,y2)
        end if
        if (m_spline == 2) then
            call cqpath_damped_cube_spline(sn,x,y,x2,y2)
        end if

        do l=1,sn
            sp_atom(k,l) = y2(l)
        end do
    end do
!           Neuen Punkte übertragen
    do j=2,sn-1
        xyz(1,i,j) = sp_atom(1,j)
        xyz(2,i,j) = sp_atom(2,j)
        xyz(3,i,j) = sp_atom(3,j)
    end do
    end do

    deallocate (strecke_X)
    deallocate (strecke_N)
    deallocate (sp_atom)
    deallocate (xyz_0)
    deallocate (xyz_1)
    deallocate (xyz_diff)
    deallocate (x)
    deallocate (y)
    deallocate (x2)
    deallocate (y2)
end

!!!!!!!!!!!!!! REPOSITIONIERUNG AUF DEM PFAD !!!!!!!!!!!!!!!!
subroutine cqpath_repos(n,m_repos,x,e,g,x2)
! in    n  - dimension von array x,y
!       x  - array x
!       e  - energien entlang des pfades
!       g  - gradienten entlang des pfades
! out   x2 - symmetrisch Punkte aus array x
!
! Methoden:
!   m_repos
!       1 - symmetrische Verteilung
!       2 - unsymmetrische Verteilung, höhere Dichte am pot. TS punkten
!
!
!
    implicit none
    integer, intent(in) :: n
    integer, intent(in) :: m_repos
    real(8), intent(in) :: x(n)
    real(8), intent(in) :: e(n)
    real(8), intent(in) :: g(n)
    real(8), intent(out) :: x2(n)

    real(8), allocatable :: e2(:)
    real(8) x_wert, x_anfang, x_ende, x_schritt
    real(8) emin,e2sum,temp_wert
    integer :: i

    ! Symmetrisch verteilen
    ! dx(i) = strecke/punkte
    if (m_repos == 1) then
        x_anfang = x(1)
        x_ende = x(n)
        x_schritt = (x_ende-x_anfang)/(REAL(n,8)-1.0)

        x_wert = x_anfang
        x2(1) = x_anfang
        do i=2,n-1
            x_wert = x_wert + x_schritt
            x2(i) = x_wert
        end do
        x2(n) = x_ende
    end if

    ! Asymmetrisch verteilen, in Abh. von e
    ! 1. e -> e' = -1.0*e                       ! umkehren
    ! 2. e' -> e'' = e' - e_min * 0.99          ! verschieben damit e_ts nicht = 0 ergibt
    ! 3. dx(i) = e''(i)/e''_summe               ! normieren
    if (m_repos == 2) then
        allocate(e2(n))

        x_anfang = x(1)
        x_ende = x(n)
        x2(1) = x_anfang
        x2(n) = x_ende
        x_schritt = x_ende-x_anfang

        emin = minval(e)*0.99
        do i=1,n
            e2(i) = (-1.0)*e(i)-emin
        end do
        e2sum = sum(e2)
        do i=1,n
            e2(i) = e2(i)/e2sum
        end do


        do i=2,n-1
!             x2(i) = x_anfang+x_schritt*e2(i)
            x_wert = x_wert + x_schritt*e2(i)
            x2(i) = x_wert
        end do

        deallocate(e2)
    end if

    ! Asymmetrisch verteilen, in Abh. von e
    ! 1. e -> e' = e*e                          ! umkehren
    ! 2. e' -> e'' = e' - e_min * 0.99          ! verschieben damit e_ts nicht = 0 ergibt
    ! 3. dx(i) = e''(i)/e''_summe               ! normieren
    if (m_repos == 3) then
        allocate(e2(n))

        x_anfang = x(1)
        x_ende = x(n)
        x2(1) = x_anfang
        x2(n) = x_ende
        x_schritt = x_ende-x_anfang

        emin = minval(e)*0.99
        do i=1,n
            e2(i) = e(i)*e(i)-emin
        end do
        e2sum = sum(e2)
        do i=1,n
            e2(i) = e2(i)/e2sum
        end do


        do i=2,n-1
!             x2(i) = x_anfang+x_schritt*e2(i)
            x_wert = x_wert + x_schritt*e2(i)
            x2(i) = x_wert
        end do

        deallocate(e2)
    end if

    ! Asymmetrisch verteilen, in Abh. von e
    ! 1. e -> e' = -1.0*e                       ! umkehren
    ! 2. e' -> e'' = (e' - e_min * 0.99)**2     ! verschieben damit e_ts nicht = 0 ergibt
    ! 3. dx(i) = e''(i)/e''_summe               ! normieren
    if (m_repos == 4) then
        allocate(e2(n))

        x_anfang = x(1)
        x_ende = x(n)
        x2(1) = x_anfang
        x2(n) = x_ende
        x_schritt = x_ende-x_anfang

        emin = minval(e)*0.99
        do i=1,n
            temp_wert = (-1.0)*e(i)-emin
            e2(i) = temp_wert*temp_wert
        end do
        e2sum = sum(e2)
        do i=1,n
            e2(i) = e2(i)/e2sum
        end do


        do i=2,n-1
!             x2(i) = x_anfang+x_schritt*e2(i)
            x_wert = x_wert + x_schritt*e2(i)
            x2(i) = x_wert
        end do

        deallocate(e2)
    end if
end

!!!!!!!!!!!!!! Y-Werte entlang der Repositionierung !!!!!!!!!!!!!!!!!!!!
subroutine cqpath_cube_spline(n,x,y,x2,y2)
! in    n  - dimension von array x,y
!       x  - array x
!       y  - array y
! out   x2 - symmetrisch Punkte aus array xx (eigentlich überflüssig)
!       y2 - symmetrische Punkte aus array yy
    implicit none
    integer, intent(in) :: n
    real(8), intent(in) :: x(n),y(n),x2(n)
    real(8), intent(out) :: y2(n)

    real(8), dimension(:), allocatable :: ypp
    real(8) y_wert, y_wert_ypval, y_wert_yppval
    integer :: i

    allocate (ypp(n))
    call spline_cubic_set ( n, x, y, 0, 0.0d0, 0, 0.0d0, ypp )
    y2(1) = y(1)
    do i=2,n-1
        call spline_cubic_val ( n, x, y, ypp, x2(i), y_wert, y_wert_ypval, y_wert_yppval )
        y2(i) = y_wert
    end do
    y2(n) = y(n)
    deallocate (ypp)
    return
end

subroutine cqpath_damped_cube_spline(n,x,y,x2,y2)
! in    n  - dimension von array x,y
!       x  - array x
!       y  - array y
! out   x2 - symmetrisch Punkte aus array xx (eigentlich überflüssig)
!       y2 - symmetrische Punkte aus array yy
    implicit none
    integer, intent(in) :: n
    real(8), intent(in) :: x(n),y(n),x2(n)
    real(8), intent(out) :: y2(n)

    real(8), dimension(:,:), allocatable :: abcd
    real(8) y_wert
    integer :: i

    allocate (abcd(n,4))
    call cqpath_damped_cube_spline_set(n,x,y,abcd)

    y2(1) = y(1)
    do i=2,n-1
        call cqpath_damped_cube_spline_val(n,abcd,x,x2(i),y_wert)
        y2(i) = y_wert
    end do
    y2(n) = y(n)

    deallocate (abcd)
    return
end

!!!!!!!!!!!!!!!!!!! SPLINE FUNKTIONEN !!!!!!!!!!!!!!!!!!!!!!!!

subroutine cqpath_damped_cube_spline_set(n,x,y,abcd)
! in    n  - dimension von array x,y
!       x  - array x
!       y  - array y
! out   abcd - array of polynom coefficients
!
! Based on Constrained Cubic Spline Interpolation for Chemical Engineering Application
! by CJC Kruger
!
! Rewritten and optimized in fortran
    implicit none
    integer, intent(in) :: n
    real(8), intent(in) :: x(n)
    real(8), intent(in) :: y(n)
    real(8), intent(out) :: abcd(n,4)

    real(8) fs_x0,fs_x1,fss_x0,fss_x1
    real(8) x0,x1,x2,y0,y1,y2
    real(8) x1_x0,y1_y0,x0_2,x0_3,x1_x0_2,x1_2
    real(8) steigung
    real(8), dimension(:), allocatable :: dx,dy,f1

    integer :: i,j,nf

    nf = n-1
    allocate (dx(nf))
    allocate (dy(nf))
    allocate (f1(n))

    do i=1,nf
        dx(i) = x(i+1)-x(i)
        dy(i) = y(i+1)-y(i)
    end do

    do i=2,nf
        steigung = dy(i-1)*dy(i)
        if (steigung > 0.0) then
            f1(i) = 2.0/(dx(i)/dy(i)+dx(i-1)/dy(i-1))
        else if (steigung <= 0.0) then
            f1(i) = 0.0
        end if
    end do

    f1(1) = 3.0*dy(1)/(2.0*dx(1)) - f1(2)/2.0
    f1(n) = 3.0*dy(n-1)/(2.0*dx(n-1)) - f1(n-1)/2.0

    do i=2,n
        x1_x0 = dx(i-1)
        y1_y0 = dy(i-1)
        x0_2 = x(i-1)*x(i-1)
        x0_3 = x0_2*x(i-1)
        x1_x0_2 = x1_x0*x1_x0
        x1_2 = x(i)*x(i)

        fss_x0 = -2.0*(f1(i) + 2.0*f1(i-1))/(x1_x0)+6.0*(y1_y0)/x1_x0_2
        fss_x1 = 2.0*(2.0*f1(i) + f1(i-1))/(x1_x0)-6.0*(y1_y0)/x1_x0_2

        abcd(i,4) = (fss_x1 - fss_x0)/(6.0*(x1_x0))
        abcd(i,3) = (x(i)*fss_x0-x(i-1)*fss_x1)/(2.0*x1_x0)
        abcd(i,2) = ((y1_y0)-abcd(i,3)*(x1_2-x0_2)-abcd(i,4)*(x1_2*x(i)-x0_3))/(x1_x0)
        abcd(i,1) = y(i-1) - abcd(i,2)*x(i-1) - abcd(i,3) * x0_2 - abcd(i,4) * x0_3
    end do

    deallocate(dx)
    deallocate(dy)
    deallocate(f1)
    return
end

subroutine cqpath_damped_cube_spline_val(n,abcd,x,x1,y1)
! in    n    - dimension von array x,y
!       abcd - array of polynom coefficients
!       x    - x
! out   y    - f(x,abcd)
!
! Based on Constrained Cubic Spline Interpolation for Chemical Engineering Application
! by CJC Kruger
!
! Rewritten and optimized in fortran
    integer, intent(in) :: n
    real(8), intent(in) :: abcd(n,4)
    real(8), intent(in) :: x(n)
    real(8), intent(in) :: x1
    real(8), intent(out) :: y1

    integer :: j
    real(8) :: xx

    do j=2,n
        if (x1 < x(j)) then
            if (x1 >= x(j-1)) then
                xx = x1*x1
                y1 = abcd(j,1)+abcd(j,2)*x1+abcd(j,3)*xx+abcd(j,4)*xx*x1
            end if
        end if
    end do
    return
end

subroutine cqpath_interpolate_nm(k,von,bis,nat,nstr,file_xyz,pn,xyz)
! Generierung der Strukturen zwischen Start und Zielstruktur
! Linerare interpolation
    implicit none
    integer, intent(in) :: k,von,bis
    integer, intent(in) :: nat,nstr,pn
    real(8), dimension(:,:,:), intent(in) :: file_xyz(3,nat,nstr)
    real(8), dimension(:,:,:), intent(inout) :: xyz(3,nat,pn)

    real(8), allocatable, dimension(:,:) :: xyz_diff,xyz_temp,xyz_start,xyz_ziel
    integer :: i,j

    allocate (xyz_diff(3,nat))
    allocate (xyz_temp(3,nat))
    allocate (xyz_start(3,nat))
    allocate (xyz_ziel(3,nat))

    do j=1,nat
        xyz_start(1,j) = file_xyz(1,j,k-1)
        xyz_start(2,j) = file_xyz(2,j,k-1)
        xyz_start(3,j) = file_xyz(3,j,k-1)
        xyz_ziel(1,j) = file_xyz(1,j,k)
        xyz_ziel(2,j) = file_xyz(2,j,k)
        xyz_ziel(3,j) = file_xyz(3,j,k)
    end do

    xyz_diff = xyz_ziel - xyz_start
    xyz_diff = xyz_diff / (bis-von)

    xyz_temp = xyz_start
    do j=1,nat
        xyz(1,j,von) = xyz_start(1,j)
        xyz(2,j,von) = xyz_start(2,j)
        xyz(3,j,von) = xyz_start(3,j)
    end do
    do i=von+1,bis-1
      xyz_temp = xyz_temp + xyz_diff
      do j=1,nat
        xyz(1,j,i) = xyz_temp(1,j)
        xyz(2,j,i) = xyz_temp(2,j)
        xyz(3,j,i) = xyz_temp(3,j)
      end do
    end do
    do j=1,nat
        xyz(1,j,bis) = xyz_ziel(1,j)
        xyz(2,j,bis) = xyz_ziel(2,j)
        xyz(3,j,bis) = xyz_ziel(3,j)
    end do

    deallocate (xyz_diff)
    deallocate (xyz_temp)
    deallocate (xyz_start)
    deallocate (xyz_ziel)
end

subroutine cqpath_read_pathfile_parameter(fn,nl,nat,nstr)
    implicit none
    character*20, intent(in) :: fn
    integer, intent(out) :: nl,nat,nstr
    integer :: u
    integer :: i,so,sr
    character*100 :: a
    character*20 :: fn2
    real(8) :: b,c,d

    fn2 = TRIM(adjustl(fn))
!     print *,'#',TRIM(fn2),'#'
    call open_file(u,trim(fn2),'r')
    if (u.eq.-1) return
    read (u,*,iostat=sr) nat
    i = 1
    do
      read (u,fmt='(A)',iostat=sr) a
      if (sr<0) exit
      if (sr>0) stop 'error in cqpath_read_pathfile_parameter'
      i = i + 1
    end do

    nl = i
    nstr = nl/(nat+2)

    call close_file (u)
    return
end

subroutine cqpath_read_pathfile(fn,nl,nat,nstr,file_xyz,iat,energy)
    implicit none
    character*20, intent(in) :: fn
    integer, intent(in) :: nat,nl,nstr
    real(8), dimension(:,:,:), intent(inout) :: file_xyz(3,nat,nstr)
    real(8), dimension(:,:,:), intent(inout) :: energy(nstr)
    integer, dimension(:), intent(out) :: iat(nat)

    integer :: u
    integer :: i,j,k,sr,so,x,nn
    real*8  :: xx(10)
    character*100 :: a
    character*2 :: b
    character*20 :: fn2

    fn2 = TRIM(adjustl(fn))
!   print *,'*',TRIM(fn2),'*',nl,nat,nstr
    call open_file(u,TRIM(fn2),'r')
    if (u.eq.-1) return
    read (u,*,iostat=sr) x
    read (u,fmt='(A)',iostat=sr) a
    call readl(a,xx,nn)
    k=1
    energy(k)=xx(1)
    do j=1,nat
        read (u,*) b,file_xyz(1,j,k),file_xyz(2,j,k),file_xyz(3,j,k)
        iat(j) = cqpathe2i( b )
!         print *, iat(j),file_xyz(1,j,k),file_xyz(2,j,k),file_xyz(3,j,k)
    end do
    do k=2,nstr
        read (u,*,iostat=sr) x
        read (u,fmt='(A)',iostat=sr) a
        call readl(a,xx,nn)
        energy(k)=xx(1)
        do j=1,nat
            read (u,*) b,file_xyz(1,j,k),file_xyz(2,j,k),file_xyz(3,j,k)
!             print *, iat(j),file_xyz(1,j,k),file_xyz(2,j,k),file_xyz(3,j,k)
        end do
    end do
    call close_file (u)
    return
end

character(2) function cqpathtohigher( s )
! wandelt Kleinbuchstaben in Großbuchstaben um
    implicit none
    character(2), intent(in) :: s
    character(2)             :: sout
    integer :: ic, i
    character(26), Parameter :: high = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
    character(26), Parameter :: low = 'abcdefghijklmnopqrstuvwxyz'

    sout = s
    do i = 1, LEN_TRIM(s)
        ic = INDEX(low, s(i:i))
        if (ic > 0) sout(i:i) = high(ic:ic)
    end do
    cqpathtohigher = sout
end function cqpathtohigher

integer function cqpathe2i( cin )
! wandelt eine Zeichenkette in iat um
    implicit none
    character(2), intent(in) :: cin
    character(2) :: c
    integer :: iout
    c = cqpathtohigher(cin)
    if (c == 'H') iout = 1
    if (c == 'HE') iout = 2
    if (c == 'LI') iout = 3
    if (c == 'BE') iout = 4
    if (c == 'B') iout = 5
    if (c == 'C') iout = 6
    if (c == 'N') iout = 7
    if (c == 'O') iout = 8
    if (c == 'F') iout = 9
    if (c == 'NE') iout = 10
    if (c == 'NA') iout = 11
    if (c == 'MG') iout = 12
    if (c == 'AL') iout = 13
    if (c == 'SI') iout = 14
    if (c == 'P') iout = 15
    if (c == 'S') iout = 16
    if (c == 'CL') iout = 17
    if (c == 'AR') iout = 18
    if (c == 'K') iout = 19
    if (c == 'CA') iout = 20
    if (c == 'SC') iout = 21
    if (c == 'TI') iout = 22
    if (c == 'V') iout = 23
    if (c == 'CR') iout = 24
    if (c == 'MN') iout = 25
    if (c == 'FE') iout = 26
    if (c == 'CO') iout = 27
    if (c == 'NI') iout = 28
    if (c == 'CU') iout = 29
    if (c == 'ZN') iout = 30
    if (c == 'GA') iout = 31
    if (c == 'GE') iout = 32
    if (c == 'AS') iout = 33
    if (c == 'SE') iout = 34
    if (c == 'BR') iout = 35
    if (c == 'KR') iout = 36
    if (c == 'RB') iout = 37
    if (c == 'SR') iout = 38
    if (c == 'Y') iout = 39
    if (c == 'ZR') iout = 40
    if (c == 'NB') iout = 41
    if (c == 'MO') iout = 42
    if (c == 'TC') iout = 43
    if (c == 'RU') iout = 44
    if (c == 'RH') iout = 45
    if (c == 'PD') iout = 46
    if (c == 'AG') iout = 47
    if (c == 'CD') iout = 48
    if (c == 'IN') iout = 49
    if (c == 'SN') iout = 50
    if (c == 'SB') iout = 51
    if (c == 'TE') iout = 52
    if (c == 'I') iout = 53
    if (c == 'XE') iout = 54
    if (c == 'CS') iout = 55
    if (c == 'BA') iout = 56
    if (c == 'LA') iout = 57
    if (c == 'CE') iout = 58
    if (c == 'PR') iout = 59
    if (c == 'ND') iout = 60
    if (c == 'PM') iout = 61
    if (c == 'SM') iout = 62
    if (c == 'EU') iout = 63
    if (c == 'GD') iout = 64
    if (c == 'TB') iout = 65
    if (c == 'DY') iout = 66
    if (c == 'HO') iout = 67
    if (c == 'ER') iout = 68
    if (c == 'TM') iout = 69
    if (c == 'YB') iout = 70
    if (c == 'LU') iout = 71
    if (c == 'HF') iout = 72
    if (c == 'TA') iout = 73
    if (c == 'W') iout = 74
    if (c == 'RE') iout = 75
    if (c == 'OS') iout = 76
    if (c == 'IR') iout = 77
    if (c == 'PT') iout = 78
    if (c == 'AU') iout = 79
    if (c == 'HG') iout = 80
    if (c == 'TL') iout = 81
    if (c == 'PB') iout = 82
    if (c == 'BI') iout = 83
    if (c == 'PO') iout = 84
    if (c == 'AT') iout = 85
    if (c == 'RN') iout = 86
    cqpathe2i = iout
    return
end function cqpathe2i

end module xtb_cqpath

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Available submodule in this program
module xtb_prog_submodules
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: xtbSubmodule, getSubmodule


   !> Possible submodules for xtb
   type :: TSubmoduleEnum

      !> Unknown run mode
      integer :: invalid = 0

      !> Main run mode of xtb
      integer :: main = 1

      !> Info run mode of xtb
      integer :: info = 2

      !> Thermodynamic function evaluator
      integer :: thermo = 3

      !> Force field topology generator
      integer :: topo = 4

      !> Fragment docking
      integer :: dock = 5

      !> IR spectra from DFTB+ output
      integer :: ir = 6

   end type TSubmoduleEnum

   !> Actual enumerator for the submodules
   type(TSubmoduleEnum), parameter :: xtbSubmodule = TSubmoduleEnum()


contains


!> Translate a string in a submodule enumerator
function getSubmodule(argument) result(submod)

   !> String identifying the submodule name
   character(len=*), intent(in) :: argument

   !> Identifier of the submodule
   integer :: submod

   select case(argument)
   case default
      submod = xtbSubmodule%invalid

   case('info')
      submod = xtbSubmodule%info

   case('thermo')
      submod = xtbSubmodule%thermo

   case('topo')
      submod = xtbSubmodule%topo

   case('dock')
      submod = xtbSubmodule%dock

   case('ir')
      submod = xtbSubmodule%ir

   end select

end function getSubmodule


end module xtb_prog_submodules

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_scf
! ========================================================================
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : autoev,evtoau
   use xtb_mctc_blas, only : mctc_gemv
   use xtb_mctc_lapack_eigensolve, only : TEigenSolver, init
   use xtb_coulomb_klopmanohno
   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType
   use xtb_disp_dftd3, only : d3_gradient
   use xtb_solv_cm5
   use xtb_solv_cosmo, only : TCosmo
   use xtb_solv_gbsa, only : TBorn
   use xtb_type_basisset
   use xtb_type_coulomb, only : TCoulomb
   use xtb_type_data
   use xtb_type_environment
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_molecule, only : TMolecule
   use xtb_type_solvation, only : TSolvation
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_timer
   use xtb_type_wavefunction
   use xtb_xtb_data
   use xtb_xtb_halogen
   use xtb_xtb_repulsion
   use xtb_xtb_coulomb
   use xtb_xtb_dispersion
   use xtb_xtb_hamiltonian, only : getSelfEnergy, build_SDQH0, build_dSDQH0, &
      & build_dSdQH0_noreset, count_dpint, count_qpint
   use xtb_xtb_hamiltonian_gpu, only: build_SDQH0_gpu, build_dSDQH0_gpu
   use xtb_xtb_multipole
   use xtb_paramset, only : tmmetal
   use xtb_scc_core
   use xtb_grad_core
   use xtb_hlex
   use xtb_local
   use xtb_dipole
   implicit none
   private

   public :: scf

   logical, parameter :: profile = .true.

   integer, parameter :: mmm(20)=(/1,2,2,2,3,3,3,3,3,3,4,4,4,4,4,4,4,4,4,4/)

   integer, parameter :: metal(1:86) = [&
      & 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, &
      & 1, 0, 0, 0, 0, 0]

contains

subroutine scf(env, mol, wfn, basis, pcem, xtbData, solvation, &
      & egap, et, maxiter, prlevel, restart, grd, acc, energy, gradient, res)


! ========================================================================
!  global storage
   use xtb_setparam

! ========================================================================
! ========================================================================
   use xtb_aespot,    only : setdqlist,get_radcn,setvsdq, &
   &                     mmomgabzero,mmompop,molmom
   use xtb_disp_dftd4, only: build_wdispmat,d4dim,d4,disppot,p_refq_gfn2xtb, &
   &                     mdisp,prmolc6,edisp_scc,d4_gradient
   use xtb_disp_ncoord,    only : dncoord_gfn,ncoord_d4,dncoord_d3
   use xtb_embedding, only : read_pcem,jpot_pcem_gfn1,jpot_pcem_gfn2
   use xtb_aespot,    only : dradcn,aniso_grad,setdvsdq
   use xtb_disp_ncoord,    only : dncoord_gfn,dncoord_d3
   use xtb_embedding, only : pcem_grad_gfn1,pcem_grad_gfn2
   use xtb_solv_cosmo, only : TCosmo

   use xtb_readin

   implicit none

   character(len=*), parameter :: source = 'scf'

! ========================================================================
   type(TEnvironment), intent(inout)    :: env
   type(TMolecule), intent(in) :: mol
   type(TWavefunction),intent(inout) :: wfn
   type(TBasisset),intent(in) :: basis
   type(tb_pcem),intent(inout) :: pcem
   real(wp),intent(inout) :: egap
   real(wp),intent(in)    :: et
   integer, intent(in)    :: maxiter
   integer, intent(in)    :: prlevel
   logical, intent(in)    :: restart
   logical, intent(in)    :: grd
   real(wp),intent(in)    :: acc
   real(wp),intent(inout) :: energy
   real(wp),intent(inout) :: gradient(3,mol%n)
   real(wp) :: sigma(3,3)
   type(scc_results),intent(out) :: res
   type(TxTBData), intent(in) :: xtbData
   class(TSolvation), allocatable, intent(inout) :: solvation
   type(TLatticePoint) :: latp
   type(TEigenSolver) :: solver
   type(TCosmo) :: cosmo

! ========================================================================
   real(wp),allocatable :: cn(:)
   real(wp),allocatable :: X(:,:)
   real(wp),allocatable :: S(:,:)
   real(wp),allocatable :: S12(:,:)
   real(wp),allocatable :: H0(:)
   real(wp),allocatable :: ves(:) ! shell ES potential
   real(wp),allocatable :: vs(:)
   real(wp),allocatable :: vd(:, :)
   real(wp),allocatable :: vq(:, :)
   real(wp),allocatable :: dhdcn(:)
   real(wp),allocatable :: tmp(:)
   real(wp),allocatable :: zsh(:)
   real(wp),allocatable :: qq(:)
   real(wp),allocatable :: qlmom(:,:)
   real(wp),allocatable :: cm5(:)
   real(wp),allocatable :: Xcao(:,:)
   real(wp),allocatable :: selfEnergy(:, :)
   real(wp),allocatable :: dSEdcn(:, :)
   real(wp),allocatable :: shellShift(:, :)
   real(wp),allocatable :: temp(:)
   real(wp),allocatable :: Pa(:, :)
   real(wp),allocatable :: Pb(:, :)
   real(wp),allocatable :: Pew(:, :)
   real(wp),allocatable :: H(:, :)
   integer :: nid
   integer, allocatable :: idnum(:)
   type(TxTBCoulomb) :: ies
   type(TKlopmanOhno) :: coulomb
   real(wp), allocatable :: djdr(:, :, :)
   real(wp), allocatable :: djdtr(:, :)
   real(wp), allocatable :: djdL(:, :, :)
!  AES stuff
   type(TxTBMultipole), allocatable :: aes
   real(wp),allocatable  :: dpint(:,:,:),qpint(:,:,:)
   real(wp),allocatable  :: radcn(:) ! CBNEW

! ========================================================================
   type(TxTBDispersion), allocatable :: scD4
   real(wp) :: embd
   integer  :: mbd
   parameter(mbd=3)
   real(wp) :: molc6,molc8,molpol
   real(wp),allocatable :: aw(:,:)
   real(wp),allocatable :: c6ab(:,:)
   real(wp),allocatable :: rvol(:)

! ========================================================================
   integer,allocatable :: mdlst(:,:),mqlst(:,:)
   integer :: ndp,nqp

   integer,allocatable :: matlist (:,:)
   integer,allocatable :: matlist2(:,:)
   integer,allocatable :: xblist(:,:)
   real(wp),allocatable :: sqrab(:)
   real(wp),allocatable :: dcndr(:,:,:)
   real(wp),allocatable :: dcndL(:,:,:)
   real(wp),allocatable :: trans(:,:)

   real(wp) :: dipol(3),dip,gsolv,eat,hlgap,efix
   real(wp) :: xsum,eh1,rab,eold,dum,xx,r2
   real(wp) :: t0,t1,sum,rr,hav,alpha,ep,dx,dy,dz,dum1,r0i,r0j
   real(wp) :: efa,efb,nfoda,nfodb,hdii,hdjj,qconv,ff
   real(wp) :: x1,x2,ed,intcut,neglect,ga,gb,ehb,h0s,hmat,rab2
   real(wp) :: h0sr,scfconv,rmsq,dum2,drfdxyz(3),yy,tex,rav,tab,ljexp
   real(wp) :: ees,xa,xb,ya,yb,za,zb,repab,jmpol,kdampxb,vvxb,exb
   real(wp) :: w2,xj,gi,gj,eatoms,neglect2
   real(wp) :: w0,w1,damp,damp0,gtmp(3),exc
   real(wp) :: esave,eel
   real(wp) :: eaes,t6,t7,pi,epol,kexpe
   parameter (pi =  3.14159265358979_wp)

!  some parameter defaults which are not fitted
   data ljexp/12.0_wp/ ! XB parameter for damped LJ in GFN1

   integer :: ich ! file handle
   integer :: npr,ii,jj,kk,i,j,k,m,iat,jat,mi,jter,atj,kkk,mj,mm
   integer :: ishell,jshell,np,ia,ndimv,l,nmat,nmat2
   integer :: ll,i1,i2,nn,ati,nxb,lin,startpdiag
   integer :: is,js,gav

   character(len=128) :: atmp,ftmp
   logical :: ex,minpr,pr,fulldiag,lastdiag,iniqsh,fail

!  GBSA stuff
   real(wp) :: gborn,ghb,gsasa,gshift
!  for the CM5 charges
   real(wp),allocatable :: cm5a(:)
   real(wp),allocatable :: dcm5a(:,:,:)

!  point charge embedding stuff
   logical  :: lpcem
   real(wp),allocatable :: Vpc(:)
   real(wp) :: epcem

   type(tb_timer) :: timer
   character(len=*),parameter :: scifmt = &
      '(10x,":",2x,a,e22.7,1x,a,1x,":")'
   character(len=*),parameter :: dblfmt = &
      '(10x,":",2x,a,f18.7,5x,a,1x,":")'
   character(len=*),parameter :: intfmt = &
      '(10x,":",2x,a,i18,      10x,":")'
   character(len=*),parameter :: chrfmt = &
      '(10x,":",2x,a,a18,      10x,":")'

   logical :: exitRun

!  broyden stuff
   logical  :: broy

! ------------------------------------------------------------------------
!  initialization
! ------------------------------------------------------------------------
   if (profile) call timer%new(7,.false.)
   if (profile) call timer%measure(1,"SCC setup")
   rmsq  =1.e+42_wp
   lastdiag=.false.
   lpcem = pcem%n > 0
   jter=0

   dipol= 0.0_wp
   eaes = 0.0_wp
   gsolv= 0.0_wp
   epol = 0.0_wp
   ees  = 0.0_wp
   epcem= 0.0_wp
   ga   = 0.0_wp
   gb   = 0.0_wp
   eel  = 0.0_wp
   ep   = 0.0_wp
   ed   = 0.0_wp
   embd = 0.0_wp
   eat  = 0.0_wp
   egap = 0.0_wp
   molpol = 0.0_wp

   pr   = prlevel.gt.1
   minpr= prlevel.gt.0

!  numerical stuff
!  primitive cut-off
   intcut=25.0_wp-10.0*log10(acc)
   intcut=max(20.0_wp,intcut)
!  integral neglect threshold (the distance criterion used in ovlp limits S to about >1.d-9
   neglect =10.0d-9*acc
   neglect2=neglect*10.0_wp
!  exit if E < scfconv, Hessian sensitive to this
   scfconv=1.d-6*acc
!  old/new q mixing start
   damp0=0.20
!  conv threshold in dRMS q
   qconv=2.d-5*acc
   if(allocated(xtbData%multipole)) qconv=1.d-4*acc

   broy = mol%n > 1
!  when to start pseudodiag (=1 after one full diag)
   startpdiag=1000 !large number=never

!  do the first SCC by full diag
   if(egap.eq.0) startpdiag=1000

   call init(latp, env, mol, 60.0_wp)

!ccccccccccccccccccc
! note: H is in eV!
!ccccccccccccccccccc
   !> update atomic Mulliken charges
   call qsh2qat(basis%ash,wfn%qsh,wfn%q)

!  # atom arrays
   allocate(qq(mol%n),qlmom(3,mol%n),cm5(mol%n),cm5a(mol%n),sqrab(mol%n*(mol%n+1)/2))
   allocate(dcndr(3,mol%n,mol%n),cn(mol%n),dcndL(3,3,mol%n))

!  initialize the GBSA module (GBSA works with CM5 charges)
   if (allocated(solvation)) then
      if (mol%npbc > 0) then
         call env%error("Solvation not available with PBC", source)
         return
      end if
      call solvation%update(env, mol%at, mol%xyz)
      allocate(dcm5a(3,mol%n,mol%n))
      gborn=0._wp
      gsasa=0._wp
      ghb=0._wp
      gshift=0._wp
      qq=0._wp
      ! initialize the CM5 charges computation
      cm5=wfn%q
      cm5a=0.d0
      dcm5a=0.d0
      if(xtbData%level == 1) then ! only GFN1 does use CM5 charges
         select type(solvation)
         type is (TBorn)
            call calc_cm5(mol%n,mol%at,mol%xyz,cm5a,dcm5a)
            cm5 = wfn%q + cm5a
         end select
      end if
   end if

   allocate(H0(basis%nao*(basis%nao+1)/2), &
   &        S(basis%nao,basis%nao),tmp(basis%nao), &
   &        X(basis%nao,basis%nao), &
   &        ves(basis%nshell), &
   &        zsh(basis%nshell),&
   &        matlist (2,basis%nao*(basis%nao+1)/2), &
   &        matlist2(2,basis%nao*(basis%nao+1)/2-basis%nao))
   allocate(selfEnergy(maxval(xtbData%nshell), mol%n))
   allocate(dSEdcn(maxval(xtbData%nshell), mol%n))

   wfn%nel = nint(sum(mol%z) - mol%chrg)
   wfn%nopen = mol%uhf
   if(wfn%nopen == 0 .and. mod(wfn%nel,2) /= 0) wfn%nopen=1

   call setzshell(xtbData,mol%n,mol%at,basis%nshell,mol%z,zsh,eatoms,xtbData%level)

   ! fill levels
   if(wfn%nel.ne.0) then
      if (wfn%nel > 2*basis%nao) then
         call env%error("Not enough basis functions for filling orbitals", source)
         return
      end if
      call occu(basis%nao,wfn%nel,wfn%nopen,wfn%ihomoa,wfn%ihomob,wfn%focca,wfn%foccb)
      wfn%focc = wfn%focca + wfn%foccb
      wfn%ihomo=wfn%ihomoa
   else
      wfn%focc=0.0_wp
      wfn%ihomo=0
      wfn%ihomoa=0
      wfn%nopen=0
   endif

!  distances and XB set
   nxb = 0
   k = 0
   do i=1,mol%n
      do j=1,i
!        save distances
         k=k+1
         sqrab(k)=(mol%xyz(1,i)-mol%xyz(1,j))**2 &
         &       +(mol%xyz(2,i)-mol%xyz(2,j))**2 &
         &       +(mol%xyz(3,i)-mol%xyz(3,j))**2
!        XB
         if(xbond(mol%at(i),mol%at(j)).and.sqrab(k).lt.400.) nxb=nxb+1
      enddo
   enddo

   ! XB part
   if(allocated(xtbData%halogen)) then ! not used in GFN2
      allocate(xblist(3,nxb+1))
      nxb = 0
      k = 0
      do i=1,mol%n
         ati=mol%at(i)
         do j=1,i
            atj=mol%at(j)
            k=k+1
            if(xbond(ati,atj).and.sqrab(k).lt.400) then
               nxb=nxb+1
               dum1=1.d+42
               if(ati.eq.17.or.ati.eq.35.or.ati.eq.53.or.ati.eq.85)then
                  xblist(1,nxb)=i
                  xblist(2,nxb)=j
                  do m=1,mol%n
                     if(m.ne.i.and.sqrab(lin(m,i)).lt.dum1)then
                        dum1=sqrab(lin(m,i))
                        xblist(3,nxb)=m
                     endif
                  enddo
               endif
               if(atj.eq.17.or.atj.eq.35.or.atj.eq.53.or.atj.eq.85)then
                  xblist(1,nxb)=j
                  xblist(2,nxb)=i
                  do m=1,mol%n
                     if(m.ne.j.and.sqrab(lin(m,j)).lt.dum1)then
                        dum1=sqrab(lin(m,j))
                        xblist(3,nxb)=m
                     endif
                  enddo
               endif
            endif
         enddo
      enddo
   endif

   ! setup isotropic electrostatics
   call init(ies, xtbData%coulomb, xtbData%nshell, mol%at)

   nid = maxval(mol%id)
   allocate(idnum(nid))
   do ii = 1, nId
      jat = 0
      do iat = 1, mol%n
         if (mol%id(iat) == ii) then
            jat = iat
            exit
         end if
      end do
      idnum(ii) = mol%at(jat)
   end do

   if(xtbData%level == 1)then
      gav = gamAverage%harmonic
   else !GFN2
      gav = gamAverage%arithmetic
   endif
   call init(coulomb, env, mol, gav, xtbData%coulomb%shellHardness, &
      & xtbData%coulomb%gExp, num=idnum, nshell=xtbData%nShell)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Setup of Coulomb evaluator failed", source)
      return
   end if

   call coulomb%getCoulombMatrix(mol, ies%jmat)

!  J potentials including the point charge stuff
   allocate(Vpc(basis%nshell))
   vpc(:) = 0.0_wp
   if(lpcem)then
      if (xtbData%level == 1)then
         call jpot_pcem_gfn1(xtbData%coulomb,mol%n,pcem,xtbData%nshell,mol%at, &
            & mol%xyz,xtbData%coulomb%gExp,Vpc)
      else ! GFN2
         call jpot_pcem_gfn2(xtbData%coulomb,mol%n,pcem,xtbData%nshell,mol%at, &
            & mol%xyz,Vpc)
      endif
   endif

   if (pr) then
      write(env%unit,'(/,10x,51("."))')
      write(env%unit,'(10x,":",22x,a,22x,":")') "SETUP"
      write(env%unit,'(10x,":",49("."),":")')
      write(env%unit,intfmt) "# basis functions  ",basis%nbf
      write(env%unit,intfmt) "# atomic orbitals  ",basis%nao
      write(env%unit,intfmt) "# shells           ",basis%nshell
      write(env%unit,intfmt) "# electrons        ",wfn%nel
      if (allocated(xtbData%halogen)) &
      write(env%unit,intfmt) "# halogen bonds    ",nxb
      write(env%unit,intfmt) "max. iterations    ",maxiter
      if (xtbData%level == 2) &
      write(env%unit,chrfmt) "Hamiltonian        ","GFN2-xTB"
      if (xtbData%level == 1) &
      write(env%unit,chrfmt) "Hamiltonian        ","GFN1-xTB"
      write(env%unit,chrfmt) "restarted?         ",bool2string(restart)
      write(env%unit,chrfmt) "GBSA solvation     ",bool2string(allocated(solvation))
      write(env%unit,chrfmt) "PC potential       ",bool2string(lpcem)
      if (lpcem) then
         write(env%unit,intfmt) "-> # point charges ",pcem%n
         write(env%unit,dblfmt) "-> sum of PC       ",sum(pcem%q),"e   "
      endif
      write(env%unit,dblfmt) "electronic temp.   ",et,      "K   "
      write(env%unit,dblfmt) "accuracy           ",acc,     "    "
      write(env%unit,scifmt) "-> integral cutoff ",intcut,  "    "
      write(env%unit,scifmt) "-> integral neglect",neglect, "    "
      write(env%unit,scifmt) "-> SCF convergence ",scfconv, "Eh  "
      write(env%unit,scifmt) "-> wf. convergence ",qconv,   "e   "
      write(env%unit,dblfmt) "Broyden damping    ",set%broydamp,"    "
      write(env%unit,'(10x,51("."))')
   endif

   qq    =wfn%q
   damp  =damp0

   if (profile) call timer%measure(1)
   if (profile) call timer%measure(3,"classical contributions")

   ! ------------------------------------------------------------------------
   ! Repulsion energy
   ep = 0.0_wp
   call latp%getLatticePoints(trans, 40.0_wp)
   call repulsionEnGrad(mol, xtbData%repulsion, trans, 40.0_wp, &
      & ep, gradient, sigma)


   ! ------------------------------------------------------------------------
   ! Halogen bond correction
   exb=0.0_wp
   if (allocated(xtbData%halogen)) then
      if (nxb > 0 .and. mol%npbc > 0) then
         call env%error("Halogen bond correction not available with PBC", source)
         return
      end if
      call xbpot(xtbData%halogen,mol%n,mol%at,mol%xyz,xblist,nxb,&
         & ljexp,exb,gradient)
   end if

   if (profile) call timer%measure(3)
   if (profile) call timer%measure(2,"Dispersion")

   ! ------------------------------------------------------------------------
   ! Coordination number
   if (xtbData%level == 1) then
      ! D3 part first because we need CN
      call getCoordinationNumber(mol, trans, 40.0_wp, cnType%exp, cn, dcndr, dcndL)
   else
      ! CN/dCN replaced by special smoother and faster decaying function
      call getCoordinationNumber(mol, trans, 40.0_wp, cnType%gfn, cn, dcndr, dcndL)
   endif

   ! ------------------------------------------------------------------------
   ! dispersion (DFT-D type correction)
   call latp%getLatticePoints(trans, 60.0_wp)
   if (xtbData%level == 1) then
      call d3_gradient &
         & (mol, trans, xtbData%dispersion%dpar, 4.0_wp, 60.0_wp, &
         &  cn, dcndr, dcndL, ed, gradient, sigma)
   else
      allocate(scD4)
      call init(scD4, xtbData%dispersion, mol)
   endif

   if (profile) call timer%measure(2)
   if (profile) call timer%measure(4,"integral evaluation")

   ! ========================================================================
   ! Overlap integrals
   allocate(dpint(3,basis%nao,basis%nao), &
      &     qpint(6,basis%nao,basis%nao), &
      &     source = 0.0_wp)

   call getSelfEnergy(xtbData%hamiltonian, xtbData%nShell, mol%at, cn=cn, &
      & selfEnergy=selfEnergy, dSEdcn=dSEdcn)
   ! compute integrals and prescreen to set up list arrays
   call latp%getLatticePoints(trans, sqrt(800.0_wp))
#ifdef XTB_GPU
   call build_SDQH0_gpu(xtbData%nShell, xtbData%hamiltonian, mol%n, mol%at, &
      & basis%nbf, basis%nao, mol%xyz, trans, selfEnergy, intcut, &
      & basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, basis%alp, &
      & basis%cont, S, dpint, qpint, H0)
#else
   call build_SDQH0(xtbData%nShell, xtbData%hamiltonian, mol%n, mol%at, &
      & basis%nbf, basis%nao, mol%xyz, trans, selfEnergy, intcut, &
      & basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, basis%alp, &
      & basis%cont, S, dpint, qpint, H0)
#endif
   call count_dpint(ndp, dpint, neglect)
   call count_qpint(nqp, qpint, neglect)

   ! prepare aes stuff
   if (allocated(xtbData%multipole)) then
      if (mol%npbc > 0) then
         call env%error("Multipoles not available with PBC", source)
         return
      end if
      allocate(aes)
      call init(aes, xtbData%multipole)

      ! allocate arrays for lists and fill (to exploit sparsity)
      allocate(mdlst(2,ndp),mqlst(2,nqp))
      call setdqlist(basis%nao,ndp,nqp,neglect,dpint,qpint,mdlst,mqlst)
      ! set up 1/R^n * damping function terms
      ii=mol%n*(mol%n+1)/2
      allocate(aes%gab3(mol%n, mol%n),aes%gab5(mol%n, mol%n),radcn(mol%n))
      call get_radcn(xtbData%multipole,mol%n,mol%at,cn,aes%cnShift, &
         & aes%cnExp,aes%cnRMax,radcn)
      call mmomgabzero(mol%n,mol%at,mol%xyz,aes%dipDamp, &
         & aes%quadDamp,radcn,aes%gab3,aes%gab5) ! zero damping
   end if

   ! ------------------------------------------------------------------------
   ! prepare matrix indices
   nmat =0
   nmat2=0
   do ii=1,basis%nao
      iat=basis%aoat2(ii)
      do jj=1,ii-1
         jat=basis%aoat2(jj)
         if(abs(S(jj,ii)).lt.neglect) then
            S(jj,ii)=0.0_wp
            S(ii,jj)=0.0_wp
            cycle
         endif
         nmat=nmat+1
         matlist(1,nmat)=ii
         matlist(2,nmat)=jj
         if(iat.ne.jat)then
            nmat2=nmat2+1
            matlist2(1,nmat2)=ii
            matlist2(2,nmat2)=jj
         endif
      enddo
      ! CB: moved this here so j/i indices from matlist come in a reasonable order
      ! also setup CN dep. stuff
      nmat=nmat+1
      matlist(1,nmat)=ii
      matlist(2,nmat)=ii
      ishell=mmm(basis%lao2(ii))
   enddo

   if (profile) call timer%measure(4)
   if (profile) call timer%measure(5,"iterations")

   ! ========================================================================
   ! SCC iterations

   if (minpr) then
      write(env%unit,'(a)')
      write(env%unit,*) 'iter      E             dE          RMSdq', &
      &'      gap      omega  full diag'
   endif

   !$acc enter data copyin(s, dpint, qpint)

   call init(solver, env, S)
   call scc(env,xtbData,solver,mol%n,wfn%nel,wfn%nopen,basis%nao,ndp,nqp,nmat,basis%nshell, &
      &     mol%at,matlist,mdlst,mqlst,basis%aoat2,basis%ao2sh,basis%ash, &
      &     wfn%q,wfn%dipm,wfn%qp,qq,qlmom,wfn%qsh,zsh, &
      &     mol%xyz,aes, &
      &     cm5,cm5a,gsolv,solvation, &
      &     scD4, &
      &     broy,set%broydamp,damp0, &
      &     lpcem,ves,vpc, &
      &     et,wfn%focc,wfn%focca,wfn%foccb,wfn%efa,wfn%efb, &
      &     eel,ees,eaes,epol,ed,epcem,egap, &
      &     wfn%emo,wfn%ihomo,wfn%ihomoa,wfn%ihomob, &
      &     H0,wfn%C,S,dpint,qpint,X,wfn%P,ies, &
      &     maxiter,startpdiag,scfconv,qconv, &
      &     minpr,pr, &
      &     fail,jter)

   !$acc exit data delete(s, dpint, qpint)

   ! check if something terrible happened in the SCC
   call env%check(exitRun)
   if (exitRun) then
      call env%error("Self consistent charge iterator terminated", source)
      return
   end if

   ! check for convergence
   res % converged = .not. fail
   ! write convergence info depending on print setting
   if (pr) then
      if (fail) then
         call touch_file('.sccnotconverged')
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***")') &
            "convergence criteria cannot be satisfied within",jter,"iterations"
      else
         write(env%unit,'(/,3x,"***",1x,a,1x,i0,1x,a,1x,"***")') &
            "convergence criteria satisfied after",jter,"iterations"
      endif
   endif

   if (profile) call timer%measure(5)
   if (.not.pr.and.profile.and.minpr) &
      call timer%write_timing(env%unit,5,'SCC iter.')
   if (profile) call timer%measure(6,"molecular gradient")
   
   ! ========================================================================
   ! GRADIENT (finally 100% analytical)
   allocate(temp(basis%nao))
   allocate(Pew(basis%nao, basis%nao))
   allocate(shellShift(maxval(xtbData%nshell), mol%n))
   allocate(dhdcn(mol%n))
   temp(:) = wfn%focc * wfn%emo * evtoau
   call dmat(basis%nao, temp, wfn%C, Pew)

   shellShift(:, :) = 0.0_wp
   i = 0
   do iat = 1, mol%n
      ati = mol%at(iat)
      do is = 1, xtbData%nShell(ati)
         shellShift(is, iat) = ves(i+is)
      end do
      i = i+xtbData%nShell(ati)
   end do

   allocate(vs(mol%n),vd(3,mol%n),vq(6,mol%n), source = 0.0_wp)
   if (allocated(xtbData%multipole)) then
      ! VS, VD, VQ-dependent potentials are changed w.r.t. SCF,
      ! since moment integrals are now computed with origin at
      ! respective atoms
      call setdvsdq(xtbData%multipole, mol%n, mol%at, mol%xyz, wfn%q, wfn%dipm, &
         & wfn%qp, aes%gab3, aes%gab5, vs, vd, vq)
   end if

   dhdcn(:) = 0.0_wp
#ifdef XTB_GPU
   call latp%getLatticePoints(trans, sqrt(800.0_wp))
   call build_dSDQH0_gpu(xtbData%nShell, xtbData%hamiltonian, selfEnergy, dSEdcn, &
      & intcut, mol%n, basis%nao, basis%nbf, mol%at, mol%xyz, trans, &
      & basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, &
      & basis%alp, basis%cont, wfn%p, Pew, shellShift, vs, vd, vq, &
      & dhdcn, gradient, sigma)
#else
   if (mol%npbc == 0) then
      allocate(H(basis%nao, basis%nao))
      H(:, :) = 0.0_wp
      do m = 1, nmat2
         i = matlist2(1,m)
         j = matlist2(2,m)
         k = j+i*(i-1)/2
         !ishell = ao2sh(i)
         !jshell = ao2sh(j)
         ! SCC terms
         !eh1 = autoev*(shellShift(ishell) + shellShift(jshell))
         !H1 = -S(j,i)*eh1*0.5_wp
         H(j,i) = H0(k)*evtoau/S(j,i)
         H(i,j) = H(j,i)
      enddo
      call build_dSDQH0_noreset(xtbData%nShell, xtbData%hamiltonian, selfEnergy, &
         & dSEdcn, intcut, mol%n, basis%nao, basis%nbf, mol%at, mol%xyz, &
         & basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, &
         & basis%alp, basis%cont, H, S, wfn%p, Pew, shellShift, vs, vd, vq, &
         & dhdcn, gradient, sigma)
   else
      call build_dSDQH0(xtbData%nShell, xtbData%hamiltonian, selfEnergy, dSEdcn, &
         & intcut, mol%n, basis%nao, basis%nbf, mol%at, mol%xyz, trans, &
         & basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, &
         & basis%alp, basis%cont, wfn%p, Pew, shellShift, vs, vd, vq, &
         & dhdcn, gradient, sigma)
   end if
#endif
   ! setup CN gradient
   call mctc_gemv(dcndr, dhdcn, gradient, beta=1.0_wp)
   call mctc_gemv(dcndL, dhdcn, sigma, beta=1.0_wp)

   ! ------------------------------------------------------------------------
   ! multipole gradient
   if (allocated(xtbData%multipole)) then
      ! VS, VD, VQ-dependent potentials are changed w.r.t. SCF,
      ! since moment integrals are now computed with origin at
      ! respective atoms
      call setdvsdq(xtbData%multipole, mol%n, mol%at, mol%xyz, wfn%q, wfn%dipm, &
         & wfn%qp, aes%gab3, aes%gab5, vs, vd, vq)

      ! WARNING: dcndr is overwritten on output and now dR0A/dXC
      call dradcn(xtbData%multipole, mol%n, mol%at, cn, aes%cnShift, &
         & aes%cnExp, aes%cnRMax, dcndr)
      call aniso_grad(mol%n, mol%at, mol%xyz, wfn%q, wfn%dipm, wfn%qp, &
         & aes%dipDamp, aes%quadDamp, radcn, dcndr, aes%gab3, aes%gab5, gradient)
   end if

   ! ------------------------------------------------------------------------
   ! dispersion (DFT-D type correction)
   if (allocated(scD4)) then
      call latp%getLatticePoints(trans, 40.0_wp)
      call getCoordinationNumber(mol, trans, 40.0_wp, cnType%cov, &
         & cn, dcndr, dcndL)
      call latp%getLatticePoints(trans, 60.0_wp)
      call d4_gradient(mol, xtbData%dispersion%dispm, trans, &
         &  xtbData%dispersion%dpar, scD4%g_a, scD4%g_c, &
         &  scD4%wf, 60.0_wp, 40.0_wp, cn, dcndr, dcndL, wfn%q, &
         &  energy=dum, gradient=gradient, sigma=sigma, e3=embd)
   endif

   ! ------------------------------------------------------------------------
   ! Solvation contributions from GBSA
   if (allocated(solvation)) then
      cm5(:)=wfn%q+cm5a
      call solvation%addGradient(env, mol%at, mol%xyz, cm5, wfn%qsh, gradient)
      select type(solvation)
      type is (TBorn)
         if (xtbData%level == 1) then
            call mctc_gemv(solvation%bornMat, cm5, solvation%shift)
            call mctc_gemv(dcm5a, solvation%shift, gradient, beta=1.0_wp)
         end if
         call solvation%getEnergyParts(env, cm5, wfn%qsh, gborn, ghb, gsasa, &
            & gshift)
         gsolv = gborn+gsasa+ghb+gshift
      type is (TCosmo)
         gborn = gsolv - solvation%gsasa
         gsasa = solvation%gsasa
      end select
   endif

   ! ------------------------------------------------------------------------
   ! Derivative of electrostatic energy
   allocate(djdr(3, mol%n, basis%nshell))
   allocate(djdtr(3, basis%nshell))
   allocate(djdL(3, 3, basis%nshell))
   call coulomb%getCoulombDerivs(mol, wfn%qsh, djdr, djdtr, djdL)
   call mctc_gemv(djdr, wfn%qsh, gradient, beta=1.0_wp)
   !call mctc_gemv(djdL, wfn%qsh, sigma, beta=1.0_wp)

   ! ------------------------------------------------------------------------
   ! ES point charge embedding
   if (lpcem) then
      if (xtbData%level == 1) then
         call pcem_grad_gfn1(xtbData%coulomb,gradient,pcem%grd,mol%n,pcem,mol%at, &
            & xtbData%nshell,mol%xyz,xtbData%coulomb%gExp,wfn%qsh)
      else
         call pcem_grad_gfn2(xtbData%coulomb,gradient,pcem%grd,mol%n,pcem,mol%at, &
            & xtbData%nshell,mol%xyz,wfn%qsh)
      end if
   end if

   if (profile) call timer%measure(6)
   if (.not.pr.and.profile.and.minpr) &
      call timer%write_timing(env%unit,6,'gradient')
   if (profile) call timer%measure(7,"printout")

   ! throw error for unconverged SCF
   if (fail) then
      call env%error("Self consistent charge iterator did not converge", source)
   end if

   ! ========================================================================
   ! PROPERTIES & PRINTOUT

   printing: if (pr) then
      ! ---------------------------------------------------------------------
      ! print orbital energies and occupation numbers
      if (set%pr_eig) then
         call print_orbital_eigenvalues(env%unit, wfn, 5)
      endif

      ! ---------------------------------------------------------------------
      ! HOMO-LUMO excitation properties if UHF=2
      if (wfn%nopen.eq.2) then
         call hlex(mol%n, mol%at, basis%nbf, basis%nao, wfn%ihomoa, mol%xyz, &
            & wfn%focc, S, wfn%C, wfn%emo, basis)
      endif

      ! ---------------------------------------------------------------------
      ! LMO /xTB-IFF
      if (set%pr_lmo) then
         tmp=wfn%emo*evtoau
         allocate(res%iff_results)
!         if(.not.set%pr_local) then
            call res%iff_results%allocateIFFResults(mol%n)
!         endif
         call local(mol%n, mol%at, basis%nbf, basis%nao, wfn%ihomoa, mol%xyz, &
               & mol%z, wfn%focc, S, wfn%P, wfn%C, tmp, wfn%q, eel, &
               & allocated(solvation), basis, res)
      endif

      if (allocated(solvation)) then
         select type(solvation)
         type is (TCosmo)
            call open_file(ich, "xtb.cosmo", 'w')
            call solvation%writeCosmoFile(ich, mol%at, mol%sym, mol%xyz, &
               & wfn%q, eel + ep + exb + merge(embd, ed + embd, allocated(scD4)))
            call close_file(ich)
         end select
      end if

   endif printing
   
   !--------------------------!
   ! Wiberg-Mayer bond orders !
   !--------------------------!
   
   ! closed-shell !
   if (wfn%nopen == 0) then
      
      call get_wiberg(mol%n, basis%nao, mol%at, mol%xyz,wfn%P, S, wfn%wbo,basis%fila2)
   
   ! (restricted) open-shell !
   else if (wfn%nopen > 0) then   
      
      allocate(Pa(basis%nao,basis%nao))
      allocate(Pb(basis%nao,basis%nao))
      
      ! obtain alpha and beta spin densities !
      call dmat(basis%nao, wfn%focca, wfn%C, Pa) 
      call dmat(basis%nao, wfn%foccb, wfn%C, Pb) 
      
      call get_unrestricted_wiberg(mol%n, basis%nao, mol%at, mol%xyz, Pa, Pb ,S, wfn%wbo, &
         & basis%fila2)
   endif

   ! ------------------------------------------------------------------------
   ! dipole calculation (always done because its free)
   if (.not.allocated(xtbData%multipole)) then
      call mmompop(mol%n,basis%nao,basis%aoat2,mol%xyz,wfn%p,s,dpint,qpint, &
         &         wfn%dipm,wfn%qp)
   endif
   call calc_dipole(mol%n,mol%at,mol%xyz,mol%z,basis%nao,wfn%P,dpint,dip,dipol)

   if (profile) call timer%measure(7)


   ! ========================================================================
   ! SAVE FOR FINAL PRINTOUT
   ! total energy
   energy = eel + ep + exb + embd
   eat = eatoms*evtoau - energy
   if (.not.allocated(scD4)) then
      energy = energy + ed
   endif
   res%e_elec  = eel
   res%e_atom  = eat
   res%e_rep   = ep
   res%e_es    = ees
   res%e_aes   = eaes
   res%e_axc   = epol
   res%e_disp  = ed+embd
   res%e_total = energy
   res%hl_gap  = egap
   res%dipole  = dipol
   if (allocated(xtbData%halogen)) res%e_xb = exb
   if (allocated(solvation)) then
      res%g_solv  = gsolv
      res%g_born  = gborn
      res%g_sasa  = gsasa
      res%g_hb    = ghb
      res%g_shift = gshift
   end if
   res%gnorm = norm2(gradient)

   if (profile.and.pr) call timer%write(env%unit,'SCC')

! ========================================================================
   if (profile) call timer%deallocate

end subroutine scf


pure elemental function early3d(i) result(bool)
   implicit none
   integer,intent(in) :: i
   logical :: bool
   bool = .false.
   if ((i.ge.21).and.(i.le.24)) bool = .true.
end function early3d


!> X..Y bond? (X=halogen but not F, Y=N,O,P,S) !CB: Cl is formally included, but
!  has a parameter of zero in GFN1-xTB
pure elemental function xbond(ati,atj) result(bool)
   integer,intent(in) :: ati,atj
   logical :: bool
   logical :: lx1,lx2,ly1,ly2

   bool=.false.
   lx1=.false.
   lx2=.false.
   ly1=.false.
   ly2=.false.

   if(ati.eq.17.or.ati.eq.35.or.ati.eq.53.or.ati.eq.85) lx1=.true.
   if(atj.eq.17.or.atj.eq.35.or.atj.eq.53.or.atj.eq.85) lx2=.true.
   if(ati.eq. 7.or.ati.eq. 8.or.ati.eq.15.or.ati.eq.16) ly1=.true.
   if(atj.eq. 7.or.atj.eq. 8.or.atj.eq.15.or.atj.eq.16) ly2=.true.

   if(lx1.and.ly2) bool=.true.
   if(lx2.and.ly1) bool=.true.

end function xbond


end module xtb_scf

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Handle conversion between element symbols and atomic numbers
module xtb_mctc_symbols
   use xtb_mctc_resize, only : resize
   implicit none
   private

   public :: symbolLength
   public :: symbolToNumber, numberToSymbol, numberToLcSymbol
   public :: toNumber, toSymbol, toLcSymbol, getIdentity


   !> Get chemical identity
   interface getIdentity
      module procedure :: getIdentityNumber
      module procedure :: getIdentitySymbol
   end interface getIdentity


   !> Maximum allowed length of element symbols
   integer, parameter :: symbolLength = 4


   !> Periodic system of elements
   character(len=2), parameter :: pse(118) = [ &
      & 'H ','He', &
      & 'Li','Be','B ','C ','N ','O ','F ','Ne', &
      & 'Na','Mg','Al','Si','P ','S ','Cl','Ar', &
      & 'K ','Ca', &
      & 'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn', &
      &           'Ga','Ge','As','Se','Br','Kr', &
      & 'Rb','Sr', &
      & 'Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd', &
      &           'In','Sn','Sb','Te','I ','Xe', &
      & 'Cs','Ba', &
      & 'La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb', &
      & 'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg', &
      &           'Tl','Pb','Bi','Po','At','Rn', &
      & 'Fr','Ra', &
      & 'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm','Md','No', &
      & 'Lr','Rf','Db','Sg','Bh','Hs','Mt','Ds','Rg','Cn', &
      &           'Nh','Fl','Mc','Lv','Ts','Og' ]


   !> Lower case version of the periodic system of elements
   character(len=2), parameter :: lcPse(118) = [ &
      & 'h ','he', &
      & 'li','be','b ','c ','n ','o ','f ','ne', &
      & 'na','mg','al','si','p ','s ','cl','ar', &
      & 'k ','ca', &
      & 'sc','ti','v ','cr','mn','fe','co','ni','cu','zn', &
      &           'ga','ge','as','se','br','kr', &
      & 'rb','sr', &
      & 'y ','zr','nb','mo','tc','ru','rh','pd','ag','cd', &
      &           'in','sn','sb','te','i ','xe', &
      & 'cs','ba','la', &
      & 'ce','pr','nd','pm','sm','eu','gd','tb','dy','ho','er','tm','yb', &
      & 'lu','hf','ta','w ','re','os','ir','pt','au','hg', &
      &           'tl','pb','bi','po','at','rn', &
      & 'fr','ra','ac', &
      & 'th','pa','u ','np','pu','am','cm','bk','cf','es','fm','md','no', &
      & 'lr','rf','db','sg','bh','hs','mt','ds','rg','cn', &
      &           'nh','fl','mc','lv','ts','og' ]


   !> ASCII offset between lowercase and uppercase letters
   integer, parameter :: offset = iachar('a') - iachar('A')


contains


!> Convert element symbol to atomic number
elemental subroutine symbolToNumber(number, symbol)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> Atomic number
   integer, intent(out) :: number

   character(len=2) :: lcSymbol
   integer :: i, j, k, l

   number = 0
   lcSymbol = '  '

   k = 0
   do j = 1, len_trim(symbol)
      if (k > 2) exit
      l = iachar(symbol(j:j))
      if (k >= 1 .and. l == iachar(' ')) exit
      if (k >= 1 .and. l == 9) exit
      if (l >= iachar('A') .and. l <= iachar('Z')) l = l + offset
      if (l >= iachar('a') .and. l <= iachar('z')) then
         k = k+1
         lcSymbol(k:k) = achar(l)
      endif
   enddo

   do i = 1, size(lcPse)
      if (lcSymbol == lcPse(i)) then
         number = i
         exit
      endif
   enddo

   if (number == 0) then
      select case(lcSymbol)
      case('d ', 't ')
         number = 1
      end select
   end if

end subroutine symbolToNumber


!> Convert atomic number to element symbol
elemental subroutine numberToSymbol(symbol, number)

   !> Atomic number
   integer, intent(in) :: number

   !> Element symbol
   character(len=2), intent(out) :: symbol

   if (number <= 0 .or. number > size(pse)) then
      symbol = '--'
   else
      symbol = pse(number)
   endif

end subroutine numberToSymbol


!> Convert atomic number to element symbol
elemental subroutine numberToLcSymbol(symbol, number)

   !> Atomic number
   integer, intent(in) :: number

   !> Element symbol
   character(len=2), intent(out) :: symbol

   if (number <= 0 .or. number > size(lcPse)) then
      symbol = '--'
   else
      symbol = lcPse(number)
   endif

end subroutine numberToLcSymbol


!> Convert element symbol to atomic number
elemental function toNumber(symbol) result(number)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> Atomic number
   integer :: number

   call symbolToNumber(number, symbol)

end function toNumber


!> Convert atomic number to element symbol
elemental function toSymbol(number) result(symbol)

   !> Atomic number
   integer,intent(in) :: number

   !> Element symbol
   character(len=2) :: symbol

   call numberToSymbol(symbol, number)

end function toSymbol


!> Convert atomic number to element symbol
elemental function toLcSymbol(number) result(symbol)

   !> Atomic number
   integer,intent(in) :: number

   !> Element symbol
   character(len=2) :: symbol

   call numberToLcSymbol(symbol, number)

end function toLcSymbol


!> Get chemical identity from a list of atomic numbers
subroutine getIdentityNumber(nId, identity, number)

   !> Number of unique species
   integer, intent(out) :: nId

   !> Ordinal numbers
   integer, intent(in) :: number(:)

   !> Chemical identity
   integer, intent(out) :: identity(:)

   integer, allocatable :: iTmp(:)
   integer :: nAt, iAt, iId

   nAt = size(identity)
   allocate(iTmp(nAt))
   nId = 0
   do iAt = 1, nAt
      iId = findNumber(iTmp(:nId), number(iAt))
      if (iId == 0) then
         call appendNumber(iTmp, nId, number(iAt))
         iId = nId
      end if
      identity(iAt) = iId
   end do

end subroutine getIdentityNumber


!> Get chemical identity from a list of element symbols
subroutine getIdentitySymbol(nId, identity, symbol)

   !> Number of unique species
   integer, intent(out) :: nId

   !> Element symbols
   character(len=symbolLength), intent(in) :: symbol(:)

   !> Chemical identity
   integer, intent(out) :: identity(:)

   character(len=symbolLength), allocatable :: sTmp(:)
   integer :: nAt, iAt, iId

   nAt = size(identity)
   allocate(sTmp(nAt))
   nId = 0
   do iAt = 1, nAt
      iId = findSymbol(sTmp(:nId), symbol(iAt))
      if (iId == 0) then
         call appendSymbol(sTmp, nId, symbol(iAt))
         iId = nId
      end if
      identity(iAt) = iId
   end do

end subroutine getIdentitySymbol


!> Find element symbol in an unordered list, all entries are required to be unique
pure function findSymbol(list, symbol) result(position)

   !> List of element symbols
   character(len=*), intent(in) :: list(:)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> Position of the symbol in list if found, otherwise zero
   integer :: position
   integer :: iSym

   position = 0
   do iSym = 1, size(list)
      if (symbol == list(iSym)) then
         position = iSym
         exit
      end if
   end do

end function findSymbol


!> Find atomic number in an unordered list, all entries are required to be unique
function findNumber(list, number) result(position)

   !> List of atomic numbers
   integer, intent(in) :: list(:)

   !> Atomic number
   integer, intent(in) :: number

   !> Position of the number in list if found, otherwise zero
   integer :: position
   integer :: iNum

   position = 0
   do iNum = 1, size(list)
      if (number == list(iNum)) then
         position = iNum
         exit
      end if
   end do

end function findNumber


!> Append an element symbol to an unsorted list, to ensure no dublicates search
!> for the element symbol first
pure subroutine appendSymbol(list, nList, symbol)

   !> List of element symbols
   character(len=*), allocatable, intent(inout) :: list(:)

   !> Current occupied size of list
   integer, intent(inout) :: nList

   !> Elements symbol
   character(len=*), intent(in) :: symbol

   if (nList >= size(list)) then
      call resize(list)
   end if

   nList = nList + 1
   list(nList) = symbol

end subroutine appendSymbol


!> Append an atomic number to an unsorted list, to ensure no dublicates search
!> for the atomic number first
pure subroutine appendNumber(list, nList, number)

   !> List of atomic number
   integer, allocatable, intent(inout) :: list(:)

   !> Current occupied size of list
   integer, intent(inout) :: nList

   !> Atomic number
   integer, intent(in) :: number

   if (nList >= size(list)) then
      call resize(list)
   end if

   nList = nList + 1
   list(nList) = number

end subroutine appendNumber


end module xtb_mctc_symbols

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine fodenmak(uhf,nmo,eps,occ,efermi)
   use xtb_mctc_convert, only : autoev
   implicit none
   integer nmo
   logical uhf
   real*8 efermi
   real*8 occ(*)
   real*8 eps(*)

   integer i
   real*8 inte

   inte=2.0d0
   if(uhf) inte=1.0d0

   do i=1,nmo
      if(eps(i)*autoev.le.efermi) then
         occ(i)=inte-occ(i)
      endif
   enddo

end subroutine fodenmak

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of an isotropic electrostatics container
module xtb_xtb_coulomb
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : blas_dot, blas_symv
   use xtb_xtb_data, only : TCoulombData
   use xtb_xtb_thirdorder, only : TThirdOrder, init
   implicit none
   private

   public :: TxTBCoulomb, init


   !> Isotropic electrostatics
   type :: TxTBCoulomb

      !> Third order electrostatics
      type(TThirdOrder) :: thirdOrder

      !> Coulomb matrix
      real(wp), allocatable :: jmat(:, :)

      !> Scratch memory for storing the shifts
      real(wp), allocatable :: shift(:)

   contains

      !> Add shifts from isotropic electrostatics
      procedure :: addShift

      !> Get energy from isotropic electrostatics
      procedure :: getEnergy

   end type TxTBCoulomb


   !> Initialize isotropic electrostatics
   interface init
      module procedure :: initCoulomb
   end interface init


contains


!> Initialize isotropic electrostatics from parametrisation data
subroutine initCoulomb(self, input, nshell, num)

   !> Instance of the isotropic electrostatics
   type(TxTBCoulomb), intent(out) :: self

   !> Parametrisation data for coulombic interactions
   type(TCoulombData), intent(in) :: input

   !> Number of shells for each species
   integer, intent(in) :: nshell(:)

   !> Atomic numbers of each element
   integer, intent(in) :: num(:)

   integer :: nsh

   call init(self%thirdOrder, input, nshell, num)

   nsh = sum(nshell(num))
   allocate(self%jmat(nsh, nsh))
   allocate(self%shift(nsh))

end subroutine initCoulomb


!> Add shifts from isotropic electrostatics
subroutine addShift(self, qat, qsh, atomicShift, shellShift)

   !> Instance of the isotropic electrostatics
   class(TxTBCoulomb), intent(inout) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Atomic potential shift
   real(wp), intent(inout) :: atomicShift(:)

   !> Shell-resolved potential shift
   real(wp), intent(inout) :: shellShift(:)

   integer :: nsh

   nsh = size(shellShift)

   call self%thirdOrder%addShift(qat, qsh, atomicShift, shellShift)

   call blas_symv('l', nsh, 1.0_wp, self%jmat, nsh, qsh, 1, 1.0_wp, shellShift, 1)

end subroutine addShift


!> Get energy from isotropic electrostatics
pure subroutine getEnergy(self, qat, qsh, energy)

   !> Instance of the isotropic electrostatics
   class(TxTBCoulomb), intent(inout) :: self

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Third order contribution to the energy
   real(wp), intent(out) :: energy

   integer :: nsh
   real(wp) :: eThird

   nsh = size(qsh)

   call self%thirdOrder%getEnergy(qat, qsh, eThird)

   call blas_symv('l', nsh, 1.0_wp, self%jmat, nsh, qsh, 1, 0.0_wp, self%shift, 1)
   energy = 0.5_wp * blas_dot(nsh, self%shift, 1, qsh, 1) + eThird

end subroutine getEnergy


end module xtb_xtb_coulomb

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the repulsion energy used in the xTB Hamiltonian
module xtb_xtb_repulsion
   use xtb_mctc_accuracy, only : wp
   use xtb_type_identitymap, only : TIdentityMap
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_neighbourlist, only : TNeighbourlist
   use xtb_xtb_data
   implicit none
   private

   public :: repulsionEnGrad


   interface repulsionEnGrad
      module procedure :: repulsionEnGrad_latp
      module procedure :: repulsionEnGrad_neighs
   end interface repulsionEnGrad


contains


!> Lattice point based implementation of the repulsion energy
subroutine repulsionEnGrad_latp(mol, repData, trans, cutoff, energy, gradient, &
      & sigma)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Repulsion parametrisation
   type(TRepulsionData), intent(in) :: repData

   !> Lattice translations
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   !> Strain derivatives
   real(wp), intent(inout) :: sigma(:, :)

   !> Repulsion energy
   real(wp), intent(inout) :: energy

   integer  :: iat, jat, iZp, jZp, itr, k, l
   real(wp) :: t16, t26, t27
   real(wp) :: alpha, zeff, kExp, cutoff2
   real(wp) :: r1, r2, rij(3), dS(3, 3), dG(3), dE
   real(wp), allocatable :: energies(:)

   cutoff2 = cutoff**2

   allocate(energies(mol%n))

   !$acc enter data create(energies, rij, dS, dG) copyin(gradient, sigma, mol, mol%at, &
   !$acc& mol%xyz, repData, repData%alpha, repData%zeff, trans)

   !$acc kernels default(present)
   energies(:) = 0.0_wp
   !$acc end kernels

#ifdef XTB_GPU
   !$acc parallel default(present)
   !$acc loop gang collapse(2) private(iZp, jZp, alpha, zeff, kExp)
#else
   !$omp parallel do default(none) reduction(+:energies, gradient, sigma) &
   !$omp shared(repData, mol, cutoff2, trans) &
   !$omp private(iat, jat, itr, iZp, jZp, r2, rij, r1, alpha, zeff, kexp, &
   !$omp& t16, t26, t27, dE, dG, dS, k, l)
#endif
   do iAt = 1, mol%n
      do jAt = 1, mol%n
         if (jAt > iAt) cycle
         iZp = mol%at(iAt)
         jZp = mol%at(jAt)
         alpha = sqrt(repData%alpha(iZp)*repData%alpha(jZp))
         zeff = repData%zeff(iZp)*repData%zeff(jZp)
         if (iZp > 2 .or. jZp > 2) then
            kExp = repData%kExp
         else
            kExp = repData%kExpLight
         end if
         !$acc loop vector private(rij, r2, r1, t16, t26, t27, dE, dG, dS)
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iAt) - mol%xyz(:, jAt) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-8_wp) cycle
            r1 = sqrt(r2)

            t16 = r1**kExp
            t26 = exp(-alpha*t16)
            t27 = r1**repData%rExp
            dE = zeff * t26/t27
            dG = -(alpha*t16*kExp + repData%rExp) * dE * rij/r2
            dS = spread(dG, 1, 3) * spread(rij, 2, 3)
            !$acc atomic
            energies(iAt) = energies(iAt) + 0.5_wp * dE
            if (iAt /= jAt) then
               !$acc atomic
               energies(jAt) = energies(jAt) + 0.5_wp * dE
               !$acc loop seq
               do k = 1, 3
                  !$acc atomic
                  gradient(k, iAt) = gradient(k, iAt) + dG(k)
                  !$acc atomic
                  gradient(k, jAt) = gradient(k, jAt) - dG(k)
               end do
               !$acc loop seq collapse(2)
               do k = 1, 3
                  do l = 1, 3
                     !$acc atomic
                     sigma(l, k) = sigma(l, k) + dS(l, k)
                  end do
               end do
            else
               !$acc loop seq collapse(2)
               do k = 1, 3
                  do l = 1, 3
                     !$acc atomic
                     sigma(l, k) = sigma(l, k) + 0.5_wp * dS(l, k)
                  end do
               end do
            endif
         enddo
      enddo
   enddo
#ifdef XTB_GPU
   !$acc end parallel

   !$acc exit data copyout(energies, gradient, sigma) delete(mol, mol%at, &
   !$acc& mol%xyz, repData, repData%alpha, repData%zeff, rij, dG, dS, trans)
#endif

   energy = energy + sum(energies)

end subroutine repulsionEnGrad_latp


!> Lattice point based implementation of the repulsion energy
subroutine repulsionEnGrad_neighs(mol, repData, neighs, neighList, energy, &
      & gradient, sigma)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Repulsion parametrisation
   type(TRepulsionData), intent(in) :: repData

   !> Number of neighbours for each atom
   integer, intent(in) :: neighs(:)

   !> Neighbourlist
   class(TNeighbourList), intent(in) :: neighList

   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   !> Strain derivatives
   real(wp), intent(inout) :: sigma(:, :)

   !> Repulsion energy
   real(wp), intent(inout) :: energy

   integer  :: iat, jat, iZp, jZp, ij, img
   real(wp) :: t16, t26, t27
   real(wp) :: alpha, zeff, kExp, cutoff2
   real(wp) :: r1, r2, rij(3), dS(3, 3), dG(3), dE
   real(wp), allocatable :: energies(:)

   allocate(energies(len(mol)))
   energies(:) = 0.0_wp

   !$omp parallel do default(none) reduction(+:energies, gradient, sigma) &
   !$omp shared(repData, mol, neighs, neighList) &
   !$omp private(iat, jat, ij, img, iZp, jZp, r2, rij, r1, alpha, zeff, kexp, &
   !$omp& t16, t26, t27, dE, dG, dS)
   do iAt = 1, len(mol)
      iZp = mol%at(iAt)
      do ij = 1, neighs(iAt)
         img = neighList%ineigh(ij, iAt)
         jAt = neighList%image(img)
         jZp = mol%at(jAt)
         rij = neighList%coords(:, iAt) - neighList%coords(:, img)
         r2 = neighList%dist2(ij, iAt)
         r1 = sqrt(r2)

         alpha = sqrt(repData%alpha(iZp)*repData%alpha(jZp))
         zeff = repData%zeff(iZp)*repData%zeff(jZp)
         if (iZp > 2 .or. jZp > 2) then
            kExp = repData%kExp
         else
            kExp = repData%kExpLight
         end if
         t16 = r1**kExp
         t26 = exp(-alpha*t16)
         t27 = r1**repData%rExp
         dE = zeff * t26/t27
         dG = -(alpha*t16*kExp + repData%rExp) * dE * rij/r2
         dS = spread(dG, 1, 3) * spread(rij, 2, 3)
         energies(iAt) = energies(iAt) + 0.5_wp * dE
         sigma = sigma + 0.5_wp * dS
         if (iAt /= jAt) then
            energies(jAt) = energies(jAt) + 0.5_wp * dE
            sigma = sigma + 0.5_wp * dS
            gradient(:, iAt) = gradient(:, iAt) + dG
            gradient(:, jAt) = gradient(:, jAt) - dG
         endif
      enddo
   enddo
   !$omp end parallel do

   energy = energy + sum(energies)

end subroutine repulsionEnGrad_neighs


end module xtb_xtb_repulsion

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  COPYRIGHT (C) 2015 by Filippo Lipparini, Benjamin Stamm, Paolo Gatto        !
!  Eric Cancès, Yvon Maday, Jean-Philip Piquemal, Louis Lagardère and          !
!  Benedetta Mennucci.                                                         !
!                             ALL RIGHT RESERVED.                              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! A modular implementation of COSMO using a domain decomposition linear scaling
! strategy.
!
! This code is governed by the LGPL license and abiding by the rules of
! distribution of free software.
! This program is distributed in the hope that it will be useful, but
! WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.
! See the GNU Lesser General Public License for more details.

module xtb_solv_ddcosmo_solver
   use xtb_solv_ddcosmo_core, only : TDomainDecomposition, hsnorm, calcv, &
      & intrhs, prtsph, adjrhs
   implicit none
   private

   public :: jacobi_diis, lx, lstarx, ldm1x, hnorm

   integer, parameter :: wp = selected_real_kind(15)


contains


!> Jacobi/DIIS solver
subroutine jacobi_diis(ddCosmo, n, lprint, diis_max, norm, tol, rhs, x, &
      & n_iter, ok, matvec, dm1vec, u_norm)

   !  Error source
   character(len=*), parameter :: source = 'ddcosmo_solver::jacobi_diis'

   !> Instance of the COSMO model
   type(TDomainDecomposition), intent(in) :: ddCosmo

   !> Integer, input, size of the matrix
   integer, intent(in) :: n

   !> Integer, input, number of points to be used for diis extrapolation
   !  if diis_max = 0, this is just a Jacobi solver.
   integer, intent(in) :: diis_max

   !> Integer, input, norm to be used to evaluate convergence
   !  1: max |x_new - x|
   !  2: rms (x_new - x)
   !  3: rms (x_new - x) and max |x_new - x|
   !  4: norm computed by the user-provided function u_norm(n, x)
   integer, intent(in) :: norm

   !> Integer, input, printing flag.
   integer, intent(in) :: lprint

   !> Real, input, convergence criterion. if norm = 3, convergence is
   !  achieved when rms (x_new - x) < tol and max |x_new - x| < 10*tol.
   real(wp), intent(in) :: tol

   !> Real, dimension(n), input, right-hand side of the linear system
   real(wp), intent(in) :: rhs(:, :)

   !> Real, dimension(n). In input, a guess of the solution (can be zero).
   !  In output, the solution
   real(wp), intent(inout), contiguous, target :: x(:, :)

   !> Integer, in input, the maximum number of iterations. In output,
   !  the number of iterations needed to converge.
   integer, intent(inout) :: n_iter

   !> Logical, output, T if the solver converged, false otherwise.
   logical, intent(inout) :: ok

   !> External, subroutine to compute the required matrix-vector multiplication
   !  format: subroutine matvec(n, x, y)
   procedure(lx) :: matvec

   !> External, subroutine to apply the inverse diagonal matrix to a vector.
   !  format: subroutine dm1vec(n, x, y)
   procedure(ldm1x) :: dm1vec

   !> External, optional function to compute the norm of a vector.
   !> Format: real(wp) function u_norm(n, x)
   procedure(hnorm), optional :: u_norm

   integer :: it, nmat, istatus, lenb
   real(wp) :: rms_norm, max_norm, tol_max
   logical :: dodiis

   real(wp), allocatable :: y(:, :), x_diis(:, :), e_diis(:, :), bmat(:, :)
   real(wp), allocatable, target :: x_new(:, :)
   real(wp), pointer :: xptr(:)

   character(len=*), parameter :: f100 = "(t3, 'iter=', i4, ' residual norm (rms, max): ', 2d14.4)"
   character(len=*), parameter :: f110 = "(t3, 'iter=', i4, ' residual norm (', a, '): ', d14.4)"
   character(len=*), parameter :: f120 = "(t3, 'iter=', i4, ' residual norm: ', d14.4)"

   ! check inputs
   if ((norm == 4) .and. (.not.present(u_norm))) then
      error stop 'must provide a function norm(n, x) to evaluate the norm of the increment'
      return
   end if

   ! DIIS extrapolation flag
   dodiis =  (diis_max /= 0)

   ! set tolerance
   tol_max = 10.0_wp * tol

   ! extrapolation required
   if (dodiis) then

      ! allocate workspaces
      lenb = diis_max + 1
      allocate(x_diis(n, diis_max), e_diis(n, diis_max), bmat(lenb, lenb))

      ! an enigmatic constant
      nmat = 1
   end if

   ! allocate workspaces
   allocate(x_new, mold=rhs)
   allocate(y, mold=rhs)

   ! Jacobi iterations
   do it = 1, n_iter

      ! y = rhs - O x
      call matvec(ddCosmo, n, x, y)
      y = rhs - y

      ! x_new = D^-1 y
      call dm1vec(ddCosmo, n, y, x_new)

      ! DIIS extrapolation
      if (dodiis) then
         x_diis(:, nmat) = reshape(x_new, [size(x_new)])
         e_diis(:, nmat) = reshape(x_new - x, [size(x_new)])

         xptr(1:size(x_new)) => x_new
         call diis(n, nmat, diis_max, x_diis, e_diis, bmat, xptr)
      end if

      ! increment
      x = x_new - x

      ! rms/max norm of increment
      if (norm <= 3) then

         ! compute norm
         xptr(1:size(x)) => x
         call rmsvec(n, xptr, rms_norm, max_norm)

         ! check norm
         if (norm == 1) then
            ok = (rms_norm < tol)
         elseif (norm == 2) then
            ok = (max_norm < tol)
         else
            ok = (rms_norm < tol) .and. (max_norm < tol_max)
         end if

         ! user-provided norm of increment
      elseif (norm == 4) then

         ! just a placeholder for printing
         max_norm = -1.0_wp

         ! compute norm
         rms_norm = u_norm(ddCosmo, n, x)

         ! check norm
         ok = (rms_norm < tol)

      end if

      ! printing
      if (lprint > 0) then
         if (norm == 1) then
            write(*, f110) it, 'max', max_norm
         else if (norm == 2) then
            write(*, f110) it, 'rms', rms_norm
         else if (norm == 3) then
            write(*, f100) it, rms_norm, max_norm
         else if (norm == 4) then
            write(*, f120) it, rms_norm
         end if
      end if

      ! update
      x = x_new

      ! EXIT Jacobi loop here

      if (ok) exit

   end do

   ! record number of Jacobi iterations
   n_iter = it

endsubroutine jacobi_diis


subroutine diis(n, nmat, ndiis, x, e, b, xnew)
   integer, intent(in) :: n, ndiis
   integer, intent(inout) :: nmat
   real(wp), intent(inout) :: x(:, :) !< [n, ndiis]
   real(wp), intent(inout) :: e(:, :) !< [n, ndiis]
   real(wp), intent(inout) :: b(:, :) !< [ndiis+1, ndiis+1]
   real(wp), intent(inout) :: xnew(:) !< [n]

   integer :: nmat1, i, istatus
   integer :: j, k
   logical :: ok

   real(wp), allocatable :: bloc(:, :), cex(:, :)

   if (nmat >= ndiis) then
      do j = 2, nmat - 10
         do k = 2, nmat - 10
            b(j, k) = b(j+10, k+10)
         end do
      end do
      do j = 1, nmat - 10
         x(:, j) = x(:, j+10)
         e(:, j) = e(:, j+10)
      end do
      nmat = nmat - 10
   end if
   nmat1 = nmat + 1
   allocate(bloc(nmat1, nmat1), cex(nmat1, 1), stat=istatus)
   if (istatus /= 0) then
      nmat = 1
      return
   end if

   call makeb(n, nmat, ndiis, e, b)
   bloc = b(1:nmat1, 1:nmat1)
   cex(:, :) = 0.0_wp
   cex(1, 1) = 1.0_wp
   call gjinv(nmat1, 1, bloc, cex, ok)
   if (.not. ok) then
      nmat = 1
      error stop "Upps!"
      return
   end if
   xnew = 0.0_wp
   do i = 1, nmat
      xnew = xnew + cex(i+1, 1)*x(:, i)
   end do
   nmat = nmat + 1

end subroutine diis


pure subroutine makeb(n, nmat, ndiis, e, b)
   integer, intent(in) :: n, nmat, ndiis
   real(wp), intent(in) :: e(n, ndiis)
   real(wp), intent(inout) :: b(ndiis+1, ndiis+1)

   integer :: i
   real(wp) :: bij

   ! 1st built
   if (nmat == 1) then
      !       [ 0 |  1  ]
      !   b = [ --+---- ]
      !       [ 1 | e*e ]
      b(1, 1) = 0.0_wp
      b(1, 2) = 1.0_wp
      b(2, 1) = 1.0_wp
      b(2, 2) = dot_product(e(:, 1), e(:, 1))
   else
      ! subsequent builts
      ! first, update the lagrangian line:
      b(nmat+1, 1) = 1.0_wp
      b(1, nmat+1) = 1.0_wp
      ! now, compute the new matrix elements:
      do i = 1, nmat - 1
         bij = dot_product(e(:, i), e(:, nmat))
         b(nmat+1, i+1) = bij
         b(i+1, nmat+1) = bij
      end do
      b(nmat+1, nmat+1) = dot_product(e(:, nmat), e(:, nmat))
   end if

end subroutine makeb


pure subroutine gjinv(n, nrhs, a, b, ok)
   integer, intent(in) :: n, nrhs
   logical, intent(inout) :: ok
   real(wp), intent(inout) :: a(:, :) ! [n, n]
   real(wp), intent(inout) :: b(:, :) ! [n, nrhs]

   integer :: i, j, k, irow, icol, istatus
   real(wp) :: big, dum, pinv

   integer, allocatable :: indxc(:), indxr(:), piv(:)
   real(wp), allocatable :: scr(:)

   ok = .false.

   allocate(indxc(n), indxr(n), piv(n), stat=istatus)
   if (istatus /= 0) then
      return
   end if
   allocate (scr(n), stat=istatus)
   if (istatus /= 0) then
      return
   end if

   piv = 0

   irow = 0
   icol = 0
   do i = 1, n
      big = 0.0_wp
      do j = 1, n
         if (piv(j) /= 1) then
            do k = 1, n
               if (piv(k) == 0) then
                  if (abs(a(j, k)) > big) then
                     big  = abs(a(j, k))
                     irow = j
                     icol = k
                  end if
               end if
            end do
         end if
      end do

      piv(icol) = piv(icol) + 1
      if (piv(icol) > 1) then
         !call warning('singular matrix', source)
         return
      end if
      if (irow /= icol) then
         scr         = a(irow, :)
         a(irow, :)   = a(icol, :)
         a(icol, :)   = scr
         scr(1:nrhs) = b(irow, :)
         b(irow, :)   = b(icol, :)
         b(icol, :)   = scr(1:nrhs)
      end if

      indxr(i) = irow
      indxc(i) = icol

      if (a(icol, icol) == 0.0_wp) then
         !call warning('singular matrix', source)
         return
      end if

      pinv = 1.0_wp/a(icol, icol)
      a(icol, icol) = 1.0_wp
      a(icol, :) = a(icol, :)*pinv
      b(icol, :) = b(icol, :)*pinv

      do j = 1, n
         if (j /= icol) then
            dum       = a(j, icol)
            a(j, icol) = 0.0_wp
            a(j, :)    = a(j, :) - a(icol, :)*dum
            b(j, :)    = b(j, :) - b(icol, :)*dum
         end if
      end do
   end do

   do j = n, 1, -1
      if (indxr(j) /= indxc(j)) then
         scr           = a(:, indxr(j))
         a(:, indxr(j)) = a(:, indxc(j))
         a(:, indxc(j)) = scr
      end if
   end do

   ok = .true.

end subroutine gjinv


!> Compute root-mean-square and max norm
pure subroutine rmsvec(n, v, vrms, vmax)
   integer, intent(in) :: n
   real(wp), intent(in) :: v(:) !< [n]
   real(wp), intent(inout) :: vrms, vmax

   integer :: i

   ! initialize
   vrms = 0.0_wp
   vmax = 0.0_wp

   ! loop over entries
   do i = 1, n

      ! max norm
      vmax = max(vmax, abs(v(i)))

      ! rms norm
      vrms = vrms + v(i)*v(i)

   end do

   ! the much neglected square root
   vrms = sqrt(vrms/dble(n))

end subroutine rmsvec


!> Given a vector x, compute y = Lx, where L is the ddCOSMO matrix
!  (off-diagonal blocks only).
subroutine lx(ddCosmo, n, x, y)

   type(TDomainDecomposition), intent(in) :: ddCosmo
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [ddCosmo%nylm, ddCosmo%nat]
   real(wp), intent(inout) :: y(:, :) ! [ddCosmo%nylm, ddCosmo%nat]

   integer :: iat, istatus
   real(wp), allocatable :: pot(:), vplm(:), basloc(:), vcos(:), vsin(:)

   ! allocate workspaces
   allocate(pot(ddCosmo%ngrid), vplm(ddCosmo%nylm), basloc(ddCosmo%nylm), &
      & vcos(ddCosmo%lmax+1), vsin(ddCosmo%lmax+1))

   if (ddCosmo%iprint >= 5) call prtsph(ddCosmo, 'X', ddCosmo%nat, 0, x)

   ! initialize
   y(:, :) = 0.0_wp

   !$omp parallel do default(none) schedule(runtime) shared(ddCosmo, y, x) &
   !$omp private(iat, pot, basloc, vplm, vcos, vsin)
   ! loop over spheres
   do iat = 1, ddCosmo%nat

      ! compute NEGATIVE action of off-digonal blocks
      call calcv(ddCosmo, .false., iat, pot, x, basloc, vplm, vcos, vsin)
      call intrhs(ddCosmo, iat, pot, y(:, iat))

      ! action of off-diagonal blocks
      y(:, iat) = - y(:, iat)

   end do

   if (ddCosmo%iprint >= 5) call prtsph(ddCosmo, 'LX (off diagonal)', ddCosmo%nat, 0, y)

end subroutine lx


!> Given a vector x, compute y = L*x, where L* is the adjoint ddCOSMO matrix.
!  if dodiag is set to .true., L includes the diagonal blocks, otherwise
!  L only includes the off-diagonal ones.
subroutine lstarx(ddCosmo, n, x, y)

   type(TDomainDecomposition), intent(in) :: ddCosmo
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [ddCosmo%nylm, ddCosmo%nat]
   real(wp), intent(inout) :: y(:, :) ! [ddCosmo%nylm, ddCosmo%nat]

   integer :: iat, ig, istatus
   real(wp), allocatable :: xi(:, :), vplm(:), basloc(:), vcos(:), vsin(:)

   ! allocate workspaces
   allocate(xi(ddCosmo%ngrid, ddCosmo%nat), vplm(ddCosmo%nylm), &
      & basloc(ddCosmo%nylm), vcos(ddCosmo%lmax+1), vsin(ddCosmo%lmax+1))

   if (ddCosmo%iprint >= 5) call prtsph(ddCosmo, 'X', ddCosmo%nat, 0, x)

   ! initilize
   y(:, :) = 0.0_wp

   ! expand x over spherical harmonics
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(ddCosmo, xi, x) private(iat, ig)
   ! loop over spheres
   do iat = 1, ddCosmo%nat
      ! loop over griwpoints
      do ig = 1, ddCosmo%ngrid
         xi(ig, iat) = dot_product(x(:, iat), ddCosmo%basis(:, ig))
      end do
   end do

   ! compute action
   !$omp parallel do default(none) schedule(runtime) &
   !$omp shared(ddCosmo, xi, y) private(iat, basloc, vplm, vcos, vsin)
   ! loop over spheres
   do iat = 1, ddCosmo%nat

      ! compute NEGATIVE action of off-digonal blocks
      call adjrhs(ddCosmo, iat, xi, y(:, iat), basloc, vplm, vcos, vsin)

      ! action of off-diagonal blocks
      y(:, iat) = - y(:, iat)

   end do

   if (ddCosmo%iprint >= 5) call prtsph(ddCosmo, 'L*X (off-diagonal)', ddCosmo%nat, 0, y)

end subroutine lstarx


!> Given a vector x, apply the inverse diagonal (block) of the L matrix:
pure subroutine ldm1x(ddCosmo, n, x, y)
   type(TDomainDecomposition), intent(in) :: ddCosmo
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [ddCosmo%nylm, ddCosmo%nat]
   real(wp), intent(inout) :: y(:, :) ! [ddCosmo%nylm, ddCosmo%nat]

   integer :: iat

   ! loop over spheres
   do iat = 1, ddCosmo%nat
      ! apply inverse
      y(:, iat) = ddCosmo%facl*x(:, iat)
   end do

end subroutine ldm1x


!> Compute the h^-1/2 norm of the increment on each sphere, then take the
!  rms value.
real(wp) function hnorm(ddCosmo, n, x)
   type(TDomainDecomposition), intent(in) :: ddCosmo
   integer, intent(in) :: n
   real(wp), intent(in) :: x(:, :) ! [ddCosmo%nylm, ddCosmo%nat]
   integer :: iat, istatus
   real(wp) :: vrms, vmax
   real(wp), allocatable :: u(:)

   ! allocate workspace
   allocate(u(ddCosmo%nat))

   ! loop over spheres
   do iat = 1, ddCosmo%nat
      ! compute norm contribution
      call hsnorm(ddCosmo, x(:, iat), u(iat))
   end do

   ! compute rms of norms
   call rmsvec(ddCosmo%nat, u, vrms, vmax)

   ! return value
   hnorm = vrms

end function hnorm


end module xtb_solv_ddcosmo_solver

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_peeq
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_peeq

contains

!> Collect all exported unit tests
subroutine collect_peeq(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("sp", test_peeq_sp), &
      new_unittest("api", test_peeq_api), &
      new_unittest("srb", test_peeq_api_srb) &
      ]

end subroutine collect_peeq


subroutine test_peeq_sp(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_mctc_systools

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_wavefunction
   use xtb_type_basisset
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment
   use xtb_solv_gbsa

   use xtb_setparam, only : set

   use xtb_pbc_tools
   use xtb_basis
   use xtb_peeq
   use xtb_readparam
   use xtb_paramset

   use xtb_xtb_data
   use xtb_xtb_gfn0

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-7_wp
   ! SiO2
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [8,14,8]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.51379029_wp,    8.29324256_wp,   -0.60000000_wp, &
      & 0.56666667_wp,    0.56666667_wp,   -0.60000000_wp, &
      & 0.96666667_wp,    0.96666667_wp,    1.20000001_wp],&
      & shape(xyz))
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[6.04712363_wp,    0.00000000_wp,    0.00000000_wp,    &
      & 0.00000000_wp,    9.82657590_wp,    0.00000000_wp,    &
      & 0.00000000_wp,    0.00000000_wp,   13.22808290_wp],   &
      & shape(lattice))
   real(wp),parameter :: et = 300.0_wp
   integer, parameter :: prlevel = 2
   logical, parameter :: lgrad = .true.
   logical, parameter :: ccm = .true.
   logical, parameter :: restart = .false.
   real(wp),parameter :: acc = 1.0_wp

   type(TMolecule)     :: mol
   type(TEnvironment)  :: env
   type(TWavefunction) :: wfn
   type(TBasisset)     :: basis
   type(scc_results)     :: res
   type(TxTBData) :: xtbData
   type(TBorn), allocatable :: gbsa

   real(wp)              :: energy
   real(wp)              :: hl_gap
   real(wp), allocatable :: gradient(:,:)
   real(wp)              :: sigma(3,3)

   integer, parameter    :: wsc_rep(3) = [1,1,1] ! FIXME

   character(len=*), parameter   :: p_fnv_gfn0 = 'param_gfn0-xtb.txt'
   character(len=:), allocatable :: fnv
   type(TxTBParameter) :: globpar
   integer  :: ipar
   logical  :: exist

   logical  :: okbas,diff

   set%gfn_method = 0
   call init(env)

   call init(mol, at, xyz, lattice=lattice)

   allocate( gradient(3,mol%n) )
   energy = 0.0_wp
   gradient = 0.0_wp
   sigma = 0.0_wp

   ! give an optional summary on the geometry used
   call print_pbcsum(stdout,mol)

   ! we will try an internal parameter file first to avoid IO
   call use_parameterset(p_fnv_gfn0,globpar,xtbData,exist)
   ! no luck, we have to fire up some IO to get our parameters
   if (.not.exist) then
      ! let's check if we can find the parameter file
      call rdpath(env%xtbpath,p_fnv_gfn0,fnv,exist)
      ! maybe the user provides a local parameter file, this was always
      ! an option in `xtb', so we will give it a try
      if (.not.exist) fnv = p_fnv_gfn0
      call open_file(ipar,fnv,'r')
      if (ipar.eq.-1) then
         call test_failed(error, "Parameter file '"//fnv//"' not found!")
         return
      endif
      call readParam(env,ipar,globpar,xtbData,.true.)
      call close_file(ipar)
   endif

   call newBasisset(xtbData,mol%n,mol%at,basis,okbas)

   call wfn%allocate(mol%n,basis%nshell,basis%nao)
   wfn%nel = idint(sum(mol%z)) - mol%chrg
   wfn%nopen = 0
   wfn%q = mol%chrg / real(mol%n,wp)

   call mctc_mute

   call peeq(env,mol,wfn,basis,xtbData,gbsa,hl_gap,et,prlevel,lgrad,.true.,acc, &
      &      energy,gradient,sigma,res)

   call check_(error, energy,-7.3570001012578_wp, thr=thr)
   call check_(error, hl_gap, 2.1170422163611_wp, thr=1.0e-4_wp)
   call check_(error, norm2(gradient),4.6531382100157_wp, thr=thr)
   call check_(error, gradient(1,1),0.0171831109909_wp, thr=thr)
   call check_(error, gradient(3,2),3.1002099423654_wp, thr=thr)

   call check_(error, sigma(1,1),-0.48669769112351_wp, thr=thr)
   call check_(error, sigma(2,1),-0.33613693973170_wp, thr=thr)
   call check_(error, sigma(2,3), -1.3504590911322_wp, thr=thr)

   call check_(error, res%e_elec,-8.303090012925_wp, thr=thr)
   call check_(error, res%e_es,  -0.126523327000_wp, thr=thr)
   call check_(error, res%e_disp,-0.004101334765_wp, thr=thr)
   call check_(error, res%e_rep,  1.076714573432_wp, thr=thr)
   call check_(error, res%e_xb,   0.000000000000_wp, thr=thr)

   ! reset for reevaluatuation without CCM
   energy = 0.0_wp
   gradient = 0.0_wp
   sigma = 0.0_wp

   call peeq(env,mol,wfn,basis,xtbData,gbsa,hl_gap,et,prlevel,lgrad,.false.,acc, &
      &      energy,gradient,sigma,res)

   call check_(error, energy,-7.3514275392244_wp, thr=thr)
   call check_(error, hl_gap, 2.2269146636198_wp, thr=1.0e-4_wp)
   call check_(error, norm2(gradient),4.6440176418778_wp, thr=thr)
   call check_(error, gradient(1,1),0.0078432890861_wp, thr=thr)
   call check_(error, gradient(3,2),3.0969842115048_wp, thr=thr)

   call check_(error, sigma(1,1),-0.51138347441108_wp, thr=thr)
   call check_(error, sigma(2,1),-0.31805950090099_wp, thr=thr)
   call check_(error, sigma(2,3), -1.3396127658627_wp, thr=thr)

   call check_(error, res%e_elec,-8.297517450892_wp, thr=thr)
   call check_(error, res%e_es,  -0.126523327000_wp, thr=thr)
   call check_(error, res%e_disp,-0.004101334765_wp, thr=thr)
   call check_(error, res%e_rep,  1.076714573432_wp, thr=thr)
   call check_(error, res%e_xb,   0.000000000000_wp, thr=thr)

end subroutine test_peeq_sp

subroutine test_peeq_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_data
   use xtb_type_param
   use xtb_type_environment

   use xtb_pbc_tools

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   ! CaF2
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [9,9,20]
   real(wp),parameter :: abc(3,nat) = reshape(&
      &[0.25_wp, 0.25_wp, 0.25_wp, &
      & 0.75_wp, 0.75_wp, 0.75_wp, &
      & 0.00_wp, 0.00_wp, 0.00_wp], shape(abc))
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[5.9598811567890_wp,      2.1071361905157_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      6.3214085715472_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      0.0000000000000_wp,      7.2993338808807_wp],   &
      & shape(lattice))
   type(peeq_options),parameter :: opt = peeq_options( &
      &  prlevel = 2, ccm = .true., acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: chk
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   logical :: failed
   real(wp) :: energy
   real(wp) :: hl_gap
   real(wp) :: gradlatt(3,3)
   real(wp) :: sigma(3,3),inv_lat(3,3)
   real(wp),allocatable :: gradient(:,:)
   real(wp),allocatable :: xyz(:,:)

   ! setup the environment variables
   call init(env)

   allocate(xyz(3, nat))
   call coord_trafo(nat,lattice,abc,xyz)
   call init(mol, at, xyz, lattice=lattice)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp
   gradlatt = 0.0_wp

   call mctc_mute

   call newXTBCalculator(env, mol, calc, method=0)
   call env%check(failed)
   if (failed) then
      call test_failed(error, "Setup failed")
      return
   end if
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)
   inv_lat = mat_inv_3x3(mol%lattice)
   call sigma_to_latgrad(sigma,inv_lat,gradlatt)

   call check_(error, hl_gap, 4.9685235017906_wp, thr=thr)
   call check_(error, energy,-8.4863996084661_wp, thr=thr)
   call check_(error, norm2(gradient),0.33507483384363E-04_wp, thr=thr)
   call check_(error, norm2(gradlatt),0.33064163041261E-02_wp, thr=thr)

end subroutine test_peeq_api

subroutine test_peeq_api_srb(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_mctc_convert
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_data
   use xtb_type_param
   use xtb_type_environment

   use xtb_pbc_tools

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-9_wp
   ! CaF2
   integer, parameter :: nat = 32
   integer, parameter :: at(nat) = [8, 8, 8, 8, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.5853168464880421_wp,  4.9392326929575878_wp,  4.1894081210748118_wp,  &
      & 5.8862267152491423_wp,  1.1425258978245871_wp,  6.5015058204768126_wp,  &
      & 1.4284279616220412_wp,  4.6017511285540875_wp,  3.1465884436348119_wp,  &
      & 2.3323404704521411_wp,  1.4471801154820869_wp,  0.7121932185858125_wp,  &
      & 4.7333543155561415_wp,  2.7747291872305868_wp,  3.1951352976178122_wp,  &
      & 5.6617754419101418_wp,  2.2133191164485870_wp,  2.1235404838618126_wp,  &
      & 5.3107598618381422_wp,  2.6902988056185868_wp,  0.7384466319968125_wp,  &
      & 4.4947071071761426_wp,  3.9530790692635867_wp,  0.6801776747598124_wp,  &
      & 4.8005171923760424_wp,  4.9185102874975870_wp,  1.8186363449528122_wp,  &
      & 4.6951362687070421_wp,  4.2781752812835867_wp,  3.1816411821728123_wp,  &
      & 1.3838574419160412_wp,  5.2817805008910863_wp,  4.1482702947948136_wp,  &
      & 1.0268974195990415_wp,  4.7234752637800881_wp,  5.4989995400388123_wp,  &
      & 2.0852659694760409_wp,  5.0956317453800875_wp,  6.5351699846458127_wp,  &
      & 2.3344644666691412_wp, -0.0736561690909131_wp,  6.4245628001158135_wp,  &
      & 2.4894017448231409_wp,  0.6213510313930869_wp,  5.0967297417158131_wp,  &
      & 1.5745272273791413_wp,  0.1243470825760870_wp,  3.9731040773988129_wp,  &
      & 5.8221065925130420_wp,  5.3013563342055878_wp,  1.7264876737078123_wp,  &
      & 3.4487807319551416_wp,  3.6355832152975864_wp,  0.7429568016758125_wp,  &
      & 4.8499393376520423_wp,  3.4713855169305874_wp,  6.4691872586348129_wp,  &
      & 0.2495364434351412_wp,  2.4795455690160870_wp,  2.1043557230378123_wp,  &
      & 5.6691068338331423_wp,  1.1234174220755870_wp,  2.1414388326468128_wp,  &
      & 3.7072009289431418_wp,  2.4357632918535872_wp,  3.0094700999208119_wp,  &
      & 4.1414520030430415_wp,  5.7877262477775879_wp,  1.7803680119358125_wp,  &
      & 5.0142851411171421_wp,  2.4165926460955873_wp,  4.1857610486448129_wp,  &
      & 3.0280930003030413_wp,  4.6201081184690871_wp,  6.2533190952188136_wp,  &
      & 0.5863628696651412_wp,  0.5757236365910867_wp,  4.1021714214668128_wp,  &
      & 2.3776130524831411_wp,  1.6969724987740866_wp,  5.2327688986668139_wp,  &
      & 1.9486148363011413_wp,  0.4390675147070869_wp,  2.9999022491838123_wp,  &
      & 3.5312997625581413_wp,  0.4467415528495868_wp,  4.8114121395028135_wp,  &
      & 6.5089895990100421_wp,  5.2100409408535882_wp,  6.0066553789008132_wp,  &
      & 0.9001165013630412_wp,  3.6420787128610868_wp,  5.4413106648508132_wp,  &
      & 1.6012116650460413_wp,  5.6845471271780879_wp,  0.7675566847298124_wp], &
      & shape(xyz)) * aatoau
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[6.4411018522600_wp,    0.0492571261505_wp,    0.2192046129910_wp,  &
      & 0.0462076831749_wp,    6.6435057067500_wp,    0.1670513770770_wp,  &
      & 0.2262248220170_wp,   -0.9573234940220_wp,    6.7608039126200_wp], &
      & shape(lattice)) * aatoau
   type(peeq_options),parameter :: opt = peeq_options( &
      &  prlevel = 2, ccm = .true., acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: chk
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   logical :: failed
   real(wp) :: energy
   real(wp) :: hl_gap
   real(wp) :: gradlatt(3,3)
   real(wp) :: sigma(3,3),inv_lat(3,3)
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz, lattice=lattice)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp
   gradlatt = 0.0_wp

   call mctc_mute

   call newXTBCalculator(env, mol, calc, method=0)
   call env%check(failed)
   if (failed) then
      call test_failed(error, "Setup failed")
      return
   end if
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)
   inv_lat = mat_inv_3x3(mol%lattice)
   call sigma_to_latgrad(sigma,inv_lat,gradlatt)

   call check_(error, hl_gap, 3.2452476555284_wp, thr=thr)
   call check_(error, energy,-47.338099017467_wp, thr=thr)
   call check_(error, norm2(gradient),0.60674690405096E-01_wp, thr=thr)
   call check_(error, norm2(gradlatt),0.25787608030965E-01_wp, thr=thr)

   call check_(error, gradient(1, 3), 0.15527599551578E-02_wp, thr=thr)
   call check_(error, gradient(2,11), 0.14689883866846E-01_wp, thr=thr)
   call check_(error, gradient(1, 6),-0.18911924607680E-02_wp, thr=thr)
   call check_(error, gradient(3, 5), 0.15935221260425E-02_wp, thr=thr)
   call check_(error, gradient(1, 8), 0.25516596273654E-02_wp, thr=thr)

   call check_(error, gradlatt(1,3), 0.24324041066017E-03_wp, thr=thr)
   call check_(error, gradlatt(2,2), 0.11757572269151E-01_wp, thr=thr)
   call check_(error, gradlatt(1,2), 0.60490544331116E-03_wp, thr=thr)

end subroutine test_peeq_api_srb

end module test_peeq

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Interfaces to LAPACK
module xtb_mctc_lapack
   use xtb_mctc_lapack_geneigval, only : lapack_sygv, lapack_sygvd, lapack_sygvx, &
      & lapack_spgv, lapack_spgvd, lapack_spgvx,lapack_hegv, lapack_hegvd, &
      & lapack_hegvx, lapack_hpgv, lapack_hpgvd,  lapack_hpgvx
   use xtb_mctc_lapack_gst, only : lapack_sygst, lapack_spgst, lapack_hegst, &
      & lapack_hpgst
   use xtb_mctc_lapack_stdeigval, only : lapack_syev, lapack_syevd, lapack_syevx, &
      & lapack_syevr, lapack_spev, lapack_spevd, lapack_spevx, lapack_heev, &
      & lapack_heevd, lapack_heevx, lapack_heevr, lapack_hpev, lapack_hpevd, &
      & lapack_hpevx
   use xtb_mctc_lapack_trf, only : lapack_getrf, lapack_sytrf, lapack_sptrf, &
      & lapack_potrf, lapack_pptrf
   use xtb_mctc_lapack_tri, only : lapack_getri, lapack_sytri, lapack_sptri, &
      & lapack_potri, lapack_pptri
   use xtb_mctc_lapack_trs, only : lapack_getrs, lapack_sytrs, lapack_sptrs, &
      & lapack_potrs, lapack_pptrs
   use xtb_mctc_lapack_wrap
   implicit none
   public


end module xtb_mctc_lapack

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine getvdwxy(rx,ry,rz, c66, s6,r0, vdw)
   !cc Ableitung nach rx und ry
   Implicit Real*8 (a-h, o-z)
   integer k, l
   !    write(*,*) 's6:', s6
   avdw=20.0
   t1 = s6 * C66
   t2 = rx ** 2
   t3 = ry ** 2
   t4 = rz ** 2
   t5 = t2 + t3 + t4
   t6 = t5 ** 2
   t7 = t6 ** 2
   t11 = sqrt(t5)
   t12 = 0.1D1 / r0
   t16 = exp(-avdw * (t11 * t12 - 0.1D1))
   t17 = 0.1D1 + t16
   t25 = t17 ** 2
   t26 = 0.1D1 / t25
   t35 = 0.1D1 / t7
   t40 = avdw ** 2
   t41 = r0 ** 2
   t43 = t40 / t41
   t44 = t16 ** 2
   t56 = -0.48D2 * t1 / t7 / t5 / t17 * rx * ry + 0.13D2 * t1 / t11 /&
      & t7 * t26 * rx * avdw * t12 * ry * t16 - 0.2D1 * t1 * t35 / t25 /&
      &t17 * t43 * rx * t44 * ry + t1 * t35 * t26 * t43 * rx * ry * t16
   vdw=t56
end subroutine

subroutine getvdwxx(rx, ry, rz, c66, s6, r0, vdw)
   !cc Ableitung nach rx und rx
   Implicit Real*8 (a-h, o-z)
   avdw=20.0
   !      write(*,*) 's6:', s6
   t1 = s6 * C66
   t2 = rx ** 2
   t3 = ry ** 2
   t4 = rz ** 2
   t5 = t2 + t3 + t4
   t6 = t5 ** 2
   t7 = t6 ** 2
   t10 = sqrt(t5)
   t11 = 0.1D1 / r0
   t15 = exp(-avdw * (t10 * t11 - 0.1D1))
   t16 = 0.1D1 + t15
   t17 = 0.1D1 / t16
   t24 = t16 ** 2
   t25 = 0.1D1 / t24
   t29 = t11 * t15
   t33 = 0.1D1 / t7
   t41 = avdw ** 2
   t42 = r0 ** 2
   t44 = t41 / t42
   t45 = t15 ** 2
   t62 = -0.48D2 * t1 / t7 / t5 * t17 * t2 + 0.13D2 * t1 / t10 / t7 *&
      & t25 * t2 * avdw * t29 + 0.6D1 * t1 * t33 * t17 - 0.2D1 * t1 * t33&
      & / t24 / t16 * t44 * t2 * t45 - t1 / t10 / t6 / t5 * t25 * avdw *&
      &t29 + t1 * t33 * t25 * t44 * t2 * t15
   vdw=t62
end subroutine

! used in ancopt Lindh
logical function rcutoff(cart,katom,latom)
   implicit none
   Real*8 Cart(3,*),xkl,ykl,zkl,rkl2
   integer katom,latom
   rcutoff=.false.
   xkl=Cart(1,kAtom)-Cart(1,lAtom)
   ykl=Cart(2,kAtom)-Cart(2,lAtom)
   zkl=Cart(3,kAtom)-Cart(3,lAtom)
   rkl2 = xkl**2 + ykl**2 + zkl**2
   if(rkl2.gt.70.0)rcutoff=.true.
end function

! used in thermodynamic Lindh
logical function rcutoff1(cart,katom,latom)
   implicit none
   Real*8 Cart(3,*),xkl,ykl,zkl,rkl2
   integer katom,latom
   rcutoff1=.false.
   xkl=Cart(1,kAtom)-Cart(1,lAtom)
   ykl=Cart(2,kAtom)-Cart(2,lAtom)
   zkl=Cart(3,kAtom)-Cart(3,lAtom)
   rkl2 = xkl**2 + ykl**2 + zkl**2
   if(rkl2.gt.150.0)rcutoff1=.true.
end function

! used in thermodynamic Lindh
logical function rcutoff2(cart,katom,latom)
   implicit none
   Real*8 Cart(3,*),xkl,ykl,zkl,rkl2
   integer katom,latom
   rcutoff2=.false.
   xkl=Cart(1,kAtom)-Cart(1,lAtom)
   ykl=Cart(2,kAtom)-Cart(2,lAtom)
   zkl=Cart(3,kAtom)-Cart(3,lAtom)
   rkl2 = xkl**2 + ykl**2 + zkl**2
   if(rkl2.gt.40.0)rcutoff2=.true.
end function

INTEGER FUNCTION iTabRow(i)
   INTEGER :: i
   !
   iTabRow=0
   If (i.gt. 0 .and. i.le. 2) Then
      iTabRow=1
   Else If (i.gt. 2 .and. i.le.10) Then
      iTabRow=2
   Else If (i.gt.10 .and. i.le.18) Then
      iTabRow=3
   Else If (i.gt.18 .and. i.le.36) Then
      iTabRow=3
   Else If (i.gt.36 .and. i.le.54) Then
      iTabRow=3
   Else If (i.gt.54 .and. i.le.86) Then
      iTabRow=3
   Else If (i.gt.86) Then
      iTabRow=3
   End If
   !
   Return
End function

Subroutine Trsn(xyz,nCent,Tau,Bt,lWrite,lWarn,Label,dBt,ldB)
   !***********************************************************************
   !                                                                      *
   ! Reference: Molecular Vibrations, E. Bright Wilson, Jr, J. C. Decicius*
   !             nd Paul C. Cross, Sec. 4-1, Eq. 20-24                    *
   !                                                                      *
   ! R.Lindh May-June '96                                                 *
   !***********************************************************************
   Implicit Real*8 (a-h,o-z)
   !     include "common/real.inc"
   !comdeck real.inc $Revision: 2002.3 $
   Real*8 Zero, One, Two, Three, Four, Five, Six, Seven,&
      &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34,&
      &       TwoP54, One2C2
   Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0,&
      &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0,&
      &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0,&
      &          Pi    =3.141592653589793D0,&
      &          SqrtP2=0.8862269254527579D0,&
      &          TwoP34=0.2519794355383808D0,&
      &          TwoP54=5.914967172795612D0,&
      &          One2C2=0.2662567690426443D-04)

   Real*8 Bt(3,nCent), xyz(3,nCent), Rij(3), Eij(3), Rjk(3), Ejk(3),&
      &       Rkl(3), Ekl(3), Rijk(3), Eijk(3), dBt(3,nCent,3,nCent),&
      &       BRij(3,2), dBRij(3,2,3,2), BRjk(3,2), dBRjk(3,2,3,2),&
      &       BRkl(3,2), dBRkl(3,2,3,2), Bf2(3,3), dum(3,4,3,4),&
      &       Bf3(3,3)
   Logical lWrite, lWarn, ldB
   Character*8 Label
   !
   !     Call qEnter('Trsn')
   mCent=2
   Call Strtch(xyz(1,1),mCent,Rij1,BRij,.False.,Label,dBRij,ldB)
   Call Strtch(xyz(1,2),mCent,Rjk1,BRjk,.False.,Label,dBRjk,ldB)
   Call Strtch(xyz(1,3),mCent,Rkl1,BRkl,.False.,Label,dBRkl,ldB)
   mCent=3
   Call Bend(xyz(1,1),mCent,Fi2,Bf2,.False.,.False.,Label,Dum,&
      &          .False.)
   SinFi2=Sin(Fi2)
   CosFi2=Cos(Fi2)
   Call Bend(xyz(1,2),mCent,Fi3,Bf3,.False.,.False.,Label,Dum,&
      &          .False.)
   SinFi3=Sin(Fi3)
   CosFi3=Cos(Fi3)
   !
   !     Get the angle between the two planes, i.e. the
   !     angle between the normal vectors.
   !
   !     r123 * r234 = CosTau
   !
   CosTau = ( ( BRij(2,1)*BRjk(3,2) - BRij(3,1)*BRjk(2,2) ) *&
      &           ( BRjk(2,1)*BRkl(3,2) - BRjk(3,1)*BRkl(2,2) ) +&
      &           ( BRij(3,1)*BRjk(1,2) - BRij(1,1)*BRjk(3,2) ) *&
      &           ( BRjk(3,1)*BRkl(1,2) - BRjk(1,1)*BRkl(3,2) ) +&
      &           ( BRij(1,1)*BRjk(2,2) - BRij(2,1)*BRjk(1,2) ) *&
      &           ( BRjk(1,1)*BRkl(2,2) - BRjk(2,1)*BRkl(1,2) ) )&
      &         / (SinFi2*SinFi3)
   !
   !     For the vector product of the two vectors. This
   !     will give a vector parallell to e23. The direction
   !     relative to e23 defines the sign.
   !
   !     e123 X e234 = SinTau * e23
   !
   SinTau = ( BRij(1,2) * (BRjk(2,1)*BRkl(3,2)-BRjk(3,1)*BRkl(2,2))&
      &         + BRij(2,2) * (BRjk(3,1)*BRkl(1,2)-BRjk(1,1)*BRkl(3,2))&
      &         + BRij(3,2) * (BRjk(1,1)*BRkl(2,2)-BRjk(2,1)*BRkl(1,2)) )&
      &         / (SinFi2*SinFi3)
   !
   !     (-Pi < Tau <= Pi)
   !
   Tau = ATan2(SinTau,CosTau)
   If (Abs(Tau).eq.Pi) Tau=Pi
   !
   dTau = 180.0D+00*Tau/Pi
   dFi2 = 180.0D+00*Fi2/Pi
   dFi3 = 180.0D+00*Fi3/Pi
   If (lWarn) Then
      If (dTau.gt.177.5 .or. dTau.lt.-177.5) Then
         Write (*,*) ' Warning: dihedral angle close to'&
            &         //' end of range'
      End If
      If (dFi2.gt.177.5 .or. dFi2.lt.2.5) Then
         Write (*,*) ' Warning: bond angle close to'&
            &         //' end of range'
      End If
      If (dFi3.gt.177.5 .or. dFi3.lt.2.5) Then
         Write (*,*) ' Warning: bond angle close to'&
            &         //' end of range'
      End If
   End If
   If (LWRITE) Write (*,1) Label,dTau,Tau
   1     FORMAT(1X,A,' : Dihedral Angle=',F10.4,&
      & '/degree,',F10.4,'/rad')
   !
   !---- Compute the WDC matrix.
   !
   Do ix = 1, 3
      iy=ix+1
      If (iy.gt.3) iy=iy-3
      iz=iy+1
      If (iz.gt.3) iz=iz-3
      Bt(ix,1) = (BRij(iy,2)*BRjk(iz,2)-BRij(iz,2)*BRjk(iy,2))&
         &           / (Rij1*SinFi2**2)
      Bt(ix,4) = (BRkl(iy,1)*BRjk(iz,1)-BRkl(iz,1)*BRjk(iy,1))&
         &           / (Rkl1*SinFi3**2)
      Bt(ix,2) = -( (Rjk1-Rij1*CosFi2) * Bt(ix,1)&
         &             +         Rkl1*CosFi3  * Bt(ix,4))/Rjk1
      Bt(ix,3) = - ( Bt(ix,1)+Bt(ix,2)+Bt(ix,4))
   End Do
   !
   If (ldB) Then
      !
      !------- Compute the derivative of the WDC matrix.
      !
      Do ix = 1, 3
         iy=ix+1
         If (iy.gt.3) iy=iy-3
         iz=iy+1
         If (iz.gt.3) iz=iz-3
         Do jx = 1, ix
            jy=jx+1
            If (jy.gt.3) jy=jy-3
            jz=jy+1
            If (jz.gt.3) jz=jz-3
            !
            dBt(ix,1,jx,1) =(  dBRij(ix,1,jy,2)*BRjk(jz,2)&
               &                       - dBRij(ix,1,jz,2)*BRjk(jy,2)&
               &                       - Bt(jx,1)*(BRij(ix,1)*SinFi2**2&
               &                       + Rij1*Two*SinFi2*CosFi2*Bf2(ix,1)) )&
               &                       / (Rij1*SinFi2**2)
            dBt(ix,1,jx,2) =-( (-BRij(ix,1)*CosFi2&
               &                         + Rij1*SinFi2*Bf2(ix,1) ) * Bt(jx,1)&
               &                         + (Rjk1-Rij1*CosFi2) * dBt(ix,1,jx,1) )&
               &                       / Rjk1
            dBt(jx,2,ix,1) = dBt(ix,1,jx,2)
            dBt(ix,1,jx,4) = Zero
            dBt(jx,4,ix,1) = dBt(ix,1,jx,4)
            dBt(ix,1,jx,3) = - (dBt(ix,1,jx,1) + dBt(ix,1,jx,2) )
            dBt(jx,3,ix,1) = dBt(ix,1,jx,3)
            dBt(ix,4,jx,4) =(  dBRkl(ix,2,jy,1)*BRjk(jz,1)&
               &                       - dBRkl(ix,2,jz,1)*BRjk(jy,1)&
               &                       - Bt(jx,4)*(BRkl(ix,2)*SinFi3**2&
               &                       + Rkl1*Two*SinFi3*CosFi3*Bf3(ix,3)) )&
               &                       / (Rkl1*SinFi3**2)
            dBt(ix,4,jx,3) =-( (-BRkl(ix,2)*CosFi3&
               &                         + Rkl1*SinFi3*Bf3(ix,3) ) * Bt(jx,4)&
               &                         + (Rjk1-Rkl1*CosFi3) * dBt(ix,4,jx,4) )&
               &                       / Rjk1
            dBt(jx,3,ix,4) = dBt(ix,4,jx,3)
            dBt(ix,4,jx,2) = - ( dBt(ix,4,jx,4) + dBt(ix,4,jx,3) )
            dBt(jx,2,ix,4) = dBt(ix,4,jx,2)
            If (ix.ne.jx) Then
               dBt(jx,1,ix,1) = dBt(ix,1,jx,1)
               dBt(ix,4,jx,1) = Zero
               dBt(jx,4,ix,4) = dBt(ix,4,jx,4)
               dBt(jx,1,ix,4) = dBt(ix,4,jx,1)
               dBt(jx,1,ix,2) =-( (-BRij(jx,1)*CosFi2&
                  &                            + Rij1*SinFi2*Bf2(jx,1) ) * Bt(ix,1)&
                  &                            + (Rjk1-Rij1*CosFi2) * dBt(jx,1,ix,1))&
                  &                          / Rjk1
               dBt(ix,2,jx,1) = dBt(jx,1,ix,2)
               dBt(ix,3,jx,1) = - ( dBt(ix,1,jx,1) + dBt(ix,2,jx,1)&
                  &                          + dBt(ix,4,jx,1) )
               dBt(jx,1,ix,3) = dBt(ix,3,jx,1)
               dBt(jx,4,ix,3) =-( (-BRkl(jx,2)*CosFi3&
                  &                            + Rkl1*SinFi3*Bf3(jx,3) ) * Bt(ix,4)&
                  &                            + (Rjk1-Rkl1*CosFi3) * dBt(jx,4,ix,4))&
                  &                          / Rjk1
               dBt(ix,3,jx,4) = dBt(jx,4,ix,3)
               dBt(ix,2,jx,4) = - ( dBt(ix,4,jx,4) + dBt(ix,3,jx,4) )
               dBt(jx,4,ix,2) = dBt(ix,2,jx,4)
            End If
            dBt(ix,2,jx,3) = - ( ( BRjk(ix,1)&
               &                           + Rkl1*SinFi3*Bf3(ix,1) ) * Bt(jx,4)&
               &                         + ( Rjk1 - Rkl1*CosFi3 ) * dBt(ix,2,jx,4)&
               &                         + ( BRij(ix,2)*CosFi2&
               &                           - Rij1*SinFi2*Bf2(ix,2) ) * Bt(jx,1)&
               &                         +  Rij1*CosFi2 * dBt(ix,2,jx,1)&
               &                         + Bt(jx,3) * BRjk(ix,1) ) / Rjk1
            dBt(jx,3,ix,2) = dBt(ix,2,jx,3)
            dBt(ix,2,jx,2) = - ( dBt(ix,2,jx,1) + dBt(ix,2,jx,4)&
               &                         + dBt(ix,2,jx,3) )
            dBt(ix,3,jx,3) = - ( dBt(ix,2,jx,3) + dBt(ix,1,jx,3)&
               &                         + dBt(ix,4,jx,3) )
            If (ix.ne.jx) Then
               dBt(ix,3,jx,2) = - ( dBt(ix,2,jx,2) + dBt(ix,1,jx,2)&
                  &                            + dBt(ix,4,jx,2) )
               dBt(jx,2,ix,3) = dBt(ix,3,jx,2)
               dBt(jx,2,ix,2) = dBt(ix,2,jx,2)
               dBt(jx,3,ix,3) = dBt(ix,3,jx,3)
            End If
            !
         End Do
      End Do
      !
   End If
   !     Call qExit('Trsn')
   Return
End      subroutine

Subroutine Strtch(xyz,nCent,Avst,B,lWrite,Label,dB,ldB)
   Implicit Real*8 (a-h,o-z)
   !      include "common/real.inc"
   !comdeck real.inc $Revision: 2002.3 $
   Real*8 Zero, One, Two, Three, Four, Five, Six, Seven,&
      &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34,&
      &       TwoP54, One2C2
   Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0,&
      &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0,&
      &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0,&
      &          Pi    =3.141592653589793D0,&
      &          SqrtP2=0.8862269254527579D0,&
      &          TwoP34=0.2519794355383808D0,&
      &          TwoP54=5.914967172795612D0,&
      &          One2C2=0.2662567690426443D-04)

   Real*8 B(3,nCent), xyz(3,nCent), dB(3,nCent,3,nCent), R(3)
   Logical lWrite, ldB
   Character*8 Label
   !      include "common/angstr.inc"
   !comdeck angstr.inc $Revision: 2002.3 $
   !
   !     Conversion factor angstrom to bohr from the IUPAC
   !     publication
   !     .529177249(24) angstrom / bohr
   !     "Quantities, Units and Symbols in Physical Chemistry"
   !     I. Mills, T. Cvitas, K. Homann, N. Kallay and
   !     K. Kuchitsu, Blackwell Scientific Publications,
   !     Oxford, 1988.
   !
   Data Angstr/0.529177249D+00/
   !
   R(1)=xyz(1,2)-xyz(1,1)
   R(2)=xyz(2,2)-xyz(2,1)
   R(3)=xyz(3,2)-xyz(3,1)
   R2=R(1)**2+R(2)**2+R(3)**2
   RR=Sqrt(R2)
   Avst=RR
   !
   aRR=RR*Angstr
   If (lWrite) Write (*,'(1X,A,A,2(F10.6,A))') Label,&
      &      ' : Bond Length=',aRR,' / Angstrom',RR,' / bohr'
   !
   !---- Compute the WDC B-matrix.
   !
   B(1,1)=-R(1)/RR
   B(2,1)=-R(2)/RR
   B(3,1)=-R(3)/RR
   !.... Utilize translational invariance.
   B(1,2)=-B(1,1)
   B(2,2)=-B(2,1)
   B(3,2)=-B(3,1)
   !
   !---- Compute the cartesian derivative of the B-matrix.
   !
   If (ldB) Then
      !
      Do i=1,3
         Do j=1,i
            If (i.eq.j) Then
               dB(i,1,j,1)= (One-B(j,1)*B(i,1))/RR
            Else
               dB(i,1,j,1)= (-B(j,1)*B(i,1))/RR
            End If
            dB(j,1,i,1)= dB(i,1,j,1)
            !
            dB(i,2,j,1)=-dB(i,1,j,1)
            dB(j,1,i,2)= dB(i,2,j,1)
            !
            dB(i,1,j,2)=-dB(i,1,j,1)
            dB(j,2,i,1)= dB(i,1,j,2)
            !
            dB(i,2,j,2)=-dB(i,2,j,1)
            dB(j,2,i,2)=dB(i,2,j,2)
         End Do
      End Do
      !
   End If
   !     Call qExit('Strtch')
   !     Call GetMem('Exit Strtch','Chec','Real',ipMass,2*msAtom)
   Return
End subroutine

!fordeck bend $Revision: 5.3 $
Subroutine Bend(xyz,nCent,Fir,Bf,lWrite,lWarn,Label,dBf,ldB)
   Implicit Real*8  (a-h,o-z)
   !      include "common/real.inc"
   !comdeck real.inc $Revision: 2002.3 $
   Real*8 Zero, One, Two, Three, Four, Five, Six, Seven,&
      &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34,&
      &       TwoP54, One2C2
   Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0,&
      &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0,&
      &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0,&
      &          Pi    =3.141592653589793D0,&
      &          SqrtP2=0.8862269254527579D0,&
      &          TwoP34=0.2519794355383808D0,&
      &          TwoP54=5.914967172795612D0,&
      &          One2C2=0.2662567690426443D-04)

   Real*8   Bf(3,nCent), xyz(3,nCent), dBf(3,nCent,3,nCent),&
      &        BRij(3,2), dBRij(3,2,3,2),&
      &        BRjk(3,2), dBRjk(3,2,3,2)
   Logical lWrite, ldB, lWarn
   Character*8 Label
   !
   !     Call QEnter('Bend')
   !
   mCent=2
   Call Strtch(xyz(1,1),mCent,Rij1,BRij,.False.,Label,dBRij,ldB)
   Call Strtch(xyz(1,2),mCent,Rjk1,BRjk,.False.,Label,dBRjk,ldB)
   Co=Zero
   Crap=Zero
   Do i = 1, 3
      Co=Co+BRij(i,1)*BRjk(i,2)
      Crap=Crap+(BRjk(i,2)+BRij(i,1))**2
   End Do
   !
   !.... Special care for cases close to linearity
   !
   If (Sqrt(Crap).lt.1.0D-6) Then
      Fir=Pi-ArSin(Sqrt(Crap))
      Si=Sqrt(Crap)
   Else
      Fir=ArCos(Co)
      Si=Sqrt(One-Co**2)
   End If
   !
   If (Abs(Fir-Pi).lt.1.0d-13) Then
      Fir=Pi
      Return
   End If
   dFir=180.0D0*Fir/Pi
   If ((Abs(dFir).gt.177.5 .or. Abs(dFir).lt.2.5).and.lWarn)&
      &   Write (*,*) ' Valence angle close to end in '//&
      &               'range of definition'
   If (lWrite) Write (*,'(1X,A,A,F10.4,A,F10.6,A)') Label,&
      &            ' : Angle=', dFir,'/degree, ',Fir,'/rad'
   !
   !---- Compute the WDC B-matrix
   !
   !     Bf=-11.1111
   Do i = 1, 3
      Bf(i,1)= (Co*BRij(i,1)-BRjk(i,2))/(Si*Rij1)
      Bf(i,3)= (Co*BRjk(i,2)-BRij(i,1))/(Si*Rjk1)
      !....... Utilize translational invariance.
      Bf(i,2)=-(Bf(i,1)+Bf(i,3))
   End Do
   !     Call RecPrt('Bf',' ',Bf,9,1)
   !
   !---- Compute the cartesian derivative of the B-Matrix.
   !
   If (ldB) Then
      !
      !        dBf=-11.11111
      Do i = 1, 3
         Do j = 1, i
            dBf(i,1,j,1)=( -Si*Bf(i,1)*BRij(j,1)&
               &                        +Co*dBRij(i,1,j,1)&
               &                        -Bf(j,1)*(Co*Bf(i,1)*Rij1&
               &                        +Si*BRij(i,1)) ) / (Si*Rij1)
            dBf(i,1,j,3)=(-Si*Bf(i,1)*BRjk(j,2)&
               &                       +dBRij(i,1,j,2)&
               &                       -Bf(j,3)*Co*Bf(i,1)*Rjk1)&
               &                       / (Si*Rjk1)
            !              Write (*,*) '13',dBf(i,1,j,3), i, j
            dBf(i,3,j,1)=(-Si*Bf(i,3)*BRij(j,1)&
               &                       +dBRjk(i,2,j,1)&
               &                       -Bf(j,1)*Co*Bf(i,3)*Rij1)&
               &                       / (Si*Rij1)
            dBf(i,3,j,3)=( -Si*Bf(i,3)*BRjk(j,2)&
               &                        +Co*dBRjk(i,2,j,2)&
               &                        -Bf(j,3)*(Co*Bf(i,3)*Rjk1&
               &                        +Si*BRjk(i,2)) ) / (Si*Rjk1)
            !
            dBf(j,1,i,1)=dBf(i,1,j,1)
            dBf(j,3,i,1)=dBf(i,1,j,3)
            dBf(j,1,i,3)=dBf(i,3,j,1)
            dBf(j,3,i,3)=dBf(i,3,j,3)
            !
            dBf(i,1,j,2)=-(dBf(i,1,j,1)+dBf(i,1,j,3))
            dBf(j,2,i,1)=dBf(i,1,j,2)
            dBf(j,1,i,2)=-(dBf(j,1,i,1)+dBf(j,1,i,3))
            dBf(i,2,j,1)=dBf(j,1,i,2)
            dBf(i,3,j,2)=-(dBf(i,3,j,1)+dBf(i,3,j,3))
            dBf(j,2,i,3)=dBf(i,3,j,2)
            dBf(j,3,i,2)=-(dBf(j,3,i,1)+dBf(j,3,i,3))
            dBf(i,2,j,3)=dBf(j,3,i,2)
            !
            dBf(i,2,j,2)=-(dBf(i,2,j,1)+dBf(i,2,j,3))
            dBf(j,2,i,2)=dBf(i,2,j,2)
            !
         End Do
      End Do
      !        Call RecPrt('dBf','(9F9.1)',dBf,9,9)
      !
   End If
   !
   !     Call QExit('Bend')
   Return
End subroutine

!fordeck arsin.f $Revision: 5.3 $
Function arSin(Arg)
   Implicit Real*8 (a-h,o-z)
   Real*8 ArSin
   !      include "common/real.inc"
   !comdeck real.inc $Revision: 2002.3 $
   Real*8 Zero, One, Two, Three, Four, Five, Six, Seven,&
      &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34,&
      &       TwoP54, One2C2
   Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0,&
      &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0,&
      &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0,&
      &          Pi    =3.141592653589793D0,&
      &          SqrtP2=0.8862269254527579D0,&
      &          TwoP34=0.2519794355383808D0,&
      &          TwoP54=5.914967172795612D0,&
      &          One2C2=0.2662567690426443D-04)

   A=Arg
   IF(ABS(A).GT.One) Then
      PRINT 3,A
      3        FORMAT(1X,'Warning argument of aSin= ',1F21.18)
      A=Sign(One,A)
   End If
   !
   ArSin=ASin(A)
   Return
End function

!fordeck arcos.f $Revision: 5.3 $
Function arCos(Arg)
   Implicit Real*8 (a-h,o-z)
   Real*8 ArCos
   !      include "common/real.inc"
   !comdeck real.inc $Revision: 2002.3 $
   Real*8 Zero, One, Two, Three, Four, Five, Six, Seven,&
      &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34,&
      &       TwoP54, One2C2
   Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0,&
      &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0,&
      &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0,&
      &          Pi    =3.141592653589793D0,&
      &          SqrtP2=0.8862269254527579D0,&
      &          TwoP34=0.2519794355383808D0,&
      &          TwoP54=5.914967172795612D0,&
      &          One2C2=0.2662567690426443D-04)

   A=Arg
   IF (ABS(A).GT.One) Then
      !         PRINT 3,A
      !3        FORMAT(1X,'Warning argument of aCos= ',1F21.18)
      A=Sign(One,A)
   End If
   !
   ArCos=ACos(A)
   Return
End function

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Interfaces to BLAS
module xtb_mctc_blas_level3
   use xtb_mctc_accuracy, only : sp, dp
#ifdef USE_CUBLAS
   use cublas, only : cublasSgemm, cublasDgemm, cublasSsymm, cublasDsymm, &
      & cublasSsyrk, cublasDsyrk, cublasSsyr2k, cublasDsyr2k, &
      & cublasStrmm, cublasDtrmm, cublasStrsm, cublasDtrsm
#endif
   implicit none
   private

   public :: mctc_gemm, mctc_symm, mctc_syrk, mctc_syr2k, mctc_trmm, mctc_trsm

   public :: blas_gemm, blas_hemm, blas_herk, blas_her2k
   public :: blas_symm, blas_syrk, blas_syr2k, blas_trmm, blas_trsm


   !> Performs one of the matrix-matrix operations
   !
   !    C := alpha*op( A )*op( B ) + beta*C,
   !
   ! where  op( X ) is one of
   !
   !    op( X ) = X   or   op( X ) = X**T,
   !
   ! alpha and beta are scalars, and A, B and C are matrices, with op( A )
   ! an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
   interface mctc_gemm
      module procedure :: mctc_sgemm
      module procedure :: mctc_dgemm
   end interface mctc_gemm

   !> Performs one of the matrix-matrix operations
   !
   !    C := alpha*A*B + beta*C,
   !
   ! or
   !
   !    C := alpha*B*A + beta*C,
   !
   ! where alpha and beta are scalars,  A is a symmetric matrix and  B and
   ! C are  m by n matrices.
   interface mctc_symm
      module procedure :: mctc_ssymm
      module procedure :: mctc_dsymm
   end interface mctc_symm

   !> Performs one of the symmetric rank k operations
   !
   !    C := alpha*A*A**T + beta*C,
   !
   ! or
   !
   !    C := alpha*A**T*A + beta*C,
   !
   ! where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
   ! and  A  is an  n by k  matrix in the first case and a  k by n  matrix
   ! in the second case.
   interface mctc_syrk
      module procedure :: mctc_ssyrk
      module procedure :: mctc_dsyrk
   end interface mctc_syrk

   !> Performs one of the symmetric rank 2k operations
   !
   !    C := alpha*A*B**T + alpha*B*A**T + beta*C,
   !
   ! or
   !
   !    C := alpha*A**T*B + alpha*B**T*A + beta*C,
   !
   ! where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
   ! and  A and B  are  n by k  matrices  in the  first  case  and  k by n
   ! matrices in the second case.
   interface mctc_syr2k
      module procedure :: mctc_ssyr2k
      module procedure :: mctc_dsyr2k
   end interface mctc_syr2k

   !> Performs one of the matrix-matrix operations
   !
   !    B := alpha*op( A )*B,   or   B := alpha*B*op( A ),
   !
   ! where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
   ! non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
   !
   !    op( A ) = A   or   op( A ) = A**T.
   interface mctc_trmm
      module procedure :: mctc_strmm
      module procedure :: mctc_dtrmm
   end interface mctc_trmm

   !> Solves one of the matrix equations
   !
   !    op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
   !
   ! where alpha is a scalar, X and B are m by n matrices, A is a unit, or
   ! non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
   !
   !    op( A ) = A   or   op( A ) = A**T.
   !
   ! The matrix X is overwritten on B.
   interface mctc_trsm
      module procedure :: mctc_strsm
      module procedure :: mctc_dtrsm
   end interface mctc_trsm


   !> Performs one of the matrix-matrix operations
   !
   !    C := alpha*op( A )*op( B ) + beta*C,
   !
   ! where  op( X ) is one of
   !
   !    op( X ) = X   or   op( X ) = X**T,
   !
   ! alpha and beta are scalars, and A, B and C are matrices, with op( A )
   ! an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.
   interface blas_gemm
      pure subroutine sgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine sgemm
      pure subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine dgemm
      pure subroutine cgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine cgemm
      pure subroutine zgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine zgemm
      pure subroutine scgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine scgemm
      pure subroutine dzgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, &
            & beta, c, ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: transb
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine dzgemm
   end interface blas_gemm

   !> Performs one of the matrix-matrix operations
   !
   !    C := alpha*A*B + beta*C,
   !
   ! or
   !
   !    C := alpha*B*A + beta*C,
   !
   ! where alpha and beta are scalars, A is an hermitian matrix and  B and
   ! C are m by n matrices.
   interface blas_hemm
      pure subroutine chemm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine chemm
      pure subroutine zhemm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine zhemm
   end interface blas_hemm

   !> Performs one of the hermitian rank k operations
   !
   !    C := alpha*A*A**H + beta*C,
   !
   ! or
   !
   !    C := alpha*A**H*A + beta*C,
   !
   ! where  alpha and beta  are  real scalars,  C is an  n by n  hermitian
   ! matrix and  A  is an  n by k  matrix in the  first case and a  k by n
   ! matrix in the second case.
   interface blas_herk
      pure subroutine cherk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldc
      end subroutine cherk
      pure subroutine zherk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldc
      end subroutine zherk
   end interface blas_herk

   !> Performs one of the hermitian rank 2k operations
   !
   !    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,
   !
   ! or
   !
   !    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,
   !
   ! where  alpha and beta  are scalars with  beta  real,  C is an  n by n
   ! hermitian matrix and  A and B  are  n by k matrices in the first case
   ! and  k by n  matrices in the second case.
   interface blas_her2k
      pure subroutine cher2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
            & ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         complex(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine cher2k
      pure subroutine zher2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
            & ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         complex(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine zher2k
   end interface blas_her2k

   !> Performs one of the matrix-matrix operations
   !
   !    C := alpha*A*B + beta*C,
   !
   ! or
   !
   !    C := alpha*B*A + beta*C,
   !
   ! where alpha and beta are scalars,  A is a symmetric matrix and  B and
   ! C are  m by n matrices.
   interface blas_symm
      pure subroutine ssymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine ssymm
      pure subroutine dsymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine dsymm
      pure subroutine csymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine csymm
      pure subroutine zsymm(side, uplo, m, n, alpha, a, lda, b, ldb, beta, c, ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine zsymm
   end interface blas_symm

   !> Performs one of the symmetric rank k operations
   !
   !    C := alpha*A*A**T + beta*C,
   !
   ! or
   !
   !    C := alpha*A**T*A + beta*C,
   !
   ! where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
   ! and  A  is an  n by k  matrix in the first case and a  k by n  matrix
   ! in the second case.
   interface blas_syrk
      pure subroutine ssyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldc
      end subroutine ssyrk
      pure subroutine dsyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldc
      end subroutine dsyrk
      pure subroutine csyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldc
      end subroutine csyrk
      pure subroutine zsyrk(uplo, trans, n, k, alpha, a, lda, beta, c, ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldc
      end subroutine zsyrk
   end interface blas_syrk

   !> Performs one of the symmetric rank 2k operations
   !
   !    C := alpha*A*B**T + alpha*B*A**T + beta*C,
   !
   ! or
   !
   !    C := alpha*A**T*B + alpha*B**T*A + beta*C,
   !
   ! where  alpha and beta  are scalars, C is an  n by n  symmetric matrix
   ! and  A and B  are  n by k  matrices  in the  first  case  and  k by n
   ! matrices in the second case.
   interface blas_syr2k
      pure subroutine ssyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
            & ldc)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: b(ldb, *)
         real(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine ssyr2k
      pure subroutine dsyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
            & ldc)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: b(ldb, *)
         real(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine dsyr2k
      pure subroutine csyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
            & ldc)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: b(ldb, *)
         complex(sp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine csyr2k
      pure subroutine zsyr2k(uplo, trans, n, k, alpha, a, lda, b, ldb, beta, c, &
            & ldc)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: b(ldb, *)
         complex(dp), intent(inout) :: c(ldc, *)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldc
      end subroutine zsyr2k
   end interface blas_syr2k

   !> Performs one of the matrix-matrix operations
   !
   !    B := alpha*op( A )*B,   or   B := alpha*B*op( A ),
   !
   ! where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
   ! non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
   !
   !    op( A ) = A   or   op( A ) = A**T.
   interface blas_trmm
      pure subroutine strmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         real(sp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine strmm
      pure subroutine dtrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         real(dp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dtrmm
      pure subroutine ctrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         complex(sp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ctrmm
      pure subroutine ztrmm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         complex(dp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ztrmm
   end interface blas_trmm

   !> Solves one of the matrix equations
   !
   !    op( A )*X = alpha*B,   or   X*op( A ) = alpha*B,
   !
   ! where alpha is a scalar, X and B are m by n matrices, A is a unit, or
   ! non-unit,  upper or lower triangular matrix  and  op( A )  is one  of
   !
   !    op( A ) = A   or   op( A ) = A**T.
   !
   ! The matrix X is overwritten on B.
   interface blas_trsm
      pure subroutine strsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         real(sp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine strsm
      pure subroutine dtrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         real(dp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dtrsm
      pure subroutine ctrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         complex(sp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ctrsm
      pure subroutine ztrsm(side, uplo, transa, diag, m, n, alpha, a, lda, b, ldb)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: side
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: transa
         character(len=1), intent(in) :: diag
         complex(dp), intent(in) :: alpha
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ztrsm
   end interface blas_trsm


contains


pure subroutine mctc_sgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(sp) :: a, b
   integer :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat, cmat)
   !$acc host_data use_device(amat, bmat, cmat)
   call cublasSgemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat, bmat)
#else
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
#endif
end subroutine mctc_sgemm


pure subroutine mctc_dgemm(amat, bmat, cmat, transa, transb, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: transb
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: tra, trb
   real(dp) :: a, b
   integer :: m, n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(transb)) then
      trb = transb
   else
      trb = 'n'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat, cmat)
   !$acc host_data use_device(amat, bmat, cmat)
   call cublasDgemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat, bmat)
#else
   call blas_gemm(tra, trb, m, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
#endif
end subroutine mctc_dgemm


pure subroutine mctc_ssymm(amat, bmat, cmat, side, uplo, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: lra, ula
   real(sp) :: a, b
   integer :: m, n, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(side)) then
      lra = side
   else
      lra = 'l'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat, cmat)
   !$acc host_data use_device(amat, bmat, cmat)
   call cublasSsymm(lra, ula, m, n, a, amat, lda, bmat, ldb, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat, bmat)
#else
   call blas_symm(lra, ula, m, n, a, amat, lda, bmat, ldb, b, cmat, ldc)
#endif
end subroutine mctc_ssymm


pure subroutine mctc_dsymm(amat, bmat, cmat, side, uplo, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: lra, ula
   real(dp) :: a, b
   integer :: m, n, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(side)) then
      lra = side
   else
      lra = 'l'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   m = size(cmat, 1)
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat, cmat)
   !$acc host_data use_device(amat, bmat, cmat)
   call cublasDsymm(lra, ula, m, n, a, amat, lda, bmat, ldb, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat, bmat)
#else
   call blas_symm(lra, ula, m, n, a, amat, lda, bmat, ldb, b, cmat, ldc)
#endif
end subroutine mctc_dsymm


pure subroutine mctc_ssyrk(amat, cmat, uplo, trans, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: trans
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: ula, tra
   real(sp) :: a, b
   integer :: n, k, lda, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldc = max(1, size(cmat, 1))
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, cmat)
   !$acc host_data use_device(amat, cmat)
   call cublasSsyrk(ula, tra, n, k, a, amat, lda, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat)
#else
   call blas_syrk(ula, tra, n, k, a, amat, lda, b, cmat, ldc)
#endif
end subroutine mctc_ssyrk


pure subroutine mctc_dsyrk(amat, cmat, uplo, trans, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: trans
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: ula, tra
   real(dp) :: a, b
   integer :: n, k, lda, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldc = max(1, size(cmat, 1))
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, cmat)
   !$acc host_data use_device(amat, cmat)
   call cublasDsyrk(ula, tra, n, k, a, amat, lda, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat)
#else
   call blas_syrk(ula, tra, n, k, a, amat, lda, b, cmat, ldc)
#endif
end subroutine mctc_dsyrk


pure subroutine mctc_ssyr2k(amat, bmat, cmat, uplo, trans, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: bmat(:, :)
   real(sp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: trans
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: ula, tra
   real(sp) :: a, b
   integer :: n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_sp
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat, cmat)
   !$acc host_data use_device(amat, bmat, cmat)
   call cublasSsyr2k(ula, tra, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat, bmat)
#else
   call blas_syr2k(ula, tra, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
#endif
end subroutine mctc_ssyr2k


pure subroutine mctc_dsyr2k(amat, bmat, cmat, uplo, trans, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: bmat(:, :)
   real(dp), intent(inout) :: cmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: trans
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: ula, tra
   real(dp) :: a, b
   integer :: n, k, lda, ldb, ldc
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0.0_dp
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   if ((tra.eq.'n'.or.tra.eq.'N')) then
      k = size(amat, 2)
   else
      k = size(amat, 1)
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   ldc = max(1, size(cmat, 1))
   n = size(cmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat, cmat)
   !$acc host_data use_device(amat, bmat, cmat)
   call cublasDsyr2k(ula, tra, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
   !$acc end host_data
   !$acc exit data copyout(cmat) delete(amat, bmat)
#else
   call blas_syr2k(ula, tra, n, k, a, amat, lda, bmat, ldb, b, cmat, ldc)
#endif
end subroutine mctc_dsyr2k


pure subroutine mctc_strsm(amat, bmat, side, uplo, transa, diag, alpha)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: diag
   real(sp), intent(in), optional :: alpha
   character(len=1) :: lra, ula, tra, dia
   real(sp) :: a
   integer :: m, n, lda, ldb
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(diag)) then
      dia = diag
   else
      dia = 'n'
   end if
   if (present(side)) then
      lra = side
   else
      lra = 'l'
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   m = size(bmat, 1)
   n = size(bmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat)
   !$acc host_data use_device(amat, bmat)
   call cublasStrsm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
   !$acc end host_data
   !$acc exit data copyout(bmat) delete(amat)
#else
   call blas_trsm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
#endif
end subroutine mctc_strsm


pure subroutine mctc_dtrsm(amat, bmat, side, uplo, transa, diag, alpha)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: diag
   real(dp), intent(in), optional :: alpha
   character(len=1) :: lra, ula, tra, dia
   real(dp) :: a
   integer :: m, n, lda, ldb
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(diag)) then
      dia = diag
   else
      dia = 'n'
   end if
   if (present(side)) then
      lra = side
   else
      lra = 'l'
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   m = size(bmat, 1)
   n = size(bmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat)
   !$acc host_data use_device(amat, bmat)
   call cublasDtrsm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
   !$acc end host_data
   !$acc exit data copyout(bmat) delete(amat)
#else
   call blas_trsm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
#endif
end subroutine mctc_dtrsm


pure subroutine mctc_strmm(amat, bmat, side, uplo, transa, diag, alpha)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: diag
   real(sp), intent(in), optional :: alpha
   character(len=1) :: lra, ula, tra, dia
   real(sp) :: a
   integer :: m, n, lda, ldb
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(diag)) then
      dia = diag
   else
      dia = 'n'
   end if
   if (present(side)) then
      lra = side
   else
      lra = 'l'
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   m = size(bmat, 1)
   n = size(bmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat)
   !$acc host_data use_device(amat, bmat)
   call cublasStrmm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
   !$acc end host_data
   !$acc exit data copyout(bmat) delete(amat)
#else
   call blas_trmm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
#endif
end subroutine mctc_strmm


pure subroutine mctc_dtrmm(amat, bmat, side, uplo, transa, diag, alpha)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: side
   character(len=1), intent(in), optional :: uplo
   character(len=1), intent(in), optional :: transa
   character(len=1), intent(in), optional :: diag
   real(dp), intent(in), optional :: alpha
   character(len=1) :: lra, ula, tra, dia
   real(dp) :: a
   integer :: m, n, lda, ldb
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(diag)) then
      dia = diag
   else
      dia = 'n'
   end if
   if (present(side)) then
      lra = side
   else
      lra = 'l'
   end if
   if (present(transa)) then
      tra = transa
   else
      tra = 'n'
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   m = size(bmat, 1)
   n = size(bmat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(amat, bmat)
   !$acc host_data use_device(amat, bmat)
   call cublasDtrmm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
   !$acc end host_data
   !$acc exit data copyout(bmat) delete(amat)
#else
   call blas_trmm(lra, ula, tra, dia, m, n, a, amat, lda, bmat, ldb)
#endif
end subroutine mctc_dtrmm


end module xtb_mctc_blas_level3

! This file is part of xtb.
!
! Copyright (C) 2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> COSMO implementation based on ddCOSMO backend
module xtb_solv_cosmo
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : mctc_dot, mctc_gemv
   use xtb_mctc_constants, only : fourpi, pi
   use xtb_mctc_convert, only : aatoau, autoaa
   use xtb_mctc_search, only : bisectSearch
   use xtb_param_vdwradd3, only : getVanDerWaalsRadD3
   use xtb_solv_ddcosmo_core
   use xtb_solv_ddcosmo_solver
   use xtb_solv_lebedev, only : gridSize, getAngGrid
   use xtb_solv_sasa, only : compute_numsa
   use xtb_type_environment, only : TEnvironment
   use xtb_type_solvation, only : TSolvation
   implicit none
   private

   public :: TCosmo, init


   !> The COSMO solvation model
   type, extends(TSolvation) :: TCosmo

      !> Number of atoms
      integer :: nat

      !> Actual COSMO calculator
      type(TDomainDecomposition) :: ddCosmo

      !> electrostatic potential phi(ncav)
      real(wp), allocatable :: phi(:)

      !> psi vector psi(nylm, n)
      real(wp), allocatable :: psi(:, :)

      !> ddcosmo solution sigma(nylm, n)
      real(wp), allocatable :: sigma(:, :)

      !> ddcosmo adjoint solution s(nylm, n)
      real(wp), allocatable :: s(:, :)

      !> dielectric constant
      real(wp) :: dielectricConst

      !> Van-der-Waal radii
      real(wp), allocatable :: rvdw(:)

      !> Number of grid point
      integer :: nAng

      !> Interaction matrix with surface charges jmat(ncav, n)
      real(wp), allocatable :: jmat(:, :)

      !> angular grid
      real(wp), allocatable :: angGrid(:, :)
      real(wp), allocatable :: angWeight(:)

      !> cut-off radius for the SASA NN list
      real(wp) :: srcut

      !> number of neighbors for SASA computation
      integer, allocatable :: nnsas(:)

      !> neighbors of an atom for SASA
      integer, allocatable :: nnlists(:, :)

      !> Atom specific surface data
      real(wp), allocatable :: vdwsa(:)
      real(wp), allocatable :: wrp(:)
      real(wp), allocatable :: trj2(:, :)

      !> Atomic surfaces
      real(wp) :: gsasa
      real(wp), allocatable :: gamsasa(:)
      real(wp), allocatable :: sasa(:)

      !> Molecular Surface gradient
      real(wp), allocatable :: dsdr(:, :)
      real(wp), allocatable :: dsdrt(:, :, :)

   contains

      !> Update coordinates and internal state
      procedure :: update

      !> Add potential shift
      procedure :: addShift

      !> Calculate solvation energy
      procedure :: getEnergy

      !> Calculate derivatives of solvation energy
      procedure :: addGradient

      !> Write cavity information as cosmo file
      procedure :: writeCosmoFile

   end type TCosmo


   !> Initialize data straucture
   interface init
      module procedure :: initCosmo
   end interface init

   integer, parameter :: ndiis = 25

   !> Smoothing dielectric function parameters
   real(wp), parameter :: w = 0.3_wp*aatoau
   real(wp), parameter :: w3 = w*(w*w)
   real(wp), parameter :: ah0 = 0.5_wp
   real(wp), parameter :: ah1 = 3._wp/(4.0_wp*w)
   real(wp), parameter :: ah3 = -1._wp/(4.0_wp*w3)

   !> Surface tension (in au)
   real(wp), parameter :: gammas = 1.0e-5_wp

   !> Salt screening
   real(wp), parameter :: kappaConst = 0.7897e-3_wp

contains


!> Initialize data straucture
subroutine initCosmo(self, env, num, dielectricConst, nAng, radScale, vdwRad, &
      & surfaceTension, probeRad, rOffset)

   !> Error source
   character(len=*), parameter :: source = 'solv_cosmo_initCosmo'

   !> Instance of the solvation model
   type(TCosmo), intent(out) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Dielectric constant
   real(wp), intent(in) :: dielectricConst

   !> Number of grid point
   integer, intent(in) :: nAng

   !> Scale van-der-Waals radii
   real(wp), intent(in) :: radScale 

   !> Van-der-Waals Radii
   real(wp), intent(in) :: vdwRad(:)

   !> Surface tension scaling
   real(wp), intent(in) :: surfaceTension(:)

   !> Probe radius of the solvent
   real(wp), intent(in) :: probeRad

   !> Offset for surface integration cutoff
   real(wp), intent(in) :: rOffset

   integer :: igrid, stat, iat, izp
   real(wp) :: r
   real(wp), allocatable :: angGrid(:, :), angWeight(:)
   type(TDomainDecompositionInput) :: input

   self%nat = size(num)
   allocate(self%rvdw(self%nat))
   self%rvdw(:) = radScale*vdwRad(num)
   self%dielectricConst = dielectricConst
   ! choose the lebedev grid with number of points closest to nAng:
   call bisectSearch(igrid, gridSize, nAng/2)
   allocate(angGrid(3, gridSize(igrid)))
   allocate(angWeight(gridSize(igrid)))
   call getAngGrid(igrid, angGrid, angWeight, stat)
   if (stat /= 0) then
      call env%error("Could not initialize angular grid for COSMO model", source)
      return
   end if

   input = TDomainDecompositionInput(lmax=6, conv=1.0e-8_wp, eta=0.2_wp)

   call initDomainDecomposition(self%ddCosmo, input, self%rvdw, angWeight, angGrid)

   allocate(self%nnsas(self%nat))
   allocate(self%nnlists(self%nat, self%nat))
   allocate(self%vdwsa(self%nat))
   allocate(self%trj2(2, self%nat))
   allocate(self%wrp(self%nat))
   allocate(self%gamsasa(self%nat))
   allocate(self%sasa(self%nat))
   allocate(self%dsdr(3, self%nat))
   allocate(self%dsdrt(3, self%nat, self%nat))
   do iat = 1, self%nat
      izp = num(iat)
      self%vdwsa(iat) = vdwRad(izp) + probeRad
      self%trj2(1, iat) = (self%vdwsa(iat)-w)**2
      self%trj2(2, iat) = (self%vdwsa(iat)+w)**2
      r=self%vdwsa(iat)+w
      self%wrp(iat)=(0.25_wp/w+ &
         &            3.0_wp*ah3*(0.2_wp*r*r-0.5_wp*r*self%vdwsa(iat)+ &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
      r=self%vdwsa(iat)-w
      self%wrp(iat)=self%wrp(iat)-(0.25/w+ &
         &    3.0_wp*ah3*(0.2_wp*r*r-0.5_wp*r*self%vdwsa(iat)+ &
         &            self%vdwsa(iat)*self%vdwsa(iat)/3.0_wp))*r*r*r
      self%gamsasa(iat) = surfaceTension(izp)
   end do
   self%srcut = 2 * (w + maxval(self%vdwsa)) + rOffset

   ! choose the lebedev grid with number of points closest to nAng:
   call bisectSearch(igrid, gridSize, nAng)
   self%nAng = gridSize(igrid)
   allocate(self%angGrid(3, gridSize(igrid)))
   allocate(self%angWeight(gridSize(igrid)))
   call getAngGrid(igrid, self%angGrid, self%angWeight, stat)
   if (stat /= 0) then
      call env%error("Could not initialize angular grid for SASA model", source)
      return
   end if

end subroutine initCosmo


subroutine update(self, env, num, xyz)

   !> Instance of the solvation model
   class(TCosmo), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   ! initialize the neighbor list
   call update_nnlist_sasa(self%nat, xyz, self%srcut, self%nnsas, self%nnlists)

   ! compute solvent accessible surface and its derivatives
   call compute_numsa(self%nat, self%nnsas, self%nnlists, xyz, self%vdwsa, &
      & self%wrp, self%trj2, self%angWeight, self%angGrid, &
      & self%sasa, self%dsdrt)

   ! contract surface gradient
   call mctc_gemv(self%dsdrt, self%gamsasa, self%dsdr)
   self%gsasa = mctc_dot(self%sasa, self%gamsasa)

   if (allocated(self%phi)) deallocate(self%phi)
   if (allocated(self%psi)) deallocate(self%psi)
   if (allocated(self%sigma)) deallocate(self%sigma)
   if (allocated(self%s)) deallocate(self%s)

   call ddupdate(self%ddcosmo, xyz)

   allocate(self%phi(self%ddCosmo%ncav), self%psi(self%ddCosmo%nylm, self%nat))
   allocate(self%jmat(self%ddCosmo%ncav, self%nat))

   call getCoulombMatrix(xyz, self%ddCosmo%ccav, self%jmat)

end subroutine update


!> Add potential shift
subroutine addShift(self, env, qat, qsh, atomicShift, shellShift)

   !> Error source
   character(len=*), parameter :: source = 'solv_cosmo_addShift'

   !> Instance of the solvation model
   class(TCosmo), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Atomic potential shift
   real(wp), intent(inout) :: atomicShift(:)

   !> Shell-resolved potential shift
   real(wp), intent(inout) :: shellShift(:)

   real(wp) :: xx(1, 1), keps
   logical :: restart

   keps = 0.5_wp * (1.0_wp - 1.0_wp/self%dielectricConst)
   restart = allocated(self%sigma)
   if (.not.allocated(self%sigma)) then
      allocate(self%sigma(self%ddCosmo%nylm, self%nat))
   end if

   call getPhi(qat, self%jmat, self%phi)

   call solveCosmoDirect(self%ddCosmo, env, .true., self%phi, xx, self%sigma, restart)

   restart = allocated(self%s)
   if (.not.allocated(self%s)) then
      allocate(self%s(self%ddCosmo%nylm, self%nat))
   end if

   call getPsi(qat, self%psi)

   ! solve adjoint ddCOSMO equation to get full potential contributions
   call solveCosmoAdjoint(self%ddCosmo, env, self%psi, self%s, restart)

   ! we abuse Phi to store the unpacked and scaled value of s
   call getZeta(self%ddCosmo, keps, self%s, self%phi)
   ! and contract with the Coulomb matrix
   call mctc_gemv(self%jmat, self%phi, atomicShift, alpha=-1.0_wp, &
      & beta=1.0_wp, trans='t')

   atomicShift(:) = atomicShift + (keps * sqrt(fourpi)) * self%sigma(1, :)

end subroutine addShift


!> Calculate solvation energy
subroutine getEnergy(self, env, qat, qsh, energy)

   !> Error source
   character(len=*), parameter :: source = 'solv_cosmo_getEnergy'

   !> Instance of the solvation model
   class(TCosmo), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Total solvation energy
   real(wp), intent(out) :: energy

   energy = 0.5_wp * (1.0_wp - 1.0_wp/self%dielectricConst) &
      & * mctc_dot(self%sigma, self%psi) + self%gsasa

end subroutine getEnergy


!> Calculate derivatives of solvation energy
subroutine addGradient(self, env, num, xyz, qat, qsh, gradient)

   !> Error source
   character(len=*), parameter :: source = 'solv_cosmo_addGradient'

   !> Instance of the solvation model
   class(TCosmo), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Atomic numbers
   integer, intent(in) :: num(:)

   !> Cartesian coordinates
   real(wp), intent(in) :: xyz(:, :)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Shell-resolved partial charges
   real(wp), intent(in) :: qsh(:)

   !> Molecular gradient
   real(wp), intent(inout) :: gradient(:, :)

   integer :: ii, iat, ig
   real(wp) :: xx(1), esolv, keps
   real(wp), allocatable :: fx(:, :), zeta(:), ef(:, :)

   gradient = gradient + self%dsdr

   keps = 0.5_wp * (1.0_wp - 1.0_wp/self%dielectricConst)

   allocate(fx(3, self%nat), zeta(self%ddCosmo%ncav), &
      & ef(3, max(self%nat, self%ddCosmo%ncav)))

   call solveCosmoAdjoint(self%ddCosmo, env, self%psi, self%s, .true., &
      & accuracy=self%ddCosmo%conv*1e-3_wp)

   ! reset Phi
   call getPhi(qat, self%jmat, self%phi)

   ! now call the routine that computes the ddcosmo specific contributions
   ! to the forces.
   call forces(self%ddCosmo, keps, self%phi, self%sigma, self%s, fx)

   ! form the "zeta" intermediate
   call getZeta(self%ddCosmo, keps, self%s, zeta)

   ! 1. solute's electric field at the cav points times zeta:
   !    compute the electric field
   call efld(self%nat, qat, self%ddCosmo%xyz, self%ddCosmo%ncav, &
      & self%ddCosmo%ccav, ef)

   ! contract it with the zeta intermediate
   ii = 0
   do iat = 1, self%ddCosmo%nat
      do ig = 1, self%ddCosmo%ngrid
         if (self%ddCosmo%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            fx(:, iat) = fx(:, iat) - zeta(ii)*ef(:, ii)
         end if
      end do
   end do

   ! 2. "zeta's" electric field at the nuclei times the charges.
   !    compute the "electric field"
   call efld(self%ddCosmo%ncav, zeta, self%ddCosmo%ccav, self%nat, &
      & self%ddCosmo%xyz, ef)

   ! contract it with the solute's charges.
   do iat = 1, self%ddCosmo%nat
      fx(:, iat) = fx(:, iat) - ef(:, iat)*qat(iat)
   end do

   gradient(:, :) = gradient(:, :) - fx

end subroutine addGradient


!> Evaluate the Coulomb interactions between the atomic sides (xyz) and the
!> surface elements of the cavity (ccav).
subroutine getCoulombMatrix(xyz, ccav, jmat)
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: ccav(:, :)
   real(wp), intent(inout) :: jmat(:, :)

   integer :: ic, j
   real(wp) :: vec(3), d2, d

   jmat(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp shared(ccav, xyz, jmat) private(ic, j, vec, d2, d)
   do ic = 1, size(ccav, 2)
      do j = 1, size(xyz, 2)
         vec(:) = ccav(:, ic) - xyz(:, j)
         d2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         d = sqrt(d2)
         jmat(ic, j) = 1.0_wp / d
      end do
   end do

end subroutine getCoulombMatrix


!> Routine to compute the psi vector
subroutine getPsi(charge, psi)
   real(wp), intent(in) :: charge(:)
   real(wp), intent(out) :: psi(:, :)

   integer :: iat
   real(wp) :: fac

   fac = sqrt(fourpi)
   psi(:,:) = 0.0_wp

   do iat = 1, size(charge)
      psi(1, iat) = fac*charge(iat)
   end do

end subroutine getPsi


!> Routine to compute the potential vector
subroutine getPhi(charge, jmat, phi)
   real(wp), intent(in) :: charge(:)
   real(wp), intent(in) :: jmat(:, :)
   real(wp), intent(out) :: phi(:)

   phi(:) = 0.0_wp

   call mctc_gemv(jmat, charge, phi)

end subroutine getPhi


!> Wrapper for the linear solvers for COSMO equation
!    L sigma = G
!  This routine performs the following operations :
!   - allocates memory for the linear solvers
!   - if star is false and cart is true, assembles the right-hand side for the COSMO
!     equations.
!   - computes a guess for the solution (using the inverse diagonal);
!   - calls the iterative solver;
subroutine solveCosmoDirect(ddCosmo, env, cart, phi, glm, sigma, restart)

   !> Error source
   character(len=*), parameter :: source = 'cosmo::solveCosmoDirect'
   type(TDomainDecomposition), intent(in) :: ddCosmo

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> true:  the right-hand side for the COSMO has to be assembled
   !         inside this routine and the unscaled potential at the
   !         external points of the cavity is provided in phi.
   !  false: the right-hand side for the COSMO equations is provided
   !         in glm.
   logical, intent(in) :: cart

   !> Contains the potential at the external cavity points if cart is true.
   !  phi is not referenced in any other case.
   real(wp), intent(in) :: phi(:)

   !> Contains the right-hand side for the COSMO equations if cart is false.
   !  glm is not referenced in any other case
   real(wp), intent(in) :: glm(:, :)

   !> The solution to the COSMO (adjoint) equations
   real(wp), intent(inout) :: sigma(:, :)

   !> Initial guess is provided on sigma
   logical, intent(in) :: restart

   integer :: iat, istatus, n_iter, info, c1, c2, cr
   real(wp) :: tol, r_norm
   logical :: ok

   real(wp), allocatable  :: g(:, :), rhs(:, :), work(:, :)

   ! parameters for the solver and matvec routine
   tol     = ddCosmo%conv
   n_iter  = 200

   ! DIRECT COSMO EQUATION L X = g

   ! allocate workspace for rhs
   allocate(rhs(ddCosmo%nylm, ddCosmo%nat), stat=istatus)
   if (istatus /= 0) then
      write(*, *) ' cosmo: [2] failed allocation'
   endif

   ! 1. RHS
   ! assemble rhs
   if (cart) then

      ! allocate workspace for weighted potential
      allocate(g(ddCosmo%ngrid, ddCosmo%nat) , stat=istatus)
      if (istatus /= 0) then
         write(*, *) ' cosmo: [3] failed allocation'
      endif

      ! weight the potential...
      call wghpot(ddCosmo, phi, g)

      ! ... and compute its multipolar expansion
      do iat = 1, ddCosmo%nat
         call intrhs(ddCosmo, iat, g(:, iat), rhs(:, iat))
      enddo

      ! deallocate workspace
      deallocate(g , stat=istatus)
      if (istatus /= 0) then
         write(*, *) 'cosmo: [1] failed deallocation'
      endif

   else
      ! no need to manipulate rhs
      rhs = glm
   end if

   ! 2. INITIAL GUESS
   if (.not.restart) then
      do iat = 1, ddCosmo%nat
         sigma(:, iat) = ddCosmo%facl(:)*rhs(:, iat)
      end do
   end if

   ! 3. SOLVER CALL
   ! Jacobi method :
   ! L X = (diag + offdiag) X = g   ==>    X = diag^-1 (g - offdiag X_guess)
   ! action of  diag^-1 :  ldm1x
   ! action of  offdiag :  lx
   call jacobi_diis(ddCosmo, ddCosmo%nat*ddCosmo%nylm, ddCosmo%iprint, &
      & ndiis, 4, tol, rhs, sigma, n_iter, ok, lx, ldm1x, hnorm)

   ! check solution
   if (.not.ok) then
      call env%error('direct ddCOSMO did not converge!', source)
      return
   endif

end subroutine solveCosmoDirect


!> Wrapper for the linear solvers for adjoint COSMO equation
!>   L^* sigma = Psi
!> This routine performs the following operations :
!>  - allocates memory for the linear solvers
!>  - computes a guess for the solution (using the inverse diagonal);
!>  - calls the iterative solver;
subroutine solveCosmoAdjoint(ddCosmo, env, psi, sigma, restart, accuracy)
   ! Error source
   character(len=*), parameter :: source = 'cosmo::solveCosmoAdjoint'
   type(TDomainDecomposition), intent(in) :: ddCosmo

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> The psi vector. it is used as a right-hand side
   real(wp), intent(in) :: psi(:, :)

   !> The solution to the COSMO (adjoint) equations
   real(wp), intent(inout) :: sigma(:, :)

   !> Initial guess is provided on sigma
   logical, intent(in) :: restart

   !> Overwrite accuracy
   real(wp), intent(in), optional :: accuracy

   integer :: iat, istatus, n_iter, info, c1, c2, cr
   real(wp) :: tol, r_norm
   logical :: ok

   real(wp), allocatable  :: g(:, :), rhs(:, :), work(:, :)

   ! parameters for the solver and matvec routine
   if (present(accuracy)) then
      tol = accuracy
   else
      tol = ddCosmo%conv
   end if
   n_iter  = 200

   ! 1. INITIAL GUESS
   if (.not.restart) then
      do iat = 1, ddCosmo%nat
         sigma(:, iat) = ddCosmo%facl(:)*psi(:, iat)
      end do
   end if

   ! 2. SOLVER CALL
   ! Jacobi method : see above
   call jacobi_diis(ddCosmo, ddCosmo%nat*ddCosmo%nylm, ddCosmo%iprint, &
      & ndiis, 4, tol, psi, sigma, n_iter, ok, lstarx, ldm1x, hnorm)

   ! check solution
   if (.not.ok) then
      call env%error('adjoint ddCOSMO did not converge!', source)
      return
   endif

end subroutine solveCosmoAdjoint


!> Compute
!
! \zeta(n, i) =
!
!  1/2 f(\eps) sum w_n U_n^i Y_l^m(s_n) [S_i]_l^m
!              l, m
!
subroutine getZeta(ddCosmo, keps, s, zeta)
   type(TDomainDecomposition), intent(in) :: ddCosmo
   real(wp), intent(in) :: keps
   real(wp), intent(in) :: s(:, :) ! [ddCosmo%nylm, ddCosmo%nat]
   real(wp), intent(inout) :: zeta(:) ! [ddCosmo%ncav]

   integer :: its, iat, ii

   ii = 0
   do iat = 1, ddCosmo%nat
      do its = 1, ddCosmo%ngrid
         if (ddCosmo%ui(its, iat) > 0.0_wp) then
            ii = ii + 1
            zeta(ii) = keps * ddCosmo%w(its) * ddCosmo%ui(its, iat) &
               & * dot_product(ddCosmo%basis(:, its), s(:, iat))
         end if
      end do
   end do

end subroutine getZeta


!> Sample driver for the calculation of the ddCOSMO forces.
subroutine forces(ddCosmo, keps, phi, sigma, s, fx)
   type(TDomainDecomposition), intent(in) :: ddCosmo
   real(wp), intent(in) :: keps
   real(wp), intent(in) :: phi(:)
   real(wp), intent(in) :: sigma(:, :)
   real(wp), intent(in) :: s(:, :)
   real(wp), intent(inout) :: fx(:, :)

   integer :: iat, ig, ii, c1, c2, cr
   real(wp) :: fep

   real(wp), allocatable :: xi(:, :), phiexp(:, :), zeta(:), ef(:, :)
   real(wp), allocatable :: basloc(:), dbsloc(:, :), vplm(:), vcos(:), vsin(:)

   allocate (xi(ddCosmo%ngrid, ddCosmo%nat), phiexp(ddCosmo%ngrid, ddCosmo%nat))
   allocate (basloc(ddCosmo%nylm), dbsloc(3, ddCosmo%nylm), vplm(ddCosmo%nylm), &
      & vcos(ddCosmo%lmax+1), vsin(ddCosmo%lmax+1))

   ! compute xi:
   !$omp parallel do default(none) collapse(2) schedule(runtime) &
   !$omp shared(ddCosmo, s, xi) private(iat, ig)
   do iat = 1, ddCosmo%nat
      do ig = 1, ddCosmo%ngrid
         xi(ig, iat) = dot_product(s(:, iat), ddCosmo%basis(:, ig))
      end do
   end do

   ! expand the potential on a sphere-by-sphere basis (needed for parallelism):
   ii = 0
   phiexp(:, :) = 0.0_wp
   do iat = 1, ddCosmo%nat
      do ig = 1, ddCosmo%ngrid
         if (ddCosmo%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            phiexp(ig, iat) = phi(ii)
         end if
      end do
   end do

   fx(:, :) = 0.0_wp
   do iat = 1, ddCosmo%nat
      call fdoka(ddCosmo, iat, sigma, xi(:, iat), basloc, dbsloc, vplm, &
         & vcos, vsin, fx(:, iat))
      call fdokb(ddCosmo, iat, sigma, xi, basloc, dbsloc, vplm, vcos, vsin, &
         & fx(:, iat))
      call fdoga(ddCosmo, iat, xi, phiexp, fx(:, iat))
   end do

   deallocate (basloc, dbsloc, vplm, vcos, vsin)
   deallocate (xi, phiexp)

   ! scale the forces time the cosmo factor:
   fx  = keps*fx

end subroutine forces


!> Computes the electric field produced by the sources src (nsrc point charges
!  with coordinates csrc) at the ntrg target points ctrg:
subroutine efld(nsrc, src, csrc, ntrg, ctrg, ef)
   integer, intent(in) :: nsrc, ntrg
   real(wp), intent(in) :: src(:)
   real(wp), intent(in) :: csrc(:, :)
   real(wp), intent(in) :: ctrg(:, :)
   real(wp), intent(inout) :: ef(:, :)

   integer :: i, j
   real(wp) :: vec(3), r2, rr, r3, f
   real(wp), parameter :: zero=0.0_wp

   ef(:, :) = 0.0_wp
   !$omp parallel do default(none) schedule(runtime) collapse(2) &
   !$omp reduction(+:ef) shared(ntrg, nsrc, ctrg, csrc, src) &
   !$omp private(j, i, f, vec, r2, rr, r3)
   do j = 1, ntrg
      do i = 1, nsrc
         vec(:) = ctrg(:, j) - csrc(:, i)
         r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
         rr = sqrt(r2)
         r3 = r2*rr
         f = src(i)/r3
         ef(:, j) = ef(:, j) + f*vec
      end do
   end do

end subroutine efld


!> setup a pairlist and compute pair distances of all neighbors
!  within thresholds lrcut and srcut.
subroutine update_nnlist_sasa(nat, xyz, srcut, nnsas, nnlists)

   integer, intent(in) :: nat
   real(wp), intent(in) :: xyz(:, :)
   real(wp), intent(in) :: srcut
   integer, intent(out) :: nnsas(:)
   integer, intent(out) :: nnlists(:, :)

   integer i1, i2
   real(wp) rcutn2, srcut2
   real(wp) x, y, z, dr2

   srcut2 = srcut*srcut

   nnsas=0
   nnlists=0
   do i1 = 1, nat
      do i2 = 1, i1-1
         x=xyz(1,i1)-xyz(1,i2)
         y=xyz(2,i1)-xyz(2,i2)
         z=xyz(3,i1)-xyz(3,i2)
         dr2=x**2+y**2+z**2
         if(dr2.lt.srcut2) then
            nnsas(i1) = nnsas(i1) + 1
            nnsas(i2) = nnsas(i2) + 1
            nnlists(nnsas(i1),i1)=i2
            nnlists(nnsas(i2),i2)=i1
         endif
      end do
   end do

end subroutine update_nnlist_sasa

!> Write a COSMO file output
subroutine writeCosmoFile(self, unit, num, sym, xyz, qat, energy)

   !> COSMO container
   class(TCosmo), intent(in) :: self

   !> Formatted unit for output
   integer, intent(in) :: unit

   !> Atomic numbers for each atom
   integer, intent(in) :: num(:)

   !> Element symbols for each atom
   character(len=*), intent(in) :: sym(:)

   !> Atomic coordinates
   real(wp), intent(in) :: xyz(:,:)

   !> Atomic partial charges
   real(wp), intent(in) :: qat(:)

   !> Total energy
   real(wp), intent(in) :: energy

   integer :: ii, ig, iat
   real(wp) :: dielEnergy, keps
   real(wp), allocatable :: phi(:), zeta(:), area(:)

   allocate(phi(self%ddCosmo%ncav), zeta(self%ddCosmo%ncav), area(self%ddCosmo%ncav))
   ! Reset potential on the cavity, note that the potential is expected in e/Å
   call getPhi(qat, self%jmat, phi)
   ii = 0
   do iat = 1, self%ddCosmo%nat
      do ig = 1, self%ddCosmo%ngrid
         if (self%ddCosmo%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            ! Calculate surface charge per area
            zeta(ii) = self%ddCosmo%w(ig) * self%ddCosmo%ui(ig, iat) &
               & * dot_product(self%ddCosmo%basis(:, ig), self%s(:, iat))
            ! Save surface area in Ångström²
            area(ii) = self%ddCosmo%w(ig) * autoaa**2 * self%rvdw(iat)**2
         end if
      end do
   end do


    ! Dielectric energy is the energy on the dielectric continuum
   keps = 0.5_wp * (1.0_wp - 1.0_wp/self%dielectricConst)
   dielEnergy = keps * dot_product(zeta, phi)

   write(unit, '(a)') &
      & "$info", &
      & "prog.: xtb"

   write(unit, '(a)') &
      & "$cosmo"
   write(unit, '(2x, a:, "=", g0)') &
      & "epsilon", self%dielectricConst

   write(unit, '(a)') &
      & "$cosmo_data"
   write(unit, '(2x, a:, "=", g0)') &
      & "fepsi", keps, &
      & "area", sum(area)

   write(unit, '(a)') &
      & "$coord_rad", &
      & "#atom   x                  y                  z             element  radius [A]"
   do iat = 1, size(xyz, 2)
      write(unit, '(i4, 3(1x, f18.14), 2x, a4, 1x, f9.5)') &
         & iat, xyz(:, iat), sym(iat), self%rvdw(iat)*autoaa
   end do

   write(unit, '(a)') &
      & "$coord_car", &
      & "!BIOSYM archive 3", &
   & "PBC=OFF", &
      & "coordinates from COSMO calculation", &
      & "!DATE"
   do iat = 1, size(xyz, 2)
      write(unit, '(a, i0, t5, 3(1x, f14.9), 1x, "COSM 1", 2(6x, a2), 1x, f6.3)') &
         & trim(sym(iat)), iat, xyz(:, iat)*autoaa, sym(iat), sym(iat), 0.0_wp
   end do
   write(unit, '(a)') &
      & "end", "end"

   write(unit, '(a)') &
      & "$screening_charge"
   write(unit, '(2x, a:, "=", g0)') &
      & "cosmo", sum(zeta), &
      & "correction", 0.0_wp, &
      & "total", sum(zeta)

   write(unit, '(a)') &
      & "$cosmo_energy"
   write(unit, '(2x, a:, "=", f21.10)') &
      & "Total energy [a.u.]            ", energy, &
      & "Total energy + OC corr. [a.u.] ", energy, &
      & "Total energy corrected [a.u.]  ", energy, &
      & "Dielectric energy [a.u.]       ", dielEnergy, &
      & "Diel. energy + OC corr. [a.u.] ", dielEnergy

   write(unit, '(a)') &
      & "$segment_information", &
      & "# n             - segment number", &
      & "# atom          - atom associated with segment n", &
      & "# position      - segment coordinates [a.u.]", &
      & "# charge        - segment charge (corrected)", &
      & "# area          - segment area [A**2]", &
      & "# potential     - solute potential on segment (A length scale)", &
      & "#", &
      & "#  n   atom              position (X, Y, Z)                   charge         area        charge/area     potential", &
      & "#", &
      & "#"

   ii = 0
   do iat = 1, self%ddCosmo%nat
      do ig = 1, self%ddCosmo%ngrid
         if (self%ddCosmo%ui(ig, iat) > 0.0_wp) then
            ii = ii + 1
            write(unit, '(2i5, 7(1x, f14.9))') &
               & ii, iat, self%ddCosmo%ccav(:, ii), &
               & zeta(ii), area(ii), zeta(ii)/area(ii), phi(ii)/autoaa
         end if
      end do
   end do
end subroutine writeCosmoFile

end module xtb_solv_cosmo

! This file is part of xtb.
!
! Copyright (C) 2022 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Intermolecular force field calculator
module xtb_iff_calculator
   use xtb_mctc_accuracy, only: wp
   use xtb_type_calculator, only: TCalculator
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule, only: TMolecule, init
   use xtb_type_restart
   use xtb_iff_data, only: TIFFData
   use xtb_type_data, only: scc_results
   use xtb_iff_iffenergy, only: iff_e
   use xtb_docking_param
   use xtb_iff_iffini, only : init_iff

   implicit none

   private

   public :: TIFFCalculator, newIFFCalculator

   !> Calculator interface for xTB based methods
   type, extends(TCalculator) :: TIFFCalculator

      type(TIFFData) :: dat

   contains

      !> Perform xTB single point calculationV
      procedure :: singlepoint

      !> Write informative printout
      procedure :: writeInfo

   end type TIFFCalculator

   character(len=*), private, parameter :: outfmt = &
                                           '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'

contains

   subroutine newIFFCalculator(env, comb, iff_data, calc)

      character(len=*), parameter :: source = 'main_setup_newIFFCalculator'

      type(TEnvironment), intent(inout) :: env

      !> Combined structure of molA and molB (molA has to be first)
      type(TMolecule), intent(in) :: comb

      type(TIFFData), intent(in) :: iff_data

      type(TIFFCalculator), intent(out) :: calc

      integer, allocatable :: at(:)
      real(wp), allocatable :: xyz(:,:)
      logical :: exitRun
      real(wp) :: molA_e,molB_e
      character(len=:), allocatable :: fnam
      real(wp) :: icoord(6), icoord0(6)
      real(wp) :: rlmo2(4,(comb%n-natom_molA)*10)

      call set_iff_param
      call calc%dat%allocateIFFData(natom_molA,comb%n-natom_molA)
      calc%dat = iff_data

      xyz=calc%dat%xyz2
      rlmo2=calc%dat%rlmo2

      call init_iff(env,calc%dat%n1,calc%dat%n2,calc%dat%at1,calc%dat%at2,&
        &          calc%dat%neigh,calc%dat%xyz1,calc%dat%xyz2,calc%dat%q1,&
        &          calc%dat%q2,calc%dat%c6ab,calc%dat%z1,calc%dat%z2,&
        &          calc%dat%cprob,calc%dat%nlmo1,calc%dat%nlmo2,calc%dat%lmo1,calc%dat%lmo2,&
        &          calc%dat%qdr1,calc%dat%qdr2,calc%dat%rlmo1,calc%dat%rlmo2,&
        &          calc%dat%cn1,calc%dat%cn2,calc%dat%alp1,calc%dat%alp2,calc%dat%alpab,&
        &          calc%dat%den1,calc%dat%den2,calc%dat%gab1,calc%dat%gab2,calc%dat%qcm1,&
        &          calc%dat%qcm2,calc%dat%n,calc%dat%at,calc%dat%xyz,calc%dat%q,icoord,icoord0,&
        &          .false.)
      calc%dat%xyz2=xyz
      calc%dat%rlmo2=rlmo2

      call env%check(exitRun)
      if (exitRun) then
         call env%error("Could not create IFF calculator", source)
         return
      end if

   end subroutine newIFFCalculator

   subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
         & energy, gradient, sigma, hlgap, results)

      !> Source of the generated errors
      character(len=*), parameter :: source = 'iff_calculator_singlepoint'

      !> Calculator instance
      class(TIFFCalculator), intent(inout) :: self

      !> Computational environment
      type(TEnvironment), intent(inout) :: env

      !> Molecular structure data
      type(TMolecule), intent(inout) :: mol

      !> Wavefunction data
      type(TRestart), intent(inout) :: chk

      !> Print level for IO
      integer, intent(in) :: printlevel

      !> Restart from previous results
      logical, intent(in) :: restart

      !> Total energy
      real(wp), intent(out) :: energy

      !> Molecular gradient
      real(wp), intent(out) :: gradient(:, :)

      !> Strain derivatives
      real(wp), intent(out) :: sigma(:, :)

      !> HOMO-LUMO gab
      real(wp), intent(out) :: hlgap

      !> Detailed results
      type(scc_results), intent(out) :: results

      call iff_e(env, self%dat%n, self%dat%n1, self%dat%n2, self%dat%at1,&
           &     self%dat%at2, self%dat%neigh, self%dat%xyz1, self%dat%xyz2,&
           &     self%dat%q1, self%dat%q2, self%dat%c6ab, self%dat%z1, self%dat%z2,&
           &     self%dat%nlmo1, self%dat%nlmo2, self%dat%lmo1, self%dat%lmo2,&
           &     self%dat%rlmo1, self%dat%rlmo2,self%dat%qdr1, self%dat%qdr2,&
           &     self%dat%cn1, self%dat%cn2, self%dat%alp1,&
           &     self%dat%alp2, self%dat%alpab, self%dat%qct1, self%dat%qct2,&
           &     self%dat%den1, self%dat%den2, self%dat%gab1, self%dat%gab2,&
           &     .true., 0, energy)

      results%e_total=energy
      gradient = 0
      sigma = 0
      hlgap = 0

   end subroutine singlepoint

   subroutine writeInfo(self, unit, mol)

      !> Calculator instance
      class(TIFFCalculator), intent(in) :: self

      !> Unit for I/O
      integer, intent(in) :: unit

      !> Molecular structure data
      type(TMolecule), intent(in) :: mol

   end subroutine writeInfo

end module xtb_iff_calculator

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_data
   use xtb_mctc_accuracy, only : wp
   use xtb_type_pcem
   use xtb_iff_data, only : TIFFData

   implicit none

   public :: scc_results
   public :: freq_results

   private

   type :: TIFFResults
      !> Number of atoms
      integer :: n       
      !> Ordinary numbers
      integer, allocatable :: at(:)
      !> Coordinates 
      real(wp), allocatable :: xyz(:, :)
      !> Charges
      real(wp), allocatable :: q(:)
      !> Number of LMOs 
      integer :: nlmo
      !> LMO positions 
      real(wp), allocatable :: rlmo(:, :)
      !> LMO values
      integer, allocatable :: lmo(:)
      !> Charge related stuff
      real(wp), allocatable :: qct(:, :)
      !> HOMO, LUMO, Dipol
      real(wp) :: elumo
      real(wp) :: ehomo
      real(wp) :: dipol

   contains

      procedure :: delete
      procedure :: allocateIFFResults

   end type TIFFResults

   type :: scc_results
      real(wp) :: e_atom = 0.0_wp
      real(wp) :: e_elec = 0.0_wp
      real(wp) :: e_total = 0.0_wp
      real(wp) :: e_rep = 0.0_wp
      real(wp) :: e_es = 0.0_wp
      real(wp) :: e_aes = 0.0_wp
      real(wp) :: e_axc = 0.0_wp
      real(wp) :: e_disp = 0.0_wp
      real(wp) :: e_xb = 0.0_wp
      real(wp) :: g_born = 0.0_wp
      real(wp) :: g_sasa = 0.0_wp
      real(wp) :: g_hb = 0.0_wp
      real(wp) :: g_shift = 0.0_wp
      real(wp) :: hl_gap = 0.0_wp
      real(wp) :: dipole(3) = (/0.0_wp,0.0_wp,0.0_wp/)
      real(wp) :: molpol = 0.0_wp
      real(wp) :: g_solv = 0.0_wp
      real(wp) :: g_total = 0.0_wp
      real(wp) :: gnorm = 0.0_wp
      logical  :: converged = .true.
      type(tb_pcem) :: pcem = tb_pcem()
      real(wp) :: e_bond = 0.0_wp
      real(wp) :: e_angl = 0.0_wp
      real(wp) :: e_tors = 0.0_wp
      real(wp) :: e_hb = 0.0_wp
      real(wp) :: e_batm = 0.0_wp
      real(wp) :: e_ext = 0.0_wp
      type(TIFFResults), allocatable :: iff_results
   end type scc_results

   type freq_results
      integer  :: n = 0
      integer  :: n3 = 0
      integer  :: n3true = 0
      integer  :: lowmode = 0
      integer  :: nimag = 0
      logical  :: linear = .false.
      logical  :: mweighted = .false.
      real(wp) :: zp = 0.0_wp
      real(wp) :: temp = 0.0_wp
      real(wp) :: etot = 0.0_wp
      real(wp) :: htot = 0.0_wp
      real(wp) :: gtot = 0.0_wp
      real(wp) :: gnorm = 0.0_wp
      real(wp),allocatable :: grad(:,:)
      real(wp),allocatable :: freq(:)
      real(wp),allocatable :: hess(:,:)
      real(wp),allocatable :: rmass(:)
      real(wp),allocatable :: dipt(:)
      real(wp),allocatable :: polt(:)
      character(len=:),allocatable :: pg
   contains
      procedure :: allocate => allocate_freq_results
      procedure :: deallocate => deallocate_freq_results
   end type freq_results

contains
   
subroutine delete(self)
   class(TIFFResults), intent(out) :: self
   if (allocated(self%at)) deallocate (self%at)
   if (allocated(self%xyz)) deallocate (self%xyz)
   if (allocated(self%q)) deallocate (self%q)
   if (allocated(self%lmo)) deallocate (self%lmo)
   if (allocated(self%rlmo)) deallocate (self%rlmo)
   if (allocated(self%qct)) deallocate (self%qct)
end subroutine delete

subroutine allocateIFFResults(self, n)
   use xtb_type_molecule, only: TMolecule
   class(TIFFResults), intent(out) :: self
   integer, intent(in) :: n
   self%n = n
   allocate(self%at(n), self%lmo(10*n), source = 0)

   allocate(self%xyz(3,n), self%q(n), self%rlmo(4,10*n),&
           & self%qct(n,2), source= 0.0_wp)
end subroutine allocateIFFResults

subroutine allocate_freq_results(self,n)
   implicit none
   class(freq_results) :: self
   integer,intent(in)  :: n
   call self%deallocate
   self%n      = n
   self%n3     = 3*n
   self%n3true = 3*n
   self%pg = 'c1'
   allocate( self%grad (3,n),     source = 0.0_wp )
   allocate( self%hess (3*n,3*n), source = 0.0_wp )
   allocate( self%freq (3*n),     source = 0.0_wp )
   allocate( self%rmass(3*n),     source = 0.0_wp )
   allocate( self%dipt (3*n),     source = 0.0_wp )
   allocate( self%polt (3*n),     source = 0.0_wp )
end subroutine allocate_freq_results

subroutine deallocate_freq_results(self)
   implicit none
   class(freq_results) :: self
   self%n = 0
   self%n3 = 0
   self%n3true = 0
   self%nimag = 0
   if (allocated( self%grad )) deallocate( self%grad )
   if (allocated( self%hess )) deallocate( self%hess )
   if (allocated( self%freq )) deallocate( self%freq )
   if (allocated( self%rmass)) deallocate( self%rmass)
   if (allocated( self%dipt )) deallocate( self%dipt )
   if (allocated( self%polt )) deallocate( self%polt )
   if (allocated( self%pg   )) deallocate( self%pg   )
end subroutine deallocate_freq_results

end module xtb_type_data

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> LAPACK eigenproblem solvers
module xtb_mctc_lapack_stdeigval
   use xtb_mctc_accuracy, only : sp, dp
   implicit none
   private

   public :: lapack_syev, lapack_syevd, lapack_syevx, lapack_syevr, lapack_spev
   public :: lapack_spevd, lapack_spevx
   public :: lapack_heev, lapack_heevd, lapack_heevx, lapack_heevr, lapack_hpev
   public :: lapack_hpevd, lapack_hpevx


   interface lapack_syev
      pure subroutine ssyev(jobz, uplo, n, a, lda, w, work, lwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine ssyev
      pure subroutine dsyev(jobz, uplo, n, a, lda, w, work, lwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine dsyev
   end interface lapack_syev

   interface lapack_heev
      pure subroutine cheev(jobz, uplo, n, a, lda, w, work, lwork, rwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(in) :: rwork(*)
      end subroutine cheev
      pure subroutine zheev(jobz, uplo, n, a, lda, w, work, lwork, rwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(in) :: rwork(*)
      end subroutine zheev
   end interface lapack_heev

   interface lapack_syevd
      pure subroutine ssyevd(jobz, uplo, n, a, lda, w, work, lwork, iwork, &
            & liwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine ssyevd
      pure subroutine dsyevd(jobz, uplo, n, a, lda, w, work, lwork, iwork, &
            & liwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dsyevd
   end interface lapack_syevd

   interface lapack_heevd
      pure subroutine cheevd(jobz, uplo, n, a, lda, w, work, lwork, rwork, &
            & lrwork, iwork, liwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine cheevd
      pure subroutine zheevd(jobz, uplo, n, a, lda, w, work, lwork, rwork, &
            & lrwork, iwork, liwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine zheevd
   end interface lapack_heevd

   interface lapack_syevx
      pure subroutine ssyevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, lwork, iwork, ifail, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(in) :: iwork(*)
      end subroutine ssyevx
      pure subroutine dsyevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, lwork, iwork, ifail, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(in) :: iwork(*)
      end subroutine dsyevx
   end interface lapack_syevx

   interface lapack_heevx
      pure subroutine cheevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, lwork, rwork, iwork, ifail, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine cheevx
      pure subroutine zheevx(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, lwork, rwork, iwork, ifail, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine zheevx
   end interface lapack_heevx

   interface lapack_syevr
      pure subroutine ssyevr(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, isuppz, work, lwork, iwork, liwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: isuppz(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine ssyevr
      pure subroutine dsyevr(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, isuppz, work, lwork, iwork, liwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: isuppz(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dsyevr
   end interface lapack_syevr

   interface lapack_heevr
      pure subroutine cheevr(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, isuppz, work, lwork, rwork, lrwork, iwork, &
            & liwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: isuppz(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine cheevr
      pure subroutine zheevr(jobz, range, uplo, n, a, lda, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, isuppz, work, lwork, rwork, lrwork, iwork, &
            & liwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: isuppz(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldz
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine zheevr
   end interface lapack_heevr

   interface lapack_spev
      pure subroutine sspev(jobz, uplo, n, ap, w, z, ldz, work, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(sp), intent(in) :: work(*)
      end subroutine sspev
      pure subroutine dspev(jobz, uplo, n, ap, w, z, ldz, work, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(dp), intent(in) :: work(*)
      end subroutine dspev
   end interface lapack_spev

   interface lapack_hpev
      pure subroutine chpev(jobz, uplo, n, ap, w, z, ldz, work, rwork, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(sp), intent(in) :: work(*)
         real(sp), intent(in) :: rwork(*)
      end subroutine chpev
      pure subroutine zhpev(jobz, uplo, n, ap, w, z, ldz, work, rwork, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(dp), intent(in) :: work(*)
         real(dp), intent(in) :: rwork(*)
      end subroutine zhpev
   end interface lapack_hpev

   interface lapack_spevd
      pure subroutine sspevd(jobz, uplo, n, ap, w, z, ldz, work, lwork, iwork, &
            & liwork, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine sspevd
      pure subroutine dspevd(jobz, uplo, n, ap, w, z, ldz, work, lwork, iwork, &
            & liwork, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dspevd
   end interface lapack_spevd

   interface lapack_hpevd
      pure subroutine chpevd(jobz, uplo, n, ap, w, z, ldz, work, lwork, rwork, &
            & lrwork, iwork, liwork, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine chpevd
      pure subroutine zhpevd(jobz, uplo, n, ap, w, z, ldz, work, lwork, rwork, &
            & lrwork, iwork, liwork, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine zhpevd
   end interface lapack_hpevd

   interface lapack_spevx
      pure subroutine sspevx(jobz, range, uplo, n, ap, vl, vu, il, iu, abstol, &
            & m, w, z, ldz, work, iwork, ifail, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(sp), intent(in) :: work(*)
         integer, intent(in) :: iwork(*)
      end subroutine sspevx
      pure subroutine dspevx(jobz, range, uplo, n, ap, vl, vu, il, iu, abstol, &
            & m, w, z, ldz, work, iwork, ifail, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(dp), intent(in) :: work(*)
         integer, intent(in) :: iwork(*)
      end subroutine dspevx
   end interface lapack_spevx

   interface lapack_hpevx
      pure subroutine chpevx(jobz, range, uplo, n, ap, vl, vu, il, iu, abstol, &
            & m, w, z, ldz, work, rwork, iwork, ifail, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         real(sp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(sp), intent(in) :: work(*)
         real(sp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine chpevx
      pure subroutine zhpevx(jobz, range, uplo, n, ap, vl, vu, il, iu, abstol, &
            & m, w, z, ldz, work, rwork, iwork, ifail, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         real(dp), intent(out) :: w(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(dp), intent(in) :: work(*)
         real(dp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine zhpevx
   end interface lapack_hpevx


contains


end module xtb_mctc_lapack_stdeigval

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Type holding the parametrisation data of the force field
module xtb_gfnff_data
   use xtb_mctc_accuracy, only : wp
   implicit none
   private

   public :: TGFFData, init


   !> Parametrisation data for the force field
   type :: TGFFData

      !> repulsion scaling
      real(wp) :: repscaln
      real(wp) :: repscalb

      !> bend/tors angle damping
      real(wp) :: atcuta
      real(wp) :: atcutt

      !> bend/tors nci angle damping for HB term
      real(wp) :: atcuta_nci
      real(wp) :: atcutt_nci

      !> damping HB
      real(wp) :: hbacut
      real(wp) :: hbscut

      !> damping XB
      real(wp) :: xbacut
      real(wp) :: xbscut

      !> damping HB/XB
      real(wp) :: hbalp

      !> damping HB/XB
      real(wp) :: hblongcut
      real(wp) :: hblongcut_xb

      !> charge scaling HB/XB
      real(wp) :: hbst
      real(wp) :: hbsf
      real(wp) :: xbst
      real(wp) :: xbsf

      !> HB AH-B
      real(wp) :: xhaci_globabh

      !> HB AH-O=C
      real(wp) :: xhaci_coh

      !> acidity
      real(wp) :: xhaci_glob

      !> HB AH-B
      real(wp) :: hbabmix

      !> new parameter for neighbour angle
      real(wp) :: hbnbcut

      !> new parameter for HB NCI angle term
      real(wp) :: tors_hb

      !> new parameter for HB NCI torsion term
      real(wp) :: bend_hb

      !> new parameter for FC scaling of bonds in HB
      real(wp) :: vbond_scale

      !> max CN cut-off
      real(wp) :: cnmax

      !> D3 scaling
      real(wp) :: dispscale

      !> Constant data
      real(wp), allocatable :: en(:)
      real(wp), allocatable :: rad(:)
      real(wp), allocatable :: rcov(:)
      integer, allocatable :: metal(:)
      integer, allocatable :: group(:)
      integer, allocatable :: normcn(:)

      !> rep alpha bond
      real(wp), allocatable :: repa (:)
      real(wp), allocatable :: repan(:)

      !> prefactor (Zval), 3atm bond term
      real(wp), allocatable :: repz (:)
      real(wp), allocatable :: zb3atm(:)

      !> HB/XB
      real(wp), allocatable :: xhaci(:)
      real(wp), allocatable :: xhbas(:)
      real(wp), allocatable :: xbaci(:)

      !> EN dep. in EEQ.
      real(wp), allocatable :: chi(:)
      real(wp), allocatable :: gam(:)
      real(wp), allocatable :: cnf(:)
      real(wp), allocatable :: alp(:)

      !> Elem. bond param.
      real(wp), allocatable :: bond(:)

      !> Elem. angular param.
      real(wp), allocatable :: angl(:)

      !> Elem. angular param.
      real(wp), allocatable :: angl2(:)

      !> Elem. torsion param_alloc.
      real(wp), allocatable :: tors(:)

      !> Elem. torsion param.
      real(wp), allocatable :: tors2(:)

      !> BJ radii set in gnff_ini()
      real(wp), allocatable :: d3r0(:)

   end type TGFFData


   !> Initialize a new instance of the parametrisation data
   interface init
      module procedure :: initGFFData
   end interface init


contains


!> Initialize a new instance of the parametrisation data
subroutine initGFFData(self, ndim)

   !> Instance of the parametrisation data
   type(TGFFData), intent(out) :: self

   !> Dimension for allocating space
   integer, intent(in) :: ndim

   allocate(self%en(ndim))
   allocate(self%rad(ndim))
   allocate(self%metal(ndim))
   allocate(self%group(ndim))
   allocate(self%normcn(ndim))
   allocate(self%rcov(ndim))

   allocate(self%repa (ndim))
   allocate(self%repan(ndim))

   allocate(self%repz (ndim))
   allocate(self%zb3atm(ndim))

   allocate(self%xhaci(ndim))
   allocate(self%xhbas(ndim))
   allocate(self%xbaci(ndim))

   allocate(self%chi(ndim))
   allocate(self%gam(ndim))
   allocate(self%cnf(ndim))
   allocate(self%alp(ndim))

   allocate(self%bond(ndim))

   allocate(self%angl(ndim))

   allocate(self%angl2(ndim))

   allocate(self%tors(ndim))

   allocate(self%tors2(ndim))

   allocate(self%d3r0(ndim*(1+ndim)/2))

end subroutine initGFFData


end module xtb_gfnff_data

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine citation(iunit)
integer,intent(in) :: iunit
write(iunit,'(3x,a)') &
   "Cite this work as:", &
   "* C. Bannwarth, E. Caldeweyher, S. Ehlert, A. Hansen, P. Pracht,",&
   "  J. Seibert, S. Spicher, S. Grimme, WIREs Comput. Mol. Sci., 2020, 11,",&
   "  e01493. DOI: 10.1002/wcms.1493",&
   "",&
   "for GFN2-xTB:",&
   "* C. Bannwarth, S. Ehlert and S. Grimme., J. Chem. Theory Comput., 2019,",&
   "  15, 1652-1671. DOI: 10.1021/acs.jctc.8b01176",&
   "for GFN1-xTB:",&
   "* S. Grimme, C. Bannwarth, P. Shushkov, J. Chem. Theory Comput., 2017,",&
   "  13, 1989-2009. DOI: 10.1021/acs.jctc.7b00118", &
   "for GFN0-xTB:",&
   "* P. Pracht, E. Caldeweyher, S. Ehlert, S. Grimme, ChemRxiv, 2019, preprint.",&
   "  DOI: 10.26434/chemrxiv.8326202.v1",&
   "for GFN-FF:",&
   "* S. Spicher and S. Grimme, Angew. Chem. Int. Ed., 2020, 59, 15665-15673.",&
   "  DOI: 10.1002/anie.202004239", &
   "",&
   "for ALPB and GBSA implicit solvation:",&
   "* S. Ehlert, M. Stahn, S. Spicher, S. Grimme, J. Chem. Theory Comput.,", &
   "  2021, 17, 4250-4261. DOI: 10.1021/acs.jctc.1c00471", &
   "",&
   "for DFT-D4:",&
   "* E. Caldeweyher, C. Bannwarth and S. Grimme, J. Chem. Phys., 2017,",&
   "  147, 034112. DOI: 10.1063/1.4993215", &
   "* E. Caldeweyher, S. Ehlert, A. Hansen, H. Neugebauer, S. Spicher,", &
   "  C. Bannwarth and S. Grimme, J. Chem. Phys., 2019, 150, 154122.", &
   "  DOI: 10.1063/1.5090222", &
   "* E. Caldeweyher, J.-M. Mewes, S. Ehlert and S. Grimme, Phys. Chem. Chem. Phys.",&
   "  2020, 22, 8499-8512. DOI: 10.1039/D0CP00502A",&
   "",&
   "for sTDA-xTB:",&
   "* S. Grimme and C. Bannwarth, J. Chem. Phys., 2016, 145, 054103.",&
   "  DOI: 10.1063/1.4959605",&
   "",&
   "in the mass-spec context:",&
   "* V. Asgeirsson, C. Bauer and S. Grimme, Chem. Sci., 2017, 8, 4879.",&
   "  DOI: 10.1039/c7sc00601b",&
   "* J. Koopman and S. Grimme, ACS Omega 2019, 4, 12, 15120-15133.",&
   "  DOI: 10.1021/acsomega.9b02011",&
   "",&
   "for metadynamics refer to:",&
   "* S. Grimme, J. Chem. Theory Comput., 2019, 155, 2847-2862", &
   "  DOI: 10.1021/acs.jctc.9b00143", &
   "",&
   "for SPH calculations refer to:",&
   "* S. Spicher and S. Grimme, J. Chem. Theory Comput., 2021, 17, 1701-1714", &
   "  DOI: 10.1021/acs.jctc.0c01306", &
   "",&
   "with help from (in alphabetical order)",&
   "P. Atkinson, C. Bannwarth, F. Bohle, G. Brandenburg, E. Caldeweyher", &
   "M. Checinski, S. Dohm, S. Ehlert, S. Ehrlich, I. Gerasimov, C. Hölzer", &
   "A. Katbashev, J. Koopman, C. Lavigne, S. Lehtola, F. März, M. Müller,", &
   "F. Musil, H. Neugebauer, J. Pisarek, C. Plett, P. Pracht, F. Pultar,", &
   "J. Seibert, P. Shushkov, S. Spicher, M. Stahn, M. Steiner, T. Strunk,", &
   "J. Stückrath, T. Rose, and J. Unsleber", &
   ""
end subroutine citation

subroutine help(iunit)
   implicit none
   integer, intent(in) :: iunit
   write(iunit,'(a)') &
   "Usage: xtb [options] <geometry> [options]", &
   "",&
   "<geometry> may be provided as valid TM coordinate file (*coord in Bohr),",&
   "in xmol format (*.xyz in Ångström), sdf or mol file format, PDB format",&
   "genFormat input or Vasp's POSCAR format.",&
   "",&
   "For a full list visit: https://grimme-lab.github.io/mctc-lib/page/index.html", &
   "",&
   "Options:",&
   "",&
   "-c, --chrg INT",&
   "    specify molecular charge as INT, overrides .CHRG file and xcontrol option",&
   "",&
   "-u, --uhf INT",&
   "    specify number of unpaired electrons as INT, overrides .UHF file and xcontrol option",&
   "",&
   "--gfn INT",&
   "    specify parametrisation of GFN-xTB (default = 2)",&
   "",&
   "--gfnff, --gff",&
   "    specify parametrisation of GFN-FF",&
   "",&
   "--tblite,",&
   "    use tblite library as implementation for xTB",&
   "",&
   "--spinpol,",&
   "    enables spin-polarization for xTB methods (tblite required)",&
   "",&
   "--oniom METHOD LIST", &
   "    use subtractive embedding via ONIOM method. 'METHOD' is given as 'inner:outer'", &
   "    where 'inner' can be 'orca', 'turbomole', 'gfn2', 'gfn1', or 'gfnff' and", &
   "    'outer' can be 'gfn2', 'gfn1', or 'gfnff'.", &
   "    The inner region is given as a comma separated indices directly in the commandline", &
   "    or in a file with each index on a separate line.", &
   "",&
   "--etemp REAL",&
   "    electronic temperature (default = 300K)",&
   "",&
   "--esp",&
   "    calculate electrostatic potential on VdW-grid",&
   "",&
   "--stm",&
   "    calculate STM image",&
   "",&
   "-a, --acc REAL",&
   "    accuracy for SCC calculation, lower is better (default = 1.0)",&
   "",&
   "--vparam FILE",&
   "    Parameter file for vTB calculation",&
   "",&
   "--xparam FILE",&
   "    Parameter file for xTB calculation (not used)",&
   "",&
   "--alpb SOLVENT [STATE]",&
   "    analytical linearized Poisson-Boltzmann (ALPB) model,",&
   "    available solvents are acetone, acetonitrile, aniline, benzaldehyde,",&
   "    benzene, ch2cl2, chcl3, cs2, dioxane, dmf, dmso, ether, ethylacetate, furane,", &
   "    hexandecane, hexane, methanol, nitromethane, octanol, woctanol, phenol, toluene,",&
   "    thf, water.",&
   "    The solvent input is not case-sensitive. The Gsolv",&
   "    reference state can be chosen as reference or bar1M (default).",&
   "",&
   "-g, --gbsa SOLVENT [STATE]",&
   "    generalized born (GB) model with solvent accessable surface (SASA) model,",&
   "    available solvents are acetone, acetonitrile, benzene (only GFN1-xTB), CH2Cl2,",&
   "    CHCl3, CS2, DMF (only GFN2-xTB), DMSO, ether, H2O, methanol,",&
   "    n-hexane (only GFN2-xTB), THF and toluene.",&
   "    The solvent input is not case-sensitive.", &
   "    The Gsolv reference state can be chosen as reference or bar1M (default).",&
   "",&
   "--cma",&
   "    shifts molecule to center of mass and transforms cartesian coordinates into the",&
   "    coordinate system of the principle axis (not affected by ‘isotopes’-file).",&
   "",&
   "--pop",&
   "    requests printout of Mulliken population analysis",&
   "",&
   "--molden",&
   "    requests printout of molden file",&
   "",&
   "--dipole",&
   "    requests dipole printout",&
   "",&
   "--wbo",&
   "    requests Wiberg bond order printout",&
   "",&
   "--lmo",&
   "    requests localization of orbitals",&
   "",&
   "--fod",&
   "    requests FOD calculation",&
   "",&
   "--scc, --sp",&
   "    performs a single point calculation",&
   "",&
   "--vip",&
   "    performs calculation of ionisation potential. This needs the param_ipea-xtb.txt",&
   "    parameters and a GFN1 Hamiltonian.",&
   "",&
   "--vea",&
   "    performs calculation of electron affinity. This needs the param_ipea-xtb.txt",&
   "    parameters and a GFN1 Hamiltonian.",&
   "",&
   "--vipea",&
   "    performs calculation of electron affinity and ionisation potential.",&
   "    This needs the param_ipea-xtb.txt parameters and a GFN1 Hamiltonian.",&
   "",&
   "--vfukui",&
   "    performs calculation of Fukui indices.",&
   "",&
   "--vomega",&
   "    performs calculation of electrophilicity index. This needs the param_ipea-xtb.txt",&
   "    parameters and a GFN1 Hamiltonian.",&
   "",&
   "--grad",&
   "    performs a gradient calculation",&
   "",&
   "-o, --opt [LEVEL]",&
   "    call ancopt(3) to perform a geometry optimization, levels from crude, sloppy,", &
   "    loose, normal (default), tight, verytight to extreme can be chosen",&
   "",&
   "--hess",&
   "    perform a numerical hessian calculation on input geometry",&
   "",&
   "--ohess [LEVEL]",&
   "    perform a numerical hessian calculation on an ancopt(3) optimized geometry",&
   "",&
   "--bhess [LEVEL]",&
   "    perform a biased numerical hessian calculation on an ancopt(3) optimized geometry",&
   "",&
   "--md",&
   "    molecular dynamics simulation on start geometry",&
   "",&
   "--metadyn [int]",&
   "    meta dynamics simulation on start geometry, saving int snapshots of the", &
   "    trajectory to bias the simulation",&
   "",&
   "--omd",&
   "    molecular dynamics simulation on ancopt(3) optimized geometry,", &
   "    a loose optimization level will be chosen",&
   "",&
   "--metaopt [LEVEL]",&
   "    call ancopt(3) to perform a geometry optimization, then try to find other", &
   "    minimas by meta dynamics",&
   "",&
   "--path [FILE]",&
   "    use meta dynamics to calculate a path from the input geometry to the given", &
   "    product structure",&
   "",&
   "--modef INT",&
   "    modefollowing algorithm. INT specifies the mode that should be used for the", &
   "    modefollowing.",&
   "",&
   "-I, --input FILE",&
   "    use FILE as input source for xcontrol(7) instructions",&
   "",&
   "--namespace STRING",&
   "    give this xtb(1) run a namespace. All files, even temporary ones, will be named",&
   "    according to STRING (might not work everywhere).",&
   "",&
   "--[no]copy",&
   "    copies the xcontrol file at startup (default = true)",&
   "",&
   "--[no]restart",&
   "    restarts calculation from xtbrestart (default = true)",&
   "",&
   "-P, --parallel INT",&
   "    number of parallel processes",&
   "",&
   "--define",&
   "    performs automatic check of input and terminate",&
   "",&
   "--json",&
   "    write xtbout.json file",&
   "",&
   "--citation",&
   "    print citation and terminate",&
   "",&
   "--license",&
   "    print license and terminate",&
   "",&
   "-v, --verbose",&
   "    be more verbose (not supported in every unit)",&
   "",&
   "-s, --silent",&
   "    clutter the screen less (not supported in every unit)",&
   "",&
   "--ceasefiles",&
   "    reduce the amount of output and files written",&
   "",&
   "--strict",&
   "    turns all warnings into hard errors",&
   "",&
   "-h, --help",&
   "    show help page",&
   "",&
   "Useful Maschine Settings:",&
   "",&
   "export MKL_NUM_THREADS=<NCORE>",&
   "export OMP_NUM_THREADS=<NCORE>,1",&
   "export OMP_STACKSIZE=4G",&
   "ulimit -s unlimited",&
   "",&
   "Output Conventions:",&
   "",&
   "total energies are given in atomic units (Eh)",&
   "gaps/HL energies are given in eV",&
   "",&
   "More information can be obtained by `man 1 xtb` and `man 7 xcontrol`",&
   "or at https://xtb-docs.readthedocs.io/en/latest/contents.html",&
   ""
end subroutine help

subroutine help_legacy
   use, intrinsic :: iso_fortran_env, only : id => output_unit
   write(id,'(''Usage: xtb <geometry> [options]'',/)')

   write(id,'(''<geometry> may be provided as'','//&
   &    'x,''valid TM coordinate file (*coord in Bohr) or'','//&
   &    '/,''in xmol format (*xyz in Ångström).'',/)')

   write(id,'(''Options:'',/)')

   write(id,'(3x,''-c, --chrg <int>  '','// &
   &          'x,''Set charge to molecule'','//&
   &      '/,22x,''overrides charge in .CHRG file'')')

   write(id,'(3x,''-u, --uhf <int>   '','// &
   &          'x,''Number pf unpaired electrons or 2S'','//&
   &      '/,22x,''overrides setting in .UHF file'')')

   write(id,'(3x,''    --nox/--nodiff'','// &
   &          'x,''skip second, extended part in sTDA-xTB'')')

   write(id,'(3x,''    --pop         '','// &
   &          'x,''do population analysis'')')

   write(id,'(3x,''    --mowr <real> '','// &
   &          'x,''cut MO write above (default 3 Eh)'')')

   write(id,'(3x,''    --mold[en]    '','// &
   &          'x,''write formatted molden file'')')

   write(id,'(3x,''    --dip[ole]    '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --wbo         '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --lmo         '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --rdchrg      '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --md          '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --hessl       '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --optts       '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --ohessl      '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --mdopt       '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --path        '','// &
   &          'x,''deactivated feature'')')

   write(id,'(3x,''    --vip         '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --vea         '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --tm          '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --orca        '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --LS          '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --mopac       '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --qmdff       '','// &
   &          'x,''hidden feature'')')

   write(id,'(3x,''    --parx <file> '','// &
   &          'x,''read parameters for sTDA-xTB calculation'',' // &
   &      '/,22x,''(default: $XTBHOME/.param_stda2.xtb)'')')

   write(id,'(3x,''    --parv <file> '','// &
   &          'x,''read parameters for vTB part in sTDA-xTB'',' // &
   &      '/,22x,''(default: $XTBHOME/.param_stda1.xtb)'')')

   write(id,'(3x,''    --xtemp <real>'','// &
   &          'x,''electronic temperature for xTB (default 0 K)'')')

   write(id,'(3x,''    --etemp <real>'','// &
   &          'x,''electronic temperature for GFN (default 300 K)'')')

   write(id,'(3x,''    --fod         '','// &
   &          'x,''calculate the FOD and write molden.input file'','// &
   &      '/,22x,''with appropriate occupations for plotting'','// &
   &      '/,22x,''(defualt T = 12500 K)'')')

   write(id,'(3x,''    --gfn1        '','// &
   &          'x,''use GFN1-xTB parametrisation'')')

   write(id,'(3x,''    --gfn2        '','// &
   &          'x,''use GFN2-xTB parametrisation'')')

   write(id,'(3x,''    --gfn2d3      '','// &
   &          'x,''GFN2-xTB with D3 instead of D4 dispersion'')')

   write(id,'(3x,''    --scc         '','// &
   &          'x,''do single point only'')')

   write(id,'(3x,''    --grad        '','// &
   &          'x,''calculate GFNn-xTB gradient'')')

   write(id,'(3x,''    --acc <real>  '','// &
   &          'x,''GFNn-xTB accuracy (default 1.0)'')')

   write(id,'(3x,''    --opt [level] '','// &
   &          'x,''optimize at GFNn-xTB level, level can be one of'',' // &
   &      '/,22x,''crude, vloose, loose, tight, vtight, extreme'')')

   write(id,'(3x,''    --hess        '','// &
   &          'x,''compute Hessian at GFNn-xTB level'')')

   write(id,'(3x,''    --ohess       '','// &
   &          'x,''optimize and compute Hessian'')')

   write(id,'(3x,''    --omd         '','// &
   &          'x,''optimize and do MD'')')

   write(id,'(3x,''    --siman       '','// &
   &          'x,''conformational search'')')

   write(id,'(3x,''    --screen      '','// &
   &          'x,''opt. loop over ensemble'')')

   write(id,'(3x,''    --gmd         '','// &
   &          'x,''annealed MD for GMD procedure'')')

   write(id,'(3x,''    --modef       '','// &
   &          'x,''vibrational mode following'')')

   write(id,'(3x,''-g, --gbsa [solv] [state]'','// &
   &      '/,22x,''use GBSA implicit solvent for solvent [solv]'',' // &
   &      '/,22x,''and solvation state [state] = reference, bar1M'','// &
   &      '/,22x,''(default: bar1M)'')')

   write(id,'(3x,''    --help        '','// &
   &          'x,''show this message'')')

   write(id,'(/,''Useful Maschine Settings:'',/)')

   write(id,'(3x,''setenv MKL_NUM_THREADS <NCORE>'')')
   write(id,'(3x,''setenv OMP_STACKSIZE 500m'')')
   write(id,'(3x,''limit stacksize unlimited'')')

   write(id,'(/,''Output Conventions:'',/)')

   write(id,'(3x,''total energies are given in atomic units (Eh)'')')
   write(id,'(3x,''gaps/HL energies are given in eV'')')

   write(id,'(/,''Please read the manual carefully'',' // &
   &         'x,''(just kidding... there is no manual)'',/)')
end subroutine help_legacy

subroutine definebanner
   use, intrinsic :: iso_fortran_env, only : id => output_unit
   write(id,"(""           _"")")
   write(id,"(""          | |"")")
   write(id,"(""  _ __ ___| |_ _   _ _ __ _ __        __"")")
   write(id,"("" | '__/ _ \ __| | | | '__| '_ \      / _|"")")
   write(id,"("" | | |  __/ |_| |_| | |  | | | |___ | |_"")")
   write(id,"("" |_|  \___|\__|\__,_|_|  |_| |_/ _ \|  _|"")")
   write(id,"(""         _       __ _         | (_) | |"")")
   write(id,"(""        | |     / _(_)         \___/|_|"")")
   write(id,"(""      __| | ___| |_ _ _ __   ___"")")
   write(id,"(""     / _` |/ _ \  _| | '_ \ / _ \"")")
   write(id,"(""    | (_| |  __/ | | | | | |  __/"")")
   write(id,"(""     \__,_|\___|_| |_|_| |_|\___|"")")
end subroutine definebanner

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Core basis functions relevant for approximated effective core potential in PTB

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

module xtb_ptb_corebasis
#if WITH_TBLITE
   use mctc_env, only: wp
   use mctc_io, only: structure_type

   use xtb_ptb_data, only: TCorePotentialData
   use xtb_ptb_vdzp, only: new_basis

   use tblite_basis_type, only: cgto_type, basis_type
   use tblite_basis_slater, only: slater_to_gauss
   use tblite_integral_overlap, only: overlap_cgto, msao
   use tblite_blas, only: gemm

   implicit none
   private

   public :: add_core_basis, get_Vecp

   real(wp), parameter :: cutoff = 20.0_wp

contains

   subroutine get_Vecp(mol, ecpdata, bas, cbas, norm_s, vecp)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Effective core potential data
      type(TCorePotentialData), intent(in) :: ecpdata
      !> Basis set type and core basis set type
      type(basis_type), intent(in) :: bas, cbas
      !> Core-valence overlap matrix
      real(wp), intent(in) :: norm_s(:)
      !> Approximated effective core potential
      real(wp), allocatable, intent(out) :: vecp(:, :)
      !> Core-valence overlap matrix
      real(wp), allocatable :: overlap_cv(:, :)
      !> Intermediate core valence overlap matrix (scaled)
      real(wp), allocatable :: secptmp(:, :)
      !> tmp indices
      integer :: i, jat, jzp, js, jsh, jj, jao, jati, j

      logical, parameter :: debug(2) = [ .false., .false. ]

      !> Calculate the core-valence overlap matrix
      call core_valence_overlap(mol, bas, cbas, norm_s, overlap_cv)

      allocate (vecp(bas%nao, bas%nao), secptmp(cbas%nao, bas%nao), source=0.0_wp)
      !> SG: N^2 step
      do i = 1, bas%nao
         do jat = 1, mol%nat
            jzp = mol%id(jat)
            jati = mol%num(jzp)
            js = cbas%ish_at(jat)
            do jsh = 1, cbas%nsh_id(jzp) !> Iteration over core shells of atom jat
               jj = cbas%iao_sh(js + jsh)
               do jao = 1, msao(cbas%cgto(jsh, jat)%ang)

                  if (debug(1)) then !##### DEV WRITE #####
                     write (*, *) "jsh, hflev(jsh,jati), kecpepsilon(jati): ", jsh, ecpdata%hflev(jsh, jati), ecpdata%kecpepsilon(jati)
                     write (*, *) "overlap_cv(jj + jao, i): ", overlap_cv(jj + jao, i)
                     write (*, *) "jj + jao, i: ", jj + jao, i
                  endif

                  secptmp(jj + jao, i) = -ecpdata%hflev(jsh, jati) * overlap_cv(jj + jao, i) * &
                     & ecpdata%kecpepsilon(jati)
               end do
            end do
         end do
      end do

      if (debug(2)) then !##### DEV WRITE #####
         write (*, *) "Overlap_CV_scaled:"
         do i = 1, bas%nao
            do j = 1, cbas%nao
               write (*, '(f10.6)', advance="no") secptmp(j, i)
            end do
            write (*, *) ""
         end do
      endif

      !> SG: N^3 step
      call gemm(overlap_cv, secptmp, vecp, 'T', 'N')

   end subroutine get_Vecp

   subroutine core_valence_overlap(mol, bas, cbas, bas_overlap_norm, cv_overlap)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set type
      type(basis_type), intent(in) :: bas, cbas
      !> Core-valence overlap matrix
      real(wp), allocatable, intent(out) :: cv_overlap(:, :)
      !> Normalization factors for valence basis functions
      real(wp), intent(in) :: bas_overlap_norm(:)

      integer :: iat, jat, izp, jzp, is, js, maxl
      integer :: ish, jsh, ii, jj, iao, jao, nao
      real(wp) :: r2, vec(3), cutoff2

      integer :: i, j

      real(wp), allocatable :: stmp(:)

      logical, parameter :: debug(2) = [ .false., .false. ]

      cutoff2 = cutoff**2

      maxl = max(bas%maxl, cbas%maxl)

      allocate (cv_overlap(cbas%nao, bas%nao), stmp(msao(maxl)**2), source=0.0_wp)

      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         do jat = 1, mol%nat
            jzp = mol%id(jat)
            js = cbas%ish_at(jat)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            if (r2 > cutoff2) cycle
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is + ish)
               do jsh = 1, cbas%nsh_id(jzp)
                  jj = cbas%iao_sh(js + jsh)
                  call overlap_cgto(cbas%cgto(jsh, jat), bas%cgto(ish, iat), &
                     & r2, vec, bas%intcut, stmp)

                  nao = msao(cbas%cgto(jsh, jat)%ang)
                  do iao = 1, msao(bas%cgto(ish, iat)%ang)
                     do jao = 1, msao(cbas%cgto(jsh, jat)%ang)
                        cv_overlap(jj + jao, ii + iao) = cv_overlap(jj + jao, ii + iao) &
                           & + stmp(jao + nao * (iao - 1))
                     end do
                  end do

               end do
            end do

         end do
      end do

      if (debug(1)) then !##### DEV WRITE #####
         write (*, *) "Core-valence overlap matrix:"
         write (*, *) "core basis NAOs: ", cbas%nao
         write (*, *) "valence basis NAOs: ", bas%nao
      endif

      do i = 1, bas%nao
         do j = 1, cbas%nao
            cv_overlap(j, i) = cv_overlap(j, i) * bas_overlap_norm(i)
            
            if(debug(2)) & !##### DEV WRITE #####
               write (*, '(f10.6)', advance="no") cv_overlap(j, i)
         
         end do

         if(debug(2)) & !##### DEV WRITE #####
            write (*, *) ""

      end do

   end subroutine core_valence_overlap

   subroutine add_core_basis(mol, ecpdata, cbas)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Effective core potential PTB parameters
      type(TCorePotentialData), intent(in) :: ecpdata
      !> Basis set type
      type(basis_type), intent(out) :: cbas

      integer :: isp, izp, ish, stat, il, iat
      integer, allocatable :: nsh_id(:)
      type(cgto_type), allocatable :: cgto(:, :)

      !> debug mode
      logical, parameter :: debug(4) = [ .false., .false., .false., .false. ]
      integer :: j, k

      nsh_id = ecpdata%nshell(mol%num)
      allocate (cgto(maxval(nsh_id), mol%nat))
      do iat = 1, mol%nat
         isp = mol%id(iat)
         izp = mol%num(isp)

         if (debug(1)) & !##### DEV WRITE #####
            write (*, *) "number of shells: ", nsh_id(isp)
         
         do ish = 1, nsh_id(isp)
            il = ecpdata%angshell(ish, izp)

            if (debug(2)) then !##### DEV WRITE #####
               write (*, *) "shell: ", ish
               write (*, *) "number of primitives: ", ecpdata%max_prim
               write (*, *) "shell type: ", ecpdata%pqn(ish, izp), ecpdata%angshell(ish, izp), ecpdata%sl_exp(ish, izp)
            endif

            call slater_to_gauss(ecpdata%max_prim, ecpdata%pqn(ish, izp), il, &
            & ecpdata%sl_exp(ish, izp), cgto(ish, iat), .true., stat)

            if (debug(3)) then !##### DEV WRITE #####
               write (*, *) "N_prim: ", cgto(ish, iat)%nprim
               do k = 1, cgto(ish, iat)%nprim
                  write (*, *) cgto(ish, iat)%alpha(k)
               end do
            endif
         end do

      end do

      if(debug(4)) then !##### DEV WRITE #####
         write (*, *) "---------FINAL PTB core basis-----------"
         do iat = 1, mol%nat
            isp = mol%id(iat)
            write (*, *) "Atom :", mol%num(isp)
            write (*, *) "Number of shells :", nsh_id(isp)
            do j = 1, nsh_id(isp)
               write (*, *) "N_prim: ", cgto(j, iat)%nprim
               write (*, *) "Exponents:"
               write (*, *) cgto(j, iat)%alpha
               write (*, *) "Coefficients:"
               write (*, *) cgto(j, iat)%coeff
            end do
         end do
         write (*, *) "----------------------------------------"
      endif

      call new_basis(cbas, mol, nsh_id, cgto, 1.0_wp)

   end subroutine add_core_basis

#endif
end module xtb_ptb_corebasis

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of DFT-D3 with Becke-Johnson damping
module xtb_disp_dftd3
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_la, only : contract
   use xtb_disp_dftd3param
   use xtb_param_sqrtzr4r2, only : sqrtZr4r2
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   implicit none
   private

   public :: d3_gradient, d3_atm_gradient


   interface d3_gradient
      module procedure :: d3_full_gradient_neigh
      module procedure :: d3_full_gradient_latp
      module procedure :: d3_gradient_neigh
      module procedure :: d3_gradient_latp
   end interface d3_gradient


   interface d3_atm_gradient
      module procedure :: d3_atm_gradient_neigh
      module procedure :: d3_atm_gradient_latp
   end interface d3_atm_gradient


contains


!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references(nat, atoms, wf, cn, gwvec, gwdcn)

   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat

   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> weighting for the atomic reference systems
   real(wp), intent(out) :: gwvec(:, :)

   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(out) :: gwdcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, gw, expw, expd, gwk, dgwk

   gwvec = 0.0_wp
   gwdcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      norm = 0.0_wp
      dnorm = 0.0_wp
      do iref = 1, number_of_references(ati)
         gw = weight_cn(wf, cn(iat), reference_cn(iref, ati))
         norm = norm + gw
         dnorm = dnorm + 2*wf*(reference_cn(iref, ati) - cn(iat)) * gw
      end do
      norm = 1.0_wp / norm
      do iref = 1, number_of_references(ati)
         expw = weight_cn(wf, cn(iat), reference_cn(iref, ati))
         expd = 2*wf*(reference_cn(iref, ati) - cn(iat)) * expw

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(reference_cn(:number_of_references(ati), ati)) &
               & == reference_cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         gwvec(iref, iat) = gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         gwdcn(iref, iat) = dgwk

      end do
   end do

end subroutine weight_references


!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6(nat, atoms, gwvec, gwdcn, c6, dc6dcn)
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting function for the atomic reference systems
   real(wp), intent(in) :: gwvec(:, :)
   !> derivative of the weighting function w.r.t. the coordination number
   real(wp), intent(in) :: gwdcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj

   c6 = 0.0_wp
   dc6dcn = 0.0_wp

   do iat = 1, nat
      ati = atoms(iat)
      do jat = 1, iat
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         do iref = 1, number_of_references(ati)
            do jref = 1, number_of_references(atj)
               refc6 = get_c6(iref, jref, ati, atj)
               dc6 = dc6 + gwvec(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcni = dc6dcni + gwdcn(iref, iat) * gwvec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + gwvec(iref, iat) * gwdcn(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
      end do
   end do
end subroutine get_atomic_c6


subroutine d3_full_gradient_latp &
      & (mol, trans, par, weighting_factor, cutoff, cutoff3, &
      &  cn, dcndr, dcndL, energy, gradient, sigma, e2, e3)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: cutoff3
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(out), optional :: e2
   real(wp), intent(out), optional :: e3

   integer :: nat, max_ref
   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(number_of_references(mol%at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      & dc6dcn(nat, nat), energies(nat), energies3(nat), &
      & dEdcn(nat), source=0.0_wp)

   call weight_references(nat, mol%at, weighting_factor, cn, gw, dgwdcn)

   call get_atomic_c6(nat, mol%at, gw, dgwdcn, c6, dc6dcn)

   call disp_gradient_latp(mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   if (present(e2)) e2 = sum(energies)
   if (par%s9 /= 0.0_wp) then
      call atm_gradient_latp(mol, trans, cutoff3, par, sqrtZr4r2, c6, dc6dcn, &
         &  energies3, gradient, sigma, dEdcn)
   end if
   if (present(e3)) e3 = sum(energies3)

   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies) + sum(energies3)

end subroutine d3_full_gradient_latp


subroutine d3_gradient_latp &
      & (mol, trans, par, weighting_factor, cutoff, &
      &  cn, dcndr, dcndL, energy, gradient, sigma)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref
   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(number_of_references(mol%at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      &     dc6dcn(nat, nat), energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references(nat, mol%at, weighting_factor, cn, gw, dgwdcn)

   call get_atomic_c6(nat, mol%at, gw, dgwdcn, c6, dc6dcn)

   call disp_gradient_latp(mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies)

end subroutine d3_gradient_latp


!> Implementation of the pairwise dispersion energy
subroutine disp_gradient_latp &
      & (mol, trans, cutoff, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, ati, atj, itr

   real(wp) :: cutoff2
   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   cutoff2 = cutoff**2
   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, sigma, dEdcn) &
   !$omp shared(mol, trans, cutoff2, par, r4r2, c6, dc6dcn) &
   !$omp private(iat, jat, itr, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG, dS)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do jat = 1, iat
         atj = mol%at(jat)
         r4r2ij = 3*r4r2(ati)*r4r2(atj)
         r0 = par%a1*sqrt(r4r2ij) + par%a2
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-10_wp) cycle


            t6 = 1._wp/(r2**3+r0**6)
            t8 = 1._wp/(r2**4+r0**8)
            t10 = 1._wp/(r2**5+r0**10)

            d6 = -6*r2**2*t6**2
            d8 = -8*r2**3*t8**2
            d10 = -10*r2**4*t10**2

            disp = par%s6*t6 + par%s8*r4r2ij*t8 &
               &  + par%s10*49.0_wp/40.0_wp*r4r2ij**2*t10
            ddisp= par%s6*d6 + par%s8*r4r2ij*d8 &
               & + par%s10*49.0_wp/40.0_wp*r4r2ij**2*d10

            dE = -c6(iat, jat)*disp * 0.5_wp
            dG = -c6(iat, jat)*ddisp*rij
            dS = spread(dG, 1, 3) * spread(rij, 2, 3) * 0.5_wp

            energies(iat) = energies(iat) + dE
            dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
            sigma = sigma + dS
            if (iat /= jat) then
               energies(jat) = energies(jat) + dE
               dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma = sigma + dS
            end if

         end do
      end do
   end do
   !$omp end parallel do

end subroutine disp_gradient_latp


subroutine d3_atm_gradient_latp &
      & (mol, trans, par, weighting_factor, cutoff, &
      &  cn, dcndr, dcndL, energy, gradient, sigma)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref
   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(number_of_references(mol%at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      &     dc6dcn(nat, nat), energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references(nat, mol%at, weighting_factor, cn, gw, dgwdcn)

   call get_atomic_c6(nat, mol%at, gw, dgwdcn, c6, dc6dcn)

   call atm_gradient_latp(mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies)

end subroutine d3_atm_gradient_latp


subroutine atm_gradient_latp &
      & (mol, trans, cutoff, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, kat, ati, atj, atk, jtr, ktr
   real(wp) :: cutoff2
   real(wp) :: rij(3), rjk(3), rik(3), r2ij, r2jk, r2ik
   real(wp) :: c6ij, c6jk, c6ik, cij, cjk, cik, scale
   real(wp) :: dE, dG(3, 3), dS(3, 3), dCN(3)
   real(wp), parameter :: sr = 4.0_wp/3.0_wp

   cutoff2 = cutoff**2

   do iat = 1, len(mol)
      ati = mol%at(iat)
      do jat = 1, iat
         atj = mol%at(jat)

         c6ij = c6(jat,iat)
         !cij = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atj))+par%a2
         cij = sr*get_vdwrad(ati, atj)

         do kat = 1, jat
            atk = mol%at(kat)

            c6ik = c6(kat,iat)
            c6jk = c6(kat,jat)

            !cik = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atk))+par%a2
            cik = sr*get_vdwrad(ati, atk)
            !cjk = par%a1*sqrt(3.0_wp*r4r2(atj)*r4r2(atk))+par%a2
            cjk = sr*get_vdwrad(atj, atk)

            do jtr = 1, size(trans, dim=2)
               rij = mol%xyz(:, jat) - mol%xyz(:, iat) + trans(:, jtr)
               r2ij = sum(rij**2)
               if (r2ij > cutoff2 .or. r2ij < 1.0e-14_wp) cycle
               do ktr = 1, size(trans, dim=2)
                  if (jat == kat .and. jtr == ktr) cycle
                  rik = mol%xyz(:, kat) - mol%xyz(:, iat) + trans(:, ktr)
                  r2ik = sum(rik**2)
                  if (r2ik > cutoff2 .or. r2ik < 1.0e-14_wp) cycle
                  rjk = mol%xyz(:, kat) - mol%xyz(:, jat) + trans(:, ktr) &
                     & - trans(:, jtr)
                  r2jk = sum(rjk**2)
                  if (r2jk > cutoff2 .or. r2jk < 1.0e-14_wp) cycle

                  call deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
                     & r2ij, r2jk, r2ik, dc6dcn(iat,jat), dc6dcn(jat,iat), &
                     & dc6dcn(jat,kat), dc6dcn(kat,jat), dc6dcn(iat,kat), &
                     & dc6dcn(kat,iat), rij, rjk, rik, par%alp, dE, dG, dS, dCN)

                  scale = par%s9 * triple_scale(iat, jat, kat)
                  energies(iat) = energies(iat) + dE * scale/3
                  energies(jat) = energies(jat) + dE * scale/3
                  energies(kat) = energies(kat) + dE * scale/3
                  gradient(:, iat) = gradient(:, iat) + dG(:, 1) * scale
                  gradient(:, jat) = gradient(:, jat) + dG(:, 2) * scale
                  gradient(:, kat) = gradient(:, kat) + dG(:, 3) * scale
                  sigma(:, :) = sigma + dS * scale
                  dEdcn(iat) = dEdcn(iat) + dCN(1) * scale
                  dEdcn(jat) = dEdcn(jat) + dCN(2) * scale
                  dEdcn(kat) = dEdcn(kat) + dCN(3) * scale

               end do
            end do

         end do
      end do
   end do

end subroutine atm_gradient_latp


subroutine d3_full_gradient_neigh &
      & (mol, neighs, neighs3, neighlist, par, weighting_factor, &
      &  cn, dcndr, dcndL, energy, gradient, sigma, e2, e3)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Neighbour list
   type(TNeighbourList), intent(in) :: neighlist

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   integer, intent(in) :: neighs(:)
   integer, intent(in) :: neighs3(:)
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(out), optional :: e2
   real(wp), intent(out), optional :: e3

   integer :: nat, max_ref
   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(number_of_references(mol%at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      & dc6dcn(nat, nat), energies(nat), energies3(nat), &
      & dEdcn(nat), source=0.0_wp)

   call weight_references(nat, mol%at, weighting_factor, cn, gw, dgwdcn)

   call get_atomic_c6(nat, mol%at, gw, dgwdcn, c6, dc6dcn)

   call disp_gradient_neigh(mol, neighs, neighlist, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   if (present(e2)) e2 = sum(energies)
   if (par%s9 /= 0.0_wp) then
      call atm_gradient_neigh(mol, neighs, neighlist, par, sqrtZr4r2, c6, dc6dcn, &
         & energies3, gradient, sigma, dEdcn)
   end if
   if (present(e3)) e3 = sum(energies3)

   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies) + sum(energies3)

end subroutine d3_full_gradient_neigh


subroutine d3_gradient_neigh &
      & (mol, neighs, neighlist, par, weighting_factor, &
      &  cn, dcndr, dcndL, energy, gradient, sigma)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Neighbour list
   type(TNeighbourList), intent(in) :: neighlist

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   integer, intent(in) :: neighs(:)
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref
   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(number_of_references(mol%at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      &     dc6dcn(nat, nat), energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references(nat, mol%at, weighting_factor, cn, gw, dgwdcn)

   call get_atomic_c6(nat, mol%at, gw, dgwdcn, c6, dc6dcn)

   call disp_gradient_neigh(mol, neighs, neighlist, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies)

end subroutine d3_gradient_neigh


subroutine disp_gradient_neigh &
      & (mol, neighs, neighlist, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Neighbour list
   type(TNeighbourList), intent(in) :: neighlist

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   integer, intent(in) :: neighs(:)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, ati, atj, ij, img
   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, sigma, dEdcn) &
   !$omp shared(mol, neighs, neighlist, par, r4r2, c6, dc6dcn) &
   !$omp private(ij, img, jat, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG, dS)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do ij = 1, neighs(iat)
         img = neighlist%ineigh(ij, iat)
         r2 = neighlist%dist2(ij, iat)
         rij = mol%xyz(:, iat) - neighlist%coords(:, img)
         jat = neighlist%image(img)
         atj = mol%at(jat)

         r4r2ij = 3*r4r2(ati)*r4r2(atj)
         r0 = par%a1*sqrt(r4r2ij) + par%a2

         t6 = 1._wp/(r2**3+r0**6)
         t8 = 1._wp/(r2**4+r0**8)
         t10 = 1._wp/(r2**5+r0**10)

         d6 = -6*r2**2*t6**2
         d8 = -8*r2**3*t8**2
         d10 = -10*r2**4*t10**2

         disp = par%s6*t6 + par%s8*r4r2ij*t8 &
            &  + par%s10*49.0_wp/40.0_wp*r4r2ij**2*t10
         ddisp= par%s6*d6 + par%s8*r4r2ij*d8 &
            & + par%s10*49.0_wp/40.0_wp*r4r2ij**2*d10

         dE = -c6(iat, jat)*disp * 0.5_wp
         dG = -c6(iat, jat)*ddisp*rij
         dS = spread(dG, 1, 3) * spread(rij, 2, 3) * 0.5_wp

         energies(iat) = energies(iat) + dE
         dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
         sigma = sigma + dS
         if (iat /= jat) then
            energies(jat) = energies(jat) + dE
            dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
            gradient(:, iat) = gradient(:, iat) + dG
            gradient(:, jat) = gradient(:, jat) - dG
            sigma = sigma + dS
         endif

      enddo
   enddo
   !$omp end parallel do

end subroutine disp_gradient_neigh


subroutine d3_atm_gradient_neigh &
      & (mol, neighs, neighlist, par, weighting_factor, &
      &  cn, dcndr, dcndL, energy, gradient, sigma)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Neighbour list
   type(TNeighbourList), intent(in) :: neighlist

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   integer, intent(in) :: neighs(:)
   real(wp), intent(in) :: weighting_factor
   real(wp), intent(in) :: cn(:)
   real(wp), intent(in) :: dcndr(:, :, :)
   real(wp), intent(in) :: dcndL(:, :, :)

   real(wp), intent(inout) :: energy
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref
   integer :: iat, jat, ati, atj, ij, img

   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   real(wp), allocatable :: gw(:, :), dgwdcn(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(number_of_references(mol%at))
   allocate(gw(max_ref, nat), dgwdcn(max_ref, nat), c6(nat, nat), &
      &     dc6dcn(nat, nat), energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references(nat, mol%at, weighting_factor, cn, gw, dgwdcn)

   call get_atomic_c6(nat, mol%at, gw, dgwdcn, c6, dc6dcn)

   call atm_gradient_neigh(mol, neighs, neighlist, par, sqrtZr4r2, c6, dc6dcn, &
      & energies, gradient, sigma, dEdcn)

   call contract(dcndr, dEdcn, gradient, beta=1.0_wp)
   call contract(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies)

end subroutine d3_atm_gradient_neigh


subroutine atm_gradient_neigh &
      & (mol, neighs, neighlist, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Neighbour list
   type(TNeighbourList), intent(in) :: neighlist

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   integer, intent(in) :: neighs(:)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, kat, ati, atj, atk, jtr, ktr, ij, jk, ik
   real(wp) :: rij(3), rjk(3), rik(3), r2ij, r2jk, r2ik
   real(wp) :: c6ij, c6jk, c6ik, cij, cjk, cik, scale
   real(wp) :: dE, dG(3, 3), dS(3, 3), dCN(3)
   real(wp), parameter :: sr = 4.0_wp/3.0_wp

   do iat = 1, len(mol)
      ati = mol%at(iat)
      do ij = 1, neighs(iat)
         jtr = neighlist%ineigh(ij, iat)
         r2ij = neighlist%dist2(ij, iat)
         rij = neighlist%coords(:, jtr) - neighlist%coords(:, iat)
         jat = neighlist%image(jtr)
         atj = mol%at(jat)

         c6ij = c6(jat,iat)
         !cij = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atj))+par%a2
         cij = sr*get_vdwrad(ati, atj)

         do ik = 1, ij-1
            ktr = neighlist%ineigh(ik, iat)
            rik = neighlist%coords(:, ktr) - neighlist%coords(:, iat)
            r2ik = neighlist%dist2(ik, iat)
            rjk = neighlist%coords(:, ktr) - neighlist%coords(:, jtr)
            r2jk = sum(rjk**2)
            kat = neighlist%image(ktr)
            atk = mol%at(kat)

            c6ik = c6(kat,iat)
            c6jk = c6(kat,jat)

            !cik = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atk))+par%a2
            cik = sr*get_vdwrad(ati, atk)
            !cjk = par%a1*sqrt(3.0_wp*r4r2(atj)*r4r2(atk))+par%a2
            cjk = sr*get_vdwrad(atj, atk)

            call deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
               & r2ij, r2jk, r2ik, dc6dcn(iat,jat), dc6dcn(jat,iat), &
               & dc6dcn(jat,kat), dc6dcn(kat,jat), dc6dcn(iat,kat), &
               & dc6dcn(kat,iat), rij, rjk, rik, par%alp, dE, dG, dS, dCN)

            scale = par%s9 * triple_scale(iat, jat, kat)
            energies(iat) = energies(iat) + dE * scale/3
            energies(jat) = energies(jat) + dE * scale/3
            energies(kat) = energies(kat) + dE * scale/3
            gradient(:, iat) = gradient(:, iat) + dG(:, 1) * scale
            gradient(:, jat) = gradient(:, jat) + dG(:, 2) * scale
            gradient(:, kat) = gradient(:, kat) + dG(:, 3) * scale
            sigma(:, :) = sigma + dS * scale
            dEdcn(iat) = dEdcn(iat) + dCN(1) * scale
            dEdcn(jat) = dEdcn(jat) + dCN(2) * scale
            dEdcn(kat) = dEdcn(kat) + dCN(3) * scale

         end do
      end do
   end do

end subroutine atm_gradient_neigh


pure subroutine deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
      & r2ij, r2jk, r2ik, dc6ij, dc6ji, dc6jk, dc6kj, dc6ik, dc6ki, &
      & rij, rjk, rik, alp, dE, dG, dS, dCN)

   real(wp), intent(in) :: c6ij, c6ik, c6jk
   real(wp), intent(in) :: cij, cjk, cik
   real(wp), intent(in) :: r2ij, r2jk, r2ik
   real(wp), intent(in) :: dc6ij, dc6ji, dc6jk, dc6kj, dc6ik, dc6ki
   real(wp), intent(in) :: rij(3), rjk(3), rik(3)
   integer, intent(in) :: alp
   real(wp), intent(out) :: dE, dG(3, 3), dS(3, 3), dCN(3)

   real(wp) :: c9, dc9, ccc1, rrr1, rrr2, rrr3, ang, dang, fdmp, dfdmp, dGr, cr

   c9 = -sqrt(c6ij*c6ik*c6jk)

   ccc1 = cij*cjk*cik

   rrr2 = r2ij*r2jk*r2ik
   rrr1 = sqrt(rrr2)
   rrr3 = rrr1*rrr2

   ang = 0.375_wp * (r2ij+r2jk-r2ik)*(r2ij-r2jk+r2ik)*(-r2ij+r2jk+r2ik) &
      & / (rrr3*rrr2) + 1.0_wp/(rrr3)

   cr = (ccc1/rrr1)**(1.0_wp/3.0_wp)
   fdmp = 1.0_wp/(1.0_wp + 6.0_wp*cr**alp)
   dfdmp = -(2.0_wp*alp*cr**alp) * fdmp**2

   ! Energy contribution
   dE = -fdmp*ang*c9

   ! Derivative w.r.t. i-j distance
   dang = -0.375_wp*(r2ij**3+r2ij**2*(r2jk+r2ik) &
      & +r2ij*(3.0_wp*r2jk**2+2.0_wp*r2jk*r2ik+3.0_wp*r2ik**2) &
      & -5.0_wp*(r2jk-r2ik)**2*(r2jk+r2ik)) / (rrr3*rrr2)
   dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2ij
   dG(:, 1) = -dGr * rij
   dG(:, 2) = +dGr * rij 
   dS(:, :) = 0.5_wp * dGr * spread(rij, 1, 3) * spread(rij, 2, 3)

   ! Derivative w.r.t. i-k distance
   dang = -0.375_wp*(r2ik**3+r2ik**2*(r2jk+r2ij) &
      & +r2ik*(3.0_wp*r2jk**2+2.0*r2jk*r2ij+3.0_wp*r2ij**2) &
      & -5.0_wp*(r2jk-r2ij)**2*(r2jk+r2ij)) / (rrr3*rrr2)
   dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2ik
   dG(:, 1) = -dGr * rik + dG(:, 1)
   dG(:, 3) = +dGr * rik 
   dS(:, :) = 0.5_wp * dGr * spread(rik, 1, 3) * spread(rik, 2, 3) + dS

   ! Derivative w.r.t. j-k distance
   dang=-0.375_wp*(r2jk**3+r2jk**2*(r2ik+r2ij) &
      & +r2jk*(3.0_wp*r2ik**2+2.0_wp*r2ik*r2ij+3.0_wp*r2ij**2) &
      & -5.0_wp*(r2ik-r2ij)**2*(r2ik+r2ij)) / (rrr3*rrr2)
   dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2jk
   dG(:, 2) = -dGr * rjk + dG(:, 2)
   dG(:, 3) = +dGr * rjk + dG(:, 3)
   dS(:, :) = 0.5_wp * dGr * spread(rjk, 1, 3) * spread(rjk, 2, 3) + dS

   ! CN derivative
   dc9 = 0.5_wp*c9*(dc6ij/c6ij+dc6ik/c6ik)
   dCN(1) = -ang*fdmp*dc9
   dc9 = 0.5_wp*c9*(dc6ji/c6ij+dc6jk/c6jk)
   dCN(2) = -ang*fdmp*dc9
   dc9 = 0.5_wp*c9*(dc6ki/c6ik+dc6kj/c6jk)
   dCN(3) = -ang*fdmp*dc9

end subroutine deriv_atm_triple


elemental function weight_cn(wf,cn,cnref) result(cngw)
   real(wp),intent(in) :: wf, cn, cnref
   real(wp) :: cngw
   intrinsic :: exp
   cngw = exp ( -wf * ( cn - cnref )**2 )
end function weight_cn


!> Correct counting of energy contributions for atomic pairs.
elemental function pair_scale(iat, jat) result(scale)

   !> Atom indices
   integer, intent(in) :: iat, jat

   !> Fraction of energy
   real(wp) :: scale

   if (iat == jat) then
      scale = 0.5_wp
   else
      scale = 1.0_wp
   endif

end function pair_scale


!> Logic exercise to distribute a triple energy to atomwise energies.
elemental function triple_scale(ii, jj, kk) result(scale)

   !> Atom indices
   integer, intent(in) :: ii, jj, kk

   !> Fraction of energy
   real(wp) :: scale

   if (ii == jj) then
      if (ii == kk) then
         ! ii'i" -> 1/6
         scale = 1.0_wp/6.0_wp
      else
         ! ii'j -> 1/2
         scale = 0.5_wp
      end if
   else
      if (ii /= kk .and. jj /= kk) then
         ! ijk -> 1 (full)
         scale = 1.0_wp
      else
         ! ijj' and iji' -> 1/2
         scale = 0.5_wp
      end if
   end if

end function triple_scale


end module xtb_disp_dftd3

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_readin
   
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_strings, only : value
   use xtb_type_environment, only : TEnvironment
   implicit none

   character,private,parameter :: flag = '$'
   character,private,parameter :: space = ' '
   character,private,parameter :: equal = '='
   character,private,parameter :: hash = '#'
   character,private,parameter :: dot = '.'
   character,private,parameter :: comma = ','
   character,private,parameter :: minus = '-'
   character(len=*),private,parameter :: flag_end = '$end'

!! ------------------------------------------------------------------[SAW]-
!  this function returns a logical and is always evaluated for its
!  side effect (parsing the given string for its real/int/bool value)
   interface getValue
      module procedure getIntValue
      module procedure getIntArray
      module procedure getRealValue
      module procedure getRealArray
      module procedure getBoolValue
   end interface getValue

contains

!! ------------------------------------------------------------------[SAW]-
!  I could use rdpath directly, but this would require access to xpath,
!  so I use xfind as a wrapper with access to the xpath variable to
!  circumvent this. Also as a gimmick, I do not return a logical, but
!  some file name. xfind succeeds if fname.ne.name, but if you inquire
!  for fname in case of failure, you might hit a local file, which you
!  than can read. This is intended as a feature (just saying).
function xfind(name) result(fname)
   use xtb_mctc_systools, only : rdpath
   use xtb_setparam, only : xenv
   character(len=*),intent(in)  :: name
   character(len=:),allocatable :: fname
   character(len=:),allocatable :: dum
   logical :: exist

   call rdpath(xenv%path,name,dum,exist)
   if (exist) then
      fname = dum
   else
      fname = name
   endif

end function xfind

!! ------------------------------------------------------------------[SAW]-
!>  wrapper around getline from the MCTC lib that strips comments
!>  automatically und removes all leading and trailing whitespace
subroutine strip_line(in,line,err)
   
   use xtb_mctc_systools, only : getline
   implicit none
   integer,intent(in)  :: in
      !! input file unit
   character(len=:),allocatable,intent(out) :: line
      !! output line
   integer,intent(out) :: err
   integer :: ic

   call getline(in,line,iostat=err)
   if (err.ne.0) return
   
   !> check for comment characters
   ic = index(line,hash)
   if (ic.eq.1) then
      line = ''
      return
   else if (ic.gt.1) then
      line = line(:ic-1)
   endif
   !> to remove all leading and trailing whitespaces
   line = trim(adjustl(line))

end subroutine strip_line

!! ------------------------------------------------------------------[SAW]-
!  same as strip_line, but has the additional function of copying to
!  one unit while reading from another, which is helpful for backing up
!  files you plan to replace in the next step of you program.
!  Funnily this subroutine exist way before strip_line...
subroutine mirror_line(in,out,line,err)
   
   use xtb_mctc_systools, only : getline
   implicit none
   
   integer,intent(in)  :: in
   integer,intent(in)  :: out
   character(len=:),allocatable,intent(out) :: line
   integer,intent(out) :: err
   
   integer :: ic

   call getline(in,line,iostat=err)
      !! returns the line from input file 
   if (err.ne.0) return
      !! iostat=-1 will return err=0
!  now write the line to the copy, we write what we read, not what we see
!  if (out.ne.-1) write(out,'(a)') trim(line)
   
   !> Check for comment characters
   ic = index(line,hash)
   if (ic.eq.1) then
      line = ''
      return
   else if (ic.gt.1) then
      line = line(:ic-1)
   endif
!  now write the line to the copy, we write what we see, not what we read
   if (out.ne.-1) write(out,'(a)') trim(line)
!  strip line from space, but after printing
   line = trim(adjustl(line))

end subroutine mirror_line

function find_new_name(fname) result(newname)
   character(len=*),intent(in)  :: fname
   character(len=:),allocatable :: newname
   character(len=5) :: dum ! five digit number must be enough
   character,parameter :: hash = '#'
   character,parameter :: dot = '.'
   integer :: i,idot
   logical :: exist

   idot = index(fname,dot)
   i = 0
   do
      i = i+1
      write(dum,'(i0)') i
      if (idot == 1) then
         newname = dot//hash//trim(dum)//fname
      else
         newname = hash//trim(dum)//dot//fname
      endif
      inquire(file=newname,exist=exist)
      if (.not.exist) return
   enddo

end function find_new_name

function getIntValue(env,val,dum) result(status)
   implicit none
   character(len=*), parameter :: source = 'readin_getIntValue'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   integer,intent(out) :: dum
   integer :: err
   logical :: status
   
!  call value(val,dum,ios=err)
   read(val,*,iostat=err) dum
   if (err.eq.0) then
      status = .true.
   else
      call env%warning('could not parse '''//val//'''',source)
      status = .false.
   endif
end function getIntValue

function getRealValue(env,val,dum) result(status)
   implicit none
   character(len=*), parameter :: source = 'readin_getRealValue'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   real(wp),intent(out) :: dum
   integer :: err
   logical :: status
   
!  call value(val,dum,ios=err)
   read(val,*,iostat=err) dum
   if (err.eq.0) then
      status = .true.
   else
      call env%warning('could not parse '''//val//'''',source)
      status = .false.
   endif
end function getRealValue

function getBoolValue(env,val,dum) result(status)
   implicit none
   character(len=*), parameter :: source = 'readin_getBoolValue'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   logical,intent(out) :: dum
   logical :: status
   
   select case(val)
   case('Y','y','Yes','yes','T','t','true','True','1')
      status = .true.
      dum = .true.
   case('N','n','No','no','F','f','false','False','0')
      status = .true.
      dum = .false.
   case default
      call env%warning('could not parse '''//val//'''',source)
      status = .false.
   end select

end function getBoolValue

function getIntArray(env,val,dum) result(status)
   implicit none
   character(len=*), parameter :: source = 'readin_getIntArray'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   integer,intent(out) :: dum(:)
   integer :: i,err
   logical :: status
  
!  call value(val,dum,ios=err)
   read(val,*,iostat=err) (dum(i),i=1,size(dum,1))
   if (err.eq.0) then
      status = .true.
   else
      call env%warning('could not parse '''//val//'''',source)
      status = .false.
   endif

end function getIntArray

function getRealArray(env,val,dum) result(status)
   implicit none
   character(len=*), parameter :: source = 'readin_getRealArray'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   real(wp),intent(out) :: dum(:)
   integer :: i,err
   logical :: status
  
!  call value(val,dum,ios=err)
   read(val,*,iostat=err) (dum(i),i=1,size(dum,1))
   if (err.eq.0) then
      status = .true.
   else
      call env%warning('could not parse '''//val//'''',source)
      status = .false.
   endif

end function getRealArray

pure elemental function bool2int(bool) result(int)
   logical,intent(in) :: bool
   integer :: int
   if (bool) then
      int = 1
   else
      int = 0
   endif
end function bool2int

pure function bool2string(bool) result(string)
   logical,intent(in) :: bool
   character(len=:),allocatable :: string
   if (bool) then
      string = 'true'
   else
      string = 'false'
   endif
end function bool2string

function getListValue(env,val,dum,n) result(status)
   implicit none
   character(len=*), parameter :: source = 'readin_getListValue'
   type(TEnvironment), intent(inout) :: env
   character(len=*),intent(in) :: val
   integer,intent(out) :: dum(:)
   integer,intent(out) :: n
   integer :: i,j,k,l,err
   logical :: status
  
   i = index(val,minus)
   if (i.eq.0) then
      read(val,*,iostat=err) dum(1)
      if (err.ne.0) then
         call env%warning('could not parse '''//val//'''',source)
         status = .false.
         return
      endif
      n = 1
      status = .true.
   else
      read(val(:i-1),*,iostat=err) j
      if (err.ne.0) then
         call env%warning('could not parse '''//val(:i-1)//''' in '''//val//'''',source)
         status = .false.
         return
      endif
      read(val(i+1:),*,iostat=err) k
      if (err.ne.0) then
         call env%warning('could not parse '''//val(i+1:)//''' in '''//val//'''',source)
         status = .false.
         return
      endif
      if (k.lt.j) then
         call env%warning('end is lower than start in list '''//val//'''',source)
         status = .false.
         return
      endif
      if ((k-j).gt.size(dum,1)) then
         call env%warning('too many list items in '''//val//'''',source)
         status = .false.
         return
      endif
      n = 0
      do i = j, k
         n = n+1
         dum(n) = i
      enddo
      status = .true.
   endif
end function getListValue

subroutine readlog(fname,nat,at,xyz,nstruc)
   use xtb_mctc_convert
   use xtb_mctc_systools
   implicit none
   character(len=*),intent(in) :: fname
   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(out)   :: xyz(3,nat,nstruc)
   integer, intent(inout) :: nstruc

   character(len=:),allocatable :: line
   real(wp) :: floats(3),f
   character(len=80)  :: strings(3)
   integer  :: j,k,cs,cf,ncheck
   integer  :: ich ! file handle
   integer  :: idum,i,err

   call open_file(ich,fname,'r')
   if (ich.eq.-1) then
      call raise('E',"Could not find '"//fname//"'!")
   endif

   j = 0
   read_struc: do
      read(ich,*,iostat=err) idum
      if (err /= 0) exit read_struc
      if (idum /= nat) then
         call raise('E',"Atom number missmatch in '"//fname//"'!")
      endif
      if (j .ge. nstruc) exit read_struc
      read(ich,'(a)')
      if (err /= 0) exit read_struc
      do i = 1, nat
         call getline(ich,line,err)
         if (err /= 0) exit read_struc
         call readline(line,floats,strings,cs,cf)
         xyz(:,i,j+1)=floats*aatoau
      enddo
      j = j+1
   enddo read_struc
   nstruc = j

   call close_file(ich)

end subroutine readlog


end module xtb_readin

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Compare and generate topological information from wavefunctions
module xtb_topology
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType, generateFileName
   use xtb_io_writer, only : writeMolecule
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_neighbourlist, only : TNeighbourList, init, resizeNeigh
   use xtb_type_topology, only : TTopology, len
   implicit none
   private

   public :: checkTopology
   public :: makeBondTopology, compareBondTopology
   public :: topologyToNeighbourList


contains


subroutine checkTopology(unit, mol, wbo, verbosity)

   integer, intent(in) :: unit

   type(TMolecule), intent(in) :: mol

   real(wp), intent(in) :: wbo(:, :)

   integer, intent(in) :: verbosity

   character(len=:), allocatable :: fname
   type(TMolecule) :: copy
   integer :: ich, ftype
   logical :: match

   ! CT files have some limits:
   ! bail out if we encounter a structure not suitable for this format
   if (mol%npbc /= 0 .or. mol%n > 999) return

   copy = mol
   call makeBondTopology(copy%bonds, mol, wbo)

   call compareBondTopology(unit, mol%bonds, copy%bonds, mol, verbosity, match)

   if (.not.match .and. len(copy%bonds) > 0) then
      ! prefer molfiles, except the input has been SDF
      if (mol%ftype /= fileType%sdf) then
         ftype = fileType%molfile
      else
         ftype = mol%ftype
      end if
      call generateFileName(fname, 'xtbtopo', '', ftype)
      call open_file(ich, fname, 'w')
      if (verbosity > 0 .and. len(mol%bonds) > 0) then
         write(unit, '("Writing corrected topology to", 1x, a)') fname
      else
         write(unit, '("Writing topology from bond orders to", 1x, a)') fname
      end if
      call writeMolecule(copy, ich, format=ftype)
      call close_file(ich)
   end if

end subroutine checkTopology


subroutine makeBondTopology(topo, mol, wbo)

   type(TTopology), intent(out) :: topo

   type(TMolecule), intent(in) :: mol

   real(wp), intent(in) :: wbo(:, :)

   real(wp), parameter :: wbothr = 0.3_wp
   integer :: iat, jat

   call topo%allocate(size=len(mol), order=3)
   do iat = 1, len(mol)
      do jat = 1, iat-1
         associate(w => wbo(jat, iat))
            if (any(mol%at(iat) == [6, 7, 8]) .and. any(mol%at(jat) == [6, 7, 8])) then
               if (w > wbothr .and. w <= 1.2_wp) then
                  call topo%push_back([jat, iat, 1])
               else if (w > 1.5_wp .and. w <= 2.3_wp) then
                  call topo%push_back([jat, iat, 2])
               else if (w > 2.3_wp) then
                  call topo%push_back([jat, iat, 3])
               else if (w > 1.2_wp .and. w <= 1.5_wp) then
                  call topo%push_back([jat, iat, 4])
               end if
            else
               if (w > wbothr .and. w <= 1.3_wp) then
                  call topo%push_back([jat, iat, 1])
               else if (w > 1.3_wp .and. w <= 2.3_wp) then
                  call topo%push_back([jat, iat, 2])
               else if (w > 2.3_wp) then
                  call topo%push_back([jat, iat, 3])
               end if
            end if
         end associate
      end do
   end do
end subroutine makeBondTopology


subroutine compareBondTopology(unit, topo1, topo2, mol, verbosity, match)

   integer, intent(in) :: unit

   type(TTopology), intent(in) :: topo1

   type(TTopology), intent(in) :: topo2

   type(TMolecule), intent(in) :: mol

   integer, intent(in) :: verbosity

   logical, intent(out) :: match

   type(TNeighbourList) :: neighList1, neighList2
   integer :: iat, neigh

   match = len(topo1) == len(topo2)

   if (.not.match .and. verbosity > 0) then
      write(unit, '("Topologies differ in total number of bonds")')
   end if

   if (match .or. verbosity > 1) then
      call topologyToNeighbourList(topo1, neighList1, mol)
      call topologyToNeighbourList(topo2, neighList2, mol)

      match = match .and. all(neighList1%neighs == neighList2%neighs)
      if (.not.match .and. verbosity > 0) then
         write(unit, '("Topologies differ in number of bonds")')
      end if

      if (match .or. verbosity > 1) then
         neigh = min(ubound(neighList1%iNeigh, 1), ubound(neighList2%iNeigh, 1))
         match = match .and. all(neighList1%iNeigh(:neigh, :) &
            & == neighList2%iNeigh(:neigh, :))
         if (.not.match .and. verbosity > 0) then
            write(unit, '("Topologies differ in connectivity")')
         end if

         if (match .or. verbosity > 1) then
            match = match .and. all(nint(neighList1%weight(:neigh, :)) &
               & == nint(neighList2%weight(:neigh, :)))
            if (.not.match .and. verbosity > 0) then
               write(unit, '("Topologies differ in bond orders")')
            end if
         end if
      end if
   end if

end subroutine compareBondTopology


subroutine topologyToNeighbourList(topo, neighList, mol)

   type(TTopology), intent(in) :: topo

   type(TMolecule), intent(in) :: mol

   type(TNeighbourList), intent(out) :: neighList

   integer :: iBond(3)
   integer :: mNeigh
   integer :: ii, iat, jat
   real(wp) :: r2

   call init(neighList, len(mol))

   mNeigh = ubound(neighList%iNeigh, dim=1)

   neighList%neighs(:) = 0
   neighList%iNeigh(:, :) = 0
   neighList%dist2(:, :) = 0.0_wp
   neighList%weight(:, :) = 0.0_wp
   do iat = 1, len(mol)
      neighList%iNeigh(0, iat) = iat
      neighList%weight(0, iat) = 1.0_wp
      neighList%coords(:, iat) = mol%xyz(:, iat)
      neighList%image(iat) = iat
      neighList%trans(iat) = 1
   end do

   do ii = 1, len(topo)
      call topo%get_item(ii, iBond)
      iat = min(iBond(1), iBond(2))
      jat = max(iBond(1), iBond(2))
      r2 = sum((neighList%coords(:, iat) - neighList%coords(:, jat))**2)
      neighList%neighs(iat) = neighList%neighs(iat) + 1
      if (neighList%neighs(iat) > mNeigh) then
         mNeigh = 2*mNeigh
         call resizeNeigh(mNeigh, neighList%iNeigh, neighList%dist2, &
            & neighList%weight)
      end if
      neighList%iNeigh(neighList%neighs(iat), iat) = jat
      neighList%dist2(neighList%neighs(iat), iat) = r2
      neighList%weight(neighList%neighs(iat), iat) = iBond(3)
   end do

   call neighList%sort

end subroutine topologyToNeighbourList


end module xtb_topology

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine zmatpr(nat,at,geo,na,nb,nc,molnum)
   use xtb_mctc_io, only : stdout
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer, intent(in) :: nat
   integer, intent(in) :: at(nat)
   integer, intent(in) :: na(nat),nb(nat),nc(nat)
   real(wp),intent(in) :: geo(3,nat)
   character(len=20) :: filename
   logical  :: ex
   integer  :: i,l,m,n
   integer, intent(in) :: molnum
   integer  :: ich ! file handle
   real(wp) :: bl,ang,dihed

   do i=1,nat
      l=1
      m=1
      n=1
      if(i.eq.1)then
         l=0
         m=0
         n=0
      endif
      if(i.eq.2)then
         m=0
         n=0
      endif
      if(i.eq.3)n=0
      bl=geo(1,i)
      ang=geo(2,i)*180./pi
      dihed=geo(3,i)*180./pi
      if(dihed.gt.180.0d0)dihed=dihed-360.0d0
      write(stdout,'(i4,2x,a2,f12.6,2x,f10.4,2x,f10.4,i6,2i5)')&
         &   i,toSymbol(at(i)),bl,ang,dihed,na(i),nb(i),nc(i)
   enddo

   write(filename,'("zmatrix",i0,".zmat")') molnum
   call open_file(ich,trim(filename),'w')

   write(ich,'(a2)') toSymbol(at(1))
   write(ich,'(a2,x,i0,x,f8.3)') toSymbol(at(2)), na(2), geo(1,2)
   write(ich,'(a2,x,i0,x,f8.3,x,i0,x,f8.3)') toSymbol(at(3)), na(3),&
      & geo(1,3),nb(3), geo(2,3)*180./pi

   do i=4,nat
      bl=geo(1,i)
      ang=geo(2,i)*180./pi
      dihed=geo(3,i)*180./pi
      if(dihed.gt.180.0d0)dihed=dihed-360.0d0
      write(ich,'(a2,x,i0,x,f8.3,x,i0,x,f8.3,x,i0,x,f8.3)')&
         & toSymbol(at(i)),na(i),bl,nb(i),ang,nc(i),dihed
   enddo
   write(ich,*)
   close(ich)
end subroutine zmatpr

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_basic_geo
contains
!  .....................................................................

      Subroutine dthetadr(nat,xyz,j,k,i,theta,kijk,dei,dej,dek)
         use xtb_mctc_accuracy, only : wp

!  .....................................................................
!
!   Input
!   -----
!                              __              __
!    ra,rb          : distance ij and distnace ik
!
!    sinth          : sinus of angle j-i-k
!
!    costh          : cosinus of angle j-i-k
!
!
!   Output
!   ------
!
!    dei            : derivatives of the atom i
!
!    dej            : derivatives of the atom j
!
!    dek            : derivatives of the atom k
!
!  .....................................................................

      implicit none

      external vecnorm

      integer ic,nat,j,k,i

      real(wp) ran,rbn,theta,xyz(3,nat)
      real(wp) ra(3),rb(3),sinth,costh
      real(wp) dei(3),dej(3),dek(3),kijk
      real(wp) fac,vecnorm,eps

      parameter (eps=1.d-14)

! ... dtheta/dri, dtheta/drj and dtheta/drk

      sinth=sin(theta)
      costh=cos(theta)

      do ic=1,3
        ra(ic)=xyz(ic,j)-xyz(ic,i)
        rb(ic)=xyz(ic,k)-xyz(ic,i)
      end do

      ran=vecnorm(ra,3,0)
      rbn=vecnorm(rb,3,0)
      if (abs(sinth).le.eps) then
        fac=sign(kijk,costh)/(ran*rbn)
      else
        fac=1.d0/(sinth*ran*rbn)
      end if

        do ic=1,3
! ... dedri
          dei(ic)=fac*( ra(ic)+rb(ic)-(rbn*rbn*ra(ic)+ran*ran*rb(ic))* &
                        costh/(ran*rbn))
! ... dedrj
          dej(ic)=fac*(ra(ic)*costh*rbn/ran-rb(ic))
! ... dedrk
          dek(ic)=fac*(rb(ic)*costh*ran/rbn-ra(ic))
        end do

      End Subroutine dthetadr

      Subroutine dphidr(nat,xyz,i,j,k,l,phi, &
                        dphidri,dphidrj,dphidrk,dphidrl)
                     use xtb_mctc_accuracy, only : wp
!     the torsion derivatives

      implicit none

      external vecnorm

      integer  ic,i,j,k,l,nat

      real(wp) sinphi,cosphi,onenner,thab,thbc
      real(wp) ra(3),rb(3),rc(3),rab(3),rac(3),rbc(3),rbb(3)
      real(wp) raa(3),rba(3),rapba(3),rapbb(3),rbpca(3),rbpcb(3)
      real(wp) rapb(3),rbpc(3),na(3),nb(3),nan,nbn
      real(wp) dphidri(3),dphidrj(3),dphidrk(3),dphidrl(3)
      real(wp) xyz(3,nat),phi,vecnorm,nenner,eps,vz

      parameter (eps=1.d-14)

      cosphi=cos(phi)
      sinphi=sin(phi)
      do ic=1,3
        ra(ic)=xyz(ic,j)-xyz(ic,i)
        rb(ic)=xyz(ic,k)-xyz(ic,j)
        rc(ic)=xyz(ic,l)-xyz(ic,k)

        rapb(ic)=ra(ic)+rb(ic)
        rbpc(ic)=rb(ic)+rc(ic)
      end do

      call crossprod(ra,rb,na)
      call crossprod(rb,rc,nb)
      nan=vecnorm(na,3,0)
      nbn=vecnorm(nb,3,0)

      nenner=nan*nbn*sinphi
      if (abs(nenner).lt.eps) then
        dphidri=0
        dphidrj=0
        dphidrk=0
        dphidrl=0
        onenner=1.0d0/(nan*nbn)
      else
        onenner=1.d0/nenner
      endif

      call crossprod(na,rb,rab)
      call crossprod(nb,ra,rba)
      call crossprod(na,rc,rac)
      call crossprod(nb,rb,rbb)
      call crossprod(nb,rc,rbc)
      call crossprod(na,ra,raa)

      call crossprod(rapb,na,rapba)
      call crossprod(rapb,nb,rapbb)
      call crossprod(rbpc,na,rbpca)
      call crossprod(rbpc,nb,rbpcb)

! ... dphidri
      do ic=1,3
        dphidri(ic)=onenner*(cosphi*nbn/nan*rab(ic)-rbb(ic))

! ... dphidrj
         dphidrj(ic)=onenner*(cosphi*(nbn/nan*rapba(ic) &
                                      +nan/nbn*rbc(ic)) &
                              -(rac(ic)+rapbb(ic)))
! ... dphidrk
        dphidrk(ic)=onenner*(cosphi*(nbn/nan*raa(ic) &
                                   +nan/nbn*rbpcb(ic)) &
                              -(rba(ic)+rbpca(ic)))
! ... dphidrl
         dphidrl(ic)=onenner*(cosphi*nan/nbn*rbb(ic)-rab(ic))
       end do

      End Subroutine dphidr

!  .....................................................................

      Subroutine domegadr &
                 (nat,xyz, &
                  i,j,k,l,omega, &
                  domegadri,domegadrj,domegadrk,domegadrl)
               use xtb_mctc_accuracy, only : wp

!     inversion derivatives
!  .....................................................................

      implicit none

      external vecnorm

      integer  ic,i,j,k,l,nat

      real(wp) omega,sinomega
      real(wp) xyz(3,nat),onenner,vecnorm,rnn,rvn
      real(wp) rn(3),rv(3),rd(3),re(3),rdme(3),rve(3)
      real(wp) rne(3),rdv(3),rdn(3)
      real(wp) rvdme(3),rndme(3),nenner
      real(wp) domegadri(3),domegadrj(3),domegadrk(3),domegadrl(3),eps

      parameter (eps=1.d-14)

      sinomega=sin(omega)

      do ic=1,3
        rv(ic)=xyz(ic,l)-xyz(ic,i)
        rd(ic)=xyz(ic,k)-xyz(ic,j)
        re(ic)=xyz(ic,i)-xyz(ic,j)

        rdme(ic)=rd(ic)-re(ic)
      end do

      call crossprod(re,rd,rn)
      rvn=vecnorm(rv,3,0)
      rnn=vecnorm(rn,3,0)

      call crossprod(rv,re,rve)
      call crossprod(rn,re,rne)
      call crossprod(rd,rv,rdv)
      call crossprod(rd,rn,rdn)
      call crossprod(rv,rdme,rvdme)
      call crossprod(rn,rdme,rndme)

      nenner=rnn*rvn*cos(omega)
      if (abs(nenner).gt.eps) then
        onenner=1.d0/nenner
        do ic=1,3
! ... domega/dri
          domegadri(ic)=onenner*(rdv(ic)-rn(ic)- &
                             sinomega*(rvn/rnn*rdn(ic)-rnn/rvn*rv(ic)))

! ... domega/drj
          domegadrj(ic)=onenner*(rvdme(ic)-sinomega*rvn/rnn*rndme(ic))

! ... domega/drk
          domegadrk(ic)=onenner*(rve(ic)-sinomega*rvn/rnn*rne(ic))

! ... domega/drl
          domegadrl(ic)=onenner*(rn(ic)-sinomega*rnn/rvn*rv(ic))
        end do
      else
        do ic=1,3
          domegadri(ic)=0.d0
          domegadrj(ic)=0.d0
          domegadrk(ic)=0.d0
          domegadrl(ic)=0.d0
        end do
      end if

      End Subroutine domegadr

!  .....................................................................

      real(wp) Function valijkl(nat,xyz,i,j,k,l)
         use xtb_mctc_accuracy, only : wp
      use xtb_mctc_constants, only: pi

!  .....................................................................

      implicit none

      external vecnorm,valijk

      integer ic,i,j,k,l,nat

      real(wp) xyz(3,nat)
      real(wp) eps,ra(3),rb(3),rc(3),na(3),nb(3)
      real(wp) rab,rbc,thab,thbc,valijk
      real(wp) vecnorm,nan,nbn,rcn,snanb,deter,test
      real(wp) raabs,rbabs,rcabs

      parameter (eps=1.0d-14)

      raabs=0.0d0
      rbabs=0.0d0
      rcabs=0.0d0
! ... get torsion coordinate
      do ic=1,3
        ra(ic)=xyz(ic,j)-xyz(ic,i)
        rb(ic)=xyz(ic,k)-xyz(ic,j)
        rc(ic)=xyz(ic,l)-xyz(ic,k)
        raabs=raabs+ra(ic)*ra(ic)
        rbabs=rbabs+rb(ic)*rb(ic)
        rcabs=rcabs+rc(ic)*rc(ic)
      end do
      raabs=sqrt(raabs)
      rbabs=sqrt(rbabs)
      rcabs=sqrt(rcabs)
! ... normalize vectors
      do ic=1,3
        ra(ic)=ra(ic)/raabs
        rb(ic)=rb(ic)/rbabs
        rc(ic)=rc(ic)/rcabs
      end do
! ... determinante of rb,ra,rc
      deter= ra(1)*(rb(2)*rc(3)-rb(3)*rc(2)) &
            -ra(2)*(rb(1)*rc(3)-rb(3)*rc(1)) &
            +ra(3)*(rb(1)*rc(2)-rb(2)*rc(1))

      call crossprod(-ra,rc,na)
      test=0.0d0
      do ic=1,3
        test=test+na(ic)*rb(ic)
      end do

      thab=valijk(nat,xyz,i,k,j)
      thbc=valijk(nat,xyz,j,l,k)
      call crossprod(ra,rb,na)
      call crossprod(rb,rc,nb)
      nan=vecnorm(na,3,1)
      nbn=vecnorm(nb,3,1)

      snanb=0.0d0
      do ic=1,3
        snanb=snanb+na(ic)*nb(ic)
      end do
      if (abs(abs(snanb)-1.d0).lt.eps) then
        snanb=sign(1.d0,snanb)
      end if

      valijkl=acos(snanb)
      if(test.lt.0.0d0) valijkl=-acos(snanb)

! the gradient dphir is only compatible with this subroutine
! if the statement below is commented out. If not, opt. and
! Hessian show large errors and imags. I don't understand
! this entirely but thats how it is.
! SG, Sat May 24 11:41:42 CEST 2014

!     if (deter.lt.0) then
!        valijkl=2.d0*pi-valijkl
!     end if

      End Function valijkl

!  .....................................................................

      real(wp) Function valijk(nat,xyz,j,k,i)
         use xtb_mctc_accuracy, only : wp

!  .....................................................................

      implicit none

      external vecnorm

      integer nat,j,k,i,ic

      real(wp) ra(3),rb(3),rab,eps
      real(wp) xyz(3,nat),vecnorm,ran,rbn

      parameter (eps=1.d-14)

      do ic=1,3
        ra(ic)=xyz(ic,j)-xyz(ic,i)
        rb(ic)=xyz(ic,k)-xyz(ic,i)
      end do

      ran=vecnorm(ra,3,1)
      rbn=vecnorm(rb,3,1)
      rab=0.d0
      do ic=1,3
        rab=rab+ra(ic)*rb(ic)
      end do

      if (abs(abs(rab)-1.d0).lt.eps) then
        rab=sign(1.d0,rab)
      end if
      valijk=acos(rab)

      End Function valijk

!  .....................................................................

      real(wp) Function omega (nat,xyz,i,j,k,l)
         use xtb_mctc_accuracy, only : wp

!   Calculates the inversion angle
!  .....................................................................

      implicit none

      external vecnorm

      integer ic,nat,i,j,k,l

      real(wp) xyz(3,nat)
      real(wp) rd(3),re(3),rn(3),rv(3),rnv
      real(wp) vecnorm,rkjn,rljn,rnn,rvn

      do ic=1,3
        re(ic)=xyz(ic,i)-xyz(ic,j)
        rd(ic)=xyz(ic,k)-xyz(ic,j)
        rv(ic)=xyz(ic,l)-xyz(ic,i)
      end do
      call crossprod(re,rd,rn)
      rnn=vecnorm(rn,3,1)
      rvn=vecnorm(rv,3,1)

      rnv=rn(1)*rv(1)+rn(2)*rv(2)+rn(3)*rv(3)
      omega=asin( rnv )

      End Function omega

!  .....................................................................

      Subroutine crossprod(ra,rb,rab)
         use xtb_mctc_accuracy, only : wp

      implicit none

      real(wp) ra(3),rb(3),rab(3)

      rab(1)=ra(2)*rb(3)-ra(3)*rb(2)
      rab(2)=ra(3)*rb(1)-ra(1)*rb(3)
      rab(3)=ra(1)*rb(2)-ra(2)*rb(1)

      End Subroutine crossprod

!  .....................................................................

      real(wp) Function  vecnorm (r,n,inorm)
         use xtb_mctc_accuracy, only : wp

      implicit none

      integer i,n,inorm

      real(wp) r(n),or,sp,rn

      sp=0.
      do i=1,n
        sp=sp+r(i)*r(i)
      end do
      rn=sqrt(sp)
      if (inorm.gt.0) then
        if (abs(rn).gt.1.d-14) then
          or=1.0d0/rn
          do i=1,n
            r(i)=or*r(i)
          end do
        end if
      end if
      vecnorm=rn

      End Function vecnorm

!  .....................................................................

      subroutine crprod(a,b,c)
         use xtb_mctc_accuracy, only : wp
      implicit double precision (a-h,o-z)
      dimension a(3),b(3),c(3)

      c(1)=a(2)*b(3)-a(3)*b(2)
      c(2)=a(3)*b(1)-a(1)*b(3)
      c(3)=a(1)*b(2)-a(2)*b(1)

      return
      end subroutine crprod

!  .....................................................................

      subroutine vsc1(a,scale,tol)
         use xtb_mctc_accuracy, only : wp
      implicit double precision (a-h,o-z)
      dimension a(3)

      rlen = norm2(a)

      if (rlen.gt.tol) then
         do i=1,3
            a(i) = a(i)*scale/rlen
         end do
      endif

      return
      end subroutine vsc1

!  .....................................................................

      pure subroutine impsc(a,b,c)
         use xtb_mctc_accuracy, only : wp
      implicit none
      real(wp),intent(in)  :: a(3),b(3)
      real(wp),intent(out) :: c
      integer  :: i
      real(wp) :: rimp,al,bl

      rimp = 0.0d0

      do i=1,3
         rimp = rimp + a(i)*b(i)
      end do

      al = norm2(a)
      bl = norm2(b)

      if (al.gt.0.0d0.and.bl.gt.0.0d0) then
         c = rimp/(al*bl)
      else
         c = 0.0d0
      endif

      return
      end subroutine impsc

!  .....................................................................

      pure subroutine bangl(xyz,i,j,k,angle)
         use xtb_mctc_accuracy, only : wp
      implicit none
      real(wp),intent(in)  :: xyz(3,*)
      real(wp),intent(out) :: angle
      integer, intent(in)  :: i,j,k

      real(wp) d2ij,d2jk,d2ik,xy,temp

      d2ij = sum((xyz(:,i)-xyz(:,j))**2)
      d2jk = sum((xyz(:,j)-xyz(:,k))**2)
      d2ik = sum((xyz(:,i)-xyz(:,k))**2)
      xy = sqrt(d2ij*d2jk)
      temp = 0.5d0 * (d2ij+d2jk-d2ik) / xy
      if (temp .gt. 1.0d0)  temp= 1.0d0
      if (temp .lt. -1.0d0) temp=-1.0d0
      angle = acos( temp )

      end subroutine bangl
end module xtb_basic_geo

! This file is part of xtb.
!
! Copyright (C) 2022 Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Topological data for force field type calculations
module xtb_iff_data
   use xtb_mctc_accuracy, only: wp
   use xtb_type_molecule, only: TMolecule
   implicit none
   private

   public :: TIFFData

   type :: TIFFData

      !> Total number of atoms
      integer :: n 

      !> Number of atoms molA and B
      integer :: n1
      integer :: n2

      !> Number of LMOs molA and B
      integer :: nlmo1
      integer :: nlmo2

      !> Coordinates molA and B and whole system
      real(wp), allocatable :: xyz1(:, :) 
      real(wp), allocatable :: xyz2(:, :)
      real(wp), allocatable :: xyz(:, :)

      !> LMO positions molA and B
      real(wp), allocatable :: rlmo1(:, :)
      real(wp), allocatable :: rlmo2(:, :)

      !> Charges
      real(wp), allocatable :: q1(:) 
      real(wp), allocatable :: q2(:)
      real(wp), allocatable :: q(:)

      !> Deviation from atomic charge
      real(wp), allocatable :: qdr1(:)
      real(wp), allocatable :: qdr2(:)

      !> Deviation from atomic position
      real(wp), allocatable ::xyzdr1(:, :)
      real(wp), allocatable ::xyzdr2(:, :)

      !> Coordination numbers
      real(wp), allocatable :: cn1(:)
      real(wp), allocatable :: cn2(:)
      real(wp), allocatable :: cn(:)

      !> Electron count per element
      real(wp), allocatable :: z1(:)
      real(wp), allocatable :: z2(:)

      !> Polarizabilities
      real(wp), allocatable :: alp1(:)
      real(wp), allocatable :: alp2(:)
      real(wp), allocatable :: alpab(:, :)
      real(wp), allocatable :: alp0(:)

      !> Ordinary number
      integer, allocatable :: at1(:)
      integer, allocatable :: at2(:)
      integer, allocatable :: at(:)

      !> LMO values
      integer, allocatable :: lmo1(:)
      integer, allocatable :: lmo2(:)
      
      !> C6 coeffs for the whole system
      real(wp), allocatable :: c6ab(:, :)

      !> C6 coeffs for molA with rare gas
      real(wp), allocatable :: cprob(:)

      real(wp), allocatable :: gab1(:, :)
      real(wp), allocatable :: gab2(:, :)

      !> Frontier orbital densities
      real(wp), allocatable :: den1(:, :, :)
      real(wp), allocatable :: den2(:, :, :)

      !> Charge related stuff (from GFN2 calc.)
      real(wp), allocatable :: qcm1(:)
      real(wp), allocatable :: qcm2(:)
      real(wp), allocatable :: qct1(:, :)
      real(wp), allocatable :: qct2(:, :)

      !> Neighbour list
      integer, allocatable :: neigh(:, :)

   contains

      procedure :: delete
      procedure :: allocateIFFData

   end type TIFFData

contains

   subroutine delete(self)
      class(TIFFData), intent(out) :: self

      if (allocated(self%xyz1)) deallocate (self%xyz1)
      if (allocated(self%rlmo1)) deallocate (self%rlmo1)
      if (allocated(self%q1)) deallocate (self%q1)
      if (allocated(self%qdr1)) deallocate (self%qdr1)
      if (allocated(self%xyzdr1)) deallocate (self%xyzdr1)
      if (allocated(self%cn1)) deallocate (self%cn1)
      if (allocated(self%z1)) deallocate (self%z1)
      if (allocated(self%alp1)) deallocate (self%alp1)
      if (allocated(self%qct1)) deallocate (self%qct1)
      if (allocated(self%at1)) deallocate (self%at1)
      if (allocated(self%lmo1)) deallocate (self%lmo1)
      if (allocated(self%xyz2)) deallocate (self%xyz2)
      if (allocated(self%rlmo2)) deallocate (self%rlmo2)
      if (allocated(self%q2)) deallocate (self%q2)
      if (allocated(self%qdr2)) deallocate (self%qdr2)
      if (allocated(self%xyzdr2)) deallocate (self%xyzdr2)
      if (allocated(self%cn2)) deallocate (self%cn2)
      if (allocated(self%z2)) deallocate (self%z2)
      if (allocated(self%alp2)) deallocate (self%alp2)
      if (allocated(self%qct2)) deallocate (self%qct2)
      if (allocated(self%at2)) deallocate (self%at2)
      if (allocated(self%lmo2)) deallocate (self%lmo2)
      if (allocated(self%c6ab)) deallocate (self%c6ab)
      if (allocated(self%alpab)) deallocate (self%alpab)
      if (allocated(self%cprob)) deallocate (self%cprob)
      if (allocated(self%xyz)) deallocate (self%xyz)
      if (allocated(self%q)) deallocate (self%q)
      if (allocated(self%cn)) deallocate (self%cn)
      if (allocated(self%alp0)) deallocate (self%alp0)
      if (allocated(self%gab1)) deallocate (self%gab1)
      if (allocated(self%gab2)) deallocate (self%gab2)
      if (allocated(self%den1)) deallocate (self%den1)
      if (allocated(self%den2)) deallocate (self%den2)
      if (allocated(self%qcm1)) deallocate (self%qcm1)
      if (allocated(self%qcm2)) deallocate (self%qcm2)
      if (allocated(self%at)) deallocate (self%at)
      if (allocated(self%neigh)) deallocate (self%neigh)

   end subroutine delete

   subroutine allocateIFFData(self, n1, n2)

      class(TIFFData), intent(out) :: self

      integer, intent(in) :: n1, n2

      integer :: n

      self%n1 = n1
      self%n2 = n2

      !Allocate Infos of molA
      allocate(self%at1(n1),self%xyz1(3,n1),self%rlmo1(4,10*n1),self%q1(n1),self%lmo1(10*n1),&
      &self%cn1(n1),self%alp1(n1),self%qct1(n1,2),self%qdr1(n1),self%xyzdr1(3,n1),&
      &self%z1(n1), self%den1(2, 4, n1), self%gab1(n1, n1), self%qcm1(n1))
      self%rlmo1 = 0.0_wp

      !Allocate Infos of molB
      allocate(self%at2(n2),self%xyz2(3,n2),self%rlmo2(4,10*n2),self%q2(n2),self%lmo2(10*n2),&
      & self%cn2(n2),self%alp2(n2),self%qct2(n2,2),self%qdr2(n2),self%xyzdr2(3,n2),&
      & self%z2(n2), self%den2(2, 4, n2), self%gab2(n2, n2), self%qcm2(n2))
      self%rlmo2 = 0.0_wp

      !Allocate combined Infos
      self%n = n1 + n2
      n = self%n
      allocate(self%at(n),self%xyz(3,n),self%q(n),self%c6ab(n,n),self%alp0(n),self%cn(n),self%neigh(0:n,n),&
      &        self%alpab(n2, n1), self%cprob(n1))

   end subroutine allocateIFFData

end module xtb_iff_data

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> LAPACK linear equation solvers.
module xtb_mctc_lapack_wrap
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_mctc_lapack_gst, only : mctc_sygst, mctc_spgst
   use xtb_mctc_lapack_trf, only : mctc_getrf, mctc_sytrf, mctc_sptrf, &
      & mctc_potrf, mctc_pptrf
   use xtb_mctc_lapack_tri, only : mctc_getri, mctc_sytri, mctc_sptri, &
      & mctc_potri, mctc_pptri
   use xtb_mctc_lapack_trs, only : mctc_getrs, mctc_sytrs, mctc_sptrs, &
      & mctc_potrs, mctc_pptrs
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: mctc_sygst, mctc_spgst
   public :: mctc_getrs, mctc_sytrs, mctc_sptrs, mctc_potrs, mctc_pptrs
   public :: mctc_getrf, mctc_sytrf, mctc_sptrf, mctc_potrf, mctc_pptrf
   public :: mctc_getri, mctc_sytri, mctc_sptri, mctc_potri, mctc_pptri


   interface mctc_getrs
      module procedure :: mctc_sgetrs1
      module procedure :: mctc_sgetrs3
      module procedure :: mctc_dgetrs1
      module procedure :: mctc_dgetrs3
   end interface mctc_getrs

   interface mctc_sytrs
      module procedure :: mctc_ssytrs1
      module procedure :: mctc_ssytrs3
      module procedure :: mctc_dsytrs1
      module procedure :: mctc_dsytrs3
   end interface mctc_sytrs

   interface mctc_sptrs
      module procedure :: mctc_ssptrs1
      module procedure :: mctc_ssptrs3
      module procedure :: mctc_dsptrs1
      module procedure :: mctc_dsptrs3
   end interface mctc_sptrs

   interface mctc_potrs
      module procedure :: mctc_spotrs1
      module procedure :: mctc_spotrs3
      module procedure :: mctc_dpotrs1
      module procedure :: mctc_dpotrs3
   end interface mctc_potrs

   interface mctc_pptrs
      module procedure :: mctc_spptrs1
      module procedure :: mctc_spptrs3
      module procedure :: mctc_dpptrs1
      module procedure :: mctc_dpptrs3
   end interface mctc_pptrs


contains


subroutine mctc_sgetrs1(env, amat, bvec, ipiv, trans)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), target :: bvec(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_getrs(env, amat, bptr, ipiv, trans)
end subroutine mctc_sgetrs1


subroutine mctc_sgetrs3(env, amat, bmat, ipiv, trans)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_getrs(env, amat, bptr, ipiv, trans)
end subroutine mctc_sgetrs3


subroutine mctc_dgetrs1(env, amat, bvec, ipiv, trans)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), target :: bvec(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_getrs(env, amat, bptr, ipiv, trans)
end subroutine mctc_dgetrs1


subroutine mctc_dgetrs3(env, amat, bmat, ipiv, trans)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_getrs(env, amat, bptr, ipiv, trans)
end subroutine mctc_dgetrs3


subroutine mctc_ssytrs1(env, amat, bvec, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), target :: bvec(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_sytrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_ssytrs1


subroutine mctc_ssytrs3(env, amat, bmat, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_sytrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_ssytrs3


subroutine mctc_dsytrs1(env, amat, bvec, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), target :: bvec(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_sytrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_dsytrs1


subroutine mctc_dsytrs3(env, amat, bmat, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_sytrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_dsytrs3


subroutine mctc_ssptrs1(env, amat, bvec, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:)
   real(sp), intent(inout), target :: bvec(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_sptrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_ssptrs1


subroutine mctc_ssptrs3(env, amat, bmat, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:)
   real(sp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_sptrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_ssptrs3


subroutine mctc_dsptrs1(env, amat, bvec, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:)
   real(dp), intent(inout), target :: bvec(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_sptrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_dsptrs1


subroutine mctc_dsptrs3(env, amat, bmat, ipiv, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:)
   real(dp), intent(inout), contiguous, target :: bmat(:, :, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_sptrs(env, amat, bptr, ipiv, uplo)
end subroutine mctc_dsptrs3


subroutine mctc_spotrs1(env, amat, bvec, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), target :: bvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_potrs(env, amat, bptr, uplo)
end subroutine mctc_spotrs1


subroutine mctc_spotrs3(env, amat, bmat, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout), contiguous, target :: bmat(:, :, :)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_potrs(env, amat, bptr, uplo)
end subroutine mctc_spotrs3


subroutine mctc_dpotrs1(env, amat, bvec, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), target :: bvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_potrs(env, amat, bptr, uplo)
end subroutine mctc_dpotrs1


subroutine mctc_dpotrs3(env, amat, bmat, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout), contiguous, target :: bmat(:, :, :)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_potrs(env, amat, bptr, uplo)
end subroutine mctc_dpotrs3


subroutine mctc_spptrs1(env, amat, bvec, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:)
   real(sp), intent(inout), target :: bvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_pptrs(env, amat, bptr, uplo)
end subroutine mctc_spptrs1


subroutine mctc_spptrs3(env, amat, bmat, uplo)
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:)
   real(sp), intent(inout), contiguous, target :: bmat(:, :, :)
   character(len=1), intent(in), optional :: uplo
   real(sp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_pptrs(env, amat, bptr, uplo)
end subroutine mctc_spptrs3


subroutine mctc_dpptrs1(env, amat, bvec, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:)
   real(dp), intent(inout), target :: bvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bvec), 1:1) => bvec
   call mctc_pptrs(env, amat, bptr, uplo)
end subroutine mctc_dpptrs1


subroutine mctc_dpptrs3(env, amat, bmat, uplo)
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:)
   real(dp), intent(inout), contiguous, target :: bmat(:, :, :)
   character(len=1), intent(in), optional :: uplo
   real(dp), pointer :: bptr(:, :)
   bptr(1:size(bmat, 1), 1:size(bmat, 2)*size(bmat, 3)) => bmat
   call mctc_pptrs(env, amat, bptr, uplo)
end subroutine mctc_dpptrs3


end module xtb_mctc_lapack_wrap

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_scanparam
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   use xtb_constrainpot
   implicit none
   private :: wp
   public

   integer,parameter :: p_scan_sequential = 1
   integer,parameter :: p_scan_concerted = 2
   integer  :: scan_mode = p_scan_sequential

   integer  :: maxscan = 0
   integer  :: maxconstr = 0
   real(wp),allocatable :: valscan(:)
   real(wp),allocatable :: valconstr(:)
   real(wp) :: fcconstr = 0.05_wp
   real(wp) :: pmf ! whatever
   real(wp) :: springexpo = 2.0_wp
   integer  :: nscan = 0
   integer  :: nconstr = 0
   integer, allocatable :: atconstr(:,:)
   integer  :: iconstr = 0
   integer  :: zconstr = 0
   logical  :: lconstr_all_torsions = .false.
   logical  :: lconstr_all_bonds    = .false.
   logical  :: lconstr_all_angles   = .false.

   type(constr_setvar) :: potset
   integer, parameter  :: p_typeid_dist     = 1
   integer, parameter  :: p_typeid_angle    = 2
   integer, parameter  :: p_typeid_dihedral = 3
   integer, parameter  :: p_typeid_cma      = 4
   integer, parameter  :: p_typeid_zaxis    = 5

   type tb_scan
      integer  :: nscan = 0
      integer  :: iconstr = 0
      real(wp) :: valconstr = 0.0_wp
      real(wp),allocatable :: valscan(:)
   end type tb_scan

   type(tb_scan),allocatable :: scan_list(:)

contains

subroutine init_constr(n,at)
   implicit none
   integer,intent(in) :: n
   integer,intent(in) :: at(n)
   if (lconstr_all_bonds)    maxconstr = maxconstr+n*(1+n)/2
   if (lconstr_all_angles)   maxconstr = maxconstr+n*(1+n)*(2+n)/6
   if (lconstr_all_torsions) maxconstr = maxconstr+n*(1+n)*(2+n)*(3+n)/24
   call clear_constr
   allocate( valconstr(maxconstr),  source = 0.0_wp )
   valconstr = 0.0_wp
   allocate( atconstr(4,maxconstr), source = 0 )
   atconstr = 0

   call potset%allocate(n,maxconstr,fc=fcconstr,expo=springexpo)
!  new model
   if (allocated(potset%fname)) then
      allocate( potset%xyz(3,n), source = 0.0_wp )
      call read_reference(potset%fname,n,at,potset%xyz)
   endif
end subroutine init_constr

subroutine init_scan
   call clear_scan
   allocate( scan_list(maxscan) )
end subroutine init_scan

subroutine clear_scan
   if (allocated(scan_list)) deallocate(scan_list)
end subroutine clear_scan

subroutine clear_constr
   if (allocated(valconstr)) deallocate(valconstr)
   if (allocated(atconstr))  deallocate(atconstr)
end subroutine clear_constr

subroutine read_reference(fname,n,at,xyz)
   implicit none
   character(len=*),intent(in) :: fname
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(out) :: xyz(3,n)

   integer  :: n1
   integer, allocatable :: at1(:)

   n1 = n
   allocate( at1(n), source = 0 )

   call rdcoord(fname,n1,xyz,at1)

   if (n1.ne.n) &
      call raise('E',"Atom number missmatch in constraint reference geometry!")
   if (any(at.ne.at1)) &
      call raise('E',"Atom type missmatch in constraint reference geometry!")

end subroutine read_reference

subroutine setup_constrain_pot(n,at,xyz)
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,ii,j,jj,ij
   real(wp) :: rij

   if (potset%pos%n.gt.0) then
      ij = 0
      do i = 1, potset%pos%n
         ii = potset%pos%atoms(i)
         do j = 1, i-1
            jj = potset%pos%atoms(j)
            ij = ij+1
            rij = sqrt(sum((xyz(1:3,jj)-xyz(1:3,ii))**2))
            potset%pos%val(ij) = rij
         enddo
      enddo
      potset%pos%fc = potset%pos%fc / real(potset%pos%n-1,wp)
   endif

end subroutine setup_constrain_pot

subroutine pot_info(iunit,n,at,xyz)
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_mctc_symbols, only : toSymbol
   use xtb_mctc_blas, only : mctc_nrm2
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   real(wp),external :: valijkl

   integer :: i,ii,j,k,l,m,mm
   real(wp) :: val0,val

   real(wp) :: e,efix,gfix
   real(wp),allocatable :: g(:,:)

   allocate( g(3,n), source = 0.0_wp )


   efix = 0.0_wp
   gfix = 0.0_wp

   if (potset%n.gt.0 .or. potset%pos%n.gt.0) then
      call generic_header(iunit,"Constraints",49,10)
      write(iunit,'(a)')
   endif
   if (potset%pos%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') potset%pos%n,"constrained atom positions"
      if (allocated(potset%xyz).and.allocated(potset%fname)) then
         write(iunit,'(3x,a,1x,"''",a,"''")') "positions refering to",&
            potset%fname
      else
         write(iunit,'(3x,a)') "positions refering to input geometry"
      endif
      write(iunit,'(a)')
      write(iunit,'(5x,"#",3x,"Z",3x,32x,"position/Å",6x,"displ./Å")')
      do i = 1, potset%pos%n
         ii = potset%pos%atoms(i)
         write(iunit,'(i6,1x,i3,1x,a2)',advance='no') ii,at(ii),toSymbol(at(ii))
         if (allocated(potset%xyz)) then
            write(iunit,'(4f14.7)') &
               potset%xyz(:,ii)*autoaa, sqrt(sum((potset%xyz(:,ii)-xyz(:,ii))**2))*autoaa
         else
            write(iunit,'(4f14.7)') &
               xyz(:,ii)*autoaa, 0.0_wp
         endif
      enddo
      write(iunit,'(a)')
      write(iunit,'(5x,a,1x,i0,1x,a)') "applying",potset%pos%n*(potset%pos%n-1)/2,&
         "atom pairwise harmonic potentials"
      write(iunit,'(5x,a,f14.7)') "  applied force constant per pair:", &
         potset%pos%fc
      write(iunit,'(5x,a,f14.7)') "effective force constant per atom:", &
         potset%pos%fc*(potset%pos%n-1)

      g = 0.0_wp
      e = 0.0_wp
      call constrain_pos(potset%pos,n,at,xyz,g,e)
      efix = efix+e
      gfix = gfix+mctc_nrm2(g)
      write(iunit,'(5x,a,2f14.7)')"    constraining energy/grad norm:", &
         e,mctc_nrm2(g)

      write(iunit,'(a)')
   endif

   if (potset%dist%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') potset%dist%n,"constrained distances"
      write(iunit,'(a)')
      write(iunit,'(2(5x,"#",3x,"Z",3x),26x,8x,"value/Å",6x,"actual/Å")')
      do m = 1, potset%dist%n
         mm = 2*m-1
         i = potset%dist%atoms(mm)
         j = potset%dist%atoms(mm+1)
         val0 = potset%dist%val(m)
         val = sqrt(sum((xyz(:,i)-xyz(:,j))**2))
         write(iunit,'(2(i6,1x,i3,1x,a2),26x,1x,2f14.7)') &
            i,at(i),toSymbol(at(i)), &
            j,at(j),toSymbol(at(j)), &
            val0*autoaa, val*autoaa
      enddo
      write(iunit,'(a)')
      write(iunit,'(5x,a,f14.7)') " applied force constant per dist.:", &
         potset%dist%fc
      write(iunit,'(5x,a,f14.7)') "effective force constant per atom:", &
         potset%dist%fc/2.0_wp

      g = 0.0_wp
      e = 0.0_wp
      call constrain_dist(potset%dist,n,at,xyz,g,e)
      efix = efix+e
      gfix = gfix+mctc_nrm2(g)
      write(iunit,'(5x,a,2f14.7)')"    constraining energy/grad norm:", &
         e,mctc_nrm2(g)

      write(iunit,'(a)')
   endif

   if (potset%angle%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') potset%angle%n,"constrained angles"
      write(iunit,'(a)')
      write(iunit,'(3(5x,"#",3x,"Z",3x),13x,8x,"value/°",6x,"actual/°")')
      do m = 1, potset%angle%n
         mm = 3*m-2
         i = potset%angle%atoms(mm)
         j = potset%angle%atoms(mm+1)
         k = potset%angle%atoms(mm+2)
         val0 = potset%angle%val(m)
         call bangl(xyz,i,j,k,val)
         write(iunit,'(3(i6,1x,i3,1x,a2),13x,1x,2f14.7)') &
            i,at(i),toSymbol(at(i)), &
            j,at(j),toSymbol(at(j)), &
            k,at(k),toSymbol(at(k)), &
            val0*180.0_wp/pi, val*180.0_wp/pi
      enddo
      write(iunit,'(a)')
      write(iunit,'(5x,a,f14.7)') " applied force constant per angle:", &
         potset%angle%fc
      write(iunit,'(5x,a,f14.7)') "effective force constant per atom:", &
         potset%angle%fc/3.0_wp

      g = 0.0_wp
      e = 0.0_wp
      call constrain_angle(potset%angle,n,at,xyz,g,e)
      efix = efix+e
      gfix = gfix+mctc_nrm2(g)
      write(iunit,'(5x,a,2f14.7)')"    constraining energy/grad norm:", &
         e,mctc_nrm2(g)

      write(iunit,'(a)')
   endif

   if (potset%dihedral%n.gt.0) then
      write(iunit,'(1x,"*",1x,i0,1x,a)') potset%dihedral%n, &
         "constrained dihedral angles"
      write(iunit,'(a)')
      write(iunit,'(4(5x,"#",3x,"Z",3x),8x,"value/°",6x,"actual/°")')
      do m = 1, potset%dihedral%n
         mm = 4*m-3
         i = potset%dihedral%atoms(mm)
         j = potset%dihedral%atoms(mm+1)
         k = potset%dihedral%atoms(mm+2)
         l = potset%dihedral%atoms(mm+3)
         val0 = potset%dihedral%val(m)
         val = valijkl(n,xyz,i,j,k,l)
         write(iunit,'(4(i6,1x,i3,1x,a2),1x,2f14.7)') &
            i,at(i),toSymbol(at(i)), &
            j,at(j),toSymbol(at(j)), &
            k,at(k),toSymbol(at(k)), &
            l,at(l),toSymbol(at(l)), &
            val0*180.0_wp/pi, val*180.0_wp/pi
      enddo
      write(iunit,'(a)')
      write(iunit,'(5x,a,f14.7)') " applied force constant per angle:", &
         potset%dihedral%fc
      write(iunit,'(5x,a,f14.7)') "effective force constant per atom:", &
         potset%dihedral%fc/4.0_wp

      g = 0.0_wp
      e = 0.0_wp
      call constrain_dihedral(potset%dihedral,n,at,xyz,g,e)
      efix = efix+e
      gfix = gfix+mctc_nrm2(g)
      write(iunit,'(5x,a,2f14.7)')"    constraining energy/grad norm:", &
         e,mctc_nrm2(g)

      write(iunit,'(a)')
   endif
   if (potset%n.gt.0 .or. potset%pos%n.gt.0) then
      write(iunit,'(5x,a,2f14.7)')"total constraint energy/grad norm:", &
         efix, gfix
      write(iunit,'(a)')
   endif

end subroutine pot_info

subroutine constrain_all_bonds(n,at,xyz)
   use xtb_mctc_param, only: rad => covalent_radius_2009
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,j
   integer  :: ioffset
   real(wp) :: r,r0
   real(wp),parameter :: f = 1.2_wp

   do i = 1, n
      do j = 1, i-1
         r  = sqrt(sum((xyz(:,i)-xyz(:,j))**2))
         r0 = rad(at(j))+rad(at(i))
         if (r.lt.f*r0) then
            ioffset = 2*potset%dist%n
            potset%dist%n = potset%dist%n+1
            potset%dist%atoms(ioffset+1) = j
            potset%dist%atoms(ioffset+2) = i
            potset%dist%val(potset%dist%n) = r
         endif
      enddo
   enddo

end subroutine constrain_all_bonds

subroutine constrain_all_angles(n,at,xyz)
   use xtb_mctc_constants
   use xtb_mctc_param
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,j,k
   integer  :: ioffset
   real(wp) :: phi
   integer, allocatable :: bond(:,:)
   real(wp),parameter   :: thr = 0.2_wp

   allocate( bond(n,n), source = 0 )
   call get_bonds(n,at,xyz,bond)

   do i = 1, n
      if (bond(i,i).lt.2) cycle
      do j = 1, i-1
         if (i.eq.j) cycle
         if (bond(i,i).lt.2) cycle
         if (bond(j,i).lt.1) cycle
         do k = 1, j-1
            if (i.eq.k .or. j.eq.k) cycle
            if (bond(k,j).lt.1) cycle
            call bangl(xyz,k,j,i,phi)
            if (abs(pi-phi).lt.thr) cycle
            ioffset = 3*potset%angle%n
            potset%angle%n = potset%angle%n+1
            potset%angle%atoms(ioffset+1) = k
            potset%angle%atoms(ioffset+2) = j
            potset%angle%atoms(ioffset+3) = i
            potset%angle%val(potset%angle%n) = phi
         enddo
      enddo
   enddo

end subroutine constrain_all_angles

subroutine constrain_all_torsions(n,at,xyz)
   use xtb_mctc_constants
   use xtb_mctc_param
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,j,k,l
   integer  :: ioffset
   real(wp) :: phi,thijk,thjkl
   integer, allocatable :: bond(:,:)
   real(wp),parameter   :: thr = 0.2_wp
   real(wp),external    :: valijkl

   allocate( bond(n,n), source = 0 )
   call get_bonds(n,at,xyz,bond)

   do i = 1, n
      if (bond(i,i).lt.2) cycle
      do j = 1, n
         if (i.eq.j) cycle
         if (bond(j,i).lt.1 .or. bond(j,j).lt.2) cycle
         do k = 1, n
            if (i.eq.k .or. j.eq.k) cycle
            if (bond(k,j).lt.1 .or. bond(k,k).lt.2) cycle
            do l = 1, n
               if (bond(l,k).lt.1) cycle
               if (i.eq.l .or. j.eq.l .or. k.eq.l) cycle
               call bangl(xyz,k,j,i,thijk)
               call bangl(xyz,l,k,j,thjkl)
               if (abs(pi-thijk).lt.thr .or. abs(pi-thjkl).lt.thr) cycle
               phi = valijkl(n,xyz,l,k,j,i)
               ioffset = 4*potset%dihedral%n
               potset%dihedral%n = potset%dihedral%n+1
               potset%dihedral%atoms(ioffset+1) = l
               potset%dihedral%atoms(ioffset+2) = k
               potset%dihedral%atoms(ioffset+3) = j
               potset%dihedral%atoms(ioffset+4) = i
               potset%dihedral%val(potset%dihedral%n) = phi
            enddo
         enddo
      enddo
   enddo

end subroutine constrain_all_torsions

end module xtb_scanparam

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_dftd4
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   implicit none
   private

   public :: collect_dftd4

contains

!> Collect all exported unit tests
subroutine collect_dftd4(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("2b-nl-pbc3d", test_dftd4_pbc3d_neighbourlist), &
      new_unittest("2b-lp-pbc3d", test_dftd4_pbc3d_latticepoints), &
      new_unittest("3b-nl-pbc3d", test_dftd4_pbc3d_threebody_neighs), &
      new_unittest("3b-nl-pbc3d", test_dftd4_pbc3d_threebody_latp) &
      ]

end subroutine collect_dftd4


subroutine test_dftd4_pbc3d_neighbourlist(error)
   use xtb_mctc_accuracy, only : wp

   use xtb_mctc_convert, only : aatoau

   use xtb_type_dispersionmodel, only : TDispersionModel
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_molecule, only : TMolecule, init, len
   use xtb_type_neighbourlist, only : TNeighbourList, init
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_param, only : dftd_parameter

   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType, &
      & cutCoordinationNumber
   use xtb_disp_dftd4, only : d4_gradient, p_refq_goedecker, newD4Model
   use xtb_disp_encharges, only : getENCharges

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 32
   integer, parameter :: at(nat) = [8, 8, 8, 8, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.5853168464880421_wp,  4.9392326929575878_wp,  4.1894081210748118_wp,  &
      & 5.8862267152491423_wp,  1.1425258978245871_wp,  6.5015058204768126_wp,  &
      & 1.4284279616220412_wp,  4.6017511285540875_wp,  3.1465884436348119_wp,  &
      & 2.3323404704521411_wp,  1.4471801154820869_wp,  0.7121932185858125_wp,  &
      & 4.7333543155561415_wp,  2.7747291872305868_wp,  3.1951352976178122_wp,  &
      & 5.6617754419101418_wp,  2.2133191164485870_wp,  2.1235404838618126_wp,  &
      & 5.3107598618381422_wp,  2.6902988056185868_wp,  0.7384466319968125_wp,  &
      & 4.4947071071761426_wp,  3.9530790692635867_wp,  0.6801776747598124_wp,  &
      & 4.8005171923760424_wp,  4.9185102874975870_wp,  1.8186363449528122_wp,  &
      & 4.6951362687070421_wp,  4.2781752812835867_wp,  3.1816411821728123_wp,  &
      & 1.3838574419160412_wp,  5.2817805008910863_wp,  4.1482702947948136_wp,  &
      & 1.0268974195990415_wp,  4.7234752637800881_wp,  5.4989995400388123_wp,  &
      & 2.0852659694760409_wp,  5.0956317453800875_wp,  6.5351699846458127_wp,  &
      & 2.3344644666691412_wp, -0.0736561690909131_wp,  6.4245628001158135_wp,  &
      & 2.4894017448231409_wp,  0.6213510313930869_wp,  5.0967297417158131_wp,  &
      & 1.5745272273791413_wp,  0.1243470825760870_wp,  3.9731040773988129_wp,  &
      & 5.8221065925130420_wp,  5.3013563342055878_wp,  1.7264876737078123_wp,  &
      & 3.4487807319551416_wp,  3.6355832152975864_wp,  0.7429568016758125_wp,  &
      & 4.8499393376520423_wp,  3.4713855169305874_wp,  6.4691872586348129_wp,  &
      & 0.2495364434351412_wp,  2.4795455690160870_wp,  2.1043557230378123_wp,  &
      & 5.6691068338331423_wp,  1.1234174220755870_wp,  2.1414388326468128_wp,  &
      & 3.7072009289431418_wp,  2.4357632918535872_wp,  3.0094700999208119_wp,  &
      & 4.1414520030430415_wp,  5.7877262477775879_wp,  1.7803680119358125_wp,  &
      & 5.0142851411171421_wp,  2.4165926460955873_wp,  4.1857610486448129_wp,  &
      & 3.0280930003030413_wp,  4.6201081184690871_wp,  6.2533190952188136_wp,  &
      & 0.5863628696651412_wp,  0.5757236365910867_wp,  4.1021714214668128_wp,  &
      & 2.3776130524831411_wp,  1.6969724987740866_wp,  5.2327688986668139_wp,  &
      & 1.9486148363011413_wp,  0.4390675147070869_wp,  2.9999022491838123_wp,  &
      & 3.5312997625581413_wp,  0.4467415528495868_wp,  4.8114121395028135_wp,  &
      & 6.5089895990100421_wp,  5.2100409408535882_wp,  6.0066553789008132_wp,  &
      & 0.9001165013630412_wp,  3.6420787128610868_wp,  5.4413106648508132_wp,  &
      & 1.6012116650460413_wp,  5.6845471271780879_wp,  0.7675566847298124_wp], &
      & shape(xyz)) * aatoau
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[6.4411018522600_wp,    0.0492571261505_wp,    0.2192046129910_wp,  &
      & 0.0462076831749_wp,    6.6435057067500_wp,    0.1670513770770_wp,  &
      & 0.2262248220170_wp,   -0.9573234940220_wp,    6.7608039126200_wp], &
      & shape(lattice)) * aatoau
   type(dftd_parameter),parameter :: dparam_pbe = dftd_parameter ( &
      & s6=1.0_wp, s8=0.95948085_wp, a1=0.38574991_wp, a2=4.80688534_wp, s9=0.0_wp)
   real(wp),parameter :: g_a = 3.0_wp
   real(wp),parameter :: g_c = 2.0_wp
   real(wp),parameter :: wf  = 6.0_wp
   integer, parameter :: refqmode = p_refq_goedecker

   type(TMolecule) :: mol
   type(TEnvironment) :: env
   type(TLatticePoint) :: latp
   type(TNeighbourlist) :: neighList
   type(TDispersionModel) :: dispm

   integer, allocatable :: neighs(:)
   real(wp), allocatable :: trans(:, :)

   integer :: ii, jj
   real(wp) :: er, el, eps(3, 3)
   real(wp), parameter :: step = 1.0e-5_wp, step2 = 0.5_wp/step
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   real(wp) :: energy, sigma(3, 3), sdum(3, 3)
   real(wp), allocatable :: gradient(:, :), gdum(:, :)
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: q(:), dqdr(:,:,:), dqdL(:,:,:)

   call init(env)

   call init(mol, at, xyz, lattice=lattice)

   call newD4Model(dispm,g_a,g_c,refqmode)
   allocate(neighs(nat))
   allocate(cn(nat), dcndr(3, nat, nat), dcndL(3, 3, nat))
   allocate(q(nat), dqdr(3, nat, nat), dqdL(3, 3, nat))
   allocate(gradient(3, nat), gdum(3, nat))

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call init(latp, env, mol, 60.0_wp)  ! Fixed cutoff
   call latp%getLatticePoints(trans, 60.0_wp)
   call init(neighList, len(mol))
   call neighList%generate(env, mol%xyz, 60.0_wp, trans, .false.)

!   cn(:) = 0.0_wp
!   dcndr(:, :, :) = 0.0_wp
!   dcndL(:, :, :) = 0.0_wp

   q(:) = 0.0_wp
   dqdr(:, :, :) = 0.0_wp
   dqdL(:, :, :) = 0.0_wp

   call neighlist%getNeighs(neighs, 40.0_wp)
   call getCoordinationNumber(mol, neighs, neighList, cnType%erf, &
      & cn, dcndr, dcndL)
   call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)
   call getENCharges(env, mol, cn, dcndr, dcndL, q, dqdr, dqdL)
   call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
      & cn, dcndr, dcndL)
   call neighlist%getNeighs(neighs, 60.0_wp)
   call d4_gradient(mol, dispm, neighs, neighList, dparam_pbe, g_a, g_c, wf, &
      & cn, dcndr, dcndL, q, dqdr, dqdL, energy, gradient, sigma)

   call check(error, energy, -0.73670210332109E-01_wp, thr=thr)
   call check(error, norm2(gradient), 0.67876404541808E-03_wp, thr=thr)

   call check(error, gradient(1, 3), -0.48796348327688E-04_wp, thr=thr)
   call check(error, gradient(2, 7),  0.85632660892000E-04_wp, thr=thr)
   call check(error, gradient(3,12),  0.15057422955536E-04_wp, thr=thr)

   call check(error, sigma(1,1),  0.80650010267247E-01_wp, thr=thr)
   call check(error, sigma(2,1), -0.20505317558255E-03_wp, thr=thr)
   call check(error, sigma(3,2),  0.21880502391427E-02_wp, thr=thr)

   ! check numerical gradient
   ! reduce the number of numerical gradient evaluations significantly
   do ii = 1, 2
      do jj = ii, 3, 2
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call mol%update
         call neighList%update(mol%xyz, trans)
         call neighlist%getNeighs(neighs, 40.0_wp)
         call getCoordinationNumber(mol, neighs, neighList, cnType%erf, &
            & cn, dcndr, dcndL)
         call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)
         call getENCharges(env, mol, cn, dcndr, dcndL, q, dqdr, dqdL)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call neighlist%getNeighs(neighs, 60.0_wp)
         call d4_gradient(mol, dispm, neighs, neighList, dparam_pbe, g_a, g_c, wf, &
            & cn, dcndr, dcndL, q, dqdr, dqdL, er, gdum, sdum)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) - 2*step

         call mol%update
         call neighList%update(mol%xyz, trans)
         call neighlist%getNeighs(neighs, 40.0_wp)
         call getCoordinationNumber(mol, neighs, neighList, cnType%erf, &
            & cn, dcndr, dcndL)
         call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)
         call getENCharges(env, mol, cn, dcndr, dcndL, q, dqdr, dqdL)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call neighlist%getNeighs(neighs, 60.0_wp)
         call d4_gradient(mol, dispm, neighs, neighList, dparam_pbe, g_a, g_c, wf, &
            & cn, dcndr, dcndL, q, dqdr, dqdL, el, gdum, sdum)

         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call check(error, gradient(jj, ii), (er - el)*step2, thr=thr)
      end do
   end do

!   ! check numerical strain derivatives
!   trans2 = trans
!   eps = unity
!   do ii = 1, 3
!      do jj = 1, ii
!         eps(jj, ii) = eps(jj, ii) + step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         !call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            !& cn, dcndr, dcndL)
!         call d4_atm_gradient(mol, dispm, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
!            & cn, dcndr, dcndL, er, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) - 2*step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         call neighList%update(mol%xyz, trans)
!         !call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            !& cn, dcndr, dcndL)
!         call d4_atm_gradient(mol, dispm, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
!            & cn, dcndr, dcndL, el, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) + step
!
!         call check(error, sigma(jj, ii), (er - el)*step2, thr=thr)
!      end do
!   end do


end subroutine test_dftd4_pbc3d_neighbourlist


subroutine test_dftd4_pbc3d_latticepoints(error)
   use xtb_mctc_accuracy, only : wp

   use xtb_mctc_convert, only : aatoau

   use xtb_type_dispersionmodel, only : TDispersionModel
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_molecule, only : TMolecule, init, len
   use xtb_type_neighbourlist, only : TNeighbourList, init
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_wignerseitzcell, only : TWignerSeitzCell, init
   use xtb_type_param, only : dftd_parameter

   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType, &
      & cutCoordinationNumber
   use xtb_disp_dftd4, only : d4_gradient, p_refq_goedecker, newD4Model
   use xtb_disp_encharges, only : getENCharges

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   real(wp),parameter :: thr2 = 1.0e-9_wp
   integer, parameter :: nat = 32
   integer, parameter :: at(nat) = [8, 8, 8, 8, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.5853168464880421_wp,  4.9392326929575878_wp,  4.1894081210748118_wp,  &
      & 5.8862267152491423_wp,  1.1425258978245871_wp,  6.5015058204768126_wp,  &
      & 1.4284279616220412_wp,  4.6017511285540875_wp,  3.1465884436348119_wp,  &
      & 2.3323404704521411_wp,  1.4471801154820869_wp,  0.7121932185858125_wp,  &
      & 4.7333543155561415_wp,  2.7747291872305868_wp,  3.1951352976178122_wp,  &
      & 5.6617754419101418_wp,  2.2133191164485870_wp,  2.1235404838618126_wp,  &
      & 5.3107598618381422_wp,  2.6902988056185868_wp,  0.7384466319968125_wp,  &
      & 4.4947071071761426_wp,  3.9530790692635867_wp,  0.6801776747598124_wp,  &
      & 4.8005171923760424_wp,  4.9185102874975870_wp,  1.8186363449528122_wp,  &
      & 4.6951362687070421_wp,  4.2781752812835867_wp,  3.1816411821728123_wp,  &
      & 1.3838574419160412_wp,  5.2817805008910863_wp,  4.1482702947948136_wp,  &
      & 1.0268974195990415_wp,  4.7234752637800881_wp,  5.4989995400388123_wp,  &
      & 2.0852659694760409_wp,  5.0956317453800875_wp,  6.5351699846458127_wp,  &
      & 2.3344644666691412_wp, -0.0736561690909131_wp,  6.4245628001158135_wp,  &
      & 2.4894017448231409_wp,  0.6213510313930869_wp,  5.0967297417158131_wp,  &
      & 1.5745272273791413_wp,  0.1243470825760870_wp,  3.9731040773988129_wp,  &
      & 5.8221065925130420_wp,  5.3013563342055878_wp,  1.7264876737078123_wp,  &
      & 3.4487807319551416_wp,  3.6355832152975864_wp,  0.7429568016758125_wp,  &
      & 4.8499393376520423_wp,  3.4713855169305874_wp,  6.4691872586348129_wp,  &
      & 0.2495364434351412_wp,  2.4795455690160870_wp,  2.1043557230378123_wp,  &
      & 5.6691068338331423_wp,  1.1234174220755870_wp,  2.1414388326468128_wp,  &
      & 3.7072009289431418_wp,  2.4357632918535872_wp,  3.0094700999208119_wp,  &
      & 4.1414520030430415_wp,  5.7877262477775879_wp,  1.7803680119358125_wp,  &
      & 5.0142851411171421_wp,  2.4165926460955873_wp,  4.1857610486448129_wp,  &
      & 3.0280930003030413_wp,  4.6201081184690871_wp,  6.2533190952188136_wp,  &
      & 0.5863628696651412_wp,  0.5757236365910867_wp,  4.1021714214668128_wp,  &
      & 2.3776130524831411_wp,  1.6969724987740866_wp,  5.2327688986668139_wp,  &
      & 1.9486148363011413_wp,  0.4390675147070869_wp,  2.9999022491838123_wp,  &
      & 3.5312997625581413_wp,  0.4467415528495868_wp,  4.8114121395028135_wp,  &
      & 6.5089895990100421_wp,  5.2100409408535882_wp,  6.0066553789008132_wp,  &
      & 0.9001165013630412_wp,  3.6420787128610868_wp,  5.4413106648508132_wp,  &
      & 1.6012116650460413_wp,  5.6845471271780879_wp,  0.7675566847298124_wp], &
      & shape(xyz)) * aatoau
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[6.4411018522600_wp,    0.0492571261505_wp,    0.2192046129910_wp,  &
      & 0.0462076831749_wp,    6.6435057067500_wp,    0.1670513770770_wp,  &
      & 0.2262248220170_wp,   -0.9573234940220_wp,    6.7608039126200_wp], &
      & shape(lattice)) * aatoau
   type(dftd_parameter),parameter :: dparam_pbe = dftd_parameter ( &
      & s6=1.0_wp, s8=0.95948085_wp, a1=0.38574991_wp, a2=4.80688534_wp, s9=0.0_wp)
   real(wp),parameter :: g_a = 3.0_wp
   real(wp),parameter :: g_c = 2.0_wp
   real(wp),parameter :: wf  = 6.0_wp
   integer, parameter :: refqmode = p_refq_goedecker

   type(TMolecule) :: mol
   type(TEnvironment) :: env
   type(TLatticePoint) :: latp
   type(TNeighbourlist) :: neighList
   type(TDispersionModel) :: dispm

   integer, allocatable :: neighs(:)
   real(wp), allocatable :: trans(:, :), trans2(:, :)

   integer :: ii, jj
   real(wp) :: er, el, eps(3, 3)
   real(wp), parameter :: step = 1.0e-5_wp, step2 = 0.5_wp/step
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   real(wp) :: energy, sigma(3, 3), sdum(3, 3)
   real(wp), allocatable :: gradient(:, :), gdum(:, :)
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: q(:), dqdr(:,:,:), dqdL(:,:,:)

   call init(env)

   call init(mol, at, xyz, lattice=lattice)

   call newD4Model(dispm,g_a,g_c,refqmode)
   allocate(neighs(nat))
   allocate(cn(nat), dcndr(3, nat, nat), dcndL(3, 3, nat))
   allocate(q(nat), dqdr(3, nat, nat), dqdL(3, 3, nat))
   allocate(gradient(3, nat), gdum(3, nat))

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

!   cn(:) = 0.0_wp
!   dcndr(:, :, :) = 0.0_wp
!   dcndL(:, :, :) = 0.0_wp

   q(:) = 0.0_wp
   dqdr(:, :, :) = 0.0_wp
   dqdL(:, :, :) = 0.0_wp

   call init(latp, env, mol, 60.0_wp)  ! Fixed cutoff
   call latp%getLatticePoints(trans, 40.0_wp)
   call init(neighList, len(mol))
   call neighList%generate(env, mol%xyz, 40.0_wp, trans, .false.)

   call neighlist%getNeighs(neighs, 40.0_wp)
   call getCoordinationNumber(mol, neighs, neighList, cnType%erf, &
      & cn, dcndr, dcndL)
   call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)
   call getENCharges(env, mol, cn, dcndr, dcndL, q, dqdr, dqdL)
   call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
      & cn, dcndr, dcndL)
   call latp%getLatticePoints(trans, 60.0_wp)
   call d4_gradient(mol, dispm, trans, dparam_pbe, g_a, g_c, wf, 60.0_wp, &
      & cn, dcndr, dcndL, q, dqdr, dqdL, energy, gradient, sigma)

   call check(error, energy, -0.73670210332109E-01_wp, thr=thr)
   call check(error, norm2(gradient), 0.67876404541808E-03_wp, thr=thr)

   call check(error, gradient(1, 3), -0.48796348327688E-04_wp, thr=thr)
   call check(error, gradient(2, 7),  0.85632660892001E-04_wp, thr=thr)
   call check(error, gradient(3,12),  0.15057422955536E-04_wp, thr=thr)

   call check(error, sigma(1,1),  0.80650010267246E-01_wp, thr=thr)
   call check(error, sigma(2,1), -0.20505317558255E-03_wp, thr=thr)
   call check(error, sigma(3,2),  0.21880502391427E-02_wp, thr=thr)

   ! check numerical gradient
   do ii = 1, nat, 9
      do jj = mod(ii, 2) + 1, 3, 2
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call mol%update
         call neighList%update(mol%xyz, trans)
         call neighlist%getNeighs(neighs, 40.0_wp)
         call getCoordinationNumber(mol, neighs, neighList, cnType%erf, &
            & cn, dcndr, dcndL)
         call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)
         call getENCharges(env, mol, cn, dcndr, dcndL, q, dqdr, dqdL)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call d4_gradient(mol, dispm, trans, dparam_pbe, g_a, g_c, wf, 60.0_wp, &
            & cn, dcndr, dcndL, q, dqdr, dqdL, er, gdum, sdum)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) - 2*step

         call mol%update
         call neighList%update(mol%xyz, trans)
         call neighlist%getNeighs(neighs, 40.0_wp)
         call getCoordinationNumber(mol, neighs, neighList, cnType%erf, &
            & cn, dcndr, dcndL)
         call cutCoordinationNumber(mol%n, cn, dcndr, dcndL, maxCN=8.0_wp)
         call getENCharges(env, mol, cn, dcndr, dcndL, q, dqdr, dqdL)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call d4_gradient(mol, dispm, trans, dparam_pbe, g_a, g_c, wf, 60.0_wp, &
            & cn, dcndr, dcndL, q, dqdr, dqdL, el, gdum, sdum)

         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call check(error, gradient(jj, ii), (er - el)*step2, thr=thr2)
      end do
   end do

!   ! check numerical strain derivatives
!   trans2 = trans
!   eps = unity
!   do ii = 1, 3
!      do jj = 1, ii
!         er = 0.0_wp
!         el = 0.0_wp
!         eps(jj, ii) = eps(jj, ii) + step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         call neighList%update(mol%xyz, trans)
!         call neighlist%getNeighs(neighs, 40.0_wp)
!         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            & cn, dcndr, dcndL)
!         call d4_gradient(mol, trans, dparam_pbe, g_a, g_c, wf, 60.0_wp, &
!            & cn, dcndr, dcndL, er, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) - 2*step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         call neighList%update(mol%xyz, trans)
!         call neighlist%getNeighs(neighs, 40.0_wp)
!         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            & cn, dcndr, dcndL)
!         call d4_gradient(mol, trans, dparam_pbe, g_a, g_c, wf, 60.0_wp, &
!            & cn, dcndr, dcndL, el, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) + step
!
!         call check(error, sigma(jj, ii), (er - el)*step2, thr=thr2)
!      end do
!   end do


end subroutine test_dftd4_pbc3d_latticepoints


subroutine test_dftd4_pbc3d_threebody_neighs(error)
   use xtb_mctc_accuracy, only : wp

   use xtb_mctc_convert, only : aatoau

   use xtb_type_dispersionmodel, only : TDispersionModel
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_molecule, only : TMolecule, init, len
   use xtb_type_neighbourlist, only : TNeighbourList, init
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_wignerseitzcell, only : TWignerSeitzCell, init
   use xtb_type_param, only : dftd_parameter

   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType
   use xtb_disp_dftd4, only : d4_atm_gradient, p_refq_goedecker, newD4Model
   use xtb_disp_encharges, only : getENCharges

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 32
   integer, parameter :: at(nat) = [8, 8, 8, 8, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.5853168464880421_wp,  4.9392326929575878_wp,  4.1894081210748118_wp,  &
      & 5.8862267152491423_wp,  1.1425258978245871_wp,  6.5015058204768126_wp,  &
      & 1.4284279616220412_wp,  4.6017511285540875_wp,  3.1465884436348119_wp,  &
      & 2.3323404704521411_wp,  1.4471801154820869_wp,  0.7121932185858125_wp,  &
      & 4.7333543155561415_wp,  2.7747291872305868_wp,  3.1951352976178122_wp,  &
      & 5.6617754419101418_wp,  2.2133191164485870_wp,  2.1235404838618126_wp,  &
      & 5.3107598618381422_wp,  2.6902988056185868_wp,  0.7384466319968125_wp,  &
      & 4.4947071071761426_wp,  3.9530790692635867_wp,  0.6801776747598124_wp,  &
      & 4.8005171923760424_wp,  4.9185102874975870_wp,  1.8186363449528122_wp,  &
      & 4.6951362687070421_wp,  4.2781752812835867_wp,  3.1816411821728123_wp,  &
      & 1.3838574419160412_wp,  5.2817805008910863_wp,  4.1482702947948136_wp,  &
      & 1.0268974195990415_wp,  4.7234752637800881_wp,  5.4989995400388123_wp,  &
      & 2.0852659694760409_wp,  5.0956317453800875_wp,  6.5351699846458127_wp,  &
      & 2.3344644666691412_wp, -0.0736561690909131_wp,  6.4245628001158135_wp,  &
      & 2.4894017448231409_wp,  0.6213510313930869_wp,  5.0967297417158131_wp,  &
      & 1.5745272273791413_wp,  0.1243470825760870_wp,  3.9731040773988129_wp,  &
      & 5.8221065925130420_wp,  5.3013563342055878_wp,  1.7264876737078123_wp,  &
      & 3.4487807319551416_wp,  3.6355832152975864_wp,  0.7429568016758125_wp,  &
      & 4.8499393376520423_wp,  3.4713855169305874_wp,  6.4691872586348129_wp,  &
      & 0.2495364434351412_wp,  2.4795455690160870_wp,  2.1043557230378123_wp,  &
      & 5.6691068338331423_wp,  1.1234174220755870_wp,  2.1414388326468128_wp,  &
      & 3.7072009289431418_wp,  2.4357632918535872_wp,  3.0094700999208119_wp,  &
      & 4.1414520030430415_wp,  5.7877262477775879_wp,  1.7803680119358125_wp,  &
      & 5.0142851411171421_wp,  2.4165926460955873_wp,  4.1857610486448129_wp,  &
      & 3.0280930003030413_wp,  4.6201081184690871_wp,  6.2533190952188136_wp,  &
      & 0.5863628696651412_wp,  0.5757236365910867_wp,  4.1021714214668128_wp,  &
      & 2.3776130524831411_wp,  1.6969724987740866_wp,  5.2327688986668139_wp,  &
      & 1.9486148363011413_wp,  0.4390675147070869_wp,  2.9999022491838123_wp,  &
      & 3.5312997625581413_wp,  0.4467415528495868_wp,  4.8114121395028135_wp,  &
      & 6.5089895990100421_wp,  5.2100409408535882_wp,  6.0066553789008132_wp,  &
      & 0.9001165013630412_wp,  3.6420787128610868_wp,  5.4413106648508132_wp,  &
      & 1.6012116650460413_wp,  5.6845471271780879_wp,  0.7675566847298124_wp], &
      & shape(xyz)) * aatoau
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[6.4411018522600_wp,    0.0492571261505_wp,    0.2192046129910_wp,  &
      & 0.0462076831749_wp,    6.6435057067500_wp,    0.1670513770770_wp,  &
      & 0.2262248220170_wp,   -0.9573234940220_wp,    6.7608039126200_wp], &
      & shape(lattice)) * aatoau
   type(dftd_parameter),parameter :: dparam_pbe = dftd_parameter ( &
      & s6=1.0_wp, s8=0.95948085_wp, a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp)
   real(wp),parameter :: g_a = 3.0_wp
   real(wp),parameter :: g_c = 2.0_wp
   real(wp),parameter :: wf  = 6.0_wp
   integer, parameter :: refqmode = p_refq_goedecker

   type(TMolecule) :: mol
   type(TEnvironment) :: env
   type(TLatticePoint) :: latp
   type(TNeighbourlist) :: neighList
   type(TDispersionModel) :: dispm

   integer, allocatable :: neighs(:)
   real(wp), allocatable :: trans(:, :), trans2(:, :)

   integer :: ii, jj
   real(wp) :: er, el, eps(3, 3)
   real(wp), parameter :: step = 1.0e-5_wp, step2 = 0.5_wp/step
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   real(wp) :: energy, sigma(3, 3), sdum(3, 3)
   real(wp), allocatable :: gradient(:, :), gdum(:, :)
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: q(:), dqdr(:,:,:), dqdL(:,:,:)

   call init(env)

   call init(mol, at, xyz)

   call newD4Model(dispm,g_a,g_c,refqmode)
   allocate(neighs(nat))
   allocate(cn(nat), dcndr(3, nat, nat), dcndL(3, 3, nat))
   allocate(gradient(3, nat), gdum(3, nat))

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call init(latp, env, mol, 15.0_wp)  ! Fixed cutoff
   call latp%getLatticePoints(trans, 15.0_wp)
   call init(neighList, len(mol))
   call neighList%generate(env, mol%xyz, 15.0_wp, trans, .false.)

   call neighlist%getNeighs(neighs, 15.0_wp)
   call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
      & cn, dcndr, dcndL)
   call d4_atm_gradient(mol, dispm, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
      & cn, dcndr, dcndL, energy, gradient, sigma)

   call check(error, energy, 0.44030151321408E-03_wp, thr=thr)
   call check(error, norm2(gradient), 0.54938536852646E-04_wp, thr=thr)

   call check(error, gradient(1, 3), -0.44803663456486E-05_wp, thr=thr)
   call check(error, gradient(2, 7), -0.11366396738396E-05_wp, thr=thr)
   call check(error, gradient(3,12), -0.76710649053134E-05_wp, thr=thr)

   call check(error, sigma(1,1), -0.18373605865520E-03_wp, thr=thr)
   call check(error, sigma(2,1), -0.33090837432067E-04_wp, thr=thr)
   call check(error, sigma(3,2),  0.34358178263607E-04_wp, thr=thr)

   ! check numerical gradient
   do ii = 1, nat, 5
      do jj = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call mol%update
         call neighList%update(mol%xyz, trans)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call d4_atm_gradient(mol, dispm, neighs, neighlist, dparam_pbe, &
            & g_a, g_c, wf, cn, dcndr, dcndL, er, gdum, sdum)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) - 2*step
         call mol%update
         call neighList%update(mol%xyz, trans)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call d4_atm_gradient(mol, dispm, neighs, neighlist, dparam_pbe, &
            & g_a, g_c, wf, cn, dcndr, dcndL, el, gdum, sdum)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call check(error, gradient(jj, ii), (er - el)*step2, thr=thr)
      end do
   end do

!   ! check numerical strain derivatives
!   trans2 = trans
!   eps = unity
!   do ii = 1, 3
!      do jj = 1, ii
!         eps(jj, ii) = eps(jj, ii) + step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         !call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            !& cn, dcndr, dcndL)
!         call d4_atm_gradient(mol, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
!            & cn, dcndr, dcndL, er, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) - 2*step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         call neighList%update(mol%xyz, trans)
!         !call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            !& cn, dcndr, dcndL)
!         call d4_atm_gradient(mol, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
!            & cn, dcndr, dcndL, el, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) + step
!
!         call check(error, sigma(jj, ii), (er - el)*step2, thr=thr)
!      end do
!   end do

end subroutine test_dftd4_pbc3d_threebody_neighs


subroutine test_dftd4_pbc3d_threebody_latp(error)
   use xtb_mctc_accuracy, only : wp

   use xtb_mctc_convert, only : aatoau

   use xtb_type_dispersionmodel, only : TDispersionModel
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_molecule, only : TMolecule, init, len
   use xtb_type_neighbourlist, only : TNeighbourList, init
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_wignerseitzcell, only : TWignerSeitzCell, init
   use xtb_type_param, only : dftd_parameter

   use xtb_disp_coordinationnumber, only : getCoordinationNumber, cnType
   use xtb_disp_dftd4, only : d4_atm_gradient, p_refq_goedecker, newD4Model
   use xtb_disp_encharges, only : getENCharges

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 32
   integer, parameter :: at(nat) = [8, 8, 8, 8, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[4.5853168464880421_wp,  4.9392326929575878_wp,  4.1894081210748118_wp,  &
      & 5.8862267152491423_wp,  1.1425258978245871_wp,  6.5015058204768126_wp,  &
      & 1.4284279616220412_wp,  4.6017511285540875_wp,  3.1465884436348119_wp,  &
      & 2.3323404704521411_wp,  1.4471801154820869_wp,  0.7121932185858125_wp,  &
      & 4.7333543155561415_wp,  2.7747291872305868_wp,  3.1951352976178122_wp,  &
      & 5.6617754419101418_wp,  2.2133191164485870_wp,  2.1235404838618126_wp,  &
      & 5.3107598618381422_wp,  2.6902988056185868_wp,  0.7384466319968125_wp,  &
      & 4.4947071071761426_wp,  3.9530790692635867_wp,  0.6801776747598124_wp,  &
      & 4.8005171923760424_wp,  4.9185102874975870_wp,  1.8186363449528122_wp,  &
      & 4.6951362687070421_wp,  4.2781752812835867_wp,  3.1816411821728123_wp,  &
      & 1.3838574419160412_wp,  5.2817805008910863_wp,  4.1482702947948136_wp,  &
      & 1.0268974195990415_wp,  4.7234752637800881_wp,  5.4989995400388123_wp,  &
      & 2.0852659694760409_wp,  5.0956317453800875_wp,  6.5351699846458127_wp,  &
      & 2.3344644666691412_wp, -0.0736561690909131_wp,  6.4245628001158135_wp,  &
      & 2.4894017448231409_wp,  0.6213510313930869_wp,  5.0967297417158131_wp,  &
      & 1.5745272273791413_wp,  0.1243470825760870_wp,  3.9731040773988129_wp,  &
      & 5.8221065925130420_wp,  5.3013563342055878_wp,  1.7264876737078123_wp,  &
      & 3.4487807319551416_wp,  3.6355832152975864_wp,  0.7429568016758125_wp,  &
      & 4.8499393376520423_wp,  3.4713855169305874_wp,  6.4691872586348129_wp,  &
      & 0.2495364434351412_wp,  2.4795455690160870_wp,  2.1043557230378123_wp,  &
      & 5.6691068338331423_wp,  1.1234174220755870_wp,  2.1414388326468128_wp,  &
      & 3.7072009289431418_wp,  2.4357632918535872_wp,  3.0094700999208119_wp,  &
      & 4.1414520030430415_wp,  5.7877262477775879_wp,  1.7803680119358125_wp,  &
      & 5.0142851411171421_wp,  2.4165926460955873_wp,  4.1857610486448129_wp,  &
      & 3.0280930003030413_wp,  4.6201081184690871_wp,  6.2533190952188136_wp,  &
      & 0.5863628696651412_wp,  0.5757236365910867_wp,  4.1021714214668128_wp,  &
      & 2.3776130524831411_wp,  1.6969724987740866_wp,  5.2327688986668139_wp,  &
      & 1.9486148363011413_wp,  0.4390675147070869_wp,  2.9999022491838123_wp,  &
      & 3.5312997625581413_wp,  0.4467415528495868_wp,  4.8114121395028135_wp,  &
      & 6.5089895990100421_wp,  5.2100409408535882_wp,  6.0066553789008132_wp,  &
      & 0.9001165013630412_wp,  3.6420787128610868_wp,  5.4413106648508132_wp,  &
      & 1.6012116650460413_wp,  5.6845471271780879_wp,  0.7675566847298124_wp], &
      & shape(xyz)) * aatoau
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[6.4411018522600_wp,    0.0492571261505_wp,    0.2192046129910_wp,  &
      & 0.0462076831749_wp,    6.6435057067500_wp,    0.1670513770770_wp,  &
      & 0.2262248220170_wp,   -0.9573234940220_wp,    6.7608039126200_wp], &
      & shape(lattice)) * aatoau
   type(dftd_parameter),parameter :: dparam_pbe = dftd_parameter ( &
      & s6=1.0_wp, s8=0.95948085_wp, a1=0.38574991_wp, a2=4.80688534_wp, s9=1.0_wp)
   real(wp),parameter :: g_a = 3.0_wp
   real(wp),parameter :: g_c = 2.0_wp
   real(wp),parameter :: wf  = 6.0_wp
   integer, parameter :: refqmode = p_refq_goedecker

   type(TMolecule) :: mol
   type(TEnvironment) :: env
   type(TLatticePoint) :: latp
   type(TNeighbourlist) :: neighList
   type(TDispersionModel) :: dispm

   integer, allocatable :: neighs(:)
   real(wp), allocatable :: trans(:, :), trans2(:, :)

   integer :: ii, jj
   real(wp) :: er, el, eps(3, 3)
   real(wp), parameter :: step = 1.0e-5_wp, step2 = 0.5_wp/step
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   real(wp) :: energy, sigma(3, 3), sdum(3, 3)
   real(wp), allocatable :: gradient(:, :), gdum(:, :)
   real(wp), allocatable :: cn(:), dcndr(:, :, :), dcndL(:, :, :)
   real(wp), allocatable :: q(:), dqdr(:,:,:), dqdL(:,:,:)

   call init(env)

   call init(mol, at, xyz)

   call newD4Model(dispm,g_a,g_c,refqmode)
   allocate(neighs(nat))
   allocate(cn(nat), dcndr(3, nat, nat), dcndL(3, 3, nat))
   allocate(gradient(3, nat), gdum(3, nat))

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp

   call init(latp, env, mol, 15.0_wp)  ! Fixed cutoff
   call latp%getLatticePoints(trans, 15.0_wp)
   call init(neighList, len(mol))
   call neighList%generate(env, mol%xyz, 15.0_wp, trans, .false.)

   call neighlist%getNeighs(neighs, 15.0_wp)
   call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
      & cn, dcndr, dcndL)
   call d4_atm_gradient(mol, dispm, trans, dparam_pbe, g_a, g_c, wf, 15.0_wp, &
      & cn, dcndr, dcndL, energy, gradient, sigma)

   call check(error, energy, 0.44070137748975E-03_wp, thr=thr)
   call check(error, norm2(gradient), 0.54976067894467E-04_wp, thr=thr)

   call check(error, gradient(1, 3), -0.44417914354499E-05_wp, thr=thr)
   call check(error, gradient(2, 7), -0.11543946516301E-05_wp, thr=thr)
   call check(error, gradient(3,12), -0.76778342664578E-05_wp, thr=thr)

   call check(error, sigma(1,1), -0.18394332445576E-03_wp, thr=thr)
   call check(error, sigma(2,1), -0.33093630257770E-04_wp, thr=thr)
   call check(error, sigma(3,2),  0.34563088053137E-04_wp, thr=thr)

   ! check numerical gradient
   do ii = 1, nat, 5
      do jj = 1, 3
         er = 0.0_wp
         el = 0.0_wp
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call mol%update
         call neighList%update(mol%xyz, trans)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call d4_atm_gradient(mol, dispm, trans, dparam_pbe, g_a, g_c, wf, &
            & 15.0_wp, cn, dcndr, dcndL, er, gdum, sdum)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) - 2*step
         call mol%update
         call neighList%update(mol%xyz, trans)
         call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
            & cn, dcndr, dcndL)
         call d4_atm_gradient(mol, dispm, trans, dparam_pbe, g_a, g_c, wf, &
            & 15.0_wp, cn, dcndr, dcndL, el, gdum, sdum)
         mol%xyz(jj, ii) = mol%xyz(jj, ii) + step
         call check(error, gradient(jj, ii), (er - el)*step2, thr=thr)
      end do
   end do

!   ! check numerical strain derivatives
!   trans2 = trans
!   eps = unity
!   do ii = 1, 3
!      do jj = 1, ii
!         eps(jj, ii) = eps(jj, ii) + step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         !call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            !& cn, dcndr, dcndL)
!         call d4_atm_gradient(mol, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
!            & cn, dcndr, dcndL, er, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) - 2*step
!         mol%lattice(:, :) = matmul(eps, lattice)
!         mol%xyz(:, :) = matmul(eps, xyz)
!         trans(:, :) = matmul(eps, trans2)
!         call mol%update
!         call neighList%update(mol%xyz, trans)
!         !call getCoordinationNumber(mol, neighs, neighList, cnType%cov, &
!            !& cn, dcndr, dcndL)
!         call d4_atm_gradient(mol, neighs, neighlist, dparam_pbe, g_a, g_c, wf, &
!            & cn, dcndr, dcndL, el, gdum, sdum)
!
!         eps(jj, ii) = eps(jj, ii) + step
!
!         call check(error, sigma(jj, ii), (er - el)*step2, thr=thr)
!      end do
!   end do

end subroutine test_dftd4_pbc3d_threebody_latp

end module test_dftd4

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_detrotra
  implicit none
  private
  public :: detrotra4, detrotra8

  contains

  subroutine detrotra4(linear,mol,h,eig)
    use xtb_mctc_accuracy, only : sp, wp
    use xtb_type_molecule
    implicit none
    type(TMolecule), intent(in) :: mol
    real(sp), intent(in)    :: h(3*mol%n,3*mol%n)    ! values from projected Lindh diag
    real(sp), intent(inout) :: eig(3*mol%n)          ! eigenvectors from projected Lindh diag
    logical, intent(in)     :: linear
  
    integer               :: i,j,k,kk,ii,nn,n3,nend
    integer,allocatable   :: ind(:)
    real(wp), allocatable :: tmp(:,:)
    real(wp), allocatable :: e(:)
    real(wp)              :: a0,b0,c0
  
    n3 = 3*mol%n
  
    allocate(tmp(3,mol%n),e(n3),ind(n3))
  
    nn = 0
    do ii=1, n3
       if(eig(ii).gt.0.05) cycle  ! only lowest checked
  
       kk=0
       do j=1,mol%n
          do k=1,3
             kk=kk+1
             tmp(k,j)=mol%xyz(k,j)+h(kk,ii) ! distort along mode ii
          enddo
       enddo
  
       c0=0            ! compared all interatomic distances of original and distortet geom.
       do i=2,mol%n
          do j=1,i-1
             a0 = sqrt((mol%xyz(1,i)-mol%xyz(1,j))**2+(mol%xyz(2,i)-mol%xyz(2,j))**2+(mol%xyz(3,i)-mol%xyz(3,j))**2)
             b0 = sqrt((tmp(1,i)-tmp(1,j))**2+(tmp(2,i)-tmp(2,j))**2+(tmp(3,i)-tmp(3,j))**2)
             c0 = c0+(a0-b0)**2   
          enddo
       enddo
       nn = nn + 1
       e(nn)=sqrt(c0/mol%n)*abs(eig(ii))  ! weight by Lindh eigenvalue
       ind(nn)=nn
  
    enddo
  
    call qsort(e, 1, nn, ind)   ! sort
  
    nend = 6
    if (linear) nend = 5
  
    do i=1,nend
       eig(ind(i)) = 0.0  ! identifier for rot/tra
    enddo
  
  end subroutine detrotra4
  
  subroutine detrotra8(linear,n,xyz,h,eig)
    use xtb_mctc_accuracy, only : wp
    use xtb_type_molecule
    implicit none
    integer, intent(in)     :: n
    real(wp), intent(in)    :: xyz(3,n)    ! values from projected Lindh diag
    real(wp), intent(in)    :: h(3*n,3*n)    ! values from projected Lindh diag
    real(wp), intent(inout) :: eig(3*n)          ! eigenvectors from projected Lindh diag
    logical, intent(in)     :: linear
  
    integer               :: i,j,k,kk,ii,nn,n3,nend
    integer,allocatable   :: ind(:)
    real(wp), allocatable :: tmp(:,:)
    real(wp), allocatable :: e(:)
    real(wp)              :: a0,b0,c0
  
    n3 = 3*n
  
    allocate(tmp(3,n),e(n3),ind(n3))
  
    nn = 0
    do ii=1, n3
       if(eig(ii).gt.0.05) cycle  ! only lowest checked
  
       kk=0
       do j=1,n
          do k=1,3
             kk=kk+1
             tmp(k,j)=xyz(k,j)+h(kk,ii) ! distort along mode ii
          enddo
       enddo
  
       c0=0            ! compared all interatomic distances of original and distortet geom.
       do i=2,n
          do j=1,i-1
             a0 = sqrt((xyz(1,i)-xyz(1,j))**2+(xyz(2,i)-xyz(2,j))**2+(xyz(3,i)-xyz(3,j))**2)
             b0 = sqrt((tmp(1,i)-tmp(1,j))**2+(tmp(2,i)-tmp(2,j))**2+(tmp(3,i)-tmp(3,j))**2)
             c0 = c0+(a0-b0)**2   
          enddo
       enddo
       nn = nn + 1
       e(nn)=sqrt(c0/n)*abs(eig(ii))  ! weight by Lindh eigenvalue
       ind(nn)=nn
  
    enddo
  
    call qsort(e, 1, nn, ind)   ! sort
  
    nend = 6
    if (linear) nend = 5
  
    do i=1,nend
       eig(ind(i)) = 0.0  ! identifier for rot/tra
    enddo
  
  end subroutine detrotra8
  
end module xtb_detrotra

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> implemenation of a list of atoms
module xtb_type_atomlist
   use xtb_mctc_accuracy, only : wp
   implicit none
   public :: TAtomList
   public :: size, len, assignment(=)
   private

   character, parameter :: p_delimiter = ','
   character, parameter :: p_skip = '-'

   type :: TAtomList
      logical, allocatable :: list(:)
      logical :: default = .false.
      character :: delimiter = p_delimiter
      character :: skip = p_skip
      logical :: error = .false.
   contains
      generic :: new => from_integers, from_logicals, from_string, from_defaults
      ! Should be private, but must be declared as public due to PGI bug #28452
      procedure, non_overridable :: from_defaults
      procedure, private :: from_integers => atomlist_assign_integers
      procedure, private :: from_logicals => atomlist_assign_logicals
      procedure, private :: from_string => atomlist_assign_string
      procedure, pass(self) :: to_string => string_assign_atomlist
      procedure, pass(self) :: to_list => list_assign_atomlist
      procedure :: switch_truth => atomlist_switch_truth
      procedure :: set_truth => atomlist_set_truth
      procedure :: get_truth => atomlist_get_truth
      procedure :: get_error => atomlist_get_error
      generic :: remove => remove_integer, remove_integers, remove_logicals
      procedure, private :: remove_integer => atomlist_remove_integer
      procedure, private :: remove_integers => atomlist_remove_integers
      procedure, private :: remove_logicals => atomlist_remove_logicals
      generic :: add => add_integer, add_integers, add_logicals, add_string
      procedure, private :: add_integer => atomlist_add_integer
      procedure, private :: add_integers => atomlist_add_integers
      procedure, private :: add_logicals => atomlist_add_logicals
      procedure, private :: add_string => atomlist_assign_string
      procedure, private :: parse => atomlist_parse_string
      procedure :: resize => atomlist_resize
      generic :: gather => gather_int, gather_real, gather_real_2d
      procedure, private :: gather_int => atomlist_gather_int
      procedure, private :: gather_real => atomlist_gather_real
      procedure, private :: gather_real_2d => atomlist_gather_real_2d
      generic :: scatter => scatter_real_2d
      procedure, private :: scatter_real_2d => atomlist_scatter_real_2d
      procedure :: destroy => atomlist_destroy
      final :: atomlist_finalizer
   end type TAtomList

   interface TAtomList
      module procedure :: atomlist_from_logicals
      module procedure :: atomlist_from_integers
      module procedure :: atomlist_from_string
   end interface TAtomList

   interface len
      module procedure :: atomlist_length
   end interface len

   interface size
      module procedure :: atomlist_size
   end interface size

   interface assignment(=)
      module procedure :: atomlist_assign_logicals
      module procedure :: atomlist_assign_integers
      module procedure :: atomlist_assign_string
      module procedure :: string_assign_atomlist
      module procedure :: list_assign_atomlist
   end interface assignment(=)

contains

pure function atomlist_from_logicals(list, truth, delimiter, skip) result(self)
   logical, intent(in) :: list(:)
   logical, intent(in), optional :: truth
   character, intent(in), optional :: delimiter, skip
   type(TAtomList) :: self
   if (present(truth)) self%default = .not.truth
   if (present(delimiter)) self%delimiter = delimiter
   if (present(skip)) self%skip = skip
   call self%new(list)
end function atomlist_from_logicals

pure function atomlist_from_integers(list, truth, delimiter, skip) result(self)
   integer, intent(in) :: list(:)
   logical, intent(in), optional :: truth
   character, intent(in), optional :: delimiter, skip
   type(TAtomList) :: self
   if (present(truth)) self%default = .not.truth
   if (present(delimiter)) self%delimiter = delimiter
   if (present(skip)) self%skip = skip
   call self%new(list)
end function atomlist_from_integers

pure function atomlist_from_string(list, truth, delimiter, skip) result(self)
   character(len=*), intent(in) :: list
   logical, intent(in), optional :: truth
   character, intent(in), optional :: delimiter, skip
   type(TAtomList) :: self
   if (present(truth)) self%default = .not.truth
   if (present(delimiter)) self%delimiter = delimiter
   if (present(skip)) self%skip = skip
   call self%new(list)
end function atomlist_from_string

subroutine from_defaults(self)
   class(TAtomList), intent(out) :: self
end subroutine from_defaults

pure elemental subroutine atomlist_switch_truth(self)
   class(TAtomList), intent(inout) :: self
   self%default = .not.self%default
end subroutine atomlist_switch_truth

pure elemental subroutine atomlist_set_truth(self, truth)
   class(TAtomList), intent(inout) :: self
   logical, intent(in) :: truth
   self%default = .not.truth
end subroutine atomlist_set_truth

pure elemental function atomlist_get_truth(self) result(truth)
   class(TAtomList), intent(in) :: self
   logical :: truth
   truth = .not.self%default
end function atomlist_get_truth

pure elemental function atomlist_get_error(self) result(error)
   class(TAtomList), intent(in) :: self
   logical :: error
   error = self%error
end function atomlist_get_error

subroutine atomlist_write_formatted(self, unit, iotype, v_list, iostat, iomsg)
   class(TAtomList), intent(in) :: self
   integer, intent(in) :: unit
   character(len=*), intent(in) :: iotype
   integer, intent(in) :: v_list(:)
   integer, intent(out) :: iostat
   character(len=*), intent(inout) :: iomsg
   character(len=:), allocatable :: buffer
   call self%to_string(buffer)
   write(unit, '(a)', iostat=iostat, iomsg=iomsg) buffer
end subroutine atomlist_write_formatted

subroutine atomlist_read_formatted(self, unit, iotype, v_list, iostat, iomsg)
   class(TAtomList), intent(inout) :: self
   integer, intent(in) :: unit
   character(len=*), intent(in) :: iotype
   integer, intent(in) :: v_list(:)
   integer, intent(out) :: iostat
   character(len=*), intent(inout) :: iomsg
   character(len=:), allocatable :: string

   call get_line(unit, string, iostat)
   call self%new(string)

contains

subroutine get_line(unit, line, iostat)
   use, intrinsic :: iso_fortran_env, only : iostat_eor
   integer, intent(in) :: unit
   character(len=:), allocatable, intent(out) :: line
   integer, intent(out), optional :: iostat

   integer, parameter :: buffersize = 256
   character(len=buffersize) :: buffer
   integer :: size
   integer :: err

   line = ''
   do
      read(unit,'(a)',advance='no',iostat=err,size=size)  &
      &    buffer
      if (err.gt.0) then
         if (present(iostat)) iostat=err
         return ! an error occurred
      endif
      line = line // buffer(:size)
      if (err.lt.0) then
         if (err.eq.iostat_eor) err = 0
         if (present(iostat)) iostat=err
         return
      endif
   enddo

end subroutine get_line
end subroutine atomlist_read_formatted

integer pure elemental function atomlist_size(self)
   class(TAtomList), intent(in) :: self
   if (allocated(self%list)) then
      atomlist_size = size(self%list)
   else
      atomlist_size = 0
   endif
end function atomlist_size

integer pure elemental function atomlist_length(self)
   class(TAtomList), intent(in) :: self
   if (allocated(self%list)) then
      atomlist_length = count(self%list.neqv.self%default)
   else
      atomlist_length = 0
   endif
end function atomlist_length

pure subroutine atomlist_add_integer(self, item)
   class(TAtomList), intent(inout) :: self
   integer, intent(in) :: item
   integer :: i
   call self%resize(item)
   self%list(item) = .not.self%default
end subroutine atomlist_add_integer

pure subroutine atomlist_add_integers(self, list)
   class(TAtomList), intent(inout) :: self
   integer, intent(in) :: list(:)
   integer :: i
   call self%resize(maxval(list))
   do i = 1, size(list)
      self%list(list(i)) = .not.self%default
   enddo
end subroutine atomlist_add_integers

pure subroutine atomlist_add_logicals(self, list)
   class(TAtomList), intent(inout) :: self
   logical, intent(in) :: list(:)
   integer :: i
   call self%resize(size(list))
   self%list(:size(list)) = list .or. self%list(:size(list))
end subroutine atomlist_add_logicals

pure subroutine atomlist_remove_integer(self, item)
   class(TAtomList), intent(inout) :: self
   integer, intent(in) :: item
   integer :: i
   call self%resize(item)
   self%list(item) = self%default
end subroutine atomlist_remove_integer

pure subroutine atomlist_remove_integers(self, list)
   class(TAtomList), intent(inout) :: self
   integer, intent(in) :: list(:)
   integer :: i
   call self%resize(maxval(list))
   do i = 1, size(list)
      self%list(list(i)) = self%default
   enddo
end subroutine atomlist_remove_integers

pure subroutine atomlist_remove_logicals(self, list)
   class(TAtomList), intent(inout) :: self
   logical, intent(in) :: list(:)
   integer :: i
   call self%resize(size(list))
   self%list(:size(list)) = list .and. self%list(:size(list))
end subroutine atomlist_remove_logicals

pure subroutine list_assign_atomlist(list, self)
   integer, allocatable, intent(out) :: list(:)
   class(TAtomList), intent(in) :: self
   integer :: i, j
   allocate(list(len(self)), source=0)
   j = 0
   do i = 1, size(self)
      if (self%list(i).neqv.self%default) then
         j = j+1
         list(j) = i
      endif
   enddo
end subroutine list_assign_atomlist

pure subroutine string_assign_atomlist(string, self)
   character(len=:), allocatable, intent(out) :: string
   class(TAtomList), intent(in) :: self
   character(len=10) :: buffer
   integer :: i, last
   logical :: state, first
   last = -1
   first = .true.
   state = .not.self%default
   do i = 1, size(self)
      if (state.eqv.self%list(i)) then
         state = .not.state
         if (state.eqv.self%default) then
            last = i
            write(buffer,'(i0)') i
            if (first) then
               first = .false.
               string = trim(buffer)
            else
               string = string // self%delimiter // trim(buffer)
            endif
         else
            if (i-1 .ne. last) then
               write(buffer,'(i0)') i-1
               string = string // self%skip // trim(buffer)
            endif
         endif
      endif
   enddo
   if (state.eqv.self%default .and.last.ne.size(self)) then
      write(buffer,'(i0)') size(self)
      string = string // self%skip // trim(buffer)
   endif
end subroutine string_assign_atomlist

pure subroutine atomlist_assign_logicals(self, list)
   class(TAtomList), intent(inout) :: self
   logical, intent(in) :: list(:)
   call self%resize(size(list))
   self%list = list
end subroutine atomlist_assign_logicals

pure subroutine atomlist_assign_integers(self, list)
   class(TAtomList), intent(inout) :: self
   integer, intent(in) :: list(:)
   integer :: i
   call self%resize(maxval(list))
   do i = 1, size(list)
      self%list(list(i)) = .not.self%default
   enddo
end subroutine atomlist_assign_integers

pure subroutine atomlist_assign_string(self, string)
   class(TAtomList), intent(inout) :: self
   character(len=*), intent(in) :: string
   character(len=:), allocatable :: buffer
   integer, allocatable :: list(:)
   integer :: pos, last, n

   last = 0
   do
      pos = index(string(last+1:), self%delimiter)
      if (pos > 0) then
         call self%parse(string(last+1:last+pos-1))
         if (self%error) exit
         last = last+pos
      else
         call self%parse(string(last+1:))
         exit
      endif
   enddo

end subroutine atomlist_assign_string

pure subroutine atomlist_parse_string(self, string)
   class(TAtomList), intent(inout) :: self
   character(len=*),intent(in) :: string
   integer :: pos, item, begin, last, err

   pos = index(string,self%skip)
   if (pos.eq.0) then
      read(string,*,iostat=err) item
      if (err.ne.0) then
         self%error = .false.
         return
      endif
      call self%add(item)
   else
      read(string(:pos-1),*,iostat=err) begin
      if (err.ne.0) then
         self%error = .false.
         return
      endif
      read(string(pos+1:),*,iostat=err) last
      if (err.ne.0) then
         self%error = .false.
         return
      endif
      if (last.lt.begin) then
         self%error = .false.
         return
      endif
      do item = begin, last
         call self%add(item)
      enddo
   endif

end subroutine atomlist_parse_string

pure subroutine atomlist_resize(self, n)
   class(TAtomList), intent(inout) :: self
   integer, intent(in), optional :: n
   logical, allocatable :: list(:)
   integer :: length, current_length
   current_length = size(self)
   if (current_length > 0) then
      if (present(n)) then
         if (n <= current_length) return
         length = n
      else
         length = current_length + current_length/2 + 1
      endif
      allocate(list(length), source=self%default)
      list(:current_length) = self%list(:current_length)
      deallocate(self%list)
      call move_alloc(list, self%list)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(self%list(length), source=self%default)
   endif
end subroutine atomlist_resize

subroutine atomlist_gather_int(self, array, selected)
   class(TAtomList), intent(in) :: self
   integer, intent(in) :: array(:)
   integer, allocatable, intent(out) :: selected(:)
   selected = pack(array, mask=self%list.neqv.self%default)
end subroutine atomlist_gather_int

subroutine atomlist_gather_real(self, array, selected)
   class(TAtomList), intent(in) :: self
   real(wp), intent(in) :: array(:)
   real(wp), allocatable, intent(out) :: selected(:)
   selected = pack(array, mask=self%list.neqv.self%default)
end subroutine atomlist_gather_real

subroutine atomlist_gather_real_2d(self, array, selected, dim)
   class(TAtomList), intent(in) :: self
   real(wp), intent(in) :: array(:,:)
   integer, intent(in), optional :: dim
   real(wp), allocatable, intent(out) :: selected(:,:)
   integer :: selected_dim, i, j
   if (present(dim)) then
      selected_dim = dim
   else
      selected_dim = 2
   endif
   if (selected_dim == 1) then
      allocate(selected(len(self), size(array, 2)), source=0.0_wp)
      j = 0
      do i = 1, min(size(array, 1), size(self))
         if (self%list(i).neqv.self%default) then
            j = j+1
            selected(j,:) = array(i,:)
         endif
      enddo
   else
      allocate(selected(size(array, 1), len(self)), source=0.0_wp)
      j = 0
      do i = 1, min(size(array, 2), size(self))
         if (self%list(i).neqv.self%default) then
            j = j+1
            selected(:,j) = array(:,i)
         endif
      enddo
   endif
end subroutine atomlist_gather_real_2d

subroutine atomlist_scatter_real_2d(self, reduced, array, dim, scale)
   class(TAtomList), intent(in) :: self
   real(wp), intent(inout) :: array(:,:)
   integer, intent(in), optional :: dim
   real(wp), intent(in), optional :: scale
   real(wp), intent(in) :: reduced(:,:)
   integer :: selected_dim, i, j
   real(wp) :: alpha
   if (present(dim)) then
      selected_dim = dim
   else
      selected_dim = 2
   endif
   if (present(scale)) then
      alpha = scale
   else
      alpha = 0.0_wp
   endif
   if (selected_dim == 1) then
      j = 0
      do i = 1, min(size(array, 1), size(self))
         if (self%list(i).neqv.self%default) then
            j = j+1
            array(i,:) = reduced(j,:) + alpha * array(i,:)
         endif
      enddo
   else
      j = 0
      do i = 1, min(size(array, 2), size(self))
         if (self%list(i).neqv.self%default) then
            j = j+1
            array(:,i) = reduced(:,j) + alpha * array(:,i)
         endif
      enddo
   endif
end subroutine atomlist_scatter_real_2d

pure elemental subroutine atomlist_destroy(self)
   class(TAtomList), intent(inout) :: self
   if (allocated(self%list)) deallocate(self%list)
end subroutine atomlist_destroy

pure elemental subroutine atomlist_finalizer(self)
   type(TAtomList), intent(inout) :: self
   call self%destroy
end subroutine atomlist_finalizer

end module xtb_type_atomlist

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Utililty functions for dealing with hessian and frequency calculations
module xtb_freq_utils
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_lapack, only : lapack_syev
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: massWeightHessian, diagHessian


contains


subroutine massWeightHessian(hessian, atmass)
   real(wp), intent(inout) :: hessian(:, :)
   real(wp), intent(in) :: atmass(:)

   integer :: ndim, nat
   integer :: iat, ii, jj, ic
   real(wp), allocatable :: isqm(:)

   ndim = size(hessian, 1)
   nat = size(atmass)

   allocate(isqm(ndim))

   do iat = 1, nat
      ic = (iat - 1)*3
      isqm(ic+1:ic+3) = sqrt(1.0_wp/atmass(iat))
   end do

   do ii = 1, ndim
      do jj = 1, ndim
         hessian(jj, ii) = hessian(jj, ii) * isqm(ii) * isqm(jj)
      end do
   end do

end subroutine massWeightHessian


subroutine diagHessian(env, hessian, freq)
   character(len=*), parameter :: source = 'freq_utils_diagHessian'
   type(TEnvironment), intent(inout) :: env
   real(wp), intent(inout) :: hessian(:, :)
   real(wp), intent(out) :: freq(:)
   real(wp), allocatable :: work(:)
   integer :: ndim, lwork, info, ii, nn, zero(6)
   ndim = size(hessian, 1)
   lwork = 1 + 6*ndim + 2*ndim**2
   allocate(work(lwork))
   call lapack_syev('v', 'u', ndim, hessian, ndim, freq, work, lwork, info)

   if (info /= 0) then
      call env%error("Could not diagonalize Hessian", source)
      return
   end if

   do ii = 1, ndim
      freq(ii) = sign(sqrt(abs(freq(ii))), freq(ii))
   end do

   nn = 0
   do ii = 1, ndim
      if (abs(freq(ii)) < 1.0e-2_wp .and. nn < size(zero)) then
         nn = nn + 1
         zero(nn) = ii
      end if
   end do

end subroutine diagHessian


end module xtb_freq_utils

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Interfaces to BLAS
module xtb_mctc_blas_level2
   use xtb_mctc_accuracy, only : sp, dp
#ifdef USE_CUBLAS
   use cublas, only : cublasSgemv, cublasDgemv, cublasSger, cublasDger, &
      & cublasSspmv, cublasDspmv, cublasSspr, cublasDspr, &
      & cublasSspr2, cublasDspr2, cublasSsymv, cublasDsymv, &
      & cublasSsyr, cublasDsyr, cublasSsyr2, cublasDsyr2
#endif
   implicit none
   private

   public :: mctc_gemv, mctc_ger, mctc_spmv, mctc_spr, mctc_spr2, mctc_symv
   public :: mctc_syr, mctc_syr2

   public :: blas_gbmv, blas_gemv, blas_ger, blas_gerc, blas_geru
   public :: blas_hbmv, blas_hemv, blas_her, blas_her2, blas_hpmv, blas_hpr, blas_hpr2
   public :: blas_sbmv, blas_spmv, blas_spr, blas_spr2, blas_symv, blas_syr, blas_syr2
   public :: blas_tbmv, blas_tbsv, blas_tpmv, blas_tpsv, blas_trmv, blas_trsv


   !> Performs one of the matrix-vector operations
   !
   !    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are vectors and A is an
   ! m by n matrix.
   interface mctc_gemv
      module procedure :: mctc_sgemv
      module procedure :: mctc_dgemv
   end interface mctc_gemv

   !> Performs the rank 1 operation
   !
   !    A := alpha*x*y**T + A,
   !
   ! where alpha is a scalar, x is an m element vector, y is an n element
   ! vector and A is an m by n matrix.
   interface mctc_ger
      module procedure :: mctc_sger
      module procedure :: mctc_dger
   end interface mctc_ger

   !> Performs the matrix-vector operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n symmetric matrix, supplied in packed form.
   interface mctc_spmv
      module procedure :: mctc_sspmv
      module procedure :: mctc_dspmv
   end interface mctc_spmv

   !> Performs the symmetric rank 1 operation
   !
   !    A := alpha*x*x**T + A,
   !
   ! where alpha is a real scalar, x is an n element vector and A is an
   ! n by n symmetric matrix, supplied in packed form.
   interface mctc_spr
      module procedure :: mctc_sspr
      module procedure :: mctc_dspr
   end interface mctc_spr

   !> Performs the symmetric rank 2 operation
   !
   !    A := alpha*x*y**T + alpha*y*x**T + A,
   !
   ! where alpha is a scalar, x and y are n element vectors and A is an
   ! n by n symmetric matrix, supplied in packed form.
   interface mctc_spr2
      module procedure :: mctc_sspr2
      module procedure :: mctc_dspr2
   end interface mctc_spr2

   !> Performs the matrix-vector  operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n symmetric matrix.
   interface mctc_symv
      module procedure :: mctc_ssymv
      module procedure :: mctc_dsymv
   end interface mctc_symv

   !> Performs the symmetric rank 1 operation
   !
   !    A := alpha*x*x**T + A,
   !
   ! where alpha is a real scalar, x is an n element vector and A is an
   ! n by n symmetric matrix.
   interface mctc_syr
      module procedure :: mctc_ssyr
      module procedure :: mctc_dsyr
   end interface mctc_syr

   !> Performs the symmetric rank 2 operation
   !
   !    A := alpha*x*y**T + alpha*y*x**T + A,
   !
   ! where alpha is a scalar, x and y are n element vectors and A is an n
   ! by n symmetric matrix.
   interface mctc_syr2
      module procedure :: mctc_ssyr2
      module procedure :: mctc_dsyr2
   end interface mctc_syr2


   !> Performs one of the matrix-vector operations
   !
   !    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are vectors and A is an
   ! m by n band matrix, with kl sub-diagonals and ku super-diagonals.
   interface blas_gbmv
      pure subroutine sgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, &
            & y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         integer, intent(in) :: kl
         integer, intent(in) :: m
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: ku
         integer, intent(in) :: lda
      end subroutine sgbmv
      pure subroutine dgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, &
            & y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         integer, intent(in) :: kl
         integer, intent(in) :: m
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: ku
         integer, intent(in) :: lda
      end subroutine dgbmv
      pure subroutine cgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, &
            & y, incy)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         integer, intent(in) :: kl
         integer, intent(in) :: m
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: ku
         integer, intent(in) :: lda
      end subroutine cgbmv
      pure subroutine zgbmv(trans, m, n, kl, ku, alpha, a, lda, x, incx, beta, &
            & y, incy)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         integer, intent(in) :: kl
         integer, intent(in) :: m
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: ku
         integer, intent(in) :: lda
      end subroutine zgbmv
   end interface blas_gbmv

   !> Performs one of the matrix-vector operations
   !
   !    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are vectors and A is an
   ! m by n matrix.
   interface blas_gemv
      pure subroutine sgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sgemv
      pure subroutine dgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dgemv
      pure subroutine cgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cgemv
      pure subroutine zgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zgemv
      pure subroutine scgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine scgemv
      pure subroutine dzgemv(trans, m, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         character(len=1), intent(in) :: trans
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dzgemv
   end interface blas_gemv

   !> Performs the rank 1 operation
   !
   !    A := alpha*x*y**T + A,
   !
   ! where alpha is a scalar, x is an m element vector, y is an n element
   ! vector and A is an m by n matrix.
   interface blas_ger
      pure subroutine sger(m, n, alpha, x, incx, y, incy, a, lda)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(in) :: y(*)
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sger
      pure subroutine dger(m, n, alpha, x, incx, y, incy, a, lda)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(in) :: y(*)
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dger
   end interface blas_ger

   !> Performs the rank 1 operation
   !
   !    A := alpha*x*y**H + A,
   !
   ! where alpha is a scalar, x is an m element vector, y is an n element
   ! vector and A is an m by n matrix.
   interface blas_gerc
      pure subroutine cgerc(m, n, alpha, x, incx, y, incy, a, lda)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(in) :: y(*)
         complex(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cgerc
      pure subroutine zgerc(m, n, alpha, x, incx, y, incy, a, lda)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(in) :: y(*)
         complex(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zgerc
   end interface blas_gerc

   !> Performs the rank 1 operation
   !
   !    A := alpha*x*y**T + A,
   !
   ! where alpha is a scalar, x is an m element vector, y is an n element
   ! vector and A is an m by n matrix.
   interface blas_geru
      pure subroutine cgeru(m, n, alpha, x, incx, y, incy, a, lda)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(in) :: y(*)
         complex(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cgeru
      pure subroutine zgeru(m, n, alpha, x, incx, y, incy, a, lda)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(in) :: y(*)
         complex(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zgeru
   end interface blas_geru

   !> Performs the matrix-vector  operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n hermitian band matrix, with k super-diagonals.
   interface blas_hbmv
      pure subroutine chbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine chbmv
      pure subroutine zhbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine zhbmv
   end interface blas_hbmv

   !> Performs the matrix-vector  operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n hermitian matrix.
   interface blas_hemv
      pure subroutine chemv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine chemv
      pure subroutine zhemv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zhemv
   end interface blas_hemv

   !> Performs the hermitian rank 1 operation
   !
   !    A := alpha*x*x**H + A,
   !
   ! where alpha is a real scalar, x is an n element vector and A is an
   ! n by n hermitian matrix.
   interface blas_her
      pure subroutine cher(uplo, n, alpha, x, incx, a, lda)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cher
      pure subroutine zher(uplo, n, alpha, x, incx, a, lda)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zher
   end interface blas_her

   !> Performs the hermitian rank 2 operation
   !
   !    A := alpha*x*y**H + conjg( alpha )*y*x**H + A,
   !
   ! where alpha is a scalar, x and y are n element vectors and A is an n
   ! by n hermitian matrix.
   interface blas_her2
      pure subroutine cher2(uplo, n, alpha, x, incx, y, incy, a, lda)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cher2
      pure subroutine zher2(uplo, n, alpha, x, incx, y, incy, a, lda)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zher2
   end interface blas_her2

   !> Performs the matrix-vector operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n hermitian matrix, supplied in packed form.
   interface blas_hpmv
      pure subroutine chpmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
         import :: sp
         complex(sp), intent(in) :: ap(*)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         complex(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine chpmv
      pure subroutine zhpmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
         import :: dp
         complex(dp), intent(in) :: ap(*)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         complex(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine zhpmv
   end interface blas_hpmv

   !> Performs the hermitian rank 1 operation
   !
   !    A := alpha*x*x**H + A,
   !
   ! where alpha is a real scalar, x is an n element vector and A is an
   ! n by n hermitian matrix, supplied in packed form.
   interface blas_hpr
      pure subroutine chpr(uplo, n, alpha, x, incx, ap)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         complex(sp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine chpr
      pure subroutine zhpr(uplo, n, alpha, x, incx, ap)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         complex(dp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine zhpr
   end interface blas_hpr

   !> Performs the hermitian rank 2 operation
   !
   !    A := alpha*x*y**H + conjg( alpha )*y*x**H + A,
   !
   ! where alpha is a scalar, x and y are n element vectors and A is an
   ! n by n hermitian matrix, supplied in packed form.
   interface blas_hpr2
      pure subroutine chpr2(uplo, n, alpha, x, incx, y, incy, ap)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine chpr2
      pure subroutine zhpr2(uplo, n, alpha, x, incx, y, incy, ap)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         complex(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine zhpr2
   end interface blas_hpr2

   !> Performs the matrix-vector  operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n symmetric band matrix, with k super-diagonals.
   interface blas_sbmv
      pure subroutine ssbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine ssbmv
      pure subroutine dsbmv(uplo, n, k, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine dsbmv
   end interface blas_sbmv

   !> Performs the matrix-vector operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n symmetric matrix, supplied in packed form.
   interface blas_spmv
      pure subroutine sspmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: ap(*)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine sspmv
      pure subroutine dspmv(uplo, n, alpha, ap, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: ap(*)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine dspmv
   end interface blas_spmv

   !> Performs the symmetric rank 1 operation
   !
   !    A := alpha*x*x**T + A,
   !
   ! where alpha is a real scalar, x is an n element vector and A is an
   ! n by n symmetric matrix, supplied in packed form.
   interface blas_spr
      pure subroutine sspr(uplo, n, alpha, x, incx, ap)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine sspr
      pure subroutine dspr(uplo, n, alpha, x, incx, ap)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine dspr
   end interface blas_spr

   !> Performs the symmetric rank 2 operation
   !
   !    A := alpha*x*y**T + alpha*y*x**T + A,
   !
   ! where alpha is a scalar, x and y are n element vectors and A is an
   ! n by n symmetric matrix, supplied in packed form.
   interface blas_spr2
      pure subroutine sspr2(uplo, n, alpha, x, incx, y, incy, ap)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(in) :: x(*)
         real(sp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine sspr2
      pure subroutine dspr2(uplo, n, alpha, x, incx, y, incy, ap)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(in) :: x(*)
         real(dp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine dspr2
   end interface blas_spr2

   !> Performs the matrix-vector  operation
   !
   !    y := alpha*A*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are n element vectors and
   ! A is an n by n symmetric matrix.
   interface blas_symv
      pure subroutine ssymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         real(sp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ssymv
      pure subroutine dsymv(uplo, n, alpha, a, lda, x, incx, beta, y, incy)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         real(dp), intent(in) :: beta
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dsymv
   end interface blas_symv

   !> Performs the symmetric rank 1 operation
   !
   !    A := alpha*x*x**T + A,
   !
   ! where alpha is a real scalar, x is an n element vector and A is an
   ! n by n symmetric matrix.
   interface blas_syr
      pure subroutine ssyr(uplo, n, alpha, x, incx, a, lda)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ssyr
      pure subroutine dsyr(uplo, n, alpha, x, incx, a, lda)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dsyr
   end interface blas_syr

   !> Performs the symmetric rank 2 operation
   !
   !    A := alpha*x*y**T + alpha*y*x**T + A,
   !
   ! where alpha is a scalar, x and y are n element vectors and A is an n
   ! by n symmetric matrix.
   interface blas_syr2
      pure subroutine ssyr2(uplo, n, alpha, x, incx, y, incy, a, lda)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(in) :: x(*)
         real(sp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         real(sp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ssyr2
      pure subroutine dsyr2(uplo, n, alpha, x, incx, y, incy, a, lda)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(in) :: x(*)
         real(dp), intent(in) :: y(*)
         character(len=1), intent(in) :: uplo
         real(dp), intent(in) :: alpha
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dsyr2
   end interface blas_syr2

   !> Performs one of the matrix-vector operations
   !
   !    x := A*x,   or   x := A**T*x,
   !
   ! where x is an n element vector and  A is an n by n unit, or non-unit,
   ! upper or lower triangular band matrix, with ( k + 1 ) diagonals.
   interface blas_tbmv
      pure subroutine stbmv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine stbmv
      pure subroutine dtbmv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine dtbmv
      pure subroutine ctbmv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine ctbmv
      pure subroutine ztbmv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine ztbmv
   end interface blas_tbmv

   !> Solves one of the systems of equations
   !
   !    A*x = b,   or   A**T*x = b,
   !
   ! where b and x are n element vectors and A is an n by n unit, or
   ! non-unit, upper or lower triangular band matrix, with ( k + 1 )
   ! diagonals.
   !
   ! No test for singularity or near-singularity is included in this
   ! routine. Such tests must be performed before calling this routine.
   interface blas_tbsv
      pure subroutine stbsv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine stbsv
      pure subroutine dtbsv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine dtbsv
      pure subroutine ctbsv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine ctbsv
      pure subroutine ztbsv(uplo, trans, diag, n, k, a, lda, x, incx)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: k
         integer, intent(in) :: lda
      end subroutine ztbsv
   end interface blas_tbsv

   !> Performs one of the matrix-vector operations
   !
   !    x := A*x,   or   x := A**T*x,
   !
   ! where x is an n element vector and  A is an n by n unit, or non-unit,
   ! upper or lower triangular matrix, supplied in packed form.
   interface blas_tpmv
      pure subroutine stpmv(uplo, trans, diag, n, ap, x, incx)
         import :: sp
         real(sp), intent(in) :: ap(*)
         real(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine stpmv
      pure subroutine dtpmv(uplo, trans, diag, n, ap, x, incx)
         import :: dp
         real(dp), intent(in) :: ap(*)
         real(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine dtpmv
      pure subroutine ctpmv(uplo, trans, diag, n, ap, x, incx)
         import :: sp
         complex(sp), intent(in) :: ap(*)
         complex(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine ctpmv
      pure subroutine ztpmv(uplo, trans, diag, n, ap, x, incx)
         import :: dp
         complex(dp), intent(in) :: ap(*)
         complex(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine ztpmv
   end interface blas_tpmv

   !> Solves one of the systems of equations
   !
   !    A*x = b,   or   A**T*x = b,
   !
   ! where b and x are n element vectors and A is an n by n unit, or
   ! non-unit, upper or lower triangular matrix, supplied in packed form.
   !
   ! No test for singularity or near-singularity is included in this
   ! routine. Such tests must be performed before calling this routine.
   interface blas_tpsv
      pure subroutine stpsv(uplo, trans, diag, n, ap, x, incx)
         import :: sp
         real(sp), intent(in) :: ap(*)
         real(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine stpsv
      pure subroutine dtpsv(uplo, trans, diag, n, ap, x, incx)
         import :: dp
         real(dp), intent(in) :: ap(*)
         real(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine dtpsv
      pure subroutine ctpsv(uplo, trans, diag, n, ap, x, incx)
         import :: sp
         complex(sp), intent(in) :: ap(*)
         complex(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine ctpsv
      pure subroutine ztpsv(uplo, trans, diag, n, ap, x, incx)
         import :: dp
         complex(dp), intent(in) :: ap(*)
         complex(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine ztpsv
   end interface blas_tpsv

   !> Performs one of the matrix-vector operations
   !
   !     x := A*x,   or   x := A**T*x,
   !
   !  where x is an n element vector and  A is an n by n unit, or non-unit,
   !  upper or lower triangular matrix.
   interface blas_trmv
      pure subroutine strmv(uplo, trans, diag, n, a, lda, x, incx)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine strmv
      pure subroutine dtrmv(uplo, trans, diag, n, a, lda, x, incx)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dtrmv
      pure subroutine ctrmv(uplo, trans, diag, n, a, lda, x, incx)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ctrmv
      pure subroutine ztrmv(uplo, trans, diag, n, a, lda, x, incx)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ztrmv
   end interface blas_trmv

   !> Solves one of the systems of equations
   !
   !     A*x = b,   or   A**T*x = b,
   !
   !  where b and x are n element vectors and A is an n by n unit, or
   !  non-unit, upper or lower triangular matrix.
   !
   !  No test for singularity or near-singularity is included in this
   !  routine. Such tests must be performed before calling this routine.
   interface blas_trsv
      pure subroutine strsv(uplo, trans, diag, n, a, lda, x, incx)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine strsv
      pure subroutine dtrsv(uplo, trans, diag, n, a, lda, x, incx)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dtrsv
      pure subroutine ctrsv(uplo, trans, diag, n, a, lda, x, incx)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ctrsv
      pure subroutine ztrsv(uplo, trans, diag, n, a, lda, x, incx)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: x(*)
         character(len=1), intent(in) :: uplo
         character(len=1), intent(in) :: trans
         character(len=1), intent(in) :: diag
         integer, intent(in) :: incx
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine ztrsv
   end interface blas_trsv


contains


pure subroutine mctc_sgemv(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp) :: a, b
   character(len=1) :: tra
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasSgemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(amat, xvec)
#else
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
#endif
end subroutine mctc_sgemv


pure subroutine mctc_dgemv(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp) :: a, b
   character(len=1) :: tra
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasDgemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(amat, xvec)
#else
   call blas_gemv(tra, m, n, a, amat, lda, xvec, incx, b, yvec, incy)
#endif
end subroutine mctc_dgemv


pure subroutine mctc_sger(amat, xvec, yvec, alpha)
   real(sp), intent(inout) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp) :: a
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasSger(m, n, a, xvec, incx, yvec, incy, amat, lda)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec, yvec)
#else
   call blas_ger(m, n, a, xvec, incx, yvec, incy, amat, lda)
#endif
end subroutine mctc_sger


pure subroutine mctc_dger(amat, xvec, yvec, alpha)
   real(dp), intent(inout) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp) :: a
   integer :: incx, incy, m, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasDger(m, n, a, xvec, incx, yvec, incy, amat, lda)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec, yvec)
#else
   call blas_ger(m, n, a, xvec, incx, yvec, incy, amat, lda)
#endif
end subroutine mctc_dger


pure subroutine mctc_sspmv(amat, xvec, yvec, uplo, alpha, beta)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   real(sp), intent(in) :: amat(:)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   character(len=1) :: ula
   real(sp) :: a, b
   integer :: incx, incy, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasSspmv(ula, n, a, amat, xvec, incx, b, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(amat, xvec)
#else
   call blas_spmv(ula, n, a, amat, xvec, incx, b, yvec, incy)
#endif
end subroutine mctc_sspmv


pure subroutine mctc_dspmv(amat, xvec, yvec, uplo, alpha, beta)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   real(dp), intent(in) :: amat(:)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   character(len=1) :: ula
   real(dp) :: a, b
   integer :: incx, incy, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasDspmv(ula, n, a, amat, xvec, incx, b, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(amat, xvec)
#else
   call blas_spmv(ula, n, a, amat, xvec, incx, b, yvec, incy)
#endif
end subroutine mctc_dspmv


pure subroutine mctc_sspr(amat, xvec, uplo, alpha)
   real(sp), intent(inout) :: amat(:)
   real(sp), intent(in) :: xvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   character(len=1) :: ula
   real(sp) :: a
   integer :: incx, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, amat)
   !$acc host_data use_device(xvec, amat)
   call cublasSspr(ula, n, a, xvec, incx, amat)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec)
#else
   call blas_spr(ula, n, a, xvec, incx, amat)
#endif
end subroutine mctc_sspr


pure subroutine mctc_dspr(amat, xvec, uplo, alpha)
   real(dp), intent(inout) :: amat(:)
   real(dp), intent(in) :: xvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   character(len=1) :: ula
   real(dp) :: a
   integer :: incx, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, amat)
   !$acc host_data use_device(xvec, amat)
   call cublasDspr(ula, n, a, xvec, incx, amat)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec)
#else
   call blas_spr(ula, n, a, xvec, incx, amat)
#endif
end subroutine mctc_dspr


pure subroutine mctc_sspr2(amat, xvec, yvec, uplo, alpha)
   real(sp), intent(inout) :: amat(:)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   character(len=1) :: ula
   real(sp) :: a
   integer :: incx, incy, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasSspr2(ula, n, a, xvec, incx, yvec, incy, amat)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec, yvec)
#else
   call blas_spr2(ula, n, a, xvec, incx, yvec, incy, amat)
#endif
end subroutine mctc_sspr2


pure subroutine mctc_dspr2(amat, xvec, yvec, uplo, alpha)
   real(dp), intent(inout) :: amat(:)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   character(len=1) :: ula
   real(dp) :: a
   integer :: incx, incy, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasDspr2(ula, n, a, xvec, incx, yvec, incy, amat)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec, yvec)
#else
   call blas_spr2(ula, n, a, xvec, incx, yvec, incy, amat)
#endif
end subroutine mctc_dspr2


pure subroutine mctc_ssymv(amat, xvec, yvec, uplo, alpha, beta)
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1) :: ula
   real(sp) :: a, b
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasSsymv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(amat, xvec)
#else
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
#endif
end subroutine mctc_ssymv


pure subroutine mctc_dsymv(amat, xvec, yvec, uplo, alpha, beta)
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1) :: ula
   real(dp) :: a, b
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(beta)) then
      b = beta
   else
      b = 0
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasDsymv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(amat, xvec)
#else
   call blas_symv(ula, n, a, amat, lda, xvec, incx, b, yvec, incy)
#endif
end subroutine mctc_dsymv


pure subroutine mctc_ssyr(amat, xvec, uplo, alpha)
   real(sp), intent(inout) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   character(len=1) :: ula
   real(sp) :: a
   integer :: incx, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, amat)
   !$acc host_data use_device(xvec, amat)
   call cublasSsyr(ula, n, a, xvec, incx, amat, lda)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec)
#else
   call blas_syr(ula, n, a, xvec, incx, amat, lda)
#endif
end subroutine mctc_ssyr


pure subroutine mctc_dsyr(amat, xvec, uplo, alpha)
   real(dp), intent(inout) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   character(len=1) :: ula
   real(dp) :: a
   integer :: incx, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, amat)
   !$acc host_data use_device(xvec, amat)
   call cublasDsyr(ula, n, a, xvec, incx, amat, lda)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec)
#else
   call blas_syr(ula, n, a, xvec, incx, amat, lda)
#endif
end subroutine mctc_dsyr


pure subroutine mctc_ssyr2(amat, xvec, yvec, uplo, alpha)
   character(len=1), intent(in), optional :: uplo
   real(sp), intent(in), optional :: alpha
   real(sp), intent(inout) :: amat(:, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in) :: yvec(:)
   character(len=1) :: ula
   real(sp) :: a
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasSsyr2(ula, n, a, xvec, incx, yvec, incy, amat, lda)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec, yvec)
#else
   call blas_syr2(ula, n, a, xvec, incx, yvec, incy, amat, lda)
#endif
end subroutine mctc_ssyr2


pure subroutine mctc_dsyr2(amat, xvec, yvec, uplo, alpha)
   character(len=1), intent(in), optional :: uplo
   real(dp), intent(in), optional :: alpha
   real(dp), intent(inout) :: amat(:, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in) :: yvec(:)
   character(len=1) :: ula
   real(dp) :: a
   integer :: incx, incy, n, lda
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   incx = 1
   incy = 1
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec, amat)
   !$acc host_data use_device(xvec, yvec, amat)
   call cublasDsyr2(ula, n, a, xvec, incx, yvec, incy, amat, lda)
   !$acc end host_data
   !$acc exit data copyout(amat) delete(xvec, yvec)
#else
   call blas_syr2(ula, n, a, xvec, incx, yvec, incy, amat, lda)
#endif
end subroutine mctc_dsyr2


end module xtb_mctc_blas_level2

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> LAPACK linear equation solvers.
module xtb_mctc_lapack_trs
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: mctc_getrs, mctc_sytrs, mctc_sptrs, mctc_potrs, mctc_pptrs

   public :: lapack_getrs, lapack_sytrs, lapack_sptrs, lapack_potrs, lapack_pptrs


   interface mctc_getrs
      module procedure :: mctc_sgetrs
      module procedure :: mctc_dgetrs
   end interface mctc_getrs

   interface mctc_sytrs
      module procedure :: mctc_ssytrs
      module procedure :: mctc_dsytrs
   end interface mctc_sytrs

   interface mctc_sptrs
      module procedure :: mctc_ssptrs
      module procedure :: mctc_dsptrs
   end interface mctc_sptrs

   interface mctc_potrs
      module procedure :: mctc_spotrs
      module procedure :: mctc_dpotrs
   end interface mctc_potrs

   interface mctc_pptrs
      module procedure :: mctc_spptrs
      module procedure :: mctc_dpptrs
   end interface mctc_pptrs


   interface lapack_getrs
      pure subroutine sgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine sgetrs
      pure subroutine dgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dgetrs
      pure subroutine cgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         complex(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine cgetrs
      pure subroutine zgetrs(trans, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         complex(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: trans
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine zgetrs
   end interface lapack_getrs

   interface lapack_sytrs
      pure subroutine ssytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine ssytrs
      pure subroutine dsytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dsytrs
      pure subroutine csytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine csytrs
      pure subroutine zsytrs(uplo, n, nrhs, a, lda, ipiv, b, ldb, info)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine zsytrs
   end interface lapack_sytrs

   interface lapack_sptrs
      pure subroutine ssptrs(uplo, n, nrhs, ap, ipiv, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: ap(*)
         real(sp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine ssptrs
      pure subroutine dsptrs(uplo, n, nrhs, ap, ipiv, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: ap(*)
         real(dp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine dsptrs
      pure subroutine csptrs(uplo, n, nrhs, ap, ipiv, b, ldb, info)
         import :: sp
         complex(sp), intent(in) :: ap(*)
         complex(sp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine csptrs
      pure subroutine zsptrs(uplo, n, nrhs, ap, ipiv, b, ldb, info)
         import :: dp
         complex(dp), intent(in) :: ap(*)
         complex(dp), intent(inout) :: b(ldb, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine zsptrs
   end interface lapack_sptrs

   interface lapack_potrs
      pure subroutine spotrs(uplo, n, nrhs, a, lda, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine spotrs
      pure subroutine dpotrs(uplo, n, nrhs, a, lda, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine dpotrs
      pure subroutine cpotrs(uplo, n, nrhs, a, lda, b, ldb, info)
         import :: sp
         complex(sp), intent(in) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine cpotrs
      pure subroutine zpotrs(uplo, n, nrhs, a, lda, b, ldb, info)
         import :: dp
         complex(dp), intent(in) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
      end subroutine zpotrs
   end interface lapack_potrs

   interface lapack_pptrs
      pure subroutine spptrs(uplo, n, nrhs, ap, b, ldb, info)
         import :: sp
         real(sp), intent(in) :: ap(*)
         real(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine spptrs
      pure subroutine dpptrs(uplo, n, nrhs, ap, b, ldb, info)
         import :: dp
         real(dp), intent(in) :: ap(*)
         real(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine dpptrs
      pure subroutine cpptrs(uplo, n, nrhs, ap, b, ldb, info)
         import :: sp
         complex(sp), intent(in) :: ap(*)
         complex(sp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine cpptrs
      pure subroutine zpptrs(uplo, n, nrhs, ap, b, ldb, info)
         import :: dp
         complex(dp), intent(in) :: ap(*)
         complex(dp), intent(inout) :: b(ldb, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: nrhs
         integer, intent(in) :: ldb
      end subroutine zpptrs
   end interface lapack_pptrs


contains


subroutine mctc_sgetrs(env, amat, bmat, ipiv, trans)
   character(len=*), parameter :: source = 'mctc_lapack_getrs'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: trans
   character(len=1) :: tra
   integer :: info, n, nrhs, lda, ldb
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_getrs(tra, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_sgetrs


subroutine mctc_dgetrs(env, amat, bmat, ipiv, trans)
   character(len=*), parameter :: source = 'mctc_lapack_getrs'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: trans
   character(len=1) :: tra
   integer :: info, n, nrhs, lda, ldb
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_getrs(tra, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_dgetrs


subroutine mctc_ssytrs(env, amat, bmat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sytrs'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, lda, ldb
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_sytrs(ula, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_ssytrs


subroutine mctc_dsytrs(env, amat, bmat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sytrs'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, lda, ldb
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_sytrs(ula, n, nrhs, amat, lda, ipiv, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_dsytrs


subroutine mctc_ssptrs(env, amat, bmat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sptrs'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:)
   real(sp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, ldb, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   ldb = max(1, size(bmat, 1))
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   end if
   nrhs = size(bmat, 2)
   call lapack_sptrs(ula, n, nrhs, amat, ipiv, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_ssptrs


subroutine mctc_dsptrs(env, amat, bmat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sptrs'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:)
   real(dp), intent(inout) :: bmat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, ldb, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   ldb = max(1, size(bmat, 1))
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   end if
   nrhs = size(bmat, 2)
   call lapack_sptrs(ula, n, nrhs, amat, ipiv, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_dsptrs


subroutine mctc_spotrs(env, amat, bmat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_potrs'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:, :)
   real(sp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, lda, ldb
   intrinsic max, present, size
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_potrs(ula, n, nrhs, amat, lda, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_spotrs


subroutine mctc_dpotrs(env, amat, bmat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_potrs'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:, :)
   real(dp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, lda, ldb
   intrinsic max, present, size
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   ldb = max(1, size(bmat, 1))
   n = size(amat, 2)
   nrhs = size(bmat, 2)
   call lapack_potrs(ula, n, nrhs, amat, lda, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_dpotrs


subroutine mctc_spptrs(env, amat, bmat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_pptrs'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(in) :: amat(:)
   real(sp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, ldb, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   ldb = max(1, size(bmat, 1))
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   end if
   nrhs = size(bmat, 2)
   call lapack_pptrs(ula, n, nrhs, amat, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_spptrs


subroutine mctc_dpptrs(env, amat, bmat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_pptrs'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(in) :: amat(:)
   real(dp), intent(inout) :: bmat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nrhs, ldb, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   ldb = max(1, size(bmat, 1))
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   end if
   nrhs = size(bmat, 2)
   call lapack_pptrs(ula, n, nrhs, amat, bmat, ldb, info)
   if (info /= 0) then
      call env%error("Solving linear system failed", source)
   end if
end subroutine mctc_dpptrs


end module xtb_mctc_lapack_trs

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Interfaces to BLAS
module xtb_mctc_blas_level1
   use xtb_mctc_accuracy, only : sp, dp
#ifdef USE_CUBLAS
   use cublas, only : cublasSasum, cublasDasum, cublasSaxpy, cublasDaxpy, &
      & cublasScopy, cublasDcopy, cublasSdot, cublasDdot, &
      & cublasSnrm2, cublasDnrm2, cublasSrot, cublasDrot, &
      & cublasSscal, cublasDscal, cublasSswap, cublasDswap, &
      & cublasSiamax, cublasDiamax
#endif
   implicit none
   private

   public :: mctc_asum, mctc_axpy, mctc_copy, mctc_dot, mctc_nrm2, mctc_rot
   public :: mctc_scal, mctc_swap, mctc_iamax

   public :: blas_asum, blas_axpy, blas_copy, blas_dot, blas_dotc, blas_dotu
   public :: blas_nrm2, blas_rot, blas_scal, blas_swap, blas_iamax, blas_cabs1


   !> Takes the sum of the absolute values.
   interface mctc_asum
      module procedure :: mctc_sasum
      module procedure :: mctc_dasum
   end interface mctc_asum

   !> Constant times a vector plus a vector.
   interface mctc_axpy
      module procedure :: mctc_saxpy
      module procedure :: mctc_daxpy
   end interface mctc_axpy

   !> Copies a vector, x, to a vector, y.
   interface mctc_copy
      module procedure :: mctc_scopy
      module procedure :: mctc_dcopy
   end interface mctc_copy

   !> Forms the dot product of two vectors.
   interface mctc_dot
      module procedure :: mctc_sdot
      module procedure :: mctc_ddot
   end interface mctc_dot

   !> Returns the euclidean norm of a vector via the function
   !  name, so that
   !
   !    NRM2 := sqrt( x'*x )
   interface mctc_nrm2
      module procedure :: mctc_snrm2
      module procedure :: mctc_dnrm2
   end interface mctc_nrm2

   !> Applies a plane rotation.
   interface mctc_rot
      module procedure :: mctc_srot
      module procedure :: mctc_drot
   end interface mctc_rot

   !> Scales a vector by a constant.
   interface mctc_scal
      module procedure :: mctc_sscal
      module procedure :: mctc_dscal
   end interface mctc_scal

   !> Interchanges two vectors.
   interface mctc_swap
      module procedure :: mctc_sswap
      module procedure :: mctc_dswap
   end interface mctc_swap

   !> Finds the index of the first element having maximum absolute value.
   interface mctc_iamax
      module procedure :: mctc_isamax
      module procedure :: mctc_idamax
   end interface mctc_iamax


   !> Takes the sum of the absolute values.
   interface blas_asum
      pure function sasum(n, x, incx)
         import :: sp
         real(sp) :: sasum
         real(sp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function sasum
      pure function scasum(n, x, incx)
         import :: sp
         real(sp) :: scasum
         complex(sp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function scasum
      pure function dasum(n, x, incx)
         import :: dp
         real(dp) :: dasum
         real(dp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function dasum
      pure function dzasum(n, x, incx)
         import :: dp
         real(dp) :: dzasum
         complex(dp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function dzasum
   end interface blas_asum

   !> Constant times a vector plus a vector.
   !  Uses unrolled loops for increments equal to one.
   interface blas_axpy
      pure subroutine saxpy(n, a, x, incx, y, incy)
         import :: sp
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine saxpy
      pure subroutine daxpy(n, a, x, incx, y, incy)
         import :: dp
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine daxpy
      pure subroutine caxpy(n, a, x, incx, y, incy)
         import :: sp
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         complex(sp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine caxpy
      pure subroutine zaxpy(n, a, x, incx, y, incy)
         import :: dp
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         complex(dp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine zaxpy
   end interface blas_axpy

   !> Copies a vector, x, to a vector, y.
   !  Uses unrolled loops for increments equal to 1.
   interface blas_copy
      pure subroutine scopy(n, x, incx, y, incy)
         import :: sp
         real(sp), intent(in) :: x(*)
         real(sp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine scopy
      pure subroutine dcopy(n, x, incx, y, incy)
         import :: dp
         real(dp), intent(in) :: x(*)
         real(dp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine dcopy
      pure subroutine ccopy(n, x, incx, y, incy)
         import :: sp
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine ccopy
      pure subroutine zcopy(n, x, incx, y, incy)
         import :: dp
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine zcopy
   end interface blas_copy

   !> Forms the dot product of two vectors.
   !  Uses unrolled loops for increments equal to one.
   interface blas_dot
      pure function sdot(n, x, incx, y, incy)
         import :: sp
         real(sp) :: sdot
         real(sp), intent(in) :: x(*)
         real(sp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function sdot
      pure function ddot(n, x, incx, y, incy)
         import :: dp
         real(dp) :: ddot
         real(dp), intent(in) :: x(*)
         real(dp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function ddot
   end interface blas_dot

   !> Forms the dot product of two complex vectors
   !    DOTC = X^H * Y
   interface blas_dotc
      pure function cdotc(n, x, incx, y, incy)
         import :: sp
         complex(sp) :: cdotc
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function cdotc
      pure function zdotc(n, x, incx, y, incy)
         import :: dp
         complex(dp) :: zdotc
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function zdotc
   end interface blas_dotc

   !> Forms the dot product of two complex vectors
   !    DOTU = X^T * Y
   interface blas_dotu
      pure function cdotu(n, x, incx, y, incy)
         import :: sp
         complex(sp) :: cdotu
         complex(sp), intent(in) :: x(*)
         complex(sp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function cdotu
      pure function zdotu(n, x, incx, y, incy)
         import :: dp
         complex(dp) :: zdotu
         complex(dp), intent(in) :: x(*)
         complex(dp), intent(in) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end function zdotu
   end interface blas_dotu

   !> Returns the euclidean norm of a vector via the function
   !  name, so that
   !
   !    NRM2 := sqrt( x'*x )
   interface blas_nrm2
      pure function snrm2(n, x, incx)
         import :: sp
         real(sp) :: snrm2
         real(sp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function snrm2
      pure function dnrm2(n, x, incx)
         import :: dp
         real(dp) :: dnrm2
         real(dp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function dnrm2
      pure function scnrm2(n, x, incx)
         import :: sp
         real(sp) :: scnrm2
         complex(sp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function scnrm2
      pure function dznrm2(n, x, incx)
         import :: dp
         real(dp) :: dznrm2
         complex(dp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function dznrm2
   end interface blas_nrm2

   !> Applies a plane rotation.
   interface blas_rot
      pure subroutine srot(n, x, incx, y, incy, c, s)
         import :: sp
         real(sp), intent(inout) :: x(*)
         real(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: c
         real(sp), intent(in) :: s
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine srot
      pure subroutine drot(n, x, incx, y, incy, c, s)
         import :: dp
         real(dp), intent(inout) :: x(*)
         real(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: c
         real(dp), intent(in) :: s
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine drot
      pure subroutine csrot(n, x, incx, y, incy, c, s)
         import :: sp
         complex(sp), intent(inout) :: x(*)
         complex(sp), intent(inout) :: y(*)
         real(sp), intent(in) :: c
         real(sp), intent(in) :: s
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine csrot
      pure subroutine zdrot(n, x, incx, y, incy, c, s)
         import :: dp
         complex(dp), intent(inout) :: x(*)
         complex(dp), intent(inout) :: y(*)
         real(dp), intent(in) :: c
         real(dp), intent(in) :: s
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine zdrot
   end interface blas_rot

   !> Scales a vector by a constant.
   !  Uses unrolled loops for increment equal to 1.
   interface blas_scal
      pure subroutine sscal(n, a, x, incx)
         import :: sp
         real(sp), intent(inout) :: x(*)
         real(sp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine sscal
      pure subroutine dscal(n, a, x, incx)
         import :: dp
         real(dp), intent(inout) :: x(*)
         real(dp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine dscal
      pure subroutine cscal(n, a, x, incx)
         import :: sp
         complex(sp), intent(inout) :: x(*)
         complex(sp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine cscal
      pure subroutine zscal(n, a, x, incx)
         import :: dp
         complex(dp), intent(inout) :: x(*)
         complex(dp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine zscal
      pure subroutine csscal(n, a, x, incx)
         import :: sp
         complex(sp), intent(inout) :: x(*)
         real(sp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine csscal
      pure subroutine zdscal(n, a, x, incx)
         import :: dp
         complex(dp), intent(inout) :: x(*)
         real(dp), intent(in) :: a
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end subroutine zdscal
   end interface blas_scal

   !> Interchanges two vectors.
   !  Uses unrolled loops for increments equal to 1.
   interface blas_swap
      pure subroutine sswap(n, x, incx, y, incy)
         import :: sp
         real(sp), intent(inout) :: x(*)
         real(sp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine sswap
      pure subroutine dswap(n, x, incx, y, incy)
         import :: dp
         real(dp), intent(inout) :: x(*)
         real(dp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine dswap
      pure subroutine cswap(n, x, incx, y, incy)
         import :: sp
         complex(sp), intent(inout) :: x(*)
         complex(sp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine cswap
      pure subroutine zswap(n, x, incx, y, incy)
         import :: dp
         complex(dp), intent(inout) :: x(*)
         complex(dp), intent(inout) :: y(*)
         integer, intent(in) :: incx
         integer, intent(in) :: incy
         integer, intent(in) :: n
      end subroutine zswap
   end interface blas_swap

   !> Finds the index of the first element having maximum absolute value.
   interface blas_iamax
      pure function isamax(n, x, incx)
         import :: sp
         integer :: isamax
         real(sp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function isamax
      pure function idamax(n, x, incx)
         import :: dp
         integer :: idamax
         real(dp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function idamax
      pure function icamax(n, x, incx)
         import :: sp
         integer :: icamax
         complex(sp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function icamax
      pure function izamax(n, x, incx)
         import :: dp
         integer :: izamax
         complex(dp), intent(in) :: x(*)
         integer, intent(in) :: incx
         integer, intent(in) :: n
      end function izamax
   end interface blas_iamax

   !> Computes |Re(.)| + |Im(.)| of a complex number
   interface blas_cabs1
      pure function scabs1(c)
         import :: sp
         real(sp) :: scabs1
         complex(sp), intent(in) :: c
      end function scabs1
      pure function dcabs1(z)
         import :: dp
         real(dp) :: dcabs1
         complex(dp), intent(in) :: z
      end function dcabs1
   end interface blas_cabs1


contains


function mctc_sasum(xvec) result(asum)
   real(sp) :: asum
   real(sp), intent(in) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec) create(asum)
   !$acc host_data use_device(xvec, asum)
   asum = cublasSasum(n, xvec, incx)
   !$acc end host_data
   !$acc exit data copyout(asum) delete(xvec)
#else
   asum = blas_asum(n, xvec, incx)
#endif
end function mctc_sasum


function mctc_dasum(xvec) result(asum)
   real(dp) :: asum
   real(dp), intent(in) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec) create(asum)
   !$acc host_data use_device(xvec, asum)
   asum = cublasDasum(n, xvec, incx)
   !$acc end host_data
   !$acc exit data copyout(asum) delete(xvec)
#else
   asum = blas_asum(n, xvec, incx)
#endif
end function mctc_dasum


subroutine mctc_saxpy(xvec, yvec, alpha)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp) :: a
   integer :: incx, incy, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_sp
   end if
   incx = 1
   incy = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec)
   !$acc host_data use_device(xvec, yvec)
   call cublasSaxpy(n, a, xvec, incx, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(xvec)
#else
   call blas_axpy(n, a, xvec, incx, yvec, incy)
#endif
end subroutine mctc_saxpy


subroutine mctc_daxpy(xvec, yvec, alpha)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp) :: a
   integer :: incx, incy, n
   if (present(alpha)) then
      a = alpha
   else
      a = 1.0_dp
   end if
   incx = 1
   incy = 1
   n = size(xvec)
#ifdef USE_CUBLAS
   !$acc enter data copyin(xvec, yvec)
   !$acc host_data use_device(xvec, yvec)
   call cublasDaxpy(n, a, xvec, incx, yvec, incy)
   !$acc end host_data
   !$acc exit data copyout(yvec) delete(xvec)
#else
   call blas_axpy(n, a, xvec, incx, yvec, incy)
#endif
end subroutine mctc_daxpy


subroutine mctc_scopy(xvec, yvec)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   call blas_copy(n, xvec, incx, yvec, incy)
end subroutine mctc_scopy


subroutine mctc_dcopy(xvec, yvec)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   call blas_copy(n, xvec, incx, yvec, incy)
end subroutine mctc_dcopy


function mctc_sdot(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   dot = blas_dot(n, xvec, incx, yvec, incy)
end function mctc_sdot


function mctc_ddot(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   dot = blas_dot(n, xvec, incx, yvec, incy)
end function mctc_ddot


function mctc_snrm2(xvec) result(nrm2)
   real(sp) :: nrm2
   real(sp), intent(in) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
   nrm2 = blas_nrm2(n, xvec, incx)
end function mctc_snrm2


function mctc_dnrm2(xvec) result(nrm2)
   real(dp) :: nrm2
   real(dp), intent(in) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
   nrm2 = blas_nrm2(n, xvec, incx)
end function mctc_dnrm2


subroutine mctc_srot(xvec, yvec, c, s)
   real(sp), intent(in) :: c
   real(sp), intent(in) :: s
   real(sp), intent(inout) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   call blas_rot(n, xvec, incx, yvec, incy, c, s)
end subroutine mctc_srot


subroutine mctc_drot(xvec, yvec, c, s)
   real(dp), intent(in) :: c
   real(dp), intent(in) :: s
   real(dp), intent(inout) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   call blas_rot(n, xvec, incx, yvec, incy, c, s)
end subroutine mctc_drot


subroutine mctc_sscal(xvec, alpha)
   real(sp), intent(in) :: alpha
   real(sp), intent(inout) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
   call blas_scal(n, alpha, xvec, incx)
end subroutine mctc_sscal


subroutine mctc_dscal(xvec, alpha)
   real(dp), intent(in) :: alpha
   real(dp), intent(inout) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
   call blas_scal(n, alpha, xvec, incx)
end subroutine mctc_dscal


subroutine mctc_sswap(xvec, yvec)
   real(sp), intent(inout) :: xvec(:)
   real(sp), intent(inout) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   call blas_swap(n, xvec, incx, yvec, incy)
end subroutine mctc_sswap


subroutine mctc_dswap(xvec, yvec)
   real(dp), intent(inout) :: xvec(:)
   real(dp), intent(inout) :: yvec(:)
   integer :: incx, incy, n
   incx = 1
   incy = 1
   n = size(xvec)
   call blas_swap(n, xvec, incx, yvec, incy)
end subroutine mctc_dswap


function mctc_isamax(xvec) result(iamax)
   integer :: iamax
   real(sp), intent(in) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
   iamax = blas_iamax(n, xvec, incx)
end function mctc_isamax


function mctc_idamax(xvec) result(iamax)
   integer :: iamax
   real(dp), intent(in) :: xvec(:)
   integer :: incx, n
   incx = 1
   n = size(xvec)
   iamax = blas_iamax(n, xvec, incx)
end function mctc_idamax


end module xtb_mctc_blas_level1

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine geosum(n,ic,xyzin)
   use xtb_mctc_convert, only : autoaa
   use xtb_mctc_symbols, only : toSymbol
   use xtb_param_atomicrad, only : atomicRad
   use xtb_splitparam
   implicit none
   integer n,ic(n)
   real*8 xyzin(3,n)

   real*8 ,allocatable :: x(:),y(:),z(:),rmin(:),rmax(:),dev(:)
   real*8 ,allocatable :: rlist(:,:),av(:)
   integer,allocatable :: bondlist(:,:),nbond(:),nty(:)

   real*8 brad,r,xxx,yyy,zzz,avv
   real*8 xyz(3,3),ang,xyz4(3,4),ra(3),rb(3)
   integer i, j, nn, k, imin, jmin, iat1, iat2
   integer nm,ij,m,iat,jat, nsel
   integer nt,a,b,ia,ib,ja,jb,ii,jj,lin,linij
   character*31  lab,lab2,angsum1 (n*150)
   character*30  lab4,angsum2(n*150)
   character*50  lab3
   character*21  lab21

   ! first nsel atoms are considered in angle/dihedreal xtb_printout
   nsel=min(10,n)

   nn=100*100
   allocate(x(n),y(n),z(n),rmin(nn),rmax(nn),dev(nn),av(nn),&
      &         rlist(n,150),bondlist(n,150),nbond(n),nty(nn))

   x(1:n)=xyzin(1,1:n)
   y(1:n)=xyzin(2,1:n)
   z(1:n)=xyzin(3,1:n)
   rmin=10000.
   k   =0
   do i=1,n
      nbond(i)=0
      do j=1,n
         if(i.eq.j)cycle
         k=k+1
         r=sqrt((x(i)-x(j))**2+(y(i)-y(j))**2+(z(i)-z(j))**2)&
            &        *0.529177260d0
         ! the max bond dist in angst
         brad=(atomicRad(ic(i))+atomicRad(ic(j)))*autoaa
         brad=brad+0.30*brad
         if(r.le.brad) then
            nbond(i)=nbond(i)+1
            bondlist(i,nbond(i))=j
            rlist   (i,nbond(i))=r
         endif
      enddo
   enddo

   write(*,*)
   write(*,*)'Bond Distances (Angstroems)'
   write(*,*)'---------------------------'
   nt=0
   nty=0
   av=0
   dev=0
   rmin=1000
   rmax=-1
   do i=1,n
      do a=1,nbond(i)
         nt=nt+1
         write(lab21,'(a2,i3,''-'',a2,i3)')&
            &      toSymbol(ic(i)),i,toSymbol(ic(bondlist(i,a))),bondlist(i,a)
         call rmblank(lab21,lab4)
         write(angsum1(nt),'(a,''='',f6.4)')&
            &      trim(lab4),rlist(i,a)
         iat1=ic(i)
         iat2=ic(bondlist(i,a))
         linij=lin(iat1,iat2)
         av(linij)=av(linij)+rlist(i,a)
         if(rlist(i,a).lt.rmin(linij))rmin(linij)=rlist(i,a)
         if(rlist(i,a).gt.rmax(linij))rmax(linij)=rlist(i,a)
         nty(linij)=nty(linij)+1
      enddo
   enddo

   do i=1,n
      do a=1,nbond(i)
         iat1=ic(i)
         iat2=ic(bondlist(i,a))
         linij=lin(iat1,iat2)
         avv=av(linij)/float(nty(linij))
         dev(linij)=dev(linij)+(avv-rlist(i,a))**2
      enddo
   enddo
   write(*,'(6a21)')(angsum1(i),i=1,nt)
   do i=1,100
      do j=1,i
         if(nty(lin(i,j)).gt.0)then
            write(*,'(2A3,'' Rav='',f6.4,'' sigma='',f6.4,&
               &      ''  Rmin='',f6.4,''  Rmax='',f6.4,i6)')&
               &      toSymbol(i),toSymbol(j),&
               &      av(lin(i,j))/nty(lin(i,j)),&
               &      sqrt(dev(lin(i,j))/float(nty(lin(i,j)))),&
               &      rmin(lin(i,j)),rmax(lin(i,j)),int(0.5*nty(lin(i,j))+0.0001)
         endif
      enddo
   enddo

   write(*,*)
   write(*,*)'selected bond angles (degree)'
   write(*,*)'--------------------'
   nt=0
   do i=1,nsel
      m=nbond(i)
      if(m.gt.1)then
         xyz(1,2)=x(i)
         xyz(2,2)=y(i)
         xyz(3,2)=z(i)
         do a=1,m
            ia=bondlist(i,a)
            do b=1,a-1
               ib=bondlist(i,b)
               nt=nt+1
               write(lab,'(a2,i5,''-'',a2,i5,''-'',a2,i5)')&
                  &toSymbol(ic(ia)),ia,toSymbol(ic(i)),i,toSymbol(ic(ib)),ib
               call rmblank(lab,lab2)
               xyz(1,1)=x(ia)
               xyz(2,1)=y(ia)
               xyz(3,1)=z(ia)
               xyz(1,3)=x(ib)
               xyz(2,3)=y(ib)
               xyz(3,3)=z(ib)
               call xbangle(xyz,ang)
               write(angsum1(nt),'(a,''='',f6.2)')trim(lab2),ang
            enddo
         enddo
      endif
   enddo
   write(*,'(4a)')(angsum1(i),i=1,nt)

   write(*,*)
   write(*,*)'selected dihedral angles (degree)'
   write(*,*)'---------------------------------'
   nt=0
   do i=1,nsel
      xyz4(1,2)=x(i)
      xyz4(2,2)=y(i)
      xyz4(3,2)=z(i)
      do j=1,i
         if(i.eq.j)cycle
         xyz4(1,3)=x(j)
         xyz4(2,3)=y(j)
         xyz4(3,3)=z(j)
         k=k+1
         r=sqrt((x(i)-x(j))**2+(y(i)-y(j))**2+(z(i)-z(j))**2)&
            &        *0.529177260d0
         ! the max bond dist in angst
         brad=(atomicRad(ic(i))+atomicRad(ic(j)))*autoaa
         brad=brad+0.25*brad
         if(r.le.brad) then
            do ii=1,nbond(i)
               ib=bondlist(i,ii)
               do jj=1,nbond(j)
                  jb=bondlist(j,jj)
                  if(ib.ne.jb.and.ib.ne.j.and.jb.ne.i)then
                     nt=nt+1
                     write(lab3,'(a2,i5,''-'',a2,i5,''-'',&
                        &                               a2,i5,''-'',a2,i5)')&
                        &                  toSymbol(ic(ib)),ib,toSymbol(ic(i)),i,&
                        &                  toSymbol(ic(j)),j,  toSymbol(ic(jb)),jb
                     call rmblank(lab3,lab4)
                     xyz4(1,1)=x(ib)
                     xyz4(2,1)=y(ib)
                     xyz4(3,1)=z(ib)
                     xyz4(1,4)=x(jb)
                     xyz4(2,4)=y(jb)
                     xyz4(3,4)=z(jb)
                     call xdihed(xyz4,ang)
                     write(angsum2(nt),'(a,''='',f6.2)')&
                        &                  trim(lab4),ang
                  endif
               enddo
            enddo
         endif
      enddo
   enddo
   write(*,'(4a)')(angsum2(i),i=1,nt)

   if(iatf2.ne.0.and.iatf1.ne.0)then
      write(*,*)
      write(*,*)'CMA Distance (Angstroems)'
      write(*,*)'---------------------------'
      call cmafrag(n,ic,xyzin,ra,rb)
      write(*,'(''R(CMA):'',f8.4)')rcma*0.529177260d0
   endif

end subroutine

!-------------------------------------------------

subroutine rmblank(as,re)
   character(len=*) as
   character(len=*) re

   re=' '
   k=0
   nsp=ichar(' ')
   do i=1,len(as)
      j=ichar(as(i:i))
      if(j.ne.nsp)then
         k=k+1
         re(k:k)=as(i:i)
      endif
   end do
end subroutine rmblank

subroutine xbangle(xyz,angle)
   implicit double precision (a-h,o-z)
   dimension xyz(3,3)
   !********************************************************************
   !
   ! bangle calculates the angle between atoms i,j, and k. the
   !        cartesian coordinates are in xyz.
   !
   !********************************************************************
   i=1
   j=2
   k=3
   d2ij = (xyz(1,i)-xyz(1,j))**2+&
      &       (xyz(2,i)-xyz(2,j))**2+&
      &       (xyz(3,i)-xyz(3,j))**2
   d2jk = (xyz(1,j)-xyz(1,k))**2+&
      &       (xyz(2,j)-xyz(2,k))**2+&
      &       (xyz(3,j)-xyz(3,k))**2
   d2ik = (xyz(1,i)-xyz(1,k))**2+&
      &       (xyz(2,i)-xyz(2,k))**2+&
      &       (xyz(3,i)-xyz(3,k))**2
   xy = sqrt(d2ij*d2jk)
   temp = 0.5d0 * (d2ij+d2jk-d2ik) / xy
   if (temp .gt. 1.0d0) temp=1.0d0
   if (temp .lt. -1.0d0) temp=-1.0d0
   angle = acos( temp )*180.0d0/3.14159265358979d0
   return
end subroutine xbangle
subroutine xdihed(xyz,angle)
   implicit double precision (a-h,o-z)
   dimension xyz(3,4)
   !********************************************************************
   !
   !      dihed calculates the dihedral angle between atoms i, j, k,
   !            and l.  the cartesian coordinates of these atoms
   !            are in array xyz.
   !
   !     dihed is a modified version of a subroutine of the same name
   !           which was written by dr. w. theil in 1973.
   !
   !********************************************************************
   data pi/3.14159265358979d0/
   i=1
   j=2
   k=3
   l=4
   xi1=xyz(1,i)-xyz(1,k)
   xj1=xyz(1,j)-xyz(1,k)
   xl1=xyz(1,l)-xyz(1,k)
   yi1=xyz(2,i)-xyz(2,k)
   yj1=xyz(2,j)-xyz(2,k)
   yl1=xyz(2,l)-xyz(2,k)
   zi1=xyz(3,i)-xyz(3,k)
   zj1=xyz(3,j)-xyz(3,k)
   zl1=xyz(3,l)-xyz(3,k)
   !      rotate around z axis to put kj along y axis
   dist= sqrt(xj1**2+yj1**2+zj1**2)
   cosa=zj1/dist
   if(cosa.gt.1.0d0) cosa=1.0d0
   if(cosa.lt.-1.0d0) cosa=-1.0d0
   ddd=1.0d0-cosa**2
   if(ddd.le.0.0) go to 10
   yxdist=dist* sqrt(ddd)
   if(yxdist.gt.1.0d-9) go to 20
   10 continue
   xi2=xi1
   xl2=xl1
   yi2=yi1
   yl2=yl1
   costh=cosa
   sinth=0.d0
   go to 30
   20 cosph=yj1/yxdist
   sinph=xj1/yxdist
   xi2=xi1*cosph-yi1*sinph
   xj2=xj1*cosph-yj1*sinph
   xl2=xl1*cosph-yl1*sinph
   yi2=xi1*sinph+yi1*cosph
   yj2=xj1*sinph+yj1*cosph
   yl2=xl1*sinph+yl1*cosph
   !      rotate kj around the x axis so kj lies along the z axis
   costh=cosa
   sinth=yj2/dist
   30 continue
   yi3=yi2*costh-zi1*sinth
   yl3=yl2*costh-zl1*sinth
   call xdang(xl2,yl3,xi2,yi3,angle)
   if (angle .lt. 0.) angle=2.0d0*pi+angle
   if (angle .ge. 2.0d0*pi    ) angle=0.d0
   angle=angle*180.0d0/pi
   return
end subroutine xdihed
subroutine xdang(a1,a2,b1,b2,rcos)
   implicit double precision (a-h,o-z)
   !*********************************************************************
   !
   !    dang  determines the angle between the points (a1,a2), (0,0),
   !          and (b1,b2).  the result is put in rcos.
   !
   !*********************************************************************
   data pi/3.14159265358979d0/
   zero=1.0d-6
   if( abs(a1).lt.zero.and. abs(a2).lt.zero) go to 10
   if( abs(b1).lt.zero.and. abs(b2).lt.zero) go to 10
   anorm=1.0d0/ sqrt(a1**2+a2**2)
   bnorm=1.0d0/ sqrt(b1**2+b2**2)
   a1=a1*anorm
   a2=a2*anorm
   b1=b1*bnorm
   b2=b2*bnorm
   sinth=(a1*b2)-(a2*b1)
   costh=a1*b1+a2*b2
   if(costh.gt.1.0d0) costh=1.0d0
   if(costh.lt.-1.0d0) costh=-1.0d0
   rcos= acos(costh)
   if( abs(rcos).lt.4.0d-4) go to 10
   if(sinth.gt.0.d0) rcos=2.0d0*pi-rcos
   rcos=-rcos
   return
   10 rcos=0.0d0
   return
end subroutine xdang

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine htosq(n,a,b)
   implicit none
! ---------------------------------------------------------------------
!      expand trigonal matrix b to full matrix a
!      a and b may refer to the same address
! ---------------------------------------------------------------------
   integer, intent(in)  :: n
   real(wp),intent(out) :: a(n,n)
   real(wp),intent(in)  :: b(n*(n+1)/2)
   integer :: i,j,ioff

   do i=n,1,-1
      ioff=i*(i-1)/2
      do j=i,1,-1
         a(j,i)=b(ioff+j)
      enddo
   enddo

   do i=1,n
      do j=1,i-1
         a(i,j)=a(j,i)
      enddo
   enddo

end subroutine htosq

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_extern_orca
!$ use omp_lib
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType
   use xtb_mctc_symbols, only : toSymbol
   use xtb_type_calculator, only : TCalculator
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_param, only : scc_parameter
   use xtb_type_restart, only : TRestart
   use xtb_io_writer, only : writeMolecule
   use xtb_mctc_systools
   use xtb_mctc_strings
   use xtb_setparam
   use xtb_readin
   use xtb_mctc_convert
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_metadynamic
   use xtb_constrainpot
   implicit none
   private

   public :: TOrcaCalculator, newOrcaCalculator


   type, extends(TCalculator) :: TOrcaCalculator
      
      type(qm_external) :: ext
   
   contains
      
      !> perform single-point calculation
      procedure :: singlepoint
      
      !> calculate hessian
      procedure :: hessian
      
      !> write informative printout
      procedure :: writeInfo
   
   end type TOrcaCalculator


contains

!> create a new calculator for driving ORCA
subroutine newOrcaCalculator(self, env, ext, oniom)
   
   !> ORCA calculator instance
   type(TOrcaCalculator), intent(out) :: self
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> ORCA settings
   type(qm_external), intent(in) :: ext
   
   !> if ONIOM calculation 
   logical, intent(in), optional :: oniom

   ! settings !
   self%ext = ext
   if (present(oniom)) self%ext%oniom=oniom
   self%threadsafe = .false. ! parallelization !

   ! setup ORCA !
   call checkOrca(env, self%ext)

end subroutine newOrcaCalculator

!> setup environment for ORCA run 
subroutine checkOrca(env, ext)

   use xtb_extern_driver, only : checkExe

   !> traceback 
   character(len=*), parameter :: source = 'extern_orca_checkOrca'
   
   !> calculation environment
   type(TEnvironment), intent(inout) :: env
   
   !> ORCA settings
   type(qm_external), intent(inout) :: ext


   !> file existence 
   logical :: exist
   
   !> XMol file  
   logical :: chk_xyzfile
   
   !> ENGRAD keyword
   logical :: chk_engrad
  
   !> ORCA input file unit
   integer :: iorca 
   
   ! find ORCA !
   call checkExe(env,ext%executable,"orca")
   
   ! check for wrong executable [GNOME screen reader] !
   if (index(ext%executable,'/usr') == 1) then
      inquire(file=ext%executable//'_scf',exist=exist)
      if (.not. exist) then
         call env%error("Executable '"//ext%executable//"' is in the system path, "//&
            & "is this the GNOME screen reader?", source)
         return
      endif
   endif
   
   ! preference for an input file !
   if (allocated(ext%input_file)) then
      inquire(file=ext%input_file,exist=exist)
      ext%exist = exist

   else ! assign input file name !
      ext%input_file = "orca-"//get_random_name()//'.inp'
      inquire(file=ext%input_file,exist=exist)  
      ext%exist = exist
   endif

   ! check existing input !
   if (ext%exist) then
      
      call open_file(iorca,ext%input_file,'r')
      
      ! sanity check !
      if (iorca.eq.-1) then 
         call env%error("ORCA input file '"//ext%input_file//"' just vanished!",source)
         return
      endif

      ! find engrad & xyzfile keys !
      call chkInput(iorca,chk_engrad,chk_xyzfile,ext%str_file)
      
      call close_file(iorca)

      if (.not.(chk_engrad.and.chk_xyzfile)) then
         call env%error("Please add '! ENGRAD' and/or '* xyzfile' to '"//&
         & ext%input_file //"'!",source)
         return
      endif
   
   else   ! input string: find || create !

      if (allocated(ext%input_string)) then
         if (index(ext%input_string,'!') == 1) then
            ext%input_string = ext%input_string(2:)
         endif
      else
         ext%input_string = 'b97-3c'
      endif
   
   endif

end subroutine checkOrca

!> check ORCA input file for certain keywords
subroutine chkInput(iunit,grad,xyz,geo)

   !> ORCA file unit
   integer, intent(in) :: iunit 
   
   !> if certain keywords are present
   logical, intent(out) :: grad, xyz

   !> buffer string
   character(len=:), allocatable :: line
   
   !> molecular structure file name
   character(len=:), allocatable :: geo

   !> error handling
   integer :: err

   !> position holders
   integer :: startPos, endPos
   
   ! Intilialization !
   grad = .false.
   xyz = .false.
   
   ! read file !
   do
      
      call strip_line(iunit,line,err)
      if (err.ne.0) exit
      
      line = lowercase(line)
      
      if (firstArgComesFirst(line,'!','engrad')) &
            grad = .true.

      if(firstArgComesFirst(line,'*','xyzfile')) then
         if (firstArgComesFirst(line,'xyzfile','.xyz')) then
            
            ! get the name of geometry file ! 
            endPos = index(line,'.xyz')
            startPos = index(line(:endPos),' ',back=.true.)
            geo = line(startPos+1:endPos+3)
            
            xyz = .true.
         endif
      endif

   enddo

end subroutine chkInput

!> check argument positions wrt. each other
function firstArgComesFirst(str,arg1,arg2)

   !> raw line
   character(len=*), intent(in) :: str

   !> arguments
   character(len=*), intent(in) :: arg1, arg2

   !> return value
   logical :: firstArgComesFirst
   
   !> arg positions
   integer :: pos1, pos2

   ! find arg positions !
   pos1 = index(str,arg1)
   pos2 = index(str,arg2)

   if (pos1 > 0 .and. pos2 > 0) then
      firstArgComesFirst = pos1 < pos2
   else 
      firstArgComesFirst = .false.
   endif 

end function

!> create *.inp for ORCA run
subroutine writeOrcaInp(env,io,mol,input,mode)
   
   !> calculation enironment
   type(TEnvironment), intent(inout) :: env

   !> ORCA input file unit
   integer, intent(in) :: io

   !> molecular structure data
   type(TMolecule), intent(in) :: mol

   !> input string 
   character(len=*), intent(in) :: input

   !> calculation type
   character(len=*), intent(in) :: mode
   
   integer :: i, nel, mult, etc
   integer :: num_threads

   write(io,'("#",1x,a)') &
      "ORCA input is generated automatically. Not correct way."
   
   num_threads = 1 ! default

   ! number of cores !
   !$omp parallel
   !$omp master
   !$   num_threads = omp_get_num_threads()
   !$omp end master
   !$omp end parallel 
   
   write(io,'("%",a,/,3x,a,1x,i0,/,a)') &
      "pal","nprocs", num_threads ,"end"
   
   ! memory usage !
   write(io,'("%",a,1x,i0)') &
      "MaxCore", get_mem(env,num_threads)
   
   ! orca keywords !
   write(io,'("!",1x,a)') &
      "nopop", "miniprint", input, mode

   ! calculate number of electrons and multiplicity !
   nel = sum(mol%at) - nint(mol%chrg)
   mult = mod(nel, 2) + 1
   if (mod(nel, 2) == mod(mol%uhf, 2)) mult = mol%uhf + 1

   ! print molecular geometry !
   write(io,'("*",1x,a,1x,i0,1x,i0)') &
      "xyz",nint(mol%chrg),mult

   do i = 1, mol%n
      write(io,'(3x,a2,3(2x,F20.14))') toSymbol(mol%at(i)), mol%xyz(:,i)*autoaa
   end do

   write(io,'("*",/)')

end subroutine writeOrcaInp

!> get available memory from /proc/meminfo
function get_mem(env,nThread)

   !> calculation environment
   type(TEnvironment), intent(inout) :: env 

   !> number of threads
   integer, intent(in) :: nThread

   !> available memory
   integer :: get_mem
   
   !> IO for 
   integer :: meminfo

   !> buffer string 
   character(len=:), allocatable :: line

   !> error handling
   integer :: err, mem

   !> array for readl
   real(wp) :: xx 

   call open_file(meminfo, '/proc/meminfo','r')
   
   ! default case !
   get_mem = 3000
   
   ! read from /proc/meminfo ! 
   if (meminfo.ne.-1) then

      call strip_line(meminfo,line,err) 
      call strip_line(meminfo,line,err)
      call strip_line(meminfo,line,err)
      if (index(line,"MemAvailable").ne.0) then
         call readl(line,xx,mem)
         get_mem = (int(xx)/1024)/nThread ! memory per core !
         get_mem = get_mem - 100 ! 100 MB that maybe needed for add jobs !
      endif

   endif

endfunction get_mem

!> read energy and gradients from ORCA calculation
subroutine readOrcaEngrad(io, energy, gradient)
   
   !> orca unit number
   integer, intent(in) :: io

   !> electronic energy
   real(wp), intent(out) :: energy

   !> gradients 
   real(wp), intent(out) :: gradient(:, :)

   !> number of atoms
   integer :: nat

   !> loop index
   integer :: iat
   
   read(io,'(a)')
   read(io,'(a)')
   read(io,'(a)')
   read(io,*) nat
   
   read(io,'(a)')
   read(io,'(a)')
   read(io,'(a)')
   read(io,*) energy
   
   read(io,'(a)')
   read(io,'(a)')
   read(io,'(a)')

   do iat = 1, nat
      read(io,*)gradient(1,iat)
      read(io,*)gradient(2,iat)
      read(io,*)gradient(3,iat)
   end do

end subroutine readOrcaEngrad

subroutine readOrcaHess(io, hess, dipgrad)
   integer, intent(in) :: io
   real(wp), intent(out) :: hess(:, :)
   real(wp), intent(out) :: dipgrad(:, :)

   integer :: ndim, irow, ii, stat
   character(len=:), allocatable :: line
   real(wp), allocatable :: buffer(:)
   integer, allocatable :: icol(:)

   stat = 0
   call getline(io, line, stat)
   do while(stat == 0)
      if (line == "$hessian") then
         call getline(io, line, stat)
         read(line, *) ndim
         allocate(icol(ndim), buffer(ndim))
         call getline(io, line, stat)
         do while(len(line) > 0 .and. stat == 0)
            icol(:) = -1
            read(line, *, iostat=stat) icol
            icol = pack(icol, icol >= 0) + 1
            do irow = 1, ndim
               read(io, *) ii, buffer(:size(icol))
               hess(icol, irow) = buffer(:size(icol))
            end do
            call getline(io, line, stat)
         end do
      end if

      if (line == "$dipole_derivatives") then
        call getline(io, line, stat)
         read(line, *) ndim
         do ii = 1, ndim
            read(io, *) dipgrad(:, ii)
         end do
      end if
      call getline(io, line, stat)
   end do
end subroutine readOrcaHess

!>  wrapper for ORCA system call 
subroutine runOrca(env,ext,mol,energy,gradient)

   !> traceback
   character(len=*), parameter :: source = 'extern_orca_runOrca'
   
   !> calculation environment 
   type(TEnvironment), intent(inout) :: env
   
   !> ORCA settings 
   type(qm_external), intent(in) :: ext
   
   !> molecular structure data 
   type(TMolecule), intent(in) :: mol

   !> ORCA SP energy
   real(wp),intent(out) :: energy
   
   !> ORCA gradients
   real(wp),intent(out) :: gradient(:, :)

   integer :: i,j,err, err2
   !> file IO unit
   integer :: iorca, eunit
   logical :: exist
   character(len=:),allocatable :: line
   character(len=:),allocatable :: outfile
   character(len=:),allocatable :: tmpfile

   character(Len=:), allocatable :: message

   !$omp critical (orca_lock)
   
   ! input file handling !
   if (ext%exist) then
      
      ! rewrite *.xyz file from ORCA input !
      call open_file(iorca,ext%str_file,'w')
      call writeMolecule(mol, iorca, format=fileType%xyz)
      call close_file(iorca)

   else
      
      ! create ORCA input !
      call open_file(iorca,ext%input_file,'w')
      call writeOrcaInp(env,iorca,mol,ext%input_string, "engrad")
      call close_file(iorca)
   
   endif
   
   ! shift responsibility from xtb !  
   write(env%unit,'(25x,"*",1x,a)') &
      "ORCA takes the control..."
   write(env%unit,'(2x,72("-"))')

   ! ORCA system call !
   if (set%oniom_settings%silent) then ! silent mode ! 
      call execute_command_line('exec '//ext%executable//' '// &
                             ext%input_file//'>orca.out 2> err',exitstat=err)
   else
      call execute_command_line('exec '//ext%executable//' '// &
                             ext%input_file//' 2> err',exitstat=err)
   endif
   
   ! ORCA dumps mpirun errors into stderr !
   call open_file(eunit,'err','r')
   call getline(eunit,message,err2)

   ! shift responsibility back !
   write(env%unit,'(2x,72("-"))')
   if (err.ne.0 .or. .not. is_iostat_end(err2)) then
      call raise('E','ORCA returned with non-zero exit status, doing the same')
   else
      write(env%unit,'(10x,"*",1x,a)') &
         "successful ORCA run, taking over control again..."
      call env%io%deleteFile("err")
   endif
   
   ! find output .engrad file !
   i = index(ext%input_file,'.inp')
   if (i > 0) then
      outfile = ext%input_file(:i-1)//'.engrad'
      tmpfile = ext%input_file(:i-1)
   else
      outfile = ext%input_file//'.engrad'
      tmpfile = ext%input_file
   endif

   inquire(file=outfile,exist=exist)
   if (.not.exist) then
      call raise('E',"Could not find '"//outfile//"', aborting driver run")
  
   else

      ! read .engrad !
      call open_file(iorca,outfile,'r')
      call readOrcaEngrad(iorca, energy, gradient)

      ! clean calculation directory !
      if (set%ceasefiles) then
         call remove_file(iorca)
         call env%io%deleteFile(tmpfile//".gbw")
         call env%io%deleteFile(tmpfile//".densities")
         call env%io%deleteFile(tmpfile//".rr")
         call env%io%deleteFile(tmpfile//"_property.txt")
         call env%io%deleteFile("orca.out")
      else
         call close_file(iorca)
      endif

   endif

   !$omp end critical (orca_lock)

end subroutine runOrca

!> wrapper for ORCA single-point run 
subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)
   
   !> traceback
   character(len=*), parameter :: source = 'extern_orca_singlepoint'
   
   !> calculator instance
   class(TOrcaCalculator), intent(inout) :: self
   
   !> computational environment
   type(TEnvironment), intent(inout) :: env
   
   !> molecular structure data
   type(TMolecule), intent(inout) :: mol
   
   !> wavefunction data
   type(TRestart), intent(inout) :: chk
   
   !> print level for I/O
   integer, intent(in) :: printlevel
   
   !> restart from previous results
   logical, intent(in) :: restart
   
   !> total energy
   real(wp), intent(out) :: energy
   
   !> molecular gradient
   real(wp), intent(out) :: gradient(:, :)
   
   !> strain derivatives
   real(wp), intent(out) :: sigma(:, :)
   
   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap
   
   !> detailed results
   type(scc_results), intent(out) :: results

   integer :: i,ich
   integer :: mode_sp_run = 1
   real(wp) :: efix
   real(wp) :: dipole(3)
   logical :: inmol
   logical, parameter :: ccm = .true.
   logical :: exitRun
   character(len=*),parameter :: outfmt = &
      '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'

   ! Intialization !
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   hlgap = 0.0_wp
   efix = 0.0_wp
   dipole(:) = 0.0_wp
   call mol%update 

   ! system call wrapper !
   call runOrca(env,self%ext,mol,energy,gradient)

   ! error handling !
   call env%check(exitRun)
   if (exitRun) then
      call env%error("Electronic structure method terminated", source)
      return
   end if

   ! various external potentials !
   call constrain_pot(potset,mol%n,mol%at,mol%xyz,gradient,efix)
   call constrpot   (mol%n,mol%at,mol%xyz,gradient,efix)
   call cavity_egrad(mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (metaset,mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (rmsdset,mol%n,mol%at,mol%xyz,efix,gradient)
   energy = energy + efix

   ! save results !
   results%e_total = energy
   results%gnorm = norm2(gradient)
   results%dipole = dipole

   ! exact fixing !
   if (fixset%n.gt.0) then
      do i=1, fixset%n
         gradient(1:3,fixset%atoms(i))=0
      enddo
   endif

   ! print calculation results !  
   if (printlevel.ge.2) then

      ! start with summary header !
      if (.not.set%silent) then
         write(env%unit,'(/,9x,53(":"))')
         write(env%unit,'(9x,"::",18x,a,19x,"::")') "ORCA SUMMARY"
      endif
      
      write(env%unit,'(9x,53(":"))')
      write(env%unit,outfmt) "total energy      ", results%e_total,"Eh   "
      write(env%unit,outfmt) "gradient norm     ", results%gnorm,  "Eh/a0"
      write(env%unit,outfmt) "HOMO-LUMO gap     ", results%hl_gap, "eV   "
      write(env%unit,'(9x,53(":"))')
      write(env%unit,'(a)')
   
   endif

end subroutine singlepoint

!> Evaluate hessian by finite difference for all atoms
subroutine hessian(self, env, mol0, chk0, list, step, hess, dipgrad, polgrad)
   character(len=*), parameter :: source = "extern_turbomole_hessian"
   !> Single point calculator
   class(TOrcaCalculator), intent(inout) :: self
   !> Computation environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol0
   !> Restart data
   type(TRestart), intent(in) :: chk0
   !> List of atoms to displace
   integer, intent(in) :: list(:)
   !> Step size for numerical differentiation
   real(wp), intent(in) :: step
   !> Array to add Hessian to
   real(wp), intent(inout) :: hess(:, :)
   !> Array to add dipole gradient to
   real(wp), intent(inout) :: dipgrad(:, :)
   !> Array to add polarizability gradient to
   real(wp), intent(inout), optional :: polgrad(:, :)

   integer :: i,j,err
   integer :: iorca ! file handle
   logical :: exist
   character(len=:),allocatable :: line
   character(len=:),allocatable :: outfile
!$ integer,external :: omp_get_num_threads

   !$omp critical (orca_lock)
   if (self%ext%exist) then
      ! we dump the name of the external xyz file to input_string... not cool
      call open_file(iorca,self%ext%input_string,'w')
      call writeMolecule(mol0, iorca, format=fileType%xyz)
      call close_file(iorca)
   else
      call open_file(iorca,self%ext%input_file,'w')
      call writeOrcaInp(env,iorca,mol0,self%ext%input_string, "anfreq")
      call close_file(iorca)
   endif

   write(env%unit,'(72("="))')
   write(env%unit,'(1x,"*",1x,a)') &
      "letting orca take over the control..."
   call execute_command_line('exec 2>&1 '//self%ext%executable//' '// &
                             self%ext%input_file,exitstat=err)
   if (err.ne.0) then
      call env%error('orca returned with non-zero exit status, doing the same',source)
   else
      write(env%unit,'(1x,"*",1x,a)') &
         "successful orca run, taking over control again..."
   endif
   write(env%unit,'(72("="))')

   i = index(self%ext%input_file,'.inp')
   if (i > 0) then
      outfile = self%ext%input_file(:i-1)//'.hess'
   else
      outfile = self%ext%input_file//'.hess'
   endif
   inquire(file=outfile,exist=exist)
   if (.not.exist) then
      call env%error("Could not find '"//outfile//"', aborting driver run",source)
   else
      call open_file(iorca,outfile,'r')
      call readOrcaHess(iorca, hess, dipgrad)
      call close_file(iorca)
   endif
   !$omp end critical (orca_lock)

end subroutine hessian

subroutine writeInfo(self, unit, mol)

   !> Calculator instance
   class(TOrcaCalculator), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   call generic_header(unit,"Orca driver",49,10)

   write(unit,'(a,1x,a)') &
      "orca executable           :",self%ext%executable, &
      "orca input file           :",self%ext%input_file,&
      "orca input line           :",self%ext%input_string
   !$omp parallel
   !$omp master
   !$ write(unit,'(a,1x,g0)') &
   !$ "orca parallel             :",bool2string(omp_get_num_threads() > 1),&
   !$ "orca number of threads    :",omp_get_num_threads()
   !$omp end master
   !$omp end parallel
end subroutine writeInfo

!> random name generator
function get_random_name() result(str)

   !> random name
   character(len=:), allocatable :: str
   
   !> random number
   real :: rnd

   !> reinterpretation of real number as an integer 
   integer :: irnd

   call random_number(rnd)
   irnd = transfer(rnd, irnd)
   str = to_hex(abs(irnd))

end function

!> transform integer value into hexadecimal
pure function to_hex(val) result(string)

   !> integer input
   integer, intent(in) :: val
   
   !> resulting name
   character(len=:), allocatable :: string

   !> length of the buffer
   integer, parameter :: buffer_len = range(val) + 2

   !> intermediate value buffer
   character(len=buffer_len) :: buffer
   
   !> position in the buffer
   integer :: pos

   !> current integer value
   integer :: n

   !> hexadecimal base
   integer, parameter :: base = 16
   
   !> hexadecimal digits mapping 
   character(len=1), parameter :: numbers(0:base-1) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"]


   ! initialization !
   n = val
   buffer = ""
   pos = buffer_len + 1 
   
   ! return 0 !
   if (val == 0) then
      string = numbers(0)
      return
   end if
   
   ! decimal -> hexadecimal !
   do while (n > 0)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, base))
      n = n/base
   end do

   string = buffer(pos:)

end function to_hex

end module xtb_extern_orca

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> TODO
module xtb_xtb_halogen
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   use xtb_lin, only : lin
   use xtb_xtb_data
   implicit none
   private

   public :: xbpot


contains


subroutine xbpot(halData,n,at,xyz,xblist,nxb,a,exb,g)
   type(THalogenData), intent(in) :: halData
   integer, intent(in) :: n
   integer, intent(in) :: at(:)
   integer, intent(in) :: nxb
   integer, intent(in) :: xblist(:,:)
   real(wp), intent(in) :: xyz(:,:)
   real(wp), intent(inout) :: g(:,:)
   real(wp), intent(inout) :: exb
   real(wp), intent(in) :: a

   integer :: m,k,AA,B,X,ati,atj
   real(wp) :: cc,r0ax,t13,t14,t16
   real(wp) :: d2ax,rax,term,aterm,xy,d2bx,d2ab,alp,lj2
   real(wp) :: er,el,step,dxa(3),dxb(3),dba(3),dcosterm
   real(wp) :: dtermlj,termlj,prefactor,numerator,denominator,rbx
   alp=6.0_wp
   lj2=0.50_wp*a

   exb = 0.0_wp
   if(nxb.lt.1) return

   ! B-X...A
   !$omp parallel do schedule(runtime) default(none) reduction(+:exb) &
   !$omp shared(nxb, xblist, at, halData, xyz, lj2, alp, a) &
   !$omp private(X, AA, B, ati, atj, cc, r0ax, dxa, dxb, dba, d2ax, &
   !$omp& d2bx, d2ab, rax, XY, aterm, t13, t14, TERM)
   do k=1,nxb
      X =xblist(1,k)
      AA=xblist(2,k)
      B=xblist(3,k)
      ati=at(X)
      atj=at(AA)
      cc=halData%bondStrength(ati)
      r0ax=halData%radScale*(halData%atomicRad(ati)+halData%atomicRad(atj))
      dxa=xyz(:,AA)-xyz(:,X)   ! acceptor - halogen
      dxb=xyz(:, B)-xyz(:,X)   ! neighbor - halogen
      dba=xyz(:,AA)-xyz(:, B)  ! acceptor - neighbor
      d2ax=sum(dxa*dxa)
      d2bx=sum(dxb*dxb)
      d2ab=sum(dba*dba)
      rax=sqrt(d2ax)
      ! angle part. term = cos angle B-X-A
      XY = SQRT(D2BX*D2AX)
      TERM = (D2BX+D2AX-D2AB) / XY
      aterm = (0.5_wp-0.25_wp*term)**alp
      t13 = r0ax/rax
      t14 = t13**a
      exb = exb +  aterm*cc*(t14-halData%dampingPar*t13**lj2) / (1.0_wp+t14)
   enddo

   ! analytic gradient
   !$omp parallel do schedule(runtime) default(none) reduction(+:g) &
   !$omp shared(nxb, xblist, at, halData, xyz, lj2, alp) &
   !$omp private(X, AA, B, ati, atj, cc, r0ax, dxa, dxb, dba, d2ax, &
   !$omp& d2bx, d2ab, rax, XY, aterm, numerator, denominator, termLJ, &
   !$omp& dtermlj, prefactor, dcosterm, t13, t14, rbx, TERM)
   do k=1,nxb
      X =xblist(1,k)
      AA=xblist(2,k)
      B=xblist(3,k)
      ati=at(X)
      atj=at(AA)
      cc=halData%bondStrength(ati)
      r0ax=halData%radScale*(halData%atomicRad(ati)+halData%atomicRad(atj))

      dxa=xyz(:,AA)-xyz(:,X)   ! acceptor - halogen
      dxb=xyz(:, B)-xyz(:,X)   ! neighbor - halogen
      dba=xyz(:,AA)-xyz(:, B)  ! acceptor - neighbor

      d2ax=sum(dxa*dxa)
      d2bx=sum(dxb*dxb)
      d2ab=sum(dba*dba)
      rax=sqrt(d2ax)+1.0e-18_wp
      rbx=sqrt(d2bx)+1.0e-18_wp

      XY = SQRT(D2BX*D2AX)
      TERM = (D2BX+D2AX-D2AB) / XY
      ! now compute angular damping function
      aterm = (0.5_wp-0.25_wp*term)**alp

      ! set up weighted inverted distance and compute the modified Lennard-Jones potential
      t14 = (r0ax/rax)**lj2 ! (rov/r)^lj2 ; lj2 = 6 in GFN1
      numerator = (t14*t14 - halData%dampingPar*t14)
      denominator = (1.0_wp + t14*t14)
      termLJ= numerator/denominator

      ! ----
      ! LJ derivative
      ! denominator part
      dtermlj=2.0_wp*lj2*numerator*t14*t14/(rax*denominator*denominator)
      ! numerator part
      dtermlj=dtermlj+lj2*t14*(halData%dampingPar - 2.0_wp*t14)/(rax*denominator)
      ! scale w/ angular damping term
      dtermlj=dtermlj*aterm*cc/rax
      ! gradient for the acceptor
      g(:,AA)=g(:,AA)+dtermlj*dxa(:)
      ! halogen gradient
      g(:,X)=g(:,X)-dtermlj*dxa(:)
      ! ----
      ! cosine term derivative
      prefactor=-0.250_wp*alp*(0.5_wp-0.25_wp*term)**(alp-1.0_wp)
      prefactor=prefactor*cc*termlj
      ! AX part
      dcosterm=2.0_wp/rbx - term/rax
      dcosterm=dcosterm*prefactor/rax
      ! gradient for the acceptor
      g(:,AA)=g(:,AA)+dcosterm*dxa(:)
      ! halogen gradient
      g(:,X)=g(:,X)-dcosterm*dxa(:)
      ! BX part
      dcosterm=2.0_wp/rax - term/rbx
      dcosterm=dcosterm*prefactor/rbx
      ! gradient for the acceptor
      g(:,B)=g(:,B)+dcosterm*dxb(:)
      ! halogen gradient
      g(:,X)=g(:,X)-dcosterm*dxb(:)
      ! AB part
      t13=2.0_wp*prefactor/xy
      ! acceptor
      g(:,AA)=g(:,AA)-t13*dba(:)
      ! neighbor
      g(:,B)=g(:,B)+t13*dba(:)

   enddo
end subroutine xbpot


end module xtb_xtb_halogen

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

! solve QM Hamiltonian A in overlap basis S (if ovlp=.true., ZDO otherwise)
! and return density matrix in A (and energy weighted density in S if ovlp=.true.)
! ndim is the dimension of the problem for nel electrons with nopen more alpha than beta

subroutine gfnffqmsolve(pr,A,S,ovlp,et,ndim,nopen,nel,eel,focc,e)
      use xtb_mctc_accuracy, only : wp
      use xtb_scc_core, only : dmat, fermismear, occu
      implicit none
      integer ndim      ! # basis
      integer nopen     ! # of open shells
      integer nel       ! # of electrons
      logical ovlp      ! in overlap basis?
      logical pr        !
      real(wp) et       ! electronic temp Fermi smear
      real(wp) eel      ! electronic energy = sum_occ nocc*eps
      real(wp) focc(ndim)! occupations
      real(wp) e(ndim)  ! eigenvalues
      real(wp) A(ndim,ndim)
      real(wp) S(ndim,ndim)

      integer ihomoa,ihomob,i,liwork,info,lwork
      real(wp) ga,gb,efa,efb,nfoda,nfodb
      real(wp),allocatable:: X(:,:)
      real(wp),allocatable:: focca(:),foccb(:),aux(:)
!     real*4  ,allocatable:: aux4(:),e4(:),A4(:,:)
      integer,allocatable :: iwork(:),ifail(:)


      allocate(focca(ndim),foccb(ndim))

! ZDO case
      if(.not.ovlp) then

      lwork  = 1 + 6*ndim + 2*ndim**2
!     allocate(aux4(lwork),e4(ndim),A4(ndim,ndim))
!     A4 = A
!     call ssyev ('V','U',ndim,A4,ndim,e4,aux4,lwork,info)
!     A = A4
!     e = e4
!     deallocate(aux4,A4,e4)
      allocate(aux(lwork))
      call dsyev ('V','U',ndim,A,ndim,e,aux,lwork,info)

      else
! with overlap case

      allocate (aux(1),iwork(1),ifail(ndim))
      call DSYGVD(1,'V','U',ndim,A,ndim,S,ndim,e,aux, &  !workspace query
     &               -1,IWORK,LIWORK,INFO)
      lwork=int(aux(1))
      liwork=iwork(1)
      deallocate(aux,iwork)

      allocate (aux(lwork),iwork(liwork))              !do it
      call DSYGVD(1,'V','U',ndim,A,ndim,S,ndim,e,aux, &
     &            LWORK,IWORK,LIWORK,INFO)

      endif
! DONE

! scale energy  so that gaps a roughly ok (in eV)

      e=e*0.1*27.2113957

      if(info.ne.0) then
         write(*,*) 'INFO',info
         stop 'diag error'
      endif

      if(et.gt.1.d-3) then
! Fermi smearing, convert restricted occ first to alpha/beta
        call occu(ndim,nel,nopen,ihomoa,ihomob,focca,foccb)
        if(ihomoa.le.ndim.and.ihomoa.gt.0) then
         call fermismear(.false.,ndim,ihomoa,et,e,focca,nfoda,efa,ga)
        else
          focca=0
        endif
        if(ihomob.le.ndim.and.ihomob.gt.0) then
          call fermismear(.false.,ndim,ihomob,et,e,foccb,nfodb,efb,gb)
        else
          foccb=0
        endif
        focc = focca + foccb
        if(ihomoa+1.le.ndim)then
        if(abs(focc(ihomoa)-focc(ihomoa+1)).lt.1.d-4) then ! a perfect birad is anit-aromatic
           focc = 0                                        ! and hence we break the sym
           do i=1,nel/2
              focc(i)=2.0d0
           enddo
           write(*,*) 'perfect biradical detected at FT-HMO level. Breaking the symmetry'
           write(*,*) 'because its assumed to be an anit-aromatic system like COT or CB.'
        endif
        endif
      else
        focc = 0
        do i=1,nel/2
           focc(i)=2.0d0
        enddo
        if(2*(nel/2).ne.nel) focc(nel/2+1)=1.0
      endif

      focca = focc * e
      eel = sum(focca)
! density matrix
      S = A
      call dmat(ndim,focc,S,A)

      if(ovlp) then
      allocate(X(ndim,ndim))
! energy weighted density on S
      call dmat(ndim,focca,S,X)
      S = X
      endif

      deallocate(focca,foccb)
      
end subroutine gfnffqmsolve

module xtb_gfnff_neighbor
  use xtb_type_latticepoint, only : TLatticePoint, init_ => init_l 
  use xtb_type_molecule, only : TMolecule
  use xtb_gfnff_data, only : TGFFData
  use xtb_mctc_accuracy, only : wp
  use xtb_type_environment, only : TEnvironment
  use xtb_mctc_sort

  implicit none
  private
  
  public :: TNeigh

  !> Neighbor lists
  type :: TNeigh
    
    ! neighbor list nb(j,i,iTr); j is neighbor of i when j is shifted by iTr
    integer, allocatable :: nb(:,:,:)  
    ! full nb
    integer, allocatable :: nbf(:,:,:)
    ! no metal nb or unsually coordinated stuff
    integer, allocatable :: nbm(:,:,:)
    ! bpair(j,i,iTr) number bonds between i and j when j is translated by iTr
    integer, allocatable :: bpair(:,:,:)
    integer, allocatable :: molbpair(:)
    ! distances of all atoms to all atoms in central 27 cells
    !real(wp), allocatable :: distances(:,:,:)
    !> Maximum number of neighbors per atom
    ! where nb(numnb,i,transVec) is the num of neigh atom i has in cell transVec
    integer :: numnb = 42
    ! number of central cells so either 1,3,9,27 depending on the PBCs dimension
    integer :: numctr
    integer, allocatable :: iTrSum(:)
    ! index of translation vector pointing in opposite direction of the vector with the input index
    integer, allocatable :: iTrNeg(:)
    ! list with bool for each iTr saying if a bond to this cell should be considered
    ! this is needed to avoid counting bonds to other cells twice
    logical, allocatable :: iTrUsed(:)
    integer :: nbond
    integer :: nbond_blist
    !> bonded atoms
    integer, allocatable :: blist(:,:)
    ! number of hydrogen bonds
    integer, allocatable :: nr_hb(:)
    !> holds 3 vectors for ebond calculation: 1-shift, 2-steepness, 3-tot prefactor
    real(wp), allocatable :: vbond(:,:)
    integer :: nTrans, iTrDim
    integer, allocatable :: idTr(:) ! gives unique id of local iTr (translation vec index)
    integer, allocatable :: Trid(:) ! gives local index for iteration from unique id
    integer, allocatable :: trVecInt(:,:)  ! holds coeff for linear combination that give transVec
    real(wp), allocatable :: transVec(:,:)  ! translation vectors for generating images of unit cell
    real(wp) :: oldCutOff ! save old cutoff in getTransVec calls to quit calc if same cutoff

  contains
   
    ! initialize neigh
    procedure :: init_n
    ! get and fill the neighbor list nb
    procedure :: get_nb
    ! get the central 27 cells
   ! procedure :: getCCells
    ! get all translation Vectors
    procedure :: getTransVec
    ! get locations of nb
    procedure :: nbLoc
    ! get the j'th neighbor of atom i with corresp iTr (transVec index)
    procedure :: jth_nb
    !
    procedure :: id2v
    ! give the shell (surrounding central cell) num that the vector is in (WHichSHell: whsh)
    !!! procedure :: ws3d ! is not in type
    !return resulting vectors index if vectors indx1 and indx2 are added
    procedure :: fTrSum

    


  end type TNeigh

contains

    subroutine init_n(self, mol, env)
      class(TNeigh), intent(inout) :: self
      type(TMolecule), intent(in) :: mol
      type(TEnvironment), intent(inout) :: env
      integer :: iTrDim
      character(len=*), parameter :: source = 'neighbor'
      !
      if(mol%npbc.eq.3) then
        self%numctr = 27
      elseif(mol%npbc.eq.0) then
        self%numctr = 1
      else
        call env%warning("Periodic boundary conditions are only tested for 3 dimensional systems.", source)
      endif

      iTrDim=min(size(self%trVecInt,dim=2),729)
      self%iTrDim=iTrDim
      call filliTrSum(iTrDim, self%trVecInt, self%iTrSum, self%iTrNeg)
      call filliTrUsed(self)
      !init cutoff for getTransVec
      self%oldCutOff=0.0_wp

    end subroutine init_n


    subroutine get_nb(self, mol, rab, rtmp, mchar, icase, f_in, f2_in, param)
      class(TNeigh), intent(inout) :: self
      !> Molecular structure data         
      type(TMolecule), intent(in) :: mol
      real(wp), intent(in) :: rab(:)
      real(wp), intent(in) :: rtmp(mol%n*(mol%n+1)/2)  ! estimated bond lengths
      real(wp), intent(in) :: mchar(mol%n), f_in, f2_in
      integer, intent(in) :: icase
      !integer, intent(inout) :: nbf(20,mol%n)
      type(TGFFData), intent(in) :: param
      !real(wp) :: latThresh, maxNBr
      real(wp) :: dist(mol%n,mol%n,self%numctr)
      integer :: i,j,iTr
      
      dist=0.0_wp
      !$omp parallel do collapse(3) default(none) shared(dist,mol,self) &
      !$omp private(iTr,i,j)
      do iTr=1, self%numctr
       do i=1, mol%n
         do j=1, mol%n
           dist(j,i,iTr) = NORM2(mol%xyz(:,i)-(mol%xyz(:,j)+self%transVec(:,iTr)))
         enddo
       enddo
      enddo
      !$omp end parallel do
      call fillnb(self,mol%n,mol%at,rtmp,dist,mchar,icase,f_in,f2_in,param)

    end subroutine get_nb


    ! get number of transVec within cutoff -> neigh%nTrans
    ! get all linear comb coeff within 60 bohr (maxCutOff)-> neigh%trVecInt
    ! get vector with indices of the nTrans translation vectors -> neigh%idTr
    ! in periodic case at least central 27 transVec to avoid artifacts for cells > 60 bohr
    subroutine getTransVec(self,env,mol,cutoff)
      !> Instance of the lattice point generator                                    
      class(TNeigh), intent(inout) :: self     
      type(TEnvironment), intent(inout) :: env
      !> Molecular structure data         
      type(TMolecule), intent(in) :: mol
      !> cutoff
      real(wp), intent(in) :: cutoff
      
      integer :: ix,iy,iz,i, nLat, nShell, d,indx,id
      integer, allocatable :: idTrTmp(:)
      real(wp), allocatable :: sVec(:) ! shortest lattice vector
      real(wp), allocatable :: vec(:), trVecTmp(:,:)
      real(wp) :: sh
      character(len=*), parameter :: source = 'neighbor'
      ! check if last calculation was with same cutoff
      if(self%oldCutOff.eq.cutoff) then
        return
      else
        self%oldCutoff=cutoff
      endif  

      ! seperate treatment depending on periodicity
      if (mol%npbc.eq.0) then !#ifmolnpbc
        if(.not.allocated(self%idTr)) allocate(self%idTr(1))
        if(.not.allocated(self%Trid)) allocate(self%Trid(1))
        self%nTrans=1
        self%idTr=1
        self%Trid=1
        if(.not.allocated(self%trVecInt)) allocate(self%trVecInt(3,1),source=0)
        if(.not.allocated(self%transVec)) allocate(self%transVec(3,1),source=0.0_wp)

      ! periodic treatment  
      else  !#ifmolnpbc
        nLat=mol%npbc
        ! find shortest lattice vector
        allocate(sVec(3))
        sVec = 1.0d15
        do i=1, 3 ! go through all lattice vectors
          if(.not.mol%pbc(i)) cycle
          if(NORM2(mol%lattice(:,i)).lt.NORM2(sVec)) then
            sVec=mol%lattice(:,i)
          endif
        enddo
        if(NORM2(sVec).eq.0.0_wp) then
          call env%error('A lattice vector for a periodic axis is zero.', source)
          return
        endif
        ! see how often sVec fits in cutoff -> gives number of needed shells
        ! e.g. in 3D  nShell=1 -> 3x3x3    nShell=4 -> 9x9x9
        nShell = CEILING(cutoff/NORM2(sVec))
        d=(2*nShell+1)**nLat

        ! lattice might change during optimization. Therefore d might change
        !  between different runs and trVecInt needs to be adjusted.
        if(allocated(self%trVecInt)) then
          if(size(self%trVecInt,dim=2).lt.d) then
            deallocate(self%trVecInt)
          endif
        endif

        ! get the linear combination coefficient vector
        ! different loops depending on dimension (nLat)
        if(.not.allocated(self%trVecInt)) then !#ifnotallocatedtrvecint
          if(nLat.eq.3) then
            allocate(self%trVecInt(3,d),source=0)
            indx=1
            do i=1,nShell
              do iz=-i, i
                do iy=-i, i
                  do ix=-i, i
                    !
                    if(abs(ix).ne.i.and.abs(iy).ne.i.and.abs(iz).ne.i) cycle
                    indx=indx+1
                    self%trVecInt(:,indx)=[ix,iy,iz]
                  enddo
                enddo
              enddo  
            enddo

          elseif(nLat.eq.2) then
            allocate(self%trVecInt(3,d),source=0)
            indx=1
            do i=1,nShell
              do iz=-i, i
                do iy=-i, i
                  do ix=-i, i
                    ! one of the lattice vecs is not periodic, only cycle wrt the other vecs
                    if(.not.mol%pbc(1)) then
                      if(abs(iy).ne.i.and.abs(iz).ne.i) cycle
                    elseif(.not.mol%pbc(2))then
                      if(abs(ix).ne.i.and.abs(iz).ne.i) cycle
                    elseif(.not.mol%pbc(3))then
                      if(abs(ix).ne.i.and.abs(iy).ne.i) cycle
                    endif
                    indx=indx+1
                    if(mol%pbc(1)) self%trVecInt(1,indx)= ix
                    if(mol%pbc(2)) self%trVecInt(2,indx)= iy
                    if(mol%pbc(3)) self%trVecInt(3,indx)= iz
                  enddo
                enddo
              enddo  
            enddo

          elseif(nLat.eq.1) then
            allocate(self%trVecInt(3,d),source=0)
            indx=1
            do i=1,nShell
              do iz=-i, i
                do iy=-i, i
                  do ix=-i, i
                    ! only one of the lattice vecs is periodic, only cycle wrt this vector
                    if(mol%pbc(1)) then
                      if(abs(ix).ne.i) cycle
                    elseif(.not.mol%pbc(2))then
                      if(abs(iy).ne.i) cycle
                    elseif(.not.mol%pbc(3))then
                      if(abs(iz).ne.i) cycle
                    endif
                    indx=indx+1
                    if(mol%pbc(1)) self%trVecInt(1,indx)= ix
                    if(mol%pbc(2)) self%trVecInt(2,indx)= iy
                    if(mol%pbc(3)) self%trVecInt(3,indx)= iz
                  enddo
                enddo
              enddo  
            enddo

          else
            call env%error('Dimension of PBCs could not be processed.', source)
            return
          endif

        endif !#ifnotallocatedtrvecint
        ! Now the linear combinations of lattice vectors are given with neigh%trVecInt
        ! Next up: get number of translation vectors within cutoff
        if(allocated(self%Trid)) deallocate(self%Trid)
        allocate(self%Trid(d),source=0)
        allocate(idTrTmp(d),source=0)
        allocate(vec(nLat),source=0.0_wp)
        indx=0

        if(nLat.eq.3) then
          allocate(trVecTmp(3,d))
          do id=1, d
            !
            vec = self%trVecInt(1,id)*mol%lattice(:,1) &
                + self%trVecInt(2,id)*mol%lattice(:,2) &
                + self%trVecInt(3,id)*mol%lattice(:,3)
            if(id.gt.27)then ! always want the central 27 cells
              ! check which shell the transVec is from (they are ordered by shell)  
              if(id.eq.28)   sh = 2.0  ! first shell has 27 cells
              if(id.eq.126)  sh = 3.0  ! second has   125
              if(id.eq.344)  sh = 4.0  ! third  has   343
              if(id.eq.730)  sh = 5.0  ! fourth has   729
              if(id.eq.1332) sh = 6.0  ! fifth  has  1331
              if(id.eq.2198) sh = 7.0  ! sixth  has  2197
              if(id.eq.3376) sh = 8.0  !   7th  has  3375
              if(id.eq.4914) sh = 9.0  !   8th  has  4913
              if(id.eq.6860) sh = 10.0 !   9th  has  6859
              if(id.eq.9262) sh = 11.0  ! 10th  has  9261
              if(id.eq.12168) sh = 12.0 ! 11th  has 12167
              if(id.eq.15626) sh = 13.0 ! 12th  has 15625
              if(id.eq.19684) sh = 14.0 ! 13th  has 19683
              ! the factor ensures that the cutoff is completely covered
              if(NORM2(vec)*(1-1/sh).gt.cutoff) then
              cycle
              endif
            endif
            indx=indx+1
            idTrTmp(indx)=id ! id is ALWAYS the same for one specific linear combination (LC)
            self%Trid(id)=indx !-> if you put indx into trVecInt you will always get the same LC
            trVecTmp(:,indx)=vec
          enddo
          if(id.gt.24389) then
            call env%error('Implementation is not adjusted for such small cells.', source)
            return
          endif
          if(allocated(self%transVec)) deallocate(self%transVec)
          if(allocated(self%idTr)) deallocate(self%idTr)
          allocate(self%transVec(3,indx))
          allocate(self%idTr(indx),source=0)
          self%transVec=trVecTmp(:,1:indx)
          self%idTr=idTrTmp(1:indx)

        elseif(nLat.eq.2)then
          !
          allocate(trVecTmp(2,d))
          do id=1, d
            !
            vec = self%trVecInt(1,id)*mol%lattice(:,1) &
                + self%trVecInt(2,id)*mol%lattice(:,2)
           if(id.gt.9)then ! always want the central 9 cells (2-Dim !)
              if(id.eq.10) sh = 2.0
              if(NORM2(vec).gt.cutoff) cycle
            endif
            indx=indx+1
            self%idTr(indx)=id ! assure that indx is ALWAYS the same
                               ! for one specific linear combination (LC)
                               ! that means: if you put indx into trVecInt
                               ! you will always get the same LC
            trVecTmp(:,indx)=vec
          enddo
          if(allocated(self%transVec)) deallocate(self%transVec)
          allocate(self%transVec(2,indx))
          self%transVec=trVecTmp(:,1:indx)

        elseif(nLat.eq.1)then
          !      
          allocate(trVecTmp(1,d))
          do id=1, d
            !
            vec = self%trVecInt(1,id)*mol%lattice(:,1)
            if(indx.gt.27)then ! always want the central 27 cells
              if(NORM2(vec).gt.cutoff) cycle
            endif
            indx=indx+1
            self%idTr(indx)=id ! assure that indx is ALWAYS the same
                               ! for one specific linear combination (LC)
                               ! that means: if you put indx into trVecInt 
                               ! you will always get the same LC
            trVecTmp(:,indx)=vec
          enddo
          if(allocated(self%transVec)) deallocate(self%transVec)
          allocate(self%transVec(1,indx))
          self%transVec=trVecTmp(:,1:indx)
        else
          call env%error('Given lattice could not be processed.', source)
          return
        endif

      endif !#ifmolnpbc
      self%nTrans=size(self%transVec,dim=2)

    end subroutine getTransVec

    
    ! returns translation vector to unique ID, needs neigh%idTr and neigh%transVec
    function id2v(self,mol,id) result(vector)
      !> Instance of the lattice point generator                                    
      class(TNeigh), intent(inout) :: self
      !> Molecular structure data         
      type(TMolecule), intent(in) :: mol
      ! unique ID of the translation vector
      integer, intent(in) :: id
      ! index in transVec
      integer :: indx
      ! result: corresponding translation vector
      real(wp) :: vector(3)

      if(id.le.size(self%trVecInt,dim=2)) then
        !
        vector = self%trVecInt(1,id)*mol%lattice(:,1) &
               + self%trVecInt(2,id)*mol%lattice(:,2) &
               + self%trVecInt(3,id)*mol%lattice(:,3)  

      endif


    end function id2v


    ! is a modified "getnb" from gfnff_ini2.f90
    subroutine fillnb(self,n,at,rad,dist,mchar,icase,f,f2,param)
      implicit none
      type(TGFFData), intent(in) :: param
      class(TNeigh), intent(inout) :: self
      integer, intent(in) :: n,at(n)
      real(wp), intent(in) :: rad(n*(n+1)/2)
      real(wp), intent(in) :: dist(n,n,self%numctr)
      real(wp), intent(in) :: mchar(n),f,f2
      integer i,j,k,iTr,nn,icase,hc_crit,nnfi,nnfj,lin
      integer tag(n,n,self%numctr)
      real(wp) rco,fm
      if(icase.eq.1) then
        if(.not. allocated(self%nbf)) then
          allocate(self%nbf(self%numnb,n,self%numctr),source=0)
        else
          self%nbf=0
        endif
      endif
      if(icase.eq.2) then
        if(.not. allocated(self%nb)) then
          allocate(self%nb(self%numnb,n,self%numctr),source=0)
        else
          self%nb=0
        endif
      endif
      if(icase.eq.3) then
        if(.not. allocated(self%nbm)) then
          allocate(self%nbm(self%numnb,n,self%numctr),source=0)
        else
          self%nbm=0
        endif
      endif

      tag = 0
      do iTr=1, self%numctr
        do i=1,n
          do j=1,n
        
            k=lin(j,i)
            if (dist(j,i,iTr).le.0.0_wp) cycle
            fm=1.0d0
!           full case                                                           
            if(icase.eq.1)then
              if(param%metal(at(i)).eq.2) fm=fm*f2 !change radius for metal atoms
              if(param%metal(at(j)).eq.2) fm=fm*f2                             
              if(param%metal(at(i)).eq.1) fm=fm*(f2+0.025)                     
              if(param%metal(at(j)).eq.1) fm=fm*(f2+0.025)                     
            endif                                                               
!           no HC atoms
            if(icase.eq.2)then
               nnfi=sum(self%nbf(self%numnb,i,:))               ! full CN of i, only valid for icase > 1
               nnfj=sum(self%nbf(self%numnb,j,:))               ! full CN of i
               hc_crit = 6
               if(param%group(at(i)).le.2) hc_crit = 4
               if(nnfi.gt.hc_crit) then
                       cycle
                endif
               hc_crit = 6
               if(param%group(at(j)).le.2) hc_crit = 4
               if(nnfj.gt.hc_crit) then
             cycle  
             endif
            endif
!           no metals and unusually coordinated stuff                                               
            if(icase.eq.3)then
               nnfi=sum(self%nbf(self%numnb,i,:))               ! full CN of i, only valid for icase > 1
               nnfj=sum(self%nbf(self%numnb,j,:))               ! full CN of i
               if(mchar(i).gt.0.25 .or. param%metal(at(i)).gt.0) cycle   ! metal case TMonly
               if(mchar(j).gt.0.25 .or. param%metal(at(j)).gt.0) cycle   ! metal case
               if(nnfi.gt.param%normcn(at(i)).and.at(i).gt.10)   cycle   ! HC case
               if(nnfj.gt.param%normcn(at(j)).and.at(j).gt.10)   cycle   ! HC case
            endif

            rco=rad(k)

            if(dist(j,i,iTr).lt. fm * f * rco) tag(j,i,iTr)=1
          enddo
        enddo
      enddo

      do iTr=1, self%numctr
      do i=1,n
         nn = 0
         do j=1,n
            if(tag(j,i,iTr).eq.1) then ! .AND.i.ne.j .OR. tag(j,i,iTr).eq.1.AND.iTr.ne.1)
               nn=nn+1
               if (icase.eq.1) self%nbf(nn,i,iTr)=j
               if (icase.eq.2) self%nb(nn,i,iTr) =j
               if (icase.eq.3) self%nbm(nn,i,iTr)=j
              ! if (iTr.eq.1) nb(nn,j,iTr)=i
            endif
         enddo
         if (icase.eq.1) self%nbf(self%numnb,i,iTr)=nn
         if (icase.eq.2) self%nb(self%numnb,i,iTr) =nn
         if (icase.eq.3) self%nbm(self%numnb,i,iTr)=nn
      enddo
      enddo

    end subroutine fillnb


    ! size(locarr, dim=2) is the number of cells that contain neighbors of indexi
    ! the other dim contains the indices of those neighbors 
    ! the LastEntry is the index (iTr) of the cell that the neighbors are in
    ! the SecondLastEntry is the number of neighbors indexi has in this cell
    subroutine nbLoc(self, n, nblist, indexi, locarr)
      class(TNeigh), intent(in) :: self
      integer, intent(in) :: n
      integer, intent(in) :: nblist(self%numnb, n, self%numctr)
      integer, intent(in) :: indexi
      integer, allocatable, intent(out) :: locarr(:,:)
      integer :: j,k,iTr,counter,counter2
      counter=0
      do iTr=1, self%numctr
       if (nblist(self%numnb,indexi,iTr).ne.0) counter = counter + 1
      enddo
      allocate(locarr(self%numnb, counter),source=0)
      ! find out which cells the neighbors are in  
      counter2=0
      do iTr=1, self%numctr
        if(nblist(self%numnb,indexi,iTr).eq.0) cycle
        counter=0           
        counter2=counter2+1
        do j=1, self%numnb-2                                  
          if(nblist(j, indexi, iTr).ne.0) then
            counter=counter+1
            locarr(counter,counter2) = nblist(j, indexi, iTr)
            locarr(self%numnb, counter2) = iTr                             ! LastEntry
            locarr(self%numnb-1, counter2) = nblist(self%numnb,indexi,iTr) ! SecondLastEntry
          endif
        enddo                                      
      enddo                                        

    endsubroutine nbLoc


    ! gives index j of the jth neighbor of i and the corresp transVec index iTr
    subroutine jth_nb(self, n, xyz, j, jth, i, iTr)
      class(TNeigh), intent(inout) :: self
      integer, intent(in) :: n
      real(wp), intent(in) :: xyz(3,n)
      integer, intent(inout) :: j, iTr
      integer, intent(in) :: jth, i
      integer ::  k, l, iTrdum, sizenb, sizeindx, jdum
      integer, allocatable :: indx(:)
      real(wp), allocatable :: distnb(:)

      sizenb = sum(self%nb(self%numnb,i,:))
      allocate(distnb(sizenb), source=0.0_wp)
      allocate(indx(sizenb), source=0)
      ! get distances from i to neighbors k in different cells iTr
      j=0
      iTr=0
      l=0
      do iTrdum=1, self%numctr
        do k=1, self%nb(self%numnb,i,iTrdum)
          jdum = self%nb(k,i,iTrdum)
          l=l+1
          distnb(l) = NORM2(xyz(:,i)-(xyz(:,jdum)+self%transVec(:,iTrDum)))
        enddo
      enddo

      ! get sorting index with heapSort from mctc_sort
      call indexHeapSort(indx, distnb)
      l=0
      do iTrdum=1, self%numctr
        do k=1, self%nb(self%numnb,i,iTrdum)
          jdum = self%nb(k,i,iTrdum)
          l=l+1
          if (l.eq.indx(jth)) then
            iTr = iTrdum
            j = jdum 
          endif
        enddo
      enddo

    end subroutine jth_nb


    function vecNorm(vector) result(vectorNorm)
      real(wp), intent(in) :: vector(3)
      real(wp) :: vectorNorm
      vectorNorm = sqrt(vector(1)**2+vector(2)**2+vector(3)**2)
    end function vecNorm


    subroutine filliTrSum(iTrDim,trVecInt,iTrSum,iTrNeg)
       !class(TNeigh), intent(inout) :: neigh                                     
       integer, intent(in) :: iTrDim
       integer, intent(in) :: trVecInt(3,iTrDim) 
       integer, allocatable, intent(out) :: iTrSum(:), iTrNeg(:)
       integer :: trVecInt2(3,iTrDim) 
       integer :: i,j,s,k,kk, lin
       integer :: vec1(3), vec2(3), vsum(3)                                      

       allocate(iTrSum(iTrDim*(iTrDim+1)/2),source=-1) 
       allocate(iTrNeg(iTrDim),source=-1)
       if (iTrDim.eq.1) then                                               
       else                                                                                
         !                               ! 
         do i=1, iTrDim                                                          
           kk=i*(i-1)/2                                                          
           do j=1, i                                                             
             k=kk+j ! packed index                                                   
             vec1 = trVecInt(:,i)   
             vec2 = trVecInt(:,j)                                                          
             vsum = vec1 + vec2
             do s=1, iTrDim 
               !                                                                           
               if (j.eq.1) then                                                          
                 if (vec1(1).eq.-trVecInt(1,s).AND.vec1(2).eq.-trVecInt(2,s)&              
                                      &       .AND.vec1(3).eq.-trVecInt(3,s)) then   
                   iTrNeg(i) = s                                                 
                   iTrNeg(s) = i   !this might be difficult for shared?
                 endif                                                           
               endif  

               if (vsum(1).eq.trVecInt(1,s).AND.vsum(2).eq.trVecInt(2,s)&                  
                                         & .AND.vsum(3).eq.trVecInt(3,s)) then
                 iTrSum(k) = s                                                   
               endif                                                                     
             enddo                                                               
           enddo                                                                 
         enddo                                                                   
       endif                                                                     
       iTrNeg(1)=1                                                         
       iTrSum(1)=1                                                         
                                                                             
    end subroutine filliTrSum            


    function fTrSum(self,indx1,indx2) result(indxSum)
      class(TNeigh) :: self
      integer :: indx1, indx2
      integer :: indxSum
      integer :: lin, id1, id2, k, idOfSum

      ! if fTrSum=-1 then the atom is shifted out of the cutoff used
      !  in the last neigh%getTransVec call
      indxSum=-1  ! default

      ! check if input is viable
      if(abs(indx1).gt.self%nTrans.or.abs(indx2).gt.self%nTrans) then
        return
      endif 
      ! change to unique index
      id1 = self%idTr(indx1)
      id2 = self%idTr(indx2)

      ! get entry from iTrSum and revert to input indx format
      k = lin(id1,id2)
      if(k.le.size(self%iTrSum)) then
        idOfSum = self%iTrSum(k)  ! unique id of sum
        ! only assign index if it can be handled by neigh%transVec
        ! else default of -1 is used, which is checked before use of %transVec
        if(idOfSum.gt.size(self%Trid)) return
        if(idOfSum.le.0) return
        if(self%Trid(idOfSum).gt.0.and.self%Trid(idOfSum).le.self%nTrans) then
          indxSum = self%Trid(idOfSum) 
        endif
      endif

    end function fTrSum

    subroutine filliTrUsed(neigh)
      class(TNeigh), intent(inout) :: neigh
      integer :: iTr,iTrF
      !
      allocate(neigh%iTrUsed(neigh%numctr))
      neigh%iTrUsed=.true.
      do iTr=neigh%numctr, 2, -1 ! iTr=1 is central cell (0,0,0) which should be used in any case
        if(neigh%iTrUsed(iTr)) then
          iTrF=neigh%iTrNeg(iTr)
          neigh%iTrUsed(iTrF)=.false.
        endif
      enddo

    end subroutine filliTrUsed


end module xtb_gfnff_neighbor

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_buffer
   implicit none
   public :: tb_buffer
   public :: len, size
   private


   type :: tb_buffer
      private
      integer :: error_code = 0
      integer :: length = 0
      integer :: pos = 0
      character(len=:), allocatable :: raw
      integer, allocatable :: table(:,:)
   contains
      generic :: allocate => new_default
      procedure, private :: new_default => buffer_new_default
      procedure :: get_error => buffer_get_error
      procedure :: push_back => buffer_push_back
      procedure :: reset => buffer_reset
      procedure :: next => buffer_next
      procedure :: getline => buffer_getline
      procedure :: resize => buffer_resize
      procedure :: deallocate => buffer_destroy
   end type tb_buffer


   interface len
      module procedure :: buffer_length
   end interface

   interface size
      module procedure :: buffer_size
   end interface


contains


subroutine buffer_new_default(self)
   class(tb_buffer), intent(out) :: self
end subroutine buffer_new_default


integer pure elemental function buffer_size(self)
   class(tb_buffer), intent(in) :: self
   if (allocated(self%table)) then
      buffer_size = size(self%table, 2)
   else
      buffer_size = 0
   endif
end function buffer_size

integer pure elemental function buffer_length(self)
   class(tb_buffer), intent(in) :: self
   if (allocated(self%table)) then
      buffer_length = self%length
   else
      buffer_length = 0
   endif
end function buffer_length

pure subroutine buffer_resize(self, n)
   class(tb_buffer), intent(inout) :: self
   integer, intent(in), optional :: n
   integer, allocatable :: table(:,:)
   integer :: length, current_length
   current_length = size(self)
   if (current_length > 0) then
      if (present(n)) then
         if (n <= current_length) return
         length = n
      else
         length = current_length + current_length/2 + 1
      endif
      allocate(table(2, length), source=0)
      table(:, :current_length) = self%table(:, :current_length)
      deallocate(self%table)
      call move_alloc(table, self%table)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(self%table(2, length), source=0)
   endif
end subroutine buffer_resize


subroutine buffer_push_back(self, string)
   class(tb_buffer), intent(inout) :: self
   character(len=*), intent(in) :: string
   integer :: pos, last, length

   pos = len(self%raw)
   length = len(string)
   last = len(self)
   if (last >= size(self)) call self%resize

   ! increment counter
   self%length = self%length+1
   ! save position of string in buffer
   self%table(:,last+1) = pos+[1,length]
   ! append string to buffer
   self%raw = self%raw // string
end subroutine buffer_push_back


subroutine buffer_reset(self)
   class(tb_buffer), intent(inout) :: self
   self%pos = 0
end subroutine buffer_reset

logical function buffer_next(self) result(next)
   class(tb_buffer), intent(inout) :: self
   next = self%pos < self%length
   if (next) self%pos = self%pos+1
end function buffer_next

subroutine buffer_getline(self, line)
   class(tb_buffer), intent(in) :: self
   character(len=:), allocatable, intent(out) :: line
   line = self%raw(self%table(1,self%pos):self%table(2,self%pos))
end subroutine buffer_getline


logical pure elemental function buffer_get_error(self) result(error)
   class(tb_buffer), intent(in) :: self
   error = self%error_code /= 0
end function buffer_get_error

subroutine buffer_destroy(self)
   class(tb_buffer), intent(inout) :: self
   if (allocated(self%raw)) deallocate(self%raw)
   if (allocated(self%table)) deallocate(self%table)
end subroutine buffer_destroy


end module xtb_type_buffer

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_bfgs
contains

subroutine bfgs(nat3,gnorm,grad,grado,dx,hess)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : blas_spmv, blas_dot
   !-------------------------------------------------------------------
   ! Purpose:
   ! Performs BFGS update of Hessian matrix
   !
   ! Input:
   ! nat3	= dimension parameter as declared in the calling routine
   ! grad	= actual gradient
   ! grado = gradient one cycle before
   ! dx    = displ = displacement = coords(k) - coord(k-1) ; k=cycle
   ! hess	= hessian matrix and in Output updated hessian
   !--------------------------------------------------------------------
   implicit none

   ! Input:
   integer, intent(in) :: nat3
   real(wp),intent(in) :: grad(nat3)
   real(wp),intent(in) :: grado(nat3)
   real(wp),intent(in) :: dx(nat3)
   real(wp),intent(in) :: gnorm
   ! Output:
   real(wp),intent(inout) :: hess(nat3*(nat3+1)/2)
   ! Local:
   integer  :: i,j,ij,ii
   real(wp),allocatable :: svec(:),tvec(:)
   real(wp) :: ddtd, dds, temp
   real(wp) :: ddot, thrs, scal, damp, dampO,dampD,thr
   real(wp) :: ooddtd, oodds, sdds, tddtd
   !---------------------------------------------------------------------
   allocate( svec(nat3),tvec(nat3), source = 0.0_wp )

   ! damping of H update
!  call hdamp(gnorm,dampO,dampD)

   thrs=1.d-12
   ! calculate dg = grad(k+1) - grad(k)
   svec(1:nat3) = grad(1:nat3) - grado(1:nat3)

   ! calculate tvec = h*dx
   call blas_spmv('u',nat3,1.0_wp,hess,dx,1,0.0_wp,tvec,1)

   ! calculate scalar dxdx and jtdx
   ddtd = blas_dot(nat3,tvec,1,dx,1)
   dds  = blas_dot(nat3,svec,1,dx,1)
   ooddtd = 1.0_wp / ddtd
   oodds  = 1.0_wp / dds

   if(dds > thrs .and. ddtd > thrs) then
   !$omp parallel default(none) &
   !$omp shared(nat3,oodds,ooddtd,svec,tvec) &
   !$omp private(i,j,ii,ij,sdds,tddtd,temp) &
   !$omp shared(hess)
   !$omp do
      do i=1,nat3
         ii = i*(i-1)/2
         sdds  = svec(i)*oodds
         tddtd = tvec(i)*ooddtd
         do j=1,i
            ij = ii + j
!           scal=dampd
!           if(i.ne.j)scal=dampo
            !temp= (svec(i)*svec(j))/dds - (tvec(i)*tvec(j))/ddtd
            temp = svec(j)*sdds - tvec(j)*tddtd
            hess(ij) = hess(ij) + temp
         end do
      end do
   !$omp end do
   !$omp end parallel
!  else
!     write(*,'(a)') ' ******* Hesse update not performed ******* '
!     write(*,*    ) dds,ddtd,thrs
   endif

   ! limit diagonal to (0.01 slightly better than 0.001)
   thr=1.d-2
   ij=0
   do i=1,nat3
      ij=ij+i
      if(abs(hess(ij)).lt.thr)hess(ij)=thr
   enddo

end subroutine bfgs

subroutine powell(nat3,gnorm,grad,grado,dx,hess)
   use xtb_mctc_accuracy, only : wp

   !-------------------------------------------------------------------
   ! Purpose:
   ! Performs Powell update of Hessian matrix
   !
   ! Input:
   ! nat3	= dimension parameter as declared in the calling routine=
   !         3*natoms
   ! grad	= actual gradient
   ! grado = gradient one cycle before
   ! dx    = displ = displacement = coords(k) - coord(k-1) ; k=cycle
   ! hess	= hessian matrix and in Output updated hessian
   !--------------------------------------------------------------------
   implicit none

   ! Input:
   integer, intent(in) :: nat3
   real(wp),intent(in) :: grad(nat3),grado(nat3),dx(nat3),gnorm
   ! Output:
   real(wp),intent(inout) :: hess(nat3*(nat3+1)/2)
   ! Local:
   integer :: i,j,ij
   real(wp) :: dds,ddtd,temp
   real(wp), dimension(nat3) :: tvec
   real(wp) :: ddot, thrs, scal, damp, dampO,dampD
   !---------------------------------------------------------------------

   ! damping of H update
!  call hdamp(gnorm,dampD,dampO)

   thrs=1.d-14

   call dspmv('u',nat3,1.0d0,hess,dx,1,0.0d0,tvec,1)

   tvec(1:nat3) = grad(1:nat3) - grado(1:nat3) - tvec(1:nat3)

   ! calculate scalar dxdx and jtdx
   dds  = ddot(nat3,dx,1,dx,1)

   if(dds > thrs) then
      ddtd = ddot(nat3,tvec,1,dx,1)/dds
      do i=1,nat3
         do j=1,i
            ij = i*(i-1)/2 + j
!           scal=dampD
!           if(i.ne.j)scal=dampo
            temp=tvec(i)*dx(j) + dx(i)*tvec(j) - dx(i)*ddtd*dx(j)
!           hess(ij) = hess(ij) + temp*scal/dds
            hess(ij) = hess(ij) + temp/dds
         end do
      end do
   else
!     write(*,'(a)') ' ******* Hesse update not performed ******* '
   endif

end subroutine powell

subroutine hdamp(gnorm,dampO,dampD)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp) gnorm,dampO,dampD
   dampD = 1.0
   dampO = 1.0
   return
   ! damping of H update
   if(gnorm > 0.5)then
      dampD = 1.0
      dampO = 0.0
   endif
   if(gnorm < 0.5 .and. gnorm > 0.2)then
      dampD = 1.0
      dampO = 0.2
   endif
   if(gnorm < 0.2 .and. gnorm > 0.05) then
      dampD = 1.0
      dampO = 0.5
   endif
end subroutine hdamp

end module xtb_bfgs

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_embedding
   use, intrinsic :: iso_fortran_env, only : output_unit
   use xtb_mctc_accuracy, only : wp
   use xtb_xtb_data, only : TCoulombData
   implicit none
!! ========================================================================
!  Embedding Stuff -- for QM/MM and subsystem-DFTB
!! ------------------------------------------------------------------------
!  in our tight binding model we can do much more than just point charge
!  embedding. Since we have a multipole electrostatic we can also use
!  these multipoles (dipole and quadrupoles). Also there is the dispersion
!  potential so we can embed the system in polarizibilities (coordination).
!  Given this fact the pcharges input will be more complicated
!  1> <npc>
!  2> <q> <x> <y> <z> [at [dx dy dz [qxx qyy qzz qxy qxz qxy [CN]]]]
!  ...
!  where q is the partial charge and x,y,z are it respective coordinates
!  at the moment the atom type is optional and by default nitrogen (7).
!! ------------------------------------------------------------------------
!  by this embedding scheme we can get in a subsystem-DFTB scheme
!  gradients for:
!  - monopole electrostatic
!  - anisotropic electrostatic
!  - dispersion
!  still missing is
!  - polynomial wavefunction terms
!  - repulsion terms
!  - shellwise electrostatic
!  - CN-shift of H0 (maybe via divide and conquere with P)
!  - nonadditive dispersion (ATM)
!  GBSA might need some special attention
!! ========================================================================

   integer,private,parameter :: p_str_length = 48
   integer,private,parameter :: p_arg_length = 24

contains

subroutine init_pcem
   use xtb_setparam
   implicit none
   select case(set%pcem_interface)
   case default
      if (.not.allocated(set%pcem_file)) set%pcem_file = "pcharge"
      if (.not.allocated(set%pcem_grad)) set%pcem_grad = "pcgrad"
   end select
end subroutine init_pcem

subroutine read_pcem(iunit,env,pcem,jData)
   use xtb_mctc_strings
   use xtb_mctc_convert
   use xtb_type_pcem
   use xtb_type_environment, only : TEnvironment
   use xtb_setparam
   use xtb_readin, only : getline => strip_line
   implicit none
   integer,      intent(in)    :: iunit
   type(TEnvironment), intent(inout) :: env
   type(tb_pcem),intent(inout) :: pcem
   type(TCoulombData), intent(in) :: jData

   integer  :: narg
   character(len=p_str_length),dimension(p_arg_length) :: argv
   character(len=:),allocatable :: line
   integer  :: err
   integer  :: npc,n
   integer  :: i,iat
   real(wp) :: xyz(3),q,gami
   real(wp) :: conv

   conv = 1.0_wp ! input is usually in *Bohr*
   if (set%pcem_orca) then
      conv = aatoau ! except when we try to read ORCA's pc-files
   endif

   ! file is not open and error was not catched from caller
   if (iunit.eq.-1) return

   ! reset file position
   rewind(iunit)

   ! load first line to buffer and attempt to parse
   call getline(iunit,line,err)
   read(line,*,iostat=err) npc
   if (err.ne.0) then
      return
   endif

   call pcem%allocate(npc)

   ! we now the number of lines that should follow, but we don't care
   ! -> read until EOF and count lines
   n = 0
   do

      ! load a new line into buffer
      ! exit if EOF occurs
      call getline(iunit,line,err)
      if (err.ne.0) exit

      ! we skip empty lines (might been commented out)
      if (len(line).eq.0) cycle

      ! try to parse the lines into argv, this has a hard limit on length and items
      ! let's assume a well-behaving user for now
      call parse(line,' ',argv,narg)

      ! user provided crap input, bad user
      if (narg.lt.4) then
         call raise('E',"Not enough entries for PC, please check!")
      endif

      ! we count this line
      n = n+1
      ! before we start parsing we check the number of lines
      if (n > npc) then ! bad user
         call raise('E',"Wrong dimension input for PC, too many lines provided")
      endif

      ! first position should be the partial charge
      read(argv(1),*,iostat=err) q
      ! get the position from the next three entries
      do i = 1, 3
         read(argv(i+1),*,iostat=err) xyz(i)
      enddo

      ! now our well-behaving user has three options:
      ! -> provide no fifth argument -> fallback to default from $pcem group
      ! -> provide a atom number     -> use gfn_method gam value (aoparam)
      ! -> provide a gam value       -> double check this one!!!
      if (narg.eq.5) then
         read(argv(5),*,iostat=err) gami
         if (err.ne.0) then
            call elem(argv(5),iat)
            if (iat.eq.0) then ! so much for the well-behaved user
               call raise('E',"Invalid PC input: '"//trim(argv(5))//"'")
            endif
            gami = jData%chemicalHardness(iat)
         endif
         ! GFN0-xTB has negative gam-values since they are internally combined
         ! with the atom radius for the full chemical hardness (overall > 0).
         ! This is certainly a problem here, but since GFN0-xTB does
         ! not provide the possibility to use a PC potential, we don't care...
         ! But if YOU are reading this comment and are in charge of implementing
         ! a PC potential for GFN0-xTB, than this is YOUR problem now.
         if (gami < 0.0_wp) then
            call raise('S',"Found negative gam-value in user input: '"//&
               &            trim(argv(5))//"'")
         endif
      else
         ! we trust the dummy atom from xcontrol, since xcontrol could already
         ! have handled potential errors, which is usually not the case...
         gami = jData%chemicalHardness(set%pcem_dummyatom)
      endif
      pcem%xyz(:,n) = xyz*conv
      pcem%q(n) = q
      pcem%gam(n) = gami
   enddo

   ! user screwed up, we could rescue this by resetting npc
   ! or we rub it in his/her face :)
   if (n /= npc) then
      call raise('E',"Wrong dimension input for PC, too few lines provided")
   endif

end subroutine read_pcem

!! ========================================================================
!  J potentials for GFN1 including the point charge stuff
!! ========================================================================
subroutine jpot_pcem_gfn1(jData,n,pcem,nshell,at,xyz,alphaj,Vpc)
   use xtb_type_pcem
   implicit none
   type(TCoulombData), intent(in) :: jData
   integer, intent(in)  :: n
   type(tb_pcem),intent(inout) :: pcem
   integer, intent(in)  :: nshell(:)
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(in)  :: alphaj
   real(wp),intent(inout) :: Vpc(:)
   integer  :: ish,ii,iat,ati,kk
   real(wp) :: eh1,dum,gi,gj,xj,rab

   ii = 0
   do iat = 1, n
      ati = at(iat)
      do ish = 1, nshell(ati)
         gi = jData%shellHardness(ish,ati)
         eh1 = 0.0_wp
         do kk = 1, pcem%n
            gj = pcem%gam(kk)
            rab = sqrt(sum((pcem%xyz(:,kk) - xyz(:,iat))**2))
            xj = 2.0_wp/(1./gi+1./gj)
            dum = 1.0_wp/(rab**alphaj+1._wp/xj**alphaj)**(1._wp/alphaj)
            eh1 = eh1+pcem%q(kk)*dum
         end do
         Vpc(ii+ish) = eh1
      end do
      ii = ii + nshell(ati)
   end do

end subroutine jpot_pcem_gfn1

!! ========================================================================
!  J potentials for GFN2 including the point charge stuff
!! ========================================================================
subroutine jpot_pcem_gfn2(jData,n,pcem,nshell,at,xyz,Vpc)
   use xtb_type_pcem
   implicit none
   type(TCoulombData), intent(in) :: jData
   integer, intent(in)  :: n
   type(tb_pcem),intent(in) :: pcem
   integer, intent(in)  :: nshell(:)
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(inout) :: Vpc(:)
   integer  :: ish,ii,iat,ati,kk
   real(wp) :: eh1,dum,gi,gj,xj,r2

   ii = 0
   do iat = 1, n
      ati = at(iat)
      do ish = 1, nshell(ati)
         gi = jData%shellHardness(ish,ati)
         eh1 = 0.0_wp
         do kk = 1, pcem%n
            gj = pcem%gam(kk)
            r2 = sum((pcem%xyz(:,kk) - xyz(:,iat))**2)
            xj = 0.5_wp*(gi+gj)
            dum = 1.0_wp/sqrt(r2+1._wp/xj**2)
            eh1 = eh1+pcem%q(kk)*dum
         enddo
         Vpc(ii+ish) = eh1
      enddo
      ii = ii + nshell(ati)
   enddo

end subroutine jpot_pcem_gfn2

!! ========================================================================
!  point charge embedding ES subroutine for SCC
!! ========================================================================
pure subroutine electro_pcem(nshell,dqsh,Vpc,es,scc)
   use xtb_mctc_convert, only : evtoau
   implicit none
   integer, intent(in)    :: nshell
   real(wp),intent(in)    :: Vpc(nshell),dqsh(nshell)
   real(wp),intent(out)   :: es
   real(wp),intent(inout) :: scc

   integer :: i,j

!  point charge contributions to ES
   es =0.0d0
   do i=1,nshell
      es =es + dqsh(i)*Vpc(i)
   enddo

!  Etotal
   scc = scc + es

end subroutine electro_pcem

!! ========================================================================
!  point charge embedding gradient for GFN1
!! ========================================================================
subroutine pcem_grad_gfn1(jData,g,gpc,n,pcem,at,nshell,xyz,alphaj,qsh)
   use xtb_type_pcem
   implicit none
   type(TCoulombData), intent(in) :: jData
   integer, intent(in) :: n
   type(tb_pcem),intent(in) :: pcem
   real(wp),intent(inout) :: g(3,n)
   real(wp),intent(inout) :: gpc(3,pcem%n)
   integer, intent(in) :: at(n)
   integer, intent(in) :: nshell(:)
   real(wp),intent(in) :: xyz(3,n)
   real(wp),intent(in) :: alphaj
   real(wp),intent(in) :: qsh(:)

   integer  :: ish,ii,j,iat,ati
   real(wp) :: dr(3)
   real(wp) :: gi,gj,r2,rr,yy,ff

   ii = 0
   do iat = 1, n
      ati = at(iat)
      do ish = 1, nshell(ati)
         gi = jData%shellHardness(ish,ati)
         do j = 1, pcem%n
            dr = xyz(:,iat) - pcem%xyz(:,j)
            r2 = sum(dr**2)
            gj = pcem%gam(j)
            rr = 2.0_wp/(1.0_wp/gi+1.0_wp/gj)
            rr = 1.0_wp/rr**alphaj
            ff = r2**(alphaj/2.0_wp-1.0_wp)*&
               &(r2**(alphaj*0.5_wp)+rr)**(-1.0_wp/alphaj-1.0_wp)
            yy = ff*qsh(ii+ish)*pcem%q(j)
            g(:,iat)=g(:,iat)-dr*yy
            gpc(:,j)=gpc(:,j)+dr*yy
         end do
      end do
      ii = ii + nshell(ati)
   end do

end subroutine pcem_grad_gfn1

!! ========================================================================
!  point charge embedding gradient for GFN2
!! ========================================================================
subroutine pcem_grad_gfn2(jData,g,gpc,n,pcem,at,nshell,xyz,qsh)
   use xtb_type_pcem
   implicit none
   type(TCoulombData), intent(in) :: jData
   integer, intent(in) :: n
   type(tb_pcem),intent(in) :: pcem
   real(wp),intent(inout) :: g(3,n)
   real(wp),intent(inout) :: gpc(3,pcem%n)
   integer, intent(in) :: at(n)
   integer, intent(in) :: nshell(:)
   real(wp),intent(in) :: xyz(3,n)
   real(wp),intent(in) :: qsh(:)

   integer  :: ish,ii,j,iat,ati
   real(wp) :: dr(3)
   real(wp) :: gi,gj,r2,rr,yy

   ii = 0
   do iat = 1, n
      ati = at(iat)
      do ish = 1, nshell(ati)
         gi = jData%shellHardness(ish,ati)
         do j = 1, pcem%n
            dr = xyz(:,iat) - pcem%xyz(:,j)
            r2 = sum(dr**2)
            gj = pcem%gam(j)
            rr = 0.5_wp*(gi+gj)
            rr = 1.0_wp/rr**2
            yy = qsh(ii+ish)*pcem%q(j)*(r2+rr)**(-1.5_wp)
            g(:,iat) = g(:,iat) - dr*yy
            gpc(:,j) = gpc(:,j) + dr*yy
         end do
      end do
      ii = ii + nshell(ati)
   end do

end subroutine pcem_grad_gfn2


end module xtb_embedding

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!in gfnff_ini:
!      integer, parameter :: maxsystem = 50
!      integer :: ispinsyst  (10*n,maxsystem)
!      integer :: nspinsyst  (maxsystem)
!      integer :: nsystem
!      call fragmentize(n,at,xyz,maxsystem, 400, rab, nb, ispinsyst, nspinsyst, nsystem)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module xtb_gfnff_fraghess
!$ use omp_lib
   use xtb_gfnff_mrec, only : mrecgff
   implicit none

   interface
     function shortest_distance(nspin, start, goal, neighbours, input_distances, visited, precessor)
        use xtb_mctc_accuracy, only : wp
        implicit none
        real(wp)             :: shortest_distance
        integer, intent(in)  :: nspin
        integer, intent(in)  :: start
        integer, intent(in)  :: goal
        integer, intent(in)  :: neighbours(20, nspin)
        real(wp), intent(in) :: input_distances(nspin, nspin)
        logical, intent(out) :: visited(nspin)
        integer, intent(out) :: precessor(nspin)
        integer  :: current
        integer  :: neighbour
        integer  :: i_neighbours
        integer  :: bonds
        real(wp) :: alt_dist
        real(wp) :: distance(nspin)
      end function shortest_distance
      subroutine eigsort4(lab,ew,u)
         use xtb_mctc_accuracy, only : sp
         implicit none
         integer  :: ii,k, j, i
         real(sp) :: pp, hilf
         integer  :: lab
         real(sp) :: ew(lab)
         real(sp) :: u(lab,lab)
      end subroutine eigsort4
    end interface

   contains

     subroutine fragmentize(nspin, at, xyz, maxsystem, maxmagnat, jab, neigh, ispinsyst, nspinsyst, nsystem, env)
        use xtb_mctc_accuracy, only : wp, sp
        use xtb_type_environment, only: TEnvironment
        implicit none

        !Dummy Arguments:
        integer,  intent(in)  :: nspin                              ! # of atoms in the whole system
        integer,  intent(in)  :: maxsystem                          ! maximum # of fragments
        integer,  intent(in)  :: maxmagnat                          ! maximum # of atoms per fragment
        integer,  intent(in)  :: neigh(20, nspin)                   ! neighbour list
        integer,  intent(in)  :: at(nspin)                          ! atom nunber
        real(wp), intent(in)  :: xyz(3,nspin)                       ! xyz coordinates
        real(wp), intent(in)  :: jab(nspin*(nspin + 1)/2)           ! distances between pairs A and B
        integer, allocatable, intent(out) :: ispinsyst(:,:)         ! array with list of atoms of each fragment
        integer, allocatable, intent(out) :: nspinsyst(:)           ! array with # of atoms for each fragment
        integer,  intent(out) :: nsystem                            ! # of fragments
        real(sp)  :: rmaxab(nspin, nspin)

        !Stack
        integer  :: i, ati
        integer  :: current
        integer  :: ass
        integer  :: k
        integer  :: j, atj
        integer  :: lin
        integer  :: fragcount
        integer  :: nfrag_ini
        integer  :: nci_ini
        integer  :: eq_frag
        integer  :: maxdistatoms(2)
        integer  :: max_linkatoms(2)
        integer  :: assigned_to_frag(nspin)
        integer  :: precessor(nspin)
        integer  :: path(nspin)
        integer  :: fragvec(nspin)
        integer  :: nbox
        integer  :: nci_frag_size
        real(wp) :: grid(3,maxsystem)
        real(wp) :: magdist(nspin, nspin)
        real(wp) :: shortest_distance
        real(wp) :: maxdist
        real(wp) :: cur_dist
        real(wp) :: max_link
        real(wp) :: box_xyz(3), vec(3)
        real(wp) :: frag_cma(3,maxsystem)
        logical  :: equal(maxsystem)
        logical  :: visited(nspin)
        logical  :: assigned(nspin, nspin)

        integer, allocatable  :: ifrag_ini(:)

        type(TEnvironment), intent(inout) :: env

        allocate( ispinsyst(nspin,maxsystem), source = 0)
        allocate( nspinsyst(maxsystem), source = 0)

        if (nspin.lt.500) then
           nsystem = 1
           return
        end if

!       open (55, file="fragment.out")

        nci_frag_size = 50
        fragcount = 0
        fragvec = 0
        eq_frag = 0
        frag_cma = 0
        grid = 0
        equal = .false.

        call mrecgff(nspin, neigh, fragcount, fragvec)

        nsystem = maxval(fragvec)

        !Use NCI-Fragmentation from mrec:
        do i = 1, nspin
           nspinsyst(fragvec(i)) = nspinsyst(fragvec(i)) + 1
           ispinsyst(nspinsyst(fragvec(i)), fragvec(i)) = i
        end do ! End Loop over  i from 1 to nspin

        !Calculate COM for each NCI fragment
        do i = 1, nsystem
           nfrag_ini = nspinsyst(i)
           if (nfrag_ini.lt.nci_frag_size) then
             allocate (ifrag_ini(nfrag_ini), source = 0)
             ifrag_ini = ispinsyst(1:nfrag_ini,i)
             call com(nfrag_ini,at(ifrag_ini),xyz(:,ifrag_ini),frag_cma(:,i))
             deallocate (ifrag_ini)
           end if
        end do

        !Determine box size
        do i = 1, 3
           box_xyz(i) = maxval(frag_cma(i,:)) - minval(frag_cma(i,:))
        end do

        !Determine number of sub boxes
        nbox =  ceiling((real(nspin)/real(maxmagnat))**(1.0d0/3.0d0))

        !Determine position of nci frag on grid
        do i = 1, nsystem
           nfrag_ini = nspinsyst(i)
           if (nfrag_ini.lt.nci_frag_size) then
             do j = 1, 3
                grid(j,i) =   nbox * ( frag_cma(j,i) - minval(frag_cma(j,:)) ) / box_xyz(j)
                if (grid(j,i).eq.0) grid(j,i) = grid(j,i) + 1.0d0
                grid(j,i) = ceiling( grid(j,i) )
             end do
           end if
        end do

        !Sum over all nci fragments on same grid position
        nci_ini=nsystem
        do i = 1, nci_ini !nsystem
           eq_frag=0
           !nfrag_ini=nspinsyst(i)
           do j = i+1, nci_ini
              nfrag_ini=nspinsyst(j)
              vec(:) = grid(:,i)-grid(:,j)
              if (norm2(grid(:,i)).ne.0.and.norm2(vec).eq.0.and..not.equal(j)) then
                eq_frag = eq_frag + 1
                do k = 1, nfrag_ini
                   ispinsyst(nspinsyst(i)+k,i) = ispinsyst(k,j)
                end do
                nspinsyst(i) = nspinsyst(i) + nspinsyst(j)
                equal(j) = .true.
              end if
           end do
           nsystem = nsystem - eq_frag
        end do

        !overwrite ispinsyst/nspinsyst
        do i = 1, nsystem
           do j = 1, nci_ini
           if (.not.equal(j)) then
             nspinsyst(i) = nspinsyst(j)
             ispinsyst(:,i) = ispinsyst(:,j)
             equal(j) = .true.
             exit
           end if
           end do
        end do

        nspinsyst(nsystem+1:maxsystem) = 0
        ispinsyst(:,nsystem+1:maxsystem) = 0

        do i = 1, nsystem !loop über separierte systeme
           do j = 1, nspinsyst(i) !loop über atom1 im system
              do k = j, nspinsyst(i)
                 ati = ispinsyst(j, i)
                 atj = ispinsyst(k, i)
                 rmaxab(atj, ati) = jab(lin(atj, ati))/1.2
                 rmaxab(ati, atj) = rmaxab(atj, ati)
              end do
           end do
        end do

        magdist = rmaxab

        !Find Sub-Systems with nspinsyst > maxmagnat
        ass = maxloc(nspinsyst, 1)
        do while (nspinsyst(ass) > maxmagnat)

           !Set Spins in this list as available for algorithm
           assigned = .false.
           do i = 1, nspinsyst(ass)
              do j = 1, nspinsyst(ass)
                 assigned(ispinsyst(i, ass), ispinsyst(j, ass)) = .true.
              end do ! End Loop over  j from 1 to nspinsyst(ass)
           end do ! End Loop over  i from 1 to nspin


           !Find largest distance:
           maxdist = maxval(rmaxab, mask=assigned)
           maxdistatoms = maxloc(rmaxab, mask=assigned)
           !        write( *, * ) "maxdistatoms", maxdistatoms

           !If a Path is found between A and B
           if (maxdist < huge(1.0_wp)) then

              !get shortest Path from A to B
              cur_dist = shortest_distance(nspin, maxdistatoms(1), maxdistatoms(2), neigh, magdist, visited, precessor)
              current = maxdistatoms(2)

              !loop while A and B are still connected
              do while (cur_dist < huge(1.0_wp))

                 !find weakest link
                 max_link = 0
                 max_linkatoms = 0
                 i = 1
                 path = 0

                 do while (precessor(current) /= 0)
                    path(i) = current
                    current = precessor(current)
                    i = i + 1
                 end do ! End loop: while precessor(current) /= 0
                 path(i) = maxdistatoms(1)
                 i = i + 1
                 max_linkatoms(1) = path(i/2)
                 max_linkatoms(2) = path((i/2) + 1)

                 !Split weakest link, set distance to infinity
                 magdist(max_linkatoms(1), max_linkatoms(2)) = huge(1.0_wp)
                 magdist(max_linkatoms(2), max_linkatoms(1)) = huge(1.0_wp)

                 !Get next-shortest Path:
                 cur_dist = shortest_distance(nspin, maxdistatoms(1), maxdistatoms(2), neigh, magdist, visited, precessor)
                 current = maxdistatoms(2)
              end do ! cur_dist < huge(1.0_wp)

              !A and B are now Seperated:
              rmaxab(maxdistatoms(1), maxdistatoms(2)) = huge(1.0_sp)
              rmaxab(maxdistatoms(2), maxdistatoms(1)) = huge(1.0_sp)
           end if ! End if: while maxdist < huge(1.0d0)

           !Split into subsystems:
           !Overwrite old spinsystem:

           cur_dist = shortest_distance(nspin, maxdistatoms(1), maxdistatoms(2), neigh, magdist, visited, precessor)
           nspinsyst(ass) = count(visited)
           ispinsyst(:, ass) = 0
           k = 1
           do i = 1, nspin
              if (visited(i)) then
                 ispinsyst(k, ass) = i
                 k = k + 1
              end if
           end do ! End Loop over  i from 1 to count(visited)

           !add new spinsystem
           cur_dist = shortest_distance(nspin, maxdistatoms(2), maxdistatoms(1), neigh, magdist, visited, precessor)
           nsystem = nsystem + 1
           nspinsyst(nsystem) = count(visited)
           k = 1
           do i = 1, nspin
              if (visited(i)) then
                 ispinsyst(k, nsystem) = i
                 k = k + 1
              end if
           end do ! End Loop over  i from 1 to count(visited)
           ass = maxloc(nspinsyst, 1)

            if (nsystem .ge. nspin) then
               call env%warning("Created more fragments than atoms. This does not look good. Turning off fragmentation.")
               nsystem=1
               return
            end if
        end do ! End loop: while nspinsyst(ass) > maxmagnat


!        write fragment.out file for visualization
!        do i = 1, nsystem !loop über separierte systeme
!           write (55, *) "System ", i, "mit atomen", nspinsyst(i)
!           do j = 1, nspinsyst(i)
!              write (55, *) ispinsyst(j, i)
!           end do
!        end do
!        close (55)

     end subroutine fragmentize

     subroutine frag_hess_diag( nat,hess,eig_calc,ispinsyst,nspinsyst,nsystem )
     !---------------------------------------------------------------------------------------------
     ! Purpose:
     ! Subroutine performs diagonalization of fragmented hessian.
     ! fragmentize must be called beforehand, fragments are available via this module.
     !
     ! How does it work?
     ! This subroutine uses masked arrays: an array (hess_mask) consists only of logicals and has
     ! the same size as the hessian matrix of the entire system. For all entries of the hessian
     ! matrix that belong to one fragment, the corresponding position in the masked array is set
     ! true. Using the intrinsic "pack and unpack" functions in combination with mask, the hessian
     ! entries for only one fragment are written into a smaller array (mini_hess) which is faster
     ! diagonalized due to the reduzed size (# of atoms in fragment < # of atoms in the entire system).
     !
     ! Input:
     ! nat      - Number of atoms of the entire system
     ! hess     - (Lindh) Hessian of the entire system
     !
     ! Output:
     ! hess     - diagonalized hessian (eigenvectors), overwritten
     ! eig_calc - diagonalized hessian (eigenvalues)
     !---------------------------------------------------------------------------------------------
     use xtb_mctc_accuracy, only : wp, sp
        implicit none
        !Dummy Arguments
        integer,  intent(in)     :: nat                          ! # of atoms
        real(sp), intent(inout)  :: hess(3*nat,3*nat)            ! input hessian
        real(sp), intent(out)    :: eig_calc(3*nat)              ! eigenvectors od entire system
        integer,  intent(in) :: ispinsyst(:,:)         ! array with list of atoms of each fragment
        integer,  intent(in) :: nspinsyst(:)           ! array with # of atoms for each fragment
        integer,  intent(in) :: nsystem                            ! # of fragments
        !Stack
        integer                  :: isystem
        integer                  :: i,j,ii,jj,k
        integer                  :: nat3                         ! # of atoms in the system * 3
        integer                  :: nat_cur                      ! # of atoms in fragment
        integer                  :: nat3_cur                     ! nat in fragments * 3
        integer                  :: info                         ! for ssyev
        integer                  :: lwork                        ! for ssyev
        logical                  :: hess_mask(3*nat,3*nat)       ! masked hessian array
        real(sp)                 :: ev_calc(3*nat,3*nat)         ! eigenvectors of entire system
        real(sp), allocatable    :: mini_hess(:,:)               ! eigenvectors of fragment
        real(sp), allocatable    :: eig(:)                       ! eigenvalues of fragment
        real(sp), allocatable    :: aux(:)                       ! for ssyev


        ev_calc  = 0.0e0_sp
        eig_calc = 0.0e0_sp
        nat3     = 3 * nat

!$omp parallel default(none) &
!$omp private(isystem,i,ii,j,jj,nat_cur,nat3_cur,mini_hess,hess_mask,eig,lwork,aux,info) &
!$omp shared(nsystem,ev_calc,eig_calc,hess,nspinsyst,ispinsyst)
!!$omp do schedule(static)
!$omp do reduction(+:ev_calc,eig_calc)
        do isystem = 1 , nsystem
           hess_mask = .false.
           do i = 1,nspinsyst(isystem)
              do j = 1,i

                 nat_cur =  nspinsyst(isystem)
                 nat3_cur = 3 * nat_cur
                 ii = 3*ispinsyst(i,isystem)
                 jj = 3*ispinsyst(j,isystem)
                 hess_mask(ii-2:ii,jj-2:jj) = .true.
                 hess_mask(jj-2:jj,ii-2:ii) = .true.

               end do
           end do

           allocate( mini_hess(nat3_cur,nat3_cur), source = 0.0e0_sp )
           allocate( eig(nat3_cur), source = 0.0e0_sp )

           mini_hess = reshape( pack( hess, mask = hess_mask ), shape( mini_hess ) )
           lwork = 1 + 6*nat3_cur + 2*nat3_cur**2
           allocate(aux(lwork))
           call ssyev ('V','U',nat3_cur,mini_hess,nat3_cur,eig,aux,lwork,info)
           deallocate(aux)
!!$omp critical
           ev_calc  = unpack( reshape( mini_hess, [ nat3_cur*nat3_cur ]  ), mask = hess_mask, field = ev_calc )
           eig_calc = unpack( eig, mask = any(hess_mask,1), field = eig_calc )
!!$omp end critical

           deallocate( mini_hess,eig )

        end do
!$omp end do
!$omp end parallel

        do i = 1,nat3
           ev_calc(:,i) = ev_calc(:,i) - ( sum( ev_calc(:,i) ) / nat3 )
        end do

        hess = ev_calc

        call eigsort4(nat3,hess,eig_calc)

     end subroutine frag_hess_diag

end module xtb_gfnff_fraghess

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!calculates the shortest path between two atoms
!start and goal are integers, determining the index in xyz
!https://de.wikipedia.org/wiki/Dijkstra-Algorithmus
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
function shortest_distance(nspin, start, goal, neighbours, input_distances, visited, precessor)
   use xtb_mctc_accuracy, only : wp, sp
   implicit none
   !Dummy Arguments:
   real(wp)             :: shortest_distance
   integer, intent(in)  :: nspin
   integer, intent(in)  :: start
   integer, intent(in)  :: goal
   integer, intent(in)  :: neighbours(20, nspin)
   real(wp), intent(in) :: input_distances(nspin, nspin)
   logical, intent(out) :: visited(nspin)
   integer, intent(out) :: precessor(nspin)

   !Stack:
   integer  :: current
   integer  :: neighbour
   integer  :: i_neighbours
   integer  :: bonds
   real(wp) :: alt_dist
   real(wp) :: distance(nspin)

   !logical:: visited(nspin)

   bonds = 0
   precessor = 0
   distance = huge(distance)
   distance(start) = 0
   visited = .false.
   do while (.not.all(visited)) !as long there are unvisited nodes
      current = minloc(distance, 1,.not. visited)

      !Abort if Fragments are not connected:
      if (distance(current) == huge(distance)) then
         shortest_distance = huge(distance)
         return
      end if ! distance(current) == huge(distance)

      visited(current) = .true.
      if (current == goal) then
         shortest_distance = distance(goal)
         !route to target found
         do while (precessor(current) /= 0)
            bonds = bonds + 1
            current = precessor(current)
         end do ! End loop: while precessor(current) /= 0
         exit
      else
         !loop over all neighbours of current atom
         do i_neighbours = 1, neighbours(20, current)
            neighbour = neighbours(i_neighbours, current)
            if (.not.visited(neighbour)) then
               !distanzupdate
               alt_dist = distance(current) + input_distances(current, neighbour)
               !write( *, * ) alt_dist, distance(current),
               if ((alt_dist < distance(neighbour))) then
                  distance(neighbour) = alt_dist
                  precessor(neighbour) = current
               end if ! (alt_dist < distance(neighbour))
            endif !(visited(neighbour))
         end do ! End Loop over  i_neighbours from 1 to all_Atoms(current)%n_neighbours
      endif
   end do ! End loop: while sum(visited) /= 0
   !initialize
   shortest_distance = distance(goal)
end function shortest_distance


subroutine eigsort4(lab,u,ew)
   use xtb_mctc_accuracy, only : wp, sp
   implicit none
   integer  :: ii,k, j, i
   real(sp) :: pp, hilf

   integer, intent(in)    :: lab
   real(sp), intent(inout) :: ew(lab)
   real(sp), intent(inout) :: u(lab,lab)

   do ii = 2, lab
      i = ii - 1
      k = i
      pp= ew(i)
      do j = ii, lab
         if (ew(j) .gt. pp) cycle
         k = j
         pp= ew(j)
      end do
      if (k .eq. i) cycle
      ew(k) = ew(i)
      ew(i) = pp
      do j=1,lab
         hilf=u(j,i)
         u(j,i)=u(j,k)
         u(j,k)=hilf
      end do
   end do

end subroutine eigsort4

pure subroutine com(n,at,xyz,sum3)
   use xtb_mctc_accuracy, only : wp
   implicit none
   !Dummy
   integer, intent(in)   :: n
   integer, intent(in)   :: at(n)
   real(wp), intent(in)  :: xyz(3,n)
   real(wp), intent(out) :: sum3(3)
   !Stack
   integer               :: i
   real(wp)              :: sumw
   real(wp)              :: sumwx,sumwy,sumwz

   sumw=0
   sumwx=0.d0
   sumwy=0.d0
   sumwz=0.d0

   do i = 1, n
      sumw = sumw + 1
      sumwx = sumwx + xyz(1,i)
      sumwy = sumwy + xyz(2,i)
      sumwz = sumwz + xyz(3,i)
   end do

   sum3(1) = sumwx / sumw
   sum3(2) = sumwy / sumw
   sum3(3) = sumwz / sumw

end subroutine com

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of Ewald summation specific tasks.
!
!  Part of this code originates from the DFTB+ codebase.
module xtb_coulomb_ewald
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: ewaldMatPBC3D, ewaldDerivPBC3D, ewaldDerivPBC3D_alp
   public :: getOptimalAlpha, getMaxG, getMaxR


   !> Nr. of max. bisection steps
   integer, parameter :: nSearchIter = 30

   abstract interface
   !> Returns the max. value of a term in the reciprocal space part of the Ewald
   !  summation for a given vector length.
   pure function getGTermGen(gg, alpha, vol) result(gTerm)
      import :: wp

      !> Length of the reciprocal space vector
      real(wp), intent(in) :: gg

      !> Parameter of the Ewald summation
      real(wp), intent(in) :: alpha

      !> Volume of the real space unit cell
      real(wp), intent(in) :: vol

      !> Reciprocal term
      real(wp) :: gTerm

   end function getGTermGen
   end interface

contains


pure function ewaldMatPBC3D(vec, gTrans, qpc, volume, alpha, scale) result(Amat)

   !> Distance from i to WSC atom
   real(wp), intent(in) :: vec(:)

   !> Reciprocal lattice
   real(wp), intent(in) :: gTrans(:, :)

   !> Pseudo-quadrupole charge
   real(wp), intent(in) :: qpc

   !> Direct cell volume
   real(wp), intent(in) :: volume

   !> Convergence factor
   real(wp), intent(in) :: alpha

   !> Additional scaling factor
   real(wp), intent(in) :: scale

   !> Element of interaction matrix
   real(wp) :: Amat

   integer :: iG
   real(wp) :: rik2, rik(3), expterm

   Amat = 0.0_wp
   do iG = 1, size(gTrans, dim=2)
      rik(:) = gTrans(:, iG)
      rik2 = dot_product(rik, rik)
      expterm = exp(-rik2/(4.0_wp*alpha**2))/rik2
      Amat = Amat + cos(dot_product(rik, vec)) * expterm * (1.0_wp + 2*rik2*qpc**2)
   end do
   Amat = Amat * 4.0_wp*pi/volume * scale

end function ewaldMatPBC3D


pure subroutine ewaldDerivPBC3D_alp(vec, gTrans, qpc, volume, alpha, scale, &
      & dAmat, sigma)

   !> Distance from i to WSC atom
   real(wp),intent(in) :: vec(:)

   !> Reciprocal lattice
   real(wp),intent(in) :: gTrans(:, :)

   !> Pseudo-quadrupole charge
   real(wp), intent(in) :: qpc

   !> Direct cell volume
   real(wp),intent(in) :: volume

   !> Convergence factor
   real(wp),intent(in) :: alpha

   !> Additional scaling factor
   real(wp), intent(in) :: scale

   !> Derivative of interaction matrix
   real(wp),intent(out) :: dAmat(:)

   !> Strain of interaction matrix
   real(wp),intent(out) :: sigma(:, :)

   integer  :: iG
   real(wp) :: rik2, rik(3), dtmp, expterm, arg
   real(wp) :: fqpc, falp, dS(3, 3)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   dAmat = 0.0_wp
   sigma = 0.0_wp
   fqpc = 2*qpc**2
   falp = 2.0_wp/3.0_wp/(4.0_wp*alpha**2)
   do iG = 1, size(gTrans, dim=2)
      rik = gTrans(:, iG)
      rik2 = dot_product(rik,rik)
      expterm = exp(-rik2/(4.0_wp*alpha**2))/rik2
      arg = dot_product(rik,vec)
      dtmp = -sin(arg) * expterm
      dAmat = dAmat + rik*dtmp
      dS = spread(rik,1,3)*spread(rik,2,3)
      sigma = sigma + expterm * cos(arg) * ( &
         & - unity * (1.0_wp + rik2*falp + rik2*fqpc) &
         & + (2.0_wp/rik2 + 0.5_wp/alpha**2 + 0.5_wp*fqpc) * dS)
   end do
   dAmat = dAmat * 4.0_wp*pi/volume * scale
   sigma = sigma * 4.0_wp*pi/volume * scale

end subroutine ewaldDerivPBC3D_alp


pure subroutine ewaldDerivPBC3D(vec, gTrans, qpc, volume, alpha, scale, &
      & dAmat, sigma)

   !> Distance from i to WSC atom
   real(wp),intent(in) :: vec(:)

   !> Reciprocal lattice
   real(wp),intent(in) :: gTrans(:, :)

   !> Pseudo-quadrupole charge
   real(wp), intent(in) :: qpc

   !> Direct cell volume
   real(wp),intent(in) :: volume

   !> Convergence factor
   real(wp),intent(in) :: alpha

   !> Additional scaling factor
   real(wp), intent(in) :: scale

   !> Derivative of interaction matrix
   real(wp),intent(out) :: dAmat(:)

   !> Strain of interaction matrix
   real(wp),intent(out) :: sigma(:, :)

   integer  :: iG
   real(wp) :: rik2, rik(3), dtmp, expterm, arg
   real(wp) :: fqpc, dS(3, 3)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   dAmat = 0.0_wp
   sigma = 0.0_wp
   fqpc = 2*qpc**2
   do iG = 1, size(gTrans, dim=2)
      rik = gTrans(:, iG)
      rik2 = dot_product(rik,rik)
      expterm = exp(-rik2/(4.0_wp*alpha**2))/rik2
      arg = dot_product(rik,vec)
      dtmp = -sin(arg) * expterm
      dAmat = dAmat + rik*dtmp
      dS = spread(rik,1,3)*spread(rik,2,3)
      sigma = sigma + 0.5_wp * expterm * cos(arg) * ( &
         & - unity * (1.0_wp + rik2*fqpc) &
         & + (2.0_wp/rik2 + 0.5_wp/alpha**2 + 0.5_wp*fqpc) * dS)
   end do
   dAmat = dAmat * 4.0_wp*pi/volume * scale
   sigma = sigma * 4.0_wp*pi/volume * scale

end subroutine ewaldDerivPBC3D


!> Get optimal alpha-parameter for the Ewald summation by finding alpha, where
!  decline of real and reciprocal part of Ewald are equal.
subroutine getOptimalAlpha(env, latVec, recVec, volume, tolerance, alpha)

   !> Source of the generated error
   character(len=*), parameter :: source = 'coulomb_ewald_getOptimalAlpha'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Lattice vectors
   real(wp), intent(in) :: latVec(:,:)

   !> Reciprocal vectors
   real(wp), intent(in) :: recVec(:,:)

   !> Volume of the unit cell
   real(wp), intent(in) :: volume

   !> Tolerance for difference in real and rec. part
   real(wp), intent(in) :: tolerance

   !> Optimal alpha
   real(wp) :: alpha

   real(wp) :: alphaLeft, alphaRight
   real(wp), parameter :: alphaInit = 1.0e-8_wp

   real(wp) :: minG, minR, diff
   integer :: iIter
   integer :: iError
   character(len=100) :: errorString

   minG = sqrt(minval(sum(recVec(:,:)**2, dim=1)))
   minR = sqrt(minval(sum(latVec(:,:)**2, dim=1)))

   iError = 0
   alpha = alphaInit
   diff = diffRecReal(alpha, getGTermPBC3D, minG, minR, volume)
   do while (diff < -tolerance .and. alpha <= huge(1.0_wp))
      alpha = 2.0_wp * alpha
      diff = diffRecReal(alpha, getGTermPBC3D, minG, minR, volume)
   end do
   if (alpha > huge(1.0_wp)) then
      iError = 1
   elseif (alpha == alphaInit) then
      iError = 2
   end if

   if (iError == 0) then
      alphaLeft = 0.5_wp * alpha
      do while (diff < tolerance .and. alpha <= huge(1.0_wp))
         alpha = 2.0_wp * alpha
         diff = diffRecReal(alpha, getGTermPBC3D, minG, minR, volume)
      end do
      if (alpha > huge(1.0_wp)) then
         iError = 3
      end if
   end if

   if (iError == 0) then
      alphaRight = alpha
      alpha = (alphaLeft + alphaRight) / 2.0
      iIter = 0
      diff = diffRecReal(alpha, getGTermPBC3D, minG, minR, volume)
      do while (abs(diff) > tolerance .and. iIter <= nSearchIter)
         if (diff < 0) then
            alphaLeft = alpha
         else
            alphaRight = alpha
         end if
         alpha = (alphaLeft + alphaRight) / 2.0
         diff = diffRecReal(alpha, getGTermPBC3D, minG, minR, volume)
         iIter = iIter + 1
      end do
      if (iIter > nSearchIter) then
         iError = 4
      end if
   end if

   if (iError /= 0) then
      !alpha = exp(-0.310104 * log(volume) + 0.786382) / 2.0
      call env%error('Failed to determine the optimal alpha for Ewald sum', source)
   end if

end subroutine getOptimalAlpha


!> Returns the longest reciprocal vector which gives a bigger contribution to
!  the Ewald sum than a certain tolerance.
subroutine getMaxG(env, alpha, volume, minValue, maxG)

   !> Source of the generated error
   character(len=*), parameter :: source = 'coulomb_ewald_getMaxG'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Parameter of the ewald summation
   real(wp), intent(in) :: alpha

   !> Volume of the unit cell
   real(wp), intent(in) :: volume

   !> Tolerance value
   real(wp), intent(in) :: minValue

   !> Magnitude of reciprocal vector
   real(wp) :: maxG

   real(wp), parameter :: gInit = 1.0e-8_wp
   real(wp) :: xLeft, xRight, yLeft, yRight, yy
   integer :: iError, iIter
   character(len=100) :: errorString

   iError = 0
   maxG = gInit
   yy = getGTermPBC3D(maxG, alpha, volume)
   do while (yy > minValue .and. maxG <= huge(1.0_wp))
      maxG = 2.0_wp * maxG
      yy = getGTermPBC3D(maxG, alpha, volume)
   end do
   if (maxG > huge(1.0_wp)) then
      iError = 1
   elseif (maxG == gInit) then
      iError = 2
   end if

   if (iError == 0) then
      xLeft = 0.5_wp * maxG
      yLeft = getGTermPBC3D(xLeft, alpha, volume)
      xRight = maxG
      yRight = yy

      iIter = 1
      do while (yLeft - yRight > minValue .and. iIter <= nSearchIter)
         maxG = 0.5_wp * (xLeft + xRight)
         yy = getGTermPBC3D(maxG, alpha, volume)
         if (yy >= minValue) then
            xLeft = maxG
            yLeft = yy
         else
            xRight = maxG
            yRight = yy
         end if
         iIter = iIter + 1
      end do
      if (iIter > nSearchIter) then
         iError = 3
      end if
   end if

   if (iError /= 0) then
      call env%error('Failed to determine max. reciprocal lattice vector', source)
   end if

end subroutine getMaxG


!> Returns the longest real space vector which gives a bigger contribution to
!  the Ewald sum than a certain tolerance.
subroutine getMaxR(env, alpha, minValue, maxR)

   !> Source of the generated error
   character(len=*), parameter :: source = 'coulomb_ewald_getMaxR'

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Parameter of the ewald summation
   real(wp), intent(in) :: alpha

   !> Tolerance value
   real(wp), intent(in) :: minValue

   !> Magnitude of real space vector
   real(wp) :: maxR

   real(wp), parameter :: rInit = 1.0e-8_wp
   real(wp) :: xLeft, xRight, yLeft, yRight, yy
   integer :: iError, iIter
   character(len=100) :: errorString

   iError = 0
   maxR = rInit
   yy = getRTerm(maxR, alpha)
   do while (yy > minValue .and. maxR <= huge(1.0_wp))
      maxR = 2.0_wp * maxR
      yy = getRTerm(maxR, alpha)
   end do
   if (maxR > huge(1.0_wp)) then
      iError = 1
   elseif (maxR == rInit) then
      iError = 2
   end if

   if (iError == 0) then
      xLeft = 0.5_wp * maxR
      yLeft = getRTerm(xLeft, alpha)
      xRight = maxR
      yRight = yy

      iIter = 1
      do while (yLeft - yRight > minValue .and. iIter <= nSearchIter)
         maxR = 0.5_wp * (xLeft + xRight)
         yy = getRTerm(maxR, alpha)
         if (yy >= minValue) then
            xLeft = maxR
            yLeft = yy
         else
            xRight = maxR
            yRight = yy
         end if
         iIter = iIter + 1
      end do
      if (iIter > nSearchIter) then
         iError = 3
      end if
   end if

   if (iError /= 0) then
      call env%error('Failed to determine max. real lattice vector', source)
   end if

end subroutine getMaxR


!> Returns the difference in the decrease of the real and reciprocal parts of the
!  Ewald sum. In order to make the real space part shorter than the reciprocal
!  space part, the values are taken at different distances for the real and the
!  reciprocal space parts.
pure function diffRecReal(alpha, getGTerm, minG, minR, volume) result(diff)

   !> Parameter for the Ewald summation
   real(wp), intent(in) :: alpha

   !> Procedure pointer to reciprocal routine
   procedure(getGTermGen) :: getGTerm

   !> Length of the shortest reciprocal space vector in the sum
   real(wp), intent(in) :: minG

   !> Length of the shortest real space vector in the sum
   real(wp), intent(in) :: minR

   !> Volume of the real space unit cell
   real(wp), intent(in) :: volume

   !> Difference between changes in the two terms
   real(wp) :: diff

   diff = ((getGTerm(4.0_wp*minG, alpha, volume) &
      & - getGTerm(5.0_wp*minG, alpha, volume))) &
      & - (getRTerm(2.0_wp*minR, alpha) - getRTerm(3.0_wp*minR, alpha))

end function diffRecReal


!> Returns the max. value of a term in the reciprocal space part of the Ewald
!  summation for a given vector length.
pure function getGTermPBC3D(gg, alpha, vol) result(gTerm)

   !> Length of the reciprocal space vector
   real(wp), intent(in) :: gg

   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha

   !> Volume of the real space unit cell
   real(wp), intent(in) :: vol

   !> Reciprocal term
   real(wp) :: gTerm

   gTerm = 4.0_wp*pi*(exp(-0.25_wp*gg**2/(alpha**2))/(vol*gg**2))

end function getGTermPBC3D


!> Returns the max. value of a term in the real space part of the Ewald summation
!  for a given vector length.
pure function getRTerm(rr, alpha) result(rTerm)

   !> Length of the real space vector
   real(wp), intent(in) :: rr

   !> Parameter of the Ewald summation
   real(wp), intent(in) :: alpha

   !> Real space term
   real(wp) :: rTerm

   rTerm = erfc(alpha*rr)/rr

end function getRTerm


end module xtb_coulomb_ewald

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> LAPACK linear equation solvers.
module xtb_mctc_lapack_trf
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: mctc_getrf, mctc_sytrf, mctc_sptrf, mctc_potrf, mctc_pptrf

   public :: lapack_getrf, lapack_sytrf, lapack_sptrf, lapack_potrf, lapack_pptrf


   interface mctc_getrf
      module procedure :: mctc_sgetrf
      module procedure :: mctc_dgetrf
   end interface mctc_getrf

   interface mctc_sytrf
      module procedure :: mctc_ssytrf
      module procedure :: mctc_dsytrf
   end interface mctc_sytrf

   interface mctc_sptrf
      module procedure :: mctc_ssptrf
      module procedure :: mctc_dsptrf
   end interface mctc_sptrf

   interface mctc_potrf
      module procedure :: mctc_spotrf
      module procedure :: mctc_dpotrf
   end interface mctc_potrf

   interface mctc_pptrf
      module procedure :: mctc_spptrf
      module procedure :: mctc_dpptrf
   end interface mctc_pptrf


   interface lapack_getrf
      pure subroutine sgetrf(m, n, a, lda, ipiv, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine sgetrf
      pure subroutine dgetrf(m, n, a, lda, ipiv, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dgetrf
      pure subroutine cgetrf(m, n, a, lda, ipiv, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cgetrf
      pure subroutine zgetrf(m, n, a, lda, ipiv, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: m
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zgetrf
   end interface lapack_getrf

   interface lapack_sytrf
      pure subroutine ssytrf(uplo, n, a, lda, ipiv, work, lwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine ssytrf
      pure subroutine dsytrf(uplo, n, a, lda, ipiv, work, lwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine dsytrf
      pure subroutine csytrf(uplo, n, a, lda, ipiv, work, lwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine csytrf
      pure subroutine zsytrf(uplo, n, a, lda, ipiv, work, lwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine zsytrf
   end interface lapack_sytrf

   interface lapack_sptrf
      pure subroutine ssptrf(uplo, n, ap, ipiv, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine ssptrf
      pure subroutine dsptrf(uplo, n, ap, ipiv, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine dsptrf
      pure subroutine csptrf(uplo, n, ap, ipiv, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine csptrf
      pure subroutine zsptrf(uplo, n, ap, ipiv, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine zsptrf
   end interface lapack_sptrf

   interface lapack_potrf
      pure subroutine spotrf(uplo, n, a, lda, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine spotrf
      pure subroutine dpotrf(uplo, n, a, lda, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dpotrf
      pure subroutine cpotrf(uplo, n, a, lda, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cpotrf
      pure subroutine zpotrf(uplo, n, a, lda, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zpotrf
   end interface lapack_potrf

   interface lapack_pptrf
      pure subroutine spptrf(uplo, n, ap, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine spptrf
      pure subroutine dpptrf(uplo, n, ap, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine dpptrf
      pure subroutine cpptrf(uplo, n, ap, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine cpptrf
      pure subroutine zpptrf(uplo, n, ap, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine zpptrf
   end interface lapack_pptrf


contains


subroutine mctc_sgetrf(env, amat, ipiv)
   character(len=*), parameter :: source = 'mctc_lapack_getrf'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   integer :: info, m, n, lda
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call lapack_getrf(m, n, amat, lda, ipiv, info)
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_sgetrf


subroutine mctc_dgetrf(env, amat, ipiv)
   character(len=*), parameter :: source = 'mctc_lapack_getrf'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   integer :: info, m, n, lda
   lda = max(1, size(amat, 1))
   m = size(amat, 1)
   n = size(amat, 2)
   call lapack_getrf(m, n, amat, lda, ipiv, info)
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_dgetrf


subroutine mctc_ssytrf(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sytrf'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, lda, lwork, stat_alloc, stat_dealloc
   real(sp), allocatable :: work(:)
   real(sp) :: test(1)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0
   lwork = -1
   call lapack_sytrf(ula, n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      if (stat_alloc==0) then
         allocate(work(lwork), stat=stat_alloc)
      end if
      if (stat_alloc==0) then
         call lapack_sytrf(ula, n, amat, lda, ipiv, work, lwork, info)
      else
         info = -1000
      end if
      deallocate(work, stat=stat_dealloc)
   end if
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_ssytrf


subroutine mctc_dsytrf(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sytrf'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(out) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, lda, lwork, stat_alloc, stat_dealloc
   real(dp), allocatable :: work(:)
   real(dp) :: test(1)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0
   lwork = -1
   call lapack_sytrf(ula, n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      if (stat_alloc==0) then
         allocate(work(lwork), stat=stat_alloc)
      end if
      if (stat_alloc==0) then
         call lapack_sytrf(ula, n, amat, lda, ipiv, work, lwork, info)
      else
         info = -1000
      end if
      deallocate(work, stat=stat_dealloc)
   end if
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_dsytrf


subroutine mctc_ssptrf(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sptrf'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:)
   integer, intent(out) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, stat_alloc, stat_dealloc, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   end if
   stat_alloc = 0
   if (stat_alloc==0) then
      call lapack_sptrf(ula, n, amat, ipiv, info)
   else
      info = -1000
   end if
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_ssptrf


subroutine mctc_dsptrf(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sptrf'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:)
   integer, intent(out) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, stat_alloc, stat_dealloc, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   end if
   stat_alloc = 0
   if (stat_alloc==0) then
      call lapack_sptrf(ula, n, amat, ipiv, info)
   else
      info = -1000
   end if
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_dsptrf


subroutine mctc_spotrf(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_potrf'
   character(len=1), intent(in), optional :: uplo
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   character(len=1) :: ula
   integer :: info, n, lda
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call lapack_potrf(ula, n, amat, lda, info)
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_spotrf


subroutine mctc_dpotrf(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_potrf'
   character(len=1), intent(in), optional :: uplo
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   character(len=1) :: ula
   integer :: info, n, lda
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call lapack_potrf(ula, n, amat, lda, info)
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_dpotrf


subroutine mctc_spptrf(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_pptrf'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   end if
   call lapack_pptrf(ula, n, amat, info)
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_spptrf


subroutine mctc_dpptrf(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_pptrf'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   end if
   call lapack_pptrf(ula, n, amat, info)
   if (info /= 0) then
      call env%error("Factorisation of matrix failed", source)
   end if
end subroutine mctc_dpptrf


end module xtb_mctc_lapack_trf

! This file is part of the dipro module in xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Version information for this project
module xtb_dipro_version
   implicit none
   private

   public :: dipro_version_string, dipro_version_compact
   public :: get_dipro_version


   !> String representation of the dipro version
   character(len=*), parameter :: dipro_version_string = "0.1.0"

   !> Numeric representation of the dipro version
   integer, parameter :: dipro_version_compact(3) = [0, 1, 0]

contains

!> Getter function to retrieve dipro version
subroutine get_dipro_version(major, minor, patch, string)
   !> Major version number of the dipro version
   integer, intent(out), optional :: major
   !> Minor version number of the dipro version
   integer, intent(out), optional :: minor
   !> Patch version number of the dipro version
   integer, intent(out), optional :: patch
   !> String representation of the dipro version
   character(len=:), allocatable, intent(out), optional :: string

   if (present(major)) then
      major = dipro_version_compact(1)
   end if
   if (present(minor)) then
      minor = dipro_version_compact(2)
   end if
   if (present(patch)) then
      patch = dipro_version_compact(3)
   end if
   if (present(string)) then
      string = dipro_version_string
   end if

end subroutine get_dipro_version

end module xtb_dipro_version

   ! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_restart
   use xtb_mctc_accuracy, only : wp, i8
   use xtb_mctc_io, only : stdout
   use xtb_type_environment, only : TEnvironment
   use xtb_type_wavefunction, only : TWavefunction
   implicit none

   public :: readRestart, writeRestart
   public :: read_restart_gff, write_restart_gff


contains


subroutine readRestart(env,wfx,fname,n,at,gfn_method,success,verbose)
   character(len=*), parameter :: source = 'restart_readRestart'
   type(TEnvironment), intent(inout) :: env
   type(TWavefunction),intent(inout) :: wfx
   character(len=*),intent(in) :: fname
   integer,intent(in)  :: n
   integer,intent(in)  :: at(n)
   integer,intent(in)  :: gfn_method
   logical,intent(out) :: success
   logical,intent(in)  :: verbose

   integer(i8) :: iver8,idum8,n8,nshell8,nel8,nopen8
   integer :: ich ! file handle
   integer :: err
   logical :: exist

   success = .false.
   call open_binary(ich,fname,'r')
   if (ich.ne.-1) then
      ! read the first 48 byte, which identify the calculation specs
      read(ich,iostat=err) iver8,idum8,n8,nshell8,nel8,nopen8
      if(err.eq.0) then
         if (iver8.ne.int(gfn_method,i8).and.verbose) &
            &  call env%warning('Version number missmatch in restart file.', source)
         if (nel8.ne.int(wfx%nel,i8).and.verbose) &
            &  call env%warning('Number of electron missmatch in restart file.', source)
         if (nopen8.ne.int(wfx%nopen,i8).and.verbose) &
            &  call env%warning('Multiplicity missmatch in restart file.', source)
         if ((n8.eq.int(wfx%n,i8)).and.(nshell8.eq.int(wfx%nshell,i8))) then
            success = .true.
            read(ich) wfx%qsh
            if (verbose) &
            write(stdout,'("q/qsh data taken from xtbrestart")')
            if ((gfn_method.gt.1).and.(iver8.gt.1)) then
!              read dipole and qpole CAMM
               read(ich) wfx%dipm
               read(ich) wfx%qp
               if (verbose) &
               write(stdout,'("CAMM data taken from xtbrestart")')
            endif
         else
            if (verbose) &
            call env%warning('Dimension missmatch in restart file.', source)
            success = .false.
         endif
      else
         if (verbose) &
         call env%warning("Dimension missmatch in restart file.", source)
         success = .false.
      end if
      call close_file(ich)
   end if

end subroutine readRestart


subroutine read_restart_gff(env,fname,n,version,success,verbose,topo)
   use xtb_gfnff_param
   use xtb_gfnff_topology, only : TGFFTopology
   implicit none
   character(len=*), parameter :: source = 'restart_read_restart_gff'
   type(TEnvironment), intent(inout) :: env
   type(TGFFTopology), intent(inout) :: topo
   character(len=*),intent(in) :: fname
   integer,intent(in)  :: n
   integer,intent(in)  :: version
   logical,intent(out) :: success
   logical,intent(in)  :: verbose

   integer(i8) :: iver8,nat8

   integer :: ich ! file handle
   integer :: err
   logical :: exist

   success = .false.
   call open_binary(ich,fname,'r')
   if (ich.ne.-1) then
      !read the first byte, which identify the calculation specs
      read(ich,iostat=err) iver8,nat8
      if(err.eq.0) then
         if (iver8.ne.int(version,i8).and.verbose) &
            &  call env%warning('Version number missmatch in restart file.',source)
         if (nat8.ne.n.and.verbose) then
            call env%warning('Atom number missmatch in restart file.',source)
            success=.false.
            call close_file(ich)
            return
         else if (iver8.eq.int(version)) then
            success = .true.
            read(ich) topo%nbond,topo%nangl,topo%ntors,topo%nathbH,topo%nathbAB,  &
                    & topo%natxbAB,topo%nbatm,topo%nfrag,topo%nsystem,topo%maxsystem
            read(ich) topo%nbond_blist,topo%nbond_vbond,topo%nangl_alloc,topo%ntors_alloc,topo%bond_hb_nr,topo%b_max
            call gfnff_param_alloc(topo, n)
            if (.not.allocated(topo%ispinsyst)) allocate( topo%ispinsyst(n,topo%maxsystem), source = 0 )
            if (.not.allocated(topo%nspinsyst)) allocate( topo%nspinsyst(topo%maxsystem), source = 0 )
            read(ich) topo%nb,topo%bpair,topo%blist,topo%alist, &
               & topo%tlist,topo%b3list,topo%fraglist,topo%hbatHl,topo%hbatABl, &
               & topo%xbatABl,topo%ispinsyst,topo%nspinsyst,topo%bond_hb_AH, &
               & topo%bond_hb_B,topo%bond_hb_Bn,topo%nr_hb
            read(ich) topo%vbond,topo%vangl,topo%vtors,topo%chieeq, &
               & topo%gameeq,topo%alpeeq,topo%alphanb,topo%qa, &
               & topo%xyze0,topo%zetac6,&
               & topo%qfrag,topo%hbbas,topo%hbaci
         else
            if (verbose) &
               call env%warning("Dimension missmatch in restart file.",source)
            success = .false.
         endif
      else
         if (verbose) &
            call env%warning("Dimension missmatch in restart file.",source)
         success = .false.
      endif
      call close_file(ich)
   endif

end subroutine read_restart_gff


subroutine writeRestart(env,wfx,fname,gfn_method)
   type(TEnvironment), intent(inout) :: env
   type(TWavefunction),intent(inout) :: wfx
   character(len=*),intent(in) :: fname
   integer,intent(in)  :: gfn_method
   integer :: ich ! file handle

   call open_binary(ich,fname,'w')
   write(ich) int(gfn_method,i8),int(gfn_method,i8), &
      int(wfx%n,i8),int(wfx%nshell,i8), &
      int(wfx%nel,i8),int(wfx%nopen,i8)
   write(ich) wfx%qsh
   if (gfn_method.gt.1) then
      write(ich) wfx%dipm
      write(ich) wfx%qp
   endif
   call close_file(ich)

end subroutine writeRestart


subroutine write_restart_gff(env,fname,nat,version,topo)
   use xtb_gfnff_param
   use xtb_gfnff_topology, only : TGFFTopology
   implicit none
   type(TEnvironment), intent(inout) :: env
   type(TGFFTopology), intent(in) :: topo
   character(len=*),intent(in) :: fname
   integer,intent(in)  :: nat
   integer,intent(in)  :: version
   integer :: ich ! file handle

   call open_binary(ich,fname,'w')
   !Dimensions
   write(ich) int(version,i8),int(nat,i8)
   write(ich) topo%nbond,topo%nangl,topo%ntors,   &
            & topo%nathbH,topo%nathbAB,topo%natxbAB,topo%nbatm,topo%nfrag,topo%nsystem,  &
            & topo%maxsystem
   write(ich) topo%nbond_blist,topo%nbond_vbond,topo%nangl_alloc,topo%ntors_alloc,topo%bond_hb_nr,topo%b_max
   !Arrays Integers
   write(ich) topo%nb,topo%bpair,topo%blist,topo%alist,topo%tlist,topo%b3list, &
      & topo%fraglist,topo%hbatHl,topo%hbatABl,topo%xbatABl,topo%ispinsyst,topo%nspinsyst,             &
      & topo%bond_hb_AH,topo%bond_hb_B,topo%bond_hb_Bn,topo%nr_hb
   !Arrays Reals
   write(ich) topo%vbond,topo%vangl,topo%vtors,topo%chieeq,topo%gameeq,topo%alpeeq,topo%alphanb,topo%qa,       &
      & topo%xyze0,topo%zetac6,topo%qfrag,topo%hbbas,topo%hbaci
   call close_file(ich)
end subroutine write_restart_gff


end module xtb_restart

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> TODO
module xtb_disp_coordinationnumber
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants, only : pi
   use xtb_param_covalentradd3, only : covalentRadD3
   use xtb_param_paulingen, only : paulingEN
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_neighbourlist, only : TNeighbourList
   use xtb_type_latticepoint, only : TLatticePoint, init_ => init
   implicit none
   private

   public :: cnType, getCoordinationNumber, cutCoordinationNumber


   interface getCoordinationNumber
      module procedure :: getCoordinationNumberWrap
      module procedure :: getCoordinationNumberNL
      module procedure :: getCoordinationNumberLP
   end interface getCoordinationNumber


   !> Possible counting functions for calculating coordination numbers
   type :: TCNTypeEnum

      !> Counting function not specified
      integer :: invalid = 0

      !> Original DFT-D3 coordination number
      integer :: exp = 1

      !> Faster decaying error function CN, better for dense systems
      integer :: erf = 2

      !> Error function CN with covalency correction
      integer :: cov = 3

      !> Particular long-ranged version of the DFT-D3 coordination number
      integer :: gfn = 4

   end type TCNTypeEnum

   !> Enumerator for different coordination number types
   type(TCNTypeEnum), parameter :: cnType = TCNTypeEnum()


   abstract interface
   !> Abstract interface for the counting function (and its derivative)
   pure function countingFunction(k, r, r0)
      import :: wp

      !> Constant for counting function
      real(wp), intent(in) :: k

      !> Actual distance
      real(wp), intent(in) :: r

      !> Critical distance
      real(wp), intent(in) :: r0

      !> Value of the counting function in the range of [0,1]
      real(wp) :: countingFunction

   end function countingFunction
   end interface


   !> Parameter for electronegativity scaling
   real(wp),parameter :: k4=4.10451_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k5=19.08857_wp

   !> Parameter for electronegativity scaling
   real(wp),parameter :: k6=2*11.28174_wp**2


contains


!> Geometric fractional coordination number, supports both error function
!  and exponential counting functions.
subroutine getCoordinationNumberWrap(env, mol, cf, cn, dcndr, dcndL, cutoff)

   !> Source for error creation
   character(len=*), parameter :: source = &
      & 'disp_coordinationnumber_getCoordinationNumberWrap'

   !> Computational Environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Coordination number type (by counting function)
   integer, intent(in) :: cf

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(out) :: dcndL(:, :, :)

   !> Real space cutoff for the coordination number
   real(wp), intent(in), optional :: cutoff

   logical :: exitRun
   real(wp) :: rCutoff
   real(wp), allocatable :: trans(:, :)
   type(TLatticePoint) :: latp

   if (present(cutoff)) then
      rCutoff = cutoff
   else
      rCutoff = 40.0_wp
   end if

   !> Initialize lattice point generator, this might fail
   call init_(latp, env, mol, rCutoff)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Setup of lattice point generator failed", source)
      return
   end if

   !> Generate a new batch of lattice points
   call latp%getLatticePoints(trans, rCutoff)

   !> Actual call to the lattice point version of the CN evaluation
   call getCoordinationNumber(mol, trans, rCutoff, cf, cn, dcndr, dcndL)

end subroutine getCoordinationNumberWrap


!> Geometric fractional coordination number, supports both error function
!  and exponential counting functions.
subroutine getCoordinationNumberNL(mol, neighs, neighlist, cf, cn, dcndr, dcndL)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Number of interacting neighbours
   integer, intent(in) :: neighs(:)

   !> Neighbourlist
   type(TNeighbourList), intent(in) :: neighlist

   !> Coordination number type (by counting function)
   integer, intent(in) :: cf

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(out) :: dcndL(:, :, :)

   real(wp), parameter :: kcn_exp = 16.0_wp
   real(wp), parameter :: kcn_erf = 7.5_wp
   real(wp), parameter :: kcn_gfn = 10.0_wp

   select case(cf)
   case(cnType%exp)
      call ncoordNeighs(mol, neighs, neighlist, kcn_exp, expCount, dexpCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%erf)
      call ncoordNeighs(mol, neighs, neighlist, kcn_erf, erfCount, derfCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%cov)
      call ncoordNeighs(mol, neighs, neighlist, kcn_erf, erfCount, derfCount, &
         & .true., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%gfn)
      call ncoordNeighs(mol, neighs, neighlist, kcn_gfn, gfnCount, dgfnCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   end select

end subroutine getCoordinationNumberNL


!> Actual implementation of the coordination number, takes a generic counting
!  function to return the respective CN.
subroutine ncoordNeighs(mol, neighs, neighlist, kcn, cfunc, dfunc, enscale, &
      & rcov, en, cn, dcndr, dcndL)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Number of interacting neighbours
   integer, intent(in) :: neighs(:)

   !> Neighbourlist
   type(TNeighbourList), target, intent(in) :: neighlist

   !> Function implementing the counting function
   procedure(countingFunction) :: cfunc

   !> Function implementing the derivative of counting function w.r.t. distance
   procedure(countingFunction) :: dfunc

   !> Use a covalency criterium by Pauling EN's
   logical, intent(in) :: enscale

   !> Steepness of counting function
   real(wp), intent(in) :: kcn

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(out) :: dcndL(:, :, :)

   integer :: iat, jat, ati, atj, ij, img
   real(wp) :: r2, r1, rc, rij(3), countf, countd(3), stress(3, 3), den

   cn = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp

   !$omp parallel do default(none) private(den) shared(enscale, rcov, en)&
   !$omp reduction(+:cn, dcndr, dcndL) shared(mol, kcn, neighlist, neighs) &
   !$omp private(ij, img, jat, ati, atj, r2, rij, r1, rc, countf, countd, stress)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do ij = 1, neighs(iat)
         img = neighlist%iNeigh(ij, iat)
         r2 = neighlist%dist2(ij, iat)
         rij = neighlist%coords(:, iat) - neighlist%coords(:, img)
         jat = neighlist%image(img)
         atj = mol%at(jat)
         r1 = sqrt(r2)

         rc = rcov(ati) + rcov(atj)

         if (enscale) then
            den = k4*exp(-(abs(en(ati)-en(atj)) + k5)**2/k6)
         else
            den = 1.0_wp
         endif

         countf = den * cfunc(kcn, r1, rc)
         countd = den * dfunc(kcn, r1, rc) * rij/r1

         cn(iat) = cn(iat) + countf
         if (iat /= jat) then
            cn(jat) = cn(jat) + countf
         endif

         dcndr(:, iat, iat) = dcndr(:, iat, iat) + countd
         dcndr(:, jat, jat) = dcndr(:, jat, jat) - countd
         dcndr(:, iat, jat) = dcndr(:, iat, jat) + countd
         dcndr(:, jat, iat) = dcndr(:, jat, iat) - countd

         stress = spread(countd, 1, 3) * spread(rij, 2, 3)

         dcndL(:, :, iat) = dcndL(:, :, iat) + stress
         if (iat /= jat) then
            dcndL(:, :, jat) = dcndL(:, :, jat) + stress
         endif

      enddo
   enddo
   !$omp end parallel do

end subroutine ncoordNeighs


!> Geometric fractional coordination number, supports both error function
!  and exponential counting functions.
subroutine getCoordinationNumberLP(mol, trans, cutoff, cf, cn, dcndr, dcndL)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Coordination number type (by counting function)
   integer, intent(in) :: cf

   !> Error function coordination number
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations
   real(wp), intent(out) :: dcndL(:, :, :)

   real(wp), parameter :: kcn_exp = 16.0_wp
   real(wp), parameter :: kcn_erf = 7.5_wp
   real(wp), parameter :: kcn_gfn = 10.0_wp

   select case(cf)
   case(cnType%exp)
      call ncoordLatP(mol, trans, cutoff, kcn_exp, expCount, dexpCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%erf)
      call ncoordLatP(mol, trans, cutoff, kcn_erf, erfCount, derfCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%cov)
      call ncoordLatP(mol, trans, cutoff, kcn_erf, erfCount, derfCount, &
         & .true., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   case(cnType%gfn)
      call ncoordLatP(mol, trans, cutoff, kcn_gfn, gfnCount, dgfnCount, &
         & .false., covalentRadD3, paulingEN, cn, dcndr, dcndL)
   end select

end subroutine getCoordinationNumberLP


!> Actual implementation of the coordination number, takes a generic counting
!  function to return the respective CN.
subroutine ncoordLatP(mol, trans, cutoff, kcn, cfunc, dfunc, enscale, &
      & rcov, en, cn, dcndr, dcndL)

   !> Molecular structure information
   type(TMolecule), intent(in) :: mol

   !> Lattice points
   real(wp), intent(in) :: trans(:, :)

   !> Real space cutoff
   real(wp), intent(in) :: cutoff

   !> Function implementing the counting function
   procedure(countingFunction) :: cfunc

   !> Function implementing the derivative of counting function w.r.t. distance
   procedure(countingFunction) :: dfunc

   !> Use a covalency criterium by Pauling EN's
   logical, intent(in) :: enscale

   !> Steepness of counting function
   real(wp), intent(in) :: kcn

   !> Covalent radius
   real(wp), intent(in) :: rcov(:)

   !> Electronegativity
   real(wp), intent(in) :: en(:)

   !> Error function coordination number.
   real(wp), intent(out) :: cn(:)

   !> Derivative of the CN with respect to the Cartesian coordinates.
   real(wp), intent(out) :: dcndr(:, :, :)

   !> Derivative of the CN with respect to strain deformations.
   real(wp), intent(out) :: dcndL(:, :, :)

   integer :: iat, jat, ati, atj, itr
   real(wp) :: r2, r1, rc, rij(3), countf, countd(3), stress(3, 3), den, cutoff2

   cn = 0.0_wp
   dcndr = 0.0_wp
   dcndL = 0.0_wp
   cutoff2 = cutoff**2

   !$omp parallel do default(none) private(den) shared(enscale, rcov, en)&
   !$omp reduction(+:cn, dcndr, dcndL) shared(mol, kcn, trans, cutoff2) &
   !$omp private(jat, itr, ati, atj, r2, rij, r1, rc, countf, countd, stress)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do jat = 1, iat
         atj = mol%at(jat)

         if (enscale) then
            den = k4*exp(-(abs(en(ati)-en(atj)) + k5)**2/k6)
         else
            den = 1.0_wp
         end if

         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - (mol%xyz(:, jat) + trans(:, itr))
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            rc = rcov(ati) + rcov(atj)

            countf = den * cfunc(kcn, r1, rc)
            countd = den * dfunc(kcn, r1, rc) * rij/r1

            cn(iat) = cn(iat) + countf
            if (iat /= jat) then
               cn(jat) = cn(jat) + countf
            end if

            dcndr(:, iat, iat) = dcndr(:, iat, iat) + countd
            dcndr(:, jat, jat) = dcndr(:, jat, jat) - countd
            dcndr(:, iat, jat) = dcndr(:, iat, jat) + countd
            dcndr(:, jat, iat) = dcndr(:, jat, iat) - countd

            stress = spread(countd, 1, 3) * spread(rij, 2, 3)

            dcndL(:, :, iat) = dcndL(:, :, iat) + stress
            if (iat /= jat) then
               dcndL(:, :, jat) = dcndL(:, :, jat) + stress
            end if

         end do
      end do
   end do
   !$omp end parallel do

end subroutine ncoordLatP


!> Error function counting function for coordination number contributions.
pure function erfCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = 0.5_wp * (1.0_wp + erf(-k*(r-r0)/r0))

end function erfCount


!> Derivative of the counting function w.r.t. the distance.
pure function derfCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp), parameter :: sqrtpi = sqrt(pi)

   real(wp) :: count

   count = -k/sqrtpi/r0*exp(-k**2*(r-r0)**2/r0**2)

end function derfCount


!> Exponential counting function for coordination number contributions.
pure function expCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count =1.0_wp/(1.0_wp+exp(-k*(r0/r-1.0_wp)))

end function expCount


!> Derivative of the counting function w.r.t. the distance.
pure function dexpCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count
   real(wp) :: expterm

   expterm = exp(-k*(r0/r-1._wp))

   count = (-k*r0*expterm)/(r**2*((expterm+1._wp)**2))

end function dexpCount


!> Exponential counting function for coordination number contributions.
pure function gfnCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = expCount(k, r, r0) * expCount(2*k, r, r0+2)

end function gfnCount


!> Derivative of the counting function w.r.t. the distance.
pure function dgfnCount(k, r, r0) result(count)

   !> Steepness of the counting function.
   real(wp), intent(in) :: k

   !> Current distance.
   real(wp), intent(in) :: r

   !> Cutoff radius.
   real(wp), intent(in) :: r0

   real(wp) :: count

   count = dexpCount(k, r, r0) * expCount(2*k, r, r0+2) &
      &  + expCount(k, r, r0) * dexpCount(2*k, r, r0+2)

end function dgfnCount


!> Cutoff function for large coordination numbers
pure subroutine cutCoordinationNumber(nAtom, cn, dcndr, dcndL, maxCN)

   !> number of atoms
   integer, intent(in) :: nAtom

   !> on input coordination number, on output modified CN
   real(wp), intent(inout) :: cn(:)

   !> on input derivative of CN w.r.t. cartesian coordinates,
   !> on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndr(:, :, :)

   !> on input derivative of CN w.r.t. strain deformation,
   !> on output derivative of modified CN
   real(wp), intent(inout), optional :: dcndL(:, :, :)

   !> maximum CN (not strictly obeyed)
   real(wp), intent(in), optional :: maxCN

   real(wp) :: cnmax
   integer :: iAt

   if (present(maxCN)) then
      cnmax = maxCN
   else
      cnmax = 4.5_wp
   end if

   if (cnmax <= 0.0_wp) return

   if (present(dcndL)) then
      do iAt = 1, nAtom
         dcndL(:, :, iAt) = dcndL(:, :, iAt) * dCutCN(cn(iAt), cnmax)
      end do
   end if

   if (present(dcndr)) then
      do iAt = 1, nAtom
         dcndr(:, :, iAt) = dcndr(:, :, iAt) * dCutCN(cn(iAt), cnmax)
      end do
   end if

   do iAt = 1, nAtom
      cn(iAt) = cutCN(cn(iAt), cnmax)
   end do

end subroutine cutCoordinationNumber


!> Cutting function for the coordination number.
elemental function cutCN(cn, cut) result(cnp)

   !> Current coordination number.
   real(wp), intent(in) :: cn

   !> Cutoff for the CN, this is not the maximum value.
   real(wp), intent(in) :: cut

   !> Cuting function vlaue
   real(wp) :: cnp

   cnp = log(1.0_wp + exp(cut)) - log(1.0_wp + exp(cut - cn))

end function cutCN


!> Derivative of the cutting function w.r.t. coordination number
elemental function dCutCN(cn, cut) result(dcnpdcn)

   !> Current coordination number.
   real(wp), intent(in) :: cn

   !> Cutoff for the CN, this is not the maximum value.
   real(wp), intent(in) :: cut

   !> Derivative of the cutting function
   real(wp) :: dcnpdcn

   dcnpdcn = exp(cut)/(exp(cut) + exp(cn))

end function dCutCn


end module xtb_disp_coordinationnumber

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Calculation of all required overlap matrices
module xtb_ptb_integrals
#if WITH_TBLITE
   use mctc_env, only: wp
   use mctc_io, only: structure_type

   use tblite_integral_dipole, only: get_dipole_integrals
   use tblite_cutoff, only: get_lattice_points
   use tblite_basis_type, only: basis_type, get_cutoff
   use tblite_integral_overlap, only: overlap_cgto, maxl, msao
   use tblite_integral_multipole, only: multipole_cgto
   use tblite_adjlist, only: adjacency_list

   use xtb_ptb_vdzp, only: add_vDZP_basis, nshell, max_shell
   implicit none

   private

   public :: get_integrals

   interface get_integrals
      module procedure get_integrals_overlap_existbasis
      module procedure get_integrals_overlap_newbasis
      module procedure get_integrals_multipole_existbasis
      module procedure get_integrals_multipole_newbasis
   end interface get_integrals

contains

   !> Calculate the overlap matrix for a given scaling factor
   subroutine get_integrals_overlap_existbasis(mol, bas, lattr, list, overlap, norm)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: lattr(:, :)
      !> Adjacency list
      type(adjacency_list), intent(in) :: list
      !> Overlap matrix as output
      real(wp), intent(out) :: overlap(:, :)
      !> Normalization factors as output
      real(wp), intent(out), optional :: norm(:)
      real(wp), allocatable :: normlocal(:)
      integer :: i, j, ij

      allocate (normlocal(bas%nao), source=0.0_wp)

      !> Calculate overlap matrix
      call get_overlap(mol, lattr, list, bas, overlap)

      !> Normalize overlap
      ij = 0
      do i = 1, bas%nao
         normlocal(i) = 1.0_wp / sqrt(overlap(i, i))
      end do
      ij = 0
      do i = 1, bas%nao
         do j = 1, i
            overlap(i, j) = overlap(i, j) * normlocal(i) * normlocal(j)
            overlap(j, i) = overlap(i, j)
         end do
      end do
      if (present(norm)) then
         norm = normlocal
      end if

   end subroutine get_integrals_overlap_existbasis

   !> Calculate the overlap matrix for a given scaling factor
   subroutine get_integrals_overlap_newbasis(mol, lattr, list, overlap, alpha_scal, norm)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: lattr(:, :)
      !> Adjacency list
      type(adjacency_list), intent(in) :: list
      !> Overlap matrix as output
      real(wp), intent(out) :: overlap(:, :)
      !> Scaling factors as input
      real(wp), intent(in), optional :: alpha_scal(max_shell, mol%nat)
      !> Normalization factors as output
      real(wp), intent(out), optional :: norm(:)
      !> Basis set data
      type(basis_type) :: bas

      !> Set up a new basis set with using the scaled exponents
      if (present(alpha_scal)) then
         call add_vDZP_basis(mol, alpha_scal, bas)
      else
         call add_vDZP_basis(mol, bas)
      end if

      call get_integrals(mol, bas, lattr, list, overlap, norm=norm)

   end subroutine get_integrals_overlap_newbasis

   !> Calculate the overlap matrix for a given scaling factor
   subroutine get_integrals_multipole_existbasis(mol, bas, lattr, list, overlap, dipole, quadrupole, norm)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Adjacency list
      type(adjacency_list), intent(in) :: list
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: lattr(:, :)
      !> Overlap matrix as output
      real(wp), intent(out) :: overlap(:, :), dipole(:, :, :), quadrupole(:, :, :)
      !> Normalization factors as output
      real(wp), intent(out), optional :: norm(:)
      real(wp), allocatable :: normlocal(:)
      real(wp) :: cutoff
      integer :: i, j, ij, k

      cutoff = get_cutoff(bas)
      allocate (normlocal(bas%nao), source=0.0_wp)

      call get_multi_int(mol, lattr, list, bas, overlap, dipole, quadrupole)

      !> Normalize overlap
      ij = 0
      do i = 1, bas%nao
         normlocal(i) = 1.0_wp / sqrt(overlap(i, i))
      end do
      ij = 0
      do i = 1, bas%nao
         do j = 1, i
            overlap(i, j) = overlap(i, j) * normlocal(i) * normlocal(j)
            overlap(j, i) = overlap(i, j)
         end do
      end do

      !> Normalize dipole integrals
      do k = 1, 3
         do i = 1, bas%nao
            do j = 1, i
               dipole(k, i, j) = dipole(k, i, j) * normlocal(i) * normlocal(j)
               dipole(k, j, i) = dipole(k, j, i) * normlocal(i) * normlocal(j)
            end do
         end do
      end do

      !> Normalize quadrupole integrals
      do k = 1, 6
         do i = 1, bas%nao
            do j = 1, i
               quadrupole(k, i, j) = quadrupole(k, i, j) * normlocal(i) * normlocal(j)
               quadrupole(k, j, i) = quadrupole(k, j, i) * normlocal(i) * normlocal(j)
            end do
         end do
      end do

      if (present(norm)) then
         norm = normlocal
      end if

   end subroutine get_integrals_multipole_existbasis

   !> Calculate the overlap matrix for a given scaling factor
   subroutine get_integrals_multipole_newbasis(mol, lattr, list, overlap, dipole, quadrupole, alpha_scal, norm)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: lattr(:, :)
      !> Adjacency list
      type(adjacency_list), intent(in) :: list
      !> Overlap matrix as output
      real(wp), intent(out) :: overlap(:, :), dipole(:, :, :), quadrupole(:, :, :)
      !> Scaling factors as input
      real(wp), intent(in), optional :: alpha_scal(max_shell, mol%nid)
      !> Normalization factors as output
      real(wp), intent(out), optional :: norm(:)
      !> Basis set data
      type(basis_type) :: bas
      !#####################

      !> Set up a new basis set with using the scaled exponents
      if (present(alpha_scal)) then
         call add_vDZP_basis(mol, alpha_scal, bas)
      else
         call add_vDZP_basis(mol, bas)
      end if

      call get_integrals(mol, bas, lattr, list, overlap, dipole, quadrupole, norm)

   end subroutine get_integrals_multipole_newbasis

   subroutine get_overlap(mol, trans, list, bas, overlap)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: trans(:, :)
      !> Neighbour list
      type(adjacency_list), intent(in) :: list
      !> Basis set information
      type(basis_type), intent(in) :: bas
      !> Overlap integral matrix
      real(wp), intent(out) :: overlap(:, :)

      integer :: iat, jat, izp, jzp, itr, img, inl
      integer :: ish, jsh, is, js, ii, jj, iao, jao, nao, ij
      real(wp) :: r2, vec(3)
      real(wp), allocatable :: stmp(:)

      overlap(:, :) = 0.0_wp

      allocate (stmp(msao(bas%maxl)**2))

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, trans, list, overlap) &
      !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij) &
      !$omp private(r2, vec, stmp, inl, img)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         inl = list%inl(iat)
         do img = 1, list%nnl(iat)
            jat = list%nlat(img + inl)
            itr = list%nltr(img + inl)
            jzp = mol%id(jat)
            js = bas%ish_at(jat)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is + ish)
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js + jsh)
                  call overlap_cgto(bas%cgto(jsh, jat), bas%cgto(ish, iat), &
                     & r2, vec, bas%intcut, stmp)

                  nao = msao(bas%cgto(jsh, jat)%ang)
                  do iao = 1, msao(bas%cgto(ish, iat)%ang)
                     do jao = 1, nao
                        ij = jao + nao * (iao - 1)
                        !$omp atomic
                        overlap(jj + jao, ii + iao) = overlap(jj + jao, ii + iao) &
                                                      + stmp(ij)

                        !$omp atomic
                        overlap(ii + iao, jj + jao) = overlap(ii + iao, jj + jao) &
                                                      + stmp(ij)
                     end do
                  end do

               end do
            end do

         end do
      end do

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, overlap) &
      !$omp private(iat, izp, itr, is, ish, jsh, ii, jj, iao, jao, nao, ij) &
      !$omp private(r2, vec, stmp)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         vec(:) = 0.0_wp
         r2 = 0.0_wp
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is + ish)
            do jsh = 1, bas%nsh_id(izp)
               jj = bas%iao_sh(is + jsh)
               call overlap_cgto(bas%cgto(jsh, iat), bas%cgto(ish, iat), &
                     & r2, vec, bas%intcut, stmp)

               nao = msao(bas%cgto(jsh, iat)%ang)
               do iao = 1, msao(bas%cgto(ish, iat)%ang)
                  do jao = 1, nao
                     ij = jao + nao * (iao - 1)
                     overlap(jj + jao, ii + iao) = overlap(jj + jao, ii + iao) &
                                                   + stmp(ij)
                  end do
               end do

            end do
         end do

      end do

   end subroutine get_overlap

   subroutine get_multi_int(mol, trans, list, bas, overlap, dpint, qpint)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Lattice points within a given realspace cutoff
      real(wp), intent(in) :: trans(:, :)
      !> Neighbour list
      type(adjacency_list), intent(in) :: list
      !> Basis set information
      type(basis_type), intent(in) :: bas
      !> Overlap integral matrix
      real(wp), intent(out) :: overlap(:, :)
      !> Dipole moment integral matrix
      real(wp), intent(out) :: dpint(:, :, :)
      !> Quadrupole moment integral matrix
      real(wp), intent(out) :: qpint(:, :, :)

      integer :: iat, jat, izp, jzp, itr, img, inl, k
      integer :: ish, jsh, is, js, ii, jj, iao, jao, nao, ij
      real(wp) :: r2, vec(3), dtmpj(3), qtmpj(6)
      real(wp), allocatable :: stmp(:), dtmpi(:, :), qtmpi(:, :)

      overlap(:, :) = 0.0_wp
      dpint(:, :, :) = 0.0_wp
      qpint(:, :, :) = 0.0_wp

      allocate (stmp(msao(bas%maxl)**2), dtmpi(3, msao(bas%maxl)**2), qtmpi(6, msao(bas%maxl)**2))

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, trans, list, overlap, dpint, qpint) &
      !$omp private(iat, jat, izp, jzp, itr, is, js, ish, jsh, ii, jj, iao, jao, nao, ij, k) &
      !$omp private(r2, vec, stmp, dtmpi, dtmpj, qtmpi, qtmpj, inl, img)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         inl = list%inl(iat)
         do img = 1, list%nnl(iat)
            jat = list%nlat(img + inl)
            itr = list%nltr(img + inl)
            jzp = mol%id(jat)
            js = bas%ish_at(jat)
            vec(:) = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = vec(1)**2 + vec(2)**2 + vec(3)**2
            do ish = 1, bas%nsh_id(izp)
               ii = bas%iao_sh(is + ish)
               do jsh = 1, bas%nsh_id(jzp)
                  jj = bas%iao_sh(js + jsh)
                  call multipole_cgto(bas%cgto(jsh, jat), bas%cgto(ish, iat), &
                     & r2, vec, bas%intcut, stmp, dtmpi, qtmpi)

                  nao = msao(bas%cgto(jsh, jat)%ang)
                  do iao = 1, msao(bas%cgto(ish, iat)%ang)
                     do jao = 1, nao
                        ij = jao + nao * (iao - 1)
                        call shift_operator(vec, stmp(ij), dtmpi(:, ij), qtmpi(:, ij), &
                           & dtmpj, qtmpj)
                        !$omp atomic
                        overlap(jj + jao, ii + iao) = overlap(jj + jao, ii + iao) &
                           & + stmp(ij)

                        !$omp atomic
                        overlap(ii + iao, jj + jao) = overlap(ii + iao, jj + jao) &
                           & + stmp(ij)

                        do k = 1, 3
                           !$omp atomic
                           dpint(k, jj + jao, ii + iao) = dpint(k, jj + jao, ii + iao) &
                              & + dtmpi(k, ij)
                        end do
                        do k = 1, 3
                           !$omp atomic
                           dpint(k, ii + iao, jj + jao) = dpint(k, ii + iao, jj + jao) &
                              & + dtmpj(k)
                        end do

                        do k = 1, 6
                           !$omp atomic
                           qpint(k, jj + jao, ii + iao) = qpint(k, jj + jao, ii + iao) &
                                                          + qtmpi(k, ij)
                        end do
                        do k = 1, 6
                           !$omp atomic
                           qpint(k, ii + iao, jj + jao) = qpint(k, ii + iao, jj + jao) &
                                                          + qtmpj(k)
                        end do
                     end do
                  end do

               end do
            end do

         end do
      end do

      !$omp parallel do schedule(runtime) default(none) &
      !$omp shared(mol, bas, overlap, dpint, qpint) &
      !$omp private(iat, izp, itr, is, ish, jsh, ii, jj, iao, jao, nao, ij) &
      !$omp private(r2, vec, stmp, dtmpi, qtmpi)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         is = bas%ish_at(iat)
         vec(:) = 0.0_wp
         r2 = 0.0_wp
         do ish = 1, bas%nsh_id(izp)
            ii = bas%iao_sh(is + ish)
            do jsh = 1, bas%nsh_id(izp)
               jj = bas%iao_sh(is + jsh)
               call multipole_cgto(bas%cgto(jsh, iat), bas%cgto(ish, iat), &
                  & r2, vec, bas%intcut, stmp, dtmpi, qtmpi)

               nao = msao(bas%cgto(jsh, iat)%ang)
               do iao = 1, msao(bas%cgto(ish, iat)%ang)
                  do jao = 1, nao
                     ij = jao + nao * (iao - 1)
                     overlap(jj + jao, ii + iao) = overlap(jj + jao, ii + iao) &
                        & + stmp(ij)
                     dpint(:, jj + jao, ii + iao) = dpint(:, jj + jao, ii + iao) &
                        & + dtmpi(:, ij)
                     qpint(:, jj + jao, ii + iao) = qpint(:, jj + jao, ii + iao) &
                        & + qtmpi(:, ij)
                  end do
               end do

            end do
         end do

      end do

   end subroutine get_multi_int

   !> TAKEN OVER FROM TBLITE
   !> Shift multipole operator from Ket function (center i) to Bra function (center j),
   !> the multipole operator on the Bra function can be assembled from the lower moments
   !> on the Ket function and the displacement vector using horizontal shift rules.
   pure subroutine shift_operator(vec, s, di, qi, dj, qj)
      !> Displacement vector of center i and j
      real(wp), intent(in) :: vec(:)
      !> Overlap integral between basis functions
      real(wp), intent(in) :: s
      !> Dipole integral with operator on Ket function (center i)
      real(wp), intent(in) :: di(:)
      !> Quadrupole integral with operator on Ket function (center i)
      real(wp), intent(in) :: qi(:)
      !> Dipole integral with operator on Bra function (center j)
      real(wp), intent(out) :: dj(:)
      !> Quadrupole integral with operator on Bra function (center j)
      real(wp), intent(out) :: qj(:)

      real(wp) :: tr

      ! Create dipole operator on Bra function from Ket function and shift contribution
      ! due to monopol displacement
      dj(1) = di(1) + vec(1) * s
      dj(2) = di(2) + vec(2) * s
      dj(3) = di(3) + vec(3) * s

      ! For the quadrupole operator on the Bra function we first construct the shift
      ! contribution from the dipole and monopol displacement, since we have to remove
      ! the trace contribution from the shift and the moment integral on the Ket function
      ! is already traceless
      qj(1) = 2 * vec(1) * di(1) + vec(1)**2 * s
      qj(3) = 2 * vec(2) * di(2) + vec(2)**2 * s
      qj(6) = 2 * vec(3) * di(3) + vec(3)**2 * s
      qj(2) = vec(1) * di(2) + vec(2) * di(1) + vec(1) * vec(2) * s
      qj(4) = vec(1) * di(3) + vec(3) * di(1) + vec(1) * vec(3) * s
      qj(5) = vec(2) * di(3) + vec(3) * di(2) + vec(2) * vec(3) * s
      ! Now collect the trace of the shift contribution
      tr = 0.5_wp * (qj(1) + qj(3) + qj(6))

      ! Finally, assemble the quadrupole operator on the Bra function from the operator
      ! on the Ket function and the traceless shift contribution
      qj(1) = qi(1) + 1.5_wp * qj(1) - tr
      qj(2) = qi(2) + 1.5_wp * qj(2)
      qj(3) = qi(3) + 1.5_wp * qj(3) - tr
      qj(4) = qi(4) + 1.5_wp * qj(4)
      qj(5) = qi(5) + 1.5_wp * qj(5)
      qj(6) = qi(6) + 1.5_wp * qj(6) - tr
   end subroutine shift_operator

#endif
end module xtb_ptb_integrals

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Restart file for calculations with tblite library
module xtb_tblite_restart
   use xtb_mctc_accuracy, only : wp, i8
   use xtb_type_environment, only : TEnvironment
   use xtb_type_restart, only : TRestart
   implicit none
   private

   public :: loadRestart, dumpRestart

contains

!> Load restart file
subroutine loadRestart(env, chk, fname, success)
   !> Computational environment
   type(TEnvironment), intent(inout) :: env
   !> Restart file
   type(TRestart), intent(inout) :: chk
   !> File name
   character(len=*), intent(in) :: fname
   !> Successfully loaded restart
   logical, intent(out) :: success

#if WITH_TBLITE
   external :: open_binary, close_file
   integer :: io, info
   integer(i8) :: version, dummy, nat, nsh, nel, nuhf

   ! call env%io%readBinary(io, fname)
   call open_binary(io, fname, "r")
   if (io == -1) then
      return
   end if

   read(io, iostat=info) &
      version, dummy, nat, nsh, nel, nuhf

   if (info == 0 &
      .and. nat == size(chk%tblite%n0at, kind=kind(nat)) &
      .and. nsh == size(chk%tblite%n0sh, kind=kind(nsh))) then
      read(io, iostat=info) chk%tblite%qsh
      if (version >= 2) then
         if (info == 0) &
            read(io, iostat=info) chk%tblite%dpat
         if (info == 0) &
            read(io, iostat=info) chk%tblite%qpat
      end if
   end if

   success = info == 0
   ! call env%io%closeFile(io)
   call close_file(io)
#else
   call feature_not_implemented(env)
#endif
end subroutine loadRestart

!> Dump restart file
subroutine dumpRestart(env, chk, fname)
   !> Computational environment
   type(TEnvironment), intent(inout) :: env
   !> Restart file
   type(TRestart), intent(inout) :: chk
   !> File name
   character(len=*), intent(in) :: fname

#if WITH_TBLITE
   external :: open_binary, close_file
   integer :: io

   ! call env%io%writeBinary(io, fname)
   call open_binary(io, fname, "w")
   if (io == -1) then
      return
   end if

   write(io) &
      2_i8, &
      0_i8, &
      size(chk%tblite%n0at, kind=i8), &
      size(chk%tblite%n0sh, kind=i8), &
      nint(chk%tblite%nocc, i8), &
      nint(chk%tblite%nuhf, i8)

   write(io) chk%tblite%qsh

   ! Always write multipole moments
   write(io) chk%tblite%dpat
   write(io) chk%tblite%qpat

   ! call env%io%closeFile(io)
   call close_file(io)
#else
   call feature_not_implemented(env)
#endif
end subroutine dumpRestart


#if ! WITH_TBLITE
subroutine feature_not_implemented(env)
   !> Computational environment
   type(TEnvironment), intent(inout) :: env

   call env%error("Compiled without support for tblite library")
end subroutine feature_not_implemented
#endif

end module xtb_tblite_restart

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Simple algebraic functions
module xtb_mctc_math
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_lapack, only : lapack_syev
   use xtb_mctc_constants, only : twothirdpi
   implicit none
   private

   public :: matDet3x3, matInv3x3, crossProd, derivDet3x3, eigval3x3, eigvec3x3


contains


!> Performs a direct calculation of the inverse of a 3×3 matrix.
!
!  reference: http://fortranwiki.org/fortran/show/Matrix+inversion
pure function matInv3x3(a) result(b)

   !> Matrix
   real(wp), intent(in) :: a(3, 3)

   !> Inverse matrix
   real(wp) :: b(3, 3)

   real(wp) :: detinv

   ! Calculate the inverse determinant of the matrix
   detinv = 1.0_wp/matDet3x3(a)

   ! Calculate the inverse of the matrix
   b(1, 1) = +detinv * (a(2, 2) * a(3, 3) - a(2, 3) * a(3, 2))
   b(2, 1) = -detinv * (a(2, 1) * a(3, 3) - a(2, 3) * a(3, 1))
   b(3, 1) = +detinv * (a(2, 1) * a(3, 2) - a(2, 2) * a(3, 1))
   b(1, 2) = -detinv * (a(1, 2) * a(3, 3) - a(1, 3) * a(3, 2))
   b(2, 2) = +detinv * (a(1, 1) * a(3, 3) - a(1, 3) * a(3, 1))
   b(3, 2) = -detinv * (a(1, 1) * a(3, 2) - a(1, 2) * a(3, 1))
   b(1, 3) = +detinv * (a(1, 2) * a(2, 3) - a(1, 3) * a(2, 2))
   b(2, 3) = -detinv * (a(1, 1) * a(2, 3) - a(1, 3) * a(2, 1))
   b(3, 3) = +detinv * (a(1, 1) * a(2, 2) - a(1, 2) * a(2, 1))

end function matInv3x3


!> Determinat of 3×3 matrix
pure function matDet3x3(a) result (det)

   !> Matrix
   real(wp), intent(in) :: a(3, 3)

   !> Determinant
   real(wp) :: det

   det =  a(1, 1) * a(2, 2) * a(3, 3)  &
      & - a(1, 1) * a(2, 3) * a(3, 2)  &
      & - a(1, 2) * a(2, 1) * a(3, 3)  &
      & + a(1, 2) * a(2, 3) * a(3, 1)  &
      & + a(1, 3) * a(2, 1) * a(3, 2)  &
      & - a(1, 3) * a(2, 2) * a(3, 1)

end function matDet3x3


!> Derivative of determinant of a 3x3 matrix
subroutine derivDet3x3(deriv, mat)

   !> derivative of the determinant
   real(wp), intent(out) :: deriv(3, 3)

   !> The matrix from which to calculate the determinant.
   real(wp), intent(in) :: mat(3, 3)

   deriv(1, 1) = mat(2, 2) * mat(3, 3) - mat(3, 2) * mat(2, 3)
   deriv(1, 2) = mat(2, 3) * mat(3, 1) - mat(3, 3) * mat(2, 1)
   deriv(1, 3) = mat(2, 1) * mat(3, 2) - mat(3, 1) * mat(2, 2)
   deriv(2, 1) = mat(1, 3) * mat(3, 2) - mat(1, 2) * mat(3, 3)
   deriv(2, 2) = mat(1, 1) * mat(3, 3) - mat(1, 3) * mat(3, 1)
   deriv(2, 3) = mat(1, 2) * mat(3, 1) - mat(1, 1) * mat(3, 2)
   deriv(3, 1) = mat(1, 2) * mat(2, 3) - mat(1, 3) * mat(2, 2)
   deriv(3, 2) = mat(1, 3) * mat(2, 1) - mat(1, 1) * mat(2, 3)
   deriv(3, 3) = mat(1, 1) * mat(2, 2) - mat(1, 2) * mat(2, 1)

   deriv = deriv * sign(1.0_wp, matDet3x3(mat))

end subroutine derivDet3x3


!> Implements the cross/vector product between two 3D vectors
pure function crossProd(a,b) result(c)

   !> First vector
   real(wp), intent(in) :: a(3)

   !> Second vector
   real(wp), intent(in) :: b(3)

   !> Orthogonal vector
   real(wp) :: c(3)

   c(1) = a(2) * b(3) - b(2) * a(3)
   c(2) = a(3) * b(1) - b(3) * a(1)
   c(3) = a(1) * b(2) - b(1) * a(2)

end function crossProd


!> Calculates eigenvalues based on the trigonometric solution of A = pB + qI
pure subroutine eigval3x3(a, w)

   !> The symmetric input matrix
   real(wp), intent(in) :: a(3, 3)

   !> Contains eigenvalues on exit
   real(wp), intent(out) :: w(3)

   real(wp) :: q, p, r

   r = a(1, 2) * a(1, 2) + a(1, 3) * a(1, 3) + a(2, 3) * a(2, 3)
   q = (a(1, 1) + a(2, 2) + a(3, 3)) / 3.0_wp
   w(1) = a(1, 1) - q
   w(2) = a(2, 2) - q
   w(3) = a(3, 3) - q
   p = sqrt((w(1) * w(1) + w(2) * w(2) + w(3) * w(3) + 2*r) / 6.0_wp)
   r = (w(1) * (w(2) * w(3) - a(2, 3) * a(2, 3)) &
      & - a(1, 2) * (a(1, 2) * w(3) - a(2, 3) * a(1, 3)) &
      & + a(1, 3) * (a(1, 2) * a(2, 3) - w(2) * a(1, 3))) / (p*p*p) * 0.5_wp

   if (r <= -1.0_wp) then
      r = 0.5_wp * twothirdpi
   else if (r >= 1.0_wp) then
      r = 0.0_wp
   else
      r = acos(r) / 3.0_wp
   end if

   w(3) = q + 2 * p * cos(r)
   w(1) = q + 2 * p * cos(r + twothirdpi)
   w(2) = 3 * q - w(1) - w(3)

end subroutine eigval3x3


!> Calculates eigenvector using an analytical method based on vector cross
!  products.
pure subroutine eigvec3x3(a, w, q)
   ! .. Arguments ..
   real(wp), intent(inout) :: a(3,3)
   real(wp), intent(out) :: w(3)
   real(wp), intent(out) :: q(3,3)

   real(wp), parameter :: eps = epsilon(1.0_wp)
   ! .. Local Variables ..
   real(wp) norm, n1, n2, n3, precon
   integer   i, j

   w(1) = max(abs(a(1, 1)), abs(a(1, 2)))
   w(2) = max(abs(a(1, 3)), abs(a(2, 2)))
   w(3) = max(abs(a(2, 3)), abs(a(3, 3)))
   precon = max(w(1), max(w(2), w(3)))

   ! null matrix
   if (precon < eps) then
      w(1) = 0.0_wp
      w(2) = 0.0_wp
      w(3) = 0.0_wp
      q(1, 1) = 1.0_wp
      q(2, 2) = 1.0_wp
      q(3, 3) = 1.0_wp
      q(1, 2) = 0.0_wp
      q(1, 3) = 0.0_wp
      q(2, 3) = 0.0_wp
      q(2, 1) = 0.0_wp
      q(3, 1) = 0.0_wp
      q(3, 2) = 0.0_wp
      return
   end if

   norm = 1.0_wp / precon

   a(1, 1) = a(1, 1) * norm
   a(1, 2) = a(1, 2) * norm
   a(2, 2) = a(2, 2) * norm
   a(1, 3) = a(1, 3) * norm
   a(2, 3) = a(2, 3) * norm
   a(3, 3) = a(3, 3) * norm

   ! Calculate eigenvalues
   call eigval3x3(a, w)

   ! Compute first eigenvector
   a(1, 1) = a(1, 1) - w(1)
   a(2, 2) = a(2, 2) - w(1)
   a(3, 3) = a(3, 3) - w(1)

   q(1, 1) = a(1, 2) * a(2, 3) - a(1, 3) * a(2, 2)
   q(2, 1) = a(1, 3) * a(1, 2) - a(1, 1) * a(2, 3)
   q(3, 1) = a(1, 1) * a(2, 2) - a(1, 2) * a(1, 2)
   q(1, 2) = a(1, 2) * a(3, 3) - a(1, 3) * a(2, 3)
   q(2, 2) = a(1, 3) * a(1, 3) - a(1, 1) * a(3, 3)
   q(3, 2) = a(1, 1) * a(2, 3) - a(1, 2) * a(1, 3)
   q(1, 3) = a(2, 2) * a(3, 3) - a(2, 3) * a(2, 3)
   q(2, 3) = a(2, 3) * a(1, 3) - a(1, 2) * a(3, 3)
   q(3, 3) = a(1, 2) * a(2, 3) - a(2, 2) * a(1, 3)
   n1 = q(1, 1) * q(1, 1) + q(2, 1) * q(2, 1) + q(3, 1) * q(3, 1)
   n2 = q(1, 2) * q(1, 2) + q(2, 2) * q(2, 2) + q(3, 2) * q(3, 2)
   n3 = q(1, 3) * q(1, 3) + q(2, 3) * q(2, 3) + q(3, 3) * q(3, 3)

   norm = n1
   i = 1
   if (n2 > norm) then
      i = 2
      norm = n1
   end if
   if (n3 > norm) then
      i = 3
   end if

   if (i == 1) then
      norm = sqrt(1.0_wp / n1)
      q(1, 1) = q(1, 1) * norm
      q(2, 1) = q(2, 1) * norm
      q(3, 1) = q(3, 1) * norm
   else if (i == 2) then
      norm = sqrt(1.0_wp / n2)
      q(1, 1) = q(1, 2) * norm
      q(2, 1) = q(2, 2) * norm
      q(3, 1) = q(3, 2) * norm
   else
      norm = sqrt(1.0_wp / n3)
      q(1, 1) = q(1, 3) * norm
      q(2, 1) = q(2, 3) * norm
      q(3, 1) = q(3, 3) * norm
   end if

   ! Robustly compute a right-hand orthonormal set (ev1, u, v)
   if (abs(q(1, 1)) > abs(q(2, 1))) then
      norm = sqrt(1.0_wp / (q(1, 1) * q(1, 1) + q(3, 1) * q(3, 1)))
      q(1, 2) = -q(3, 1) * norm
      q(2, 2) = 0.0_wp
      q(3, 2) = +q(1, 1) * norm
   else
      norm = sqrt(1.0_wp / (q(2, 1) * q(2, 1) + q(3, 1) * q(3, 1)))
      q(1, 2) = 0.0_wp
      q(2, 2) = +q(3, 1) * norm
      q(3, 2) = -q(2, 1) * norm
   end if
   q(1, 3) = q(2, 1) * q(3, 2) - q(3, 1) * q(2, 2)
   q(2, 3) = q(3, 1) * q(1, 2) - q(1, 1) * q(3, 2)
   q(3, 3) = q(1, 1) * q(2, 2) - q(2, 1) * q(1, 2)

   ! Reset A
   a(1, 1) = a(1, 1) + w(1)
   a(2, 2) = a(2, 2) + w(1)
   a(3, 3) = a(3, 3) + w(1)

   ! A*U
   n1 = a(1, 1) * q(1, 2) + a(1, 2) * q(2, 2) + a(1, 3) * q(3, 2)
   n2 = a(1, 2) * q(1, 2) + a(2, 2) * q(2, 2) + a(2, 3) * q(3, 2)
   n3 = a(1, 3) * q(1, 2) + a(2, 3) * q(2, 2) + a(3, 3) * q(3, 2)

   ! A*V, note out of order computation
   a(3, 3) = a(1, 3) * q(1, 3) + a(2, 3) * q(2, 3) + a(3, 3) * q(3, 3)
   a(1, 3) = a(1, 1) * q(1, 3) + a(1, 2) * q(2, 3) + a(1, 3) * q(3, 3)
   a(2, 3) = a(1, 2) * q(1, 3) + a(2, 2) * q(2, 3) + a(2, 3) * q(3, 3)

   ! UT*(A*U) - l2*E
   n1 = q(1, 2) * n1 + q(2, 2) * n2 + q(3, 2) * n3 - w(2)
   ! UT*(A*V)
   n2 = q(1, 2) * a(1, 3) + q(2, 2) * a(2, 3) + q(3, 2) * a(3, 3)
   ! VT*(A*V) - l2*E
   n3 = q(1, 3) * a(1, 3) + q(2, 3) * a(2, 3) + q(3, 3) * a(3, 3) - w(2)

   if (abs(n1) >= abs(n3)) then
      norm = max(abs(n1), abs(n2))
      if (norm > eps) then
         if (abs(n1) >= abs(n2)) then
            n2 = n2 / n1
            n1 = sqrt(1.0_wp / (1.0_wp + n2 * n2))
            n2 = n2 * n1
         else
            n1 = n1 / n2
            n2 = sqrt(1.0_wp / (1.0_wp + n1 * n1))
            n1 = n1 * n2
         end if
         q(1, 2) = n2 * q(1, 2) - n1 * q(1, 3)
         q(2, 2) = n2 * q(2, 2) - n1 * q(2, 3)
         q(3, 2) = n2 * q(3, 2) - n1 * q(3, 3)
      end if
   else
      norm = max(abs(n3), abs(n2))
      if (norm > eps) then
         if (abs(n3) >= abs(n2)) then
            n2 = n2 / n3
            n3 = sqrt(1.0_wp / (1.0_wp + n2 * n2))
            n2 = n2 * n3
         else
            n3 = n3 / n2
            n2 = sqrt(1.0_wp / (1.0_wp + n3 * n3))
            n3 = n3 * n2
         end if
         q(1, 2) = n3 * q(1, 2) - n2 * q(1, 3)
         q(2, 2) = n3 * q(2, 2) - n2 * q(2, 3)
         q(3, 2) = n3 * q(3, 2) - n2 * q(3, 3)
      end if
   end if

   ! Calculate third eigenvector from cross product
   q(1, 3) = q(2, 1) * q(3, 2) - q(3, 1) * q(2, 2)
   q(2, 3) = q(3, 1) * q(1, 2) - q(1, 1) * q(3, 2)
   q(3, 3) = q(1, 1) * q(2, 2) - q(2, 1) * q(1, 2)

   w(1) = w(1) * precon
   w(2) = w(2) * precon
   w(3) = w(3) * precon

end subroutine eigvec3x3


end module xtb_mctc_math

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine getring36(n,at,nbin,a0_in,cout,irout)
      implicit none
      integer cout(10,20),irout(20)  ! output: atomlist, ringsize, # of rings in irout(20)
      integer at(n)
      integer n,nbin(20,n),a0,i,nb(20,n),a0_in
      integer    i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
      integer n0,n1,n2,n3,n4,n5,n6,n7,n8,n9,n10
      integer    a1,a2,a3,a4,a5,a6,a7,a8,a9,a10
      integer list(n),m,mm,nn,c(10),cdum(10,600),iring
      integer adum1(0:n),adum2(0:n),kk,j,idum(600),same(600),k
      real*8  w(n),av,sd
      logical chkrng

      if(n.le.2) return

      nn=nbin(20,a0_in)

      cdum=0
      kk=0
      do m=1,nn
!     if(nb(m,a0_in).eq.1) cycle
      nb=nbin
      do i=1,n
         if(nb(20,i).eq.1)nb(20,i)=0
      enddo

      do mm=1,nn
         w(mm)=dble(mm)
         list(mm)=mm
      enddo
      w(m)   =0.0d0
      call ssort(nn,w,list)
      do mm=1,nn
         nb(mm,a0_in)=nbin(list(mm),a0_in)
      enddo

      iring =0
      c     =0

      a0=a0_in
      n0=nb(20,a0)

      do i1=1,n0
         a1=nb(i1,a0)
         if(a1.eq.a0) cycle
         n1=nb(20,a1)
         do i2=1,n1
            a2=nb(i2,a1)
            if(a2.eq.a1) cycle
            n2=nb(20,a2)
            do i3=1,n2
               a3=nb(i3,a2)
               n3=nb(20,a3)
               if(a3.eq.a2) cycle
               c(1)=a1
               c(2)=a2
               c(3)=a3
               if(a3.eq.a0.and.chkrng(n,3,c))then
                iring=3
                kk=kk+1
                cdum(1:iring,kk)=c(1:iring)
                idum(kk)=iring
               endif
               do i4=1,n3
                  a4=nb(i4,a3)
                  n4=nb(20,a4)
                  if(a4.eq.a3) cycle
                  c(4)=a4
                  if(a4.eq.a0.and.chkrng(n,4,c))then
                   iring=4
                   kk=kk+1
                   cdum(1:iring,kk)=c(1:iring)
                   idum(kk)=iring
                  endif
                  do i5=1,n4
                     a5=nb(i5,a4)
                     n5=nb(20,a5)
                     if(a5.eq.a4) cycle
                     c(5)=a5
                     if(a5.eq.a0.and.chkrng(n,5,c))then
                      iring=5
                      kk=kk+1
                      cdum(1:iring,kk)=c(1:iring)
                      idum(kk)=iring
                     endif
                     do i6=1,n5
                        a6=nb(i6,a5)
                        n6=nb(20,a6)
                        if(a6.eq.a5) cycle
                        c(6)=a6
                        if(a6.eq.a0.and.chkrng(n,6,c))then
                         iring=6
                         kk=kk+1
                         cdum(1:iring,kk)=c(1:iring)
                         idum(kk)=iring
                        endif
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo


 99   continue

      enddo

! compare
      same=0
      do i=1,kk
         do j=i+1,kk
            if(idum(i).ne.idum(j)) cycle ! different ring size
            if(same(j).eq.1      ) cycle ! already double
            adum1=0
            adum2=0
            do m=1,10
               i1=cdum(m,i)
               i2=cdum(m,j)
               adum1(i1)=1
               adum2(i2)=1
            enddo
            if(sum(abs(adum1-adum2)).ne.0) then
                  same(j)=0
            else
                  same(j)=1
            endif
         enddo
      enddo

      m=0
      do i=1,kk
         if(same(i).eq.0) then
            m=m+1
            if(m.gt.20) stop 'too many rings'
            irout(m)=idum(i)     ! number of atoms in ring m
            nn=idum(i)
            cout(1:nn,m)=cdum(1:nn,i)
            i2=0
            do k=1,nn            ! determine if its a hetereo
               i1=at(cdum(k,i))
               i2=i2+i1
            enddo
            av=dble(i2)/dble(nn)
            sd=0
            cout(m,19)=0
            do k=1,nn
               i1=at(cdum(k,i))
               sd=sd+(av-dble(i1))**2
            enddo
            if(sd.gt.1.d-6) cout(m,19)=idint(1000.*sqrt(sd)/dble(nn))
         endif
      enddo
      irout(20)=m  ! number of rings for this atom

      return
      end

      subroutine ssort(n,edum,ind)
      implicit none
      integer n,ii,k,j,m,i,sc1
      real*8 edum(n),pp
      integer ind(n)

      do 140   ii = 2, n
         i = ii - 1
         k = i
         pp= edum(i)
         do 120   j = ii, n
            if (edum(j) .gt. pp) go to 120
            k = j
            pp= edum(j)
  120    continue
         if (k .eq. i) go to 140
         edum(k) = edum(i)
         edum(i) = pp
         sc1=ind(i)
         ind(i)=ind(k)
         ind(k)=sc1
  140 continue

      end

! This file is part of ancopt.
! SPDX-Identifier: LGPL-3.0-or-later
!
! ancopt is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! ancopt is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with ancopt.  If not, see <https://www.gnu.org/licenses/>.

module xtb_pbc_optimizer_filter
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule
   use xtb_pbc_optimizer_filter_cart, only : cartesian_filter, new_cartesian_filter
   !use xtb_pbc_optimizer_filter_anc, only : anc_input
   !use ancopt_filter_cartesian, only : cartesian_filter, new_cartesian_filter
   use xtb_pbc_optimizer_filter_type, only : filter_type
   implicit none
   private

   public :: filter_type, filter_input, new_filter

   type :: filter_input
      !type(anc_input), allocatable :: anc
      logical :: optcell = .false.
   end type filter_input

contains


subroutine new_filter(self, mol, input)
   !> Instance of the transformation filter
   class(filter_type), allocatable, intent(out) :: self
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol
   !> Input to generate transformation filter from
   type(filter_input), intent(in) :: input

   call new_cartesian_filter_(self, mol, input%optcell)

end subroutine new_filter


subroutine new_cartesian_filter_(self, mol, optcell)
   !> Instance of the transformation filter
   class(filter_type), allocatable, intent(out) :: self
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol
   !> Relax lattice parameters
   logical, intent(in) :: optcell

   type(cartesian_filter), allocatable :: new

   allocate(new)
   call new_cartesian_filter(new, mol, optcell .and. any(mol%pbc))
   call move_alloc(new, self)
end subroutine new_cartesian_filter_


end module xtb_pbc_optimizer_filter

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of coulombic interaction evaluator
!
!  This is the base class implementing a point charge electrostatics for all
!  supported boundary conditions
module xtb_type_coulomb
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_boundaryconditions, only : boundaryCondition
   use xtb_mctc_constants, only : pi, sqrtpi
   use xtb_mctc_math, only : matInv3x3, matDet3x3
   use xtb_coulomb_ewald
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_wignerseitzcell, only : TWignerSeitzCell, init
   implicit none
   private

   public :: TCoulomb, init
   public :: setupBoundaryConditions, setupIndexTable


   !> Base point charge electrostatics evaluator
   type :: TCoulomb

      !> Number of atoms
      integer :: natom

      !> Boundary conditions for this Coulomb evaluator
      integer :: boundaryCondition

      !> Index table to map to shells
      integer, allocatable :: itbl(:, :)

      !> Ewald tolerance
      real(wp) :: tolerance

      !> Convergence factor for Ewald summation
      real(wp) :: alpha

      !> Real space lattice translations
      type(TLatticePoint) :: rLatPoint

      !> Reciprocal space lattice translations
      type(TLatticePoint) :: gLatPoint

      !> Wigner-Seitz cell for periodic boundary conditions
      type(TWignerSeitzCell) :: wsCell

      !> Real space lattice translations
      real(wp), allocatable :: rTrans(:, :)

      !> Reciprocal space lattice translations
      real(wp), allocatable :: gTrans(:, :)

      !> Real space cutoff
      real(wp) :: rCutoff

      !> Reciprocal space cutoff
      real(wp) :: gCutoff

   contains

      !> Update internal state
      procedure :: update

      !> Returns full Coulomb matrix
      procedure :: getCoulombMatrix

      !> Returns derivatives of Coulomb matrix
      procedure :: getCoulombDerivs

   end type TCoulomb


   interface init
      module procedure :: initFromMolecule
      module procedure :: initCoulomb
   end interface init


contains


subroutine initFromMolecule(self, env, mol, num, nshell, alpha, tolerance)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_coulomb_initFromMolecule'

   !> Instance of the Coulomb evaluator
   type(TCoulomb), intent(out) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   !> Number of shell for each species
   integer, intent(in), optional :: nshell(:)

   !> Convergence factor
   real(wp), intent(in), optional :: alpha

   !> Tolerance for the Ewald sum
   real(wp), intent(in), optional :: tolerance

   logical :: exitRun

   call init(self, env, mol%id, mol%lattice, mol%boundaryCondition, num, nshell, &
      & alpha, tolerance)

   call env%check(exitRun)
   if (exitRun) return

   call self%update(env, mol)
   call env%check(exitRun)
   if (exitRun) then
      call env%error("Initializing internal state of evaluator failed", source)
   end if

end subroutine initFromMolecule


subroutine initCoulomb(self, env, id, lattice, boundaryCond, num, nshell, alpha, &
      & tolerance)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_coulomb_initCoulomb'

   !> Instance of the Coulomb evaluator
   type(TCoulomb), intent(out) :: self

   !> Identity of each atom
   integer, intent(in) :: id(:)

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)

   !> Boundary conditions for this evaluator
   integer, intent(in) :: boundaryCond

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   !> Number of shell for each species
   integer, intent(in), optional :: nshell(:)

   !> Convergence factor
   real(wp), intent(in), optional :: alpha

   !> Tolerance for the Ewald sum
   real(wp), intent(in), optional :: tolerance

   logical :: exitRun

   self%boundaryCondition = boundaryCond
   self%natom = size(id, dim=1)

   call setupIndexTable(self%natom, self%itbl, id, num, nshell)

   call setupBoundaryConditions(self, env, lattice, alpha, tolerance)

end subroutine initCoulomb


subroutine setupIndexTable(natom, itbl, id, num, nshell)

   !> Number of atoms
   integer, intent(in) :: natom

   !> Index table
   integer, allocatable, intent(out) :: itbl(:, :)

   !> Identity of each atom
   integer, intent(in) :: id(:)

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   !> Number of shell for each species
   integer, intent(in), optional :: nshell(:)

   integer :: ind, iat, ish

   allocate(itbl(2, natom))
   if (present(nshell)) then
      ind = 0
      if (present(num)) then
         do iat = 1, natom
            ish = nshell(num(id(iat)))
            itbl(:, iat) = [ind, ish]
            ind = ind + ish
         end do
      else
         do iat = 1, natom
            ish = nshell(id(iat))
            itbl(:, iat) = [ind, ish]
            ind = ind + ish
         end do
      end if
   else
      do iat = 1, natom
         itbl(:, iat) = [iat-1, 1]
      end do
   end if

end subroutine setupIndexTable


subroutine setupBoundaryConditions(self, env, lattice, alpha, tolerance)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_coulomb_setupBoundaryConditions'

   !> Instance of the Coulomb evaluator
   class(TCoulomb), intent(inout) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)

   !> Convergence factor
   real(wp), intent(in), optional :: alpha

   !> Tolerance for the Ewald sum
   real(wp), intent(in), optional :: tolerance

   logical :: exitRun
   real(wp) :: volume, recLat(3, 3)

   select case(self%boundaryCondition)
   case default
      call env%error("Boundary condition not supported", source)
   case(boundaryCondition%cluster)
      ! nothing to do
   case(boundaryCondition%pbc3d)
      volume = abs(matDet3x3(lattice))
      recLat(:, :) = 2*pi*transpose(matInv3x3(lattice))

      if (present(tolerance)) then
         self%tolerance = tolerance
      else
         self%tolerance = 1.0e-8_wp
      end if

      if (present(alpha)) then
         self%alpha = alpha
      else
         call getOptimalAlpha(env, lattice, recLat, volume, self%tolerance, &
            & self%alpha)
      end if

      call getMaxR(env, self%alpha, self%tolerance, self%rCutoff)
      call getMaxG(env, self%alpha, volume, self%tolerance, self%gCutoff)

      call env%check(exitRun)
      if (exitRun) then
         call env%error("Could not setup numerical thresholds", source)
         return
      end if

      call init(self%rLatPoint, env, lattice, self%boundaryCondition, self%rCutoff)
      call init(self%gLatPoint, env, recLat, self%boundaryCondition, self%gCutoff)
      call init(self%wsCell, self%natom)
   end select

end subroutine setupBoundaryConditions


!> Update internal state of the Coulomb evaluator
subroutine update(self, env, mol)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_coulomb_update'

   !> Instance of the Coulomb evaluator
   class(TCoulomb), intent(inout) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   integer :: nTransOld
   logical :: exitRun

   !> No need for updates in case of cluster calculations
   if (self%boundaryCondition == boundaryCondition%cluster) return

   call self%rLatPoint%update(env, mol%lattice)
   call self%gLatPoint%update(env, mol%rec_lat)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Could not update lattice points", source)
      return
   end if

   if (allocated(self%rTrans)) then
      nTransOld = size(self%rTrans)
   else
      nTransOld = 0
   end if
   call self%rLatPoint%getLatticePoints(self%rTrans)
   call self%gLatPoint%getLatticePoints(self%gTrans)
   if (size(self%rTrans) /= nTransOld) then
      call self%wsCell%generate(env, mol%xyz, self%rCutoff, self%rTrans, .false.)

      call env%check(exitRun)
      if (exitRun) then
         call env%error("Failed to generate Wigner-Seitz cell", source)
         return
      end if
   else
      call self%wsCell%update(mol%xyz, self%rTrans)
   end if

end subroutine update


subroutine getCoulombMatrix(self, mol, jmat)

   !> Instance of the Coulomb evaluator
   class(TCoulomb), intent(inout) :: self

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   select case(self%boundaryCondition)
   case(boundaryCondition%cluster)
      call getCoulombMatrixCluster(mol, self%itbl, jmat)
   case(boundaryCondition%pbc3d)
      call getCoulombMatrixPBC3D(self%wsCell, self%itbl, self%alpha, &
         & mol%volume, self%rTrans, self%gTrans(:, 2:), jmat)
   end select

end subroutine getCoulombMatrix


subroutine getCoulombMatrixCluster(mol, itbl, jmat)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   integer :: iat, jat, ish, jsh, ii, jj
   real(wp) :: r1, rterm

   jmat(:, :) = 0.0_wp

   !$omp parallel do default(none) shared(mol, itbl, jmat) &
   !$omp private(iat, jat, ish, jsh, ii, jj, r1, rterm)
   do iat = 1, len(mol)
      ii = itbl(1, iat)
      do jat = 1, iat-1
         jj = itbl(1, jat)
         r1 = sqrt(sum((mol%xyz(:, jat) - mol%xyz(:, iat))**2))
         rterm = 1.0_wp/r1
         do ish = 1, itbl(2, iat)
            do jsh = 1, itbl(2, jat)
               jmat(jj+jsh, ii+ish) = rterm
               jmat(ii+ish, jj+jsh) = rterm
            end do
         end do
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombMatrixCluster


subroutine getCoulombMatrixPBC3D(wsCell, itbl, alpha, volume, rTrans,  gTrans, &
      & jmat)

   !> Wigner-Seitz cell
   type(TWignerSeitzCell), intent(in) :: wsCell

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Cell volume
   real(wp), intent(in) :: volume

   !> Convergence factor
   real(wp), intent(in) :: alpha

   !> Real space lattice translations
   real(wp), intent(in) :: rTrans(:, :)

   !> Reciprocal space lattice translations
   real(wp), intent(in) :: gTrans(:, :)

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   integer :: iat, ineigh, img, jat, ish, jsh, ii, jj
   real(wp) :: vec(3), rterm, weight
   real(wp), parameter :: zero(3) = 0.0_wp

   jmat(:, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:jmat) &
   !$omp shared(wsCell, itbl, alpha, volume, gTrans, rTrans) &
   !$omp private(iat, ineigh, img, jat, ish, jsh, ii, jj, rterm, vec, weight)
   do iat = 1, size(wsCell%neighs)
      ii = itbl(1, iat)
      do ineigh = 1, wsCell%neighs(iat)
         img = wsCell%ineigh(ineigh, iat)
         jat = wsCell%image(img)
         jj = itbl(1, jat)
         weight = wsCell%weight(ineigh, iat)
         vec(:) = wsCell%coords(:, img) - wsCell%coords(:, iat)
         rterm = ewaldMatPBC3D(vec, gTrans, 0.0_wp, volume, alpha, weight) &
            &  + getRTerm(vec, rTrans, alpha, weight) &
            &  - pi / (volume * alpha**2) * weight
         if (iat /= jat) then
            do ish = 1, itbl(2, iat)
               do jsh = 1, itbl(2, jat)
                  jmat(jj+jsh, ii+ish) = jmat(jj+jsh, ii+ish) + rterm
                  jmat(ii+ish, jj+jsh) = jmat(ii+ish, jj+jsh) + rterm
               end do
            end do
         else
            do ish = 1, itbl(2, iat)
               do jsh = 1, ish-1
                  jmat(ii+jsh, ii+ish) = jmat(ii+jsh, ii+ish) + rterm
                  jmat(ii+ish, ii+jsh) = jmat(ii+ish, ii+jsh) + rterm
               end do
               jmat(ii+ish, ii+ish) = jmat(ii+ish, ii+ish) + rterm
            end do
         end if
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombMatrixPBC3D


pure function getRTerm(vec, rTrans, alpha, scale) result(rTerm)
   real(wp),intent(in) :: vec(3)
   real(wp),intent(in) :: rTrans(:,:)
   real(wp),intent(in) :: alpha
   real(wp),intent(in) :: scale
   real(wp) :: rTerm
   real(wp),parameter :: eps = 1.0e-9_wp
   integer  :: itr
   real(wp) :: r1, rij(3)
   rTerm = 0.0_wp
   do itr = 1, size(rTrans, dim=2)
      rij = vec + rTrans(:, itr)
      r1 = norm2(rij)
      ! self-interaction correction
      if(r1 < eps) then
         rTerm = rTerm - 2.0_wp*alpha/sqrtpi
      else
         rTerm = rTerm + erfc(alpha*r1)/r1
      end if
   end do
   rTerm = rTerm * scale
end function getRTerm


subroutine getCoulombDerivs(self, mol, qvec, djdr, djdtr, djdL)

   !> Instance of the Coulomb evaluator
   class(TCoulomb), intent(inout) :: self

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   !> Derivative of Coulomb matrix w.r.t. strain deformations
   real(wp), intent(out) :: djdL(:, :, :)

   select case(self%boundaryCondition)
   case(boundaryCondition%cluster)
      call getCoulombDerivsCluster(mol, self%itbl, qvec, djdr, djdtr, djdL)
   case(boundaryCondition%pbc3d)
      call getCoulombDerivsPBC3D(self%wsCell, self%itbl, self%alpha, mol%volume, &
         & self%rTrans, self%gTrans(:, 2:), qvec, djdr, djdtr, djdL)
   end select

end subroutine getCoulombDerivs


subroutine getCoulombDerivsCluster(mol, itbl, qvec, djdr, djdtr, djdL)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   !> Derivative of Coulomb matrix w.r.t. strain deformations
   real(wp), intent(out) :: djdL(:, :, :)

   integer :: iat, jat, ish, jsh, ii, jj
   real(wp) :: r1, vec(3), dG(3), dS(3, 3)

   djdr(:, :, :) = 0.0_wp
   djdtr(:, :) = 0.0_wp
   djdL(:, :, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:djdr, djdtr, djdL) &
   !$omp shared(mol, itbl, qvec) &
   !$omp private(iat, jat, ish, jsh, ii, jj, r1, vec, dG, dS)
   do iat = 1, len(mol)
      ii = itbl(1, iat)
      do jat = 1, iat-1
         jj = itbl(1, jat)
         vec(:) = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = norm2(vec)
         dG(:) = -vec/r1**3
         dS(:, :) = 0.5_wp * spread(dG, 1, 3) * spread(vec, 2, 3)
         do ish = 1, itbl(2, iat)
            do jsh = 1, itbl(2, jat)
               djdr(:, iat, jj+jsh) = djdr(:, iat, jj+jsh) - dG*qvec(ii+ish)
               djdr(:, jat, ii+ish) = djdr(:, jat, ii+ish) + dG*qvec(jj+jsh)
               djdtr(:, jj+jsh) = djdtr(:, jj+jsh) + dG*qvec(ii+ish)
               djdtr(:, ii+ish) = djdtr(:, ii+ish) - dG*qvec(jj+jsh)
               djdL(:, :, jj+jsh) = djdL(:, :, jj+jsh) + dS*qvec(ii+ish)
               djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(jj+jsh)
            end do
         end do
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombDerivsCluster


subroutine getCoulombDerivsPBC3D(wsCell, itbl, alpha, volume, rTrans, gTrans, &
      & qvec, djdr, djdtr, djdL)

   !> Wigner-Seitz cell
   type(TWignerSeitzCell), intent(in) :: wsCell

   !> Cell volume
   real(wp), intent(in) :: volume

   !> Convergence factor
   real(wp), intent(in) :: alpha

   !> Real space lattice translations
   real(wp), intent(in) :: rTrans(:, :)

   !> Reciprocal space lattice translations
   real(wp), intent(in) :: gTrans(:, :)

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   !> Derivative of Coulomb matrix w.r.t. strain deformations
   real(wp), intent(out) :: djdL(:, :, :)

   integer :: iat, jat, ish, jsh, ii, jj, ineigh, img
   real(wp) :: weight, vec(3), dG(3), dS(3, 3), dGg(3), dGr(3), dSg(3, 3), dSr(3, 3)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   djdr(:, :, :) = 0.0_wp
   djdtr(:, :) = 0.0_wp
   djdL(:, :, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:djdr, djdtr, djdL) &
   !$omp shared(wsCell, itbl, qvec, alpha, volume, gTrans, rTrans) &
   !$omp private(iat, ineigh, img, jat, ish, jsh, ii, jj, vec, weight, dG, dS,&
   !$omp& dGg, dGr, dSg, dSr)
   do iat = 1, size(wsCell%neighs)
      ii = itbl(1, iat)
      do ineigh = 1, wsCell%neighs(iat)
         img = wsCell%ineigh(ineigh, iat)
         jat = wsCell%image(img)
         jj = itbl(1, jat)
         weight = wsCell%weight(ineigh, iat)
         vec(:) = wsCell%coords(:, img) - wsCell%coords(:, iat)
         call ewaldDerivPBC3D(vec, gTrans, 0.0_wp, volume, alpha, weight, dGg, dSg)
         call getRDeriv(vec, rTrans, alpha, weight, dGr, dSr)
         dG(:) = dGg + dGr
         dS(:, :) = dSg + dSr + pi / (volume * alpha**2) * weight * unity
         if (iat /= jat) then
            do ish = 1, itbl(2, iat)
               do jsh = 1, itbl(2, jat)
                  djdr(:, iat, jj+jsh) = djdr(:, iat, jj+jsh) - dG*qvec(ii+ish)
                  djdr(:, jat, ii+ish) = djdr(:, jat, ii+ish) + dG*qvec(jj+jsh)
                  djdtr(:, jj+jsh) = djdtr(:, jj+jsh) + dG*qvec(ii+ish)
                  djdtr(:, ii+ish) = djdtr(:, ii+ish) - dG*qvec(jj+jsh)
                  djdL(:, :, jj+jsh) = djdL(:, :, jj+jsh) + dS*qvec(ii+ish)
                  djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(jj+jsh)
               end do
            end do
         else
            do ish = 1, itbl(2, iat)
               do jsh = 1, ish-1
                  djdL(:, :, ii+jsh) = djdL(:, :, ii+jsh) + dS*qvec(ii+ish)
                  djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(ii+jsh)
               end do
               djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(ii+ish)
            end do
         end if
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombDerivsPBC3D


pure subroutine getRDeriv(vec, rTrans, alpha, scale, dG, dS)
   real(wp), intent(in) :: vec(:)
   real(wp), intent(in) :: rTrans(:,:)
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: scale
   real(wp), intent(out) :: dG(:)
   real(wp), intent(out) :: dS(:,:)
   real(wp), parameter :: eps = 1.0e-9_wp
   integer :: itr
   real(wp) :: r1, rij(3), arg, dd
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   dG = 0.0_wp
   dS = 0.0_wp
   do itr = 1, size(rTrans, dim=2)
      ! real contributions
      rij = vec + rTrans(:, itr)
      r1 = norm2(rij)
      if (r1 < eps) cycle
      arg = alpha**2*r1**2
      dd = - 2*alpha*exp(-arg)/(sqrtpi*r1**2) - erfc(alpha*r1)/(r1**3)
      dG = dG + rij*dd
      dS = dS + 0.5_wp*dd*spread(rij, 1, 3)*spread(rij, 2, 3)
   enddo
   dG = dG * scale
   dS = dS * scale

end subroutine getRDeriv


end module xtb_type_coulomb

!------------------------------------------------------------------------------
! This file is part of xtb.
!
! Copyright (C) 2017-2019 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
! 2D => 3D structure converter, uses GFN-FF MD + OPT to generate a 3D structure
! of an 2 dimensional input structure.
!------------------------------------------------------------------------------
module xtb_gfnff_convert
contains

subroutine struc_convert( &
         & env,restart,mol,chk,egap,et,maxiter,maxcycle,&
         & etot,g,sigma)
  use xtb_mctc_accuracy, only : wp
  use xtb_gfnff_param
  use xtb_gfnff_setup
  use xtb_disp_dftd3param
  use xtb_type_environment
  use xtb_type_molecule
  use xtb_type_restart
  use xtb_gfnff_calculator, only : TGFFCalculator, newGFFCalculator
  use xtb_type_data
  use xtb_restart
  use xtb_setmod
  use xtb_setparam
  use xtb_dynamic
  use xtb_geoopt
  use xtb_readin, only : xfind
  implicit none
! Dummy -----------------------------------------------------------------------
  type(TEnvironment),intent(inout)            :: env
  type(TMolecule),intent(inout)               :: mol
  type(TRestart),intent(inout)                :: chk
  integer,intent(in)                          :: maxiter
  integer,intent(in)                          :: maxcycle
  real(wp),intent(inout)                      :: etot
  real(wp),intent(in)                         :: et
  real(wp),intent(inout)                      :: egap
  real(wp),intent(inout)                      :: g(3,mol%n)
  real(wp),intent(inout)                      :: sigma(3,3)
  logical,intent(in)                          :: restart
  character(len=:),allocatable                :: fnv
! Stack -----------------------------------------------------------------------
  type(TGFFCalculator)                        :: calc
  integer                                     :: ich
  integer                                     :: idum
  integer                                     :: mode_input
  real(wp)                                    :: time_in
  real(wp)                                    :: temp_in
  real(wp)                                    :: step_in
  real(wp)                                    :: dump_in
  real(wp)                                    :: hmass_in
  logical                                     :: exist
  logical                                     :: fail
  integer, allocatable :: opt_in
  character(len=*),parameter                  :: p_fname_param_gfnff = '.param_gfnff.xtb'
! loop geoopt -----------------------------------------------------------------
  integer                                     :: i, j
  integer, parameter                          :: num_shift_runs = 3
  real(wp), allocatable                       :: shift(:)
  real(wp), allocatable                       :: mol_xyz_arr(:,:,:)
  real(wp)                                    :: etot_arr(num_shift_runs)
  real(wp)                                    :: sign_threshold
  type(TMolecule)                             :: mol_shifted
  allocate(shift(mol%n), source=0.0_wp)
  allocate(mol_xyz_arr(3, mol%n, num_shift_runs), source=0.0_wp)
  etot_arr = 0.0_wp
!------------------------------------------------------------------------------
! set up force field
  call struc_convert_header(env%unit)
  if (allocated(set%opt_engine)) then
    opt_in = set%opt_engine
  end if
  set%opt_engine = p_engine_rf
  mode_input = set%mode_extrun
  set%mode_extrun = p_ext_gfnff
  if (.not.allocated(fnv)) fnv=xfind(p_fname_param_gfnff)
  call newGFFCalculator(env, mol, calc, fnv, restart, gffVersion%harmonic2020)

!===============================
! Set Block
  time_in  = set%time_md
  set%time_md  = 5.0_wp              ! short 5 ps MD to move it in 3D
  temp_in  = set%temp_md
  set%temp_md  = 298.0_wp            ! md temperature 298 K
  step_in  = set%tstep_md
  set%tstep_md = 2.5_wp              ! md time step 2.5 fs
  dump_in  = set%dump_md2
  set%dump_md2 = 100.0_wp            ! md dump 100 fs
  hmass_in = set%md_hmass
  set%md_hmass = 4.0_wp              ! md hydrogen mass
  set%nvt_md = .true.                ! md thermostat
!===============================
  if (allocated(set%opt_logfile)) then
    fnv = set%opt_logfile
  else
    deallocate(fnv)
  endif
  set%opt_logfile = 'convert.log'
!------------------------------------------------------------------------------
! force field geometry optimization
  ! loop runs 3 geoopt with different shifts in the new 3rd coordinate
  ! and then keeps the mol%xyz with lowest etot for md
  mol_shifted = mol
  do i=1, num_shift_runs
    if (i.ne.42) then  ! if in case you want an opt with the 2D init -> e.g. use if (i.ne.1)
      mol_shifted = mol
      ! create array with random shifts: 0<= shift <1
      call RANDOM_NUMBER(shift)
      ! change signs of shifts randomly
      do j=1, size(shift)
        call RANDOM_NUMBER(sign_threshold)
        if (sign_threshold.lt.0.5_wp) shift(j) = -1.0_wp*shift(j)
      enddo
      mol_shifted%xyz(3,:) = mol_shifted%xyz(3,:) + shift  ! apply shifts
    endif
    
    call geometry_optimization &
        &     (env,mol_shifted,chk,calc,   &
        &      egap,set%etemp,maxiter,maxcycle,etot,g,sigma,p_olev_crude,.false.,.true.,fail)
    mol_xyz_arr(:,:,i) = mol_shifted%xyz  ! store optimized xyz
    etot_arr(i) = etot                    ! store energy etot
  enddo

  mol%xyz(:,:) = mol_xyz_arr(:,:,minloc(etot_arr, DIM=1))  ! keep xyz with lowest etot

    if (allocated(fnv)) then
      set%opt_logfile = fnv
    else
      deallocate(set%opt_logfile)
    endif
    write(*,*)
!------------------------------------------------------------------------------
! force field md simulation
  idum = 0
  call md                &
      &   (env,mol,chk,calc, &
      &    egap,set%etemp,maxiter,etot,g,sigma,0,set%temp_md,idum)
!------------------------------------------------------------------------------
! set all back to input
  set%time_md  = time_in
  set%temp_md  = temp_in
  set%tstep_md = step_in
  set%dump_md2 = dump_in
  set%md_hmass = hmass_in
  if (allocated(opt_in)) then
    set%opt_engine = opt_in
  else
    deallocate(set%opt_engine)
  end if
!------------------------------------------------------------------------------
  write(*,*)
  write(*,'(10x," ------------------------------------------------- ")')
  write(*,'(10x,"|           2D => 3D conversion done!             |")')
  write(*,'(10x," ------------------------------------------------- ")')
  write(*,*)
  set%mode_extrun = mode_input
  mol%info%two_dimensional=.false.
  call gfnff_param_dealloc(calc%topo)

end subroutine struc_convert
end module xtb_gfnff_convert

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_onetri
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : blas_symm, blas_gemm
   use xtb_blowsy
   implicit none
   private

   public :: onetri

contains

subroutine onetri(ity,s,s1,array,n,ival)
   !     ******designed for abelian groups only******
   !
   !     calling sequence:
   !     ity       =1 sym ao
   !               =-1 anti sym ao
   !     s         input property matrix over ao's
   !     s1        transformed integrals on output
   !     s2        scratch arrays large enough to hold a square matrix
   !     array     mo matrix over so's
   !     n         linear dimension of arrays
   !     bernd hess, university of bonn, january 1991
   integer, intent(in) :: n
   integer, intent(in) :: ity
   integer, intent(in) :: ival
   real(wp), intent(in) :: s(*)
   real(wp), intent(inout) :: s1(*)
   real(wp), intent(in) :: array(n,ival)
   real(wp) :: s2(n,n)
   external :: dsymm, dgemm ! can't use wrappers due to change of leading dim

   !
   !     determine if we have an antisymmetric integral
   if (ity /= -1) then
      !
      !     blow up symmetric matrix s
      call blowsy(ity,s,s1,n)

      !
      !     transformation of s
      call dsymm('l','l',n,ival,1.d0,s1,n,array,n,0.d0,s2,n)
      call dgemm('t','n',ival,ival,n,1.d0,array,n,s2,n,0.d0,s1,ival)
   else
      !
      !     blow up anti-symmetric matrix s
      call blowsy(ity,s,s1,n)
      !
      !     transformation of s
      call dgemm('n','n',n,ival,n,1.d0,s1,n,array,n,0.d0,s2,n)
      call dgemm('t','n',ival,ival,n,1.d0,array,n,s2,n,0.d0,s1,ival)
   end if
end subroutine

end module xtb_onetri

! This file is part of ancopt.
! SPDX-Identifier: LGPL-3.0-or-later
!
! ancopt is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! ancopt is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with ancopt.  If not, see <https://www.gnu.org/licenses/>.

module xtb_pbc_optimizer_filter_cart
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule
   use xtb_mctc_math, only : matInv3x3
   use xtb_pbc_optimizer_filter_type, only : filter_type
   implicit none
   private

   public :: cartesian_filter, new_cartesian_filter

   type, extends(filter_type) :: cartesian_filter
      integer :: nvar
   contains
      procedure :: get_dimension
      procedure :: transform_structure
      procedure :: transform_derivative
   end type cartesian_filter

contains


subroutine new_cartesian_filter(self, mol, optcell)
   !> Instance of the transformation filter
   type(cartesian_filter), intent(out) :: self
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol
   !> Relax lattice parameters
   logical, intent(in) :: optcell

   self%optcell = optcell
   self%nvar = size(mol%xyz)
   if (self%optcell) self%nvar = self%nvar + size(mol%lattice)
end subroutine new_cartesian_filter


pure function get_dimension(self) result(n)
   !> Instance of the transformation filter
   class(cartesian_filter), intent(in) :: self
   integer :: n

   n = self%nvar
end function get_dimension


subroutine transform_structure(self, mol, displacement)
   !> Instance of the transformation filter
   class(cartesian_filter), intent(in) :: self
   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol
   real(wp), intent(in) :: displacement(:)

   mol%xyz(:, :) = mol%xyz + reshape(displacement(:size(mol%xyz)), shape(mol%xyz))
   if (self%optcell) then
      mol%lattice(:, :) = mol%lattice &
         & + reshape(displacement(size(mol%xyz)+1:), shape(mol%lattice))
   end if
end subroutine transform_structure


subroutine transform_derivative(self, mol, energy, gradient, sigma, val, deriv)
   !> Instance of the transformation filter
   class(cartesian_filter), intent(in) :: self
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol
   real(wp), intent(in) :: energy
   real(wp), intent(in) :: gradient(:, :)
   real(wp), intent(in) :: sigma(:, :)
   real(wp), intent(out) :: val
   real(wp), intent(out) :: deriv(:)

   real(wp) :: inv_lat(3, 3), lat_grad(3, 3)

   val = energy
   deriv(:size(gradient)) = reshape(gradient, [size(gradient)])
   if (self%optcell) then
      inv_lat(:, :) = transpose(matInv3x3(mol%lattice))
      lat_grad(:, :) = matmul(sigma, inv_lat) &
         & - matmul(gradient, matmul(transpose(mol%xyz), inv_lat))
      deriv(size(gradient)+1:) = reshape(lat_grad, [size(lat_grad)])
   end if
end subroutine transform_derivative


end module xtb_pbc_optimizer_filter_cart

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine write_tm_mos(iunit,n,at,basis,wfn)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_type_wavefunction
   use xtb_type_basisset
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   type(TBasisset),    intent(in) :: basis
   type(TWavefunction),intent(in) :: wfn

   character(len=*),parameter :: keyword = "$scfmo   expanded   format(4d20.14)"
   character(len=*),parameter :: format = "(4d20.14)"
   integer :: i,j

   write(iunit,'(a)') keyword
   write(iunit,'(a)') &
      '# molecular orbitals from extended tight binding calculation'
   do i = 1, wfn%nao
      write(iunit,'(i6,2x,"a",6x,"eigenvalue=",d20.14,3x,"nsaos=",i0)') &
         i, wfn%emo(i)*evtoau, wfn%nao
      write(iunit,format) (wfn%C(j,i),j=1,wfn%nao)
   enddo
   write(iunit,'(a)') "$end"
end subroutine write_tm_mos

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mdoptim
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_filetypes, only : fileType
   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_type_restart
   use xtb_type_data
   use xtb_io_writer, only : writeMolecule
   use xtb_setparam
   use xtb_splitparam
   use xtb_geoopt
   use xtb_cqpath
   implicit none
   private

   public :: mdopt


contains


subroutine mdopt(env, mol, chk, calc, egap, et, maxiter, epot, grd, sigma)

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   type(TMolecule), intent(inout) :: mol
   type(TRestart),intent(inout) :: chk
   class(TCalculator), intent(inout) :: calc
   integer  :: icall,maxiter
   real(wp) :: epot,et,egap
   real(wp), intent(inout) :: grd(3,mol%n)
   real(wp), intent(inout) :: sigma(3,3)
   type(scc_results) :: res

   real(wp),allocatable :: xyznew(:,:,:), eread(:)
   real(wp) :: e,angtoau
   parameter (angtoau=1.0d0/0.529177260d0)
   integer i,j,iz1,iz2,nall,ol
   character(80) atmp
   logical ex, fail
   integer ich

   write(*,*)
   write(*,'(7x,''======================================='')')
   write(*,'(7x,''|              M D O P T              |'')')
   write(*,'(7x,''|    optimizations along trajectory   |'')')
   write(*,'(7x,''======================================='')')
   write(*,*)
   write(*,*)'skipping interval            :',set%skip_md
   write(*,*)'opt level                    :',set%optset%optlev

   atmp='xtb.trj'
   call cqpath_read_pathfile_parameter(atmp,iz1,iz2,nall)
   if(iz2.ne.mol%n) call env%terminate('read error in mdopt')
   allocate(xyznew(3,mol%n,nall),eread(nall))
   call cqpath_read_pathfile(atmp,iz1,iz2,nall,xyznew,mol%at,eread)
   write(*,*)'total number of points on trj:',nall
   write(*,*)'total number of optimizations:',nall/set%skip_md

   call open_file(ich,'xtb_ensemble.xyz','w')

   j   =0
   do i=1,nall

      j = j +1

      if(mod(j,set%skip_md).eq.0)then
         mol%xyz=xyznew(:,:,i)*angtoau

         call geometry_optimization &
            &      (env, mol,chk,calc, &
            &       egap,set%etemp,set%maxscciter,set%optset%maxoptcycle,epot,grd,sigma, &
            &       set%optset%optlev,.false.,.true.,fail)

         if(.not.fail)then
            call writeMolecule(mol, ich, fileType%xyz, energy=epot)
         endif
      endif

   enddo

   call close_file(ich)

end subroutine mdopt


end module xtb_mdoptim

! This file is part of xtb.
!
! Copyright (C) 2022 Stefan Grimme, Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_iff_ifflmo
   use xtb_docking_param
   use xtb_axis, only: axisvec
   use xtb_splitparam, only: atmass
   use mctcpar_atomic_masses
   use xtb_setmod
   implicit none

   private
   public :: setlmo

contains

   subroutine trflmo(mol, n, nl, c, cl)
      integer, intent(in) :: n
      integer, intent(in) :: nl
      integer, intent(in) :: mol
      real(wp), intent(in) :: c(3, n)
      real(wp), intent(out) :: cl(4, n*10)

      integer :: i, iat, jat, kat
      real(wp) :: r3(3), r, r1, r2

      do i = 1, nl
!        LMO on atom
         if (lmoatom(1, i, mol) .eq. 1) then
            iat = lmoatom(2, i, mol)
            cl(1:3, i) = c(1:3, iat)
         end if
!        LP or pi
         if (lmoatom(1, i, mol) .eq. 4) then
            iat = lmoatom(2, i, mol)
            jat = lmoatom(3, i, mol)
            kat = lmoatom(4, i, mol)
            call trflp(n, c, iat, jat, kat,&
     &           lmoint(1, i, mol), lmoint(2, i, mol), lmoint(3, i, mol), r3)
            cl(1:3, i) = r3(1:3)
         end if
!        sigma
         if (lmoatom(1, i, mol) .eq. 2) then
            iat = lmoatom(2, i, mol)
            jat = lmoatom(3, i, mol)
            r3(1:3) = c(1:3, iat) - c(1:3, jat)
            r = dsqrt(r3(1)**2 + r3(2)**2 + r3(3)**2)
            r1 = lmoint(1, i, mol)
            r2 = lmoint(2, i, mol)
            if (r2 .gt. r) then
               cl(1:3, i) = c(1:3, iat) + r1*r3(1:3)/r
            else
               cl(1:3, i) = c(1:3, iat) - r1*r3(1:3)/r
            end if
         end if
      end do

   end subroutine trflmo

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! important LMO prep routine for anisotropic ES
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
   subroutine setlmo(mol, n, nl, at, xyz, alp0, q, cn, c, lmo)

      integer, intent(in) :: mol, n
      real(wp), intent(in) :: xyz(3, n)
      real(wp), intent(in) :: alp0(n)
      real(wp), intent(in) :: q(n)
      real(wp), intent(in) :: cn(n)
      integer, intent(in) :: at(n)
      real(wp), intent(inout) :: c(4, 10*n)
      integer, intent(inout) :: lmo(10*n), nl

      integer :: i, j, ii, ia1, imin, ind(n), ltmp(10*n), nlp, npi, nsig, ia2, ia3
      real(wp) :: ex, ey, ez, rmin, f, norm(n), lpcharge, dip(3), cnfac, di, ff, rr1
      real(wp) :: d2,alp,p6pi,p6sig,r1,r2,qq,dex,c1,c2,ex1,ey1,ez1,rr,rr2
      real(wp) :: r0_free, ctmp(4, 10*n), prxs(3, 3), aa, bb, cc, vtmp(3), vnew(3)
      real(wp) :: s1, s2
      logical :: sigbond, pibond

      lmoatom(1, 1:maxlmo, mol) = 0
      ltmp = lmo
      ctmp = c
      c = 0

      if (n .eq. 1) then ! if just an atom, exit here (LPs break symmetry)
         nl = 0
         return
      end if

      npi = 0
      nlp = 0
      nsig = 0
      i = 0
      do ii = 1, nl
         if (n .eq. 1) ltmp(ii) = 2  ! a single atom always has only LP
         ex = ctmp(1, ii)
         ey = ctmp(2, ii)
         ez = ctmp(3, ii)
         rmin = 1.d+42
         do ia1 = 1, n
            norm(ia1) = sqrt((xyz(1, ia1) - ex)**2 + (xyz(2, ia1) - ey)**2&
                         &+ (xyz(3, ia1) - ez)**2)
            ind(ia1) = ia1
         end do
         call Qsort(norm, 1, n, ind)
         ia3 = 0
         ia1 = ind(1)
         ia2 = ind(1)
         if (n .gt. 1) ia2 = ind(2)
         if (n .gt. 2) ia3 = ind(3)
         if (ltmp(ii) .eq. 2 .and. lpatom(at(ia1)) .eq. 1) then
!           put it on the line along atom...LP center
            i = i + 1
            if (i .gt. maxlmo) stop 'too many LMO'
            f = -par_pos1_lp
            ex1 = xyz(1, ia1) + f*(xyz(1, ia1) - ex)
            ey1 = xyz(2, ia1) + f*(xyz(2, ia1) - ey)
            ez1 = xyz(3, ia1) + f*(xyz(3, ia1) - ez)
            c(1, i) = ex1
            c(2, i) = ey1
            c(3, i) = ez1
            c(4, i) = -0.010*par_chrg_lp*alp0(ia1)/r0_atom(at(ia1))
            !  speical hack for heavy elements
            if (at(ia1) .gt. 10)&
           &c(4, i) = -0.010*par_chrg_lp*alp0(ia1)/r0_atom(at(ia1))/1.8 
            lmo(i) = ia1 ! important overwrite of LMO type info by atom number to which LMO i is attached
            lmoatom(1, i, mol) = 4
            lmoatom(2, i, mol) = ia1
            lmoatom(3, i, mol) = ia2
            lmoatom(4, i, mol) = ia3
            call internal4(n, xyz, c(1, i), ia1, ia2, ia3,&
                &lmoint(1, i, mol), lmoint(2, i, mol), lmoint(3, i, mol))
            ! to distinguish LPs, set lmoatom(3:4,...) = 0
            lmoatom(3, i, mol) = 0
            lmoatom(4, i, mol) = 0
            !!!
            if (i .gt. maxlmo) stop 'too many LMO'
            i = i + 1
            f = -par_pos2_lp                             
            ! along the line but close to nuc (or at nuc if par_pos2_lp is 0)
            ! same side a + charge
            ex1 = xyz(1, ia1) + f*(xyz(1, ia1) - ex)
            ey1 = xyz(2, ia1) + f*(xyz(2, ia1) - ey)
            ez1 = xyz(3, ia1) + f*(xyz(3, ia1) - ez)
            c(1, i) = ex1
            c(2, i) = ey1
            c(3, i) = ez1
            c(4, i) = -c(4, i - 1)
            lmo(i) = ia1
            lmoatom(1, i, mol) = 1
            lmoatom(2, i, mol) = ia1
            nlp = nlp + 1
         end if

         sigbond = (sigatom(at(ia1)) .eq. 1 .or. sigatom(at(ia2)) .eq. 1)&   
                   &.and. (ltmp(ii) .eq. 1) .and. (n .ne. 1) .and. at(ia1) .ne. 1&
                   &.and. at(ia2) .ne. 1
         pibond = ltmp(ii) .ge. 3
         if (sigbond .or. pibond) then       ! sigma and pi part -
            i = i + 1
            if (i .gt. maxlmo) stop 'too many LMO'
            alp = (alp0(ia1)*alp0(ia2))**0.5 ! average of two closest atom values
            r0_free = (r0_atom(at(ia1))*r0_atom(at(ia2)))**0.5
            c(1:3, i) = ctmp(1:3, ii)         ! the - charge point at LMO center
            lmo(i) = ia1
            ! rest is + charge position
            r1 = sqrt((ex - xyz(1, ia1))**2 + (ey - xyz(2, ia1))**2&
                  &+ (ez - xyz(3, ia1))**2)
            r2 = sqrt((ex - xyz(1, ia2))**2 + (ey - xyz(2, ia2))**2&
                  &+ (ez - xyz(3, ia2))**2)
            c1 = r1/(r1 + r2)
            c2 = r2/(r1 + r2)
            if (sigbond) then               ! sigma
               rr = sqrt((xyz(1, ia1) - xyz(1, ia2))**2 +&
                      &(xyz(2, ia1) - xyz(2, ia2))**2 +&
                      &(xyz(3, ia1) - xyz(3, ia2))**2)
               ex1 = xyz(1, ia2) - xyz(1, ia1)
               ey1 = xyz(2, ia2) - xyz(2, ia1)
               ez1 = xyz(3, ia2) - xyz(3, ia1)
               qq = 0.01*par_chrg_sig*alp/r0_free
               c(4, i) = -qq
               lmoatom(1, i, mol) = 2
               lmoatom(2, i, mol) = ia1
               lmoatom(3, i, mol) = ia2
               lmoint(1, i, mol) = r1
               lmoint(2, i, mol) = r2
               i = i + 1
               if (i .gt. maxlmo) stop 'too many LMO'
               c(1, i) = ex - par_pos_sig*ex1/rr
               c(2, i) = ey - par_pos_sig*ey1/rr
               c(3, i) = ez - par_pos_sig*ez1/rr
               c(4, i) = qq*c1
               lmo(i) = ia1
               rr1 = sqrt((xyz(1, ia1) - c(1, i))**2 +&
                       &(xyz(2, ia1) - c(2, i))**2 +&
                       &(xyz(3, ia1) - c(3, i))**2)
               rr2 = sqrt((xyz(1, ia2) - c(1, i))**2 +&
                       &(xyz(2, ia2) - c(2, i))**2 +&
                       &(xyz(3, ia2) - c(3, i))**2)
               lmoatom(1, i, mol) = 2
               lmoatom(2, i, mol) = ia1
               lmoatom(3, i, mol) = ia2
               lmoint(1, i, mol) = rr1
               lmoint(2, i, mol) = rr2
               i = i + 1
               if (i .gt. maxlmo) stop 'too many LMO'
               c(1, i) = ex + par_pos_sig*ex1/rr
               c(2, i) = ey + par_pos_sig*ey1/rr
               c(3, i) = ez + par_pos_sig*ez1/rr
               c(4, i) = qq*c2
               lmo(i) = ia2
               rr2 = sqrt((xyz(1, ia2) - c(1, i))**2 +&
                       &(xyz(2, ia2) - c(2, i))**2 +&
                       &(xyz(3, ia2) - c(3, i))**2)
               rr1 = sqrt((xyz(1, ia1) - c(1, i))**2 +&
                       &(xyz(2, ia1) - c(2, i))**2 +&
                       &(xyz(3, ia1) - c(3, i))**2)
               lmoatom(1, i, mol) = 2
               lmoatom(2, i, mol) = ia2
               lmoatom(3, i, mol) = ia1
               lmoint(1, i, mol) = rr2
               lmoint(2, i, mol) = rr1
               nsig = nsig + 1
            else                          ! pi
               ff = 1.0
               if (ltmp(ii) .eq. 4) ff = 3.0   ! deloc pi
               qq = ff*0.01*par_chrg_pi*alp/r0_free
               c(4, i) = -qq
               lmoatom(1, i, mol) = 4
               lmoatom(2, i, mol) = ia1
               lmoatom(3, i, mol) = ia2
               lmoatom(4, i, mol) = ia3
               call internal4(n, xyz, c(1, i), ia1, ia2, ia3,&
                   &lmoint(1, i, mol), lmoint(2, i, mol), lmoint(3, i, mol))
               i = i + 1
               if (i .gt. maxlmo) stop 'too many LMO'
               c(1:3, i) = xyz(1:3, ia1)      ! + on atoms
               c(4, i) = qq*c1
               lmo(i) = ia1
               lmoatom(1, i, mol) = 1
               lmoatom(2, i, mol) = ia1
               i = i + 1
               if (i .gt. maxlmo) stop 'too many LMO'
               c(1:3, i) = xyz(1:3, ia2)
               c(4, i) = qq*c2
               lmo(i) = ia2
               lmoatom(1, i, mol) = 1
               lmoatom(2, i, mol) = ia2
               npi = npi + 1
            end if
         end if
!     next LMO
      end do

! special treatment for linear molecules to avoid the symmetry breaking
! this is done by projecting the off-center charges onto the molecular axis, thus
! done after positioning of the charge centers (most importantly the LPs)
      aa = 0.0d0
      bb = 0.0d0
      cc = 0.0d0
      prxs = 0.0d0
      atmass = atomic_mass(at)
      !Both yield the same result (delete axisvec2 here)
      call axisvec(n, at, xyz, aa, bb, cc, prxs)

      if (cc .lt. 1.d-8) then  ! check, whether molecule is linear
         do j = 1, i
            if (lmoatom(1, j, mol) .le. 1) cycle
            vtmp = 0.0d0
            vnew = 0.0d0
            ia1 = lmoatom(2, j, mol)
            vtmp(1:3) = c(1:3, j) - xyz(1:3, ia1)
            s2 = vtmp(1)**2
            s2 = s2 + vtmp(2)**2
            s2 = s2 + vtmp(3)**2
            s2 = sqrt(s2)
            ! project off-center charge onto molecular axis
            s1 = vtmp(1)*prxs(1, 1)
            s1 = vtmp(2)*prxs(2, 1)
            s1 = vtmp(3)*prxs(3, 1)
            vnew(1) = s1*prxs(1, 1)
            vnew(2) = s1*prxs(2, 1)
            vnew(3) = s1*prxs(3, 1)
            c(1:3, j) = xyz(1:3, ia1) + vnew(1:3)

            ! rescale charges
            s1 = vnew(1)**2
            s1 = s1 + vnew(2)**2
            s1 = s1 + vnew(3)**2
            s1 = sqrt(s1)
            aa = vtmp(1)*vnew(1)
            aa = aa + vtmp(2)*vnew(2)
            aa = aa + vtmp(3)*vnew(3)
            aa = aa/(s1*s2) ! cosine
            aa = 2.0d0 - aa**2 ! 1+ sine**2
            ia2 = lmoatom(2, j + 1, mol)
            if (ia1 .eq. ia2) then
               if (lmoatom(3, j, mol) .eq. 0) then   !LP case
                  c(4, j) = c(4, j)*aa
                  c(4, j + 1) = c(4, j + 1)*aa
                  cycle
               end if
               if (lmoatom(3, j + 1, mol) .eq. 0) then ! deloc pi case
                  c(4, j) = c(4, j)*aa
                  c(4, j + 1) = c(4, j + 1)*aa
                  c(4, j + 2) = c(4, j + 2)*aa
                  cycle
               end if
               ! sigma or pi
               c(4, j) = c(4, j)*aa
               c(4, j + 1) = c(4, j + 1)*aa
               c(4, j + 2) = c(4, j + 2)*aa
            end if
         end do
      end if

      nl = i
      if(set%verbose) write (*, '(''# of LP/pi/sigma LMOs    :'',3i5)') nlp, npi, nsig
      if(set%verbose) write (*, '(''# of off-center charges  :'', i5)') nl

      dip = 0
      do i = 1, nl
         dip(1:3) = dip(1:3) + c(1:3, i)*c(4, i)
      end do
      do i = 1, n
         dip(1:3) = dip(1:3) + xyz(1:3, i)*q(i)
      end do
      di = sqrt(dip(1)**2 + dip(2)**2 + dip(3)**2)
      if(set%verbose) write (*, '(''dipole moment (read/calc):'',2F8.3)') dipol(mol), di

   end subroutine setlmo

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! internal coords (R,angle,dihedral) for LP and pi LMO center
! as defined wrt next neighbors, i.e., ijkl
! c(3) is the LMO center
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   subroutine internal4(n, xyz, c, j, k, l, r, alp, bet)
      integer, intent(in) :: n, j, k, l
      real(wp), intent(in) :: xyz(3, n), c(3)
      real(wp), intent(out) :: r, alp, bet

      real(wp) :: xyz2(3, 4)

      alp = 10.0 ! nonsense value
      bet = 10.0 ! nonsense value
      r = sqrt((c(1) - xyz(1, j))**2 +&
              &(c(2) - xyz(2, j))**2 +&
              &(c(3) - xyz(3, j))**2)

      if (k .gt. 0) then
         xyz2(1:3, 1) = c(1:3)
         xyz2(1:3, 2) = xyz(1:3, j)
         xyz2(1:3, 3) = xyz(1:3, k)
         call xbangle(XYZ2, 1, 2, 3, alp)
         if (l .gt. 0) then
            xyz2(1:3, 4) = xyz(1:3, l)
            call xDIHED(XYZ2, 1, 2, 3, 4, bet)
         end if
      end if

   end subroutine internal4

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   subroutine trflp(n, coord, nai, nbi, nci, geo1i, geo2i, geo3i, ci)
      integer, intent(in) :: n, nai, nbi, nci
      real(wp), intent(in) :: coord(3, n)
      real(wp), intent(in) :: geo1i, geo2i, geo3i
      real(wp), intent(out) :: ci(3)

      real(wp) :: xb, yb, zb, xpa, xpb, xa, ya, za, xyb, xrd, yqd, xqd, zqd
      real(wp) :: costh, sinth, cosph, sinph, cosd, sind, xd, yd, zd, xpd
      real(wp) :: ypd, zpd, rbc, cosa, ypa, coskh, sinkh, sina, yza, zqa, xqa
      integer :: ma, mb, mc, k

      COSA = COS(GEO2I)
      MB = NBI
      MC = NAI
      XB = COORD(1, MB) - COORD(1, MC)
      YB = COORD(2, MB) - COORD(2, MC)
      ZB = COORD(3, MB) - COORD(3, MC)
      RBC = 1.0D00/DSQRT(XB*XB + YB*YB + ZB*ZB)
!
!     THE ATOMS ARE NOT COLLINEAR
!
      MA = NCI
      XA = COORD(1, MA) - COORD(1, MC)
      YA = COORD(2, MA) - COORD(2, MC)
      ZA = COORD(3, MA) - COORD(3, MC)
!
!     ROTATE ABOUT THE Z-AXIS TO MAKE YB=0, AND XB POSITIVE.  IF XYB IS
!     TOO SMALL, FIRST ROTATE THE Y-AXIS BY 90 DEGREES.
!
      XYB = DSQRT(XB*XB + YB*YB)
      K = -1
      IF (XYB .LE. 0.1D00) then
         XPA = ZA
         ZA = -XA
         XA = XPA
         XPB = ZB
         ZB = -XB
         XB = XPB
         XYB = DSQRT(XB*XB + YB*YB)
         K = 1
      end if
!
!     ROTATE ABOUT THE Y-AXIS TO MAKE ZB VANISH
!
      COSTH = XB/XYB
      SINTH = YB/XYB
      XPA = XA*COSTH + YA*SINTH
      YPA = YA*COSTH - XA*SINTH
      SINPH = ZB*RBC
      COSPH = DSQRT(ABS(1.D00 - SINPH*SINPH))
      XQA = XPA*COSPH + ZA*SINPH
      ZQA = ZA*COSPH - XPA*SINPH
!
!     ROTATE ABOUT THE X-AXIS TO MAKE ZA=0, AND YA POSITIVE.
!
      YZA = DSQRT(YPA*YPA + ZQA*ZQA)
      IF (YZA .LT. 1.D-4) stop 'lp coord gen error'
      COSKH = YPA/YZA
      SINKH = ZQA/YZA
!
!     COORDINATES :-   A=(XQA,YZA,0),   B=(RBC,0,0),  C=(0,0,0)
!     NONE ARE NEGATIVE.
!     THE COORDINATES OF I ARE EVALUATED IN THE NEW FRAME.
!
      SINA = SIN(GEO2I)
      SIND = -SIN(GEO3I)
      COSD = COS(GEO3I)
      XD = GEO1I*COSA
      YD = GEO1I*SINA*COSD
      ZD = GEO1I*SINA*SIND
!
!     TRANSFORM THE COORDINATES BACK TO THE ORIGINAL SYSTEM.
!
      YPD = YD*COSKH - ZD*SINKH
      ZPD = ZD*COSKH + YD*SINKH
      XPD = XD*COSPH - ZPD*SINPH
      ZQD = ZPD*COSPH + XD*SINPH
      XQD = XPD*COSTH - YPD*SINTH
      YQD = YPD*COSTH + XPD*SINTH
      IF (K .GE. 1) then
         XRD = -ZQD
         ZQD = XQD
         XQD = XRD
      end if
      CI(1) = XQD + COORD(1, MC)
      CI(2) = YQD + COORD(2, MC)
      CI(3) = ZQD + COORD(3, MC)

   end subroutine trflp
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   subroutine xBANGLE(XYZ, I, J, K, ANGLE)
      integer, intent(in) :: I, J, K
      real(wp), intent(in) :: XYZ(3, *)
      real(wp), intent(out) :: ANGLE

      real(wp) :: D2IJ, D2JK, D2IK, XY, TEMP
! BANGLE CALCULATES THE ANGLE BETWEEN ATOMS I,J, AND K. THE
!        CARTESIAN COORDINATES ARE IN XYZ.
      D2IJ = (XYZ(1, I) - XYZ(1, J))**2 +&
            &(XYZ(2, I) - XYZ(2, J))**2 +&
            &(XYZ(3, I) - XYZ(3, J))**2
      D2JK = (XYZ(1, J) - XYZ(1, K))**2 +&
            &(XYZ(2, J) - XYZ(2, K))**2 +&
            &(XYZ(3, J) - XYZ(3, K))**2
      D2IK = (XYZ(1, I) - XYZ(1, K))**2 +&
            &(XYZ(2, I) - XYZ(2, K))**2 +&
            &(XYZ(3, I) - XYZ(3, K))**2
      XY = SQRT(D2IJ*D2JK + 1.d-14)
      TEMP = 0.5D0*(D2IJ + D2JK - D2IK)/XY
      IF (TEMP .GT. 1.0D0) TEMP = 1.0D0
      IF (TEMP .LT. -1.0D0) TEMP = -1.0D0
      ANGLE = ACOS(TEMP)
      RETURN
   end subroutine xBANGLE

   subroutine xDIHED(XYZ, I, J, K, L, ANGLE)
      real(wp), intent(in) :: XYZ(3, 4)
      integer, intent(in) :: I, J, K, L
      real(wp), intent(out) :: ANGLE

      real(wp) :: XI1, XJ1, XL1, YI1, YJ1, YL1, ZI1, ZJ1, ZL1
      real(wp) :: XI2, XJ2, XL2, YI2, YJ2, YL2, ZI2, ZJ2, ZL2
      real(wp) :: YI3, YL3
      real(wp) :: DIST, COSA, DDD, YXDIST, COSTH, SINTH, COSPH, SINPH

      real(wp), parameter :: PI = 3.14159265358979_wp
      XI1 = XYZ(1, I) - XYZ(1, K)
      XJ1 = XYZ(1, J) - XYZ(1, K)
      XL1 = XYZ(1, L) - XYZ(1, K)
      YI1 = XYZ(2, I) - XYZ(2, K)
      YJ1 = XYZ(2, J) - XYZ(2, K)
      YL1 = XYZ(2, L) - XYZ(2, K)
      ZI1 = XYZ(3, I) - XYZ(3, K)
      ZJ1 = XYZ(3, J) - XYZ(3, K)
      ZL1 = XYZ(3, L) - XYZ(3, K)
!      ROTATE AROUND Z AXIS TO PUT KJ ALONG Y AXIS
      DIST = SQRT(XJ1**2 + YJ1**2 + ZJ1**2 + 1.d-14)
      COSA = ZJ1/DIST
      IF (COSA .GT. 1.0D0) COSA = 1.0D0
      IF (COSA .LT. -1.0D0) COSA = -1.0D0
      DDD = 1.0D0 - COSA**2
      IF (DDD .GT. 0.0) then
         YXDIST = DIST*SQRT(DDD)
      end if
      IF (YXDIST .LE. 1.0D-9 .AND. DDD .GT. 0.0) then
         XI2 = XI1
         XL2 = XL1
         YI2 = YI1
         YL2 = YL1
         COSTH = COSA
         SINTH = 0.D0
      end if
      IF (YXDIST .GT. 1.0D-9 .OR. DDD .LE. 0.0) then
         COSPH = YJ1/YXDIST
         SINPH = XJ1/YXDIST
         XI2 = XI1*COSPH - YI1*SINPH
         XJ2 = XJ1*COSPH - YJ1*SINPH
         XL2 = XL1*COSPH - YL1*SINPH
         YI2 = XI1*SINPH + YI1*COSPH
         YJ2 = XJ1*SINPH + YJ1*COSPH
         YL2 = XL1*SINPH + YL1*COSPH
!      ROTATE KJ AROUND THE X AXIS SO KJ LIES ALONG THE Z AXIS
         COSTH = COSA
         SINTH = YJ2/DIST
      end if
      YI3 = YI2*COSTH - ZI1*SINTH
      YL3 = YL2*COSTH - ZL1*SINTH
      CALL xDANG(XL2, YL3, XI2, YI3, ANGLE)
      IF (ANGLE .LT. 0.) ANGLE = 2.0D0*PI + ANGLE
      IF (ANGLE .GE. 2.0d0*PI) ANGLE = 0.D0
      RETURN
   end subroutine xDIHED

   subroutine xDANG(A1, A2, B1, B2, RCOS)
      real(wp), intent(inout) :: A1, A2, B1, B2
      real(wp), intent(out) :: RCOS

      real(wp) :: ZERO, SINTH, COTH, ANORM, BNORM, COSTH
      real(wp), parameter :: PI = 3.14159265358979_wp
      ZERO = 1.0D-6
      IF (ABS(A1) .LT. ZERO .AND. ABS(A2) .LT. ZERO) then
         RCOS = 0.0D0
         return
      end if
      IF (ABS(B1) .LT. ZERO .AND. ABS(B2) .LT. ZERO) then
         RCOS = 0.0D0
         return
      end if
      ANORM = 1.0D0/SQRT(A1**2 + A2**2)
      BNORM = 1.0D0/SQRT(B1**2 + B2**2)
      A1 = A1*ANORM
      A2 = A2*ANORM
      B1 = B1*BNORM
      B2 = B2*BNORM
      SINTH = (A1*B2) - (A2*B1)
      COSTH = A1*B1 + A2*B2
      IF (COSTH .GT. 1.0D0) COSTH = 1.0D0
      IF (COSTH .LT. -1.0D0) COSTH = -1.0D0
      RCOS = ACOS(COSTH)
      IF (ABS(RCOS) .GE. 4.0D-4) then
         IF (SINTH .GT. 0.D0) RCOS = 2.0D0*PI - RCOS
         RCOS = -RCOS
         RETURN
      END IF
      RCOS = 0.0D0
      RETURN
   end subroutine xDANG

end module xtb_iff_ifflmo

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine mctc_init(progname,ntimer,verbose)
   use, intrinsic :: iso_c_binding, only : c_int, c_funptr, c_funloc
   use xtb_mctc_global
   use xtb_mctc_timings
   use xtb_mctc_filetools
   use xtb_type_environment, only : init
   implicit none
   character(len=*),intent(in) :: progname
   integer,         intent(in) :: ntimer
   logical,         intent(in) :: verbose
#ifdef USE_CUSOLVER
   integer :: err
#endif

!! ========================================================================
!  signal processing
   interface
      subroutine xtb_wsigint(signal) bind(C)
         import :: c_int
         integer(c_int), value :: signal
      end subroutine xtb_wsigint
      subroutine xtb_wsigterm(signal) bind(C)
         import :: c_int
         integer(c_int), value :: signal
      end subroutine xtb_wsigterm
      subroutine xtb_signal_handler(signal, handler) bind(C)
         import :: c_int, c_funptr
         integer(c_int), value :: signal
         type(c_funptr), value :: handler
      end subroutine xtb_signal_handler
   end interface
!  here two important signal handlers are installed, it seems that
!  FORTRAN by itself cannot handle signals in the way I expected it
!  to do, but this will force it to die when I hit CTRL^C.
   call xtb_signal_handler(2_c_int, c_funloc(xtb_wsigint))
   call xtb_signal_handler(15_c_int, c_funloc(xtb_wsigterm))

!  initialize the timing system
   call start_timing_run
   call init_timing(ntimer,verb=verbose) ! verbosity allows printing of cputime
   call start_timing(1)

!  initialize the messagebuffer for the error handler
   call init_errorbuffer

!  initialize the filelist
   call init_filelist(20)

!  set this for xtb_mctc_global
   name = progname

   allocate(persistentEnv)
   call init(persistentEnv)

#ifdef USE_CUSOLVER
   err = cusolverDnCreate(cusolverDnH)
   if (err /= 0) then
      call persistentEnv%error("failed to create cusolver handle", "mctc_init")
   end if
#endif
end subroutine mctc_init

subroutine mctc_sanity(sane)
   use xtb_mctc_global
   logical,intent(out) :: sane
   sane = good
end subroutine mctc_sanity

subroutine mctc_strict
   use xtb_mctc_global
   strict = .true.
end subroutine mctc_strict

subroutine mctc_mute
   use xtb_mctc_global
   mute = .true.
end subroutine mctc_mute

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_anharmlib
contains

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! analyze a pot curve with n points for stationary points
! xx are the grid points, yy the energies and yy* the
! derivatives
! nstat is the number of stationary points found
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine curveanal(n,xx,yy,yy1,yy2,list,ityp,nstat,eps)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer n
   real(wp) xx(n),yy(n),yy1(n),yy2(n),eps
   integer list(*),ityp(*),nstat

   integer i,j,k,kk,mem,it1,it2,icall
   real(wp) xmin,av,dx,dxmax
   character*15 typ(3)

   write(*,*) 'analysis of potential (stationary points)'
   typ( 1)='##saddle       '
   typ( 2)='##probably min.'
   typ( 3)='##minimum      '

   !     do i=1,n
   !        write(142,*) xx(i),yy(i)
   !     enddo
   !     write(142,*)
   !     do i=1,n
   !        write(142,*) xx(i),yy1(i)
   !     enddo
   !     write(142,*)

   dxmax=xx(n)-xx(1)

   av=0
   k =0
   do i=1,n
      if(abs(yy1(i)).gt.1.d-6)then
         av=av+abs(yy1(i))
         k=k+1
      endif
   enddo
   av=av/dble(k)

   eps=0.05*av
   k=0
   icall=0

   1  continue
   write(*,*) 'epsilon (for zero check in Eh/Bohr) : ',eps
   if(eps.ne.eps) stop
   i=1
   10  if(abs(yy1(i)).lt.eps.and.abs(yy2(i)).gt.1.d-9)then
      k=k+1
      xmin=1.d+42
      do j=i,i+50
         if(abs(yy1(j)).lt.xmin)then
            mem=j
            xmin=abs(yy1(j))
         endif
      enddo
      list(k)=mem
      ityp(k)=2+int(sign(1.0d0,yy2(list(k))))
      i=j+50  ! skip
      if(k.gt.1)then   ! check if the the same point is close
         it2=2+int(sign(1.0d0,yy2(list(k-1))))
         dx=abs(xx(list(k))-xx(list(k-1)))
         if(ityp(k).eq.it2.and.dx/dxmax.lt.0.1)&
            &         k=k-1 ! invalid because its close
         if(k.gt.100) stop 'too many stationary points'
      endif
   endif
   i=i+1
   if(i.lt.n) goto 10

   if(k.eq.0.and.icall.lt.10) then
      eps=eps*5.
      icall=icall+1
      goto 1
   endif

   !     check the borders
   kk=k
   i =1
   !     do i=1,k
   if(ityp(i).eq.1)then
      if(yy(list(i)).gt.yy(2))then
         kk=kk+1
         ityp(kk)=2
         do j=1,n
            if(abs(yy2(j)).gt.eps)then
               list(kk)=j
               goto 20
            endif
         enddo
      endif
   endif
   !     enddo
   20   continue
   !     do i=k,1,-1
   i=k
   if(ityp(i).eq.1)then
      if(yy(list(i)).gt.yy(n-1))then
         kk=kk+1
         ityp(kk)=2
         do j=n,1,-1
            if(abs(yy2(j)).gt.eps)then
               list(kk)=j
               goto 30
            endif
         enddo
      endif
   endif
   !     enddo
   30   continue

   do i=1,kk
      write(*,'(i3,2x,a15,'' at '',f8.3,5x,''Erel /kcal '',f8.2)') &
         &   i,typ(ityp(i)),&
         &   xx(list(i)),yy(list(i))*627.509
   enddo

   nstat = kk

end subroutine

end module xtb_anharmlib

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!cuts the at blanks and tabstops and returns all floats and strings in order of occurence
subroutine cutline(line,floats,strings)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp) floats(*),num
   character(len=128) line,str,stmp
   character(len=80) strings(3)
   character(len=1) digit
   integer i,ty,cs,cf

   stmp=''
   cs=1
   cf=1
   strings(:)=''
   do i=1,len(trim(line))
      digit=line(i:i)
      if(digit.ne.' '.and.digit.ne.char(9)) then  !should exclude tabstops and blanks, 9 is ascii code for tab
         stmp=trim(stmp)//trim(digit)
      elseif(stmp.ne.'')then
         call checktype(stmp,num,str,ty)      !get type of string, 0=number, 1=character
         if(ty.eq.0) then
            floats(cf)=num
            cf=cf+1
         elseif(ty.eq.1) then
            strings(cs)=trim(str)
            cs=cs+1
         else
            write(*,*)'Problem in checktype, must abort'
            exit
         endif
         stmp=''
      endif
      if(i.eq.len(trim(line))) then  !special case: end of line
         call checktype(stmp,num,str,ty)
         if(ty.eq.0) then
            floats(cf)=num
            cf=cf+1
         elseif(ty.eq.1) then
            strings(cs)=trim(str)
            cs=cs+1
         else
            write(*,*)'Problem in checktype, must abort'
            exit
         endif
         stmp=''
      endif
   enddo
end subroutine cutline


!this checks the type of the string and returns it cast to real or as string.
subroutine checktype(field,num,str,ty)
   use xtb_mctc_accuracy, only : wp
   implicit none
   character(len=*) field,str
   real(wp) num
   integer i,e,ty
   logical is_num

   ty=99
   str=''
   is_num=.false.
   read(field,'(F10.5)',IOSTAT=e)num !cast string on real and get error code; 0 means success.
   if(e.eq.0)is_num=.true.
   if(is_num)then
      if(index(field,'.').ne.0) then  !check for integer/real
         read(field,'(F30.16)')num
         ty=0
      else                       !if integer, add .0 to string; otherwise cast to real does not work
         str=trim(field)//'.0'
         read(str,'(F30.16)')num
         str=''
         ty=0
      endif
   else
      str=field
      ty=1
   endif
end subroutine checktype

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
! compute localized "normal" modes according to the Pipek-Mezey algo
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine locmode(n,n3,at,xyz,vthr,freq,rmass,uin,ng,group)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_blas, only : blas_gemm
   implicit none
   integer n,n3,at(n),ng,group(n)
   real(wp) xyz(3,n),freq(n3),rmass(n3),uin(n3,n3),vthr

   integer nvar,nvsq,r,s,a,ii,ij,ija,k,i,j,highest,ga,n36
   real(wp) dum1,dum2,dd,vtyp(3),tors(n3)
   real(wp),allocatable:: ul(:,:), fl(:), pop(:,:), rl(:), pp(:)
   real(wp),allocatable:: d(:,:),u(:,:),bmat(:,:),rr(:), fl2(:)
   integer,allocatable::ind(:),ind2(:)

   write(*,*)
   write(*,*)'Pipek-Mezey localization of normal modes'
   do i=1,n3
      if(freq(i).lt.vthr) highest=i
   enddo

   nvar=highest-6
   write(*,*) 'number of localized modes ',nvar
   write(*,*) 'frequency thrshold        ',vthr
   write(*,*) 'number of groups          ',ng
   write(*,*) 'atom-group assingment :   '
   write(*,'(30i3)') group

   nvsq=nvar*(nvar+1)/2
   allocate ( pop(nvsq,ng),ul(n3,n3),u(n3,nvar),&
      &           fl(nvar),rl(nvar),rr(n3),fl2(n3),pp(ng),&
      &           d(nvar,nvar),ind(nvar),ind2(n3) )

   ! skip tr/rot
   do i=7,6+nvar
      u(1:n3,i-6)=uin(1:n3,i)
   enddo

   pop = 0
   ! do the popmat
   k=0
   do r=1,nvar
      do s=1,r-1
         k=k+1
         pp=0
         do a=1, n
            ga=group(a)
            do ij=1,3
               ija=ij+(a-1)*3
               pp(ga)=pp(ga)+u(ija,r)*u(ija,s)
            enddo
         enddo
         pop(k,1:ng)=pp(1:ng)*2.0d0
      enddo
      k=k+1
      do a=1, n
         ga=group(a)
         do ij=1,3
            ija=ij+(a-1)*3
            pop(k,ga)=pop(k,ga)+u(ija,r)*u(ija,r)
         enddo
      enddo
   enddo
   write(*,*) 'pop matrix done.'
   ! do the trafo
   call lopt(.true.,nvar,ng,1.d-6,pop,d)
   ! new freq, rmass
   do i=1,nvar
      dum1=0.0d0
      dum2=0.0d0
      do k=1,nvar
         dd=d(k,i)*d(k,i)
         dum1=dum1+freq (k+6)*dd
         dum2=dum2+rmass(k+6)*dd
      enddo
      fl(i)=dum1
      rl(i)=dum2
   enddo
   ! the local modes in ul
   CALL blas_gemm('N','N',n3,nvar,nvar,1.D0,u,n3,d,nvar,0.D0,ul,n3)

   ! sort
   do i=1,nvar
      ind(i)=i
   enddo
   call Qsort(fl, 1, nvar, ind)

   do i=1,nvar
      freq (i+6)=fl(    i )
      rmass(i+6)=rl(ind(i))
      uin(1:n3,i+6)=ul(1:n3,ind(i))
   enddo

end subroutine locmode

subroutine test_pbc_lancopt
   use xtb_mctc_accuracy, only : wp
   use assertion

   use xtb_type_molecule

   use model_phonons

   implicit none

   real(wp),parameter :: thr = 1.0e-9_wp
   integer, parameter :: nat = 6
   integer, parameter :: at(nat) = [22,22, 8, 8, 8, 8]
   real(wp),parameter :: xyz(3,nat) = reshape( &
      &[0.00000000_wp, 0.00000000_wp, 0.00000000_wp, &
      & 0.08499567_wp, 0.08499567_wp, 0.05476752_wp, &
      & 0.04795456_wp, 0.04795456_wp, 0.00000000_wp, &
      & 0.03704111_wp, 0.13295023_wp, 0.05476752_wp, &
      & 0.12203678_wp, 0.12203678_wp, 0.00000000_wp, &
      & 0.13295023_wp, 0.03704111_wp, 0.05476752_wp], shape(xyz))
   real(wp),parameter :: lattice(3,3) = reshape( &
      &[0.16999134_wp, 0.00000000_wp, 0.00000000_wp, &
      & 0.00000000_wp, 0.16999134_wp, 0.00000000_wp, &
      & 0.00000000_wp, 0.00000000_wp, 0.10953503_wp], shape(lattice))
   integer, parameter :: wsc_rep(3) = [1,1,1]

   type(TMolecule) :: mol
   type(mp_options)  :: opt = mp_options(k_stretch = 0.04_wp, coupled = .true.)

   integer :: i,j,ij
   integer :: nvar,npvar
   real(wp), allocatable :: hess(:)
   real(wp), allocatable :: phon(:,:)
   real(wp), allocatable :: freq(:)

   integer  :: info
   integer  :: lwork
   integer  :: liwork
   integer, allocatable :: iwork(:)
   real(wp),allocatable :: aux(:)

   call mol%allocate(nat)
   mol%at   = at
   mol%xyz  = xyz
   mol%npbc = 3
   mol%pbc  = .true.
   mol%lattice = lattice
   call mol%update
   call generate_wsc(mol,mol%wsc,wsc_rep)
   call generate_wsl(mol,mol%wsl,wsc_rep)


   call terminate(afail+1)

end subroutine test_pbc_lancopt

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Implementation of the dimer projection method for extended tight binding methods.
module xtb_dipro
   use mctc_env, only : error_type, fatal_error, get_argument, wp
   use mctc_io, only : structure_type, new
   use mctc_io_convert, only : autoev
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, assignment(=)
   use xtb_type_calculator, only : TCalculator
   use xtb_tblite_calculator, only : TTBLiteCalculator, TTBLiteInput, newTBLiteCalculator
   use xtb_setparam
#if WITH_TBLITE
   use xtb_dipro_bondorder, only : get_wiberg_bondorder
   use xtb_dipro_fragment, only : get_wiberg_fragment
   use xtb_dipro_output, only : format_list, to_string
   use xtb_dipro_xtb, only : get_calculator
   use tblite_basis_type, only : get_cutoff, basis_type
   use tblite_blas, only : dot, gemv, gemm
   use tblite_context_type, only : context_type
   use tblite_cutoff, only : get_lattice_points
   use tblite_integral_overlap, only : get_overlap
   use tblite_output_format, only : format_string
   use tblite_wavefunction_type, only : wavefunction_type, new_wavefunction, &
      & get_density_matrix
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_singlepoint, only : xtb_singlepoint
#endif
   implicit none
   private
   public :: get_jab, jab_input

   !> Configuration data for calculation
   type :: jab_input
      !> Flag for evoking DIPRO
      logical :: diprocalc
      !>Orbital degeneracy threshold
      real(wp) :: othr
      !> Name of the requested tight binding method
      character(len=:), allocatable :: method
      !> List of fragments, generated if not given here
      integer, allocatable :: fragment(:)
      !> Threshold for generating fragments from bond orders
      real(wp) :: thr = 0.1_wp
      !> Calculation accuracy
      real(wp) :: accuracy = 1.0_wp
      !> Output verbosity
      integer :: verbosity = 2
      !> total j_ab,eff in eV for test module
      real(wp) :: totjab(3)
   end type jab_input

   character(len=*), parameter :: source = 'xtb_dipro'
   !> Conversion factor from temperature to energy (Boltzmann's constant in atomic units)
   real(wp), parameter :: ktoau = 3.166808578545117e-06_wp

contains

!> Entry point for calculation of dimer projection (DIPRO) related properties
subroutine get_jab(env, tblite, mol, fragment, dipro)
   use, intrinsic :: iso_fortran_env, only : output_unit
   implicit none
   !> Molecular structure data
   type(TMolecule), intent(in) :: mol  
   !requested gfn method for calculations Input
   type(TTBLiteInput), intent(inout) :: tblite

   type(jab_input),intent(inout) :: dipro

   type(TEnvironment),intent(inout) :: env

   integer, allocatable, intent(inout) :: fragment(:)
#if WITH_TBLITE
   !> structure_type /= molecular structure
   type(structure_type) :: struc
   type(error_type),allocatable :: error

   type(context_type) :: ctx
   type(basis_type) :: bas
   !> fcalc is =xcalc just for fragments
   type(xtb_calculator) :: xcalc
   type(xtb_calculator), allocatable :: fcalc(:)
   !> mfrag is =struc just for fragments
   type(structure_type), allocatable :: mfrag(:)
   type(wavefunction_type) :: wfn
   !> wfx is =wfn just for fragments
   type(wavefunction_type), allocatable :: wfx(:)

   !> Molecular gradient, strain derivatives
   real(wp), allocatable :: gradient(:, :), sigma(:,:), nel(:)
   real(wp), allocatable :: overlap(:, :), trans(:, :), wbo(:, :), chrg(:), p2mat(:,:), coeff2(:,:),loc(:,:)
   real(wp), allocatable :: orbital(:, :, :), scmat(:, :), fdim(:, :), scratch(:), efrag(:),y(:,:),Edim(:,:)
   integer, allocatable :: spinfrag(:), start_index(:),end_index(:),orbprint(:)

   integer :: charge, stat, unit, ifr, nfrag, nao, i, j, k

   logical :: exist

   character(3) :: adv='NO '

   real(wp) :: energy, cutoff, jab, sab, jeff, Vtot(3)

!======================================================================================

   struc=mol

   if ( tblite%method == '' ) then 
      tblite%method = 'gfn2'
      call env%warning("No method provided, falling back to default GFN2-xTB.", source)
   end if

!=========================set up calculator===========================================   

   call get_calculator(xcalc, struc, tblite%method, error)  
   call new_wavefunction(wfn, struc%nat, xcalc%bas%nsh, xcalc%bas%nao, & 
      & 1, set%etemp * ktoau)
   wfn%nspin=1

!=========================print Header===============================================

   call generic_header(6,'D I P R O',49,10)

!=========================calculation for dimer======================================             

   write(*,'(A)') "Calculation for dimer "
   write(*,'(A)') "--------------------- "
   write(*,'(A)') "  "

   write(*,'(A,F4.0)') "charge of dimer : ", mol%chrg
   write(*,'(A,I2)') "unpaired e- of dimer : ", set%nalphabeta

   call xtb_singlepoint(ctx, struc, xcalc, wfn, tblite%accuracy, energy,gradient,sigma,2)
   if (ctx%failed()) then
       call env%error("Single point calculation for dimer failed.", source)
      return
   end if

   allocate(overlap(xcalc%bas%nao, xcalc%bas%nao),y(xcalc%bas%nao,2))
   cutoff = get_cutoff(xcalc%bas)
   call get_lattice_points(struc%periodic, struc%lattice, cutoff, trans) 
   call get_overlap(struc, trans, cutoff, xcalc%bas, overlap)  

!==================set up fragments if not given by xcontrol=========================

   if (allocated(fragment)) then
   else
      !> wfn%density is [nao,nao,spin], pmat in wiberg bondorder is [nao,nao], thus pmat2 is introduced here     
      allocate(wbo(struc%nat, struc%nat),p2mat(xcalc%bas%nao,xcalc%bas%nao))
      do i=1,xcalc%bas%nao
         do j=1,xcalc%bas%nao
            p2mat(i,j)=wfn%density(i,j,1)
         end do
      end do
      call get_wiberg_bondorder(xcalc%bas, overlap, p2mat, wbo)

      allocate(fragment(struc%nat))
      call get_wiberg_fragment(fragment, wbo, 0.1_wp)
   end if

   nfrag = maxval(fragment)
   select case(nfrag)
   case(:1)
      call ctx%message("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")
      call ctx%message("Found no fragments in the input structure.")
      call ctx%message("Aborting...")
      call env%error("Found no fragments in input structure.", source)
      return
   case(2:)
      call ctx%message("Found "//to_string(nfrag)//" fragments!")
      do ifr = 1, nfrag
         call ctx%message("Fragment "//to_string(ifr)//":  "//format_list(fragment == ifr))
      end do
      call ctx%message("")
      if (nfrag > 2) then
         call ctx%message("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")
         call ctx%message("Found "//to_string(nfrag)// &
            & " fragments in the input structure, too many fragments.")
         call ctx%message("Aborting...")
         call env%error("Found too many fragments in input structure.", source)
         return
      end if
   end select

   nao = size(wfn%emo)
   allocate(orbital(nao, nfrag,nao), efrag(nfrag), scmat(nao, nao), fdim(nao, nao), &
      & scratch(nao), mfrag(nfrag), wfx(nfrag), chrg(nfrag), spinfrag(nfrag), &
      & start_index(nfrag),end_index(nfrag),orbprint(nfrag),nel(nfrag))

!==================================external files CHRG & UHF read-in====================================

   inquire(file='.UHFfrag', exist=exist)
   if (exist) then
      open(file='.UHFfrag', newunit=unit)
      write(output_unit, '(a)') "[Info] Fragment spin read from .UHFfrag"
      read(unit,*,iostat=stat) spinfrag(1),spinfrag(2)
      close(unit)
   else if (set%nalphabeta .ne. 0) then
      call ctx%message("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!ERROR!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!")
      call ctx%message("Total spin specified but no fragment spins. Spins are not determined &
              &automatically by xtb. Please set up .UHFfrag or use total spin =0." )
      call ctx%message("Aborting...")
      call env%error("Total spin specified but no fragment spins.", source)
      return
   else
      spinfrag=0
   end if

   inquire(file='.CHRGfrag', exist=exist)
   if (exist) then
      open(file='.CHRGfrag', newunit=unit)
      write(output_unit, '(a)') "[Info] Fragment charge read from .CHRGfrag"
      read(unit,*,iostat=stat) chrg(1),chrg(2)
      close(unit)
   else
      chrg=0
   end if

!=================================fragment calculations=============================================   

   allocate(fcalc(nfrag))
   do ifr = 1, nfrag 
      call ctx%message("Calculation for fragment "//to_string(ifr))
      write(*,*) "------------------------------"
      write(*,*) "  "
      call get_structure_fragment(mfrag(ifr), struc, fragment == ifr)

      !> summation of fragment charges stored in chrg(nfrag)
      if ( all(chrg.eq.0) ) then
         chrg(ifr)=0
         !> fragment mask generated on the fly 
         chrg(ifr)=sum(pack(wfn%qat(:,1), fragment == ifr)) !> wfn%qat is [nat,nspin=1]
         mfrag(ifr)%charge=nint(chrg(ifr))
      else
         mfrag(ifr)%charge=nint(chrg(ifr))
      end if
      write(*,'(A,F4.0)') "charge of fragment : ", mfrag(ifr)%charge

      !> uhf fragments spins
      mfrag(ifr)%uhf = spinfrag(ifr)
      write(*,'(A,I2)') "unpaired e- of fragment : ", mfrag(ifr)%uhf

      call get_calculator(fcalc(ifr), mfrag(ifr), tblite%method, error)
      !> mol%charge is updated automatically from wfn by tblite library 
      call new_wavefunction(wfx(ifr), mfrag(ifr)%nat, fcalc(ifr)%bas%nsh, fcalc(ifr)%bas%nao, &
         & 1, set%etemp * ktoau)

     !> mol%type (dimer) == mfrag%type (fragments), wfn (dimer) == wfx (fragments), calc (dimer)==fcalc(fragments)
      wfx%nspin=1
      call xtb_singlepoint(ctx, mfrag(ifr), fcalc(ifr), wfx(ifr), tblite%accuracy, energy)
      if (ctx%failed()) then
         call env%error("Single point calculation for fragment failed.", source)
         return
      end if

      nel(ifr)=wfx(ifr)%nel(1)+wfx(ifr)%nel(2)

!==================================DIPRO==================================================

      do j = 1, fcalc(ifr)%bas%nao
         !> coeff is [nao,nao,spin=1]
         call unpack_coeff(xcalc%bas, fcalc(ifr)%bas, orbital(:, ifr, j), &
         & wfx(ifr)%coeff(:, j,1), fragment == ifr)
      end do 
   end do

   allocate(coeff2(nao,nao),Edim(nao,nao))
   Edim=0
   do i=1,nao
      Edim(i,i)=wfn%emo(i,1)
      do j=1,nao
         coeff2(i,j)=wfn%coeff(i,j,1) 
      end do
   end do

   start_index = -1
   end_index = -1

   !> find out which orbitals are within [HOMO-othr,LUMO+othr] and should be considered for DIPRO
   write(*,*) "  "
   write(*,*) "  ::::::::::::::::::::::::::::::::::::::::::::::"
   write(*,*) "  ::     D I P R O      C O U P L I N G S     ::"
   write(*,*) "  ::::::::::::::::::::::::::::::::::::::::::::::"
   write(*,*) "  "

   call ctx%message("energy threshhold for near-degenerate orbitals near HOMO and LUMO &
           &considered for DIPRO: "//format_string(dipro%othr, '(f6.3)')//" eV")

   do ifr=1,nfrag
      do j = 1, fcalc(ifr)%bas%nao
         if (wfx(ifr)%emo(j,1) .ge. (wfx(ifr)%emo(wfx(ifr)%homo(2),1) - dipro%othr/autoev) .and.&
           & wfx(ifr)%emo(j,1) .le. (wfx(ifr)%emo(wfx(ifr)%homo(2)+1,1) + dipro%othr/autoev)) then
           if (start_index(ifr).eq.-1) then 
                   start_index(ifr) = j
              end if
              end_index(ifr) = j
         endif
      end do
      write(*,'(A, I2, I10)') "no. of orbitals within energy window of frag", ifr, end_index(ifr)-start_index(ifr)+1
   end do
   write(*,*) "  "

!========================================DIPRO equations===========================================
!> equations after B. Baumeier, J. Kirkpatrick, D. Andrienko, PCCP 2010, 12, 11103.
!> y_A^i = C_A^i * S_AB * C_AB                  orbital projection of monomer A onto dimer
!> y_B^j = C_B^j * S_AB * C_AB                  orbital projection of monomer B onto dimer
!> S_ab^ij = y_A^i * y_B^j                      projected overlap
!> E_A^i = y_A^i * E_AB * y_A^i                 site energy monomeCALL execute_command_line('wc -l < file.txt > wc.txt' )r A
!> E_B^j = y_B^j * E_AB * y_B^j                 site energy monomer B
!> J_AB^ij = y_A^i * E_AB * y_B^j               coupling integral J_AB
!> J_AB^ij effective = (J_AB^ij - (E_A^i + E_B^j) / 2 * S_ab^ij) / (1 - S_ab^ij * S_ab^ij)            
!> A,B: monomers   AB: dimer
!> i,j: orbitals of the monomers
!> C: orbital coefficients     S: overlap matrix      E: orbital energy of the dimer

   Vtot=0
   !> gemm(amat,bmat,cmat,transa,transb,a1,a2): X=a1*Amat*Bmat+a2*Cmat
   !> scmat=S_dim*C_dim
   call gemm(overlap, coeff2, scmat)
   do j = start_index(1), end_index(1)
      orbprint(1)=wfx(1)%homo(max(2,1))-j

      y(:,1)=0
      !> gemv(amat, xvec,yvec,a1,a2,transa): X=a1*Amat*xvec+a2*yvec
      !> y_mon1(ifr)=C_mon1(j)*S_dim*C_dim
      call gemv( scmat, orbital(:, 1, j), y(:,1), trans="t" )
      !> scratch=E_dim*y1(j)
      call gemv( Edim, y(:,1), scratch )
      !> E_mon=y1(j)*E_dim*y1(j)
      efrag(1)=dot( y(:,1), scratch)

      do k = start_index(2), end_index(2)
         orbprint(2)=wfx(2)%homo(max(2,1))-k

         y(:,2)=0
         !> y_mon2(ifr)=C_mon2(k)*S_dim*C_dim
         call gemv( scmat, orbital(:, 2, k), y(:,2), trans="t" )
         !> scratch=E_dim*y2(k)
         call gemv( Edim, y(:,2), scratch )
         !> E_mon=y(ifr)*E_dim*y2(k)
         efrag(2)=dot( y(:,2), scratch)

         !> sab=y1(j)*y2(k)
         sab=dot( y(:,1), y(:,2) )
         !> jab=y1(j)*E_dim*y2(k)
         jab=dot( y(:,1), scratch )

         jeff = (jab - sum(efrag) / nfrag * sab) / (1.0_wp - sab**2)

!=======================================Printout============================================         

         do ifr=1,2

            !> both coupling monomer orbitals are printed in the same line
            if (ifr.eq.2) then 
               adv='YES'
            else
               adv='NO '
            end if

            !> if the number of electrons is odd, the SOMO is the new HOMO
            if (mod(nint(nel(ifr)),2).eq.1) then
               if (orbprint(ifr).gt.0) then
                    write(*, '( "  Fragment ", I1, " SOMO-", I1 )', ADVANCE=adv ) ifr, orbprint(ifr)
                  else if (orbprint(ifr).eq.0) then
                    write(*, '( "  Fragment ", I1, " SOMO ")', ADVANCE=adv ) ifr
                  else if (orbprint(ifr).eq.-1) then
                    write(*, '( "  Fragment ", I1, " LUMO ")', ADVANCE=adv ) ifr
                  else if (orbprint(ifr).lt.-1) then
                    write(*, '( "  Fragment ", I1, " LUMO+", I1 )', ADVANCE=adv ) ifr, abs(orbprint(ifr))-1
               end if
            else if (mod(nint(nel(ifr)),2).eq.0) then
               if (orbprint(ifr).gt.0) then
                    write(*, '( "  Fragment ", I1, " HOMO-", I1 )', ADVANCE=adv ) ifr, orbprint(ifr)
                  else if (orbprint(ifr).eq.0) then
                    write(*, '( "  Fragment ", I1, " HOMO ")', ADVANCE=adv ) ifr
                  else if (orbprint(ifr).eq.-1) then
                    write(*, '( "  Fragment ", I1, " LUMO ")', ADVANCE=adv ) ifr
                  else if (orbprint(ifr).lt.-1) then
                    write(*, '( "  Fragment ", I1, " LUMO+", I1 )', ADVANCE=adv ) ifr, abs(orbprint(ifr))-1
               end if
            end if
         end do
         write(*,'(A)') "--------------------------------------"

         call ctx%message("E_mon(orb) frag1 frag2"//format_string(efrag(1)*autoev, '(f20.3)')// &
           &format_string(efrag(2)*autoev, '(f10.3)')//" eV")
         call ctx%message("J(AB): "//format_string(jab*autoev, '(f20.3)')//" eV")    
         call ctx%message("S(AB): "//format_string(sab, '(f22.8)')//" Eh")
         call ctx%message("|J(AB,eff)|: "//format_string(abs(jeff)*autoev, '(f16.3)')//" eV")
         write(*,*) "  "

         !> Vtotal=sqrt(sum(jeff^2)) for 1. occ-->occ; 2. virt-->virt; 3. occ-->virt/virt-->occ transitions
         if(orbprint(1).ge.0.and.orbprint(2).ge.0) then
            Vtot(1)=Vtot(1)+jeff**2
         else if (orbprint(1).le.-1.and.orbprint(2).le.-1) then
            Vtot(2)=Vtot(2)+jeff**2
         else 
            Vtot(3)=Vtot(3)+jeff**2
         end if

      end do
   end do

   dipro%totjab(1)=sqrt(Vtot(1))*autoev
   dipro%totjab(2)=sqrt(Vtot(2))*autoev
   dipro%totjab(3)=sqrt(Vtot(3))*autoev
   
   write(*,'(A)') ".............................................................................."
   call ctx%message(":  total |J(AB,eff)| for hole transport (occ. MOs) :"//format_string(sqrt(Vtot(1))*autoev, '(f20.3)')//" eV  :")
   call ctx%message(":  total |J(AB,eff)| for charge transport (unocc. MOs) :"//format_string(sqrt(Vtot(2))*autoev,& 
          &'(f16.3)')//" eV  :")
   call ctx%message(":  total |J(AB,eff)| for charge transfer (CT) :"//format_string(sqrt(Vtot(3))*autoev, '(f25.3)')//" eV  :")
   write(*,'(A)') ".............................................................................."

   write(*,*) " "
   write(*,*) "Please remember, DIPRO is not available for restart!"
   write(*,*) "  "
   write(*,'(A)') "normal termination of dipro"
#else
   Call env%error("DIPRO is not available without TBLite.", source)
#endif

end subroutine get_jab

#if WITH_TBLITE
!> Unpack coefficients from a fragment orbital space in the full orbital space
subroutine unpack_coeff(full_bas, frag_bas, full, frag, mask)
   !> Basis set information for full system
   type(basis_type), intent(in) :: full_bas
   !> Basis set information for fragment
   type(basis_type), intent(in) :: frag_bas
   !> Quantity in full orbital space
   real(wp), intent(out) :: full(:)
   !> Quantity in fragment orbital space
   real(wp), intent(in) :: frag(:)
   !> Atom resolved mask for this fragment
   logical, intent(in) :: mask(:)

   integer :: iat, jat, ish, ii, jj, iao, jao, nao

   jat = 0
   do iat = 1, size(mask)
      if (mask(iat)) then
         jat = jat + 1
         ii = full_bas%ish_at(iat)
         jj = frag_bas%ish_at(jat)
         do ish = 1, full_bas%nsh_at(iat)
            iao = full_bas%iao_sh(ii+ish)
            jao = frag_bas%iao_sh(jj+ish)
            nao = full_bas%nao_sh(ii+ish)
            full(iao+1:iao+nao) = frag(jao+1:jao+nao)
         end do
      else
         ii = full_bas%ish_at(iat)
         do ish = 1, full_bas%nsh_at(iat)
            iao = full_bas%iao_sh(ii+ish)
            nao = full_bas%nao_sh(ii+ish)
            full(iao+1:iao+nao) = 0.0_wp
         end do
      end if
   end do
end subroutine unpack_coeff


!> Extract a the fragment structure from the full structure
subroutine get_structure_fragment(frag, struc, mask) !mol
   !> Molecular structure data of the fragment
   type(structure_type), intent(out) :: frag
   !> Molecular structure data of the full system
   type(structure_type), intent(in) :: struc  !mol
   !> Atom resolved mask for this fragment
   logical, intent(in) :: mask(:)

   integer :: nat
   integer, allocatable :: num(:)
   real(wp), allocatable :: xyz(:, :)

   nat = count(mask)
   num = pack(struc%num(struc%id), mask)
   xyz = reshape(pack(struc%xyz, spread(mask, 1, 3)), [3, nat])
   call new(frag, num, xyz)
end subroutine get_structure_fragment
#endif

end module xtb_dipro

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> DFT-D3 Covalent radii for coordination number
module xtb_param_covalentradd3
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert, only : aatoau
   use xtb_mctc_symbols, only : toNumber
   implicit none
   private

   public :: getCovalentRadD3, covalentRadD3


   !> Get atomic radius for a species
   interface getCovalentRadD3
      module procedure :: getCovalentRadD3Symbol
      module procedure :: getCovalentRadD3Number
   end interface getCovalentRadD3


   !> Covalent radii (taken from Pyykko and Atsumi, Chem. Eur. J. 15, 2009,
   !> 188-197), values for metals decreased by 10%.
   real(wp), parameter :: covalentRadD3(1:118) = [ &
      & 0.32_wp,0.46_wp, & ! H,He
      & 1.20_wp,0.94_wp,0.77_wp,0.75_wp,0.71_wp,0.63_wp,0.64_wp,0.67_wp, & ! Li-Ne
      & 1.40_wp,1.25_wp,1.13_wp,1.04_wp,1.10_wp,1.02_wp,0.99_wp,0.96_wp, & ! Na-Ar
      & 1.76_wp,1.54_wp, & ! K,Ca
      &                 1.33_wp,1.22_wp,1.21_wp,1.10_wp,1.07_wp, & ! Sc-
      &                 1.04_wp,1.00_wp,0.99_wp,1.01_wp,1.09_wp, & ! -Zn
      &                 1.12_wp,1.09_wp,1.15_wp,1.10_wp,1.14_wp,1.17_wp, & ! Ga-Kr
      & 1.89_wp,1.67_wp, & ! Rb,Sr
      &                 1.47_wp,1.39_wp,1.32_wp,1.24_wp,1.15_wp, & ! Y-
      &                 1.13_wp,1.13_wp,1.08_wp,1.15_wp,1.23_wp, & ! -Cd
      &                 1.28_wp,1.26_wp,1.26_wp,1.23_wp,1.32_wp,1.31_wp, & ! In-Xe
      & 2.09_wp,1.76_wp, & ! Cs,Ba
      &         1.62_wp,1.47_wp,1.58_wp,1.57_wp,1.56_wp,1.55_wp,1.51_wp, & ! La-Eu
      &         1.52_wp,1.51_wp,1.50_wp,1.49_wp,1.49_wp,1.48_wp,1.53_wp, & ! Gd-Yb
      &                 1.46_wp,1.37_wp,1.31_wp,1.23_wp,1.18_wp, & ! Lu-
      &                 1.16_wp,1.11_wp,1.12_wp,1.13_wp,1.32_wp, & ! -Hg
      &                 1.30_wp,1.30_wp,1.36_wp,1.31_wp,1.38_wp,1.42_wp, & ! Tl-Rn
      & 2.01_wp,1.81_wp, & ! Fr,Ra
      &         1.67_wp,1.58_wp,1.52_wp,1.53_wp,1.54_wp,1.55_wp,1.49_wp, & ! Ac-Am
      &         1.49_wp,1.51_wp,1.51_wp,1.48_wp,1.50_wp,1.56_wp,1.58_wp, & ! Cm-No
      &                 1.45_wp,1.41_wp,1.34_wp,1.29_wp,1.27_wp, & ! Lr-
      &                 1.21_wp,1.16_wp,1.15_wp,1.09_wp,1.22_wp, & ! -Cn
      &                 1.36_wp,1.43_wp,1.46_wp,1.58_wp,1.48_wp,1.57_wp] & ! Nh-Og
      & * aatoau * 4.0_wp / 3.0_wp


contains


!> Get covalent radius for species with a given symbol
elemental function getCovalentRadD3Symbol(symbol) result(rad)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> atomic radius
   real(wp) :: rad

   rad = getCovalentRadD3(toNumber(symbol))

end function getCovalentRadD3Symbol


!> Get covalent radius for species with a given atomic number
elemental function getCovalentRadD3Number(number) result(rad)

   !> Atomic number
   integer, intent(in) :: number

   !> atomic radius
   real(wp) :: rad

   if (number > 0 .and. number <= size(covalentRadD3, dim=1)) then
      rad = covalentRadD3(number)
   else
      rad = -1.0_wp
   end if

end function getCovalentRadD3Number


end module xtb_param_covalentradd3

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_wsc
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   implicit none
   private

   public :: collect_wsc

contains

!> Collect all exported unit tests
subroutine collect_wsc(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("0d", test_wigner_seitz_0d), &
      new_unittest("3d", test_wigner_seitz_3D) &
      ]

end subroutine collect_wsc


subroutine test_wigner_seitz_0d(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule
   use xtb_type_wsc
   type(error_type), allocatable, intent(out) :: error
   type(TMolecule) :: mol
   type(tb_wsc) :: wsc

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      [ 0.00000000000000_wp,  0.00000000000000_wp, -0.73578586109551_wp, &
      & 1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp, &
      &-1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp  &
      & ],shape(xyz))

   call init(mol, at, xyz)

   call generate_wsc(mol,wsc)

   call check(error, allocated(wsc%lattr))
   call check(error, allocated(wsc%itbl))

   call check(error, all(wsc%itbl <= 1))
   call check(error, all(wsc%lattr == 0))

end subroutine test_wigner_seitz_0D

subroutine test_wigner_seitz_3D(error)
   use xtb_mctc_accuracy, only : wp

   use xtb_type_molecule
   use xtb_type_wsc

   use xtb_pbc_tools

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   ! CaF2
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [9,9,20]
   real(wp),parameter :: abc(3,nat) = reshape(&
      &[0.25_wp, 0.25_wp, 0.25_wp, &
      & 0.75_wp, 0.75_wp, 0.75_wp, &
      & 0.00_wp, 0.00_wp, 0.00_wp], shape(abc))
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[5.9598811567890_wp,      2.1071361905157_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      6.3214085715472_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      0.0000000000000_wp,      7.2993338808807_wp],   &
      & shape(lattice))

   type(TMolecule) :: mol
   type(tb_wsc) :: wsc
   real(wp), allocatable :: xyz(:, :)

   allocate(xyz(3, nat))
   call coord_trafo(nat,lattice,abc,xyz)
   call init(mol, at, xyz, lattice=lattice)

   call generate_wsc(mol,wsc)

   call check(error, allocated(wsc%lattr))
   call check(error, allocated(wsc%itbl))

   call check(error, all(abs(wsc%lattr) <= 1))
   call check(error, wsc%itbl(1,1), 12)
   call check(error, wsc%itbl(2,2), 12)
   call check(error, wsc%itbl(3,3), 12)
   call check(error, wsc%itbl(1,2), 6)
   call check(error, wsc%itbl(1,3), 4)
   call check(error, wsc%itbl(2,3), 4)
   call check(error, wsc%itbl(1,2), wsc%itbl(2,1))
   call check(error, wsc%itbl(1,3), wsc%itbl(3,1))
   call check(error, wsc%itbl(2,3), wsc%itbl(3,2))

end subroutine test_wigner_seitz_3D

end module test_wsc

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!---------------------------------------------------------------------
module xtb_lin
!---------------------------------------------------------------------


contains

  !***********************************************************************
  !* address in packed array
  !***********************************************************************

  pure elemental integer function lin(i1,i2)
    !$acc routine seq
    integer,intent(in) :: i1,i2
    integer :: idum1,idum2
    idum1=max(i1,i2)
    idum2=min(i1,i2)
    lin=idum2+idum1*(idum1-1)/2
    return
  end function lin

  pure elemental integer function lina(i1,i2)
    integer,intent(in) :: i1,i2
    integer :: idum1,idum2
    idum1=max(i1,i2)
    idum2=min(i1,i2)
    lina=idum2+idum1*(idum1-1)/2
    return
  end function lina


end module xtb_lin

   ! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_fragments
   implicit none
   public :: TFragments
   public :: len
   private


   type :: TFragments
      integer, allocatable :: list(:)
      integer :: n = 0
   contains
      generic :: allocate => new_default, new_from_list
      procedure, private :: new_default => frag_new_default
      procedure, private :: new_from_list => frag_new_from_list
      procedure :: get_list => frag_get_list
      procedure :: deallocate => frag_destroy
   end type TFragments


   interface len
      module procedure :: frag_length
   end interface len


contains


subroutine frag_new_default(self, number_of_atoms)
   class(TFragments), intent(inout) :: self
   integer, intent(in) :: number_of_atoms
   allocate(self%list(number_of_atoms), source=0)
end subroutine frag_new_default

subroutine frag_new_from_list(self, list)
   class(TFragments), intent(inout) :: self
   integer, intent(in) :: list(:)
   if (all(list > 0)) then
      self%list = list
      self%n = maxval(list)
   endif
end subroutine frag_new_from_list


integer pure elemental function frag_length(self) result(length)
   class(TFragments), intent(in) :: self
   if (allocated(self%list)) then
      length = maxval(self%list)
   else
      length = 0
   endif
end function frag_length


subroutine frag_get_list(self, fragment, list)
   class(TFragments), intent(in) :: self
   integer, intent(in) :: fragment
   integer, allocatable, intent(out) :: list(:)
   integer :: i
   list = pack([(i, i=1, size(self%list, 1))], mask=self%list.eq.fragment)
end subroutine frag_get_list


subroutine frag_destroy(self)
   class(TFragments), intent(inout) :: self
   if (allocated(self%list)) deallocate(self%list)
end subroutine frag_destroy


end module xtb_type_fragments

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_extern_driver
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_io, only: stdout
   use xtb_mctc_filetypes, only: fileType, generateFileName
   use xtb_mctc_symbols, only: toSymbol
   use xtb_type_calculator, only: TCalculator
   use xtb_type_data, only: scc_results
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule, only: TMolecule, len
   use xtb_type_param, only: scc_parameter
   use xtb_type_restart, only: TRestart
   use xtb_io_writer, only: writeMolecule
   use xtb_mctc_systools
   use xtb_mctc_strings
   use xtb_setparam
   use xtb_readin
   use xtb_mctc_convert
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_metadynamic
   use xtb_constrainpot
   use xtb_extern_turbomole, only: wrtm, rdtm
   implicit none
   private

   public :: TDriverCalculator, newDriverCalculator, checkExe

   type, extends(TCalculator) :: TDriverCalculator
      type(qm_external) :: ext
   contains
      !> Perform single point calculation
      procedure :: singlepoint
      !> Write informative printout
      procedure :: writeInfo
   end type TDriverCalculator
   
   character,parameter :: tilde = '~'

contains

!> Create a new calculator for driving the external driver program
subroutine newDriverCalculator(self, env, ext)

   !> Instance of the external driver calculator
   type(TDriverCalculator), intent(out) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Settings for the external driver calculator
   type(qm_external), intent(in) :: ext

   self%threadsafe = .false.
   self%ext = ext

end subroutine newDriverCalculator

subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)

   !> Source of the generated errors
   character(len=*), parameter :: source = 'extern_driver_singlepoint'
   
   !> Calculator instance
   class(TDriverCalculator), intent(inout) :: self
   
   !> Computational environment
   type(TEnvironment), intent(inout) :: env
   
   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol
   
   !> Wavefunction data
   type(TRestart), intent(inout) :: chk
   
   !> Print level for IO
   integer, intent(in) :: printlevel
   
   !> Restart from previous results
   logical, intent(in) :: restart
   
   !> Total energy
   real(wp), intent(out) :: energy
   
   !> Molecular gradient
   real(wp), intent(out) :: gradient(:, :)
   
   !> Strain derivatives
   real(wp), intent(out) :: sigma(:, :)
   
   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap
   
   !> Detailed results
   type(scc_results), intent(out) :: results

   integer :: i, ich
   integer :: mode_sp_run = 1
   real(wp) :: efix
   real(wp) :: dipole(3)
   logical :: cache, exist
   logical, parameter :: ccm = .true.
   logical :: exitRun
   character(len=*), parameter :: outfmt = &
                                 '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'
   real(wp) :: xyz_cached(3, mol%n)
   integer :: err
   character(len=:),allocatable :: extension
   character(len=:),allocatable :: tmpname

   !> executable
   character(len=50), allocatable :: exe(:)
   character(len=:), allocatable :: buff

   !> number of arguments
   integer :: nargs

   call mol%update

   cache = .false.
   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   hlgap = 0.0_wp
   efix = 0.0_wp
   dipole(:) = 0.0_wp

   !$omp critical (turbo_lock)
   inquire (file='gradient', exist=exist)

   if (exist) then
      ! ### only TM output is supported for now ###
      call rdtm(env,mol%n, .true., energy, gradient, xyz_cached)
      cache = all(abs(xyz_cached - mol%xyz) < 1.e-10_wp)
      if (cache .and. printlevel > 0) then 
         write(env%unit,'(/,a,/)') &
         & "Geometry is equivalent to the one in &
         & 'gradient'. Reading gradient from: 'gradient'."
      endif
   end if

   if (.not. cache) then

      call generateFileName(tmpname, 'xtbdriver', extension, mol%ftype)
      
      if (printlevel > 0) then
         write(env%unit,'(/,a,1x,a,/)') &
            "updated geometry written to:",tmpname
      endif
      
      call open_file(ich,tmpname,'w')
      
      if (exist) then
         call writeMolecule(mol, ich, format=mol%ftype, energy=energy, &
            & gnorm=norm2(gradient))
      else
         call writeMolecule(mol, ich, format=mol%ftype)
      end if
      
      call close_file(ich)

      write (env%unit, '(72("="))')
      write (env%unit, '(1x,"*",1x,a)') &
      "letting driver take over the control..."

      ! check driver executable !
      allocate(exe(1))
      call parse(self%ext%executable,' ',exe,nargs)
      
      ! if absolute path is given !
      if (index(exe(1),"/").ne.0) then 
         buff = exe(1)
         call checkExe(env,buff)
      else 
         call checkExe(env,buff,exe(1))
      endif

      call execute_command_line('exec 2>&1 '//self%ext%executable, exitstat=err)
      
      if (err /= 0) then
         call raise('E','driver returned with non-zero exit status, doing the same')
      else
         write (env%unit, '(1x,"*",1x,a)') &
            "successful driver run, taking over control again..."
      end if

      write (env%unit, '(72("="))')

      ! only TM output is supported for now !
      call rdtm(env,mol%n, .true., energy, gradient, xyz_cached)

   end if

   !$omp end critical (turbo_lock)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Electronic structure method terminated", source)
      return
   end if

   ! various external potentials !
   call constrain_pot(potset, mol%n, mol%at, mol%xyz, gradient, efix)
   call constrpot(mol%n, mol%at, mol%xyz, gradient, efix)
   call cavity_egrad(mol%n, mol%at, mol%xyz, efix, gradient)
   call metadynamic(metaset, mol%n, mol%at, mol%xyz, efix, gradient)
   call metadynamic(rmsdset, mol%n, mol%at, mol%xyz, efix, gradient)

   ! fixing of certain atoms !
   energy = energy + efix
   results%e_total = energy
   results%gnorm = norm2(gradient)
   results%dipole = dipole
   if (fixset%n .gt. 0) then
      do i = 1, fixset%n
         gradient(1:3, fixset%atoms(i)) = 0
      end do
   end if

   if (printlevel .ge. 2) then
      
      ! start with summary header !
      if (.not. set%silent) then
         write (env%unit, '(9x,53(":"))')
         write (env%unit, '(9x,"::",21x,a,21x,"::")') "SUMMARY"
      end if

      write (env%unit, '(9x,53(":"))')
      write (env%unit, outfmt) "total energy      ", results%e_total, "Eh   "
      write (env%unit, outfmt) "gradient norm     ", results%gnorm, "Eh/a0"
      write (env%unit, outfmt) "HOMO-LUMO gap     ", results%hl_gap, "eV   "
      write (env%unit, '(9x,53(":"))')
      write (env%unit, '(a)')
   end if

end subroutine singlepoint

subroutine writeInfo(self, unit, mol)

   !> Calculator instance
   class(TDriverCalculator), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   call generic_header(unit, "Driver", 49, 10)

end subroutine writeInfo

!> find executable in the system 
subroutine checkExe(env,name,prog)

   !> traceback
   character(len=*), parameter :: source = "extern_driver_checkExe"

   !> calculation environment
   type(TEnvironment), intent(inout) :: env

   !> exe
   character(len=:), allocatable, intent(inout) :: name

   !> exe name to search for
   character(len=*), intent(in), optional :: prog

   !> absolute path to home dir
   character(len=:),allocatable :: homedir

   !> $PATH 
   character(len=:),allocatable :: syspath
   
   !> file existence bool 
   logical :: exists


   
   ! user-provided executable name !
   if (allocated(name)) then    
 
      if (name(1:1).eq.tilde) then ! relative -> absolute path convertion !
         call rdvar('HOME',homedir)   
         name = homedir // name(2:)
      endif 

      ! system search !
      inquire(file=name,exist=exists)
      
      if (.not.exists) then
         call raise('E',"'"//trim(name)//"' was not found, please check")
      endif

   ! no exe !
   else
      
      ! search for prog executable in $PATH !
      if (present(prog)) then

         call rdvar('PATH',syspath)
         call rdpath(syspath,prog,name,exists)

         if (.not.exists) then
            call raise('E','Could not locate '//trim(prog)//' executable')
         endif
      
      else
         call raise('E','No executable specified')  
      endif  

   endif
   
end subroutine checkExe

end module xtb_extern_driver

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_oniom
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_oniom

contains

!> Collect all exported unit tests
subroutine collect_oniom(testsuite)
   type(unittest_type),allocatable,intent(out) :: testsuite(:)
      !! array of objects(unit tests)

   testsuite = [ &
      new_unittest("calculateCharge", test_oniom_calculateCharge), &
         !! function that registers a new unit test -> result unittest_type object
      new_unittest("cutbond", test_oniom_cutbond), &
      new_unittest("singlepoint", test_oniom_singlepoint) &
      ]

end subroutine collect_oniom 

!---------------------------------------------
! Unit test for automatic charge determination
!---------------------------------------------
subroutine test_oniom_calculateCharge(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_convert, only : aatoau

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_basisset
   use xtb_type_environment
   use xtb_setparam
   
   use xtb_oniom, only : TOniomCalculator, calculateCharge, newOniomCalculator, oniom_input
   use xtb_xtb_calculator, only : TxTBCalculator,newWavefunction
   use xtb_io_writer 
   use xtb_mctc_filetypes, only : filetype
   type(error_type), allocatable, intent(out) :: error
      !! error message type, with stat amd message
   real(wp), parameter :: thr = 1.0e-7_wp
   !> Molecular structure data
   integer, parameter :: nat = 17
      !! 1,3 pentadiene-1-cation + h2o
   integer, parameter :: at(nat) = [6,6,6,6,6,1,1,1,1,1,1,1,1,1, 8,1,1]
   real(wp), parameter :: xyz(3,nat) = reshape(&
      [ 7.11179039031184_wp, -0.65533236978132_wp,  0.64998029924754_wp, &
      & 9.54574522537207_wp,  0.30133566481849_wp,  0.45943898636196_wp, &
      & 5.13954887436106_wp,  0.33928833942508_wp, -0.70036877110532_wp, &
      &11.69126318297630_wp, -0.71972100226778_wp,  1.75001053205592_wp, &
      & 2.55237710171780_wp, -0.58098675992530_wp, -0.59290041363421_wp, &
      & 6.76811222294413_wp, -2.23038959587740_wp,  1.90836157103276_wp, &
      & 9.86172384803294_wp,  1.88061446715386_wp, -0.80779818687663_wp, &
      & 5.50044858469288_wp,  1.92224580974752_wp, -1.95079140534105_wp, &
      &11.22134447610320_wp, -1.94366600251515_wp,  3.32992090742500_wp, &
      &12.66603076756040_wp, -1.91198818602751_wp,  0.30482336978588_wp, &
      &13.10010470005330_wp,  0.69862396283326_wp,  2.23170047213733_wp, &
      & 1.27494163620898_wp,  0.97527170197973_wp, -0.13473721665480_wp, &
      & 1.96940212226880_wp, -1.18150778329094_wp, -2.48288874184834_wp, &
      & 2.29849092954603_wp, -2.12388855284911_wp,  0.73684528757996_wp, &
      &14.20884549186960_wp, -3.85859246461132_wp, -2.12437520158188_wp, &
      &13.93153897438870_wp, -5.65462186833272_wp, -2.15399113818471_wp, &
      &15.98310331300670_wp, -3.59190426260830_wp, -2.41348990450454_wp  &
      & ], shape(xyz))
   
   type(TMolecule)  :: mol
   type(TRestart)   :: chk1,chk2
   type(TEnvironment)       :: env
   type(TOniomCalculator)   :: calc1,calc2
   type(oniom_input)        :: oniom_input1, oniom_input2

   
   integer ::  innchrg, innchrg2
   
   call init(env)
      !! construct calculation environment

   call init(mol, at, xyz)
      !! construct molecular structure type
      !! interface to initMoleculeNumbers
   mol%chrg = 1.0_wp
   !> allocate calculation  settings
   oniom_input1%first_arg = 'turbomole:gfn2'
   oniom_input2%first_arg = 'orca:gfn2'
   oniom_input1%second_arg = '1-14'
   oniom_input2%second_arg = '15-17'
   
   call newOniomCalculator(calc1,env,mol,oniom_input1)
   select type(xtb => calc1%real_low)
   type is(TxTBCalculator)
      call chk1%wfn%allocate(mol%n,xtb%basis%nshell,xtb%basis%nao)
      call newWavefunction(env,mol,xtb,chk1)
   end select
   innchrg=calculateCharge(calc1,env,mol,chk1)
   call check_(error,calc1%method_low,2)
   call check_(error,calc1%method_high,5)
   call check_(error,chk1%wfn%q(6),0.159091489555113_wp, thr=thr)
   call check_(error,chk1%wfn%q(17),0.340373819431617_wp, thr=thr)
   call check_(error,innchrg,1)

   call newOniomCalculator(calc2,env,mol,oniom_input2)
   select type(xtb => calc2%real_low)
   type is(TxTBCalculator)
      call chk2%wfn%allocate(mol%n,xtb%basis%nshell,xtb%basis%nao)
      call newWavefunction(env,mol,xtb,chk2)
   end select

   innchrg2=calculateCharge(calc2,env,mol,chk2)
   call check_(error,calc2%method_low,2)
   call check_(error,calc2%method_high,4)
   call check_(error,chk2%wfn%q(6),0.159091489555113_wp, thr=thr)
   call check_(error,chk2%wfn%q(17),0.340373819431617_wp, thr=thr)
   call check_(error,innchrg2,0)

endsubroutine test_oniom_calculateCharge

!---------------------------------------------
! Unit test for cutbond
!---------------------------------------------
subroutine test_oniom_cutbond(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_convert, only : aatoau

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_basisset
   use xtb_type_environment
   use xtb_setparam
   
   use xtb_oniom, only : TOniomCalculator, calculateCharge, newOniomCalculator, oniom_input
   use xtb_xtb_calculator, only : TxTBCalculator,newWavefunction
   use xtb_io_writer 
   use xtb_mctc_filetypes, only : filetype
   use xtb_type_data, only : scc_results

   type(error_type), allocatable, intent(out) :: error
      !! error message type, with stat amd message
   real(wp), parameter :: thr = 1.0e-7_wp
      !! molecular structure data
   integer, parameter :: nat = 8
      !! ethane 
   integer, parameter :: at(nat) = [6,6,1,1,1,1,1,1]
   real(wp), parameter :: xyz(3,nat) = reshape(&
      [-6.42056194812604_wp,  4.42017706707601_wp,  0.00000514267503_wp, &
      &-3.54497465898797_wp,  4.42017905349380_wp, -0.00000041470841_wp, &
      &-7.14339394244295_wp,  4.96696898911297_wp,  1.84484217131586_wp, &
      &-7.14339651464075_wp,  2.54910578073934_wp, -0.44887528991923_wp, &
      &-7.14340046326272_wp,  5.74445490934900_wp, -1.39594753088679_wp, &
      &-2.82213644603571_wp,  3.09590294303751_wp,  1.39595405551176_wp, &
      &-2.82214050550548_wp,  6.29125104633740_wp,  0.44887759570039_wp, &
      &-2.82214295551184_wp,  3.87338472886870_wp, -1.84483683242736_wp &
      & ], shape(xyz))
   
   type(TMolecule)  :: mol, inner_mol
   type(TRestart)   :: chk
   type(TEnvironment)       :: env
   type(TOniomCalculator)   :: calc
   type(oniom_input)        :: oniom_input3
   type(scc_results)        :: results
   real(wp),allocatable :: jacobian(:,:)
   integer,allocatable  :: idx_orig(:)
   real(wp) :: energy, hlgap, sigma(3,3)
   real(wp), allocatable :: gradient(:,:)


   call init(env)
      !! To initialize environment
   call init(mol,at,xyz)
      !! construct molecular structure type
      !! interface to initMoleculeNumbers
   mol%chrg = 0.0_wp
   allocate(gradient(3,mol%n))

   oniom_input3%first_arg = "gfn2:gfn2" 
   oniom_input3%second_arg = '1,3-5'

   call newOniomCalculator(calc,env,mol,oniom_input3)
   
   select type(xtb => calc%real_low)
   type is(TxTBCalculator)
      call chk%wfn%allocate(mol%n,xtb%basis%nshell,xtb%basis%nao)
      call newWavefunction(env,mol,xtb,chk)
   end select
   
   !> Check newOniomCalculator
   call check_(error,calc%method_low,2)
   call check_(error,calc%method_high,2)
   call check_(error,calc%idx(4),5)
   
   !> check newWavefunction
   call check_(error,chk%wfn%q(1),-0.258519131601850_wp, thr=thr)

   !> SP for whole molecule
   call calc%real_low%singlepoint(env,mol,chk,0,.false.,energy,gradient,sigma,hlgap,results)
   
   call check_(error,energy, -7.336370550119_wp, thr=thr)
   call check_(error,hlgap, 15.501740190914_wp, thr=thr)
   call check_(error,norm2(gradient), 0.000327194200_wp, thr=thr)
   
   !> cutbond
   call calc%cutbond(env,mol,chk,calc%topo,inner_mol,jacobian,idx_orig)
   
   call check_(error,idx_orig(5),2)
   call check_(error,inner_mol%xyz(1,5),-4.38055107024201_wp,thr=thr)
   call check_(error,inner_mol%xyz(2,5),4.42017847630110_wp,thr=thr)
   call check_(error,inner_mol%xyz(3,5),0.00000120013337_wp,thr=thr)

end subroutine test_oniom_cutbond

!---------------------------------------------
! Unit test ONIOM sp 
!---------------------------------------------
subroutine test_oniom_singlepoint(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_convert, only : autoaa

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_basisset
   use xtb_type_environment
   use xtb_setparam
   
   use xtb_oniom, only : TOniomCalculator, calculateCharge, newOniomCalculator, oniom_input
   use xtb_xtb_calculator, only : TxTBCalculator,newWavefunction
   use xtb_io_writer 
   use xtb_mctc_filetypes, only : filetype
   use xtb_type_data, only : scc_results
   use xtb_gfnff_calculator, only :TGFFCalculator


   type(error_type), allocatable, intent(out) :: error
      !! error message type, with stat amd message
   real(wp), parameter :: thr = 1.0e-7_wp
   integer, parameter :: nat = 12
      !! water cluster
   integer, parameter :: at(nat) = [8,1,1, 8,1,1, 8,1,1, 8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape([&
      &-2.75237178376284_wp, 2.43247309226225_wp,-0.01392519847964_wp, &
      &-0.93157260886974_wp, 2.79621404458590_wp,-0.01863384029005_wp, &
      &-3.43820531288547_wp, 3.30583608421060_wp, 1.42134539425148_wp, &
      &-2.43247309226225_wp,-2.75237178376284_wp, 0.01392519847964_wp, &
      &-2.79621404458590_wp,-0.93157260886974_wp, 0.01863384029005_wp, &
      &-3.30583608421060_wp,-3.43820531288547_wp,-1.42134539425148_wp, &
      & 2.75237178376284_wp,-2.43247309226225_wp,-0.01392519847964_wp, &
      & 0.93157260886974_wp,-2.79621404458590_wp,-0.01863384029005_wp, &
      & 3.43820531288547_wp,-3.30583608421060_wp, 1.42134539425148_wp, &
      & 2.43247309226225_wp, 2.75237178376284_wp, 0.01392519847964_wp, &
      & 2.79621404458590_wp, 0.93157260886974_wp, 0.01863384029005_wp, &
      & 3.30583608421060_wp, 3.43820531288547_wp,-1.42134539425148_wp], shape(xyz))
   
   type(TMolecule)  :: mol, inner_mol
   type(TRestart)   :: chk
   type(TEnvironment)       :: env
   type(TOniomCalculator)   :: calc
   type(oniom_input)        :: oniom_input4
   type(scc_results)        :: results
   real(wp),allocatable :: jacobian(:,:)
   integer,allocatable  :: idx_orig(:)
   real(wp) :: energy, hlgap, sigma(3,3)
   real(wp), allocatable :: gradient(:,:)
   integer :: io

   call init(env)
      !! To initialize environment
   call init(mol,at,xyz)
      !! construct molecular structure type
      !! interface to initMoleculeNumbers
   mol%chrg = 0.0_wp
   allocate(gradient(3,mol%n))
   call open_file(io,"w.coord","w")
   call writeMolecule(mol,io,filetype%tmol)
   call close_file(io)
   oniom_input4%second_arg = '1-6'

   call newOniomCalculator(calc,env,mol,oniom_input4)
   
   select type(xtb => calc%real_low)
   type is(TGFFCalculator)
      call check_(error,xtb%topo%qa(1),-0.570632781827558_wp, thr=thr)
      call check_(error,xtb%topo%qa(2),0.285316390913779_wp, thr=thr)
   end select
   
   !> Check newOniomCalculator
   call check_(error,calc%method_low,3)
   call check_(error,calc%method_high,2)
   call check_(error,mol%at(calc%idx(4)),8)
   

   !> SP for whole molecule
   call calc%singlepoint(env,mol,chk,0,.false.,energy,gradient,sigma,hlgap,results)
   
   call check_(error,energy, -10.831044042094_wp, thr=thr)
   call check_(error,norm2(gradient), 0.034482361663_wp, thr=thr)
   !call check_(error,hlgap, 15.501740190914_wp, thr=thr)
   
   !> cutbond
   !call calc%cutbond(env,mol,chk,calc%topo,inner_mol,jacobian,idx_orig)
   
   !call check_(error,idx_orig(5),2)
   !call check_(error,inner_mol%xyz(1,5),-4.38055107024201_wp,thr=thr)
   !call check_(error,inner_mol%xyz(2,5),4.42017847630110_wp,thr=thr)
   !call check_(error,inner_mol%xyz(3,5),0.00000120013337_wp,thr=thr)

end subroutine test_oniom_singlepoint


end module test_oniom

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


      subroutine vsub(a,b,c,n)
      implicit none
      integer n
      real*8 a(n),b(n),c(n)
      integer i

      do i=1,n
         c(i) = a(i) - b(i)
      end do

      return
      end subroutine vsub

c  .....................................................................

      real*8 function vlen(a)
      implicit none !double precision (a-h,o-z)
      real*8 a(3)
      real*8 tot

      tot = a(1)*a(1)+a(2)*a(2)+a(3)*a(3)
      vlen = 0.0d0
      if (tot.gt.0.0d0) vlen = dsqrt(tot)

      return
      end function vlen

c  .....................................................................

      real*8 function valijklff(natoms,xyz,i,j,k,l)

      implicit none

      external
     ,     vecnorm,valijk

      integer
     ,     ic,i,j,k,l,natoms

      real*8
     ,     xyz(3,natoms),
     ,     eps,ra(3),rb(3),rc(3),na(3),nb(3),
     ,     rab,rbc,thab,thbc,valijk,
     ,     vecnorm,nan,nbn,rcn,snanb,deter,pi

      parameter (eps=1.0d-14)
      data pi/3.1415926535897932384626433832795029d0/

c ... get torsion coordinate
      do ic=1,3
        ra(ic)=xyz(ic,j)-xyz(ic,i)
        rb(ic)=xyz(ic,k)-xyz(ic,j)
        rc(ic)=xyz(ic,l)-xyz(ic,k)
      end do

c ... determinante of rb,ra,rc
      deter= ra(1)*(rb(2)*rc(3)-rb(3)*rc(2))
     ,      -ra(2)*(rb(1)*rc(3)-rb(3)*rc(1))
     ,      +ra(3)*(rb(1)*rc(2)-rb(2)*rc(1))

      thab=valijk(natoms,xyz,i,k,j)
      thbc=valijk(natoms,xyz,j,l,k)
      call crossprod(ra,rb,na)
      call crossprod(rb,rc,nb)
      nan=vecnorm(na,3,1)
      nbn=vecnorm(nb,3,1)

      snanb=0.0d0
      do ic=1,3
        snanb=snanb+na(ic)*nb(ic)
      end do
      if (abs(abs(snanb)-1.d0).lt.eps) then
        snanb=sign(1.d0,snanb)
      end if

      valijklff=acos(snanb)

      end function valijklff

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Generalized Klopman-Ohno electrostatics
module xtb_coulomb_klopmanohno
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_boundaryconditions, only : boundaryCondition
   use xtb_mctc_constants, only : pi, sqrtpi
   use xtb_mctc_math, only : matInv3x3, matDet3x3
   use xtb_coulomb_ewald
   use xtb_type_coulomb, only : TCoulomb, setupBoundaryConditions, setupIndexTable
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_latticepoint, only : TLatticePoint, init
   use xtb_type_wignerseitzcell, only : TWignerSeitzCell, init
   implicit none
   private

   public :: TKlopmanOhno, init
   public :: gamAverage


   !> Possible averaging functions for hardnesses
   type :: TGamAverageEnum

      !> Harmonic average used in GFN1-xTB
      integer :: harmonic = 1

      !> Arithmetic average used in GFN2-xTB
      integer :: arithmetic = 2

      !> Geometric average
      integer :: geometric = 3

   end type TGamAverageEnum

   !> Actual enumerator for hardnesses
   type(TGamAverageEnum), parameter :: gamAverage = TGamAverageEnum()


   type, extends(TCoulomb) :: TKlopmanOhno

      !> Shell/Atomic hardnesses for each species
      real(wp), allocatable :: hardness(:, :)

      !> Generalized exponent
      real(wp) :: gExp

      !> Averaging function for the hardnesses
      procedure(funcAverage), nopass, pointer :: gamAverage => null()

   contains

      !> Returns full Coulomb matrix
      procedure :: getCoulombMatrix

      !> Returns derivatives of Coulomb matrix
      procedure :: getCoulombDerivs

   end type TKlopmanOhno


   interface init
      module procedure :: initFromMolecule
      module procedure :: initKlopmanOhno
   end interface init


   abstract interface
   pure function funcAverage(gi, gj) result(gam)
      import :: wp

      !> Hardness of shell i
      real(wp), intent(in) :: gi

      !> Hardness of shell j
      real(wp), intent(in) :: gj

      !> Averaged hardness
      real(wp) :: gam

   end function funcAverage
   end interface


contains


subroutine initFromMolecule(self, env, mol, gav, hardness, gExp, num, nshell, &
      & alpha, tolerance)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_coulomb_initFromMolecule'

   !> Instance of the Coulomb evaluator
   type(TKlopmanOhno), intent(out) :: self

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Averaging function
   integer, intent(in) :: gav

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: hardness(:, :)

   !> Generalized exponent
   real(wp), intent(in) :: gExp

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   !> Number of shell for each species
   integer, intent(in), optional :: nshell(:)

   !> Convergence factor
   real(wp), intent(in), optional :: alpha

   !> Tolerance for the Ewald sum
   real(wp), intent(in), optional :: tolerance

   logical :: exitRun

   call init(self, env, mol%id, mol%lattice, mol%boundaryCondition, gav, &
      & hardness, gExp, num, nshell, alpha, tolerance)

   call env%check(exitRun)
   if (exitRun) return

   call self%update(env, mol)
   call env%check(exitRun)
   if (exitRun) then
      call env%error("Initializing internal state of evaluator failed", source)
   end if

end subroutine initFromMolecule


subroutine initKlopmanOhno(self, env, id, lattice, boundaryCond, gav, hardness, &
      & gExp, num, nshell, alpha, tolerance)

   !> Source of the generated error
   character(len=*), parameter :: source = 'type_coulomb_initCoulomb'

   !> Instance of the Coulomb evaluator
   type(TKlopmanOhno), intent(out) :: self

   !> Identity of each atom
   integer, intent(in) :: id(:)

   !> Calculation environment
   type(TEnvironment), intent(inout) :: env

   !> Lattice parameters
   real(wp), intent(in) :: lattice(:, :)

   !> Boundary conditions for this evaluator
   integer, intent(in) :: boundaryCond

   !> Averaging function
   integer, intent(in) :: gav

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: hardness(:, :)

   !> Generalized exponent
   real(wp), intent(in) :: gExp

   !> Atomic number for each id
   integer, intent(in), optional :: num(:)

   !> Number of shell for each species
   integer, intent(in), optional :: nshell(:)

   !> Convergence factor
   real(wp), intent(in), optional :: alpha

   !> Tolerance for the Ewald sum
   real(wp), intent(in), optional :: tolerance

   logical :: exitRun
   integer :: ii

   self%boundaryCondition = boundaryCond
   self%gExp = gExp
   self%natom = size(id, dim=1)

   call setupIndexTable(self%natom, self%itbl, id, num, nshell)

   if (present(num)) then
      allocate(self%hardness(size(hardness, dim=1), size(num)))
      do ii = 1, size(num)
         self%hardness(:, ii) = hardness(:, num(ii))
      end do
   else
      self%hardness = hardness
   end if

   select case(gav)
   case default
      call env%error("Unknown averaging function specified", source)
      return
   case(gamAverage%harmonic)
      self%gamAverage => harmonicAverage
   case(gamAverage%arithmetic)
      self%gamAverage => arithmeticAverage
   case(gamAverage%geometric)
      self%gamAverage => geometricAverage
   end select

   call setupBoundaryConditions(self, env, lattice, alpha, tolerance)

end subroutine initKlopmanOhno


subroutine getCoulombMatrix(self, mol, jmat)

   !> Instance of the Coulomb evaluator
   class(TKlopmanOhno), intent(inout) :: self

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   select case(self%boundaryCondition)
   case(boundaryCondition%cluster)
      call getCoulombMatrixCluster(mol, self%itbl, self%gamAverage, self%gExp, &
         & self%hardness, jmat)
   case(boundaryCondition%pbc3d)
      call getCoulombMatrixPBC3D(self%wsCell, mol%id, self%itbl, self%gamAverage, &
         & self%gExp, self%hardness, self%alpha, mol%volume, self%rTrans, &
         & self%gTrans(:, 2:), jmat)
   end select

end subroutine getCoulombMatrix


subroutine getCoulombMatrixCluster(mol, itbl, gamAverage, gExp, hardness, jmat)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Averaging function for the hardnesses
   procedure(funcAverage) :: gamAverage

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: hardness(:, :)

   !> Generalized exponent
   real(wp), intent(in) :: gExp

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   integer :: iat, jat, ish, jsh, ii, jj, iid, jid
   real(wp) :: r1, rterm, gij

   jmat(:, :) = 0.0_wp

   !$omp parallel do default(none) shared(mol, itbl, hardness, gExp, jmat) &
   !$omp private(iat, jat, ish, jsh, ii, jj, iid, jid, r1, rterm, gij)
   do iat = 1, len(mol)
      ii = itbl(1, iat)
      iid = mol%id(iat)
      do jat = 1, iat-1
         jj = itbl(1, jat)
         jid = mol%id(jat)
         r1 = sqrt(sum((mol%xyz(:, jat) - mol%xyz(:, iat))**2))
         rterm = 1.0_wp/r1
         do ish = 1, itbl(2, iat)
            do jsh = 1, itbl(2, jat)
               gij = gamAverage(hardness(ish, iid), hardness(jsh, jid))
               rterm = 1.0_wp/(r1**gExp + gij**(-gExp))**(1.0_wp/gExp)
               jmat(jj+jsh, ii+ish) = rterm
               jmat(ii+ish, jj+jsh) = rterm
            end do
         end do
      end do
      do ish = 1, itbl(2, iat)
         do jsh = 1, ish-1
            gij = gamAverage(hardness(ish, iid), hardness(jsh, iid))
            jmat(ii+jsh, ii+ish) = gij
            jmat(ii+ish, ii+jsh) = gij
         end do
         jmat(ii+ish, ii+ish) = hardness(ish, iid)
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombMatrixCluster


subroutine getCoulombMatrixPBC3D(wsCell, id, itbl, gamAverage, gExp, hardness, &
      & alpha, volume, rTrans, gTrans, jmat)

   !> Wigner-Seitz cell
   type(TWignerSeitzCell), intent(in) :: wsCell

   !> Identity
   integer, intent(in) :: id(:)

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Averaging function for the hardnesses
   procedure(funcAverage) :: gamAverage

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: hardness(:, :)

   !> Generalized exponent
   real(wp), intent(in) :: gExp

   !> Cell volume
   real(wp), intent(in) :: volume

   !> Convergence factor
   real(wp), intent(in) :: alpha

   !> Real space lattice translations
   real(wp), intent(in) :: rTrans(:, :)

   !> Reciprocal space lattice translations
   real(wp), intent(in) :: gTrans(:, :)

   !> Coulomb matrix
   real(wp), intent(out) :: jmat(:, :)

   integer :: iat, ineigh, img, jat, ish, jsh, ii, jj, iid, jid
   real(wp) :: vec(3), rterm, gterm, weight, gij
   real(wp), parameter :: zero(3) = 0.0_wp

   jmat(:, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:jmat) &
   !$omp shared(wsCell, id, itbl, alpha, volume, gTrans, rTrans, hardness, gExp) &
   !$omp private(iat, ineigh, img, jat, ish, jsh, ii, jj, iid, jid, rterm, &
   !$omp& gterm, vec, weight, gij)
   do iat = 1, size(wsCell%neighs)
      ii = itbl(1, iat)
      iid = id(iat)
      do ineigh = 1, wsCell%neighs(iat)
         img = wsCell%ineigh(ineigh, iat)
         jat = wsCell%image(img)
         jj = itbl(1, jat)
         jid = id(jat)
         weight = wsCell%weight(ineigh, iat)
         vec(:) = wsCell%coords(:, img) - wsCell%coords(:, iat)
         gterm = ewaldMatPBC3D(vec, gTrans, 0.0_wp, volume, alpha, weight) &
            &  - pi / (volume * alpha**2) * weight
         if (iat /= jat) then
            do ish = 1, itbl(2, iat)
               do jsh = 1, itbl(2, jat)
                  gij = gamAverage(hardness(ish, iid), hardness(jsh, jid))
                  rterm = gterm + getRTerm(vec, gij, gExp, rTrans, alpha, weight)
                  jmat(jj+jsh, ii+ish) = jmat(jj+jsh, ii+ish) + rterm
                  jmat(ii+ish, jj+jsh) = jmat(ii+ish, jj+jsh) + rterm
               end do
            end do
         else
            do ish = 1, itbl(2, iat)
               do jsh = 1, ish-1
                  gij = gamAverage(hardness(ish, iid), hardness(jsh, iid))
                  rterm = gterm + getRTerm(vec, gij, gExp, rTrans, alpha, weight)
                  jmat(ii+jsh, ii+ish) = jmat(ii+jsh, ii+ish) + rterm
                  jmat(ii+ish, ii+jsh) = jmat(ii+ish, ii+jsh) + rterm
               end do
               gij = hardness(ish, iid)
               rterm = gterm + getRTerm(vec, gij, gExp, rTrans, alpha, weight)
               jmat(ii+ish, ii+ish) = jmat(ii+ish, ii+ish) + rterm
            end do
         end if
      end do
      do ish = 1, itbl(2, iat)
         do jsh = 1, ish-1
            gij = gamAverage(hardness(ish, iid), hardness(jsh, iid))
            jmat(ii+jsh, ii+ish) = jmat(ii+jsh, ii+ish) + gij
            jmat(ii+ish, ii+jsh) = jmat(ii+ish, ii+jsh) + gij
         end do
         gij = hardness(ish, iid)
         jmat(ii+ish, ii+ish) = jmat(ii+ish, ii+ish) + gij
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombMatrixPBC3D


pure function getRTerm(vec, gam, gExp, rTrans, alpha, scale) result(rTerm)
   real(wp),intent(in) :: vec(3)
   real(wp),intent(in) :: gam
   real(wp),intent(in) :: gExp
   real(wp),intent(in) :: rTrans(:,:)
   real(wp),intent(in) :: alpha
   real(wp),intent(in) :: scale
   real(wp) :: rTerm
   real(wp),parameter :: eps = 1.0e-9_wp
   integer  :: itr
   real(wp) :: r1, rij(3)
   rTerm = 0.0_wp
   do itr = 1, size(rTrans, dim=2)
      rij = vec + rTrans(:, itr)
      r1 = sqrt(sum(rij**2))
      ! self-interaction correction
      if(r1 < eps) then
         rTerm = rTerm - 2.0_wp*alpha/sqrtpi
      else
         rterm = rTerm + 1.0_wp/(r1**gExp + gam**(-gExp))**(1.0_wp/gExp) &
            & - erf(alpha*r1)/r1
      end if
   end do
   rTerm = rTerm * scale
end function getRTerm


subroutine getCoulombDerivs(self, mol, qvec, djdr, djdtr, djdL)

   !> Instance of the Coulomb evaluator
   class(TKlopmanOhno), intent(inout) :: self

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   !> Derivative of Coulomb matrix w.r.t. strain deformations
   real(wp), intent(out) :: djdL(:, :, :)

   select case(self%boundaryCondition)
   case(boundaryCondition%cluster)
      call getCoulombDerivsCluster(mol, self%itbl, self%gamAverage, self%gExp, &
         & self%hardness, qvec, djdr, djdtr, djdL)
   case(boundaryCondition%pbc3d)
      call getCoulombDerivsPBC3D(self%wsCell, mol%id, self%itbl, &
         & self%gamAverage, self%gExp, self%hardness, self%alpha, mol%volume, &
         & self%rTrans, self%gTrans(:, 2:), qvec, djdr, djdtr, djdL)
   end select

end subroutine getCoulombDerivs


subroutine getCoulombDerivsCluster(mol, itbl, gamAverage, gExp, hardness, &
      & qvec, djdr, djdtr, djdL)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Averaging function for the hardnesses
   procedure(funcAverage) :: gamAverage

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: hardness(:, :)

   !> Generalized exponent
   real(wp), intent(in) :: gExp

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   !> Derivative of Coulomb matrix w.r.t. strain deformations
   real(wp), intent(out) :: djdL(:, :, :)

   integer :: iat, jat, ish, jsh, ii, jj, iid, jid
   real(wp) :: r1, g1, gij, vec(3), dG(3), dS(3, 3)

   djdr(:, :, :) = 0.0_wp
   djdtr(:, :) = 0.0_wp
   djdL(:, :, :) = 0.0_wp

   !$omp parallel do default(none) reduction(+:djdr, djdtr, djdL) &
   !$omp shared(mol, itbl, qvec, gExp, hardness) &
   !$omp private(iat, jat, ish, jsh, ii, jj, iid, jid, r1, g1, gij, vec, dG, dS)
   do iat = 1, len(mol)
      ii = itbl(1, iat)
      iid = mol%id(iat)
      do jat = 1, iat-1
         jj = itbl(1, jat)
         jid = mol%id(jat)
         vec(:) = mol%xyz(:, jat) - mol%xyz(:, iat)
         r1 = sqrt(sum(vec**2))
         do ish = 1, itbl(2, iat)
            do jsh = 1, itbl(2, jat)
               gij = gamAverage(hardness(ish, iid), hardness(jsh, jid))
               g1 = 1.0_wp / (r1**gExp + gij**(-gExp))
               dG(:) = -vec*r1**(gExp-2.0_wp) * g1 * g1**(1.0_wp/gExp)
               dS(:, :) = 0.5_wp * spread(dG, 1, 3) * spread(vec, 2, 3)
               djdr(:, iat, jj+jsh) = djdr(:, iat, jj+jsh) - dG*qvec(ii+ish)
               djdr(:, jat, ii+ish) = djdr(:, jat, ii+ish) + dG*qvec(jj+jsh)
               djdtr(:, jj+jsh) = djdtr(:, jj+jsh) + dG*qvec(ii+ish)
               djdtr(:, ii+ish) = djdtr(:, ii+ish) - dG*qvec(jj+jsh)
               djdL(:, :, jj+jsh) = djdL(:, :, jj+jsh) + dS*qvec(ii+ish)
               djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(jj+jsh)
            end do
         end do
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombDerivsCluster


subroutine getCoulombDerivsPBC3D(wsCell, id, itbl, gamAverage, gExp, hardness, &
      & alpha, volume, rTrans, gTrans, qvec, djdr, djdtr, djdL)

   !> Wigner-Seitz cell
   type(TWignerSeitzCell), intent(in) :: wsCell

   !> Identity
   integer, intent(in) :: id(:)

   !> Averaging function for the hardnesses
   procedure(funcAverage) :: gamAverage

   !> Shell/Atomic hardnesses for each species
   real(wp), intent(in) :: hardness(:, :)

   !> Generalized exponent
   real(wp), intent(in) :: gExp

   !> Cell volume
   real(wp), intent(in) :: volume

   !> Convergence factor
   real(wp), intent(in) :: alpha

   !> Real space lattice translations
   real(wp), intent(in) :: rTrans(:, :)

   !> Reciprocal space lattice translations
   real(wp), intent(in) :: gTrans(:, :)

   !> Index table
   integer, intent(in) :: itbl(:, :)

   !> Charges
   real(wp), intent(in) :: qvec(:)

   !> Derivative of Coulomb matrix w.r.t. Cartesian coordinates
   real(wp), intent(out) :: djdr(:, :, :)

   !> Trace derivative of Coulomb matrix
   real(wp), intent(out) :: djdtr(:, :)

   !> Derivative of Coulomb matrix w.r.t. strain deformations
   real(wp), intent(out) :: djdL(:, :, :)

   integer :: iat, jat, ish, jsh, ii, jj, ineigh, img, iid, jid
   real(wp) :: weight, gij, vec(3), dG(3), dS(3, 3), dGg(3), dGr(3), dSg(3, 3)
   real(wp) :: dSr(3, 3)
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])

   djdr(:, :, :) = 0.0_wp
   djdtr(:, :) = 0.0_wp
   djdL(:, :, :) = 0.0_wp

   dGr = 0.0_wp
   dSr = 0.0_wp
   !$omp parallel do default(none) reduction(+:djdr, djdtr, djdL) &
   !$omp shared(wsCell, id, itbl, hardness, gExp, qvec, alpha, volume, gTrans, &
   !$omp& rTrans) &
   !$omp private(iat, ineigh, img, jat, ish, jsh, ii, jj, iid, jid, vec, weight, &
   !$omp& gij, dG, dS, dGg, dGr, dSg, dSr)
   do iat = 1, size(wsCell%neighs)
      ii = itbl(1, iat)
      iid = id(iat)
      do ineigh = 1, wsCell%neighs(iat)
         img = wsCell%ineigh(ineigh, iat)
         jat = wsCell%image(img)
         jj = itbl(1, jat)
         jid = id(jat)
         weight = wsCell%weight(ineigh, iat)
         vec(:) = wsCell%coords(:, img) - wsCell%coords(:, iat)
         call ewaldDerivPBC3D(vec, gTrans, 0.0_wp, volume, alpha, weight, dGg, dSg)
         if (iat /= jat) then
            do ish = 1, itbl(2, iat)
               do jsh = 1, itbl(2, jat)
                  gij = gamAverage(hardness(ish, iid), hardness(jsh, jid))
                  call getRDeriv(vec, gij, gExp, rTrans, alpha, weight, dGr, dSr)
                  dG(:) = dGg + dGr
                  dS(:, :) = dSg + dSr + pi / (volume * alpha**2) * weight * unity
                  djdr(:, iat, jj+jsh) = djdr(:, iat, jj+jsh) - dG*qvec(ii+ish)
                  djdr(:, jat, ii+ish) = djdr(:, jat, ii+ish) + dG*qvec(jj+jsh)
                  djdtr(:, jj+jsh) = djdtr(:, jj+jsh) + dG*qvec(ii+ish)
                  djdtr(:, ii+ish) = djdtr(:, ii+ish) - dG*qvec(jj+jsh)
                  djdL(:, :, jj+jsh) = djdL(:, :, jj+jsh) + dS*qvec(ii+ish)
                  djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(jj+jsh)
               end do
            end do
         else
            do ish = 1, itbl(2, iat)
               do jsh = 1, ish-1
                  gij = gamAverage(hardness(ish, iid), hardness(jsh, iid))
                  call getRDeriv(vec, gij, gExp, rTrans, alpha, weight, dGr, dSr)
                  dS(:, :) = dSg + dSr + pi / (volume * alpha**2) * weight * unity
                  djdL(:, :, ii+jsh) = djdL(:, :, ii+jsh) + dS*qvec(ii+ish)
                  djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(ii+jsh)
               end do
               gij = hardness(ish, iid)
               call getRDeriv(vec, gij, gExp, rTrans, alpha, weight, dGr, dSr)
               dS(:, :) = dSg + dSr + pi / (volume * alpha**2) * weight * unity
               djdL(:, :, ii+ish) = djdL(:, :, ii+ish) + dS*qvec(ii+ish)
            end do
         end if
      end do
   end do
   !$omp end parallel do

end subroutine getCoulombDerivsPBC3D


pure subroutine getRDeriv(vec, gij, gExp, rTrans, alpha, scale, dG, dS)
   real(wp), intent(in) :: vec(:)
   real(wp), intent(in) :: gij
   real(wp), intent(in) :: gExp
   real(wp), intent(in) :: rTrans(:,:)
   real(wp), intent(in) :: alpha
   real(wp), intent(in) :: scale
   real(wp), intent(out) :: dG(:)
   real(wp), intent(out) :: dS(:,:)
   real(wp), parameter :: eps = 1.0e-9_wp
   integer :: itr
   real(wp) :: r1, g1, rij(3), arg, dd
   real(wp), parameter :: unity(3, 3) = reshape(&
      & [1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp, 0.0_wp, 0.0_wp, 0.0_wp, 1.0_wp], &
      & [3, 3])
   dG = 0.0_wp
   dS = 0.0_wp
   do itr = 1, size(rTrans, dim=2)
      ! real contributions
      rij = vec + rTrans(:, itr)
      r1 = sqrt(sum(rij**2))
      if (r1 < eps) cycle
      arg = alpha**2*r1**2
      g1 = 1.0_wp / (r1**gExp + gij**(-gExp))
      dd = -r1**(gExp-2.0_wp) * g1 * g1**(1.0_wp/gExp) &
         & - 2*alpha*exp(-arg)/(sqrtpi*r1**2) + erf(alpha*r1)/(r1**3)
      dG = dG + rij*dd
      dS = dS + 0.5_wp * dd*spread(rij, 1, 3)*spread(rij, 2, 3)
   enddo
   dG = dG * scale
   dS = dS * scale

end subroutine getRDeriv


!> Harmonic averaging functions for hardnesses in GFN1-xTB
pure function harmonicAverage(gi, gj) result(gam)

   !> Hardness of shell i
   real(wp), intent(in) :: gi

   !> Hardness of shell j
   real(wp), intent(in) :: gj

   !> Averaged hardness
   real(wp) :: gam

   gam = 2.0_wp/(1.0_wp/gi+1.0_wp/gj)

end function harmonicAverage


!> Arithmetic averaging functions for hardnesses in GFN2-xTB
pure function arithmeticAverage(gi, gj) result(gam)

   !> Hardness of shell i
   real(wp), intent(in) :: gi

   !> Hardness of shell j
   real(wp), intent(in) :: gj

   !> Averaged hardness
   real(wp) :: gam

   gam = 0.5_wp*(gi+gj)

end function arithmeticAverage


!> Geometric averaging functions for hardnesses
pure function geometricAverage(gi, gj) result(gam)

   !> Hardness of shell i
   real(wp), intent(in) :: gi

   !> Hardness of shell j
   real(wp), intent(in) :: gj

   !> Averaged hardness
   real(wp) :: gam

   gam = sqrt(gi*gj)

end function geometricAverage


end module xtb_coulomb_klopmanohno

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_iniq
   use xtb_mctc_accuracy, only : wp
   use xtb_param_paulingen, only : paulingEN
   implicit none

   integer, private, parameter :: metal(1:86) = [&
      & 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, &
      & 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, &
      & 1, 0, 0, 0, 0, 0]

contains

!! ========================================================================
!  driver for calculation of Grimme-Gasteiger charges, which come in
!  three flavors: GG(vTB), GG(GFN1) and GG(GFN2). They differ in the way
!  the coordination number is taken into account.
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  z    :: nuclear charges
!  chrg :: system charge
!  OUTPUT
!  q    :: partial charges
!  cn   :: coordination number
!  PARAMETER
!  kchrg1  :: for GFN1-type Grimme-Gasteiger charges
!  OPTIONS
!  version :: vTB(=0),GFN1(=1),GFN2(>1)
!  verbose :: prints some header and makes a bit of analysis in the end
subroutine iniqcn(nat,at,z,xyz,chrg,kchrg1,q,cn,version,verbose)
   use, intrinsic :: iso_fortran_env, only : id => output_unit

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: z(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: chrg
   real(wp),intent(in)  :: kchrg1
   real(wp),intent(out) :: q(nat)
   real(wp),intent(out) :: cn(nat)
   integer, intent(in)  :: version
   logical, intent(in),optional :: verbose

   integer  :: i
   real(wp) :: dipole(3)

   logical :: pr
   if (present(verbose)) then
      pr = verbose
   else
      pr = .false.
   endif

!  print some header if requested
   if (pr) then
      write(id,'(a)')
      write(id,'(''doing Grimme-Gasteiger EN-charges'')')
   endif

!  select the variant of Grimme-Gasteiger charges based on the version number
   if (version.le.0) then
      call iniqcn_vtb(nat,at,z,xyz,chrg,q,cn)
   else if (version.eq.1) then
      if (pr) write(id,'(''using D3 CN'')')
      call iniqcn_gfn1(nat,at,z,xyz,chrg,kchrg1,q,cn)
   else
      if (pr) write(id,'(''using GFN CN'')')
      call iniqcn_gfn2(nat,at,z,xyz,chrg,q,cn)
   endif


!  calculate the dipole moment of the guess charges if requested
   if (pr) then
      dipole = 0.0_wp
      do i = 1, nat
         dipole(1)=dipole(1)+xyz(1,i)*q(i)
         dipole(2)=dipole(2)+xyz(2,i)*q(i)
         dipole(3)=dipole(3)+xyz(3,i)*q(i)
      enddo
      write(id,'(1x,''sum q :'',1x,d14.7)') sum(q)
      write(id,'(1x,''point charge moment (au)'')')
      write(id,'(5x,''X'',7x,''Y'',7x,''Z'')')
      write(id,'(3f9.4,''  total (Debye): '',f8.3)') &
      &  dipole(1), dipole(2), dipole(3), &
      &  sqrt(sum(dipole**2))*2.5418_wp
   endif

end subroutine iniqcn

!! ========================================================================
!  non-iterative, distance dependent Gasteiger-Grimme type charges
!  for the vTB part in sTDA-xTB calculations
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  z    :: nuclear charges
!  en   :: atomic EN (taken from aoparam)
!  chrg :: system charge
!  OUTPUT
!  q    :: partial charges
!  cn   :: coordination number
pure subroutine iniqcn_vtb(nat,at,z,xyz,chrg,q,cn)

!  get interface to ncoord
   use xtb_disp_ncoord, only : ncoord_d3

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: z(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: chrg
   real(wp),intent(out) :: q(nat)
   real(wp),intent(out) :: cn(nat)

   integer :: i
   real(wp),allocatable :: ena(:)

!  in case it is a single atom, quick return
   if (nat.eq.1) then
      q(1) = real(chrg,wp)
      cn(1) = 0.0_wp
      return
   endif

   allocate( ena(nat), source = 0.0_wp )

!  get the coordination number
   call ncoord_d3(nat,at,xyz,cn)

!  uncorrected electronegativites
   do i = 1, nat
      ena(i) = paulingEN(at(i))
      if (metal(at(i)).gt.0) cn(i) = 0.0_wp
   enddo

!  the neutral part, start from nuclear charges
   q = z

!  now distribute the electrons ena dependent
   call gasteiger_partition(nat,at,xyz,ena,q)

!  normalize to Nel
   q = q * (sum(z)-real(chrg,wp))/sum(z)

!  make partial charges
   q = z - q

end subroutine iniqcn_vtb

!! ========================================================================
!  non-iterative, distance dependent Gasteiger-Grimme type charges
!  for GFN1-xTB calculations
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  z    :: nuclear charges
!  en   :: atomic EN (taken from aoparam)
!  chrg :: system charge
!  OUTPUT
!  q    :: partial charges
!  cn   :: coordination number
!  PARAMETER:
!  kchrg1 (via INPUT)
pure subroutine iniqcn_gfn1(nat,at,z,xyz,chrg,kchrg1,q,cn)

!  get interface to ncoord
   use xtb_disp_ncoord, only : ncoord_d3

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: z(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: chrg
   real(wp),intent(in)  :: kchrg1
   real(wp),intent(out) :: q(nat)
   real(wp),intent(out) :: cn(nat)

   integer :: i
   real(wp),allocatable :: ena(:)

!  in case it is a single atom, quick return
   if (nat.eq.1) then
      q(1) = real(chrg,wp)
      cn(1) = 0.0_wp
      return
   endif

   allocate( ena(nat), source = 0.0_wp )

!  get the coordination number
   call ncoord_d3(nat,at,xyz,cn)

!  correct the CN with effective coordination numbers
   do i = 1, nat
      if (metal(at(i)).gt.0) then
         ena(i) = 0.0_wp
      else
         ena(i) = paulingEN(at(i)) - kchrg1*sqrt(cn(i))
      endif
   enddo

!  the neutral part, start from nuclear charges
   q = z

!  now distribute the electrons ena dependent
   call gasteiger_partition(nat,at,xyz,ena,q)

!  normalize to Nel
   q = q * (sum(z)-real(chrg,wp))/sum(z)

!  make partial charges
   q = z - q

end subroutine iniqcn_gfn1

!! ========================================================================
!  non-iterative, distance dependent Gasteiger-Grimme type charges
!  for GFN2-xTB calculations
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  z    :: nuclear charges
!  en   :: atomic EN (taken from aoparam)
!  chrg :: system charge
!  OUTPUT
!  q    :: partial charges
!  cn   :: coordination number
pure subroutine iniqcn_gfn2(nat,at,z,xyz,chrg,q,cn)

!  get interface to ncoord
   use xtb_disp_ncoord, only : ncoord_gfn

   implicit none

   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: z(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: chrg
   real(wp),intent(out) :: q(nat)
   real(wp),intent(out) :: cn(nat)

   real(wp),parameter   :: kchrg2 = 0.2_wp

   integer :: i
   real(wp),allocatable :: ena(:)

!  in case it is a single atom, quick return
   if (nat.eq.1) then
      q(1) = real(chrg,wp)
      cn(1) = 0.0_wp
      return
   endif

   allocate( ena(nat), source = 0.0_wp )

!  get the coordination number
   call ncoord_gfn(nat,at,xyz,cn)

!  correct the CN with effective coordination numbers
   do i = 1, nat
      if (metal(at(i)).gt.0) then
         ena(i) = kchrg2*sqrt(cn(i)) ! avoid to big q for metals
      else
         ena(i) = paulingEN(at(i)) + kchrg2*sqrt(cn(i))
      endif
   enddo

!  the neutral part, start from nuclear charges
   q = z

!  now distribute the electrons ena dependent
   call gasteiger_partition(nat,at,xyz,ena,q)

!  normalize to Nel
   q = q * (sum(z)-real(chrg,wp))/sum(z)

!  make partial charges
   q = z - q

end subroutine iniqcn_gfn2

!! ========================================================================
!  non-iterative, distance dependent Gasteiger-Grimme type charges
!  INPUT
!  nat  :: number of atoms
!  at   :: ordinal number of atoms
!  xyz  :: coordinates in Bohr
!  en   :: systemspecific EN
!  OUTPUT
!  q    :: EN based population
pure subroutine gasteiger_partition(nat,at,xyz,en,q)

!  get data from parameter modules
   use xtb_mctc_param, only : rcov => covalent_radius_d3

   implicit none

   integer, intent(in)    :: nat
   integer, intent(in)    :: at(nat)
   real(wp),intent(in)    :: xyz(3,nat)
   real(wp),intent(in)    :: en(nat)
   real(wp),intent(inout) :: q(nat)

   integer  :: i,j
   real(wp) :: tmp,r2,rav,den,rexp

   do i = 1, nat
      tmp = 0.0_wp
      do j = 1, nat
         if (i.eq.j) cycle
         r2 = sqrt(sum( (xyz(:,j) - xyz(:,i))**2 ))
         rav = 0.5_wp * ( rcov(at(i))+rcov(at(j)) )
         den = en(i) - en(j)
         rexp = (rav/r2)**6
         tmp = tmp + den*rexp
      enddo
      q(i) = q(i) + tmp
   enddo

end subroutine gasteiger_partition
end module xtb_iniq

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_pbc
   use xtb_mctc_accuracy, only : wp
   implicit none
!! ========================================================================
!  Helper functions for periodic boundary conditions, mostly from dftd3
!! ------------------------------------------------------------------------

contains

!! ------------------------------------------------------------------------
!  generate a supercell based on a realspace cutoff, this subroutine
!  doesn't know anything about the convergence behaviour of the
!  associated property. rthr is assumed to be the *quadratic* threshold!
pure subroutine get_realspace_cutoff(lat,rthr,tau_max)
   implicit none
   real(wp),intent(in)  :: rthr
   real(wp),intent(in)  :: lat(3,3)
   integer, intent(out) :: tau_max(3)
   real(wp) :: r_cutoff
   real(wp) :: normx(3),normy(3),normz(3)
   real(wp) :: cos10,cos21,cos32

   r_cutoff=sqrt(rthr)
!  write(*,*) 'lat',lat
   ! find normal to the plane...
   call crossproduct(lat(:,2),lat(:,3),normx)
   call crossproduct(lat(:,3),lat(:,1),normy)
   call crossproduct(lat(:,1),lat(:,2),normz)
!  write(*,*) 'normy',normy
   ! ...normalize it...
   normx=normx/norm2(normx)
   normy=normy/norm2(normy)
   normz=normz/norm2(normz)
!  write(*,*) 'normy_',normy
   ! cos angles between normals and lattice vectors
   cos10=sum(normx*lat(:,1))
   cos21=sum(normy*lat(:,2))
   cos32=sum(normz*lat(:,3))
!  write(*,*) 'cos32',cos32
!  tau_max(1)=abs(2*r_cutoff/cos10)
!  tau_max(2)=abs(2*r_cutoff/cos21)
!  tau_max(3)=abs(2*r_cutoff/cos32)
   tau_max(1)=ceiling(abs(r_cutoff/cos10))
   tau_max(2)=ceiling(abs(r_cutoff/cos21))
   tau_max(3)=ceiling(abs(r_cutoff/cos32))

contains

pure subroutine crossproduct(a,b,c)
   implicit none

   real(wp),intent(in)  :: a(3),b(3)
   real(wp),intent(out) :: c(3)
   real(wp) :: x,y,z

   x=a(2)*b(3)-b(2)*a(3)
   y=a(3)*b(1)-b(3)*a(1)
   z=a(1)*b(2)-b(1)*a(2)
   c=(/x,y,z/)
end subroutine crossproduct

end subroutine get_realspace_cutoff

real(wp) function volume(lat)
   implicit none
   real(wp),intent(in) ::lat(3,3)
   real(wp) :: det

   det=lat(1,1)*lat(2,2)*lat(3,3)+lat(1,2)*lat(2,3)*lat(3,1) + &
   &   lat(1,3)*lat(2,1)*lat(3,2)-lat(1,3)*lat(2,2)*lat(3,1) - &
   &   lat(1,2)*lat(2,1)*lat(3,3)-lat(1,1)*lat(2,3)*lat(3,2)
   volume=abs(det)
end function volume

subroutine xyz_to_abc(xyz,abc,lat,n)
   implicit none
   integer, intent(in)  :: n
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: abc(3,n)

   real(wp) :: lat_1(3,3)
   integer  :: i,j,k

   call inv_cell(lat,lat_1)

   abc(:,:n)=0.0d0
   do i=1,n
      do j=1,3
         do k=1,3
            abc(j,i)=abc(j,i)+lat_1(j,k)*xyz(k,i)
         enddo !k
         abc(j,i)=mod(abc(j,i),1.0_wp)
      enddo !j
   enddo !i

end subroutine xyz_to_abc

pure subroutine inv_cell(x,a) !x is normal lat, a is lat^(-1)
   implicit none
   real(wp),intent(in)  :: x(3,3) !unitcell vectors in direct space
   real(wp),intent(out) :: a(3,3) !unitcell vectors in reciprocal space
   real(wp) :: det

   a=0.0_wp
   det=x(1,1)*x(2,2)*x(3,3)+x(1,2)*x(2,3)*x(3,1)+x(1,3)*x(2,1)* &
   &   x(3,2)-x(1,3)*x(2,2)*x(3,1)-x(1,2)*x(2,1)*x(3,3)-x(1,1)* &
   &   x(2,3)*x(3,2)
!  write(*,*)'Det:',det
   a(1,1)=x(2,2)*x(3,3)-x(2,3)*x(3,2)
   a(2,1)=x(2,3)*x(3,1)-x(2,1)*x(3,3)
   a(3,1)=x(2,1)*x(3,2)-x(2,2)*x(3,1)
   a(1,2)=x(1,3)*x(3,2)-x(1,2)*x(3,3)
   a(2,2)=x(1,1)*x(3,3)-x(1,3)*x(3,1)
   a(3,2)=x(1,2)*x(3,1)-x(1,1)*x(3,2)
   a(1,3)=x(1,2)*x(2,3)-x(1,3)*x(2,2)
   a(2,3)=x(1,3)*x(2,1)-x(1,1)*x(2,3)
   a(3,3)=x(1,1)*x(2,2)-x(1,2)*x(2,1)
   a=a/det
end subroutine inv_cell

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine abc_to_xyz(abc,xyz,lat,n)
   implicit none
   integer, intent(in)  :: n
   real(wp),intent(in)  :: abc(3,n)
   real(wp),intent(in)  :: lat(3,3)
   real(wp),intent(out) :: xyz(3,n)

   integer i,j,k

   xyz(:,:n)=0.0_wp
   do i=1,n
      do j=1,3
         do k=1,3
            xyz(j,i)=xyz(j,i)+lat(j,k)*abc(k,i)
         enddo !k
      enddo !j
   enddo !i

end subroutine abc_to_xyz

pure subroutine get_translation(t1,t2,t3,xyz,abc,out)
  implicit none
  integer,  intent(in)  :: t1,t2,t3
  real(wp), intent(in)  :: xyz(3)
  real(wp), intent(in)  :: abc(3,3)
  real(wp), intent(inout) :: out(3)
  out=0.0_wp
  out(1)=(xyz(1)+t1*abc(1,1)+t2*abc(1,2)+t3*abc(1,3))
  out(2)=(xyz(2)+t2*abc(2,1)+t2*abc(2,2)+t3*abc(2,3))
  out(3)=(xyz(3)+t3*abc(3,1)+t2*abc(3,2)+t3*abc(3,3))
end subroutine get_translation

pure function mdet3 (a) result (det)
  !! determinant of 3x3 matrix
  implicit none
  real*8, intent(in)  :: a(3,3)
  real*8 :: det

  det =   a(1,1)*a(2,2)*a(3,3)  &
       - a(1,1)*a(2,3)*a(3,2)  &
       - a(1,2)*a(2,1)*a(3,3)  &
       + a(1,2)*a(2,3)*a(3,1)  &
       + a(1,3)*a(2,1)*a(3,2)  &
       - a(1,3)*a(2,2)*a(3,1)
end function mdet3

pure function minv3(a) result(b)
  !! http://fortranwiki.org/fortran/show/Matrix+inversion
  !! Performs a direct calculation of the inverse of a 3×3 matrix.
  real*8, intent(in) :: a(3,3)   !! Matrix
  real*8             :: b(3,3)   !! Inverse matrix
  real*8             :: detinv

  ! Calculate the inverse determinant of the matrix
  detinv = 1/(a(1,1)*a(2,2)*a(3,3) - a(1,1)*a(2,3)*a(3,2)&
       - a(1,2)*a(2,1)*a(3,3) + a(1,2)*a(2,3)*a(3,1)&
       + a(1,3)*a(2,1)*a(3,2) - a(1,3)*a(2,2)*a(3,1))

  ! Calculate the inverse of the matrix
  b(1,1) = +detinv * (a(2,2)*a(3,3) - a(2,3)*a(3,2))
  b(2,1) = -detinv * (a(2,1)*a(3,3) - a(2,3)*a(3,1))
  b(3,1) = +detinv * (a(2,1)*a(3,2) - a(2,2)*a(3,1))
  b(1,2) = -detinv * (a(1,2)*a(3,3) - a(1,3)*a(3,2))
  b(2,2) = +detinv * (a(1,1)*a(3,3) - a(1,3)*a(3,1))
  b(3,2) = -detinv * (a(1,1)*a(3,2) - a(1,2)*a(3,1))
  b(1,3) = +detinv * (a(1,2)*a(2,3) - a(1,3)*a(2,2))
  b(2,3) = -detinv * (a(1,1)*a(2,3) - a(1,3)*a(2,1))
  b(3,3) = +detinv * (a(1,1)*a(2,2) - a(1,2)*a(2,1))
end function minv3

pure logical function sametest(v)
  implicit none
  real*8, intent(in) ::v(3)
  real*8 ::l
  real*8, parameter :: s=1.0E-9

  sametest=.false.
  l=sqrt(dot_product(v,v))
  if (l<=s) sametest=.true.
end function sametest
end module xtb_pbc

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module mctcpar_pse
   implicit none
   character(len=2), parameter :: pse(118) = [ &
      & 'h ','he', &
      & 'li','be','b ','c ','n ','o ','f ','ne', &
      & 'na','mg','al','si','p ','s ','cl','ar', &
      & 'k ','ca', &
      & 'sc','ti','v ','cr','mn','fe','co','ni','cu','zn', &
      &           'ga','ge','as','se','br','kr', &
      & 'rb','sr', &
      & 'y ','zr','nb','mo','tc','ru','rh','pd','ag','cd', &
      &           'in','sn','sb','te','i ','xe', &
      & 'cs','ba','la', &
      & 'ce','pr','nd','pm','sm','eu','gd','tb','dy','ho','er','tm','yb', &
      & 'lu','hf','ta','w ','re','os','ir','pt','au','hg', &
      &           'tl','pb','bi','po','at','rn', &
      & 'fr','ra','ac', &
      & 'th','pa','u ','np','pu','am','cm','bk','cf','es','fm','md','no', &
      & 'lr','rf','db','sg','bh','hs','mt','ds','rg','cn', &
      &           'nh','fl','mc','lv','ts','og' ]

   integer, parameter :: metal(94) = [&
      &  0,                                                 0, &! H-He
      &  1, 1,                               1, 0, 0, 0, 0, 0, &! Li-Ne
      &  1, 1,                               1, 0, 0, 0, 0, 0, &! Na-Ar
      &  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, &! K-Kr
      &  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, &! Rb-Xe
      &  1, 1, &! Cs/Ba
      &        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, &!La-Lu
      &        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, &! Lu-Rn
      &  1, 1, 1, 1, 1, 1, 1, 1  ]! Fr-Pu

end module mctcpar_pse

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Wrappers for BLAS
module xtb_mctc_blas_wrap2
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_mctc_blas_level2, only : mctc_gemv, mctc_ger, mctc_spmv, mctc_spr, &
      & mctc_spr2, mctc_symv, mctc_syr, mctc_syr2
   implicit none
   private

   public :: mctc_gemv, mctc_ger, mctc_spmv, mctc_spr, mctc_spr2, mctc_symv
   public :: mctc_syr, mctc_syr2


   !> Performs one of the matrix-vector operations
   !
   !    y := alpha*A*x + beta*y,   or   y := alpha*A**T*x + beta*y,
   !
   ! where alpha and beta are scalars, x and y are vectors and A is an
   ! m by n matrix.
   interface mctc_gemv
      module procedure :: mctc_sgemv312
      module procedure :: mctc_sgemv321
      module procedure :: mctc_dgemv312
      module procedure :: mctc_dgemv321
   end interface mctc_gemv


contains


subroutine mctc_sgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call mctc_gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine mctc_sgemv312


subroutine mctc_sgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(sp), intent(in), contiguous, target :: amat(:, :, :)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(sp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call mctc_gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine mctc_sgemv321


subroutine mctc_dgemv312(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), yptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      yptr(1:size(yvec, 1)*size(yvec, 2)) => yvec
   else
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      yptr(1:size(yvec, 1) * size(yvec, 2)) => yvec
   end if
   call mctc_gemv(aptr, xvec, yptr, alpha, beta, tra)
end subroutine mctc_dgemv312


subroutine mctc_dgemv321(amat, xvec, yvec, alpha, beta, trans)
   real(dp), intent(in), contiguous, target :: amat(:, :, :)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), intent(in), optional :: beta
   character(len=1), intent(in), optional :: trans
   real(dp), pointer :: aptr(:, :), xptr(:)
   character(len=1) :: tra
   if (present(trans)) then
      tra = trans
   else
      tra = 'n'
   end if
   if (any(tra == ['n', 'N'])) then
      aptr(1:size(amat, 1), 1:size(amat, 2)*size(amat, 3)) => amat
      xptr(1:size(xvec, 1)*size(xvec, 2)) => xvec
   else
      aptr(1:size(amat, 1)*size(amat, 2), 1:size(amat, 3)) => amat
      xptr(1:size(xvec, 1) * size(xvec, 2)) => xvec
   end if
   call mctc_gemv(aptr, xptr, yvec, alpha, beta, tra)
end subroutine mctc_dgemv321


end module xtb_mctc_blas_wrap2

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_docking
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_docking

contains

!> Collect all exported unit tests
subroutine collect_docking(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("eth_wat", test_dock_eth_wat)]!, &
!      new_unittest("ellips", test_iff_ellips), &
!      ]

end subroutine collect_docking


subroutine test_dock_eth_wat(error)
   use xtb_type_environment, only: TEnvironment, init
   use xtb_mctc_accuracy, only: wp
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule
   use xtb_setparam, only: initrand
   use xtb_mctc_systools
   use xtb_setmod
   use xtb_docking_set_module
   use xtb_docking_param
   use xtb_iff_iffini, only: init_iff
   use xtb_iff_iffprepare, only: precomp
   use xtb_iff_iffenergy
   use xtb_docking_search_nci, only: docking_search
   use xtb_mctc_systools
   use xtb_iff_data, only: TIFFData
   type(error_type), allocatable, intent(out) :: error
   !> All important variables stored here
   type(TIFFData) :: iff_data
   real(wp),parameter :: thr = 1.0e-6_wp
   real(wp) :: icoord0(6),icoord(6) 
   integer :: n1 
   integer :: at1(9)
   real(wp) :: xyz1(3,9) 
   integer :: n2 
   integer :: at2(3)
   real(wp) :: xyz2(3,3)
   integer,parameter  :: n = 12
   integer :: at(n)
   real(wp) :: xyz(3,n)
   real(wp) :: molA_e, molB_e

   logical, parameter :: restart = .false.

   type(TMolecule)     :: molA,molB,comb
   real(wp) :: r(3),e
   integer :: i, j, k
   type(TEnvironment)  :: env
   character(len=:), allocatable :: fnam

   logical  :: exist

   n1 = 9
   at1 = [6,6,1,1,1,1,8,1,1]
   xyz1 = reshape(&
     &[-10.23731657240310_wp, 4.49526140160057_wp,-0.01444418438295_wp, &
     &  -8.92346521409264_wp, 1.93070071439448_wp,-0.06395255870166_wp, &
     & -11.68223026601517_wp, 4.59275319594179_wp,-1.47773402464476_wp, &
     &  -8.87186386250594_wp, 5.99323351202269_wp,-0.34218865473603_wp, &
     & -11.13173905821587_wp, 4.79659470137971_wp, 1.81087156124027_wp, &
     &  -8.00237319881732_wp, 1.64827398274591_wp,-1.90766384850460_wp, &
     & -10.57950417459641_wp,-0.08678859323640_wp, 0.45375344239209_wp, &
     &  -7.47634978432660_wp, 1.83563324786661_wp, 1.40507877109963_wp, &
     & -11.96440476139715_wp,-0.02296384600667_wp,-0.72783557254661_wp],&
     & shape(xyz1))

   n2 = 3
   at2 = [8,1,1]
   xyz2 = reshape(&
     &[-14.55824225787638_wp, 0.85763330814882_wp, 0.00000000000000_wp, &
     & -12.72520790897730_wp, 0.85763330814882_wp, 0.00000000000000_wp, &
     & -15.16924740842229_wp,-0.86379381534203_wp,-0.15285994688912_wp],&
     & shape(xyz2))

   call init(env)
   call init(molA, at1, xyz1)
   call init(molB, at2, xyz2)
   call iff_data%allocateIFFData(molA%n, molB%n)

   call initrand

   call set_iff_param
   fnam = 'xtblmoinfo'
   set%pr_local = .false.

   call precomp(env, iff_data, molA, molA_e, 1)
   call check_(error, molA_e,-11.3943358674_wp, thr=thr)
   call precomp(env, iff_data, molB, molB_e, 2)

   call env%checkpoint("LMO computation failed")

   call cmadock(molA%n, molA%n, molA%at, molA%xyz, r)
   do i = 1, 3
      molA%xyz(i, 1:molA%n) = molA%xyz(i, 1:molA%n) - r(i)
   end do
   call cmadock(molB%n, molB%n, molB%at, molB%xyz, r)
   do i = 1, 3
      molB%xyz(i, 1:molB%n) = molB%xyz(i, 1:molB%n) - r(i)
   end do

   call init_iff(env, iff_data%n1, iff_data%n2, iff_data%at1, iff_data%at2,&
      &          iff_data%neigh, iff_data%xyz1, iff_data%xyz2, iff_data%q1, &
      &          iff_data%q2, iff_data%c6ab, iff_data%z1, iff_data%z2,&
      &          iff_data%cprob, iff_data%nlmo1, iff_data%nlmo2, iff_data%lmo1, iff_data%lmo2,&
      &          iff_data%qdr1, iff_data%qdr2, iff_data%rlmo1, iff_data%rlmo2,&
      &          iff_data%cn1, iff_data%cn2, iff_data%alp1, iff_data%alp2, iff_data%alpab,&
      &          iff_data%den1, iff_data%den2, iff_data%gab1, iff_data%gab2, iff_data%qcm1,&
      &          iff_data%qcm2, iff_data%n, iff_data%at, iff_data%xyz, iff_data%q, icoord, icoord0,&
      &          .false.)

   call check_(error, icoord(1) ,-4.5265_wp, thr=1.0e-3_wp)

   call env%checkpoint("Initializing xtb-IFF failed.")

   call iff_e(env, iff_data%n, iff_data%n1, iff_data%n2, iff_data%at1, iff_data%at2,&
             &  iff_data%neigh, iff_data%xyz1, iff_data%xyz2, iff_data%q1, iff_data%q2,&
             & iff_data%c6ab, iff_data%z1, iff_data%z2,&
             & iff_data%nlmo1, iff_data%nlmo2, iff_data%lmo1, iff_data%lmo2, &
             & iff_data%rlmo1, iff_data%rlmo2,&
             & iff_data%qdr1, iff_data%qdr2, iff_data%cn1, iff_data%cn2, iff_data%alp1, &
             & iff_data%alp2, iff_data%alpab, iff_data%qct1, iff_data%qct2, &
             & iff_data%den1, iff_data%den2, iff_data%gab1, iff_data%gab2, &
             & set%verbose, 0, e, icoord)

   call check_(error, e,0.07745330953243718_wp, thr=thr)

   call env%checkpoint("xtb-IFF sp computation failed")

   call set_optlvl(env) !Sets the optimization level for search in global parameters
!   call docking_search(env, molA, molB, n, n1, n2, at1, at2, neigh, xyz1,&
!                 & xyz2, q1, q2, c6ab, z1, z2,&
!                 &nlmo1, nlmo2, lmo1, lmo2, rlmo1, rlmo2,&
!                 &qdr1, qdr2, cn1, cn2, alp1, alp2, alpab, qct1, qct2,&
!                 &den1, den2, gab1, gab2, molA_e, molB_e,&
!                 &cprob, e, icoord, comb)

!   call env%checkpoint("Docking algorithm failed")

!   call check_(error, calc%topo%nbond,6)
!
!   call check_(error, res_gff%e_total,-0.76480130317838_wp, thr=thr)

   call molA%deallocate
   call molB%deallocate

end subroutine test_dock_eth_wat

end module test_docking

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Response approximation within PTB

module xtb_ptb_response
#if WITH_TBLITE

   !> mctc-lib
   use mctc_env, only: error_type, wp
   use mctc_io, only: structure_type
   !> tblite-lib
   use tblite_basis_type, only: basis_type
   use tblite_context, only: context_type
   use tblite_wavefunction, only: wavefunction_type
   use tblite_integral_type, only: integral_type
   use tblite_container, only: container_cache
   use tblite_external_field, only: electric_field
   use tblite_scf_potential, only: potential_type, new_potential, add_pot_to_h1
   use tblite_scf_solver, only: solver_type
   use tblite_scf_iterator, only: get_qat_from_qsh
   use tblite_adjlist, only: adjacency_list
   use tblite_wavefunction_mulliken, only: get_mulliken_atomic_multipoles, &
      & get_mulliken_shell_charges
   use tblite_blas, only: gemv
   !> xtb-ptb-lib
   use xtb_ptb_data, only: TPTBData
   use xtb_ptb_integral_types, only: aux_integral_type
   use xtb_ptb_param, only: ptbGlobals
   use xtb_ptb_scf, only: get_density
   use xtb_ptb_mmlpopanalysis, only: get_mml_shell_charges
   use xtb_ptb_hamiltonian, only: get_hamiltonian
   use xtb_ptb_guess, only: get_psh_from_qsh
   use xtb_ptb_paulixc, only: calc_Vxc_pauli
   use xtb_ptb_coulomb, only: coulomb_potential
   use xtb_ptb_plusu, only: plusu_potential_type

   implicit none
   private

   public :: numgrad_polarizability

   !> Conversion factor from temperature to energy
   real(wp), parameter :: kt = 3.166808578545117e-06_wp

contains

   subroutine numgrad_polarizability(ctx, data, mol, bas, wfn, ints, auxints, &
         & Vecp, neighborlist, selfenergies, ves_twostepscf, CN_plusU, delta, alpha, efield)
      !> Calculation context
      type(context_type), intent(inout) :: ctx
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(in) :: wfn
      type(wavefunction_type) :: wfn_tmp
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> PTB parameterization data
      type(TPTBData), intent(in) :: data
      !> Basis set and core-valence basis set data
      type(basis_type), intent(in) :: bas
      !> Integral type (last solved Hamiltonian matrix (not coeffs and not only H0!)
      !> should be on 'ints%hamiltonian')
      type(integral_type), intent(in) :: ints
      type(integral_type) :: ints_tmp
      !> Auxiliary integral type
      type(aux_integral_type), intent(in) :: auxints
      !> Approx. effective core potential
      real(wp), intent(in) :: Vecp(:, :)
      !> Neighbor list
      type(adjacency_list), intent(in) :: neighborlist
      !> Effective self-energies
      real(wp), intent(in) :: selfenergies(:)
      !> Electrostatic potential in second iteration
      real(wp), intent(in) :: ves_twostepscf(:)
      !> Coordination number for +U
      real(wp), intent(in) :: CN_plusU(:)
      !> Perturbation strength
      real(wp), intent(in) :: delta
      !> Static dipole polarizability
      real(wp), intent(out) :: alpha(3, 3)
      !> (optional) Electric field
      real(wp), intent(in), optional :: efield(:)
      !> Error type
      type(error_type), allocatable :: error
      !> Potential type
      type(potential_type) :: pot
      !> Restart data for interaction containers
      type(container_cache) :: icache
      !> Electric field object
      type(electric_field) :: efield_object
      !> Electronic solver
      class(solver_type), allocatable :: solver
      !> Electronic entropy
      real(wp) :: ts
      !> Molecular dipole moment
      real(wp) :: dip_plus(3), dip_minus(3)
      real(wp) :: eff_ef(3), tmp_ef(3)
      !> Loop variables
      integer :: k, i, j


      !> debug mode
      logical, parameter :: debug(4) = &
               [ .false., .false., .false., .false. ]

      !> Solver for the effective Hamiltonian
      call ctx%new_solver(solver, bas%nao)

      alpha = 0.0_wp
      if (present(efield)) then
         eff_ef = efield
      else
         eff_ef = 0.0_wp
      end if

      cart_coord_loop: do k = 1, 3
         tmp_ef = eff_ef
         !> Add perturbation to electric field (minus sign corresponds to original PTB implementation)
         tmp_ef(k) = tmp_ef(k) - delta
         efield_object = electric_field(tmp_ef)

         !> Copy exact wavefunction and integrals (mainly for H0) from two step-scf to temporary wavefunction
         wfn_tmp = wfn
         ints_tmp = ints
         !> Get potential and apply it to Hamiltonian
         call new_potential(pot, mol, bas, wfn%nspin)
         call pot%reset()
         call efield_object%update(mol, icache)
         call efield_object%get_potential(mol, icache, wfn_tmp, pot)
         call add_pot_to_h1(bas, ints, pot, wfn_tmp%coeff)
         
         if (debug(1)) then !##### DEV WRITE #####
            write (*, *) "Matrix to solve ..."
            do i = 1, size(wfn_tmp%coeff, 1)
               do j = 1, size(wfn_tmp%coeff, 2)
                  write (*, '(f11.7)', advance="no") wfn_tmp%coeff(i, j, 1)
               end do
               write (*, '(/)', advance="no")
            end do
         endif
            
         !> Solve effective Hamiltonian including the electric field
         call get_density(wfn_tmp, solver, ints, ts, error, ptbGlobals%geps, ptbGlobals%geps0)
         if (allocated(error)) then
            call ctx%set_error(error)
            return
         end if

         if (debug(2)) then !##### DEV WRITE #####
            write (*, *) "Density matrix after adding field ..."
            do i = 1, size(wfn_tmp%density, 1)
               do j = 1, size(wfn_tmp%density, 2)
                  write (*, '(f11.7)', advance="no") wfn_tmp%density(i, j, 1)
               end do
               write (*, '(/)', advance="no")
            end do
         endif

         !> Get updated atomic and shell charges
         call get_mml_shell_charges(bas, auxints%overlap_to_x, auxints%overlap_to_1_x, &
            & wfn_tmp%density, wfn_tmp%n0sh, wfn_tmp%qsh)
         call get_qat_from_qsh(bas, wfn_tmp%qsh, wfn_tmp%qat)

         !> Reset Hamiltonian and enter one-step SCF routine to get updated wavefunction
         call onestepscf(ctx, data, mol, bas, wfn_tmp, ints_tmp, auxints, Vecp, neighborlist, selfenergies, &
            & ves_twostepscf, CN_plusU, efield_object, dip_minus)
         if (ctx%failed()) return

         tmp_ef = eff_ef
         !> Add perturbation to electric field (minus sign corresponds to original PTB implementation)
         tmp_ef(k) = tmp_ef(k) + delta
         efield_object = electric_field(tmp_ef)

         !> Copy exact wavefunction and integrals (mainly for H0) from two step-scf to temporary wavefunction
         wfn_tmp = wfn
         ints_tmp = ints
         !> Get potential and apply it to Hamiltonian
         call pot%reset()
         call efield_object%update(mol, icache)
         call efield_object%get_potential(mol, icache, wfn_tmp, pot)
         call add_pot_to_h1(bas, ints, pot, wfn_tmp%coeff)
         
         if (debug(3)) then !##### DEV WRITE #####
            write (*, *) "Matrix to solve ..."
            do i = 1, size(wfn_tmp%coeff, 1)
               do j = 1, size(wfn_tmp%coeff, 2)
                  write (*, '(f11.7)', advance="no") wfn_tmp%coeff(i, j, 1)
               end do
               write (*, '(/)', advance="no")
            end do
         endif
         
         !> Solve effective Hamiltonian including the electric field
         call get_density(wfn_tmp, solver, ints, ts, error, ptbGlobals%geps, ptbGlobals%geps0)
         if (allocated(error)) then
            call ctx%set_error(error)
            return
         end if

         if (debug(4)) then !##### DEV WRITE #####
            write (*, *) "Density matrix after adding field ..."
            do i = 1, size(wfn_tmp%density, 1)
               do j = 1, size(wfn_tmp%density, 2)
                  write (*, '(f11.7)', advance="no") wfn_tmp%density(i, j, 1)
               end do
               write (*, '(/)', advance="no")
            end do
         endif

         !> Get updated atomic and shell charges
         call get_mml_shell_charges(bas, auxints%overlap_to_x, auxints%overlap_to_1_x, &
            & wfn_tmp%density, wfn_tmp%n0sh, wfn_tmp%qsh)
         call get_qat_from_qsh(bas, wfn_tmp%qsh, wfn_tmp%qat)

         !> Reset Hamiltonian and enter one-step SCF routine to get updated wavefunction
         call onestepscf(ctx, data, mol, bas, wfn_tmp, ints_tmp, auxints, Vecp, neighborlist, selfenergies, &
            & ves_twostepscf, CN_plusU, efield_object, dip_plus)
         if (ctx%failed()) return

         alpha(k, 1:3) = -(dip_minus - dip_plus) / (2.0_wp * delta)                               ! numerical diff. dmu/dfield
      end do cart_coord_loop

      !> Symmetrization of polarizability tensor
      alpha(2, 1) = 0.5 * (alpha(2, 1) + alpha(1, 2))
      alpha(1, 2) = alpha(2, 1)
      alpha(3, 1) = 0.5 * (alpha(3, 1) + alpha(1, 3))
      alpha(1, 3) = alpha(3, 1)
      alpha(3, 2) = 0.5 * (alpha(3, 2) + alpha(2, 3))
      alpha(2, 3) = alpha(3, 2)

   end subroutine numgrad_polarizability

   subroutine onestepscf(ctx, data, mol, bas, wfn, ints, auxints, vecp, list, levels, &
         & ves_twostepscf, CN_plusU, efield, dipole)
      !> Calculation context
      type(context_type), intent(inout) :: ctx
      !> PTB parameterization data
      type(TPTBData), intent(in) :: data
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> Basis set and core-valence basis set data
      type(basis_type), intent(in) :: bas
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(inout) :: wfn
      !> Integral type
      type(integral_type), intent(inout) :: ints
      !> Auxiliary integral type
      type(aux_integral_type), intent(in) :: auxints
      !> Approx. effective core potential
      real(wp), intent(in) :: vecp(:, :)
      !> Neighbor list
      type(adjacency_list), intent(in) :: list
      !> Effective self-energies
      real(wp), intent(in) :: levels(:)
      !> Electrostatic potential from second iteration for mixing
      real(wp), intent(in) :: ves_twostepscf(:)
      !> Coordination number for +U
      real(wp), intent(in) :: CN_plusU(:)
      !> Electric field object
      type(electric_field), intent(in) :: efield
      !> Dipole moment
      real(wp), intent(out) :: dipole(3)
      !> Electronic solver
      class(solver_type), allocatable :: solver
      !> Electronic entropy
      real(wp) :: ts
      !> Error type
      type(error_type), allocatable :: error
      !> Restart data for interaction containers
      type(container_cache) :: icache
      !> Potential type
      type(potential_type) :: pot
      !> Coulomb potential
      type(coulomb_potential) :: coulomb
      !> +U potential
      type(plusu_potential_type) :: plusu
      !> Shell popoulations
      real(wp), allocatable :: psh(:, :)
      !> Temporary Mulliken populations
      real(wp), allocatable :: mulliken_qsh(:, :), mulliken_qat(:, :)
      !> Tmp variable for dipole moment
      real(wp) :: tmpdip(3)
      integer :: i, j, iat, izp, ii, ish

      !> debug mode
      logical, parameter :: debug = .false.

      !> Solver for the effective Hamiltonian
      call ctx%new_solver(solver, bas%nao)

      !> Reset H0 matrix
      ints%hamiltonian = 0.0_wp
      !> H0 matrix
      call get_hamiltonian(mol, list, bas, data%hamiltonian, data%response%kares, auxints%overlap_h0_1, &
      & levels, ints%hamiltonian, ptbGlobals%kpolres)

      !> Add effective core potential
      ints%hamiltonian = ints%hamiltonian + vecp

      !> Initialize potential
      call new_potential(pot, mol, bas, wfn%nspin)
      !> CAUTION: Because pot is mixed on the pot object, Coulomb has to follow
      !> DIRECTLY after pot%reset()!
      call pot%reset()

      !> Add Coulomb potential
      call coulomb%init(mol, bas, wfn%qat(:, 1), data%coulomb%shellHardnessSecondIter, &
         & 0.0_wp, data%response%kOK_onescf, data%coulomb%kTO)
      call coulomb%update(mol, bas)
      call coulomb%get_potential(wfn, pot)
      !> Mixing of old and new Coulomb potential via parameter
      !> CAUTION: THIRD-ORDER IS NOT AFFECTED BY THIS MIXING
      do iat = 1, mol%nat
         izp = mol%id(iat)
         ii = bas%ish_at(iat)
         do ish = 1, bas%nsh_at(iat)
            pot%vsh(ii + ish, 1) = pot%vsh(ii + ish, 1) * data%response%cvesres(izp) +  &
               & ves_twostepscf(ii + ish) * (1.0_wp - data%response%cvesres(izp))
         enddo
      end do

      !> Add perturbing electric field
      call efield%update(mol, icache)
      call efield%get_potential(mol, icache, wfn, pot)
      !> Add potentials on wfn%coeff (togther with H0)
      call add_pot_to_h1(bas, ints, pot, wfn%coeff)

      !> Add Vxc Pauli potential
      allocate (psh(bas%nsh, wfn%nspin), source=0.0_wp)
      psh = get_psh_from_qsh(wfn, bas)
      call calc_Vxc_pauli(mol, bas, psh(:, 1), ints%overlap, levels, data%pauli%kxc2l, wfn%coeff(:, :, 1))

      !> Add +U potential
      call plusu%init(data%plusU, mol, bas, wfn%qat(:, 1), CN_plusU, selfenergy_scal=data%response%kueffres)
      call plusu%get_potential(mol, bas, wfn%density(:, :, 1), wfn%coeff(:, :, 1))

      if (debug) then !##### DEV WRITE #####
         write (*, *) "Final wfn%coeff(:, :, 1) to solve ..."
         do i = 1, size(wfn%coeff, 1)
            do j = 1, size(wfn%coeff, 2)
               write (*, '(f11.7)', advance="no") wfn%coeff(i, j, 1)
            end do
            write (*, '(/)', advance="no")
         end do
      endif

      call get_density(wfn, solver, ints, ts, error, ptbGlobals%geps, ptbGlobals%geps0)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if

      call get_mml_shell_charges(bas, auxints%overlap_to_x, auxints%overlap_to_1_x, &
         & wfn%density, wfn%n0sh, wfn%qsh)
      psh = get_psh_from_qsh(wfn, bas)
      call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)
      call get_mulliken_atomic_multipoles(bas, ints%dipole, wfn%density, &
      & wfn%dpat)
      !> This step is only required because the dipole integrals in tblite are not
      !> centered to a fixed point (e.g., origin) but are atomic dipole moments
      !> Calculation of dipole moments requires Mulliken atomic charges.
      allocate (mulliken_qsh(bas%nsh, wfn%nspin), mulliken_qat(mol%nat, wfn%nspin))
      call get_mulliken_shell_charges(bas, ints%overlap, wfn%density, wfn%n0sh, &
      & mulliken_qsh)
      call get_qat_from_qsh(bas, mulliken_qsh, mulliken_qat)
      call gemv(mol%xyz, mulliken_qat(:, 1), tmpdip)
      dipole(:) = tmpdip + sum(wfn%dpat(:, :, 1), 2)

   end subroutine onestepscf

#endif
end module xtb_ptb_response

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine timing(t,w)
   use xtb_mctc_accuracy, only : wp
   real(wp) :: t,w
   integer :: time_count,time_rate,time_max
   call system_clock(time_count,time_rate,time_max)
   call cpu_time(t)
   w = real(time_count,wp)/real(time_rate,wp)
end subroutine timing


subroutine prtime(io,tt,ww,string)
   use xtb_mctc_accuracy, only : wp
   integer  :: io
   real(wp) :: ww,tt,t,tsec,wsec
   integer  :: tday,thour,tmin
   integer  :: wday,whour,wmin
   character(len=*),intent(in) :: string

   t=tt
   tday=idint(t/86400)
   t=t-tday*86400
   thour=idint(t/3600)
   t=t-thour*3600
   tmin=idint(t/60)
   t=t-60*tmin
   tsec=t

   t=ww
   wday=idint(t/86400)
   t=t-wday*86400
   whour=idint(t/3600)
   t=t-whour*3600
   wmin=idint(t/60)
   t=t-60*wmin
   wsec=t

   if(tday.ne.0)then
      write(io,2 )trim(string),tday,thour,tmin,tsec
      write(io,20)trim(string),wday,whour,wmin,wsec
      return
   endif
   if(thour.ne.0)then
      write(io,3 )trim(string),thour,tmin,tsec
      write(io,30)trim(string),whour,wmin,wsec
      return
   endif
   if(tmin .ne.0)then
      write(io,4 )trim(string),tmin,tsec
      write(io,40)trim(string),wmin,wsec
      return
   endif
   write(io,5 )trim(string),tsec
   write(io,50)trim(string),wsec
   return

 2    format('cpu  time for ',a,2x,i3,' d',i3,' h',i3,' m',f5.1,' s')
 3    format('cpu  time for ',a,2x,i3,' h',i3,' m',f5.1,' s')
 4    format('cpu  time for ',a,2x,i3,' m',f5.1,' s')
 5    format('cpu  time for ',a,2x,f6.2,' s')
 20   format('wall time for ',a,2x,i3,' d',i3,' h',i3,' m',f5.1,' s')
 30   format('wall time for ',a,2x,i3,' h',i3,' m',f5.1,' s')
 40   format('wall time for ',a,2x,i3,' m',f5.1,' s')
 50   format('wall time for ',a,2x,f6.2,' s')

end subroutine prtime

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine main_geometry(iunit,mol)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule
   implicit none
   integer, intent(in)  :: iunit
   type(TMolecule), intent(in) :: mol

   if (mol%npbc == 0) then
      call print_geosum(iunit,mol%n,mol%at,mol%sym,mol%xyz)
   else
      call print_pbcsum(iunit,mol)
   endif

end subroutine main_geometry

subroutine print_pbcsum(iunit,mol)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_type_molecule
   implicit none
   integer, intent(in)  :: iunit
   type(TMolecule),intent(in) :: mol

   integer  :: i
   real(wp) :: conv

   conv = autoaa

   call generic_header(iunit,"Geometry Summary",49,10)
   write(iunit,'(a)')

   ! atomic coordinates
   write(iunit,'(1x,"*",1x,i0,1x,a)') mol%n,"atoms in unit cell"
   write(iunit,'(a)')
   write(iunit,'(5x,"#",3x,"Z",5x,32x,"position/Å",8x,"charge")')
   do i = 1, mol%n
      write(iunit,'(i6,1x,i3,1x,a4)',advance='no') i,mol%at(i),mol%sym(i)
      write(iunit,'(3f14.7)',advance='no') mol%xyz(:,i)*conv
      write(iunit,'(f14.7)') mol%z(i)
   enddo
   write(iunit,'(a)')

   ! periodicity
   write(iunit,'(1x,"*",1x,i0,a)') mol%npbc,"D periodic system"
   write(iunit,'(a)')

   if (mol%npbc > 0) then
      ! cell parameters
      write(iunit,'(1x,"*",1x,a)') "cell parameter"
      write(iunit,'(a)')
      write(iunit,'(a12,2a15,2x,3a11)') &
         "|a|/Å", "|b|/Å", "|c|/Å", "α/°", "β/°", "γ/°"
      write(iunit,'(f13.7,2f14.7,1x,3f9.3)') &
         mol%cellpar(:3)*conv,mol%cellpar(4:)*180.0_wp/pi
      write(iunit,'(a)')

      ! direct lattice (transformation abc -> xyz)
      write(iunit,'(1x,"*",1x,a)') "direct lattice/Å"
      write(iunit,'(a)')
      write(iunit,'(12x,a,3f14.7)') "a",mol%lattice(:,1)*conv
      write(iunit,'(12x,a,3f14.7)') "b",mol%lattice(:,2)*conv
      write(iunit,'(12x,a,3f14.7)') "c",mol%lattice(:,3)*conv
      write(iunit,'(a)')

      ! reciprocal lattice
      write(iunit,'(1x,"*",1x,a)') "reciprocal lattice/Å⁻¹"
      write(iunit,'(a)')
      write(iunit,'(11x,a,3f14.7)') "a*",mol%rec_lat(:,1)/conv
      write(iunit,'(11x,a,3f14.7)') "b*",mol%rec_lat(:,2)/conv
      write(iunit,'(11x,a,3f14.7)') "c*",mol%rec_lat(:,3)/conv
      write(iunit,'(a)')

      ! geometry in fractional coordinates
      write(iunit,'(1x,"*",1x,a)') "geometry in fractional coordinates"
      write(iunit,'(a)')
      write(iunit,'(5x,"#",3x,"Z",5x,20x,"fractional coordinates")')
      do i = 1, mol%n
         write(iunit,'(i6,1x,i3,1x,a4)',advance='no') i,mol%at(i),mol%sym(i)
         write(iunit,'(3f14.7)',advance='no') mol%abc(:,i)
         write(iunit,'(a)')
      enddo
      write(iunit,'(a)')

      ! volume of unit cell
      write(iunit,'(1x,"*",1x,a,1x,"=",f14.7)') "volume of direct unit cell/Å³", &
         mol%volume*conv**3
      write(iunit,'(a)')

      ! mass density of unit cell
      write(iunit,'(1x,"*",1x,a,1x,"=",f14.7)') "mass density of direct unit cell/g·cm⁻³", &
         sum(mol%atmass)*metokg*1.0e27_wp/(mol%volume*conv**3)
      write(iunit,'(a)')
   endif

end subroutine print_pbcsum


subroutine print_geosum(iunit,n,at,sym,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_setparam
   use xtb_splitparam
   use xtb_disp_ncoord
   use xtb_approxrab
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   character(len=*), intent(in) :: sym(n)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,j,k,l,m
   integer  :: iat,jat
   integer  :: imax,imin

   integer  :: maxdist,maxbend,maxtrsn,maxelem
   integer  :: ndist,nbend,ntrsn,nelem
   integer, allocatable :: bond(:,:)
   integer, allocatable :: id(:,:)
   real(wp),allocatable :: dist(:)
   integer, allocatable :: ndel(:,:)
   real(wp),allocatable :: distel(:,:)
   real(wp),allocatable :: maxdel(:,:)
   real(wp),allocatable :: mindel(:,:)
   integer, allocatable :: ib(:,:)
   real(wp),allocatable :: bend(:)
   integer, allocatable :: it(:,:)
   real(wp),allocatable :: trsn(:)
   real(wp),allocatable :: cn(:)
   real(wp) :: moments(3)

   maxdist = n*(n-1)/2
   maxbend = n*(n-1)*(n-2)/6
   maxtrsn = n*(n-1)*(n-2)*(n-3)/24
   maxelem = min(maxval(at),118)

   allocate( cn(n), source = 0.0_wp )
   allocate( bond(n,n), source = 0 )
   call ncoord_erf(n,at,xyz,cn,900.0_wp)
   call approx_bonds(n,at,xyz,cn,bond,0.0537_wp)
   !call get_bonds(n,at,xyz,bond)

   if (set%pr_moments.or.set%pr_distances.or.set%pr_angles.or.set%pr_torsions) then
      call generic_header(iunit,"Geometry Summary",49,10)
      write(iunit,'(a)')
   endif

   if (set%pr_moments) then
      call print_moments(iunit,n,atmass,xyz)
   endif

   if (set%pr_distances) then
      allocate( dist(maxdist),distel(maxelem,maxelem), &
         maxdel(maxelem,maxelem),mindel(maxelem,maxelem), source = 0.0_wp )
      allocate( id(2,maxdist),ndel(maxelem,maxelem), source = 0 )
      call calc_distances(n,at,xyz,bond,maxdist,ndist,dist,id, &
         maxelem,nelem,ndel,distel,maxdel,mindel)
      if (ndist.gt.0) then
         call print_distances(iunit,n,at,sym,ndist,dist,id)
         call print_elem_dist(iunit,maxelem,nelem,ndel,distel,maxdel,mindel)
      endif
      deallocate( dist,distel,maxdel,mindel,id,ndel)
   endif

   if (set%pr_angles) then
      allocate( bend(maxbend), source = 0.0_wp )
      allocate( ib(3,maxbend), source = 0 )
      call calc_angles(n,at,xyz,bond,maxbend,nbend,bend,ib)
      if (nbend.gt.0) then
         call print_angles(iunit,n,at,sym,nbend,bend,ib)
      endif
      deallocate( bend,ib )
   endif

   if (set%pr_torsions) then
      allocate( trsn(maxtrsn), source = 0.0_wp )
      allocate( it(4,maxtrsn), source = 0 )
      call calc_torsions(n,at,xyz,bond,maxtrsn,ntrsn,trsn,it)
      if (ntrsn.gt.0) then
         call print_torsions(iunit,n,at,sym,ntrsn,trsn,it)
      endif
      deallocate( trsn,it )
   endif

end subroutine print_geosum

subroutine print_elem_dist(iunit,n,nbond,bond,dist,maxd,mind)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: nbond
   integer, intent(in)  :: bond(n,n)
   real(wp),intent(in)  :: dist(n,n)
   real(wp),intent(in)  :: maxd(n,n)
   real(wp),intent(in)  :: mind(n,n)

   integer :: iat,jat

   write(iunit,'(1x,"*",1x,i0,1x,a)') nbond,"distinct bonds (by element types)"
   write(iunit,'(a)')
   write(iunit,'(2(3x,"Z",3x),10x,"#",3x,"av. dist./Å",8x,"max./Å",8x,"min./Å")')
   do iat = 1, n
      do jat = 1, iat
         if (bond(jat,iat).lt.1) cycle
         write(iunit,'(2(1x,i3,1x,a2),i11,3f14.7)') &
            jat,toSymbol(jat),iat,toSymbol(iat),bond(jat,iat),dist(jat,iat)*autoaa, &
            maxd(jat,iat)*autoaa,mind(jat,iat)*autoaa
      enddo
   enddo
   write(iunit,'(a)')

end subroutine print_elem_dist

subroutine print_distances(iunit,n,at,sym,ndist,dist,id)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   character(len=*), intent(in) :: sym(n)
   integer, intent(in)  :: ndist
   real(wp),intent(in)  :: dist(ndist)
   integer, intent(in)  :: id(2,ndist)

   integer :: i,j,m
   integer :: imax,imin

   write(iunit,'(1x,"*",1x,i0,1x,a)') ndist,"selected distances"
   write(iunit,'(a)')
   write(iunit,'(2(5x,"#",3x,"Z",5x),30x,8x,"value/Å")')
   imax = maxloc(dist,1)
   imin = minloc(dist,1)
   do m = 1, ndist
      i = id(1,m)
      j = id(2,m)
      write(iunit,'(2(i6,1x,i3,1x,a4),30x,1x,f14.7)',advance='no') &
         i,at(i),sym(i), &
         j,at(j),sym(j), &
         dist(m)*autoaa
      if (imax.eq.m) then
         write(iunit,'(1x,"(max)")')
      elseif (imin.eq.m) then
         write(iunit,'(1x,"(min)")')
      else
         write(iunit,'(a)')
      endif
   enddo
   write(iunit,'(a)')

end subroutine print_distances

subroutine print_angles(iunit,n,at,sym,nbend,bend,ib)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   character(len=*), intent(in) :: sym(n)
   integer, intent(in)  :: nbend
   real(wp),intent(in)  :: bend(nbend)
   integer, intent(in)  :: ib(3,nbend)

   integer :: i,j,k,m
   integer :: imax,imin

   write(iunit,'(1x,"*",1x,i0,1x,a)') nbend,"selected angles"
   write(iunit,'(a)')
   write(iunit,'(3(5x,"#",3x,"Z",5x),13x,10x,"value/°")')
   do m = 1, nbend
      i = ib(1,m)
      j = ib(2,m)
      k = ib(3,m)
      write(iunit,'(3(i6,1x,i3,1x,a4),13x,1x,f14.7)') &
         i,at(i),sym(i), &
         j,at(j),sym(j), &
         k,at(k),sym(k), &
         bend(m)*180.0_wp/pi
   enddo
   write(iunit,'(a)')

end subroutine print_angles

subroutine print_torsions(iunit,n,at,sym,ntrsn,trsn,it)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_mctc_symbols, only : toSymbol
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   character(len=*), intent(in) :: sym(n)
   integer, intent(in)  :: ntrsn
   real(wp),intent(in)  :: trsn(ntrsn)
   integer, intent(in)  :: it(4,ntrsn)

   integer :: i,j,k,l,m
   integer :: imax,imin

   write(iunit,'(1x,"*",1x,i0,1x,a)') ntrsn, "selected dihedral angles"
   write(iunit,'(a)')
   write(iunit,'(4(5x,"#",3x,"Z",5x),8x,"value/°")')
   do m = 1, ntrsn
      i = it(1,m)
      j = it(2,m)
      k = it(3,m)
      l = it(4,m)
      write(iunit,'(4(i6,1x,i3,1x,a4),1x,f14.7)') &
         i,at(i),sym(i), &
         j,at(j),sym(j), &
         k,at(k),sym(k), &
         l,at(l),sym(l), &
         trsn(m)*180.0_wp/pi
   enddo
   write(iunit,'(a)')

end subroutine print_torsions

subroutine calc_distances(n,at,xyz,bond,maxdist,ndist,dist,id, &
      maxelem,nelem,ndel,distel,maxdel,mindel)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   integer, intent(in)  :: bond(n,n)
   integer, intent(in)  :: maxdist
   integer, intent(out) :: ndist
   real(wp),intent(out) :: dist(maxdist)
   integer, intent(out) :: id(2,maxdist)
   integer, intent(in)  :: maxelem
   integer, intent(out) :: nelem
   integer, intent(out) :: ndel(maxelem,maxelem)
   real(wp),intent(out) :: distel(maxelem,maxelem)
   real(wp),intent(out) :: maxdel(maxelem,maxelem)
   real(wp),intent(out) :: mindel(maxelem,maxelem)

   integer  :: i,j,m
   integer  :: iat,jat
   real(wp) :: r

   ndist = 0
   nelem = 0
   id = 0
   dist = 0.0_wp
   ndel = 0
   distel = 0.0_wp
   maxdel = -1.0e42_wp
   mindel = +1.0e42_wp

   m = 0
   get_dist: do i = 1, n
      iat = at(i)
      do j = 1, i-1
         jat = at(j)
         r  = sqrt(sum((xyz(:,i)-xyz(:,j))**2))
         if (bond(j,i).gt.0) then
            m = m+1
            if (m.ge.maxdist) exit get_dist
            ndel(iat,jat) = ndel(iat,jat)+1
            maxdel(iat,jat) = max(maxdel(iat,jat),r)
            mindel(iat,jat) = min(mindel(iat,jat),r)
            distel(iat,jat) = distel(iat,jat)+r
            id(1,m) = j
            id(2,m) = i
            dist(m) = r
         endif
      enddo
   enddo get_dist
   ndist = m
   m = 0
   do iat = 1, maxelem
      do jat = 1, iat
         if (iat.ne.jat) then
            ndel(jat,iat) = ndel(jat,iat)+ndel(iat,jat)
            ndel(iat,jat) = ndel(jat,iat)
         endif
         if (ndel(jat,iat).lt.1) cycle
         m = m+1
         distel(jat,iat) = (distel(iat,jat)+distel(jat,iat)) &
            /real(ndel(jat,iat),wp)
         if (iat.eq.jat) distel(jat,iat) = distel(jat,iat)*0.5_wp
         distel(iat,jat) = distel(jat,iat)
         maxdel(jat,iat) = max(maxdel(iat,jat),maxdel(jat,iat))
         maxdel(iat,jat) = maxdel(jat,iat)
         mindel(jat,iat) = min(mindel(iat,jat),mindel(jat,iat))
         mindel(iat,jat) = mindel(jat,iat)
      enddo
   enddo
   nelem = m

end subroutine calc_distances

subroutine calc_angles(n,at,xyz,bond,maxbend,nbend,bend,ib)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   integer, intent(in)  :: bond(n,n)
   integer, intent(in)  :: maxbend
   integer, intent(out) :: nbend
   real(wp),intent(out) :: bend(maxbend)
   integer, intent(out) :: ib(3,maxbend)

   integer  :: i,j,k,m
   real(wp) :: phi

   nbend = 0
   ib = 0
   bend = 0.0_wp

   m = 0
   get_bend: do i = 1, n
      if (bond(i,i).lt.2) cycle
      do j = 1, i-1
         if (i.eq.j) cycle
         if (bond(i,i).lt.2) cycle
         if (bond(j,i).lt.1) cycle
         do k = 1, j-1
            if (i.eq.k .or. j.eq.k) cycle
            if (bond(k,j).lt.1) cycle
            call bangl(xyz,k,j,i,phi)
            if (m.ge.maxbend) exit get_bend
            m = m+1
            ib(1,m) = k
            ib(2,m) = j
            ib(3,m) = i
            bend(m) = phi
         enddo
      enddo
   enddo get_bend
   nbend = m

end subroutine calc_angles

subroutine calc_torsions(n,at,xyz,bond,maxtrsn,ntrsn,trsn,it)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   integer, intent(in)  :: bond(n,n)
   integer, intent(in)  :: maxtrsn
   integer, intent(out) :: ntrsn
   real(wp),intent(out) :: trsn(maxtrsn)
   integer, intent(out) :: it(4,maxtrsn)

   integer  :: i,j,k,l,m
   real(wp) :: phi
   real(wp),external :: valijkl

   m = 0
   get_trsn: do i = 1, n
      if (bond(i,i).lt.2) cycle
      do j = 1, n
         if (i.eq.j) cycle
         if (bond(j,i).lt.1 .or. bond(j,j).lt.2) cycle
         do k = 1, n
            if (i.eq.k .or. j.eq.k) cycle
            if (bond(k,j).lt.1 .or. bond(k,k).lt.2) cycle
            do l = 1, n
               if (bond(l,k).lt.1) cycle
               if (i.eq.l .or. j.eq.l .or. k.eq.l) cycle
               phi = valijkl(n,xyz,l,k,j,i)
               if (m.ge.maxtrsn) exit get_trsn
               m = m+1
               it(1,m) = l
               it(2,m) = k
               it(3,m) = j
               it(4,m) = i
               trsn(m) = phi
            enddo
         enddo
      enddo
   enddo get_trsn
   ntrsn = m

end subroutine calc_torsions

subroutine get_bonds(n,at,xyz,bond)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_param, only: rad => covalent_radius_2009
   implicit none
   integer, intent(in)  :: n
   integer, intent(in)  :: at(n)
   real(wp),intent(in)  :: xyz(3,n)
   integer, intent(out) :: bond(n,n)

   integer  :: i,j,k
   real(wp) :: r,f,r0

   bond = 0

   do i = 1, n
      f = 1.3_wp
      k = 0
      do while(k.eq.0 .and. f.lt.1.5_wp)
         do j = 1, i-1
            r = sqrt(sum((xyz(:,j)-xyz(:,i))**2))
            r0 = rad(at(i))+rad(at(j))
            if (r.lt.f*r0) then
               k = k+1
               bond(j,i) = 1
               bond(i,j) = 1
            endif
         enddo
         f = f*1.1_wp
      enddo
      bond(i,i) = k
   enddo

end subroutine get_bonds

subroutine print_moments(iunit,n,atmass,xyz)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   implicit none
   integer, intent(in)  :: iunit
   integer, intent(in)  :: n
   real(wp),intent(in)  :: atmass(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp) :: molmass
   real(wp) :: cma(3)
   real(wp) :: moments(3)

   molmass = molecular_mass(n,atmass)
   cma = center_of_mass(n,atmass,xyz)
   moments = moments_of_inertia(n,atmass,xyz)

   write(iunit,'(a," : ", f16.7)') "      molecular mass/u   ", molmass*autoamu
   write(iunit,'(a," : ",3f16.7)') "   center of mass at/Å   ", cma*autoaa
   write(iunit,'(a," : ",4x,3e16.7)') "  moments of inertia/u·Å²", moments*autoaa**2*autoamu
   write(iunit,'(a," : ",4x,3e16.7)') "rotational constants/cm⁻¹", 0.5_wp*autorcm/moments
   write(iunit,'(a)')

contains

pure function moments_of_inertia(n,atmass,xyz) result(moments)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_lapack, only : lapack_spev
   use xtb_mctc_convert
   implicit none
   integer, intent(in)  :: n
   real(wp),intent(in)  :: atmass(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp) :: moments(3)
   real(wp) :: center(3),mass,t(6),work(9),tmp(3,3)
   real(wp) :: x,x2,y,y2,z,z2
   integer  :: iat,info

   center = center_of_mass(n,atmass,xyz)

   t = 0.0_wp

   do iat = 1, n
      mass = atmass(iat)*amutoau
      x = xyz(1,iat)-center(1); x2 = x**2
      y = xyz(2,iat)-center(2); y2 = y**2
      z = xyz(3,iat)-center(3); z2 = z**2
      t(1) = t(1) + mass * (y2+z2)
      t(2) = t(2) - mass * x*y
      t(3) = t(3) + mass * (x2+z2)
      t(4) = t(4) - mass * x*z
      t(5) = t(5) - mass * y*z
      t(6) = t(6) + mass * (x2+y2)
   enddo

   call lapack_spev('N','U',3,t,moments,tmp,3,work,info)
   if (info.ne.0) moments = -1.0_wp

end function moments_of_inertia

pure function center_of_mass(n,atmass,xyz) result(center)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)  :: n
   real(wp),intent(in)  :: atmass(n)
   real(wp),intent(in)  :: xyz(3,n)
   real(wp) :: center(3)
   integer  :: idir
   center = 0.0_wp
   do idir = 1, 3
      center(idir) = sum(atmass*xyz(idir,:))
   enddo
   center = center/sum(atmass)
end function center_of_mass

pure function molecular_mass(n,atmass) result(molmass)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   implicit none
   integer, intent(in) :: n
   real(wp),intent(in) :: atmass(n)
   real(wp) :: molmass
   molmass = sum(atmass)*amutoau
end function molecular_mass

end subroutine print_moments


subroutine check_cold_fusion(env, mol, cold_fusion)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_environment
   use xtb_type_molecule
   type(TEnvironment), intent(inout) :: env
   type(TMolecule), intent(in) :: mol
   logical, intent(out) :: cold_fusion
   integer :: iat, jat
   character(len=10) :: a10
   character(len=20) :: a20
   cold_fusion = .false.
   do iat = 1, len(mol)
      do jat = 1, iat-1
         if (mol%dist(jat, iat) < 1.0e-9_wp) then
            cold_fusion = .true.
            write(a20, '(a,i0,"-",a,i0)') &
               &  trim(mol%sym(jat)), jat, trim(mol%sym(iat)), iat
            write(a10, '(es10.3)') mol%dist(jat, iat)
            call env%error("Found *very* short distance of "//a10//" for "//&
               &           trim(a20))
         endif
      enddo
   enddo
end subroutine check_cold_fusion

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_iff
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_iff

contains

!> Collect all exported unit tests
subroutine collect_iff(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("iff_sp", test_iff_sp) &
      ]

end subroutine collect_iff


subroutine test_iff_sp(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_systools
   use xtb_type_environment
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_data
   use xtb_setparam
   use xtb_setmod
   use xtb_docking_param
   use xtb_type_restart, only: TRestart
   use xtb_iff_calculator, only : TIFFCalculator, newIFFCalculator
   use xtb_iff_data, only : TIFFData
   use xtb_iff_iffprepare, only : prepare_IFF
   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 6
   integer, parameter :: at(nat) = [8,1,1,8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
   &[-0.04394313126682_wp,-0.15162589575685_wp,-0.12104386666899_wp, &
   &  1.57021196791551_wp, 0.39852223676357_wp,-0.74238980424452_wp, &
   & -0.52096572705612_wp,-1.61453119575215_wp,-1.08142949421996_wp, &
   & -3.35527313086215_wp, 3.63311912367937_wp,-1.97688072772302_wp, &
   & -4.33218397586988_wp, 4.42399249914350_wp,-0.67195282333972_wp, &
   & -2.30284007732108_wp, 2.38679302539156_wp,-1.14422985849389_wp],&
   & shape(xyz))

   type(TMolecule)     :: mol
   type(TEnvironment)  :: env
   type(TIFFCalculator) :: calc
   type(TIFFData) :: iff_data

   real(wp) :: etot,egap
   real(wp), allocatable :: g(:,:)
   type(TRestart) :: chk
   real(wp) :: sigma(3,3)
   type(scc_results) :: res


   logical  :: exist

   call init(env)
   call init(mol,at,xyz)

   natom_arg = '1-3'
   call prepare_IFF(env, mol, iff_data)
   call env%checkpoint("Could not generate electronic properties for IFF")

   call newIFFCalculator(env, mol, iff_data, calc)

   call env%checkpoint("xtb-IFF parameter setup failed")

   allocate( g(3,mol%n), source = 0.0_wp )
 
   call calc%singlepoint(env, mol, chk, 2, exist, etot, g, sigma, egap, res)
   write(*,*) 'WW', etot

   call check_(error, etot,-0.002628051951328639_wp, thr=thr)

   call mol%deallocate

end subroutine test_iff_sp

end module test_iff

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_intmodes

contains

! project cartesian on internal mode to determine str, bend, tors
subroutine intmodestep(n,bmat,u,step,geo,na,nb,nc,coord)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: n
   integer, intent(in)    :: na(n),nb(n),nc(n)
   real(wp),intent(in)    :: bmat(3*n-6,3*n)
   real(wp),intent(in)    :: u(3*n)
   real(wp),intent(inout) :: geo(3,n)
   real(wp),intent(inout) :: coord(3,n)
   real(wp),intent(in)    :: step

   real(wp),allocatable :: dit(:)
   real(wp),allocatable :: geo2(:,:)
   real(wp) norm
   integer k,j,kl,l,lend,n36
   logical fail

   allocate(dit(3*n-6), geo2(3,n))

   dit = 0
   do k=1,3*n
      do j=1,3*n-6
         dit(j)=dit(j)+bmat(j,k)*u(k)
      enddo
   enddo

   kl=0
   geo2=0
   do k=2,n
      lend=3
      if(k.eq.2) lend=1
      if(k.eq.3) lend=2
      do l=1,lend
         kl=kl+1
         geo(l,k)=geo(l,k)+dit(kl)*step
      enddo
   enddo
   !     new cartesians
   call gmetry(n,geo,coord,na,nb,nc,fail)

end subroutine intmodestep

! project cartesian on internal mode to determine str, bend, tors
pure subroutine modetyp(n,bmat,u,root,vtyp)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: n
   integer, intent(in) :: root
   real(wp),intent(in) :: bmat(3*n-6,3*n)
   real(wp),intent(in) :: u(3*n,3*n)
   real(wp),intent(inout) :: vtyp(3)

   real(wp) :: norm
   real(wp),allocatable :: dit(:)
   integer  :: k,j,kl,l,lend

   allocate(dit(3*n-6))

   dit = 0
   do k=1,3*n
      do j=1,3*n-6
         dit(j)=dit(j)+bmat(j,k)*u(k,root)
      enddo
   enddo

   vtyp = 0
   kl=0
   do k=2,n
      lend=3
      if(k.eq.2) lend=1
      if(k.eq.3) lend=2
      do l=1,lend
         kl=kl+1
         vtyp(l)=vtyp(l)+dit(kl)**2
      enddo
   enddo

   norm=sum(vtyp)
   vtyp=vtyp/norm

end subroutine modetyp

! bmatrix dzmat/dxyz
subroutine bzmat(n,at,xyzin,bmat)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: n,at(n)
   real(wp),intent(in) :: xyzin(3,n)
   real(wp),intent(inout) :: bmat(3*n-6,3*n)

   real(wp),allocatable :: xyz(:,:),geo(:,:),br(:),bl(:)
   real(wp) :: step,one
   parameter (one=1.0d0)
   integer, allocatable :: na(:),nb(:),nc(:)
   integer :: i,k,n3,ia,ii,ic,n36,j,kl
   integer lend,l,ij

   allocate(xyz(3,n),geo(3,n),br(3*n-6),bl(3*n-6))
   allocate(na(n),nb(n),nc(n))

   n36=3*n-6
   n3=3*n
   xyz=xyzin*0.52916790d0
   step=1.d-5

   ! eq. zmat
   geo = 0
   call xyzint(xyz,n,na,nb,nc,one,geo)

   ! make bmat
   ij=0
   do i=1,n
      do j=1,3
         ij=ij+1
         xyz(j,i)=xyz(j,i)+step
         call xyzgeo(xyz,n,na,nb,nc,one,geo)
         kl=0
         do k=2,n
            lend=3
            if(k.eq.2) lend=1
            if(k.eq.3) lend=2
            do l=1,lend
               kl=kl+1
               br(kl)=geo(l,k)
            enddo
         enddo
         xyz(j,i)=xyz(j,i)-step*2.
         call xyzgeo(xyz,n,na,nb,nc,one,geo)
         xyz(j,i)=xyz(j,i)+step
         kl=0
         do k=2,n
            lend=3
            if(k.eq.2) lend=1
            if(k.eq.3) lend=2
            do l=1,lend
               kl=kl+1
               bl(kl)=geo(l,k)
            enddo
         enddo
         do k=1,n36
            bmat(k,ij)=0.5*(br(k)-bl(k))/step
         enddo
      enddo
   enddo

end subroutine


!     *****************************************************************

subroutine makenabc(xyzin,molvec,at,nat,n,n2,nmol,&
      &                    fragind,na,nb,nc)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: n,n2
   integer, intent(inout) :: na(n2), nb(n2), nc(n2)
   integer, intent(in)    :: at(n), nmol, fragind(100)
   integer, intent(inout) :: nat(n2)
   integer, intent(in)    :: molvec(n)
   real(wp),intent(in)    :: xyzin(3,n)

   integer  :: i,j,k,m,nm,ntot,mm
   real(wp) :: r,sum3(3),one
   integer, allocatable :: ind(:,:),molv(:),idum(:)
   real(wp),allocatable :: xyz(:,:),rr(:),tmp(:,:)
   parameter (one=1.0d0)

   allocate(ind(n2,n2),molv(n2),idum(n))
   allocate(xyz(3,n2),rr(n2),tmp(3,n2))

   if(nmol.gt.1)then
      k=1
      ntot=0
      do nm=1,nmol  ! loop over fragments
         m=0
         do i=k,fragind(nm)
            m=m+1
            tmp(1:3,m)=xyzin(1:3,i)
            idum(m)=at(i)
         enddo
         call cma(m,idum,tmp,sum3)
         ntot=ntot+1
         nat(ntot)=107
         molv(ntot)=nm
         xyz(1:3,ntot)=sum3(1:3)
         do i=k,fragind(nm)
            ntot=ntot+1
            xyz(1:3,ntot)=xyzin(1:3,i)
            molv(ntot)=molvec(i)
            nat(ntot)=at(i)
         enddo
         k=k+fragind(nm)
      enddo
   else
      nat=at
      molv=molvec
      xyz=xyzin
   endif

   do i=1,n2
      do j=1,n2
         r=(xyz(1,i)-xyz(1,j))**2+&
            &        (xyz(2,i)-xyz(2,j))**2+&
            &        (xyz(3,i)-xyz(3,j))**2
         rr(j)=r+abs(molv(i)-molv(j))*100000.
         if(i.eq.j) rr(j)=1.d+42
         ind(j,i)=j
      enddo
      call qsort(rr,1,n,ind(1,i))
   enddo
   na(2)=1
   call bonded(3,na,nb,nc,ind,n2,molv)
   na(1)=0
   nb(1)=0
   nc(1)=0
   nb(2)=0
   nc(2)=0
   nc(3)=0

   write(*,*) 'z-matrix connectivity:'
   mm=1
   do i=1,n2
      na(i)=0
      if(i.gt.1)then
         if(molv(i).ne.molv(i-1)) then
            na(i)=mm
            mm=na(i)
         endif
      endif
      call bonded(i,na,nb,nc,ind,n2,molv)
      !        write(*,*)'atom ',i,'  na,nb,nc :',na(i),nb(i),nc(i)
   enddo

   call xyzint(xyz,n2,na,nb,nc,1.d0,tmp)
   call xyzgeo(xyz,n2,na,nb,nc,one,tmp)
   call zmatpr(n2,nat,tmp,na,nb,nc,1)

end subroutine makenabc

!     *****************************************************************

subroutine cart2zmat(xyzin,molvec,at,nat,n,n2,nmol,&
      &                    fragind,na,nb,nc,geo)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: n,n2
   integer, intent(in) :: na(n2), nb(n2), nc(n2)
   integer, intent(in) :: at(n), nmol, fragind(100)
   integer, intent(in) :: molvec(n),nat(n2)
   real(wp),intent(in) :: xyzin(3,n)
   real(wp),intent(inout) :: geo(3,n2)

   integer  :: i,j,k,m,nm,ntot,mm
   real(wp) :: r,sum3(3),one
   integer, allocatable :: ind(:,:),molv(:),idum(:)
   real(wp),allocatable :: xyz(:,:),rr(:),tmp(:,:)
   parameter (one=1.0d0)
   allocate(ind(n2,n2),molv(n2),idum(n))
   allocate(xyz(3,n2),rr(n2),tmp(3,n))

   if(nmol.gt.1)then
      k=1
      ntot=0
      do nm=1,nmol  ! loop over fragments
         m=0
         do i=k,fragind(nm)
            m=m+1
            tmp(1:3,m)=xyzin(1:3,i)
            idum(m)=at(i)
         enddo
         call cma(m,idum,tmp,sum3)
         ntot=ntot+1
         xyz(1:3,ntot)=sum3(1:3)
         do i=k,fragind(nm)
            ntot=ntot+1
            xyz(1:3,ntot)=xyzin(1:3,i)
         enddo
         k=k+fragind(nm)
      enddo
   else
      xyz=xyzin
   endif

   call xyzgeo(xyz,n2,na,nb,nc,one,geo)

end subroutine cart2zmat

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

pure subroutine bonded(i,na,nb,nc,ind,n,molvec)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer,intent(in) :: i,n,ind(n,n)
   integer,intent(in) :: molvec(n)
   integer,intent(inout) :: na(n),nb(n),nc(n)
   integer :: j,is
   integer :: icon

   nb(i)=0
   nc(i)=0
   is=0
   if(na(i) == 0) then
      do j=1,n
         icon=ind(j,i)
         if(icon.lt.i.and.molvec(icon).eq.molvec(i)) then
            is=j
            na(i)=icon
            exit
         endif
      enddo
   end if
   if(na(i) == 0)then
      do j=1,n
         icon=ind(j,i)
         if(icon.lt.i) then
            is=j
            na(i)=icon
            exit
         endif
      enddo
   endif
   do j=is+1,n
      icon=ind(j,i)
      if(icon.lt.i.and.molvec(icon).eq.molvec(i)&
         &   .and.icon.ne.na(i)) then
         is=j
         nb(i)=icon
         exit
      endif
   enddo
   if(nb(i) == 0)then
      do j=is+1,n
         icon=ind(j,i)
         if(icon.lt.i .and. icon.ne.na(i)) then
            is=j
            nb(i)=icon
            exit
         endif
      enddo
   endif
   do j=is+1,n
      icon=ind(j,i)
      if(icon.lt.i.and.molvec(icon).eq.molvec(i)&
         &   .and.icon.ne.na(i).and.icon.ne.nb(i)) then
         is=j
         nc(i)=icon
         exit
      endif
   enddo
   if(nc(i) == 0)then
      do j=is+1,n
         icon=ind(j,i)
         if(icon.lt.i&
            &   .and.icon.ne.na(i).and.icon.ne.nb(i)) then
            is=j
            nc(i)=icon
            exit
         endif
      enddo
   endif

end subroutine bonded

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine zmat2cart(n,n2,at,geo,xyz,na,nb,nc,fail)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: n,n2
   integer, intent(in) :: na(n2),nb(n2),nc(n2)
   integer, intent(in) :: at(n2)
   real(wp),intent(inout) :: xyz(3,n)
   real(wp),intent(in) :: geo(3,n2)
   logical, intent(out) :: fail

   integer k,m
   real(wp),allocatable :: tmp(:,:)
   allocate(tmp(3,n2))

   call gmetry(n2,geo,tmp,na,nb,nc,fail)

   m=0
   do k=1,n2
      if(at(k).lt.100) then
         m=m+1
         xyz(1:3,m)=tmp(1:3,k)
      endif
   enddo

end subroutine

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!     subroutine int2cart(nall,s1,s2,xyzref,xyz,n,nmol,fragind)
!     use xtb_lsrmsd
!     implicit none
!     integer n,nall,s1,s2,fragind(100),nmol
!     real(wp) xyzref(3,n,nall),xyz(3,n)

!     integer nm,i,j,k,m,mm
!     real(wp),allocatable::tmp(:,:),tmp2(:,:)
!     real(wp) gdum(3,3), u(3,3), x(3), y(3), dum
!
!     k=1
!     mm=0
!     do nm=1,nmol  ! loop over fragments
!        m=0
!        do i=k,fragind(nm)
!           m=m+1
!        enddo
!        mm=m
!        allocate(tmp(3,mm),tmp2(3,mm))
!        m=0
!        do i=k,fragind(nm)
!           m=m+1
!           tmp (1:3,m)=xyzref(1:3,i,1)
!           tmp2(1:3,m)=xyzref(1:3,i,s1)                 ! copy bad zmat
!        enddo
!        call rmsd(mm,tmp,tmp2,1,u1,x,y1,dum,.false.,gdum) ! det orient
!        m=0
!        do i=k,fragind(nm)
!           m=m+1
!           tmp (1:3,m)=xyzref(1:3,i,1)
!           tmp2(1:3,m)=xyzref(1:3,i,s2)                 ! copy bad zmat
!        enddo
!        call rmsd(mm,tmp,tmp2,1,u2,x,y2,dum,.false.,gdum) ! det orient
!        write(*,*) nm,dum
!        call prmat(6,u,3,3,'u')
!        write(*,*) x
!        write(*,*) y
!        do i=1,mm                                       ! shift
!           tmp2(1:3,i)=tmp2(1:3,i)-y(1:3)
!        enddo
!        tmp2=matmul(u,tmp2)                             ! rotate
!        m=0
!        do i=k,fragind(nm)
!           m=m+1
!           xyz(1:3,i)=tmp2(1:3,m)+x(1:3)                ! shift back
!        enddo
!        deallocate(tmp,tmp2)
!        k=k+fragind(nm)
!     enddo

!     end

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

subroutine xyzgeo(xyz,numat,na,nb,nc,degree,geo)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: numat
   real(wp),intent(in)    :: xyz(3,numat)
   integer, intent(in)    :: na(numat), nb(numat), nc(numat)
   real(wp),intent(in)    :: degree
   real(wp),intent(inout) :: geo(3,numat)
   !**********************************************************************
   !
   !   xyzgeo converts coordinates from cartesian to internal.
   !
   !     on input xyz  = array of cartesian coordinates
   !              numat= number of atoms
   !              na   = numbers of atom to which atoms are related
   !                     by distance
   !              nb   = numbers of atom to which atoms are related
   !                     by angle
   !              nc   = numbers of atom to which atoms are related
   !                     by dihedral
   !
   !    on output geo  = internal coordinates in angstroms, radians,
   !                     and radians
   !
   !**********************************************************************
   integer :: i,j,k,l
   integer :: ii
   do i=2,numat
      j=na(i)
      k=nb(i)
      l=nc(i)
      if(i.lt.3) cycle
      ii=i
      call bangle(xyz,ii,j,k,geo(2,i))
      geo(2,i)=geo(2,i)*degree
      if(i.lt.4) cycle
      !
      !   make sure dihedral is meaninglful
      !
      !        call bangle(xyz,j,k,l,angl)
      !        tol=0.2617994d0
      !        if(angl.gt.3.1415926d0-tol.or.angl.lt.tol)then
      !
      !  angle is unsatisfactory, let's search for another atom for
      !  defining the dihedral.
      ! 88       sum=100.d0
      !        do 74 i1=1,ii-1
      !           r=(xyz(1,i1)-xyz(1,k))**2+
      !    1          (xyz(2,i1)-xyz(2,k))**2+
      !    2          (xyz(3,i1)-xyz(3,k))**2
      !           if(r.lt.sum.and.i1.ne.j.and.i1.ne.k) then
      !         call bangle(xyz,j,k,i1,angl)
      !        if(angl.lt.3.1415926d0-tol.or.angl.gt.tol)then
      !              sum=r
      !              l=i1
      !              nc(ii)=l
      !           endif
      !           endif
      ! 74  continue
      !     if(sum.gt.99.d0.and.tol.gt.0.1d0)then
      !
      ! anything within 5 degrees?
      !
      !     tol=0.087266d0
      !     goto 88
      !     endif
      !           endif
      call dihed(xyz,ii,j,k,l,geo(3,i))
      geo(3,i)=geo(3,i)*degree
      geo(1,i)= sqrt((xyz(1,i)-xyz(1,j))**2+&
         &               (xyz(2,i)-xyz(2,j))**2+&
         &               (xyz(3,i)-xyz(3,j))**2)
   enddo
   geo(1,1)=0.d0
   geo(2,1)=0.d0
   geo(3,1)=0.d0
   geo(2,2)=0.d0
   geo(3,2)=0.d0
   geo(3,3)=0.d0
end subroutine xyzgeo

!     *****************************************************************
subroutine xyzint(xyz,numat,na,nb,nc,degree,geo)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: numat
   real(wp),intent(in)    :: xyz(3,numat)
   integer, intent(inout) :: na(numat), nb(numat), nc(numat)
   real(wp),intent(in)    :: degree
   real(wp),intent(inout) :: geo(3,numat)
   !**********************************************************************
   !
   ! xyzint works out the internal coordinates of a molecule.
   !        the "rules" for the connectivity are as follows:
   !        atom i is defined as being at a distance from the nearest
   !        atom j, atom j already having been defined.
   !        atom i makes an angle with atom j and the atom k, which has
   !        already been defined, and is the nearest atom to j
   !        atom i makes a dihedral angle with atoms j, k, and l. l having
   !        been defined and is the nearest atom to k, and j, k and l
   !        have a contained angle in the range 15 to 165 degrees,
   !        if possible.
   !
   !        note that geo and xyz must not be the same in the call.
   !
   !   on input xyz    = cartesian array of numat atoms
   !            degree = 1 if angles are to be in radians
   !            degree = 57.29578 if angles are to be in radians
   !
   !**********************************************************************
   integer  :: nai1,nai2
   integer  :: i,j,k
   integer  :: im1
   real(wp) :: r,sum
   nai1=0
   nai2=0
   do i=1,numat
      na(i)=2
      nb(i)=3
      nc(i)=4
      im1=i-1
      if(im1.eq.0) cycle
      sum=100.d0
      do j=1,im1
         r=(xyz(1,i)-xyz(1,j))**2+&
            &          (xyz(2,i)-xyz(2,j))**2+&
            &          (xyz(3,i)-xyz(3,j))**2
         if(r.lt.sum.and.na(j).ne.j.and.nb(j).ne.j) then
            sum=r
            k=j
         endif
      enddo
      !
      !   atom i is nearest to atom k
      !
      na(i)=k
      if(i.gt.2)nb(i)=na(k)
      if(i.gt.3)nc(i)=nb(k)
      !
      !   find any atom to relate to na(i)
      !
   enddo
   na(1)=0
   nb(1)=0
   nc(1)=0
   nb(2)=0
   nc(2)=0
   nc(3)=0

   call xyzgeo(xyz,numat,na,nb,nc,degree,geo)
end subroutine xyzint

pure subroutine bangle(xyz,i,j,k,angle)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in) :: i,j,k
   real(wp),intent(in) :: xyz(3,*)
   real(wp),intent(out) :: angle
   !********************************************************************
   !
   ! bangle calculates the angle between atoms i,j, and k. the
   !        cartesian coordinates are in xyz.
   !
   !********************************************************************
   real(wp) :: d2ij,d2jk,d2ik,xy,temp
   d2ij = (xyz(1,i)-xyz(1,j))**2+&
      &       (xyz(2,i)-xyz(2,j))**2+&
      &       (xyz(3,i)-xyz(3,j))**2
   d2jk = (xyz(1,j)-xyz(1,k))**2+&
      &       (xyz(2,j)-xyz(2,k))**2+&
      &       (xyz(3,j)-xyz(3,k))**2
   d2ik = (xyz(1,i)-xyz(1,k))**2+&
      &       (xyz(2,i)-xyz(2,k))**2+&
      &       (xyz(3,i)-xyz(3,k))**2
   xy = sqrt(d2ij*d2jk+1.d-14)
   temp = 0.5d0 * (d2ij+d2jk-d2ik) / xy
   if (temp .gt. 1.0d0) temp=1.0d0
   if (temp .lt. -1.0d0) temp=-1.0d0
   angle = acos( temp )
end subroutine bangle
subroutine dihed(xyz,i,j,k,l,angle)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: i,j,k,l
   real(wp),intent(inout) :: angle
   real(wp),intent(in)    :: xyz(3,*)
   !********************************************************************
   !
   !      dihed calculates the dihedral angle between atoms i, j, k,
   !            and l.  the cartesian coordinates of these atoms
   !            are in array xyz.
   !
   !     dihed is a modified version of a subroutine of the same name
   !           which was written by dr. w. theil in 1973.
   !
   !********************************************************************
   real(wp),parameter :: pi = 3.14159265358979d0
   real(wp) :: xi1,xj1,xl1,xi2,xj2,xl2
   real(wp) :: yi1,yj1,yl1,yi2,yj2,yl2,yi3,yl3
   real(wp) :: zi1,zj1,zl1
   real(wp) :: dist,yxdist
   real(wp) :: cosa,sinth,costh,cosph,sinph
   real(wp) :: ddd
   xi1=xyz(1,i)-xyz(1,k)
   xj1=xyz(1,j)-xyz(1,k)
   xl1=xyz(1,l)-xyz(1,k)
   yi1=xyz(2,i)-xyz(2,k)
   yj1=xyz(2,j)-xyz(2,k)
   yl1=xyz(2,l)-xyz(2,k)
   zi1=xyz(3,i)-xyz(3,k)
   zj1=xyz(3,j)-xyz(3,k)
   zl1=xyz(3,l)-xyz(3,k)
   !      rotate around z axis to put kj along y axis
   dist= sqrt(xj1**2+yj1**2+zj1**2+1.d-14)
   cosa=zj1/dist
   if(cosa.gt.1.0d0) cosa=1.0d0
   if(cosa.lt.-1.0d0) cosa=-1.0d0
   ddd=1.0d0-cosa**2
   if(ddd.le.0.0) go to 10
   yxdist=dist* sqrt(ddd)
   if(yxdist.gt.1.0d-12) go to 20
   10 continue
   xi2=xi1
   xl2=xl1
   yi2=yi1
   yl2=yl1
   costh=cosa
   sinth=0.d0
   go to 30
   20 cosph=yj1/yxdist
   sinph=xj1/yxdist
   xi2=xi1*cosph-yi1*sinph
   xj2=xj1*cosph-yj1*sinph
   xl2=xl1*cosph-yl1*sinph
   yi2=xi1*sinph+yi1*cosph
   yj2=xj1*sinph+yj1*cosph
   yl2=xl1*sinph+yl1*cosph
   !      rotate kj around the x axis so kj lies along the z axis
   costh=cosa
   sinth=yj2/dist
   30 continue
   yi3=yi2*costh-zi1*sinth
   yl3=yl2*costh-zl1*sinth
   call dang(xl2,yl3,xi2,yi3,angle)
   !     if (angle .lt. 0.) angle=2.0d0*pi+angle
   !sg   if (angle .ge. 2.0d0*pi    ) angle=0.d0
end subroutine dihed
pure subroutine dang(a1,a2,b1,b2,rcos)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp),intent(inout) :: a1,a2,b1,b2
   real(wp),intent(out)   :: rcos
   !*********************************************************************
   !
   !    dang  determines the angle between the points (a1,a2), (0,0),
   !          and (b1,b2).  the result is put in rcos.
   !
   !*********************************************************************
   real(wp),parameter :: pi = 3.14159265358979d0
   real(wp) :: zero
   real(wp) :: anorm,bnorm
   real(wp) :: sinth,costh
   zero=1.0d-10
   if( abs(a1).lt.zero.and. abs(a2).lt.zero) go to 10
   if( abs(b1).lt.zero.and. abs(b2).lt.zero) go to 10
   anorm=1.0d0/ sqrt(a1**2+a2**2)
   bnorm=1.0d0/ sqrt(b1**2+b2**2)
   a1=a1*anorm
   a2=a2*anorm
   b1=b1*bnorm
   b2=b2*bnorm
   sinth=(a1*b2)-(a2*b1)
   costh=a1*b1+a2*b2
   if(costh.gt.1.0d0) costh=1.0d0
   if(costh.lt.-1.0d0) costh=-1.0d0
   rcos= acos(costh)
   if( abs(rcos).lt.zero) go to 10
   if(sinth.gt.0.d0) rcos=2.0d0*pi-rcos
   rcos=-rcos
   return
   10 rcos=0.0d0
end subroutine dang

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

pure subroutine gmetry(natoms, geo, coord, na,nb,nc,fail)
   use xtb_mctc_accuracy, only : wp
   implicit none

   integer, intent(in)    :: natoms
   real(wp),intent(inout) :: coord(3,natoms)
   real(wp),intent(in)    :: geo(3,natoms)
   integer, intent(in)    :: na(natoms), nb(natoms), nc(natoms)
   logical, intent(out)   :: fail
   real(wp) :: ccos
   real(wp) :: xa,ya,za
   real(wp) :: xb,yb,zb
   real(wp) :: xd,yd,zd
   real(wp) :: rbc,xpa,xpb,xyb
   real(wp) :: ypa,xqa,zqa,yza
   real(wp) :: ypd,zpd,xpd,zqd,xqd,yqd,xrd
   real(wp) :: costh,sinth,sinph,cosph
   real(wp) :: coskh,sinkh,sina,cosa,sind,cosd
   integer  :: i,k
   integer  :: ma,mb,mc

   fail=.false.

   coord(1,1)=0.0d00
   coord(2,1)=0.0d00
   coord(3,1)=0.0d00
   coord(1,2)=geo(1,2)
   coord(2,2)=0.0d00
   coord(3,2)=0.0d00
   if(natoms.eq.2) goto 110
   ccos=cos(geo(2,3))
   if(na(3).eq.1)then
      coord(1,3)=coord(1,1)+geo(1,3)*ccos
   else
      coord(1,3)=coord(1,2)-geo(1,3)*ccos
   endif
   coord(2,3)=geo(1,3)*sin(geo(2,3))
   coord(3,3)=0.0d00
   do i=4,natoms
      cosa=cos(geo(2,i))
      mb=nb(i)
      mc=na(i)
      xb=coord(1,mb)-coord(1,mc)
      yb=coord(2,mb)-coord(2,mc)
      zb=coord(3,mb)-coord(3,mc)
      rbc=1.0d00/dsqrt(xb*xb+yb*yb+zb*zb)
      if (abs(cosa).lt.0.9999999999d0) go to 40
      !
      !     atoms mc, mb, and (i) are collinear
      !
      rbc=geo(1,i)*rbc*cosa
      coord(1,i)=coord(1,mc)+xb*rbc
      coord(2,i)=coord(2,mc)+yb*rbc
      coord(3,i)=coord(3,mc)+zb*rbc
      cycle
      !
      !     the atoms are not collinear
      !
      40    ma=nc(i)
      xa=coord(1,ma)-coord(1,mc)
      ya=coord(2,ma)-coord(2,mc)
      za=coord(3,ma)-coord(3,mc)
      !
      !     rotate about the z-axis to make yb=0, and xb positive.  if xyb is
      !     too small, first rotate the y-axis by 90 degrees.
      !
      xyb=dsqrt(xb*xb+yb*yb)
      k=-1
      if (xyb.gt.0.1d00) go to 50
      xpa=za
      za=-xa
      xa=xpa
      xpb=zb
      zb=-xb
      xb=xpb
      xyb=dsqrt(xb*xb+yb*yb)
      k=1
      !
      !     rotate about the y-axis to make zb vanish
      !
      50    costh=xb/xyb
      sinth=yb/xyb
      xpa=xa*costh+ya*sinth
      ypa=ya*costh-xa*sinth
      sinph=zb*rbc
      cosph=dsqrt(abs(1.d00-sinph*sinph))
      xqa=xpa*cosph+za*sinph
      zqa=za*cosph-xpa*sinph
      !
      !     rotate about the x-axis to make za=0, and ya positive.
      !
      yza=dsqrt(ypa*ypa+zqa*zqa)
      if(yza.lt.1.d-4 )then
         if(yza.lt.1.d-4)goto 70
         !           write(*,'(/9x,'' atoms'',i3,'','',i3,'', and'',i3,
         !    1'' are within'',f7.4,'' angstroms of a straight line'')')
         !    2mc,mb,ma,yza
         fail=.true.
         return
      endif
      coskh=ypa/yza
      sinkh=zqa/yza
      goto 80
      70    continue
      !
      !   angle too small to be important
      !
      coskh=1.d0
      sinkh=0.d0
      80    continue
      !
      !     coordinates :-   a=(xqa,yza,0),   b=(rbc,0,0),  c=(0,0,0)
      !     none are negative.
      !     the coordinates of i are evaluated in the new frame.
      !
      sina=sin(geo(2,i))
      sind=-sin(geo(3,i))
      cosd=cos(geo(3,i))
      xd=geo(1,i)*cosa
      yd=geo(1,i)*sina*cosd
      zd=geo(1,i)*sina*sind
      !
      !     transform the coordinates back to the original system.
      !
      ypd=yd*coskh-zd*sinkh
      zpd=zd*coskh+yd*sinkh
      xpd=xd*cosph-zpd*sinph
      zqd=zpd*cosph+xd*sinph
      xqd=xpd*costh-ypd*sinth
      yqd=ypd*costh+xpd*sinth
      if (k.lt.1) go to 90
      xrd=-zqd
      zqd=xqd
      xqd=xrd
      90    coord(1,i)=xqd+coord(1,mc)
      coord(2,i)=yqd+coord(2,mc)
      coord(3,i)=zqd+coord(3,mc)
   end do
   110 continue

end subroutine gmetry

pure subroutine cma(nat,at,xyz,sum3)
   use xtb_mctc_accuracy, only : wp
   ! atomic masses
   use xtb_splitparam
   implicit none
   integer, intent(in)  :: nat
   real(wp),intent(in)  :: xyz(3,nat)
   integer, intent(in)  :: at(nat)
   real(wp),intent(out) :: sum3(3)
   real(wp) :: sumw,sumwx,sumwy,sumwz
   integer  :: i

   sumw=0.0_wp
   sumwx=0.0_wp
   sumwy=0.0_wp
   sumwz=0.0_wp

   do i=1,nat
      sumw=sumw+atmass(i)
      sumwx=sumwx+atmass(i)*xyz(1,i)
      sumwy=sumwy+atmass(i)*xyz(2,i)
      sumwz=sumwz+atmass(i)*xyz(3,i)
   enddo

   sum3(1)=sumwx/sumw
   sum3(2)=sumwy/sumw
   sum3(3)=sumwz/sumw

end subroutine cma

end module xtb_intmodes

! This file is part of the dipro module in xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Helper routines to handle calculations with the tblite library
module xtb_dipro_xtb
   use mctc_env, only : error_type, fatal_error, wp
   use mctc_io, only : structure_type
#if WITH_TBLITE
   use tblite_xtb_calculator, only : xtb_calculator
   use tblite_xtb_gfn2, only : new_gfn2_calculator
   use tblite_xtb_gfn1, only : new_gfn1_calculator
   use tblite_xtb_ipea1, only : new_ipea1_calculator
   implicit none
   private

   public :: get_calculator

contains

!> Create a new calculator for a given method string
subroutine get_calculator(xcalc, mol, method, error)
   !> Instance of the new calculator
   type(xtb_calculator), intent(out) :: xcalc
   !> Molecular structure data
   type(structure_type), intent(in) :: mol
   !> Name of the requested method
   character(len=*), intent(in) :: method
   !> Error handling
   type(error_type), allocatable, intent(out) :: error

   select case(method)
   case default
      call fatal_error(error, "Unknown method '"//method//"' requested")
!      error stop
   case("gfn2")
      call new_gfn2_calculator(xcalc, mol)
   case("gfn1")
      call new_gfn1_calculator(xcalc, mol)
   case("ipea1")
      call new_ipea1_calculator(xcalc, mol)
   end select
end subroutine get_calculator
#endif

end module xtb_dipro_xtb

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of a map from element symbols/atomic numbers to ids
module xtb_type_identitymap
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_resize, only : resize
   use xtb_mctc_symbols, only : symbolLength
   use xtb_type_molecule, only : TMolecule
   implicit none
   private

   public :: TIdentityMap, init


   !> Maps an identity to all its atoms
   type :: TAtomicMap

      !> Positions in the atomic array
      integer, allocatable :: pos(:)

   end type TAtomicMap


   !> Map from element symbols to identity
   type :: TIdentityMap
      private

      !> Atomic numbers for each id
      integer, allocatable :: num(:)

      !> Element symbols for each id
      character(len=symbolLength), allocatable :: sym(:)

      !> Maps from id to its atoms
      type(TAtomicMap), allocatable :: map(:)

   contains

      !> Write informative printout for the map
      procedure :: writeInfo

      !> Check if symbol or number maps to atoms
      generic :: has => hasSymbol, hasNumber

      !> Check if element symbol maps to atoms
      procedure, private :: hasSymbol

      !> Check if atomic number maps to atoms
      procedure, private :: hasNumber

      !> Get indices
      generic :: get => getIndexSymbol, getIndexNumber

      !> Get indices for an unique element symbol
      procedure, private :: getIndexSymbol

      !> Get indices for a certain atomic number
      procedure, private :: getIndexNumber

      !> Setter functions in atomic arrays
      generic :: set => setRealWithSymbol, setRealWithNumber

      !> Set value in an array using an unique element symbol
      procedure, private :: setRealWithSymbol

      !> Set value in an array using the atomic number
      procedure, private :: setRealWithNumber

   end type TIdentityMap


   !> Initialize identity map
   interface init
      module procedure :: initIdentityMapFromMolecule
      module procedure :: initIdentityMapFromArrays
   end interface init


contains


!> Initialize identity map from molecular structure data
subroutine initIdentityMapFromMolecule(self, mol)

   !> Instance of the map
   type(TIdentityMap), intent(out) :: self

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   call init(self, mol%id, mol%sym, mol%at)

end subroutine initIdentityMapFromMolecule


!> Initialize identity map from at atomic numbers and element symbols
subroutine initIdentityMapFromArrays(self, id, sym, num)

   !> Instance of the map
   type(TIdentityMap), intent(out) :: self

   !> Atomic numbers for each id
   integer, intent(in) :: id(:)

   !> Atomic numbers for each atom
   integer, intent(in) :: num(:)

   !> Element symbols for each atom
   character(len=symbolLength), intent(in) :: sym(:)

   integer :: nAt, nId
   integer :: iId, iAt, thisAt, initialSize, nMp
   integer, allocatable :: pos(:)

   nAt = size(id)
   nId = maxval(id)

   allocate(self%map(nId))
   allocate(self%num(nId))
   allocate(self%sym(nId))

   initialSize = nAt / nId + 1
   allocate(pos(initialSize))

   do iId = 1, nId
      pos = 0
      nMp = 0
      thisAt = 0
      do iAt = 1, nAt
         if (id(iAt) == iId) then
            if (thisAt == 0) thisAt = iAt
            if (nMp >= size(pos)) then
               call resize(pos)
            end if
            nMp = nMp + 1
            pos(nMp) = iAt
         end if
      end do
      self%num(iId) = num(thisAt)
      self%sym(iId) = sym(thisAt)
      allocate(self%map(iId)%pos(nMp))
      self%map(iId)%pos(:) = pos(:nMp)
   end do

end subroutine initIdentityMapFromArrays


subroutine writeInfo(self, unit)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   integer :: iId, iStart, iEnd, iDel
   character(len=:), allocatable :: list

   write(unit, '(a5,1x,a4,1x,a4,3x,a5)') "ID", "Z", "sym.", "atoms"
   do iId = 1, size(self%sym)
      write(unit, '(i5,1x,i4,1x,a4,3x)', advance='no') &
         & iId, self%num(iId), self%sym(iId)
      call serializeAtomicMap(self%map(iId)%pos, list, '-', ', ')
      iStart = 1
      iEnd = min(60, len(list))
      do while(iStart <= len(list))
         if (iEnd >= len(list)) then
            iDel = iEnd
         else
            iDel = index(list(iStart:iEnd), ' ', back=.true.) + iStart - 2
            if (iDel < iStart) then
               iDel = index(list(iEnd:), ' ') + iEnd - 2
               if (iDel == iEnd - 2) iDel = len(list)
            end if
         end if
         write(unit, '(a)') list(iStart:iDel)
         iStart = iDel+1
         iEnd = min(iStart+60, len(list))
         if (iStart < len(list)) then
            write(unit, '(17x)', advance='no')
         end if
      end do
   end do

end subroutine writeInfo


subroutine serializeAtomicMap(list, string, separator, delimiter)

   !> Instance of an atomic map
   integer, intent(in) :: list(:)

   !> Serialized form of the atomic map
   character(len=:), allocatable, intent(out) :: string

   !> Separator for list
   character(len=*), intent(in), optional :: separator

   !> Separator for list
   character(len=*), intent(in), optional :: delimiter

   integer :: ii, jj, kk
   character(len=64) :: buffer
   character(len=:), allocatable :: sep, del

   if (present(separator)) then
      sep = separator
   else
      sep = ', '
   end if

   if (present(delimiter)) then
      del = delimiter
   else
      del = '-'
   end if

   string = ''
   jj = list(1)
   kk = jj
   do ii = 2, size(list)
      if (jj+1 == list(ii)) then
         jj = jj+1
      else
         if (jj-kk == 0) then
            write(buffer, '(i0)') jj
         else if (jj-kk == 1) then
            write(buffer, '(i0,a,i0)') kk, del, jj
         else
            write(buffer, '(i0,a,i0)') kk, sep, jj
         end if
         string = string // trim(buffer) // del
         jj = list(ii)
         kk = jj
      end if
   end do
   if (jj-kk == 0) then
      write(buffer, '(i0)') jj
   else if (jj-kk == 1) then
      write(buffer, '(i0,a,i0)') kk, del, jj
   else
      write(buffer, '(i0,a,i0)') kk, sep, jj
   end if
   string = string // trim(buffer)

end subroutine serializeAtomicMap


!> Check if element symbol maps to atoms
pure function hasSymbol(self, sym) result(exist)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Element symbol
   character(len=*), intent(in) :: sym

   !> Symbol is present
   logical :: exist

   exist = any(self%sym == sym)

end function hasSymbol


!> Check if atomic number maps to atoms
pure function hasNumber(self, num) result(exist)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Atomic number
   integer, intent(in) :: num

   !> Number is present
   logical :: exist

   exist = any(self%num == num)

end function hasNumber


!> Get indices for an unique element symbol
subroutine getIndexSymbol(self, indx, sym)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Indices for all selected atoms
   integer, allocatable, intent(out) :: indx(:)

   !> Element symbol
   character(len=*), intent(in) :: sym

   integer :: iId

   do iId = 1, size(self%sym)
      if (self%sym(iId) == sym) then
         indx = self%map(iId)%pos
         exit
      end if
   end do

end subroutine getIndexSymbol


!> Get indices for a certain atomic number
subroutine getIndexNumber(self, indx, num)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Indices for all selected atoms
   integer, allocatable, intent(out) :: indx(:)

   !> Atomic number
   integer, intent(in) :: num

   integer :: nAt, iId, newSize
   integer, allocatable :: pos(:)

   nAt = 0
   do iId = 1, size(self%num)
      if (self%num(iId) == num) then
         newSize = nAt + size(self%map(iId)%pos)
         if (newSize >= size(pos)) then
            call resize(pos, newSize)
         end if
         pos(nAt+1:newSize) = self%map(iId)%pos
      end if
   end do

   if (nAt > 0) then
      call move_alloc(pos, indx)
   end if

end subroutine getIndexNumber


!> Set value in an array using an unique element symbol
subroutine setRealWithSymbol(self, array, sym, val)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Instance of the array
   real(wp), intent(inout) :: array(:)

   !> Element symbol
   character(len=*), intent(in) :: sym

   !> Value to set
   real(wp), intent(in) :: val

   integer :: iId

   do iId = 1, size(self%sym)
      if (self%sym(iId) == sym) then
         array(self%map(iId)%pos) = val
      end if
   end do

end subroutine setRealWithSymbol


!> Set value in an array using the atomic number
subroutine setRealWithNumber(self, array, num, val)

   !> Instance of the map
   class(TIdentityMap), intent(in) :: self

   !> Instance of the array
   real(wp), intent(inout) :: array(:)

   !> Atomic number
   integer, intent(in) :: num

   !> Value to set
   real(wp), intent(in) :: val

   integer :: iId

   do iId = 1, size(self%num)
      if (self%num(iId) == num) then
         array(self%map(iId)%pos) = val
      end if
   end do

end subroutine setRealWithNumber


end module xtb_type_identitymap

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ========================================================================
!  This module implements various model Hessians, the actual definition
!  of the model Hessian is given in the description of each header, the
!  implementation following tries to do its very best to transform it back
!  from redundant internal coordinates (where the model is defined) to
!  Cartesian coordinates which are then used in any imaginable fashion
!  later on in the actual optimization.                        - SAW190131
!! ========================================================================
module xtb_modelhessian
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_chargemodel
   implicit none

   public :: mh_lindh
   public :: mh_lindh_d2
   public :: mh_swart
   private

!  van-der-Waals radii used in the D2 model
   real(wp),parameter :: vander(86) = aatoau * (/ &
     0.91_wp,0.92_wp, & ! H, He
     0.75_wp,1.28_wp,1.35_wp,1.32_wp,1.27_wp,1.22_wp,1.17_wp,1.13_wp, & ! Li-Ne
     1.04_wp,1.24_wp,1.49_wp,1.56_wp,1.55_wp,1.53_wp,1.49_wp,1.45_wp, & ! Na-Ar
     1.35_wp,1.34_wp, & ! K, Ca
     1.42_wp,1.42_wp,1.42_wp,1.42_wp,1.42_wp, & ! Sc-Zn
     1.42_wp,1.42_wp,1.42_wp,1.42_wp,1.42_wp, &
     1.50_wp,1.57_wp,1.60_wp,1.61_wp,1.59_wp,1.57_wp, & ! Ga-Kr
     1.48_wp,1.46_wp, & ! Rb, Sr
     1.49_wp,1.49_wp,1.49_wp,1.49_wp,1.49_wp, & ! Y-Cd
     1.49_wp,1.49_wp,1.49_wp,1.49_wp,1.49_wp, &
     1.52_wp,1.64_wp,1.71_wp,1.72_wp,1.72_wp,1.71_wp, & ! In-Xe
     2.00_wp,2.00_wp, &
     2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp, & ! La-Yb
     2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp, &
     2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp, & ! Lu-Hg
     2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp, &
     2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp,2.00_wp /) ! Tl-Rn
!  C6 coefficients used in the D2 model
   real(wp),parameter :: c6(86) = (/&
      0.14_wp, 0.08_wp, & ! H,He
      1.61_wp, 1.61_wp, 3.13_wp, 1.75_wp, 1.23_wp, 0.70_wp, 0.75_wp, 0.63_wp, &
      5.71_wp, 5.71_wp,10.79_wp, 9.23_wp, 7.84_wp, 5.57_wp, 5.07_wp, 4.61_wp, &
     10.80_wp,10.80_wp, & ! K,Ca
     10.80_wp,10.80_wp,10.80_wp,10.80_wp,10.80_wp, & ! Sc-Zn
     10.80_wp,10.80_wp,10.80_wp,10.80_wp,10.80_wp, &
     16.99_wp,17.10_wp,16.37_wp,12.64_wp,12.47_wp,12.01_wp, & ! Ga-Kr
     24.67_wp,24.67_wp, & ! Rb,Sr
     24.67_wp,24.67_wp,24.67_wp,24.67_wp,24.67_wp, & ! Y-Cd
     24.67_wp,24.67_wp,24.67_wp,24.67_wp,24.67_wp, &
     37.32_wp,38.71_wp,38.44_wp,31.74_wp,31.50_wp,29.99_wp, & ! In-Xe
     50.00_wp,50.00_wp, & ! Cs,Ba
     50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp, & ! La-Yb
     50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp, &
     50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp, & ! Lu-Hg
     50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp, &
     50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp,50.00_wp /) ! Tl-Rn

   real(wp),parameter :: min_fk = 1.0e-3_wp

contains

!! ========================================================================
!  Swart's Model Hessian augmented with D2
!! ------------------------------------------------------------------------
!  Implemented after:
!  M. Swart, F. M. Bickelhaupt, Int. J. Quantum Chem., 2006, 106, 2536–2544.
!  DOI:10.1002/qua.21049
!
!  gij = exp[-(Rij/Cij-1)]
!  kij   = rkr·gij
!  kijk  = rkf·gij·gjk
!  kijkl = rkt·gij·gjk·gkl
!
!  The proposed force constants by Swart are:
!  rkr = 0.35, rkf = 0.15, rkt = 0.005
!
!  This Hessian is additionally augmented with D2, please note that D2
!  is not implemented in atomic units and requires some magical conversion
!  factor somewhere hidden in the implementation below.
!! ------------------------------------------------------------------------
subroutine mh_swart(xyz,n,hess,at,modh)
   use xtb_mctc_constants
   use xtb_mctc_convert
   use xtb_mctc_param, only: rad => covalent_radius_2009

   use xtb_type_setvar
   use xtb_type_param

   implicit none

   integer, intent(in)  :: n
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(out) :: hess((3*n)*(3*n+1)/2)
   integer, intent(in)  :: at(n)
   type(modhess_setvar),intent(in) :: modh

   integer  :: n3
   real(wp),parameter :: rzero = 1.0e-10_wp
   logical, allocatable :: lcutoff(:,:)
   type(chrg_parameter) :: chrgeq
   real(wp) :: kd

   allocate( lcutoff(n,n), source=.false.)

   n3=3*n
   hess = 0.0d0

!  the dispersion force constant is used relative to the stretch force constant
   kd = modh%kd/modh%kr

   call mh_swart_stretch(n,at,xyz,hess,modh%kr,kd,modh%s6,rad,rad,lcutoff,modh%rcut)
   if (modh%kf.ne.0.0_wp) &
   call mh_swart_bend   (n,at,xyz,hess,modh%kf,kd,        rad,rad,lcutoff)
   if (modh%kt.ne.0.0_wp) &
   call mh_swart_torsion(n,at,xyz,hess,modh%kt,kd,        rad,rad,lcutoff)
   if (modh%ko.ne.0.0_wp) &
   call mh_swart_outofp (n,at,xyz,hess,modh%ko,kd,        rad,rad,lcutoff)
   if (modh%kq.ne.0.0_wp) then
      call new_charge_model_2019(chrgeq,n,at)
      call mh_eeq(n,at,xyz,0.0_wp,chrgeq,modh%kq,hess)
   endif

end subroutine mh_swart

pure subroutine mh_swart_stretch(n,at,xyz,hess,kr,kd,s6,rcov,rvdw,lcutoff,rcut)
   use xtb_mctc_constants
   use xtb_mctc_convert

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: kr
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: s6
   real(wp),intent(in)    :: rcov(:)
   real(wp),intent(in)    :: rvdw(:)
   logical, intent(out)   :: lcutoff(n,n)
   real(wp),intent(in)    :: rcut

   integer  :: i,j
   real(wp) :: xij,yij,zij,rij2,r0,d0
   real(wp) :: gmm
   real(wp) :: c6i,c6j,c6ij,rv
   real(wp) :: hxx,hxy,hxz,hyy,hyz,hzz
   real(wp) :: vdw(3,3)

!! ------------------------------------------------------------------------
!  Hessian for stretch
!! ------------------------------------------------------------------------
   stretch_iAt: do i = 1, n

      stretch_jAt: do j = 1, i-1

         ! save for later
         lcutoff(i,j) = rcutoff(xyz,i,j,rcut)
         lcutoff(j,i) = lcutoff(i,j)

         xij=xyz(1,i)-xyz(1,j)
         yij=xyz(2,i)-xyz(2,j)
         zij=xyz(3,i)-xyz(3,j)
         rij2 = xij**2 + yij**2 + zij**2
         r0 = rcov(at(i))+rcov(at(j))
         d0 = rvdw(at(i))+rvdw(at(j))

         !cccccc vdwx ccccccccccccccccccccccccccccccccc
         c6i=c6(at(i))
         c6j=c6(at(j))
         c6ij=sqrt(c6i*c6j)
         rv=(vander(at(i))+vander(at(j)))*aatoau

         call getvdwxx(xij, yij, zij, c6ij, s6, rv, vdw(1,1))
         call getvdwxy(xij, yij, zij, c6ij, s6, rv, vdw(1,2))
         call getvdwxy(xij, zij, yij, c6ij, s6, rv, vdw(1,3))
         call getvdwxx(yij, xij, zij, c6ij, s6, rv, vdw(2,2))
         call getvdwxy(yij, zij, xij, c6ij, s6, rv, vdw(2,3))
         call getvdwxx(zij, xij, yij, c6ij, s6, rv, vdw(3,3))
         !cccccc ende vdwx ccccccccccccccccccccccccccccccc

         gmm = kr*fk_swart(1.0_wp,  r0,rij2) &
            + kr*kd * fk_vdw(5.0_wp,d0,rij2)

         !gmm = max(gmm,min_fk)

         hxx=gmm*xij*xij/rij2-vdw(1,1)
         hxy=gmm*xij*yij/rij2-vdw(1,2)
         hxz=gmm*xij*zij/rij2-vdw(1,3)
         hyy=gmm*yij*yij/rij2-vdw(2,2)
         hyz=gmm*yij*zij/rij2-vdw(2,3)
         hzz=gmm*zij*zij/rij2-vdw(3,3)

         ! save diagonal elements for atom i
         hess(ind(1,i,1,i))=hess(ind(1,i,1,i))+hxx
         hess(ind(2,i,1,i))=hess(ind(2,i,1,i))+hxy
         hess(ind(2,i,2,i))=hess(ind(2,i,2,i))+hyy
         hess(ind(3,i,1,i))=hess(ind(3,i,1,i))+hxz
         hess(ind(3,i,2,i))=hess(ind(3,i,2,i))+hyz
         hess(ind(3,i,3,i))=hess(ind(3,i,3,i))+hzz
         ! save elements between atom i and atom j
         hess(ind(1,i,1,j))=hess(ind(1,i,1,j))-hxx
         hess(ind(1,i,2,j))=hess(ind(1,i,2,j))-hxy
         hess(ind(1,i,3,j))=hess(ind(1,i,3,j))-hxz
         hess(ind(2,i,1,j))=hess(ind(2,i,1,j))-hxy
         hess(ind(2,i,2,j))=hess(ind(2,i,2,j))-hyy
         hess(ind(2,i,3,j))=hess(ind(2,i,3,j))-hyz
         hess(ind(3,i,1,j))=hess(ind(3,i,1,j))-hxz
         hess(ind(3,i,2,j))=hess(ind(3,i,2,j))-hyz
         hess(ind(3,i,3,j))=hess(ind(3,i,3,j))-hzz
         ! save diagonal elements for atom j
         hess(ind(1,j,1,j))=hess(ind(1,j,1,j))+hxx
         hess(ind(2,j,1,j))=hess(ind(2,j,1,j))+hxy
         hess(ind(2,j,2,j))=hess(ind(2,j,2,j))+hyy
         hess(ind(3,j,1,j))=hess(ind(3,j,1,j))+hxz
         hess(ind(3,j,2,j))=hess(ind(3,j,2,j))+hyz
         hess(ind(3,j,3,j))=hess(ind(3,j,3,j))+hzz

      end do stretch_jAt
   end do stretch_iAt

end subroutine mh_swart_stretch

pure subroutine mh_swart_bend(n,at,xyz,hess,kf,kd,rcov,rvdw,lcutoff)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: kf
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: rcov(:)
   real(wp),intent(in)    :: rvdw(:)
   logical, intent(in)    :: lcutoff(n,n)

   integer  :: i,j,m,ic,jc,ii
   real(wp),parameter :: rzero = 1.0e-10_wp
   real(wp) :: xij,yij,zij,rij2,rrij,r1
   real(wp) :: xmi,ymi,zmi,rmi2,rmi,r0mi,d0mj,gmi
   real(wp) :: xmj,ymj,zmj,rmj2,rmj,r0mj,d0mi,gmj
   real(wp) :: test,gij,rl2,rl,rmidotrmj
   real(wp) :: sinphi,cosphi,costhetax,costhetay,costhetaz
   real(wp) :: alpha
   real(wp) :: si(3),sj(3),sm(3),x(2),y(2),z(2)

!! ------------------------------------------------------------------------
!  Hessian for bending
!! ------------------------------------------------------------------------
   bend_mAt: do m = 1, n
      bend_iAt: do i = 1, n
         if (i.eq.m) cycle bend_iAt
         if(lcutoff(i,m)) cycle bend_iAt

         xmi=(xyz(1,i)-xyz(1,m))
         ymi=(xyz(2,i)-xyz(2,m))
         zmi=(xyz(3,i)-xyz(3,m))
         rmi2 = xmi**2 + ymi**2 + zmi**2
         rmi=sqrt(rmi2)
         r0mi=rcov(at(m))+rcov(at(i))
         d0mi=rvdw(at(m))+rvdw(at(i))

         bend_jAt: do j = 1, i-1
            if (j.eq.m) cycle bend_jAt
            if(lcutoff(j,i)) cycle bend_jAt
            if(lcutoff(j,m)) cycle bend_jAt

            xmj=(xyz(1,j)-xyz(1,m))
            ymj=(xyz(2,j)-xyz(2,m))
            zmj=(xyz(3,j)-xyz(3,m))
            rmj2 = xmj**2 + ymj**2 + zmj**2
            rmj=sqrt(rmj2)
            r0mj=rcov(at(m))+rcov(at(j))
            d0mj=rvdw(at(m))+rvdw(at(j))

            ! test if zero angle
            test=xmi*xmj+ymi*ymj+zmi*zmj
            test=test/(rmi*rmj)
            if (abs(test-1.0_wp).lt.1.0e-12_wp) cycle bend_jAt

            xij=(xyz(1,j)-xyz(1,i))
            yij=(xyz(2,j)-xyz(2,i))
            zij=(xyz(3,j)-xyz(3,i))
            rij2 = xij**2 + yij**2 + zij**2
            rrij=sqrt(rij2)

            gmi = fk_swart(1.0_wp,r0mi,rmi2) &
                + 0.5_wp*kd * fk_vdw(5.0_wp,d0mi,rmi2)
            gmj = fk_swart(1.0_wp,r0mj,rmj2) &
                + 0.5_wp*kd * fk_vdw(5.0_wp,d0mj,rmj2)

            gij = kf*gmi*gmj

            rl2=(ymi*zmj-zmi*ymj)**2+(zmi*xmj-xmi*zmj)**2+(xmi*ymj-ymi*xmj)**2

            if(rl2.lt.1.e-14_wp) then
               rl=0.0_wp
            else
               rl=sqrt(rl2)
            end if

            !gij = max(gij,min_fk)

            if ((rmj.gt.rzero).and.(rmi.gt.rzero).and.(rrij.gt.rzero)) then
               sinphi=rl/(rmj*rmi)
               rmidotrmj=xmi*xmj+ymi*ymj+zmi*zmj
               cosphi=rmidotrmj/(rmj*rmi)
               ! none linear case
               if (sinphi.gt.rzero) then
                  si(1)=(xmi/rmi*cosphi-xmj/rmj)/(rmi*sinphi)
                  si(2)=(ymi/rmi*cosphi-ymj/rmj)/(rmi*sinphi)
                  si(3)=(zmi/rmi*cosphi-zmj/rmj)/(rmi*sinphi)
                  sj(1)=(cosphi*xmj/rmj-xmi/rmi)/(rmj*sinphi)
                  sj(2)=(cosphi*ymj/rmj-ymi/rmi)/(rmj*sinphi)
                  sj(3)=(cosphi*zmj/rmj-zmi/rmi)/(rmj*sinphi)
                  sm(1)=-si(1)-sj(1)
                  sm(2)=-si(2)-sj(2)
                  sm(3)=-si(3)-sj(3)
                  do ic=1,3
                     do jc=1,3
                        if (m.gt.i) then
                           hess(ind(ic,m,jc,i))=hess(ind(ic,m,jc,i)) &
                              +gij*sm(ic)*si(jc)
                        else
                           hess(ind(ic,i,jc,m))=hess(ind(ic,i,jc,m)) &
                              +gij*si(ic)*sm(jc)
                        end if
                        if (m.gt.j) then
                           hess(ind(ic,m,jc,j))=hess(ind(ic,m,jc,j)) &
                              +gij*sm(ic)*sj(jc)
                        else
                           hess(ind(ic,j,jc,m))=hess(ind(ic,j,jc,m)) &
                              +gij*sj(ic)*sm(jc)
                        end if
                        if (i.gt.j) then
                           hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j)) &
                              +gij*si(ic)*sj(jc)
                        else
                           hess(ind(ic,j,jc,i))=hess(ind(ic,j,jc,i)) &
                              +gij*sj(ic)*si(jc)
                        end if
                     end do
                  end do
                  do ic=1,3
                     do jc=1,ic
                        hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i))+gij*si(ic)*si(jc)
                        hess(ind(ic,m,jc,m))=hess(ind(ic,m,jc,m))+gij*sm(ic)*sm(jc)
                        hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j))+gij*sj(ic)*sj(jc)
                     end do
                  end do
               else
                  ! linear case
                  if ((abs(ymi).gt.rzero).or.(abs(xmi).gt.rzero)) then
                     x(1)=-ymi
                     y(1)=xmi
                     z(1)=0.0_wp
                     x(2)=-xmi*zmi
                     y(2)=-ymi*zmi
                     z(2)=xmi*xmi+ymi*ymi
                  else
                     x(1)=1.0_wp
                     y(1)=0.0_wp
                     z(1)=0.0_wp
                     x(2)=0.0_wp
                     y(2)=1.0_wp
                     z(2)=0.0_wp
                  end if
                  do ii=1,2
                     r1=sqrt(x(ii)**2+y(ii)**2+z(ii)**2)
                     costhetax=x(ii)/r1
                     costhetay=y(ii)/r1
                     costhetaz=z(ii)/r1
                     si(1)=-costhetax/rmi
                     si(2)=-costhetay/rmi
                     si(3)=-costhetaz/rmi
                     sj(1)=-costhetax/rmj
                     sj(2)=-costhetay/rmj
                     sj(3)=-costhetaz/rmj
                     sm(1)=-(si(1)+sj(1))
                     sm(2)=-(si(2)+sj(2))
                     sm(3)=-(si(3)+sj(3))
                     !
                     do ic=1,3
                        do jc=1,3
                           if (m.gt.i) then
                              hess(ind(ic,m,jc,i))=hess(ind(ic,m,jc,i)) &
                                 +gij*sm(ic)*si(jc)
                           else
                              hess(ind(ic,i,jc,m))=hess(ind(ic,i,jc,m)) &
                                 +gij*si(ic)*sm(jc)
                           end if
                           if (m.gt.j) then
                              hess(ind(ic,m,jc,j))=hess(ind(ic,m,jc,j)) &
                                 +gij*sm(ic)*sj(jc)
                           else
                              hess(ind(ic,j,jc,m))=hess(ind(ic,j,jc,m)) &
                                 +gij*sj(ic)*sm(jc)
                           end if
                           if (i.gt.j) then
                              hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j)) &
                                 +gij*si(ic)*sj(jc)
                           else
                              hess(ind(ic,j,jc,i))=hess(ind(ic,j,jc,i)) &
                                 +gij*sj(ic)*si(jc)
                           end if
                        end do
                     end do
                     do ic=1,3
                        do jc=1,ic
                           hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i)) &
                              +gij*si(ic)*si(jc)
                           hess(ind(ic,m,jc,m))=hess(ind(ic,m,jc,m)) &
                              +gij*sm(ic)*sm(jc)
                           hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j)) &
                              +gij*sj(ic)*sj(jc)
                        end do
                     end do
                  end do

               end if
            end if

         end do bend_jAt
      end do bend_iAt
   end do bend_mAt

end subroutine mh_swart_bend

pure subroutine mh_swart_torsion(n,at,xyz,hess,kt,kd,rcov,rvdw,lcutoff)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: kt
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: rcov(:)
   real(wp),intent(in)    :: rvdw(:)
   logical, intent(in)    :: lcutoff(n,n)

   integer  :: i,j,k,l,ic,jc,ij,kl
!  allow only angles in the range of 35-145
   real(wp),parameter :: a35 = (35.0d0/180.d0)* pi
   real(wp),parameter :: cosfi_max=cos(a35)
   real(wp) :: txyz(3,4),c(3,4)
   real(wp) :: rij(3),rij0,aij,rij2,d0ij,gij
   real(wp) :: rjk(3),rjk0,ajk,rjk2,d0jk,gjk
   real(wp) :: rkl(3),rkl0,akl,rkl2,d0kl,gkl
   real(wp) :: cosfi2,cosfi3,cosfi4
   real(wp) :: beta,tij,tau
   real(wp) :: si(3),sj(3),sk(3),sl(3)

!! ------------------------------------------------------------------------
!  Hessian for torsion
!! ------------------------------------------------------------------------
   torsion_jAt: do j = 1,n
      txyz(:,2)=xyz(:,j)
      torsion_kAt: do k = 1, n
         if (k.eq.j) cycle torsion_kAt
         if(lcutoff(k,j)) cycle torsion_kAt
         txyz(:,3) = xyz(:,k)
         torsion_iAt: do i = 1, n
            ij=n*(j-1)+i
            if (i.eq.j) cycle torsion_iAt
            if (i.eq.k) cycle torsion_iAt
            if(lcutoff(i,k)) cycle torsion_iAt
            if(lcutoff(i,j)) cycle torsion_iAt

            txyz(:,1)=xyz(:,i)
            torsion_lAt: do l = 1, n
               if (ij.le.kl) cycle torsion_lAt
               if (l.eq.i)   cycle torsion_lAt
               if (l.eq.j)   cycle torsion_lAt
               if (l.eq.k)   cycle torsion_lAt
!
               if(lcutoff(l,i)) cycle torsion_lAt
               if(lcutoff(l,k)) cycle torsion_lAt
               if(lcutoff(l,j)) cycle torsion_lAt

               txyz(:,4)=xyz(:,l)

               rij=xyz(:,i)-xyz(:,j)
               d0ij=rvdw(at(i))+rvdw(at(j))
               rij0=rcov(at(i))+rcov(at(j))

               rjk=xyz(:,j)-xyz(:,k)
               d0jk=rvdw(at(j))+rvdw(at(k))
               rjk0=rcov(at(j))+rcov(at(k))

               rkl=xyz(:,k)-xyz(:,l)
               d0kl=rvdw(at(k))+rvdw(at(l))
               rkl0=rcov(at(k))+rcov(at(l))

               rij2=sum(rij**2)
               rjk2=sum(rjk**2)
               rkl2=sum(rjk**2)

               cosfi2=dot_product(rij,rjk)/sqrt(rij2*rjk2)
               if (abs(cosfi2).gt.cosfi_max) cycle
               cosfi3=dot_product(rkl,rjk)/sqrt(rkl2*rjk2)
               if (abs(cosfi3).gt.cosfi_max) cycle

               gij = fk_swart(1.0_wp,rij0,rij2) &
                  + 0.5_wp*kd * fk_vdw(5.0_wp,d0ij,rij2)
               gjk = fk_swart(1.0_wp,rjk0,rjk2) &
                  + 0.5_wp*kd * fk_vdw(5.0_wp,d0jk,rjk2)
               gkl = fk_swart(1.0_wp,rkl0,rkl2) &
                  + 0.5_wp*kd * fk_vdw(5.0_wp,d0kl,rkl2)

               tij = kt * gij*gjk*gkl

               !tij = max(tij,10*min_fk)

               call trsn2(txyz,tau,c)
               si = c(:,1)
               sj = c(:,2)
               sk = c(:,3)
               sl = c(:,4)

               ! off diagonal block
               do ic=1,3
                  do jc=1,3
                     hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j))+tij*si(ic) * sj(jc)
                     hess(ind(ic,i,jc,k))=hess(ind(ic,i,jc,k))+tij*si(ic) * sk(jc)
                     hess(ind(ic,i,jc,l))=hess(ind(ic,i,jc,l))+tij*si(ic) * sl(jc)
                     hess(ind(ic,j,jc,k))=hess(ind(ic,j,jc,k))+tij*sj(ic) * sk(jc)
                     hess(ind(ic,j,jc,l))=hess(ind(ic,j,jc,l))+tij*sj(ic) * sl(jc)
                     hess(ind(ic,k,jc,l))=hess(ind(ic,k,jc,l))+tij*sk(ic) * sl(jc)
                  end do
               end do

               ! diagonal block
               do ic=1,3
                  do jc=1,ic
                     hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i))+tij*si(ic) * si(jc)
                     hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j))+tij*sj(ic) * sj(jc)
                     hess(ind(ic,k,jc,k))=hess(ind(ic,k,jc,k))+tij*sk(ic) * sk(jc)
                     hess(ind(ic,l,jc,l))=hess(ind(ic,l,jc,l))+tij*sl(ic) * sl(jc)
                  end do
               end do

            end do torsion_lAt
         end do torsion_iAt
      end do torsion_kAt
   end do torsion_jAt

end subroutine mh_swart_torsion

pure subroutine mh_swart_outofp(n,at,xyz,hess,ko,kd,rcov,rvdw,lcutoff)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: ko
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: rcov(:)
   real(wp),intent(in)    :: rvdw(:)
   logical, intent(in)    :: lcutoff(n,n)

   integer  :: i,ir,j,jr,k,kr,l,lr,ic,jc
   real(wp) :: txyz(3,4),c(3,4)
   real(wp) :: rij(3),rij0,d0ij,rij2,gij
   real(wp) :: rik(3),rik0,d0ik,rik2,gik
   real(wp) :: ril(3),ril0,d0il,ril2,gil
   real(wp) :: cosfi2,cosfi3,cosfi4
   real(wp) :: beta,tij,tau
   real(wp) :: si(3),sj(3),sk(3),sl(3)

!! ------------------------------------------------------------------------
!  Hessian for out-of-plane
!! ------------------------------------------------------------------------
   outofplane_iAt: do i = 1, n
      txyz(:,4) = xyz(:,i)
      outofplane_jAt: do j = 1, n
         if (j.eq.i) cycle outofplane_jAt
         if(lcutoff(j,i)) cycle outofplane_jAt
         txyz(:,1) = xyz(:,j)
         outofplane_kAt: do k = 1, n
            if (i.eq.k) cycle outofplane_kAt
            if (j.eq.k) cycle outofplane_kat
            if(lcutoff(k,i)) cycle outofplane_kAt
            if(lcutoff(k,j)) cycle outofplane_kAt
            txyz(:,2) = xyz(:,k)
            outofplane_lAt: do l = 1, n
               txyz(:,3) = xyz(:,l)
               if (l.eq.i)   cycle outofplane_lAt
               if (l.eq.j)   cycle outofplane_lAt
               if (l.eq.k)   cycle outofplane_lAt
               if(lcutoff(l,i)) cycle outofplane_lAt
               if(lcutoff(l,k)) cycle outofplane_lAt
               if(lcutoff(l,j)) cycle outofplane_lAt

               rij=xyz(:,i)-xyz(:,j)
               rij0=rcov(at(i))+rcov(at(j))
               d0ij=rvdw(at(i))+rvdw(at(j))

               rik=xyz(:,i)-xyz(:,k)
               rik0=rcov(at(i))+rcov(at(k))
               d0ik=rvdw(at(i))+rvdw(at(k))

               ril=xyz(:,i)-xyz(:,l)
               ril0=rcov(at(i))+rcov(at(l))
               d0il=rvdw(at(i))+rvdw(at(l))

               rij2=sum(rij**2)
               rik2=sum(rik**2)
               ril2=sum(ril**2)

               cosfi2=dot_product(rij,rik)/sqrt(rij2*rik2)
               if (abs(abs(cosfi2)-1.0_wp).lt.1.0e-1_wp) cycle
               cosfi3=dot_product(rij,ril)/sqrt(rij2*ril2)
               if (abs(abs(cosfi3)-1.0_wp).lt.1.0e-1_wp) cycle
               cosfi4=dot_product(rik,ril)/sqrt(rik2*ril2)
               if (abs(abs(cosfi4)-1.0_wp).lt.1.0e-1_wp) cycle

               gij = fk_swart(1.0_wp,rij0,rij2) &
                  + 0.5_wp*kd * fk_vdw(5.0_wp,d0ij,rij2)
               gik = fk_swart(1.0_wp,rik0,rik2) &
                  + 0.5_wp*kd * fk_vdw(5.0_wp,d0ik,rik2)
               gil = fk_swart(1.0_wp,ril0,ril2) &
                  + 0.5_wp*kd * fk_vdw(5.0_wp,d0il,ril2)

               tij = ko * gij*gik*gil

               !tij = max(tij,10*min_fk)

               call outofp2(xyz,tau,c)
               If (abs(tau).gt.45.0d0*(pi/180.d0)) cycle

               si = c(:,4)
               sj = c(:,1)
               sk = c(:,2)
               sl = c(:,3)

               ! off diagonal block
               do ic=1,3
                  do jc=1,3
                     hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j))+tij*si(ic) * sj(jc)
                     hess(ind(ic,i,jc,k))=hess(ind(ic,i,jc,k))+tij*si(ic) * sk(jc)
                     hess(ind(ic,i,jc,l))=hess(ind(ic,i,jc,l))+tij*si(ic) * sl(jc)
                     hess(ind(ic,j,jc,k))=hess(ind(ic,j,jc,k))+tij*sj(ic) * sk(jc)
                     hess(ind(ic,j,jc,l))=hess(ind(ic,j,jc,l))+tij*sj(ic) * sl(jc)
                     hess(ind(ic,k,jc,l))=hess(ind(ic,k,jc,l))+tij*sk(ic) * sl(jc)
                  end do
               end do

               ! diagonal block
               do ic=1,3
                  do jc=1,ic
                     hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i))+tij*si(ic) * si(jc)
                     hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j))+tij*sj(ic) * sj(jc)
                     hess(ind(ic,k,jc,k))=hess(ind(ic,k,jc,k))+tij*sk(ic) * sk(jc)
                     hess(ind(ic,l,jc,l))=hess(ind(ic,l,jc,l))+tij*sl(ic) * sl(jc)
                  end do
               end do

            enddo outofplane_lAt
         enddo outofplane_kAt
      enddo outofplane_jAt
   enddo outofplane_iAt

end subroutine mh_swart_outofp

!! ========================================================================
!  Lindh's Model Hessian augmented with D2
!! ------------------------------------------------------------------------
!  Implemented after:
!  Lindh, R., Bernhardsson, A., Karlström, G., & Malmqvist, P.-Å. (1995).
!  On the use of a Hessian model function in molecular geometry optimizations.
!  Chem. Phys. Lett., 241(4), 423–428. doi:10.1016/0009-2614(95)00646-l
!
!  gij = exp[αij(R²ref - R²ij)]
!  kij   = rkr·gij
!  kijk  = rkf·gij·gjk
!  kijkl = rkt·gij·gjk·gkl
!
!  Originally Lindh proposed (we tweaked those a little bit):
!  rkr = 0.45, rkf = 0.15, rkt = 0.005
!
!  the reference distances are divided by rows in the PSE:
!  rAv:        1        2        3       aAv:        1        2        3
!    1    1.3500   2.1000   2.5300         1    1.0000   0.3949   0.3949
!    2    2.1000   2.8700   3.4000         2    0.3949   0.2800   0.2800
!    3    2.5300   3.4000   3.4000         3    0.3949   0.2800   0.2800
!
!  This Hessian is additionally augmented with D2, please note that D2
!  is not implemented in atomic units and requires some magical conversion
!  factor somewhere hidden in the implementation below.
!! ------------------------------------------------------------------------
subroutine mh_lindh_d2(xyz,n,hess,at,modh)
   use xtb_mctc_constants
   use xtb_mctc_convert

   use xtb_type_setvar
   use xtb_type_param

   implicit none

   integer, intent(in)  :: n
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(out) :: hess((3*n)*(3*n+1)/2)
   integer, intent(in)  :: at(n)
   type(modhess_setvar),intent(in) :: modh

   real(wp),parameter :: rAv(3,3) = reshape( &
     (/1.3500_wp,2.1000_wp,2.5300_wp, &
       2.1000_wp,2.8700_wp,3.4000_wp, &
       2.5300_wp,3.4000_wp,3.4000_wp/), shape(rAv) )
   real(wp),parameter :: aAv(3,3) = reshape ( &
     (/1.0000_wp,0.3949_wp,0.3949_wp, &
       0.3949_wp,0.2800_wp,0.2800_wp, &
       0.3949_wp,0.2800_wp,0.2800_wp/), shape(aAv) )
   real(wp),parameter :: dAv(3,3) = reshape ( &
     (/0.0000_wp,0.0000_wp,0.0000_wp, &
       0.0000_wp,0.0000_wp,0.0000_wp, &
       0.0000_wp,0.0000_wp,0.0000_wp/), shape(aAv) )

   integer  :: n3
   real(wp) :: kd
   logical, allocatable :: lcutoff(:,:)
   type(chrg_parameter) :: chrgeq

   allocate( lcutoff(n,n), source=.false.)

   n3=3*n
   hess = 0.0d0

!  the dispersion force constant is used relative to the stretch force constant
   kd = modh%kd/modh%kr

   call mh_lindh_stretch(n,at,xyz,hess,modh%kr,kd,modh%s6,aav,rav,dav,lcutoff,modh%rcut)
   if (modh%kf.ne.0.0_wp) &
   call mh_lindh_bend   (n,at,xyz,hess,modh%kf,kd,        aav,rav,dav,lcutoff)
   if (modh%kt.ne.0.0_wp) &
   call mh_lindh_torsion(n,at,xyz,hess,modh%kt,kd,        aav,rav,dav,lcutoff)
   if (modh%ko.ne.0.0_wp) &
   call mh_lindh_outofp (n,at,xyz,hess,modh%ko,kd,        aav,rav,dav,lcutoff)
   if (modh%kq.ne.0.0_wp) then
      call new_charge_model_2019(chrgeq,n,at)
      call mh_eeq(n,at,xyz,0.0_wp,chrgeq,modh%kq,hess)
   endif

end subroutine mh_lindh_d2

!! ========================================================================
!  Lindh's Model Hessian updated around 2007
!! ------------------------------------------------------------------------
!  R. Lindh, personal communication.
!
!  gij = exp[αij(R²ref - R²ij)]
!  dij = exp[-4·(Rvdw - Rij)²]
!  kij   = rkr·gij + rkd·dij
!  kijk  = rkf·(gij+½·rkd/rkr·dij)·(gjk+½·rkd/rkr·djk)
!  kijkl = rkt·(gij+½·rkd/rkr·dij)·(gjk+½·rkd/rkr·djk)·(gkl+½·rkd/rkr·dkl)
!
!  parameters tweaked by R. Lindh in 2007:
!  rkr = 0.45, rkf = 0.10, rkt = 0.0025, rko = 0.16, rkd = 0.05
!
!  the reference distances are divided by rows in the PSE:
!  rAv:        1        2        3       aAv:        1        2        3
!    1    1.3500   2.1000   2.5300         1    1.0000   0.3949   0.3949
!    2    2.1000   2.8700   3.8000         2    0.3949   0.2800   0.1200
!    3    2.5300   3.8000   4.5000         3    0.3949   0.1200   0.0600
!
!  dAv:        1        2        3
!    1    0.0000   3.6000   3.6000
!    2    3.6000   5.3000   5.3000
!    3    3.6000   5.3000   5.3000
!
!! ------------------------------------------------------------------------
subroutine mh_lindh(xyz,n,hess,at,modh)
   use xtb_mctc_constants
   use xtb_mctc_convert

   use xtb_type_setvar
   use xtb_type_param

   implicit none

   integer, intent(in)  :: n
   real(wp),intent(in)  :: xyz(3,n)
   real(wp),intent(out) :: hess((3*n)*(3*n+1)/2)
   integer, intent(in)  :: at(n)
   type(modhess_setvar),intent(in) :: modh

   real(wp),parameter :: rAv(3,3) = reshape( &
     (/1.3500_wp,2.1000_wp,2.5300_wp, &
       2.1000_wp,2.8700_wp,3.8000_wp, &
       2.5300_wp,3.8000_wp,4.5000_wp/), shape(rAv) )
   real(wp),parameter :: aAv(3,3) = reshape ( &
     (/1.0000_wp,0.3949_wp,0.3949_wp, &
       0.3949_wp,0.2800_wp,0.1200_wp, &
       0.3949_wp,0.1200_wp,0.0600_wp/), shape(aAv) )
   real(wp),parameter :: dAv(3,3) = reshape ( &
     (/0.0000_wp,3.6000_wp,3.6000_wp, &
       3.6000_wp,5.3000_wp,5.3000_wp, &
       3.6000_wp,5.3000_wp,5.3000_wp/), shape(aAv) )

   integer  :: n3
   real(wp) :: kd
   logical, allocatable :: lcutoff(:,:)
   type(chrg_parameter) :: chrgeq

   allocate( lcutoff(n,n), source=.false.)

   n3=3*n
   hess = 0.0d0

!  the dispersion force constant is used relative to the stretch force constant
   kd = modh%kd/modh%kr

   call mh_lindh_stretch(n,at,xyz,hess,modh%kr,kd,modh%s6,aav,rav,dav,lcutoff,modh%rcut)
   if (modh%kf.ne.0.0_wp) &
   call mh_lindh_bend   (n,at,xyz,hess,modh%kf,kd,        aav,rav,dav,lcutoff)
   if (modh%kt.ne.0.0_wp) &
   call mh_lindh_torsion(n,at,xyz,hess,modh%kt,kd,        aav,rav,dav,lcutoff)
   if (modh%ko.ne.0.0_wp) &
   call mh_lindh_outofp (n,at,xyz,hess,modh%ko,0.0_wp,    aav,rav,dav,lcutoff)
   if (modh%kq.ne.0.0_wp) then
      call new_charge_model_2019(chrgeq,n,at)
      call mh_eeq(n,at,xyz,0.0_wp,chrgeq,modh%kq,hess)
   endif

end subroutine mh_lindh

pure subroutine mh_lindh_stretch(n,at,xyz,hess,kr,kd,s6,aav,rav,dav,lcutoff,rcut)
   use xtb_mctc_constants
   use xtb_mctc_convert

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: kr
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: s6
   real(wp),intent(in)    :: aav(3,3)
   real(wp),intent(in)    :: rav(3,3)
   real(wp),intent(in)    :: dav(3,3)
   logical, intent(out)   :: lcutoff(n,n)
   real(wp),intent(in)    :: rcut

   integer  :: i,ir,j,jr
   real(wp) :: xij,yij,zij,rij2,r0,d0
   real(wp) :: alpha,gmm
   real(wp) :: c6i,c6j,c6ij,rv
   real(wp) :: hxx,hxy,hxz,hyy,hyz,hzz
   real(wp) :: vdw(3,3)

!! ------------------------------------------------------------------------
!  Hessian for stretch
!! ------------------------------------------------------------------------
   stretch_iAt: do i = 1, n
      ir = itabrow(at(i))

      stretch_jAt: do j = 1, i-1
         jr=itabrow(at(j))

         ! save for later
         lcutoff(i,j) = rcutoff(xyz,i,j,rcut)
         lcutoff(j,i) = lcutoff(i,j)

         xij=xyz(1,i)-xyz(1,j)
         yij=xyz(2,i)-xyz(2,j)
         zij=xyz(3,i)-xyz(3,j)
         rij2 = xij**2 + yij**2 + zij**2
         r0 = rav(ir,jr)
         d0 = dav(ir,jr)
         alpha=aav(ir,jr)

         !cccccc vdwx ccccccccccccccccccccccccccccccccc
         c6i=c6(at(i))
         c6j=c6(at(j))
         c6ij=sqrt(c6i*c6j)
         rv=(vander(at(i))+vander(at(j)))*aatoau

         call getvdwxx(xij, yij, zij, c6ij, s6, rv, vdw(1,1))
         call getvdwxy(xij, yij, zij, c6ij, s6, rv, vdw(1,2))
         call getvdwxy(xij, zij, yij, c6ij, s6, rv, vdw(1,3))
         call getvdwxx(yij, xij, zij, c6ij, s6, rv, vdw(2,2))
         call getvdwxy(yij, zij, xij, c6ij, s6, rv, vdw(2,3))
         call getvdwxx(zij, xij, yij, c6ij, s6, rv, vdw(3,3))
         !cccccc ende vdwx ccccccccccccccccccccccccccccccc

         gmm = kr*fk_lindh(alpha,r0,rij2) &
            + kr*kd * fk_vdw(4.0_wp,d0,rij2)

         !gmm = max(gmm,min_fk)

         hxx=gmm*xij*xij/rij2-vdw(1,1)
         hxy=gmm*xij*yij/rij2-vdw(1,2)
         hxz=gmm*xij*zij/rij2-vdw(1,3)
         hyy=gmm*yij*yij/rij2-vdw(2,2)
         hyz=gmm*yij*zij/rij2-vdw(2,3)
         hzz=gmm*zij*zij/rij2-vdw(3,3)

         ! save diagonal elements for atom i
         hess(ind(1,i,1,i))=hess(ind(1,i,1,i))+hxx
         hess(ind(2,i,1,i))=hess(ind(2,i,1,i))+hxy
         hess(ind(2,i,2,i))=hess(ind(2,i,2,i))+hyy
         hess(ind(3,i,1,i))=hess(ind(3,i,1,i))+hxz
         hess(ind(3,i,2,i))=hess(ind(3,i,2,i))+hyz
         hess(ind(3,i,3,i))=hess(ind(3,i,3,i))+hzz
         ! save elements between atom i and atom j
         hess(ind(1,i,1,j))=hess(ind(1,i,1,j))-hxx
         hess(ind(1,i,2,j))=hess(ind(1,i,2,j))-hxy
         hess(ind(1,i,3,j))=hess(ind(1,i,3,j))-hxz
         hess(ind(2,i,1,j))=hess(ind(2,i,1,j))-hxy
         hess(ind(2,i,2,j))=hess(ind(2,i,2,j))-hyy
         hess(ind(2,i,3,j))=hess(ind(2,i,3,j))-hyz
         hess(ind(3,i,1,j))=hess(ind(3,i,1,j))-hxz
         hess(ind(3,i,2,j))=hess(ind(3,i,2,j))-hyz
         hess(ind(3,i,3,j))=hess(ind(3,i,3,j))-hzz
         ! save diagonal elements for atom j
         hess(ind(1,j,1,j))=hess(ind(1,j,1,j))+hxx
         hess(ind(2,j,1,j))=hess(ind(2,j,1,j))+hxy
         hess(ind(2,j,2,j))=hess(ind(2,j,2,j))+hyy
         hess(ind(3,j,1,j))=hess(ind(3,j,1,j))+hxz
         hess(ind(3,j,2,j))=hess(ind(3,j,2,j))+hyz
         hess(ind(3,j,3,j))=hess(ind(3,j,3,j))+hzz

      end do stretch_jAt
   end do stretch_iAt

end subroutine mh_lindh_stretch

pure subroutine mh_lindh_bend(n,at,xyz,hess,kf,kd,aav,rav,dav,lcutoff)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: kf
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: aav(3,3)
   real(wp),intent(in)    :: rav(3,3)
   real(wp),intent(in)    :: dav(3,3)
   logical, intent(in)    :: lcutoff(n,n)

   integer  :: i,ir,j,jr,m,mr,ic,jc,ii
   real(wp),parameter :: rzero = 1.0e-10_wp
   real(wp) :: xij,yij,zij,rij2,rrij,r1
   real(wp) :: xmi,ymi,zmi,rmi2,rmi,r0mi,ami,d0mj,gmi
   real(wp) :: xmj,ymj,zmj,rmj2,rmj,r0mj,amj,d0mi,gmj
   real(wp) :: test,gij,rl2,rl,rmidotrmj
   real(wp) :: sinphi,cosphi,costhetax,costhetay,costhetaz
   real(wp) :: alpha
   real(wp) :: si(3),sj(3),sm(3),x(2),y(2),z(2)

!! ------------------------------------------------------------------------
!  Hessian for bending
!! ------------------------------------------------------------------------
   bend_mAt: do m = 1, n
      mr=itabrow(at(m))
      bend_iAt: do i = 1, n
         if (i.eq.m) cycle bend_iAt
         ir=itabrow(at(i))
         if(lcutoff(i,m)) cycle bend_iAt

         xmi=(xyz(1,i)-xyz(1,m))
         ymi=(xyz(2,i)-xyz(2,m))
         zmi=(xyz(3,i)-xyz(3,m))
         rmi2 = xmi**2 + ymi**2 + zmi**2
         rmi=sqrt(rmi2)
         r0mi=rav(mr,ir)
         d0mi=dav(mr,ir)
         ami=aav(mr,ir)

         bend_jAt: do j = 1, i-1
            if (j.eq.m) cycle bend_jAt
            jr=itabrow(at(j))
            if(lcutoff(j,i)) cycle bend_jAt
            if(lcutoff(j,m)) cycle bend_jAt

            xmj=(xyz(1,j)-xyz(1,m))
            ymj=(xyz(2,j)-xyz(2,m))
            zmj=(xyz(3,j)-xyz(3,m))
            rmj2 = xmj**2 + ymj**2 + zmj**2
            rmj=sqrt(rmj2)
            r0mj=rav(mr,jr)
            d0mj=dav(mr,jr)
            amj=aav(mr,jr)

            ! test if zero angle
            test=xmi*xmj+ymi*ymj+zmi*zmj
            test=test/(rmi*rmj)
            if (abs(test-1.0_wp).lt.1.0e-12_wp) cycle bend_jAt

            xij=(xyz(1,j)-xyz(1,i))
            yij=(xyz(2,j)-xyz(2,i))
            zij=(xyz(3,j)-xyz(3,i))
            rij2 = xij**2 + yij**2 + zij**2
            rrij=sqrt(rij2)

            gmi = fk_lindh(ami,r0mi,rmi2) &
                + 0.5_wp*kd * fk_vdw(4.0_wp,d0mi,rmi2)
            gmj = fk_lindh(amj,r0mj,rmj2) &
                + 0.5_wp*kd * fk_vdw(4.0_wp,d0mj,rmj2)

            gij = kf*gmi*gmj

            rl2=(ymi*zmj-zmi*ymj)**2+(zmi*xmj-xmi*zmj)**2+(xmi*ymj-ymi*xmj)**2

            if(rl2.lt.1.e-14_wp) then
               rl=0.0_wp
            else
               rl=sqrt(rl2)
            end if

            !gij = max(gij,min_fk)

            if ((rmj.gt.rzero).and.(rmi.gt.rzero).and.(rrij.gt.rzero)) then
               sinphi=rl/(rmj*rmi)
               rmidotrmj=xmi*xmj+ymi*ymj+zmi*zmj
               cosphi=rmidotrmj/(rmj*rmi)
               ! none linear case
               if (sinphi.gt.rzero) then
                  si(1)=(xmi/rmi*cosphi-xmj/rmj)/(rmi*sinphi)
                  si(2)=(ymi/rmi*cosphi-ymj/rmj)/(rmi*sinphi)
                  si(3)=(zmi/rmi*cosphi-zmj/rmj)/(rmi*sinphi)
                  sj(1)=(cosphi*xmj/rmj-xmi/rmi)/(rmj*sinphi)
                  sj(2)=(cosphi*ymj/rmj-ymi/rmi)/(rmj*sinphi)
                  sj(3)=(cosphi*zmj/rmj-zmi/rmi)/(rmj*sinphi)
                  sm(1)=-si(1)-sj(1)
                  sm(2)=-si(2)-sj(2)
                  sm(3)=-si(3)-sj(3)
                  do ic=1,3
                     do jc=1,3
                        if (m.gt.i) then
                           hess(ind(ic,m,jc,i))=hess(ind(ic,m,jc,i)) &
                              +gij*sm(ic)*si(jc)
                        else
                           hess(ind(ic,i,jc,m))=hess(ind(ic,i,jc,m)) &
                              +gij*si(ic)*sm(jc)
                        end if
                        if (m.gt.j) then
                           hess(ind(ic,m,jc,j))=hess(ind(ic,m,jc,j)) &
                              +gij*sm(ic)*sj(jc)
                        else
                           hess(ind(ic,j,jc,m))=hess(ind(ic,j,jc,m)) &
                              +gij*sj(ic)*sm(jc)
                        end if
                        if (i.gt.j) then
                           hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j)) &
                              +gij*si(ic)*sj(jc)
                        else
                           hess(ind(ic,j,jc,i))=hess(ind(ic,j,jc,i)) &
                              +gij*sj(ic)*si(jc)
                        end if
                     end do
                  end do
                  do ic=1,3
                     do jc=1,ic
                        hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i))+gij*si(ic)*si(jc)
                        hess(ind(ic,m,jc,m))=hess(ind(ic,m,jc,m))+gij*sm(ic)*sm(jc)
                        hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j))+gij*sj(ic)*sj(jc)
                     end do
                  end do
               else
                  ! linear case
                  if ((abs(ymi).gt.rzero).or.(abs(xmi).gt.rzero)) then
                     x(1)=-ymi
                     y(1)=xmi
                     z(1)=0.0_wp
                     x(2)=-xmi*zmi
                     y(2)=-ymi*zmi
                     z(2)=xmi*xmi+ymi*ymi
                  else
                     x(1)=1.0_wp
                     y(1)=0.0_wp
                     z(1)=0.0_wp
                     x(2)=0.0_wp
                     y(2)=1.0_wp
                     z(2)=0.0_wp
                  end if
                  do ii=1,2
                     r1=sqrt(x(ii)**2+y(ii)**2+z(ii)**2)
                     costhetax=x(ii)/r1
                     costhetay=y(ii)/r1
                     costhetaz=z(ii)/r1
                     si(1)=-costhetax/rmi
                     si(2)=-costhetay/rmi
                     si(3)=-costhetaz/rmi
                     sj(1)=-costhetax/rmj
                     sj(2)=-costhetay/rmj
                     sj(3)=-costhetaz/rmj
                     sm(1)=-(si(1)+sj(1))
                     sm(2)=-(si(2)+sj(2))
                     sm(3)=-(si(3)+sj(3))
                     !
                     do ic=1,3
                        do jc=1,3
                           if (m.gt.i) then
                              hess(ind(ic,m,jc,i))=hess(ind(ic,m,jc,i)) &
                                 +gij*sm(ic)*si(jc)
                           else
                              hess(ind(ic,i,jc,m))=hess(ind(ic,i,jc,m)) &
                                 +gij*si(ic)*sm(jc)
                           end if
                           if (m.gt.j) then
                              hess(ind(ic,m,jc,j))=hess(ind(ic,m,jc,j)) &
                                 +gij*sm(ic)*sj(jc)
                           else
                              hess(ind(ic,j,jc,m))=hess(ind(ic,j,jc,m)) &
                                 +gij*sj(ic)*sm(jc)
                           end if
                           if (i.gt.j) then
                              hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j)) &
                                 +gij*si(ic)*sj(jc)
                           else
                              hess(ind(ic,j,jc,i))=hess(ind(ic,j,jc,i)) &
                                 +gij*sj(ic)*si(jc)
                           end if
                        end do
                     end do
                     do ic=1,3
                        do jc=1,ic
                           hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i)) &
                              +gij*si(ic)*si(jc)
                           hess(ind(ic,m,jc,m))=hess(ind(ic,m,jc,m)) &
                              +gij*sm(ic)*sm(jc)
                           hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j)) &
                              +gij*sj(ic)*sj(jc)
                        end do
                     end do
                  end do

               end if
            end if

         end do bend_jAt
      end do bend_iAt
   end do bend_mAt

end subroutine mh_lindh_bend

subroutine mh_lindh_torsion(n,at,xyz,hess,kt,kd,aav,rav,dav,lcutoff)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: kt
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: aav(3,3)
   real(wp),intent(in)    :: rav(3,3)
   real(wp),intent(in)    :: dav(3,3)
   logical, intent(in)    :: lcutoff(n,n)

   integer  :: i,ir,j,jr,k,kr,l,lr,ic,jc,ij,kl
!  allow only angles in the range of 35-145
   real(wp),parameter :: a35 = (35.0d0/180.d0)* pi
   real(wp),parameter :: cosfi_max=cos(a35)
   real(wp) :: txyz(3,4),c(3,4)
   real(wp) :: rij(3),rij0,aij,rij2,d0ij,gij
   real(wp) :: rjk(3),rjk0,ajk,rjk2,d0jk,gjk
   real(wp) :: rkl(3),rkl0,akl,rkl2,d0kl,gkl
   real(wp) :: cosfi2,cosfi3,cosfi4
   real(wp) :: beta,tij,tau,dum(3,4,3,4)
   real(wp) :: si(3),sj(3),sk(3),sl(3)

!! ------------------------------------------------------------------------
!  Hessian for torsion
!! ------------------------------------------------------------------------
   torsion_jAt: do j = 1,n
      jr=itabrow(at(j))
      txyz(:,2)=xyz(:,j)
      torsion_kAt: do k = 1, n
         if (k.eq.j) cycle torsion_kAt
         kr=itabrow(at(k))
         if(lcutoff(k,j)) cycle torsion_kAt
         txyz(:,3) = xyz(:,k)
         torsion_iAt: do i = 1, n
            ij=n*(j-1)+i
            if (i.eq.j) cycle torsion_iAt
            if (i.eq.k) cycle torsion_iAt
            ir=itabrow(at(i))
            if(lcutoff(i,k)) cycle torsion_iAt
            if(lcutoff(i,j)) cycle torsion_iAt

            txyz(:,1)=xyz(:,i)
            torsion_lAt: do l = 1, n
               kl=n*(k-1)+l
               if (ij.le.kl) cycle torsion_lAt
               if (l.eq.i)   cycle torsion_lAt
               if (l.eq.j)   cycle torsion_lAt
               if (l.eq.k)   cycle torsion_lAt
               lr=itabrow(at(l))
!
               if(lcutoff(l,i)) cycle torsion_lAt
               if(lcutoff(l,k)) cycle torsion_lAt
               if(lcutoff(l,j)) cycle torsion_lAt

               txyz(:,4)=xyz(:,l)

               rij=xyz(:,i)-xyz(:,j)
               d0ij=dav(ir,jr)
               rij0=rav(ir,jr)
               aij =aav(ir,jr)

               rjk=xyz(:,j)-xyz(:,k)
               d0jk=dav(jr,kr)
               rjk0=rav(jr,kr)
               ajk =aav(jr,kr)

               rkl=xyz(:,k)-xyz(:,l)
               d0kl=dav(kr,lr)
               rkl0=rav(kr,lr)
               akl =aav(kr,lr)

               rij2=sum(rij**2)
               rjk2=sum(rjk**2)
               rkl2=sum(rjk**2)

               cosfi2=dot_product(rij,rjk)/sqrt(rij2*rjk2)
               if (abs(cosfi2).gt.cosfi_max) cycle
               cosfi3=dot_product(rkl,rjk)/sqrt(rkl2*rjk2)
               if (abs(cosfi3).gt.cosfi_max) cycle

               gij = fk_lindh(aij,rij0,rij2) &
                  + 0.5_wp*kd * fk_vdw(4.0_wp,d0ij,rij2)
               gjk = fk_lindh(ajk,rjk0,rjk2) &
                  + 0.5_wp*kd * fk_vdw(4.0_wp,d0jk,rjk2)
               gkl = fk_lindh(akl,rkl0,rkl2) &
                  + 0.5_wp*kd * fk_vdw(4.0_wp,d0kl,rkl2)

               tij = kt * gij*gjk*gkl

               !tij = max(tij,10*min_fk)

               !call trsn2(txyz,tau,c)
               Call Trsn(txyz,4,Tau,C,.False.,.False.,'        ', &
      &                  Dum,.False.)
               si = c(:,1)
               sj = c(:,2)
               sk = c(:,3)
               sl = c(:,4)

               ! off diagonal block
               do ic=1,3
                  do jc=1,3
                     hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j))+tij*si(ic) * sj(jc)
                     hess(ind(ic,i,jc,k))=hess(ind(ic,i,jc,k))+tij*si(ic) * sk(jc)
                     hess(ind(ic,i,jc,l))=hess(ind(ic,i,jc,l))+tij*si(ic) * sl(jc)
                     hess(ind(ic,j,jc,k))=hess(ind(ic,j,jc,k))+tij*sj(ic) * sk(jc)
                     hess(ind(ic,j,jc,l))=hess(ind(ic,j,jc,l))+tij*sj(ic) * sl(jc)
                     hess(ind(ic,k,jc,l))=hess(ind(ic,k,jc,l))+tij*sk(ic) * sl(jc)
                  end do
               end do

               ! diagonal block
               do ic=1,3
                  do jc=1,ic
                     hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i))+tij*si(ic) * si(jc)
                     hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j))+tij*sj(ic) * sj(jc)
                     hess(ind(ic,k,jc,k))=hess(ind(ic,k,jc,k))+tij*sk(ic) * sk(jc)
                     hess(ind(ic,l,jc,l))=hess(ind(ic,l,jc,l))+tij*sl(ic) * sl(jc)
                  end do
               end do

            end do torsion_lAt
         end do torsion_iAt
      end do torsion_kAt
   end do torsion_jAt

end subroutine mh_lindh_torsion

pure subroutine mh_lindh_outofp(n,at,xyz,hess,ko,kd,aav,rav,dav,lcutoff)
   use xtb_mctc_constants

   implicit none

   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: hess((3*n)*(3*n+1)/2)
   real(wp),intent(in)    :: ko
   real(wp),intent(in)    :: kd
   real(wp),intent(in)    :: aav(3,3)
   real(wp),intent(in)    :: rav(3,3)
   real(wp),intent(in)    :: dav(3,3)
   logical, intent(in)    :: lcutoff(n,n)

   integer  :: i,ir,j,jr,k,kr,l,lr,ic,jc
   real(wp) :: txyz(3,4),c(3,4)
   real(wp) :: rij(3),rij0,aij,rij2,gij,d0ij
   real(wp) :: rik(3),rik0,aik,rik2,gik,d0ik
   real(wp) :: ril(3),ril0,ail,ril2,gil,d0il
   real(wp) :: cosfi2,cosfi3,cosfi4
   real(wp) :: beta,tij,tau
   real(wp) :: si(3),sj(3),sk(3),sl(3)

!! ------------------------------------------------------------------------
!  Hessian for out-of-plane
!! ------------------------------------------------------------------------
   outofplane_iAt: do i = 1, n
      ir = itabrow(at(i))
      txyz(:,4) = xyz(:,i)
      outofplane_jAt: do j = 1, n
         if (j.eq.i) cycle outofplane_jAt
         if(lcutoff(j,i)) cycle outofplane_jAt
         jr = itabrow(at(j))
         txyz(:,1) = xyz(:,j)
         outofplane_kAt: do k = 1, n
            if (i.eq.k) cycle outofplane_kAt
            if (j.eq.k) cycle outofplane_kat
            if(lcutoff(k,i)) cycle outofplane_kAt
            if(lcutoff(k,j)) cycle outofplane_kAt
            kr = itabrow(at(k))
            txyz(:,2) = xyz(:,k)
            outofplane_lAt: do l = 1, n
               lr = itabrow(at(l))
               txyz(:,3) = xyz(:,l)
               if (l.eq.i) cycle outofplane_lAt
               if (l.eq.j) cycle outofplane_lAt
               if (l.eq.k) cycle outofplane_lAt
               if(lcutoff(l,i)) cycle outofplane_lAt
               if(lcutoff(l,k)) cycle outofplane_lAt
               if(lcutoff(l,j)) cycle outofplane_lAt

               rij=xyz(:,i)-xyz(:,j)
               d0ij=dav(ir,jr)
               rij0=rav(ir,jr)
               aij =aav(ir,jr)

               rik=xyz(:,i)-xyz(:,k)
               d0ik=dav(ir,kr)
               rik0=rav(ir,kr)
               aik =aav(ir,kr)

               ril=xyz(:,i)-xyz(:,l)
               d0il=dav(ir,lr)
               ril0=rav(ir,lr)
               ail =aav(ir,lr)

               rij2=sum(rij**2)
               rik2=sum(rik**2)
               ril2=sum(ril**2)

               cosfi2=dot_product(rij,rik)/sqrt(rij2*rik2)
               if (abs(abs(cosfi2)-1.0_wp).lt.1.0e-1_wp) cycle
               cosfi3=dot_product(rij,ril)/sqrt(rij2*ril2)
               if (abs(abs(cosfi3)-1.0_wp).lt.1.0e-1_wp) cycle
               cosfi4=dot_product(rik,ril)/sqrt(rik2*ril2)
               if (abs(abs(cosfi4)-1.0_wp).lt.1.0e-1_wp) cycle

               gij = fk_lindh(aij,rij0,rij2) &
                  + 0.5_wp*kd * fk_vdw(4.0_wp,d0ij,rij2)
               gik = fk_lindh(aik,rik0,rik2) &
                  + 0.5_wp*kd * fk_vdw(4.0_wp,d0ik,rik2)
               gil = fk_lindh(ail,ril0,ril2) &
                  + 0.5_wp*kd * fk_vdw(4.0_wp,d0il,ril2)

               tij = ko * gij*gik*gil

               !tij = max(tij,10*min_fk)

               call outofp2(xyz,tau,c)
               If (abs(tau).gt.45.0d0*(pi/180.d0)) cycle

               si = c(:,4)
               sj = c(:,1)
               sk = c(:,2)
               sl = c(:,3)

               ! off diagonal block
               do ic=1,3
                  do jc=1,3
                     hess(ind(ic,i,jc,j))=hess(ind(ic,i,jc,j))+tij*si(ic) * sj(jc)
                     hess(ind(ic,i,jc,k))=hess(ind(ic,i,jc,k))+tij*si(ic) * sk(jc)
                     hess(ind(ic,i,jc,l))=hess(ind(ic,i,jc,l))+tij*si(ic) * sl(jc)
                     hess(ind(ic,j,jc,k))=hess(ind(ic,j,jc,k))+tij*sj(ic) * sk(jc)
                     hess(ind(ic,j,jc,l))=hess(ind(ic,j,jc,l))+tij*sj(ic) * sl(jc)
                     hess(ind(ic,k,jc,l))=hess(ind(ic,k,jc,l))+tij*sk(ic) * sl(jc)
                  end do
               end do

               ! diagonal block
               do ic=1,3
                  do jc=1,ic
                     hess(ind(ic,i,jc,i))=hess(ind(ic,i,jc,i))+tij*si(ic) * si(jc)
                     hess(ind(ic,j,jc,j))=hess(ind(ic,j,jc,j))+tij*sj(ic) * sj(jc)
                     hess(ind(ic,k,jc,k))=hess(ind(ic,k,jc,k))+tij*sk(ic) * sk(jc)
                     hess(ind(ic,l,jc,l))=hess(ind(ic,l,jc,l))+tij*sl(ic) * sl(jc)
                  end do
               end do

            enddo outofplane_lAt
         enddo outofplane_kAt
      enddo outofplane_jAt
   enddo outofplane_iAt

end subroutine mh_lindh_outofp

pure elemental function ixyz(i,iatom)
   integer :: ixyz
   integer,intent(in) :: i,iatom
   ixyz = (iatom-1)*3 + i
end function ixyz
pure elemental function jnd(i,j)
   integer :: jnd
   integer,intent(in) :: i,j
   jnd = i*(i-1)/2 +j
end function jnd
pure elemental function ind(i,iatom,j,jatom)
   integer :: ind
   integer,intent(in) :: i,iatom,j,jatom
   ind=jnd(max(ixyz(i,iatom),ixyz(j,jatom)),min(ixyz(i,iatom),ixyz(j,jatom)))
end function ind

pure function rcutoff(xyz,katom,latom,rcut)
   implicit none
   logical  :: rcutoff
   real(wp),intent(in) :: xyz(3,*)
   real(wp),intent(in) :: rcut
   real(wp) :: rkl(3),rkl2
   integer, intent(in) :: katom,latom
   rcutoff=.false.
   rkl=xyz(:,kAtom)-xyz(:,lAtom)
   rkl2 = sum(rkl**2)
   if(rkl2.gt.rcut) rcutoff=.true.
end function rcutoff

pure elemental function itabrow(i)
   integer :: itabrow
   integer,intent(in) :: i

   itabrow=0
   if (i.gt. 0 .and. i.le. 2) then
      itabrow=1
   else if (i.gt. 2 .and. i.le.10) then
      itabrow=2
   else if (i.gt.10 .and. i.le.18) then
      itabrow=3
   else if (i.gt.18 .and. i.le.36) then
      itabrow=3
   else if (i.gt.36 .and. i.le.54) then
      itabrow=3
   else if (i.gt.54 .and. i.le.86) then
      itabrow=3
   else if (i.gt.86) then
      itabrow=3
   end if

   return
end function itabrow

pure subroutine outofp2(xyz,teta,bt)
   use xtb_mctc_constants
   implicit none
   real(wp),intent(out) :: teta
   real(wp),intent(out) :: bt(3,4)
   real(wp),intent(in)  :: xyz(3,4)
   real(wp) :: r1(3),r2(3),r3(3)
   real(wp) :: q41,q42,q43,e41(3),e42(3),e43(3)
   real(wp) :: cosfi1,fi1,dfi1,cosfi2,fi2,dfi2,cosfi3,fi3,dfi3
   real(wp) :: c14(3,3),br14(3,3)
   real(wp) :: r42(3),r43(3)
   integer  :: ix,iy,iz
!  4 -> 1 (bond)
   r1=xyz(:,1)-xyz(:,4)
   q41=norm2(r1)
   e41 = r1 / q41
!  4 -> 2 (bond in plane)
   r2=xyz(:,2)-xyz(:,4)
   q42=norm2(r2)
   e42 = r2 / q42
!  4 -> 3 (bond in plane)
   r3=xyz(:,3)-xyz(:,4)
   q43=norm2(r3)
   e43 = r3 / q43
!
!  get the angle between e43 and e42
!
   cosfi1 = dot_product(e43,e42)

   fi1=acos(cosfi1)
   dfi1 = 180.d0 * fi1 / pi
!
!  dirty exit! this happens when an earlier structure is ill defined.
!
   if (abs(fi1-pi).lt.1.0d-13) then
      teta=0.0_wp
      bt = 0.0_wp
      return
   end if
!
!  get the angle between e41 and e43
!
   cosfi2 = dot_product(e41,e43)

   fi2=acos(cosfi2)
   dfi2 = 180.d0 * fi2 / pi
!
!  get the angle between e41 and e42
!
   cosfi3 = dot_product(e41,e42)

   fi3=acos(cosfi3)
   dfi3 = 180.d0 * fi3 / pi
!
!  the first two centers are trivially
!
   c14(:,1) = xyz(:,1)
   c14(:,2) = xyz(:,4)
!
!  the 3rd is
!
   r42=xyz(:,2)-xyz(:,4)
   r43=xyz(:,3)-xyz(:,4)
   c14(1,3)=r42(2)*r43(3)-r42(3)*r43(2)
   c14(2,3)=r42(3)*r43(1)-r42(1)*r43(3)
   c14(3,3)=r42(1)*r43(2)-r42(2)*r43(1)
!
!  exit if 2-3-4 are collinear
!  (equivalent to the above check, but this is more concrete)
!
   if ((c14(1,3)**2+c14(2,3)**2+c14(3,3)**2).lt.1.0d-10) then
      teta=0.0d0
      bt = 0.0_wp
      return
   end if
   c14(1,3)=c14(1,3)+xyz(1,4)
   c14(2,3)=c14(2,3)+xyz(2,4)
   c14(3,3)=c14(3,3)+xyz(3,4)

   call bend2(c14,teta,br14)

   teta = teta - 0.5_wp*pi
!
!--compute the wdc matrix
!
   do ix = 1, 3
      iy = mod(ix+1, 4)+(ix+1)/4
      iz = mod(iy+1, 4)+(iy+1)/4

      bt(ix,1) = - br14(ix,1)
      bt(ix,2) =   r43(iz)*br14(iy,3) - r43(iy)*br14(iz,3)
      bt(ix,3) = - r42(iz)*br14(iy,3) + r42(iy)*br14(iz,3)

      bt(ix,4) = - (bt(ix,1)+bt(ix,2)+bt(ix,3))

   end do

   bt = -bt
end subroutine outofp2

pure subroutine trsn2(xyz,tau,bt)
   use xtb_mctc_constants
   implicit none
   real(wp),intent(out) :: bt(3,4)
   real(wp),intent(out) :: tau
   real(wp),intent(in)  :: xyz(3,4)
   real(wp) :: rij(3),rij1,brij(3,2)
   real(wp) :: rjk(3),rjk1,brjk(3,2)
   real(wp) :: rkl(3),rkl1,brkl(3,2)
   real(wp) :: bf2(3,3),fi2,sinfi2,cosfi2
   real(wp) :: bf3(3,3),fi3,sinfi3,cosfi3
   real(wp) :: costau,sintau
   integer  :: ix,iy,iz
   call strtch2(xyz(1,1),rij1,brij)
   call strtch2(xyz(1,2),rjk1,brjk)
   call strtch2(xyz(1,3),rkl1,brkl)
   call bend2(xyz(1,1),fi2,bf2)
   sinfi2=sin(fi2)
   cosfi2=cos(fi2)
   call bend2(xyz(1,2),fi3,bf3)
   sinfi3=sin(fi3)
   cosfi3=cos(fi3)
   costau = ( ( brij(2,1)*brjk(3,2) - brij(3,1)*brjk(2,2) ) * &
               ( brjk(2,1)*brkl(3,2) - brjk(3,1)*brkl(2,2) ) + &
               ( brij(3,1)*brjk(1,2) - brij(1,1)*brjk(3,2) ) * &
               ( brjk(3,1)*brkl(1,2) - brjk(1,1)*brkl(3,2) ) + &
               ( brij(1,1)*brjk(2,2) - brij(2,1)*brjk(1,2) ) * &
               ( brjk(1,1)*brkl(2,2) - brjk(2,1)*brkl(1,2) ) ) &
             / (sinfi2*sinfi3)
   sintau = ( brij(1,2) * (brjk(2,1)*brkl(3,2)-brjk(3,1)*brkl(2,2)) &
             + brij(2,2) * (brjk(3,1)*brkl(1,2)-brjk(1,1)*brkl(3,2)) &
             + brij(3,2) * (brjk(1,1)*brkl(2,2)-brjk(2,1)*brkl(1,2)) ) &
             / (sinfi2*sinfi3)
   tau = atan2(sintau,costau)
   if (abs(tau).eq.pi) tau=pi
   do ix = 1, 3
      iy=ix+1
      if (iy.gt.3) iy=iy-3
      iz=iy+1
      if (iz.gt.3) iz=iz-3
      bt(ix,1) = (brij(iy,2)*brjk(iz,2)-brij(iz,2)*brjk(iy,2)) &
         &           / (rij1*sinfi2**2)
      bt(ix,4) = (brkl(iy,1)*brjk(iz,1)-brkl(iz,1)*brjk(iy,1)) &
         &           / (rkl1*sinfi3**2)
      bt(ix,2) = -( (rjk1-rij1*cosfi2) * bt(ix,1) &
         &             +         rkl1*cosfi3  * bt(ix,4))/rjk1
      bt(ix,3) = - ( bt(ix,1)+bt(ix,2)+bt(ix,4))
   end do
end subroutine trsn2
pure subroutine strtch2(xyz,avst,b)
   implicit none
   real(wp),intent(out) :: b(3,2)
   real(wp),intent(in)  :: xyz(3,2)
   real(wp) :: r(3)
   real(wp) :: rr
   real(wp),intent(out) :: avst
   r=xyz(:,2)-xyz(:,1)
   rr=norm2(r)
   avst=rr
   b(:,1)=-r/rr
   b(:,2)=-b(:,1)
end subroutine strtch2
pure subroutine bend2(xyz,fir,bf)
   use xtb_mctc_constants
   implicit none
   real(wp),intent(out) :: bf(3,3)
   real(wp),intent(in)  :: xyz(3,3)
   real(wp) :: brij(3,2)
   real(wp) :: brjk(3,2)
   real(wp) :: co,crap
   real(wp),intent(out) :: fir
   real(wp) :: si
   real(wp) :: rij1,rjk1
   integer  :: i
   call strtch2(xyz(1,1),rij1,brij)
   call strtch2(xyz(1,2),rjk1,brjk)
   co=0.0_wp
   crap=0.0_wp
   do i = 1, 3
      co=co+brij(i,1)*brjk(i,2)
      crap=crap+(brjk(i,2)+brij(i,1))**2
   end do
   if (sqrt(crap).lt.1.0d-6) then
      fir=pi-asin(sqrt(crap))
      si=sqrt(crap)
   else
      fir=acos(co)
      si=sqrt(1.0_wp-co**2)
   end if
   if (abs(fir-pi).lt.1.0d-13) then
      fir=pi
      return
   end if
   do i = 1, 3
      bf(i,1)= (co*brij(i,1)-brjk(i,2))/(si*rij1)
      bf(i,3)= (co*brjk(i,2)-brij(i,1))/(si*rjk1)
      bf(i,2)=-(bf(i,1)+bf(i,3))
   end do
end subroutine bend2

pure elemental subroutine getvdwxy(rx,ry,rz, c66, s6,r0, vdw)
   !cc Ableitung nach rx und ry
   implicit none
   real(wp),intent(in)  :: rx,ry,rz,c66,s6,r0
   real(wp),intent(out) :: vdw
   real(wp) :: t1,t2,t3,t4,t5,t6,t7,t11,t12,t16,t17,t25,t26,t35
   real(wp) :: t40,t41,t43,t44,t56,avdw
   ! write(*,*) 's6:', s6
   avdw=20.0
   t1 = s6 * C66
   t2 = rx ** 2
   t3 = ry ** 2
   t4 = rz ** 2
   t5 = t2 + t3 + t4
   t6 = t5 ** 2
   t7 = t6 ** 2
   t11 = sqrt(t5)
   t12 = 0.1D1 / r0
   t16 = exp(-avdw * (t11 * t12 - 0.1D1))
   t17 = 0.1D1 + t16
   t25 = t17 ** 2
   t26 = 0.1D1 / t25
   t35 = 0.1D1 / t7
   t40 = avdw ** 2
   t41 = r0 ** 2
   t43 = t40 / t41
   t44 = t16 ** 2
   t56 = -0.48D2 * t1 / t7 / t5 / t17 * rx * ry + 0.13D2 * t1 / t11 / &
      t7 * t26 * rx * avdw * t12 * ry * t16 - 0.2D1 * t1 * t35 / t25 / &
      t17 * t43 * rx * t44 * ry + t1 * t35 * t26 * t43 * rx * ry * t16
   vdw=t56
end subroutine getvdwxy

pure elemental subroutine getvdwxx(rx, ry, rz, c66, s6, r0, vdw)
   !cc Ableitung nach rx und rx
   implicit none
   real(wp),intent(in)  :: rx,ry,rz,c66,s6,r0
   real(wp),intent(out) :: vdw
   real(wp) :: t1,t2,t3,t4,t5,t6,t7,t10,t11,t15,t16,t17,t24,t25,t29
   real(wp) :: t33,t41,t42,t44,t45,t62,avdw
   avdw=20.0
   ! write(*,*) 's6:', s6
   t1 = s6 * C66
   t2 = rx ** 2
   t3 = ry ** 2
   t4 = rz ** 2
   t5 = t2 + t3 + t4
   t6 = t5 ** 2
   t7 = t6 ** 2
   t10 = sqrt(t5)
   t11 = 0.1D1 / r0
   t15 = exp(-avdw * (t10 * t11 - 0.1D1))
   t16 = 0.1D1 + t15
   t17 = 0.1D1 / t16
   t24 = t16 ** 2
   t25 = 0.1D1 / t24
   t29 = t11 * t15
   t33 = 0.1D1 / t7
   t41 = avdw ** 2
   t42 = r0 ** 2
   t44 = t41 / t42
   t45 = t15 ** 2
   t62 = -0.48D2 * t1 / t7 / t5 * t17 * t2 + 0.13D2 * t1 / t10 / t7 * &
      t25 * t2 * avdw * t29 + 0.6D1 * t1 * t33 * t17 - 0.2D1 * t1 * t33 &
      / t24 / t16 * t44 * t2 * t45 - t1 / t10 / t6 / t5 * t25 * avdw * &
      t29 + t1 * t33 * t25 * t44 * t2 * t15
   vdw=t62
end subroutine getvdwxx

pure elemental function fk_lindh(alpha,r0,r2) result(gmm)
   implicit none
   real(wp),intent(in) :: alpha,r0,r2
   real(wp) :: gmm
   gmm = exp(alpha*(r0**2 - r2))
end function fk_lindh

pure elemental function fk_swart(alpha,r0,r2) result(gmm)
   implicit none
   real(wp),intent(in) :: alpha,r0,r2
   real(wp) :: gmm
   gmm = exp(-alpha*(sqrt(r2)/r0 - 1.0_wp))
end function fk_swart

pure elemental function fk_vdw(alpha,r0,r2) result(gmm)
   implicit none
   real(wp),intent(in) :: alpha,r0,r2
   real(wp) :: gmm
   gmm = exp(-alpha*(r0 - sqrt(r2))**2)
end function fk_vdw

subroutine mh_eeq(n,at,xyz,chrg,chrgeq,kq,hess)
   use xtb_type_param
   implicit none

!! ------------------------------------------------------------------------
!  Input
!! ------------------------------------------------------------------------
   integer, intent(in)    :: n                ! number of atoms
   integer, intent(in)    :: at(n)            ! ordinal numbers
   real(wp),intent(in)    :: xyz(3,n)         ! geometry
   real(wp),intent(in)    :: chrg             ! total charge
   real(wp),intent(in)    :: kq               ! scaling parameter
   type(chrg_parameter),intent(in) :: chrgeq  ! charge model
!! ------------------------------------------------------------------------
!  Output
!! ------------------------------------------------------------------------
   real(wp),intent(out)   :: hess((3*n)*(3*n+1)/2)
   real(wp),allocatable   :: hessian(:,:,:,:) ! molecular hessian of IES

!  π itself
   real(wp),parameter :: pi = 3.1415926535897932384626433832795029_wp
!  √π
   real(wp),parameter :: sqrtpi = sqrt(pi)
!  √(2/π)
   real(wp),parameter :: sqrt2pi = sqrt(2.0_wp/pi)
!
!! ------------------------------------------------------------------------
!  charge model
!! ------------------------------------------------------------------------
   integer  :: m ! dimension of the Lagrangian
   real(wp),allocatable :: Amat(:,:)
   real(wp),allocatable :: Xvec(:)
   real(wp),allocatable :: Ainv(:,:)
   real(wp),allocatable :: dAmat(:,:,:)
   real(wp),allocatable :: dqdr(:,:,:)

!! ------------------------------------------------------------------------
!  local variables
!! ------------------------------------------------------------------------
   integer  :: i,j,k,l
   real(wp) :: r,rij(3),r2
   real(wp) :: gamij,gamij2
   real(wp) :: arg,arg2,tmp,dtmp
   real(wp) :: lambda
   real(wp) :: es,expterm,erfterm
   real(wp) :: htmp,rxr(3,3)
   real(wp) :: rcovij,rr

!! ------------------------------------------------------------------------
!  scratch variables
!! ------------------------------------------------------------------------
   real(wp),allocatable :: alpha(:)
   real(wp),allocatable :: xtmp(:)
   real(wp),allocatable :: atmp(:,:)

!! ------------------------------------------------------------------------
!  Lapack work variables
!! ------------------------------------------------------------------------
   integer, allocatable :: ipiv(:)
   real(wp),allocatable :: temp(:)
   real(wp),allocatable :: work(:)
   integer  :: lwork
   integer  :: info
   real(wp) :: test(1)

!! ------------------------------------------------------------------------
!  initizialization
!! ------------------------------------------------------------------------
   m    = n+1
   allocate( ipiv(m), source = 0 )
   allocate( Amat(m,m), Xvec(m), alpha(n), dqdr(3,n,m), source = 0.0_wp )

!! ------------------------------------------------------------------------
!  set up the A matrix and X vector
!! ------------------------------------------------------------------------
!  αi -> alpha(i), ENi -> xi(i), κi -> kappa(i), Jii -> gam(i)
!  γij = 1/√(αi+αj)
!  Xi  = -ENi + κi·√CNi
!  Aii = Jii + 2/√π·γii
!  Aij = erf(γij·Rij)/Rij = 2/√π·F0(γ²ij·R²ij)
!! ------------------------------------------------------------------------
!  prepare some arrays
!$omp parallel default(none) &
!$omp shared(n,at,chrgeq) &
!$omp private(i) &
!$omp shared(Xvec,alpha)
!$omp do schedule(dynamic)
   do i = 1, n
      Xvec(i) = -chrgeq%en(i)
      alpha(i) = chrgeq%alpha(i)**2
   enddo
!$omp enddo
!$omp endparallel

!$omp parallel default(none) &
!$omp shared(n,at,xyz,chrgeq,alpha) &
!$omp private(i,j,r,gamij) &
!$omp shared(Amat)
!$omp do schedule(dynamic)
   ! prepare A matrix
   do i = 1, n
      ! EN of atom i
      do j = 1, i-1
         r = sqrt(sum((xyz(:,j) - xyz(:,i))**2))
         gamij = 1.0_wp/sqrt(alpha(i)+alpha(j))
         Amat(j,i) = erf(gamij*r)/r
         Amat(i,j) = Amat(j,i)
      enddo
      Amat(i,i) = chrgeq%gam(i) + sqrt2pi/sqrt(alpha(i))
   enddo
!$omp enddo
!$omp endparallel

!! ------------------------------------------------------------------------
!  solve the linear equations to obtain partial charges
!! ------------------------------------------------------------------------
   Amat(m,1:m) = 1.0_wp
   Amat(1:m,m) = 1.0_wp
   Amat(m,m  ) = 0.0_wp
   Xvec(m)     = chrg
   ! generate temporary copy
   allocate( Atmp(m,m), source = Amat )
   allocate( Xtmp(m),   source = Xvec )

   ! assume work space query, set best value to test after first dsysv call
   call dsysv('u', m, 1, Atmp, m, ipiv, Xtmp, m, test, -1, info)
   lwork = int(test(1))
   allocate( work(lwork), source = 0.0_wp )

   call dsysv('u',m,1,Atmp,m,ipiv,Xtmp,m,work,lwork,info)
   if(info > 0) call raise('E','(goedecker_solve) DSYSV failed')

   if(abs(sum(Xtmp(:n))-chrg) > 1.e-6_wp) &
      call raise('E','(goedecker_solve) charge constrain error')
   !print'(3f20.14)',Xtmp

!! ------------------------------------------------------------------------
!  calculate isotropic electrostatic (IES) energy
!! ------------------------------------------------------------------------
!  E = ∑i (ENi - κi·√CNi)·qi + ∑i (Jii + 2/√π·γii)·q²i
!      + ½ ∑i ∑j,j≠i qi·qj·2/√π·F0(γ²ij·R²ij)
!    = q·(½A·q - X)
!! ------------------------------------------------------------------------
!   work(:m) = Xvec
!   call dsymv('u',m,0.5_wp,Amat,m,Xtmp,1,-1.0_wp,work,1)
!   es = dot_product(Xtmp,work(:m))
!   energy = es + energy

!! ------------------------------------------------------------------------
!  calculate molecular gradient of the IES energy
!! ------------------------------------------------------------------------
!  dE/dRj -> g(:,j), ∂Xi/∂Rj -> -dcn(:,i,j), ½∂Aij/∂Rj -> dAmat(:,j,i)
!  dE/dR = (½∂A/∂R·q - ∂X/∂R)·q
!  ∂Aij/∂Rj = ∂Aij/∂Ri
!! ------------------------------------------------------------------------
   allocate( dAmat(3,n,m), source = 0.0_wp )
!$omp parallel default(none) &
!$omp shared(n,xyz,alpha,Amat,Xtmp) &
!$omp private(i,j,rij,r2,gamij,arg,dtmp) &
!$omp reduction(+:dAmat)
!$omp do schedule(dynamic)
   do i = 1, n
      do j = 1, i-1
         rij = xyz(:,i) - xyz(:,j)
         r2 = sum(rij**2)
         gamij = 1.0_wp/sqrt(alpha(i) + alpha(j))
         arg = gamij**2*r2
         dtmp = 2.0_wp*gamij*exp(-arg)/(sqrtpi*r2)-Amat(j,i)/r2
         dAmat(:,i,i) = +dtmp*rij*Xtmp(j) + dAmat(:,i,i)
         dAmat(:,j,j) = -dtmp*rij*Xtmp(i) + dAmat(:,j,j)
         dAmat(:,i,j) = +dtmp*rij*Xtmp(i)
         dAmat(:,j,i) = -dtmp*rij*Xtmp(j)
      enddo
   enddo
!$omp enddo
!$omp endparallel

!! ------------------------------------------------------------------------
!  invert the A matrix using a Bunch-Kaufman factorization
!  A⁻¹ = (L·D·L^T)⁻¹ = L^T·D⁻¹·L
!! ------------------------------------------------------------------------
   allocate( Ainv(m,m), source = Amat )

   ! assume work space query, set best value to test after first dsytrf call
   call dsytrf('L',m,Ainv,m,ipiv,test,-1,info)
   if (int(test(1)) > lwork) then
      deallocate(work)
      lwork=int(test(1))
      allocate( work(lwork), source = 0.0_wp )
   endif

   ! Bunch-Kaufman factorization A = L*D*L**T
   call dsytrf('L',m,Ainv,m,ipiv,work,lwork,info)
   if(info > 0)then
      call raise('E', '(goedecker_inversion) DSYTRF failed')
   endif

   ! A⁻¹ from factorized L matrix, save lower part of A⁻¹ in Ainv matrix
   ! Ainv matrix is overwritten with lower triangular part of A⁻¹
   call dsytri('L',m,Ainv,m,ipiv,work,info)
   if (info > 0) then
      call raise('E', '(goedecker_inversion) DSYTRI failed')
   endif

   ! symmetrizes A⁻¹ matrix from lower triangular part of inverse matrix
   do i = 1, m
      do j = i+1, m
         Ainv(i,j)=Ainv(j,i)
      enddo
   enddo

!! ------------------------------------------------------------------------
!  calculate gradient of the partial charge w.r.t. the nuclear coordinates
!! ------------------------------------------------------------------------
   !call dsymm('r','l',3*n,m,-1.0_wp,Ainv,m,dAmat,3*n,1.0_wp,dqdr,3*n)
   call dgemm('n','n',3*n,m,m,-1.0_wp,dAmat,3*n,Ainv,m,1.0_wp,dqdr,3*n)
   !print'(/,"analytical gradient")'
   !print'(3f20.14)',dqdr(:,:,:n)

!! ------------------------------------------------------------------------
!  molecular Hessian calculation
!! ------------------------------------------------------------------------
   do i = 1, n
      do j = 1, i-1
         rij = xyz(:,j) - xyz(:,i)
         r2 = sum(rij**2)
         r = sqrt(r2)
         gamij = 1.0_wp/sqrt(alpha(i)+alpha(j))
         gamij2 = gamij**2
         arg2 = gamij2 * r2
         arg = sqrt(arg2)
         erfterm = Xtmp(i)*Xtmp(j)*erf(arg)/r
         expterm = Xtmp(i)*Xtmp(j)*2*gamij*exp(-arg2)/sqrtpi
         ! ∂²(qAq)/(∂Ri∂Rj):
         ! ∂²(qAq)/(∂Xi∂Xi) = (1-3X²ij/R²ij-2γ²ijX²ij) 2γij/√π exp[-γ²ij·R²ij]/R²ij
         !                  - (R²ij-3X²ij) erf[γij·Rij]/R⁵ij
         ! ∂²(qAq)/(∂Xi∂Xj) = (R²ij-3X²ij) erf[γij·Rij]/R⁵ij
         !                  - (1-3X²ij/R²ij-2γ²ijX²ij) 2γij/√π exp[-γ²ij·R²ij]/R²ij
         ! ∂²(qAq)/(∂Xi∂Yi) = 3X²ij erf[γij·Rij]/R⁵ij
         !                  - (3X²ij/R²ij+2γ²ijX²ij) 2γij/√π exp[-γ²ij·R²ij]/R²ij
         ! ∂²(qAq)/(∂Xi∂Yj) = (3X²ij/R²ij+2γ²ijX²ij) 2γij/√π exp[-γ²ij·R²ij]/R²ij
         !                  - 3X²ij erf[γij·Rij]/R⁵ij
         rxr(1,1) = erfterm * ( 3*rij(1)**2/r2**2 - 1.0_wp/r2 ) &
                  - expterm * ( 3*rij(1)**2/r2**2 + 2*gamij2*rij(1)**2/r2 - 1/r2 )
         rxr(2,2) = erfterm * ( 3*rij(2)**2/r2**2 - 1.0_wp/r2 ) &
                  - expterm * ( 3*rij(2)**2/r2**2 + 2*gamij2*rij(2)**2/r2 - 1/r2 )
         rxr(3,3) = erfterm * ( 3*rij(3)**2/r2**2 - 1.0_wp/r2 ) &
                  - expterm * ( 3*rij(3)**2/r2**2 + 2*gamij2*rij(3)**2/r2 - 1/r2 )
         rxr(2,1) = erfterm * 3*rij(2)*rij(1)/r2**2 &
                  - expterm * ( 3*rij(2)*rij(1)/r2**2 + 2*gamij2*rij(2)*rij(1)/r2 )
         rxr(3,1) = erfterm * 3*rij(3)*rij(1)/r2**2 &
                  - expterm * ( 3*rij(3)*rij(1)/r2**2 + 2*gamij2*rij(3)*rij(1)/r2 )
         rxr(3,2) = erfterm * 3*rij(3)*rij(2)/r2**2 &
                  - expterm * ( 3*rij(3)*rij(2)/r2**2 + 2*gamij2*rij(3)*rij(2)/r2 )

         do k = 1, m
            rxr(1,1) = rxr(1,1) + 0.5_wp*dqdr(1,i,k)*dAmat(1,j,k) &
                                + 0.5_wp*dqdr(1,j,k)*dAmat(1,i,k)
            rxr(2,1) = rxr(2,1) + 0.5_wp*dqdr(2,i,k)*dAmat(1,j,k) &
                                + 0.5_wp*dqdr(2,j,k)*dAmat(1,i,k)
            rxr(3,1) = rxr(3,1) + 0.5_wp*dqdr(3,i,k)*dAmat(1,j,k) &
                                + 0.5_wp*dqdr(3,j,k)*dAmat(1,i,k)
            rxr(2,2) = rxr(2,2) + 0.5_wp*dqdr(2,i,k)*dAmat(2,j,k) &
                                + 0.5_wp*dqdr(2,j,k)*dAmat(2,i,k)
            rxr(3,2) = rxr(3,2) + 0.5_wp*dqdr(3,i,k)*dAmat(2,j,k) &
                                + 0.5_wp*dqdr(3,j,k)*dAmat(2,i,k)
            rxr(3,3) = rxr(3,3) + 0.5_wp*dqdr(3,i,k)*dAmat(3,j,k) &
                                + 0.5_wp*dqdr(3,j,k)*dAmat(3,i,k)
         enddo
         ! symmetrize
         rxr(1,2) = rxr(2,1)
         rxr(1,3) = rxr(3,1)
         rxr(2,3) = rxr(3,2)

         ! save diagonal elements for atom i
         hess(ind(1,i,1,i))=hess(ind(1,i,1,i)) + kq*rxr(1,1)
         hess(ind(2,i,1,i))=hess(ind(2,i,1,i)) + kq*rxr(2,1)
         hess(ind(2,i,2,i))=hess(ind(2,i,2,i)) + kq*rxr(2,2)
         hess(ind(3,i,1,i))=hess(ind(3,i,1,i)) + kq*rxr(3,1)
         hess(ind(3,i,2,i))=hess(ind(3,i,2,i)) + kq*rxr(3,2)
         hess(ind(3,i,3,i))=hess(ind(3,i,3,i)) + kq*rxr(3,3)
         ! save elements between atom i and atom j
         hess(ind(1,i,1,j))=hess(ind(1,i,1,j)) - kq*rxr(1,1)
         hess(ind(1,i,2,j))=hess(ind(1,i,2,j)) - kq*rxr(2,1)
         hess(ind(1,i,3,j))=hess(ind(1,i,3,j)) - kq*rxr(3,1)
         hess(ind(2,i,1,j))=hess(ind(2,i,1,j)) - kq*rxr(2,1)
         hess(ind(2,i,2,j))=hess(ind(2,i,2,j)) - kq*rxr(2,2)
         hess(ind(2,i,3,j))=hess(ind(2,i,3,j)) - kq*rxr(3,2)
         hess(ind(3,i,1,j))=hess(ind(3,i,1,j)) - kq*rxr(3,1)
         hess(ind(3,i,2,j))=hess(ind(3,i,2,j)) - kq*rxr(3,2)
         hess(ind(3,i,3,j))=hess(ind(3,i,3,j)) - kq*rxr(3,3)
         ! save diagonal elements for atom j
         hess(ind(1,j,1,j))=hess(ind(1,j,1,j)) + kq*rxr(1,1)
         hess(ind(2,j,1,j))=hess(ind(2,j,1,j)) + kq*rxr(2,1)
         hess(ind(2,j,2,j))=hess(ind(2,j,2,j)) + kq*rxr(2,2)
         hess(ind(3,j,1,j))=hess(ind(3,j,1,j)) + kq*rxr(3,1)
         hess(ind(3,j,2,j))=hess(ind(3,j,2,j)) + kq*rxr(3,2)
         hess(ind(3,j,3,j))=hess(ind(3,j,3,j)) + kq*rxr(3,3)
      enddo
   enddo

   ! ∂²(qA)/(∂Ri∂q)·∂q/∂Rj
  ! hessian = hessian + reshape(matmul(reshape(dqdr,(/3*n,m/)),&
  !    transpose(reshape(dAmat,(/3*n,m/)))),(/3,n,3,n/))
   !call dgemm('n','t',3*n,m,3*n,+1.0_wp,dqdr,3*n,dAmat,3*n,1.0_wp,hessian,3*n)
   !call dgemm('n','t',3*n,m,3*n,+1.0_wp,dAmat,3*n,dqdr,3*n,1.0_wp,hessian,3*n)

end subroutine mh_eeq

end module xtb_modelhessian

      subroutine ddvopt(Cart,nAtoms,Hess,iANr,s6)
      Implicit Integer(i-n)
      Implicit Real*8 (a-h, o-z)
! include "common/real.inc" (molpro 2002.6)
      Real*8 Zero, One, Two, Three, Four, Five, Six, Seven, &
     &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34, &
     &       TwoP54, One2C2
      Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0, &
     &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0, &
     &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0, &
     &          Pi    =3.141592653589793D0, &
     &          SqrtP2=0.8862269254527579D0, &
     &          TwoP34=0.2519794355383808D0, &
     &          TwoP54=5.914967172795612D0, &
     &          One2C2=0.2662567690426443D-04)
! end: common/real.inc

      Real*8 Cart(3,nAtoms),rij(3),rjk(3),rkl(3), &
     &       Hess((3*nAtoms)*(3*nAtoms+1)/2),si(3),sj(3),sk(3), &
     &       sl(3),sm(3),x(2),y(2),z(2), &
     &       xyz(3,4), C(3,4), Dum(3,4,3,4)
      Integer   iANr(nAtoms)

      logical rcutoff

! include  "common/ddvdt.inc" (molpro 2002.6)
      Real*8 rAV(3,3), aAV(3,3), &
     &       B_Str(6), A_Bend(2), A_Trsn(2), A_StrH(2), &
     &       rkr, rkf, A_Str, RF_Const, &
     &       wthr

      Data rAv/1.3500d+00,2.1000d+00,2.5300d+00, &
     &         2.1000d+00,2.8700d+00,3.4000d+00, &
     &         2.5300d+00,3.4000d+00,3.4000d+00/
      Data aAv/1.0000d+00,0.3949d+00,0.3949d+00, &
     &         0.3949d+00,0.2800d+00,0.2800d+00, &
     &         0.3949d+00,0.2800d+00,0.2800d+00/
!org  Data rkr,rkf,rkt/0.4500D+00,0.1500D+00,0.5000D-02/
      Data rkr,rkf,rkt/0.4000D+00,0.1300D+00,0.7500D-02/
      Data A_Str/1.734d0/
      Data B_Str/-.244d0,0.352d0,1.085d0,0.660d0,1.522d0,2.068d0/
      Data A_Bend/0.160d0,0.250d0/
      Data A_Trsn/0.0023d0,0.07d0/
      Data A_StrH/0.3601d0,1.944d0/
      Data RF_Const/1.0D-2/
      Data wthr/0.2/
! end: "common/ddvdt.inc"

!cc VDWx-Parameters (Grimme) used for vdw-correction of model hessian
      real*8 alphavdw, damp, c6(100), c6k, c6l, c66, vander(100), &
     &   vdw(3,3), dr(3)
      integer kxyz, lxyz
      data vander &
! H, He
     &     /0.91d0,0.92d0, &
! Li-Ne
     &      0.75d0,1.28d0,1.35d0,1.32d0,1.27d0,1.22d0,1.17d0,1.13d0, &
! Na-Ar
     &      1.04d0,1.24d0,1.49d0,1.56d0,1.55d0,1.53d0,1.49d0,1.45d0, &
! K, Ca
     &      1.35d0,1.34d0, &
! Sc-Zn
     &      1.42d0,1.42d0,1.42d0,1.42d0,1.42d0, &
     &      1.42d0,1.42d0,1.42d0,1.42d0,1.42d0, &
! Ga-Kr
     &      1.50d0,1.57d0,1.60d0,1.61d0,1.59d0,1.57d0, &
! Rb, Sr
     &      1.48d0,1.46d0, &
! Y-Cd
     &      1.49d0,1.49d0,1.49d0,1.49d0,1.49d0, &
     &      1.49d0,1.49d0,1.49d0,1.49d0,1.49d0, &
! In, Sn, Sb, Te, I, Xe
     &      1.52d0,1.64d0,1.71d0,1.72d0,1.72d0,1.71d0, &
     &      46*2.d0/
!cc End: VDWx ccccccccccccccccc

!
!------- Statement functions
!
      ixyz(i,iAtom) = (iAtom-1)*3 + i
      Jnd(i,j) = i*(i-1)/2 +j
      Ind(i,iAtom,j,jAtom)=Jnd(Max(ixyz(i,iAtom),ixyz(j,jAtom)), &
     &                         Min(ixyz(i,iAtom),ixyz(j,jAtom)))
!end

!cc VDWx cccccccccccccccccccc
       c6 =   50.0
       c6( 1)=0.14
       c6( 2)=0.08
       c6( 3)=1.61
       c6( 4)=1.61
       c6( 5)=3.13
       c6( 6)=1.75
       c6( 7)=1.23
       c6( 8)=0.70
       c6( 9)=0.75
       c6(10)=0.63
       c6(11)=5.71
       c6(12)=5.71
       c6(13)=10.79
       c6(14)=9.23
       c6(15)=7.84
       c6(16)=5.57
       c6(17)=5.07
       c6(18)=4.61
       c6(19:30)=10.8
       c6(31)=16.99
       c6(32)=17.10
       c6(33)=16.37
       c6(34)=12.64
       c6(35)=12.47
       c6(36)=12.01
       c6(37:48)=24.67
       c6(49)=37.32
       c6(50)=38.71
       c6(51)=38.44
       c6(52)=31.74
       c6(53)=31.50
       c6(54)=29.99
!cc ENDE VDWx cccccccccccccccc

      bohr=0.52917726d0
      Fact=One
!hjw threshold reduced
      rZero=1.0d-10
      n3=3*nAtoms
      Hess = 0.0d0

!
!     Hessian for tension
!
 777  Do kAtom = 1, nAtoms
         kr=iTabRow(iANr(kAtom))
!        If (kr.eq.0) Go To 5

         Do lAtom = 1, kAtom-1
            lr=iTabRow(iANr(lAtom))
!           If (lr.eq.0) Go To 10
            xkl=Cart(1,kAtom)-Cart(1,lAtom)
            ykl=Cart(2,kAtom)-Cart(2,lAtom)
            zkl=Cart(3,kAtom)-Cart(3,lAtom)
            rkl2 = xkl**2 + ykl**2 + zkl**2
            r0=rAv(kr,lr)
            alpha=aAv(kr,lr)

!cccccc VDWx ccccccccccccccccccccccccccccccccc
            c6k=c6(iANr(katom))
            c6l=c6(iANr(latom))
            c66=sqrt(c6k*c6l)
            Rv=(vander(iANr(katom))+vander(iANr(latom)))/0.52917721

            call getvdwxx(xkl, ykl, zkl, c66, s6, Rv, vdw(1,1))
            call getvdwxy(xkl, ykl, zkl, c66, s6, Rv, vdw(1,2))
            call getvdwxy(xkl, zkl, ykl, c66, s6, Rv, vdw(1,3))
            call getvdwxx(ykl, xkl, zkl, c66, s6, Rv, vdw(2,2))
            call getvdwxy(ykl, zkl, xkl, c66, s6, Rv, vdw(2,3))
            call getvdwxx(zkl, xkl, ykl, c66, s6, Rv, vdw(3,3))
!cccccc Ende VDWx ccccccccccccccccccccccccccccccc

            gamma=rkr*Exp(alpha*r0**2)
! not better: *sqrt(abs(wb(kAtom,lAtom)))
            gmm=gamma*Exp(-alpha*rkl2)
            Hxx=gmm*xkl*xkl/rkl2-vdw(1,1)
            Hxy=gmm*xkl*ykl/rkl2-vdw(1,2)
            Hxz=gmm*xkl*zkl/rkl2-vdw(1,3)
            Hyy=gmm*ykl*ykl/rkl2-vdw(2,2)
            Hyz=gmm*ykl*zkl/rkl2-vdw(2,3)
            Hzz=gmm*zkl*zkl/rkl2-vdw(3,3)

!
            Hess(Ind(1,kAtom,1,kAtom))=Hess(Ind(1,kAtom,1,kAtom))+Hxx
            Hess(Ind(2,kAtom,1,kAtom))=Hess(Ind(2,kAtom,1,kAtom))+Hxy
            Hess(Ind(2,kAtom,2,kAtom))=Hess(Ind(2,kAtom,2,kAtom))+Hyy
            Hess(Ind(3,kAtom,1,kAtom))=Hess(Ind(3,kAtom,1,kAtom))+Hxz
            Hess(Ind(3,kAtom,2,kAtom))=Hess(Ind(3,kAtom,2,kAtom))+Hyz
            Hess(Ind(3,kAtom,3,kAtom))=Hess(Ind(3,kAtom,3,kAtom))+Hzz
!
            Hess(Ind(1,kAtom,1,lAtom))=Hess(Ind(1,kAtom,1,lAtom))-Hxx
            Hess(Ind(1,kAtom,2,lAtom))=Hess(Ind(1,kAtom,2,lAtom))-Hxy
            Hess(Ind(1,kAtom,3,lAtom))=Hess(Ind(1,kAtom,3,lAtom))-Hxz
            Hess(Ind(2,kAtom,1,lAtom))=Hess(Ind(2,kAtom,1,lAtom))-Hxy
            Hess(Ind(2,kAtom,2,lAtom))=Hess(Ind(2,kAtom,2,lAtom))-Hyy
            Hess(Ind(2,kAtom,3,lAtom))=Hess(Ind(2,kAtom,3,lAtom))-Hyz
            Hess(Ind(3,kAtom,1,lAtom))=Hess(Ind(3,kAtom,1,lAtom))-Hxz
            Hess(Ind(3,kAtom,2,lAtom))=Hess(Ind(3,kAtom,2,lAtom))-Hyz
            Hess(Ind(3,kAtom,3,lAtom))=Hess(Ind(3,kAtom,3,lAtom))-Hzz
!
            Hess(Ind(1,lAtom,1,lAtom))=Hess(Ind(1,lAtom,1,lAtom))+Hxx
            Hess(Ind(2,lAtom,1,lAtom))=Hess(Ind(2,lAtom,1,lAtom))+Hxy
            Hess(Ind(2,lAtom,2,lAtom))=Hess(Ind(2,lAtom,2,lAtom))+Hyy
            Hess(Ind(3,lAtom,1,lAtom))=Hess(Ind(3,lAtom,1,lAtom))+Hxz
            Hess(Ind(3,lAtom,2,lAtom))=Hess(Ind(3,lAtom,2,lAtom))+Hyz
            Hess(Ind(3,lAtom,3,lAtom))=Hess(Ind(3,lAtom,3,lAtom))+Hzz
!

 10         Continue
         End Do

 5       Continue
      End Do


!
!     Hessian for bending
!
      Do mAtom = 1, nAtoms
         mr=iTabRow(iANr(mAtom))
!        If (mr.eq.0) Go To 20
         Do iAtom = 1, nAtoms
           If (iAtom.eq.mAtom) Go To 30
           ir=iTabRow(iANr(iAtom))
!          If (ir.eq.0) Go To 30
           if(rcutoff(cart,iatom,matom)) cycle
!          if(wb(iatom,matom).lt.wthr) cycle
           Do jAtom = 1, iAtom-1
            If (jAtom.eq.mAtom) Go To 40
            jr=iTabRow(iANr(jAtom))
!           If (jr.eq.0) Go To 40
            if(rcutoff(cart,jatom,iatom)) cycle
            if(rcutoff(cart,jatom,matom)) cycle
!           if(wb(jatom,iatom).lt.wthr) cycle
!           if(wb(jatom,matom).lt.wthr) cycle

            xmi=(Cart(1,iAtom)-Cart(1,mAtom))
            ymi=(Cart(2,iAtom)-Cart(2,mAtom))
            zmi=(Cart(3,iAtom)-Cart(3,mAtom))
            rmi2 = xmi**2 + ymi**2 + zmi**2
            rmi=sqrt(rmi2)
            r0mi=rAv(mr,ir)
            ami=aAv(mr,ir)
!
            xmj=(Cart(1,jAtom)-Cart(1,mAtom))
            ymj=(Cart(2,jAtom)-Cart(2,mAtom))
            zmj=(Cart(3,jAtom)-Cart(3,mAtom))
            rmj2 = xmj**2 + ymj**2 + zmj**2
            rmj=sqrt(rmj2)
            r0mj=rAv(mr,jr)
            amj=aAv(mr,jr)
!
!---------- Test if zero angle
!
            Test=xmi*xmj+ymi*ymj+zmi*zmj
            Test=Test/(rmi*rmj)
            If (Test.eq.One) Go To 40
!
            xij=(Cart(1,jAtom)-Cart(1,iAtom))
            yij=(Cart(2,jAtom)-Cart(2,iAtom))
            zij=(Cart(3,jAtom)-Cart(3,iAtom))
            rij2 = xij**2 + yij**2 + zij**2
            rrij=sqrt(rij2)
!
            alpha=rkf*exp((ami*r0mi**2+amj*r0mj**2))
!
            r=sqrt(rmj2+rmi2)
            gij=alpha*exp(-(ami*rmi2+amj*rmj2))
!           Write (*,*) ' gij=',gij
            rL2=(ymi*zmj-zmi*ymj)**2+(zmi*xmj-xmi*zmj)**2+ &
     &         (xmi*ymj-ymi*xmj)**2
!hjw modified
            if(rL2.lt.1.d-14) then
              rL=0
            else
              rL=sqrt(rL2)
            end if
!
            if ((rmj.gt.rZero).and.(rmi.gt.rZero).and. &
     &                                (rrij.gt.rZero)) Then
              SinPhi=rL/(rmj*rmi)
              rmidotrmj=xmi*xmj+ymi*ymj+zmi*zmj
              CosPhi=rmidotrmj/(rmj*rmi)
!
!-------------None linear case
!
              If (SinPhi.gt.rZero) Then
!               Write (*,*) ' None linear case'
                si(1)=(xmi/rmi*cosphi-xmj/rmj)/(rmi*sinphi)
                si(2)=(ymi/rmi*cosphi-ymj/rmj)/(rmi*sinphi)
                si(3)=(zmi/rmi*cosphi-zmj/rmj)/(rmi*sinphi)
                sj(1)=(cosphi*xmj/rmj-xmi/rmi)/(rmj*sinphi)
                sj(2)=(cosphi*ymj/rmj-ymi/rmi)/(rmj*sinphi)
                sj(3)=(cosphi*zmj/rmj-zmi/rmi)/(rmj*sinphi)
                sm(1)=-si(1)-sj(1)
                sm(2)=-si(2)-sj(2)
                sm(3)=-si(3)-sj(3)
                Do icoor=1,3
                   Do jCoor=1,3
                    If (mAtom.gt.iAtom) Then
                       Hess(Ind(icoor,mAtom,jcoor,iAtom))= &
     &                        Hess(Ind(icoor,mAtom,jcoor,iAtom)) &
     &                        +gij*sm(icoor)*si(jcoor)
                    else
                      Hess(Ind(icoor,iAtom,jcoor,mAtom))= &
     &                        Hess(Ind(icoor,iAtom,jcoor,mAtom)) &
     &                        +gij*si(icoor)*sm(jcoor)
                    End If
                    If (mAtom.gt.jAtom) Then
                        Hess(Ind(icoor,mAtom,jcoor,jAtom))= &
     &                        Hess(Ind(icoor,mAtom,jcoor,jAtom)) &
     &                        +gij*sm(icoor)*sj(jcoor)
                    else
                      Hess(Ind(icoor,jAtom,jcoor,mAtom))= &
     &                        Hess(Ind(icoor,jAtom,jcoor,mAtom)) &
     &                        +gij*sj(icoor)*sm(jcoor)
                    End If
                    If (iAtom.gt.jAtom) Then
                        Hess(Ind(icoor,iAtom,jcoor,jAtom))= &
     &                        Hess(Ind(icoor,iAtom,jcoor,jAtom)) &
     &                        +gij*si(icoor)*sj(jcoor)
                     else
                        Hess(Ind(icoor,jAtom,jcoor,iAtom))= &
     &                        Hess(Ind(icoor,jAtom,jcoor,iAtom)) &
     &                        +gij*sj(icoor)*si(jcoor)
                     End If
                   End Do
                End Do
                Do icoor=1,3
                  Do jCoor=1,icoor
                    Hess(Ind(icoor,iAtom,jcoor,iAtom))= &
     &                        Hess(Ind(icoor,iAtom,jcoor,iAtom)) &
     &                        +gij*si(icoor)*si(jcoor)
                    Hess(Ind(icoor,mAtom,jcoor,mAtom))= &
     &                        Hess(Ind(icoor,mAtom,jcoor,mAtom)) &
     &                        +gij*sm(icoor)*sm(jcoor)
                    Hess(Ind(icoor,jAtom,jcoor,jAtom))= &
     &                        Hess(Ind(icoor,jAtom,jcoor,jAtom)) &
     &                        +gij*sj(icoor)*sj(jcoor)

!
                  End Do
                End Do
              Else
!
!----------------Linear case
!
!               Write (*,*) 'linear case'
                    if ((abs(ymi).gt.rZero).or. &
     &                 (abs(xmi).gt.rZero)) Then
                      x(1)=-ymi
                      y(1)=xmi
                      z(1)=Zero
                      x(2)=-xmi*zmi
                      y(2)=-ymi*zmi
                      z(2)=xmi*xmi+ymi*ymi
                    Else
                      x(1)=One
                      y(1)=Zero
                      z(1)=Zero
                      x(2)=Zero
                      y(2)=One
                      z(2)=Zero
                    End If
                    Do i=1,2
                     r1=sqrt(x(i)**2+y(i)**2+z(i)**2)
                     cosThetax=x(i)/r1
                     cosThetay=y(i)/r1
                     cosThetaz=z(i)/r1
                     si(1)=-cosThetax/rmi
                     si(2)=-cosThetay/rmi
                     si(3)=-cosThetaz/rmi
                     sj(1)=-cosThetax/rmj
                     sj(2)=-cosThetay/rmj
                     sj(3)=-cosThetaz/rmj
                     sm(1)=-(si(1)+sj(1))
                     sm(2)=-(si(2)+sj(2))
                     sm(3)=-(si(3)+sj(3))
!
                     Do icoor=1,3
                       Do jCoor=1,3
                        If (mAtom.gt.iAtom) Then
                          Hess(Ind(icoor,mAtom,jcoor,iAtom))= &
     &                        Hess(Ind(icoor,mAtom,jcoor,iAtom)) &
     &                         +gij*sm(icoor)*si(jcoor)
                        else
                           Hess(Ind(icoor,iAtom,jcoor,mAtom))= &
     &                        Hess(Ind(icoor,iAtom,jcoor,mAtom)) &
     &                         +gij*si(icoor)*sm(jcoor)
                        End If
                        If (mAtom.gt.jAtom) Then
                          Hess(Ind(icoor,mAtom,jcoor,jAtom))= &
     &                        Hess(Ind(icoor,mAtom,jcoor,jAtom)) &
     &                         +gij*sm(icoor)*sj(jcoor)
                        else
                          Hess(Ind(icoor,jAtom,jcoor,mAtom))= &
     &                        Hess(Ind(icoor,jAtom,jcoor,mAtom)) &
     &                         +gij*sj(icoor)*sm(jcoor)
                        End If
                        If (iAtom.gt.jAtom) Then
                           Hess(Ind(icoor,iAtom,jcoor,jAtom))= &
     &                        Hess(Ind(icoor,iAtom,jcoor,jAtom)) &
     &                         +gij*si(icoor)*sj(jcoor)
                        else
                           Hess(Ind(icoor,jAtom,jcoor,iAtom))= &
     &                        Hess(Ind(icoor,jAtom,jcoor,iAtom)) &
     &                         +gij*sj(icoor)*si(jcoor)
                        End If
                       End Do
                     End Do
                     Do icoor=1,3
                       Do jCoor=1,icoor
                         Hess(Ind(icoor,iAtom,jcoor,iAtom))= &
     &                        Hess(Ind(icoor,iAtom,jcoor,iAtom)) &
     &                         +gij*si(icoor)*si(jcoor)
                         Hess(Ind(icoor,mAtom,jcoor,mAtom))= &
     &                        Hess(Ind(icoor,mAtom,jcoor,mAtom)) &
     &                         +gij*sm(icoor)*sm(jcoor)
                         Hess(Ind(icoor,jAtom,jcoor,jAtom))= &
     &                         Hess(Ind(icoor,jAtom,jcoor,jAtom)) &
     &                         +gij*sj(icoor)*sj(jcoor)
                       End Do
                     End Do
                 End Do
              End If
            End If
!
 40         Continue
        End Do
 30     Continue
       End Do
 20    Continue
      End Do
!
!     Hessian for torsion
!
      Do jAtom = 1,nAtoms
        jr=iTabRow(iANr(jAtom))
!       If (jr.eq.0) Go To 444
!
        Call DCopy(3,Cart(1,jAtom),1,xyz(1,2),1)
!
        Do kAtom = 1, nAtoms
           If (kAtom.eq.jAtom) Go To 111
           kr=iTabRow(iANr(kAtom))
!          If (kr.eq.0) Go To 111

           if(rcutoff(cart,katom,jatom)) cycle
!          if(wb(katom,jatom).lt.wthr) cycle
!
           Call DCopy(3,Cart(1,kAtom),1,xyz(1,3),1)
!
           Do iAtom = 1, nAtoms
              ij_=nAtoms*(jAtom-1)+iAtom
              If (iAtom.eq.jAtom) Go To 333
              If (iAtom.eq.kAtom) Go To 333
              ir=iTabRow(iANr(iAtom))
!             If (ir.eq.0) Go To 333
!
              if(rcutoff(cart,iatom,katom)) cycle
              if(rcutoff(cart,iatom,jatom)) cycle
!             if(wb(iatom,katom).lt.wthr) cycle
!             if(wb(iatom,jatom).lt.wthr) cycle

              Call DCopy(3,Cart(1,iAtom),1,xyz(1,1),1)
!
              Do lAtom = 1, nAtoms
                 lk_=nAtoms*(kAtom-1)+lAtom
                 If (ij_.le.lk_) Go To 222
                 If (lAtom.eq.iAtom) Go To 222
                 If (lAtom.eq.jAtom) Go To 222
                 If (lAtom.eq.kAtom) Go To 222
                 lr=iTabRow(iANr(lAtom))
!                If (lr.eq.0) Go To 222
!
                 if(rcutoff(cart,latom,iatom)) cycle
                 if(rcutoff(cart,latom,katom)) cycle
                 if(rcutoff(cart,latom,jatom)) cycle
!                if(wb(latom,iatom).lt.wthr) cycle
!                if(wb(latom,katom).lt.wthr) cycle
!                if(wb(latom,jatom).lt.wthr) cycle

                 Call DCopy(3,Cart(1,lAtom),1,xyz(1,4),1)
!
                 rij(1)=Cart(1,iAtom)-Cart(1,jAtom)
                 rij(2)=Cart(2,iAtom)-Cart(2,jAtom)
                 rij(3)=Cart(3,iAtom)-Cart(3,jAtom)
                 rij0=rAv(ir,jr)**2
                 aij =aAv(ir,jr)
!
                 rjk(1)=Cart(1,jAtom)-Cart(1,kAtom)
                 rjk(2)=Cart(2,jAtom)-Cart(2,kAtom)
                 rjk(3)=Cart(3,jAtom)-Cart(3,kAtom)
                 rjk0=rAv(jr,kr)**2
                 ajk =aAv(jr,kr)
!
                 rkl(1)=Cart(1,kAtom)-Cart(1,lAtom)
                 rkl(2)=Cart(2,kAtom)-Cart(2,lAtom)
                 rkl(3)=Cart(3,kAtom)-Cart(3,lAtom)
                 rkl0=rAv(kr,lr)**2
                 akl =aAv(kr,lr)
!
                 rij2=rij(1)**2+rij(2)**2+rij(3)**2
                 rjk2=rjk(1)**2+rjk(2)**2+rjk(3)**2
                 rkl2=rkl(1)**2+rkl(2)**2+rkl(3)**2

!              Allow only angles in the range of 35-145
               A35 = (35.0D0/180.D0)* Pi
               CosFi_Max=Cos(A35)
               CosFi2=(rij(1)*rjk(1)+rij(2)*rjk(2)+rij(3)*rjk(3)) &
     &               /Sqrt(rij2*rjk2)
               If (Abs(CosFi2).gt.CosFi_Max) Go To 222
               CosFi3=(rkl(1)*rjk(1)+rkl(2)*rjk(2)+rkl(3)*rjk(3)) &
     &               /Sqrt(rkl2*rjk2)
               If (Abs(CosFi3).gt.CosFi_Max) Go To 222

               beta=rkt* &
     &                       exp( (aij*rij0+ajk*rjk0+akl*rkl0))
               tij=beta*exp(-(aij*rij2+ajk*rjk2+akl*rkl2))

               Call Trsn(xyz,4,Tau,C,.False.,.False.,'        ', &
     &                  Dum,.False.)
               Call DCopy(3,C(1,1),1,si,1)
               Call DCopy(3,C(1,2),1,sj,1)
               Call DCopy(3,C(1,3),1,sk,1)
               Call DCopy(3,C(1,4),1,sl,1)
!
!-------------Off diagonal block
!
              Do icoor=1,3
                Do jCoor=1,3
                 Hess(Ind(icoor,iAtom,jcoor,jAtom))= &
     &           Hess(Ind(icoor,iAtom,jcoor,jAtom)) &
     &            +tij*si(icoor) * sj(jcoor)
                 Hess(Ind(icoor,iAtom,jcoor,kAtom))= &
     &           Hess(Ind(icoor,iAtom,jcoor,kAtom)) &
     &            +tij*si(icoor) * sk(jcoor)
                 Hess(Ind(icoor,iAtom,jcoor,lAtom))= &
     &           Hess(Ind(icoor,iAtom,jcoor,lAtom)) &
     &            +tij*si(icoor) * sl(jcoor)
                 Hess(Ind(icoor,jAtom,jcoor,kAtom))= &
     &           Hess(Ind(icoor,jAtom,jcoor,kAtom)) &
     &            +tij*sj(icoor) * sk(jcoor)
                 Hess(Ind(icoor,jAtom,jcoor,lAtom))= &
     &           Hess(Ind(icoor,jAtom,jcoor,lAtom)) &
     &            +tij*sj(icoor) * sl(jcoor)
                 Hess(Ind(icoor,kAtom,jcoor,lAtom))= &
     &           Hess(Ind(icoor,kAtom,jcoor,lAtom)) &
     &            +tij*sk(icoor) * sl(jcoor)

                End Do
              End Do
!
!-------------Diagonal block
!
              Do icoor=1,3
                Do jCoor=1,icoor
                 Hess(Ind(icoor,iAtom,jcoor,iAtom))= &
     &           Hess(Ind(icoor,iAtom,jcoor,iAtom)) &
     &            +tij*si(icoor) * si(jcoor)
                 Hess(Ind(icoor,jAtom,jcoor,jAtom))= &
     &           Hess(Ind(icoor,jAtom,jcoor,jAtom)) &
     &            +tij*sj(icoor) * sj(jcoor)
                 Hess(Ind(icoor,kAtom,jcoor,kAtom))= &
     &           Hess(Ind(icoor,kAtom,jcoor,kAtom)) &
     &            +tij*sk(icoor) * sk(jcoor)
                 Hess(Ind(icoor,lAtom,jcoor,lAtom))= &
     &           Hess(Ind(icoor,lAtom,jcoor,lAtom)) &
     &            +tij*sl(icoor) * sl(jcoor)

!
                 End Do
               End Do
222            Continue
             End Do        ! lAtom
333          Continue
           End Do          ! iAtom
111        Continue
        End Do             ! kAtom
444     Continue
      End Do               ! jAtom
      Return
      End

      subroutine gff_ddvopt(Cart,nAtoms,Hess,at,s6,param,topo)
      use xtb_gfnff_data, only : TGFFData
      use xtb_gfnff_topology, only : TGFFTopology
      use xtb_type_timer
      Implicit Real*8 (a-h, o-z)
      type(TGFFData), intent(in) :: param
      type(TGFFTopology), intent(in) :: topo

      Integer at(nAtoms)
      Real*8 Cart(3,nAtoms)
      Real*8 Hess((3*nAtoms)*(3*nAtoms+1)/2)
      Real*8 s6
!     charges qa taken from gffcom

      Real*8 rij(3),rjk(3),rkl(3),&
     &       si(3),sj(3),sk(3),&
     &       sl(3),sm(3),x(2),y(2),z(2),&
     &       xyz(3,4), C(3,4), Dum(3,4,3,4) 
      Real*8 rAV(3,3), aAV(3,3),rkr, rkf
      Integer iANr(nAtoms)
      logical profile

      Data rAv/1.3500d+00,2.1000d+00,2.5300d+00,&
     &         2.1000d+00,2.8700d+00,3.4000d+00,&
     &         2.5300d+00,3.4000d+00,3.4000d+00/ 
      Data aAv/1.0000d+00,0.3949d+00,0.3949d+00,&
     &         0.3949d+00,0.2800d+00,0.2800d+00,&
     &         0.3949d+00,0.2800d+00,0.2800d+00/ 
!     Data rkr,rkf,rkt/0.4500D+00,0.1500D+00,0.5000D-02/ ! org
      Data rkr,rkf,rkt/0.4500D+00,0.3000D+00,0.75000  /  ! adjusted to account for redundant angles in old version

!cc VDWx-Parameters (Grimme) used for vdw-correction of model hessian 
      real*8 c6(54),c66
! NOT USED ANYMORE (BJ instead)
!     data vander &
! H, He
!    &     /0.91d0,0.92d0,&
! Li-Ne
!    &      0.75d0,1.28d0,1.35d0,1.32d0,1.27d0,1.22d0,1.17d0,1.13d0,&
! Na-Ar
!    &      1.04d0,1.24d0,1.49d0,1.56d0,1.55d0,1.53d0,1.49d0,1.45d0,&
! K, Ca
!    &      1.35d0,1.34d0,&
! Sc-Zn
!    &      1.42d0,1.42d0,1.42d0,1.42d0,1.42d0,&
!    &      1.42d0,1.42d0,1.42d0,1.42d0,1.42d0,&
! Ga-Kr
!    &      1.50d0,1.57d0,1.60d0,1.61d0,1.59d0,1.57d0,&
! Rb, Sr
!    &      1.48d0,1.46d0,&
! Y-Cd
!    &      1.49d0,1.49d0,1.49d0,1.49d0,1.49d0,&
!    &      1.49d0,1.49d0,1.49d0,1.49d0,1.49d0,&
! In, Sn, Sb, Te, I, Xe
!    &      1.52d0,1.64d0,1.71d0,1.72d0,1.72d0,1.71d0/ 

      Real*8 Zero, One, Two, Three, Four, Five, Six, Seven,&
     &       Eight, RNine, Ten, Half, Pi, SqrtP2, TwoP34,&
     &       TwoP54, One2C2
      Parameter(Zero =0.0D0, One  =1.0D0, Two=2.0D0, Three=3.0D0,&
     &          Four =4.0D0, Five =5.0D0, Six=6.0D0, Seven=7.0D0,&
     &          Eight=8.0D0, rNine=9.0D0, Ten=1.0D1, Half=0.5D0,&
     &          Pi    =3.141592653589793D0,&
     &          SqrtP2=0.8862269254527579D0,&
     &          TwoP34=0.2519794355383808D0,&
     &          TwoP54=5.914967172795612D0,&
     &          One2C2=0.2662567690426443D-04)

      type(tb_timer) :: timer
!     inline fct
      lina(i,j)=min(i,j)+max(i,j)*(max(i,j)-1)/2        
      ixyz(i,iAtom) = (iAtom-1)*3 + i
      Jnd(i,j) = i*(i-1)/2 +j
      Ind(i,iAtom,j,jAtom)=Jnd(Max(ixyz(i,iAtom),ixyz(j,jAtom)),&
     &                         Min(ixyz(i,iAtom),ixyz(j,jAtom)))

!     map heavy atoms to Z<=54
      do i=1,nAtoms
         iANr(i)=at(i)
         if(at(i).gt.54) iANr(i)=at(i) - 18
         if(at(i).gt.72) iANr(i)=at(i) - 32
         if(at(i).gt.56.and.at(i).lt.72) iANr(i)=39 ! set LNs to Y
      enddo

      profile=.false.

      if (profile) call timer%new(3,.false.)
      if (profile) call timer%measure(1,'bond/vdw/qq')
!     D2 C6
      c6( 1)=0.14; c6( 2)=0.08; c6( 3)=1.61; c6( 4)=1.61; c6( 5)=3.13
      c6( 6)=1.75; c6( 7)=1.23; c6( 8)=0.70; c6( 9)=0.75; c6(10)=0.63
      c6(11)=5.71; c6(12)=5.71; c6(13)=10.79; c6(14)=9.23; c6(15)=7.84
      c6(16)=5.57; c6(17)=5.07; c6(18)=4.61; c6(19:30)=10.8; c6(31)=16.99
      c6(32)=17.10; c6(33)=16.37; c6(34)=12.64; c6(35)=12.47; c6(36)=12.01
      c6(37:48)=24.67; c6(49)=37.32; c6(50)=38.71; c6(51)=38.44
      c6(52)=31.74; c6(53)=31.50; c6(54)=29.99

!hjw threshold reduced
      rZero=1.0d-10
      n3=3*nAtoms
!     Hess = 0.0d0

!
!     Hessian for tension
!
      do ibond=1,topo%nbond
         kAtom=topo%blist(1,ibond)
         lAtom=topo%blist(2,ibond)
         kr=iTabRow(iANr(kAtom))
         lr=iTabRow(iANr(lAtom))
            xkl=Cart(1,kAtom)-Cart(1,lAtom)
            ykl=Cart(2,kAtom)-Cart(2,lAtom)
            zkl=Cart(3,kAtom)-Cart(3,lAtom)
            rkl2 = xkl**2 + ykl**2 + zkl**2
            r0=rAv(kr,lr)
            alpha=aAv(kr,lr)
            gmm=Exp(-alpha*rkl2)*rkr*Exp(alpha*r0**2)
            Hxx=gmm*xkl*xkl/rkl2
            Hxy=gmm*xkl*ykl/rkl2
            Hxz=gmm*xkl*zkl/rkl2
            Hyy=gmm*ykl*ykl/rkl2
            Hyz=gmm*ykl*zkl/rkl2
            Hzz=gmm*zkl*zkl/rkl2
            Hess(Ind(1,kAtom,1,kAtom))=Hess(Ind(1,kAtom,1,kAtom))+Hxx
            Hess(Ind(2,kAtom,1,kAtom))=Hess(Ind(2,kAtom,1,kAtom))+Hxy
            Hess(Ind(2,kAtom,2,kAtom))=Hess(Ind(2,kAtom,2,kAtom))+Hyy
            Hess(Ind(3,kAtom,1,kAtom))=Hess(Ind(3,kAtom,1,kAtom))+Hxz
            Hess(Ind(3,kAtom,2,kAtom))=Hess(Ind(3,kAtom,2,kAtom))+Hyz
            Hess(Ind(3,kAtom,3,kAtom))=Hess(Ind(3,kAtom,3,kAtom))+Hzz
            Hess(Ind(1,kAtom,1,lAtom))=Hess(Ind(1,kAtom,1,lAtom))-Hxx
            Hess(Ind(1,kAtom,2,lAtom))=Hess(Ind(1,kAtom,2,lAtom))-Hxy
            Hess(Ind(1,kAtom,3,lAtom))=Hess(Ind(1,kAtom,3,lAtom))-Hxz
            Hess(Ind(2,kAtom,1,lAtom))=Hess(Ind(2,kAtom,1,lAtom))-Hxy
            Hess(Ind(2,kAtom,2,lAtom))=Hess(Ind(2,kAtom,2,lAtom))-Hyy
            Hess(Ind(2,kAtom,3,lAtom))=Hess(Ind(2,kAtom,3,lAtom))-Hyz
            Hess(Ind(3,kAtom,1,lAtom))=Hess(Ind(3,kAtom,1,lAtom))-Hxz
            Hess(Ind(3,kAtom,2,lAtom))=Hess(Ind(3,kAtom,2,lAtom))-Hyz
            Hess(Ind(3,kAtom,3,lAtom))=Hess(Ind(3,kAtom,3,lAtom))-Hzz
            Hess(Ind(1,lAtom,1,lAtom))=Hess(Ind(1,lAtom,1,lAtom))+Hxx
            Hess(Ind(2,lAtom,1,lAtom))=Hess(Ind(2,lAtom,1,lAtom))+Hxy
            Hess(Ind(2,lAtom,2,lAtom))=Hess(Ind(2,lAtom,2,lAtom))+Hyy
            Hess(Ind(3,lAtom,1,lAtom))=Hess(Ind(3,lAtom,1,lAtom))+Hxz
            Hess(Ind(3,lAtom,2,lAtom))=Hess(Ind(3,lAtom,2,lAtom))+Hyz
            Hess(Ind(3,lAtom,3,lAtom))=Hess(Ind(3,lAtom,3,lAtom))+Hzz
      End do
 
!
!     Hessian for Coulomb+dispersion
!

      do kAtom=1,nAtoms
         do lAtom=1,kAtom-1
            xkl=Cart(1,kAtom)-Cart(1,lAtom)
            ykl=Cart(2,kAtom)-Cart(2,lAtom)
            zkl=Cart(3,kAtom)-Cart(3,lAtom)
            rkl2 = xkl**2 + ykl**2 + zkl**2
            if(rkl2.gt.1600.d0) cycle
            c66=-s6*sqrt(c6(iANr(katom))*c6(iANr(latom))) ! D2 value
            rr=sqrt(rkl2)
            rr3=rr*rkl2
            r02=param%d3r0(lina(at(katom),at(latom)))
            rrpa=rr+sqrt(r02) ! qq damping with BJ radius
            cqq=2.0d0*topo%qa(kAtom)*topo%qa(lAtom) ! a bit upscaled
            call getqqxx(xkl,    cqq,c66,rr,rkl2,rr3,rrpa,r02,hxx)
            call getqqxy(xkl,ykl,cqq,c66,rr,rkl2,rr3,rrpa,r02,hxy)
            call getqqxy(xkl,zkl,cqq,c66,rr,rkl2,rr3,rrpa,r02,hxz)
            call getqqxx(ykl,    cqq,c66,rr,rkl2,rr3,rrpa,r02,hyy)
            call getqqxy(ykl,zkl,cqq,c66,rr,rkl2,rr3,rrpa,r02,hyz)
            call getqqxx(zkl,    cqq,c66,rr,rkl2,rr3,rrpa,r02,hzz)
            Hess(Ind(1,kAtom,1,kAtom))=Hess(Ind(1,kAtom,1,kAtom))+Hxx
            Hess(Ind(2,kAtom,1,kAtom))=Hess(Ind(2,kAtom,1,kAtom))+Hxy
            Hess(Ind(2,kAtom,2,kAtom))=Hess(Ind(2,kAtom,2,kAtom))+Hyy
            Hess(Ind(3,kAtom,1,kAtom))=Hess(Ind(3,kAtom,1,kAtom))+Hxz
            Hess(Ind(3,kAtom,2,kAtom))=Hess(Ind(3,kAtom,2,kAtom))+Hyz
            Hess(Ind(3,kAtom,3,kAtom))=Hess(Ind(3,kAtom,3,kAtom))+Hzz
            Hess(Ind(1,kAtom,1,lAtom))=Hess(Ind(1,kAtom,1,lAtom))-Hxx
            Hess(Ind(1,kAtom,2,lAtom))=Hess(Ind(1,kAtom,2,lAtom))-Hxy
            Hess(Ind(1,kAtom,3,lAtom))=Hess(Ind(1,kAtom,3,lAtom))-Hxz
            Hess(Ind(2,kAtom,1,lAtom))=Hess(Ind(2,kAtom,1,lAtom))-Hxy
            Hess(Ind(2,kAtom,2,lAtom))=Hess(Ind(2,kAtom,2,lAtom))-Hyy
            Hess(Ind(2,kAtom,3,lAtom))=Hess(Ind(2,kAtom,3,lAtom))-Hyz
            Hess(Ind(3,kAtom,1,lAtom))=Hess(Ind(3,kAtom,1,lAtom))-Hxz
            Hess(Ind(3,kAtom,2,lAtom))=Hess(Ind(3,kAtom,2,lAtom))-Hyz
            Hess(Ind(3,kAtom,3,lAtom))=Hess(Ind(3,kAtom,3,lAtom))-Hzz
            Hess(Ind(1,lAtom,1,lAtom))=Hess(Ind(1,lAtom,1,lAtom))+Hxx
            Hess(Ind(2,lAtom,1,lAtom))=Hess(Ind(2,lAtom,1,lAtom))+Hxy
            Hess(Ind(2,lAtom,2,lAtom))=Hess(Ind(2,lAtom,2,lAtom))+Hyy
            Hess(Ind(3,lAtom,1,lAtom))=Hess(Ind(3,lAtom,1,lAtom))+Hxz
            Hess(Ind(3,lAtom,2,lAtom))=Hess(Ind(3,lAtom,2,lAtom))+Hyz
            Hess(Ind(3,lAtom,3,lAtom))=Hess(Ind(3,lAtom,3,lAtom))+Hzz
         End Do
      End Do

      if (profile) call timer%measure(1)

!
!     Hessian for bending
!
      if (profile) call timer%measure(2,'bend')
      do iangl=1,topo%nangl
         mAtom=topo%alist(1,iangl)
         iAtom=topo%alist(2,iangl)
         jAtom=topo%alist(3,iangl)
         mr=iTabRow(iANr(mAtom))
         ir=iTabRow(iANr(iAtom))
         jr=iTabRow(iANr(jAtom))
 
            xmi=(Cart(1,iAtom)-Cart(1,mAtom))
            ymi=(Cart(2,iAtom)-Cart(2,mAtom))
            zmi=(Cart(3,iAtom)-Cart(3,mAtom))
            rmi2 = xmi**2 + ymi**2 + zmi**2
            rmi=sqrt(rmi2)
            r0mi=rAv(mr,ir)
            ami=aAv(mr,ir)
            xmj=(Cart(1,jAtom)-Cart(1,mAtom))
            ymj=(Cart(2,jAtom)-Cart(2,mAtom))
            zmj=(Cart(3,jAtom)-Cart(3,mAtom))
            rmj2 = xmj**2 + ymj**2 + zmj**2
            rmj=sqrt(rmj2)
            r0mj=rAv(mr,jr)
            amj=aAv(mr,jr)
            xij=(Cart(1,jAtom)-Cart(1,iAtom))
            yij=(Cart(2,jAtom)-Cart(2,iAtom))
            zij=(Cart(3,jAtom)-Cart(3,iAtom))
            rij2 = xij**2 + yij**2 + zij**2
            rrij=sqrt(rij2)

            alpha=rkf*exp((ami*r0mi**2+amj*r0mj**2))
            r=sqrt(rmj2+rmi2)
            gij=alpha*exp(-(ami*rmi2+amj*rmj2))
            rL2=(ymi*zmj-zmi*ymj)**2+(zmi*xmj-xmi*zmj)**2+&
     &         (xmi*ymj-ymi*xmj)**2
!hjw modified
            if(rL2.lt.1.d-14) then
              rL=0
            else
              rL=sqrt(rL2)
            end if
            if ((rmj.gt.rZero).and.(rmi.gt.rZero).and.&
     &                                (rrij.gt.rZero)) Then
              SinPhi=rL/(rmj*rmi)
              rmidotrmj=xmi*xmj+ymi*ymj+zmi*zmj
              CosPhi=rmidotrmj/(rmj*rmi)
!-------------None linear case
              If (SinPhi.gt.rZero) Then
                si(1)=(xmi/rmi*cosphi-xmj/rmj)/(rmi*sinphi)
                si(2)=(ymi/rmi*cosphi-ymj/rmj)/(rmi*sinphi)
                si(3)=(zmi/rmi*cosphi-zmj/rmj)/(rmi*sinphi)
                sj(1)=(cosphi*xmj/rmj-xmi/rmi)/(rmj*sinphi)
                sj(2)=(cosphi*ymj/rmj-ymi/rmi)/(rmj*sinphi)
                sj(3)=(cosphi*zmj/rmj-zmi/rmi)/(rmj*sinphi)
                sm(1)=-si(1)-sj(1)
                sm(2)=-si(2)-sj(2)
                sm(3)=-si(3)-sj(3)
                Do icoor=1,3
                   Do jCoor=1,3
                    If (mAtom.gt.iAtom) Then
                       Hess(Ind(icoor,mAtom,jcoor,iAtom))=&
     &                        Hess(Ind(icoor,mAtom,jcoor,iAtom))&
     &                        +gij*sm(icoor)*si(jcoor)
                    else
                      Hess(Ind(icoor,iAtom,jcoor,mAtom))=&
     &                        Hess(Ind(icoor,iAtom,jcoor,mAtom))&
     &                        +gij*si(icoor)*sm(jcoor)
                    End If
                    If (mAtom.gt.jAtom) Then
                        Hess(Ind(icoor,mAtom,jcoor,jAtom))=&
     &                        Hess(Ind(icoor,mAtom,jcoor,jAtom))&
     &                        +gij*sm(icoor)*sj(jcoor)
                    else
                      Hess(Ind(icoor,jAtom,jcoor,mAtom))=&
     &                        Hess(Ind(icoor,jAtom,jcoor,mAtom))&
     &                        +gij*sj(icoor)*sm(jcoor)
                    End If
                    If (iAtom.gt.jAtom) Then
                        Hess(Ind(icoor,iAtom,jcoor,jAtom))=&
     &                        Hess(Ind(icoor,iAtom,jcoor,jAtom))&
     &                        +gij*si(icoor)*sj(jcoor)
                     else
                        Hess(Ind(icoor,jAtom,jcoor,iAtom))=&
     &                        Hess(Ind(icoor,jAtom,jcoor,iAtom))&
     &                        +gij*sj(icoor)*si(jcoor)
                     End If
                   End Do
                End Do
                Do icoor=1,3
                  Do jCoor=1,icoor
                    Hess(Ind(icoor,iAtom,jcoor,iAtom))=&
     &                        Hess(Ind(icoor,iAtom,jcoor,iAtom))&
     &                        +gij*si(icoor)*si(jcoor)
                    Hess(Ind(icoor,mAtom,jcoor,mAtom))=&
     &                        Hess(Ind(icoor,mAtom,jcoor,mAtom))&
     &                        +gij*sm(icoor)*sm(jcoor)
                    Hess(Ind(icoor,jAtom,jcoor,jAtom))=&
     &                        Hess(Ind(icoor,jAtom,jcoor,jAtom))&
     &                        +gij*sj(icoor)*sj(jcoor)

                  End Do
                End Do
              Else
!----------------Linear case
                    if ((abs(ymi).gt.rZero).or.(abs(xmi).gt.rZero)) Then
                      x(1)=-ymi
                      y(1)=xmi
                      z(1)=Zero
                      x(2)=-xmi*zmi
                      y(2)=-ymi*zmi
                      z(2)=xmi*xmi+ymi*ymi
                    Else
                      x(1)=One
                      y(1)=Zero
                      z(1)=Zero
                      x(2)=Zero
                      y(2)=One
                      z(2)=Zero
                    End If
                    Do i=1,2
                     r1=sqrt(x(i)**2+y(i)**2+z(i)**2)
                     cosThetax=x(i)/r1
                     cosThetay=y(i)/r1
                     cosThetaz=z(i)/r1
                     si(1)=-cosThetax/rmi
                     si(2)=-cosThetay/rmi
                     si(3)=-cosThetaz/rmi
                     sj(1)=-cosThetax/rmj
                     sj(2)=-cosThetay/rmj
                     sj(3)=-cosThetaz/rmj
                     sm(1)=-(si(1)+sj(1))
                     sm(2)=-(si(2)+sj(2))
                     sm(3)=-(si(3)+sj(3))
                     Do icoor=1,3
                       Do jCoor=1,3
                        If (mAtom.gt.iAtom) Then
                          Hess(Ind(icoor,mAtom,jcoor,iAtom))=&
     &                        Hess(Ind(icoor,mAtom,jcoor,iAtom))&
     &                         +gij*sm(icoor)*si(jcoor)
                        else
                           Hess(Ind(icoor,iAtom,jcoor,mAtom))=&
     &                        Hess(Ind(icoor,iAtom,jcoor,mAtom))&
     &                         +gij*si(icoor)*sm(jcoor)
                        End If
                        If (mAtom.gt.jAtom) Then
                          Hess(Ind(icoor,mAtom,jcoor,jAtom))=&
     &                        Hess(Ind(icoor,mAtom,jcoor,jAtom))&
     &                         +gij*sm(icoor)*sj(jcoor)
                        else
                          Hess(Ind(icoor,jAtom,jcoor,mAtom))=&
     &                        Hess(Ind(icoor,jAtom,jcoor,mAtom))&
     &                         +gij*sj(icoor)*sm(jcoor)
                        End If
                        If (iAtom.gt.jAtom) Then
                           Hess(Ind(icoor,iAtom,jcoor,jAtom))=&
     &                        Hess(Ind(icoor,iAtom,jcoor,jAtom))&
     &                         +gij*si(icoor)*sj(jcoor)
                        else
                           Hess(Ind(icoor,jAtom,jcoor,iAtom))=&
     &                        Hess(Ind(icoor,jAtom,jcoor,iAtom))&
     &                         +gij*sj(icoor)*si(jcoor)
                        End If
                       End Do
                     End Do
                     Do icoor=1,3
                       Do jCoor=1,icoor
                         Hess(Ind(icoor,iAtom,jcoor,iAtom))=&
     &                        Hess(Ind(icoor,iAtom,jcoor,iAtom))&
     &                         +gij*si(icoor)*si(jcoor)
                         Hess(Ind(icoor,mAtom,jcoor,mAtom))=&
     &                        Hess(Ind(icoor,mAtom,jcoor,mAtom))&
     &                         +gij*sm(icoor)*sm(jcoor)
                         Hess(Ind(icoor,jAtom,jcoor,jAtom))=&
     &                         Hess(Ind(icoor,jAtom,jcoor,jAtom))&
     &                         +gij*sj(icoor)*sj(jcoor)
                       End Do
                     End Do
                 End Do
              End If
            End If
      End Do ! bend list

      if (profile) call timer%measure(2)

!
!     Hessian for torsion
!
      if (profile) call timer%measure(3,'torsion')
      do itors=1,topo%ntors
         iAtom=topo%tlist(3,itors)
         jAtom=topo%tlist(1,itors)
         kAtom=topo%tlist(2,itors)
         lAtom=topo%tlist(4,itors)

                 ir=iTabRow(iANr(iAtom))
                 jr=iTabRow(iANr(jAtom))
                 kr=iTabRow(iANr(kAtom))
                 lr=iTabRow(iANr(lAtom))
                 Call DCopy(3,Cart(1,iAtom),1,xyz(1,1),1)
                 Call DCopy(3,Cart(1,jAtom),1,xyz(1,2),1)
                 Call DCopy(3,Cart(1,kAtom),1,xyz(1,3),1)
                 Call DCopy(3,Cart(1,lAtom),1,xyz(1,4),1)
                 rij(1)=Cart(1,iAtom)-Cart(1,jAtom)
                 rij(2)=Cart(2,iAtom)-Cart(2,jAtom)
                 rij(3)=Cart(3,iAtom)-Cart(3,jAtom)
                 rij0=rAv(ir,jr)**2
                 aij =aAv(ir,jr)
                 rjk(1)=Cart(1,jAtom)-Cart(1,kAtom)
                 rjk(2)=Cart(2,jAtom)-Cart(2,kAtom)
                 rjk(3)=Cart(3,jAtom)-Cart(3,kAtom)
                 rjk0=rAv(jr,kr)**2
                 ajk =aAv(jr,kr)
                 rkl(1)=Cart(1,kAtom)-Cart(1,lAtom)
                 rkl(2)=Cart(2,kAtom)-Cart(2,lAtom)
                 rkl(3)=Cart(3,kAtom)-Cart(3,lAtom)
                 rkl0=rAv(kr,lr)**2
                 akl =aAv(kr,lr)
                 rij2=rij(1)**2+rij(2)**2+rij(3)**2
                 rjk2=rjk(1)**2+rjk(2)**2+rjk(3)**2
                 rkl2=rkl(1)**2+rkl(2)**2+rkl(3)**2

               beta=rkt*exp( (aij*rij0+ajk*rjk0+akl*rkl0))
               tij=beta*exp(-(aij*rij2+ajk*rjk2+akl*rkl2))

               Call Trsn(xyz,4,Tau,C,.False.,.False.,'        ',Dum,.False.)
               Call DCopy(3,C(1,1),1,si,1)
               Call DCopy(3,C(1,2),1,sj,1)
               Call DCopy(3,C(1,3),1,sk,1)
               Call DCopy(3,C(1,4),1,sl,1)
!-------------Off diagonal block
              Do icoor=1,3
                Do jCoor=1,3
                 Hess(Ind(icoor,iAtom,jcoor,jAtom))=&
     &           Hess(Ind(icoor,iAtom,jcoor,jAtom))&
     &            +tij*si(icoor) * sj(jcoor)
                 Hess(Ind(icoor,iAtom,jcoor,kAtom))=&
     &           Hess(Ind(icoor,iAtom,jcoor,kAtom))&
     &            +tij*si(icoor) * sk(jcoor)
                 Hess(Ind(icoor,iAtom,jcoor,lAtom))=&
     &           Hess(Ind(icoor,iAtom,jcoor,lAtom))&
     &            +tij*si(icoor) * sl(jcoor)
                 Hess(Ind(icoor,jAtom,jcoor,kAtom))=&
     &           Hess(Ind(icoor,jAtom,jcoor,kAtom))&
     &            +tij*sj(icoor) * sk(jcoor)
                 Hess(Ind(icoor,jAtom,jcoor,lAtom))=&
     &           Hess(Ind(icoor,jAtom,jcoor,lAtom))&
     &            +tij*sj(icoor) * sl(jcoor)
                 Hess(Ind(icoor,kAtom,jcoor,lAtom))=&
     &           Hess(Ind(icoor,kAtom,jcoor,lAtom))&
     &            +tij*sk(icoor) * sl(jcoor)

                End Do
              End Do
!-------------Diagonal block
              Do icoor=1,3
                Do jCoor=1,icoor
                 Hess(Ind(icoor,iAtom,jcoor,iAtom))=&
     &           Hess(Ind(icoor,iAtom,jcoor,iAtom))&
     &            +tij*si(icoor) * si(jcoor)
                 Hess(Ind(icoor,jAtom,jcoor,jAtom))=&
     &           Hess(Ind(icoor,jAtom,jcoor,jAtom))&
     &            +tij*sj(icoor) * sj(jcoor)
                 Hess(Ind(icoor,kAtom,jcoor,kAtom))=&
     &           Hess(Ind(icoor,kAtom,jcoor,kAtom))&
     &            +tij*sk(icoor) * sk(jcoor)
                 Hess(Ind(icoor,lAtom,jcoor,lAtom))=&
     &           Hess(Ind(icoor,lAtom,jcoor,lAtom))&
     &            +tij*sl(icoor) * sl(jcoor)

                 End Do
               End Do
 
      enddo ! tors list

      if (profile) call timer%measure(3)
      if (profile) call timer%write(6,'modhes')
      Return
      End

! Coulomb + dispersion Hessian (SG, 5/19)
! d/(dxdx)  q*q/(damp+r),  rpa=damp+r
! d/(dxdx)   c6/(r02^3+r^6)
      subroutine getqqxx(dx,qq,c6,r,r2,r3,rpa,r02,d2)      
      implicit none
      real*8 dx,qq,c6,r,r2,r3,rpa,r02,d2
      real*8 rpa2,dx2,ar6,r6,r8

!     Coulomb part
      rpa2=rpa**2
      dx2 = dx**2
      d2  = qq*(2.d0*dx2/(r2*rpa*rpa2) + dx2/(r3*rpa2) - 1.d0/(r*rpa2))
!     disp part
      r6  = r3*r3
      r8  = r6*r2
      ar6 = r02**3+r6
      d2  = d2 + c6*(dx2*72.d0*r8/ar6**3 - dx2*24.d0*r2/ar6**2 &
     &         - 6.d0*r2*r2/ar6**2)
      end

! d/(dxdy)  q*q/(damp+r),  rpa=damp+r
! d/(dxdy)   c6/(r02^3+r^6)
      subroutine getqqxy(dx,dy,qq,c6,r,r2,r3,rpa,r02,d2)      
      implicit none
      real*8 dx,dy,qq,c6,r,r2,r3,rpa,r02,d2
      real*8 rpa2,r6,r8,ar6

!     Coulomb part
      rpa2=rpa**2
      d2  =qq*(2.d0*dx*dy/(r2*rpa*rpa2) + dx*dy/(r3*rpa2))
!     disp part
      r6  = r3*r3
      r8  = r6*r2
      ar6 = r02**3+r6
      d2  = d2 + c6*(dx*dy*72.d0*r8/ar6**3 - dx*dy*24.d0*r2/ar6**2)

      end

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Implementation of the xTB core Hamiltonian
module xtb_xtb_hamiltonian
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants, only : pi
   use xtb_mctc_convert, only : evtoau
   use xtb_xtb_data, only : THamiltonianData
   use xtb_intgrad
   use xtb_lin
   use xtb_scc_core, only : shellPoly, h0scal
   use xtb_grad_core, only : dshellPoly
   implicit none
   private

   public :: getSelfEnergy, build_SDQH0, build_dSDQH0, build_dSDQH0_noreset
   public :: count_dpint, count_qpint


   interface getSelfEnergy
      module procedure :: getSelfEnergyFlat
      module procedure :: getSelfEnergy2D
   end interface getSelfEnergy


   integer,private, parameter :: llao (0:3) = (/ 1, 3, 6,10/)
   integer,private, parameter :: llao2(0:3) = (/ 1, 3, 5, 7/)

contains


subroutine getSelfEnergyFlat(hData, nShell, at, cn, qat, selfEnergy, dSEdcn, dSEdq)
   type(THamiltonianData), intent(in) :: hData
   integer, intent(in) :: nShell(:)
   integer, intent(in) :: at(:)
   real(wp), intent(in), optional :: cn(:)
   real(wp), intent(in), optional :: qat(:)
   real(wp), intent(out) :: selfEnergy(:)
   real(wp), intent(out), optional :: dSEdcn(:)
   real(wp), intent(out), optional :: dSEdq(:)

   integer :: ind, iAt, iZp, iSh

   selfEnergy(:) = 0.0_wp
   if (present(dSEdcn)) dSEdcn(:) = 0.0_wp
   if (present(dSEdq)) dSEdq(:) = 0.0_wp
   ind = 0
   do iAt = 1, size(cn)
      iZp = at(iAt)
      do iSh = 1, nShell(iZp)
         selfEnergy(ind+iSh) = hData%selfEnergy(iSh, iZp)
      end do
      ind = ind + nShell(iZp)
   end do
   if (present(dSEdcn) .and. present(cn)) then
      ind = 0
      do iAt = 1, size(cn)
         iZp = at(iAt)
         do iSh = 1, nShell(iZp)
            selfEnergy(ind+iSh) = selfEnergy(ind+iSh) &
               & - hData%kCN(iSh, iZp) * cn(iAt)
            dSEdcn(ind+iSh) = -hData%kCN(iSh, iZp)
         end do
         ind = ind + nShell(iZp)
      end do
   end if
   if (present(dSEdq) .and. present(qat)) then
      ind = 0
      do iAt = 1, size(cn)
         iZp = at(iAt)
         do iSh = 1, nShell(iZp)
            selfEnergy(ind+iSh) = selfEnergy(ind+iSh) &
               & - hData%kQShell(iSh,iZp)*qat(iAt) - hData%kQAtom(iZp)*qat(iAt)**2
            dSEdq(ind+iSh) = -hData%kQShell(iSh,iZp) - hData%kQAtom(iZp)*2*qat(iAt)
         end do
         ind = ind + nShell(iZp)
      end do
   end if

end subroutine getSelfEnergyFlat


subroutine getSelfEnergy2D(hData, nShell, at, cn, qat, selfEnergy, dSEdcn, dSEdq)
   type(THamiltonianData), intent(in) :: hData
   integer, intent(in) :: nShell(:)
   integer, intent(in) :: at(:)
   real(wp), intent(in), optional :: cn(:)
   real(wp), intent(in), optional :: qat(:)
   real(wp), intent(out) :: selfEnergy(:, :)
   real(wp), intent(out), optional :: dSEdcn(:, :)
   real(wp), intent(out), optional :: dSEdq(:, :)

   integer :: iAt, iZp, iSh

   selfEnergy(:, :) = 0.0_wp
   if (present(dSEdcn)) dSEdcn(:, :) = 0.0_wp
   if (present(dSEdq)) dSEdq(:, :) = 0.0_wp
   do iAt = 1, size(cn)
      iZp = at(iAt)
      do iSh = 1, nShell(iZp)
         selfEnergy(iSh, iAt) = hData%selfEnergy(iSh, iZp)
      end do
   end do
   if (present(dSEdcn) .and. present(cn)) then
      do iAt = 1, size(cn)
         iZp = at(iAt)
         do iSh = 1, nShell(iZp)
            selfEnergy(iSh, iAt) = selfEnergy(iSh, iAt) &
               & - hData%kCN(iSh, iZp) * cn(iAt)
            dSEdcn(iSh, iAt) = -hData%kCN(iSh, iZp)
         end do
      end do
   end if
   if (present(dSEdq) .and. present(qat)) then
      do iAt = 1, size(cn)
         iZp = at(iAt)
         do iSh = 1, nShell(iZp)
            selfEnergy(iSh, iAt) = selfEnergy(iSh, iAt) &
               & - hData%kQShell(iSh,iZp)*qat(iAt) - hData%kQAtom(iZp)*qat(iAt)**2
            dSEdq(iSh, iAt) = -hData%kQShell(iSh,iZp) &
               & - hData%kQAtom(iZp)*2*qat(iAt)
         end do
      end do
   end if

end subroutine getSelfEnergy2D


!> Computes the dipole and quadrupole integrals and performs screening to
!  determine, which contribute to potential
subroutine build_SDQH0(nShell, hData, nat, at, nbf, nao, xyz, trans, selfEnergy, &
      & intcut, caoshell, saoshell, nprim, primcount, alp, cont, &
      & sint, dpint, qpint, H0)
   implicit none
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   !> # of atoms
   integer, intent(in)  :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)  :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)  :: nbf
   integer, intent(in)  :: at(nat)
   !> Cartesian coordinates
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(in)    :: trans(:, :)
   real(wp), intent(in) :: selfEnergy(:, :)
   !> Integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)  :: intcut
   !> Map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)  :: caoshell(:,:)
   !> Map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)  :: saoshell(:,:)
   integer, intent(in)  :: nprim(:)
   !> Index of first primitive (over entire system) of given CAO
   integer, intent(in)  :: primcount(:)
   real(wp),intent(in)  :: alp(:)
   real(wp),intent(in)  :: cont(:)
   !> Overlap integral matrix
   real(wp),intent(out) :: sint(nao,nao)
   !> Dipole integral matrix
   real(wp),intent(out) :: dpint(3,nao,nao)
   !> Quadrupole integral matrix
   real(wp),intent(out) :: qpint(6,nao,nao)
   !> Core Hamiltonian
   real(wp),intent(out) :: H0(:)


   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij
   real(wp) tmp1,tmp2,tmp3,tmp4,step,step2
   real(wp) dx,dy,dz,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,thr2,f,ci,cc,cj,alpi,rab2,ab,est

   real(wp)  ra(3),rb(3),f1,f2,point(3)
   real(wp) dtmp(3),qtmp(6),ss(6,6),dd(3,6,6),qq(6,6,6),tmp(6,6)
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,jshmax
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   integer :: il, jl, itr
   real(wp) :: zi, zj, zetaij, km, hii, hjj, hav, shpoly
   integer itt(0:3)
   parameter(itt  =(/0,1,4,10/))
   real(wp) :: saw(10)


   ! integrals
   H0(:) = 0.0_wp
   sint = 0.0_wp
   dpint = 0.0_wp
   qpint = 0.0_wp
   ! --- Aufpunkt for moment operator
   point = 0.0_wp

   !$omp parallel do default(none) schedule(dynamic) &
   !$omp shared(nat, xyz, at, nShell, hData, selfEnergy, caoshell, saoshell, &
   !$omp& nprim, primcount, alp, cont, intcut, trans, point) &
   !$omp private (iat,jat,izp,ci,ra,rb,saw, &
   !$omp& rab2,jzp,ish,ishtyp,icao,naoi,iptyp, &
   !$omp& jsh,jshmax,jshtyp,jcao,naoj,jptyp,ss,dd,qq,shpoly, &
   !$omp& est,alpi,alpj,ab,iprim,jprim,ip,jp,il,jl,hii,hjj,km,zi,zj,zetaij,hav, &
   !$omp& mli,mlj,tmp,tmp1,tmp2,iao,jao,ii,jj,k,ij,itr) &
   !$omp shared(sint,dpint,qpint,H0)
   do iat = 1, nat
      ra(1:3) = xyz(1:3,iat)
      izp = at(iat)
      do jat = 1, iat-1
         jzp = at(jat)
         do ish = 1, nShell(izp)
            ishtyp = hData%angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            do jsh = 1, nShell(jzp)
               jshtyp = hData%angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, izp)
               zj = hData%slaterExponent(jsh, jzp)
               zetaij = (2 * sqrt(zi*zj)/(zi+zj))**hData%wExp
               call h0scal(hData,il,jl,izp,jzp,hData%valenceShell(ish, izp).ne.0, &
                  & hData%valenceShell(jsh, jzp).ne.0,km)

               hav = 0.5_wp * km * (hii + hjj) * zetaij

               do itr = 1, size(trans, dim=2)
                  rb(1:3) = xyz(1:3,jat) + trans(:, itr)
                  rab2 = sum( (rb-ra)**2 )

                  ! distance dependent polynomial
                  shpoly=shellPoly(hData%shellPoly(il,izp),hData%shellPoly(jl,jzp),&
                     &             hData%atomicRad(izp),hData%atomicRad(jzp),ra,rb)

                  ss = 0.0_wp
                  dd = 0.0_wp
                  qq = 0.0_wp
                  call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,rb,point, &
                     &               intcut,nprim,primcount,alp,cont,ss,dd,qq)
                  !transform from CAO to SAO
                  call dtrf2(ss,ishtyp,jshtyp)
                  do k = 1,3
                     tmp(1:6,1:6) = dd(k,1:6,1:6)
                     call dtrf2(tmp,ishtyp,jshtyp)
                     dd(k,1:6,1:6) = tmp(1:6,1:6)
                  enddo
                  do k = 1,6
                     tmp(1:6,1:6) = qq(k,1:6,1:6)
                     call dtrf2(tmp,ishtyp,jshtyp)
                     qq(k,1:6,1:6) = tmp(1:6,1:6)
                  enddo
                  do ii = 1,llao2(ishtyp)
                     iao = ii+saoshell(ish,iat)
                     do jj = 1,llao2(jshtyp)
                        jao = jj+saoshell(jsh,jat)
                        ij = lin(iao, jao)
                        H0(ij) = H0(ij) + hav * shpoly * ss(jj, ii)
                        !sint(iao, jao) = sint(iao, jao) + ss(jj, ii)
                        sint(jao, iao) = sint(jao, iao) + ss(jj, ii)
                        !dpint(:, iao, jao) = dpint(:, iao, jao) + dd(:, jj, ii)
                        dpint(:, jao, iao) = dpint(:, jao, iao) + dd(:, jj, ii)
                        !qpint(:, iao, jao) = qpint(:, iao, jao) + qq(:, jj, ii)
                        qpint(:, jao, iao) = qpint(:, jao, iao) + qq(:, jj, ii)
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
   enddo
   !$omp parallel do default(none) shared(nao, sint, dpint, qpint) private(iao, jao)
   do iao = 1, nao
      do jao = 1, iao - 1
         sint(iao, jao) = sint(jao, iao)
         dpint(:, iao, jao) = dpint(:, jao, iao)
         qpint(:, iao, jao) = qpint(:, jao, iao)
      end do
   end do

   ! diagonal elements
   !$omp parallel do default(none) schedule(dynamic) &
   !$omp shared(H0, sint, dpint, qpint) &
   !$omp shared(nat, xyz, at, nShell, hData, saoshell, selfEnergy, caoshell, &
   !$omp& point, intcut, nprim, primcount, alp, cont) &
   !$omp private(iat, ra, izp, ish, ishtyp, iao, i, ii, icao, naoi, iptyp, &
   !$omp& jsh, jshtyp, jcao, ss, dd, qq, k, tmp, jao, jj, naoj, jptyp)
   do iat = 1, nat
      ra = xyz(:, iat)
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = hData%angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)
            ii = i*(1+i)/2
            sint(i,i) = 1.0_wp + sint(i,i)
            H0(ii) = H0(ii) + selfEnergy(ish, iat)
         end do

         icao = caoshell(ish,iat)
         naoi = llao(ishtyp)
         iptyp = itt(ishtyp)
         do jsh = 1, ish
            jshtyp = hData%angShell(jsh,izp)
            jcao = caoshell(jsh,iat)
            naoj = llao(jshtyp)
            jptyp = itt(jshtyp)
            ss = 0.0_wp
            dd = 0.0_wp
            qq = 0.0_wp
            call get_multiints(icao,jcao,naoi,naoj,ishtyp,jshtyp,ra,ra,point, &
               &               intcut,nprim,primcount,alp,cont,ss,dd,qq)
            !transform from CAO to SAO
            !call dtrf2(ss,ishtyp,jshtyp)
            do k = 1,3
               tmp(1:6, 1:6) = dd(k,1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               dd(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do k = 1,6
               tmp(1:6, 1:6) = qq(k, 1:6, 1:6)
               call dtrf2(tmp, ishtyp, jshtyp)
               qq(k, 1:6, 1:6) = tmp(1:6, 1:6)
            enddo
            do ii = 1, llao2(ishtyp)
               iao = ii + saoshell(ish,iat)
               do jj = 1, llao2(jshtyp)
                  jao = jj + saoshell(jsh,iat)
                  if (jao > iao .and. ish ==  jsh) cycle
                  dpint(1:3, iao, jao) = dpint(1:3, iao, jao) + dd(1:3, jj, ii)
                  if (iao /= jao) then
                     dpint(1:3, jao, iao) = dpint(1:3, jao, iao) + dd(1:3, jj, ii)
                  end if
                  qpint(1:6, iao, jao) = qpint(1:6, iao, jao) + qq(1:6, jj, ii)
                  if (jao /= iao) then
                     qpint(1:6, jao, iao) = qpint(1:6, jao, iao) + qq(1:6, jj, ii)
                  end if
               end do
            end do
         end do
      end do
   end do

end subroutine build_SDQH0


!> Computes the gradient of the dipole/qpole integral contribution
subroutine build_dSDQH0(nShell, hData, selfEnergy, dSEdcn, intcut, nat, nao, nbf, &
      & at, xyz, trans, caoshell, saoshell, nprim, primcount, alp, cont, &
      & p, Pew, ves, vs, vd, vq, dhdcn, g, sigma)
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   real(wp), intent(in) :: selfEnergy(:, :)
   real(wp), intent(in) :: dSEdcn(:, :)
   !> # of atoms
   integer, intent(in)    :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)    :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)    :: nbf
   !> Atomic numbers of atoms
   integer, intent(in)    :: at(nat)
   !> Integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)    :: intcut
   real(wp),intent(in)    :: ves(:, :)
   real(wp),intent(in)    :: vs(nat)
   real(wp),intent(in)    :: vd(3,nat)
   real(wp),intent(in)    :: vq(6,nat)
   !> Cartesian coordinates
   real(wp),intent(in)    :: xyz(3,nat)
   real(wp),intent(in)    :: trans(:, :)
   !> Map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)    :: caoshell(:,:)
   !> Map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)    :: saoshell(:,:)
   integer, intent(in)    :: nprim(:)
   !> Index of first primitive (over entire system) of given CAO, dimension: nbf
   integer, intent(in)    :: primcount(:)
   real(wp),intent(in)    :: alp(:)
   real(wp),intent(in)    :: cont(:)
   !> Density matrix
   real(wp),intent(in) :: p(:, :)
   !> Energy weighted density matrix
   real(wp),intent(in) :: Pew(:, :)
   real(wp),intent(inout) :: g(:, :)
   real(wp),intent(inout) :: sigma(:, :)
   real(wp),intent(inout) :: dhdcn(:)

   integer itt(0:3)
   parameter (itt=(/0,1,4,10/))
   real(wp) tmp1,tmp2,tmp3,step,step2,step3,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,thr2,f,ci,cj,alpi,rij2,ab,est
   real(wp) f1,f2,point(3),tmp(6,6),rij(3),ri(3),rj(3)
   real(wp) stmp,ral(3,3),rar(3,3),rbl(3,3),pre
   real(wp) dtmp,qtmp,rbr(3,3),r2l(3),r2r(3),qqa(6,6,6,3)
   real(wp)  ss(6,6,3),ddc(3,6,6,3),qqc(6,6,6,3),dda(3,6,6,3)
   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij,jshmax
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,ixyz
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   real(wp) :: dumdum(3,10),dum(10),sdq(10,6,6),sdqg(3,19,6,6)
   integer :: il, jl, itr
   real(wp) :: zi, zj, zetaij, km, hii, hjj, hav, shpoly, dshpoly(3)
   real(wp) :: Pij, Hij, HPij, g_xyz(3)
   real(wp), parameter :: rthr = 1600.0_wp

   thr2 = intcut
   point = 0.0_wp
   ! call timing(t1,t3)
   !$omp parallel do default(none) schedule(dynamic) &
   !$omp shared(nat, at, xyz, trans, nShell, hData, selfEnergy, dSEdcn, P, Pew, &
   !$omp& ves, vs, vd, vq, intcut, nprim, primcount, caoshell, saoshell, alp, cont) &
   !$omp private(iat,jat,ixyz,izp,ci,rij2,jzp,ish,ishtyp, &
   !$omp& icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp, &
   !$omp& sdq,sdqg,est,alpi,alpj,ab,iprim,jprim,ip,jp,ri,rj,rij,km,shpoly,dshpoly, &
   !$omp& mli,mlj,dum,dumdum,tmp,stmp,dtmp,qtmp,il,jl,zi,zj,zetaij,hii,hjj,hav, &
   !$omp& iao,jao,ii,jj,k,pij,hij,hpij,g_xyz,itr) &
   !$omp reduction(+:g,sigma,dhdcn)
   do iat = 1,nat
      ri = xyz(:,iat)
      izp = at(iat)
      do jat = 1,iat-1
         !           if (jat.eq.iat) cycle
         jzp = at(jat)

         do ish = 1,nShell(izp)
            ishtyp = hData%angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(jzp)
            !              if(iat.eq.jat) jshmax = ish
            do jsh = 1,jshmax ! jshells
               jshtyp = hData%angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! we scale the two shells depending on their exponent
               zi = hData%slaterExponent(ish, izp)
               zj = hData%slaterExponent(jsh, jzp)
               zetaij = (2 * sqrt(zi*zj)/(zi+zj))**hData%wExp
               call h0scal(hData,il,jl,izp,jzp,hData%valenceShell(ish, izp).ne.0, &
                  & hData%valenceShell(jsh, jzp).ne.0,km)

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * km * (hii + hjj) * zetaij * evtoau

               do itr = 1, size(trans, dim=2)
                  rj = xyz(:,jat) + trans(:, itr)
                  rij = ri - rj
                  rij2 =  sum( rij**2 )

                  if (rij2 > rthr) cycle

                  ! distance dependent polynomial
                  call dshellPoly(hData%shellPoly(il,izp),hData%shellPoly(jl,jzp),&
                     & hData%atomicRad(izp),hData%atomicRad(jzp),rij2,ri,rj,&
                     & shpoly,dshpoly)

                  sdqg = 0;sdq = 0
                  call get_grad_multiint(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj, &
                     &                   intcut,nprim,primcount,alp,cont,sdq,sdqg)
                  tmp(1:6,1:6) = sdq(1,1:6,1:6)
                  call dtrf2(tmp,ishtyp,jshtyp)
                  sdq(1,1:6,1:6) = tmp(1:6,1:6)
                  do k = 1,19 ! 1 S, 2-4 D, 5-10 Q, 11-13 D, 14-19 Q
                     do ixyz = 1,3
                        ! transform from CAO to SAO
                        !                        call dtrf2(sdqg(ixyz,k,1:6,1:6),ishtyp,jshtyp)
                        tmp(1:6,1:6) = sdqg(ixyz,k,1:6,1:6)
                        call dtrf2(tmp,ishtyp,jshtyp)
                        sdqg(ixyz,k,1:6,1:6) = tmp(1:6,1:6)
                     enddo
                  enddo
                  g_xyz(:) = 0.0_wp
                  do ii = 1,llao2(ishtyp)
                     iao = ii+saoshell(ish,iat)
                     do jj = 1,llao2(jshtyp)
                        jao = jj+saoshell(jsh,jat)
                        Pij = p(jao,iao)

                        ! Hamiltonian element without overlap
                        Hij  = hav * shpoly
                        HPij = Hij * Pij

                        g_xyz(:) = g_xyz + 2*HPij*sdq(1,jj,ii)*dshpoly/shpoly

                        do ixyz = 1,3
                           stmp = sdqg(ixyz,1,jj,ii)*(2*HPij - 2*Pew(jao, iao) &
                              & -Pij*(ves(ish,iat)+ves(jsh,jat)) &
                              & +Pij*(vs(iat)+vs(jat)))
                           dtmp = Pij*sum(sdqg(ixyz,11:13,jj,ii)*vd(1:3,iat) &
                              & +sdqg(ixyz, 2:4, jj,ii)*vd(1:3,jat) )
                           qtmp = Pij*sum( sdqg(ixyz,14:19,jj,ii)*vq(1:6,iat) &
                              & +sdqg(ixyz, 5:10,jj,ii)*vq(1:6,jat) )
                           g_xyz(ixyz) = g_xyz(ixyz)+stmp+dtmp+qtmp

                        enddo ! ixyz

                        ! Hamiltonian without Hav
                        HPij = km * zetaij * shpoly * Pij * sdq(1,jj,ii) * evtoau
                        ! save dE/dCN for CNi
                        dhdcn(iat) = dhdcn(iat) + HPij*dSEdcn(ish, iat)
                        ! save dE/dCN for CNj
                        dhdcn(jat) = dhdcn(jat) + HPij*dSEdcn(jsh, jat)
                     enddo
                  enddo
                  g(:,iat) = g(:,iat)+g_xyz
                  g(:,jat) = g(:,jat)-g_xyz
                  sigma(:, :) = sigma + spread(g_xyz, 1, 3) * spread(rij, 2, 3)
               enddo ! lattice translations
            enddo ! jsh : loop over shells on jat
         enddo  ! ish : loop over shells on iat
      enddo ! jat
   enddo  ! iat

   ! diagonal contributions
   !$omp parallel do default(none) schedule(dynamic) reduction(+:dhdcn) &
   !$omp shared(nat, at, nshell, hData, saoshell, P, dSEdcn) &
   !$omp private(iat, izp, ish, ishtyp, iao, i, Pij)
   do iat = 1, nat
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = hData%angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)

            Pij = P(i,i)
            ! save dE/dCN for CNi
            dhdcn(iat) = dhdcn(iat) + Pij*dSEdcn(ish, iat)*evtoau
         end do
      end do
   end do

end subroutine build_dSDQH0


!> Computes the gradient of the dipole/qpole integral contribution
subroutine build_dSDQH0_noreset(nShell, hData, selfEnergy, dSEdcn, intcut, &
      & nat, nao, nbf, at, xyz, caoshell, saoshell, nprim, primcount, &
      & alp, cont, H0, S, p, Pew, ves, vs, vd, vq, dhdcn, g, sigma)
   integer, intent(in) :: nShell(:)
   type(THamiltonianData), intent(in) :: hData
   real(wp), intent(in) :: selfEnergy(:, :)
   real(wp), intent(in) :: dSEdcn(:, :)
   !> # of atoms
   integer, intent(in)    :: nat
   !> # of spherical AOs (SAOs)
   integer, intent(in)    :: nao
   !> # of Cartesian AOs (CAOs)
   integer, intent(in)    :: nbf
   !> Atomic numbers of atoms
   integer, intent(in)    :: at(nat)
   !> Integral cutoff according to prefactor from Gaussian product theorem
   real(wp),intent(in)    :: intcut
   real(wp),intent(in)    :: ves(:, :)
   real(wp),intent(in)    :: vs(nat)
   real(wp),intent(in)    :: vd(3,nat)
   real(wp),intent(in)    :: vq(6,nat)
   !> Cartesian coordinates
   real(wp),intent(in)    :: xyz(3,nat)
   !> Map shell of atom to index in CAO space (lowest Cart. component is taken)
   integer, intent(in)    :: caoshell(:,:)
   !> Map shell of atom to index in SAO space (lowest m_l component is taken)
   integer, intent(in)    :: saoshell(:,:)
   integer, intent(in)    :: nprim(:)
   !> Index of first primitive (over entire system) of given CAO, dimension: nbf
   integer, intent(in)    :: primcount(:)
   real(wp),intent(in)    :: alp(:)
   real(wp),intent(in)    :: cont(:)
   !> Molecular Hamiltonian
   real(wp),intent(in) :: H0(:, :)
   !> Molecular Overlap
   real(wp),intent(in) :: S(:, :)
   !> Density matrix
   real(wp),intent(in) :: p(:, :)
   !> Energy weighted density matrix
   real(wp),intent(in) :: Pew(:, :)
   real(wp),intent(inout) :: g(:, :)
   real(wp),intent(inout) :: sigma(:, :)
   real(wp),intent(inout) :: dhdcn(:)

   integer itt(0:3)
   parameter (itt=(/0,1,4,10/))
   real(wp) tmp1,tmp2,tmp3,step,step2,step3,s00r,s00l,s00,alpj
   real(wp) skj,r1,r2,tt,t1,t2,t3,t4,thr2,f,ci,cj,alpi,rij2,ab,est
   real(wp) f1,f2,point(3),tmp(6,6),rij(3),ri(3),rj(3)
   real(wp) stmp,ral(3,3),rar(3,3),rbl(3,3),pre
   real(wp) dtmp,qtmp,rbr(3,3),r2l(3),r2r(3),qqa(6,6,6,3)
   real(wp)  ss(6,6,3),ddc(3,6,6,3),qqc(6,6,6,3),dda(3,6,6,3)
   integer i,j,k,l,m,ii,jj,ll,mm,kk,ki,kj,kl,mi,mj,ij,jshmax
   integer ip,jp,iat,jat,izp,jzp,ish,jsh,icao,jcao,iao,jao,ixyz
   integer ishtyp,jshtyp,iptyp,jptyp,naoi,naoj,mli,mlj,iprim,jprim
   real(wp) :: dumdum(3,10),dum(10),sdq(10,6,6),sdqg(3,19,6,6)
   integer :: il, jl, itr
   real(wp) :: zi, zj, zetaij, km, hii, hjj, hav, shpoly, dshpoly(3), dCN
   real(wp) :: Pij, Hij, HPij, g_xyz(3)
   real(wp), parameter :: rthr = 1600.0_wp

   thr2 = intcut
   point = 0.0_wp
   ! call timing(t1,t3)
   !$omp parallel do default(none) schedule(dynamic) &
   !$omp shared(nat, at, xyz, nShell, hData, selfEnergy, dSEdcn, P, Pew, &
   !$omp& H0, S, ves, vs, vd, vq, intcut, nprim, primcount, caoshell, saoshell, &
   !$omp& alp, cont) &
   !$omp private(iat,jat,ixyz,izp,ci,rij2,jzp,ish,ishtyp,ij, &
   !$omp& icao,naoi,iptyp,jsh,jshmax,jshtyp,jcao,naoj,jptyp,dCN, &
   !$omp& sdq,sdqg,est,alpi,alpj,ab,iprim,jprim,ip,jp,ri,rj,rij,km,shpoly,dshpoly, &
   !$omp& mli,mlj,dum,dumdum,tmp,stmp,dtmp,qtmp,il,jl,zi,zj,zetaij,hii,hjj,hav, &
   !$omp& iao,jao,ii,jj,k,pij,hij,hpij,g_xyz,itr) &
   !$omp reduction(+:g,sigma,dhdcn)
   do iat = 1,nat
      ri = xyz(:,iat)
      izp = at(iat)
      do jat = 1,iat-1
         !           if (jat.eq.iat) cycle
         jzp = at(jat)

         rj = xyz(:,jat)
         rij = ri - rj
         rij2 =  sum( rij**2 )

         if (rij2 > rthr) cycle
         do ish = 1,nShell(izp)
            ishtyp = hData%angShell(ish,izp)
            icao = caoshell(ish,iat)
            naoi = llao(ishtyp)
            iptyp = itt(ishtyp)
            jshmax = nShell(jzp)
            !              if(iat.eq.jat) jshmax = ish
            do jsh = 1,jshmax ! jshells
               jshtyp = hData%angShell(jsh,jzp)
               jcao = caoshell(jsh,jat)
               naoj = llao(jshtyp)
               jptyp = itt(jshtyp)

               il = ishtyp+1
               jl = jshtyp+1
               ! diagonals are the same for all H0 elements
               hii = selfEnergy(ish, iat)
               hjj = selfEnergy(jsh, jat)

               ! distance dependent polynomial
               call dshellPoly(hData%shellPoly(il,izp),hData%shellPoly(jl,jzp),&
                  & hData%atomicRad(izp),hData%atomicRad(jzp),rij2,ri,rj,&
                  & shpoly,dshpoly)

               ! averaged H0 element (without overlap contribution!)
               hav = 0.5_wp * (hii + hjj)

               sdqg = 0;sdq = 0
               call get_grad_multiint(icao,jcao,naoi,naoj,ishtyp,jshtyp,ri,rj, &
                  &                   intcut,nprim,primcount,alp,cont,sdq,sdqg)
               do k = 1,19 ! 1 S, 2-4 D, 5-10 Q, 11-13 D, 14-19 Q
                  do ixyz = 1,3
                     ! transform from CAO to SAO
                     !                        call dtrf2(sdqg(ixyz,k,1:6,1:6),ishtyp,jshtyp)
                     tmp(1:6,1:6) = sdqg(ixyz,k,1:6,1:6)
                     call dtrf2(tmp,ishtyp,jshtyp)
                     sdqg(ixyz,k,1:6,1:6) = tmp(1:6,1:6)
                  enddo
               enddo
               g_xyz(:) = 0.0_wp
               dCN = 0.0_wp
               do ii = 1,llao2(ishtyp)
                  iao = ii+saoshell(ish,iat)
                  do jj = 1,llao2(jshtyp)
                     jao = jj+saoshell(jsh,jat)
                     Pij = p(jao,iao)

                     ! Hamiltonian element without overlap
                     Hij  = H0(jao, iao)
                     HPij = Hij * Pij

                     g_xyz(:) = g_xyz + 2*HPij*S(jao,iao)*dshpoly/shpoly &
                        & + sdqg(:,1,jj,ii)*(2*HPij - 2*Pew(jao, iao) &
                        & - Pij*(ves(ish,iat)+ves(jsh,jat)) &
                        & + Pij*(vs(iat)+vs(jat)))

                     do ixyz = 1,3
                        dtmp = Pij*sum(sdqg(ixyz,11:13,jj,ii)*vd(1:3,iat) &
                           & +sdqg(ixyz, 2:4, jj,ii)*vd(1:3,jat) )
                        qtmp = Pij*sum( sdqg(ixyz,14:19,jj,ii)*vq(1:6,iat) &
                           & +sdqg(ixyz, 5:10,jj,ii)*vq(1:6,jat) )
                        g_xyz(ixyz) = g_xyz(ixyz)+stmp+dtmp+qtmp

                     enddo ! ixyz

                     ! Hamiltonian without Hav
                     dCN = dCN + HPij / hav * S(jao, iao)
                  enddo
               enddo
               ! save dE/dCN for CNi
               dhdcn(iat) = dhdcn(iat) + dCN*dSEdcn(ish, iat)
               ! save dE/dCN for CNj
               dhdcn(jat) = dhdcn(jat) + dCN*dSEdcn(jsh, jat)
               g(:,iat) = g(:,iat)+g_xyz
               g(:,jat) = g(:,jat)-g_xyz
               sigma(:, :) = sigma + spread(g_xyz, 1, 3) * spread(rij, 2, 3)
            enddo ! jsh : loop over shells on jat
         enddo  ! ish : loop over shells on iat
      enddo ! jat
   enddo  ! iat

   ! diagonal contributions
   !$omp parallel do default(none) schedule(dynamic) reduction(+:dhdcn) &
   !$omp shared(nat, at, nshell, hData, saoshell, P, dSEdcn) &
   !$omp private(iat, izp, ish, ishtyp, iao, i, Pij)
   do iat = 1, nat
      izp = at(iat)
      do ish = 1, nShell(izp)
         ishtyp = hData%angShell(ish,izp)
         do iao = 1, llao2(ishtyp)
            i = iao+saoshell(ish,iat)

            Pij = P(i,i)
            ! save dE/dCN for CNi
            dhdcn(iat) = dhdcn(iat) + Pij*dSEdcn(ish, iat)*evtoau
         end do
      end do
   end do

end subroutine build_dSDQH0_noreset


!> Count number of significant dipole integrals
subroutine count_dpint(ndp, dpint, thr)

   !> Number of significant dipole integrals
   integer, intent(out) :: ndp

   !> Dipole integrals
   real(wp), intent(in) :: dpint(:, :, :)

   !> Neglect threshold for dipole integrals
   real(wp), intent(in) :: thr

   integer :: i, j
   real(wp) :: tmp1, thr2

   ndp = 0
   thr2 = (thr*1.0e-2_wp)-thr*1.0e-12_wp

   do i = 1, size(dpint, dim=3)
      do j = 1, i
         tmp1 = sum(dpint(1:3, j, i)**2)
         if (tmp1 > thr2) ndp = ndp + 1
      enddo
   enddo

end subroutine count_dpint


!> Count number of significant quadrupole integrals
subroutine count_qpint(nqp, qpint, thr)

   !> Number of significant quadrupole integrals
   integer, intent(out) :: nqp

   !> Quadrupole integrals
   real(wp), intent(in) :: qpint(:, :, :)

   !> Neglect threshold for quadrupole integrals
   real(wp), intent(in) :: thr

   integer :: i, j
   real(wp) :: tmp2, thr2

   nqp = 0
   thr2 = (thr*1.0e-2_wp)-thr*1.0e-12_wp

   do i = 1, size(qpint, dim=3)
      do j = 1, i
         tmp2 = sum(qpint(1:3, j, i)**2) + 2*sum(qpint(4:6, j, i)**2)
         if (tmp2 > thr2) nqp = nqp + 1
      enddo
   enddo

end subroutine count_qpint


end module xtb_xtb_hamiltonian

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_gfn0
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_gfn0

contains

!> Collect all exported unit tests
subroutine collect_gfn0(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("sp", test_gfn0_sp), &
      new_unittest("api", test_gfn0_api), &
      new_unittest("api-srb", test_gfn0_api_srb), &
      new_unittest("mindless-basic", test_gfn0_mindless_basic), &
      new_unittest("mindless-solvation", test_gfn0_mindless_solvation) &
      ]

end subroutine collect_gfn0


subroutine test_gfn0_sp(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_mctc_systools
   use xtb_type_options

   use xtb_type_molecule
   use xtb_type_wavefunction
   use xtb_type_basisset
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment
   use xtb_solv_gbsa

   use xtb_setparam
   use xtb_basis
   use xtb_peeq
   use xtb_readparam
   use xtb_paramset

   use xtb_xtb_data
   use xtb_xtb_gfn0

   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-7_wp
   real(wp),parameter :: thr2 = 1.0e-5_wp
   integer, parameter :: nat = 8
   integer, parameter :: at(nat) = [7,15,9,9,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[1.50040286526241_wp,-2.88219140061585_wp, 0.00000000000000_wp, &
      & 0.00000000000000_wp, 1.90142164792207_wp, 0.00000000000000_wp, &
      &-0.02649585010919_wp,-5.05651406856634_wp, 0.00000000000000_wp, &
      &-1.39762821979929_wp, 4.65236211997835_wp, 0.00000000000000_wp, &
      & 2.62205170116282_wp,-3.14316635901963_wp, 1.53958066744940_wp, &
      &-1.46489869067775_wp, 0.78885483581631_wp, 1.94964934855945_wp, &
      & 2.62205170116282_wp,-3.14316635901963_wp,-1.53958066744940_wp, &
      &-1.46489869067775_wp, 0.78885483581631_wp,-1.94964934855945_wp],&
      & shape(xyz))
   real(wp),parameter :: et = 300.0_wp
   integer, parameter :: maxiter = 50
   integer, parameter :: prlevel = 2
   logical, parameter :: lgrad = .true.
   logical, parameter :: restart = .false.
   real(wp),parameter :: acc = 1.0_wp

   type(TEnvironment)  :: env
   type(TMolecule)     :: mol
   type(scc_results)     :: res
   type(TBasisset)     :: basis
   type(TWavefunction) :: wfn
   type(TxTBData) :: xtbData
   type(TBorn), allocatable :: gbsa

   real(wp) :: etot,egap,sigma(3,3)
   real(wp), allocatable :: g(:,:)
   character(len=:),allocatable :: fnv
   integer  :: ipar

   type(TxTBParameter) :: globpar
   logical  :: okpar,okbas,exist,diff

   call init(env)

   set%gfn_method = 0

   call init(mol, at, xyz)

   wfn%nel = idint(sum(mol%z))
   wfn%nopen = 0

   allocate( g(3,mol%n), source = 0.0_wp )
 
   call use_parameterset('param_gfn0-xtb.txt',globpar,xtbData,okpar)
   !call check_(error, okpar)
      call rdpath(env%xtbpath,'param_gfn0-xtb.txt',fnv,exist)
      ! maybe the user provides a local parameter file, this was always
      ! an option in `xtb', so we will give it a try
      if (.not.exist) fnv = 'param_gfn0-xtb.txt'
      call open_file(ipar,fnv,'r')
      if (ipar.eq.-1) then
         ! at this point there is no chance to recover from this error
         ! THEREFORE, we have to kill the program
         call env%error("Parameter file '"//fnv//"' not found!")
         call terminate(1)
         return
      endif
      call readParam(env,ipar,globpar,xtbData,.true.)
      call close_file(ipar)

   call newBasisset(xtbData,mol%n,mol%at,basis,okbas)
   call check_(error, okbas)

   call check_(error, basis%nshell,17)
   call check_(error, basis%nbf,   30)
   call check_(error, basis%nao,   29)

   call wfn%allocate(mol%n,basis%nshell,basis%nao)
   wfn%q = mol%chrg/real(mol%n,wp)

   g = 0.0_wp

   call peeq(env,mol,wfn,basis,xtbData,gbsa, &
      &   egap,et,prlevel,lgrad,.false.,acc,etot,g,sigma,res)

   call check_(error, res%converged)

   call check_(error, res%e_total,-15.271927490420_wp, thr=thr)
   call check_(error, res%gnorm,0.55600868499186E-01_wp, thr=thr)
   ! value in electron volt
   call check_(error, res%hl_gap, 4.4910991783546_wp, thr=1.0e-4_wp)
   call check_(error, res%e_elec,-15.238855850629_wp, thr=thr)
   ! es and aes are not welldefined at this accuracy level
   call check_(error, res%e_es,   -0.091088841288_wp, thr=thr*10)
   call check_(error, res%e_disp, -0.001331408911_wp, thr=thr)
   call check_(error, res%e_rep,   0.071830283799_wp, thr=thr)
   call check_(error, res%e_xb,   -0.012481673391_wp, thr=thr)

   call mol%deallocate
   call wfn%deallocate
   call basis%deallocate

end subroutine test_gfn0_sp

subroutine test_gfn0_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_restart
   use xtb_type_data
   use xtb_type_param
   use xtb_type_environment

   use xtb_pbc_tools

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-7_wp
   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [51,1,1,1,1,16,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      [-0.33839323285714_wp,-2.52035427985714_wp, 0.00000000000000_wp, &
      & 0.87126950614286_wp,-4.36564525285714_wp, 2.28275498100000_wp, &
      & 0.87126950614286_wp,-4.36564525285714_wp,-2.28275498100000_wp, &
      &-3.07540243785714_wp,-4.12867550385714_wp, 0.00000000000000_wp, &
      & 2.16321847414286_wp, 6.15526246914286_wp, 0.00000000000000_wp, &
      &-0.33839323285714_wp, 5.87053934414286_wp, 0.00000000000000_wp, &
      &-0.15356858285714_wp, 3.35451847614286_wp, 0.00000000000000_wp], shape(xyz))
   type(peeq_options),parameter :: opt = peeq_options( &
      &  prlevel = 2, ccm = .false., acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: chk
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy
   real(wp) :: hl_gap
   real(wp) :: sigma(3,3)
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=0)
   call env%checkpoint("failed setup")
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 5.5384029314207_wp, thr=thr)
   call check_(error, energy,-8.6908532561691_wp, thr=thr)
   call check_(error, norm2(gradient),0.24709483673929E-01_wp, thr=thr)

   call check_(error, gradient(1,3), 0.12460501676405E-02_wp, thr=thr)
   call check_(error, gradient(2,1),-0.20307939298595E-01_wp, thr=thr)
   call check_(error, gradient(1,6),-0.29075269403059E-02_wp, thr=thr)
   call check_(error, gradient(3,5), 0.00000000000000E+00_wp, thr=thr)

end subroutine test_gfn0_api

subroutine test_gfn0_api_srb(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_data
   use xtb_type_restart
   use xtb_type_param
   use xtb_type_environment

   use xtb_pbc_tools

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-7_wp
   integer, parameter :: nat = 24
   integer, parameter :: at(nat) = [6,7,6,7,6,6,6,8,7,6,8,7,6,6, &
      &                             1,1,1,1,1,1,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[ 2.02799738646442_wp,  0.09231312124713_wp, -0.14310895950963_wp, &
      &  4.75011007621000_wp,  0.02373496014051_wp, -0.14324124033844_wp, &
      &  6.33434307654413_wp,  2.07098865582721_wp, -0.14235306905930_wp, &
      &  8.72860718071825_wp,  1.38002919517619_wp, -0.14265542523943_wp, &
      &  8.65318821103610_wp, -1.19324866489847_wp, -0.14231527453678_wp, &
      &  6.23857175648671_wp, -2.08353643730276_wp, -0.14218299370797_wp, &
      &  5.63266886875962_wp, -4.69950321056008_wp, -0.13940509630299_wp, &
      &  3.44931709749015_wp, -5.48092386085491_wp, -0.14318454855466_wp, &
      &  7.77508917214346_wp, -6.24427872938674_wp, -0.13107140408805_wp, &
      & 10.30229550927022_wp, -5.39739796609292_wp, -0.13672168520430_wp, &
      & 12.07410272485492_wp, -6.91573621641911_wp, -0.13666499342053_wp, &
      & 10.70038521493902_wp, -2.79078533715849_wp, -0.14148379504141_wp, &
      & 13.24597858727017_wp, -1.76969072232377_wp, -0.14218299370797_wp, &
      &  7.40891694074004_wp, -8.95905928176407_wp, -0.11636933482904_wp, &
      &  1.38702118184179_wp,  2.05575746325296_wp, -0.14178615122154_wp, &
      &  1.34622199478497_wp, -0.86356704498496_wp,  1.55590600570783_wp, &
      &  1.34624089204623_wp, -0.86133716815647_wp, -1.84340893849267_wp, &
      &  5.65596919189118_wp,  4.00172183859480_wp, -0.14131371969009_wp, &
      & 14.67430918222276_wp, -3.26230980007732_wp, -0.14344911021228_wp, &
      & 13.50897177220290_wp, -0.60815166181684_wp,  1.54898960808727_wp, &
      & 13.50780014200488_wp, -0.60614855212345_wp, -1.83214617078268_wp, &
      &  5.41408424778406_wp, -9.49239668625902_wp, -0.11022772492007_wp, &
      &  8.31919801555568_wp, -9.74947502841788_wp,  1.56539243085954_wp, &
      &  8.31511620712388_wp, -9.76854236502758_wp, -1.79108242206824_wp],&
      &  shape(xyz))
   type(peeq_options),parameter :: opt = peeq_options( &
      &  prlevel = 2, ccm = .false., acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: chk
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy
   real(wp) :: hl_gap
   real(wp) :: sigma(3,3)
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=0)
   call env%checkpoint("failed setup")
   call newWavefunction(env, mol, calc, chk)

   call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 3.1192454818777_wp, thr=thr)
   call check_(error, energy,-40.908850360158_wp, thr=thr)
   call check_(error, norm2(gradient),0.83573853247451E-01_wp, thr=thr)

   call check_(error, gradient(1, 3), 0.29870640452823E-01_wp, thr=thr)
   call check_(error, gradient(2, 1), 0.67498165159819E-03_wp, thr=thr)
   call check_(error, gradient(1, 6),-0.54145817368542E-02_wp, thr=thr)
   call check_(error, gradient(3, 5),-0.39879097860049E-04_wp, thr=thr)
   call check_(error, gradient(1, 8),-0.63393710255449E-02_wp, thr=thr)
   call check_(error, gradient(2, 6), 0.19478157220852E-01_wp, thr=thr)
   call check_(error, gradient(1,20), 0.10070932785359E-03_wp, thr=thr)
   call check_(error, gradient(3,10),-0.54834076982200E-04_wp, thr=thr)

end subroutine test_gfn0_api_srb


subroutine test_gfn0_mindless_basic(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   real(wp), parameter :: ref_energies(10) = &
      &[-28.497588460796_wp, -23.254292745575_wp, -23.060461949336_wp, &
      & -21.822909508325_wp, -27.551996281113_wp, -18.814024099835_wp, &
      & -31.195804700948_wp, -27.317394883750_wp, -20.258074646863_wp, &
      & -25.051348388657_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.05890968017315_wp, 0.04174928560148_wp, 0.05768263390495_wp, &
      & 0.06591502692791_wp, 0.08382457849620_wp, 0.09995152858607_wp, &
      & 0.08343577915160_wp, 0.08653790675487_wp, 0.06328938755566_wp, &
      & 0.06269021365940_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[4.9355818428641_wp, 0.5817815942841_wp, 2.4534066058746_wp, &
      & 0.8490082064427_wp, 1.4811842635615_wp, 0.9873933294559_wp, &
      & 4.4138879602731_wp, 1.1871662062975_wp, 1.9816407664953_wp, &
      & 0.3432086163775_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, method=0)
      call newWavefunction(env, mol, calc, chk)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn0_mindless_basic


subroutine test_gfn0_mindless_solvation(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator
   use xtb_main_setup, only : newXTBCalculator, newWavefunction, addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   character(len=*), parameter :: solvents(10) = [character(len=20) ::&
      & "h2o", "chcl3", "thf", "acetonitrile", "toluene", &
      & "ch2cl2", "ether", "methanol", "cs2", "dmso"]
   real(wp), parameter :: ref_energies(10) = &
      &[-28.510632030412_wp, -23.266701495294_wp, -23.086125389488_wp, &
      & -21.822303641621_wp, -27.566928060995_wp, -18.832541288587_wp, &
      & -31.204815373848_wp, -27.323931773594_wp, -20.270903985453_wp, &
      & -25.053546379618_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.05788277333095_wp, 0.04117813956764_wp, 0.05838285007764_wp, &
      & 0.06675003613700_wp, 0.08237342790744_wp, 0.10215599601359_wp, &
      & 0.08394783095013_wp, 0.086507373560174_wp, 0.06283764829270_wp, &
      & 0.06263571386482_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[4.9494565569973_wp, 0.5809054942177_wp, 2.4549059279536_wp, &
      & 0.8522897920347_wp, 1.4827703858899_wp, 0.9710672494430_wp, &
      & 4.3955269926200_wp, 1.1868023047842_wp, 1.9777105277691_wp, &
      & 0.3654558060973_wp]


   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, method=0)
      call newWavefunction(env, mol, calc, chk)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & alpb=mod(iMol, 2)==0, kernel=gbKernel%still))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn0_mindless_solvation

end module test_gfn0

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine expire
   use, intrinsic :: iso_fortran_env, only : output_unit
   implicit none
   intrinsic date_and_time

   integer :: i,upper(3),lower(3),val(8),edate,cdate,adate
   parameter (upper=(/2019, 4,30/)) ! expire date
   parameter (edate=365*upper(1) + 30.5*upper(2) + upper(3))
   parameter (lower=(/2018,11, 1/)) ! build date
   parameter (cdate=365*lower(1) + 30.5*lower(2) + lower(3))

   call date_and_time(values=val)
   adate=365*val(1) + 30.5*val(2) + val(3) ! actual date

   if ((adate.gt.cdate).and.(adate.lt.edate)) then
      write(output_unit,'(3x,i0,1x,a)') edate-adate, &
      &   'days left until this program expires'
   else
      write(output_unit,'(a)') 'code expired'
      call terminate(0)
   endif

end subroutine expire

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_local
contains

subroutine local(nat,at,nbf,nao,ihomo,xyz,z,focc,s,p,cmo,eig,q,etot,gbsa,basis,results)
   use xtb_mctc_accuracy, only : wp, sp
   use xtb_mctc_constants, only : pi
   use xtb_mctc_convert, only : autoev,autoaa
   use xtb_mctc_symbols, only : toSymbol
   use xtb_mctc_blas, only : blas_gemm
   use xtb_type_basisset
   use xtb_setparam
   use xtb_scc_core, only : get_wiberg
   use xtb_dtrafo
   use xtb_onetri
   use xtb_dipole
   use xtb_type_data, only : scc_results
   use xtb_docking_param, only : dipol, ehomo, elumo

   implicit none
   type(TBasisset), intent(in) :: basis
   integer, intent(in) :: nao,ihomo,nat,at(nat),nbf
   real(wp),intent(in) :: cmo(nao,nao),eig(nao),focc(nao)
   real(wp),intent(in) :: s(nao,nao),xyz(3,nat),z(nat),q(nat)
   real(wp),intent(in) :: p(nao,nao),etot
   logical, intent(in) :: gbsa
   type(scc_results), intent(inout) :: results

   real(wp),allocatable :: op(:,:)
   real(wp),allocatable :: oc(:,:,:)
   real(wp),allocatable :: cca(:)
   real(wp),allocatable :: dip2(:)
   real(wp),allocatable :: qua (:,:)
   real(wp),allocatable :: dip (:,:)
   real(wp),allocatable :: ecent(:,:),qcent(:,:),ecent2(:,:)
   real(wp),allocatable :: d(:,:)
   real(wp),allocatable :: f(:)
   real(wp),allocatable :: eiga(:)
   real(wp),allocatable :: xcen(:)
   real(wp),allocatable :: qmo(:,:)
   real(wp),allocatable :: tmpq(:,:)
   real(wp),allocatable :: rr(:)
   real(wp),allocatable :: wbo(:,:)
   real(wp),allocatable :: xyztmp(:,:)
   real(sp),allocatable :: rklmo(:,:)
   integer, allocatable :: ind(:)
   integer, allocatable :: lneigh(:,:)
   integer, allocatable :: aneigh(:,:)

   integer mo,n,i,j,k,ii,jj,imem(nat),idum,isc,iso,nop,pilist(ihomo)
   integer lamdu1,lamdu2,imo1,imo2,iso1,iso2,ij,jdum,maxlp,maxpi,is1
   integer ilumo,klev,nlev,nn,m,ldum(ihomo),sigrel(3,ihomo),npi,is2
   integer i1,i2,i3,is3,ipi,piset(nat),ncyc,j1,j2,smo,pmo,nl,nm,nr
   integer imo,new
   real(wp) :: dd,dum,det,pp,dtot(3),diptot,thr,t0,w0,t1,w1,vec1(3),v(6)
   real(wp) :: enlumo,enhomo,qhl(nat,2),ps,efh,efl,r1,r2,pithr,vec2(3)
   real(wp) :: praxis(3,3),aa,bb,cc
   character(len=80) :: atmp
   character(len=5) :: lmostring(4)
   data lmostring/'sigma','LP   ','pi   ','delpi'/
   logical l1,l2,l3,flip
   integer LWORK,IWORK,LIWORK,INFO
   integer :: iscreen,icoord,ilmoi,icent ! file handles

   call timing(t0,w0)
   if(set%pr_local) then
      write(*,*)
      write(*,*)'localization/xTB-IFF output generation'
   end if
   n=ihomo
   ilumo=n+1

   if(ilumo.gt.nao)then
      enlumo=1000.
   else
      enlumo=eig(ilumo)
   endif
   efh=eig(n)
   efl=enlumo

   !     HOMO/LUMO populations for xTB FF (CT terms)
   qhl = 0
   thr = 0.01

   if(ihomo.eq.0) then
      ! the HOMO is non-existing, place at unrealistically low energy
      enhomo=-999.999999990d0
      qhl(1:nat,1)=0.0d0
   else
      klev=0
      enhomo=0
      do nlev=ihomo,1,-1 ! loop over highest levels
         if(efh-eig(nlev).gt.thr) exit
         klev=klev+1
         enhomo=enhomo+eig(nlev)
         do i=1,nao
            ii=basis%aoat2(i)
            do j=1,i-1
               jj=basis%aoat2(j)
               ps=s(j,i)*cmo(j,nlev)*cmo(i,nlev)
               qhl(ii,1)=qhl(ii,1)+ps
               qhl(jj,1)=qhl(jj,1)+ps
            enddo
            ps=s(i,i)*cmo(i,nlev)*cmo(i,nlev)
            qhl(ii,1)=qhl(ii,1)+ps
         enddo
      enddo
      dum=1./float(klev)
      enhomo=enhomo*dum
      qhl(1:nat,1)=qhl(1:nat,1)*dum
      if(set%pr_local) write(*,*)'averaging CT terms over ',klev,' occ. levels'
   endif

   klev=0
   enlumo=0
   do nlev=ilumo,nao ! loop over highest levels
      if(eig(nlev)-efl.gt.thr) exit
      klev=klev+1
      enlumo=enlumo+eig(nlev)
      do i=1,nao
         ii=basis%aoat2(i)
         do j=1,i-1
            jj=basis%aoat2(j)
            ps=s(j,i)*cmo(j,nlev)*cmo(i,nlev)
            qhl(ii,2)=qhl(ii,2)+ps
            qhl(jj,2)=qhl(jj,2)+ps
         enddo
         ps=s(i,i)*cmo(i,nlev)*cmo(i,nlev)
         qhl(ii,2)=qhl(ii,2)+ps
      enddo
   enddo
   dum=1./float(klev)
   enlumo=enlumo*dum
   qhl(1:nat,2)=qhl(1:nat,2)*dum
   if(set%pr_local) write(*,*)'averaging CT terms over ',klev,' virt. levels'
   if(ilumo.gt.nao)then
      enlumo=1000.
      qhl(1:nat,2)=0
   endif

   allocate(cca(nao*nao),xcen(n),lneigh(4,n),aneigh(2,n))
   allocate(d(n,n),ecent(n,4),eiga(n),qcent(n,3),ecent2(n,4))

   ! do only occ. ones
   cca=0
   k=  0
   do i=1,n
      k=k+1
      eiga(k)=eig(i)
      do j=1,nao
         cca(j+(k-1)*nao)=cmo(j,i)
      enddo
   enddo

   nop=3
   !     dipole integrals
   allocate(dip2(nao*nao),dip(nbf*(nbf+1)/2,3),op(n*(n+1)/2,nop))
   !    .         qua (nbf*(nbf+1)/2,3))
   call Dints  (nat,nbf,xyz,dip(1,1),dip(1,2),dip(1,3),basis)
   !     call DQ3ints(nat,nbf,xyz,dip(1,1),dip(1,2),dip(1,3),
   !    .                         qua(1,1),qua(1,2),qua(1,3))
   call cao2saop(nbf,nao,dip(1,1),basis)
   call cao2saop(nbf,nao,dip(1,2),basis)
   call cao2saop(nbf,nao,dip(1,3),basis)
   !     call cao2saop(nbf,nao,qua(1,1))
   !     call cao2saop(nbf,nao,qua(1,2))
   !     call cao2saop(nbf,nao,qua(1,3))
   !     d=0
   do mo=1,3
      call onetri(1,dip(1,mo),dip2,cca,nao,n)
      k=0
      do i=1,n
         do j=1,i
            k=k+1
            op(k,mo)=dip2(j+(i-1)*n)
         enddo
      enddo
   enddo

   !     compute dipole moment core part
   dtot = 0
   do i=1,nat
      dtot(1)=dtot(1)+xyz(1,i)*z(i)
      dtot(2)=dtot(2)+xyz(2,i)*z(i)
      dtot(3)=dtot(3)+xyz(3,i)*z(i)
   enddo
   k=0
   do i=1,n
      k=k+i
      dtot(1)=dtot(1)+op(k,1)*focc(i)
      dtot(2)=dtot(2)+op(k,2)*focc(i)
      dtot(3)=dtot(3)+op(k,3)*focc(i)
   enddo
   diptot=sqrt(dtot(1)**2+dtot(2)**2+dtot(3)**2)
   if(set%pr_local) then
      write(*,*)'dipole moment from electron density (au)'
      write(*,*)'    X       Y       Z   '
      write(*,'(3f9.4,''  total (Debye): '',f8.3)') &
      &      dtot(1),dtot(2),dtot(3),diptot*2.5418
   end if

   call timing(t1,w1)
   if(set%pr_local) call prtime(6,t1-t0,w1-w0,'init local')
   ! do optimization
   if(set%pr_local) write(*,*) 'doing rotations ...'
   call lopt(.true.,n,3,1.d-6,op,d)

   if(set%pr_local) write(*,*) 'doing transformations ...'
   ! MO charge center
   k=0
   do i=1,n
      k=k+i
      ecent(i,1)=-op(k,1)
      ecent(i,2)=-op(k,2)
      ecent(i,3)=-op(k,3)
   enddo

   ! LMO fock matrix
   allocate(f(n))
   do i=1,n
      dum=0.0d0
      do k=1,n
         dum=dum+eiga(k)*d(k,i)*d(k,i)
      enddo
      f(i)=dum
   enddo
   call lmosort2(n,f,d,ecent)

   ! the lmos
   CALL dgemm('N','N',nao,n,n,1.D0,cca,nao,d,n,0.D0,cmo,nao) ! non-std BLAS

   ! X^2,Y^2,Z^2 over LMOs
   !     k=0
   !     do i=1,n
   !        k=k+1
   !        do j=1,nao
   !           cca(j+(k-1)*nao)=cmo(j,i)
   !        enddo
   !     enddo
   !     do mo=1,3
   !        call onetri(1,qua(1,mo),dip2,cca,nao,n)
   !        do i=1,n
   !           qcent(i,mo)=dip2(i+(i-1)*n)
   !        enddo
   !     enddo
   !     deallocate(qua)

   !     do i=1,n
   !        r1=sum(ecent(i,1:3)**2)
   !        r2=sum(-qcent(i,1:3))
   !        ecent(i,4)=sqrt(r2-r1)
   !     enddo

   pithr=2.20  ! below is pi, large is pi deloc (typ=4)

   ! number of centers for each mo
   allocate(qmo(nat,n))
   call mocent(nat,nao,n,cmo,s,qmo,xcen,basis%aoat2)

   allocate(rklmo(5,2*n))
   if(set%pr_local) write(*,*) 'lmo centers(Z=2) and atoms on file <lmocent.coord>'
   if(set%pr_local) write(*,*) 'LMO Fii/eV  ncent    charge center   contributions...'
   if(set%pr_local) call open_file(iscreen,'xtbscreen.xyz','w')
   allocate(tmpq(nat,n))
   tmpq(1:nat,1:n)=qmo(1:nat,1:n)
   maxlp=0
   maxpi=0
   do i=1,n
      do j=1,nat
         imem(j)=j
      enddo
      call lmosort(nat,n,i,imem,qmo)
      idum=1
      do j=1,nat
         if(qmo(j,i).gt.0.07) idum=j
      enddo
      if(nat.eq.1)then
         jdum=2
      else
         call lmotype(nat,at,xyz,ecent(i,1),ecent(i,2),ecent(i,3), &
         &                imem(1),imem(2),xcen(i),.false.,pithr,jdum)
      endif
      rklmo(1:3,i)=ecent(i,1:3)
      rklmo(  4,i)=ecent(i,  4)
      rklmo(  5,i)=real(jdum)
      if(jdum.eq.2)maxlp=i
      if(jdum.eq.3)maxpi=i
   enddo
   qmo(1:nat,1:n)=tmpq(1:nat,1:n)
   deallocate(tmpq)


   do i=1,n
      do j=1,nat
         imem(j)=j
      enddo
      call lmosort(nat,n,i,imem,qmo)
      idum=1
      do j=1,nat
         if(qmo(j,i).gt.0.07) idum=j
      enddo
      if(nat.eq.1)then
         jdum=1
      else
         call lmotype(nat,at,xyz,ecent(i,1),ecent(i,2),ecent(i,3), &
         &                imem(1),imem(2),xcen(i),.true.,pithr,jdum)
      endif
      if(set%pr_local) then 
      write(*,'(i5,1x,a5,2f7.2,3f10.5,12(i5,2x,a2,'':'',f6.2))')  &
      &   i,lmostring(jdum),autoev*f(i),xcen(i),ecent(i,1:3), &
      &   (imem(j),toSymbol(at(imem(j))),qmo(j,i),j=1,idum)
      end if
      !        write + LP/pi as H for protonation search
      if(set%pr_local) then
         if(jdum.gt.1) then
            if( i.eq.maxlp .or. (i.eq.maxpi.and.maxlp.eq.0) )then
               call open_file(icoord,'coordprot.0','w')
               write(icoord,'(''$coord'')')
               do ii=1,nat
                  write(icoord,'(3F24.10,5x,a2)') xyz(1:3,ii),toSymbol(at(ii))
               enddo
               write(icoord,'(3F24.10,5x,a2)') ecent(i,1:3),toSymbol(1)
               write(icoord,'(''$end'')')
               write(icoord,'(''$set'')')
               write(icoord,'('' chrg '',i2)')set%ichrg+1
               write(icoord,'('' ewin_conf 50.0 '')')
               write(icoord,'(''$end'')')
               call close_file(icoord)
            else
               write(iscreen,*) nat+1
               write(iscreen,*)
               do ii=1,nat
                  write(iscreen,'(a2,3F24.10)')toSymbol(at(ii)),xyz(1:3,ii)*autoaa
               enddo
               write(iscreen,'(a2,3F24.10)') toSymbol(1),ecent(i,1:3)*autoaa
            endif
         endif
      endif

   enddo

   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   new=0
   if(maxval(rklmo(5,1:n)).ge.3.)then
      if(set%pr_local) write(*,*) 'starting deloc pi regularization ...'

      call atomneigh(n,nat,xyz,ecent,aneigh) ! the nearest  atom neighbors for each LMO
      call lmoneigh (n,rklmo,ecent,aneigh,lneigh)   ! the nearest LMO neighbor but not LP

      ldum = -1
      do i=1,n
         if(int(rklmo(5,i)).ge.3.and.ldum(i).ne.1)then
            flip=.false.
            call piorient(ecent(i,:),ecent(lneigh(1,i),:),flip) ! check for same alignment of pi orbitals
            if(flip) then
               ldum(i)=1        ! i itself is the pi DOWN counterpart and lneigh(1,i) contains the pi UP part
               ldum(lneigh(1,i))=0
            else
               ldum(i)=0
               ldum(lneigh(1,i))=1       ! lneigh(1,i) contains the pi DOWN counterpart
            endif
         endif
      enddo
      k=0
      piset=0
      do i=1,n
         if(ldum(i).eq.0)then
            k=k+1
            pilist(k)=i               ! UP plane unique pi list
            piset(aneigh(1,i))=1
            piset(aneigh(2,i))=1
         endif
      enddo
      npi=k


      !     determine for each deloc pi bond sigma bonds which are in the pi system
      j=0
      ldum=0
      nn=0
      sigrel=0
      do i=1,npi
         ipi=pilist(i)
         call irand3(i1,i2,i3)    ! change order of lookup
         is1=lneigh(i1+1,ipi)
         is2=lneigh(i2+1,ipi)
         is3=lneigh(i3+1,ipi)
         l1 =bndcheck(nat,piset,aneigh(1,is1),aneigh(2,is1)) !do bonds on ipi belong to the pi system?
         l2 =bndcheck(nat,piset,aneigh(1,is2),aneigh(2,is2))
         l3 =bndcheck(nat,piset,aneigh(1,is3),aneigh(2,is3))
         if(l1.and.ldum(is1).eq.0)then
            ldum(is1)=1
            sigrel(1,i)=is1
         endif
         if(l2.and.ldum(is2).eq.0)then
            ldum(is2)=1
            sigrel(2,i)=is2
         endif
         if(l3.and.ldum(is3).eq.0)then
            ldum(is3)=1
            sigrel(3,i)=is3
         endif
      enddo

      ldum=0
      do i=1,npi
         ipi=pilist(i)
         do j=1,3
            is1=sigrel(j,i)
            if(is1.gt.0)ldum(is1)=ldum(is1)+1
         enddo
      enddo

      if(set%pr_local) write(*,*) 'thr ',pithr, '# pi deloc LMO',npi


      allocate(wbo(nat,nat))
      wbo=0.0d0
      call get_wiberg(nat,nao,at,xyz,p,s,wbo,basis%fila2)

      !     now create new LMO
      k=0
      m=0
      do i=1,npi
         pmo=pilist(i)
         i1 = aneigh(1,pmo)
         i2 = aneigh(2,pmo)
         dd=wbo(i2,i1)
         do j=1,3
            smo=sigrel(j,i)
            if(rklmo(5,smo).ne.1) cycle
            !         if(rklmo(5,smo).eq.0.or.rklmo(5,smo).eq.2) cycle
            j1 = aneigh(1,smo)
            j2 = aneigh(2,smo)
            dum=wbo(j2,j1)
            ! take difference of pi-bond order (i.e., WBO > 1) relative to its sum (i.e., number of pi-electrons distributed among the 3 centers)
            pp=abs((dum-dd)/(dum+dd-2.0d0))
            if(pp.ge.0.50d0) cycle
            !                              pi atom  center  sigma (nl,nm,nr)
            ! from 3 atoms A-B=C, find central atom (B)
            call threeoutfour(i1,i2,j1,j2,nl,nm,nr)
            if(nl.eq.0) cycle                ! fall back =do nothing if assignment fails
            vec1(1:3)=xyz(1:3,nm)
            vec2(1:3)=(xyz(1:3,nl)+xyz(1:3,nr))*0.5
            dtot(1:3)=rklmo(1:3,pmo)
            call calcrotation(dtot,vec2,vec1-vec2,pi)   ! project upper pi center to other bond
            k=k+1
            rklmo(1:3,n+k)= dtot(1:3)
            rklmo(4:5,n+k)=rklmo(4:5,pmo)
            !        add to screen file, protomer search
            if(set%pr_local) then
               write(iscreen,*) nat+1
               write(iscreen,*)
               do ii=1,nat
                  write(iscreen,'(a2,3F24.10)')toSymbol(at(ii)),xyz(1:3,ii)*autoaa
               enddo
               write(iscreen,'(a2,3F24.10)') toSymbol(1),dtot(1:3)*autoaa
            endif
            imo=lneigh(1,pmo)
            vec1(1:3)=xyz(1:3,nm)
            vec2(1:3)=(xyz(1:3,nl)+xyz(1:3,nr))*0.5
            dtot(1:3)=rklmo(1:3,imo)
            call calcrotation(dtot,vec2,vec1-vec2,pi)   ! project bottom pi center to other bond
            k=k+1
            rklmo(1:3,n+k)= dtot(1:3)
            rklmo(4:5,n+k)=rklmo(4:5,imo)
            rklmo(  5,smo)=0 ! remove sigma
            !        add to screen file, protomer search
            if(set%pr_local) then 
               write(iscreen,*) nat+1
               write(iscreen,*)
               do ii=1,nat
                  write(iscreen,'(a2,3F24.10)')toSymbol(at(ii)),xyz(1:3,ii)*autoaa
               enddo
               write(iscreen,'(a2,3F24.10)') toSymbol(1),dtot(1:3)*autoaa
            end if
            m=m+1
         enddo
      enddo
      new=k

      if(set%pr_local) then 
      call close_file(iscreen)
      end if
      deallocate(wbo)


   endif
   !ccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   !> If the normal xtb mode is used with --lmo, set%pr_local is true and
   !  a file with all information is written.
   !  If the docking mode is used, information are stored intrenally

   if(set%pr_local) then
      call open_file(ilmoi,set%lmoinfo_fname,'w')
      write(ilmoi,*) nat
      if(set%pr_local) call open_file(icent,'lmocent.coord','w')
      if(set%pr_local) write(icent,'(''$coord'')')
      do i=1,nat
         write(ilmoi,'(i2,3F20.10,E18.10)') at(i),xyz(1:3,i),q(i)
         if(set%pr_local) write(icent,'(3F24.10,5x,a2)') xyz(1:3,i),toSymbol(at(i))
      enddo
      k=0
      do i=1,n+new
         if(int(rklmo(5,i)).gt.0)k=k+1
      enddo
      write(ilmoi,'(i5,5f14.8)')k,diptot,enlumo,enhomo,etot
      do i=1,n+new
         if(int(rklmo(5,i)).gt.0)then
            write(ilmoi,'(i2,3F20.10,f14.8)')int(rklmo(5,i)),rklmo(1:3,i)
            if(set%pr_local) write(icent,'(3F24.10,5x,a2)') rklmo(1:3,i),toSymbol(2)
         endif
      enddo
      write(ilmoi,'(10(F10.6))') (qhl(i,1),i=1,nat)  ! HOMO atom pop
      write(ilmoi,'(10(F10.6))') (qhl(i,2),i=1,nat)  ! LUMO atom pop
      if(set%pr_local) write(icent,'(''$end'')')
      call close_file(ilmoi)
      if(set%pr_local) call close_file(icent)
   end if 

   !> Saving results
   k=0
   do i=1,n+new
      if(int(rklmo(5,i)).gt.0)k=k+1
   enddo
   results%iff_results%at = at
   results%iff_results%xyz = xyz
   results%iff_results%q = q
   results%iff_results%nlmo = k
   results%iff_results%dipol = diptot
   results%iff_results%elumo = enlumo
   results%iff_results%ehomo = enhomo
   results%iff_results%qct(1:nat,1) = qhl(1:nat,1)
   results%iff_results%qct(1:nat,2) = qhl(1:nat,2)
   do i=1,n+new
      if(int(rklmo(5,i)).gt.0) then
         results%iff_results%lmo(i) = int(rklmo(5,i))
         results%iff_results%rlmo(1:3,i) = rklmo(1:3,i)
      endif
   end do

   if(set%pr_local) then
      write(*,*)'files:'
      write(*,*)'coordprot.0/xtbscreen.xyz/xtblmoinfo/lmocent.coord'
      write(*,*)'with protonation site input, xtbdock and'
      write(*,*)'LMO center info written'
      write(*,*)
   end if

   deallocate(xcen,cca,d,f,qmo,ecent,rklmo)

end subroutine local

! determine type of LMO
subroutine lmotype(n,at,xyz,ex,ey,ez,ia1,ia2,xcen,modi,pithr,typ)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: n,ia1,ia2,at(n)
   integer, intent(out)   :: typ
   logical, intent(in)    :: modi
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: ex,ey,ez
   real(wp),intent(in)    :: xcen,pithr
   real(wp) :: r1,r2,r,r0,f,norm

   if(xcen.lt.1.3333333)then
      typ=2 ! LP
      f=-2.2
      if(modi)then
         norm=sqrt((xyz(1,ia1)-ex)**2+(xyz(2,ia1)-ey)**2 &
         &              +(xyz(3,ia1)-ez)**2)
         ! the LP is on the atom e.g. in TM compounds so just shift it away
         if(norm.lt.0.2) then
            call shiftlp(n,at,ia1,xyz,ex,ey,ez)
         else
            ! put it on the line along atom...LP center
            ex=ex+f*(xyz(1,ia1)-ex)
            ey=ey+f*(xyz(2,ia1)-ey)
            ez=ez+f*(xyz(3,ia1)-ez)
         endif
      endif
   else
      r1=sqrt((xyz(1,ia1)-ex)**2+(xyz(2,ia1)-ey)**2+(xyz(3,ia1)-ez)**2)
      r2=sqrt((xyz(1,ia2)-ex)**2+(xyz(2,ia2)-ey)**2+(xyz(3,ia2)-ez)**2)
      r=r1+r2
      r0=sqrt(sum((xyz(:,ia1)-xyz(:,ia2))**2))
      if(r/r0.gt.1.04)then
         typ=3  ! pi
         if(xcen.gt.pithr) typ=4
      else
         typ=1  ! sigma
      endif
   endif

end subroutine lmotype


!ccccccccccccccccccccccccccccccccccccccc

subroutine mocent(n,ndim,ihomo,x,s,qmo,xcen,aoat2)
   implicit none
   integer n,ndim,ihomo
   integer, intent(in) :: aoat2(ndim)
   real*8 xcen(ihomo),x(ndim,ndim),s(ndim,ndim)
   real*8 qmo(n,ihomo)

   integer ia,ib,m,i,j,k
   real*8 dum,tmp

   qmo=0
   !$OMP  PARALLEL PRIVATE (m,j,ia,k,ib,tmp,dum) &
   !$OMP& SHARED(qmo,xcen,X,S) &
   !$OMP& DEFAULT(SHARED)
   !$OMP DO
   do m=1,ihomo
      do j=1,ndim
         ia=aoat2(j)
         do k=1,j-1
            ib=aoat2(k)
            tmp=X(j,m)*X(k,m)*s(k,j)
            qmo(ia,m)=qmo(ia,m)+tmp
            qmo(ib,m)=qmo(ib,m)+tmp
         enddo
         qmo(ia,m)=qmo(ia,m)+X(j,m)*X(j,m)*s(j,j)
      enddo
      dum=0
      do i=1,n
         dum=dum+qmo(i,m)**2
      enddo
      xcen(m)=1.0/(1.0d-8+dum)
   enddo
   !$OMP END DO
   !$OMP END PARALLEL

end subroutine mocent

SUBROUTINE lmosort(ncent,ihomo,imo,imem,qmo)
   IMPLICIT REAL*8(A-H,O-Z)
   dimension qmo(ncent,ihomo)
   dimension imem(ncent)

   do ii = 2,ncent
      i = ii - 1
      k = i
      pp= qmo(i,imo)
      do j = ii, ncent
         if (qmo(j,imo) .lt. pp) cycle
         k = j
         pp=qmo(j,imo)
      enddo
      if (k .eq. i) cycle
      qmo(k,imo) = qmo(i,imo)
      qmo(i,imo) = pp

      ihilf=imem(i)
      imem(i)=imem(k)
      imem(k)=ihilf
   enddo

end subroutine lmosort

SUBROUTINE lmosort2(n,eps,d,ecent)
   IMPLICIT REAL*8(A-H,O-Z)
   dimension d(n,n), eps(n), ecent(n,3)

   do ii = 2,n
      i = ii - 1
      k = i
      pp= eps(i)
      do    j = ii, n
         if (eps(j) .gt. pp) cycle
         k = j
         pp=eps(j)
      enddo
      if (k .eq. i) cycle
      eps(k) = eps(i)
      eps(i) = pp

      do j=1,n
         hilf=d(j,i)
         d(j,i)=d(j,k)
         d(j,k)=hilf
      enddo

      do j=1,3
         hilf=ecent(i,j)
         ecent(i,j)=ecent(k,j)
         ecent(k,j)=hilf
      enddo

   enddo

end subroutine lmosort2


subroutine lmoneigh(n,rk,ecent,aneigh,neigh)
   implicit none
   integer n,neigh(4,n),aneigh(2,*)
   real*8 ecent(n,3)
   real*4 rk(5,2*n)

   real*8 rr(n)
   integer i,j,ind(n),i1,i2,j1,j2

   do i=1,n
      i1=aneigh(1,i)
      i2=aneigh(2,i)
      do j=1,n
         j1=aneigh(1,j)
         j2=aneigh(2,j)
         rr(j)= (ecent(i,1)-ecent(j,1))**2 &
            &            +(ecent(i,2)-ecent(j,2))**2 &
            &            +(ecent(i,3)-ecent(j,3))**2
         if(int(rk(5,j)).eq.2) rr(j)=1.d+42  ! LP
         if(i1.eq.j1.and.i2.eq.j2) rr(j)=-1.0 ! same bond?
         if(i1.eq.j2.and.i2.eq.j1) rr(j)=-1.0
         if(i.eq.j) rr(j)=2.d+42
         ind(j)=j
      enddo
      call Qsort(rr,1,n,ind)
      neigh(1,i)=ind(1)
      neigh(2,i)=ind(2)
      neigh(3,i)=ind(3)
      neigh(4,i)=ind(4)
   enddo

end subroutine lmoneigh

subroutine atomneigh(n,nat,xyz,ecent,neigh)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer, intent(in)    :: n,nat
   integer, intent(inout) :: neigh(2,n)
   real(wp),intent(in)    :: ecent(n,3)
   real(wp),intent(in)    :: xyz(3,nat)

   real(wp) :: rr(nat)
   integer  :: i,j,ind(nat)

   do i=1,n
      do j=1,nat
         rr(j)= (ecent(i,1)-xyz(1,j))**2 &
            &  +(ecent(i,2)-xyz(2,j))**2 &
            &  +(ecent(i,3)-xyz(3,j))**2
         ind(j)=j
      enddo
      call Qsort(rr,1,nat,ind)
      neigh(1,i)=ind(1)
      neigh(2,i)=ind(2)
   enddo

end subroutine atomneigh

pure function bndcheck(nat,list,i1,i2) result(check)
   integer,intent(in) :: nat,list(nat),i1,i2
   logical :: check
   check = .false.
   if(list(i1).eq.1.and.list(i2).eq.1) check=.true.
end function bndcheck

subroutine irand3(n1,n2,n3)
   use xtb_mctc_accuracy, only : sp
   integer,intent(out) :: n1,n2,n3
   integer  :: irand
   real(sp) :: x

   call random_number(x)
   irand=int(3.1*x)
   if(irand.lt.1) irand=1
   if(irand.gt.3) irand=3
   n1=irand
10 call random_number(x)
   irand=int(3.1*x)
   if(irand.lt.1) irand=1
   if(irand.gt.3) irand=3
   if(irand.ne.n1)then
      n2=irand
   else
      goto 10
   endif
20 call random_number(x)
   irand=int(3.1*x)
   if(irand.lt.1) irand=1
   if(irand.gt.3) irand=3
   if(irand.ne.n1.and.irand.ne.n2)then
      n3=irand
   else
      goto 20
   endif

end subroutine irand3

pure subroutine threeoutfour(i1,i2,j1,j2,n1,n2,n3)
   implicit none
   integer,intent(in)  :: i1,i2,j1,j2
   integer,intent(out) :: n1,n2,n3

   n1=0
   if(i1.eq.j1)then
      n1=i2
      n2=i1
      n3=j2
      return
   endif
   if(i1.eq.j2)then
      n1=i2
      n2=i1
      n3=j1
      return
   endif
   if(i2.eq.j1)then
      n1=i1
      n2=i2
      n3=j2
      return
   endif
   if(i2.eq.j2)then
      n1=i1
      n2=i2
      n3=j1
      return
   endif

end subroutine threeoutfour

pure subroutine calcrotation(x,ori,vec,phi)
   use xtb_mctc_accuracy, only : wp
   implicit none

   integer i,j

   real(wp),intent(inout) :: x(3)
   real(wp),intent(in)    :: ori(3)
   real(wp),intent(in)    :: vec(3)
   real(wp),intent(in)    :: phi
   real(wp) :: d(3)
   real(wp) :: xtmp(3)
   real(wp) :: absd

   d(1:3) = vec(1:3)

   xtmp(1:3) = x(1:3) - ori(1:3)

   absd = sqrt(d(1)**2 + d(2)**2 + d(3)**2)

   d(1:3) = d(1:3) / absd

   x(1) = ( (d(2)**2+d(3)**2)*cos(phi) + d(1)**2 ) * xtmp(1) +  &
   &      ( d(1)*d(2)*(1-cos(phi))-d(3)*sin(phi) ) * xtmp(2) +  &
   &      ( d(1)*d(3)*(1-cos(phi))+d(2)*sin(phi) ) * xtmp(3)
   x(2) = ( d(1)*d(2)*(1-cos(phi))+d(3)*sin(phi) ) * xtmp(1) +  &
   &      ( (d(1)**2+d(3)**2)*cos(phi) + d(2)**2 ) * xtmp(2) +  &
   &    ( d(2)*d(3)*(1-cos(phi))-d(1)*sin(phi) ) * xtmp(3)
   x(3) = ( d(1)*d(3)*(1-cos(phi))-d(2)*sin(phi) ) * xtmp(1) +  &
   &      ( d(2)*d(3)*(1-cos(phi))+d(1)*sin(phi) ) * xtmp(2) +  &
   &      ( (d(1)**2+d(2)**2)*cos(phi) + d(3)**2 ) * xtmp(3)
   x(1:3) = x(1:3) + ori(1:3)

end subroutine calcrotation

pure subroutine piorient(a,b,flip)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp),intent(in)  :: a(3),b(3)
   logical, intent(out) :: flip
   integer  :: i,j
   real(wp) :: d(3),d2(3)
   flip=.false.
   d=0.0d0
   j=0

   do i=1,3
      d(i)=a(i)-b(i)
      d2(i)=d(i)*d(i)
   enddo
   j=maxloc(d2,1)
   if(d(j).lt.0.0d0) flip=.true.
   return
end subroutine piorient

end module xtb_local

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_gfnff_mrec
      private
      public :: mrecgff, mrecgffPBC
contains

      subroutine mrecgff(nat,nb,molcount,molvec)
      ! molcount: number of total fragments (increased during search)
      ! nat: overall number of atoms
      ! molvec: assignment vector of atom to fragment
      implicit none
      integer nat,molvec(nat),i,j,molcount,nb(20,nat)
      real*8, allocatable:: bond(:,:)
      logical,allocatable:: taken(:)

      allocate(taken(nat),bond(nat,nat))
      bond=0
      do i=1,nat
         do j=1,nb(20,i)
            bond(i,nb(j,i))=1
            bond(nb(j,i),i)=1
         enddo
      enddo
      molvec=0
      molcount=1
      taken=.false.
      do i=1,nat
       if(.not.taken(i)) then
         molvec(i)=molcount
         taken(i)=.true.
         call mrecgff2(nb,i,taken,nat,bond,molvec,molcount)
         molcount=molcount+1
      endif
      enddo
      molcount=molcount-1
      end subroutine mrecgff

      recursive subroutine mrecgff2(nb,i,taken,nat,bond,molvec,molcnt)
      implicit none
      integer i,nat, molcnt,molvec(nat),j,icn,k,nb(20,nat)
      real*8 bond(nat,nat)
      logical taken(nat)

      icn=nb(20,i)
      do k=1,icn
         j=maxloc(bond(:,i),1)
         bond(j,i)=0
         if (i .eq. j) cycle
         if (.not.taken(j)) then
            molvec(j)=molcnt
            taken(j)=.true.
            call mrecgff2(nb,j,taken,nat,bond,molvec,molcnt)
         endif
      enddo
      end subroutine mrecgff2


      subroutine mrecgffPBC(nat,numctr,numnb,nb,molcount,molvec)
      ! molcount: number of total fragments (increased during search)
      ! nat: overall number of atoms
      ! molvec: assignment vector of atom to fragment
      implicit none
      integer, intent(in) :: nat, numctr, numnb, nb(numnb,nat,numctr)
      integer, intent(inout) ::molvec(nat),molcount
      integer :: i,j, iTr
      real*8, allocatable:: bond(:,:,:)
      logical,allocatable:: taken(:)

      allocate(taken(nat),bond(nat,nat,numctr))
      ! create array with 1's as marks for bond partners
      bond=0
      do i=1,nat
        do iTr=1, numctr  
          do j=1,nb(numnb,i,iTr)
            bond(nb(j,i,iTr), i, iTr)=1
          enddo
        enddo
      enddo
     
      ! double-check
      if (int(sum(bond)).ne.sum(nb(numnb,:,:))) then
        write(*,*) 
        write(*,*) 'Warning: Check mrec.f90',int(sum(bond)),sum(nb(numnb,:,:))
        write(*,*)
      endif

      ! recursive search for fragments 
      molvec=0 
      molcount=1
      taken=.false.
      do i=1,nat
          if(.not.taken(i)) then
            molvec(i)=molcount
            taken(i)=.true.
            call mrecgff2PBC(numctr,numnb,nat,nb,i,taken,bond,molvec,molcount)
            molcount=molcount+1
          endif
      enddo
      molcount=molcount-1
      end subroutine mrecgffPBC

      recursive subroutine mrecgff2PBC(numctr,numnb,nat,nb,i,taken,bond,molvec,molcnt)
      implicit none
      integer, intent(in) :: numctr, numnb, nat, nb(numnb,nat,numctr),i, molcnt
      integer j,icn,k,iTr, j_iTr(2)
      real*8, intent(inout) :: bond(nat,nat,numctr)
      integer, intent(inout) :: molvec(nat)
      logical, intent(inout) :: taken(nat)

      icn=sum(nb(numnb,i,:))
      do k=1,icn
         j_iTr=maxloc(bond(:,i,:))  ! get positions of the 1's one after another
         j  = j_iTr(1)
         iTr= j_iTr(2)
         bond(j,i,iTr)=0            ! set to zero to get to next 1-entry
         if (i .eq. j.and.iTr.eq.1) cycle
         if (.not.taken(j)) then
            molvec(j)=molcnt
            taken(j)=.true.
            call mrecgff2PBC(numctr,numnb,nat,nb,j,taken,bond,molvec,molcnt)
         endif
      enddo
      end subroutine mrecgff2PBC
end module xtb_gfnff_mrec

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Data for the generation of a force field topology
module xtb_gfnff_generator
   use xtb_mctc_accuracy, only : wp, sp
   implicit none
   private

   public :: TGFFGenerator


   !> Generator for the force field topology
   type TGFFGenerator

      !> when is an angle close to linear ? (GEODEP)
      !  for metals values closer to 170 (than to 160) are better
      real(wp) linthr

      !> skip torsion and bending if potential is small
      real(wp) fcthr

      !> R threshold in Angstroem for cov distance estimated used in apprx EEQ
      real(sp) tdist_thr

      !> important bond determination threshold, large values yield more 1.23
      real(wp) rthr

      !> decrease if a metal is present, larger values yield smaller CN
      real(wp) rthr2

      !> change of R0 for topo with charge qa
      !  larger values yield smaller CN for metals in particular
      real(wp) rqshrink

      !> H charge (qa) threshold for H in HB list 18
      real(wp) hqabthr

      !> AB charge (qa) threshold for AB in HB list
      !  - avoids HBs with positive atoms,
      !  - larger val. better for S30L but worse in PubChem RMSD checks
      real(wp) qabthr

      !> Parameter
      real(wp) srb1
      real(wp) srb2
      real(wp) srb3

      !> change of non-bonded rep. with q(topo)
      real(wp) qrepscal

      !> change of non-bonded rep. with CN
      real(wp) nrepscal

      !> HH repulsion
      real(wp) hhfac
      real(wp) hh13rep
      real(wp) hh14rep
      real(wp) bstren(9)

      !> bend FC change with polarity
      real(wp) qfacBEN

      !> torsion FC change with polarity
      real(wp) qfacTOR

      !> tors FC 3-ring
      real(wp) fr3

      !> tors FC 4-ring
      real(wp) fr4

      !> tors FC 5-ring
      real(wp) fr5

      !> tors FC 6-ring
      real(wp) fr6

      !> bonds
      real(wp) torsf(8)

      !> small bend corr.
      real(wp) fbs1

      !> bonded ATM scal
      real(wp) batmscal

      !> Shifts
      real(wp) mchishift

      !> gen shift
      real(wp) rabshift

      !> XH
      real(wp) rabshifth

      !> hypervalent
      real(wp) hyper_shift

      !> heavy
      real(wp) hshift3
      real(wp) hshift4
      real(wp) hshift5

      !> group 1+2 metals
      real(wp) metal1_shift

      !> TM
      real(wp) metal2_shift

      !> main group metals
      real(wp) metal3_shift

      !> eta bonded
      real(wp) eta_shift

      !> Charge Param
      real(wp) qfacbm(0:4)

      !> bond charge dependent
      real(wp) qfacbm0

      !> topo dist scaling
      real(wp) rfgoed1

      !> Hückel Param
      !  decrease Hueckel off-diag for triple bonds because they are less well conjugated 1.4
      real(wp) htriple

      !> increase pot depth depending on P
      real(wp) hueckelp2

      !> diagonal element change with qa
      real(wp) hueckelp3

      !> diagonal element relative to C
      real(wp) hdiag(17)

      !> Huckel off-diag constants
      real(wp) hoffdiag(17)

      !> iteration mixing
      real(wp) hiter

      !> diagonal qa dep.
      real(wp) hueckelp

      !> ref P value R shift
      real(wp) bzref

      !> ref P value k stretch
      real(wp) bzref2

      !> 2el diag shift
      real(wp) pilpf

      !> the Hückel iterations can diverge so take only a few steps
      real(wp) maxhiter

      !> D3 Param
      real(wp) d3a1

      !> D3
      real(wp) d3a2

      !> mixing of sp^n with sp^n-1
      real(wp) split0

      !> mixing of sp^n with sp^n-1
      real(wp) split1

      !> str ring size dep.
      real(wp) fringbo

      !> three coord. heavy eq. angle
      real(wp) aheavy3

      !> four coord. heavy eq. angle
      real(wp) aheavy4
      real(wp) bsmat(0:3,0:3)

      !> max CN cut-off
      real(wp) :: cnmax

   end type TGFFGenerator


contains


end module xtb_gfnff_generator

! This file is part of xtb.
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

module xtb_features
   implicit none
   private

   public :: get_xtb_feature

   logical, parameter :: tblite_support = WITH_TBLITE /= 0


contains

function get_xtb_feature(feature) result(has_feature)
   !> Feature name
   character(len=*), intent(in) :: feature
   !> Whether the feature is enabled
   logical :: has_feature

   select case(feature)
   case("tblite")
      has_feature = tblite_support
   case("color")
      has_feature = color_support()
   case default
      has_feature = .false.
   end select
end function get_xtb_feature

!> Check output terminal for color support
function color_support() result(color)
   use, intrinsic :: iso_fortran_env, only : output_unit
#if defined __INTEL_COMPILER
   use ifport, only : isatty
#endif
   !> Whether color can be supported
   logical :: color

   color = .false.
#if defined __GFORTRAN__ || defined __INTEL_COMPILER
   color = isatty(output_unit)
#endif
end function color_support

end module xtb_features

! This file is part of ancopt.
! SPDX-Identifier: LGPL-3.0-or-later
!
! ancopt is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! ancopt is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with ancopt.  If not, see <https://www.gnu.org/licenses/>.

module xtb_pbc_optimizer_filter_type
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule
   implicit none
   private

   public :: filter_type

   type, abstract :: filter_type
      logical :: optcell = .false.
   contains
      procedure(get_dimension), deferred :: get_dimension
      procedure(transform_structure), deferred :: transform_structure
      procedure(transform_derivative), deferred :: transform_derivative
   end type filter_type

   abstract interface
      pure function get_dimension(self) result(n)
         import :: filter_type
         class(filter_type), intent(in) :: self
         integer :: n
      end function get_dimension

      subroutine transform_structure(self, mol, displacement)
         import :: filter_type, TMolecule, wp
         class(filter_type), intent(in) :: self
         type(TMolecule), intent(inout) :: mol
         real(wp), intent(in) :: displacement(:)
      end subroutine transform_structure

      subroutine transform_derivative(self, mol, energy, gradient, sigma, val, deriv)
         import :: filter_type, TMolecule, wp
         class(filter_type), intent(in) :: self
         type(TMolecule), intent(in) :: mol
         real(wp), intent(in) :: energy
         real(wp), intent(in) :: gradient(:, :)
         real(wp), intent(in) :: sigma(:, :)
         real(wp), intent(out) :: val
         real(wp), intent(out) :: deriv(:)
      end subroutine transform_derivative
   end interface

end module xtb_pbc_optimizer_filter_type

!------------------------------------------------------------------------------
! This file is part of xtb.
!
! Copyright (C) 2017-2019 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
!------------------------------------------------------------------------------
module xtb_kopt
  use xtb_mctc_accuracy, only : wp
  use xtb_mctc_convert, only : autoaa
  use xtb_type_environment
  use xtb_type_molecule
  use xtb_type_restart
  use xtb_type_calculator
  use xtb_type_data
  use xtb_type_setvar
  use xtb_restart
  use xtb_setmod
  use xtb_setparam
  use xtb_geoopt
  use xtb_lsrmsd
  implicit none
  private :: wp
  public

contains
  
subroutine get_kopt( &
         & metaset,env,restart,mol,chk,calc,egap,et,maxiter,maxcycle,optlev,&
         & etot,g,sigma,acc)
  implicit none
! Dummy -----------------------------------------------------------------------
  class(TCalculator),intent(inout)            :: calc
  type(metadyn_setvar),intent(inout)          :: metaset
  type(TEnvironment),intent(inout)            :: env
  type(TMolecule),intent(inout)               :: mol
  type(TRestart),intent(inout)                :: chk
  integer,intent(in)                          :: maxiter
  integer,intent(in)                          :: maxcycle
  integer,intent(in)                          :: optlev
  real(wp),intent(inout)                      :: etot
  real(wp),intent(in)                         :: et
  real(wp),intent(in)                         :: acc
  real(wp),intent(inout)                      :: egap
  real(wp),intent(inout)                      :: g(3,mol%n)
  real(wp),intent(inout)                      :: sigma(3,3)
  logical,intent(in)                          :: restart
! Stack -----------------------------------------------------------------------
  type(TMolecule)                             :: tmol
  integer                                     :: i
  integer                                     :: idum
  real(wp)                                    :: current_rmsd
  real(wp)                                    :: kopt
  real(wp)                                    :: kbias
  real(wp)                                    :: ax,cx
  logical                                     :: fail
!! ========================================================================
  call generic_header(env%unit,"Optimal kpush determination",49,10)
!------------------------------------------------------------------------------
! copy input coordinates
  tmol=mol

! set kopt boundaries
  ax         =0.0_wp
  cx         =0.005_wp*(dble(mol%n)/(set%target_rmsd+0.01_wp))

  kbias = ax
  metaset%factor = -kbias
  call get_rmsd( &
                 & calc,env,restart,mol,chk,egap,et,maxiter,maxcycle,optlev,&
                 & etot,g,sigma,current_rmsd)
  write(env%unit,'("target rmsd / Å        ",f9.6)') set%target_rmsd  
  write(env%unit,'("unbiased initial rmsd  ",f9.6)') current_rmsd  
  write(env%unit,*)
  write(env%unit,'("iter. min.        max.        rmsd       kpush")') 
  if ( current_rmsd.gt.set%target_rmsd ) then
     do i = 1,10
        mol=tmol
        kbias = 0.5_wp * (cx +ax)
        metaset%factor = -kbias
        call get_rmsd( &
                       & calc,env,restart,mol,chk,egap,et,maxiter,maxcycle,optlev,&
                       & etot,g,sigma,current_rmsd)
        write(*,'(i2,4f12.6)') i,&
        &ax,cx,current_rmsd,metaset%factor(metaset%nstruc)
        if ( current_rmsd.gt.set%target_rmsd ) then
           ax = kbias
        else
           cx = kbias
        end if
        if ( abs(current_rmsd-set%target_rmsd) .lt. 1.0d-3 ) exit
     end do
  end if
  kopt = kbias
  metaset%factor = -kopt
  write(env%unit,'("final kpush: ",f9.6)') -kopt   

end subroutine get_kopt

subroutine get_rmsd( &
         & calc,env,restart,mol,chk,egap,et,maxiter,maxcycle,optlev,&
         & etot,g,sigma,rmsdval)
  implicit none
! Dummy -----------------------------------------------------------------------
  class(TCalculator),intent(inout)            :: calc
  type(TEnvironment),intent(inout)            :: env
  type(TMolecule),intent(inout)               :: mol
  type(TRestart),intent(inout)                :: chk
  integer,intent(in)                          :: maxiter
  integer,intent(in)                          :: maxcycle
  integer,intent(in)                          :: optlev
  real(wp),intent(inout)                      :: etot
  real(wp),intent(in)                         :: et
  real(wp),intent(out)                        :: rmsdval
  real(wp),intent(inout)                      :: egap
  real(wp),intent(inout)                      :: g(3,mol%n)
  real(wp),intent(inout)                      :: sigma(3,3)
  logical,intent(in)                          :: restart
! Stack -----------------------------------------------------------------------
  type(TMolecule)                             :: tmol
  integer                                     :: idum
  real(wp)                                    :: U(3,3)
  real(wp)                                    :: x_center(3),y_center(3)
  real(wp),allocatable                        :: grad(:,:)
  logical                                     :: fail
!------------------------------------------------------------------------------
! save input geometry
  tmol=mol
!------------------------------------------------------------------------------
! geometry optimization
  call geometry_optimization &
      &     (env,mol,chk,calc,   &
      &      egap,set%etemp,maxiter,maxcycle,etot,g,sigma,optlev,.false.,.true.,fail)

  allocate( grad(3,mol%n), source = 0.0_wp )
  call rmsd(mol%n,mol%xyz,tmol%xyz,1,U,x_center,y_center,rmsdval,.true.,grad)
  rmsdval=rmsdval*autoaa

end subroutine get_rmsd

end module xtb_kopt

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> LAPACK linear equation solvers.
module xtb_mctc_lapack_tri
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_type_environment, only : TEnvironment
   implicit none
   private

   public :: mctc_getri, mctc_sytri, mctc_sptri, mctc_potri, mctc_pptri

   public :: lapack_getri, lapack_sytri, lapack_sptri, lapack_potri, lapack_pptri


   interface mctc_getri
      module procedure :: mctc_sgetri
      module procedure :: mctc_dgetri
   end interface mctc_getri

   interface mctc_sytri
      module procedure :: mctc_ssytri
      module procedure :: mctc_dsytri
   end interface mctc_sytri

   interface mctc_sptri
      module procedure :: mctc_ssptri
      module procedure :: mctc_dsptri
   end interface mctc_sptri

   interface mctc_potri
      module procedure :: mctc_spotri
      module procedure :: mctc_dpotri
   end interface mctc_potri

   interface mctc_pptri
      module procedure :: mctc_spptri
      module procedure :: mctc_dpptri
   end interface mctc_pptri


   interface lapack_getri
      pure subroutine sgetri(n, a, lda, ipiv, work, lwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine sgetri
      pure subroutine dgetri(n, a, lda, ipiv, work, lwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine dgetri
      pure subroutine cgetri(n, a, lda, ipiv, work, lwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine cgetri
      pure subroutine zgetri(n, a, lda, ipiv, work, lwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine zgetri
   end interface lapack_getri

   interface lapack_sytri
      pure subroutine ssytri(uplo, n, a, lda, ipiv, work, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(sp), intent(in) :: work(*)
      end subroutine ssytri
      pure subroutine dsytri(uplo, n, a, lda, ipiv, work, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         real(dp), intent(in) :: work(*)
      end subroutine dsytri
      pure subroutine csytri(uplo, n, a, lda, ipiv, work, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(sp), intent(in) :: work(*)
      end subroutine csytri
      pure subroutine zsytri(uplo, n, a, lda, ipiv, work, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         complex(dp), intent(in) :: work(*)
      end subroutine zsytri
   end interface lapack_sytri

   interface lapack_sptri
      pure subroutine ssptri(uplo, n, ap, ipiv, work, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         real(sp), intent(in) :: work(*)
      end subroutine ssptri
      pure subroutine dsptri(uplo, n, ap, ipiv, work, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         real(dp), intent(in) :: work(*)
      end subroutine dsptri
      pure subroutine csptri(uplo, n, ap, ipiv, work, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         complex(sp), intent(in) :: work(*)
      end subroutine csptri
      pure subroutine zsptri(uplo, n, ap, ipiv, work, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         integer, intent(in) :: ipiv(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         complex(dp), intent(in) :: work(*)
      end subroutine zsptri
   end interface lapack_sptri

   interface lapack_potri
      pure subroutine spotri(uplo, n, a, lda, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine spotri
      pure subroutine dpotri(uplo, n, a, lda, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine dpotri
      pure subroutine cpotri(uplo, n, a, lda, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine cpotri
      pure subroutine zpotri(uplo, n, a, lda, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
      end subroutine zpotri
   end interface lapack_potri

   interface lapack_pptri
      pure subroutine spptri(uplo, n, ap, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine spptri
      pure subroutine dpptri(uplo, n, ap, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine dpptri
      pure subroutine cpptri(uplo, n, ap, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine cpptri
      pure subroutine zpptri(uplo, n, ap, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
      end subroutine zpptri
   end interface lapack_pptri


contains


subroutine mctc_sgetri(env, amat, ipiv)
   character(len=*), parameter :: source = 'mctc_lapack_getri'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   integer :: info, n, lda, lwork, stat_alloc, stat_dealloc
   real(sp), allocatable :: work(:)
   real(sp) :: test(1)
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0
   lwork = -1
   call lapack_getri(n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      allocate(work(lwork), stat=stat_alloc)
      if (stat_alloc==0) then
         call lapack_getri(n, amat, lda, ipiv, work, lwork, info)
      else
         info = -1000
      end if
      deallocate(work, stat=stat_dealloc)
   end if
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_sgetri


subroutine mctc_dgetri(env, amat, ipiv)
   character(len=*), parameter :: source = 'mctc_lapack_getri'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   integer :: info, n, lda, lwork, stat_alloc, stat_dealloc
   real(dp), allocatable :: work(:)
   real(dp) :: test(1)
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0
   lwork = -1
   call lapack_getri(n, amat, lda, ipiv, test, lwork, info)
   if (info == 0) then
      lwork = nint(test(1))
      allocate(work(lwork), stat=stat_alloc)
      if (stat_alloc==0) then
         call lapack_getri(n, amat, lda, ipiv, work, lwork, info)
      else
         info = -1000
      end if
      deallocate(work, stat=stat_dealloc)
   end if
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_dgetri


subroutine mctc_ssytri(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sytri'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, lda, stat_alloc, stat_dealloc
   real(sp), allocatable :: work(:)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0
   allocate(work(n), stat=stat_alloc)
   if (stat_alloc==0) then
      call lapack_sytri(ula, n, amat, lda, ipiv, work, info)
   else
      info = -1000
   end if
   deallocate(work, stat=stat_dealloc)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_ssytri


subroutine mctc_dsytri(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sytri'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, lda, stat_alloc, stat_dealloc
   real(dp), allocatable :: work(:)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   stat_alloc = 0
   allocate(work(n), stat=stat_alloc)
   if (stat_alloc==0) then
      call lapack_sytri(ula, n, amat, lda, ipiv, work, info)
   else
      info = -1000
   end if
   deallocate(work, stat=stat_dealloc)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_dsytri


subroutine mctc_ssptri(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sptri'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, stat_alloc, stat_dealloc, nn
   real(sp), allocatable :: work(:)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   end if
   stat_alloc = 0
   allocate(work(n), stat=stat_alloc)
   if (stat_alloc==0) then
      call lapack_sptri(ula, n, amat, ipiv, work, info)
   else
      info = -1000
   end if
   deallocate(work, stat=stat_dealloc)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_ssptri


subroutine mctc_dsptri(env, amat, ipiv, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_sptri'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:)
   integer, intent(in) :: ipiv(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, stat_alloc, stat_dealloc, nn
   real(dp), allocatable :: work(:)
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   end if
   stat_alloc = 0
   allocate(work(n), stat=stat_alloc)
   if (stat_alloc==0) then
      call lapack_sptri(ula, n, amat, ipiv, work, info)
   else
      info = -1000
   end if
   deallocate(work, stat=stat_dealloc)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_dsptri


subroutine mctc_spotri(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_potri'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, lda
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call lapack_potri(ula, n, amat, lda, info)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_spotri


subroutine mctc_dpotri(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_potri'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:, :)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, lda
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   lda = max(1, size(amat, 1))
   n = size(amat, 2)
   call lapack_potri(ula, n, amat, lda, info)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_dpotri


subroutine mctc_spptri(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_pptri'
   type(TEnvironment), intent(inout) :: env
   real(sp), intent(inout) :: amat(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, sp))))/2
   end if
   call lapack_pptri(ula, n, amat, info)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_spptri


subroutine mctc_dpptri(env, amat, uplo)
   character(len=*), parameter :: source = 'mctc_lapack_pptri'
   type(TEnvironment), intent(inout) :: env
   real(dp), intent(inout) :: amat(:)
   character(len=1), intent(in), optional :: uplo
   character(len=1) :: ula
   integer :: info, n, nn
   if (present(uplo)) then
      ula = uplo
   else
      ula = 'u'
   end if
   nn = size(amat)
   if (nn <= 0) then
      n = nn
   else
      n = int((-1+sqrt(1+8*real(nn, dp))))/2
   end if
   call lapack_pptri(ula, n, amat, info)
   if (info /= 0) then
      call env%error("Inverting matrix failed", source)
   end if
end subroutine mctc_dpptri


end module xtb_mctc_lapack_tri

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Two-step SCF of the PTB method

module xtb_ptb_scf
#if WITH_TBLITE
   use mctc_io, only: structure_type
   use mctc_env, only: wp, error_type, fatal_error

   use tblite_basis_type, only: basis_type, get_cutoff
   use tblite_blas, only: gemv
   use tblite_context, only: context_type
   use tblite_scf_solver, only: solver_type
   use tblite_scf_iterator, only: get_qat_from_qsh
   use tblite_adjlist, only: adjacency_list, new_adjacency_list
   use tblite_cutoff, only: get_lattice_points
   use tblite_wavefunction, only: wavefunction_type, get_alpha_beta_occupation
   use tblite_wavefunction_fermi, only: get_fermi_filling
   use tblite_wavefunction_type, only: get_density_matrix
   use tblite_wavefunction_mulliken, only: get_mulliken_atomic_multipoles, &
      & get_mulliken_shell_charges, get_mayer_bond_orders, get_molecular_quadrupole_moment, &
      & get_molecular_dipole_moment
   use tblite_scf_potential, only: potential_type, new_potential, add_pot_to_h1
   use tblite_integral_type, only: new_integral, integral_type
   use tblite_container, only: container_type, container_cache
   use tblite_external_field, only: electric_field

   use multicharge_model, only: mchrg_model_type

   use xtb_ptb_vdzp, only: add_vDZP_basis, nshell, max_shell
   use xtb_ptb_param, only: ptbGlobals, rf
   use xtb_ptb_integrals, only: get_integrals
   use xtb_ptb_mmlpopanalysis, only: get_mml_overlaps, get_mml_shell_charges
   use xtb_ptb_ncoord, only: ncoord_erf
   use xtb_ptb_corebasis, only: get_Vecp
   use xtb_ptb_data, only: TPTBData
   use xtb_ptb_hamiltonian, only: get_hamiltonian, get_selfenergy, get_occupation
   use xtb_ptb_guess, only: guess_qsh, get_psh_from_qat, get_psh_from_qsh
   use xtb_ptb_paulixc, only: calc_Vxc_pauli
   use xtb_ptb_integral_types, only: aux_integral_type, new_aux_integral
   use xtb_ptb_coulomb, only: coulomb_potential
   use xtb_ptb_plusu, only: plusu_potential_type

   use xtb_readin, only: bool2string, bool2int

   implicit none
   private

   public :: twostepscf, get_density

   character(len=*), private, parameter :: outfmt = &
                                           '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'
   character(len=*), parameter :: intfmt = &
                                  '(10x,":",2x,a,i18,      10x,":")'
   character(len=*), parameter :: chrfmt = &
                                  '(10x,":",2x,a,a18,      10x,":")'
   character(len=*), parameter :: scifmt = &
                                  '(10x,":",2x,a,e22.7,1x,a,1x,":")'
   character(len=*), parameter :: dblfmt = &
                                  '(10x,":",2x,a,f18.7,5x,a,1x,":")'
   character(len=*), parameter :: source = "twostepscf"

   real(wp), parameter :: default_cutoff = 25.0_wp
   !> Conversion factor from temperature to energy
   real(wp), parameter :: kt = 3.166808578545117e-06_wp

contains

   !> Final Hamiltonian to solve (2nd iteration) on ints%hamiltonian
   subroutine twostepscf(ctx, wfn, data, mol, bas, cbas, ints, auxints, &
         & eeqmodel, dipole, quadrupole, vecp, list, levels, v_es_sh, cn_star, wbo, efield)
      !> Calculation context
      type(context_type), intent(inout) :: ctx
      !> Wavefunction of tblite type
      type(wavefunction_type), intent(inout) :: wfn
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> PTB parameterization data
      type(TPTBData), intent(in) :: data
      !> Basis set and core-valence basis set data
      type(basis_type), intent(in) :: bas, cbas
      !> Integral type
      type(integral_type), intent(out) :: ints
      !> Auxiliary integral type
      type(aux_integral_type), intent(out) :: auxints
      !> Initialized EEQ model
      type(mchrg_model_type), intent(in) :: eeqmodel
      !> Molecular dipole moment
      real(wp), intent(out) :: dipole(3)
      !> Molecular quadrupole moment
      real(wp), intent(out) :: quadrupole(6)
      !> Wiberg bond orders
      real(wp), allocatable, intent(out) :: wbo(:, :, :)
      !> Effective core potential
      real(wp), allocatable, intent(out) :: vecp(:, :)
      !> Adjacency list
      type(adjacency_list), intent(out) :: list
      !> Effective self-energies
      real(wp), allocatable, intent(out) :: levels(:)
      !> Electrostatic potential in second iteration
      real(wp), allocatable, intent(out) :: v_es_sh(:)
      !> (optional) Electric field
      real(wp), intent(in), optional :: efield(:)
      !> Electronic solver
      class(solver_type), allocatable :: solver
      !> Error type
      type(error_type), allocatable :: error
      !> Coulomb potential
      type(coulomb_potential) :: coulomb
      !> +U potential
      type(plusu_potential_type) :: plusu
      !> Potential type
      type(potential_type) :: pot
      !> H0 basis in second iteration
      type(basis_type), allocatable :: bas_h0
      !> Restart data for interaction containers
      type(container_cache) :: icache
      !> Electric field object
      type(electric_field) :: efield_object
      real(wp), allocatable :: expscal_h0_2nditer(:, :)
      !> Loop variables
      integer :: i, j, isp, izp, iat, ish, iid, is
      !> Coordination numbers
      real(wp), intent(out) :: cn_star(mol%nat)
      real(wp) :: cn(mol%nat), cn_eeq(mol%nat)
      real(wp) :: radii(mol%nid)
      !> Lattice points
      real(wp), allocatable :: lattr(:, :)
      !> Cutoff for lattice points
      real(wp) :: cutoff
      !> Number of electrons
      real(wp) :: nel
      !> Shell populations required for Pauli XC potential
      real(wp), allocatable :: psh(:, :)
      !> Electronic entropy
      real(wp) :: ts
      !> Tmp variable for dipole moment
      real(wp) :: tmpdip(3)
      real(wp), allocatable :: mulliken_qsh(:, :), mulliken_qat(:, :)

      !> debug mode
      logical, parameter :: alternative_dipole = .false.
      logical, parameter :: debug(15) = [ .false., .false., .false., .false., .false., &
                              .false., .false., .false., .false., .false., .false., &
                              .false., .false., .false., .false.] 

      !> Solver for the effective Hamiltonian
      call ctx%new_solver(solver, bas%nao)

      if (present(efield)) then
         efield_object = electric_field(efield)
      end if

      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)

      !            _____                    _____                _____                    _____                    _____
      !           /\    \                  /\    \              /\    \                  /\    \                  /\    \
      !          /::\    \                /::\    \            /::\    \                /::\____\                /::\    \
      !         /::::\    \              /::::\    \           \:::\    \              /:::/    /               /::::\    \
      !        /::::::\    \            /::::::\    \           \:::\    \            /:::/    /               /::::::\    \
      !       /:::/\:::\    \          /:::/\:::\    \           \:::\    \          /:::/    /               /:::/\:::\    \
      !      /:::/__\:::\    \        /:::/__\:::\    \           \:::\    \        /:::/    /               /:::/__\:::\    \
      !      \:::\   \:::\    \      /::::\   \:::\    \          /::::\    \      /:::/    /               /::::\   \:::\    \
      !    ___\:::\   \:::\    \    /::::::\   \:::\    \        /::::::\    \    /:::/    /      _____    /::::::\   \:::\    \
      !   /\   \:::\   \:::\    \  /:::/\:::\   \:::\    \      /:::/\:::\    \  /:::/____/      /\    \  /:::/\:::\   \:::\____\
      !  /::\   \:::\   \:::\____\/:::/__\:::\   \:::\____\    /:::/  \:::\____\|:::|    /      /::\____\/:::/  \:::\   \:::|    |
      !  \:::\   \:::\   \::/    /\:::\   \:::\   \::/    /   /:::/    \::/    /|:::|____\     /:::/    /\::/    \:::\  /:::|____|
      !   \:::\   \:::\   \/____/  \:::\   \:::\   \/____/   /:::/    / \/____/  \:::\    \   /:::/    /  \/_____/\:::\/:::/    /
      !    \:::\   \:::\    \       \:::\   \:::\    \      /:::/    /            \:::\    \ /:::/    /            \::::::/    /
      !     \:::\   \:::\____\       \:::\   \:::\____\    /:::/    /              \:::\    /:::/    /              \::::/    /
      !      \:::\  /:::/    /        \:::\   \::/    /    \::/    /                \:::\__/:::/    /                \::/____/
      !       \:::\/:::/    /          \:::\   \/____/      \/____/                  \::::::::/    /                  ~~
      !        \::::::/    /            \:::\    \                                    \::::::/    /
      !         \::::/    /              \:::\____\                                    \::::/    /
      !          \::/    /                \::/    /                                     \::/____/
      !           \/____/                  \/____/                                       ~~

      !    _____           _                                   _
      !   |_   _|         | |                                 | |
      !     | |    _ __   | |_    ___    __ _   _ __    __ _  | |  ___
      !     | |   | '_ \  | __|  / _ \  / _` | | '__|  / _` | | | / __|
      !    _| |_  | | | | | |_  |  __/ | (_| | | |    | (_| | | | \__ \
      !   |_____| |_| |_|  \__|  \___|  \__, | |_|     \__,_| |_| |___/
      !                                  __/ |
      !                                 |___/

      call new_integral(ints, bas%nao)
      call new_aux_integral(auxints, bas%nao)
      call get_integrals(mol, bas, lattr, list, ints%overlap, ints%dipole, ints%quadrupole, norm=auxints%norm)
      
      if (debug(1)) then !##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f8.5)', advance="no") ints%overlap(i, j)
            end do
            write (*, *) ""
         end do
         write (*, *) "Dipole moment integrals:"
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(2i3,3f8.4)') i, j, ints%dipole(:, i, j)
            end do
         end do
         write (*, *) "Quadrupole moment integrals:"
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(2i3,6f8.4)') i, j, ints%quadrupole(:, i, j)
            end do
         end do
      endif

      call get_integrals(mol, lattr, list, auxints%overlap_h0_1, alpha_scal=id_to_atom(mol, data%hamiltonian%kalphah0l))
      
      if (debug(2)) then!##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f10.6)', advance="no") auxints%overlap_h0_1(i, j)
            end do
            write (*, *) ""
         end do
      endif

      call get_integrals(mol, lattr, list, auxints%overlap_xc, alpha_scal=id_to_atom(mol, data%pauli%klalphaxc))
      
      if (debug(3)) then!##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f10.6)', advance="no") auxints%overlap_xc(i, j)
            end do
            write (*, '(/)', advance="no")
         end do
      endif

      call get_mml_overlaps(bas, ints%overlap, ptbGlobals%mlmix, auxints%overlap_to_x, &
      & auxints%overlap_to_1_x)

      !     _____   _   _
      !    / ____| | \ | |
      !   | |      |  \| |
      !   | |      | . ` |
      !   | |____  | |\  |
      !    \_____| |_| \_|

      !> Get first coordination number (" CN' ")
      call ncoord_erf(mol, ptbGlobals%kerfcn, default_cutoff, cn_star)
      
      if (debug(4)) then !##### DEV WRITE #####
         write (*, *) "CN star:"
         do i = 1, mol%nat
            write (*, *) "Atom ", i, ":", cn_star(i)
         end do
      endif
         
      !> Get radii from PTB parameters for second coordination number (" CN ")
      do isp = 1, mol%nid
         izp = mol%num(isp)
         radii(isp) = rf(izp)
      end do
      !> Get second coordination number (" CN ")
      call ncoord_erf(mol, ptbGlobals%kerfcn, default_cutoff, cn, covrad=radii)
      if (debug(5)) then !##### DEV WRITE #####
         write (*, *) "CN:"
         do i = 1, mol%nat
            write (*, *) "Atom ", i, ":", cn(i)
         end do
      endif

      !> Get third coordination number for EEQ model (" CN-EEQ ")
      call ncoord_erf(mol, ptbGlobals%kerfcn_eeq, default_cutoff, cn_eeq)

      if (debug(6)) then !##### DEV WRITE #####
         write (*, *) "CN-EEQ:"
         do i = 1, mol%nat
            write (*, *) "Atom ", i, ":", cn_eeq(i)
         end do
      endif

      !    _    _    ___
      !   | |  | |  / _ \
      !   | |__| | | | | |
      !   |  __  | | | | |
      !   | |  | | | |_| |
      !   |_|  |_|  \___/

      !> V_ECP via PTB core basis
      call get_Vecp(mol, data%corepotential, bas, cbas, auxints%norm, vecp)
      
      if (debug(7)) then !##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f10.6)', advance="no") vecp(i, j)
            end do
            write (*, *) ""
         end do
      endif
      
      !> Get the effective self-energies
      call get_selfenergy(mol, bas, data%hamiltonian, cn, cn_star, levels)

      !    ______   _                 _
      !   |  ____| | |               | |
      !   | |__    | |   ___    ___  | |_   _ __    ___
      !   |  __|   | |  / _ \  / __| | __| | '__|  / _ \
      !   | |____  | | |  __/ | (__  | |_  | |    | (_) |
      !   |______| |_|  \___|  \___|  \__| |_|     \___/

      !> EEQ call
      call eeqmodel%solve(mol, cn_eeq, qvec=wfn%qat(:, 1))
      if (debug(8)) then !##### DEV WRITE #####
         write (*, *) "EEQ charges:"
         do i = 1, mol%nat
            write (*, '(a,i0,a,f12.6)') "Atom ", i, ":", wfn%qat(i, 1)
         end do
      endif
      
      !> Project reference occupation on wavefunction and use EEQ charges as guess
      call get_occupation(mol, bas, data%hamiltonian%refocc, wfn%nocc, wfn%n0at, wfn%n0sh)
      call guess_qsh(wfn, bas)
      if (debug(9)) then !##### DEV WRITE #####
         do i = 1, bas%nsh
            write(*,*) wfn%qsh(i, 1)
         enddo
      endif

      call coulomb%init(mol, bas, wfn%qat(:, 1), data%coulomb%shellHardnessFirstIter, &
         & data%coulomb%kQHubbard, data%coulomb%kOK1, data%coulomb%kTO)
      call coulomb%update(mol, bas)

      if (ctx%verbosity > 1) then
         write (ctx%unit, '(/,10x,51("."))')
         write (ctx%unit, '(10x,":",22x,a,22x,":")') "SETUP"
         write (ctx%unit, '(10x,":",49("."),":")')
         write (ctx%unit, intfmt) "# atomic orbitals  ", bas%nao
         write (ctx%unit, intfmt) "# shells           ", bas%nsh
         write (ctx%unit, intfmt) "# electrons        ", nint(wfn%nocc)
         write (ctx%unit, intfmt) "# open shells      ", mol%uhf
         write (ctx%unit, intfmt) "max. iterations    ", 2
         write (ctx%unit, chrfmt) "Hamiltonian        ", "PTB"
         write (ctx%unit, chrfmt) "PC potential       ", bool2string(.false.)
         ! if (lpcem) then
         !    write (env%unit, intfmt) "-> # point charges ", pcem%n
         !    write (env%unit, dblfmt) "-> sum of PC       ", sum(pcem%q), "e   "
         ! end if
         write (ctx%unit, dblfmt) "electronic temp.   ", wfn%kt / kt, "K   "
         ! write (env%unit, dblfmt) "accuracy           ", acc, "    "
         write (ctx%unit, scifmt) "-> integral cutoff ", bas%intcut, "    "
         ! write (env%unit, scifmt) "-> integral neglect", neglect, "    "
         write (ctx%unit, intfmt) "verbosity level    ", ctx%verbosity
         write (ctx%unit, '(10x,51("."))')
      end if

      if (ctx%verbosity > 1) then
         write (ctx%unit, '(/,10x,a)') "--- Calculation progress: ---"
         write (ctx%unit, '(14x,a)') "1st iteration..."
      end if

      !           _____                    _____                    _____
      !         /\    \                  /\    \                  /\    \
      !        /::\    \                /::\    \                /::\    \
      !       /::::\    \              /::::\    \              /::::\    \
      !      /::::::\    \            /::::::\    \            /::::::\    \
      !     /:::/\:::\    \          /:::/\:::\    \          /:::/\:::\    \
      !    /:::/__\:::\    \        /:::/  \:::\    \        /:::/__\:::\    \
      !    \:::\   \:::\    \      /:::/    \:::\    \      /::::\   \:::\    \
      !  ___\:::\   \:::\    \    /:::/    / \:::\    \    /::::::\   \:::\    \
      ! /\   \:::\   \:::\    \  /:::/    /   \:::\    \  /:::/\:::\   \:::\    \
      !/::\   \:::\   \:::\____\/:::/____/     \:::\____\/:::/  \:::\   \:::\____\
      !\:::\   \:::\   \::/    /\:::\    \      \::/    /\::/    \:::\   \::/    /
      ! \:::\   \:::\   \/____/  \:::\    \      \/____/  \/____/ \:::\   \/____/
      !  \:::\   \:::\    \       \:::\    \                       \:::\    \
      !   \:::\   \:::\____\       \:::\    \                       \:::\____\
      !    \:::\  /:::/    /        \:::\    \                       \::/    /
      !     \:::\/:::/    /          \:::\    \                       \/____/
      !      \::::::/    /            \:::\    \
      !       \::::/    /              \:::\____\
      !        \::/    /                \::/    /
      !         \/____/                  \/____/

      !   _     _     _ _                 _   _
      !  / |___| |_  (_) |_ ___ _ __ __ _| |_(_) ___  _ __
      !  | / __| __| | | __/ _ \ '__/ _` | __| |/ _ \| '_ \
      !  | \__ \ |_  | | ||  __/ | | (_| | |_| | (_) | | | |
      !  |_|___/\__| |_|\__\___|_|  \__,_|\__|_|\___/|_| |_|

      !> Set up the effective Hamiltonian in the first iteration
      call new_potential(pot, mol, bas, wfn%nspin)
      !    _    _  ___
      !   | |  | |/ _ \
      !   | |__| | | | |
      !   |  __  | | | |
      !   | |  | | |_| |
      !   |_|  |_|\___/
      !
      !>  --------- Get H0 (wavefunction-independent (but iteration-dependent)) ----------

      ints%hamiltonian = 0.0_wp
      call get_hamiltonian(mol, list, bas, data%hamiltonian, data%hamiltonian%kla, auxints%overlap_h0_1, &
      & levels, ints%hamiltonian, ptbGlobals%kpol, ptbGlobals%kitr, ptbGlobals%kitocod)
      ints%hamiltonian = ints%hamiltonian + vecp
      if (debug(10)) then !##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f8.4)', advance="no") ints%hamiltonian(i, j)
            end do
            write (*, '(/)', advance="no")
         end do
      endif
      

      !    _____      _             _   _       _
      !   |  __ \    | |           | | (_)     | |
      !   | |__) |__ | |_ ___ _ __ | |_ _  __ _| |
      !   |  ___/ _ \| __/ _ \ '_ \| __| |/ _` | |
      !   | |  | (_) | ||  __/ | | | |_| | (_| | |
      !   |_|   \___/ \__\___|_| |_|\__|_|\__,_|_|
      !
      !>  --------- Get potential (wavefunction-dependent) -----

      call pot%reset()
      !> Coulomb potential
      call coulomb%get_potential(wfn, pot)
      call add_pot_to_h1(bas, ints, pot, wfn%coeff)

      !> Pauli XC potential
      allocate (psh(bas%nsh, wfn%nspin), source=0.0_wp)
      psh = get_psh_from_qat(wfn, bas)
      call calc_Vxc_pauli(mol, bas, psh(:, 1), auxints%overlap_xc, levels, data%pauli%kxc1, wfn%coeff(:, :, 1))

      if (debug(11)) then!##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f11.7)', advance="no") wfn%coeff(i, j, 1)
            end do
            write (*, '(/)', advance="no")
         end do
      endif

      !   __       _
      !  / _\ ___ | |_   _____
      !  \ \ / _ \| \ \ / / _ \
      !  _\ \ (_) | |\ V /  __/
      !  \__/\___/|_| \_/ \___|

      !> Project occupations on alpha and beta orbitals
      nel = sum(wfn%n0at) - mol%charge
      if (mod(mol%uhf, 2) == mod(nint(nel), 2)) then
         wfn%nuhf = mol%uhf
      else
         call fatal_error(error, "Number of electrons and spin multiplicity do not match.")
      end if
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if
      call get_alpha_beta_occupation(wfn%nocc, wfn%nuhf, wfn%nel(1), wfn%nel(2))
      call get_density(wfn, solver, ints, ts, error)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if

      call get_mml_shell_charges(bas, auxints%overlap_to_x, auxints%overlap_to_1_x, &
         & wfn%density, wfn%n0sh, wfn%qsh)
      call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)
      psh = get_psh_from_qsh(wfn, bas)
      
      if (debug(12)) then !##### DEV WRITE #####
         write (*, *) "Shell charges after 1st iteration ..."
         do i = 1, bas%nsh
            write (*, '(f8.4)') wfn%qsh(i, 1)
         end do
         write (*, *) "Atomic charges after 1st iteration ..."
         do i = 1, mol%nat
            write (*, '(f8.4)') wfn%qat(i, 1)
         end do
      endif

      if (ctx%verbosity > 1) then
         write (ctx%unit, '(14x,a)') "2nd iteration..."
      end if

      !   ____            _   _ _                 _   _
      !  |___ \ _ __   __| | (_) |_ ___ _ __ __ _| |_(_) ___  _ __
      !    __) | '_ \ / _` | | | __/ _ \ '__/ _` | __| |/ _ \| '_ \
      !   / __/| | | | (_| | | | ||  __/ | | (_| | |_| | (_) | | | |
      !  |_____|_| |_|\__,_| |_|\__\___|_|  \__,_|\__|_|\___/|_| |_|

      !    _    _  ___
      !   | |  | |/ _ \
      !   | |__| | | | |
      !   |  __  | | | |
      !   | |  | | |_| |
      !   |_|  |_|\___/

      !>  --------- Get H0 (wavefunction-independent (but iteration-dependent)) ----------
      !> Allocate temporary basis set and charge-dependent scaling factors
      !> Consequently, the basis set is not equal for same atom ids but different
      !> for each symmetry-unique atom
      allocate (bas_h0)
      allocate (expscal_h0_2nditer(max_shell, mol%nat), source=1.0_wp)
      do iat = 1, mol%nat
         iid = mol%id(iat)
         is = bas%ish_at(iat)
         do ish = 1, bas%nsh_at(iat)
            expscal_h0_2nditer(ish, iat) = data%hamiltonian%kalphah0l(ish, iid) * &
               & (1.0_wp + data%hamiltonian%kits0(iid) * wfn%qsh(is + ish, 1))
            
            if (debug(13)) then !##### DEV WRITE #####
               write(*,*) "qsh: ", wfn%qsh(is + ish, 1)
               write (*, *) "Atom ", iat, ":", expscal_h0_2nditer(ish, iat)
            endif

         end do
      end do
      !> Get temporary basis set with charge-dependent scaled exponents
      call add_vDZP_basis(mol, expscal_h0_2nditer, bas_h0)
      !> Get integrals with temporary basis set
      call get_integrals(mol, bas_h0, lattr, list, auxints%overlap_h0_2)
      !> Deallocate temporary basis set and charge-dependent scaling factors
      deallocate (bas_h0, expscal_h0_2nditer)
      
      if (debug(14)) then !##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f10.6)', advance="no") auxints%overlap_h0_2(i, j)
            end do
            write (*, *) ""
         end do
      endif

      ints%hamiltonian = 0.0_wp
      call get_hamiltonian(mol, list, bas, data%hamiltonian, data%hamiltonian%kla, auxints%overlap_h0_2, &
      & levels, ints%hamiltonian, ptbGlobals%kpol)
      ints%hamiltonian = ints%hamiltonian + vecp
      
      if (debug(15)) then!##### DEV WRITE #####
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f11.7)', advance="no") ints%hamiltonian(i, j)
            end do
            write (*, '(/)', advance="no")
         end do
      endif

      !    _____      _             _   _       _
      !   |  __ \    | |           | | (_)     | |
      !   | |__) |__ | |_ ___ _ __ | |_ _  __ _| |
      !   |  ___/ _ \| __/ _ \ '_ \| __| |/ _` | |
      !   | |  | (_) | ||  __/ | | | |_| | (_| | |
      !   |_|   \___/ \__\___|_| |_|\__|_|\__,_|_|
      !
      !>  --------- Get potential (wavefunction-dependent) -----
      call coulomb%init(mol, bas, wfn%qat(:, 1), data%coulomb%shellHardnessSecondIter, &
         & 0.0_wp, data%coulomb%kOK2, data%coulomb%kTO)
      call plusu%init(data%plusU, mol, bas, wfn%qat(:, 1), cn_star)

      call pot%reset()
      call coulomb%update(mol, bas)
      call coulomb%get_potential(wfn, pot)
      allocate (v_es_sh(bas%nsh), source=0.0_wp)
      v_es_sh(:) = pot%vsh(:, 1)
      if (present(efield)) then
         call efield_object%update(mol, icache)
         call efield_object%get_potential(mol, icache, wfn, pot)
      end if
      call add_pot_to_h1(bas, ints, pot, wfn%coeff)
      call calc_Vxc_pauli(mol, bas, psh(:, 1), auxints%overlap_xc, levels, data%pauli%kxc2l, wfn%coeff(:, :, 1))
      call plusu%get_potential(mol, bas, wfn%density(:, :, 1), wfn%coeff(:, :, 1))

      ints%hamiltonian = wfn%coeff(:, :, 1)
      call get_density(wfn, solver, ints, ts, error, ptbGlobals%geps, ptbGlobals%geps0)
      if (allocated(error)) then
         call ctx%set_error(error)
         return
      end if

      call get_mml_shell_charges(bas, auxints%overlap_to_x, auxints%overlap_to_1_x, &
         & wfn%density, wfn%n0sh, wfn%qsh)
      psh = get_psh_from_qsh(wfn, bas)
      call get_qat_from_qsh(bas, wfn%qsh, wfn%qat)
      call get_mulliken_atomic_multipoles(bas, ints%dipole, wfn%density, &
         & wfn%dpat)
      call get_mulliken_atomic_multipoles(bas, ints%quadrupole, wfn%density, &
         & wfn%qpat)
      
      !> This step is only required because the dipole integrals in tblite are not
      !> centered to a fixed point (e.g., origin) but are atomic dipole moments
      !> Calculation of dipole moments requires Mulliken atomic charges.
      allocate (mulliken_qsh(bas%nsh, wfn%nspin), mulliken_qat(mol%nat, wfn%nspin))
      call get_mulliken_shell_charges(bas, ints%overlap, wfn%density, wfn%n0sh, &
      & mulliken_qsh)
      call get_qat_from_qsh(bas, mulliken_qsh, mulliken_qat)
      !> Get the molecular dipole moment
      call gemv(mol%xyz, mulliken_qat(:, 1), tmpdip)
      dipole(:) = tmpdip + sum(wfn%dpat(:, :, 1), 2)

      !> Alternative way to get the molecular dipole moment
      if (alternative_dipole) & !##### DEV TEST #####
         call get_molecular_dipole_moment(mol, mulliken_qat(:, 1), wfn%dpat(:, :, 1), &
            & dipole)
      
      call get_molecular_quadrupole_moment(mol, mulliken_qat(:, 1), wfn%dpat(:, :, 1), &
         & wfn%qpat(:, :, 1), quadrupole)

      !> Get the WBOs
      allocate (wbo(mol%nat, mol%nat, wfn%nspin))
      call get_mayer_bond_orders(bas, ints%overlap, wfn%density, wbo)

      !> Save some memory by deallocating the second-iteration-specific HO overlap integrals
      deallocate (auxints%overlap_h0_2)

      if (ctx%verbosity > 1) then
         write (ctx%unit, '(10x,a,/)') "--- Two-step SCF done. ---"
      end if

   end subroutine twostepscf

   !> TAKEN OVER FROM TBLITE - modified in order to use the PTB parameters
   subroutine get_density(wfn, solver, ints, ts, error, keps_param, keps0_param)
      !> Tight-binding wavefunction data
      type(wavefunction_type), intent(inout) :: wfn
      !> Solver for the general eigenvalue problem
      class(solver_type), intent(inout) :: solver
      !> Integral container
      type(integral_type), intent(in) :: ints
      !> Electronic entropy
      real(wp), intent(out) :: ts
      !> Error handling
      type(error_type), allocatable, intent(out) :: error
      !> Linear regression cofactors for the orbital energies
      real(wp), intent(in), optional :: keps_param, keps0_param
      real(wp) :: keps, keps0

      real(wp) :: e_fermi, stmp(2)
      real(wp), allocatable :: focc(:)
      integer :: spin

      if (present(keps_param)) then
         keps = keps_param
      else
         keps = 0.0_wp
      end if
      if (present(keps0_param)) then
         keps0 = keps0_param
      else
         keps0 = 0.0_wp
      end if

      select case (wfn%nspin)
      case default
         call solver%solve(wfn%coeff(:, :, 1), ints%overlap, wfn%emo(:, 1), error)
         if (allocated(error)) return
         wfn%emo(:, 1) = wfn%emo(:, 1) * (1.0_wp + keps) + keps0

         allocate (focc(size(wfn%focc, 1)))
         wfn%focc(:, :) = 0.0_wp
         do spin = 1, 2
            call get_fermi_filling(wfn%nel(spin), wfn%kt, wfn%emo(:, 1), &
               & wfn%homo(spin), focc, e_fermi)
            call get_electronic_entropy(focc, wfn%kt, stmp(spin))
            wfn%focc(:, 1) = wfn%focc(:, 1) + focc
         end do
         ts = sum(stmp)

         call get_density_matrix(wfn%focc(:, 1), wfn%coeff(:, :, 1), wfn%density(:, :, 1))
      case (2)
         wfn%coeff = 2 * wfn%coeff
         do spin = 1, 2
            call solver%solve(wfn%coeff(:, :, spin), ints%overlap, wfn%emo(:, spin), error)
            if (allocated(error)) return
            wfn%emo(:, 1) = wfn%emo(:, 1) * (1.0_wp + keps) + keps0

            call get_fermi_filling(wfn%nel(spin), wfn%kt, wfn%emo(:, spin), &
               & wfn%homo(spin), wfn%focc(:, spin), e_fermi)
            call get_electronic_entropy(wfn%focc(:, spin), wfn%kt, stmp(spin))
            call get_density_matrix(wfn%focc(:, spin), wfn%coeff(:, :, spin), &
               & wfn%density(:, :, spin))
         end do
         ts = sum(stmp)
      end select
   end subroutine get_density

   pure function id_to_atom(mol, idparam) result(atomparam)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> PTB parameterization data for each species
      real(wp), intent(in) :: idparam(:, :)
      !> PTB parameterization data for each atom
      real(wp), allocatable :: atomparam(:, :)

      integer :: iat, iid

      allocate (atomparam(size(idparam, 1), mol%nat), source=0.0_wp)
      do iat = 1, mol%nat
         iid = mol%id(iat)
         atomparam(:, iat) = idparam(:, iid)
      end do

   end function id_to_atom

   pure subroutine get_electronic_entropy(occ, kt, s)
      real(wp), intent(in) :: occ(:)
      real(wp), intent(in) :: kt
      real(wp), intent(out) :: s

      s = sum(log(occ**occ * (1 - occ)**(1 - occ))) * kt
   end subroutine get_electronic_entropy

#endif
end module xtb_ptb_scf

! This file is part of xtb.
!
! Copyright (C) 2022 Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_iff_iffprepare
   use xtb_mctc_accuracy, only: wp
   use xtb_type_environment, only: TEnvironment
   use xtb_splitparam
   use xtb_iff_calculator, only: TIFFCalculator
   use xtb_iff_data, only: TIFFData
   use xtb_type_atomlist
   use xtb_type_molecule, only: TMolecule
   use xtb_setparam
   use xtb_type_restart, only: TRestart
   use xtb_type_calculator, only: TCalculator
   use xtb_xtb_calculator, only: TxTBCalculator
   use xtb_setmod, only: set_gfn
   use xtb_readin, only: xfind
   use xtb_solv_state, only: solutionState
   use xtb_type_data, only: scc_results
   use xtb_main_defaults, only: initDefaults
   use xtb_disp_ncoord, only: ncoord_gfn, ncoord_erf
   use xtb_scc_core, only: iniqshell
   use xtb_eeq, only: goedecker_chrgeq
   use xtb_main_setup, only: newCalculator
   use xtb_single, only: singlepoint
   use xtb_docking_param, only: chrg, uhf, gsolvstate_iff, pre_e_A, &
                              & pre_e_B, optlvl, ehomo, elumo, dipol, &
                              & natom_molA, natom_arg, split_mol

   implicit none

   private
   public :: prepare_IFF, precomp

contains

   subroutine prepare_IFF(env, comb, iff_data)

      type(TEnvironment), intent(inout) :: env
      !> Combined structure of molA and molB (molA has to be first)
      type(TMolecule), intent(in) :: comb
      !> IFF data
      type(TIFFData) :: iff_data

      character(len=*), parameter :: source = 'preperation_IFFCalculator'
      type(TMolecule) :: molA, molB
      integer, allocatable :: at(:)
      real(wp), allocatable :: xyz(:, :)
      real(wp) :: molA_e, molB_e
      integer, allocatable :: list(:)
      type(TAtomList) :: atl

      call atl%resize(comb%n)

      !> First make the argument natom_arg to a list of number of atoms
      call atl%new(natom_arg)
      if (atl%get_error()) then
         call env%warning('something is wrong in the fixing list',source)
         return
      endif
      call atl%to_list(list)

      molA%n = size(list)
      natom_molA = molA%n
      molB%n = comb%n - molA%n

      if (natom_molA == 0) call env%error('No atoms of Molecule A given')
      if(natom_molA > comb%n) &
              & call env%error('More atoms of Molecule A than contained in structure')

      call split_mol(molA, molB, size(list), list, comb)
      call iff_data%allocateIFFData(molA%n, molB%n)

      call precomp(env, iff_data, molA, molA_e, 1)
      call precomp(env, iff_data, molB, molB_e, 2)

   end subroutine prepare_IFF

   subroutine precomp(env, iff_data, mol, etot, mol_num)

      !> Molecular structure data
      type(TMolecule), intent(inout) :: mol
      !> IFF data
      type(TIFFData), intent(inout) :: iff_data
      !> Calculation environment
      type(TEnvironment), intent(inout) :: env
      integer, intent(in) :: mol_num

      class(TCalculator), allocatable :: calc
      type(TRestart) :: chk
      character(len=:), allocatable :: fnv !parameter file
      logical :: restart = .false.
      real(wp) :: acc = 1.0_wp !SCF accuracy
      real(wp) :: egap
      integer :: gsolvstate !Should be gas
      real(wp), allocatable :: cn(:)
      real(wp), allocatable :: dcn(:, :, :), dq(:, :, :), g(:, :)
      real(wp) :: er
      integer, external :: ncore
      logical :: lgrad
      logical :: exist
      real(wp), intent(out) :: etot
      real(wp) :: sigma(3, 3)
      type(scc_results) :: res
      integer :: i
      integer :: extrun_tmp
      integer, allocatable ::  tmp_unit
      logical :: newdisp_tmp
      integer :: itemp = 48

      allocate (cn(mol%n), g(3, mol%n))

      set%pr_lmo = .true.
      set%silent = .true.

      !Setting up z
      do i = 1, mol%n
         mol%z(i) = mol%at(i) - ncore(mol%at(i))
         ! lanthanides without f are treated as La
         if (mol%at(i) .gt. 57 .and. mol%at(i) .lt. 72) mol%z(i) = 3
      end do

      !> Set GFN2 settings
      if (optlvl /= 'gfn1') then
         set%gfn_method = 2
         fnv = xfind('param_gfn2-xtb.txt')
         extrun_tmp = set%mode_extrun
         set%mode_extrun = p_ext_xtb
         newdisp_tmp = set%newdisp
         set%newdisp = .true.
      else
         fnv = xfind('param_gfn1-xtb.txt') !Other stuff already set
      end if
      if (mol_num .eq. 1) then
         if (chrg(1) /= 0.0_wp) mol%chrg = chrg(1)
         if (uhf(1) /= 0.0_wp) mol%uhf = uhf(1)
      elseif (mol_num .eq. 2) then
         if (chrg(2) /= 0.0_wp) mol%chrg = chrg(2)
         if (uhf(2) /= 0.0_wp) mol%uhf = uhf(2)
      end if

      call open_file(itemp, 'tmp_lmo', 'w')
      tmp_unit = env%unit
      env%unit = itemp

      !> New calculator
      call newCalculator(env, mol, calc, fnv, restart, acc)
      call env%checkpoint("Could not setup parameterisation")

!   gsolvstate = solutionState%gsolv
      call initDefaults(env, calc, mol, gsolvstate_iff)
      !> initial guess, setup wavefunction
      select type (calc)
      type is (TxTBCalculator)
         calc%etemp = set%etemp
         calc%maxiter = set%maxscciter
         call chk%wfn%allocate(mol%n, calc%basis%nshell, calc%basis%nao)
         !> EN charges and CN
         call ncoord_gfn(mol%n, mol%at, mol%xyz, cn)
         if (mol%npbc > 0) then
            chk%wfn%q = real(set%ichrg, wp)/real(mol%n, wp)
         else
            call ncoord_erf(mol%n, mol%at, mol%xyz, cn)
            call goedecker_chrgeq(mol%n,mol%at,mol%xyz,real(set%ichrg,wp),cn,dcn,chk%wfn%q,dq,er,g,&
                                  .false., .false., .false.)
            chk%wfn%q = real(set%ichrg, wp)/real(mol%n, wp)
         end if
         !> initialize shell charges from gasteiger charges
      call iniqshell(calc%xtbData,mol%n,mol%at,mol%z,calc%basis%nshell,chk%wfn%q,chk%wfn%qsh,set%gfn_method)
      end select

      call delete_file('.sccnotconverged')
      call delete_file('charges')

      call env%checkpoint("Setup for calculation failed")

      allocate(res%iff_results)

      !> the SP
      call singlepoint &
         &       (env, mol, chk, calc, egap, set%etemp, set%maxscciter, 2,&
         &        exist, lgrad, acc, etot, g, sigma, res)

      set%pr_lmo = .false.

      !> Save the results
      if (mol_num .eq. 1) then
         pre_e_A = etot
         iff_data%n1 = res%iff_results%n
         iff_data%at1 = res%iff_results%at
         iff_data%xyz1 = res%iff_results%xyz
         iff_data%q1 = res%iff_results%q
         iff_data%nlmo1 = res%iff_results%nlmo
         iff_data%rlmo1 = res%iff_results%rlmo
         iff_data%lmo1 = res%iff_results%lmo
         iff_data%qct1 = res%iff_results%qct
         ehomo(1) = res%iff_results%ehomo
         elumo(1) = res%iff_results%elumo
         dipol(1) = res%iff_results%dipol
      elseif (mol_num .eq. 2) then
         pre_e_B = etot
         iff_data%n2 = res%iff_results%n
         iff_data%at2 = res%iff_results%at
         iff_data%xyz2 = res%iff_results%xyz
         iff_data%q2 = res%iff_results%q
         iff_data%nlmo2 = res%iff_results%nlmo
         iff_data%rlmo2 = res%iff_results%rlmo
         iff_data%lmo2 = res%iff_results%lmo
         iff_data%qct2 = res%iff_results%qct
         ehomo(2) = res%iff_results%ehomo
         elumo(2) = res%iff_results%elumo
         dipol(2) = res%iff_results%dipol
      end if

      if (optlvl /= 'gfn1') then
         set%mode_extrun = extrun_tmp
         set%newdisp = newdisp_tmp
      end if

      set%silent = .false.
      env%unit = tmp_unit
      call remove_file(itemp)
      deallocate (cn, g)

   end subroutine precomp

end module xtb_iff_iffprepare

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_splitparam
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   implicit none
   private :: wp
   public

!   integer  :: splitlist,iatf1,iatf2
!   real(wp) :: rcma,massf1,massf2,atmass
!   dimension :: splitlist(10000),atmass(10000)
   integer  :: maxsplit = 0
   integer  :: iatf1 = 0
   integer  :: iatf2 = 0
   integer, allocatable :: splitlist(:)
   integer, allocatable :: iatf(:)
   real(wp) :: rcma = 0.0_wp
   real(wp) :: massf1 = 0.0_wp
   real(wp) :: massf2 = 0.0_wp
   real(wp),allocatable :: atmass(:)

   integer  :: maxfrag = 0

contains

subroutine init_split(nsplit)
   implicit none
   integer,intent(in) :: nsplit
   maxsplit = nsplit
   call clear_split
   allocate( splitlist(nsplit), source = 0 )
   allocate( iatf(nsplit),      source = 0 )
   allocate( atmass(nsplit),    source = 0.0_wp )
end subroutine init_split

subroutine clear_split
   if (allocated(splitlist)) deallocate(splitlist)
   if (allocated(atmass))    deallocate(atmass)
end subroutine clear_split

subroutine splitm(nat,at,xyz,cn)
   use xtb_mctc_convert, only : autoaa
   use xtb_param_atomicRad, only : atomicRad
   implicit none
   integer, intent(in) :: nat
   real(wp),intent(in) :: xyz(3,nat)
   integer, intent(in) :: at(nat)
   real(wp),intent(in) :: cn(nat)

   integer  :: i,j,k
   real(wp) :: r,f,rco
   real(wp),allocatable :: bond(:,:)
   allocate(bond(nat,nat))

!  determine covalent neighbours
   bond = 0
   do i=1,nat
      do j=1,nat
         r=sqrt(sum((xyz(:,i)-xyz(:,j))**2))
         rco=(atomicRad(at(i))+atomicRad(at(j)))*autoaa
         if(r.lt.2.5*rco) bond(j,i)=1
      enddo
      bond(i,i)=0
   enddo

   call mrec(i,xyz,cn,bond,nat,at,splitlist)

   iatf1=0
   iatf2=0
   do i=1,nat
      if(splitlist(i).gt.2) splitlist(i)=2
      if(splitlist(i).eq.1) iatf1=iatf1+1
      if(splitlist(i).eq.2) iatf2=iatf2+1
   enddo

end subroutine splitm

subroutine cmafrag(nat,at,xyz,r1,r2)
   implicit none
   real(wp) xyz(3,nat),r1(3),r2(3)
   integer nat,at(nat)

   integer i
   real(wp) sum1x,atmas,sum1y,sum1z,sum2x,sum2y,sum2z,dr(3)

   sum1x=0._wp
   sum1y=0._wp
   sum1z=0._wp
   sum2x=0._wp
   sum2y=0._wp
   sum2z=0._wp
   do i=1,nat
      atmas=atmass(i)
      if(splitlist(i).eq.1)then
         sum1x=sum1x+atmas*xyz(1,i)
         sum1y=sum1y+atmas*xyz(2,i)
         sum1z=sum1z+atmas*xyz(3,i)
      else
         sum2x=sum2x+atmas*xyz(1,i)
         sum2y=sum2y+atmas*xyz(2,i)
         sum2z=sum2z+atmas*xyz(3,i)
      endif
   enddo
   !
   r1(1)=sum1x/massf1
   r1(2)=sum1y/massf1
   r1(3)=sum1z/massf1
   r2(1)=sum2x/massf2
   r2(2)=sum2y/massf2
   r2(3)=sum2z/massf2

   dr(1:3)=r1(1:3)-r2(1:3)

   rcma=sqrt(sum(dr*dr))

end subroutine cmafrag

subroutine splitprint(nat,at,xyz)
   use xtb_scanparam
   implicit none
   real(wp) xyz(3,nat)
   integer nat,at(nat)

   real(wp) ra(3),rb(3)
   integer i

   if(iatf1.eq.0.or.iatf2.eq.0) return

   massf1=0
   massf2=0
   do i=1,nat
      if(splitlist(i).eq.1)then
         massf1=massf1+atmass(i)
      else
         massf2=massf2+atmass(i)
      endif
   enddo
   call cmafrag(nat,at,xyz,ra,rb)

   write(stdout,'(a)')
   write(stdout,'(''molecular fragmentation (1/2 indicates fragments):'')')
   write(stdout,'(72i1)') splitlist(1:nat)
   write(stdout,'(''# atoms in fragment 1/2:'',2i6)')iatf1,iatf2
   write(stdout,'('' fragment masses (1/2) :'',2f12.2)')massf1,massf2
   write(stdout,'(''CMA distance (Bohr)    :'',f8.3)')rcma
   write(stdout,'(''constraining FC (au)   :'',f8.4)')fcconstr

end subroutine splitprint

subroutine cmaiface(nat,at,xyz)
   implicit none
   real(wp) xyz(3,nat)
   integer nat,at(nat)

   integer i,j
   real(wp) r,r0,rvdw(94),asum,bsum,xsum,ff
   rvdw(1:94)= (/ &
    1.09155,0.86735,1.7478 ,1.5491 ,1.608  ,1.45515,1.31125,1.24085, &
    1.1498 ,1.0687 ,1.8541 ,1.74195,2.0053 ,1.89585,1.75085,1.65535, &
    1.5523 ,1.4574 ,2.12055,2.05175,1.94515,1.8821 ,1.86055,1.7207, &
    1.7731 ,1.72105,1.71635,1.6731 ,1.6504 ,1.61545,1.97895,1.93095, &
    1.83125,1.7634 ,1.6831 ,1.6048 ,2.3088 ,2.2382 ,2.1098 ,2.02985, &
    1.9298 ,1.87715,1.7845 ,1.73115,1.69875,1.67625,1.6654 ,1.731, &
    2.13115,2.0937 ,2.0075 ,1.94505,1.869  ,1.79445,2.52835,2.5907, &
    2.31305,2.31005,2.2851 ,2.26355,2.2448 ,2.22575,2.2117 ,2.06215, &
    2.12135,2.07705,2.1397 ,2.1225 ,2.1104 ,2.0993 ,2.0065 ,2.1225, &
    2.049  ,1.99275,1.94775,1.8745 ,1.7228 ,1.67625,1.6282 ,1.67995, &
    2.15635,2.1382 ,2.05875,2.0027 ,1.9322 ,1.8608 ,2.5398 ,2.4647, &
    2.35215,2.2126 ,2.2297 ,2.19785,2.17695,2.21705/)

   atmass=0
   ff=-5._wp

   asum=0
   do i=1,nat
      if(splitlist(i).eq.1)then
         xsum=0
         do j=1,nat
            if(splitlist(j).ne.1)then
               r=sqrt((xyz(1,i)-xyz(1,j))**2+ &
               &      (xyz(2,i)-xyz(2,j))**2+ &
               &      (xyz(3,i)-xyz(3,j))**2)
               r0=rvdw(at(i))+rvdw(at(j))
               xsum=xsum+exp(ff*r/r0**2)
            endif
         enddo
         asum=asum+xsum
         atmass(i)=xsum
      endif
   enddo
   do i=1,nat
      if(splitlist(i).eq.1)atmass(i)=atmass(i)/asum
   enddo

   bsum=0
   do i=1,nat
      if(splitlist(i).ne.1)then
         xsum=0
         do j=1,nat
            if(splitlist(j).eq.1)then
               r=sqrt((xyz(1,i)-xyz(1,j))**2+ &
               &      (xyz(2,i)-xyz(2,j))**2+ &
               &      (xyz(3,i)-xyz(3,j))**2)
               r0=rvdw(at(i))+rvdw(at(j))
               xsum=xsum+exp(ff*r/r0**2)
            endif
         enddo
         bsum=bsum+xsum
         atmass(i)=xsum
      endif
   enddo
   do i=1,nat
      if(splitlist(i).ne.1)atmass(i)=atmass(i)/bsum
   enddo
   ff=maxval(atmass(1:nat))
   atmass(1:nat)=atmass(1:nat)/ff

   !     do i=1,nat
   !        write(*,*) i,atmass(i)
   !     enddo

end subroutine cmaiface

end module xtb_splitparam

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> TODO
module xtb_main_setup
   use xtb_mctc_accuracy, only: wp
   use xtb_solv_input, only: TSolvInput
   use xtb_solv_model, only: init
   use xtb_extern_orca, only: TOrcaCalculator, newOrcaCalculator
   use xtb_extern_mopac, only: TMopacCalculator, newMopacCalculator
   use xtb_extern_turbomole, only: TTMCalculator, newTMCalculator
   use xtb_extern_driver, only: TDriverCalculator, newDriverCalculator
   use xtb_tblite_calculator, only: TTBLiteCalculator, TTBLiteInput, newTBLiteCalculator
   use xtb_type_calculator, only: TCalculator
   use xtb_type_environment, only: TEnvironment
   use xtb_type_molecule, only: TMolecule
   use xtb_type_restart, only: TRestart
   use xtb_type_wavefunction, only: TWavefunction
   use xtb_xtb_calculator, only: TxTBCalculator, newXTBcalculator, newWavefunction
   use xtb_ptb_calculator, only: TPTBCalculator, newPTBcalculator
   use xtb_gfnff_calculator, only: TGFFCalculator, newGFFCalculator
   use xtb_iff_calculator, only: TIFFCalculator, newIFFCalculator
   use xtb_iff_data, only: TIFFData
   use xtb_oniom, only: TOniomCalculator, newOniomCalculator, oniom_input
   use xtb_setparam
   implicit none
   private

   public :: newCalculator, newWavefunction, addSolvationModel
   public :: newXTBCalculator

contains

   subroutine newCalculator(env, mol, calc, fname, restart, accuracy, input, iff_data, tblite_input)

      character(len=*), parameter :: source = 'main_setup_newCalculator'

      type(TEnvironment), intent(inout) :: env

      type(TMolecule), intent(in) :: mol

      class(TCalculator), allocatable, intent(out) :: calc

      character(len=*), intent(in) :: fname

      logical, intent(in) :: restart

      real(wp), intent(in) :: accuracy

      type(oniom_input), intent(in), optional :: input

      type(TIFFData), intent(in), optional, allocatable :: iff_data

      !> Input for TBLite calculator
      type(TTBLiteInput), intent(in), optional :: tblite_input

      type(TxTBCalculator), allocatable :: xtb
      type(TTBLiteCalculator), allocatable :: tblite
      type(TGFFCalculator), allocatable :: gfnff
      type(TIFFCalculator), allocatable :: iff
      type(TOrcaCalculator), allocatable :: orca
      type(TMopacCalculator), allocatable :: mopac
      type(TTMCalculator), allocatable :: turbo
      type(TOniomCalculator), allocatable :: oniom
      type(TDriverCalculator), allocatable :: driver
      type(TPTBCalculator), allocatable :: ptb

      logical :: exitRun

      select case (set%mode_extrun)
      case default
         call env%error("Unknown calculator type", source)

      case (p_ext_oniom)
         if (.not. present(input)) then
            call env%error("ONIOM calculator requires input", source)
            return
         end if
         allocate (oniom)
         call newOniomCalculator(oniom, env, mol, input)
         call move_alloc(oniom, calc)

      case (p_ext_eht, p_ext_xtb)
         allocate (xtb)

         call newXTBCalculator(env, mol, xtb, fname, set%gfn_method, accuracy)

         call env%check(exitRun)
         if (exitRun) then
            call env%error("Could not construct new calculator", source)
            return
         end if

         call move_alloc(xtb, calc)
      case (p_ext_tblite)
         if (.not. present(tblite_input)) then
            call env%error("TBLite calculator requires input", source)
            return
         end if
         allocate (tblite)

         call newTBLiteCalculator(env, mol, tblite, tblite_input)

         call env%check(exitRun)
         if (exitRun) then
            call env%error("Could not construct new calculator", source)
            return
         end if

         call move_alloc(tblite, calc)
      case (p_ext_gfnff)
         allocate (gfnff)

         call newGFFCalculator(env, mol, gfnff, fname, restart)

         call env%check(exitRun)
         if (exitRun) then
            call env%error("Could not construct new calculator", source)
            return
         end if

         call move_alloc(gfnff, calc)
      case (p_ext_mcgfnff)
         allocate (gfnff)

         call newGFFCalculator(env, mol, gfnff, fname, restart, 4) ! mcgfnff2023 version

         call env%check(exitRun)
         if (exitRun) then
            call env%error("Could not construct new calculator", source)
            return
         end if

         call move_alloc(gfnff, calc)
      case (p_ext_iff)
         if (.not. present(iff_data)) then
            call env%error("IFF calculator requires input", source)
            return
         end if
         allocate (iff)

         if (.not. allocated(iff_data)) then
            call env%error("IFF Data not present for Calculator", source)
         end if

         call newIFFCalculator(env, mol, iff_data, iff)

         call env%check(exitRun)
         if (exitRun) then
            call env%error("Could not construct new calculator", source)
            return
         end if

         call move_alloc(iff, calc)

      case (p_ext_ptb)
         allocate (ptb)

         call newPTBCalculator(env, mol, ptb)

         call env%check(exitRun)
         if (exitRun) then
            call env%error("Could not construct new calculator", source)
            return
         end if

         call move_alloc(ptb, calc)

      case (p_ext_orca)
         allocate (orca)
         call newOrcaCalculator(orca, env, set%ext_orca)
         call move_alloc(orca, calc)

      case (p_ext_mopac)
         allocate (mopac)
         call newMopacCalculator(mopac, env, set%ext_mopac)
         call move_alloc(mopac, calc)

      case (p_ext_turbomole)
         allocate (turbo)
         call newTMCalculator(turbo, set%extcode, set%extmode)
         call move_alloc(turbo, calc)

      case (p_ext_driver)
         allocate (driver)
         call newDriverCalculator(driver, env, set%ext_driver)
         call move_alloc(driver, calc)
      end select

   end subroutine newCalculator

   subroutine addSolvationModel(env, calc, input)
      type(TEnvironment), intent(inout) :: env
      class(TCalculator), intent(inout) :: calc
      type(TSolvInput), intent(in) :: input
      integer :: level

      level = 0
      select type (calc)
      type is (TxTBCalculator)
         level = calc%xtbData%level
      type is (TOniomCalculator)
         select type (xtb => calc%real_low)
         type is (TxTBCalculator)
            level = xtb%xtbData%level
         end select
      end select

      if (allocated(input%solvent)) then
         calc%lSolv = input%solvent /= 'none' .and. input%solvent /= 'gas' &
            & .and. input%solvent /= 'vac'
      else
         calc%lSolv = .false.
      end if

      if (calc%lSolv) then
         allocate (calc%solvation)
         call init(calc%solvation, env, input, level)
      end if

   end subroutine addSolvationModel

end module xtb_main_setup

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Module for the mixed Mulliken-Loewdin population analysis

module xtb_ptb_mmlpopanalysis
#if WITH_TBLITE
   use mctc_env, only: wp

   use xtb_mctc_lapack, only: lapack_syev

   use tblite_basis_type, only: basis_type
   use tblite_blas, only: gemm
   use tblite_wavefunction_spin, only: updown_to_magnet
   implicit none
   private

   public :: get_mml_overlaps, get_mml_shell_charges

contains

   subroutine get_mml_overlaps(bas, overlap, ratio, sx, soneminusx)
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Overlap matrix
      real(wp), intent(in) :: overlap(:, :)
      !> Ratio of Mulliken to Loewdin population
      real(wp), intent(in) :: ratio
      !> Overlap matrix for Mulliken-Lowdin population analysis
      real(wp), intent(out) :: sx(:, :), soneminusx(:, :)
      !> Variables for ML-pop:
      !> Eigenvalues of overlap matrix (exponentiated)
      real(wp), allocatable :: seig(:), seig1(:), seig2(:)
      !> Auxiliary variables for diagonalization
      integer :: lwork, info, i, j
      real(wp), allocatable :: aux(:)
      !> Temporary overlap matrix as a result of the diagonalization
      real(wp), allocatable :: tmps(:, :)
      !> Temporary overlap matrix for the matrix multiplication
      real(wp) :: tmp2s(bas%nao, bas%nao)

      !> debug mode
      logical, parameter :: debug(2) = [ .false., .false. ]

      allocate (tmps(bas%nao, bas%nao), seig(bas%nao), &
      & seig1(bas%nao), seig2(bas%nao))
      tmps = overlap

      allocate (aux(1))
      lwork = -1
      call lapack_syev('V', 'U', bas%nao, tmps, bas%nao, seig, aux, lwork, info)
      lwork = int(aux(1))
      deallocate (aux)
      allocate (aux(lwork))
      call lapack_syev('V', 'U', bas%nao, tmps, bas%nao, seig, aux, lwork, info)
      do i = 1, bas%nao
         seig1(i) = seig(i)**(1.0_wp - ratio)
         seig2(i) = seig(i)**ratio
      end do

      if (debug(1)) then !##### DEV WRITE #####
         write (*, *) "Overlap tmpS:"
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f10.5)', advance="no") tmps(i, j)
            end do
            write (*, *) ""
         end do
      endif
         
      do i = 1, bas%nao
         do j = 1, bas%nao
            tmp2s(j, i) = tmps(j, i) * seig1(i)
         end do
      end do
      
      if (debug(2)) then !##### DEV WRITE #####
         write (*, *) "Overlap tmp2S:"
         do i = 1, bas%nao
            do j = 1, bas%nao
               write (*, '(f10.6)', advance="no") tmp2s(i, j)
            end do
            write (*, *) ""
         end do
      endif
      
      call gemm(tmps, tmp2s, soneminusx, 'N', 'T')

      do i = 1, bas%nao
         do j = 1, bas%nao
            tmp2s(j, i) = tmps(j, i) * seig2(i)
         end do
      end do
      call gemm(tmps, tmp2s, sx, 'N', 'T')

   end subroutine get_mml_overlaps

   subroutine get_mml_shell_charges(bas, sx, soneminusx, density, &
   & n0sh, qsh)
      !> Basis set data
      type(basis_type), intent(in) :: bas
      !> Overlap matrix for Mulliken-Lowdin population analysis
      real(wp), intent(in) :: sx(:, :), soneminusx(:, :), &
         & density(:, :, :)
      !> Reference occupations
      real(wp), intent(in) :: n0sh(:)
      !> Shell charges
      real(wp), intent(out) :: qsh(:, :)
      !> Auxiliary variables for the matrix multiplication
      real(wp), allocatable :: cc(:, :), pmix(:, :)
      integer :: iao, ish, spin, ii
      real(wp) :: pao

      allocate (cc(bas%nao, bas%nao), pmix(bas%nao, bas%nao))
      call gemm(density(:, :, 1), soneminusx, cc, 'N', 'N')
      call gemm(sx, cc, pmix, 'N', 'N')

      qsh(:, :) = 0.0_wp
      !$omp parallel do default(none) collapse(2) schedule(runtime) reduction(+:qsh) &
      !$omp shared(bas, density, pmix) private(spin, iao, ii, ish, pao)
      do spin = 1, size(density, 3)
         do ish = 1, bas%nsh
            ii = bas%iao_sh(ish)
            pao = 0.0_wp
            do iao = 1, bas%nao_sh(ish)
               pao = pao + pmix(ii + iao, ii + iao)
            end do
            qsh(ish, spin) = qsh(ish, spin) - pao
         end do
      end do

      call updown_to_magnet(qsh)
      qsh(:, 1) = qsh(:, 1) + n0sh

   end subroutine get_mml_shell_charges

#endif
end module xtb_ptb_mmlpopanalysis

! This file is part of xtb.
!
! Copyright (C) 2022 Christoph Plett
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_iff_iffini
   use xtb_mctc_accuracy, only: wp
   use xtb_docking_param
   use xtb_iff_ifflmo
   use xtb_sphereparam
   use xtb_disp_ncoord
   use xtb_type_environment, only: TEnvironment
   use xtb_setmod
   use xtb_type_param
   use xtb_disp_dftd4param
   use xtb_disp_dftd4, only : newD4Model, zeta, weight_references, get_atomic_c6, d4, d4dim
   use xtb_type_dispersionmodel, only: TDispersionModel
   use xtb_mctc_param, only: gamma => chemical_hardness
   use xtb_type_molecule, only: TMolecule, init
   implicit none

   private
   public :: init_iff

contains
   subroutine init_iff(env,n1,n2,at1,at2,neigh,xyz1,xyz2,q1,q2,c6ab,z1,z2,&
   &                   cprob, nlmo1, nlmo2, lmo1, lmo2,&
   &                   qdr1, qdr2, rlmo1, rlmo2,&
   &                   cn1, cn2, alp1, alp2, alpab,&
   &                   den1, den2, gab1, gab2, qcm1, qcm2,&
   &                   n, at, xyz, q, icoord, icoord0,&
   &                   pr)

      type(TEnvironment), intent(inout) :: env
      integer, intent(in) :: n, n1, n2
      integer, intent(inout) :: nlmo1, nlmo2
      integer, intent(out) :: neigh(0:n, n)
      integer, intent(out) :: at(n)
      integer, intent(in) :: at1(n1)
      integer, intent(in) :: at2(n2)
      integer, intent(inout) :: lmo1(n1*10)
      integer, intent(inout) :: lmo2(n2*10)
      real(wp), intent(out) :: xyz(3, n)
      real(wp), intent(out) :: q(n)
      real(wp), intent(inout) :: xyz1(3, n1)
      real(wp), intent(inout) :: xyz2(3, n2)
      real(wp), intent(inout) :: rlmo1(4, n1*10)
      real(wp), intent(inout) :: rlmo2(4, n2*10)
      real(wp), intent(in) :: q1(n1)
      real(wp), intent(out) :: qdr1(n1)
      real(wp), intent(in) :: q2(n2)
      real(wp), intent(out) :: qdr2(n2)
      real(wp), intent(out) :: cn1(n1)
      real(wp), intent(out) :: cn2(n2)
      real(wp), intent(out) :: alp1(n1)
      real(wp), intent(out) :: alp2(n2)
      real(wp), intent(out) :: c6ab(n, n)
      real(wp), intent(out) :: z1(n1)
      real(wp), intent(out) :: z2(n2)
      real(wp), intent(in) :: qcm1(n1)
      real(wp), intent(in) :: qcm2(n2)
      real(wp), intent(out) :: alpab(n2, n1)
      real(wp), intent(out) :: cprob(n1)
      real(wp), intent(inout) :: icoord(6), icoord0(6)
      real(wp), intent(out) :: den1(2,4,n1),den2(2,4,n2),gab1(n1,n1),gab2(n2,n2)
      logical, intent(in) :: pr

      real(wp) :: dum_array(3, 1)
      integer, allocatable :: dum_at(:)
      real(wp) :: distance, max_distanceA, max_distanceB
      integer :: i, j, k, nfreq, np
      real(wp) :: edum, r(3), rr, rrr, r42, c6d4, tmp, thr, a1, a2, s8, ai, aj, p1, fc
      real(wp) :: aa, bb, cc, avmom, wt, h298, g298, ts298, zp, symn 
      real(wp) :: freq1(3*n1), freq2(3*n2), dum(n), dum1(n1), dum2(n2)
      real(wp) :: cn(n), alp0(n), c6ab1(n1, n1), c6ab2(n2, n2), gsolv_inf
      real(wp) :: f,fall,fhyd,c6(94),qt1(1),qt2(1),r0,e1(4),c1(4),c6aad4,boxoffset
      !> D3 CAA(CNmax) coefficients
      data c6/& 
      &  3.03, 1.56, 85.32, 55.14, 28.03, 18.21, 15.58, 10.37,&
      &  7.13, 6.29, 186.11, 175.56, 153.59, 149.77, 151.69, 125.81,&
      & 90.40, 64.65, 338.02, 343.33, 313.98, 321.59, 269.33, 153.34,&
      &113.85, 109.50, 118.29, 141.88, 175.00, 153.45, 172.32, 180.29,&
      &224.29, 210.52, 169.24, 130.40, 476.26, 491.74, 451.08, 458.69,&
      &428.90, 337.11, 265.87, 239.01, 244.66, 265.87, 268.61, 263.45,&
      &310.83, 336.10, 417.38, 418.58, 358.50, 290.22, 649.09, 716.55,&
      &766.02, 688.04, 647.02, 620.52, 581.74, 587.79, 549.03, 595.36,&
      &524.92, 544.44, 472.80, 446.23, 440.52, 487.08, 411.57, 420.98,&
      &458.77, 398.10, 332.14, 297.83, 305.53, 336.87, 317.16, 298.86,&
      &389.61, 455.29, 533.88, 558.97, 495.45, 412.83, 822.05, 867.56,&
      &906.04, 1224.59, 980.38, 753.86, 698.16, 1051.25/
      real(wp), parameter ::au = 627.509541d0
      character*4 pgroup
      logical :: linear

      alp0 = 0.0_wp
      c6ab = 0.0_wp
      qt1 = 0.0_wp
      qt2 = 0.0_wp

! copy the whole system for CM5, GBSA, D4
      do i = 1, n1
         xyz(1:3, i) = xyz1(1:3, i)
         at(i) = at1(i)
         q(i) = q1(i)
      end do
      do i = 1, n2
         xyz(1:3, i + n1) = xyz2(1:3, i)
         at(i + n1) = at2(i)
         q(i + n1) = q2(i)
      end do
! q1 & q2 eingelesen
!     used for xtb recalc
      chrg(1) = sum(q1) + 1.d-8
      chrg(2) = sum(q2) + 1.d-8

!     ccccccccccccccccccccccccccccccccccccccccccccccccc
!               preCOMPUTE D3,D4 and REP stuff
!     ccccccccccccccccccccccccccccccccccccccccccccccccc

      if (sphere .eq. 1) write (*, '(''spherical box radius     :'',F10.3)') boxr
      if (sphere .eq. 2) write (*, '(''ellipsoid axis lengths   :'',3F10.3)') rabc

      !> Determine a factor to shift molB away from molA so that the Disp coefficients are those of seperated mols
      max_distanceA = 0.0_wp
      distance = 0.0_wp
      do i = 1, n1
         do j = 1, i - 1
            distance = sqrt(sum((xyz1(:, j) - xyz1(:, i))**2))
            max_distanceA = max(max_distanceA, distance)
         end do
      end do

      max_distanceB = 0.0_wp
      distance = 0.0_wp
      do i = 1, n2
         do j = 1, i - 1
            distance = sqrt(sum((xyz2(:, j) - xyz2(:, i))**2))
            max_distanceB = max(max_distanceB, distance)
         end do
      end do

      shift_geo = max_distanceA + max_distanceB + 1.d+6
!      shift_geo = 1.d+8

      do i = 1, n2  ! shift (later done reversely) to get seperated disp coefficients
         xyz(1:3, i + n1) = xyz2(1:3, i) + shift_geo
      end do

      a1 = par_d3_a1
      a2 = par_d3_a2
      s8 = par_d3_s8
      do i = 1, 86 ! precompute BJ damping terms
         dum_array(1:3, 1) = 0.0_wp
         call c6_alp0(1, [i], dum_array, [0.0d0], [0.d0], qt1, qt2) !qt1=a(0), qt2=c6ab
         r0_atom(i) = qt1(1)**(1./3.)   ! free atom values alpha(0) = radius | Saved in dockingparam
         do j = 1, i
            r42 = r2r4(i)*r2r4(j)
            rrab(j, i) = r42*3.0d0*s8  !include s8
            rrab(i, j) = r42*3.0d0*s8
            r0ab6(j, i) = (a1*dsqrt(3.0d0*r42) + a2)**6
            r0ab8(j, i) = (a1*dsqrt(3.0d0*r42) + a2)**8
            r0ab6(i, j) = r0ab6(j, i)
            r0ab8(i, j) = r0ab8(j, i)
         end do
      end do

      !> All C6 and alp0 coefficients for molA and molB
      call ncoord_d4(n, at, xyz, cn, 500.d0)
      call c6_alp0(n, at, xyz, cn, q, alp0, c6ab)
      c6aad4 = 0
      do i = 1, n
      do j = 1, n
         c6aad4 = c6aad4 + c6ab(j, i)
      end do
      end do

! at this point we have
! q1/q2    : fragment atomic Mulliken charges
! q        : full system atomic CM5 charges

      c6d4 = 0
      do i = 1, n1
         cprob(i) = sqrt(c6ab(i, i)*c6(probe_atom_type)) ! probe RG atom C6AB
         ai = alp0(i)**(1./3)
         do j = 1, n2
            aj = alp0(j + n1)**(1./3)
            alpab(j, i) = 2.6*(ai + aj)*0.5               ! the factor just converts the values to the
            ! r0ab scale so that the element factors are about one
            c6d4 = c6d4 + c6ab(j + n1, i)
         end do
      end do

      if(set%verbose) write (env%unit, '(''molecular C6AA D4 /au    :'',2F12.1)') c6aad4
      if(set%verbose) write (env%unit, '(''molecular C6AB D4 /au    :'',2F12.1)') c6d4

! setup ATM and other stuff
      thr = 25.0 ! intra mol cut-off to avoid too many pairs right from the start
      do i = 1, n1
         alp1(i) = alp0(i)
         cn1(i) = cn(i)
         z1(i) = val_e(at1(i))
         k = 0
         do j = 1, n1
            rr = (xyz1(1, j) - xyz1(1, i))**2 + (xyz1(2, j) - xyz1(2, i))**2 +&
              &(xyz1(3, j) - xyz1(3, i))**2
            r0 = sqrt(rr)
            gab1(j, i) = 1.0d0/(r0 + 1./sqrt(gam(at1(i))*gam(at1(j))))
            ai = alp0(i)**(1./3)
            aj = alp0(j)**(1./3)
            rrr = 1.13*2.6*(ai + aj)*0.5/r0
            tmp = 1.0d0/(1.d0 + 6.d0*rrr**14)
            if (j .ne. i .and. tmp .gt. 0.90 .and. r0 .lt. thr) then
               k = k + 1
               neigh(k, i) = j
            end if
         end do
         neigh(0, i) = k
      end do
!     molB
      do i = 1, n2
         alp2(i) = alp0(i + n1)
         cn2(i) = cn(i + n1)
         z2(i) = val_e(at2(i))
         k = 0
         do j = 1, n2
            rr = (xyz2(1, j) - xyz2(1, i))**2 + (xyz2(2, j) - xyz2(2, i))**2 +&
              &(xyz2(3, j) - xyz2(3, i))**2
            r0 = sqrt(rr)
            gab2(j, i) = 1.0d0/(r0 + 1./sqrt(gam(at2(i))*gam(at2(j))))
            ai = alp0(i + n1)**(1./3)
            aj = alp0(j + n1)**(1./3)
            rrr = 1.13*2.6*(ai + aj)*0.5/r0
            tmp = 1.0d0/(1.d0 + 6.d0*rrr**14)
            if (j .ne. i .and. tmp .gt. 0.90 .and. r0 .lt. thr) then
               k = k + 1
               neigh(k, i + n1) = j
            end if
         end do
         neigh(0, i + n1) = k
      end do

!     define LP centers
      call setlmo(1, n1, nlmo1, at1, xyz1, alp1, q1, cn1, rlmo1, lmo1)
      call setlmo(2, n2, nlmo2, at2, xyz2, alp2, q2, cn2, rlmo2, lmo2)

      if (debug) then ! write actual centers to file
         call wrc('xtbiff.coord', n1, n2, at1, at2, xyz1, xyz2, icoord)
         call wrlmocoord('lmocent2.coord', n1, n2, xyz1, xyz2,&
                        &at1, at2, nlmo1, nlmo2,&
                        &lmo1, lmo2, rlmo1, rlmo2)
      end if

      icoord = 0
!     shift to CMA and xyz1 is not changed anymore
      if (nfrag1 .eq. 0) then
         call cmadock(n1, n1, at1, xyz1, r) !cma kommt als r(3) zurück
      else
         call cmadock(nfrag1, n1, at1, xyz1, r)
      end if
      icoord(1:3) = -r(1:3)
      do i = 1, 3
         xyz1(i, 1:n1) = xyz1(i, 1:n1) - r(i)
         rlmo1(i, 1:nlmo1) = rlmo1(i, 1:nlmo1) - r(i)
      end do
      call cmadock(n2, n2, at2, xyz2, r)
      icoord(1:3) = icoord(1:3) + r(1:3)
      do i = 1, 3
         xyz2(i, 1:n2) = xyz2(i, 1:n2) - r(i)
         rlmo2(i, 1:nlmo2) = rlmo2(i, 1:nlmo2) - r(i)
      end do
! save orig coord
      icoord0 = icoord

!     Drude and Gauss ini
      np = 4 ! # of prims
      fall = 0.50d0
      fhyd = 3.00d0
      p1 = 4.00   ! just for convenience so that r0scal is around 1
      do i = 1, n1
         f = fall
         if (at1(i) .le. 2) f = fhyd
         fc = par_drude_fc*gam(at1(i))
         qdr1(i) = -f*(fc*alp1(i))**0.50d0
         alp1(i) = alp1(i)**(1./3.)           ! make radius
         if (at1(i) .eq. 1) then
            aa = p1*r0scal(at1(i))/alp1(i)    ! Gaussian density
            aa = aa*(1.+cn1(i))**(1./2.)
         else
            aa = p1*r0scal(at1(i))/alp1(i)    ! Gaussian density
            aa = aa*(1.+cn1(i))**(-1./3.)
         end if
         dum1(i) = aa
         call setsto4(np, 1, 1, aa, e1, c1)
         den1(1, 1:np, i) = e1(1:np)            ! exp
         den1(2, 1:np, i) = c1(1:np)            ! contract
      end do
      do i = 1, n2
         f = fall
         if (at2(i) .le. 2) f = fhyd
         fc = par_drude_fc*gam(at2(i))
         qdr2(i) = -f*(fc*alp2(i))**0.50d0
         alp2(i) = alp2(i)**(1./3.)           ! make radius
         if (at2(i) .eq. 1) then
            aa = p1*r0scal(at2(i))/alp2(i)    ! Gaussian density
            aa = aa*(1.+cn2(i))**(1./2.)
         else
            aa = p1*r0scal(at2(i))/alp2(i)    ! Gaussian density
            aa = aa*(1.+cn2(i))**(-1./3.)
         end if
         dum2(i) = aa
         call setsto4(np, 1, 1, aa, e1, c1)
         den2(1, 1:np, i) = e1(1:np)            ! exp
         den2(2, 1:np, i) = c1(1:np)            ! contract
      end do

!     ccccccccccccccccccccccccccccccccccccccccccccccccc
!                       some output
!     ccccccccccccccccccccccccccccccccccccccccccccccccc

      if (debug) then
      write(*,*) '  #   Z           coordinates (CMA)   CN(D4)    qM/CM5','   alp   dexpo'
         do i = 1, n1
            write (*, '(2i4,3f10.5,3f6.2,3f7.3)')&
          &i, at1(i), xyz1(1:3, i), cn1(i), q1(i), q(i), alp1(i), dum1(i)
         end do
         write (*, *) 'LMOcent on atom     coordinates    charge'
         do i = 1, nlmo1
            write (*, '(2i7,3f10.5,5x,f7.3)') i, lmo1(i), rlmo1(1:4, i)
         end do
         write (*, *) &
        &'  #   Z           coordinates (CMA)   CN(D4)     qM/CM5',&
        &'   alp   dexpo'
         do i = 1, n2
            write (*, '(2i4,3f10.5,3f6.2,3f7.3)')&
           &i, at2(i), xyz2(1:3, i), cn2(i), q2(i), q(i + n1), alp2(i), dum2(i)
         end do
         write (*, *) 'LMOcent on atom     coordinates    charge'
         do i = 1, nlmo2
            write (*, '(2i7,3f10.5,5x,f7.3)') i, lmo2(i), rlmo2(1:4, i)
         end do
      end if

      write (*, '(''  LUMO energy 1 (read)           :'',F8.3)')&
      &elumo(1)*27.212
      write (*, '(''  HOMO energy 1 (read)           :'',F8.3)')&
      &ehomo(1)*27.212

      write (*, '(''  LUMO energy 2 (read)           :'',F8.3)')&
      &elumo(2)*27.212
      write (*, '(''  HOMO energy 2 (read)           :'',F8.3)')&
      &ehomo(2)*27.212

   end subroutine

   subroutine setsto4(nprim, n, l, zeta, expo, cont)
      integer, intent(in) :: n, l
      integer, intent(inout) :: nprim
      real(wp), intent(in) :: zeta
      real(wp), intent(out) :: expo(nprim), cont(nprim)

      real(wp) :: ALLC(4, 5, 4), ALLZ(4, 5, 4)
      integer :: iam
      real(wp) :: DEX(-1:96)
      integer :: I, J, DEX2
      real(wp) :: XNORM, PI

      nprim = 4

      PI = 4.D0*ATAN(1.D0)
      DO I = -1, 10
         if (I .lt. 2) then
            DEX2 = 1
         else
            DEX2 = 1
            do j = 1, I, 2
               DEX2 = DEX2*j
            end do
         end if
         DEX(I) = DEX2
      END DO
!                      1S
      ALLZ(1, 1, 1) = 5.216844534
      ALLZ(2, 1, 1) = 9.546182760D-1
      ALLZ(3, 1, 1) = 2.652034102D-1
      ALLZ(4, 1, 1) = 8.801862774D-2
      ALLC(1, 1, 1) = 5.675242080D-2
      ALLC(2, 1, 1) = 2.601413550D-1
      ALLC(3, 1, 1) = 5.328461143D-1
      ALLC(4, 1, 1) = 2.916254405D-1
!                      2S
      ALLZ(1, 2, 1) = 1.161525551D1
      ALLZ(2, 2, 1) = 2.000243111
      ALLZ(3, 2, 1) = 1.607280687D-1
      ALLZ(4, 2, 1) = 6.125744532D-2
      ALLC(1, 2, 1) = -1.198411747D-2
      ALLC(2, 2, 1) = -5.472052539D-2
      ALLC(3, 2, 1) = 5.805587176D-1
      ALLC(4, 2, 1) = 4.770079976D-1
!                     2P
      ALLZ(1, 2, 2) = 1.798260992
      ALLZ(2, 2, 2) = 4.662622228D-1
      ALLZ(3, 2, 2) = 1.643718620D-1
      ALLZ(4, 2, 2) = 6.543927065D-2
      ALLC(1, 2, 2) = 5.713170255D-2
      ALLC(2, 2, 2) = 2.857455515D-1
      ALLC(3, 2, 2) = 5.517873105D-1
      ALLC(4, 2, 2) = 2.632314924D-1
!                      3S
      ALLZ(1, 3, 1) = 1.513265591
      ALLZ(2, 3, 1) = 4.262497508D-1
      ALLZ(3, 3, 1) = 7.643320863D-2
      ALLZ(4, 3, 1) = 3.760545063D-2
      ALLC(1, 3, 1) = -3.295496352D-2
      ALLC(2, 3, 1) = -1.724516959D-1
      ALLC(3, 3, 1) = 7.518511194D-1
      ALLC(4, 3, 1) = 3.589627317D-1
!                     3P
      ALLZ(1, 3, 2) = 1.853180239
      ALLZ(2, 3, 2) = 1.915075719D-1
      ALLZ(3, 3, 2) = 8.655487938D-2
      ALLZ(4, 3, 2) = 4.184253862D-2
      ALLC(1, 3, 2) = -1.434249391D-2
      ALLC(2, 3, 2) = 2.755177580D-1
      ALLC(3, 3, 2) = 5.846750879D-1
      ALLC(4, 3, 2) = 2.144986514D-1
!                      4S
      ALLZ(1, 4, 1) = 3.242212833D-1
      ALLZ(2, 4, 1) = 1.663217177D-1
      ALLZ(3, 4, 1) = 5.081097451D-2
      ALLZ(4, 4, 1) = 2.829066600D-2
      ALLC(1, 4, 1) = -1.120682822D-1
      ALLC(2, 4, 1) = -2.845426863D-1
      ALLC(3, 4, 1) = 8.909873788D-1
      ALLC(4, 4, 1) = 3.517811205D-1
!                     4P
      ALLZ(1, 4, 2) = 1.492607880
      ALLZ(2, 4, 2) = 4.327619272D-1
      ALLZ(3, 4, 2) = 7.553156064D-2
      ALLZ(4, 4, 2) = 3.706272183D-2
      ALLC(1, 4, 2) = -6.035216774D-3
      ALLC(2, 4, 2) = -6.013310874D-2
      ALLC(3, 4, 2) = 6.451518200D-1
      ALLC(4, 4, 2) = 4.117923820D-1
!                      5S
      ALLZ(1, 5, 1) = 8.602284252D-1
      ALLZ(2, 5, 1) = 1.189050200D-1
      ALLZ(3, 5, 1) = 3.446076176D-2
      ALLZ(4, 5, 1) = 1.974798796D-2
      ALLC(1, 5, 1) = 1.103657561D-2
      ALLC(2, 5, 1) = -5.606519023D-1
      ALLC(3, 5, 1) = 1.179429987
      ALLC(4, 5, 1) = 1.734974376D-1
!                     5P
      ALLZ(1, 5, 2) = 3.962838833D-1
      ALLZ(2, 5, 2) = 1.838858552D-1
      ALLZ(3, 5, 2) = 4.943555157D-2
      ALLZ(4, 5, 2) = 2.750222273D-2
      ALLC(1, 5, 2) = -1.801459207D-2
      ALLC(2, 5, 2) = -1.360777372D-1
      ALLC(3, 5, 2) = 7.533973719D-1
      ALLC(4, 5, 2) = 3.409304859D-1
! 3d
      ALLZ(1, 3, 3) = 9.185846715D-1
      ALLZ(2, 3, 3) = 2.920461109D-1
      ALLZ(3, 3, 3) = 1.187568890D-1
      ALLZ(4, 3, 3) = 5.286755896D-2
      ALLC(1, 3, 3) = 5.799057705D-2
      ALLC(2, 3, 3) = 3.045581349D-1
      ALLC(3, 3, 3) = 5.601358038D-1
      ALLC(4, 3, 3) = 2.432423313D-1
! 4d
      ALLZ(1, 4, 3) = 1.995825422
      ALLZ(2, 4, 3) = 1.823461280D-1
      ALLZ(3, 4, 3) = 8.197240896D-2
      ALLZ(4, 4, 3) = 4.000634951D-2
      ALLC(1, 4, 3) = -2.816702620D-3
      ALLC(2, 4, 3) = 2.177095871D-1
      ALLC(3, 4, 3) = 6.058047348D-1
      ALLC(4, 4, 3) = 2.717811257D-1
! 5d
      ALLZ(1, 5, 3) = 4.230617826D-1
      ALLZ(2, 5, 3) = 8.293863702D-2
      ALLZ(3, 5, 3) = 4.590326388D-2
      ALLZ(4, 5, 3) = 2.628744797D-2
      ALLC(1, 5, 3) = -2.421626009D-2
      ALLC(2, 5, 3) = 3.937644956D-1
      ALLC(3, 5, 3) = 5.489520286D-1
      ALLC(4, 5, 3) = 1.190436963D-1

! 4f (the add. factors are required because the normal. function
!     below is not correct for f)
      ALLZ(1, 4, 4) = 0.05691670217
      ALLZ(2, 4, 4) = 0.2074585819
      ALLZ(3, 4, 4) = 0.09298346885
      ALLZ(4, 4, 4) = 0.04473508853
      ALLC(1, 4, 4) = 0.05902730589/1.063832358490576**0.5
      ALLC(2, 4, 4) = 0.3191828952/1.063832358490576**0.5
      ALLC(3, 4, 4) = 0.5639423893/1.063832358490576**0.5
      ALLC(4, 4, 4) = 0.2284796537/1.063832358490576**0.5

      iam = l - 1
      DO J = 1, nprim
         cont(J) = ALLC(J, N, L)
         expo(J) = ALLZ(J, N, L)*zeta**2
         XNORM = (2.D0*EXPO(J)/PI)**0.75D0*(4.D0*EXPO(J))**(IAM/2.D0)/&
               &SQRT(DEX(2*IAM - 1))
         cont(j) = cont(j)*xnorm
      END DO

   end subroutine setsto4

   subroutine c6_alp0(nat, at, xyz, cn, q, azero, c6ab)

      integer, intent(in) :: nat, at(nat)
      real(wp), intent(in) :: xyz(3, nat)
      !> Coordination number of every atom and charge.
      real(wp), intent(in) :: cn(nat), q(nat)
      !> C6AB Coefficients
      real(wp), intent(out) :: c6ab(nat, nat)
      !> Polarizabilities
      real(wp), intent(out) :: azero(nat)

      !> Molecular Structure information.
      type(TMolecule) :: mol

      type(TDispersionModel) :: dispm

      !> Charge scaling height.
      real(wp) :: g_a = 3.0_wp

      !> Charge scaling steepness.
      real(wp) :: g_c = 2.0_wp

      !> Exponent for the Gaussian weighting.
      real(wp) :: wf = 6.0_wp

      integer :: max_ref, i, ii, ia, k, iz

      real(wp) :: aw(23, nat), covcn(nat)

      real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
      real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
      real(wp), allocatable :: dc6dcn(:, :), dc6dq(:, :), gw(:), c6ref(:,:), zetvec(:)

      integer :: dispdim

      aw = 0.0_wp
      call init(mol, at, xyz)

      call newD4Model(dispm, g_a, g_c, p_refq_gfn2xtb)
      call d4dim(dispm, nat, at, dispdim) !To get disp dimension

      max_ref = maxval(dispm%nref(at))
      allocate (zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &         zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &         dc6dcn(nat, nat), dc6dq(nat, nat), gw(dispdim), c6ref(dispdim, dispdim), &
      &         zetvec(dispdim), source=0.0_wp)

      call weight_references(dispm, nat, at, g_a, g_c, wf, q, cn, zeff, gamma, &
         & zetavec, zerovec, zetadcn, zerodcn, zetadq) !generated zetavecotrs
      call get_atomic_c6(dispm, nat, mol%at, zetavec, zetadcn, zetadq, &
         & c6ab, dc6dcn, dc6dq) !c6ab are generated here
      call d4(dispm, nat, dispdim, at, wf, g_a, g_c, cn, gw, c6ref) !To get gw

      k = 0
      do i = 1, nat
         ia = at(i)
         iz = zeff(ia)
         do ii = 1, dispm%nref(ia)
            k = k + 1
            zetvec(k) = gw(k)*zeta(g_a, gamma(ia)*g_c, dispm%q(ii, ia) + iz, q(i) + iz)
            aw(:, i) = aw(:, i) + zetvec(k)*dispm%alpha(:, ii, ia)
         end do
      end do

      azero(:) = aw(1, :)

      deallocate(dispm%atoms,dispm%nref,dispm%ncount,dispm%cn,dispm%q,dispm%alpha,dispm%c6)
      dispm%g_a = 0.0_wp
      dispm%g_c = 0.0_wp

      deallocate(zetavec,zetadcn,zetadq,zerovec,zerodcn,zerodq,dc6dcn,dc6dq,gw,c6ref,zetvec)

   end subroutine c6_alp0

end module xtb_iff_iffini

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!! ------------------------------------------------------------------------
!  this module implements system calls (calls to functions implemented by
!  the Linux kernel, *not* call system()!) in a Fortran accessable way.
!  All system calls can be looked up by `man 2 <name>'.
!! ------------------------------------------------------------------------
module xtb_mctc_linux
   !  sys/types.h
   !  > typedef unsigned short mode_t; /* file type and permissions bits */
   !    Note: rwxr-xr-x -> o'0755' -> b'0000000111101101'
   use iso_c_binding, mode_t => c_short
   interface c_mkdir
      !  int mkdir(const char *pathname, mode_t mode);
      integer(c_int) function mkdir(pathname, mode) bind(c)
         import c_int,mode_t,c_char
         character(kind=c_char),intent(in) :: pathname
         integer(mode_t),value             :: mode
      end function mkdir
   end interface c_mkdir
   interface c_rmdir
      !  int rmdir(const char *pathname);
      integer(c_int) function rmdir(pathname) bind(c)
         import c_int,c_char
         character(kind=c_char),intent(in) :: pathname
      end function rmdir
   end interface c_rmdir
   interface c_link
      !  int link(const char *oldpath, const char *newpath);
      integer(c_int) function link(oldpath,newpath) bind(c)
         import c_int,c_char
         character(kind=c_char),intent(in) :: oldpath,newpath
      end function link
   end interface c_link
   interface c_unlink
      !  int unlink(const char *pathname);
      integer(c_int) function unlink(pathname) bind(c)
         import c_int,c_char
         character(kind=c_char),intent(in) :: pathname
      end function unlink
   end interface c_unlink
   interface c_symlink
      !  int symlink(const char *oldpath, const char *newpath);
      integer(c_int) function symlink(oldpath,newpath) bind(c)
         import c_int,c_char
         character(kind=c_char),intent(in) :: oldpath,newpath
      end function symlink
   end interface c_symlink
   interface c_chdir
      !  int chdir(const char *pathname);
      integer(c_int) function chdir(pathname) bind(c)
         import c_int,c_char
         character(kind=c_char),intent(in) :: pathname
      end function chdir
   end interface c_chdir
   interface c_umask
      !  mode_t umask(mode_t mask);
      integer(mode_t) function umask(pathname, mode) bind(c)
         import mode_t
         integer(mode_t),value :: mode
      end function umask
   end interface c_umask
   interface c_chmod
      !  int chmod(const char *pathname, mode_t mode);
      integer(c_int) function chmod(pathname, mode) bind(c)
         import c_int,mode_t,c_char
         character(kind=c_char),intent(in) :: pathname
         integer(mode_t),value             :: mode
      end function chmod
   end interface c_chmod

contains
!! ------------------------------------------------------------------------
function sys_mkdir(pathname) result(err)
   use iso_c_binding
   integer :: err
   character(len=*),intent(in)                :: pathname
   character(kind=c_char,len=len(pathname)+1) :: c_name
   integer(mode_t),parameter :: umask = int(O'0755',mode_t)
   c_name = pathname // c_null_char

   err = c_mkdir(c_name,umask)

end function sys_mkdir
!! ------------------------------------------------------------------------
function sys_rmdir(pathname) result(err)
   use iso_c_binding
   integer :: err
   character(len=*),intent(in)                :: pathname
   character(kind=c_char,len=len(pathname)+1) :: c_name
   c_name = pathname // c_null_char

   err = c_rmdir(c_name)

end function sys_rmdir
!! ------------------------------------------------------------------------
function sys_link(oldpath,newpath) result(err)
   use iso_c_binding
   integer :: err
   character(len=*),intent(in)               :: oldpath
   character(len=*),intent(in)               :: newpath
   character(kind=c_char,len=len(oldpath)+1) :: c_old
   character(kind=c_char,len=len(newpath)+1) :: c_new
   c_old = oldpath // c_null_char
   c_new = newpath // c_null_char

   err = c_link(c_old,c_new)
end function sys_link
!! ------------------------------------------------------------------------
function sys_unlink(pathname) result(err)
   use iso_c_binding
   integer :: err
   character(len=*),intent(in)                :: pathname
   character(kind=c_char,len=len(pathname)+1) :: c_name
   c_name = pathname // c_null_char

   err = c_unlink(c_name)

end function sys_unlink
!! ------------------------------------------------------------------------
function sys_symlink(oldpath,newpath) result(err)
   use iso_c_binding
   integer :: err
   character(len=*),intent(in)               :: oldpath
   character(len=*),intent(in)               :: newpath
   character(kind=c_char,len=len(oldpath)+1) :: c_old
   character(kind=c_char,len=len(newpath)+1) :: c_new
   c_old = oldpath // c_null_char
   c_new = newpath // c_null_char

   err = c_symlink(c_old,c_new)
end function sys_symlink
!! ------------------------------------------------------------------------
function sys_chdir(pathname) result(err)
   use iso_c_binding
   integer :: err
   character(len=*),intent(in)                :: pathname
   character(kind=c_char,len=len(pathname)+1) :: c_name
   c_name = pathname // c_null_char
   err = c_chdir(c_name)
end function sys_chdir

end module xtb_mctc_linux

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Available boundary conditions in this program
module xtb_mctc_boundaryconditions
   implicit none
   private

   public :: boundaryCondition


   !> Possible boundary conditions
   type :: TBoundaryCondEnum

      !> Finite molecular structure
      integer :: cluster = 0

      !> Three dimensional infinite periodic boundary conditions
      integer :: pbc3d = 3

   end type 

   !> Boundary condition enumerator
   type(TBoundaryCondEnum), parameter :: boundaryCondition = TBoundaryCondEnum()


contains


end module xtb_mctc_boundaryconditions

! This file is part of xtb.
!
! Copyright (C) 2021 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_freq_io
   use xtb_mctc_accuracy, only: wp
   use xtb_lin, only: lin
   implicit none
   private

   public :: writeHessianOut, rdhess, wrhess, write_tm_vibspectrum
   public :: g98fake, g98fake2

contains

!> Write the second derivative matrix
   subroutine writeHessianOut(fname, hessian)

      !> File name
      character(len=*), intent(in) :: fname

      !> Dynamical (Hessian) matrix
      real(wp), intent(in) :: hessian(:, :)

      !> Format string for energy second derivative matrix
      character(len=*), parameter :: fmt = '(4f16.10)'

      integer :: ii, id

      call open_file(id, fname, 'w')
      do ii = 1, size(hessian, dim=2)
         write (id, fmt) hessian(:, ii)
      end do
      call close_file(id)

   end subroutine writeHessianOut

   subroutine wrhess(nat3, h, fname)
      integer, intent(in) :: nat3
      real(wp), intent(in) :: h(nat3 * (nat3 + 1) / 2)
      character(len=*), intent(in) :: fname
      integer iunit, i, j, mincol, maxcol, k
      character(len=5) :: adum
      character(len=80) :: a80

      adum = '   '
      call open_file(iunit, fname, 'w')
      a80 = '$hessian'
      write (iunit, '(a)') a80
      do i = 1, nat3
         maxcol = 0
         k = 0
200      mincol = maxcol + 1
         k = k + 1
         maxcol = min(maxcol + 5, nat3)
         write (iunit, '(a5,5f15.10)') adum, (h(lin(i, j)), j=mincol, maxcol)
         if (maxcol < nat3) goto 200
      end do
      call close_file(iunit)

   end subroutine wrhess

   subroutine rdhess(nat3, h, fname)
      integer, intent(in) :: nat3
      real(wp), intent(out) :: h(nat3, nat3)
      character(len=*), intent(in) :: fname
      integer :: iunit, i, j, mincol, maxcol
      character(len=5) :: adum
      character(len=80) :: a80

      !     write(*,*) 'Reading Hessian <',trim(fname),'>'
      call open_file(iunit, fname, 'r')
50    read (iunit, '(a)') a80
      if (index(a80, '$hessian') /= 0) then
         do i = 1, nat3
            maxcol = 0
200         mincol = maxcol + 1
            maxcol = min(maxcol + 5, nat3)
            read (iunit, *) (h(j, i), j=mincol, maxcol)
            if (maxcol < nat3) goto 200
         end do
         call close_file(iunit)
         goto 300
      end if
      goto 50

300   return
   end subroutine rdhess

   subroutine write_tm_vibspectrum(ich, n3, freq, ir_int, raman_activity, temp, v_incident)
      use xtb_setparam
      use xtb_mctc_constants
      use xtb_mctc_convert
      integer, intent(in) :: ich ! file handle
      integer, intent(in) :: n3
      real(wp), intent(in) :: freq(n3)
      real(wp), intent(in) :: ir_int(n3)
      real(wp), intent(in), optional :: raman_activity(n3)
      !> CAUTION: v_incident is in cm**(-1)
      real(wp), intent(in), optional :: temp, v_incident
      real(wp), allocatable :: raman_int(:)
      integer :: i
      real(wp) :: thr = 1.0e-2_wp
      real(wp) :: thr_int = 1.0e-2_wp
      real(wp) :: v_meter, hbycvb, bfactor, prefactor, v0minvito4, raman_act_si

      if (set%elprop == p_elprop_alpha) then
         allocate (raman_int(n3), source=0.0_wp)
         !> Conversion into measurable intensities follows
         !> https://doi.org/10.1016/j.cplett.2004.12.096
         !> Chemical Physics Letters 403 (2005) 211–217
         !> Further literature under: http://chemcraftprog.com/help/spectrumwindow.html;
         !                            https://old.iupac.org/reports/V/spectro/partXVIII.pdf
         !                            https://doi.org/10.1016/j.molstruc.2004.06.004
         !                            https://doi.org/10.1021/j100384a024
         do i = 1, n3
            !> B_i
            v_meter = freq(i) * 1.0e2_wp
            bfactor = 1.0_wp - exp(-(v_meter * h_SI * lightspeed_SI) / (kB_SI * temp))
            !      h
            ! -------------
            ! c * vi * Bi
            hbycvb = h_SI / (lightspeed_SI * v_meter * bfactor)
            !       (2 * Pi)^4
            ! ------------------
            !    45 * 8 * Pi^2
            prefactor = (2.0_wp * (pi**2)) / 45.0_wp
            ! (v_incident - v_i)^4
            v0minvito4 = ((v_incident * 1.0e2_wp) - v_meter)**4
            !> Conversion into SI units
            raman_act_si = raman_activity(i) / m4bykgtoang4byamu()
            !> putting it all together
            raman_int(i) = prefactor * hbycvb * v0minvito4 * raman_act_si * 1.0e+20_wp
         end do

         write (ich, '("$vibrational spectrum")')
   write(ich,'("#  mode     symmetry     wave number   IR intensity   Raman activity   Raman scatt. cross-section   selection rules")')
   write(ich,'("#                           (cm⁻¹)      (km*mol⁻¹)      (Å⁴*amu⁻¹)             (Å²*sr⁻¹)              IR     RAMAN")')
         do i = 1, n3
            if (abs(freq(i)) < thr) then
               write (ich, '(i6,9x,    f18.2,f16.5,f16.5,8x,e16.5,13x," - ",5x," - ")') &
                  &  i, freq(i), 0.0_wp, 0.0_wp, 0.0_wp
            else
               write (ich, '(i6,8x,"a",f18.2,f16.5,f16.5,8x,e16.5,13x)', advance="no") &
                  &  i, freq(i), ir_int(i), raman_activity(i), raman_int(i)

               if (ir_int(i) > thr_int) then
                  write (ich, '(a)', advance="no") "YES"
               else
                  write (ich, '(a)', advance="no") "NO "
               end if

               if (raman_activity(i) > thr_int) then
                  write (ich, '(5x,a)') "YES"
               else
                  write (ich, '(5x,a)') "NO "
               end if
            end if
         end do
      else
         write (ich, '("$vibrational spectrum")')
         write (ich, '("#  mode     symmetry     wave number   IR intensity    selection rules")')
         write (ich, '("#                         cm**(-1)      (km*mol⁻¹)        IR     ")')
         do i = 1, n3
            if (abs(freq(i)) < thr) then
               write (ich, '(i6,9x,    f18.2,f16.5,9x," - ")') &
                  i, freq(i), 0.0_wp
            else
               if (ir_int(i) > thr_int) then
                  write (ich, '(i6,8x,"a",f18.2,f16.5,9x,"YES")') &
                     i, freq(i), ir_int(i)
               else
                  write (ich, '(i6,8x,"a",f18.2,f16.5,9x,"NO")') &
                     i, freq(i), ir_int(i)
               end if
            end if
         end do
      end if

      write (ich, '("$end")')
   end subroutine

   subroutine g98fake2(fname, n, at, xyz, freq, red_mass, ir_int, u2)
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      real(wp), intent(in) :: freq(3 * n)
      real(wp), intent(in) :: xyz(3, n)
      real(wp), intent(in) :: u2(3 * n, 3 * n)
      character(len=*), intent(in) :: fname
      real(wp), intent(in) :: red_mass(3 * n)
      real(wp), intent(in) :: ir_int(3 * n)

      integer :: gu, i, j, ka, kb, kc, la, lb, k
      character(len=2) :: irrep
      real(wp), allocatable :: u(:, :)
      real(wp), allocatable :: red(:)
      real(wp), allocatable :: f2(:)
      real(wp), allocatable :: ir(:)
      real(wp) :: zero

      allocate (u(3 * n, 3 * n), red(3 * n), f2(3 * n), ir(3 * n), source=0.0_wp)

      irrep = 'a'
      zero = 0.0

      k = 0
      do i = 1, 3 * n
         if (abs(freq(i)) > 1.d-1) then
            k = k + 1
            u(1:3 * n, k) = u2(1:3 * n, i)
            f2(k) = freq(i)
            ir(k) = ir_int(i)
            red(k) = red_mass(i)
         end if
      end do

      gu = 55
      call open_file(gu, fname, 'w')
      write (gu, '('' Entering Gaussian System'')')
      write (gu, '('' *********************************************'')')
      write (gu, '('' Gaussian 98:'')')
      write (gu, '('' frequency output generated by the xtb code'')')
      write (gu, '('' *********************************************'')')

      write (gu, *) '                        Standard orientation:'
      write (gu, *) '---------------------------------------------', &
         & '-----------------------'
      write (gu, *) ' Center     Atomic     Atomic', &
         & '              Coordinates (Angstroms)'
      write (gu, *) ' Number     Number      Type ', &
         & '             X           Y           Z'
      write (gu, *) '-----------------------', &
         & '---------------------------------------------'
      j = 0
      do i = 1, n
         write (gu, 111) i, at(i), j, xyz(1:3, i) * 0.52917726
      end do
      write (gu, *) '----------------------', &
         & '----------------------------------------------'
      write (gu, *) '    1 basis functions        1 primitive gaussians'
      write (gu, *) '    1 alpha electrons        1 beta electrons'
      write (gu, *)
111   format(i5, i11, i14, 4x, 3f12.6)

      write (gu, *) 'Harmonic frequencies (cm**-1), IR intensities', &
         & ' (km*mol⁻¹),'
      write (gu, *) 'Raman scattering activities (A**4/amu),', &
         & ' Raman depolarization ratios,'
      write (gu, *) 'reduced masses (AMU), force constants (mDyne/A)', &
         & ' and normal coordinates:'

      ka = 1
      kc = 3
60    kb = min0(kc, k)
      write (gu, 100) (j, j=ka, kb)
      write (gu, 105) (irrep, j=ka, kb)
      write (gu, 110) ' Frequencies --', (f2(j), j=ka, kb)
      write (gu, 110) ' Red. masses --', (red(j), j=ka, kb)
      write (gu, 110) ' Frc consts  --', (zero, j=ka, kb)
      write (gu, 110) ' IR Inten    --', (ir(j), j=ka, kb)
      write (gu, 110) ' Raman Activ --', (zero, j=ka, kb)
      write (gu, 110) ' Depolar     --', (zero, j=ka, kb)
      write (gu, *) 'Atom AN      X      Y      Z        X      Y', &
         & '      Z        X      Y      Z'
      la = 1
70    lb = n
      do i = la, lb
         write (gu, 130) i, at(i), (u(i * 3 - 2, j), u(i * 3 - 1, j), u(i * 3, j), j=ka, kb)
      end do
      if (lb == n) go to 90
      go to 70
90    if (kb == k) then
         return
      end if
      ka = kc + 1
      kc = kc + 3
      go to 60

100   format(3(20x, i3))
105   format(3x, 3(18x, a5))
110   format(a15, f11.4, 12x, f11.4, 12x, f11.4)
130   format(2i4, 3(2x, 3f7.2))

      write (gu, '(''end of file'')')
      call close_file(gu)
      return

   end subroutine g98fake2

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

   subroutine g98fake(fname, n, at, xyz, freq, u2)
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      real(wp), intent(in) :: freq(3 * n)
      real(wp), intent(in) :: xyz(3, n)
      real(wp), intent(in) :: u2(3 * n, 3 * n)
      character(len=*), intent(in) :: fname

      integer :: gu, i, j, ka, kb, kc, la, lb, k
      character(len=2) :: irrep
      real(wp), allocatable :: u(:, :)
      real(wp), allocatable :: red_mass(:)
      real(wp), allocatable :: force(:)
      real(wp), allocatable :: ir_int(:)
      real(wp), allocatable :: f2(:)
      real(wp) :: zero

      allocate (u(3 * n, 3 * n), red_mass(3 * n), force(3 * n), ir_int(3 * n), f2(3 * n), &
                source=0.0_wp)

      irrep = 'a'
      red_mass = 99.0
      force = 99.0
      ir_int = 99.0
      zero = 0.0

      k = 0
      do i = 1, 3 * n
         if (abs(freq(i)) > 1.d-1) then
            k = k + 1
            u(1:3 * n, k) = u2(1:3 * n, i)
            f2(k) = freq(i)
         end if
      end do

      gu = 55
      call open_file(gu, fname, 'w')
      write (gu, '('' Entering Gaussian System'')')
      write (gu, '('' *********************************************'')')
      write (gu, '('' Gaussian 98:'')')
      write (gu, '('' frequency output generated by the xtb code'')')
      write (gu, '('' *********************************************'')')

      write (gu, *) '                        Standard orientation:'
      write (gu, *) '---------------------------------------------', &
         & '-----------------------'
      write (gu, *) ' Center     Atomic     Atomic', &
         & '              Coordinates (Angstroms)'
      write (gu, *) ' Number     Number      Type ', &
         & '             X           Y           Z'
      write (gu, *) '-----------------------', &
         & '---------------------------------------------'
      j = 0
      do i = 1, n
         write (gu, 111) i, at(i), j, xyz(1:3, i) * 0.52917726
      end do
      write (gu, *) '----------------------', &
         & '----------------------------------------------'
      write (gu, *) '    1 basis functions        1 primitive gaussians'
      write (gu, *) '    1 alpha electrons        1 beta electrons'
      write (gu, *)
111   format(i5, i11, i14, 4x, 3f12.6)

      write (gu, *) 'Harmonic frequencies (cm**-1), IR intensities', ' (km*mol⁻¹),'
      write (gu, *) 'Raman scattering activities (A**4/amu),', &
         & ' Raman depolarization ratios,'
      write (gu, *) 'reduced masses (AMU), force constants (mDyne/A)', &
         & ' and normal coordinates:'

      ka = 1
      kc = 3
60    kb = min0(kc, k)
      write (gu, 100) (j, j=ka, kb)
      write (gu, 105) (irrep, j=ka, kb)
      write (gu, 110) ' Frequencies --', (f2(j), j=ka, kb)
      write (gu, 110) ' Red. masses --', (red_mass(j), j=ka, kb)
      write (gu, 110) ' Frc consts  --', (force(j), j=ka, kb)
      write (gu, 110) ' IR Inten    --', (ir_int(j), j=ka, kb)
      write (gu, 110) ' Raman Activ --', (zero, j=ka, kb)
      write (gu, 110) ' Depolar     --', (zero, j=ka, kb)
      write (gu, *) 'Atom AN      X      Y      Z        X      Y', &
         & '      Z        X      Y      Z'
      la = 1
70    lb = n
      do i = la, lb
         write (gu, 130) i, at(i), (u(i * 3 - 2, j), u(i * 3 - 1, j), u(i * 3, j), j=ka, kb)
      end do
      if (lb == n) go to 90
      go to 70
90    if (kb == k) then
         return
      end if
      ka = kc + 1
      kc = kc + 3
      go to 60

100   format(3(20x, i3))
105   format(3x, 3(18x, a5))
110   format(a15, f11.4, 12x, f11.4, 12x, f11.4)
130   format(2i4, 3(2x, 3f7.2))

      write (gu, '(''end of file'')')
      call close_file(gu)
      return

   end subroutine g98fake

end module xtb_freq_io

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine wrgbw(xtbData,n,iat,coord,z,basis,wfn)
   use, intrinsic :: iso_fortran_env, only : output_unit
   use, intrinsic :: iso_c_binding, only : c_bool, c_char, c_int, c_long, c_double
   use xtb_mctc_accuracy, only : wp, int64 => i8
   use xtb_type_basisset
   use xtb_type_wavefunction
   use xtb_xtb_data
   implicit none
!! ------------------------------------------------------------------------
!  xtb input
   type(TxTBData), intent(in) :: xtbData
   integer, intent(in) :: n
   integer, intent(in) :: iat(n)
   real(wp),intent(in) :: coord(3,n)
   real(wp),intent(in) :: z(n)
   type(TBasisset),    intent(in) :: basis
   type(TWavefunction),intent(in) :: wfn
!! ------------------------------------------------------------------------
!  ORCA input
!  file pointer
   integer(c_long) :: ptr_info
   integer(c_long) :: ptr_geometry
   integer(c_long) :: ptr_basisset
   integer(c_long) :: ptr_wavefunction
   integer(c_long),parameter :: ptr_ecp = 0
!  Geometry
   integer(c_int) :: nat
   integer(c_int),allocatable :: at(:)
   integer(c_int),allocatable :: frag(:)
   integer(c_int),allocatable :: fix(:,:)
   real(c_double),allocatable :: xyz(:,:)
   real(c_double),allocatable :: za(:)
   real(c_double),allocatable :: xi(:)
   real(c_double),allocatable :: am(:)

!  Basisset
   integer(c_int),parameter :: maxgauss = 32
   type :: BFNGauss ! defined exactly as the ORCA equivalent
      integer(c_int) :: l = 0       ! angular momentum quantum number for the shell
      integer(c_int) :: lstart = 0  ! where the shell starts in the basis
      integer(c_int) :: ng = 0      ! Number of components
      real(c_double) :: a(maxgauss) = 0.0_c_double ! orbital exponents
      real(c_double) :: d(maxgauss) = 0.0_c_double ! expansion coeffients
   end type BFNGauss
   logical(c_bool),parameter :: Have_STO     = .false.
   logical(c_bool),parameter :: Have_GTO     = .true.
   logical(c_bool),parameter :: Have_GTOAUX  = .false.
   logical(c_bool),parameter :: Have_GTOCABS = .false.
   logical(c_bool),parameter :: Have_Label   = .false.
   integer(c_int),allocatable :: nshell(:)
   type(BFNGauss),allocatable :: BG(:,:)

!  Wavefunction
   integer(c_int),parameter :: nop = 1
   integer(c_int) :: nao
   real(c_double),allocatable :: C(:,:)
   real(c_double),allocatable :: occ(:)
   real(c_double),allocatable :: emo(:)
   integer(c_int),allocatable :: irrep(:)
   integer(c_int),allocatable :: core(:)

!  local
   integer :: iunit
   logical :: exist
   integer :: i,ish,ati,ishtyp,icao,iao,ip,iprim,icount
   character(kind=c_char),allocatable :: info(:)
   integer(int64) :: iend,istart,ival(3)
   integer(int64) :: total_size = 0
   integer(int64) :: size_info = 0
   integer(int64) :: size_pointer = 0
   integer(int64) :: size_geometry = 0
   integer(int64) :: size_basisset = 0
   integer(int64) :: size_wavefunction = 0
   integer(c_int) :: ishell

!  check if we can provide the necessary C-types
   if (c_long.eq.0) &
      call raise('E','Fortran and C kinds are incompatible!')
   if (c_int.eq.0 .or. c_int.ne.kind(n)) &
      call raise('E','Fortran and C kinds are incompatible!')
   if (c_double.eq.0 .or. c_double.ne.wp) &
      call raise('E','Fortran and C kinds are incompatible!')

!  copy the important dimensions
   nat = int(n,c_int)
   nao = int(wfn%nao,c_int)
!  and allocate some memory for the printout
!  geometry
   allocate( xyz(3,nat) ); xyz = real(coord,c_double)
   allocate( za(nat) );     za = real(z,c_double)
   allocate( xi(nat) );     xi = real(0.0_wp,c_double)
   allocate( am(nat) );     am = real(0.0_wp,c_double)
   allocate( at(nat) );     at = int(iat,c_int)
   allocate( frag(nat) ); frag = int(1,c_int)
   allocate( fix(3,nat) ); fix = int(0,c_int)
!  basis set
   allocate( BG(3,nat) )
   allocate( nshell(nat)); nshell = int(0,c_int)
!  wavefunction
   allocate( C(nao,nao) ); C = real(wfn%C,c_double)
   allocate( emo(nao) ); emo = real(wfn%emo,c_double)
   allocate( occ(nao) ); occ = real(wfn%focc,c_double)
   allocate( irrep(nao)); irrep = int(0,c_int)
   allocate( core(nao));  core  = int(0,c_int)

!  BFNGauss** is a ragged array of BFNGauss[iat][ishell]
!  but we don't use ragged pointer arrays, so we will fake is...
   do i = 1, nat
      ati = iat(i)
      nshell(i) = int(xtbData%nShell(ati),c_int)
      do ish = 1, xtbData%nShell(ati)
         ishtyp = xtbData%hamiltonian%angShell(ish,ati)
         icao = basis%caoshell(ish,ati)
         iao  = basis%saoshell(ish,ati)
         BG(ish,i)%lstart = int(iao,c_int)
         BG(ish,i)%l      = int(ishtyp,c_int)
         BG(ish,i)%ng     = int(basis%nprim(icao+1),c_int)
         do ip = 1, basis%nprim(icao+1)
            iprim = ip + basis%primcount(icao+1)
            BG(ish,i)%a(ip) = real(basis%alp(iprim),c_double)
            BG(ish,i)%d(ip) = real(basis%cont(iprim),c_double)
         enddo
      enddo
   enddo

!  the file pointer section are 5 words of long
   size_pointer = 5*8
!  the geometry section are one + 5*nat words of int and 6*nat words of double precision
   size_geometry = (1+5*n)*4 + (6*n)*8
!  the basis set section are one word of int, 5 words of bool, nat words of int
!  and nshell times 4 words of int and 64 words of double precision
   size_basisset = (1+n)*4 + 5 + (64*8 + 4*4)*wfn%nshell
!  wavefunction
   size_wavefunction = (1+1+wfn%nao+wfn%nao)*4 + (wfn%nao**2+wfn%nao+wfn%nao)*8

   inquire(file='orca.gbw',exist=exist)
   if (.not.exist) &
      call raise('E','Unfortunately, we need an template gbw-file write the info block, otherwise this is not working.')
   open(newunit=iunit,file='orca.gbw',form='unformatted',access='stream')
   read(iunit) istart
   read(iunit) ival
   iend = minval(ival)
   size_info = iend-istart
   print*,istart,ival,iend,size_info
   allocate( info(size_info) )
   read(iunit,pos=istart) info
   close(iunit)

   ptr_info = int(size_pointer,c_long)
   ptr_geometry = size_info + ptr_info
   ptr_wavefunction = ptr_geometry + int(size_geometry,c_long)
   ptr_basisset = ptr_wavefunction + int(size_wavefunction,c_long)

   total_size = size_pointer+size_geometry+size_basisset+size_wavefunction+size_info
   write(output_unit,'(/,"writing xtb.gbw (",i0,1x,"bytes)")') total_size
   write(output_unit,'("file pointer I at",1x,z16)') ptr_info
   write(output_unit,'("file pointer G at",1x,z16)') ptr_geometry
   write(output_unit,'("file pointer B at",1x,z16)') ptr_basisset
   write(output_unit,'("file pointer W at",1x,z16)') ptr_wavefunction

!  from here on this looks like ORCA printout, it behaves like ORCA printout,
!  but it is *not* ORCA printout (but ORCA will never get the difference).

   open(newunit=iunit,file='xtb.gbw',form='unformatted',access='stream')

!  write file pointer
   write(iunit) ptr_info          ! 1× int64
   write(iunit) ptr_geometry      ! 1× int64
   write(iunit) ptr_basisset      ! 1× int64
   write(iunit) ptr_wavefunction  ! 1× int64
   write(iunit) ptr_ecp           ! 1× int64
   !write(output_unit,'(z16,1x,z16)') ptr_info,ptr_geometry
   !write(output_unit,'(z16,1x,z16)') ptr_basisset,ptr_wavefunction
   !write(output_unit,'(z16)') ptr_ecp

   write(iunit) info

!  write geometry
   write(iunit) nat          ! 1×  int32
   !write(output_unit,'(z8)') nat
   do i = 1, nat
      !write(output_unit,'(z16,1x,z16,/,z16,1x,z16)') xyz(:,i),za(i)
      write(iunit) xyz(:,i)  ! 3× real64
      write(iunit) za(i)     ! 1× real64
      write(iunit) xi(i)     ! 1× real64
      write(iunit) am(i)     ! 1× real64
      write(iunit) at(i)     ! 1×  int32
      write(iunit) frag(i)   ! 1×  int32
      write(iunit) fix(:,i)  ! 3×  int32
   enddo

!  write wavefuntion
   write(iunit) nop          !  1× int32
   write(iunit) nao          !  1× int32
   write(iunit) C            !  nao*nao × real64
   write(iunit) occ          !  nao × real64
   write(iunit) emo          !  nao × real64
   write(iunit) irrep        !  nao ×  int32
   write(iunit) core         !  nao ×  int32

!  write basis set
   write(iunit) nat          ! 1× int32
   write(iunit) Have_STO     ! 1× bool
   write(iunit) Have_GTO     ! 1× bool
   write(iunit) Have_GTOAUX  ! 1× bool
   write(iunit) Have_GTOCABS ! 1× bool
   write(iunit) Have_Label   ! 1× bool

   write(iunit) nshell       ! nat × int32
   do i = 1, nat
      ishell = nshell(i)
      write(iunit) BG(1:ishell,i) ! ishell × (3× int32 + 64× real64)
   enddo

   close(iunit)

end subroutine wrgbw

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_gfn1
   use testdrive, only : new_unittest, unittest_type, error_type, check_ => check, test_failed
   implicit none
   private

   public :: collect_gfn1

contains

!> Collect all exported unit tests
subroutine collect_gfn1(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("scc", test_gfn1_scc), &
      new_unittest("api", test_gfn1_api), &
      new_unittest("gbsa", test_gfn1gbsa_api), &
      new_unittest("pcem", test_gfn1_pcem_api), &
      new_unittest("xb", test_gfn1_xb), &
      new_unittest("pbc3d", test_gfn1_pbc3d), &
      new_unittest("mindless-basic", test_gfn1_mindless_basic), &
      new_unittest("mindless-solvation", test_gfn1_mindless_solvation), &
      new_unittest("ipea-indole", test_ipea_indole), &
      new_unittest("mindless-cosmo", test_gfn1_mindless_cosmo) &
      ]

end subroutine collect_gfn1


subroutine test_gfn1_scc(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_environment
   use xtb_type_molecule
   use xtb_type_wavefunction
   use xtb_type_basisset
   use xtb_type_param
   use xtb_type_data
   use xtb_type_pcem
   use xtb_type_environment
   use xtb_type_solvation
   use xtb_solv_gbsa

   use xtb_setparam
   use xtb_basis
   use xtb_scf
   use xtb_scc_core
   use xtb_paramset
   use xtb_xtb_data
   use xtb_xtb_gfn1

   type(error_type), allocatable, intent(out) :: error
   real(wp),parameter :: thr = 1.0e-7_wp
   real(wp),parameter :: thr2 = 1.0e-5_wp
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      [ 0.00000000000000_wp,  0.00000000000000_wp, -0.73578586109551_wp, &
      & 1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp, &
      &-1.44183152868459_wp,  0.00000000000000_wp,  0.36789293054775_wp  &
      & ],shape(xyz))
   real(wp),parameter :: et = 300.0_wp
   integer, parameter :: maxiter = 50
   integer, parameter :: prlevel = 2
   logical, parameter :: lgrad = .true.
   logical, parameter :: restart = .false.
   real(wp),parameter :: acc = 1.0_wp

   type(TEnvironment) :: env
   type(TMolecule)     :: mol
   type(scc_results)     :: res
   type(TBasisset)     :: basis
   type(TWavefunction) :: wfn
   type(tb_pcem)         :: pcem
   type(TxTBData) :: xtbData
   class(TSolvation), allocatable :: solvation

   real(wp) :: etot,egap
   real(wp), allocatable :: g(:,:)

   type(TxTBParameter) :: globpar
   logical  :: okpar,okbas,diff,exitRun

   set%gfn_method = 1
   call init(env)

   call init(mol, at, xyz)

   wfn%nel = idint(sum(mol%z))
   wfn%nopen = 0

   allocate( g(3,mol%n), source = 0.0_wp )

   call use_parameterset('param_gfn1-xtb.txt',globpar,xtbData,okpar)
   call check_(error, okpar)

   call newBasisset(xtbData,mol%n,mol%at,basis,okbas)
   call check_(error, okbas)

   call check_(error, basis%nshell,6)
   call check_(error, basis%nbf,   8)
   call check_(error, basis%nao,   8)

   call wfn%allocate(mol%n,basis%nshell,basis%nao)
   wfn%q = mol%chrg/real(mol%n,wp)

   call iniqshell(xtbData,mol%n,mol%at,mol%z,basis%nshell,wfn%q,wfn%qsh,set%gfn_method)

   g = 0.0_wp

   call scf(env,mol,wfn,basis,pcem,xtbData,solvation, &
      &   egap,et,maxiter,prlevel,restart,lgrad,acc,etot,g,res)

   call env%check(exitRun)
   call check_(error, .not.exitRun)

   call check_(error, res%converged)

   call check_(error, res%e_total,-5.768694907835_wp, thr=thr)
   call check_(error, res%gnorm,   0.006990472552_wp, thr=thr*10)
   ! value in electron volt
   call check_(error, res%hl_gap,  9.314571212134_wp, thr=1.0e-4_wp)
   call check_(error, res%e_elec, -5.805476374506_wp, thr=thr)
   call check_(error, res%e_es,    0.050114150158_wp, thr=thr)
   call check_(error, res%e_disp, -0.000137581088_wp, thr=thr)
   call check_(error, res%e_rep,   0.036919047759_wp, thr=thr)

   call check_(error, wfn%q(2),0.33430923478162_wp, thr=thr2)
   call check_(error, wfn%q(3),wfn%q(2), thr=thr2)
   call check_(error, wfn%qsh(1),0.30697460552546_wp, thr=thr2)
   call check_(error, wfn%qsh(4),-0.31974031743775E-01_wp, thr=thr2)

   call check_(error, wfn%ihomo,4)
   call check_(error, wfn%ihomoa,wfn%ihomob)
   call check_(error, wfn%emo(wfn%ihomo),-13.612017816475_wp, thr=thr2)
   call check_(error, wfn%focca(wfn%ihomo),wfn%foccb(wfn%ihomo), thr=thr2)
   call check_(error, wfn%focc(wfn%ihomo),2.0_wp, thr=thr2)

   call mol%deallocate
   call wfn%deallocate
   call basis%deallocate

end subroutine test_gfn1_scc

subroutine test_gfn1_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_data
   use xtb_type_restart
   use xtb_type_environment

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-10_wp
   integer, parameter :: nat = 7
   integer, parameter :: at(nat) = [6,6,6,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00000000000000_wp, 0.00000000000000_wp, 0.00000000000000_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp,-2.45883087071663_wp, &
      & 0.00000000000000_wp, 0.00000000000000_wp, 2.45883087071663_wp, &
      &-1.23873299308709_wp,-1.23873299308709_wp,-3.52402313872811_wp, &
      & 1.23873299308709_wp, 1.23873299308709_wp,-3.52402313872811_wp, &
      &-1.23873299308709_wp, 1.23873299308709_wp, 3.52402313872811_wp, &
      & 1.23873299308709_wp,-1.23873299308709_wp, 3.52402313872811_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: wfn
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3, 3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=1)
   call newWavefunction(env, mol, calc, wfn)

   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 5.6067613073468_wp, thr=thr)
   call check_(error, energy,-8.4156335928615_wp, thr=thr)
   call check_(error, norm2(gradient),0.95790240549503E-02_wp, thr=thr)

   call check_(error, gradient(1,5), 0.18116310445596E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.00000000000000E+00_wp, thr=thr)
   call check_(error, gradient(1,4),-0.18116310445594E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.76256813454808E-03_wp, thr=thr)

end subroutine test_gfn1_api

subroutine test_gfn1gbsa_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_data
   use xtb_type_restart
   use xtb_type_environment
   use xtb_solv_input

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-7_wp
   integer, parameter :: nat = 8
   integer, parameter :: at(nat) = [7,7,9,1,1,1,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape(&
      &[0.00000000000000_wp, 1.30633555031959_wp, 0.00000000000000_wp,  &
      &-1.26402080275201_wp,-4.06871453465823_wp, 0.00000000000000_wp,  &
      & 1.42937939828404_wp, 3.57212474255400_wp, 0.00000000000000_wp,  &
      &-2.92500314615638_wp,-3.12058224200551_wp, 0.00000000000000_wp,  &
      & 0.71133449039308_wp, 0.35812010971703_wp, 1.51289962417918_wp,  &
      &-1.25697212427635_wp,-5.20406577474818_wp,-1.53711646457211_wp,  &
      & 0.71133449039308_wp, 0.35812010971703_wp,-1.51289962417918_wp,  &
      &-1.25697212427635_wp,-5.20406577474818_wp, 1.53711646457211_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true.,&
      &  solvent = 'ch2cl2' )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart):: wfn
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=1)
   call newWavefunction(env, mol, calc, wfn)
   call addSolvationModel(env, calc, TSolvInput(solvent=opt%solvent, alpb=.false., kernel=gbKernel%still))

   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 6.641641300724_wp, thr=1e-4_wp)
   call check_(error, energy,-14.215790820910_wp, thr=thr)
   call check_(error, norm2(gradient),0.14758139345468E-01_wp, thr=thr)
   call check_(error, gradient(2,3),0.1002863160985e-01_wp, thr=thr)
   call check_(error, gradient(3,5),-gradient(3,7), thr=thr)
   call check_(error, gradient(1,7),-0.6983782950712e-03_wp, thr=thr)
   call check_(error, gradient(3,8),0.9313074280892e-03_wp, thr=thr)

end subroutine test_gfn1gbsa_api

subroutine test_gfn1_pcem_api(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_data
   use xtb_type_restart
   use xtb_type_environment

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-9_wp
   integer, parameter :: nat = 12, nat2 = nat/2
   integer, parameter :: at(nat) = [8,1,1, 8,1,1, 8,1,1, 8,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape([&
      &-2.75237178376284_wp, 2.43247309226225_wp,-0.01392519847964_wp, &
      &-0.93157260886974_wp, 2.79621404458590_wp,-0.01863384029005_wp, &
      &-3.43820531288547_wp, 3.30583608421060_wp, 1.42134539425148_wp, &
      &-2.43247309226225_wp,-2.75237178376284_wp, 0.01392519847964_wp, &
      &-2.79621404458590_wp,-0.93157260886974_wp, 0.01863384029005_wp, &
      &-3.30583608421060_wp,-3.43820531288547_wp,-1.42134539425148_wp, &
      & 2.75237178376284_wp,-2.43247309226225_wp,-0.01392519847964_wp, &
      & 0.93157260886974_wp,-2.79621404458590_wp,-0.01863384029005_wp, &
      & 3.43820531288547_wp,-3.30583608421060_wp, 1.42134539425148_wp, &
      & 2.43247309226225_wp, 2.75237178376284_wp, 0.01392519847964_wp, &
      & 2.79621404458590_wp, 0.93157260886974_wp, 0.01863384029005_wp, &
      & 3.30583608421060_wp, 3.43820531288547_wp,-1.42134539425148_wp], shape(xyz))
   real(wp),parameter :: q(nat2) = [&
      &-0.69645733_wp,       0.36031084_wp,       0.33614649_wp, &
      &-0.69645733_wp,       0.36031084_wp,       0.33614649_wp]
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )
   real(wp),parameter :: gam(nat2) = [&
      & 0.583349_wp,0.470099_wp,0.470099_wp, 0.583349_wp,0.470099_wp,0.470099_wp]

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: wfn
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, method=1)
   call newWavefunction(env, mol, calc, wfn)

   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 9.0155275960407_wp, thr=thr*10)
   call check_(error, energy,-23.113490914998_wp, thr=thr)
   call check_(error, norm2(gradient),0.11143014174684E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.17083259496397E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.17083259496398E-02_wp, thr=thr)
   call check_(error, gradient(1,4), 0.27992413917387E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.10966149569550E-02_wp, thr=thr)

   ! reset
   call mol%deallocate
   energy = 0.0_wp
   gradient = 0.0_wp

   call init(mol, at(:nat2), xyz(:, :nat2))

   call newXTBCalculator(env, mol, calc, 'param_gfn1-xtb.txt', 1)

   call calc%pcem%allocate(nat2)
   calc%pcem%xyz = xyz(:,nat2+1:)
   ! gam from xtb_aoparam is now filled with GFN1-xTB hardnesses
   calc%pcem%gam = gam
   calc%pcem%q   = q
   calc%pcem%grd = 0.0_wp

   call newWavefunction(env, mol, calc, wfn)
   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 8.7253450652232_wp, thr=thr)
   call check_(error, energy,-11.559896105984_wp, thr=thr)
   call check_(error, norm2(gradient),0.24211484942219E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.16368872701817E-02_wp, thr=thr)
   call check_(error, gradient(2,2), 0.34511834874966E-02_wp, thr=thr)
   call check_(error, gradient(1,4),-0.27846344196073E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.12174494093948E-02_wp, thr=thr)

   call check_(error, norm2(calc%pcem%grd),0.12965281862178E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,5),-0.65532598920592E-03_wp, thr=thr)
   call check_(error, calc%pcem%grd(2,2), 0.17820246510446E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,4), 0.60888638785130E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(3,6), 0.86753094430381E-03_wp, thr=thr)

   ! reset
   energy = 0.0_wp
   gradient = 0.0_wp
   calc%pcem%grd = 0.0_wp
   calc%pcem%gam = 999.0_wp ! point charges

   call newWavefunction(env, mol, calc, wfn)
   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 8.9183046283326_wp, thr=thr)
   call check_(error, energy,-11.565012263827_wp, thr=thr)
   call check_(error, norm2(gradient),0.23134284179991E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.63000570838230E-03_wp, thr=thr)
   call check_(error, gradient(2,2), 0.28673054867063E-02_wp, thr=thr)
   call check_(error, gradient(1,4),-0.75488974649673E-02_wp, thr=thr)
   call check_(error, gradient(3,6),-0.12128428341685E-02_wp, thr=thr)

   call check_(error, norm2(calc%pcem%grd),0.18251544072073E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,5),-0.16079631752423E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(2,2), 0.23749979339001E-02_wp, thr=thr)
   call check_(error, calc%pcem%grd(1,4), 0.10140193991067E-01_wp, thr=thr)
   call check_(error, calc%pcem%grd(3,6), 0.11833638475792E-02_wp, thr=thr)

end subroutine test_gfn1_pcem_api

subroutine test_gfn1_xb(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_data
   use xtb_type_restart
   use xtb_type_environment

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-9_wp
   integer, parameter :: nat = 6
   integer, parameter :: at(nat) = [35,35,8,6,1,1]
   real(wp),parameter :: xyz(3,nat) = reshape([&
      &-1.785333747_wp,    -3.126082999_wp,     0.000000000_wp, &
      & 0.000000000_wp,     0.816042264_wp,     0.000000000_wp, &
      & 2.658286999_wp,     5.297075806_wp,     0.000000000_wp, &
      & 4.885971586_wp,     4.861161373_wp,     0.000000000_wp, &
      & 5.615509753_wp,     2.908222159_wp,     0.000000000_wp, &
      & 6.289076126_wp,     6.399636435_wp,     0.000000000_wp], shape(xyz))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(TRestart) :: wfn
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp),allocatable :: gradient(:,:)

   ! setup the environment variables
   call init(env)

   call init(mol, at, xyz)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp

   call newXTBCalculator(env, mol, calc, 'param_gfn1-xtb.txt', 1)
   call newWavefunction(env, mol, calc, wfn)

   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 2.4991941159068_wp, thr=thr)
   call check_(error, energy,-15.606233877972_wp, thr=thr)
   call check_(error, norm2(gradient),0.23014320345408E-01_wp, thr=thr)

   call check_(error, gradient(1,5),-0.39000047348209E-02_wp, thr=thr)
   call check_(error, gradient(2,2),-0.49294645520340E-02_wp, thr=thr)
   call check_(error, gradient(1,4), 0.17228152301357E-01_wp, thr=thr)
   call check_(error, gradient(3,6), 0.00000000000000E+00_wp, thr=thr)

end subroutine test_gfn1_xb


subroutine test_gfn1_pbc3d(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout

   use xtb_mctc_convert
   use xtb_type_options
   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data
   use xtb_type_environment
   use xtb_type_restart

   use xtb_pbc_tools

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp),parameter :: thr = 1.0e-9_wp
   ! CaF2
   integer, parameter :: nat = 3
   integer, parameter :: at(nat) = [9,9,20]
   real(wp),parameter :: abc(3,nat) = reshape(&
      &[0.25_wp, 0.25_wp, 0.25_wp, &
      & 0.75_wp, 0.75_wp, 0.75_wp, &
      & 0.00_wp, 0.00_wp, 0.00_wp], shape(abc))
   real(wp),parameter :: lattice(3,3) = reshape(&
      &[5.9598811567890_wp,      2.1071361905157_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      6.3214085715472_wp,      3.6496669404404_wp,    &
      & 0.0000000000000_wp,      0.0000000000000_wp,      7.2993338808807_wp],   &
      & shape(lattice))
   type(scc_options),parameter :: opt = scc_options( &
      &  prlevel = 2, maxiter = 30, acc = 1.0_wp, etemp = 300.0_wp, grad = .true. )

   type(TMolecule)    :: mol
   type(TEnvironment) :: env
   type(tb_pcem)      :: pcem
   type(TRestart) :: wfn
   type(scc_results) :: res
   type(TxTBCalculator) :: calc

   real(wp) :: energy, sigma(3,3)
   real(wp) :: hl_gap
   real(wp) :: gradlatt(3,3)
   real(wp) :: stress(3,3)
   real(wp),allocatable :: gradient(:,:)
   real(wp),allocatable :: xyz(:,:)

   ! setup the environment variables
   call init(env)

   allocate(xyz(3, nat))
   call coord_trafo(nat,lattice,abc,xyz)
   call init(mol, at, xyz, lattice=lattice)

   allocate(gradient(3,mol%n))
   energy = 0.0_wp
   gradient = 0.0_wp
   gradlatt = 0.0_wp

   call mctc_mute

   call newXTBCalculator(env, mol, calc, 'param_gfn1-xtb.txt', 1)
   call newWavefunction(env, mol, calc, wfn)

   call calc%singlepoint(env, mol, wfn, 2, .false., energy, gradient, sigma, &
      & hl_gap, res)

   call check_(error, hl_gap, 7.5302549612743_wp, thr=thr)
   call check_(error, energy,-11.069452578476_wp, thr=thr)
   call check_(error, norm2(gradient), 0.28766497266274E-01_wp, thr=thr)

   call check_(error, gradient(1,1),-0.18972454825631E-03_wp, thr=thr)
   call check_(error, gradient(1,2),-0.66834750631031E-02_wp, thr=thr)
   call check_(error, gradient(1,3), 0.68731996113594E-02_wp, thr=thr)
   call check_(error, gradient(2,1),-0.26831102888425E-03_wp, thr=thr)
   call check_(error, gradient(3,3), 0.16835831947879E-01_wp, thr=thr)

end subroutine test_gfn1_pbc3d


subroutine test_gfn1_mindless_basic(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   real(wp), parameter :: ref_energies(10) = &
      &[-33.040345103560_wp, -26.858637887392_wp, -25.818131312372_wp, &
      & -24.896623131166_wp, -29.038403257541_wp, -20.596982571512_wp, &
      & -35.754243805311_wp, -33.088749099589_wp, -21.414820157390_wp, &
      & -26.650774557476_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.049510354228196_wp, 0.062164738458454_wp, 0.050970505747783_wp, &
      & 0.089329244570940_wp, 0.049188889391502_wp, 0.059353809155596_wp, &
      & 0.063932193893054_wp, 0.059154356097925_wp, 0.043307936447560_wp, &
      & 0.043009212776427_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[3.4192962150687_wp, 1.6702597448498_wp, 2.4899572196060_wp, &
      & 1.6706491472352_wp, 2.4613273978074_wp, 3.9778768185046_wp, &
      & 2.5370236462819_wp, 1.3590769445407_wp, 4.0816020166740_wp, &
      & 1.3640382002752_wp]

   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn1-xtb.txt', 1)
      call newWavefunction(env, mol, calc, chk)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn1_mindless_basic


subroutine test_gfn1_mindless_solvation(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   character(len=*), parameter :: solvents(10) = [character(len=20) ::&
      & "h2o", "chcl3", "thf", "acetonitrile", "toluene", &
      & "ch2cl2", "ether", "methanol", "cs2", "dmso"]
   real(wp), parameter :: ref_energies(10) = &
      &[-33.075972501756_wp, -26.890550325491_wp, -25.875403448921_wp, &
      & -24.905567384699_wp, -29.056610710932_wp, -20.626564707704_wp, &
      & -35.787363117115_wp, -33.103345507512_wp, -21.425126566837_wp, &
      & -26.683086381488_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.058132809354921_wp, 0.061771913881691_wp, 0.056320324680277_wp, &
      & 0.094108546452594_wp, 0.049107097494380_wp, 0.056792563143050_wp, &
      & 0.063361086949237_wp, 0.059227312312587_wp, 0.041889795619126_wp, &
      & 0.045018190836542_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[3.5484557435287_wp, 1.6696997912942_wp, 2.5331364339285_wp, &
      & 1.6610531980301_wp, 2.3956600668633_wp, 3.7354634449786_wp, &
      & 2.6533136247624_wp, 1.3546253158640_wp, 4.0956047417239_wp, &
      & 1.3095666818230_wp]


   call init(env)
   do iMol = 1, 10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn1-xtb.txt', 1)
      call newWavefunction(env, mol, calc, chk)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & alpb=mod(iMol, 2)==0, kernel=gbKernel%still))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn1_mindless_solvation


subroutine test_ipea_indole(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule
   use xtb_mctc_systools, only : rdpath

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput
   use xtb_solv_kernel, only : gbKernel

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   integer, parameter :: nat = 15
   character(len=*), parameter :: sym(nat) = [character(len=4)::&
      & "C", "C", "C", "C", "C", "C", "H", "H", "H", "H", "C", "C", "N", "H", &
      & "H"]
   real(wp), parameter :: xyz(3, nat) = reshape([&
      & -5.35892196512242_wp,  1.73312414112064_wp, -0.57717892384120_wp, &
      & -7.65881264141790_wp,  0.49826397815934_wp, -0.98802419062021_wp, &
      & -3.18596416481952_wp,  0.23723616573036_wp, -0.37947581998019_wp, &
      & -3.24547162745174_wp, -2.39135340069686_wp, -0.57504353378802_wp, &
      & -5.58372373567590_wp, -3.59229298714979_wp, -0.98874228639030_wp, &
      & -7.77510636165883_wp, -2.12452413033580_wp, -1.19171772498436_wp, &
      & -9.38333853055452_wp,  1.60452830650258_wp, -1.15099413591722_wp, &
      & -5.68917043033699_wp, -5.63501089146626_wp, -1.14933117729174_wp, &
      & -9.58383842846746_wp, -3.04470716793929_wp, -1.51155380153258_wp, &
      & -5.27586852013397_wp,  3.77546410029495_wp, -0.41965138859121_wp, &
      & -0.72015557111823_wp, -3.26425550101682_wp, -0.28287304164551_wp, &
      &  0.80122480411036_wp, -1.18587847253807_wp,  0.07759213768431_wp, &
      & -0.70611490908719_wp,  0.91783977772213_wp,  0.01598707951313_wp, &
      & -0.09943736690084_wp,  2.71570592169382_wp,  0.22824107134708_wp, &
      & -0.09051786154600_wp, -5.20876436014445_wp, -0.33266731412436_wp],&
      & shape(xyz))
   real(wp), parameter :: charge = -1.0_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun, exist
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)
   character(len=:), allocatable :: paramfile

   call init(env)
   call init(mol, sym, xyz, chrg=charge)

   allocate(gradient(3, len(mol)))

   call rdpath(env%xtbpath, 'param_ipea-xtb.txt', paramfile, exist)
   if (.not.exist) paramfile = 'param_ipea-xtb.txt'

   call newXTBCalculator(env, mol, calc, paramfile, 1)
   call env%check(exitRun)
   call check_(error, .not.exitRun)
   if (.not.exitRun) then

      call newWavefunction(env, mol, calc, chk)

   end if

   call env%check(exitRun)
   call check_(error, .not.exitRun)
   if (.not.exitRun) then

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

   end if

   call env%check(exitRun)
   call check_(error, .not.exitRun)
   if (.not.exitRun) then

      call check_(error, energy, -26.590861716652_wp, thr=thr)
      call check_(error, norm2(gradient), 0.84641833840045E-01_wp, thr=thr)
      call check_(error, hl_gap, 2.5955961749533_wp, thr=thr)

   end if

end subroutine test_ipea_indole


subroutine test_gfn1_mindless_cosmo(error)
   use xtb_mctc_accuracy, only : wp
   use xtb_test_molstock, only : getMolecule

   use xtb_type_molecule
   use xtb_type_param
   use xtb_type_pcem
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment, init
   use xtb_type_restart, only : TRestart

   use xtb_xtb_calculator, only : TxTBCalculator, newXTBCalculator, newWavefunction
   use xtb_main_setup, only : addSolvationModel
   use xtb_solv_input, only : TSolvInput

   type(error_type), allocatable, intent(out) :: error

   real(wp), parameter :: thr = 1.0e-8_wp

   type(TEnvironment) :: env
   type(TMolecule) :: mol
   type(TRestart) :: chk
   type(TxTBCalculator) :: calc
   type(scc_results) :: res

   integer :: iMol
   logical :: exitRun
   real(wp) :: energy, hl_gap, sigma(3, 3)
   real(wp), allocatable :: gradient(:, :)

   character(len=*), parameter :: mindless(10) = [&
      & "mindless01", "mindless02", "mindless03", "mindless04", "mindless05", &
      & "mindless06", "mindless07", "mindless08", "mindless09", "mindless10"]
   character(len=*), parameter :: solvents(10) = [character(len=20) ::&
      & "h2o", "chcl3", "thf", "acetonitrile", "toluene", &
      & "ch2cl2", "ether", "methanol", "cs2", "dmso"]
   real(wp), parameter :: ref_energies(10) = &
      &[-33.086826283006_wp,-26.892421337119_wp,-25.862366080135_wp, &
      & -24.929812068243_wp,-29.068535381601_wp,-20.631250827831_wp, &
      & -35.780608195840_wp,-33.119209493948_wp,-21.444833411574_wp, &
      & -26.674508354162_wp]
   real(wp), parameter :: ref_gnorms(10) = &
      &[0.056910263744_wp, 0.059732400683_wp, 0.052197041661_wp, &
      & 0.097844384419_wp, 0.047961348424_wp, 0.057230114090_wp, &
      & 0.060889237549_wp, 0.068600226343_wp, 0.042102755940_wp, &
      & 0.042610278777_wp]
   real(wp), parameter :: ref_hlgaps(10) = &
      &[3.560961680882_wp, 1.701178515210_wp, 2.575575698307_wp, &
      & 1.642444939544_wp, 2.389954524574_wp, 3.624912973388_wp, &
      & 2.770751688023_wp, 1.357191094207_wp, 4.102623151933_wp, &
      & 1.391461153653_wp]

   call init(env)
   do iMol = 1,10

      call getMolecule(mol, mindless(iMol))

      if (allocated(gradient)) deallocate(gradient)
      allocate(gradient(3, len(mol)))

      call newXTBCalculator(env, mol, calc, 'param_gfn1-xtb.txt', 1)
      call newWavefunction(env, mol, calc, chk)
      call addSolvationModel(env, calc, TSolvInput(solvent=trim(solvents(iMol)), &
         & cosmo=.true., nang=170))

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call calc%singlepoint(env, mol, chk, 2, .false., energy, gradient, sigma, &
         & hl_gap, res)

      call env%check(exitRun)
      call check_(error, .not.exitRun)
      if (exitRun) exit

      call check_(error, energy, ref_energies(iMol), thr=thr)
      call check_(error, norm2(gradient), ref_gnorms(iMol), thr=thr)
      call check_(error, hl_gap, ref_hlgaps(iMol), thr=thr)

   end do

end subroutine test_gfn1_mindless_cosmo

end module test_gfn1

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine mrec(molcount,xyz,cn,bond,nat,at,molvec)
   ! molcount: number of total fragments (increased during search)
   ! xyz: overall Cart. coordinates
   ! nat: overall number of atoms
   ! at: atomic number array
   ! molvec: assignment vector of atom to fragment

   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp),intent(in)    :: xyz(3,nat),cn(nat)
   integer, intent(in)    :: nat,at(nat)
   integer, intent(inout) :: molvec(nat),molcount
   real(wp),intent(in)    :: bond(nat,nat)
   logical, allocatable   :: taken(:)
   integer :: i
   allocate( taken(nat) )
   molvec=0
   molcount=1
   taken=.false.
   do i=1,nat
      if(.not.taken(i)) then
         molvec(i)=molcount
         taken(i)=.true.
         call neighbours(i,xyz,cn,at,taken,nat,bond,molvec,molcount)
         molcount=molcount+1
      endif
   enddo
   molcount=molcount-1
end subroutine mrec

recursive subroutine neighbours(i,xyz,cn,iat,taken,nat,bond,&
      &                                molvec,molcnt)
   use xtb_mctc_accuracy, only : wp
   implicit none
   real(wp) xyz(3,nat),cn(nat)
   real(wp)  bond(nat,nat)
   integer i,nat, molcnt,molvec(nat),j,iat(nat),icn,k
   logical taken(nat)

   icn=nint(cn(i))
   do k=1,icn
      j=maxloc(bond(:,i),1)
      bond(j,i)=0
      if (i .eq. j) cycle
      if (.not.taken(j)) then
         molvec(j)=molcnt
         taken(j)=.true.
         call neighbours(j,xyz,cn,iat,taken,nat,bond,molvec,molcnt)
      endif
   enddo
end subroutine neighbours

!CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

subroutine cutcov(n,at,xyz,cn,wb,bond)
   use xtb_mctc_accuracy, only : wp
   implicit none
   integer i,n,j,at(n),k,nb(20,n),iring,c(8,n),s(n)
   real(wp) bond(n,n)
   real(wp) wb(n,n),cn(n),xyz(3,n)
   logical samering

   bond = 0

   call neighborh(n,at,xyz,nb)
   do i=1,n
      call getring(n,nb,i,c(1,i),s(i))
   enddo

   do i=1,n
      do j=1,n
         if(wb(j,i).lt.0.5)  cycle
         if(wb(j,i).gt.1.3)               bond(j,i)=1
         if(cn(i).lt.1.2.or.cn(j).lt.1.2) bond(j,i)=1
         if(samering(n,i,j,c,s))          bond(j,i)=1
      enddo
   enddo

end subroutine cutcov

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

module xtb_tblite_mapping
   
   use xtb_type_environment, only: TEnvironment
   use xtb_type_restart, only: TRestart
   use xtb_type_data, only: scc_results
   use xtb_type_molecule, only: TMolecule
   use xtb_mctc_accuracy, only: wp   
   use mctc_io_convert, only: autoev
   use xtb_type_wavefunction, only: TWavefunction

#if WITH_TBLITE
   use tblite_basis_type, only: basis_type
#endif
   implicit none
   private
   public :: convert_tblite_to_results

#if WITH_TBLITE
   public :: convert_tblite_to_wfn
   interface assignment(=)
      module procedure :: from_tblite_wfn
      module procedure :: from_tblite_basis
      module procedure :: from_struc
   end interface assignment(=)
#endif
contains

#if WITH_TBLITE
!> convert tblite wavefunction to xtb wavefunction
subroutine convert_tblite_to_wfn(env, bas, mol, chk, wbo)

   !> computational environment
   type(TEnvironment), intent(inout) :: env

   !> basis set
   type(basis_type), intent(in) :: bas
   
   !> molecular structure
   type(TMolecule), intent(in) :: mol

   !> restart data
   type(TRestart), intent(inout) :: chk

   !> wiberg bond orders
   real(wp), optional, intent(in) :: wbo(:,:,:)

   call chk%wfn%allocate(mol%n, bas%nsh, bas%nao)

   ! assignment interfaces !
   chk%wfn = chk%tblite
   chk%wfn = bas
   chk%wfn = mol
   
   if (present(wbo)) chk%wfn%wbo = wbo(:,:,1) ! only 

end subroutine convert_tblite_to_wfn
#endif

!> convert tblite results to xtb results
subroutine convert_tblite_to_results(results, mol, chk, energy, converged, gradient) 

   !> scc results
   type(scc_results), intent(inout) :: results

   !> molecular structure
   type(TMolecule), intent(in) :: mol

   !> restart data
   type(TRestart), intent(in) :: chk

   !> SCC energy
   real(wp), intent(in) :: energy

   !> convergence flag
   logical, intent(in) :: converged

   !> (analytical) gradients
   real(wp), optional, intent(in) :: gradient(:,:)

   
   results%e_total = energy
   results%converged = converged

#if WITH_TBLITE
   
   ! do not overwrite dipole moments, if calculated (PTB case) ! 
   if (all(results%dipole == 0.0_wp)) then
      results%dipole = sum(chk%tblite%dpat(:, :, 1), 2) + matmul(mol%xyz, chk%tblite%qat(: ,1))
   endif
   results%hl_gap = (chk%tblite%emo(chk%tblite%homo(1) + 1, 1) - chk%tblite%emo(chk%tblite%homo(1), 1)) * autoev

#endif

   if (present(gradient)) results%gnorm = norm2(gradient)

end subroutine convert_tblite_to_results


#if WITH_TBLITE

subroutine from_tblite_wfn(wfn, tblite)

   use tblite_wavefunction, only : wavefunction_type
   
   type(TWavefunction), intent(inout) :: wfn 
   type(wavefunction_type), intent(in) :: tblite

   wfn%dipm = tblite%dpat(:, :, 1)
   wfn%nel = nint(tblite%nocc)
   wfn%P = tblite%density(:, :, 1)
   wfn%q = tblite%qat(:, 1)
   wfn%qsh = tblite%qsh(:, 1)
   wfn%focca = tblite%focc(:, 1)
   wfn%foccb = 0.0_wp
   wfn%focc(:) = tblite%focc(:, 1)
   wfn%emo = tblite%emo(:, 1) * autoev
   wfn%C = tblite%coeff(:, :, 1)
   wfn%ihomo = tblite%homo(1)
   wfn%ihomoa = tblite%homo(1)
   wfn%ihomob = tblite%homo(2)
   wfn%qp = tblite%qpat(:, :, 1)

end subroutine from_tblite_wfn

subroutine from_tblite_basis(wfn, bas)

   use tblite_basis_type, only: basis_type
   
   type(TWavefunction), intent(inout) :: wfn
   type(basis_type), intent(in) :: bas
   
   wfn%nshell = bas%nsh
   wfn%nao = bas%nao

end subroutine from_tblite_basis

subroutine from_struc(wfn, mol)

   type(TWavefunction), intent(inout) :: wfn
   type(TMolecule), intent(in) :: mol

   wfn%n = mol%n
   wfn%nopen = mol%uhf

end subroutine from_struc
#endif

#if ! WITH_TBLITE
subroutine feature_not_implemented(env)
   !> Computational environment
   type(TEnvironment), intent(inout) :: env

   call env%error("Compiled without support for tblite library")
end subroutine feature_not_implemented
#endif

end module xtb_tblite_mapping

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifdef __GNUC__
#if GCC_VERSION < 70500
#define HAS_GCC_BUG_84412
#endif
#endif

!> Wrapper to read from Fortran units
module xtb_type_reader
   implicit none
   private

   public :: TReader


   !> Wrapper for reading from Fortran units
   type :: TReader

      !> Connected unit
      integer :: unit = -1

   contains

      !> Connect reader
      generic :: open => openUnit, openFile

      !> Connect reader to unit
      procedure, private :: openUnit

      !> Connect reader to file
      procedure, private :: openFile

      !> Read from unit
      generic :: read => readLine, readInteger

      !> Read entire record from line
      procedure, private :: readLine

      !> Read an integer from a record
      procedure, private :: readInteger

      !> Close unit in reader
      generic :: close => closeUnit

      !> Close connected unit
      ! Should be private, but must be declared as public due to PGI bug #28452
      procedure :: closeUnit

   end type TReader


contains


!> Connect reader to unit
subroutine openUnit(self, unit)

   !> Instance of reader
   class(TReader), intent(inout) :: self

   !> IO unit connect to
   integer, intent(in) :: unit

#ifdef HAS_GCC_BUG_84412
   self%unit = unit
#else
   logical :: opened

   inquire(opened=opened, unit=unit)
   if (opened) then
      self%unit = unit
   end if
#endif

end subroutine openUnit


!> Connect reader to unit
subroutine openFile(self, file)

   !> Instance of reader
   class(TReader), intent(inout) :: self

   !> IO unit connect t
   character(len=*), intent(in) :: file

   logical :: exist

   inquire(exist=exist, file=file)
   if (exist) then
      open(file=file, newunit=self%unit, status='old')
   end if

end subroutine openFile


!> Read from unit
subroutine readLine(self, line, iostat)

   !> Instance of reader
   class(TReader), intent(inout) :: self

   !> Character buffer to read into
   character(len=:), allocatable, intent(out) :: line

   !> Status of read
   integer, intent(out) :: iostat

   integer, parameter :: bufferSize = 512
   character(len=bufferSize) :: buffer
   integer :: size

   line = ''
   do
      read(self%unit, '(a)', advance='no', iostat=iostat, size=size) buffer
      if (iostat > 0) then
         exit
      end if
      line = line // buffer(:size)
      if (iostat < 0) then
         if (is_iostat_eor(iostat)) then
            iostat = 0
         end if
         exit
      end if
   end do

end subroutine readLine


subroutine readInteger(self, val, iostat)

   !> Instance of reader
   class(TReader), intent(inout) :: self

   !> Value of integer read
   integer, intent(out) :: val

   !> Status of read
   integer, intent(out) :: iostat

   read(self%unit, *, iostat=iostat) val

end subroutine readInteger


!> Close unit in reader
subroutine closeUnit(self)

   !> Instance of reader
   class(TReader), intent(inout) :: self

#ifdef HAS_GCC_BUG_84412
   close(self%unit)
#else
   logical :: opened

   inquire(opened=opened, unit=self%unit)
   if (opened) then
      close(self%unit)
   end if
#endif

end subroutine closeUnit


end module xtb_type_reader

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine eval_define(verbose)
   use, intrinsic :: iso_fortran_env, only : id => output_unit
   use xtb_mctc_global, only : msgid, name
   implicit none
   logical,intent(in) :: verbose
   integer :: save_i
   if (verbose) then
      name = 'define'
      call definebanner
   endif
   save_i = msgid
   call raise('F','Your input has following faults:')
   call terminate(save_i)
end subroutine eval_define

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_type_topology
   implicit none
   public :: TTopology
   public :: len, size, assignment(=)
   private


   type :: TTopology
      !private
      integer :: order = 2
      integer :: length = 0
      integer, allocatable :: list(:,:)
   contains
      generic :: allocate => new_default, new_from_list
      procedure, private :: new_default => top_new_default
      procedure, private :: new_from_list => top_new_from_list
      procedure, pass(self) :: to_list => list_assign_top
      procedure :: push_back => top_push_back
      procedure :: set_item => top_set_item
      procedure :: get_item => top_get_item
      procedure :: resize => top_resize
      procedure :: deallocate => top_destroy
   end type TTopology


   interface len
      module procedure :: top_length
   end interface len

   interface size
      module procedure :: top_size
   end interface size

   interface assignment(=)
      module procedure :: top_new_from_list
      module procedure :: list_assign_top
   end interface assignment(=)


contains


subroutine top_new_default(self, order, size)
   class(TTopology), intent(out) :: self
   integer, intent(in), optional :: order
   integer, intent(in), optional :: size
   if (present(order)) self%order = order
   if (present(size)) call self%resize(size)
end subroutine top_new_default

subroutine top_new_from_list(self, list)
   class(TTopology), intent(out) :: self
   integer, intent(in) :: list(:,:)
   self%order = size(list, 1)
   call self%resize(size(list, 2))
   self%list = list
end subroutine top_new_from_list

subroutine list_assign_top(list, self)
   class(TTopology), intent(in) :: self
   integer, allocatable, intent(out) :: list(:,:)
   list = self%list(:,:len(self))
end subroutine list_assign_top


integer pure elemental function top_length(self) result(length)
   class(TTopology), intent(in) :: self
   if (allocated(self%list)) then
      length = self%length
   else
      length = 0
   endif
end function top_length

integer pure elemental function top_size(self) result(length)
   class(TTopology), intent(in) :: self
   if (allocated(self%list)) then
      length = size(self%list, 2)
   else
      length = 0
   endif
end function top_size


subroutine top_get_item(self, at, item)
   class(TTopology), intent(in) :: self
   integer, intent(in) :: at
   integer, intent(out) :: item(:)
   if (at > len(self)) item = 0
   item = self%list(:, at)
end subroutine top_get_item

subroutine top_set_item(self, at, item)
   class(TTopology), intent(inout) :: self
   integer, intent(in) :: at
   integer, intent(in) :: item(:)
   if (at > len(self)) call self%resize(at)
   self%list(:, at) = item
end subroutine top_set_item


subroutine top_push_back(self, item)
   class(TTopology), intent(inout) :: self
   integer, intent(in) :: item(:)
   integer :: pos, last, length

   last = len(self)
   if (last >= size(self)) call self%resize

   self%length = last+1
   self%list(:,last+1) = item
end subroutine top_push_back

subroutine top_resize(self, n)
   class(TTopology), intent(inout) :: self
   integer, intent(in), optional :: n
   integer, allocatable :: list(:,:)
   integer :: length, current_length
   current_length = size(self)
   if (current_length > 0) then
      if (present(n)) then
         if (n <= current_length) return
         length = n
      else
         length = current_length + current_length/2 + 1
      endif
      allocate(list(self%order, length), source=0)
      list(:, :current_length) = self%list(:, :current_length)
      deallocate(self%list)
      call move_alloc(list, self%list)
   else
      if (present(n)) then
         length = n
      else
         length = 64
      endif
      allocate(self%list(self%order, length), source=0)
   endif
end subroutine top_resize

subroutine top_destroy(self)
   class(TTopology), intent(inout) :: self
   if (allocated(self%list)) deallocate(self%list)
end subroutine top_destroy

end module xtb_type_topology

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_constrainpot
contains

subroutine constrain_zaxis(fix,n,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   type(fix_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: e
   real(wp),intent(inout) :: g(3,n)

   integer  :: i,ii
   real(wp) :: z0,dz

   if (fix%n.eq.0) return

   do i = 1, fix%n
      ii = fix%atoms(i)
      z0 = fix%val(i)
      dz = xyz(3,ii) - z0
      e  = e + fix%fc*dz**2
      g(3,ii) = g(3,ii) + 2.0d0*fix%fc*dz
   enddo

end subroutine constrain_zaxis

subroutine constrain_pos(fix,n,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   type(fix_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: e
   real(wp),intent(inout) :: g(3,n)

   integer  :: i,j,ii,jj,k
   real(wp) :: r,rij(3),tmp,d

   if (fix%n.eq.0) return

   k = 0
   do i = 1, fix%n
      ii = fix%atoms(i)
      do j = 1, i-1
         jj = fix%atoms(j)
         k = k+1
         rij = xyz(:,jj) - xyz(:,ii)
         r = norm2(rij)
         d = r - fix%val(k)
         e = e + fix%fc * d**2
         tmp = fix%fc * 2.0_wp * d
         g(:,jj) = g(:,jj) + tmp*rij/r
         g(:,ii) = g(:,ii) - tmp*rij/r
      enddo
   enddo
contains
pure elemental integer function lin(i1,i2)
   integer,intent(in) :: i1,i2
   integer :: idum1,idum2
   idum1=max(i1,i2)
   idum2=min(i1,i2)
   lin=idum2+idum1*(idum1-1)/2
end function lin

end subroutine constrain_pos

subroutine qpothess2(fix,n,at,xyz,h)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   type(fix_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: h(n*3*(n*3+1)/2)

   real(wp) :: rij(3),dr,r0
   real(wp) :: t1,t0,w0,w1,dx,dx2,dy,dy2,r,r2,r3
   integer  :: i,j,k,l,m,ii,jj,iik,iikl,ikjm,ijk,ij

   if(fix%n.eq.0) return

   ! calculate hessian
   do i = 1, fix%n !loop over all atoms
      ii = (fix%atoms(i)-1)*3
      do k = 1, 3  !loop diagonal elements (xyz components)
         do j = 1, fix%n !inner loop for sum over all atoms
            if (i.ne.j) then
               rij = xyz(:,fix%atoms(j))-xyz(:,fix%atoms(i))
               r  = norm2(rij)
               r2 = r*r
               r3 = r2*r
               ij = lin(i-1,j-1)+1
               r0 = fix%val(ij)
               dr = r-r0
               dx = xyz(k,fix%atoms(i))-xyz(k,fix%atoms(j))
               dx2 = dx*dx
               iik = lin(ii+k,ii+k)
               h(iik) = h(iik) + 2.0_wp*fix%fc*(1.0_wp+(dx2/r2)-(dx2*dr/r3)-(r0/r))
               do l = k+1, 3 !loop same-atom block-diagonal elements
                  dy = xyz(l,fix%atoms(i))-xyz(l,fix%atoms(j))
                  iikl = lin(ii+k,ii+l)
                  h(iikl) = h(iikl) + 2.0_wp*fix%fc*r0*dx*dy/r3
               enddo !end loop same-atom block-diagonal elements
            endif
         enddo !end inner loop for sum over all atoms
         do j = i+1, fix%n !loop over the rest (mixed atoms)
            rij = xyz(:,fix%atoms(j))-xyz(:,fix%atoms(i))
            r  = norm2(rij)
            r2 = r*r
            r3 = r2*r
            ij = lin(i-1,j-1)+1
            r0 = fix%val(ij)
            dr = r-r0
            jj = (fix%atoms(j)-1)*3
            do m = 1, 3
               if (k.eq.m) then !same component case
                  dx = xyz(k,fix%atoms(i))-xyz(k,fix%atoms(j))
                  dx2 = dx*dx
                  ijk = lin(ii+k,jj+k)
                  h(ijk) = h(ijk) - 2.0_wp*fix%fc*(1.0_wp+dx2/r2-dx2*dr/r3-r0/r)
               else !different component case
                  dx = xyz(k,fix%atoms(i))-xyz(k,fix%atoms(j))
                  dy = xyz(m,fix%atoms(i))-xyz(m,fix%atoms(j))
                  ikjm = lin(ii+k,jj+m)
                  h(ikjm) = h(ikjm) - 2.0_wp*fix%fc*r0*dx*dy/r3
               endif
            enddo
         enddo
      enddo !end loop diagonal elements (xyz components)
   enddo !end loop atoms

contains
pure elemental integer function lin(i1,i2)
   integer,intent(in) :: i1,i2
   integer :: idum1,idum2
   idum1=max(i1,i2)
   idum2=min(i1,i2)
   lin=idum2+idum1*(idum1-1)/2
end function lin

end subroutine qpothess2

subroutine constrain_dist(fix,n,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   type(fix_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: e
   real(wp),intent(inout) :: g(3,n)

   integer i,j,k,l,m,mm
   real(wp)rij(3),dum,r0,r,vp(3),ra(3),rb(3)
   real(wp)va(3),vb(3),vc(3),vab(3),vcb(3),deda(3),dedc(3),dedb(3)
   real(wp)dda(3),ddb(3),ddc(3),ddd(3)
   real(wp)c0,rab2,rcb2,theta,dt,rmul1,rmul2,deddt,rp,cosa,ea,vlen,d
   real(wp)c1,phi0,phi,dphi1,x1cos,x1sin,dij,valijkl,ff,dum1,dum2
   real(wp)dx,dy,dz,termx,termy,termz,abcx,abcy,abcz,a,z0,expo,expom1

   if(fix%n.eq.0) return

   do m = 1, fix%n
      mm = 2*m-1
      i = fix%atoms(mm)
      j = fix%atoms(mm+1)
      r0= fix%val(m)
      rij=xyz(:,j)-xyz(:,i)
      r = norm2(rij)
      d=r-r0
!     e=e+fix%fc*d*d
!     ff=fix%fc*2.0d0*d
      dum= d**fix%expo(m)
      dum2=d**(fix%expo(m)-1.0_wp)
      e=e+fix%fc*dum
      ff=fix%fc*fix%expo(m)*dum2
      dum=ff/r
      g(:,j)=g(:,j)+dum*rij
      g(:,i)=g(:,i)-dum*rij

   enddo

end subroutine constrain_dist

subroutine constrain_angle(fix,n,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   use xtb_basic_geo
   implicit none
   type(fix_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: e
   real(wp),intent(inout) :: g(3,n)

   integer i,j,k,l,m,mm
   real(wp)rij(3),dum,r0,ffc,vp(3),ra(3),rb(3)
   real(wp)va(3),vb(3),vc(3),vab(3),vcb(3),deda(3),dedc(3),dedb(3)
   real(wp)dda(3),ddb(3),ddc(3),ddd(3)
   real(wp)c0,rab2,rcb2,theta,dt,rmul1,rmul2,deddt,rp,cosa,ea,vlen,d
   real(wp)dx,dy,dz,termx,termy,termz,abcx,abcy,abcz,a,z0,expo,expom1

   if(fix%n.eq.0) return

   do m = 1, fix%n
      mm = 3*m-2
      i = fix%atoms(mm)
      j = fix%atoms(mm+1)
      k = fix%atoms(mm+2)
      c0 = fix%val(m)
      va = xyz(1:3,i)
      vb = xyz(1:3,j)
      vc = xyz(1:3,k)
      vab = va-vb
      vcb = vc-vb
      rab2 = vab(1)*vab(1) + vab(2)*vab(2) + vab(3)*vab(3)
      rcb2 = vcb(1)*vcb(1) + vcb(2)*vcb(2) + vcb(3)*vcb(3)
      call crprod(vcb,vab,vp)
      rp = norm2(vp)+1.d-14
      call impsc(vab,vcb,cosa)
      cosa = dble(min(1.0d0,max(-1.0d0,cosa)))
      theta= dacos(cosa)
      dt  = theta - c0
      ea  = fix%fc* dt**2
      deddt = 2.d0 * fix%fc * dt
      e = e + ea
      call crprod(vab,vp,deda)
      rmul1 = -deddt / (rab2*rp)
      deda = deda*rmul1
      call crprod(vcb,vp,dedc)
      rmul2 =  deddt / (rcb2*rp)
      dedc = dedc*rmul2
      dedb = deda+dedc
      g(:,i) = g(:,i) + deda
      g(:,j) = g(:,j) - dedb
      g(:,k) = g(:,k) + dedc
   enddo

end subroutine constrain_angle

subroutine constrain_dihedral(fix,n,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_type_setvar
   use xtb_basic_geo
   implicit none
   type(fix_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: e
   real(wp),intent(inout) :: g(3,n)

   integer i,j,k,l,m,mm
   real(wp)rij(3),dum,r0,ffc,vp(3),ra(3),rb(3)
   real(wp)va(3),vb(3),vc(3),vab(3),vcb(3),deda(3),dedc(3),dedb(3)
   real(wp)dda(3),ddb(3),ddc(3),ddd(3)
   real(wp)c0,rab2,rcb2,theta,dt,rmul1,rmul2,deddt,rp,cosa,ea,vlen,d
   real(wp)c1,phi0,phi,dphi1,x1cos,x1sin,dij,ff,dum1,dum2
   real(wp)dx,dy,dz,termx,termy,termz,abcx,abcy,abcz,a,z0,expo,expom1

   if(fix%n.eq.0) return

   do m = 1, fix%n
      mm = 4*m-3
      i= fix%atoms(mm)
      j= fix%atoms(mm+1)
      k= fix%atoms(mm+2)
      l= fix%atoms(mm+3)
      phi0 =fix%val(m)
      phi=valijkl(n,xyz,i,j,k,l)
      if(abs(phi-pi).lt.1.d-8.or.abs(phi).lt.1.d-8) phi=phi+1.d-8
      call dphidr(n,xyz,i,j,k,l,phi,dda,ddb,ddc,ddd)
      dphi1=phi0-phi+pi
      x1cos=cos(dphi1)
      x1sin=sin(dphi1)
      dij  =fix%fc*x1sin
      g(:,i)=g(:,i)+dij*dda
      g(:,j)=g(:,j)+dij*ddb
      g(:,k)=g(:,k)+dij*ddc
      g(:,l)=g(:,l)+dij*ddd
      e=e+fix%fc*(1.0_wp+x1cos)
   enddo

end subroutine constrain_dihedral

subroutine constrain_pot(fix,n,at,xyz,g,e)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   type(constr_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz(3,n)
   real(wp),intent(inout) :: e
   real(wp),intent(inout) :: g(3,n)

   call constrain_pos     (fix%pos,     n,at,xyz,g,e)
   call constrain_dist    (fix%dist,    n,at,xyz,g,e)
   call constrain_angle   (fix%angle,   n,at,xyz,g,e)
   call constrain_dihedral(fix%dihedral,n,at,xyz,g,e)

end subroutine constrain_pot

subroutine constrain_hess(fix,n,at,xyz0,Hess)
   use xtb_mctc_accuracy, only : wp
   use xtb_type_setvar
   implicit none
   type(constr_setvar),intent(in) :: fix
   integer, intent(in)    :: n
   integer, intent(in)    :: at(n)
   real(wp),intent(in)    :: xyz0(3,n)
   real(wp),intent(inout) :: Hess((n*3)*((n*3)+1)/2)

   integer ia,ic,ja,jc,i,j,k,n3,ii,jj
   real(wp) step,step2,e
   real(wp),allocatable :: xyz(:,:)
   real(wp),allocatable :: h(:,:),gr(:,:),gl(:,:)

   if(fix%n.eq.0) return

   allocate( h(n*3,n*3),gr(3,n),gl(3,n),xyz(3,n), source = 0.0_wp )

   xyz = xyz0

   n3=3*n
   step =0.0001_wp
   step2=0.5_wp/step
   e=0

   do ia = 1, n
      do ic = 1, 3
         ii = (ia-1)*3+ic
         xyz(ic,ia)=xyz0(ic,ia)+step
         gr=0.0_wp
         call constrpot(n,at,xyz,gr,e)
         xyz(ic,ia)=xyz0(ic,ia)-step
         gl=0.0_wp
         call constrpot(n,at,xyz,gl,e)
         xyz(ic,ia)=xyz0(ic,ia)
         do ja = 1, n
            do jc = 1, 3
               jj = (ja-1)*3 + jc
               h(jj,ii) =(gr(jc,ja) - gl(jc,ja)) * step2
            enddo
         enddo
      enddo
   enddo

!  call prmat(6,h,3*n,3*n,'H')

   k=0
   do i=1,n3
      do j=1,i
         k=k+1
         hess(k)=hess(k)+0.5_wp*(h(j,i)+h(i,j))
      enddo
   enddo

end subroutine constrain_hess

end module xtb_constrainpot

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> provides definition of calculation options type
module xtb_type_options
   use xtb_mctc_accuracy, only : wp
   use iso_c_binding
   implicit none

   public :: tb_options

   public :: peeq_options
   public :: c_peeq_options
   public :: scc_options
   public :: c_scc_options
   public :: eeq_options
   public :: c_eeq_options
   public :: dftd_options
   public :: c_dftd_options
   public :: assignment(=)

   private

!> bundles all calculation options in one type
   type :: tb_options
      character(len=:),allocatable :: fname    !< geometry file
      character(len=:),allocatable :: xcontrol !< instruction file
      character(len=:),allocatable :: fnv      !< parameter file
      real(wp) :: acc = 0.0_wp                 !< calculation accuracy
      real(wp) :: etemp = 0.0_wp
      integer  :: prlevel = 0
      integer  :: maxiter = 0
      logical  :: copycontrol = .false.        !< copy control file
      logical  :: restart = .false.            !< print restart file
      logical  :: grad = .false.               !< calculate gradient
      logical  :: define = .false.             !< check the current run
      logical  :: verbose = .false.            !< print more information
      logical  :: veryverbose = .false.        !< clutter the screen more
      logical  :: silent = .false.             !< clutter the screen less
   contains
   procedure :: allocate => allocate_options
   procedure :: deallocate => deallocate_options
   procedure :: write => write_options
   procedure :: default_options
   procedure :: export_peeq => export_peeq_options
   procedure :: export_scc  => export_scc_options
   end type tb_options


   type :: scc_options
      sequence
      integer  :: prlevel = 0
      integer  :: parallel = 0
      real(wp) :: acc = 0.0_wp
      real(wp) :: etemp = 0.0_wp
      logical  :: grad = .false.
      logical  :: restart = .false.
      logical  :: ccm = .false.
      integer  :: maxiter = 0
      character(len=20) :: solvent = "none"
   end type scc_options

   type,bind(C) :: c_scc_options
      integer(c_int)  :: prlevel = 0_c_int
      integer(c_int)  :: parallel = 0_c_int
      real(c_double)  :: acc = 0.0_c_double
      real(c_double)  :: etemp = 0.0_c_double
      logical(c_bool) :: grad = .false._c_bool
      logical(c_bool) :: restart = .false._c_bool
      logical(c_bool) :: ccm = .false._c_bool
      integer(c_int)  :: maxiter = 0_c_int
      character(c_char) :: solvent(20) = c_null_char
   end type c_scc_options

   type :: peeq_options
      sequence
      integer  :: prlevel = 0
      integer  :: parallel = 0
      real(wp) :: acc = 0.0_wp
      real(wp) :: etemp = 0.0_wp
      logical  :: grad = .false.
      logical  :: ccm = .false.
      character(len=20) :: solvent = "none"
   end type peeq_options

   type,bind(C) :: c_peeq_options
      integer(c_int)  :: prlevel = 0_c_int
      integer(c_int)  :: parallel = 0_c_int
      real(c_double)  :: acc = 0.0_c_double
      real(c_double)  :: etemp = 0.0_c_double
      logical(c_bool) :: grad = .false._c_bool
      logical(c_bool) :: ccm = .false._c_bool
      character(c_char) :: solvent(20) = c_null_char
   end type c_peeq_options

   type :: eeq_options
      sequence
      integer  :: prlevel = 0
      integer  :: param = 0
      logical  :: grad = .false.
   end type eeq_options

   type,bind(C) :: c_eeq_options
      integer(c_int)  :: prlevel = 0_c_int
      integer(c_int)  :: param = 0_c_int
      logical(c_bool) :: grad = .false._c_bool
   end type c_eeq_options

!> calculation setup
   type :: dftd_options
      sequence
      integer  :: lmbd = -1                 !< kind of non-additivity correction
      integer  :: refq = -1                 !< kind of charge model
      real(wp) :: wf = 0.0_wp               !< weighting factor
      real(wp) :: g_a = 0.0_wp              !< charge scale height
      real(wp) :: g_c = 0.0_wp              !< charge scale steepness
      logical  :: lmolpol = .false.         !< calculate molecular properties?
      logical  :: lenergy = .false.         !< calculate dispersion energy?
      logical  :: lgradient = .false.       !< calculate dispersion gradient?
      logical  :: verbose = .false.         !< print more information
      logical  :: veryverbose = .false.     !< clutter the screen more
      logical  :: silent = .false.          !< clutter the screen less
   end type dftd_options

!> calculation setup
   type,bind(C) :: c_dftd_options
      integer(c_int)  :: lmbd = -1             !< kind of non-additivity correction
      integer(c_int)  :: refq = -1             !< kind of charge model
      real(c_double)  :: wf = 0.0_wp           !< weighting factor
      real(c_double)  :: g_a = 0.0_wp          !< charge scale height
      real(c_double)  :: g_c = 0.0_wp          !< charge scale steepness
      logical(c_bool) :: lmolpol = .false.     !< calculate molecular properties?
      logical(c_bool) :: lenergy = .false.     !< calculate dispersion energy?
      logical(c_bool) :: lgradient = .false.   !< calculate dispersion gradient?
      logical(c_bool) :: verbose = .false.     !< print more information
      logical(c_bool) :: veryverbose = .false. !< clutter the screen more
      logical(c_bool) :: silent = .false.      !< clutter the screen less
   end type c_dftd_options

   interface assignment(=)
      module procedure :: convert_peeq_options_c_to_f
      module procedure :: convert_peeq_options_f_to_c
      module procedure :: convert_scc_options_c_to_f
      module procedure :: convert_scc_options_f_to_c
      module procedure :: convert_eeq_options_c_to_f
      module procedure :: convert_eeq_options_f_to_c
      module procedure :: convert_dftd_options_c_to_f
      module procedure :: convert_dftd_options_f_to_c
   end interface

contains


subroutine default_options(self)
   implicit none
   class(tb_options),intent(out) :: self

   self%acc = 1.0_wp
   self%restart = .true.
   self%copycontrol = .false.
   self%grad = .false.
   self%etemp = 300.0_wp
   self%maxiter = 250

end subroutine default_options

!> constructor for calculation options
subroutine allocate_options(self)
   implicit none
   class(tb_options),intent(inout) :: self
   call self%deallocate
end subroutine allocate_options

!> deconstructor for calculation options
subroutine deallocate_options(self)
   implicit none
   class(tb_options),intent(inout) :: self
   if (allocated(self%fname))    deallocate(self%fname)
   if (allocated(self%xcontrol)) deallocate(self%xcontrol)
   if (allocated(self%fnv))      deallocate(self%fnv)
end subroutine deallocate_options

!> print information about current calculation options to unit
subroutine write_options(self,iunit,comment)
   implicit none
   class(tb_options),intent(in) :: self    !< calculation options
   integer,          intent(in) :: iunit   !< file handle
   character(len=*), intent(in) :: comment !< name of the variable
   character(len=*),parameter :: dfmt = '(1x,a,1x,"=",1x,g0)'

   write(iunit,'(72(">"))')
   write(iunit,'(1x,"*",1x,a)') "Writing 'tb_options' class"
   write(iunit,'(  "->",1x,a)') comment
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "status of the fields"
   write(iunit,dfmt) "real    :: acc         ",self%acc
   write(iunit,dfmt) "logical :: copycontrol ",self%copycontrol
   write(iunit,dfmt) "logical :: restart     ",self%restart
   write(iunit,dfmt) "logical :: grad        ",self%grad
   write(iunit,dfmt) "logical :: define      ",self%define
   write(iunit,dfmt) "logical :: verbose     ",self%verbose
   write(iunit,dfmt) "logical :: veryverbose ",self%veryverbose
   write(iunit,dfmt) "logical :: silent      ",self%silent
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "allocation status"
   write(iunit,dfmt) "allocated? fname       ",allocated(self%fname)
   write(iunit,dfmt) "allocated? xcontrol    ",allocated(self%xcontrol)
   write(iunit,dfmt) "allocated? fnv         ",allocated(self%fnv)
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "size of memory allocation"
   if (allocated(self%fname)) then
   write(iunit,dfmt) "length  :: fname       ",len(self%fname)
   endif
   if (allocated(self%xcontrol)) then
   write(iunit,dfmt) "length  :: xcontrol    ",len(self%xcontrol)
   endif
   if (allocated(self%fnv)) then
   write(iunit,dfmt) "length  :: fnv         ",len(self%fnv)
   endif
   write(iunit,'(72("-"))')
   write(iunit,'(1x,"*",1x,a)') "string content"
   if (allocated(self%fname)) then
   write(iunit,dfmt) "string  :: fname       ",self%fname
   endif
   if (allocated(self%xcontrol)) then
   write(iunit,dfmt) "string  :: xcontrol    ",self%xcontrol
   endif
   if (allocated(self%fnv)) then
   write(iunit,dfmt) "string  :: fnv         ",self%fnv
   endif
   write(iunit,'(72("<"))')
end subroutine write_options

pure function export_scc_options(self) result(opt)
   implicit none
   class(tb_options), intent(in) :: self
   type(scc_options) :: opt
   opt%prlevel = self%prlevel
   opt%maxiter = self%maxiter
   opt%acc     = self%acc
   opt%etemp   = self%etemp
   opt%grad    = self%grad
end function export_scc_options

pure elemental subroutine convert_scc_options_c_to_f &
      (f_opt,c_opt)
   use iso_c_binding, only : c_null_char
   implicit none
   type(c_scc_options), intent(in)  :: c_opt
   type(scc_options),   intent(out) :: f_opt
   integer :: i
   f_opt%prlevel = c_opt%prlevel
   f_opt%maxiter = c_opt%maxiter
   f_opt%acc     = c_opt%acc
   f_opt%etemp   = c_opt%etemp
   f_opt%grad    = c_opt%grad
   f_opt%restart = c_opt%restart
   f_opt%parallel= c_opt%parallel
   f_opt%ccm     = c_opt%ccm

   f_opt%solvent = ''
   do i = 1, 20
      if (c_opt%solvent(i).eq.c_null_char) exit
      f_opt%solvent(i:i) = c_opt%solvent(i)
   enddo

end subroutine convert_scc_options_c_to_f

pure elemental subroutine convert_scc_options_f_to_c &
      (c_opt,f_opt)
   use iso_c_binding, only : c_null_char
   implicit none
   type(scc_options),  intent(in)  :: f_opt
   type(c_scc_options),intent(out) :: c_opt
   integer :: i
   c_opt%prlevel = f_opt%prlevel
   c_opt%maxiter = f_opt%maxiter
   c_opt%acc     = f_opt%acc
   c_opt%etemp   = f_opt%etemp
   c_opt%grad    = f_opt%grad
   c_opt%restart = f_opt%restart
   c_opt%parallel= f_opt%parallel
   c_opt%ccm     = f_opt%ccm

   do i = 1, len_trim(f_opt%solvent)
      c_opt%solvent(i) = f_opt%solvent(i:i)
   enddo
   c_opt%solvent(len_trim(f_opt%solvent)+1) = c_null_char

end subroutine convert_scc_options_f_to_c

pure function export_peeq_options(self) result(opt)
   implicit none
   class(tb_options), intent(in) :: self
   type(peeq_options) :: opt
   opt%prlevel = self%prlevel
   opt%acc     = self%acc
   opt%etemp   = self%etemp
   opt%grad    = self%grad
end function export_peeq_options

pure elemental subroutine convert_peeq_options_c_to_f &
      (f_opt,c_opt)
   implicit none
   type(c_peeq_options), intent(in)  :: c_opt
   type(peeq_options),   intent(out) :: f_opt
   integer :: i
   f_opt%prlevel = c_opt%prlevel
   f_opt%ccm     = c_opt%ccm
   f_opt%acc     = c_opt%acc
   f_opt%etemp   = c_opt%etemp
   f_opt%grad    = c_opt%grad
   f_opt%parallel= c_opt%parallel

   f_opt%solvent = ''
   do i = 1, 20
      if (c_opt%solvent(i).eq.c_null_char) exit
      f_opt%solvent(i:i) = c_opt%solvent(i)
   enddo
end subroutine convert_peeq_options_c_to_f

pure elemental subroutine convert_peeq_options_f_to_c &
      (c_opt,f_opt)
   implicit none
   type(peeq_options),  intent(in)  :: f_opt
   type(c_peeq_options),intent(out) :: c_opt
   integer :: i
   c_opt%prlevel = f_opt%prlevel
   c_opt%ccm     = f_opt%ccm
   c_opt%acc     = f_opt%acc
   c_opt%etemp   = f_opt%etemp
   c_opt%grad    = f_opt%grad
   c_opt%parallel= f_opt%parallel

   do i = 1, len_trim(f_opt%solvent)
      c_opt%solvent(i) = f_opt%solvent(i:i)
   enddo
   c_opt%solvent(len_trim(f_opt%solvent)+1) = c_null_char
end subroutine convert_peeq_options_f_to_c

pure elemental subroutine convert_eeq_options_c_to_f &
      (f_opt,c_opt)
   implicit none
   type(c_eeq_options), intent(in)  :: c_opt
   type(eeq_options),   intent(out) :: f_opt
   f_opt%prlevel = c_opt%prlevel
   f_opt%param   = c_opt%param
   f_opt%grad    = c_opt%grad
end subroutine convert_eeq_options_c_to_f

pure elemental subroutine convert_eeq_options_f_to_c &
      (c_opt,f_opt)
   implicit none
   type(eeq_options),  intent(in)  :: f_opt
   type(c_eeq_options),intent(out) :: c_opt
   c_opt%prlevel = f_opt%prlevel
   c_opt%param   = f_opt%param
   c_opt%grad    = f_opt%grad
end subroutine convert_eeq_options_f_to_c

pure elemental subroutine convert_dftd_options_c_to_f &
      (f_dopt,c_dopt)
   implicit none
   type(c_dftd_options),intent(in)  :: c_dopt
   type(dftd_options),  intent(out) :: f_dopt
   f_dopt%lmbd        = c_dopt%lmbd
   f_dopt%refq        = c_dopt%refq
   f_dopt%wf          = c_dopt%wf
   f_dopt%g_a         = c_dopt%g_a
   f_dopt%g_c         = c_dopt%g_c
   f_dopt%lmolpol     = c_dopt%lmolpol
   f_dopt%lenergy     = c_dopt%lenergy
   f_dopt%lgradient   = c_dopt%lgradient
   f_dopt%verbose     = c_dopt%verbose
   f_dopt%veryverbose = c_dopt%veryverbose
   f_dopt%silent      = c_dopt%silent
end subroutine convert_dftd_options_c_to_f

pure elemental subroutine convert_dftd_options_f_to_c &
      (c_dopt,f_dopt)
   implicit none
   type(c_dftd_options),intent(out) :: c_dopt
   type(dftd_options),  intent(in)  :: f_dopt
   c_dopt%lmbd        = f_dopt%lmbd
   c_dopt%refq        = f_dopt%refq
   c_dopt%wf          = f_dopt%wf
   c_dopt%g_a         = f_dopt%g_a
   c_dopt%g_c         = f_dopt%g_c
   c_dopt%lmolpol     = f_dopt%lmolpol
   c_dopt%lenergy     = f_dopt%lenergy
   c_dopt%lgradient   = f_dopt%lgradient
   c_dopt%verbose     = f_dopt%verbose
   c_dopt%veryverbose = f_dopt%veryverbose
   c_dopt%silent      = f_dopt%silent
end subroutine convert_dftd_options_f_to_c

end module xtb_type_options

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Module for the relevant coordination numbers

module xtb_ptb_ncoord
#if WITH_TBLITE
   use mctc_env, only: wp
   use mctc_io, only: structure_type

   use tblite_data_covrad, only: get_covalent_rad

   implicit none

   private

   public :: ncoord_erf

contains

   !> @brief Calculate the coordination number from the error function
   subroutine ncoord_erf(mol, kcn, cutoff, cn, covrad)

      !> Molecular structure data
      type(structure_type), intent(in) :: mol

      !> Steepness of the counting function
      real(wp), intent(in) :: kcn

      !> Real space cutoff
      real(wp), intent(in) :: cutoff

      !> Covalent radius
      real(wp), intent(in), optional :: covrad(:)
      !> Effectively used covalent radius
      real(wp), allocatable :: rcov(:)

      !> Error function coordination number.
      real(wp), intent(out) :: cn(:)

      integer :: iat, jat, izp, jzp
      real(wp) :: r2, r1, rc, rij(3), countf, cutoff2

      cn(:) = 0.0_wp
      cutoff2 = cutoff**2

      allocate(rcov(mol%nid))
      if (present(covrad)) then
         rcov(:) = covrad
      else
         rcov(:) = get_covalent_rad(mol%num)
      end if

      !$omp parallel do default(none) reduction(+:cn) &
      !$omp shared(mol, cutoff2, rcov, kcn) &
      !$omp private(jat, izp, jzp, r2, rij, r1, rc, countf)
      do iat = 1, mol%nat
         izp = mol%id(iat)
         do jat = 1, iat
            jzp = mol%id(jat)
            rij = mol%xyz(:, iat) - (mol%xyz(:, jat))
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-12_wp) cycle
            r1 = sqrt(r2)

            rc = rcov(izp) + rcov(jzp)

            countf = erf_count(kcn, r1, rc)

            cn(iat) = cn(iat) + countf
            if (iat /= jat) then
               cn(jat) = cn(jat) + countf
            end if
         end do
      end do

   end subroutine ncoord_erf

!> Error function counting function for coordination number contributions.
   pure function erf_count(k, r, r0) result(count)

      !> Steepness of the counting function.
      real(wp), intent(in) :: k

      !> Current distance.
      real(wp), intent(in) :: r

      !> Sum of covalent radii.
      real(wp), intent(in) :: r0

      real(wp) :: count

      count = 0.5_wp*(1.0_wp + erf(-k*(r - r0)/r0))

   end function erf_count

#endif
end module xtb_ptb_ncoord

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> LAPACK eigenproblem solvers
module xtb_mctc_lapack_geneigval
   use xtb_mctc_accuracy, only : sp, dp
   implicit none
   private

   public :: lapack_sygv, lapack_sygvd, lapack_sygvx, lapack_spgv, lapack_spgvd
   public :: lapack_spgvx
   public :: lapack_hegv, lapack_hegvd, lapack_hegvx, lapack_hpgv, lapack_hpgvd
   public :: lapack_hpgvx


   interface lapack_sygv
      pure subroutine ssygv(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine ssygv
      pure subroutine dsygv(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
      end subroutine dsygv
   end interface lapack_sygv

   interface lapack_hegv
      pure subroutine chegv(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & rwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(in) :: rwork(*)
      end subroutine chegv
      pure subroutine zhegv(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & rwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(in) :: rwork(*)
      end subroutine zhegv
   end interface lapack_hegv

   interface lapack_sygvd
      pure subroutine ssygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & iwork, liwork, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine ssygvd
      pure subroutine dsygvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & iwork, liwork, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dsygvd
   end interface lapack_sygvd

   interface lapack_hegvd
      pure subroutine chegvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & rwork, lrwork, iwork, liwork, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine chegvd
      pure subroutine zhegvd(itype, jobz, uplo, n, a, lda, b, ldb, w, work, lwork, &
            & rwork, lrwork, iwork, liwork, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: uplo
         integer, intent(out) :: info
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine zhegvd
   end interface lapack_hegvd

   interface lapack_sygvx
      pure subroutine ssygvx(itype, jobz, range, uplo, n, a, lda, b, ldb, vl, vu, &
            & il, iu, abstol, m, w, z, ldz, work, lwork, iwork, ifail, info)
         import :: sp
         real(sp), intent(inout) :: a(lda, *)
         real(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldz
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(in) :: iwork(*)
      end subroutine ssygvx
      pure subroutine dsygvx(itype, jobz, range, uplo, n, a, lda, b, ldb, vl, vu, &
            & il, iu, abstol, m, w, z, ldz, work, lwork, iwork, ifail, info)
         import :: dp
         real(dp), intent(inout) :: a(lda, *)
         real(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldz
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(in) :: iwork(*)
      end subroutine dsygvx
   end interface lapack_sygvx

   interface lapack_hegvx
      pure subroutine chegvx(itype, jobz, range, uplo, n, a, lda, b, ldb, vl, vu, &
            & il, iu, abstol, m, w, z, ldz, work, lwork, rwork, iwork, ifail, info)
         import :: sp
         complex(sp), intent(inout) :: a(lda, *)
         complex(sp), intent(inout) :: b(ldb, *)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldz
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine chegvx
      pure subroutine zhegvx(itype, jobz, range, uplo, n, a, lda, b, ldb, vl, vu, &
            & il, iu, abstol, m, w, z, ldz, work, lwork, rwork, iwork, ifail, info)
         import :: dp
         complex(dp), intent(inout) :: a(lda, *)
         complex(dp), intent(inout) :: b(ldb, *)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: lda
         integer, intent(in) :: ldb
         integer, intent(in) :: ldz
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine zhegvx
   end interface lapack_hegvx

   interface lapack_spgv
      pure subroutine sspgv(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(inout) :: bp(*)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(sp), intent(in) :: work(*)
      end subroutine sspgv
      pure subroutine dspgv(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(inout) :: bp(*)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(dp), intent(in) :: work(*)
      end subroutine dspgv
   end interface lapack_spgv

   interface lapack_hpgv
      pure subroutine chpgv(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, rwork, &
            & info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         complex(sp), intent(inout) :: bp(*)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(sp), intent(in) :: work(*)
         real(sp), intent(in) :: rwork(*)
      end subroutine chpgv
      pure subroutine zhpgv(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, rwork, &
            & info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         complex(dp), intent(inout) :: bp(*)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(dp), intent(in) :: work(*)
         real(dp), intent(in) :: rwork(*)
      end subroutine zhpgv
   end interface lapack_hpgv

   interface lapack_spgvd
      pure subroutine sspgvd(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, lwork, &
            & iwork, liwork, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(inout) :: bp(*)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine sspgvd
      pure subroutine dspgvd(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, lwork, &
            & iwork, liwork, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(inout) :: bp(*)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine dspgvd
   end interface lapack_spgvd

   interface lapack_hpgvd
      pure subroutine chpgvd(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, lwork, &
            & rwork, lrwork, iwork, liwork, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         complex(sp), intent(inout) :: bp(*)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(sp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(sp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine chpgvd
      pure subroutine zhpgvd(itype, jobz, uplo, n, ap, bp, w, z, ldz, work, lwork, &
            & rwork, lrwork, iwork, liwork, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         complex(dp), intent(inout) :: bp(*)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(dp), intent(inout) :: work(*)
         integer, intent(in) :: lwork
         real(dp), intent(inout) :: rwork(*)
         integer, intent(in) :: lrwork
         integer, intent(inout) :: iwork(*)
         integer, intent(in) :: liwork
      end subroutine zhpgvd
   end interface lapack_hpgvd

   interface lapack_spgvx
      pure subroutine sspgvx(itype, jobz, range, uplo, n, ap, bp, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, iwork, ifail, info)
         import :: sp
         real(sp), intent(inout) :: ap(*)
         real(sp), intent(inout) :: bp(*)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(sp), intent(in) :: work(*)
         integer, intent(in) :: iwork(*)
      end subroutine sspgvx
      pure subroutine dspgvx(itype, jobz, range, uplo, n, ap, bp, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, iwork, ifail, info)
         import :: dp
         real(dp), intent(inout) :: ap(*)
         real(dp), intent(inout) :: bp(*)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         real(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         real(dp), intent(in) :: work(*)
         integer, intent(in) :: iwork(*)
      end subroutine dspgvx
   end interface lapack_spgvx

   interface lapack_hpgvx
      pure subroutine chpgvx(itype, jobz, range, uplo, n, ap, bp, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, rwork, iwork, ifail, info)
         import :: sp
         complex(sp), intent(inout) :: ap(*)
         complex(sp), intent(inout) :: bp(*)
         real(sp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(sp), intent(out) :: z(ldz, *)
         real(sp), intent(in) :: vl
         real(sp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(sp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(sp), intent(in) :: work(*)
         real(sp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine chpgvx
      pure subroutine zhpgvx(itype, jobz, range, uplo, n, ap, bp, vl, vu, il, iu, &
            & abstol, m, w, z, ldz, work, rwork, iwork, ifail, info)
         import :: dp
         complex(dp), intent(inout) :: ap(*)
         complex(dp), intent(inout) :: bp(*)
         real(dp), intent(out) :: w(*)
         integer, intent(in) :: itype
         character(len=1), intent(in) :: uplo
         complex(dp), intent(out) :: z(ldz, *)
         real(dp), intent(in) :: vl
         real(dp), intent(in) :: vu
         integer, intent(in) :: il
         integer, intent(in) :: iu
         integer, intent(out) :: m
         integer, intent(out) :: ifail(*)
         real(dp), intent(in) :: abstol
         integer, intent(out) :: info
         character(len=1), intent(in) :: jobz
         character(len=1), intent(in) :: range
         integer, intent(in) :: n
         integer, intent(in) :: ldz
         complex(dp), intent(in) :: work(*)
         real(dp), intent(in) :: rwork(*)
         integer, intent(in) :: iwork(*)
      end subroutine zhpgvx
   end interface lapack_hpgvx


contains


end module xtb_mctc_lapack_geneigval

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Wrappers for BLAS
module xtb_mctc_blas_wrap1
   use xtb_mctc_accuracy, only : sp, dp
   use xtb_mctc_blas_level1, only : mctc_asum, mctc_axpy, mctc_copy, mctc_dot, &
      & mctc_nrm2, mctc_rot, mctc_scal, mctc_swap, mctc_iamax
   implicit none
   private

   public :: mctc_asum, mctc_axpy, mctc_copy, mctc_dot, mctc_nrm2, mctc_rot
   public :: mctc_scal, mctc_swap, mctc_iamax

   !> Takes the sum of the absolute values.
   interface mctc_asum
      module procedure :: mctc_sasum2
      module procedure :: mctc_dasum2
   end interface mctc_asum

   !> Constant times a vector plus a vector.
   interface mctc_axpy
      module procedure :: mctc_saxpy12
      module procedure :: mctc_saxpy21
      module procedure :: mctc_saxpy22
      module procedure :: mctc_daxpy12
      module procedure :: mctc_daxpy21
      module procedure :: mctc_daxpy22
   end interface mctc_axpy

   !> Copies a vector, x, to a vector, y.
   interface mctc_copy
      module procedure :: mctc_scopy12
      module procedure :: mctc_scopy21
      module procedure :: mctc_scopy22
      module procedure :: mctc_dcopy12
      module procedure :: mctc_dcopy21
      module procedure :: mctc_dcopy22
   end interface mctc_copy

   !> Forms the dot product of two vectors.
   interface mctc_dot
      module procedure :: mctc_sdot12
      module procedure :: mctc_sdot21
      module procedure :: mctc_sdot22
      module procedure :: mctc_ddot12
      module procedure :: mctc_ddot21
      module procedure :: mctc_ddot22
   end interface mctc_dot

   !> Returns the euclidean norm of a vector via the function
   !  name, so that
   !
   !    NRM2 := sqrt( x'*x )
   interface mctc_nrm2
      module procedure :: mctc_snrm22
      module procedure :: mctc_dnrm22
   end interface mctc_nrm2

   !> Applies a plane rotation.
   interface mctc_rot
      module procedure :: mctc_srot22
      module procedure :: mctc_drot22
   end interface mctc_rot

   !> Scales a vector by a constant.
   interface mctc_scal
      module procedure :: mctc_sscal2
      module procedure :: mctc_dscal2
   end interface mctc_scal

   !> Interchanges two vectors.
   interface mctc_swap
      module procedure :: mctc_sswap22
      module procedure :: mctc_dswap22
   end interface mctc_swap

   !> Finds the index of the first element having maximum absolute value.
   interface mctc_iamax
      module procedure :: mctc_isamax2
      module procedure :: mctc_idamax2
   end interface mctc_iamax


contains


function mctc_sasum2(xvec) result(asum)
   real(sp) :: asum
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   asum = mctc_asum(xptr)
end function mctc_sasum2


function mctc_dasum2(xvec) result(asum)
   real(dp) :: asum
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   asum = mctc_asum(xptr)
end function mctc_dasum2


subroutine mctc_saxpy12(xvec, yvec, alpha)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   call mctc_axpy(xvec, yptr, alpha)
end subroutine mctc_saxpy12


subroutine mctc_saxpy21(xvec, yvec, alpha)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout) :: yvec(:)
   real(sp), intent(in), optional :: alpha
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   call mctc_axpy(xptr, yvec, alpha)
end subroutine mctc_saxpy21


subroutine mctc_saxpy22(xvec, yvec, alpha)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), intent(in), optional :: alpha
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_axpy(xptr, yptr, alpha)
end subroutine mctc_saxpy22


subroutine mctc_daxpy12(xvec, yvec, alpha)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   call mctc_axpy(xvec, yptr, alpha)
end subroutine mctc_daxpy12


subroutine mctc_daxpy21(xvec, yvec, alpha)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout) :: yvec(:)
   real(dp), intent(in), optional :: alpha
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   call mctc_axpy(xptr, yvec, alpha)
end subroutine mctc_daxpy21


subroutine mctc_daxpy22(xvec, yvec, alpha)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), intent(in), optional :: alpha
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_axpy(xptr, yptr, alpha)
end subroutine mctc_daxpy22


subroutine mctc_scopy12(xvec, yvec)
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   call mctc_copy(xvec, yptr)
end subroutine mctc_scopy12


subroutine mctc_scopy21(xvec, yvec)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout) :: yvec(:)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   call mctc_copy(xptr, yvec)
end subroutine mctc_scopy21


subroutine mctc_scopy22(xvec, yvec)
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_copy(xptr, yptr)
end subroutine mctc_scopy22


subroutine mctc_dcopy12(xvec, yvec)
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   call mctc_copy(xvec, yptr)
end subroutine mctc_dcopy12


subroutine mctc_dcopy21(xvec, yvec)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout) :: yvec(:)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   call mctc_copy(xptr, yvec)
end subroutine mctc_dcopy21


subroutine mctc_dcopy22(xvec, yvec)
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_copy(xptr, yptr)
end subroutine mctc_dcopy22


function mctc_sdot12(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in) :: xvec(:)
   real(sp), intent(in), contiguous, target :: yvec(:, :)
   real(sp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   dot = mctc_dot(xvec, yptr)
end function mctc_sdot12


function mctc_sdot21(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(in) :: yvec(:)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   dot = mctc_dot(xptr, yvec)
end function mctc_sdot21


function mctc_sdot22(xvec, yvec) result(dot)
   real(sp) :: dot
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), intent(in), contiguous, target :: yvec(:, :)
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   dot = mctc_dot(xptr, yptr)
end function mctc_sdot22


function mctc_ddot12(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in) :: xvec(:)
   real(dp), intent(in), contiguous, target :: yvec(:, :)
   real(dp), pointer :: yptr(:)
   yptr(1:size(yvec)) => yvec
   dot = mctc_dot(xvec, yptr)
end function mctc_ddot12


function mctc_ddot21(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(in) :: yvec(:)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   dot = mctc_dot(xptr, yvec)
end function mctc_ddot21


function mctc_ddot22(xvec, yvec) result(dot)
   real(dp) :: dot
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), intent(in), contiguous, target :: yvec(:, :)
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   dot = mctc_dot(xptr, yptr)
end function mctc_ddot22


function mctc_snrm22(xvec) result(nrm2)
   real(sp) :: nrm2
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   nrm2 = mctc_nrm2(xptr)
end function mctc_snrm22


function mctc_dnrm22(xvec) result(nrm2)
   real(dp) :: nrm2
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   nrm2 = mctc_nrm2(xptr)
end function mctc_dnrm22


subroutine mctc_srot22(xvec, yvec, c, s)
   real(sp), intent(in) :: c
   real(sp), intent(in) :: s
   real(sp), intent(inout), contiguous, target :: xvec(:, :)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_rot(xptr, yptr, c, s)
end subroutine mctc_srot22


subroutine mctc_drot22(xvec, yvec, c, s)
   real(dp), intent(in) :: c
   real(dp), intent(in) :: s
   real(dp), intent(inout), contiguous, target :: xvec(:, :)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_rot(xptr, yptr, c, s)
end subroutine mctc_drot22


subroutine mctc_sscal2(xvec, alpha)
   real(sp), intent(in) :: alpha
   real(sp), intent(inout), contiguous, target :: xvec(:, :)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   call mctc_scal(xptr, alpha)
end subroutine mctc_sscal2


subroutine mctc_dscal2(xvec, alpha)
   real(dp), intent(in) :: alpha
   real(dp), intent(inout), contiguous, target :: xvec(:, :)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   call mctc_scal(xptr, alpha)
end subroutine mctc_dscal2


subroutine mctc_sswap22(xvec, yvec)
   real(sp), intent(inout), contiguous, target :: xvec(:, :)
   real(sp), intent(inout), contiguous, target :: yvec(:, :)
   real(sp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_swap(xptr, yptr)
end subroutine mctc_sswap22


subroutine mctc_dswap22(xvec, yvec)
   real(dp), intent(inout), contiguous, target :: xvec(:, :)
   real(dp), intent(inout), contiguous, target :: yvec(:, :)
   real(dp), pointer :: xptr(:), yptr(:)
   xptr(1:size(xvec)) => xvec
   yptr(1:size(yvec)) => yvec
   call mctc_swap(xptr, yptr)
end subroutine mctc_dswap22


function mctc_isamax2(xvec) result(iamax)
   integer :: iamax
   real(sp), intent(in), contiguous, target :: xvec(:, :)
   real(sp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   iamax = mctc_iamax(xptr)
end function mctc_isamax2


function mctc_idamax2(xvec) result(iamax)
   integer :: iamax
   real(dp), intent(in), contiguous, target :: xvec(:, :)
   real(dp), pointer :: xptr(:)
   xptr(1:size(xvec)) => xvec
   iamax = mctc_iamax(xptr)
end function mctc_idamax2


end module xtb_mctc_blas_wrap1

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module test_atomlist
   use testdrive, only : new_unittest, unittest_type, error_type, check, test_failed
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stderr
   use xtb_type_atomlist
   implicit none
   private

   public :: collect_atomlist

   integer, parameter :: atoms(9) = [3,1,1,5,8,1,1,2,5]
   logical, parameter :: lpar(9) = [.true., .false., .true., .true., .true., &
      &                             .false., .false., .true., .false.]
   integer, parameter :: ipar(5) = [1, 3, 4, 5, 8]
   character(len=*), parameter :: cpar = '1,3-5,8'

contains

!> Collect all exported unit tests
subroutine collect_atomlist(testsuite)
   !> Collection of tests
   type(unittest_type), allocatable, intent(out) :: testsuite(:)

   testsuite = [ &
      new_unittest("defaults", test_atomlist_defaults), &
      new_unittest("constr1", test_atomlist_constr1), &
      new_unittest("constr2", test_atomlist_constr2), &
      new_unittest("constr3", test_atomlist_constr3), &
      new_unittest("constr4", test_atomlist_constr4), &
      new_unittest("manip1", test_atomlist_manip1), &
      new_unittest("manip2", test_atomlist_manip2) &
      ]

end subroutine collect_atomlist


subroutine test_atomlist_defaults(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   call check(error, atl%get_truth() .eqv. .true.)
   call atl%switch_truth
   call check(error, atl%get_truth() .eqv. .false.)
   call check(error, size(atl), 0)

end subroutine test_atomlist_defaults

subroutine test_atomlist_constr1(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   atl = TAtomList(list=lpar, truth=.true.)
   call check(error, size(atl), 9)
   call check(error, len(atl), 5)

end subroutine test_atomlist_constr1

subroutine test_atomlist_constr2(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   atl = TAtomList(list=lpar, truth=.false.)
   call check(error, size(atl), 9)
   call check(error, len(atl), 4)

end subroutine test_atomlist_constr2

subroutine test_atomlist_constr3(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   atl = TAtomList(list=ipar, truth=.true.)
   call check(error, size(atl), 8)
   call check(error, len(atl), 5)
   call atl%to_list(list)
   call check(error, all(list == ipar))

end subroutine test_atomlist_constr3

subroutine test_atomlist_constr4(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   atl = TAtomList(list=cpar, truth=.false.)
   call check(error, size(atl), 8)
   call check(error, len(atl), 5)
   call atl%to_string(string)
   call check(error, string, cpar)
   call atl%new

end subroutine test_atomlist_constr4

subroutine test_atomlist_manip1(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   call atl%new(lpar)
   call atl%resize(9)
   call atl%switch_truth
   call atl%to_string(string)
   call check(error, string, '2,6-7,9')
   call atl%gather(atoms, list)
   call check(error, all(list == [1,1,1,5]))
   call check(error, size(list), len(atl))
   call atl%new

end subroutine test_atomlist_manip1

subroutine test_atomlist_manip2(error)
   type(error_type), allocatable, intent(out) :: error
   type(TAtomList) :: atl
   character(len=:), allocatable :: string
   integer, allocatable :: list(:)

   atl = TAtomList(list=lpar, truth=.false., delimiter=' ', skip=':')
   call atl%to_string(string)
   call check(error, string, '2 6:7 9')
   call atl%switch_truth
   call atl%to_list(list)
   call atl%switch_truth
   call atl%add(list)
   call check(error, len(atl), size(atl))
   call atl%to_string(string)
   call check(error, string, '1:9')

end subroutine test_atomlist_manip2

end module test_atomlist

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine raise(mode,message)
   use xtb_mctc_global
   implicit none
   character, intent(in) :: mode
   character(len=*), intent(in) :: message

   select case(mode)
   case('S','s') ! save to message buffer
      if (strict) then
         call persistentEnv%error(message)
         call persistentEnv%terminate("Global environment terminated")
      else
         call persistentEnv%warning(message)
      endif
   case('F','f') ! flush message buffer
      call persistentEnv%checkpoint(message)
   case('W','w') ! print warning directly
      if (strict) then
         call persistentEnv%error(message)
         call persistentEnv%terminate("Global environment terminated")
      else
         call persistentEnv%warning(message)
      endif
   case('E','e')
      call persistentEnv%error(message)
      call persistentEnv%terminate("Global environment terminated")
   end select

end subroutine raise

subroutine terminate(signal)
   use xtb_mctc_io, only : stderr
   use xtb_mctc_global, only : name
   integer,intent(in) :: signal
   integer,parameter  :: p_exit_success = 0
   integer,parameter  :: p_exit_failure = 1
   integer,parameter  :: p_exit_external = -1
   if (.not.allocated(name)) name = 'program'
   select case(signal)
   case(p_exit_success)
      write(stderr,'(  "normal termination of",1x,a)') name
      stop
   case(p_exit_external)
      write(stderr,'("external termination of",1x,a)') name
      error stop
   case default
      write(stderr,'("abnormal termination of",1x,a)') name
      error stop
   end select
end subroutine terminate

subroutine xtb_wsigint(signal) bind(c)
   use, intrinsic :: iso_c_binding, only : c_int
   use xtb_mctc_io, only : stderr
   implicit none
   integer(c_int), value :: signal
   write(stderr,'("recieved SIGINT, terminating...")')
   call terminate(-1)
end subroutine xtb_wsigint

subroutine xtb_wsigterm(signal) bind(c)
   use, intrinsic :: iso_c_binding, only : c_int
   use xtb_mctc_io, only : stderr
   implicit none
   integer(c_int), value :: signal
   write(stderr,'("recieved SIGTERM, terminating...")')
   call terminate(-1)
end subroutine xtb_wsigterm

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_extern_mopac
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_io, only : stdout
   use xtb_mctc_symbols, only : toSymbol
   use xtb_type_calculator, only : TCalculator
   use xtb_type_data, only : scc_results
   use xtb_type_environment, only : TEnvironment
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_param, only : scc_parameter
   use xtb_type_restart, only : TRestart
   use xtb_io_writer, only : writeMolecule
   use xtb_mctc_systools
   use xtb_setparam
   use xtb_readin
   use xtb_mctc_convert
   use xtb_mctc_systools
   use xtb_setparam
   use xtb_fixparam
   use xtb_scanparam
   use xtb_sphereparam
   use xtb_metadynamic
   use xtb_constrainpot
   implicit none
   private

   public :: TMopacCalculator, newMopacCalculator


   type, extends(TCalculator) :: TMopacCalculator
      type(qm_external) :: ext
   contains
      !> Perform single point calculation
      procedure :: singlepoint
      !> Write informative printout
      procedure :: writeInfo
   end type TMopacCalculator


contains


subroutine checkMopac(env,ext)
   character(len=*), parameter :: source = 'extern_mopac_checkMopac'
   type(TEnvironment), intent(inout) :: env
   type(qm_external), intent(inout) :: ext
   character(len=:),allocatable :: homedir,syspath
   character(len=5) :: chdum
   integer :: i
   logical :: exist

   ! check for MOPAC executable
   if (allocated(ext%executable)) then ! user input
      if (ext%executable(1:1).eq.'~') then
         ! this is relative to the users home, expand it
         call rdvar('HOME',homedir)
         ext%executable = homedir // ext%executable(2:)
         if (set%verbose) then
            write(stdout,'(a,1x,a)') &
               "user home directory        :",homedir
         endif
      endif
      inquire(file=ext%executable,exist=exist)
      if (.not.exist) then
         call env%error("'"//ext%executable//"' was not found, please check",source)
         return
      endif
   else ! no executable provided, lets find it
      call rdvar('PATH',syspath)
      if (set%verbose) then
         write(stdout,'(a,1x,a)') &
            "system path                :",syspath
      endif
      call rdpath(syspath,'mopac',ext%executable,exist)
      if (.not.exist) then
         call env%error('Could not locate mopac executable',source)
         return
      endif
   endif
   if (set%verbose) then
      write(stdout,'(a,1x,a)') &
         "mopac executable           :",ext%executable
   endif

   ! see if there is a preference for an input file
   if (allocated(ext%input_file)) then
      inquire(file=ext%input_file,exist=exist)
      ext%exist = exist
   else
      ext%input_file = 'GCOORD'
      inquire(file=ext%input_file,exist=exist)
   endif
   if (set%verbose) then
      write(stdout,'(a,1x,a)') &
         "mopac input file           :",ext%input_file,&
         "mopac input present        :",bool2string(exist)
         !"mopac input override       :",bool2string(.not.ext%exist)
   endif

   ! check for the input line
   if (allocated(ext%input_string)) then
      if (index(ext%input_string,'grad') == 0) then
         call env%warning('added grad keyword to mopac input', source)
         ext%input_string = ext%input_string //' grad'
      end if
      if (index(ext%input_string,'charge=') == 0) then
         write(chdum,'(i5)') set%ichrg
         ! add total charge
         ext%input_string = ext%input_string //' charge='//trim(adjustl(chdum))
      endif
      if (set%nalphabeta > 0) then
         if (index(ext%input_string,'uhf') == 0) then
            ! write spin state if necessary
            select case(set%nalphabeta)
            case default ! skip
            case(1); ext%input_string = ext%input_string // ' uhf doublet'
            case(2); ext%input_string = ext%input_string // ' uhf triplet'
            case(3); ext%input_string = ext%input_string // ' uhf quartet'
            case(4); ext%input_string = ext%input_string // ' uhf quintet'
            case(5); ext%input_string = ext%input_string // ' uhf sextet'
            case(6); ext%input_string = ext%input_string // ' uhf septet'
            case(7); ext%input_string = ext%input_string // ' uhf octet'
            end select
         endif
      endif
   else
      ! general input
      ext%input_string = '1scf pm6-d3h4 aux(42,PRECISION=12,MOS=-99999,COMP)'
      ! write spin state if necessary
      select case(set%nalphabeta)
      case default ! skip
      case(1); ext%input_string = ext%input_string // ' uhf doublet'
      case(2); ext%input_string = ext%input_string // ' uhf triplet'
      case(3); ext%input_string = ext%input_string // ' uhf quartet'
      case(4); ext%input_string = ext%input_string // ' uhf quintet'
      case(5); ext%input_string = ext%input_string // ' uhf sextet'
      case(6); ext%input_string = ext%input_string // ' uhf septet'
      case(7); ext%input_string = ext%input_string // ' uhf octet'
      end select
      ! convergence criterium in kcal/mol
      ext%input_string = ext%input_string // &
         ' scfcrt=6.d-5 geo-ok mmok grad xyz charge='
      write(chdum,'(i5)') set%ichrg
      ! add total charge
      ext%input_string = ext%input_string // trim(adjustl(chdum))
   endif
   if (set%verbose) then
      write(stdout,'(a,1x,a)') &
         "mopac input line           :",ext%input_string
   endif

end subroutine checkMopac


!> Create a new calculator for driving the Mopac program
subroutine newMopacCalculator(self, env, ext)
   !> Instance of the Mopac calculator
   type(TMopacCalculator), intent(out) :: self
   !> Calculation environment
   type(TEnvironment), intent(inout) :: env
   !> Settings for the Mopac calculator
   type(qm_external), intent(in) :: ext

   self%ext = ext
   self%threadsafe = .false.
   call checkMopac(env, self%ext)
end subroutine newMopacCalculator


subroutine runMopac(env,ext,nat,at,xyz,energy,gradient,dipole)
   character(len=*), parameter :: source = 'extern_mopac_checkMopac'
   type(TEnvironment), intent(inout) :: env
   type(qm_external), intent(in) :: ext
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: xyz(3,nat)
   real(wp),intent(out) :: energy
   real(wp),intent(out) :: gradient(3,nat)
   real(wp),intent(out) :: dipole(3)

   integer :: i,j,err
   integer :: imopac ! file handle
   logical :: exist
   character(len=:),allocatable :: line
   integer :: num
   real(wp) :: dum(10),edum

   !$omp critical(mopac_lock)
   call open_file(imopac,ext%input_file,'w')
   write(imopac,'(a,/,/)') ext%input_string
   do i = 1, nat
      write(imopac,'(3x,a2,3(f20.14,i5))') &
         toSymbol(at(i)),autoaa*xyz(1,i),1,autoaa*xyz(2,i),1,autoaa*xyz(3,i),1
   enddo
   call close_file(imopac)

   write(stdout,'(72("="))')
   write(stdout,'(1x,"*",1x,a)') &
      "handing control over to mopac..."
   call execute_command_line('exec 2>&1 '//ext%executable//' '// &
                             ext%input_file,exitstat=err)
   if (err.ne.0) then
      call env%error('mopac returned with non-zero exit status, following this',source)
   else
      if (set%verbose) then
         inquire(file=ext%input_file//'.arc',exist=exist)
         if (exist) then
            call open_file(imopac,ext%input_file//'.arc','r')
            print_mopac_output: do
               call getline(imopac,line,iostat=err)
               if (is_iostat_end(err)) exit print_mopac_output
            enddo print_mopac_output
            call close_file(imopac)
         endif
      endif

      write(stdout,'(1x,"*",1x,a)') &
         "regaining control after successful mopac run..."
   endif
   write(stdout,'(72("="))')

   call open_file(imopac,ext%input_file//'.aux','r')
   if (imopac.eq.-1) then
      call env%error("Could not find '"//ext%input_file//".aux'",source)
   else
      read_mopac_output: do
         call getline(imopac,line,iostat=err)
         if (is_iostat_end(err)) then
            call env%error('Could not find gradient in mopac output',source)
         endif
         if (index(line,'HEAT_OF_FORMATION:KCAL/MOL') > 0) then
            call readl(line,dum,num)
            energy = dum(num)*kcaltoau
            cycle read_mopac_output
         endif
         if (index(line,'DIP_VEC:DEBYE') > 0)then
            call readl(line,dum,num)
            dipole(1:3) = dum(2:4)*dtoau
            cycle read_mopac_output
         endif
         if (index(line,'GRADIENTS:KCAL/MOL/ANGSTROM') > 0) then
            read(imopac,*)((gradient(j,i),j=1,3),i=1,nat)
            exit read_mopac_output
         endif
      enddo read_mopac_output
      call close_file(imopac)
      gradient = gradient * kcaltoau / aatoau
   endif
   !$omp end critical (mopac_lock)

end subroutine runMopac


subroutine singlepoint(self, env, mol, chk, printlevel, restart, &
      & energy, gradient, sigma, hlgap, results)
   !> Source of the generated errors
   character(len=*), parameter :: source = 'extern_mopac_singlepoint'
   !> Calculator instance
   class(TMopacCalculator), intent(inout) :: self
   !> Computational environment
   type(TEnvironment), intent(inout) :: env
   !> Molecular structure data
   type(TMolecule), intent(inout) :: mol
   !> Wavefunction data
   type(TRestart), intent(inout) :: chk
   !> Print level for IO
   integer, intent(in) :: printlevel
   !> Restart from previous results
   logical, intent(in) :: restart
   !> Total energy
   real(wp), intent(out) :: energy
   !> Molecular gradient
   real(wp), intent(out) :: gradient(:, :)
   !> Strain derivatives
   real(wp), intent(out) :: sigma(:, :)
   !> HOMO-LUMO gap
   real(wp), intent(out) :: hlgap
   !> Detailed results
   type(scc_results), intent(out) :: results

   integer :: i,ich
   integer :: mode_sp_run = 1
   real(wp) :: efix
   real(wp) :: dipole(3)
   logical :: inmol
   logical, parameter :: ccm = .true.
   logical :: exitRun
   character(len=*),parameter :: outfmt = &
      '(9x,"::",1x,a,f23.12,1x,a,1x,"::")'

   call mol%update

   energy = 0.0_wp
   gradient(:, :) = 0.0_wp
   sigma(:, :) = 0.0_wp
   hlgap = 0.0_wp
   efix = 0.0_wp
   dipole(:) = 0.0_wp

   call runMopac(env,self%ext,mol%n,mol%at,mol%xyz,energy,gradient,dipole)

   call env%check(exitRun)
   if (exitRun) then
      call env%error("Electronic structure method terminated", source)
      return
   end if

   ! ------------------------------------------------------------------------
   !  various external potentials
   call constrain_pot(potset,mol%n,mol%at,mol%xyz,gradient,efix)
   call constrpot   (mol%n,mol%at,mol%xyz,gradient,efix)
   call cavity_egrad(mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (metaset,mol%n,mol%at,mol%xyz,efix,gradient)
   call metadynamic (rmsdset,mol%n,mol%at,mol%xyz,efix,gradient)

   ! ------------------------------------------------------------------------
   !  fixing of certain atoms
   !  print*,abs(efix/etot)
   energy = energy + efix
   results%e_total = energy
   results%gnorm = norm2(gradient)
   results%dipole = dipole
   if (fixset%n.gt.0) then
      do i=1, fixset%n
         !print*,i,fixset%atoms(i)
         gradient(1:3,fixset%atoms(i))=0
      enddo
   endif

   if (printlevel.ge.2) then
      ! start with summary header
      if (.not.set%silent) then
         write(env%unit,'(9x,53(":"))')
         write(env%unit,'(9x,"::",21x,a,21x,"::")') "SUMMARY"
      endif
      write(env%unit,'(9x,53(":"))')
      write(env%unit,outfmt) "total energy      ", results%e_total,"Eh   "
      write(env%unit,outfmt) "gradient norm     ", results%gnorm,  "Eh/a0"
      write(env%unit,outfmt) "HOMO-LUMO gap     ", results%hl_gap, "eV   "
      write(env%unit,'(9x,53(":"))')
      write(env%unit,'(a)')
   endif
end subroutine singlepoint

subroutine writeInfo(self, unit, mol)

   !> Calculator instance
   class(TMopacCalculator), intent(in) :: self

   !> Unit for I/O
   integer, intent(in) :: unit

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   call generic_header(unit,"Mopac driver",49,10)
end subroutine writeInfo


end module xtb_extern_mopac

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_global
   use xtb_type_environment, only : TEnvironment
#ifdef USE_CUSOLVER
   use cublas
   use cusolverDn
#endif
   character(len=:),allocatable :: name  !< name of the currently running program
   character(len=:),allocatable,target :: msgbuffer !< error message buffer
   integer :: msgid !< number of generated errors
   integer :: maxmsg = 100 !< size of error buffer
   logical :: is_release = .false.
   ! set strict to turn all warnings into hard errors
   logical :: strict = .false.
   ! mute the error messages and generate warnings instead
   logical :: mute = .false.
   ! sanity status of the mctc environment, beware if it goes insane
   logical :: good = .true.

   !> Global environment
   type(TEnvironment), allocatable :: persistentEnv
#ifdef USE_CUSOLVER
   type(cuSolverDnHandle) :: cusolverDnH
#endif

   type :: errormsg
      character(len=:),allocatable :: msg
      integer :: len
   endtype errormsg

   type(errormsg),allocatable :: errorbuffer(:)

contains

subroutine init_errorbuffer
   implicit none
   if (allocated(errorbuffer)) deallocate ( errorbuffer )
   allocate ( errorbuffer(maxmsg) )
   msgid = 0
   msgbuffer = ' '
end subroutine init_errorbuffer

end module xtb_mctc_global

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

module test_ptb

   use mctc_env, only: wp
   use mctc_io, only: structure_type, new

   use xtb_type_molecule, only: TMolecule, assignment(=)
   use xtb_test_molstock, only: getMolecule
   use xtb_features, only : get_xtb_feature

   use testdrive, only: new_unittest, unittest_type, error_type, check_ => check, test_failed, skip_test

   implicit none
   private

   real(wp), parameter :: thr = 1.0e-7_wp
   real(wp), parameter :: thr2 = 1.0e-5_wp
   real(wp), parameter :: thr3 = 1.0e-4_wp
   real(wp), parameter :: thr4 = 1.0e-3_wp
   !> Reference implementation of PTB used partially single precision
   !> Numerical derivatives enhance small errors, which is why we need a
   !> higher threshold
   real(wp), parameter :: thr_alpha = 1.0e-1_wp

   public :: collect_ptb

contains

!> Collect all exported unit tests
   subroutine collect_ptb(testsuite)
      !> Collection of tests
      type(unittest_type), allocatable, intent(out) :: testsuite(:)

      testsuite = [ &
#if WITH_TBLITE
                  new_unittest("basis", test_ptb_basis), &
                  new_unittest("eeq", test_ptb_eeq), &
                  new_unittest("overlap", test_ptb_overlap), &
                  new_unittest("overlap_h0", test_ptb_overlap_h0), &
                  new_unittest("overlap_sx", test_ptb_overlap_SX), &
                  new_unittest("v_ecp", test_ptb_V_ECP), &
                  new_unittest("selfenergies", test_ptb_selfenergies), &
                  new_unittest("hamiltonian_h0", test_ptb_hamiltonian_h0), &
                  new_unittest("v_xc", test_ptb_V_XC), &
                  new_unittest("hubbard", test_ptb_hubbard), &
                  new_unittest("coulomb_pot", test_ptb_coulomb_potential), &
                  new_unittest("plus_U_pot", test_ptb_plus_U_potential), &
                  new_unittest("mb16-43-01", test_ptb_mb16_43_01), &
                  new_unittest("mb16-43-01_charged", test_ptb_mb16_43_01_charged), &
                  new_unittest("mb16-43-01_efield", test_ptb_mb16_43_01_efield), &
                  new_unittest("dipole_moment", test_ptb_dipmom_caffeine), &
                  new_unittest("polarizability", test_ptb_polarizability) &
#else
                  new_unittest("ptb_not_present", test_ptb_not_present) &
#endif
                  ]

   end subroutine collect_ptb

#if WITH_TBLITE
   subroutine test_ptb_basis(error)
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use tblite_basis_type, only: basis_type

      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Basis set type
      type(basis_type) :: bas

      integer :: nsh_exp = 11
      integer :: nao_exp = 23
      integer :: maxl_exp = 2

      call getMolecule(struc, "h2o")
      mol = struc

      call add_vDZP_basis(mol, bas)

      call check_(error, bas%nsh, nsh_exp, "Number of shells not matching to expected value.")
      call check_(error, bas%nao, nao_exp, "Number of AOs not matching to expected value.")
      call check_(error, bas%maxl, maxl_exp, "Maximum angular momentum not matching to expected value.")
      call check_(error, bas%cgto(1, 1)%alpha(1), 3.54364182058582_wp, thr=thr)
      call check_(error, bas%cgto(1, 2)%alpha(1), 81.8867808750392_wp, thr=thr)

   end subroutine test_ptb_basis

   subroutine test_ptb_eeq(error)
      use xtb_ptb_param, only: ptbGlobals, initPTB
      use xtb_ptb_ncoord, only: ncoord_erf
      use multicharge_model, only: new_mchrg_model, mchrg_model_type
      use xtb_ptb_data, only: TPTBData

      type(error_type), allocatable, intent(out) :: error
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> EEQ Model
      type(mchrg_model_type) :: eeqmodel
      real(wp), allocatable :: cn_eeq(:)
      integer :: i
      !> EEQ charges
      real(wp), allocatable :: q_eeq(:)

      real(wp), parameter :: q_exp(16) = [ &
      &  0.191209985_wp, &
      &  0.093681828_wp, &
      &  0.013831373_wp, &
      &  0.086328769_wp, &
      &  0.023833233_wp, &
      & -0.024182298_wp, &
      &  0.127341995_wp, &
      & -0.033180774_wp, &
      &  0.195514665_wp, &
      &  0.033261333_wp, &
      &  0.004616166_wp, &
      &  0.478869532_wp, &
      & -0.573638388_wp, &
      & -0.379500359_wp, &
      &  0.060803901_wp, &
      & -0.298790960_wp]

      call getMolecule(struc, "mindless01")
      mol = struc
      allocate (ptbData)
      call initPTB(ptbData, mol%num)
      allocate (cn_eeq(mol%nat))
      call ncoord_erf(mol, ptbGlobals%kerfcn_eeq, 25.0_wp, cn_eeq)
      call new_mchrg_model(eeqmodel, chi=ptbData%eeq%chi, &
      & rad=ptbData%eeq%alp, eta=ptbData%eeq%gam, kcn=ptbData%eeq%cnf)
      allocate (q_eeq(mol%nat))
      call eeqmodel%solve(mol, cn_eeq, qvec=q_eeq)

      do i = 1, mol%nat
         call check_(error, q_eeq(i), q_exp(i), thr=thr, &
         & message="EEQ charge for an atom not matching to expected value.")
      end do

   end subroutine test_ptb_eeq

   subroutine test_ptb_overlap(error)
      use xtb_ptb_integrals, only: get_integrals
      use xtb_ptb_integral_types, only: aux_integral_type, new_aux_integral
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_integral_type, only: integral_type, new_integral
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      use tblite_cutoff, only: get_lattice_points

      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Integral type
      type(integral_type) :: ints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> (Scaled) overlap matrix
      character(len=:), allocatable :: message
      real(wp), parameter :: overlap_exp(6) = [ &
      & 0.93209460_wp, & ! 1,2
      & 0.35489609_wp, & ! 1,3
      & 0.65682608_wp, & ! 2,3
      & 0.05627743_wp, & ! 1,15
      & -0.14217162_wp, &  ! 1,24; diffferent because of tblite ordering
      & 0.41844087_wp] ! 14,23; diffferent because of tblite ordering
      real(wp), allocatable :: lattr(:, :)
      real(wp) :: cutoff

      message = "Overlap matrix element not matching to expected value."

      call getMolecule(struc, "mgh2")
      mol = struc
      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)

      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)

      call new_integral(ints, bas%nao)
      call get_integrals(mol, bas, lattr, list, ints%overlap)
      call check_(error, ints%overlap(1, 2), overlap_exp(1), thr=thr)
      call check_(error, ints%overlap(1, 3), overlap_exp(2), thr=thr)
      call check_(error, ints%overlap(2, 3), overlap_exp(3), thr=thr)
      call check_(error, ints%overlap(1, 15), overlap_exp(4), thr=thr)
      call check_(error, ints%overlap(1, 23), overlap_exp(5), thr=thr)
      call check_(error, ints%overlap(12, 22), overlap_exp(6), thr=thr)

   end subroutine test_ptb_overlap

   subroutine test_ptb_overlap_h0(error)
      use xtb_ptb_integrals, only: get_integrals
      use xtb_ptb_param, only: kalphah0l
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use xtb_ptb_integral_types, only: aux_integral_type, new_aux_integral
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_integral_type, only: integral_type, new_integral
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      use tblite_cutoff, only: get_lattice_points

      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Integral type
      type(integral_type) :: ints
      !> Auxiliary integral type
      type(aux_integral_type) :: auxints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      character(len=:), allocatable :: message
      real(wp), parameter :: overlap_exp(6) = [ &
      & 0.95689468_wp, & ! 1,2
      & 0.39195790_wp, & ! 1,3
      & 0.62961212_wp, & ! 2,3
      & 0.03782850_wp, & ! 1,15
      &-0.13826216_wp, &  ! 1,24; diffferent because of tblite ordering
      & 0.43334922_wp] ! 14,23; diffferent because of tblite ordering
      real(wp), allocatable :: lattr(:, :)
      real(wp) :: cutoff

      message = "Scaled overlap matrix element not matching to expected value."

      call getMolecule(struc, "mgh2")
      mol = struc
      allocate (ptbData)
      call initPTB(ptbData, mol%num)
      call add_vDZP_basis(mol, id_to_atom(mol, ptbData%hamiltonian%kalphah0l), bas)

      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)

      !> set up the basis set for the PTB-Hamiltonian
      call new_integral(ints, bas%nao)
      call new_aux_integral(auxints, bas%nao)
      call get_integrals(mol, bas, lattr, list, auxints%overlap_h0_1)
      call check_(error, auxints%overlap_h0_1(1, 2), overlap_exp(1), thr=thr, &
      & message=message)
      call check_(error, auxints%overlap_h0_1(1, 3), overlap_exp(2), thr=thr, &
      & message=message)
      call check_(error, auxints%overlap_h0_1(2, 3), overlap_exp(3), thr=thr, &
      & message=message)
      call check_(error, auxints%overlap_h0_1(1, 15), overlap_exp(4), thr=thr, &
      & message=message)
      call check_(error, auxints%overlap_h0_1(1, 23), overlap_exp(5), thr=thr, &
      & message=message)
      call check_(error, auxints%overlap_h0_1(12, 22), overlap_exp(6), thr=thr, &
      & message=message)

   end subroutine test_ptb_overlap_h0

   subroutine test_ptb_overlap_SX(error)
      !> PTB dependencies
      use xtb_ptb_integrals, only: get_integrals
      use xtb_ptb_mmlpopanalysis, only: get_mml_overlaps
      use xtb_ptb_param, only: ptbGlobals
      use xtb_ptb_vdzp, only: add_vDZP_basis
      !> tblite dependencies
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_integral_type, only: integral_type, new_integral
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      use tblite_cutoff, only: get_lattice_points

      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Integral type
      type(integral_type) :: ints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Mulliken-Loewdin overlap matrices
      real(wp), allocatable :: overlap_sx(:, :), overlap_oneminusx(:, :)
      character(len=:), allocatable :: message
      real(wp), parameter :: overlap_oneminusx_exp(6) = [ &
      & 0.70788_wp, & ! 1,2
      & 0.16203_wp, & ! 1,3
      & 0.41532_wp, & ! 2,3
      & 0.01449_wp, & ! 1,15
      &-0.07203_wp, &  ! 1,24; diffferent because of tblite ordering
      & 0.28751_wp] ! 14,23; diffferent because of tblite ordering
      real(wp), allocatable :: lattr(:, :)
      real(wp) :: cutoff

      message = "Solved overlap matrix (^(1-x)) element not matching to expected value."

      call getMolecule(struc, "mgh2")
      mol = struc
      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)
      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)

      call new_integral(ints, bas%nao)
      call get_integrals(mol, bas, lattr, list, ints%overlap)
      allocate (overlap_sx(bas%nao, bas%nao), overlap_oneminusx(bas%nao, bas%nao))
      call get_mml_overlaps(bas, ints%overlap, ptbGlobals%mlmix, overlap_sx, &
         & overlap_oneminusx)

      call check_(error, overlap_oneminusx(1, 2), overlap_oneminusx_exp(1), thr=thr2, &
      & message=message)
      call check_(error, overlap_oneminusx(1, 3), overlap_oneminusx_exp(2), thr=thr2, &
      & message=message)
      call check_(error, overlap_oneminusx(2, 3), overlap_oneminusx_exp(3), thr=thr2, &
      & message=message)
      call check_(error, overlap_oneminusx(1, 15), overlap_oneminusx_exp(4), thr=thr2, &
      & message=message)
      call check_(error, overlap_oneminusx(1, 23), overlap_oneminusx_exp(5), thr=thr2, &
      & message=message)
      call check_(error, overlap_oneminusx(12, 22), overlap_oneminusx_exp(6), thr=thr2, &
      & message=message)

   end subroutine test_ptb_overlap_SX

   subroutine test_ptb_V_ECP(error)
      !> tblite dependencies
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_integral_type, only: integral_type, new_integral
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      use tblite_cutoff, only: get_lattice_points
      !> PTB dependencies
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use xtb_ptb_corebasis, only: add_core_basis, get_Vecp
      use xtb_ptb_integrals, only: get_integrals
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB
      use xtb_ptb_integral_types, only: aux_integral_type, new_aux_integral

      !> PTB vDZP basis set and core basis set
      type(basis_type) :: bas, cbas
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Integral type
      type(integral_type) :: ints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Auxiliary integral type
      type(aux_integral_type) :: auxints
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Effective core potential
      real(wp), allocatable :: vecp(:, :)
      type(error_type), allocatable, intent(out) :: error
      character(len=:), allocatable :: message
      real(wp), parameter :: vecp_ref(4) = [ &
      &  0.077719_wp, & ! 1,1 ; diffferent because of tblite ordering
      & -0.059122_wp, & ! 1,3 ; diffferent because of tblite ordering
      &  0.052775_wp, & ! 3,5 ; diffferent because of tblite ordering
      &  0.117176_wp]   ! 9,9 ; diffferent because of tblite ordering
      real(wp), parameter :: xyz(3, 2) = reshape([ &
      & 2.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp], [3, 2])
      integer, parameter :: nat = 2
      integer, parameter :: at(nat) = [5, 17]
      real(wp), allocatable :: lattr(:, :)
      real(wp) :: cutoff

      call new(mol, at, xyz)
      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)

      allocate (ptbData)
      call initPTB(ptbData, mol%num)

      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)

      !> New integrals
      call new_integral(ints, bas%nao)
      call new_aux_integral(auxints, bas%nao)
      !> Add the core basis set to 'cbas' basis set type
      call add_core_basis(mol, ptbData%corepotential, cbas)
      !> -> for normalization factors
      call get_integrals(mol, bas, lattr, list, ints%overlap, norm=auxints%norm)
      !> V_ECP via PTB core basis
      call get_Vecp(mol, ptbData%corepotential, bas, cbas, auxints%norm, vecp)

      message = "V_ecp matrix element not matching to expected value."
      call check_(error, vecp(1, 1), vecp_ref(1), thr=thr2, &
      & message=message)
      call check_(error, vecp(1, 5), vecp_ref(2), thr=thr2, &
      & message=message)
      call check_(error, vecp(5, 8), vecp_ref(3), thr=thr2, &
      & message=message)
      call check_(error, vecp(12, 12), vecp_ref(4), thr=thr2, &
      & message=message)
   end subroutine test_ptb_V_ECP

   subroutine test_ptb_selfenergies(error)
      use tblite_basis_type, only: basis_type
      use xtb_ptb_param, only: initPTB
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_hamiltonian, only: get_selfenergy
      use xtb_ptb_vdzp, only: add_vDZP_basis

      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Basis set type
      type(basis_type) :: bas
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Self-energies
      real(wp), allocatable :: selfenergies(:)
      !> Loop indices
      integer :: i
      real(wp), parameter :: cn_normal(16) = [ &
      &     0.029861202_wp, &
      &     0.000001336_wp, &
      &     0.130180690_wp, &
      &     0.000001491_wp, &
      &     0.045177881_wp, &
      &     0.033255113_wp, &
      &     0.000001968_wp, &
      &     0.092410992_wp, &
      &     0.218995650_wp, &
      &     0.043474970_wp, &
      &     0.032456272_wp, &
      &     0.113876443_wp, &
      &     0.054029961_wp, &
      &     0.186931056_wp, &
      &     0.222153392_wp, &
      &     0.154564877_wp &
      & ]

      real(wp), parameter :: cn_star(16) = [ &
      &     4.180004755_wp, &
      &     0.803964926_wp, &
      &     1.830423819_wp, &
      &     1.291529751_wp, &
      &     1.254518733_wp, &
      &     0.976661010_wp, &
      &     1.524506244_wp, &
      &     1.645124982_wp, &
      &     3.435549964_wp, &
      &     1.012204252_wp, &
      &     1.002889652_wp, &
      &     2.106643916_wp, &
      &     3.669906182_wp, &
      &     3.358227639_wp, &
      &     3.430865101_wp, &
      &     5.328552015_wp &
      & ]

      real(wp), parameter :: selfenergies_exp(69) = [ &
      &    -0.979211416_wp, &
      &    -0.322921123_wp, &
      &    -0.697551918_wp, &
      &    -1.023303502_wp, &
      &    -0.527093446_wp, &
      &    -0.514468061_wp, &
      &    -0.663960241_wp, &
      &    -0.281743767_wp, &
      &    -0.225076174_wp, &
      &    -1.383725200_wp, &
      &    -0.320247843_wp, &
      &    -0.673454332_wp, &
      &    -0.380112291_wp, &
      &    -0.359748390_wp, &
      &    -0.691229491_wp, &
      &    -0.286971656_wp, &
      &    -0.231757459_wp, &
      &    -1.205066048_wp, &
      &    -0.457780964_wp, &
      &    -0.711328979_wp, &
      &    -0.424791274_wp, &
      &    -0.315612564_wp, &
      &    -0.670965339_wp, &
      &    -0.283512863_wp, &
      &    -0.227190530_wp, &
      &    -0.704259715_wp, &
      &    -0.289469733_wp, &
      &    -0.234950020_wp, &
      &    -1.369436961_wp, &
      &    -0.319173701_wp, &
      &    -0.666351872_wp, &
      &    -0.375372836_wp, &
      &    -0.357968581_wp, &
      &    -1.200385286_wp, &
      &    -0.309750483_wp, &
      &    -0.624221535_wp, &
      &    -0.327315414_wp, &
      &    -0.350288899_wp, &
      &    -0.672137693_wp, &
      &    -0.283868580_wp, &
      &    -0.227600095_wp, &
      &    -0.672496043_wp, &
      &    -0.283796084_wp, &
      &    -0.227556008_wp, &
      &    -1.025588207_wp, &
      &    -0.388417755_wp, &
      &    -0.718646241_wp, &
      &    -0.447066846_wp, &
      &    -0.571777637_wp, &
      &    -0.794691589_wp, &
      &    -0.268730643_wp, &
      &    -0.574208389_wp, &
      &    -0.289554304_wp, &
      &    -0.194234001_wp, &
      &    -0.795098088_wp, &
      &    -0.268832436_wp, &
      &    -0.580445264_wp, &
      &    -0.290173217_wp, &
      &    -0.197401138_wp, &
      &    -1.200410535_wp, &
      &    -0.309694149_wp, &
      &    -0.624487718_wp, &
      &    -0.327397806_wp, &
      &    -0.350251414_wp, &
      &    -0.737447660_wp, &
      &    -0.274291608_wp, &
      &    -0.488598371_wp, &
      &    -0.279699675_wp, &
      &    -0.270934337_wp &
      & ]

      call getMolecule(struc, "mindless01")
      mol = struc
      allocate (ptbData)
      call initPTB(ptbData, mol%num)
      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)

      !> Get self-energies
      call get_selfenergy(mol, bas, ptbData%hamiltonian, cn_normal, cn_star, selfenergies)

      do i = 1, size(selfenergies_exp)
         call check_(error, selfenergies(i), selfenergies_exp(i), thr=thr, &
         & message="Self-energies not matching to expected value.")
      end do

   end subroutine test_ptb_selfenergies

   subroutine test_ptb_hamiltonian_h0(error)
      !> tblite basis set type
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_integral_type, only: new_integral, integral_type
      use tblite_cutoff, only: get_lattice_points
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      !> PTB core basis set generation
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use xtb_ptb_integrals, only: get_integrals
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB, ptbGlobals
      use xtb_ptb_integral_types, only: aux_integral_type, new_aux_integral
      use xtb_ptb_hamiltonian, only: get_hamiltonian

      !> PTB vDZP basis set and core basis set
      type(basis_type) :: bas
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Integral type
      type(integral_type) :: ints
      !> Auxiliary integral type
      type(aux_integral_type) :: auxints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Cutoff for lattice points
      real(wp) :: cutoff
      !> Lattice points
      real(wp), allocatable :: lattr(:, :)
      character(len=:), allocatable :: message
      !> Structure
      real(wp), parameter :: xyz(3, 2) = reshape([ &
      & 2.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp], [3, 2])
      integer, parameter :: nat = 2
      integer, parameter :: at(nat) = [5, 17]
      !> Dummy vecp
      real(wp), allocatable :: vecp(:, :)

      real(wp), parameter :: h0_ref(6) = [ &
      &  -1.59330281_wp, & ! 1,1
      &  -2.24996207_wp, & ! 1,2
      &   0.34974782_wp, & ! 1,23 ; diffferent because of tblite ordering
      &   0.0_wp, & ! 7,11 ; different because of tblite ordering
      &  -1.17757007_wp, & ! 3,6 ; different because of tblite ordering
      &   0.48301561_wp]   ! 11,24 ; diffferent because of tblite ordering
      real(wp), parameter :: levels(10) = [ &
      &    -0.796651404_wp, &
      &    -0.269771638_wp, &
      &    -0.593749262_wp, &
      &    -0.292154638_wp, &
      &    -0.204518309_wp, &
      &    -1.022956257_wp, &
      &    -0.356719004_wp, &
      &    -0.736092857_wp, &
      &    -0.464644474_wp, &
      &    -0.572539094_wp]

      call new(mol, at, xyz)
      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)

      allocate (ptbData)
      call initPTB(ptbData, mol%num)

      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)
      call new_integral(ints, bas%nao)
      call new_aux_integral(auxints, bas%nao)
      call get_integrals(mol, lattr, list, auxints%overlap_h0_1, &
         & alpha_scal=id_to_atom(mol, ptbData%hamiltonian%kalphah0l))
      allocate (vecp(bas%nao, bas%nao), source=0.0_wp)

      call get_hamiltonian(mol, list, bas, ptbData%hamiltonian, ptbData%hamiltonian%kla, auxints%overlap_h0_1, &
      & levels, ints%hamiltonian, ptbGlobals%kpol, ptbGlobals%kitr, ptbGlobals%kitocod)
      message = "H0 matrix element not matching to expected value."
      call check_(error, ints%hamiltonian(1, 1), h0_ref(1), thr=thr)
      call check_(error, ints%hamiltonian(1, 2), h0_ref(2), thr=thr)
      call check_(error, ints%hamiltonian(1, 22), h0_ref(3), thr=thr)
      call check_(error, ints%hamiltonian(13, 6), h0_ref(4), thr=thr)
      call check_(error, ints%hamiltonian(8, 5), h0_ref(5), thr=thr)
      call check_(error, ints%hamiltonian(13, 26), h0_ref(6), thr=thr)
   end subroutine test_ptb_hamiltonian_h0

   subroutine test_ptb_V_XC(error)
      !> tblite basis set type
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_integral_type, only: integral_type, new_integral
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      use tblite_cutoff, only: get_lattice_points
      !> PTB core basis set generation
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use xtb_ptb_corebasis, only: add_core_basis, get_Vecp
      !> PTB overlap matrix calculation
      use xtb_ptb_integrals, only: get_integrals
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB
      use xtb_ptb_paulixc, only: calc_Vxc_pauli
      use xtb_ptb_integral_types, only: aux_integral_type, new_aux_integral

      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Integral type
      type(integral_type) :: ints
      !> Auxiliary integral type
      type(aux_integral_type) :: auxints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      character(len=:), allocatable :: message
      real(wp), parameter :: Vxc_ref(4) = [ &
      & -0.92793357_wp, & ! 1,1
      & -0.85981333_wp, & ! 1,2
      &  0.06632750_wp, & ! 1,23 ; diffferent because of tblite ordering
      &  0.00151880_wp]   ! 11,24 ; diffferent because of tblite ordering
      real(wp), parameter :: xyz(3, 2) = reshape([ &
      & 2.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp], [3, 2])
      integer, parameter :: nat = 2
      integer, parameter :: at(nat) = [5, 17]
      !> (Scaled) overlap matrix
      real(wp), allocatable :: Vxc(:, :)
      real(wp), parameter :: shellpops(10) = [ &
      &     0.562668128_wp, &
      &     0.182476968_wp, &
      &     1.714291065_wp, &
      &     0.447798837_wp, &
      &     0.583667232_wp, &
      &     1.180050163_wp, &
      &     0.466096258_wp, &
      &     3.688775422_wp, &
      &     1.071618511_wp, &
      &     0.102557478_wp]
      real(wp), parameter :: levels(10) = [ &
      &    -0.796651404_wp, &
      &    -0.269771638_wp, &
      &    -0.593749262_wp, &
      &    -0.292154638_wp, &
      &    -0.204518309_wp, &
      &    -1.022956257_wp, &
      &    -0.356719004_wp, &
      &    -0.736092857_wp, &
      &    -0.464644474_wp, &
      &    -0.572539094_wp]
      real(wp), allocatable :: lattr(:, :)
      real(wp) :: cutoff

      call new(mol, at, xyz)

      allocate (ptbData)
      call initPTB(ptbData, mol%num)

      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, id_to_atom(mol, ptbData%pauli%klalphaxc), bas)

      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)
      !> New integrals
      call new_integral(ints, bas%nao)
      call new_aux_integral(auxints, bas%nao)
      call get_integrals(mol, bas, lattr, list, auxints%overlap_xc)
      allocate (Vxc(bas%nao, bas%nao), source=0.0_wp)
      call calc_Vxc_pauli(mol, bas, shellpops, auxints%overlap_xc, levels, ptbData%pauli%kxc1, Vxc)

      message = "V_XC matrix element not matching to expected value."
      call check_(error, Vxc(1, 1), Vxc_ref(1), thr=thr, &
      & message=message)
      call check_(error, Vxc(1, 2), Vxc_ref(2), thr=thr, &
      & message=message)
      call check_(error, Vxc(1, 22), Vxc_ref(3), thr=thr, &
      & message=message)
      call check_(error, Vxc(13, 26), Vxc_ref(4), thr=thr, &
      & message=message)

   end subroutine test_ptb_V_XC

   subroutine test_ptb_hubbard(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB
      use xtb_ptb_coulomb, only: coulomb_potential
      use xtb_ptb_vdzp, only: add_vDZP_basis
      !> tblite basis set type
      use tblite_basis_type, only: basis_type

      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Coulomb potential
      type(coulomb_potential) :: coulomb
      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      integer :: iat, ish, ii

      real(wp), parameter :: q(16) = [ &
      &     0.191209985_wp, &
      &     0.093681828_wp, &
      &     0.013831373_wp, &
      &     0.086328769_wp, &
      &     0.023833233_wp, &
      &    -0.024182298_wp, &
      &     0.127341995_wp, &
      &    -0.033180774_wp, &
      &     0.195514665_wp, &
      &     0.033261333_wp, &
      &     0.004616166_wp, &
      &     0.478869532_wp, &
      &    -0.573638388_wp, &
      &    -0.379500359_wp, &
      &     0.060803901_wp, &
      &    -0.298790960_wp]

      real(wp), parameter :: gam_ref(69) = [ &
      &     0.572444634_wp, &
      &     0.174965574_wp, &
      &     0.278145596_wp, &
      &     0.398307229_wp, &
      &     0.140308229_wp, &
      &     0.071711282_wp, &
      &     0.699475104_wp, &
      &     0.013446193_wp, &
      &     1.442753158_wp, &
      &     0.288724569_wp, &
      &     0.503017753_wp, &
      &     0.756666283_wp, &
      &     0.576968584_wp, &
      &     1.661483681_wp, &
      &     0.698218709_wp, &
      &     0.013422041_wp, &
      &     1.440161689_wp, &
      &     0.227163646_wp, &
      &     3.918675421_wp, &
      &     0.645967076_wp, &
      &     0.871429742_wp, &
      &     1.585273418_wp, &
      &     0.679336015_wp, &
      &     0.013059054_wp, &
      &     1.401213818_wp, &
      &     0.705226516_wp, &
      &     0.013556754_wp, &
      &     1.454616149_wp, &
      &     0.285342872_wp, &
      &     0.497126139_wp, &
      &     0.747803801_wp, &
      &     0.570210818_wp, &
      &     1.642023493_wp, &
      &     0.208808961_wp, &
      &     0.276840832_wp, &
      &     0.652246415_wp, &
      &     0.299293868_wp, &
      &     0.853512542_wp, &
      &     0.689151236_wp, &
      &     0.013247734_wp, &
      &     1.421458914_wp, &
      &     0.684256722_wp, &
      &     0.013153646_wp, &
      &     1.411363380_wp, &
      &    11.195497673_wp, &
      &     0.011092823_wp, &
      &     0.414254987_wp, &
      &     0.324375967_wp, &
      &     0.072787435_wp, &
      &     0.332654683_wp, &
      &     0.007146331_wp, &
      &     0.772424282_wp, &
      &     0.025798653_wp, &
      &     1.373674042_wp, &
      &     0.351502934_wp, &
      &     0.007551243_wp, &
      &     0.816189927_wp, &
      &     0.027260407_wp, &
      &     1.451506566_wp, &
      &     0.202104465_wp, &
      &     0.267951949_wp, &
      &     0.631303903_wp, &
      &     0.289684057_wp, &
      &     0.826107721_wp, &
      &     3.596643423_wp, &
      &     0.007302541_wp, &
      &     0.215477130_wp, &
      &     0.082115458_wp, &
      &     1.009534102_wp]

      call getMolecule(struc, "mindless01")
      mol = struc
      allocate (ptbData)
      call initPTB(ptbData, mol%num)

      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)
      call coulomb%init(mol, bas, q, ptbData%coulomb%shellHardnessFirstIter, &
      & ptbData%coulomb%kQHubbard, ptbData%coulomb%kOK1, ptbData%coulomb%kTO)

      !> Check the shell gammas
      ii = 0
      do iat = 1, mol%nat
         do ish = 1, bas%nsh_at(iat)
            ii = ii + 1
            call check_(error, coulomb%gam(ish, iat), gam_ref(ii), thr=thr2)
         end do
      end do

      !> Check the Hubbard matrix
      call check_(error, coulomb%hubbard(4, 5, 12, 16), 0.490990522465014_wp, thr=thr2)
      call check_(error, coulomb%hubbard(1, 2, 6, 9), 0.393374820246109_wp, thr=thr2)

   end subroutine test_ptb_hubbard

   subroutine test_ptb_coulomb_potential(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB
      use xtb_ptb_coulomb, only: coulomb_potential
      use xtb_ptb_vdzp, only: add_vDZP_basis
      use xtb_ptb_guess, only: guess_qsh
      use xtb_ptb_hamiltonian, only: get_occupation
      use xtb_ptb_integrals, only: get_integrals
      !> tblite basis set type
      use tblite_basis_type, only: basis_type, get_cutoff
      use tblite_wavefunction, only: wavefunction_type, new_wavefunction
      use tblite_scf_potential, only: potential_type, new_potential, add_pot_to_h1
      use tblite_integral_type, only: integral_type, new_integral
      use tblite_adjlist, only: adjacency_list, new_adjacency_list
      use tblite_cutoff, only: get_lattice_points

      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> Coulomb potential
      type(coulomb_potential) :: coulomb
      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Wavefunction data
      type(wavefunction_type) :: wfn
      !> Potential type
      type(potential_type) :: pot
      !> Integral type
      type(integral_type) :: ints
      !> Adjacency list
      type(adjacency_list) :: list
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      real(wp), parameter :: q(3) = [ &
      &    0.42739211_wp, &
      &    -0.21369606_wp, &
      &    -0.21369606_wp]
      !> Conversion factor from temperature to energy
      real(wp), parameter :: kt = 3.166808578545117e-06_wp
      real(wp), parameter :: coulomb_pot_ref(4) = [ &
      &  -0.05693153_wp, & ! 1,1
      &  -0.33917531_wp, & ! 1,2
      &  -0.00539212_wp, & ! 1,21 ; diffferent because of tblite ordering
      &   0.01305793_wp]   ! 6,24 ; diffferent because of tblite ordering
      real(wp), allocatable :: lattr(:, :)
      real(wp) :: cutoff

      call getMolecule(struc, "mgh2")
      mol = struc
      allocate (ptbData)
      call initPTB(ptbData, mol%num)

      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)
      !> Get the cutoff for the lattice points
      cutoff = get_cutoff(bas)
      call get_lattice_points(mol%periodic, mol%lattice, cutoff, lattr)
      !> Get the adjacency list for iteration through the Hamiltonian
      call new_adjacency_list(list, mol, lattr, cutoff)
      !> New integrals
      call new_integral(ints, bas%nao)
      call get_integrals(mol, bas, lattr, list, ints%overlap)

      call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, &
         & nspin=1, kt=300.0_wp * kt)
      call new_potential(pot, mol, bas, wfn%nspin)
      call pot%reset()

      wfn%qat(:, 1) = q
      !> Project reference occupation on wavefunction and use EEQ charges as guess
      call get_occupation(mol, bas, ptbData%hamiltonian%refocc, wfn%nocc, wfn%n0at, wfn%n0sh)
      call guess_qsh(wfn, bas)

      call coulomb%init(mol, bas, wfn%qat(:, 1), ptbData%coulomb%shellHardnessFirstIter, &
      & ptbData%coulomb%kQHubbard, ptbData%coulomb%kOK1, ptbData%coulomb%kTO)
      call coulomb%update(mol, bas)
      call coulomb%get_potential(wfn, pot)
      ints%hamiltonian = 0.0_wp
      call add_pot_to_h1(bas, ints, pot, wfn%coeff)

      call check_(error, wfn%coeff(1, 1, 1), coulomb_pot_ref(1), thr=thr)
      call check_(error, wfn%coeff(1, 2, 1), coulomb_pot_ref(2), thr=thr)
      call check_(error, wfn%coeff(1, 21, 1), coulomb_pot_ref(3), thr=thr)
      call check_(error, wfn%coeff(5, 23, 1), coulomb_pot_ref(4), thr=thr)

   end subroutine test_ptb_coulomb_potential

   subroutine test_ptb_plus_U_potential(error)

      !> xtb-ptb lib
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_param, only: initPTB
      use xtb_ptb_plusu, only: plusu_potential_type
      use xtb_ptb_vdzp, only: add_vDZP_basis
      !> tblite lib
      use tblite_basis_type, only: basis_type
      use tblite_wavefunction, only: wavefunction_type, new_wavefunction
      use tblite_scf_potential, only: potential_type, new_potential, add_pot_to_h1

      !> Structure type (mctc-lib)
      type(structure_type) :: mol
      !> PTB vDZP basis set
      type(basis_type) :: bas
      !> Wavefunction data
      type(wavefunction_type) :: wfn
      !> Parametrisation data base
      type(TPTBData), allocatable :: ptbData
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> +U potential
      type(plusu_potential_type) :: plusu
      real(wp), parameter :: q(2) = [ &
         &   -1.1113011_wp, &
         &    1.1113086_wp &
         & ]
      real(wp), parameter :: cn(2) = [ &
         &    0.9397642_wp, &
         &    0.9397642_wp &
         & ]
      !> Conversion factor from temperature to energy
      real(wp), parameter :: kt = 3.166808578545117e-06_wp
      real(wp), parameter :: xyz(3, 2) = reshape([ &
      & 2.0_wp, 0.0_wp, 0.0_wp, &
      & 0.0_wp, 0.0_wp, 0.0_wp], [3, 2])
      integer, parameter :: nat = 2
      integer, parameter :: at(nat) = [5, 17]
      real(wp), parameter :: plusU_pot_ref(4) = [ &
      &  -0.0023185_wp, & ! 1,1
      &  -0.0018289_wp, & ! 1,2
      &  -0.5266562_wp, & ! 1,21 ; diffferent because of tblite ordering
      &  -1.6745659_wp]   ! 6,24 ; diffferent because of tblite ordering

      call new(mol, at, xyz)
      allocate (ptbData)
      call initPTB(ptbData, mol%num)

      !> set up the basis set for the PTB-Hamiltonian
      call add_vDZP_basis(mol, bas)
      call new_wavefunction(wfn, mol%nat, bas%nsh, bas%nao, &
         & nspin=1, kt=300.0_wp * kt)

      wfn%density = 2.0_wp
      wfn%coeff = 0.0_wp
      wfn%qat(:, 1) = q
      call plusu%init(ptbData%plusU, mol, bas, wfn%qat(:, 1), cn)
      call plusu%get_potential(mol, bas, wfn%density(:, :, 1), wfn%coeff(:, :, 1))

      call check_(error, wfn%coeff(1, 1, 1), plusU_pot_ref(1), thr=thr)
      call check_(error, wfn%coeff(1, 2, 1), plusU_pot_ref(2), thr=thr)
      call check_(error, wfn%coeff(1, 20, 1), plusU_pot_ref(3), thr=thr)
      call check_(error, wfn%coeff(8, 26, 1), plusU_pot_ref(4), thr=thr)

   end subroutine test_ptb_plus_U_potential

   subroutine test_ptb_mb16_43_01(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_calculator, only: TPTBCalculator, newPTBcalculator
      use xtb_ptb_guess, only: get_psh_from_qsh
      !> tblite lib
      use xtb_type_environment, only: TEnvironment, init
      use xtb_type_calculator, only: TCalculator
      use xtb_type_restart, only: TRestart
      use xtb_type_data, only: scc_results

      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Generic calculator class
      class(TCalculator), allocatable :: calc
      !> PTB calculator class
      type(TPTBCalculator), allocatable :: ptb, ptb_save
      !> Environment type
      type(TEnvironment) :: env
      !> Restart type
      type(TRestart) :: chk
      !> Calculation results
      type(scc_results) :: res
      !> variables that are needed for calc%singlepoint but useless for PTB
      real(wp) :: energy, gap
      real(wp), allocatable :: gradient(:, :)
      real(wp) :: sigma(3, 3)
      integer :: iat, ish
      !> PTB shell populations
      real(wp), allocatable :: psh(:, :)
      !> PTB reference atomic charges of MB16-43-01
      real(wp), parameter :: q_ref(16) = [ &
         &     0.68170445_wp, &
         &    -0.02179514_wp, &
         &    -0.39271375_wp, &
         &    -0.04860209_wp, &
         &    -0.16998965_wp, &
         &     0.05243959_wp, &
         &    -0.02162296_wp, &
         &    -0.27122167_wp, &
         &    -0.10233830_wp, &
         &     0.05425879_wp, &
         &     0.06345147_wp, &
         &     0.18291012_wp, &
         &    -0.23545020_wp, &
         &    -0.17286158_wp, &
         &     0.01710696_wp, &
         &     0.38467781_wp &
         & ]
      !> PTB reference shell populations of Na atom in MB16-43-01
      real(wp), parameter :: psh_ref(6) = [ &
         &     1.42836761_wp, &
         &     0.55988306_wp, &
         &     0.07385892_wp, &
         &     5.16059363_wp, &
         &     0.86661109_wp, &
         &     0.22898123_wp &
         & ]
      !> PTB reference WBOs of MB16-43-01
      real(wp), parameter :: wbo_ref(2) = [ &
         & 0.616933710808355_wp, &
         & 0.608892999962882_wp &
         & ]

      !> Initialize calculation environment
      call init(env)

      call getMolecule(struc, "mindless01")

      allocate (ptb, ptb_save)
      call newPTBCalculator(env, struc, ptb)
      ptb_save = ptb
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      allocate (gradient(3, struc%n), source=0.0_wp)
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)
      allocate (psh(ptb_save%bas%nsh, chk%tblite%nspin), source=0.0_wp)
      psh = get_psh_from_qsh(chk%tblite, ptb_save%bas)

      do iat = 1, struc%n
         call check_(error, chk%wfn%q(iat), q_ref(iat), thr=thr2)
      end do
      do ish = 1, ptb_save%bas%nsh_at(1)
         call check_(error, psh(ish, 1), psh_ref(ish), thr=thr2)
      end do
      call check_(error, chk%wfn%wbo(16, 12), wbo_ref(1), thr=thr2)
      call check_(error, chk%wfn%wbo(13, 12), wbo_ref(2), thr=thr2)

   end subroutine test_ptb_mb16_43_01

   subroutine test_ptb_mb16_43_01_charged(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_calculator, only: TPTBCalculator, newPTBcalculator
      use xtb_ptb_guess, only: get_psh_from_qsh
      !> tblite lib
      use xtb_type_environment, only: TEnvironment, init
      use xtb_type_calculator, only: TCalculator
      use xtb_type_restart, only: TRestart
      use xtb_type_data, only: scc_results

      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Generic calculator class
      class(TCalculator), allocatable :: calc
      !> PTB calculator class
      type(TPTBCalculator), allocatable :: ptb, ptb_save
      !> Environment type
      type(TEnvironment) :: env
      !> Restart type
      type(TRestart) :: chk
      !> Calculation results
      type(scc_results) :: res
      !> variables that are needed for calc%singlepoint but useless for PTB
      real(wp) :: energy, gap
      real(wp), allocatable :: gradient(:, :)
      real(wp) :: sigma(3, 3)
      integer :: iat, ish
      !> PTB shell populations
      real(wp), allocatable :: psh(:, :)
      !> PTB reference atomic charges of MB16-43-01
      real(wp), parameter :: q_ref(16) = [ &
         &     0.77426386_wp, &
         &     0.26649239_wp, &
         &     0.30837190_wp, &
         &     0.03983377_wp, &
         &    -0.11302422_wp, &
         &     0.11155364_wp, &
         &    -0.00620840_wp, &
         &    -0.21730028_wp, &
         &    -0.44619143_wp, &
         &     0.10306089_wp, &
         &     0.12243405_wp, &
         &     0.39382297_wp, &
         &     0.21994776_wp, &
         &    -0.01642522_wp, &
         &     0.07058748_wp, &
         &     0.38873424_wp &
         & ]
      !> PTB reference shell populations of Na atom in MB16-43-01
      real(wp), parameter :: psh_ref(6) = [ &
         &     1.42766702_wp, &
         &     0.56155699_wp, &
         &     0.03990374_wp, &
         &     5.16610789_wp, &
         &     0.85170540_wp, &
         &     0.17879509_wp &
         & ]
      !> PTB reference WBOs of MB16-43-01
      real(wp), parameter :: wbo_ref(2) = [ &
         & 0.772617695042871_wp, &
         & 0.526583157894007_wp &
         & ]

      !> Initialize calculation environment
      call init(env)

      call getMolecule(struc, "mindless01")
      struc%chrg = 2.0_wp

      allocate (ptb, ptb_save)
      call newPTBCalculator(env, struc, ptb)
      ptb_save = ptb
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      allocate (gradient(3, struc%n), source=0.0_wp)
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)
      allocate (psh(ptb_save%bas%nsh, chk%tblite%nspin), source=0.0_wp)
      psh = get_psh_from_qsh(chk%tblite, ptb_save%bas)

      do iat = 1, struc%n
         call check_(error, chk%wfn%q(iat), q_ref(iat), thr=thr3)
      end do
      do ish = 1, ptb_save%bas%nsh_at(1)
         call check_(error, psh(ish, 1), psh_ref(ish), thr=thr3)
      end do
      call check_(error, chk%wfn%wbo(16, 12), wbo_ref(1), thr=thr3)
      call check_(error, chk%wfn%wbo(13, 12), wbo_ref(2), thr=thr3)

   end subroutine test_ptb_mb16_43_01_charged

   subroutine test_ptb_mb16_43_01_efield(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_data, only: TPTBData
      use xtb_ptb_calculator, only: TPTBCalculator, newPTBcalculator
      use xtb_ptb_guess, only: get_psh_from_qsh
      !> xtb lib
      use xtb_type_environment, only: TEnvironment, init
      use xtb_type_calculator, only: TCalculator
      use xtb_type_restart, only: TRestart
      use xtb_type_data, only: scc_results
      use xtb_setparam

      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Generic calculator class
      class(TCalculator), allocatable :: calc
      !> PTB calculator class
      type(TPTBCalculator), allocatable :: ptb, ptb_save
      !> Environment type
      type(TEnvironment) :: env
      !> Restart type
      type(TRestart) :: chk
      !> Calculation results
      type(scc_results) :: res
      !> variables that are needed for calc%singlepoint but useless for PTB
      real(wp) :: energy, gap
      real(wp), allocatable :: gradient(:, :)
      real(wp) :: sigma(3, 3)
      integer :: iat, ish
      !> PTB shell populations
      real(wp), allocatable :: psh(:, :)
      !> PTB reference atomic charges of MB16-43-01
      real(wp), parameter :: q_ref(16) = [ &
         &    -1.87083162_wp, &
         &    -3.61266413_wp, &
         &     5.08098387_wp, &
         &    -3.30344743_wp, &
         &     6.89679486_wp, &
         &     0.00416323_wp, &
         &    -0.24406779_wp, &
         &     3.84145983_wp, &
         &     2.70491922_wp, &
         &     0.41943598_wp, &
         &     0.78384251_wp, &
         &   -11.00332421_wp, &
         &    -4.96965395_wp, &
         &     2.25944041_wp, &
         &     2.46367706_wp, &
         &     0.54923654_wp &
         & ]
      !> PTB reference shell populations of Na atom in MB16-43-01
      real(wp), parameter :: psh_ref(6) = [ &
         &     1.45512176_wp, &
         &     0.57954907_wp, &
         &     0.65686184_wp, &
         &     5.17897618_wp, &
         &     0.99362525_wp, &
         &     2.00669752_wp &
         & ]
      !> PTB reference WBOs of MB16-43-01
      real(wp), parameter :: wbo_ref(2) = [ &
         & 0.839744207773282_wp, &
         & 1.31529170060079_wp &
         & ]
      set%efield(1) = 0.0_wp
      set%efield(2) = 0.1_wp
      set%efield(3) = 0.3_wp

      !> Initialize calculation environment
      call init(env)

      call getMolecule(struc, "mindless01")

      allocate (ptb, ptb_save)
      call newPTBCalculator(env, struc, ptb)
      ptb_save = ptb
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      allocate (gradient(3, struc%n), source=0.0_wp)
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)
      allocate (psh(ptb_save%bas%nsh, chk%tblite%nspin), source=0.0_wp)
      psh = get_psh_from_qsh(chk%tblite, ptb_save%bas)

      do iat = 1, struc%n
         call check_(error, chk%wfn%q(iat), q_ref(iat), thr=thr3)
      end do
      do ish = 1, ptb_save%bas%nsh_at(1)
         call check_(error, psh(ish, 1), psh_ref(ish), thr=thr3)
      end do
      call check_(error, chk%wfn%wbo(16, 12), wbo_ref(1), thr=thr3)
      call check_(error, chk%wfn%wbo(13, 12), wbo_ref(2), thr=thr3)
      set%efield = 0.0_wp

   end subroutine test_ptb_mb16_43_01_efield

   subroutine test_ptb_dipmom_caffeine(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_calculator, only: TPTBCalculator, newPTBcalculator
      !> xtb lib
      use xtb_type_environment, only: TEnvironment, init
      use xtb_type_calculator, only: TCalculator
      use xtb_type_restart, only: TRestart
      use xtb_type_data, only: scc_results
      use xtb_setparam

      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Generic calculator class
      class(TCalculator), allocatable :: calc
      !> PTB calculator class
      type(TPTBCalculator), allocatable :: ptb
      !> Environment type
      type(TEnvironment) :: env
      !> Restart type
      type(TRestart) :: chk
      !> Calculation results
      type(scc_results) :: res
      !> variables that are needed for calc%singlepoint but useless for PTB
      real(wp) :: energy, gap
      real(wp), allocatable :: gradient(:, :)
      real(wp) :: sigma(3, 3)
      real(wp), parameter :: dipmom_ref(3) = [ &
         & -1.029811_wp, &
         & 1.487256_wp, &
         & 0.005426_wp &
         & ]
      real(wp), parameter :: dipmom_anion_ref(3) = [ &
         & -14.460494, &
         & 6.045541, &
         & 0.284856 &
         & ]
      real(wp), parameter :: dipmom_efield_ref(3) = [ &
         & -6.754478, &
         & 80.047721, &
         & 26.646085 &
         & ]
      integer :: i

      !> Initialize calculation environment
      call init(env)

      call getMolecule(struc, "caffeine")

      !> Neutral
      allocate (ptb)
      call newPTBCalculator(env, struc, ptb)
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      allocate (gradient(3, struc%n), source=0.0_wp)
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)
      do i = 1, 3
         call check_(error, res%dipole(i), dipmom_ref(i), thr=thr2)
      end do
      deallocate (calc)

      !> Now with anion
      struc%chrg = -2.0_wp
      allocate (ptb)
      call newPTBCalculator(env, struc, ptb)
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      gradient = 0.0_wp
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)
      do i = 1, 3
         call check_(error, res%dipole(i), dipmom_anion_ref(i), thr=thr2)
      end do
      deallocate (calc)
      struc%chrg = 0.0_wp

      !> Now with electric field
      set%efield(1) = 0.0_wp
      set%efield(2) = 0.1_wp
      set%efield(3) = 0.3_wp
      allocate (ptb)
      call newPTBCalculator(env, struc, ptb)
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      gradient = 0.0_wp
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)
      do i = 1, 3
         call check_(error, res%dipole(i), dipmom_efield_ref(i), thr=thr4)
      end do
      deallocate (calc)
      set%efield = 0.0_wp

   end subroutine test_ptb_dipmom_caffeine

   subroutine test_ptb_polarizability(error)
      !> PTB overlap matrix calculation
      use xtb_ptb_calculator, only: TPTBCalculator, newPTBcalculator
      !> xtb lib
      use xtb_type_environment, only: TEnvironment, init
      use xtb_type_calculator, only: TCalculator
      use xtb_type_restart, only: TRestart
      use xtb_type_data, only: scc_results
      use xtb_setparam

      !> Error type
      type(error_type), allocatable, intent(out) :: error
      !> Structure type (xtb)
      type(TMolecule) :: struc
      !> Generic calculator class
      class(TCalculator), allocatable :: calc
      !> PTB calculator class
      type(TPTBCalculator), allocatable :: ptb
      !> Environment type
      type(TEnvironment) :: env
      !> Restart type
      type(TRestart) :: chk
      !> Calculation results
      type(scc_results) :: res
      !> variables that are needed for calc%singlepoint but useless for PTB
      real(wp) :: energy, gap
      real(wp), allocatable :: gradient(:, :)
      real(wp) :: sigma(3, 3)
      real(wp), parameter :: alpha_ref(6) = [ &
      & 88.369115_wp, &
      &  0.006262_wp, &
      & 89.779851_wp, &
      & -0.002677_wp, &
      &  0.000768_wp, &
      & 99.524132_wp &
      & ]

      set%elprop = p_elprop_alpha
      !> Initialize calculation environment
      call init(env)

      call getMolecule(struc, "feco5")

      allocate (ptb)
      call newPTBCalculator(env, struc, ptb)
      call move_alloc(ptb, calc)

      gap = 0.0_wp
      allocate (gradient(3, struc%n), source=0.0_wp)
      call calc%singlepoint(env, struc, chk, 2, .false., energy, gradient, sigma, &
         & gap, res)

      call check_(error, res%alpha(1, 1), alpha_ref(1), thr=thr_alpha)
      call check_(error, res%alpha(1, 2), alpha_ref(2), thr=thr_alpha)
      call check_(error, res%alpha(2, 2), alpha_ref(3), thr=thr_alpha)
      call check_(error, res%alpha(1, 3), alpha_ref(4), thr=thr_alpha)
      call check_(error, res%alpha(2, 3), alpha_ref(5), thr=thr_alpha)
      call check_(error, res%alpha(3, 3), alpha_ref(6), thr=thr_alpha)
      set%elprop = p_elprop_dipole

   end subroutine test_ptb_polarizability

   pure function id_to_atom(mol, idparam) result(atomparam)
      !> Molecular structure data
      type(structure_type), intent(in) :: mol
      !> PTB parameterization data for each species
      real(wp), intent(in) :: idparam(:, :)
      !> PTB parameterization data for each atom
      real(wp), allocatable :: atomparam(:, :)

      integer :: iat, iid

      allocate (atomparam(size(idparam, 1), mol%nat), source=0.0_wp)
      do iat = 1, mol%nat
         iid = mol%id(iat)
         atomparam(:, iat) = idparam(:, iid)
      end do

   end function id_to_atom
#else
   subroutine test_ptb_not_present(error)
      !> Error type
      type(error_type), allocatable, intent(out) :: error
      if (.not. get_xtb_feature('tblite')) then
         call skip_test(error, "xtb not compiled with tblite support")
         return
      end if
   end subroutine test_ptb_not_present

#endif
end module test_ptb

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_aoparam
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   use xtb_mctc_param, only: pauling_en, covalent_radius_2010, chemical_hardness, &
      &                  covalent_radius_d3
   use xtb_type_param, only : TxTBParameter
   implicit none
   private

   integer, public, parameter :: max_elem = 118
   integer, public, parameter :: max_sh = 10
   type, public :: tb_parameter
      real(wp) :: en = 1.50_wp
      real(wp) :: mc = 0.0_wp
      real(wp) :: rad = 0.0_wp
      real(wp) :: gam = 0.0_wp
      real(wp) :: gam3 = 0.0_wp
      real(wp) :: alp0 = 0.0_wp
      real(wp) :: wll(max_sh) = 0.0_wp
      real(wp) :: rep(2) = 0.0_wp
      real(wp) :: polyr(4) = 0.0_wp
      real(wp) :: cxb = 0.0_wp
      real(wp) :: ao_exp(max_sh) = 0.0_wp
      real(wp) :: ao_lev(max_sh) = 0.0_wp
      real(wp) :: lpar(0:2) = 0.0_wp
      real(wp) :: kcnat(0:2) = 0.0_wp
      real(wp) :: kqat(3) = 0.0_wp
      real(wp) :: radaes = 5.0_wp
      real(wp) :: dpolc = 0.0_wp
      real(wp) :: qpolc = 0.0_wp
      integer  :: ao_pqn(max_sh) = 0
      integer  :: ao_l(max_sh) = 0
      integer  :: ao_n = 0
      integer  :: ao_typ(max_sh) = 0
      integer  :: metal = 0
      integer  :: cnval = 0
      character(len=30) :: timestp='------------------------------'
   end type tb_parameter

   character, parameter :: flag = '$'
   character, parameter :: space = ' '
   character, parameter :: equal = '='
   character, parameter :: hash = '#'
   character, parameter :: dot = '.'
   character(len=*), parameter :: flag_end = '$end'

   real(wp), public :: en(max_elem) = pauling_en
   real(wp), public :: mc(max_elem)
   real(wp), public :: rad(max_elem) = covalent_radius_2010 * autoaa
   real(wp), public :: gam(max_elem) = chemical_hardness
   real(wp), public :: gam3(max_elem)
   real(wp), public :: alp0(max_elem)
   real(wp), public :: wll(max_elem,10)
   real(wp), public :: rep(2,max_elem)
   real(wp), public :: polyr(4,max_elem)
   real(wp), public :: cxb(max_elem)
   real(wp), public :: eeqkcn(max_elem)
   real(wp), public :: kqat2(max_elem)
   real(wp), public :: ao_exp(10,max_elem)
   real(wp), public :: ao_lev(10,max_elem)
   real(wp), public :: lpar(0:2,max_elem)
   real(wp), public :: kpair(max_elem,max_elem)
   real(wp), public :: kcnat(0:2,max_elem)
   real(wp), public :: kqat(3,max_elem)
   real(wp), public :: radaes(max_elem) = covalent_radius_d3
   real(wp), public :: eeqEN(max_elem)
   real(wp), public :: dpolc(max_elem)
   real(wp), public :: qpolc(max_elem)
   integer, public  :: ao_pqn(10,max_elem)
   integer, public  :: ao_l(10,max_elem)
   integer, public  :: ao_n(max_elem)
   integer, public  :: ao_typ(10,max_elem)
   integer, public  :: metal(max_elem)
   integer, public  :: cnval(max_elem)
   character(len=30), public :: timestp(max_elem)

   data metal / &
   &  0,                                                 0, &! H-He
   &  1, 1,                               1, 0, 0, 0, 0, 0, &! Li-Ne
   &  1, 1,                               1, 0, 0, 0, 0, 0, &! Na-Ar
   &  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, &! K-Kr
   &  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, &! Rb-Xe
   &  1, 1, &! Cs/Ba
   &        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, &!La-Lu
   &        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, &! Lu-Rn
   &  1, 1, &
   &        1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, &!Fr-
   &        1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0 /! -Og

      data    cnval   / & ! normal CN used in CN dep. AES damping
     & 1,                                                             1, &
     & 1, 2,                                           3, 3, 3, 2, 1, 1, &
     & 1, 2,                                           3, 3, 3, 3, 1, 1, &
     & 1, 2, 4,          4, 6, 6, 6, 6, 6, 4, 4,  2,   3, 3, 3, 3, 1, 1, &
     & 1, 2, 4,          4, 6, 6, 6, 6, 6, 4, 4,  2,   3, 3, 3, 3, 1, 1, &
     & 1, 2, 4,14*6,     4, 6, 6, 6, 6, 6, 4, 4,  2,   3, 3, 3, 3, 1, 1, &
     & 2*0, 14*0, 10*0, 6*0 /

contains


end module xtb_aoparam

! This file is part of the dipro module in xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Helper routines to for output generation
module xtb_dipro_output
   implicit none
   private

   public :: format_list, to_string

contains

!> Format a list of logicals as integer ranges
function format_list(list, default, delimiter, skip) result(string)
   !> Generated string representation of the list
   character(len=:), allocatable :: string
   !> Actual list to format as string
   logical, intent(in) :: list(:)
   !> Default value of the list
   logical, intent(in), optional :: default
   !> Delimiter between two ranges
   character(len=*), intent(in), optional :: delimiter
   !> Symbol to represent skipping integers in a range
   character(len=*), intent(in), optional :: skip

   integer :: i, last
   logical :: state, first
   logical :: default_
   character(len=:), allocatable :: delimiter_
   character(len=:), allocatable :: skip_

   if (present(default)) then
      default_ = default
   else
      default_ = .false.
   end if
   if (present(delimiter)) then
      delimiter_ = delimiter
   else
      delimiter_ = ", "
   end if
   if (present(skip)) then
      skip_ = skip
   else
      skip_ = "-"
   end if

   last = -1
   first = .true.
   state = .not.default_
   do i = 1, size(list)
      if (state.eqv.list(i)) then
         state = .not.state
         if (state.eqv.default_) then
            last = i
            if (first) then
               first = .false.
               string = to_string(i)
            else
               string = string // delimiter_ // to_string(i)
            endif
         else
            if (i-1 .ne. last) then
               string = string // skip_ // to_string(i-1)
            endif
         endif
      endif
   enddo
   if (state.eqv.default_ .and.last.ne.size(list)) then
      string = string // skip_ // to_string(size(list))
   endif
end function format_list

!> Format an integer as string without using internal IO
pure function to_string(val) result(string)
   !> Integer value to format
   integer, intent(in) :: val
   !> Resulting string representation
   character(len=:), allocatable :: string

   character(len=1), parameter :: numbers(0:9) = &
      ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9"]
   integer, parameter :: buffer_len = range(val)+2
   character(len=buffer_len) :: buffer
   integer :: pos
   integer :: n

   if (val == 0) then
      string = numbers(0)
      return
   end if

   n = abs(val)
   buffer = ""

   pos = buffer_len + 1
   do while (n > 0)
      pos = pos - 1
      buffer(pos:pos) = numbers(mod(n, 10))
      n = n/10
   end do
   if (val < 0) then
      pos = pos - 1
      buffer(pos:pos) = '-'
   end if

   string = buffer(pos:)
end function to_string

end module xtb_dipro_output

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_io_writer_turbomole
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule, len
   use xtb_pbc_tools
   implicit none
   private

   public :: writeResultsTurbomole
   public :: writeNormalModesTurbomole


contains


subroutine writeResultsTurbomole(mol, unit, energy, gradient, sigma)
   type(TMolecule), intent(in) :: mol
   integer, intent(in), optional :: unit
   real(wp), intent(in), optional :: energy
   real(wp), intent(in), optional :: gradient(:, :)
   real(wp), intent(in), optional :: sigma(:, :)
   integer :: ien, igr, igl
   real(wp) :: en

   if (present(unit)) then
      ien = unit
      igr = unit
      igl = unit
   else
      if (present(energy)) then
         call open_file(ien, "energy", "w")
      end if
      if (present(gradient)) then
         call open_file(igr, "gradient", "w")
      end if
      if (present(sigma) .and. mol%npbc > 0) then
         call open_file(igl, "gradlatt", "w")
      end if
   end if

   if (present(energy)) then
      en = energy
      call writeEnergyTurbomole(ien, en)
   else
      en = 0.0_wp
   end if

   if (present(gradient)) then
      call writeGradientTurbomole(igr, mol%xyz, mol%sym, en, gradient)
   end if

   if (present(sigma) .and. mol%npbc > 0) then
      call writeGradLattTurbomole(igl, mol%lattice, en, sigma)
   end if

   if (present(unit)) then
      if (present(energy) .or. present(gradient) &
         & .or. (present(sigma) .and. mol%npbc > 0)) then
         write(unit, '("$end")')
      end if
   else
      if (present(energy)) then
         write(ien, '("$end")')
         call close_file(ien)
      end if
      if (present(gradient)) then
         write(igr, '("$end")')
         call close_file(igr)
      end if
      if (present(sigma) .and. mol%npbc > 0) then
         write(igl, '("$end")')
         call close_file(igl)
      end if
   end if

end subroutine writeResultsTurbomole


subroutine writeEnergyTurbomole(unit, energy)
   integer, intent(in) :: unit
   real(wp), intent(in) :: energy
   write(unit, '("$energy")')
   write(unit, '(i6,3F18.11)') 1, spread(energy, 1, 3)
end subroutine writeEnergyTurbomole


subroutine writeGradientTurbomole(unit, xyz, sym, energy, gradient)
   integer, intent(in) :: unit
   real(wp), intent(in) :: xyz(:, :)
   character(len=*), intent(in) :: sym(:)
   real(wp), intent(in) :: energy
   real(wp), intent(in) :: gradient(:, :)
   integer :: i

   write(unit, '("$grad")')
   write(unit, '(2x,"cycle =",1x,i6,4x,"SCF energy =",f18.11,3x,'//&
      &        '"|dE/dxyz| =",f10.6)') 1, energy, norm2(gradient)
   do i = 1, size(xyz, dim=2)
      write(unit, '(3(F20.14,2x),4x,a2)') xyz(1,i), xyz(2,i), xyz(3,i), sym(i)
   end do
   do i = 1, size(gradient, dim=2)
      write(unit, '(3ES22.13)') gradient(1,i), gradient(2,i), gradient(3,i)
   end do

end subroutine writeGradientTurbomole


subroutine writeGradLattTurbomole(unit, lattice, energy, sigma)
   integer, intent(in) :: unit
   real(wp), intent(in) :: lattice(:, :)
   real(wp), intent(in) :: energy
   real(wp), intent(in) :: sigma(:, :)
   real(wp) :: gradlatt(3, 3), inv_lat(3, 3)
   integer :: i

   inv_lat = mat_inv_3x3(lattice)
   call sigma_to_latgrad(sigma, inv_lat, gradlatt)

   write(unit, '("$gradlatt")')
   write(unit, '(2x,"cycle =",1x,i6,4x,"SCF energy =",f18.11,3x,'//&
      &        '"|dE/dlatt| =",f10.6)') 1, energy, norm2(gradlatt)
   do i = 1, size(lattice, dim=2)
      write(unit, '(3(F20.14,2x))') lattice(1, i), lattice(2, i), lattice(3, i)
   end do
   do i = 1, size(gradlatt, dim=2)
      write(unit, '(3ES22.13)') gradlatt(1, i), gradlatt(2, i), gradlatt(3, i)
   end do
end subroutine writeGradLattTurbomole


subroutine writeNormalModesTurbomole(unit, atmass, normalModes)
   implicit none
   integer, intent(in) :: unit
   real(wp), intent(in) :: atmass(:) !< atom mass
   real(wp), intent(in) :: normalModes(:, :) !< NM
   real(wp), allocatable :: h(:, :)

   integer :: i,j,k,mincol,maxcol,ic,n,nat3
   character(len=:), allocatable :: frmt

   h = normalModes
   n = size(atmass)
   nat3 = size(normalModes, 1)

   do j=1,nat3
      do i=1,n
         do k=1,3
            ic = 3*(i-1) + k
            h(ic,j) = h(ic,j) / sqrt(atmass(i))  ! remove mass (needed for vibesTM compatibility)
         enddo
      enddo
   enddo

   frmt = '(i2,i3,5f15.10)'
   if (nat3.gt.99) frmt = '(i3,i2,5f15.10)'

   write(unit, '(a)') '$vibrational normal modes'

   do i = 1, nat3
      ic = 0
      maxcol = 0
      do while(maxcol.lt.nat3)
         mincol = maxcol+1
         maxcol = min(maxcol+5,nat3)
         ic=ic+1
         write(unit,frmt) i,ic,(h(i,j),j=mincol,maxcol) ! right TM order
!        write(unit,frmt) i,ic,(h(j,i),j=mincol,maxcol) ! natural, state order
      end do
   end do

   write(unit, '(a)') '$end'

end subroutine writeNormalModesTurbomole


end module xtb_io_writer_turbomole

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public Licen
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


subroutine rmrottr(natoms,mass,vel_atom,c)
   implicit none
   integer natoms
   real*8 vel_atom(3,natoms),c(3,natoms),mass(natoms)

   integer         :: i
   real*8          :: rlm(3), ram(3), omega(3)
   real*8          :: ixx,iyy,izz,ixy,ixz,iyz,dummy
   real*8          :: fixx,fiyy,fizz,fixy,fixz,fiyz,COM(3)
   real*8          :: inertia(3,3),angmom(3)
   real*8          :: tmass

   rlm = 0.0
   ram = 0.0
   call centerofmass(natoms,c,mass,tmass,COM)
   angmom = 0.0
   do i = 1, natoms
      c(1,i)=c(1,i)-COM(1)
      c(2,i)=c(2,i)-COM(2)
      c(3,i)=c(3,i)-COM(3)
      angmom(1) = angmom(1) + mass(i) * ( c(2,i) * vel_atom(3,i) -&
         &                                      c(3,i) * vel_atom(2,i) )
      angmom(2) = angmom(2) + mass(i) * ( c(3,i) * vel_atom(1,i) -&
         &                                      c(1,i) * vel_atom(3,i) )
      angmom(3) = angmom(3) + mass(i) * ( c(1,i) * vel_atom(2,i) -&
         &                                      c(2,i) * vel_atom(1,i) )
   end do
   ixx = 0.0
   iyy = 0.0
   izz = 0.0
   ixy = 0.0
   ixz = 0.0
   iyz = 0.0
   do i = 1, natoms
      ixx = ixx + mass(i) * ( c(2,i) * c(2,i) + c(3,i) * c(3,i) )
      iyy = iyy + mass(i) * ( c(3,i) * c(3,i) + c(1,i) * c(1,i) )
      izz = izz + mass(i) * ( c(1,i) * c(1,i) + c(2,i) * c(2,i) )
      ixy = ixy - mass(i) *   c(1,i) * c(2,i)
      ixz = ixz - mass(i) *   c(1,i) * c(3,i)
      iyz = iyz - mass(i) *   c(2,i) * c(3,i)
   end do
   inertia(1,1) = ixx
   inertia(2,2) = iyy
   inertia(3,3) = izz
   inertia(1,2) = ixy
   inertia(2,1) = ixy
   inertia(1,3) = ixz
   inertia(3,1) = ixz
   inertia(2,3) = iyz
   inertia(3,2) = iyz
   call dmatinv(inertia,3,3,dummy)
   omega =  matmul(inertia,angmom)
   do i = 1, natoms
      rlm(1) = rlm(1) + mass(i) * vel_atom(1,i)
      rlm(2) = rlm(2) + mass(i) * vel_atom(2,i)
      rlm(3) = rlm(3) + mass(i) * vel_atom(3,i)
   end do
   do i = 1, natoms
      ram(1) =        ( omega(2) * c(3,i) - omega(3) * c(2,i) )
      ram(2) =        ( omega(3) * c(1,i) - omega(1) * c(3,i) )
      ram(3) =        ( omega(1) * c(2,i) - omega(2) * c(1,i) )

      vel_atom(1,i) = vel_atom(1,i) - rlm(1) / tmass  - ram(1)
      vel_atom(2,i) = vel_atom(2,i) - rlm(2) / tmass  - ram(2)
      vel_atom(3,i) = vel_atom(3,i) - rlm(3) / tmass  - ram(3)

      c(1,i)=c(1,i)+COM(1)
      c(2,i)=c(2,i)+COM(2)
      c(3,i)=c(3,i)+COM(3)
   end do

end subroutine

subroutine centerofmass(natoms,c,mass,totmass,COM)
   implicit none
   integer natoms
   real*8 c(3,natoms),totmass,mass(natoms),COM(3)

   integer         :: i,j

   COM(1)=0.0
   COM(2)=0.0
   COM(3)=0.0

   totmass=0
   do i = 1, natoms
      totmass=totmass+mass(i)
      COM(1) = COM(1) + mass(i)*c(1,i)
      COM(2) = COM(2) + mass(i)*c(2,i)
      COM(3) = COM(3) + mass(i)*c(3,i)
   enddo

   COM(1)=COM(1)/totmass
   COM(2)=COM(2)/totmass
   COM(3)=COM(3)/totmass
   !     write(9,'(3f20.9)')(COM(j),j=1,3)
end subroutine

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_propertyoutput
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_io, only: stdout
   use xtb_mctc_symbols, only: toSymbol
   use xtb_mctc_convert, only: evtoau, autod, autoaa
   use xtb_solv_cm5
   use xtb_cube
   use xtb_topology
#if WITH_TBLITE
   use tblite_basis_type, only: basis_type
   use tblite_wavefunction_type, only: wavefunction_type
#endif
   contains

   subroutine write_energy(iunit, sccres, frqres, hess)
      use xtb_type_data
      implicit none
      integer, intent(in) :: iunit ! file handle (usually output_unit=6)
      logical, intent(in) :: hess
      type(scc_results), intent(in) :: sccres
      type(freq_results), intent(in) :: frqres
      character(len=*), parameter :: outfmt = '(10x,"|",1x,a,f24.12,1x,a,1x,"|")'
      write (iunit, '(a)')
      write (iunit, '(11x,49("-"))')
      if (hess) then
         write (iunit, outfmt) "TOTAL ENERGY      ", frqres%etot, "Eh  "
         write (iunit, outfmt) "TOTAL ENTHALPY    ", frqres%etot + frqres%htot, "Eh  "
         write (iunit, outfmt) "TOTAL FREE ENERGY ", frqres%etot + frqres%gtot, "Eh  "
         write (iunit, outfmt) "GRADIENT NORM     ", frqres%gnorm, "Eh/α"
      else
         write (iunit, outfmt) "TOTAL ENERGY      ", sccres%e_total, "Eh  "
         write (iunit, outfmt) "GRADIENT NORM     ", sccres%gnorm, "Eh/α"
      end if
      write (iunit, outfmt) "HOMO-LUMO GAP     ", sccres%hl_gap, "eV  "
      write (iunit, '(11x,49("-"))')
   end subroutine write_energy

   subroutine write_energy_gff(iunit, sccres, frqres, hess)
      use xtb_type_data
      implicit none
      integer, intent(in) :: iunit ! file handle (usually output_unit=6)
      logical, intent(in) :: hess
      type(scc_results), intent(in) :: sccres
      type(freq_results), intent(in) :: frqres
      character(len=*), parameter :: outfmt = '(10x,"|",1x,a,f24.12,1x,a,1x,"|")'
      write (iunit, '(a)')
      write (iunit, '(11x,49("-"))')
      if (hess) then
         write (iunit, outfmt) "TOTAL ENERGY      ", frqres%etot, "Eh  "
         write (iunit, outfmt) "TOTAL ENTHALPY    ", frqres%etot + frqres%htot, "Eh  "
         write (iunit, outfmt) "TOTAL FREE ENERGY ", frqres%etot + frqres%gtot, "Eh  "
         write (iunit, outfmt) "GRADIENT NORM     ", frqres%gnorm, "Eh/α"
      else
         write (iunit, outfmt) "TOTAL ENERGY      ", sccres%e_total, "Eh  "
         write (iunit, outfmt) "GRADIENT NORM     ", sccres%gnorm, "Eh/α"
      end if
      write (iunit, '(11x,49("-"))')
   end subroutine write_energy_gff

   subroutine write_energy_oniom(iunit, sccres, frqres, hess)
      use xtb_type_data
      implicit none
      integer, intent(in) :: iunit ! file handle (usually output_unit=6)
      logical, intent(in) :: hess
      type(scc_results), intent(in) :: sccres
      type(freq_results), intent(in) :: frqres
      character(len=*), parameter :: outfmt = '(10x,"|",1x,a,f18.12,1x,a,1x,"|")'

      write (iunit, '(a)')
      write (iunit, '(11x,49("-"))')
      if (hess) then
         write (iunit, outfmt) "ONIOM TOTAL ENERGY      ", frqres%etot, "Eh  "
         write (iunit, outfmt) "ONIOM TOTAL ENTHALPY    ", frqres%etot + frqres%htot, "Eh  "
         write (iunit, outfmt) "ONIOM TOTAL FREE ENERGY ", frqres%etot + frqres%gtot, "Eh  "
         write (iunit, outfmt) "ONIOM GRADIENT NORM     ", frqres%gnorm, "Eh/α"
      else
         write (iunit, outfmt) "ONIOM TOTAL ENERGY      ", sccres%e_total, "Eh  "
         write (iunit, outfmt) "ONIOM GRADIENT NORM     ", sccres%gnorm, "Eh/α"
      end if
      write (iunit, '(11x,49("-"))')
   end subroutine write_energy_oniom

   subroutine main_property &
      (iunit, env, mol, wfx, basis, xtbData, res, solvModel, acc)

      use xtb_mctc_convert

!! ========================================================================
!  load class definitions
      use xtb_type_molecule
      use xtb_type_wavefunction
      use xtb_type_environment
      use xtb_type_basisset
      use xtb_type_data
      use xtb_type_param
      use xtb_solv_model
      use xtb_solv_gbsa, only: TBorn
      use xtb_xtb_data
      use xtb_intgrad

!! ========================================================================
!  global storage of options, parameters and basis set
      use xtb_setparam

!! ------------------------------------------------------------------------
      use xtb_aespot
      use xtb_dtrafo

      implicit none

!! ========================================================================
      integer, intent(in) :: iunit ! file handle (usually output_unit=6)
!  molecule data
      type(TMolecule), intent(in) :: mol
      type(TEnvironment), intent(inout) :: env
      type(TxTBData), intent(in) :: xtbData
      real(wp), intent(in) :: acc      ! accuracy of integral calculation
      type(TWavefunction), intent(inout) :: wfx
      type(TBasisset), intent(in) :: basis
      type(scc_results), intent(in) :: res
      type(TSolvModel), allocatable, intent(in) :: solvModel

      real(wp), allocatable :: S(:, :)     ! overlap integrals
      real(wp), allocatable :: dpint(:, :, :) ! dipole integrals
      real(wp), allocatable :: qpint(:, :, :) ! quadrupole integrals
      real(wp), allocatable :: C(:, :)     ! molecular orbitals
      real(wp), allocatable :: emo(:)     ! orbital energies
      real(wp), allocatable :: focc(:)    ! fractional occupation numbers
      integer :: ifile
      integer :: ndim, ndp, nqp
      real(wp) :: dip, dipol(3)
      real(wp) :: intcut, neglect
      real(wp), parameter :: trans(3, 1) = 0.0_wp

      type(TBorn) :: gbsa

!  primitive cut-off
      intcut = 25.0_wp - 10.0 * log10(acc)
      intcut = max(20.0_wp, intcut)
!  integral neglect threshold
      neglect = 10.0d-9 * acc
      ndim = basis%nao * (basis%nao + 1) / 2
      allocate (S(basis%nao, basis%nao), dpint(3, basis%nao, basis%nao), &
         & qpint(6, basis%nao, basis%nao), source=0.0_wp)
#ifdef XTB_GPU
      call sdqint_gpu(xtbData%nShell, xtbData%hamiltonian%angShell, mol%n, mol%at, &
         &        basis%nbf, basis%nao, mol%xyz, trans, intcut, &
         &        basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, &
         &        basis%alp, basis%cont, S, dpint, qpint)
#else
      call sdqint(xtbData%nShell, xtbData%hamiltonian%angShell, mol%n, mol%at, &
         &        basis%nbf, basis%nao, mol%xyz, intcut, &
         &        basis%caoshell, basis%saoshell, basis%nprim, basis%primcount, &
         &        basis%alp, basis%cont, S, dpint, qpint)
#endif

!! orbital energies and occupation
      if (set%pr_eig) then
         write (iunit, '(/,4x,"*",1x,a)') "Orbital Energies and Occupations"
         call print_orbital_eigenvalues(iunit, wfx, 11)
      end if

!! Mulliken and CM5 charges
      if (set%pr_mulliken .and. set%gfn_method == 1) then
         call print_mulliken(iunit, mol%n, mol%at, mol%sym, mol%xyz, mol%z, &
            & basis%nao, S, wfx%P, basis%aoat2, basis%lao2)
      end if
      if (set%pr_charges) then
         call open_file(ifile, 'charges', 'w')
         call print_charges(ifile, mol%n, wfx%q)
         call close_file(ifile)
      end if

      ! GBSA information
      if (allocated(solvModel) .and. set%pr_gbsa) then
         call newBornModel(solvModel, env, gbsa, mol%at)
         call gbsa%update(env, mol%at, mol%xyz)
         call print_gbsa_info(iunit, mol%sym, gbsa)
      end if

!! D4 molecular dispersion printout
      if ((set%newdisp .and. set%gfn_method == 2) .and. set%pr_mulliken) then
         call print_molpol(iunit, mol%n, mol%at, mol%sym, mol%xyz, wfx%q, &
            & xtbData%dispersion%wf, xtbData%dispersion%g_a, xtbData%dispersion%g_c, &
            & xtbData%dispersion%dispm)
      end if
      if (set%gfn_method == 0 .and. set%pr_mulliken) then
         call print_molpol(iunit, mol%n, mol%at, mol%sym, mol%xyz, wfx%q, &
            & xtbData%dispersion%wf, xtbData%dispersion%g_a, xtbData%dispersion%g_c,&
            & xtbData%dispersion%dispm)
      end if

!! Spin population
      if (set%pr_spin_population .and. wfx%nopen /= 0) then
         call print_spin_population(iunit, mol%n, mol%at, mol%sym, basis%nao, wfx%focca,&
            & wfx%foccb, S, wfx%C, basis%aoat2, basis%lao2)
      end if

      if (set%pr_fod_pop) then
         call open_file(ifile, 'fod', 'w')
         call print_fod_population(iunit, ifile, mol%n, mol%at, mol%sym, basis%nao, S, &
            & wfx%C, set%etemp, wfx%emo, wfx%ihomoa, wfx%ihomob, basis%aoat2, basis%lao2)
         call close_file(ifile)
      end if

!! wiberg bond orders
      if (set%pr_wiberg) then
         call open_file(ifile, 'wbo', 'w')
         call print_wbofile(ifile, mol%n, wfx%wbo, 0.1_wp)
         call close_file(ifile)
         call print_wiberg(iunit, mol%n, mol%at, mol%sym, wfx%wbo, 0.1_wp)

         call checkTopology(iunit, mol, wfx%wbo, 1)
      end if

      if (set%pr_wbofrag) &
         call print_wbo_fragment(iunit, mol%n, mol%at, wfx%wbo, 0.1_wp)

!! molden file
      if (set%pr_molden_input) then
         allocate (C(basis%nbf, basis%nao), focc(basis%nao), emo(basis%nao), source=0.0_wp)
         if (basis%nbf == basis%nao) then
            C = wfx%C
         else
            call sao2cao(basis%nao, wfx%C, basis%nbf, C, basis)
         end if
         emo = wfx%emo * evtoau
         focc = wfx%focca + wfx%foccb
         call printmold(mol%n, basis%nao, basis%nbf, mol%xyz, mol%at, C, emo, focc, 2.0_wp, basis)
         write (iunit, '(/,"MOs/occ written to file <molden.input>",/)')
         deallocate (C, focc, emo)
      end if

      if (set%pr_gbw) &
         call wrgbw(xtbData, mol%n, mol%at, mol%xyz, mol%z, basis, wfx)

      if (set%pr_tmbas .or. set%pr_tmmos) then
         call open_file(ifile, 'basis', 'w')
         call write_tm_basis(ifile, xtbData, mol%n, mol%at, basis, wfx)
         call close_file(ifile)
      end if

      if (set%pr_tmmos) then
         call open_file(ifile, 'mos', 'w')
         call write_tm_mos(ifile, mol%n, mol%at, basis, wfx)
         call close_file(ifile)
      end if

!! multipole moment prinout
      if (set%pr_dipole) then
         if (set%gfn_method > 1) then
            ! print overall multipole moment
            call molmom(iunit, mol%n, mol%xyz, wfx%q, wfx%dipm, wfx%qp, dip, dipol)
            write (iunit, '(a)')
         else
            call print_dipole(iunit, mol%n, mol%at, mol%xyz, mol%z, wfx%nao, wfx%P, dpint)
         end if
      end if

   end subroutine main_property

   !> wrapper for tblite-PTB property output
   subroutine ptb_property&
                     (iunit, env, chk, calc, mol, res)
      
      use xtb_type_molecule, only: TMolecule
      use xtb_type_restart, only: TRestart
      use xtb_type_environment,  only: TEnvironment
      use xtb_type_data, only: scc_results
      use xtb_type_calculator, only: TCalculator
      use xtb_ptb_calculator, only: TPTBCalculator

      integer, intent(in) :: iunit
      type(TMolecule), intent(in) :: mol
      type(TEnvironment), intent(inout) :: env
      type(TRestart),  intent(inout) :: chk
      type(TPTBCalculator), intent(in) :: calc
      type(scc_results), intent(in) :: res
      
#if WITH_TBLITE
   call tblite_ptb_property(iunit, env, chk%tblite, calc%bas, mol, chk%wfn, res)
#endif

   end subroutine ptb_property

#if WITH_TBLITE
   subroutine tblite_ptb_property &
      (iunit, env, wfn, bas, struc, wfx, res)

      use xtb_mctc_convert
      use xtb_type_molecule
      use xtb_type_wavefunction
      use xtb_type_environment
      use xtb_type_basisset
      use xtb_type_data

      !========================================================================
      !> global storage of options, parameters and basis set
      use xtb_setparam

      !========================================================================
      !> PTB specific property output
      use xtb_ptb_property, only: print_charges_to_screen
      use xtb_ptb_guess, only: get_psh_from_qsh

      use mctc_io_structure, only: structure_type

      implicit none

      !========================================================================
      integer, intent(in) :: iunit ! file handle (usually output_unit=6)
      !> tblite data formats
      type(structure_type) :: mol
      type(wavefunction_type), intent(in) :: wfn
      type(basis_type), intent(in) :: bas
      !> molecule data
      type(TMolecule), intent(in) :: struc
      type(TEnvironment), intent(inout) :: env
      type(TWavefunction), intent(inout) :: wfx
      type(scc_results), intent(in) :: res
      integer :: ifile, i
      real(wp), allocatable :: psh(:, :)
      real(wp) :: dip, isotropic_alpha

      mol = struc

      !> orbital energies and occupation
      if (set%pr_eig) then
         write (iunit, '(/,4x,"*",1x,a)') "Orbital Energies and Occupations"
         call print_orbital_eigenvalues(iunit, wfx, 11)
      end if

      !> Mixed Mulliken-Loewdin atomic charges and shell populations
      allocate (psh(bas%nsh, wfn%nspin), source=0.0_wp)
      psh = get_psh_from_qsh(wfn, bas)
      call print_charges_to_screen(iunit, mol, bas, wfn%qat, psh)
      if (set%pr_charges) then
         call open_file(ifile, 'charges', 'w')
         call print_charges(ifile, struc%n, wfx%q)
         call close_file(ifile)
      end if

      !> Spin population
      ! if (set%pr_spin_population .and. wfx%nopen .ne. 0) then
      !    call print_spin_population(iunit, mol%n, mol%at, mol%sym, basis%nao, wfx%focca,&
      !       & wfx%foccb, S, wfx%C, basis%aoat2, basis%lao2)
      ! end if

!! wiberg bond orders
      if (set%pr_wiberg) then
         call open_file(ifile, 'wbo', 'w')
         call print_wbofile(ifile, struc%n, wfx%wbo, 0.1_wp)
         call close_file(ifile)
         call print_wiberg(iunit, struc%n, struc%at, struc%sym, wfx%wbo, 0.1_wp)

         call checkTopology(iunit, struc, wfx%wbo, 1)
      end if

      if (set%pr_wbofrag) &
         call print_wbo_fragment(iunit, struc%n, struc%at, wfx%wbo, 0.1_wp)

      ! if (set%pr_tmmos) then
      !    call open_file(ifile, 'mos', 'w')
      !    call write_tm_mos(ifile, struc%n, struc%at, basis, wfx)
      !    call close_file(ifile)
      ! end if

      dip = norm2(res%dipole)

      write (iunit, '(a)')
      write (iunit, '(1x)', advance="no")
      do i = 1, 38
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      write (iunit, '(4x,"Molecular dipole moment (a.u.)")')
      write (iunit, '(4x,"X        Y        Z")')
      write (iunit, '(1x)', advance="no")
      do i = 1, 38
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      write (iunit, '(1x,3f9.4)') &
            & res%dipole(1), res%dipole(2), res%dipole(3)
      write (iunit, '(1x)', advance="no")
      do i = 1, 38
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      write (iunit, '(4x,"Total dipole moment (a.u. / Debye):",/,1x,2f9.4)') &
            & dip, dip * autod

      write (iunit, '(a)')
      write (iunit, '(1x)', advance="no")
      do i = 1, 38
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      write (iunit, '(4x,"Molecular quadrupole tensor: (a.u.)")')
      write (iunit, '(9x,"X         Y         Z")')
      write (iunit, '(4x,a,f10.4)') "X", res%quadrupole(1)
      write (iunit, '(4x,a,2f10.4)') "Y", res%quadrupole(2:3)
      write (iunit, '(4x,a,3f10.4)') "Z", res%quadrupole(4:6)
      write (iunit, '(1x)', advance="no")

      if (set%elprop == p_elprop_alpha) then
         isotropic_alpha = (res%alpha(1, 1) + res%alpha(2, 2) + res%alpha(3, 3)) / 3.0_wp
         write (iunit, '(a)')
         write (iunit, '(1x)', advance="no")
         do i = 1, 38
            write (iunit, '(a)', advance="no") "-"
         end do
         write (iunit, '(/)', advance="no")
         write (iunit, '(4x,"Numerical polarizability tensor: (a.u.)")')
         write (iunit, '(9x,"X         Y         Z")')
         write (iunit, '(4x,a,3f10.4)') "X", res%alpha(1, 1:3)
         write (iunit, '(4x,a,3f10.4)') "Y", res%alpha(2, 1:3)
         write (iunit, '(4x,a,3f10.4)') "Z", res%alpha(3, 1:3)
         write (iunit, '(1x)', advance="no")
         do i = 1, 38
            write (iunit, '(a)', advance="no") "-"
         end do
         write (iunit, '(/)', advance="no")
         write (iunit, '(4x,"Total isotropic dipole polarizability (a.u. / Å³):",/,1x,2f9.4)') &
               & isotropic_alpha, isotropic_alpha * (autoaa**3)
      end if

   end subroutine tblite_ptb_property
#endif

   subroutine gfnff_property(iunit, n, xyz, topo, nlist)
      use xtb_gfnff_topology, only: TGFFTopology
      use xtb_gfnff_neighbourlist, only: TGFFNeighbourList
      use xtb_aespot, only: molqdip
!! ========================================================================
      !  global storage of options, parameters and basis set
      use xtb_setparam
      integer, intent(in) :: iunit, n
      real(wp), intent(in) :: xyz(3, n)
      type(TGFFTopology), intent(in) :: topo
      type(TGFFNeighbourList), intent(in) :: nlist

      ! dipole moment from charge
      if (set%pr_dipole) then
         call molqdip(iunit, n, xyz, nlist%q)
      end if

   end subroutine gfnff_property

   subroutine main_cube &
      (lverbose, mol, wfx, basis, res)

      use xtb_mctc_convert

!! ========================================================================
!  load class definitions
      use xtb_type_molecule
      use xtb_type_wavefunction
      use xtb_type_basisset
      use xtb_type_data
      use xtb_type_param

!! ========================================================================
!  global storage of options, parameters and basis set
      use xtb_setparam

!! ------------------------------------------------------------------------
      use xtb_aespot
      use xtb_scc_core
      use esp
      use stm
      use xtb_dtrafo

      implicit none

!! ========================================================================
      logical, intent(in) :: lverbose
!  molecule data
      type(TMolecule), intent(in) :: mol
      type(TWavefunction), intent(in) :: wfx
      type(TBasisset), intent(in) :: basis
      type(scc_results), intent(in) :: res

      real(wp), allocatable :: C(:, :)     ! molecular orbitals
      real(wp), allocatable :: emo(:)     ! orbital energies
      real(wp), allocatable :: focc(:)    ! fractional occupation numbers
      real(wp), allocatable :: focca(:)   ! fractional occupation numbers (alpha)
      real(wp), allocatable :: foccb(:)   ! fractional occupation numbers (beta)
      integer :: ndim, ndp, nqp
      real(wp) :: dip, dipol(3)
      real(wp) :: acc, intcut, neglect
      real(wp) :: efa, efb, ga, gb, nfoda, nfodb

!! ------------------------------------------------------------------------
!  FOD
      if (set%pr_fod) then
         allocate (C(basis%nbf, basis%nao), focca(basis%nao), foccb(basis%nao), focc(basis%nao), emo(basis%nao), &
                   source=0.0_wp)
         if (wfx%ihomoa + 1 <= basis%nao) &
            call fermismear(.false., basis%nao, wfx%ihomoa, set%etemp, wfx%emo, focca, nfoda, efa, ga)
         if (wfx%ihomob + 1 <= basis%nao) &
            call fermismear(.false., basis%nao, wfx%ihomob, set%etemp, wfx%emo, foccb, nfodb, efb, gb)
         emo = wfx%emo * evtoau
         call fodenmak(.true., basis%nao, emo, focca, efa)
         call fodenmak(.true., basis%nao, emo, foccb, efb)
         focc = focca + foccb
         if (basis%nbf == basis%nao) then
            C = wfx%C
         else
            call sao2cao(basis%nao, wfx%C, basis%nbf, C, basis)
         end if
         if (lverbose) &
            write (stdout, '(/,"FOD written to file: ''fod.cub''",/)')
         call cube(mol%n, basis%nao, basis%nbf, mol%xyz, mol%at, C, emo, focc, 'fod.cub', basis)
         deallocate (C, focca, foccb, focc, emo)
      end if

!! ------------------------------------------------------------------------
!  print spin density to cube file
      if (set%pr_spin_density .and. wfx%nopen /= 0) then
         allocate (C(basis%nbf, basis%nao), focc(basis%nao), emo(basis%nao), source=0.0_wp)
         if (basis%nbf == basis%nao) then
            C = wfx%C
         else
            call sao2cao(basis%nao, wfx%C, basis%nbf, C, basis)
         end if
         if (lverbose) &
            write (stdout, '(/,"(R)spin-density written to file: ''spindensity.cub''",/)')
         emo = wfx%emo * evtoau
         focc = wfx%focca - wfx%foccb
         call cube(mol%n, basis%nao, basis%nbf, mol%xyz, mol%at, C, emo, focc, 'spindensity.cub', basis)
         deallocate (C, focc, emo)
      end if

!! ------------------------------------------------------------------------
!  print density to cube file
      if (set%pr_density) then
         allocate (C(basis%nbf, basis%nao), emo(basis%nao), source=0.0_wp)
         if (basis%nbf == basis%nao) then
            C = wfx%C
         else
            call sao2cao(basis%nao, wfx%C, basis%nbf, C, basis)
         end if
         if (lverbose) &
            write (stdout, '(/,"density written to file: ''density.cub''",/)')
         emo = wfx%emo * evtoau
         call cube(mol%n, basis%nao, basis%nbf, mol%xyz, mol%at, C, emo, wfx%focc, 'density.cub', basis)
         deallocate (C, emo)
      end if

!! ------------------------------------------------------------------------
!  make an ESP plot
      if (set%pr_esp) then
         allocate (C(basis%nbf, basis%nao), source=0.0_wp)
         if (basis%nbf == basis%nao) then
            C = wfx%C
         else
            call sao2cao(basis%nao, wfx%C, basis%nbf, C, basis)
         end if
         call espplot(mol%n, basis%nao, basis%nbf, mol%at, mol%xyz, mol%z, wfx%focc, C, basis)
         deallocate (C)
      end if

!! ------------------------------------------------------------------------
!  make a STM image
      if (set%pr_stm) then
         allocate (C(basis%nbf, basis%nao), focc(basis%nao), source=0.0_wp)
         if (basis%nbf == basis%nao) then
            C = wfx%C
         else
            call sao2cao(basis%nao, wfx%C, basis%nbf, C, basis)
         end if
         if (wfx%ihomoa + 1 <= wfx%nao) &
            call fermismear(.false., basis%nao, wfx%ihomoa, set%etemp, wfx%emo, focc, nfoda, efa, ga)
         if (wfx%ihomob + 1 <= wfx%nao) &
            call fermismear(.false., basis%nao, wfx%ihomob, set%etemp, wfx%emo, focc, nfodb, efb, gb)
         call stmpic(mol%n, basis%nao, basis%nbf, mol%at, mol%xyz, C, 0.5_wp * (efa + efb), wfx%emo, basis)
         deallocate (C, focc)
      end if

   end subroutine main_cube

   subroutine main_freq &
      (iunit, mol, wfx, res)

      use xtb_mctc_convert

!! ========================================================================
!  load class definitions
      use xtb_type_molecule
      use xtb_type_wavefunction
      use xtb_type_basisset
      use xtb_type_data
      use xtb_type_param

!! ========================================================================
!  global storage of options, parameters and basis set
      use xtb_setparam
      use xtb_splitparam, only: atmass

!! ------------------------------------------------------------------------
      use xtb_hessian
      use xtb_disp_ncoord
      use xtb_io_writer_turbomole, only: writeNormalModesTurbomole

      implicit none

!! ========================================================================
      integer, intent(in) :: iunit
!  molecule data
      type(TMolecule), intent(inout) :: mol
      type(TWavefunction), intent(in) :: wfx
      type(freq_results), intent(inout) :: res

      integer :: ifile
      integer :: i, ii, j, jj, k, l
      character(len=:), allocatable :: hname
      real(wp), allocatable :: bond(:, :)
      integer, allocatable :: molvec(:)
      real(wp), allocatable :: cn(:)
      real(wp), allocatable :: xyz0(:, :)
      real(wp), allocatable :: h(:, :)
      real(wp) :: etot, h298, dum
      integer :: lowmode

      allocate (molvec(mol%n), source=0)
      allocate (xyz0(3, mol%n), h(3 * mol%n, 3 * mol%n), bond(mol%n, mol%n), cn(mol%n), source=0.0_wp)

      if (res%linear) then
         write (iunit, '(1x,a)') 'vibrational frequencies (cm⁻¹)'
      else
         write (iunit, '(1x,a)') 'projected vibrational frequencies (cm⁻¹)'
      end if
      call PREIGF(iunit, res%freq, res%n3true)

      write (iunit, '(1x,a)') 'reduced masses (amu)'
      write (iunit, '(8(i4,'':'',f6.2))') (i, res%rmass(i), i=1, res%n3)
      write (iunit, '(1x,a)') 'IR intensities (km·mol⁻¹)'
      write (iunit, '(8(i4,'':'',f6.2))') (i, res%dipt(i), i=1, res%n3)
      write (iunit, '(1x,a)') 'Raman intensities (Ä⁴*amu⁻¹)'
      write (iunit, '(8(i4,'':'',f6.2))') (i, res%polt(i), i=1, res%n3)

      call open_file(ifile, 'vibspectrum', 'w')
      if (set%elprop == p_elprop_alpha) then
         call write_tm_vibspectrum(ifile, res%n3, res%freq, res%dipt, res%polt,&
                                           set%ptbsetup%raman_temp, set%ptbsetup%raman_lambda)
      else
         call write_tm_vibspectrum(ifile, res%n3, res%freq, res%dipt, res%polt)
      end if
      call close_file(ifile)

      write (iunit, '(1x,a)') 'output can be read by thermo (or use thermo option).'
      write (iunit, '(1x,a)') 'writing <g98.out> molden fake output.'
      write (iunit, '(1x,a)') &
         & 'recommended (thermochemical) frequency scaling factor: 1.0'
      call g98fake2('g98.out', mol%n, mol%at, mol%xyz, res%freq, res%rmass, res%dipt, res%hess)

      if (set%pr_nmtm) then
         call open_file(ifile, "vib_normal_modes", 'w')
         if (ifile /= -1) then
            call writeNormalModesTurbomole(ifile, atmass, res%hess)
            call close_file(ifile)
         end if
      end if

      call generic_header(iunit, "Thermodynamic Functions", 49, 10)
      call print_thermo(iunit, mol%n, res%n3true, mol%at, mol%xyz, res%freq, res%etot, res%htot, res%gtot, &
                        res%nimag, .true., res%zp)
      res%pg = trim(set%pgroup)
      res%temp = set%thermotemp(set%nthermo)
      if (set%enso_mode) then
         call open_file(ifile, "xtb_enso.json", 'w')
         if (ifile /= -1) then
            call enso_printout(ifile, res)
            call close_file(ifile)
         end if
      end if

      ! distort along imags if present
      call distort(mol, res%freq, res%hess)

      if (set%pr_modef .and. (mol%n > 3)) then

         ! do analysis and write mode following file
         call wrmodef(0, mol%n, mol%at, mol%xyz, wfx%wbo, res%rmass, res%freq, res%hess, h, set%mode_vthr, res%linear)

         ! localize the modes
         if (set%mode_vthr > 1.d-6) then
            ! determine molecular fragments
            call ncoord_erf(mol%n, mol%at, mol%xyz, cn)
            call cutcov(mol%n, mol%at, mol%xyz, cn, wfx%wbo, bond)
            call mrec(i, mol%xyz, cn, bond, mol%n, mol%at, molvec)
            call locmode(mol%n, res%n3, mol%at, mol%xyz, set%mode_vthr, res%freq, res%rmass, res%hess, &
                         i, molvec)
            call PREIGF0(iunit, res%freq, res%n3true)
            write (iunit, '("written to xtb_localmodes and g98l.out")')
            call wrmodef(1, mol%n, mol%at, mol%xyz, wfx%wbo, res%rmass, res%freq, res%hess, &
                         h, set%mode_vthr + 200.0_wp, res%linear)
         end if

         call open_file(ifile, '.tmpxtbmodef', 'w')
         write (ifile, *) res%lowmode, res%lowmode
         write (ifile, *) res%etot    ! energy for comparison
         call close_file(ifile)

      end if

   end subroutine main_freq

   subroutine print_charges(ifile, n, q)
      implicit none
      integer, intent(in) :: ifile
      integer, intent(in) :: n
      real(wp), intent(in) :: q(n)
      integer :: i
      if (ifile /= -1) then
         do i = 1, n
            write (ifile, '(f14.8)') q(i)
         end do
      end if
   end subroutine print_charges

   subroutine print_mulliken(iunit, n, at, sym, xyz, z, nao, S, P, aoat2, lao2)
      use xtb_scc_core, only: mpop
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      character(len=*), intent(in) :: sym(n)
      real(wp), intent(in) :: xyz(3, n)
      real(wp), intent(in) :: z(n)
      integer, intent(in) :: nao
      real(wp), intent(in) :: S(nao, nao)
      real(wp), intent(in) :: P(nao, nao)
      integer, intent(in) :: aoat2(nao)
      integer, intent(in) :: lao2(nao)
      real(wp), allocatable :: q(:)       ! Mulliken partial charges
      real(wp), allocatable :: qlmom(:, :) ! population per shell
      real(wp), allocatable :: cm5(:)     ! CM5 partial charges
      real(wp), allocatable :: cm5a(:)     ! CM5 partial charges
      real(wp), allocatable :: dcm5a(:, :, :)! CM5 partial charges
      integer :: i

      allocate (cm5(n), q(n), qlmom(3, n), cm5a(n), dcm5a(3, n, n), source=0.0_wp)
      call mpop(n, nao, aoat2, lao2, S, P, q, qlmom)
      q = z - q
      call calc_cm5(n, at, xyz, cm5a, dcm5a)
      cm5 = q + cm5a
      write (iunit, '(a)')
      write (iunit, '(2x,"Mulliken/CM5 charges         n(s)   n(p)   n(d)")')
      do i = 1, n
         write (iunit, '(i6,a4,2f9.5,1x,4f7.3)') &
            i, sym(i), q(i), cm5(i), qlmom(1, i), qlmom(2, i), qlmom(3, i)
      end do
   end subroutine print_mulliken

   subroutine print_wbofile(iunit, n, wbo, thr)
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: n
      real(wp), intent(in) :: wbo(n, n)
      real(wp), intent(in) :: thr
      integer :: i, j
      do i = 1, n
         do j = 1, i - 1
            if (wbo(j, i) > thr) write (iunit, *) j, i, wbo(j, i)
         end do
      end do
   end subroutine print_wbofile

   subroutine print_wiberg(iunit, n, at, sym, wbo, thr)
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      character(len=*), intent(in) :: sym(n)
      real(wp), intent(in) :: wbo(n, n)
      real(wp), intent(in) :: thr

      real(wp), allocatable :: wbr(:, :)
      integer, allocatable :: imem(:)
      integer :: i, j, k, ibmax
      real(wp) :: xsum

      allocate (wbr(n, n), source=wbo)
      allocate (imem(n), source=0)

      write (iunit, '(a)')
      write (iunit, '("Wiberg/Mayer (AO) data.")')
      write (iunit, '("largest (>",f4.2,") Wiberg bond orders for each atom")') thr
      write (iunit, '(a)')
      write (iunit, '(1x,75("-"))')
      write (iunit, '(5x,"#",3x,"Z",1x,"sym",2x,"total",t25,3(5x,"#",1x,"sym",2x,"WBO",2x))')
      write (iunit, '(1x,75("-"))')
      do i = 1, n
         do j = 1, n
            imem(j) = j
         end do
         call wibsort(n, i, imem, wbr)
         ibmax = 0
         xsum = 0.0_wp
         do j = 1, n
            if (wbr(i, j) > thr) ibmax = j
            xsum = xsum + wbr(i, j)
         end do
         if (ibmax > 0) then
            write (iunit, '(i6,1x,i3,1x,a4,f6.3,1x,"--")', advance='no') &
               & i, at(i), sym(i), xsum
         else
            write (iunit, '(i6,1x,i3,1x,a4,f6.3)') &
               & i, at(i), sym(i), xsum
         end if
         do j = 1, ibmax, 3
            if (j > 1) then
               write (iunit, '(t25)', advance='no')
            end if
            do k = j, min(ibmax, j + 2)
               write (iunit, '(i6,1x,a4,f6.3)', advance='no') &
                  & imem(k), sym(imem(k)), wbr(i, k)
            end do
            write (iunit, '(a)')
         end do
      end do
      write (iunit, '(1x,75("-"))')
      write (iunit, '(a)')

      deallocate (wbr, imem)

   contains

      SUBROUTINE wibsort(ncent, imo, imem, qmo)
         implicit none
         integer :: ncent
         integer :: imo
         real(wp) :: qmo(ncent, ncent)
         integer :: imem(ncent)
         integer :: ii, i, j, k, ihilf
         real(wp) :: pp

         do ii = 2, ncent
            i = ii - 1
            k = i
            pp = qmo(imo, i)
            do j = ii, ncent
               if (qmo(imo, j) < pp) cycle
               k = j
               pp = qmo(imo, j)
            end do
            if (k == i) cycle
            qmo(imo, k) = qmo(imo, i)
            qmo(imo, i) = pp

            ihilf = imem(i)
            imem(i) = imem(k)
            imem(k) = ihilf
         end do

      end SUBROUTINE wibsort

   end subroutine print_wiberg

   subroutine print_wbo_fragment(iunit, n, at, wbo, thr)
      use xtb_type_atomlist
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      real(wp), intent(in) :: wbo(n, n)
      real(wp), intent(in) :: thr

      type(TAtomList) :: atl

      real(wp), allocatable :: bond(:, :)
      integer, allocatable :: cn(:)
      integer, allocatable :: fragment(:)
      integer, allocatable :: list(:)
      character(len=:), allocatable :: string
      integer :: i, j, k, nfrag
      real(wp) :: xsum

      allocate (fragment(n), cn(n), list(n), source=0)
      allocate (bond(n, n), source=0.0_wp)
      where (wbo > thr)
         bond = min(wbo, 1.0_wp)
      elsewhere
         bond = 0.0_wp
      end where
      forall (i=1:n) cn(i) = sum(ceiling(bond(:, i)))

      call mrec(nfrag, cn, bond, n, at, fragment)

      write (iunit, '(a)')
      if (nfrag > 1) then
         write (iunit, '(1x,"*",1x,i0,1x,a)', advance='no') &
            nfrag, "fragments found"
      else
         write (iunit, '(1x,"*",1x,a)', advance='no') &
            "no fragments found"
      end if
      write (iunit, '(1x,"(WBO >",f5.2,")")') thr
      write (iunit, '(a)')
      do i = 1, nfrag
         call atl%new
         call atl%add(fragment == i)
         call atl%to_string(string)
         write (iunit, '(3x,a,"(",i0,"):",1x,a)') "fragment", i, string
      end do

   contains
      subroutine mrec(molcount, cn, bond, n, at, molvec)
         ! molcount: number of total fragments (increased during search)
         ! xyz: overall Cart. coordinates
         ! n: overall number of atoms
         ! at: atomic number array
         ! molvec: assignment vector of atom to fragment
         implicit none
         integer, intent(in) :: cn(n)
         integer, intent(in) :: n, at(n)
         integer, intent(inout) :: molvec(n), molcount
         real(wp), intent(inout) :: bond(n, n)
         logical, allocatable :: taken(:)
         integer :: i
         allocate (taken(n))
         molvec = 0
         molcount = 1
         taken = .false.
         do i = 1, n
            if (.not. taken(i)) then
               molvec(i) = molcount
               taken(i) = .true.
               call neighbours(i, cn, at, taken, n, bond, molvec, molcount)
               molcount = molcount + 1
            end if
         end do
         molcount = molcount - 1
      end subroutine mrec

      recursive subroutine neighbours(i, cn, at, taken, n, bond, &
         &                                molvec, molcnt)
         implicit none
         integer, intent(in) :: cn(n)
         real(wp), intent(inout) :: bond(n, n)
         integer, intent(in) :: i, n, at(n)
         integer, intent(inout) :: molcnt, molvec(n)
         logical, intent(inout) :: taken(n)
         integer :: j, icn, k

         icn = cn(i)
         do k = 1, icn
            j = maxloc(bond(:, i), 1)
            bond(j, i) = 0
            if (i == j) cycle
            if (.not. taken(j)) then
               molvec(j) = molcnt
               taken(j) = .true.
               call neighbours(j, cn, at, taken, n, bond, molvec, molcnt)
            end if
         end do
      end subroutine neighbours

   end subroutine print_wbo_fragment

   subroutine print_molpol(iunit, n, at, sym, xyz, q, wf, g_a, g_c, dispm)
      use xtb_disp_dftd4
      use xtb_disp_ncoord
      use xtb_eeq
      use xtb_type_dispersionmodel
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      character(len=*), intent(in) :: sym(n)
      real(wp), intent(in) :: xyz(3, n)
      real(wp), intent(in) :: q(n)
      real(wp), intent(in) :: wf
      real(wp), intent(in) :: g_a
      real(wp), intent(in) :: g_c
      type(TDispersionModel), intent(in) :: dispm

      integer :: i
      integer :: dispdim
      real(wp) :: molpol, molc6, molc8
      real(wp), allocatable :: covcn(:)   ! covalent coordination number
      real(wp), allocatable :: gw(:)      ! gaussian weights for references
      real(wp), allocatable :: c6ref(:, :) ! unscaled reference C6
      real(wp), allocatable :: aw(:, :)    ! frequency dependent polarizibilities
      real(wp), allocatable :: c6ab(:, :)  ! actual C6 coeffients

      call d4dim(dispm, n, at, dispdim)
      allocate (covcn(n), aw(23, n), c6ab(n, n), gw(dispdim), &
                c6ref(dispdim, dispdim), source=0.0_wp)

      call ncoord_d4(n, at, xyz, covcn, thr=1600.0_wp)
      call d4(dispm, n, dispdim, at, wf, g_a, g_c, covcn, gw, c6ref)
      call mdisp(dispm, n, dispdim, at, q, xyz, g_a, g_c, gw, c6ref, &
                 molc6, molc8, molpol, aout=aw, cout=c6ab)

      write (iunit, '(a)')
      write (iunit, '("     #   Z     ")', advance='no')
      write (iunit, '("     covCN")', advance='no')
      write (iunit, '("         q")', advance='no')
      write (iunit, '("      C6AA")', advance='no')
      write (iunit, '("      α(0)")', advance='no')
      write (iunit, '(a)')
      do i = 1, n
         write (iunit, '(i6,1x,i3,1x,a4)', advance='no') &
         &     i, at(i), sym(i)
         write (iunit, '(f10.3)', advance='no') covcn(i)
         write (iunit, '(f10.3)', advance='no') q(i)
         write (iunit, '(f10.3)', advance='no') c6ab(i, i)
         write (iunit, '(f10.3)', advance='no') aw(1, i)
         write (iunit, '(a)')
      end do
      write (iunit, '(/,1x,"Mol. C6AA /au·bohr⁶  :",f18.6,'// &
      &            '/,1x,"Mol. C8AA /au·bohr⁸  :",f18.6,'// &
      &            '/,1x,"Mol. α(0) /au        :",f18.6,/)') &
      &             molc6, molc8, molpol

   end subroutine print_molpol

   subroutine print_dipole(iunit, n, at, xyz, z, nao, P, dpint)
      use xtb_mctc_convert
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: n
      integer, intent(in) :: at(n)
      real(wp), intent(in) :: xyz(3, n)
      real(wp), intent(in) :: z(n)
      integer, intent(in) :: nao
      real(wp), intent(in) :: P(nao, nao)
      real(wp), intent(in) :: dpint(3, nao, nao)

      integer :: i, j, k
      real(wp) :: d(3), dip

      ! core part
      d = 0.0_wp
      do i = 1, n
         d = d + xyz(:, i) * z(i)
      end do

      ! contraction with P
      k = 0
      do i = 1, nao
         do j = 1, i - 1
            k = k + 1
            d = d - 2.0_wp * P(j, i) * dpint(:, i, j)
         end do
         k = k + 1
         d = d - P(i, i) * dpint(:, i, i)
      end do

      dip = norm2(d)

      write (iunit, '(a)')
      write (iunit, '(1x,"dipole moment from electron density (au)")')
      write (iunit, '(1x,"    X       Y       Z   ")')
      write (iunit, '(3f9.4,"  total (Debye): ",f8.3)') &
            & d(1), d(2), d(3), dip * autod
      write (iunit, '(a)')

   end subroutine print_dipole

   subroutine print_spin_population(iunit, n, at, sym, nao, focca, foccb, S, C, aoat2, lao2)
      use xtb_scc_core, only: dmat, mpop
      implicit none
      integer, intent(in) :: iunit       ! STDOUT
      integer, intent(in) :: n           ! number of atoms
      integer, intent(in) :: at(n)       ! atom types
      character(len=*), intent(in) :: sym(n) ! atom symbols
      integer, intent(in) :: nao         ! number of spherical atomic orbitals
      real(wp), intent(in) :: focca(nao)  ! fractional occupation numbers (alpha)
      real(wp), intent(in) :: foccb(nao)  ! fractional occupation numbers (beta)
      real(wp), intent(in) :: S(nao, nao)  ! overlap matrix
      real(wp), intent(in) :: C(nao, nao)  ! eigenvector/orbitals
      integer, intent(in) :: aoat2(nao)
      integer, intent(in) :: lao2(nao)

      integer :: i
      real(wp), allocatable :: tmp(:)
      real(wp), allocatable :: q(:)
      real(wp), allocatable :: qlmom(:, :)
      real(wp), allocatable :: X(:, :)

      allocate (tmp(nao), q(n), qlmom(3, n), X(nao, nao), source=0.0_wp)

      write (iunit, '("(R)spin-density population")')
      tmp = focca - foccb
      call dmat(nao, tmp, C, X) ! X is scratch
      call mpop(n, nao, aoat2, lao2, S, X, q, qlmom)
      write (iunit, '(a)')
      write (iunit, '(1x,"Mulliken population  n(s)   n(p)   n(d)")')
      do i = 1, n
         write (iunit, '(i6,a4,1f8.4,1x,4f7.3)') &
            &  i, sym(i), q(i), qlmom(1, i), qlmom(2, i), qlmom(3, i)
      end do

   end subroutine print_spin_population

   subroutine print_fod_population(iunit, ifile, n, at, sym, nao, S, C, etemp, emo, ihomoa, &
         & ihomob, aoat2, lao2)
      use xtb_mctc_convert
      use xtb_scc_core
      implicit none
      integer, intent(in) :: iunit       ! STDOUT
      integer, intent(in) :: ifile       ! file handle for printout of FOD population
      integer, intent(in) :: n           ! number of atoms
      integer, intent(in) :: at(n)       ! atom types
      character(len=*), intent(in) :: sym(n)  ! atom symbols
      integer, intent(in) :: nao         ! number of spherical atomic orbitals
      real(wp), intent(in) :: S(nao, nao)  ! overlap matrix
      real(wp), intent(in) :: C(nao, nao)  ! eigenvector/orbitals
      real(wp), intent(in) :: etemp       ! electronic temperature
      real(wp), intent(in) :: emo(nao)    ! orbital energies
      integer, intent(in) :: ihomoa      ! position of HOMO in alpha space
      integer, intent(in) :: ihomob      ! position of HOMO in beta space
      integer, intent(in) :: aoat2(nao)
      integer, intent(in) :: lao2(nao)

      integer :: i
      real(wp), allocatable :: focc(:)    ! fractional occupation numbers
      real(wp), allocatable :: q(:)       ! FOD populations
      real(wp), allocatable :: qlmom(:, :) ! FOD populations per shell
      real(wp), allocatable :: X(:, :)     ! Loewdin orthonormalizer
      real(wp), allocatable :: focca(:)   ! fractional occupation numbers (alpha)
      real(wp), allocatable :: foccb(:)   ! fractional occupation numbers (beta)
      real(wp) :: efa, efb, ga, gb, nfoda, nfodb

      allocate (q(n), qlmom(3, n), X(nao, nao), focca(nao), foccb(nao), focc(nao), &
                source=0.0_wp)

      call makel(nao, S, C, X)
      if (ihomoa + 1 <= nao) &
         call fermismear(.false., nao, ihomoa, etemp, emo, focca, nfoda, efa, ga)
      if (ihomob + 1 <= nao) &
         call fermismear(.false., nao, ihomob, etemp, emo, foccb, nfodb, efb, gb)
      call fodenmak(.true., nao, emo * evtoau, focca, efa)
      call fodenmak(.true., nao, emo * evtoau, foccb, efb)

      focc = focca + foccb
      write (iunit, '(/,"NFOD :",1x,F10.4)') sum(focc)
      q = 0
      qlmom = 0
      call lpop(n, nao, aoat2, lao2, focc, X, 1.0d0, q, qlmom)
      write (iunit, '(a)')
      write (iunit, '(" Loewdin FODpop      n(s)   n(p)   n(d)")')
      do i = 1, n
         write (iunit, '(i6,a4,f8.4,1x,4f7.3)') &
            i, sym(i), q(i), qlmom(1, i), qlmom(2, i), qlmom(3, i)
      end do
      if (ifile /= -1) then
         do i = 1, n
            write (ifile, '(F14.8)') q(i)
         end do
      end if

   end subroutine print_fod_population

   subroutine print_thermo(iunit, nat, nvib_in, at, xyz, freq, etot, htot, gtot, nimag, pr, zp)
      use xtb_mctc_convert
      use xtb_readin
      use xtb_setparam
      use xtb_axis, only: axis2
      use xtb_thermo
      implicit none
      integer, intent(in) :: iunit
      logical, intent(in) :: pr
      integer, intent(in) :: nat
      integer, intent(in) :: at(nat)
      integer, intent(in) :: nvib_in
      real(wp), intent(in) :: freq(3 * nat)
      real(wp), intent(in) :: xyz(3, nat)
      real(wp), intent(in) :: etot
      real(wp), intent(out) :: gtot
      real(wp), intent(out) :: htot
      real(wp), intent(out) :: zp

      real(wp) xx(10), sthr, temp, scale_factor
      real(wp) aa, bb, cc, vibthr, ithr
      real(wp) escf, symnum, wt, avmom, diff
      real(wp) :: omega, maxfreq, fswitch, lnq_r, lnq_v
      real(wp), allocatable :: et(:), ht(:), gt(:), ts(:)
      integer nn, nvib, i, j, k, n, nvib_theo, isthr
      integer, intent(out) :: nimag
      real(wp), allocatable :: vibs(:), tmp(:)
      character(len=*), parameter :: outfmt = &
                                     '(9x,"::",1x,a,f24.12,1x,a,1x,"::")'
      character(len=*), parameter :: dblfmt = &
                                     '(10x,":",2x,a,f24.7,1x,a,1x,":")'
      character(len=*), parameter :: intfmt = &
                                     '(10x,":",2x,a,i24,       6x,":")'
      character(len=*), parameter :: chrfmt = &
                                     '(10x,":",2x,a,a24,       6x,":")'

      logical linear, atom, da

      allocate (et(set%nthermo), ht(set%nthermo), gt(set%nthermo), ts(set%nthermo), &
         &      vibs(3 * nat), tmp(3 * nat), source=0.0_wp)

      ! frequencies read in are considered
      ! as being real if .gt. this value in cm-1
      ! this threshold requires projected freqs.!
      vibthr = 1.0
      ithr = set%thermo_ithr

      atom = .false.
      linear = .false.
      sthr = set%thermo_sthr
      if (abs(set%thermo_fscal - 1.0_wp) > 1.0e-8_wp) then
         scale_factor = set%thermo_fscal
      else
         if (set%mode_extrun == p_ext_gfnff) then
            scale_factor = 1.03_wp
         else
            scale_factor = 1.0_wp
         end if
      end if
      nvib = 0
      nimag = 0

   call axis2(nat,xyz,aa,bb,cc,avmom,wt)

      nvib_theo = 3 * nat - 6
      if (cc < 1.d-10) linear = .true.
      if (linear) nvib_theo = 3 * nat - 5

      if (aa + bb + cc < 1.d-6) then
         atom = .true.
         nvib = 0
         nvib_theo = 0
      end if

      ! the rotational number
      call getsymmetry(pr, iunit, nat, at, xyz, set%desy, set%maxatdesy, set%pgroup)
      call getsymnum(set%pgroup, linear, symnum)

      vibs = 0
      do i = 1, 3 * nat
         if (abs(freq(i)) > vibthr .and. i <= nvib_in) then
            nvib = nvib + 1
            vibs(nvib) = freq(i)
         end if
      end do

      ! scale
      vibs(1:nvib) = vibs(1:nvib) * scale_factor

      do i = 1, nvib
         ! artifacts
         if (vibs(i) < 0 .and. vibs(i) > ithr) then
            vibs(i) = -vibs(i)
            if (pr) write (iunit, *) 'inverting freq ', i, vibs(i)
         end if
      end do
      tmp = vibs

      k = nvib
      nvib = 0
      j = 0
      diff = abs(maxval(vibs) - set%thermo_sthr)
      do i = 1, k
         if (tmp(i) > 0) then
            nvib = nvib + 1
            if (abs(tmp(i) - set%thermo_sthr) < diff) then
               diff = abs(tmp(i) - set%thermo_sthr)
               isthr = nvib
            end if
            vibs(nvib) = tmp(i) * rcmtoau ! work in atomic units, seriously
         else
            j = j + 1
         end if
      end do
      nimag = j

      if (pr) then
         write (iunit, '(a)')
         write (iunit, '(10x,51("."))')
         write (iunit, '(10x,":",22x,a,22x,":")') "SETUP"
         write (iunit, '(10x,":",49("."),":")')
         write (iunit, intfmt) "# frequencies    ", nvib
         write (iunit, intfmt) "# imaginary freq.", nimag
         write (iunit, chrfmt) "linear?          ", bool2string(linear)
         write (iunit, chrfmt) "only rotor calc. ", bool2string(nvib == 0)
         write (iunit, chrfmt) "symmetry         ", trim(set%pgroup)
         write (iunit, intfmt) "rotational number", int(symnum)
         write (iunit, dblfmt) "scaling factor   ", scale_factor, "    "
         write (iunit, dblfmt) "rotor cutoff     ", set%thermo_sthr, "cm⁻¹"
         write (iunit, dblfmt) "imag. cutoff     ", ithr, "cm⁻¹"
         write (iunit, '(10x,":",49("."),":")')
      end if

      call print_thermo_sthr_ts(iunit, nvib, vibs, avmom, set%thermo_sthr, set%thermotemp(set%nthermo))

      ! do calc.
      zp = 0.5_wp * sum(vibs(1:nvib))
      do i = 1, set%nthermo
         temp = set%thermotemp(i)
         call thermodyn(iunit, aa, bb, cc, avmom, linear, atom, symnum, wt, vibs, nvib, escf, &
            & temp, sthr, et(i), ht(i), gt(i), ts(i), zp, pr)
         !call oldthermo(aa,bb,cc,avmom,linear,atom,symnum,wt,vibs,nvib,escf, &
         !   & temp,sthr,et(i),ht(i),gt(i),ts(i),zp,pr)
      end do

      write (iunit, '(a)')
      write (iunit, '(a10)', advance='no') "T/K"
      write (iunit, '(a16)', advance='no') "H(0)-H(T)+PV"
      write (iunit, '(a16)', advance='no') "H(T)/Eh"
      write (iunit, '(a16)', advance='no') "T*S/Eh"
      write (iunit, '(a16)', advance='no') "G(T)/Eh"
      write (iunit, '(a)')
      write (iunit, '(3x,72("-"))')
      do i = 1, set%nthermo
         write (iunit, '(3f10.2)', advance='no') set%thermotemp(i)
         write (iunit, '(3e16.6)', advance='no') ht(i)
         write (iunit, '(3e16.6)', advance='no') et(i)
         write (iunit, '(3e16.6)', advance='no') ts(i)
         write (iunit, '(3e16.6)', advance='no') gt(i)
         if (i == set%nthermo .and. set%nthermo > 1) then
            write (iunit, '(1x,"(used)")')
         else
            write (iunit, '(a)')
         end if
      end do
      write (iunit, '(3x,72("-"))')

      gtot = gt(set%nthermo)
      htot = et(set%nthermo)

      write (iunit, '(a)')
      write (iunit, '(9x,53(":"))')
      write (iunit, '(9x,"::",18x,a,18x,"::")') "THERMODYNAMIC"
      write (iunit, '(9x,53(":"))')
      write (iunit, outfmt) "total free energy ", gtot + etot, "Eh  "
      write (iunit, '(9x,"::",49("."),"::")')
      write (iunit, outfmt) "total energy      ", etot, "Eh  "
      write (iunit, outfmt) "zero point energy ", zp, "Eh  "
      write (iunit, outfmt) "G(RRHO) w/o ZPVE  ", gtot - zp, "Eh  "
      write (iunit, outfmt) "G(RRHO) contrib.  ", gtot, "Eh  "
      write (iunit, '(9x,53(":"))')

   end subroutine print_thermo

   subroutine print_thermo_sthr_lnq(iunit, nvib, vibs, avmom, sthr, temp)
      use xtb_mctc_convert
      use xtb_thermo
      implicit none
      integer, intent(in) :: iunit
      integer, intent(in) :: nvib
      real(wp), intent(in) :: vibs(nvib)
      real(wp), intent(in) :: avmom
      real(wp), intent(in) :: sthr
      real(wp), intent(in) :: temp

      integer :: i
      real(wp) :: maxfreq, omega, lnq_r, lnq_v, fswitch

      write (iunit, '(a)')
      maxfreq = max(300.0_wp, chg_inverted(0.99_wp, sthr))
      write (iunit, '(a8,a14,a12,10x,a12,10x,a12)') &
         "mode", "ω/cm⁻¹", "ln{qvib}", "ln{qrot}", "ln{qtot}"
      write (iunit, '(3x,72("-"))')
      do i = 1, nvib
         omega = vibs(i) * autorcm
         lnq_r = lnqvib(temp, omega)
         lnq_v = lnqrot(temp, omega, avmom)
         fswitch = 1.0_wp - chg_switching(omega, sthr)
         if (omega > maxfreq) exit
         write (iunit, '(i8,f10.2,2(f12.5,1x,"(",f6.2,"%)"),f12.5)') &
            i, omega, lnq_v, (1.0_wp - fswitch) * 100, &
            lnq_r, fswitch * 100, (1.0_wp - fswitch) * lnq_v + fswitch * lnq_r
      end do
      write (iunit, '(3x,72("-"))')

   end subroutine print_thermo_sthr_lnq

   subroutine print_thermo_sthr_ts(iunit, nvib, vibs, avmom_si, sthr_rcm, temp)
      use xtb_mctc_constants
      use xtb_mctc_convert
      use xtb_thermo
      implicit none

      integer, intent(in) :: iunit      !< output unit, usually STDOUT
      integer, intent(in) :: nvib       !< number of frequencies
      real(wp), intent(in) :: vibs(nvib) !< frequencies in Eh
      real(wp), intent(in) :: avmom_si   !< average moment
      real(wp), intent(in) :: sthr_rcm   !< rotor cutoff
      real(wp), intent(in) :: temp       !< temperature

      integer :: i
      real(wp) :: maxfreq, omega, s_r, s_v, fswitch
      real(wp) :: beta, xxmom, e, ewj, mu, RT, sthr, avmom
      beta = 1.0_wp / kB / temp ! beta in 1/Eh
      sthr = sthr_rcm * rcmtoau ! sthr in Eh
      RT = kb * temp * autokcal ! RT in kcal/mol for printout
      avmom = avmom_si * kgtome * aatoau**2 * 1.0e+20_wp ! in me·α²

      write (iunit, '(a)')
      maxfreq = max(300.0_wp, chg_inverted(0.99_wp, sthr_rcm))
      write (iunit, '(a8,a14,1x,a27,a27,a12)') &
         "mode", "ω/cm⁻¹", "T·S(HO)/kcal·mol⁻¹", "T·S(FR)/kcal·mol⁻¹", "T·S(vib)"
      write (iunit, '(3x,72("-"))')
      do i = 1, nvib
         ! frequency is Eh
         omega = vibs(i)
         ! omega in Eh, beta in 1/Eh
         ewj = exp(-omega * beta)
         ! moment of intertia corresponding to the rotor with frequency omega
         ! mu is in me·α² (au)
         mu = 0.5_wp / (omega + 1.0e-14_wp)
         ! this reduced moment limits the rotational moment of inertia for
         ! this vibration to that of the total molecule rotation/3
         ! avmom and mu are in au
         mu = mu * avmom / (mu + avmom)
         !              free rotor entropy
         ! Cramer, page 328 for one degree of freedom or
         ! http://cccbdb.nist.gov/thermo.asp, eq. 35, sigma=1
         !              harm. osc. entropy
         if (omega > 0) then
            ! this is S/R which is dimensionless
            s_v = omega * beta * ewj / (1.0_wp - ewj) - log(1.0_wp - ewj)
            s_r = 0.5_wp + log(sqrt(pi / beta * 2.0_wp * mu))
         else
            s_v = 0.0_wp
            s_r = 0.0_wp
         end if
         ! Head-Gordon weighting
         fswitch = 1.0_wp - chg_switching(omega, sthr)
         if (omega > maxfreq * rcmtoau) exit
         write (iunit, '(i8,f10.2,2(f12.5,1x,"(",f6.2,"%)"),f12.5)') &
            i, omega * autorcm, -RT * s_v, (1.0_wp - fswitch) * 100, &
            -RT * s_r, fswitch * 100, -RT * ((1.0_wp - fswitch) * s_v + fswitch * s_r)
      end do
      write (iunit, '(3x,72("-"))')

   end subroutine print_thermo_sthr_ts

   subroutine print_gbsa_info(iunit, sym, gbsa)
      use xtb_mctc_constants
      use xtb_mctc_convert
      use xtb_solv_gbsa, only: TBorn
      implicit none
      integer, intent(in) :: iunit
      character(len=*), intent(in) :: sym(:)
      type(TBorn), intent(in) :: gbsa

      integer :: i

      write (iunit, '(a)')
      write (iunit, '(1x,"*",1x,a)') &
         &  "generalized Born model for continuum solvation"
      write (iunit, '(a)')
      if (gbsa%lhb) then
         write (iunit, '(2x,2a4,5x,3a)') "#", "Z", "Born rad/Å", "   SASA/Å²", "    H-bond"
         do i = 1, size(sym)
            write (iunit, '(i6,1x,i3,1x,a4,3f10.3)') &
               &  i, gbsa%at(i), sym(i), &
               &  gbsa%brad(i) * autoaa, gbsa%sasa(i) * fourpi * autoaa**2, &
               &  gbsa%hbw(i)
         end do
      else
         write (iunit, '(2x,2a4,5x,2a)') "#", "Z", "Born rad/Å", "   SASA/Å²"
         do i = 1, size(sym)
            write (iunit, '(i6,1x,i3,1x,a4,2f10.3)') &
               &  i, gbsa%at(i), sym(i), &
               &  gbsa%brad(i) * autoaa, gbsa%sasa(i) * fourpi * autoaa**2
         end do
      end if
      write (iunit, '(/,1x,"total SASA / Å² :",f13.3)') &
         &  sum(gbsa%sasa) * fourpi * autoaa**2

   end subroutine print_gbsa_info

end module xtb_propertyoutput

subroutine print_orbital_eigenvalues(iunit, wfn, range)
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_convert
   use xtb_type_wavefunction
   implicit none
   integer, intent(in) :: iunit
   integer, intent(in) :: range
   type(TWavefunction), intent(in) :: wfn
   character(len=*), parameter :: hlfmt = '(    a24,f21.7,1x,"Eh",f18.4,1x,"eV")'
   integer :: maxorb, minorb, iorb
   real(wp) :: gap

   minorb = max(wfn%ihomoa - (range + 1), 1)
   maxorb = min(wfn%ihomoa + range, wfn%nao)
   gap = wfn%emo(wfn%ihomoa + 1) - wfn%emo(wfn%ihomoa)

   write (iunit, '(a)')
   write (iunit, '(a10,a14,a21,a21)') "#", "Occupation", "Energy/Eh", "Energy/eV"
   write (iunit, '(6x,61("-"))')
   if (minorb > 1) then
      call write_line(1, wfn%focc, wfn%emo, wfn%ihomo)
      if (minorb > 2) &
         write (iunit, '(a10,a14,a21,a21)') "...", "...", "...", "..."
   end if
   do iorb = minorb, maxorb
      call write_line(iorb, wfn%focc, wfn%emo, wfn%ihomo)
   end do
   if (maxorb < wfn%nao) then
      if (maxorb < wfn%nao - 1) then
         if (wfn%focc(maxorb) > 1.0e-7_wp) then
            write (iunit, '(a10,a14,a21,a21)') "...", "...", "...", "..."
         else
            write (iunit, '(a10,a14,a21,a21)') "...", "", "...", "..."
         end if
      end if
      call write_line(wfn%nao, wfn%focc, wfn%emo, wfn%ihomo)
   end if
   write (iunit, '(6x,61("-"))')
   write (iunit, hlfmt) "HL-Gap", gap * evtoau, gap
   write (iunit, hlfmt) "Fermi-level", (wfn%efa + wfn%efb) / 2 * evtoau, (wfn%efa + wfn%efb) / 2
contains
   subroutine write_line(iorb, focc, emo, ihomo)
      integer, intent(in) :: iorb
      integer, intent(in) :: ihomo
      real(wp), intent(in) :: focc(:)
      real(wp), intent(in) :: emo(:)
      character(len=*), parameter :: mofmt = '(i10,f14.4,f21.7,f21.4)'
      character(len=*), parameter :: vofmt = '(i10,14x,  f21.7,f21.4)'
      if (focc(iorb) < 1.0e-7_wp) then
         write (iunit, vofmt, advance='no') iorb, emo(iorb) * evtoau, emo(iorb)
      else
         write (iunit, mofmt, advance='no') iorb, focc(iorb), emo(iorb) * evtoau, emo(iorb)
      end if
      if (iorb == ihomo) then
         write (iunit, '(1x,"(HOMO)")')
      elseif (iorb == ihomo + 1) then
         write (iunit, '(1x,"(LUMO)")')
      else
         write (iunit, '(a)')
      end if
   end subroutine write_line
end subroutine print_orbital_eigenvalues

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Wigner-Seitz cell based on a neighbour list
module xtb_type_wignerseitzcell
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_search, only : bisectSearch
   use xtb_mctc_sort, only : indexHeapSort
   use xtb_mctc_thresholds, only : tolSameDist2, minNeighDist2
   use xtb_type_environment, only : TEnvironment
   use xtb_type_neighbourlist, only : TNeighbourList, initialNumberOfNeighbours, &
      & resizeNeigh, resizeImage
   implicit none
   private

   public :: TWignerSeitzCell, init


   !> Wigner-Seitz cell based on the infrastructure for the neighbour list
   type, extends(TNeighbourList) :: TWignerSeitzCell
   contains

      !> Generate Wigner-Seitz cell
      procedure :: generate

   end type TWignerSeitzCell


   !> Initialize Wigner-Seitz cell
   interface init
      module procedure :: initWignerSeitzCell
   end interface init


   !> Tolerance for including images in the Wigner-Seitz cell
   real(wp), parameter :: wsTol2 = 0.01_wp**2


contains


!> Initialize Wigner-Seitz cell
subroutine initWignerSeitzCell(self, nAtom)

   !> Instance of the Wigner-Seitz cell
   type(TWignerSeitzCell), intent(out) :: self

   !> Number of atoms in the system
   integer, intent(in) :: nAtom

   allocate(self%neighs(nAtom))
   allocate(self%image(nAtom))
   allocate(self%coords(3, nAtom))
   allocate(self%trans(nAtom))

   allocate(self%iNeigh(0:initialNumberOfNeighbours, nAtom))
   allocate(self%dist2(0:initialNumberOfNeighbours, nAtom))
   allocate(self%weight(0:initialNumberOfNeighbours, nAtom))

   self%cutoff = -1.0_wp

end subroutine initWignerSeitzCell


!> Generate Wigner-Seitz cell
subroutine generate(self, env, coords0, cutoff, latPoint, symmetric)

   !> Source for generating errors
   character(len=*), parameter :: source = 'type_wignerseitzcell_generate'

   !> Instance of the Wigner-Seitz cell
   class(TWignerSeitzCell), intent(inout) :: self

   !> Computation environment
   type(TEnvironment), intent(inout) :: env

   !> Folded coordinates of the atoms inside the unit cell
   real(wp), intent(in) :: coords0(:, :)

   !> Realspace cutoff for the generation of neighbours
   real(wp), intent(in) :: cutoff

   !> Lattice points for all supercells within the cutoff
   real(wp), intent(in) :: latPoint(:, :)

   !> Generate a symmetric map
   logical, intent(in) :: symmetric

   !> Number of atoms in the central cell
   integer :: nAtom

   !> Number of translations to consider
   integer :: nTrans

   !> Capacity of the atom related arrays
   integer :: mImage

   !> Capacity of the neighbour related arrays
   integer :: mNeigh

   !> Index of the current image
   integer :: nImage

   !> Quadratic cutoff
   real(wp) :: cutoff2

   integer :: iTr, iAt, iAtOld, jAt, jAtEnd, iWs, nWs
   real(wp) :: ri(3), dist2, trans(3), wsWeight
   integer, allocatable :: wsTrans(:), indx(:)
   real(wp), allocatable :: wsDist2(:)

   !> Get dimensions for the generator loop
   nAtom = size(self%neighs, dim=1)
   nTrans = size(latPoint, dim=2)
   nImage = nAtom*nTrans

   !> Get initial capacities
   mImage = size(self%coords, dim=2)
   mNeigh = ubound(self%iNeigh, dim=1)

   if (nImage > mImage) then
      call resizeImage(nImage, self%image, self%trans, self%coords)
   end if

   !> Set the value of the cutoff
   self%cutoff = cutoff
   cutoff2 = cutoff**2

   !> Initialize neighbour list with distances from every atom to itself
   self%neighs(:) = 0
   self%iNeigh(:, :) = 0
   self%dist2(:, :) = 0.0_wp
   self%weight(:, :) = 0.0_wp
   do iAt = 1, nAtom
      self%iNeigh(0, iAt) = iAt
      self%weight(0, iAt) = 1.0_wp
      self%coords(:, iAt) = coords0(:, iAt)
      self%image(iAt) = iAt
      self%trans(iAt) = 1
   end do

   !> Allocate scratch space for Wigner-Seitz neighbours
   allocate(wsDist2(nTrans))
   allocate(wsTrans(nTrans))
   allocate(indx(nTrans))

   !> Start with images in the central cell already generated
   nImage = nAtom
   lpIAt: do iAt = 1, nAtom
      if (symmetric) then
         jAtEnd = nAtom
      else
         jAtEnd = iAt
      end if
      lpJAt: do jAt = 1, jAtEnd

         nWs = 0
         lpTrans: do iTr = 1, nTrans
            !> Generate position of image
            ri(:) = coords0(:, iAt) + latPoint(:, iTr)
            dist2 = sum((ri - coords0(:, jAt))**2)
            if (dist2 > cutoff2) then
               cycle lpTrans
            end if

            if (dist2 < minNeighDist2) then
               !> Small distances between the atom and itself are okay
               if (iTr == 1 .and. iAt == jAt) then
                  cycle lpTrans
               else
                  call env%error("Very close distance found", source)
               end if
            end if

            nWs = nWs + 1
            wsDist2(nWs) = dist2
            wsTrans(nWs) = iTr
         end do lpTrans

         if (nWs == 0) cycle lpJAt

         !> Sort the neighbours in the Wigner-Seitz cell
         call indexHeapSort(indx(1:nWs), wsDist2(1:nWs), tolSameDist2)
         wsDist2(1:nWs) = wsDist2(indx(1:nWs))
         wsTrans(1:nWs) = wsTrans(indx(1:nWs))

         !> Drop all but the closest neighbours
         call bisectSearch(nWs, wsDist2(1:nWs), wsDist2(1)+wsTol2, tolSameDist2)
         wsWeight = 1.0_wp/real(nWs, wp)

         !> Make sure the capacity of the arrays is large enough
         if (nImage + nWs > mImage) then
            mImage = max(2*mImage, mImage + 2*nWs)
            call resizeImage(mImage, self%image, self%trans, self%coords)
         end if
         if (self%neighs(jAt) + nWs > mNeigh) then
            mNeigh = max(2*mNeigh, mNeigh + 2*nWs)
            call resizeNeigh(mNeigh, self%iNeigh, self%dist2, self%weight)
         end if

         !> Store the Wigner-Seitz cell
         do iWs = 1, nWs
            iTr = wsTrans(iWs)
            if (iTr /= 1) then
               nImage = nImage + 1
               self%coords(:, nImage) = coords0(:, iAt) + latPoint(:, wsTrans(iWs))
               self%image(nImage) = iAt
               self%trans(nImage) = iTr
               self%iNeigh(self%neighs(jAt)+iWs, jAt) = nImage
            else
               self%iNeigh(self%neighs(jAt)+iWs, jAt) = iAt
            end if
            self%dist2(self%neighs(jAt)+iWs, jAt) = wsDist2(iWs)
            self%weight(self%neighs(jAt)+iWs, jAt) = wsWeight
         end do
         self%neighs(jAt) = self%neighs(jAt) + nWs

      end do lpJAt
   end do lpIAt

   call resizeImage(nImage, self%image, self%trans, self%coords)

   call self%sort

end subroutine generate


end module xtb_type_wignerseitzcell

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
! Copyright (C) 2020, NVIDIA CORPORATION. All rights reserved.
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_disp_dftd4
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants, only : pi
   use xtb_mctc_param, only: gam => chemical_hardness
   use xtb_mctc_blas, only : mctc_gemv
   !! ========================================================================
   !  mix in the covalent coordination number from the ncoord module
   !  also get the CN-Parameters to inline the CN-derivative in the gradient
   use xtb_disp_dftd4param, only: zeff, thopi, ootpi, p_mbd_none, p_mbd_rpalike, &
      &                   p_mbd_exact_atm, p_mbd_approx_atm, p_refq_goedecker, &
      &                   p_refq_gfn2xtb
   use xtb_param_sqrtzr4r2, only : sqrtZr4r2
   use xtb_type_dispersionmodel
   use xtb_type_molecule, only : TMolecule, len
   use xtb_type_neighbourlist, only : TNeighbourList
   use xtb_type_param, only : dftd_parameter
   implicit none


   interface d4_gradient
      module procedure :: d4_full_gradient_neigh
      module procedure :: d4_full_gradient_latp
      module procedure :: d4_gradient_neigh
      module procedure :: d4_gradient_latp
   end interface d4_gradient


   interface d4_atm_gradient
      module procedure :: d4_atm_gradient_neigh
      module procedure :: d4_atm_gradient_latp
   end interface d4_atm_gradient


contains

subroutine newD3Model(dispm,nat,at)
   use xtb_disp_dftd4param
   implicit none
   type(TDispersionModel), intent(out) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)

   integer  :: i,ia,is,icn,j,ja,ii,jj,ij
   integer  :: cncount(0:18)
   real(wp) :: alpha(23),c6

   intrinsic :: nint

   call init(dispm, maxElem=maxval(at))

   dispm%atoms = 0
   dispm%nref = 0.0_wp

   !> set up ncount und alpha, also obtain the dimension of the dispmat
   do i = 1, nat
      ia = at(i)
      if (dispm%atoms(ia).eq.0) then
         dispm%nref(ia) = refn(ia)
         do j = 1, dispm%nref(ia)
            is = refsys(j,ia)
            alpha = sscale(is)*secaiw(:,is)
            dispm%cn(j,ia) = refcn(j,ia)
            dispm%alpha(:,j,ia) = max(ascale(j,ia)*(alphaiw(:,j,ia) &
               &                - hcount(j,ia)*alpha), 0.0_wp)
         enddo
      endif
      dispm%atoms(ia) = dispm%atoms(ia)+1
   enddo

   ! integrate C6 coefficients
   do i = 1, maxval(at)
      do j = 1, i
         if (dispm%atoms(i) > 0 .and. dispm%atoms(j) > 0) then
            do ii = 1, dispm%nref(i)
               do jj = 1, dispm%nref(j)
                  alpha = dispm%alpha(:,ii,i)*dispm%alpha(:,jj,j)
                  c6 = thopi * trapzd(alpha)
                  dispm%c6(ii,jj,i,j) = c6
                  dispm%c6(jj,ii,j,i) = c6
               enddo
            enddo
         endif
      enddo
   enddo

end subroutine newD3Model

subroutine newD4Model(dispm,g_a,g_c,mode)
   use xtb_disp_dftd4param
   type(TDispersionModel), intent(out) :: dispm
   real(wp),intent(in)  :: g_a,g_c
   integer, intent(in)  :: mode

   integer  :: i,ia,is,icn,j,ii,jj
   integer  :: cncount(0:18)
   real(wp) :: sec_al(23),iz,c6,alpha(23)
   real(wp) :: tmp_hq(7,118)

   intrinsic :: nint

   call init(dispm)

   secq = 0.0_wp
   select case(mode)
   case(p_refq_hirshfeld,p_refq_periodic)
!     print'(1x,''* using PBE0/def2-TZVP Hirshfeld charges'')'
      refq = dftq
      refh = dfth
      secq = dfts
!  case(2)
!     refq = pbcq
!     refh = pbch
!     secq = pbcs
   case(p_refq_gasteiger)
!     print'(1x,''* using classical Gasteiger charges'')'
      refq = gffq
      refh = gffh
      secq = gffs
   case(p_refq_goedecker)
      refq = clsq
      refh = clsh
      secq = clss
   case(p_refq_gfn2xtb_gbsa_h2o)
!     print'(1x,''* using GFN2-xTB//GBSA(H2O) charges'')'
      refq = solq
      refh = solh
      secq = sols
   end select

   select case(mode)
   case(p_refq_hirshfeld,p_refq_periodic)
      dispm%q = dftq
      tmp_hq = dfth
   case(p_refq_gasteiger)
      dispm%q = gffq
      tmp_hq = gffh
   case(p_refq_goedecker)
      dispm%q = clsq
      tmp_hq = clsh
   case(p_refq_gfn2xtb_gbsa_h2o)
      dispm%q = solq
      tmp_hq = solh
   case default
      dispm%q = refq
      tmp_hq = refh
   end select

   dispm%atoms = 0
   dispm%nref = 0

   do ia = 1, 118
      cncount = 0
      cncount(0) = 1
      dispm%nref(ia) = refn(ia)
      do j = 1, refn(ia)
         is = refsys(j,ia)
         iz = zeff(is)
         sec_al = sscale(is)*secaiw(:,is) &
            &  * zeta(g_a,gam(is)*g_c,secq(is)+iz,tmp_hq(j,ia)+iz)
         dispm%cn(j,ia) = refcovcn(j,ia)
         icn =nint(refcn(j,ia))
         cncount(icn) = cncount(icn) + 1
         dispm%alpha(:,j,ia) = max(ascale(j,ia)*(alphaiw(:,j,ia)-hcount(j,ia)*sec_al),0.0_wp)
      enddo
      do j = 1, refn(ia)
         icn = cncount(nint(refcn(j,ia)))
         dispm%ncount(j,ia) = icn*(icn+1)/2
      enddo
   end do

   ! integrate C6 coefficients
   do i = 1, 118
      do j = 1, i
         do ii = 1, dispm%nref(i)
            do jj = 1, dispm%nref(j)
               alpha = dispm%alpha(:,ii,i)*dispm%alpha(:,jj,j)
               c6 = thopi * trapzd(alpha)
               dispm%c6(jj,ii,j,i) = c6
               dispm%c6(ii,jj,i,j) = c6
            enddo
         enddo
      enddo
   enddo

end subroutine newD4Model

subroutine d4dim(dispm,nat,at,ndim)
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   integer, intent(out) :: ndim

   integer :: i

   ndim = 0

   do i = 1, nat
      ndim = ndim + dispm%nref(at(i))
   enddo

end subroutine d4dim

subroutine prmolc6(molc6,molc8,molpol,nat,at,  &
      & cn,covcn,q,qlmom,c6ab,alpha,rvdw,hvol)
   use xtb_mctc_convert, only : autoaa
   use xtb_mctc_io, only : stdout
   use xtb_mctc_symbols, only : toSymbol
   real(wp),intent(in)  :: molc6
   real(wp),intent(in)  :: molc8
   real(wp),intent(in)  :: molpol
   integer, intent(in)  :: nat
   integer, intent(in)  :: at(nat)
   real(wp),intent(in),optional :: cn(nat)
   real(wp),intent(in),optional :: covcn(nat)
   real(wp),intent(in),optional :: q(nat)
   real(wp),intent(in),optional :: qlmom(3,nat)
   real(wp),intent(in),optional :: c6ab(nat,nat)
   real(wp),intent(in),optional :: alpha(nat)
   real(wp),intent(in),optional :: rvdw(nat)
   real(wp),intent(in),optional :: hvol(nat)
   integer :: i
   if(present(cn).or.present(covcn).or.present(q).or.present(c6ab) &
   &   .or.present(alpha).or.present(rvdw).or.present(hvol)) then
   write(stdout,'(a)')
   write(stdout,'(''   #   Z   '')',advance='no')
   if(present(cn))   write(stdout,'(''        CN'')',advance='no')
   if(present(covcn))write(stdout,'(''     covCN'')',advance='no')
   if(present(q))    write(stdout,'(''         q'')',advance='no')
   if(present(qlmom))write(stdout,   '(''   n(s)'')',advance='no')
   if(present(qlmom))write(stdout,   '(''   n(p)'')',advance='no')
   if(present(qlmom))write(stdout,   '(''   n(d)'')',advance='no')
   if(present(c6ab)) write(stdout,'(''      C6AA'')',advance='no')
   if(present(alpha))write(stdout,'(''      α(0)'')',advance='no')
   if(present(rvdw)) write(stdout,'(''    RvdW/Å'')',advance='no')
   if(present(hvol)) write(stdout,'(''    relVol'')',advance='no')
   write(*,'(a)')
   do i=1,nat
      write(*,'(i4,1x,i3,1x,a2)',advance='no') &
      &     i,at(i),toSymbol(at(i))
      if(present(cn))   write(stdout,'(f10.3)',advance='no')cn(i)
      if(present(covcn))write(stdout,'(f10.3)',advance='no')covcn(i)
      if(present(q))    write(stdout,'(f10.3)',advance='no')q(i)
      if(present(qlmom))write(stdout, '(f7.3)',advance='no')qlmom(1,i)
      if(present(qlmom))write(stdout, '(f7.3)',advance='no')qlmom(2,i)
      if(present(qlmom))write(stdout, '(f7.3)',advance='no')qlmom(3,i)
      if(present(c6ab)) write(stdout,'(f10.3)',advance='no')c6ab(i,i)
      if(present(alpha))write(stdout,'(f10.3)',advance='no')alpha(i)
      if(present(rvdw)) write(stdout,'(f10.3)',advance='no')rvdw(i)*autoaa
      if(present(hvol)) write(stdout,'(f10.3)',advance='no')hvol(i)
      write(*,'(a)')
   enddo
   endif
   write(stdout,'(/,1x,''Mol. C6AA /au·bohr⁶  :'',f18.6,'// &
   &         '/,1x,''Mol. C8AA /au·bohr⁸  :'',f18.6,'// &
   &         '/,1x,''Mol. α(0) /au        :'',f18.6,/)') &
   &          molc6,molc8,molpol
end subroutine prmolc6

subroutine mdisp(dispm,nat,ndim,at,q,xyz,g_a,g_c, &
      &     gw,c6abns,molc6,molc8,molpol,aout,cout,rout,vout)
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: ndim
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: q(nat) 
   real(wp),intent(in)  :: xyz(3,nat) 
   real(wp),intent(in)  :: g_a,g_c
   real(wp),intent(in)  :: gw(ndim)
   real(wp),intent(in)  :: c6abns(ndim,ndim)
   real(wp),intent(out) :: molc6
   real(wp),intent(out) :: molc8
   real(wp),intent(out) :: molpol
   real(wp),intent(out),optional :: aout(23,nat)
   real(wp),intent(out),optional :: cout(nat,nat)
   real(wp),intent(out),optional :: rout(nat)
   real(wp),intent(out),optional :: vout(nat)

   integer  :: i,ii,ia,j,jj,ja,k,l
   integer, allocatable :: itbl(:,:)
   real(wp) :: qmod,oth,iz
   real(wp),allocatable :: zetvec(:)
   real(wp),allocatable :: rvdw(:)
   real(wp),allocatable :: phv(:)
   real(wp),allocatable :: c6ab(:,:)
   real(wp),allocatable :: aw(:,:)
   parameter (oth=1._wp/3._wp)
   
   allocate( zetvec(ndim),rvdw(nat),phv(nat),c6ab(nat,nat),aw(23,nat), &
   &         source = 0.0_wp )
   allocate( itbl(7,nat), source = 0 )

   molc6  = 0._wp
   molc8  = 0._wp
   molpol = 0._wp

   k = 0
   do i = 1, nat
      ia = at(i)
      iz = zeff(ia)
      do ii = 1, dispm%nref(ia)
         k = k+1
         itbl(ii,i) = k
         zetvec(k) = gw(k) * zeta(g_a,gam(ia)*g_c,dispm%q(ii,ia)+iz,q(i)+iz)
         aw(:,i) = aw(:,i) + zetvec(k) * dispm%alpha(:,ii,ia)
      enddo
!     van-der-Waals radius, alpha = 4/3 pi r**3 <=> r = (3/(4pi) alpha)**(1/3)
      rvdw(i) = (0.25_wp*thopi*aw(1,i))**oth
!     pseudo-hirshfeld volume
      phv(i) = aw(1,i)/dispm%alpha(1,1,ia)
      c6ab(i,i) = thopi * trapzd(aw(:,i)**2)
      molpol = molpol + aw(1,i)
      molc6  = molc6  + c6ab(i,i)
      molc8 = molc8 + 3*sqrtZr4r2(ia)**2*c6ab(i,i)
      do j = 1, i-1
         ja = at(j)
         c6ab(j,i) = thopi * trapzd(aw(:,i)*aw(:,j))
         c6ab(i,j) = c6ab(j,i)
         molc6 = molc6 + 2*c6ab(j,i)
         molc8 = molc8 + 6*sqrtZr4r2(ia)*sqrtZr4r2(ja)*c6ab(j,i)
      enddo
   enddo

   if (present(aout)) aout = aw
   if (present(vout)) vout = phv
   if (present(rout)) rout = rvdw
   if (present(cout)) cout = c6ab

end subroutine mdisp

pure elemental function zeta(a,c,qref,qmod)
   !$acc routine seq
   real(wp),intent(in) :: qmod,qref
   real(wp),intent(in) :: a,c
   real(wp)            :: zeta

   intrinsic :: exp

   if (qmod.lt.0._wp) then
      zeta = exp( a )
   else
      zeta = exp( a * ( 1._wp - exp( c * ( 1._wp - qref/qmod ) ) ) )
   endif

end function zeta

pure elemental function dzeta(a,c,qref,qmod)
   !$acc routine seq
   real(wp),intent(in) :: qmod,qref
   real(wp),intent(in) :: a,c
   real(wp)            :: dzeta

   intrinsic :: exp

   if (qmod.lt.0._wp) then
      dzeta = 0._wp
   else
      dzeta = - a * c * exp( c * ( 1._wp - qref/qmod ) ) &
      &           * zeta(a,c,qref,qmod) * qref / ( qmod**2 )
   endif

end function dzeta

pure function trapzd(pol)
   real(wp),intent(in) :: pol(23)
   real(wp)            :: trapzd

   real(wp)            :: tmp1, tmp2
   real(wp),parameter  :: freq(23) = (/ &
&   0.000001_wp,0.050000_wp,0.100000_wp, &
&   0.200000_wp,0.300000_wp,0.400000_wp, &
&   0.500000_wp,0.600000_wp,0.700000_wp, &
&   0.800000_wp,0.900000_wp,1.000000_wp, &
&   1.200000_wp,1.400000_wp,1.600000_wp, &
&   1.800000_wp,2.000000_wp,2.500000_wp, &
&   3.000000_wp,4.000000_wp,5.000000_wp, &
&   7.500000_wp,10.00000_wp /)
!  just precalculate all weights and get the job done
   real(wp),parameter :: weights(23) = 0.5_wp * (/ &
&  ( freq (2) - freq (1) ),  &
&  ( freq (2) - freq (1) ) + ( freq (3) - freq (2) ),  &
&  ( freq (3) - freq (2) ) + ( freq (4) - freq (3) ),  &
&  ( freq (4) - freq (3) ) + ( freq (5) - freq (4) ),  &
&  ( freq (5) - freq (4) ) + ( freq (6) - freq (5) ),  &
&  ( freq (6) - freq (5) ) + ( freq (7) - freq (6) ),  &
&  ( freq (7) - freq (6) ) + ( freq (8) - freq (7) ),  &
&  ( freq (8) - freq (7) ) + ( freq (9) - freq (8) ),  &
&  ( freq (9) - freq (8) ) + ( freq(10) - freq (9) ),  &
&  ( freq(10) - freq (9) ) + ( freq(11) - freq(10) ),  &
&  ( freq(11) - freq(10) ) + ( freq(12) - freq(11) ),  &
&  ( freq(12) - freq(11) ) + ( freq(13) - freq(12) ),  &
&  ( freq(13) - freq(12) ) + ( freq(14) - freq(13) ),  &
&  ( freq(14) - freq(13) ) + ( freq(15) - freq(14) ),  &
&  ( freq(15) - freq(14) ) + ( freq(16) - freq(15) ),  &
&  ( freq(16) - freq(15) ) + ( freq(17) - freq(16) ),  &
&  ( freq(17) - freq(16) ) + ( freq(18) - freq(17) ),  &
&  ( freq(18) - freq(17) ) + ( freq(19) - freq(18) ),  &
&  ( freq(19) - freq(18) ) + ( freq(20) - freq(19) ),  &
&  ( freq(20) - freq(19) ) + ( freq(21) - freq(20) ),  &
&  ( freq(21) - freq(20) ) + ( freq(22) - freq(21) ),  &
&  ( freq(22) - freq(21) ) + ( freq(23) - freq(22) ),  &
&  ( freq(23) - freq(22) ) /)

!!  do average between trap(1)-trap(22) .and. trap(2)-trap(23)
!   tmp1 = 0.5_wp * ( &
!&  ( freq (2) - freq (1) ) * ( pol (2) + pol (1) )+ &
!&  ( freq (4) - freq (3) ) * ( pol (4) + pol (3) )+ &
!&  ( freq (6) - freq (5) ) * ( pol (6) + pol (5) )+ &
!&  ( freq (8) - freq (7) ) * ( pol (8) + pol (7) )+ &
!&  ( freq(10) - freq (9) ) * ( pol(10) + pol (9) )+ &
!&  ( freq(12) - freq(11) ) * ( pol(12) + pol(11) )+ &
!&  ( freq(14) - freq(13) ) * ( pol(14) + pol(13) )+ &
!&  ( freq(16) - freq(15) ) * ( pol(16) + pol(15) )+ &
!&  ( freq(18) - freq(17) ) * ( pol(18) + pol(17) )+ &
!&  ( freq(20) - freq(19) ) * ( pol(20) + pol(19) )+ &
!&  ( freq(22) - freq(21) ) * ( pol(22) + pol(21) ))
!   tmp2 = 0.5_wp * ( &
!&  ( freq (3) - freq (2) ) * ( pol (3) + pol (2) )+ &
!&  ( freq (5) - freq (4) ) * ( pol (5) + pol (4) )+ &
!&  ( freq (7) - freq (6) ) * ( pol (7) + pol (6) )+ &
!&  ( freq (9) - freq (8) ) * ( pol (9) + pol (8) )+ &
!&  ( freq(11) - freq(10) ) * ( pol(11) + pol(10) )+ &
!&  ( freq(13) - freq(12) ) * ( pol(13) + pol(12) )+ &
!&  ( freq(15) - freq(14) ) * ( pol(15) + pol(14) )+ &
!&  ( freq(17) - freq(16) ) * ( pol(17) + pol(16) )+ &
!&  ( freq(19) - freq(18) ) * ( pol(19) + pol(18) )+ &
!&  ( freq(21) - freq(20) ) * ( pol(21) + pol(20) )+ &
!&  ( freq(23) - freq(22) ) * ( pol(23) + pol(22) ))

   trapzd = sum(pol*weights)

end function trapzd

pure elemental function cngw(wf,cn,cnref)
   !$acc routine seq
   real(wp),intent(in) :: wf,cn,cnref
   real(wp)            :: cngw ! CN-gaussian-weight

   intrinsic :: exp

   cngw = exp ( -wf * ( cn - cnref )**2 )

end function cngw

pure elemental function dcngw(wf,cn,cnref)
   real(wp),intent(in) :: wf,cn,cnref
   real(wp) :: dcngw

   dcngw = 2*wf*(cnref-cn)*cngw(wf,cn,cnref)

end function dcngw

!* BJ damping function ala DFT-D3(BJ)
!  f(n,rab) = sn*rab**n/(rab**n + R0**n)  w/ R0 = a1*sqrt(C6/C8)+a2
!  see: https://doi.org/10.1002/jcc.21759
pure elemental function fdmpr_bj(n,r,c) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp) :: fdmp
   fdmp = 1.0_wp / ( r**n + c**n )
end function fdmpr_bj
pure elemental function fdmprdr_bj(n,r,c) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp) :: dfdmp
   dfdmp = -n*r**(n-1) * fdmpr_bj(n,r,c)**2
end function fdmprdr_bj

!* original DFT-D3(0) damping
!  f(n,rab) = sn/(1+6*(4/3*R0/rab)**alp)  w/ R0 of unknown origin
pure elemental function fdmpr_zero(n,r,c,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: fdmp
   fdmp = 1.0_wp / (r**n*(1 + six * (c/r)**(n+alp)))
end function fdmpr_zero
pure elemental function fdmprdr_zero(n,r,c,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: dfdmp
   dfdmp = -( n*r**(n-1)*(1+six*(c/r)**(alp)) &
             - alp*r**n/c*six*(c/r)**(alp-1) ) &
           * fdmpr_zero(n,r,c,alp)**2
!  fdmp = 1.0_wp / (r**n*(1 + 6.0_wp * (c/r)**(n+alp)))
end function fdmprdr_zero

!* fermi damping function from TS and MBD methods
!  f(n,rab) = sn/(1+exp[-alp*(rab/R0-1)]) w/ R0 as experimenal vdW-Radii
pure elemental function fdmpr_fermi(n,r,c,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: fdmp
   fdmp = 1.0_wp / (r**n*(1.0_wp+exp(-alp*(r/c - 1.0))))
end function fdmpr_fermi
pure elemental function fdmprdr_fermi(n,r,c,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: dfdmp
   dfdmp = -(-alp/c*r**n*exp(-alp*(r/c - 1.0)) &
             + n*r**(n-1)*(1.0_wp+exp(-alp*(r/c - 1.0)))) &
             * fdmpr_fermi(n,r,c,alp)**2
end function fdmprdr_fermi

!* optimized power zero damping (M. Head-Gordon)
!  f(n,rab) = sn*rab**(n+alp)/(rab**(n+alp) + R0**(n+alp))
!  see: https://dx.doi.org/10.1021/acs.jpclett.7b00176
pure elemental function fdmpr_op(n,r,c,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: fdmp
   fdmp = r**alp / (r**(n+alp)*c**(n+alp))
end function fdmpr_op
pure elemental function fdmprdr_op(n,r,c,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   integer, intent(in)  :: alp
   real(wp) :: dfdmp
   dfdmp = (alp*r*(alp-1) - (n+alp)*r**alp*r**(n+alp-1)) &
           * fdmpr_op(n,r,c,alp)**2
!  fdmp = r**alp / (r**(n+alp)*c**(n+alp))
end function fdmprdr_op

!* Sherrill's M-zero damping function
!  f(n,rab) = sn/(1+6*(4/3*R0/rab+a2*R0)**(-alp))
!  see: https://dx.doi.org/10.1021/acs.jpclett.6b00780
pure elemental function fdmpr_zerom(n,r,c,rsn,alp) result(fdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp),intent(in)  :: rsn
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: fdmp
   fdmp = 1.0_wp / (r**n*(1 + six * (r/c+rsn*c)**(-alp)))
end function fdmpr_zerom
pure elemental function fdmprdr_zerom(n,r,c,rsn,alp) result(dfdmp)
   integer, intent(in)  :: n
   real(wp),intent(in)  :: r
   real(wp),intent(in)  :: c
   real(wp),intent(in)  :: rsn
   integer, intent(in)  :: alp
   real(wp),parameter   :: six = 6.0_wp
   real(wp) :: dfdmp
   dfdmp = -( n*r**(n-1)*(1+six*(r/c+rsn*c)**(-alp)) &
              - alp*r**n/c*six*(r/c+rsn*c)**(-alp-1) ) &
           * fdmpr_zerom(n,r,c,rsn,alp)**2
end function fdmprdr_zerom


subroutine d4(dispm,nat,ndim,at,wf,g_a,g_c,covcn,gw,c6abns)
   use xtb_mctc_accuracy, only : wp
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: ndim
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: wf,g_a,g_c
   real(wp),intent(in)  :: covcn(nat)
   real(wp),intent(out) :: gw(ndim)
   real(wp),intent(out) :: c6abns(ndim,ndim)

   integer  :: i,ia,is,icn,ii,iii,j,jj,ja,k,l
   integer,allocatable :: itbl(:,:)
   real(wp) :: twf,norm,aiw(23)

   intrinsic :: maxval

   allocate( itbl(7,nat), source = 0 )

   gw = 0._wp
   c6abns = 0._wp

   k = 0
   do i = 1, nat
      do ii = 1, dispm%nref(at(i))
         k = k+1
         itbl(ii,i) = k
      enddo
   enddo

   do i = 1, nat
      ia = at(i)
      norm = 0.0_wp
      do ii = 1, dispm%nref(ia)
         do iii = 1, dispm%ncount(ii,ia)
            twf = iii*wf
            norm = norm + cngw(twf,covcn(i),dispm%cn(ii,ia))
         enddo
      enddo
      norm = 1._wp / norm
      do ii = 1, dispm%nref(ia)
         k = itbl(ii,i)
         do iii = 1, dispm%ncount(ii,ia)
            twf = iii*wf
            gw(k) = gw(k) + cngw(twf,covcn(i),dispm%cn(ii,ia)) * norm
         enddo
!    --- okay, if we run out of numerical precision, gw(k) will be NaN.
!        In case it is NaN, it will not match itself! So we can rescue
!        this exception. This can only happen for very high CNs.
         if (gw(k).ne.gw(k)) then
            if (maxval(dispm%cn(:dispm%nref(ia),ia)).eq.dispm%cn(ii,ia)) then
               gw(k) = 1.0_wp
            else
               gw(k) = 0.0_wp
            endif
         endif
         do j = 1, i-1
            ja = at(j)
            do jj = 1, dispm%nref(ja)
               l = itbl(jj,j)
               c6abns(l,k) = dispm%c6(ii,jj,ia,ja)
               c6abns(k,l) = c6abns(l,k)
            enddo
         enddo
      enddo
   enddo

end subroutine d4


subroutine build_wdispmat(dispm,nat,ndim,at,itbl,xyz,par,c6abns,gw,wdispmat)
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: ndim
   integer, intent(in)  :: at(:)
   integer, intent(in)  :: itbl(:)
   real(wp),intent(in)  :: xyz(:, :)
   type(dftd_parameter),intent(in)  :: par
   real(wp),intent(in)  :: c6abns(:, :)
   real(wp),intent(in)  :: gw(:)
   real(wp),intent(out) :: wdispmat(:, :)

   integer :: i,ii,ia,j,jj,ja,k,l
   real(wp) :: c8abns,c10abns,r2,cutoff,oor6,oor8,oor10,r,gwgw,r4r2ij
   real(wp), parameter :: rthr = 72.0_wp ! slightly larger than in gradient
   real(wp), parameter :: gwcut = 1.0e-7_wp

   ! acc enter data create(wdispmat) copyin(at, xyz, itbl, dispm, dispm%nref, &
   ! acc& c6abns, gw, par)
 
   ! acc kernels default(present)
   wdispmat = 0.0_wp
   ! acc end kernels

!#ifdef XTB_GPU
   ! acc parallel default(present)
   ! acc loop gang collapse(2) private(r4r2ij, cutoff, r2, oor6, oor8, oor10)
!#else
   !$omp parallel do shared(wdispmat) &
   !$omp shared(nat, at, xyz, itbl, par, dispm, c6abns, gw) &
   !$omp private(ia, k, j, ja, l, r4r2ij, cutoff, r2, oor6, oor8, oor10, &
   !$omp& ii, jj, gwgw, c8abns, c10abns)
!#endif
   do i = 1, nat
      do j = 1, nat
         if (j >= i) cycle
         ia = at(i)
         ja = at(j)
         k = itbl(i)
         l = itbl(j)
         r4r2ij = 3.0_wp*sqrtZr4r2(ia)*sqrtZr4r2(ja)
         cutoff = par%a1*sqrt(r4r2ij)+par%a2
         r2 = sum( (xyz(:,j)-xyz(:,i))**2 )
         if (r2.gt.rthr*rthr) cycle
         oor6  = 1.0_wp/(r2**3 + cutoff**6 )
         oor8  = 1.0_wp/(r2**4 + cutoff**8 )
         oor10 = 1.0_wp/(r2**5 + cutoff**10)
         ! acc loop seq
         do ii = 1, dispm%nref(ia)
            ! acc loop seq private(gwgw, c8abns, c10abns)
            do jj = 1, dispm%nref(ja)
               gwgw = gw(k+ii)*gw(l+jj)
               if (gwgw.lt.gwcut) cycle
               c8abns  = r4r2ij * c6abns(k+ii,l+jj)
               c10abns = 49.0_wp/40.0_wp * r4r2ij**2 * c6abns(k+ii,l+jj)
               wdispmat(k+ii,l+jj) = gw(k+ii)*gw(l+jj) * ( &
               &  - par%s6  * ( c6abns(k+ii,l+jj)  * oor6 ) &
               &  - par%s8  * ( c8abns       * oor8 ) &
               &  - par%s10 * ( c10abns      * oor10) )
               wdispmat(l+jj,k+ii) = wdispmat(k+ii,l+jj)
            enddo
         enddo
      enddo
   enddo
!#ifdef XTB_GPU
   ! acc end parallel

   ! acc exit data copyout(wdispmat) delete(itbl, sqrtZr4r2, dispm, dispm%nref, &
   ! acc& c6abns, gw)
!#endif

end subroutine build_wdispmat


subroutine disppot(dispm,nat,ndim,at,itbl,q,g_a,g_c,wdispmat,gw,hdisp)
   use xtb_mctc_blas, only : mctc_symv
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: ndim
   integer, intent(in)  :: at(:)
   integer, intent(in)  :: itbl(:)
   real(wp),intent(in)  :: q(:)
   real(wp),intent(in)  :: g_a,g_c
   real(wp),intent(in)  :: wdispmat(:,:)
   real(wp),intent(in)  :: gw(:)
   real(wp),intent(inout) :: hdisp(:)

   integer  :: iat,ii,k,ati
   real(wp) :: qmod,iz
   real(wp),parameter   :: gw_cut = 1.0e-7_wp
   real(wp),allocatable :: zetavec(:)
   real(wp),allocatable :: zerovec(:)
   real(wp),allocatable :: dumvec(:)

   intrinsic :: sum,dble

   allocate( zetavec(ndim),zerovec(ndim),dumvec(ndim), source = 0._wp )

   !$acc enter data create(zetavec, zerovec, dumvec) copyin(hdisp, itbl, at, zeff, &
   !$acc& dispm, dispm%nref, dispm%q, q, gw, wdispmat, g_a, g_c)

   !$acc kernels default(present)
   zetavec = 0.0_wp
   zerovec = 0.0_wp
   dumvec  = 0.0_wp
   !$acc end kernels

#ifdef XTB_GPU
   !$acc parallel default(present)
   !$acc loop gang private(k, ati, iz)
#else
   !$omp parallel do shared(itbl, at, dispm, gw, q, g_a, g_c) &
   !$omp private(k, ati, iz, ii)
#endif
   do iat = 1, nat
      k = itbl(iat)
      ati = at(iat)
      iz = zeff(ati)
      !$acc loop vector
      do ii = 1, dispm%nref(ati)
         if (gw(k+ii).lt.gw_cut) cycle
         zerovec(k+ii) = dzeta(g_a,gam(ati)*g_c,dispm%q(ii,ati)+iz,q(iat)+iz)
         zetavec(k+ii) =  zeta(g_a,gam(ati)*g_c,dispm%q(ii,ati)+iz,q(iat)+iz)
      enddo
   enddo
#ifdef XTB_GPU
   !$acc end parallel
   !$acc exit data copyout(zetavec)
#endif

!  create vector -> dispmat(ndim,dnim) * zetavec(ndim) = dumvec(ndim) 
   call mctc_symv(wdispmat,zetavec,dumvec)

!  get atomic reference contributions
#ifdef XTB_GPU
   !$acc parallel default(present)
   !$acc loop gang private(k, ati)
#else
   !$omp parallel do reduction(+:hdisp) shared(itbl, at, dumvec, zerovec) &
   !$omp private(ati, ii)
#endif
   do iat = 1, nat
      k = itbl(iat)
      ati = at(iat)
      !$acc loop vector
      do ii = 1, dispm%nref(ati)
         !$acc atomic
         hdisp(iat) = hdisp(iat) + dumvec(k+ii)*zerovec(k+ii)
      end do
   enddo
#ifdef XTB_GPU
   !$acc end parallel

   !$acc exit data copyout(hdisp) delete(zerovec, dumvec, itbl, at, zeff, &
   !$acc& dispm, dispm%nref, dispm%q, q, g_a, g_c, wdispmat, gw)
#endif

end subroutine disppot


function edisp_scc(dispm,nat,ndim,at,itbl,q,g_a,g_c,wdispmat,gw) result(ed)
   use xtb_mctc_blas, only : mctc_symv, mctc_dot
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: ndim
   integer, intent(in)  :: at(:)
   integer, intent(in)  :: itbl(:)
   real(wp),intent(in)  :: q(:)
   real(wp),intent(in)  :: g_a,g_c
   real(wp),intent(in)  :: wdispmat(:,:)
   real(wp),intent(in)  :: gw(:)
   real(wp) :: ed

   integer  :: iat,ii,k,ati
   real(wp) :: qmod,iz
   real(wp),parameter   :: gw_cut = 1.0e-7_wp
   real(wp),allocatable :: zetavec(:)
   real(wp),allocatable :: dumvec(:)

   intrinsic :: sum,dble

   allocate( zetavec(ndim),dumvec(ndim))

   zetavec = 0.0_wp
   dumvec = 0.0_wp
   ed = 0.0_wp

   !$omp parallel do shared(zetavec, dispm, nat, itbl, at, q, g_c, g_a) &
   !$omp private(k, ati, iz, ii)
   do iat = 1, nat
       k = itbl(iat)
       ati = at(iat)
       iz = zeff(ati)
       do ii = 1, dispm%nref(ati)
          if (gw(k+ii).lt.gw_cut) cycle
          zetavec(k+ii) = zeta(g_a,gam(ati)*g_c,dispm%q(ii,ati)+iz,q(iat)+iz)
      enddo
   enddo

!  create vector -> dispmat(ndim,dnim) * zetavec(ndim) = dumvec(ndim)
   call mctc_symv(wdispmat,zetavec,dumvec,alpha=0.5_wp)
   ed = mctc_dot(dumvec,zetavec)

end function edisp_scc


! --- PBC
subroutine pbc_d4(dispm,nat,ndim,at,wf,g_a,g_c,covcn,gw,refc6)
   type(TDispersionModel), intent(in) :: dispm
   integer, intent(in)  :: nat
   integer, intent(in)  :: ndim
   integer, intent(in)  :: at(nat)
   real(wp),intent(in)  :: wf,g_a,g_c
   real(wp),intent(in)  :: covcn(nat)
   real(wp),intent(out) :: gw(ndim)
   real(wp),intent(out) :: refc6(ndim,ndim)

   integer  :: i,ia,is,icn,ii,iii,j,jj,ja,k,l
   integer,allocatable :: itbl(:,:)
   real(wp) :: twf,norm,aiw(23)

   intrinsic :: maxval

   allocate( itbl(7,nat), source = 0 )

   gw = 0._wp
   refc6 = 0._wp

   k = 0
   do i = 1, nat
      do ii = 1, dispm%nref(at(i))
         k = k+1
         itbl(ii,i) = k
      enddo
   enddo

   do i = 1, nat
      ia = at(i)
      norm = 0.0_wp
      do ii = 1, dispm%nref(ia)
         do iii = 1, dispm%ncount(ii,ia)
            twf = iii*wf
            norm = norm + cngw(twf,covcn(i),dispm%cn(ii,ia))
         enddo
      enddo
      norm = 1._wp / norm
      do ii = 1, dispm%nref(ia)
         k = itbl(ii,i)
         do iii = 1, dispm%ncount(ii,ia)
            twf = iii*wf
            gw(k) = gw(k) + cngw(twf,covcn(i),dispm%cn(ii,ia)) * norm
         enddo
!    --- okay, if we run out of numerical precision, gw(k) will be NaN.
!        In case it is NaN, it will not match itself! So we can rescue
!        this exception. This can only happen for very high CNs.
         if (gw(k).ne.gw(k)) then
            if (maxval(dispm%cn(:dispm%nref(ia),ia)).eq.dispm%cn(ii,ia)) then
               gw(k) = 1.0_wp
            else
               gw(k) = 0.0_wp
            endif
         endif
         ! diagonal terms
         do jj = 1, ii
            l = itbl(jj,i)
            refc6(l,k) = dispm%c6(ii,jj,ia,ia)
            refc6(k,l) = refc6(l,k)
         enddo
         ! offdiagonal terms
         do j = 1, i-1
            ja = at(j)
            do jj = 1, dispm%nref(ja)
               l = itbl(jj,j)
               refc6(l,k) = dispm%c6(ii,jj,ia,ja)
               refc6(k,l) = refc6(l,k)
            enddo
         enddo
      enddo
   enddo

end subroutine pbc_d4


!> Calculate the weights of the reference system and the derivatives w.r.t.
!  coordination number for later use.
subroutine weight_references(dispm, nat, atoms, g_a, g_c, wf, q, cn, zeff, gam, &
      &                      zetavec, zerovec, zetadcn, zerodcn, zetadq)
   type(TDispersionModel), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> Atomic numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> Charge scaling height.
   real(wp), intent(in) :: g_a
   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c
   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf
   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)
   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)
   real(wp), intent(in) :: zeff(:)
   real(wp), intent(in) :: gam(:)
   !> weighting and scaling function for the atomic reference systems
   real(wp), intent(out) :: zetaVec(:, :)
   !> weighting and scaling function for the atomic reference systems for q=0
   real(wp), intent(out) :: zeroVec(:, :)
   !> derivative of the weight'n'scale function w.r.t. the partial charges
   real(wp), intent(out) :: zetadq(:, :)
   !> derivative of the weight'n'scale function w.r.t. the coordination number
   real(wp), intent(out) :: zetadcn(:, :)
   !> derivative of the weight'n'scale function w.r.t. the CN for q=0
   real(wp), intent(out) :: zerodcn(:, :)

   integer :: iat, ati, iref, icount
   real(wp) :: norm, dnorm, twf, gw, expw, expd, gwk, dgwk
   real(wp) :: gi, zi

   ! acc enter data create(zetavec, zerovec, zetadq, zetadq, zetadcn, zerodcn) &
   ! acc& copyin(dispm, dispm%nref, dispm%ncount, dispm%cn, dispm%q, atoms, &
   ! acc& cn, q, zeff, gam, g_a, g_c, wf)

   ! acc kernels default(present)
   zetavec = 0.0_wp
   zerovec = 0.0_wp
   zetadcn = 0.0_wp
   zerodcn = 0.0_wp
   zetadq  = 0.0_wp
   ! acc end kernels

!#ifdef XTB_GPU
   ! acc parallel default(present)
   ! acc loop gang private(zi, gi, norm, dnorm)
!#else
   !$omp parallel do shared(zetavec, zetadcn, zetadq, zerodcn) &
   !$omp shared(nat, atoms, dispm, cn, q, g_a, g_c, wf, zerovec) &
   !$omp private(iat, ati, zi, gi, norm, dnorm, iref, icount, twf, gw, expw, &
   !$omp& expd, gwk, dgwk)
!#endif
   do iat = 1, nat
      ati = atoms(iat)

      zi = zeff(ati)
      gi = g_c * gam(ati)

      norm = 0.0_wp
      dnorm = 0.0_wp
      ! acc loop vector
      do iref = 1, dispm%nref(ati)
         ! acc loop seq private(twf, gw)
         do icount = 1, dispm%ncount(iref, ati)
            twf = icount * wf
            gw = cngw(twf, cn(iat), dispm%cn(iref, ati))
            norm = norm + gw
            dnorm = dnorm + 2*twf*(dispm%cn(iref, ati) - cn(iat)) * gw
         enddo
      end do
      norm = 1.0_wp / norm
      ! acc loop vector private(expw, expd)
      do iref = 1, dispm%nref(ati)
         expw = 0.0_wp
         expd = 0.0_wp
         ! acc loop seq private(twf, gw)
         do icount = 1, dispm%ncount(iref, ati)
            twf = icount * wf
            gw = cngw(twf, cn(iat), dispm%cn(iref, ati))
            expw = expw + gw
            expd = expd + 2*twf*(dispm%cn(iref, ati) - cn(iat)) * gw
         enddo

         gwk = expw * norm
         if (gwk /= gwk) then
            if (maxval(dispm%cn(:dispm%nref(ati), ati)) &
               & == dispm%cn(iref, ati)) then
               gwk = 1.0_wp
            else
               gwk = 0.0_wp
            endif
         endif
         zetavec(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,q(iat)+zi) * gwk
         zerovec(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,zi) * gwk

         dgwk = expd*norm-expw*dnorm*norm**2
         if (dgwk /= dgwk) then
            dgwk = 0.0_wp
         endif
         zetadcn(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,q(iat)+zi) * dgwk
         zetadq(iref, iat) = dzeta(g_a,gi,dispm%q(iref,ati)+zi,q(iat)+zi) * gwk
         zerodcn(iref, iat) = zeta(g_a,gi,dispm%q(iref,ati)+zi,zi) * dgwk

      end do
   end do
!#ifdef XTB_GPU
   ! acc end parallel

   ! acc exit data copyout(zetavec, zerovec, zetadq, zetadq, zetadcn, zerodcn) &
   ! acc& delete(dispm, dispm%nref, dispm%ncount, dispm%cn, dispm%q, atoms, &
   ! acc& cn, q, zeff, gam, g_a, g_c, wf)
!#endif

end subroutine weight_references

!> calculate atomic dispersion coefficients and their derivatives w.r.t.
!  the coordination number.
subroutine get_atomic_c6(dispm, nat, atoms, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)
   type(TDispersionModel), intent(in) :: dispm
   !> Nr. of atoms (without periodic images)
   integer, intent(in) :: nat
   !> numbers of every atom.
   integer, intent(in) :: atoms(:)
   !> weighting and scaling function for the atomic reference systems
   real(wp), intent(in) :: zetaVec(:, :)
   !> derivative of the weight'n'scale function w.r.t. the partial charges
   real(wp), intent(in) :: zetadq(:, :)
   !> derivative of the weight'n'scale function w.r.t. the coordination number
   real(wp), intent(in) :: zetadcn(:, :)
   !> C6 coefficients for all atom pairs.
   real(wp), intent(out) :: c6(:, :)
   !> derivative of the C6 w.r.t. the coordination number
   real(wp), intent(out) :: dc6dcn(:, :)
   !> derivative of the C6 w.r.t. the partial charge
   real(wp), intent(out) :: dc6dq(:, :)

   integer :: iat, jat, ati, atj, iref, jref
   real(wp) :: refc6, dc6, dc6dcni, dc6dcnj, dc6dqi, dc6dqj

   !$acc enter data create(c6, dc6dcn, dc6dq) copyin(atoms, dispm, dispm%nref, dispm%c6, &
   !$acc& zetavec, zetadcn, zetadq)

   !$acc kernels default(present)
   c6 = 0.0_wp
   dc6dcn = 0.0_wp
   dc6dq = 0.0_wp
   !$acc end kernels

#ifdef XTB_GPU
   !$acc parallel default(present)
   !$acc loop gang collapse(2)
#else
   !$omp parallel do default(none) shared(c6, dc6dcn, dc6dq) &
   !$omp shared(nat, atoms, dispm, zetavec, zetadcn, zetadq) &
   !$omp private(iat, ati, jat, atj, dc6, dc6dcni, dc6dcnj, dc6dqi, dc6dqj, &
   !$omp& iref, jref, refc6)
#endif
   do iat = 1, nat
      do jat = 1, nat
         if (jat > iat) cycle
         ati = atoms(iat)
         atj = atoms(jat)
         dc6 = 0.0_wp
         dc6dcni = 0.0_wp
         dc6dcnj = 0.0_wp
         dc6dqi = 0.0_wp
         dc6dqj = 0.0_wp
         !$acc loop vector collapse(2)
         do iref = 1, dispm%nref(ati)
            do jref = 1, dispm%nref(atj)
               refc6 = dispm%c6(iref, jref, ati, atj)
               dc6 = dc6 + zetavec(iref, iat) * zetavec(jref, jat) * refc6
               dc6dcni = dc6dcni + zetadcn(iref, iat) * zetavec(jref, jat) * refc6
               dc6dcnj = dc6dcnj + zetavec(iref, iat) * zetadcn(jref, jat) * refc6
               dc6dqi = dc6dqi + zetadq(iref, iat) * zetavec(jref, jat) * refc6
               dc6dqj = dc6dqj + zetavec(iref, iat) * zetadq(jref, jat) * refc6
            end do
         end do
         c6(iat, jat) = dc6
         c6(jat, iat) = dc6
         dc6dcn(iat, jat) = dc6dcni
         dc6dcn(jat, iat) = dc6dcnj
         dc6dq(iat, jat) = dc6dqi
         dc6dq(jat, iat) = dc6dqj
      end do
   end do
#ifdef XTB_GPU
   !$acc end parallel

   !$acc exit data copyout(c6, dc6dcn, dc6dq) delete(atoms, dispm, dispm%nref, dispm%c6, &
   !$acc& zetavec, zetadcn, zetadq)
#endif

end subroutine get_atomic_c6


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_full_gradient_neigh &
      & (mol, dispm, neighs, neighs3, neighlist, par, g_a, g_c, wf, &
      &  cn, dcndr, dcndL, q, dqdr, dqdL, energy, gradient, sigma, e2, e3)
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   type(TDispersionModel), intent(in) :: dispm

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Static neighbourlist.
   type(TNeighbourList), intent(in) :: neighlist

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   !> Number of neighbours for each atom.
   integer, intent(in) :: neighs(:)

   !> Number of neighbours for each atom.
   integer, intent(in) :: neighs3(:)

   !> Charge scaling height.
   real(wp), intent(in) :: g_a

   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of CN w.r.t. strain deformations
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)

   !> Derivative of partial charges w.r.t. atomic coordinates.
   real(wp), intent(in), optional :: dqdr(:, :, :)

   !> Derivative of partial charges w.r.t. strain deformations
   real(wp), intent(in), optional :: dqdL(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   real(wp), intent(out), optional :: e2
   real(wp), intent(out), optional :: e3

   integer :: nat, max_ref

   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:), dEdq(:)

   nat = len(mol)
   max_ref = maxval(dispm%nref(mol%at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), energies3(nat), dEdcn(nat), dEdq(nat), source=0.0_wp)

   call weight_references(dispm, nat, mol%at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, mol%at, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)

   call disp_gradient_neigh(mol, neighs, neighlist, par, sqrtZr4r2, &
      & c6, dc6dcn, dc6dq, energies, gradient, sigma, dEdcn, dEdq)

   if (present(e2)) e2 = sum(energies)
   if (par%s9 /= 0.0_wp) then
      call get_atomic_c6(dispm, nat, mol%at, zerovec, zerodcn, zerodq, &
         & c6, dc6dcn, dc6dq)
      call atm_gradient_neigh(mol, neighs3, neighlist, par, sqrtZr4r2, c6, dc6dcn, &
         & energies3, gradient, sigma, dEdcn)
   end if
   if (present(e3)) e3 = sum(energies3)

   call mctc_gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   if (present(dqdr)) then
      call mctc_gemv(dqdr, dEdq, gradient, beta=1.0_wp)
   end if
   call mctc_gemv(dcndL, dEdcn, sigma, beta=1.0_wp)
   if (present(dqdL)) then
      call mctc_gemv(dqdL, dEdq, sigma, beta=1.0_wp)
   end if

   energy = energy + sum(energies) + sum(energies3)

end subroutine d4_full_gradient_neigh


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_gradient_neigh &
      & (mol, dispm, neighs, neighlist, par, g_a, g_c, wf, &
      &  cn, dcndr, dcndL, q, dqdr, dqdL, energy, gradient, sigma)
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   type(TDispersionModel), intent(in) :: dispm

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Static neighbourlist.
   type(TNeighbourList), intent(in) :: neighlist

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   !> Number of neighbours for each atom.
   integer, intent(in) :: neighs(:)

   !> Charge scaling height.
   real(wp), intent(in) :: g_a

   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of CN w.r.t. strain deformations
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)

   !> Derivative of partial charges w.r.t. atomic coordinates.
   real(wp), intent(in), optional :: dqdr(:, :, :)

   !> Derivative of partial charges w.r.t. strain deformations
   real(wp), intent(in), optional :: dqdL(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref

   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:), dEdq(:)

   nat = len(mol)
   max_ref = maxval(dispm%nref(mol%at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), dEdcn(nat), dEdq(nat), source=0.0_wp)

   call weight_references(dispm, nat, mol%at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, mol%at, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)

   call disp_gradient_neigh(mol, neighs, neighlist, par, sqrtZr4r2, &
      & c6, dc6dcn, dc6dq, energies, gradient, sigma, dEdcn, dEdq)

   call mctc_gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   if (present(dqdr)) then
      call mctc_gemv(dqdr, dEdq, gradient, beta=1.0_wp)
   end if
   call mctc_gemv(dcndL, dEdcn, sigma, beta=1.0_wp)
   if (present(dqdL)) then
      call mctc_gemv(dqdL, dEdq, sigma, beta=1.0_wp)
   end if

   energy = energy + sum(energies)

end subroutine d4_gradient_neigh


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine disp_gradient_neigh &
      & (mol, neighs, neighlist, par, r4r2, c6, dc6dcn, dc6dq, &
      &  energies, gradient, sigma, dEdcn, dEdq)

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Static neighbourlist.
   type(TNeighbourList), intent(in) :: neighlist

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: r4r2(:)

   !> Number of neighbours for each atom.
   integer, intent(in) :: neighs(:)

   real(wp), intent(in) :: c6(:, :)

   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(in) :: dc6dq(:, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energies(:)

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   real(wp), intent(inout) :: dEdcn(:)

   real(wp), intent(inout) :: dEdq(:)

   integer :: iat, jat, ati, atj, ij, img

   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, sigma, dEdcn, dEdq) &
   !$omp shared(mol, neighs, neighlist, par, r4r2, c6, dc6dcn, dc6dq) &
   !$omp private(ij, img, jat, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG, dS)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do ij = 1, neighs(iat)
         img = neighlist%ineigh(ij, iat)
         r2 = neighlist%dist2(ij, iat)
         rij = mol%xyz(:, iat) - neighlist%coords(:, img)
         jat = neighlist%image(img)
         atj = mol%at(jat)

         r4r2ij = 3*r4r2(ati)*r4r2(atj)
         r0 = par%a1*sqrt(r4r2ij) + par%a2

         t6 = 1._wp/(r2**3+r0**6)
         t8 = 1._wp/(r2**4+r0**8)
         t10 = 1._wp/(r2**5+r0**10)

         d6 = -6*r2**2*t6**2
         d8 = -8*r2**3*t8**2
         d10 = -10*r2**4*t10**2

         disp = par%s6*t6 + par%s8*r4r2ij*t8 &
            &  + par%s10*49.0_wp/40.0_wp*r4r2ij**2*t10
         ddisp= par%s6*d6 + par%s8*r4r2ij*d8 &
            & + par%s10*49.0_wp/40.0_wp*r4r2ij**2*d10

         dE = -c6(iat, jat)*disp * 0.5_wp
         dG = -c6(iat, jat)*ddisp*rij
         dS = spread(dG, 1, 3) * spread(rij, 2, 3) * 0.5_wp

         energies(iat) = energies(iat) + dE
         dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
         dEdq(iat) = dEdq(iat) - dc6dq(iat, jat) * disp
         sigma = sigma + dS
         if (iat /= jat) then
            energies(jat) = energies(jat) + dE
            dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
            dEdq(jat) = dEdq(jat) - dc6dq(jat, iat) * disp
            gradient(:, iat) = gradient(:, iat) + dG
            gradient(:, jat) = gradient(:, jat) - dG
            sigma = sigma + dS
         endif

      enddo
   enddo
   !$omp end parallel do

end subroutine disp_gradient_neigh


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_atm_gradient_neigh &
      & (mol, dispm, neighs, neighlist, par, g_a, g_c, wf, cn, dcndr, dcndL, &
      &  energy, gradient, sigma)
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   type(TDispersionModel), intent(in) :: dispm

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Static neighbourlist.
   type(TNeighbourList), intent(in) :: neighlist

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   !> Number of neighbours for each atom.
   integer, intent(in) :: neighs(:)

   !> Charge scaling height.
   real(wp), intent(in) :: g_a

   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of CN w.r.t. strain deformations
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref

   real(wp), allocatable :: q(:)
   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), dEdcn(:)

   nat = len(mol)
   max_ref = maxval(dispm%nref(mol%at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     q(nat), c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references(dispm, nat, mol%at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, mol%at, zerovec, zerodcn, zerodq, &
      & c6, dc6dcn, dc6dq)

   call atm_gradient_neigh &
      & (mol, neighs, neighlist, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   call mctc_gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   call mctc_gemv(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies)

end subroutine d4_atm_gradient_neigh


subroutine atm_gradient_neigh &
      & (mol, neighs, neighlist, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Neighbour list
   type(TNeighbourList), intent(in) :: neighlist

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   integer, intent(in) :: neighs(:)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, kat, ati, atj, atk, jtr, ktr, ij, jk, ik
   real(wp) :: rij(3), rjk(3), rik(3), r2ij, r2jk, r2ik
   real(wp) :: c6ij, c6jk, c6ik, cij, cjk, cik, scale
   real(wp) :: dE, dG(3, 3), dS(3, 3), dCN(3)
   real(wp), parameter :: sr = 4.0_wp/3.0_wp

   !$omp parallel do default(none) reduction(+:energies, gradient, sigma, dEdcn) &
   !$omp shared(mol, neighs, neighlist, par, r4r2, c6, dc6dcn) &
   !$omp private(iat, ati, ij, jtr, r2ij, rij, jat, atj, ik, ktr, kat, atk, rik, &
   !$omp& r2ik, rjk, r2jk, c6ij, cij, c6ik, c6jk, cik, cjk, scale, dE, dG, dS, dCN)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do ij = 1, neighs(iat)
         jtr = neighlist%ineigh(ij, iat)
         r2ij = neighlist%dist2(ij, iat)
         rij = neighlist%coords(:, jtr) - neighlist%coords(:, iat)
         jat = neighlist%image(jtr)
         atj = mol%at(jat)

         c6ij = c6(jat,iat)
         cij = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atj))+par%a2

         do ik = 1, ij-1
            ktr = neighlist%ineigh(ik, iat)
            rik = neighlist%coords(:, ktr) - neighlist%coords(:, iat)
            r2ik = neighlist%dist2(ik, iat)
            rjk = neighlist%coords(:, ktr) - neighlist%coords(:, jtr)
            r2jk = sum(rjk**2)
            kat = neighlist%image(ktr)
            atk = mol%at(kat)

            c6ik = c6(kat,iat)
            c6jk = c6(kat,jat)

            cik = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atk))+par%a2
            cjk = par%a1*sqrt(3.0_wp*r4r2(atj)*r4r2(atk))+par%a2

            call deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
               & r2ij, r2jk, r2ik, dc6dcn(iat,jat), dc6dcn(jat,iat), &
               & dc6dcn(jat,kat), dc6dcn(kat,jat), dc6dcn(iat,kat), &
               & dc6dcn(kat,iat), rij, rjk, rik, par%alp, dE, dG, dS, dCN)

            scale = par%s9 * triple_scale(iat, jat, kat)
            energies(iat) = energies(iat) + dE * scale/3
            energies(jat) = energies(jat) + dE * scale/3
            energies(kat) = energies(kat) + dE * scale/3
            gradient(:, iat) = gradient(:, iat) + dG(:, 1) * scale
            gradient(:, jat) = gradient(:, jat) + dG(:, 2) * scale
            gradient(:, kat) = gradient(:, kat) + dG(:, 3) * scale
            sigma(:, :) = sigma + dS * scale
            dEdcn(iat) = dEdcn(iat) + dCN(1) * scale
            dEdcn(jat) = dEdcn(jat) + dCN(2) * scale
            dEdcn(kat) = dEdcn(kat) + dCN(3) * scale

         end do
      end do
   end do
   !$omp end parallel do

end subroutine atm_gradient_neigh


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_full_gradient_latp &
      & (mol, dispm, trans, par, g_a, g_c, wf, cutoff, cutoff3, &
      &  cn, dcndr, dcndL, q, dqdr, dqdL, energy, gradient, sigma, e2, e3)
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   type(TDispersionModel), intent(in) :: dispm

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)

   !> Charge scaling height.
   real(wp), intent(in) :: g_a

   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Cutoff for pairwise interactions
   real(wp), intent(in) :: cutoff

   !> Cutoff for threebody interactions
   real(wp), intent(in) :: cutoff3

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of CN w.r.t. strain deformations
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)

   !> Derivative of partial charges w.r.t. atomic coordinates.
   real(wp), intent(in), optional :: dqdr(:, :, :)

   !> Derivative of partial charges w.r.t. strain deformations
   real(wp), intent(in), optional :: dqdL(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   real(wp), intent(out), optional :: e2
   real(wp), intent(out), optional :: e3

   integer :: nat, max_ref

   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:), dEdq(:)

   nat = len(mol)
   max_ref = maxval(dispm%nref(mol%at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), energies3(nat), dEdcn(nat), dEdq(nat), source=0.0_wp)

   call weight_references(dispm, nat, mol%at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, mol%at, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)

   call disp_gradient_latp(mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, dc6dq, &
      &  energies, gradient, sigma, dEdcn, dEdq)

   if (present(e2)) e2 = sum(energies)
   if (par%s9 /= 0.0_wp) then
      call get_atomic_c6(dispm, nat, mol%at, zerovec, zerodcn, zerodq, &
         & c6, dc6dcn, dc6dq)
#ifdef XTB_GPU
      call atm_gradient_latp_gpu(mol, trans, cutoff3, par, sqrtZr4r2, c6, dc6dcn, &
         & energies3, gradient, sigma, dEdcn)
#else
      call atm_gradient_latp(mol, trans, cutoff3, par, sqrtZr4r2, c6, dc6dcn, &
         & energies3, gradient, sigma, dEdcn)
#endif
   end if
   if (present(e3)) e3 = sum(energies3)

   call mctc_gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   if (present(dqdr)) then
      call mctc_gemv(dqdr, dEdq, gradient, beta=1.0_wp)
   end if
   call mctc_gemv(dcndL, dEdcn, sigma, beta=1.0_wp)
   if (present(dqdL)) then
      call mctc_gemv(dqdL, dEdq, sigma, beta=1.0_wp)
   end if

   energy = energy + sum(energies) + sum(energies3)

end subroutine d4_full_gradient_latp


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_gradient_latp &
      & (mol, dispm, trans, par, g_a, g_c, wf, cutoff, &
      &  cn, dcndr, dcndL, q, dqdr, dqdL, energy, gradient, sigma)
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   type(TDispersionModel), intent(in) :: dispm

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)

   !> Charge scaling height.
   real(wp), intent(in) :: g_a

   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Cutoff for pairwise interactions
   real(wp), intent(in) :: cutoff

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of CN w.r.t. strain deformations
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Partial charge of every atom.
   real(wp), intent(in) :: q(:)

   !> Derivative of partial charges w.r.t. atomic coordinates.
   real(wp), intent(in), optional :: dqdr(:, :, :)

   !> Derivative of partial charges w.r.t. strain deformations
   real(wp), intent(in), optional :: dqdL(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref

   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:), dEdq(:)

   nat = len(mol)
   max_ref = maxval(dispm%nref(mol%at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), dEdcn(nat), dEdq(nat), source=0.0_wp)

   call weight_references(dispm, nat, mol%at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, mol%at, zetavec, zetadcn, zetadq, &
      & c6, dc6dcn, dc6dq)

   call disp_gradient_latp(mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, dc6dq, &
      & energies, gradient, sigma, dEdcn, dEdq)

   call mctc_gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   if (present(dqdr)) then
      call mctc_gemv(dqdr, dEdq, gradient, beta=1.0_wp)
   end if
   call mctc_gemv(dcndL, dEdcn, sigma, beta=1.0_wp)
   if (present(dqdL)) then
      call mctc_gemv(dqdL, dEdq, sigma, beta=1.0_wp)
   end if

   energy = energy + sum(energies)

end subroutine d4_gradient_latp


subroutine disp_gradient_latp &
      & (mol, trans, cutoff, par, r4r2, c6, dc6dcn, dc6dq, &
      &  energies, gradient, sigma, dEdcn, dEdq)

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: r4r2(:)

   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)

   !> Cutoff for pairwise interactions
   real(wp), intent(in) :: cutoff

   real(wp), intent(in) :: c6(:, :)

   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(in) :: dc6dq(:, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energies(:)

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   real(wp), intent(inout) :: dEdcn(:)

   real(wp), intent(inout) :: dEdq(:)

   integer :: iat, jat, ati, atj, itr

   real(wp) :: cutoff2
   real(wp) :: r4r2ij, r0, rij(3), r2, t6, t8, t10, d6, d8, d10
   real(wp) :: dE, dG(3), dS(3, 3), disp, ddisp

   cutoff2 = cutoff**2
   !$omp parallel do default(none) &
   !$omp reduction(+:energies, gradient, sigma, dEdcn, dEdq) &
   !$omp shared(mol, trans, cutoff2, par, r4r2, c6, dc6dcn, dc6dq) &
   !$omp private(iat, jat, itr, ati, atj, r2, rij, r4r2ij, r0, t6, t8, t10, &
   !$omp&        d6, d8, d10, disp, ddisp, dE, dG, dS)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do jat = 1, iat
         atj = mol%at(jat)

         r4r2ij = 3*r4r2(ati)*r4r2(atj)
         r0 = par%a1*sqrt(r4r2ij) + par%a2
         do itr = 1, size(trans, dim=2)
            rij = mol%xyz(:, iat) - mol%xyz(:, jat) - trans(:, itr)
            r2 = sum(rij**2)
            if (r2 > cutoff2 .or. r2 < 1.0e-10_wp) cycle

            t6 = 1._wp/(r2**3+r0**6)
            t8 = 1._wp/(r2**4+r0**8)
            t10 = 1._wp/(r2**5+r0**10)

            d6 = -6*r2**2*t6**2
            d8 = -8*r2**3*t8**2
            d10 = -10*r2**4*t10**2

            disp = par%s6*t6 + par%s8*r4r2ij*t8 &
               &  + par%s10*49.0_wp/40.0_wp*r4r2ij**2*t10
            ddisp= par%s6*d6 + par%s8*r4r2ij*d8 &
               & + par%s10*49.0_wp/40.0_wp*r4r2ij**2*d10

            dE = -c6(iat, jat)*disp * 0.5_wp
            dG = -c6(iat, jat)*ddisp*rij
            dS = spread(dG, 1, 3) * spread(rij, 2, 3) * 0.5_wp

            energies(iat) = energies(iat) + dE
            dEdcn(iat) = dEdcn(iat) - dc6dcn(iat, jat) * disp
            dEdq(iat) = dEdq(iat) - dc6dq(iat, jat) * disp
            sigma = sigma + dS
            if (iat /= jat) then
               energies(jat) = energies(jat) + dE
               dEdcn(jat) = dEdcn(jat) - dc6dcn(jat, iat) * disp
               dEdq(jat) = dEdq(jat) - dc6dq(jat, iat) * disp
               gradient(:, iat) = gradient(:, iat) + dG
               gradient(:, jat) = gradient(:, jat) - dG
               sigma = sigma + dS
            end if

         end do
      end do
   end do
   !$omp end parallel do

end subroutine disp_gradient_latp


!> Evaluate gradient of DFT-D4, this routine can handle systems of arbitrary
!  periodicity due to the static neighbourlist.
subroutine d4_atm_gradient_latp &
      & (mol, dispm, trans, par, g_a, g_c, wf, cutoff, cn, dcndr, dcndL, &
      &  energy, gradient, sigma)
   use xtb_type_molecule
   use xtb_type_neighbourlist
   use xtb_type_param
   type(TDispersionModel), intent(in) :: dispm

   !> Molecular Structure information.
   type(TMolecule), intent(in) :: mol

   !> Becke--Johnson damping parameters.
   type(dftd_parameter), intent(in) :: par

   !> Translation vectors
   real(wp), intent(in) :: trans(:, :)

   !> Charge scaling height.
   real(wp), intent(in) :: g_a

   !> Charge scaling steepness.
   real(wp), intent(in) :: g_c

   !> Exponent for the Gaussian weighting.
   real(wp), intent(in) :: wf

   !> Cutoff for pairwise interactions
   real(wp), intent(in) :: cutoff

   !> Coordination number of every atom.
   real(wp), intent(in) :: cn(:)

   !> Derivative of CN w.r.t. atomic coordinates.
   real(wp), intent(in) :: dcndr(:, :, :)

   !> Derivative of CN w.r.t. strain deformations
   real(wp), intent(in) :: dcndL(:, :, :)

   !> Dispersion energy.
   real(wp), intent(inout) :: energy

   !> Derivative of the dispersion energy w.r.t. atomic positions.
   real(wp), intent(inout) :: gradient(:, :)

   !> Stress tensor resulting from dispersion interactions.
   real(wp), intent(inout) :: sigma(:, :)

   integer :: nat, max_ref

   real(wp), allocatable :: q(:)
   real(wp), allocatable :: zetavec(:, :), zetadcn(:, :), zetadq(:, :)
   real(wp), allocatable :: zerovec(:, :), zerodcn(:, :), zerodq(:, :)
   real(wp), allocatable :: c6(:, :), dc6dcn(:, :), dc6dq(:, :)
   real(wp), allocatable :: energies(:), energies3(:), dEdcn(:), dEdq(:)

   nat = len(mol)
   max_ref = maxval(dispm%nref(mol%at))
   allocate(zetavec(max_ref, nat), zetadcn(max_ref, nat), zetadq(max_ref, nat), &
      &     zerovec(max_ref, nat), zerodcn(max_ref, nat), zerodq(max_ref, nat), &
      &     q(nat), c6(nat, nat), dc6dcn(nat, nat), dc6dq(nat, nat), &
      &     energies(nat), dEdcn(nat), source=0.0_wp)

   call weight_references(dispm, nat, mol%at, g_a, g_c, wf, q, cn, zeff, gam, &
      & zetavec, zerovec, zetadcn, zerodcn, zetadq)

   call get_atomic_c6(dispm, nat, mol%at, zerovec, zerodcn, zerodq, &
      & c6, dc6dcn, dc6dq)

#ifdef XTB_GPU
   call atm_gradient_latp_gpu &
      & (mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)
#else
   call atm_gradient_latp &
      & (mol, trans, cutoff, par, sqrtZr4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)
#endif

   call mctc_gemv(dcndr, dEdcn, gradient, beta=1.0_wp)
   call mctc_gemv(dcndL, dEdcn, sigma, beta=1.0_wp)

   energy = energy + sum(energies)

end subroutine d4_atm_gradient_latp

subroutine atm_gradient_latp &
      & (mol, trans, cutoff, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, kat, ati, atj, atk, jtr, ktr
   real(wp) :: cutoff2
   real(wp) :: rij(3), rjk(3), rik(3), r2ij, r2jk, r2ik
   real(wp) :: c6ij, c6jk, c6ik, cij, cjk, cik, scale
   real(wp) :: dE, dG(3, 3), dS(3, 3), dCN(3)
   real(wp), parameter :: sr = 4.0_wp/3.0_wp

   cutoff2 = cutoff**2

   !$omp parallel do default(none) reduction(+:energies, gradient, sigma, dEdcn) &
   !$omp shared(mol, r4r2, par, trans, cutoff2, c6, dc6dcn) &
   !$omp private(iat, ati, jat, atj, kat, atk, c6ij, cij, c6ik, c6jk, cik, cjk, &
   !$omp& rij, r2ij, ktr, rik, r2ik, rjk, r2jk, scale, dE, dG, dS, dCN)
   do iat = 1, len(mol)
      ati = mol%at(iat)
      do jat = 1, iat
         atj = mol%at(jat)

         c6ij = c6(jat,iat)
         cij = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atj))+par%a2

         do kat = 1, jat
            atk = mol%at(kat)

            c6ik = c6(kat,iat)
            c6jk = c6(kat,jat)

            cik = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atk))+par%a2
            cjk = par%a1*sqrt(3.0_wp*r4r2(atj)*r4r2(atk))+par%a2

            do jtr = 1, size(trans, dim=2)
               rij = mol%xyz(:, jat) - mol%xyz(:, iat) + trans(:, jtr)
               r2ij = sum(rij**2)
               if (r2ij > cutoff2 .or. r2ij < 1.0e-14_wp) cycle
               do ktr = 1, size(trans, dim=2)
                  if (jat == kat .and. jtr == ktr) cycle
                  rik = mol%xyz(:, kat) - mol%xyz(:, iat) + trans(:, ktr)
                  r2ik = sum(rik**2)
                  if (r2ik > cutoff2 .or. r2ik < 1.0e-14_wp) cycle
                  rjk = mol%xyz(:, kat) - mol%xyz(:, jat) + trans(:, ktr) &
                     & - trans(:, jtr)
                  r2jk = sum(rjk**2)
                  if (r2jk > cutoff2 .or. r2jk < 1.0e-14_wp) cycle

                  call deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
                     & r2ij, r2jk, r2ik, dc6dcn(iat,jat), dc6dcn(jat,iat), &
                     & dc6dcn(jat,kat), dc6dcn(kat,jat), dc6dcn(iat,kat), &
                     & dc6dcn(kat,iat), rij, rjk, rik, par%alp, dE, dG, dS, dCN)

                  scale = par%s9 * triple_scale(iat, jat, kat)
                  energies(iat) = energies(iat) + dE * scale/3
                  energies(jat) = energies(jat) + dE * scale/3
                  energies(kat) = energies(kat) + dE * scale/3
                  gradient(:, iat) = gradient(:, iat) + dG(:, 1) * scale
                  gradient(:, jat) = gradient(:, jat) + dG(:, 2) * scale
                  gradient(:, kat) = gradient(:, kat) + dG(:, 3) * scale
                  sigma(:, :) = sigma + dS * scale
                  dEdcn(iat) = dEdcn(iat) + dCN(1) * scale
                  dEdcn(jat) = dEdcn(jat) + dCN(2) * scale
                  dEdcn(kat) = dEdcn(kat) + dCN(3) * scale

               end do
            end do

         end do
      end do
   end do
   !$omp end parallel do

end subroutine atm_gradient_latp

subroutine atm_gradient_latp_gpu &
      & (mol, trans, cutoff, par, r4r2, c6, dc6dcn, &
      &  energies, gradient, sigma, dEdcn)

   !> Molecular structure data
   type(TMolecule), intent(in) :: mol

   !> Damping parameters
   type(dftd_parameter), intent(in) :: par

   real(wp), intent(in) :: trans(:, :)
   real(wp), intent(in) :: r4r2(:)
   real(wp), intent(in) :: cutoff
   real(wp), intent(in) :: c6(:, :)
   real(wp), intent(in) :: dc6dcn(:, :)

   real(wp), intent(inout) :: energies(:)
   real(wp), intent(inout) :: gradient(:, :)
   real(wp), intent(inout) :: sigma(:, :)
   real(wp), intent(inout) :: dEdcn(:)

   integer :: iat, jat, kat, ati, atj, atk, jtr, ktr
   real(wp) :: cutoff2
   real(wp) :: rij(3), rjk(3), rik(3), r2ij, r2jk, r2ik
   real(wp) :: c6ij, c6jk, c6ik, cij, cjk, cik, scale
   real(wp) :: dE, dG(3, 3), dS(3, 3), dCN(3)
   real(wp), parameter :: sr = 4.0_wp/3.0_wp
   integer :: mlen, k, kk

   real(wp) :: c9, dc9, ccc1, rrr1, rrr2, rrr3, ang, dang, fdmp, dfdmp, dGr, cr

   cutoff2 = cutoff**2
   mlen = len(mol)

   !$acc enter data copyin(par,trans,r4r2,c6,dc6dcn,energies,gradient,sigma,dEdcn, &
   !$acc& mol,mol%at,mol%xyz)

   !$acc parallel default(present) private(rij,rjk,rik,dG,dS,dCN) 

   !$acc loop gang collapse(3)
   do iat = 1, mlen
      do jat = 1, mlen
         do kat = 1, mlen
            if (jat.gt.iat) cycle
            if (kat.gt.jat) cycle

            ati = mol%at(iat)
            atj = mol%at(jat)

            c6ij = c6(jat,iat)
            cij = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atj))+par%a2

            atk = mol%at(kat)

            c6ik = c6(kat,iat)
            c6jk = c6(kat,jat)

            cik = par%a1*sqrt(3.0_wp*r4r2(ati)*r4r2(atk))+par%a2
            cjk = par%a1*sqrt(3.0_wp*r4r2(atj)*r4r2(atk))+par%a2

            do jtr = 1, size(trans, dim=2)
               rij = mol%xyz(:, jat) - mol%xyz(:, iat) + trans(:, jtr)
               r2ij = sum(rij**2)
               if (r2ij > cutoff2 .or. r2ij < 1.0e-14_wp) cycle
               do ktr = 1, size(trans, dim=2)
                  if (jat == kat .and. jtr == ktr) cycle
                  rik = mol%xyz(:, kat) - mol%xyz(:, iat) + trans(:, ktr)
                  r2ik = sum(rik**2)
                  if (r2ik > cutoff2 .or. r2ik < 1.0e-14_wp) cycle
                  rjk = mol%xyz(:, kat) - mol%xyz(:, jat) + trans(:, ktr) &
                     & - trans(:, jtr)
                  r2jk = sum(rjk**2)
                  if (r2jk > cutoff2 .or. r2jk < 1.0e-14_wp) cycle

                  call deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
                     & r2ij, r2jk, r2ik, dc6dcn(iat,jat), dc6dcn(jat,iat), &
                     & dc6dcn(jat,kat), dc6dcn(kat,jat), dc6dcn(iat,kat), &
                     & dc6dcn(kat,iat), rij, rjk, rik, par%alp, dE, dG, dS, dCN)

   !c9 = -sqrt(c6ij*c6ik*c6jk)

   !ccc1 = cij*cjk*cik

   !rrr2 = r2ij*r2jk*r2ik
   !rrr1 = sqrt(rrr2)
   !rrr3 = rrr1*rrr2

   !ang = 0.375_wp * (r2ij+r2jk-r2ik)*(r2ij-r2jk+r2ik)*(-r2ij+r2jk+r2ik) &
   !   & / (rrr3*rrr2) + 1.0_wp/(rrr3)

   !cr = (ccc1/rrr1)**(1.0_wp/3.0_wp)
   !fdmp = 1.0_wp/(1.0_wp + 6.0_wp*cr**par%alp)
   !dfdmp = -(2.0_wp*par%alp*cr**par%alp) * fdmp**2

   !! Energy contribution
   !dE = -fdmp*ang*c9

   !! Derivative w.r.t. i-j distance
   !dang = -0.375_wp*(r2ij**3+r2ij**2*(r2jk+r2ik) &
   !   & +r2ij*(3.0_wp*r2jk**2+2.0_wp*r2jk*r2ik+3.0_wp*r2ik**2) &
   !   & -5.0_wp*(r2jk-r2ik)**2*(r2jk+r2ik)) / (rrr3*rrr2)
   !dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2ij
   !dG(:, 1) = -dGr * rij
   !dG(:, 2) = +dGr * rij 
   !dS(:, :) = 0.5_wp * dGr * spread(rij, 1, 3) * spread(rij, 2, 3)

   !! Derivative w.r.t. i-k distance
   !dang = -0.375_wp*(r2ik**3+r2ik**2*(r2jk+r2ij) &
   !   & +r2ik*(3.0_wp*r2jk**2+2.0*r2jk*r2ij+3.0_wp*r2ij**2) &
   !   & -5.0_wp*(r2jk-r2ij)**2*(r2jk+r2ij)) / (rrr3*rrr2)
   !dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2ik
   !dG(:, 1) = -dGr * rik + dG(:, 1)
   !dG(:, 3) = +dGr * rik 
   !dS(:, :) = 0.5_wp * dGr * spread(rik, 1, 3) * spread(rik, 2, 3) + dS

   !! Derivative w.r.t. j-k distance
   !dang=-0.375_wp*(r2jk**3+r2jk**2*(r2ik+r2ij) &
   !   & +r2jk*(3.0_wp*r2ik**2+2.0_wp*r2ik*r2ij+3.0_wp*r2ij**2) &
   !   & -5.0_wp*(r2ik-r2ij)**2*(r2ik+r2ij)) / (rrr3*rrr2)
   !dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2jk
   !dG(:, 2) = -dGr * rjk + dG(:, 2)
   !dG(:, 3) = +dGr * rjk + dG(:, 3)
   !dS(:, :) = 0.5_wp * dGr * spread(rjk, 1, 3) * spread(rjk, 2, 3) + dS

   !! CN derivative
   !dc9 = 0.5_wp*c9*(dc6dcn(iat,jat)/c6ij+dc6dcn(iat,kat)/c6ik)
   !dCN(1) = -ang*fdmp*dc9
   !dc9 = 0.5_wp*c9*(dc6dcn(jat,iat)/c6ij+dc6dcn(jat,kat)/c6jk)
   !dCN(2) = -ang*fdmp*dc9
   !dc9 = 0.5_wp*c9*(dc6dcn(kat,iat)/c6ik+dc6dcn(kat,jat)/c6jk)
   !dCN(3) = -ang*fdmp*dc9

                  scale = par%s9 * triple_scale(iat, jat, kat)
                  !$acc atomic
                  energies(iat) = energies(iat) + dE * scale/3
                  !$acc atomic
                  energies(jat) = energies(jat) + dE * scale/3
                  !$acc atomic
                  energies(kat) = energies(kat) + dE * scale/3
                  do k = 1,3
                    !$acc atomic
                    gradient(k, iat) = gradient(k, iat) + dG(k, 1) * scale
                    !$acc atomic
                    gradient(k, jat) = gradient(k, jat) + dG(k, 2) * scale
                    !$acc atomic
                    gradient(k, kat) = gradient(k, kat) + dG(k, 3) * scale
                  enddo
                  do k = 1,3
                    do kk = 1,3
                      !$acc atomic
                      sigma(kk, k) = sigma(kk, k) + dS(kk, k) * scale
                    enddo
                  enddo
                  !$acc atomic
                  dEdcn(iat) = dEdcn(iat) + dCN(1) * scale
                  !$acc atomic
                  dEdcn(jat) = dEdcn(jat) + dCN(2) * scale
                  !$acc atomic
                  dEdcn(kat) = dEdcn(kat) + dCN(3) * scale

               end do
            end do

         end do
      end do
   end do
   !$acc end parallel

   !$acc exit data copyout(energies,gradient,sigma,dEdcn)
   !$acc exit data delete(par,trans,r4r2,c6,dc6dcn,mol,mol%at,mol%xyz)


end subroutine atm_gradient_latp_gpu


pure subroutine deriv_atm_triple(c6ij, c6ik, c6jk, cij, cjk, cik, &
      & r2ij, r2jk, r2ik, dc6ij, dc6ji, dc6jk, dc6kj, dc6ik, dc6ki, &
      & rij, rjk, rik, alp, dE, dG, dS, dCN)

   !$acc routine vector
   real(wp), intent(in) :: c6ij, c6ik, c6jk
   real(wp), intent(in) :: cij, cjk, cik
   real(wp), intent(in) :: r2ij, r2jk, r2ik
   real(wp), intent(in) :: dc6ij, dc6ji, dc6jk, dc6kj, dc6ik, dc6ki
   real(wp), intent(in) :: rij(3), rjk(3), rik(3)
   integer, intent(in) :: alp
   real(wp), intent(out) :: dE, dG(3, 3), dS(3, 3), dCN(3)

   real(wp) :: c9, dc9, ccc1, rrr1, rrr2, rrr3, ang, dang, fdmp, dfdmp, dGr, cr

   c9 = -sqrt(c6ij*c6ik*c6jk)

   ccc1 = cij*cjk*cik

   rrr2 = r2ij*r2jk*r2ik
   rrr1 = sqrt(rrr2)
   rrr3 = rrr1*rrr2

   ang = 0.375_wp * (r2ij+r2jk-r2ik)*(r2ij-r2jk+r2ik)*(-r2ij+r2jk+r2ik) &
      & / (rrr3*rrr2) + 1.0_wp/(rrr3)

   cr = (ccc1/rrr1)**(1.0_wp/3.0_wp)
   fdmp = 1.0_wp/(1.0_wp + 6.0_wp*cr**alp)
   dfdmp = -(2.0_wp*alp*cr**alp) * fdmp**2

   ! Energy contribution
   dE = -fdmp*ang*c9

   ! Derivative w.r.t. i-j distance
   dang = -0.375_wp*(r2ij**3+r2ij**2*(r2jk+r2ik) &
      & +r2ij*(3.0_wp*r2jk**2+2.0_wp*r2jk*r2ik+3.0_wp*r2ik**2) &
      & -5.0_wp*(r2jk-r2ik)**2*(r2jk+r2ik)) / (rrr3*rrr2)
   dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2ij
   dG(:, 1) = -dGr * rij
   dG(:, 2) = +dGr * rij 
   dS(:, :) = 0.5_wp * dGr * spread(rij, 1, 3) * spread(rij, 2, 3)

   ! Derivative w.r.t. i-k distance
   dang = -0.375_wp*(r2ik**3+r2ik**2*(r2jk+r2ij) &
      & +r2ik*(3.0_wp*r2jk**2+2.0*r2jk*r2ij+3.0_wp*r2ij**2) &
      & -5.0_wp*(r2jk-r2ij)**2*(r2jk+r2ij)) / (rrr3*rrr2)
   dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2ik
   dG(:, 1) = -dGr * rik + dG(:, 1)
   dG(:, 3) = +dGr * rik 
   dS(:, :) = 0.5_wp * dGr * spread(rik, 1, 3) * spread(rik, 2, 3) + dS

   ! Derivative w.r.t. j-k distance
   dang=-0.375_wp*(r2jk**3+r2jk**2*(r2ik+r2ij) &
      & +r2jk*(3.0_wp*r2ik**2+2.0_wp*r2ik*r2ij+3.0_wp*r2ij**2) &
      & -5.0_wp*(r2ik-r2ij)**2*(r2ik+r2ij)) / (rrr3*rrr2)
   dGr = (-dang*c9*fdmp + dfdmp*c9*ang)/r2jk
   dG(:, 2) = -dGr * rjk + dG(:, 2)
   dG(:, 3) = +dGr * rjk + dG(:, 3)
   dS(:, :) = 0.5_wp * dGr * spread(rjk, 1, 3) * spread(rjk, 2, 3) + dS

   ! CN derivative
   dc9 = 0.5_wp*c9*(dc6ij/c6ij+dc6ik/c6ik)
   dCN(1) = -ang*fdmp*dc9
   dc9 = 0.5_wp*c9*(dc6ji/c6ij+dc6jk/c6jk)
   dCN(2) = -ang*fdmp*dc9
   dc9 = 0.5_wp*c9*(dc6ki/c6ik+dc6kj/c6jk)
   dCN(3) = -ang*fdmp*dc9

end subroutine deriv_atm_triple


!> Logic exercise to distribute a triple energy to atomwise energies.
elemental function triple_scale(ii, jj, kk) result(scale)
   !$acc routine seq

   !> Atom indices
   integer, intent(in) :: ii, jj, kk

   !> Fraction of energy
   real(wp) :: scale

   if (ii == jj) then
      if (ii == kk) then
         ! ii'i" -> 1/6
         scale = 1.0_wp/6.0_wp
      else
         ! ii'j -> 1/2
         scale = 0.5_wp
      end if
   else
      if (ii /= kk .and. jj /= kk) then
         ! ijk -> 1 (full)
         scale = 1.0_wp
      else
         ! ijj' and iji' -> 1/2
         scale = 0.5_wp
      end if
   end if

end function triple_scale


end module xtb_disp_dftd4

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
module xtb_dipole
contains

subroutine Dints(n,nbf,xyz,S1,S2,S3,basis)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_constants
   use xtb_type_basisset
   use xtb_intpack, only : opab1,propa
   implicit none
   type(TBasisset), intent(in) :: basis
   integer, intent(in)  :: n
   integer, intent(in)  :: nbf
   real(wp),intent(out) :: S1(nbf*(nbf+1)/2)
   real(wp),intent(out) :: S2(nbf*(nbf+1)/2)
   real(wp),intent(out) :: S3(nbf*(nbf+1)/2)
   real(wp),intent(in)  :: xyz(3,n)

   integer  :: i,j,k,l
   integer  :: iprimcount,jprimcount
   integer  :: npri,nprj
   integer  :: ii,iii,jj,jjj,ll,m,li,lj,mm,nn
   real(wp) :: xyza(3),xyzb(3),rab,est,ss,sss,lmnfak(84),gama,arg
   real(wp) :: point(3),gm2,ttt(3),tt1,tt2,tt3,intcut

   intcut=20.0_wp

   point=0.0_wp
   s1=0.0_wp
   s2=0.0_wp
   s3=0.0_wp

   k=0
   iprimcount=0
   do i=1,nbf
      ! aufpunkt i
      xyza(1:3)=xyz(1:3,basis%aoat(i))
      ! #prims
      npri=basis%nprim(i)
      jprimcount=0
      do j=1,i
         k=k+1
         nprj=basis%nprim(j)
         ! aufpunkt j
         xyzb(1:3)=xyz(1:3,basis%aoat(j))
         rab=sum((xyza-xyzb)**2)
         if(rab.gt.200) goto 42 ! cut-off gives crambin dipole accurate to 1d-3 Deb
         !prim loop
         tt1=0.0_wp
         tt2=0.0_wp
         tt3=0.0_wp
         do ii=1,npri
            iii=iprimcount+ii
            do jj=1,nprj
               jjj=jprimcount+jj
               gama=1.0_wp/(basis%alp(iii)+basis%alp(jjj))
               est=rab*basis%alp(iii)*basis%alp(jjj)*gama
               ! cutoff
               if(est.lt.intcut)then
                  ttt=0
                  call propa(opab1,xyza,xyzb,point,basis%alp(iii),basis%alp(jjj),&
                     &       basis%lao(i),basis%lao(j),ttt,3)
                  tt1=tt1+ttt(1)*basis%cont(iii)*basis%cont(jjj)
                  tt2=tt2+ttt(2)*basis%cont(iii)*basis%cont(jjj)
                  tt3=tt3+ttt(3)*basis%cont(iii)*basis%cont(jjj)
               endif
            enddo
         enddo
         s1(k)=tt1
         s2(k)=tt2
         s3(k)=tt3
 42      jprimcount=jprimcount+nprj
      enddo
      iprimcount=iprimcount+npri
   enddo

end subroutine Dints

subroutine calc_dipole(n,at,xyz,z,nao,P,dpint,dip,d)
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_convert
   implicit none
   integer, intent(in) :: n
   integer, intent(in) :: at(n)
   real(wp),intent(in) :: xyz(3,n)
   real(wp),intent(in) :: z(n)
   integer, intent(in) :: nao
   real(wp),intent(in) :: P(nao,nao)
   real(wp),intent(in) :: dpint(3,nao,nao)

   integer  :: i,j,k
   real(wp),intent(out) :: d(3),dip

   ! core part
   d = 0.0_wp
   do i = 1, n
      d = d + xyz(:,i)*z(i)
   enddo

   ! contraction with P
   k = 0
   do i = 1, nao
      do j = 1, i-1
         k = k+1
         d = d - 2.0_wp*P(j,i)*dpint(:,i,j)
      enddo
      k = k+1
      d = d - P(i,i)*dpint(:,i,i)
   enddo

   dip = norm2(d)

end subroutine calc_dipole

end module xtb_dipole

! This file is part of xtb.
!
! Copyright (C) 2019-2020 Sebastian Ehlert
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!> Pauling electronegativities
module xtb_param_paulingen
   use xtb_mctc_accuracy, only : wp
   use xtb_mctc_symbols, only : toNumber
   implicit none
   private

   public :: getPaulingEN, paulingEN


   !> Get electronegativity for a species
   interface getPaulingEN
      module procedure :: getPaulingENSymbol
      module procedure :: getPaulingENNumber
   end interface getPaulingEN


   !> Pauling electronegativities, used for the covalent coordination number.
   real(wp), parameter :: paulingEN(1:118) = [ &
      & 2.20_wp,3.00_wp, & ! H,He
      & 0.98_wp,1.57_wp,2.04_wp,2.55_wp,3.04_wp,3.44_wp,3.98_wp,4.50_wp, & ! Li-Ne
      & 0.93_wp,1.31_wp,1.61_wp,1.90_wp,2.19_wp,2.58_wp,3.16_wp,3.50_wp, & ! Na-Ar
      & 0.82_wp,1.00_wp, & ! K,Ca
      &                 1.36_wp,1.54_wp,1.63_wp,1.66_wp,1.55_wp, & ! Sc-
      &                 1.83_wp,1.88_wp,1.91_wp,1.90_wp,1.65_wp, & ! -Zn
      &                 1.81_wp,2.01_wp,2.18_wp,2.55_wp,2.96_wp,3.00_wp, & ! Ga-Kr
      & 0.82_wp,0.95_wp, & ! Rb,Sr
      &                 1.22_wp,1.33_wp,1.60_wp,2.16_wp,1.90_wp, & ! Y-
      &                 2.20_wp,2.28_wp,2.20_wp,1.93_wp,1.69_wp, & ! -Cd
      &                 1.78_wp,1.96_wp,2.05_wp,2.10_wp,2.66_wp,2.60_wp, & ! In-Xe
      & 0.79_wp,0.89_wp, & ! Cs,Ba
      &         1.10_wp,1.12_wp,1.13_wp,1.14_wp,1.15_wp,1.17_wp,1.18_wp, & ! La-Eu
      &         1.20_wp,1.21_wp,1.22_wp,1.23_wp,1.24_wp,1.25_wp,1.26_wp, & ! Gd-Yb
      &                 1.27_wp,1.30_wp,1.50_wp,2.36_wp,1.90_wp, & ! Lu-
      &                 2.20_wp,2.20_wp,2.28_wp,2.54_wp,2.00_wp, & ! -Hg
      &                 1.62_wp,2.33_wp,2.02_wp,2.00_wp,2.20_wp,2.20_wp, & ! Tl-Rn
      ! only dummies below
      & 1.50_wp,1.50_wp, & ! Fr,Ra
      &         1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Ac-Am
      &         1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Cm-No
      &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Rf-
      &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp, & ! Rf-Cn
      &                 1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp,1.50_wp ] ! Nh-Og


contains


!> Get electronegativity for species with a given symbol
elemental function getPaulingENSymbol(symbol) result(en)

   !> Element symbol
   character(len=*), intent(in) :: symbol

   !> atomic EN
   real(wp) :: en

   en = getPaulingEN(toNumber(symbol))

end function getPaulingENSymbol


!> Get electronegativity for species with a given atomic number
elemental function getPaulingENNumber(number) result(en)

   !> Atomic number
   integer, intent(in) :: number

   !> atomic EN
   real(wp) :: en

   if (number > 0 .and. number <= size(paulingEN, dim=1)) then
      en = paulingEN(number)
   else
      en = -1.0_wp
   end if

end function getPaulingENNumber


end module xtb_param_paulingen

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

subroutine print_filelist(iunit)
   use xtb_mctc_global, only : persistentEnv
   use xtb_readin
   implicit none
   integer,intent(in) :: iunit

   call persistentEnv%io%list(iunit)

end subroutine print_filelist

subroutine delete_file(name)
   use xtb_mctc_global, only : persistentEnv
   implicit none
   character(len=*),intent(in)  :: name

   call persistentEnv%io%deleteFile(name)

end subroutine delete_file

subroutine touch_file(name)
   use xtb_mctc_global, only : persistentEnv
   use xtb_setparam
   implicit none
   character(len=*),intent(in)  :: name

   call persistentEnv%io%touchFile(name)

end subroutine touch_file

subroutine open_binary(iunit,name,status)
   use xtb_mctc_global, only : persistentEnv
   implicit none
   integer, intent(out) :: iunit
   character(len=*),intent(in)  :: name
   character(len=1),intent(in)  :: status

   select case(status)
   case default
      iunit = -1
   case('r','R')
      call persistentEnv%io%readBinary(iunit, name)
   case('w','W')
      call persistentEnv%io%writeBinary(iunit, name)
   end select

end subroutine open_binary

subroutine open_file(iunit,name,status)
   use xtb_mctc_global, only : persistentEnv
   implicit none
   character(len=*),intent(in)  :: name
   character(len=1),intent(in)  :: status
   integer,intent(out) :: iunit

   select case(status)
   case default
      iunit = -1
   case('r','R')
      call persistentEnv%io%readFile(iunit, name)
   case('w','W')
      call persistentEnv%io%writeFile(iunit, name)
   end select

end subroutine open_file

subroutine close_file(unit)
   use xtb_mctc_global, only : persistentEnv
   implicit none
   integer,intent(in) :: unit

   call persistentEnv%io%closeFile(unit)

end subroutine close_file

subroutine remove_file(unit)
   use xtb_mctc_global, only : persistentEnv
   implicit none
   integer,intent(in) :: unit

   call persistentEnv%io%closeFile(unit, remove=.true.)

end subroutine remove_file

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_io_writer_gaussian
   use xtb_mctc_accuracy, only : wp
   use xtb_type_molecule, only : TMolecule, len
   implicit none
   private

   public :: writeResultsGaussianExternal


contains


subroutine writeResultsGaussianExternal(unit, energy, dipole, gradient)
   integer, intent(in) :: unit
   real(wp), intent(in) :: energy
   real(wp), intent(in) :: dipole(:)
   real(wp), intent(in) :: gradient(:, :)

   write(unit, '(4D20.12)') energy, dipole
   write(unit, '(3D20.12)') gradient

end subroutine writeResultsGaussianExternal


end module xtb_io_writer_gaussian

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

!**********************************************************************
!                                                                     *
!  make the loewdin orthogonalization matrix x = u' s1/2 u            *
!  and the Loewdin orbitals cl from canonical ca
!                                                                     *
!**********************************************************************

subroutine makel(nao, s, can, clo)
   use xtb_mctc_lapack, only: lapack_syev
   use xtb_mctc_blas, only: blas_gemm
   implicit real * 8(a - h, o - z)
   dimension s(nao, nao)
   dimension can(nao, nao)
   dimension clo(nao, nao)
   real*8, allocatable :: aux(:), vecs(:, :), e(:), cc(:, :), x(:, :)

   lwork = 1 + 6 * nao + 2 * nao**2
   allocate (vecs(nao, nao), e(nao), aux(lwork), cc(nao, nao))
   allocate (x(nao, nao))

   vecs = s

   call lapack_syev('V', 'U', nao, vecs, nao, e, aux, lwork, info)

   do i = 1, nao
      if (e(i) < 0) stop 'sorry, must stop in S^1/2!'
      e(i) = dsqrt(e(i))
   end do

   do m = 1, nao
      do i = 1, nao
         x(i, m) = vecs(i, m)
         cc(i, m) = e(m) * vecs(i, m)
      end do
   end do

   call blas_gemm('N', 'T', nao, nao, nao, 1.0d0, x, nao, cc, nao, 0.0d0, vecs, nao)

   x = vecs
   deallocate (e, aux, cc, vecs)

   moci = nao
   call blas_gemm('n', 'n', nao, moci, nao, 1.d0, x, nao, can, nao, 0.d0, clo, nao)

   deallocate (x)
   return
end subroutine makel

! unrestricted version
subroutine umakel(nao, s, cana, canb, cloa, clob)
   use xtb_mctc_lapack, only: lapack_syev
   use xtb_mctc_blas, only: blas_gemm
   implicit real * 8(a - h, o - z)
   dimension s(nao, nao)
   dimension cana(nao, nao)
   dimension cloa(nao, nao)
   dimension canb(nao, nao)
   dimension clob(nao, nao)
   real*8, allocatable :: aux(:), vecs(:, :), e(:), cc(:, :), x(:, :)

   lwork = 1 + 6 * nao + 2 * nao**2
   allocate (vecs(nao, nao), e(nao), aux(lwork), cc(nao, nao))
   allocate (x(nao, nao))

   vecs = s

   call lapack_syev('V', 'U', nao, vecs, nao, e, aux, lwork, info)

   do i = 1, nao
      if (e(i) < 0) stop 'sorry, must stop in S^1/2!'
      e(i) = dsqrt(e(i))
   end do

   do m = 1, nao
      do i = 1, nao
         x(i, m) = vecs(i, m)
         cc(i, m) = e(m) * vecs(i, m)
      end do
   end do

   call blas_gemm('N', 'T', nao, nao, nao, 1.0d0, x, nao, cc, nao, 0.0d0, vecs, nao)

   x = vecs
   deallocate (e, aux, cc, vecs)

   moci = nao
   call blas_gemm('n', 'n', nao, moci, nao, 1.d0, x, nao, cana, nao, 0.d0, cloa, nao)
   call blas_gemm('n', 'n', nao, moci, nao, 1.d0, x, nao, canb, nao, 0.d0, clob, nao)

   deallocate (x)
   return
end subroutine umakel

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

module xtb_mctc_convert
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_constants
   implicit none
   public :: autoaa4byamu, m4bykgtoang4byamu
   private
!  convert bohr (a.u.) to Ångström and back
   real(wp), public, parameter :: autoaa = 0.52917726_wp
   real(wp), public, parameter :: aatoau = 1.0_wp / autoaa
!  convert Hartree to eV and back
   real(wp), public, parameter :: autoev = 27.21138505_wp
   real(wp), public, parameter :: evtoau = 1.0_wp / autoev
!  convert Hartree to kcal/mol and back
   real(wp), public, parameter :: autokcal = 627.50947428_wp
   real(wp), public, parameter :: kcaltoau = 1.0_wp / autokcal
!  convert Hartree to kJ/mol and back
   real(wp), public, parameter :: autokj = 2625.49964038_wp
   real(wp), public, parameter :: kjtoau = 1.0_wp / autokj
!  convert Hartree (a.u.) to Joule and back
   real(wp), public, parameter :: autoj = 4.3597447222071e-18_wp
   real(wp), public, parameter :: jtoau = 1.0_wp / autoj
!  convert Hartree to reciproce centimeters/wavenumbers and back
   real(wp), public, parameter :: autorcm = 219474.63067_wp
   real(wp), public, parameter :: autowav = autorcm
   real(wp), public, parameter :: rcmtoau = 1.0_wp / autorcm
   real(wp), public, parameter :: wavtoau = 1.0_wp / autowav
!  convert Hartree to nanometers and back
   real(wp), public, parameter :: autonm = 45.56335266_wp
   real(wp), public, parameter :: nmtoau = 1.0_wp / autonm
!  masses
!  amu -> kg :: conversion from atomic mass units to kg
!  me  -> kg :: electron mass (a.u.) in kg
!  amu -> au :: conversion from a.u. to amu
   real(wp), public, parameter :: amutokg = 1.660539040e-27_wp
   real(wp), public, parameter :: kgtoamu = 1.0_wp / amutokg
   real(wp), public, parameter :: metokg = 9.10938356e-31_wp
   real(wp), public, parameter :: kgtome = 1.0_wp / metokg
   real(wp), public, parameter :: amutoau = amutokg * kgtome
   real(wp), public, parameter :: autoamu = kgtoamu * metokg
!  femtosectons to atomic time units
   real(wp), public, parameter :: fstoau = 41.3413733365614_wp
   real(wp), public, parameter :: autofs = 1.0_wp / fstoau
!  Coulomb to atomic charge units (electrons)
   real(wp), public, parameter :: autoc = 1.6021766208e-19_wp
   real(wp), public, parameter :: ctoau = 1.0_wp / autoc
!  Debye to atomic units
   real(wp), public, parameter :: autod = autoc * lightspeed * autoaa**2 * fstoau * 1.0e+16_wp
   real(wp), public, parameter :: dtoau = 1.0_wp / autod

!> ----- DIPOLE DERIVATIVE UNITS -----
!  Dipole derivatives along mass-weighted normal mode coordinates (a.u.) to km/mol (IR int.)
!  autokmmol is the factor to convert dipole derivatives along
!  (mass-weighted) normal mode coordinates from a.u. into
!  the Naperian absorption coefficient
!
!        (pi)*(Navogadro)*(dipole derivative along normal mode)**2
!   A =  ---------------------------------------------------------  ,
!                       3*(4*(pi)*(epsilon0))*c**2
!
!  measured in km/mol. Cf. International Union of Pure and Applied
!  Chemistry (IUPAC), Quantities, Units and Symbols in Physical
!  Chemistry, Recommendations 1993, Reprinted with Corrections 1995.
!  Blackwell Scientific Publications.
   real(wp), public, parameter :: autokmmol = 1.7770969e+6_wp
!> ----------------------------------

!> ----- RAMAN INTENSITY UNITS -----
!
!                    a.u.         |        SI unit     |      typical unit
!---------------------------------|--------------------|----------------------
!               e**2 a_0**2       |          C**2 m**2 |          Ä⁴
!      from S = -----------       |  to  S = --------- | to  S = -----
!               m_e**2 (E_h/e)**2 |           amu V**2 |          amu
!
! For the conversion of the Raman intensity from a.u. to the
! SI unit and the typical unit used in the literature, see:
! https://onlinelibrary.wiley.com/doi/10.1002/jcc.10089

contains

   function autoaa4byamu() result(aa4byamu)

      real(wp) :: ramantonormunits, recip4pie0
      real(wp) :: aa4byamu
      ramantonormunits = (autoc**2 * (autoaa * 1.0e-10_wp)**2) & ! 1.065693E-31
                         / ((autoamu * amutokg) * (autoj / autoc)**2)
      recip4pie0 = (1.0_wp / (4.0_wp * pi * 8.8541878128e-12_wp))**2 ! 8.077608721857700E+019
      aa4byamu = ramantonormunits * recip4pie0 * m4bykgtoang4byamu()
   end function autoaa4byamu

   function m4bykgtoang4byamu() result(sitoang4byamu)

      real(wp) :: sitoang4byamu
      sitoang4byamu = (1.0e+10_wp)**4 / kgtoamu ! 16605390400000.0
   end function m4bykgtoang4byamu
!> ----------------------------------

end module xtb_mctc_convert

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Declaration of an integral storage container to collect all overlap related integrals
module xtb_ptb_integral_types
#if WITH_TBLITE
   use mctc_env, only: wp
   implicit none
   private

   public :: new_aux_integral

   !> Integral container to store all overlap related integrals
   type, public :: aux_integral_type
      !> Overlap integrals
      real(wp), allocatable :: overlap_h0_1(:, :), overlap_h0_2(:, :), overlap_xc(:, :)
      !> Overlap^(x) and Overlap^(1-x) integrals
      real(wp), allocatable :: overlap_to_x(:, :), overlap_to_1_x(:, :)
      !> Norm of overlap matrix (Normalization factors)
      real(wp), allocatable :: norm(:)
   end type aux_integral_type

contains

!> Create and allocate a new integral container storage
   subroutine new_aux_integral(self, nao)
      !> Instance of the integral container
      type(aux_integral_type), intent(out) :: self
      !> Dimension of the integrals
      integer, intent(in) :: nao

      allocate (self%norm(nao), source=0.0_wp)
      allocate (self%overlap_h0_1(nao, nao), self%overlap_h0_2(nao, nao), source=0.0_wp)
      allocate (self%overlap_xc(nao, nao), source=0.0_wp)
      allocate (self%overlap_to_x(nao, nao), source=0.0_wp)
      allocate (self%overlap_to_1_x(nao, nao), source=0.0_wp)
   end subroutine new_aux_integral

#endif
end module xtb_ptb_integral_types

! This file is part of xtb.
!
! Copyright (C) 2017-2020 Stefan Grimme
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.


module xtb_prog_main
   use xtb_mctc_accuracy, only: wp
   use xtb_mctc_io, only: stderr
   use xtb_mctc_timings
   use xtb_mctc_systools
   use xtb_mctc_convert
   use xtb_mctc_param
   use xtb_type_molecule
   use xtb_type_calculator
   use xtb_type_restart
   use xtb_tblite_restart, only: loadRestart, dumpRestart
   use xtb_type_param
   use xtb_type_data
   use xtb_type_environment, only: TEnvironment, init
   use xtb_prog_argparser
   use xtb_solv_state
   use xtb_setparam
   use xtb_sphereparam
   use xtb_scanparam
   use xtb_splitparam
   use xtb_fixparam
   use xtb_features, only: get_xtb_feature
   use xtb_constrain_param, only: read_userdata
   use xtb_shake, only: init_shake
   use xtb_gfnff_shake, only: gff_init_shake => init_shake
   use xtb_embedding, only: init_pcem
   use xtb_io_reader, only: readMolecule
   use xtb_io_writer, only: writeMolecule
   use xtb_mctc_filetypes, only: fileType, getFileType, generateFileMetaInfo, &
      & generateFileName
   use xtb_readin
   use xtb_printout
   use xtb_setmod
   use xtb_propertyoutput
   use xtb_io_writer_turbomole, only: writeResultsTurbomole
   use xtb_io_writer_orca, only: writeResultsOrca
   use xtb_io_writer_gaussian, only: writeResultsGaussianExternal
   use xtb_restart
   use xtb_readparam
   use xtb_scc_core, only: iniqshell
   use xtb_aespot, only: get_radcn
   use xtb_iniq, only: iniqcn
   use xtb_eeq
   use xtb_disp_ncoord, only: ncoord_gfn, dncoord_erf, dncoord_d3, ncoord_erf, &
      & ncoord_d3
   use xtb_basis
   use xtb_axis, only: axis3
   use xtb_hessian, only: numhess
   use xtb_dynamic, only: md
   use xtb_modef, only: modefollow
   use xtb_mdoptim, only: mdopt
   use xtb_screening, only: screen
   use xtb_xtb_calculator
   use xtb_gfnff_calculator
   use xtb_iff_calculator, only: TIFFCalculator
   use xtb_paramset
   use xtb_xtb_gfn0
   use xtb_xtb_gfn1
   use xtb_xtb_gfn2
   use xtb_main_setup
   use xtb_main_defaults, only: initDefaults
   use xtb_main_json, only: main_xtb_json, write_json_gfnff_lists
   use xtb_geoopt
   use xtb_metadynamic
   use xtb_biaspath
   use xtb_coffee
   use xtb_disp_dftd3param
   use xtb_disp_dftd4
   use xtb_gfnff_param, only: gff_print
   use xtb_gfnff_topology, only: TPrintTopo
   use xtb_gfnff_convert, only: struc_convert
   use xtb_scan
   use xtb_kopt
   use xtb_iff_iffprepare, only: prepare_IFF
   use xtb_iff_data, only: TIFFData
   use xtb_oniom, only: oniom_input, TOniomCalculator, calculateCharge
   use xtb_vertical, only: vfukui
   use xtb_tblite_calculator, only: TTBLiteCalculator, TTBLiteInput, &
         & newTBLiteWavefunction, get_ceh
   use xtb_ptb_calculator, only: TPTBCalculator
   use xtb_solv_cpx, only: TCpcmx
   use xtb_dipro, only: get_jab, jab_input
   !> PTB related modules
   use xtb_main_json, only: main_ptb_json

   implicit none
   private

   public :: xtbMain

contains

   subroutine xtbMain(env, argParser)

      !> Source of errors in the main program unit
      character(len=*), parameter :: source = "prog_main"

      type(TEnvironment), intent(inout) :: env

      type(TArgParser), intent(inout) :: argParser

!! ========================================================================
!  use some wrapper types to bundle information together
      type(TMolecule) :: mol
      type(scc_results) :: res
      class(TCalculator), allocatable :: calc, cpxcalc
      type(freq_results) :: fres
      type(TRestart) :: chk
      type(chrg_parameter) :: chrgeq
      type(TIFFData), allocatable :: iff_data
      type(oniom_input) :: oniom
      type(jab_input) :: dipro
      type(TCpcmx) :: cpx
      type(TTBLiteInput) :: tblite
!  store important names and stuff like that in FORTRAN strings
      character(len=:), allocatable :: fname    ! geometry input file
      character(len=:), allocatable :: xcontrol ! instruction file
      character(len=:), allocatable :: xrc      ! global instruction file
      character(len=:), allocatable :: fnv      ! parameter file
      character(len=:), allocatable :: tmpname  ! temporary string
      character(len=:), allocatable :: cdum     ! temporary string
      character(len=:), allocatable :: extension, basename, directory
      integer :: ftype

!! ========================================================================
!  default names for important files in xtb
      character(len=*), parameter :: p_fname_rc = '.xtbrc'
      character(len=*), parameter :: p_fname_param_gfn0 = 'param_gfn0-xtb.txt'
      character(len=*), parameter :: p_fname_param_gfn1 = 'param_gfn1-xtb.txt'
      character(len=*), parameter :: p_fname_param_gfn2 = 'param_gfn2-xtb.txt'
      character(len=*), parameter :: p_fname_param_gfnff = '.param_gfnff.xtb'
      character(len=*), parameter :: p_fname_param_ipea = 'param_ipea-xtb.txt'
      character(len=*), parameter :: p_fname_param_ptb = 'param_ptb.txt'

      integer :: gsolvstate
      integer :: i, j, k, l, idum
      integer :: ich, ictrl, iprop ! file handle
      real(wp) :: sigma(3, 3)
      real(wp), allocatable :: cn(:)
      real(wp), allocatable :: sat(:)
      real(wp), allocatable :: g(:, :)
      real(wp), allocatable :: fukui(:, :)
      real(wp) :: vec3(3)
      type(TxTBParameter) :: globpar
      real(wp), allocatable :: dcn(:, :, :)
      real(wp), allocatable :: dq(:, :, :)
      real(wp), allocatable :: dumdumdum(:, :, :)
      real(wp), allocatable :: q(:)
      real(wp), allocatable :: ql(:)
      real(wp), allocatable :: qr(:)
!! ------------------------------------------------------------------------
      integer, external :: ncore

!! ------------------------------------------------------------------------
      logical :: struc_conversion_done = .false.
      logical :: anyopt, anyhess

!! ========================================================================
!  debugging variables for numerical gradient
      logical, parameter :: gen_param = .false.
      logical, parameter :: debug = .false.
      type(TRestart) :: wf0
      real(wp), allocatable :: coord(:, :), numg(:, :), gdum(:, :)
      real(wp) :: sdum(3, 3), nums(3, 3), eps(3, 3), latt(3, 3)

      real(wp), parameter :: step = 0.00001_wp, step2 = 0.5_wp / step ! for numerical gradient
      real(wp), parameter :: sstep = 1.0_wp * 10.0_wp**(-6), sstep2 = 0.5_wp / sstep ! for numerical sigma
      real(wp) :: er, el
      logical :: coffee ! if debugging gets really though, get a coffee

!! ------------------------------------------------------------------------
!  undocumented and unexplainable variables go here
      integer :: nFiles, iFile
      integer :: rohf, err
      real(wp) :: dum5, egap, etot, ipeashift
      real(wp) :: zero, t0, t1, w0, w1, etot2, g298
      real(wp) :: one, two
      real(wp) :: ea, ip
      real(wp) :: vomega
      real(wp) :: energy_gas
      parameter(zero=0.0_wp)
      parameter(one=1.0_wp)
      parameter(two=2.0_wp)
      logical :: ex, okbas
      logical :: epr, diff, murks
      logical :: exist
      logical :: lgrad, restart
      logical :: copycontrol
      logical :: newreader
      logical :: strict
      logical :: exitRun
      logical :: cold_fusion

!  OMP stuff
      integer :: TID, OMP_GET_NUM_THREADS, OMP_GET_THREAD_NUM
      integer :: nproc

      type(TPrintTopo) :: printTopo ! gfnff topology printout list

      xenv%home = env%xtbhome
      xenv%path = env%xtbpath

      ! ------------------------------------------------------------------------
      !> read the command line arguments

      call parseArguments(env, argParser, xcontrol, fnv, lgrad, &
         & restart, gsolvstate, strict, copycontrol, coffee, printTopo, oniom, dipro, tblite)

      
      ! TEMPORARY: no solvation available for PTB and tblite !
      if (set%mode_extrun == p_ext_tblite .or. set%mode_extrun == p_ext_ptb) then
         if (allocated(set%solvInput%solvent)) then
            call env%error("Solvation is not implemented for PTB/tblite", source)
         endif
      end if

      !> Spin-polarization is only available in the tblite library
      if (set%mode_extrun /= p_ext_tblite .and. tblite%spin_polarized) then
         call env%error("Spin-polarization is only available with the tblite library! Try --tblite", source)
      end if

      !> If hessian (or ohess or bhess) is requested in combination with PTB, conduct GFN2-xTB + PTB hessian
      anyhess = (set%runtyp == p_run_hess) .or. (set%runtyp == p_run_ohess) .or. (set%runtyp == p_run_bhess)
      if (anyhess) then
         if(set%mode_extrun == p_ext_ptb) then
            set%mode_extrun = p_ext_xtb
            set%ptbsetup%ptb_in_hessian = .true.
            call set_gfn(env, 'method', '2')
            call set_gfn(env, 'd4', 'true')
            tblite%method = "gfn2"
            set%ptbsetup%hessmethod = "GFN2-xTB"
         else
            if (set%elprop == p_elprop_alpha) then
               call env%error("Raman activities are not implemented with this method",source)
            end if
         endif
      endif 

      nFiles = argParser%countFiles()
      select case (nFiles)
      case (0)
         if (.not. coffee) then
          if (printTopo%warning) call env%error("Eventually the input file was given to wrtopo as an argument.", source)
            call env%error("No input file given, so there is nothing to do", source)
         else
            fname = 'coffee'
         end if
      case (1:)
         do iFile = 1, nFiles - 1
            call argParser%nextFile(fname)
            call env%warning("Input file '"//fname//"' will be ignored", source)
         end do
         call argParser%nextFile(fname)
      end select

      if (.not. allocated(xcontrol)) then
         if (copycontrol) then
            xcontrol = 'xtb.inp'
         else
            xcontrol = fname
         end if
      end if

      anyopt = ((set%runtyp == p_run_opt) .or. (set%runtyp == p_run_ohess) .or. &
         &   (set%runtyp == p_run_omd) .or. (set%runtyp == p_run_screen) .or. &
         &   (set%runtyp == p_run_metaopt))

      if (allocated(set%solvInput%cpxsolvent).and.anyopt) then
            call env%terminate("CPCM-X not implemented for geometry optimization. &
                 & Please use another solvation model for optimization instead.")
      endif     
 
      if ((set%mode_extrun == p_ext_ptb) .and. anyopt) call env%terminate("PTB not implemented for geometry optimization. &
         &Please use another method for optimization instead.")

      call env%checkpoint("Command line argument parsing failed")

      ! ------------------------------------------------------------------------
      !> read the detailed input file
      call rdcontrol(xcontrol, env, copy_file=copycontrol)

      call env%checkpoint("Reading '"//xcontrol//"' failed")

      ! ------------------------------------------------------------------------
      !> read dot-Files before reading the rc and after reading the xcontrol
      !> Total molecular charge
      call open_file(ich, '.CHRG', 'r')
      if (ich /= -1) then
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%error('.CHRG is empty!', source)
         else
            call set_chrg(env, cdum)
            call close_file(ich)
         end if
      end if

      call env%checkpoint("Reading charge from file failed")

      !> Number of unpaired electrons
      call open_file(ich, '.UHF', 'r')
      if (ich /= -1) then
         call getline(ich, cdum, iostat=err)
         if (err /= 0) then
            call env%error('.UHF is empty!', source)
         else
            call set_spin(env, cdum)
            call close_file(ich)
         end if
      end if

      call env%checkpoint("Reading multiplicity from file failed")

      !> efield read: gfnff and PTB only
      if (set%mode_extrun == p_ext_gfnff .or. set%mode_extrun == p_ext_ptb) then
         call open_file(ich, '.EFIELD', 'r')
         if (ich /= -1) then
            call getline(ich, cdum, iostat=err)
            if (err /= 0) then
               call env%error('.EFIELD is empty!', source)
            else
               call set_efield(env, cdum)
               call close_file(ich)
            end if
         end if
      end if

      !> If EFIELD is not zero when using xtb, print a warning
      if (((set%mode_extrun /= p_ext_ptb) .and. (set%mode_extrun /= p_ext_gfnff)) &
         & .and. (sum(abs(set%efield)) /= 0.0_wp)) then
         call env%terminate("External electric field is not zero ('--efield' or file '.EFIELD'), &
            & but only supported for GFN-FF and PTB")
      end if

      ! ------------------------------------------------------------------------
      !> read the xtbrc if you can find it (use rdpath directly instead of xfind)
      call rdpath(env%xtbpath, p_fname_rc, xrc, exist)
      if (exist) then
         call rdcontrol(xrc, env, copy_file=.false.)

         call env%checkpoint("Reading '"//xrc//"' failed")
      end if

      ! ------------------------------------------------------------------------
      !> FIXME: some settings that are still not automatic
      !> Make sure GFN0-xTB uses the correct exttyp
      if (set%gfn_method == 0) call set_exttyp('eht')
      rohf = 1 ! HS default
      egap = 0.0_wp
      ipeashift = 0.0_wp

      ! ========================================================================
      !> no user interaction up to now, time to show off!
      !> print the xtb banner with version number and compilation date
      !> making a fancy version of this is hard, x is difficult in ASCII art
      call xtb_header(env%unit)
      !> make sure you cannot blame us for destroying your computer
      call disclamer(env%unit)
      !> how to cite this program
      call citation(env%unit)
      !> print current time
      call prdate('S')

      ! ------------------------------------------------------------------------
      !> get molecular structure
      if (coffee) then ! it's coffee time
         fname = 'caffeine'
         call get_coffee(mol)
         call generateFileMetaInfo(fname, directory, basename, extension)
      else
         call generateFileMetaInfo(fname, directory, basename, extension)
         ftype = getFileType(fname)
         call open_file(ich, fname, 'r')
         call readMolecule(env, mol, ich, ftype)
         call close_file(ich)
         if (mol%info%two_dimensional) then
            call env%warning("Two dimensional input structure detected", source)
         end if

         ! Special CT input file case
         if (mol%chrg /= 0.0_wp) then
            if (set%clichrg) then
               call env%warning("Charge in sdf/mol input was overwritten", source)
            else
               set%ichrg = nint(mol%chrg)
            end if
         end if

         call env%checkpoint("reading geometry input '"//fname//"' failed")
      end if

      ! ------------------------------------------------------------------------
      !> initialize the global storage
      call init_fix(mol%n)
      call init_split(mol%n)
      call init_constr(mol%n, mol%at)
      call init_scan
      call init_walls
      call init_pcem
      if (set%runtyp == p_run_bhess) then
         call init_bhess(mol%n)
      else
         call init_metadyn(mol%n, metaset%maxsave)
      end if
      call load_rmsdbias(rmsdset, mol%n, mol%at, mol%xyz)
      ! ------------------------------------------------------------------------
      !> CONSTRAINTS & SCANS
      !> now we are at a point that we can check for requested constraints
      call read_userdata(xcontrol, env, mol)
      ! ------------------------------------------------------------------------
      !> get some memory
      allocate (cn(mol%n), sat(mol%n), g(3, mol%n), source=0.0_wp)
      atmass = atomic_mass(mol%at) * autoamu ! from splitparam.f90
      set%periodic = mol%npbc > 0
      if (mol%npbc == 0) then
         if (set%do_cma_trafo) then
            allocate (coord(3, mol%n), source=0.0_wp)
            call axis3(1, mol%n, mol%at, mol%xyz, coord, vec3)
            mol%xyz = coord
            deallocate (coord)
         end if
      end if

      do i = 1, mol%n
         mol%z(i) = mol%at(i) - ncore(mol%at(i))
         ! lanthanides without f are treated as La
         if (mol%at(i) > 57 .and. mol%at(i) < 72) mol%z(i) = 3
      end do

      !> initialize time step for MD if requested autocomplete
      if (set%tstep_md < 0.0_wp) then
         set%tstep_md = (minval(atmass) / (atomic_mass(1) * autoamu))**(1.0_wp / 3.0_wp)
      end if

      mol%chrg = real(set%ichrg, wp)
   !! To assign charge
      mol%uhf = set%nalphabeta
      call initrand

      call setup_summary(env%unit, mol%n, fname, xcontrol, chk%wfn, xrc)

      ! ------------------------------------------------------------------------
      !> 2D => 3D STRUCTURE CONVERTER
      ! ------------------------------------------------------------------------
      if (mol%info%two_dimensional) then
         call struc_convert(env, restart, mol, chk, egap, set%etemp, set%maxscciter, &
                           &  set%optset%maxoptcycle, etot, g, sigma)
         struc_conversion_done = .true.
         mol%info%two_dimensional = .false.
      end if


      if (sum(abs(set%efield)) /= 0.0_wp) then
         write (env%unit, '(/,3x,a)') "--------------------------------------"
         write (env%unit, '(3x,a)') "--- external electric field / a.u. ---"
         write (env%unit, '(3x,3(a,f8.4))') "x = ", set%efield(1), " y = ", set%efield(2), " z = ", set%efield(3)
         write (env%unit, '(3x,a)') "--------------------------------------"
      end if

      !> initialize metadynamics
      call load_metadynamic(metaset, mol%n, mol%at, mol%xyz)

      !> restraining potential
      if (allocated(potset%xyz)) then
         if (lconstr_all_bonds) call constrain_all_bonds(mol%n, mol%at, potset%xyz)
         if (lconstr_all_angles) call constrain_all_angles(mol%n, mol%at, potset%xyz)
         if (lconstr_all_torsions) call constrain_all_torsions(mol%n, mol%at, potset%xyz)
         call setup_constrain_pot(mol%n, mol%at, potset%xyz)
      else
         if (lconstr_all_bonds) call constrain_all_bonds(mol%n, mol%at, mol%xyz)
         if (lconstr_all_angles) call constrain_all_angles(mol%n, mol%at, mol%xyz)
         if (lconstr_all_torsions) call constrain_all_torsions(mol%n, mol%at, mol%xyz)
         call setup_constrain_pot(mol%n, mol%at, mol%xyz)
      end if
      !  fragmentation for CMA constrain
      if (iatf1 == 0 .and. iatf2 == 0) then
         call ncoord_erf(mol%n, mol%at, mol%xyz, cn)
         call splitm(mol%n, mol%at, mol%xyz, cn)
      end if
      call splitprint(mol%n, mol%at, mol%xyz)

      if (set%verbose) then
         call fix_info(env%unit, mol%n, mol%at, mol%xyz)
         call pot_info(env%unit, mol%n, mol%at, mol%xyz)
      end if

      ! ------------------------------------------------------------------------
      !> write copy of detailed input
      if (copycontrol) then
         call open_set(ictrl, xcontrol)
         call write_set(ictrl)
         call close_set(ictrl)
      end if

      ! ------------------------------------------------------------------------
      !> if you have requested a define we stop here...
      if (set%define) then
         if (set%verbose) call main_geometry(env%unit, mol)
         call eval_define(set%veryverbose)
      end if
      call env%show('Please study the warnings concerning your input carefully')
      call raise('F', 'Please study the warnings concerning your input carefully')

      ! ========================================================================
      !> From here we switch to the method setup
      !> enable error on warnings
      if (strict) call mctc_strict
      env%strict = strict

      !> one last check on the input geometry
      call check_cold_fusion(env, mol, cold_fusion)
      if (cold_fusion) then
         call env%error("XTB REFUSES TO CONTINUE WITH THIS CALCULATION!")
         call env%terminate("Some atoms in the start geometry are *very* close")
      end if

      !> check if someone is still using GFN3...
      if (set%gfn_method == 3) then
         call env%terminate('Wait for some months - for now, please use gfn_method=2!')
      end if

      ! ------------------------------------------------------------------------
      !> Print the method header and select the parameter file

      if (.not. allocated(fnv)) then
         select case (set%runtyp)
         case default
            call env%terminate('This is an internal error, please define your runtypes!')
         case (p_run_scc, p_run_grad, p_run_opt, p_run_hess, p_run_ohess, p_run_bhess, &
               p_run_md, p_run_omd, p_run_path, p_run_screen, &
               p_run_modef, p_run_mdopt, p_run_metaopt)
            if (set%mode_extrun == p_ext_gfnff) then
               fnv = xfind(p_fname_param_gfnff)
             elseif (set%mode_extrun .eq. p_ext_ptb) then
                  fnv = xfind(p_fname_param_ptb)
            else
               if (set%gfn_method == 0) then
                  fnv = xfind(p_fname_param_gfn0)
               end if
               if (set%gfn_method == 1) then
                  fnv = xfind(p_fname_param_gfn1)
               end if
               if (set%gfn_method == 2) then
                  fnv = xfind(p_fname_param_gfn2)
               end if
            end if
         case (p_run_vip, p_run_vea, p_run_vipea, p_run_vfukui, p_run_vomega)
            if (set%gfn_method == 0) then
               fnv = xfind(p_fname_param_gfn0)
            end if
            if (set%gfn_method == 1) then
               fnv = xfind(p_fname_param_gfn1)
            end if
            if (set%gfn_method == 2) then
               fnv = xfind(p_fname_param_gfn2)
            end if
         end select
      end if

      !-------------------------------------------------------------------------
      !> Perform a precomputation of electronic properties for xTB-IFF
      if (set%mode_extrun == p_ext_iff) then
         allocate (iff_data)
         call prepare_IFF(env, mol, iff_data)
         call env%checkpoint("Could not generate electronic properties")
      end if

      ! ------------------------------------------------------------------------
      !> Obtain the parameter data
      call newCalculator(env, mol, calc, fnv, restart, set%acc, oniom, iff_data, tblite)
      call env%checkpoint("Could not setup single-point calculator")

      call initDefaults(env, calc, mol, gsolvstate)
      call env%checkpoint("Could not setup defaults")

      ! ------------------------------------------------------------------------
      !> initial guess, setup wavefunction
      select type (calc)
      type is (TxTBCalculator)
         call chk%wfn%allocate(mol%n, calc%basis%nshell, calc%basis%nao)

         ! Make sure number of electrons is initialized an multiplicity is consistent
         chk%wfn%nel = nint(sum(mol%z) - mol%chrg)
         chk%wfn%nopen = mol%uhf
         if (chk%wfn%nopen == 0 .and. mod(chk%wfn%nel, 2) /= 0) chk%wfn%nopen = 1

         !> EN charges and CN
         if (set%gfn_method < 2) then
            call ncoord_d3(mol%n, mol%at, mol%xyz, cn)
         else
            call ncoord_gfn(mol%n, mol%at, mol%xyz, cn)
         end if
         if (mol%npbc > 0) then
            chk%wfn%q = real(set%ichrg, wp) / real(mol%n, wp)
         else
            if (set%guess_charges == p_guess_gasteiger) then
               call iniqcn(mol%n, mol%at, mol%z, mol%xyz, set%ichrg, 1.0_wp, chk%wfn%q, cn, set%gfn_method, .true.)
            else if (set%guess_charges == p_guess_goedecker) then
               call ncoord_erf(mol%n, mol%at, mol%xyz, cn)
               call goedecker_chrgeq(mol%n, mol%at, mol%xyz, real(set%ichrg, wp), cn, dcn, chk%wfn%q, dq, er, g, &
                                     .false., .false., .false.)
            else
               call ncoord_gfn(mol%n, mol%at, mol%xyz, cn)
               chk%wfn%q = real(set%ichrg, wp) / real(mol%n, wp)
            end if
         end if
         !> initialize shell charges from gasteiger charges
         call iniqshell(calc%xtbData, mol%n, mol%at, mol%z, calc%basis%nshell, chk%wfn%q, chk%wfn%qsh, set%gfn_method)
      type is (TTBLiteCalculator)
         call newTBLiteWavefunction(env, mol, calc, chk)
      end select

      ! get CEH charges !
      if (tblite%ceh) &
         call get_ceh(env,mol,tblite)

      ! ------------------------------------------------------------------------
      !> printout a header for the exttyp
      call calc%writeInfo(env%unit, mol)

      call delete_file('.sccnotconverged')

      call env%checkpoint("Setup for calculation failed")

      select type (calc)
      type is (TxTBCalculator)
         if (restart .and. calc%xtbData%level /= 0) then ! only in first run
            call readRestart(env, chk%wfn, 'xtbrestart', mol%n, mol%at, set%gfn_method, exist, .true.)
         end if
         ipeashift = calc%xtbData%ipeashift
      type is (TTBLiteCalculator)
         if (restart) then
            call loadRestart(env, chk, 'xtbrestart', exist)
            if (exist) write (env%unit, "(a)") "Wavefunction read from restart file"
         end if
      type is (TOniomCalculator)
         select type (xtb => calc%real_low)
         type is (TxTBCalculator)
            call chk%wfn%allocate(mol%n, xtb%basis%nshell, xtb%basis%nao)
            call newWavefunction(env, mol, xtb, chk)
         !! assigns only partial charges q and shell charges
            if (restart) then ! only in first run
               call readRestart(env, chk%wfn, 'xtbrestart', mol%n, mol%at, set%gfn_method, exist, .true.)
            end if
         end select
         if (.not. set%oniom_settings%fixed_chrgs) then
            set%oniom_settings%innerchrg = calculateCharge(calc, env, mol, chk)
         end if

      end select
      !-------------------------------------------------------------------------
      !> DIPRO calculation of coupling integrals for dimers
      if (dipro%diprocalc) then
         call start_timing(11)
         call get_jab(env, tblite, mol, splitlist, dipro)
         call env%checkpoint("Something in your DIPRO calculation went wrong.")
         call stop_timing_run
         call stop_timing(11)
         write (*, '(A)') "----------------------------------------------------------"
         call prdate('E')
         write (*, '(A)') "----------------------------------------------------------"
         call prtiming(11, 'dipro')
         call terminate(0)
      end if

      ! ========================================================================
      !> the SP energy which is always done
      call start_timing(2)
      call calc%singlepoint(env, mol, chk, 2, exist, etot, g, sigma, egap, res)
      call stop_timing(2)
      select type (calc)
      type is (TGFFCalculator)
         gff_print = .false.
      end select
      call env%checkpoint("Single point calculation terminated")

      !> write 2d => 3d converted structure
      if (struc_conversion_done) then
         call generateFileName(tmpname, 'gfnff_convert', extension, mol%ftype)
         write (env%unit, '(10x,a,1x,a,/)') &
            "converted geometry written to:", tmpname
         call open_file(ich, tmpname, 'w')
         call writeMolecule(mol, ich, energy=res%e_total, gnorm=res%gnorm)
         call close_file(ich)
      end if

      ! ========================================================================
      !> determine kopt for bhess including final biased geometry optimization
      if (set%runtyp == p_run_bhess) then
         call set_metadynamic(metaset, mol%n, mol%at, mol%xyz)
         call get_kopt(metaset, env, restart, mol, chk, calc, egap, set%etemp, set%maxscciter, &
            & set%optset%maxoptcycle, set%optset%optlev, etot, g, sigma, set%acc)
      end if

      ! ------------------------------------------------------------------------
      !> numerical gradient for debugging purposes
      if (debug) then
         !  generate a warning to keep release versions from calculating numerical gradients
         call env%warning('XTB IS CALCULATING NUMERICAL GRADIENTS, RESET DEBUG FOR RELEASE!')
         print'(/,"analytical gradient")'
         print *, g
         allocate (coord(3, mol%n), source=mol%xyz)
         allocate (numg(3, mol%n), gdum(3, mol%n), source=0.0_wp)
         wf0 = chk
         do i = 1, mol%n
            do j = 1, 3
               mol%xyz(j, i) = mol%xyz(j, i) + step
               chk = wf0
               call calc%singlepoint(env, mol, chk, 0, .true., er, gdum, sdum, egap, res)
               mol%xyz(j, i) = mol%xyz(j, i) - 2 * step
               chk = wf0
               call calc%singlepoint(env, mol, chk, 0, .true., el, gdum, sdum, egap, res)
               mol%xyz(j, i) = mol%xyz(j, i) + step
               numg(j, i) = step2 * (er - el)
            end do
         end do
         print'(/,"numerical gradient")'
         print *, numg
         print'(/,"difference gradient")'
         print *, g - numg
         deallocate (coord)
      end if

      !> numerical sigma (=volume*stressTensor) for debugging purposes
      if (debug .and. mol%npbc == 3) then
         !  generate a warning to keep release versions from calculating numerical gradients
         call env%warning('XTB IS CALCULATING NUMERICAL STRESS, RESET DEBUG FOR RELEASE!')
         print'(/,"analytical sigma")'
         print *, sigma
         if (.not. allocated(gdum)) allocate (gdum(3, mol%n), source=0.0_wp)
         allocate (coord(3, mol%n), source=mol%xyz)
         latt = mol%lattice
         nums = 0.0_wp
         !sdum = 0.0_wp
         wf0 = chk
         do j = 1, 3
            do i = 1, j
               ! Only eps_ij=step the rest equals zero: eps_(kl.ne.ij)=0
               eps = 0.0_wp
               eps(i, j) = sstep
               ! adjust position vectors and lattice to get er
               do k = 1, 3
                  mol%xyz(k, :) = kron(k, 1) * mol%xyz(1, :) + eps(k, 1) * mol%xyz(1, :) + &
                                &   kron(k, 2) * mol%xyz(2, :) + eps(k, 2) * mol%xyz(2, :) + &
                                &   kron(k, 3) * mol%xyz(3, :) + eps(k, 3) * mol%xyz(3, :)
                  mol%lattice(k, 1) = (kron(k, 1) + eps(k, 1)) * mol%lattice(1, 1) + &
                                   & (kron(k, 2) + eps(k, 2)) * mol%lattice(2, 1) + &
                                   & (kron(k, 3) + eps(k, 3)) * mol%lattice(3, 1)
                  mol%lattice(k, 2) = (kron(k, 1) + eps(k, 1)) * mol%lattice(1, 2) + &
                                   & (kron(k, 2) + eps(k, 2)) * mol%lattice(2, 2) + &
                                   & (kron(k, 3) + eps(k, 3)) * mol%lattice(3, 2)
                  mol%lattice(k, 3) = (kron(k, 1) + eps(k, 1)) * mol%lattice(1, 3) + &
                                   & (kron(k, 2) + eps(k, 2)) * mol%lattice(2, 3) + &
                                   & (kron(k, 3) + eps(k, 3)) * mol%lattice(3, 3)
               end do
               chk = wf0
               call calc%singlepoint(env, mol, chk, 0, .true., er, gdum, sdum, egap, res)

               ! reset coordinates and lattice
               mol%xyz = coord
               mol%lattice = latt
               ! adjust position vectors and lattice to get el
               do k = 1, 3
                  mol%xyz(k, :) = kron(k, 1) * mol%xyz(1, :) - eps(k, 1) * mol%xyz(1, :) + &
                                &  kron(k, 2) * mol%xyz(2, :) - eps(k, 2) * mol%xyz(2, :) + &
                                &  kron(k, 3) * mol%xyz(3, :) - eps(k, 3) * mol%xyz(3, :)
                  mol%lattice(k, 1) = (kron(k, 1) - eps(k, 1)) * mol%lattice(1, 1) + &
                                   & (kron(k, 2) - eps(k, 2)) * mol%lattice(2, 1) + &
                                   & (kron(k, 3) - eps(k, 3)) * mol%lattice(3, 1)
                  mol%lattice(k, 2) = (kron(k, 1) - eps(k, 1)) * mol%lattice(1, 2) + &
                                   & (kron(k, 2) - eps(k, 2)) * mol%lattice(2, 2) + &
                                   & (kron(k, 3) - eps(k, 3)) * mol%lattice(3, 2)
                  mol%lattice(k, 3) = (kron(k, 1) - eps(k, 1)) * mol%lattice(1, 3) + &
                                   & (kron(k, 2) - eps(k, 2)) * mol%lattice(2, 3) + &
                                   & (kron(k, 3) - eps(k, 3)) * mol%lattice(3, 3)
               end do
               chk = wf0
               call calc%singlepoint(env, mol, chk, 0, .true., el, gdum, sdum, egap, res)

               ! numerical sigma (=volume*stressTensor)
               nums(i, j) = sstep2 * (er - el)  ! divide by 2 times step size
               nums(j, i) = nums(i, j)  ! stress tensor is symmetric
               ! reset coordinates and lattice
               mol%xyz = coord
               mol%lattice = latt
            end do
         end do

         print'(/,"numerical sigma")'
         print *, nums
         print'(/,"difference sigma")'
         print *, sigma - nums
         deallocate (coord)
      end if

!---------------------------------------------!
! Geometry optimization(ANCopt,L_ANCopt,FIRE) !
!---------------------------------------------!
      if (anyopt) then

         if (mol%npbc > 0 .and. (set%mode_extrun == p_ext_gfnff &
                 & .or. set%mode_extrun == p_ext_mcgfnff)) then  ! if(npbc)
            deallocate (set%opt_engine)
            call set_opt(env, 'engine', 'pbc_lbfgs')  ! use lbfgs
         end if
         if (set%opt_engine == p_engine_rf) &
            call ancopt_header(env%unit, set%veryverbose)
         !! Print ANCopt header

         ! start optimization timer !
         call start_timing(3)

         ! calculation !
         call geometry_optimization &
            &     (env, mol, chk, calc, &
        &      egap,set%etemp,set%maxscciter,set%optset%maxoptcycle,etot,g,sigma,set%optset%optlev,.true.,.false.,murks)

         ! save results !
         res%e_total = etot
         res%gnorm = norm2(g)

         ! constrained optimization !
         if (nscan > 0) then
            call relaxed_scan(env, mol, chk, calc)
         end if

         ! in case of failure cretae xtblast geometry !
         if (murks) then
            call generateFileName(tmpname, 'xtblast', extension, mol%ftype)
            write (env%unit, '(/,a,1x,a,/)') &
               "last geometry written to:", tmpname
            call open_file(ich, tmpname, 'w')
            call writeMolecule(mol, ich, energy=res%e_total, gnorm=res%gnorm)
            call close_file(ich)
            call env%terminate("Geometry optimization failed")
         end if

         ! stop optimization timer !
         call stop_timing(3)

      end if

      ! ------------------------------------------------------------------------
      !> automatic VIP and VEA single point (maybe after optimization)
      if (set%runtyp == p_run_vip .or. set%runtyp == p_run_vipea &
         & .or. set%runtyp == p_run_vomega) then
         call start_timing(2)
         call vip_header(env%unit)
         mol%chrg = mol%chrg + 1
         chk%wfn%nel = chk%wfn%nel - 1
         if (mod(chk%wfn%nel, 2) /= 0) chk%wfn%nopen = 1
         call calc%singlepoint(env, mol, chk, 1, exist, etot2, g, sigma, egap, res)
         ip = etot2 - etot - ipeashift
         write (env%unit, '(72("-"))')
         write (env%unit, '("empirical IP shift (eV):",f10.4)') &
            &                  autoev * ipeashift
         write (env%unit, '("delta SCC IP (eV):",f10.4)') autoev * ip
         write (env%unit, '(72("-"))')
         mol%chrg = mol%chrg - 1
         chk%wfn%nel = chk%wfn%nel + 1
         call stop_timing(2)
      end if

      if (set%runtyp == p_run_vea .or. set%runtyp == p_run_vipea &
         & .or. set%runtyp == p_run_vomega) then
         call start_timing(2)
         call vea_header(env%unit)
         mol%chrg = mol%chrg - 1
         chk%wfn%nel = chk%wfn%nel + 1
         if (mod(chk%wfn%nel, 2) /= 0) chk%wfn%nopen = 1
         call calc%singlepoint(env, mol, chk, 1, exist, etot2, g, sigma, egap, res)
         ea = etot - etot2 - ipeashift
         write (env%unit, '(72("-"))')
         write (env%unit, '("empirical EA shift (eV):",f10.4)') &
            &                  autoev * ipeashift
         write (env%unit, '("delta SCC EA (eV):",f10.4)') autoev * ea
         write (env%unit, '(72("-"))')

         mol%chrg = mol%chrg + 1
         chk%wfn%nel = chk%wfn%nel - 1
         call stop_timing(2)
      end if

      ! ------------------------------------------------------------------------
      !> vomega (electrophilicity) index
      if (set%runtyp == p_run_vomega) then
         write (env%unit, '(a)')
         write (env%unit, '(72("-"))')
         write (env%unit, '(a,1x,a)') &
            "Calculation of global electrophilicity index", &
            "(IP+EA)²/(8·(IP-EA))"
         vomega = (ip + ea)**2 / (8 * (ip - ea))
         write (env%unit, '("Global electrophilicity index (eV):",f10.4)') &
            autoev * vomega
         write (env%unit, '(72("-"))')
      end if

      ! ------------------------------------------------------------------------
      !> Fukui Index from Mulliken population analysis
      if (set%runtyp == p_run_vfukui) then
         allocate (fukui(3, mol%n))
         call vfukui(env, mol, chk, calc, fukui)
      end if

      ! ------------------------------------------------------------------------
      !> numerical hessian calculation
      if ((set%runtyp == p_run_hess) .or. (set%runtyp == p_run_ohess) .or. (set%runtyp == p_run_bhess)) then
         if (set%runtyp == p_run_bhess .and. set%mode_extrun /= p_ext_turbomole) then
            call generic_header(env%unit, "Biased Numerical Hessian", 49, 10)
         else if (set%runtyp == p_run_bhess .and. set%mode_extrun == p_ext_turbomole) then
            call generic_header(env%unit, "Biased Analytical TM Hessian", 49, 10)
         else if (set%mode_extrun == p_ext_turbomole) then
            call generic_header(env%unit, "Analytical TM Hessian", 49, 10)
         else
            call numhess_header(env%unit)
         end if
         if (mol%npbc > 0) then
            call env%error("Phonon calculations under PBC are not implemented", source)
         end if
         call start_timing(5)
         call numhess &
            &       (env, mol, chk, calc, &
            &        egap, set%etemp, set%maxscciter, etot, g, sigma, fres)
         call stop_timing(5)

         call env%checkpoint("Hessian calculation terminated")
      end if

      ! reset the gap, since it is currently not updated in ancopt and numhess
      if (allocated(chk%wfn%emo)) then
         res%hl_gap = chk%wfn%emo(chk%wfn%ihomo + 1) - chk%wfn%emo(chk%wfn%ihomo)
      end if

      !> CPCM-X post-SCF solvation
      if (allocated(calc%solvation)) then
         if (allocated(calc%solvation%cpxsolvent)) then
            select type (calc)
            type is (TxTBCalculator)
               call generic_header(env%unit, "CPCM-X post-SCF solvation evaluation", 49, 10)
               if (set%gfn_method /= 2) call env%warning("CPCM-X was parametrized for GFN2-xTB. &
                  &The results are probably inaccurate with other methods.")
               Call cpx%setup(env, calc%solvation%cpxsolvent)
               Call env%checkpoint("CPCM-X setup terminated")
               cpxcalc = calc
               deallocate (cpxcalc%solvation)
               call cpxcalc%singlepoint(env, mol, chk, 1, .false., energy_gas, g, sigma, egap, res)
          Call cpx%calc_solv(env, calc%solvation%cpxsolvent, energy_gas, 0.4_wp, 298.15_wp, 500, 0.0001_wp, res%e_total)
               Call cpx%print(set%verbose)
               Call env%checkpoint("CPCM-X post-SCF solvation evaluation terminated")
            type is (TGFFCalculator)
               call env%error("CPCM-X is not possible with a force field.", source)
            end select
         end if
      end if

      call env%checkpoint("Calculation terminated")

      ! ========================================================================
      !> PRINTOUT SECTION
      if (allocated(set%property_file)) then
         call open_file(iprop, set%property_file, 'w')
         if (iprop == -1) then
            iprop = env%unit
            deallocate (set%property_file)
         else
            write (env%unit, '(/,a)') "Property printout bound to '"//set%property_file//"'"
            if (allocated(cdum)) deallocate (cdum)
            call get_command(length=l)
            allocate (character(len=l) :: cdum)
            call get_command(cdum)
            write (iprop, '("command:  ''",a,"''")') cdum
            call rdvar('HOSTNAME', cdum, err)
            if (err == 0) &
               write (iprop, '("hostname: ''",a,"''")') cdum
            write (iprop, '("date:     ",a)') prtimestring('S')
         end if
      else
         iprop = env%unit
      end if

      call generic_header(iprop, 'Property Printout', 49, 10)
      if (lgrad) then
         call writeResultsTurbomole(mol, energy=etot, gradient=g, sigma=sigma)
         if (allocated(basename)) then
            cdum = basename//'.engrad'
         else
            cdum = 'xtb-orca.engrad'
         end if
         call open_file(ich, cdum, 'w')
         call writeResultsOrca(ich, mol, etot, g)
         call close_file(ich)
      end if
      if (mol%ftype == fileType%gaussian) then
         if (allocated(basename)) then
            cdum = basename//'.EOu'
         else
            cdum = 'xtb-gaussian.EOu'
         end if
         call open_file(ich, cdum, 'w')
         call writeResultsGaussianExternal(ich, etot, res%dipole, g)
         call close_file(ich)
      end if

      if (set%periodic) then
         write (*, *) 'Periodic properties'
      else
         select type (calc)
         type is (TxTBCalculator)
            call main_property(iprop, env, mol, chk%wfn, calc%basis, calc%xtbData, res, &
               & calc%solvation, set%acc)
            call main_cube(set%verbose, mol, chk%wfn, calc%basis, res)
         type is (TGFFCalculator)
            call gfnff_property(iprop, mol%n, mol%xyz, calc%topo, chk%nlist)
         type is (TPTBCalculator)
            call ptb_property(iprop, env, chk, calc, mol, res)
         end select
      end if

      if (set%pr_json) then
         select type (calc)
         type is (TxTBCalculator)
            call open_file(ich, 'xtbout.json', 'w')
            call main_xtb_json(ich, &
                               mol, chk%wfn, calc%basis, res, fres)
            call close_file(ich)
         type is (TPTBCalculator)
            call open_file(ich, 'xtbout.json', 'w')
            call main_ptb_json(ich, &
                               mol, chk%wfn, calc, res, fres)
            call close_file(ich)
         end select
      end if
      if (printTopo%any()) then
         select type (calc)
         type is (TGFFCalculator)
            call write_json_gfnff_lists(mol%n, res%e_total, res%gnorm, calc%topo, calc%neigh, chk%nlist, printTopo)
         end select
      end if
      if ((set%runtyp == p_run_opt) .or. (set%runtyp == p_run_ohess) .or. &
          (set%runtyp == p_run_omd) .or. (set%runtyp == p_run_screen) .or. &
          (set%runtyp == p_run_metaopt) .or. (set%runtyp == p_run_bhess)) then
         call main_geometry(iprop, mol)
      end if

      if ((set%runtyp == p_run_hess) .or. (set%runtyp == p_run_ohess) .or. (set%runtyp == p_run_bhess)) then
         call generic_header(iprop, 'Frequency Printout', 49, 10)
         call main_freq(iprop, mol, chk%wfn, fres)
      end if

      if (allocated(set%property_file)) then
         if (iprop /= -1 .and. iprop /= env%unit) then
            call write_energy(iprop, res, fres, &
               & (set%runtyp == p_run_hess) .or. (set%runtyp == p_run_ohess) .or. (set%runtyp == p_run_bhess))
            call close_file(iprop)
         end if
      end if

      if ((set%runtyp == p_run_opt) .or. (set%runtyp == p_run_ohess) .or. &
          (set%runtyp == p_run_omd) .or. (set%runtyp == p_run_screen) .or. &
          (set%runtyp == p_run_metaopt) .or. (set%runtyp == p_run_bhess)) then
         call generateFileName(tmpname, 'xtbopt', extension, mol%ftype)
         write (env%unit, '(/,a,1x,a,/)') &
            "optimized geometry written to:", tmpname
         call open_file(ich, tmpname, 'w')
         call writeMolecule(mol, ich, energy=res%e_total, gnorm=res%gnorm)
         call close_file(ich)
      end if

      select type (calc)
      type is (TxTBCalculator)
         call write_energy(env%unit, res, fres, anyhess)
      type is (TOniomCalculator)
         call write_energy_oniom(env%unit, res, fres, anyhess)
      type is (TPTBCalculator)
      class default
         call write_energy_gff(env%unit, res, fres, anyhess)
      end select

      ! ------------------------------------------------------------------------
      !  xtb molecular dynamics
      if ((set%runtyp == p_run_md) .or. (set%runtyp == p_run_omd)) then
         if (metaset%maxsave > 0) then
            if (mol%npbc > 0) then
               call env%error("Metadynamic under PBC is not implemented", source)
            end if
            call metadyn_header(env%unit)
         else
            call md_header(env%unit)
         end if
         fixset%n = 0 ! no fixing for MD runs
         call start_timing(6)
         idum = 0
         select type (calc)
         class default
            if (set%shake_md) call init_shake(mol%n, mol%at, mol%xyz, chk%wfn%wbo)
         type is (TGFFCalculator)
            if (set%shake_md) call gff_init_shake(mol%n, mol%at, mol%xyz, calc%topo)
         end select
         call md &
            &     (env, mol, chk, calc, &
            &      egap, set%etemp, set%maxscciter, etot, g, sigma, 0, set%temp_md, idum)
         call stop_timing(6)
      end if

      ! ------------------------------------------------------------------------
      !  metadynamics
      if (set%runtyp == p_run_metaopt) then
         if (mol%npbc > 0) then
            call env%warning("Metadynamic under PBC is not implemented", source)
         end if
         call metadyn_header(env%unit)
         ! check if ANCOPT already convered
         if (murks) then
            call env%error('Optimization did not converge, aborting', source)
         end if
         write (env%unit, '(1x,"output written to xtbmeta.log")')
         call open_file(ich, 'xtbmeta.log', 'w')
         call writeMolecule(mol, ich, fileType%xyz, energy=etot, gnorm=norm2(g))
         k = metaset%nstruc + 1
         call start_timing(6)
         do l = k, metaset%maxsave
            metaset%nstruc = l
            metaset%xyz(:, :, metaset%nstruc) = mol%xyz
            ! randomize structure to avoid zero RMSD
            do i = 1, mol%n
               do j = 1, 3
                  call random_number(er)
                  mol%xyz(j, i) = mol%xyz(j, i) + 1.0e-6_wp * er
               end do
            end do
            call geometry_optimization &
               &     (env, mol, chk, calc, &
               &      egap, set%etemp, set%maxscciter, set%optset%maxoptcycle, etot, g, sigma, &
               &      set%optset%optlev, set%verbose, .true., murks)
            if (.not. set%verbose) then
               write (env%unit, '("current energy:",1x,f20.8)') etot
            end if
            if (murks) then
               call close_file(ich)
               write (env%unit, '(/,3x,"***",1x,a,1x,"***",/)') &
                  "FAILED TO CONVERGE GEOMETRY OPTIMIZATION"
               call touch_file('NOT_CONVERGED')
            end if
            call writeMolecule(mol, ich, fileType%xyz, energy=etot, gnorm=norm2(g))
         end do
         call close_file(ich)
         call stop_timing(6)
      end if

      ! ------------------------------------------------------------------------
      !  path finder
      if (set%runtyp == p_run_path) then
         call rmsdpath_header(env%unit)
         if (mol%npbc > 0) then
            call env%warning("Metadynamics under PBC are not implemented", source)
         end if
         call start_timing(4)
         call bias_path(env, mol, chk, calc, egap, set%etemp, set%maxscciter, etot, g, sigma)
         call stop_timing(4)
      end if

      ! ------------------------------------------------------------------------
      !  screen over input structures
      if (set%runtyp == p_run_screen) then
         call start_timing(8)
         call screen(env, mol, chk, calc, egap, set%etemp, set%maxscciter, etot, g, sigma)
         call stop_timing(8)
      end if

      ! ------------------------------------------------------------------------
      !  mode following for conformer search
      if (set%runtyp == p_run_modef) then
         if (mol%npbc > 0) then
            call env%warning("Modefollowing under PBC is not implemented", source)
         end if
         call start_timing(9)
         call modefollow(env, mol, chk, calc, egap, set%etemp, set%maxscciter, etot, g, sigma)
         call stop_timing(9)
      end if

      ! ------------------------------------------------------------------------
      !  optimize along MD from xtb.trj for conformer searches
      if (set%runtyp == p_run_mdopt) then
         call start_timing(10)
         call mdopt(env, mol, chk, calc, egap, set%etemp, set%maxscciter, etot, g, sigma)
         call stop_timing(10)
      end if

      ! ------------------------------------------------------------------------
      !  to further speed up xtb calculations we dump our most important
      !  quantities in a restart file, so we can save some precious seconds
      select type (calc)
      type is (TxTBCalculator)
         if (restart) then
            call writeRestart(env, chk%wfn, 'xtbrestart', set%gfn_method)
         end if
      type is (TTBLiteCalculator)
         if (restart) call dumpRestart(env, chk, 'xtbrestart')
      end select

      ! ------------------------------------------------------------------------
      !  we may have generated some non-fatal errors, which have been saved,
      !  so we should tell the user, (s)he may want to know what went wrong
      call env%show("Runtime exception occurred")
      call raise('F', 'Some non-fatal runtime exceptions were caught,'// &
         &           ' please check:')

      ! ------------------------------------------------------------------------
      !  print all files xtb interacted with while running (for debugging mainly)
      if (set%verbose) then
         write (env%unit, '(a)')
         write (env%unit, '(72("-"))')
         call print_filelist(env%unit)
      end if

      ! ------------------------------------------------------------------------
      !  make some post processing afterward, show some timings and stuff
      write (env%unit, '(a)')
      write (env%unit, '(72("-"))')
      call stop_timing_run
      call stop_timing(1)
      call prdate('E')
      write (env%unit, '(72("-"))')
      call prtiming(1, 'total')
      call prtiming(2, 'SCF')
      if ((set%runtyp == p_run_opt) .or. (set%runtyp == p_run_ohess) .or. &
         &   (set%runtyp == p_run_omd) .or. (set%runtyp == p_run_metaopt)) then
         call prtiming(3, 'ANC optimizer')
      end if
      if (set%runtyp == p_run_path) then
         call prtiming(4, 'path finder')
      end if
      if (((set%runtyp == p_run_hess) .or. (set%runtyp == p_run_ohess) .or. (set%runtyp == p_run_bhess))) then
         if (set%mode_extrun /= p_ext_turbomole) then
            call prtiming(5, 'analytical hessian')
         else
            call prtiming(5, 'numerical hessian')
         end if
      end if
      if ((set%runtyp == p_run_md) .or. (set%runtyp == p_run_omd) .or. &
          (set%runtyp == p_run_metaopt)) then
         call prtiming(6, 'MD')
      end if
      if (set%runtyp == p_run_screen) then
         call prtiming(8, 'screen')
      end if
      if (set%runtyp == p_run_modef) then
         call prtiming(9, 'mode following')
      end if
      if (set%runtyp == p_run_mdopt) then
         call prtiming(10, 'MD opt.')
      end if

      write (env%unit, '(a)')
      call terminate(0)

   end subroutine xtbMain

!> Parse command line arguments and forward them to settings
   subroutine parseArguments(env, args, inputFile, paramFile, lgrad, &
         & restart, gsolvstate, strict, copycontrol, coffee, printTopo, oniom, dipro, tblite)

      use xtb_mctc_global, only: persistentEnv

      !> Name of error producer
      character(len=*), parameter :: source = "prog_main_parseArguments"

      !> Calculation environment
      type(TEnvironment) :: env

      !> Command line argument parser
      type(TArgParser) :: args

      !> Detailed input file name
      character(len=:), allocatable, intent(out) :: inputFile

      !> Parameter file name
      character(len=:), allocatable, intent(out) :: paramFile

      !> Reference state for solvation free energies
      integer, intent(out) :: gsolvstate

      !> Restart calculation
      logical, intent(out) :: restart

      !> Handle warnings as errors
      logical, intent(out) :: strict

      !> Debugging with a lot of caffeine
      logical, intent(out) :: coffee

      !> topology printout list
      type(TPrintTopo), intent(out) :: printTopo

      !> Print the gradient to file
      logical, intent(out) :: lgrad

      !> Copy the detailed input file
      logical, intent(out) :: copycontrol

      !> Input for ONIOM model
      type(oniom_input), intent(out) :: oniom

      !> Input for DIPRO
      type(jab_input), intent(inout) :: dipro

      !> Stuff for second argument parser
!   integer  :: narg
!   character(len=p_str_length), dimension(p_arg_length) :: argv
!   type(TAtomList) :: atl
!   integer, allocatable :: list(:)

      !> Input for TBLite calculator
      type(TTBLiteInput), intent(out) :: tblite

!$    integer :: omp_get_num_threads, nproc
      integer :: nFlags
      integer :: idum, ndum
      real(wp) :: ddum
      character(len=:), allocatable :: flag, sec
      logical :: exist

      set%gfn_method = 2
      dipro%diprocalc = .false.
      coffee = .false.
      strict = .false.
      restart = .true.
      copycontrol = .false.
      lgrad = .false.
      gsolvstate = solutionState%gsolv
      tblite%color = get_xtb_feature('color')

      nFlags = args%countFlags()
      call args%nextFlag(flag)
      do while (allocated(flag))
         if (len(flag) > 2 .and. flag(1:1) == '-' .and. flag(1:2) /= '--') then
            call env%warning("the use of '"//flag//"' is discouraged, "// &
               & "please use '-"//flag//"' next time", source)
            flag = '-'//flag
         end if
         select case (flag)
         case default
            call env%warning("Unknown option '"//flag//"' provided", source)

         case ('-h', '--help')
            call help(env%unit)
            call terminate(0)

         case ('--citation')
            call citation(env%unit)
            call terminate(0)

         case ('--license')
            call disclamer(env%unit)
            call terminate(0)

         case ('--version')
            call xtb_header(env%unit)
            call terminate(0)

         case ('-v', '--verbose')
            set%verbose = .true.

         case ('-V', '--very-verbose')
            set%verbose = .true.
            set%veryverbose = .true.

         case ('--define')
            call set_define

         case ('-P', '--parallel')
!$          if (.false.) then
               call env%warning('Program compiled without threading support', source)
!$          end if
            ! Always remove next argument to keep argument parsing consistent
            call args%nextArg(sec)
!$          if (allocated(sec)) then
!$             if (getValue(env, sec, idum)) then
!$                nproc = omp_get_num_threads()
!$                call omp_set_num_threads(idum)
#ifdef WITH_MKL
!$                call mkl_set_num_threads(idum)
#endif
!$             end if
!$          end if

         case ('--restart')
            restart = .true.

         case ('--norestart')
            restart = .false.

         case ('--copy')
            copycontrol = .true.

         case ('--nocopy')
            copycontrol = .false.

         case ('--strict')
            strict = .true.

         case ('-I', '--input')
            call args%nextArg(inputFile)
            if (.not. allocated(inputFile)) then
               call env%error("Filename for detailed input is missing", source)
            end if

         case ('--namespace')
            call args%nextArg(persistentEnv%io%namespace)
            if (.not. allocated(persistentEnv%io%namespace)) then
               call env%error("Namespace argument is missing", source)
            end if

         case ('--vparam')
            call args%nextArg(paramFile)
            if (.not. allocated(paramFile)) then
               call env%error("Filename for --vparam is missing", source)
            else
               tblite%param = paramFile
            end if

         case ('--coffee')
            coffee = .true.

         case ('-a', '--acc')
            call args%nextArg(sec)
            if (allocated(sec)) then
               if (getValue(env, sec, ddum)) then
                  if (ddum < 1.e-4_wp) then
                     call env%warning("We cannot provide this level of accuracy, "//&
                        & "resetted accuracy to 0.0001", source)
                     set%acc = 1.e-4_wp
                  else if (ddum > 1.e+3_wp) then
                     call env%warning("We cannot provide this level of accuracy, "//&
                        & "resetted accuracy to 1000", source)
                     set%acc = 1.e+3_wp
                  else
                     set%acc = ddum
                  end if
               end if
               tblite%accuracy = set%acc
            else
               call env%error("Accuracy is not provided", source)
            end if

         case ('-c', '--chrg', '--charge')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_chrg(env, sec)
            else
               call env%error("Molecular charge is not provided", source)
            end if
         
         case('--ceh')
            if (get_xtb_feature('tblite')) then
               tblite%ceh = .true.
            else
               call env%error("CEH charges are only available through tblite library", source)
               return
            end if


         case ('-u', '--uhf')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_spin(env, sec)
            else
               call env%error("Number of unpaired electrons is not provided", source)
            end if

         case ("--efield")
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_efield(env, sec)
            else
               call env%error("Electric field is not provided", source)
            end if

         case ('--gfn')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_gfn(env, 'method', sec)
               if (sec == '0') call set_exttyp('eht')
               tblite%method = "gfn"//sec
            else
               call env%error("No method provided for --gfn option", source)
            end if

         case ('--gfn1')
            call set_gfn(env, 'method', '1')
            call env%warning("The use of '"//flag//"' is discouraged, "//&
               & "please use '--gfn 1' next time", source)
            tblite%method = "gfn1"

         case ('--gfn2')
            call set_gfn(env, 'method', '2')
            call set_gfn(env, 'd4', 'true')
            tblite%method = "gfn2"

         case ('--gfn0')
            call set_gfn(env, 'method', '0')
            call set_exttyp('eht')
            call env%warning("The use of '"//flag//"' is discouraged, "//&
               & "please use '--gfn 0' next time", source)

         case ('--gfnff')
            call set_exttyp('ff')

         case ('--gff')
            call set_exttyp('ff')

         case ('--mcgfnff')
            call set_exttyp('mcff')

         case ('--iff')
            call set_exttyp('iff')

         case ('--ptb')
            call set_exttyp('ptb')
            if (.not. get_xtb_feature('tblite')) then
               call ptb_feature_not_implemented(env)
               return
            endif

         case ('--tblite')
            if (get_xtb_feature('tblite')) then
               call set_exttyp('tblite')
            else
               call env%error("Compiled without support for tblite library", source)
               return
            end if

         case ('--color')
            if (allocated(sec)) then
               select case (sec)
               case ('auto')
                  tblite%color = get_xtb_feature('color')
               case ('always')
                  tblite%color = .true.
               case ('never')
                  tblite%color = .false.
               case default
                  call env%warning("Unknown color option '"//sec//"' provided", source)
               end select
            else
               call env%error("No color scheme provided for --color option", source)
            end if

         case ('--spinpol')
            if (get_xtb_feature('tblite')) then
               tblite%spin_polarized = .true.
            else
           call env%error("Compiled without support for tblite library. This is required for spin-polarization", source)
               return
            end if

         case ('--dipro')
            if (get_xtb_feature('tblite')) then
               dipro%diprocalc = .true.
               call set_runtyp('scc')
               call args%nextArg(sec)
               if (allocated(sec)) then
                  read (sec, '(f10.3)') dipro%othr
               else
                  dipro%othr = 0.1_wp
               end if
            else
               call env%error("Compiled without support for tblite library. This is required for DIPRO", source)
               return
            end if

         case ('--oniom')
            call set_exttyp('oniom')
            call args%nextArg(sec)

            if (.not. allocated(sec)) then ! handle no argument case !
               call env%error("No inner region is  provided for ONIOM", source)
               return
            end if
            call move_alloc(sec, oniom%first_arg)

            call args%nextArg(sec)
            if (.not. allocated(sec)) then
               call env%warning("No method is specified for ONIOM," &
                     &//achar(10)//" default gfn2:gfnff combination will be used", source)
               call move_alloc(oniom%first_arg, sec)
            end if

            inquire (file=sec, exist=exist)
            if (exist) then
               sec = read_whole_file(sec)
            end if
            call move_alloc(sec, oniom%second_arg)

         case ('--cut')
            call set_cut

         case ('--etemp')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_scc(env, 'temp', sec)
            else
               call env%error("Temperature in --etemp option is missing", source)
            end if

         case ('--esp')
            call set_runtyp('scc')
            call set_write(env, 'esp', 'true')

         case ('--stm')
            call set_runtyp('scc')
            call set_write(env, 'stm', 'true')

         case ('--cma')
            call set_cma

         case ('--tm')
            call set_exttyp('turbomole')

         case ('--enso')
            call set_enso_mode

         case ('--json')
            call set_write(env, 'json', 'true')
            Call setWRtopo("json", printTopo)

         case ('--ceasefiles')
            restart = .false.
            set%verbose = .false.
            set%ceasefiles = .true.
            call set_write(env, 'wiberg', 'false')
            call set_write(env, 'charges', 'false')
#ifdef _WIN32
            call set_opt(env, 'logfile', 'NUL')
#else
            call set_opt(env, 'logfile', '/dev/null')
#endif

         case ('--orca')
            call set_exttyp('orca')

         case ('--driver')
            call set_exttyp('driver')
            call args%nextArg(sec)
            if (allocated(sec)) then
               set%ext_driver%executable = sec
            end if

         case ('--mopac')
            call set_exttyp('mopac')

         case ('--pop')
            call set_write(env, 'mulliken', 'true')

         case ('--molden')
            call set_write(env, 'mos', 'true')

         case ('--dipole')
            call set_write(env, 'dipole', 'true')

         case ('--wbo')
            call set_write(env, 'wiberg', 'true')

         case ('--lmo')
            call set_write(env, 'mulliken', 'true')
            call set_write(env, 'lmo', 'true')

         case ('--ewin')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_siman(env, 'ewin', sec)
            else
               call env%error("Real argument for --ewin is missing", source)
            end if

         case ('--fod')
            call set_write(env, 'fod', 'true')
            call set_scc(env, 'temp', '5000.0')

         case ('--iterations', '--maxiterations')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_scc(env, 'maxiterations', sec)
            else
               call env%error("Integer argument for --iterations is missing", source)
            end if

         case ('--cycles')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'maxcycle', sec)
            else
               call env%error("Integer argument for --cycles is missing", source)
            end if

         case ('-g', '--gbsa')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_gbsa(env, 'solvent', sec)
               call set_gbsa(env, 'alpb', 'false')
               call set_gbsa(env, 'kernel', 'still')
               call args%nextArg(sec)
               if (allocated(sec)) then
                  if (sec == 'reference') then
                     gsolvstate = solutionState%reference
                  else if (sec == 'bar1M') then
                     gsolvstate = solutionState%mol1bar
                  else
                     call env%warning("Unknown reference state '"//sec//"'", source)
                  end if
               end if
            else
               call env%error("No solvent name provided for GBSA", source)
            end if

         case ('--alpb')
            call args%nextArg(sec)
            call set_gbsa(env, 'alpb', 'true')
            if (allocated(sec)) then
               call set_gbsa(env, 'solvent', sec)
               call args%nextArg(sec)
               if (allocated(sec)) then
                  if (sec == 'reference') then
                     gsolvstate = solutionState%reference
                  else if (sec == 'bar1M') then
                     gsolvstate = solutionState%mol1bar
                  else
                     call env%warning("Unknown reference state '"//sec//"'", source)
                  end if
               end if
            else
               call env%error("No solvent name provided for ALPB", source)
            end if

         case ('--cosmo', '--tmcosmo')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_gbsa(env, 'solvent', sec)
               call set_gbsa(env, flag(3:), 'true')
               call args%nextArg(sec)
               if (allocated(sec)) then
                  if (sec == 'reference') then
                     gsolvstate = 1
                  else if (sec == 'bar1M') then
                     gsolvstate = 2
                  else
                     call env%warning("Unknown reference state '"//sec//"'", source)
                  end if
               end if
            else
               call env%error("No solvent name provided for COSMO", source)
            end if

         case ('--cpcmx')
            if (get_xtb_feature('cpcmx')) then
               call args%nextArg(sec)
               if (allocated(sec)) then
                  call set_gbsa(env, 'solvent', 'infinity')
                  call set_gbsa(env, 'cosmo', 'true')
                  call set_gbsa(env, 'cpcmx', sec)
               else
                  call env%error("No solvent name provided for CPCM-X", source)
               end if
            else
               call env%error("The CPCM-X library was not included in this version of xTB.", source)
            end if

         case ('--scc', '--sp')
            call set_runtyp('scc')

         case ('--vip')
            call set_gfn(env, 'method', '1')
            call set_runtyp('vip')

         case ('--vea')
            call set_gfn(env, 'method', '1')
            call set_runtyp('vea')

         case ('--vipea')
            call set_gfn(env, 'method', '1')
            call set_runtyp('vipea')

         case ('--vomega')
            call set_gfn(env, 'method', '1')
            call set_runtyp('vomega')

         case ('--vfukui')
            call set_runtyp('vfukui')

         case ('--alpha')
            call set_elprop('alpha')

         case ('--raman')
            call set_elprop('raman')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_raman(env,sec)
               call args%nextArg(sec)
               if (allocated(sec)) then
                  call set_raman(env,sec)
               endif
            endif


         case ('--grad')
            call set_runtyp('grad')
            lgrad = .true.

         case ('-o', '--opt')
            call set_runtyp('opt')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'optlevel', sec)
            end if

         case ('--hess')
            call set_runtyp('hess')

         case ('--md')
            call set_runtyp('md')

         case ('--ohess')
            call set_runtyp('ohess')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'optlevel', sec)
            end if

         case ('--bhess')
            call set_runtyp('bhess')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'optlevel', sec)
            end if

         case ('--omd')
            call set_runtyp('omd')
            call set_opt(env, 'optlevel', '-1')

         case ('--siman')
            call set_runtyp('siman')
            call set_md(env, 'nvt', 'true')

         case ('--path')
            call set_runtyp('path')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_path(env, 'product', sec)
            end if

         case ('--screen')
            call set_runtyp('screen')

         case ('--gmd')
            call set_runtyp('gmd')
            call env%error("This feature has been deprecated, I'm sorry.", source)

         case ('--modef')
            call set_runtyp('modef')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_modef(env, 'mode', sec)
            end if

         case ('--mdopt')
            call set_runtyp('mdopt')

         case ('--metadyn')
            call set_runtyp('md')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_metadyn(env, 'save', sec)
            end if
            call set_metadyn(env, 'static', 'false')

         case ('--metaopt')
            call set_runtyp('metaopt')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_opt(env, 'optlevel', sec)
            end if

         case ('--nat')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_natom(env, sec)
            end if

         case ('--bias-input', '--gesc')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call set_metadyn(env, 'bias-input', sec)
            else
               call env%error("No input file for RMSD bias provided", source)
            end if

         case ('--wrtopo')
            call args%nextArg(sec)
            if (allocated(sec)) then
               call setWRtopo(sec, printTopo)
               if (printTopo%warning) call env%error("A wrtopo argument has been misspelled.", source)
            else
               call env%error("The wrtopo keyword is missing an argument.", source)
            end if

         case ('--nocellopt')
            set%optcell = .false.

         end select
         call args%nextFlag(flag)
      end do

   end subroutine parseArguments

!> kronecker delta
   function kron(i, j) result(res_kronij)
      integer, intent(in) :: i, j
      real(wp) :: res_kronij

      res_kronij = 0.0_wp
      if (i == j) res_kronij = 1.0_wp

   end function kron
   function read_whole_file(fname) result(list)
      character(len=*), intent(in) :: fname
      character(len=:), allocatable :: list
      integer :: io, stat
      character(len=:), allocatable :: line
      open (newunit=io, file=fname, iostat=stat)
      call getline(io, list, stat)
      do while (stat == 0)
         call getline(io, line, stat)
         if (stat == 0) list = list//","//line
      end do
      close (io, iostat=stat)
   end function read_whole_file

! set booleans for requested topology list printout
   subroutine setWRtopo(sec, printTopo)
      ! command line argument
      character(len=*), intent(in) :: sec
      ! type holds booleans of to be printed topology lists
      type(TPrintTopo), intent(inout) :: printTopo
      ! seperator for lists is ","
      character, parameter :: sep = ","
      ! current and old position of seperator
      integer :: curr_pos, old_pos
      integer :: lenSec, i

      curr_pos = 0
      old_pos = 0
      lenSec = len(sec)
      do i = 1, lenSec
         curr_pos = scan(sec(curr_pos + 1:lenSec), sep) + old_pos
         if (curr_pos /= old_pos) then
            call selectList(sec(old_pos + 1:curr_pos - 1), printTopo)
         else
            call selectList(sec(old_pos + 1:lenSec), printTopo)
            exit
         end if
         old_pos = curr_pos
      end do

   end subroutine setWRtopo

   subroutine selectList(secSplit, printTopo)
      ! part of command line argument
      character(len=*), intent(in) :: secSplit
      ! holds booleans of to be printed topology lists
      type(TPrintTopo), intent(inout) :: printTopo

      select case (secSplit)
      case ("etot")
         printTopo%etot = .true.
      case ("gnorm")
         printTopo%gnorm = .true.
      case ("nb")
         printTopo%nb = .true.
      case ("bpair")
         printTopo%bpair = .true.
      case ("alist")
         printTopo%alist = .true.
      case ("blist")
         printTopo%blist = .true.
      case ("tlist")
         printTopo%tlist = .true.
      case ("vtors")
         printTopo%vtors = .true.
      case ("vbond")
         printTopo%vbond = .true.
      case ("vangl")
         printTopo%vangl = .true.
      case ("hbbond")
         printTopo%hbbond = .true.
      case ("eeq")
         printTopo%eeq = .true.
      case ("json")
         printTopo%etot = .true.
         printTopo%gnorm = .true.
         printTopo%nb = .true.
         printTopo%bpair = .true.
         printTopo%alist = .true.
         printTopo%blist = .true.
         printTopo%tlist = .true.
         printTopo%vtors = .true.
         printTopo%vbond = .true.
         printTopo%vangl = .true.
         printTopo%hbbond = .true.
         printTopo%eeq = .true.
      case default
         printTopo%warning = .true.
      end select
   end subroutine selectList

   subroutine ptb_feature_not_implemented(env)
      !> Computational environment
      type(TEnvironment), intent(inout) :: env

      call env%error("PTB not available without 'tblite'. Compiled without support for 'tblite' library.")
      call env%error("Please recompile without '-Dtblite=disabled' option or change meson setup.")
   end subroutine ptb_feature_not_implemented

end module xtb_prog_main

! This file is part of xtb.
! SPDX-Identifier: LGPL-3.0-or-later
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.
!
! MS, 09/2023: Initial implementation


!> domain-decomposed volume calculation for molecule
module xtb_solv_ddvolume
    use xtb_mctc_accuracy, only: wp
    implicit none
    private

    public :: ddvolume

    type :: sphere_type
        real(wp) :: x,y,z,r
        integer, allocatable :: neighbours(:)
        integer :: num_neighbours
        real(wp) :: volume
    contains
        procedure :: init => sphere_init
    end type sphere_type

    interface distance2
        module procedure :: distance2_spheres
        module procedure :: distance2_spherepoint
    end interface

contains 

    !> Calculates the volumes of an array of xyz-coordinates with a given radii and resolution based on a custom dd algorithm
    subroutine ddvolume(xyz,r,resolution,volume)
        !> xyz-coordinates (3,nat)
        real(wp), dimension(:,:), intent(in) :: xyz
        !> Radius (nat)
        real(wp), dimension(:), intent(in) :: r
        !> Resolution
        real(wp), intent(in) :: resolution
        !> Volume (nat)
        real(wp), dimension(:), allocatable, intent(out) :: volume

        !> Transfer input to sphere type
        type(sphere_type), allocatable :: spheres(:)
        integer :: i,s,x,y,z
        real(wp) :: x_min,x_max,y_min,y_max,z_min,z_max
    
        allocate(spheres(size(xyz,2)))
        allocate(volume(size(xyz,2)))
        volume = 0.0_wp
        !! Initialize spheres
        do i=1,size(r)
            call spheres(i)%init(xyz(1,i),xyz(2,i),xyz(3,i),r(i),size(xyz,2))
        end do

        call find_neighbours(spheres)
        !$OMP PARALLEL DO DEFAULT(NONE) SHARED(spheres, volume,resolution) PRIVATE(s,x,y,z,x_min,x_max,y_min,y_max,z_min,z_max)
        do s=1,size(spheres)
            x_min=(spheres(s)%x-spheres(s)%r)
            x_max=(spheres(s)%x+spheres(s)%r)
            y_min=(spheres(s)%y-spheres(s)%r)
            y_max=(spheres(s)%y+spheres(s)%r)
            z_min=(spheres(s)%z-spheres(s)%r)
            z_max=(spheres(s)%z+spheres(s)%r)
            do x = floor(x_min/resolution), ceiling(x_max/resolution)
                do y = floor(y_min/resolution), ceiling(y_max/resolution)
                    do z = floor(z_min/resolution), ceiling(z_max/resolution)
                        if (is_inside(x*resolution,y*resolution,z*resolution,spheres,s)) then
                            spheres(s)%volume = spheres(s)%volume + resolution**3
                        end if
                    end do
                end do
            end do
            volume(s) = spheres(s)%volume
      end do
      !$OMP END PARALLEL DO
    end subroutine ddvolume

    !> Initializes a sphere
    subroutine sphere_init(self,x,y,z,r,count)
        class(sphere_type), intent(inout) :: self
        !> Coordinates and radii
        real(wp), intent(in) :: x,y,z,r
        !> Number of maximum possible neighbours (amount of spheres)
        integer, intent(in) :: count

        self%x = x
        self%y = y
        self%z = z
        self%r = r
        self%num_neighbours = 0
        self%volume = 0.0_wp
        allocate(self%neighbours(count))
        self%neighbours = -1

    end subroutine sphere_init

    !> Set up neighbour list for a given array of spheres
    subroutine find_neighbours(spheres)
        !> Array of Sphere Type
        type(sphere_type), intent(inout) :: spheres(:)

        integer :: i,j,k
        real(wp) :: dist2

        do i=1,size(spheres)-1
            do j=i+1,size(spheres)
                dist2 = distance2(spheres(i),spheres(j))
                if (dist2 < (spheres(i)%r+spheres(j)%r)**2) then
                    do k=1,size(spheres(i)%neighbours)
                        if (spheres(i)%neighbours(k) == -1) then
                            spheres(i)%neighbours(k) = j
                            spheres(i)%num_neighbours = spheres(i)%num_neighbours + 1
                            exit
                        end if
                    end do
                    do k=1,size(spheres(j)%neighbours)
                        if (spheres(j)%neighbours(k) == -1) then
                            spheres(j)%neighbours(k) = i
                            spheres(j)%num_neighbours = spheres(j)%num_neighbours + 1
                            exit
                        end if
                    end do
                end if
            end do
        end do
    end subroutine

    !> Quadratic distance between two spheres
    function distance2_spheres(sphere1,sphere2) result(distance2)
        type(sphere_type), intent(in) :: sphere1,sphere2
        real(wp) :: distance2

        distance2 = (sphere1%x-sphere2%x)**2 + (sphere1%y-sphere2%y)**2 + (sphere1%z-sphere2%z)**2
    end function distance2_spheres

    !> Quadratic distance between a sphere and a point
    function distance2_spherepoint(sphere1,x,y,z) result(distance2)
        type(sphere_type), intent(in) :: sphere1
        real(wp), intent(in) :: x,y,z
        real(wp) :: distance2

        distance2 = (sphere1%x-x)**2 + (sphere1%y-y)**2 + (sphere1%z-z)**2
    end function distance2_spherepoint

    !> Checks if a point is inside a sphere or not
    function is_inside(x,y,z,spheres,this) result(inside)
        implicit none
        !> Array of Sphere Type (all spheres)
        type(sphere_type), intent(in) :: spheres(:)
        !> Index of the sphere to check
        integer, intent(in) :: this
        !> Coordinates of the point to check
        real(wp), intent(in) :: x,y,z
        !> Is it inside?
        logical :: inside


        integer :: i,n
        real(wp) :: dist2, distn2


        !! Check if point is even inside the sphere
        dist2 = distance2(spheres(this),x,y,z)
        if (dist2 <= spheres(this)%r**2) then
            inside = .true.
        else
            inside = .false.
            return
        end if
    
        !! Check if point is nearer to one of the neighbours than to the sphere itself
        do i=1,spheres(this)%num_neighbours
            n = spheres(this)%neighbours(i)
            distn2 = distance2(spheres(n),x,y,z)
            if (distn2 < dist2 .and. distn2 <= spheres(n)%r**2) then
                inside = .false.
                return
            end if
        end do
      end function is_inside


end module xtb_solv_ddvolume

! This file is part of xtb.
!
! Copyright (C) 2023 Marcel Mueller
!
! xtb is free software: you can redistribute it and/or modify it under
! the terms of the GNU Lesser General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! xtb is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU Lesser General Public License for more details.
!
! You should have received a copy of the GNU Lesser General Public License
! along with xtb.  If not, see <https://www.gnu.org/licenses/>.

#ifndef WITH_TBLITE
#define WITH_TBLITE 0
#endif

!> Property printout of the PTB method

module xtb_ptb_property
#if WITH_TBLITE
   use mctc_env, only: wp
   use mctc_io, only: structure_type

   use tblite_basis_type, only: basis_type

   implicit none
   private

   public :: print_charges_to_screen

contains

   subroutine print_charges_to_screen(iunit, mol, bas, qat, qsh)
      implicit none
      integer, intent(in) :: iunit
      !> mctc structure type
      type(structure_type), intent(in) :: mol
      type(basis_type), intent(in) :: bas
      real(wp), intent(in) :: qat(:, :) ! Atomic partial charges
      real(wp), intent(in) :: qsh(:, :) ! Shell populations
      integer :: i, iid, ish, is
      real(wp) :: sumq

      write (iunit, '(a)')
      write (iunit, '(4x,"* Atomic partial charges (q)     Shell populations (p)")')
      write (iunit, '(4x)', advance="no")
      do i = 1,29+11*maxval(bas%nsh_at(:))
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      write (iunit, '(6x,"#  sym   q",11x)', advance="no")
      do i = 1, maxval(bas%nsh_at(:))
         write (iunit, '(i11)', advance="no") i
      end do
      write (iunit, '(/)', advance="no")
      write (iunit, '(4x)', advance="no")
      do i = 1,29+11*maxval(bas%nsh_at(:))
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      do i = 1, mol%nat
         iid = mol%id(i)
         is = bas%ish_at(i)
         write (iunit, '(i7,2x,a4,f9.5)', advance="no") &
            & i, mol%sym(iid), qat(i, 1)
         write (iunit, '(11x)', advance="no")
         do ish = 1, bas%nsh_at(i)
            write (iunit, '(2x,f9.5)', advance="no") qsh(is + ish, 1)
         end do
         write (iunit, '(/)', advance="no")
      end do
      write (iunit, '(4x)', advance="no")
      do i = 1,29+11*maxval(bas%nsh_at(:))
         write (iunit, '(a)', advance="no") "-"
      end do
      write (iunit, '(/)', advance="no")
      sumq = sum(qat(:, 1))
      if (abs(sumq) < 1.0E-7_wp) then
         sumq = 0.0_wp
      end if
      write (iunit, '(6x,a,f10.5)') &
         & "total:", sumq 

   end subroutine print_charges_to_screen

#endif
end module xtb_ptb_property

#!/bin/bash
# run this script to set up a xtb environment
# requirements: $XTBHOME is set to `pwd`
if [ -z "${XTBHOME}" ]; then
   XTBHOME="$(cd -P "$(dirname "${BASH_SOURCE[0]}")" && pwd)/../../"
fi

# set up path for xtb, using the xtb directory and the users home directory
XTBPATH=${XTBHOME}/@datadir@:${HOME}

# to include the documentation we include our man pages in the users manpath
MANPATH=${MANPATH}:${XTBHOME}/@mandir@

# finally we have to make the binaries
PATH=${PATH}:${XTBHOME}/@bindir@

# enable package config for xtb
PKG_CONFIG_PATH=${PKG_CONFIG_PATH}:${XTBHOME}/@libdir@/pkgconfig

export PATH XTBPATH MANPATH PKG_CONFIG_PATH

#!/bin/csh
# run this script to set up a xtb environment
# requirements: $XTBHOME is set to `pwd`
if ( ! ${?XTBHOME} ) then
   setenv XTBHOME "`dirname $0`/../../"
endif

# set up path for xtb, using the xtb directory and the users home directory
setenv XTBPATH ${XTBHOME}/@datadir@:${HOME}

# to include the documentation we include our man pages in the users manpath
setenv MANPATH ${MANPATH}:${XTBHOME}/@mandir@

# finally we have to make the binaries and scripts accessable
setenv PATH ${PATH}:${XTBHOME}/@bindir@

# enable package config for xtb
setenv PKG_CONFIG_PATH ${PKG_CONFIG_PATH}:${XTBHOME}/@libdir@/pkgconfig

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: unconfirmed
assignees: ''

---

**Describe the bug**
A clear and concise description of what the bug is.

**To Reproduce**
Steps to reproduce the behaviour:

1. happens with input (include input files)
2. start `xtb` with (all the options here)
3. run `xtb` with your options and the `--verbose` flag
4. output showing the error

Please provide all input and output file such that we confirm your report.

**Expected behaviour**
A clear and concise description of what you expected to happen.

**Additional context**
Add any other context about the problem here.
